#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 3471
#define LARGE_STATE_COUNT 2072
#define SYMBOL_COUNT 505
#define ALIAS_COUNT 1
#define TOKEN_COUNT 352
#define EXTERNAL_TOKEN_COUNT 8
#define FIELD_COUNT 55
#define MAX_ALIAS_SEQUENCE_LENGTH 6
#define PRODUCTION_ID_COUNT 97

enum ts_symbol_identifiers {
  sym_command_name = 1,
  sym__whitespace = 2,
  sym_line_comment = 3,
  anon_sym_BSLASHiffalse = 4,
  anon_sym_BSLASHfi = 5,
  anon_sym_LBRACK = 6,
  anon_sym_RBRACK = 7,
  anon_sym_COMMA = 8,
  anon_sym_EQ = 9,
  anon_sym_LPAREN = 10,
  anon_sym_RPAREN = 11,
  anon_sym_BSLASHpart = 12,
  anon_sym_BSLASHpart_STAR = 13,
  anon_sym_BSLASHaddpart = 14,
  anon_sym_BSLASHaddpart_STAR = 15,
  anon_sym_BSLASHchapter = 16,
  anon_sym_BSLASHchapter_STAR = 17,
  anon_sym_BSLASHaddchap = 18,
  anon_sym_BSLASHaddchap_STAR = 19,
  anon_sym_BSLASHsection = 20,
  anon_sym_BSLASHsection_STAR = 21,
  anon_sym_BSLASHaddsec = 22,
  anon_sym_BSLASHaddsec_STAR = 23,
  anon_sym_BSLASHsubsection = 24,
  anon_sym_BSLASHsubsection_STAR = 25,
  anon_sym_BSLASHsubsubsection = 26,
  anon_sym_BSLASHsubsubsection_STAR = 27,
  anon_sym_BSLASHparagraph = 28,
  anon_sym_BSLASHparagraph_STAR = 29,
  anon_sym_BSLASHsubparagraph = 30,
  anon_sym_BSLASHsubparagraph_STAR = 31,
  anon_sym_BSLASHitem = 32,
  anon_sym_BSLASHitem_STAR = 33,
  anon_sym_LBRACE = 34,
  anon_sym_RBRACE = 35,
  anon_sym_BSLASHand = 36,
  sym_word = 37,
  sym_placeholder = 38,
  sym_path = 39,
  sym_uri = 40,
  sym_argc = 41,
  aux_sym__glob_pattern_fragment_token1 = 42,
  anon_sym_PLUS = 43,
  anon_sym_DASH = 44,
  anon_sym_STAR = 45,
  anon_sym_SLASH = 46,
  anon_sym_LT = 47,
  anon_sym_GT = 48,
  anon_sym_BANG = 49,
  anon_sym_PIPE = 50,
  anon_sym_COLON = 51,
  anon_sym_SQUOTE = 52,
  sym_letter = 53,
  anon_sym__ = 54,
  anon_sym_CARET = 55,
  anon_sym_DOLLAR_DOLLAR = 56,
  anon_sym_BSLASH_LBRACK = 57,
  anon_sym_BSLASH_RBRACK = 58,
  anon_sym_DOLLAR = 59,
  anon_sym_BSLASH_LPAREN = 60,
  anon_sym_BSLASH_RPAREN = 61,
  anon_sym_BSLASHbegin = 62,
  anon_sym_BSLASHend = 63,
  anon_sym_comment = 64,
  anon_sym_verbatim = 65,
  anon_sym_lstlisting = 66,
  anon_sym_minted = 67,
  anon_sym_pycode = 68,
  anon_sym_sagesilent = 69,
  anon_sym_sageblock = 70,
  anon_sym_math = 71,
  anon_sym_displaymath = 72,
  anon_sym_displaymath_STAR = 73,
  anon_sym_equation = 74,
  anon_sym_equation_STAR = 75,
  anon_sym_multline = 76,
  anon_sym_multline_STAR = 77,
  anon_sym_eqnarray = 78,
  anon_sym_eqnarray_STAR = 79,
  anon_sym_align = 80,
  anon_sym_align_STAR = 81,
  anon_sym_array = 82,
  anon_sym_array_STAR = 83,
  anon_sym_split = 84,
  anon_sym_split_STAR = 85,
  anon_sym_alignat = 86,
  anon_sym_alignat_STAR = 87,
  anon_sym_gather = 88,
  anon_sym_gather_STAR = 89,
  anon_sym_flalign = 90,
  anon_sym_flalign_STAR = 91,
  anon_sym_BSLASHtitle = 92,
  anon_sym_BSLASHauthor = 93,
  anon_sym_BSLASHusepackage = 94,
  anon_sym_BSLASHRequirePackage = 95,
  anon_sym_BSLASHdocumentclass = 96,
  anon_sym_BSLASHinclude = 97,
  anon_sym_BSLASHsubfileinclude = 98,
  anon_sym_BSLASHinput = 99,
  anon_sym_BSLASHsubfile = 100,
  anon_sym_BSLASHaddbibresource = 101,
  anon_sym_BSLASHbibliographystyle = 102,
  anon_sym_BSLASHbibliography = 103,
  anon_sym_BSLASHincludegraphics = 104,
  anon_sym_BSLASHincludesvg = 105,
  anon_sym_BSLASHincludeinkscape = 106,
  anon_sym_BSLASHverbatiminput = 107,
  anon_sym_BSLASHVerbatimInput = 108,
  anon_sym_BSLASHimport = 109,
  anon_sym_BSLASHsubimport = 110,
  anon_sym_BSLASHinputfrom = 111,
  anon_sym_BSLASHsubimportfrom = 112,
  anon_sym_BSLASHincludefrom = 113,
  anon_sym_BSLASHsubincludefrom = 114,
  anon_sym_BSLASHcaption = 115,
  anon_sym_BSLASHcite = 116,
  anon_sym_BSLASHcite_STAR = 117,
  anon_sym_BSLASHCite = 118,
  anon_sym_BSLASHnocite = 119,
  anon_sym_BSLASHcitet = 120,
  anon_sym_BSLASHcitep = 121,
  anon_sym_BSLASHcitet_STAR = 122,
  anon_sym_BSLASHcitep_STAR = 123,
  anon_sym_BSLASHciteA = 124,
  anon_sym_BSLASHciteR = 125,
  anon_sym_BSLASHciteS = 126,
  anon_sym_BSLASHciteyearR = 127,
  anon_sym_BSLASHciteauthor = 128,
  anon_sym_BSLASHciteauthor_STAR = 129,
  anon_sym_BSLASHCiteauthor = 130,
  anon_sym_BSLASHCiteauthor_STAR = 131,
  anon_sym_BSLASHcitetitle = 132,
  anon_sym_BSLASHcitetitle_STAR = 133,
  anon_sym_BSLASHciteyear = 134,
  anon_sym_BSLASHciteyear_STAR = 135,
  anon_sym_BSLASHcitedate = 136,
  anon_sym_BSLASHcitedate_STAR = 137,
  anon_sym_BSLASHciteurl = 138,
  anon_sym_BSLASHfullcite = 139,
  anon_sym_BSLASHciteyearpar = 140,
  anon_sym_BSLASHcitealt = 141,
  anon_sym_BSLASHcitealp = 142,
  anon_sym_BSLASHcitetext = 143,
  anon_sym_BSLASHparencite = 144,
  anon_sym_BSLASHparencite_STAR = 145,
  anon_sym_BSLASHParencite = 146,
  anon_sym_BSLASHfootcite = 147,
  anon_sym_BSLASHfootfullcite = 148,
  anon_sym_BSLASHfootcitetext = 149,
  anon_sym_BSLASHtextcite = 150,
  anon_sym_BSLASHTextcite = 151,
  anon_sym_BSLASHsmartcite = 152,
  anon_sym_BSLASHSmartcite = 153,
  anon_sym_BSLASHsupercite = 154,
  anon_sym_BSLASHautocite = 155,
  anon_sym_BSLASHAutocite = 156,
  anon_sym_BSLASHautocite_STAR = 157,
  anon_sym_BSLASHAutocite_STAR = 158,
  anon_sym_BSLASHvolcite = 159,
  anon_sym_BSLASHVolcite = 160,
  anon_sym_BSLASHpvolcite = 161,
  anon_sym_BSLASHPvolcite = 162,
  anon_sym_BSLASHfvolcite = 163,
  anon_sym_BSLASHftvolcite = 164,
  anon_sym_BSLASHsvolcite = 165,
  anon_sym_BSLASHSvolcite = 166,
  anon_sym_BSLASHtvolcite = 167,
  anon_sym_BSLASHTvolcite = 168,
  anon_sym_BSLASHavolcite = 169,
  anon_sym_BSLASHAvolcite = 170,
  anon_sym_BSLASHnotecite = 171,
  anon_sym_BSLASHNotecite = 172,
  anon_sym_BSLASHpnotecite = 173,
  anon_sym_BSLASHPnotecite = 174,
  anon_sym_BSLASHfnotecite = 175,
  anon_sym_BSLASHlabel = 176,
  anon_sym_BSLASHref = 177,
  anon_sym_BSLASHeqref = 178,
  anon_sym_BSLASHvref = 179,
  anon_sym_BSLASHVref = 180,
  anon_sym_BSLASHautoref = 181,
  anon_sym_BSLASHpageref = 182,
  anon_sym_BSLASHcref = 183,
  anon_sym_BSLASHCref = 184,
  anon_sym_BSLASHcref_STAR = 185,
  anon_sym_BSLASHCref_STAR = 186,
  anon_sym_BSLASHnamecref = 187,
  anon_sym_BSLASHnameCref = 188,
  anon_sym_BSLASHlcnamecref = 189,
  anon_sym_BSLASHnamecrefs = 190,
  anon_sym_BSLASHnameCrefs = 191,
  anon_sym_BSLASHlcnamecrefs = 192,
  anon_sym_BSLASHlabelcref = 193,
  anon_sym_BSLASHlabelcpageref = 194,
  anon_sym_BSLASHcrefrange = 195,
  anon_sym_BSLASHcrefrange_STAR = 196,
  anon_sym_BSLASHCrefrange = 197,
  anon_sym_BSLASHCrefrange_STAR = 198,
  anon_sym_BSLASHnewlabel = 199,
  anon_sym_BSLASHnewcommand = 200,
  anon_sym_BSLASHnewcommand_STAR = 201,
  anon_sym_BSLASHrenewcommand = 202,
  anon_sym_BSLASHrenewcommand_STAR = 203,
  anon_sym_BSLASHDeclareRobustCommand = 204,
  anon_sym_BSLASHDeclareRobustCommand_STAR = 205,
  anon_sym_BSLASHDeclareMathOperator = 206,
  anon_sym_BSLASHDeclareMathOperator_STAR = 207,
  anon_sym_BSLASHNewDocumentCommand = 208,
  anon_sym_BSLASHRenewDocumentCommand = 209,
  anon_sym_BSLASHProvideDocumentCommand = 210,
  anon_sym_BSLASHDeclareDocumentCommand = 211,
  anon_sym_BSLASHNewExpandableDocumentCommand = 212,
  anon_sym_BSLASHRenewExpandableDocumentCommand = 213,
  anon_sym_BSLASHProvideExpandableDocumentCommand = 214,
  anon_sym_BSLASHDeclareExpandableDocumentCommand = 215,
  anon_sym_BSLASHdef = 216,
  anon_sym_BSLASHlet = 217,
  anon_sym_BSLASHleft = 218,
  anon_sym_BSLASHbigl = 219,
  anon_sym_BSLASHBigl = 220,
  anon_sym_BSLASHbiggl = 221,
  anon_sym_BSLASHBiggl = 222,
  anon_sym_BSLASHright = 223,
  anon_sym_BSLASHbigr = 224,
  anon_sym_BSLASHBigr = 225,
  anon_sym_BSLASHbiggr = 226,
  anon_sym_BSLASHBiggr = 227,
  anon_sym_BSLASHDeclarePairedDelimiter = 228,
  anon_sym_BSLASHDeclarePairedDelimiterX = 229,
  anon_sym_BSLASHnewenvironment = 230,
  anon_sym_BSLASHrenewenvironment = 231,
  anon_sym_BSLASHNewDocumentEnvironment = 232,
  anon_sym_BSLASHRenewDocumentEnvironment = 233,
  anon_sym_BSLASHProvideDocumentEnvironment = 234,
  anon_sym_BSLASHDeclareDocumentEnvironment = 235,
  anon_sym_BSLASHnewglossaryentry = 236,
  anon_sym_BSLASHgls = 237,
  anon_sym_BSLASHGls = 238,
  anon_sym_BSLASHGLS = 239,
  anon_sym_BSLASHglspl = 240,
  anon_sym_BSLASHGlspl = 241,
  anon_sym_BSLASHGLSpl = 242,
  anon_sym_BSLASHglsdisp = 243,
  anon_sym_BSLASHglslink = 244,
  anon_sym_BSLASHglstext = 245,
  anon_sym_BSLASHGlstext = 246,
  anon_sym_BSLASHGLStext = 247,
  anon_sym_BSLASHglsfirst = 248,
  anon_sym_BSLASHGlsfirst = 249,
  anon_sym_BSLASHGLSfirst = 250,
  anon_sym_BSLASHglsplural = 251,
  anon_sym_BSLASHGlsplural = 252,
  anon_sym_BSLASHGLSplural = 253,
  anon_sym_BSLASHglsfirstplural = 254,
  anon_sym_BSLASHGlsfirstplural = 255,
  anon_sym_BSLASHGLSfirstplural = 256,
  anon_sym_BSLASHglsname = 257,
  anon_sym_BSLASHGlsname = 258,
  anon_sym_BSLASHGLSname = 259,
  anon_sym_BSLASHglssymbol = 260,
  anon_sym_BSLASHGlssymbol = 261,
  anon_sym_BSLASHglsdesc = 262,
  anon_sym_BSLASHGlsdesc = 263,
  anon_sym_BSLASHGLSdesc = 264,
  anon_sym_BSLASHglsuseri = 265,
  anon_sym_BSLASHGlsuseri = 266,
  anon_sym_BSLASHGLSuseri = 267,
  anon_sym_BSLASHglsuserii = 268,
  anon_sym_BSLASHGlsuserii = 269,
  anon_sym_BSLASHGLSuserii = 270,
  anon_sym_BSLASHglsuseriii = 271,
  anon_sym_BSLASHGlsuseriii = 272,
  anon_sym_BSLASHGLSuseriii = 273,
  anon_sym_BSLASHglsuseriv = 274,
  anon_sym_BSLASHGlsuseriv = 275,
  anon_sym_BSLASHGLSuseriv = 276,
  anon_sym_BSLASHglsuserv = 277,
  anon_sym_BSLASHGlsuserv = 278,
  anon_sym_BSLASHGLSuserv = 279,
  anon_sym_BSLASHglsuservi = 280,
  anon_sym_BSLASHGlsuservi = 281,
  anon_sym_BSLASHGLSuservi = 282,
  anon_sym_BSLASHnewacronym = 283,
  anon_sym_BSLASHacrshort = 284,
  anon_sym_BSLASHAcrshort = 285,
  anon_sym_BSLASHACRshort = 286,
  anon_sym_BSLASHacrshortpl = 287,
  anon_sym_BSLASHAcrshortpl = 288,
  anon_sym_BSLASHACRshortpl = 289,
  anon_sym_BSLASHacrlong = 290,
  anon_sym_BSLASHAcrlong = 291,
  anon_sym_BSLASHACRlong = 292,
  anon_sym_BSLASHacrlongpl = 293,
  anon_sym_BSLASHAcrlongpl = 294,
  anon_sym_BSLASHACRlongpl = 295,
  anon_sym_BSLASHacrfull = 296,
  anon_sym_BSLASHAcrfull = 297,
  anon_sym_BSLASHACRfull = 298,
  anon_sym_BSLASHacrfullpl = 299,
  anon_sym_BSLASHAcrfullpl = 300,
  anon_sym_BSLASHACRfullpl = 301,
  anon_sym_BSLASHacs = 302,
  anon_sym_BSLASHAcs = 303,
  anon_sym_BSLASHacsp = 304,
  anon_sym_BSLASHAcsp = 305,
  anon_sym_BSLASHacl = 306,
  anon_sym_BSLASHAcl = 307,
  anon_sym_BSLASHaclp = 308,
  anon_sym_BSLASHAclp = 309,
  anon_sym_BSLASHacf = 310,
  anon_sym_BSLASHAcf = 311,
  anon_sym_BSLASHacfp = 312,
  anon_sym_BSLASHAcfp = 313,
  anon_sym_BSLASHac = 314,
  anon_sym_BSLASHAc = 315,
  anon_sym_BSLASHacp = 316,
  anon_sym_BSLASHglsentrylong = 317,
  anon_sym_BSLASHGlsentrylong = 318,
  anon_sym_BSLASHglsentrylongpl = 319,
  anon_sym_BSLASHGlsentrylongpl = 320,
  anon_sym_BSLASHglsentryshort = 321,
  anon_sym_BSLASHGlsentryshort = 322,
  anon_sym_BSLASHglsentryshortpl = 323,
  anon_sym_BSLASHGlsentryshortpl = 324,
  anon_sym_BSLASHglsentryfullpl = 325,
  anon_sym_BSLASHGlsentryfullpl = 326,
  anon_sym_BSLASHnewtheorem = 327,
  anon_sym_BSLASHnewtheorem_STAR = 328,
  anon_sym_BSLASHdeclaretheorem = 329,
  anon_sym_BSLASHdeclaretheorem_STAR = 330,
  anon_sym_BSLASHdefinecolor = 331,
  anon_sym_BSLASHdefinecolorset = 332,
  anon_sym_BSLASHcolor = 333,
  anon_sym_BSLASHcolorbox = 334,
  anon_sym_BSLASHtextcolor = 335,
  anon_sym_BSLASHpagecolor = 336,
  anon_sym_BSLASHusepgflibrary = 337,
  anon_sym_BSLASHusetikzlibrary = 338,
  anon_sym_BSLASHtext = 339,
  anon_sym_BSLASHintertext = 340,
  anon_sym_BSLASHshortintertext = 341,
  anon_sym_BSLASHurl = 342,
  anon_sym_BSLASHhref = 343,
  sym__trivia_raw_fi = 344,
  sym__trivia_raw_env_comment = 345,
  sym__trivia_raw_env_verbatim = 346,
  sym__trivia_raw_env_listing = 347,
  sym__trivia_raw_env_minted = 348,
  sym__trivia_raw_env_pycode = 349,
  sym__trivia_raw_env_sagesilent = 350,
  sym__trivia_raw_env_sageblock = 351,
  sym_source_file = 352,
  sym_block_comment = 353,
  sym__root_content = 354,
  sym__flat_content = 355,
  sym__text_with_env_content = 356,
  sym__text_content = 357,
  sym__section = 358,
  sym__paragraph = 359,
  sym__section_part = 360,
  sym__part_declaration = 361,
  sym_part = 362,
  sym__chapter_declaration = 363,
  sym_chapter = 364,
  sym__section_declaration = 365,
  sym_section = 366,
  sym__subsection_declaration = 367,
  sym_subsection = 368,
  sym__subsubsection_declaration = 369,
  sym_subsubsection = 370,
  sym__paragraph_declaration = 371,
  sym_paragraph = 372,
  sym__subparagraph_declaration = 373,
  sym_subparagraph = 374,
  sym__enum_itemdeclaration = 375,
  sym_enum_item = 376,
  sym_curly_group = 377,
  sym_curly_group_text = 378,
  sym_curly_group_text_list = 379,
  sym_curly_group_path = 380,
  sym_curly_group_path_list = 381,
  sym_curly_group_uri = 382,
  sym_curly_group_command_name = 383,
  sym_curly_group_key_value = 384,
  sym_curly_group_glob_pattern = 385,
  sym_curly_group_impl = 386,
  sym_curly_group_author_list = 387,
  sym_brack_group = 388,
  sym_brack_group_text = 389,
  sym_brack_group_argc = 390,
  sym_brack_group_key_value = 391,
  sym_text = 392,
  sym_glob_pattern = 393,
  sym__glob_pattern_fragment = 394,
  sym_operator = 395,
  sym_subscript = 396,
  sym_superscript = 397,
  sym_key_value_pair = 398,
  sym_value = 399,
  sym_displayed_equation = 400,
  sym_inline_formula = 401,
  sym_begin = 402,
  sym_end = 403,
  sym_generic_environment = 404,
  sym_comment_environment = 405,
  sym__comment_environment_begin = 406,
  sym__comment_environment_end = 407,
  sym__comment_environment_group = 408,
  sym__comment_environment_name = 409,
  sym_verbatim_environment = 410,
  sym__verbatim_environment_begin = 411,
  sym__verbatim_environment_end = 412,
  sym__verbatim_environment_group = 413,
  sym__verbatim_environment_name = 414,
  sym_listing_environment = 415,
  sym__listing_environment_begin = 416,
  sym__listing_environment_end = 417,
  sym__listing_environment_group = 418,
  sym__listing_environment_name = 419,
  sym_minted_environment = 420,
  sym__minted_environment_begin = 421,
  sym__minted_environment_end = 422,
  sym__minted_environment_group = 423,
  sym__minted_environment_name = 424,
  sym_pycode_environment = 425,
  sym__pycode_environment_begin = 426,
  sym__pycode_environment_end = 427,
  sym__pycode_environment_group = 428,
  sym__pycode_environment_name = 429,
  sym_sagesilent_environment = 430,
  sym__sagesilent_environment_begin = 431,
  sym__sagesilent_environment_end = 432,
  sym__sagesilent_environment_group = 433,
  sym__sagesilent_environment_name = 434,
  sym_sageblock_environment = 435,
  sym__sageblock_environment_begin = 436,
  sym__sageblock_environment_end = 437,
  sym__sageblock_environment_group = 438,
  sym__sageblock_environment_name = 439,
  sym_math_environment = 440,
  sym__math_environment_begin = 441,
  sym__math_environment_end = 442,
  sym__math_environment_group = 443,
  sym__math_environment_name = 444,
  sym__command = 445,
  sym_generic_command = 446,
  sym_title_declaration = 447,
  sym_author_declaration = 448,
  sym_package_include = 449,
  sym_class_include = 450,
  sym_latex_include = 451,
  sym_biblatex_include = 452,
  sym_bibstyle_include = 453,
  sym_bibtex_include = 454,
  sym_graphics_include = 455,
  sym_svg_include = 456,
  sym_inkscape_include = 457,
  sym_verbatim_include = 458,
  sym_import_include = 459,
  sym_caption = 460,
  sym_citation = 461,
  sym_label_definition = 462,
  sym_label_reference = 463,
  sym_label_reference_range = 464,
  sym_label_number = 465,
  sym_new_command_definition = 466,
  sym_old_command_definition = 467,
  sym_let_command_definition = 468,
  sym__math_delimiter_part = 469,
  sym_math_delimiter = 470,
  sym_paired_delimiter_definition = 471,
  sym_environment_definition = 472,
  sym_glossary_entry_definition = 473,
  sym_glossary_entry_reference = 474,
  sym_acronym_definition = 475,
  sym_acronym_reference = 476,
  sym_theorem_definition = 477,
  sym_color_definition = 478,
  sym_color_set_definition = 479,
  sym_color_reference = 480,
  sym_tikz_library_import = 481,
  sym_text_mode = 482,
  sym_hyperlink = 483,
  aux_sym_source_file_repeat1 = 484,
  aux_sym__section_repeat1 = 485,
  aux_sym__section_repeat2 = 486,
  aux_sym__section_repeat3 = 487,
  aux_sym__section_repeat4 = 488,
  aux_sym__section_repeat5 = 489,
  aux_sym__paragraph_repeat1 = 490,
  aux_sym__paragraph_repeat2 = 491,
  aux_sym__paragraph_repeat3 = 492,
  aux_sym_part_repeat1 = 493,
  aux_sym_curly_group_text_list_repeat1 = 494,
  aux_sym_curly_group_path_list_repeat1 = 495,
  aux_sym_curly_group_key_value_repeat1 = 496,
  aux_sym_curly_group_impl_repeat1 = 497,
  aux_sym_curly_group_author_list_repeat1 = 498,
  aux_sym_curly_group_author_list_repeat2 = 499,
  aux_sym_brack_group_repeat1 = 500,
  aux_sym_text_repeat1 = 501,
  aux_sym_glob_pattern_repeat1 = 502,
  aux_sym_value_repeat1 = 503,
  aux_sym_generic_command_repeat1 = 504,
  alias_sym_author = 505,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_command_name] = "command_name",
  [sym__whitespace] = "_whitespace",
  [sym_line_comment] = "line_comment",
  [anon_sym_BSLASHiffalse] = "\\iffalse",
  [anon_sym_BSLASHfi] = "\\fi",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_BSLASHpart] = "\\part",
  [anon_sym_BSLASHpart_STAR] = "\\part*",
  [anon_sym_BSLASHaddpart] = "\\addpart",
  [anon_sym_BSLASHaddpart_STAR] = "\\addpart*",
  [anon_sym_BSLASHchapter] = "\\chapter",
  [anon_sym_BSLASHchapter_STAR] = "\\chapter*",
  [anon_sym_BSLASHaddchap] = "\\addchap",
  [anon_sym_BSLASHaddchap_STAR] = "\\addchap*",
  [anon_sym_BSLASHsection] = "\\section",
  [anon_sym_BSLASHsection_STAR] = "\\section*",
  [anon_sym_BSLASHaddsec] = "\\addsec",
  [anon_sym_BSLASHaddsec_STAR] = "\\addsec*",
  [anon_sym_BSLASHsubsection] = "\\subsection",
  [anon_sym_BSLASHsubsection_STAR] = "\\subsection*",
  [anon_sym_BSLASHsubsubsection] = "\\subsubsection",
  [anon_sym_BSLASHsubsubsection_STAR] = "\\subsubsection*",
  [anon_sym_BSLASHparagraph] = "\\paragraph",
  [anon_sym_BSLASHparagraph_STAR] = "\\paragraph*",
  [anon_sym_BSLASHsubparagraph] = "\\subparagraph",
  [anon_sym_BSLASHsubparagraph_STAR] = "\\subparagraph*",
  [anon_sym_BSLASHitem] = "\\item",
  [anon_sym_BSLASHitem_STAR] = "\\item*",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_BSLASHand] = "command_name",
  [sym_word] = "word",
  [sym_placeholder] = "placeholder",
  [sym_path] = "path",
  [sym_uri] = "uri",
  [sym_argc] = "argc",
  [aux_sym__glob_pattern_fragment_token1] = "_glob_pattern_fragment_token1",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_BANG] = "!",
  [anon_sym_PIPE] = "|",
  [anon_sym_COLON] = ":",
  [anon_sym_SQUOTE] = "'",
  [sym_letter] = "letter",
  [anon_sym__] = "_",
  [anon_sym_CARET] = "^",
  [anon_sym_DOLLAR_DOLLAR] = "$$",
  [anon_sym_BSLASH_LBRACK] = "\\[",
  [anon_sym_BSLASH_RBRACK] = "\\]",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_BSLASH_LPAREN] = "\\(",
  [anon_sym_BSLASH_RPAREN] = "\\)",
  [anon_sym_BSLASHbegin] = "\\begin",
  [anon_sym_BSLASHend] = "\\end",
  [anon_sym_comment] = "word",
  [anon_sym_verbatim] = "word",
  [anon_sym_lstlisting] = "word",
  [anon_sym_minted] = "word",
  [anon_sym_pycode] = "word",
  [anon_sym_sagesilent] = "word",
  [anon_sym_sageblock] = "word",
  [anon_sym_math] = "word",
  [anon_sym_displaymath] = "word",
  [anon_sym_displaymath_STAR] = "word",
  [anon_sym_equation] = "word",
  [anon_sym_equation_STAR] = "word",
  [anon_sym_multline] = "word",
  [anon_sym_multline_STAR] = "word",
  [anon_sym_eqnarray] = "word",
  [anon_sym_eqnarray_STAR] = "word",
  [anon_sym_align] = "word",
  [anon_sym_align_STAR] = "word",
  [anon_sym_array] = "word",
  [anon_sym_array_STAR] = "word",
  [anon_sym_split] = "word",
  [anon_sym_split_STAR] = "word",
  [anon_sym_alignat] = "word",
  [anon_sym_alignat_STAR] = "word",
  [anon_sym_gather] = "word",
  [anon_sym_gather_STAR] = "word",
  [anon_sym_flalign] = "word",
  [anon_sym_flalign_STAR] = "word",
  [anon_sym_BSLASHtitle] = "\\title",
  [anon_sym_BSLASHauthor] = "\\author",
  [anon_sym_BSLASHusepackage] = "\\usepackage",
  [anon_sym_BSLASHRequirePackage] = "\\RequirePackage",
  [anon_sym_BSLASHdocumentclass] = "\\documentclass",
  [anon_sym_BSLASHinclude] = "\\include",
  [anon_sym_BSLASHsubfileinclude] = "\\subfileinclude",
  [anon_sym_BSLASHinput] = "\\input",
  [anon_sym_BSLASHsubfile] = "\\subfile",
  [anon_sym_BSLASHaddbibresource] = "\\addbibresource",
  [anon_sym_BSLASHbibliographystyle] = "\\bibliographystyle",
  [anon_sym_BSLASHbibliography] = "\\bibliography",
  [anon_sym_BSLASHincludegraphics] = "\\includegraphics",
  [anon_sym_BSLASHincludesvg] = "\\includesvg",
  [anon_sym_BSLASHincludeinkscape] = "\\includeinkscape",
  [anon_sym_BSLASHverbatiminput] = "\\verbatiminput",
  [anon_sym_BSLASHVerbatimInput] = "\\VerbatimInput",
  [anon_sym_BSLASHimport] = "\\import",
  [anon_sym_BSLASHsubimport] = "\\subimport",
  [anon_sym_BSLASHinputfrom] = "\\inputfrom",
  [anon_sym_BSLASHsubimportfrom] = "\\subimportfrom",
  [anon_sym_BSLASHincludefrom] = "\\includefrom",
  [anon_sym_BSLASHsubincludefrom] = "\\subincludefrom",
  [anon_sym_BSLASHcaption] = "\\caption",
  [anon_sym_BSLASHcite] = "\\cite",
  [anon_sym_BSLASHcite_STAR] = "\\cite*",
  [anon_sym_BSLASHCite] = "\\Cite",
  [anon_sym_BSLASHnocite] = "\\nocite",
  [anon_sym_BSLASHcitet] = "\\citet",
  [anon_sym_BSLASHcitep] = "\\citep",
  [anon_sym_BSLASHcitet_STAR] = "\\citet*",
  [anon_sym_BSLASHcitep_STAR] = "\\citep*",
  [anon_sym_BSLASHciteA] = "\\citeA",
  [anon_sym_BSLASHciteR] = "\\citeR",
  [anon_sym_BSLASHciteS] = "\\citeS",
  [anon_sym_BSLASHciteyearR] = "\\citeyearR",
  [anon_sym_BSLASHciteauthor] = "\\citeauthor",
  [anon_sym_BSLASHciteauthor_STAR] = "\\citeauthor*",
  [anon_sym_BSLASHCiteauthor] = "\\Citeauthor",
  [anon_sym_BSLASHCiteauthor_STAR] = "\\Citeauthor*",
  [anon_sym_BSLASHcitetitle] = "\\citetitle",
  [anon_sym_BSLASHcitetitle_STAR] = "\\citetitle*",
  [anon_sym_BSLASHciteyear] = "\\citeyear",
  [anon_sym_BSLASHciteyear_STAR] = "\\citeyear*",
  [anon_sym_BSLASHcitedate] = "\\citedate",
  [anon_sym_BSLASHcitedate_STAR] = "\\citedate*",
  [anon_sym_BSLASHciteurl] = "\\citeurl",
  [anon_sym_BSLASHfullcite] = "\\fullcite",
  [anon_sym_BSLASHciteyearpar] = "\\citeyearpar",
  [anon_sym_BSLASHcitealt] = "\\citealt",
  [anon_sym_BSLASHcitealp] = "\\citealp",
  [anon_sym_BSLASHcitetext] = "\\citetext",
  [anon_sym_BSLASHparencite] = "\\parencite",
  [anon_sym_BSLASHparencite_STAR] = "\\parencite*",
  [anon_sym_BSLASHParencite] = "\\Parencite",
  [anon_sym_BSLASHfootcite] = "\\footcite",
  [anon_sym_BSLASHfootfullcite] = "\\footfullcite",
  [anon_sym_BSLASHfootcitetext] = "\\footcitetext",
  [anon_sym_BSLASHtextcite] = "\\textcite",
  [anon_sym_BSLASHTextcite] = "\\Textcite",
  [anon_sym_BSLASHsmartcite] = "\\smartcite",
  [anon_sym_BSLASHSmartcite] = "\\Smartcite",
  [anon_sym_BSLASHsupercite] = "\\supercite",
  [anon_sym_BSLASHautocite] = "\\autocite",
  [anon_sym_BSLASHAutocite] = "\\Autocite",
  [anon_sym_BSLASHautocite_STAR] = "\\autocite*",
  [anon_sym_BSLASHAutocite_STAR] = "\\Autocite*",
  [anon_sym_BSLASHvolcite] = "\\volcite",
  [anon_sym_BSLASHVolcite] = "\\Volcite",
  [anon_sym_BSLASHpvolcite] = "\\pvolcite",
  [anon_sym_BSLASHPvolcite] = "\\Pvolcite",
  [anon_sym_BSLASHfvolcite] = "\\fvolcite",
  [anon_sym_BSLASHftvolcite] = "\\ftvolcite",
  [anon_sym_BSLASHsvolcite] = "\\svolcite",
  [anon_sym_BSLASHSvolcite] = "\\Svolcite",
  [anon_sym_BSLASHtvolcite] = "\\tvolcite",
  [anon_sym_BSLASHTvolcite] = "\\Tvolcite",
  [anon_sym_BSLASHavolcite] = "\\avolcite",
  [anon_sym_BSLASHAvolcite] = "\\Avolcite",
  [anon_sym_BSLASHnotecite] = "\\notecite",
  [anon_sym_BSLASHNotecite] = "\\Notecite",
  [anon_sym_BSLASHpnotecite] = "\\pnotecite",
  [anon_sym_BSLASHPnotecite] = "\\Pnotecite",
  [anon_sym_BSLASHfnotecite] = "\\fnotecite",
  [anon_sym_BSLASHlabel] = "\\label",
  [anon_sym_BSLASHref] = "\\ref",
  [anon_sym_BSLASHeqref] = "\\eqref",
  [anon_sym_BSLASHvref] = "\\vref",
  [anon_sym_BSLASHVref] = "\\Vref",
  [anon_sym_BSLASHautoref] = "\\autoref",
  [anon_sym_BSLASHpageref] = "\\pageref",
  [anon_sym_BSLASHcref] = "\\cref",
  [anon_sym_BSLASHCref] = "\\Cref",
  [anon_sym_BSLASHcref_STAR] = "\\cref*",
  [anon_sym_BSLASHCref_STAR] = "\\Cref*",
  [anon_sym_BSLASHnamecref] = "\\namecref",
  [anon_sym_BSLASHnameCref] = "\\nameCref",
  [anon_sym_BSLASHlcnamecref] = "\\lcnamecref",
  [anon_sym_BSLASHnamecrefs] = "\\namecrefs",
  [anon_sym_BSLASHnameCrefs] = "\\nameCrefs",
  [anon_sym_BSLASHlcnamecrefs] = "\\lcnamecrefs",
  [anon_sym_BSLASHlabelcref] = "\\labelcref",
  [anon_sym_BSLASHlabelcpageref] = "\\labelcpageref",
  [anon_sym_BSLASHcrefrange] = "\\crefrange",
  [anon_sym_BSLASHcrefrange_STAR] = "\\crefrange*",
  [anon_sym_BSLASHCrefrange] = "\\Crefrange",
  [anon_sym_BSLASHCrefrange_STAR] = "\\Crefrange*",
  [anon_sym_BSLASHnewlabel] = "\\newlabel",
  [anon_sym_BSLASHnewcommand] = "\\newcommand",
  [anon_sym_BSLASHnewcommand_STAR] = "\\newcommand*",
  [anon_sym_BSLASHrenewcommand] = "\\renewcommand",
  [anon_sym_BSLASHrenewcommand_STAR] = "\\renewcommand*",
  [anon_sym_BSLASHDeclareRobustCommand] = "\\DeclareRobustCommand",
  [anon_sym_BSLASHDeclareRobustCommand_STAR] = "\\DeclareRobustCommand*",
  [anon_sym_BSLASHDeclareMathOperator] = "\\DeclareMathOperator",
  [anon_sym_BSLASHDeclareMathOperator_STAR] = "\\DeclareMathOperator*",
  [anon_sym_BSLASHNewDocumentCommand] = "\\NewDocumentCommand",
  [anon_sym_BSLASHRenewDocumentCommand] = "\\RenewDocumentCommand",
  [anon_sym_BSLASHProvideDocumentCommand] = "\\ProvideDocumentCommand",
  [anon_sym_BSLASHDeclareDocumentCommand] = "\\DeclareDocumentCommand",
  [anon_sym_BSLASHNewExpandableDocumentCommand] = "\\NewExpandableDocumentCommand",
  [anon_sym_BSLASHRenewExpandableDocumentCommand] = "\\RenewExpandableDocumentCommand",
  [anon_sym_BSLASHProvideExpandableDocumentCommand] = "\\ProvideExpandableDocumentCommand",
  [anon_sym_BSLASHDeclareExpandableDocumentCommand] = "\\DeclareExpandableDocumentCommand",
  [anon_sym_BSLASHdef] = "\\def",
  [anon_sym_BSLASHlet] = "\\let",
  [anon_sym_BSLASHleft] = "\\left",
  [anon_sym_BSLASHbigl] = "\\bigl",
  [anon_sym_BSLASHBigl] = "\\Bigl",
  [anon_sym_BSLASHbiggl] = "\\biggl",
  [anon_sym_BSLASHBiggl] = "\\Biggl",
  [anon_sym_BSLASHright] = "\\right",
  [anon_sym_BSLASHbigr] = "\\bigr",
  [anon_sym_BSLASHBigr] = "\\Bigr",
  [anon_sym_BSLASHbiggr] = "\\biggr",
  [anon_sym_BSLASHBiggr] = "\\Biggr",
  [anon_sym_BSLASHDeclarePairedDelimiter] = "\\DeclarePairedDelimiter",
  [anon_sym_BSLASHDeclarePairedDelimiterX] = "\\DeclarePairedDelimiterX",
  [anon_sym_BSLASHnewenvironment] = "\\newenvironment",
  [anon_sym_BSLASHrenewenvironment] = "\\renewenvironment",
  [anon_sym_BSLASHNewDocumentEnvironment] = "\\NewDocumentEnvironment",
  [anon_sym_BSLASHRenewDocumentEnvironment] = "\\RenewDocumentEnvironment",
  [anon_sym_BSLASHProvideDocumentEnvironment] = "\\ProvideDocumentEnvironment",
  [anon_sym_BSLASHDeclareDocumentEnvironment] = "\\DeclareDocumentEnvironment",
  [anon_sym_BSLASHnewglossaryentry] = "\\newglossaryentry",
  [anon_sym_BSLASHgls] = "\\gls",
  [anon_sym_BSLASHGls] = "\\Gls",
  [anon_sym_BSLASHGLS] = "\\GLS",
  [anon_sym_BSLASHglspl] = "\\glspl",
  [anon_sym_BSLASHGlspl] = "\\Glspl",
  [anon_sym_BSLASHGLSpl] = "\\GLSpl",
  [anon_sym_BSLASHglsdisp] = "\\glsdisp",
  [anon_sym_BSLASHglslink] = "\\glslink",
  [anon_sym_BSLASHglstext] = "\\glstext",
  [anon_sym_BSLASHGlstext] = "\\Glstext",
  [anon_sym_BSLASHGLStext] = "\\GLStext",
  [anon_sym_BSLASHglsfirst] = "\\glsfirst",
  [anon_sym_BSLASHGlsfirst] = "\\Glsfirst",
  [anon_sym_BSLASHGLSfirst] = "\\GLSfirst",
  [anon_sym_BSLASHglsplural] = "\\glsplural",
  [anon_sym_BSLASHGlsplural] = "\\Glsplural",
  [anon_sym_BSLASHGLSplural] = "\\GLSplural",
  [anon_sym_BSLASHglsfirstplural] = "\\glsfirstplural",
  [anon_sym_BSLASHGlsfirstplural] = "\\Glsfirstplural",
  [anon_sym_BSLASHGLSfirstplural] = "\\GLSfirstplural",
  [anon_sym_BSLASHglsname] = "\\glsname",
  [anon_sym_BSLASHGlsname] = "\\Glsname",
  [anon_sym_BSLASHGLSname] = "\\GLSname",
  [anon_sym_BSLASHglssymbol] = "\\glssymbol",
  [anon_sym_BSLASHGlssymbol] = "\\Glssymbol",
  [anon_sym_BSLASHglsdesc] = "\\glsdesc",
  [anon_sym_BSLASHGlsdesc] = "\\Glsdesc",
  [anon_sym_BSLASHGLSdesc] = "\\GLSdesc",
  [anon_sym_BSLASHglsuseri] = "\\glsuseri",
  [anon_sym_BSLASHGlsuseri] = "\\Glsuseri",
  [anon_sym_BSLASHGLSuseri] = "\\GLSuseri",
  [anon_sym_BSLASHglsuserii] = "\\glsuserii",
  [anon_sym_BSLASHGlsuserii] = "\\Glsuserii",
  [anon_sym_BSLASHGLSuserii] = "\\GLSuserii",
  [anon_sym_BSLASHglsuseriii] = "\\glsuseriii",
  [anon_sym_BSLASHGlsuseriii] = "\\Glsuseriii",
  [anon_sym_BSLASHGLSuseriii] = "\\GLSuseriii",
  [anon_sym_BSLASHglsuseriv] = "\\glsuseriv",
  [anon_sym_BSLASHGlsuseriv] = "\\Glsuseriv",
  [anon_sym_BSLASHGLSuseriv] = "\\GLSuseriv",
  [anon_sym_BSLASHglsuserv] = "\\glsuserv",
  [anon_sym_BSLASHGlsuserv] = "\\Glsuserv",
  [anon_sym_BSLASHGLSuserv] = "\\GLSuserv",
  [anon_sym_BSLASHglsuservi] = "\\glsuservi",
  [anon_sym_BSLASHGlsuservi] = "\\Glsuservi",
  [anon_sym_BSLASHGLSuservi] = "\\GLSuservi",
  [anon_sym_BSLASHnewacronym] = "\\newacronym",
  [anon_sym_BSLASHacrshort] = "\\acrshort",
  [anon_sym_BSLASHAcrshort] = "\\Acrshort",
  [anon_sym_BSLASHACRshort] = "\\ACRshort",
  [anon_sym_BSLASHacrshortpl] = "\\acrshortpl",
  [anon_sym_BSLASHAcrshortpl] = "\\Acrshortpl",
  [anon_sym_BSLASHACRshortpl] = "\\ACRshortpl",
  [anon_sym_BSLASHacrlong] = "\\acrlong",
  [anon_sym_BSLASHAcrlong] = "\\Acrlong",
  [anon_sym_BSLASHACRlong] = "\\ACRlong",
  [anon_sym_BSLASHacrlongpl] = "\\acrlongpl",
  [anon_sym_BSLASHAcrlongpl] = "\\Acrlongpl",
  [anon_sym_BSLASHACRlongpl] = "\\ACRlongpl",
  [anon_sym_BSLASHacrfull] = "\\acrfull",
  [anon_sym_BSLASHAcrfull] = "\\Acrfull",
  [anon_sym_BSLASHACRfull] = "\\ACRfull",
  [anon_sym_BSLASHacrfullpl] = "\\acrfullpl",
  [anon_sym_BSLASHAcrfullpl] = "\\Acrfullpl",
  [anon_sym_BSLASHACRfullpl] = "\\ACRfullpl",
  [anon_sym_BSLASHacs] = "\\acs",
  [anon_sym_BSLASHAcs] = "\\Acs",
  [anon_sym_BSLASHacsp] = "\\acsp",
  [anon_sym_BSLASHAcsp] = "\\Acsp",
  [anon_sym_BSLASHacl] = "\\acl",
  [anon_sym_BSLASHAcl] = "\\Acl",
  [anon_sym_BSLASHaclp] = "\\aclp",
  [anon_sym_BSLASHAclp] = "\\Aclp",
  [anon_sym_BSLASHacf] = "\\acf",
  [anon_sym_BSLASHAcf] = "\\Acf",
  [anon_sym_BSLASHacfp] = "\\acfp",
  [anon_sym_BSLASHAcfp] = "\\Acfp",
  [anon_sym_BSLASHac] = "\\ac",
  [anon_sym_BSLASHAc] = "\\Ac",
  [anon_sym_BSLASHacp] = "\\acp",
  [anon_sym_BSLASHglsentrylong] = "\\glsentrylong",
  [anon_sym_BSLASHGlsentrylong] = "\\Glsentrylong",
  [anon_sym_BSLASHglsentrylongpl] = "\\glsentrylongpl",
  [anon_sym_BSLASHGlsentrylongpl] = "\\Glsentrylongpl",
  [anon_sym_BSLASHglsentryshort] = "\\glsentryshort",
  [anon_sym_BSLASHGlsentryshort] = "\\Glsentryshort",
  [anon_sym_BSLASHglsentryshortpl] = "\\glsentryshortpl",
  [anon_sym_BSLASHGlsentryshortpl] = "\\Glsentryshortpl",
  [anon_sym_BSLASHglsentryfullpl] = "\\glsentryfullpl",
  [anon_sym_BSLASHGlsentryfullpl] = "\\Glsentryfullpl",
  [anon_sym_BSLASHnewtheorem] = "\\newtheorem",
  [anon_sym_BSLASHnewtheorem_STAR] = "\\newtheorem*",
  [anon_sym_BSLASHdeclaretheorem] = "\\declaretheorem",
  [anon_sym_BSLASHdeclaretheorem_STAR] = "\\declaretheorem*",
  [anon_sym_BSLASHdefinecolor] = "\\definecolor",
  [anon_sym_BSLASHdefinecolorset] = "\\definecolorset",
  [anon_sym_BSLASHcolor] = "\\color",
  [anon_sym_BSLASHcolorbox] = "\\colorbox",
  [anon_sym_BSLASHtextcolor] = "\\textcolor",
  [anon_sym_BSLASHpagecolor] = "\\pagecolor",
  [anon_sym_BSLASHusepgflibrary] = "\\usepgflibrary",
  [anon_sym_BSLASHusetikzlibrary] = "\\usetikzlibrary",
  [anon_sym_BSLASHtext] = "\\text",
  [anon_sym_BSLASHintertext] = "\\intertext",
  [anon_sym_BSLASHshortintertext] = "\\shortintertext",
  [anon_sym_BSLASHurl] = "\\url",
  [anon_sym_BSLASHhref] = "\\href",
  [sym__trivia_raw_fi] = "comment",
  [sym__trivia_raw_env_comment] = "comment",
  [sym__trivia_raw_env_verbatim] = "comment",
  [sym__trivia_raw_env_listing] = "source_code",
  [sym__trivia_raw_env_minted] = "source_code",
  [sym__trivia_raw_env_pycode] = "source_code",
  [sym__trivia_raw_env_sagesilent] = "source_code",
  [sym__trivia_raw_env_sageblock] = "source_code",
  [sym_source_file] = "source_file",
  [sym_block_comment] = "block_comment",
  [sym__root_content] = "_root_content",
  [sym__flat_content] = "_flat_content",
  [sym__text_with_env_content] = "_text_with_env_content",
  [sym__text_content] = "_text_content",
  [sym__section] = "_section",
  [sym__paragraph] = "_paragraph",
  [sym__section_part] = "_section_part",
  [sym__part_declaration] = "_part_declaration",
  [sym_part] = "part",
  [sym__chapter_declaration] = "_chapter_declaration",
  [sym_chapter] = "chapter",
  [sym__section_declaration] = "_section_declaration",
  [sym_section] = "section",
  [sym__subsection_declaration] = "_subsection_declaration",
  [sym_subsection] = "subsection",
  [sym__subsubsection_declaration] = "_subsubsection_declaration",
  [sym_subsubsection] = "subsubsection",
  [sym__paragraph_declaration] = "_paragraph_declaration",
  [sym_paragraph] = "paragraph",
  [sym__subparagraph_declaration] = "_subparagraph_declaration",
  [sym_subparagraph] = "subparagraph",
  [sym__enum_itemdeclaration] = "_enum_itemdeclaration",
  [sym_enum_item] = "enum_item",
  [sym_curly_group] = "curly_group",
  [sym_curly_group_text] = "curly_group_text",
  [sym_curly_group_text_list] = "curly_group_text_list",
  [sym_curly_group_path] = "curly_group_path",
  [sym_curly_group_path_list] = "curly_group_path_list",
  [sym_curly_group_uri] = "curly_group_uri",
  [sym_curly_group_command_name] = "curly_group_command_name",
  [sym_curly_group_key_value] = "curly_group_key_value",
  [sym_curly_group_glob_pattern] = "curly_group_glob_pattern",
  [sym_curly_group_impl] = "curly_group_impl",
  [sym_curly_group_author_list] = "curly_group_author_list",
  [sym_brack_group] = "brack_group",
  [sym_brack_group_text] = "brack_group_text",
  [sym_brack_group_argc] = "brack_group_argc",
  [sym_brack_group_key_value] = "brack_group_key_value",
  [sym_text] = "text",
  [sym_glob_pattern] = "glob_pattern",
  [sym__glob_pattern_fragment] = "_glob_pattern_fragment",
  [sym_operator] = "operator",
  [sym_subscript] = "subscript",
  [sym_superscript] = "superscript",
  [sym_key_value_pair] = "key_value_pair",
  [sym_value] = "value",
  [sym_displayed_equation] = "displayed_equation",
  [sym_inline_formula] = "inline_formula",
  [sym_begin] = "begin",
  [sym_end] = "end",
  [sym_generic_environment] = "generic_environment",
  [sym_comment_environment] = "comment_environment",
  [sym__comment_environment_begin] = "begin",
  [sym__comment_environment_end] = "end",
  [sym__comment_environment_group] = "curly_group_text",
  [sym__comment_environment_name] = "text",
  [sym_verbatim_environment] = "verbatim_environment",
  [sym__verbatim_environment_begin] = "begin",
  [sym__verbatim_environment_end] = "end",
  [sym__verbatim_environment_group] = "curly_group_text",
  [sym__verbatim_environment_name] = "text",
  [sym_listing_environment] = "listing_environment",
  [sym__listing_environment_begin] = "begin",
  [sym__listing_environment_end] = "end",
  [sym__listing_environment_group] = "curly_group_text",
  [sym__listing_environment_name] = "text",
  [sym_minted_environment] = "minted_environment",
  [sym__minted_environment_begin] = "begin",
  [sym__minted_environment_end] = "end",
  [sym__minted_environment_group] = "curly_group_text",
  [sym__minted_environment_name] = "text",
  [sym_pycode_environment] = "pycode_environment",
  [sym__pycode_environment_begin] = "begin",
  [sym__pycode_environment_end] = "end",
  [sym__pycode_environment_group] = "curly_group_text",
  [sym__pycode_environment_name] = "text",
  [sym_sagesilent_environment] = "sagesilent_environment",
  [sym__sagesilent_environment_begin] = "begin",
  [sym__sagesilent_environment_end] = "end",
  [sym__sagesilent_environment_group] = "curly_group_text",
  [sym__sagesilent_environment_name] = "text",
  [sym_sageblock_environment] = "sageblock_environment",
  [sym__sageblock_environment_begin] = "begin",
  [sym__sageblock_environment_end] = "end",
  [sym__sageblock_environment_group] = "curly_group_text",
  [sym__sageblock_environment_name] = "text",
  [sym_math_environment] = "math_environment",
  [sym__math_environment_begin] = "begin",
  [sym__math_environment_end] = "end",
  [sym__math_environment_group] = "curly_group_text",
  [sym__math_environment_name] = "text",
  [sym__command] = "_command",
  [sym_generic_command] = "generic_command",
  [sym_title_declaration] = "title_declaration",
  [sym_author_declaration] = "author_declaration",
  [sym_package_include] = "package_include",
  [sym_class_include] = "class_include",
  [sym_latex_include] = "latex_include",
  [sym_biblatex_include] = "biblatex_include",
  [sym_bibstyle_include] = "bibstyle_include",
  [sym_bibtex_include] = "bibtex_include",
  [sym_graphics_include] = "graphics_include",
  [sym_svg_include] = "svg_include",
  [sym_inkscape_include] = "inkscape_include",
  [sym_verbatim_include] = "verbatim_include",
  [sym_import_include] = "import_include",
  [sym_caption] = "caption",
  [sym_citation] = "citation",
  [sym_label_definition] = "label_definition",
  [sym_label_reference] = "label_reference",
  [sym_label_reference_range] = "label_reference_range",
  [sym_label_number] = "label_number",
  [sym_new_command_definition] = "new_command_definition",
  [sym_old_command_definition] = "old_command_definition",
  [sym_let_command_definition] = "let_command_definition",
  [sym__math_delimiter_part] = "_math_delimiter_part",
  [sym_math_delimiter] = "math_delimiter",
  [sym_paired_delimiter_definition] = "paired_delimiter_definition",
  [sym_environment_definition] = "environment_definition",
  [sym_glossary_entry_definition] = "glossary_entry_definition",
  [sym_glossary_entry_reference] = "glossary_entry_reference",
  [sym_acronym_definition] = "acronym_definition",
  [sym_acronym_reference] = "acronym_reference",
  [sym_theorem_definition] = "theorem_definition",
  [sym_color_definition] = "color_definition",
  [sym_color_set_definition] = "color_set_definition",
  [sym_color_reference] = "color_reference",
  [sym_tikz_library_import] = "tikz_library_import",
  [sym_text_mode] = "text_mode",
  [sym_hyperlink] = "hyperlink",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym__section_repeat1] = "_section_repeat1",
  [aux_sym__section_repeat2] = "_section_repeat2",
  [aux_sym__section_repeat3] = "_section_repeat3",
  [aux_sym__section_repeat4] = "_section_repeat4",
  [aux_sym__section_repeat5] = "_section_repeat5",
  [aux_sym__paragraph_repeat1] = "_paragraph_repeat1",
  [aux_sym__paragraph_repeat2] = "_paragraph_repeat2",
  [aux_sym__paragraph_repeat3] = "_paragraph_repeat3",
  [aux_sym_part_repeat1] = "part_repeat1",
  [aux_sym_curly_group_text_list_repeat1] = "curly_group_text_list_repeat1",
  [aux_sym_curly_group_path_list_repeat1] = "curly_group_path_list_repeat1",
  [aux_sym_curly_group_key_value_repeat1] = "curly_group_key_value_repeat1",
  [aux_sym_curly_group_impl_repeat1] = "curly_group_impl_repeat1",
  [aux_sym_curly_group_author_list_repeat1] = "curly_group_author_list_repeat1",
  [aux_sym_curly_group_author_list_repeat2] = "curly_group_author_list_repeat2",
  [aux_sym_brack_group_repeat1] = "brack_group_repeat1",
  [aux_sym_text_repeat1] = "text_repeat1",
  [aux_sym_glob_pattern_repeat1] = "glob_pattern_repeat1",
  [aux_sym_value_repeat1] = "value_repeat1",
  [aux_sym_generic_command_repeat1] = "generic_command_repeat1",
  [alias_sym_author] = "author",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_command_name] = sym_command_name,
  [sym__whitespace] = sym__whitespace,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_BSLASHiffalse] = anon_sym_BSLASHiffalse,
  [anon_sym_BSLASHfi] = anon_sym_BSLASHfi,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_BSLASHpart] = anon_sym_BSLASHpart,
  [anon_sym_BSLASHpart_STAR] = anon_sym_BSLASHpart_STAR,
  [anon_sym_BSLASHaddpart] = anon_sym_BSLASHaddpart,
  [anon_sym_BSLASHaddpart_STAR] = anon_sym_BSLASHaddpart_STAR,
  [anon_sym_BSLASHchapter] = anon_sym_BSLASHchapter,
  [anon_sym_BSLASHchapter_STAR] = anon_sym_BSLASHchapter_STAR,
  [anon_sym_BSLASHaddchap] = anon_sym_BSLASHaddchap,
  [anon_sym_BSLASHaddchap_STAR] = anon_sym_BSLASHaddchap_STAR,
  [anon_sym_BSLASHsection] = anon_sym_BSLASHsection,
  [anon_sym_BSLASHsection_STAR] = anon_sym_BSLASHsection_STAR,
  [anon_sym_BSLASHaddsec] = anon_sym_BSLASHaddsec,
  [anon_sym_BSLASHaddsec_STAR] = anon_sym_BSLASHaddsec_STAR,
  [anon_sym_BSLASHsubsection] = anon_sym_BSLASHsubsection,
  [anon_sym_BSLASHsubsection_STAR] = anon_sym_BSLASHsubsection_STAR,
  [anon_sym_BSLASHsubsubsection] = anon_sym_BSLASHsubsubsection,
  [anon_sym_BSLASHsubsubsection_STAR] = anon_sym_BSLASHsubsubsection_STAR,
  [anon_sym_BSLASHparagraph] = anon_sym_BSLASHparagraph,
  [anon_sym_BSLASHparagraph_STAR] = anon_sym_BSLASHparagraph_STAR,
  [anon_sym_BSLASHsubparagraph] = anon_sym_BSLASHsubparagraph,
  [anon_sym_BSLASHsubparagraph_STAR] = anon_sym_BSLASHsubparagraph_STAR,
  [anon_sym_BSLASHitem] = anon_sym_BSLASHitem,
  [anon_sym_BSLASHitem_STAR] = anon_sym_BSLASHitem_STAR,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_BSLASHand] = sym_command_name,
  [sym_word] = sym_word,
  [sym_placeholder] = sym_placeholder,
  [sym_path] = sym_path,
  [sym_uri] = sym_uri,
  [sym_argc] = sym_argc,
  [aux_sym__glob_pattern_fragment_token1] = aux_sym__glob_pattern_fragment_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym_letter] = sym_letter,
  [anon_sym__] = anon_sym__,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_DOLLAR_DOLLAR] = anon_sym_DOLLAR_DOLLAR,
  [anon_sym_BSLASH_LBRACK] = anon_sym_BSLASH_LBRACK,
  [anon_sym_BSLASH_RBRACK] = anon_sym_BSLASH_RBRACK,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_BSLASH_LPAREN] = anon_sym_BSLASH_LPAREN,
  [anon_sym_BSLASH_RPAREN] = anon_sym_BSLASH_RPAREN,
  [anon_sym_BSLASHbegin] = anon_sym_BSLASHbegin,
  [anon_sym_BSLASHend] = anon_sym_BSLASHend,
  [anon_sym_comment] = sym_word,
  [anon_sym_verbatim] = sym_word,
  [anon_sym_lstlisting] = sym_word,
  [anon_sym_minted] = sym_word,
  [anon_sym_pycode] = sym_word,
  [anon_sym_sagesilent] = sym_word,
  [anon_sym_sageblock] = sym_word,
  [anon_sym_math] = sym_word,
  [anon_sym_displaymath] = sym_word,
  [anon_sym_displaymath_STAR] = sym_word,
  [anon_sym_equation] = sym_word,
  [anon_sym_equation_STAR] = sym_word,
  [anon_sym_multline] = sym_word,
  [anon_sym_multline_STAR] = sym_word,
  [anon_sym_eqnarray] = sym_word,
  [anon_sym_eqnarray_STAR] = sym_word,
  [anon_sym_align] = sym_word,
  [anon_sym_align_STAR] = sym_word,
  [anon_sym_array] = sym_word,
  [anon_sym_array_STAR] = sym_word,
  [anon_sym_split] = sym_word,
  [anon_sym_split_STAR] = sym_word,
  [anon_sym_alignat] = sym_word,
  [anon_sym_alignat_STAR] = sym_word,
  [anon_sym_gather] = sym_word,
  [anon_sym_gather_STAR] = sym_word,
  [anon_sym_flalign] = sym_word,
  [anon_sym_flalign_STAR] = sym_word,
  [anon_sym_BSLASHtitle] = anon_sym_BSLASHtitle,
  [anon_sym_BSLASHauthor] = anon_sym_BSLASHauthor,
  [anon_sym_BSLASHusepackage] = anon_sym_BSLASHusepackage,
  [anon_sym_BSLASHRequirePackage] = anon_sym_BSLASHRequirePackage,
  [anon_sym_BSLASHdocumentclass] = anon_sym_BSLASHdocumentclass,
  [anon_sym_BSLASHinclude] = anon_sym_BSLASHinclude,
  [anon_sym_BSLASHsubfileinclude] = anon_sym_BSLASHsubfileinclude,
  [anon_sym_BSLASHinput] = anon_sym_BSLASHinput,
  [anon_sym_BSLASHsubfile] = anon_sym_BSLASHsubfile,
  [anon_sym_BSLASHaddbibresource] = anon_sym_BSLASHaddbibresource,
  [anon_sym_BSLASHbibliographystyle] = anon_sym_BSLASHbibliographystyle,
  [anon_sym_BSLASHbibliography] = anon_sym_BSLASHbibliography,
  [anon_sym_BSLASHincludegraphics] = anon_sym_BSLASHincludegraphics,
  [anon_sym_BSLASHincludesvg] = anon_sym_BSLASHincludesvg,
  [anon_sym_BSLASHincludeinkscape] = anon_sym_BSLASHincludeinkscape,
  [anon_sym_BSLASHverbatiminput] = anon_sym_BSLASHverbatiminput,
  [anon_sym_BSLASHVerbatimInput] = anon_sym_BSLASHVerbatimInput,
  [anon_sym_BSLASHimport] = anon_sym_BSLASHimport,
  [anon_sym_BSLASHsubimport] = anon_sym_BSLASHsubimport,
  [anon_sym_BSLASHinputfrom] = anon_sym_BSLASHinputfrom,
  [anon_sym_BSLASHsubimportfrom] = anon_sym_BSLASHsubimportfrom,
  [anon_sym_BSLASHincludefrom] = anon_sym_BSLASHincludefrom,
  [anon_sym_BSLASHsubincludefrom] = anon_sym_BSLASHsubincludefrom,
  [anon_sym_BSLASHcaption] = anon_sym_BSLASHcaption,
  [anon_sym_BSLASHcite] = anon_sym_BSLASHcite,
  [anon_sym_BSLASHcite_STAR] = anon_sym_BSLASHcite_STAR,
  [anon_sym_BSLASHCite] = anon_sym_BSLASHCite,
  [anon_sym_BSLASHnocite] = anon_sym_BSLASHnocite,
  [anon_sym_BSLASHcitet] = anon_sym_BSLASHcitet,
  [anon_sym_BSLASHcitep] = anon_sym_BSLASHcitep,
  [anon_sym_BSLASHcitet_STAR] = anon_sym_BSLASHcitet_STAR,
  [anon_sym_BSLASHcitep_STAR] = anon_sym_BSLASHcitep_STAR,
  [anon_sym_BSLASHciteA] = anon_sym_BSLASHciteA,
  [anon_sym_BSLASHciteR] = anon_sym_BSLASHciteR,
  [anon_sym_BSLASHciteS] = anon_sym_BSLASHciteS,
  [anon_sym_BSLASHciteyearR] = anon_sym_BSLASHciteyearR,
  [anon_sym_BSLASHciteauthor] = anon_sym_BSLASHciteauthor,
  [anon_sym_BSLASHciteauthor_STAR] = anon_sym_BSLASHciteauthor_STAR,
  [anon_sym_BSLASHCiteauthor] = anon_sym_BSLASHCiteauthor,
  [anon_sym_BSLASHCiteauthor_STAR] = anon_sym_BSLASHCiteauthor_STAR,
  [anon_sym_BSLASHcitetitle] = anon_sym_BSLASHcitetitle,
  [anon_sym_BSLASHcitetitle_STAR] = anon_sym_BSLASHcitetitle_STAR,
  [anon_sym_BSLASHciteyear] = anon_sym_BSLASHciteyear,
  [anon_sym_BSLASHciteyear_STAR] = anon_sym_BSLASHciteyear_STAR,
  [anon_sym_BSLASHcitedate] = anon_sym_BSLASHcitedate,
  [anon_sym_BSLASHcitedate_STAR] = anon_sym_BSLASHcitedate_STAR,
  [anon_sym_BSLASHciteurl] = anon_sym_BSLASHciteurl,
  [anon_sym_BSLASHfullcite] = anon_sym_BSLASHfullcite,
  [anon_sym_BSLASHciteyearpar] = anon_sym_BSLASHciteyearpar,
  [anon_sym_BSLASHcitealt] = anon_sym_BSLASHcitealt,
  [anon_sym_BSLASHcitealp] = anon_sym_BSLASHcitealp,
  [anon_sym_BSLASHcitetext] = anon_sym_BSLASHcitetext,
  [anon_sym_BSLASHparencite] = anon_sym_BSLASHparencite,
  [anon_sym_BSLASHparencite_STAR] = anon_sym_BSLASHparencite_STAR,
  [anon_sym_BSLASHParencite] = anon_sym_BSLASHParencite,
  [anon_sym_BSLASHfootcite] = anon_sym_BSLASHfootcite,
  [anon_sym_BSLASHfootfullcite] = anon_sym_BSLASHfootfullcite,
  [anon_sym_BSLASHfootcitetext] = anon_sym_BSLASHfootcitetext,
  [anon_sym_BSLASHtextcite] = anon_sym_BSLASHtextcite,
  [anon_sym_BSLASHTextcite] = anon_sym_BSLASHTextcite,
  [anon_sym_BSLASHsmartcite] = anon_sym_BSLASHsmartcite,
  [anon_sym_BSLASHSmartcite] = anon_sym_BSLASHSmartcite,
  [anon_sym_BSLASHsupercite] = anon_sym_BSLASHsupercite,
  [anon_sym_BSLASHautocite] = anon_sym_BSLASHautocite,
  [anon_sym_BSLASHAutocite] = anon_sym_BSLASHAutocite,
  [anon_sym_BSLASHautocite_STAR] = anon_sym_BSLASHautocite_STAR,
  [anon_sym_BSLASHAutocite_STAR] = anon_sym_BSLASHAutocite_STAR,
  [anon_sym_BSLASHvolcite] = anon_sym_BSLASHvolcite,
  [anon_sym_BSLASHVolcite] = anon_sym_BSLASHVolcite,
  [anon_sym_BSLASHpvolcite] = anon_sym_BSLASHpvolcite,
  [anon_sym_BSLASHPvolcite] = anon_sym_BSLASHPvolcite,
  [anon_sym_BSLASHfvolcite] = anon_sym_BSLASHfvolcite,
  [anon_sym_BSLASHftvolcite] = anon_sym_BSLASHftvolcite,
  [anon_sym_BSLASHsvolcite] = anon_sym_BSLASHsvolcite,
  [anon_sym_BSLASHSvolcite] = anon_sym_BSLASHSvolcite,
  [anon_sym_BSLASHtvolcite] = anon_sym_BSLASHtvolcite,
  [anon_sym_BSLASHTvolcite] = anon_sym_BSLASHTvolcite,
  [anon_sym_BSLASHavolcite] = anon_sym_BSLASHavolcite,
  [anon_sym_BSLASHAvolcite] = anon_sym_BSLASHAvolcite,
  [anon_sym_BSLASHnotecite] = anon_sym_BSLASHnotecite,
  [anon_sym_BSLASHNotecite] = anon_sym_BSLASHNotecite,
  [anon_sym_BSLASHpnotecite] = anon_sym_BSLASHpnotecite,
  [anon_sym_BSLASHPnotecite] = anon_sym_BSLASHPnotecite,
  [anon_sym_BSLASHfnotecite] = anon_sym_BSLASHfnotecite,
  [anon_sym_BSLASHlabel] = anon_sym_BSLASHlabel,
  [anon_sym_BSLASHref] = anon_sym_BSLASHref,
  [anon_sym_BSLASHeqref] = anon_sym_BSLASHeqref,
  [anon_sym_BSLASHvref] = anon_sym_BSLASHvref,
  [anon_sym_BSLASHVref] = anon_sym_BSLASHVref,
  [anon_sym_BSLASHautoref] = anon_sym_BSLASHautoref,
  [anon_sym_BSLASHpageref] = anon_sym_BSLASHpageref,
  [anon_sym_BSLASHcref] = anon_sym_BSLASHcref,
  [anon_sym_BSLASHCref] = anon_sym_BSLASHCref,
  [anon_sym_BSLASHcref_STAR] = anon_sym_BSLASHcref_STAR,
  [anon_sym_BSLASHCref_STAR] = anon_sym_BSLASHCref_STAR,
  [anon_sym_BSLASHnamecref] = anon_sym_BSLASHnamecref,
  [anon_sym_BSLASHnameCref] = anon_sym_BSLASHnameCref,
  [anon_sym_BSLASHlcnamecref] = anon_sym_BSLASHlcnamecref,
  [anon_sym_BSLASHnamecrefs] = anon_sym_BSLASHnamecrefs,
  [anon_sym_BSLASHnameCrefs] = anon_sym_BSLASHnameCrefs,
  [anon_sym_BSLASHlcnamecrefs] = anon_sym_BSLASHlcnamecrefs,
  [anon_sym_BSLASHlabelcref] = anon_sym_BSLASHlabelcref,
  [anon_sym_BSLASHlabelcpageref] = anon_sym_BSLASHlabelcpageref,
  [anon_sym_BSLASHcrefrange] = anon_sym_BSLASHcrefrange,
  [anon_sym_BSLASHcrefrange_STAR] = anon_sym_BSLASHcrefrange_STAR,
  [anon_sym_BSLASHCrefrange] = anon_sym_BSLASHCrefrange,
  [anon_sym_BSLASHCrefrange_STAR] = anon_sym_BSLASHCrefrange_STAR,
  [anon_sym_BSLASHnewlabel] = anon_sym_BSLASHnewlabel,
  [anon_sym_BSLASHnewcommand] = anon_sym_BSLASHnewcommand,
  [anon_sym_BSLASHnewcommand_STAR] = anon_sym_BSLASHnewcommand_STAR,
  [anon_sym_BSLASHrenewcommand] = anon_sym_BSLASHrenewcommand,
  [anon_sym_BSLASHrenewcommand_STAR] = anon_sym_BSLASHrenewcommand_STAR,
  [anon_sym_BSLASHDeclareRobustCommand] = anon_sym_BSLASHDeclareRobustCommand,
  [anon_sym_BSLASHDeclareRobustCommand_STAR] = anon_sym_BSLASHDeclareRobustCommand_STAR,
  [anon_sym_BSLASHDeclareMathOperator] = anon_sym_BSLASHDeclareMathOperator,
  [anon_sym_BSLASHDeclareMathOperator_STAR] = anon_sym_BSLASHDeclareMathOperator_STAR,
  [anon_sym_BSLASHNewDocumentCommand] = anon_sym_BSLASHNewDocumentCommand,
  [anon_sym_BSLASHRenewDocumentCommand] = anon_sym_BSLASHRenewDocumentCommand,
  [anon_sym_BSLASHProvideDocumentCommand] = anon_sym_BSLASHProvideDocumentCommand,
  [anon_sym_BSLASHDeclareDocumentCommand] = anon_sym_BSLASHDeclareDocumentCommand,
  [anon_sym_BSLASHNewExpandableDocumentCommand] = anon_sym_BSLASHNewExpandableDocumentCommand,
  [anon_sym_BSLASHRenewExpandableDocumentCommand] = anon_sym_BSLASHRenewExpandableDocumentCommand,
  [anon_sym_BSLASHProvideExpandableDocumentCommand] = anon_sym_BSLASHProvideExpandableDocumentCommand,
  [anon_sym_BSLASHDeclareExpandableDocumentCommand] = anon_sym_BSLASHDeclareExpandableDocumentCommand,
  [anon_sym_BSLASHdef] = anon_sym_BSLASHdef,
  [anon_sym_BSLASHlet] = anon_sym_BSLASHlet,
  [anon_sym_BSLASHleft] = anon_sym_BSLASHleft,
  [anon_sym_BSLASHbigl] = anon_sym_BSLASHbigl,
  [anon_sym_BSLASHBigl] = anon_sym_BSLASHBigl,
  [anon_sym_BSLASHbiggl] = anon_sym_BSLASHbiggl,
  [anon_sym_BSLASHBiggl] = anon_sym_BSLASHBiggl,
  [anon_sym_BSLASHright] = anon_sym_BSLASHright,
  [anon_sym_BSLASHbigr] = anon_sym_BSLASHbigr,
  [anon_sym_BSLASHBigr] = anon_sym_BSLASHBigr,
  [anon_sym_BSLASHbiggr] = anon_sym_BSLASHbiggr,
  [anon_sym_BSLASHBiggr] = anon_sym_BSLASHBiggr,
  [anon_sym_BSLASHDeclarePairedDelimiter] = anon_sym_BSLASHDeclarePairedDelimiter,
  [anon_sym_BSLASHDeclarePairedDelimiterX] = anon_sym_BSLASHDeclarePairedDelimiterX,
  [anon_sym_BSLASHnewenvironment] = anon_sym_BSLASHnewenvironment,
  [anon_sym_BSLASHrenewenvironment] = anon_sym_BSLASHrenewenvironment,
  [anon_sym_BSLASHNewDocumentEnvironment] = anon_sym_BSLASHNewDocumentEnvironment,
  [anon_sym_BSLASHRenewDocumentEnvironment] = anon_sym_BSLASHRenewDocumentEnvironment,
  [anon_sym_BSLASHProvideDocumentEnvironment] = anon_sym_BSLASHProvideDocumentEnvironment,
  [anon_sym_BSLASHDeclareDocumentEnvironment] = anon_sym_BSLASHDeclareDocumentEnvironment,
  [anon_sym_BSLASHnewglossaryentry] = anon_sym_BSLASHnewglossaryentry,
  [anon_sym_BSLASHgls] = anon_sym_BSLASHgls,
  [anon_sym_BSLASHGls] = anon_sym_BSLASHGls,
  [anon_sym_BSLASHGLS] = anon_sym_BSLASHGLS,
  [anon_sym_BSLASHglspl] = anon_sym_BSLASHglspl,
  [anon_sym_BSLASHGlspl] = anon_sym_BSLASHGlspl,
  [anon_sym_BSLASHGLSpl] = anon_sym_BSLASHGLSpl,
  [anon_sym_BSLASHglsdisp] = anon_sym_BSLASHglsdisp,
  [anon_sym_BSLASHglslink] = anon_sym_BSLASHglslink,
  [anon_sym_BSLASHglstext] = anon_sym_BSLASHglstext,
  [anon_sym_BSLASHGlstext] = anon_sym_BSLASHGlstext,
  [anon_sym_BSLASHGLStext] = anon_sym_BSLASHGLStext,
  [anon_sym_BSLASHglsfirst] = anon_sym_BSLASHglsfirst,
  [anon_sym_BSLASHGlsfirst] = anon_sym_BSLASHGlsfirst,
  [anon_sym_BSLASHGLSfirst] = anon_sym_BSLASHGLSfirst,
  [anon_sym_BSLASHglsplural] = anon_sym_BSLASHglsplural,
  [anon_sym_BSLASHGlsplural] = anon_sym_BSLASHGlsplural,
  [anon_sym_BSLASHGLSplural] = anon_sym_BSLASHGLSplural,
  [anon_sym_BSLASHglsfirstplural] = anon_sym_BSLASHglsfirstplural,
  [anon_sym_BSLASHGlsfirstplural] = anon_sym_BSLASHGlsfirstplural,
  [anon_sym_BSLASHGLSfirstplural] = anon_sym_BSLASHGLSfirstplural,
  [anon_sym_BSLASHglsname] = anon_sym_BSLASHglsname,
  [anon_sym_BSLASHGlsname] = anon_sym_BSLASHGlsname,
  [anon_sym_BSLASHGLSname] = anon_sym_BSLASHGLSname,
  [anon_sym_BSLASHglssymbol] = anon_sym_BSLASHglssymbol,
  [anon_sym_BSLASHGlssymbol] = anon_sym_BSLASHGlssymbol,
  [anon_sym_BSLASHglsdesc] = anon_sym_BSLASHglsdesc,
  [anon_sym_BSLASHGlsdesc] = anon_sym_BSLASHGlsdesc,
  [anon_sym_BSLASHGLSdesc] = anon_sym_BSLASHGLSdesc,
  [anon_sym_BSLASHglsuseri] = anon_sym_BSLASHglsuseri,
  [anon_sym_BSLASHGlsuseri] = anon_sym_BSLASHGlsuseri,
  [anon_sym_BSLASHGLSuseri] = anon_sym_BSLASHGLSuseri,
  [anon_sym_BSLASHglsuserii] = anon_sym_BSLASHglsuserii,
  [anon_sym_BSLASHGlsuserii] = anon_sym_BSLASHGlsuserii,
  [anon_sym_BSLASHGLSuserii] = anon_sym_BSLASHGLSuserii,
  [anon_sym_BSLASHglsuseriii] = anon_sym_BSLASHglsuseriii,
  [anon_sym_BSLASHGlsuseriii] = anon_sym_BSLASHGlsuseriii,
  [anon_sym_BSLASHGLSuseriii] = anon_sym_BSLASHGLSuseriii,
  [anon_sym_BSLASHglsuseriv] = anon_sym_BSLASHglsuseriv,
  [anon_sym_BSLASHGlsuseriv] = anon_sym_BSLASHGlsuseriv,
  [anon_sym_BSLASHGLSuseriv] = anon_sym_BSLASHGLSuseriv,
  [anon_sym_BSLASHglsuserv] = anon_sym_BSLASHglsuserv,
  [anon_sym_BSLASHGlsuserv] = anon_sym_BSLASHGlsuserv,
  [anon_sym_BSLASHGLSuserv] = anon_sym_BSLASHGLSuserv,
  [anon_sym_BSLASHglsuservi] = anon_sym_BSLASHglsuservi,
  [anon_sym_BSLASHGlsuservi] = anon_sym_BSLASHGlsuservi,
  [anon_sym_BSLASHGLSuservi] = anon_sym_BSLASHGLSuservi,
  [anon_sym_BSLASHnewacronym] = anon_sym_BSLASHnewacronym,
  [anon_sym_BSLASHacrshort] = anon_sym_BSLASHacrshort,
  [anon_sym_BSLASHAcrshort] = anon_sym_BSLASHAcrshort,
  [anon_sym_BSLASHACRshort] = anon_sym_BSLASHACRshort,
  [anon_sym_BSLASHacrshortpl] = anon_sym_BSLASHacrshortpl,
  [anon_sym_BSLASHAcrshortpl] = anon_sym_BSLASHAcrshortpl,
  [anon_sym_BSLASHACRshortpl] = anon_sym_BSLASHACRshortpl,
  [anon_sym_BSLASHacrlong] = anon_sym_BSLASHacrlong,
  [anon_sym_BSLASHAcrlong] = anon_sym_BSLASHAcrlong,
  [anon_sym_BSLASHACRlong] = anon_sym_BSLASHACRlong,
  [anon_sym_BSLASHacrlongpl] = anon_sym_BSLASHacrlongpl,
  [anon_sym_BSLASHAcrlongpl] = anon_sym_BSLASHAcrlongpl,
  [anon_sym_BSLASHACRlongpl] = anon_sym_BSLASHACRlongpl,
  [anon_sym_BSLASHacrfull] = anon_sym_BSLASHacrfull,
  [anon_sym_BSLASHAcrfull] = anon_sym_BSLASHAcrfull,
  [anon_sym_BSLASHACRfull] = anon_sym_BSLASHACRfull,
  [anon_sym_BSLASHacrfullpl] = anon_sym_BSLASHacrfullpl,
  [anon_sym_BSLASHAcrfullpl] = anon_sym_BSLASHAcrfullpl,
  [anon_sym_BSLASHACRfullpl] = anon_sym_BSLASHACRfullpl,
  [anon_sym_BSLASHacs] = anon_sym_BSLASHacs,
  [anon_sym_BSLASHAcs] = anon_sym_BSLASHAcs,
  [anon_sym_BSLASHacsp] = anon_sym_BSLASHacsp,
  [anon_sym_BSLASHAcsp] = anon_sym_BSLASHAcsp,
  [anon_sym_BSLASHacl] = anon_sym_BSLASHacl,
  [anon_sym_BSLASHAcl] = anon_sym_BSLASHAcl,
  [anon_sym_BSLASHaclp] = anon_sym_BSLASHaclp,
  [anon_sym_BSLASHAclp] = anon_sym_BSLASHAclp,
  [anon_sym_BSLASHacf] = anon_sym_BSLASHacf,
  [anon_sym_BSLASHAcf] = anon_sym_BSLASHAcf,
  [anon_sym_BSLASHacfp] = anon_sym_BSLASHacfp,
  [anon_sym_BSLASHAcfp] = anon_sym_BSLASHAcfp,
  [anon_sym_BSLASHac] = anon_sym_BSLASHac,
  [anon_sym_BSLASHAc] = anon_sym_BSLASHAc,
  [anon_sym_BSLASHacp] = anon_sym_BSLASHacp,
  [anon_sym_BSLASHglsentrylong] = anon_sym_BSLASHglsentrylong,
  [anon_sym_BSLASHGlsentrylong] = anon_sym_BSLASHGlsentrylong,
  [anon_sym_BSLASHglsentrylongpl] = anon_sym_BSLASHglsentrylongpl,
  [anon_sym_BSLASHGlsentrylongpl] = anon_sym_BSLASHGlsentrylongpl,
  [anon_sym_BSLASHglsentryshort] = anon_sym_BSLASHglsentryshort,
  [anon_sym_BSLASHGlsentryshort] = anon_sym_BSLASHGlsentryshort,
  [anon_sym_BSLASHglsentryshortpl] = anon_sym_BSLASHglsentryshortpl,
  [anon_sym_BSLASHGlsentryshortpl] = anon_sym_BSLASHGlsentryshortpl,
  [anon_sym_BSLASHglsentryfullpl] = anon_sym_BSLASHglsentryfullpl,
  [anon_sym_BSLASHGlsentryfullpl] = anon_sym_BSLASHGlsentryfullpl,
  [anon_sym_BSLASHnewtheorem] = anon_sym_BSLASHnewtheorem,
  [anon_sym_BSLASHnewtheorem_STAR] = anon_sym_BSLASHnewtheorem_STAR,
  [anon_sym_BSLASHdeclaretheorem] = anon_sym_BSLASHdeclaretheorem,
  [anon_sym_BSLASHdeclaretheorem_STAR] = anon_sym_BSLASHdeclaretheorem_STAR,
  [anon_sym_BSLASHdefinecolor] = anon_sym_BSLASHdefinecolor,
  [anon_sym_BSLASHdefinecolorset] = anon_sym_BSLASHdefinecolorset,
  [anon_sym_BSLASHcolor] = anon_sym_BSLASHcolor,
  [anon_sym_BSLASHcolorbox] = anon_sym_BSLASHcolorbox,
  [anon_sym_BSLASHtextcolor] = anon_sym_BSLASHtextcolor,
  [anon_sym_BSLASHpagecolor] = anon_sym_BSLASHpagecolor,
  [anon_sym_BSLASHusepgflibrary] = anon_sym_BSLASHusepgflibrary,
  [anon_sym_BSLASHusetikzlibrary] = anon_sym_BSLASHusetikzlibrary,
  [anon_sym_BSLASHtext] = anon_sym_BSLASHtext,
  [anon_sym_BSLASHintertext] = anon_sym_BSLASHintertext,
  [anon_sym_BSLASHshortintertext] = anon_sym_BSLASHshortintertext,
  [anon_sym_BSLASHurl] = anon_sym_BSLASHurl,
  [anon_sym_BSLASHhref] = anon_sym_BSLASHhref,
  [sym__trivia_raw_fi] = sym__trivia_raw_fi,
  [sym__trivia_raw_env_comment] = sym__trivia_raw_fi,
  [sym__trivia_raw_env_verbatim] = sym__trivia_raw_fi,
  [sym__trivia_raw_env_listing] = sym__trivia_raw_env_listing,
  [sym__trivia_raw_env_minted] = sym__trivia_raw_env_listing,
  [sym__trivia_raw_env_pycode] = sym__trivia_raw_env_listing,
  [sym__trivia_raw_env_sagesilent] = sym__trivia_raw_env_listing,
  [sym__trivia_raw_env_sageblock] = sym__trivia_raw_env_listing,
  [sym_source_file] = sym_source_file,
  [sym_block_comment] = sym_block_comment,
  [sym__root_content] = sym__root_content,
  [sym__flat_content] = sym__flat_content,
  [sym__text_with_env_content] = sym__text_with_env_content,
  [sym__text_content] = sym__text_content,
  [sym__section] = sym__section,
  [sym__paragraph] = sym__paragraph,
  [sym__section_part] = sym__section_part,
  [sym__part_declaration] = sym__part_declaration,
  [sym_part] = sym_part,
  [sym__chapter_declaration] = sym__chapter_declaration,
  [sym_chapter] = sym_chapter,
  [sym__section_declaration] = sym__section_declaration,
  [sym_section] = sym_section,
  [sym__subsection_declaration] = sym__subsection_declaration,
  [sym_subsection] = sym_subsection,
  [sym__subsubsection_declaration] = sym__subsubsection_declaration,
  [sym_subsubsection] = sym_subsubsection,
  [sym__paragraph_declaration] = sym__paragraph_declaration,
  [sym_paragraph] = sym_paragraph,
  [sym__subparagraph_declaration] = sym__subparagraph_declaration,
  [sym_subparagraph] = sym_subparagraph,
  [sym__enum_itemdeclaration] = sym__enum_itemdeclaration,
  [sym_enum_item] = sym_enum_item,
  [sym_curly_group] = sym_curly_group,
  [sym_curly_group_text] = sym_curly_group_text,
  [sym_curly_group_text_list] = sym_curly_group_text_list,
  [sym_curly_group_path] = sym_curly_group_path,
  [sym_curly_group_path_list] = sym_curly_group_path_list,
  [sym_curly_group_uri] = sym_curly_group_uri,
  [sym_curly_group_command_name] = sym_curly_group_command_name,
  [sym_curly_group_key_value] = sym_curly_group_key_value,
  [sym_curly_group_glob_pattern] = sym_curly_group_glob_pattern,
  [sym_curly_group_impl] = sym_curly_group_impl,
  [sym_curly_group_author_list] = sym_curly_group_author_list,
  [sym_brack_group] = sym_brack_group,
  [sym_brack_group_text] = sym_brack_group_text,
  [sym_brack_group_argc] = sym_brack_group_argc,
  [sym_brack_group_key_value] = sym_brack_group_key_value,
  [sym_text] = sym_text,
  [sym_glob_pattern] = sym_glob_pattern,
  [sym__glob_pattern_fragment] = sym__glob_pattern_fragment,
  [sym_operator] = sym_operator,
  [sym_subscript] = sym_subscript,
  [sym_superscript] = sym_superscript,
  [sym_key_value_pair] = sym_key_value_pair,
  [sym_value] = sym_value,
  [sym_displayed_equation] = sym_displayed_equation,
  [sym_inline_formula] = sym_inline_formula,
  [sym_begin] = sym_begin,
  [sym_end] = sym_end,
  [sym_generic_environment] = sym_generic_environment,
  [sym_comment_environment] = sym_comment_environment,
  [sym__comment_environment_begin] = sym_begin,
  [sym__comment_environment_end] = sym_end,
  [sym__comment_environment_group] = sym_curly_group_text,
  [sym__comment_environment_name] = sym_text,
  [sym_verbatim_environment] = sym_verbatim_environment,
  [sym__verbatim_environment_begin] = sym_begin,
  [sym__verbatim_environment_end] = sym_end,
  [sym__verbatim_environment_group] = sym_curly_group_text,
  [sym__verbatim_environment_name] = sym_text,
  [sym_listing_environment] = sym_listing_environment,
  [sym__listing_environment_begin] = sym_begin,
  [sym__listing_environment_end] = sym_end,
  [sym__listing_environment_group] = sym_curly_group_text,
  [sym__listing_environment_name] = sym_text,
  [sym_minted_environment] = sym_minted_environment,
  [sym__minted_environment_begin] = sym_begin,
  [sym__minted_environment_end] = sym_end,
  [sym__minted_environment_group] = sym_curly_group_text,
  [sym__minted_environment_name] = sym_text,
  [sym_pycode_environment] = sym_pycode_environment,
  [sym__pycode_environment_begin] = sym_begin,
  [sym__pycode_environment_end] = sym_end,
  [sym__pycode_environment_group] = sym_curly_group_text,
  [sym__pycode_environment_name] = sym_text,
  [sym_sagesilent_environment] = sym_sagesilent_environment,
  [sym__sagesilent_environment_begin] = sym_begin,
  [sym__sagesilent_environment_end] = sym_end,
  [sym__sagesilent_environment_group] = sym_curly_group_text,
  [sym__sagesilent_environment_name] = sym_text,
  [sym_sageblock_environment] = sym_sageblock_environment,
  [sym__sageblock_environment_begin] = sym_begin,
  [sym__sageblock_environment_end] = sym_end,
  [sym__sageblock_environment_group] = sym_curly_group_text,
  [sym__sageblock_environment_name] = sym_text,
  [sym_math_environment] = sym_math_environment,
  [sym__math_environment_begin] = sym_begin,
  [sym__math_environment_end] = sym_end,
  [sym__math_environment_group] = sym_curly_group_text,
  [sym__math_environment_name] = sym_text,
  [sym__command] = sym__command,
  [sym_generic_command] = sym_generic_command,
  [sym_title_declaration] = sym_title_declaration,
  [sym_author_declaration] = sym_author_declaration,
  [sym_package_include] = sym_package_include,
  [sym_class_include] = sym_class_include,
  [sym_latex_include] = sym_latex_include,
  [sym_biblatex_include] = sym_biblatex_include,
  [sym_bibstyle_include] = sym_bibstyle_include,
  [sym_bibtex_include] = sym_bibtex_include,
  [sym_graphics_include] = sym_graphics_include,
  [sym_svg_include] = sym_svg_include,
  [sym_inkscape_include] = sym_inkscape_include,
  [sym_verbatim_include] = sym_verbatim_include,
  [sym_import_include] = sym_import_include,
  [sym_caption] = sym_caption,
  [sym_citation] = sym_citation,
  [sym_label_definition] = sym_label_definition,
  [sym_label_reference] = sym_label_reference,
  [sym_label_reference_range] = sym_label_reference_range,
  [sym_label_number] = sym_label_number,
  [sym_new_command_definition] = sym_new_command_definition,
  [sym_old_command_definition] = sym_old_command_definition,
  [sym_let_command_definition] = sym_let_command_definition,
  [sym__math_delimiter_part] = sym__math_delimiter_part,
  [sym_math_delimiter] = sym_math_delimiter,
  [sym_paired_delimiter_definition] = sym_paired_delimiter_definition,
  [sym_environment_definition] = sym_environment_definition,
  [sym_glossary_entry_definition] = sym_glossary_entry_definition,
  [sym_glossary_entry_reference] = sym_glossary_entry_reference,
  [sym_acronym_definition] = sym_acronym_definition,
  [sym_acronym_reference] = sym_acronym_reference,
  [sym_theorem_definition] = sym_theorem_definition,
  [sym_color_definition] = sym_color_definition,
  [sym_color_set_definition] = sym_color_set_definition,
  [sym_color_reference] = sym_color_reference,
  [sym_tikz_library_import] = sym_tikz_library_import,
  [sym_text_mode] = sym_text_mode,
  [sym_hyperlink] = sym_hyperlink,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym__section_repeat1] = aux_sym__section_repeat1,
  [aux_sym__section_repeat2] = aux_sym__section_repeat2,
  [aux_sym__section_repeat3] = aux_sym__section_repeat3,
  [aux_sym__section_repeat4] = aux_sym__section_repeat4,
  [aux_sym__section_repeat5] = aux_sym__section_repeat5,
  [aux_sym__paragraph_repeat1] = aux_sym__paragraph_repeat1,
  [aux_sym__paragraph_repeat2] = aux_sym__paragraph_repeat2,
  [aux_sym__paragraph_repeat3] = aux_sym__paragraph_repeat3,
  [aux_sym_part_repeat1] = aux_sym_part_repeat1,
  [aux_sym_curly_group_text_list_repeat1] = aux_sym_curly_group_text_list_repeat1,
  [aux_sym_curly_group_path_list_repeat1] = aux_sym_curly_group_path_list_repeat1,
  [aux_sym_curly_group_key_value_repeat1] = aux_sym_curly_group_key_value_repeat1,
  [aux_sym_curly_group_impl_repeat1] = aux_sym_curly_group_impl_repeat1,
  [aux_sym_curly_group_author_list_repeat1] = aux_sym_curly_group_author_list_repeat1,
  [aux_sym_curly_group_author_list_repeat2] = aux_sym_curly_group_author_list_repeat2,
  [aux_sym_brack_group_repeat1] = aux_sym_brack_group_repeat1,
  [aux_sym_text_repeat1] = aux_sym_text_repeat1,
  [aux_sym_glob_pattern_repeat1] = aux_sym_glob_pattern_repeat1,
  [aux_sym_value_repeat1] = aux_sym_value_repeat1,
  [aux_sym_generic_command_repeat1] = aux_sym_generic_command_repeat1,
  [alias_sym_author] = alias_sym_author,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym__whitespace] = {
    .visible = false,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHiffalse] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHfi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHpart] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHpart_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHaddpart] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHaddpart_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHchapter] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHchapter_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHaddchap] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHaddchap_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsection_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHaddsec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHaddsec_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubsection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubsection_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubsubsection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubsubsection_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHparagraph] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHparagraph_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubparagraph] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubparagraph_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHitem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHitem_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHand] = {
    .visible = true,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [sym_placeholder] = {
    .visible = true,
    .named = true,
  },
  [sym_path] = {
    .visible = true,
    .named = true,
  },
  [sym_uri] = {
    .visible = true,
    .named = true,
  },
  [sym_argc] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__glob_pattern_fragment_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_letter] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHbegin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_verbatim] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_lstlisting] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_minted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_pycode] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_sagesilent] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_sageblock] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_math] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_displaymath] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_displaymath_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_equation] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_equation_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_multline] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_multline_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_eqnarray] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_eqnarray_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_align] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_align_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_array] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_array_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_split] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_split_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_alignat] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_alignat_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_gather] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_gather_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_flalign] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_flalign_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHtitle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHauthor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHusepackage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHRequirePackage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHdocumentclass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHinclude] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubfileinclude] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHinput] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubfile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHaddbibresource] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHbibliographystyle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHbibliography] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHincludegraphics] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHincludesvg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHincludeinkscape] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHverbatiminput] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHVerbatimInput] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHimport] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubimport] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHinputfrom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubimportfrom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHincludefrom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsubincludefrom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcaption] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcite_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHCite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnocite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitet] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitep] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitet_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitep_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteyearR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteauthor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteauthor_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHCiteauthor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHCiteauthor_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitetitle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitetitle_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteyear] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteyear_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitedate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitedate_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteurl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHfullcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHciteyearpar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitealt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitealp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcitetext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHparencite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHparencite_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHParencite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHfootcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHfootfullcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHfootcitetext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHtextcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHTextcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsmartcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHSmartcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsupercite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHautocite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAutocite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHautocite_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAutocite_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHVolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHpvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHPvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHfvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHftvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHsvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHSvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHtvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHTvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHavolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAvolcite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnotecite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHNotecite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHpnotecite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHPnotecite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHfnotecite] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHlabel] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHeqref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHvref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHVref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHautoref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHpageref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHCref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcref_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHCref_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnamecref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnameCref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHlcnamecref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnamecrefs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnameCrefs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHlcnamecrefs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHlabelcref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHlabelcpageref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcrefrange] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcrefrange_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHCrefrange] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHCrefrange_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnewlabel] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnewcommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnewcommand_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHrenewcommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHrenewcommand_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHDeclareRobustCommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHDeclareRobustCommand_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHDeclareMathOperator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHDeclareMathOperator_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHNewDocumentCommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHRenewDocumentCommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHProvideDocumentCommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHDeclareDocumentCommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHNewExpandableDocumentCommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHRenewExpandableDocumentCommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHProvideExpandableDocumentCommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHDeclareExpandableDocumentCommand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHdef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHlet] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHleft] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHbigl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHBigl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHbiggl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHBiggl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHright] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHbigr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHBigr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHbiggr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHBiggr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHDeclarePairedDelimiter] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHDeclarePairedDelimiterX] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnewenvironment] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHrenewenvironment] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHNewDocumentEnvironment] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHRenewDocumentEnvironment] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHProvideDocumentEnvironment] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHDeclareDocumentEnvironment] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnewglossaryentry] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHgls] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGls] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglspl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlspl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsdisp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglslink] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglstext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlstext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLStext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsfirst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsfirst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSfirst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsplural] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsplural] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSplural] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsfirstplural] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsfirstplural] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSfirstplural] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsname] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsname] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSname] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglssymbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlssymbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsdesc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsdesc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSdesc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsuseri] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsuseri] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSuseri] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsuserii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsuserii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSuserii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsuseriii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsuseriii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSuseriii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsuseriv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsuseriv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSuseriv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsuserv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsuserv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSuserv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsuservi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsuservi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGLSuservi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnewacronym] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacrshort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcrshort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHACRshort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacrshortpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcrshortpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHACRshortpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacrlong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcrlong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHACRlong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacrlongpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcrlongpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHACRlongpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacrfull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcrfull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHACRfull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacrfullpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcrfullpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHACRfullpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcs] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacsp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcsp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHaclp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAclp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacfp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAcfp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHAc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHacp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsentrylong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsentrylong] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsentrylongpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsentrylongpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsentryshort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsentryshort] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsentryshortpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsentryshortpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHglsentryfullpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHGlsentryfullpl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnewtheorem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHnewtheorem_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHdeclaretheorem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHdeclaretheorem_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHdefinecolor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHdefinecolorset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcolor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHcolorbox] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHtextcolor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHpagecolor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHusepgflibrary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHusetikzlibrary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHtext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHintertext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHshortintertext] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHurl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHhref] = {
    .visible = true,
    .named = false,
  },
  [sym__trivia_raw_fi] = {
    .visible = true,
    .named = true,
  },
  [sym__trivia_raw_env_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__trivia_raw_env_verbatim] = {
    .visible = true,
    .named = true,
  },
  [sym__trivia_raw_env_listing] = {
    .visible = true,
    .named = true,
  },
  [sym__trivia_raw_env_minted] = {
    .visible = true,
    .named = true,
  },
  [sym__trivia_raw_env_pycode] = {
    .visible = true,
    .named = true,
  },
  [sym__trivia_raw_env_sagesilent] = {
    .visible = true,
    .named = true,
  },
  [sym__trivia_raw_env_sageblock] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__root_content] = {
    .visible = false,
    .named = true,
  },
  [sym__flat_content] = {
    .visible = false,
    .named = true,
  },
  [sym__text_with_env_content] = {
    .visible = false,
    .named = true,
  },
  [sym__text_content] = {
    .visible = false,
    .named = true,
  },
  [sym__section] = {
    .visible = false,
    .named = true,
  },
  [sym__paragraph] = {
    .visible = false,
    .named = true,
  },
  [sym__section_part] = {
    .visible = false,
    .named = true,
  },
  [sym__part_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_part] = {
    .visible = true,
    .named = true,
  },
  [sym__chapter_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_chapter] = {
    .visible = true,
    .named = true,
  },
  [sym__section_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_section] = {
    .visible = true,
    .named = true,
  },
  [sym__subsection_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_subsection] = {
    .visible = true,
    .named = true,
  },
  [sym__subsubsection_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_subsubsection] = {
    .visible = true,
    .named = true,
  },
  [sym__paragraph_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_paragraph] = {
    .visible = true,
    .named = true,
  },
  [sym__subparagraph_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_subparagraph] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_itemdeclaration] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_item] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_text] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_text_list] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_path] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_path_list] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_uri] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_key_value] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_glob_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_impl] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_group_author_list] = {
    .visible = true,
    .named = true,
  },
  [sym_brack_group] = {
    .visible = true,
    .named = true,
  },
  [sym_brack_group_text] = {
    .visible = true,
    .named = true,
  },
  [sym_brack_group_argc] = {
    .visible = true,
    .named = true,
  },
  [sym_brack_group_key_value] = {
    .visible = true,
    .named = true,
  },
  [sym_text] = {
    .visible = true,
    .named = true,
  },
  [sym_glob_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__glob_pattern_fragment] = {
    .visible = false,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_superscript] = {
    .visible = true,
    .named = true,
  },
  [sym_key_value_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_value] = {
    .visible = true,
    .named = true,
  },
  [sym_displayed_equation] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_formula] = {
    .visible = true,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_end] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_environment] = {
    .visible = true,
    .named = true,
  },
  [sym_comment_environment] = {
    .visible = true,
    .named = true,
  },
  [sym__comment_environment_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__comment_environment_end] = {
    .visible = true,
    .named = true,
  },
  [sym__comment_environment_group] = {
    .visible = true,
    .named = true,
  },
  [sym__comment_environment_name] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_environment] = {
    .visible = true,
    .named = true,
  },
  [sym__verbatim_environment_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__verbatim_environment_end] = {
    .visible = true,
    .named = true,
  },
  [sym__verbatim_environment_group] = {
    .visible = true,
    .named = true,
  },
  [sym__verbatim_environment_name] = {
    .visible = true,
    .named = true,
  },
  [sym_listing_environment] = {
    .visible = true,
    .named = true,
  },
  [sym__listing_environment_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__listing_environment_end] = {
    .visible = true,
    .named = true,
  },
  [sym__listing_environment_group] = {
    .visible = true,
    .named = true,
  },
  [sym__listing_environment_name] = {
    .visible = true,
    .named = true,
  },
  [sym_minted_environment] = {
    .visible = true,
    .named = true,
  },
  [sym__minted_environment_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__minted_environment_end] = {
    .visible = true,
    .named = true,
  },
  [sym__minted_environment_group] = {
    .visible = true,
    .named = true,
  },
  [sym__minted_environment_name] = {
    .visible = true,
    .named = true,
  },
  [sym_pycode_environment] = {
    .visible = true,
    .named = true,
  },
  [sym__pycode_environment_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__pycode_environment_end] = {
    .visible = true,
    .named = true,
  },
  [sym__pycode_environment_group] = {
    .visible = true,
    .named = true,
  },
  [sym__pycode_environment_name] = {
    .visible = true,
    .named = true,
  },
  [sym_sagesilent_environment] = {
    .visible = true,
    .named = true,
  },
  [sym__sagesilent_environment_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__sagesilent_environment_end] = {
    .visible = true,
    .named = true,
  },
  [sym__sagesilent_environment_group] = {
    .visible = true,
    .named = true,
  },
  [sym__sagesilent_environment_name] = {
    .visible = true,
    .named = true,
  },
  [sym_sageblock_environment] = {
    .visible = true,
    .named = true,
  },
  [sym__sageblock_environment_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__sageblock_environment_end] = {
    .visible = true,
    .named = true,
  },
  [sym__sageblock_environment_group] = {
    .visible = true,
    .named = true,
  },
  [sym__sageblock_environment_name] = {
    .visible = true,
    .named = true,
  },
  [sym_math_environment] = {
    .visible = true,
    .named = true,
  },
  [sym__math_environment_begin] = {
    .visible = true,
    .named = true,
  },
  [sym__math_environment_end] = {
    .visible = true,
    .named = true,
  },
  [sym__math_environment_group] = {
    .visible = true,
    .named = true,
  },
  [sym__math_environment_name] = {
    .visible = true,
    .named = true,
  },
  [sym__command] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_command] = {
    .visible = true,
    .named = true,
  },
  [sym_title_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_author_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_package_include] = {
    .visible = true,
    .named = true,
  },
  [sym_class_include] = {
    .visible = true,
    .named = true,
  },
  [sym_latex_include] = {
    .visible = true,
    .named = true,
  },
  [sym_biblatex_include] = {
    .visible = true,
    .named = true,
  },
  [sym_bibstyle_include] = {
    .visible = true,
    .named = true,
  },
  [sym_bibtex_include] = {
    .visible = true,
    .named = true,
  },
  [sym_graphics_include] = {
    .visible = true,
    .named = true,
  },
  [sym_svg_include] = {
    .visible = true,
    .named = true,
  },
  [sym_inkscape_include] = {
    .visible = true,
    .named = true,
  },
  [sym_verbatim_include] = {
    .visible = true,
    .named = true,
  },
  [sym_import_include] = {
    .visible = true,
    .named = true,
  },
  [sym_caption] = {
    .visible = true,
    .named = true,
  },
  [sym_citation] = {
    .visible = true,
    .named = true,
  },
  [sym_label_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_label_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_label_reference_range] = {
    .visible = true,
    .named = true,
  },
  [sym_label_number] = {
    .visible = true,
    .named = true,
  },
  [sym_new_command_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_old_command_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_let_command_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__math_delimiter_part] = {
    .visible = false,
    .named = true,
  },
  [sym_math_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_paired_delimiter_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_environment_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_glossary_entry_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_glossary_entry_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_acronym_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_acronym_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_theorem_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_color_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_color_set_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_color_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_tikz_library_import] = {
    .visible = true,
    .named = true,
  },
  [sym_text_mode] = {
    .visible = true,
    .named = true,
  },
  [sym_hyperlink] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section_repeat4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__section_repeat5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__paragraph_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__paragraph_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__paragraph_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_part_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_curly_group_text_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_curly_group_path_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_curly_group_key_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_curly_group_impl_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_curly_group_author_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_curly_group_author_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_brack_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_text_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_glob_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_author] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_arg = 1,
  field_argc = 2,
  field_authors = 3,
  field_begin = 4,
  field_body = 5,
  field_code = 6,
  field_command = 7,
  field_comment = 8,
  field_content = 9,
  field_counter = 10,
  field_declaration = 11,
  field_default = 12,
  field_directory = 13,
  field_end = 14,
  field_file = 15,
  field_from = 16,
  field_glob = 17,
  field_head = 18,
  field_implementation = 19,
  field_key = 20,
  field_keys = 21,
  field_label = 22,
  field_language = 23,
  field_left = 24,
  field_left_command = 25,
  field_left_delimiter = 26,
  field_long = 27,
  field_model = 28,
  field_name = 29,
  field_names = 30,
  field_number = 31,
  field_options = 32,
  field_pair = 33,
  field_path = 34,
  field_paths = 35,
  field_pattern = 36,
  field_postnote = 37,
  field_prenote = 38,
  field_right = 39,
  field_right_command = 40,
  field_right_delimiter = 41,
  field_short = 42,
  field_spec = 43,
  field_subscript = 44,
  field_superscript = 45,
  field_tail = 46,
  field_text = 47,
  field_title = 48,
  field_to = 49,
  field_toc = 50,
  field_ty = 51,
  field_uri = 52,
  field_value = 53,
  field_verbatim = 54,
  field_word = 55,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_arg] = "arg",
  [field_argc] = "argc",
  [field_authors] = "authors",
  [field_begin] = "begin",
  [field_body] = "body",
  [field_code] = "code",
  [field_command] = "command",
  [field_comment] = "comment",
  [field_content] = "content",
  [field_counter] = "counter",
  [field_declaration] = "declaration",
  [field_default] = "default",
  [field_directory] = "directory",
  [field_end] = "end",
  [field_file] = "file",
  [field_from] = "from",
  [field_glob] = "glob",
  [field_head] = "head",
  [field_implementation] = "implementation",
  [field_key] = "key",
  [field_keys] = "keys",
  [field_label] = "label",
  [field_language] = "language",
  [field_left] = "left",
  [field_left_command] = "left_command",
  [field_left_delimiter] = "left_delimiter",
  [field_long] = "long",
  [field_model] = "model",
  [field_name] = "name",
  [field_names] = "names",
  [field_number] = "number",
  [field_options] = "options",
  [field_pair] = "pair",
  [field_path] = "path",
  [field_paths] = "paths",
  [field_pattern] = "pattern",
  [field_postnote] = "postnote",
  [field_prenote] = "prenote",
  [field_right] = "right",
  [field_right_command] = "right_command",
  [field_right_delimiter] = "right_delimiter",
  [field_short] = "short",
  [field_spec] = "spec",
  [field_subscript] = "subscript",
  [field_superscript] = "superscript",
  [field_tail] = "tail",
  [field_text] = "text",
  [field_title] = "title",
  [field_to] = "to",
  [field_toc] = "toc",
  [field_ty] = "ty",
  [field_uri] = "uri",
  [field_value] = "value",
  [field_verbatim] = "verbatim",
  [field_word] = "word",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 3},
  [5] = {.index = 6, .length = 2},
  [6] = {.index = 8, .length = 1},
  [7] = {.index = 9, .length = 2},
  [8] = {.index = 11, .length = 2},
  [9] = {.index = 13, .length = 3},
  [10] = {.index = 16, .length = 1},
  [11] = {.index = 17, .length = 2},
  [12] = {.index = 19, .length = 1},
  [13] = {.index = 20, .length = 1},
  [14] = {.index = 21, .length = 2},
  [15] = {.index = 23, .length = 3},
  [16] = {.index = 26, .length = 1},
  [17] = {.index = 27, .length = 2},
  [18] = {.index = 29, .length = 2},
  [19] = {.index = 31, .length = 2},
  [20] = {.index = 33, .length = 2},
  [21] = {.index = 35, .length = 2},
  [22] = {.index = 37, .length = 1},
  [23] = {.index = 38, .length = 2},
  [24] = {.index = 40, .length = 2},
  [25] = {.index = 42, .length = 2},
  [26] = {.index = 44, .length = 2},
  [27] = {.index = 46, .length = 2},
  [28] = {.index = 48, .length = 2},
  [29] = {.index = 50, .length = 6},
  [30] = {.index = 56, .length = 2},
  [31] = {.index = 58, .length = 3},
  [32] = {.index = 61, .length = 2},
  [33] = {.index = 63, .length = 3},
  [34] = {.index = 66, .length = 4},
  [35] = {.index = 70, .length = 2},
  [36] = {.index = 72, .length = 3},
  [37] = {.index = 75, .length = 3},
  [38] = {.index = 78, .length = 1},
  [39] = {.index = 79, .length = 3},
  [40] = {.index = 82, .length = 3},
  [41] = {.index = 85, .length = 2},
  [42] = {.index = 87, .length = 3},
  [43] = {.index = 90, .length = 3},
  [44] = {.index = 93, .length = 3},
  [45] = {.index = 96, .length = 3},
  [46] = {.index = 99, .length = 3},
  [47] = {.index = 102, .length = 3},
  [48] = {.index = 105, .length = 3},
  [49] = {.index = 108, .length = 3},
  [50] = {.index = 111, .length = 3},
  [51] = {.index = 114, .length = 2},
  [52] = {.index = 116, .length = 7},
  [53] = {.index = 123, .length = 7},
  [54] = {.index = 130, .length = 7},
  [55] = {.index = 137, .length = 9},
  [56] = {.index = 146, .length = 6},
  [57] = {.index = 152, .length = 1},
  [58] = {.index = 153, .length = 2},
  [59] = {.index = 155, .length = 5},
  [61] = {.index = 160, .length = 1},
  [62] = {.index = 161, .length = 1},
  [63] = {.index = 162, .length = 1},
  [64] = {.index = 163, .length = 4},
  [65] = {.index = 167, .length = 1},
  [66] = {.index = 168, .length = 4},
  [67] = {.index = 172, .length = 3},
  [68] = {.index = 175, .length = 4},
  [69] = {.index = 179, .length = 4},
  [70] = {.index = 183, .length = 4},
  [71] = {.index = 187, .length = 4},
  [72] = {.index = 191, .length = 4},
  [73] = {.index = 195, .length = 4},
  [74] = {.index = 199, .length = 4},
  [75] = {.index = 203, .length = 4},
  [76] = {.index = 207, .length = 1},
  [77] = {.index = 208, .length = 2},
  [78] = {.index = 210, .length = 2},
  [79] = {.index = 212, .length = 2},
  [80] = {.index = 214, .length = 2},
  [81] = {.index = 216, .length = 2},
  [82] = {.index = 218, .length = 2},
  [83] = {.index = 220, .length = 2},
  [84] = {.index = 222, .length = 1},
  [85] = {.index = 223, .length = 5},
  [86] = {.index = 228, .length = 4},
  [87] = {.index = 232, .length = 5},
  [88] = {.index = 237, .length = 5},
  [89] = {.index = 242, .length = 5},
  [90] = {.index = 247, .length = 5},
  [91] = {.index = 252, .length = 5},
  [92] = {.index = 257, .length = 5},
  [93] = {.index = 262, .length = 4},
  [94] = {.index = 266, .length = 5},
  [95] = {.index = 271, .length = 6},
  [96] = {.index = 277, .length = 6},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_begin, 0},
  [1] =
    {field_command, 0},
  [2] =
    {field_word, 0},
  [3] =
    {field_command, 0, .inherited = true},
    {field_text, 0, .inherited = true},
    {field_toc, 0, .inherited = true},
  [6] =
    {field_command, 0, .inherited = true},
    {field_label, 0, .inherited = true},
  [8] =
    {field_word, 0, .inherited = true},
  [9] =
    {field_begin, 0},
    {field_comment, 1},
  [11] =
    {field_begin, 0},
    {field_end, 1},
  [13] =
    {field_command, 0},
    {field_text, 1, .inherited = true},
    {field_toc, 1, .inherited = true},
  [16] =
    {field_text, 0},
  [17] =
    {field_command, 0},
    {field_label, 1},
  [19] =
    {field_subscript, 1},
  [20] =
    {field_superscript, 1},
  [21] =
    {field_command, 0},
    {field_name, 1},
  [23] =
    {field_command, 0},
    {field_name, 1},
    {field_text, 1, .inherited = true},
  [26] =
    {field_arg, 0},
  [27] =
    {field_arg, 1, .inherited = true},
    {field_command, 0},
  [29] =
    {field_command, 0},
    {field_text, 1},
  [31] =
    {field_authors, 1},
    {field_command, 0},
  [33] =
    {field_command, 0},
    {field_paths, 1},
  [35] =
    {field_command, 0},
    {field_path, 1},
  [37] =
    {field_glob, 1},
  [38] =
    {field_command, 0},
    {field_long, 1},
  [40] =
    {field_command, 0},
    {field_keys, 1},
  [42] =
    {field_command, 0},
    {field_names, 1},
  [44] =
    {field_command, 0},
    {field_declaration, 1},
  [46] =
    {field_command, 0},
    {field_content, 1},
  [48] =
    {field_command, 0},
    {field_uri, 1},
  [50] =
    {field_begin, 0},
    {field_command, 0, .inherited = true},
    {field_command, 1, .inherited = true},
    {field_end, 1},
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [56] =
    {field_word, 0, .inherited = true},
    {field_word, 1, .inherited = true},
  [58] =
    {field_begin, 0},
    {field_comment, 1},
    {field_end, 2},
  [61] =
    {field_text, 1},
    {field_toc, 0},
  [63] =
    {field_command, 0},
    {field_name, 1},
    {field_options, 2},
  [66] =
    {field_command, 0},
    {field_language, 2},
    {field_name, 1},
    {field_text, 1, .inherited = true},
  [70] =
    {field_arg, 0, .inherited = true},
    {field_arg, 1, .inherited = true},
  [72] =
    {field_command, 0},
    {field_options, 1},
    {field_text, 2},
  [75] =
    {field_authors, 2},
    {field_command, 0},
    {field_options, 1},
  [78] =
    {field_key, 0},
  [79] =
    {field_command, 0},
    {field_options, 1},
    {field_paths, 2},
  [82] =
    {field_command, 0},
    {field_options, 1},
    {field_path, 2},
  [85] =
    {field_glob, 2},
    {field_options, 1},
  [87] =
    {field_command, 0},
    {field_directory, 1},
    {field_file, 2},
  [90] =
    {field_command, 0},
    {field_long, 2},
    {field_short, 1},
  [93] =
    {field_command, 0},
    {field_keys, 2},
    {field_prenote, 1},
  [96] =
    {field_command, 0},
    {field_from, 1},
    {field_to, 2},
  [99] =
    {field_command, 0},
    {field_name, 1},
    {field_number, 2},
  [102] =
    {field_command, 0},
    {field_declaration, 1},
    {field_implementation, 2},
  [105] =
    {field_command, 0},
    {field_name, 2},
    {field_options, 1},
  [108] =
    {field_command, 0},
    {field_name, 1},
    {field_title, 2},
  [111] =
    {field_command, 0},
    {field_label, 2},
    {field_uri, 1},
  [114] =
    {field_begin, 0},
    {field_end, 2},
  [116] =
    {field_begin, 0},
    {field_command, 0, .inherited = true},
    {field_command, 2, .inherited = true},
    {field_comment, 1},
    {field_end, 2},
    {field_name, 0, .inherited = true},
    {field_name, 2, .inherited = true},
  [123] =
    {field_begin, 0},
    {field_command, 0, .inherited = true},
    {field_command, 2, .inherited = true},
    {field_end, 2},
    {field_name, 0, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_verbatim, 1},
  [130] =
    {field_begin, 0},
    {field_code, 1},
    {field_command, 0, .inherited = true},
    {field_command, 2, .inherited = true},
    {field_end, 2},
    {field_name, 0, .inherited = true},
    {field_name, 2, .inherited = true},
  [137] =
    {field_begin, 0},
    {field_code, 1},
    {field_command, 0, .inherited = true},
    {field_command, 2, .inherited = true},
    {field_end, 2},
    {field_language, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_options, 0, .inherited = true},
  [146] =
    {field_begin, 0},
    {field_command, 0, .inherited = true},
    {field_command, 2, .inherited = true},
    {field_end, 2},
    {field_name, 0, .inherited = true},
    {field_name, 2, .inherited = true},
  [152] =
    {field_text, 1},
  [153] =
    {field_text, 1},
    {field_word, 1, .inherited = true},
  [155] =
    {field_command, 0},
    {field_language, 3},
    {field_name, 1},
    {field_options, 2},
    {field_text, 1, .inherited = true},
  [160] =
    {field_pair, 1},
  [161] =
    {field_path, 1},
  [162] =
    {field_pattern, 1},
  [163] =
    {field_command, 0},
    {field_keys, 3},
    {field_postnote, 2},
    {field_prenote, 1},
  [167] =
    {field_command, 1},
  [168] =
    {field_argc, 2},
    {field_command, 0},
    {field_declaration, 1},
    {field_implementation, 3},
  [172] =
    {field_command, 0},
    {field_declaration, 1},
    {field_implementation, 3},
  [175] =
    {field_left_command, 0},
    {field_left_delimiter, 1},
    {field_right_command, 2},
    {field_right_delimiter, 3},
  [179] =
    {field_command, 0},
    {field_declaration, 1},
    {field_left, 2},
    {field_right, 3},
  [183] =
    {field_begin, 2},
    {field_command, 0},
    {field_end, 3},
    {field_name, 1},
  [187] =
    {field_command, 0},
    {field_long, 3},
    {field_name, 1},
    {field_short, 2},
  [191] =
    {field_command, 0},
    {field_counter, 3},
    {field_name, 1},
    {field_title, 2},
  [195] =
    {field_command, 0},
    {field_counter, 2},
    {field_name, 1},
    {field_title, 3},
  [199] =
    {field_command, 0},
    {field_name, 2},
    {field_options, 1},
    {field_title, 3},
  [203] =
    {field_command, 0},
    {field_model, 2},
    {field_name, 1},
    {field_spec, 3},
  [207] =
    {field_uri, 1},
  [208] =
    {field_key, 0},
    {field_value, 2},
  [210] =
    {field_pair, 1},
    {field_pair, 2, .inherited = true},
  [212] =
    {field_pair, 0, .inherited = true},
    {field_pair, 1, .inherited = true},
  [214] =
    {field_path, 1},
    {field_path, 2, .inherited = true},
  [216] =
    {field_path, 0, .inherited = true},
    {field_path, 1, .inherited = true},
  [218] =
    {field_text, 1},
    {field_text, 2, .inherited = true},
  [220] =
    {field_text, 0, .inherited = true},
    {field_text, 1, .inherited = true},
  [222] =
    {field_value, 1},
  [223] =
    {field_argc, 2},
    {field_command, 0},
    {field_declaration, 1},
    {field_default, 3},
    {field_implementation, 4},
  [228] =
    {field_left_command, 0},
    {field_left_delimiter, 1},
    {field_right_command, 3},
    {field_right_delimiter, 4},
  [232] =
    {field_body, 4},
    {field_command, 0},
    {field_declaration, 1},
    {field_left, 2},
    {field_right, 3},
  [237] =
    {field_argc, 2},
    {field_command, 0},
    {field_declaration, 1},
    {field_left, 3},
    {field_right, 4},
  [242] =
    {field_argc, 2},
    {field_begin, 3},
    {field_command, 0},
    {field_end, 4},
    {field_name, 1},
  [247] =
    {field_command, 0},
    {field_long, 4},
    {field_name, 2},
    {field_options, 1},
    {field_short, 3},
  [252] =
    {field_command, 0},
    {field_counter, 4},
    {field_name, 2},
    {field_options, 1},
    {field_title, 3},
  [257] =
    {field_command, 0},
    {field_counter, 3},
    {field_name, 2},
    {field_options, 1},
    {field_title, 4},
  [262] =
    {field_command, 0},
    {field_model, 3},
    {field_name, 2},
    {field_spec, 4},
  [266] =
    {field_command, 0},
    {field_head, 2},
    {field_model, 1},
    {field_spec, 4},
    {field_tail, 3},
  [271] =
    {field_argc, 2},
    {field_body, 5},
    {field_command, 0},
    {field_declaration, 1},
    {field_left, 3},
    {field_right, 4},
  [277] =
    {field_command, 0},
    {field_head, 3},
    {field_model, 2},
    {field_spec, 5},
    {field_tail, 4},
    {field_ty, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [60] = {
    [1] = alias_sym_author,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym_curly_group_author_list_repeat1, 2,
    aux_sym_curly_group_author_list_repeat1,
    alias_sym_author,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 7,
  [9] = 6,
  [10] = 6,
  [11] = 6,
  [12] = 7,
  [13] = 6,
  [14] = 7,
  [15] = 6,
  [16] = 7,
  [17] = 7,
  [18] = 7,
  [19] = 19,
  [20] = 6,
  [21] = 7,
  [22] = 6,
  [23] = 7,
  [24] = 6,
  [25] = 5,
  [26] = 5,
  [27] = 4,
  [28] = 2,
  [29] = 3,
  [30] = 4,
  [31] = 2,
  [32] = 3,
  [33] = 3,
  [34] = 5,
  [35] = 2,
  [36] = 3,
  [37] = 5,
  [38] = 38,
  [39] = 3,
  [40] = 4,
  [41] = 5,
  [42] = 3,
  [43] = 2,
  [44] = 5,
  [45] = 45,
  [46] = 38,
  [47] = 2,
  [48] = 4,
  [49] = 4,
  [50] = 2,
  [51] = 45,
  [52] = 3,
  [53] = 45,
  [54] = 2,
  [55] = 45,
  [56] = 4,
  [57] = 38,
  [58] = 38,
  [59] = 45,
  [60] = 38,
  [61] = 45,
  [62] = 45,
  [63] = 38,
  [64] = 19,
  [65] = 38,
  [66] = 4,
  [67] = 5,
  [68] = 68,
  [69] = 5,
  [70] = 70,
  [71] = 68,
  [72] = 72,
  [73] = 19,
  [74] = 74,
  [75] = 5,
  [76] = 70,
  [77] = 77,
  [78] = 78,
  [79] = 77,
  [80] = 80,
  [81] = 80,
  [82] = 5,
  [83] = 70,
  [84] = 77,
  [85] = 3,
  [86] = 68,
  [87] = 2,
  [88] = 4,
  [89] = 78,
  [90] = 78,
  [91] = 72,
  [92] = 2,
  [93] = 80,
  [94] = 72,
  [95] = 3,
  [96] = 72,
  [97] = 68,
  [98] = 70,
  [99] = 78,
  [100] = 78,
  [101] = 77,
  [102] = 77,
  [103] = 70,
  [104] = 77,
  [105] = 80,
  [106] = 80,
  [107] = 80,
  [108] = 80,
  [109] = 78,
  [110] = 77,
  [111] = 80,
  [112] = 77,
  [113] = 78,
  [114] = 70,
  [115] = 68,
  [116] = 72,
  [117] = 72,
  [118] = 68,
  [119] = 70,
  [120] = 77,
  [121] = 80,
  [122] = 4,
  [123] = 68,
  [124] = 2,
  [125] = 19,
  [126] = 70,
  [127] = 4,
  [128] = 68,
  [129] = 78,
  [130] = 80,
  [131] = 77,
  [132] = 19,
  [133] = 78,
  [134] = 72,
  [135] = 70,
  [136] = 68,
  [137] = 72,
  [138] = 72,
  [139] = 68,
  [140] = 70,
  [141] = 68,
  [142] = 72,
  [143] = 80,
  [144] = 77,
  [145] = 78,
  [146] = 3,
  [147] = 70,
  [148] = 148,
  [149] = 149,
  [150] = 148,
  [151] = 151,
  [152] = 152,
  [153] = 149,
  [154] = 148,
  [155] = 148,
  [156] = 149,
  [157] = 149,
  [158] = 148,
  [159] = 149,
  [160] = 152,
  [161] = 151,
  [162] = 162,
  [163] = 163,
  [164] = 151,
  [165] = 152,
  [166] = 151,
  [167] = 152,
  [168] = 151,
  [169] = 152,
  [170] = 162,
  [171] = 163,
  [172] = 172,
  [173] = 173,
  [174] = 162,
  [175] = 163,
  [176] = 162,
  [177] = 163,
  [178] = 162,
  [179] = 163,
  [180] = 180,
  [181] = 172,
  [182] = 173,
  [183] = 183,
  [184] = 172,
  [185] = 172,
  [186] = 173,
  [187] = 173,
  [188] = 172,
  [189] = 173,
  [190] = 180,
  [191] = 183,
  [192] = 192,
  [193] = 193,
  [194] = 180,
  [195] = 183,
  [196] = 183,
  [197] = 183,
  [198] = 180,
  [199] = 180,
  [200] = 192,
  [201] = 201,
  [202] = 193,
  [203] = 203,
  [204] = 193,
  [205] = 193,
  [206] = 193,
  [207] = 192,
  [208] = 192,
  [209] = 192,
  [210] = 210,
  [211] = 211,
  [212] = 203,
  [213] = 213,
  [214] = 201,
  [215] = 203,
  [216] = 201,
  [217] = 201,
  [218] = 203,
  [219] = 203,
  [220] = 201,
  [221] = 211,
  [222] = 213,
  [223] = 210,
  [224] = 213,
  [225] = 213,
  [226] = 213,
  [227] = 210,
  [228] = 211,
  [229] = 210,
  [230] = 210,
  [231] = 211,
  [232] = 211,
  [233] = 233,
  [234] = 234,
  [235] = 234,
  [236] = 233,
  [237] = 233,
  [238] = 233,
  [239] = 234,
  [240] = 234,
  [241] = 234,
  [242] = 233,
  [243] = 233,
  [244] = 234,
  [245] = 233,
  [246] = 234,
  [247] = 211,
  [248] = 248,
  [249] = 249,
  [250] = 248,
  [251] = 251,
  [252] = 251,
  [253] = 248,
  [254] = 251,
  [255] = 255,
  [256] = 256,
  [257] = 256,
  [258] = 255,
  [259] = 255,
  [260] = 255,
  [261] = 256,
  [262] = 256,
  [263] = 255,
  [264] = 256,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 267,
  [269] = 266,
  [270] = 267,
  [271] = 266,
  [272] = 266,
  [273] = 267,
  [274] = 274,
  [275] = 267,
  [276] = 266,
  [277] = 267,
  [278] = 267,
  [279] = 267,
  [280] = 266,
  [281] = 266,
  [282] = 267,
  [283] = 266,
  [284] = 267,
  [285] = 266,
  [286] = 266,
  [287] = 266,
  [288] = 267,
  [289] = 289,
  [290] = 289,
  [291] = 291,
  [292] = 291,
  [293] = 293,
  [294] = 294,
  [295] = 293,
  [296] = 294,
  [297] = 293,
  [298] = 293,
  [299] = 293,
  [300] = 293,
  [301] = 293,
  [302] = 293,
  [303] = 293,
  [304] = 293,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 307,
  [309] = 307,
  [310] = 307,
  [311] = 307,
  [312] = 307,
  [313] = 307,
  [314] = 307,
  [315] = 307,
  [316] = 307,
  [317] = 317,
  [318] = 255,
  [319] = 256,
  [320] = 256,
  [321] = 255,
  [322] = 256,
  [323] = 255,
  [324] = 324,
  [325] = 325,
  [326] = 256,
  [327] = 255,
  [328] = 325,
  [329] = 329,
  [330] = 324,
  [331] = 331,
  [332] = 324,
  [333] = 325,
  [334] = 325,
  [335] = 325,
  [336] = 324,
  [337] = 324,
  [338] = 338,
  [339] = 331,
  [340] = 340,
  [341] = 329,
  [342] = 331,
  [343] = 329,
  [344] = 331,
  [345] = 331,
  [346] = 329,
  [347] = 329,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 338,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 340,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 338,
  [422] = 340,
  [423] = 340,
  [424] = 424,
  [425] = 338,
  [426] = 426,
  [427] = 427,
  [428] = 340,
  [429] = 338,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 407,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 387,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 416,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 404,
  [462] = 462,
  [463] = 463,
  [464] = 403,
  [465] = 394,
  [466] = 466,
  [467] = 385,
  [468] = 390,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 349,
  [474] = 395,
  [475] = 396,
  [476] = 397,
  [477] = 398,
  [478] = 478,
  [479] = 384,
  [480] = 399,
  [481] = 400,
  [482] = 401,
  [483] = 402,
  [484] = 354,
  [485] = 485,
  [486] = 362,
  [487] = 487,
  [488] = 365,
  [489] = 489,
  [490] = 367,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 393,
  [495] = 383,
  [496] = 382,
  [497] = 381,
  [498] = 380,
  [499] = 379,
  [500] = 378,
  [501] = 377,
  [502] = 376,
  [503] = 503,
  [504] = 350,
  [505] = 352,
  [506] = 506,
  [507] = 353,
  [508] = 508,
  [509] = 355,
  [510] = 356,
  [511] = 375,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 415,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 389,
  [525] = 525,
  [526] = 357,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 391,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 405,
  [556] = 556,
  [557] = 358,
  [558] = 359,
  [559] = 360,
  [560] = 361,
  [561] = 363,
  [562] = 364,
  [563] = 366,
  [564] = 420,
  [565] = 565,
  [566] = 417,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 388,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 392,
  [582] = 582,
  [583] = 583,
  [584] = 368,
  [585] = 369,
  [586] = 406,
  [587] = 418,
  [588] = 412,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 419,
  [594] = 594,
  [595] = 595,
  [596] = 374,
  [597] = 414,
  [598] = 598,
  [599] = 599,
  [600] = 373,
  [601] = 601,
  [602] = 602,
  [603] = 413,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 372,
  [632] = 371,
  [633] = 370,
  [634] = 348,
  [635] = 635,
  [636] = 411,
  [637] = 410,
  [638] = 409,
  [639] = 408,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 398,
  [645] = 352,
  [646] = 370,
  [647] = 348,
  [648] = 371,
  [649] = 372,
  [650] = 373,
  [651] = 374,
  [652] = 412,
  [653] = 373,
  [654] = 411,
  [655] = 410,
  [656] = 409,
  [657] = 408,
  [658] = 349,
  [659] = 407,
  [660] = 406,
  [661] = 400,
  [662] = 401,
  [663] = 402,
  [664] = 406,
  [665] = 407,
  [666] = 408,
  [667] = 375,
  [668] = 376,
  [669] = 377,
  [670] = 378,
  [671] = 409,
  [672] = 379,
  [673] = 380,
  [674] = 381,
  [675] = 382,
  [676] = 410,
  [677] = 383,
  [678] = 384,
  [679] = 385,
  [680] = 411,
  [681] = 387,
  [682] = 388,
  [683] = 389,
  [684] = 392,
  [685] = 349,
  [686] = 395,
  [687] = 396,
  [688] = 397,
  [689] = 394,
  [690] = 399,
  [691] = 400,
  [692] = 401,
  [693] = 402,
  [694] = 412,
  [695] = 413,
  [696] = 414,
  [697] = 415,
  [698] = 374,
  [699] = 406,
  [700] = 407,
  [701] = 408,
  [702] = 409,
  [703] = 410,
  [704] = 411,
  [705] = 412,
  [706] = 413,
  [707] = 414,
  [708] = 415,
  [709] = 364,
  [710] = 368,
  [711] = 413,
  [712] = 372,
  [713] = 414,
  [714] = 371,
  [715] = 415,
  [716] = 348,
  [717] = 366,
  [718] = 370,
  [719] = 399,
  [720] = 369,
  [721] = 360,
  [722] = 363,
  [723] = 398,
  [724] = 368,
  [725] = 427,
  [726] = 397,
  [727] = 396,
  [728] = 366,
  [729] = 361,
  [730] = 403,
  [731] = 364,
  [732] = 395,
  [733] = 363,
  [734] = 402,
  [735] = 354,
  [736] = 362,
  [737] = 365,
  [738] = 367,
  [739] = 391,
  [740] = 405,
  [741] = 420,
  [742] = 401,
  [743] = 359,
  [744] = 358,
  [745] = 400,
  [746] = 357,
  [747] = 356,
  [748] = 355,
  [749] = 349,
  [750] = 399,
  [751] = 392,
  [752] = 353,
  [753] = 369,
  [754] = 419,
  [755] = 418,
  [756] = 417,
  [757] = 416,
  [758] = 404,
  [759] = 403,
  [760] = 394,
  [761] = 390,
  [762] = 350,
  [763] = 398,
  [764] = 393,
  [765] = 389,
  [766] = 388,
  [767] = 432,
  [768] = 387,
  [769] = 426,
  [770] = 390,
  [771] = 385,
  [772] = 384,
  [773] = 424,
  [774] = 393,
  [775] = 383,
  [776] = 382,
  [777] = 390,
  [778] = 394,
  [779] = 403,
  [780] = 404,
  [781] = 350,
  [782] = 397,
  [783] = 352,
  [784] = 416,
  [785] = 417,
  [786] = 418,
  [787] = 419,
  [788] = 381,
  [789] = 353,
  [790] = 380,
  [791] = 420,
  [792] = 361,
  [793] = 405,
  [794] = 391,
  [795] = 355,
  [796] = 396,
  [797] = 395,
  [798] = 356,
  [799] = 357,
  [800] = 367,
  [801] = 358,
  [802] = 365,
  [803] = 431,
  [804] = 393,
  [805] = 350,
  [806] = 352,
  [807] = 353,
  [808] = 355,
  [809] = 356,
  [810] = 357,
  [811] = 359,
  [812] = 358,
  [813] = 359,
  [814] = 360,
  [815] = 361,
  [816] = 363,
  [817] = 364,
  [818] = 366,
  [819] = 362,
  [820] = 354,
  [821] = 368,
  [822] = 369,
  [823] = 370,
  [824] = 348,
  [825] = 371,
  [826] = 372,
  [827] = 373,
  [828] = 374,
  [829] = 379,
  [830] = 378,
  [831] = 360,
  [832] = 377,
  [833] = 376,
  [834] = 354,
  [835] = 362,
  [836] = 365,
  [837] = 367,
  [838] = 391,
  [839] = 405,
  [840] = 430,
  [841] = 420,
  [842] = 375,
  [843] = 419,
  [844] = 418,
  [845] = 417,
  [846] = 416,
  [847] = 404,
  [848] = 375,
  [849] = 376,
  [850] = 377,
  [851] = 378,
  [852] = 379,
  [853] = 380,
  [854] = 381,
  [855] = 382,
  [856] = 383,
  [857] = 384,
  [858] = 385,
  [859] = 387,
  [860] = 388,
  [861] = 389,
  [862] = 392,
  [863] = 439,
  [864] = 255,
  [865] = 431,
  [866] = 431,
  [867] = 433,
  [868] = 430,
  [869] = 434,
  [870] = 435,
  [871] = 432,
  [872] = 436,
  [873] = 437,
  [874] = 427,
  [875] = 424,
  [876] = 424,
  [877] = 426,
  [878] = 426,
  [879] = 427,
  [880] = 430,
  [881] = 431,
  [882] = 426,
  [883] = 438,
  [884] = 432,
  [885] = 430,
  [886] = 256,
  [887] = 432,
  [888] = 424,
  [889] = 427,
  [890] = 463,
  [891] = 453,
  [892] = 539,
  [893] = 540,
  [894] = 532,
  [895] = 619,
  [896] = 548,
  [897] = 897,
  [898] = 533,
  [899] = 621,
  [900] = 541,
  [901] = 535,
  [902] = 902,
  [903] = 549,
  [904] = 902,
  [905] = 433,
  [906] = 527,
  [907] = 618,
  [908] = 437,
  [909] = 485,
  [910] = 590,
  [911] = 606,
  [912] = 589,
  [913] = 436,
  [914] = 487,
  [915] = 435,
  [916] = 434,
  [917] = 582,
  [918] = 583,
  [919] = 623,
  [920] = 471,
  [921] = 470,
  [922] = 469,
  [923] = 451,
  [924] = 450,
  [925] = 489,
  [926] = 523,
  [927] = 503,
  [928] = 529,
  [929] = 620,
  [930] = 517,
  [931] = 607,
  [932] = 436,
  [933] = 608,
  [934] = 609,
  [935] = 610,
  [936] = 611,
  [937] = 491,
  [938] = 614,
  [939] = 612,
  [940] = 902,
  [941] = 434,
  [942] = 439,
  [943] = 435,
  [944] = 434,
  [945] = 902,
  [946] = 435,
  [947] = 616,
  [948] = 519,
  [949] = 518,
  [950] = 433,
  [951] = 516,
  [952] = 515,
  [953] = 514,
  [954] = 513,
  [955] = 493,
  [956] = 492,
  [957] = 478,
  [958] = 472,
  [959] = 466,
  [960] = 550,
  [961] = 462,
  [962] = 460,
  [963] = 459,
  [964] = 902,
  [965] = 458,
  [966] = 456,
  [967] = 902,
  [968] = 438,
  [969] = 536,
  [970] = 449,
  [971] = 454,
  [972] = 436,
  [973] = 973,
  [974] = 447,
  [975] = 448,
  [976] = 437,
  [977] = 546,
  [978] = 572,
  [979] = 445,
  [980] = 545,
  [981] = 506,
  [982] = 508,
  [983] = 544,
  [984] = 512,
  [985] = 521,
  [986] = 522,
  [987] = 528,
  [988] = 530,
  [989] = 531,
  [990] = 554,
  [991] = 433,
  [992] = 556,
  [993] = 553,
  [994] = 439,
  [995] = 443,
  [996] = 594,
  [997] = 547,
  [998] = 538,
  [999] = 565,
  [1000] = 604,
  [1001] = 568,
  [1002] = 569,
  [1003] = 570,
  [1004] = 571,
  [1005] = 455,
  [1006] = 627,
  [1007] = 595,
  [1008] = 602,
  [1009] = 605,
  [1010] = 613,
  [1011] = 615,
  [1012] = 437,
  [1013] = 439,
  [1014] = 543,
  [1015] = 617,
  [1016] = 573,
  [1017] = 902,
  [1018] = 574,
  [1019] = 542,
  [1020] = 577,
  [1021] = 578,
  [1022] = 579,
  [1023] = 580,
  [1024] = 598,
  [1025] = 534,
  [1026] = 902,
  [1027] = 902,
  [1028] = 440,
  [1029] = 599,
  [1030] = 601,
  [1031] = 438,
  [1032] = 592,
  [1033] = 537,
  [1034] = 591,
  [1035] = 567,
  [1036] = 552,
  [1037] = 525,
  [1038] = 902,
  [1039] = 438,
  [1040] = 442,
  [1041] = 444,
  [1042] = 446,
  [1043] = 622,
  [1044] = 575,
  [1045] = 624,
  [1046] = 625,
  [1047] = 626,
  [1048] = 628,
  [1049] = 629,
  [1050] = 630,
  [1051] = 635,
  [1052] = 640,
  [1053] = 641,
  [1054] = 642,
  [1055] = 643,
  [1056] = 462,
  [1057] = 582,
  [1058] = 540,
  [1059] = 539,
  [1060] = 538,
  [1061] = 537,
  [1062] = 536,
  [1063] = 535,
  [1064] = 534,
  [1065] = 533,
  [1066] = 532,
  [1067] = 544,
  [1068] = 529,
  [1069] = 527,
  [1070] = 618,
  [1071] = 543,
  [1072] = 542,
  [1073] = 595,
  [1074] = 485,
  [1075] = 545,
  [1076] = 546,
  [1077] = 547,
  [1078] = 548,
  [1079] = 549,
  [1080] = 550,
  [1081] = 553,
  [1082] = 590,
  [1083] = 589,
  [1084] = 619,
  [1085] = 621,
  [1086] = 582,
  [1087] = 583,
  [1088] = 623,
  [1089] = 471,
  [1090] = 470,
  [1091] = 469,
  [1092] = 451,
  [1093] = 450,
  [1094] = 523,
  [1095] = 503,
  [1096] = 616,
  [1097] = 449,
  [1098] = 614,
  [1099] = 447,
  [1100] = 612,
  [1101] = 445,
  [1102] = 519,
  [1103] = 518,
  [1104] = 517,
  [1105] = 516,
  [1106] = 515,
  [1107] = 514,
  [1108] = 513,
  [1109] = 493,
  [1110] = 492,
  [1111] = 478,
  [1112] = 472,
  [1113] = 466,
  [1114] = 463,
  [1115] = 462,
  [1116] = 460,
  [1117] = 459,
  [1118] = 458,
  [1119] = 456,
  [1120] = 455,
  [1121] = 454,
  [1122] = 453,
  [1123] = 443,
  [1124] = 594,
  [1125] = 448,
  [1126] = 599,
  [1127] = 601,
  [1128] = 506,
  [1129] = 508,
  [1130] = 512,
  [1131] = 521,
  [1132] = 522,
  [1133] = 528,
  [1134] = 530,
  [1135] = 531,
  [1136] = 554,
  [1137] = 556,
  [1138] = 565,
  [1139] = 487,
  [1140] = 604,
  [1141] = 568,
  [1142] = 569,
  [1143] = 570,
  [1144] = 571,
  [1145] = 627,
  [1146] = 640,
  [1147] = 602,
  [1148] = 605,
  [1149] = 613,
  [1150] = 615,
  [1151] = 572,
  [1152] = 617,
  [1153] = 573,
  [1154] = 574,
  [1155] = 643,
  [1156] = 642,
  [1157] = 641,
  [1158] = 640,
  [1159] = 635,
  [1160] = 630,
  [1161] = 629,
  [1162] = 628,
  [1163] = 626,
  [1164] = 625,
  [1165] = 624,
  [1166] = 575,
  [1167] = 491,
  [1168] = 611,
  [1169] = 610,
  [1170] = 609,
  [1171] = 622,
  [1172] = 608,
  [1173] = 607,
  [1174] = 606,
  [1175] = 620,
  [1176] = 446,
  [1177] = 444,
  [1178] = 442,
  [1179] = 525,
  [1180] = 552,
  [1181] = 567,
  [1182] = 591,
  [1183] = 592,
  [1184] = 440,
  [1185] = 489,
  [1186] = 577,
  [1187] = 598,
  [1188] = 580,
  [1189] = 579,
  [1190] = 578,
  [1191] = 577,
  [1192] = 578,
  [1193] = 574,
  [1194] = 573,
  [1195] = 579,
  [1196] = 580,
  [1197] = 598,
  [1198] = 489,
  [1199] = 440,
  [1200] = 592,
  [1201] = 591,
  [1202] = 567,
  [1203] = 552,
  [1204] = 525,
  [1205] = 617,
  [1206] = 615,
  [1207] = 613,
  [1208] = 605,
  [1209] = 602,
  [1210] = 595,
  [1211] = 627,
  [1212] = 571,
  [1213] = 570,
  [1214] = 569,
  [1215] = 568,
  [1216] = 604,
  [1217] = 487,
  [1218] = 565,
  [1219] = 442,
  [1220] = 556,
  [1221] = 554,
  [1222] = 531,
  [1223] = 530,
  [1224] = 528,
  [1225] = 522,
  [1226] = 521,
  [1227] = 512,
  [1228] = 508,
  [1229] = 506,
  [1230] = 577,
  [1231] = 444,
  [1232] = 446,
  [1233] = 620,
  [1234] = 606,
  [1235] = 607,
  [1236] = 608,
  [1237] = 622,
  [1238] = 609,
  [1239] = 612,
  [1240] = 519,
  [1241] = 574,
  [1242] = 610,
  [1243] = 611,
  [1244] = 491,
  [1245] = 575,
  [1246] = 518,
  [1247] = 624,
  [1248] = 625,
  [1249] = 626,
  [1250] = 628,
  [1251] = 629,
  [1252] = 630,
  [1253] = 635,
  [1254] = 472,
  [1255] = 641,
  [1256] = 642,
  [1257] = 643,
  [1258] = 572,
  [1259] = 451,
  [1260] = 469,
  [1261] = 448,
  [1262] = 453,
  [1263] = 454,
  [1264] = 455,
  [1265] = 456,
  [1266] = 458,
  [1267] = 459,
  [1268] = 460,
  [1269] = 463,
  [1270] = 470,
  [1271] = 471,
  [1272] = 623,
  [1273] = 466,
  [1274] = 447,
  [1275] = 550,
  [1276] = 449,
  [1277] = 440,
  [1278] = 573,
  [1279] = 583,
  [1280] = 619,
  [1281] = 517,
  [1282] = 553,
  [1283] = 550,
  [1284] = 549,
  [1285] = 548,
  [1286] = 547,
  [1287] = 546,
  [1288] = 545,
  [1289] = 544,
  [1290] = 543,
  [1291] = 542,
  [1292] = 541,
  [1293] = 540,
  [1294] = 539,
  [1295] = 516,
  [1296] = 538,
  [1297] = 537,
  [1298] = 1298,
  [1299] = 536,
  [1300] = 535,
  [1301] = 534,
  [1302] = 533,
  [1303] = 478,
  [1304] = 492,
  [1305] = 493,
  [1306] = 513,
  [1307] = 514,
  [1308] = 515,
  [1309] = 516,
  [1310] = 517,
  [1311] = 518,
  [1312] = 519,
  [1313] = 612,
  [1314] = 614,
  [1315] = 616,
  [1316] = 503,
  [1317] = 532,
  [1318] = 523,
  [1319] = 589,
  [1320] = 590,
  [1321] = 485,
  [1322] = 618,
  [1323] = 527,
  [1324] = 529,
  [1325] = 532,
  [1326] = 533,
  [1327] = 534,
  [1328] = 535,
  [1329] = 529,
  [1330] = 515,
  [1331] = 536,
  [1332] = 537,
  [1333] = 538,
  [1334] = 539,
  [1335] = 540,
  [1336] = 541,
  [1337] = 542,
  [1338] = 543,
  [1339] = 544,
  [1340] = 545,
  [1341] = 514,
  [1342] = 546,
  [1343] = 513,
  [1344] = 547,
  [1345] = 493,
  [1346] = 548,
  [1347] = 492,
  [1348] = 1298,
  [1349] = 478,
  [1350] = 527,
  [1351] = 618,
  [1352] = 485,
  [1353] = 590,
  [1354] = 589,
  [1355] = 523,
  [1356] = 450,
  [1357] = 1357,
  [1358] = 503,
  [1359] = 616,
  [1360] = 445,
  [1361] = 443,
  [1362] = 594,
  [1363] = 599,
  [1364] = 601,
  [1365] = 491,
  [1366] = 579,
  [1367] = 1367,
  [1368] = 472,
  [1369] = 466,
  [1370] = 463,
  [1371] = 1298,
  [1372] = 462,
  [1373] = 549,
  [1374] = 556,
  [1375] = 553,
  [1376] = 619,
  [1377] = 621,
  [1378] = 582,
  [1379] = 583,
  [1380] = 623,
  [1381] = 471,
  [1382] = 470,
  [1383] = 469,
  [1384] = 451,
  [1385] = 450,
  [1386] = 449,
  [1387] = 447,
  [1388] = 445,
  [1389] = 443,
  [1390] = 594,
  [1391] = 599,
  [1392] = 601,
  [1393] = 506,
  [1394] = 508,
  [1395] = 512,
  [1396] = 521,
  [1397] = 522,
  [1398] = 528,
  [1399] = 530,
  [1400] = 531,
  [1401] = 554,
  [1402] = 460,
  [1403] = 459,
  [1404] = 621,
  [1405] = 456,
  [1406] = 455,
  [1407] = 454,
  [1408] = 453,
  [1409] = 448,
  [1410] = 572,
  [1411] = 458,
  [1412] = 642,
  [1413] = 578,
  [1414] = 1298,
  [1415] = 611,
  [1416] = 610,
  [1417] = 609,
  [1418] = 641,
  [1419] = 608,
  [1420] = 607,
  [1421] = 606,
  [1422] = 620,
  [1423] = 640,
  [1424] = 635,
  [1425] = 630,
  [1426] = 629,
  [1427] = 628,
  [1428] = 626,
  [1429] = 625,
  [1430] = 624,
  [1431] = 1431,
  [1432] = 489,
  [1433] = 575,
  [1434] = 622,
  [1435] = 446,
  [1436] = 444,
  [1437] = 442,
  [1438] = 525,
  [1439] = 552,
  [1440] = 567,
  [1441] = 591,
  [1442] = 565,
  [1443] = 604,
  [1444] = 568,
  [1445] = 569,
  [1446] = 570,
  [1447] = 571,
  [1448] = 627,
  [1449] = 595,
  [1450] = 602,
  [1451] = 605,
  [1452] = 592,
  [1453] = 643,
  [1454] = 1367,
  [1455] = 617,
  [1456] = 1298,
  [1457] = 615,
  [1458] = 1298,
  [1459] = 1459,
  [1460] = 580,
  [1461] = 598,
  [1462] = 613,
  [1463] = 1298,
  [1464] = 487,
  [1465] = 1298,
  [1466] = 614,
  [1467] = 1298,
  [1468] = 541,
  [1469] = 1298,
  [1470] = 1470,
  [1471] = 1470,
  [1472] = 1472,
  [1473] = 1470,
  [1474] = 1472,
  [1475] = 1470,
  [1476] = 1472,
  [1477] = 1470,
  [1478] = 1472,
  [1479] = 1470,
  [1480] = 1472,
  [1481] = 1470,
  [1482] = 1470,
  [1483] = 1472,
  [1484] = 1472,
  [1485] = 1472,
  [1486] = 1470,
  [1487] = 1472,
  [1488] = 1470,
  [1489] = 1470,
  [1490] = 1472,
  [1491] = 1491,
  [1492] = 432,
  [1493] = 424,
  [1494] = 431,
  [1495] = 430,
  [1496] = 427,
  [1497] = 426,
  [1498] = 436,
  [1499] = 438,
  [1500] = 432,
  [1501] = 424,
  [1502] = 426,
  [1503] = 427,
  [1504] = 430,
  [1505] = 437,
  [1506] = 431,
  [1507] = 435,
  [1508] = 434,
  [1509] = 424,
  [1510] = 432,
  [1511] = 431,
  [1512] = 430,
  [1513] = 427,
  [1514] = 439,
  [1515] = 426,
  [1516] = 453,
  [1517] = 434,
  [1518] = 546,
  [1519] = 545,
  [1520] = 544,
  [1521] = 543,
  [1522] = 542,
  [1523] = 541,
  [1524] = 540,
  [1525] = 539,
  [1526] = 538,
  [1527] = 537,
  [1528] = 536,
  [1529] = 535,
  [1530] = 534,
  [1531] = 533,
  [1532] = 532,
  [1533] = 529,
  [1534] = 527,
  [1535] = 618,
  [1536] = 590,
  [1537] = 589,
  [1538] = 523,
  [1539] = 616,
  [1540] = 614,
  [1541] = 612,
  [1542] = 519,
  [1543] = 518,
  [1544] = 517,
  [1545] = 516,
  [1546] = 515,
  [1547] = 514,
  [1548] = 513,
  [1549] = 493,
  [1550] = 492,
  [1551] = 478,
  [1552] = 472,
  [1553] = 466,
  [1554] = 463,
  [1555] = 462,
  [1556] = 460,
  [1557] = 459,
  [1558] = 458,
  [1559] = 456,
  [1560] = 601,
  [1561] = 454,
  [1562] = 620,
  [1563] = 575,
  [1564] = 491,
  [1565] = 611,
  [1566] = 610,
  [1567] = 609,
  [1568] = 438,
  [1569] = 608,
  [1570] = 607,
  [1571] = 606,
  [1572] = 595,
  [1573] = 548,
  [1574] = 448,
  [1575] = 643,
  [1576] = 642,
  [1577] = 641,
  [1578] = 640,
  [1579] = 549,
  [1580] = 489,
  [1581] = 550,
  [1582] = 437,
  [1583] = 547,
  [1584] = 627,
  [1585] = 630,
  [1586] = 629,
  [1587] = 628,
  [1588] = 455,
  [1589] = 435,
  [1590] = 553,
  [1591] = 438,
  [1592] = 619,
  [1593] = 625,
  [1594] = 624,
  [1595] = 622,
  [1596] = 446,
  [1597] = 444,
  [1598] = 442,
  [1599] = 525,
  [1600] = 439,
  [1601] = 621,
  [1602] = 552,
  [1603] = 567,
  [1604] = 487,
  [1605] = 591,
  [1606] = 436,
  [1607] = 592,
  [1608] = 440,
  [1609] = 582,
  [1610] = 598,
  [1611] = 580,
  [1612] = 579,
  [1613] = 578,
  [1614] = 577,
  [1615] = 583,
  [1616] = 574,
  [1617] = 623,
  [1618] = 434,
  [1619] = 435,
  [1620] = 626,
  [1621] = 594,
  [1622] = 436,
  [1623] = 573,
  [1624] = 1624,
  [1625] = 617,
  [1626] = 615,
  [1627] = 613,
  [1628] = 605,
  [1629] = 602,
  [1630] = 437,
  [1631] = 599,
  [1632] = 439,
  [1633] = 506,
  [1634] = 508,
  [1635] = 512,
  [1636] = 521,
  [1637] = 522,
  [1638] = 528,
  [1639] = 530,
  [1640] = 531,
  [1641] = 554,
  [1642] = 556,
  [1643] = 565,
  [1644] = 604,
  [1645] = 568,
  [1646] = 569,
  [1647] = 570,
  [1648] = 571,
  [1649] = 635,
  [1650] = 1431,
  [1651] = 577,
  [1652] = 599,
  [1653] = 615,
  [1654] = 487,
  [1655] = 489,
  [1656] = 491,
  [1657] = 594,
  [1658] = 623,
  [1659] = 583,
  [1660] = 506,
  [1661] = 508,
  [1662] = 582,
  [1663] = 512,
  [1664] = 621,
  [1665] = 521,
  [1666] = 522,
  [1667] = 528,
  [1668] = 530,
  [1669] = 531,
  [1670] = 554,
  [1671] = 556,
  [1672] = 619,
  [1673] = 565,
  [1674] = 568,
  [1675] = 569,
  [1676] = 570,
  [1677] = 571,
  [1678] = 573,
  [1679] = 574,
  [1680] = 553,
  [1681] = 577,
  [1682] = 578,
  [1683] = 579,
  [1684] = 580,
  [1685] = 598,
  [1686] = 549,
  [1687] = 550,
  [1688] = 592,
  [1689] = 591,
  [1690] = 567,
  [1691] = 1357,
  [1692] = 506,
  [1693] = 508,
  [1694] = 512,
  [1695] = 521,
  [1696] = 522,
  [1697] = 528,
  [1698] = 530,
  [1699] = 531,
  [1700] = 554,
  [1701] = 556,
  [1702] = 575,
  [1703] = 491,
  [1704] = 611,
  [1705] = 610,
  [1706] = 609,
  [1707] = 565,
  [1708] = 608,
  [1709] = 607,
  [1710] = 606,
  [1711] = 604,
  [1712] = 552,
  [1713] = 525,
  [1714] = 442,
  [1715] = 444,
  [1716] = 446,
  [1717] = 575,
  [1718] = 448,
  [1719] = 568,
  [1720] = 569,
  [1721] = 489,
  [1722] = 453,
  [1723] = 454,
  [1724] = 455,
  [1725] = 456,
  [1726] = 458,
  [1727] = 459,
  [1728] = 460,
  [1729] = 462,
  [1730] = 463,
  [1731] = 570,
  [1732] = 571,
  [1733] = 627,
  [1734] = 595,
  [1735] = 602,
  [1736] = 605,
  [1737] = 613,
  [1738] = 466,
  [1739] = 472,
  [1740] = 478,
  [1741] = 492,
  [1742] = 493,
  [1743] = 487,
  [1744] = 513,
  [1745] = 514,
  [1746] = 515,
  [1747] = 516,
  [1748] = 517,
  [1749] = 518,
  [1750] = 519,
  [1751] = 544,
  [1752] = 616,
  [1753] = 523,
  [1754] = 617,
  [1755] = 527,
  [1756] = 543,
  [1757] = 529,
  [1758] = 573,
  [1759] = 542,
  [1760] = 574,
  [1761] = 532,
  [1762] = 533,
  [1763] = 601,
  [1764] = 534,
  [1765] = 535,
  [1766] = 578,
  [1767] = 579,
  [1768] = 536,
  [1769] = 580,
  [1770] = 537,
  [1771] = 541,
  [1772] = 538,
  [1773] = 539,
  [1774] = 540,
  [1775] = 541,
  [1776] = 542,
  [1777] = 543,
  [1778] = 544,
  [1779] = 545,
  [1780] = 546,
  [1781] = 547,
  [1782] = 548,
  [1783] = 549,
  [1784] = 550,
  [1785] = 598,
  [1786] = 553,
  [1787] = 582,
  [1788] = 583,
  [1789] = 623,
  [1790] = 594,
  [1791] = 431,
  [1792] = 440,
  [1793] = 592,
  [1794] = 591,
  [1795] = 599,
  [1796] = 567,
  [1797] = 601,
  [1798] = 552,
  [1799] = 525,
  [1800] = 442,
  [1801] = 444,
  [1802] = 446,
  [1803] = 540,
  [1804] = 620,
  [1805] = 622,
  [1806] = 624,
  [1807] = 625,
  [1808] = 604,
  [1809] = 626,
  [1810] = 440,
  [1811] = 628,
  [1812] = 629,
  [1813] = 630,
  [1814] = 635,
  [1815] = 640,
  [1816] = 641,
  [1817] = 642,
  [1818] = 643,
  [1819] = 545,
  [1820] = 448,
  [1821] = 453,
  [1822] = 454,
  [1823] = 621,
  [1824] = 455,
  [1825] = 539,
  [1826] = 424,
  [1827] = 619,
  [1828] = 456,
  [1829] = 458,
  [1830] = 459,
  [1831] = 460,
  [1832] = 462,
  [1833] = 463,
  [1834] = 466,
  [1835] = 472,
  [1836] = 478,
  [1837] = 492,
  [1838] = 612,
  [1839] = 493,
  [1840] = 513,
  [1841] = 514,
  [1842] = 515,
  [1843] = 516,
  [1844] = 517,
  [1845] = 518,
  [1846] = 519,
  [1847] = 612,
  [1848] = 546,
  [1849] = 614,
  [1850] = 547,
  [1851] = 616,
  [1852] = 538,
  [1853] = 523,
  [1854] = 548,
  [1855] = 589,
  [1856] = 590,
  [1857] = 618,
  [1858] = 527,
  [1859] = 529,
  [1860] = 532,
  [1861] = 618,
  [1862] = 533,
  [1863] = 534,
  [1864] = 535,
  [1865] = 536,
  [1866] = 537,
  [1867] = 614,
  [1868] = 435,
  [1869] = 1357,
  [1870] = 439,
  [1871] = 432,
  [1872] = 430,
  [1873] = 427,
  [1874] = 1431,
  [1875] = 426,
  [1876] = 437,
  [1877] = 616,
  [1878] = 438,
  [1879] = 623,
  [1880] = 436,
  [1881] = 463,
  [1882] = 552,
  [1883] = 434,
  [1884] = 569,
  [1885] = 549,
  [1886] = 539,
  [1887] = 458,
  [1888] = 456,
  [1889] = 455,
  [1890] = 454,
  [1891] = 453,
  [1892] = 448,
  [1893] = 527,
  [1894] = 446,
  [1895] = 444,
  [1896] = 442,
  [1897] = 525,
  [1898] = 567,
  [1899] = 591,
  [1900] = 592,
  [1901] = 618,
  [1902] = 598,
  [1903] = 580,
  [1904] = 579,
  [1905] = 578,
  [1906] = 577,
  [1907] = 574,
  [1908] = 573,
  [1909] = 571,
  [1910] = 570,
  [1911] = 568,
  [1912] = 544,
  [1913] = 565,
  [1914] = 556,
  [1915] = 554,
  [1916] = 531,
  [1917] = 530,
  [1918] = 528,
  [1919] = 522,
  [1920] = 521,
  [1921] = 512,
  [1922] = 508,
  [1923] = 506,
  [1924] = 460,
  [1925] = 523,
  [1926] = 543,
  [1927] = 466,
  [1928] = 472,
  [1929] = 478,
  [1930] = 492,
  [1931] = 614,
  [1932] = 612,
  [1933] = 518,
  [1934] = 517,
  [1935] = 542,
  [1936] = 541,
  [1937] = 459,
  [1938] = 540,
  [1939] = 493,
  [1940] = 516,
  [1941] = 440,
  [1942] = 538,
  [1943] = 462,
  [1944] = 604,
  [1945] = 575,
  [1946] = 491,
  [1947] = 537,
  [1948] = 536,
  [1949] = 601,
  [1950] = 599,
  [1951] = 594,
  [1952] = 621,
  [1953] = 583,
  [1954] = 619,
  [1955] = 519,
  [1956] = 489,
  [1957] = 582,
  [1958] = 553,
  [1959] = 1959,
  [1960] = 550,
  [1961] = 535,
  [1962] = 529,
  [1963] = 548,
  [1964] = 547,
  [1965] = 532,
  [1966] = 533,
  [1967] = 534,
  [1968] = 513,
  [1969] = 545,
  [1970] = 514,
  [1971] = 487,
  [1972] = 515,
  [1973] = 546,
  [1974] = 424,
  [1975] = 431,
  [1976] = 430,
  [1977] = 432,
  [1978] = 427,
  [1979] = 426,
  [1980] = 436,
  [1981] = 569,
  [1982] = 435,
  [1983] = 434,
  [1984] = 552,
  [1985] = 439,
  [1986] = 463,
  [1987] = 616,
  [1988] = 623,
  [1989] = 438,
  [1990] = 437,
  [1991] = 573,
  [1992] = 489,
  [1993] = 487,
  [1994] = 553,
  [1995] = 453,
  [1996] = 455,
  [1997] = 545,
  [1998] = 491,
  [1999] = 544,
  [2000] = 543,
  [2001] = 542,
  [2002] = 541,
  [2003] = 548,
  [2004] = 540,
  [2005] = 539,
  [2006] = 516,
  [2007] = 547,
  [2008] = 538,
  [2009] = 537,
  [2010] = 575,
  [2011] = 454,
  [2012] = 550,
  [2013] = 536,
  [2014] = 535,
  [2015] = 534,
  [2016] = 533,
  [2017] = 532,
  [2018] = 529,
  [2019] = 527,
  [2020] = 582,
  [2021] = 506,
  [2022] = 601,
  [2023] = 508,
  [2024] = 512,
  [2025] = 523,
  [2026] = 519,
  [2027] = 521,
  [2028] = 522,
  [2029] = 528,
  [2030] = 530,
  [2031] = 531,
  [2032] = 554,
  [2033] = 556,
  [2034] = 549,
  [2035] = 565,
  [2036] = 517,
  [2037] = 568,
  [2038] = 518,
  [2039] = 570,
  [2040] = 571,
  [2041] = 574,
  [2042] = 515,
  [2043] = 577,
  [2044] = 578,
  [2045] = 579,
  [2046] = 580,
  [2047] = 598,
  [2048] = 594,
  [2049] = 514,
  [2050] = 592,
  [2051] = 591,
  [2052] = 546,
  [2053] = 567,
  [2054] = 513,
  [2055] = 525,
  [2056] = 442,
  [2057] = 444,
  [2058] = 446,
  [2059] = 448,
  [2060] = 493,
  [2061] = 458,
  [2062] = 583,
  [2063] = 492,
  [2064] = 478,
  [2065] = 456,
  [2066] = 599,
  [2067] = 459,
  [2068] = 460,
  [2069] = 462,
  [2070] = 472,
  [2071] = 466,
  [2072] = 2072,
  [2073] = 2072,
  [2074] = 2072,
  [2075] = 2072,
  [2076] = 2072,
  [2077] = 2072,
  [2078] = 2072,
  [2079] = 2079,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 2082,
  [2083] = 2082,
  [2084] = 2080,
  [2085] = 2081,
  [2086] = 2082,
  [2087] = 2081,
  [2088] = 2082,
  [2089] = 2082,
  [2090] = 2081,
  [2091] = 2080,
  [2092] = 2080,
  [2093] = 2081,
  [2094] = 2082,
  [2095] = 2081,
  [2096] = 2082,
  [2097] = 2080,
  [2098] = 2081,
  [2099] = 2080,
  [2100] = 2081,
  [2101] = 2082,
  [2102] = 2082,
  [2103] = 2080,
  [2104] = 2080,
  [2105] = 2080,
  [2106] = 2081,
  [2107] = 2107,
  [2108] = 2107,
  [2109] = 2109,
  [2110] = 2109,
  [2111] = 2109,
  [2112] = 2107,
  [2113] = 2107,
  [2114] = 2109,
  [2115] = 2109,
  [2116] = 2109,
  [2117] = 2109,
  [2118] = 2107,
  [2119] = 2107,
  [2120] = 2109,
  [2121] = 2107,
  [2122] = 2109,
  [2123] = 2107,
  [2124] = 2107,
  [2125] = 2109,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2107,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 2134,
  [2135] = 2131,
  [2136] = 2136,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 2133,
  [2145] = 2145,
  [2146] = 2131,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 2149,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2132,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2131,
  [2156] = 2154,
  [2157] = 2150,
  [2158] = 2132,
  [2159] = 2131,
  [2160] = 2153,
  [2161] = 2148,
  [2162] = 2143,
  [2163] = 2131,
  [2164] = 2134,
  [2165] = 2140,
  [2166] = 2137,
  [2167] = 2139,
  [2168] = 2151,
  [2169] = 2131,
  [2170] = 2138,
  [2171] = 2138,
  [2172] = 2145,
  [2173] = 2149,
  [2174] = 2139,
  [2175] = 2175,
  [2176] = 2149,
  [2177] = 2145,
  [2178] = 2175,
  [2179] = 2137,
  [2180] = 2134,
  [2181] = 2140,
  [2182] = 2182,
  [2183] = 2141,
  [2184] = 2141,
  [2185] = 2136,
  [2186] = 2142,
  [2187] = 2151,
  [2188] = 2143,
  [2189] = 2182,
  [2190] = 2131,
  [2191] = 2147,
  [2192] = 2148,
  [2193] = 2141,
  [2194] = 2136,
  [2195] = 2150,
  [2196] = 2136,
  [2197] = 2175,
  [2198] = 2182,
  [2199] = 2142,
  [2200] = 2133,
  [2201] = 2150,
  [2202] = 2151,
  [2203] = 2134,
  [2204] = 2137,
  [2205] = 2182,
  [2206] = 2136,
  [2207] = 2145,
  [2208] = 2149,
  [2209] = 2175,
  [2210] = 2138,
  [2211] = 2139,
  [2212] = 2140,
  [2213] = 2182,
  [2214] = 2143,
  [2215] = 2131,
  [2216] = 2148,
  [2217] = 2147,
  [2218] = 2133,
  [2219] = 2150,
  [2220] = 2151,
  [2221] = 2153,
  [2222] = 2154,
  [2223] = 2134,
  [2224] = 2137,
  [2225] = 2145,
  [2226] = 2149,
  [2227] = 2153,
  [2228] = 2175,
  [2229] = 2141,
  [2230] = 2154,
  [2231] = 2138,
  [2232] = 2139,
  [2233] = 2140,
  [2234] = 2132,
  [2235] = 2143,
  [2236] = 2148,
  [2237] = 2154,
  [2238] = 2153,
  [2239] = 2148,
  [2240] = 2153,
  [2241] = 2154,
  [2242] = 2148,
  [2243] = 2143,
  [2244] = 2140,
  [2245] = 2139,
  [2246] = 2138,
  [2247] = 2132,
  [2248] = 2175,
  [2249] = 2141,
  [2250] = 2149,
  [2251] = 2145,
  [2252] = 2137,
  [2253] = 2131,
  [2254] = 2134,
  [2255] = 2142,
  [2256] = 2132,
  [2257] = 2136,
  [2258] = 2151,
  [2259] = 2150,
  [2260] = 2142,
  [2261] = 2133,
  [2262] = 2147,
  [2263] = 2136,
  [2264] = 2147,
  [2265] = 2182,
  [2266] = 2142,
  [2267] = 2133,
  [2268] = 2147,
  [2269] = 2150,
  [2270] = 2147,
  [2271] = 2151,
  [2272] = 2182,
  [2273] = 2133,
  [2274] = 2142,
  [2275] = 2147,
  [2276] = 2133,
  [2277] = 2134,
  [2278] = 2132,
  [2279] = 2154,
  [2280] = 2153,
  [2281] = 2148,
  [2282] = 2143,
  [2283] = 2140,
  [2284] = 2139,
  [2285] = 2138,
  [2286] = 2141,
  [2287] = 2175,
  [2288] = 2149,
  [2289] = 2145,
  [2290] = 2137,
  [2291] = 2134,
  [2292] = 2151,
  [2293] = 2150,
  [2294] = 2137,
  [2295] = 2145,
  [2296] = 2149,
  [2297] = 2136,
  [2298] = 2175,
  [2299] = 2138,
  [2300] = 2139,
  [2301] = 2140,
  [2302] = 2143,
  [2303] = 2148,
  [2304] = 2182,
  [2305] = 2141,
  [2306] = 2136,
  [2307] = 2141,
  [2308] = 2153,
  [2309] = 2136,
  [2310] = 2182,
  [2311] = 2154,
  [2312] = 2132,
  [2313] = 2147,
  [2314] = 2133,
  [2315] = 2141,
  [2316] = 2316,
  [2317] = 2132,
  [2318] = 2154,
  [2319] = 2153,
  [2320] = 2148,
  [2321] = 2143,
  [2322] = 2133,
  [2323] = 2147,
  [2324] = 2182,
  [2325] = 2140,
  [2326] = 2142,
  [2327] = 2139,
  [2328] = 2132,
  [2329] = 2138,
  [2330] = 2154,
  [2331] = 2175,
  [2332] = 2149,
  [2333] = 2145,
  [2334] = 2137,
  [2335] = 2134,
  [2336] = 2153,
  [2337] = 2151,
  [2338] = 2150,
  [2339] = 2150,
  [2340] = 2151,
  [2341] = 2142,
  [2342] = 2134,
  [2343] = 2137,
  [2344] = 2145,
  [2345] = 2149,
  [2346] = 2175,
  [2347] = 2142,
  [2348] = 2138,
  [2349] = 2139,
  [2350] = 2140,
  [2351] = 2143,
  [2352] = 2352,
  [2353] = 2353,
  [2354] = 2354,
  [2355] = 2355,
  [2356] = 2356,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2355,
  [2361] = 2355,
  [2362] = 2353,
  [2363] = 2356,
  [2364] = 2364,
  [2365] = 2365,
  [2366] = 2352,
  [2367] = 2354,
  [2368] = 2357,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2358,
  [2372] = 2352,
  [2373] = 2365,
  [2374] = 2359,
  [2375] = 2359,
  [2376] = 2365,
  [2377] = 2358,
  [2378] = 2357,
  [2379] = 2352,
  [2380] = 2354,
  [2381] = 2356,
  [2382] = 2353,
  [2383] = 2355,
  [2384] = 2384,
  [2385] = 2353,
  [2386] = 2352,
  [2387] = 2365,
  [2388] = 2359,
  [2389] = 2358,
  [2390] = 2355,
  [2391] = 2353,
  [2392] = 2356,
  [2393] = 2393,
  [2394] = 2357,
  [2395] = 2354,
  [2396] = 2357,
  [2397] = 2358,
  [2398] = 2359,
  [2399] = 2399,
  [2400] = 2356,
  [2401] = 2365,
  [2402] = 2352,
  [2403] = 2354,
  [2404] = 2356,
  [2405] = 2353,
  [2406] = 2406,
  [2407] = 2407,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2354,
  [2411] = 2365,
  [2412] = 2412,
  [2413] = 2355,
  [2414] = 2365,
  [2415] = 2359,
  [2416] = 2357,
  [2417] = 2352,
  [2418] = 2353,
  [2419] = 2358,
  [2420] = 2365,
  [2421] = 2356,
  [2422] = 2357,
  [2423] = 2354,
  [2424] = 2424,
  [2425] = 2354,
  [2426] = 2359,
  [2427] = 2357,
  [2428] = 2358,
  [2429] = 2355,
  [2430] = 2353,
  [2431] = 2356,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2354,
  [2435] = 2357,
  [2436] = 2358,
  [2437] = 2359,
  [2438] = 2356,
  [2439] = 2353,
  [2440] = 2358,
  [2441] = 2357,
  [2442] = 2354,
  [2443] = 2365,
  [2444] = 2355,
  [2445] = 2352,
  [2446] = 2356,
  [2447] = 2353,
  [2448] = 2355,
  [2449] = 2355,
  [2450] = 2358,
  [2451] = 2359,
  [2452] = 2407,
  [2453] = 2365,
  [2454] = 2359,
  [2455] = 2352,
  [2456] = 2352,
  [2457] = 2407,
  [2458] = 2407,
  [2459] = 2407,
  [2460] = 2407,
  [2461] = 2407,
  [2462] = 2408,
  [2463] = 2393,
  [2464] = 2407,
  [2465] = 2407,
  [2466] = 2407,
  [2467] = 2467,
  [2468] = 2468,
  [2469] = 2469,
  [2470] = 2470,
  [2471] = 2471,
  [2472] = 2472,
  [2473] = 2473,
  [2474] = 2474,
  [2475] = 2475,
  [2476] = 2476,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 2479,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 2484,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 2487,
  [2488] = 2488,
  [2489] = 2489,
  [2490] = 2490,
  [2491] = 2491,
  [2492] = 2492,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2495,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2467,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2477,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2510,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 2513,
  [2514] = 2514,
  [2515] = 2514,
  [2516] = 2492,
  [2517] = 2490,
  [2518] = 2489,
  [2519] = 2488,
  [2520] = 2486,
  [2521] = 2485,
  [2522] = 2473,
  [2523] = 2513,
  [2524] = 487,
  [2525] = 2477,
  [2526] = 2526,
  [2527] = 2477,
  [2528] = 2528,
  [2529] = 2477,
  [2530] = 2477,
  [2531] = 2531,
  [2532] = 2477,
  [2533] = 2533,
  [2534] = 2477,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2477,
  [2538] = 2478,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2477,
  [2544] = 2544,
  [2545] = 2468,
  [2546] = 2546,
  [2547] = 2544,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 2546,
  [2551] = 2551,
  [2552] = 2552,
  [2553] = 2553,
  [2554] = 2554,
  [2555] = 2555,
  [2556] = 2535,
  [2557] = 2542,
  [2558] = 2555,
  [2559] = 2554,
  [2560] = 2553,
  [2561] = 2540,
  [2562] = 2552,
  [2563] = 2551,
  [2564] = 2564,
  [2565] = 2479,
  [2566] = 2549,
  [2567] = 2469,
  [2568] = 2470,
  [2569] = 2471,
  [2570] = 2474,
  [2571] = 2478,
  [2572] = 2548,
  [2573] = 2480,
  [2574] = 2574,
  [2575] = 2497,
  [2576] = 2564,
  [2577] = 2512,
  [2578] = 2511,
  [2579] = 2468,
  [2580] = 2580,
  [2581] = 2581,
  [2582] = 2539,
  [2583] = 2503,
  [2584] = 2584,
  [2585] = 2507,
  [2586] = 2586,
  [2587] = 2587,
  [2588] = 2588,
  [2589] = 2541,
  [2590] = 2472,
  [2591] = 2546,
  [2592] = 2564,
  [2593] = 2475,
  [2594] = 2476,
  [2595] = 2580,
  [2596] = 2596,
  [2597] = 2597,
  [2598] = 2587,
  [2599] = 2481,
  [2600] = 2482,
  [2601] = 2483,
  [2602] = 2484,
  [2603] = 2580,
  [2604] = 2604,
  [2605] = 2510,
  [2606] = 2509,
  [2607] = 2588,
  [2608] = 2491,
  [2609] = 2541,
  [2610] = 2493,
  [2611] = 2494,
  [2612] = 2495,
  [2613] = 2496,
  [2614] = 2497,
  [2615] = 2498,
  [2616] = 2499,
  [2617] = 2467,
  [2618] = 2501,
  [2619] = 2502,
  [2620] = 2546,
  [2621] = 2564,
  [2622] = 2505,
  [2623] = 2506,
  [2624] = 2580,
  [2625] = 2508,
  [2626] = 2509,
  [2627] = 2510,
  [2628] = 2511,
  [2629] = 2512,
  [2630] = 2513,
  [2631] = 2508,
  [2632] = 2514,
  [2633] = 2492,
  [2634] = 2490,
  [2635] = 2489,
  [2636] = 2488,
  [2637] = 2486,
  [2638] = 2485,
  [2639] = 2473,
  [2640] = 2473,
  [2641] = 2474,
  [2642] = 2471,
  [2643] = 2587,
  [2644] = 2588,
  [2645] = 2470,
  [2646] = 2541,
  [2647] = 2546,
  [2648] = 2564,
  [2649] = 2580,
  [2650] = 2469,
  [2651] = 2479,
  [2652] = 2485,
  [2653] = 2587,
  [2654] = 2588,
  [2655] = 2486,
  [2656] = 2539,
  [2657] = 2488,
  [2658] = 489,
  [2659] = 2489,
  [2660] = 2506,
  [2661] = 2490,
  [2662] = 2468,
  [2663] = 2505,
  [2664] = 2544,
  [2665] = 2548,
  [2666] = 2549,
  [2667] = 2541,
  [2668] = 2551,
  [2669] = 2552,
  [2670] = 2553,
  [2671] = 2554,
  [2672] = 2555,
  [2673] = 2535,
  [2674] = 2542,
  [2675] = 2492,
  [2676] = 2514,
  [2677] = 2546,
  [2678] = 2540,
  [2679] = 2513,
  [2680] = 2512,
  [2681] = 2511,
  [2682] = 2479,
  [2683] = 2510,
  [2684] = 2469,
  [2685] = 2470,
  [2686] = 2471,
  [2687] = 2474,
  [2688] = 2478,
  [2689] = 2509,
  [2690] = 2480,
  [2691] = 2467,
  [2692] = 2508,
  [2693] = 2506,
  [2694] = 2505,
  [2695] = 2502,
  [2696] = 2502,
  [2697] = 2501,
  [2698] = 2467,
  [2699] = 2499,
  [2700] = 2503,
  [2701] = 2498,
  [2702] = 2507,
  [2703] = 2586,
  [2704] = 2535,
  [2705] = 2496,
  [2706] = 2495,
  [2707] = 2472,
  [2708] = 2494,
  [2709] = 2493,
  [2710] = 2475,
  [2711] = 2476,
  [2712] = 2564,
  [2713] = 2580,
  [2714] = 2491,
  [2715] = 2540,
  [2716] = 2481,
  [2717] = 2482,
  [2718] = 2483,
  [2719] = 2484,
  [2720] = 2501,
  [2721] = 2587,
  [2722] = 2499,
  [2723] = 2498,
  [2724] = 2497,
  [2725] = 2491,
  [2726] = 2588,
  [2727] = 2493,
  [2728] = 2494,
  [2729] = 2495,
  [2730] = 2496,
  [2731] = 2497,
  [2732] = 2498,
  [2733] = 2499,
  [2734] = 2467,
  [2735] = 2501,
  [2736] = 2502,
  [2737] = 2541,
  [2738] = 2487,
  [2739] = 2505,
  [2740] = 2506,
  [2741] = 2546,
  [2742] = 2508,
  [2743] = 2509,
  [2744] = 2510,
  [2745] = 2511,
  [2746] = 2512,
  [2747] = 2513,
  [2748] = 2496,
  [2749] = 2514,
  [2750] = 2492,
  [2751] = 2490,
  [2752] = 2489,
  [2753] = 2488,
  [2754] = 2486,
  [2755] = 2485,
  [2756] = 2473,
  [2757] = 2564,
  [2758] = 2580,
  [2759] = 2587,
  [2760] = 2588,
  [2761] = 2541,
  [2762] = 2546,
  [2763] = 2564,
  [2764] = 2580,
  [2765] = 2587,
  [2766] = 2588,
  [2767] = 2541,
  [2768] = 2495,
  [2769] = 2546,
  [2770] = 2564,
  [2771] = 2580,
  [2772] = 2484,
  [2773] = 2539,
  [2774] = 2483,
  [2775] = 2587,
  [2776] = 2482,
  [2777] = 2494,
  [2778] = 2481,
  [2779] = 2468,
  [2780] = 2493,
  [2781] = 2544,
  [2782] = 2548,
  [2783] = 2549,
  [2784] = 2588,
  [2785] = 2551,
  [2786] = 2552,
  [2787] = 2553,
  [2788] = 2554,
  [2789] = 2555,
  [2790] = 2535,
  [2791] = 2542,
  [2792] = 2480,
  [2793] = 2476,
  [2794] = 2475,
  [2795] = 2540,
  [2796] = 2472,
  [2797] = 2491,
  [2798] = 2586,
  [2799] = 2479,
  [2800] = 2507,
  [2801] = 2469,
  [2802] = 2470,
  [2803] = 2471,
  [2804] = 2474,
  [2805] = 2478,
  [2806] = 2503,
  [2807] = 2480,
  [2808] = 2535,
  [2809] = 2555,
  [2810] = 2541,
  [2811] = 2484,
  [2812] = 2554,
  [2813] = 2480,
  [2814] = 2478,
  [2815] = 2474,
  [2816] = 2471,
  [2817] = 2503,
  [2818] = 2470,
  [2819] = 2507,
  [2820] = 2586,
  [2821] = 2469,
  [2822] = 2479,
  [2823] = 2546,
  [2824] = 2472,
  [2825] = 2540,
  [2826] = 2542,
  [2827] = 2475,
  [2828] = 2476,
  [2829] = 2564,
  [2830] = 2580,
  [2831] = 2555,
  [2832] = 2554,
  [2833] = 2481,
  [2834] = 2482,
  [2835] = 2483,
  [2836] = 2484,
  [2837] = 2553,
  [2838] = 2553,
  [2839] = 2552,
  [2840] = 2491,
  [2841] = 2587,
  [2842] = 2493,
  [2843] = 2494,
  [2844] = 2495,
  [2845] = 2496,
  [2846] = 2497,
  [2847] = 2498,
  [2848] = 2499,
  [2849] = 2467,
  [2850] = 2501,
  [2851] = 2502,
  [2852] = 2552,
  [2853] = 2551,
  [2854] = 2505,
  [2855] = 2506,
  [2856] = 2588,
  [2857] = 2508,
  [2858] = 2509,
  [2859] = 2510,
  [2860] = 2511,
  [2861] = 2512,
  [2862] = 2551,
  [2863] = 2503,
  [2864] = 2597,
  [2865] = 2865,
  [2866] = 2866,
  [2867] = 2867,
  [2868] = 2868,
  [2869] = 2507,
  [2870] = 2574,
  [2871] = 2549,
  [2872] = 2604,
  [2873] = 2586,
  [2874] = 2548,
  [2875] = 2539,
  [2876] = 2544,
  [2877] = 2472,
  [2878] = 2512,
  [2879] = 2468,
  [2880] = 2475,
  [2881] = 2468,
  [2882] = 2487,
  [2883] = 2544,
  [2884] = 2548,
  [2885] = 2549,
  [2886] = 2476,
  [2887] = 2539,
  [2888] = 2888,
  [2889] = 2889,
  [2890] = 2540,
  [2891] = 2891,
  [2892] = 2892,
  [2893] = 2893,
  [2894] = 2479,
  [2895] = 2597,
  [2896] = 2469,
  [2897] = 2470,
  [2898] = 2471,
  [2899] = 2474,
  [2900] = 2865,
  [2901] = 2480,
  [2902] = 2866,
  [2903] = 2867,
  [2904] = 2868,
  [2905] = 2542,
  [2906] = 2574,
  [2907] = 2604,
  [2908] = 2482,
  [2909] = 2483,
  [2910] = 2484,
  [2911] = 2503,
  [2912] = 2541,
  [2913] = 2507,
  [2914] = 2586,
  [2915] = 2915,
  [2916] = 2473,
  [2917] = 2485,
  [2918] = 2472,
  [2919] = 2486,
  [2920] = 2488,
  [2921] = 2475,
  [2922] = 2476,
  [2923] = 2888,
  [2924] = 2489,
  [2925] = 2490,
  [2926] = 2492,
  [2927] = 2481,
  [2928] = 2482,
  [2929] = 2483,
  [2930] = 2484,
  [2931] = 2889,
  [2932] = 2891,
  [2933] = 2892,
  [2934] = 2491,
  [2935] = 2893,
  [2936] = 2493,
  [2937] = 2494,
  [2938] = 2495,
  [2939] = 2496,
  [2940] = 2497,
  [2941] = 2498,
  [2942] = 2499,
  [2943] = 2467,
  [2944] = 2501,
  [2945] = 2502,
  [2946] = 2514,
  [2947] = 2597,
  [2948] = 2505,
  [2949] = 2506,
  [2950] = 2513,
  [2951] = 2508,
  [2952] = 2509,
  [2953] = 2510,
  [2954] = 2511,
  [2955] = 2512,
  [2956] = 2865,
  [2957] = 2866,
  [2958] = 2867,
  [2959] = 2553,
  [2960] = 2868,
  [2961] = 2865,
  [2962] = 2511,
  [2963] = 2539,
  [2964] = 2510,
  [2965] = 2487,
  [2966] = 2483,
  [2967] = 2509,
  [2968] = 2586,
  [2969] = 2482,
  [2970] = 2544,
  [2971] = 2548,
  [2972] = 2549,
  [2973] = 2574,
  [2974] = 2508,
  [2975] = 2506,
  [2976] = 2505,
  [2977] = 2540,
  [2978] = 2481,
  [2979] = 2502,
  [2980] = 2479,
  [2981] = 2501,
  [2982] = 2469,
  [2983] = 2470,
  [2984] = 2471,
  [2985] = 2474,
  [2986] = 2499,
  [2987] = 2480,
  [2988] = 2498,
  [2989] = 2497,
  [2990] = 2496,
  [2991] = 2495,
  [2992] = 2494,
  [2993] = 2493,
  [2994] = 2491,
  [2995] = 2604,
  [2996] = 2866,
  [2997] = 2503,
  [2998] = 2487,
  [2999] = 2507,
  [3000] = 2586,
  [3001] = 2549,
  [3002] = 2484,
  [3003] = 2483,
  [3004] = 2472,
  [3005] = 2482,
  [3006] = 2481,
  [3007] = 2475,
  [3008] = 2476,
  [3009] = 2548,
  [3010] = 2491,
  [3011] = 2476,
  [3012] = 2475,
  [3013] = 2481,
  [3014] = 2482,
  [3015] = 2484,
  [3016] = 2472,
  [3017] = 2586,
  [3018] = 2507,
  [3019] = 2491,
  [3020] = 2888,
  [3021] = 2493,
  [3022] = 2494,
  [3023] = 2495,
  [3024] = 2496,
  [3025] = 2497,
  [3026] = 2498,
  [3027] = 2499,
  [3028] = 2467,
  [3029] = 2501,
  [3030] = 2502,
  [3031] = 2503,
  [3032] = 2539,
  [3033] = 2505,
  [3034] = 2506,
  [3035] = 2867,
  [3036] = 2508,
  [3037] = 2509,
  [3038] = 2510,
  [3039] = 2511,
  [3040] = 2512,
  [3041] = 2493,
  [3042] = 2888,
  [3043] = 2587,
  [3044] = 2480,
  [3045] = 2889,
  [3046] = 2891,
  [3047] = 2478,
  [3048] = 2539,
  [3049] = 2474,
  [3050] = 2892,
  [3051] = 2588,
  [3052] = 2471,
  [3053] = 2468,
  [3054] = 2470,
  [3055] = 2544,
  [3056] = 2548,
  [3057] = 2549,
  [3058] = 2893,
  [3059] = 2469,
  [3060] = 2479,
  [3061] = 2531,
  [3062] = 2540,
  [3063] = 2533,
  [3064] = 2540,
  [3065] = 2479,
  [3066] = 2542,
  [3067] = 2469,
  [3068] = 2470,
  [3069] = 2471,
  [3070] = 2474,
  [3071] = 2535,
  [3072] = 2480,
  [3073] = 2555,
  [3074] = 2889,
  [3075] = 2891,
  [3076] = 2892,
  [3077] = 2536,
  [3078] = 2476,
  [3079] = 2475,
  [3080] = 2893,
  [3081] = 2892,
  [3082] = 2891,
  [3083] = 2889,
  [3084] = 2581,
  [3085] = 2554,
  [3086] = 2888,
  [3087] = 2584,
  [3088] = 2596,
  [3089] = 2597,
  [3090] = 2865,
  [3091] = 2866,
  [3092] = 2867,
  [3093] = 2868,
  [3094] = 2494,
  [3095] = 2495,
  [3096] = 2552,
  [3097] = 2551,
  [3098] = 2574,
  [3099] = 2549,
  [3100] = 2548,
  [3101] = 2604,
  [3102] = 2574,
  [3103] = 2604,
  [3104] = 2544,
  [3105] = 2468,
  [3106] = 2868,
  [3107] = 2867,
  [3108] = 2866,
  [3109] = 2865,
  [3110] = 2496,
  [3111] = 2893,
  [3112] = 2597,
  [3113] = 2596,
  [3114] = 2584,
  [3115] = 2581,
  [3116] = 2536,
  [3117] = 2533,
  [3118] = 2531,
  [3119] = 2472,
  [3120] = 2514,
  [3121] = 2893,
  [3122] = 2892,
  [3123] = 2891,
  [3124] = 2889,
  [3125] = 2497,
  [3126] = 2888,
  [3127] = 2498,
  [3128] = 2499,
  [3129] = 2467,
  [3130] = 2501,
  [3131] = 2888,
  [3132] = 2889,
  [3133] = 2891,
  [3134] = 2539,
  [3135] = 2892,
  [3136] = 2893,
  [3137] = 2531,
  [3138] = 2533,
  [3139] = 2536,
  [3140] = 2581,
  [3141] = 2604,
  [3142] = 2574,
  [3143] = 2584,
  [3144] = 2596,
  [3145] = 2597,
  [3146] = 2868,
  [3147] = 2867,
  [3148] = 2866,
  [3149] = 2865,
  [3150] = 2502,
  [3151] = 2597,
  [3152] = 2596,
  [3153] = 2584,
  [3154] = 2581,
  [3155] = 2536,
  [3156] = 2533,
  [3157] = 2531,
  [3158] = 2893,
  [3159] = 2892,
  [3160] = 2891,
  [3161] = 2889,
  [3162] = 2865,
  [3163] = 2888,
  [3164] = 2866,
  [3165] = 2867,
  [3166] = 2868,
  [3167] = 2505,
  [3168] = 2506,
  [3169] = 2574,
  [3170] = 2604,
  [3171] = 2508,
  [3172] = 2544,
  [3173] = 2509,
  [3174] = 2510,
  [3175] = 2586,
  [3176] = 2511,
  [3177] = 2468,
  [3178] = 2604,
  [3179] = 2574,
  [3180] = 2512,
  [3181] = 2507,
  [3182] = 2473,
  [3183] = 2868,
  [3184] = 2867,
  [3185] = 2866,
  [3186] = 2865,
  [3187] = 2485,
  [3188] = 2597,
  [3189] = 2596,
  [3190] = 2584,
  [3191] = 2581,
  [3192] = 2536,
  [3193] = 2533,
  [3194] = 2531,
  [3195] = 2893,
  [3196] = 2892,
  [3197] = 2891,
  [3198] = 2889,
  [3199] = 2888,
  [3200] = 2888,
  [3201] = 2889,
  [3202] = 2891,
  [3203] = 2892,
  [3204] = 2893,
  [3205] = 2531,
  [3206] = 2533,
  [3207] = 2536,
  [3208] = 2486,
  [3209] = 2581,
  [3210] = 2488,
  [3211] = 2489,
  [3212] = 2490,
  [3213] = 2492,
  [3214] = 2481,
  [3215] = 2604,
  [3216] = 2574,
  [3217] = 2584,
  [3218] = 2503,
  [3219] = 2868,
  [3220] = 2868,
  [3221] = 2867,
  [3222] = 2866,
  [3223] = 2865,
  [3224] = 2513,
  [3225] = 2597,
  [3226] = 2596,
  [3227] = 3227,
  [3228] = 3228,
  [3229] = 3229,
  [3230] = 3230,
  [3231] = 3231,
  [3232] = 3232,
  [3233] = 3233,
  [3234] = 3234,
  [3235] = 3235,
  [3236] = 3236,
  [3237] = 3236,
  [3238] = 3235,
  [3239] = 3234,
  [3240] = 3233,
  [3241] = 3232,
  [3242] = 3231,
  [3243] = 3230,
  [3244] = 3229,
  [3245] = 3227,
  [3246] = 3228,
  [3247] = 3247,
  [3248] = 3248,
  [3249] = 3249,
  [3250] = 3228,
  [3251] = 3251,
  [3252] = 3229,
  [3253] = 3230,
  [3254] = 3227,
  [3255] = 3231,
  [3256] = 3232,
  [3257] = 3233,
  [3258] = 3234,
  [3259] = 3235,
  [3260] = 3236,
  [3261] = 3261,
  [3262] = 3262,
  [3263] = 3263,
  [3264] = 3227,
  [3265] = 3265,
  [3266] = 3266,
  [3267] = 3267,
  [3268] = 3268,
  [3269] = 3269,
  [3270] = 3228,
  [3271] = 3229,
  [3272] = 3230,
  [3273] = 3236,
  [3274] = 3231,
  [3275] = 3235,
  [3276] = 3234,
  [3277] = 3233,
  [3278] = 3232,
  [3279] = 3231,
  [3280] = 3230,
  [3281] = 3229,
  [3282] = 3232,
  [3283] = 3228,
  [3284] = 3233,
  [3285] = 3234,
  [3286] = 3235,
  [3287] = 3236,
  [3288] = 3288,
  [3289] = 3227,
  [3290] = 3290,
  [3291] = 3227,
  [3292] = 3228,
  [3293] = 3288,
  [3294] = 3229,
  [3295] = 3230,
  [3296] = 3231,
  [3297] = 3232,
  [3298] = 3233,
  [3299] = 3234,
  [3300] = 3235,
  [3301] = 3236,
  [3302] = 3248,
  [3303] = 3236,
  [3304] = 3304,
  [3305] = 3290,
  [3306] = 3288,
  [3307] = 3269,
  [3308] = 3268,
  [3309] = 3236,
  [3310] = 3248,
  [3311] = 3247,
  [3312] = 3228,
  [3313] = 3313,
  [3314] = 3314,
  [3315] = 3314,
  [3316] = 3269,
  [3317] = 3268,
  [3318] = 3318,
  [3319] = 3290,
  [3320] = 3227,
  [3321] = 3288,
  [3322] = 3269,
  [3323] = 3268,
  [3324] = 3314,
  [3325] = 3248,
  [3326] = 3247,
  [3327] = 3327,
  [3328] = 3328,
  [3329] = 3235,
  [3330] = 3234,
  [3331] = 3233,
  [3332] = 3236,
  [3333] = 3314,
  [3334] = 3247,
  [3335] = 3228,
  [3336] = 3290,
  [3337] = 3248,
  [3338] = 3249,
  [3339] = 3251,
  [3340] = 3261,
  [3341] = 3232,
  [3342] = 3227,
  [3343] = 3231,
  [3344] = 3262,
  [3345] = 3263,
  [3346] = 3230,
  [3347] = 3265,
  [3348] = 3266,
  [3349] = 3267,
  [3350] = 3229,
  [3351] = 3351,
  [3352] = 3268,
  [3353] = 3236,
  [3354] = 3269,
  [3355] = 3314,
  [3356] = 3228,
  [3357] = 3290,
  [3358] = 3288,
  [3359] = 3288,
  [3360] = 3269,
  [3361] = 3268,
  [3362] = 3362,
  [3363] = 3227,
  [3364] = 3266,
  [3365] = 3265,
  [3366] = 3263,
  [3367] = 3261,
  [3368] = 3251,
  [3369] = 3249,
  [3370] = 3248,
  [3371] = 3247,
  [3372] = 3290,
  [3373] = 3373,
  [3374] = 3374,
  [3375] = 3375,
  [3376] = 3267,
  [3377] = 3314,
  [3378] = 3266,
  [3379] = 3379,
  [3380] = 3265,
  [3381] = 3263,
  [3382] = 3262,
  [3383] = 3314,
  [3384] = 3290,
  [3385] = 3288,
  [3386] = 611,
  [3387] = 610,
  [3388] = 3269,
  [3389] = 3268,
  [3390] = 3261,
  [3391] = 3267,
  [3392] = 609,
  [3393] = 3266,
  [3394] = 3265,
  [3395] = 608,
  [3396] = 607,
  [3397] = 3263,
  [3398] = 3262,
  [3399] = 3261,
  [3400] = 3251,
  [3401] = 606,
  [3402] = 3249,
  [3403] = 3248,
  [3404] = 3404,
  [3405] = 3405,
  [3406] = 3247,
  [3407] = 3228,
  [3408] = 3251,
  [3409] = 3249,
  [3410] = 3410,
  [3411] = 3248,
  [3412] = 3412,
  [3413] = 3413,
  [3414] = 3414,
  [3415] = 3415,
  [3416] = 3314,
  [3417] = 3417,
  [3418] = 3290,
  [3419] = 3288,
  [3420] = 3269,
  [3421] = 3268,
  [3422] = 3422,
  [3423] = 3267,
  [3424] = 3266,
  [3425] = 3265,
  [3426] = 3263,
  [3427] = 3262,
  [3428] = 3261,
  [3429] = 3251,
  [3430] = 3249,
  [3431] = 3248,
  [3432] = 3247,
  [3433] = 3433,
  [3434] = 3247,
  [3435] = 3248,
  [3436] = 3249,
  [3437] = 3251,
  [3438] = 3261,
  [3439] = 3262,
  [3440] = 3263,
  [3441] = 3314,
  [3442] = 3265,
  [3443] = 3266,
  [3444] = 3267,
  [3445] = 3445,
  [3446] = 3268,
  [3447] = 3269,
  [3448] = 3288,
  [3449] = 3449,
  [3450] = 3290,
  [3451] = 3290,
  [3452] = 3288,
  [3453] = 3453,
  [3454] = 3269,
  [3455] = 3268,
  [3456] = 3227,
  [3457] = 3267,
  [3458] = 3266,
  [3459] = 3265,
  [3460] = 3263,
  [3461] = 3461,
  [3462] = 3262,
  [3463] = 3261,
  [3464] = 3251,
  [3465] = 3249,
  [3466] = 3248,
  [3467] = 3247,
  [3468] = 3247,
  [3469] = 491,
  [3470] = 3314,
};

static TSCharacterRange sym_word_character_set_1[] = {
  {0, 0x08}, {0x0e, 0x1f}, {'!', '"'}, {'&', '\''}, {'.', '.'}, {'0', '<'}, {'>', 'Z'}, {'`', 'z'},
  {'|', '|'}, {'~', 0x10ffff},
};

static TSCharacterRange sym_path_character_set_1[] = {
  {0, '!'}, {'#', ')'}, {'+', '+'}, {'-', '9'}, {'=', '='}, {'?', 'Z'}, {'\\', '\\'}, {'^', 'z'},
  {'~', 0x10ffff},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 235,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(179);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 242,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 236,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 237,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 244,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 245,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 250,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 238,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 256,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 246,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 239,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 258,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 247,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 240,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 254,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 243,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 249,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 255,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 257,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 253,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '>', 190,
        '[', 50,
        '\\', 260,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '\'' || '-' < lookahead) &&
          (lookahead < '<' || '>' < lookahead) &&
          (lookahead < '[' || '_' < lookahead)) ADVANCE(179);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '>', 190,
        '\\', 259,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '\'' || '-' < lookahead) &&
          (lookahead < '<' || '>' < lookahead) &&
          (lookahead < '[' || '_' < lookahead)) ADVANCE(179);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '%', 47,
        '\'', 194,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 1375,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '#' || '%' < lookahead) &&
          (lookahead < '\'' || '-' < lookahead)) ADVANCE(179);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '%', 47,
        '\'', 194,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '\\', 1374,
        ']', 51,
        '^', 197,
        '_', 196,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '#' || '%' < lookahead) &&
          (lookahead < '\'' || '-' < lookahead) &&
          (lookahead < '[' || '_' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '%', 47,
        '\'', 194,
        '*', 187,
        '+', 185,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '>', 190,
        '\\', 1375,
        '^', 197,
        '_', 196,
        'a', 125,
        'c', 148,
        'd', 114,
        'e', 153,
        'f', 126,
        'g', 82,
        'l', 160,
        'm', 91,
        'p', 175,
        's', 83,
        'v', 102,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '#' || '%' < lookahead) &&
          (lookahead < '\'' || '-' < lookahead) &&
          (lookahead < '<' || '>' < lookahead) &&
          (lookahead < '[' || '_' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '%', 47,
        '(', 54,
        ')', 55,
        '=', 53,
        '[', 50,
        '\\', 1376,
        ']', 51,
        '{', 78,
        '|', 192,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '#' || '%' < lookahead) &&
          (lookahead < '(' || '-' < lookahead) &&
          lookahead != '/' &&
          (lookahead < '[' || '_' < lookahead) &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(179);
      END_STATE();
    case 26:
      if (lookahead == '%') ADVANCE(47);
      if (lookahead == '\\') ADVANCE(1376);
      if (lookahead == '{') ADVANCE(78);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0 &&
          (lookahead < '#' || '%' < lookahead) &&
          lookahead != '^' &&
          lookahead != '_' &&
          lookahead != '}') ADVANCE(195);
      END_STATE();
    case 27:
      if (lookahead == '%') ADVANCE(47);
      if (lookahead == '\\') ADVANCE(31);
      if (lookahead == '}') ADVANCE(79);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(183);
      END_STATE();
    case 28:
      if (lookahead == '%') ADVANCE(44);
      if (lookahead == '{') ADVANCE(78);
      if (lookahead == '}') ADVANCE(79);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(41);
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(184);
      END_STATE();
    case 29:
      if (lookahead == '%') ADVANCE(45);
      if (lookahead == '}') ADVANCE(79);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(42);
      if ((!eof && set_contains(sym_path_character_set_1, 9, lookahead))) ADVANCE(181);
      END_STATE();
    case 30:
      if (lookahead == '%') ADVANCE(46);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(43);
      if (lookahead != 0 &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(182);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(33);
      END_STATE();
    case 32:
      if (lookahead == 'd') ADVANCE(80);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(32);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(180);
      END_STATE();
    case 35:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 252,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 36:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 241,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 37:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 248,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 38:
      if (eof) ADVANCE(39);
      ADVANCE_MAP(
        '!', 191,
        '#', 34,
        '$', 201,
        '%', 47,
        '\'', 194,
        '(', 54,
        ')', 55,
        '*', 187,
        '+', 185,
        ',', 52,
        '-', 186,
        '/', 188,
        ':', 193,
        '<', 189,
        '=', 53,
        '>', 190,
        '[', 50,
        '\\', 251,
        ']', 51,
        '^', 197,
        '_', 196,
        '{', 78,
        '|', 192,
        '}', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      if (lookahead != 0) ADVANCE(179);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym__whitespace);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(40);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym__whitespace);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(41);
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(184);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym__whitespace);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(42);
      if ((!eof && set_contains(sym_path_character_set_1, 9, lookahead))) ADVANCE(181);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym__whitespace);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(43);
      if (lookahead != 0 &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(182);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(184);
      if (lookahead == '"' ||
          (':' <= lookahead && lookahead <= '<') ||
          lookahead == '>' ||
          lookahead == '[' ||
          lookahead == ']' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(47);
      if (lookahead != 0) ADVANCE(44);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(181);
      if (lookahead == '"' ||
          lookahead == '*' ||
          lookahead == ',' ||
          (':' <= lookahead && lookahead <= '<') ||
          lookahead == '>' ||
          lookahead == '[' ||
          lookahead == ']' ||
          ('{' <= lookahead && lookahead <= '}')) ADVANCE(47);
      if (lookahead != 0) ADVANCE(45);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(182);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(47);
      if (lookahead != 0) ADVANCE(46);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(47);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_BSLASHiffalse);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_BSLASHfi);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_BSLASHpart);
      if (lookahead == '*') ADVANCE(57);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_BSLASHpart_STAR);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_BSLASHaddpart);
      if (lookahead == '*') ADVANCE(59);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_BSLASHaddpart_STAR);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_BSLASHchapter);
      if (lookahead == '*') ADVANCE(61);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_BSLASHchapter_STAR);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_BSLASHaddchap);
      if (lookahead == '*') ADVANCE(63);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_BSLASHaddchap_STAR);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_BSLASHsection);
      if (lookahead == '*') ADVANCE(65);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_BSLASHsection_STAR);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_BSLASHaddsec);
      if (lookahead == '*') ADVANCE(67);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_BSLASHaddsec_STAR);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_BSLASHsubsection);
      if (lookahead == '*') ADVANCE(69);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_BSLASHsubsection_STAR);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_BSLASHsubsubsection);
      if (lookahead == '*') ADVANCE(71);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_BSLASHsubsubsection_STAR);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_BSLASHparagraph);
      if (lookahead == '*') ADVANCE(73);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_BSLASHparagraph_STAR);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_BSLASHsubparagraph);
      if (lookahead == '*') ADVANCE(75);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_BSLASHsubparagraph_STAR);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_BSLASHitem);
      if (lookahead == '*') ADVANCE(77);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_BSLASHitem_STAR);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_BSLASHand);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_BSLASHand);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(162);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(108);
      if (lookahead == 'p') ADVANCE(127);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(176);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(178);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(158);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(132);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(177);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(169);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(173);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(167);
      if (lookahead == 'i') ADVANCE(142);
      if (lookahead == 'u') ADVANCE(133);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'a') ADVANCE(168);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'b') ADVANCE(128);
      if (lookahead == 's') ADVANCE(122);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'b') ADVANCE(90);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'c') ADVANCE(124);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'c') ADVANCE(149);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'd') ADVANCE(209);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'd') ADVANCE(100);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(93);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(210);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(218);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(154);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(97);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(155);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(146);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'e') ADVANCE(147);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'g') ADVANCE(208);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'g') ADVANCE(99);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'g') ADVANCE(139);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'g') ADVANCE(140);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'h') ADVANCE(213);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'h') ADVANCE(214);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'h') ADVANCE(104);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(159);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(109);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(151);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(110);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(135);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(145);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(163);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(144);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(134);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'i') ADVANCE(161);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'k') ADVANCE(212);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(115);
      if (lookahead == 'r') ADVANCE(156);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(87);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(120);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(150);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(119);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(85);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(123);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(117);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(172);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'l') ADVANCE(106);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'm') ADVANCE(207);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'm') ADVANCE(137);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'm') ADVANCE(105);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'm') ADVANCE(92);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(222);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(232);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(216);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(170);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(86);
      if (lookahead == 'u') ADVANCE(89);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(107);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(101);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(165);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'n') ADVANCE(166);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'o') ADVANCE(136);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'o') ADVANCE(98);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'o') ADVANCE(95);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'o') ADVANCE(141);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'p') ADVANCE(130);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'q') ADVANCE(143);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'r') ADVANCE(94);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'r') ADVANCE(230);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'r') ADVANCE(84);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'r') ADVANCE(88);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'r') ADVANCE(157);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 's') ADVANCE(152);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 's') ADVANCE(171);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 's') ADVANCE(174);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(113);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(226);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(228);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(206);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(211);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(111);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(112);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(116);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(103);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(131);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(129);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(118);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 't') ADVANCE(121);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'y') ADVANCE(96);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'y') ADVANCE(224);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'y') ADVANCE(220);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == 'y') ADVANCE(138);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_word);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_placeholder);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_path);
      if ((!eof && set_contains(sym_path_character_set_1, 9, lookahead))) ADVANCE(181);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_uri);
      if (lookahead != 0 &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_argc);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym__glob_pattern_fragment_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_LT);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_GT);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_BANG);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_COLON);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_letter);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DOLLAR);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_BSLASH_LBRACK);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_BSLASH_RBRACK);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(198);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_BSLASH_LPAREN);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_BSLASH_RPAREN);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_BSLASHbegin);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_BSLASHend);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_comment);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_verbatim);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_lstlisting);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_minted);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_pycode);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_sagesilent);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_sageblock);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_math);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_displaymath);
      if (lookahead == '*') ADVANCE(215);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_displaymath_STAR);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_equation);
      if (lookahead == '*') ADVANCE(217);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_equation_STAR);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_multline);
      if (lookahead == '*') ADVANCE(219);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_multline_STAR);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_eqnarray);
      if (lookahead == '*') ADVANCE(221);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_eqnarray_STAR);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_align);
      if (lookahead == '*') ADVANCE(223);
      if (lookahead == 'a') ADVANCE(164);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_align_STAR);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_array);
      if (lookahead == '*') ADVANCE(225);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_array_STAR);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_split);
      if (lookahead == '*') ADVANCE(227);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_split_STAR);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_alignat);
      if (lookahead == '*') ADVANCE(229);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_alignat_STAR);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_gather);
      if (lookahead == '*') ADVANCE(231);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_gather_STAR);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_flalign);
      if (lookahead == '*') ADVANCE(233);
      if ((!eof && set_contains(sym_word_character_set_1, 10, lookahead))) ADVANCE(179);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_flalign_STAR);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_command_name);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        ')', 203,
        'A', 261,
        'B', 693,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        ']', 200,
        'a', 383,
        'b', 535,
        'c', 287,
        'd', 477,
        'e', 921,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 478,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        ')', 203,
        'A', 261,
        'B', 693,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 535,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 478,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        ')', 203,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        ']', 200,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        ')', 203,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 383,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        ')', 203,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 921,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        ')', 203,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        ')', 203,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 693,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        ']', 200,
        'a', 384,
        'b', 535,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 478,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 693,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 535,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 478,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 693,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 535,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 478,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        ']', 200,
        'a', 383,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        ']', 200,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 921,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        ']', 200,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        ']', 200,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 921,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 921,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 384,
        'b', 536,
        'c', 287,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 623,
        'l', 289,
        'n', 291,
        'p', 292,
        'r', 479,
        's', 541,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 386,
        'b', 700,
        'c', 288,
        'd', 477,
        'e', 1091,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 624,
        'l', 289,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 678,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 386,
        'b', 700,
        'c', 288,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 624,
        'l', 289,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 678,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 386,
        'b', 536,
        'c', 288,
        'd', 477,
        'e', 921,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 624,
        'l', 289,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 678,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 386,
        'b', 536,
        'c', 288,
        'd', 477,
        'e', 921,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 624,
        'l', 289,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 678,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 386,
        'b', 536,
        'c', 288,
        'd', 477,
        'e', 1091,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 624,
        'l', 289,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 678,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 386,
        'b', 536,
        'c', 288,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 624,
        'l', 289,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 678,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 385,
        'b', 700,
        'c', 288,
        'd', 477,
        'e', 1091,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 624,
        'l', 289,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 678,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        '(', 202,
        'A', 261,
        'B', 711,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        '[', 199,
        'a', 385,
        'b', 700,
        'c', 288,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 624,
        'l', 289,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 678,
        't', 577,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(285);
      if (lookahead == 'c') ADVANCE(1600);
      if (lookahead == 'u') ADVANCE(1232);
      if (lookahead == 'v') ADVANCE(1046);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1141);
      if (lookahead == 'c') ADVANCE(1142);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1034);
      if (lookahead == 'E') ADVANCE(978);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1036);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1037);
      if (lookahead == 'E') ADVANCE(979);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1038);
      if (lookahead == 'E') ADVANCE(980);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1039);
      if (lookahead == 'E') ADVANCE(981);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1040);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1041);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1042);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'C') ADVANCE(1043);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'D') ADVANCE(1044);
      if (lookahead == 'E') ADVANCE(1347);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'D') ADVANCE(584);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'D') ADVANCE(1047);
      if (lookahead == 'E') ADVANCE(1358);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'D') ADVANCE(1050);
      if (lookahead == 'E') ADVANCE(1359);
      if (lookahead == 'M') ADVANCE(320);
      if (lookahead == 'P') ADVANCE(351);
      if (lookahead == 'R') ADVANCE(991);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'D') ADVANCE(1053);
      if (lookahead == 'E') ADVANCE(1360);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'D') ADVANCE(1055);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'D') ADVANCE(1063);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'D') ADVANCE(1065);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'D') ADVANCE(1067);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'I') ADVANCE(931);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'L') ADVANCE(286);
      if (lookahead == 'l') ADVANCE(1174);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'O') ADVANCE(1080);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'P') ADVANCE(353);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'R') ADVANCE(641);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'S') ADVANCE(1524);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1073);
      if (lookahead == 'h') ADVANCE(331);
      if (lookahead == 'i') ADVANCE(1240);
      if (lookahead == 'o') ADVANCE(810);
      if (lookahead == 'r') ADVANCE(546);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1073);
      if (lookahead == 'i') ADVANCE(1240);
      if (lookahead == 'o') ADVANCE(810);
      if (lookahead == 'r') ADVANCE(546);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(371);
      if (lookahead == 'c') ADVANCE(922);
      if (lookahead == 'e') ADVANCE(642);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(371);
      if (lookahead == 'c') ADVANCE(922);
      if (lookahead == 'e') ADVANCE(1197);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(869);
      if (lookahead == 'e') ADVANCE(1343);
      if (lookahead == 'o') ADVANCE(393);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(664);
      if (lookahead == 'n') ADVANCE(1066);
      if (lookahead == 'v') ADVANCE(1058);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(665);
      if (lookahead == 'n') ADVANCE(1066);
      if (lookahead == 'v') ADVANCE(1058);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1169);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(877);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(663);
      if (lookahead == 'e') ADVANCE(969);
      if (lookahead == 't') ADVANCE(56);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1069);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(398);
      if (lookahead == 'c') ADVANCE(989);
      if (lookahead == 'e') ADVANCE(955);
      if (lookahead == 'g') ADVANCE(814);
      if (lookahead == 'l') ADVANCE(332);
      if (lookahead == 't') ADVANCE(684);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1072);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(394);
      if (lookahead == 'g') ADVANCE(645);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1074);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(376);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(930);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(925);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1096);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(927);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(786);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1108);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(787);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(929);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1101);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(932);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(934);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(791);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1111);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(936);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1114);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(938);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(939);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1233);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(941);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(942);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(943);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(944);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(796);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(799);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(802);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(831);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1116);
      if (lookahead == 'n') ADVANCE(1062);
      if (lookahead == 'r') ADVANCE(986);
      if (lookahead == 'v') ADVANCE(1049);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1282);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1083);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(373);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1238);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1183);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1075);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1081);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1119);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(956);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(871);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1239);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1076);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(670);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1136);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(872);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1126);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(671);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(873);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(672);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1140);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1257);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(730);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(674);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(438);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1171);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(380);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(381);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(382);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(983);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(984);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(985);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(643);
      if (lookahead == 'p') ADVANCE(549);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(644);
      if (lookahead == 'p') ADVANCE(549);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(701);
      if (lookahead == 'c') ADVANCE(681);
      if (lookahead == 'p') ADVANCE(345);
      if (lookahead == 's') ADVANCE(550);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(701);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(811);
      if (lookahead == 'g') ADVANCE(662);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(811);
      if (lookahead == 'g') ADVANCE(667);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(811);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(333);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(1318);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(1195);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(563);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(1157);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(573);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(1012);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(1015);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(826);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(1143);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(340);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(1161);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(854);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(855);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(856);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'd') ADVANCE(450);
      if (lookahead == 'n') ADVANCE(451);
      if (lookahead == 'u') ADVANCE(1196);
      if (lookahead == 'v') ADVANCE(1056);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'd') ADVANCE(450);
      if (lookahead == 'u') ADVANCE(1196);
      if (lookahead == 'v') ADVANCE(1056);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'd') ADVANCE(465);
      if (lookahead == 'n') ADVANCE(451);
      if (lookahead == 'u') ADVANCE(1196);
      if (lookahead == 'v') ADVANCE(1056);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1599);
      if (lookahead == 'd') ADVANCE(465);
      if (lookahead == 'u') ADVANCE(1196);
      if (lookahead == 'v') ADVANCE(1056);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(742);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(66);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1549);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1548);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1547);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1312);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(718);
      if (lookahead == 't') ADVANCE(603);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(766);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(808);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(809);
      if (lookahead == 'p') ADVANCE(1306);
      if (lookahead == 't') ADVANCE(547);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(809);
      if (lookahead == 'p') ADVANCE(1306);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1159);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1177);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(336);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(821);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(529);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1019);
      if (lookahead == 'r') ADVANCE(557);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1144);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(721);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(833);
      if (lookahead == 'f') ADVANCE(1501);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(834);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1021);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(723);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(836);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(724);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(726);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(727);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(728);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(731);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(732);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(733);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(734);
      if (lookahead == 'r') ADVANCE(554);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(735);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(736);
      if (lookahead == 'f') ADVANCE(1329);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(737);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(738);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(739);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(740);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(741);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(743);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(744);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(745);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(746);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(747);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(748);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(749);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(750);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(751);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(752);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(753);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1324);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(767);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1283);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1031);
      if (lookahead == 'e') ADVANCE(977);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1325);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1285);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1286);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1326);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1327);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1328);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1330);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1331);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1332);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(363);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(81);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(205);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1485);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1487);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(273);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1493);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1489);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1494);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1496);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1495);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1497);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1498);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1500);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(1499);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(364);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(302);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(619);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(493);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(570);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(530);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(355);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(356);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(357);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(395);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1342);
      if (lookahead == 'o') ADVANCE(1277);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1348);
      if (lookahead == 'v') ADVANCE(1054);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(406);
      if (lookahead == 'o') ADVANCE(392);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(626);
      if (lookahead == 'i') ADVANCE(652);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(626);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1068);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1403);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1401);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(262);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1377);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1404);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(275);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1544);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1543);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(284);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1445);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1542);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(48);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1382);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1385);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1444);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1441);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1455);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1457);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1447);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1451);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1436);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1453);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1440);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1454);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1421);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1432);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1424);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1448);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1456);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1446);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1450);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1435);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1452);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1482);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1431);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1459);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1438);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1417);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1480);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1460);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1449);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1429);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1458);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1437);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1439);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1379);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1433);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1380);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1386);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1383);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1391);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1387);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(937);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1105);
      if (lookahead == 'o') ADVANCE(807);
      if (lookahead == 'r') ADVANCE(543);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(661);
      if (lookahead == 'i') ADVANCE(365);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(661);
      if (lookahead == 'i') ADVANCE(366);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(627);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(858);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(403);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(277);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(439);
      if (lookahead == 'h') ADVANCE(1017);
      if (lookahead == 'm') ADVANCE(354);
      if (lookahead == 'u') ADVANCE(361);
      if (lookahead == 'v') ADVANCE(1059);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1344);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(628);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(968);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1179);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(629);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1158);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(630);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1168);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(388);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(631);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(632);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(455);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(633);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(408);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1185);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(634);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(635);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(862);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1094);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(404);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(636);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(776);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(637);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1107);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1028);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(638);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(865);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1095);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(646);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1109);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(639);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(781);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1289);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1104);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1223);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1349);
      if (lookahead == 'i') ADVANCE(1236);
      if (lookahead == 'v') ADVANCE(1060);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(945);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1180);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(305);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1350);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(946);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1182);
      if (lookahead == 'i') ADVANCE(1178);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(817);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1351);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(947);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1352);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(948);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(949);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1354);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(971);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1355);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(950);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1356);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(951);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1357);
      if (lookahead == 'i') ADVANCE(1236);
      if (lookahead == 'v') ADVANCE(1060);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(952);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(953);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1133);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1147);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1029);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(413);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(423);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(428);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(430);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(433);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1163);
      if (lookahead == 'o') ADVANCE(838);
      if (lookahead == 'r') ADVANCE(551);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(442);
      if (lookahead == 'u') ADVANCE(370);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(969);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1165);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(970);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(443);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(972);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(974);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(973);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(975);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(976);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(278);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(276);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(279);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(280);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(1345);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(640);
      if (lookahead == 'm') ADVANCE(1086);
      if (lookahead == 'n') ADVANCE(396);
      if (lookahead == 't') ADVANCE(538);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(640);
      if (lookahead == 'm') ADVANCE(1086);
      if (lookahead == 'n') ADVANCE(396);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(640);
      if (lookahead == 'm') ADVANCE(1086);
      if (lookahead == 'n') ADVANCE(397);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1462);
      if (lookahead == 'n') ADVANCE(542);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1469);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1465);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1468);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1628);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1464);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1463);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1466);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1467);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1473);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1472);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1478);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1474);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1479);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(328);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1307);
      if (lookahead == 'l') ADVANCE(992);
      if (lookahead == 's') ADVANCE(688);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1198);
      if (lookahead == 't') ADVANCE(1502);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(716);
      if (lookahead == 'i') ADVANCE(907);
      if (lookahead == 'p') ADVANCE(337);
      if (lookahead == 's') ADVANCE(608);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(716);
      if (lookahead == 'i') ADVANCE(907);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(815);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1131);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1314);
      if (lookahead == 'l') ADVANCE(995);
      if (lookahead == 's') ADVANCE(689);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1316);
      if (lookahead == 'l') ADVANCE(996);
      if (lookahead == 's') ADVANCE(690);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1319);
      if (lookahead == 'l') ADVANCE(1010);
      if (lookahead == 's') ADVANCE(691);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1320);
      if (lookahead == 'l') ADVANCE(1011);
      if (lookahead == 's') ADVANCE(692);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(653);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(682);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(769);
      if (lookahead == 'l') ADVANCE(1505);
      if (lookahead == 'r') ADVANCE(1510);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(1577);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(1576);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(1575);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(1390);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(1603);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(1602);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(666);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(703);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(773);
      if (lookahead == 'l') ADVANCE(1504);
      if (lookahead == 'r') ADVANCE(1509);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(1117);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(539);
      if (lookahead == 'r') ADVANCE(296);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(539);
      if (lookahead == 'r') ADVANCE(609);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(770);
      if (lookahead == 'l') ADVANCE(1505);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(774);
      if (lookahead == 'l') ADVANCE(1504);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(514);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(519);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(600);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(526);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(528);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(1128);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'g') ADVANCE(1154);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(72);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(283);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(74);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1017);
      if (lookahead == 'm') ADVANCE(354);
      if (lookahead == 'u') ADVANCE(362);
      if (lookahead == 'v') ADVANCE(1059);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1361);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(993);
      if (lookahead == 'o') ADVANCE(418);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(297);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1201);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(713);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(566);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1007);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1009);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(601);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1022);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1023);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1024);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1026);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'h') ADVANCE(1027);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(651);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(49);
      if (lookahead == 'n') ADVANCE(1064);
      if (lookahead == 'o') ADVANCE(994);
      if (lookahead == 't') ADVANCE(1341);
      if (lookahead == 'u') ADVANCE(852);
      if (lookahead == 'v') ADVANCE(1057);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(763);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1552);
      if (lookahead == 'v') ADVANCE(1564);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1551);
      if (lookahead == 'v') ADVANCE(1563);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1550);
      if (lookahead == 'v') ADVANCE(1562);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1237);
      if (lookahead == 'r') ADVANCE(537);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(366);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(377);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(467);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(915);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(372);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1113);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(859);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(875);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(367);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(920);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1030);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(660);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(958);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(399);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(906);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1149);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(824);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1152);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1245);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(998);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1138);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1246);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1000);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1247);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1248);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1008);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1249);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1250);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1251);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1013);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1146);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1252);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1253);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1254);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1255);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1256);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1258);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1259);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1260);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1261);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1262);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1263);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1264);
      if (lookahead == 'o') ADVANCE(829);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1265);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1266);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1267);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1268);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1269);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1270);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1271);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1272);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1273);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1274);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1275);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1276);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1162);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(959);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(379);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1166);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1167);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1170);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1172);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1173);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'k') ADVANCE(1372);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'k') ADVANCE(1529);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'k') ADVANCE(1184);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'k') ADVANCE(346);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'k') ADVANCE(348);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 768:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1627);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1507);
      if (lookahead == 'r') ADVANCE(1512);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1507);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1527);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1526);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1506);
      if (lookahead == 'r') ADVANCE(1511);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1506);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1525);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1461);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1583);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1582);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1581);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1423);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1484);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1586);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1580);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 784:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1585);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1579);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 786:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1538);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1537);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1546);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1584);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1578);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1536);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1545);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1574);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1573);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1572);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1541);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1611);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 798:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1605);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 799:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1540);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1610);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1604);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1539);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1609);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1608);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1175);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 806:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1070);
      if (lookahead == 'u') ADVANCE(1284);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(405);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 808:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(343);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1313);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 810:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(988);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 811:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(710);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 812:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1321);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1078);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 814:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(990);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 815:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(704);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(777);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 817:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(714);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 818:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(778);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 819:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1004);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 820:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(779);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 821:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(334);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(484);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 823:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(813);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 824:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(494);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(518);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(540);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 827:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(532);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 828:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1079);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 829:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1005);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 830:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(828);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 831:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1193);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1014);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 833:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(349);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 834:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1315);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 835:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1322);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 836:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1317);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 837:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(1323);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 838:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(409);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 839:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(757);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 840:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(412);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 841:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(414);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 842:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(415);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 843:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(417);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 844:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(419);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 845:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(421);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 846:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(422);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 847:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(424);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 848:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(425);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 849:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(426);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 850:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(431);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 851:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(436);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 852:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(845);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 853:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(851);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 854:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(618);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 855:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(620);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 856:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(621);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 857:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(294);
      if (lookahead == 'v') ADVANCE(1052);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 858:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(76);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 859:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(281);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 860:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(1396);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 861:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(1568);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 862:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(1612);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 863:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(1398);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 864:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(1397);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 865:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(1614);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 866:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(1399);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 867:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(374);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 868:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(874);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 869:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(483);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 870:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(578);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 871:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(487);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 872:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(488);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 873:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(491);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 874:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(306);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 875:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(756);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 876:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(310);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 877:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(561);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 878:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(312);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 879:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(313);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 880:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(316);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 881:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(318);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 882:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(319);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 883:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(321);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 884:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(322);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 885:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(323);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 886:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(324);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 887:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(375);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 888:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(876);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 889:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(582);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 890:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(878);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 891:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(586);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 892:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(879);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 893:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(880);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 894:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(589);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 895:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(881);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 896:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(591);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 897:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(882);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 898:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(593);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 899:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(883);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 900:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(595);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 901:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(884);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 902:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(597);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 903:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(885);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 904:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(598);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 905:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(886);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 906:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(754);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 907:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(1087);
      if (lookahead == 'n') ADVANCE(407);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(611);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 909:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(613);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 910:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(614);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 911:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(615);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 912:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(616);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 913:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(617);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 914:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'm') ADVANCE(354);
      if (lookahead == 'u') ADVANCE(362);
      if (lookahead == 'v') ADVANCE(1059);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 915:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(204);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 916:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1400);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 917:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(64);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 918:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(68);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 919:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(70);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 920:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(764);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 921:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(452);
      if (lookahead == 'q') ADVANCE(1120);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 922:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(295);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 923:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(765);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 924:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(654);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 925:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(466);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 926:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(655);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 927:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(453);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 928:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(656);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 929:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(454);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 930:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(668);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 931:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1084);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 932:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(456);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 933:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(658);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 934:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(457);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 935:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(659);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 936:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(458);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 937:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(622);
      if (lookahead == 'q') ADVANCE(1305);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 938:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(459);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 939:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(460);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 940:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1241);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 941:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(461);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 942:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(462);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 943:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(463);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 944:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(464);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 945:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1279);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 946:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1216);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 947:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1224);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 948:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1244);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 949:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1226);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 950:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1227);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 951:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1228);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 952:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1229);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 953:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1230);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 954:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1366);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 955:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1335);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 956:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(669);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 957:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(555);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 958:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1296);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 959:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1085);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 960:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(891);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 961:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(894);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 962:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1290);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 963:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(410);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 964:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(898);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 965:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(900);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 966:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(902);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 967:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(904);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 968:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(427);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 969:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(432);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 970:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1294);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 971:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1295);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 972:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1297);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 973:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1298);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 974:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1300);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 975:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1301);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 976:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1303);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 977:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1336);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 978:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1337);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 979:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1338);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 980:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1339);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 981:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1340);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 982:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(1064);
      if (lookahead == 'o') ADVANCE(994);
      if (lookahead == 't') ADVANCE(1341);
      if (lookahead == 'u') ADVANCE(852);
      if (lookahead == 'v') ADVANCE(1057);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 983:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(471);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 984:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(472);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 985:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(473);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 986:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1333);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 987:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1346);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 988:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1092);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 989:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(868);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 990:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1181);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 991:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(369);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 992:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(924);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 993:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1093);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 994:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1231);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 995:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(926);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 996:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(928);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 997:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(860);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 998:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(916);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 999:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(863);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1000:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(917);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1001:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(864);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1002:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(866);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1003:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(954);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1004:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1097);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1005:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1098);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1006:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(960);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1007:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1099);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1008:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(918);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1009:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1100);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1010:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(933);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1011:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(935);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1012:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(788);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1013:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(919);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1014:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1102);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1015:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(792);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1016:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1103);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1017:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1118);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1018:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1309);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1019:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(819);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1020:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1123);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1021:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(832);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1022:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1130);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1023:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1132);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1024:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1134);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1025:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1135);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1026:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1137);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1027:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1139);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1028:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1145);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1029:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1148);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1030:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(673);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1031:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(888);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1032:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(961);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1033:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(411);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1034:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(890);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1035:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(964);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1036:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(892);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1037:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(893);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1038:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(895);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1039:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(897);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1040:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(899);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1041:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(901);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1042:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(903);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1043:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(905);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1044:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(437);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1045:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(965);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1046:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(840);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1047:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(444);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1048:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(966);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1049:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(841);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1050:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(445);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1051:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(967);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1052:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(842);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1053:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(446);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1054:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(843);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1055:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(441);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1056:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(844);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1057:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(846);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1058:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(847);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1059:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(848);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1060:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(849);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1061:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(850);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1062:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1299);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1063:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(447);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1064:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1302);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1065:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(448);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1066:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(1304);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1067:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(449);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1068:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(300);
      if (lookahead == 't') ADVANCE(695);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1069:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(62);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1070:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1427);
      if (lookahead == 't') ADVANCE(1426);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1071:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1528);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1072:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(675);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1073:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1235);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1074:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(679);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1075:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(683);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1076:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(677);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1077:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(342);
      if (lookahead == 'r') ADVANCE(564);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1078:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(797);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1079:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(800);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1080:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(599);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1081:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(531);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1082:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(304);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1083:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1243);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1084:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1310);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1085:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1311);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1086:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1020);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1087:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1025);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1088:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(358);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1089:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(359);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1090:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(360);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1091:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'q') ADVANCE(1120);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1092:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1618);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1093:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1378);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1094:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(696);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1095:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(60);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1096:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1419);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1097:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1621);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1098:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1620);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1099:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1415);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1100:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1413);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1101:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1425);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1102:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1616);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1103:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1491);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1104:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1513);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1105:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(368);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1106:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1368);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1107:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(697);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1108:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1369);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1109:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(698);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1110:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(768);
      if (lookahead == 's') ADVANCE(480);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1111:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1362);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1112:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(548);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1113:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1186);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1114:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1363);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1115:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1364);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1116:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(544);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1117:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(299);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1118:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1280);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1119:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(352);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1120:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(552);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1121:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(402);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1122:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(307);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1123:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1202);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1124:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(997);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1125:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(780);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1126:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1205);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1127:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(999);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1128:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(301);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1129:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1001);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1130:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1207);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1131:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1002);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1132:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1208);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1133:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(330);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1134:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1211);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1135:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1215);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1136:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(486);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1137:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1219);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1138:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(489);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1139:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1221);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1140:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(574);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1141:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(558);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1142:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(562);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1143:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(556);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1144:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(567);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1145:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(559);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1146:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(553);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1147:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(572);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1148:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(568);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1149:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1188);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1150:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(309);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1151:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(335);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1152:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1190);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1153:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(314);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1154:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(341);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1155:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(325);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1156:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(326);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1157:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(315);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1158:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1287);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1159:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1003);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1160:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(327);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1161:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(317);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1162:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1006);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1163:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(378);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1164:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1370);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1165:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1288);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1166:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1032);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1167:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1035);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1168:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(435);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1169:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1292);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1170:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1045);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1171:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1293);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1172:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1048);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1173:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(1051);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1174:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1523);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1175:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1522);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1176:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1381);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1177:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1389);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1178:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1071);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1179:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(389);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1180:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(390);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1181:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1194);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1182:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(391);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1183:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1176);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1184:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(400);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1185:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1018);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1186:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1209);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1187:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(560);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1188:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1210);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1189:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(565);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1190:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1213);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1191:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(571);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1192:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1218);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1193:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(492);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1194:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(308);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1195:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(612);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1196:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(680);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1197:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1502);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1198:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1503);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1199:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1624);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1200:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1384);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1201:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1508);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1202:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1394);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1203:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1532);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1204:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1531);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1205:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(58);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1206:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1530);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1207:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1571);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1208:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1570);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1209:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1535);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1210:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1534);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1211:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1569);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1212:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1428);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1213:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1533);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1214:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1625);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1215:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1395);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1216:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(263);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1217:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1434);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1218:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(264);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1219:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1607);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1220:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1393);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1221:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1606);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1222:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1392);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1223:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1617);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1224:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1515);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1225:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1626);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1226:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1516);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1227:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1517);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1228:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1518);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1229:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1520);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1230:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1519);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1231:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(420);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1232:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1033);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1233:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(676);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1234:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1367);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1235:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(719);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1236:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(822);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1237:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(481);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1238:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(706);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1239:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(707);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1240:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(482);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1241:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1106);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1242:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(387);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1243:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(569);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1244:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1115);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1245:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(485);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1246:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(490);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1247:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(495);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1248:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(496);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1249:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(497);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1250:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(498);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1251:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(499);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1252:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(500);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1253:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(501);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1254:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(502);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1255:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(503);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1256:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(504);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1257:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(505);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1258:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(506);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1259:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(507);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1260:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(508);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1261:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(509);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1262:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(510);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1263:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(511);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1264:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(512);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1265:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(513);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1266:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(515);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1267:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(516);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1268:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(517);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1269:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(520);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1270:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(521);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1271:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(522);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1272:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(523);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1273:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(524);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1274:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(525);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1275:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(527);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1276:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(575);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1277:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(602);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1278:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(685);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1279:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(401);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1280:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(712);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1281:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(825);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1282:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1016);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1283:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(722);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1284:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(686);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1285:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(725);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1286:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(729);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1287:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(590);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1288:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(594);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1289:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(687);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1290:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(1164);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1291:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(416);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1292:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(429);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1293:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(434);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1294:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(265);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1295:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(268);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1296:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(610);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1297:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(266);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1298:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(269);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1299:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(604);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1300:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(267);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1301:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(270);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1302:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(605);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1303:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(271);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1304:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(606);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1305:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(720);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1306:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1200);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1307:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(816);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1308:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1278);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1309:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1121);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1310:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1220);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1311:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1222);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1312:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(870);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1313:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(468);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1314:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(818);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1315:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(469);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1316:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(820);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1317:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(470);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1318:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1192);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1319:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(823);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1320:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(830);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1321:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1155);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1322:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1156);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1323:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1160);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1324:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(889);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1325:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(896);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1326:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(908);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1327:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(909);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1328:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(910);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1329:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(853);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1330:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(911);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1331:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(912);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1332:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(913);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1333:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'v') ADVANCE(702);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1334:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'v') ADVANCE(657);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1335:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'v') ADVANCE(755);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1336:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'v') ADVANCE(758);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1337:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'v') ADVANCE(759);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1338:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'v') ADVANCE(760);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1339:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'v') ADVANCE(761);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1340:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'v') ADVANCE(762);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1341:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'v') ADVANCE(1061);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1342:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'w') ADVANCE(272);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1343:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'w') ADVANCE(298);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1344:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'w') ADVANCE(440);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1345:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'w') ADVANCE(274);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1346:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1619);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1347:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1082);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1348:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1291);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1349:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1199);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1350:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1203);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1351:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1204);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1352:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1206);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1353:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1212);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1354:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1214);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1355:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1217);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1356:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1225);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1357:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1242);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1358:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1088);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1359:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1089);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1360:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(1090);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1361:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(1388);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1362:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(1622);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1363:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(1623);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1364:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(1521);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1365:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(867);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1366:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(861);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1367:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(827);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1368:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(649);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1369:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(588);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1370:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(650);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1371:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(887);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1372:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'z') ADVANCE(839);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(1373);
      END_STATE();
    case 1373:
      ACCEPT_TOKEN(sym_command_name);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1374:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        'A', 261,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        'a', 386,
        'b', 708,
        'c', 288,
        'd', 477,
        'e', 1091,
        'f', 694,
        'g', 805,
        'h', 1112,
        'i', 625,
        'l', 290,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 914,
        't', 596,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 1375:
      ACCEPT_TOKEN(sym_command_name);
      ADVANCE_MAP(
        'A', 261,
        'C', 699,
        'D', 474,
        'G', 282,
        'N', 475,
        'P', 329,
        'R', 533,
        'S', 857,
        'T', 476,
        'V', 534,
        'a', 386,
        'b', 708,
        'c', 288,
        'd', 477,
        'e', 1091,
        'f', 982,
        'g', 805,
        'h', 1112,
        'i', 625,
        'l', 290,
        'n', 291,
        'p', 293,
        'r', 479,
        's', 914,
        't', 596,
        'u', 1110,
        'v', 607,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('j' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 1376:
      ACCEPT_TOKEN(sym_command_name);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(234);
      END_STATE();
    case 1377:
      ACCEPT_TOKEN(anon_sym_BSLASHtitle);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1378:
      ACCEPT_TOKEN(anon_sym_BSLASHauthor);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1379:
      ACCEPT_TOKEN(anon_sym_BSLASHusepackage);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1380:
      ACCEPT_TOKEN(anon_sym_BSLASHRequirePackage);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1381:
      ACCEPT_TOKEN(anon_sym_BSLASHdocumentclass);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1382:
      ACCEPT_TOKEN(anon_sym_BSLASHinclude);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1127);
      if (lookahead == 'g') ADVANCE(1151);
      if (lookahead == 'i') ADVANCE(923);
      if (lookahead == 's') ADVANCE(1334);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1383:
      ACCEPT_TOKEN(anon_sym_BSLASHsubfileinclude);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1384:
      ACCEPT_TOKEN(anon_sym_BSLASHinput);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1124);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1385:
      ACCEPT_TOKEN(anon_sym_BSLASHsubfile);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(963);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1386:
      ACCEPT_TOKEN(anon_sym_BSLASHaddbibresource);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1387:
      ACCEPT_TOKEN(anon_sym_BSLASHbibliographystyle);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1388:
      ACCEPT_TOKEN(anon_sym_BSLASHbibliography);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1389:
      ACCEPT_TOKEN(anon_sym_BSLASHincludegraphics);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1390:
      ACCEPT_TOKEN(anon_sym_BSLASHincludesvg);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1391:
      ACCEPT_TOKEN(anon_sym_BSLASHincludeinkscape);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1392:
      ACCEPT_TOKEN(anon_sym_BSLASHverbatiminput);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1393:
      ACCEPT_TOKEN(anon_sym_BSLASHVerbatimInput);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1394:
      ACCEPT_TOKEN(anon_sym_BSLASHimport);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1395:
      ACCEPT_TOKEN(anon_sym_BSLASHsubimport);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1129);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1396:
      ACCEPT_TOKEN(anon_sym_BSLASHinputfrom);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1397:
      ACCEPT_TOKEN(anon_sym_BSLASHsubimportfrom);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1398:
      ACCEPT_TOKEN(anon_sym_BSLASHincludefrom);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1399:
      ACCEPT_TOKEN(anon_sym_BSLASHsubincludefrom);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1400:
      ACCEPT_TOKEN(anon_sym_BSLASHcaption);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1401:
      ACCEPT_TOKEN(anon_sym_BSLASHcite);
      ADVANCE_MAP(
        '*', 1402,
        'A', 1409,
        'R', 1410,
        'S', 1411,
        'a', 806,
        'd', 350,
        'p', 1406,
        't', 1405,
        'u', 1125,
        'y', 580,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1402:
      ACCEPT_TOKEN(anon_sym_BSLASHcite_STAR);
      END_STATE();
    case 1403:
      ACCEPT_TOKEN(anon_sym_BSLASHCite);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'a') ADVANCE(1308);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1404:
      ACCEPT_TOKEN(anon_sym_BSLASHnocite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1405:
      ACCEPT_TOKEN(anon_sym_BSLASHcitet);
      if (lookahead == '*') ADVANCE(1407);
      if (lookahead == 'e') ADVANCE(1353);
      if (lookahead == 'i') ADVANCE(1281);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1406:
      ACCEPT_TOKEN(anon_sym_BSLASHcitep);
      if (lookahead == '*') ADVANCE(1408);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1407:
      ACCEPT_TOKEN(anon_sym_BSLASHcitet_STAR);
      END_STATE();
    case 1408:
      ACCEPT_TOKEN(anon_sym_BSLASHcitep_STAR);
      END_STATE();
    case 1409:
      ACCEPT_TOKEN(anon_sym_BSLASHciteA);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1410:
      ACCEPT_TOKEN(anon_sym_BSLASHciteR);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1411:
      ACCEPT_TOKEN(anon_sym_BSLASHciteS);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1412:
      ACCEPT_TOKEN(anon_sym_BSLASHciteyearR);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1413:
      ACCEPT_TOKEN(anon_sym_BSLASHciteauthor);
      if (lookahead == '*') ADVANCE(1414);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1414:
      ACCEPT_TOKEN(anon_sym_BSLASHciteauthor_STAR);
      END_STATE();
    case 1415:
      ACCEPT_TOKEN(anon_sym_BSLASHCiteauthor);
      if (lookahead == '*') ADVANCE(1416);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1416:
      ACCEPT_TOKEN(anon_sym_BSLASHCiteauthor_STAR);
      END_STATE();
    case 1417:
      ACCEPT_TOKEN(anon_sym_BSLASHcitetitle);
      if (lookahead == '*') ADVANCE(1418);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1418:
      ACCEPT_TOKEN(anon_sym_BSLASHcitetitle_STAR);
      END_STATE();
    case 1419:
      ACCEPT_TOKEN(anon_sym_BSLASHciteyear);
      if (lookahead == '*') ADVANCE(1420);
      if (lookahead == 'R') ADVANCE(1412);
      if (lookahead == 'p') ADVANCE(311);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1420:
      ACCEPT_TOKEN(anon_sym_BSLASHciteyear_STAR);
      END_STATE();
    case 1421:
      ACCEPT_TOKEN(anon_sym_BSLASHcitedate);
      if (lookahead == '*') ADVANCE(1422);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1422:
      ACCEPT_TOKEN(anon_sym_BSLASHcitedate_STAR);
      END_STATE();
    case 1423:
      ACCEPT_TOKEN(anon_sym_BSLASHciteurl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1424:
      ACCEPT_TOKEN(anon_sym_BSLASHfullcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1425:
      ACCEPT_TOKEN(anon_sym_BSLASHciteyearpar);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1426:
      ACCEPT_TOKEN(anon_sym_BSLASHcitealt);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1427:
      ACCEPT_TOKEN(anon_sym_BSLASHcitealp);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1428:
      ACCEPT_TOKEN(anon_sym_BSLASHcitetext);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1429:
      ACCEPT_TOKEN(anon_sym_BSLASHparencite);
      if (lookahead == '*') ADVANCE(1430);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1430:
      ACCEPT_TOKEN(anon_sym_BSLASHparencite_STAR);
      END_STATE();
    case 1431:
      ACCEPT_TOKEN(anon_sym_BSLASHParencite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1432:
      ACCEPT_TOKEN(anon_sym_BSLASHfootcite);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 't') ADVANCE(592);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1433:
      ACCEPT_TOKEN(anon_sym_BSLASHfootfullcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1434:
      ACCEPT_TOKEN(anon_sym_BSLASHfootcitetext);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1435:
      ACCEPT_TOKEN(anon_sym_BSLASHtextcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1436:
      ACCEPT_TOKEN(anon_sym_BSLASHTextcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1437:
      ACCEPT_TOKEN(anon_sym_BSLASHsmartcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1438:
      ACCEPT_TOKEN(anon_sym_BSLASHSmartcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1439:
      ACCEPT_TOKEN(anon_sym_BSLASHsupercite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1440:
      ACCEPT_TOKEN(anon_sym_BSLASHautocite);
      if (lookahead == '*') ADVANCE(1442);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1441:
      ACCEPT_TOKEN(anon_sym_BSLASHAutocite);
      if (lookahead == '*') ADVANCE(1443);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1442:
      ACCEPT_TOKEN(anon_sym_BSLASHautocite_STAR);
      END_STATE();
    case 1443:
      ACCEPT_TOKEN(anon_sym_BSLASHAutocite_STAR);
      END_STATE();
    case 1444:
      ACCEPT_TOKEN(anon_sym_BSLASHvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1445:
      ACCEPT_TOKEN(anon_sym_BSLASHVolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1446:
      ACCEPT_TOKEN(anon_sym_BSLASHpvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1447:
      ACCEPT_TOKEN(anon_sym_BSLASHPvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1448:
      ACCEPT_TOKEN(anon_sym_BSLASHfvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1449:
      ACCEPT_TOKEN(anon_sym_BSLASHftvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1450:
      ACCEPT_TOKEN(anon_sym_BSLASHsvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1451:
      ACCEPT_TOKEN(anon_sym_BSLASHSvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1452:
      ACCEPT_TOKEN(anon_sym_BSLASHtvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1453:
      ACCEPT_TOKEN(anon_sym_BSLASHTvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1454:
      ACCEPT_TOKEN(anon_sym_BSLASHavolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1455:
      ACCEPT_TOKEN(anon_sym_BSLASHAvolcite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1456:
      ACCEPT_TOKEN(anon_sym_BSLASHnotecite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1457:
      ACCEPT_TOKEN(anon_sym_BSLASHNotecite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1458:
      ACCEPT_TOKEN(anon_sym_BSLASHpnotecite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1459:
      ACCEPT_TOKEN(anon_sym_BSLASHPnotecite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1460:
      ACCEPT_TOKEN(anon_sym_BSLASHfnotecite);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1461:
      ACCEPT_TOKEN(anon_sym_BSLASHlabel);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(1077);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1462:
      ACCEPT_TOKEN(anon_sym_BSLASHref);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1463:
      ACCEPT_TOKEN(anon_sym_BSLASHeqref);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1464:
      ACCEPT_TOKEN(anon_sym_BSLASHvref);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1465:
      ACCEPT_TOKEN(anon_sym_BSLASHVref);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1466:
      ACCEPT_TOKEN(anon_sym_BSLASHautoref);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1467:
      ACCEPT_TOKEN(anon_sym_BSLASHpageref);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1468:
      ACCEPT_TOKEN(anon_sym_BSLASHcref);
      if (lookahead == '*') ADVANCE(1470);
      if (lookahead == 'r') ADVANCE(338);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1469:
      ACCEPT_TOKEN(anon_sym_BSLASHCref);
      if (lookahead == '*') ADVANCE(1471);
      if (lookahead == 'r') ADVANCE(303);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1470:
      ACCEPT_TOKEN(anon_sym_BSLASHcref_STAR);
      END_STATE();
    case 1471:
      ACCEPT_TOKEN(anon_sym_BSLASHCref_STAR);
      END_STATE();
    case 1472:
      ACCEPT_TOKEN(anon_sym_BSLASHnamecref);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1475);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1473:
      ACCEPT_TOKEN(anon_sym_BSLASHnameCref);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1476);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1474:
      ACCEPT_TOKEN(anon_sym_BSLASHlcnamecref);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(1477);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1475:
      ACCEPT_TOKEN(anon_sym_BSLASHnamecrefs);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1476:
      ACCEPT_TOKEN(anon_sym_BSLASHnameCrefs);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1477:
      ACCEPT_TOKEN(anon_sym_BSLASHlcnamecrefs);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1478:
      ACCEPT_TOKEN(anon_sym_BSLASHlabelcref);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1479:
      ACCEPT_TOKEN(anon_sym_BSLASHlabelcpageref);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1480:
      ACCEPT_TOKEN(anon_sym_BSLASHcrefrange);
      if (lookahead == '*') ADVANCE(1481);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1481:
      ACCEPT_TOKEN(anon_sym_BSLASHcrefrange_STAR);
      END_STATE();
    case 1482:
      ACCEPT_TOKEN(anon_sym_BSLASHCrefrange);
      if (lookahead == '*') ADVANCE(1483);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1483:
      ACCEPT_TOKEN(anon_sym_BSLASHCrefrange_STAR);
      END_STATE();
    case 1484:
      ACCEPT_TOKEN(anon_sym_BSLASHnewlabel);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1485:
      ACCEPT_TOKEN(anon_sym_BSLASHnewcommand);
      if (lookahead == '*') ADVANCE(1486);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1486:
      ACCEPT_TOKEN(anon_sym_BSLASHnewcommand_STAR);
      END_STATE();
    case 1487:
      ACCEPT_TOKEN(anon_sym_BSLASHrenewcommand);
      if (lookahead == '*') ADVANCE(1488);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1488:
      ACCEPT_TOKEN(anon_sym_BSLASHrenewcommand_STAR);
      END_STATE();
    case 1489:
      ACCEPT_TOKEN(anon_sym_BSLASHDeclareRobustCommand);
      if (lookahead == '*') ADVANCE(1490);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1490:
      ACCEPT_TOKEN(anon_sym_BSLASHDeclareRobustCommand_STAR);
      END_STATE();
    case 1491:
      ACCEPT_TOKEN(anon_sym_BSLASHDeclareMathOperator);
      if (lookahead == '*') ADVANCE(1492);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1492:
      ACCEPT_TOKEN(anon_sym_BSLASHDeclareMathOperator_STAR);
      END_STATE();
    case 1493:
      ACCEPT_TOKEN(anon_sym_BSLASHNewDocumentCommand);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1494:
      ACCEPT_TOKEN(anon_sym_BSLASHRenewDocumentCommand);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1495:
      ACCEPT_TOKEN(anon_sym_BSLASHProvideDocumentCommand);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1496:
      ACCEPT_TOKEN(anon_sym_BSLASHDeclareDocumentCommand);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1497:
      ACCEPT_TOKEN(anon_sym_BSLASHNewExpandableDocumentCommand);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1498:
      ACCEPT_TOKEN(anon_sym_BSLASHRenewExpandableDocumentCommand);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1499:
      ACCEPT_TOKEN(anon_sym_BSLASHProvideExpandableDocumentCommand);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1500:
      ACCEPT_TOKEN(anon_sym_BSLASHDeclareExpandableDocumentCommand);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1501:
      ACCEPT_TOKEN(anon_sym_BSLASHdef);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(957);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1502:
      ACCEPT_TOKEN(anon_sym_BSLASHlet);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1503:
      ACCEPT_TOKEN(anon_sym_BSLASHleft);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1504:
      ACCEPT_TOKEN(anon_sym_BSLASHbigl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1505:
      ACCEPT_TOKEN(anon_sym_BSLASHBigl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1506:
      ACCEPT_TOKEN(anon_sym_BSLASHbiggl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1507:
      ACCEPT_TOKEN(anon_sym_BSLASHBiggl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1508:
      ACCEPT_TOKEN(anon_sym_BSLASHright);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1509:
      ACCEPT_TOKEN(anon_sym_BSLASHbigr);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1510:
      ACCEPT_TOKEN(anon_sym_BSLASHBigr);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1511:
      ACCEPT_TOKEN(anon_sym_BSLASHbiggr);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1512:
      ACCEPT_TOKEN(anon_sym_BSLASHBiggr);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1513:
      ACCEPT_TOKEN(anon_sym_BSLASHDeclarePairedDelimiter);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'X') ADVANCE(1514);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1514:
      ACCEPT_TOKEN(anon_sym_BSLASHDeclarePairedDelimiterX);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1515:
      ACCEPT_TOKEN(anon_sym_BSLASHnewenvironment);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1516:
      ACCEPT_TOKEN(anon_sym_BSLASHrenewenvironment);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1517:
      ACCEPT_TOKEN(anon_sym_BSLASHNewDocumentEnvironment);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1518:
      ACCEPT_TOKEN(anon_sym_BSLASHRenewDocumentEnvironment);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1519:
      ACCEPT_TOKEN(anon_sym_BSLASHProvideDocumentEnvironment);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1520:
      ACCEPT_TOKEN(anon_sym_BSLASHDeclareDocumentEnvironment);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1521:
      ACCEPT_TOKEN(anon_sym_BSLASHnewglossaryentry);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1522:
      ACCEPT_TOKEN(anon_sym_BSLASHgls);
      ADVANCE_MAP(
        '*', 234,
        'd', 583,
        'e', 962,
        'f', 717,
        'l', 709,
        'n', 347,
        'p', 775,
        's', 1371,
        't', 587,
        'u', 1191,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1523:
      ACCEPT_TOKEN(anon_sym_BSLASHGls);
      ADVANCE_MAP(
        '*', 234,
        'd', 579,
        'e', 940,
        'f', 715,
        'n', 344,
        'p', 772,
        's', 1365,
        't', 585,
        'u', 1189,
      );
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1524:
      ACCEPT_TOKEN(anon_sym_BSLASHGLS);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'd') ADVANCE(545);
      if (lookahead == 'f') ADVANCE(705);
      if (lookahead == 'n') ADVANCE(339);
      if (lookahead == 'p') ADVANCE(771);
      if (lookahead == 't') ADVANCE(581);
      if (lookahead == 'u') ADVANCE(1187);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1525:
      ACCEPT_TOKEN(anon_sym_BSLASHglspl);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1153);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1526:
      ACCEPT_TOKEN(anon_sym_BSLASHGlspl);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1150);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1527:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSpl);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'u') ADVANCE(1122);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1528:
      ACCEPT_TOKEN(anon_sym_BSLASHglsdisp);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1529:
      ACCEPT_TOKEN(anon_sym_BSLASHglslink);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1530:
      ACCEPT_TOKEN(anon_sym_BSLASHglstext);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1531:
      ACCEPT_TOKEN(anon_sym_BSLASHGlstext);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1532:
      ACCEPT_TOKEN(anon_sym_BSLASHGLStext);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1533:
      ACCEPT_TOKEN(anon_sym_BSLASHglsfirst);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(837);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1534:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsfirst);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(835);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1535:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSfirst);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(812);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1536:
      ACCEPT_TOKEN(anon_sym_BSLASHglsplural);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1537:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsplural);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1538:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSplural);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1539:
      ACCEPT_TOKEN(anon_sym_BSLASHglsfirstplural);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1540:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsfirstplural);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1541:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSfirstplural);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1542:
      ACCEPT_TOKEN(anon_sym_BSLASHglsname);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1543:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsname);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1544:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSname);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1545:
      ACCEPT_TOKEN(anon_sym_BSLASHglssymbol);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1546:
      ACCEPT_TOKEN(anon_sym_BSLASHGlssymbol);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1547:
      ACCEPT_TOKEN(anon_sym_BSLASHglsdesc);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1548:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsdesc);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1549:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSdesc);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1550:
      ACCEPT_TOKEN(anon_sym_BSLASHglsuseri);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1553);
      if (lookahead == 'v') ADVANCE(1559);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1551:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsuseri);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1554);
      if (lookahead == 'v') ADVANCE(1560);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1552:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSuseri);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1555);
      if (lookahead == 'v') ADVANCE(1561);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1553:
      ACCEPT_TOKEN(anon_sym_BSLASHglsuserii);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1556);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1554:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsuserii);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1557);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1555:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSuserii);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1558);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1556:
      ACCEPT_TOKEN(anon_sym_BSLASHglsuseriii);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1557:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsuseriii);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1558:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSuseriii);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1559:
      ACCEPT_TOKEN(anon_sym_BSLASHglsuseriv);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1560:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsuseriv);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1561:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSuseriv);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1562:
      ACCEPT_TOKEN(anon_sym_BSLASHglsuserv);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1565);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1563:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsuserv);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1566);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1564:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSuserv);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'i') ADVANCE(1567);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1565:
      ACCEPT_TOKEN(anon_sym_BSLASHglsuservi);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1566:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsuservi);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1567:
      ACCEPT_TOKEN(anon_sym_BSLASHGLSuservi);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1568:
      ACCEPT_TOKEN(anon_sym_BSLASHnewacronym);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1569:
      ACCEPT_TOKEN(anon_sym_BSLASHacrshort);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(795);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1570:
      ACCEPT_TOKEN(anon_sym_BSLASHAcrshort);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(794);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1571:
      ACCEPT_TOKEN(anon_sym_BSLASHACRshort);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(793);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1572:
      ACCEPT_TOKEN(anon_sym_BSLASHacrshortpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1573:
      ACCEPT_TOKEN(anon_sym_BSLASHAcrshortpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1574:
      ACCEPT_TOKEN(anon_sym_BSLASHACRshortpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1575:
      ACCEPT_TOKEN(anon_sym_BSLASHacrlong);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(790);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1576:
      ACCEPT_TOKEN(anon_sym_BSLASHAcrlong);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(785);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1577:
      ACCEPT_TOKEN(anon_sym_BSLASHACRlong);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(783);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1578:
      ACCEPT_TOKEN(anon_sym_BSLASHacrlongpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1579:
      ACCEPT_TOKEN(anon_sym_BSLASHAcrlongpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1580:
      ACCEPT_TOKEN(anon_sym_BSLASHACRlongpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1581:
      ACCEPT_TOKEN(anon_sym_BSLASHacrfull);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(789);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1582:
      ACCEPT_TOKEN(anon_sym_BSLASHAcrfull);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(784);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1583:
      ACCEPT_TOKEN(anon_sym_BSLASHACRfull);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(782);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1584:
      ACCEPT_TOKEN(anon_sym_BSLASHacrfullpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1585:
      ACCEPT_TOKEN(anon_sym_BSLASHAcrfullpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1586:
      ACCEPT_TOKEN(anon_sym_BSLASHACRfullpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1587:
      ACCEPT_TOKEN(anon_sym_BSLASHacs);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1589);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1588:
      ACCEPT_TOKEN(anon_sym_BSLASHAcs);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1590);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1589:
      ACCEPT_TOKEN(anon_sym_BSLASHacsp);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1590:
      ACCEPT_TOKEN(anon_sym_BSLASHAcsp);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1591:
      ACCEPT_TOKEN(anon_sym_BSLASHacl);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1593);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1592:
      ACCEPT_TOKEN(anon_sym_BSLASHAcl);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1594);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1593:
      ACCEPT_TOKEN(anon_sym_BSLASHaclp);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1594:
      ACCEPT_TOKEN(anon_sym_BSLASHAclp);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1595:
      ACCEPT_TOKEN(anon_sym_BSLASHacf);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1597);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1596:
      ACCEPT_TOKEN(anon_sym_BSLASHAcf);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(1598);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1597:
      ACCEPT_TOKEN(anon_sym_BSLASHacfp);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1598:
      ACCEPT_TOKEN(anon_sym_BSLASHAcfp);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1599:
      ACCEPT_TOKEN(anon_sym_BSLASHac);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1595);
      if (lookahead == 'l') ADVANCE(1591);
      if (lookahead == 'p') ADVANCE(1601);
      if (lookahead == 'r') ADVANCE(648);
      if (lookahead == 's') ADVANCE(1587);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1600:
      ACCEPT_TOKEN(anon_sym_BSLASHAc);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'f') ADVANCE(1596);
      if (lookahead == 'l') ADVANCE(1592);
      if (lookahead == 'r') ADVANCE(647);
      if (lookahead == 's') ADVANCE(1588);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1601:
      ACCEPT_TOKEN(anon_sym_BSLASHacp);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1602:
      ACCEPT_TOKEN(anon_sym_BSLASHglsentrylong);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(801);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1603:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsentrylong);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(798);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1604:
      ACCEPT_TOKEN(anon_sym_BSLASHglsentrylongpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1605:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsentrylongpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1606:
      ACCEPT_TOKEN(anon_sym_BSLASHglsentryshort);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(804);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1607:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsentryshort);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'p') ADVANCE(803);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1608:
      ACCEPT_TOKEN(anon_sym_BSLASHglsentryshortpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1609:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsentryshortpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1610:
      ACCEPT_TOKEN(anon_sym_BSLASHglsentryfullpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1611:
      ACCEPT_TOKEN(anon_sym_BSLASHGlsentryfullpl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1612:
      ACCEPT_TOKEN(anon_sym_BSLASHnewtheorem);
      if (lookahead == '*') ADVANCE(1613);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1613:
      ACCEPT_TOKEN(anon_sym_BSLASHnewtheorem_STAR);
      END_STATE();
    case 1614:
      ACCEPT_TOKEN(anon_sym_BSLASHdeclaretheorem);
      if (lookahead == '*') ADVANCE(1615);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1615:
      ACCEPT_TOKEN(anon_sym_BSLASHdeclaretheorem_STAR);
      END_STATE();
    case 1616:
      ACCEPT_TOKEN(anon_sym_BSLASHdefinecolor);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 's') ADVANCE(576);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1617:
      ACCEPT_TOKEN(anon_sym_BSLASHdefinecolorset);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1618:
      ACCEPT_TOKEN(anon_sym_BSLASHcolor);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'b') ADVANCE(987);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1619:
      ACCEPT_TOKEN(anon_sym_BSLASHcolorbox);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1620:
      ACCEPT_TOKEN(anon_sym_BSLASHtextcolor);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1621:
      ACCEPT_TOKEN(anon_sym_BSLASHpagecolor);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1622:
      ACCEPT_TOKEN(anon_sym_BSLASHusepgflibrary);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1623:
      ACCEPT_TOKEN(anon_sym_BSLASHusetikzlibrary);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1624:
      ACCEPT_TOKEN(anon_sym_BSLASHtext);
      if (lookahead == '*') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(742);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1625:
      ACCEPT_TOKEN(anon_sym_BSLASHintertext);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1626:
      ACCEPT_TOKEN(anon_sym_BSLASHshortintertext);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1627:
      ACCEPT_TOKEN(anon_sym_BSLASHurl);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    case 1628:
      ACCEPT_TOKEN(anon_sym_BSLASHhref);
      if (lookahead == '*') ADVANCE(234);
      if (('@' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(1373);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 35},
  [2] = {.lex_state = 1},
  [3] = {.lex_state = 2},
  [4] = {.lex_state = 2},
  [5] = {.lex_state = 1},
  [6] = {.lex_state = 4},
  [7] = {.lex_state = 4},
  [8] = {.lex_state = 4},
  [9] = {.lex_state = 4},
  [10] = {.lex_state = 4},
  [11] = {.lex_state = 4},
  [12] = {.lex_state = 4},
  [13] = {.lex_state = 4},
  [14] = {.lex_state = 4},
  [15] = {.lex_state = 4},
  [16] = {.lex_state = 4},
  [17] = {.lex_state = 4},
  [18] = {.lex_state = 4},
  [19] = {.lex_state = 4},
  [20] = {.lex_state = 4},
  [21] = {.lex_state = 4},
  [22] = {.lex_state = 4},
  [23] = {.lex_state = 4},
  [24] = {.lex_state = 4},
  [25] = {.lex_state = 5},
  [26] = {.lex_state = 37},
  [27] = {.lex_state = 36},
  [28] = {.lex_state = 37},
  [29] = {.lex_state = 36},
  [30] = {.lex_state = 7},
  [31] = {.lex_state = 5},
  [32] = {.lex_state = 7},
  [33] = {.lex_state = 36},
  [34] = {.lex_state = 3},
  [35] = {.lex_state = 37},
  [36] = {.lex_state = 10},
  [37] = {.lex_state = 9},
  [38] = {.lex_state = 6},
  [39] = {.lex_state = 36},
  [40] = {.lex_state = 36},
  [41] = {.lex_state = 9},
  [42] = {.lex_state = 3},
  [43] = {.lex_state = 37},
  [44] = {.lex_state = 37},
  [45] = {.lex_state = 6},
  [46] = {.lex_state = 6},
  [47] = {.lex_state = 9},
  [48] = {.lex_state = 10},
  [49] = {.lex_state = 36},
  [50] = {.lex_state = 9},
  [51] = {.lex_state = 6},
  [52] = {.lex_state = 10},
  [53] = {.lex_state = 6},
  [54] = {.lex_state = 3},
  [55] = {.lex_state = 6},
  [56] = {.lex_state = 3},
  [57] = {.lex_state = 6},
  [58] = {.lex_state = 6},
  [59] = {.lex_state = 6},
  [60] = {.lex_state = 6},
  [61] = {.lex_state = 6},
  [62] = {.lex_state = 6},
  [63] = {.lex_state = 6},
  [64] = {.lex_state = 35},
  [65] = {.lex_state = 6},
  [66] = {.lex_state = 10},
  [67] = {.lex_state = 37},
  [68] = {.lex_state = 37},
  [69] = {.lex_state = 37},
  [70] = {.lex_state = 36},
  [71] = {.lex_state = 37},
  [72] = {.lex_state = 35},
  [73] = {.lex_state = 37},
  [74] = {.lex_state = 35},
  [75] = {.lex_state = 37},
  [76] = {.lex_state = 36},
  [77] = {.lex_state = 37},
  [78] = {.lex_state = 35},
  [79] = {.lex_state = 37},
  [80] = {.lex_state = 36},
  [81] = {.lex_state = 36},
  [82] = {.lex_state = 37},
  [83] = {.lex_state = 36},
  [84] = {.lex_state = 37},
  [85] = {.lex_state = 36},
  [86] = {.lex_state = 37},
  [87] = {.lex_state = 37},
  [88] = {.lex_state = 36},
  [89] = {.lex_state = 35},
  [90] = {.lex_state = 35},
  [91] = {.lex_state = 35},
  [92] = {.lex_state = 37},
  [93] = {.lex_state = 36},
  [94] = {.lex_state = 35},
  [95] = {.lex_state = 36},
  [96] = {.lex_state = 35},
  [97] = {.lex_state = 37},
  [98] = {.lex_state = 36},
  [99] = {.lex_state = 35},
  [100] = {.lex_state = 35},
  [101] = {.lex_state = 37},
  [102] = {.lex_state = 37},
  [103] = {.lex_state = 36},
  [104] = {.lex_state = 37},
  [105] = {.lex_state = 36},
  [106] = {.lex_state = 36},
  [107] = {.lex_state = 36},
  [108] = {.lex_state = 36},
  [109] = {.lex_state = 35},
  [110] = {.lex_state = 37},
  [111] = {.lex_state = 36},
  [112] = {.lex_state = 37},
  [113] = {.lex_state = 35},
  [114] = {.lex_state = 36},
  [115] = {.lex_state = 37},
  [116] = {.lex_state = 35},
  [117] = {.lex_state = 35},
  [118] = {.lex_state = 37},
  [119] = {.lex_state = 36},
  [120] = {.lex_state = 37},
  [121] = {.lex_state = 36},
  [122] = {.lex_state = 36},
  [123] = {.lex_state = 37},
  [124] = {.lex_state = 37},
  [125] = {.lex_state = 6},
  [126] = {.lex_state = 36},
  [127] = {.lex_state = 36},
  [128] = {.lex_state = 37},
  [129] = {.lex_state = 35},
  [130] = {.lex_state = 36},
  [131] = {.lex_state = 37},
  [132] = {.lex_state = 36},
  [133] = {.lex_state = 35},
  [134] = {.lex_state = 35},
  [135] = {.lex_state = 36},
  [136] = {.lex_state = 37},
  [137] = {.lex_state = 35},
  [138] = {.lex_state = 35},
  [139] = {.lex_state = 37},
  [140] = {.lex_state = 36},
  [141] = {.lex_state = 37},
  [142] = {.lex_state = 35},
  [143] = {.lex_state = 36},
  [144] = {.lex_state = 37},
  [145] = {.lex_state = 35},
  [146] = {.lex_state = 36},
  [147] = {.lex_state = 36},
  [148] = {.lex_state = 4},
  [149] = {.lex_state = 4},
  [150] = {.lex_state = 35},
  [151] = {.lex_state = 4},
  [152] = {.lex_state = 4},
  [153] = {.lex_state = 35},
  [154] = {.lex_state = 37},
  [155] = {.lex_state = 6},
  [156] = {.lex_state = 36},
  [157] = {.lex_state = 37},
  [158] = {.lex_state = 36},
  [159] = {.lex_state = 6},
  [160] = {.lex_state = 35},
  [161] = {.lex_state = 35},
  [162] = {.lex_state = 4},
  [163] = {.lex_state = 4},
  [164] = {.lex_state = 6},
  [165] = {.lex_state = 36},
  [166] = {.lex_state = 37},
  [167] = {.lex_state = 37},
  [168] = {.lex_state = 36},
  [169] = {.lex_state = 6},
  [170] = {.lex_state = 35},
  [171] = {.lex_state = 35},
  [172] = {.lex_state = 4},
  [173] = {.lex_state = 4},
  [174] = {.lex_state = 37},
  [175] = {.lex_state = 36},
  [176] = {.lex_state = 6},
  [177] = {.lex_state = 37},
  [178] = {.lex_state = 36},
  [179] = {.lex_state = 6},
  [180] = {.lex_state = 4},
  [181] = {.lex_state = 35},
  [182] = {.lex_state = 35},
  [183] = {.lex_state = 4},
  [184] = {.lex_state = 36},
  [185] = {.lex_state = 37},
  [186] = {.lex_state = 37},
  [187] = {.lex_state = 6},
  [188] = {.lex_state = 6},
  [189] = {.lex_state = 36},
  [190] = {.lex_state = 35},
  [191] = {.lex_state = 35},
  [192] = {.lex_state = 4},
  [193] = {.lex_state = 4},
  [194] = {.lex_state = 6},
  [195] = {.lex_state = 36},
  [196] = {.lex_state = 6},
  [197] = {.lex_state = 37},
  [198] = {.lex_state = 37},
  [199] = {.lex_state = 36},
  [200] = {.lex_state = 35},
  [201] = {.lex_state = 4},
  [202] = {.lex_state = 35},
  [203] = {.lex_state = 4},
  [204] = {.lex_state = 36},
  [205] = {.lex_state = 6},
  [206] = {.lex_state = 37},
  [207] = {.lex_state = 37},
  [208] = {.lex_state = 36},
  [209] = {.lex_state = 6},
  [210] = {.lex_state = 4},
  [211] = {.lex_state = 4},
  [212] = {.lex_state = 35},
  [213] = {.lex_state = 4},
  [214] = {.lex_state = 35},
  [215] = {.lex_state = 36},
  [216] = {.lex_state = 36},
  [217] = {.lex_state = 6},
  [218] = {.lex_state = 6},
  [219] = {.lex_state = 37},
  [220] = {.lex_state = 37},
  [221] = {.lex_state = 35},
  [222] = {.lex_state = 35},
  [223] = {.lex_state = 35},
  [224] = {.lex_state = 6},
  [225] = {.lex_state = 37},
  [226] = {.lex_state = 36},
  [227] = {.lex_state = 6},
  [228] = {.lex_state = 6},
  [229] = {.lex_state = 36},
  [230] = {.lex_state = 37},
  [231] = {.lex_state = 37},
  [232] = {.lex_state = 36},
  [233] = {.lex_state = 8},
  [234] = {.lex_state = 8},
  [235] = {.lex_state = 8},
  [236] = {.lex_state = 8},
  [237] = {.lex_state = 8},
  [238] = {.lex_state = 8},
  [239] = {.lex_state = 8},
  [240] = {.lex_state = 8},
  [241] = {.lex_state = 8},
  [242] = {.lex_state = 8},
  [243] = {.lex_state = 8},
  [244] = {.lex_state = 8},
  [245] = {.lex_state = 8},
  [246] = {.lex_state = 8},
  [247] = {.lex_state = 8},
  [248] = {.lex_state = 11},
  [249] = {.lex_state = 11},
  [250] = {.lex_state = 11},
  [251] = {.lex_state = 11},
  [252] = {.lex_state = 11},
  [253] = {.lex_state = 11},
  [254] = {.lex_state = 11},
  [255] = {.lex_state = 4},
  [256] = {.lex_state = 4},
  [257] = {.lex_state = 35},
  [258] = {.lex_state = 35},
  [259] = {.lex_state = 37},
  [260] = {.lex_state = 6},
  [261] = {.lex_state = 6},
  [262] = {.lex_state = 37},
  [263] = {.lex_state = 36},
  [264] = {.lex_state = 36},
  [265] = {.lex_state = 24},
  [266] = {.lex_state = 14},
  [267] = {.lex_state = 14},
  [268] = {.lex_state = 14},
  [269] = {.lex_state = 14},
  [270] = {.lex_state = 14},
  [271] = {.lex_state = 14},
  [272] = {.lex_state = 14},
  [273] = {.lex_state = 14},
  [274] = {.lex_state = 14},
  [275] = {.lex_state = 14},
  [276] = {.lex_state = 14},
  [277] = {.lex_state = 14},
  [278] = {.lex_state = 14},
  [279] = {.lex_state = 14},
  [280] = {.lex_state = 14},
  [281] = {.lex_state = 14},
  [282] = {.lex_state = 14},
  [283] = {.lex_state = 14},
  [284] = {.lex_state = 14},
  [285] = {.lex_state = 14},
  [286] = {.lex_state = 14},
  [287] = {.lex_state = 14},
  [288] = {.lex_state = 14},
  [289] = {.lex_state = 14},
  [290] = {.lex_state = 14},
  [291] = {.lex_state = 14},
  [292] = {.lex_state = 14},
  [293] = {.lex_state = 20},
  [294] = {.lex_state = 14},
  [295] = {.lex_state = 20},
  [296] = {.lex_state = 14},
  [297] = {.lex_state = 20},
  [298] = {.lex_state = 20},
  [299] = {.lex_state = 20},
  [300] = {.lex_state = 20},
  [301] = {.lex_state = 20},
  [302] = {.lex_state = 20},
  [303] = {.lex_state = 20},
  [304] = {.lex_state = 20},
  [305] = {.lex_state = 20},
  [306] = {.lex_state = 20},
  [307] = {.lex_state = 14},
  [308] = {.lex_state = 14},
  [309] = {.lex_state = 14},
  [310] = {.lex_state = 14},
  [311] = {.lex_state = 14},
  [312] = {.lex_state = 14},
  [313] = {.lex_state = 14},
  [314] = {.lex_state = 14},
  [315] = {.lex_state = 14},
  [316] = {.lex_state = 14},
  [317] = {.lex_state = 14},
  [318] = {.lex_state = 8},
  [319] = {.lex_state = 8},
  [320] = {.lex_state = 14},
  [321] = {.lex_state = 14},
  [322] = {.lex_state = 11},
  [323] = {.lex_state = 11},
  [324] = {.lex_state = 4},
  [325] = {.lex_state = 4},
  [326] = {.lex_state = 20},
  [327] = {.lex_state = 20},
  [328] = {.lex_state = 35},
  [329] = {.lex_state = 4},
  [330] = {.lex_state = 35},
  [331] = {.lex_state = 4},
  [332] = {.lex_state = 36},
  [333] = {.lex_state = 36},
  [334] = {.lex_state = 6},
  [335] = {.lex_state = 37},
  [336] = {.lex_state = 37},
  [337] = {.lex_state = 6},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 35},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 35},
  [342] = {.lex_state = 36},
  [343] = {.lex_state = 36},
  [344] = {.lex_state = 6},
  [345] = {.lex_state = 37},
  [346] = {.lex_state = 6},
  [347] = {.lex_state = 37},
  [348] = {.lex_state = 4},
  [349] = {.lex_state = 4},
  [350] = {.lex_state = 4},
  [351] = {.lex_state = 35},
  [352] = {.lex_state = 4},
  [353] = {.lex_state = 4},
  [354] = {.lex_state = 4},
  [355] = {.lex_state = 4},
  [356] = {.lex_state = 4},
  [357] = {.lex_state = 4},
  [358] = {.lex_state = 4},
  [359] = {.lex_state = 4},
  [360] = {.lex_state = 4},
  [361] = {.lex_state = 4},
  [362] = {.lex_state = 4},
  [363] = {.lex_state = 4},
  [364] = {.lex_state = 4},
  [365] = {.lex_state = 4},
  [366] = {.lex_state = 4},
  [367] = {.lex_state = 4},
  [368] = {.lex_state = 4},
  [369] = {.lex_state = 4},
  [370] = {.lex_state = 4},
  [371] = {.lex_state = 4},
  [372] = {.lex_state = 4},
  [373] = {.lex_state = 4},
  [374] = {.lex_state = 4},
  [375] = {.lex_state = 4},
  [376] = {.lex_state = 4},
  [377] = {.lex_state = 4},
  [378] = {.lex_state = 4},
  [379] = {.lex_state = 4},
  [380] = {.lex_state = 4},
  [381] = {.lex_state = 4},
  [382] = {.lex_state = 4},
  [383] = {.lex_state = 4},
  [384] = {.lex_state = 4},
  [385] = {.lex_state = 4},
  [386] = {.lex_state = 35},
  [387] = {.lex_state = 4},
  [388] = {.lex_state = 4},
  [389] = {.lex_state = 4},
  [390] = {.lex_state = 4},
  [391] = {.lex_state = 4},
  [392] = {.lex_state = 4},
  [393] = {.lex_state = 4},
  [394] = {.lex_state = 4},
  [395] = {.lex_state = 4},
  [396] = {.lex_state = 4},
  [397] = {.lex_state = 4},
  [398] = {.lex_state = 4},
  [399] = {.lex_state = 4},
  [400] = {.lex_state = 4},
  [401] = {.lex_state = 4},
  [402] = {.lex_state = 4},
  [403] = {.lex_state = 4},
  [404] = {.lex_state = 4},
  [405] = {.lex_state = 4},
  [406] = {.lex_state = 4},
  [407] = {.lex_state = 4},
  [408] = {.lex_state = 4},
  [409] = {.lex_state = 4},
  [410] = {.lex_state = 4},
  [411] = {.lex_state = 4},
  [412] = {.lex_state = 4},
  [413] = {.lex_state = 4},
  [414] = {.lex_state = 4},
  [415] = {.lex_state = 4},
  [416] = {.lex_state = 4},
  [417] = {.lex_state = 4},
  [418] = {.lex_state = 4},
  [419] = {.lex_state = 4},
  [420] = {.lex_state = 4},
  [421] = {.lex_state = 36},
  [422] = {.lex_state = 6},
  [423] = {.lex_state = 36},
  [424] = {.lex_state = 4},
  [425] = {.lex_state = 37},
  [426] = {.lex_state = 15, .external_lex_state = 2},
  [427] = {.lex_state = 4},
  [428] = {.lex_state = 37},
  [429] = {.lex_state = 6},
  [430] = {.lex_state = 4},
  [431] = {.lex_state = 4},
  [432] = {.lex_state = 4},
  [433] = {.lex_state = 4},
  [434] = {.lex_state = 4},
  [435] = {.lex_state = 4},
  [436] = {.lex_state = 4},
  [437] = {.lex_state = 15},
  [438] = {.lex_state = 4},
  [439] = {.lex_state = 4},
  [440] = {.lex_state = 4},
  [441] = {.lex_state = 35},
  [442] = {.lex_state = 4},
  [443] = {.lex_state = 4},
  [444] = {.lex_state = 4},
  [445] = {.lex_state = 4},
  [446] = {.lex_state = 4},
  [447] = {.lex_state = 4},
  [448] = {.lex_state = 4},
  [449] = {.lex_state = 4},
  [450] = {.lex_state = 4},
  [451] = {.lex_state = 4},
  [452] = {.lex_state = 35},
  [453] = {.lex_state = 4},
  [454] = {.lex_state = 4},
  [455] = {.lex_state = 4},
  [456] = {.lex_state = 4},
  [457] = {.lex_state = 35},
  [458] = {.lex_state = 4},
  [459] = {.lex_state = 4},
  [460] = {.lex_state = 4},
  [461] = {.lex_state = 35},
  [462] = {.lex_state = 4},
  [463] = {.lex_state = 4},
  [464] = {.lex_state = 35},
  [465] = {.lex_state = 35},
  [466] = {.lex_state = 4},
  [467] = {.lex_state = 35},
  [468] = {.lex_state = 35},
  [469] = {.lex_state = 4},
  [470] = {.lex_state = 4},
  [471] = {.lex_state = 4},
  [472] = {.lex_state = 4},
  [473] = {.lex_state = 35},
  [474] = {.lex_state = 35},
  [475] = {.lex_state = 35},
  [476] = {.lex_state = 35},
  [477] = {.lex_state = 35},
  [478] = {.lex_state = 4},
  [479] = {.lex_state = 35},
  [480] = {.lex_state = 35},
  [481] = {.lex_state = 35},
  [482] = {.lex_state = 35},
  [483] = {.lex_state = 35},
  [484] = {.lex_state = 35},
  [485] = {.lex_state = 4},
  [486] = {.lex_state = 35},
  [487] = {.lex_state = 4},
  [488] = {.lex_state = 35},
  [489] = {.lex_state = 4},
  [490] = {.lex_state = 35},
  [491] = {.lex_state = 4},
  [492] = {.lex_state = 4},
  [493] = {.lex_state = 4},
  [494] = {.lex_state = 35},
  [495] = {.lex_state = 35},
  [496] = {.lex_state = 35},
  [497] = {.lex_state = 35},
  [498] = {.lex_state = 35},
  [499] = {.lex_state = 35},
  [500] = {.lex_state = 35},
  [501] = {.lex_state = 35},
  [502] = {.lex_state = 35},
  [503] = {.lex_state = 4},
  [504] = {.lex_state = 35},
  [505] = {.lex_state = 35},
  [506] = {.lex_state = 4},
  [507] = {.lex_state = 35},
  [508] = {.lex_state = 4},
  [509] = {.lex_state = 35},
  [510] = {.lex_state = 35},
  [511] = {.lex_state = 35},
  [512] = {.lex_state = 4},
  [513] = {.lex_state = 4},
  [514] = {.lex_state = 4},
  [515] = {.lex_state = 4},
  [516] = {.lex_state = 4},
  [517] = {.lex_state = 4},
  [518] = {.lex_state = 4},
  [519] = {.lex_state = 4},
  [520] = {.lex_state = 35},
  [521] = {.lex_state = 4},
  [522] = {.lex_state = 4},
  [523] = {.lex_state = 4},
  [524] = {.lex_state = 35},
  [525] = {.lex_state = 4},
  [526] = {.lex_state = 35},
  [527] = {.lex_state = 4},
  [528] = {.lex_state = 4},
  [529] = {.lex_state = 4},
  [530] = {.lex_state = 4},
  [531] = {.lex_state = 4},
  [532] = {.lex_state = 4},
  [533] = {.lex_state = 4},
  [534] = {.lex_state = 4},
  [535] = {.lex_state = 4},
  [536] = {.lex_state = 4},
  [537] = {.lex_state = 4},
  [538] = {.lex_state = 4},
  [539] = {.lex_state = 4},
  [540] = {.lex_state = 4},
  [541] = {.lex_state = 4},
  [542] = {.lex_state = 4},
  [543] = {.lex_state = 4},
  [544] = {.lex_state = 4},
  [545] = {.lex_state = 4},
  [546] = {.lex_state = 4},
  [547] = {.lex_state = 4},
  [548] = {.lex_state = 4},
  [549] = {.lex_state = 4},
  [550] = {.lex_state = 4},
  [551] = {.lex_state = 35},
  [552] = {.lex_state = 4},
  [553] = {.lex_state = 4},
  [554] = {.lex_state = 4},
  [555] = {.lex_state = 35},
  [556] = {.lex_state = 4},
  [557] = {.lex_state = 35},
  [558] = {.lex_state = 35},
  [559] = {.lex_state = 35},
  [560] = {.lex_state = 35},
  [561] = {.lex_state = 35},
  [562] = {.lex_state = 35},
  [563] = {.lex_state = 35},
  [564] = {.lex_state = 35},
  [565] = {.lex_state = 4},
  [566] = {.lex_state = 35},
  [567] = {.lex_state = 4},
  [568] = {.lex_state = 4},
  [569] = {.lex_state = 4},
  [570] = {.lex_state = 4},
  [571] = {.lex_state = 4},
  [572] = {.lex_state = 4},
  [573] = {.lex_state = 4},
  [574] = {.lex_state = 4},
  [575] = {.lex_state = 4},
  [576] = {.lex_state = 35},
  [577] = {.lex_state = 4},
  [578] = {.lex_state = 4},
  [579] = {.lex_state = 4},
  [580] = {.lex_state = 4},
  [581] = {.lex_state = 35},
  [582] = {.lex_state = 4},
  [583] = {.lex_state = 4},
  [584] = {.lex_state = 35},
  [585] = {.lex_state = 35},
  [586] = {.lex_state = 35},
  [587] = {.lex_state = 35},
  [588] = {.lex_state = 35},
  [589] = {.lex_state = 4},
  [590] = {.lex_state = 4},
  [591] = {.lex_state = 4},
  [592] = {.lex_state = 4},
  [593] = {.lex_state = 35},
  [594] = {.lex_state = 4},
  [595] = {.lex_state = 4},
  [596] = {.lex_state = 35},
  [597] = {.lex_state = 35},
  [598] = {.lex_state = 4},
  [599] = {.lex_state = 4},
  [600] = {.lex_state = 35},
  [601] = {.lex_state = 4},
  [602] = {.lex_state = 4},
  [603] = {.lex_state = 35},
  [604] = {.lex_state = 4},
  [605] = {.lex_state = 4},
  [606] = {.lex_state = 4},
  [607] = {.lex_state = 4},
  [608] = {.lex_state = 4},
  [609] = {.lex_state = 4},
  [610] = {.lex_state = 4},
  [611] = {.lex_state = 4},
  [612] = {.lex_state = 4},
  [613] = {.lex_state = 4},
  [614] = {.lex_state = 4},
  [615] = {.lex_state = 4},
  [616] = {.lex_state = 4},
  [617] = {.lex_state = 4},
  [618] = {.lex_state = 4},
  [619] = {.lex_state = 4},
  [620] = {.lex_state = 4},
  [621] = {.lex_state = 4},
  [622] = {.lex_state = 4},
  [623] = {.lex_state = 4},
  [624] = {.lex_state = 4},
  [625] = {.lex_state = 4},
  [626] = {.lex_state = 4},
  [627] = {.lex_state = 4},
  [628] = {.lex_state = 4},
  [629] = {.lex_state = 4},
  [630] = {.lex_state = 4},
  [631] = {.lex_state = 35},
  [632] = {.lex_state = 35},
  [633] = {.lex_state = 35},
  [634] = {.lex_state = 35},
  [635] = {.lex_state = 4},
  [636] = {.lex_state = 35},
  [637] = {.lex_state = 35},
  [638] = {.lex_state = 35},
  [639] = {.lex_state = 35},
  [640] = {.lex_state = 4},
  [641] = {.lex_state = 4},
  [642] = {.lex_state = 4},
  [643] = {.lex_state = 4},
  [644] = {.lex_state = 37},
  [645] = {.lex_state = 37},
  [646] = {.lex_state = 37},
  [647] = {.lex_state = 37},
  [648] = {.lex_state = 37},
  [649] = {.lex_state = 37},
  [650] = {.lex_state = 37},
  [651] = {.lex_state = 37},
  [652] = {.lex_state = 36},
  [653] = {.lex_state = 6},
  [654] = {.lex_state = 36},
  [655] = {.lex_state = 36},
  [656] = {.lex_state = 36},
  [657] = {.lex_state = 36},
  [658] = {.lex_state = 36},
  [659] = {.lex_state = 36},
  [660] = {.lex_state = 36},
  [661] = {.lex_state = 6},
  [662] = {.lex_state = 6},
  [663] = {.lex_state = 6},
  [664] = {.lex_state = 6},
  [665] = {.lex_state = 6},
  [666] = {.lex_state = 6},
  [667] = {.lex_state = 37},
  [668] = {.lex_state = 37},
  [669] = {.lex_state = 37},
  [670] = {.lex_state = 37},
  [671] = {.lex_state = 6},
  [672] = {.lex_state = 37},
  [673] = {.lex_state = 37},
  [674] = {.lex_state = 37},
  [675] = {.lex_state = 37},
  [676] = {.lex_state = 6},
  [677] = {.lex_state = 37},
  [678] = {.lex_state = 37},
  [679] = {.lex_state = 37},
  [680] = {.lex_state = 6},
  [681] = {.lex_state = 37},
  [682] = {.lex_state = 37},
  [683] = {.lex_state = 37},
  [684] = {.lex_state = 37},
  [685] = {.lex_state = 37},
  [686] = {.lex_state = 37},
  [687] = {.lex_state = 37},
  [688] = {.lex_state = 37},
  [689] = {.lex_state = 6},
  [690] = {.lex_state = 37},
  [691] = {.lex_state = 37},
  [692] = {.lex_state = 37},
  [693] = {.lex_state = 37},
  [694] = {.lex_state = 6},
  [695] = {.lex_state = 6},
  [696] = {.lex_state = 6},
  [697] = {.lex_state = 6},
  [698] = {.lex_state = 6},
  [699] = {.lex_state = 37},
  [700] = {.lex_state = 37},
  [701] = {.lex_state = 37},
  [702] = {.lex_state = 37},
  [703] = {.lex_state = 37},
  [704] = {.lex_state = 37},
  [705] = {.lex_state = 37},
  [706] = {.lex_state = 37},
  [707] = {.lex_state = 37},
  [708] = {.lex_state = 37},
  [709] = {.lex_state = 37},
  [710] = {.lex_state = 37},
  [711] = {.lex_state = 36},
  [712] = {.lex_state = 6},
  [713] = {.lex_state = 36},
  [714] = {.lex_state = 6},
  [715] = {.lex_state = 36},
  [716] = {.lex_state = 6},
  [717] = {.lex_state = 37},
  [718] = {.lex_state = 6},
  [719] = {.lex_state = 6},
  [720] = {.lex_state = 6},
  [721] = {.lex_state = 37},
  [722] = {.lex_state = 37},
  [723] = {.lex_state = 6},
  [724] = {.lex_state = 6},
  [725] = {.lex_state = 35},
  [726] = {.lex_state = 6},
  [727] = {.lex_state = 6},
  [728] = {.lex_state = 6},
  [729] = {.lex_state = 37},
  [730] = {.lex_state = 6},
  [731] = {.lex_state = 6},
  [732] = {.lex_state = 6},
  [733] = {.lex_state = 6},
  [734] = {.lex_state = 36},
  [735] = {.lex_state = 36},
  [736] = {.lex_state = 36},
  [737] = {.lex_state = 36},
  [738] = {.lex_state = 36},
  [739] = {.lex_state = 36},
  [740] = {.lex_state = 36},
  [741] = {.lex_state = 36},
  [742] = {.lex_state = 36},
  [743] = {.lex_state = 37},
  [744] = {.lex_state = 37},
  [745] = {.lex_state = 36},
  [746] = {.lex_state = 37},
  [747] = {.lex_state = 37},
  [748] = {.lex_state = 37},
  [749] = {.lex_state = 6},
  [750] = {.lex_state = 36},
  [751] = {.lex_state = 6},
  [752] = {.lex_state = 37},
  [753] = {.lex_state = 37},
  [754] = {.lex_state = 36},
  [755] = {.lex_state = 36},
  [756] = {.lex_state = 36},
  [757] = {.lex_state = 36},
  [758] = {.lex_state = 36},
  [759] = {.lex_state = 36},
  [760] = {.lex_state = 36},
  [761] = {.lex_state = 36},
  [762] = {.lex_state = 37},
  [763] = {.lex_state = 36},
  [764] = {.lex_state = 37},
  [765] = {.lex_state = 6},
  [766] = {.lex_state = 6},
  [767] = {.lex_state = 35},
  [768] = {.lex_state = 6},
  [769] = {.lex_state = 38, .external_lex_state = 2},
  [770] = {.lex_state = 6},
  [771] = {.lex_state = 6},
  [772] = {.lex_state = 6},
  [773] = {.lex_state = 35},
  [774] = {.lex_state = 6},
  [775] = {.lex_state = 6},
  [776] = {.lex_state = 6},
  [777] = {.lex_state = 37},
  [778] = {.lex_state = 37},
  [779] = {.lex_state = 37},
  [780] = {.lex_state = 37},
  [781] = {.lex_state = 6},
  [782] = {.lex_state = 36},
  [783] = {.lex_state = 6},
  [784] = {.lex_state = 37},
  [785] = {.lex_state = 37},
  [786] = {.lex_state = 37},
  [787] = {.lex_state = 37},
  [788] = {.lex_state = 6},
  [789] = {.lex_state = 6},
  [790] = {.lex_state = 6},
  [791] = {.lex_state = 37},
  [792] = {.lex_state = 6},
  [793] = {.lex_state = 37},
  [794] = {.lex_state = 37},
  [795] = {.lex_state = 6},
  [796] = {.lex_state = 36},
  [797] = {.lex_state = 36},
  [798] = {.lex_state = 6},
  [799] = {.lex_state = 6},
  [800] = {.lex_state = 37},
  [801] = {.lex_state = 6},
  [802] = {.lex_state = 37},
  [803] = {.lex_state = 35},
  [804] = {.lex_state = 36},
  [805] = {.lex_state = 36},
  [806] = {.lex_state = 36},
  [807] = {.lex_state = 36},
  [808] = {.lex_state = 36},
  [809] = {.lex_state = 36},
  [810] = {.lex_state = 36},
  [811] = {.lex_state = 6},
  [812] = {.lex_state = 36},
  [813] = {.lex_state = 36},
  [814] = {.lex_state = 36},
  [815] = {.lex_state = 36},
  [816] = {.lex_state = 36},
  [817] = {.lex_state = 36},
  [818] = {.lex_state = 36},
  [819] = {.lex_state = 37},
  [820] = {.lex_state = 37},
  [821] = {.lex_state = 36},
  [822] = {.lex_state = 36},
  [823] = {.lex_state = 36},
  [824] = {.lex_state = 36},
  [825] = {.lex_state = 36},
  [826] = {.lex_state = 36},
  [827] = {.lex_state = 36},
  [828] = {.lex_state = 36},
  [829] = {.lex_state = 6},
  [830] = {.lex_state = 6},
  [831] = {.lex_state = 6},
  [832] = {.lex_state = 6},
  [833] = {.lex_state = 6},
  [834] = {.lex_state = 6},
  [835] = {.lex_state = 6},
  [836] = {.lex_state = 6},
  [837] = {.lex_state = 6},
  [838] = {.lex_state = 6},
  [839] = {.lex_state = 6},
  [840] = {.lex_state = 35},
  [841] = {.lex_state = 6},
  [842] = {.lex_state = 6},
  [843] = {.lex_state = 6},
  [844] = {.lex_state = 6},
  [845] = {.lex_state = 6},
  [846] = {.lex_state = 6},
  [847] = {.lex_state = 6},
  [848] = {.lex_state = 36},
  [849] = {.lex_state = 36},
  [850] = {.lex_state = 36},
  [851] = {.lex_state = 36},
  [852] = {.lex_state = 36},
  [853] = {.lex_state = 36},
  [854] = {.lex_state = 36},
  [855] = {.lex_state = 36},
  [856] = {.lex_state = 36},
  [857] = {.lex_state = 36},
  [858] = {.lex_state = 36},
  [859] = {.lex_state = 36},
  [860] = {.lex_state = 36},
  [861] = {.lex_state = 36},
  [862] = {.lex_state = 36},
  [863] = {.lex_state = 35},
  [864] = {.lex_state = 22},
  [865] = {.lex_state = 36},
  [866] = {.lex_state = 6},
  [867] = {.lex_state = 35},
  [868] = {.lex_state = 6},
  [869] = {.lex_state = 35},
  [870] = {.lex_state = 35},
  [871] = {.lex_state = 6},
  [872] = {.lex_state = 35},
  [873] = {.lex_state = 38},
  [874] = {.lex_state = 6},
  [875] = {.lex_state = 6},
  [876] = {.lex_state = 36},
  [877] = {.lex_state = 16, .external_lex_state = 2},
  [878] = {.lex_state = 12, .external_lex_state = 2},
  [879] = {.lex_state = 37},
  [880] = {.lex_state = 37},
  [881] = {.lex_state = 37},
  [882] = {.lex_state = 13, .external_lex_state = 2},
  [883] = {.lex_state = 35},
  [884] = {.lex_state = 36},
  [885] = {.lex_state = 36},
  [886] = {.lex_state = 22},
  [887] = {.lex_state = 37},
  [888] = {.lex_state = 37},
  [889] = {.lex_state = 36},
  [890] = {.lex_state = 35},
  [891] = {.lex_state = 35},
  [892] = {.lex_state = 35},
  [893] = {.lex_state = 35},
  [894] = {.lex_state = 35},
  [895] = {.lex_state = 35},
  [896] = {.lex_state = 35},
  [897] = {.lex_state = 22},
  [898] = {.lex_state = 35},
  [899] = {.lex_state = 35},
  [900] = {.lex_state = 35},
  [901] = {.lex_state = 35},
  [902] = {.lex_state = 22},
  [903] = {.lex_state = 35},
  [904] = {.lex_state = 22},
  [905] = {.lex_state = 36},
  [906] = {.lex_state = 35},
  [907] = {.lex_state = 35},
  [908] = {.lex_state = 13},
  [909] = {.lex_state = 35},
  [910] = {.lex_state = 35},
  [911] = {.lex_state = 35},
  [912] = {.lex_state = 35},
  [913] = {.lex_state = 37},
  [914] = {.lex_state = 35},
  [915] = {.lex_state = 37},
  [916] = {.lex_state = 37},
  [917] = {.lex_state = 35},
  [918] = {.lex_state = 35},
  [919] = {.lex_state = 35},
  [920] = {.lex_state = 35},
  [921] = {.lex_state = 35},
  [922] = {.lex_state = 35},
  [923] = {.lex_state = 35},
  [924] = {.lex_state = 35},
  [925] = {.lex_state = 35},
  [926] = {.lex_state = 35},
  [927] = {.lex_state = 35},
  [928] = {.lex_state = 35},
  [929] = {.lex_state = 35},
  [930] = {.lex_state = 35},
  [931] = {.lex_state = 35},
  [932] = {.lex_state = 6},
  [933] = {.lex_state = 35},
  [934] = {.lex_state = 35},
  [935] = {.lex_state = 35},
  [936] = {.lex_state = 35},
  [937] = {.lex_state = 35},
  [938] = {.lex_state = 35},
  [939] = {.lex_state = 35},
  [940] = {.lex_state = 22},
  [941] = {.lex_state = 36},
  [942] = {.lex_state = 37},
  [943] = {.lex_state = 6},
  [944] = {.lex_state = 6},
  [945] = {.lex_state = 22},
  [946] = {.lex_state = 36},
  [947] = {.lex_state = 35},
  [948] = {.lex_state = 35},
  [949] = {.lex_state = 35},
  [950] = {.lex_state = 37},
  [951] = {.lex_state = 35},
  [952] = {.lex_state = 35},
  [953] = {.lex_state = 35},
  [954] = {.lex_state = 35},
  [955] = {.lex_state = 35},
  [956] = {.lex_state = 35},
  [957] = {.lex_state = 35},
  [958] = {.lex_state = 35},
  [959] = {.lex_state = 35},
  [960] = {.lex_state = 35},
  [961] = {.lex_state = 35},
  [962] = {.lex_state = 35},
  [963] = {.lex_state = 35},
  [964] = {.lex_state = 22},
  [965] = {.lex_state = 35},
  [966] = {.lex_state = 35},
  [967] = {.lex_state = 22},
  [968] = {.lex_state = 37},
  [969] = {.lex_state = 35},
  [970] = {.lex_state = 35},
  [971] = {.lex_state = 35},
  [972] = {.lex_state = 36},
  [973] = {.lex_state = 6},
  [974] = {.lex_state = 35},
  [975] = {.lex_state = 35},
  [976] = {.lex_state = 12},
  [977] = {.lex_state = 35},
  [978] = {.lex_state = 35},
  [979] = {.lex_state = 35},
  [980] = {.lex_state = 35},
  [981] = {.lex_state = 35},
  [982] = {.lex_state = 35},
  [983] = {.lex_state = 35},
  [984] = {.lex_state = 35},
  [985] = {.lex_state = 35},
  [986] = {.lex_state = 35},
  [987] = {.lex_state = 35},
  [988] = {.lex_state = 35},
  [989] = {.lex_state = 35},
  [990] = {.lex_state = 35},
  [991] = {.lex_state = 6},
  [992] = {.lex_state = 35},
  [993] = {.lex_state = 35},
  [994] = {.lex_state = 36},
  [995] = {.lex_state = 35},
  [996] = {.lex_state = 35},
  [997] = {.lex_state = 35},
  [998] = {.lex_state = 35},
  [999] = {.lex_state = 35},
  [1000] = {.lex_state = 35},
  [1001] = {.lex_state = 35},
  [1002] = {.lex_state = 35},
  [1003] = {.lex_state = 35},
  [1004] = {.lex_state = 35},
  [1005] = {.lex_state = 35},
  [1006] = {.lex_state = 35},
  [1007] = {.lex_state = 35},
  [1008] = {.lex_state = 35},
  [1009] = {.lex_state = 35},
  [1010] = {.lex_state = 35},
  [1011] = {.lex_state = 35},
  [1012] = {.lex_state = 16},
  [1013] = {.lex_state = 6},
  [1014] = {.lex_state = 35},
  [1015] = {.lex_state = 35},
  [1016] = {.lex_state = 35},
  [1017] = {.lex_state = 22},
  [1018] = {.lex_state = 35},
  [1019] = {.lex_state = 35},
  [1020] = {.lex_state = 35},
  [1021] = {.lex_state = 35},
  [1022] = {.lex_state = 35},
  [1023] = {.lex_state = 35},
  [1024] = {.lex_state = 35},
  [1025] = {.lex_state = 35},
  [1026] = {.lex_state = 22},
  [1027] = {.lex_state = 22},
  [1028] = {.lex_state = 35},
  [1029] = {.lex_state = 35},
  [1030] = {.lex_state = 35},
  [1031] = {.lex_state = 36},
  [1032] = {.lex_state = 35},
  [1033] = {.lex_state = 35},
  [1034] = {.lex_state = 35},
  [1035] = {.lex_state = 35},
  [1036] = {.lex_state = 35},
  [1037] = {.lex_state = 35},
  [1038] = {.lex_state = 22},
  [1039] = {.lex_state = 6},
  [1040] = {.lex_state = 35},
  [1041] = {.lex_state = 35},
  [1042] = {.lex_state = 35},
  [1043] = {.lex_state = 35},
  [1044] = {.lex_state = 35},
  [1045] = {.lex_state = 35},
  [1046] = {.lex_state = 35},
  [1047] = {.lex_state = 35},
  [1048] = {.lex_state = 35},
  [1049] = {.lex_state = 35},
  [1050] = {.lex_state = 35},
  [1051] = {.lex_state = 35},
  [1052] = {.lex_state = 35},
  [1053] = {.lex_state = 35},
  [1054] = {.lex_state = 35},
  [1055] = {.lex_state = 35},
  [1056] = {.lex_state = 36},
  [1057] = {.lex_state = 37},
  [1058] = {.lex_state = 6},
  [1059] = {.lex_state = 6},
  [1060] = {.lex_state = 6},
  [1061] = {.lex_state = 6},
  [1062] = {.lex_state = 6},
  [1063] = {.lex_state = 6},
  [1064] = {.lex_state = 6},
  [1065] = {.lex_state = 6},
  [1066] = {.lex_state = 6},
  [1067] = {.lex_state = 6},
  [1068] = {.lex_state = 6},
  [1069] = {.lex_state = 6},
  [1070] = {.lex_state = 6},
  [1071] = {.lex_state = 6},
  [1072] = {.lex_state = 6},
  [1073] = {.lex_state = 36},
  [1074] = {.lex_state = 6},
  [1075] = {.lex_state = 6},
  [1076] = {.lex_state = 6},
  [1077] = {.lex_state = 6},
  [1078] = {.lex_state = 6},
  [1079] = {.lex_state = 6},
  [1080] = {.lex_state = 6},
  [1081] = {.lex_state = 6},
  [1082] = {.lex_state = 6},
  [1083] = {.lex_state = 6},
  [1084] = {.lex_state = 6},
  [1085] = {.lex_state = 6},
  [1086] = {.lex_state = 6},
  [1087] = {.lex_state = 6},
  [1088] = {.lex_state = 6},
  [1089] = {.lex_state = 6},
  [1090] = {.lex_state = 6},
  [1091] = {.lex_state = 6},
  [1092] = {.lex_state = 6},
  [1093] = {.lex_state = 6},
  [1094] = {.lex_state = 6},
  [1095] = {.lex_state = 6},
  [1096] = {.lex_state = 6},
  [1097] = {.lex_state = 6},
  [1098] = {.lex_state = 6},
  [1099] = {.lex_state = 6},
  [1100] = {.lex_state = 6},
  [1101] = {.lex_state = 6},
  [1102] = {.lex_state = 6},
  [1103] = {.lex_state = 6},
  [1104] = {.lex_state = 6},
  [1105] = {.lex_state = 6},
  [1106] = {.lex_state = 6},
  [1107] = {.lex_state = 6},
  [1108] = {.lex_state = 6},
  [1109] = {.lex_state = 6},
  [1110] = {.lex_state = 6},
  [1111] = {.lex_state = 6},
  [1112] = {.lex_state = 6},
  [1113] = {.lex_state = 6},
  [1114] = {.lex_state = 6},
  [1115] = {.lex_state = 6},
  [1116] = {.lex_state = 6},
  [1117] = {.lex_state = 6},
  [1118] = {.lex_state = 6},
  [1119] = {.lex_state = 6},
  [1120] = {.lex_state = 6},
  [1121] = {.lex_state = 6},
  [1122] = {.lex_state = 6},
  [1123] = {.lex_state = 6},
  [1124] = {.lex_state = 6},
  [1125] = {.lex_state = 6},
  [1126] = {.lex_state = 6},
  [1127] = {.lex_state = 6},
  [1128] = {.lex_state = 36},
  [1129] = {.lex_state = 36},
  [1130] = {.lex_state = 36},
  [1131] = {.lex_state = 36},
  [1132] = {.lex_state = 36},
  [1133] = {.lex_state = 36},
  [1134] = {.lex_state = 36},
  [1135] = {.lex_state = 36},
  [1136] = {.lex_state = 36},
  [1137] = {.lex_state = 36},
  [1138] = {.lex_state = 36},
  [1139] = {.lex_state = 37},
  [1140] = {.lex_state = 36},
  [1141] = {.lex_state = 36},
  [1142] = {.lex_state = 36},
  [1143] = {.lex_state = 36},
  [1144] = {.lex_state = 36},
  [1145] = {.lex_state = 36},
  [1146] = {.lex_state = 36},
  [1147] = {.lex_state = 36},
  [1148] = {.lex_state = 36},
  [1149] = {.lex_state = 36},
  [1150] = {.lex_state = 36},
  [1151] = {.lex_state = 6},
  [1152] = {.lex_state = 36},
  [1153] = {.lex_state = 36},
  [1154] = {.lex_state = 36},
  [1155] = {.lex_state = 6},
  [1156] = {.lex_state = 6},
  [1157] = {.lex_state = 6},
  [1158] = {.lex_state = 6},
  [1159] = {.lex_state = 6},
  [1160] = {.lex_state = 6},
  [1161] = {.lex_state = 6},
  [1162] = {.lex_state = 6},
  [1163] = {.lex_state = 6},
  [1164] = {.lex_state = 6},
  [1165] = {.lex_state = 6},
  [1166] = {.lex_state = 6},
  [1167] = {.lex_state = 36},
  [1168] = {.lex_state = 36},
  [1169] = {.lex_state = 36},
  [1170] = {.lex_state = 36},
  [1171] = {.lex_state = 6},
  [1172] = {.lex_state = 36},
  [1173] = {.lex_state = 36},
  [1174] = {.lex_state = 36},
  [1175] = {.lex_state = 36},
  [1176] = {.lex_state = 6},
  [1177] = {.lex_state = 6},
  [1178] = {.lex_state = 6},
  [1179] = {.lex_state = 6},
  [1180] = {.lex_state = 6},
  [1181] = {.lex_state = 6},
  [1182] = {.lex_state = 6},
  [1183] = {.lex_state = 6},
  [1184] = {.lex_state = 6},
  [1185] = {.lex_state = 36},
  [1186] = {.lex_state = 36},
  [1187] = {.lex_state = 6},
  [1188] = {.lex_state = 6},
  [1189] = {.lex_state = 6},
  [1190] = {.lex_state = 6},
  [1191] = {.lex_state = 6},
  [1192] = {.lex_state = 36},
  [1193] = {.lex_state = 6},
  [1194] = {.lex_state = 6},
  [1195] = {.lex_state = 36},
  [1196] = {.lex_state = 36},
  [1197] = {.lex_state = 36},
  [1198] = {.lex_state = 37},
  [1199] = {.lex_state = 36},
  [1200] = {.lex_state = 36},
  [1201] = {.lex_state = 36},
  [1202] = {.lex_state = 36},
  [1203] = {.lex_state = 36},
  [1204] = {.lex_state = 36},
  [1205] = {.lex_state = 6},
  [1206] = {.lex_state = 6},
  [1207] = {.lex_state = 6},
  [1208] = {.lex_state = 6},
  [1209] = {.lex_state = 6},
  [1210] = {.lex_state = 6},
  [1211] = {.lex_state = 6},
  [1212] = {.lex_state = 6},
  [1213] = {.lex_state = 6},
  [1214] = {.lex_state = 6},
  [1215] = {.lex_state = 6},
  [1216] = {.lex_state = 6},
  [1217] = {.lex_state = 36},
  [1218] = {.lex_state = 6},
  [1219] = {.lex_state = 36},
  [1220] = {.lex_state = 6},
  [1221] = {.lex_state = 6},
  [1222] = {.lex_state = 6},
  [1223] = {.lex_state = 6},
  [1224] = {.lex_state = 6},
  [1225] = {.lex_state = 6},
  [1226] = {.lex_state = 6},
  [1227] = {.lex_state = 6},
  [1228] = {.lex_state = 6},
  [1229] = {.lex_state = 6},
  [1230] = {.lex_state = 37},
  [1231] = {.lex_state = 36},
  [1232] = {.lex_state = 36},
  [1233] = {.lex_state = 37},
  [1234] = {.lex_state = 37},
  [1235] = {.lex_state = 37},
  [1236] = {.lex_state = 37},
  [1237] = {.lex_state = 36},
  [1238] = {.lex_state = 37},
  [1239] = {.lex_state = 37},
  [1240] = {.lex_state = 37},
  [1241] = {.lex_state = 37},
  [1242] = {.lex_state = 37},
  [1243] = {.lex_state = 37},
  [1244] = {.lex_state = 37},
  [1245] = {.lex_state = 36},
  [1246] = {.lex_state = 37},
  [1247] = {.lex_state = 36},
  [1248] = {.lex_state = 36},
  [1249] = {.lex_state = 36},
  [1250] = {.lex_state = 36},
  [1251] = {.lex_state = 36},
  [1252] = {.lex_state = 36},
  [1253] = {.lex_state = 36},
  [1254] = {.lex_state = 36},
  [1255] = {.lex_state = 36},
  [1256] = {.lex_state = 36},
  [1257] = {.lex_state = 36},
  [1258] = {.lex_state = 36},
  [1259] = {.lex_state = 37},
  [1260] = {.lex_state = 37},
  [1261] = {.lex_state = 36},
  [1262] = {.lex_state = 36},
  [1263] = {.lex_state = 36},
  [1264] = {.lex_state = 36},
  [1265] = {.lex_state = 36},
  [1266] = {.lex_state = 36},
  [1267] = {.lex_state = 36},
  [1268] = {.lex_state = 36},
  [1269] = {.lex_state = 36},
  [1270] = {.lex_state = 37},
  [1271] = {.lex_state = 37},
  [1272] = {.lex_state = 37},
  [1273] = {.lex_state = 36},
  [1274] = {.lex_state = 37},
  [1275] = {.lex_state = 36},
  [1276] = {.lex_state = 37},
  [1277] = {.lex_state = 37},
  [1278] = {.lex_state = 37},
  [1279] = {.lex_state = 37},
  [1280] = {.lex_state = 37},
  [1281] = {.lex_state = 37},
  [1282] = {.lex_state = 37},
  [1283] = {.lex_state = 37},
  [1284] = {.lex_state = 37},
  [1285] = {.lex_state = 37},
  [1286] = {.lex_state = 37},
  [1287] = {.lex_state = 37},
  [1288] = {.lex_state = 37},
  [1289] = {.lex_state = 37},
  [1290] = {.lex_state = 37},
  [1291] = {.lex_state = 37},
  [1292] = {.lex_state = 37},
  [1293] = {.lex_state = 37},
  [1294] = {.lex_state = 37},
  [1295] = {.lex_state = 37},
  [1296] = {.lex_state = 37},
  [1297] = {.lex_state = 37},
  [1298] = {.lex_state = 22},
  [1299] = {.lex_state = 37},
  [1300] = {.lex_state = 37},
  [1301] = {.lex_state = 37},
  [1302] = {.lex_state = 37},
  [1303] = {.lex_state = 36},
  [1304] = {.lex_state = 36},
  [1305] = {.lex_state = 36},
  [1306] = {.lex_state = 36},
  [1307] = {.lex_state = 36},
  [1308] = {.lex_state = 36},
  [1309] = {.lex_state = 36},
  [1310] = {.lex_state = 36},
  [1311] = {.lex_state = 36},
  [1312] = {.lex_state = 36},
  [1313] = {.lex_state = 36},
  [1314] = {.lex_state = 36},
  [1315] = {.lex_state = 36},
  [1316] = {.lex_state = 36},
  [1317] = {.lex_state = 37},
  [1318] = {.lex_state = 36},
  [1319] = {.lex_state = 36},
  [1320] = {.lex_state = 36},
  [1321] = {.lex_state = 36},
  [1322] = {.lex_state = 36},
  [1323] = {.lex_state = 36},
  [1324] = {.lex_state = 36},
  [1325] = {.lex_state = 36},
  [1326] = {.lex_state = 36},
  [1327] = {.lex_state = 36},
  [1328] = {.lex_state = 36},
  [1329] = {.lex_state = 37},
  [1330] = {.lex_state = 37},
  [1331] = {.lex_state = 36},
  [1332] = {.lex_state = 36},
  [1333] = {.lex_state = 36},
  [1334] = {.lex_state = 36},
  [1335] = {.lex_state = 36},
  [1336] = {.lex_state = 36},
  [1337] = {.lex_state = 36},
  [1338] = {.lex_state = 36},
  [1339] = {.lex_state = 36},
  [1340] = {.lex_state = 36},
  [1341] = {.lex_state = 37},
  [1342] = {.lex_state = 36},
  [1343] = {.lex_state = 37},
  [1344] = {.lex_state = 36},
  [1345] = {.lex_state = 37},
  [1346] = {.lex_state = 36},
  [1347] = {.lex_state = 37},
  [1348] = {.lex_state = 22},
  [1349] = {.lex_state = 37},
  [1350] = {.lex_state = 37},
  [1351] = {.lex_state = 37},
  [1352] = {.lex_state = 37},
  [1353] = {.lex_state = 37},
  [1354] = {.lex_state = 37},
  [1355] = {.lex_state = 37},
  [1356] = {.lex_state = 37},
  [1357] = {.lex_state = 6},
  [1358] = {.lex_state = 37},
  [1359] = {.lex_state = 37},
  [1360] = {.lex_state = 37},
  [1361] = {.lex_state = 37},
  [1362] = {.lex_state = 37},
  [1363] = {.lex_state = 37},
  [1364] = {.lex_state = 37},
  [1365] = {.lex_state = 6},
  [1366] = {.lex_state = 37},
  [1367] = {.lex_state = 22},
  [1368] = {.lex_state = 37},
  [1369] = {.lex_state = 37},
  [1370] = {.lex_state = 37},
  [1371] = {.lex_state = 22},
  [1372] = {.lex_state = 37},
  [1373] = {.lex_state = 36},
  [1374] = {.lex_state = 37},
  [1375] = {.lex_state = 36},
  [1376] = {.lex_state = 36},
  [1377] = {.lex_state = 36},
  [1378] = {.lex_state = 36},
  [1379] = {.lex_state = 36},
  [1380] = {.lex_state = 36},
  [1381] = {.lex_state = 36},
  [1382] = {.lex_state = 36},
  [1383] = {.lex_state = 36},
  [1384] = {.lex_state = 36},
  [1385] = {.lex_state = 36},
  [1386] = {.lex_state = 36},
  [1387] = {.lex_state = 36},
  [1388] = {.lex_state = 36},
  [1389] = {.lex_state = 36},
  [1390] = {.lex_state = 36},
  [1391] = {.lex_state = 36},
  [1392] = {.lex_state = 36},
  [1393] = {.lex_state = 37},
  [1394] = {.lex_state = 37},
  [1395] = {.lex_state = 37},
  [1396] = {.lex_state = 37},
  [1397] = {.lex_state = 37},
  [1398] = {.lex_state = 37},
  [1399] = {.lex_state = 37},
  [1400] = {.lex_state = 37},
  [1401] = {.lex_state = 37},
  [1402] = {.lex_state = 37},
  [1403] = {.lex_state = 37},
  [1404] = {.lex_state = 37},
  [1405] = {.lex_state = 37},
  [1406] = {.lex_state = 37},
  [1407] = {.lex_state = 37},
  [1408] = {.lex_state = 37},
  [1409] = {.lex_state = 37},
  [1410] = {.lex_state = 37},
  [1411] = {.lex_state = 37},
  [1412] = {.lex_state = 37},
  [1413] = {.lex_state = 37},
  [1414] = {.lex_state = 22},
  [1415] = {.lex_state = 6},
  [1416] = {.lex_state = 6},
  [1417] = {.lex_state = 6},
  [1418] = {.lex_state = 37},
  [1419] = {.lex_state = 6},
  [1420] = {.lex_state = 6},
  [1421] = {.lex_state = 6},
  [1422] = {.lex_state = 6},
  [1423] = {.lex_state = 37},
  [1424] = {.lex_state = 37},
  [1425] = {.lex_state = 37},
  [1426] = {.lex_state = 37},
  [1427] = {.lex_state = 37},
  [1428] = {.lex_state = 37},
  [1429] = {.lex_state = 37},
  [1430] = {.lex_state = 37},
  [1431] = {.lex_state = 6},
  [1432] = {.lex_state = 6},
  [1433] = {.lex_state = 37},
  [1434] = {.lex_state = 37},
  [1435] = {.lex_state = 37},
  [1436] = {.lex_state = 37},
  [1437] = {.lex_state = 37},
  [1438] = {.lex_state = 37},
  [1439] = {.lex_state = 37},
  [1440] = {.lex_state = 37},
  [1441] = {.lex_state = 37},
  [1442] = {.lex_state = 37},
  [1443] = {.lex_state = 37},
  [1444] = {.lex_state = 37},
  [1445] = {.lex_state = 37},
  [1446] = {.lex_state = 37},
  [1447] = {.lex_state = 37},
  [1448] = {.lex_state = 37},
  [1449] = {.lex_state = 37},
  [1450] = {.lex_state = 37},
  [1451] = {.lex_state = 37},
  [1452] = {.lex_state = 37},
  [1453] = {.lex_state = 37},
  [1454] = {.lex_state = 22},
  [1455] = {.lex_state = 37},
  [1456] = {.lex_state = 22},
  [1457] = {.lex_state = 37},
  [1458] = {.lex_state = 22},
  [1459] = {.lex_state = 6},
  [1460] = {.lex_state = 37},
  [1461] = {.lex_state = 37},
  [1462] = {.lex_state = 37},
  [1463] = {.lex_state = 22},
  [1464] = {.lex_state = 6},
  [1465] = {.lex_state = 22},
  [1466] = {.lex_state = 37},
  [1467] = {.lex_state = 22},
  [1468] = {.lex_state = 6},
  [1469] = {.lex_state = 22},
  [1470] = {.lex_state = 22},
  [1471] = {.lex_state = 22},
  [1472] = {.lex_state = 22},
  [1473] = {.lex_state = 22},
  [1474] = {.lex_state = 22},
  [1475] = {.lex_state = 22},
  [1476] = {.lex_state = 22},
  [1477] = {.lex_state = 22},
  [1478] = {.lex_state = 22},
  [1479] = {.lex_state = 22},
  [1480] = {.lex_state = 22},
  [1481] = {.lex_state = 22},
  [1482] = {.lex_state = 22},
  [1483] = {.lex_state = 22},
  [1484] = {.lex_state = 22},
  [1485] = {.lex_state = 22},
  [1486] = {.lex_state = 22},
  [1487] = {.lex_state = 22},
  [1488] = {.lex_state = 22},
  [1489] = {.lex_state = 22},
  [1490] = {.lex_state = 22},
  [1491] = {.lex_state = 22},
  [1492] = {.lex_state = 8},
  [1493] = {.lex_state = 8},
  [1494] = {.lex_state = 8},
  [1495] = {.lex_state = 8},
  [1496] = {.lex_state = 8},
  [1497] = {.lex_state = 17, .external_lex_state = 2},
  [1498] = {.lex_state = 8},
  [1499] = {.lex_state = 8},
  [1500] = {.lex_state = 11},
  [1501] = {.lex_state = 11},
  [1502] = {.lex_state = 18, .external_lex_state = 2},
  [1503] = {.lex_state = 11},
  [1504] = {.lex_state = 11},
  [1505] = {.lex_state = 17},
  [1506] = {.lex_state = 11},
  [1507] = {.lex_state = 8},
  [1508] = {.lex_state = 8},
  [1509] = {.lex_state = 14},
  [1510] = {.lex_state = 14},
  [1511] = {.lex_state = 14},
  [1512] = {.lex_state = 14},
  [1513] = {.lex_state = 14},
  [1514] = {.lex_state = 8},
  [1515] = {.lex_state = 19, .external_lex_state = 2},
  [1516] = {.lex_state = 8},
  [1517] = {.lex_state = 11},
  [1518] = {.lex_state = 8},
  [1519] = {.lex_state = 8},
  [1520] = {.lex_state = 8},
  [1521] = {.lex_state = 8},
  [1522] = {.lex_state = 8},
  [1523] = {.lex_state = 8},
  [1524] = {.lex_state = 8},
  [1525] = {.lex_state = 8},
  [1526] = {.lex_state = 8},
  [1527] = {.lex_state = 8},
  [1528] = {.lex_state = 8},
  [1529] = {.lex_state = 8},
  [1530] = {.lex_state = 8},
  [1531] = {.lex_state = 8},
  [1532] = {.lex_state = 8},
  [1533] = {.lex_state = 8},
  [1534] = {.lex_state = 8},
  [1535] = {.lex_state = 8},
  [1536] = {.lex_state = 8},
  [1537] = {.lex_state = 8},
  [1538] = {.lex_state = 8},
  [1539] = {.lex_state = 8},
  [1540] = {.lex_state = 8},
  [1541] = {.lex_state = 8},
  [1542] = {.lex_state = 8},
  [1543] = {.lex_state = 8},
  [1544] = {.lex_state = 8},
  [1545] = {.lex_state = 8},
  [1546] = {.lex_state = 8},
  [1547] = {.lex_state = 8},
  [1548] = {.lex_state = 8},
  [1549] = {.lex_state = 8},
  [1550] = {.lex_state = 8},
  [1551] = {.lex_state = 8},
  [1552] = {.lex_state = 8},
  [1553] = {.lex_state = 8},
  [1554] = {.lex_state = 8},
  [1555] = {.lex_state = 8},
  [1556] = {.lex_state = 8},
  [1557] = {.lex_state = 8},
  [1558] = {.lex_state = 8},
  [1559] = {.lex_state = 8},
  [1560] = {.lex_state = 8},
  [1561] = {.lex_state = 8},
  [1562] = {.lex_state = 8},
  [1563] = {.lex_state = 8},
  [1564] = {.lex_state = 8},
  [1565] = {.lex_state = 8},
  [1566] = {.lex_state = 8},
  [1567] = {.lex_state = 8},
  [1568] = {.lex_state = 11},
  [1569] = {.lex_state = 8},
  [1570] = {.lex_state = 8},
  [1571] = {.lex_state = 8},
  [1572] = {.lex_state = 8},
  [1573] = {.lex_state = 8},
  [1574] = {.lex_state = 8},
  [1575] = {.lex_state = 8},
  [1576] = {.lex_state = 8},
  [1577] = {.lex_state = 8},
  [1578] = {.lex_state = 8},
  [1579] = {.lex_state = 8},
  [1580] = {.lex_state = 8},
  [1581] = {.lex_state = 8},
  [1582] = {.lex_state = 19},
  [1583] = {.lex_state = 8},
  [1584] = {.lex_state = 8},
  [1585] = {.lex_state = 8},
  [1586] = {.lex_state = 8},
  [1587] = {.lex_state = 8},
  [1588] = {.lex_state = 8},
  [1589] = {.lex_state = 11},
  [1590] = {.lex_state = 8},
  [1591] = {.lex_state = 14},
  [1592] = {.lex_state = 8},
  [1593] = {.lex_state = 8},
  [1594] = {.lex_state = 8},
  [1595] = {.lex_state = 8},
  [1596] = {.lex_state = 8},
  [1597] = {.lex_state = 8},
  [1598] = {.lex_state = 8},
  [1599] = {.lex_state = 8},
  [1600] = {.lex_state = 14},
  [1601] = {.lex_state = 8},
  [1602] = {.lex_state = 8},
  [1603] = {.lex_state = 8},
  [1604] = {.lex_state = 8},
  [1605] = {.lex_state = 8},
  [1606] = {.lex_state = 11},
  [1607] = {.lex_state = 8},
  [1608] = {.lex_state = 8},
  [1609] = {.lex_state = 8},
  [1610] = {.lex_state = 8},
  [1611] = {.lex_state = 8},
  [1612] = {.lex_state = 8},
  [1613] = {.lex_state = 8},
  [1614] = {.lex_state = 8},
  [1615] = {.lex_state = 8},
  [1616] = {.lex_state = 8},
  [1617] = {.lex_state = 8},
  [1618] = {.lex_state = 14},
  [1619] = {.lex_state = 14},
  [1620] = {.lex_state = 8},
  [1621] = {.lex_state = 8},
  [1622] = {.lex_state = 14},
  [1623] = {.lex_state = 8},
  [1624] = {.lex_state = 8},
  [1625] = {.lex_state = 8},
  [1626] = {.lex_state = 8},
  [1627] = {.lex_state = 8},
  [1628] = {.lex_state = 8},
  [1629] = {.lex_state = 8},
  [1630] = {.lex_state = 18},
  [1631] = {.lex_state = 8},
  [1632] = {.lex_state = 11},
  [1633] = {.lex_state = 8},
  [1634] = {.lex_state = 8},
  [1635] = {.lex_state = 8},
  [1636] = {.lex_state = 8},
  [1637] = {.lex_state = 8},
  [1638] = {.lex_state = 8},
  [1639] = {.lex_state = 8},
  [1640] = {.lex_state = 8},
  [1641] = {.lex_state = 8},
  [1642] = {.lex_state = 8},
  [1643] = {.lex_state = 8},
  [1644] = {.lex_state = 8},
  [1645] = {.lex_state = 8},
  [1646] = {.lex_state = 8},
  [1647] = {.lex_state = 8},
  [1648] = {.lex_state = 8},
  [1649] = {.lex_state = 8},
  [1650] = {.lex_state = 11},
  [1651] = {.lex_state = 11},
  [1652] = {.lex_state = 11},
  [1653] = {.lex_state = 11},
  [1654] = {.lex_state = 14},
  [1655] = {.lex_state = 14},
  [1656] = {.lex_state = 14},
  [1657] = {.lex_state = 11},
  [1658] = {.lex_state = 11},
  [1659] = {.lex_state = 11},
  [1660] = {.lex_state = 14},
  [1661] = {.lex_state = 14},
  [1662] = {.lex_state = 11},
  [1663] = {.lex_state = 14},
  [1664] = {.lex_state = 11},
  [1665] = {.lex_state = 14},
  [1666] = {.lex_state = 14},
  [1667] = {.lex_state = 14},
  [1668] = {.lex_state = 14},
  [1669] = {.lex_state = 14},
  [1670] = {.lex_state = 14},
  [1671] = {.lex_state = 14},
  [1672] = {.lex_state = 11},
  [1673] = {.lex_state = 14},
  [1674] = {.lex_state = 14},
  [1675] = {.lex_state = 14},
  [1676] = {.lex_state = 14},
  [1677] = {.lex_state = 14},
  [1678] = {.lex_state = 14},
  [1679] = {.lex_state = 14},
  [1680] = {.lex_state = 11},
  [1681] = {.lex_state = 14},
  [1682] = {.lex_state = 14},
  [1683] = {.lex_state = 14},
  [1684] = {.lex_state = 14},
  [1685] = {.lex_state = 14},
  [1686] = {.lex_state = 11},
  [1687] = {.lex_state = 11},
  [1688] = {.lex_state = 14},
  [1689] = {.lex_state = 14},
  [1690] = {.lex_state = 14},
  [1691] = {.lex_state = 11},
  [1692] = {.lex_state = 11},
  [1693] = {.lex_state = 11},
  [1694] = {.lex_state = 11},
  [1695] = {.lex_state = 11},
  [1696] = {.lex_state = 11},
  [1697] = {.lex_state = 11},
  [1698] = {.lex_state = 11},
  [1699] = {.lex_state = 11},
  [1700] = {.lex_state = 11},
  [1701] = {.lex_state = 11},
  [1702] = {.lex_state = 11},
  [1703] = {.lex_state = 11},
  [1704] = {.lex_state = 11},
  [1705] = {.lex_state = 11},
  [1706] = {.lex_state = 11},
  [1707] = {.lex_state = 11},
  [1708] = {.lex_state = 11},
  [1709] = {.lex_state = 11},
  [1710] = {.lex_state = 11},
  [1711] = {.lex_state = 11},
  [1712] = {.lex_state = 14},
  [1713] = {.lex_state = 14},
  [1714] = {.lex_state = 14},
  [1715] = {.lex_state = 14},
  [1716] = {.lex_state = 14},
  [1717] = {.lex_state = 14},
  [1718] = {.lex_state = 14},
  [1719] = {.lex_state = 11},
  [1720] = {.lex_state = 11},
  [1721] = {.lex_state = 11},
  [1722] = {.lex_state = 14},
  [1723] = {.lex_state = 14},
  [1724] = {.lex_state = 14},
  [1725] = {.lex_state = 14},
  [1726] = {.lex_state = 14},
  [1727] = {.lex_state = 14},
  [1728] = {.lex_state = 14},
  [1729] = {.lex_state = 14},
  [1730] = {.lex_state = 14},
  [1731] = {.lex_state = 11},
  [1732] = {.lex_state = 11},
  [1733] = {.lex_state = 11},
  [1734] = {.lex_state = 11},
  [1735] = {.lex_state = 11},
  [1736] = {.lex_state = 11},
  [1737] = {.lex_state = 11},
  [1738] = {.lex_state = 14},
  [1739] = {.lex_state = 14},
  [1740] = {.lex_state = 14},
  [1741] = {.lex_state = 14},
  [1742] = {.lex_state = 14},
  [1743] = {.lex_state = 11},
  [1744] = {.lex_state = 14},
  [1745] = {.lex_state = 14},
  [1746] = {.lex_state = 14},
  [1747] = {.lex_state = 14},
  [1748] = {.lex_state = 14},
  [1749] = {.lex_state = 14},
  [1750] = {.lex_state = 14},
  [1751] = {.lex_state = 11},
  [1752] = {.lex_state = 14},
  [1753] = {.lex_state = 14},
  [1754] = {.lex_state = 11},
  [1755] = {.lex_state = 14},
  [1756] = {.lex_state = 11},
  [1757] = {.lex_state = 14},
  [1758] = {.lex_state = 11},
  [1759] = {.lex_state = 11},
  [1760] = {.lex_state = 11},
  [1761] = {.lex_state = 14},
  [1762] = {.lex_state = 14},
  [1763] = {.lex_state = 11},
  [1764] = {.lex_state = 14},
  [1765] = {.lex_state = 14},
  [1766] = {.lex_state = 11},
  [1767] = {.lex_state = 11},
  [1768] = {.lex_state = 14},
  [1769] = {.lex_state = 11},
  [1770] = {.lex_state = 14},
  [1771] = {.lex_state = 11},
  [1772] = {.lex_state = 14},
  [1773] = {.lex_state = 14},
  [1774] = {.lex_state = 14},
  [1775] = {.lex_state = 14},
  [1776] = {.lex_state = 14},
  [1777] = {.lex_state = 14},
  [1778] = {.lex_state = 14},
  [1779] = {.lex_state = 14},
  [1780] = {.lex_state = 14},
  [1781] = {.lex_state = 14},
  [1782] = {.lex_state = 14},
  [1783] = {.lex_state = 14},
  [1784] = {.lex_state = 14},
  [1785] = {.lex_state = 11},
  [1786] = {.lex_state = 14},
  [1787] = {.lex_state = 14},
  [1788] = {.lex_state = 14},
  [1789] = {.lex_state = 14},
  [1790] = {.lex_state = 14},
  [1791] = {.lex_state = 20},
  [1792] = {.lex_state = 11},
  [1793] = {.lex_state = 11},
  [1794] = {.lex_state = 11},
  [1795] = {.lex_state = 14},
  [1796] = {.lex_state = 11},
  [1797] = {.lex_state = 14},
  [1798] = {.lex_state = 11},
  [1799] = {.lex_state = 11},
  [1800] = {.lex_state = 11},
  [1801] = {.lex_state = 11},
  [1802] = {.lex_state = 11},
  [1803] = {.lex_state = 11},
  [1804] = {.lex_state = 11},
  [1805] = {.lex_state = 11},
  [1806] = {.lex_state = 11},
  [1807] = {.lex_state = 11},
  [1808] = {.lex_state = 14},
  [1809] = {.lex_state = 11},
  [1810] = {.lex_state = 14},
  [1811] = {.lex_state = 11},
  [1812] = {.lex_state = 11},
  [1813] = {.lex_state = 11},
  [1814] = {.lex_state = 11},
  [1815] = {.lex_state = 11},
  [1816] = {.lex_state = 11},
  [1817] = {.lex_state = 11},
  [1818] = {.lex_state = 11},
  [1819] = {.lex_state = 11},
  [1820] = {.lex_state = 11},
  [1821] = {.lex_state = 11},
  [1822] = {.lex_state = 11},
  [1823] = {.lex_state = 14},
  [1824] = {.lex_state = 11},
  [1825] = {.lex_state = 11},
  [1826] = {.lex_state = 20},
  [1827] = {.lex_state = 14},
  [1828] = {.lex_state = 11},
  [1829] = {.lex_state = 11},
  [1830] = {.lex_state = 11},
  [1831] = {.lex_state = 11},
  [1832] = {.lex_state = 11},
  [1833] = {.lex_state = 11},
  [1834] = {.lex_state = 11},
  [1835] = {.lex_state = 11},
  [1836] = {.lex_state = 11},
  [1837] = {.lex_state = 11},
  [1838] = {.lex_state = 14},
  [1839] = {.lex_state = 11},
  [1840] = {.lex_state = 11},
  [1841] = {.lex_state = 11},
  [1842] = {.lex_state = 11},
  [1843] = {.lex_state = 11},
  [1844] = {.lex_state = 11},
  [1845] = {.lex_state = 11},
  [1846] = {.lex_state = 11},
  [1847] = {.lex_state = 11},
  [1848] = {.lex_state = 11},
  [1849] = {.lex_state = 11},
  [1850] = {.lex_state = 11},
  [1851] = {.lex_state = 11},
  [1852] = {.lex_state = 11},
  [1853] = {.lex_state = 11},
  [1854] = {.lex_state = 11},
  [1855] = {.lex_state = 11},
  [1856] = {.lex_state = 11},
  [1857] = {.lex_state = 11},
  [1858] = {.lex_state = 11},
  [1859] = {.lex_state = 11},
  [1860] = {.lex_state = 11},
  [1861] = {.lex_state = 14},
  [1862] = {.lex_state = 11},
  [1863] = {.lex_state = 11},
  [1864] = {.lex_state = 11},
  [1865] = {.lex_state = 11},
  [1866] = {.lex_state = 11},
  [1867] = {.lex_state = 14},
  [1868] = {.lex_state = 20},
  [1869] = {.lex_state = 14},
  [1870] = {.lex_state = 20},
  [1871] = {.lex_state = 20},
  [1872] = {.lex_state = 20},
  [1873] = {.lex_state = 20},
  [1874] = {.lex_state = 14},
  [1875] = {.lex_state = 21, .external_lex_state = 2},
  [1876] = {.lex_state = 21},
  [1877] = {.lex_state = 20},
  [1878] = {.lex_state = 20},
  [1879] = {.lex_state = 20},
  [1880] = {.lex_state = 20},
  [1881] = {.lex_state = 20},
  [1882] = {.lex_state = 20},
  [1883] = {.lex_state = 20},
  [1884] = {.lex_state = 20},
  [1885] = {.lex_state = 20},
  [1886] = {.lex_state = 20},
  [1887] = {.lex_state = 20},
  [1888] = {.lex_state = 20},
  [1889] = {.lex_state = 20},
  [1890] = {.lex_state = 20},
  [1891] = {.lex_state = 20},
  [1892] = {.lex_state = 20},
  [1893] = {.lex_state = 20},
  [1894] = {.lex_state = 20},
  [1895] = {.lex_state = 20},
  [1896] = {.lex_state = 20},
  [1897] = {.lex_state = 20},
  [1898] = {.lex_state = 20},
  [1899] = {.lex_state = 20},
  [1900] = {.lex_state = 20},
  [1901] = {.lex_state = 20},
  [1902] = {.lex_state = 20},
  [1903] = {.lex_state = 20},
  [1904] = {.lex_state = 20},
  [1905] = {.lex_state = 20},
  [1906] = {.lex_state = 20},
  [1907] = {.lex_state = 20},
  [1908] = {.lex_state = 20},
  [1909] = {.lex_state = 20},
  [1910] = {.lex_state = 20},
  [1911] = {.lex_state = 20},
  [1912] = {.lex_state = 20},
  [1913] = {.lex_state = 20},
  [1914] = {.lex_state = 20},
  [1915] = {.lex_state = 20},
  [1916] = {.lex_state = 20},
  [1917] = {.lex_state = 20},
  [1918] = {.lex_state = 20},
  [1919] = {.lex_state = 20},
  [1920] = {.lex_state = 20},
  [1921] = {.lex_state = 20},
  [1922] = {.lex_state = 20},
  [1923] = {.lex_state = 20},
  [1924] = {.lex_state = 20},
  [1925] = {.lex_state = 20},
  [1926] = {.lex_state = 20},
  [1927] = {.lex_state = 20},
  [1928] = {.lex_state = 20},
  [1929] = {.lex_state = 20},
  [1930] = {.lex_state = 20},
  [1931] = {.lex_state = 20},
  [1932] = {.lex_state = 20},
  [1933] = {.lex_state = 20},
  [1934] = {.lex_state = 20},
  [1935] = {.lex_state = 20},
  [1936] = {.lex_state = 20},
  [1937] = {.lex_state = 20},
  [1938] = {.lex_state = 20},
  [1939] = {.lex_state = 20},
  [1940] = {.lex_state = 20},
  [1941] = {.lex_state = 20},
  [1942] = {.lex_state = 20},
  [1943] = {.lex_state = 20},
  [1944] = {.lex_state = 20},
  [1945] = {.lex_state = 20},
  [1946] = {.lex_state = 20},
  [1947] = {.lex_state = 20},
  [1948] = {.lex_state = 20},
  [1949] = {.lex_state = 20},
  [1950] = {.lex_state = 20},
  [1951] = {.lex_state = 20},
  [1952] = {.lex_state = 20},
  [1953] = {.lex_state = 20},
  [1954] = {.lex_state = 20},
  [1955] = {.lex_state = 20},
  [1956] = {.lex_state = 20},
  [1957] = {.lex_state = 20},
  [1958] = {.lex_state = 20},
  [1959] = {.lex_state = 20},
  [1960] = {.lex_state = 20},
  [1961] = {.lex_state = 20},
  [1962] = {.lex_state = 20},
  [1963] = {.lex_state = 20},
  [1964] = {.lex_state = 20},
  [1965] = {.lex_state = 20},
  [1966] = {.lex_state = 20},
  [1967] = {.lex_state = 20},
  [1968] = {.lex_state = 20},
  [1969] = {.lex_state = 20},
  [1970] = {.lex_state = 20},
  [1971] = {.lex_state = 20},
  [1972] = {.lex_state = 20},
  [1973] = {.lex_state = 20},
  [1974] = {.lex_state = 22},
  [1975] = {.lex_state = 22},
  [1976] = {.lex_state = 22},
  [1977] = {.lex_state = 22},
  [1978] = {.lex_state = 22},
  [1979] = {.lex_state = 23, .external_lex_state = 2},
  [1980] = {.lex_state = 22},
  [1981] = {.lex_state = 22},
  [1982] = {.lex_state = 22},
  [1983] = {.lex_state = 22},
  [1984] = {.lex_state = 22},
  [1985] = {.lex_state = 22},
  [1986] = {.lex_state = 22},
  [1987] = {.lex_state = 22},
  [1988] = {.lex_state = 22},
  [1989] = {.lex_state = 22},
  [1990] = {.lex_state = 23},
  [1991] = {.lex_state = 22},
  [1992] = {.lex_state = 22},
  [1993] = {.lex_state = 22},
  [1994] = {.lex_state = 22},
  [1995] = {.lex_state = 22},
  [1996] = {.lex_state = 22},
  [1997] = {.lex_state = 22},
  [1998] = {.lex_state = 22},
  [1999] = {.lex_state = 22},
  [2000] = {.lex_state = 22},
  [2001] = {.lex_state = 22},
  [2002] = {.lex_state = 22},
  [2003] = {.lex_state = 22},
  [2004] = {.lex_state = 22},
  [2005] = {.lex_state = 22},
  [2006] = {.lex_state = 22},
  [2007] = {.lex_state = 22},
  [2008] = {.lex_state = 22},
  [2009] = {.lex_state = 22},
  [2010] = {.lex_state = 22},
  [2011] = {.lex_state = 22},
  [2012] = {.lex_state = 22},
  [2013] = {.lex_state = 22},
  [2014] = {.lex_state = 22},
  [2015] = {.lex_state = 22},
  [2016] = {.lex_state = 22},
  [2017] = {.lex_state = 22},
  [2018] = {.lex_state = 22},
  [2019] = {.lex_state = 22},
  [2020] = {.lex_state = 22},
  [2021] = {.lex_state = 22},
  [2022] = {.lex_state = 22},
  [2023] = {.lex_state = 22},
  [2024] = {.lex_state = 22},
  [2025] = {.lex_state = 22},
  [2026] = {.lex_state = 22},
  [2027] = {.lex_state = 22},
  [2028] = {.lex_state = 22},
  [2029] = {.lex_state = 22},
  [2030] = {.lex_state = 22},
  [2031] = {.lex_state = 22},
  [2032] = {.lex_state = 22},
  [2033] = {.lex_state = 22},
  [2034] = {.lex_state = 22},
  [2035] = {.lex_state = 22},
  [2036] = {.lex_state = 22},
  [2037] = {.lex_state = 22},
  [2038] = {.lex_state = 22},
  [2039] = {.lex_state = 22},
  [2040] = {.lex_state = 22},
  [2041] = {.lex_state = 22},
  [2042] = {.lex_state = 22},
  [2043] = {.lex_state = 22},
  [2044] = {.lex_state = 22},
  [2045] = {.lex_state = 22},
  [2046] = {.lex_state = 22},
  [2047] = {.lex_state = 22},
  [2048] = {.lex_state = 22},
  [2049] = {.lex_state = 22},
  [2050] = {.lex_state = 22},
  [2051] = {.lex_state = 22},
  [2052] = {.lex_state = 22},
  [2053] = {.lex_state = 22},
  [2054] = {.lex_state = 22},
  [2055] = {.lex_state = 22},
  [2056] = {.lex_state = 22},
  [2057] = {.lex_state = 22},
  [2058] = {.lex_state = 22},
  [2059] = {.lex_state = 22},
  [2060] = {.lex_state = 22},
  [2061] = {.lex_state = 22},
  [2062] = {.lex_state = 22},
  [2063] = {.lex_state = 22},
  [2064] = {.lex_state = 22},
  [2065] = {.lex_state = 22},
  [2066] = {.lex_state = 22},
  [2067] = {.lex_state = 22},
  [2068] = {.lex_state = 22},
  [2069] = {.lex_state = 22},
  [2070] = {.lex_state = 22},
  [2071] = {.lex_state = 22},
  [2072] = {.lex_state = 24},
  [2073] = {.lex_state = 24},
  [2074] = {.lex_state = 24},
  [2075] = {.lex_state = 24},
  [2076] = {.lex_state = 24},
  [2077] = {.lex_state = 24},
  [2078] = {.lex_state = 24},
  [2079] = {.lex_state = 0},
  [2080] = {.lex_state = 25},
  [2081] = {.lex_state = 25},
  [2082] = {.lex_state = 25},
  [2083] = {.lex_state = 25},
  [2084] = {.lex_state = 25},
  [2085] = {.lex_state = 25},
  [2086] = {.lex_state = 25},
  [2087] = {.lex_state = 25},
  [2088] = {.lex_state = 25},
  [2089] = {.lex_state = 25},
  [2090] = {.lex_state = 25},
  [2091] = {.lex_state = 25},
  [2092] = {.lex_state = 25},
  [2093] = {.lex_state = 25},
  [2094] = {.lex_state = 25},
  [2095] = {.lex_state = 25},
  [2096] = {.lex_state = 25},
  [2097] = {.lex_state = 25},
  [2098] = {.lex_state = 25},
  [2099] = {.lex_state = 25},
  [2100] = {.lex_state = 25},
  [2101] = {.lex_state = 25},
  [2102] = {.lex_state = 25},
  [2103] = {.lex_state = 25},
  [2104] = {.lex_state = 25},
  [2105] = {.lex_state = 25},
  [2106] = {.lex_state = 25},
  [2107] = {.lex_state = 25},
  [2108] = {.lex_state = 25},
  [2109] = {.lex_state = 28},
  [2110] = {.lex_state = 28},
  [2111] = {.lex_state = 28},
  [2112] = {.lex_state = 25},
  [2113] = {.lex_state = 25},
  [2114] = {.lex_state = 28},
  [2115] = {.lex_state = 28},
  [2116] = {.lex_state = 28},
  [2117] = {.lex_state = 28},
  [2118] = {.lex_state = 25},
  [2119] = {.lex_state = 25},
  [2120] = {.lex_state = 28},
  [2121] = {.lex_state = 25},
  [2122] = {.lex_state = 28},
  [2123] = {.lex_state = 25},
  [2124] = {.lex_state = 25},
  [2125] = {.lex_state = 28},
  [2126] = {.lex_state = 28},
  [2127] = {.lex_state = 28},
  [2128] = {.lex_state = 28},
  [2129] = {.lex_state = 25},
  [2130] = {.lex_state = 28},
  [2131] = {.lex_state = 35},
  [2132] = {.lex_state = 35},
  [2133] = {.lex_state = 35},
  [2134] = {.lex_state = 35},
  [2135] = {.lex_state = 35},
  [2136] = {.lex_state = 35},
  [2137] = {.lex_state = 35},
  [2138] = {.lex_state = 35},
  [2139] = {.lex_state = 35},
  [2140] = {.lex_state = 35},
  [2141] = {.lex_state = 35},
  [2142] = {.lex_state = 35},
  [2143] = {.lex_state = 35},
  [2144] = {.lex_state = 35},
  [2145] = {.lex_state = 35},
  [2146] = {.lex_state = 35},
  [2147] = {.lex_state = 35},
  [2148] = {.lex_state = 35},
  [2149] = {.lex_state = 35},
  [2150] = {.lex_state = 26},
  [2151] = {.lex_state = 26},
  [2152] = {.lex_state = 35},
  [2153] = {.lex_state = 35},
  [2154] = {.lex_state = 35},
  [2155] = {.lex_state = 35},
  [2156] = {.lex_state = 35},
  [2157] = {.lex_state = 26},
  [2158] = {.lex_state = 35},
  [2159] = {.lex_state = 35},
  [2160] = {.lex_state = 35},
  [2161] = {.lex_state = 35},
  [2162] = {.lex_state = 35},
  [2163] = {.lex_state = 35},
  [2164] = {.lex_state = 35},
  [2165] = {.lex_state = 35},
  [2166] = {.lex_state = 35},
  [2167] = {.lex_state = 35},
  [2168] = {.lex_state = 26},
  [2169] = {.lex_state = 35},
  [2170] = {.lex_state = 35},
  [2171] = {.lex_state = 35},
  [2172] = {.lex_state = 35},
  [2173] = {.lex_state = 35},
  [2174] = {.lex_state = 35},
  [2175] = {.lex_state = 35},
  [2176] = {.lex_state = 35},
  [2177] = {.lex_state = 35},
  [2178] = {.lex_state = 35},
  [2179] = {.lex_state = 35},
  [2180] = {.lex_state = 35},
  [2181] = {.lex_state = 35},
  [2182] = {.lex_state = 35},
  [2183] = {.lex_state = 35},
  [2184] = {.lex_state = 35},
  [2185] = {.lex_state = 35},
  [2186] = {.lex_state = 35},
  [2187] = {.lex_state = 26},
  [2188] = {.lex_state = 35},
  [2189] = {.lex_state = 35},
  [2190] = {.lex_state = 35},
  [2191] = {.lex_state = 35},
  [2192] = {.lex_state = 35},
  [2193] = {.lex_state = 35},
  [2194] = {.lex_state = 35},
  [2195] = {.lex_state = 26},
  [2196] = {.lex_state = 35},
  [2197] = {.lex_state = 35},
  [2198] = {.lex_state = 35},
  [2199] = {.lex_state = 35},
  [2200] = {.lex_state = 35},
  [2201] = {.lex_state = 26},
  [2202] = {.lex_state = 26},
  [2203] = {.lex_state = 35},
  [2204] = {.lex_state = 35},
  [2205] = {.lex_state = 35},
  [2206] = {.lex_state = 35},
  [2207] = {.lex_state = 35},
  [2208] = {.lex_state = 35},
  [2209] = {.lex_state = 35},
  [2210] = {.lex_state = 35},
  [2211] = {.lex_state = 35},
  [2212] = {.lex_state = 35},
  [2213] = {.lex_state = 35},
  [2214] = {.lex_state = 35},
  [2215] = {.lex_state = 35},
  [2216] = {.lex_state = 35},
  [2217] = {.lex_state = 35},
  [2218] = {.lex_state = 35},
  [2219] = {.lex_state = 26},
  [2220] = {.lex_state = 26},
  [2221] = {.lex_state = 35},
  [2222] = {.lex_state = 35},
  [2223] = {.lex_state = 35},
  [2224] = {.lex_state = 35},
  [2225] = {.lex_state = 35},
  [2226] = {.lex_state = 35},
  [2227] = {.lex_state = 35},
  [2228] = {.lex_state = 35},
  [2229] = {.lex_state = 35},
  [2230] = {.lex_state = 35},
  [2231] = {.lex_state = 35},
  [2232] = {.lex_state = 35},
  [2233] = {.lex_state = 35},
  [2234] = {.lex_state = 35},
  [2235] = {.lex_state = 35},
  [2236] = {.lex_state = 35},
  [2237] = {.lex_state = 35},
  [2238] = {.lex_state = 35},
  [2239] = {.lex_state = 35},
  [2240] = {.lex_state = 35},
  [2241] = {.lex_state = 35},
  [2242] = {.lex_state = 35},
  [2243] = {.lex_state = 35},
  [2244] = {.lex_state = 35},
  [2245] = {.lex_state = 35},
  [2246] = {.lex_state = 35},
  [2247] = {.lex_state = 35},
  [2248] = {.lex_state = 35},
  [2249] = {.lex_state = 35},
  [2250] = {.lex_state = 35},
  [2251] = {.lex_state = 35},
  [2252] = {.lex_state = 35},
  [2253] = {.lex_state = 35},
  [2254] = {.lex_state = 35},
  [2255] = {.lex_state = 35},
  [2256] = {.lex_state = 35},
  [2257] = {.lex_state = 35},
  [2258] = {.lex_state = 26},
  [2259] = {.lex_state = 26},
  [2260] = {.lex_state = 35},
  [2261] = {.lex_state = 35},
  [2262] = {.lex_state = 35},
  [2263] = {.lex_state = 35},
  [2264] = {.lex_state = 35},
  [2265] = {.lex_state = 35},
  [2266] = {.lex_state = 35},
  [2267] = {.lex_state = 35},
  [2268] = {.lex_state = 35},
  [2269] = {.lex_state = 26},
  [2270] = {.lex_state = 35},
  [2271] = {.lex_state = 26},
  [2272] = {.lex_state = 35},
  [2273] = {.lex_state = 35},
  [2274] = {.lex_state = 35},
  [2275] = {.lex_state = 35},
  [2276] = {.lex_state = 35},
  [2277] = {.lex_state = 35},
  [2278] = {.lex_state = 35},
  [2279] = {.lex_state = 35},
  [2280] = {.lex_state = 35},
  [2281] = {.lex_state = 35},
  [2282] = {.lex_state = 35},
  [2283] = {.lex_state = 35},
  [2284] = {.lex_state = 35},
  [2285] = {.lex_state = 35},
  [2286] = {.lex_state = 35},
  [2287] = {.lex_state = 35},
  [2288] = {.lex_state = 35},
  [2289] = {.lex_state = 35},
  [2290] = {.lex_state = 35},
  [2291] = {.lex_state = 35},
  [2292] = {.lex_state = 26},
  [2293] = {.lex_state = 26},
  [2294] = {.lex_state = 35},
  [2295] = {.lex_state = 35},
  [2296] = {.lex_state = 35},
  [2297] = {.lex_state = 35},
  [2298] = {.lex_state = 35},
  [2299] = {.lex_state = 35},
  [2300] = {.lex_state = 35},
  [2301] = {.lex_state = 35},
  [2302] = {.lex_state = 35},
  [2303] = {.lex_state = 35},
  [2304] = {.lex_state = 35},
  [2305] = {.lex_state = 35},
  [2306] = {.lex_state = 35},
  [2307] = {.lex_state = 35},
  [2308] = {.lex_state = 35},
  [2309] = {.lex_state = 35},
  [2310] = {.lex_state = 35},
  [2311] = {.lex_state = 35},
  [2312] = {.lex_state = 35},
  [2313] = {.lex_state = 35},
  [2314] = {.lex_state = 35},
  [2315] = {.lex_state = 35},
  [2316] = {.lex_state = 35},
  [2317] = {.lex_state = 35},
  [2318] = {.lex_state = 35},
  [2319] = {.lex_state = 35},
  [2320] = {.lex_state = 35},
  [2321] = {.lex_state = 35},
  [2322] = {.lex_state = 35},
  [2323] = {.lex_state = 35},
  [2324] = {.lex_state = 35},
  [2325] = {.lex_state = 35},
  [2326] = {.lex_state = 35},
  [2327] = {.lex_state = 35},
  [2328] = {.lex_state = 35},
  [2329] = {.lex_state = 35},
  [2330] = {.lex_state = 35},
  [2331] = {.lex_state = 35},
  [2332] = {.lex_state = 35},
  [2333] = {.lex_state = 35},
  [2334] = {.lex_state = 35},
  [2335] = {.lex_state = 35},
  [2336] = {.lex_state = 35},
  [2337] = {.lex_state = 26},
  [2338] = {.lex_state = 26},
  [2339] = {.lex_state = 26},
  [2340] = {.lex_state = 26},
  [2341] = {.lex_state = 35},
  [2342] = {.lex_state = 35},
  [2343] = {.lex_state = 35},
  [2344] = {.lex_state = 35},
  [2345] = {.lex_state = 35},
  [2346] = {.lex_state = 35},
  [2347] = {.lex_state = 35},
  [2348] = {.lex_state = 35},
  [2349] = {.lex_state = 35},
  [2350] = {.lex_state = 35},
  [2351] = {.lex_state = 35},
  [2352] = {.lex_state = 35},
  [2353] = {.lex_state = 35},
  [2354] = {.lex_state = 35},
  [2355] = {.lex_state = 35},
  [2356] = {.lex_state = 25},
  [2357] = {.lex_state = 35},
  [2358] = {.lex_state = 27},
  [2359] = {.lex_state = 25},
  [2360] = {.lex_state = 35},
  [2361] = {.lex_state = 35},
  [2362] = {.lex_state = 35},
  [2363] = {.lex_state = 25},
  [2364] = {.lex_state = 25},
  [2365] = {.lex_state = 35},
  [2366] = {.lex_state = 35},
  [2367] = {.lex_state = 35},
  [2368] = {.lex_state = 35},
  [2369] = {.lex_state = 27},
  [2370] = {.lex_state = 35},
  [2371] = {.lex_state = 27},
  [2372] = {.lex_state = 35},
  [2373] = {.lex_state = 35},
  [2374] = {.lex_state = 25},
  [2375] = {.lex_state = 25},
  [2376] = {.lex_state = 35},
  [2377] = {.lex_state = 27},
  [2378] = {.lex_state = 35},
  [2379] = {.lex_state = 35},
  [2380] = {.lex_state = 35},
  [2381] = {.lex_state = 25},
  [2382] = {.lex_state = 35},
  [2383] = {.lex_state = 35},
  [2384] = {.lex_state = 35},
  [2385] = {.lex_state = 35},
  [2386] = {.lex_state = 35},
  [2387] = {.lex_state = 35},
  [2388] = {.lex_state = 25},
  [2389] = {.lex_state = 27},
  [2390] = {.lex_state = 35},
  [2391] = {.lex_state = 35},
  [2392] = {.lex_state = 25},
  [2393] = {.lex_state = 35},
  [2394] = {.lex_state = 35},
  [2395] = {.lex_state = 35},
  [2396] = {.lex_state = 35},
  [2397] = {.lex_state = 27},
  [2398] = {.lex_state = 25},
  [2399] = {.lex_state = 35},
  [2400] = {.lex_state = 25},
  [2401] = {.lex_state = 35},
  [2402] = {.lex_state = 35},
  [2403] = {.lex_state = 35},
  [2404] = {.lex_state = 25},
  [2405] = {.lex_state = 35},
  [2406] = {.lex_state = 28},
  [2407] = {.lex_state = 25},
  [2408] = {.lex_state = 35},
  [2409] = {.lex_state = 35},
  [2410] = {.lex_state = 35},
  [2411] = {.lex_state = 35},
  [2412] = {.lex_state = 28},
  [2413] = {.lex_state = 35},
  [2414] = {.lex_state = 35},
  [2415] = {.lex_state = 25},
  [2416] = {.lex_state = 35},
  [2417] = {.lex_state = 35},
  [2418] = {.lex_state = 35},
  [2419] = {.lex_state = 27},
  [2420] = {.lex_state = 35},
  [2421] = {.lex_state = 25},
  [2422] = {.lex_state = 35},
  [2423] = {.lex_state = 35},
  [2424] = {.lex_state = 35},
  [2425] = {.lex_state = 35},
  [2426] = {.lex_state = 25},
  [2427] = {.lex_state = 35},
  [2428] = {.lex_state = 27},
  [2429] = {.lex_state = 35},
  [2430] = {.lex_state = 35},
  [2431] = {.lex_state = 25},
  [2432] = {.lex_state = 35},
  [2433] = {.lex_state = 25},
  [2434] = {.lex_state = 35},
  [2435] = {.lex_state = 35},
  [2436] = {.lex_state = 27},
  [2437] = {.lex_state = 25},
  [2438] = {.lex_state = 25},
  [2439] = {.lex_state = 35},
  [2440] = {.lex_state = 27},
  [2441] = {.lex_state = 35},
  [2442] = {.lex_state = 35},
  [2443] = {.lex_state = 35},
  [2444] = {.lex_state = 35},
  [2445] = {.lex_state = 35},
  [2446] = {.lex_state = 25},
  [2447] = {.lex_state = 35},
  [2448] = {.lex_state = 35},
  [2449] = {.lex_state = 35},
  [2450] = {.lex_state = 27},
  [2451] = {.lex_state = 25},
  [2452] = {.lex_state = 25},
  [2453] = {.lex_state = 35},
  [2454] = {.lex_state = 25},
  [2455] = {.lex_state = 35},
  [2456] = {.lex_state = 35},
  [2457] = {.lex_state = 25},
  [2458] = {.lex_state = 25},
  [2459] = {.lex_state = 25},
  [2460] = {.lex_state = 25},
  [2461] = {.lex_state = 25},
  [2462] = {.lex_state = 35},
  [2463] = {.lex_state = 35},
  [2464] = {.lex_state = 25},
  [2465] = {.lex_state = 25},
  [2466] = {.lex_state = 25},
  [2467] = {.lex_state = 0},
  [2468] = {.lex_state = 0},
  [2469] = {.lex_state = 0},
  [2470] = {.lex_state = 0},
  [2471] = {.lex_state = 0},
  [2472] = {.lex_state = 0},
  [2473] = {.lex_state = 0},
  [2474] = {.lex_state = 0},
  [2475] = {.lex_state = 0},
  [2476] = {.lex_state = 0},
  [2477] = {.lex_state = 0},
  [2478] = {.lex_state = 24},
  [2479] = {.lex_state = 0},
  [2480] = {.lex_state = 0},
  [2481] = {.lex_state = 0},
  [2482] = {.lex_state = 0},
  [2483] = {.lex_state = 0},
  [2484] = {.lex_state = 0},
  [2485] = {.lex_state = 0},
  [2486] = {.lex_state = 0},
  [2487] = {.lex_state = 0},
  [2488] = {.lex_state = 0},
  [2489] = {.lex_state = 0},
  [2490] = {.lex_state = 0},
  [2491] = {.lex_state = 0},
  [2492] = {.lex_state = 0},
  [2493] = {.lex_state = 0},
  [2494] = {.lex_state = 29},
  [2495] = {.lex_state = 0},
  [2496] = {.lex_state = 0},
  [2497] = {.lex_state = 0},
  [2498] = {.lex_state = 0},
  [2499] = {.lex_state = 0},
  [2500] = {.lex_state = 0},
  [2501] = {.lex_state = 0},
  [2502] = {.lex_state = 0},
  [2503] = {.lex_state = 0},
  [2504] = {.lex_state = 0},
  [2505] = {.lex_state = 0},
  [2506] = {.lex_state = 0},
  [2507] = {.lex_state = 0},
  [2508] = {.lex_state = 25},
  [2509] = {.lex_state = 0},
  [2510] = {.lex_state = 0},
  [2511] = {.lex_state = 0},
  [2512] = {.lex_state = 0},
  [2513] = {.lex_state = 0},
  [2514] = {.lex_state = 0},
  [2515] = {.lex_state = 0},
  [2516] = {.lex_state = 0},
  [2517] = {.lex_state = 0},
  [2518] = {.lex_state = 0},
  [2519] = {.lex_state = 0},
  [2520] = {.lex_state = 0},
  [2521] = {.lex_state = 0},
  [2522] = {.lex_state = 0},
  [2523] = {.lex_state = 0},
  [2524] = {.lex_state = 25},
  [2525] = {.lex_state = 0},
  [2526] = {.lex_state = 35},
  [2527] = {.lex_state = 0},
  [2528] = {.lex_state = 35},
  [2529] = {.lex_state = 0},
  [2530] = {.lex_state = 0},
  [2531] = {.lex_state = 24},
  [2532] = {.lex_state = 0},
  [2533] = {.lex_state = 24},
  [2534] = {.lex_state = 0},
  [2535] = {.lex_state = 0},
  [2536] = {.lex_state = 24},
  [2537] = {.lex_state = 0},
  [2538] = {.lex_state = 24},
  [2539] = {.lex_state = 0},
  [2540] = {.lex_state = 0},
  [2541] = {.lex_state = 0},
  [2542] = {.lex_state = 0},
  [2543] = {.lex_state = 0},
  [2544] = {.lex_state = 0},
  [2545] = {.lex_state = 0},
  [2546] = {.lex_state = 0},
  [2547] = {.lex_state = 0},
  [2548] = {.lex_state = 0},
  [2549] = {.lex_state = 0},
  [2550] = {.lex_state = 0},
  [2551] = {.lex_state = 0},
  [2552] = {.lex_state = 0},
  [2553] = {.lex_state = 0},
  [2554] = {.lex_state = 0},
  [2555] = {.lex_state = 0},
  [2556] = {.lex_state = 0},
  [2557] = {.lex_state = 0},
  [2558] = {.lex_state = 0},
  [2559] = {.lex_state = 0},
  [2560] = {.lex_state = 0},
  [2561] = {.lex_state = 0},
  [2562] = {.lex_state = 0},
  [2563] = {.lex_state = 0},
  [2564] = {.lex_state = 0},
  [2565] = {.lex_state = 0},
  [2566] = {.lex_state = 0},
  [2567] = {.lex_state = 0},
  [2568] = {.lex_state = 0},
  [2569] = {.lex_state = 0},
  [2570] = {.lex_state = 0},
  [2571] = {.lex_state = 24},
  [2572] = {.lex_state = 0},
  [2573] = {.lex_state = 0},
  [2574] = {.lex_state = 0},
  [2575] = {.lex_state = 0},
  [2576] = {.lex_state = 0},
  [2577] = {.lex_state = 0},
  [2578] = {.lex_state = 0},
  [2579] = {.lex_state = 0},
  [2580] = {.lex_state = 0},
  [2581] = {.lex_state = 24},
  [2582] = {.lex_state = 0},
  [2583] = {.lex_state = 0},
  [2584] = {.lex_state = 24},
  [2585] = {.lex_state = 0},
  [2586] = {.lex_state = 0},
  [2587] = {.lex_state = 0},
  [2588] = {.lex_state = 0},
  [2589] = {.lex_state = 0},
  [2590] = {.lex_state = 0},
  [2591] = {.lex_state = 0},
  [2592] = {.lex_state = 0},
  [2593] = {.lex_state = 0},
  [2594] = {.lex_state = 0},
  [2595] = {.lex_state = 0},
  [2596] = {.lex_state = 24},
  [2597] = {.lex_state = 0},
  [2598] = {.lex_state = 0},
  [2599] = {.lex_state = 0},
  [2600] = {.lex_state = 0},
  [2601] = {.lex_state = 0},
  [2602] = {.lex_state = 0},
  [2603] = {.lex_state = 0},
  [2604] = {.lex_state = 0},
  [2605] = {.lex_state = 0},
  [2606] = {.lex_state = 0},
  [2607] = {.lex_state = 0},
  [2608] = {.lex_state = 0},
  [2609] = {.lex_state = 0},
  [2610] = {.lex_state = 0},
  [2611] = {.lex_state = 29},
  [2612] = {.lex_state = 0},
  [2613] = {.lex_state = 0},
  [2614] = {.lex_state = 0},
  [2615] = {.lex_state = 0},
  [2616] = {.lex_state = 0},
  [2617] = {.lex_state = 0},
  [2618] = {.lex_state = 0},
  [2619] = {.lex_state = 0},
  [2620] = {.lex_state = 0},
  [2621] = {.lex_state = 0},
  [2622] = {.lex_state = 0},
  [2623] = {.lex_state = 0},
  [2624] = {.lex_state = 0},
  [2625] = {.lex_state = 25},
  [2626] = {.lex_state = 0},
  [2627] = {.lex_state = 0},
  [2628] = {.lex_state = 0},
  [2629] = {.lex_state = 0},
  [2630] = {.lex_state = 0},
  [2631] = {.lex_state = 25},
  [2632] = {.lex_state = 0},
  [2633] = {.lex_state = 0},
  [2634] = {.lex_state = 0},
  [2635] = {.lex_state = 0},
  [2636] = {.lex_state = 0},
  [2637] = {.lex_state = 0},
  [2638] = {.lex_state = 0},
  [2639] = {.lex_state = 0},
  [2640] = {.lex_state = 0},
  [2641] = {.lex_state = 0},
  [2642] = {.lex_state = 0},
  [2643] = {.lex_state = 0},
  [2644] = {.lex_state = 0},
  [2645] = {.lex_state = 0},
  [2646] = {.lex_state = 0},
  [2647] = {.lex_state = 0},
  [2648] = {.lex_state = 0},
  [2649] = {.lex_state = 0},
  [2650] = {.lex_state = 0},
  [2651] = {.lex_state = 0},
  [2652] = {.lex_state = 0},
  [2653] = {.lex_state = 0},
  [2654] = {.lex_state = 0},
  [2655] = {.lex_state = 0},
  [2656] = {.lex_state = 0},
  [2657] = {.lex_state = 0},
  [2658] = {.lex_state = 25},
  [2659] = {.lex_state = 0},
  [2660] = {.lex_state = 0},
  [2661] = {.lex_state = 0},
  [2662] = {.lex_state = 0},
  [2663] = {.lex_state = 0},
  [2664] = {.lex_state = 0},
  [2665] = {.lex_state = 0},
  [2666] = {.lex_state = 0},
  [2667] = {.lex_state = 0},
  [2668] = {.lex_state = 0},
  [2669] = {.lex_state = 0},
  [2670] = {.lex_state = 0},
  [2671] = {.lex_state = 0},
  [2672] = {.lex_state = 0},
  [2673] = {.lex_state = 0},
  [2674] = {.lex_state = 0},
  [2675] = {.lex_state = 0},
  [2676] = {.lex_state = 0},
  [2677] = {.lex_state = 0},
  [2678] = {.lex_state = 0},
  [2679] = {.lex_state = 0},
  [2680] = {.lex_state = 0},
  [2681] = {.lex_state = 0},
  [2682] = {.lex_state = 0},
  [2683] = {.lex_state = 0},
  [2684] = {.lex_state = 0},
  [2685] = {.lex_state = 0},
  [2686] = {.lex_state = 0},
  [2687] = {.lex_state = 0},
  [2688] = {.lex_state = 24},
  [2689] = {.lex_state = 0},
  [2690] = {.lex_state = 0},
  [2691] = {.lex_state = 0},
  [2692] = {.lex_state = 25},
  [2693] = {.lex_state = 0},
  [2694] = {.lex_state = 0},
  [2695] = {.lex_state = 0},
  [2696] = {.lex_state = 0},
  [2697] = {.lex_state = 0},
  [2698] = {.lex_state = 0},
  [2699] = {.lex_state = 0},
  [2700] = {.lex_state = 0},
  [2701] = {.lex_state = 0},
  [2702] = {.lex_state = 0},
  [2703] = {.lex_state = 0},
  [2704] = {.lex_state = 0},
  [2705] = {.lex_state = 0},
  [2706] = {.lex_state = 0},
  [2707] = {.lex_state = 0},
  [2708] = {.lex_state = 29},
  [2709] = {.lex_state = 0},
  [2710] = {.lex_state = 0},
  [2711] = {.lex_state = 0},
  [2712] = {.lex_state = 0},
  [2713] = {.lex_state = 0},
  [2714] = {.lex_state = 0},
  [2715] = {.lex_state = 0},
  [2716] = {.lex_state = 0},
  [2717] = {.lex_state = 0},
  [2718] = {.lex_state = 0},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 0},
  [2721] = {.lex_state = 0},
  [2722] = {.lex_state = 0},
  [2723] = {.lex_state = 0},
  [2724] = {.lex_state = 0},
  [2725] = {.lex_state = 0},
  [2726] = {.lex_state = 0},
  [2727] = {.lex_state = 0},
  [2728] = {.lex_state = 29},
  [2729] = {.lex_state = 0},
  [2730] = {.lex_state = 0},
  [2731] = {.lex_state = 0},
  [2732] = {.lex_state = 0},
  [2733] = {.lex_state = 0},
  [2734] = {.lex_state = 0},
  [2735] = {.lex_state = 0},
  [2736] = {.lex_state = 0},
  [2737] = {.lex_state = 0},
  [2738] = {.lex_state = 0},
  [2739] = {.lex_state = 0},
  [2740] = {.lex_state = 0},
  [2741] = {.lex_state = 0},
  [2742] = {.lex_state = 25},
  [2743] = {.lex_state = 0},
  [2744] = {.lex_state = 0},
  [2745] = {.lex_state = 0},
  [2746] = {.lex_state = 0},
  [2747] = {.lex_state = 0},
  [2748] = {.lex_state = 0},
  [2749] = {.lex_state = 0},
  [2750] = {.lex_state = 0},
  [2751] = {.lex_state = 0},
  [2752] = {.lex_state = 0},
  [2753] = {.lex_state = 0},
  [2754] = {.lex_state = 0},
  [2755] = {.lex_state = 0},
  [2756] = {.lex_state = 0},
  [2757] = {.lex_state = 0},
  [2758] = {.lex_state = 0},
  [2759] = {.lex_state = 0},
  [2760] = {.lex_state = 0},
  [2761] = {.lex_state = 0},
  [2762] = {.lex_state = 0},
  [2763] = {.lex_state = 0},
  [2764] = {.lex_state = 0},
  [2765] = {.lex_state = 0},
  [2766] = {.lex_state = 0},
  [2767] = {.lex_state = 0},
  [2768] = {.lex_state = 0},
  [2769] = {.lex_state = 0},
  [2770] = {.lex_state = 0},
  [2771] = {.lex_state = 0},
  [2772] = {.lex_state = 0},
  [2773] = {.lex_state = 0},
  [2774] = {.lex_state = 0},
  [2775] = {.lex_state = 0},
  [2776] = {.lex_state = 0},
  [2777] = {.lex_state = 29},
  [2778] = {.lex_state = 0},
  [2779] = {.lex_state = 0},
  [2780] = {.lex_state = 0},
  [2781] = {.lex_state = 0},
  [2782] = {.lex_state = 0},
  [2783] = {.lex_state = 0},
  [2784] = {.lex_state = 0},
  [2785] = {.lex_state = 0},
  [2786] = {.lex_state = 0},
  [2787] = {.lex_state = 0},
  [2788] = {.lex_state = 0},
  [2789] = {.lex_state = 0},
  [2790] = {.lex_state = 0},
  [2791] = {.lex_state = 0},
  [2792] = {.lex_state = 0},
  [2793] = {.lex_state = 0},
  [2794] = {.lex_state = 0},
  [2795] = {.lex_state = 0},
  [2796] = {.lex_state = 0},
  [2797] = {.lex_state = 0},
  [2798] = {.lex_state = 0},
  [2799] = {.lex_state = 0},
  [2800] = {.lex_state = 0},
  [2801] = {.lex_state = 0},
  [2802] = {.lex_state = 0},
  [2803] = {.lex_state = 0},
  [2804] = {.lex_state = 0},
  [2805] = {.lex_state = 24},
  [2806] = {.lex_state = 0},
  [2807] = {.lex_state = 0},
  [2808] = {.lex_state = 0},
  [2809] = {.lex_state = 0},
  [2810] = {.lex_state = 0},
  [2811] = {.lex_state = 0},
  [2812] = {.lex_state = 0},
  [2813] = {.lex_state = 0},
  [2814] = {.lex_state = 24},
  [2815] = {.lex_state = 0},
  [2816] = {.lex_state = 0},
  [2817] = {.lex_state = 0},
  [2818] = {.lex_state = 0},
  [2819] = {.lex_state = 0},
  [2820] = {.lex_state = 0},
  [2821] = {.lex_state = 0},
  [2822] = {.lex_state = 0},
  [2823] = {.lex_state = 0},
  [2824] = {.lex_state = 0},
  [2825] = {.lex_state = 0},
  [2826] = {.lex_state = 0},
  [2827] = {.lex_state = 0},
  [2828] = {.lex_state = 0},
  [2829] = {.lex_state = 0},
  [2830] = {.lex_state = 0},
  [2831] = {.lex_state = 0},
  [2832] = {.lex_state = 0},
  [2833] = {.lex_state = 0},
  [2834] = {.lex_state = 0},
  [2835] = {.lex_state = 0},
  [2836] = {.lex_state = 0},
  [2837] = {.lex_state = 0},
  [2838] = {.lex_state = 0},
  [2839] = {.lex_state = 0},
  [2840] = {.lex_state = 0},
  [2841] = {.lex_state = 0},
  [2842] = {.lex_state = 0},
  [2843] = {.lex_state = 29},
  [2844] = {.lex_state = 0},
  [2845] = {.lex_state = 0},
  [2846] = {.lex_state = 0},
  [2847] = {.lex_state = 0},
  [2848] = {.lex_state = 0},
  [2849] = {.lex_state = 0},
  [2850] = {.lex_state = 0},
  [2851] = {.lex_state = 0},
  [2852] = {.lex_state = 0},
  [2853] = {.lex_state = 0},
  [2854] = {.lex_state = 0},
  [2855] = {.lex_state = 0},
  [2856] = {.lex_state = 0},
  [2857] = {.lex_state = 25},
  [2858] = {.lex_state = 0},
  [2859] = {.lex_state = 0},
  [2860] = {.lex_state = 0},
  [2861] = {.lex_state = 0},
  [2862] = {.lex_state = 0},
  [2863] = {.lex_state = 0},
  [2864] = {.lex_state = 0},
  [2865] = {.lex_state = 0},
  [2866] = {.lex_state = 0},
  [2867] = {.lex_state = 0},
  [2868] = {.lex_state = 0},
  [2869] = {.lex_state = 0},
  [2870] = {.lex_state = 0},
  [2871] = {.lex_state = 0},
  [2872] = {.lex_state = 0},
  [2873] = {.lex_state = 0},
  [2874] = {.lex_state = 0},
  [2875] = {.lex_state = 0},
  [2876] = {.lex_state = 0},
  [2877] = {.lex_state = 0},
  [2878] = {.lex_state = 0},
  [2879] = {.lex_state = 0},
  [2880] = {.lex_state = 0},
  [2881] = {.lex_state = 0},
  [2882] = {.lex_state = 0},
  [2883] = {.lex_state = 0},
  [2884] = {.lex_state = 0},
  [2885] = {.lex_state = 0},
  [2886] = {.lex_state = 0},
  [2887] = {.lex_state = 0},
  [2888] = {.lex_state = 0},
  [2889] = {.lex_state = 0},
  [2890] = {.lex_state = 0},
  [2891] = {.lex_state = 0},
  [2892] = {.lex_state = 0},
  [2893] = {.lex_state = 0},
  [2894] = {.lex_state = 0},
  [2895] = {.lex_state = 0},
  [2896] = {.lex_state = 0},
  [2897] = {.lex_state = 0},
  [2898] = {.lex_state = 0},
  [2899] = {.lex_state = 0},
  [2900] = {.lex_state = 0},
  [2901] = {.lex_state = 0},
  [2902] = {.lex_state = 0},
  [2903] = {.lex_state = 0},
  [2904] = {.lex_state = 0},
  [2905] = {.lex_state = 0},
  [2906] = {.lex_state = 0},
  [2907] = {.lex_state = 0},
  [2908] = {.lex_state = 0},
  [2909] = {.lex_state = 0},
  [2910] = {.lex_state = 0},
  [2911] = {.lex_state = 0},
  [2912] = {.lex_state = 0},
  [2913] = {.lex_state = 0},
  [2914] = {.lex_state = 0},
  [2915] = {.lex_state = 0},
  [2916] = {.lex_state = 0},
  [2917] = {.lex_state = 0},
  [2918] = {.lex_state = 0},
  [2919] = {.lex_state = 0},
  [2920] = {.lex_state = 0},
  [2921] = {.lex_state = 0},
  [2922] = {.lex_state = 0},
  [2923] = {.lex_state = 0},
  [2924] = {.lex_state = 0},
  [2925] = {.lex_state = 0},
  [2926] = {.lex_state = 0},
  [2927] = {.lex_state = 0},
  [2928] = {.lex_state = 0},
  [2929] = {.lex_state = 0},
  [2930] = {.lex_state = 0},
  [2931] = {.lex_state = 0},
  [2932] = {.lex_state = 0},
  [2933] = {.lex_state = 0},
  [2934] = {.lex_state = 0},
  [2935] = {.lex_state = 0},
  [2936] = {.lex_state = 0},
  [2937] = {.lex_state = 29},
  [2938] = {.lex_state = 0},
  [2939] = {.lex_state = 0},
  [2940] = {.lex_state = 0},
  [2941] = {.lex_state = 0},
  [2942] = {.lex_state = 0},
  [2943] = {.lex_state = 0},
  [2944] = {.lex_state = 0},
  [2945] = {.lex_state = 0},
  [2946] = {.lex_state = 0},
  [2947] = {.lex_state = 0},
  [2948] = {.lex_state = 0},
  [2949] = {.lex_state = 0},
  [2950] = {.lex_state = 0},
  [2951] = {.lex_state = 25},
  [2952] = {.lex_state = 0},
  [2953] = {.lex_state = 0},
  [2954] = {.lex_state = 0},
  [2955] = {.lex_state = 0},
  [2956] = {.lex_state = 0},
  [2957] = {.lex_state = 0},
  [2958] = {.lex_state = 0},
  [2959] = {.lex_state = 0},
  [2960] = {.lex_state = 0},
  [2961] = {.lex_state = 0},
  [2962] = {.lex_state = 0},
  [2963] = {.lex_state = 0},
  [2964] = {.lex_state = 0},
  [2965] = {.lex_state = 0},
  [2966] = {.lex_state = 0},
  [2967] = {.lex_state = 0},
  [2968] = {.lex_state = 0},
  [2969] = {.lex_state = 0},
  [2970] = {.lex_state = 0},
  [2971] = {.lex_state = 0},
  [2972] = {.lex_state = 0},
  [2973] = {.lex_state = 0},
  [2974] = {.lex_state = 25},
  [2975] = {.lex_state = 0},
  [2976] = {.lex_state = 0},
  [2977] = {.lex_state = 0},
  [2978] = {.lex_state = 0},
  [2979] = {.lex_state = 0},
  [2980] = {.lex_state = 0},
  [2981] = {.lex_state = 0},
  [2982] = {.lex_state = 0},
  [2983] = {.lex_state = 0},
  [2984] = {.lex_state = 0},
  [2985] = {.lex_state = 0},
  [2986] = {.lex_state = 0},
  [2987] = {.lex_state = 0},
  [2988] = {.lex_state = 0},
  [2989] = {.lex_state = 0},
  [2990] = {.lex_state = 0},
  [2991] = {.lex_state = 0},
  [2992] = {.lex_state = 29},
  [2993] = {.lex_state = 0},
  [2994] = {.lex_state = 0},
  [2995] = {.lex_state = 0},
  [2996] = {.lex_state = 0},
  [2997] = {.lex_state = 0},
  [2998] = {.lex_state = 0},
  [2999] = {.lex_state = 0},
  [3000] = {.lex_state = 0},
  [3001] = {.lex_state = 0},
  [3002] = {.lex_state = 0},
  [3003] = {.lex_state = 0},
  [3004] = {.lex_state = 0},
  [3005] = {.lex_state = 0},
  [3006] = {.lex_state = 0},
  [3007] = {.lex_state = 0},
  [3008] = {.lex_state = 0},
  [3009] = {.lex_state = 0},
  [3010] = {.lex_state = 0},
  [3011] = {.lex_state = 0},
  [3012] = {.lex_state = 0},
  [3013] = {.lex_state = 0},
  [3014] = {.lex_state = 0},
  [3015] = {.lex_state = 0},
  [3016] = {.lex_state = 0},
  [3017] = {.lex_state = 0},
  [3018] = {.lex_state = 0},
  [3019] = {.lex_state = 0},
  [3020] = {.lex_state = 0},
  [3021] = {.lex_state = 0},
  [3022] = {.lex_state = 29},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 0},
  [3025] = {.lex_state = 0},
  [3026] = {.lex_state = 0},
  [3027] = {.lex_state = 0},
  [3028] = {.lex_state = 0},
  [3029] = {.lex_state = 0},
  [3030] = {.lex_state = 0},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 0},
  [3033] = {.lex_state = 0},
  [3034] = {.lex_state = 0},
  [3035] = {.lex_state = 0},
  [3036] = {.lex_state = 25},
  [3037] = {.lex_state = 0},
  [3038] = {.lex_state = 0},
  [3039] = {.lex_state = 0},
  [3040] = {.lex_state = 0},
  [3041] = {.lex_state = 0},
  [3042] = {.lex_state = 0},
  [3043] = {.lex_state = 0},
  [3044] = {.lex_state = 0},
  [3045] = {.lex_state = 0},
  [3046] = {.lex_state = 0},
  [3047] = {.lex_state = 24},
  [3048] = {.lex_state = 0},
  [3049] = {.lex_state = 0},
  [3050] = {.lex_state = 0},
  [3051] = {.lex_state = 0},
  [3052] = {.lex_state = 0},
  [3053] = {.lex_state = 0},
  [3054] = {.lex_state = 0},
  [3055] = {.lex_state = 0},
  [3056] = {.lex_state = 0},
  [3057] = {.lex_state = 0},
  [3058] = {.lex_state = 0},
  [3059] = {.lex_state = 0},
  [3060] = {.lex_state = 0},
  [3061] = {.lex_state = 24},
  [3062] = {.lex_state = 0},
  [3063] = {.lex_state = 24},
  [3064] = {.lex_state = 0},
  [3065] = {.lex_state = 0},
  [3066] = {.lex_state = 0},
  [3067] = {.lex_state = 0},
  [3068] = {.lex_state = 0},
  [3069] = {.lex_state = 0},
  [3070] = {.lex_state = 0},
  [3071] = {.lex_state = 0},
  [3072] = {.lex_state = 0},
  [3073] = {.lex_state = 0},
  [3074] = {.lex_state = 0},
  [3075] = {.lex_state = 0},
  [3076] = {.lex_state = 0},
  [3077] = {.lex_state = 24},
  [3078] = {.lex_state = 0},
  [3079] = {.lex_state = 0},
  [3080] = {.lex_state = 0},
  [3081] = {.lex_state = 0},
  [3082] = {.lex_state = 0},
  [3083] = {.lex_state = 0},
  [3084] = {.lex_state = 24},
  [3085] = {.lex_state = 0},
  [3086] = {.lex_state = 0},
  [3087] = {.lex_state = 24},
  [3088] = {.lex_state = 24},
  [3089] = {.lex_state = 0},
  [3090] = {.lex_state = 0},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 0},
  [3093] = {.lex_state = 0},
  [3094] = {.lex_state = 29},
  [3095] = {.lex_state = 0},
  [3096] = {.lex_state = 0},
  [3097] = {.lex_state = 0},
  [3098] = {.lex_state = 0},
  [3099] = {.lex_state = 0},
  [3100] = {.lex_state = 0},
  [3101] = {.lex_state = 0},
  [3102] = {.lex_state = 0},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 0},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 0},
  [3107] = {.lex_state = 0},
  [3108] = {.lex_state = 0},
  [3109] = {.lex_state = 0},
  [3110] = {.lex_state = 0},
  [3111] = {.lex_state = 0},
  [3112] = {.lex_state = 0},
  [3113] = {.lex_state = 24},
  [3114] = {.lex_state = 24},
  [3115] = {.lex_state = 24},
  [3116] = {.lex_state = 24},
  [3117] = {.lex_state = 24},
  [3118] = {.lex_state = 24},
  [3119] = {.lex_state = 0},
  [3120] = {.lex_state = 0},
  [3121] = {.lex_state = 0},
  [3122] = {.lex_state = 0},
  [3123] = {.lex_state = 0},
  [3124] = {.lex_state = 0},
  [3125] = {.lex_state = 0},
  [3126] = {.lex_state = 0},
  [3127] = {.lex_state = 0},
  [3128] = {.lex_state = 0},
  [3129] = {.lex_state = 0},
  [3130] = {.lex_state = 0},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 0},
  [3133] = {.lex_state = 0},
  [3134] = {.lex_state = 0},
  [3135] = {.lex_state = 0},
  [3136] = {.lex_state = 0},
  [3137] = {.lex_state = 24},
  [3138] = {.lex_state = 24},
  [3139] = {.lex_state = 24},
  [3140] = {.lex_state = 24},
  [3141] = {.lex_state = 0},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 24},
  [3144] = {.lex_state = 24},
  [3145] = {.lex_state = 0},
  [3146] = {.lex_state = 0},
  [3147] = {.lex_state = 0},
  [3148] = {.lex_state = 0},
  [3149] = {.lex_state = 0},
  [3150] = {.lex_state = 0},
  [3151] = {.lex_state = 0},
  [3152] = {.lex_state = 24},
  [3153] = {.lex_state = 24},
  [3154] = {.lex_state = 24},
  [3155] = {.lex_state = 24},
  [3156] = {.lex_state = 24},
  [3157] = {.lex_state = 24},
  [3158] = {.lex_state = 0},
  [3159] = {.lex_state = 0},
  [3160] = {.lex_state = 0},
  [3161] = {.lex_state = 0},
  [3162] = {.lex_state = 0},
  [3163] = {.lex_state = 0},
  [3164] = {.lex_state = 0},
  [3165] = {.lex_state = 0},
  [3166] = {.lex_state = 0},
  [3167] = {.lex_state = 0},
  [3168] = {.lex_state = 0},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 0},
  [3171] = {.lex_state = 25},
  [3172] = {.lex_state = 0},
  [3173] = {.lex_state = 0},
  [3174] = {.lex_state = 0},
  [3175] = {.lex_state = 0},
  [3176] = {.lex_state = 0},
  [3177] = {.lex_state = 0},
  [3178] = {.lex_state = 0},
  [3179] = {.lex_state = 0},
  [3180] = {.lex_state = 0},
  [3181] = {.lex_state = 0},
  [3182] = {.lex_state = 0},
  [3183] = {.lex_state = 0},
  [3184] = {.lex_state = 0},
  [3185] = {.lex_state = 0},
  [3186] = {.lex_state = 0},
  [3187] = {.lex_state = 0},
  [3188] = {.lex_state = 0},
  [3189] = {.lex_state = 24},
  [3190] = {.lex_state = 24},
  [3191] = {.lex_state = 24},
  [3192] = {.lex_state = 24},
  [3193] = {.lex_state = 24},
  [3194] = {.lex_state = 24},
  [3195] = {.lex_state = 0},
  [3196] = {.lex_state = 0},
  [3197] = {.lex_state = 0},
  [3198] = {.lex_state = 0},
  [3199] = {.lex_state = 0},
  [3200] = {.lex_state = 0},
  [3201] = {.lex_state = 0},
  [3202] = {.lex_state = 0},
  [3203] = {.lex_state = 0},
  [3204] = {.lex_state = 0},
  [3205] = {.lex_state = 24},
  [3206] = {.lex_state = 24},
  [3207] = {.lex_state = 24},
  [3208] = {.lex_state = 0},
  [3209] = {.lex_state = 24},
  [3210] = {.lex_state = 0},
  [3211] = {.lex_state = 0},
  [3212] = {.lex_state = 0},
  [3213] = {.lex_state = 0},
  [3214] = {.lex_state = 0},
  [3215] = {.lex_state = 0},
  [3216] = {.lex_state = 0},
  [3217] = {.lex_state = 24},
  [3218] = {.lex_state = 0},
  [3219] = {.lex_state = 0},
  [3220] = {.lex_state = 0},
  [3221] = {.lex_state = 0},
  [3222] = {.lex_state = 0},
  [3223] = {.lex_state = 0},
  [3224] = {.lex_state = 0},
  [3225] = {.lex_state = 0},
  [3226] = {.lex_state = 24},
  [3227] = {.lex_state = 30},
  [3228] = {.lex_state = 29},
  [3229] = {.lex_state = 0, .external_lex_state = 3},
  [3230] = {.lex_state = 0, .external_lex_state = 4},
  [3231] = {.lex_state = 0, .external_lex_state = 5},
  [3232] = {.lex_state = 0, .external_lex_state = 6},
  [3233] = {.lex_state = 0, .external_lex_state = 7},
  [3234] = {.lex_state = 0, .external_lex_state = 8},
  [3235] = {.lex_state = 0, .external_lex_state = 9},
  [3236] = {.lex_state = 25},
  [3237] = {.lex_state = 25},
  [3238] = {.lex_state = 0, .external_lex_state = 9},
  [3239] = {.lex_state = 0, .external_lex_state = 8},
  [3240] = {.lex_state = 0, .external_lex_state = 7},
  [3241] = {.lex_state = 0, .external_lex_state = 6},
  [3242] = {.lex_state = 0, .external_lex_state = 5},
  [3243] = {.lex_state = 0, .external_lex_state = 4},
  [3244] = {.lex_state = 0, .external_lex_state = 3},
  [3245] = {.lex_state = 30},
  [3246] = {.lex_state = 29},
  [3247] = {.lex_state = 35},
  [3248] = {.lex_state = 0},
  [3249] = {.lex_state = 0},
  [3250] = {.lex_state = 29},
  [3251] = {.lex_state = 0},
  [3252] = {.lex_state = 0, .external_lex_state = 3},
  [3253] = {.lex_state = 0, .external_lex_state = 4},
  [3254] = {.lex_state = 30},
  [3255] = {.lex_state = 0, .external_lex_state = 5},
  [3256] = {.lex_state = 0, .external_lex_state = 6},
  [3257] = {.lex_state = 0, .external_lex_state = 7},
  [3258] = {.lex_state = 0, .external_lex_state = 8},
  [3259] = {.lex_state = 0, .external_lex_state = 9},
  [3260] = {.lex_state = 25},
  [3261] = {.lex_state = 0},
  [3262] = {.lex_state = 0},
  [3263] = {.lex_state = 0},
  [3264] = {.lex_state = 30},
  [3265] = {.lex_state = 0},
  [3266] = {.lex_state = 0},
  [3267] = {.lex_state = 0},
  [3268] = {.lex_state = 0},
  [3269] = {.lex_state = 0},
  [3270] = {.lex_state = 29},
  [3271] = {.lex_state = 0, .external_lex_state = 3},
  [3272] = {.lex_state = 0, .external_lex_state = 4},
  [3273] = {.lex_state = 25},
  [3274] = {.lex_state = 0, .external_lex_state = 5},
  [3275] = {.lex_state = 0, .external_lex_state = 9},
  [3276] = {.lex_state = 0, .external_lex_state = 8},
  [3277] = {.lex_state = 0, .external_lex_state = 7},
  [3278] = {.lex_state = 0, .external_lex_state = 6},
  [3279] = {.lex_state = 0, .external_lex_state = 5},
  [3280] = {.lex_state = 0, .external_lex_state = 4},
  [3281] = {.lex_state = 0, .external_lex_state = 3},
  [3282] = {.lex_state = 0, .external_lex_state = 6},
  [3283] = {.lex_state = 29},
  [3284] = {.lex_state = 0, .external_lex_state = 7},
  [3285] = {.lex_state = 0, .external_lex_state = 8},
  [3286] = {.lex_state = 0, .external_lex_state = 9},
  [3287] = {.lex_state = 25},
  [3288] = {.lex_state = 25},
  [3289] = {.lex_state = 30},
  [3290] = {.lex_state = 0},
  [3291] = {.lex_state = 30},
  [3292] = {.lex_state = 29},
  [3293] = {.lex_state = 25},
  [3294] = {.lex_state = 0, .external_lex_state = 3},
  [3295] = {.lex_state = 0, .external_lex_state = 4},
  [3296] = {.lex_state = 0, .external_lex_state = 5},
  [3297] = {.lex_state = 0, .external_lex_state = 6},
  [3298] = {.lex_state = 0, .external_lex_state = 7},
  [3299] = {.lex_state = 0, .external_lex_state = 8},
  [3300] = {.lex_state = 0, .external_lex_state = 9},
  [3301] = {.lex_state = 25},
  [3302] = {.lex_state = 0},
  [3303] = {.lex_state = 25},
  [3304] = {.lex_state = 27},
  [3305] = {.lex_state = 0},
  [3306] = {.lex_state = 25},
  [3307] = {.lex_state = 0},
  [3308] = {.lex_state = 0},
  [3309] = {.lex_state = 25},
  [3310] = {.lex_state = 0},
  [3311] = {.lex_state = 35},
  [3312] = {.lex_state = 29},
  [3313] = {.lex_state = 0},
  [3314] = {.lex_state = 25},
  [3315] = {.lex_state = 25},
  [3316] = {.lex_state = 0},
  [3317] = {.lex_state = 0},
  [3318] = {.lex_state = 0, .external_lex_state = 6},
  [3319] = {.lex_state = 0},
  [3320] = {.lex_state = 30},
  [3321] = {.lex_state = 25},
  [3322] = {.lex_state = 0},
  [3323] = {.lex_state = 0},
  [3324] = {.lex_state = 25},
  [3325] = {.lex_state = 0},
  [3326] = {.lex_state = 35},
  [3327] = {.lex_state = 0},
  [3328] = {.lex_state = 0},
  [3329] = {.lex_state = 0, .external_lex_state = 9},
  [3330] = {.lex_state = 0, .external_lex_state = 8},
  [3331] = {.lex_state = 0, .external_lex_state = 7},
  [3332] = {.lex_state = 25},
  [3333] = {.lex_state = 25},
  [3334] = {.lex_state = 35},
  [3335] = {.lex_state = 29},
  [3336] = {.lex_state = 0},
  [3337] = {.lex_state = 0},
  [3338] = {.lex_state = 0},
  [3339] = {.lex_state = 0},
  [3340] = {.lex_state = 0},
  [3341] = {.lex_state = 0, .external_lex_state = 6},
  [3342] = {.lex_state = 30},
  [3343] = {.lex_state = 0, .external_lex_state = 5},
  [3344] = {.lex_state = 0},
  [3345] = {.lex_state = 0},
  [3346] = {.lex_state = 0, .external_lex_state = 4},
  [3347] = {.lex_state = 0},
  [3348] = {.lex_state = 0},
  [3349] = {.lex_state = 0},
  [3350] = {.lex_state = 0, .external_lex_state = 3},
  [3351] = {.lex_state = 0},
  [3352] = {.lex_state = 0},
  [3353] = {.lex_state = 25},
  [3354] = {.lex_state = 0},
  [3355] = {.lex_state = 25},
  [3356] = {.lex_state = 29},
  [3357] = {.lex_state = 0},
  [3358] = {.lex_state = 25},
  [3359] = {.lex_state = 25},
  [3360] = {.lex_state = 0},
  [3361] = {.lex_state = 0},
  [3362] = {.lex_state = 0, .external_lex_state = 9},
  [3363] = {.lex_state = 30},
  [3364] = {.lex_state = 0},
  [3365] = {.lex_state = 0},
  [3366] = {.lex_state = 0},
  [3367] = {.lex_state = 0},
  [3368] = {.lex_state = 0},
  [3369] = {.lex_state = 0},
  [3370] = {.lex_state = 0},
  [3371] = {.lex_state = 35},
  [3372] = {.lex_state = 0},
  [3373] = {.lex_state = 0, .external_lex_state = 8},
  [3374] = {.lex_state = 0, .external_lex_state = 7},
  [3375] = {.lex_state = 0, .external_lex_state = 5},
  [3376] = {.lex_state = 0},
  [3377] = {.lex_state = 25},
  [3378] = {.lex_state = 0},
  [3379] = {.lex_state = 0, .external_lex_state = 4},
  [3380] = {.lex_state = 0},
  [3381] = {.lex_state = 0},
  [3382] = {.lex_state = 0},
  [3383] = {.lex_state = 25},
  [3384] = {.lex_state = 0},
  [3385] = {.lex_state = 25},
  [3386] = {.lex_state = 0, .external_lex_state = 9},
  [3387] = {.lex_state = 0, .external_lex_state = 8},
  [3388] = {.lex_state = 0},
  [3389] = {.lex_state = 0},
  [3390] = {.lex_state = 0},
  [3391] = {.lex_state = 0},
  [3392] = {.lex_state = 0, .external_lex_state = 7},
  [3393] = {.lex_state = 0},
  [3394] = {.lex_state = 0},
  [3395] = {.lex_state = 0, .external_lex_state = 5},
  [3396] = {.lex_state = 0, .external_lex_state = 4},
  [3397] = {.lex_state = 0},
  [3398] = {.lex_state = 0},
  [3399] = {.lex_state = 0},
  [3400] = {.lex_state = 0},
  [3401] = {.lex_state = 0, .external_lex_state = 3},
  [3402] = {.lex_state = 0},
  [3403] = {.lex_state = 0},
  [3404] = {.lex_state = 0, .external_lex_state = 6},
  [3405] = {.lex_state = 0},
  [3406] = {.lex_state = 35},
  [3407] = {.lex_state = 29},
  [3408] = {.lex_state = 0},
  [3409] = {.lex_state = 0},
  [3410] = {.lex_state = 29},
  [3411] = {.lex_state = 0},
  [3412] = {.lex_state = 0, .external_lex_state = 3},
  [3413] = {.lex_state = 35},
  [3414] = {.lex_state = 0},
  [3415] = {.lex_state = 0},
  [3416] = {.lex_state = 25},
  [3417] = {.lex_state = 0},
  [3418] = {.lex_state = 0},
  [3419] = {.lex_state = 25},
  [3420] = {.lex_state = 0},
  [3421] = {.lex_state = 0},
  [3422] = {.lex_state = 25},
  [3423] = {.lex_state = 0},
  [3424] = {.lex_state = 0},
  [3425] = {.lex_state = 0},
  [3426] = {.lex_state = 0},
  [3427] = {.lex_state = 0},
  [3428] = {.lex_state = 0},
  [3429] = {.lex_state = 0},
  [3430] = {.lex_state = 0},
  [3431] = {.lex_state = 0},
  [3432] = {.lex_state = 35},
  [3433] = {.lex_state = 0},
  [3434] = {.lex_state = 35},
  [3435] = {.lex_state = 0},
  [3436] = {.lex_state = 0},
  [3437] = {.lex_state = 0},
  [3438] = {.lex_state = 0},
  [3439] = {.lex_state = 0},
  [3440] = {.lex_state = 0},
  [3441] = {.lex_state = 25},
  [3442] = {.lex_state = 0},
  [3443] = {.lex_state = 0},
  [3444] = {.lex_state = 0},
  [3445] = {.lex_state = 0},
  [3446] = {.lex_state = 0},
  [3447] = {.lex_state = 0},
  [3448] = {.lex_state = 25},
  [3449] = {.lex_state = 0},
  [3450] = {.lex_state = 0},
  [3451] = {.lex_state = 0},
  [3452] = {.lex_state = 25},
  [3453] = {.lex_state = 0},
  [3454] = {.lex_state = 0},
  [3455] = {.lex_state = 0},
  [3456] = {.lex_state = 30},
  [3457] = {.lex_state = 0},
  [3458] = {.lex_state = 0},
  [3459] = {.lex_state = 0},
  [3460] = {.lex_state = 0},
  [3461] = {.lex_state = 0},
  [3462] = {.lex_state = 0},
  [3463] = {.lex_state = 0},
  [3464] = {.lex_state = 0},
  [3465] = {.lex_state = 0},
  [3466] = {.lex_state = 0},
  [3467] = {.lex_state = 35},
  [3468] = {.lex_state = 35},
  [3469] = {.lex_state = 0, .external_lex_state = 6},
  [3470] = {.lex_state = 25},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_command_name] = ACTIONS(1),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1),
    [anon_sym_BSLASHfi] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_BSLASHpart] = ACTIONS(1),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(1),
    [anon_sym_BSLASHaddpart] = ACTIONS(1),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(1),
    [anon_sym_BSLASHchapter] = ACTIONS(1),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(1),
    [anon_sym_BSLASHaddchap] = ACTIONS(1),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(1),
    [anon_sym_BSLASHsection] = ACTIONS(1),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(1),
    [anon_sym_BSLASHaddsec] = ACTIONS(1),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(1),
    [anon_sym_BSLASHsubsection] = ACTIONS(1),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(1),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(1),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(1),
    [anon_sym_BSLASHparagraph] = ACTIONS(1),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(1),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(1),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(1),
    [anon_sym_BSLASHitem] = ACTIONS(1),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_BSLASHand] = ACTIONS(1),
    [sym_word] = ACTIONS(1),
    [sym_placeholder] = ACTIONS(1),
    [sym_argc] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_letter] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1),
    [anon_sym_BSLASHbegin] = ACTIONS(1),
    [anon_sym_BSLASHend] = ACTIONS(1),
    [anon_sym_BSLASHtitle] = ACTIONS(1),
    [anon_sym_BSLASHauthor] = ACTIONS(1),
    [anon_sym_BSLASHusepackage] = ACTIONS(1),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1),
    [anon_sym_BSLASHinclude] = ACTIONS(1),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1),
    [anon_sym_BSLASHinput] = ACTIONS(1),
    [anon_sym_BSLASHsubfile] = ACTIONS(1),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1),
    [anon_sym_BSLASHbibliography] = ACTIONS(1),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1),
    [anon_sym_BSLASHimport] = ACTIONS(1),
    [anon_sym_BSLASHsubimport] = ACTIONS(1),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1),
    [anon_sym_BSLASHcaption] = ACTIONS(1),
    [anon_sym_BSLASHcite] = ACTIONS(1),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1),
    [anon_sym_BSLASHCite] = ACTIONS(1),
    [anon_sym_BSLASHnocite] = ACTIONS(1),
    [anon_sym_BSLASHcitet] = ACTIONS(1),
    [anon_sym_BSLASHcitep] = ACTIONS(1),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1),
    [anon_sym_BSLASHciteA] = ACTIONS(1),
    [anon_sym_BSLASHciteR] = ACTIONS(1),
    [anon_sym_BSLASHciteS] = ACTIONS(1),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1),
    [anon_sym_BSLASHciteyear] = ACTIONS(1),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1),
    [anon_sym_BSLASHcitedate] = ACTIONS(1),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1),
    [anon_sym_BSLASHciteurl] = ACTIONS(1),
    [anon_sym_BSLASHfullcite] = ACTIONS(1),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1),
    [anon_sym_BSLASHcitealt] = ACTIONS(1),
    [anon_sym_BSLASHcitealp] = ACTIONS(1),
    [anon_sym_BSLASHcitetext] = ACTIONS(1),
    [anon_sym_BSLASHparencite] = ACTIONS(1),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1),
    [anon_sym_BSLASHParencite] = ACTIONS(1),
    [anon_sym_BSLASHfootcite] = ACTIONS(1),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1),
    [anon_sym_BSLASHtextcite] = ACTIONS(1),
    [anon_sym_BSLASHTextcite] = ACTIONS(1),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1),
    [anon_sym_BSLASHsupercite] = ACTIONS(1),
    [anon_sym_BSLASHautocite] = ACTIONS(1),
    [anon_sym_BSLASHAutocite] = ACTIONS(1),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1),
    [anon_sym_BSLASHvolcite] = ACTIONS(1),
    [anon_sym_BSLASHVolcite] = ACTIONS(1),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1),
    [anon_sym_BSLASHavolcite] = ACTIONS(1),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1),
    [anon_sym_BSLASHnotecite] = ACTIONS(1),
    [anon_sym_BSLASHNotecite] = ACTIONS(1),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1),
    [anon_sym_BSLASHlabel] = ACTIONS(1),
    [anon_sym_BSLASHref] = ACTIONS(1),
    [anon_sym_BSLASHeqref] = ACTIONS(1),
    [anon_sym_BSLASHvref] = ACTIONS(1),
    [anon_sym_BSLASHVref] = ACTIONS(1),
    [anon_sym_BSLASHautoref] = ACTIONS(1),
    [anon_sym_BSLASHpageref] = ACTIONS(1),
    [anon_sym_BSLASHcref] = ACTIONS(1),
    [anon_sym_BSLASHCref] = ACTIONS(1),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1),
    [anon_sym_BSLASHnamecref] = ACTIONS(1),
    [anon_sym_BSLASHnameCref] = ACTIONS(1),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1),
    [anon_sym_BSLASHdef] = ACTIONS(1),
    [anon_sym_BSLASHlet] = ACTIONS(1),
    [anon_sym_BSLASHleft] = ACTIONS(1),
    [anon_sym_BSLASHbigl] = ACTIONS(1),
    [anon_sym_BSLASHBigl] = ACTIONS(1),
    [anon_sym_BSLASHbiggl] = ACTIONS(1),
    [anon_sym_BSLASHBiggl] = ACTIONS(1),
    [anon_sym_BSLASHright] = ACTIONS(1),
    [anon_sym_BSLASHbigr] = ACTIONS(1),
    [anon_sym_BSLASHBigr] = ACTIONS(1),
    [anon_sym_BSLASHbiggr] = ACTIONS(1),
    [anon_sym_BSLASHBiggr] = ACTIONS(1),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1),
    [anon_sym_BSLASHgls] = ACTIONS(1),
    [anon_sym_BSLASHGls] = ACTIONS(1),
    [anon_sym_BSLASHGLS] = ACTIONS(1),
    [anon_sym_BSLASHglspl] = ACTIONS(1),
    [anon_sym_BSLASHGlspl] = ACTIONS(1),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1),
    [anon_sym_BSLASHglslink] = ACTIONS(1),
    [anon_sym_BSLASHglstext] = ACTIONS(1),
    [anon_sym_BSLASHGlstext] = ACTIONS(1),
    [anon_sym_BSLASHGLStext] = ACTIONS(1),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1),
    [anon_sym_BSLASHglsplural] = ACTIONS(1),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1),
    [anon_sym_BSLASHglsname] = ACTIONS(1),
    [anon_sym_BSLASHGlsname] = ACTIONS(1),
    [anon_sym_BSLASHGLSname] = ACTIONS(1),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1),
    [anon_sym_BSLASHacrshort] = ACTIONS(1),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1),
    [anon_sym_BSLASHACRshort] = ACTIONS(1),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1),
    [anon_sym_BSLASHacrlong] = ACTIONS(1),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1),
    [anon_sym_BSLASHACRlong] = ACTIONS(1),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1),
    [anon_sym_BSLASHacrfull] = ACTIONS(1),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1),
    [anon_sym_BSLASHACRfull] = ACTIONS(1),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1),
    [anon_sym_BSLASHacs] = ACTIONS(1),
    [anon_sym_BSLASHAcs] = ACTIONS(1),
    [anon_sym_BSLASHacsp] = ACTIONS(1),
    [anon_sym_BSLASHAcsp] = ACTIONS(1),
    [anon_sym_BSLASHacl] = ACTIONS(1),
    [anon_sym_BSLASHAcl] = ACTIONS(1),
    [anon_sym_BSLASHaclp] = ACTIONS(1),
    [anon_sym_BSLASHAclp] = ACTIONS(1),
    [anon_sym_BSLASHacf] = ACTIONS(1),
    [anon_sym_BSLASHAcf] = ACTIONS(1),
    [anon_sym_BSLASHacfp] = ACTIONS(1),
    [anon_sym_BSLASHAcfp] = ACTIONS(1),
    [anon_sym_BSLASHac] = ACTIONS(1),
    [anon_sym_BSLASHAc] = ACTIONS(1),
    [anon_sym_BSLASHacp] = ACTIONS(1),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1),
    [anon_sym_BSLASHcolor] = ACTIONS(1),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1),
    [anon_sym_BSLASHtext] = ACTIONS(1),
    [anon_sym_BSLASHintertext] = ACTIONS(1),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1),
    [anon_sym_BSLASHurl] = ACTIONS(1),
    [anon_sym_BSLASHhref] = ACTIONS(1),
    [sym__trivia_raw_fi] = ACTIONS(1),
    [sym__trivia_raw_env_comment] = ACTIONS(1),
    [sym__trivia_raw_env_verbatim] = ACTIONS(1),
    [sym__trivia_raw_env_listing] = ACTIONS(1),
    [sym__trivia_raw_env_minted] = ACTIONS(1),
    [sym__trivia_raw_env_pycode] = ACTIONS(1),
    [sym__trivia_raw_env_sagesilent] = ACTIONS(1),
    [sym__trivia_raw_env_sageblock] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(3328),
    [sym_block_comment] = STATE(74),
    [sym__root_content] = STATE(74),
    [sym__flat_content] = STATE(74),
    [sym__text_with_env_content] = STATE(74),
    [sym__text_content] = STATE(74),
    [sym__section] = STATE(74),
    [sym__paragraph] = STATE(74),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(74),
    [sym_text] = STATE(74),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(74),
    [sym_inline_formula] = STATE(74),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(74),
    [sym_comment_environment] = STATE(74),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(74),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(74),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(74),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(74),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(74),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(74),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(74),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(74),
    [sym_generic_command] = STATE(74),
    [sym_title_declaration] = STATE(74),
    [sym_author_declaration] = STATE(74),
    [sym_package_include] = STATE(74),
    [sym_class_include] = STATE(74),
    [sym_latex_include] = STATE(74),
    [sym_biblatex_include] = STATE(74),
    [sym_bibstyle_include] = STATE(74),
    [sym_bibtex_include] = STATE(74),
    [sym_graphics_include] = STATE(74),
    [sym_svg_include] = STATE(74),
    [sym_inkscape_include] = STATE(74),
    [sym_verbatim_include] = STATE(74),
    [sym_import_include] = STATE(74),
    [sym_caption] = STATE(74),
    [sym_citation] = STATE(74),
    [sym_label_definition] = STATE(74),
    [sym_label_reference] = STATE(74),
    [sym_label_reference_range] = STATE(74),
    [sym_label_number] = STATE(74),
    [sym_new_command_definition] = STATE(74),
    [sym_old_command_definition] = STATE(74),
    [sym_let_command_definition] = STATE(74),
    [sym_math_delimiter] = STATE(74),
    [sym_paired_delimiter_definition] = STATE(74),
    [sym_environment_definition] = STATE(74),
    [sym_glossary_entry_definition] = STATE(74),
    [sym_glossary_entry_reference] = STATE(74),
    [sym_acronym_definition] = STATE(74),
    [sym_acronym_reference] = STATE(74),
    [sym_theorem_definition] = STATE(74),
    [sym_color_definition] = STATE(74),
    [sym_color_set_definition] = STATE(74),
    [sym_color_reference] = STATE(74),
    [sym_tikz_library_import] = STATE(74),
    [sym_text_mode] = STATE(74),
    [sym_hyperlink] = STATE(74),
    [aux_sym_source_file_repeat1] = STATE(74),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_RBRACK] = ACTIONS(11),
    [anon_sym_COMMA] = ACTIONS(11),
    [anon_sym_EQ] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_RPAREN] = ACTIONS(11),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [2] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHright] = ACTIONS(149),
    [anon_sym_BSLASHbigr] = ACTIONS(149),
    [anon_sym_BSLASHBigr] = ACTIONS(149),
    [anon_sym_BSLASHbiggr] = ACTIONS(149),
    [anon_sym_BSLASHBiggr] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [3] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHright] = ACTIONS(155),
    [anon_sym_BSLASHbigr] = ACTIONS(155),
    [anon_sym_BSLASHBigr] = ACTIONS(155),
    [anon_sym_BSLASHbiggr] = ACTIONS(155),
    [anon_sym_BSLASHBiggr] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [4] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHright] = ACTIONS(161),
    [anon_sym_BSLASHbigr] = ACTIONS(161),
    [anon_sym_BSLASHBigr] = ACTIONS(161),
    [anon_sym_BSLASHbiggr] = ACTIONS(161),
    [anon_sym_BSLASHBiggr] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [5] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHright] = ACTIONS(165),
    [anon_sym_BSLASHbigr] = ACTIONS(165),
    [anon_sym_BSLASHBigr] = ACTIONS(165),
    [anon_sym_BSLASHbiggr] = ACTIONS(165),
    [anon_sym_BSLASHBiggr] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [6] = {
    [sym_block_comment] = STATE(23),
    [sym__root_content] = STATE(23),
    [sym__flat_content] = STATE(23),
    [sym__text_with_env_content] = STATE(23),
    [sym__text_content] = STATE(23),
    [sym__section] = STATE(23),
    [sym__paragraph] = STATE(23),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(23),
    [sym_text] = STATE(23),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(23),
    [sym_inline_formula] = STATE(23),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(23),
    [sym_comment_environment] = STATE(23),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(23),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(23),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(23),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(23),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(23),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(23),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(23),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(23),
    [sym_generic_command] = STATE(23),
    [sym_title_declaration] = STATE(23),
    [sym_author_declaration] = STATE(23),
    [sym_package_include] = STATE(23),
    [sym_class_include] = STATE(23),
    [sym_latex_include] = STATE(23),
    [sym_biblatex_include] = STATE(23),
    [sym_bibstyle_include] = STATE(23),
    [sym_bibtex_include] = STATE(23),
    [sym_graphics_include] = STATE(23),
    [sym_svg_include] = STATE(23),
    [sym_inkscape_include] = STATE(23),
    [sym_verbatim_include] = STATE(23),
    [sym_import_include] = STATE(23),
    [sym_caption] = STATE(23),
    [sym_citation] = STATE(23),
    [sym_label_definition] = STATE(23),
    [sym_label_reference] = STATE(23),
    [sym_label_reference_range] = STATE(23),
    [sym_label_number] = STATE(23),
    [sym_new_command_definition] = STATE(23),
    [sym_old_command_definition] = STATE(23),
    [sym_let_command_definition] = STATE(23),
    [sym_math_delimiter] = STATE(23),
    [sym_paired_delimiter_definition] = STATE(23),
    [sym_environment_definition] = STATE(23),
    [sym_glossary_entry_definition] = STATE(23),
    [sym_glossary_entry_reference] = STATE(23),
    [sym_acronym_definition] = STATE(23),
    [sym_acronym_reference] = STATE(23),
    [sym_theorem_definition] = STATE(23),
    [sym_color_definition] = STATE(23),
    [sym_color_set_definition] = STATE(23),
    [sym_color_reference] = STATE(23),
    [sym_tikz_library_import] = STATE(23),
    [sym_text_mode] = STATE(23),
    [sym_hyperlink] = STATE(23),
    [aux_sym_source_file_repeat1] = STATE(23),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(173),
    [anon_sym_RBRACK] = ACTIONS(173),
    [anon_sym_COMMA] = ACTIONS(173),
    [anon_sym_EQ] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(173),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(281),
    [anon_sym_BSLASHbigr] = ACTIONS(281),
    [anon_sym_BSLASHBigr] = ACTIONS(281),
    [anon_sym_BSLASHbiggr] = ACTIONS(281),
    [anon_sym_BSLASHBiggr] = ACTIONS(281),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [7] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(313),
    [anon_sym_BSLASHbigr] = ACTIONS(313),
    [anon_sym_BSLASHBigr] = ACTIONS(313),
    [anon_sym_BSLASHbiggr] = ACTIONS(313),
    [anon_sym_BSLASHBiggr] = ACTIONS(313),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [8] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(315),
    [anon_sym_BSLASHbigr] = ACTIONS(315),
    [anon_sym_BSLASHBigr] = ACTIONS(315),
    [anon_sym_BSLASHbiggr] = ACTIONS(315),
    [anon_sym_BSLASHBiggr] = ACTIONS(315),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [9] = {
    [sym_block_comment] = STATE(16),
    [sym__root_content] = STATE(16),
    [sym__flat_content] = STATE(16),
    [sym__text_with_env_content] = STATE(16),
    [sym__text_content] = STATE(16),
    [sym__section] = STATE(16),
    [sym__paragraph] = STATE(16),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(16),
    [sym_text] = STATE(16),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(16),
    [sym_inline_formula] = STATE(16),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(16),
    [sym_comment_environment] = STATE(16),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(16),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(16),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(16),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(16),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(16),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(16),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(16),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(16),
    [sym_generic_command] = STATE(16),
    [sym_title_declaration] = STATE(16),
    [sym_author_declaration] = STATE(16),
    [sym_package_include] = STATE(16),
    [sym_class_include] = STATE(16),
    [sym_latex_include] = STATE(16),
    [sym_biblatex_include] = STATE(16),
    [sym_bibstyle_include] = STATE(16),
    [sym_bibtex_include] = STATE(16),
    [sym_graphics_include] = STATE(16),
    [sym_svg_include] = STATE(16),
    [sym_inkscape_include] = STATE(16),
    [sym_verbatim_include] = STATE(16),
    [sym_import_include] = STATE(16),
    [sym_caption] = STATE(16),
    [sym_citation] = STATE(16),
    [sym_label_definition] = STATE(16),
    [sym_label_reference] = STATE(16),
    [sym_label_reference_range] = STATE(16),
    [sym_label_number] = STATE(16),
    [sym_new_command_definition] = STATE(16),
    [sym_old_command_definition] = STATE(16),
    [sym_let_command_definition] = STATE(16),
    [sym_math_delimiter] = STATE(16),
    [sym_paired_delimiter_definition] = STATE(16),
    [sym_environment_definition] = STATE(16),
    [sym_glossary_entry_definition] = STATE(16),
    [sym_glossary_entry_reference] = STATE(16),
    [sym_acronym_definition] = STATE(16),
    [sym_acronym_reference] = STATE(16),
    [sym_theorem_definition] = STATE(16),
    [sym_color_definition] = STATE(16),
    [sym_color_set_definition] = STATE(16),
    [sym_color_reference] = STATE(16),
    [sym_tikz_library_import] = STATE(16),
    [sym_text_mode] = STATE(16),
    [sym_hyperlink] = STATE(16),
    [aux_sym_source_file_repeat1] = STATE(16),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(317),
    [anon_sym_RBRACK] = ACTIONS(317),
    [anon_sym_COMMA] = ACTIONS(317),
    [anon_sym_EQ] = ACTIONS(317),
    [anon_sym_LPAREN] = ACTIONS(317),
    [anon_sym_RPAREN] = ACTIONS(317),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(319),
    [anon_sym_BSLASHbigr] = ACTIONS(319),
    [anon_sym_BSLASHBigr] = ACTIONS(319),
    [anon_sym_BSLASHbiggr] = ACTIONS(319),
    [anon_sym_BSLASHBiggr] = ACTIONS(319),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [10] = {
    [sym_block_comment] = STATE(17),
    [sym__root_content] = STATE(17),
    [sym__flat_content] = STATE(17),
    [sym__text_with_env_content] = STATE(17),
    [sym__text_content] = STATE(17),
    [sym__section] = STATE(17),
    [sym__paragraph] = STATE(17),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(17),
    [sym_text] = STATE(17),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(17),
    [sym_inline_formula] = STATE(17),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(17),
    [sym_comment_environment] = STATE(17),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(17),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(17),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(17),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(17),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(17),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(17),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(17),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(17),
    [sym_generic_command] = STATE(17),
    [sym_title_declaration] = STATE(17),
    [sym_author_declaration] = STATE(17),
    [sym_package_include] = STATE(17),
    [sym_class_include] = STATE(17),
    [sym_latex_include] = STATE(17),
    [sym_biblatex_include] = STATE(17),
    [sym_bibstyle_include] = STATE(17),
    [sym_bibtex_include] = STATE(17),
    [sym_graphics_include] = STATE(17),
    [sym_svg_include] = STATE(17),
    [sym_inkscape_include] = STATE(17),
    [sym_verbatim_include] = STATE(17),
    [sym_import_include] = STATE(17),
    [sym_caption] = STATE(17),
    [sym_citation] = STATE(17),
    [sym_label_definition] = STATE(17),
    [sym_label_reference] = STATE(17),
    [sym_label_reference_range] = STATE(17),
    [sym_label_number] = STATE(17),
    [sym_new_command_definition] = STATE(17),
    [sym_old_command_definition] = STATE(17),
    [sym_let_command_definition] = STATE(17),
    [sym_math_delimiter] = STATE(17),
    [sym_paired_delimiter_definition] = STATE(17),
    [sym_environment_definition] = STATE(17),
    [sym_glossary_entry_definition] = STATE(17),
    [sym_glossary_entry_reference] = STATE(17),
    [sym_acronym_definition] = STATE(17),
    [sym_acronym_reference] = STATE(17),
    [sym_theorem_definition] = STATE(17),
    [sym_color_definition] = STATE(17),
    [sym_color_set_definition] = STATE(17),
    [sym_color_reference] = STATE(17),
    [sym_tikz_library_import] = STATE(17),
    [sym_text_mode] = STATE(17),
    [sym_hyperlink] = STATE(17),
    [aux_sym_source_file_repeat1] = STATE(17),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(321),
    [anon_sym_RBRACK] = ACTIONS(321),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(321),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(323),
    [anon_sym_BSLASHbigr] = ACTIONS(323),
    [anon_sym_BSLASHBigr] = ACTIONS(323),
    [anon_sym_BSLASHbiggr] = ACTIONS(323),
    [anon_sym_BSLASHBiggr] = ACTIONS(323),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [11] = {
    [sym_block_comment] = STATE(12),
    [sym__root_content] = STATE(12),
    [sym__flat_content] = STATE(12),
    [sym__text_with_env_content] = STATE(12),
    [sym__text_content] = STATE(12),
    [sym__section] = STATE(12),
    [sym__paragraph] = STATE(12),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(12),
    [sym_text] = STATE(12),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(12),
    [sym_inline_formula] = STATE(12),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(12),
    [sym_comment_environment] = STATE(12),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(12),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(12),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(12),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(12),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(12),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(12),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(12),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(12),
    [sym_generic_command] = STATE(12),
    [sym_title_declaration] = STATE(12),
    [sym_author_declaration] = STATE(12),
    [sym_package_include] = STATE(12),
    [sym_class_include] = STATE(12),
    [sym_latex_include] = STATE(12),
    [sym_biblatex_include] = STATE(12),
    [sym_bibstyle_include] = STATE(12),
    [sym_bibtex_include] = STATE(12),
    [sym_graphics_include] = STATE(12),
    [sym_svg_include] = STATE(12),
    [sym_inkscape_include] = STATE(12),
    [sym_verbatim_include] = STATE(12),
    [sym_import_include] = STATE(12),
    [sym_caption] = STATE(12),
    [sym_citation] = STATE(12),
    [sym_label_definition] = STATE(12),
    [sym_label_reference] = STATE(12),
    [sym_label_reference_range] = STATE(12),
    [sym_label_number] = STATE(12),
    [sym_new_command_definition] = STATE(12),
    [sym_old_command_definition] = STATE(12),
    [sym_let_command_definition] = STATE(12),
    [sym_math_delimiter] = STATE(12),
    [sym_paired_delimiter_definition] = STATE(12),
    [sym_environment_definition] = STATE(12),
    [sym_glossary_entry_definition] = STATE(12),
    [sym_glossary_entry_reference] = STATE(12),
    [sym_acronym_definition] = STATE(12),
    [sym_acronym_reference] = STATE(12),
    [sym_theorem_definition] = STATE(12),
    [sym_color_definition] = STATE(12),
    [sym_color_set_definition] = STATE(12),
    [sym_color_reference] = STATE(12),
    [sym_tikz_library_import] = STATE(12),
    [sym_text_mode] = STATE(12),
    [sym_hyperlink] = STATE(12),
    [aux_sym_source_file_repeat1] = STATE(12),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(325),
    [anon_sym_RBRACK] = ACTIONS(325),
    [anon_sym_COMMA] = ACTIONS(325),
    [anon_sym_EQ] = ACTIONS(325),
    [anon_sym_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(327),
    [anon_sym_BSLASHbigr] = ACTIONS(327),
    [anon_sym_BSLASHBigr] = ACTIONS(327),
    [anon_sym_BSLASHbiggr] = ACTIONS(327),
    [anon_sym_BSLASHBiggr] = ACTIONS(327),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [12] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(329),
    [anon_sym_BSLASHbigr] = ACTIONS(329),
    [anon_sym_BSLASHBigr] = ACTIONS(329),
    [anon_sym_BSLASHbiggr] = ACTIONS(329),
    [anon_sym_BSLASHBiggr] = ACTIONS(329),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [13] = {
    [sym_block_comment] = STATE(7),
    [sym__root_content] = STATE(7),
    [sym__flat_content] = STATE(7),
    [sym__text_with_env_content] = STATE(7),
    [sym__text_content] = STATE(7),
    [sym__section] = STATE(7),
    [sym__paragraph] = STATE(7),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(7),
    [sym_text] = STATE(7),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(7),
    [sym_inline_formula] = STATE(7),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(7),
    [sym_comment_environment] = STATE(7),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(7),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(7),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(7),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(7),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(7),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(7),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(7),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(7),
    [sym_generic_command] = STATE(7),
    [sym_title_declaration] = STATE(7),
    [sym_author_declaration] = STATE(7),
    [sym_package_include] = STATE(7),
    [sym_class_include] = STATE(7),
    [sym_latex_include] = STATE(7),
    [sym_biblatex_include] = STATE(7),
    [sym_bibstyle_include] = STATE(7),
    [sym_bibtex_include] = STATE(7),
    [sym_graphics_include] = STATE(7),
    [sym_svg_include] = STATE(7),
    [sym_inkscape_include] = STATE(7),
    [sym_verbatim_include] = STATE(7),
    [sym_import_include] = STATE(7),
    [sym_caption] = STATE(7),
    [sym_citation] = STATE(7),
    [sym_label_definition] = STATE(7),
    [sym_label_reference] = STATE(7),
    [sym_label_reference_range] = STATE(7),
    [sym_label_number] = STATE(7),
    [sym_new_command_definition] = STATE(7),
    [sym_old_command_definition] = STATE(7),
    [sym_let_command_definition] = STATE(7),
    [sym_math_delimiter] = STATE(7),
    [sym_paired_delimiter_definition] = STATE(7),
    [sym_environment_definition] = STATE(7),
    [sym_glossary_entry_definition] = STATE(7),
    [sym_glossary_entry_reference] = STATE(7),
    [sym_acronym_definition] = STATE(7),
    [sym_acronym_reference] = STATE(7),
    [sym_theorem_definition] = STATE(7),
    [sym_color_definition] = STATE(7),
    [sym_color_set_definition] = STATE(7),
    [sym_color_reference] = STATE(7),
    [sym_tikz_library_import] = STATE(7),
    [sym_text_mode] = STATE(7),
    [sym_hyperlink] = STATE(7),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(331),
    [anon_sym_RBRACK] = ACTIONS(331),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(331),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(333),
    [anon_sym_BSLASHbigr] = ACTIONS(333),
    [anon_sym_BSLASHBigr] = ACTIONS(333),
    [anon_sym_BSLASHbiggr] = ACTIONS(333),
    [anon_sym_BSLASHBiggr] = ACTIONS(333),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [14] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(335),
    [anon_sym_BSLASHbigr] = ACTIONS(335),
    [anon_sym_BSLASHBigr] = ACTIONS(335),
    [anon_sym_BSLASHbiggr] = ACTIONS(335),
    [anon_sym_BSLASHBiggr] = ACTIONS(335),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [15] = {
    [sym_block_comment] = STATE(14),
    [sym__root_content] = STATE(14),
    [sym__flat_content] = STATE(14),
    [sym__text_with_env_content] = STATE(14),
    [sym__text_content] = STATE(14),
    [sym__section] = STATE(14),
    [sym__paragraph] = STATE(14),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(14),
    [sym_text] = STATE(14),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(14),
    [sym_inline_formula] = STATE(14),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(14),
    [sym_comment_environment] = STATE(14),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(14),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(14),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(14),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(14),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(14),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(14),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(14),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(14),
    [sym_generic_command] = STATE(14),
    [sym_title_declaration] = STATE(14),
    [sym_author_declaration] = STATE(14),
    [sym_package_include] = STATE(14),
    [sym_class_include] = STATE(14),
    [sym_latex_include] = STATE(14),
    [sym_biblatex_include] = STATE(14),
    [sym_bibstyle_include] = STATE(14),
    [sym_bibtex_include] = STATE(14),
    [sym_graphics_include] = STATE(14),
    [sym_svg_include] = STATE(14),
    [sym_inkscape_include] = STATE(14),
    [sym_verbatim_include] = STATE(14),
    [sym_import_include] = STATE(14),
    [sym_caption] = STATE(14),
    [sym_citation] = STATE(14),
    [sym_label_definition] = STATE(14),
    [sym_label_reference] = STATE(14),
    [sym_label_reference_range] = STATE(14),
    [sym_label_number] = STATE(14),
    [sym_new_command_definition] = STATE(14),
    [sym_old_command_definition] = STATE(14),
    [sym_let_command_definition] = STATE(14),
    [sym_math_delimiter] = STATE(14),
    [sym_paired_delimiter_definition] = STATE(14),
    [sym_environment_definition] = STATE(14),
    [sym_glossary_entry_definition] = STATE(14),
    [sym_glossary_entry_reference] = STATE(14),
    [sym_acronym_definition] = STATE(14),
    [sym_acronym_reference] = STATE(14),
    [sym_theorem_definition] = STATE(14),
    [sym_color_definition] = STATE(14),
    [sym_color_set_definition] = STATE(14),
    [sym_color_reference] = STATE(14),
    [sym_tikz_library_import] = STATE(14),
    [sym_text_mode] = STATE(14),
    [sym_hyperlink] = STATE(14),
    [aux_sym_source_file_repeat1] = STATE(14),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(337),
    [anon_sym_COMMA] = ACTIONS(337),
    [anon_sym_EQ] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(337),
    [anon_sym_RPAREN] = ACTIONS(337),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(339),
    [anon_sym_BSLASHbigr] = ACTIONS(339),
    [anon_sym_BSLASHBigr] = ACTIONS(339),
    [anon_sym_BSLASHbiggr] = ACTIONS(339),
    [anon_sym_BSLASHBiggr] = ACTIONS(339),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [16] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(341),
    [anon_sym_BSLASHbigr] = ACTIONS(341),
    [anon_sym_BSLASHBigr] = ACTIONS(341),
    [anon_sym_BSLASHbiggr] = ACTIONS(341),
    [anon_sym_BSLASHBiggr] = ACTIONS(341),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [17] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(343),
    [anon_sym_BSLASHbigr] = ACTIONS(343),
    [anon_sym_BSLASHBigr] = ACTIONS(343),
    [anon_sym_BSLASHbiggr] = ACTIONS(343),
    [anon_sym_BSLASHBiggr] = ACTIONS(343),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [18] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(345),
    [anon_sym_BSLASHbigr] = ACTIONS(345),
    [anon_sym_BSLASHBigr] = ACTIONS(345),
    [anon_sym_BSLASHbiggr] = ACTIONS(345),
    [anon_sym_BSLASHBiggr] = ACTIONS(345),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [19] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(347),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(353),
    [anon_sym_RBRACK] = ACTIONS(353),
    [anon_sym_COMMA] = ACTIONS(353),
    [anon_sym_EQ] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(353),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_BSLASHpart] = ACTIONS(356),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(359),
    [anon_sym_BSLASHaddpart] = ACTIONS(356),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(359),
    [anon_sym_BSLASHchapter] = ACTIONS(362),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(365),
    [anon_sym_BSLASHaddchap] = ACTIONS(362),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(365),
    [anon_sym_BSLASHsection] = ACTIONS(368),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(371),
    [anon_sym_BSLASHaddsec] = ACTIONS(368),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(371),
    [anon_sym_BSLASHsubsection] = ACTIONS(374),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(377),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(380),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(383),
    [anon_sym_BSLASHparagraph] = ACTIONS(386),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(389),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(392),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(395),
    [anon_sym_BSLASHitem] = ACTIONS(398),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(401),
    [anon_sym_LBRACE] = ACTIONS(404),
    [sym_word] = ACTIONS(407),
    [sym_placeholder] = ACTIONS(410),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_STAR] = ACTIONS(413),
    [anon_sym_SLASH] = ACTIONS(413),
    [anon_sym_LT] = ACTIONS(416),
    [anon_sym_GT] = ACTIONS(416),
    [anon_sym_BANG] = ACTIONS(416),
    [anon_sym_PIPE] = ACTIONS(416),
    [anon_sym_COLON] = ACTIONS(416),
    [anon_sym_SQUOTE] = ACTIONS(416),
    [anon_sym__] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(422),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(425),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(425),
    [anon_sym_DOLLAR] = ACTIONS(428),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(431),
    [anon_sym_BSLASHbegin] = ACTIONS(434),
    [anon_sym_BSLASHtitle] = ACTIONS(437),
    [anon_sym_BSLASHauthor] = ACTIONS(440),
    [anon_sym_BSLASHusepackage] = ACTIONS(443),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(443),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(446),
    [anon_sym_BSLASHinclude] = ACTIONS(449),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(449),
    [anon_sym_BSLASHinput] = ACTIONS(449),
    [anon_sym_BSLASHsubfile] = ACTIONS(449),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(452),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(455),
    [anon_sym_BSLASHbibliography] = ACTIONS(458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(461),
    [anon_sym_BSLASHincludesvg] = ACTIONS(464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(467),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(470),
    [anon_sym_BSLASHimport] = ACTIONS(473),
    [anon_sym_BSLASHsubimport] = ACTIONS(473),
    [anon_sym_BSLASHinputfrom] = ACTIONS(473),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(473),
    [anon_sym_BSLASHincludefrom] = ACTIONS(473),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(473),
    [anon_sym_BSLASHcaption] = ACTIONS(476),
    [anon_sym_BSLASHcite] = ACTIONS(479),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(482),
    [anon_sym_BSLASHCite] = ACTIONS(479),
    [anon_sym_BSLASHnocite] = ACTIONS(479),
    [anon_sym_BSLASHcitet] = ACTIONS(479),
    [anon_sym_BSLASHcitep] = ACTIONS(479),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(482),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(482),
    [anon_sym_BSLASHciteA] = ACTIONS(479),
    [anon_sym_BSLASHciteR] = ACTIONS(479),
    [anon_sym_BSLASHciteS] = ACTIONS(479),
    [anon_sym_BSLASHciteyearR] = ACTIONS(479),
    [anon_sym_BSLASHciteauthor] = ACTIONS(479),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(482),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(479),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(482),
    [anon_sym_BSLASHcitetitle] = ACTIONS(479),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(482),
    [anon_sym_BSLASHciteyear] = ACTIONS(479),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(482),
    [anon_sym_BSLASHcitedate] = ACTIONS(479),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(482),
    [anon_sym_BSLASHciteurl] = ACTIONS(479),
    [anon_sym_BSLASHfullcite] = ACTIONS(479),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(479),
    [anon_sym_BSLASHcitealt] = ACTIONS(479),
    [anon_sym_BSLASHcitealp] = ACTIONS(479),
    [anon_sym_BSLASHcitetext] = ACTIONS(479),
    [anon_sym_BSLASHparencite] = ACTIONS(479),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(482),
    [anon_sym_BSLASHParencite] = ACTIONS(479),
    [anon_sym_BSLASHfootcite] = ACTIONS(479),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(479),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(479),
    [anon_sym_BSLASHtextcite] = ACTIONS(479),
    [anon_sym_BSLASHTextcite] = ACTIONS(479),
    [anon_sym_BSLASHsmartcite] = ACTIONS(479),
    [anon_sym_BSLASHSmartcite] = ACTIONS(479),
    [anon_sym_BSLASHsupercite] = ACTIONS(479),
    [anon_sym_BSLASHautocite] = ACTIONS(479),
    [anon_sym_BSLASHAutocite] = ACTIONS(479),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(482),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(482),
    [anon_sym_BSLASHvolcite] = ACTIONS(479),
    [anon_sym_BSLASHVolcite] = ACTIONS(479),
    [anon_sym_BSLASHpvolcite] = ACTIONS(479),
    [anon_sym_BSLASHPvolcite] = ACTIONS(479),
    [anon_sym_BSLASHfvolcite] = ACTIONS(479),
    [anon_sym_BSLASHftvolcite] = ACTIONS(479),
    [anon_sym_BSLASHsvolcite] = ACTIONS(479),
    [anon_sym_BSLASHSvolcite] = ACTIONS(479),
    [anon_sym_BSLASHtvolcite] = ACTIONS(479),
    [anon_sym_BSLASHTvolcite] = ACTIONS(479),
    [anon_sym_BSLASHavolcite] = ACTIONS(479),
    [anon_sym_BSLASHAvolcite] = ACTIONS(479),
    [anon_sym_BSLASHnotecite] = ACTIONS(479),
    [anon_sym_BSLASHNotecite] = ACTIONS(479),
    [anon_sym_BSLASHpnotecite] = ACTIONS(479),
    [anon_sym_BSLASHPnotecite] = ACTIONS(479),
    [anon_sym_BSLASHfnotecite] = ACTIONS(479),
    [anon_sym_BSLASHlabel] = ACTIONS(485),
    [anon_sym_BSLASHref] = ACTIONS(488),
    [anon_sym_BSLASHeqref] = ACTIONS(488),
    [anon_sym_BSLASHvref] = ACTIONS(488),
    [anon_sym_BSLASHVref] = ACTIONS(488),
    [anon_sym_BSLASHautoref] = ACTIONS(488),
    [anon_sym_BSLASHpageref] = ACTIONS(488),
    [anon_sym_BSLASHcref] = ACTIONS(488),
    [anon_sym_BSLASHCref] = ACTIONS(488),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(491),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(491),
    [anon_sym_BSLASHnamecref] = ACTIONS(488),
    [anon_sym_BSLASHnameCref] = ACTIONS(488),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(488),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(488),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(488),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(488),
    [anon_sym_BSLASHlabelcref] = ACTIONS(488),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(488),
    [anon_sym_BSLASHcrefrange] = ACTIONS(494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(497),
    [anon_sym_BSLASHCrefrange] = ACTIONS(494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(497),
    [anon_sym_BSLASHnewlabel] = ACTIONS(500),
    [anon_sym_BSLASHnewcommand] = ACTIONS(503),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(506),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(503),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(506),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(503),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(506),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(503),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(506),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(503),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(503),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(503),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(503),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(503),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(503),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(503),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(503),
    [anon_sym_BSLASHdef] = ACTIONS(509),
    [anon_sym_BSLASHlet] = ACTIONS(512),
    [anon_sym_BSLASHleft] = ACTIONS(515),
    [anon_sym_BSLASHbigl] = ACTIONS(515),
    [anon_sym_BSLASHBigl] = ACTIONS(515),
    [anon_sym_BSLASHbiggl] = ACTIONS(515),
    [anon_sym_BSLASHBiggl] = ACTIONS(515),
    [anon_sym_BSLASHright] = ACTIONS(518),
    [anon_sym_BSLASHbigr] = ACTIONS(518),
    [anon_sym_BSLASHBigr] = ACTIONS(518),
    [anon_sym_BSLASHbiggr] = ACTIONS(518),
    [anon_sym_BSLASHBiggr] = ACTIONS(518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(520),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(520),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(523),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(523),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(523),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(523),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(523),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(523),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(526),
    [anon_sym_BSLASHgls] = ACTIONS(529),
    [anon_sym_BSLASHGls] = ACTIONS(529),
    [anon_sym_BSLASHGLS] = ACTIONS(529),
    [anon_sym_BSLASHglspl] = ACTIONS(529),
    [anon_sym_BSLASHGlspl] = ACTIONS(529),
    [anon_sym_BSLASHGLSpl] = ACTIONS(529),
    [anon_sym_BSLASHglsdisp] = ACTIONS(529),
    [anon_sym_BSLASHglslink] = ACTIONS(529),
    [anon_sym_BSLASHglstext] = ACTIONS(529),
    [anon_sym_BSLASHGlstext] = ACTIONS(529),
    [anon_sym_BSLASHGLStext] = ACTIONS(529),
    [anon_sym_BSLASHglsfirst] = ACTIONS(529),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(529),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(529),
    [anon_sym_BSLASHglsplural] = ACTIONS(529),
    [anon_sym_BSLASHGlsplural] = ACTIONS(529),
    [anon_sym_BSLASHGLSplural] = ACTIONS(529),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(529),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(529),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(529),
    [anon_sym_BSLASHglsname] = ACTIONS(529),
    [anon_sym_BSLASHGlsname] = ACTIONS(529),
    [anon_sym_BSLASHGLSname] = ACTIONS(529),
    [anon_sym_BSLASHglssymbol] = ACTIONS(529),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(529),
    [anon_sym_BSLASHglsdesc] = ACTIONS(529),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(529),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(529),
    [anon_sym_BSLASHglsuseri] = ACTIONS(529),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(529),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(529),
    [anon_sym_BSLASHglsuserii] = ACTIONS(529),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(529),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(529),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(529),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(529),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(529),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(529),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(529),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(529),
    [anon_sym_BSLASHglsuserv] = ACTIONS(529),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(529),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(529),
    [anon_sym_BSLASHglsuservi] = ACTIONS(529),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(529),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(529),
    [anon_sym_BSLASHnewacronym] = ACTIONS(532),
    [anon_sym_BSLASHacrshort] = ACTIONS(535),
    [anon_sym_BSLASHAcrshort] = ACTIONS(535),
    [anon_sym_BSLASHACRshort] = ACTIONS(535),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(535),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(535),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(535),
    [anon_sym_BSLASHacrlong] = ACTIONS(535),
    [anon_sym_BSLASHAcrlong] = ACTIONS(535),
    [anon_sym_BSLASHACRlong] = ACTIONS(535),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(535),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(535),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(535),
    [anon_sym_BSLASHacrfull] = ACTIONS(535),
    [anon_sym_BSLASHAcrfull] = ACTIONS(535),
    [anon_sym_BSLASHACRfull] = ACTIONS(535),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(535),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(535),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(535),
    [anon_sym_BSLASHacs] = ACTIONS(535),
    [anon_sym_BSLASHAcs] = ACTIONS(535),
    [anon_sym_BSLASHacsp] = ACTIONS(535),
    [anon_sym_BSLASHAcsp] = ACTIONS(535),
    [anon_sym_BSLASHacl] = ACTIONS(535),
    [anon_sym_BSLASHAcl] = ACTIONS(535),
    [anon_sym_BSLASHaclp] = ACTIONS(535),
    [anon_sym_BSLASHAclp] = ACTIONS(535),
    [anon_sym_BSLASHacf] = ACTIONS(535),
    [anon_sym_BSLASHAcf] = ACTIONS(535),
    [anon_sym_BSLASHacfp] = ACTIONS(535),
    [anon_sym_BSLASHAcfp] = ACTIONS(535),
    [anon_sym_BSLASHac] = ACTIONS(535),
    [anon_sym_BSLASHAc] = ACTIONS(535),
    [anon_sym_BSLASHacp] = ACTIONS(535),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(535),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(535),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(535),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(535),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(535),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(535),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(535),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(535),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(535),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(535),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(538),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(541),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(538),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(541),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(544),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(547),
    [anon_sym_BSLASHcolor] = ACTIONS(550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(553),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(553),
    [anon_sym_BSLASHtext] = ACTIONS(556),
    [anon_sym_BSLASHintertext] = ACTIONS(556),
    [anon_sym_BSLASHshortintertext] = ACTIONS(556),
    [anon_sym_BSLASHurl] = ACTIONS(559),
    [anon_sym_BSLASHhref] = ACTIONS(559),
  },
  [20] = {
    [sym_block_comment] = STATE(18),
    [sym__root_content] = STATE(18),
    [sym__flat_content] = STATE(18),
    [sym__text_with_env_content] = STATE(18),
    [sym__text_content] = STATE(18),
    [sym__section] = STATE(18),
    [sym__paragraph] = STATE(18),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(18),
    [sym_text] = STATE(18),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(18),
    [sym_inline_formula] = STATE(18),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(18),
    [sym_comment_environment] = STATE(18),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(18),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(18),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(18),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(18),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(18),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(18),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(18),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(18),
    [sym_generic_command] = STATE(18),
    [sym_title_declaration] = STATE(18),
    [sym_author_declaration] = STATE(18),
    [sym_package_include] = STATE(18),
    [sym_class_include] = STATE(18),
    [sym_latex_include] = STATE(18),
    [sym_biblatex_include] = STATE(18),
    [sym_bibstyle_include] = STATE(18),
    [sym_bibtex_include] = STATE(18),
    [sym_graphics_include] = STATE(18),
    [sym_svg_include] = STATE(18),
    [sym_inkscape_include] = STATE(18),
    [sym_verbatim_include] = STATE(18),
    [sym_import_include] = STATE(18),
    [sym_caption] = STATE(18),
    [sym_citation] = STATE(18),
    [sym_label_definition] = STATE(18),
    [sym_label_reference] = STATE(18),
    [sym_label_reference_range] = STATE(18),
    [sym_label_number] = STATE(18),
    [sym_new_command_definition] = STATE(18),
    [sym_old_command_definition] = STATE(18),
    [sym_let_command_definition] = STATE(18),
    [sym_math_delimiter] = STATE(18),
    [sym_paired_delimiter_definition] = STATE(18),
    [sym_environment_definition] = STATE(18),
    [sym_glossary_entry_definition] = STATE(18),
    [sym_glossary_entry_reference] = STATE(18),
    [sym_acronym_definition] = STATE(18),
    [sym_acronym_reference] = STATE(18),
    [sym_theorem_definition] = STATE(18),
    [sym_color_definition] = STATE(18),
    [sym_color_set_definition] = STATE(18),
    [sym_color_reference] = STATE(18),
    [sym_tikz_library_import] = STATE(18),
    [sym_text_mode] = STATE(18),
    [sym_hyperlink] = STATE(18),
    [aux_sym_source_file_repeat1] = STATE(18),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_RBRACK] = ACTIONS(562),
    [anon_sym_COMMA] = ACTIONS(562),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(562),
    [anon_sym_RPAREN] = ACTIONS(562),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(564),
    [anon_sym_BSLASHbigr] = ACTIONS(564),
    [anon_sym_BSLASHBigr] = ACTIONS(564),
    [anon_sym_BSLASHbiggr] = ACTIONS(564),
    [anon_sym_BSLASHBiggr] = ACTIONS(564),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [21] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(566),
    [anon_sym_BSLASHbigr] = ACTIONS(566),
    [anon_sym_BSLASHBigr] = ACTIONS(566),
    [anon_sym_BSLASHbiggr] = ACTIONS(566),
    [anon_sym_BSLASHBiggr] = ACTIONS(566),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [22] = {
    [sym_block_comment] = STATE(21),
    [sym__root_content] = STATE(21),
    [sym__flat_content] = STATE(21),
    [sym__text_with_env_content] = STATE(21),
    [sym__text_content] = STATE(21),
    [sym__section] = STATE(21),
    [sym__paragraph] = STATE(21),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(21),
    [sym_text] = STATE(21),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(21),
    [sym_inline_formula] = STATE(21),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(21),
    [sym_comment_environment] = STATE(21),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(21),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(21),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(21),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(21),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(21),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(21),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(21),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(21),
    [sym_generic_command] = STATE(21),
    [sym_title_declaration] = STATE(21),
    [sym_author_declaration] = STATE(21),
    [sym_package_include] = STATE(21),
    [sym_class_include] = STATE(21),
    [sym_latex_include] = STATE(21),
    [sym_biblatex_include] = STATE(21),
    [sym_bibstyle_include] = STATE(21),
    [sym_bibtex_include] = STATE(21),
    [sym_graphics_include] = STATE(21),
    [sym_svg_include] = STATE(21),
    [sym_inkscape_include] = STATE(21),
    [sym_verbatim_include] = STATE(21),
    [sym_import_include] = STATE(21),
    [sym_caption] = STATE(21),
    [sym_citation] = STATE(21),
    [sym_label_definition] = STATE(21),
    [sym_label_reference] = STATE(21),
    [sym_label_reference_range] = STATE(21),
    [sym_label_number] = STATE(21),
    [sym_new_command_definition] = STATE(21),
    [sym_old_command_definition] = STATE(21),
    [sym_let_command_definition] = STATE(21),
    [sym_math_delimiter] = STATE(21),
    [sym_paired_delimiter_definition] = STATE(21),
    [sym_environment_definition] = STATE(21),
    [sym_glossary_entry_definition] = STATE(21),
    [sym_glossary_entry_reference] = STATE(21),
    [sym_acronym_definition] = STATE(21),
    [sym_acronym_reference] = STATE(21),
    [sym_theorem_definition] = STATE(21),
    [sym_color_definition] = STATE(21),
    [sym_color_set_definition] = STATE(21),
    [sym_color_reference] = STATE(21),
    [sym_tikz_library_import] = STATE(21),
    [sym_text_mode] = STATE(21),
    [sym_hyperlink] = STATE(21),
    [aux_sym_source_file_repeat1] = STATE(21),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(568),
    [anon_sym_RBRACK] = ACTIONS(568),
    [anon_sym_COMMA] = ACTIONS(568),
    [anon_sym_EQ] = ACTIONS(568),
    [anon_sym_LPAREN] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(568),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(570),
    [anon_sym_BSLASHbigr] = ACTIONS(570),
    [anon_sym_BSLASHBigr] = ACTIONS(570),
    [anon_sym_BSLASHbiggr] = ACTIONS(570),
    [anon_sym_BSLASHBiggr] = ACTIONS(570),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [23] = {
    [sym_block_comment] = STATE(19),
    [sym__root_content] = STATE(19),
    [sym__flat_content] = STATE(19),
    [sym__text_with_env_content] = STATE(19),
    [sym__text_content] = STATE(19),
    [sym__section] = STATE(19),
    [sym__paragraph] = STATE(19),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(19),
    [sym_text] = STATE(19),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(19),
    [sym_inline_formula] = STATE(19),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(19),
    [sym_comment_environment] = STATE(19),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(19),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(19),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(19),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(19),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(19),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(19),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(19),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(19),
    [sym_generic_command] = STATE(19),
    [sym_title_declaration] = STATE(19),
    [sym_author_declaration] = STATE(19),
    [sym_package_include] = STATE(19),
    [sym_class_include] = STATE(19),
    [sym_latex_include] = STATE(19),
    [sym_biblatex_include] = STATE(19),
    [sym_bibstyle_include] = STATE(19),
    [sym_bibtex_include] = STATE(19),
    [sym_graphics_include] = STATE(19),
    [sym_svg_include] = STATE(19),
    [sym_inkscape_include] = STATE(19),
    [sym_verbatim_include] = STATE(19),
    [sym_import_include] = STATE(19),
    [sym_caption] = STATE(19),
    [sym_citation] = STATE(19),
    [sym_label_definition] = STATE(19),
    [sym_label_reference] = STATE(19),
    [sym_label_reference_range] = STATE(19),
    [sym_label_number] = STATE(19),
    [sym_new_command_definition] = STATE(19),
    [sym_old_command_definition] = STATE(19),
    [sym_let_command_definition] = STATE(19),
    [sym_math_delimiter] = STATE(19),
    [sym_paired_delimiter_definition] = STATE(19),
    [sym_environment_definition] = STATE(19),
    [sym_glossary_entry_definition] = STATE(19),
    [sym_glossary_entry_reference] = STATE(19),
    [sym_acronym_definition] = STATE(19),
    [sym_acronym_reference] = STATE(19),
    [sym_theorem_definition] = STATE(19),
    [sym_color_definition] = STATE(19),
    [sym_color_set_definition] = STATE(19),
    [sym_color_reference] = STATE(19),
    [sym_tikz_library_import] = STATE(19),
    [sym_text_mode] = STATE(19),
    [sym_hyperlink] = STATE(19),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(311),
    [anon_sym_RBRACK] = ACTIONS(311),
    [anon_sym_COMMA] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(311),
    [anon_sym_LPAREN] = ACTIONS(311),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(572),
    [anon_sym_BSLASHbigr] = ACTIONS(572),
    [anon_sym_BSLASHBigr] = ACTIONS(572),
    [anon_sym_BSLASHbiggr] = ACTIONS(572),
    [anon_sym_BSLASHBiggr] = ACTIONS(572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [24] = {
    [sym_block_comment] = STATE(8),
    [sym__root_content] = STATE(8),
    [sym__flat_content] = STATE(8),
    [sym__text_with_env_content] = STATE(8),
    [sym__text_content] = STATE(8),
    [sym__section] = STATE(8),
    [sym__paragraph] = STATE(8),
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(419),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(418),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(417),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(416),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(404),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(8),
    [sym_text] = STATE(8),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(8),
    [sym_inline_formula] = STATE(8),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(8),
    [sym_comment_environment] = STATE(8),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(8),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(8),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(8),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(8),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(8),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(8),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(8),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(8),
    [sym_generic_command] = STATE(8),
    [sym_title_declaration] = STATE(8),
    [sym_author_declaration] = STATE(8),
    [sym_package_include] = STATE(8),
    [sym_class_include] = STATE(8),
    [sym_latex_include] = STATE(8),
    [sym_biblatex_include] = STATE(8),
    [sym_bibstyle_include] = STATE(8),
    [sym_bibtex_include] = STATE(8),
    [sym_graphics_include] = STATE(8),
    [sym_svg_include] = STATE(8),
    [sym_inkscape_include] = STATE(8),
    [sym_verbatim_include] = STATE(8),
    [sym_import_include] = STATE(8),
    [sym_caption] = STATE(8),
    [sym_citation] = STATE(8),
    [sym_label_definition] = STATE(8),
    [sym_label_reference] = STATE(8),
    [sym_label_reference_range] = STATE(8),
    [sym_label_number] = STATE(8),
    [sym_new_command_definition] = STATE(8),
    [sym_old_command_definition] = STATE(8),
    [sym_let_command_definition] = STATE(8),
    [sym_math_delimiter] = STATE(8),
    [sym_paired_delimiter_definition] = STATE(8),
    [sym_environment_definition] = STATE(8),
    [sym_glossary_entry_definition] = STATE(8),
    [sym_glossary_entry_reference] = STATE(8),
    [sym_acronym_definition] = STATE(8),
    [sym_acronym_reference] = STATE(8),
    [sym_theorem_definition] = STATE(8),
    [sym_color_definition] = STATE(8),
    [sym_color_set_definition] = STATE(8),
    [sym_color_reference] = STATE(8),
    [sym_tikz_library_import] = STATE(8),
    [sym_text_mode] = STATE(8),
    [sym_hyperlink] = STATE(8),
    [aux_sym_source_file_repeat1] = STATE(8),
    [aux_sym__section_repeat1] = STATE(419),
    [aux_sym__section_repeat2] = STATE(418),
    [aux_sym__section_repeat3] = STATE(417),
    [aux_sym__section_repeat4] = STATE(416),
    [aux_sym__section_repeat5] = STATE(404),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_RBRACK] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(574),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(576),
    [anon_sym_BSLASHbigr] = ACTIONS(576),
    [anon_sym_BSLASHBigr] = ACTIONS(576),
    [anon_sym_BSLASHbiggr] = ACTIONS(576),
    [anon_sym_BSLASHBiggr] = ACTIONS(576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [25] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(578),
    [anon_sym_RBRACK] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(578),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(167),
    [anon_sym_RBRACE] = ACTIONS(167),
    [anon_sym_BSLASHand] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [26] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [ts_builtin_sym_end] = ACTIONS(167),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [anon_sym_RBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [27] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [28] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [29] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [ts_builtin_sym_end] = ACTIONS(157),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_RBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [30] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_RBRACK] = ACTIONS(612),
    [anon_sym_COMMA] = ACTIONS(612),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_BSLASHand] = ACTIONS(161),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [31] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(578),
    [anon_sym_RBRACK] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(578),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_BSLASHand] = ACTIONS(149),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [32] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_RBRACK] = ACTIONS(612),
    [anon_sym_COMMA] = ACTIONS(612),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_RBRACE] = ACTIONS(157),
    [anon_sym_BSLASHand] = ACTIONS(155),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [33] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(612),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_RBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [34] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [35] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [36] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHend] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [37] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHend] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [38] = {
    [sym_block_comment] = STATE(59),
    [sym__root_content] = STATE(59),
    [sym__flat_content] = STATE(59),
    [sym__text_with_env_content] = STATE(59),
    [sym__text_content] = STATE(59),
    [sym__section] = STATE(59),
    [sym__paragraph] = STATE(59),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(59),
    [sym_text] = STATE(59),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(59),
    [sym_inline_formula] = STATE(59),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1856),
    [sym_generic_environment] = STATE(59),
    [sym_comment_environment] = STATE(59),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(59),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(59),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(59),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(59),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(59),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(59),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(59),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(59),
    [sym_generic_command] = STATE(59),
    [sym_title_declaration] = STATE(59),
    [sym_author_declaration] = STATE(59),
    [sym_package_include] = STATE(59),
    [sym_class_include] = STATE(59),
    [sym_latex_include] = STATE(59),
    [sym_biblatex_include] = STATE(59),
    [sym_bibstyle_include] = STATE(59),
    [sym_bibtex_include] = STATE(59),
    [sym_graphics_include] = STATE(59),
    [sym_svg_include] = STATE(59),
    [sym_inkscape_include] = STATE(59),
    [sym_verbatim_include] = STATE(59),
    [sym_import_include] = STATE(59),
    [sym_caption] = STATE(59),
    [sym_citation] = STATE(59),
    [sym_label_definition] = STATE(59),
    [sym_label_reference] = STATE(59),
    [sym_label_reference_range] = STATE(59),
    [sym_label_number] = STATE(59),
    [sym_new_command_definition] = STATE(59),
    [sym_old_command_definition] = STATE(59),
    [sym_let_command_definition] = STATE(59),
    [sym_math_delimiter] = STATE(59),
    [sym_paired_delimiter_definition] = STATE(59),
    [sym_environment_definition] = STATE(59),
    [sym_glossary_entry_definition] = STATE(59),
    [sym_glossary_entry_reference] = STATE(59),
    [sym_acronym_definition] = STATE(59),
    [sym_acronym_reference] = STATE(59),
    [sym_theorem_definition] = STATE(59),
    [sym_color_definition] = STATE(59),
    [sym_color_set_definition] = STATE(59),
    [sym_color_reference] = STATE(59),
    [sym_tikz_library_import] = STATE(59),
    [sym_text_mode] = STATE(59),
    [sym_hyperlink] = STATE(59),
    [aux_sym_source_file_repeat1] = STATE(59),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(650),
    [anon_sym_RBRACK] = ACTIONS(650),
    [anon_sym_COMMA] = ACTIONS(650),
    [anon_sym_EQ] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(650),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(704),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [39] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_RBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [40] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(612),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [41] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHend] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [42] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [43] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [44] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(167),
    [anon_sym_RBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [45] = {
    [sym_block_comment] = STATE(125),
    [sym__root_content] = STATE(125),
    [sym__flat_content] = STATE(125),
    [sym__text_with_env_content] = STATE(125),
    [sym__text_content] = STATE(125),
    [sym__section] = STATE(125),
    [sym__paragraph] = STATE(125),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(125),
    [sym_text] = STATE(125),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(125),
    [sym_inline_formula] = STATE(125),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1412),
    [sym_generic_environment] = STATE(125),
    [sym_comment_environment] = STATE(125),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(125),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(125),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(125),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(125),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(125),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(125),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(125),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(125),
    [sym_generic_command] = STATE(125),
    [sym_title_declaration] = STATE(125),
    [sym_author_declaration] = STATE(125),
    [sym_package_include] = STATE(125),
    [sym_class_include] = STATE(125),
    [sym_latex_include] = STATE(125),
    [sym_biblatex_include] = STATE(125),
    [sym_bibstyle_include] = STATE(125),
    [sym_bibtex_include] = STATE(125),
    [sym_graphics_include] = STATE(125),
    [sym_svg_include] = STATE(125),
    [sym_inkscape_include] = STATE(125),
    [sym_verbatim_include] = STATE(125),
    [sym_import_include] = STATE(125),
    [sym_caption] = STATE(125),
    [sym_citation] = STATE(125),
    [sym_label_definition] = STATE(125),
    [sym_label_reference] = STATE(125),
    [sym_label_reference_range] = STATE(125),
    [sym_label_number] = STATE(125),
    [sym_new_command_definition] = STATE(125),
    [sym_old_command_definition] = STATE(125),
    [sym_let_command_definition] = STATE(125),
    [sym_math_delimiter] = STATE(125),
    [sym_paired_delimiter_definition] = STATE(125),
    [sym_environment_definition] = STATE(125),
    [sym_glossary_entry_definition] = STATE(125),
    [sym_glossary_entry_reference] = STATE(125),
    [sym_acronym_definition] = STATE(125),
    [sym_acronym_reference] = STATE(125),
    [sym_theorem_definition] = STATE(125),
    [sym_color_definition] = STATE(125),
    [sym_color_set_definition] = STATE(125),
    [sym_color_reference] = STATE(125),
    [sym_tikz_library_import] = STATE(125),
    [sym_text_mode] = STATE(125),
    [sym_hyperlink] = STATE(125),
    [aux_sym_source_file_repeat1] = STATE(125),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(788),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(790),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [46] = {
    [sym_block_comment] = STATE(55),
    [sym__root_content] = STATE(55),
    [sym__flat_content] = STATE(55),
    [sym__text_with_env_content] = STATE(55),
    [sym__text_content] = STATE(55),
    [sym__section] = STATE(55),
    [sym__paragraph] = STATE(55),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(55),
    [sym_text] = STATE(55),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(55),
    [sym_inline_formula] = STATE(55),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1320),
    [sym_generic_environment] = STATE(55),
    [sym_comment_environment] = STATE(55),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(55),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(55),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(55),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(55),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(55),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(55),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(55),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(55),
    [sym_generic_command] = STATE(55),
    [sym_title_declaration] = STATE(55),
    [sym_author_declaration] = STATE(55),
    [sym_package_include] = STATE(55),
    [sym_class_include] = STATE(55),
    [sym_latex_include] = STATE(55),
    [sym_biblatex_include] = STATE(55),
    [sym_bibstyle_include] = STATE(55),
    [sym_bibtex_include] = STATE(55),
    [sym_graphics_include] = STATE(55),
    [sym_svg_include] = STATE(55),
    [sym_inkscape_include] = STATE(55),
    [sym_verbatim_include] = STATE(55),
    [sym_import_include] = STATE(55),
    [sym_caption] = STATE(55),
    [sym_citation] = STATE(55),
    [sym_label_definition] = STATE(55),
    [sym_label_reference] = STATE(55),
    [sym_label_reference_range] = STATE(55),
    [sym_label_number] = STATE(55),
    [sym_new_command_definition] = STATE(55),
    [sym_old_command_definition] = STATE(55),
    [sym_let_command_definition] = STATE(55),
    [sym_math_delimiter] = STATE(55),
    [sym_paired_delimiter_definition] = STATE(55),
    [sym_environment_definition] = STATE(55),
    [sym_glossary_entry_definition] = STATE(55),
    [sym_glossary_entry_reference] = STATE(55),
    [sym_acronym_definition] = STATE(55),
    [sym_acronym_reference] = STATE(55),
    [sym_theorem_definition] = STATE(55),
    [sym_color_definition] = STATE(55),
    [sym_color_set_definition] = STATE(55),
    [sym_color_reference] = STATE(55),
    [sym_tikz_library_import] = STATE(55),
    [sym_text_mode] = STATE(55),
    [sym_hyperlink] = STATE(55),
    [aux_sym_source_file_repeat1] = STATE(55),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(792),
    [anon_sym_RBRACK] = ACTIONS(792),
    [anon_sym_COMMA] = ACTIONS(792),
    [anon_sym_EQ] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(792),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(794),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [47] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHend] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [48] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHend] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [49] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [50] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHend] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [51] = {
    [sym_block_comment] = STATE(125),
    [sym__root_content] = STATE(125),
    [sym__flat_content] = STATE(125),
    [sym__text_with_env_content] = STATE(125),
    [sym__text_content] = STATE(125),
    [sym__section] = STATE(125),
    [sym__paragraph] = STATE(125),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(125),
    [sym_text] = STATE(125),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(125),
    [sym_inline_formula] = STATE(125),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1156),
    [sym_generic_environment] = STATE(125),
    [sym_comment_environment] = STATE(125),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(125),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(125),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(125),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(125),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(125),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(125),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(125),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(125),
    [sym_generic_command] = STATE(125),
    [sym_title_declaration] = STATE(125),
    [sym_author_declaration] = STATE(125),
    [sym_package_include] = STATE(125),
    [sym_class_include] = STATE(125),
    [sym_latex_include] = STATE(125),
    [sym_biblatex_include] = STATE(125),
    [sym_bibstyle_include] = STATE(125),
    [sym_bibtex_include] = STATE(125),
    [sym_graphics_include] = STATE(125),
    [sym_svg_include] = STATE(125),
    [sym_inkscape_include] = STATE(125),
    [sym_verbatim_include] = STATE(125),
    [sym_import_include] = STATE(125),
    [sym_caption] = STATE(125),
    [sym_citation] = STATE(125),
    [sym_label_definition] = STATE(125),
    [sym_label_reference] = STATE(125),
    [sym_label_reference_range] = STATE(125),
    [sym_label_number] = STATE(125),
    [sym_new_command_definition] = STATE(125),
    [sym_old_command_definition] = STATE(125),
    [sym_let_command_definition] = STATE(125),
    [sym_math_delimiter] = STATE(125),
    [sym_paired_delimiter_definition] = STATE(125),
    [sym_environment_definition] = STATE(125),
    [sym_glossary_entry_definition] = STATE(125),
    [sym_glossary_entry_reference] = STATE(125),
    [sym_acronym_definition] = STATE(125),
    [sym_acronym_reference] = STATE(125),
    [sym_theorem_definition] = STATE(125),
    [sym_color_definition] = STATE(125),
    [sym_color_set_definition] = STATE(125),
    [sym_color_reference] = STATE(125),
    [sym_tikz_library_import] = STATE(125),
    [sym_text_mode] = STATE(125),
    [sym_hyperlink] = STATE(125),
    [aux_sym_source_file_repeat1] = STATE(125),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(788),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(796),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [52] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHend] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [53] = {
    [sym_block_comment] = STATE(125),
    [sym__root_content] = STATE(125),
    [sym__flat_content] = STATE(125),
    [sym__text_with_env_content] = STATE(125),
    [sym__text_content] = STATE(125),
    [sym__section] = STATE(125),
    [sym__paragraph] = STATE(125),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(125),
    [sym_text] = STATE(125),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(125),
    [sym_inline_formula] = STATE(125),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(642),
    [sym_generic_environment] = STATE(125),
    [sym_comment_environment] = STATE(125),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(125),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(125),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(125),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(125),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(125),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(125),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(125),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(125),
    [sym_generic_command] = STATE(125),
    [sym_title_declaration] = STATE(125),
    [sym_author_declaration] = STATE(125),
    [sym_package_include] = STATE(125),
    [sym_class_include] = STATE(125),
    [sym_latex_include] = STATE(125),
    [sym_biblatex_include] = STATE(125),
    [sym_bibstyle_include] = STATE(125),
    [sym_bibtex_include] = STATE(125),
    [sym_graphics_include] = STATE(125),
    [sym_svg_include] = STATE(125),
    [sym_inkscape_include] = STATE(125),
    [sym_verbatim_include] = STATE(125),
    [sym_import_include] = STATE(125),
    [sym_caption] = STATE(125),
    [sym_citation] = STATE(125),
    [sym_label_definition] = STATE(125),
    [sym_label_reference] = STATE(125),
    [sym_label_reference_range] = STATE(125),
    [sym_label_number] = STATE(125),
    [sym_new_command_definition] = STATE(125),
    [sym_old_command_definition] = STATE(125),
    [sym_let_command_definition] = STATE(125),
    [sym_math_delimiter] = STATE(125),
    [sym_paired_delimiter_definition] = STATE(125),
    [sym_environment_definition] = STATE(125),
    [sym_glossary_entry_definition] = STATE(125),
    [sym_glossary_entry_reference] = STATE(125),
    [sym_acronym_definition] = STATE(125),
    [sym_acronym_reference] = STATE(125),
    [sym_theorem_definition] = STATE(125),
    [sym_color_definition] = STATE(125),
    [sym_color_set_definition] = STATE(125),
    [sym_color_reference] = STATE(125),
    [sym_tikz_library_import] = STATE(125),
    [sym_text_mode] = STATE(125),
    [sym_hyperlink] = STATE(125),
    [aux_sym_source_file_repeat1] = STATE(125),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(788),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(798),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [54] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [55] = {
    [sym_block_comment] = STATE(125),
    [sym__root_content] = STATE(125),
    [sym__flat_content] = STATE(125),
    [sym__text_with_env_content] = STATE(125),
    [sym__text_content] = STATE(125),
    [sym__section] = STATE(125),
    [sym__paragraph] = STATE(125),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(125),
    [sym_text] = STATE(125),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(125),
    [sym_inline_formula] = STATE(125),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1256),
    [sym_generic_environment] = STATE(125),
    [sym_comment_environment] = STATE(125),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(125),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(125),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(125),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(125),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(125),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(125),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(125),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(125),
    [sym_generic_command] = STATE(125),
    [sym_title_declaration] = STATE(125),
    [sym_author_declaration] = STATE(125),
    [sym_package_include] = STATE(125),
    [sym_class_include] = STATE(125),
    [sym_latex_include] = STATE(125),
    [sym_biblatex_include] = STATE(125),
    [sym_bibstyle_include] = STATE(125),
    [sym_bibtex_include] = STATE(125),
    [sym_graphics_include] = STATE(125),
    [sym_svg_include] = STATE(125),
    [sym_inkscape_include] = STATE(125),
    [sym_verbatim_include] = STATE(125),
    [sym_import_include] = STATE(125),
    [sym_caption] = STATE(125),
    [sym_citation] = STATE(125),
    [sym_label_definition] = STATE(125),
    [sym_label_reference] = STATE(125),
    [sym_label_reference_range] = STATE(125),
    [sym_label_number] = STATE(125),
    [sym_new_command_definition] = STATE(125),
    [sym_old_command_definition] = STATE(125),
    [sym_let_command_definition] = STATE(125),
    [sym_math_delimiter] = STATE(125),
    [sym_paired_delimiter_definition] = STATE(125),
    [sym_environment_definition] = STATE(125),
    [sym_glossary_entry_definition] = STATE(125),
    [sym_glossary_entry_reference] = STATE(125),
    [sym_acronym_definition] = STATE(125),
    [sym_acronym_reference] = STATE(125),
    [sym_theorem_definition] = STATE(125),
    [sym_color_definition] = STATE(125),
    [sym_color_set_definition] = STATE(125),
    [sym_color_reference] = STATE(125),
    [sym_tikz_library_import] = STATE(125),
    [sym_text_mode] = STATE(125),
    [sym_hyperlink] = STATE(125),
    [aux_sym_source_file_repeat1] = STATE(125),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(788),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(794),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [56] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [57] = {
    [sym_block_comment] = STATE(51),
    [sym__root_content] = STATE(51),
    [sym__flat_content] = STATE(51),
    [sym__text_with_env_content] = STATE(51),
    [sym__text_content] = STATE(51),
    [sym__section] = STATE(51),
    [sym__paragraph] = STATE(51),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(51),
    [sym_text] = STATE(51),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(51),
    [sym_inline_formula] = STATE(51),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1082),
    [sym_generic_environment] = STATE(51),
    [sym_comment_environment] = STATE(51),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(51),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(51),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(51),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(51),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(51),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(51),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(51),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(51),
    [sym_generic_command] = STATE(51),
    [sym_title_declaration] = STATE(51),
    [sym_author_declaration] = STATE(51),
    [sym_package_include] = STATE(51),
    [sym_class_include] = STATE(51),
    [sym_latex_include] = STATE(51),
    [sym_biblatex_include] = STATE(51),
    [sym_bibstyle_include] = STATE(51),
    [sym_bibtex_include] = STATE(51),
    [sym_graphics_include] = STATE(51),
    [sym_svg_include] = STATE(51),
    [sym_inkscape_include] = STATE(51),
    [sym_verbatim_include] = STATE(51),
    [sym_import_include] = STATE(51),
    [sym_caption] = STATE(51),
    [sym_citation] = STATE(51),
    [sym_label_definition] = STATE(51),
    [sym_label_reference] = STATE(51),
    [sym_label_reference_range] = STATE(51),
    [sym_label_number] = STATE(51),
    [sym_new_command_definition] = STATE(51),
    [sym_old_command_definition] = STATE(51),
    [sym_let_command_definition] = STATE(51),
    [sym_math_delimiter] = STATE(51),
    [sym_paired_delimiter_definition] = STATE(51),
    [sym_environment_definition] = STATE(51),
    [sym_glossary_entry_definition] = STATE(51),
    [sym_glossary_entry_reference] = STATE(51),
    [sym_acronym_definition] = STATE(51),
    [sym_acronym_reference] = STATE(51),
    [sym_theorem_definition] = STATE(51),
    [sym_color_definition] = STATE(51),
    [sym_color_set_definition] = STATE(51),
    [sym_color_reference] = STATE(51),
    [sym_tikz_library_import] = STATE(51),
    [sym_text_mode] = STATE(51),
    [sym_hyperlink] = STATE(51),
    [aux_sym_source_file_repeat1] = STATE(51),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(800),
    [anon_sym_RBRACK] = ACTIONS(800),
    [anon_sym_COMMA] = ACTIONS(800),
    [anon_sym_EQ] = ACTIONS(800),
    [anon_sym_LPAREN] = ACTIONS(800),
    [anon_sym_RPAREN] = ACTIONS(800),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(796),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [58] = {
    [sym_block_comment] = STATE(53),
    [sym__root_content] = STATE(53),
    [sym__flat_content] = STATE(53),
    [sym__text_with_env_content] = STATE(53),
    [sym__text_content] = STATE(53),
    [sym__section] = STATE(53),
    [sym__paragraph] = STATE(53),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(53),
    [sym_text] = STATE(53),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(53),
    [sym_inline_formula] = STATE(53),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(590),
    [sym_generic_environment] = STATE(53),
    [sym_comment_environment] = STATE(53),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(53),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(53),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(53),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(53),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(53),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(53),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(53),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(53),
    [sym_generic_command] = STATE(53),
    [sym_title_declaration] = STATE(53),
    [sym_author_declaration] = STATE(53),
    [sym_package_include] = STATE(53),
    [sym_class_include] = STATE(53),
    [sym_latex_include] = STATE(53),
    [sym_biblatex_include] = STATE(53),
    [sym_bibstyle_include] = STATE(53),
    [sym_bibtex_include] = STATE(53),
    [sym_graphics_include] = STATE(53),
    [sym_svg_include] = STATE(53),
    [sym_inkscape_include] = STATE(53),
    [sym_verbatim_include] = STATE(53),
    [sym_import_include] = STATE(53),
    [sym_caption] = STATE(53),
    [sym_citation] = STATE(53),
    [sym_label_definition] = STATE(53),
    [sym_label_reference] = STATE(53),
    [sym_label_reference_range] = STATE(53),
    [sym_label_number] = STATE(53),
    [sym_new_command_definition] = STATE(53),
    [sym_old_command_definition] = STATE(53),
    [sym_let_command_definition] = STATE(53),
    [sym_math_delimiter] = STATE(53),
    [sym_paired_delimiter_definition] = STATE(53),
    [sym_environment_definition] = STATE(53),
    [sym_glossary_entry_definition] = STATE(53),
    [sym_glossary_entry_reference] = STATE(53),
    [sym_acronym_definition] = STATE(53),
    [sym_acronym_reference] = STATE(53),
    [sym_theorem_definition] = STATE(53),
    [sym_color_definition] = STATE(53),
    [sym_color_set_definition] = STATE(53),
    [sym_color_reference] = STATE(53),
    [sym_tikz_library_import] = STATE(53),
    [sym_text_mode] = STATE(53),
    [sym_hyperlink] = STATE(53),
    [aux_sym_source_file_repeat1] = STATE(53),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(802),
    [anon_sym_RBRACK] = ACTIONS(802),
    [anon_sym_COMMA] = ACTIONS(802),
    [anon_sym_EQ] = ACTIONS(802),
    [anon_sym_LPAREN] = ACTIONS(802),
    [anon_sym_RPAREN] = ACTIONS(802),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(798),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [59] = {
    [sym_block_comment] = STATE(125),
    [sym__root_content] = STATE(125),
    [sym__flat_content] = STATE(125),
    [sym__text_with_env_content] = STATE(125),
    [sym__text_content] = STATE(125),
    [sym__section] = STATE(125),
    [sym__paragraph] = STATE(125),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(125),
    [sym_text] = STATE(125),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(125),
    [sym_inline_formula] = STATE(125),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1817),
    [sym_generic_environment] = STATE(125),
    [sym_comment_environment] = STATE(125),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(125),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(125),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(125),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(125),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(125),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(125),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(125),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(125),
    [sym_generic_command] = STATE(125),
    [sym_title_declaration] = STATE(125),
    [sym_author_declaration] = STATE(125),
    [sym_package_include] = STATE(125),
    [sym_class_include] = STATE(125),
    [sym_latex_include] = STATE(125),
    [sym_biblatex_include] = STATE(125),
    [sym_bibstyle_include] = STATE(125),
    [sym_bibtex_include] = STATE(125),
    [sym_graphics_include] = STATE(125),
    [sym_svg_include] = STATE(125),
    [sym_inkscape_include] = STATE(125),
    [sym_verbatim_include] = STATE(125),
    [sym_import_include] = STATE(125),
    [sym_caption] = STATE(125),
    [sym_citation] = STATE(125),
    [sym_label_definition] = STATE(125),
    [sym_label_reference] = STATE(125),
    [sym_label_reference_range] = STATE(125),
    [sym_label_number] = STATE(125),
    [sym_new_command_definition] = STATE(125),
    [sym_old_command_definition] = STATE(125),
    [sym_let_command_definition] = STATE(125),
    [sym_math_delimiter] = STATE(125),
    [sym_paired_delimiter_definition] = STATE(125),
    [sym_environment_definition] = STATE(125),
    [sym_glossary_entry_definition] = STATE(125),
    [sym_glossary_entry_reference] = STATE(125),
    [sym_acronym_definition] = STATE(125),
    [sym_acronym_reference] = STATE(125),
    [sym_theorem_definition] = STATE(125),
    [sym_color_definition] = STATE(125),
    [sym_color_set_definition] = STATE(125),
    [sym_color_reference] = STATE(125),
    [sym_tikz_library_import] = STATE(125),
    [sym_text_mode] = STATE(125),
    [sym_hyperlink] = STATE(125),
    [aux_sym_source_file_repeat1] = STATE(125),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(788),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(704),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [60] = {
    [sym_block_comment] = STATE(45),
    [sym__root_content] = STATE(45),
    [sym__flat_content] = STATE(45),
    [sym__text_with_env_content] = STATE(45),
    [sym__text_content] = STATE(45),
    [sym__section] = STATE(45),
    [sym__paragraph] = STATE(45),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(45),
    [sym_text] = STATE(45),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(45),
    [sym_inline_formula] = STATE(45),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1353),
    [sym_generic_environment] = STATE(45),
    [sym_comment_environment] = STATE(45),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(45),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(45),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(45),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(45),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(45),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(45),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(45),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(45),
    [sym_generic_command] = STATE(45),
    [sym_title_declaration] = STATE(45),
    [sym_author_declaration] = STATE(45),
    [sym_package_include] = STATE(45),
    [sym_class_include] = STATE(45),
    [sym_latex_include] = STATE(45),
    [sym_biblatex_include] = STATE(45),
    [sym_bibstyle_include] = STATE(45),
    [sym_bibtex_include] = STATE(45),
    [sym_graphics_include] = STATE(45),
    [sym_svg_include] = STATE(45),
    [sym_inkscape_include] = STATE(45),
    [sym_verbatim_include] = STATE(45),
    [sym_import_include] = STATE(45),
    [sym_caption] = STATE(45),
    [sym_citation] = STATE(45),
    [sym_label_definition] = STATE(45),
    [sym_label_reference] = STATE(45),
    [sym_label_reference_range] = STATE(45),
    [sym_label_number] = STATE(45),
    [sym_new_command_definition] = STATE(45),
    [sym_old_command_definition] = STATE(45),
    [sym_let_command_definition] = STATE(45),
    [sym_math_delimiter] = STATE(45),
    [sym_paired_delimiter_definition] = STATE(45),
    [sym_environment_definition] = STATE(45),
    [sym_glossary_entry_definition] = STATE(45),
    [sym_glossary_entry_reference] = STATE(45),
    [sym_acronym_definition] = STATE(45),
    [sym_acronym_reference] = STATE(45),
    [sym_theorem_definition] = STATE(45),
    [sym_color_definition] = STATE(45),
    [sym_color_set_definition] = STATE(45),
    [sym_color_reference] = STATE(45),
    [sym_tikz_library_import] = STATE(45),
    [sym_text_mode] = STATE(45),
    [sym_hyperlink] = STATE(45),
    [aux_sym_source_file_repeat1] = STATE(45),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_RBRACK] = ACTIONS(804),
    [anon_sym_COMMA] = ACTIONS(804),
    [anon_sym_EQ] = ACTIONS(804),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_RPAREN] = ACTIONS(804),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(790),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [61] = {
    [sym_block_comment] = STATE(125),
    [sym__root_content] = STATE(125),
    [sym__flat_content] = STATE(125),
    [sym__text_with_env_content] = STATE(125),
    [sym__text_content] = STATE(125),
    [sym__section] = STATE(125),
    [sym__paragraph] = STATE(125),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(125),
    [sym_text] = STATE(125),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(125),
    [sym_inline_formula] = STATE(125),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1576),
    [sym_generic_environment] = STATE(125),
    [sym_comment_environment] = STATE(125),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(125),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(125),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(125),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(125),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(125),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(125),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(125),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(125),
    [sym_generic_command] = STATE(125),
    [sym_title_declaration] = STATE(125),
    [sym_author_declaration] = STATE(125),
    [sym_package_include] = STATE(125),
    [sym_class_include] = STATE(125),
    [sym_latex_include] = STATE(125),
    [sym_biblatex_include] = STATE(125),
    [sym_bibstyle_include] = STATE(125),
    [sym_bibtex_include] = STATE(125),
    [sym_graphics_include] = STATE(125),
    [sym_svg_include] = STATE(125),
    [sym_inkscape_include] = STATE(125),
    [sym_verbatim_include] = STATE(125),
    [sym_import_include] = STATE(125),
    [sym_caption] = STATE(125),
    [sym_citation] = STATE(125),
    [sym_label_definition] = STATE(125),
    [sym_label_reference] = STATE(125),
    [sym_label_reference_range] = STATE(125),
    [sym_label_number] = STATE(125),
    [sym_new_command_definition] = STATE(125),
    [sym_old_command_definition] = STATE(125),
    [sym_let_command_definition] = STATE(125),
    [sym_math_delimiter] = STATE(125),
    [sym_paired_delimiter_definition] = STATE(125),
    [sym_environment_definition] = STATE(125),
    [sym_glossary_entry_definition] = STATE(125),
    [sym_glossary_entry_reference] = STATE(125),
    [sym_acronym_definition] = STATE(125),
    [sym_acronym_reference] = STATE(125),
    [sym_theorem_definition] = STATE(125),
    [sym_color_definition] = STATE(125),
    [sym_color_set_definition] = STATE(125),
    [sym_color_reference] = STATE(125),
    [sym_tikz_library_import] = STATE(125),
    [sym_text_mode] = STATE(125),
    [sym_hyperlink] = STATE(125),
    [aux_sym_source_file_repeat1] = STATE(125),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(788),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(806),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [62] = {
    [sym_block_comment] = STATE(125),
    [sym__root_content] = STATE(125),
    [sym__flat_content] = STATE(125),
    [sym__text_with_env_content] = STATE(125),
    [sym__text_content] = STATE(125),
    [sym__section] = STATE(125),
    [sym__paragraph] = STATE(125),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(125),
    [sym_text] = STATE(125),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(125),
    [sym_inline_formula] = STATE(125),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1054),
    [sym_generic_environment] = STATE(125),
    [sym_comment_environment] = STATE(125),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(125),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(125),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(125),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(125),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(125),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(125),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(125),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(125),
    [sym_generic_command] = STATE(125),
    [sym_title_declaration] = STATE(125),
    [sym_author_declaration] = STATE(125),
    [sym_package_include] = STATE(125),
    [sym_class_include] = STATE(125),
    [sym_latex_include] = STATE(125),
    [sym_biblatex_include] = STATE(125),
    [sym_bibstyle_include] = STATE(125),
    [sym_bibtex_include] = STATE(125),
    [sym_graphics_include] = STATE(125),
    [sym_svg_include] = STATE(125),
    [sym_inkscape_include] = STATE(125),
    [sym_verbatim_include] = STATE(125),
    [sym_import_include] = STATE(125),
    [sym_caption] = STATE(125),
    [sym_citation] = STATE(125),
    [sym_label_definition] = STATE(125),
    [sym_label_reference] = STATE(125),
    [sym_label_reference_range] = STATE(125),
    [sym_label_number] = STATE(125),
    [sym_new_command_definition] = STATE(125),
    [sym_old_command_definition] = STATE(125),
    [sym_let_command_definition] = STATE(125),
    [sym_math_delimiter] = STATE(125),
    [sym_paired_delimiter_definition] = STATE(125),
    [sym_environment_definition] = STATE(125),
    [sym_glossary_entry_definition] = STATE(125),
    [sym_glossary_entry_reference] = STATE(125),
    [sym_acronym_definition] = STATE(125),
    [sym_acronym_reference] = STATE(125),
    [sym_theorem_definition] = STATE(125),
    [sym_color_definition] = STATE(125),
    [sym_color_set_definition] = STATE(125),
    [sym_color_reference] = STATE(125),
    [sym_tikz_library_import] = STATE(125),
    [sym_text_mode] = STATE(125),
    [sym_hyperlink] = STATE(125),
    [aux_sym_source_file_repeat1] = STATE(125),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(788),
    [anon_sym_RBRACK] = ACTIONS(788),
    [anon_sym_COMMA] = ACTIONS(788),
    [anon_sym_EQ] = ACTIONS(788),
    [anon_sym_LPAREN] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(788),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(808),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [63] = {
    [sym_block_comment] = STATE(61),
    [sym__root_content] = STATE(61),
    [sym__flat_content] = STATE(61),
    [sym__text_with_env_content] = STATE(61),
    [sym__text_content] = STATE(61),
    [sym__section] = STATE(61),
    [sym__paragraph] = STATE(61),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(61),
    [sym_text] = STATE(61),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(61),
    [sym_inline_formula] = STATE(61),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(1536),
    [sym_generic_environment] = STATE(61),
    [sym_comment_environment] = STATE(61),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(61),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(61),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(61),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(61),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(61),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(61),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(61),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(61),
    [sym_generic_command] = STATE(61),
    [sym_title_declaration] = STATE(61),
    [sym_author_declaration] = STATE(61),
    [sym_package_include] = STATE(61),
    [sym_class_include] = STATE(61),
    [sym_latex_include] = STATE(61),
    [sym_biblatex_include] = STATE(61),
    [sym_bibstyle_include] = STATE(61),
    [sym_bibtex_include] = STATE(61),
    [sym_graphics_include] = STATE(61),
    [sym_svg_include] = STATE(61),
    [sym_inkscape_include] = STATE(61),
    [sym_verbatim_include] = STATE(61),
    [sym_import_include] = STATE(61),
    [sym_caption] = STATE(61),
    [sym_citation] = STATE(61),
    [sym_label_definition] = STATE(61),
    [sym_label_reference] = STATE(61),
    [sym_label_reference_range] = STATE(61),
    [sym_label_number] = STATE(61),
    [sym_new_command_definition] = STATE(61),
    [sym_old_command_definition] = STATE(61),
    [sym_let_command_definition] = STATE(61),
    [sym_math_delimiter] = STATE(61),
    [sym_paired_delimiter_definition] = STATE(61),
    [sym_environment_definition] = STATE(61),
    [sym_glossary_entry_definition] = STATE(61),
    [sym_glossary_entry_reference] = STATE(61),
    [sym_acronym_definition] = STATE(61),
    [sym_acronym_reference] = STATE(61),
    [sym_theorem_definition] = STATE(61),
    [sym_color_definition] = STATE(61),
    [sym_color_set_definition] = STATE(61),
    [sym_color_reference] = STATE(61),
    [sym_tikz_library_import] = STATE(61),
    [sym_text_mode] = STATE(61),
    [sym_hyperlink] = STATE(61),
    [aux_sym_source_file_repeat1] = STATE(61),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(810),
    [anon_sym_RBRACK] = ACTIONS(810),
    [anon_sym_COMMA] = ACTIONS(810),
    [anon_sym_EQ] = ACTIONS(810),
    [anon_sym_LPAREN] = ACTIONS(810),
    [anon_sym_RPAREN] = ACTIONS(810),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(806),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [64] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(812),
    [sym_command_name] = ACTIONS(814),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(820),
    [anon_sym_RBRACK] = ACTIONS(820),
    [anon_sym_COMMA] = ACTIONS(820),
    [anon_sym_EQ] = ACTIONS(820),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_RPAREN] = ACTIONS(820),
    [anon_sym_BSLASHpart] = ACTIONS(823),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(826),
    [anon_sym_BSLASHaddpart] = ACTIONS(823),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(826),
    [anon_sym_BSLASHchapter] = ACTIONS(829),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(832),
    [anon_sym_BSLASHaddchap] = ACTIONS(829),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(832),
    [anon_sym_BSLASHsection] = ACTIONS(835),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(838),
    [anon_sym_BSLASHaddsec] = ACTIONS(835),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(838),
    [anon_sym_BSLASHsubsection] = ACTIONS(841),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(844),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(847),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(850),
    [anon_sym_BSLASHparagraph] = ACTIONS(853),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(856),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(859),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(862),
    [anon_sym_BSLASHitem] = ACTIONS(865),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(868),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(812),
    [sym_word] = ACTIONS(874),
    [sym_placeholder] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(880),
    [anon_sym_DASH] = ACTIONS(880),
    [anon_sym_STAR] = ACTIONS(880),
    [anon_sym_SLASH] = ACTIONS(880),
    [anon_sym_LT] = ACTIONS(883),
    [anon_sym_GT] = ACTIONS(883),
    [anon_sym_BANG] = ACTIONS(883),
    [anon_sym_PIPE] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(883),
    [anon_sym_SQUOTE] = ACTIONS(883),
    [anon_sym__] = ACTIONS(886),
    [anon_sym_CARET] = ACTIONS(889),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(892),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(892),
    [anon_sym_DOLLAR] = ACTIONS(895),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(898),
    [anon_sym_BSLASHbegin] = ACTIONS(434),
    [anon_sym_BSLASHtitle] = ACTIONS(901),
    [anon_sym_BSLASHauthor] = ACTIONS(904),
    [anon_sym_BSLASHusepackage] = ACTIONS(907),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(907),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(910),
    [anon_sym_BSLASHinclude] = ACTIONS(913),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(913),
    [anon_sym_BSLASHinput] = ACTIONS(913),
    [anon_sym_BSLASHsubfile] = ACTIONS(913),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(916),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(919),
    [anon_sym_BSLASHbibliography] = ACTIONS(922),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(925),
    [anon_sym_BSLASHincludesvg] = ACTIONS(928),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(931),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(934),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(934),
    [anon_sym_BSLASHimport] = ACTIONS(937),
    [anon_sym_BSLASHsubimport] = ACTIONS(937),
    [anon_sym_BSLASHinputfrom] = ACTIONS(937),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(937),
    [anon_sym_BSLASHincludefrom] = ACTIONS(937),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(937),
    [anon_sym_BSLASHcaption] = ACTIONS(940),
    [anon_sym_BSLASHcite] = ACTIONS(943),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(946),
    [anon_sym_BSLASHCite] = ACTIONS(943),
    [anon_sym_BSLASHnocite] = ACTIONS(943),
    [anon_sym_BSLASHcitet] = ACTIONS(943),
    [anon_sym_BSLASHcitep] = ACTIONS(943),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(946),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(946),
    [anon_sym_BSLASHciteA] = ACTIONS(943),
    [anon_sym_BSLASHciteR] = ACTIONS(943),
    [anon_sym_BSLASHciteS] = ACTIONS(943),
    [anon_sym_BSLASHciteyearR] = ACTIONS(943),
    [anon_sym_BSLASHciteauthor] = ACTIONS(943),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(946),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(943),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(946),
    [anon_sym_BSLASHcitetitle] = ACTIONS(943),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(946),
    [anon_sym_BSLASHciteyear] = ACTIONS(943),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(946),
    [anon_sym_BSLASHcitedate] = ACTIONS(943),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(946),
    [anon_sym_BSLASHciteurl] = ACTIONS(943),
    [anon_sym_BSLASHfullcite] = ACTIONS(943),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(943),
    [anon_sym_BSLASHcitealt] = ACTIONS(943),
    [anon_sym_BSLASHcitealp] = ACTIONS(943),
    [anon_sym_BSLASHcitetext] = ACTIONS(943),
    [anon_sym_BSLASHparencite] = ACTIONS(943),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(946),
    [anon_sym_BSLASHParencite] = ACTIONS(943),
    [anon_sym_BSLASHfootcite] = ACTIONS(943),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(943),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(943),
    [anon_sym_BSLASHtextcite] = ACTIONS(943),
    [anon_sym_BSLASHTextcite] = ACTIONS(943),
    [anon_sym_BSLASHsmartcite] = ACTIONS(943),
    [anon_sym_BSLASHSmartcite] = ACTIONS(943),
    [anon_sym_BSLASHsupercite] = ACTIONS(943),
    [anon_sym_BSLASHautocite] = ACTIONS(943),
    [anon_sym_BSLASHAutocite] = ACTIONS(943),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(946),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(946),
    [anon_sym_BSLASHvolcite] = ACTIONS(943),
    [anon_sym_BSLASHVolcite] = ACTIONS(943),
    [anon_sym_BSLASHpvolcite] = ACTIONS(943),
    [anon_sym_BSLASHPvolcite] = ACTIONS(943),
    [anon_sym_BSLASHfvolcite] = ACTIONS(943),
    [anon_sym_BSLASHftvolcite] = ACTIONS(943),
    [anon_sym_BSLASHsvolcite] = ACTIONS(943),
    [anon_sym_BSLASHSvolcite] = ACTIONS(943),
    [anon_sym_BSLASHtvolcite] = ACTIONS(943),
    [anon_sym_BSLASHTvolcite] = ACTIONS(943),
    [anon_sym_BSLASHavolcite] = ACTIONS(943),
    [anon_sym_BSLASHAvolcite] = ACTIONS(943),
    [anon_sym_BSLASHnotecite] = ACTIONS(943),
    [anon_sym_BSLASHNotecite] = ACTIONS(943),
    [anon_sym_BSLASHpnotecite] = ACTIONS(943),
    [anon_sym_BSLASHPnotecite] = ACTIONS(943),
    [anon_sym_BSLASHfnotecite] = ACTIONS(943),
    [anon_sym_BSLASHlabel] = ACTIONS(949),
    [anon_sym_BSLASHref] = ACTIONS(952),
    [anon_sym_BSLASHeqref] = ACTIONS(952),
    [anon_sym_BSLASHvref] = ACTIONS(952),
    [anon_sym_BSLASHVref] = ACTIONS(952),
    [anon_sym_BSLASHautoref] = ACTIONS(952),
    [anon_sym_BSLASHpageref] = ACTIONS(952),
    [anon_sym_BSLASHcref] = ACTIONS(952),
    [anon_sym_BSLASHCref] = ACTIONS(952),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(955),
    [anon_sym_BSLASHnamecref] = ACTIONS(952),
    [anon_sym_BSLASHnameCref] = ACTIONS(952),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(952),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(952),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(952),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(952),
    [anon_sym_BSLASHlabelcref] = ACTIONS(952),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(952),
    [anon_sym_BSLASHcrefrange] = ACTIONS(958),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(961),
    [anon_sym_BSLASHCrefrange] = ACTIONS(958),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(961),
    [anon_sym_BSLASHnewlabel] = ACTIONS(964),
    [anon_sym_BSLASHnewcommand] = ACTIONS(967),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(970),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(967),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(970),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(967),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(970),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(967),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(970),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(967),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(967),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(967),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(967),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(967),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(967),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(967),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(967),
    [anon_sym_BSLASHdef] = ACTIONS(973),
    [anon_sym_BSLASHlet] = ACTIONS(976),
    [anon_sym_BSLASHleft] = ACTIONS(979),
    [anon_sym_BSLASHbigl] = ACTIONS(979),
    [anon_sym_BSLASHBigl] = ACTIONS(979),
    [anon_sym_BSLASHbiggl] = ACTIONS(979),
    [anon_sym_BSLASHBiggl] = ACTIONS(979),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(982),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(982),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(985),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(985),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(985),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(985),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(985),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(985),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(988),
    [anon_sym_BSLASHgls] = ACTIONS(991),
    [anon_sym_BSLASHGls] = ACTIONS(991),
    [anon_sym_BSLASHGLS] = ACTIONS(991),
    [anon_sym_BSLASHglspl] = ACTIONS(991),
    [anon_sym_BSLASHGlspl] = ACTIONS(991),
    [anon_sym_BSLASHGLSpl] = ACTIONS(991),
    [anon_sym_BSLASHglsdisp] = ACTIONS(991),
    [anon_sym_BSLASHglslink] = ACTIONS(991),
    [anon_sym_BSLASHglstext] = ACTIONS(991),
    [anon_sym_BSLASHGlstext] = ACTIONS(991),
    [anon_sym_BSLASHGLStext] = ACTIONS(991),
    [anon_sym_BSLASHglsfirst] = ACTIONS(991),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(991),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(991),
    [anon_sym_BSLASHglsplural] = ACTIONS(991),
    [anon_sym_BSLASHGlsplural] = ACTIONS(991),
    [anon_sym_BSLASHGLSplural] = ACTIONS(991),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(991),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(991),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(991),
    [anon_sym_BSLASHglsname] = ACTIONS(991),
    [anon_sym_BSLASHGlsname] = ACTIONS(991),
    [anon_sym_BSLASHGLSname] = ACTIONS(991),
    [anon_sym_BSLASHglssymbol] = ACTIONS(991),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(991),
    [anon_sym_BSLASHglsdesc] = ACTIONS(991),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(991),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(991),
    [anon_sym_BSLASHglsuseri] = ACTIONS(991),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(991),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(991),
    [anon_sym_BSLASHglsuserii] = ACTIONS(991),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(991),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(991),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(991),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(991),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(991),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(991),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(991),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(991),
    [anon_sym_BSLASHglsuserv] = ACTIONS(991),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(991),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(991),
    [anon_sym_BSLASHglsuservi] = ACTIONS(991),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(991),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(991),
    [anon_sym_BSLASHnewacronym] = ACTIONS(994),
    [anon_sym_BSLASHacrshort] = ACTIONS(997),
    [anon_sym_BSLASHAcrshort] = ACTIONS(997),
    [anon_sym_BSLASHACRshort] = ACTIONS(997),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(997),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(997),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(997),
    [anon_sym_BSLASHacrlong] = ACTIONS(997),
    [anon_sym_BSLASHAcrlong] = ACTIONS(997),
    [anon_sym_BSLASHACRlong] = ACTIONS(997),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(997),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(997),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(997),
    [anon_sym_BSLASHacrfull] = ACTIONS(997),
    [anon_sym_BSLASHAcrfull] = ACTIONS(997),
    [anon_sym_BSLASHACRfull] = ACTIONS(997),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(997),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(997),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(997),
    [anon_sym_BSLASHacs] = ACTIONS(997),
    [anon_sym_BSLASHAcs] = ACTIONS(997),
    [anon_sym_BSLASHacsp] = ACTIONS(997),
    [anon_sym_BSLASHAcsp] = ACTIONS(997),
    [anon_sym_BSLASHacl] = ACTIONS(997),
    [anon_sym_BSLASHAcl] = ACTIONS(997),
    [anon_sym_BSLASHaclp] = ACTIONS(997),
    [anon_sym_BSLASHAclp] = ACTIONS(997),
    [anon_sym_BSLASHacf] = ACTIONS(997),
    [anon_sym_BSLASHAcf] = ACTIONS(997),
    [anon_sym_BSLASHacfp] = ACTIONS(997),
    [anon_sym_BSLASHAcfp] = ACTIONS(997),
    [anon_sym_BSLASHac] = ACTIONS(997),
    [anon_sym_BSLASHAc] = ACTIONS(997),
    [anon_sym_BSLASHacp] = ACTIONS(997),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(997),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(997),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(997),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(997),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(997),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(997),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(997),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(997),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(997),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(997),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1000),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1003),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1000),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1003),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1006),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1009),
    [anon_sym_BSLASHcolor] = ACTIONS(1012),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1012),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1012),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1012),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1015),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1015),
    [anon_sym_BSLASHtext] = ACTIONS(1018),
    [anon_sym_BSLASHintertext] = ACTIONS(1018),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1018),
    [anon_sym_BSLASHurl] = ACTIONS(1021),
    [anon_sym_BSLASHhref] = ACTIONS(1021),
  },
  [65] = {
    [sym_block_comment] = STATE(62),
    [sym__root_content] = STATE(62),
    [sym__flat_content] = STATE(62),
    [sym__text_with_env_content] = STATE(62),
    [sym__text_content] = STATE(62),
    [sym__section] = STATE(62),
    [sym__paragraph] = STATE(62),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(62),
    [sym_text] = STATE(62),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(62),
    [sym_inline_formula] = STATE(62),
    [sym_begin] = STATE(57),
    [sym_end] = STATE(910),
    [sym_generic_environment] = STATE(62),
    [sym_comment_environment] = STATE(62),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(62),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(62),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(62),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(62),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(62),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(62),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(62),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(62),
    [sym_generic_command] = STATE(62),
    [sym_title_declaration] = STATE(62),
    [sym_author_declaration] = STATE(62),
    [sym_package_include] = STATE(62),
    [sym_class_include] = STATE(62),
    [sym_latex_include] = STATE(62),
    [sym_biblatex_include] = STATE(62),
    [sym_bibstyle_include] = STATE(62),
    [sym_bibtex_include] = STATE(62),
    [sym_graphics_include] = STATE(62),
    [sym_svg_include] = STATE(62),
    [sym_inkscape_include] = STATE(62),
    [sym_verbatim_include] = STATE(62),
    [sym_import_include] = STATE(62),
    [sym_caption] = STATE(62),
    [sym_citation] = STATE(62),
    [sym_label_definition] = STATE(62),
    [sym_label_reference] = STATE(62),
    [sym_label_reference_range] = STATE(62),
    [sym_label_number] = STATE(62),
    [sym_new_command_definition] = STATE(62),
    [sym_old_command_definition] = STATE(62),
    [sym_let_command_definition] = STATE(62),
    [sym_math_delimiter] = STATE(62),
    [sym_paired_delimiter_definition] = STATE(62),
    [sym_environment_definition] = STATE(62),
    [sym_glossary_entry_definition] = STATE(62),
    [sym_glossary_entry_reference] = STATE(62),
    [sym_acronym_definition] = STATE(62),
    [sym_acronym_reference] = STATE(62),
    [sym_theorem_definition] = STATE(62),
    [sym_color_definition] = STATE(62),
    [sym_color_set_definition] = STATE(62),
    [sym_color_reference] = STATE(62),
    [sym_tikz_library_import] = STATE(62),
    [sym_text_mode] = STATE(62),
    [sym_hyperlink] = STATE(62),
    [aux_sym_source_file_repeat1] = STATE(62),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_RBRACK] = ACTIONS(1024),
    [anon_sym_COMMA] = ACTIONS(1024),
    [anon_sym_EQ] = ACTIONS(1024),
    [anon_sym_LPAREN] = ACTIONS(1024),
    [anon_sym_RPAREN] = ACTIONS(1024),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(808),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [66] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHend] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [67] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(167),
    [anon_sym_RBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [68] = {
    [sym_block_comment] = STATE(79),
    [sym__root_content] = STATE(79),
    [sym__flat_content] = STATE(79),
    [sym__text_with_env_content] = STATE(79),
    [sym__text_content] = STATE(79),
    [sym__section] = STATE(79),
    [sym__paragraph] = STATE(79),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(79),
    [sym_text] = STATE(79),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(79),
    [sym_inline_formula] = STATE(79),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(79),
    [sym_comment_environment] = STATE(79),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(79),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(79),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(79),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(79),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(79),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(79),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(79),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(79),
    [sym_generic_command] = STATE(79),
    [sym_title_declaration] = STATE(79),
    [sym_author_declaration] = STATE(79),
    [sym_package_include] = STATE(79),
    [sym_class_include] = STATE(79),
    [sym_latex_include] = STATE(79),
    [sym_biblatex_include] = STATE(79),
    [sym_bibstyle_include] = STATE(79),
    [sym_bibtex_include] = STATE(79),
    [sym_graphics_include] = STATE(79),
    [sym_svg_include] = STATE(79),
    [sym_inkscape_include] = STATE(79),
    [sym_verbatim_include] = STATE(79),
    [sym_import_include] = STATE(79),
    [sym_caption] = STATE(79),
    [sym_citation] = STATE(79),
    [sym_label_definition] = STATE(79),
    [sym_label_reference] = STATE(79),
    [sym_label_reference_range] = STATE(79),
    [sym_label_number] = STATE(79),
    [sym_new_command_definition] = STATE(79),
    [sym_old_command_definition] = STATE(79),
    [sym_let_command_definition] = STATE(79),
    [sym_math_delimiter] = STATE(79),
    [sym_paired_delimiter_definition] = STATE(79),
    [sym_environment_definition] = STATE(79),
    [sym_glossary_entry_definition] = STATE(79),
    [sym_glossary_entry_reference] = STATE(79),
    [sym_acronym_definition] = STATE(79),
    [sym_acronym_reference] = STATE(79),
    [sym_theorem_definition] = STATE(79),
    [sym_color_definition] = STATE(79),
    [sym_color_set_definition] = STATE(79),
    [sym_color_reference] = STATE(79),
    [sym_tikz_library_import] = STATE(79),
    [sym_text_mode] = STATE(79),
    [sym_hyperlink] = STATE(79),
    [aux_sym_source_file_repeat1] = STATE(79),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1030),
    [anon_sym_RBRACK] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1030),
    [anon_sym_EQ] = ACTIONS(1030),
    [anon_sym_LPAREN] = ACTIONS(1030),
    [anon_sym_RPAREN] = ACTIONS(1030),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1046),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1050),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [69] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [70] = {
    [sym_block_comment] = STATE(93),
    [sym__root_content] = STATE(93),
    [sym__flat_content] = STATE(93),
    [sym__text_with_env_content] = STATE(93),
    [sym__text_content] = STATE(93),
    [sym__section] = STATE(93),
    [sym__paragraph] = STATE(93),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(93),
    [sym_text] = STATE(93),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(93),
    [sym_inline_formula] = STATE(93),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(93),
    [sym_comment_environment] = STATE(93),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(93),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(93),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(93),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(93),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(93),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(93),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(93),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(93),
    [sym_generic_command] = STATE(93),
    [sym_title_declaration] = STATE(93),
    [sym_author_declaration] = STATE(93),
    [sym_package_include] = STATE(93),
    [sym_class_include] = STATE(93),
    [sym_latex_include] = STATE(93),
    [sym_biblatex_include] = STATE(93),
    [sym_bibstyle_include] = STATE(93),
    [sym_bibtex_include] = STATE(93),
    [sym_graphics_include] = STATE(93),
    [sym_svg_include] = STATE(93),
    [sym_inkscape_include] = STATE(93),
    [sym_verbatim_include] = STATE(93),
    [sym_import_include] = STATE(93),
    [sym_caption] = STATE(93),
    [sym_citation] = STATE(93),
    [sym_label_definition] = STATE(93),
    [sym_label_reference] = STATE(93),
    [sym_label_reference_range] = STATE(93),
    [sym_label_number] = STATE(93),
    [sym_new_command_definition] = STATE(93),
    [sym_old_command_definition] = STATE(93),
    [sym_let_command_definition] = STATE(93),
    [sym_math_delimiter] = STATE(93),
    [sym_paired_delimiter_definition] = STATE(93),
    [sym_environment_definition] = STATE(93),
    [sym_glossary_entry_definition] = STATE(93),
    [sym_glossary_entry_reference] = STATE(93),
    [sym_acronym_definition] = STATE(93),
    [sym_acronym_reference] = STATE(93),
    [sym_theorem_definition] = STATE(93),
    [sym_color_definition] = STATE(93),
    [sym_color_set_definition] = STATE(93),
    [sym_color_reference] = STATE(93),
    [sym_tikz_library_import] = STATE(93),
    [sym_text_mode] = STATE(93),
    [sym_hyperlink] = STATE(93),
    [aux_sym_source_file_repeat1] = STATE(93),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1142),
    [anon_sym_RBRACK] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1142),
    [anon_sym_EQ] = ACTIONS(1142),
    [anon_sym_LPAREN] = ACTIONS(1142),
    [anon_sym_RPAREN] = ACTIONS(1142),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1160),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1164),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [71] = {
    [sym_block_comment] = STATE(77),
    [sym__root_content] = STATE(77),
    [sym__flat_content] = STATE(77),
    [sym__text_with_env_content] = STATE(77),
    [sym__text_content] = STATE(77),
    [sym__section] = STATE(77),
    [sym__paragraph] = STATE(77),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(77),
    [sym_text] = STATE(77),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(77),
    [sym_inline_formula] = STATE(77),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(77),
    [sym_comment_environment] = STATE(77),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(77),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(77),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(77),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(77),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(77),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(77),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(77),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(77),
    [sym_generic_command] = STATE(77),
    [sym_title_declaration] = STATE(77),
    [sym_author_declaration] = STATE(77),
    [sym_package_include] = STATE(77),
    [sym_class_include] = STATE(77),
    [sym_latex_include] = STATE(77),
    [sym_biblatex_include] = STATE(77),
    [sym_bibstyle_include] = STATE(77),
    [sym_bibtex_include] = STATE(77),
    [sym_graphics_include] = STATE(77),
    [sym_svg_include] = STATE(77),
    [sym_inkscape_include] = STATE(77),
    [sym_verbatim_include] = STATE(77),
    [sym_import_include] = STATE(77),
    [sym_caption] = STATE(77),
    [sym_citation] = STATE(77),
    [sym_label_definition] = STATE(77),
    [sym_label_reference] = STATE(77),
    [sym_label_reference_range] = STATE(77),
    [sym_label_number] = STATE(77),
    [sym_new_command_definition] = STATE(77),
    [sym_old_command_definition] = STATE(77),
    [sym_let_command_definition] = STATE(77),
    [sym_math_delimiter] = STATE(77),
    [sym_paired_delimiter_definition] = STATE(77),
    [sym_environment_definition] = STATE(77),
    [sym_glossary_entry_definition] = STATE(77),
    [sym_glossary_entry_reference] = STATE(77),
    [sym_acronym_definition] = STATE(77),
    [sym_acronym_reference] = STATE(77),
    [sym_theorem_definition] = STATE(77),
    [sym_color_definition] = STATE(77),
    [sym_color_set_definition] = STATE(77),
    [sym_color_reference] = STATE(77),
    [sym_tikz_library_import] = STATE(77),
    [sym_text_mode] = STATE(77),
    [sym_hyperlink] = STATE(77),
    [aux_sym_source_file_repeat1] = STATE(77),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACK] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1250),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1252),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [72] = {
    [sym_block_comment] = STATE(109),
    [sym__root_content] = STATE(109),
    [sym__flat_content] = STATE(109),
    [sym__text_with_env_content] = STATE(109),
    [sym__text_content] = STATE(109),
    [sym__section] = STATE(109),
    [sym__paragraph] = STATE(109),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(109),
    [sym_text] = STATE(109),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(109),
    [sym_inline_formula] = STATE(109),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(109),
    [sym_comment_environment] = STATE(109),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(109),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(109),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(109),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(109),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(109),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(109),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(109),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(109),
    [sym_generic_command] = STATE(109),
    [sym_title_declaration] = STATE(109),
    [sym_author_declaration] = STATE(109),
    [sym_package_include] = STATE(109),
    [sym_class_include] = STATE(109),
    [sym_latex_include] = STATE(109),
    [sym_biblatex_include] = STATE(109),
    [sym_bibstyle_include] = STATE(109),
    [sym_bibtex_include] = STATE(109),
    [sym_graphics_include] = STATE(109),
    [sym_svg_include] = STATE(109),
    [sym_inkscape_include] = STATE(109),
    [sym_verbatim_include] = STATE(109),
    [sym_import_include] = STATE(109),
    [sym_caption] = STATE(109),
    [sym_citation] = STATE(109),
    [sym_label_definition] = STATE(109),
    [sym_label_reference] = STATE(109),
    [sym_label_reference_range] = STATE(109),
    [sym_label_number] = STATE(109),
    [sym_new_command_definition] = STATE(109),
    [sym_old_command_definition] = STATE(109),
    [sym_let_command_definition] = STATE(109),
    [sym_math_delimiter] = STATE(109),
    [sym_paired_delimiter_definition] = STATE(109),
    [sym_environment_definition] = STATE(109),
    [sym_glossary_entry_definition] = STATE(109),
    [sym_glossary_entry_reference] = STATE(109),
    [sym_acronym_definition] = STATE(109),
    [sym_acronym_reference] = STATE(109),
    [sym_theorem_definition] = STATE(109),
    [sym_color_definition] = STATE(109),
    [sym_color_set_definition] = STATE(109),
    [sym_color_reference] = STATE(109),
    [sym_tikz_library_import] = STATE(109),
    [sym_text_mode] = STATE(109),
    [sym_hyperlink] = STATE(109),
    [aux_sym_source_file_repeat1] = STATE(109),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1254),
    [anon_sym_RBRACK] = ACTIONS(1254),
    [anon_sym_COMMA] = ACTIONS(1254),
    [anon_sym_EQ] = ACTIONS(1254),
    [anon_sym_LPAREN] = ACTIONS(1254),
    [anon_sym_RPAREN] = ACTIONS(1254),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [73] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1258),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1264),
    [anon_sym_RBRACK] = ACTIONS(1264),
    [anon_sym_COMMA] = ACTIONS(1264),
    [anon_sym_EQ] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_BSLASHpart] = ACTIONS(1267),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(1270),
    [anon_sym_BSLASHaddpart] = ACTIONS(1267),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(1270),
    [anon_sym_BSLASHchapter] = ACTIONS(1273),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(1276),
    [anon_sym_BSLASHaddchap] = ACTIONS(1273),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(1276),
    [anon_sym_BSLASHsection] = ACTIONS(1279),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(1282),
    [anon_sym_BSLASHaddsec] = ACTIONS(1279),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(1282),
    [anon_sym_BSLASHsubsection] = ACTIONS(1285),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(1288),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(1291),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(1294),
    [anon_sym_BSLASHparagraph] = ACTIONS(1297),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(1300),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(1303),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(1306),
    [anon_sym_BSLASHitem] = ACTIONS(1309),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [sym_word] = ACTIONS(1318),
    [sym_placeholder] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_SLASH] = ACTIONS(1324),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_COLON] = ACTIONS(1327),
    [anon_sym_SQUOTE] = ACTIONS(1327),
    [anon_sym__] = ACTIONS(1330),
    [anon_sym_CARET] = ACTIONS(1333),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1336),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(812),
    [anon_sym_DOLLAR] = ACTIONS(1339),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1342),
    [anon_sym_BSLASHbegin] = ACTIONS(434),
    [anon_sym_BSLASHtitle] = ACTIONS(1345),
    [anon_sym_BSLASHauthor] = ACTIONS(1348),
    [anon_sym_BSLASHusepackage] = ACTIONS(1351),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1351),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1354),
    [anon_sym_BSLASHinclude] = ACTIONS(1357),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1357),
    [anon_sym_BSLASHinput] = ACTIONS(1357),
    [anon_sym_BSLASHsubfile] = ACTIONS(1357),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1360),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1363),
    [anon_sym_BSLASHbibliography] = ACTIONS(1366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1369),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1372),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1375),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1378),
    [anon_sym_BSLASHimport] = ACTIONS(1381),
    [anon_sym_BSLASHsubimport] = ACTIONS(1381),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1381),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1381),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1381),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1381),
    [anon_sym_BSLASHcaption] = ACTIONS(1384),
    [anon_sym_BSLASHcite] = ACTIONS(1387),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHCite] = ACTIONS(1387),
    [anon_sym_BSLASHnocite] = ACTIONS(1387),
    [anon_sym_BSLASHcitet] = ACTIONS(1387),
    [anon_sym_BSLASHcitep] = ACTIONS(1387),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHciteA] = ACTIONS(1387),
    [anon_sym_BSLASHciteR] = ACTIONS(1387),
    [anon_sym_BSLASHciteS] = ACTIONS(1387),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1387),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1387),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1387),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1387),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHciteyear] = ACTIONS(1387),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHcitedate] = ACTIONS(1387),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHciteurl] = ACTIONS(1387),
    [anon_sym_BSLASHfullcite] = ACTIONS(1387),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1387),
    [anon_sym_BSLASHcitealt] = ACTIONS(1387),
    [anon_sym_BSLASHcitealp] = ACTIONS(1387),
    [anon_sym_BSLASHcitetext] = ACTIONS(1387),
    [anon_sym_BSLASHparencite] = ACTIONS(1387),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHParencite] = ACTIONS(1387),
    [anon_sym_BSLASHfootcite] = ACTIONS(1387),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1387),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1387),
    [anon_sym_BSLASHtextcite] = ACTIONS(1387),
    [anon_sym_BSLASHTextcite] = ACTIONS(1387),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1387),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1387),
    [anon_sym_BSLASHsupercite] = ACTIONS(1387),
    [anon_sym_BSLASHautocite] = ACTIONS(1387),
    [anon_sym_BSLASHAutocite] = ACTIONS(1387),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1390),
    [anon_sym_BSLASHvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHVolcite] = ACTIONS(1387),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHavolcite] = ACTIONS(1387),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1387),
    [anon_sym_BSLASHnotecite] = ACTIONS(1387),
    [anon_sym_BSLASHNotecite] = ACTIONS(1387),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1387),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1387),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1387),
    [anon_sym_BSLASHlabel] = ACTIONS(1393),
    [anon_sym_BSLASHref] = ACTIONS(1396),
    [anon_sym_BSLASHeqref] = ACTIONS(1396),
    [anon_sym_BSLASHvref] = ACTIONS(1396),
    [anon_sym_BSLASHVref] = ACTIONS(1396),
    [anon_sym_BSLASHautoref] = ACTIONS(1396),
    [anon_sym_BSLASHpageref] = ACTIONS(1396),
    [anon_sym_BSLASHcref] = ACTIONS(1396),
    [anon_sym_BSLASHCref] = ACTIONS(1396),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1399),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1399),
    [anon_sym_BSLASHnamecref] = ACTIONS(1396),
    [anon_sym_BSLASHnameCref] = ACTIONS(1396),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1396),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1396),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1396),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1396),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1396),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1396),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1405),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1405),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1408),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1411),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1414),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1411),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1414),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1411),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1414),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1411),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1414),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1411),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1411),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1411),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1411),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1411),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1411),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1411),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1411),
    [anon_sym_BSLASHdef] = ACTIONS(1417),
    [anon_sym_BSLASHlet] = ACTIONS(1420),
    [anon_sym_BSLASHleft] = ACTIONS(1423),
    [anon_sym_BSLASHbigl] = ACTIONS(1423),
    [anon_sym_BSLASHBigl] = ACTIONS(1423),
    [anon_sym_BSLASHbiggl] = ACTIONS(1423),
    [anon_sym_BSLASHBiggl] = ACTIONS(1423),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1429),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1429),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1429),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1429),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1429),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1429),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1432),
    [anon_sym_BSLASHgls] = ACTIONS(1435),
    [anon_sym_BSLASHGls] = ACTIONS(1435),
    [anon_sym_BSLASHGLS] = ACTIONS(1435),
    [anon_sym_BSLASHglspl] = ACTIONS(1435),
    [anon_sym_BSLASHGlspl] = ACTIONS(1435),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1435),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1435),
    [anon_sym_BSLASHglslink] = ACTIONS(1435),
    [anon_sym_BSLASHglstext] = ACTIONS(1435),
    [anon_sym_BSLASHGlstext] = ACTIONS(1435),
    [anon_sym_BSLASHGLStext] = ACTIONS(1435),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1435),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1435),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1435),
    [anon_sym_BSLASHglsplural] = ACTIONS(1435),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1435),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1435),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1435),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1435),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1435),
    [anon_sym_BSLASHglsname] = ACTIONS(1435),
    [anon_sym_BSLASHGlsname] = ACTIONS(1435),
    [anon_sym_BSLASHGLSname] = ACTIONS(1435),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1435),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1435),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1435),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1435),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1435),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1435),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1435),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1435),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1435),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1435),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1435),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1435),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1435),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1435),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1435),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1435),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1435),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1435),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1435),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1435),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1435),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1435),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1435),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1438),
    [anon_sym_BSLASHacrshort] = ACTIONS(1441),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1441),
    [anon_sym_BSLASHACRshort] = ACTIONS(1441),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1441),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1441),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1441),
    [anon_sym_BSLASHacrlong] = ACTIONS(1441),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1441),
    [anon_sym_BSLASHACRlong] = ACTIONS(1441),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1441),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1441),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1441),
    [anon_sym_BSLASHacrfull] = ACTIONS(1441),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1441),
    [anon_sym_BSLASHACRfull] = ACTIONS(1441),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1441),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1441),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1441),
    [anon_sym_BSLASHacs] = ACTIONS(1441),
    [anon_sym_BSLASHAcs] = ACTIONS(1441),
    [anon_sym_BSLASHacsp] = ACTIONS(1441),
    [anon_sym_BSLASHAcsp] = ACTIONS(1441),
    [anon_sym_BSLASHacl] = ACTIONS(1441),
    [anon_sym_BSLASHAcl] = ACTIONS(1441),
    [anon_sym_BSLASHaclp] = ACTIONS(1441),
    [anon_sym_BSLASHAclp] = ACTIONS(1441),
    [anon_sym_BSLASHacf] = ACTIONS(1441),
    [anon_sym_BSLASHAcf] = ACTIONS(1441),
    [anon_sym_BSLASHacfp] = ACTIONS(1441),
    [anon_sym_BSLASHAcfp] = ACTIONS(1441),
    [anon_sym_BSLASHac] = ACTIONS(1441),
    [anon_sym_BSLASHAc] = ACTIONS(1441),
    [anon_sym_BSLASHacp] = ACTIONS(1441),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1441),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1441),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1441),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1441),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1441),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1441),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1441),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1441),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1441),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1441),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1444),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1447),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1444),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1447),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1453),
    [anon_sym_BSLASHcolor] = ACTIONS(1456),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1456),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1456),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1456),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1459),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1459),
    [anon_sym_BSLASHtext] = ACTIONS(1462),
    [anon_sym_BSLASHintertext] = ACTIONS(1462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1462),
    [anon_sym_BSLASHurl] = ACTIONS(1465),
    [anon_sym_BSLASHhref] = ACTIONS(1465),
  },
  [74] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(1468),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [75] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [76] = {
    [sym_block_comment] = STATE(80),
    [sym__root_content] = STATE(80),
    [sym__flat_content] = STATE(80),
    [sym__text_with_env_content] = STATE(80),
    [sym__text_content] = STATE(80),
    [sym__section] = STATE(80),
    [sym__paragraph] = STATE(80),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(80),
    [sym_text] = STATE(80),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(80),
    [sym_inline_formula] = STATE(80),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(80),
    [sym_comment_environment] = STATE(80),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(80),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(80),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(80),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(80),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(80),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(80),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(80),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(80),
    [sym_generic_command] = STATE(80),
    [sym_title_declaration] = STATE(80),
    [sym_author_declaration] = STATE(80),
    [sym_package_include] = STATE(80),
    [sym_class_include] = STATE(80),
    [sym_latex_include] = STATE(80),
    [sym_biblatex_include] = STATE(80),
    [sym_bibstyle_include] = STATE(80),
    [sym_bibtex_include] = STATE(80),
    [sym_graphics_include] = STATE(80),
    [sym_svg_include] = STATE(80),
    [sym_inkscape_include] = STATE(80),
    [sym_verbatim_include] = STATE(80),
    [sym_import_include] = STATE(80),
    [sym_caption] = STATE(80),
    [sym_citation] = STATE(80),
    [sym_label_definition] = STATE(80),
    [sym_label_reference] = STATE(80),
    [sym_label_reference_range] = STATE(80),
    [sym_label_number] = STATE(80),
    [sym_new_command_definition] = STATE(80),
    [sym_old_command_definition] = STATE(80),
    [sym_let_command_definition] = STATE(80),
    [sym_math_delimiter] = STATE(80),
    [sym_paired_delimiter_definition] = STATE(80),
    [sym_environment_definition] = STATE(80),
    [sym_glossary_entry_definition] = STATE(80),
    [sym_glossary_entry_reference] = STATE(80),
    [sym_acronym_definition] = STATE(80),
    [sym_acronym_reference] = STATE(80),
    [sym_theorem_definition] = STATE(80),
    [sym_color_definition] = STATE(80),
    [sym_color_set_definition] = STATE(80),
    [sym_color_reference] = STATE(80),
    [sym_tikz_library_import] = STATE(80),
    [sym_text_mode] = STATE(80),
    [sym_hyperlink] = STATE(80),
    [aux_sym_source_file_repeat1] = STATE(80),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1472),
    [anon_sym_RBRACK] = ACTIONS(1472),
    [anon_sym_COMMA] = ACTIONS(1472),
    [anon_sym_EQ] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1472),
    [anon_sym_RPAREN] = ACTIONS(1472),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1476),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [77] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1482),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [78] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1484),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [79] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1486),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1488),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [80] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1492),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1494),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [81] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1498),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [82] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [83] = {
    [sym_block_comment] = STATE(108),
    [sym__root_content] = STATE(108),
    [sym__flat_content] = STATE(108),
    [sym__text_with_env_content] = STATE(108),
    [sym__text_content] = STATE(108),
    [sym__section] = STATE(108),
    [sym__paragraph] = STATE(108),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(108),
    [sym_text] = STATE(108),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(108),
    [sym_inline_formula] = STATE(108),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(108),
    [sym_comment_environment] = STATE(108),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(108),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(108),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(108),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(108),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(108),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(108),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(108),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(108),
    [sym_generic_command] = STATE(108),
    [sym_title_declaration] = STATE(108),
    [sym_author_declaration] = STATE(108),
    [sym_package_include] = STATE(108),
    [sym_class_include] = STATE(108),
    [sym_latex_include] = STATE(108),
    [sym_biblatex_include] = STATE(108),
    [sym_bibstyle_include] = STATE(108),
    [sym_bibtex_include] = STATE(108),
    [sym_graphics_include] = STATE(108),
    [sym_svg_include] = STATE(108),
    [sym_inkscape_include] = STATE(108),
    [sym_verbatim_include] = STATE(108),
    [sym_import_include] = STATE(108),
    [sym_caption] = STATE(108),
    [sym_citation] = STATE(108),
    [sym_label_definition] = STATE(108),
    [sym_label_reference] = STATE(108),
    [sym_label_reference_range] = STATE(108),
    [sym_label_number] = STATE(108),
    [sym_new_command_definition] = STATE(108),
    [sym_old_command_definition] = STATE(108),
    [sym_let_command_definition] = STATE(108),
    [sym_math_delimiter] = STATE(108),
    [sym_paired_delimiter_definition] = STATE(108),
    [sym_environment_definition] = STATE(108),
    [sym_glossary_entry_definition] = STATE(108),
    [sym_glossary_entry_reference] = STATE(108),
    [sym_acronym_definition] = STATE(108),
    [sym_acronym_reference] = STATE(108),
    [sym_theorem_definition] = STATE(108),
    [sym_color_definition] = STATE(108),
    [sym_color_set_definition] = STATE(108),
    [sym_color_reference] = STATE(108),
    [sym_tikz_library_import] = STATE(108),
    [sym_text_mode] = STATE(108),
    [sym_hyperlink] = STATE(108),
    [aux_sym_source_file_repeat1] = STATE(108),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1500),
    [anon_sym_RBRACK] = ACTIONS(1500),
    [anon_sym_COMMA] = ACTIONS(1500),
    [anon_sym_EQ] = ACTIONS(1500),
    [anon_sym_LPAREN] = ACTIONS(1500),
    [anon_sym_RPAREN] = ACTIONS(1500),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1504),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [84] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1506),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1508),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [85] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [86] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(578),
    [anon_sym_RBRACK] = ACTIONS(578),
    [anon_sym_COMMA] = ACTIONS(578),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1510),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [87] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [88] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [89] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1512),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [90] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1514),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [91] = {
    [sym_block_comment] = STATE(145),
    [sym__root_content] = STATE(145),
    [sym__flat_content] = STATE(145),
    [sym__text_with_env_content] = STATE(145),
    [sym__text_content] = STATE(145),
    [sym__section] = STATE(145),
    [sym__paragraph] = STATE(145),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(145),
    [sym_text] = STATE(145),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(145),
    [sym_inline_formula] = STATE(145),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(145),
    [sym_comment_environment] = STATE(145),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(145),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(145),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(145),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(145),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(145),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(145),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(145),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(145),
    [sym_generic_command] = STATE(145),
    [sym_title_declaration] = STATE(145),
    [sym_author_declaration] = STATE(145),
    [sym_package_include] = STATE(145),
    [sym_class_include] = STATE(145),
    [sym_latex_include] = STATE(145),
    [sym_biblatex_include] = STATE(145),
    [sym_bibstyle_include] = STATE(145),
    [sym_bibtex_include] = STATE(145),
    [sym_graphics_include] = STATE(145),
    [sym_svg_include] = STATE(145),
    [sym_inkscape_include] = STATE(145),
    [sym_verbatim_include] = STATE(145),
    [sym_import_include] = STATE(145),
    [sym_caption] = STATE(145),
    [sym_citation] = STATE(145),
    [sym_label_definition] = STATE(145),
    [sym_label_reference] = STATE(145),
    [sym_label_reference_range] = STATE(145),
    [sym_label_number] = STATE(145),
    [sym_new_command_definition] = STATE(145),
    [sym_old_command_definition] = STATE(145),
    [sym_let_command_definition] = STATE(145),
    [sym_math_delimiter] = STATE(145),
    [sym_paired_delimiter_definition] = STATE(145),
    [sym_environment_definition] = STATE(145),
    [sym_glossary_entry_definition] = STATE(145),
    [sym_glossary_entry_reference] = STATE(145),
    [sym_acronym_definition] = STATE(145),
    [sym_acronym_reference] = STATE(145),
    [sym_theorem_definition] = STATE(145),
    [sym_color_definition] = STATE(145),
    [sym_color_set_definition] = STATE(145),
    [sym_color_reference] = STATE(145),
    [sym_tikz_library_import] = STATE(145),
    [sym_text_mode] = STATE(145),
    [sym_hyperlink] = STATE(145),
    [aux_sym_source_file_repeat1] = STATE(145),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1516),
    [anon_sym_RBRACK] = ACTIONS(1516),
    [anon_sym_COMMA] = ACTIONS(1516),
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1516),
    [anon_sym_RPAREN] = ACTIONS(1516),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1518),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [92] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [93] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1520),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1522),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [94] = {
    [sym_block_comment] = STATE(78),
    [sym__root_content] = STATE(78),
    [sym__flat_content] = STATE(78),
    [sym__text_with_env_content] = STATE(78),
    [sym__text_content] = STATE(78),
    [sym__section] = STATE(78),
    [sym__paragraph] = STATE(78),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(78),
    [sym_text] = STATE(78),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(78),
    [sym_inline_formula] = STATE(78),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(78),
    [sym_comment_environment] = STATE(78),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(78),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(78),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(78),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(78),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(78),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(78),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(78),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(78),
    [sym_generic_command] = STATE(78),
    [sym_title_declaration] = STATE(78),
    [sym_author_declaration] = STATE(78),
    [sym_package_include] = STATE(78),
    [sym_class_include] = STATE(78),
    [sym_latex_include] = STATE(78),
    [sym_biblatex_include] = STATE(78),
    [sym_bibstyle_include] = STATE(78),
    [sym_bibtex_include] = STATE(78),
    [sym_graphics_include] = STATE(78),
    [sym_svg_include] = STATE(78),
    [sym_inkscape_include] = STATE(78),
    [sym_verbatim_include] = STATE(78),
    [sym_import_include] = STATE(78),
    [sym_caption] = STATE(78),
    [sym_citation] = STATE(78),
    [sym_label_definition] = STATE(78),
    [sym_label_reference] = STATE(78),
    [sym_label_reference_range] = STATE(78),
    [sym_label_number] = STATE(78),
    [sym_new_command_definition] = STATE(78),
    [sym_old_command_definition] = STATE(78),
    [sym_let_command_definition] = STATE(78),
    [sym_math_delimiter] = STATE(78),
    [sym_paired_delimiter_definition] = STATE(78),
    [sym_environment_definition] = STATE(78),
    [sym_glossary_entry_definition] = STATE(78),
    [sym_glossary_entry_reference] = STATE(78),
    [sym_acronym_definition] = STATE(78),
    [sym_acronym_reference] = STATE(78),
    [sym_theorem_definition] = STATE(78),
    [sym_color_definition] = STATE(78),
    [sym_color_set_definition] = STATE(78),
    [sym_color_reference] = STATE(78),
    [sym_tikz_library_import] = STATE(78),
    [sym_text_mode] = STATE(78),
    [sym_hyperlink] = STATE(78),
    [aux_sym_source_file_repeat1] = STATE(78),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_RBRACK] = ACTIONS(1524),
    [anon_sym_COMMA] = ACTIONS(1524),
    [anon_sym_EQ] = ACTIONS(1524),
    [anon_sym_LPAREN] = ACTIONS(1524),
    [anon_sym_RPAREN] = ACTIONS(1524),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1526),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [95] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [96] = {
    [sym_block_comment] = STATE(100),
    [sym__root_content] = STATE(100),
    [sym__flat_content] = STATE(100),
    [sym__text_with_env_content] = STATE(100),
    [sym__text_content] = STATE(100),
    [sym__section] = STATE(100),
    [sym__paragraph] = STATE(100),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(100),
    [sym_text] = STATE(100),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(100),
    [sym_inline_formula] = STATE(100),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(100),
    [sym_comment_environment] = STATE(100),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(100),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(100),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(100),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(100),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(100),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(100),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(100),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(100),
    [sym_generic_command] = STATE(100),
    [sym_title_declaration] = STATE(100),
    [sym_author_declaration] = STATE(100),
    [sym_package_include] = STATE(100),
    [sym_class_include] = STATE(100),
    [sym_latex_include] = STATE(100),
    [sym_biblatex_include] = STATE(100),
    [sym_bibstyle_include] = STATE(100),
    [sym_bibtex_include] = STATE(100),
    [sym_graphics_include] = STATE(100),
    [sym_svg_include] = STATE(100),
    [sym_inkscape_include] = STATE(100),
    [sym_verbatim_include] = STATE(100),
    [sym_import_include] = STATE(100),
    [sym_caption] = STATE(100),
    [sym_citation] = STATE(100),
    [sym_label_definition] = STATE(100),
    [sym_label_reference] = STATE(100),
    [sym_label_reference_range] = STATE(100),
    [sym_label_number] = STATE(100),
    [sym_new_command_definition] = STATE(100),
    [sym_old_command_definition] = STATE(100),
    [sym_let_command_definition] = STATE(100),
    [sym_math_delimiter] = STATE(100),
    [sym_paired_delimiter_definition] = STATE(100),
    [sym_environment_definition] = STATE(100),
    [sym_glossary_entry_definition] = STATE(100),
    [sym_glossary_entry_reference] = STATE(100),
    [sym_acronym_definition] = STATE(100),
    [sym_acronym_reference] = STATE(100),
    [sym_theorem_definition] = STATE(100),
    [sym_color_definition] = STATE(100),
    [sym_color_set_definition] = STATE(100),
    [sym_color_reference] = STATE(100),
    [sym_tikz_library_import] = STATE(100),
    [sym_text_mode] = STATE(100),
    [sym_hyperlink] = STATE(100),
    [aux_sym_source_file_repeat1] = STATE(100),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1528),
    [anon_sym_RBRACK] = ACTIONS(1528),
    [anon_sym_COMMA] = ACTIONS(1528),
    [anon_sym_EQ] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1528),
    [anon_sym_RPAREN] = ACTIONS(1528),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [97] = {
    [sym_block_comment] = STATE(102),
    [sym__root_content] = STATE(102),
    [sym__flat_content] = STATE(102),
    [sym__text_with_env_content] = STATE(102),
    [sym__text_content] = STATE(102),
    [sym__section] = STATE(102),
    [sym__paragraph] = STATE(102),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(102),
    [sym_text] = STATE(102),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(102),
    [sym_inline_formula] = STATE(102),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(102),
    [sym_comment_environment] = STATE(102),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(102),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(102),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(102),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(102),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(102),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(102),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(102),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(102),
    [sym_generic_command] = STATE(102),
    [sym_title_declaration] = STATE(102),
    [sym_author_declaration] = STATE(102),
    [sym_package_include] = STATE(102),
    [sym_class_include] = STATE(102),
    [sym_latex_include] = STATE(102),
    [sym_biblatex_include] = STATE(102),
    [sym_bibstyle_include] = STATE(102),
    [sym_bibtex_include] = STATE(102),
    [sym_graphics_include] = STATE(102),
    [sym_svg_include] = STATE(102),
    [sym_inkscape_include] = STATE(102),
    [sym_verbatim_include] = STATE(102),
    [sym_import_include] = STATE(102),
    [sym_caption] = STATE(102),
    [sym_citation] = STATE(102),
    [sym_label_definition] = STATE(102),
    [sym_label_reference] = STATE(102),
    [sym_label_reference_range] = STATE(102),
    [sym_label_number] = STATE(102),
    [sym_new_command_definition] = STATE(102),
    [sym_old_command_definition] = STATE(102),
    [sym_let_command_definition] = STATE(102),
    [sym_math_delimiter] = STATE(102),
    [sym_paired_delimiter_definition] = STATE(102),
    [sym_environment_definition] = STATE(102),
    [sym_glossary_entry_definition] = STATE(102),
    [sym_glossary_entry_reference] = STATE(102),
    [sym_acronym_definition] = STATE(102),
    [sym_acronym_reference] = STATE(102),
    [sym_theorem_definition] = STATE(102),
    [sym_color_definition] = STATE(102),
    [sym_color_set_definition] = STATE(102),
    [sym_color_reference] = STATE(102),
    [sym_tikz_library_import] = STATE(102),
    [sym_text_mode] = STATE(102),
    [sym_hyperlink] = STATE(102),
    [aux_sym_source_file_repeat1] = STATE(102),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1532),
    [anon_sym_RBRACK] = ACTIONS(1532),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1534),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1252),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [98] = {
    [sym_block_comment] = STATE(105),
    [sym__root_content] = STATE(105),
    [sym__flat_content] = STATE(105),
    [sym__text_with_env_content] = STATE(105),
    [sym__text_content] = STATE(105),
    [sym__section] = STATE(105),
    [sym__paragraph] = STATE(105),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(105),
    [sym_text] = STATE(105),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(105),
    [sym_inline_formula] = STATE(105),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(105),
    [sym_comment_environment] = STATE(105),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(105),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(105),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(105),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(105),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(105),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(105),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(105),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(105),
    [sym_generic_command] = STATE(105),
    [sym_title_declaration] = STATE(105),
    [sym_author_declaration] = STATE(105),
    [sym_package_include] = STATE(105),
    [sym_class_include] = STATE(105),
    [sym_latex_include] = STATE(105),
    [sym_biblatex_include] = STATE(105),
    [sym_bibstyle_include] = STATE(105),
    [sym_bibtex_include] = STATE(105),
    [sym_graphics_include] = STATE(105),
    [sym_svg_include] = STATE(105),
    [sym_inkscape_include] = STATE(105),
    [sym_verbatim_include] = STATE(105),
    [sym_import_include] = STATE(105),
    [sym_caption] = STATE(105),
    [sym_citation] = STATE(105),
    [sym_label_definition] = STATE(105),
    [sym_label_reference] = STATE(105),
    [sym_label_reference_range] = STATE(105),
    [sym_label_number] = STATE(105),
    [sym_new_command_definition] = STATE(105),
    [sym_old_command_definition] = STATE(105),
    [sym_let_command_definition] = STATE(105),
    [sym_math_delimiter] = STATE(105),
    [sym_paired_delimiter_definition] = STATE(105),
    [sym_environment_definition] = STATE(105),
    [sym_glossary_entry_definition] = STATE(105),
    [sym_glossary_entry_reference] = STATE(105),
    [sym_acronym_definition] = STATE(105),
    [sym_acronym_reference] = STATE(105),
    [sym_theorem_definition] = STATE(105),
    [sym_color_definition] = STATE(105),
    [sym_color_set_definition] = STATE(105),
    [sym_color_reference] = STATE(105),
    [sym_tikz_library_import] = STATE(105),
    [sym_text_mode] = STATE(105),
    [sym_hyperlink] = STATE(105),
    [aux_sym_source_file_repeat1] = STATE(105),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1536),
    [anon_sym_RBRACK] = ACTIONS(1536),
    [anon_sym_COMMA] = ACTIONS(1536),
    [anon_sym_EQ] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1536),
    [anon_sym_RPAREN] = ACTIONS(1536),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1538),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1164),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [99] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1540),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [100] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1542),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [101] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1544),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1546),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [102] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1548),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1482),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [103] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_RBRACK] = ACTIONS(612),
    [anon_sym_COMMA] = ACTIONS(612),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(612),
    [anon_sym_RPAREN] = ACTIONS(612),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [104] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1554),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [105] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1556),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1522),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [106] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1560),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [107] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1562),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1564),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [108] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1566),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1568),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [109] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [110] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1572),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1574),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [111] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1578),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [112] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1580),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1582),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [113] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1584),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [114] = {
    [sym_block_comment] = STATE(111),
    [sym__root_content] = STATE(111),
    [sym__flat_content] = STATE(111),
    [sym__text_with_env_content] = STATE(111),
    [sym__text_content] = STATE(111),
    [sym__section] = STATE(111),
    [sym__paragraph] = STATE(111),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(111),
    [sym_text] = STATE(111),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(111),
    [sym_inline_formula] = STATE(111),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(111),
    [sym_comment_environment] = STATE(111),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(111),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(111),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(111),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(111),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(111),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(111),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(111),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(111),
    [sym_generic_command] = STATE(111),
    [sym_title_declaration] = STATE(111),
    [sym_author_declaration] = STATE(111),
    [sym_package_include] = STATE(111),
    [sym_class_include] = STATE(111),
    [sym_latex_include] = STATE(111),
    [sym_biblatex_include] = STATE(111),
    [sym_bibstyle_include] = STATE(111),
    [sym_bibtex_include] = STATE(111),
    [sym_graphics_include] = STATE(111),
    [sym_svg_include] = STATE(111),
    [sym_inkscape_include] = STATE(111),
    [sym_verbatim_include] = STATE(111),
    [sym_import_include] = STATE(111),
    [sym_caption] = STATE(111),
    [sym_citation] = STATE(111),
    [sym_label_definition] = STATE(111),
    [sym_label_reference] = STATE(111),
    [sym_label_reference_range] = STATE(111),
    [sym_label_number] = STATE(111),
    [sym_new_command_definition] = STATE(111),
    [sym_old_command_definition] = STATE(111),
    [sym_let_command_definition] = STATE(111),
    [sym_math_delimiter] = STATE(111),
    [sym_paired_delimiter_definition] = STATE(111),
    [sym_environment_definition] = STATE(111),
    [sym_glossary_entry_definition] = STATE(111),
    [sym_glossary_entry_reference] = STATE(111),
    [sym_acronym_definition] = STATE(111),
    [sym_acronym_reference] = STATE(111),
    [sym_theorem_definition] = STATE(111),
    [sym_color_definition] = STATE(111),
    [sym_color_set_definition] = STATE(111),
    [sym_color_reference] = STATE(111),
    [sym_tikz_library_import] = STATE(111),
    [sym_text_mode] = STATE(111),
    [sym_hyperlink] = STATE(111),
    [aux_sym_source_file_repeat1] = STATE(111),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1586),
    [anon_sym_RBRACK] = ACTIONS(1586),
    [anon_sym_COMMA] = ACTIONS(1586),
    [anon_sym_EQ] = ACTIONS(1586),
    [anon_sym_LPAREN] = ACTIONS(1586),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1588),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1590),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [115] = {
    [sym_block_comment] = STATE(112),
    [sym__root_content] = STATE(112),
    [sym__flat_content] = STATE(112),
    [sym__text_with_env_content] = STATE(112),
    [sym__text_content] = STATE(112),
    [sym__section] = STATE(112),
    [sym__paragraph] = STATE(112),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(112),
    [sym_text] = STATE(112),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(112),
    [sym_inline_formula] = STATE(112),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(112),
    [sym_comment_environment] = STATE(112),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(112),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(112),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(112),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(112),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(112),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(112),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(112),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(112),
    [sym_generic_command] = STATE(112),
    [sym_title_declaration] = STATE(112),
    [sym_author_declaration] = STATE(112),
    [sym_package_include] = STATE(112),
    [sym_class_include] = STATE(112),
    [sym_latex_include] = STATE(112),
    [sym_biblatex_include] = STATE(112),
    [sym_bibstyle_include] = STATE(112),
    [sym_bibtex_include] = STATE(112),
    [sym_graphics_include] = STATE(112),
    [sym_svg_include] = STATE(112),
    [sym_inkscape_include] = STATE(112),
    [sym_verbatim_include] = STATE(112),
    [sym_import_include] = STATE(112),
    [sym_caption] = STATE(112),
    [sym_citation] = STATE(112),
    [sym_label_definition] = STATE(112),
    [sym_label_reference] = STATE(112),
    [sym_label_reference_range] = STATE(112),
    [sym_label_number] = STATE(112),
    [sym_new_command_definition] = STATE(112),
    [sym_old_command_definition] = STATE(112),
    [sym_let_command_definition] = STATE(112),
    [sym_math_delimiter] = STATE(112),
    [sym_paired_delimiter_definition] = STATE(112),
    [sym_environment_definition] = STATE(112),
    [sym_glossary_entry_definition] = STATE(112),
    [sym_glossary_entry_reference] = STATE(112),
    [sym_acronym_definition] = STATE(112),
    [sym_acronym_reference] = STATE(112),
    [sym_theorem_definition] = STATE(112),
    [sym_color_definition] = STATE(112),
    [sym_color_set_definition] = STATE(112),
    [sym_color_reference] = STATE(112),
    [sym_tikz_library_import] = STATE(112),
    [sym_text_mode] = STATE(112),
    [sym_hyperlink] = STATE(112),
    [aux_sym_source_file_repeat1] = STATE(112),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1592),
    [anon_sym_RBRACK] = ACTIONS(1592),
    [anon_sym_COMMA] = ACTIONS(1592),
    [anon_sym_EQ] = ACTIONS(1592),
    [anon_sym_LPAREN] = ACTIONS(1592),
    [anon_sym_RPAREN] = ACTIONS(1592),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1594),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1596),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [116] = {
    [sym_block_comment] = STATE(113),
    [sym__root_content] = STATE(113),
    [sym__flat_content] = STATE(113),
    [sym__text_with_env_content] = STATE(113),
    [sym__text_content] = STATE(113),
    [sym__section] = STATE(113),
    [sym__paragraph] = STATE(113),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(113),
    [sym_text] = STATE(113),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(113),
    [sym_inline_formula] = STATE(113),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(113),
    [sym_comment_environment] = STATE(113),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(113),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(113),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(113),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(113),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(113),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(113),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(113),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(113),
    [sym_generic_command] = STATE(113),
    [sym_title_declaration] = STATE(113),
    [sym_author_declaration] = STATE(113),
    [sym_package_include] = STATE(113),
    [sym_class_include] = STATE(113),
    [sym_latex_include] = STATE(113),
    [sym_biblatex_include] = STATE(113),
    [sym_bibstyle_include] = STATE(113),
    [sym_bibtex_include] = STATE(113),
    [sym_graphics_include] = STATE(113),
    [sym_svg_include] = STATE(113),
    [sym_inkscape_include] = STATE(113),
    [sym_verbatim_include] = STATE(113),
    [sym_import_include] = STATE(113),
    [sym_caption] = STATE(113),
    [sym_citation] = STATE(113),
    [sym_label_definition] = STATE(113),
    [sym_label_reference] = STATE(113),
    [sym_label_reference_range] = STATE(113),
    [sym_label_number] = STATE(113),
    [sym_new_command_definition] = STATE(113),
    [sym_old_command_definition] = STATE(113),
    [sym_let_command_definition] = STATE(113),
    [sym_math_delimiter] = STATE(113),
    [sym_paired_delimiter_definition] = STATE(113),
    [sym_environment_definition] = STATE(113),
    [sym_glossary_entry_definition] = STATE(113),
    [sym_glossary_entry_reference] = STATE(113),
    [sym_acronym_definition] = STATE(113),
    [sym_acronym_reference] = STATE(113),
    [sym_theorem_definition] = STATE(113),
    [sym_color_definition] = STATE(113),
    [sym_color_set_definition] = STATE(113),
    [sym_color_reference] = STATE(113),
    [sym_tikz_library_import] = STATE(113),
    [sym_text_mode] = STATE(113),
    [sym_hyperlink] = STATE(113),
    [aux_sym_source_file_repeat1] = STATE(113),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1598),
    [anon_sym_RBRACK] = ACTIONS(1598),
    [anon_sym_COMMA] = ACTIONS(1598),
    [anon_sym_EQ] = ACTIONS(1598),
    [anon_sym_LPAREN] = ACTIONS(1598),
    [anon_sym_RPAREN] = ACTIONS(1598),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1600),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [117] = {
    [sym_block_comment] = STATE(90),
    [sym__root_content] = STATE(90),
    [sym__flat_content] = STATE(90),
    [sym__text_with_env_content] = STATE(90),
    [sym__text_content] = STATE(90),
    [sym__section] = STATE(90),
    [sym__paragraph] = STATE(90),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(90),
    [sym_text] = STATE(90),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(90),
    [sym_inline_formula] = STATE(90),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(90),
    [sym_comment_environment] = STATE(90),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(90),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(90),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(90),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(90),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(90),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(90),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(90),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(90),
    [sym_generic_command] = STATE(90),
    [sym_title_declaration] = STATE(90),
    [sym_author_declaration] = STATE(90),
    [sym_package_include] = STATE(90),
    [sym_class_include] = STATE(90),
    [sym_latex_include] = STATE(90),
    [sym_biblatex_include] = STATE(90),
    [sym_bibstyle_include] = STATE(90),
    [sym_bibtex_include] = STATE(90),
    [sym_graphics_include] = STATE(90),
    [sym_svg_include] = STATE(90),
    [sym_inkscape_include] = STATE(90),
    [sym_verbatim_include] = STATE(90),
    [sym_import_include] = STATE(90),
    [sym_caption] = STATE(90),
    [sym_citation] = STATE(90),
    [sym_label_definition] = STATE(90),
    [sym_label_reference] = STATE(90),
    [sym_label_reference_range] = STATE(90),
    [sym_label_number] = STATE(90),
    [sym_new_command_definition] = STATE(90),
    [sym_old_command_definition] = STATE(90),
    [sym_let_command_definition] = STATE(90),
    [sym_math_delimiter] = STATE(90),
    [sym_paired_delimiter_definition] = STATE(90),
    [sym_environment_definition] = STATE(90),
    [sym_glossary_entry_definition] = STATE(90),
    [sym_glossary_entry_reference] = STATE(90),
    [sym_acronym_definition] = STATE(90),
    [sym_acronym_reference] = STATE(90),
    [sym_theorem_definition] = STATE(90),
    [sym_color_definition] = STATE(90),
    [sym_color_set_definition] = STATE(90),
    [sym_color_reference] = STATE(90),
    [sym_tikz_library_import] = STATE(90),
    [sym_text_mode] = STATE(90),
    [sym_hyperlink] = STATE(90),
    [aux_sym_source_file_repeat1] = STATE(90),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1602),
    [anon_sym_RBRACK] = ACTIONS(1602),
    [anon_sym_COMMA] = ACTIONS(1602),
    [anon_sym_EQ] = ACTIONS(1602),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_RPAREN] = ACTIONS(1602),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1604),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [118] = {
    [sym_block_comment] = STATE(120),
    [sym__root_content] = STATE(120),
    [sym__flat_content] = STATE(120),
    [sym__text_with_env_content] = STATE(120),
    [sym__text_content] = STATE(120),
    [sym__section] = STATE(120),
    [sym__paragraph] = STATE(120),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(120),
    [sym_text] = STATE(120),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(120),
    [sym_inline_formula] = STATE(120),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(120),
    [sym_comment_environment] = STATE(120),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(120),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(120),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(120),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(120),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(120),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(120),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(120),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(120),
    [sym_generic_command] = STATE(120),
    [sym_title_declaration] = STATE(120),
    [sym_author_declaration] = STATE(120),
    [sym_package_include] = STATE(120),
    [sym_class_include] = STATE(120),
    [sym_latex_include] = STATE(120),
    [sym_biblatex_include] = STATE(120),
    [sym_bibstyle_include] = STATE(120),
    [sym_bibtex_include] = STATE(120),
    [sym_graphics_include] = STATE(120),
    [sym_svg_include] = STATE(120),
    [sym_inkscape_include] = STATE(120),
    [sym_verbatim_include] = STATE(120),
    [sym_import_include] = STATE(120),
    [sym_caption] = STATE(120),
    [sym_citation] = STATE(120),
    [sym_label_definition] = STATE(120),
    [sym_label_reference] = STATE(120),
    [sym_label_reference_range] = STATE(120),
    [sym_label_number] = STATE(120),
    [sym_new_command_definition] = STATE(120),
    [sym_old_command_definition] = STATE(120),
    [sym_let_command_definition] = STATE(120),
    [sym_math_delimiter] = STATE(120),
    [sym_paired_delimiter_definition] = STATE(120),
    [sym_environment_definition] = STATE(120),
    [sym_glossary_entry_definition] = STATE(120),
    [sym_glossary_entry_reference] = STATE(120),
    [sym_acronym_definition] = STATE(120),
    [sym_acronym_reference] = STATE(120),
    [sym_theorem_definition] = STATE(120),
    [sym_color_definition] = STATE(120),
    [sym_color_set_definition] = STATE(120),
    [sym_color_reference] = STATE(120),
    [sym_tikz_library_import] = STATE(120),
    [sym_text_mode] = STATE(120),
    [sym_hyperlink] = STATE(120),
    [aux_sym_source_file_repeat1] = STATE(120),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1606),
    [anon_sym_RBRACK] = ACTIONS(1606),
    [anon_sym_COMMA] = ACTIONS(1606),
    [anon_sym_EQ] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1606),
    [anon_sym_RPAREN] = ACTIONS(1606),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1608),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1252),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [119] = {
    [sym_block_comment] = STATE(121),
    [sym__root_content] = STATE(121),
    [sym__flat_content] = STATE(121),
    [sym__text_with_env_content] = STATE(121),
    [sym__text_content] = STATE(121),
    [sym__section] = STATE(121),
    [sym__paragraph] = STATE(121),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(121),
    [sym_text] = STATE(121),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(121),
    [sym_inline_formula] = STATE(121),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(121),
    [sym_comment_environment] = STATE(121),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(121),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(121),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(121),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(121),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(121),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(121),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(121),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(121),
    [sym_generic_command] = STATE(121),
    [sym_title_declaration] = STATE(121),
    [sym_author_declaration] = STATE(121),
    [sym_package_include] = STATE(121),
    [sym_class_include] = STATE(121),
    [sym_latex_include] = STATE(121),
    [sym_biblatex_include] = STATE(121),
    [sym_bibstyle_include] = STATE(121),
    [sym_bibtex_include] = STATE(121),
    [sym_graphics_include] = STATE(121),
    [sym_svg_include] = STATE(121),
    [sym_inkscape_include] = STATE(121),
    [sym_verbatim_include] = STATE(121),
    [sym_import_include] = STATE(121),
    [sym_caption] = STATE(121),
    [sym_citation] = STATE(121),
    [sym_label_definition] = STATE(121),
    [sym_label_reference] = STATE(121),
    [sym_label_reference_range] = STATE(121),
    [sym_label_number] = STATE(121),
    [sym_new_command_definition] = STATE(121),
    [sym_old_command_definition] = STATE(121),
    [sym_let_command_definition] = STATE(121),
    [sym_math_delimiter] = STATE(121),
    [sym_paired_delimiter_definition] = STATE(121),
    [sym_environment_definition] = STATE(121),
    [sym_glossary_entry_definition] = STATE(121),
    [sym_glossary_entry_reference] = STATE(121),
    [sym_acronym_definition] = STATE(121),
    [sym_acronym_reference] = STATE(121),
    [sym_theorem_definition] = STATE(121),
    [sym_color_definition] = STATE(121),
    [sym_color_set_definition] = STATE(121),
    [sym_color_reference] = STATE(121),
    [sym_tikz_library_import] = STATE(121),
    [sym_text_mode] = STATE(121),
    [sym_hyperlink] = STATE(121),
    [aux_sym_source_file_repeat1] = STATE(121),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1610),
    [anon_sym_RBRACK] = ACTIONS(1610),
    [anon_sym_COMMA] = ACTIONS(1610),
    [anon_sym_EQ] = ACTIONS(1610),
    [anon_sym_LPAREN] = ACTIONS(1610),
    [anon_sym_RPAREN] = ACTIONS(1610),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1612),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1164),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [120] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1614),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1482),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [121] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1616),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1522),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [122] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [123] = {
    [sym_block_comment] = STATE(144),
    [sym__root_content] = STATE(144),
    [sym__flat_content] = STATE(144),
    [sym__text_with_env_content] = STATE(144),
    [sym__text_content] = STATE(144),
    [sym__section] = STATE(144),
    [sym__paragraph] = STATE(144),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(144),
    [sym_text] = STATE(144),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(144),
    [sym_inline_formula] = STATE(144),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(144),
    [sym_comment_environment] = STATE(144),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(144),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(144),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(144),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(144),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(144),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(144),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(144),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(144),
    [sym_generic_command] = STATE(144),
    [sym_title_declaration] = STATE(144),
    [sym_author_declaration] = STATE(144),
    [sym_package_include] = STATE(144),
    [sym_class_include] = STATE(144),
    [sym_latex_include] = STATE(144),
    [sym_biblatex_include] = STATE(144),
    [sym_bibstyle_include] = STATE(144),
    [sym_bibtex_include] = STATE(144),
    [sym_graphics_include] = STATE(144),
    [sym_svg_include] = STATE(144),
    [sym_inkscape_include] = STATE(144),
    [sym_verbatim_include] = STATE(144),
    [sym_import_include] = STATE(144),
    [sym_caption] = STATE(144),
    [sym_citation] = STATE(144),
    [sym_label_definition] = STATE(144),
    [sym_label_reference] = STATE(144),
    [sym_label_reference_range] = STATE(144),
    [sym_label_number] = STATE(144),
    [sym_new_command_definition] = STATE(144),
    [sym_old_command_definition] = STATE(144),
    [sym_let_command_definition] = STATE(144),
    [sym_math_delimiter] = STATE(144),
    [sym_paired_delimiter_definition] = STATE(144),
    [sym_environment_definition] = STATE(144),
    [sym_glossary_entry_definition] = STATE(144),
    [sym_glossary_entry_reference] = STATE(144),
    [sym_acronym_definition] = STATE(144),
    [sym_acronym_reference] = STATE(144),
    [sym_theorem_definition] = STATE(144),
    [sym_color_definition] = STATE(144),
    [sym_color_set_definition] = STATE(144),
    [sym_color_reference] = STATE(144),
    [sym_tikz_library_import] = STATE(144),
    [sym_text_mode] = STATE(144),
    [sym_hyperlink] = STATE(144),
    [aux_sym_source_file_repeat1] = STATE(144),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1618),
    [anon_sym_RBRACK] = ACTIONS(1618),
    [anon_sym_COMMA] = ACTIONS(1618),
    [anon_sym_EQ] = ACTIONS(1618),
    [anon_sym_LPAREN] = ACTIONS(1618),
    [anon_sym_RPAREN] = ACTIONS(1618),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1620),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1622),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [124] = {
    [sym_block_comment] = STATE(101),
    [sym__root_content] = STATE(101),
    [sym__flat_content] = STATE(101),
    [sym__text_with_env_content] = STATE(101),
    [sym__text_content] = STATE(101),
    [sym__section] = STATE(101),
    [sym__paragraph] = STATE(101),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(101),
    [sym_text] = STATE(101),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(101),
    [sym_inline_formula] = STATE(101),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(101),
    [sym_comment_environment] = STATE(101),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(101),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(101),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(101),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(101),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(101),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(101),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(101),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(101),
    [sym_generic_command] = STATE(101),
    [sym_title_declaration] = STATE(101),
    [sym_author_declaration] = STATE(101),
    [sym_package_include] = STATE(101),
    [sym_class_include] = STATE(101),
    [sym_latex_include] = STATE(101),
    [sym_biblatex_include] = STATE(101),
    [sym_bibstyle_include] = STATE(101),
    [sym_bibtex_include] = STATE(101),
    [sym_graphics_include] = STATE(101),
    [sym_svg_include] = STATE(101),
    [sym_inkscape_include] = STATE(101),
    [sym_verbatim_include] = STATE(101),
    [sym_import_include] = STATE(101),
    [sym_caption] = STATE(101),
    [sym_citation] = STATE(101),
    [sym_label_definition] = STATE(101),
    [sym_label_reference] = STATE(101),
    [sym_label_reference_range] = STATE(101),
    [sym_label_number] = STATE(101),
    [sym_new_command_definition] = STATE(101),
    [sym_old_command_definition] = STATE(101),
    [sym_let_command_definition] = STATE(101),
    [sym_math_delimiter] = STATE(101),
    [sym_paired_delimiter_definition] = STATE(101),
    [sym_environment_definition] = STATE(101),
    [sym_glossary_entry_definition] = STATE(101),
    [sym_glossary_entry_reference] = STATE(101),
    [sym_acronym_definition] = STATE(101),
    [sym_acronym_reference] = STATE(101),
    [sym_theorem_definition] = STATE(101),
    [sym_color_definition] = STATE(101),
    [sym_color_set_definition] = STATE(101),
    [sym_color_reference] = STATE(101),
    [sym_tikz_library_import] = STATE(101),
    [sym_text_mode] = STATE(101),
    [sym_hyperlink] = STATE(101),
    [aux_sym_source_file_repeat1] = STATE(101),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(153),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [125] = {
    [sym_block_comment] = STATE(125),
    [sym__root_content] = STATE(125),
    [sym__flat_content] = STATE(125),
    [sym__text_with_env_content] = STATE(125),
    [sym__text_content] = STATE(125),
    [sym__section] = STATE(125),
    [sym__paragraph] = STATE(125),
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(843),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(844),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(845),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(846),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(847),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(125),
    [sym_text] = STATE(125),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(125),
    [sym_inline_formula] = STATE(125),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(125),
    [sym_comment_environment] = STATE(125),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(125),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(125),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(125),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(125),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(125),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(125),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(125),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(125),
    [sym_generic_command] = STATE(125),
    [sym_title_declaration] = STATE(125),
    [sym_author_declaration] = STATE(125),
    [sym_package_include] = STATE(125),
    [sym_class_include] = STATE(125),
    [sym_latex_include] = STATE(125),
    [sym_biblatex_include] = STATE(125),
    [sym_bibstyle_include] = STATE(125),
    [sym_bibtex_include] = STATE(125),
    [sym_graphics_include] = STATE(125),
    [sym_svg_include] = STATE(125),
    [sym_inkscape_include] = STATE(125),
    [sym_verbatim_include] = STATE(125),
    [sym_import_include] = STATE(125),
    [sym_caption] = STATE(125),
    [sym_citation] = STATE(125),
    [sym_label_definition] = STATE(125),
    [sym_label_reference] = STATE(125),
    [sym_label_reference_range] = STATE(125),
    [sym_label_number] = STATE(125),
    [sym_new_command_definition] = STATE(125),
    [sym_old_command_definition] = STATE(125),
    [sym_let_command_definition] = STATE(125),
    [sym_math_delimiter] = STATE(125),
    [sym_paired_delimiter_definition] = STATE(125),
    [sym_environment_definition] = STATE(125),
    [sym_glossary_entry_definition] = STATE(125),
    [sym_glossary_entry_reference] = STATE(125),
    [sym_acronym_definition] = STATE(125),
    [sym_acronym_reference] = STATE(125),
    [sym_theorem_definition] = STATE(125),
    [sym_color_definition] = STATE(125),
    [sym_color_set_definition] = STATE(125),
    [sym_color_reference] = STATE(125),
    [sym_tikz_library_import] = STATE(125),
    [sym_text_mode] = STATE(125),
    [sym_hyperlink] = STATE(125),
    [aux_sym_source_file_repeat1] = STATE(125),
    [aux_sym__section_repeat1] = STATE(843),
    [aux_sym__section_repeat2] = STATE(844),
    [aux_sym__section_repeat3] = STATE(845),
    [aux_sym__section_repeat4] = STATE(846),
    [aux_sym__section_repeat5] = STATE(847),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(1624),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1630),
    [anon_sym_RBRACK] = ACTIONS(1630),
    [anon_sym_COMMA] = ACTIONS(1630),
    [anon_sym_EQ] = ACTIONS(1630),
    [anon_sym_LPAREN] = ACTIONS(1630),
    [anon_sym_RPAREN] = ACTIONS(1630),
    [anon_sym_BSLASHpart] = ACTIONS(1633),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(1636),
    [anon_sym_BSLASHaddpart] = ACTIONS(1633),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(1636),
    [anon_sym_BSLASHchapter] = ACTIONS(1639),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(1642),
    [anon_sym_BSLASHaddchap] = ACTIONS(1639),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(1642),
    [anon_sym_BSLASHsection] = ACTIONS(1645),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(1648),
    [anon_sym_BSLASHaddsec] = ACTIONS(1645),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(1648),
    [anon_sym_BSLASHsubsection] = ACTIONS(1651),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(1654),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(1657),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(1660),
    [anon_sym_BSLASHparagraph] = ACTIONS(1663),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(1666),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(1669),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(1672),
    [anon_sym_BSLASHitem] = ACTIONS(1675),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(1678),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1684),
    [sym_placeholder] = ACTIONS(1687),
    [anon_sym_PLUS] = ACTIONS(1690),
    [anon_sym_DASH] = ACTIONS(1690),
    [anon_sym_STAR] = ACTIONS(1690),
    [anon_sym_SLASH] = ACTIONS(1690),
    [anon_sym_LT] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1693),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_PIPE] = ACTIONS(1693),
    [anon_sym_COLON] = ACTIONS(1693),
    [anon_sym_SQUOTE] = ACTIONS(1693),
    [anon_sym__] = ACTIONS(1696),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1702),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1702),
    [anon_sym_DOLLAR] = ACTIONS(1705),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1708),
    [anon_sym_BSLASHbegin] = ACTIONS(434),
    [anon_sym_BSLASHend] = ACTIONS(518),
    [anon_sym_BSLASHtitle] = ACTIONS(1711),
    [anon_sym_BSLASHauthor] = ACTIONS(1714),
    [anon_sym_BSLASHusepackage] = ACTIONS(1717),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1717),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1720),
    [anon_sym_BSLASHinclude] = ACTIONS(1723),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1723),
    [anon_sym_BSLASHinput] = ACTIONS(1723),
    [anon_sym_BSLASHsubfile] = ACTIONS(1723),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1726),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1729),
    [anon_sym_BSLASHbibliography] = ACTIONS(1732),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1735),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1738),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1741),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1744),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1744),
    [anon_sym_BSLASHimport] = ACTIONS(1747),
    [anon_sym_BSLASHsubimport] = ACTIONS(1747),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1747),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1747),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1747),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1747),
    [anon_sym_BSLASHcaption] = ACTIONS(1750),
    [anon_sym_BSLASHcite] = ACTIONS(1753),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHCite] = ACTIONS(1753),
    [anon_sym_BSLASHnocite] = ACTIONS(1753),
    [anon_sym_BSLASHcitet] = ACTIONS(1753),
    [anon_sym_BSLASHcitep] = ACTIONS(1753),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHciteA] = ACTIONS(1753),
    [anon_sym_BSLASHciteR] = ACTIONS(1753),
    [anon_sym_BSLASHciteS] = ACTIONS(1753),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1753),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1753),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1753),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1753),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHciteyear] = ACTIONS(1753),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHcitedate] = ACTIONS(1753),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHciteurl] = ACTIONS(1753),
    [anon_sym_BSLASHfullcite] = ACTIONS(1753),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1753),
    [anon_sym_BSLASHcitealt] = ACTIONS(1753),
    [anon_sym_BSLASHcitealp] = ACTIONS(1753),
    [anon_sym_BSLASHcitetext] = ACTIONS(1753),
    [anon_sym_BSLASHparencite] = ACTIONS(1753),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHParencite] = ACTIONS(1753),
    [anon_sym_BSLASHfootcite] = ACTIONS(1753),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1753),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1753),
    [anon_sym_BSLASHtextcite] = ACTIONS(1753),
    [anon_sym_BSLASHTextcite] = ACTIONS(1753),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1753),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1753),
    [anon_sym_BSLASHsupercite] = ACTIONS(1753),
    [anon_sym_BSLASHautocite] = ACTIONS(1753),
    [anon_sym_BSLASHAutocite] = ACTIONS(1753),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1756),
    [anon_sym_BSLASHvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHVolcite] = ACTIONS(1753),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHavolcite] = ACTIONS(1753),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1753),
    [anon_sym_BSLASHnotecite] = ACTIONS(1753),
    [anon_sym_BSLASHNotecite] = ACTIONS(1753),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1753),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1753),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1753),
    [anon_sym_BSLASHlabel] = ACTIONS(1759),
    [anon_sym_BSLASHref] = ACTIONS(1762),
    [anon_sym_BSLASHeqref] = ACTIONS(1762),
    [anon_sym_BSLASHvref] = ACTIONS(1762),
    [anon_sym_BSLASHVref] = ACTIONS(1762),
    [anon_sym_BSLASHautoref] = ACTIONS(1762),
    [anon_sym_BSLASHpageref] = ACTIONS(1762),
    [anon_sym_BSLASHcref] = ACTIONS(1762),
    [anon_sym_BSLASHCref] = ACTIONS(1762),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1765),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1765),
    [anon_sym_BSLASHnamecref] = ACTIONS(1762),
    [anon_sym_BSLASHnameCref] = ACTIONS(1762),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1762),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1762),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1762),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1762),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1762),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1762),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1768),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1771),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1768),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1771),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1774),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1777),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1780),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1777),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1780),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1777),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1780),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1777),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1780),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1777),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1777),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1777),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1777),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1777),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1777),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1777),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1777),
    [anon_sym_BSLASHdef] = ACTIONS(1783),
    [anon_sym_BSLASHlet] = ACTIONS(1786),
    [anon_sym_BSLASHleft] = ACTIONS(1789),
    [anon_sym_BSLASHbigl] = ACTIONS(1789),
    [anon_sym_BSLASHBigl] = ACTIONS(1789),
    [anon_sym_BSLASHbiggl] = ACTIONS(1789),
    [anon_sym_BSLASHBiggl] = ACTIONS(1789),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1792),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1792),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1795),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1795),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1795),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1795),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1795),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1795),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1798),
    [anon_sym_BSLASHgls] = ACTIONS(1801),
    [anon_sym_BSLASHGls] = ACTIONS(1801),
    [anon_sym_BSLASHGLS] = ACTIONS(1801),
    [anon_sym_BSLASHglspl] = ACTIONS(1801),
    [anon_sym_BSLASHGlspl] = ACTIONS(1801),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1801),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1801),
    [anon_sym_BSLASHglslink] = ACTIONS(1801),
    [anon_sym_BSLASHglstext] = ACTIONS(1801),
    [anon_sym_BSLASHGlstext] = ACTIONS(1801),
    [anon_sym_BSLASHGLStext] = ACTIONS(1801),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1801),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1801),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1801),
    [anon_sym_BSLASHglsplural] = ACTIONS(1801),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1801),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1801),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1801),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1801),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1801),
    [anon_sym_BSLASHglsname] = ACTIONS(1801),
    [anon_sym_BSLASHGlsname] = ACTIONS(1801),
    [anon_sym_BSLASHGLSname] = ACTIONS(1801),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1801),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1801),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1801),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1801),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1801),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1801),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1801),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1801),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1801),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1801),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1801),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1801),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1801),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1801),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1801),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1801),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1801),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1801),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1801),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1801),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1801),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1801),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1801),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1804),
    [anon_sym_BSLASHacrshort] = ACTIONS(1807),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1807),
    [anon_sym_BSLASHACRshort] = ACTIONS(1807),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1807),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1807),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1807),
    [anon_sym_BSLASHacrlong] = ACTIONS(1807),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1807),
    [anon_sym_BSLASHACRlong] = ACTIONS(1807),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1807),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1807),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1807),
    [anon_sym_BSLASHacrfull] = ACTIONS(1807),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1807),
    [anon_sym_BSLASHACRfull] = ACTIONS(1807),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1807),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1807),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1807),
    [anon_sym_BSLASHacs] = ACTIONS(1807),
    [anon_sym_BSLASHAcs] = ACTIONS(1807),
    [anon_sym_BSLASHacsp] = ACTIONS(1807),
    [anon_sym_BSLASHAcsp] = ACTIONS(1807),
    [anon_sym_BSLASHacl] = ACTIONS(1807),
    [anon_sym_BSLASHAcl] = ACTIONS(1807),
    [anon_sym_BSLASHaclp] = ACTIONS(1807),
    [anon_sym_BSLASHAclp] = ACTIONS(1807),
    [anon_sym_BSLASHacf] = ACTIONS(1807),
    [anon_sym_BSLASHAcf] = ACTIONS(1807),
    [anon_sym_BSLASHacfp] = ACTIONS(1807),
    [anon_sym_BSLASHAcfp] = ACTIONS(1807),
    [anon_sym_BSLASHac] = ACTIONS(1807),
    [anon_sym_BSLASHAc] = ACTIONS(1807),
    [anon_sym_BSLASHacp] = ACTIONS(1807),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1807),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1807),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1807),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1807),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1807),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1807),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1807),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1807),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1807),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1807),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1810),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1813),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1810),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1813),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1816),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1819),
    [anon_sym_BSLASHcolor] = ACTIONS(1822),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1822),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1822),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1822),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1825),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1825),
    [anon_sym_BSLASHtext] = ACTIONS(1828),
    [anon_sym_BSLASHintertext] = ACTIONS(1828),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1828),
    [anon_sym_BSLASHurl] = ACTIONS(1831),
    [anon_sym_BSLASHhref] = ACTIONS(1831),
  },
  [126] = {
    [sym_block_comment] = STATE(107),
    [sym__root_content] = STATE(107),
    [sym__flat_content] = STATE(107),
    [sym__text_with_env_content] = STATE(107),
    [sym__text_content] = STATE(107),
    [sym__section] = STATE(107),
    [sym__paragraph] = STATE(107),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(107),
    [sym_text] = STATE(107),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(107),
    [sym_inline_formula] = STATE(107),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(107),
    [sym_comment_environment] = STATE(107),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(107),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(107),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(107),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(107),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(107),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(107),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(107),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(107),
    [sym_generic_command] = STATE(107),
    [sym_title_declaration] = STATE(107),
    [sym_author_declaration] = STATE(107),
    [sym_package_include] = STATE(107),
    [sym_class_include] = STATE(107),
    [sym_latex_include] = STATE(107),
    [sym_biblatex_include] = STATE(107),
    [sym_bibstyle_include] = STATE(107),
    [sym_bibtex_include] = STATE(107),
    [sym_graphics_include] = STATE(107),
    [sym_svg_include] = STATE(107),
    [sym_inkscape_include] = STATE(107),
    [sym_verbatim_include] = STATE(107),
    [sym_import_include] = STATE(107),
    [sym_caption] = STATE(107),
    [sym_citation] = STATE(107),
    [sym_label_definition] = STATE(107),
    [sym_label_reference] = STATE(107),
    [sym_label_reference_range] = STATE(107),
    [sym_label_number] = STATE(107),
    [sym_new_command_definition] = STATE(107),
    [sym_old_command_definition] = STATE(107),
    [sym_let_command_definition] = STATE(107),
    [sym_math_delimiter] = STATE(107),
    [sym_paired_delimiter_definition] = STATE(107),
    [sym_environment_definition] = STATE(107),
    [sym_glossary_entry_definition] = STATE(107),
    [sym_glossary_entry_reference] = STATE(107),
    [sym_acronym_definition] = STATE(107),
    [sym_acronym_reference] = STATE(107),
    [sym_theorem_definition] = STATE(107),
    [sym_color_definition] = STATE(107),
    [sym_color_set_definition] = STATE(107),
    [sym_color_reference] = STATE(107),
    [sym_tikz_library_import] = STATE(107),
    [sym_text_mode] = STATE(107),
    [sym_hyperlink] = STATE(107),
    [aux_sym_source_file_repeat1] = STATE(107),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1834),
    [anon_sym_RBRACK] = ACTIONS(1834),
    [anon_sym_COMMA] = ACTIONS(1834),
    [anon_sym_EQ] = ACTIONS(1834),
    [anon_sym_LPAREN] = ACTIONS(1834),
    [anon_sym_RPAREN] = ACTIONS(1834),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1836),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1838),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [127] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [128] = {
    [sym_block_comment] = STATE(104),
    [sym__root_content] = STATE(104),
    [sym__flat_content] = STATE(104),
    [sym__text_with_env_content] = STATE(104),
    [sym__text_content] = STATE(104),
    [sym__section] = STATE(104),
    [sym__paragraph] = STATE(104),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(104),
    [sym_text] = STATE(104),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(104),
    [sym_inline_formula] = STATE(104),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(104),
    [sym_comment_environment] = STATE(104),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(104),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(104),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(104),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(104),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(104),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(104),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(104),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(104),
    [sym_generic_command] = STATE(104),
    [sym_title_declaration] = STATE(104),
    [sym_author_declaration] = STATE(104),
    [sym_package_include] = STATE(104),
    [sym_class_include] = STATE(104),
    [sym_latex_include] = STATE(104),
    [sym_biblatex_include] = STATE(104),
    [sym_bibstyle_include] = STATE(104),
    [sym_bibtex_include] = STATE(104),
    [sym_graphics_include] = STATE(104),
    [sym_svg_include] = STATE(104),
    [sym_inkscape_include] = STATE(104),
    [sym_verbatim_include] = STATE(104),
    [sym_import_include] = STATE(104),
    [sym_caption] = STATE(104),
    [sym_citation] = STATE(104),
    [sym_label_definition] = STATE(104),
    [sym_label_reference] = STATE(104),
    [sym_label_reference_range] = STATE(104),
    [sym_label_number] = STATE(104),
    [sym_new_command_definition] = STATE(104),
    [sym_old_command_definition] = STATE(104),
    [sym_let_command_definition] = STATE(104),
    [sym_math_delimiter] = STATE(104),
    [sym_paired_delimiter_definition] = STATE(104),
    [sym_environment_definition] = STATE(104),
    [sym_glossary_entry_definition] = STATE(104),
    [sym_glossary_entry_reference] = STATE(104),
    [sym_acronym_definition] = STATE(104),
    [sym_acronym_reference] = STATE(104),
    [sym_theorem_definition] = STATE(104),
    [sym_color_definition] = STATE(104),
    [sym_color_set_definition] = STATE(104),
    [sym_color_reference] = STATE(104),
    [sym_tikz_library_import] = STATE(104),
    [sym_text_mode] = STATE(104),
    [sym_hyperlink] = STATE(104),
    [aux_sym_source_file_repeat1] = STATE(104),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1840),
    [anon_sym_RBRACK] = ACTIONS(1840),
    [anon_sym_COMMA] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(1840),
    [anon_sym_LPAREN] = ACTIONS(1840),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1842),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1844),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [129] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(1846),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [130] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(1848),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(1850),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [131] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1852),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(1854),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [132] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1856),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1862),
    [anon_sym_RBRACK] = ACTIONS(1862),
    [anon_sym_COMMA] = ACTIONS(1862),
    [anon_sym_EQ] = ACTIONS(1862),
    [anon_sym_LPAREN] = ACTIONS(1862),
    [anon_sym_RPAREN] = ACTIONS(1862),
    [anon_sym_BSLASHpart] = ACTIONS(1865),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(1868),
    [anon_sym_BSLASHaddpart] = ACTIONS(1865),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(1868),
    [anon_sym_BSLASHchapter] = ACTIONS(1871),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(1874),
    [anon_sym_BSLASHaddchap] = ACTIONS(1871),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(1874),
    [anon_sym_BSLASHsection] = ACTIONS(1877),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(1880),
    [anon_sym_BSLASHaddsec] = ACTIONS(1877),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(1880),
    [anon_sym_BSLASHsubsection] = ACTIONS(1883),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(1886),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(1889),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(1892),
    [anon_sym_BSLASHparagraph] = ACTIONS(1895),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(1898),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(1901),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(1904),
    [anon_sym_BSLASHitem] = ACTIONS(1907),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(1910),
    [anon_sym_LBRACE] = ACTIONS(1913),
    [sym_word] = ACTIONS(1916),
    [sym_placeholder] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1922),
    [anon_sym_DASH] = ACTIONS(1922),
    [anon_sym_STAR] = ACTIONS(1922),
    [anon_sym_SLASH] = ACTIONS(1922),
    [anon_sym_LT] = ACTIONS(1925),
    [anon_sym_GT] = ACTIONS(1925),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_PIPE] = ACTIONS(1925),
    [anon_sym_COLON] = ACTIONS(1925),
    [anon_sym_SQUOTE] = ACTIONS(1925),
    [anon_sym__] = ACTIONS(1928),
    [anon_sym_CARET] = ACTIONS(1931),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1934),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1934),
    [anon_sym_DOLLAR] = ACTIONS(1937),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1940),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(812),
    [anon_sym_BSLASHbegin] = ACTIONS(434),
    [anon_sym_BSLASHtitle] = ACTIONS(1943),
    [anon_sym_BSLASHauthor] = ACTIONS(1946),
    [anon_sym_BSLASHusepackage] = ACTIONS(1949),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1949),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1952),
    [anon_sym_BSLASHinclude] = ACTIONS(1955),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1955),
    [anon_sym_BSLASHinput] = ACTIONS(1955),
    [anon_sym_BSLASHsubfile] = ACTIONS(1955),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1958),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1961),
    [anon_sym_BSLASHbibliography] = ACTIONS(1964),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1967),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1970),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1973),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1976),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1976),
    [anon_sym_BSLASHimport] = ACTIONS(1979),
    [anon_sym_BSLASHsubimport] = ACTIONS(1979),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1979),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1979),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1979),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1979),
    [anon_sym_BSLASHcaption] = ACTIONS(1982),
    [anon_sym_BSLASHcite] = ACTIONS(1985),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHCite] = ACTIONS(1985),
    [anon_sym_BSLASHnocite] = ACTIONS(1985),
    [anon_sym_BSLASHcitet] = ACTIONS(1985),
    [anon_sym_BSLASHcitep] = ACTIONS(1985),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHciteA] = ACTIONS(1985),
    [anon_sym_BSLASHciteR] = ACTIONS(1985),
    [anon_sym_BSLASHciteS] = ACTIONS(1985),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1985),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1985),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1985),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1985),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHciteyear] = ACTIONS(1985),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHcitedate] = ACTIONS(1985),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHciteurl] = ACTIONS(1985),
    [anon_sym_BSLASHfullcite] = ACTIONS(1985),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1985),
    [anon_sym_BSLASHcitealt] = ACTIONS(1985),
    [anon_sym_BSLASHcitealp] = ACTIONS(1985),
    [anon_sym_BSLASHcitetext] = ACTIONS(1985),
    [anon_sym_BSLASHparencite] = ACTIONS(1985),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHParencite] = ACTIONS(1985),
    [anon_sym_BSLASHfootcite] = ACTIONS(1985),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1985),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1985),
    [anon_sym_BSLASHtextcite] = ACTIONS(1985),
    [anon_sym_BSLASHTextcite] = ACTIONS(1985),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1985),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1985),
    [anon_sym_BSLASHsupercite] = ACTIONS(1985),
    [anon_sym_BSLASHautocite] = ACTIONS(1985),
    [anon_sym_BSLASHAutocite] = ACTIONS(1985),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1988),
    [anon_sym_BSLASHvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHVolcite] = ACTIONS(1985),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHavolcite] = ACTIONS(1985),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1985),
    [anon_sym_BSLASHnotecite] = ACTIONS(1985),
    [anon_sym_BSLASHNotecite] = ACTIONS(1985),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1985),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1985),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1985),
    [anon_sym_BSLASHlabel] = ACTIONS(1991),
    [anon_sym_BSLASHref] = ACTIONS(1994),
    [anon_sym_BSLASHeqref] = ACTIONS(1994),
    [anon_sym_BSLASHvref] = ACTIONS(1994),
    [anon_sym_BSLASHVref] = ACTIONS(1994),
    [anon_sym_BSLASHautoref] = ACTIONS(1994),
    [anon_sym_BSLASHpageref] = ACTIONS(1994),
    [anon_sym_BSLASHcref] = ACTIONS(1994),
    [anon_sym_BSLASHCref] = ACTIONS(1994),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1997),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1997),
    [anon_sym_BSLASHnamecref] = ACTIONS(1994),
    [anon_sym_BSLASHnameCref] = ACTIONS(1994),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1994),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1994),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1994),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1994),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1994),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1994),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2000),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2003),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2000),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2003),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2006),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2009),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2012),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2009),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2012),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2009),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2012),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2009),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2012),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2009),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2009),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2009),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2009),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2009),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2009),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2009),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2009),
    [anon_sym_BSLASHdef] = ACTIONS(2015),
    [anon_sym_BSLASHlet] = ACTIONS(2018),
    [anon_sym_BSLASHleft] = ACTIONS(2021),
    [anon_sym_BSLASHbigl] = ACTIONS(2021),
    [anon_sym_BSLASHBigl] = ACTIONS(2021),
    [anon_sym_BSLASHbiggl] = ACTIONS(2021),
    [anon_sym_BSLASHBiggl] = ACTIONS(2021),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2024),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2024),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2027),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2027),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2027),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2027),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2027),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2027),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2030),
    [anon_sym_BSLASHgls] = ACTIONS(2033),
    [anon_sym_BSLASHGls] = ACTIONS(2033),
    [anon_sym_BSLASHGLS] = ACTIONS(2033),
    [anon_sym_BSLASHglspl] = ACTIONS(2033),
    [anon_sym_BSLASHGlspl] = ACTIONS(2033),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2033),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2033),
    [anon_sym_BSLASHglslink] = ACTIONS(2033),
    [anon_sym_BSLASHglstext] = ACTIONS(2033),
    [anon_sym_BSLASHGlstext] = ACTIONS(2033),
    [anon_sym_BSLASHGLStext] = ACTIONS(2033),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2033),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2033),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2033),
    [anon_sym_BSLASHglsplural] = ACTIONS(2033),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2033),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2033),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2033),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2033),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2033),
    [anon_sym_BSLASHglsname] = ACTIONS(2033),
    [anon_sym_BSLASHGlsname] = ACTIONS(2033),
    [anon_sym_BSLASHGLSname] = ACTIONS(2033),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2033),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2033),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2033),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2033),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2033),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2033),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2033),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2033),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2033),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2033),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2033),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2033),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2033),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2033),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2033),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2033),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2033),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2033),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2033),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2033),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2033),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2033),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2033),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2036),
    [anon_sym_BSLASHacrshort] = ACTIONS(2039),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2039),
    [anon_sym_BSLASHACRshort] = ACTIONS(2039),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2039),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2039),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2039),
    [anon_sym_BSLASHacrlong] = ACTIONS(2039),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2039),
    [anon_sym_BSLASHACRlong] = ACTIONS(2039),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2039),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2039),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2039),
    [anon_sym_BSLASHacrfull] = ACTIONS(2039),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2039),
    [anon_sym_BSLASHACRfull] = ACTIONS(2039),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2039),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2039),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2039),
    [anon_sym_BSLASHacs] = ACTIONS(2039),
    [anon_sym_BSLASHAcs] = ACTIONS(2039),
    [anon_sym_BSLASHacsp] = ACTIONS(2039),
    [anon_sym_BSLASHAcsp] = ACTIONS(2039),
    [anon_sym_BSLASHacl] = ACTIONS(2039),
    [anon_sym_BSLASHAcl] = ACTIONS(2039),
    [anon_sym_BSLASHaclp] = ACTIONS(2039),
    [anon_sym_BSLASHAclp] = ACTIONS(2039),
    [anon_sym_BSLASHacf] = ACTIONS(2039),
    [anon_sym_BSLASHAcf] = ACTIONS(2039),
    [anon_sym_BSLASHacfp] = ACTIONS(2039),
    [anon_sym_BSLASHAcfp] = ACTIONS(2039),
    [anon_sym_BSLASHac] = ACTIONS(2039),
    [anon_sym_BSLASHAc] = ACTIONS(2039),
    [anon_sym_BSLASHacp] = ACTIONS(2039),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2039),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2039),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2039),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2039),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2039),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2039),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2039),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2039),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2039),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2039),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2042),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2045),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2042),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2045),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2048),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2051),
    [anon_sym_BSLASHcolor] = ACTIONS(2054),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2054),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2054),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2054),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2057),
    [anon_sym_BSLASHtext] = ACTIONS(2060),
    [anon_sym_BSLASHintertext] = ACTIONS(2060),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2060),
    [anon_sym_BSLASHurl] = ACTIONS(2063),
    [anon_sym_BSLASHhref] = ACTIONS(2063),
  },
  [133] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2066),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [134] = {
    [sym_block_comment] = STATE(99),
    [sym__root_content] = STATE(99),
    [sym__flat_content] = STATE(99),
    [sym__text_with_env_content] = STATE(99),
    [sym__text_content] = STATE(99),
    [sym__section] = STATE(99),
    [sym__paragraph] = STATE(99),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(99),
    [sym_text] = STATE(99),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(99),
    [sym_inline_formula] = STATE(99),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(99),
    [sym_comment_environment] = STATE(99),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(99),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(99),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(99),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(99),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(99),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(99),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(99),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(99),
    [sym_generic_command] = STATE(99),
    [sym_title_declaration] = STATE(99),
    [sym_author_declaration] = STATE(99),
    [sym_package_include] = STATE(99),
    [sym_class_include] = STATE(99),
    [sym_latex_include] = STATE(99),
    [sym_biblatex_include] = STATE(99),
    [sym_bibstyle_include] = STATE(99),
    [sym_bibtex_include] = STATE(99),
    [sym_graphics_include] = STATE(99),
    [sym_svg_include] = STATE(99),
    [sym_inkscape_include] = STATE(99),
    [sym_verbatim_include] = STATE(99),
    [sym_import_include] = STATE(99),
    [sym_caption] = STATE(99),
    [sym_citation] = STATE(99),
    [sym_label_definition] = STATE(99),
    [sym_label_reference] = STATE(99),
    [sym_label_reference_range] = STATE(99),
    [sym_label_number] = STATE(99),
    [sym_new_command_definition] = STATE(99),
    [sym_old_command_definition] = STATE(99),
    [sym_let_command_definition] = STATE(99),
    [sym_math_delimiter] = STATE(99),
    [sym_paired_delimiter_definition] = STATE(99),
    [sym_environment_definition] = STATE(99),
    [sym_glossary_entry_definition] = STATE(99),
    [sym_glossary_entry_reference] = STATE(99),
    [sym_acronym_definition] = STATE(99),
    [sym_acronym_reference] = STATE(99),
    [sym_theorem_definition] = STATE(99),
    [sym_color_definition] = STATE(99),
    [sym_color_set_definition] = STATE(99),
    [sym_color_reference] = STATE(99),
    [sym_tikz_library_import] = STATE(99),
    [sym_text_mode] = STATE(99),
    [sym_hyperlink] = STATE(99),
    [aux_sym_source_file_repeat1] = STATE(99),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_RBRACK] = ACTIONS(2068),
    [anon_sym_COMMA] = ACTIONS(2068),
    [anon_sym_EQ] = ACTIONS(2068),
    [anon_sym_LPAREN] = ACTIONS(2068),
    [anon_sym_RPAREN] = ACTIONS(2068),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2070),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [135] = {
    [sym_block_comment] = STATE(130),
    [sym__root_content] = STATE(130),
    [sym__flat_content] = STATE(130),
    [sym__text_with_env_content] = STATE(130),
    [sym__text_content] = STATE(130),
    [sym__section] = STATE(130),
    [sym__paragraph] = STATE(130),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(130),
    [sym_text] = STATE(130),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(130),
    [sym_inline_formula] = STATE(130),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(130),
    [sym_comment_environment] = STATE(130),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(130),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(130),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(130),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(130),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(130),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(130),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(130),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(130),
    [sym_generic_command] = STATE(130),
    [sym_title_declaration] = STATE(130),
    [sym_author_declaration] = STATE(130),
    [sym_package_include] = STATE(130),
    [sym_class_include] = STATE(130),
    [sym_latex_include] = STATE(130),
    [sym_biblatex_include] = STATE(130),
    [sym_bibstyle_include] = STATE(130),
    [sym_bibtex_include] = STATE(130),
    [sym_graphics_include] = STATE(130),
    [sym_svg_include] = STATE(130),
    [sym_inkscape_include] = STATE(130),
    [sym_verbatim_include] = STATE(130),
    [sym_import_include] = STATE(130),
    [sym_caption] = STATE(130),
    [sym_citation] = STATE(130),
    [sym_label_definition] = STATE(130),
    [sym_label_reference] = STATE(130),
    [sym_label_reference_range] = STATE(130),
    [sym_label_number] = STATE(130),
    [sym_new_command_definition] = STATE(130),
    [sym_old_command_definition] = STATE(130),
    [sym_let_command_definition] = STATE(130),
    [sym_math_delimiter] = STATE(130),
    [sym_paired_delimiter_definition] = STATE(130),
    [sym_environment_definition] = STATE(130),
    [sym_glossary_entry_definition] = STATE(130),
    [sym_glossary_entry_reference] = STATE(130),
    [sym_acronym_definition] = STATE(130),
    [sym_acronym_reference] = STATE(130),
    [sym_theorem_definition] = STATE(130),
    [sym_color_definition] = STATE(130),
    [sym_color_set_definition] = STATE(130),
    [sym_color_reference] = STATE(130),
    [sym_tikz_library_import] = STATE(130),
    [sym_text_mode] = STATE(130),
    [sym_hyperlink] = STATE(130),
    [aux_sym_source_file_repeat1] = STATE(130),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2072),
    [anon_sym_RBRACK] = ACTIONS(2072),
    [anon_sym_COMMA] = ACTIONS(2072),
    [anon_sym_EQ] = ACTIONS(2072),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_RPAREN] = ACTIONS(2072),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2074),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2076),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [136] = {
    [sym_block_comment] = STATE(131),
    [sym__root_content] = STATE(131),
    [sym__flat_content] = STATE(131),
    [sym__text_with_env_content] = STATE(131),
    [sym__text_content] = STATE(131),
    [sym__section] = STATE(131),
    [sym__paragraph] = STATE(131),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(131),
    [sym_text] = STATE(131),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(131),
    [sym_inline_formula] = STATE(131),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(131),
    [sym_comment_environment] = STATE(131),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(131),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(131),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(131),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(131),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(131),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(131),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(131),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(131),
    [sym_generic_command] = STATE(131),
    [sym_title_declaration] = STATE(131),
    [sym_author_declaration] = STATE(131),
    [sym_package_include] = STATE(131),
    [sym_class_include] = STATE(131),
    [sym_latex_include] = STATE(131),
    [sym_biblatex_include] = STATE(131),
    [sym_bibstyle_include] = STATE(131),
    [sym_bibtex_include] = STATE(131),
    [sym_graphics_include] = STATE(131),
    [sym_svg_include] = STATE(131),
    [sym_inkscape_include] = STATE(131),
    [sym_verbatim_include] = STATE(131),
    [sym_import_include] = STATE(131),
    [sym_caption] = STATE(131),
    [sym_citation] = STATE(131),
    [sym_label_definition] = STATE(131),
    [sym_label_reference] = STATE(131),
    [sym_label_reference_range] = STATE(131),
    [sym_label_number] = STATE(131),
    [sym_new_command_definition] = STATE(131),
    [sym_old_command_definition] = STATE(131),
    [sym_let_command_definition] = STATE(131),
    [sym_math_delimiter] = STATE(131),
    [sym_paired_delimiter_definition] = STATE(131),
    [sym_environment_definition] = STATE(131),
    [sym_glossary_entry_definition] = STATE(131),
    [sym_glossary_entry_reference] = STATE(131),
    [sym_acronym_definition] = STATE(131),
    [sym_acronym_reference] = STATE(131),
    [sym_theorem_definition] = STATE(131),
    [sym_color_definition] = STATE(131),
    [sym_color_set_definition] = STATE(131),
    [sym_color_reference] = STATE(131),
    [sym_tikz_library_import] = STATE(131),
    [sym_text_mode] = STATE(131),
    [sym_hyperlink] = STATE(131),
    [aux_sym_source_file_repeat1] = STATE(131),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2078),
    [anon_sym_RBRACK] = ACTIONS(2078),
    [anon_sym_COMMA] = ACTIONS(2078),
    [anon_sym_EQ] = ACTIONS(2078),
    [anon_sym_LPAREN] = ACTIONS(2078),
    [anon_sym_RPAREN] = ACTIONS(2078),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2080),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2082),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [137] = {
    [sym_block_comment] = STATE(133),
    [sym__root_content] = STATE(133),
    [sym__flat_content] = STATE(133),
    [sym__text_with_env_content] = STATE(133),
    [sym__text_content] = STATE(133),
    [sym__section] = STATE(133),
    [sym__paragraph] = STATE(133),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(133),
    [sym_text] = STATE(133),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(133),
    [sym_inline_formula] = STATE(133),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(133),
    [sym_comment_environment] = STATE(133),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(133),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(133),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(133),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(133),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(133),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(133),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(133),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(133),
    [sym_generic_command] = STATE(133),
    [sym_title_declaration] = STATE(133),
    [sym_author_declaration] = STATE(133),
    [sym_package_include] = STATE(133),
    [sym_class_include] = STATE(133),
    [sym_latex_include] = STATE(133),
    [sym_biblatex_include] = STATE(133),
    [sym_bibstyle_include] = STATE(133),
    [sym_bibtex_include] = STATE(133),
    [sym_graphics_include] = STATE(133),
    [sym_svg_include] = STATE(133),
    [sym_inkscape_include] = STATE(133),
    [sym_verbatim_include] = STATE(133),
    [sym_import_include] = STATE(133),
    [sym_caption] = STATE(133),
    [sym_citation] = STATE(133),
    [sym_label_definition] = STATE(133),
    [sym_label_reference] = STATE(133),
    [sym_label_reference_range] = STATE(133),
    [sym_label_number] = STATE(133),
    [sym_new_command_definition] = STATE(133),
    [sym_old_command_definition] = STATE(133),
    [sym_let_command_definition] = STATE(133),
    [sym_math_delimiter] = STATE(133),
    [sym_paired_delimiter_definition] = STATE(133),
    [sym_environment_definition] = STATE(133),
    [sym_glossary_entry_definition] = STATE(133),
    [sym_glossary_entry_reference] = STATE(133),
    [sym_acronym_definition] = STATE(133),
    [sym_acronym_reference] = STATE(133),
    [sym_theorem_definition] = STATE(133),
    [sym_color_definition] = STATE(133),
    [sym_color_set_definition] = STATE(133),
    [sym_color_reference] = STATE(133),
    [sym_tikz_library_import] = STATE(133),
    [sym_text_mode] = STATE(133),
    [sym_hyperlink] = STATE(133),
    [aux_sym_source_file_repeat1] = STATE(133),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2084),
    [anon_sym_RBRACK] = ACTIONS(2084),
    [anon_sym_COMMA] = ACTIONS(2084),
    [anon_sym_EQ] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2084),
    [anon_sym_RPAREN] = ACTIONS(2084),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2086),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [138] = {
    [sym_block_comment] = STATE(89),
    [sym__root_content] = STATE(89),
    [sym__flat_content] = STATE(89),
    [sym__text_with_env_content] = STATE(89),
    [sym__text_content] = STATE(89),
    [sym__section] = STATE(89),
    [sym__paragraph] = STATE(89),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(89),
    [sym_text] = STATE(89),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(89),
    [sym_inline_formula] = STATE(89),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(89),
    [sym_comment_environment] = STATE(89),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(89),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(89),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(89),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(89),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(89),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(89),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(89),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(89),
    [sym_generic_command] = STATE(89),
    [sym_title_declaration] = STATE(89),
    [sym_author_declaration] = STATE(89),
    [sym_package_include] = STATE(89),
    [sym_class_include] = STATE(89),
    [sym_latex_include] = STATE(89),
    [sym_biblatex_include] = STATE(89),
    [sym_bibstyle_include] = STATE(89),
    [sym_bibtex_include] = STATE(89),
    [sym_graphics_include] = STATE(89),
    [sym_svg_include] = STATE(89),
    [sym_inkscape_include] = STATE(89),
    [sym_verbatim_include] = STATE(89),
    [sym_import_include] = STATE(89),
    [sym_caption] = STATE(89),
    [sym_citation] = STATE(89),
    [sym_label_definition] = STATE(89),
    [sym_label_reference] = STATE(89),
    [sym_label_reference_range] = STATE(89),
    [sym_label_number] = STATE(89),
    [sym_new_command_definition] = STATE(89),
    [sym_old_command_definition] = STATE(89),
    [sym_let_command_definition] = STATE(89),
    [sym_math_delimiter] = STATE(89),
    [sym_paired_delimiter_definition] = STATE(89),
    [sym_environment_definition] = STATE(89),
    [sym_glossary_entry_definition] = STATE(89),
    [sym_glossary_entry_reference] = STATE(89),
    [sym_acronym_definition] = STATE(89),
    [sym_acronym_reference] = STATE(89),
    [sym_theorem_definition] = STATE(89),
    [sym_color_definition] = STATE(89),
    [sym_color_set_definition] = STATE(89),
    [sym_color_reference] = STATE(89),
    [sym_tikz_library_import] = STATE(89),
    [sym_text_mode] = STATE(89),
    [sym_hyperlink] = STATE(89),
    [aux_sym_source_file_repeat1] = STATE(89),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_RBRACK] = ACTIONS(2088),
    [anon_sym_COMMA] = ACTIONS(2088),
    [anon_sym_EQ] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(2088),
    [anon_sym_RPAREN] = ACTIONS(2088),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2090),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [139] = {
    [sym_block_comment] = STATE(84),
    [sym__root_content] = STATE(84),
    [sym__flat_content] = STATE(84),
    [sym__text_with_env_content] = STATE(84),
    [sym__text_content] = STATE(84),
    [sym__section] = STATE(84),
    [sym__paragraph] = STATE(84),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(84),
    [sym_text] = STATE(84),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(84),
    [sym_inline_formula] = STATE(84),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(84),
    [sym_comment_environment] = STATE(84),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(84),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(84),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(84),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(84),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(84),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(84),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(84),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(84),
    [sym_generic_command] = STATE(84),
    [sym_title_declaration] = STATE(84),
    [sym_author_declaration] = STATE(84),
    [sym_package_include] = STATE(84),
    [sym_class_include] = STATE(84),
    [sym_latex_include] = STATE(84),
    [sym_biblatex_include] = STATE(84),
    [sym_bibstyle_include] = STATE(84),
    [sym_bibtex_include] = STATE(84),
    [sym_graphics_include] = STATE(84),
    [sym_svg_include] = STATE(84),
    [sym_inkscape_include] = STATE(84),
    [sym_verbatim_include] = STATE(84),
    [sym_import_include] = STATE(84),
    [sym_caption] = STATE(84),
    [sym_citation] = STATE(84),
    [sym_label_definition] = STATE(84),
    [sym_label_reference] = STATE(84),
    [sym_label_reference_range] = STATE(84),
    [sym_label_number] = STATE(84),
    [sym_new_command_definition] = STATE(84),
    [sym_old_command_definition] = STATE(84),
    [sym_let_command_definition] = STATE(84),
    [sym_math_delimiter] = STATE(84),
    [sym_paired_delimiter_definition] = STATE(84),
    [sym_environment_definition] = STATE(84),
    [sym_glossary_entry_definition] = STATE(84),
    [sym_glossary_entry_reference] = STATE(84),
    [sym_acronym_definition] = STATE(84),
    [sym_acronym_reference] = STATE(84),
    [sym_theorem_definition] = STATE(84),
    [sym_color_definition] = STATE(84),
    [sym_color_set_definition] = STATE(84),
    [sym_color_reference] = STATE(84),
    [sym_tikz_library_import] = STATE(84),
    [sym_text_mode] = STATE(84),
    [sym_hyperlink] = STATE(84),
    [aux_sym_source_file_repeat1] = STATE(84),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2092),
    [anon_sym_RBRACK] = ACTIONS(2092),
    [anon_sym_COMMA] = ACTIONS(2092),
    [anon_sym_EQ] = ACTIONS(2092),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [anon_sym_RPAREN] = ACTIONS(2092),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2094),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2096),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [140] = {
    [sym_block_comment] = STATE(106),
    [sym__root_content] = STATE(106),
    [sym__flat_content] = STATE(106),
    [sym__text_with_env_content] = STATE(106),
    [sym__text_content] = STATE(106),
    [sym__section] = STATE(106),
    [sym__paragraph] = STATE(106),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(106),
    [sym_text] = STATE(106),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(106),
    [sym_inline_formula] = STATE(106),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(106),
    [sym_comment_environment] = STATE(106),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(106),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(106),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(106),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(106),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(106),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(106),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(106),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(106),
    [sym_generic_command] = STATE(106),
    [sym_title_declaration] = STATE(106),
    [sym_author_declaration] = STATE(106),
    [sym_package_include] = STATE(106),
    [sym_class_include] = STATE(106),
    [sym_latex_include] = STATE(106),
    [sym_biblatex_include] = STATE(106),
    [sym_bibstyle_include] = STATE(106),
    [sym_bibtex_include] = STATE(106),
    [sym_graphics_include] = STATE(106),
    [sym_svg_include] = STATE(106),
    [sym_inkscape_include] = STATE(106),
    [sym_verbatim_include] = STATE(106),
    [sym_import_include] = STATE(106),
    [sym_caption] = STATE(106),
    [sym_citation] = STATE(106),
    [sym_label_definition] = STATE(106),
    [sym_label_reference] = STATE(106),
    [sym_label_reference_range] = STATE(106),
    [sym_label_number] = STATE(106),
    [sym_new_command_definition] = STATE(106),
    [sym_old_command_definition] = STATE(106),
    [sym_let_command_definition] = STATE(106),
    [sym_math_delimiter] = STATE(106),
    [sym_paired_delimiter_definition] = STATE(106),
    [sym_environment_definition] = STATE(106),
    [sym_glossary_entry_definition] = STATE(106),
    [sym_glossary_entry_reference] = STATE(106),
    [sym_acronym_definition] = STATE(106),
    [sym_acronym_reference] = STATE(106),
    [sym_theorem_definition] = STATE(106),
    [sym_color_definition] = STATE(106),
    [sym_color_set_definition] = STATE(106),
    [sym_color_reference] = STATE(106),
    [sym_tikz_library_import] = STATE(106),
    [sym_text_mode] = STATE(106),
    [sym_hyperlink] = STATE(106),
    [aux_sym_source_file_repeat1] = STATE(106),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_RBRACK] = ACTIONS(2098),
    [anon_sym_COMMA] = ACTIONS(2098),
    [anon_sym_EQ] = ACTIONS(2098),
    [anon_sym_LPAREN] = ACTIONS(2098),
    [anon_sym_RPAREN] = ACTIONS(2098),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2100),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2102),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [141] = {
    [sym_block_comment] = STATE(110),
    [sym__root_content] = STATE(110),
    [sym__flat_content] = STATE(110),
    [sym__text_with_env_content] = STATE(110),
    [sym__text_content] = STATE(110),
    [sym__section] = STATE(110),
    [sym__paragraph] = STATE(110),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(110),
    [sym_text] = STATE(110),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(110),
    [sym_inline_formula] = STATE(110),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(110),
    [sym_comment_environment] = STATE(110),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(110),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(110),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(110),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(110),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(110),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(110),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(110),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(110),
    [sym_generic_command] = STATE(110),
    [sym_title_declaration] = STATE(110),
    [sym_author_declaration] = STATE(110),
    [sym_package_include] = STATE(110),
    [sym_class_include] = STATE(110),
    [sym_latex_include] = STATE(110),
    [sym_biblatex_include] = STATE(110),
    [sym_bibstyle_include] = STATE(110),
    [sym_bibtex_include] = STATE(110),
    [sym_graphics_include] = STATE(110),
    [sym_svg_include] = STATE(110),
    [sym_inkscape_include] = STATE(110),
    [sym_verbatim_include] = STATE(110),
    [sym_import_include] = STATE(110),
    [sym_caption] = STATE(110),
    [sym_citation] = STATE(110),
    [sym_label_definition] = STATE(110),
    [sym_label_reference] = STATE(110),
    [sym_label_reference_range] = STATE(110),
    [sym_label_number] = STATE(110),
    [sym_new_command_definition] = STATE(110),
    [sym_old_command_definition] = STATE(110),
    [sym_let_command_definition] = STATE(110),
    [sym_math_delimiter] = STATE(110),
    [sym_paired_delimiter_definition] = STATE(110),
    [sym_environment_definition] = STATE(110),
    [sym_glossary_entry_definition] = STATE(110),
    [sym_glossary_entry_reference] = STATE(110),
    [sym_acronym_definition] = STATE(110),
    [sym_acronym_reference] = STATE(110),
    [sym_theorem_definition] = STATE(110),
    [sym_color_definition] = STATE(110),
    [sym_color_set_definition] = STATE(110),
    [sym_color_reference] = STATE(110),
    [sym_tikz_library_import] = STATE(110),
    [sym_text_mode] = STATE(110),
    [sym_hyperlink] = STATE(110),
    [aux_sym_source_file_repeat1] = STATE(110),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2104),
    [anon_sym_RBRACK] = ACTIONS(2104),
    [anon_sym_COMMA] = ACTIONS(2104),
    [anon_sym_EQ] = ACTIONS(2104),
    [anon_sym_LPAREN] = ACTIONS(2104),
    [anon_sym_RPAREN] = ACTIONS(2104),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2106),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2108),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [142] = {
    [sym_block_comment] = STATE(129),
    [sym__root_content] = STATE(129),
    [sym__flat_content] = STATE(129),
    [sym__text_with_env_content] = STATE(129),
    [sym__text_content] = STATE(129),
    [sym__section] = STATE(129),
    [sym__paragraph] = STATE(129),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(129),
    [sym_text] = STATE(129),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(129),
    [sym_inline_formula] = STATE(129),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(129),
    [sym_comment_environment] = STATE(129),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(129),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(129),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(129),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(129),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(129),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(129),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(129),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(129),
    [sym_generic_command] = STATE(129),
    [sym_title_declaration] = STATE(129),
    [sym_author_declaration] = STATE(129),
    [sym_package_include] = STATE(129),
    [sym_class_include] = STATE(129),
    [sym_latex_include] = STATE(129),
    [sym_biblatex_include] = STATE(129),
    [sym_bibstyle_include] = STATE(129),
    [sym_bibtex_include] = STATE(129),
    [sym_graphics_include] = STATE(129),
    [sym_svg_include] = STATE(129),
    [sym_inkscape_include] = STATE(129),
    [sym_verbatim_include] = STATE(129),
    [sym_import_include] = STATE(129),
    [sym_caption] = STATE(129),
    [sym_citation] = STATE(129),
    [sym_label_definition] = STATE(129),
    [sym_label_reference] = STATE(129),
    [sym_label_reference_range] = STATE(129),
    [sym_label_number] = STATE(129),
    [sym_new_command_definition] = STATE(129),
    [sym_old_command_definition] = STATE(129),
    [sym_let_command_definition] = STATE(129),
    [sym_math_delimiter] = STATE(129),
    [sym_paired_delimiter_definition] = STATE(129),
    [sym_environment_definition] = STATE(129),
    [sym_glossary_entry_definition] = STATE(129),
    [sym_glossary_entry_reference] = STATE(129),
    [sym_acronym_definition] = STATE(129),
    [sym_acronym_reference] = STATE(129),
    [sym_theorem_definition] = STATE(129),
    [sym_color_definition] = STATE(129),
    [sym_color_set_definition] = STATE(129),
    [sym_color_reference] = STATE(129),
    [sym_tikz_library_import] = STATE(129),
    [sym_text_mode] = STATE(129),
    [sym_hyperlink] = STATE(129),
    [aux_sym_source_file_repeat1] = STATE(129),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [anon_sym_RBRACK] = ACTIONS(2110),
    [anon_sym_COMMA] = ACTIONS(2110),
    [anon_sym_EQ] = ACTIONS(2110),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [anon_sym_RPAREN] = ACTIONS(2110),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2112),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [143] = {
    [sym_block_comment] = STATE(132),
    [sym__root_content] = STATE(132),
    [sym__flat_content] = STATE(132),
    [sym__text_with_env_content] = STATE(132),
    [sym__text_content] = STATE(132),
    [sym__section] = STATE(132),
    [sym__paragraph] = STATE(132),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(132),
    [sym_text] = STATE(132),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(132),
    [sym_inline_formula] = STATE(132),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(132),
    [sym_comment_environment] = STATE(132),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(132),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(132),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(132),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(132),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(132),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(132),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(132),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(132),
    [sym_generic_command] = STATE(132),
    [sym_title_declaration] = STATE(132),
    [sym_author_declaration] = STATE(132),
    [sym_package_include] = STATE(132),
    [sym_class_include] = STATE(132),
    [sym_latex_include] = STATE(132),
    [sym_biblatex_include] = STATE(132),
    [sym_bibstyle_include] = STATE(132),
    [sym_bibtex_include] = STATE(132),
    [sym_graphics_include] = STATE(132),
    [sym_svg_include] = STATE(132),
    [sym_inkscape_include] = STATE(132),
    [sym_verbatim_include] = STATE(132),
    [sym_import_include] = STATE(132),
    [sym_caption] = STATE(132),
    [sym_citation] = STATE(132),
    [sym_label_definition] = STATE(132),
    [sym_label_reference] = STATE(132),
    [sym_label_reference_range] = STATE(132),
    [sym_label_number] = STATE(132),
    [sym_new_command_definition] = STATE(132),
    [sym_old_command_definition] = STATE(132),
    [sym_let_command_definition] = STATE(132),
    [sym_math_delimiter] = STATE(132),
    [sym_paired_delimiter_definition] = STATE(132),
    [sym_environment_definition] = STATE(132),
    [sym_glossary_entry_definition] = STATE(132),
    [sym_glossary_entry_reference] = STATE(132),
    [sym_acronym_definition] = STATE(132),
    [sym_acronym_reference] = STATE(132),
    [sym_theorem_definition] = STATE(132),
    [sym_color_definition] = STATE(132),
    [sym_color_set_definition] = STATE(132),
    [sym_color_reference] = STATE(132),
    [sym_tikz_library_import] = STATE(132),
    [sym_text_mode] = STATE(132),
    [sym_hyperlink] = STATE(132),
    [aux_sym_source_file_repeat1] = STATE(132),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(1490),
    [anon_sym_RBRACK] = ACTIONS(1490),
    [anon_sym_COMMA] = ACTIONS(1490),
    [anon_sym_EQ] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_RPAREN] = ACTIONS(1490),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2114),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2116),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [144] = {
    [sym_block_comment] = STATE(73),
    [sym__root_content] = STATE(73),
    [sym__flat_content] = STATE(73),
    [sym__text_with_env_content] = STATE(73),
    [sym__text_content] = STATE(73),
    [sym__section] = STATE(73),
    [sym__paragraph] = STATE(73),
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(787),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(786),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(785),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(784),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(780),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(73),
    [sym_text] = STATE(73),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(73),
    [sym_inline_formula] = STATE(73),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(73),
    [sym_comment_environment] = STATE(73),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(73),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(73),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(73),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(73),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(73),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(73),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(73),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(73),
    [sym_generic_command] = STATE(73),
    [sym_title_declaration] = STATE(73),
    [sym_author_declaration] = STATE(73),
    [sym_package_include] = STATE(73),
    [sym_class_include] = STATE(73),
    [sym_latex_include] = STATE(73),
    [sym_biblatex_include] = STATE(73),
    [sym_bibstyle_include] = STATE(73),
    [sym_bibtex_include] = STATE(73),
    [sym_graphics_include] = STATE(73),
    [sym_svg_include] = STATE(73),
    [sym_inkscape_include] = STATE(73),
    [sym_verbatim_include] = STATE(73),
    [sym_import_include] = STATE(73),
    [sym_caption] = STATE(73),
    [sym_citation] = STATE(73),
    [sym_label_definition] = STATE(73),
    [sym_label_reference] = STATE(73),
    [sym_label_reference_range] = STATE(73),
    [sym_label_number] = STATE(73),
    [sym_new_command_definition] = STATE(73),
    [sym_old_command_definition] = STATE(73),
    [sym_let_command_definition] = STATE(73),
    [sym_math_delimiter] = STATE(73),
    [sym_paired_delimiter_definition] = STATE(73),
    [sym_environment_definition] = STATE(73),
    [sym_glossary_entry_definition] = STATE(73),
    [sym_glossary_entry_reference] = STATE(73),
    [sym_acronym_definition] = STATE(73),
    [sym_acronym_reference] = STATE(73),
    [sym_theorem_definition] = STATE(73),
    [sym_color_definition] = STATE(73),
    [sym_color_set_definition] = STATE(73),
    [sym_color_reference] = STATE(73),
    [sym_tikz_library_import] = STATE(73),
    [sym_text_mode] = STATE(73),
    [sym_hyperlink] = STATE(73),
    [aux_sym_source_file_repeat1] = STATE(73),
    [aux_sym__section_repeat1] = STATE(787),
    [aux_sym__section_repeat2] = STATE(786),
    [aux_sym__section_repeat3] = STATE(785),
    [aux_sym__section_repeat4] = STATE(784),
    [aux_sym__section_repeat5] = STATE(780),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_RBRACK] = ACTIONS(1478),
    [anon_sym_COMMA] = ACTIONS(1478),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2118),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2120),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [145] = {
    [sym_block_comment] = STATE(64),
    [sym__root_content] = STATE(64),
    [sym__flat_content] = STATE(64),
    [sym__text_with_env_content] = STATE(64),
    [sym__text_content] = STATE(64),
    [sym__section] = STATE(64),
    [sym__paragraph] = STATE(64),
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(593),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(587),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(566),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(457),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(461),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(64),
    [sym_text] = STATE(64),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(64),
    [sym_inline_formula] = STATE(64),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(64),
    [sym_comment_environment] = STATE(64),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(64),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(64),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(64),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(64),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(64),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(64),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(64),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(64),
    [sym_generic_command] = STATE(64),
    [sym_title_declaration] = STATE(64),
    [sym_author_declaration] = STATE(64),
    [sym_package_include] = STATE(64),
    [sym_class_include] = STATE(64),
    [sym_latex_include] = STATE(64),
    [sym_biblatex_include] = STATE(64),
    [sym_bibstyle_include] = STATE(64),
    [sym_bibtex_include] = STATE(64),
    [sym_graphics_include] = STATE(64),
    [sym_svg_include] = STATE(64),
    [sym_inkscape_include] = STATE(64),
    [sym_verbatim_include] = STATE(64),
    [sym_import_include] = STATE(64),
    [sym_caption] = STATE(64),
    [sym_citation] = STATE(64),
    [sym_label_definition] = STATE(64),
    [sym_label_reference] = STATE(64),
    [sym_label_reference_range] = STATE(64),
    [sym_label_number] = STATE(64),
    [sym_new_command_definition] = STATE(64),
    [sym_old_command_definition] = STATE(64),
    [sym_let_command_definition] = STATE(64),
    [sym_math_delimiter] = STATE(64),
    [sym_paired_delimiter_definition] = STATE(64),
    [sym_environment_definition] = STATE(64),
    [sym_glossary_entry_definition] = STATE(64),
    [sym_glossary_entry_reference] = STATE(64),
    [sym_acronym_definition] = STATE(64),
    [sym_acronym_reference] = STATE(64),
    [sym_theorem_definition] = STATE(64),
    [sym_color_definition] = STATE(64),
    [sym_color_set_definition] = STATE(64),
    [sym_color_reference] = STATE(64),
    [sym_tikz_library_import] = STATE(64),
    [sym_text_mode] = STATE(64),
    [sym_hyperlink] = STATE(64),
    [aux_sym_source_file_repeat1] = STATE(64),
    [aux_sym__section_repeat1] = STATE(593),
    [aux_sym__section_repeat2] = STATE(587),
    [aux_sym__section_repeat3] = STATE(566),
    [aux_sym__section_repeat4] = STATE(457),
    [aux_sym__section_repeat5] = STATE(461),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_text_repeat1] = STATE(257),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_RBRACK] = ACTIONS(1470),
    [anon_sym_COMMA] = ACTIONS(1470),
    [anon_sym_EQ] = ACTIONS(1470),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2122),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [146] = {
    [sym_block_comment] = STATE(81),
    [sym__root_content] = STATE(81),
    [sym__flat_content] = STATE(81),
    [sym__text_with_env_content] = STATE(81),
    [sym__text_content] = STATE(81),
    [sym__section] = STATE(81),
    [sym__paragraph] = STATE(81),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(81),
    [sym_text] = STATE(81),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(81),
    [sym_inline_formula] = STATE(81),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(81),
    [sym_comment_environment] = STATE(81),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(81),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(81),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(81),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(81),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(81),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(81),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(81),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(81),
    [sym_generic_command] = STATE(81),
    [sym_title_declaration] = STATE(81),
    [sym_author_declaration] = STATE(81),
    [sym_package_include] = STATE(81),
    [sym_class_include] = STATE(81),
    [sym_latex_include] = STATE(81),
    [sym_biblatex_include] = STATE(81),
    [sym_bibstyle_include] = STATE(81),
    [sym_bibtex_include] = STATE(81),
    [sym_graphics_include] = STATE(81),
    [sym_svg_include] = STATE(81),
    [sym_inkscape_include] = STATE(81),
    [sym_verbatim_include] = STATE(81),
    [sym_import_include] = STATE(81),
    [sym_caption] = STATE(81),
    [sym_citation] = STATE(81),
    [sym_label_definition] = STATE(81),
    [sym_label_reference] = STATE(81),
    [sym_label_reference_range] = STATE(81),
    [sym_label_number] = STATE(81),
    [sym_new_command_definition] = STATE(81),
    [sym_old_command_definition] = STATE(81),
    [sym_let_command_definition] = STATE(81),
    [sym_math_delimiter] = STATE(81),
    [sym_paired_delimiter_definition] = STATE(81),
    [sym_environment_definition] = STATE(81),
    [sym_glossary_entry_definition] = STATE(81),
    [sym_glossary_entry_reference] = STATE(81),
    [sym_acronym_definition] = STATE(81),
    [sym_acronym_reference] = STATE(81),
    [sym_theorem_definition] = STATE(81),
    [sym_color_definition] = STATE(81),
    [sym_color_set_definition] = STATE(81),
    [sym_color_reference] = STATE(81),
    [sym_tikz_library_import] = STATE(81),
    [sym_text_mode] = STATE(81),
    [sym_hyperlink] = STATE(81),
    [aux_sym_source_file_repeat1] = STATE(81),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(612),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(159),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [147] = {
    [sym_block_comment] = STATE(143),
    [sym__root_content] = STATE(143),
    [sym__flat_content] = STATE(143),
    [sym__text_with_env_content] = STATE(143),
    [sym__text_content] = STATE(143),
    [sym__section] = STATE(143),
    [sym__paragraph] = STATE(143),
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(754),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(755),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(756),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(757),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(758),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(143),
    [sym_text] = STATE(143),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(143),
    [sym_inline_formula] = STATE(143),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(143),
    [sym_comment_environment] = STATE(143),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(143),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(143),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(143),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(143),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(143),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(143),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(143),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(143),
    [sym_generic_command] = STATE(143),
    [sym_title_declaration] = STATE(143),
    [sym_author_declaration] = STATE(143),
    [sym_package_include] = STATE(143),
    [sym_class_include] = STATE(143),
    [sym_latex_include] = STATE(143),
    [sym_biblatex_include] = STATE(143),
    [sym_bibstyle_include] = STATE(143),
    [sym_bibtex_include] = STATE(143),
    [sym_graphics_include] = STATE(143),
    [sym_svg_include] = STATE(143),
    [sym_inkscape_include] = STATE(143),
    [sym_verbatim_include] = STATE(143),
    [sym_import_include] = STATE(143),
    [sym_caption] = STATE(143),
    [sym_citation] = STATE(143),
    [sym_label_definition] = STATE(143),
    [sym_label_reference] = STATE(143),
    [sym_label_reference_range] = STATE(143),
    [sym_label_number] = STATE(143),
    [sym_new_command_definition] = STATE(143),
    [sym_old_command_definition] = STATE(143),
    [sym_let_command_definition] = STATE(143),
    [sym_math_delimiter] = STATE(143),
    [sym_paired_delimiter_definition] = STATE(143),
    [sym_environment_definition] = STATE(143),
    [sym_glossary_entry_definition] = STATE(143),
    [sym_glossary_entry_reference] = STATE(143),
    [sym_acronym_definition] = STATE(143),
    [sym_acronym_reference] = STATE(143),
    [sym_theorem_definition] = STATE(143),
    [sym_color_definition] = STATE(143),
    [sym_color_set_definition] = STATE(143),
    [sym_color_reference] = STATE(143),
    [sym_tikz_library_import] = STATE(143),
    [sym_text_mode] = STATE(143),
    [sym_hyperlink] = STATE(143),
    [aux_sym_source_file_repeat1] = STATE(143),
    [aux_sym__section_repeat1] = STATE(754),
    [aux_sym__section_repeat2] = STATE(755),
    [aux_sym__section_repeat3] = STATE(756),
    [aux_sym__section_repeat4] = STATE(757),
    [aux_sym__section_repeat5] = STATE(758),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2124),
    [anon_sym_RBRACK] = ACTIONS(2124),
    [anon_sym_COMMA] = ACTIONS(2124),
    [anon_sym_EQ] = ACTIONS(2124),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_RPAREN] = ACTIONS(2124),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2126),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2128),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [148] = {
    [sym_block_comment] = STATE(211),
    [sym__flat_content] = STATE(211),
    [sym__text_with_env_content] = STATE(211),
    [sym__text_content] = STATE(211),
    [sym__paragraph] = STATE(325),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(379),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(380),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(381),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(382),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(211),
    [sym_text] = STATE(211),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(211),
    [sym_inline_formula] = STATE(211),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(211),
    [sym_comment_environment] = STATE(211),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(211),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(211),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(211),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(211),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(211),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(211),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(211),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(211),
    [sym_generic_command] = STATE(211),
    [sym_title_declaration] = STATE(211),
    [sym_author_declaration] = STATE(211),
    [sym_package_include] = STATE(211),
    [sym_class_include] = STATE(211),
    [sym_latex_include] = STATE(211),
    [sym_biblatex_include] = STATE(211),
    [sym_bibstyle_include] = STATE(211),
    [sym_bibtex_include] = STATE(211),
    [sym_graphics_include] = STATE(211),
    [sym_svg_include] = STATE(211),
    [sym_inkscape_include] = STATE(211),
    [sym_verbatim_include] = STATE(211),
    [sym_import_include] = STATE(211),
    [sym_caption] = STATE(211),
    [sym_citation] = STATE(211),
    [sym_label_definition] = STATE(211),
    [sym_label_reference] = STATE(211),
    [sym_label_reference_range] = STATE(211),
    [sym_label_number] = STATE(211),
    [sym_new_command_definition] = STATE(211),
    [sym_old_command_definition] = STATE(211),
    [sym_let_command_definition] = STATE(211),
    [sym_math_delimiter] = STATE(211),
    [sym_paired_delimiter_definition] = STATE(211),
    [sym_environment_definition] = STATE(211),
    [sym_glossary_entry_definition] = STATE(211),
    [sym_glossary_entry_reference] = STATE(211),
    [sym_acronym_definition] = STATE(211),
    [sym_acronym_reference] = STATE(211),
    [sym_theorem_definition] = STATE(211),
    [sym_color_definition] = STATE(211),
    [sym_color_set_definition] = STATE(211),
    [sym_color_reference] = STATE(211),
    [sym_tikz_library_import] = STATE(211),
    [sym_text_mode] = STATE(211),
    [sym_hyperlink] = STATE(211),
    [aux_sym__section_repeat2] = STATE(379),
    [aux_sym__section_repeat3] = STATE(380),
    [aux_sym__section_repeat4] = STATE(381),
    [aux_sym__section_repeat5] = STATE(382),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(211),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_RBRACK] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2132),
    [anon_sym_BSLASHbigr] = ACTIONS(2132),
    [anon_sym_BSLASHBigr] = ACTIONS(2132),
    [anon_sym_BSLASHbiggr] = ACTIONS(2132),
    [anon_sym_BSLASHBiggr] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [149] = {
    [sym_block_comment] = STATE(148),
    [sym__flat_content] = STATE(148),
    [sym__text_with_env_content] = STATE(148),
    [sym__text_content] = STATE(148),
    [sym__paragraph] = STATE(324),
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(393),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(350),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(352),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(353),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(148),
    [sym_text] = STATE(148),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(148),
    [sym_inline_formula] = STATE(148),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(148),
    [sym_comment_environment] = STATE(148),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(148),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(148),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(148),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(148),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(148),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(148),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(148),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(148),
    [sym_generic_command] = STATE(148),
    [sym_title_declaration] = STATE(148),
    [sym_author_declaration] = STATE(148),
    [sym_package_include] = STATE(148),
    [sym_class_include] = STATE(148),
    [sym_latex_include] = STATE(148),
    [sym_biblatex_include] = STATE(148),
    [sym_bibstyle_include] = STATE(148),
    [sym_bibtex_include] = STATE(148),
    [sym_graphics_include] = STATE(148),
    [sym_svg_include] = STATE(148),
    [sym_inkscape_include] = STATE(148),
    [sym_verbatim_include] = STATE(148),
    [sym_import_include] = STATE(148),
    [sym_caption] = STATE(148),
    [sym_citation] = STATE(148),
    [sym_label_definition] = STATE(148),
    [sym_label_reference] = STATE(148),
    [sym_label_reference_range] = STATE(148),
    [sym_label_number] = STATE(148),
    [sym_new_command_definition] = STATE(148),
    [sym_old_command_definition] = STATE(148),
    [sym_let_command_definition] = STATE(148),
    [sym_math_delimiter] = STATE(148),
    [sym_paired_delimiter_definition] = STATE(148),
    [sym_environment_definition] = STATE(148),
    [sym_glossary_entry_definition] = STATE(148),
    [sym_glossary_entry_reference] = STATE(148),
    [sym_acronym_definition] = STATE(148),
    [sym_acronym_reference] = STATE(148),
    [sym_theorem_definition] = STATE(148),
    [sym_color_definition] = STATE(148),
    [sym_color_set_definition] = STATE(148),
    [sym_color_reference] = STATE(148),
    [sym_tikz_library_import] = STATE(148),
    [sym_text_mode] = STATE(148),
    [sym_hyperlink] = STATE(148),
    [aux_sym__section_repeat2] = STATE(393),
    [aux_sym__section_repeat3] = STATE(350),
    [aux_sym__section_repeat4] = STATE(352),
    [aux_sym__section_repeat5] = STATE(353),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(148),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [anon_sym_RBRACK] = ACTIONS(2136),
    [anon_sym_COMMA] = ACTIONS(2136),
    [anon_sym_EQ] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(2136),
    [anon_sym_RPAREN] = ACTIONS(2136),
    [anon_sym_BSLASHpart] = ACTIONS(2138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHaddpart] = ACTIONS(2138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2138),
    [anon_sym_BSLASHbigr] = ACTIONS(2138),
    [anon_sym_BSLASHBigr] = ACTIONS(2138),
    [anon_sym_BSLASHbiggr] = ACTIONS(2138),
    [anon_sym_BSLASHBiggr] = ACTIONS(2138),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [150] = {
    [sym_block_comment] = STATE(221),
    [sym__flat_content] = STATE(221),
    [sym__text_with_env_content] = STATE(221),
    [sym__text_content] = STATE(221),
    [sym__paragraph] = STATE(328),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(499),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(498),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(497),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(496),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(221),
    [sym_text] = STATE(221),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(221),
    [sym_inline_formula] = STATE(221),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(221),
    [sym_comment_environment] = STATE(221),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(221),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(221),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(221),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(221),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(221),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(221),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(221),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(221),
    [sym_generic_command] = STATE(221),
    [sym_title_declaration] = STATE(221),
    [sym_author_declaration] = STATE(221),
    [sym_package_include] = STATE(221),
    [sym_class_include] = STATE(221),
    [sym_latex_include] = STATE(221),
    [sym_biblatex_include] = STATE(221),
    [sym_bibstyle_include] = STATE(221),
    [sym_bibtex_include] = STATE(221),
    [sym_graphics_include] = STATE(221),
    [sym_svg_include] = STATE(221),
    [sym_inkscape_include] = STATE(221),
    [sym_verbatim_include] = STATE(221),
    [sym_import_include] = STATE(221),
    [sym_caption] = STATE(221),
    [sym_citation] = STATE(221),
    [sym_label_definition] = STATE(221),
    [sym_label_reference] = STATE(221),
    [sym_label_reference_range] = STATE(221),
    [sym_label_number] = STATE(221),
    [sym_new_command_definition] = STATE(221),
    [sym_old_command_definition] = STATE(221),
    [sym_let_command_definition] = STATE(221),
    [sym_math_delimiter] = STATE(221),
    [sym_paired_delimiter_definition] = STATE(221),
    [sym_environment_definition] = STATE(221),
    [sym_glossary_entry_definition] = STATE(221),
    [sym_glossary_entry_reference] = STATE(221),
    [sym_acronym_definition] = STATE(221),
    [sym_acronym_reference] = STATE(221),
    [sym_theorem_definition] = STATE(221),
    [sym_color_definition] = STATE(221),
    [sym_color_set_definition] = STATE(221),
    [sym_color_reference] = STATE(221),
    [sym_tikz_library_import] = STATE(221),
    [sym_text_mode] = STATE(221),
    [sym_hyperlink] = STATE(221),
    [aux_sym__section_repeat2] = STATE(499),
    [aux_sym__section_repeat3] = STATE(498),
    [aux_sym__section_repeat4] = STATE(497),
    [aux_sym__section_repeat5] = STATE(496),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(221),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_RBRACK] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [151] = {
    [sym_block_comment] = STATE(211),
    [sym__flat_content] = STATE(211),
    [sym__text_with_env_content] = STATE(211),
    [sym__text_content] = STATE(211),
    [sym__paragraph] = STATE(331),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(387),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(388),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(389),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(211),
    [sym_text] = STATE(211),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(211),
    [sym_inline_formula] = STATE(211),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(211),
    [sym_comment_environment] = STATE(211),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(211),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(211),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(211),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(211),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(211),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(211),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(211),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(211),
    [sym_generic_command] = STATE(211),
    [sym_title_declaration] = STATE(211),
    [sym_author_declaration] = STATE(211),
    [sym_package_include] = STATE(211),
    [sym_class_include] = STATE(211),
    [sym_latex_include] = STATE(211),
    [sym_biblatex_include] = STATE(211),
    [sym_bibstyle_include] = STATE(211),
    [sym_bibtex_include] = STATE(211),
    [sym_graphics_include] = STATE(211),
    [sym_svg_include] = STATE(211),
    [sym_inkscape_include] = STATE(211),
    [sym_verbatim_include] = STATE(211),
    [sym_import_include] = STATE(211),
    [sym_caption] = STATE(211),
    [sym_citation] = STATE(211),
    [sym_label_definition] = STATE(211),
    [sym_label_reference] = STATE(211),
    [sym_label_reference_range] = STATE(211),
    [sym_label_number] = STATE(211),
    [sym_new_command_definition] = STATE(211),
    [sym_old_command_definition] = STATE(211),
    [sym_let_command_definition] = STATE(211),
    [sym_math_delimiter] = STATE(211),
    [sym_paired_delimiter_definition] = STATE(211),
    [sym_environment_definition] = STATE(211),
    [sym_glossary_entry_definition] = STATE(211),
    [sym_glossary_entry_reference] = STATE(211),
    [sym_acronym_definition] = STATE(211),
    [sym_acronym_reference] = STATE(211),
    [sym_theorem_definition] = STATE(211),
    [sym_color_definition] = STATE(211),
    [sym_color_set_definition] = STATE(211),
    [sym_color_reference] = STATE(211),
    [sym_tikz_library_import] = STATE(211),
    [sym_text_mode] = STATE(211),
    [sym_hyperlink] = STATE(211),
    [aux_sym__section_repeat3] = STATE(387),
    [aux_sym__section_repeat4] = STATE(388),
    [aux_sym__section_repeat5] = STATE(389),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(211),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_RBRACK] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2144),
    [anon_sym_BSLASHbigr] = ACTIONS(2144),
    [anon_sym_BSLASHBigr] = ACTIONS(2144),
    [anon_sym_BSLASHbiggr] = ACTIONS(2144),
    [anon_sym_BSLASHBiggr] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [152] = {
    [sym_block_comment] = STATE(151),
    [sym__flat_content] = STATE(151),
    [sym__text_with_env_content] = STATE(151),
    [sym__text_content] = STATE(151),
    [sym__paragraph] = STATE(329),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(355),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(356),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(357),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(151),
    [sym_text] = STATE(151),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(151),
    [sym_inline_formula] = STATE(151),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(151),
    [sym_comment_environment] = STATE(151),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(151),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(151),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(151),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(151),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(151),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(151),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(151),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(151),
    [sym_generic_command] = STATE(151),
    [sym_title_declaration] = STATE(151),
    [sym_author_declaration] = STATE(151),
    [sym_package_include] = STATE(151),
    [sym_class_include] = STATE(151),
    [sym_latex_include] = STATE(151),
    [sym_biblatex_include] = STATE(151),
    [sym_bibstyle_include] = STATE(151),
    [sym_bibtex_include] = STATE(151),
    [sym_graphics_include] = STATE(151),
    [sym_svg_include] = STATE(151),
    [sym_inkscape_include] = STATE(151),
    [sym_verbatim_include] = STATE(151),
    [sym_import_include] = STATE(151),
    [sym_caption] = STATE(151),
    [sym_citation] = STATE(151),
    [sym_label_definition] = STATE(151),
    [sym_label_reference] = STATE(151),
    [sym_label_reference_range] = STATE(151),
    [sym_label_number] = STATE(151),
    [sym_new_command_definition] = STATE(151),
    [sym_old_command_definition] = STATE(151),
    [sym_let_command_definition] = STATE(151),
    [sym_math_delimiter] = STATE(151),
    [sym_paired_delimiter_definition] = STATE(151),
    [sym_environment_definition] = STATE(151),
    [sym_glossary_entry_definition] = STATE(151),
    [sym_glossary_entry_reference] = STATE(151),
    [sym_acronym_definition] = STATE(151),
    [sym_acronym_reference] = STATE(151),
    [sym_theorem_definition] = STATE(151),
    [sym_color_definition] = STATE(151),
    [sym_color_set_definition] = STATE(151),
    [sym_color_reference] = STATE(151),
    [sym_tikz_library_import] = STATE(151),
    [sym_text_mode] = STATE(151),
    [sym_hyperlink] = STATE(151),
    [aux_sym__section_repeat3] = STATE(355),
    [aux_sym__section_repeat4] = STATE(356),
    [aux_sym__section_repeat5] = STATE(357),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(151),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_RBRACK] = ACTIONS(2148),
    [anon_sym_COMMA] = ACTIONS(2148),
    [anon_sym_EQ] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2148),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [anon_sym_BSLASHpart] = ACTIONS(2150),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddpart] = ACTIONS(2150),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHchapter] = ACTIONS(2150),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddchap] = ACTIONS(2150),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2150),
    [anon_sym_BSLASHbigr] = ACTIONS(2150),
    [anon_sym_BSLASHBigr] = ACTIONS(2150),
    [anon_sym_BSLASHbiggr] = ACTIONS(2150),
    [anon_sym_BSLASHBiggr] = ACTIONS(2150),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [153] = {
    [sym_block_comment] = STATE(150),
    [sym__flat_content] = STATE(150),
    [sym__text_with_env_content] = STATE(150),
    [sym__text_content] = STATE(150),
    [sym__paragraph] = STATE(330),
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(494),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(504),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(505),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(507),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(150),
    [sym_text] = STATE(150),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(150),
    [sym_inline_formula] = STATE(150),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(150),
    [sym_comment_environment] = STATE(150),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(150),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(150),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(150),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(150),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(150),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(150),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(150),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(150),
    [sym_generic_command] = STATE(150),
    [sym_title_declaration] = STATE(150),
    [sym_author_declaration] = STATE(150),
    [sym_package_include] = STATE(150),
    [sym_class_include] = STATE(150),
    [sym_latex_include] = STATE(150),
    [sym_biblatex_include] = STATE(150),
    [sym_bibstyle_include] = STATE(150),
    [sym_bibtex_include] = STATE(150),
    [sym_graphics_include] = STATE(150),
    [sym_svg_include] = STATE(150),
    [sym_inkscape_include] = STATE(150),
    [sym_verbatim_include] = STATE(150),
    [sym_import_include] = STATE(150),
    [sym_caption] = STATE(150),
    [sym_citation] = STATE(150),
    [sym_label_definition] = STATE(150),
    [sym_label_reference] = STATE(150),
    [sym_label_reference_range] = STATE(150),
    [sym_label_number] = STATE(150),
    [sym_new_command_definition] = STATE(150),
    [sym_old_command_definition] = STATE(150),
    [sym_let_command_definition] = STATE(150),
    [sym_math_delimiter] = STATE(150),
    [sym_paired_delimiter_definition] = STATE(150),
    [sym_environment_definition] = STATE(150),
    [sym_glossary_entry_definition] = STATE(150),
    [sym_glossary_entry_reference] = STATE(150),
    [sym_acronym_definition] = STATE(150),
    [sym_acronym_reference] = STATE(150),
    [sym_theorem_definition] = STATE(150),
    [sym_color_definition] = STATE(150),
    [sym_color_set_definition] = STATE(150),
    [sym_color_reference] = STATE(150),
    [sym_tikz_library_import] = STATE(150),
    [sym_text_mode] = STATE(150),
    [sym_hyperlink] = STATE(150),
    [aux_sym__section_repeat2] = STATE(494),
    [aux_sym__section_repeat3] = STATE(504),
    [aux_sym__section_repeat4] = STATE(505),
    [aux_sym__section_repeat5] = STATE(507),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(150),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2140),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2154),
    [anon_sym_COMMA] = ACTIONS(2154),
    [anon_sym_EQ] = ACTIONS(2154),
    [anon_sym_LPAREN] = ACTIONS(2154),
    [anon_sym_RPAREN] = ACTIONS(2154),
    [anon_sym_BSLASHpart] = ACTIONS(2138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHaddpart] = ACTIONS(2138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2140),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [154] = {
    [sym_block_comment] = STATE(231),
    [sym__flat_content] = STATE(231),
    [sym__text_with_env_content] = STATE(231),
    [sym__text_content] = STATE(231),
    [sym__paragraph] = STATE(335),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(672),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(673),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(674),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(675),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(231),
    [sym_text] = STATE(231),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(231),
    [sym_inline_formula] = STATE(231),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(231),
    [sym_comment_environment] = STATE(231),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(231),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(231),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(231),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(231),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(231),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(231),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(231),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(231),
    [sym_generic_command] = STATE(231),
    [sym_title_declaration] = STATE(231),
    [sym_author_declaration] = STATE(231),
    [sym_package_include] = STATE(231),
    [sym_class_include] = STATE(231),
    [sym_latex_include] = STATE(231),
    [sym_biblatex_include] = STATE(231),
    [sym_bibstyle_include] = STATE(231),
    [sym_bibtex_include] = STATE(231),
    [sym_graphics_include] = STATE(231),
    [sym_svg_include] = STATE(231),
    [sym_inkscape_include] = STATE(231),
    [sym_verbatim_include] = STATE(231),
    [sym_import_include] = STATE(231),
    [sym_caption] = STATE(231),
    [sym_citation] = STATE(231),
    [sym_label_definition] = STATE(231),
    [sym_label_reference] = STATE(231),
    [sym_label_reference_range] = STATE(231),
    [sym_label_number] = STATE(231),
    [sym_new_command_definition] = STATE(231),
    [sym_old_command_definition] = STATE(231),
    [sym_let_command_definition] = STATE(231),
    [sym_math_delimiter] = STATE(231),
    [sym_paired_delimiter_definition] = STATE(231),
    [sym_environment_definition] = STATE(231),
    [sym_glossary_entry_definition] = STATE(231),
    [sym_glossary_entry_reference] = STATE(231),
    [sym_acronym_definition] = STATE(231),
    [sym_acronym_reference] = STATE(231),
    [sym_theorem_definition] = STATE(231),
    [sym_color_definition] = STATE(231),
    [sym_color_set_definition] = STATE(231),
    [sym_color_reference] = STATE(231),
    [sym_tikz_library_import] = STATE(231),
    [sym_text_mode] = STATE(231),
    [sym_hyperlink] = STATE(231),
    [aux_sym__section_repeat2] = STATE(672),
    [aux_sym__section_repeat3] = STATE(673),
    [aux_sym__section_repeat4] = STATE(674),
    [aux_sym__section_repeat5] = STATE(675),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(231),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_RBRACK] = ACTIONS(2156),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_EQ] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [155] = {
    [sym_block_comment] = STATE(228),
    [sym__flat_content] = STATE(228),
    [sym__text_with_env_content] = STATE(228),
    [sym__text_content] = STATE(228),
    [sym__paragraph] = STATE(334),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(829),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(790),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(788),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(776),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(228),
    [sym_text] = STATE(228),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(228),
    [sym_inline_formula] = STATE(228),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(228),
    [sym_comment_environment] = STATE(228),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(228),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(228),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(228),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(228),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(228),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(228),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(228),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(228),
    [sym_generic_command] = STATE(228),
    [sym_title_declaration] = STATE(228),
    [sym_author_declaration] = STATE(228),
    [sym_package_include] = STATE(228),
    [sym_class_include] = STATE(228),
    [sym_latex_include] = STATE(228),
    [sym_biblatex_include] = STATE(228),
    [sym_bibstyle_include] = STATE(228),
    [sym_bibtex_include] = STATE(228),
    [sym_graphics_include] = STATE(228),
    [sym_svg_include] = STATE(228),
    [sym_inkscape_include] = STATE(228),
    [sym_verbatim_include] = STATE(228),
    [sym_import_include] = STATE(228),
    [sym_caption] = STATE(228),
    [sym_citation] = STATE(228),
    [sym_label_definition] = STATE(228),
    [sym_label_reference] = STATE(228),
    [sym_label_reference_range] = STATE(228),
    [sym_label_number] = STATE(228),
    [sym_new_command_definition] = STATE(228),
    [sym_old_command_definition] = STATE(228),
    [sym_let_command_definition] = STATE(228),
    [sym_math_delimiter] = STATE(228),
    [sym_paired_delimiter_definition] = STATE(228),
    [sym_environment_definition] = STATE(228),
    [sym_glossary_entry_definition] = STATE(228),
    [sym_glossary_entry_reference] = STATE(228),
    [sym_acronym_definition] = STATE(228),
    [sym_acronym_reference] = STATE(228),
    [sym_theorem_definition] = STATE(228),
    [sym_color_definition] = STATE(228),
    [sym_color_set_definition] = STATE(228),
    [sym_color_reference] = STATE(228),
    [sym_tikz_library_import] = STATE(228),
    [sym_text_mode] = STATE(228),
    [sym_hyperlink] = STATE(228),
    [aux_sym__section_repeat2] = STATE(829),
    [aux_sym__section_repeat3] = STATE(790),
    [aux_sym__section_repeat4] = STATE(788),
    [aux_sym__section_repeat5] = STATE(776),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(228),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [156] = {
    [sym_block_comment] = STATE(158),
    [sym__flat_content] = STATE(158),
    [sym__text_with_env_content] = STATE(158),
    [sym__text_content] = STATE(158),
    [sym__paragraph] = STATE(332),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(804),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(805),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(806),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(807),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(158),
    [sym_text] = STATE(158),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(158),
    [sym_inline_formula] = STATE(158),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(158),
    [sym_comment_environment] = STATE(158),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(158),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(158),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(158),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(158),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(158),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(158),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(158),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(158),
    [sym_generic_command] = STATE(158),
    [sym_title_declaration] = STATE(158),
    [sym_author_declaration] = STATE(158),
    [sym_package_include] = STATE(158),
    [sym_class_include] = STATE(158),
    [sym_latex_include] = STATE(158),
    [sym_biblatex_include] = STATE(158),
    [sym_bibstyle_include] = STATE(158),
    [sym_bibtex_include] = STATE(158),
    [sym_graphics_include] = STATE(158),
    [sym_svg_include] = STATE(158),
    [sym_inkscape_include] = STATE(158),
    [sym_verbatim_include] = STATE(158),
    [sym_import_include] = STATE(158),
    [sym_caption] = STATE(158),
    [sym_citation] = STATE(158),
    [sym_label_definition] = STATE(158),
    [sym_label_reference] = STATE(158),
    [sym_label_reference_range] = STATE(158),
    [sym_label_number] = STATE(158),
    [sym_new_command_definition] = STATE(158),
    [sym_old_command_definition] = STATE(158),
    [sym_let_command_definition] = STATE(158),
    [sym_math_delimiter] = STATE(158),
    [sym_paired_delimiter_definition] = STATE(158),
    [sym_environment_definition] = STATE(158),
    [sym_glossary_entry_definition] = STATE(158),
    [sym_glossary_entry_reference] = STATE(158),
    [sym_acronym_definition] = STATE(158),
    [sym_acronym_reference] = STATE(158),
    [sym_theorem_definition] = STATE(158),
    [sym_color_definition] = STATE(158),
    [sym_color_set_definition] = STATE(158),
    [sym_color_reference] = STATE(158),
    [sym_tikz_library_import] = STATE(158),
    [sym_text_mode] = STATE(158),
    [sym_hyperlink] = STATE(158),
    [aux_sym__section_repeat2] = STATE(804),
    [aux_sym__section_repeat3] = STATE(805),
    [aux_sym__section_repeat4] = STATE(806),
    [aux_sym__section_repeat5] = STATE(807),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(158),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2160),
    [anon_sym_RBRACK] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2160),
    [anon_sym_EQ] = ACTIONS(2160),
    [anon_sym_LPAREN] = ACTIONS(2160),
    [anon_sym_RPAREN] = ACTIONS(2160),
    [anon_sym_BSLASHpart] = ACTIONS(2138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHaddpart] = ACTIONS(2138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2140),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [157] = {
    [sym_block_comment] = STATE(154),
    [sym__flat_content] = STATE(154),
    [sym__text_with_env_content] = STATE(154),
    [sym__text_content] = STATE(154),
    [sym__paragraph] = STATE(336),
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(764),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(762),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(645),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(752),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(154),
    [sym_text] = STATE(154),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(154),
    [sym_inline_formula] = STATE(154),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(154),
    [sym_comment_environment] = STATE(154),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(154),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(154),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(154),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(154),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(154),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(154),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(154),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(154),
    [sym_generic_command] = STATE(154),
    [sym_title_declaration] = STATE(154),
    [sym_author_declaration] = STATE(154),
    [sym_package_include] = STATE(154),
    [sym_class_include] = STATE(154),
    [sym_latex_include] = STATE(154),
    [sym_biblatex_include] = STATE(154),
    [sym_bibstyle_include] = STATE(154),
    [sym_bibtex_include] = STATE(154),
    [sym_graphics_include] = STATE(154),
    [sym_svg_include] = STATE(154),
    [sym_inkscape_include] = STATE(154),
    [sym_verbatim_include] = STATE(154),
    [sym_import_include] = STATE(154),
    [sym_caption] = STATE(154),
    [sym_citation] = STATE(154),
    [sym_label_definition] = STATE(154),
    [sym_label_reference] = STATE(154),
    [sym_label_reference_range] = STATE(154),
    [sym_label_number] = STATE(154),
    [sym_new_command_definition] = STATE(154),
    [sym_old_command_definition] = STATE(154),
    [sym_let_command_definition] = STATE(154),
    [sym_math_delimiter] = STATE(154),
    [sym_paired_delimiter_definition] = STATE(154),
    [sym_environment_definition] = STATE(154),
    [sym_glossary_entry_definition] = STATE(154),
    [sym_glossary_entry_reference] = STATE(154),
    [sym_acronym_definition] = STATE(154),
    [sym_acronym_reference] = STATE(154),
    [sym_theorem_definition] = STATE(154),
    [sym_color_definition] = STATE(154),
    [sym_color_set_definition] = STATE(154),
    [sym_color_reference] = STATE(154),
    [sym_tikz_library_import] = STATE(154),
    [sym_text_mode] = STATE(154),
    [sym_hyperlink] = STATE(154),
    [aux_sym__section_repeat2] = STATE(764),
    [aux_sym__section_repeat3] = STATE(762),
    [aux_sym__section_repeat4] = STATE(645),
    [aux_sym__section_repeat5] = STATE(752),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(154),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2164),
    [anon_sym_RBRACK] = ACTIONS(2164),
    [anon_sym_COMMA] = ACTIONS(2164),
    [anon_sym_EQ] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2164),
    [anon_sym_RPAREN] = ACTIONS(2164),
    [anon_sym_BSLASHpart] = ACTIONS(2138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHaddpart] = ACTIONS(2138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2140),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [158] = {
    [sym_block_comment] = STATE(232),
    [sym__flat_content] = STATE(232),
    [sym__text_with_env_content] = STATE(232),
    [sym__text_content] = STATE(232),
    [sym__paragraph] = STATE(333),
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(852),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(853),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(854),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(855),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(232),
    [sym_text] = STATE(232),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(232),
    [sym_inline_formula] = STATE(232),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(232),
    [sym_comment_environment] = STATE(232),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(232),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(232),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(232),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(232),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(232),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(232),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(232),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(232),
    [sym_generic_command] = STATE(232),
    [sym_title_declaration] = STATE(232),
    [sym_author_declaration] = STATE(232),
    [sym_package_include] = STATE(232),
    [sym_class_include] = STATE(232),
    [sym_latex_include] = STATE(232),
    [sym_biblatex_include] = STATE(232),
    [sym_bibstyle_include] = STATE(232),
    [sym_bibtex_include] = STATE(232),
    [sym_graphics_include] = STATE(232),
    [sym_svg_include] = STATE(232),
    [sym_inkscape_include] = STATE(232),
    [sym_verbatim_include] = STATE(232),
    [sym_import_include] = STATE(232),
    [sym_caption] = STATE(232),
    [sym_citation] = STATE(232),
    [sym_label_definition] = STATE(232),
    [sym_label_reference] = STATE(232),
    [sym_label_reference_range] = STATE(232),
    [sym_label_number] = STATE(232),
    [sym_new_command_definition] = STATE(232),
    [sym_old_command_definition] = STATE(232),
    [sym_let_command_definition] = STATE(232),
    [sym_math_delimiter] = STATE(232),
    [sym_paired_delimiter_definition] = STATE(232),
    [sym_environment_definition] = STATE(232),
    [sym_glossary_entry_definition] = STATE(232),
    [sym_glossary_entry_reference] = STATE(232),
    [sym_acronym_definition] = STATE(232),
    [sym_acronym_reference] = STATE(232),
    [sym_theorem_definition] = STATE(232),
    [sym_color_definition] = STATE(232),
    [sym_color_set_definition] = STATE(232),
    [sym_color_reference] = STATE(232),
    [sym_tikz_library_import] = STATE(232),
    [sym_text_mode] = STATE(232),
    [sym_hyperlink] = STATE(232),
    [aux_sym__section_repeat2] = STATE(852),
    [aux_sym__section_repeat3] = STATE(853),
    [aux_sym__section_repeat4] = STATE(854),
    [aux_sym__section_repeat5] = STATE(855),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(232),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [159] = {
    [sym_block_comment] = STATE(155),
    [sym__flat_content] = STATE(155),
    [sym__text_with_env_content] = STATE(155),
    [sym__text_content] = STATE(155),
    [sym__paragraph] = STATE(337),
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(774),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(781),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(783),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(789),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(155),
    [sym_text] = STATE(155),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(155),
    [sym_inline_formula] = STATE(155),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(155),
    [sym_comment_environment] = STATE(155),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(155),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(155),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(155),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(155),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(155),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(155),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(155),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(155),
    [sym_generic_command] = STATE(155),
    [sym_title_declaration] = STATE(155),
    [sym_author_declaration] = STATE(155),
    [sym_package_include] = STATE(155),
    [sym_class_include] = STATE(155),
    [sym_latex_include] = STATE(155),
    [sym_biblatex_include] = STATE(155),
    [sym_bibstyle_include] = STATE(155),
    [sym_bibtex_include] = STATE(155),
    [sym_graphics_include] = STATE(155),
    [sym_svg_include] = STATE(155),
    [sym_inkscape_include] = STATE(155),
    [sym_verbatim_include] = STATE(155),
    [sym_import_include] = STATE(155),
    [sym_caption] = STATE(155),
    [sym_citation] = STATE(155),
    [sym_label_definition] = STATE(155),
    [sym_label_reference] = STATE(155),
    [sym_label_reference_range] = STATE(155),
    [sym_label_number] = STATE(155),
    [sym_new_command_definition] = STATE(155),
    [sym_old_command_definition] = STATE(155),
    [sym_let_command_definition] = STATE(155),
    [sym_math_delimiter] = STATE(155),
    [sym_paired_delimiter_definition] = STATE(155),
    [sym_environment_definition] = STATE(155),
    [sym_glossary_entry_definition] = STATE(155),
    [sym_glossary_entry_reference] = STATE(155),
    [sym_acronym_definition] = STATE(155),
    [sym_acronym_reference] = STATE(155),
    [sym_theorem_definition] = STATE(155),
    [sym_color_definition] = STATE(155),
    [sym_color_set_definition] = STATE(155),
    [sym_color_reference] = STATE(155),
    [sym_tikz_library_import] = STATE(155),
    [sym_text_mode] = STATE(155),
    [sym_hyperlink] = STATE(155),
    [aux_sym__section_repeat2] = STATE(774),
    [aux_sym__section_repeat3] = STATE(781),
    [aux_sym__section_repeat4] = STATE(783),
    [aux_sym__section_repeat5] = STATE(789),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(155),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2168),
    [anon_sym_RBRACK] = ACTIONS(2168),
    [anon_sym_COMMA] = ACTIONS(2168),
    [anon_sym_EQ] = ACTIONS(2168),
    [anon_sym_LPAREN] = ACTIONS(2168),
    [anon_sym_RPAREN] = ACTIONS(2168),
    [anon_sym_BSLASHpart] = ACTIONS(2138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHaddpart] = ACTIONS(2138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2140),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2138),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [160] = {
    [sym_block_comment] = STATE(161),
    [sym__flat_content] = STATE(161),
    [sym__text_with_env_content] = STATE(161),
    [sym__text_content] = STATE(161),
    [sym__paragraph] = STATE(341),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(509),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(510),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(526),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(161),
    [sym_text] = STATE(161),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(161),
    [sym_inline_formula] = STATE(161),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(161),
    [sym_comment_environment] = STATE(161),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(161),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(161),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(161),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(161),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(161),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(161),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(161),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(161),
    [sym_generic_command] = STATE(161),
    [sym_title_declaration] = STATE(161),
    [sym_author_declaration] = STATE(161),
    [sym_package_include] = STATE(161),
    [sym_class_include] = STATE(161),
    [sym_latex_include] = STATE(161),
    [sym_biblatex_include] = STATE(161),
    [sym_bibstyle_include] = STATE(161),
    [sym_bibtex_include] = STATE(161),
    [sym_graphics_include] = STATE(161),
    [sym_svg_include] = STATE(161),
    [sym_inkscape_include] = STATE(161),
    [sym_verbatim_include] = STATE(161),
    [sym_import_include] = STATE(161),
    [sym_caption] = STATE(161),
    [sym_citation] = STATE(161),
    [sym_label_definition] = STATE(161),
    [sym_label_reference] = STATE(161),
    [sym_label_reference_range] = STATE(161),
    [sym_label_number] = STATE(161),
    [sym_new_command_definition] = STATE(161),
    [sym_old_command_definition] = STATE(161),
    [sym_let_command_definition] = STATE(161),
    [sym_math_delimiter] = STATE(161),
    [sym_paired_delimiter_definition] = STATE(161),
    [sym_environment_definition] = STATE(161),
    [sym_glossary_entry_definition] = STATE(161),
    [sym_glossary_entry_reference] = STATE(161),
    [sym_acronym_definition] = STATE(161),
    [sym_acronym_reference] = STATE(161),
    [sym_theorem_definition] = STATE(161),
    [sym_color_definition] = STATE(161),
    [sym_color_set_definition] = STATE(161),
    [sym_color_reference] = STATE(161),
    [sym_tikz_library_import] = STATE(161),
    [sym_text_mode] = STATE(161),
    [sym_hyperlink] = STATE(161),
    [aux_sym__section_repeat3] = STATE(509),
    [aux_sym__section_repeat4] = STATE(510),
    [aux_sym__section_repeat5] = STATE(526),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(161),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2152),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_RBRACK] = ACTIONS(2170),
    [anon_sym_COMMA] = ACTIONS(2170),
    [anon_sym_EQ] = ACTIONS(2170),
    [anon_sym_LPAREN] = ACTIONS(2170),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_BSLASHpart] = ACTIONS(2150),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddpart] = ACTIONS(2150),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHchapter] = ACTIONS(2150),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddchap] = ACTIONS(2150),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2152),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [161] = {
    [sym_block_comment] = STATE(221),
    [sym__flat_content] = STATE(221),
    [sym__text_with_env_content] = STATE(221),
    [sym__text_content] = STATE(221),
    [sym__paragraph] = STATE(339),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(452),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(576),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(524),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(221),
    [sym_text] = STATE(221),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(221),
    [sym_inline_formula] = STATE(221),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(221),
    [sym_comment_environment] = STATE(221),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(221),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(221),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(221),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(221),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(221),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(221),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(221),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(221),
    [sym_generic_command] = STATE(221),
    [sym_title_declaration] = STATE(221),
    [sym_author_declaration] = STATE(221),
    [sym_package_include] = STATE(221),
    [sym_class_include] = STATE(221),
    [sym_latex_include] = STATE(221),
    [sym_biblatex_include] = STATE(221),
    [sym_bibstyle_include] = STATE(221),
    [sym_bibtex_include] = STATE(221),
    [sym_graphics_include] = STATE(221),
    [sym_svg_include] = STATE(221),
    [sym_inkscape_include] = STATE(221),
    [sym_verbatim_include] = STATE(221),
    [sym_import_include] = STATE(221),
    [sym_caption] = STATE(221),
    [sym_citation] = STATE(221),
    [sym_label_definition] = STATE(221),
    [sym_label_reference] = STATE(221),
    [sym_label_reference_range] = STATE(221),
    [sym_label_number] = STATE(221),
    [sym_new_command_definition] = STATE(221),
    [sym_old_command_definition] = STATE(221),
    [sym_let_command_definition] = STATE(221),
    [sym_math_delimiter] = STATE(221),
    [sym_paired_delimiter_definition] = STATE(221),
    [sym_environment_definition] = STATE(221),
    [sym_glossary_entry_definition] = STATE(221),
    [sym_glossary_entry_reference] = STATE(221),
    [sym_acronym_definition] = STATE(221),
    [sym_acronym_reference] = STATE(221),
    [sym_theorem_definition] = STATE(221),
    [sym_color_definition] = STATE(221),
    [sym_color_set_definition] = STATE(221),
    [sym_color_reference] = STATE(221),
    [sym_tikz_library_import] = STATE(221),
    [sym_text_mode] = STATE(221),
    [sym_hyperlink] = STATE(221),
    [aux_sym__section_repeat3] = STATE(452),
    [aux_sym__section_repeat4] = STATE(576),
    [aux_sym__section_repeat5] = STATE(524),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(221),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_RBRACK] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [162] = {
    [sym_block_comment] = STATE(211),
    [sym__flat_content] = STATE(211),
    [sym__text_with_env_content] = STATE(211),
    [sym__text_content] = STATE(211),
    [sym__paragraph] = STATE(338),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(395),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(396),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(211),
    [sym_text] = STATE(211),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(211),
    [sym_inline_formula] = STATE(211),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(211),
    [sym_comment_environment] = STATE(211),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(211),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(211),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(211),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(211),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(211),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(211),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(211),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(211),
    [sym_generic_command] = STATE(211),
    [sym_title_declaration] = STATE(211),
    [sym_author_declaration] = STATE(211),
    [sym_package_include] = STATE(211),
    [sym_class_include] = STATE(211),
    [sym_latex_include] = STATE(211),
    [sym_biblatex_include] = STATE(211),
    [sym_bibstyle_include] = STATE(211),
    [sym_bibtex_include] = STATE(211),
    [sym_graphics_include] = STATE(211),
    [sym_svg_include] = STATE(211),
    [sym_inkscape_include] = STATE(211),
    [sym_verbatim_include] = STATE(211),
    [sym_import_include] = STATE(211),
    [sym_caption] = STATE(211),
    [sym_citation] = STATE(211),
    [sym_label_definition] = STATE(211),
    [sym_label_reference] = STATE(211),
    [sym_label_reference_range] = STATE(211),
    [sym_label_number] = STATE(211),
    [sym_new_command_definition] = STATE(211),
    [sym_old_command_definition] = STATE(211),
    [sym_let_command_definition] = STATE(211),
    [sym_math_delimiter] = STATE(211),
    [sym_paired_delimiter_definition] = STATE(211),
    [sym_environment_definition] = STATE(211),
    [sym_glossary_entry_definition] = STATE(211),
    [sym_glossary_entry_reference] = STATE(211),
    [sym_acronym_definition] = STATE(211),
    [sym_acronym_reference] = STATE(211),
    [sym_theorem_definition] = STATE(211),
    [sym_color_definition] = STATE(211),
    [sym_color_set_definition] = STATE(211),
    [sym_color_reference] = STATE(211),
    [sym_tikz_library_import] = STATE(211),
    [sym_text_mode] = STATE(211),
    [sym_hyperlink] = STATE(211),
    [aux_sym__section_repeat4] = STATE(395),
    [aux_sym__section_repeat5] = STATE(396),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(211),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_RBRACK] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2172),
    [anon_sym_BSLASHbigr] = ACTIONS(2172),
    [anon_sym_BSLASHBigr] = ACTIONS(2172),
    [anon_sym_BSLASHbiggr] = ACTIONS(2172),
    [anon_sym_BSLASHBiggr] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [163] = {
    [sym_block_comment] = STATE(162),
    [sym__flat_content] = STATE(162),
    [sym__text_with_env_content] = STATE(162),
    [sym__text_content] = STATE(162),
    [sym__paragraph] = STATE(340),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(358),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(359),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(162),
    [sym_text] = STATE(162),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(162),
    [sym_inline_formula] = STATE(162),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(162),
    [sym_comment_environment] = STATE(162),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(162),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(162),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(162),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(162),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(162),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(162),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(162),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(162),
    [sym_generic_command] = STATE(162),
    [sym_title_declaration] = STATE(162),
    [sym_author_declaration] = STATE(162),
    [sym_package_include] = STATE(162),
    [sym_class_include] = STATE(162),
    [sym_latex_include] = STATE(162),
    [sym_biblatex_include] = STATE(162),
    [sym_bibstyle_include] = STATE(162),
    [sym_bibtex_include] = STATE(162),
    [sym_graphics_include] = STATE(162),
    [sym_svg_include] = STATE(162),
    [sym_inkscape_include] = STATE(162),
    [sym_verbatim_include] = STATE(162),
    [sym_import_include] = STATE(162),
    [sym_caption] = STATE(162),
    [sym_citation] = STATE(162),
    [sym_label_definition] = STATE(162),
    [sym_label_reference] = STATE(162),
    [sym_label_reference_range] = STATE(162),
    [sym_label_number] = STATE(162),
    [sym_new_command_definition] = STATE(162),
    [sym_old_command_definition] = STATE(162),
    [sym_let_command_definition] = STATE(162),
    [sym_math_delimiter] = STATE(162),
    [sym_paired_delimiter_definition] = STATE(162),
    [sym_environment_definition] = STATE(162),
    [sym_glossary_entry_definition] = STATE(162),
    [sym_glossary_entry_reference] = STATE(162),
    [sym_acronym_definition] = STATE(162),
    [sym_acronym_reference] = STATE(162),
    [sym_theorem_definition] = STATE(162),
    [sym_color_definition] = STATE(162),
    [sym_color_set_definition] = STATE(162),
    [sym_color_reference] = STATE(162),
    [sym_tikz_library_import] = STATE(162),
    [sym_text_mode] = STATE(162),
    [sym_hyperlink] = STATE(162),
    [aux_sym__section_repeat4] = STATE(358),
    [aux_sym__section_repeat5] = STATE(359),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(162),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2176),
    [anon_sym_RBRACK] = ACTIONS(2176),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_EQ] = ACTIONS(2176),
    [anon_sym_LPAREN] = ACTIONS(2176),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [anon_sym_BSLASHpart] = ACTIONS(2178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddpart] = ACTIONS(2178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHchapter] = ACTIONS(2178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddchap] = ACTIONS(2178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsection] = ACTIONS(2178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddsec] = ACTIONS(2178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2178),
    [anon_sym_BSLASHbigr] = ACTIONS(2178),
    [anon_sym_BSLASHBigr] = ACTIONS(2178),
    [anon_sym_BSLASHbiggr] = ACTIONS(2178),
    [anon_sym_BSLASHBiggr] = ACTIONS(2178),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [164] = {
    [sym_block_comment] = STATE(228),
    [sym__flat_content] = STATE(228),
    [sym__text_with_env_content] = STATE(228),
    [sym__text_content] = STATE(228),
    [sym__paragraph] = STATE(344),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(768),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(766),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(765),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(228),
    [sym_text] = STATE(228),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(228),
    [sym_inline_formula] = STATE(228),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(228),
    [sym_comment_environment] = STATE(228),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(228),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(228),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(228),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(228),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(228),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(228),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(228),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(228),
    [sym_generic_command] = STATE(228),
    [sym_title_declaration] = STATE(228),
    [sym_author_declaration] = STATE(228),
    [sym_package_include] = STATE(228),
    [sym_class_include] = STATE(228),
    [sym_latex_include] = STATE(228),
    [sym_biblatex_include] = STATE(228),
    [sym_bibstyle_include] = STATE(228),
    [sym_bibtex_include] = STATE(228),
    [sym_graphics_include] = STATE(228),
    [sym_svg_include] = STATE(228),
    [sym_inkscape_include] = STATE(228),
    [sym_verbatim_include] = STATE(228),
    [sym_import_include] = STATE(228),
    [sym_caption] = STATE(228),
    [sym_citation] = STATE(228),
    [sym_label_definition] = STATE(228),
    [sym_label_reference] = STATE(228),
    [sym_label_reference_range] = STATE(228),
    [sym_label_number] = STATE(228),
    [sym_new_command_definition] = STATE(228),
    [sym_old_command_definition] = STATE(228),
    [sym_let_command_definition] = STATE(228),
    [sym_math_delimiter] = STATE(228),
    [sym_paired_delimiter_definition] = STATE(228),
    [sym_environment_definition] = STATE(228),
    [sym_glossary_entry_definition] = STATE(228),
    [sym_glossary_entry_reference] = STATE(228),
    [sym_acronym_definition] = STATE(228),
    [sym_acronym_reference] = STATE(228),
    [sym_theorem_definition] = STATE(228),
    [sym_color_definition] = STATE(228),
    [sym_color_set_definition] = STATE(228),
    [sym_color_reference] = STATE(228),
    [sym_tikz_library_import] = STATE(228),
    [sym_text_mode] = STATE(228),
    [sym_hyperlink] = STATE(228),
    [aux_sym__section_repeat3] = STATE(768),
    [aux_sym__section_repeat4] = STATE(766),
    [aux_sym__section_repeat5] = STATE(765),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(228),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [165] = {
    [sym_block_comment] = STATE(168),
    [sym__flat_content] = STATE(168),
    [sym__text_with_env_content] = STATE(168),
    [sym__text_content] = STATE(168),
    [sym__paragraph] = STATE(343),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(808),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(809),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(810),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(168),
    [sym_text] = STATE(168),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(168),
    [sym_inline_formula] = STATE(168),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(168),
    [sym_comment_environment] = STATE(168),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(168),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(168),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(168),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(168),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(168),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(168),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(168),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(168),
    [sym_generic_command] = STATE(168),
    [sym_title_declaration] = STATE(168),
    [sym_author_declaration] = STATE(168),
    [sym_package_include] = STATE(168),
    [sym_class_include] = STATE(168),
    [sym_latex_include] = STATE(168),
    [sym_biblatex_include] = STATE(168),
    [sym_bibstyle_include] = STATE(168),
    [sym_bibtex_include] = STATE(168),
    [sym_graphics_include] = STATE(168),
    [sym_svg_include] = STATE(168),
    [sym_inkscape_include] = STATE(168),
    [sym_verbatim_include] = STATE(168),
    [sym_import_include] = STATE(168),
    [sym_caption] = STATE(168),
    [sym_citation] = STATE(168),
    [sym_label_definition] = STATE(168),
    [sym_label_reference] = STATE(168),
    [sym_label_reference_range] = STATE(168),
    [sym_label_number] = STATE(168),
    [sym_new_command_definition] = STATE(168),
    [sym_old_command_definition] = STATE(168),
    [sym_let_command_definition] = STATE(168),
    [sym_math_delimiter] = STATE(168),
    [sym_paired_delimiter_definition] = STATE(168),
    [sym_environment_definition] = STATE(168),
    [sym_glossary_entry_definition] = STATE(168),
    [sym_glossary_entry_reference] = STATE(168),
    [sym_acronym_definition] = STATE(168),
    [sym_acronym_reference] = STATE(168),
    [sym_theorem_definition] = STATE(168),
    [sym_color_definition] = STATE(168),
    [sym_color_set_definition] = STATE(168),
    [sym_color_reference] = STATE(168),
    [sym_tikz_library_import] = STATE(168),
    [sym_text_mode] = STATE(168),
    [sym_hyperlink] = STATE(168),
    [aux_sym__section_repeat3] = STATE(808),
    [aux_sym__section_repeat4] = STATE(809),
    [aux_sym__section_repeat5] = STATE(810),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(168),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_RBRACK] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2182),
    [anon_sym_EQ] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_RPAREN] = ACTIONS(2182),
    [anon_sym_BSLASHpart] = ACTIONS(2150),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddpart] = ACTIONS(2150),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHchapter] = ACTIONS(2150),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddchap] = ACTIONS(2150),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2152),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [166] = {
    [sym_block_comment] = STATE(231),
    [sym__flat_content] = STATE(231),
    [sym__text_with_env_content] = STATE(231),
    [sym__text_content] = STATE(231),
    [sym__paragraph] = STATE(345),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(681),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(682),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(683),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(231),
    [sym_text] = STATE(231),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(231),
    [sym_inline_formula] = STATE(231),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(231),
    [sym_comment_environment] = STATE(231),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(231),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(231),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(231),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(231),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(231),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(231),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(231),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(231),
    [sym_generic_command] = STATE(231),
    [sym_title_declaration] = STATE(231),
    [sym_author_declaration] = STATE(231),
    [sym_package_include] = STATE(231),
    [sym_class_include] = STATE(231),
    [sym_latex_include] = STATE(231),
    [sym_biblatex_include] = STATE(231),
    [sym_bibstyle_include] = STATE(231),
    [sym_bibtex_include] = STATE(231),
    [sym_graphics_include] = STATE(231),
    [sym_svg_include] = STATE(231),
    [sym_inkscape_include] = STATE(231),
    [sym_verbatim_include] = STATE(231),
    [sym_import_include] = STATE(231),
    [sym_caption] = STATE(231),
    [sym_citation] = STATE(231),
    [sym_label_definition] = STATE(231),
    [sym_label_reference] = STATE(231),
    [sym_label_reference_range] = STATE(231),
    [sym_label_number] = STATE(231),
    [sym_new_command_definition] = STATE(231),
    [sym_old_command_definition] = STATE(231),
    [sym_let_command_definition] = STATE(231),
    [sym_math_delimiter] = STATE(231),
    [sym_paired_delimiter_definition] = STATE(231),
    [sym_environment_definition] = STATE(231),
    [sym_glossary_entry_definition] = STATE(231),
    [sym_glossary_entry_reference] = STATE(231),
    [sym_acronym_definition] = STATE(231),
    [sym_acronym_reference] = STATE(231),
    [sym_theorem_definition] = STATE(231),
    [sym_color_definition] = STATE(231),
    [sym_color_set_definition] = STATE(231),
    [sym_color_reference] = STATE(231),
    [sym_tikz_library_import] = STATE(231),
    [sym_text_mode] = STATE(231),
    [sym_hyperlink] = STATE(231),
    [aux_sym__section_repeat3] = STATE(681),
    [aux_sym__section_repeat4] = STATE(682),
    [aux_sym__section_repeat5] = STATE(683),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(231),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_RBRACK] = ACTIONS(2156),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_EQ] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [167] = {
    [sym_block_comment] = STATE(166),
    [sym__flat_content] = STATE(166),
    [sym__text_with_env_content] = STATE(166),
    [sym__text_content] = STATE(166),
    [sym__paragraph] = STATE(347),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(748),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(747),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(746),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(166),
    [sym_text] = STATE(166),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(166),
    [sym_inline_formula] = STATE(166),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(166),
    [sym_comment_environment] = STATE(166),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(166),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(166),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(166),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(166),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(166),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(166),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(166),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(166),
    [sym_generic_command] = STATE(166),
    [sym_title_declaration] = STATE(166),
    [sym_author_declaration] = STATE(166),
    [sym_package_include] = STATE(166),
    [sym_class_include] = STATE(166),
    [sym_latex_include] = STATE(166),
    [sym_biblatex_include] = STATE(166),
    [sym_bibstyle_include] = STATE(166),
    [sym_bibtex_include] = STATE(166),
    [sym_graphics_include] = STATE(166),
    [sym_svg_include] = STATE(166),
    [sym_inkscape_include] = STATE(166),
    [sym_verbatim_include] = STATE(166),
    [sym_import_include] = STATE(166),
    [sym_caption] = STATE(166),
    [sym_citation] = STATE(166),
    [sym_label_definition] = STATE(166),
    [sym_label_reference] = STATE(166),
    [sym_label_reference_range] = STATE(166),
    [sym_label_number] = STATE(166),
    [sym_new_command_definition] = STATE(166),
    [sym_old_command_definition] = STATE(166),
    [sym_let_command_definition] = STATE(166),
    [sym_math_delimiter] = STATE(166),
    [sym_paired_delimiter_definition] = STATE(166),
    [sym_environment_definition] = STATE(166),
    [sym_glossary_entry_definition] = STATE(166),
    [sym_glossary_entry_reference] = STATE(166),
    [sym_acronym_definition] = STATE(166),
    [sym_acronym_reference] = STATE(166),
    [sym_theorem_definition] = STATE(166),
    [sym_color_definition] = STATE(166),
    [sym_color_set_definition] = STATE(166),
    [sym_color_reference] = STATE(166),
    [sym_tikz_library_import] = STATE(166),
    [sym_text_mode] = STATE(166),
    [sym_hyperlink] = STATE(166),
    [aux_sym__section_repeat3] = STATE(748),
    [aux_sym__section_repeat4] = STATE(747),
    [aux_sym__section_repeat5] = STATE(746),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(166),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2184),
    [anon_sym_RBRACK] = ACTIONS(2184),
    [anon_sym_COMMA] = ACTIONS(2184),
    [anon_sym_EQ] = ACTIONS(2184),
    [anon_sym_LPAREN] = ACTIONS(2184),
    [anon_sym_RPAREN] = ACTIONS(2184),
    [anon_sym_BSLASHpart] = ACTIONS(2150),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddpart] = ACTIONS(2150),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHchapter] = ACTIONS(2150),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddchap] = ACTIONS(2150),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2152),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [168] = {
    [sym_block_comment] = STATE(232),
    [sym__flat_content] = STATE(232),
    [sym__text_with_env_content] = STATE(232),
    [sym__text_content] = STATE(232),
    [sym__paragraph] = STATE(342),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(859),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(860),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(861),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(232),
    [sym_text] = STATE(232),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(232),
    [sym_inline_formula] = STATE(232),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(232),
    [sym_comment_environment] = STATE(232),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(232),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(232),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(232),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(232),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(232),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(232),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(232),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(232),
    [sym_generic_command] = STATE(232),
    [sym_title_declaration] = STATE(232),
    [sym_author_declaration] = STATE(232),
    [sym_package_include] = STATE(232),
    [sym_class_include] = STATE(232),
    [sym_latex_include] = STATE(232),
    [sym_biblatex_include] = STATE(232),
    [sym_bibstyle_include] = STATE(232),
    [sym_bibtex_include] = STATE(232),
    [sym_graphics_include] = STATE(232),
    [sym_svg_include] = STATE(232),
    [sym_inkscape_include] = STATE(232),
    [sym_verbatim_include] = STATE(232),
    [sym_import_include] = STATE(232),
    [sym_caption] = STATE(232),
    [sym_citation] = STATE(232),
    [sym_label_definition] = STATE(232),
    [sym_label_reference] = STATE(232),
    [sym_label_reference_range] = STATE(232),
    [sym_label_number] = STATE(232),
    [sym_new_command_definition] = STATE(232),
    [sym_old_command_definition] = STATE(232),
    [sym_let_command_definition] = STATE(232),
    [sym_math_delimiter] = STATE(232),
    [sym_paired_delimiter_definition] = STATE(232),
    [sym_environment_definition] = STATE(232),
    [sym_glossary_entry_definition] = STATE(232),
    [sym_glossary_entry_reference] = STATE(232),
    [sym_acronym_definition] = STATE(232),
    [sym_acronym_reference] = STATE(232),
    [sym_theorem_definition] = STATE(232),
    [sym_color_definition] = STATE(232),
    [sym_color_set_definition] = STATE(232),
    [sym_color_reference] = STATE(232),
    [sym_tikz_library_import] = STATE(232),
    [sym_text_mode] = STATE(232),
    [sym_hyperlink] = STATE(232),
    [aux_sym__section_repeat3] = STATE(859),
    [aux_sym__section_repeat4] = STATE(860),
    [aux_sym__section_repeat5] = STATE(861),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(232),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [169] = {
    [sym_block_comment] = STATE(164),
    [sym__flat_content] = STATE(164),
    [sym__text_with_env_content] = STATE(164),
    [sym__text_content] = STATE(164),
    [sym__paragraph] = STATE(346),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(795),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(798),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(799),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(164),
    [sym_text] = STATE(164),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(164),
    [sym_inline_formula] = STATE(164),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(164),
    [sym_comment_environment] = STATE(164),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(164),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(164),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(164),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(164),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(164),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(164),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(164),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(164),
    [sym_generic_command] = STATE(164),
    [sym_title_declaration] = STATE(164),
    [sym_author_declaration] = STATE(164),
    [sym_package_include] = STATE(164),
    [sym_class_include] = STATE(164),
    [sym_latex_include] = STATE(164),
    [sym_biblatex_include] = STATE(164),
    [sym_bibstyle_include] = STATE(164),
    [sym_bibtex_include] = STATE(164),
    [sym_graphics_include] = STATE(164),
    [sym_svg_include] = STATE(164),
    [sym_inkscape_include] = STATE(164),
    [sym_verbatim_include] = STATE(164),
    [sym_import_include] = STATE(164),
    [sym_caption] = STATE(164),
    [sym_citation] = STATE(164),
    [sym_label_definition] = STATE(164),
    [sym_label_reference] = STATE(164),
    [sym_label_reference_range] = STATE(164),
    [sym_label_number] = STATE(164),
    [sym_new_command_definition] = STATE(164),
    [sym_old_command_definition] = STATE(164),
    [sym_let_command_definition] = STATE(164),
    [sym_math_delimiter] = STATE(164),
    [sym_paired_delimiter_definition] = STATE(164),
    [sym_environment_definition] = STATE(164),
    [sym_glossary_entry_definition] = STATE(164),
    [sym_glossary_entry_reference] = STATE(164),
    [sym_acronym_definition] = STATE(164),
    [sym_acronym_reference] = STATE(164),
    [sym_theorem_definition] = STATE(164),
    [sym_color_definition] = STATE(164),
    [sym_color_set_definition] = STATE(164),
    [sym_color_reference] = STATE(164),
    [sym_tikz_library_import] = STATE(164),
    [sym_text_mode] = STATE(164),
    [sym_hyperlink] = STATE(164),
    [aux_sym__section_repeat3] = STATE(795),
    [aux_sym__section_repeat4] = STATE(798),
    [aux_sym__section_repeat5] = STATE(799),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(164),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2186),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_EQ] = ACTIONS(2186),
    [anon_sym_LPAREN] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_BSLASHpart] = ACTIONS(2150),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddpart] = ACTIONS(2150),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHchapter] = ACTIONS(2150),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHaddchap] = ACTIONS(2150),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2152),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2150),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [170] = {
    [sym_block_comment] = STATE(221),
    [sym__flat_content] = STATE(221),
    [sym__text_with_env_content] = STATE(221),
    [sym__text_content] = STATE(221),
    [sym__paragraph] = STATE(351),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(474),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(475),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(221),
    [sym_text] = STATE(221),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(221),
    [sym_inline_formula] = STATE(221),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(221),
    [sym_comment_environment] = STATE(221),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(221),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(221),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(221),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(221),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(221),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(221),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(221),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(221),
    [sym_generic_command] = STATE(221),
    [sym_title_declaration] = STATE(221),
    [sym_author_declaration] = STATE(221),
    [sym_package_include] = STATE(221),
    [sym_class_include] = STATE(221),
    [sym_latex_include] = STATE(221),
    [sym_biblatex_include] = STATE(221),
    [sym_bibstyle_include] = STATE(221),
    [sym_bibtex_include] = STATE(221),
    [sym_graphics_include] = STATE(221),
    [sym_svg_include] = STATE(221),
    [sym_inkscape_include] = STATE(221),
    [sym_verbatim_include] = STATE(221),
    [sym_import_include] = STATE(221),
    [sym_caption] = STATE(221),
    [sym_citation] = STATE(221),
    [sym_label_definition] = STATE(221),
    [sym_label_reference] = STATE(221),
    [sym_label_reference_range] = STATE(221),
    [sym_label_number] = STATE(221),
    [sym_new_command_definition] = STATE(221),
    [sym_old_command_definition] = STATE(221),
    [sym_let_command_definition] = STATE(221),
    [sym_math_delimiter] = STATE(221),
    [sym_paired_delimiter_definition] = STATE(221),
    [sym_environment_definition] = STATE(221),
    [sym_glossary_entry_definition] = STATE(221),
    [sym_glossary_entry_reference] = STATE(221),
    [sym_acronym_definition] = STATE(221),
    [sym_acronym_reference] = STATE(221),
    [sym_theorem_definition] = STATE(221),
    [sym_color_definition] = STATE(221),
    [sym_color_set_definition] = STATE(221),
    [sym_color_reference] = STATE(221),
    [sym_tikz_library_import] = STATE(221),
    [sym_text_mode] = STATE(221),
    [sym_hyperlink] = STATE(221),
    [aux_sym__section_repeat4] = STATE(474),
    [aux_sym__section_repeat5] = STATE(475),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(221),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_RBRACK] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [171] = {
    [sym_block_comment] = STATE(170),
    [sym__flat_content] = STATE(170),
    [sym__text_with_env_content] = STATE(170),
    [sym__text_content] = STATE(170),
    [sym__paragraph] = STATE(386),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(557),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(558),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(170),
    [sym_text] = STATE(170),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(170),
    [sym_inline_formula] = STATE(170),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(170),
    [sym_comment_environment] = STATE(170),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(170),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(170),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(170),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(170),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(170),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(170),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(170),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(170),
    [sym_generic_command] = STATE(170),
    [sym_title_declaration] = STATE(170),
    [sym_author_declaration] = STATE(170),
    [sym_package_include] = STATE(170),
    [sym_class_include] = STATE(170),
    [sym_latex_include] = STATE(170),
    [sym_biblatex_include] = STATE(170),
    [sym_bibstyle_include] = STATE(170),
    [sym_bibtex_include] = STATE(170),
    [sym_graphics_include] = STATE(170),
    [sym_svg_include] = STATE(170),
    [sym_inkscape_include] = STATE(170),
    [sym_verbatim_include] = STATE(170),
    [sym_import_include] = STATE(170),
    [sym_caption] = STATE(170),
    [sym_citation] = STATE(170),
    [sym_label_definition] = STATE(170),
    [sym_label_reference] = STATE(170),
    [sym_label_reference_range] = STATE(170),
    [sym_label_number] = STATE(170),
    [sym_new_command_definition] = STATE(170),
    [sym_old_command_definition] = STATE(170),
    [sym_let_command_definition] = STATE(170),
    [sym_math_delimiter] = STATE(170),
    [sym_paired_delimiter_definition] = STATE(170),
    [sym_environment_definition] = STATE(170),
    [sym_glossary_entry_definition] = STATE(170),
    [sym_glossary_entry_reference] = STATE(170),
    [sym_acronym_definition] = STATE(170),
    [sym_acronym_reference] = STATE(170),
    [sym_theorem_definition] = STATE(170),
    [sym_color_definition] = STATE(170),
    [sym_color_set_definition] = STATE(170),
    [sym_color_reference] = STATE(170),
    [sym_tikz_library_import] = STATE(170),
    [sym_text_mode] = STATE(170),
    [sym_hyperlink] = STATE(170),
    [aux_sym__section_repeat4] = STATE(557),
    [aux_sym__section_repeat5] = STATE(558),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(170),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2180),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2188),
    [anon_sym_RBRACK] = ACTIONS(2188),
    [anon_sym_COMMA] = ACTIONS(2188),
    [anon_sym_EQ] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2188),
    [anon_sym_RPAREN] = ACTIONS(2188),
    [anon_sym_BSLASHpart] = ACTIONS(2178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddpart] = ACTIONS(2178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHchapter] = ACTIONS(2178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddchap] = ACTIONS(2178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsection] = ACTIONS(2178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddsec] = ACTIONS(2178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2180),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [172] = {
    [sym_block_comment] = STATE(211),
    [sym__flat_content] = STATE(211),
    [sym__text_with_env_content] = STATE(211),
    [sym__text_content] = STATE(211),
    [sym__paragraph] = STATE(398),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(399),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(211),
    [sym_text] = STATE(211),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(211),
    [sym_inline_formula] = STATE(211),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(211),
    [sym_comment_environment] = STATE(211),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(211),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(211),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(211),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(211),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(211),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(211),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(211),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(211),
    [sym_generic_command] = STATE(211),
    [sym_title_declaration] = STATE(211),
    [sym_author_declaration] = STATE(211),
    [sym_package_include] = STATE(211),
    [sym_class_include] = STATE(211),
    [sym_latex_include] = STATE(211),
    [sym_biblatex_include] = STATE(211),
    [sym_bibstyle_include] = STATE(211),
    [sym_bibtex_include] = STATE(211),
    [sym_graphics_include] = STATE(211),
    [sym_svg_include] = STATE(211),
    [sym_inkscape_include] = STATE(211),
    [sym_verbatim_include] = STATE(211),
    [sym_import_include] = STATE(211),
    [sym_caption] = STATE(211),
    [sym_citation] = STATE(211),
    [sym_label_definition] = STATE(211),
    [sym_label_reference] = STATE(211),
    [sym_label_reference_range] = STATE(211),
    [sym_label_number] = STATE(211),
    [sym_new_command_definition] = STATE(211),
    [sym_old_command_definition] = STATE(211),
    [sym_let_command_definition] = STATE(211),
    [sym_math_delimiter] = STATE(211),
    [sym_paired_delimiter_definition] = STATE(211),
    [sym_environment_definition] = STATE(211),
    [sym_glossary_entry_definition] = STATE(211),
    [sym_glossary_entry_reference] = STATE(211),
    [sym_acronym_definition] = STATE(211),
    [sym_acronym_reference] = STATE(211),
    [sym_theorem_definition] = STATE(211),
    [sym_color_definition] = STATE(211),
    [sym_color_set_definition] = STATE(211),
    [sym_color_reference] = STATE(211),
    [sym_tikz_library_import] = STATE(211),
    [sym_text_mode] = STATE(211),
    [sym_hyperlink] = STATE(211),
    [aux_sym__section_repeat5] = STATE(399),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(211),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_RBRACK] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2190),
    [anon_sym_BSLASHbigr] = ACTIONS(2190),
    [anon_sym_BSLASHBigr] = ACTIONS(2190),
    [anon_sym_BSLASHbiggr] = ACTIONS(2190),
    [anon_sym_BSLASHBiggr] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [173] = {
    [sym_block_comment] = STATE(172),
    [sym__flat_content] = STATE(172),
    [sym__text_with_env_content] = STATE(172),
    [sym__text_content] = STATE(172),
    [sym__paragraph] = STATE(360),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(361),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(172),
    [sym_text] = STATE(172),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(172),
    [sym_inline_formula] = STATE(172),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(172),
    [sym_comment_environment] = STATE(172),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(172),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(172),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(172),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(172),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(172),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(172),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(172),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(172),
    [sym_generic_command] = STATE(172),
    [sym_title_declaration] = STATE(172),
    [sym_author_declaration] = STATE(172),
    [sym_package_include] = STATE(172),
    [sym_class_include] = STATE(172),
    [sym_latex_include] = STATE(172),
    [sym_biblatex_include] = STATE(172),
    [sym_bibstyle_include] = STATE(172),
    [sym_bibtex_include] = STATE(172),
    [sym_graphics_include] = STATE(172),
    [sym_svg_include] = STATE(172),
    [sym_inkscape_include] = STATE(172),
    [sym_verbatim_include] = STATE(172),
    [sym_import_include] = STATE(172),
    [sym_caption] = STATE(172),
    [sym_citation] = STATE(172),
    [sym_label_definition] = STATE(172),
    [sym_label_reference] = STATE(172),
    [sym_label_reference_range] = STATE(172),
    [sym_label_number] = STATE(172),
    [sym_new_command_definition] = STATE(172),
    [sym_old_command_definition] = STATE(172),
    [sym_let_command_definition] = STATE(172),
    [sym_math_delimiter] = STATE(172),
    [sym_paired_delimiter_definition] = STATE(172),
    [sym_environment_definition] = STATE(172),
    [sym_glossary_entry_definition] = STATE(172),
    [sym_glossary_entry_reference] = STATE(172),
    [sym_acronym_definition] = STATE(172),
    [sym_acronym_reference] = STATE(172),
    [sym_theorem_definition] = STATE(172),
    [sym_color_definition] = STATE(172),
    [sym_color_set_definition] = STATE(172),
    [sym_color_reference] = STATE(172),
    [sym_tikz_library_import] = STATE(172),
    [sym_text_mode] = STATE(172),
    [sym_hyperlink] = STATE(172),
    [aux_sym__section_repeat5] = STATE(361),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(172),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_RBRACK] = ACTIONS(2194),
    [anon_sym_COMMA] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_RPAREN] = ACTIONS(2194),
    [anon_sym_BSLASHpart] = ACTIONS(2196),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddpart] = ACTIONS(2196),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHchapter] = ACTIONS(2196),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddchap] = ACTIONS(2196),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsection] = ACTIONS(2196),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddsec] = ACTIONS(2196),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsection] = ACTIONS(2196),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2196),
    [anon_sym_BSLASHbigr] = ACTIONS(2196),
    [anon_sym_BSLASHBigr] = ACTIONS(2196),
    [anon_sym_BSLASHbiggr] = ACTIONS(2196),
    [anon_sym_BSLASHBiggr] = ACTIONS(2196),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [174] = {
    [sym_block_comment] = STATE(231),
    [sym__flat_content] = STATE(231),
    [sym__text_with_env_content] = STATE(231),
    [sym__text_content] = STATE(231),
    [sym__paragraph] = STATE(425),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(686),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(687),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(231),
    [sym_text] = STATE(231),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(231),
    [sym_inline_formula] = STATE(231),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(231),
    [sym_comment_environment] = STATE(231),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(231),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(231),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(231),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(231),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(231),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(231),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(231),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(231),
    [sym_generic_command] = STATE(231),
    [sym_title_declaration] = STATE(231),
    [sym_author_declaration] = STATE(231),
    [sym_package_include] = STATE(231),
    [sym_class_include] = STATE(231),
    [sym_latex_include] = STATE(231),
    [sym_biblatex_include] = STATE(231),
    [sym_bibstyle_include] = STATE(231),
    [sym_bibtex_include] = STATE(231),
    [sym_graphics_include] = STATE(231),
    [sym_svg_include] = STATE(231),
    [sym_inkscape_include] = STATE(231),
    [sym_verbatim_include] = STATE(231),
    [sym_import_include] = STATE(231),
    [sym_caption] = STATE(231),
    [sym_citation] = STATE(231),
    [sym_label_definition] = STATE(231),
    [sym_label_reference] = STATE(231),
    [sym_label_reference_range] = STATE(231),
    [sym_label_number] = STATE(231),
    [sym_new_command_definition] = STATE(231),
    [sym_old_command_definition] = STATE(231),
    [sym_let_command_definition] = STATE(231),
    [sym_math_delimiter] = STATE(231),
    [sym_paired_delimiter_definition] = STATE(231),
    [sym_environment_definition] = STATE(231),
    [sym_glossary_entry_definition] = STATE(231),
    [sym_glossary_entry_reference] = STATE(231),
    [sym_acronym_definition] = STATE(231),
    [sym_acronym_reference] = STATE(231),
    [sym_theorem_definition] = STATE(231),
    [sym_color_definition] = STATE(231),
    [sym_color_set_definition] = STATE(231),
    [sym_color_reference] = STATE(231),
    [sym_tikz_library_import] = STATE(231),
    [sym_text_mode] = STATE(231),
    [sym_hyperlink] = STATE(231),
    [aux_sym__section_repeat4] = STATE(686),
    [aux_sym__section_repeat5] = STATE(687),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(231),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_RBRACK] = ACTIONS(2156),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_EQ] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [175] = {
    [sym_block_comment] = STATE(178),
    [sym__flat_content] = STATE(178),
    [sym__text_with_env_content] = STATE(178),
    [sym__text_content] = STATE(178),
    [sym__paragraph] = STATE(423),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(812),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(813),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(178),
    [sym_text] = STATE(178),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(178),
    [sym_inline_formula] = STATE(178),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(178),
    [sym_comment_environment] = STATE(178),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(178),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(178),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(178),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(178),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(178),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(178),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(178),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(178),
    [sym_generic_command] = STATE(178),
    [sym_title_declaration] = STATE(178),
    [sym_author_declaration] = STATE(178),
    [sym_package_include] = STATE(178),
    [sym_class_include] = STATE(178),
    [sym_latex_include] = STATE(178),
    [sym_biblatex_include] = STATE(178),
    [sym_bibstyle_include] = STATE(178),
    [sym_bibtex_include] = STATE(178),
    [sym_graphics_include] = STATE(178),
    [sym_svg_include] = STATE(178),
    [sym_inkscape_include] = STATE(178),
    [sym_verbatim_include] = STATE(178),
    [sym_import_include] = STATE(178),
    [sym_caption] = STATE(178),
    [sym_citation] = STATE(178),
    [sym_label_definition] = STATE(178),
    [sym_label_reference] = STATE(178),
    [sym_label_reference_range] = STATE(178),
    [sym_label_number] = STATE(178),
    [sym_new_command_definition] = STATE(178),
    [sym_old_command_definition] = STATE(178),
    [sym_let_command_definition] = STATE(178),
    [sym_math_delimiter] = STATE(178),
    [sym_paired_delimiter_definition] = STATE(178),
    [sym_environment_definition] = STATE(178),
    [sym_glossary_entry_definition] = STATE(178),
    [sym_glossary_entry_reference] = STATE(178),
    [sym_acronym_definition] = STATE(178),
    [sym_acronym_reference] = STATE(178),
    [sym_theorem_definition] = STATE(178),
    [sym_color_definition] = STATE(178),
    [sym_color_set_definition] = STATE(178),
    [sym_color_reference] = STATE(178),
    [sym_tikz_library_import] = STATE(178),
    [sym_text_mode] = STATE(178),
    [sym_hyperlink] = STATE(178),
    [aux_sym__section_repeat4] = STATE(812),
    [aux_sym__section_repeat5] = STATE(813),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(178),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [anon_sym_RBRACK] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_EQ] = ACTIONS(2200),
    [anon_sym_LPAREN] = ACTIONS(2200),
    [anon_sym_RPAREN] = ACTIONS(2200),
    [anon_sym_BSLASHpart] = ACTIONS(2178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddpart] = ACTIONS(2178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHchapter] = ACTIONS(2178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddchap] = ACTIONS(2178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsection] = ACTIONS(2178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddsec] = ACTIONS(2178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2180),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [176] = {
    [sym_block_comment] = STATE(228),
    [sym__flat_content] = STATE(228),
    [sym__text_with_env_content] = STATE(228),
    [sym__text_content] = STATE(228),
    [sym__paragraph] = STATE(429),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(732),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(727),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(228),
    [sym_text] = STATE(228),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(228),
    [sym_inline_formula] = STATE(228),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(228),
    [sym_comment_environment] = STATE(228),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(228),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(228),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(228),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(228),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(228),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(228),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(228),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(228),
    [sym_generic_command] = STATE(228),
    [sym_title_declaration] = STATE(228),
    [sym_author_declaration] = STATE(228),
    [sym_package_include] = STATE(228),
    [sym_class_include] = STATE(228),
    [sym_latex_include] = STATE(228),
    [sym_biblatex_include] = STATE(228),
    [sym_bibstyle_include] = STATE(228),
    [sym_bibtex_include] = STATE(228),
    [sym_graphics_include] = STATE(228),
    [sym_svg_include] = STATE(228),
    [sym_inkscape_include] = STATE(228),
    [sym_verbatim_include] = STATE(228),
    [sym_import_include] = STATE(228),
    [sym_caption] = STATE(228),
    [sym_citation] = STATE(228),
    [sym_label_definition] = STATE(228),
    [sym_label_reference] = STATE(228),
    [sym_label_reference_range] = STATE(228),
    [sym_label_number] = STATE(228),
    [sym_new_command_definition] = STATE(228),
    [sym_old_command_definition] = STATE(228),
    [sym_let_command_definition] = STATE(228),
    [sym_math_delimiter] = STATE(228),
    [sym_paired_delimiter_definition] = STATE(228),
    [sym_environment_definition] = STATE(228),
    [sym_glossary_entry_definition] = STATE(228),
    [sym_glossary_entry_reference] = STATE(228),
    [sym_acronym_definition] = STATE(228),
    [sym_acronym_reference] = STATE(228),
    [sym_theorem_definition] = STATE(228),
    [sym_color_definition] = STATE(228),
    [sym_color_set_definition] = STATE(228),
    [sym_color_reference] = STATE(228),
    [sym_tikz_library_import] = STATE(228),
    [sym_text_mode] = STATE(228),
    [sym_hyperlink] = STATE(228),
    [aux_sym__section_repeat4] = STATE(732),
    [aux_sym__section_repeat5] = STATE(727),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(228),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [177] = {
    [sym_block_comment] = STATE(174),
    [sym__flat_content] = STATE(174),
    [sym__text_with_env_content] = STATE(174),
    [sym__text_content] = STATE(174),
    [sym__paragraph] = STATE(428),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(744),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(743),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(174),
    [sym_text] = STATE(174),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(174),
    [sym_inline_formula] = STATE(174),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(174),
    [sym_comment_environment] = STATE(174),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(174),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(174),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(174),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(174),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(174),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(174),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(174),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(174),
    [sym_generic_command] = STATE(174),
    [sym_title_declaration] = STATE(174),
    [sym_author_declaration] = STATE(174),
    [sym_package_include] = STATE(174),
    [sym_class_include] = STATE(174),
    [sym_latex_include] = STATE(174),
    [sym_biblatex_include] = STATE(174),
    [sym_bibstyle_include] = STATE(174),
    [sym_bibtex_include] = STATE(174),
    [sym_graphics_include] = STATE(174),
    [sym_svg_include] = STATE(174),
    [sym_inkscape_include] = STATE(174),
    [sym_verbatim_include] = STATE(174),
    [sym_import_include] = STATE(174),
    [sym_caption] = STATE(174),
    [sym_citation] = STATE(174),
    [sym_label_definition] = STATE(174),
    [sym_label_reference] = STATE(174),
    [sym_label_reference_range] = STATE(174),
    [sym_label_number] = STATE(174),
    [sym_new_command_definition] = STATE(174),
    [sym_old_command_definition] = STATE(174),
    [sym_let_command_definition] = STATE(174),
    [sym_math_delimiter] = STATE(174),
    [sym_paired_delimiter_definition] = STATE(174),
    [sym_environment_definition] = STATE(174),
    [sym_glossary_entry_definition] = STATE(174),
    [sym_glossary_entry_reference] = STATE(174),
    [sym_acronym_definition] = STATE(174),
    [sym_acronym_reference] = STATE(174),
    [sym_theorem_definition] = STATE(174),
    [sym_color_definition] = STATE(174),
    [sym_color_set_definition] = STATE(174),
    [sym_color_reference] = STATE(174),
    [sym_tikz_library_import] = STATE(174),
    [sym_text_mode] = STATE(174),
    [sym_hyperlink] = STATE(174),
    [aux_sym__section_repeat4] = STATE(744),
    [aux_sym__section_repeat5] = STATE(743),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(174),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2202),
    [anon_sym_RBRACK] = ACTIONS(2202),
    [anon_sym_COMMA] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_LPAREN] = ACTIONS(2202),
    [anon_sym_RPAREN] = ACTIONS(2202),
    [anon_sym_BSLASHpart] = ACTIONS(2178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddpart] = ACTIONS(2178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHchapter] = ACTIONS(2178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddchap] = ACTIONS(2178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsection] = ACTIONS(2178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddsec] = ACTIONS(2178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2180),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [178] = {
    [sym_block_comment] = STATE(232),
    [sym__flat_content] = STATE(232),
    [sym__text_with_env_content] = STATE(232),
    [sym__text_content] = STATE(232),
    [sym__paragraph] = STATE(421),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(797),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(796),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(232),
    [sym_text] = STATE(232),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(232),
    [sym_inline_formula] = STATE(232),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(232),
    [sym_comment_environment] = STATE(232),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(232),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(232),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(232),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(232),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(232),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(232),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(232),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(232),
    [sym_generic_command] = STATE(232),
    [sym_title_declaration] = STATE(232),
    [sym_author_declaration] = STATE(232),
    [sym_package_include] = STATE(232),
    [sym_class_include] = STATE(232),
    [sym_latex_include] = STATE(232),
    [sym_biblatex_include] = STATE(232),
    [sym_bibstyle_include] = STATE(232),
    [sym_bibtex_include] = STATE(232),
    [sym_graphics_include] = STATE(232),
    [sym_svg_include] = STATE(232),
    [sym_inkscape_include] = STATE(232),
    [sym_verbatim_include] = STATE(232),
    [sym_import_include] = STATE(232),
    [sym_caption] = STATE(232),
    [sym_citation] = STATE(232),
    [sym_label_definition] = STATE(232),
    [sym_label_reference] = STATE(232),
    [sym_label_reference_range] = STATE(232),
    [sym_label_number] = STATE(232),
    [sym_new_command_definition] = STATE(232),
    [sym_old_command_definition] = STATE(232),
    [sym_let_command_definition] = STATE(232),
    [sym_math_delimiter] = STATE(232),
    [sym_paired_delimiter_definition] = STATE(232),
    [sym_environment_definition] = STATE(232),
    [sym_glossary_entry_definition] = STATE(232),
    [sym_glossary_entry_reference] = STATE(232),
    [sym_acronym_definition] = STATE(232),
    [sym_acronym_reference] = STATE(232),
    [sym_theorem_definition] = STATE(232),
    [sym_color_definition] = STATE(232),
    [sym_color_set_definition] = STATE(232),
    [sym_color_reference] = STATE(232),
    [sym_tikz_library_import] = STATE(232),
    [sym_text_mode] = STATE(232),
    [sym_hyperlink] = STATE(232),
    [aux_sym__section_repeat4] = STATE(797),
    [aux_sym__section_repeat5] = STATE(796),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(232),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [179] = {
    [sym_block_comment] = STATE(176),
    [sym__flat_content] = STATE(176),
    [sym__text_with_env_content] = STATE(176),
    [sym__text_content] = STATE(176),
    [sym__paragraph] = STATE(422),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(801),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(811),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(176),
    [sym_text] = STATE(176),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(176),
    [sym_inline_formula] = STATE(176),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(176),
    [sym_comment_environment] = STATE(176),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(176),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(176),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(176),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(176),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(176),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(176),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(176),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(176),
    [sym_generic_command] = STATE(176),
    [sym_title_declaration] = STATE(176),
    [sym_author_declaration] = STATE(176),
    [sym_package_include] = STATE(176),
    [sym_class_include] = STATE(176),
    [sym_latex_include] = STATE(176),
    [sym_biblatex_include] = STATE(176),
    [sym_bibstyle_include] = STATE(176),
    [sym_bibtex_include] = STATE(176),
    [sym_graphics_include] = STATE(176),
    [sym_svg_include] = STATE(176),
    [sym_inkscape_include] = STATE(176),
    [sym_verbatim_include] = STATE(176),
    [sym_import_include] = STATE(176),
    [sym_caption] = STATE(176),
    [sym_citation] = STATE(176),
    [sym_label_definition] = STATE(176),
    [sym_label_reference] = STATE(176),
    [sym_label_reference_range] = STATE(176),
    [sym_label_number] = STATE(176),
    [sym_new_command_definition] = STATE(176),
    [sym_old_command_definition] = STATE(176),
    [sym_let_command_definition] = STATE(176),
    [sym_math_delimiter] = STATE(176),
    [sym_paired_delimiter_definition] = STATE(176),
    [sym_environment_definition] = STATE(176),
    [sym_glossary_entry_definition] = STATE(176),
    [sym_glossary_entry_reference] = STATE(176),
    [sym_acronym_definition] = STATE(176),
    [sym_acronym_reference] = STATE(176),
    [sym_theorem_definition] = STATE(176),
    [sym_color_definition] = STATE(176),
    [sym_color_set_definition] = STATE(176),
    [sym_color_reference] = STATE(176),
    [sym_tikz_library_import] = STATE(176),
    [sym_text_mode] = STATE(176),
    [sym_hyperlink] = STATE(176),
    [aux_sym__section_repeat4] = STATE(801),
    [aux_sym__section_repeat5] = STATE(811),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(176),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2204),
    [anon_sym_RBRACK] = ACTIONS(2204),
    [anon_sym_COMMA] = ACTIONS(2204),
    [anon_sym_EQ] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2204),
    [anon_sym_RPAREN] = ACTIONS(2204),
    [anon_sym_BSLASHpart] = ACTIONS(2178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddpart] = ACTIONS(2178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHchapter] = ACTIONS(2178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddchap] = ACTIONS(2178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsection] = ACTIONS(2178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHaddsec] = ACTIONS(2178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2180),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2178),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [180] = {
    [sym_block_comment] = STATE(183),
    [sym__flat_content] = STATE(183),
    [sym__text_with_env_content] = STATE(183),
    [sym__text_content] = STATE(183),
    [sym__paragraph] = STATE(485),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(183),
    [sym_text] = STATE(183),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(183),
    [sym_inline_formula] = STATE(183),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(183),
    [sym_comment_environment] = STATE(183),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(183),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(183),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(183),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(183),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(183),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(183),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(183),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(183),
    [sym_generic_command] = STATE(183),
    [sym_title_declaration] = STATE(183),
    [sym_author_declaration] = STATE(183),
    [sym_package_include] = STATE(183),
    [sym_class_include] = STATE(183),
    [sym_latex_include] = STATE(183),
    [sym_biblatex_include] = STATE(183),
    [sym_bibstyle_include] = STATE(183),
    [sym_bibtex_include] = STATE(183),
    [sym_graphics_include] = STATE(183),
    [sym_svg_include] = STATE(183),
    [sym_inkscape_include] = STATE(183),
    [sym_verbatim_include] = STATE(183),
    [sym_import_include] = STATE(183),
    [sym_caption] = STATE(183),
    [sym_citation] = STATE(183),
    [sym_label_definition] = STATE(183),
    [sym_label_reference] = STATE(183),
    [sym_label_reference_range] = STATE(183),
    [sym_label_number] = STATE(183),
    [sym_new_command_definition] = STATE(183),
    [sym_old_command_definition] = STATE(183),
    [sym_let_command_definition] = STATE(183),
    [sym_math_delimiter] = STATE(183),
    [sym_paired_delimiter_definition] = STATE(183),
    [sym_environment_definition] = STATE(183),
    [sym_glossary_entry_definition] = STATE(183),
    [sym_glossary_entry_reference] = STATE(183),
    [sym_acronym_definition] = STATE(183),
    [sym_acronym_reference] = STATE(183),
    [sym_theorem_definition] = STATE(183),
    [sym_color_definition] = STATE(183),
    [sym_color_set_definition] = STATE(183),
    [sym_color_reference] = STATE(183),
    [sym_tikz_library_import] = STATE(183),
    [sym_text_mode] = STATE(183),
    [sym_hyperlink] = STATE(183),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(183),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_RBRACK] = ACTIONS(2206),
    [anon_sym_COMMA] = ACTIONS(2206),
    [anon_sym_EQ] = ACTIONS(2206),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_RPAREN] = ACTIONS(2206),
    [anon_sym_BSLASHpart] = ACTIONS(2208),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddpart] = ACTIONS(2208),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHchapter] = ACTIONS(2208),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddchap] = ACTIONS(2208),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsection] = ACTIONS(2208),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddsec] = ACTIONS(2208),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2208),
    [anon_sym_BSLASHbigr] = ACTIONS(2208),
    [anon_sym_BSLASHBigr] = ACTIONS(2208),
    [anon_sym_BSLASHbiggr] = ACTIONS(2208),
    [anon_sym_BSLASHBiggr] = ACTIONS(2208),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [181] = {
    [sym_block_comment] = STATE(221),
    [sym__flat_content] = STATE(221),
    [sym__text_with_env_content] = STATE(221),
    [sym__text_content] = STATE(221),
    [sym__paragraph] = STATE(477),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(480),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(221),
    [sym_text] = STATE(221),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(221),
    [sym_inline_formula] = STATE(221),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(221),
    [sym_comment_environment] = STATE(221),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(221),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(221),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(221),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(221),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(221),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(221),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(221),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(221),
    [sym_generic_command] = STATE(221),
    [sym_title_declaration] = STATE(221),
    [sym_author_declaration] = STATE(221),
    [sym_package_include] = STATE(221),
    [sym_class_include] = STATE(221),
    [sym_latex_include] = STATE(221),
    [sym_biblatex_include] = STATE(221),
    [sym_bibstyle_include] = STATE(221),
    [sym_bibtex_include] = STATE(221),
    [sym_graphics_include] = STATE(221),
    [sym_svg_include] = STATE(221),
    [sym_inkscape_include] = STATE(221),
    [sym_verbatim_include] = STATE(221),
    [sym_import_include] = STATE(221),
    [sym_caption] = STATE(221),
    [sym_citation] = STATE(221),
    [sym_label_definition] = STATE(221),
    [sym_label_reference] = STATE(221),
    [sym_label_reference_range] = STATE(221),
    [sym_label_number] = STATE(221),
    [sym_new_command_definition] = STATE(221),
    [sym_old_command_definition] = STATE(221),
    [sym_let_command_definition] = STATE(221),
    [sym_math_delimiter] = STATE(221),
    [sym_paired_delimiter_definition] = STATE(221),
    [sym_environment_definition] = STATE(221),
    [sym_glossary_entry_definition] = STATE(221),
    [sym_glossary_entry_reference] = STATE(221),
    [sym_acronym_definition] = STATE(221),
    [sym_acronym_reference] = STATE(221),
    [sym_theorem_definition] = STATE(221),
    [sym_color_definition] = STATE(221),
    [sym_color_set_definition] = STATE(221),
    [sym_color_reference] = STATE(221),
    [sym_tikz_library_import] = STATE(221),
    [sym_text_mode] = STATE(221),
    [sym_hyperlink] = STATE(221),
    [aux_sym__section_repeat5] = STATE(480),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(221),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2192),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_RBRACK] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [182] = {
    [sym_block_comment] = STATE(181),
    [sym__flat_content] = STATE(181),
    [sym__text_with_env_content] = STATE(181),
    [sym__text_content] = STATE(181),
    [sym__paragraph] = STATE(559),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(560),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(181),
    [sym_text] = STATE(181),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(181),
    [sym_inline_formula] = STATE(181),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(181),
    [sym_comment_environment] = STATE(181),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(181),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(181),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(181),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(181),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(181),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(181),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(181),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(181),
    [sym_generic_command] = STATE(181),
    [sym_title_declaration] = STATE(181),
    [sym_author_declaration] = STATE(181),
    [sym_package_include] = STATE(181),
    [sym_class_include] = STATE(181),
    [sym_latex_include] = STATE(181),
    [sym_biblatex_include] = STATE(181),
    [sym_bibstyle_include] = STATE(181),
    [sym_bibtex_include] = STATE(181),
    [sym_graphics_include] = STATE(181),
    [sym_svg_include] = STATE(181),
    [sym_inkscape_include] = STATE(181),
    [sym_verbatim_include] = STATE(181),
    [sym_import_include] = STATE(181),
    [sym_caption] = STATE(181),
    [sym_citation] = STATE(181),
    [sym_label_definition] = STATE(181),
    [sym_label_reference] = STATE(181),
    [sym_label_reference_range] = STATE(181),
    [sym_label_number] = STATE(181),
    [sym_new_command_definition] = STATE(181),
    [sym_old_command_definition] = STATE(181),
    [sym_let_command_definition] = STATE(181),
    [sym_math_delimiter] = STATE(181),
    [sym_paired_delimiter_definition] = STATE(181),
    [sym_environment_definition] = STATE(181),
    [sym_glossary_entry_definition] = STATE(181),
    [sym_glossary_entry_reference] = STATE(181),
    [sym_acronym_definition] = STATE(181),
    [sym_acronym_reference] = STATE(181),
    [sym_theorem_definition] = STATE(181),
    [sym_color_definition] = STATE(181),
    [sym_color_set_definition] = STATE(181),
    [sym_color_reference] = STATE(181),
    [sym_tikz_library_import] = STATE(181),
    [sym_text_mode] = STATE(181),
    [sym_hyperlink] = STATE(181),
    [aux_sym__section_repeat5] = STATE(560),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(181),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2198),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2212),
    [anon_sym_RBRACK] = ACTIONS(2212),
    [anon_sym_COMMA] = ACTIONS(2212),
    [anon_sym_EQ] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2212),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [anon_sym_BSLASHpart] = ACTIONS(2196),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddpart] = ACTIONS(2196),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHchapter] = ACTIONS(2196),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddchap] = ACTIONS(2196),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsection] = ACTIONS(2196),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddsec] = ACTIONS(2196),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsection] = ACTIONS(2196),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2198),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [183] = {
    [sym_block_comment] = STATE(211),
    [sym__flat_content] = STATE(211),
    [sym__text_with_env_content] = STATE(211),
    [sym__text_content] = STATE(211),
    [sym__paragraph] = STATE(572),
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(403),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(394),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(390),
    [sym_curly_group] = STATE(211),
    [sym_text] = STATE(211),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(211),
    [sym_inline_formula] = STATE(211),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(211),
    [sym_comment_environment] = STATE(211),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(211),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(211),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(211),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(211),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(211),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(211),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(211),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(211),
    [sym_generic_command] = STATE(211),
    [sym_title_declaration] = STATE(211),
    [sym_author_declaration] = STATE(211),
    [sym_package_include] = STATE(211),
    [sym_class_include] = STATE(211),
    [sym_latex_include] = STATE(211),
    [sym_biblatex_include] = STATE(211),
    [sym_bibstyle_include] = STATE(211),
    [sym_bibtex_include] = STATE(211),
    [sym_graphics_include] = STATE(211),
    [sym_svg_include] = STATE(211),
    [sym_inkscape_include] = STATE(211),
    [sym_verbatim_include] = STATE(211),
    [sym_import_include] = STATE(211),
    [sym_caption] = STATE(211),
    [sym_citation] = STATE(211),
    [sym_label_definition] = STATE(211),
    [sym_label_reference] = STATE(211),
    [sym_label_reference_range] = STATE(211),
    [sym_label_number] = STATE(211),
    [sym_new_command_definition] = STATE(211),
    [sym_old_command_definition] = STATE(211),
    [sym_let_command_definition] = STATE(211),
    [sym_math_delimiter] = STATE(211),
    [sym_paired_delimiter_definition] = STATE(211),
    [sym_environment_definition] = STATE(211),
    [sym_glossary_entry_definition] = STATE(211),
    [sym_glossary_entry_reference] = STATE(211),
    [sym_acronym_definition] = STATE(211),
    [sym_acronym_reference] = STATE(211),
    [sym_theorem_definition] = STATE(211),
    [sym_color_definition] = STATE(211),
    [sym_color_set_definition] = STATE(211),
    [sym_color_reference] = STATE(211),
    [sym_tikz_library_import] = STATE(211),
    [sym_text_mode] = STATE(211),
    [sym_hyperlink] = STATE(211),
    [aux_sym__paragraph_repeat1] = STATE(403),
    [aux_sym__paragraph_repeat2] = STATE(394),
    [aux_sym__paragraph_repeat3] = STATE(390),
    [aux_sym_part_repeat1] = STATE(211),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_RBRACK] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2214),
    [anon_sym_BSLASHbigr] = ACTIONS(2214),
    [anon_sym_BSLASHBigr] = ACTIONS(2214),
    [anon_sym_BSLASHbiggr] = ACTIONS(2214),
    [anon_sym_BSLASHBiggr] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [184] = {
    [sym_block_comment] = STATE(232),
    [sym__flat_content] = STATE(232),
    [sym__text_with_env_content] = STATE(232),
    [sym__text_content] = STATE(232),
    [sym__paragraph] = STATE(763),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(750),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(232),
    [sym_text] = STATE(232),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(232),
    [sym_inline_formula] = STATE(232),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(232),
    [sym_comment_environment] = STATE(232),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(232),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(232),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(232),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(232),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(232),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(232),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(232),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(232),
    [sym_generic_command] = STATE(232),
    [sym_title_declaration] = STATE(232),
    [sym_author_declaration] = STATE(232),
    [sym_package_include] = STATE(232),
    [sym_class_include] = STATE(232),
    [sym_latex_include] = STATE(232),
    [sym_biblatex_include] = STATE(232),
    [sym_bibstyle_include] = STATE(232),
    [sym_bibtex_include] = STATE(232),
    [sym_graphics_include] = STATE(232),
    [sym_svg_include] = STATE(232),
    [sym_inkscape_include] = STATE(232),
    [sym_verbatim_include] = STATE(232),
    [sym_import_include] = STATE(232),
    [sym_caption] = STATE(232),
    [sym_citation] = STATE(232),
    [sym_label_definition] = STATE(232),
    [sym_label_reference] = STATE(232),
    [sym_label_reference_range] = STATE(232),
    [sym_label_number] = STATE(232),
    [sym_new_command_definition] = STATE(232),
    [sym_old_command_definition] = STATE(232),
    [sym_let_command_definition] = STATE(232),
    [sym_math_delimiter] = STATE(232),
    [sym_paired_delimiter_definition] = STATE(232),
    [sym_environment_definition] = STATE(232),
    [sym_glossary_entry_definition] = STATE(232),
    [sym_glossary_entry_reference] = STATE(232),
    [sym_acronym_definition] = STATE(232),
    [sym_acronym_reference] = STATE(232),
    [sym_theorem_definition] = STATE(232),
    [sym_color_definition] = STATE(232),
    [sym_color_set_definition] = STATE(232),
    [sym_color_reference] = STATE(232),
    [sym_tikz_library_import] = STATE(232),
    [sym_text_mode] = STATE(232),
    [sym_hyperlink] = STATE(232),
    [aux_sym__section_repeat5] = STATE(750),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(232),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [185] = {
    [sym_block_comment] = STATE(231),
    [sym__flat_content] = STATE(231),
    [sym__text_with_env_content] = STATE(231),
    [sym__text_content] = STATE(231),
    [sym__paragraph] = STATE(644),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(690),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(231),
    [sym_text] = STATE(231),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(231),
    [sym_inline_formula] = STATE(231),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(231),
    [sym_comment_environment] = STATE(231),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(231),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(231),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(231),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(231),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(231),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(231),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(231),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(231),
    [sym_generic_command] = STATE(231),
    [sym_title_declaration] = STATE(231),
    [sym_author_declaration] = STATE(231),
    [sym_package_include] = STATE(231),
    [sym_class_include] = STATE(231),
    [sym_latex_include] = STATE(231),
    [sym_biblatex_include] = STATE(231),
    [sym_bibstyle_include] = STATE(231),
    [sym_bibtex_include] = STATE(231),
    [sym_graphics_include] = STATE(231),
    [sym_svg_include] = STATE(231),
    [sym_inkscape_include] = STATE(231),
    [sym_verbatim_include] = STATE(231),
    [sym_import_include] = STATE(231),
    [sym_caption] = STATE(231),
    [sym_citation] = STATE(231),
    [sym_label_definition] = STATE(231),
    [sym_label_reference] = STATE(231),
    [sym_label_reference_range] = STATE(231),
    [sym_label_number] = STATE(231),
    [sym_new_command_definition] = STATE(231),
    [sym_old_command_definition] = STATE(231),
    [sym_let_command_definition] = STATE(231),
    [sym_math_delimiter] = STATE(231),
    [sym_paired_delimiter_definition] = STATE(231),
    [sym_environment_definition] = STATE(231),
    [sym_glossary_entry_definition] = STATE(231),
    [sym_glossary_entry_reference] = STATE(231),
    [sym_acronym_definition] = STATE(231),
    [sym_acronym_reference] = STATE(231),
    [sym_theorem_definition] = STATE(231),
    [sym_color_definition] = STATE(231),
    [sym_color_set_definition] = STATE(231),
    [sym_color_reference] = STATE(231),
    [sym_tikz_library_import] = STATE(231),
    [sym_text_mode] = STATE(231),
    [sym_hyperlink] = STATE(231),
    [aux_sym__section_repeat5] = STATE(690),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(231),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_RBRACK] = ACTIONS(2156),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_EQ] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [186] = {
    [sym_block_comment] = STATE(185),
    [sym__flat_content] = STATE(185),
    [sym__text_with_env_content] = STATE(185),
    [sym__text_content] = STATE(185),
    [sym__paragraph] = STATE(721),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(729),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(185),
    [sym_text] = STATE(185),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(185),
    [sym_inline_formula] = STATE(185),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(185),
    [sym_comment_environment] = STATE(185),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(185),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(185),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(185),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(185),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(185),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(185),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(185),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(185),
    [sym_generic_command] = STATE(185),
    [sym_title_declaration] = STATE(185),
    [sym_author_declaration] = STATE(185),
    [sym_package_include] = STATE(185),
    [sym_class_include] = STATE(185),
    [sym_latex_include] = STATE(185),
    [sym_biblatex_include] = STATE(185),
    [sym_bibstyle_include] = STATE(185),
    [sym_bibtex_include] = STATE(185),
    [sym_graphics_include] = STATE(185),
    [sym_svg_include] = STATE(185),
    [sym_inkscape_include] = STATE(185),
    [sym_verbatim_include] = STATE(185),
    [sym_import_include] = STATE(185),
    [sym_caption] = STATE(185),
    [sym_citation] = STATE(185),
    [sym_label_definition] = STATE(185),
    [sym_label_reference] = STATE(185),
    [sym_label_reference_range] = STATE(185),
    [sym_label_number] = STATE(185),
    [sym_new_command_definition] = STATE(185),
    [sym_old_command_definition] = STATE(185),
    [sym_let_command_definition] = STATE(185),
    [sym_math_delimiter] = STATE(185),
    [sym_paired_delimiter_definition] = STATE(185),
    [sym_environment_definition] = STATE(185),
    [sym_glossary_entry_definition] = STATE(185),
    [sym_glossary_entry_reference] = STATE(185),
    [sym_acronym_definition] = STATE(185),
    [sym_acronym_reference] = STATE(185),
    [sym_theorem_definition] = STATE(185),
    [sym_color_definition] = STATE(185),
    [sym_color_set_definition] = STATE(185),
    [sym_color_reference] = STATE(185),
    [sym_tikz_library_import] = STATE(185),
    [sym_text_mode] = STATE(185),
    [sym_hyperlink] = STATE(185),
    [aux_sym__section_repeat5] = STATE(729),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(185),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_RBRACK] = ACTIONS(2218),
    [anon_sym_COMMA] = ACTIONS(2218),
    [anon_sym_EQ] = ACTIONS(2218),
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_RPAREN] = ACTIONS(2218),
    [anon_sym_BSLASHpart] = ACTIONS(2196),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddpart] = ACTIONS(2196),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHchapter] = ACTIONS(2196),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddchap] = ACTIONS(2196),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsection] = ACTIONS(2196),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddsec] = ACTIONS(2196),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsection] = ACTIONS(2196),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2198),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [187] = {
    [sym_block_comment] = STATE(188),
    [sym__flat_content] = STATE(188),
    [sym__text_with_env_content] = STATE(188),
    [sym__text_content] = STATE(188),
    [sym__paragraph] = STATE(831),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(792),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(188),
    [sym_text] = STATE(188),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(188),
    [sym_inline_formula] = STATE(188),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(188),
    [sym_comment_environment] = STATE(188),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(188),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(188),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(188),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(188),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(188),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(188),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(188),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(188),
    [sym_generic_command] = STATE(188),
    [sym_title_declaration] = STATE(188),
    [sym_author_declaration] = STATE(188),
    [sym_package_include] = STATE(188),
    [sym_class_include] = STATE(188),
    [sym_latex_include] = STATE(188),
    [sym_biblatex_include] = STATE(188),
    [sym_bibstyle_include] = STATE(188),
    [sym_bibtex_include] = STATE(188),
    [sym_graphics_include] = STATE(188),
    [sym_svg_include] = STATE(188),
    [sym_inkscape_include] = STATE(188),
    [sym_verbatim_include] = STATE(188),
    [sym_import_include] = STATE(188),
    [sym_caption] = STATE(188),
    [sym_citation] = STATE(188),
    [sym_label_definition] = STATE(188),
    [sym_label_reference] = STATE(188),
    [sym_label_reference_range] = STATE(188),
    [sym_label_number] = STATE(188),
    [sym_new_command_definition] = STATE(188),
    [sym_old_command_definition] = STATE(188),
    [sym_let_command_definition] = STATE(188),
    [sym_math_delimiter] = STATE(188),
    [sym_paired_delimiter_definition] = STATE(188),
    [sym_environment_definition] = STATE(188),
    [sym_glossary_entry_definition] = STATE(188),
    [sym_glossary_entry_reference] = STATE(188),
    [sym_acronym_definition] = STATE(188),
    [sym_acronym_reference] = STATE(188),
    [sym_theorem_definition] = STATE(188),
    [sym_color_definition] = STATE(188),
    [sym_color_set_definition] = STATE(188),
    [sym_color_reference] = STATE(188),
    [sym_tikz_library_import] = STATE(188),
    [sym_text_mode] = STATE(188),
    [sym_hyperlink] = STATE(188),
    [aux_sym__section_repeat5] = STATE(792),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(188),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2220),
    [anon_sym_RBRACK] = ACTIONS(2220),
    [anon_sym_COMMA] = ACTIONS(2220),
    [anon_sym_EQ] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(2220),
    [anon_sym_RPAREN] = ACTIONS(2220),
    [anon_sym_BSLASHpart] = ACTIONS(2196),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddpart] = ACTIONS(2196),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHchapter] = ACTIONS(2196),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddchap] = ACTIONS(2196),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsection] = ACTIONS(2196),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddsec] = ACTIONS(2196),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsection] = ACTIONS(2196),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2196),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [188] = {
    [sym_block_comment] = STATE(228),
    [sym__flat_content] = STATE(228),
    [sym__text_with_env_content] = STATE(228),
    [sym__text_content] = STATE(228),
    [sym__paragraph] = STATE(723),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(719),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(228),
    [sym_text] = STATE(228),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(228),
    [sym_inline_formula] = STATE(228),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(228),
    [sym_comment_environment] = STATE(228),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(228),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(228),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(228),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(228),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(228),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(228),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(228),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(228),
    [sym_generic_command] = STATE(228),
    [sym_title_declaration] = STATE(228),
    [sym_author_declaration] = STATE(228),
    [sym_package_include] = STATE(228),
    [sym_class_include] = STATE(228),
    [sym_latex_include] = STATE(228),
    [sym_biblatex_include] = STATE(228),
    [sym_bibstyle_include] = STATE(228),
    [sym_bibtex_include] = STATE(228),
    [sym_graphics_include] = STATE(228),
    [sym_svg_include] = STATE(228),
    [sym_inkscape_include] = STATE(228),
    [sym_verbatim_include] = STATE(228),
    [sym_import_include] = STATE(228),
    [sym_caption] = STATE(228),
    [sym_citation] = STATE(228),
    [sym_label_definition] = STATE(228),
    [sym_label_reference] = STATE(228),
    [sym_label_reference_range] = STATE(228),
    [sym_label_number] = STATE(228),
    [sym_new_command_definition] = STATE(228),
    [sym_old_command_definition] = STATE(228),
    [sym_let_command_definition] = STATE(228),
    [sym_math_delimiter] = STATE(228),
    [sym_paired_delimiter_definition] = STATE(228),
    [sym_environment_definition] = STATE(228),
    [sym_glossary_entry_definition] = STATE(228),
    [sym_glossary_entry_reference] = STATE(228),
    [sym_acronym_definition] = STATE(228),
    [sym_acronym_reference] = STATE(228),
    [sym_theorem_definition] = STATE(228),
    [sym_color_definition] = STATE(228),
    [sym_color_set_definition] = STATE(228),
    [sym_color_reference] = STATE(228),
    [sym_tikz_library_import] = STATE(228),
    [sym_text_mode] = STATE(228),
    [sym_hyperlink] = STATE(228),
    [aux_sym__section_repeat5] = STATE(719),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(228),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [189] = {
    [sym_block_comment] = STATE(184),
    [sym__flat_content] = STATE(184),
    [sym__text_with_env_content] = STATE(184),
    [sym__text_content] = STATE(184),
    [sym__paragraph] = STATE(814),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(815),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(184),
    [sym_text] = STATE(184),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(184),
    [sym_inline_formula] = STATE(184),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(184),
    [sym_comment_environment] = STATE(184),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(184),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(184),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(184),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(184),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(184),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(184),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(184),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(184),
    [sym_generic_command] = STATE(184),
    [sym_title_declaration] = STATE(184),
    [sym_author_declaration] = STATE(184),
    [sym_package_include] = STATE(184),
    [sym_class_include] = STATE(184),
    [sym_latex_include] = STATE(184),
    [sym_biblatex_include] = STATE(184),
    [sym_bibstyle_include] = STATE(184),
    [sym_bibtex_include] = STATE(184),
    [sym_graphics_include] = STATE(184),
    [sym_svg_include] = STATE(184),
    [sym_inkscape_include] = STATE(184),
    [sym_verbatim_include] = STATE(184),
    [sym_import_include] = STATE(184),
    [sym_caption] = STATE(184),
    [sym_citation] = STATE(184),
    [sym_label_definition] = STATE(184),
    [sym_label_reference] = STATE(184),
    [sym_label_reference_range] = STATE(184),
    [sym_label_number] = STATE(184),
    [sym_new_command_definition] = STATE(184),
    [sym_old_command_definition] = STATE(184),
    [sym_let_command_definition] = STATE(184),
    [sym_math_delimiter] = STATE(184),
    [sym_paired_delimiter_definition] = STATE(184),
    [sym_environment_definition] = STATE(184),
    [sym_glossary_entry_definition] = STATE(184),
    [sym_glossary_entry_reference] = STATE(184),
    [sym_acronym_definition] = STATE(184),
    [sym_acronym_reference] = STATE(184),
    [sym_theorem_definition] = STATE(184),
    [sym_color_definition] = STATE(184),
    [sym_color_set_definition] = STATE(184),
    [sym_color_reference] = STATE(184),
    [sym_tikz_library_import] = STATE(184),
    [sym_text_mode] = STATE(184),
    [sym_hyperlink] = STATE(184),
    [aux_sym__section_repeat5] = STATE(815),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(184),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_RBRACK] = ACTIONS(2222),
    [anon_sym_COMMA] = ACTIONS(2222),
    [anon_sym_EQ] = ACTIONS(2222),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_RPAREN] = ACTIONS(2222),
    [anon_sym_BSLASHpart] = ACTIONS(2196),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddpart] = ACTIONS(2196),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHchapter] = ACTIONS(2196),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddchap] = ACTIONS(2196),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsection] = ACTIONS(2196),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHaddsec] = ACTIONS(2196),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsection] = ACTIONS(2196),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2198),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2198),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [190] = {
    [sym_block_comment] = STATE(191),
    [sym__flat_content] = STATE(191),
    [sym__text_with_env_content] = STATE(191),
    [sym__text_content] = STATE(191),
    [sym__paragraph] = STATE(909),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(191),
    [sym_text] = STATE(191),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(191),
    [sym_inline_formula] = STATE(191),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(191),
    [sym_comment_environment] = STATE(191),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(191),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(191),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(191),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(191),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(191),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(191),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(191),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(191),
    [sym_generic_command] = STATE(191),
    [sym_title_declaration] = STATE(191),
    [sym_author_declaration] = STATE(191),
    [sym_package_include] = STATE(191),
    [sym_class_include] = STATE(191),
    [sym_latex_include] = STATE(191),
    [sym_biblatex_include] = STATE(191),
    [sym_bibstyle_include] = STATE(191),
    [sym_bibtex_include] = STATE(191),
    [sym_graphics_include] = STATE(191),
    [sym_svg_include] = STATE(191),
    [sym_inkscape_include] = STATE(191),
    [sym_verbatim_include] = STATE(191),
    [sym_import_include] = STATE(191),
    [sym_caption] = STATE(191),
    [sym_citation] = STATE(191),
    [sym_label_definition] = STATE(191),
    [sym_label_reference] = STATE(191),
    [sym_label_reference_range] = STATE(191),
    [sym_label_number] = STATE(191),
    [sym_new_command_definition] = STATE(191),
    [sym_old_command_definition] = STATE(191),
    [sym_let_command_definition] = STATE(191),
    [sym_math_delimiter] = STATE(191),
    [sym_paired_delimiter_definition] = STATE(191),
    [sym_environment_definition] = STATE(191),
    [sym_glossary_entry_definition] = STATE(191),
    [sym_glossary_entry_reference] = STATE(191),
    [sym_acronym_definition] = STATE(191),
    [sym_acronym_reference] = STATE(191),
    [sym_theorem_definition] = STATE(191),
    [sym_color_definition] = STATE(191),
    [sym_color_set_definition] = STATE(191),
    [sym_color_reference] = STATE(191),
    [sym_tikz_library_import] = STATE(191),
    [sym_text_mode] = STATE(191),
    [sym_hyperlink] = STATE(191),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(191),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2210),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2224),
    [anon_sym_RBRACK] = ACTIONS(2224),
    [anon_sym_COMMA] = ACTIONS(2224),
    [anon_sym_EQ] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(2224),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [anon_sym_BSLASHpart] = ACTIONS(2208),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddpart] = ACTIONS(2208),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHchapter] = ACTIONS(2208),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddchap] = ACTIONS(2208),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsection] = ACTIONS(2208),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddsec] = ACTIONS(2208),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2210),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [191] = {
    [sym_block_comment] = STATE(221),
    [sym__flat_content] = STATE(221),
    [sym__text_with_env_content] = STATE(221),
    [sym__text_content] = STATE(221),
    [sym__paragraph] = STATE(978),
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(464),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(465),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(468),
    [sym_curly_group] = STATE(221),
    [sym_text] = STATE(221),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(221),
    [sym_inline_formula] = STATE(221),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(221),
    [sym_comment_environment] = STATE(221),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(221),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(221),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(221),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(221),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(221),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(221),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(221),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(221),
    [sym_generic_command] = STATE(221),
    [sym_title_declaration] = STATE(221),
    [sym_author_declaration] = STATE(221),
    [sym_package_include] = STATE(221),
    [sym_class_include] = STATE(221),
    [sym_latex_include] = STATE(221),
    [sym_biblatex_include] = STATE(221),
    [sym_bibstyle_include] = STATE(221),
    [sym_bibtex_include] = STATE(221),
    [sym_graphics_include] = STATE(221),
    [sym_svg_include] = STATE(221),
    [sym_inkscape_include] = STATE(221),
    [sym_verbatim_include] = STATE(221),
    [sym_import_include] = STATE(221),
    [sym_caption] = STATE(221),
    [sym_citation] = STATE(221),
    [sym_label_definition] = STATE(221),
    [sym_label_reference] = STATE(221),
    [sym_label_reference_range] = STATE(221),
    [sym_label_number] = STATE(221),
    [sym_new_command_definition] = STATE(221),
    [sym_old_command_definition] = STATE(221),
    [sym_let_command_definition] = STATE(221),
    [sym_math_delimiter] = STATE(221),
    [sym_paired_delimiter_definition] = STATE(221),
    [sym_environment_definition] = STATE(221),
    [sym_glossary_entry_definition] = STATE(221),
    [sym_glossary_entry_reference] = STATE(221),
    [sym_acronym_definition] = STATE(221),
    [sym_acronym_reference] = STATE(221),
    [sym_theorem_definition] = STATE(221),
    [sym_color_definition] = STATE(221),
    [sym_color_set_definition] = STATE(221),
    [sym_color_reference] = STATE(221),
    [sym_tikz_library_import] = STATE(221),
    [sym_text_mode] = STATE(221),
    [sym_hyperlink] = STATE(221),
    [aux_sym__paragraph_repeat1] = STATE(464),
    [aux_sym__paragraph_repeat2] = STATE(465),
    [aux_sym__paragraph_repeat3] = STATE(468),
    [aux_sym_part_repeat1] = STATE(221),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2216),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_RBRACK] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2216),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [192] = {
    [sym_block_comment] = STATE(193),
    [sym__flat_content] = STATE(193),
    [sym__text_with_env_content] = STATE(193),
    [sym__text_content] = STATE(193),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(363),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(364),
    [sym_curly_group] = STATE(193),
    [sym_text] = STATE(193),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(193),
    [sym_inline_formula] = STATE(193),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(193),
    [sym_comment_environment] = STATE(193),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(193),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(193),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(193),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(193),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(193),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(193),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(193),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(193),
    [sym_generic_command] = STATE(193),
    [sym_title_declaration] = STATE(193),
    [sym_author_declaration] = STATE(193),
    [sym_package_include] = STATE(193),
    [sym_class_include] = STATE(193),
    [sym_latex_include] = STATE(193),
    [sym_biblatex_include] = STATE(193),
    [sym_bibstyle_include] = STATE(193),
    [sym_bibtex_include] = STATE(193),
    [sym_graphics_include] = STATE(193),
    [sym_svg_include] = STATE(193),
    [sym_inkscape_include] = STATE(193),
    [sym_verbatim_include] = STATE(193),
    [sym_import_include] = STATE(193),
    [sym_caption] = STATE(193),
    [sym_citation] = STATE(193),
    [sym_label_definition] = STATE(193),
    [sym_label_reference] = STATE(193),
    [sym_label_reference_range] = STATE(193),
    [sym_label_number] = STATE(193),
    [sym_new_command_definition] = STATE(193),
    [sym_old_command_definition] = STATE(193),
    [sym_let_command_definition] = STATE(193),
    [sym_math_delimiter] = STATE(193),
    [sym_paired_delimiter_definition] = STATE(193),
    [sym_environment_definition] = STATE(193),
    [sym_glossary_entry_definition] = STATE(193),
    [sym_glossary_entry_reference] = STATE(193),
    [sym_acronym_definition] = STATE(193),
    [sym_acronym_reference] = STATE(193),
    [sym_theorem_definition] = STATE(193),
    [sym_color_definition] = STATE(193),
    [sym_color_set_definition] = STATE(193),
    [sym_color_reference] = STATE(193),
    [sym_tikz_library_import] = STATE(193),
    [sym_text_mode] = STATE(193),
    [sym_hyperlink] = STATE(193),
    [aux_sym__paragraph_repeat2] = STATE(363),
    [aux_sym__paragraph_repeat3] = STATE(364),
    [aux_sym_part_repeat1] = STATE(193),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_RBRACK] = ACTIONS(2226),
    [anon_sym_COMMA] = ACTIONS(2226),
    [anon_sym_EQ] = ACTIONS(2226),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_RPAREN] = ACTIONS(2226),
    [anon_sym_BSLASHpart] = ACTIONS(2228),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddpart] = ACTIONS(2228),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHchapter] = ACTIONS(2228),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddchap] = ACTIONS(2228),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsection] = ACTIONS(2228),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddsec] = ACTIONS(2228),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHparagraph] = ACTIONS(2228),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2228),
    [anon_sym_BSLASHbigr] = ACTIONS(2228),
    [anon_sym_BSLASHBigr] = ACTIONS(2228),
    [anon_sym_BSLASHbiggr] = ACTIONS(2228),
    [anon_sym_BSLASHBiggr] = ACTIONS(2228),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [193] = {
    [sym_block_comment] = STATE(211),
    [sym__flat_content] = STATE(211),
    [sym__text_with_env_content] = STATE(211),
    [sym__text_content] = STATE(211),
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(400),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(401),
    [sym_curly_group] = STATE(211),
    [sym_text] = STATE(211),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(211),
    [sym_inline_formula] = STATE(211),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(211),
    [sym_comment_environment] = STATE(211),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(211),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(211),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(211),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(211),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(211),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(211),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(211),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(211),
    [sym_generic_command] = STATE(211),
    [sym_title_declaration] = STATE(211),
    [sym_author_declaration] = STATE(211),
    [sym_package_include] = STATE(211),
    [sym_class_include] = STATE(211),
    [sym_latex_include] = STATE(211),
    [sym_biblatex_include] = STATE(211),
    [sym_bibstyle_include] = STATE(211),
    [sym_bibtex_include] = STATE(211),
    [sym_graphics_include] = STATE(211),
    [sym_svg_include] = STATE(211),
    [sym_inkscape_include] = STATE(211),
    [sym_verbatim_include] = STATE(211),
    [sym_import_include] = STATE(211),
    [sym_caption] = STATE(211),
    [sym_citation] = STATE(211),
    [sym_label_definition] = STATE(211),
    [sym_label_reference] = STATE(211),
    [sym_label_reference_range] = STATE(211),
    [sym_label_number] = STATE(211),
    [sym_new_command_definition] = STATE(211),
    [sym_old_command_definition] = STATE(211),
    [sym_let_command_definition] = STATE(211),
    [sym_math_delimiter] = STATE(211),
    [sym_paired_delimiter_definition] = STATE(211),
    [sym_environment_definition] = STATE(211),
    [sym_glossary_entry_definition] = STATE(211),
    [sym_glossary_entry_reference] = STATE(211),
    [sym_acronym_definition] = STATE(211),
    [sym_acronym_reference] = STATE(211),
    [sym_theorem_definition] = STATE(211),
    [sym_color_definition] = STATE(211),
    [sym_color_set_definition] = STATE(211),
    [sym_color_reference] = STATE(211),
    [sym_tikz_library_import] = STATE(211),
    [sym_text_mode] = STATE(211),
    [sym_hyperlink] = STATE(211),
    [aux_sym__paragraph_repeat2] = STATE(400),
    [aux_sym__paragraph_repeat3] = STATE(401),
    [aux_sym_part_repeat1] = STATE(211),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_RBRACK] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2232),
    [anon_sym_BSLASHbigr] = ACTIONS(2232),
    [anon_sym_BSLASHBigr] = ACTIONS(2232),
    [anon_sym_BSLASHbiggr] = ACTIONS(2232),
    [anon_sym_BSLASHBiggr] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [194] = {
    [sym_block_comment] = STATE(196),
    [sym__flat_content] = STATE(196),
    [sym__text_with_env_content] = STATE(196),
    [sym__text_content] = STATE(196),
    [sym__paragraph] = STATE(1074),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(196),
    [sym_text] = STATE(196),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(196),
    [sym_inline_formula] = STATE(196),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(196),
    [sym_comment_environment] = STATE(196),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(196),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(196),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(196),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(196),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(196),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(196),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(196),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(196),
    [sym_generic_command] = STATE(196),
    [sym_title_declaration] = STATE(196),
    [sym_author_declaration] = STATE(196),
    [sym_package_include] = STATE(196),
    [sym_class_include] = STATE(196),
    [sym_latex_include] = STATE(196),
    [sym_biblatex_include] = STATE(196),
    [sym_bibstyle_include] = STATE(196),
    [sym_bibtex_include] = STATE(196),
    [sym_graphics_include] = STATE(196),
    [sym_svg_include] = STATE(196),
    [sym_inkscape_include] = STATE(196),
    [sym_verbatim_include] = STATE(196),
    [sym_import_include] = STATE(196),
    [sym_caption] = STATE(196),
    [sym_citation] = STATE(196),
    [sym_label_definition] = STATE(196),
    [sym_label_reference] = STATE(196),
    [sym_label_reference_range] = STATE(196),
    [sym_label_number] = STATE(196),
    [sym_new_command_definition] = STATE(196),
    [sym_old_command_definition] = STATE(196),
    [sym_let_command_definition] = STATE(196),
    [sym_math_delimiter] = STATE(196),
    [sym_paired_delimiter_definition] = STATE(196),
    [sym_environment_definition] = STATE(196),
    [sym_glossary_entry_definition] = STATE(196),
    [sym_glossary_entry_reference] = STATE(196),
    [sym_acronym_definition] = STATE(196),
    [sym_acronym_reference] = STATE(196),
    [sym_theorem_definition] = STATE(196),
    [sym_color_definition] = STATE(196),
    [sym_color_set_definition] = STATE(196),
    [sym_color_reference] = STATE(196),
    [sym_tikz_library_import] = STATE(196),
    [sym_text_mode] = STATE(196),
    [sym_hyperlink] = STATE(196),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(196),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2236),
    [anon_sym_RBRACK] = ACTIONS(2236),
    [anon_sym_COMMA] = ACTIONS(2236),
    [anon_sym_EQ] = ACTIONS(2236),
    [anon_sym_LPAREN] = ACTIONS(2236),
    [anon_sym_RPAREN] = ACTIONS(2236),
    [anon_sym_BSLASHpart] = ACTIONS(2208),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddpart] = ACTIONS(2208),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHchapter] = ACTIONS(2208),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddchap] = ACTIONS(2208),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsection] = ACTIONS(2208),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddsec] = ACTIONS(2208),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2208),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [195] = {
    [sym_block_comment] = STATE(232),
    [sym__flat_content] = STATE(232),
    [sym__text_with_env_content] = STATE(232),
    [sym__text_content] = STATE(232),
    [sym__paragraph] = STATE(1258),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(232),
    [sym_text] = STATE(232),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(232),
    [sym_inline_formula] = STATE(232),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(232),
    [sym_comment_environment] = STATE(232),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(232),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(232),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(232),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(232),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(232),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(232),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(232),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(232),
    [sym_generic_command] = STATE(232),
    [sym_title_declaration] = STATE(232),
    [sym_author_declaration] = STATE(232),
    [sym_package_include] = STATE(232),
    [sym_class_include] = STATE(232),
    [sym_latex_include] = STATE(232),
    [sym_biblatex_include] = STATE(232),
    [sym_bibstyle_include] = STATE(232),
    [sym_bibtex_include] = STATE(232),
    [sym_graphics_include] = STATE(232),
    [sym_svg_include] = STATE(232),
    [sym_inkscape_include] = STATE(232),
    [sym_verbatim_include] = STATE(232),
    [sym_import_include] = STATE(232),
    [sym_caption] = STATE(232),
    [sym_citation] = STATE(232),
    [sym_label_definition] = STATE(232),
    [sym_label_reference] = STATE(232),
    [sym_label_reference_range] = STATE(232),
    [sym_label_number] = STATE(232),
    [sym_new_command_definition] = STATE(232),
    [sym_old_command_definition] = STATE(232),
    [sym_let_command_definition] = STATE(232),
    [sym_math_delimiter] = STATE(232),
    [sym_paired_delimiter_definition] = STATE(232),
    [sym_environment_definition] = STATE(232),
    [sym_glossary_entry_definition] = STATE(232),
    [sym_glossary_entry_reference] = STATE(232),
    [sym_acronym_definition] = STATE(232),
    [sym_acronym_reference] = STATE(232),
    [sym_theorem_definition] = STATE(232),
    [sym_color_definition] = STATE(232),
    [sym_color_set_definition] = STATE(232),
    [sym_color_reference] = STATE(232),
    [sym_tikz_library_import] = STATE(232),
    [sym_text_mode] = STATE(232),
    [sym_hyperlink] = STATE(232),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(232),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [196] = {
    [sym_block_comment] = STATE(228),
    [sym__flat_content] = STATE(228),
    [sym__text_with_env_content] = STATE(228),
    [sym__text_content] = STATE(228),
    [sym__paragraph] = STATE(1151),
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(730),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(689),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(770),
    [sym_curly_group] = STATE(228),
    [sym_text] = STATE(228),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(228),
    [sym_inline_formula] = STATE(228),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(228),
    [sym_comment_environment] = STATE(228),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(228),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(228),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(228),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(228),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(228),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(228),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(228),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(228),
    [sym_generic_command] = STATE(228),
    [sym_title_declaration] = STATE(228),
    [sym_author_declaration] = STATE(228),
    [sym_package_include] = STATE(228),
    [sym_class_include] = STATE(228),
    [sym_latex_include] = STATE(228),
    [sym_biblatex_include] = STATE(228),
    [sym_bibstyle_include] = STATE(228),
    [sym_bibtex_include] = STATE(228),
    [sym_graphics_include] = STATE(228),
    [sym_svg_include] = STATE(228),
    [sym_inkscape_include] = STATE(228),
    [sym_verbatim_include] = STATE(228),
    [sym_import_include] = STATE(228),
    [sym_caption] = STATE(228),
    [sym_citation] = STATE(228),
    [sym_label_definition] = STATE(228),
    [sym_label_reference] = STATE(228),
    [sym_label_reference_range] = STATE(228),
    [sym_label_number] = STATE(228),
    [sym_new_command_definition] = STATE(228),
    [sym_old_command_definition] = STATE(228),
    [sym_let_command_definition] = STATE(228),
    [sym_math_delimiter] = STATE(228),
    [sym_paired_delimiter_definition] = STATE(228),
    [sym_environment_definition] = STATE(228),
    [sym_glossary_entry_definition] = STATE(228),
    [sym_glossary_entry_reference] = STATE(228),
    [sym_acronym_definition] = STATE(228),
    [sym_acronym_reference] = STATE(228),
    [sym_theorem_definition] = STATE(228),
    [sym_color_definition] = STATE(228),
    [sym_color_set_definition] = STATE(228),
    [sym_color_reference] = STATE(228),
    [sym_tikz_library_import] = STATE(228),
    [sym_text_mode] = STATE(228),
    [sym_hyperlink] = STATE(228),
    [aux_sym__paragraph_repeat1] = STATE(730),
    [aux_sym__paragraph_repeat2] = STATE(689),
    [aux_sym__paragraph_repeat3] = STATE(770),
    [aux_sym_part_repeat1] = STATE(228),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2214),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [197] = {
    [sym_block_comment] = STATE(231),
    [sym__flat_content] = STATE(231),
    [sym__text_with_env_content] = STATE(231),
    [sym__text_content] = STATE(231),
    [sym__paragraph] = STATE(1410),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(231),
    [sym_text] = STATE(231),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(231),
    [sym_inline_formula] = STATE(231),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(231),
    [sym_comment_environment] = STATE(231),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(231),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(231),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(231),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(231),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(231),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(231),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(231),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(231),
    [sym_generic_command] = STATE(231),
    [sym_title_declaration] = STATE(231),
    [sym_author_declaration] = STATE(231),
    [sym_package_include] = STATE(231),
    [sym_class_include] = STATE(231),
    [sym_latex_include] = STATE(231),
    [sym_biblatex_include] = STATE(231),
    [sym_bibstyle_include] = STATE(231),
    [sym_bibtex_include] = STATE(231),
    [sym_graphics_include] = STATE(231),
    [sym_svg_include] = STATE(231),
    [sym_inkscape_include] = STATE(231),
    [sym_verbatim_include] = STATE(231),
    [sym_import_include] = STATE(231),
    [sym_caption] = STATE(231),
    [sym_citation] = STATE(231),
    [sym_label_definition] = STATE(231),
    [sym_label_reference] = STATE(231),
    [sym_label_reference_range] = STATE(231),
    [sym_label_number] = STATE(231),
    [sym_new_command_definition] = STATE(231),
    [sym_old_command_definition] = STATE(231),
    [sym_let_command_definition] = STATE(231),
    [sym_math_delimiter] = STATE(231),
    [sym_paired_delimiter_definition] = STATE(231),
    [sym_environment_definition] = STATE(231),
    [sym_glossary_entry_definition] = STATE(231),
    [sym_glossary_entry_reference] = STATE(231),
    [sym_acronym_definition] = STATE(231),
    [sym_acronym_reference] = STATE(231),
    [sym_theorem_definition] = STATE(231),
    [sym_color_definition] = STATE(231),
    [sym_color_set_definition] = STATE(231),
    [sym_color_reference] = STATE(231),
    [sym_tikz_library_import] = STATE(231),
    [sym_text_mode] = STATE(231),
    [sym_hyperlink] = STATE(231),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(231),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_RBRACK] = ACTIONS(2156),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_EQ] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2216),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [198] = {
    [sym_block_comment] = STATE(197),
    [sym__flat_content] = STATE(197),
    [sym__text_with_env_content] = STATE(197),
    [sym__text_content] = STATE(197),
    [sym__paragraph] = STATE(1352),
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(779),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(778),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(777),
    [sym_curly_group] = STATE(197),
    [sym_text] = STATE(197),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(197),
    [sym_inline_formula] = STATE(197),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(197),
    [sym_comment_environment] = STATE(197),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(197),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(197),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(197),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(197),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(197),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(197),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(197),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(197),
    [sym_generic_command] = STATE(197),
    [sym_title_declaration] = STATE(197),
    [sym_author_declaration] = STATE(197),
    [sym_package_include] = STATE(197),
    [sym_class_include] = STATE(197),
    [sym_latex_include] = STATE(197),
    [sym_biblatex_include] = STATE(197),
    [sym_bibstyle_include] = STATE(197),
    [sym_bibtex_include] = STATE(197),
    [sym_graphics_include] = STATE(197),
    [sym_svg_include] = STATE(197),
    [sym_inkscape_include] = STATE(197),
    [sym_verbatim_include] = STATE(197),
    [sym_import_include] = STATE(197),
    [sym_caption] = STATE(197),
    [sym_citation] = STATE(197),
    [sym_label_definition] = STATE(197),
    [sym_label_reference] = STATE(197),
    [sym_label_reference_range] = STATE(197),
    [sym_label_number] = STATE(197),
    [sym_new_command_definition] = STATE(197),
    [sym_old_command_definition] = STATE(197),
    [sym_let_command_definition] = STATE(197),
    [sym_math_delimiter] = STATE(197),
    [sym_paired_delimiter_definition] = STATE(197),
    [sym_environment_definition] = STATE(197),
    [sym_glossary_entry_definition] = STATE(197),
    [sym_glossary_entry_reference] = STATE(197),
    [sym_acronym_definition] = STATE(197),
    [sym_acronym_reference] = STATE(197),
    [sym_theorem_definition] = STATE(197),
    [sym_color_definition] = STATE(197),
    [sym_color_set_definition] = STATE(197),
    [sym_color_reference] = STATE(197),
    [sym_tikz_library_import] = STATE(197),
    [sym_text_mode] = STATE(197),
    [sym_hyperlink] = STATE(197),
    [aux_sym__paragraph_repeat1] = STATE(779),
    [aux_sym__paragraph_repeat2] = STATE(778),
    [aux_sym__paragraph_repeat3] = STATE(777),
    [aux_sym_part_repeat1] = STATE(197),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2238),
    [anon_sym_RBRACK] = ACTIONS(2238),
    [anon_sym_COMMA] = ACTIONS(2238),
    [anon_sym_EQ] = ACTIONS(2238),
    [anon_sym_LPAREN] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(2238),
    [anon_sym_BSLASHpart] = ACTIONS(2208),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddpart] = ACTIONS(2208),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHchapter] = ACTIONS(2208),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddchap] = ACTIONS(2208),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsection] = ACTIONS(2208),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddsec] = ACTIONS(2208),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2210),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [199] = {
    [sym_block_comment] = STATE(195),
    [sym__flat_content] = STATE(195),
    [sym__text_with_env_content] = STATE(195),
    [sym__text_content] = STATE(195),
    [sym__paragraph] = STATE(1321),
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(759),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(760),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(761),
    [sym_curly_group] = STATE(195),
    [sym_text] = STATE(195),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(195),
    [sym_inline_formula] = STATE(195),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(195),
    [sym_comment_environment] = STATE(195),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(195),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(195),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(195),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(195),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(195),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(195),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(195),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(195),
    [sym_generic_command] = STATE(195),
    [sym_title_declaration] = STATE(195),
    [sym_author_declaration] = STATE(195),
    [sym_package_include] = STATE(195),
    [sym_class_include] = STATE(195),
    [sym_latex_include] = STATE(195),
    [sym_biblatex_include] = STATE(195),
    [sym_bibstyle_include] = STATE(195),
    [sym_bibtex_include] = STATE(195),
    [sym_graphics_include] = STATE(195),
    [sym_svg_include] = STATE(195),
    [sym_inkscape_include] = STATE(195),
    [sym_verbatim_include] = STATE(195),
    [sym_import_include] = STATE(195),
    [sym_caption] = STATE(195),
    [sym_citation] = STATE(195),
    [sym_label_definition] = STATE(195),
    [sym_label_reference] = STATE(195),
    [sym_label_reference_range] = STATE(195),
    [sym_label_number] = STATE(195),
    [sym_new_command_definition] = STATE(195),
    [sym_old_command_definition] = STATE(195),
    [sym_let_command_definition] = STATE(195),
    [sym_math_delimiter] = STATE(195),
    [sym_paired_delimiter_definition] = STATE(195),
    [sym_environment_definition] = STATE(195),
    [sym_glossary_entry_definition] = STATE(195),
    [sym_glossary_entry_reference] = STATE(195),
    [sym_acronym_definition] = STATE(195),
    [sym_acronym_reference] = STATE(195),
    [sym_theorem_definition] = STATE(195),
    [sym_color_definition] = STATE(195),
    [sym_color_set_definition] = STATE(195),
    [sym_color_reference] = STATE(195),
    [sym_tikz_library_import] = STATE(195),
    [sym_text_mode] = STATE(195),
    [sym_hyperlink] = STATE(195),
    [aux_sym__paragraph_repeat1] = STATE(759),
    [aux_sym__paragraph_repeat2] = STATE(760),
    [aux_sym__paragraph_repeat3] = STATE(761),
    [aux_sym_part_repeat1] = STATE(195),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2240),
    [anon_sym_RBRACK] = ACTIONS(2240),
    [anon_sym_COMMA] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(2240),
    [anon_sym_LPAREN] = ACTIONS(2240),
    [anon_sym_RPAREN] = ACTIONS(2240),
    [anon_sym_BSLASHpart] = ACTIONS(2208),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddpart] = ACTIONS(2208),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHchapter] = ACTIONS(2208),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddchap] = ACTIONS(2208),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsection] = ACTIONS(2208),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHaddsec] = ACTIONS(2208),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2208),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2210),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2210),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [200] = {
    [sym_block_comment] = STATE(202),
    [sym__flat_content] = STATE(202),
    [sym__text_with_env_content] = STATE(202),
    [sym__text_content] = STATE(202),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(561),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(562),
    [sym_curly_group] = STATE(202),
    [sym_text] = STATE(202),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(202),
    [sym_inline_formula] = STATE(202),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(202),
    [sym_comment_environment] = STATE(202),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(202),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(202),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(202),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(202),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(202),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(202),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(202),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(202),
    [sym_generic_command] = STATE(202),
    [sym_title_declaration] = STATE(202),
    [sym_author_declaration] = STATE(202),
    [sym_package_include] = STATE(202),
    [sym_class_include] = STATE(202),
    [sym_latex_include] = STATE(202),
    [sym_biblatex_include] = STATE(202),
    [sym_bibstyle_include] = STATE(202),
    [sym_bibtex_include] = STATE(202),
    [sym_graphics_include] = STATE(202),
    [sym_svg_include] = STATE(202),
    [sym_inkscape_include] = STATE(202),
    [sym_verbatim_include] = STATE(202),
    [sym_import_include] = STATE(202),
    [sym_caption] = STATE(202),
    [sym_citation] = STATE(202),
    [sym_label_definition] = STATE(202),
    [sym_label_reference] = STATE(202),
    [sym_label_reference_range] = STATE(202),
    [sym_label_number] = STATE(202),
    [sym_new_command_definition] = STATE(202),
    [sym_old_command_definition] = STATE(202),
    [sym_let_command_definition] = STATE(202),
    [sym_math_delimiter] = STATE(202),
    [sym_paired_delimiter_definition] = STATE(202),
    [sym_environment_definition] = STATE(202),
    [sym_glossary_entry_definition] = STATE(202),
    [sym_glossary_entry_reference] = STATE(202),
    [sym_acronym_definition] = STATE(202),
    [sym_acronym_reference] = STATE(202),
    [sym_theorem_definition] = STATE(202),
    [sym_color_definition] = STATE(202),
    [sym_color_set_definition] = STATE(202),
    [sym_color_reference] = STATE(202),
    [sym_tikz_library_import] = STATE(202),
    [sym_text_mode] = STATE(202),
    [sym_hyperlink] = STATE(202),
    [aux_sym__paragraph_repeat2] = STATE(561),
    [aux_sym__paragraph_repeat3] = STATE(562),
    [aux_sym_part_repeat1] = STATE(202),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2230),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2242),
    [anon_sym_RBRACK] = ACTIONS(2242),
    [anon_sym_COMMA] = ACTIONS(2242),
    [anon_sym_EQ] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2242),
    [anon_sym_RPAREN] = ACTIONS(2242),
    [anon_sym_BSLASHpart] = ACTIONS(2228),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddpart] = ACTIONS(2228),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHchapter] = ACTIONS(2228),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddchap] = ACTIONS(2228),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsection] = ACTIONS(2228),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddsec] = ACTIONS(2228),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHparagraph] = ACTIONS(2228),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2230),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [201] = {
    [sym_block_comment] = STATE(203),
    [sym__flat_content] = STATE(203),
    [sym__text_with_env_content] = STATE(203),
    [sym__text_content] = STATE(203),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(366),
    [sym_curly_group] = STATE(203),
    [sym_text] = STATE(203),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(203),
    [sym_inline_formula] = STATE(203),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(203),
    [sym_comment_environment] = STATE(203),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(203),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(203),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(203),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(203),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(203),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(203),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(203),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(203),
    [sym_generic_command] = STATE(203),
    [sym_title_declaration] = STATE(203),
    [sym_author_declaration] = STATE(203),
    [sym_package_include] = STATE(203),
    [sym_class_include] = STATE(203),
    [sym_latex_include] = STATE(203),
    [sym_biblatex_include] = STATE(203),
    [sym_bibstyle_include] = STATE(203),
    [sym_bibtex_include] = STATE(203),
    [sym_graphics_include] = STATE(203),
    [sym_svg_include] = STATE(203),
    [sym_inkscape_include] = STATE(203),
    [sym_verbatim_include] = STATE(203),
    [sym_import_include] = STATE(203),
    [sym_caption] = STATE(203),
    [sym_citation] = STATE(203),
    [sym_label_definition] = STATE(203),
    [sym_label_reference] = STATE(203),
    [sym_label_reference_range] = STATE(203),
    [sym_label_number] = STATE(203),
    [sym_new_command_definition] = STATE(203),
    [sym_old_command_definition] = STATE(203),
    [sym_let_command_definition] = STATE(203),
    [sym_math_delimiter] = STATE(203),
    [sym_paired_delimiter_definition] = STATE(203),
    [sym_environment_definition] = STATE(203),
    [sym_glossary_entry_definition] = STATE(203),
    [sym_glossary_entry_reference] = STATE(203),
    [sym_acronym_definition] = STATE(203),
    [sym_acronym_reference] = STATE(203),
    [sym_theorem_definition] = STATE(203),
    [sym_color_definition] = STATE(203),
    [sym_color_set_definition] = STATE(203),
    [sym_color_reference] = STATE(203),
    [sym_tikz_library_import] = STATE(203),
    [sym_text_mode] = STATE(203),
    [sym_hyperlink] = STATE(203),
    [aux_sym__paragraph_repeat3] = STATE(366),
    [aux_sym_part_repeat1] = STATE(203),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2244),
    [anon_sym_RBRACK] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(2244),
    [anon_sym_EQ] = ACTIONS(2244),
    [anon_sym_LPAREN] = ACTIONS(2244),
    [anon_sym_RPAREN] = ACTIONS(2244),
    [anon_sym_BSLASHpart] = ACTIONS(2246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddpart] = ACTIONS(2246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHchapter] = ACTIONS(2246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddchap] = ACTIONS(2246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsection] = ACTIONS(2246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddsec] = ACTIONS(2246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2246),
    [anon_sym_BSLASHbigr] = ACTIONS(2246),
    [anon_sym_BSLASHBigr] = ACTIONS(2246),
    [anon_sym_BSLASHbiggr] = ACTIONS(2246),
    [anon_sym_BSLASHBiggr] = ACTIONS(2246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [202] = {
    [sym_block_comment] = STATE(221),
    [sym__flat_content] = STATE(221),
    [sym__text_with_env_content] = STATE(221),
    [sym__text_content] = STATE(221),
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(481),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(482),
    [sym_curly_group] = STATE(221),
    [sym_text] = STATE(221),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(221),
    [sym_inline_formula] = STATE(221),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(221),
    [sym_comment_environment] = STATE(221),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(221),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(221),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(221),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(221),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(221),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(221),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(221),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(221),
    [sym_generic_command] = STATE(221),
    [sym_title_declaration] = STATE(221),
    [sym_author_declaration] = STATE(221),
    [sym_package_include] = STATE(221),
    [sym_class_include] = STATE(221),
    [sym_latex_include] = STATE(221),
    [sym_biblatex_include] = STATE(221),
    [sym_bibstyle_include] = STATE(221),
    [sym_bibtex_include] = STATE(221),
    [sym_graphics_include] = STATE(221),
    [sym_svg_include] = STATE(221),
    [sym_inkscape_include] = STATE(221),
    [sym_verbatim_include] = STATE(221),
    [sym_import_include] = STATE(221),
    [sym_caption] = STATE(221),
    [sym_citation] = STATE(221),
    [sym_label_definition] = STATE(221),
    [sym_label_reference] = STATE(221),
    [sym_label_reference_range] = STATE(221),
    [sym_label_number] = STATE(221),
    [sym_new_command_definition] = STATE(221),
    [sym_old_command_definition] = STATE(221),
    [sym_let_command_definition] = STATE(221),
    [sym_math_delimiter] = STATE(221),
    [sym_paired_delimiter_definition] = STATE(221),
    [sym_environment_definition] = STATE(221),
    [sym_glossary_entry_definition] = STATE(221),
    [sym_glossary_entry_reference] = STATE(221),
    [sym_acronym_definition] = STATE(221),
    [sym_acronym_reference] = STATE(221),
    [sym_theorem_definition] = STATE(221),
    [sym_color_definition] = STATE(221),
    [sym_color_set_definition] = STATE(221),
    [sym_color_reference] = STATE(221),
    [sym_tikz_library_import] = STATE(221),
    [sym_text_mode] = STATE(221),
    [sym_hyperlink] = STATE(221),
    [aux_sym__paragraph_repeat2] = STATE(481),
    [aux_sym__paragraph_repeat3] = STATE(482),
    [aux_sym_part_repeat1] = STATE(221),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_RBRACK] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [203] = {
    [sym_block_comment] = STATE(211),
    [sym__flat_content] = STATE(211),
    [sym__text_with_env_content] = STATE(211),
    [sym__text_content] = STATE(211),
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(402),
    [sym_curly_group] = STATE(211),
    [sym_text] = STATE(211),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(211),
    [sym_inline_formula] = STATE(211),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(211),
    [sym_comment_environment] = STATE(211),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(211),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(211),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(211),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(211),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(211),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(211),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(211),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(211),
    [sym_generic_command] = STATE(211),
    [sym_title_declaration] = STATE(211),
    [sym_author_declaration] = STATE(211),
    [sym_package_include] = STATE(211),
    [sym_class_include] = STATE(211),
    [sym_latex_include] = STATE(211),
    [sym_biblatex_include] = STATE(211),
    [sym_bibstyle_include] = STATE(211),
    [sym_bibtex_include] = STATE(211),
    [sym_graphics_include] = STATE(211),
    [sym_svg_include] = STATE(211),
    [sym_inkscape_include] = STATE(211),
    [sym_verbatim_include] = STATE(211),
    [sym_import_include] = STATE(211),
    [sym_caption] = STATE(211),
    [sym_citation] = STATE(211),
    [sym_label_definition] = STATE(211),
    [sym_label_reference] = STATE(211),
    [sym_label_reference_range] = STATE(211),
    [sym_label_number] = STATE(211),
    [sym_new_command_definition] = STATE(211),
    [sym_old_command_definition] = STATE(211),
    [sym_let_command_definition] = STATE(211),
    [sym_math_delimiter] = STATE(211),
    [sym_paired_delimiter_definition] = STATE(211),
    [sym_environment_definition] = STATE(211),
    [sym_glossary_entry_definition] = STATE(211),
    [sym_glossary_entry_reference] = STATE(211),
    [sym_acronym_definition] = STATE(211),
    [sym_acronym_reference] = STATE(211),
    [sym_theorem_definition] = STATE(211),
    [sym_color_definition] = STATE(211),
    [sym_color_set_definition] = STATE(211),
    [sym_color_reference] = STATE(211),
    [sym_tikz_library_import] = STATE(211),
    [sym_text_mode] = STATE(211),
    [sym_hyperlink] = STATE(211),
    [aux_sym__paragraph_repeat3] = STATE(402),
    [aux_sym_part_repeat1] = STATE(211),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_RBRACK] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2250),
    [anon_sym_BSLASHbigr] = ACTIONS(2250),
    [anon_sym_BSLASHBigr] = ACTIONS(2250),
    [anon_sym_BSLASHbiggr] = ACTIONS(2250),
    [anon_sym_BSLASHBiggr] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [204] = {
    [sym_block_comment] = STATE(232),
    [sym__flat_content] = STATE(232),
    [sym__text_with_env_content] = STATE(232),
    [sym__text_content] = STATE(232),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(745),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(742),
    [sym_curly_group] = STATE(232),
    [sym_text] = STATE(232),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(232),
    [sym_inline_formula] = STATE(232),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(232),
    [sym_comment_environment] = STATE(232),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(232),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(232),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(232),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(232),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(232),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(232),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(232),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(232),
    [sym_generic_command] = STATE(232),
    [sym_title_declaration] = STATE(232),
    [sym_author_declaration] = STATE(232),
    [sym_package_include] = STATE(232),
    [sym_class_include] = STATE(232),
    [sym_latex_include] = STATE(232),
    [sym_biblatex_include] = STATE(232),
    [sym_bibstyle_include] = STATE(232),
    [sym_bibtex_include] = STATE(232),
    [sym_graphics_include] = STATE(232),
    [sym_svg_include] = STATE(232),
    [sym_inkscape_include] = STATE(232),
    [sym_verbatim_include] = STATE(232),
    [sym_import_include] = STATE(232),
    [sym_caption] = STATE(232),
    [sym_citation] = STATE(232),
    [sym_label_definition] = STATE(232),
    [sym_label_reference] = STATE(232),
    [sym_label_reference_range] = STATE(232),
    [sym_label_number] = STATE(232),
    [sym_new_command_definition] = STATE(232),
    [sym_old_command_definition] = STATE(232),
    [sym_let_command_definition] = STATE(232),
    [sym_math_delimiter] = STATE(232),
    [sym_paired_delimiter_definition] = STATE(232),
    [sym_environment_definition] = STATE(232),
    [sym_glossary_entry_definition] = STATE(232),
    [sym_glossary_entry_reference] = STATE(232),
    [sym_acronym_definition] = STATE(232),
    [sym_acronym_reference] = STATE(232),
    [sym_theorem_definition] = STATE(232),
    [sym_color_definition] = STATE(232),
    [sym_color_set_definition] = STATE(232),
    [sym_color_reference] = STATE(232),
    [sym_tikz_library_import] = STATE(232),
    [sym_text_mode] = STATE(232),
    [sym_hyperlink] = STATE(232),
    [aux_sym__paragraph_repeat2] = STATE(745),
    [aux_sym__paragraph_repeat3] = STATE(742),
    [aux_sym_part_repeat1] = STATE(232),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [205] = {
    [sym_block_comment] = STATE(228),
    [sym__flat_content] = STATE(228),
    [sym__text_with_env_content] = STATE(228),
    [sym__text_content] = STATE(228),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(661),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(662),
    [sym_curly_group] = STATE(228),
    [sym_text] = STATE(228),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(228),
    [sym_inline_formula] = STATE(228),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(228),
    [sym_comment_environment] = STATE(228),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(228),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(228),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(228),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(228),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(228),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(228),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(228),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(228),
    [sym_generic_command] = STATE(228),
    [sym_title_declaration] = STATE(228),
    [sym_author_declaration] = STATE(228),
    [sym_package_include] = STATE(228),
    [sym_class_include] = STATE(228),
    [sym_latex_include] = STATE(228),
    [sym_biblatex_include] = STATE(228),
    [sym_bibstyle_include] = STATE(228),
    [sym_bibtex_include] = STATE(228),
    [sym_graphics_include] = STATE(228),
    [sym_svg_include] = STATE(228),
    [sym_inkscape_include] = STATE(228),
    [sym_verbatim_include] = STATE(228),
    [sym_import_include] = STATE(228),
    [sym_caption] = STATE(228),
    [sym_citation] = STATE(228),
    [sym_label_definition] = STATE(228),
    [sym_label_reference] = STATE(228),
    [sym_label_reference_range] = STATE(228),
    [sym_label_number] = STATE(228),
    [sym_new_command_definition] = STATE(228),
    [sym_old_command_definition] = STATE(228),
    [sym_let_command_definition] = STATE(228),
    [sym_math_delimiter] = STATE(228),
    [sym_paired_delimiter_definition] = STATE(228),
    [sym_environment_definition] = STATE(228),
    [sym_glossary_entry_definition] = STATE(228),
    [sym_glossary_entry_reference] = STATE(228),
    [sym_acronym_definition] = STATE(228),
    [sym_acronym_reference] = STATE(228),
    [sym_theorem_definition] = STATE(228),
    [sym_color_definition] = STATE(228),
    [sym_color_set_definition] = STATE(228),
    [sym_color_reference] = STATE(228),
    [sym_tikz_library_import] = STATE(228),
    [sym_text_mode] = STATE(228),
    [sym_hyperlink] = STATE(228),
    [aux_sym__paragraph_repeat2] = STATE(661),
    [aux_sym__paragraph_repeat3] = STATE(662),
    [aux_sym_part_repeat1] = STATE(228),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [206] = {
    [sym_block_comment] = STATE(231),
    [sym__flat_content] = STATE(231),
    [sym__text_with_env_content] = STATE(231),
    [sym__text_content] = STATE(231),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(691),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(692),
    [sym_curly_group] = STATE(231),
    [sym_text] = STATE(231),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(231),
    [sym_inline_formula] = STATE(231),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(231),
    [sym_comment_environment] = STATE(231),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(231),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(231),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(231),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(231),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(231),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(231),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(231),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(231),
    [sym_generic_command] = STATE(231),
    [sym_title_declaration] = STATE(231),
    [sym_author_declaration] = STATE(231),
    [sym_package_include] = STATE(231),
    [sym_class_include] = STATE(231),
    [sym_latex_include] = STATE(231),
    [sym_biblatex_include] = STATE(231),
    [sym_bibstyle_include] = STATE(231),
    [sym_bibtex_include] = STATE(231),
    [sym_graphics_include] = STATE(231),
    [sym_svg_include] = STATE(231),
    [sym_inkscape_include] = STATE(231),
    [sym_verbatim_include] = STATE(231),
    [sym_import_include] = STATE(231),
    [sym_caption] = STATE(231),
    [sym_citation] = STATE(231),
    [sym_label_definition] = STATE(231),
    [sym_label_reference] = STATE(231),
    [sym_label_reference_range] = STATE(231),
    [sym_label_number] = STATE(231),
    [sym_new_command_definition] = STATE(231),
    [sym_old_command_definition] = STATE(231),
    [sym_let_command_definition] = STATE(231),
    [sym_math_delimiter] = STATE(231),
    [sym_paired_delimiter_definition] = STATE(231),
    [sym_environment_definition] = STATE(231),
    [sym_glossary_entry_definition] = STATE(231),
    [sym_glossary_entry_reference] = STATE(231),
    [sym_acronym_definition] = STATE(231),
    [sym_acronym_reference] = STATE(231),
    [sym_theorem_definition] = STATE(231),
    [sym_color_definition] = STATE(231),
    [sym_color_set_definition] = STATE(231),
    [sym_color_reference] = STATE(231),
    [sym_tikz_library_import] = STATE(231),
    [sym_text_mode] = STATE(231),
    [sym_hyperlink] = STATE(231),
    [aux_sym__paragraph_repeat2] = STATE(691),
    [aux_sym__paragraph_repeat3] = STATE(692),
    [aux_sym_part_repeat1] = STATE(231),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_RBRACK] = ACTIONS(2156),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_EQ] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [207] = {
    [sym_block_comment] = STATE(206),
    [sym__flat_content] = STATE(206),
    [sym__text_with_env_content] = STATE(206),
    [sym__text_content] = STATE(206),
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(722),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(709),
    [sym_curly_group] = STATE(206),
    [sym_text] = STATE(206),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(206),
    [sym_inline_formula] = STATE(206),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(206),
    [sym_comment_environment] = STATE(206),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(206),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(206),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(206),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(206),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(206),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(206),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(206),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(206),
    [sym_generic_command] = STATE(206),
    [sym_title_declaration] = STATE(206),
    [sym_author_declaration] = STATE(206),
    [sym_package_include] = STATE(206),
    [sym_class_include] = STATE(206),
    [sym_latex_include] = STATE(206),
    [sym_biblatex_include] = STATE(206),
    [sym_bibstyle_include] = STATE(206),
    [sym_bibtex_include] = STATE(206),
    [sym_graphics_include] = STATE(206),
    [sym_svg_include] = STATE(206),
    [sym_inkscape_include] = STATE(206),
    [sym_verbatim_include] = STATE(206),
    [sym_import_include] = STATE(206),
    [sym_caption] = STATE(206),
    [sym_citation] = STATE(206),
    [sym_label_definition] = STATE(206),
    [sym_label_reference] = STATE(206),
    [sym_label_reference_range] = STATE(206),
    [sym_label_number] = STATE(206),
    [sym_new_command_definition] = STATE(206),
    [sym_old_command_definition] = STATE(206),
    [sym_let_command_definition] = STATE(206),
    [sym_math_delimiter] = STATE(206),
    [sym_paired_delimiter_definition] = STATE(206),
    [sym_environment_definition] = STATE(206),
    [sym_glossary_entry_definition] = STATE(206),
    [sym_glossary_entry_reference] = STATE(206),
    [sym_acronym_definition] = STATE(206),
    [sym_acronym_reference] = STATE(206),
    [sym_theorem_definition] = STATE(206),
    [sym_color_definition] = STATE(206),
    [sym_color_set_definition] = STATE(206),
    [sym_color_reference] = STATE(206),
    [sym_tikz_library_import] = STATE(206),
    [sym_text_mode] = STATE(206),
    [sym_hyperlink] = STATE(206),
    [aux_sym__paragraph_repeat2] = STATE(722),
    [aux_sym__paragraph_repeat3] = STATE(709),
    [aux_sym_part_repeat1] = STATE(206),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_RBRACK] = ACTIONS(2254),
    [anon_sym_COMMA] = ACTIONS(2254),
    [anon_sym_EQ] = ACTIONS(2254),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_RPAREN] = ACTIONS(2254),
    [anon_sym_BSLASHpart] = ACTIONS(2228),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddpart] = ACTIONS(2228),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHchapter] = ACTIONS(2228),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddchap] = ACTIONS(2228),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsection] = ACTIONS(2228),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddsec] = ACTIONS(2228),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHparagraph] = ACTIONS(2228),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2230),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [208] = {
    [sym_block_comment] = STATE(204),
    [sym__flat_content] = STATE(204),
    [sym__text_with_env_content] = STATE(204),
    [sym__text_content] = STATE(204),
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(816),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(817),
    [sym_curly_group] = STATE(204),
    [sym_text] = STATE(204),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(204),
    [sym_inline_formula] = STATE(204),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(204),
    [sym_comment_environment] = STATE(204),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(204),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(204),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(204),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(204),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(204),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(204),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(204),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(204),
    [sym_generic_command] = STATE(204),
    [sym_title_declaration] = STATE(204),
    [sym_author_declaration] = STATE(204),
    [sym_package_include] = STATE(204),
    [sym_class_include] = STATE(204),
    [sym_latex_include] = STATE(204),
    [sym_biblatex_include] = STATE(204),
    [sym_bibstyle_include] = STATE(204),
    [sym_bibtex_include] = STATE(204),
    [sym_graphics_include] = STATE(204),
    [sym_svg_include] = STATE(204),
    [sym_inkscape_include] = STATE(204),
    [sym_verbatim_include] = STATE(204),
    [sym_import_include] = STATE(204),
    [sym_caption] = STATE(204),
    [sym_citation] = STATE(204),
    [sym_label_definition] = STATE(204),
    [sym_label_reference] = STATE(204),
    [sym_label_reference_range] = STATE(204),
    [sym_label_number] = STATE(204),
    [sym_new_command_definition] = STATE(204),
    [sym_old_command_definition] = STATE(204),
    [sym_let_command_definition] = STATE(204),
    [sym_math_delimiter] = STATE(204),
    [sym_paired_delimiter_definition] = STATE(204),
    [sym_environment_definition] = STATE(204),
    [sym_glossary_entry_definition] = STATE(204),
    [sym_glossary_entry_reference] = STATE(204),
    [sym_acronym_definition] = STATE(204),
    [sym_acronym_reference] = STATE(204),
    [sym_theorem_definition] = STATE(204),
    [sym_color_definition] = STATE(204),
    [sym_color_set_definition] = STATE(204),
    [sym_color_reference] = STATE(204),
    [sym_tikz_library_import] = STATE(204),
    [sym_text_mode] = STATE(204),
    [sym_hyperlink] = STATE(204),
    [aux_sym__paragraph_repeat2] = STATE(816),
    [aux_sym__paragraph_repeat3] = STATE(817),
    [aux_sym_part_repeat1] = STATE(204),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_RBRACK] = ACTIONS(2256),
    [anon_sym_COMMA] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2256),
    [anon_sym_RPAREN] = ACTIONS(2256),
    [anon_sym_BSLASHpart] = ACTIONS(2228),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddpart] = ACTIONS(2228),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHchapter] = ACTIONS(2228),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddchap] = ACTIONS(2228),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsection] = ACTIONS(2228),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddsec] = ACTIONS(2228),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHparagraph] = ACTIONS(2228),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2230),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [209] = {
    [sym_block_comment] = STATE(205),
    [sym__flat_content] = STATE(205),
    [sym__text_with_env_content] = STATE(205),
    [sym__text_content] = STATE(205),
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(733),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(731),
    [sym_curly_group] = STATE(205),
    [sym_text] = STATE(205),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(205),
    [sym_inline_formula] = STATE(205),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(205),
    [sym_comment_environment] = STATE(205),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(205),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(205),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(205),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(205),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(205),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(205),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(205),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(205),
    [sym_generic_command] = STATE(205),
    [sym_title_declaration] = STATE(205),
    [sym_author_declaration] = STATE(205),
    [sym_package_include] = STATE(205),
    [sym_class_include] = STATE(205),
    [sym_latex_include] = STATE(205),
    [sym_biblatex_include] = STATE(205),
    [sym_bibstyle_include] = STATE(205),
    [sym_bibtex_include] = STATE(205),
    [sym_graphics_include] = STATE(205),
    [sym_svg_include] = STATE(205),
    [sym_inkscape_include] = STATE(205),
    [sym_verbatim_include] = STATE(205),
    [sym_import_include] = STATE(205),
    [sym_caption] = STATE(205),
    [sym_citation] = STATE(205),
    [sym_label_definition] = STATE(205),
    [sym_label_reference] = STATE(205),
    [sym_label_reference_range] = STATE(205),
    [sym_label_number] = STATE(205),
    [sym_new_command_definition] = STATE(205),
    [sym_old_command_definition] = STATE(205),
    [sym_let_command_definition] = STATE(205),
    [sym_math_delimiter] = STATE(205),
    [sym_paired_delimiter_definition] = STATE(205),
    [sym_environment_definition] = STATE(205),
    [sym_glossary_entry_definition] = STATE(205),
    [sym_glossary_entry_reference] = STATE(205),
    [sym_acronym_definition] = STATE(205),
    [sym_acronym_reference] = STATE(205),
    [sym_theorem_definition] = STATE(205),
    [sym_color_definition] = STATE(205),
    [sym_color_set_definition] = STATE(205),
    [sym_color_reference] = STATE(205),
    [sym_tikz_library_import] = STATE(205),
    [sym_text_mode] = STATE(205),
    [sym_hyperlink] = STATE(205),
    [aux_sym__paragraph_repeat2] = STATE(733),
    [aux_sym__paragraph_repeat3] = STATE(731),
    [aux_sym_part_repeat1] = STATE(205),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_RBRACK] = ACTIONS(2258),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_EQ] = ACTIONS(2258),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [anon_sym_BSLASHpart] = ACTIONS(2228),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddpart] = ACTIONS(2228),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHchapter] = ACTIONS(2228),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddchap] = ACTIONS(2228),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsection] = ACTIONS(2228),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHaddsec] = ACTIONS(2228),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2228),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHparagraph] = ACTIONS(2228),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2230),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2228),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [210] = {
    [sym_block_comment] = STATE(213),
    [sym__flat_content] = STATE(213),
    [sym__text_with_env_content] = STATE(213),
    [sym__text_content] = STATE(213),
    [sym_curly_group] = STATE(213),
    [sym_text] = STATE(213),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(213),
    [sym_inline_formula] = STATE(213),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(213),
    [sym_comment_environment] = STATE(213),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(213),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(213),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(213),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(213),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(213),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(213),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(213),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(213),
    [sym_generic_command] = STATE(213),
    [sym_title_declaration] = STATE(213),
    [sym_author_declaration] = STATE(213),
    [sym_package_include] = STATE(213),
    [sym_class_include] = STATE(213),
    [sym_latex_include] = STATE(213),
    [sym_biblatex_include] = STATE(213),
    [sym_bibstyle_include] = STATE(213),
    [sym_bibtex_include] = STATE(213),
    [sym_graphics_include] = STATE(213),
    [sym_svg_include] = STATE(213),
    [sym_inkscape_include] = STATE(213),
    [sym_verbatim_include] = STATE(213),
    [sym_import_include] = STATE(213),
    [sym_caption] = STATE(213),
    [sym_citation] = STATE(213),
    [sym_label_definition] = STATE(213),
    [sym_label_reference] = STATE(213),
    [sym_label_reference_range] = STATE(213),
    [sym_label_number] = STATE(213),
    [sym_new_command_definition] = STATE(213),
    [sym_old_command_definition] = STATE(213),
    [sym_let_command_definition] = STATE(213),
    [sym_math_delimiter] = STATE(213),
    [sym_paired_delimiter_definition] = STATE(213),
    [sym_environment_definition] = STATE(213),
    [sym_glossary_entry_definition] = STATE(213),
    [sym_glossary_entry_reference] = STATE(213),
    [sym_acronym_definition] = STATE(213),
    [sym_acronym_reference] = STATE(213),
    [sym_theorem_definition] = STATE(213),
    [sym_color_definition] = STATE(213),
    [sym_color_set_definition] = STATE(213),
    [sym_color_reference] = STATE(213),
    [sym_tikz_library_import] = STATE(213),
    [sym_text_mode] = STATE(213),
    [sym_hyperlink] = STATE(213),
    [aux_sym_part_repeat1] = STATE(213),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2260),
    [anon_sym_RBRACK] = ACTIONS(2260),
    [anon_sym_COMMA] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2260),
    [anon_sym_RPAREN] = ACTIONS(2260),
    [anon_sym_BSLASHpart] = ACTIONS(2262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddpart] = ACTIONS(2262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHchapter] = ACTIONS(2262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddchap] = ACTIONS(2262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsection] = ACTIONS(2262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddsec] = ACTIONS(2262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHitem] = ACTIONS(2262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2262),
    [anon_sym_BSLASHbigr] = ACTIONS(2262),
    [anon_sym_BSLASHBigr] = ACTIONS(2262),
    [anon_sym_BSLASHbiggr] = ACTIONS(2262),
    [anon_sym_BSLASHBiggr] = ACTIONS(2262),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [211] = {
    [sym_block_comment] = STATE(211),
    [sym__flat_content] = STATE(211),
    [sym__text_with_env_content] = STATE(211),
    [sym__text_content] = STATE(211),
    [sym_curly_group] = STATE(211),
    [sym_text] = STATE(211),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(211),
    [sym_inline_formula] = STATE(211),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(211),
    [sym_comment_environment] = STATE(211),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(211),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(211),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(211),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(211),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(211),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(211),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(211),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(211),
    [sym_generic_command] = STATE(211),
    [sym_title_declaration] = STATE(211),
    [sym_author_declaration] = STATE(211),
    [sym_package_include] = STATE(211),
    [sym_class_include] = STATE(211),
    [sym_latex_include] = STATE(211),
    [sym_biblatex_include] = STATE(211),
    [sym_bibstyle_include] = STATE(211),
    [sym_bibtex_include] = STATE(211),
    [sym_graphics_include] = STATE(211),
    [sym_svg_include] = STATE(211),
    [sym_inkscape_include] = STATE(211),
    [sym_verbatim_include] = STATE(211),
    [sym_import_include] = STATE(211),
    [sym_caption] = STATE(211),
    [sym_citation] = STATE(211),
    [sym_label_definition] = STATE(211),
    [sym_label_reference] = STATE(211),
    [sym_label_reference_range] = STATE(211),
    [sym_label_number] = STATE(211),
    [sym_new_command_definition] = STATE(211),
    [sym_old_command_definition] = STATE(211),
    [sym_let_command_definition] = STATE(211),
    [sym_math_delimiter] = STATE(211),
    [sym_paired_delimiter_definition] = STATE(211),
    [sym_environment_definition] = STATE(211),
    [sym_glossary_entry_definition] = STATE(211),
    [sym_glossary_entry_reference] = STATE(211),
    [sym_acronym_definition] = STATE(211),
    [sym_acronym_reference] = STATE(211),
    [sym_theorem_definition] = STATE(211),
    [sym_color_definition] = STATE(211),
    [sym_color_set_definition] = STATE(211),
    [sym_color_reference] = STATE(211),
    [sym_tikz_library_import] = STATE(211),
    [sym_text_mode] = STATE(211),
    [sym_hyperlink] = STATE(211),
    [aux_sym_part_repeat1] = STATE(211),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(2266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2269),
    [anon_sym_LBRACK] = ACTIONS(2272),
    [anon_sym_RBRACK] = ACTIONS(2272),
    [anon_sym_COMMA] = ACTIONS(2272),
    [anon_sym_EQ] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2272),
    [anon_sym_RPAREN] = ACTIONS(2272),
    [anon_sym_BSLASHpart] = ACTIONS(2275),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddpart] = ACTIONS(2275),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHchapter] = ACTIONS(2275),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddchap] = ACTIONS(2275),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsection] = ACTIONS(2275),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddsec] = ACTIONS(2275),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHitem] = ACTIONS(2275),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2279),
    [sym_word] = ACTIONS(2282),
    [sym_placeholder] = ACTIONS(2285),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2288),
    [anon_sym_SLASH] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(2291),
    [anon_sym_GT] = ACTIONS(2291),
    [anon_sym_BANG] = ACTIONS(2291),
    [anon_sym_PIPE] = ACTIONS(2291),
    [anon_sym_COLON] = ACTIONS(2291),
    [anon_sym_SQUOTE] = ACTIONS(2291),
    [anon_sym__] = ACTIONS(2294),
    [anon_sym_CARET] = ACTIONS(2297),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2300),
    [anon_sym_DOLLAR] = ACTIONS(2303),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2306),
    [anon_sym_BSLASHbegin] = ACTIONS(2309),
    [anon_sym_BSLASHtitle] = ACTIONS(2312),
    [anon_sym_BSLASHauthor] = ACTIONS(2315),
    [anon_sym_BSLASHusepackage] = ACTIONS(2318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2321),
    [anon_sym_BSLASHinclude] = ACTIONS(2324),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2324),
    [anon_sym_BSLASHinput] = ACTIONS(2324),
    [anon_sym_BSLASHsubfile] = ACTIONS(2324),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2327),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2330),
    [anon_sym_BSLASHbibliography] = ACTIONS(2333),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2336),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2339),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2345),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2345),
    [anon_sym_BSLASHimport] = ACTIONS(2348),
    [anon_sym_BSLASHsubimport] = ACTIONS(2348),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2348),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2348),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2348),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2348),
    [anon_sym_BSLASHcaption] = ACTIONS(2351),
    [anon_sym_BSLASHcite] = ACTIONS(2354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHCite] = ACTIONS(2354),
    [anon_sym_BSLASHnocite] = ACTIONS(2354),
    [anon_sym_BSLASHcitet] = ACTIONS(2354),
    [anon_sym_BSLASHcitep] = ACTIONS(2354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHciteA] = ACTIONS(2354),
    [anon_sym_BSLASHciteR] = ACTIONS(2354),
    [anon_sym_BSLASHciteS] = ACTIONS(2354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHciteyear] = ACTIONS(2354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHcitedate] = ACTIONS(2354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHciteurl] = ACTIONS(2354),
    [anon_sym_BSLASHfullcite] = ACTIONS(2354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2354),
    [anon_sym_BSLASHcitealt] = ACTIONS(2354),
    [anon_sym_BSLASHcitealp] = ACTIONS(2354),
    [anon_sym_BSLASHcitetext] = ACTIONS(2354),
    [anon_sym_BSLASHparencite] = ACTIONS(2354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHParencite] = ACTIONS(2354),
    [anon_sym_BSLASHfootcite] = ACTIONS(2354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2354),
    [anon_sym_BSLASHtextcite] = ACTIONS(2354),
    [anon_sym_BSLASHTextcite] = ACTIONS(2354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2354),
    [anon_sym_BSLASHsupercite] = ACTIONS(2354),
    [anon_sym_BSLASHautocite] = ACTIONS(2354),
    [anon_sym_BSLASHAutocite] = ACTIONS(2354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2357),
    [anon_sym_BSLASHvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHVolcite] = ACTIONS(2354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHavolcite] = ACTIONS(2354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2354),
    [anon_sym_BSLASHnotecite] = ACTIONS(2354),
    [anon_sym_BSLASHNotecite] = ACTIONS(2354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2354),
    [anon_sym_BSLASHlabel] = ACTIONS(2360),
    [anon_sym_BSLASHref] = ACTIONS(2363),
    [anon_sym_BSLASHeqref] = ACTIONS(2363),
    [anon_sym_BSLASHvref] = ACTIONS(2363),
    [anon_sym_BSLASHVref] = ACTIONS(2363),
    [anon_sym_BSLASHautoref] = ACTIONS(2363),
    [anon_sym_BSLASHpageref] = ACTIONS(2363),
    [anon_sym_BSLASHcref] = ACTIONS(2363),
    [anon_sym_BSLASHCref] = ACTIONS(2363),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2366),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2366),
    [anon_sym_BSLASHnamecref] = ACTIONS(2363),
    [anon_sym_BSLASHnameCref] = ACTIONS(2363),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2363),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2363),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2363),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2363),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2363),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2363),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2369),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2369),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2375),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2381),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2381),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2381),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2381),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2378),
    [anon_sym_BSLASHdef] = ACTIONS(2384),
    [anon_sym_BSLASHlet] = ACTIONS(2387),
    [anon_sym_BSLASHleft] = ACTIONS(2390),
    [anon_sym_BSLASHbigl] = ACTIONS(2390),
    [anon_sym_BSLASHBigl] = ACTIONS(2390),
    [anon_sym_BSLASHbiggl] = ACTIONS(2390),
    [anon_sym_BSLASHBiggl] = ACTIONS(2390),
    [anon_sym_BSLASHright] = ACTIONS(2275),
    [anon_sym_BSLASHbigr] = ACTIONS(2275),
    [anon_sym_BSLASHBigr] = ACTIONS(2275),
    [anon_sym_BSLASHbiggr] = ACTIONS(2275),
    [anon_sym_BSLASHBiggr] = ACTIONS(2275),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2393),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2393),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2396),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2396),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2396),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2396),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2396),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2396),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2399),
    [anon_sym_BSLASHgls] = ACTIONS(2402),
    [anon_sym_BSLASHGls] = ACTIONS(2402),
    [anon_sym_BSLASHGLS] = ACTIONS(2402),
    [anon_sym_BSLASHglspl] = ACTIONS(2402),
    [anon_sym_BSLASHGlspl] = ACTIONS(2402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2402),
    [anon_sym_BSLASHglslink] = ACTIONS(2402),
    [anon_sym_BSLASHglstext] = ACTIONS(2402),
    [anon_sym_BSLASHGlstext] = ACTIONS(2402),
    [anon_sym_BSLASHGLStext] = ACTIONS(2402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2402),
    [anon_sym_BSLASHglsplural] = ACTIONS(2402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2402),
    [anon_sym_BSLASHglsname] = ACTIONS(2402),
    [anon_sym_BSLASHGlsname] = ACTIONS(2402),
    [anon_sym_BSLASHGLSname] = ACTIONS(2402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2405),
    [anon_sym_BSLASHacrshort] = ACTIONS(2408),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2408),
    [anon_sym_BSLASHACRshort] = ACTIONS(2408),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2408),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2408),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2408),
    [anon_sym_BSLASHacrlong] = ACTIONS(2408),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2408),
    [anon_sym_BSLASHACRlong] = ACTIONS(2408),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2408),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2408),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2408),
    [anon_sym_BSLASHacrfull] = ACTIONS(2408),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2408),
    [anon_sym_BSLASHACRfull] = ACTIONS(2408),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2408),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2408),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2408),
    [anon_sym_BSLASHacs] = ACTIONS(2408),
    [anon_sym_BSLASHAcs] = ACTIONS(2408),
    [anon_sym_BSLASHacsp] = ACTIONS(2408),
    [anon_sym_BSLASHAcsp] = ACTIONS(2408),
    [anon_sym_BSLASHacl] = ACTIONS(2408),
    [anon_sym_BSLASHAcl] = ACTIONS(2408),
    [anon_sym_BSLASHaclp] = ACTIONS(2408),
    [anon_sym_BSLASHAclp] = ACTIONS(2408),
    [anon_sym_BSLASHacf] = ACTIONS(2408),
    [anon_sym_BSLASHAcf] = ACTIONS(2408),
    [anon_sym_BSLASHacfp] = ACTIONS(2408),
    [anon_sym_BSLASHAcfp] = ACTIONS(2408),
    [anon_sym_BSLASHac] = ACTIONS(2408),
    [anon_sym_BSLASHAc] = ACTIONS(2408),
    [anon_sym_BSLASHacp] = ACTIONS(2408),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2408),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2408),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2408),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2408),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2408),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2408),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2408),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2408),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2408),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2408),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2411),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2414),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2411),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2414),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2417),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2420),
    [anon_sym_BSLASHcolor] = ACTIONS(2423),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2423),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2423),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2423),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2426),
    [anon_sym_BSLASHtext] = ACTIONS(2429),
    [anon_sym_BSLASHintertext] = ACTIONS(2429),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2429),
    [anon_sym_BSLASHurl] = ACTIONS(2432),
    [anon_sym_BSLASHhref] = ACTIONS(2432),
  },
  [212] = {
    [sym_block_comment] = STATE(221),
    [sym__flat_content] = STATE(221),
    [sym__text_with_env_content] = STATE(221),
    [sym__text_content] = STATE(221),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(483),
    [sym_curly_group] = STATE(221),
    [sym_text] = STATE(221),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(221),
    [sym_inline_formula] = STATE(221),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(221),
    [sym_comment_environment] = STATE(221),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(221),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(221),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(221),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(221),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(221),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(221),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(221),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(221),
    [sym_generic_command] = STATE(221),
    [sym_title_declaration] = STATE(221),
    [sym_author_declaration] = STATE(221),
    [sym_package_include] = STATE(221),
    [sym_class_include] = STATE(221),
    [sym_latex_include] = STATE(221),
    [sym_biblatex_include] = STATE(221),
    [sym_bibstyle_include] = STATE(221),
    [sym_bibtex_include] = STATE(221),
    [sym_graphics_include] = STATE(221),
    [sym_svg_include] = STATE(221),
    [sym_inkscape_include] = STATE(221),
    [sym_verbatim_include] = STATE(221),
    [sym_import_include] = STATE(221),
    [sym_caption] = STATE(221),
    [sym_citation] = STATE(221),
    [sym_label_definition] = STATE(221),
    [sym_label_reference] = STATE(221),
    [sym_label_reference_range] = STATE(221),
    [sym_label_number] = STATE(221),
    [sym_new_command_definition] = STATE(221),
    [sym_old_command_definition] = STATE(221),
    [sym_let_command_definition] = STATE(221),
    [sym_math_delimiter] = STATE(221),
    [sym_paired_delimiter_definition] = STATE(221),
    [sym_environment_definition] = STATE(221),
    [sym_glossary_entry_definition] = STATE(221),
    [sym_glossary_entry_reference] = STATE(221),
    [sym_acronym_definition] = STATE(221),
    [sym_acronym_reference] = STATE(221),
    [sym_theorem_definition] = STATE(221),
    [sym_color_definition] = STATE(221),
    [sym_color_set_definition] = STATE(221),
    [sym_color_reference] = STATE(221),
    [sym_tikz_library_import] = STATE(221),
    [sym_text_mode] = STATE(221),
    [sym_hyperlink] = STATE(221),
    [aux_sym__paragraph_repeat3] = STATE(483),
    [aux_sym_part_repeat1] = STATE(221),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2252),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_RBRACK] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2252),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [213] = {
    [sym_block_comment] = STATE(211),
    [sym__flat_content] = STATE(211),
    [sym__text_with_env_content] = STATE(211),
    [sym__text_content] = STATE(211),
    [sym_curly_group] = STATE(211),
    [sym_text] = STATE(211),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym_displayed_equation] = STATE(211),
    [sym_inline_formula] = STATE(211),
    [sym_begin] = STATE(58),
    [sym_generic_environment] = STATE(211),
    [sym_comment_environment] = STATE(211),
    [sym__comment_environment_begin] = STATE(3275),
    [sym_verbatim_environment] = STATE(211),
    [sym__verbatim_environment_begin] = STATE(3276),
    [sym_listing_environment] = STATE(211),
    [sym__listing_environment_begin] = STATE(3277),
    [sym_minted_environment] = STATE(211),
    [sym__minted_environment_begin] = STATE(3278),
    [sym_pycode_environment] = STATE(211),
    [sym__pycode_environment_begin] = STATE(3279),
    [sym_sagesilent_environment] = STATE(211),
    [sym__sagesilent_environment_begin] = STATE(3280),
    [sym_sageblock_environment] = STATE(211),
    [sym__sageblock_environment_begin] = STATE(3281),
    [sym_math_environment] = STATE(211),
    [sym__math_environment_begin] = STATE(245),
    [sym__command] = STATE(211),
    [sym_generic_command] = STATE(211),
    [sym_title_declaration] = STATE(211),
    [sym_author_declaration] = STATE(211),
    [sym_package_include] = STATE(211),
    [sym_class_include] = STATE(211),
    [sym_latex_include] = STATE(211),
    [sym_biblatex_include] = STATE(211),
    [sym_bibstyle_include] = STATE(211),
    [sym_bibtex_include] = STATE(211),
    [sym_graphics_include] = STATE(211),
    [sym_svg_include] = STATE(211),
    [sym_inkscape_include] = STATE(211),
    [sym_verbatim_include] = STATE(211),
    [sym_import_include] = STATE(211),
    [sym_caption] = STATE(211),
    [sym_citation] = STATE(211),
    [sym_label_definition] = STATE(211),
    [sym_label_reference] = STATE(211),
    [sym_label_reference_range] = STATE(211),
    [sym_label_number] = STATE(211),
    [sym_new_command_definition] = STATE(211),
    [sym_old_command_definition] = STATE(211),
    [sym_let_command_definition] = STATE(211),
    [sym_math_delimiter] = STATE(211),
    [sym_paired_delimiter_definition] = STATE(211),
    [sym_environment_definition] = STATE(211),
    [sym_glossary_entry_definition] = STATE(211),
    [sym_glossary_entry_reference] = STATE(211),
    [sym_acronym_definition] = STATE(211),
    [sym_acronym_reference] = STATE(211),
    [sym_theorem_definition] = STATE(211),
    [sym_color_definition] = STATE(211),
    [sym_color_set_definition] = STATE(211),
    [sym_color_reference] = STATE(211),
    [sym_tikz_library_import] = STATE(211),
    [sym_text_mode] = STATE(211),
    [sym_hyperlink] = STATE(211),
    [aux_sym_part_repeat1] = STATE(211),
    [aux_sym_text_repeat1] = STATE(256),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(2130),
    [anon_sym_RBRACK] = ACTIONS(2130),
    [anon_sym_COMMA] = ACTIONS(2130),
    [anon_sym_EQ] = ACTIONS(2130),
    [anon_sym_LPAREN] = ACTIONS(2130),
    [anon_sym_RPAREN] = ACTIONS(2130),
    [anon_sym_BSLASHpart] = ACTIONS(2435),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddpart] = ACTIONS(2435),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHchapter] = ACTIONS(2435),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddchap] = ACTIONS(2435),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsection] = ACTIONS(2435),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddsec] = ACTIONS(2435),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHitem] = ACTIONS(2435),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(221),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(221),
    [anon_sym_DOLLAR] = ACTIONS(223),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(225),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(279),
    [anon_sym_BSLASHbigl] = ACTIONS(279),
    [anon_sym_BSLASHBigl] = ACTIONS(279),
    [anon_sym_BSLASHbiggl] = ACTIONS(279),
    [anon_sym_BSLASHBiggl] = ACTIONS(279),
    [anon_sym_BSLASHright] = ACTIONS(2435),
    [anon_sym_BSLASHbigr] = ACTIONS(2435),
    [anon_sym_BSLASHBigr] = ACTIONS(2435),
    [anon_sym_BSLASHbiggr] = ACTIONS(2435),
    [anon_sym_BSLASHBiggr] = ACTIONS(2435),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(307),
    [anon_sym_BSLASHintertext] = ACTIONS(307),
    [anon_sym_BSLASHshortintertext] = ACTIONS(307),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [214] = {
    [sym_block_comment] = STATE(212),
    [sym__flat_content] = STATE(212),
    [sym__text_with_env_content] = STATE(212),
    [sym__text_content] = STATE(212),
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(563),
    [sym_curly_group] = STATE(212),
    [sym_text] = STATE(212),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(212),
    [sym_inline_formula] = STATE(212),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(212),
    [sym_comment_environment] = STATE(212),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(212),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(212),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(212),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(212),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(212),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(212),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(212),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(212),
    [sym_generic_command] = STATE(212),
    [sym_title_declaration] = STATE(212),
    [sym_author_declaration] = STATE(212),
    [sym_package_include] = STATE(212),
    [sym_class_include] = STATE(212),
    [sym_latex_include] = STATE(212),
    [sym_biblatex_include] = STATE(212),
    [sym_bibstyle_include] = STATE(212),
    [sym_bibtex_include] = STATE(212),
    [sym_graphics_include] = STATE(212),
    [sym_svg_include] = STATE(212),
    [sym_inkscape_include] = STATE(212),
    [sym_verbatim_include] = STATE(212),
    [sym_import_include] = STATE(212),
    [sym_caption] = STATE(212),
    [sym_citation] = STATE(212),
    [sym_label_definition] = STATE(212),
    [sym_label_reference] = STATE(212),
    [sym_label_reference_range] = STATE(212),
    [sym_label_number] = STATE(212),
    [sym_new_command_definition] = STATE(212),
    [sym_old_command_definition] = STATE(212),
    [sym_let_command_definition] = STATE(212),
    [sym_math_delimiter] = STATE(212),
    [sym_paired_delimiter_definition] = STATE(212),
    [sym_environment_definition] = STATE(212),
    [sym_glossary_entry_definition] = STATE(212),
    [sym_glossary_entry_reference] = STATE(212),
    [sym_acronym_definition] = STATE(212),
    [sym_acronym_reference] = STATE(212),
    [sym_theorem_definition] = STATE(212),
    [sym_color_definition] = STATE(212),
    [sym_color_set_definition] = STATE(212),
    [sym_color_reference] = STATE(212),
    [sym_tikz_library_import] = STATE(212),
    [sym_text_mode] = STATE(212),
    [sym_hyperlink] = STATE(212),
    [aux_sym__paragraph_repeat3] = STATE(563),
    [aux_sym_part_repeat1] = STATE(212),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2248),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_RBRACK] = ACTIONS(2439),
    [anon_sym_COMMA] = ACTIONS(2439),
    [anon_sym_EQ] = ACTIONS(2439),
    [anon_sym_LPAREN] = ACTIONS(2439),
    [anon_sym_RPAREN] = ACTIONS(2439),
    [anon_sym_BSLASHpart] = ACTIONS(2246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddpart] = ACTIONS(2246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHchapter] = ACTIONS(2246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddchap] = ACTIONS(2246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsection] = ACTIONS(2246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddsec] = ACTIONS(2246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2248),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [215] = {
    [sym_block_comment] = STATE(232),
    [sym__flat_content] = STATE(232),
    [sym__text_with_env_content] = STATE(232),
    [sym__text_content] = STATE(232),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(734),
    [sym_curly_group] = STATE(232),
    [sym_text] = STATE(232),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(232),
    [sym_inline_formula] = STATE(232),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(232),
    [sym_comment_environment] = STATE(232),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(232),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(232),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(232),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(232),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(232),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(232),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(232),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(232),
    [sym_generic_command] = STATE(232),
    [sym_title_declaration] = STATE(232),
    [sym_author_declaration] = STATE(232),
    [sym_package_include] = STATE(232),
    [sym_class_include] = STATE(232),
    [sym_latex_include] = STATE(232),
    [sym_biblatex_include] = STATE(232),
    [sym_bibstyle_include] = STATE(232),
    [sym_bibtex_include] = STATE(232),
    [sym_graphics_include] = STATE(232),
    [sym_svg_include] = STATE(232),
    [sym_inkscape_include] = STATE(232),
    [sym_verbatim_include] = STATE(232),
    [sym_import_include] = STATE(232),
    [sym_caption] = STATE(232),
    [sym_citation] = STATE(232),
    [sym_label_definition] = STATE(232),
    [sym_label_reference] = STATE(232),
    [sym_label_reference_range] = STATE(232),
    [sym_label_number] = STATE(232),
    [sym_new_command_definition] = STATE(232),
    [sym_old_command_definition] = STATE(232),
    [sym_let_command_definition] = STATE(232),
    [sym_math_delimiter] = STATE(232),
    [sym_paired_delimiter_definition] = STATE(232),
    [sym_environment_definition] = STATE(232),
    [sym_glossary_entry_definition] = STATE(232),
    [sym_glossary_entry_reference] = STATE(232),
    [sym_acronym_definition] = STATE(232),
    [sym_acronym_reference] = STATE(232),
    [sym_theorem_definition] = STATE(232),
    [sym_color_definition] = STATE(232),
    [sym_color_set_definition] = STATE(232),
    [sym_color_reference] = STATE(232),
    [sym_tikz_library_import] = STATE(232),
    [sym_text_mode] = STATE(232),
    [sym_hyperlink] = STATE(232),
    [aux_sym__paragraph_repeat3] = STATE(734),
    [aux_sym_part_repeat1] = STATE(232),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [216] = {
    [sym_block_comment] = STATE(215),
    [sym__flat_content] = STATE(215),
    [sym__text_with_env_content] = STATE(215),
    [sym__text_content] = STATE(215),
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(818),
    [sym_curly_group] = STATE(215),
    [sym_text] = STATE(215),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(215),
    [sym_inline_formula] = STATE(215),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(215),
    [sym_comment_environment] = STATE(215),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(215),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(215),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(215),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(215),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(215),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(215),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(215),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(215),
    [sym_generic_command] = STATE(215),
    [sym_title_declaration] = STATE(215),
    [sym_author_declaration] = STATE(215),
    [sym_package_include] = STATE(215),
    [sym_class_include] = STATE(215),
    [sym_latex_include] = STATE(215),
    [sym_biblatex_include] = STATE(215),
    [sym_bibstyle_include] = STATE(215),
    [sym_bibtex_include] = STATE(215),
    [sym_graphics_include] = STATE(215),
    [sym_svg_include] = STATE(215),
    [sym_inkscape_include] = STATE(215),
    [sym_verbatim_include] = STATE(215),
    [sym_import_include] = STATE(215),
    [sym_caption] = STATE(215),
    [sym_citation] = STATE(215),
    [sym_label_definition] = STATE(215),
    [sym_label_reference] = STATE(215),
    [sym_label_reference_range] = STATE(215),
    [sym_label_number] = STATE(215),
    [sym_new_command_definition] = STATE(215),
    [sym_old_command_definition] = STATE(215),
    [sym_let_command_definition] = STATE(215),
    [sym_math_delimiter] = STATE(215),
    [sym_paired_delimiter_definition] = STATE(215),
    [sym_environment_definition] = STATE(215),
    [sym_glossary_entry_definition] = STATE(215),
    [sym_glossary_entry_reference] = STATE(215),
    [sym_acronym_definition] = STATE(215),
    [sym_acronym_reference] = STATE(215),
    [sym_theorem_definition] = STATE(215),
    [sym_color_definition] = STATE(215),
    [sym_color_set_definition] = STATE(215),
    [sym_color_reference] = STATE(215),
    [sym_tikz_library_import] = STATE(215),
    [sym_text_mode] = STATE(215),
    [sym_hyperlink] = STATE(215),
    [aux_sym__paragraph_repeat3] = STATE(818),
    [aux_sym_part_repeat1] = STATE(215),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [anon_sym_RBRACK] = ACTIONS(2441),
    [anon_sym_COMMA] = ACTIONS(2441),
    [anon_sym_EQ] = ACTIONS(2441),
    [anon_sym_LPAREN] = ACTIONS(2441),
    [anon_sym_RPAREN] = ACTIONS(2441),
    [anon_sym_BSLASHpart] = ACTIONS(2246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddpart] = ACTIONS(2246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHchapter] = ACTIONS(2246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddchap] = ACTIONS(2246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsection] = ACTIONS(2246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddsec] = ACTIONS(2246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2248),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [217] = {
    [sym_block_comment] = STATE(218),
    [sym__flat_content] = STATE(218),
    [sym__text_with_env_content] = STATE(218),
    [sym__text_content] = STATE(218),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(728),
    [sym_curly_group] = STATE(218),
    [sym_text] = STATE(218),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(218),
    [sym_inline_formula] = STATE(218),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(218),
    [sym_comment_environment] = STATE(218),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(218),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(218),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(218),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(218),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(218),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(218),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(218),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(218),
    [sym_generic_command] = STATE(218),
    [sym_title_declaration] = STATE(218),
    [sym_author_declaration] = STATE(218),
    [sym_package_include] = STATE(218),
    [sym_class_include] = STATE(218),
    [sym_latex_include] = STATE(218),
    [sym_biblatex_include] = STATE(218),
    [sym_bibstyle_include] = STATE(218),
    [sym_bibtex_include] = STATE(218),
    [sym_graphics_include] = STATE(218),
    [sym_svg_include] = STATE(218),
    [sym_inkscape_include] = STATE(218),
    [sym_verbatim_include] = STATE(218),
    [sym_import_include] = STATE(218),
    [sym_caption] = STATE(218),
    [sym_citation] = STATE(218),
    [sym_label_definition] = STATE(218),
    [sym_label_reference] = STATE(218),
    [sym_label_reference_range] = STATE(218),
    [sym_label_number] = STATE(218),
    [sym_new_command_definition] = STATE(218),
    [sym_old_command_definition] = STATE(218),
    [sym_let_command_definition] = STATE(218),
    [sym_math_delimiter] = STATE(218),
    [sym_paired_delimiter_definition] = STATE(218),
    [sym_environment_definition] = STATE(218),
    [sym_glossary_entry_definition] = STATE(218),
    [sym_glossary_entry_reference] = STATE(218),
    [sym_acronym_definition] = STATE(218),
    [sym_acronym_reference] = STATE(218),
    [sym_theorem_definition] = STATE(218),
    [sym_color_definition] = STATE(218),
    [sym_color_set_definition] = STATE(218),
    [sym_color_reference] = STATE(218),
    [sym_tikz_library_import] = STATE(218),
    [sym_text_mode] = STATE(218),
    [sym_hyperlink] = STATE(218),
    [aux_sym__paragraph_repeat3] = STATE(728),
    [aux_sym_part_repeat1] = STATE(218),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2443),
    [anon_sym_RBRACK] = ACTIONS(2443),
    [anon_sym_COMMA] = ACTIONS(2443),
    [anon_sym_EQ] = ACTIONS(2443),
    [anon_sym_LPAREN] = ACTIONS(2443),
    [anon_sym_RPAREN] = ACTIONS(2443),
    [anon_sym_BSLASHpart] = ACTIONS(2246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddpart] = ACTIONS(2246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHchapter] = ACTIONS(2246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddchap] = ACTIONS(2246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsection] = ACTIONS(2246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddsec] = ACTIONS(2246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2246),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [218] = {
    [sym_block_comment] = STATE(228),
    [sym__flat_content] = STATE(228),
    [sym__text_with_env_content] = STATE(228),
    [sym__text_content] = STATE(228),
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(663),
    [sym_curly_group] = STATE(228),
    [sym_text] = STATE(228),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(228),
    [sym_inline_formula] = STATE(228),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(228),
    [sym_comment_environment] = STATE(228),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(228),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(228),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(228),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(228),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(228),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(228),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(228),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(228),
    [sym_generic_command] = STATE(228),
    [sym_title_declaration] = STATE(228),
    [sym_author_declaration] = STATE(228),
    [sym_package_include] = STATE(228),
    [sym_class_include] = STATE(228),
    [sym_latex_include] = STATE(228),
    [sym_biblatex_include] = STATE(228),
    [sym_bibstyle_include] = STATE(228),
    [sym_bibtex_include] = STATE(228),
    [sym_graphics_include] = STATE(228),
    [sym_svg_include] = STATE(228),
    [sym_inkscape_include] = STATE(228),
    [sym_verbatim_include] = STATE(228),
    [sym_import_include] = STATE(228),
    [sym_caption] = STATE(228),
    [sym_citation] = STATE(228),
    [sym_label_definition] = STATE(228),
    [sym_label_reference] = STATE(228),
    [sym_label_reference_range] = STATE(228),
    [sym_label_number] = STATE(228),
    [sym_new_command_definition] = STATE(228),
    [sym_old_command_definition] = STATE(228),
    [sym_let_command_definition] = STATE(228),
    [sym_math_delimiter] = STATE(228),
    [sym_paired_delimiter_definition] = STATE(228),
    [sym_environment_definition] = STATE(228),
    [sym_glossary_entry_definition] = STATE(228),
    [sym_glossary_entry_reference] = STATE(228),
    [sym_acronym_definition] = STATE(228),
    [sym_acronym_reference] = STATE(228),
    [sym_theorem_definition] = STATE(228),
    [sym_color_definition] = STATE(228),
    [sym_color_set_definition] = STATE(228),
    [sym_color_reference] = STATE(228),
    [sym_tikz_library_import] = STATE(228),
    [sym_text_mode] = STATE(228),
    [sym_hyperlink] = STATE(228),
    [aux_sym__paragraph_repeat3] = STATE(663),
    [aux_sym_part_repeat1] = STATE(228),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2250),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [219] = {
    [sym_block_comment] = STATE(231),
    [sym__flat_content] = STATE(231),
    [sym__text_with_env_content] = STATE(231),
    [sym__text_content] = STATE(231),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(693),
    [sym_curly_group] = STATE(231),
    [sym_text] = STATE(231),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(231),
    [sym_inline_formula] = STATE(231),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(231),
    [sym_comment_environment] = STATE(231),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(231),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(231),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(231),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(231),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(231),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(231),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(231),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(231),
    [sym_generic_command] = STATE(231),
    [sym_title_declaration] = STATE(231),
    [sym_author_declaration] = STATE(231),
    [sym_package_include] = STATE(231),
    [sym_class_include] = STATE(231),
    [sym_latex_include] = STATE(231),
    [sym_biblatex_include] = STATE(231),
    [sym_bibstyle_include] = STATE(231),
    [sym_bibtex_include] = STATE(231),
    [sym_graphics_include] = STATE(231),
    [sym_svg_include] = STATE(231),
    [sym_inkscape_include] = STATE(231),
    [sym_verbatim_include] = STATE(231),
    [sym_import_include] = STATE(231),
    [sym_caption] = STATE(231),
    [sym_citation] = STATE(231),
    [sym_label_definition] = STATE(231),
    [sym_label_reference] = STATE(231),
    [sym_label_reference_range] = STATE(231),
    [sym_label_number] = STATE(231),
    [sym_new_command_definition] = STATE(231),
    [sym_old_command_definition] = STATE(231),
    [sym_let_command_definition] = STATE(231),
    [sym_math_delimiter] = STATE(231),
    [sym_paired_delimiter_definition] = STATE(231),
    [sym_environment_definition] = STATE(231),
    [sym_glossary_entry_definition] = STATE(231),
    [sym_glossary_entry_reference] = STATE(231),
    [sym_acronym_definition] = STATE(231),
    [sym_acronym_reference] = STATE(231),
    [sym_theorem_definition] = STATE(231),
    [sym_color_definition] = STATE(231),
    [sym_color_set_definition] = STATE(231),
    [sym_color_reference] = STATE(231),
    [sym_tikz_library_import] = STATE(231),
    [sym_text_mode] = STATE(231),
    [sym_hyperlink] = STATE(231),
    [aux_sym__paragraph_repeat3] = STATE(693),
    [aux_sym_part_repeat1] = STATE(231),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_RBRACK] = ACTIONS(2156),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_EQ] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2252),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [220] = {
    [sym_block_comment] = STATE(219),
    [sym__flat_content] = STATE(219),
    [sym__text_with_env_content] = STATE(219),
    [sym__text_content] = STATE(219),
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(717),
    [sym_curly_group] = STATE(219),
    [sym_text] = STATE(219),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(219),
    [sym_inline_formula] = STATE(219),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(219),
    [sym_comment_environment] = STATE(219),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(219),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(219),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(219),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(219),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(219),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(219),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(219),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(219),
    [sym_generic_command] = STATE(219),
    [sym_title_declaration] = STATE(219),
    [sym_author_declaration] = STATE(219),
    [sym_package_include] = STATE(219),
    [sym_class_include] = STATE(219),
    [sym_latex_include] = STATE(219),
    [sym_biblatex_include] = STATE(219),
    [sym_bibstyle_include] = STATE(219),
    [sym_bibtex_include] = STATE(219),
    [sym_graphics_include] = STATE(219),
    [sym_svg_include] = STATE(219),
    [sym_inkscape_include] = STATE(219),
    [sym_verbatim_include] = STATE(219),
    [sym_import_include] = STATE(219),
    [sym_caption] = STATE(219),
    [sym_citation] = STATE(219),
    [sym_label_definition] = STATE(219),
    [sym_label_reference] = STATE(219),
    [sym_label_reference_range] = STATE(219),
    [sym_label_number] = STATE(219),
    [sym_new_command_definition] = STATE(219),
    [sym_old_command_definition] = STATE(219),
    [sym_let_command_definition] = STATE(219),
    [sym_math_delimiter] = STATE(219),
    [sym_paired_delimiter_definition] = STATE(219),
    [sym_environment_definition] = STATE(219),
    [sym_glossary_entry_definition] = STATE(219),
    [sym_glossary_entry_reference] = STATE(219),
    [sym_acronym_definition] = STATE(219),
    [sym_acronym_reference] = STATE(219),
    [sym_theorem_definition] = STATE(219),
    [sym_color_definition] = STATE(219),
    [sym_color_set_definition] = STATE(219),
    [sym_color_reference] = STATE(219),
    [sym_tikz_library_import] = STATE(219),
    [sym_text_mode] = STATE(219),
    [sym_hyperlink] = STATE(219),
    [aux_sym__paragraph_repeat3] = STATE(717),
    [aux_sym_part_repeat1] = STATE(219),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2445),
    [anon_sym_RBRACK] = ACTIONS(2445),
    [anon_sym_COMMA] = ACTIONS(2445),
    [anon_sym_EQ] = ACTIONS(2445),
    [anon_sym_LPAREN] = ACTIONS(2445),
    [anon_sym_RPAREN] = ACTIONS(2445),
    [anon_sym_BSLASHpart] = ACTIONS(2246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddpart] = ACTIONS(2246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHchapter] = ACTIONS(2246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddchap] = ACTIONS(2246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsection] = ACTIONS(2246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHaddsec] = ACTIONS(2246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2248),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [221] = {
    [sym_block_comment] = STATE(221),
    [sym__flat_content] = STATE(221),
    [sym__text_with_env_content] = STATE(221),
    [sym__text_content] = STATE(221),
    [sym_curly_group] = STATE(221),
    [sym_text] = STATE(221),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(221),
    [sym_inline_formula] = STATE(221),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(221),
    [sym_comment_environment] = STATE(221),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(221),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(221),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(221),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(221),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(221),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(221),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(221),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(221),
    [sym_generic_command] = STATE(221),
    [sym_title_declaration] = STATE(221),
    [sym_author_declaration] = STATE(221),
    [sym_package_include] = STATE(221),
    [sym_class_include] = STATE(221),
    [sym_latex_include] = STATE(221),
    [sym_biblatex_include] = STATE(221),
    [sym_bibstyle_include] = STATE(221),
    [sym_bibtex_include] = STATE(221),
    [sym_graphics_include] = STATE(221),
    [sym_svg_include] = STATE(221),
    [sym_inkscape_include] = STATE(221),
    [sym_verbatim_include] = STATE(221),
    [sym_import_include] = STATE(221),
    [sym_caption] = STATE(221),
    [sym_citation] = STATE(221),
    [sym_label_definition] = STATE(221),
    [sym_label_reference] = STATE(221),
    [sym_label_reference_range] = STATE(221),
    [sym_label_number] = STATE(221),
    [sym_new_command_definition] = STATE(221),
    [sym_old_command_definition] = STATE(221),
    [sym_let_command_definition] = STATE(221),
    [sym_math_delimiter] = STATE(221),
    [sym_paired_delimiter_definition] = STATE(221),
    [sym_environment_definition] = STATE(221),
    [sym_glossary_entry_definition] = STATE(221),
    [sym_glossary_entry_reference] = STATE(221),
    [sym_acronym_definition] = STATE(221),
    [sym_acronym_reference] = STATE(221),
    [sym_theorem_definition] = STATE(221),
    [sym_color_definition] = STATE(221),
    [sym_color_set_definition] = STATE(221),
    [sym_color_reference] = STATE(221),
    [sym_tikz_library_import] = STATE(221),
    [sym_text_mode] = STATE(221),
    [sym_hyperlink] = STATE(221),
    [aux_sym_part_repeat1] = STATE(221),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2277),
    [sym_command_name] = ACTIONS(2447),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2453),
    [anon_sym_RBRACK] = ACTIONS(2453),
    [anon_sym_COMMA] = ACTIONS(2453),
    [anon_sym_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(2453),
    [anon_sym_RPAREN] = ACTIONS(2453),
    [anon_sym_BSLASHpart] = ACTIONS(2275),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddpart] = ACTIONS(2275),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHchapter] = ACTIONS(2275),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddchap] = ACTIONS(2275),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsection] = ACTIONS(2275),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddsec] = ACTIONS(2275),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHitem] = ACTIONS(2275),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2277),
    [sym_word] = ACTIONS(2459),
    [sym_placeholder] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2465),
    [anon_sym_DASH] = ACTIONS(2465),
    [anon_sym_STAR] = ACTIONS(2465),
    [anon_sym_SLASH] = ACTIONS(2465),
    [anon_sym_LT] = ACTIONS(2468),
    [anon_sym_GT] = ACTIONS(2468),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_PIPE] = ACTIONS(2468),
    [anon_sym_COLON] = ACTIONS(2468),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [anon_sym__] = ACTIONS(2471),
    [anon_sym_CARET] = ACTIONS(2474),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2477),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2477),
    [anon_sym_DOLLAR] = ACTIONS(2480),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2483),
    [anon_sym_BSLASHbegin] = ACTIONS(2309),
    [anon_sym_BSLASHtitle] = ACTIONS(2486),
    [anon_sym_BSLASHauthor] = ACTIONS(2489),
    [anon_sym_BSLASHusepackage] = ACTIONS(2492),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2492),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2495),
    [anon_sym_BSLASHinclude] = ACTIONS(2498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2498),
    [anon_sym_BSLASHinput] = ACTIONS(2498),
    [anon_sym_BSLASHsubfile] = ACTIONS(2498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2501),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2504),
    [anon_sym_BSLASHbibliography] = ACTIONS(2507),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2513),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2516),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2519),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2519),
    [anon_sym_BSLASHimport] = ACTIONS(2522),
    [anon_sym_BSLASHsubimport] = ACTIONS(2522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2522),
    [anon_sym_BSLASHcaption] = ACTIONS(2525),
    [anon_sym_BSLASHcite] = ACTIONS(2528),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHCite] = ACTIONS(2528),
    [anon_sym_BSLASHnocite] = ACTIONS(2528),
    [anon_sym_BSLASHcitet] = ACTIONS(2528),
    [anon_sym_BSLASHcitep] = ACTIONS(2528),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHciteA] = ACTIONS(2528),
    [anon_sym_BSLASHciteR] = ACTIONS(2528),
    [anon_sym_BSLASHciteS] = ACTIONS(2528),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2528),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2528),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2528),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2528),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHciteyear] = ACTIONS(2528),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHcitedate] = ACTIONS(2528),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHciteurl] = ACTIONS(2528),
    [anon_sym_BSLASHfullcite] = ACTIONS(2528),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2528),
    [anon_sym_BSLASHcitealt] = ACTIONS(2528),
    [anon_sym_BSLASHcitealp] = ACTIONS(2528),
    [anon_sym_BSLASHcitetext] = ACTIONS(2528),
    [anon_sym_BSLASHparencite] = ACTIONS(2528),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHParencite] = ACTIONS(2528),
    [anon_sym_BSLASHfootcite] = ACTIONS(2528),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2528),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2528),
    [anon_sym_BSLASHtextcite] = ACTIONS(2528),
    [anon_sym_BSLASHTextcite] = ACTIONS(2528),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2528),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2528),
    [anon_sym_BSLASHsupercite] = ACTIONS(2528),
    [anon_sym_BSLASHautocite] = ACTIONS(2528),
    [anon_sym_BSLASHAutocite] = ACTIONS(2528),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2531),
    [anon_sym_BSLASHvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHVolcite] = ACTIONS(2528),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHavolcite] = ACTIONS(2528),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2528),
    [anon_sym_BSLASHnotecite] = ACTIONS(2528),
    [anon_sym_BSLASHNotecite] = ACTIONS(2528),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2528),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2528),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2528),
    [anon_sym_BSLASHlabel] = ACTIONS(2534),
    [anon_sym_BSLASHref] = ACTIONS(2537),
    [anon_sym_BSLASHeqref] = ACTIONS(2537),
    [anon_sym_BSLASHvref] = ACTIONS(2537),
    [anon_sym_BSLASHVref] = ACTIONS(2537),
    [anon_sym_BSLASHautoref] = ACTIONS(2537),
    [anon_sym_BSLASHpageref] = ACTIONS(2537),
    [anon_sym_BSLASHcref] = ACTIONS(2537),
    [anon_sym_BSLASHCref] = ACTIONS(2537),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2540),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2540),
    [anon_sym_BSLASHnamecref] = ACTIONS(2537),
    [anon_sym_BSLASHnameCref] = ACTIONS(2537),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2537),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2537),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2537),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2537),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2537),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2537),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2543),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2546),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2543),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2546),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2549),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2552),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2555),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2552),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2555),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2552),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2555),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2552),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2555),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2552),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2552),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2552),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2552),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2552),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2552),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2552),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2552),
    [anon_sym_BSLASHdef] = ACTIONS(2558),
    [anon_sym_BSLASHlet] = ACTIONS(2561),
    [anon_sym_BSLASHleft] = ACTIONS(2564),
    [anon_sym_BSLASHbigl] = ACTIONS(2564),
    [anon_sym_BSLASHBigl] = ACTIONS(2564),
    [anon_sym_BSLASHbiggl] = ACTIONS(2564),
    [anon_sym_BSLASHBiggl] = ACTIONS(2564),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2567),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2567),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2570),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2570),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2570),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2570),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2570),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2570),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2573),
    [anon_sym_BSLASHgls] = ACTIONS(2576),
    [anon_sym_BSLASHGls] = ACTIONS(2576),
    [anon_sym_BSLASHGLS] = ACTIONS(2576),
    [anon_sym_BSLASHglspl] = ACTIONS(2576),
    [anon_sym_BSLASHGlspl] = ACTIONS(2576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2576),
    [anon_sym_BSLASHglslink] = ACTIONS(2576),
    [anon_sym_BSLASHglstext] = ACTIONS(2576),
    [anon_sym_BSLASHGlstext] = ACTIONS(2576),
    [anon_sym_BSLASHGLStext] = ACTIONS(2576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2576),
    [anon_sym_BSLASHglsplural] = ACTIONS(2576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2576),
    [anon_sym_BSLASHglsname] = ACTIONS(2576),
    [anon_sym_BSLASHGlsname] = ACTIONS(2576),
    [anon_sym_BSLASHGLSname] = ACTIONS(2576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2579),
    [anon_sym_BSLASHacrshort] = ACTIONS(2582),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2582),
    [anon_sym_BSLASHACRshort] = ACTIONS(2582),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2582),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2582),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2582),
    [anon_sym_BSLASHacrlong] = ACTIONS(2582),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2582),
    [anon_sym_BSLASHACRlong] = ACTIONS(2582),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2582),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2582),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2582),
    [anon_sym_BSLASHacrfull] = ACTIONS(2582),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2582),
    [anon_sym_BSLASHACRfull] = ACTIONS(2582),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2582),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2582),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2582),
    [anon_sym_BSLASHacs] = ACTIONS(2582),
    [anon_sym_BSLASHAcs] = ACTIONS(2582),
    [anon_sym_BSLASHacsp] = ACTIONS(2582),
    [anon_sym_BSLASHAcsp] = ACTIONS(2582),
    [anon_sym_BSLASHacl] = ACTIONS(2582),
    [anon_sym_BSLASHAcl] = ACTIONS(2582),
    [anon_sym_BSLASHaclp] = ACTIONS(2582),
    [anon_sym_BSLASHAclp] = ACTIONS(2582),
    [anon_sym_BSLASHacf] = ACTIONS(2582),
    [anon_sym_BSLASHAcf] = ACTIONS(2582),
    [anon_sym_BSLASHacfp] = ACTIONS(2582),
    [anon_sym_BSLASHAcfp] = ACTIONS(2582),
    [anon_sym_BSLASHac] = ACTIONS(2582),
    [anon_sym_BSLASHAc] = ACTIONS(2582),
    [anon_sym_BSLASHacp] = ACTIONS(2582),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2582),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2582),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2582),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2582),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2582),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2582),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2582),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2582),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2582),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2582),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2585),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2585),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2591),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2594),
    [anon_sym_BSLASHcolor] = ACTIONS(2597),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2597),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2597),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2597),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2600),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2600),
    [anon_sym_BSLASHtext] = ACTIONS(2603),
    [anon_sym_BSLASHintertext] = ACTIONS(2603),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2603),
    [anon_sym_BSLASHurl] = ACTIONS(2606),
    [anon_sym_BSLASHhref] = ACTIONS(2606),
  },
  [222] = {
    [sym_block_comment] = STATE(221),
    [sym__flat_content] = STATE(221),
    [sym__text_with_env_content] = STATE(221),
    [sym__text_content] = STATE(221),
    [sym_curly_group] = STATE(221),
    [sym_text] = STATE(221),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(221),
    [sym_inline_formula] = STATE(221),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(221),
    [sym_comment_environment] = STATE(221),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(221),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(221),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(221),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(221),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(221),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(221),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(221),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(221),
    [sym_generic_command] = STATE(221),
    [sym_title_declaration] = STATE(221),
    [sym_author_declaration] = STATE(221),
    [sym_package_include] = STATE(221),
    [sym_class_include] = STATE(221),
    [sym_latex_include] = STATE(221),
    [sym_biblatex_include] = STATE(221),
    [sym_bibstyle_include] = STATE(221),
    [sym_bibtex_include] = STATE(221),
    [sym_graphics_include] = STATE(221),
    [sym_svg_include] = STATE(221),
    [sym_inkscape_include] = STATE(221),
    [sym_verbatim_include] = STATE(221),
    [sym_import_include] = STATE(221),
    [sym_caption] = STATE(221),
    [sym_citation] = STATE(221),
    [sym_label_definition] = STATE(221),
    [sym_label_reference] = STATE(221),
    [sym_label_reference_range] = STATE(221),
    [sym_label_number] = STATE(221),
    [sym_new_command_definition] = STATE(221),
    [sym_old_command_definition] = STATE(221),
    [sym_let_command_definition] = STATE(221),
    [sym_math_delimiter] = STATE(221),
    [sym_paired_delimiter_definition] = STATE(221),
    [sym_environment_definition] = STATE(221),
    [sym_glossary_entry_definition] = STATE(221),
    [sym_glossary_entry_reference] = STATE(221),
    [sym_acronym_definition] = STATE(221),
    [sym_acronym_reference] = STATE(221),
    [sym_theorem_definition] = STATE(221),
    [sym_color_definition] = STATE(221),
    [sym_color_set_definition] = STATE(221),
    [sym_color_reference] = STATE(221),
    [sym_tikz_library_import] = STATE(221),
    [sym_text_mode] = STATE(221),
    [sym_hyperlink] = STATE(221),
    [aux_sym_part_repeat1] = STATE(221),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2437),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2142),
    [anon_sym_RBRACK] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2142),
    [anon_sym_EQ] = ACTIONS(2142),
    [anon_sym_LPAREN] = ACTIONS(2142),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_BSLASHpart] = ACTIONS(2435),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddpart] = ACTIONS(2435),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHchapter] = ACTIONS(2435),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddchap] = ACTIONS(2435),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsection] = ACTIONS(2435),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddsec] = ACTIONS(2435),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHitem] = ACTIONS(2435),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2437),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [223] = {
    [sym_block_comment] = STATE(222),
    [sym__flat_content] = STATE(222),
    [sym__text_with_env_content] = STATE(222),
    [sym__text_content] = STATE(222),
    [sym_curly_group] = STATE(222),
    [sym_text] = STATE(222),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym_displayed_equation] = STATE(222),
    [sym_inline_formula] = STATE(222),
    [sym_begin] = STATE(65),
    [sym_generic_environment] = STATE(222),
    [sym_comment_environment] = STATE(222),
    [sym__comment_environment_begin] = STATE(3329),
    [sym_verbatim_environment] = STATE(222),
    [sym__verbatim_environment_begin] = STATE(3330),
    [sym_listing_environment] = STATE(222),
    [sym__listing_environment_begin] = STATE(3331),
    [sym_minted_environment] = STATE(222),
    [sym__minted_environment_begin] = STATE(3341),
    [sym_pycode_environment] = STATE(222),
    [sym__pycode_environment_begin] = STATE(3343),
    [sym_sagesilent_environment] = STATE(222),
    [sym__sagesilent_environment_begin] = STATE(3346),
    [sym_sageblock_environment] = STATE(222),
    [sym__sageblock_environment_begin] = STATE(3350),
    [sym_math_environment] = STATE(222),
    [sym__math_environment_begin] = STATE(233),
    [sym__command] = STATE(222),
    [sym_generic_command] = STATE(222),
    [sym_title_declaration] = STATE(222),
    [sym_author_declaration] = STATE(222),
    [sym_package_include] = STATE(222),
    [sym_class_include] = STATE(222),
    [sym_latex_include] = STATE(222),
    [sym_biblatex_include] = STATE(222),
    [sym_bibstyle_include] = STATE(222),
    [sym_bibtex_include] = STATE(222),
    [sym_graphics_include] = STATE(222),
    [sym_svg_include] = STATE(222),
    [sym_inkscape_include] = STATE(222),
    [sym_verbatim_include] = STATE(222),
    [sym_import_include] = STATE(222),
    [sym_caption] = STATE(222),
    [sym_citation] = STATE(222),
    [sym_label_definition] = STATE(222),
    [sym_label_reference] = STATE(222),
    [sym_label_reference_range] = STATE(222),
    [sym_label_number] = STATE(222),
    [sym_new_command_definition] = STATE(222),
    [sym_old_command_definition] = STATE(222),
    [sym_let_command_definition] = STATE(222),
    [sym_math_delimiter] = STATE(222),
    [sym_paired_delimiter_definition] = STATE(222),
    [sym_environment_definition] = STATE(222),
    [sym_glossary_entry_definition] = STATE(222),
    [sym_glossary_entry_reference] = STATE(222),
    [sym_acronym_definition] = STATE(222),
    [sym_acronym_reference] = STATE(222),
    [sym_theorem_definition] = STATE(222),
    [sym_color_definition] = STATE(222),
    [sym_color_set_definition] = STATE(222),
    [sym_color_reference] = STATE(222),
    [sym_tikz_library_import] = STATE(222),
    [sym_text_mode] = STATE(222),
    [sym_hyperlink] = STATE(222),
    [aux_sym_part_repeat1] = STATE(222),
    [aux_sym_text_repeat1] = STATE(257),
    [ts_builtin_sym_end] = ACTIONS(2264),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_RBRACK] = ACTIONS(2609),
    [anon_sym_COMMA] = ACTIONS(2609),
    [anon_sym_EQ] = ACTIONS(2609),
    [anon_sym_LPAREN] = ACTIONS(2609),
    [anon_sym_RPAREN] = ACTIONS(2609),
    [anon_sym_BSLASHpart] = ACTIONS(2262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddpart] = ACTIONS(2262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHchapter] = ACTIONS(2262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddchap] = ACTIONS(2262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsection] = ACTIONS(2262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddsec] = ACTIONS(2262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHitem] = ACTIONS(2262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2264),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(59),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(59),
    [anon_sym_DOLLAR] = ACTIONS(61),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(63),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(119),
    [anon_sym_BSLASHbigl] = ACTIONS(119),
    [anon_sym_BSLASHBigl] = ACTIONS(119),
    [anon_sym_BSLASHbiggl] = ACTIONS(119),
    [anon_sym_BSLASHBiggl] = ACTIONS(119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(145),
    [anon_sym_BSLASHintertext] = ACTIONS(145),
    [anon_sym_BSLASHshortintertext] = ACTIONS(145),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [224] = {
    [sym_block_comment] = STATE(228),
    [sym__flat_content] = STATE(228),
    [sym__text_with_env_content] = STATE(228),
    [sym__text_content] = STATE(228),
    [sym_curly_group] = STATE(228),
    [sym_text] = STATE(228),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(228),
    [sym_inline_formula] = STATE(228),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(228),
    [sym_comment_environment] = STATE(228),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(228),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(228),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(228),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(228),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(228),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(228),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(228),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(228),
    [sym_generic_command] = STATE(228),
    [sym_title_declaration] = STATE(228),
    [sym_author_declaration] = STATE(228),
    [sym_package_include] = STATE(228),
    [sym_class_include] = STATE(228),
    [sym_latex_include] = STATE(228),
    [sym_biblatex_include] = STATE(228),
    [sym_bibstyle_include] = STATE(228),
    [sym_bibtex_include] = STATE(228),
    [sym_graphics_include] = STATE(228),
    [sym_svg_include] = STATE(228),
    [sym_inkscape_include] = STATE(228),
    [sym_verbatim_include] = STATE(228),
    [sym_import_include] = STATE(228),
    [sym_caption] = STATE(228),
    [sym_citation] = STATE(228),
    [sym_label_definition] = STATE(228),
    [sym_label_reference] = STATE(228),
    [sym_label_reference_range] = STATE(228),
    [sym_label_number] = STATE(228),
    [sym_new_command_definition] = STATE(228),
    [sym_old_command_definition] = STATE(228),
    [sym_let_command_definition] = STATE(228),
    [sym_math_delimiter] = STATE(228),
    [sym_paired_delimiter_definition] = STATE(228),
    [sym_environment_definition] = STATE(228),
    [sym_glossary_entry_definition] = STATE(228),
    [sym_glossary_entry_reference] = STATE(228),
    [sym_acronym_definition] = STATE(228),
    [sym_acronym_reference] = STATE(228),
    [sym_theorem_definition] = STATE(228),
    [sym_color_definition] = STATE(228),
    [sym_color_set_definition] = STATE(228),
    [sym_color_reference] = STATE(228),
    [sym_tikz_library_import] = STATE(228),
    [sym_text_mode] = STATE(228),
    [sym_hyperlink] = STATE(228),
    [aux_sym_part_repeat1] = STATE(228),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2158),
    [anon_sym_RBRACK] = ACTIONS(2158),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_LPAREN] = ACTIONS(2158),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_BSLASHpart] = ACTIONS(2435),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddpart] = ACTIONS(2435),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHchapter] = ACTIONS(2435),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddchap] = ACTIONS(2435),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsection] = ACTIONS(2435),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddsec] = ACTIONS(2435),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHitem] = ACTIONS(2435),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2435),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [225] = {
    [sym_block_comment] = STATE(231),
    [sym__flat_content] = STATE(231),
    [sym__text_with_env_content] = STATE(231),
    [sym__text_content] = STATE(231),
    [sym_curly_group] = STATE(231),
    [sym_text] = STATE(231),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(231),
    [sym_inline_formula] = STATE(231),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(231),
    [sym_comment_environment] = STATE(231),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(231),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(231),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(231),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(231),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(231),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(231),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(231),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(231),
    [sym_generic_command] = STATE(231),
    [sym_title_declaration] = STATE(231),
    [sym_author_declaration] = STATE(231),
    [sym_package_include] = STATE(231),
    [sym_class_include] = STATE(231),
    [sym_latex_include] = STATE(231),
    [sym_biblatex_include] = STATE(231),
    [sym_bibstyle_include] = STATE(231),
    [sym_bibtex_include] = STATE(231),
    [sym_graphics_include] = STATE(231),
    [sym_svg_include] = STATE(231),
    [sym_inkscape_include] = STATE(231),
    [sym_verbatim_include] = STATE(231),
    [sym_import_include] = STATE(231),
    [sym_caption] = STATE(231),
    [sym_citation] = STATE(231),
    [sym_label_definition] = STATE(231),
    [sym_label_reference] = STATE(231),
    [sym_label_reference_range] = STATE(231),
    [sym_label_number] = STATE(231),
    [sym_new_command_definition] = STATE(231),
    [sym_old_command_definition] = STATE(231),
    [sym_let_command_definition] = STATE(231),
    [sym_math_delimiter] = STATE(231),
    [sym_paired_delimiter_definition] = STATE(231),
    [sym_environment_definition] = STATE(231),
    [sym_glossary_entry_definition] = STATE(231),
    [sym_glossary_entry_reference] = STATE(231),
    [sym_acronym_definition] = STATE(231),
    [sym_acronym_reference] = STATE(231),
    [sym_theorem_definition] = STATE(231),
    [sym_color_definition] = STATE(231),
    [sym_color_set_definition] = STATE(231),
    [sym_color_reference] = STATE(231),
    [sym_tikz_library_import] = STATE(231),
    [sym_text_mode] = STATE(231),
    [sym_hyperlink] = STATE(231),
    [aux_sym_part_repeat1] = STATE(231),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2156),
    [anon_sym_RBRACK] = ACTIONS(2156),
    [anon_sym_COMMA] = ACTIONS(2156),
    [anon_sym_EQ] = ACTIONS(2156),
    [anon_sym_LPAREN] = ACTIONS(2156),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_BSLASHpart] = ACTIONS(2435),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddpart] = ACTIONS(2435),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHchapter] = ACTIONS(2435),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddchap] = ACTIONS(2435),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsection] = ACTIONS(2435),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddsec] = ACTIONS(2435),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHitem] = ACTIONS(2435),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2437),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [226] = {
    [sym_block_comment] = STATE(232),
    [sym__flat_content] = STATE(232),
    [sym__text_with_env_content] = STATE(232),
    [sym__text_content] = STATE(232),
    [sym_curly_group] = STATE(232),
    [sym_text] = STATE(232),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(232),
    [sym_inline_formula] = STATE(232),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(232),
    [sym_comment_environment] = STATE(232),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(232),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(232),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(232),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(232),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(232),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(232),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(232),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(232),
    [sym_generic_command] = STATE(232),
    [sym_title_declaration] = STATE(232),
    [sym_author_declaration] = STATE(232),
    [sym_package_include] = STATE(232),
    [sym_class_include] = STATE(232),
    [sym_latex_include] = STATE(232),
    [sym_biblatex_include] = STATE(232),
    [sym_bibstyle_include] = STATE(232),
    [sym_bibtex_include] = STATE(232),
    [sym_graphics_include] = STATE(232),
    [sym_svg_include] = STATE(232),
    [sym_inkscape_include] = STATE(232),
    [sym_verbatim_include] = STATE(232),
    [sym_import_include] = STATE(232),
    [sym_caption] = STATE(232),
    [sym_citation] = STATE(232),
    [sym_label_definition] = STATE(232),
    [sym_label_reference] = STATE(232),
    [sym_label_reference_range] = STATE(232),
    [sym_label_number] = STATE(232),
    [sym_new_command_definition] = STATE(232),
    [sym_old_command_definition] = STATE(232),
    [sym_let_command_definition] = STATE(232),
    [sym_math_delimiter] = STATE(232),
    [sym_paired_delimiter_definition] = STATE(232),
    [sym_environment_definition] = STATE(232),
    [sym_glossary_entry_definition] = STATE(232),
    [sym_glossary_entry_reference] = STATE(232),
    [sym_acronym_definition] = STATE(232),
    [sym_acronym_reference] = STATE(232),
    [sym_theorem_definition] = STATE(232),
    [sym_color_definition] = STATE(232),
    [sym_color_set_definition] = STATE(232),
    [sym_color_reference] = STATE(232),
    [sym_tikz_library_import] = STATE(232),
    [sym_text_mode] = STATE(232),
    [sym_hyperlink] = STATE(232),
    [aux_sym_part_repeat1] = STATE(232),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2166),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_BSLASHpart] = ACTIONS(2435),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddpart] = ACTIONS(2435),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHchapter] = ACTIONS(2435),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddchap] = ACTIONS(2435),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsection] = ACTIONS(2435),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHaddsec] = ACTIONS(2435),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2435),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2435),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2437),
    [anon_sym_BSLASHitem] = ACTIONS(2435),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2437),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [227] = {
    [sym_block_comment] = STATE(224),
    [sym__flat_content] = STATE(224),
    [sym__text_with_env_content] = STATE(224),
    [sym__text_content] = STATE(224),
    [sym_curly_group] = STATE(224),
    [sym_text] = STATE(224),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(224),
    [sym_inline_formula] = STATE(224),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(224),
    [sym_comment_environment] = STATE(224),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(224),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(224),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(224),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(224),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(224),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(224),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(224),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(224),
    [sym_generic_command] = STATE(224),
    [sym_title_declaration] = STATE(224),
    [sym_author_declaration] = STATE(224),
    [sym_package_include] = STATE(224),
    [sym_class_include] = STATE(224),
    [sym_latex_include] = STATE(224),
    [sym_biblatex_include] = STATE(224),
    [sym_bibstyle_include] = STATE(224),
    [sym_bibtex_include] = STATE(224),
    [sym_graphics_include] = STATE(224),
    [sym_svg_include] = STATE(224),
    [sym_inkscape_include] = STATE(224),
    [sym_verbatim_include] = STATE(224),
    [sym_import_include] = STATE(224),
    [sym_caption] = STATE(224),
    [sym_citation] = STATE(224),
    [sym_label_definition] = STATE(224),
    [sym_label_reference] = STATE(224),
    [sym_label_reference_range] = STATE(224),
    [sym_label_number] = STATE(224),
    [sym_new_command_definition] = STATE(224),
    [sym_old_command_definition] = STATE(224),
    [sym_let_command_definition] = STATE(224),
    [sym_math_delimiter] = STATE(224),
    [sym_paired_delimiter_definition] = STATE(224),
    [sym_environment_definition] = STATE(224),
    [sym_glossary_entry_definition] = STATE(224),
    [sym_glossary_entry_reference] = STATE(224),
    [sym_acronym_definition] = STATE(224),
    [sym_acronym_reference] = STATE(224),
    [sym_theorem_definition] = STATE(224),
    [sym_color_definition] = STATE(224),
    [sym_color_set_definition] = STATE(224),
    [sym_color_reference] = STATE(224),
    [sym_tikz_library_import] = STATE(224),
    [sym_text_mode] = STATE(224),
    [sym_hyperlink] = STATE(224),
    [aux_sym_part_repeat1] = STATE(224),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(2611),
    [anon_sym_RBRACK] = ACTIONS(2611),
    [anon_sym_COMMA] = ACTIONS(2611),
    [anon_sym_EQ] = ACTIONS(2611),
    [anon_sym_LPAREN] = ACTIONS(2611),
    [anon_sym_RPAREN] = ACTIONS(2611),
    [anon_sym_BSLASHpart] = ACTIONS(2262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddpart] = ACTIONS(2262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHchapter] = ACTIONS(2262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddchap] = ACTIONS(2262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsection] = ACTIONS(2262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddsec] = ACTIONS(2262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHitem] = ACTIONS(2262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(698),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(698),
    [anon_sym_DOLLAR] = ACTIONS(700),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(702),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(2262),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(758),
    [anon_sym_BSLASHbigl] = ACTIONS(758),
    [anon_sym_BSLASHBigl] = ACTIONS(758),
    [anon_sym_BSLASHbiggl] = ACTIONS(758),
    [anon_sym_BSLASHBiggl] = ACTIONS(758),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(784),
    [anon_sym_BSLASHintertext] = ACTIONS(784),
    [anon_sym_BSLASHshortintertext] = ACTIONS(784),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [228] = {
    [sym_block_comment] = STATE(228),
    [sym__flat_content] = STATE(228),
    [sym__text_with_env_content] = STATE(228),
    [sym__text_content] = STATE(228),
    [sym_curly_group] = STATE(228),
    [sym_text] = STATE(228),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym_displayed_equation] = STATE(228),
    [sym_inline_formula] = STATE(228),
    [sym_begin] = STATE(57),
    [sym_generic_environment] = STATE(228),
    [sym_comment_environment] = STATE(228),
    [sym__comment_environment_begin] = STATE(3259),
    [sym_verbatim_environment] = STATE(228),
    [sym__verbatim_environment_begin] = STATE(3258),
    [sym_listing_environment] = STATE(228),
    [sym__listing_environment_begin] = STATE(3257),
    [sym_minted_environment] = STATE(228),
    [sym__minted_environment_begin] = STATE(3256),
    [sym_pycode_environment] = STATE(228),
    [sym__pycode_environment_begin] = STATE(3255),
    [sym_sagesilent_environment] = STATE(228),
    [sym__sagesilent_environment_begin] = STATE(3253),
    [sym_sageblock_environment] = STATE(228),
    [sym__sageblock_environment_begin] = STATE(3252),
    [sym_math_environment] = STATE(228),
    [sym__math_environment_begin] = STATE(238),
    [sym__command] = STATE(228),
    [sym_generic_command] = STATE(228),
    [sym_title_declaration] = STATE(228),
    [sym_author_declaration] = STATE(228),
    [sym_package_include] = STATE(228),
    [sym_class_include] = STATE(228),
    [sym_latex_include] = STATE(228),
    [sym_biblatex_include] = STATE(228),
    [sym_bibstyle_include] = STATE(228),
    [sym_bibtex_include] = STATE(228),
    [sym_graphics_include] = STATE(228),
    [sym_svg_include] = STATE(228),
    [sym_inkscape_include] = STATE(228),
    [sym_verbatim_include] = STATE(228),
    [sym_import_include] = STATE(228),
    [sym_caption] = STATE(228),
    [sym_citation] = STATE(228),
    [sym_label_definition] = STATE(228),
    [sym_label_reference] = STATE(228),
    [sym_label_reference_range] = STATE(228),
    [sym_label_number] = STATE(228),
    [sym_new_command_definition] = STATE(228),
    [sym_old_command_definition] = STATE(228),
    [sym_let_command_definition] = STATE(228),
    [sym_math_delimiter] = STATE(228),
    [sym_paired_delimiter_definition] = STATE(228),
    [sym_environment_definition] = STATE(228),
    [sym_glossary_entry_definition] = STATE(228),
    [sym_glossary_entry_reference] = STATE(228),
    [sym_acronym_definition] = STATE(228),
    [sym_acronym_reference] = STATE(228),
    [sym_theorem_definition] = STATE(228),
    [sym_color_definition] = STATE(228),
    [sym_color_set_definition] = STATE(228),
    [sym_color_reference] = STATE(228),
    [sym_tikz_library_import] = STATE(228),
    [sym_text_mode] = STATE(228),
    [sym_hyperlink] = STATE(228),
    [aux_sym_part_repeat1] = STATE(228),
    [aux_sym_text_repeat1] = STATE(261),
    [sym_command_name] = ACTIONS(2613),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2616),
    [anon_sym_LBRACK] = ACTIONS(2619),
    [anon_sym_RBRACK] = ACTIONS(2619),
    [anon_sym_COMMA] = ACTIONS(2619),
    [anon_sym_EQ] = ACTIONS(2619),
    [anon_sym_LPAREN] = ACTIONS(2619),
    [anon_sym_RPAREN] = ACTIONS(2619),
    [anon_sym_BSLASHpart] = ACTIONS(2275),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddpart] = ACTIONS(2275),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHchapter] = ACTIONS(2275),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddchap] = ACTIONS(2275),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsection] = ACTIONS(2275),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddsec] = ACTIONS(2275),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHitem] = ACTIONS(2275),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2622),
    [sym_word] = ACTIONS(2625),
    [sym_placeholder] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2631),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_SLASH] = ACTIONS(2631),
    [anon_sym_LT] = ACTIONS(2634),
    [anon_sym_GT] = ACTIONS(2634),
    [anon_sym_BANG] = ACTIONS(2634),
    [anon_sym_PIPE] = ACTIONS(2634),
    [anon_sym_COLON] = ACTIONS(2634),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym__] = ACTIONS(2637),
    [anon_sym_CARET] = ACTIONS(2640),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2643),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2643),
    [anon_sym_DOLLAR] = ACTIONS(2646),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2649),
    [anon_sym_BSLASHbegin] = ACTIONS(2309),
    [anon_sym_BSLASHend] = ACTIONS(2275),
    [anon_sym_BSLASHtitle] = ACTIONS(2652),
    [anon_sym_BSLASHauthor] = ACTIONS(2655),
    [anon_sym_BSLASHusepackage] = ACTIONS(2658),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2658),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2661),
    [anon_sym_BSLASHinclude] = ACTIONS(2664),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2664),
    [anon_sym_BSLASHinput] = ACTIONS(2664),
    [anon_sym_BSLASHsubfile] = ACTIONS(2664),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2667),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2670),
    [anon_sym_BSLASHbibliography] = ACTIONS(2673),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2676),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2679),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2682),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2685),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2685),
    [anon_sym_BSLASHimport] = ACTIONS(2688),
    [anon_sym_BSLASHsubimport] = ACTIONS(2688),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2688),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2688),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2688),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2688),
    [anon_sym_BSLASHcaption] = ACTIONS(2691),
    [anon_sym_BSLASHcite] = ACTIONS(2694),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHCite] = ACTIONS(2694),
    [anon_sym_BSLASHnocite] = ACTIONS(2694),
    [anon_sym_BSLASHcitet] = ACTIONS(2694),
    [anon_sym_BSLASHcitep] = ACTIONS(2694),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHciteA] = ACTIONS(2694),
    [anon_sym_BSLASHciteR] = ACTIONS(2694),
    [anon_sym_BSLASHciteS] = ACTIONS(2694),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2694),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2694),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2694),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2694),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHciteyear] = ACTIONS(2694),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHcitedate] = ACTIONS(2694),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHciteurl] = ACTIONS(2694),
    [anon_sym_BSLASHfullcite] = ACTIONS(2694),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2694),
    [anon_sym_BSLASHcitealt] = ACTIONS(2694),
    [anon_sym_BSLASHcitealp] = ACTIONS(2694),
    [anon_sym_BSLASHcitetext] = ACTIONS(2694),
    [anon_sym_BSLASHparencite] = ACTIONS(2694),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHParencite] = ACTIONS(2694),
    [anon_sym_BSLASHfootcite] = ACTIONS(2694),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2694),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2694),
    [anon_sym_BSLASHtextcite] = ACTIONS(2694),
    [anon_sym_BSLASHTextcite] = ACTIONS(2694),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2694),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2694),
    [anon_sym_BSLASHsupercite] = ACTIONS(2694),
    [anon_sym_BSLASHautocite] = ACTIONS(2694),
    [anon_sym_BSLASHAutocite] = ACTIONS(2694),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2697),
    [anon_sym_BSLASHvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHVolcite] = ACTIONS(2694),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHavolcite] = ACTIONS(2694),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2694),
    [anon_sym_BSLASHnotecite] = ACTIONS(2694),
    [anon_sym_BSLASHNotecite] = ACTIONS(2694),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2694),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2694),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2694),
    [anon_sym_BSLASHlabel] = ACTIONS(2700),
    [anon_sym_BSLASHref] = ACTIONS(2703),
    [anon_sym_BSLASHeqref] = ACTIONS(2703),
    [anon_sym_BSLASHvref] = ACTIONS(2703),
    [anon_sym_BSLASHVref] = ACTIONS(2703),
    [anon_sym_BSLASHautoref] = ACTIONS(2703),
    [anon_sym_BSLASHpageref] = ACTIONS(2703),
    [anon_sym_BSLASHcref] = ACTIONS(2703),
    [anon_sym_BSLASHCref] = ACTIONS(2703),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2706),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2706),
    [anon_sym_BSLASHnamecref] = ACTIONS(2703),
    [anon_sym_BSLASHnameCref] = ACTIONS(2703),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2703),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2703),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2703),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2703),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2703),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2703),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2709),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2712),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2709),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2712),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2715),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2718),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2721),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2718),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2721),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2718),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2721),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2718),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2721),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2718),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2718),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2718),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2718),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2718),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2718),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2718),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2718),
    [anon_sym_BSLASHdef] = ACTIONS(2724),
    [anon_sym_BSLASHlet] = ACTIONS(2727),
    [anon_sym_BSLASHleft] = ACTIONS(2730),
    [anon_sym_BSLASHbigl] = ACTIONS(2730),
    [anon_sym_BSLASHBigl] = ACTIONS(2730),
    [anon_sym_BSLASHbiggl] = ACTIONS(2730),
    [anon_sym_BSLASHBiggl] = ACTIONS(2730),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2733),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2733),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2736),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2736),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2736),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2736),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2736),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2736),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2739),
    [anon_sym_BSLASHgls] = ACTIONS(2742),
    [anon_sym_BSLASHGls] = ACTIONS(2742),
    [anon_sym_BSLASHGLS] = ACTIONS(2742),
    [anon_sym_BSLASHglspl] = ACTIONS(2742),
    [anon_sym_BSLASHGlspl] = ACTIONS(2742),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2742),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2742),
    [anon_sym_BSLASHglslink] = ACTIONS(2742),
    [anon_sym_BSLASHglstext] = ACTIONS(2742),
    [anon_sym_BSLASHGlstext] = ACTIONS(2742),
    [anon_sym_BSLASHGLStext] = ACTIONS(2742),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2742),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2742),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2742),
    [anon_sym_BSLASHglsplural] = ACTIONS(2742),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2742),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2742),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2742),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2742),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2742),
    [anon_sym_BSLASHglsname] = ACTIONS(2742),
    [anon_sym_BSLASHGlsname] = ACTIONS(2742),
    [anon_sym_BSLASHGLSname] = ACTIONS(2742),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2742),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2742),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2742),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2742),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2742),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2742),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2742),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2742),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2742),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2742),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2742),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2742),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2742),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2742),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2742),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2742),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2742),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2742),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2742),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2742),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2742),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2742),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2742),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2745),
    [anon_sym_BSLASHacrshort] = ACTIONS(2748),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2748),
    [anon_sym_BSLASHACRshort] = ACTIONS(2748),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2748),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2748),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2748),
    [anon_sym_BSLASHacrlong] = ACTIONS(2748),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2748),
    [anon_sym_BSLASHACRlong] = ACTIONS(2748),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2748),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2748),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2748),
    [anon_sym_BSLASHacrfull] = ACTIONS(2748),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2748),
    [anon_sym_BSLASHACRfull] = ACTIONS(2748),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2748),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2748),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2748),
    [anon_sym_BSLASHacs] = ACTIONS(2748),
    [anon_sym_BSLASHAcs] = ACTIONS(2748),
    [anon_sym_BSLASHacsp] = ACTIONS(2748),
    [anon_sym_BSLASHAcsp] = ACTIONS(2748),
    [anon_sym_BSLASHacl] = ACTIONS(2748),
    [anon_sym_BSLASHAcl] = ACTIONS(2748),
    [anon_sym_BSLASHaclp] = ACTIONS(2748),
    [anon_sym_BSLASHAclp] = ACTIONS(2748),
    [anon_sym_BSLASHacf] = ACTIONS(2748),
    [anon_sym_BSLASHAcf] = ACTIONS(2748),
    [anon_sym_BSLASHacfp] = ACTIONS(2748),
    [anon_sym_BSLASHAcfp] = ACTIONS(2748),
    [anon_sym_BSLASHac] = ACTIONS(2748),
    [anon_sym_BSLASHAc] = ACTIONS(2748),
    [anon_sym_BSLASHacp] = ACTIONS(2748),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2748),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2748),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2748),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2748),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2748),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2748),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2748),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2748),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2748),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2748),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2751),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2754),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2751),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2754),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2757),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2760),
    [anon_sym_BSLASHcolor] = ACTIONS(2763),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2763),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2763),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2763),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2766),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2766),
    [anon_sym_BSLASHtext] = ACTIONS(2769),
    [anon_sym_BSLASHintertext] = ACTIONS(2769),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2769),
    [anon_sym_BSLASHurl] = ACTIONS(2772),
    [anon_sym_BSLASHhref] = ACTIONS(2772),
  },
  [229] = {
    [sym_block_comment] = STATE(226),
    [sym__flat_content] = STATE(226),
    [sym__text_with_env_content] = STATE(226),
    [sym__text_content] = STATE(226),
    [sym_curly_group] = STATE(226),
    [sym_text] = STATE(226),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(226),
    [sym_inline_formula] = STATE(226),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(226),
    [sym_comment_environment] = STATE(226),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(226),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(226),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(226),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(226),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(226),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(226),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(226),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(226),
    [sym_generic_command] = STATE(226),
    [sym_title_declaration] = STATE(226),
    [sym_author_declaration] = STATE(226),
    [sym_package_include] = STATE(226),
    [sym_class_include] = STATE(226),
    [sym_latex_include] = STATE(226),
    [sym_biblatex_include] = STATE(226),
    [sym_bibstyle_include] = STATE(226),
    [sym_bibtex_include] = STATE(226),
    [sym_graphics_include] = STATE(226),
    [sym_svg_include] = STATE(226),
    [sym_inkscape_include] = STATE(226),
    [sym_verbatim_include] = STATE(226),
    [sym_import_include] = STATE(226),
    [sym_caption] = STATE(226),
    [sym_citation] = STATE(226),
    [sym_label_definition] = STATE(226),
    [sym_label_reference] = STATE(226),
    [sym_label_reference_range] = STATE(226),
    [sym_label_number] = STATE(226),
    [sym_new_command_definition] = STATE(226),
    [sym_old_command_definition] = STATE(226),
    [sym_let_command_definition] = STATE(226),
    [sym_math_delimiter] = STATE(226),
    [sym_paired_delimiter_definition] = STATE(226),
    [sym_environment_definition] = STATE(226),
    [sym_glossary_entry_definition] = STATE(226),
    [sym_glossary_entry_reference] = STATE(226),
    [sym_acronym_definition] = STATE(226),
    [sym_acronym_reference] = STATE(226),
    [sym_theorem_definition] = STATE(226),
    [sym_color_definition] = STATE(226),
    [sym_color_set_definition] = STATE(226),
    [sym_color_reference] = STATE(226),
    [sym_tikz_library_import] = STATE(226),
    [sym_text_mode] = STATE(226),
    [sym_hyperlink] = STATE(226),
    [aux_sym_part_repeat1] = STATE(226),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(2775),
    [anon_sym_RBRACK] = ACTIONS(2775),
    [anon_sym_COMMA] = ACTIONS(2775),
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_LPAREN] = ACTIONS(2775),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [anon_sym_BSLASHpart] = ACTIONS(2262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddpart] = ACTIONS(2262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHchapter] = ACTIONS(2262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddchap] = ACTIONS(2262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsection] = ACTIONS(2262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddsec] = ACTIONS(2262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHitem] = ACTIONS(2262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1158),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1158),
    [anon_sym_DOLLAR] = ACTIONS(2162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1162),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2264),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(1218),
    [anon_sym_BSLASHbigl] = ACTIONS(1218),
    [anon_sym_BSLASHBigl] = ACTIONS(1218),
    [anon_sym_BSLASHbiggl] = ACTIONS(1218),
    [anon_sym_BSLASHBiggl] = ACTIONS(1218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(1244),
    [anon_sym_BSLASHintertext] = ACTIONS(1244),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1244),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [230] = {
    [sym_block_comment] = STATE(225),
    [sym__flat_content] = STATE(225),
    [sym__text_with_env_content] = STATE(225),
    [sym__text_content] = STATE(225),
    [sym_curly_group] = STATE(225),
    [sym_text] = STATE(225),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(225),
    [sym_inline_formula] = STATE(225),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(225),
    [sym_comment_environment] = STATE(225),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(225),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(225),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(225),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(225),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(225),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(225),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(225),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(225),
    [sym_generic_command] = STATE(225),
    [sym_title_declaration] = STATE(225),
    [sym_author_declaration] = STATE(225),
    [sym_package_include] = STATE(225),
    [sym_class_include] = STATE(225),
    [sym_latex_include] = STATE(225),
    [sym_biblatex_include] = STATE(225),
    [sym_bibstyle_include] = STATE(225),
    [sym_bibtex_include] = STATE(225),
    [sym_graphics_include] = STATE(225),
    [sym_svg_include] = STATE(225),
    [sym_inkscape_include] = STATE(225),
    [sym_verbatim_include] = STATE(225),
    [sym_import_include] = STATE(225),
    [sym_caption] = STATE(225),
    [sym_citation] = STATE(225),
    [sym_label_definition] = STATE(225),
    [sym_label_reference] = STATE(225),
    [sym_label_reference_range] = STATE(225),
    [sym_label_number] = STATE(225),
    [sym_new_command_definition] = STATE(225),
    [sym_old_command_definition] = STATE(225),
    [sym_let_command_definition] = STATE(225),
    [sym_math_delimiter] = STATE(225),
    [sym_paired_delimiter_definition] = STATE(225),
    [sym_environment_definition] = STATE(225),
    [sym_glossary_entry_definition] = STATE(225),
    [sym_glossary_entry_reference] = STATE(225),
    [sym_acronym_definition] = STATE(225),
    [sym_acronym_reference] = STATE(225),
    [sym_theorem_definition] = STATE(225),
    [sym_color_definition] = STATE(225),
    [sym_color_set_definition] = STATE(225),
    [sym_color_reference] = STATE(225),
    [sym_tikz_library_import] = STATE(225),
    [sym_text_mode] = STATE(225),
    [sym_hyperlink] = STATE(225),
    [aux_sym_part_repeat1] = STATE(225),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(2777),
    [anon_sym_RBRACK] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LPAREN] = ACTIONS(2777),
    [anon_sym_RPAREN] = ACTIONS(2777),
    [anon_sym_BSLASHpart] = ACTIONS(2262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddpart] = ACTIONS(2262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHchapter] = ACTIONS(2262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddchap] = ACTIONS(2262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsection] = ACTIONS(2262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHaddsec] = ACTIONS(2262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2264),
    [anon_sym_BSLASHitem] = ACTIONS(2262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(1048),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(1048),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2264),
    [anon_sym_DOLLAR] = ACTIONS(1052),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(1054),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(1108),
    [anon_sym_BSLASHbigl] = ACTIONS(1108),
    [anon_sym_BSLASHBigl] = ACTIONS(1108),
    [anon_sym_BSLASHbiggl] = ACTIONS(1108),
    [anon_sym_BSLASHBiggl] = ACTIONS(1108),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(1134),
    [anon_sym_BSLASHintertext] = ACTIONS(1134),
    [anon_sym_BSLASHshortintertext] = ACTIONS(1134),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [231] = {
    [sym_block_comment] = STATE(231),
    [sym__flat_content] = STATE(231),
    [sym__text_with_env_content] = STATE(231),
    [sym__text_content] = STATE(231),
    [sym_curly_group] = STATE(231),
    [sym_text] = STATE(231),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym_displayed_equation] = STATE(231),
    [sym_inline_formula] = STATE(231),
    [sym_begin] = STATE(60),
    [sym_generic_environment] = STATE(231),
    [sym_comment_environment] = STATE(231),
    [sym__comment_environment_begin] = STATE(3300),
    [sym_verbatim_environment] = STATE(231),
    [sym__verbatim_environment_begin] = STATE(3299),
    [sym_listing_environment] = STATE(231),
    [sym__listing_environment_begin] = STATE(3298),
    [sym_minted_environment] = STATE(231),
    [sym__minted_environment_begin] = STATE(3297),
    [sym_pycode_environment] = STATE(231),
    [sym__pycode_environment_begin] = STATE(3296),
    [sym_sagesilent_environment] = STATE(231),
    [sym__sagesilent_environment_begin] = STATE(3295),
    [sym_sageblock_environment] = STATE(231),
    [sym__sageblock_environment_begin] = STATE(3294),
    [sym_math_environment] = STATE(231),
    [sym__math_environment_begin] = STATE(237),
    [sym__command] = STATE(231),
    [sym_generic_command] = STATE(231),
    [sym_title_declaration] = STATE(231),
    [sym_author_declaration] = STATE(231),
    [sym_package_include] = STATE(231),
    [sym_class_include] = STATE(231),
    [sym_latex_include] = STATE(231),
    [sym_biblatex_include] = STATE(231),
    [sym_bibstyle_include] = STATE(231),
    [sym_bibtex_include] = STATE(231),
    [sym_graphics_include] = STATE(231),
    [sym_svg_include] = STATE(231),
    [sym_inkscape_include] = STATE(231),
    [sym_verbatim_include] = STATE(231),
    [sym_import_include] = STATE(231),
    [sym_caption] = STATE(231),
    [sym_citation] = STATE(231),
    [sym_label_definition] = STATE(231),
    [sym_label_reference] = STATE(231),
    [sym_label_reference_range] = STATE(231),
    [sym_label_number] = STATE(231),
    [sym_new_command_definition] = STATE(231),
    [sym_old_command_definition] = STATE(231),
    [sym_let_command_definition] = STATE(231),
    [sym_math_delimiter] = STATE(231),
    [sym_paired_delimiter_definition] = STATE(231),
    [sym_environment_definition] = STATE(231),
    [sym_glossary_entry_definition] = STATE(231),
    [sym_glossary_entry_reference] = STATE(231),
    [sym_acronym_definition] = STATE(231),
    [sym_acronym_reference] = STATE(231),
    [sym_theorem_definition] = STATE(231),
    [sym_color_definition] = STATE(231),
    [sym_color_set_definition] = STATE(231),
    [sym_color_reference] = STATE(231),
    [sym_tikz_library_import] = STATE(231),
    [sym_text_mode] = STATE(231),
    [sym_hyperlink] = STATE(231),
    [aux_sym_part_repeat1] = STATE(231),
    [aux_sym_text_repeat1] = STATE(262),
    [sym_command_name] = ACTIONS(2779),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2785),
    [anon_sym_RBRACK] = ACTIONS(2785),
    [anon_sym_COMMA] = ACTIONS(2785),
    [anon_sym_EQ] = ACTIONS(2785),
    [anon_sym_LPAREN] = ACTIONS(2785),
    [anon_sym_RPAREN] = ACTIONS(2785),
    [anon_sym_BSLASHpart] = ACTIONS(2275),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddpart] = ACTIONS(2275),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHchapter] = ACTIONS(2275),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddchap] = ACTIONS(2275),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsection] = ACTIONS(2275),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddsec] = ACTIONS(2275),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHitem] = ACTIONS(2275),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2788),
    [sym_word] = ACTIONS(2791),
    [sym_placeholder] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_DASH] = ACTIONS(2797),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_SLASH] = ACTIONS(2797),
    [anon_sym_LT] = ACTIONS(2800),
    [anon_sym_GT] = ACTIONS(2800),
    [anon_sym_BANG] = ACTIONS(2800),
    [anon_sym_PIPE] = ACTIONS(2800),
    [anon_sym_COLON] = ACTIONS(2800),
    [anon_sym_SQUOTE] = ACTIONS(2800),
    [anon_sym__] = ACTIONS(2803),
    [anon_sym_CARET] = ACTIONS(2806),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2809),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2809),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2277),
    [anon_sym_DOLLAR] = ACTIONS(2812),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2815),
    [anon_sym_BSLASHbegin] = ACTIONS(2309),
    [anon_sym_BSLASHtitle] = ACTIONS(2818),
    [anon_sym_BSLASHauthor] = ACTIONS(2821),
    [anon_sym_BSLASHusepackage] = ACTIONS(2824),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2824),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2827),
    [anon_sym_BSLASHinclude] = ACTIONS(2830),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2830),
    [anon_sym_BSLASHinput] = ACTIONS(2830),
    [anon_sym_BSLASHsubfile] = ACTIONS(2830),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2833),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2836),
    [anon_sym_BSLASHbibliography] = ACTIONS(2839),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2842),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2845),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2848),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2851),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2851),
    [anon_sym_BSLASHimport] = ACTIONS(2854),
    [anon_sym_BSLASHsubimport] = ACTIONS(2854),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2854),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2854),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2854),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2854),
    [anon_sym_BSLASHcaption] = ACTIONS(2857),
    [anon_sym_BSLASHcite] = ACTIONS(2860),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHCite] = ACTIONS(2860),
    [anon_sym_BSLASHnocite] = ACTIONS(2860),
    [anon_sym_BSLASHcitet] = ACTIONS(2860),
    [anon_sym_BSLASHcitep] = ACTIONS(2860),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHciteA] = ACTIONS(2860),
    [anon_sym_BSLASHciteR] = ACTIONS(2860),
    [anon_sym_BSLASHciteS] = ACTIONS(2860),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2860),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2860),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2860),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2860),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHciteyear] = ACTIONS(2860),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHcitedate] = ACTIONS(2860),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHciteurl] = ACTIONS(2860),
    [anon_sym_BSLASHfullcite] = ACTIONS(2860),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2860),
    [anon_sym_BSLASHcitealt] = ACTIONS(2860),
    [anon_sym_BSLASHcitealp] = ACTIONS(2860),
    [anon_sym_BSLASHcitetext] = ACTIONS(2860),
    [anon_sym_BSLASHparencite] = ACTIONS(2860),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHParencite] = ACTIONS(2860),
    [anon_sym_BSLASHfootcite] = ACTIONS(2860),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2860),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2860),
    [anon_sym_BSLASHtextcite] = ACTIONS(2860),
    [anon_sym_BSLASHTextcite] = ACTIONS(2860),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2860),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2860),
    [anon_sym_BSLASHsupercite] = ACTIONS(2860),
    [anon_sym_BSLASHautocite] = ACTIONS(2860),
    [anon_sym_BSLASHAutocite] = ACTIONS(2860),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2863),
    [anon_sym_BSLASHvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHVolcite] = ACTIONS(2860),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHavolcite] = ACTIONS(2860),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2860),
    [anon_sym_BSLASHnotecite] = ACTIONS(2860),
    [anon_sym_BSLASHNotecite] = ACTIONS(2860),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2860),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2860),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2860),
    [anon_sym_BSLASHlabel] = ACTIONS(2866),
    [anon_sym_BSLASHref] = ACTIONS(2869),
    [anon_sym_BSLASHeqref] = ACTIONS(2869),
    [anon_sym_BSLASHvref] = ACTIONS(2869),
    [anon_sym_BSLASHVref] = ACTIONS(2869),
    [anon_sym_BSLASHautoref] = ACTIONS(2869),
    [anon_sym_BSLASHpageref] = ACTIONS(2869),
    [anon_sym_BSLASHcref] = ACTIONS(2869),
    [anon_sym_BSLASHCref] = ACTIONS(2869),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2872),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2872),
    [anon_sym_BSLASHnamecref] = ACTIONS(2869),
    [anon_sym_BSLASHnameCref] = ACTIONS(2869),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2869),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2869),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2869),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2869),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2869),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2869),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2875),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2878),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2875),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2878),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2881),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2884),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2887),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2884),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2887),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2884),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2887),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2884),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2887),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2884),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2884),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2884),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2884),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2884),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2884),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2884),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2884),
    [anon_sym_BSLASHdef] = ACTIONS(2890),
    [anon_sym_BSLASHlet] = ACTIONS(2893),
    [anon_sym_BSLASHleft] = ACTIONS(2896),
    [anon_sym_BSLASHbigl] = ACTIONS(2896),
    [anon_sym_BSLASHBigl] = ACTIONS(2896),
    [anon_sym_BSLASHbiggl] = ACTIONS(2896),
    [anon_sym_BSLASHBiggl] = ACTIONS(2896),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2899),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2899),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2902),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2902),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2902),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2902),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2902),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2902),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2905),
    [anon_sym_BSLASHgls] = ACTIONS(2908),
    [anon_sym_BSLASHGls] = ACTIONS(2908),
    [anon_sym_BSLASHGLS] = ACTIONS(2908),
    [anon_sym_BSLASHglspl] = ACTIONS(2908),
    [anon_sym_BSLASHGlspl] = ACTIONS(2908),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2908),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2908),
    [anon_sym_BSLASHglslink] = ACTIONS(2908),
    [anon_sym_BSLASHglstext] = ACTIONS(2908),
    [anon_sym_BSLASHGlstext] = ACTIONS(2908),
    [anon_sym_BSLASHGLStext] = ACTIONS(2908),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2908),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2908),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2908),
    [anon_sym_BSLASHglsplural] = ACTIONS(2908),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2908),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2908),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2908),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2908),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2908),
    [anon_sym_BSLASHglsname] = ACTIONS(2908),
    [anon_sym_BSLASHGlsname] = ACTIONS(2908),
    [anon_sym_BSLASHGLSname] = ACTIONS(2908),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2908),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2908),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2908),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2908),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2908),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2908),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2908),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2908),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2908),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2908),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2908),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2908),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2908),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2908),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2908),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2908),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2908),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2908),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2908),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2908),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2908),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2908),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2908),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2911),
    [anon_sym_BSLASHacrshort] = ACTIONS(2914),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2914),
    [anon_sym_BSLASHACRshort] = ACTIONS(2914),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2914),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2914),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2914),
    [anon_sym_BSLASHacrlong] = ACTIONS(2914),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2914),
    [anon_sym_BSLASHACRlong] = ACTIONS(2914),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2914),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2914),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2914),
    [anon_sym_BSLASHacrfull] = ACTIONS(2914),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2914),
    [anon_sym_BSLASHACRfull] = ACTIONS(2914),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2914),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2914),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2914),
    [anon_sym_BSLASHacs] = ACTIONS(2914),
    [anon_sym_BSLASHAcs] = ACTIONS(2914),
    [anon_sym_BSLASHacsp] = ACTIONS(2914),
    [anon_sym_BSLASHAcsp] = ACTIONS(2914),
    [anon_sym_BSLASHacl] = ACTIONS(2914),
    [anon_sym_BSLASHAcl] = ACTIONS(2914),
    [anon_sym_BSLASHaclp] = ACTIONS(2914),
    [anon_sym_BSLASHAclp] = ACTIONS(2914),
    [anon_sym_BSLASHacf] = ACTIONS(2914),
    [anon_sym_BSLASHAcf] = ACTIONS(2914),
    [anon_sym_BSLASHacfp] = ACTIONS(2914),
    [anon_sym_BSLASHAcfp] = ACTIONS(2914),
    [anon_sym_BSLASHac] = ACTIONS(2914),
    [anon_sym_BSLASHAc] = ACTIONS(2914),
    [anon_sym_BSLASHacp] = ACTIONS(2914),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2914),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2914),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2914),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2914),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2914),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2914),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2914),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2914),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2914),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2914),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2917),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2920),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2917),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2920),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2923),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2926),
    [anon_sym_BSLASHcolor] = ACTIONS(2929),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2929),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2929),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2929),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2932),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2932),
    [anon_sym_BSLASHtext] = ACTIONS(2935),
    [anon_sym_BSLASHintertext] = ACTIONS(2935),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2935),
    [anon_sym_BSLASHurl] = ACTIONS(2938),
    [anon_sym_BSLASHhref] = ACTIONS(2938),
  },
  [232] = {
    [sym_block_comment] = STATE(232),
    [sym__flat_content] = STATE(232),
    [sym__text_with_env_content] = STATE(232),
    [sym__text_content] = STATE(232),
    [sym_curly_group] = STATE(232),
    [sym_text] = STATE(232),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym_displayed_equation] = STATE(232),
    [sym_inline_formula] = STATE(232),
    [sym_begin] = STATE(46),
    [sym_generic_environment] = STATE(232),
    [sym_comment_environment] = STATE(232),
    [sym__comment_environment_begin] = STATE(3286),
    [sym_verbatim_environment] = STATE(232),
    [sym__verbatim_environment_begin] = STATE(3285),
    [sym_listing_environment] = STATE(232),
    [sym__listing_environment_begin] = STATE(3284),
    [sym_minted_environment] = STATE(232),
    [sym__minted_environment_begin] = STATE(3282),
    [sym_pycode_environment] = STATE(232),
    [sym__pycode_environment_begin] = STATE(3274),
    [sym_sagesilent_environment] = STATE(232),
    [sym__sagesilent_environment_begin] = STATE(3272),
    [sym_sageblock_environment] = STATE(232),
    [sym__sageblock_environment_begin] = STATE(3271),
    [sym_math_environment] = STATE(232),
    [sym__math_environment_begin] = STATE(243),
    [sym__command] = STATE(232),
    [sym_generic_command] = STATE(232),
    [sym_title_declaration] = STATE(232),
    [sym_author_declaration] = STATE(232),
    [sym_package_include] = STATE(232),
    [sym_class_include] = STATE(232),
    [sym_latex_include] = STATE(232),
    [sym_biblatex_include] = STATE(232),
    [sym_bibstyle_include] = STATE(232),
    [sym_bibtex_include] = STATE(232),
    [sym_graphics_include] = STATE(232),
    [sym_svg_include] = STATE(232),
    [sym_inkscape_include] = STATE(232),
    [sym_verbatim_include] = STATE(232),
    [sym_import_include] = STATE(232),
    [sym_caption] = STATE(232),
    [sym_citation] = STATE(232),
    [sym_label_definition] = STATE(232),
    [sym_label_reference] = STATE(232),
    [sym_label_reference_range] = STATE(232),
    [sym_label_number] = STATE(232),
    [sym_new_command_definition] = STATE(232),
    [sym_old_command_definition] = STATE(232),
    [sym_let_command_definition] = STATE(232),
    [sym_math_delimiter] = STATE(232),
    [sym_paired_delimiter_definition] = STATE(232),
    [sym_environment_definition] = STATE(232),
    [sym_glossary_entry_definition] = STATE(232),
    [sym_glossary_entry_reference] = STATE(232),
    [sym_acronym_definition] = STATE(232),
    [sym_acronym_reference] = STATE(232),
    [sym_theorem_definition] = STATE(232),
    [sym_color_definition] = STATE(232),
    [sym_color_set_definition] = STATE(232),
    [sym_color_reference] = STATE(232),
    [sym_tikz_library_import] = STATE(232),
    [sym_text_mode] = STATE(232),
    [sym_hyperlink] = STATE(232),
    [aux_sym_part_repeat1] = STATE(232),
    [aux_sym_text_repeat1] = STATE(264),
    [sym_command_name] = ACTIONS(2941),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2944),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_RBRACK] = ACTIONS(2947),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_BSLASHpart] = ACTIONS(2275),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddpart] = ACTIONS(2275),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHchapter] = ACTIONS(2275),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddchap] = ACTIONS(2275),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsection] = ACTIONS(2275),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHaddsec] = ACTIONS(2275),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2275),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2275),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2277),
    [anon_sym_BSLASHitem] = ACTIONS(2275),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2277),
    [anon_sym_LBRACE] = ACTIONS(2950),
    [sym_word] = ACTIONS(2953),
    [sym_placeholder] = ACTIONS(2956),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2959),
    [anon_sym_STAR] = ACTIONS(2959),
    [anon_sym_SLASH] = ACTIONS(2959),
    [anon_sym_LT] = ACTIONS(2962),
    [anon_sym_GT] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_PIPE] = ACTIONS(2962),
    [anon_sym_COLON] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym__] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2968),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2971),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2971),
    [anon_sym_DOLLAR] = ACTIONS(2974),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2977),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2277),
    [anon_sym_BSLASHbegin] = ACTIONS(2309),
    [anon_sym_BSLASHtitle] = ACTIONS(2980),
    [anon_sym_BSLASHauthor] = ACTIONS(2983),
    [anon_sym_BSLASHusepackage] = ACTIONS(2986),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2986),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2989),
    [anon_sym_BSLASHinclude] = ACTIONS(2992),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2992),
    [anon_sym_BSLASHinput] = ACTIONS(2992),
    [anon_sym_BSLASHsubfile] = ACTIONS(2992),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2995),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2998),
    [anon_sym_BSLASHbibliography] = ACTIONS(3001),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3004),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3007),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3010),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3013),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3013),
    [anon_sym_BSLASHimport] = ACTIONS(3016),
    [anon_sym_BSLASHsubimport] = ACTIONS(3016),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3016),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3016),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3016),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3016),
    [anon_sym_BSLASHcaption] = ACTIONS(3019),
    [anon_sym_BSLASHcite] = ACTIONS(3022),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHCite] = ACTIONS(3022),
    [anon_sym_BSLASHnocite] = ACTIONS(3022),
    [anon_sym_BSLASHcitet] = ACTIONS(3022),
    [anon_sym_BSLASHcitep] = ACTIONS(3022),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHciteA] = ACTIONS(3022),
    [anon_sym_BSLASHciteR] = ACTIONS(3022),
    [anon_sym_BSLASHciteS] = ACTIONS(3022),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3022),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3022),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3022),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3022),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHciteyear] = ACTIONS(3022),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHcitedate] = ACTIONS(3022),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHciteurl] = ACTIONS(3022),
    [anon_sym_BSLASHfullcite] = ACTIONS(3022),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3022),
    [anon_sym_BSLASHcitealt] = ACTIONS(3022),
    [anon_sym_BSLASHcitealp] = ACTIONS(3022),
    [anon_sym_BSLASHcitetext] = ACTIONS(3022),
    [anon_sym_BSLASHparencite] = ACTIONS(3022),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHParencite] = ACTIONS(3022),
    [anon_sym_BSLASHfootcite] = ACTIONS(3022),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3022),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3022),
    [anon_sym_BSLASHtextcite] = ACTIONS(3022),
    [anon_sym_BSLASHTextcite] = ACTIONS(3022),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3022),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3022),
    [anon_sym_BSLASHsupercite] = ACTIONS(3022),
    [anon_sym_BSLASHautocite] = ACTIONS(3022),
    [anon_sym_BSLASHAutocite] = ACTIONS(3022),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3025),
    [anon_sym_BSLASHvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHVolcite] = ACTIONS(3022),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHavolcite] = ACTIONS(3022),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3022),
    [anon_sym_BSLASHnotecite] = ACTIONS(3022),
    [anon_sym_BSLASHNotecite] = ACTIONS(3022),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3022),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3022),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3022),
    [anon_sym_BSLASHlabel] = ACTIONS(3028),
    [anon_sym_BSLASHref] = ACTIONS(3031),
    [anon_sym_BSLASHeqref] = ACTIONS(3031),
    [anon_sym_BSLASHvref] = ACTIONS(3031),
    [anon_sym_BSLASHVref] = ACTIONS(3031),
    [anon_sym_BSLASHautoref] = ACTIONS(3031),
    [anon_sym_BSLASHpageref] = ACTIONS(3031),
    [anon_sym_BSLASHcref] = ACTIONS(3031),
    [anon_sym_BSLASHCref] = ACTIONS(3031),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3034),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3034),
    [anon_sym_BSLASHnamecref] = ACTIONS(3031),
    [anon_sym_BSLASHnameCref] = ACTIONS(3031),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3031),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3031),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3031),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3031),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3031),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3031),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3037),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3040),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3037),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3040),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3043),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3046),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3049),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3046),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3049),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3046),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3049),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3046),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3049),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3046),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3046),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3046),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3046),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3046),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3046),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3046),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3046),
    [anon_sym_BSLASHdef] = ACTIONS(3052),
    [anon_sym_BSLASHlet] = ACTIONS(3055),
    [anon_sym_BSLASHleft] = ACTIONS(3058),
    [anon_sym_BSLASHbigl] = ACTIONS(3058),
    [anon_sym_BSLASHBigl] = ACTIONS(3058),
    [anon_sym_BSLASHbiggl] = ACTIONS(3058),
    [anon_sym_BSLASHBiggl] = ACTIONS(3058),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3061),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3061),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3064),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3064),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3064),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3064),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3064),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3064),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3067),
    [anon_sym_BSLASHgls] = ACTIONS(3070),
    [anon_sym_BSLASHGls] = ACTIONS(3070),
    [anon_sym_BSLASHGLS] = ACTIONS(3070),
    [anon_sym_BSLASHglspl] = ACTIONS(3070),
    [anon_sym_BSLASHGlspl] = ACTIONS(3070),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3070),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3070),
    [anon_sym_BSLASHglslink] = ACTIONS(3070),
    [anon_sym_BSLASHglstext] = ACTIONS(3070),
    [anon_sym_BSLASHGlstext] = ACTIONS(3070),
    [anon_sym_BSLASHGLStext] = ACTIONS(3070),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3070),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3070),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3070),
    [anon_sym_BSLASHglsplural] = ACTIONS(3070),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3070),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3070),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3070),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3070),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3070),
    [anon_sym_BSLASHglsname] = ACTIONS(3070),
    [anon_sym_BSLASHGlsname] = ACTIONS(3070),
    [anon_sym_BSLASHGLSname] = ACTIONS(3070),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3070),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3070),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3070),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3070),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3070),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3070),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3070),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3070),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3070),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3070),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3070),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3070),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3070),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3070),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3070),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3070),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3070),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3070),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3070),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3070),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3070),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3070),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3070),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3073),
    [anon_sym_BSLASHacrshort] = ACTIONS(3076),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3076),
    [anon_sym_BSLASHACRshort] = ACTIONS(3076),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3076),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3076),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3076),
    [anon_sym_BSLASHacrlong] = ACTIONS(3076),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3076),
    [anon_sym_BSLASHACRlong] = ACTIONS(3076),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3076),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3076),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3076),
    [anon_sym_BSLASHacrfull] = ACTIONS(3076),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3076),
    [anon_sym_BSLASHACRfull] = ACTIONS(3076),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3076),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3076),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3076),
    [anon_sym_BSLASHacs] = ACTIONS(3076),
    [anon_sym_BSLASHAcs] = ACTIONS(3076),
    [anon_sym_BSLASHacsp] = ACTIONS(3076),
    [anon_sym_BSLASHAcsp] = ACTIONS(3076),
    [anon_sym_BSLASHacl] = ACTIONS(3076),
    [anon_sym_BSLASHAcl] = ACTIONS(3076),
    [anon_sym_BSLASHaclp] = ACTIONS(3076),
    [anon_sym_BSLASHAclp] = ACTIONS(3076),
    [anon_sym_BSLASHacf] = ACTIONS(3076),
    [anon_sym_BSLASHAcf] = ACTIONS(3076),
    [anon_sym_BSLASHacfp] = ACTIONS(3076),
    [anon_sym_BSLASHAcfp] = ACTIONS(3076),
    [anon_sym_BSLASHac] = ACTIONS(3076),
    [anon_sym_BSLASHAc] = ACTIONS(3076),
    [anon_sym_BSLASHacp] = ACTIONS(3076),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3076),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3076),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3076),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3076),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3076),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3076),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3076),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3076),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3076),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3076),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3079),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3082),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3079),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3082),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3088),
    [anon_sym_BSLASHcolor] = ACTIONS(3091),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3091),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3091),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3091),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3094),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3094),
    [anon_sym_BSLASHtext] = ACTIONS(3097),
    [anon_sym_BSLASHintertext] = ACTIONS(3097),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3097),
    [anon_sym_BSLASHurl] = ACTIONS(3100),
    [anon_sym_BSLASHhref] = ACTIONS(3100),
  },
  [233] = {
    [sym_block_comment] = STATE(235),
    [sym__flat_content] = STATE(235),
    [sym__text_with_env_content] = STATE(235),
    [sym__text_content] = STATE(235),
    [sym_curly_group] = STATE(235),
    [sym_text] = STATE(235),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(235),
    [sym_inline_formula] = STATE(235),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(235),
    [sym_comment_environment] = STATE(235),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(235),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(235),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(235),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(235),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(235),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(235),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(235),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(912),
    [sym__command] = STATE(235),
    [sym_generic_command] = STATE(235),
    [sym_title_declaration] = STATE(235),
    [sym_author_declaration] = STATE(235),
    [sym_package_include] = STATE(235),
    [sym_class_include] = STATE(235),
    [sym_latex_include] = STATE(235),
    [sym_biblatex_include] = STATE(235),
    [sym_bibstyle_include] = STATE(235),
    [sym_bibtex_include] = STATE(235),
    [sym_graphics_include] = STATE(235),
    [sym_svg_include] = STATE(235),
    [sym_inkscape_include] = STATE(235),
    [sym_verbatim_include] = STATE(235),
    [sym_import_include] = STATE(235),
    [sym_caption] = STATE(235),
    [sym_citation] = STATE(235),
    [sym_label_definition] = STATE(235),
    [sym_label_reference] = STATE(235),
    [sym_label_reference_range] = STATE(235),
    [sym_label_number] = STATE(235),
    [sym_new_command_definition] = STATE(235),
    [sym_old_command_definition] = STATE(235),
    [sym_let_command_definition] = STATE(235),
    [sym_math_delimiter] = STATE(235),
    [sym_paired_delimiter_definition] = STATE(235),
    [sym_environment_definition] = STATE(235),
    [sym_glossary_entry_definition] = STATE(235),
    [sym_glossary_entry_reference] = STATE(235),
    [sym_acronym_definition] = STATE(235),
    [sym_acronym_reference] = STATE(235),
    [sym_theorem_definition] = STATE(235),
    [sym_color_definition] = STATE(235),
    [sym_color_set_definition] = STATE(235),
    [sym_color_reference] = STATE(235),
    [sym_tikz_library_import] = STATE(235),
    [sym_text_mode] = STATE(235),
    [sym_hyperlink] = STATE(235),
    [aux_sym_part_repeat1] = STATE(235),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_RBRACK] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_RPAREN] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3129),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [234] = {
    [sym_block_comment] = STATE(247),
    [sym__flat_content] = STATE(247),
    [sym__text_with_env_content] = STATE(247),
    [sym__text_content] = STATE(247),
    [sym_curly_group] = STATE(247),
    [sym_text] = STATE(247),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(247),
    [sym_inline_formula] = STATE(247),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(247),
    [sym_comment_environment] = STATE(247),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(247),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(247),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(247),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(247),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(247),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(247),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(247),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(624),
    [sym__command] = STATE(247),
    [sym_generic_command] = STATE(247),
    [sym_title_declaration] = STATE(247),
    [sym_author_declaration] = STATE(247),
    [sym_package_include] = STATE(247),
    [sym_class_include] = STATE(247),
    [sym_latex_include] = STATE(247),
    [sym_biblatex_include] = STATE(247),
    [sym_bibstyle_include] = STATE(247),
    [sym_bibtex_include] = STATE(247),
    [sym_graphics_include] = STATE(247),
    [sym_svg_include] = STATE(247),
    [sym_inkscape_include] = STATE(247),
    [sym_verbatim_include] = STATE(247),
    [sym_import_include] = STATE(247),
    [sym_caption] = STATE(247),
    [sym_citation] = STATE(247),
    [sym_label_definition] = STATE(247),
    [sym_label_reference] = STATE(247),
    [sym_label_reference_range] = STATE(247),
    [sym_label_number] = STATE(247),
    [sym_new_command_definition] = STATE(247),
    [sym_old_command_definition] = STATE(247),
    [sym_let_command_definition] = STATE(247),
    [sym_math_delimiter] = STATE(247),
    [sym_paired_delimiter_definition] = STATE(247),
    [sym_environment_definition] = STATE(247),
    [sym_glossary_entry_definition] = STATE(247),
    [sym_glossary_entry_reference] = STATE(247),
    [sym_acronym_definition] = STATE(247),
    [sym_acronym_reference] = STATE(247),
    [sym_theorem_definition] = STATE(247),
    [sym_color_definition] = STATE(247),
    [sym_color_set_definition] = STATE(247),
    [sym_color_reference] = STATE(247),
    [sym_tikz_library_import] = STATE(247),
    [sym_text_mode] = STATE(247),
    [sym_hyperlink] = STATE(247),
    [aux_sym_part_repeat1] = STATE(247),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_RBRACK] = ACTIONS(3213),
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3215),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [235] = {
    [sym_block_comment] = STATE(247),
    [sym__flat_content] = STATE(247),
    [sym__text_with_env_content] = STATE(247),
    [sym__text_content] = STATE(247),
    [sym_curly_group] = STATE(247),
    [sym_text] = STATE(247),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(247),
    [sym_inline_formula] = STATE(247),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(247),
    [sym_comment_environment] = STATE(247),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(247),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(247),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(247),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(247),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(247),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(247),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(247),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1045),
    [sym__command] = STATE(247),
    [sym_generic_command] = STATE(247),
    [sym_title_declaration] = STATE(247),
    [sym_author_declaration] = STATE(247),
    [sym_package_include] = STATE(247),
    [sym_class_include] = STATE(247),
    [sym_latex_include] = STATE(247),
    [sym_biblatex_include] = STATE(247),
    [sym_bibstyle_include] = STATE(247),
    [sym_bibtex_include] = STATE(247),
    [sym_graphics_include] = STATE(247),
    [sym_svg_include] = STATE(247),
    [sym_inkscape_include] = STATE(247),
    [sym_verbatim_include] = STATE(247),
    [sym_import_include] = STATE(247),
    [sym_caption] = STATE(247),
    [sym_citation] = STATE(247),
    [sym_label_definition] = STATE(247),
    [sym_label_reference] = STATE(247),
    [sym_label_reference_range] = STATE(247),
    [sym_label_number] = STATE(247),
    [sym_new_command_definition] = STATE(247),
    [sym_old_command_definition] = STATE(247),
    [sym_let_command_definition] = STATE(247),
    [sym_math_delimiter] = STATE(247),
    [sym_paired_delimiter_definition] = STATE(247),
    [sym_environment_definition] = STATE(247),
    [sym_glossary_entry_definition] = STATE(247),
    [sym_glossary_entry_reference] = STATE(247),
    [sym_acronym_definition] = STATE(247),
    [sym_acronym_reference] = STATE(247),
    [sym_theorem_definition] = STATE(247),
    [sym_color_definition] = STATE(247),
    [sym_color_set_definition] = STATE(247),
    [sym_color_reference] = STATE(247),
    [sym_tikz_library_import] = STATE(247),
    [sym_text_mode] = STATE(247),
    [sym_hyperlink] = STATE(247),
    [aux_sym_part_repeat1] = STATE(247),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_RBRACK] = ACTIONS(3213),
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3129),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [236] = {
    [sym_block_comment] = STATE(239),
    [sym__flat_content] = STATE(239),
    [sym__text_with_env_content] = STATE(239),
    [sym__text_content] = STATE(239),
    [sym_curly_group] = STATE(239),
    [sym_text] = STATE(239),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(239),
    [sym_inline_formula] = STATE(239),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(239),
    [sym_comment_environment] = STATE(239),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(239),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(239),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(239),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(239),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(239),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(239),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(239),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1855),
    [sym__command] = STATE(239),
    [sym_generic_command] = STATE(239),
    [sym_title_declaration] = STATE(239),
    [sym_author_declaration] = STATE(239),
    [sym_package_include] = STATE(239),
    [sym_class_include] = STATE(239),
    [sym_latex_include] = STATE(239),
    [sym_biblatex_include] = STATE(239),
    [sym_bibstyle_include] = STATE(239),
    [sym_bibtex_include] = STATE(239),
    [sym_graphics_include] = STATE(239),
    [sym_svg_include] = STATE(239),
    [sym_inkscape_include] = STATE(239),
    [sym_verbatim_include] = STATE(239),
    [sym_import_include] = STATE(239),
    [sym_caption] = STATE(239),
    [sym_citation] = STATE(239),
    [sym_label_definition] = STATE(239),
    [sym_label_reference] = STATE(239),
    [sym_label_reference_range] = STATE(239),
    [sym_label_number] = STATE(239),
    [sym_new_command_definition] = STATE(239),
    [sym_old_command_definition] = STATE(239),
    [sym_let_command_definition] = STATE(239),
    [sym_math_delimiter] = STATE(239),
    [sym_paired_delimiter_definition] = STATE(239),
    [sym_environment_definition] = STATE(239),
    [sym_glossary_entry_definition] = STATE(239),
    [sym_glossary_entry_reference] = STATE(239),
    [sym_acronym_definition] = STATE(239),
    [sym_acronym_reference] = STATE(239),
    [sym_theorem_definition] = STATE(239),
    [sym_color_definition] = STATE(239),
    [sym_color_set_definition] = STATE(239),
    [sym_color_reference] = STATE(239),
    [sym_tikz_library_import] = STATE(239),
    [sym_text_mode] = STATE(239),
    [sym_hyperlink] = STATE(239),
    [aux_sym_part_repeat1] = STATE(239),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3217),
    [anon_sym_RBRACK] = ACTIONS(3217),
    [anon_sym_COMMA] = ACTIONS(3217),
    [anon_sym_EQ] = ACTIONS(3217),
    [anon_sym_LPAREN] = ACTIONS(3217),
    [anon_sym_RPAREN] = ACTIONS(3217),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3219),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [237] = {
    [sym_block_comment] = STATE(240),
    [sym__flat_content] = STATE(240),
    [sym__text_with_env_content] = STATE(240),
    [sym__text_content] = STATE(240),
    [sym_curly_group] = STATE(240),
    [sym_text] = STATE(240),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(240),
    [sym_inline_formula] = STATE(240),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(240),
    [sym_comment_environment] = STATE(240),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(240),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(240),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(240),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(240),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(240),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(240),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(240),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1354),
    [sym__command] = STATE(240),
    [sym_generic_command] = STATE(240),
    [sym_title_declaration] = STATE(240),
    [sym_author_declaration] = STATE(240),
    [sym_package_include] = STATE(240),
    [sym_class_include] = STATE(240),
    [sym_latex_include] = STATE(240),
    [sym_biblatex_include] = STATE(240),
    [sym_bibstyle_include] = STATE(240),
    [sym_bibtex_include] = STATE(240),
    [sym_graphics_include] = STATE(240),
    [sym_svg_include] = STATE(240),
    [sym_inkscape_include] = STATE(240),
    [sym_verbatim_include] = STATE(240),
    [sym_import_include] = STATE(240),
    [sym_caption] = STATE(240),
    [sym_citation] = STATE(240),
    [sym_label_definition] = STATE(240),
    [sym_label_reference] = STATE(240),
    [sym_label_reference_range] = STATE(240),
    [sym_label_number] = STATE(240),
    [sym_new_command_definition] = STATE(240),
    [sym_old_command_definition] = STATE(240),
    [sym_let_command_definition] = STATE(240),
    [sym_math_delimiter] = STATE(240),
    [sym_paired_delimiter_definition] = STATE(240),
    [sym_environment_definition] = STATE(240),
    [sym_glossary_entry_definition] = STATE(240),
    [sym_glossary_entry_reference] = STATE(240),
    [sym_acronym_definition] = STATE(240),
    [sym_acronym_reference] = STATE(240),
    [sym_theorem_definition] = STATE(240),
    [sym_color_definition] = STATE(240),
    [sym_color_set_definition] = STATE(240),
    [sym_color_reference] = STATE(240),
    [sym_tikz_library_import] = STATE(240),
    [sym_text_mode] = STATE(240),
    [sym_hyperlink] = STATE(240),
    [aux_sym_part_repeat1] = STATE(240),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3221),
    [anon_sym_RBRACK] = ACTIONS(3221),
    [anon_sym_COMMA] = ACTIONS(3221),
    [anon_sym_EQ] = ACTIONS(3221),
    [anon_sym_LPAREN] = ACTIONS(3221),
    [anon_sym_RPAREN] = ACTIONS(3221),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3223),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [238] = {
    [sym_block_comment] = STATE(241),
    [sym__flat_content] = STATE(241),
    [sym__text_with_env_content] = STATE(241),
    [sym__text_content] = STATE(241),
    [sym_curly_group] = STATE(241),
    [sym_text] = STATE(241),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(241),
    [sym_inline_formula] = STATE(241),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(241),
    [sym_comment_environment] = STATE(241),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(241),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(241),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(241),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(241),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(241),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(241),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(241),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1083),
    [sym__command] = STATE(241),
    [sym_generic_command] = STATE(241),
    [sym_title_declaration] = STATE(241),
    [sym_author_declaration] = STATE(241),
    [sym_package_include] = STATE(241),
    [sym_class_include] = STATE(241),
    [sym_latex_include] = STATE(241),
    [sym_biblatex_include] = STATE(241),
    [sym_bibstyle_include] = STATE(241),
    [sym_bibtex_include] = STATE(241),
    [sym_graphics_include] = STATE(241),
    [sym_svg_include] = STATE(241),
    [sym_inkscape_include] = STATE(241),
    [sym_verbatim_include] = STATE(241),
    [sym_import_include] = STATE(241),
    [sym_caption] = STATE(241),
    [sym_citation] = STATE(241),
    [sym_label_definition] = STATE(241),
    [sym_label_reference] = STATE(241),
    [sym_label_reference_range] = STATE(241),
    [sym_label_number] = STATE(241),
    [sym_new_command_definition] = STATE(241),
    [sym_old_command_definition] = STATE(241),
    [sym_let_command_definition] = STATE(241),
    [sym_math_delimiter] = STATE(241),
    [sym_paired_delimiter_definition] = STATE(241),
    [sym_environment_definition] = STATE(241),
    [sym_glossary_entry_definition] = STATE(241),
    [sym_glossary_entry_reference] = STATE(241),
    [sym_acronym_definition] = STATE(241),
    [sym_acronym_reference] = STATE(241),
    [sym_theorem_definition] = STATE(241),
    [sym_color_definition] = STATE(241),
    [sym_color_set_definition] = STATE(241),
    [sym_color_reference] = STATE(241),
    [sym_tikz_library_import] = STATE(241),
    [sym_text_mode] = STATE(241),
    [sym_hyperlink] = STATE(241),
    [aux_sym_part_repeat1] = STATE(241),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3225),
    [anon_sym_RBRACK] = ACTIONS(3225),
    [anon_sym_COMMA] = ACTIONS(3225),
    [anon_sym_EQ] = ACTIONS(3225),
    [anon_sym_LPAREN] = ACTIONS(3225),
    [anon_sym_RPAREN] = ACTIONS(3225),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3227),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [239] = {
    [sym_block_comment] = STATE(247),
    [sym__flat_content] = STATE(247),
    [sym__text_with_env_content] = STATE(247),
    [sym__text_content] = STATE(247),
    [sym_curly_group] = STATE(247),
    [sym_text] = STATE(247),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(247),
    [sym_inline_formula] = STATE(247),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(247),
    [sym_comment_environment] = STATE(247),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(247),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(247),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(247),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(247),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(247),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(247),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(247),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1806),
    [sym__command] = STATE(247),
    [sym_generic_command] = STATE(247),
    [sym_title_declaration] = STATE(247),
    [sym_author_declaration] = STATE(247),
    [sym_package_include] = STATE(247),
    [sym_class_include] = STATE(247),
    [sym_latex_include] = STATE(247),
    [sym_biblatex_include] = STATE(247),
    [sym_bibstyle_include] = STATE(247),
    [sym_bibtex_include] = STATE(247),
    [sym_graphics_include] = STATE(247),
    [sym_svg_include] = STATE(247),
    [sym_inkscape_include] = STATE(247),
    [sym_verbatim_include] = STATE(247),
    [sym_import_include] = STATE(247),
    [sym_caption] = STATE(247),
    [sym_citation] = STATE(247),
    [sym_label_definition] = STATE(247),
    [sym_label_reference] = STATE(247),
    [sym_label_reference_range] = STATE(247),
    [sym_label_number] = STATE(247),
    [sym_new_command_definition] = STATE(247),
    [sym_old_command_definition] = STATE(247),
    [sym_let_command_definition] = STATE(247),
    [sym_math_delimiter] = STATE(247),
    [sym_paired_delimiter_definition] = STATE(247),
    [sym_environment_definition] = STATE(247),
    [sym_glossary_entry_definition] = STATE(247),
    [sym_glossary_entry_reference] = STATE(247),
    [sym_acronym_definition] = STATE(247),
    [sym_acronym_reference] = STATE(247),
    [sym_theorem_definition] = STATE(247),
    [sym_color_definition] = STATE(247),
    [sym_color_set_definition] = STATE(247),
    [sym_color_reference] = STATE(247),
    [sym_tikz_library_import] = STATE(247),
    [sym_text_mode] = STATE(247),
    [sym_hyperlink] = STATE(247),
    [aux_sym_part_repeat1] = STATE(247),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_RBRACK] = ACTIONS(3213),
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3219),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [240] = {
    [sym_block_comment] = STATE(247),
    [sym__flat_content] = STATE(247),
    [sym__text_with_env_content] = STATE(247),
    [sym__text_content] = STATE(247),
    [sym_curly_group] = STATE(247),
    [sym_text] = STATE(247),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(247),
    [sym_inline_formula] = STATE(247),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(247),
    [sym_comment_environment] = STATE(247),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(247),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(247),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(247),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(247),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(247),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(247),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(247),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1430),
    [sym__command] = STATE(247),
    [sym_generic_command] = STATE(247),
    [sym_title_declaration] = STATE(247),
    [sym_author_declaration] = STATE(247),
    [sym_package_include] = STATE(247),
    [sym_class_include] = STATE(247),
    [sym_latex_include] = STATE(247),
    [sym_biblatex_include] = STATE(247),
    [sym_bibstyle_include] = STATE(247),
    [sym_bibtex_include] = STATE(247),
    [sym_graphics_include] = STATE(247),
    [sym_svg_include] = STATE(247),
    [sym_inkscape_include] = STATE(247),
    [sym_verbatim_include] = STATE(247),
    [sym_import_include] = STATE(247),
    [sym_caption] = STATE(247),
    [sym_citation] = STATE(247),
    [sym_label_definition] = STATE(247),
    [sym_label_reference] = STATE(247),
    [sym_label_reference_range] = STATE(247),
    [sym_label_number] = STATE(247),
    [sym_new_command_definition] = STATE(247),
    [sym_old_command_definition] = STATE(247),
    [sym_let_command_definition] = STATE(247),
    [sym_math_delimiter] = STATE(247),
    [sym_paired_delimiter_definition] = STATE(247),
    [sym_environment_definition] = STATE(247),
    [sym_glossary_entry_definition] = STATE(247),
    [sym_glossary_entry_reference] = STATE(247),
    [sym_acronym_definition] = STATE(247),
    [sym_acronym_reference] = STATE(247),
    [sym_theorem_definition] = STATE(247),
    [sym_color_definition] = STATE(247),
    [sym_color_set_definition] = STATE(247),
    [sym_color_reference] = STATE(247),
    [sym_tikz_library_import] = STATE(247),
    [sym_text_mode] = STATE(247),
    [sym_hyperlink] = STATE(247),
    [aux_sym_part_repeat1] = STATE(247),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_RBRACK] = ACTIONS(3213),
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3223),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [241] = {
    [sym_block_comment] = STATE(247),
    [sym__flat_content] = STATE(247),
    [sym__text_with_env_content] = STATE(247),
    [sym__text_content] = STATE(247),
    [sym_curly_group] = STATE(247),
    [sym_text] = STATE(247),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(247),
    [sym_inline_formula] = STATE(247),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(247),
    [sym_comment_environment] = STATE(247),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(247),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(247),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(247),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(247),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(247),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(247),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(247),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1165),
    [sym__command] = STATE(247),
    [sym_generic_command] = STATE(247),
    [sym_title_declaration] = STATE(247),
    [sym_author_declaration] = STATE(247),
    [sym_package_include] = STATE(247),
    [sym_class_include] = STATE(247),
    [sym_latex_include] = STATE(247),
    [sym_biblatex_include] = STATE(247),
    [sym_bibstyle_include] = STATE(247),
    [sym_bibtex_include] = STATE(247),
    [sym_graphics_include] = STATE(247),
    [sym_svg_include] = STATE(247),
    [sym_inkscape_include] = STATE(247),
    [sym_verbatim_include] = STATE(247),
    [sym_import_include] = STATE(247),
    [sym_caption] = STATE(247),
    [sym_citation] = STATE(247),
    [sym_label_definition] = STATE(247),
    [sym_label_reference] = STATE(247),
    [sym_label_reference_range] = STATE(247),
    [sym_label_number] = STATE(247),
    [sym_new_command_definition] = STATE(247),
    [sym_old_command_definition] = STATE(247),
    [sym_let_command_definition] = STATE(247),
    [sym_math_delimiter] = STATE(247),
    [sym_paired_delimiter_definition] = STATE(247),
    [sym_environment_definition] = STATE(247),
    [sym_glossary_entry_definition] = STATE(247),
    [sym_glossary_entry_reference] = STATE(247),
    [sym_acronym_definition] = STATE(247),
    [sym_acronym_reference] = STATE(247),
    [sym_theorem_definition] = STATE(247),
    [sym_color_definition] = STATE(247),
    [sym_color_set_definition] = STATE(247),
    [sym_color_reference] = STATE(247),
    [sym_tikz_library_import] = STATE(247),
    [sym_text_mode] = STATE(247),
    [sym_hyperlink] = STATE(247),
    [aux_sym_part_repeat1] = STATE(247),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_RBRACK] = ACTIONS(3213),
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3227),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [242] = {
    [sym_block_comment] = STATE(246),
    [sym__flat_content] = STATE(246),
    [sym__text_with_env_content] = STATE(246),
    [sym__text_content] = STATE(246),
    [sym_curly_group] = STATE(246),
    [sym_text] = STATE(246),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(246),
    [sym_inline_formula] = STATE(246),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(246),
    [sym_comment_environment] = STATE(246),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(246),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(246),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(246),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(246),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(246),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(246),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(246),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1537),
    [sym__command] = STATE(246),
    [sym_generic_command] = STATE(246),
    [sym_title_declaration] = STATE(246),
    [sym_author_declaration] = STATE(246),
    [sym_package_include] = STATE(246),
    [sym_class_include] = STATE(246),
    [sym_latex_include] = STATE(246),
    [sym_biblatex_include] = STATE(246),
    [sym_bibstyle_include] = STATE(246),
    [sym_bibtex_include] = STATE(246),
    [sym_graphics_include] = STATE(246),
    [sym_svg_include] = STATE(246),
    [sym_inkscape_include] = STATE(246),
    [sym_verbatim_include] = STATE(246),
    [sym_import_include] = STATE(246),
    [sym_caption] = STATE(246),
    [sym_citation] = STATE(246),
    [sym_label_definition] = STATE(246),
    [sym_label_reference] = STATE(246),
    [sym_label_reference_range] = STATE(246),
    [sym_label_number] = STATE(246),
    [sym_new_command_definition] = STATE(246),
    [sym_old_command_definition] = STATE(246),
    [sym_let_command_definition] = STATE(246),
    [sym_math_delimiter] = STATE(246),
    [sym_paired_delimiter_definition] = STATE(246),
    [sym_environment_definition] = STATE(246),
    [sym_glossary_entry_definition] = STATE(246),
    [sym_glossary_entry_reference] = STATE(246),
    [sym_acronym_definition] = STATE(246),
    [sym_acronym_reference] = STATE(246),
    [sym_theorem_definition] = STATE(246),
    [sym_color_definition] = STATE(246),
    [sym_color_set_definition] = STATE(246),
    [sym_color_reference] = STATE(246),
    [sym_tikz_library_import] = STATE(246),
    [sym_text_mode] = STATE(246),
    [sym_hyperlink] = STATE(246),
    [aux_sym_part_repeat1] = STATE(246),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3229),
    [anon_sym_RBRACK] = ACTIONS(3229),
    [anon_sym_COMMA] = ACTIONS(3229),
    [anon_sym_EQ] = ACTIONS(3229),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_RPAREN] = ACTIONS(3229),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3231),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [243] = {
    [sym_block_comment] = STATE(244),
    [sym__flat_content] = STATE(244),
    [sym__text_with_env_content] = STATE(244),
    [sym__text_content] = STATE(244),
    [sym_curly_group] = STATE(244),
    [sym_text] = STATE(244),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(244),
    [sym_inline_formula] = STATE(244),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(244),
    [sym_comment_environment] = STATE(244),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(244),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(244),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(244),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(244),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(244),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(244),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(244),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1319),
    [sym__command] = STATE(244),
    [sym_generic_command] = STATE(244),
    [sym_title_declaration] = STATE(244),
    [sym_author_declaration] = STATE(244),
    [sym_package_include] = STATE(244),
    [sym_class_include] = STATE(244),
    [sym_latex_include] = STATE(244),
    [sym_biblatex_include] = STATE(244),
    [sym_bibstyle_include] = STATE(244),
    [sym_bibtex_include] = STATE(244),
    [sym_graphics_include] = STATE(244),
    [sym_svg_include] = STATE(244),
    [sym_inkscape_include] = STATE(244),
    [sym_verbatim_include] = STATE(244),
    [sym_import_include] = STATE(244),
    [sym_caption] = STATE(244),
    [sym_citation] = STATE(244),
    [sym_label_definition] = STATE(244),
    [sym_label_reference] = STATE(244),
    [sym_label_reference_range] = STATE(244),
    [sym_label_number] = STATE(244),
    [sym_new_command_definition] = STATE(244),
    [sym_old_command_definition] = STATE(244),
    [sym_let_command_definition] = STATE(244),
    [sym_math_delimiter] = STATE(244),
    [sym_paired_delimiter_definition] = STATE(244),
    [sym_environment_definition] = STATE(244),
    [sym_glossary_entry_definition] = STATE(244),
    [sym_glossary_entry_reference] = STATE(244),
    [sym_acronym_definition] = STATE(244),
    [sym_acronym_reference] = STATE(244),
    [sym_theorem_definition] = STATE(244),
    [sym_color_definition] = STATE(244),
    [sym_color_set_definition] = STATE(244),
    [sym_color_reference] = STATE(244),
    [sym_tikz_library_import] = STATE(244),
    [sym_text_mode] = STATE(244),
    [sym_hyperlink] = STATE(244),
    [aux_sym_part_repeat1] = STATE(244),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3233),
    [anon_sym_RBRACK] = ACTIONS(3233),
    [anon_sym_COMMA] = ACTIONS(3233),
    [anon_sym_EQ] = ACTIONS(3233),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_RPAREN] = ACTIONS(3233),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3235),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [244] = {
    [sym_block_comment] = STATE(247),
    [sym__flat_content] = STATE(247),
    [sym__text_with_env_content] = STATE(247),
    [sym__text_content] = STATE(247),
    [sym_curly_group] = STATE(247),
    [sym_text] = STATE(247),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(247),
    [sym_inline_formula] = STATE(247),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(247),
    [sym_comment_environment] = STATE(247),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(247),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(247),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(247),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(247),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(247),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(247),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(247),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1247),
    [sym__command] = STATE(247),
    [sym_generic_command] = STATE(247),
    [sym_title_declaration] = STATE(247),
    [sym_author_declaration] = STATE(247),
    [sym_package_include] = STATE(247),
    [sym_class_include] = STATE(247),
    [sym_latex_include] = STATE(247),
    [sym_biblatex_include] = STATE(247),
    [sym_bibstyle_include] = STATE(247),
    [sym_bibtex_include] = STATE(247),
    [sym_graphics_include] = STATE(247),
    [sym_svg_include] = STATE(247),
    [sym_inkscape_include] = STATE(247),
    [sym_verbatim_include] = STATE(247),
    [sym_import_include] = STATE(247),
    [sym_caption] = STATE(247),
    [sym_citation] = STATE(247),
    [sym_label_definition] = STATE(247),
    [sym_label_reference] = STATE(247),
    [sym_label_reference_range] = STATE(247),
    [sym_label_number] = STATE(247),
    [sym_new_command_definition] = STATE(247),
    [sym_old_command_definition] = STATE(247),
    [sym_let_command_definition] = STATE(247),
    [sym_math_delimiter] = STATE(247),
    [sym_paired_delimiter_definition] = STATE(247),
    [sym_environment_definition] = STATE(247),
    [sym_glossary_entry_definition] = STATE(247),
    [sym_glossary_entry_reference] = STATE(247),
    [sym_acronym_definition] = STATE(247),
    [sym_acronym_reference] = STATE(247),
    [sym_theorem_definition] = STATE(247),
    [sym_color_definition] = STATE(247),
    [sym_color_set_definition] = STATE(247),
    [sym_color_reference] = STATE(247),
    [sym_tikz_library_import] = STATE(247),
    [sym_text_mode] = STATE(247),
    [sym_hyperlink] = STATE(247),
    [aux_sym_part_repeat1] = STATE(247),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_RBRACK] = ACTIONS(3213),
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3235),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [245] = {
    [sym_block_comment] = STATE(234),
    [sym__flat_content] = STATE(234),
    [sym__text_with_env_content] = STATE(234),
    [sym__text_content] = STATE(234),
    [sym_curly_group] = STATE(234),
    [sym_text] = STATE(234),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(234),
    [sym_inline_formula] = STATE(234),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(234),
    [sym_comment_environment] = STATE(234),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(234),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(234),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(234),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(234),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(234),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(234),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(234),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(589),
    [sym__command] = STATE(234),
    [sym_generic_command] = STATE(234),
    [sym_title_declaration] = STATE(234),
    [sym_author_declaration] = STATE(234),
    [sym_package_include] = STATE(234),
    [sym_class_include] = STATE(234),
    [sym_latex_include] = STATE(234),
    [sym_biblatex_include] = STATE(234),
    [sym_bibstyle_include] = STATE(234),
    [sym_bibtex_include] = STATE(234),
    [sym_graphics_include] = STATE(234),
    [sym_svg_include] = STATE(234),
    [sym_inkscape_include] = STATE(234),
    [sym_verbatim_include] = STATE(234),
    [sym_import_include] = STATE(234),
    [sym_caption] = STATE(234),
    [sym_citation] = STATE(234),
    [sym_label_definition] = STATE(234),
    [sym_label_reference] = STATE(234),
    [sym_label_reference_range] = STATE(234),
    [sym_label_number] = STATE(234),
    [sym_new_command_definition] = STATE(234),
    [sym_old_command_definition] = STATE(234),
    [sym_let_command_definition] = STATE(234),
    [sym_math_delimiter] = STATE(234),
    [sym_paired_delimiter_definition] = STATE(234),
    [sym_environment_definition] = STATE(234),
    [sym_glossary_entry_definition] = STATE(234),
    [sym_glossary_entry_reference] = STATE(234),
    [sym_acronym_definition] = STATE(234),
    [sym_acronym_reference] = STATE(234),
    [sym_theorem_definition] = STATE(234),
    [sym_color_definition] = STATE(234),
    [sym_color_set_definition] = STATE(234),
    [sym_color_reference] = STATE(234),
    [sym_tikz_library_import] = STATE(234),
    [sym_text_mode] = STATE(234),
    [sym_hyperlink] = STATE(234),
    [aux_sym_part_repeat1] = STATE(234),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3237),
    [anon_sym_RBRACK] = ACTIONS(3237),
    [anon_sym_COMMA] = ACTIONS(3237),
    [anon_sym_EQ] = ACTIONS(3237),
    [anon_sym_LPAREN] = ACTIONS(3237),
    [anon_sym_RPAREN] = ACTIONS(3237),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3215),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [246] = {
    [sym_block_comment] = STATE(247),
    [sym__flat_content] = STATE(247),
    [sym__text_with_env_content] = STATE(247),
    [sym__text_content] = STATE(247),
    [sym_curly_group] = STATE(247),
    [sym_text] = STATE(247),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(247),
    [sym_inline_formula] = STATE(247),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(247),
    [sym_comment_environment] = STATE(247),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(247),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(247),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(247),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(247),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(247),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(247),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(247),
    [sym__math_environment_begin] = STATE(242),
    [sym__math_environment_end] = STATE(1594),
    [sym__command] = STATE(247),
    [sym_generic_command] = STATE(247),
    [sym_title_declaration] = STATE(247),
    [sym_author_declaration] = STATE(247),
    [sym_package_include] = STATE(247),
    [sym_class_include] = STATE(247),
    [sym_latex_include] = STATE(247),
    [sym_biblatex_include] = STATE(247),
    [sym_bibstyle_include] = STATE(247),
    [sym_bibtex_include] = STATE(247),
    [sym_graphics_include] = STATE(247),
    [sym_svg_include] = STATE(247),
    [sym_inkscape_include] = STATE(247),
    [sym_verbatim_include] = STATE(247),
    [sym_import_include] = STATE(247),
    [sym_caption] = STATE(247),
    [sym_citation] = STATE(247),
    [sym_label_definition] = STATE(247),
    [sym_label_reference] = STATE(247),
    [sym_label_reference_range] = STATE(247),
    [sym_label_number] = STATE(247),
    [sym_new_command_definition] = STATE(247),
    [sym_old_command_definition] = STATE(247),
    [sym_let_command_definition] = STATE(247),
    [sym_math_delimiter] = STATE(247),
    [sym_paired_delimiter_definition] = STATE(247),
    [sym_environment_definition] = STATE(247),
    [sym_glossary_entry_definition] = STATE(247),
    [sym_glossary_entry_reference] = STATE(247),
    [sym_acronym_definition] = STATE(247),
    [sym_acronym_reference] = STATE(247),
    [sym_theorem_definition] = STATE(247),
    [sym_color_definition] = STATE(247),
    [sym_color_set_definition] = STATE(247),
    [sym_color_reference] = STATE(247),
    [sym_tikz_library_import] = STATE(247),
    [sym_text_mode] = STATE(247),
    [sym_hyperlink] = STATE(247),
    [aux_sym_part_repeat1] = STATE(247),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3213),
    [anon_sym_RBRACK] = ACTIONS(3213),
    [anon_sym_COMMA] = ACTIONS(3213),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_LPAREN] = ACTIONS(3213),
    [anon_sym_RPAREN] = ACTIONS(3213),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3123),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3123),
    [anon_sym_DOLLAR] = ACTIONS(3125),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3127),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHend] = ACTIONS(3231),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3183),
    [anon_sym_BSLASHbigl] = ACTIONS(3183),
    [anon_sym_BSLASHBigl] = ACTIONS(3183),
    [anon_sym_BSLASHbiggl] = ACTIONS(3183),
    [anon_sym_BSLASHBiggl] = ACTIONS(3183),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3209),
    [anon_sym_BSLASHintertext] = ACTIONS(3209),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3209),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [247] = {
    [sym_block_comment] = STATE(247),
    [sym__flat_content] = STATE(247),
    [sym__text_with_env_content] = STATE(247),
    [sym__text_content] = STATE(247),
    [sym_curly_group] = STATE(247),
    [sym_text] = STATE(247),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym_displayed_equation] = STATE(247),
    [sym_inline_formula] = STATE(247),
    [sym_begin] = STATE(63),
    [sym_generic_environment] = STATE(247),
    [sym_comment_environment] = STATE(247),
    [sym__comment_environment_begin] = STATE(3235),
    [sym_verbatim_environment] = STATE(247),
    [sym__verbatim_environment_begin] = STATE(3234),
    [sym_listing_environment] = STATE(247),
    [sym__listing_environment_begin] = STATE(3233),
    [sym_minted_environment] = STATE(247),
    [sym__minted_environment_begin] = STATE(3232),
    [sym_pycode_environment] = STATE(247),
    [sym__pycode_environment_begin] = STATE(3231),
    [sym_sagesilent_environment] = STATE(247),
    [sym__sagesilent_environment_begin] = STATE(3230),
    [sym_sageblock_environment] = STATE(247),
    [sym__sageblock_environment_begin] = STATE(3229),
    [sym_math_environment] = STATE(247),
    [sym__math_environment_begin] = STATE(242),
    [sym__command] = STATE(247),
    [sym_generic_command] = STATE(247),
    [sym_title_declaration] = STATE(247),
    [sym_author_declaration] = STATE(247),
    [sym_package_include] = STATE(247),
    [sym_class_include] = STATE(247),
    [sym_latex_include] = STATE(247),
    [sym_biblatex_include] = STATE(247),
    [sym_bibstyle_include] = STATE(247),
    [sym_bibtex_include] = STATE(247),
    [sym_graphics_include] = STATE(247),
    [sym_svg_include] = STATE(247),
    [sym_inkscape_include] = STATE(247),
    [sym_verbatim_include] = STATE(247),
    [sym_import_include] = STATE(247),
    [sym_caption] = STATE(247),
    [sym_citation] = STATE(247),
    [sym_label_definition] = STATE(247),
    [sym_label_reference] = STATE(247),
    [sym_label_reference_range] = STATE(247),
    [sym_label_number] = STATE(247),
    [sym_new_command_definition] = STATE(247),
    [sym_old_command_definition] = STATE(247),
    [sym_let_command_definition] = STATE(247),
    [sym_math_delimiter] = STATE(247),
    [sym_paired_delimiter_definition] = STATE(247),
    [sym_environment_definition] = STATE(247),
    [sym_glossary_entry_definition] = STATE(247),
    [sym_glossary_entry_reference] = STATE(247),
    [sym_acronym_definition] = STATE(247),
    [sym_acronym_reference] = STATE(247),
    [sym_theorem_definition] = STATE(247),
    [sym_color_definition] = STATE(247),
    [sym_color_set_definition] = STATE(247),
    [sym_color_reference] = STATE(247),
    [sym_tikz_library_import] = STATE(247),
    [sym_text_mode] = STATE(247),
    [sym_hyperlink] = STATE(247),
    [aux_sym_part_repeat1] = STATE(247),
    [aux_sym_text_repeat1] = STATE(319),
    [sym_command_name] = ACTIONS(3239),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(3245),
    [anon_sym_RBRACK] = ACTIONS(3245),
    [anon_sym_COMMA] = ACTIONS(3245),
    [anon_sym_EQ] = ACTIONS(3245),
    [anon_sym_LPAREN] = ACTIONS(3245),
    [anon_sym_RPAREN] = ACTIONS(3245),
    [anon_sym_LBRACE] = ACTIONS(3248),
    [sym_word] = ACTIONS(3251),
    [sym_placeholder] = ACTIONS(3254),
    [anon_sym_PLUS] = ACTIONS(3257),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_STAR] = ACTIONS(3257),
    [anon_sym_SLASH] = ACTIONS(3257),
    [anon_sym_LT] = ACTIONS(3260),
    [anon_sym_GT] = ACTIONS(3260),
    [anon_sym_BANG] = ACTIONS(3260),
    [anon_sym_PIPE] = ACTIONS(3260),
    [anon_sym_COLON] = ACTIONS(3260),
    [anon_sym_SQUOTE] = ACTIONS(3260),
    [anon_sym__] = ACTIONS(3263),
    [anon_sym_CARET] = ACTIONS(3266),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3269),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3269),
    [anon_sym_DOLLAR] = ACTIONS(3272),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3275),
    [anon_sym_BSLASHbegin] = ACTIONS(2309),
    [anon_sym_BSLASHend] = ACTIONS(2275),
    [anon_sym_BSLASHtitle] = ACTIONS(3278),
    [anon_sym_BSLASHauthor] = ACTIONS(3281),
    [anon_sym_BSLASHusepackage] = ACTIONS(3284),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3284),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3287),
    [anon_sym_BSLASHinclude] = ACTIONS(3290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3290),
    [anon_sym_BSLASHinput] = ACTIONS(3290),
    [anon_sym_BSLASHsubfile] = ACTIONS(3290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3293),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3296),
    [anon_sym_BSLASHbibliography] = ACTIONS(3299),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3305),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3308),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3311),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3311),
    [anon_sym_BSLASHimport] = ACTIONS(3314),
    [anon_sym_BSLASHsubimport] = ACTIONS(3314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3314),
    [anon_sym_BSLASHcaption] = ACTIONS(3317),
    [anon_sym_BSLASHcite] = ACTIONS(3320),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHCite] = ACTIONS(3320),
    [anon_sym_BSLASHnocite] = ACTIONS(3320),
    [anon_sym_BSLASHcitet] = ACTIONS(3320),
    [anon_sym_BSLASHcitep] = ACTIONS(3320),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHciteA] = ACTIONS(3320),
    [anon_sym_BSLASHciteR] = ACTIONS(3320),
    [anon_sym_BSLASHciteS] = ACTIONS(3320),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3320),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3320),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3320),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3320),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHciteyear] = ACTIONS(3320),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHcitedate] = ACTIONS(3320),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHciteurl] = ACTIONS(3320),
    [anon_sym_BSLASHfullcite] = ACTIONS(3320),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3320),
    [anon_sym_BSLASHcitealt] = ACTIONS(3320),
    [anon_sym_BSLASHcitealp] = ACTIONS(3320),
    [anon_sym_BSLASHcitetext] = ACTIONS(3320),
    [anon_sym_BSLASHparencite] = ACTIONS(3320),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHParencite] = ACTIONS(3320),
    [anon_sym_BSLASHfootcite] = ACTIONS(3320),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3320),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3320),
    [anon_sym_BSLASHtextcite] = ACTIONS(3320),
    [anon_sym_BSLASHTextcite] = ACTIONS(3320),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3320),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3320),
    [anon_sym_BSLASHsupercite] = ACTIONS(3320),
    [anon_sym_BSLASHautocite] = ACTIONS(3320),
    [anon_sym_BSLASHAutocite] = ACTIONS(3320),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3323),
    [anon_sym_BSLASHvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHVolcite] = ACTIONS(3320),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHavolcite] = ACTIONS(3320),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3320),
    [anon_sym_BSLASHnotecite] = ACTIONS(3320),
    [anon_sym_BSLASHNotecite] = ACTIONS(3320),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3320),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3320),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3320),
    [anon_sym_BSLASHlabel] = ACTIONS(3326),
    [anon_sym_BSLASHref] = ACTIONS(3329),
    [anon_sym_BSLASHeqref] = ACTIONS(3329),
    [anon_sym_BSLASHvref] = ACTIONS(3329),
    [anon_sym_BSLASHVref] = ACTIONS(3329),
    [anon_sym_BSLASHautoref] = ACTIONS(3329),
    [anon_sym_BSLASHpageref] = ACTIONS(3329),
    [anon_sym_BSLASHcref] = ACTIONS(3329),
    [anon_sym_BSLASHCref] = ACTIONS(3329),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3332),
    [anon_sym_BSLASHnamecref] = ACTIONS(3329),
    [anon_sym_BSLASHnameCref] = ACTIONS(3329),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3329),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3329),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3329),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3329),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3329),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3329),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3335),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3338),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3335),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3338),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3341),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3344),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3347),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3344),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3347),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3344),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3347),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3344),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3347),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3344),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3344),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3344),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3344),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3344),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3344),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3344),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3344),
    [anon_sym_BSLASHdef] = ACTIONS(3350),
    [anon_sym_BSLASHlet] = ACTIONS(3353),
    [anon_sym_BSLASHleft] = ACTIONS(3356),
    [anon_sym_BSLASHbigl] = ACTIONS(3356),
    [anon_sym_BSLASHBigl] = ACTIONS(3356),
    [anon_sym_BSLASHbiggl] = ACTIONS(3356),
    [anon_sym_BSLASHBiggl] = ACTIONS(3356),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3359),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3359),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3365),
    [anon_sym_BSLASHgls] = ACTIONS(3368),
    [anon_sym_BSLASHGls] = ACTIONS(3368),
    [anon_sym_BSLASHGLS] = ACTIONS(3368),
    [anon_sym_BSLASHglspl] = ACTIONS(3368),
    [anon_sym_BSLASHGlspl] = ACTIONS(3368),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3368),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3368),
    [anon_sym_BSLASHglslink] = ACTIONS(3368),
    [anon_sym_BSLASHglstext] = ACTIONS(3368),
    [anon_sym_BSLASHGlstext] = ACTIONS(3368),
    [anon_sym_BSLASHGLStext] = ACTIONS(3368),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3368),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3368),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3368),
    [anon_sym_BSLASHglsplural] = ACTIONS(3368),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3368),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3368),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3368),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3368),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3368),
    [anon_sym_BSLASHglsname] = ACTIONS(3368),
    [anon_sym_BSLASHGlsname] = ACTIONS(3368),
    [anon_sym_BSLASHGLSname] = ACTIONS(3368),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3368),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3368),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3368),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3368),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3368),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3368),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3368),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3368),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3368),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3368),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3368),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3368),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3368),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3368),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3368),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3368),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3368),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3368),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3368),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3368),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3368),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3368),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3368),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3371),
    [anon_sym_BSLASHacrshort] = ACTIONS(3374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3374),
    [anon_sym_BSLASHACRshort] = ACTIONS(3374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3374),
    [anon_sym_BSLASHacrlong] = ACTIONS(3374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3374),
    [anon_sym_BSLASHACRlong] = ACTIONS(3374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3374),
    [anon_sym_BSLASHacrfull] = ACTIONS(3374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3374),
    [anon_sym_BSLASHACRfull] = ACTIONS(3374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3374),
    [anon_sym_BSLASHacs] = ACTIONS(3374),
    [anon_sym_BSLASHAcs] = ACTIONS(3374),
    [anon_sym_BSLASHacsp] = ACTIONS(3374),
    [anon_sym_BSLASHAcsp] = ACTIONS(3374),
    [anon_sym_BSLASHacl] = ACTIONS(3374),
    [anon_sym_BSLASHAcl] = ACTIONS(3374),
    [anon_sym_BSLASHaclp] = ACTIONS(3374),
    [anon_sym_BSLASHAclp] = ACTIONS(3374),
    [anon_sym_BSLASHacf] = ACTIONS(3374),
    [anon_sym_BSLASHAcf] = ACTIONS(3374),
    [anon_sym_BSLASHacfp] = ACTIONS(3374),
    [anon_sym_BSLASHAcfp] = ACTIONS(3374),
    [anon_sym_BSLASHac] = ACTIONS(3374),
    [anon_sym_BSLASHAc] = ACTIONS(3374),
    [anon_sym_BSLASHacp] = ACTIONS(3374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3377),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3377),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3383),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3386),
    [anon_sym_BSLASHcolor] = ACTIONS(3389),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3389),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3389),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3389),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3392),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3392),
    [anon_sym_BSLASHtext] = ACTIONS(3395),
    [anon_sym_BSLASHintertext] = ACTIONS(3395),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3395),
    [anon_sym_BSLASHurl] = ACTIONS(3398),
    [anon_sym_BSLASHhref] = ACTIONS(3398),
  },
  [248] = {
    [sym_block_comment] = STATE(254),
    [sym__text_with_env_content] = STATE(254),
    [sym__text_content] = STATE(254),
    [sym_curly_group] = STATE(254),
    [sym_brack_group] = STATE(254),
    [sym_text] = STATE(254),
    [sym_operator] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_superscript] = STATE(1763),
    [sym_displayed_equation] = STATE(254),
    [sym_inline_formula] = STATE(254),
    [sym_begin] = STATE(38),
    [sym_generic_environment] = STATE(254),
    [sym_comment_environment] = STATE(254),
    [sym__comment_environment_begin] = STATE(3238),
    [sym_verbatim_environment] = STATE(254),
    [sym__verbatim_environment_begin] = STATE(3239),
    [sym_listing_environment] = STATE(254),
    [sym__listing_environment_begin] = STATE(3240),
    [sym_minted_environment] = STATE(254),
    [sym__minted_environment_begin] = STATE(3241),
    [sym_pycode_environment] = STATE(254),
    [sym__pycode_environment_begin] = STATE(3242),
    [sym_sagesilent_environment] = STATE(254),
    [sym__sagesilent_environment_begin] = STATE(3243),
    [sym_sageblock_environment] = STATE(254),
    [sym__sageblock_environment_begin] = STATE(3244),
    [sym_math_environment] = STATE(254),
    [sym__math_environment_begin] = STATE(236),
    [sym__command] = STATE(254),
    [sym_generic_command] = STATE(254),
    [sym_title_declaration] = STATE(254),
    [sym_author_declaration] = STATE(254),
    [sym_package_include] = STATE(254),
    [sym_class_include] = STATE(254),
    [sym_latex_include] = STATE(254),
    [sym_biblatex_include] = STATE(254),
    [sym_bibstyle_include] = STATE(254),
    [sym_bibtex_include] = STATE(254),
    [sym_graphics_include] = STATE(254),
    [sym_svg_include] = STATE(254),
    [sym_inkscape_include] = STATE(254),
    [sym_verbatim_include] = STATE(254),
    [sym_import_include] = STATE(254),
    [sym_caption] = STATE(254),
    [sym_citation] = STATE(254),
    [sym_label_definition] = STATE(254),
    [sym_label_reference] = STATE(254),
    [sym_label_reference_range] = STATE(254),
    [sym_label_number] = STATE(254),
    [sym_new_command_definition] = STATE(254),
    [sym_old_command_definition] = STATE(254),
    [sym_let_command_definition] = STATE(254),
    [sym_math_delimiter] = STATE(254),
    [sym_paired_delimiter_definition] = STATE(254),
    [sym_environment_definition] = STATE(254),
    [sym_glossary_entry_definition] = STATE(254),
    [sym_glossary_entry_reference] = STATE(254),
    [sym_acronym_definition] = STATE(254),
    [sym_acronym_reference] = STATE(254),
    [sym_theorem_definition] = STATE(254),
    [sym_color_definition] = STATE(254),
    [sym_color_set_definition] = STATE(254),
    [sym_color_reference] = STATE(254),
    [sym_tikz_library_import] = STATE(254),
    [sym_text_mode] = STATE(254),
    [sym_hyperlink] = STATE(254),
    [aux_sym_brack_group_repeat1] = STATE(254),
    [aux_sym_text_repeat1] = STATE(322),
    [sym_command_name] = ACTIONS(3401),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(3407),
    [anon_sym_COMMA] = ACTIONS(3409),
    [anon_sym_EQ] = ACTIONS(3409),
    [anon_sym_LPAREN] = ACTIONS(3409),
    [anon_sym_RPAREN] = ACTIONS(3409),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(3413),
    [sym_placeholder] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym__] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3425),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3429),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(3431),
    [anon_sym_BSLASHauthor] = ACTIONS(3433),
    [anon_sym_BSLASHusepackage] = ACTIONS(3435),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3435),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3437),
    [anon_sym_BSLASHinclude] = ACTIONS(3439),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3439),
    [anon_sym_BSLASHinput] = ACTIONS(3439),
    [anon_sym_BSLASHsubfile] = ACTIONS(3439),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3441),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3443),
    [anon_sym_BSLASHbibliography] = ACTIONS(3445),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3447),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3449),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3451),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3453),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3453),
    [anon_sym_BSLASHimport] = ACTIONS(3455),
    [anon_sym_BSLASHsubimport] = ACTIONS(3455),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3455),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHcaption] = ACTIONS(3457),
    [anon_sym_BSLASHcite] = ACTIONS(3459),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCite] = ACTIONS(3459),
    [anon_sym_BSLASHnocite] = ACTIONS(3459),
    [anon_sym_BSLASHcitet] = ACTIONS(3459),
    [anon_sym_BSLASHcitep] = ACTIONS(3459),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteA] = ACTIONS(3459),
    [anon_sym_BSLASHciteR] = ACTIONS(3459),
    [anon_sym_BSLASHciteS] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3459),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteyear] = ACTIONS(3459),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitedate] = ACTIONS(3459),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteurl] = ACTIONS(3459),
    [anon_sym_BSLASHfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3459),
    [anon_sym_BSLASHcitealt] = ACTIONS(3459),
    [anon_sym_BSLASHcitealp] = ACTIONS(3459),
    [anon_sym_BSLASHcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHparencite] = ACTIONS(3459),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHParencite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHtextcite] = ACTIONS(3459),
    [anon_sym_BSLASHTextcite] = ACTIONS(3459),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHsupercite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite] = ACTIONS(3459),
    [anon_sym_BSLASHAutocite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHVolcite] = ACTIONS(3459),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHavolcite] = ACTIONS(3459),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHNotecite] = ACTIONS(3459),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHlabel] = ACTIONS(3463),
    [anon_sym_BSLASHref] = ACTIONS(3465),
    [anon_sym_BSLASHeqref] = ACTIONS(3465),
    [anon_sym_BSLASHvref] = ACTIONS(3465),
    [anon_sym_BSLASHVref] = ACTIONS(3465),
    [anon_sym_BSLASHautoref] = ACTIONS(3465),
    [anon_sym_BSLASHpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcref] = ACTIONS(3465),
    [anon_sym_BSLASHCref] = ACTIONS(3465),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnameCref] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3473),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHdef] = ACTIONS(3479),
    [anon_sym_BSLASHlet] = ACTIONS(3481),
    [anon_sym_BSLASHleft] = ACTIONS(3483),
    [anon_sym_BSLASHbigl] = ACTIONS(3483),
    [anon_sym_BSLASHBigl] = ACTIONS(3483),
    [anon_sym_BSLASHbiggl] = ACTIONS(3483),
    [anon_sym_BSLASHBiggl] = ACTIONS(3483),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3485),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3485),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3489),
    [anon_sym_BSLASHgls] = ACTIONS(3491),
    [anon_sym_BSLASHGls] = ACTIONS(3491),
    [anon_sym_BSLASHGLS] = ACTIONS(3491),
    [anon_sym_BSLASHglspl] = ACTIONS(3491),
    [anon_sym_BSLASHGlspl] = ACTIONS(3491),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3491),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3491),
    [anon_sym_BSLASHglslink] = ACTIONS(3491),
    [anon_sym_BSLASHglstext] = ACTIONS(3491),
    [anon_sym_BSLASHGlstext] = ACTIONS(3491),
    [anon_sym_BSLASHGLStext] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3491),
    [anon_sym_BSLASHglsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsname] = ACTIONS(3491),
    [anon_sym_BSLASHGlsname] = ACTIONS(3491),
    [anon_sym_BSLASHGLSname] = ACTIONS(3491),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3491),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3493),
    [anon_sym_BSLASHacrshort] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3495),
    [anon_sym_BSLASHACRshort] = ACTIONS(3495),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrlong] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3495),
    [anon_sym_BSLASHACRlong] = ACTIONS(3495),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrfull] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3495),
    [anon_sym_BSLASHACRfull] = ACTIONS(3495),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHacs] = ACTIONS(3495),
    [anon_sym_BSLASHAcs] = ACTIONS(3495),
    [anon_sym_BSLASHacsp] = ACTIONS(3495),
    [anon_sym_BSLASHAcsp] = ACTIONS(3495),
    [anon_sym_BSLASHacl] = ACTIONS(3495),
    [anon_sym_BSLASHAcl] = ACTIONS(3495),
    [anon_sym_BSLASHaclp] = ACTIONS(3495),
    [anon_sym_BSLASHAclp] = ACTIONS(3495),
    [anon_sym_BSLASHacf] = ACTIONS(3495),
    [anon_sym_BSLASHAcf] = ACTIONS(3495),
    [anon_sym_BSLASHacfp] = ACTIONS(3495),
    [anon_sym_BSLASHAcfp] = ACTIONS(3495),
    [anon_sym_BSLASHac] = ACTIONS(3495),
    [anon_sym_BSLASHAc] = ACTIONS(3495),
    [anon_sym_BSLASHacp] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3497),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3497),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3501),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3503),
    [anon_sym_BSLASHcolor] = ACTIONS(3505),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3505),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3505),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3505),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3507),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3507),
    [anon_sym_BSLASHtext] = ACTIONS(3509),
    [anon_sym_BSLASHintertext] = ACTIONS(3509),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3509),
    [anon_sym_BSLASHurl] = ACTIONS(3511),
    [anon_sym_BSLASHhref] = ACTIONS(3511),
  },
  [249] = {
    [sym_block_comment] = STATE(249),
    [sym__text_with_env_content] = STATE(249),
    [sym__text_content] = STATE(249),
    [sym_curly_group] = STATE(249),
    [sym_brack_group] = STATE(249),
    [sym_text] = STATE(249),
    [sym_operator] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_superscript] = STATE(1763),
    [sym_displayed_equation] = STATE(249),
    [sym_inline_formula] = STATE(249),
    [sym_begin] = STATE(38),
    [sym_generic_environment] = STATE(249),
    [sym_comment_environment] = STATE(249),
    [sym__comment_environment_begin] = STATE(3238),
    [sym_verbatim_environment] = STATE(249),
    [sym__verbatim_environment_begin] = STATE(3239),
    [sym_listing_environment] = STATE(249),
    [sym__listing_environment_begin] = STATE(3240),
    [sym_minted_environment] = STATE(249),
    [sym__minted_environment_begin] = STATE(3241),
    [sym_pycode_environment] = STATE(249),
    [sym__pycode_environment_begin] = STATE(3242),
    [sym_sagesilent_environment] = STATE(249),
    [sym__sagesilent_environment_begin] = STATE(3243),
    [sym_sageblock_environment] = STATE(249),
    [sym__sageblock_environment_begin] = STATE(3244),
    [sym_math_environment] = STATE(249),
    [sym__math_environment_begin] = STATE(236),
    [sym__command] = STATE(249),
    [sym_generic_command] = STATE(249),
    [sym_title_declaration] = STATE(249),
    [sym_author_declaration] = STATE(249),
    [sym_package_include] = STATE(249),
    [sym_class_include] = STATE(249),
    [sym_latex_include] = STATE(249),
    [sym_biblatex_include] = STATE(249),
    [sym_bibstyle_include] = STATE(249),
    [sym_bibtex_include] = STATE(249),
    [sym_graphics_include] = STATE(249),
    [sym_svg_include] = STATE(249),
    [sym_inkscape_include] = STATE(249),
    [sym_verbatim_include] = STATE(249),
    [sym_import_include] = STATE(249),
    [sym_caption] = STATE(249),
    [sym_citation] = STATE(249),
    [sym_label_definition] = STATE(249),
    [sym_label_reference] = STATE(249),
    [sym_label_reference_range] = STATE(249),
    [sym_label_number] = STATE(249),
    [sym_new_command_definition] = STATE(249),
    [sym_old_command_definition] = STATE(249),
    [sym_let_command_definition] = STATE(249),
    [sym_math_delimiter] = STATE(249),
    [sym_paired_delimiter_definition] = STATE(249),
    [sym_environment_definition] = STATE(249),
    [sym_glossary_entry_definition] = STATE(249),
    [sym_glossary_entry_reference] = STATE(249),
    [sym_acronym_definition] = STATE(249),
    [sym_acronym_reference] = STATE(249),
    [sym_theorem_definition] = STATE(249),
    [sym_color_definition] = STATE(249),
    [sym_color_set_definition] = STATE(249),
    [sym_color_reference] = STATE(249),
    [sym_tikz_library_import] = STATE(249),
    [sym_text_mode] = STATE(249),
    [sym_hyperlink] = STATE(249),
    [aux_sym_brack_group_repeat1] = STATE(249),
    [aux_sym_text_repeat1] = STATE(322),
    [sym_command_name] = ACTIONS(3513),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3519),
    [anon_sym_RBRACK] = ACTIONS(3522),
    [anon_sym_COMMA] = ACTIONS(3524),
    [anon_sym_EQ] = ACTIONS(3524),
    [anon_sym_LPAREN] = ACTIONS(3524),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [sym_word] = ACTIONS(3530),
    [sym_placeholder] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3536),
    [anon_sym_DASH] = ACTIONS(3536),
    [anon_sym_STAR] = ACTIONS(3536),
    [anon_sym_SLASH] = ACTIONS(3536),
    [anon_sym_LT] = ACTIONS(3539),
    [anon_sym_GT] = ACTIONS(3539),
    [anon_sym_BANG] = ACTIONS(3539),
    [anon_sym_PIPE] = ACTIONS(3539),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_SQUOTE] = ACTIONS(3539),
    [anon_sym__] = ACTIONS(3542),
    [anon_sym_CARET] = ACTIONS(3545),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3548),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3548),
    [anon_sym_DOLLAR] = ACTIONS(3551),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3554),
    [anon_sym_BSLASHbegin] = ACTIONS(3557),
    [anon_sym_BSLASHtitle] = ACTIONS(3560),
    [anon_sym_BSLASHauthor] = ACTIONS(3563),
    [anon_sym_BSLASHusepackage] = ACTIONS(3566),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3566),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3569),
    [anon_sym_BSLASHinclude] = ACTIONS(3572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3572),
    [anon_sym_BSLASHinput] = ACTIONS(3572),
    [anon_sym_BSLASHsubfile] = ACTIONS(3572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3575),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3578),
    [anon_sym_BSLASHbibliography] = ACTIONS(3581),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3584),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3587),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3590),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3593),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3593),
    [anon_sym_BSLASHimport] = ACTIONS(3596),
    [anon_sym_BSLASHsubimport] = ACTIONS(3596),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3596),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3596),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3596),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3596),
    [anon_sym_BSLASHcaption] = ACTIONS(3599),
    [anon_sym_BSLASHcite] = ACTIONS(3602),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHCite] = ACTIONS(3602),
    [anon_sym_BSLASHnocite] = ACTIONS(3602),
    [anon_sym_BSLASHcitet] = ACTIONS(3602),
    [anon_sym_BSLASHcitep] = ACTIONS(3602),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHciteA] = ACTIONS(3602),
    [anon_sym_BSLASHciteR] = ACTIONS(3602),
    [anon_sym_BSLASHciteS] = ACTIONS(3602),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3602),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3602),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3602),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3602),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHciteyear] = ACTIONS(3602),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHcitedate] = ACTIONS(3602),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHciteurl] = ACTIONS(3602),
    [anon_sym_BSLASHfullcite] = ACTIONS(3602),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3602),
    [anon_sym_BSLASHcitealt] = ACTIONS(3602),
    [anon_sym_BSLASHcitealp] = ACTIONS(3602),
    [anon_sym_BSLASHcitetext] = ACTIONS(3602),
    [anon_sym_BSLASHparencite] = ACTIONS(3602),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHParencite] = ACTIONS(3602),
    [anon_sym_BSLASHfootcite] = ACTIONS(3602),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3602),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3602),
    [anon_sym_BSLASHtextcite] = ACTIONS(3602),
    [anon_sym_BSLASHTextcite] = ACTIONS(3602),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3602),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3602),
    [anon_sym_BSLASHsupercite] = ACTIONS(3602),
    [anon_sym_BSLASHautocite] = ACTIONS(3602),
    [anon_sym_BSLASHAutocite] = ACTIONS(3602),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3605),
    [anon_sym_BSLASHvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHVolcite] = ACTIONS(3602),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHavolcite] = ACTIONS(3602),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3602),
    [anon_sym_BSLASHnotecite] = ACTIONS(3602),
    [anon_sym_BSLASHNotecite] = ACTIONS(3602),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3602),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3602),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3602),
    [anon_sym_BSLASHlabel] = ACTIONS(3608),
    [anon_sym_BSLASHref] = ACTIONS(3611),
    [anon_sym_BSLASHeqref] = ACTIONS(3611),
    [anon_sym_BSLASHvref] = ACTIONS(3611),
    [anon_sym_BSLASHVref] = ACTIONS(3611),
    [anon_sym_BSLASHautoref] = ACTIONS(3611),
    [anon_sym_BSLASHpageref] = ACTIONS(3611),
    [anon_sym_BSLASHcref] = ACTIONS(3611),
    [anon_sym_BSLASHCref] = ACTIONS(3611),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3614),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3614),
    [anon_sym_BSLASHnamecref] = ACTIONS(3611),
    [anon_sym_BSLASHnameCref] = ACTIONS(3611),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3611),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3611),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3611),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3611),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3611),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3611),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3617),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3620),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3617),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3620),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3623),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3626),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3629),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3626),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3629),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3626),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3629),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3626),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3629),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3626),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3626),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3626),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3626),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3626),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3626),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3626),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3626),
    [anon_sym_BSLASHdef] = ACTIONS(3632),
    [anon_sym_BSLASHlet] = ACTIONS(3635),
    [anon_sym_BSLASHleft] = ACTIONS(3638),
    [anon_sym_BSLASHbigl] = ACTIONS(3638),
    [anon_sym_BSLASHBigl] = ACTIONS(3638),
    [anon_sym_BSLASHbiggl] = ACTIONS(3638),
    [anon_sym_BSLASHBiggl] = ACTIONS(3638),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3641),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3641),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3644),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3644),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3644),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3644),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3644),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3644),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3647),
    [anon_sym_BSLASHgls] = ACTIONS(3650),
    [anon_sym_BSLASHGls] = ACTIONS(3650),
    [anon_sym_BSLASHGLS] = ACTIONS(3650),
    [anon_sym_BSLASHglspl] = ACTIONS(3650),
    [anon_sym_BSLASHGlspl] = ACTIONS(3650),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3650),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3650),
    [anon_sym_BSLASHglslink] = ACTIONS(3650),
    [anon_sym_BSLASHglstext] = ACTIONS(3650),
    [anon_sym_BSLASHGlstext] = ACTIONS(3650),
    [anon_sym_BSLASHGLStext] = ACTIONS(3650),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3650),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3650),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3650),
    [anon_sym_BSLASHglsplural] = ACTIONS(3650),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3650),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3650),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3650),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3650),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3650),
    [anon_sym_BSLASHglsname] = ACTIONS(3650),
    [anon_sym_BSLASHGlsname] = ACTIONS(3650),
    [anon_sym_BSLASHGLSname] = ACTIONS(3650),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3650),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3650),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3650),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3650),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3650),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3650),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3650),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3650),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3650),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3650),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3650),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3650),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3650),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3650),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3650),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3650),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3650),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3650),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3650),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3650),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3650),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3650),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3650),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3653),
    [anon_sym_BSLASHacrshort] = ACTIONS(3656),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3656),
    [anon_sym_BSLASHACRshort] = ACTIONS(3656),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3656),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3656),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3656),
    [anon_sym_BSLASHacrlong] = ACTIONS(3656),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3656),
    [anon_sym_BSLASHACRlong] = ACTIONS(3656),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3656),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3656),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3656),
    [anon_sym_BSLASHacrfull] = ACTIONS(3656),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3656),
    [anon_sym_BSLASHACRfull] = ACTIONS(3656),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3656),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3656),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3656),
    [anon_sym_BSLASHacs] = ACTIONS(3656),
    [anon_sym_BSLASHAcs] = ACTIONS(3656),
    [anon_sym_BSLASHacsp] = ACTIONS(3656),
    [anon_sym_BSLASHAcsp] = ACTIONS(3656),
    [anon_sym_BSLASHacl] = ACTIONS(3656),
    [anon_sym_BSLASHAcl] = ACTIONS(3656),
    [anon_sym_BSLASHaclp] = ACTIONS(3656),
    [anon_sym_BSLASHAclp] = ACTIONS(3656),
    [anon_sym_BSLASHacf] = ACTIONS(3656),
    [anon_sym_BSLASHAcf] = ACTIONS(3656),
    [anon_sym_BSLASHacfp] = ACTIONS(3656),
    [anon_sym_BSLASHAcfp] = ACTIONS(3656),
    [anon_sym_BSLASHac] = ACTIONS(3656),
    [anon_sym_BSLASHAc] = ACTIONS(3656),
    [anon_sym_BSLASHacp] = ACTIONS(3656),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3656),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3656),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3656),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3656),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3656),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3656),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3656),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3656),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3656),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3656),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3659),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3662),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3659),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3662),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3665),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3668),
    [anon_sym_BSLASHcolor] = ACTIONS(3671),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3671),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3671),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3671),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3674),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3674),
    [anon_sym_BSLASHtext] = ACTIONS(3677),
    [anon_sym_BSLASHintertext] = ACTIONS(3677),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3677),
    [anon_sym_BSLASHurl] = ACTIONS(3680),
    [anon_sym_BSLASHhref] = ACTIONS(3680),
  },
  [250] = {
    [sym_block_comment] = STATE(252),
    [sym__text_with_env_content] = STATE(252),
    [sym__text_content] = STATE(252),
    [sym_curly_group] = STATE(252),
    [sym_brack_group] = STATE(252),
    [sym_text] = STATE(252),
    [sym_operator] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_superscript] = STATE(1763),
    [sym_displayed_equation] = STATE(252),
    [sym_inline_formula] = STATE(252),
    [sym_begin] = STATE(38),
    [sym_generic_environment] = STATE(252),
    [sym_comment_environment] = STATE(252),
    [sym__comment_environment_begin] = STATE(3238),
    [sym_verbatim_environment] = STATE(252),
    [sym__verbatim_environment_begin] = STATE(3239),
    [sym_listing_environment] = STATE(252),
    [sym__listing_environment_begin] = STATE(3240),
    [sym_minted_environment] = STATE(252),
    [sym__minted_environment_begin] = STATE(3241),
    [sym_pycode_environment] = STATE(252),
    [sym__pycode_environment_begin] = STATE(3242),
    [sym_sagesilent_environment] = STATE(252),
    [sym__sagesilent_environment_begin] = STATE(3243),
    [sym_sageblock_environment] = STATE(252),
    [sym__sageblock_environment_begin] = STATE(3244),
    [sym_math_environment] = STATE(252),
    [sym__math_environment_begin] = STATE(236),
    [sym__command] = STATE(252),
    [sym_generic_command] = STATE(252),
    [sym_title_declaration] = STATE(252),
    [sym_author_declaration] = STATE(252),
    [sym_package_include] = STATE(252),
    [sym_class_include] = STATE(252),
    [sym_latex_include] = STATE(252),
    [sym_biblatex_include] = STATE(252),
    [sym_bibstyle_include] = STATE(252),
    [sym_bibtex_include] = STATE(252),
    [sym_graphics_include] = STATE(252),
    [sym_svg_include] = STATE(252),
    [sym_inkscape_include] = STATE(252),
    [sym_verbatim_include] = STATE(252),
    [sym_import_include] = STATE(252),
    [sym_caption] = STATE(252),
    [sym_citation] = STATE(252),
    [sym_label_definition] = STATE(252),
    [sym_label_reference] = STATE(252),
    [sym_label_reference_range] = STATE(252),
    [sym_label_number] = STATE(252),
    [sym_new_command_definition] = STATE(252),
    [sym_old_command_definition] = STATE(252),
    [sym_let_command_definition] = STATE(252),
    [sym_math_delimiter] = STATE(252),
    [sym_paired_delimiter_definition] = STATE(252),
    [sym_environment_definition] = STATE(252),
    [sym_glossary_entry_definition] = STATE(252),
    [sym_glossary_entry_reference] = STATE(252),
    [sym_acronym_definition] = STATE(252),
    [sym_acronym_reference] = STATE(252),
    [sym_theorem_definition] = STATE(252),
    [sym_color_definition] = STATE(252),
    [sym_color_set_definition] = STATE(252),
    [sym_color_reference] = STATE(252),
    [sym_tikz_library_import] = STATE(252),
    [sym_text_mode] = STATE(252),
    [sym_hyperlink] = STATE(252),
    [aux_sym_brack_group_repeat1] = STATE(252),
    [aux_sym_text_repeat1] = STATE(322),
    [sym_command_name] = ACTIONS(3401),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(3683),
    [anon_sym_COMMA] = ACTIONS(3685),
    [anon_sym_EQ] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(3685),
    [anon_sym_RPAREN] = ACTIONS(3685),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(3413),
    [sym_placeholder] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym__] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3425),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3429),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(3431),
    [anon_sym_BSLASHauthor] = ACTIONS(3433),
    [anon_sym_BSLASHusepackage] = ACTIONS(3435),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3435),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3437),
    [anon_sym_BSLASHinclude] = ACTIONS(3439),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3439),
    [anon_sym_BSLASHinput] = ACTIONS(3439),
    [anon_sym_BSLASHsubfile] = ACTIONS(3439),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3441),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3443),
    [anon_sym_BSLASHbibliography] = ACTIONS(3445),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3447),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3449),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3451),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3453),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3453),
    [anon_sym_BSLASHimport] = ACTIONS(3455),
    [anon_sym_BSLASHsubimport] = ACTIONS(3455),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3455),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHcaption] = ACTIONS(3457),
    [anon_sym_BSLASHcite] = ACTIONS(3459),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCite] = ACTIONS(3459),
    [anon_sym_BSLASHnocite] = ACTIONS(3459),
    [anon_sym_BSLASHcitet] = ACTIONS(3459),
    [anon_sym_BSLASHcitep] = ACTIONS(3459),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteA] = ACTIONS(3459),
    [anon_sym_BSLASHciteR] = ACTIONS(3459),
    [anon_sym_BSLASHciteS] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3459),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteyear] = ACTIONS(3459),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitedate] = ACTIONS(3459),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteurl] = ACTIONS(3459),
    [anon_sym_BSLASHfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3459),
    [anon_sym_BSLASHcitealt] = ACTIONS(3459),
    [anon_sym_BSLASHcitealp] = ACTIONS(3459),
    [anon_sym_BSLASHcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHparencite] = ACTIONS(3459),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHParencite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHtextcite] = ACTIONS(3459),
    [anon_sym_BSLASHTextcite] = ACTIONS(3459),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHsupercite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite] = ACTIONS(3459),
    [anon_sym_BSLASHAutocite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHVolcite] = ACTIONS(3459),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHavolcite] = ACTIONS(3459),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHNotecite] = ACTIONS(3459),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHlabel] = ACTIONS(3463),
    [anon_sym_BSLASHref] = ACTIONS(3465),
    [anon_sym_BSLASHeqref] = ACTIONS(3465),
    [anon_sym_BSLASHvref] = ACTIONS(3465),
    [anon_sym_BSLASHVref] = ACTIONS(3465),
    [anon_sym_BSLASHautoref] = ACTIONS(3465),
    [anon_sym_BSLASHpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcref] = ACTIONS(3465),
    [anon_sym_BSLASHCref] = ACTIONS(3465),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnameCref] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3473),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHdef] = ACTIONS(3479),
    [anon_sym_BSLASHlet] = ACTIONS(3481),
    [anon_sym_BSLASHleft] = ACTIONS(3483),
    [anon_sym_BSLASHbigl] = ACTIONS(3483),
    [anon_sym_BSLASHBigl] = ACTIONS(3483),
    [anon_sym_BSLASHbiggl] = ACTIONS(3483),
    [anon_sym_BSLASHBiggl] = ACTIONS(3483),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3485),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3485),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3489),
    [anon_sym_BSLASHgls] = ACTIONS(3491),
    [anon_sym_BSLASHGls] = ACTIONS(3491),
    [anon_sym_BSLASHGLS] = ACTIONS(3491),
    [anon_sym_BSLASHglspl] = ACTIONS(3491),
    [anon_sym_BSLASHGlspl] = ACTIONS(3491),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3491),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3491),
    [anon_sym_BSLASHglslink] = ACTIONS(3491),
    [anon_sym_BSLASHglstext] = ACTIONS(3491),
    [anon_sym_BSLASHGlstext] = ACTIONS(3491),
    [anon_sym_BSLASHGLStext] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3491),
    [anon_sym_BSLASHglsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsname] = ACTIONS(3491),
    [anon_sym_BSLASHGlsname] = ACTIONS(3491),
    [anon_sym_BSLASHGLSname] = ACTIONS(3491),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3491),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3493),
    [anon_sym_BSLASHacrshort] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3495),
    [anon_sym_BSLASHACRshort] = ACTIONS(3495),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrlong] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3495),
    [anon_sym_BSLASHACRlong] = ACTIONS(3495),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrfull] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3495),
    [anon_sym_BSLASHACRfull] = ACTIONS(3495),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHacs] = ACTIONS(3495),
    [anon_sym_BSLASHAcs] = ACTIONS(3495),
    [anon_sym_BSLASHacsp] = ACTIONS(3495),
    [anon_sym_BSLASHAcsp] = ACTIONS(3495),
    [anon_sym_BSLASHacl] = ACTIONS(3495),
    [anon_sym_BSLASHAcl] = ACTIONS(3495),
    [anon_sym_BSLASHaclp] = ACTIONS(3495),
    [anon_sym_BSLASHAclp] = ACTIONS(3495),
    [anon_sym_BSLASHacf] = ACTIONS(3495),
    [anon_sym_BSLASHAcf] = ACTIONS(3495),
    [anon_sym_BSLASHacfp] = ACTIONS(3495),
    [anon_sym_BSLASHAcfp] = ACTIONS(3495),
    [anon_sym_BSLASHac] = ACTIONS(3495),
    [anon_sym_BSLASHAc] = ACTIONS(3495),
    [anon_sym_BSLASHacp] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3497),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3497),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3501),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3503),
    [anon_sym_BSLASHcolor] = ACTIONS(3505),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3505),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3505),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3505),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3507),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3507),
    [anon_sym_BSLASHtext] = ACTIONS(3509),
    [anon_sym_BSLASHintertext] = ACTIONS(3509),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3509),
    [anon_sym_BSLASHurl] = ACTIONS(3511),
    [anon_sym_BSLASHhref] = ACTIONS(3511),
  },
  [251] = {
    [sym_block_comment] = STATE(249),
    [sym__text_with_env_content] = STATE(249),
    [sym__text_content] = STATE(249),
    [sym_curly_group] = STATE(249),
    [sym_brack_group] = STATE(249),
    [sym_text] = STATE(249),
    [sym_operator] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_superscript] = STATE(1763),
    [sym_displayed_equation] = STATE(249),
    [sym_inline_formula] = STATE(249),
    [sym_begin] = STATE(38),
    [sym_generic_environment] = STATE(249),
    [sym_comment_environment] = STATE(249),
    [sym__comment_environment_begin] = STATE(3238),
    [sym_verbatim_environment] = STATE(249),
    [sym__verbatim_environment_begin] = STATE(3239),
    [sym_listing_environment] = STATE(249),
    [sym__listing_environment_begin] = STATE(3240),
    [sym_minted_environment] = STATE(249),
    [sym__minted_environment_begin] = STATE(3241),
    [sym_pycode_environment] = STATE(249),
    [sym__pycode_environment_begin] = STATE(3242),
    [sym_sagesilent_environment] = STATE(249),
    [sym__sagesilent_environment_begin] = STATE(3243),
    [sym_sageblock_environment] = STATE(249),
    [sym__sageblock_environment_begin] = STATE(3244),
    [sym_math_environment] = STATE(249),
    [sym__math_environment_begin] = STATE(236),
    [sym__command] = STATE(249),
    [sym_generic_command] = STATE(249),
    [sym_title_declaration] = STATE(249),
    [sym_author_declaration] = STATE(249),
    [sym_package_include] = STATE(249),
    [sym_class_include] = STATE(249),
    [sym_latex_include] = STATE(249),
    [sym_biblatex_include] = STATE(249),
    [sym_bibstyle_include] = STATE(249),
    [sym_bibtex_include] = STATE(249),
    [sym_graphics_include] = STATE(249),
    [sym_svg_include] = STATE(249),
    [sym_inkscape_include] = STATE(249),
    [sym_verbatim_include] = STATE(249),
    [sym_import_include] = STATE(249),
    [sym_caption] = STATE(249),
    [sym_citation] = STATE(249),
    [sym_label_definition] = STATE(249),
    [sym_label_reference] = STATE(249),
    [sym_label_reference_range] = STATE(249),
    [sym_label_number] = STATE(249),
    [sym_new_command_definition] = STATE(249),
    [sym_old_command_definition] = STATE(249),
    [sym_let_command_definition] = STATE(249),
    [sym_math_delimiter] = STATE(249),
    [sym_paired_delimiter_definition] = STATE(249),
    [sym_environment_definition] = STATE(249),
    [sym_glossary_entry_definition] = STATE(249),
    [sym_glossary_entry_reference] = STATE(249),
    [sym_acronym_definition] = STATE(249),
    [sym_acronym_reference] = STATE(249),
    [sym_theorem_definition] = STATE(249),
    [sym_color_definition] = STATE(249),
    [sym_color_set_definition] = STATE(249),
    [sym_color_reference] = STATE(249),
    [sym_tikz_library_import] = STATE(249),
    [sym_text_mode] = STATE(249),
    [sym_hyperlink] = STATE(249),
    [aux_sym_brack_group_repeat1] = STATE(249),
    [aux_sym_text_repeat1] = STATE(322),
    [sym_command_name] = ACTIONS(3401),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(3687),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_RPAREN] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(3413),
    [sym_placeholder] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym__] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3425),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3429),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(3431),
    [anon_sym_BSLASHauthor] = ACTIONS(3433),
    [anon_sym_BSLASHusepackage] = ACTIONS(3435),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3435),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3437),
    [anon_sym_BSLASHinclude] = ACTIONS(3439),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3439),
    [anon_sym_BSLASHinput] = ACTIONS(3439),
    [anon_sym_BSLASHsubfile] = ACTIONS(3439),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3441),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3443),
    [anon_sym_BSLASHbibliography] = ACTIONS(3445),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3447),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3449),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3451),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3453),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3453),
    [anon_sym_BSLASHimport] = ACTIONS(3455),
    [anon_sym_BSLASHsubimport] = ACTIONS(3455),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3455),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHcaption] = ACTIONS(3457),
    [anon_sym_BSLASHcite] = ACTIONS(3459),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCite] = ACTIONS(3459),
    [anon_sym_BSLASHnocite] = ACTIONS(3459),
    [anon_sym_BSLASHcitet] = ACTIONS(3459),
    [anon_sym_BSLASHcitep] = ACTIONS(3459),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteA] = ACTIONS(3459),
    [anon_sym_BSLASHciteR] = ACTIONS(3459),
    [anon_sym_BSLASHciteS] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3459),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteyear] = ACTIONS(3459),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitedate] = ACTIONS(3459),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteurl] = ACTIONS(3459),
    [anon_sym_BSLASHfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3459),
    [anon_sym_BSLASHcitealt] = ACTIONS(3459),
    [anon_sym_BSLASHcitealp] = ACTIONS(3459),
    [anon_sym_BSLASHcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHparencite] = ACTIONS(3459),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHParencite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHtextcite] = ACTIONS(3459),
    [anon_sym_BSLASHTextcite] = ACTIONS(3459),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHsupercite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite] = ACTIONS(3459),
    [anon_sym_BSLASHAutocite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHVolcite] = ACTIONS(3459),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHavolcite] = ACTIONS(3459),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHNotecite] = ACTIONS(3459),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHlabel] = ACTIONS(3463),
    [anon_sym_BSLASHref] = ACTIONS(3465),
    [anon_sym_BSLASHeqref] = ACTIONS(3465),
    [anon_sym_BSLASHvref] = ACTIONS(3465),
    [anon_sym_BSLASHVref] = ACTIONS(3465),
    [anon_sym_BSLASHautoref] = ACTIONS(3465),
    [anon_sym_BSLASHpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcref] = ACTIONS(3465),
    [anon_sym_BSLASHCref] = ACTIONS(3465),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnameCref] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3473),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHdef] = ACTIONS(3479),
    [anon_sym_BSLASHlet] = ACTIONS(3481),
    [anon_sym_BSLASHleft] = ACTIONS(3483),
    [anon_sym_BSLASHbigl] = ACTIONS(3483),
    [anon_sym_BSLASHBigl] = ACTIONS(3483),
    [anon_sym_BSLASHbiggl] = ACTIONS(3483),
    [anon_sym_BSLASHBiggl] = ACTIONS(3483),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3485),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3485),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3489),
    [anon_sym_BSLASHgls] = ACTIONS(3491),
    [anon_sym_BSLASHGls] = ACTIONS(3491),
    [anon_sym_BSLASHGLS] = ACTIONS(3491),
    [anon_sym_BSLASHglspl] = ACTIONS(3491),
    [anon_sym_BSLASHGlspl] = ACTIONS(3491),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3491),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3491),
    [anon_sym_BSLASHglslink] = ACTIONS(3491),
    [anon_sym_BSLASHglstext] = ACTIONS(3491),
    [anon_sym_BSLASHGlstext] = ACTIONS(3491),
    [anon_sym_BSLASHGLStext] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3491),
    [anon_sym_BSLASHglsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsname] = ACTIONS(3491),
    [anon_sym_BSLASHGlsname] = ACTIONS(3491),
    [anon_sym_BSLASHGLSname] = ACTIONS(3491),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3491),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3493),
    [anon_sym_BSLASHacrshort] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3495),
    [anon_sym_BSLASHACRshort] = ACTIONS(3495),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrlong] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3495),
    [anon_sym_BSLASHACRlong] = ACTIONS(3495),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrfull] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3495),
    [anon_sym_BSLASHACRfull] = ACTIONS(3495),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHacs] = ACTIONS(3495),
    [anon_sym_BSLASHAcs] = ACTIONS(3495),
    [anon_sym_BSLASHacsp] = ACTIONS(3495),
    [anon_sym_BSLASHAcsp] = ACTIONS(3495),
    [anon_sym_BSLASHacl] = ACTIONS(3495),
    [anon_sym_BSLASHAcl] = ACTIONS(3495),
    [anon_sym_BSLASHaclp] = ACTIONS(3495),
    [anon_sym_BSLASHAclp] = ACTIONS(3495),
    [anon_sym_BSLASHacf] = ACTIONS(3495),
    [anon_sym_BSLASHAcf] = ACTIONS(3495),
    [anon_sym_BSLASHacfp] = ACTIONS(3495),
    [anon_sym_BSLASHAcfp] = ACTIONS(3495),
    [anon_sym_BSLASHac] = ACTIONS(3495),
    [anon_sym_BSLASHAc] = ACTIONS(3495),
    [anon_sym_BSLASHacp] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3497),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3497),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3501),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3503),
    [anon_sym_BSLASHcolor] = ACTIONS(3505),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3505),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3505),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3505),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3507),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3507),
    [anon_sym_BSLASHtext] = ACTIONS(3509),
    [anon_sym_BSLASHintertext] = ACTIONS(3509),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3509),
    [anon_sym_BSLASHurl] = ACTIONS(3511),
    [anon_sym_BSLASHhref] = ACTIONS(3511),
  },
  [252] = {
    [sym_block_comment] = STATE(249),
    [sym__text_with_env_content] = STATE(249),
    [sym__text_content] = STATE(249),
    [sym_curly_group] = STATE(249),
    [sym_brack_group] = STATE(249),
    [sym_text] = STATE(249),
    [sym_operator] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_superscript] = STATE(1763),
    [sym_displayed_equation] = STATE(249),
    [sym_inline_formula] = STATE(249),
    [sym_begin] = STATE(38),
    [sym_generic_environment] = STATE(249),
    [sym_comment_environment] = STATE(249),
    [sym__comment_environment_begin] = STATE(3238),
    [sym_verbatim_environment] = STATE(249),
    [sym__verbatim_environment_begin] = STATE(3239),
    [sym_listing_environment] = STATE(249),
    [sym__listing_environment_begin] = STATE(3240),
    [sym_minted_environment] = STATE(249),
    [sym__minted_environment_begin] = STATE(3241),
    [sym_pycode_environment] = STATE(249),
    [sym__pycode_environment_begin] = STATE(3242),
    [sym_sagesilent_environment] = STATE(249),
    [sym__sagesilent_environment_begin] = STATE(3243),
    [sym_sageblock_environment] = STATE(249),
    [sym__sageblock_environment_begin] = STATE(3244),
    [sym_math_environment] = STATE(249),
    [sym__math_environment_begin] = STATE(236),
    [sym__command] = STATE(249),
    [sym_generic_command] = STATE(249),
    [sym_title_declaration] = STATE(249),
    [sym_author_declaration] = STATE(249),
    [sym_package_include] = STATE(249),
    [sym_class_include] = STATE(249),
    [sym_latex_include] = STATE(249),
    [sym_biblatex_include] = STATE(249),
    [sym_bibstyle_include] = STATE(249),
    [sym_bibtex_include] = STATE(249),
    [sym_graphics_include] = STATE(249),
    [sym_svg_include] = STATE(249),
    [sym_inkscape_include] = STATE(249),
    [sym_verbatim_include] = STATE(249),
    [sym_import_include] = STATE(249),
    [sym_caption] = STATE(249),
    [sym_citation] = STATE(249),
    [sym_label_definition] = STATE(249),
    [sym_label_reference] = STATE(249),
    [sym_label_reference_range] = STATE(249),
    [sym_label_number] = STATE(249),
    [sym_new_command_definition] = STATE(249),
    [sym_old_command_definition] = STATE(249),
    [sym_let_command_definition] = STATE(249),
    [sym_math_delimiter] = STATE(249),
    [sym_paired_delimiter_definition] = STATE(249),
    [sym_environment_definition] = STATE(249),
    [sym_glossary_entry_definition] = STATE(249),
    [sym_glossary_entry_reference] = STATE(249),
    [sym_acronym_definition] = STATE(249),
    [sym_acronym_reference] = STATE(249),
    [sym_theorem_definition] = STATE(249),
    [sym_color_definition] = STATE(249),
    [sym_color_set_definition] = STATE(249),
    [sym_color_reference] = STATE(249),
    [sym_tikz_library_import] = STATE(249),
    [sym_text_mode] = STATE(249),
    [sym_hyperlink] = STATE(249),
    [aux_sym_brack_group_repeat1] = STATE(249),
    [aux_sym_text_repeat1] = STATE(322),
    [sym_command_name] = ACTIONS(3401),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(3691),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_RPAREN] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(3413),
    [sym_placeholder] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym__] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3425),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3429),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(3431),
    [anon_sym_BSLASHauthor] = ACTIONS(3433),
    [anon_sym_BSLASHusepackage] = ACTIONS(3435),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3435),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3437),
    [anon_sym_BSLASHinclude] = ACTIONS(3439),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3439),
    [anon_sym_BSLASHinput] = ACTIONS(3439),
    [anon_sym_BSLASHsubfile] = ACTIONS(3439),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3441),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3443),
    [anon_sym_BSLASHbibliography] = ACTIONS(3445),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3447),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3449),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3451),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3453),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3453),
    [anon_sym_BSLASHimport] = ACTIONS(3455),
    [anon_sym_BSLASHsubimport] = ACTIONS(3455),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3455),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHcaption] = ACTIONS(3457),
    [anon_sym_BSLASHcite] = ACTIONS(3459),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCite] = ACTIONS(3459),
    [anon_sym_BSLASHnocite] = ACTIONS(3459),
    [anon_sym_BSLASHcitet] = ACTIONS(3459),
    [anon_sym_BSLASHcitep] = ACTIONS(3459),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteA] = ACTIONS(3459),
    [anon_sym_BSLASHciteR] = ACTIONS(3459),
    [anon_sym_BSLASHciteS] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3459),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteyear] = ACTIONS(3459),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitedate] = ACTIONS(3459),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteurl] = ACTIONS(3459),
    [anon_sym_BSLASHfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3459),
    [anon_sym_BSLASHcitealt] = ACTIONS(3459),
    [anon_sym_BSLASHcitealp] = ACTIONS(3459),
    [anon_sym_BSLASHcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHparencite] = ACTIONS(3459),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHParencite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHtextcite] = ACTIONS(3459),
    [anon_sym_BSLASHTextcite] = ACTIONS(3459),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHsupercite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite] = ACTIONS(3459),
    [anon_sym_BSLASHAutocite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHVolcite] = ACTIONS(3459),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHavolcite] = ACTIONS(3459),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHNotecite] = ACTIONS(3459),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHlabel] = ACTIONS(3463),
    [anon_sym_BSLASHref] = ACTIONS(3465),
    [anon_sym_BSLASHeqref] = ACTIONS(3465),
    [anon_sym_BSLASHvref] = ACTIONS(3465),
    [anon_sym_BSLASHVref] = ACTIONS(3465),
    [anon_sym_BSLASHautoref] = ACTIONS(3465),
    [anon_sym_BSLASHpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcref] = ACTIONS(3465),
    [anon_sym_BSLASHCref] = ACTIONS(3465),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnameCref] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3473),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHdef] = ACTIONS(3479),
    [anon_sym_BSLASHlet] = ACTIONS(3481),
    [anon_sym_BSLASHleft] = ACTIONS(3483),
    [anon_sym_BSLASHbigl] = ACTIONS(3483),
    [anon_sym_BSLASHBigl] = ACTIONS(3483),
    [anon_sym_BSLASHbiggl] = ACTIONS(3483),
    [anon_sym_BSLASHBiggl] = ACTIONS(3483),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3485),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3485),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3489),
    [anon_sym_BSLASHgls] = ACTIONS(3491),
    [anon_sym_BSLASHGls] = ACTIONS(3491),
    [anon_sym_BSLASHGLS] = ACTIONS(3491),
    [anon_sym_BSLASHglspl] = ACTIONS(3491),
    [anon_sym_BSLASHGlspl] = ACTIONS(3491),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3491),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3491),
    [anon_sym_BSLASHglslink] = ACTIONS(3491),
    [anon_sym_BSLASHglstext] = ACTIONS(3491),
    [anon_sym_BSLASHGlstext] = ACTIONS(3491),
    [anon_sym_BSLASHGLStext] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3491),
    [anon_sym_BSLASHglsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsname] = ACTIONS(3491),
    [anon_sym_BSLASHGlsname] = ACTIONS(3491),
    [anon_sym_BSLASHGLSname] = ACTIONS(3491),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3491),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3493),
    [anon_sym_BSLASHacrshort] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3495),
    [anon_sym_BSLASHACRshort] = ACTIONS(3495),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrlong] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3495),
    [anon_sym_BSLASHACRlong] = ACTIONS(3495),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrfull] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3495),
    [anon_sym_BSLASHACRfull] = ACTIONS(3495),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHacs] = ACTIONS(3495),
    [anon_sym_BSLASHAcs] = ACTIONS(3495),
    [anon_sym_BSLASHacsp] = ACTIONS(3495),
    [anon_sym_BSLASHAcsp] = ACTIONS(3495),
    [anon_sym_BSLASHacl] = ACTIONS(3495),
    [anon_sym_BSLASHAcl] = ACTIONS(3495),
    [anon_sym_BSLASHaclp] = ACTIONS(3495),
    [anon_sym_BSLASHAclp] = ACTIONS(3495),
    [anon_sym_BSLASHacf] = ACTIONS(3495),
    [anon_sym_BSLASHAcf] = ACTIONS(3495),
    [anon_sym_BSLASHacfp] = ACTIONS(3495),
    [anon_sym_BSLASHAcfp] = ACTIONS(3495),
    [anon_sym_BSLASHac] = ACTIONS(3495),
    [anon_sym_BSLASHAc] = ACTIONS(3495),
    [anon_sym_BSLASHacp] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3497),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3497),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3501),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3503),
    [anon_sym_BSLASHcolor] = ACTIONS(3505),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3505),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3505),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3505),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3507),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3507),
    [anon_sym_BSLASHtext] = ACTIONS(3509),
    [anon_sym_BSLASHintertext] = ACTIONS(3509),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3509),
    [anon_sym_BSLASHurl] = ACTIONS(3511),
    [anon_sym_BSLASHhref] = ACTIONS(3511),
  },
  [253] = {
    [sym_block_comment] = STATE(251),
    [sym__text_with_env_content] = STATE(251),
    [sym__text_content] = STATE(251),
    [sym_curly_group] = STATE(251),
    [sym_brack_group] = STATE(251),
    [sym_text] = STATE(251),
    [sym_operator] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_superscript] = STATE(1763),
    [sym_displayed_equation] = STATE(251),
    [sym_inline_formula] = STATE(251),
    [sym_begin] = STATE(38),
    [sym_generic_environment] = STATE(251),
    [sym_comment_environment] = STATE(251),
    [sym__comment_environment_begin] = STATE(3238),
    [sym_verbatim_environment] = STATE(251),
    [sym__verbatim_environment_begin] = STATE(3239),
    [sym_listing_environment] = STATE(251),
    [sym__listing_environment_begin] = STATE(3240),
    [sym_minted_environment] = STATE(251),
    [sym__minted_environment_begin] = STATE(3241),
    [sym_pycode_environment] = STATE(251),
    [sym__pycode_environment_begin] = STATE(3242),
    [sym_sagesilent_environment] = STATE(251),
    [sym__sagesilent_environment_begin] = STATE(3243),
    [sym_sageblock_environment] = STATE(251),
    [sym__sageblock_environment_begin] = STATE(3244),
    [sym_math_environment] = STATE(251),
    [sym__math_environment_begin] = STATE(236),
    [sym__command] = STATE(251),
    [sym_generic_command] = STATE(251),
    [sym_title_declaration] = STATE(251),
    [sym_author_declaration] = STATE(251),
    [sym_package_include] = STATE(251),
    [sym_class_include] = STATE(251),
    [sym_latex_include] = STATE(251),
    [sym_biblatex_include] = STATE(251),
    [sym_bibstyle_include] = STATE(251),
    [sym_bibtex_include] = STATE(251),
    [sym_graphics_include] = STATE(251),
    [sym_svg_include] = STATE(251),
    [sym_inkscape_include] = STATE(251),
    [sym_verbatim_include] = STATE(251),
    [sym_import_include] = STATE(251),
    [sym_caption] = STATE(251),
    [sym_citation] = STATE(251),
    [sym_label_definition] = STATE(251),
    [sym_label_reference] = STATE(251),
    [sym_label_reference_range] = STATE(251),
    [sym_label_number] = STATE(251),
    [sym_new_command_definition] = STATE(251),
    [sym_old_command_definition] = STATE(251),
    [sym_let_command_definition] = STATE(251),
    [sym_math_delimiter] = STATE(251),
    [sym_paired_delimiter_definition] = STATE(251),
    [sym_environment_definition] = STATE(251),
    [sym_glossary_entry_definition] = STATE(251),
    [sym_glossary_entry_reference] = STATE(251),
    [sym_acronym_definition] = STATE(251),
    [sym_acronym_reference] = STATE(251),
    [sym_theorem_definition] = STATE(251),
    [sym_color_definition] = STATE(251),
    [sym_color_set_definition] = STATE(251),
    [sym_color_reference] = STATE(251),
    [sym_tikz_library_import] = STATE(251),
    [sym_text_mode] = STATE(251),
    [sym_hyperlink] = STATE(251),
    [aux_sym_brack_group_repeat1] = STATE(251),
    [aux_sym_text_repeat1] = STATE(322),
    [sym_command_name] = ACTIONS(3401),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(3693),
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_EQ] = ACTIONS(3695),
    [anon_sym_LPAREN] = ACTIONS(3695),
    [anon_sym_RPAREN] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(3413),
    [sym_placeholder] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym__] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3425),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3429),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(3431),
    [anon_sym_BSLASHauthor] = ACTIONS(3433),
    [anon_sym_BSLASHusepackage] = ACTIONS(3435),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3435),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3437),
    [anon_sym_BSLASHinclude] = ACTIONS(3439),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3439),
    [anon_sym_BSLASHinput] = ACTIONS(3439),
    [anon_sym_BSLASHsubfile] = ACTIONS(3439),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3441),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3443),
    [anon_sym_BSLASHbibliography] = ACTIONS(3445),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3447),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3449),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3451),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3453),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3453),
    [anon_sym_BSLASHimport] = ACTIONS(3455),
    [anon_sym_BSLASHsubimport] = ACTIONS(3455),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3455),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHcaption] = ACTIONS(3457),
    [anon_sym_BSLASHcite] = ACTIONS(3459),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCite] = ACTIONS(3459),
    [anon_sym_BSLASHnocite] = ACTIONS(3459),
    [anon_sym_BSLASHcitet] = ACTIONS(3459),
    [anon_sym_BSLASHcitep] = ACTIONS(3459),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteA] = ACTIONS(3459),
    [anon_sym_BSLASHciteR] = ACTIONS(3459),
    [anon_sym_BSLASHciteS] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3459),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteyear] = ACTIONS(3459),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitedate] = ACTIONS(3459),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteurl] = ACTIONS(3459),
    [anon_sym_BSLASHfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3459),
    [anon_sym_BSLASHcitealt] = ACTIONS(3459),
    [anon_sym_BSLASHcitealp] = ACTIONS(3459),
    [anon_sym_BSLASHcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHparencite] = ACTIONS(3459),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHParencite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHtextcite] = ACTIONS(3459),
    [anon_sym_BSLASHTextcite] = ACTIONS(3459),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHsupercite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite] = ACTIONS(3459),
    [anon_sym_BSLASHAutocite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHVolcite] = ACTIONS(3459),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHavolcite] = ACTIONS(3459),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHNotecite] = ACTIONS(3459),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHlabel] = ACTIONS(3463),
    [anon_sym_BSLASHref] = ACTIONS(3465),
    [anon_sym_BSLASHeqref] = ACTIONS(3465),
    [anon_sym_BSLASHvref] = ACTIONS(3465),
    [anon_sym_BSLASHVref] = ACTIONS(3465),
    [anon_sym_BSLASHautoref] = ACTIONS(3465),
    [anon_sym_BSLASHpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcref] = ACTIONS(3465),
    [anon_sym_BSLASHCref] = ACTIONS(3465),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnameCref] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3473),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHdef] = ACTIONS(3479),
    [anon_sym_BSLASHlet] = ACTIONS(3481),
    [anon_sym_BSLASHleft] = ACTIONS(3483),
    [anon_sym_BSLASHbigl] = ACTIONS(3483),
    [anon_sym_BSLASHBigl] = ACTIONS(3483),
    [anon_sym_BSLASHbiggl] = ACTIONS(3483),
    [anon_sym_BSLASHBiggl] = ACTIONS(3483),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3485),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3485),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3489),
    [anon_sym_BSLASHgls] = ACTIONS(3491),
    [anon_sym_BSLASHGls] = ACTIONS(3491),
    [anon_sym_BSLASHGLS] = ACTIONS(3491),
    [anon_sym_BSLASHglspl] = ACTIONS(3491),
    [anon_sym_BSLASHGlspl] = ACTIONS(3491),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3491),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3491),
    [anon_sym_BSLASHglslink] = ACTIONS(3491),
    [anon_sym_BSLASHglstext] = ACTIONS(3491),
    [anon_sym_BSLASHGlstext] = ACTIONS(3491),
    [anon_sym_BSLASHGLStext] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3491),
    [anon_sym_BSLASHglsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsname] = ACTIONS(3491),
    [anon_sym_BSLASHGlsname] = ACTIONS(3491),
    [anon_sym_BSLASHGLSname] = ACTIONS(3491),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3491),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3493),
    [anon_sym_BSLASHacrshort] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3495),
    [anon_sym_BSLASHACRshort] = ACTIONS(3495),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrlong] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3495),
    [anon_sym_BSLASHACRlong] = ACTIONS(3495),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrfull] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3495),
    [anon_sym_BSLASHACRfull] = ACTIONS(3495),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHacs] = ACTIONS(3495),
    [anon_sym_BSLASHAcs] = ACTIONS(3495),
    [anon_sym_BSLASHacsp] = ACTIONS(3495),
    [anon_sym_BSLASHAcsp] = ACTIONS(3495),
    [anon_sym_BSLASHacl] = ACTIONS(3495),
    [anon_sym_BSLASHAcl] = ACTIONS(3495),
    [anon_sym_BSLASHaclp] = ACTIONS(3495),
    [anon_sym_BSLASHAclp] = ACTIONS(3495),
    [anon_sym_BSLASHacf] = ACTIONS(3495),
    [anon_sym_BSLASHAcf] = ACTIONS(3495),
    [anon_sym_BSLASHacfp] = ACTIONS(3495),
    [anon_sym_BSLASHAcfp] = ACTIONS(3495),
    [anon_sym_BSLASHac] = ACTIONS(3495),
    [anon_sym_BSLASHAc] = ACTIONS(3495),
    [anon_sym_BSLASHacp] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3497),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3497),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3501),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3503),
    [anon_sym_BSLASHcolor] = ACTIONS(3505),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3505),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3505),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3505),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3507),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3507),
    [anon_sym_BSLASHtext] = ACTIONS(3509),
    [anon_sym_BSLASHintertext] = ACTIONS(3509),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3509),
    [anon_sym_BSLASHurl] = ACTIONS(3511),
    [anon_sym_BSLASHhref] = ACTIONS(3511),
  },
  [254] = {
    [sym_block_comment] = STATE(249),
    [sym__text_with_env_content] = STATE(249),
    [sym__text_content] = STATE(249),
    [sym_curly_group] = STATE(249),
    [sym_brack_group] = STATE(249),
    [sym_text] = STATE(249),
    [sym_operator] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_superscript] = STATE(1763),
    [sym_displayed_equation] = STATE(249),
    [sym_inline_formula] = STATE(249),
    [sym_begin] = STATE(38),
    [sym_generic_environment] = STATE(249),
    [sym_comment_environment] = STATE(249),
    [sym__comment_environment_begin] = STATE(3238),
    [sym_verbatim_environment] = STATE(249),
    [sym__verbatim_environment_begin] = STATE(3239),
    [sym_listing_environment] = STATE(249),
    [sym__listing_environment_begin] = STATE(3240),
    [sym_minted_environment] = STATE(249),
    [sym__minted_environment_begin] = STATE(3241),
    [sym_pycode_environment] = STATE(249),
    [sym__pycode_environment_begin] = STATE(3242),
    [sym_sagesilent_environment] = STATE(249),
    [sym__sagesilent_environment_begin] = STATE(3243),
    [sym_sageblock_environment] = STATE(249),
    [sym__sageblock_environment_begin] = STATE(3244),
    [sym_math_environment] = STATE(249),
    [sym__math_environment_begin] = STATE(236),
    [sym__command] = STATE(249),
    [sym_generic_command] = STATE(249),
    [sym_title_declaration] = STATE(249),
    [sym_author_declaration] = STATE(249),
    [sym_package_include] = STATE(249),
    [sym_class_include] = STATE(249),
    [sym_latex_include] = STATE(249),
    [sym_biblatex_include] = STATE(249),
    [sym_bibstyle_include] = STATE(249),
    [sym_bibtex_include] = STATE(249),
    [sym_graphics_include] = STATE(249),
    [sym_svg_include] = STATE(249),
    [sym_inkscape_include] = STATE(249),
    [sym_verbatim_include] = STATE(249),
    [sym_import_include] = STATE(249),
    [sym_caption] = STATE(249),
    [sym_citation] = STATE(249),
    [sym_label_definition] = STATE(249),
    [sym_label_reference] = STATE(249),
    [sym_label_reference_range] = STATE(249),
    [sym_label_number] = STATE(249),
    [sym_new_command_definition] = STATE(249),
    [sym_old_command_definition] = STATE(249),
    [sym_let_command_definition] = STATE(249),
    [sym_math_delimiter] = STATE(249),
    [sym_paired_delimiter_definition] = STATE(249),
    [sym_environment_definition] = STATE(249),
    [sym_glossary_entry_definition] = STATE(249),
    [sym_glossary_entry_reference] = STATE(249),
    [sym_acronym_definition] = STATE(249),
    [sym_acronym_reference] = STATE(249),
    [sym_theorem_definition] = STATE(249),
    [sym_color_definition] = STATE(249),
    [sym_color_set_definition] = STATE(249),
    [sym_color_reference] = STATE(249),
    [sym_tikz_library_import] = STATE(249),
    [sym_text_mode] = STATE(249),
    [sym_hyperlink] = STATE(249),
    [aux_sym_brack_group_repeat1] = STATE(249),
    [aux_sym_text_repeat1] = STATE(322),
    [sym_command_name] = ACTIONS(3401),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(3697),
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_EQ] = ACTIONS(3689),
    [anon_sym_LPAREN] = ACTIONS(3689),
    [anon_sym_RPAREN] = ACTIONS(3689),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(3413),
    [sym_placeholder] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym__] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3425),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3429),
    [anon_sym_BSLASHbegin] = ACTIONS(65),
    [anon_sym_BSLASHtitle] = ACTIONS(3431),
    [anon_sym_BSLASHauthor] = ACTIONS(3433),
    [anon_sym_BSLASHusepackage] = ACTIONS(3435),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3435),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3437),
    [anon_sym_BSLASHinclude] = ACTIONS(3439),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3439),
    [anon_sym_BSLASHinput] = ACTIONS(3439),
    [anon_sym_BSLASHsubfile] = ACTIONS(3439),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3441),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3443),
    [anon_sym_BSLASHbibliography] = ACTIONS(3445),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3447),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3449),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3451),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3453),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3453),
    [anon_sym_BSLASHimport] = ACTIONS(3455),
    [anon_sym_BSLASHsubimport] = ACTIONS(3455),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3455),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHcaption] = ACTIONS(3457),
    [anon_sym_BSLASHcite] = ACTIONS(3459),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCite] = ACTIONS(3459),
    [anon_sym_BSLASHnocite] = ACTIONS(3459),
    [anon_sym_BSLASHcitet] = ACTIONS(3459),
    [anon_sym_BSLASHcitep] = ACTIONS(3459),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteA] = ACTIONS(3459),
    [anon_sym_BSLASHciteR] = ACTIONS(3459),
    [anon_sym_BSLASHciteS] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3459),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteyear] = ACTIONS(3459),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitedate] = ACTIONS(3459),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteurl] = ACTIONS(3459),
    [anon_sym_BSLASHfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3459),
    [anon_sym_BSLASHcitealt] = ACTIONS(3459),
    [anon_sym_BSLASHcitealp] = ACTIONS(3459),
    [anon_sym_BSLASHcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHparencite] = ACTIONS(3459),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHParencite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHtextcite] = ACTIONS(3459),
    [anon_sym_BSLASHTextcite] = ACTIONS(3459),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHsupercite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite] = ACTIONS(3459),
    [anon_sym_BSLASHAutocite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHVolcite] = ACTIONS(3459),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHavolcite] = ACTIONS(3459),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHNotecite] = ACTIONS(3459),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHlabel] = ACTIONS(3463),
    [anon_sym_BSLASHref] = ACTIONS(3465),
    [anon_sym_BSLASHeqref] = ACTIONS(3465),
    [anon_sym_BSLASHvref] = ACTIONS(3465),
    [anon_sym_BSLASHVref] = ACTIONS(3465),
    [anon_sym_BSLASHautoref] = ACTIONS(3465),
    [anon_sym_BSLASHpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcref] = ACTIONS(3465),
    [anon_sym_BSLASHCref] = ACTIONS(3465),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnameCref] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3473),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHdef] = ACTIONS(3479),
    [anon_sym_BSLASHlet] = ACTIONS(3481),
    [anon_sym_BSLASHleft] = ACTIONS(3483),
    [anon_sym_BSLASHbigl] = ACTIONS(3483),
    [anon_sym_BSLASHBigl] = ACTIONS(3483),
    [anon_sym_BSLASHbiggl] = ACTIONS(3483),
    [anon_sym_BSLASHBiggl] = ACTIONS(3483),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3485),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3485),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3489),
    [anon_sym_BSLASHgls] = ACTIONS(3491),
    [anon_sym_BSLASHGls] = ACTIONS(3491),
    [anon_sym_BSLASHGLS] = ACTIONS(3491),
    [anon_sym_BSLASHglspl] = ACTIONS(3491),
    [anon_sym_BSLASHGlspl] = ACTIONS(3491),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3491),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3491),
    [anon_sym_BSLASHglslink] = ACTIONS(3491),
    [anon_sym_BSLASHglstext] = ACTIONS(3491),
    [anon_sym_BSLASHGlstext] = ACTIONS(3491),
    [anon_sym_BSLASHGLStext] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3491),
    [anon_sym_BSLASHglsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsname] = ACTIONS(3491),
    [anon_sym_BSLASHGlsname] = ACTIONS(3491),
    [anon_sym_BSLASHGLSname] = ACTIONS(3491),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3491),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3493),
    [anon_sym_BSLASHacrshort] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3495),
    [anon_sym_BSLASHACRshort] = ACTIONS(3495),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrlong] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3495),
    [anon_sym_BSLASHACRlong] = ACTIONS(3495),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrfull] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3495),
    [anon_sym_BSLASHACRfull] = ACTIONS(3495),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHacs] = ACTIONS(3495),
    [anon_sym_BSLASHAcs] = ACTIONS(3495),
    [anon_sym_BSLASHacsp] = ACTIONS(3495),
    [anon_sym_BSLASHAcsp] = ACTIONS(3495),
    [anon_sym_BSLASHacl] = ACTIONS(3495),
    [anon_sym_BSLASHAcl] = ACTIONS(3495),
    [anon_sym_BSLASHaclp] = ACTIONS(3495),
    [anon_sym_BSLASHAclp] = ACTIONS(3495),
    [anon_sym_BSLASHacf] = ACTIONS(3495),
    [anon_sym_BSLASHAcf] = ACTIONS(3495),
    [anon_sym_BSLASHacfp] = ACTIONS(3495),
    [anon_sym_BSLASHAcfp] = ACTIONS(3495),
    [anon_sym_BSLASHac] = ACTIONS(3495),
    [anon_sym_BSLASHAc] = ACTIONS(3495),
    [anon_sym_BSLASHacp] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3497),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3497),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3501),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3503),
    [anon_sym_BSLASHcolor] = ACTIONS(3505),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3505),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3505),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3505),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3507),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3507),
    [anon_sym_BSLASHtext] = ACTIONS(3509),
    [anon_sym_BSLASHintertext] = ACTIONS(3509),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3509),
    [anon_sym_BSLASHurl] = ACTIONS(3511),
    [anon_sym_BSLASHhref] = ACTIONS(3511),
  },
  [255] = {
    [sym_block_comment] = STATE(601),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym__command] = STATE(601),
    [sym_generic_command] = STATE(601),
    [sym_title_declaration] = STATE(601),
    [sym_author_declaration] = STATE(601),
    [sym_package_include] = STATE(601),
    [sym_class_include] = STATE(601),
    [sym_latex_include] = STATE(601),
    [sym_biblatex_include] = STATE(601),
    [sym_bibstyle_include] = STATE(601),
    [sym_bibtex_include] = STATE(601),
    [sym_graphics_include] = STATE(601),
    [sym_svg_include] = STATE(601),
    [sym_inkscape_include] = STATE(601),
    [sym_verbatim_include] = STATE(601),
    [sym_import_include] = STATE(601),
    [sym_caption] = STATE(601),
    [sym_citation] = STATE(601),
    [sym_label_definition] = STATE(601),
    [sym_label_reference] = STATE(601),
    [sym_label_reference_range] = STATE(601),
    [sym_label_number] = STATE(601),
    [sym_new_command_definition] = STATE(601),
    [sym_old_command_definition] = STATE(601),
    [sym_let_command_definition] = STATE(601),
    [sym_paired_delimiter_definition] = STATE(601),
    [sym_environment_definition] = STATE(601),
    [sym_glossary_entry_definition] = STATE(601),
    [sym_glossary_entry_reference] = STATE(601),
    [sym_acronym_definition] = STATE(601),
    [sym_acronym_reference] = STATE(601),
    [sym_theorem_definition] = STATE(601),
    [sym_color_definition] = STATE(601),
    [sym_color_set_definition] = STATE(601),
    [sym_color_reference] = STATE(601),
    [sym_tikz_library_import] = STATE(601),
    [sym_hyperlink] = STATE(601),
    [aux_sym_text_repeat1] = STATE(255),
    [sym_command_name] = ACTIONS(3699),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3702),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHpart] = ACTIONS(3707),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddpart] = ACTIONS(3707),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHchapter] = ACTIONS(3707),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddchap] = ACTIONS(3707),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsection] = ACTIONS(3707),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddsec] = ACTIONS(3707),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHitem] = ACTIONS(3707),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [sym_word] = ACTIONS(3709),
    [sym_placeholder] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3715),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_STAR] = ACTIONS(3715),
    [anon_sym_SLASH] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(3718),
    [anon_sym_GT] = ACTIONS(3718),
    [anon_sym_BANG] = ACTIONS(3718),
    [anon_sym_PIPE] = ACTIONS(3718),
    [anon_sym_COLON] = ACTIONS(3718),
    [anon_sym_SQUOTE] = ACTIONS(3718),
    [anon_sym__] = ACTIONS(3721),
    [anon_sym_CARET] = ACTIONS(3724),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3705),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3705),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHbegin] = ACTIONS(3707),
    [anon_sym_BSLASHtitle] = ACTIONS(3727),
    [anon_sym_BSLASHauthor] = ACTIONS(3730),
    [anon_sym_BSLASHusepackage] = ACTIONS(3733),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3733),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3736),
    [anon_sym_BSLASHinclude] = ACTIONS(3739),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3739),
    [anon_sym_BSLASHinput] = ACTIONS(3739),
    [anon_sym_BSLASHsubfile] = ACTIONS(3739),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3742),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3745),
    [anon_sym_BSLASHbibliography] = ACTIONS(3748),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3751),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3754),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3757),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3760),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3760),
    [anon_sym_BSLASHimport] = ACTIONS(3763),
    [anon_sym_BSLASHsubimport] = ACTIONS(3763),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3763),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3763),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3763),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3763),
    [anon_sym_BSLASHcaption] = ACTIONS(3766),
    [anon_sym_BSLASHcite] = ACTIONS(3769),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHCite] = ACTIONS(3769),
    [anon_sym_BSLASHnocite] = ACTIONS(3769),
    [anon_sym_BSLASHcitet] = ACTIONS(3769),
    [anon_sym_BSLASHcitep] = ACTIONS(3769),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHciteA] = ACTIONS(3769),
    [anon_sym_BSLASHciteR] = ACTIONS(3769),
    [anon_sym_BSLASHciteS] = ACTIONS(3769),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3769),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3769),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3769),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3769),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHciteyear] = ACTIONS(3769),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHcitedate] = ACTIONS(3769),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHciteurl] = ACTIONS(3769),
    [anon_sym_BSLASHfullcite] = ACTIONS(3769),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3769),
    [anon_sym_BSLASHcitealt] = ACTIONS(3769),
    [anon_sym_BSLASHcitealp] = ACTIONS(3769),
    [anon_sym_BSLASHcitetext] = ACTIONS(3769),
    [anon_sym_BSLASHparencite] = ACTIONS(3769),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHParencite] = ACTIONS(3769),
    [anon_sym_BSLASHfootcite] = ACTIONS(3769),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3769),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3769),
    [anon_sym_BSLASHtextcite] = ACTIONS(3769),
    [anon_sym_BSLASHTextcite] = ACTIONS(3769),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3769),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3769),
    [anon_sym_BSLASHsupercite] = ACTIONS(3769),
    [anon_sym_BSLASHautocite] = ACTIONS(3769),
    [anon_sym_BSLASHAutocite] = ACTIONS(3769),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3772),
    [anon_sym_BSLASHvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHVolcite] = ACTIONS(3769),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHavolcite] = ACTIONS(3769),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3769),
    [anon_sym_BSLASHnotecite] = ACTIONS(3769),
    [anon_sym_BSLASHNotecite] = ACTIONS(3769),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3769),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3769),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3769),
    [anon_sym_BSLASHlabel] = ACTIONS(3775),
    [anon_sym_BSLASHref] = ACTIONS(3778),
    [anon_sym_BSLASHeqref] = ACTIONS(3778),
    [anon_sym_BSLASHvref] = ACTIONS(3778),
    [anon_sym_BSLASHVref] = ACTIONS(3778),
    [anon_sym_BSLASHautoref] = ACTIONS(3778),
    [anon_sym_BSLASHpageref] = ACTIONS(3778),
    [anon_sym_BSLASHcref] = ACTIONS(3778),
    [anon_sym_BSLASHCref] = ACTIONS(3778),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3781),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3781),
    [anon_sym_BSLASHnamecref] = ACTIONS(3778),
    [anon_sym_BSLASHnameCref] = ACTIONS(3778),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3778),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3778),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3778),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3778),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3778),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3778),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3784),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3787),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3784),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3787),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3790),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3793),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3796),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3793),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3796),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3793),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3796),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3793),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3796),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3793),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3793),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3793),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3793),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3793),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3793),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3793),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3793),
    [anon_sym_BSLASHdef] = ACTIONS(3799),
    [anon_sym_BSLASHlet] = ACTIONS(3802),
    [anon_sym_BSLASHleft] = ACTIONS(3707),
    [anon_sym_BSLASHbigl] = ACTIONS(3707),
    [anon_sym_BSLASHBigl] = ACTIONS(3707),
    [anon_sym_BSLASHbiggl] = ACTIONS(3707),
    [anon_sym_BSLASHBiggl] = ACTIONS(3707),
    [anon_sym_BSLASHright] = ACTIONS(3707),
    [anon_sym_BSLASHbigr] = ACTIONS(3707),
    [anon_sym_BSLASHBigr] = ACTIONS(3707),
    [anon_sym_BSLASHbiggr] = ACTIONS(3707),
    [anon_sym_BSLASHBiggr] = ACTIONS(3707),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3805),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3805),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3811),
    [anon_sym_BSLASHgls] = ACTIONS(3814),
    [anon_sym_BSLASHGls] = ACTIONS(3814),
    [anon_sym_BSLASHGLS] = ACTIONS(3814),
    [anon_sym_BSLASHglspl] = ACTIONS(3814),
    [anon_sym_BSLASHGlspl] = ACTIONS(3814),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3814),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3814),
    [anon_sym_BSLASHglslink] = ACTIONS(3814),
    [anon_sym_BSLASHglstext] = ACTIONS(3814),
    [anon_sym_BSLASHGlstext] = ACTIONS(3814),
    [anon_sym_BSLASHGLStext] = ACTIONS(3814),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3814),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3814),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3814),
    [anon_sym_BSLASHglsplural] = ACTIONS(3814),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3814),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3814),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3814),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3814),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3814),
    [anon_sym_BSLASHglsname] = ACTIONS(3814),
    [anon_sym_BSLASHGlsname] = ACTIONS(3814),
    [anon_sym_BSLASHGLSname] = ACTIONS(3814),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3814),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3814),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3814),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3814),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3814),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3814),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3814),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3814),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3814),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3814),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3814),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3814),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3814),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3814),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3814),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3814),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3814),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3814),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3814),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3814),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3814),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3814),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3814),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3817),
    [anon_sym_BSLASHacrshort] = ACTIONS(3820),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3820),
    [anon_sym_BSLASHACRshort] = ACTIONS(3820),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3820),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3820),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3820),
    [anon_sym_BSLASHacrlong] = ACTIONS(3820),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3820),
    [anon_sym_BSLASHACRlong] = ACTIONS(3820),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3820),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3820),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3820),
    [anon_sym_BSLASHacrfull] = ACTIONS(3820),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3820),
    [anon_sym_BSLASHACRfull] = ACTIONS(3820),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3820),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3820),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3820),
    [anon_sym_BSLASHacs] = ACTIONS(3820),
    [anon_sym_BSLASHAcs] = ACTIONS(3820),
    [anon_sym_BSLASHacsp] = ACTIONS(3820),
    [anon_sym_BSLASHAcsp] = ACTIONS(3820),
    [anon_sym_BSLASHacl] = ACTIONS(3820),
    [anon_sym_BSLASHAcl] = ACTIONS(3820),
    [anon_sym_BSLASHaclp] = ACTIONS(3820),
    [anon_sym_BSLASHAclp] = ACTIONS(3820),
    [anon_sym_BSLASHacf] = ACTIONS(3820),
    [anon_sym_BSLASHAcf] = ACTIONS(3820),
    [anon_sym_BSLASHacfp] = ACTIONS(3820),
    [anon_sym_BSLASHAcfp] = ACTIONS(3820),
    [anon_sym_BSLASHac] = ACTIONS(3820),
    [anon_sym_BSLASHAc] = ACTIONS(3820),
    [anon_sym_BSLASHacp] = ACTIONS(3820),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3820),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3820),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3820),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3820),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3820),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3820),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3820),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3820),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3820),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3820),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3823),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3826),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3823),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3826),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3829),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3832),
    [anon_sym_BSLASHcolor] = ACTIONS(3835),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3835),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3835),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3835),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3838),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3838),
    [anon_sym_BSLASHtext] = ACTIONS(3707),
    [anon_sym_BSLASHintertext] = ACTIONS(3707),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3707),
    [anon_sym_BSLASHurl] = ACTIONS(3841),
    [anon_sym_BSLASHhref] = ACTIONS(3841),
  },
  [256] = {
    [sym_block_comment] = STATE(601),
    [sym_operator] = STATE(601),
    [sym_subscript] = STATE(601),
    [sym_superscript] = STATE(601),
    [sym__command] = STATE(601),
    [sym_generic_command] = STATE(601),
    [sym_title_declaration] = STATE(601),
    [sym_author_declaration] = STATE(601),
    [sym_package_include] = STATE(601),
    [sym_class_include] = STATE(601),
    [sym_latex_include] = STATE(601),
    [sym_biblatex_include] = STATE(601),
    [sym_bibstyle_include] = STATE(601),
    [sym_bibtex_include] = STATE(601),
    [sym_graphics_include] = STATE(601),
    [sym_svg_include] = STATE(601),
    [sym_inkscape_include] = STATE(601),
    [sym_verbatim_include] = STATE(601),
    [sym_import_include] = STATE(601),
    [sym_caption] = STATE(601),
    [sym_citation] = STATE(601),
    [sym_label_definition] = STATE(601),
    [sym_label_reference] = STATE(601),
    [sym_label_reference_range] = STATE(601),
    [sym_label_number] = STATE(601),
    [sym_new_command_definition] = STATE(601),
    [sym_old_command_definition] = STATE(601),
    [sym_let_command_definition] = STATE(601),
    [sym_paired_delimiter_definition] = STATE(601),
    [sym_environment_definition] = STATE(601),
    [sym_glossary_entry_definition] = STATE(601),
    [sym_glossary_entry_reference] = STATE(601),
    [sym_acronym_definition] = STATE(601),
    [sym_acronym_reference] = STATE(601),
    [sym_theorem_definition] = STATE(601),
    [sym_color_definition] = STATE(601),
    [sym_color_set_definition] = STATE(601),
    [sym_color_reference] = STATE(601),
    [sym_tikz_library_import] = STATE(601),
    [sym_hyperlink] = STATE(601),
    [aux_sym_text_repeat1] = STATE(255),
    [sym_command_name] = ACTIONS(169),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(171),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_RBRACK] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [anon_sym_RPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHpart] = ACTIONS(3846),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddpart] = ACTIONS(3846),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHchapter] = ACTIONS(3846),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddchap] = ACTIONS(3846),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsection] = ACTIONS(3846),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddsec] = ACTIONS(3846),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHitem] = ACTIONS(3846),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [sym_word] = ACTIONS(209),
    [sym_placeholder] = ACTIONS(211),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COLON] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym__] = ACTIONS(217),
    [anon_sym_CARET] = ACTIONS(219),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3844),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3844),
    [anon_sym_DOLLAR] = ACTIONS(3846),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHbegin] = ACTIONS(3846),
    [anon_sym_BSLASHtitle] = ACTIONS(227),
    [anon_sym_BSLASHauthor] = ACTIONS(229),
    [anon_sym_BSLASHusepackage] = ACTIONS(231),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(231),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(233),
    [anon_sym_BSLASHinclude] = ACTIONS(235),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(235),
    [anon_sym_BSLASHinput] = ACTIONS(235),
    [anon_sym_BSLASHsubfile] = ACTIONS(235),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(237),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(239),
    [anon_sym_BSLASHbibliography] = ACTIONS(241),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(243),
    [anon_sym_BSLASHincludesvg] = ACTIONS(245),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(247),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(249),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(249),
    [anon_sym_BSLASHimport] = ACTIONS(251),
    [anon_sym_BSLASHsubimport] = ACTIONS(251),
    [anon_sym_BSLASHinputfrom] = ACTIONS(251),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(251),
    [anon_sym_BSLASHincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(251),
    [anon_sym_BSLASHcaption] = ACTIONS(253),
    [anon_sym_BSLASHcite] = ACTIONS(255),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCite] = ACTIONS(255),
    [anon_sym_BSLASHnocite] = ACTIONS(255),
    [anon_sym_BSLASHcitet] = ACTIONS(255),
    [anon_sym_BSLASHcitep] = ACTIONS(255),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteA] = ACTIONS(255),
    [anon_sym_BSLASHciteR] = ACTIONS(255),
    [anon_sym_BSLASHciteS] = ACTIONS(255),
    [anon_sym_BSLASHciteyearR] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor] = ACTIONS(255),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(255),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitetitle] = ACTIONS(255),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteyear] = ACTIONS(255),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(257),
    [anon_sym_BSLASHcitedate] = ACTIONS(255),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(257),
    [anon_sym_BSLASHciteurl] = ACTIONS(255),
    [anon_sym_BSLASHfullcite] = ACTIONS(255),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(255),
    [anon_sym_BSLASHcitealt] = ACTIONS(255),
    [anon_sym_BSLASHcitealp] = ACTIONS(255),
    [anon_sym_BSLASHcitetext] = ACTIONS(255),
    [anon_sym_BSLASHparencite] = ACTIONS(255),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHParencite] = ACTIONS(255),
    [anon_sym_BSLASHfootcite] = ACTIONS(255),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(255),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(255),
    [anon_sym_BSLASHtextcite] = ACTIONS(255),
    [anon_sym_BSLASHTextcite] = ACTIONS(255),
    [anon_sym_BSLASHsmartcite] = ACTIONS(255),
    [anon_sym_BSLASHSmartcite] = ACTIONS(255),
    [anon_sym_BSLASHsupercite] = ACTIONS(255),
    [anon_sym_BSLASHautocite] = ACTIONS(255),
    [anon_sym_BSLASHAutocite] = ACTIONS(255),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(257),
    [anon_sym_BSLASHvolcite] = ACTIONS(255),
    [anon_sym_BSLASHVolcite] = ACTIONS(255),
    [anon_sym_BSLASHpvolcite] = ACTIONS(255),
    [anon_sym_BSLASHPvolcite] = ACTIONS(255),
    [anon_sym_BSLASHfvolcite] = ACTIONS(255),
    [anon_sym_BSLASHftvolcite] = ACTIONS(255),
    [anon_sym_BSLASHsvolcite] = ACTIONS(255),
    [anon_sym_BSLASHSvolcite] = ACTIONS(255),
    [anon_sym_BSLASHtvolcite] = ACTIONS(255),
    [anon_sym_BSLASHTvolcite] = ACTIONS(255),
    [anon_sym_BSLASHavolcite] = ACTIONS(255),
    [anon_sym_BSLASHAvolcite] = ACTIONS(255),
    [anon_sym_BSLASHnotecite] = ACTIONS(255),
    [anon_sym_BSLASHNotecite] = ACTIONS(255),
    [anon_sym_BSLASHpnotecite] = ACTIONS(255),
    [anon_sym_BSLASHPnotecite] = ACTIONS(255),
    [anon_sym_BSLASHfnotecite] = ACTIONS(255),
    [anon_sym_BSLASHlabel] = ACTIONS(259),
    [anon_sym_BSLASHref] = ACTIONS(261),
    [anon_sym_BSLASHeqref] = ACTIONS(261),
    [anon_sym_BSLASHvref] = ACTIONS(261),
    [anon_sym_BSLASHVref] = ACTIONS(261),
    [anon_sym_BSLASHautoref] = ACTIONS(261),
    [anon_sym_BSLASHpageref] = ACTIONS(261),
    [anon_sym_BSLASHcref] = ACTIONS(261),
    [anon_sym_BSLASHCref] = ACTIONS(261),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(263),
    [anon_sym_BSLASHnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnameCref] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(261),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(261),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(261),
    [anon_sym_BSLASHlabelcref] = ACTIONS(261),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(261),
    [anon_sym_BSLASHcrefrange] = ACTIONS(265),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHCrefrange] = ACTIONS(265),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(267),
    [anon_sym_BSLASHnewlabel] = ACTIONS(269),
    [anon_sym_BSLASHnewcommand] = ACTIONS(271),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(271),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(273),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(271),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(273),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(271),
    [anon_sym_BSLASHdef] = ACTIONS(275),
    [anon_sym_BSLASHlet] = ACTIONS(277),
    [anon_sym_BSLASHleft] = ACTIONS(3846),
    [anon_sym_BSLASHbigl] = ACTIONS(3846),
    [anon_sym_BSLASHBigl] = ACTIONS(3846),
    [anon_sym_BSLASHbiggl] = ACTIONS(3846),
    [anon_sym_BSLASHBiggl] = ACTIONS(3846),
    [anon_sym_BSLASHright] = ACTIONS(3846),
    [anon_sym_BSLASHbigr] = ACTIONS(3846),
    [anon_sym_BSLASHBigr] = ACTIONS(3846),
    [anon_sym_BSLASHbiggr] = ACTIONS(3846),
    [anon_sym_BSLASHBiggr] = ACTIONS(3846),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(283),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(283),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(285),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(285),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(287),
    [anon_sym_BSLASHgls] = ACTIONS(289),
    [anon_sym_BSLASHGls] = ACTIONS(289),
    [anon_sym_BSLASHGLS] = ACTIONS(289),
    [anon_sym_BSLASHglspl] = ACTIONS(289),
    [anon_sym_BSLASHGlspl] = ACTIONS(289),
    [anon_sym_BSLASHGLSpl] = ACTIONS(289),
    [anon_sym_BSLASHglsdisp] = ACTIONS(289),
    [anon_sym_BSLASHglslink] = ACTIONS(289),
    [anon_sym_BSLASHglstext] = ACTIONS(289),
    [anon_sym_BSLASHGlstext] = ACTIONS(289),
    [anon_sym_BSLASHGLStext] = ACTIONS(289),
    [anon_sym_BSLASHglsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(289),
    [anon_sym_BSLASHglsplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSplural] = ACTIONS(289),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(289),
    [anon_sym_BSLASHglsname] = ACTIONS(289),
    [anon_sym_BSLASHGlsname] = ACTIONS(289),
    [anon_sym_BSLASHGLSname] = ACTIONS(289),
    [anon_sym_BSLASHglssymbol] = ACTIONS(289),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(289),
    [anon_sym_BSLASHglsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(289),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(289),
    [anon_sym_BSLASHglsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(289),
    [anon_sym_BSLASHglsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(289),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(289),
    [anon_sym_BSLASHglsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(289),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(289),
    [anon_sym_BSLASHglsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(289),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(289),
    [anon_sym_BSLASHnewacronym] = ACTIONS(291),
    [anon_sym_BSLASHacrshort] = ACTIONS(293),
    [anon_sym_BSLASHAcrshort] = ACTIONS(293),
    [anon_sym_BSLASHACRshort] = ACTIONS(293),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(293),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(293),
    [anon_sym_BSLASHacrlong] = ACTIONS(293),
    [anon_sym_BSLASHAcrlong] = ACTIONS(293),
    [anon_sym_BSLASHACRlong] = ACTIONS(293),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(293),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(293),
    [anon_sym_BSLASHacrfull] = ACTIONS(293),
    [anon_sym_BSLASHAcrfull] = ACTIONS(293),
    [anon_sym_BSLASHACRfull] = ACTIONS(293),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(293),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(293),
    [anon_sym_BSLASHacs] = ACTIONS(293),
    [anon_sym_BSLASHAcs] = ACTIONS(293),
    [anon_sym_BSLASHacsp] = ACTIONS(293),
    [anon_sym_BSLASHAcsp] = ACTIONS(293),
    [anon_sym_BSLASHacl] = ACTIONS(293),
    [anon_sym_BSLASHAcl] = ACTIONS(293),
    [anon_sym_BSLASHaclp] = ACTIONS(293),
    [anon_sym_BSLASHAclp] = ACTIONS(293),
    [anon_sym_BSLASHacf] = ACTIONS(293),
    [anon_sym_BSLASHAcf] = ACTIONS(293),
    [anon_sym_BSLASHacfp] = ACTIONS(293),
    [anon_sym_BSLASHAcfp] = ACTIONS(293),
    [anon_sym_BSLASHac] = ACTIONS(293),
    [anon_sym_BSLASHAc] = ACTIONS(293),
    [anon_sym_BSLASHacp] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(293),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(293),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(293),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(293),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(295),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(295),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(297),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(299),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(301),
    [anon_sym_BSLASHcolor] = ACTIONS(303),
    [anon_sym_BSLASHcolorbox] = ACTIONS(303),
    [anon_sym_BSLASHtextcolor] = ACTIONS(303),
    [anon_sym_BSLASHpagecolor] = ACTIONS(303),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(305),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(305),
    [anon_sym_BSLASHtext] = ACTIONS(3846),
    [anon_sym_BSLASHintertext] = ACTIONS(3846),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3846),
    [anon_sym_BSLASHurl] = ACTIONS(309),
    [anon_sym_BSLASHhref] = ACTIONS(309),
  },
  [257] = {
    [sym_block_comment] = STATE(1030),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym__command] = STATE(1030),
    [sym_generic_command] = STATE(1030),
    [sym_title_declaration] = STATE(1030),
    [sym_author_declaration] = STATE(1030),
    [sym_package_include] = STATE(1030),
    [sym_class_include] = STATE(1030),
    [sym_latex_include] = STATE(1030),
    [sym_biblatex_include] = STATE(1030),
    [sym_bibstyle_include] = STATE(1030),
    [sym_bibtex_include] = STATE(1030),
    [sym_graphics_include] = STATE(1030),
    [sym_svg_include] = STATE(1030),
    [sym_inkscape_include] = STATE(1030),
    [sym_verbatim_include] = STATE(1030),
    [sym_import_include] = STATE(1030),
    [sym_caption] = STATE(1030),
    [sym_citation] = STATE(1030),
    [sym_label_definition] = STATE(1030),
    [sym_label_reference] = STATE(1030),
    [sym_label_reference_range] = STATE(1030),
    [sym_label_number] = STATE(1030),
    [sym_new_command_definition] = STATE(1030),
    [sym_old_command_definition] = STATE(1030),
    [sym_let_command_definition] = STATE(1030),
    [sym_paired_delimiter_definition] = STATE(1030),
    [sym_environment_definition] = STATE(1030),
    [sym_glossary_entry_definition] = STATE(1030),
    [sym_glossary_entry_reference] = STATE(1030),
    [sym_acronym_definition] = STATE(1030),
    [sym_acronym_reference] = STATE(1030),
    [sym_theorem_definition] = STATE(1030),
    [sym_color_definition] = STATE(1030),
    [sym_color_set_definition] = STATE(1030),
    [sym_color_reference] = STATE(1030),
    [sym_tikz_library_import] = STATE(1030),
    [sym_hyperlink] = STATE(1030),
    [aux_sym_text_repeat1] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(3844),
    [sym_command_name] = ACTIONS(7),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_RBRACK] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [anon_sym_RPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHpart] = ACTIONS(3846),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddpart] = ACTIONS(3846),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHchapter] = ACTIONS(3846),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddchap] = ACTIONS(3846),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsection] = ACTIONS(3846),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddsec] = ACTIONS(3846),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHitem] = ACTIONS(3846),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [anon_sym_RBRACE] = ACTIONS(3844),
    [sym_word] = ACTIONS(47),
    [sym_placeholder] = ACTIONS(49),
    [anon_sym_PLUS] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(51),
    [anon_sym_STAR] = ACTIONS(51),
    [anon_sym_SLASH] = ACTIONS(51),
    [anon_sym_LT] = ACTIONS(53),
    [anon_sym_GT] = ACTIONS(53),
    [anon_sym_BANG] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_COLON] = ACTIONS(53),
    [anon_sym_SQUOTE] = ACTIONS(53),
    [anon_sym__] = ACTIONS(55),
    [anon_sym_CARET] = ACTIONS(57),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3844),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3844),
    [anon_sym_DOLLAR] = ACTIONS(3846),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHbegin] = ACTIONS(3846),
    [anon_sym_BSLASHtitle] = ACTIONS(67),
    [anon_sym_BSLASHauthor] = ACTIONS(69),
    [anon_sym_BSLASHusepackage] = ACTIONS(71),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(71),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(73),
    [anon_sym_BSLASHinclude] = ACTIONS(75),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(75),
    [anon_sym_BSLASHinput] = ACTIONS(75),
    [anon_sym_BSLASHsubfile] = ACTIONS(75),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(77),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(79),
    [anon_sym_BSLASHbibliography] = ACTIONS(81),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(83),
    [anon_sym_BSLASHincludesvg] = ACTIONS(85),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(87),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(89),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(89),
    [anon_sym_BSLASHimport] = ACTIONS(91),
    [anon_sym_BSLASHsubimport] = ACTIONS(91),
    [anon_sym_BSLASHinputfrom] = ACTIONS(91),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(91),
    [anon_sym_BSLASHincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(91),
    [anon_sym_BSLASHcaption] = ACTIONS(93),
    [anon_sym_BSLASHcite] = ACTIONS(95),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCite] = ACTIONS(95),
    [anon_sym_BSLASHnocite] = ACTIONS(95),
    [anon_sym_BSLASHcitet] = ACTIONS(95),
    [anon_sym_BSLASHcitep] = ACTIONS(95),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteA] = ACTIONS(95),
    [anon_sym_BSLASHciteR] = ACTIONS(95),
    [anon_sym_BSLASHciteS] = ACTIONS(95),
    [anon_sym_BSLASHciteyearR] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor] = ACTIONS(95),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(95),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitetitle] = ACTIONS(95),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteyear] = ACTIONS(95),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(97),
    [anon_sym_BSLASHcitedate] = ACTIONS(95),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(97),
    [anon_sym_BSLASHciteurl] = ACTIONS(95),
    [anon_sym_BSLASHfullcite] = ACTIONS(95),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(95),
    [anon_sym_BSLASHcitealt] = ACTIONS(95),
    [anon_sym_BSLASHcitealp] = ACTIONS(95),
    [anon_sym_BSLASHcitetext] = ACTIONS(95),
    [anon_sym_BSLASHparencite] = ACTIONS(95),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHParencite] = ACTIONS(95),
    [anon_sym_BSLASHfootcite] = ACTIONS(95),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(95),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(95),
    [anon_sym_BSLASHtextcite] = ACTIONS(95),
    [anon_sym_BSLASHTextcite] = ACTIONS(95),
    [anon_sym_BSLASHsmartcite] = ACTIONS(95),
    [anon_sym_BSLASHSmartcite] = ACTIONS(95),
    [anon_sym_BSLASHsupercite] = ACTIONS(95),
    [anon_sym_BSLASHautocite] = ACTIONS(95),
    [anon_sym_BSLASHAutocite] = ACTIONS(95),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(97),
    [anon_sym_BSLASHvolcite] = ACTIONS(95),
    [anon_sym_BSLASHVolcite] = ACTIONS(95),
    [anon_sym_BSLASHpvolcite] = ACTIONS(95),
    [anon_sym_BSLASHPvolcite] = ACTIONS(95),
    [anon_sym_BSLASHfvolcite] = ACTIONS(95),
    [anon_sym_BSLASHftvolcite] = ACTIONS(95),
    [anon_sym_BSLASHsvolcite] = ACTIONS(95),
    [anon_sym_BSLASHSvolcite] = ACTIONS(95),
    [anon_sym_BSLASHtvolcite] = ACTIONS(95),
    [anon_sym_BSLASHTvolcite] = ACTIONS(95),
    [anon_sym_BSLASHavolcite] = ACTIONS(95),
    [anon_sym_BSLASHAvolcite] = ACTIONS(95),
    [anon_sym_BSLASHnotecite] = ACTIONS(95),
    [anon_sym_BSLASHNotecite] = ACTIONS(95),
    [anon_sym_BSLASHpnotecite] = ACTIONS(95),
    [anon_sym_BSLASHPnotecite] = ACTIONS(95),
    [anon_sym_BSLASHfnotecite] = ACTIONS(95),
    [anon_sym_BSLASHlabel] = ACTIONS(99),
    [anon_sym_BSLASHref] = ACTIONS(101),
    [anon_sym_BSLASHeqref] = ACTIONS(101),
    [anon_sym_BSLASHvref] = ACTIONS(101),
    [anon_sym_BSLASHVref] = ACTIONS(101),
    [anon_sym_BSLASHautoref] = ACTIONS(101),
    [anon_sym_BSLASHpageref] = ACTIONS(101),
    [anon_sym_BSLASHcref] = ACTIONS(101),
    [anon_sym_BSLASHCref] = ACTIONS(101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(103),
    [anon_sym_BSLASHnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnameCref] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(109),
    [anon_sym_BSLASHnewcommand] = ACTIONS(111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(113),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(113),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(111),
    [anon_sym_BSLASHdef] = ACTIONS(115),
    [anon_sym_BSLASHlet] = ACTIONS(117),
    [anon_sym_BSLASHleft] = ACTIONS(3846),
    [anon_sym_BSLASHbigl] = ACTIONS(3846),
    [anon_sym_BSLASHBigl] = ACTIONS(3846),
    [anon_sym_BSLASHbiggl] = ACTIONS(3846),
    [anon_sym_BSLASHBiggl] = ACTIONS(3846),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(121),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(121),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(125),
    [anon_sym_BSLASHgls] = ACTIONS(127),
    [anon_sym_BSLASHGls] = ACTIONS(127),
    [anon_sym_BSLASHGLS] = ACTIONS(127),
    [anon_sym_BSLASHglspl] = ACTIONS(127),
    [anon_sym_BSLASHGlspl] = ACTIONS(127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(127),
    [anon_sym_BSLASHglslink] = ACTIONS(127),
    [anon_sym_BSLASHglstext] = ACTIONS(127),
    [anon_sym_BSLASHGlstext] = ACTIONS(127),
    [anon_sym_BSLASHGLStext] = ACTIONS(127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(127),
    [anon_sym_BSLASHglsplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(127),
    [anon_sym_BSLASHglsname] = ACTIONS(127),
    [anon_sym_BSLASHGlsname] = ACTIONS(127),
    [anon_sym_BSLASHGLSname] = ACTIONS(127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(129),
    [anon_sym_BSLASHacrshort] = ACTIONS(131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(131),
    [anon_sym_BSLASHACRshort] = ACTIONS(131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(131),
    [anon_sym_BSLASHacrlong] = ACTIONS(131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(131),
    [anon_sym_BSLASHACRlong] = ACTIONS(131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(131),
    [anon_sym_BSLASHacrfull] = ACTIONS(131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(131),
    [anon_sym_BSLASHACRfull] = ACTIONS(131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(131),
    [anon_sym_BSLASHacs] = ACTIONS(131),
    [anon_sym_BSLASHAcs] = ACTIONS(131),
    [anon_sym_BSLASHacsp] = ACTIONS(131),
    [anon_sym_BSLASHAcsp] = ACTIONS(131),
    [anon_sym_BSLASHacl] = ACTIONS(131),
    [anon_sym_BSLASHAcl] = ACTIONS(131),
    [anon_sym_BSLASHaclp] = ACTIONS(131),
    [anon_sym_BSLASHAclp] = ACTIONS(131),
    [anon_sym_BSLASHacf] = ACTIONS(131),
    [anon_sym_BSLASHAcf] = ACTIONS(131),
    [anon_sym_BSLASHacfp] = ACTIONS(131),
    [anon_sym_BSLASHAcfp] = ACTIONS(131),
    [anon_sym_BSLASHac] = ACTIONS(131),
    [anon_sym_BSLASHAc] = ACTIONS(131),
    [anon_sym_BSLASHacp] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(133),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(133),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(135),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(137),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(139),
    [anon_sym_BSLASHcolor] = ACTIONS(141),
    [anon_sym_BSLASHcolorbox] = ACTIONS(141),
    [anon_sym_BSLASHtextcolor] = ACTIONS(141),
    [anon_sym_BSLASHpagecolor] = ACTIONS(141),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(143),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(143),
    [anon_sym_BSLASHtext] = ACTIONS(3846),
    [anon_sym_BSLASHintertext] = ACTIONS(3846),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3846),
    [anon_sym_BSLASHurl] = ACTIONS(147),
    [anon_sym_BSLASHhref] = ACTIONS(147),
  },
  [258] = {
    [sym_block_comment] = STATE(1030),
    [sym_operator] = STATE(1030),
    [sym_subscript] = STATE(1030),
    [sym_superscript] = STATE(1030),
    [sym__command] = STATE(1030),
    [sym_generic_command] = STATE(1030),
    [sym_title_declaration] = STATE(1030),
    [sym_author_declaration] = STATE(1030),
    [sym_package_include] = STATE(1030),
    [sym_class_include] = STATE(1030),
    [sym_latex_include] = STATE(1030),
    [sym_biblatex_include] = STATE(1030),
    [sym_bibstyle_include] = STATE(1030),
    [sym_bibtex_include] = STATE(1030),
    [sym_graphics_include] = STATE(1030),
    [sym_svg_include] = STATE(1030),
    [sym_inkscape_include] = STATE(1030),
    [sym_verbatim_include] = STATE(1030),
    [sym_import_include] = STATE(1030),
    [sym_caption] = STATE(1030),
    [sym_citation] = STATE(1030),
    [sym_label_definition] = STATE(1030),
    [sym_label_reference] = STATE(1030),
    [sym_label_reference_range] = STATE(1030),
    [sym_label_number] = STATE(1030),
    [sym_new_command_definition] = STATE(1030),
    [sym_old_command_definition] = STATE(1030),
    [sym_let_command_definition] = STATE(1030),
    [sym_paired_delimiter_definition] = STATE(1030),
    [sym_environment_definition] = STATE(1030),
    [sym_glossary_entry_definition] = STATE(1030),
    [sym_glossary_entry_reference] = STATE(1030),
    [sym_acronym_definition] = STATE(1030),
    [sym_acronym_reference] = STATE(1030),
    [sym_theorem_definition] = STATE(1030),
    [sym_color_definition] = STATE(1030),
    [sym_color_set_definition] = STATE(1030),
    [sym_color_reference] = STATE(1030),
    [sym_tikz_library_import] = STATE(1030),
    [sym_hyperlink] = STATE(1030),
    [aux_sym_text_repeat1] = STATE(258),
    [ts_builtin_sym_end] = ACTIONS(3705),
    [sym_command_name] = ACTIONS(3848),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3851),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHpart] = ACTIONS(3707),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddpart] = ACTIONS(3707),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHchapter] = ACTIONS(3707),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddchap] = ACTIONS(3707),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsection] = ACTIONS(3707),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddsec] = ACTIONS(3707),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHitem] = ACTIONS(3707),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [sym_word] = ACTIONS(3854),
    [sym_placeholder] = ACTIONS(3857),
    [anon_sym_PLUS] = ACTIONS(3860),
    [anon_sym_DASH] = ACTIONS(3860),
    [anon_sym_STAR] = ACTIONS(3860),
    [anon_sym_SLASH] = ACTIONS(3860),
    [anon_sym_LT] = ACTIONS(3863),
    [anon_sym_GT] = ACTIONS(3863),
    [anon_sym_BANG] = ACTIONS(3863),
    [anon_sym_PIPE] = ACTIONS(3863),
    [anon_sym_COLON] = ACTIONS(3863),
    [anon_sym_SQUOTE] = ACTIONS(3863),
    [anon_sym__] = ACTIONS(3866),
    [anon_sym_CARET] = ACTIONS(3869),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3705),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3705),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHbegin] = ACTIONS(3707),
    [anon_sym_BSLASHtitle] = ACTIONS(3872),
    [anon_sym_BSLASHauthor] = ACTIONS(3875),
    [anon_sym_BSLASHusepackage] = ACTIONS(3878),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3878),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3881),
    [anon_sym_BSLASHinclude] = ACTIONS(3884),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3884),
    [anon_sym_BSLASHinput] = ACTIONS(3884),
    [anon_sym_BSLASHsubfile] = ACTIONS(3884),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3887),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3890),
    [anon_sym_BSLASHbibliography] = ACTIONS(3893),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3896),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3899),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3902),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3905),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3905),
    [anon_sym_BSLASHimport] = ACTIONS(3908),
    [anon_sym_BSLASHsubimport] = ACTIONS(3908),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3908),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3908),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3908),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3908),
    [anon_sym_BSLASHcaption] = ACTIONS(3911),
    [anon_sym_BSLASHcite] = ACTIONS(3914),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHCite] = ACTIONS(3914),
    [anon_sym_BSLASHnocite] = ACTIONS(3914),
    [anon_sym_BSLASHcitet] = ACTIONS(3914),
    [anon_sym_BSLASHcitep] = ACTIONS(3914),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHciteA] = ACTIONS(3914),
    [anon_sym_BSLASHciteR] = ACTIONS(3914),
    [anon_sym_BSLASHciteS] = ACTIONS(3914),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3914),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3914),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3914),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3914),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHciteyear] = ACTIONS(3914),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHcitedate] = ACTIONS(3914),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHciteurl] = ACTIONS(3914),
    [anon_sym_BSLASHfullcite] = ACTIONS(3914),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3914),
    [anon_sym_BSLASHcitealt] = ACTIONS(3914),
    [anon_sym_BSLASHcitealp] = ACTIONS(3914),
    [anon_sym_BSLASHcitetext] = ACTIONS(3914),
    [anon_sym_BSLASHparencite] = ACTIONS(3914),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHParencite] = ACTIONS(3914),
    [anon_sym_BSLASHfootcite] = ACTIONS(3914),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3914),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3914),
    [anon_sym_BSLASHtextcite] = ACTIONS(3914),
    [anon_sym_BSLASHTextcite] = ACTIONS(3914),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3914),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3914),
    [anon_sym_BSLASHsupercite] = ACTIONS(3914),
    [anon_sym_BSLASHautocite] = ACTIONS(3914),
    [anon_sym_BSLASHAutocite] = ACTIONS(3914),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3917),
    [anon_sym_BSLASHvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHVolcite] = ACTIONS(3914),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHavolcite] = ACTIONS(3914),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3914),
    [anon_sym_BSLASHnotecite] = ACTIONS(3914),
    [anon_sym_BSLASHNotecite] = ACTIONS(3914),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3914),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3914),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3914),
    [anon_sym_BSLASHlabel] = ACTIONS(3920),
    [anon_sym_BSLASHref] = ACTIONS(3923),
    [anon_sym_BSLASHeqref] = ACTIONS(3923),
    [anon_sym_BSLASHvref] = ACTIONS(3923),
    [anon_sym_BSLASHVref] = ACTIONS(3923),
    [anon_sym_BSLASHautoref] = ACTIONS(3923),
    [anon_sym_BSLASHpageref] = ACTIONS(3923),
    [anon_sym_BSLASHcref] = ACTIONS(3923),
    [anon_sym_BSLASHCref] = ACTIONS(3923),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3926),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3926),
    [anon_sym_BSLASHnamecref] = ACTIONS(3923),
    [anon_sym_BSLASHnameCref] = ACTIONS(3923),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3923),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3923),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3923),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3923),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3923),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3923),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3929),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3932),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3929),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3932),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3935),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3938),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3941),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3938),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3941),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3938),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3941),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3938),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3941),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3938),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3938),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3938),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3938),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3938),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3938),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3938),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3938),
    [anon_sym_BSLASHdef] = ACTIONS(3944),
    [anon_sym_BSLASHlet] = ACTIONS(3947),
    [anon_sym_BSLASHleft] = ACTIONS(3707),
    [anon_sym_BSLASHbigl] = ACTIONS(3707),
    [anon_sym_BSLASHBigl] = ACTIONS(3707),
    [anon_sym_BSLASHbiggl] = ACTIONS(3707),
    [anon_sym_BSLASHBiggl] = ACTIONS(3707),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3950),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3950),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3956),
    [anon_sym_BSLASHgls] = ACTIONS(3959),
    [anon_sym_BSLASHGls] = ACTIONS(3959),
    [anon_sym_BSLASHGLS] = ACTIONS(3959),
    [anon_sym_BSLASHglspl] = ACTIONS(3959),
    [anon_sym_BSLASHGlspl] = ACTIONS(3959),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3959),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3959),
    [anon_sym_BSLASHglslink] = ACTIONS(3959),
    [anon_sym_BSLASHglstext] = ACTIONS(3959),
    [anon_sym_BSLASHGlstext] = ACTIONS(3959),
    [anon_sym_BSLASHGLStext] = ACTIONS(3959),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3959),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3959),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3959),
    [anon_sym_BSLASHglsplural] = ACTIONS(3959),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3959),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3959),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3959),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3959),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3959),
    [anon_sym_BSLASHglsname] = ACTIONS(3959),
    [anon_sym_BSLASHGlsname] = ACTIONS(3959),
    [anon_sym_BSLASHGLSname] = ACTIONS(3959),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3959),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3959),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3959),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3959),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3959),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3959),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3959),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3959),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3959),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3959),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3959),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3959),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3959),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3959),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3959),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3959),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3959),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3959),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3959),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3959),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3959),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3959),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3959),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3962),
    [anon_sym_BSLASHacrshort] = ACTIONS(3965),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3965),
    [anon_sym_BSLASHACRshort] = ACTIONS(3965),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3965),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3965),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3965),
    [anon_sym_BSLASHacrlong] = ACTIONS(3965),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3965),
    [anon_sym_BSLASHACRlong] = ACTIONS(3965),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3965),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3965),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3965),
    [anon_sym_BSLASHacrfull] = ACTIONS(3965),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3965),
    [anon_sym_BSLASHACRfull] = ACTIONS(3965),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3965),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3965),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3965),
    [anon_sym_BSLASHacs] = ACTIONS(3965),
    [anon_sym_BSLASHAcs] = ACTIONS(3965),
    [anon_sym_BSLASHacsp] = ACTIONS(3965),
    [anon_sym_BSLASHAcsp] = ACTIONS(3965),
    [anon_sym_BSLASHacl] = ACTIONS(3965),
    [anon_sym_BSLASHAcl] = ACTIONS(3965),
    [anon_sym_BSLASHaclp] = ACTIONS(3965),
    [anon_sym_BSLASHAclp] = ACTIONS(3965),
    [anon_sym_BSLASHacf] = ACTIONS(3965),
    [anon_sym_BSLASHAcf] = ACTIONS(3965),
    [anon_sym_BSLASHacfp] = ACTIONS(3965),
    [anon_sym_BSLASHAcfp] = ACTIONS(3965),
    [anon_sym_BSLASHac] = ACTIONS(3965),
    [anon_sym_BSLASHAc] = ACTIONS(3965),
    [anon_sym_BSLASHacp] = ACTIONS(3965),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3965),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3965),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3965),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3965),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3965),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3965),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3965),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3965),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3965),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3965),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3968),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3971),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3968),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3971),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3974),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3977),
    [anon_sym_BSLASHcolor] = ACTIONS(3980),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3980),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3980),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3980),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3983),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3983),
    [anon_sym_BSLASHtext] = ACTIONS(3707),
    [anon_sym_BSLASHintertext] = ACTIONS(3707),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3707),
    [anon_sym_BSLASHurl] = ACTIONS(3986),
    [anon_sym_BSLASHhref] = ACTIONS(3986),
  },
  [259] = {
    [sym_block_comment] = STATE(1364),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym__command] = STATE(1364),
    [sym_generic_command] = STATE(1364),
    [sym_title_declaration] = STATE(1364),
    [sym_author_declaration] = STATE(1364),
    [sym_package_include] = STATE(1364),
    [sym_class_include] = STATE(1364),
    [sym_latex_include] = STATE(1364),
    [sym_biblatex_include] = STATE(1364),
    [sym_bibstyle_include] = STATE(1364),
    [sym_bibtex_include] = STATE(1364),
    [sym_graphics_include] = STATE(1364),
    [sym_svg_include] = STATE(1364),
    [sym_inkscape_include] = STATE(1364),
    [sym_verbatim_include] = STATE(1364),
    [sym_import_include] = STATE(1364),
    [sym_caption] = STATE(1364),
    [sym_citation] = STATE(1364),
    [sym_label_definition] = STATE(1364),
    [sym_label_reference] = STATE(1364),
    [sym_label_reference_range] = STATE(1364),
    [sym_label_number] = STATE(1364),
    [sym_new_command_definition] = STATE(1364),
    [sym_old_command_definition] = STATE(1364),
    [sym_let_command_definition] = STATE(1364),
    [sym_paired_delimiter_definition] = STATE(1364),
    [sym_environment_definition] = STATE(1364),
    [sym_glossary_entry_definition] = STATE(1364),
    [sym_glossary_entry_reference] = STATE(1364),
    [sym_acronym_definition] = STATE(1364),
    [sym_acronym_reference] = STATE(1364),
    [sym_theorem_definition] = STATE(1364),
    [sym_color_definition] = STATE(1364),
    [sym_color_set_definition] = STATE(1364),
    [sym_color_reference] = STATE(1364),
    [sym_tikz_library_import] = STATE(1364),
    [sym_hyperlink] = STATE(1364),
    [aux_sym_text_repeat1] = STATE(259),
    [sym_command_name] = ACTIONS(3989),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3992),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHpart] = ACTIONS(3707),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddpart] = ACTIONS(3707),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHchapter] = ACTIONS(3707),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddchap] = ACTIONS(3707),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsection] = ACTIONS(3707),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddsec] = ACTIONS(3707),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHitem] = ACTIONS(3707),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [sym_word] = ACTIONS(3995),
    [sym_placeholder] = ACTIONS(3998),
    [anon_sym_PLUS] = ACTIONS(4001),
    [anon_sym_DASH] = ACTIONS(4001),
    [anon_sym_STAR] = ACTIONS(4001),
    [anon_sym_SLASH] = ACTIONS(4001),
    [anon_sym_LT] = ACTIONS(4004),
    [anon_sym_GT] = ACTIONS(4004),
    [anon_sym_BANG] = ACTIONS(4004),
    [anon_sym_PIPE] = ACTIONS(4004),
    [anon_sym_COLON] = ACTIONS(4004),
    [anon_sym_SQUOTE] = ACTIONS(4004),
    [anon_sym__] = ACTIONS(4007),
    [anon_sym_CARET] = ACTIONS(4010),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3705),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3705),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(3705),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHbegin] = ACTIONS(3707),
    [anon_sym_BSLASHtitle] = ACTIONS(4013),
    [anon_sym_BSLASHauthor] = ACTIONS(4016),
    [anon_sym_BSLASHusepackage] = ACTIONS(4019),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4019),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4022),
    [anon_sym_BSLASHinclude] = ACTIONS(4025),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4025),
    [anon_sym_BSLASHinput] = ACTIONS(4025),
    [anon_sym_BSLASHsubfile] = ACTIONS(4025),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4028),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4031),
    [anon_sym_BSLASHbibliography] = ACTIONS(4034),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4037),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4040),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4043),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4046),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4046),
    [anon_sym_BSLASHimport] = ACTIONS(4049),
    [anon_sym_BSLASHsubimport] = ACTIONS(4049),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4049),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4049),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4049),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4049),
    [anon_sym_BSLASHcaption] = ACTIONS(4052),
    [anon_sym_BSLASHcite] = ACTIONS(4055),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHCite] = ACTIONS(4055),
    [anon_sym_BSLASHnocite] = ACTIONS(4055),
    [anon_sym_BSLASHcitet] = ACTIONS(4055),
    [anon_sym_BSLASHcitep] = ACTIONS(4055),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHciteA] = ACTIONS(4055),
    [anon_sym_BSLASHciteR] = ACTIONS(4055),
    [anon_sym_BSLASHciteS] = ACTIONS(4055),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4055),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4055),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4055),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4055),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHciteyear] = ACTIONS(4055),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHcitedate] = ACTIONS(4055),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHciteurl] = ACTIONS(4055),
    [anon_sym_BSLASHfullcite] = ACTIONS(4055),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4055),
    [anon_sym_BSLASHcitealt] = ACTIONS(4055),
    [anon_sym_BSLASHcitealp] = ACTIONS(4055),
    [anon_sym_BSLASHcitetext] = ACTIONS(4055),
    [anon_sym_BSLASHparencite] = ACTIONS(4055),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHParencite] = ACTIONS(4055),
    [anon_sym_BSLASHfootcite] = ACTIONS(4055),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4055),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4055),
    [anon_sym_BSLASHtextcite] = ACTIONS(4055),
    [anon_sym_BSLASHTextcite] = ACTIONS(4055),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4055),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4055),
    [anon_sym_BSLASHsupercite] = ACTIONS(4055),
    [anon_sym_BSLASHautocite] = ACTIONS(4055),
    [anon_sym_BSLASHAutocite] = ACTIONS(4055),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4058),
    [anon_sym_BSLASHvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHVolcite] = ACTIONS(4055),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHavolcite] = ACTIONS(4055),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4055),
    [anon_sym_BSLASHnotecite] = ACTIONS(4055),
    [anon_sym_BSLASHNotecite] = ACTIONS(4055),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4055),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4055),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4055),
    [anon_sym_BSLASHlabel] = ACTIONS(4061),
    [anon_sym_BSLASHref] = ACTIONS(4064),
    [anon_sym_BSLASHeqref] = ACTIONS(4064),
    [anon_sym_BSLASHvref] = ACTIONS(4064),
    [anon_sym_BSLASHVref] = ACTIONS(4064),
    [anon_sym_BSLASHautoref] = ACTIONS(4064),
    [anon_sym_BSLASHpageref] = ACTIONS(4064),
    [anon_sym_BSLASHcref] = ACTIONS(4064),
    [anon_sym_BSLASHCref] = ACTIONS(4064),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4067),
    [anon_sym_BSLASHnamecref] = ACTIONS(4064),
    [anon_sym_BSLASHnameCref] = ACTIONS(4064),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4064),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4064),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4064),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4064),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4064),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4064),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4070),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4073),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4070),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4073),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4076),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4079),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4082),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4079),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4082),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4079),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4082),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4079),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4082),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4079),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4079),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4079),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4079),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4079),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4079),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4079),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4079),
    [anon_sym_BSLASHdef] = ACTIONS(4085),
    [anon_sym_BSLASHlet] = ACTIONS(4088),
    [anon_sym_BSLASHleft] = ACTIONS(3707),
    [anon_sym_BSLASHbigl] = ACTIONS(3707),
    [anon_sym_BSLASHBigl] = ACTIONS(3707),
    [anon_sym_BSLASHbiggl] = ACTIONS(3707),
    [anon_sym_BSLASHBiggl] = ACTIONS(3707),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4091),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4091),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4094),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4094),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4094),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4094),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4094),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4094),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4097),
    [anon_sym_BSLASHgls] = ACTIONS(4100),
    [anon_sym_BSLASHGls] = ACTIONS(4100),
    [anon_sym_BSLASHGLS] = ACTIONS(4100),
    [anon_sym_BSLASHglspl] = ACTIONS(4100),
    [anon_sym_BSLASHGlspl] = ACTIONS(4100),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4100),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4100),
    [anon_sym_BSLASHglslink] = ACTIONS(4100),
    [anon_sym_BSLASHglstext] = ACTIONS(4100),
    [anon_sym_BSLASHGlstext] = ACTIONS(4100),
    [anon_sym_BSLASHGLStext] = ACTIONS(4100),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4100),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4100),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4100),
    [anon_sym_BSLASHglsplural] = ACTIONS(4100),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4100),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4100),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4100),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4100),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4100),
    [anon_sym_BSLASHglsname] = ACTIONS(4100),
    [anon_sym_BSLASHGlsname] = ACTIONS(4100),
    [anon_sym_BSLASHGLSname] = ACTIONS(4100),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4100),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4100),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4100),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4100),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4100),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4100),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4100),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4100),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4100),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4100),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4100),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4100),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4100),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4100),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4100),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4100),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4100),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4100),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4100),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4100),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4100),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4100),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4100),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4103),
    [anon_sym_BSLASHacrshort] = ACTIONS(4106),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4106),
    [anon_sym_BSLASHACRshort] = ACTIONS(4106),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4106),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4106),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4106),
    [anon_sym_BSLASHacrlong] = ACTIONS(4106),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4106),
    [anon_sym_BSLASHACRlong] = ACTIONS(4106),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4106),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4106),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4106),
    [anon_sym_BSLASHacrfull] = ACTIONS(4106),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4106),
    [anon_sym_BSLASHACRfull] = ACTIONS(4106),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4106),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4106),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4106),
    [anon_sym_BSLASHacs] = ACTIONS(4106),
    [anon_sym_BSLASHAcs] = ACTIONS(4106),
    [anon_sym_BSLASHacsp] = ACTIONS(4106),
    [anon_sym_BSLASHAcsp] = ACTIONS(4106),
    [anon_sym_BSLASHacl] = ACTIONS(4106),
    [anon_sym_BSLASHAcl] = ACTIONS(4106),
    [anon_sym_BSLASHaclp] = ACTIONS(4106),
    [anon_sym_BSLASHAclp] = ACTIONS(4106),
    [anon_sym_BSLASHacf] = ACTIONS(4106),
    [anon_sym_BSLASHAcf] = ACTIONS(4106),
    [anon_sym_BSLASHacfp] = ACTIONS(4106),
    [anon_sym_BSLASHAcfp] = ACTIONS(4106),
    [anon_sym_BSLASHac] = ACTIONS(4106),
    [anon_sym_BSLASHAc] = ACTIONS(4106),
    [anon_sym_BSLASHacp] = ACTIONS(4106),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4106),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4106),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4106),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4106),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4106),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4106),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4106),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4106),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4106),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4106),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4109),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4112),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4109),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4112),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4115),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4118),
    [anon_sym_BSLASHcolor] = ACTIONS(4121),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4121),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4121),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4121),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4124),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4124),
    [anon_sym_BSLASHtext] = ACTIONS(3707),
    [anon_sym_BSLASHintertext] = ACTIONS(3707),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3707),
    [anon_sym_BSLASHurl] = ACTIONS(4127),
    [anon_sym_BSLASHhref] = ACTIONS(4127),
  },
  [260] = {
    [sym_block_comment] = STATE(1127),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym__command] = STATE(1127),
    [sym_generic_command] = STATE(1127),
    [sym_title_declaration] = STATE(1127),
    [sym_author_declaration] = STATE(1127),
    [sym_package_include] = STATE(1127),
    [sym_class_include] = STATE(1127),
    [sym_latex_include] = STATE(1127),
    [sym_biblatex_include] = STATE(1127),
    [sym_bibstyle_include] = STATE(1127),
    [sym_bibtex_include] = STATE(1127),
    [sym_graphics_include] = STATE(1127),
    [sym_svg_include] = STATE(1127),
    [sym_inkscape_include] = STATE(1127),
    [sym_verbatim_include] = STATE(1127),
    [sym_import_include] = STATE(1127),
    [sym_caption] = STATE(1127),
    [sym_citation] = STATE(1127),
    [sym_label_definition] = STATE(1127),
    [sym_label_reference] = STATE(1127),
    [sym_label_reference_range] = STATE(1127),
    [sym_label_number] = STATE(1127),
    [sym_new_command_definition] = STATE(1127),
    [sym_old_command_definition] = STATE(1127),
    [sym_let_command_definition] = STATE(1127),
    [sym_paired_delimiter_definition] = STATE(1127),
    [sym_environment_definition] = STATE(1127),
    [sym_glossary_entry_definition] = STATE(1127),
    [sym_glossary_entry_reference] = STATE(1127),
    [sym_acronym_definition] = STATE(1127),
    [sym_acronym_reference] = STATE(1127),
    [sym_theorem_definition] = STATE(1127),
    [sym_color_definition] = STATE(1127),
    [sym_color_set_definition] = STATE(1127),
    [sym_color_reference] = STATE(1127),
    [sym_tikz_library_import] = STATE(1127),
    [sym_hyperlink] = STATE(1127),
    [aux_sym_text_repeat1] = STATE(260),
    [sym_command_name] = ACTIONS(4130),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4133),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHpart] = ACTIONS(3707),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddpart] = ACTIONS(3707),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHchapter] = ACTIONS(3707),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddchap] = ACTIONS(3707),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsection] = ACTIONS(3707),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddsec] = ACTIONS(3707),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHitem] = ACTIONS(3707),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [sym_word] = ACTIONS(4136),
    [sym_placeholder] = ACTIONS(4139),
    [anon_sym_PLUS] = ACTIONS(4142),
    [anon_sym_DASH] = ACTIONS(4142),
    [anon_sym_STAR] = ACTIONS(4142),
    [anon_sym_SLASH] = ACTIONS(4142),
    [anon_sym_LT] = ACTIONS(4145),
    [anon_sym_GT] = ACTIONS(4145),
    [anon_sym_BANG] = ACTIONS(4145),
    [anon_sym_PIPE] = ACTIONS(4145),
    [anon_sym_COLON] = ACTIONS(4145),
    [anon_sym_SQUOTE] = ACTIONS(4145),
    [anon_sym__] = ACTIONS(4148),
    [anon_sym_CARET] = ACTIONS(4151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3705),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3705),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHbegin] = ACTIONS(3707),
    [anon_sym_BSLASHend] = ACTIONS(3707),
    [anon_sym_BSLASHtitle] = ACTIONS(4154),
    [anon_sym_BSLASHauthor] = ACTIONS(4157),
    [anon_sym_BSLASHusepackage] = ACTIONS(4160),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4160),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4163),
    [anon_sym_BSLASHinclude] = ACTIONS(4166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4166),
    [anon_sym_BSLASHinput] = ACTIONS(4166),
    [anon_sym_BSLASHsubfile] = ACTIONS(4166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4169),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4172),
    [anon_sym_BSLASHbibliography] = ACTIONS(4175),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4178),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4181),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4184),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4187),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4187),
    [anon_sym_BSLASHimport] = ACTIONS(4190),
    [anon_sym_BSLASHsubimport] = ACTIONS(4190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4190),
    [anon_sym_BSLASHcaption] = ACTIONS(4193),
    [anon_sym_BSLASHcite] = ACTIONS(4196),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHCite] = ACTIONS(4196),
    [anon_sym_BSLASHnocite] = ACTIONS(4196),
    [anon_sym_BSLASHcitet] = ACTIONS(4196),
    [anon_sym_BSLASHcitep] = ACTIONS(4196),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHciteA] = ACTIONS(4196),
    [anon_sym_BSLASHciteR] = ACTIONS(4196),
    [anon_sym_BSLASHciteS] = ACTIONS(4196),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4196),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4196),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4196),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4196),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHciteyear] = ACTIONS(4196),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHcitedate] = ACTIONS(4196),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHciteurl] = ACTIONS(4196),
    [anon_sym_BSLASHfullcite] = ACTIONS(4196),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4196),
    [anon_sym_BSLASHcitealt] = ACTIONS(4196),
    [anon_sym_BSLASHcitealp] = ACTIONS(4196),
    [anon_sym_BSLASHcitetext] = ACTIONS(4196),
    [anon_sym_BSLASHparencite] = ACTIONS(4196),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHParencite] = ACTIONS(4196),
    [anon_sym_BSLASHfootcite] = ACTIONS(4196),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4196),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4196),
    [anon_sym_BSLASHtextcite] = ACTIONS(4196),
    [anon_sym_BSLASHTextcite] = ACTIONS(4196),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4196),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4196),
    [anon_sym_BSLASHsupercite] = ACTIONS(4196),
    [anon_sym_BSLASHautocite] = ACTIONS(4196),
    [anon_sym_BSLASHAutocite] = ACTIONS(4196),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4199),
    [anon_sym_BSLASHvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHVolcite] = ACTIONS(4196),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHavolcite] = ACTIONS(4196),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4196),
    [anon_sym_BSLASHnotecite] = ACTIONS(4196),
    [anon_sym_BSLASHNotecite] = ACTIONS(4196),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4196),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4196),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4196),
    [anon_sym_BSLASHlabel] = ACTIONS(4202),
    [anon_sym_BSLASHref] = ACTIONS(4205),
    [anon_sym_BSLASHeqref] = ACTIONS(4205),
    [anon_sym_BSLASHvref] = ACTIONS(4205),
    [anon_sym_BSLASHVref] = ACTIONS(4205),
    [anon_sym_BSLASHautoref] = ACTIONS(4205),
    [anon_sym_BSLASHpageref] = ACTIONS(4205),
    [anon_sym_BSLASHcref] = ACTIONS(4205),
    [anon_sym_BSLASHCref] = ACTIONS(4205),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4208),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4208),
    [anon_sym_BSLASHnamecref] = ACTIONS(4205),
    [anon_sym_BSLASHnameCref] = ACTIONS(4205),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4205),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4205),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4205),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4205),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4205),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4205),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4211),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4214),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4211),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4214),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4217),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4220),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4223),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4220),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4223),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4220),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4223),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4220),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4223),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4220),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4220),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4220),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4220),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4220),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4220),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4220),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4220),
    [anon_sym_BSLASHdef] = ACTIONS(4226),
    [anon_sym_BSLASHlet] = ACTIONS(4229),
    [anon_sym_BSLASHleft] = ACTIONS(3707),
    [anon_sym_BSLASHbigl] = ACTIONS(3707),
    [anon_sym_BSLASHBigl] = ACTIONS(3707),
    [anon_sym_BSLASHbiggl] = ACTIONS(3707),
    [anon_sym_BSLASHBiggl] = ACTIONS(3707),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4235),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4235),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4235),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4235),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4235),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4235),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4238),
    [anon_sym_BSLASHgls] = ACTIONS(4241),
    [anon_sym_BSLASHGls] = ACTIONS(4241),
    [anon_sym_BSLASHGLS] = ACTIONS(4241),
    [anon_sym_BSLASHglspl] = ACTIONS(4241),
    [anon_sym_BSLASHGlspl] = ACTIONS(4241),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4241),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4241),
    [anon_sym_BSLASHglslink] = ACTIONS(4241),
    [anon_sym_BSLASHglstext] = ACTIONS(4241),
    [anon_sym_BSLASHGlstext] = ACTIONS(4241),
    [anon_sym_BSLASHGLStext] = ACTIONS(4241),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4241),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4241),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4241),
    [anon_sym_BSLASHglsplural] = ACTIONS(4241),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4241),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4241),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4241),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4241),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4241),
    [anon_sym_BSLASHglsname] = ACTIONS(4241),
    [anon_sym_BSLASHGlsname] = ACTIONS(4241),
    [anon_sym_BSLASHGLSname] = ACTIONS(4241),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4241),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4241),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4241),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4241),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4241),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4241),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4241),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4241),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4241),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4241),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4241),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4241),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4241),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4241),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4241),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4241),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4241),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4241),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4241),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4241),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4241),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4241),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4241),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4244),
    [anon_sym_BSLASHacrshort] = ACTIONS(4247),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4247),
    [anon_sym_BSLASHACRshort] = ACTIONS(4247),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4247),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4247),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4247),
    [anon_sym_BSLASHacrlong] = ACTIONS(4247),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4247),
    [anon_sym_BSLASHACRlong] = ACTIONS(4247),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4247),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4247),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4247),
    [anon_sym_BSLASHacrfull] = ACTIONS(4247),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4247),
    [anon_sym_BSLASHACRfull] = ACTIONS(4247),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4247),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4247),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4247),
    [anon_sym_BSLASHacs] = ACTIONS(4247),
    [anon_sym_BSLASHAcs] = ACTIONS(4247),
    [anon_sym_BSLASHacsp] = ACTIONS(4247),
    [anon_sym_BSLASHAcsp] = ACTIONS(4247),
    [anon_sym_BSLASHacl] = ACTIONS(4247),
    [anon_sym_BSLASHAcl] = ACTIONS(4247),
    [anon_sym_BSLASHaclp] = ACTIONS(4247),
    [anon_sym_BSLASHAclp] = ACTIONS(4247),
    [anon_sym_BSLASHacf] = ACTIONS(4247),
    [anon_sym_BSLASHAcf] = ACTIONS(4247),
    [anon_sym_BSLASHacfp] = ACTIONS(4247),
    [anon_sym_BSLASHAcfp] = ACTIONS(4247),
    [anon_sym_BSLASHac] = ACTIONS(4247),
    [anon_sym_BSLASHAc] = ACTIONS(4247),
    [anon_sym_BSLASHacp] = ACTIONS(4247),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4247),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4247),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4247),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4247),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4247),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4247),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4247),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4247),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4247),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4247),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4253),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4253),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4256),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4259),
    [anon_sym_BSLASHcolor] = ACTIONS(4262),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4262),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4262),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4262),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4265),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4265),
    [anon_sym_BSLASHtext] = ACTIONS(3707),
    [anon_sym_BSLASHintertext] = ACTIONS(3707),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3707),
    [anon_sym_BSLASHurl] = ACTIONS(4268),
    [anon_sym_BSLASHhref] = ACTIONS(4268),
  },
  [261] = {
    [sym_block_comment] = STATE(1127),
    [sym_operator] = STATE(1127),
    [sym_subscript] = STATE(1127),
    [sym_superscript] = STATE(1127),
    [sym__command] = STATE(1127),
    [sym_generic_command] = STATE(1127),
    [sym_title_declaration] = STATE(1127),
    [sym_author_declaration] = STATE(1127),
    [sym_package_include] = STATE(1127),
    [sym_class_include] = STATE(1127),
    [sym_latex_include] = STATE(1127),
    [sym_biblatex_include] = STATE(1127),
    [sym_bibstyle_include] = STATE(1127),
    [sym_bibtex_include] = STATE(1127),
    [sym_graphics_include] = STATE(1127),
    [sym_svg_include] = STATE(1127),
    [sym_inkscape_include] = STATE(1127),
    [sym_verbatim_include] = STATE(1127),
    [sym_import_include] = STATE(1127),
    [sym_caption] = STATE(1127),
    [sym_citation] = STATE(1127),
    [sym_label_definition] = STATE(1127),
    [sym_label_reference] = STATE(1127),
    [sym_label_reference_range] = STATE(1127),
    [sym_label_number] = STATE(1127),
    [sym_new_command_definition] = STATE(1127),
    [sym_old_command_definition] = STATE(1127),
    [sym_let_command_definition] = STATE(1127),
    [sym_paired_delimiter_definition] = STATE(1127),
    [sym_environment_definition] = STATE(1127),
    [sym_glossary_entry_definition] = STATE(1127),
    [sym_glossary_entry_reference] = STATE(1127),
    [sym_acronym_definition] = STATE(1127),
    [sym_acronym_reference] = STATE(1127),
    [sym_theorem_definition] = STATE(1127),
    [sym_color_definition] = STATE(1127),
    [sym_color_set_definition] = STATE(1127),
    [sym_color_reference] = STATE(1127),
    [sym_tikz_library_import] = STATE(1127),
    [sym_hyperlink] = STATE(1127),
    [aux_sym_text_repeat1] = STATE(260),
    [sym_command_name] = ACTIONS(646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_RBRACK] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [anon_sym_RPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHpart] = ACTIONS(3846),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddpart] = ACTIONS(3846),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHchapter] = ACTIONS(3846),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddchap] = ACTIONS(3846),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsection] = ACTIONS(3846),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddsec] = ACTIONS(3846),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHitem] = ACTIONS(3846),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [sym_word] = ACTIONS(686),
    [sym_placeholder] = ACTIONS(688),
    [anon_sym_PLUS] = ACTIONS(690),
    [anon_sym_DASH] = ACTIONS(690),
    [anon_sym_STAR] = ACTIONS(690),
    [anon_sym_SLASH] = ACTIONS(690),
    [anon_sym_LT] = ACTIONS(692),
    [anon_sym_GT] = ACTIONS(692),
    [anon_sym_BANG] = ACTIONS(692),
    [anon_sym_PIPE] = ACTIONS(692),
    [anon_sym_COLON] = ACTIONS(692),
    [anon_sym_SQUOTE] = ACTIONS(692),
    [anon_sym__] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(696),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3844),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3844),
    [anon_sym_DOLLAR] = ACTIONS(3846),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHbegin] = ACTIONS(3846),
    [anon_sym_BSLASHend] = ACTIONS(3846),
    [anon_sym_BSLASHtitle] = ACTIONS(706),
    [anon_sym_BSLASHauthor] = ACTIONS(708),
    [anon_sym_BSLASHusepackage] = ACTIONS(710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(712),
    [anon_sym_BSLASHinclude] = ACTIONS(714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(714),
    [anon_sym_BSLASHinput] = ACTIONS(714),
    [anon_sym_BSLASHsubfile] = ACTIONS(714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(716),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(718),
    [anon_sym_BSLASHbibliography] = ACTIONS(720),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(728),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(728),
    [anon_sym_BSLASHimport] = ACTIONS(730),
    [anon_sym_BSLASHsubimport] = ACTIONS(730),
    [anon_sym_BSLASHinputfrom] = ACTIONS(730),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(730),
    [anon_sym_BSLASHincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(730),
    [anon_sym_BSLASHcaption] = ACTIONS(732),
    [anon_sym_BSLASHcite] = ACTIONS(734),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCite] = ACTIONS(734),
    [anon_sym_BSLASHnocite] = ACTIONS(734),
    [anon_sym_BSLASHcitet] = ACTIONS(734),
    [anon_sym_BSLASHcitep] = ACTIONS(734),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteA] = ACTIONS(734),
    [anon_sym_BSLASHciteR] = ACTIONS(734),
    [anon_sym_BSLASHciteS] = ACTIONS(734),
    [anon_sym_BSLASHciteyearR] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor] = ACTIONS(734),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(734),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(734),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteyear] = ACTIONS(734),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(736),
    [anon_sym_BSLASHcitedate] = ACTIONS(734),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(736),
    [anon_sym_BSLASHciteurl] = ACTIONS(734),
    [anon_sym_BSLASHfullcite] = ACTIONS(734),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(734),
    [anon_sym_BSLASHcitealt] = ACTIONS(734),
    [anon_sym_BSLASHcitealp] = ACTIONS(734),
    [anon_sym_BSLASHcitetext] = ACTIONS(734),
    [anon_sym_BSLASHparencite] = ACTIONS(734),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHParencite] = ACTIONS(734),
    [anon_sym_BSLASHfootcite] = ACTIONS(734),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(734),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(734),
    [anon_sym_BSLASHtextcite] = ACTIONS(734),
    [anon_sym_BSLASHTextcite] = ACTIONS(734),
    [anon_sym_BSLASHsmartcite] = ACTIONS(734),
    [anon_sym_BSLASHSmartcite] = ACTIONS(734),
    [anon_sym_BSLASHsupercite] = ACTIONS(734),
    [anon_sym_BSLASHautocite] = ACTIONS(734),
    [anon_sym_BSLASHAutocite] = ACTIONS(734),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(736),
    [anon_sym_BSLASHvolcite] = ACTIONS(734),
    [anon_sym_BSLASHVolcite] = ACTIONS(734),
    [anon_sym_BSLASHpvolcite] = ACTIONS(734),
    [anon_sym_BSLASHPvolcite] = ACTIONS(734),
    [anon_sym_BSLASHfvolcite] = ACTIONS(734),
    [anon_sym_BSLASHftvolcite] = ACTIONS(734),
    [anon_sym_BSLASHsvolcite] = ACTIONS(734),
    [anon_sym_BSLASHSvolcite] = ACTIONS(734),
    [anon_sym_BSLASHtvolcite] = ACTIONS(734),
    [anon_sym_BSLASHTvolcite] = ACTIONS(734),
    [anon_sym_BSLASHavolcite] = ACTIONS(734),
    [anon_sym_BSLASHAvolcite] = ACTIONS(734),
    [anon_sym_BSLASHnotecite] = ACTIONS(734),
    [anon_sym_BSLASHNotecite] = ACTIONS(734),
    [anon_sym_BSLASHpnotecite] = ACTIONS(734),
    [anon_sym_BSLASHPnotecite] = ACTIONS(734),
    [anon_sym_BSLASHfnotecite] = ACTIONS(734),
    [anon_sym_BSLASHlabel] = ACTIONS(738),
    [anon_sym_BSLASHref] = ACTIONS(740),
    [anon_sym_BSLASHeqref] = ACTIONS(740),
    [anon_sym_BSLASHvref] = ACTIONS(740),
    [anon_sym_BSLASHVref] = ACTIONS(740),
    [anon_sym_BSLASHautoref] = ACTIONS(740),
    [anon_sym_BSLASHpageref] = ACTIONS(740),
    [anon_sym_BSLASHcref] = ACTIONS(740),
    [anon_sym_BSLASHCref] = ACTIONS(740),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(742),
    [anon_sym_BSLASHnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnameCref] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(740),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(740),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(740),
    [anon_sym_BSLASHlabelcref] = ACTIONS(740),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(740),
    [anon_sym_BSLASHcrefrange] = ACTIONS(744),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHCrefrange] = ACTIONS(744),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(746),
    [anon_sym_BSLASHnewlabel] = ACTIONS(748),
    [anon_sym_BSLASHnewcommand] = ACTIONS(750),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(750),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(752),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(750),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(752),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(750),
    [anon_sym_BSLASHdef] = ACTIONS(754),
    [anon_sym_BSLASHlet] = ACTIONS(756),
    [anon_sym_BSLASHleft] = ACTIONS(3846),
    [anon_sym_BSLASHbigl] = ACTIONS(3846),
    [anon_sym_BSLASHBigl] = ACTIONS(3846),
    [anon_sym_BSLASHbiggl] = ACTIONS(3846),
    [anon_sym_BSLASHBiggl] = ACTIONS(3846),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(760),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(760),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(762),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(762),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(764),
    [anon_sym_BSLASHgls] = ACTIONS(766),
    [anon_sym_BSLASHGls] = ACTIONS(766),
    [anon_sym_BSLASHGLS] = ACTIONS(766),
    [anon_sym_BSLASHglspl] = ACTIONS(766),
    [anon_sym_BSLASHGlspl] = ACTIONS(766),
    [anon_sym_BSLASHGLSpl] = ACTIONS(766),
    [anon_sym_BSLASHglsdisp] = ACTIONS(766),
    [anon_sym_BSLASHglslink] = ACTIONS(766),
    [anon_sym_BSLASHglstext] = ACTIONS(766),
    [anon_sym_BSLASHGlstext] = ACTIONS(766),
    [anon_sym_BSLASHGLStext] = ACTIONS(766),
    [anon_sym_BSLASHglsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(766),
    [anon_sym_BSLASHglsplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSplural] = ACTIONS(766),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(766),
    [anon_sym_BSLASHglsname] = ACTIONS(766),
    [anon_sym_BSLASHGlsname] = ACTIONS(766),
    [anon_sym_BSLASHGLSname] = ACTIONS(766),
    [anon_sym_BSLASHglssymbol] = ACTIONS(766),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(766),
    [anon_sym_BSLASHglsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(766),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(766),
    [anon_sym_BSLASHglsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(766),
    [anon_sym_BSLASHglsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(766),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(766),
    [anon_sym_BSLASHglsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(766),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(766),
    [anon_sym_BSLASHglsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(766),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(766),
    [anon_sym_BSLASHnewacronym] = ACTIONS(768),
    [anon_sym_BSLASHacrshort] = ACTIONS(770),
    [anon_sym_BSLASHAcrshort] = ACTIONS(770),
    [anon_sym_BSLASHACRshort] = ACTIONS(770),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(770),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(770),
    [anon_sym_BSLASHacrlong] = ACTIONS(770),
    [anon_sym_BSLASHAcrlong] = ACTIONS(770),
    [anon_sym_BSLASHACRlong] = ACTIONS(770),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(770),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(770),
    [anon_sym_BSLASHacrfull] = ACTIONS(770),
    [anon_sym_BSLASHAcrfull] = ACTIONS(770),
    [anon_sym_BSLASHACRfull] = ACTIONS(770),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(770),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(770),
    [anon_sym_BSLASHacs] = ACTIONS(770),
    [anon_sym_BSLASHAcs] = ACTIONS(770),
    [anon_sym_BSLASHacsp] = ACTIONS(770),
    [anon_sym_BSLASHAcsp] = ACTIONS(770),
    [anon_sym_BSLASHacl] = ACTIONS(770),
    [anon_sym_BSLASHAcl] = ACTIONS(770),
    [anon_sym_BSLASHaclp] = ACTIONS(770),
    [anon_sym_BSLASHAclp] = ACTIONS(770),
    [anon_sym_BSLASHacf] = ACTIONS(770),
    [anon_sym_BSLASHAcf] = ACTIONS(770),
    [anon_sym_BSLASHacfp] = ACTIONS(770),
    [anon_sym_BSLASHAcfp] = ACTIONS(770),
    [anon_sym_BSLASHac] = ACTIONS(770),
    [anon_sym_BSLASHAc] = ACTIONS(770),
    [anon_sym_BSLASHacp] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(770),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(770),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(770),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(770),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(772),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(772),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(774),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(776),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(778),
    [anon_sym_BSLASHcolor] = ACTIONS(780),
    [anon_sym_BSLASHcolorbox] = ACTIONS(780),
    [anon_sym_BSLASHtextcolor] = ACTIONS(780),
    [anon_sym_BSLASHpagecolor] = ACTIONS(780),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(782),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(782),
    [anon_sym_BSLASHtext] = ACTIONS(3846),
    [anon_sym_BSLASHintertext] = ACTIONS(3846),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3846),
    [anon_sym_BSLASHurl] = ACTIONS(786),
    [anon_sym_BSLASHhref] = ACTIONS(786),
  },
  [262] = {
    [sym_block_comment] = STATE(1364),
    [sym_operator] = STATE(1364),
    [sym_subscript] = STATE(1364),
    [sym_superscript] = STATE(1364),
    [sym__command] = STATE(1364),
    [sym_generic_command] = STATE(1364),
    [sym_title_declaration] = STATE(1364),
    [sym_author_declaration] = STATE(1364),
    [sym_package_include] = STATE(1364),
    [sym_class_include] = STATE(1364),
    [sym_latex_include] = STATE(1364),
    [sym_biblatex_include] = STATE(1364),
    [sym_bibstyle_include] = STATE(1364),
    [sym_bibtex_include] = STATE(1364),
    [sym_graphics_include] = STATE(1364),
    [sym_svg_include] = STATE(1364),
    [sym_inkscape_include] = STATE(1364),
    [sym_verbatim_include] = STATE(1364),
    [sym_import_include] = STATE(1364),
    [sym_caption] = STATE(1364),
    [sym_citation] = STATE(1364),
    [sym_label_definition] = STATE(1364),
    [sym_label_reference] = STATE(1364),
    [sym_label_reference_range] = STATE(1364),
    [sym_label_number] = STATE(1364),
    [sym_new_command_definition] = STATE(1364),
    [sym_old_command_definition] = STATE(1364),
    [sym_let_command_definition] = STATE(1364),
    [sym_paired_delimiter_definition] = STATE(1364),
    [sym_environment_definition] = STATE(1364),
    [sym_glossary_entry_definition] = STATE(1364),
    [sym_glossary_entry_reference] = STATE(1364),
    [sym_acronym_definition] = STATE(1364),
    [sym_acronym_reference] = STATE(1364),
    [sym_theorem_definition] = STATE(1364),
    [sym_color_definition] = STATE(1364),
    [sym_color_set_definition] = STATE(1364),
    [sym_color_reference] = STATE(1364),
    [sym_tikz_library_import] = STATE(1364),
    [sym_hyperlink] = STATE(1364),
    [aux_sym_text_repeat1] = STATE(259),
    [sym_command_name] = ACTIONS(1026),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1028),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_RBRACK] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [anon_sym_RPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHpart] = ACTIONS(3846),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddpart] = ACTIONS(3846),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHchapter] = ACTIONS(3846),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddchap] = ACTIONS(3846),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsection] = ACTIONS(3846),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddsec] = ACTIONS(3846),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHitem] = ACTIONS(3846),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [sym_word] = ACTIONS(1034),
    [sym_placeholder] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1038),
    [anon_sym_DASH] = ACTIONS(1038),
    [anon_sym_STAR] = ACTIONS(1038),
    [anon_sym_SLASH] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_BANG] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_COLON] = ACTIONS(1040),
    [anon_sym_SQUOTE] = ACTIONS(1040),
    [anon_sym__] = ACTIONS(1042),
    [anon_sym_CARET] = ACTIONS(1044),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3844),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3844),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(3844),
    [anon_sym_DOLLAR] = ACTIONS(3846),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHbegin] = ACTIONS(3846),
    [anon_sym_BSLASHtitle] = ACTIONS(1056),
    [anon_sym_BSLASHauthor] = ACTIONS(1058),
    [anon_sym_BSLASHusepackage] = ACTIONS(1060),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1060),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1062),
    [anon_sym_BSLASHinclude] = ACTIONS(1064),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1064),
    [anon_sym_BSLASHinput] = ACTIONS(1064),
    [anon_sym_BSLASHsubfile] = ACTIONS(1064),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1066),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1068),
    [anon_sym_BSLASHbibliography] = ACTIONS(1070),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1072),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1074),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1076),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1078),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1078),
    [anon_sym_BSLASHimport] = ACTIONS(1080),
    [anon_sym_BSLASHsubimport] = ACTIONS(1080),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1080),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1080),
    [anon_sym_BSLASHcaption] = ACTIONS(1082),
    [anon_sym_BSLASHcite] = ACTIONS(1084),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCite] = ACTIONS(1084),
    [anon_sym_BSLASHnocite] = ACTIONS(1084),
    [anon_sym_BSLASHcitet] = ACTIONS(1084),
    [anon_sym_BSLASHcitep] = ACTIONS(1084),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteA] = ACTIONS(1084),
    [anon_sym_BSLASHciteR] = ACTIONS(1084),
    [anon_sym_BSLASHciteS] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1084),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1084),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteyear] = ACTIONS(1084),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHcitedate] = ACTIONS(1084),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHciteurl] = ACTIONS(1084),
    [anon_sym_BSLASHfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1084),
    [anon_sym_BSLASHcitealt] = ACTIONS(1084),
    [anon_sym_BSLASHcitealp] = ACTIONS(1084),
    [anon_sym_BSLASHcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHparencite] = ACTIONS(1084),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHParencite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1084),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1084),
    [anon_sym_BSLASHtextcite] = ACTIONS(1084),
    [anon_sym_BSLASHTextcite] = ACTIONS(1084),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1084),
    [anon_sym_BSLASHsupercite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite] = ACTIONS(1084),
    [anon_sym_BSLASHAutocite] = ACTIONS(1084),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1086),
    [anon_sym_BSLASHvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHVolcite] = ACTIONS(1084),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHavolcite] = ACTIONS(1084),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1084),
    [anon_sym_BSLASHnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHNotecite] = ACTIONS(1084),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1084),
    [anon_sym_BSLASHlabel] = ACTIONS(1088),
    [anon_sym_BSLASHref] = ACTIONS(1090),
    [anon_sym_BSLASHeqref] = ACTIONS(1090),
    [anon_sym_BSLASHvref] = ACTIONS(1090),
    [anon_sym_BSLASHVref] = ACTIONS(1090),
    [anon_sym_BSLASHautoref] = ACTIONS(1090),
    [anon_sym_BSLASHpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcref] = ACTIONS(1090),
    [anon_sym_BSLASHCref] = ACTIONS(1090),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1092),
    [anon_sym_BSLASHnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnameCref] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1090),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1090),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1090),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1094),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1096),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1098),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1100),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1102),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1100),
    [anon_sym_BSLASHdef] = ACTIONS(1104),
    [anon_sym_BSLASHlet] = ACTIONS(1106),
    [anon_sym_BSLASHleft] = ACTIONS(3846),
    [anon_sym_BSLASHbigl] = ACTIONS(3846),
    [anon_sym_BSLASHBigl] = ACTIONS(3846),
    [anon_sym_BSLASHbiggl] = ACTIONS(3846),
    [anon_sym_BSLASHBiggl] = ACTIONS(3846),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1110),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1110),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1112),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1112),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1114),
    [anon_sym_BSLASHgls] = ACTIONS(1116),
    [anon_sym_BSLASHGls] = ACTIONS(1116),
    [anon_sym_BSLASHGLS] = ACTIONS(1116),
    [anon_sym_BSLASHglspl] = ACTIONS(1116),
    [anon_sym_BSLASHGlspl] = ACTIONS(1116),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1116),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1116),
    [anon_sym_BSLASHglslink] = ACTIONS(1116),
    [anon_sym_BSLASHglstext] = ACTIONS(1116),
    [anon_sym_BSLASHGlstext] = ACTIONS(1116),
    [anon_sym_BSLASHGLStext] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1116),
    [anon_sym_BSLASHglsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1116),
    [anon_sym_BSLASHglsname] = ACTIONS(1116),
    [anon_sym_BSLASHGlsname] = ACTIONS(1116),
    [anon_sym_BSLASHGLSname] = ACTIONS(1116),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1116),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1116),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1116),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1116),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1116),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1116),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1118),
    [anon_sym_BSLASHacrshort] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1120),
    [anon_sym_BSLASHACRshort] = ACTIONS(1120),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrlong] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1120),
    [anon_sym_BSLASHACRlong] = ACTIONS(1120),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1120),
    [anon_sym_BSLASHacrfull] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1120),
    [anon_sym_BSLASHACRfull] = ACTIONS(1120),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHacs] = ACTIONS(1120),
    [anon_sym_BSLASHAcs] = ACTIONS(1120),
    [anon_sym_BSLASHacsp] = ACTIONS(1120),
    [anon_sym_BSLASHAcsp] = ACTIONS(1120),
    [anon_sym_BSLASHacl] = ACTIONS(1120),
    [anon_sym_BSLASHAcl] = ACTIONS(1120),
    [anon_sym_BSLASHaclp] = ACTIONS(1120),
    [anon_sym_BSLASHAclp] = ACTIONS(1120),
    [anon_sym_BSLASHacf] = ACTIONS(1120),
    [anon_sym_BSLASHAcf] = ACTIONS(1120),
    [anon_sym_BSLASHacfp] = ACTIONS(1120),
    [anon_sym_BSLASHAcfp] = ACTIONS(1120),
    [anon_sym_BSLASHac] = ACTIONS(1120),
    [anon_sym_BSLASHAc] = ACTIONS(1120),
    [anon_sym_BSLASHacp] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1120),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1120),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1120),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1122),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1122),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1124),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1126),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1128),
    [anon_sym_BSLASHcolor] = ACTIONS(1130),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1130),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1130),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1130),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1132),
    [anon_sym_BSLASHtext] = ACTIONS(3846),
    [anon_sym_BSLASHintertext] = ACTIONS(3846),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3846),
    [anon_sym_BSLASHurl] = ACTIONS(1136),
    [anon_sym_BSLASHhref] = ACTIONS(1136),
  },
  [263] = {
    [sym_block_comment] = STATE(1392),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym__command] = STATE(1392),
    [sym_generic_command] = STATE(1392),
    [sym_title_declaration] = STATE(1392),
    [sym_author_declaration] = STATE(1392),
    [sym_package_include] = STATE(1392),
    [sym_class_include] = STATE(1392),
    [sym_latex_include] = STATE(1392),
    [sym_biblatex_include] = STATE(1392),
    [sym_bibstyle_include] = STATE(1392),
    [sym_bibtex_include] = STATE(1392),
    [sym_graphics_include] = STATE(1392),
    [sym_svg_include] = STATE(1392),
    [sym_inkscape_include] = STATE(1392),
    [sym_verbatim_include] = STATE(1392),
    [sym_import_include] = STATE(1392),
    [sym_caption] = STATE(1392),
    [sym_citation] = STATE(1392),
    [sym_label_definition] = STATE(1392),
    [sym_label_reference] = STATE(1392),
    [sym_label_reference_range] = STATE(1392),
    [sym_label_number] = STATE(1392),
    [sym_new_command_definition] = STATE(1392),
    [sym_old_command_definition] = STATE(1392),
    [sym_let_command_definition] = STATE(1392),
    [sym_paired_delimiter_definition] = STATE(1392),
    [sym_environment_definition] = STATE(1392),
    [sym_glossary_entry_definition] = STATE(1392),
    [sym_glossary_entry_reference] = STATE(1392),
    [sym_acronym_definition] = STATE(1392),
    [sym_acronym_reference] = STATE(1392),
    [sym_theorem_definition] = STATE(1392),
    [sym_color_definition] = STATE(1392),
    [sym_color_set_definition] = STATE(1392),
    [sym_color_reference] = STATE(1392),
    [sym_tikz_library_import] = STATE(1392),
    [sym_hyperlink] = STATE(1392),
    [aux_sym_text_repeat1] = STATE(263),
    [sym_command_name] = ACTIONS(4271),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4274),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHpart] = ACTIONS(3707),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddpart] = ACTIONS(3707),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHchapter] = ACTIONS(3707),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddchap] = ACTIONS(3707),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsection] = ACTIONS(3707),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHaddsec] = ACTIONS(3707),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3707),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3707),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3705),
    [anon_sym_BSLASHitem] = ACTIONS(3707),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [sym_word] = ACTIONS(4277),
    [sym_placeholder] = ACTIONS(4280),
    [anon_sym_PLUS] = ACTIONS(4283),
    [anon_sym_DASH] = ACTIONS(4283),
    [anon_sym_STAR] = ACTIONS(4283),
    [anon_sym_SLASH] = ACTIONS(4283),
    [anon_sym_LT] = ACTIONS(4286),
    [anon_sym_GT] = ACTIONS(4286),
    [anon_sym_BANG] = ACTIONS(4286),
    [anon_sym_PIPE] = ACTIONS(4286),
    [anon_sym_COLON] = ACTIONS(4286),
    [anon_sym_SQUOTE] = ACTIONS(4286),
    [anon_sym__] = ACTIONS(4289),
    [anon_sym_CARET] = ACTIONS(4292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3705),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3705),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3705),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHbegin] = ACTIONS(3707),
    [anon_sym_BSLASHtitle] = ACTIONS(4295),
    [anon_sym_BSLASHauthor] = ACTIONS(4298),
    [anon_sym_BSLASHusepackage] = ACTIONS(4301),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4301),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4304),
    [anon_sym_BSLASHinclude] = ACTIONS(4307),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4307),
    [anon_sym_BSLASHinput] = ACTIONS(4307),
    [anon_sym_BSLASHsubfile] = ACTIONS(4307),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4313),
    [anon_sym_BSLASHbibliography] = ACTIONS(4316),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4319),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4325),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4328),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4328),
    [anon_sym_BSLASHimport] = ACTIONS(4331),
    [anon_sym_BSLASHsubimport] = ACTIONS(4331),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4331),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4331),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4331),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4331),
    [anon_sym_BSLASHcaption] = ACTIONS(4334),
    [anon_sym_BSLASHcite] = ACTIONS(4337),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHCite] = ACTIONS(4337),
    [anon_sym_BSLASHnocite] = ACTIONS(4337),
    [anon_sym_BSLASHcitet] = ACTIONS(4337),
    [anon_sym_BSLASHcitep] = ACTIONS(4337),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHciteA] = ACTIONS(4337),
    [anon_sym_BSLASHciteR] = ACTIONS(4337),
    [anon_sym_BSLASHciteS] = ACTIONS(4337),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4337),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4337),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4337),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4337),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHciteyear] = ACTIONS(4337),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHcitedate] = ACTIONS(4337),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHciteurl] = ACTIONS(4337),
    [anon_sym_BSLASHfullcite] = ACTIONS(4337),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4337),
    [anon_sym_BSLASHcitealt] = ACTIONS(4337),
    [anon_sym_BSLASHcitealp] = ACTIONS(4337),
    [anon_sym_BSLASHcitetext] = ACTIONS(4337),
    [anon_sym_BSLASHparencite] = ACTIONS(4337),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHParencite] = ACTIONS(4337),
    [anon_sym_BSLASHfootcite] = ACTIONS(4337),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4337),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4337),
    [anon_sym_BSLASHtextcite] = ACTIONS(4337),
    [anon_sym_BSLASHTextcite] = ACTIONS(4337),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4337),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4337),
    [anon_sym_BSLASHsupercite] = ACTIONS(4337),
    [anon_sym_BSLASHautocite] = ACTIONS(4337),
    [anon_sym_BSLASHAutocite] = ACTIONS(4337),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4340),
    [anon_sym_BSLASHvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHVolcite] = ACTIONS(4337),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHavolcite] = ACTIONS(4337),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4337),
    [anon_sym_BSLASHnotecite] = ACTIONS(4337),
    [anon_sym_BSLASHNotecite] = ACTIONS(4337),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4337),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4337),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4337),
    [anon_sym_BSLASHlabel] = ACTIONS(4343),
    [anon_sym_BSLASHref] = ACTIONS(4346),
    [anon_sym_BSLASHeqref] = ACTIONS(4346),
    [anon_sym_BSLASHvref] = ACTIONS(4346),
    [anon_sym_BSLASHVref] = ACTIONS(4346),
    [anon_sym_BSLASHautoref] = ACTIONS(4346),
    [anon_sym_BSLASHpageref] = ACTIONS(4346),
    [anon_sym_BSLASHcref] = ACTIONS(4346),
    [anon_sym_BSLASHCref] = ACTIONS(4346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4349),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4349),
    [anon_sym_BSLASHnamecref] = ACTIONS(4346),
    [anon_sym_BSLASHnameCref] = ACTIONS(4346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4352),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4355),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4352),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4355),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4361),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4361),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4361),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4361),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4361),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4361),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4361),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4361),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4361),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4361),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4361),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4361),
    [anon_sym_BSLASHdef] = ACTIONS(4367),
    [anon_sym_BSLASHlet] = ACTIONS(4370),
    [anon_sym_BSLASHleft] = ACTIONS(3707),
    [anon_sym_BSLASHbigl] = ACTIONS(3707),
    [anon_sym_BSLASHBigl] = ACTIONS(3707),
    [anon_sym_BSLASHbiggl] = ACTIONS(3707),
    [anon_sym_BSLASHBiggl] = ACTIONS(3707),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4373),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4373),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4376),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4376),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4376),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4376),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4376),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4376),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4379),
    [anon_sym_BSLASHgls] = ACTIONS(4382),
    [anon_sym_BSLASHGls] = ACTIONS(4382),
    [anon_sym_BSLASHGLS] = ACTIONS(4382),
    [anon_sym_BSLASHglspl] = ACTIONS(4382),
    [anon_sym_BSLASHGlspl] = ACTIONS(4382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4382),
    [anon_sym_BSLASHglslink] = ACTIONS(4382),
    [anon_sym_BSLASHglstext] = ACTIONS(4382),
    [anon_sym_BSLASHGlstext] = ACTIONS(4382),
    [anon_sym_BSLASHGLStext] = ACTIONS(4382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4382),
    [anon_sym_BSLASHglsplural] = ACTIONS(4382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4382),
    [anon_sym_BSLASHglsname] = ACTIONS(4382),
    [anon_sym_BSLASHGlsname] = ACTIONS(4382),
    [anon_sym_BSLASHGLSname] = ACTIONS(4382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4385),
    [anon_sym_BSLASHacrshort] = ACTIONS(4388),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4388),
    [anon_sym_BSLASHACRshort] = ACTIONS(4388),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4388),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4388),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4388),
    [anon_sym_BSLASHacrlong] = ACTIONS(4388),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4388),
    [anon_sym_BSLASHACRlong] = ACTIONS(4388),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4388),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4388),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4388),
    [anon_sym_BSLASHacrfull] = ACTIONS(4388),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4388),
    [anon_sym_BSLASHACRfull] = ACTIONS(4388),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4388),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4388),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4388),
    [anon_sym_BSLASHacs] = ACTIONS(4388),
    [anon_sym_BSLASHAcs] = ACTIONS(4388),
    [anon_sym_BSLASHacsp] = ACTIONS(4388),
    [anon_sym_BSLASHAcsp] = ACTIONS(4388),
    [anon_sym_BSLASHacl] = ACTIONS(4388),
    [anon_sym_BSLASHAcl] = ACTIONS(4388),
    [anon_sym_BSLASHaclp] = ACTIONS(4388),
    [anon_sym_BSLASHAclp] = ACTIONS(4388),
    [anon_sym_BSLASHacf] = ACTIONS(4388),
    [anon_sym_BSLASHAcf] = ACTIONS(4388),
    [anon_sym_BSLASHacfp] = ACTIONS(4388),
    [anon_sym_BSLASHAcfp] = ACTIONS(4388),
    [anon_sym_BSLASHac] = ACTIONS(4388),
    [anon_sym_BSLASHAc] = ACTIONS(4388),
    [anon_sym_BSLASHacp] = ACTIONS(4388),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4388),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4388),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4388),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4388),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4388),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4388),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4388),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4388),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4388),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4388),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4391),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4394),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4391),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4394),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4397),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4400),
    [anon_sym_BSLASHcolor] = ACTIONS(4403),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4403),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4403),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4403),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4406),
    [anon_sym_BSLASHtext] = ACTIONS(3707),
    [anon_sym_BSLASHintertext] = ACTIONS(3707),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3707),
    [anon_sym_BSLASHurl] = ACTIONS(4409),
    [anon_sym_BSLASHhref] = ACTIONS(4409),
  },
  [264] = {
    [sym_block_comment] = STATE(1392),
    [sym_operator] = STATE(1392),
    [sym_subscript] = STATE(1392),
    [sym_superscript] = STATE(1392),
    [sym__command] = STATE(1392),
    [sym_generic_command] = STATE(1392),
    [sym_title_declaration] = STATE(1392),
    [sym_author_declaration] = STATE(1392),
    [sym_package_include] = STATE(1392),
    [sym_class_include] = STATE(1392),
    [sym_latex_include] = STATE(1392),
    [sym_biblatex_include] = STATE(1392),
    [sym_bibstyle_include] = STATE(1392),
    [sym_bibtex_include] = STATE(1392),
    [sym_graphics_include] = STATE(1392),
    [sym_svg_include] = STATE(1392),
    [sym_inkscape_include] = STATE(1392),
    [sym_verbatim_include] = STATE(1392),
    [sym_import_include] = STATE(1392),
    [sym_caption] = STATE(1392),
    [sym_citation] = STATE(1392),
    [sym_label_definition] = STATE(1392),
    [sym_label_reference] = STATE(1392),
    [sym_label_reference_range] = STATE(1392),
    [sym_label_number] = STATE(1392),
    [sym_new_command_definition] = STATE(1392),
    [sym_old_command_definition] = STATE(1392),
    [sym_let_command_definition] = STATE(1392),
    [sym_paired_delimiter_definition] = STATE(1392),
    [sym_environment_definition] = STATE(1392),
    [sym_glossary_entry_definition] = STATE(1392),
    [sym_glossary_entry_reference] = STATE(1392),
    [sym_acronym_definition] = STATE(1392),
    [sym_acronym_reference] = STATE(1392),
    [sym_theorem_definition] = STATE(1392),
    [sym_color_definition] = STATE(1392),
    [sym_color_set_definition] = STATE(1392),
    [sym_color_reference] = STATE(1392),
    [sym_tikz_library_import] = STATE(1392),
    [sym_hyperlink] = STATE(1392),
    [aux_sym_text_repeat1] = STATE(263),
    [sym_command_name] = ACTIONS(1138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(1140),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_RBRACK] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [anon_sym_RPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHpart] = ACTIONS(3846),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddpart] = ACTIONS(3846),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHchapter] = ACTIONS(3846),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddchap] = ACTIONS(3846),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsection] = ACTIONS(3846),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHaddsec] = ACTIONS(3846),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(3846),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(3846),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(3844),
    [anon_sym_BSLASHitem] = ACTIONS(3846),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [sym_word] = ACTIONS(1146),
    [sym_placeholder] = ACTIONS(1148),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_SLASH] = ACTIONS(1150),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_BANG] = ACTIONS(1152),
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_COLON] = ACTIONS(1152),
    [anon_sym_SQUOTE] = ACTIONS(1152),
    [anon_sym__] = ACTIONS(1154),
    [anon_sym_CARET] = ACTIONS(1156),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3844),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3844),
    [anon_sym_DOLLAR] = ACTIONS(3846),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3844),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHbegin] = ACTIONS(3846),
    [anon_sym_BSLASHtitle] = ACTIONS(1166),
    [anon_sym_BSLASHauthor] = ACTIONS(1168),
    [anon_sym_BSLASHusepackage] = ACTIONS(1170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(1170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(1172),
    [anon_sym_BSLASHinclude] = ACTIONS(1174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(1174),
    [anon_sym_BSLASHinput] = ACTIONS(1174),
    [anon_sym_BSLASHsubfile] = ACTIONS(1174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(1176),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(1178),
    [anon_sym_BSLASHbibliography] = ACTIONS(1180),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(1182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(1184),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(1186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(1188),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(1188),
    [anon_sym_BSLASHimport] = ACTIONS(1190),
    [anon_sym_BSLASHsubimport] = ACTIONS(1190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(1190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(1190),
    [anon_sym_BSLASHcaption] = ACTIONS(1192),
    [anon_sym_BSLASHcite] = ACTIONS(1194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCite] = ACTIONS(1194),
    [anon_sym_BSLASHnocite] = ACTIONS(1194),
    [anon_sym_BSLASHcitet] = ACTIONS(1194),
    [anon_sym_BSLASHcitep] = ACTIONS(1194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteA] = ACTIONS(1194),
    [anon_sym_BSLASHciteR] = ACTIONS(1194),
    [anon_sym_BSLASHciteS] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(1194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(1194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteyear] = ACTIONS(1194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHcitedate] = ACTIONS(1194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHciteurl] = ACTIONS(1194),
    [anon_sym_BSLASHfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(1194),
    [anon_sym_BSLASHcitealt] = ACTIONS(1194),
    [anon_sym_BSLASHcitealp] = ACTIONS(1194),
    [anon_sym_BSLASHcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHparencite] = ACTIONS(1194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHParencite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(1194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(1194),
    [anon_sym_BSLASHtextcite] = ACTIONS(1194),
    [anon_sym_BSLASHTextcite] = ACTIONS(1194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(1194),
    [anon_sym_BSLASHsupercite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite] = ACTIONS(1194),
    [anon_sym_BSLASHAutocite] = ACTIONS(1194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(1196),
    [anon_sym_BSLASHvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHVolcite] = ACTIONS(1194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHavolcite] = ACTIONS(1194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(1194),
    [anon_sym_BSLASHnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHNotecite] = ACTIONS(1194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(1194),
    [anon_sym_BSLASHlabel] = ACTIONS(1198),
    [anon_sym_BSLASHref] = ACTIONS(1200),
    [anon_sym_BSLASHeqref] = ACTIONS(1200),
    [anon_sym_BSLASHvref] = ACTIONS(1200),
    [anon_sym_BSLASHVref] = ACTIONS(1200),
    [anon_sym_BSLASHautoref] = ACTIONS(1200),
    [anon_sym_BSLASHpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcref] = ACTIONS(1200),
    [anon_sym_BSLASHCref] = ACTIONS(1200),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(1202),
    [anon_sym_BSLASHnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnameCref] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(1200),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcref] = ACTIONS(1200),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(1200),
    [anon_sym_BSLASHcrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHCrefrange] = ACTIONS(1204),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(1206),
    [anon_sym_BSLASHnewlabel] = ACTIONS(1208),
    [anon_sym_BSLASHnewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(1210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(1212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(1210),
    [anon_sym_BSLASHdef] = ACTIONS(1214),
    [anon_sym_BSLASHlet] = ACTIONS(1216),
    [anon_sym_BSLASHleft] = ACTIONS(3846),
    [anon_sym_BSLASHbigl] = ACTIONS(3846),
    [anon_sym_BSLASHBigl] = ACTIONS(3846),
    [anon_sym_BSLASHbiggl] = ACTIONS(3846),
    [anon_sym_BSLASHBiggl] = ACTIONS(3846),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(1220),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(1220),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(1222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(1222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(1224),
    [anon_sym_BSLASHgls] = ACTIONS(1226),
    [anon_sym_BSLASHGls] = ACTIONS(1226),
    [anon_sym_BSLASHGLS] = ACTIONS(1226),
    [anon_sym_BSLASHglspl] = ACTIONS(1226),
    [anon_sym_BSLASHGlspl] = ACTIONS(1226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(1226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(1226),
    [anon_sym_BSLASHglslink] = ACTIONS(1226),
    [anon_sym_BSLASHglstext] = ACTIONS(1226),
    [anon_sym_BSLASHGlstext] = ACTIONS(1226),
    [anon_sym_BSLASHGLStext] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(1226),
    [anon_sym_BSLASHglsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(1226),
    [anon_sym_BSLASHglsname] = ACTIONS(1226),
    [anon_sym_BSLASHGlsname] = ACTIONS(1226),
    [anon_sym_BSLASHGLSname] = ACTIONS(1226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(1226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(1226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(1226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(1226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(1226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(1226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(1228),
    [anon_sym_BSLASHacrshort] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(1230),
    [anon_sym_BSLASHACRshort] = ACTIONS(1230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrlong] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(1230),
    [anon_sym_BSLASHACRlong] = ACTIONS(1230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(1230),
    [anon_sym_BSLASHacrfull] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(1230),
    [anon_sym_BSLASHACRfull] = ACTIONS(1230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHacs] = ACTIONS(1230),
    [anon_sym_BSLASHAcs] = ACTIONS(1230),
    [anon_sym_BSLASHacsp] = ACTIONS(1230),
    [anon_sym_BSLASHAcsp] = ACTIONS(1230),
    [anon_sym_BSLASHacl] = ACTIONS(1230),
    [anon_sym_BSLASHAcl] = ACTIONS(1230),
    [anon_sym_BSLASHaclp] = ACTIONS(1230),
    [anon_sym_BSLASHAclp] = ACTIONS(1230),
    [anon_sym_BSLASHacf] = ACTIONS(1230),
    [anon_sym_BSLASHAcf] = ACTIONS(1230),
    [anon_sym_BSLASHacfp] = ACTIONS(1230),
    [anon_sym_BSLASHAcfp] = ACTIONS(1230),
    [anon_sym_BSLASHac] = ACTIONS(1230),
    [anon_sym_BSLASHAc] = ACTIONS(1230),
    [anon_sym_BSLASHacp] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(1230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(1230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(1230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(1232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(1232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(1234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(1236),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(1238),
    [anon_sym_BSLASHcolor] = ACTIONS(1240),
    [anon_sym_BSLASHcolorbox] = ACTIONS(1240),
    [anon_sym_BSLASHtextcolor] = ACTIONS(1240),
    [anon_sym_BSLASHpagecolor] = ACTIONS(1240),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(1242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(1242),
    [anon_sym_BSLASHtext] = ACTIONS(3846),
    [anon_sym_BSLASHintertext] = ACTIONS(3846),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3846),
    [anon_sym_BSLASHurl] = ACTIONS(1246),
    [anon_sym_BSLASHhref] = ACTIONS(1246),
  },
  [265] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3411),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__comment_environment_name] = STATE(3409),
    [sym__verbatim_environment_name] = STATE(3408),
    [sym__listing_environment_name] = STATE(3390),
    [sym__minted_environment_name] = STATE(3382),
    [sym__pycode_environment_name] = STATE(3381),
    [sym__sagesilent_environment_name] = STATE(3380),
    [sym__sageblock_environment_name] = STATE(3378),
    [sym__math_environment_name] = STATE(3376),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_comment] = ACTIONS(4428),
    [anon_sym_verbatim] = ACTIONS(4430),
    [anon_sym_lstlisting] = ACTIONS(4432),
    [anon_sym_minted] = ACTIONS(4434),
    [anon_sym_pycode] = ACTIONS(4436),
    [anon_sym_sagesilent] = ACTIONS(4438),
    [anon_sym_sageblock] = ACTIONS(4440),
    [anon_sym_math] = ACTIONS(4442),
    [anon_sym_displaymath] = ACTIONS(4442),
    [anon_sym_displaymath_STAR] = ACTIONS(4444),
    [anon_sym_equation] = ACTIONS(4442),
    [anon_sym_equation_STAR] = ACTIONS(4444),
    [anon_sym_multline] = ACTIONS(4442),
    [anon_sym_multline_STAR] = ACTIONS(4444),
    [anon_sym_eqnarray] = ACTIONS(4442),
    [anon_sym_eqnarray_STAR] = ACTIONS(4444),
    [anon_sym_align] = ACTIONS(4442),
    [anon_sym_align_STAR] = ACTIONS(4444),
    [anon_sym_array] = ACTIONS(4442),
    [anon_sym_array_STAR] = ACTIONS(4444),
    [anon_sym_split] = ACTIONS(4442),
    [anon_sym_split_STAR] = ACTIONS(4444),
    [anon_sym_alignat] = ACTIONS(4442),
    [anon_sym_alignat_STAR] = ACTIONS(4444),
    [anon_sym_gather] = ACTIONS(4442),
    [anon_sym_gather_STAR] = ACTIONS(4444),
    [anon_sym_flalign] = ACTIONS(4442),
    [anon_sym_flalign_STAR] = ACTIONS(4444),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [266] = {
    [sym_block_comment] = STATE(273),
    [sym__text_content] = STATE(273),
    [sym_curly_group] = STATE(273),
    [sym_text] = STATE(273),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(273),
    [sym_inline_formula] = STATE(273),
    [sym__command] = STATE(273),
    [sym_generic_command] = STATE(273),
    [sym_title_declaration] = STATE(273),
    [sym_author_declaration] = STATE(273),
    [sym_package_include] = STATE(273),
    [sym_class_include] = STATE(273),
    [sym_latex_include] = STATE(273),
    [sym_biblatex_include] = STATE(273),
    [sym_bibstyle_include] = STATE(273),
    [sym_bibtex_include] = STATE(273),
    [sym_graphics_include] = STATE(273),
    [sym_svg_include] = STATE(273),
    [sym_inkscape_include] = STATE(273),
    [sym_verbatim_include] = STATE(273),
    [sym_import_include] = STATE(273),
    [sym_caption] = STATE(273),
    [sym_citation] = STATE(273),
    [sym_label_definition] = STATE(273),
    [sym_label_reference] = STATE(273),
    [sym_label_reference_range] = STATE(273),
    [sym_label_number] = STATE(273),
    [sym_new_command_definition] = STATE(273),
    [sym_old_command_definition] = STATE(273),
    [sym_let_command_definition] = STATE(273),
    [sym_math_delimiter] = STATE(273),
    [sym_paired_delimiter_definition] = STATE(273),
    [sym_environment_definition] = STATE(273),
    [sym_glossary_entry_definition] = STATE(273),
    [sym_glossary_entry_reference] = STATE(273),
    [sym_acronym_definition] = STATE(273),
    [sym_acronym_reference] = STATE(273),
    [sym_theorem_definition] = STATE(273),
    [sym_color_definition] = STATE(273),
    [sym_color_set_definition] = STATE(273),
    [sym_color_reference] = STATE(273),
    [sym_tikz_library_import] = STATE(273),
    [sym_text_mode] = STATE(273),
    [sym_hyperlink] = STATE(273),
    [aux_sym_curly_group_impl_repeat1] = STATE(273),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4528),
    [anon_sym_RBRACK] = ACTIONS(4528),
    [anon_sym_COMMA] = ACTIONS(4528),
    [anon_sym_EQ] = ACTIONS(4528),
    [anon_sym_LPAREN] = ACTIONS(4528),
    [anon_sym_RPAREN] = ACTIONS(4528),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [267] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [268] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4638),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [269] = {
    [sym_block_comment] = STATE(268),
    [sym__text_content] = STATE(268),
    [sym_curly_group] = STATE(268),
    [sym_text] = STATE(268),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(268),
    [sym_inline_formula] = STATE(268),
    [sym__command] = STATE(268),
    [sym_generic_command] = STATE(268),
    [sym_title_declaration] = STATE(268),
    [sym_author_declaration] = STATE(268),
    [sym_package_include] = STATE(268),
    [sym_class_include] = STATE(268),
    [sym_latex_include] = STATE(268),
    [sym_biblatex_include] = STATE(268),
    [sym_bibstyle_include] = STATE(268),
    [sym_bibtex_include] = STATE(268),
    [sym_graphics_include] = STATE(268),
    [sym_svg_include] = STATE(268),
    [sym_inkscape_include] = STATE(268),
    [sym_verbatim_include] = STATE(268),
    [sym_import_include] = STATE(268),
    [sym_caption] = STATE(268),
    [sym_citation] = STATE(268),
    [sym_label_definition] = STATE(268),
    [sym_label_reference] = STATE(268),
    [sym_label_reference_range] = STATE(268),
    [sym_label_number] = STATE(268),
    [sym_new_command_definition] = STATE(268),
    [sym_old_command_definition] = STATE(268),
    [sym_let_command_definition] = STATE(268),
    [sym_math_delimiter] = STATE(268),
    [sym_paired_delimiter_definition] = STATE(268),
    [sym_environment_definition] = STATE(268),
    [sym_glossary_entry_definition] = STATE(268),
    [sym_glossary_entry_reference] = STATE(268),
    [sym_acronym_definition] = STATE(268),
    [sym_acronym_reference] = STATE(268),
    [sym_theorem_definition] = STATE(268),
    [sym_color_definition] = STATE(268),
    [sym_color_set_definition] = STATE(268),
    [sym_color_reference] = STATE(268),
    [sym_tikz_library_import] = STATE(268),
    [sym_text_mode] = STATE(268),
    [sym_hyperlink] = STATE(268),
    [aux_sym_curly_group_impl_repeat1] = STATE(268),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_RBRACK] = ACTIONS(4640),
    [anon_sym_COMMA] = ACTIONS(4640),
    [anon_sym_EQ] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4642),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [270] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [271] = {
    [sym_block_comment] = STATE(278),
    [sym__text_content] = STATE(278),
    [sym_curly_group] = STATE(278),
    [sym_text] = STATE(278),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(278),
    [sym_inline_formula] = STATE(278),
    [sym__command] = STATE(278),
    [sym_generic_command] = STATE(278),
    [sym_title_declaration] = STATE(278),
    [sym_author_declaration] = STATE(278),
    [sym_package_include] = STATE(278),
    [sym_class_include] = STATE(278),
    [sym_latex_include] = STATE(278),
    [sym_biblatex_include] = STATE(278),
    [sym_bibstyle_include] = STATE(278),
    [sym_bibtex_include] = STATE(278),
    [sym_graphics_include] = STATE(278),
    [sym_svg_include] = STATE(278),
    [sym_inkscape_include] = STATE(278),
    [sym_verbatim_include] = STATE(278),
    [sym_import_include] = STATE(278),
    [sym_caption] = STATE(278),
    [sym_citation] = STATE(278),
    [sym_label_definition] = STATE(278),
    [sym_label_reference] = STATE(278),
    [sym_label_reference_range] = STATE(278),
    [sym_label_number] = STATE(278),
    [sym_new_command_definition] = STATE(278),
    [sym_old_command_definition] = STATE(278),
    [sym_let_command_definition] = STATE(278),
    [sym_math_delimiter] = STATE(278),
    [sym_paired_delimiter_definition] = STATE(278),
    [sym_environment_definition] = STATE(278),
    [sym_glossary_entry_definition] = STATE(278),
    [sym_glossary_entry_reference] = STATE(278),
    [sym_acronym_definition] = STATE(278),
    [sym_acronym_reference] = STATE(278),
    [sym_theorem_definition] = STATE(278),
    [sym_color_definition] = STATE(278),
    [sym_color_set_definition] = STATE(278),
    [sym_color_reference] = STATE(278),
    [sym_tikz_library_import] = STATE(278),
    [sym_text_mode] = STATE(278),
    [sym_hyperlink] = STATE(278),
    [aux_sym_curly_group_impl_repeat1] = STATE(278),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4646),
    [anon_sym_RBRACK] = ACTIONS(4646),
    [anon_sym_COMMA] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(4646),
    [anon_sym_LPAREN] = ACTIONS(4646),
    [anon_sym_RPAREN] = ACTIONS(4646),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4648),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [272] = {
    [sym_block_comment] = STATE(270),
    [sym__text_content] = STATE(270),
    [sym_curly_group] = STATE(270),
    [sym_text] = STATE(270),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(270),
    [sym_inline_formula] = STATE(270),
    [sym__command] = STATE(270),
    [sym_generic_command] = STATE(270),
    [sym_title_declaration] = STATE(270),
    [sym_author_declaration] = STATE(270),
    [sym_package_include] = STATE(270),
    [sym_class_include] = STATE(270),
    [sym_latex_include] = STATE(270),
    [sym_biblatex_include] = STATE(270),
    [sym_bibstyle_include] = STATE(270),
    [sym_bibtex_include] = STATE(270),
    [sym_graphics_include] = STATE(270),
    [sym_svg_include] = STATE(270),
    [sym_inkscape_include] = STATE(270),
    [sym_verbatim_include] = STATE(270),
    [sym_import_include] = STATE(270),
    [sym_caption] = STATE(270),
    [sym_citation] = STATE(270),
    [sym_label_definition] = STATE(270),
    [sym_label_reference] = STATE(270),
    [sym_label_reference_range] = STATE(270),
    [sym_label_number] = STATE(270),
    [sym_new_command_definition] = STATE(270),
    [sym_old_command_definition] = STATE(270),
    [sym_let_command_definition] = STATE(270),
    [sym_math_delimiter] = STATE(270),
    [sym_paired_delimiter_definition] = STATE(270),
    [sym_environment_definition] = STATE(270),
    [sym_glossary_entry_definition] = STATE(270),
    [sym_glossary_entry_reference] = STATE(270),
    [sym_acronym_definition] = STATE(270),
    [sym_acronym_reference] = STATE(270),
    [sym_theorem_definition] = STATE(270),
    [sym_color_definition] = STATE(270),
    [sym_color_set_definition] = STATE(270),
    [sym_color_reference] = STATE(270),
    [sym_tikz_library_import] = STATE(270),
    [sym_text_mode] = STATE(270),
    [sym_hyperlink] = STATE(270),
    [aux_sym_curly_group_impl_repeat1] = STATE(270),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4650),
    [anon_sym_RBRACK] = ACTIONS(4650),
    [anon_sym_COMMA] = ACTIONS(4650),
    [anon_sym_EQ] = ACTIONS(4650),
    [anon_sym_LPAREN] = ACTIONS(4650),
    [anon_sym_RPAREN] = ACTIONS(4650),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4652),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [273] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [274] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4656),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4659),
    [anon_sym_LBRACK] = ACTIONS(4662),
    [anon_sym_RBRACK] = ACTIONS(4662),
    [anon_sym_COMMA] = ACTIONS(4662),
    [anon_sym_EQ] = ACTIONS(4662),
    [anon_sym_LPAREN] = ACTIONS(4662),
    [anon_sym_RPAREN] = ACTIONS(4662),
    [anon_sym_LBRACE] = ACTIONS(4665),
    [anon_sym_RBRACE] = ACTIONS(4668),
    [sym_word] = ACTIONS(4670),
    [sym_placeholder] = ACTIONS(4673),
    [anon_sym_PLUS] = ACTIONS(4676),
    [anon_sym_DASH] = ACTIONS(4676),
    [anon_sym_STAR] = ACTIONS(4676),
    [anon_sym_SLASH] = ACTIONS(4676),
    [anon_sym_LT] = ACTIONS(4679),
    [anon_sym_GT] = ACTIONS(4679),
    [anon_sym_BANG] = ACTIONS(4679),
    [anon_sym_PIPE] = ACTIONS(4679),
    [anon_sym_COLON] = ACTIONS(4679),
    [anon_sym_SQUOTE] = ACTIONS(4679),
    [anon_sym__] = ACTIONS(4682),
    [anon_sym_CARET] = ACTIONS(4685),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4688),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4688),
    [anon_sym_DOLLAR] = ACTIONS(4691),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4694),
    [anon_sym_BSLASHtitle] = ACTIONS(4697),
    [anon_sym_BSLASHauthor] = ACTIONS(4700),
    [anon_sym_BSLASHusepackage] = ACTIONS(4703),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4703),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4706),
    [anon_sym_BSLASHinclude] = ACTIONS(4709),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4709),
    [anon_sym_BSLASHinput] = ACTIONS(4709),
    [anon_sym_BSLASHsubfile] = ACTIONS(4709),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4712),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4715),
    [anon_sym_BSLASHbibliography] = ACTIONS(4718),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4721),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4724),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4727),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4730),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4730),
    [anon_sym_BSLASHimport] = ACTIONS(4733),
    [anon_sym_BSLASHsubimport] = ACTIONS(4733),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4733),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4733),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4733),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4733),
    [anon_sym_BSLASHcaption] = ACTIONS(4736),
    [anon_sym_BSLASHcite] = ACTIONS(4739),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHCite] = ACTIONS(4739),
    [anon_sym_BSLASHnocite] = ACTIONS(4739),
    [anon_sym_BSLASHcitet] = ACTIONS(4739),
    [anon_sym_BSLASHcitep] = ACTIONS(4739),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHciteA] = ACTIONS(4739),
    [anon_sym_BSLASHciteR] = ACTIONS(4739),
    [anon_sym_BSLASHciteS] = ACTIONS(4739),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4739),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4739),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4739),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4739),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHciteyear] = ACTIONS(4739),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHcitedate] = ACTIONS(4739),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHciteurl] = ACTIONS(4739),
    [anon_sym_BSLASHfullcite] = ACTIONS(4739),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4739),
    [anon_sym_BSLASHcitealt] = ACTIONS(4739),
    [anon_sym_BSLASHcitealp] = ACTIONS(4739),
    [anon_sym_BSLASHcitetext] = ACTIONS(4739),
    [anon_sym_BSLASHparencite] = ACTIONS(4739),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHParencite] = ACTIONS(4739),
    [anon_sym_BSLASHfootcite] = ACTIONS(4739),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4739),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4739),
    [anon_sym_BSLASHtextcite] = ACTIONS(4739),
    [anon_sym_BSLASHTextcite] = ACTIONS(4739),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4739),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4739),
    [anon_sym_BSLASHsupercite] = ACTIONS(4739),
    [anon_sym_BSLASHautocite] = ACTIONS(4739),
    [anon_sym_BSLASHAutocite] = ACTIONS(4739),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4742),
    [anon_sym_BSLASHvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHVolcite] = ACTIONS(4739),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHavolcite] = ACTIONS(4739),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4739),
    [anon_sym_BSLASHnotecite] = ACTIONS(4739),
    [anon_sym_BSLASHNotecite] = ACTIONS(4739),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4739),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4739),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4739),
    [anon_sym_BSLASHlabel] = ACTIONS(4745),
    [anon_sym_BSLASHref] = ACTIONS(4748),
    [anon_sym_BSLASHeqref] = ACTIONS(4748),
    [anon_sym_BSLASHvref] = ACTIONS(4748),
    [anon_sym_BSLASHVref] = ACTIONS(4748),
    [anon_sym_BSLASHautoref] = ACTIONS(4748),
    [anon_sym_BSLASHpageref] = ACTIONS(4748),
    [anon_sym_BSLASHcref] = ACTIONS(4748),
    [anon_sym_BSLASHCref] = ACTIONS(4748),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4751),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4751),
    [anon_sym_BSLASHnamecref] = ACTIONS(4748),
    [anon_sym_BSLASHnameCref] = ACTIONS(4748),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4748),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4748),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4748),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4748),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4748),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4748),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4754),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4757),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4754),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4757),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4760),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4763),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4766),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4763),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4766),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4763),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4766),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4763),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4766),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4763),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4763),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4763),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4763),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4763),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4763),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4763),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4763),
    [anon_sym_BSLASHdef] = ACTIONS(4769),
    [anon_sym_BSLASHlet] = ACTIONS(4772),
    [anon_sym_BSLASHleft] = ACTIONS(4775),
    [anon_sym_BSLASHbigl] = ACTIONS(4775),
    [anon_sym_BSLASHBigl] = ACTIONS(4775),
    [anon_sym_BSLASHbiggl] = ACTIONS(4775),
    [anon_sym_BSLASHBiggl] = ACTIONS(4775),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4778),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4778),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4781),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4781),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4781),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4781),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4781),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4781),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4784),
    [anon_sym_BSLASHgls] = ACTIONS(4787),
    [anon_sym_BSLASHGls] = ACTIONS(4787),
    [anon_sym_BSLASHGLS] = ACTIONS(4787),
    [anon_sym_BSLASHglspl] = ACTIONS(4787),
    [anon_sym_BSLASHGlspl] = ACTIONS(4787),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4787),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4787),
    [anon_sym_BSLASHglslink] = ACTIONS(4787),
    [anon_sym_BSLASHglstext] = ACTIONS(4787),
    [anon_sym_BSLASHGlstext] = ACTIONS(4787),
    [anon_sym_BSLASHGLStext] = ACTIONS(4787),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4787),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4787),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4787),
    [anon_sym_BSLASHglsplural] = ACTIONS(4787),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4787),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4787),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4787),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4787),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4787),
    [anon_sym_BSLASHglsname] = ACTIONS(4787),
    [anon_sym_BSLASHGlsname] = ACTIONS(4787),
    [anon_sym_BSLASHGLSname] = ACTIONS(4787),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4787),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4787),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4787),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4787),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4787),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4787),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4787),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4787),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4787),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4787),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4787),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4787),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4787),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4787),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4787),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4787),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4787),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4787),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4787),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4787),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4787),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4787),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4787),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4790),
    [anon_sym_BSLASHacrshort] = ACTIONS(4793),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4793),
    [anon_sym_BSLASHACRshort] = ACTIONS(4793),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4793),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4793),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4793),
    [anon_sym_BSLASHacrlong] = ACTIONS(4793),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4793),
    [anon_sym_BSLASHACRlong] = ACTIONS(4793),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4793),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4793),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4793),
    [anon_sym_BSLASHacrfull] = ACTIONS(4793),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4793),
    [anon_sym_BSLASHACRfull] = ACTIONS(4793),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4793),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4793),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4793),
    [anon_sym_BSLASHacs] = ACTIONS(4793),
    [anon_sym_BSLASHAcs] = ACTIONS(4793),
    [anon_sym_BSLASHacsp] = ACTIONS(4793),
    [anon_sym_BSLASHAcsp] = ACTIONS(4793),
    [anon_sym_BSLASHacl] = ACTIONS(4793),
    [anon_sym_BSLASHAcl] = ACTIONS(4793),
    [anon_sym_BSLASHaclp] = ACTIONS(4793),
    [anon_sym_BSLASHAclp] = ACTIONS(4793),
    [anon_sym_BSLASHacf] = ACTIONS(4793),
    [anon_sym_BSLASHAcf] = ACTIONS(4793),
    [anon_sym_BSLASHacfp] = ACTIONS(4793),
    [anon_sym_BSLASHAcfp] = ACTIONS(4793),
    [anon_sym_BSLASHac] = ACTIONS(4793),
    [anon_sym_BSLASHAc] = ACTIONS(4793),
    [anon_sym_BSLASHacp] = ACTIONS(4793),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4793),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4793),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4793),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4793),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4793),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4793),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4793),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4793),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4793),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4793),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4796),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4799),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4796),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4799),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4802),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4805),
    [anon_sym_BSLASHcolor] = ACTIONS(4808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4811),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4811),
    [anon_sym_BSLASHtext] = ACTIONS(4814),
    [anon_sym_BSLASHintertext] = ACTIONS(4814),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4814),
    [anon_sym_BSLASHurl] = ACTIONS(4817),
    [anon_sym_BSLASHhref] = ACTIONS(4817),
  },
  [275] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [276] = {
    [sym_block_comment] = STATE(275),
    [sym__text_content] = STATE(275),
    [sym_curly_group] = STATE(275),
    [sym_text] = STATE(275),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(275),
    [sym_inline_formula] = STATE(275),
    [sym__command] = STATE(275),
    [sym_generic_command] = STATE(275),
    [sym_title_declaration] = STATE(275),
    [sym_author_declaration] = STATE(275),
    [sym_package_include] = STATE(275),
    [sym_class_include] = STATE(275),
    [sym_latex_include] = STATE(275),
    [sym_biblatex_include] = STATE(275),
    [sym_bibstyle_include] = STATE(275),
    [sym_bibtex_include] = STATE(275),
    [sym_graphics_include] = STATE(275),
    [sym_svg_include] = STATE(275),
    [sym_inkscape_include] = STATE(275),
    [sym_verbatim_include] = STATE(275),
    [sym_import_include] = STATE(275),
    [sym_caption] = STATE(275),
    [sym_citation] = STATE(275),
    [sym_label_definition] = STATE(275),
    [sym_label_reference] = STATE(275),
    [sym_label_reference_range] = STATE(275),
    [sym_label_number] = STATE(275),
    [sym_new_command_definition] = STATE(275),
    [sym_old_command_definition] = STATE(275),
    [sym_let_command_definition] = STATE(275),
    [sym_math_delimiter] = STATE(275),
    [sym_paired_delimiter_definition] = STATE(275),
    [sym_environment_definition] = STATE(275),
    [sym_glossary_entry_definition] = STATE(275),
    [sym_glossary_entry_reference] = STATE(275),
    [sym_acronym_definition] = STATE(275),
    [sym_acronym_reference] = STATE(275),
    [sym_theorem_definition] = STATE(275),
    [sym_color_definition] = STATE(275),
    [sym_color_set_definition] = STATE(275),
    [sym_color_reference] = STATE(275),
    [sym_tikz_library_import] = STATE(275),
    [sym_text_mode] = STATE(275),
    [sym_hyperlink] = STATE(275),
    [aux_sym_curly_group_impl_repeat1] = STATE(275),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4822),
    [anon_sym_RBRACK] = ACTIONS(4822),
    [anon_sym_COMMA] = ACTIONS(4822),
    [anon_sym_EQ] = ACTIONS(4822),
    [anon_sym_LPAREN] = ACTIONS(4822),
    [anon_sym_RPAREN] = ACTIONS(4822),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4824),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [277] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4826),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [278] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4828),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [279] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4830),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [280] = {
    [sym_block_comment] = STATE(277),
    [sym__text_content] = STATE(277),
    [sym_curly_group] = STATE(277),
    [sym_text] = STATE(277),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(277),
    [sym_inline_formula] = STATE(277),
    [sym__command] = STATE(277),
    [sym_generic_command] = STATE(277),
    [sym_title_declaration] = STATE(277),
    [sym_author_declaration] = STATE(277),
    [sym_package_include] = STATE(277),
    [sym_class_include] = STATE(277),
    [sym_latex_include] = STATE(277),
    [sym_biblatex_include] = STATE(277),
    [sym_bibstyle_include] = STATE(277),
    [sym_bibtex_include] = STATE(277),
    [sym_graphics_include] = STATE(277),
    [sym_svg_include] = STATE(277),
    [sym_inkscape_include] = STATE(277),
    [sym_verbatim_include] = STATE(277),
    [sym_import_include] = STATE(277),
    [sym_caption] = STATE(277),
    [sym_citation] = STATE(277),
    [sym_label_definition] = STATE(277),
    [sym_label_reference] = STATE(277),
    [sym_label_reference_range] = STATE(277),
    [sym_label_number] = STATE(277),
    [sym_new_command_definition] = STATE(277),
    [sym_old_command_definition] = STATE(277),
    [sym_let_command_definition] = STATE(277),
    [sym_math_delimiter] = STATE(277),
    [sym_paired_delimiter_definition] = STATE(277),
    [sym_environment_definition] = STATE(277),
    [sym_glossary_entry_definition] = STATE(277),
    [sym_glossary_entry_reference] = STATE(277),
    [sym_acronym_definition] = STATE(277),
    [sym_acronym_reference] = STATE(277),
    [sym_theorem_definition] = STATE(277),
    [sym_color_definition] = STATE(277),
    [sym_color_set_definition] = STATE(277),
    [sym_color_reference] = STATE(277),
    [sym_tikz_library_import] = STATE(277),
    [sym_text_mode] = STATE(277),
    [sym_hyperlink] = STATE(277),
    [aux_sym_curly_group_impl_repeat1] = STATE(277),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4832),
    [anon_sym_RBRACK] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4832),
    [anon_sym_EQ] = ACTIONS(4832),
    [anon_sym_LPAREN] = ACTIONS(4832),
    [anon_sym_RPAREN] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4834),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [281] = {
    [sym_block_comment] = STATE(282),
    [sym__text_content] = STATE(282),
    [sym_curly_group] = STATE(282),
    [sym_text] = STATE(282),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(282),
    [sym_inline_formula] = STATE(282),
    [sym__command] = STATE(282),
    [sym_generic_command] = STATE(282),
    [sym_title_declaration] = STATE(282),
    [sym_author_declaration] = STATE(282),
    [sym_package_include] = STATE(282),
    [sym_class_include] = STATE(282),
    [sym_latex_include] = STATE(282),
    [sym_biblatex_include] = STATE(282),
    [sym_bibstyle_include] = STATE(282),
    [sym_bibtex_include] = STATE(282),
    [sym_graphics_include] = STATE(282),
    [sym_svg_include] = STATE(282),
    [sym_inkscape_include] = STATE(282),
    [sym_verbatim_include] = STATE(282),
    [sym_import_include] = STATE(282),
    [sym_caption] = STATE(282),
    [sym_citation] = STATE(282),
    [sym_label_definition] = STATE(282),
    [sym_label_reference] = STATE(282),
    [sym_label_reference_range] = STATE(282),
    [sym_label_number] = STATE(282),
    [sym_new_command_definition] = STATE(282),
    [sym_old_command_definition] = STATE(282),
    [sym_let_command_definition] = STATE(282),
    [sym_math_delimiter] = STATE(282),
    [sym_paired_delimiter_definition] = STATE(282),
    [sym_environment_definition] = STATE(282),
    [sym_glossary_entry_definition] = STATE(282),
    [sym_glossary_entry_reference] = STATE(282),
    [sym_acronym_definition] = STATE(282),
    [sym_acronym_reference] = STATE(282),
    [sym_theorem_definition] = STATE(282),
    [sym_color_definition] = STATE(282),
    [sym_color_set_definition] = STATE(282),
    [sym_color_reference] = STATE(282),
    [sym_tikz_library_import] = STATE(282),
    [sym_text_mode] = STATE(282),
    [sym_hyperlink] = STATE(282),
    [aux_sym_curly_group_impl_repeat1] = STATE(282),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_RBRACK] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(4836),
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4838),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [282] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4840),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [283] = {
    [sym_block_comment] = STATE(279),
    [sym__text_content] = STATE(279),
    [sym_curly_group] = STATE(279),
    [sym_text] = STATE(279),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(279),
    [sym_inline_formula] = STATE(279),
    [sym__command] = STATE(279),
    [sym_generic_command] = STATE(279),
    [sym_title_declaration] = STATE(279),
    [sym_author_declaration] = STATE(279),
    [sym_package_include] = STATE(279),
    [sym_class_include] = STATE(279),
    [sym_latex_include] = STATE(279),
    [sym_biblatex_include] = STATE(279),
    [sym_bibstyle_include] = STATE(279),
    [sym_bibtex_include] = STATE(279),
    [sym_graphics_include] = STATE(279),
    [sym_svg_include] = STATE(279),
    [sym_inkscape_include] = STATE(279),
    [sym_verbatim_include] = STATE(279),
    [sym_import_include] = STATE(279),
    [sym_caption] = STATE(279),
    [sym_citation] = STATE(279),
    [sym_label_definition] = STATE(279),
    [sym_label_reference] = STATE(279),
    [sym_label_reference_range] = STATE(279),
    [sym_label_number] = STATE(279),
    [sym_new_command_definition] = STATE(279),
    [sym_old_command_definition] = STATE(279),
    [sym_let_command_definition] = STATE(279),
    [sym_math_delimiter] = STATE(279),
    [sym_paired_delimiter_definition] = STATE(279),
    [sym_environment_definition] = STATE(279),
    [sym_glossary_entry_definition] = STATE(279),
    [sym_glossary_entry_reference] = STATE(279),
    [sym_acronym_definition] = STATE(279),
    [sym_acronym_reference] = STATE(279),
    [sym_theorem_definition] = STATE(279),
    [sym_color_definition] = STATE(279),
    [sym_color_set_definition] = STATE(279),
    [sym_color_reference] = STATE(279),
    [sym_tikz_library_import] = STATE(279),
    [sym_text_mode] = STATE(279),
    [sym_hyperlink] = STATE(279),
    [aux_sym_curly_group_impl_repeat1] = STATE(279),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4842),
    [anon_sym_RBRACK] = ACTIONS(4842),
    [anon_sym_COMMA] = ACTIONS(4842),
    [anon_sym_EQ] = ACTIONS(4842),
    [anon_sym_LPAREN] = ACTIONS(4842),
    [anon_sym_RPAREN] = ACTIONS(4842),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4844),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [284] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4846),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [285] = {
    [sym_block_comment] = STATE(284),
    [sym__text_content] = STATE(284),
    [sym_curly_group] = STATE(284),
    [sym_text] = STATE(284),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(284),
    [sym_inline_formula] = STATE(284),
    [sym__command] = STATE(284),
    [sym_generic_command] = STATE(284),
    [sym_title_declaration] = STATE(284),
    [sym_author_declaration] = STATE(284),
    [sym_package_include] = STATE(284),
    [sym_class_include] = STATE(284),
    [sym_latex_include] = STATE(284),
    [sym_biblatex_include] = STATE(284),
    [sym_bibstyle_include] = STATE(284),
    [sym_bibtex_include] = STATE(284),
    [sym_graphics_include] = STATE(284),
    [sym_svg_include] = STATE(284),
    [sym_inkscape_include] = STATE(284),
    [sym_verbatim_include] = STATE(284),
    [sym_import_include] = STATE(284),
    [sym_caption] = STATE(284),
    [sym_citation] = STATE(284),
    [sym_label_definition] = STATE(284),
    [sym_label_reference] = STATE(284),
    [sym_label_reference_range] = STATE(284),
    [sym_label_number] = STATE(284),
    [sym_new_command_definition] = STATE(284),
    [sym_old_command_definition] = STATE(284),
    [sym_let_command_definition] = STATE(284),
    [sym_math_delimiter] = STATE(284),
    [sym_paired_delimiter_definition] = STATE(284),
    [sym_environment_definition] = STATE(284),
    [sym_glossary_entry_definition] = STATE(284),
    [sym_glossary_entry_reference] = STATE(284),
    [sym_acronym_definition] = STATE(284),
    [sym_acronym_reference] = STATE(284),
    [sym_theorem_definition] = STATE(284),
    [sym_color_definition] = STATE(284),
    [sym_color_set_definition] = STATE(284),
    [sym_color_reference] = STATE(284),
    [sym_tikz_library_import] = STATE(284),
    [sym_text_mode] = STATE(284),
    [sym_hyperlink] = STATE(284),
    [aux_sym_curly_group_impl_repeat1] = STATE(284),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4848),
    [anon_sym_RBRACK] = ACTIONS(4848),
    [anon_sym_COMMA] = ACTIONS(4848),
    [anon_sym_EQ] = ACTIONS(4848),
    [anon_sym_LPAREN] = ACTIONS(4848),
    [anon_sym_RPAREN] = ACTIONS(4848),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4850),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [286] = {
    [sym_block_comment] = STATE(267),
    [sym__text_content] = STATE(267),
    [sym_curly_group] = STATE(267),
    [sym_text] = STATE(267),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(267),
    [sym_inline_formula] = STATE(267),
    [sym__command] = STATE(267),
    [sym_generic_command] = STATE(267),
    [sym_title_declaration] = STATE(267),
    [sym_author_declaration] = STATE(267),
    [sym_package_include] = STATE(267),
    [sym_class_include] = STATE(267),
    [sym_latex_include] = STATE(267),
    [sym_biblatex_include] = STATE(267),
    [sym_bibstyle_include] = STATE(267),
    [sym_bibtex_include] = STATE(267),
    [sym_graphics_include] = STATE(267),
    [sym_svg_include] = STATE(267),
    [sym_inkscape_include] = STATE(267),
    [sym_verbatim_include] = STATE(267),
    [sym_import_include] = STATE(267),
    [sym_caption] = STATE(267),
    [sym_citation] = STATE(267),
    [sym_label_definition] = STATE(267),
    [sym_label_reference] = STATE(267),
    [sym_label_reference_range] = STATE(267),
    [sym_label_number] = STATE(267),
    [sym_new_command_definition] = STATE(267),
    [sym_old_command_definition] = STATE(267),
    [sym_let_command_definition] = STATE(267),
    [sym_math_delimiter] = STATE(267),
    [sym_paired_delimiter_definition] = STATE(267),
    [sym_environment_definition] = STATE(267),
    [sym_glossary_entry_definition] = STATE(267),
    [sym_glossary_entry_reference] = STATE(267),
    [sym_acronym_definition] = STATE(267),
    [sym_acronym_reference] = STATE(267),
    [sym_theorem_definition] = STATE(267),
    [sym_color_definition] = STATE(267),
    [sym_color_set_definition] = STATE(267),
    [sym_color_reference] = STATE(267),
    [sym_tikz_library_import] = STATE(267),
    [sym_text_mode] = STATE(267),
    [sym_hyperlink] = STATE(267),
    [aux_sym_curly_group_impl_repeat1] = STATE(267),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4852),
    [anon_sym_RBRACK] = ACTIONS(4852),
    [anon_sym_COMMA] = ACTIONS(4852),
    [anon_sym_EQ] = ACTIONS(4852),
    [anon_sym_LPAREN] = ACTIONS(4852),
    [anon_sym_RPAREN] = ACTIONS(4852),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4854),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [287] = {
    [sym_block_comment] = STATE(288),
    [sym__text_content] = STATE(288),
    [sym_curly_group] = STATE(288),
    [sym_text] = STATE(288),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(288),
    [sym_inline_formula] = STATE(288),
    [sym__command] = STATE(288),
    [sym_generic_command] = STATE(288),
    [sym_title_declaration] = STATE(288),
    [sym_author_declaration] = STATE(288),
    [sym_package_include] = STATE(288),
    [sym_class_include] = STATE(288),
    [sym_latex_include] = STATE(288),
    [sym_biblatex_include] = STATE(288),
    [sym_bibstyle_include] = STATE(288),
    [sym_bibtex_include] = STATE(288),
    [sym_graphics_include] = STATE(288),
    [sym_svg_include] = STATE(288),
    [sym_inkscape_include] = STATE(288),
    [sym_verbatim_include] = STATE(288),
    [sym_import_include] = STATE(288),
    [sym_caption] = STATE(288),
    [sym_citation] = STATE(288),
    [sym_label_definition] = STATE(288),
    [sym_label_reference] = STATE(288),
    [sym_label_reference_range] = STATE(288),
    [sym_label_number] = STATE(288),
    [sym_new_command_definition] = STATE(288),
    [sym_old_command_definition] = STATE(288),
    [sym_let_command_definition] = STATE(288),
    [sym_math_delimiter] = STATE(288),
    [sym_paired_delimiter_definition] = STATE(288),
    [sym_environment_definition] = STATE(288),
    [sym_glossary_entry_definition] = STATE(288),
    [sym_glossary_entry_reference] = STATE(288),
    [sym_acronym_definition] = STATE(288),
    [sym_acronym_reference] = STATE(288),
    [sym_theorem_definition] = STATE(288),
    [sym_color_definition] = STATE(288),
    [sym_color_set_definition] = STATE(288),
    [sym_color_reference] = STATE(288),
    [sym_tikz_library_import] = STATE(288),
    [sym_text_mode] = STATE(288),
    [sym_hyperlink] = STATE(288),
    [aux_sym_curly_group_impl_repeat1] = STATE(288),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4856),
    [anon_sym_RBRACK] = ACTIONS(4856),
    [anon_sym_COMMA] = ACTIONS(4856),
    [anon_sym_EQ] = ACTIONS(4856),
    [anon_sym_LPAREN] = ACTIONS(4856),
    [anon_sym_RPAREN] = ACTIONS(4856),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4858),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [288] = {
    [sym_block_comment] = STATE(274),
    [sym__text_content] = STATE(274),
    [sym_curly_group] = STATE(274),
    [sym_text] = STATE(274),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(274),
    [sym_inline_formula] = STATE(274),
    [sym__command] = STATE(274),
    [sym_generic_command] = STATE(274),
    [sym_title_declaration] = STATE(274),
    [sym_author_declaration] = STATE(274),
    [sym_package_include] = STATE(274),
    [sym_class_include] = STATE(274),
    [sym_latex_include] = STATE(274),
    [sym_biblatex_include] = STATE(274),
    [sym_bibstyle_include] = STATE(274),
    [sym_bibtex_include] = STATE(274),
    [sym_graphics_include] = STATE(274),
    [sym_svg_include] = STATE(274),
    [sym_inkscape_include] = STATE(274),
    [sym_verbatim_include] = STATE(274),
    [sym_import_include] = STATE(274),
    [sym_caption] = STATE(274),
    [sym_citation] = STATE(274),
    [sym_label_definition] = STATE(274),
    [sym_label_reference] = STATE(274),
    [sym_label_reference_range] = STATE(274),
    [sym_label_number] = STATE(274),
    [sym_new_command_definition] = STATE(274),
    [sym_old_command_definition] = STATE(274),
    [sym_let_command_definition] = STATE(274),
    [sym_math_delimiter] = STATE(274),
    [sym_paired_delimiter_definition] = STATE(274),
    [sym_environment_definition] = STATE(274),
    [sym_glossary_entry_definition] = STATE(274),
    [sym_glossary_entry_reference] = STATE(274),
    [sym_acronym_definition] = STATE(274),
    [sym_acronym_reference] = STATE(274),
    [sym_theorem_definition] = STATE(274),
    [sym_color_definition] = STATE(274),
    [sym_color_set_definition] = STATE(274),
    [sym_color_reference] = STATE(274),
    [sym_tikz_library_import] = STATE(274),
    [sym_text_mode] = STATE(274),
    [sym_hyperlink] = STATE(274),
    [aux_sym_curly_group_impl_repeat1] = STATE(274),
    [aux_sym_text_repeat1] = STATE(320),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(4634),
    [anon_sym_RBRACK] = ACTIONS(4634),
    [anon_sym_COMMA] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4634),
    [anon_sym_RPAREN] = ACTIONS(4634),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4546),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4550),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [289] = {
    [sym_block_comment] = STATE(289),
    [sym__text_content] = STATE(289),
    [sym_curly_group] = STATE(289),
    [sym_brack_group] = STATE(289),
    [sym_text] = STATE(289),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(289),
    [sym_inline_formula] = STATE(289),
    [sym__command] = STATE(289),
    [sym_generic_command] = STATE(289),
    [sym_title_declaration] = STATE(289),
    [sym_author_declaration] = STATE(289),
    [sym_package_include] = STATE(289),
    [sym_class_include] = STATE(289),
    [sym_latex_include] = STATE(289),
    [sym_biblatex_include] = STATE(289),
    [sym_bibstyle_include] = STATE(289),
    [sym_bibtex_include] = STATE(289),
    [sym_graphics_include] = STATE(289),
    [sym_svg_include] = STATE(289),
    [sym_inkscape_include] = STATE(289),
    [sym_verbatim_include] = STATE(289),
    [sym_import_include] = STATE(289),
    [sym_caption] = STATE(289),
    [sym_citation] = STATE(289),
    [sym_label_definition] = STATE(289),
    [sym_label_reference] = STATE(289),
    [sym_label_reference_range] = STATE(289),
    [sym_label_number] = STATE(289),
    [sym_new_command_definition] = STATE(289),
    [sym_old_command_definition] = STATE(289),
    [sym_let_command_definition] = STATE(289),
    [sym_math_delimiter] = STATE(289),
    [sym_paired_delimiter_definition] = STATE(289),
    [sym_environment_definition] = STATE(289),
    [sym_glossary_entry_definition] = STATE(289),
    [sym_glossary_entry_reference] = STATE(289),
    [sym_acronym_definition] = STATE(289),
    [sym_acronym_reference] = STATE(289),
    [sym_theorem_definition] = STATE(289),
    [sym_color_definition] = STATE(289),
    [sym_color_set_definition] = STATE(289),
    [sym_color_reference] = STATE(289),
    [sym_tikz_library_import] = STATE(289),
    [sym_text_mode] = STATE(289),
    [sym_hyperlink] = STATE(289),
    [aux_sym_text_repeat1] = STATE(320),
    [aux_sym_value_repeat1] = STATE(289),
    [sym_command_name] = ACTIONS(4862),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4865),
    [anon_sym_LBRACK] = ACTIONS(4868),
    [anon_sym_RBRACK] = ACTIONS(4871),
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4873),
    [anon_sym_RPAREN] = ACTIONS(4873),
    [anon_sym_LBRACE] = ACTIONS(4876),
    [sym_word] = ACTIONS(4879),
    [sym_placeholder] = ACTIONS(4882),
    [anon_sym_PLUS] = ACTIONS(4885),
    [anon_sym_DASH] = ACTIONS(4885),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_SLASH] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4888),
    [anon_sym_GT] = ACTIONS(4888),
    [anon_sym_BANG] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4888),
    [anon_sym_COLON] = ACTIONS(4888),
    [anon_sym_SQUOTE] = ACTIONS(4888),
    [anon_sym__] = ACTIONS(4891),
    [anon_sym_CARET] = ACTIONS(4894),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(4897),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(4897),
    [anon_sym_DOLLAR] = ACTIONS(4900),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(4903),
    [anon_sym_BSLASHtitle] = ACTIONS(4906),
    [anon_sym_BSLASHauthor] = ACTIONS(4909),
    [anon_sym_BSLASHusepackage] = ACTIONS(4912),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4912),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4915),
    [anon_sym_BSLASHinclude] = ACTIONS(4918),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4918),
    [anon_sym_BSLASHinput] = ACTIONS(4918),
    [anon_sym_BSLASHsubfile] = ACTIONS(4918),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4921),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4924),
    [anon_sym_BSLASHbibliography] = ACTIONS(4927),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4930),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4933),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4936),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4939),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4939),
    [anon_sym_BSLASHimport] = ACTIONS(4942),
    [anon_sym_BSLASHsubimport] = ACTIONS(4942),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4942),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4942),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4942),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4942),
    [anon_sym_BSLASHcaption] = ACTIONS(4945),
    [anon_sym_BSLASHcite] = ACTIONS(4948),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHCite] = ACTIONS(4948),
    [anon_sym_BSLASHnocite] = ACTIONS(4948),
    [anon_sym_BSLASHcitet] = ACTIONS(4948),
    [anon_sym_BSLASHcitep] = ACTIONS(4948),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHciteA] = ACTIONS(4948),
    [anon_sym_BSLASHciteR] = ACTIONS(4948),
    [anon_sym_BSLASHciteS] = ACTIONS(4948),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4948),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4948),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4948),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4948),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHciteyear] = ACTIONS(4948),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHcitedate] = ACTIONS(4948),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHciteurl] = ACTIONS(4948),
    [anon_sym_BSLASHfullcite] = ACTIONS(4948),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4948),
    [anon_sym_BSLASHcitealt] = ACTIONS(4948),
    [anon_sym_BSLASHcitealp] = ACTIONS(4948),
    [anon_sym_BSLASHcitetext] = ACTIONS(4948),
    [anon_sym_BSLASHparencite] = ACTIONS(4948),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHParencite] = ACTIONS(4948),
    [anon_sym_BSLASHfootcite] = ACTIONS(4948),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4948),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4948),
    [anon_sym_BSLASHtextcite] = ACTIONS(4948),
    [anon_sym_BSLASHTextcite] = ACTIONS(4948),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4948),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4948),
    [anon_sym_BSLASHsupercite] = ACTIONS(4948),
    [anon_sym_BSLASHautocite] = ACTIONS(4948),
    [anon_sym_BSLASHAutocite] = ACTIONS(4948),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHVolcite] = ACTIONS(4948),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHavolcite] = ACTIONS(4948),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHnotecite] = ACTIONS(4948),
    [anon_sym_BSLASHNotecite] = ACTIONS(4948),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4948),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4948),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4948),
    [anon_sym_BSLASHlabel] = ACTIONS(4954),
    [anon_sym_BSLASHref] = ACTIONS(4957),
    [anon_sym_BSLASHeqref] = ACTIONS(4957),
    [anon_sym_BSLASHvref] = ACTIONS(4957),
    [anon_sym_BSLASHVref] = ACTIONS(4957),
    [anon_sym_BSLASHautoref] = ACTIONS(4957),
    [anon_sym_BSLASHpageref] = ACTIONS(4957),
    [anon_sym_BSLASHcref] = ACTIONS(4957),
    [anon_sym_BSLASHCref] = ACTIONS(4957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4960),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4960),
    [anon_sym_BSLASHnamecref] = ACTIONS(4957),
    [anon_sym_BSLASHnameCref] = ACTIONS(4957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4963),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4966),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4963),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4966),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4969),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4972),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4975),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4972),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4975),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4972),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4975),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4972),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4975),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHdef] = ACTIONS(4978),
    [anon_sym_BSLASHlet] = ACTIONS(4981),
    [anon_sym_BSLASHleft] = ACTIONS(4984),
    [anon_sym_BSLASHbigl] = ACTIONS(4984),
    [anon_sym_BSLASHBigl] = ACTIONS(4984),
    [anon_sym_BSLASHbiggl] = ACTIONS(4984),
    [anon_sym_BSLASHBiggl] = ACTIONS(4984),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4987),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4987),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4990),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4990),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4990),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4990),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4990),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4990),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4993),
    [anon_sym_BSLASHgls] = ACTIONS(4996),
    [anon_sym_BSLASHGls] = ACTIONS(4996),
    [anon_sym_BSLASHGLS] = ACTIONS(4996),
    [anon_sym_BSLASHglspl] = ACTIONS(4996),
    [anon_sym_BSLASHGlspl] = ACTIONS(4996),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4996),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4996),
    [anon_sym_BSLASHglslink] = ACTIONS(4996),
    [anon_sym_BSLASHglstext] = ACTIONS(4996),
    [anon_sym_BSLASHGlstext] = ACTIONS(4996),
    [anon_sym_BSLASHGLStext] = ACTIONS(4996),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4996),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4996),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4996),
    [anon_sym_BSLASHglsplural] = ACTIONS(4996),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4996),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4996),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4996),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4996),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4996),
    [anon_sym_BSLASHglsname] = ACTIONS(4996),
    [anon_sym_BSLASHGlsname] = ACTIONS(4996),
    [anon_sym_BSLASHGLSname] = ACTIONS(4996),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4996),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4996),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4996),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4996),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4996),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4996),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4996),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4996),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4996),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4996),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4996),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4999),
    [anon_sym_BSLASHacrshort] = ACTIONS(5002),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5002),
    [anon_sym_BSLASHACRshort] = ACTIONS(5002),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHacrlong] = ACTIONS(5002),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5002),
    [anon_sym_BSLASHACRlong] = ACTIONS(5002),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5002),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5002),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5002),
    [anon_sym_BSLASHacrfull] = ACTIONS(5002),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5002),
    [anon_sym_BSLASHACRfull] = ACTIONS(5002),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHacs] = ACTIONS(5002),
    [anon_sym_BSLASHAcs] = ACTIONS(5002),
    [anon_sym_BSLASHacsp] = ACTIONS(5002),
    [anon_sym_BSLASHAcsp] = ACTIONS(5002),
    [anon_sym_BSLASHacl] = ACTIONS(5002),
    [anon_sym_BSLASHAcl] = ACTIONS(5002),
    [anon_sym_BSLASHaclp] = ACTIONS(5002),
    [anon_sym_BSLASHAclp] = ACTIONS(5002),
    [anon_sym_BSLASHacf] = ACTIONS(5002),
    [anon_sym_BSLASHAcf] = ACTIONS(5002),
    [anon_sym_BSLASHacfp] = ACTIONS(5002),
    [anon_sym_BSLASHAcfp] = ACTIONS(5002),
    [anon_sym_BSLASHac] = ACTIONS(5002),
    [anon_sym_BSLASHAc] = ACTIONS(5002),
    [anon_sym_BSLASHacp] = ACTIONS(5002),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5002),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5002),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5002),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5005),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5008),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5005),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5008),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5011),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5014),
    [anon_sym_BSLASHcolor] = ACTIONS(5017),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5017),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5017),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5017),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5020),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5020),
    [anon_sym_BSLASHtext] = ACTIONS(5023),
    [anon_sym_BSLASHintertext] = ACTIONS(5023),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5023),
    [anon_sym_BSLASHurl] = ACTIONS(5026),
    [anon_sym_BSLASHhref] = ACTIONS(5026),
  },
  [290] = {
    [sym_block_comment] = STATE(290),
    [sym__text_content] = STATE(290),
    [sym_curly_group] = STATE(290),
    [sym_brack_group] = STATE(290),
    [sym_text] = STATE(290),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(290),
    [sym_inline_formula] = STATE(290),
    [sym__command] = STATE(290),
    [sym_generic_command] = STATE(290),
    [sym_title_declaration] = STATE(290),
    [sym_author_declaration] = STATE(290),
    [sym_package_include] = STATE(290),
    [sym_class_include] = STATE(290),
    [sym_latex_include] = STATE(290),
    [sym_biblatex_include] = STATE(290),
    [sym_bibstyle_include] = STATE(290),
    [sym_bibtex_include] = STATE(290),
    [sym_graphics_include] = STATE(290),
    [sym_svg_include] = STATE(290),
    [sym_inkscape_include] = STATE(290),
    [sym_verbatim_include] = STATE(290),
    [sym_import_include] = STATE(290),
    [sym_caption] = STATE(290),
    [sym_citation] = STATE(290),
    [sym_label_definition] = STATE(290),
    [sym_label_reference] = STATE(290),
    [sym_label_reference_range] = STATE(290),
    [sym_label_number] = STATE(290),
    [sym_new_command_definition] = STATE(290),
    [sym_old_command_definition] = STATE(290),
    [sym_let_command_definition] = STATE(290),
    [sym_math_delimiter] = STATE(290),
    [sym_paired_delimiter_definition] = STATE(290),
    [sym_environment_definition] = STATE(290),
    [sym_glossary_entry_definition] = STATE(290),
    [sym_glossary_entry_reference] = STATE(290),
    [sym_acronym_definition] = STATE(290),
    [sym_acronym_reference] = STATE(290),
    [sym_theorem_definition] = STATE(290),
    [sym_color_definition] = STATE(290),
    [sym_color_set_definition] = STATE(290),
    [sym_color_reference] = STATE(290),
    [sym_tikz_library_import] = STATE(290),
    [sym_text_mode] = STATE(290),
    [sym_hyperlink] = STATE(290),
    [aux_sym_text_repeat1] = STATE(320),
    [aux_sym_value_repeat1] = STATE(290),
    [sym_command_name] = ACTIONS(4862),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4865),
    [anon_sym_LBRACK] = ACTIONS(4868),
    [anon_sym_COMMA] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(5029),
    [anon_sym_RPAREN] = ACTIONS(5029),
    [anon_sym_LBRACE] = ACTIONS(4876),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [sym_word] = ACTIONS(4879),
    [sym_placeholder] = ACTIONS(4882),
    [anon_sym_PLUS] = ACTIONS(4885),
    [anon_sym_DASH] = ACTIONS(4885),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_SLASH] = ACTIONS(4885),
    [anon_sym_LT] = ACTIONS(4888),
    [anon_sym_GT] = ACTIONS(4888),
    [anon_sym_BANG] = ACTIONS(4888),
    [anon_sym_PIPE] = ACTIONS(4888),
    [anon_sym_COLON] = ACTIONS(4888),
    [anon_sym_SQUOTE] = ACTIONS(4888),
    [anon_sym__] = ACTIONS(4891),
    [anon_sym_CARET] = ACTIONS(4894),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5032),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5032),
    [anon_sym_DOLLAR] = ACTIONS(5035),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5038),
    [anon_sym_BSLASHtitle] = ACTIONS(4906),
    [anon_sym_BSLASHauthor] = ACTIONS(4909),
    [anon_sym_BSLASHusepackage] = ACTIONS(4912),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4912),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4915),
    [anon_sym_BSLASHinclude] = ACTIONS(4918),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4918),
    [anon_sym_BSLASHinput] = ACTIONS(4918),
    [anon_sym_BSLASHsubfile] = ACTIONS(4918),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4921),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4924),
    [anon_sym_BSLASHbibliography] = ACTIONS(4927),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4930),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4933),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4936),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4939),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4939),
    [anon_sym_BSLASHimport] = ACTIONS(4942),
    [anon_sym_BSLASHsubimport] = ACTIONS(4942),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4942),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4942),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4942),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4942),
    [anon_sym_BSLASHcaption] = ACTIONS(4945),
    [anon_sym_BSLASHcite] = ACTIONS(4948),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHCite] = ACTIONS(4948),
    [anon_sym_BSLASHnocite] = ACTIONS(4948),
    [anon_sym_BSLASHcitet] = ACTIONS(4948),
    [anon_sym_BSLASHcitep] = ACTIONS(4948),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHciteA] = ACTIONS(4948),
    [anon_sym_BSLASHciteR] = ACTIONS(4948),
    [anon_sym_BSLASHciteS] = ACTIONS(4948),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4948),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4948),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4948),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4948),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHciteyear] = ACTIONS(4948),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHcitedate] = ACTIONS(4948),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHciteurl] = ACTIONS(4948),
    [anon_sym_BSLASHfullcite] = ACTIONS(4948),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4948),
    [anon_sym_BSLASHcitealt] = ACTIONS(4948),
    [anon_sym_BSLASHcitealp] = ACTIONS(4948),
    [anon_sym_BSLASHcitetext] = ACTIONS(4948),
    [anon_sym_BSLASHparencite] = ACTIONS(4948),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHParencite] = ACTIONS(4948),
    [anon_sym_BSLASHfootcite] = ACTIONS(4948),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4948),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4948),
    [anon_sym_BSLASHtextcite] = ACTIONS(4948),
    [anon_sym_BSLASHTextcite] = ACTIONS(4948),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4948),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4948),
    [anon_sym_BSLASHsupercite] = ACTIONS(4948),
    [anon_sym_BSLASHautocite] = ACTIONS(4948),
    [anon_sym_BSLASHAutocite] = ACTIONS(4948),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4951),
    [anon_sym_BSLASHvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHVolcite] = ACTIONS(4948),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHavolcite] = ACTIONS(4948),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4948),
    [anon_sym_BSLASHnotecite] = ACTIONS(4948),
    [anon_sym_BSLASHNotecite] = ACTIONS(4948),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4948),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4948),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4948),
    [anon_sym_BSLASHlabel] = ACTIONS(4954),
    [anon_sym_BSLASHref] = ACTIONS(4957),
    [anon_sym_BSLASHeqref] = ACTIONS(4957),
    [anon_sym_BSLASHvref] = ACTIONS(4957),
    [anon_sym_BSLASHVref] = ACTIONS(4957),
    [anon_sym_BSLASHautoref] = ACTIONS(4957),
    [anon_sym_BSLASHpageref] = ACTIONS(4957),
    [anon_sym_BSLASHcref] = ACTIONS(4957),
    [anon_sym_BSLASHCref] = ACTIONS(4957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4960),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4960),
    [anon_sym_BSLASHnamecref] = ACTIONS(4957),
    [anon_sym_BSLASHnameCref] = ACTIONS(4957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4963),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4966),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4963),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4966),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4969),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4972),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4975),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4972),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4975),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4972),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4975),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4972),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4975),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4972),
    [anon_sym_BSLASHdef] = ACTIONS(4978),
    [anon_sym_BSLASHlet] = ACTIONS(4981),
    [anon_sym_BSLASHleft] = ACTIONS(4984),
    [anon_sym_BSLASHbigl] = ACTIONS(4984),
    [anon_sym_BSLASHBigl] = ACTIONS(4984),
    [anon_sym_BSLASHbiggl] = ACTIONS(4984),
    [anon_sym_BSLASHBiggl] = ACTIONS(4984),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4987),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4987),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4990),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4990),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4990),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4990),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4990),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4990),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4993),
    [anon_sym_BSLASHgls] = ACTIONS(4996),
    [anon_sym_BSLASHGls] = ACTIONS(4996),
    [anon_sym_BSLASHGLS] = ACTIONS(4996),
    [anon_sym_BSLASHglspl] = ACTIONS(4996),
    [anon_sym_BSLASHGlspl] = ACTIONS(4996),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4996),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4996),
    [anon_sym_BSLASHglslink] = ACTIONS(4996),
    [anon_sym_BSLASHglstext] = ACTIONS(4996),
    [anon_sym_BSLASHGlstext] = ACTIONS(4996),
    [anon_sym_BSLASHGLStext] = ACTIONS(4996),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4996),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4996),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4996),
    [anon_sym_BSLASHglsplural] = ACTIONS(4996),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4996),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4996),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4996),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4996),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4996),
    [anon_sym_BSLASHglsname] = ACTIONS(4996),
    [anon_sym_BSLASHGlsname] = ACTIONS(4996),
    [anon_sym_BSLASHGLSname] = ACTIONS(4996),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4996),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4996),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4996),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4996),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4996),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4996),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4996),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4996),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4996),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4996),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4996),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4996),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4996),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4999),
    [anon_sym_BSLASHacrshort] = ACTIONS(5002),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5002),
    [anon_sym_BSLASHACRshort] = ACTIONS(5002),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHacrlong] = ACTIONS(5002),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5002),
    [anon_sym_BSLASHACRlong] = ACTIONS(5002),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5002),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5002),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5002),
    [anon_sym_BSLASHacrfull] = ACTIONS(5002),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5002),
    [anon_sym_BSLASHACRfull] = ACTIONS(5002),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHacs] = ACTIONS(5002),
    [anon_sym_BSLASHAcs] = ACTIONS(5002),
    [anon_sym_BSLASHacsp] = ACTIONS(5002),
    [anon_sym_BSLASHAcsp] = ACTIONS(5002),
    [anon_sym_BSLASHacl] = ACTIONS(5002),
    [anon_sym_BSLASHAcl] = ACTIONS(5002),
    [anon_sym_BSLASHaclp] = ACTIONS(5002),
    [anon_sym_BSLASHAclp] = ACTIONS(5002),
    [anon_sym_BSLASHacf] = ACTIONS(5002),
    [anon_sym_BSLASHAcf] = ACTIONS(5002),
    [anon_sym_BSLASHacfp] = ACTIONS(5002),
    [anon_sym_BSLASHAcfp] = ACTIONS(5002),
    [anon_sym_BSLASHac] = ACTIONS(5002),
    [anon_sym_BSLASHAc] = ACTIONS(5002),
    [anon_sym_BSLASHacp] = ACTIONS(5002),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5002),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5002),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5002),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5002),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5002),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5005),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5008),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5005),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5008),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5011),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5014),
    [anon_sym_BSLASHcolor] = ACTIONS(5017),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5017),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5017),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5017),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5020),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5020),
    [anon_sym_BSLASHtext] = ACTIONS(5023),
    [anon_sym_BSLASHintertext] = ACTIONS(5023),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5023),
    [anon_sym_BSLASHurl] = ACTIONS(5026),
    [anon_sym_BSLASHhref] = ACTIONS(5026),
  },
  [291] = {
    [sym_block_comment] = STATE(289),
    [sym__text_content] = STATE(289),
    [sym_curly_group] = STATE(289),
    [sym_brack_group] = STATE(289),
    [sym_text] = STATE(289),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(289),
    [sym_inline_formula] = STATE(289),
    [sym__command] = STATE(289),
    [sym_generic_command] = STATE(289),
    [sym_title_declaration] = STATE(289),
    [sym_author_declaration] = STATE(289),
    [sym_package_include] = STATE(289),
    [sym_class_include] = STATE(289),
    [sym_latex_include] = STATE(289),
    [sym_biblatex_include] = STATE(289),
    [sym_bibstyle_include] = STATE(289),
    [sym_bibtex_include] = STATE(289),
    [sym_graphics_include] = STATE(289),
    [sym_svg_include] = STATE(289),
    [sym_inkscape_include] = STATE(289),
    [sym_verbatim_include] = STATE(289),
    [sym_import_include] = STATE(289),
    [sym_caption] = STATE(289),
    [sym_citation] = STATE(289),
    [sym_label_definition] = STATE(289),
    [sym_label_reference] = STATE(289),
    [sym_label_reference_range] = STATE(289),
    [sym_label_number] = STATE(289),
    [sym_new_command_definition] = STATE(289),
    [sym_old_command_definition] = STATE(289),
    [sym_let_command_definition] = STATE(289),
    [sym_math_delimiter] = STATE(289),
    [sym_paired_delimiter_definition] = STATE(289),
    [sym_environment_definition] = STATE(289),
    [sym_glossary_entry_definition] = STATE(289),
    [sym_glossary_entry_reference] = STATE(289),
    [sym_acronym_definition] = STATE(289),
    [sym_acronym_reference] = STATE(289),
    [sym_theorem_definition] = STATE(289),
    [sym_color_definition] = STATE(289),
    [sym_color_set_definition] = STATE(289),
    [sym_color_reference] = STATE(289),
    [sym_tikz_library_import] = STATE(289),
    [sym_text_mode] = STATE(289),
    [sym_hyperlink] = STATE(289),
    [aux_sym_text_repeat1] = STATE(320),
    [aux_sym_value_repeat1] = STATE(289),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(5041),
    [anon_sym_RBRACK] = ACTIONS(5043),
    [anon_sym_COMMA] = ACTIONS(5043),
    [anon_sym_LPAREN] = ACTIONS(5045),
    [anon_sym_RPAREN] = ACTIONS(5045),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5047),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5047),
    [anon_sym_DOLLAR] = ACTIONS(5049),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5051),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [292] = {
    [sym_block_comment] = STATE(290),
    [sym__text_content] = STATE(290),
    [sym_curly_group] = STATE(290),
    [sym_brack_group] = STATE(290),
    [sym_text] = STATE(290),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_displayed_equation] = STATE(290),
    [sym_inline_formula] = STATE(290),
    [sym__command] = STATE(290),
    [sym_generic_command] = STATE(290),
    [sym_title_declaration] = STATE(290),
    [sym_author_declaration] = STATE(290),
    [sym_package_include] = STATE(290),
    [sym_class_include] = STATE(290),
    [sym_latex_include] = STATE(290),
    [sym_biblatex_include] = STATE(290),
    [sym_bibstyle_include] = STATE(290),
    [sym_bibtex_include] = STATE(290),
    [sym_graphics_include] = STATE(290),
    [sym_svg_include] = STATE(290),
    [sym_inkscape_include] = STATE(290),
    [sym_verbatim_include] = STATE(290),
    [sym_import_include] = STATE(290),
    [sym_caption] = STATE(290),
    [sym_citation] = STATE(290),
    [sym_label_definition] = STATE(290),
    [sym_label_reference] = STATE(290),
    [sym_label_reference_range] = STATE(290),
    [sym_label_number] = STATE(290),
    [sym_new_command_definition] = STATE(290),
    [sym_old_command_definition] = STATE(290),
    [sym_let_command_definition] = STATE(290),
    [sym_math_delimiter] = STATE(290),
    [sym_paired_delimiter_definition] = STATE(290),
    [sym_environment_definition] = STATE(290),
    [sym_glossary_entry_definition] = STATE(290),
    [sym_glossary_entry_reference] = STATE(290),
    [sym_acronym_definition] = STATE(290),
    [sym_acronym_reference] = STATE(290),
    [sym_theorem_definition] = STATE(290),
    [sym_color_definition] = STATE(290),
    [sym_color_set_definition] = STATE(290),
    [sym_color_reference] = STATE(290),
    [sym_tikz_library_import] = STATE(290),
    [sym_text_mode] = STATE(290),
    [sym_hyperlink] = STATE(290),
    [aux_sym_text_repeat1] = STATE(320),
    [aux_sym_value_repeat1] = STATE(290),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(5041),
    [anon_sym_COMMA] = ACTIONS(5043),
    [anon_sym_LPAREN] = ACTIONS(5053),
    [anon_sym_RPAREN] = ACTIONS(5053),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(5043),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5055),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5055),
    [anon_sym_DOLLAR] = ACTIONS(5057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5059),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [293] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2377),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5069),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [294] = {
    [sym_block_comment] = STATE(291),
    [sym__text_content] = STATE(291),
    [sym_curly_group] = STATE(291),
    [sym_brack_group] = STATE(291),
    [sym_text] = STATE(291),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_value] = STATE(2370),
    [sym_displayed_equation] = STATE(291),
    [sym_inline_formula] = STATE(291),
    [sym__command] = STATE(291),
    [sym_generic_command] = STATE(291),
    [sym_title_declaration] = STATE(291),
    [sym_author_declaration] = STATE(291),
    [sym_package_include] = STATE(291),
    [sym_class_include] = STATE(291),
    [sym_latex_include] = STATE(291),
    [sym_biblatex_include] = STATE(291),
    [sym_bibstyle_include] = STATE(291),
    [sym_bibtex_include] = STATE(291),
    [sym_graphics_include] = STATE(291),
    [sym_svg_include] = STATE(291),
    [sym_inkscape_include] = STATE(291),
    [sym_verbatim_include] = STATE(291),
    [sym_import_include] = STATE(291),
    [sym_caption] = STATE(291),
    [sym_citation] = STATE(291),
    [sym_label_definition] = STATE(291),
    [sym_label_reference] = STATE(291),
    [sym_label_reference_range] = STATE(291),
    [sym_label_number] = STATE(291),
    [sym_new_command_definition] = STATE(291),
    [sym_old_command_definition] = STATE(291),
    [sym_let_command_definition] = STATE(291),
    [sym_math_delimiter] = STATE(291),
    [sym_paired_delimiter_definition] = STATE(291),
    [sym_environment_definition] = STATE(291),
    [sym_glossary_entry_definition] = STATE(291),
    [sym_glossary_entry_reference] = STATE(291),
    [sym_acronym_definition] = STATE(291),
    [sym_acronym_reference] = STATE(291),
    [sym_theorem_definition] = STATE(291),
    [sym_color_definition] = STATE(291),
    [sym_color_set_definition] = STATE(291),
    [sym_color_reference] = STATE(291),
    [sym_tikz_library_import] = STATE(291),
    [sym_text_mode] = STATE(291),
    [sym_hyperlink] = STATE(291),
    [aux_sym_text_repeat1] = STATE(320),
    [aux_sym_value_repeat1] = STATE(291),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(5041),
    [anon_sym_LPAREN] = ACTIONS(5173),
    [anon_sym_RPAREN] = ACTIONS(5173),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5047),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5047),
    [anon_sym_DOLLAR] = ACTIONS(5049),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5051),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [295] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2436),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [296] = {
    [sym_block_comment] = STATE(292),
    [sym__text_content] = STATE(292),
    [sym_curly_group] = STATE(292),
    [sym_brack_group] = STATE(292),
    [sym_text] = STATE(292),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym_value] = STATE(2370),
    [sym_displayed_equation] = STATE(292),
    [sym_inline_formula] = STATE(292),
    [sym__command] = STATE(292),
    [sym_generic_command] = STATE(292),
    [sym_title_declaration] = STATE(292),
    [sym_author_declaration] = STATE(292),
    [sym_package_include] = STATE(292),
    [sym_class_include] = STATE(292),
    [sym_latex_include] = STATE(292),
    [sym_biblatex_include] = STATE(292),
    [sym_bibstyle_include] = STATE(292),
    [sym_bibtex_include] = STATE(292),
    [sym_graphics_include] = STATE(292),
    [sym_svg_include] = STATE(292),
    [sym_inkscape_include] = STATE(292),
    [sym_verbatim_include] = STATE(292),
    [sym_import_include] = STATE(292),
    [sym_caption] = STATE(292),
    [sym_citation] = STATE(292),
    [sym_label_definition] = STATE(292),
    [sym_label_reference] = STATE(292),
    [sym_label_reference_range] = STATE(292),
    [sym_label_number] = STATE(292),
    [sym_new_command_definition] = STATE(292),
    [sym_old_command_definition] = STATE(292),
    [sym_let_command_definition] = STATE(292),
    [sym_math_delimiter] = STATE(292),
    [sym_paired_delimiter_definition] = STATE(292),
    [sym_environment_definition] = STATE(292),
    [sym_glossary_entry_definition] = STATE(292),
    [sym_glossary_entry_reference] = STATE(292),
    [sym_acronym_definition] = STATE(292),
    [sym_acronym_reference] = STATE(292),
    [sym_theorem_definition] = STATE(292),
    [sym_color_definition] = STATE(292),
    [sym_color_set_definition] = STATE(292),
    [sym_color_reference] = STATE(292),
    [sym_tikz_library_import] = STATE(292),
    [sym_text_mode] = STATE(292),
    [sym_hyperlink] = STATE(292),
    [aux_sym_text_repeat1] = STATE(320),
    [aux_sym_value_repeat1] = STATE(292),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(5041),
    [anon_sym_LPAREN] = ACTIONS(5177),
    [anon_sym_RPAREN] = ACTIONS(5177),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5055),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5055),
    [anon_sym_DOLLAR] = ACTIONS(5057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5059),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(4604),
    [anon_sym_BSLASHbigl] = ACTIONS(4604),
    [anon_sym_BSLASHBigl] = ACTIONS(4604),
    [anon_sym_BSLASHbiggl] = ACTIONS(4604),
    [anon_sym_BSLASHBiggl] = ACTIONS(4604),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(4630),
    [anon_sym_BSLASHintertext] = ACTIONS(4630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(4630),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [297] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2428),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5179),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [298] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2358),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5181),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [299] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2450),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5183),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [300] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2389),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5185),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [301] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2440),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [302] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2397),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5189),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [303] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2419),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5191),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [304] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_curly_group_author_list_repeat2] = STATE(2371),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5193),
    [anon_sym_BSLASHand] = ACTIONS(5071),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [305] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5195),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5198),
    [anon_sym_LPAREN] = ACTIONS(5201),
    [anon_sym_RPAREN] = ACTIONS(5201),
    [anon_sym_LBRACE] = ACTIONS(5204),
    [anon_sym_RBRACE] = ACTIONS(5207),
    [anon_sym_BSLASHand] = ACTIONS(5209),
    [sym_word] = ACTIONS(5211),
    [sym_placeholder] = ACTIONS(5214),
    [anon_sym_PLUS] = ACTIONS(5217),
    [anon_sym_DASH] = ACTIONS(5217),
    [anon_sym_STAR] = ACTIONS(5217),
    [anon_sym_SLASH] = ACTIONS(5217),
    [anon_sym_LT] = ACTIONS(5220),
    [anon_sym_GT] = ACTIONS(5220),
    [anon_sym_BANG] = ACTIONS(5220),
    [anon_sym_PIPE] = ACTIONS(5220),
    [anon_sym_COLON] = ACTIONS(5220),
    [anon_sym_SQUOTE] = ACTIONS(5220),
    [anon_sym__] = ACTIONS(5223),
    [anon_sym_CARET] = ACTIONS(5226),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5229),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5229),
    [anon_sym_DOLLAR] = ACTIONS(5232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5235),
    [anon_sym_BSLASHtitle] = ACTIONS(5238),
    [anon_sym_BSLASHauthor] = ACTIONS(5241),
    [anon_sym_BSLASHusepackage] = ACTIONS(5244),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5244),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5247),
    [anon_sym_BSLASHinclude] = ACTIONS(5250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5250),
    [anon_sym_BSLASHinput] = ACTIONS(5250),
    [anon_sym_BSLASHsubfile] = ACTIONS(5250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5253),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5256),
    [anon_sym_BSLASHbibliography] = ACTIONS(5259),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5262),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5265),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5268),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5271),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5271),
    [anon_sym_BSLASHimport] = ACTIONS(5274),
    [anon_sym_BSLASHsubimport] = ACTIONS(5274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5274),
    [anon_sym_BSLASHcaption] = ACTIONS(5277),
    [anon_sym_BSLASHcite] = ACTIONS(5280),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHCite] = ACTIONS(5280),
    [anon_sym_BSLASHnocite] = ACTIONS(5280),
    [anon_sym_BSLASHcitet] = ACTIONS(5280),
    [anon_sym_BSLASHcitep] = ACTIONS(5280),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHciteA] = ACTIONS(5280),
    [anon_sym_BSLASHciteR] = ACTIONS(5280),
    [anon_sym_BSLASHciteS] = ACTIONS(5280),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5280),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5280),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5280),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5280),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHciteyear] = ACTIONS(5280),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHcitedate] = ACTIONS(5280),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHciteurl] = ACTIONS(5280),
    [anon_sym_BSLASHfullcite] = ACTIONS(5280),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5280),
    [anon_sym_BSLASHcitealt] = ACTIONS(5280),
    [anon_sym_BSLASHcitealp] = ACTIONS(5280),
    [anon_sym_BSLASHcitetext] = ACTIONS(5280),
    [anon_sym_BSLASHparencite] = ACTIONS(5280),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHParencite] = ACTIONS(5280),
    [anon_sym_BSLASHfootcite] = ACTIONS(5280),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5280),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5280),
    [anon_sym_BSLASHtextcite] = ACTIONS(5280),
    [anon_sym_BSLASHTextcite] = ACTIONS(5280),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5280),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5280),
    [anon_sym_BSLASHsupercite] = ACTIONS(5280),
    [anon_sym_BSLASHautocite] = ACTIONS(5280),
    [anon_sym_BSLASHAutocite] = ACTIONS(5280),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5283),
    [anon_sym_BSLASHvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHVolcite] = ACTIONS(5280),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHavolcite] = ACTIONS(5280),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5280),
    [anon_sym_BSLASHnotecite] = ACTIONS(5280),
    [anon_sym_BSLASHNotecite] = ACTIONS(5280),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5280),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5280),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5280),
    [anon_sym_BSLASHlabel] = ACTIONS(5286),
    [anon_sym_BSLASHref] = ACTIONS(5289),
    [anon_sym_BSLASHeqref] = ACTIONS(5289),
    [anon_sym_BSLASHvref] = ACTIONS(5289),
    [anon_sym_BSLASHVref] = ACTIONS(5289),
    [anon_sym_BSLASHautoref] = ACTIONS(5289),
    [anon_sym_BSLASHpageref] = ACTIONS(5289),
    [anon_sym_BSLASHcref] = ACTIONS(5289),
    [anon_sym_BSLASHCref] = ACTIONS(5289),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5292),
    [anon_sym_BSLASHnamecref] = ACTIONS(5289),
    [anon_sym_BSLASHnameCref] = ACTIONS(5289),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5289),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5289),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5289),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5289),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5289),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5289),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5295),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5298),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5295),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5298),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5301),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5304),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5307),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5304),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5307),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5304),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5307),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5304),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5307),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5304),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5304),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5304),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5304),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5304),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5304),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5304),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5304),
    [anon_sym_BSLASHdef] = ACTIONS(5310),
    [anon_sym_BSLASHlet] = ACTIONS(5313),
    [anon_sym_BSLASHleft] = ACTIONS(5316),
    [anon_sym_BSLASHbigl] = ACTIONS(5316),
    [anon_sym_BSLASHBigl] = ACTIONS(5316),
    [anon_sym_BSLASHbiggl] = ACTIONS(5316),
    [anon_sym_BSLASHBiggl] = ACTIONS(5316),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5319),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5319),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5325),
    [anon_sym_BSLASHgls] = ACTIONS(5328),
    [anon_sym_BSLASHGls] = ACTIONS(5328),
    [anon_sym_BSLASHGLS] = ACTIONS(5328),
    [anon_sym_BSLASHglspl] = ACTIONS(5328),
    [anon_sym_BSLASHGlspl] = ACTIONS(5328),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5328),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5328),
    [anon_sym_BSLASHglslink] = ACTIONS(5328),
    [anon_sym_BSLASHglstext] = ACTIONS(5328),
    [anon_sym_BSLASHGlstext] = ACTIONS(5328),
    [anon_sym_BSLASHGLStext] = ACTIONS(5328),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5328),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5328),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5328),
    [anon_sym_BSLASHglsplural] = ACTIONS(5328),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5328),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5328),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5328),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5328),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5328),
    [anon_sym_BSLASHglsname] = ACTIONS(5328),
    [anon_sym_BSLASHGlsname] = ACTIONS(5328),
    [anon_sym_BSLASHGLSname] = ACTIONS(5328),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5328),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5328),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5328),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5328),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5328),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5328),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5328),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5328),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5328),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5328),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5328),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5328),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5328),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5328),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5328),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5328),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5328),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5328),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5328),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5328),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5328),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5328),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5328),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5331),
    [anon_sym_BSLASHacrshort] = ACTIONS(5334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5334),
    [anon_sym_BSLASHACRshort] = ACTIONS(5334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5334),
    [anon_sym_BSLASHacrlong] = ACTIONS(5334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5334),
    [anon_sym_BSLASHACRlong] = ACTIONS(5334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5334),
    [anon_sym_BSLASHacrfull] = ACTIONS(5334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5334),
    [anon_sym_BSLASHACRfull] = ACTIONS(5334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5334),
    [anon_sym_BSLASHacs] = ACTIONS(5334),
    [anon_sym_BSLASHAcs] = ACTIONS(5334),
    [anon_sym_BSLASHacsp] = ACTIONS(5334),
    [anon_sym_BSLASHAcsp] = ACTIONS(5334),
    [anon_sym_BSLASHacl] = ACTIONS(5334),
    [anon_sym_BSLASHAcl] = ACTIONS(5334),
    [anon_sym_BSLASHaclp] = ACTIONS(5334),
    [anon_sym_BSLASHAclp] = ACTIONS(5334),
    [anon_sym_BSLASHacf] = ACTIONS(5334),
    [anon_sym_BSLASHAcf] = ACTIONS(5334),
    [anon_sym_BSLASHacfp] = ACTIONS(5334),
    [anon_sym_BSLASHAcfp] = ACTIONS(5334),
    [anon_sym_BSLASHac] = ACTIONS(5334),
    [anon_sym_BSLASHAc] = ACTIONS(5334),
    [anon_sym_BSLASHacp] = ACTIONS(5334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5337),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5337),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5343),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5346),
    [anon_sym_BSLASHcolor] = ACTIONS(5349),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5349),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5349),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5349),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5352),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5352),
    [anon_sym_BSLASHtext] = ACTIONS(5355),
    [anon_sym_BSLASHintertext] = ACTIONS(5355),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5355),
    [anon_sym_BSLASHurl] = ACTIONS(5358),
    [anon_sym_BSLASHhref] = ACTIONS(5358),
  },
  [306] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(305),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5361),
    [anon_sym_BSLASHand] = ACTIONS(5363),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [307] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(298),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5365),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [308] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(301),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5367),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [309] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(297),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5369),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [310] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(293),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5371),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [311] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(302),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5373),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [312] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(295),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5375),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [313] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(303),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [314] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(299),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5379),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [315] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(304),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5381),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [316] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(300),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(5383),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [317] = {
    [sym_block_comment] = STATE(1959),
    [sym__text_content] = STATE(1959),
    [sym_curly_group] = STATE(1959),
    [sym_text] = STATE(1959),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym_displayed_equation] = STATE(1959),
    [sym_inline_formula] = STATE(1959),
    [sym__command] = STATE(1959),
    [sym_generic_command] = STATE(1959),
    [sym_title_declaration] = STATE(1959),
    [sym_author_declaration] = STATE(1959),
    [sym_package_include] = STATE(1959),
    [sym_class_include] = STATE(1959),
    [sym_latex_include] = STATE(1959),
    [sym_biblatex_include] = STATE(1959),
    [sym_bibstyle_include] = STATE(1959),
    [sym_bibtex_include] = STATE(1959),
    [sym_graphics_include] = STATE(1959),
    [sym_svg_include] = STATE(1959),
    [sym_inkscape_include] = STATE(1959),
    [sym_verbatim_include] = STATE(1959),
    [sym_import_include] = STATE(1959),
    [sym_caption] = STATE(1959),
    [sym_citation] = STATE(1959),
    [sym_label_definition] = STATE(1959),
    [sym_label_reference] = STATE(1959),
    [sym_label_reference_range] = STATE(1959),
    [sym_label_number] = STATE(1959),
    [sym_new_command_definition] = STATE(1959),
    [sym_old_command_definition] = STATE(1959),
    [sym_let_command_definition] = STATE(1959),
    [sym_math_delimiter] = STATE(1959),
    [sym_paired_delimiter_definition] = STATE(1959),
    [sym_environment_definition] = STATE(1959),
    [sym_glossary_entry_definition] = STATE(1959),
    [sym_glossary_entry_reference] = STATE(1959),
    [sym_acronym_definition] = STATE(1959),
    [sym_acronym_reference] = STATE(1959),
    [sym_theorem_definition] = STATE(1959),
    [sym_color_definition] = STATE(1959),
    [sym_color_set_definition] = STATE(1959),
    [sym_color_reference] = STATE(1959),
    [sym_tikz_library_import] = STATE(1959),
    [sym_text_mode] = STATE(1959),
    [sym_hyperlink] = STATE(1959),
    [aux_sym_curly_group_author_list_repeat1] = STATE(306),
    [aux_sym_text_repeat1] = STATE(326),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(5065),
    [anon_sym_RPAREN] = ACTIONS(5065),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5085),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5085),
    [anon_sym_DOLLAR] = ACTIONS(5087),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5089),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(5143),
    [anon_sym_BSLASHbigl] = ACTIONS(5143),
    [anon_sym_BSLASHBigl] = ACTIONS(5143),
    [anon_sym_BSLASHbiggl] = ACTIONS(5143),
    [anon_sym_BSLASHBiggl] = ACTIONS(5143),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(5169),
    [anon_sym_BSLASHintertext] = ACTIONS(5169),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5169),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [318] = {
    [sym_block_comment] = STATE(1560),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym__command] = STATE(1560),
    [sym_generic_command] = STATE(1560),
    [sym_title_declaration] = STATE(1560),
    [sym_author_declaration] = STATE(1560),
    [sym_package_include] = STATE(1560),
    [sym_class_include] = STATE(1560),
    [sym_latex_include] = STATE(1560),
    [sym_biblatex_include] = STATE(1560),
    [sym_bibstyle_include] = STATE(1560),
    [sym_bibtex_include] = STATE(1560),
    [sym_graphics_include] = STATE(1560),
    [sym_svg_include] = STATE(1560),
    [sym_inkscape_include] = STATE(1560),
    [sym_verbatim_include] = STATE(1560),
    [sym_import_include] = STATE(1560),
    [sym_caption] = STATE(1560),
    [sym_citation] = STATE(1560),
    [sym_label_definition] = STATE(1560),
    [sym_label_reference] = STATE(1560),
    [sym_label_reference_range] = STATE(1560),
    [sym_label_number] = STATE(1560),
    [sym_new_command_definition] = STATE(1560),
    [sym_old_command_definition] = STATE(1560),
    [sym_let_command_definition] = STATE(1560),
    [sym_paired_delimiter_definition] = STATE(1560),
    [sym_environment_definition] = STATE(1560),
    [sym_glossary_entry_definition] = STATE(1560),
    [sym_glossary_entry_reference] = STATE(1560),
    [sym_acronym_definition] = STATE(1560),
    [sym_acronym_reference] = STATE(1560),
    [sym_theorem_definition] = STATE(1560),
    [sym_color_definition] = STATE(1560),
    [sym_color_set_definition] = STATE(1560),
    [sym_color_reference] = STATE(1560),
    [sym_tikz_library_import] = STATE(1560),
    [sym_hyperlink] = STATE(1560),
    [aux_sym_text_repeat1] = STATE(318),
    [sym_command_name] = ACTIONS(5385),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5388),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [sym_word] = ACTIONS(5391),
    [sym_placeholder] = ACTIONS(5394),
    [anon_sym_PLUS] = ACTIONS(5397),
    [anon_sym_DASH] = ACTIONS(5397),
    [anon_sym_STAR] = ACTIONS(5397),
    [anon_sym_SLASH] = ACTIONS(5397),
    [anon_sym_LT] = ACTIONS(5400),
    [anon_sym_GT] = ACTIONS(5400),
    [anon_sym_BANG] = ACTIONS(5400),
    [anon_sym_PIPE] = ACTIONS(5400),
    [anon_sym_COLON] = ACTIONS(5400),
    [anon_sym_SQUOTE] = ACTIONS(5400),
    [anon_sym__] = ACTIONS(5403),
    [anon_sym_CARET] = ACTIONS(5406),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3705),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3705),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHbegin] = ACTIONS(3707),
    [anon_sym_BSLASHend] = ACTIONS(3707),
    [anon_sym_BSLASHtitle] = ACTIONS(5409),
    [anon_sym_BSLASHauthor] = ACTIONS(5412),
    [anon_sym_BSLASHusepackage] = ACTIONS(5415),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5415),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5418),
    [anon_sym_BSLASHinclude] = ACTIONS(5421),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5421),
    [anon_sym_BSLASHinput] = ACTIONS(5421),
    [anon_sym_BSLASHsubfile] = ACTIONS(5421),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5424),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5427),
    [anon_sym_BSLASHbibliography] = ACTIONS(5430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5433),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5436),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5439),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5442),
    [anon_sym_BSLASHimport] = ACTIONS(5445),
    [anon_sym_BSLASHsubimport] = ACTIONS(5445),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5445),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5445),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5445),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5445),
    [anon_sym_BSLASHcaption] = ACTIONS(5448),
    [anon_sym_BSLASHcite] = ACTIONS(5451),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHCite] = ACTIONS(5451),
    [anon_sym_BSLASHnocite] = ACTIONS(5451),
    [anon_sym_BSLASHcitet] = ACTIONS(5451),
    [anon_sym_BSLASHcitep] = ACTIONS(5451),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHciteA] = ACTIONS(5451),
    [anon_sym_BSLASHciteR] = ACTIONS(5451),
    [anon_sym_BSLASHciteS] = ACTIONS(5451),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5451),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5451),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5451),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5451),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHciteyear] = ACTIONS(5451),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHcitedate] = ACTIONS(5451),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHciteurl] = ACTIONS(5451),
    [anon_sym_BSLASHfullcite] = ACTIONS(5451),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5451),
    [anon_sym_BSLASHcitealt] = ACTIONS(5451),
    [anon_sym_BSLASHcitealp] = ACTIONS(5451),
    [anon_sym_BSLASHcitetext] = ACTIONS(5451),
    [anon_sym_BSLASHparencite] = ACTIONS(5451),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHParencite] = ACTIONS(5451),
    [anon_sym_BSLASHfootcite] = ACTIONS(5451),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5451),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5451),
    [anon_sym_BSLASHtextcite] = ACTIONS(5451),
    [anon_sym_BSLASHTextcite] = ACTIONS(5451),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5451),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5451),
    [anon_sym_BSLASHsupercite] = ACTIONS(5451),
    [anon_sym_BSLASHautocite] = ACTIONS(5451),
    [anon_sym_BSLASHAutocite] = ACTIONS(5451),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5454),
    [anon_sym_BSLASHvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHVolcite] = ACTIONS(5451),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHavolcite] = ACTIONS(5451),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5451),
    [anon_sym_BSLASHnotecite] = ACTIONS(5451),
    [anon_sym_BSLASHNotecite] = ACTIONS(5451),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5451),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5451),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5451),
    [anon_sym_BSLASHlabel] = ACTIONS(5457),
    [anon_sym_BSLASHref] = ACTIONS(5460),
    [anon_sym_BSLASHeqref] = ACTIONS(5460),
    [anon_sym_BSLASHvref] = ACTIONS(5460),
    [anon_sym_BSLASHVref] = ACTIONS(5460),
    [anon_sym_BSLASHautoref] = ACTIONS(5460),
    [anon_sym_BSLASHpageref] = ACTIONS(5460),
    [anon_sym_BSLASHcref] = ACTIONS(5460),
    [anon_sym_BSLASHCref] = ACTIONS(5460),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5463),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5463),
    [anon_sym_BSLASHnamecref] = ACTIONS(5460),
    [anon_sym_BSLASHnameCref] = ACTIONS(5460),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5460),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5460),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5460),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5460),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5460),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5460),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5469),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5469),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5472),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5475),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5478),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5475),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5478),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5475),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5478),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5475),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5478),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5475),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5475),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5475),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5475),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5475),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5475),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5475),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5475),
    [anon_sym_BSLASHdef] = ACTIONS(5481),
    [anon_sym_BSLASHlet] = ACTIONS(5484),
    [anon_sym_BSLASHleft] = ACTIONS(3707),
    [anon_sym_BSLASHbigl] = ACTIONS(3707),
    [anon_sym_BSLASHBigl] = ACTIONS(3707),
    [anon_sym_BSLASHbiggl] = ACTIONS(3707),
    [anon_sym_BSLASHBiggl] = ACTIONS(3707),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5487),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5487),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5490),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5490),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5490),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5490),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5490),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5490),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5493),
    [anon_sym_BSLASHgls] = ACTIONS(5496),
    [anon_sym_BSLASHGls] = ACTIONS(5496),
    [anon_sym_BSLASHGLS] = ACTIONS(5496),
    [anon_sym_BSLASHglspl] = ACTIONS(5496),
    [anon_sym_BSLASHGlspl] = ACTIONS(5496),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5496),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5496),
    [anon_sym_BSLASHglslink] = ACTIONS(5496),
    [anon_sym_BSLASHglstext] = ACTIONS(5496),
    [anon_sym_BSLASHGlstext] = ACTIONS(5496),
    [anon_sym_BSLASHGLStext] = ACTIONS(5496),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5496),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5496),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5496),
    [anon_sym_BSLASHglsplural] = ACTIONS(5496),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5496),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5496),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5496),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5496),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5496),
    [anon_sym_BSLASHglsname] = ACTIONS(5496),
    [anon_sym_BSLASHGlsname] = ACTIONS(5496),
    [anon_sym_BSLASHGLSname] = ACTIONS(5496),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5496),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5496),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5496),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5496),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5496),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5496),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5496),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5496),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5496),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5496),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5496),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5496),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5496),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5496),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5496),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5496),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5496),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5496),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5496),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5496),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5496),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5496),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5496),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5499),
    [anon_sym_BSLASHacrshort] = ACTIONS(5502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5502),
    [anon_sym_BSLASHACRshort] = ACTIONS(5502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5502),
    [anon_sym_BSLASHacrlong] = ACTIONS(5502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5502),
    [anon_sym_BSLASHACRlong] = ACTIONS(5502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5502),
    [anon_sym_BSLASHacrfull] = ACTIONS(5502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5502),
    [anon_sym_BSLASHACRfull] = ACTIONS(5502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5502),
    [anon_sym_BSLASHacs] = ACTIONS(5502),
    [anon_sym_BSLASHAcs] = ACTIONS(5502),
    [anon_sym_BSLASHacsp] = ACTIONS(5502),
    [anon_sym_BSLASHAcsp] = ACTIONS(5502),
    [anon_sym_BSLASHacl] = ACTIONS(5502),
    [anon_sym_BSLASHAcl] = ACTIONS(5502),
    [anon_sym_BSLASHaclp] = ACTIONS(5502),
    [anon_sym_BSLASHAclp] = ACTIONS(5502),
    [anon_sym_BSLASHacf] = ACTIONS(5502),
    [anon_sym_BSLASHAcf] = ACTIONS(5502),
    [anon_sym_BSLASHacfp] = ACTIONS(5502),
    [anon_sym_BSLASHAcfp] = ACTIONS(5502),
    [anon_sym_BSLASHac] = ACTIONS(5502),
    [anon_sym_BSLASHAc] = ACTIONS(5502),
    [anon_sym_BSLASHacp] = ACTIONS(5502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5505),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5505),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5511),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5514),
    [anon_sym_BSLASHcolor] = ACTIONS(5517),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5517),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5517),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5517),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5520),
    [anon_sym_BSLASHtext] = ACTIONS(3707),
    [anon_sym_BSLASHintertext] = ACTIONS(3707),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3707),
    [anon_sym_BSLASHurl] = ACTIONS(5523),
    [anon_sym_BSLASHhref] = ACTIONS(5523),
  },
  [319] = {
    [sym_block_comment] = STATE(1560),
    [sym_operator] = STATE(1560),
    [sym_subscript] = STATE(1560),
    [sym_superscript] = STATE(1560),
    [sym__command] = STATE(1560),
    [sym_generic_command] = STATE(1560),
    [sym_title_declaration] = STATE(1560),
    [sym_author_declaration] = STATE(1560),
    [sym_package_include] = STATE(1560),
    [sym_class_include] = STATE(1560),
    [sym_latex_include] = STATE(1560),
    [sym_biblatex_include] = STATE(1560),
    [sym_bibstyle_include] = STATE(1560),
    [sym_bibtex_include] = STATE(1560),
    [sym_graphics_include] = STATE(1560),
    [sym_svg_include] = STATE(1560),
    [sym_inkscape_include] = STATE(1560),
    [sym_verbatim_include] = STATE(1560),
    [sym_import_include] = STATE(1560),
    [sym_caption] = STATE(1560),
    [sym_citation] = STATE(1560),
    [sym_label_definition] = STATE(1560),
    [sym_label_reference] = STATE(1560),
    [sym_label_reference_range] = STATE(1560),
    [sym_label_number] = STATE(1560),
    [sym_new_command_definition] = STATE(1560),
    [sym_old_command_definition] = STATE(1560),
    [sym_let_command_definition] = STATE(1560),
    [sym_paired_delimiter_definition] = STATE(1560),
    [sym_environment_definition] = STATE(1560),
    [sym_glossary_entry_definition] = STATE(1560),
    [sym_glossary_entry_reference] = STATE(1560),
    [sym_acronym_definition] = STATE(1560),
    [sym_acronym_reference] = STATE(1560),
    [sym_theorem_definition] = STATE(1560),
    [sym_color_definition] = STATE(1560),
    [sym_color_set_definition] = STATE(1560),
    [sym_color_reference] = STATE(1560),
    [sym_tikz_library_import] = STATE(1560),
    [sym_hyperlink] = STATE(1560),
    [aux_sym_text_repeat1] = STATE(318),
    [sym_command_name] = ACTIONS(3103),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_RBRACK] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [anon_sym_RPAREN] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [sym_word] = ACTIONS(3111),
    [sym_placeholder] = ACTIONS(3113),
    [anon_sym_PLUS] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym__] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3844),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3844),
    [anon_sym_DOLLAR] = ACTIONS(3846),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHbegin] = ACTIONS(3846),
    [anon_sym_BSLASHend] = ACTIONS(3846),
    [anon_sym_BSLASHtitle] = ACTIONS(3131),
    [anon_sym_BSLASHauthor] = ACTIONS(3133),
    [anon_sym_BSLASHusepackage] = ACTIONS(3135),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3135),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3137),
    [anon_sym_BSLASHinclude] = ACTIONS(3139),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3139),
    [anon_sym_BSLASHinput] = ACTIONS(3139),
    [anon_sym_BSLASHsubfile] = ACTIONS(3139),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3141),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3143),
    [anon_sym_BSLASHbibliography] = ACTIONS(3145),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3147),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3151),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3153),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3153),
    [anon_sym_BSLASHimport] = ACTIONS(3155),
    [anon_sym_BSLASHsubimport] = ACTIONS(3155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3155),
    [anon_sym_BSLASHcaption] = ACTIONS(3157),
    [anon_sym_BSLASHcite] = ACTIONS(3159),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCite] = ACTIONS(3159),
    [anon_sym_BSLASHnocite] = ACTIONS(3159),
    [anon_sym_BSLASHcitet] = ACTIONS(3159),
    [anon_sym_BSLASHcitep] = ACTIONS(3159),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteA] = ACTIONS(3159),
    [anon_sym_BSLASHciteR] = ACTIONS(3159),
    [anon_sym_BSLASHciteS] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3159),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3159),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteyear] = ACTIONS(3159),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHcitedate] = ACTIONS(3159),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHciteurl] = ACTIONS(3159),
    [anon_sym_BSLASHfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3159),
    [anon_sym_BSLASHcitealt] = ACTIONS(3159),
    [anon_sym_BSLASHcitealp] = ACTIONS(3159),
    [anon_sym_BSLASHcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHparencite] = ACTIONS(3159),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHParencite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3159),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3159),
    [anon_sym_BSLASHtextcite] = ACTIONS(3159),
    [anon_sym_BSLASHTextcite] = ACTIONS(3159),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3159),
    [anon_sym_BSLASHsupercite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite] = ACTIONS(3159),
    [anon_sym_BSLASHAutocite] = ACTIONS(3159),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3161),
    [anon_sym_BSLASHvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHVolcite] = ACTIONS(3159),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHavolcite] = ACTIONS(3159),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3159),
    [anon_sym_BSLASHnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHNotecite] = ACTIONS(3159),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3159),
    [anon_sym_BSLASHlabel] = ACTIONS(3163),
    [anon_sym_BSLASHref] = ACTIONS(3165),
    [anon_sym_BSLASHeqref] = ACTIONS(3165),
    [anon_sym_BSLASHvref] = ACTIONS(3165),
    [anon_sym_BSLASHVref] = ACTIONS(3165),
    [anon_sym_BSLASHautoref] = ACTIONS(3165),
    [anon_sym_BSLASHpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcref] = ACTIONS(3165),
    [anon_sym_BSLASHCref] = ACTIONS(3165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3167),
    [anon_sym_BSLASHnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnameCref] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3169),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3171),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3173),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3175),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3177),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3175),
    [anon_sym_BSLASHdef] = ACTIONS(3179),
    [anon_sym_BSLASHlet] = ACTIONS(3181),
    [anon_sym_BSLASHleft] = ACTIONS(3846),
    [anon_sym_BSLASHbigl] = ACTIONS(3846),
    [anon_sym_BSLASHBigl] = ACTIONS(3846),
    [anon_sym_BSLASHbiggl] = ACTIONS(3846),
    [anon_sym_BSLASHBiggl] = ACTIONS(3846),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3185),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3185),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3187),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3187),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3189),
    [anon_sym_BSLASHgls] = ACTIONS(3191),
    [anon_sym_BSLASHGls] = ACTIONS(3191),
    [anon_sym_BSLASHGLS] = ACTIONS(3191),
    [anon_sym_BSLASHglspl] = ACTIONS(3191),
    [anon_sym_BSLASHGlspl] = ACTIONS(3191),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3191),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3191),
    [anon_sym_BSLASHglslink] = ACTIONS(3191),
    [anon_sym_BSLASHglstext] = ACTIONS(3191),
    [anon_sym_BSLASHGlstext] = ACTIONS(3191),
    [anon_sym_BSLASHGLStext] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3191),
    [anon_sym_BSLASHglsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3191),
    [anon_sym_BSLASHglsname] = ACTIONS(3191),
    [anon_sym_BSLASHGlsname] = ACTIONS(3191),
    [anon_sym_BSLASHGLSname] = ACTIONS(3191),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3191),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3191),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3191),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3191),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3191),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3191),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3193),
    [anon_sym_BSLASHacrshort] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3195),
    [anon_sym_BSLASHACRshort] = ACTIONS(3195),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrlong] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3195),
    [anon_sym_BSLASHACRlong] = ACTIONS(3195),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3195),
    [anon_sym_BSLASHacrfull] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3195),
    [anon_sym_BSLASHACRfull] = ACTIONS(3195),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHacs] = ACTIONS(3195),
    [anon_sym_BSLASHAcs] = ACTIONS(3195),
    [anon_sym_BSLASHacsp] = ACTIONS(3195),
    [anon_sym_BSLASHAcsp] = ACTIONS(3195),
    [anon_sym_BSLASHacl] = ACTIONS(3195),
    [anon_sym_BSLASHAcl] = ACTIONS(3195),
    [anon_sym_BSLASHaclp] = ACTIONS(3195),
    [anon_sym_BSLASHAclp] = ACTIONS(3195),
    [anon_sym_BSLASHacf] = ACTIONS(3195),
    [anon_sym_BSLASHAcf] = ACTIONS(3195),
    [anon_sym_BSLASHacfp] = ACTIONS(3195),
    [anon_sym_BSLASHAcfp] = ACTIONS(3195),
    [anon_sym_BSLASHac] = ACTIONS(3195),
    [anon_sym_BSLASHAc] = ACTIONS(3195),
    [anon_sym_BSLASHacp] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3195),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3195),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3195),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3197),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3197),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3199),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3201),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3203),
    [anon_sym_BSLASHcolor] = ACTIONS(3205),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3205),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3205),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3205),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3207),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3207),
    [anon_sym_BSLASHtext] = ACTIONS(3846),
    [anon_sym_BSLASHintertext] = ACTIONS(3846),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3846),
    [anon_sym_BSLASHurl] = ACTIONS(3211),
    [anon_sym_BSLASHhref] = ACTIONS(3211),
  },
  [320] = {
    [sym_block_comment] = STATE(1797),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym__command] = STATE(1797),
    [sym_generic_command] = STATE(1797),
    [sym_title_declaration] = STATE(1797),
    [sym_author_declaration] = STATE(1797),
    [sym_package_include] = STATE(1797),
    [sym_class_include] = STATE(1797),
    [sym_latex_include] = STATE(1797),
    [sym_biblatex_include] = STATE(1797),
    [sym_bibstyle_include] = STATE(1797),
    [sym_bibtex_include] = STATE(1797),
    [sym_graphics_include] = STATE(1797),
    [sym_svg_include] = STATE(1797),
    [sym_inkscape_include] = STATE(1797),
    [sym_verbatim_include] = STATE(1797),
    [sym_import_include] = STATE(1797),
    [sym_caption] = STATE(1797),
    [sym_citation] = STATE(1797),
    [sym_label_definition] = STATE(1797),
    [sym_label_reference] = STATE(1797),
    [sym_label_reference_range] = STATE(1797),
    [sym_label_number] = STATE(1797),
    [sym_new_command_definition] = STATE(1797),
    [sym_old_command_definition] = STATE(1797),
    [sym_let_command_definition] = STATE(1797),
    [sym_paired_delimiter_definition] = STATE(1797),
    [sym_environment_definition] = STATE(1797),
    [sym_glossary_entry_definition] = STATE(1797),
    [sym_glossary_entry_reference] = STATE(1797),
    [sym_acronym_definition] = STATE(1797),
    [sym_acronym_reference] = STATE(1797),
    [sym_theorem_definition] = STATE(1797),
    [sym_color_definition] = STATE(1797),
    [sym_color_set_definition] = STATE(1797),
    [sym_color_reference] = STATE(1797),
    [sym_tikz_library_import] = STATE(1797),
    [sym_hyperlink] = STATE(1797),
    [aux_sym_text_repeat1] = STATE(321),
    [sym_command_name] = ACTIONS(4524),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4526),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_RBRACK] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [anon_sym_RPAREN] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [anon_sym_RBRACE] = ACTIONS(3844),
    [sym_word] = ACTIONS(4534),
    [sym_placeholder] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_STAR] = ACTIONS(4538),
    [anon_sym_SLASH] = ACTIONS(4538),
    [anon_sym_LT] = ACTIONS(4540),
    [anon_sym_GT] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_PIPE] = ACTIONS(4540),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4540),
    [anon_sym__] = ACTIONS(4542),
    [anon_sym_CARET] = ACTIONS(4544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3844),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3844),
    [anon_sym_DOLLAR] = ACTIONS(3846),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHtitle] = ACTIONS(4552),
    [anon_sym_BSLASHauthor] = ACTIONS(4554),
    [anon_sym_BSLASHusepackage] = ACTIONS(4556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4558),
    [anon_sym_BSLASHinclude] = ACTIONS(4560),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4560),
    [anon_sym_BSLASHinput] = ACTIONS(4560),
    [anon_sym_BSLASHsubfile] = ACTIONS(4560),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4564),
    [anon_sym_BSLASHbibliography] = ACTIONS(4566),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4568),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4570),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4574),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4574),
    [anon_sym_BSLASHimport] = ACTIONS(4576),
    [anon_sym_BSLASHsubimport] = ACTIONS(4576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4576),
    [anon_sym_BSLASHcaption] = ACTIONS(4578),
    [anon_sym_BSLASHcite] = ACTIONS(4580),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCite] = ACTIONS(4580),
    [anon_sym_BSLASHnocite] = ACTIONS(4580),
    [anon_sym_BSLASHcitet] = ACTIONS(4580),
    [anon_sym_BSLASHcitep] = ACTIONS(4580),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteA] = ACTIONS(4580),
    [anon_sym_BSLASHciteR] = ACTIONS(4580),
    [anon_sym_BSLASHciteS] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4580),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4580),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteyear] = ACTIONS(4580),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHcitedate] = ACTIONS(4580),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHciteurl] = ACTIONS(4580),
    [anon_sym_BSLASHfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4580),
    [anon_sym_BSLASHcitealt] = ACTIONS(4580),
    [anon_sym_BSLASHcitealp] = ACTIONS(4580),
    [anon_sym_BSLASHcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHparencite] = ACTIONS(4580),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHParencite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4580),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4580),
    [anon_sym_BSLASHtextcite] = ACTIONS(4580),
    [anon_sym_BSLASHTextcite] = ACTIONS(4580),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4580),
    [anon_sym_BSLASHsupercite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite] = ACTIONS(4580),
    [anon_sym_BSLASHAutocite] = ACTIONS(4580),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4582),
    [anon_sym_BSLASHvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHVolcite] = ACTIONS(4580),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHavolcite] = ACTIONS(4580),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4580),
    [anon_sym_BSLASHnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHNotecite] = ACTIONS(4580),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4580),
    [anon_sym_BSLASHlabel] = ACTIONS(4584),
    [anon_sym_BSLASHref] = ACTIONS(4586),
    [anon_sym_BSLASHeqref] = ACTIONS(4586),
    [anon_sym_BSLASHvref] = ACTIONS(4586),
    [anon_sym_BSLASHVref] = ACTIONS(4586),
    [anon_sym_BSLASHautoref] = ACTIONS(4586),
    [anon_sym_BSLASHpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcref] = ACTIONS(4586),
    [anon_sym_BSLASHCref] = ACTIONS(4586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4588),
    [anon_sym_BSLASHnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnameCref] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4596),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4598),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4596),
    [anon_sym_BSLASHdef] = ACTIONS(4600),
    [anon_sym_BSLASHlet] = ACTIONS(4602),
    [anon_sym_BSLASHleft] = ACTIONS(3846),
    [anon_sym_BSLASHbigl] = ACTIONS(3846),
    [anon_sym_BSLASHBigl] = ACTIONS(3846),
    [anon_sym_BSLASHbiggl] = ACTIONS(3846),
    [anon_sym_BSLASHBiggl] = ACTIONS(3846),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4608),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4608),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4610),
    [anon_sym_BSLASHgls] = ACTIONS(4612),
    [anon_sym_BSLASHGls] = ACTIONS(4612),
    [anon_sym_BSLASHGLS] = ACTIONS(4612),
    [anon_sym_BSLASHglspl] = ACTIONS(4612),
    [anon_sym_BSLASHGlspl] = ACTIONS(4612),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4612),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4612),
    [anon_sym_BSLASHglslink] = ACTIONS(4612),
    [anon_sym_BSLASHglstext] = ACTIONS(4612),
    [anon_sym_BSLASHGlstext] = ACTIONS(4612),
    [anon_sym_BSLASHGLStext] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4612),
    [anon_sym_BSLASHglsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4612),
    [anon_sym_BSLASHglsname] = ACTIONS(4612),
    [anon_sym_BSLASHGlsname] = ACTIONS(4612),
    [anon_sym_BSLASHGLSname] = ACTIONS(4612),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4612),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4612),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4612),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4612),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4612),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4612),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4614),
    [anon_sym_BSLASHacrshort] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4616),
    [anon_sym_BSLASHACRshort] = ACTIONS(4616),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrlong] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4616),
    [anon_sym_BSLASHACRlong] = ACTIONS(4616),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4616),
    [anon_sym_BSLASHacrfull] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4616),
    [anon_sym_BSLASHACRfull] = ACTIONS(4616),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHacs] = ACTIONS(4616),
    [anon_sym_BSLASHAcs] = ACTIONS(4616),
    [anon_sym_BSLASHacsp] = ACTIONS(4616),
    [anon_sym_BSLASHAcsp] = ACTIONS(4616),
    [anon_sym_BSLASHacl] = ACTIONS(4616),
    [anon_sym_BSLASHAcl] = ACTIONS(4616),
    [anon_sym_BSLASHaclp] = ACTIONS(4616),
    [anon_sym_BSLASHAclp] = ACTIONS(4616),
    [anon_sym_BSLASHacf] = ACTIONS(4616),
    [anon_sym_BSLASHAcf] = ACTIONS(4616),
    [anon_sym_BSLASHacfp] = ACTIONS(4616),
    [anon_sym_BSLASHAcfp] = ACTIONS(4616),
    [anon_sym_BSLASHac] = ACTIONS(4616),
    [anon_sym_BSLASHAc] = ACTIONS(4616),
    [anon_sym_BSLASHacp] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4616),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4616),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4616),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4624),
    [anon_sym_BSLASHcolor] = ACTIONS(4626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4628),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4628),
    [anon_sym_BSLASHtext] = ACTIONS(3846),
    [anon_sym_BSLASHintertext] = ACTIONS(3846),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3846),
    [anon_sym_BSLASHurl] = ACTIONS(4632),
    [anon_sym_BSLASHhref] = ACTIONS(4632),
  },
  [321] = {
    [sym_block_comment] = STATE(1797),
    [sym_operator] = STATE(1797),
    [sym_subscript] = STATE(1797),
    [sym_superscript] = STATE(1797),
    [sym__command] = STATE(1797),
    [sym_generic_command] = STATE(1797),
    [sym_title_declaration] = STATE(1797),
    [sym_author_declaration] = STATE(1797),
    [sym_package_include] = STATE(1797),
    [sym_class_include] = STATE(1797),
    [sym_latex_include] = STATE(1797),
    [sym_biblatex_include] = STATE(1797),
    [sym_bibstyle_include] = STATE(1797),
    [sym_bibtex_include] = STATE(1797),
    [sym_graphics_include] = STATE(1797),
    [sym_svg_include] = STATE(1797),
    [sym_inkscape_include] = STATE(1797),
    [sym_verbatim_include] = STATE(1797),
    [sym_import_include] = STATE(1797),
    [sym_caption] = STATE(1797),
    [sym_citation] = STATE(1797),
    [sym_label_definition] = STATE(1797),
    [sym_label_reference] = STATE(1797),
    [sym_label_reference_range] = STATE(1797),
    [sym_label_number] = STATE(1797),
    [sym_new_command_definition] = STATE(1797),
    [sym_old_command_definition] = STATE(1797),
    [sym_let_command_definition] = STATE(1797),
    [sym_paired_delimiter_definition] = STATE(1797),
    [sym_environment_definition] = STATE(1797),
    [sym_glossary_entry_definition] = STATE(1797),
    [sym_glossary_entry_reference] = STATE(1797),
    [sym_acronym_definition] = STATE(1797),
    [sym_acronym_reference] = STATE(1797),
    [sym_theorem_definition] = STATE(1797),
    [sym_color_definition] = STATE(1797),
    [sym_color_set_definition] = STATE(1797),
    [sym_color_reference] = STATE(1797),
    [sym_tikz_library_import] = STATE(1797),
    [sym_hyperlink] = STATE(1797),
    [aux_sym_text_repeat1] = STATE(321),
    [sym_command_name] = ACTIONS(5526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5529),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [sym_word] = ACTIONS(5532),
    [sym_placeholder] = ACTIONS(5535),
    [anon_sym_PLUS] = ACTIONS(5538),
    [anon_sym_DASH] = ACTIONS(5538),
    [anon_sym_STAR] = ACTIONS(5538),
    [anon_sym_SLASH] = ACTIONS(5538),
    [anon_sym_LT] = ACTIONS(5541),
    [anon_sym_GT] = ACTIONS(5541),
    [anon_sym_BANG] = ACTIONS(5541),
    [anon_sym_PIPE] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5541),
    [anon_sym_SQUOTE] = ACTIONS(5541),
    [anon_sym__] = ACTIONS(5544),
    [anon_sym_CARET] = ACTIONS(5547),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3705),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3705),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHtitle] = ACTIONS(5550),
    [anon_sym_BSLASHauthor] = ACTIONS(5553),
    [anon_sym_BSLASHusepackage] = ACTIONS(5556),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5556),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5559),
    [anon_sym_BSLASHinclude] = ACTIONS(5562),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5562),
    [anon_sym_BSLASHinput] = ACTIONS(5562),
    [anon_sym_BSLASHsubfile] = ACTIONS(5562),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5565),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5568),
    [anon_sym_BSLASHbibliography] = ACTIONS(5571),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5574),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5577),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5580),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5583),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5583),
    [anon_sym_BSLASHimport] = ACTIONS(5586),
    [anon_sym_BSLASHsubimport] = ACTIONS(5586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5586),
    [anon_sym_BSLASHcaption] = ACTIONS(5589),
    [anon_sym_BSLASHcite] = ACTIONS(5592),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHCite] = ACTIONS(5592),
    [anon_sym_BSLASHnocite] = ACTIONS(5592),
    [anon_sym_BSLASHcitet] = ACTIONS(5592),
    [anon_sym_BSLASHcitep] = ACTIONS(5592),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHciteA] = ACTIONS(5592),
    [anon_sym_BSLASHciteR] = ACTIONS(5592),
    [anon_sym_BSLASHciteS] = ACTIONS(5592),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5592),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5592),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5592),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5592),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHciteyear] = ACTIONS(5592),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHcitedate] = ACTIONS(5592),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHciteurl] = ACTIONS(5592),
    [anon_sym_BSLASHfullcite] = ACTIONS(5592),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5592),
    [anon_sym_BSLASHcitealt] = ACTIONS(5592),
    [anon_sym_BSLASHcitealp] = ACTIONS(5592),
    [anon_sym_BSLASHcitetext] = ACTIONS(5592),
    [anon_sym_BSLASHparencite] = ACTIONS(5592),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHParencite] = ACTIONS(5592),
    [anon_sym_BSLASHfootcite] = ACTIONS(5592),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5592),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5592),
    [anon_sym_BSLASHtextcite] = ACTIONS(5592),
    [anon_sym_BSLASHTextcite] = ACTIONS(5592),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5592),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5592),
    [anon_sym_BSLASHsupercite] = ACTIONS(5592),
    [anon_sym_BSLASHautocite] = ACTIONS(5592),
    [anon_sym_BSLASHAutocite] = ACTIONS(5592),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5595),
    [anon_sym_BSLASHvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHVolcite] = ACTIONS(5592),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHavolcite] = ACTIONS(5592),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5592),
    [anon_sym_BSLASHnotecite] = ACTIONS(5592),
    [anon_sym_BSLASHNotecite] = ACTIONS(5592),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5592),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5592),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5592),
    [anon_sym_BSLASHlabel] = ACTIONS(5598),
    [anon_sym_BSLASHref] = ACTIONS(5601),
    [anon_sym_BSLASHeqref] = ACTIONS(5601),
    [anon_sym_BSLASHvref] = ACTIONS(5601),
    [anon_sym_BSLASHVref] = ACTIONS(5601),
    [anon_sym_BSLASHautoref] = ACTIONS(5601),
    [anon_sym_BSLASHpageref] = ACTIONS(5601),
    [anon_sym_BSLASHcref] = ACTIONS(5601),
    [anon_sym_BSLASHCref] = ACTIONS(5601),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5604),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5604),
    [anon_sym_BSLASHnamecref] = ACTIONS(5601),
    [anon_sym_BSLASHnameCref] = ACTIONS(5601),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5601),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5601),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5601),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5601),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5601),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5601),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5607),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5610),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5607),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5610),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5613),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5616),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5619),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5616),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5619),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5616),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5619),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5616),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5619),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5616),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5616),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5616),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5616),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5616),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5616),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5616),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5616),
    [anon_sym_BSLASHdef] = ACTIONS(5622),
    [anon_sym_BSLASHlet] = ACTIONS(5625),
    [anon_sym_BSLASHleft] = ACTIONS(3707),
    [anon_sym_BSLASHbigl] = ACTIONS(3707),
    [anon_sym_BSLASHBigl] = ACTIONS(3707),
    [anon_sym_BSLASHbiggl] = ACTIONS(3707),
    [anon_sym_BSLASHBiggl] = ACTIONS(3707),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5628),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5628),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5631),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5631),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5631),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5631),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5631),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5631),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5634),
    [anon_sym_BSLASHgls] = ACTIONS(5637),
    [anon_sym_BSLASHGls] = ACTIONS(5637),
    [anon_sym_BSLASHGLS] = ACTIONS(5637),
    [anon_sym_BSLASHglspl] = ACTIONS(5637),
    [anon_sym_BSLASHGlspl] = ACTIONS(5637),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5637),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5637),
    [anon_sym_BSLASHglslink] = ACTIONS(5637),
    [anon_sym_BSLASHglstext] = ACTIONS(5637),
    [anon_sym_BSLASHGlstext] = ACTIONS(5637),
    [anon_sym_BSLASHGLStext] = ACTIONS(5637),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5637),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5637),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5637),
    [anon_sym_BSLASHglsplural] = ACTIONS(5637),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5637),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5637),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5637),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5637),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5637),
    [anon_sym_BSLASHglsname] = ACTIONS(5637),
    [anon_sym_BSLASHGlsname] = ACTIONS(5637),
    [anon_sym_BSLASHGLSname] = ACTIONS(5637),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5637),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5637),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5637),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5637),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5637),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5637),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5637),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5637),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5637),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5637),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5637),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5637),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5637),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5637),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5637),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5637),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5637),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5637),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5637),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5637),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5637),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5637),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5637),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5640),
    [anon_sym_BSLASHacrshort] = ACTIONS(5643),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5643),
    [anon_sym_BSLASHACRshort] = ACTIONS(5643),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5643),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5643),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5643),
    [anon_sym_BSLASHacrlong] = ACTIONS(5643),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5643),
    [anon_sym_BSLASHACRlong] = ACTIONS(5643),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5643),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5643),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5643),
    [anon_sym_BSLASHacrfull] = ACTIONS(5643),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5643),
    [anon_sym_BSLASHACRfull] = ACTIONS(5643),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5643),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5643),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5643),
    [anon_sym_BSLASHacs] = ACTIONS(5643),
    [anon_sym_BSLASHAcs] = ACTIONS(5643),
    [anon_sym_BSLASHacsp] = ACTIONS(5643),
    [anon_sym_BSLASHAcsp] = ACTIONS(5643),
    [anon_sym_BSLASHacl] = ACTIONS(5643),
    [anon_sym_BSLASHAcl] = ACTIONS(5643),
    [anon_sym_BSLASHaclp] = ACTIONS(5643),
    [anon_sym_BSLASHAclp] = ACTIONS(5643),
    [anon_sym_BSLASHacf] = ACTIONS(5643),
    [anon_sym_BSLASHAcf] = ACTIONS(5643),
    [anon_sym_BSLASHacfp] = ACTIONS(5643),
    [anon_sym_BSLASHAcfp] = ACTIONS(5643),
    [anon_sym_BSLASHac] = ACTIONS(5643),
    [anon_sym_BSLASHAc] = ACTIONS(5643),
    [anon_sym_BSLASHacp] = ACTIONS(5643),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5643),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5643),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5643),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5643),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5643),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5643),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5643),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5643),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5643),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5643),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5646),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5649),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5646),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5649),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5652),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5655),
    [anon_sym_BSLASHcolor] = ACTIONS(5658),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5658),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5658),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5658),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5661),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5661),
    [anon_sym_BSLASHtext] = ACTIONS(3707),
    [anon_sym_BSLASHintertext] = ACTIONS(3707),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3707),
    [anon_sym_BSLASHurl] = ACTIONS(5664),
    [anon_sym_BSLASHhref] = ACTIONS(5664),
  },
  [322] = {
    [sym_block_comment] = STATE(1763),
    [sym_operator] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_superscript] = STATE(1763),
    [sym__command] = STATE(1763),
    [sym_generic_command] = STATE(1763),
    [sym_title_declaration] = STATE(1763),
    [sym_author_declaration] = STATE(1763),
    [sym_package_include] = STATE(1763),
    [sym_class_include] = STATE(1763),
    [sym_latex_include] = STATE(1763),
    [sym_biblatex_include] = STATE(1763),
    [sym_bibstyle_include] = STATE(1763),
    [sym_bibtex_include] = STATE(1763),
    [sym_graphics_include] = STATE(1763),
    [sym_svg_include] = STATE(1763),
    [sym_inkscape_include] = STATE(1763),
    [sym_verbatim_include] = STATE(1763),
    [sym_import_include] = STATE(1763),
    [sym_caption] = STATE(1763),
    [sym_citation] = STATE(1763),
    [sym_label_definition] = STATE(1763),
    [sym_label_reference] = STATE(1763),
    [sym_label_reference_range] = STATE(1763),
    [sym_label_number] = STATE(1763),
    [sym_new_command_definition] = STATE(1763),
    [sym_old_command_definition] = STATE(1763),
    [sym_let_command_definition] = STATE(1763),
    [sym_paired_delimiter_definition] = STATE(1763),
    [sym_environment_definition] = STATE(1763),
    [sym_glossary_entry_definition] = STATE(1763),
    [sym_glossary_entry_reference] = STATE(1763),
    [sym_acronym_definition] = STATE(1763),
    [sym_acronym_reference] = STATE(1763),
    [sym_theorem_definition] = STATE(1763),
    [sym_color_definition] = STATE(1763),
    [sym_color_set_definition] = STATE(1763),
    [sym_color_reference] = STATE(1763),
    [sym_tikz_library_import] = STATE(1763),
    [sym_hyperlink] = STATE(1763),
    [aux_sym_text_repeat1] = STATE(323),
    [sym_command_name] = ACTIONS(3401),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(3403),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [anon_sym_RBRACK] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [anon_sym_RPAREN] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [sym_word] = ACTIONS(3413),
    [sym_placeholder] = ACTIONS(3415),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3417),
    [anon_sym_LT] = ACTIONS(3419),
    [anon_sym_GT] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3419),
    [anon_sym_COLON] = ACTIONS(3419),
    [anon_sym_SQUOTE] = ACTIONS(3419),
    [anon_sym__] = ACTIONS(3421),
    [anon_sym_CARET] = ACTIONS(3423),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3844),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3844),
    [anon_sym_DOLLAR] = ACTIONS(3846),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHbegin] = ACTIONS(3846),
    [anon_sym_BSLASHtitle] = ACTIONS(3431),
    [anon_sym_BSLASHauthor] = ACTIONS(3433),
    [anon_sym_BSLASHusepackage] = ACTIONS(3435),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(3435),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(3437),
    [anon_sym_BSLASHinclude] = ACTIONS(3439),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(3439),
    [anon_sym_BSLASHinput] = ACTIONS(3439),
    [anon_sym_BSLASHsubfile] = ACTIONS(3439),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(3441),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(3443),
    [anon_sym_BSLASHbibliography] = ACTIONS(3445),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(3447),
    [anon_sym_BSLASHincludesvg] = ACTIONS(3449),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(3451),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(3453),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(3453),
    [anon_sym_BSLASHimport] = ACTIONS(3455),
    [anon_sym_BSLASHsubimport] = ACTIONS(3455),
    [anon_sym_BSLASHinputfrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(3455),
    [anon_sym_BSLASHincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(3455),
    [anon_sym_BSLASHcaption] = ACTIONS(3457),
    [anon_sym_BSLASHcite] = ACTIONS(3459),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCite] = ACTIONS(3459),
    [anon_sym_BSLASHnocite] = ACTIONS(3459),
    [anon_sym_BSLASHcitet] = ACTIONS(3459),
    [anon_sym_BSLASHcitep] = ACTIONS(3459),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteA] = ACTIONS(3459),
    [anon_sym_BSLASHciteR] = ACTIONS(3459),
    [anon_sym_BSLASHciteS] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearR] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(3459),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitetitle] = ACTIONS(3459),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteyear] = ACTIONS(3459),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHcitedate] = ACTIONS(3459),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHciteurl] = ACTIONS(3459),
    [anon_sym_BSLASHfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(3459),
    [anon_sym_BSLASHcitealt] = ACTIONS(3459),
    [anon_sym_BSLASHcitealp] = ACTIONS(3459),
    [anon_sym_BSLASHcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHparencite] = ACTIONS(3459),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHParencite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(3459),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(3459),
    [anon_sym_BSLASHtextcite] = ACTIONS(3459),
    [anon_sym_BSLASHTextcite] = ACTIONS(3459),
    [anon_sym_BSLASHsmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHSmartcite] = ACTIONS(3459),
    [anon_sym_BSLASHsupercite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite] = ACTIONS(3459),
    [anon_sym_BSLASHAutocite] = ACTIONS(3459),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(3461),
    [anon_sym_BSLASHvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHVolcite] = ACTIONS(3459),
    [anon_sym_BSLASHpvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHPvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHfvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHftvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHsvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHSvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHtvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHTvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHavolcite] = ACTIONS(3459),
    [anon_sym_BSLASHAvolcite] = ACTIONS(3459),
    [anon_sym_BSLASHnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHNotecite] = ACTIONS(3459),
    [anon_sym_BSLASHpnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHPnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHfnotecite] = ACTIONS(3459),
    [anon_sym_BSLASHlabel] = ACTIONS(3463),
    [anon_sym_BSLASHref] = ACTIONS(3465),
    [anon_sym_BSLASHeqref] = ACTIONS(3465),
    [anon_sym_BSLASHvref] = ACTIONS(3465),
    [anon_sym_BSLASHVref] = ACTIONS(3465),
    [anon_sym_BSLASHautoref] = ACTIONS(3465),
    [anon_sym_BSLASHpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcref] = ACTIONS(3465),
    [anon_sym_BSLASHCref] = ACTIONS(3465),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(3467),
    [anon_sym_BSLASHnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnameCref] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(3465),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcref] = ACTIONS(3465),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(3465),
    [anon_sym_BSLASHcrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHCrefrange] = ACTIONS(3469),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(3471),
    [anon_sym_BSLASHnewlabel] = ACTIONS(3473),
    [anon_sym_BSLASHnewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(3475),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(3477),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(3475),
    [anon_sym_BSLASHdef] = ACTIONS(3479),
    [anon_sym_BSLASHlet] = ACTIONS(3481),
    [anon_sym_BSLASHleft] = ACTIONS(3846),
    [anon_sym_BSLASHbigl] = ACTIONS(3846),
    [anon_sym_BSLASHBigl] = ACTIONS(3846),
    [anon_sym_BSLASHbiggl] = ACTIONS(3846),
    [anon_sym_BSLASHBiggl] = ACTIONS(3846),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(3485),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(3485),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(3487),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(3487),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(3489),
    [anon_sym_BSLASHgls] = ACTIONS(3491),
    [anon_sym_BSLASHGls] = ACTIONS(3491),
    [anon_sym_BSLASHGLS] = ACTIONS(3491),
    [anon_sym_BSLASHglspl] = ACTIONS(3491),
    [anon_sym_BSLASHGlspl] = ACTIONS(3491),
    [anon_sym_BSLASHGLSpl] = ACTIONS(3491),
    [anon_sym_BSLASHglsdisp] = ACTIONS(3491),
    [anon_sym_BSLASHglslink] = ACTIONS(3491),
    [anon_sym_BSLASHglstext] = ACTIONS(3491),
    [anon_sym_BSLASHGlstext] = ACTIONS(3491),
    [anon_sym_BSLASHGLStext] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(3491),
    [anon_sym_BSLASHglsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(3491),
    [anon_sym_BSLASHglsname] = ACTIONS(3491),
    [anon_sym_BSLASHGlsname] = ACTIONS(3491),
    [anon_sym_BSLASHGLSname] = ACTIONS(3491),
    [anon_sym_BSLASHglssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(3491),
    [anon_sym_BSLASHglsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(3491),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(3491),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(3491),
    [anon_sym_BSLASHglsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(3491),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(3491),
    [anon_sym_BSLASHnewacronym] = ACTIONS(3493),
    [anon_sym_BSLASHacrshort] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshort] = ACTIONS(3495),
    [anon_sym_BSLASHACRshort] = ACTIONS(3495),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrlong] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlong] = ACTIONS(3495),
    [anon_sym_BSLASHACRlong] = ACTIONS(3495),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(3495),
    [anon_sym_BSLASHacrfull] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfull] = ACTIONS(3495),
    [anon_sym_BSLASHACRfull] = ACTIONS(3495),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHacs] = ACTIONS(3495),
    [anon_sym_BSLASHAcs] = ACTIONS(3495),
    [anon_sym_BSLASHacsp] = ACTIONS(3495),
    [anon_sym_BSLASHAcsp] = ACTIONS(3495),
    [anon_sym_BSLASHacl] = ACTIONS(3495),
    [anon_sym_BSLASHAcl] = ACTIONS(3495),
    [anon_sym_BSLASHaclp] = ACTIONS(3495),
    [anon_sym_BSLASHAclp] = ACTIONS(3495),
    [anon_sym_BSLASHacf] = ACTIONS(3495),
    [anon_sym_BSLASHAcf] = ACTIONS(3495),
    [anon_sym_BSLASHacfp] = ACTIONS(3495),
    [anon_sym_BSLASHAcfp] = ACTIONS(3495),
    [anon_sym_BSLASHac] = ACTIONS(3495),
    [anon_sym_BSLASHAc] = ACTIONS(3495),
    [anon_sym_BSLASHacp] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(3495),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(3495),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(3495),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(3497),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(3497),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(3499),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(3501),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(3503),
    [anon_sym_BSLASHcolor] = ACTIONS(3505),
    [anon_sym_BSLASHcolorbox] = ACTIONS(3505),
    [anon_sym_BSLASHtextcolor] = ACTIONS(3505),
    [anon_sym_BSLASHpagecolor] = ACTIONS(3505),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(3507),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(3507),
    [anon_sym_BSLASHtext] = ACTIONS(3846),
    [anon_sym_BSLASHintertext] = ACTIONS(3846),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3846),
    [anon_sym_BSLASHurl] = ACTIONS(3511),
    [anon_sym_BSLASHhref] = ACTIONS(3511),
  },
  [323] = {
    [sym_block_comment] = STATE(1763),
    [sym_operator] = STATE(1763),
    [sym_subscript] = STATE(1763),
    [sym_superscript] = STATE(1763),
    [sym__command] = STATE(1763),
    [sym_generic_command] = STATE(1763),
    [sym_title_declaration] = STATE(1763),
    [sym_author_declaration] = STATE(1763),
    [sym_package_include] = STATE(1763),
    [sym_class_include] = STATE(1763),
    [sym_latex_include] = STATE(1763),
    [sym_biblatex_include] = STATE(1763),
    [sym_bibstyle_include] = STATE(1763),
    [sym_bibtex_include] = STATE(1763),
    [sym_graphics_include] = STATE(1763),
    [sym_svg_include] = STATE(1763),
    [sym_inkscape_include] = STATE(1763),
    [sym_verbatim_include] = STATE(1763),
    [sym_import_include] = STATE(1763),
    [sym_caption] = STATE(1763),
    [sym_citation] = STATE(1763),
    [sym_label_definition] = STATE(1763),
    [sym_label_reference] = STATE(1763),
    [sym_label_reference_range] = STATE(1763),
    [sym_label_number] = STATE(1763),
    [sym_new_command_definition] = STATE(1763),
    [sym_old_command_definition] = STATE(1763),
    [sym_let_command_definition] = STATE(1763),
    [sym_paired_delimiter_definition] = STATE(1763),
    [sym_environment_definition] = STATE(1763),
    [sym_glossary_entry_definition] = STATE(1763),
    [sym_glossary_entry_reference] = STATE(1763),
    [sym_acronym_definition] = STATE(1763),
    [sym_acronym_reference] = STATE(1763),
    [sym_theorem_definition] = STATE(1763),
    [sym_color_definition] = STATE(1763),
    [sym_color_set_definition] = STATE(1763),
    [sym_color_reference] = STATE(1763),
    [sym_tikz_library_import] = STATE(1763),
    [sym_hyperlink] = STATE(1763),
    [aux_sym_text_repeat1] = STATE(323),
    [sym_command_name] = ACTIONS(5667),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5670),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [sym_word] = ACTIONS(5673),
    [sym_placeholder] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5679),
    [anon_sym_DASH] = ACTIONS(5679),
    [anon_sym_STAR] = ACTIONS(5679),
    [anon_sym_SLASH] = ACTIONS(5679),
    [anon_sym_LT] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5682),
    [anon_sym_BANG] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5682),
    [anon_sym_COLON] = ACTIONS(5682),
    [anon_sym_SQUOTE] = ACTIONS(5682),
    [anon_sym__] = ACTIONS(5685),
    [anon_sym_CARET] = ACTIONS(5688),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3705),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3705),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHbegin] = ACTIONS(3707),
    [anon_sym_BSLASHtitle] = ACTIONS(5691),
    [anon_sym_BSLASHauthor] = ACTIONS(5694),
    [anon_sym_BSLASHusepackage] = ACTIONS(5697),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5697),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5700),
    [anon_sym_BSLASHinclude] = ACTIONS(5703),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5703),
    [anon_sym_BSLASHinput] = ACTIONS(5703),
    [anon_sym_BSLASHsubfile] = ACTIONS(5703),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5706),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5709),
    [anon_sym_BSLASHbibliography] = ACTIONS(5712),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5715),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5718),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5721),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5724),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5724),
    [anon_sym_BSLASHimport] = ACTIONS(5727),
    [anon_sym_BSLASHsubimport] = ACTIONS(5727),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5727),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5727),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5727),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5727),
    [anon_sym_BSLASHcaption] = ACTIONS(5730),
    [anon_sym_BSLASHcite] = ACTIONS(5733),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHCite] = ACTIONS(5733),
    [anon_sym_BSLASHnocite] = ACTIONS(5733),
    [anon_sym_BSLASHcitet] = ACTIONS(5733),
    [anon_sym_BSLASHcitep] = ACTIONS(5733),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHciteA] = ACTIONS(5733),
    [anon_sym_BSLASHciteR] = ACTIONS(5733),
    [anon_sym_BSLASHciteS] = ACTIONS(5733),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5733),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5733),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5733),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5733),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHciteyear] = ACTIONS(5733),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHcitedate] = ACTIONS(5733),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHciteurl] = ACTIONS(5733),
    [anon_sym_BSLASHfullcite] = ACTIONS(5733),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5733),
    [anon_sym_BSLASHcitealt] = ACTIONS(5733),
    [anon_sym_BSLASHcitealp] = ACTIONS(5733),
    [anon_sym_BSLASHcitetext] = ACTIONS(5733),
    [anon_sym_BSLASHparencite] = ACTIONS(5733),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHParencite] = ACTIONS(5733),
    [anon_sym_BSLASHfootcite] = ACTIONS(5733),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5733),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5733),
    [anon_sym_BSLASHtextcite] = ACTIONS(5733),
    [anon_sym_BSLASHTextcite] = ACTIONS(5733),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5733),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5733),
    [anon_sym_BSLASHsupercite] = ACTIONS(5733),
    [anon_sym_BSLASHautocite] = ACTIONS(5733),
    [anon_sym_BSLASHAutocite] = ACTIONS(5733),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5736),
    [anon_sym_BSLASHvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHVolcite] = ACTIONS(5733),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHavolcite] = ACTIONS(5733),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5733),
    [anon_sym_BSLASHnotecite] = ACTIONS(5733),
    [anon_sym_BSLASHNotecite] = ACTIONS(5733),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5733),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5733),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5733),
    [anon_sym_BSLASHlabel] = ACTIONS(5739),
    [anon_sym_BSLASHref] = ACTIONS(5742),
    [anon_sym_BSLASHeqref] = ACTIONS(5742),
    [anon_sym_BSLASHvref] = ACTIONS(5742),
    [anon_sym_BSLASHVref] = ACTIONS(5742),
    [anon_sym_BSLASHautoref] = ACTIONS(5742),
    [anon_sym_BSLASHpageref] = ACTIONS(5742),
    [anon_sym_BSLASHcref] = ACTIONS(5742),
    [anon_sym_BSLASHCref] = ACTIONS(5742),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5745),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5745),
    [anon_sym_BSLASHnamecref] = ACTIONS(5742),
    [anon_sym_BSLASHnameCref] = ACTIONS(5742),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5742),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5742),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5742),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5742),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5742),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5742),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5748),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5751),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5748),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5751),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5754),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5757),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5760),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5757),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5760),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5757),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5760),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5757),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5760),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5757),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5757),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5757),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5757),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5757),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5757),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5757),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5757),
    [anon_sym_BSLASHdef] = ACTIONS(5763),
    [anon_sym_BSLASHlet] = ACTIONS(5766),
    [anon_sym_BSLASHleft] = ACTIONS(3707),
    [anon_sym_BSLASHbigl] = ACTIONS(3707),
    [anon_sym_BSLASHBigl] = ACTIONS(3707),
    [anon_sym_BSLASHbiggl] = ACTIONS(3707),
    [anon_sym_BSLASHBiggl] = ACTIONS(3707),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5769),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5769),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5772),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5772),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5772),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5772),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5772),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5772),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5775),
    [anon_sym_BSLASHgls] = ACTIONS(5778),
    [anon_sym_BSLASHGls] = ACTIONS(5778),
    [anon_sym_BSLASHGLS] = ACTIONS(5778),
    [anon_sym_BSLASHglspl] = ACTIONS(5778),
    [anon_sym_BSLASHGlspl] = ACTIONS(5778),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5778),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5778),
    [anon_sym_BSLASHglslink] = ACTIONS(5778),
    [anon_sym_BSLASHglstext] = ACTIONS(5778),
    [anon_sym_BSLASHGlstext] = ACTIONS(5778),
    [anon_sym_BSLASHGLStext] = ACTIONS(5778),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5778),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5778),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5778),
    [anon_sym_BSLASHglsplural] = ACTIONS(5778),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5778),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5778),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5778),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5778),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5778),
    [anon_sym_BSLASHglsname] = ACTIONS(5778),
    [anon_sym_BSLASHGlsname] = ACTIONS(5778),
    [anon_sym_BSLASHGLSname] = ACTIONS(5778),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5778),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5778),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5778),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5778),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5778),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5778),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5778),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5778),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5778),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5778),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5778),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5778),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5778),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5778),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5778),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5778),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5778),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5778),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5778),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5778),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5778),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5778),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5778),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5781),
    [anon_sym_BSLASHacrshort] = ACTIONS(5784),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5784),
    [anon_sym_BSLASHACRshort] = ACTIONS(5784),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5784),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5784),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5784),
    [anon_sym_BSLASHacrlong] = ACTIONS(5784),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5784),
    [anon_sym_BSLASHACRlong] = ACTIONS(5784),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5784),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5784),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5784),
    [anon_sym_BSLASHacrfull] = ACTIONS(5784),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5784),
    [anon_sym_BSLASHACRfull] = ACTIONS(5784),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5784),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5784),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5784),
    [anon_sym_BSLASHacs] = ACTIONS(5784),
    [anon_sym_BSLASHAcs] = ACTIONS(5784),
    [anon_sym_BSLASHacsp] = ACTIONS(5784),
    [anon_sym_BSLASHAcsp] = ACTIONS(5784),
    [anon_sym_BSLASHacl] = ACTIONS(5784),
    [anon_sym_BSLASHAcl] = ACTIONS(5784),
    [anon_sym_BSLASHaclp] = ACTIONS(5784),
    [anon_sym_BSLASHAclp] = ACTIONS(5784),
    [anon_sym_BSLASHacf] = ACTIONS(5784),
    [anon_sym_BSLASHAcf] = ACTIONS(5784),
    [anon_sym_BSLASHacfp] = ACTIONS(5784),
    [anon_sym_BSLASHAcfp] = ACTIONS(5784),
    [anon_sym_BSLASHac] = ACTIONS(5784),
    [anon_sym_BSLASHAc] = ACTIONS(5784),
    [anon_sym_BSLASHacp] = ACTIONS(5784),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5784),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5784),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5784),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5784),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5784),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5784),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5784),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5784),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5784),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5784),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5787),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5790),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5787),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5790),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5793),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5796),
    [anon_sym_BSLASHcolor] = ACTIONS(5799),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5799),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5799),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5799),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5802),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5802),
    [anon_sym_BSLASHtext] = ACTIONS(3707),
    [anon_sym_BSLASHintertext] = ACTIONS(3707),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3707),
    [anon_sym_BSLASHurl] = ACTIONS(5805),
    [anon_sym_BSLASHhref] = ACTIONS(5805),
  },
  [324] = {
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(375),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(376),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(377),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(378),
    [aux_sym__section_repeat2] = STATE(375),
    [aux_sym__section_repeat3] = STATE(376),
    [aux_sym__section_repeat4] = STATE(377),
    [aux_sym__section_repeat5] = STATE(378),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHright] = ACTIONS(2132),
    [anon_sym_BSLASHbigr] = ACTIONS(2132),
    [anon_sym_BSLASHBigr] = ACTIONS(2132),
    [anon_sym_BSLASHbiggr] = ACTIONS(2132),
    [anon_sym_BSLASHBiggr] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [325] = {
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(406),
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(407),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(408),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(409),
    [aux_sym__section_repeat2] = STATE(406),
    [aux_sym__section_repeat3] = STATE(407),
    [aux_sym__section_repeat4] = STATE(408),
    [aux_sym__section_repeat5] = STATE(409),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHright] = ACTIONS(5808),
    [anon_sym_BSLASHbigr] = ACTIONS(5808),
    [anon_sym_BSLASHBigr] = ACTIONS(5808),
    [anon_sym_BSLASHbiggr] = ACTIONS(5808),
    [anon_sym_BSLASHBiggr] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [326] = {
    [sym_block_comment] = STATE(1949),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym__command] = STATE(1949),
    [sym_generic_command] = STATE(1949),
    [sym_title_declaration] = STATE(1949),
    [sym_author_declaration] = STATE(1949),
    [sym_package_include] = STATE(1949),
    [sym_class_include] = STATE(1949),
    [sym_latex_include] = STATE(1949),
    [sym_biblatex_include] = STATE(1949),
    [sym_bibstyle_include] = STATE(1949),
    [sym_bibtex_include] = STATE(1949),
    [sym_graphics_include] = STATE(1949),
    [sym_svg_include] = STATE(1949),
    [sym_inkscape_include] = STATE(1949),
    [sym_verbatim_include] = STATE(1949),
    [sym_import_include] = STATE(1949),
    [sym_caption] = STATE(1949),
    [sym_citation] = STATE(1949),
    [sym_label_definition] = STATE(1949),
    [sym_label_reference] = STATE(1949),
    [sym_label_reference_range] = STATE(1949),
    [sym_label_number] = STATE(1949),
    [sym_new_command_definition] = STATE(1949),
    [sym_old_command_definition] = STATE(1949),
    [sym_let_command_definition] = STATE(1949),
    [sym_paired_delimiter_definition] = STATE(1949),
    [sym_environment_definition] = STATE(1949),
    [sym_glossary_entry_definition] = STATE(1949),
    [sym_glossary_entry_reference] = STATE(1949),
    [sym_acronym_definition] = STATE(1949),
    [sym_acronym_reference] = STATE(1949),
    [sym_theorem_definition] = STATE(1949),
    [sym_color_definition] = STATE(1949),
    [sym_color_set_definition] = STATE(1949),
    [sym_color_reference] = STATE(1949),
    [sym_tikz_library_import] = STATE(1949),
    [sym_hyperlink] = STATE(1949),
    [aux_sym_text_repeat1] = STATE(327),
    [sym_command_name] = ACTIONS(5061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5063),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [anon_sym_RPAREN] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [anon_sym_RBRACE] = ACTIONS(3844),
    [anon_sym_BSLASHand] = ACTIONS(3846),
    [sym_word] = ACTIONS(5073),
    [sym_placeholder] = ACTIONS(5075),
    [anon_sym_PLUS] = ACTIONS(5077),
    [anon_sym_DASH] = ACTIONS(5077),
    [anon_sym_STAR] = ACTIONS(5077),
    [anon_sym_SLASH] = ACTIONS(5077),
    [anon_sym_LT] = ACTIONS(5079),
    [anon_sym_GT] = ACTIONS(5079),
    [anon_sym_BANG] = ACTIONS(5079),
    [anon_sym_PIPE] = ACTIONS(5079),
    [anon_sym_COLON] = ACTIONS(5079),
    [anon_sym_SQUOTE] = ACTIONS(5079),
    [anon_sym__] = ACTIONS(5081),
    [anon_sym_CARET] = ACTIONS(5083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3844),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3844),
    [anon_sym_DOLLAR] = ACTIONS(3846),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3844),
    [anon_sym_BSLASHtitle] = ACTIONS(5091),
    [anon_sym_BSLASHauthor] = ACTIONS(5093),
    [anon_sym_BSLASHusepackage] = ACTIONS(5095),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5095),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5097),
    [anon_sym_BSLASHinclude] = ACTIONS(5099),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5099),
    [anon_sym_BSLASHinput] = ACTIONS(5099),
    [anon_sym_BSLASHsubfile] = ACTIONS(5099),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5103),
    [anon_sym_BSLASHbibliography] = ACTIONS(5105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5107),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5109),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5113),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5113),
    [anon_sym_BSLASHimport] = ACTIONS(5115),
    [anon_sym_BSLASHsubimport] = ACTIONS(5115),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5115),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5115),
    [anon_sym_BSLASHcaption] = ACTIONS(5117),
    [anon_sym_BSLASHcite] = ACTIONS(5119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCite] = ACTIONS(5119),
    [anon_sym_BSLASHnocite] = ACTIONS(5119),
    [anon_sym_BSLASHcitet] = ACTIONS(5119),
    [anon_sym_BSLASHcitep] = ACTIONS(5119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteA] = ACTIONS(5119),
    [anon_sym_BSLASHciteR] = ACTIONS(5119),
    [anon_sym_BSLASHciteS] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteyear] = ACTIONS(5119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHcitedate] = ACTIONS(5119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHciteurl] = ACTIONS(5119),
    [anon_sym_BSLASHfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5119),
    [anon_sym_BSLASHcitealt] = ACTIONS(5119),
    [anon_sym_BSLASHcitealp] = ACTIONS(5119),
    [anon_sym_BSLASHcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHparencite] = ACTIONS(5119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHParencite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5119),
    [anon_sym_BSLASHtextcite] = ACTIONS(5119),
    [anon_sym_BSLASHTextcite] = ACTIONS(5119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5119),
    [anon_sym_BSLASHsupercite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite] = ACTIONS(5119),
    [anon_sym_BSLASHAutocite] = ACTIONS(5119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5121),
    [anon_sym_BSLASHvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHVolcite] = ACTIONS(5119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHavolcite] = ACTIONS(5119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5119),
    [anon_sym_BSLASHnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHNotecite] = ACTIONS(5119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5119),
    [anon_sym_BSLASHlabel] = ACTIONS(5123),
    [anon_sym_BSLASHref] = ACTIONS(5125),
    [anon_sym_BSLASHeqref] = ACTIONS(5125),
    [anon_sym_BSLASHvref] = ACTIONS(5125),
    [anon_sym_BSLASHVref] = ACTIONS(5125),
    [anon_sym_BSLASHautoref] = ACTIONS(5125),
    [anon_sym_BSLASHpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcref] = ACTIONS(5125),
    [anon_sym_BSLASHCref] = ACTIONS(5125),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5127),
    [anon_sym_BSLASHnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnameCref] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5125),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5125),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5125),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5129),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5131),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5133),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5135),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5137),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5135),
    [anon_sym_BSLASHdef] = ACTIONS(5139),
    [anon_sym_BSLASHlet] = ACTIONS(5141),
    [anon_sym_BSLASHleft] = ACTIONS(3846),
    [anon_sym_BSLASHbigl] = ACTIONS(3846),
    [anon_sym_BSLASHBigl] = ACTIONS(3846),
    [anon_sym_BSLASHbiggl] = ACTIONS(3846),
    [anon_sym_BSLASHBiggl] = ACTIONS(3846),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5145),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5145),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5147),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5147),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5149),
    [anon_sym_BSLASHgls] = ACTIONS(5151),
    [anon_sym_BSLASHGls] = ACTIONS(5151),
    [anon_sym_BSLASHGLS] = ACTIONS(5151),
    [anon_sym_BSLASHglspl] = ACTIONS(5151),
    [anon_sym_BSLASHGlspl] = ACTIONS(5151),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5151),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5151),
    [anon_sym_BSLASHglslink] = ACTIONS(5151),
    [anon_sym_BSLASHglstext] = ACTIONS(5151),
    [anon_sym_BSLASHGlstext] = ACTIONS(5151),
    [anon_sym_BSLASHGLStext] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5151),
    [anon_sym_BSLASHglsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5151),
    [anon_sym_BSLASHglsname] = ACTIONS(5151),
    [anon_sym_BSLASHGlsname] = ACTIONS(5151),
    [anon_sym_BSLASHGLSname] = ACTIONS(5151),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5151),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5151),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5151),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5151),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5151),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5151),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5153),
    [anon_sym_BSLASHacrshort] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5155),
    [anon_sym_BSLASHACRshort] = ACTIONS(5155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrlong] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5155),
    [anon_sym_BSLASHACRlong] = ACTIONS(5155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5155),
    [anon_sym_BSLASHacrfull] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5155),
    [anon_sym_BSLASHACRfull] = ACTIONS(5155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHacs] = ACTIONS(5155),
    [anon_sym_BSLASHAcs] = ACTIONS(5155),
    [anon_sym_BSLASHacsp] = ACTIONS(5155),
    [anon_sym_BSLASHAcsp] = ACTIONS(5155),
    [anon_sym_BSLASHacl] = ACTIONS(5155),
    [anon_sym_BSLASHAcl] = ACTIONS(5155),
    [anon_sym_BSLASHaclp] = ACTIONS(5155),
    [anon_sym_BSLASHAclp] = ACTIONS(5155),
    [anon_sym_BSLASHacf] = ACTIONS(5155),
    [anon_sym_BSLASHAcf] = ACTIONS(5155),
    [anon_sym_BSLASHacfp] = ACTIONS(5155),
    [anon_sym_BSLASHAcfp] = ACTIONS(5155),
    [anon_sym_BSLASHac] = ACTIONS(5155),
    [anon_sym_BSLASHAc] = ACTIONS(5155),
    [anon_sym_BSLASHacp] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5157),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5157),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5159),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5163),
    [anon_sym_BSLASHcolor] = ACTIONS(5165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5167),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5167),
    [anon_sym_BSLASHtext] = ACTIONS(3846),
    [anon_sym_BSLASHintertext] = ACTIONS(3846),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3846),
    [anon_sym_BSLASHurl] = ACTIONS(5171),
    [anon_sym_BSLASHhref] = ACTIONS(5171),
  },
  [327] = {
    [sym_block_comment] = STATE(1949),
    [sym_operator] = STATE(1949),
    [sym_subscript] = STATE(1949),
    [sym_superscript] = STATE(1949),
    [sym__command] = STATE(1949),
    [sym_generic_command] = STATE(1949),
    [sym_title_declaration] = STATE(1949),
    [sym_author_declaration] = STATE(1949),
    [sym_package_include] = STATE(1949),
    [sym_class_include] = STATE(1949),
    [sym_latex_include] = STATE(1949),
    [sym_biblatex_include] = STATE(1949),
    [sym_bibstyle_include] = STATE(1949),
    [sym_bibtex_include] = STATE(1949),
    [sym_graphics_include] = STATE(1949),
    [sym_svg_include] = STATE(1949),
    [sym_inkscape_include] = STATE(1949),
    [sym_verbatim_include] = STATE(1949),
    [sym_import_include] = STATE(1949),
    [sym_caption] = STATE(1949),
    [sym_citation] = STATE(1949),
    [sym_label_definition] = STATE(1949),
    [sym_label_reference] = STATE(1949),
    [sym_label_reference_range] = STATE(1949),
    [sym_label_number] = STATE(1949),
    [sym_new_command_definition] = STATE(1949),
    [sym_old_command_definition] = STATE(1949),
    [sym_let_command_definition] = STATE(1949),
    [sym_paired_delimiter_definition] = STATE(1949),
    [sym_environment_definition] = STATE(1949),
    [sym_glossary_entry_definition] = STATE(1949),
    [sym_glossary_entry_reference] = STATE(1949),
    [sym_acronym_definition] = STATE(1949),
    [sym_acronym_reference] = STATE(1949),
    [sym_theorem_definition] = STATE(1949),
    [sym_color_definition] = STATE(1949),
    [sym_color_set_definition] = STATE(1949),
    [sym_color_reference] = STATE(1949),
    [sym_tikz_library_import] = STATE(1949),
    [sym_hyperlink] = STATE(1949),
    [aux_sym_text_repeat1] = STATE(327),
    [sym_command_name] = ACTIONS(5812),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5815),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_BSLASHand] = ACTIONS(3707),
    [sym_word] = ACTIONS(5818),
    [sym_placeholder] = ACTIONS(5821),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_DASH] = ACTIONS(5824),
    [anon_sym_STAR] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5827),
    [anon_sym_GT] = ACTIONS(5827),
    [anon_sym_BANG] = ACTIONS(5827),
    [anon_sym_PIPE] = ACTIONS(5827),
    [anon_sym_COLON] = ACTIONS(5827),
    [anon_sym_SQUOTE] = ACTIONS(5827),
    [anon_sym__] = ACTIONS(5830),
    [anon_sym_CARET] = ACTIONS(5833),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(3705),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(3705),
    [anon_sym_DOLLAR] = ACTIONS(3707),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(3705),
    [anon_sym_BSLASHtitle] = ACTIONS(5836),
    [anon_sym_BSLASHauthor] = ACTIONS(5839),
    [anon_sym_BSLASHusepackage] = ACTIONS(5842),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5842),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5845),
    [anon_sym_BSLASHinclude] = ACTIONS(5848),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5848),
    [anon_sym_BSLASHinput] = ACTIONS(5848),
    [anon_sym_BSLASHsubfile] = ACTIONS(5848),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5851),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5854),
    [anon_sym_BSLASHbibliography] = ACTIONS(5857),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5860),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5863),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5866),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5869),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5869),
    [anon_sym_BSLASHimport] = ACTIONS(5872),
    [anon_sym_BSLASHsubimport] = ACTIONS(5872),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5872),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5872),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5872),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5872),
    [anon_sym_BSLASHcaption] = ACTIONS(5875),
    [anon_sym_BSLASHcite] = ACTIONS(5878),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHCite] = ACTIONS(5878),
    [anon_sym_BSLASHnocite] = ACTIONS(5878),
    [anon_sym_BSLASHcitet] = ACTIONS(5878),
    [anon_sym_BSLASHcitep] = ACTIONS(5878),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHciteA] = ACTIONS(5878),
    [anon_sym_BSLASHciteR] = ACTIONS(5878),
    [anon_sym_BSLASHciteS] = ACTIONS(5878),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5878),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5878),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5878),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5878),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHciteyear] = ACTIONS(5878),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHcitedate] = ACTIONS(5878),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHciteurl] = ACTIONS(5878),
    [anon_sym_BSLASHfullcite] = ACTIONS(5878),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5878),
    [anon_sym_BSLASHcitealt] = ACTIONS(5878),
    [anon_sym_BSLASHcitealp] = ACTIONS(5878),
    [anon_sym_BSLASHcitetext] = ACTIONS(5878),
    [anon_sym_BSLASHparencite] = ACTIONS(5878),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHParencite] = ACTIONS(5878),
    [anon_sym_BSLASHfootcite] = ACTIONS(5878),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5878),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5878),
    [anon_sym_BSLASHtextcite] = ACTIONS(5878),
    [anon_sym_BSLASHTextcite] = ACTIONS(5878),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5878),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5878),
    [anon_sym_BSLASHsupercite] = ACTIONS(5878),
    [anon_sym_BSLASHautocite] = ACTIONS(5878),
    [anon_sym_BSLASHAutocite] = ACTIONS(5878),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5881),
    [anon_sym_BSLASHvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHVolcite] = ACTIONS(5878),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHavolcite] = ACTIONS(5878),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5878),
    [anon_sym_BSLASHnotecite] = ACTIONS(5878),
    [anon_sym_BSLASHNotecite] = ACTIONS(5878),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5878),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5878),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5878),
    [anon_sym_BSLASHlabel] = ACTIONS(5884),
    [anon_sym_BSLASHref] = ACTIONS(5887),
    [anon_sym_BSLASHeqref] = ACTIONS(5887),
    [anon_sym_BSLASHvref] = ACTIONS(5887),
    [anon_sym_BSLASHVref] = ACTIONS(5887),
    [anon_sym_BSLASHautoref] = ACTIONS(5887),
    [anon_sym_BSLASHpageref] = ACTIONS(5887),
    [anon_sym_BSLASHcref] = ACTIONS(5887),
    [anon_sym_BSLASHCref] = ACTIONS(5887),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5890),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5890),
    [anon_sym_BSLASHnamecref] = ACTIONS(5887),
    [anon_sym_BSLASHnameCref] = ACTIONS(5887),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5887),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5887),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5887),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5887),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5887),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5887),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5893),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5896),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5893),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5896),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5899),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5902),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5905),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5902),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5905),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5902),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5905),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5902),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5905),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5902),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5902),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5902),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5902),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5902),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5902),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5902),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5902),
    [anon_sym_BSLASHdef] = ACTIONS(5908),
    [anon_sym_BSLASHlet] = ACTIONS(5911),
    [anon_sym_BSLASHleft] = ACTIONS(3707),
    [anon_sym_BSLASHbigl] = ACTIONS(3707),
    [anon_sym_BSLASHBigl] = ACTIONS(3707),
    [anon_sym_BSLASHbiggl] = ACTIONS(3707),
    [anon_sym_BSLASHBiggl] = ACTIONS(3707),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5914),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5914),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5917),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5917),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5917),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5917),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5917),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5917),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5920),
    [anon_sym_BSLASHgls] = ACTIONS(5923),
    [anon_sym_BSLASHGls] = ACTIONS(5923),
    [anon_sym_BSLASHGLS] = ACTIONS(5923),
    [anon_sym_BSLASHglspl] = ACTIONS(5923),
    [anon_sym_BSLASHGlspl] = ACTIONS(5923),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5923),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5923),
    [anon_sym_BSLASHglslink] = ACTIONS(5923),
    [anon_sym_BSLASHglstext] = ACTIONS(5923),
    [anon_sym_BSLASHGlstext] = ACTIONS(5923),
    [anon_sym_BSLASHGLStext] = ACTIONS(5923),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5923),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5923),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5923),
    [anon_sym_BSLASHglsplural] = ACTIONS(5923),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5923),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5923),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5923),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5923),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5923),
    [anon_sym_BSLASHglsname] = ACTIONS(5923),
    [anon_sym_BSLASHGlsname] = ACTIONS(5923),
    [anon_sym_BSLASHGLSname] = ACTIONS(5923),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5923),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5923),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5923),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5923),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5923),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5923),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5923),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5923),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5923),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5923),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5923),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5923),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5923),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5923),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5923),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5923),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5923),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5923),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5923),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5923),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5923),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5923),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5923),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5926),
    [anon_sym_BSLASHacrshort] = ACTIONS(5929),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5929),
    [anon_sym_BSLASHACRshort] = ACTIONS(5929),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5929),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5929),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5929),
    [anon_sym_BSLASHacrlong] = ACTIONS(5929),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5929),
    [anon_sym_BSLASHACRlong] = ACTIONS(5929),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5929),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5929),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5929),
    [anon_sym_BSLASHacrfull] = ACTIONS(5929),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5929),
    [anon_sym_BSLASHACRfull] = ACTIONS(5929),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5929),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5929),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5929),
    [anon_sym_BSLASHacs] = ACTIONS(5929),
    [anon_sym_BSLASHAcs] = ACTIONS(5929),
    [anon_sym_BSLASHacsp] = ACTIONS(5929),
    [anon_sym_BSLASHAcsp] = ACTIONS(5929),
    [anon_sym_BSLASHacl] = ACTIONS(5929),
    [anon_sym_BSLASHAcl] = ACTIONS(5929),
    [anon_sym_BSLASHaclp] = ACTIONS(5929),
    [anon_sym_BSLASHAclp] = ACTIONS(5929),
    [anon_sym_BSLASHacf] = ACTIONS(5929),
    [anon_sym_BSLASHAcf] = ACTIONS(5929),
    [anon_sym_BSLASHacfp] = ACTIONS(5929),
    [anon_sym_BSLASHAcfp] = ACTIONS(5929),
    [anon_sym_BSLASHac] = ACTIONS(5929),
    [anon_sym_BSLASHAc] = ACTIONS(5929),
    [anon_sym_BSLASHacp] = ACTIONS(5929),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5929),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5929),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5929),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5929),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5929),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5929),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5929),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5929),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5929),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5929),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5932),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5935),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5932),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5935),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5938),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5941),
    [anon_sym_BSLASHcolor] = ACTIONS(5944),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5944),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5944),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5944),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5947),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5947),
    [anon_sym_BSLASHtext] = ACTIONS(3707),
    [anon_sym_BSLASHintertext] = ACTIONS(3707),
    [anon_sym_BSLASHshortintertext] = ACTIONS(3707),
    [anon_sym_BSLASHurl] = ACTIONS(5950),
    [anon_sym_BSLASHhref] = ACTIONS(5950),
  },
  [328] = {
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(586),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(441),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(639),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(638),
    [aux_sym__section_repeat2] = STATE(586),
    [aux_sym__section_repeat3] = STATE(441),
    [aux_sym__section_repeat4] = STATE(639),
    [aux_sym__section_repeat5] = STATE(638),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [329] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(383),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(384),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(385),
    [aux_sym__section_repeat3] = STATE(383),
    [aux_sym__section_repeat4] = STATE(384),
    [aux_sym__section_repeat5] = STATE(385),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHright] = ACTIONS(2144),
    [anon_sym_BSLASHbigr] = ACTIONS(2144),
    [anon_sym_BSLASHBigr] = ACTIONS(2144),
    [anon_sym_BSLASHbiggr] = ACTIONS(2144),
    [anon_sym_BSLASHBiggr] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [330] = {
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(511),
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(502),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(501),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(500),
    [aux_sym__section_repeat2] = STATE(511),
    [aux_sym__section_repeat3] = STATE(502),
    [aux_sym__section_repeat4] = STATE(501),
    [aux_sym__section_repeat5] = STATE(500),
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [331] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(410),
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(411),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(412),
    [aux_sym__section_repeat3] = STATE(410),
    [aux_sym__section_repeat4] = STATE(411),
    [aux_sym__section_repeat5] = STATE(412),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHright] = ACTIONS(5953),
    [anon_sym_BSLASHbigr] = ACTIONS(5953),
    [anon_sym_BSLASHBigr] = ACTIONS(5953),
    [anon_sym_BSLASHbiggr] = ACTIONS(5953),
    [anon_sym_BSLASHBiggr] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [332] = {
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(848),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(849),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(850),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(851),
    [aux_sym__section_repeat2] = STATE(848),
    [aux_sym__section_repeat3] = STATE(849),
    [aux_sym__section_repeat4] = STATE(850),
    [aux_sym__section_repeat5] = STATE(851),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [333] = {
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(660),
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(659),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(657),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(656),
    [aux_sym__section_repeat2] = STATE(660),
    [aux_sym__section_repeat3] = STATE(659),
    [aux_sym__section_repeat4] = STATE(657),
    [aux_sym__section_repeat5] = STATE(656),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [334] = {
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(664),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(665),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(666),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(671),
    [aux_sym__section_repeat2] = STATE(664),
    [aux_sym__section_repeat3] = STATE(665),
    [aux_sym__section_repeat4] = STATE(666),
    [aux_sym__section_repeat5] = STATE(671),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHend] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [335] = {
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(699),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(700),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(701),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(702),
    [aux_sym__section_repeat2] = STATE(699),
    [aux_sym__section_repeat3] = STATE(700),
    [aux_sym__section_repeat4] = STATE(701),
    [aux_sym__section_repeat5] = STATE(702),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [336] = {
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(667),
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(668),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(669),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(670),
    [aux_sym__section_repeat2] = STATE(667),
    [aux_sym__section_repeat3] = STATE(668),
    [aux_sym__section_repeat4] = STATE(669),
    [aux_sym__section_repeat5] = STATE(670),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [337] = {
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(842),
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(833),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(832),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(830),
    [aux_sym__section_repeat2] = STATE(842),
    [aux_sym__section_repeat3] = STATE(833),
    [aux_sym__section_repeat4] = STATE(832),
    [aux_sym__section_repeat5] = STATE(830),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHend] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [338] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(413),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(414),
    [aux_sym__section_repeat4] = STATE(413),
    [aux_sym__section_repeat5] = STATE(414),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHright] = ACTIONS(5957),
    [anon_sym_BSLASHbigr] = ACTIONS(5957),
    [anon_sym_BSLASHBigr] = ACTIONS(5957),
    [anon_sym_BSLASHbiggr] = ACTIONS(5957),
    [anon_sym_BSLASHBiggr] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [339] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(637),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(636),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(588),
    [aux_sym__section_repeat3] = STATE(637),
    [aux_sym__section_repeat4] = STATE(636),
    [aux_sym__section_repeat5] = STATE(588),
    [ts_builtin_sym_end] = ACTIONS(5955),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [anon_sym_RBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [340] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(392),
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(349),
    [aux_sym__section_repeat4] = STATE(392),
    [aux_sym__section_repeat5] = STATE(349),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHright] = ACTIONS(2172),
    [anon_sym_BSLASHbigr] = ACTIONS(2172),
    [anon_sym_BSLASHBigr] = ACTIONS(2172),
    [anon_sym_BSLASHbiggr] = ACTIONS(2172),
    [anon_sym_BSLASHBiggr] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [341] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(495),
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(479),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(467),
    [aux_sym__section_repeat3] = STATE(495),
    [aux_sym__section_repeat4] = STATE(479),
    [aux_sym__section_repeat5] = STATE(467),
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [342] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(655),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(654),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(652),
    [aux_sym__section_repeat3] = STATE(655),
    [aux_sym__section_repeat4] = STATE(654),
    [aux_sym__section_repeat5] = STATE(652),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [343] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(856),
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(857),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(858),
    [aux_sym__section_repeat3] = STATE(856),
    [aux_sym__section_repeat4] = STATE(857),
    [aux_sym__section_repeat5] = STATE(858),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [344] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(676),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(680),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(694),
    [aux_sym__section_repeat3] = STATE(676),
    [aux_sym__section_repeat4] = STATE(680),
    [aux_sym__section_repeat5] = STATE(694),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHend] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [345] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(703),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(704),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(705),
    [aux_sym__section_repeat3] = STATE(703),
    [aux_sym__section_repeat4] = STATE(704),
    [aux_sym__section_repeat5] = STATE(705),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [346] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(775),
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(772),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(771),
    [aux_sym__section_repeat3] = STATE(775),
    [aux_sym__section_repeat4] = STATE(772),
    [aux_sym__section_repeat5] = STATE(771),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHend] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [347] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(677),
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(678),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(679),
    [aux_sym__section_repeat3] = STATE(677),
    [aux_sym__section_repeat4] = STATE(678),
    [aux_sym__section_repeat5] = STATE(679),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [348] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(5961),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5963),
    [anon_sym_RBRACK] = ACTIONS(5963),
    [anon_sym_COMMA] = ACTIONS(5963),
    [anon_sym_EQ] = ACTIONS(5963),
    [anon_sym_LPAREN] = ACTIONS(5963),
    [anon_sym_RPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHpart] = ACTIONS(5961),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddpart] = ACTIONS(5961),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHchapter] = ACTIONS(5961),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddchap] = ACTIONS(5961),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsection] = ACTIONS(5961),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddsec] = ACTIONS(5961),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubsection] = ACTIONS(5965),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5968),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5961),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHitem] = ACTIONS(5961),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5963),
    [anon_sym_LBRACE] = ACTIONS(5963),
    [sym_word] = ACTIONS(5961),
    [sym_placeholder] = ACTIONS(5963),
    [anon_sym_PLUS] = ACTIONS(5963),
    [anon_sym_DASH] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_SLASH] = ACTIONS(5963),
    [anon_sym_LT] = ACTIONS(5961),
    [anon_sym_GT] = ACTIONS(5961),
    [anon_sym_BANG] = ACTIONS(5961),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_COLON] = ACTIONS(5961),
    [anon_sym_SQUOTE] = ACTIONS(5961),
    [anon_sym__] = ACTIONS(5963),
    [anon_sym_CARET] = ACTIONS(5963),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5963),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5963),
    [anon_sym_DOLLAR] = ACTIONS(5961),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHbegin] = ACTIONS(5961),
    [anon_sym_BSLASHtitle] = ACTIONS(5961),
    [anon_sym_BSLASHauthor] = ACTIONS(5961),
    [anon_sym_BSLASHusepackage] = ACTIONS(5961),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5961),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5961),
    [anon_sym_BSLASHinclude] = ACTIONS(5961),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5961),
    [anon_sym_BSLASHinput] = ACTIONS(5961),
    [anon_sym_BSLASHsubfile] = ACTIONS(5961),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5961),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5961),
    [anon_sym_BSLASHbibliography] = ACTIONS(5961),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5961),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5961),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5961),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5961),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5961),
    [anon_sym_BSLASHimport] = ACTIONS(5961),
    [anon_sym_BSLASHsubimport] = ACTIONS(5961),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5961),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHcaption] = ACTIONS(5961),
    [anon_sym_BSLASHcite] = ACTIONS(5961),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCite] = ACTIONS(5961),
    [anon_sym_BSLASHnocite] = ACTIONS(5961),
    [anon_sym_BSLASHcitet] = ACTIONS(5961),
    [anon_sym_BSLASHcitep] = ACTIONS(5961),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteA] = ACTIONS(5961),
    [anon_sym_BSLASHciteR] = ACTIONS(5961),
    [anon_sym_BSLASHciteS] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5961),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteyear] = ACTIONS(5961),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitedate] = ACTIONS(5961),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteurl] = ACTIONS(5961),
    [anon_sym_BSLASHfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5961),
    [anon_sym_BSLASHcitealt] = ACTIONS(5961),
    [anon_sym_BSLASHcitealp] = ACTIONS(5961),
    [anon_sym_BSLASHcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHparencite] = ACTIONS(5961),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHParencite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHtextcite] = ACTIONS(5961),
    [anon_sym_BSLASHTextcite] = ACTIONS(5961),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHsupercite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite] = ACTIONS(5961),
    [anon_sym_BSLASHAutocite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHVolcite] = ACTIONS(5961),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHavolcite] = ACTIONS(5961),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHNotecite] = ACTIONS(5961),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHlabel] = ACTIONS(5961),
    [anon_sym_BSLASHref] = ACTIONS(5961),
    [anon_sym_BSLASHeqref] = ACTIONS(5961),
    [anon_sym_BSLASHvref] = ACTIONS(5961),
    [anon_sym_BSLASHVref] = ACTIONS(5961),
    [anon_sym_BSLASHautoref] = ACTIONS(5961),
    [anon_sym_BSLASHpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcref] = ACTIONS(5961),
    [anon_sym_BSLASHCref] = ACTIONS(5961),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnameCref] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHdef] = ACTIONS(5961),
    [anon_sym_BSLASHlet] = ACTIONS(5961),
    [anon_sym_BSLASHleft] = ACTIONS(5961),
    [anon_sym_BSLASHbigl] = ACTIONS(5961),
    [anon_sym_BSLASHBigl] = ACTIONS(5961),
    [anon_sym_BSLASHbiggl] = ACTIONS(5961),
    [anon_sym_BSLASHBiggl] = ACTIONS(5961),
    [anon_sym_BSLASHright] = ACTIONS(5961),
    [anon_sym_BSLASHbigr] = ACTIONS(5961),
    [anon_sym_BSLASHBigr] = ACTIONS(5961),
    [anon_sym_BSLASHbiggr] = ACTIONS(5961),
    [anon_sym_BSLASHBiggr] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5961),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5961),
    [anon_sym_BSLASHgls] = ACTIONS(5961),
    [anon_sym_BSLASHGls] = ACTIONS(5961),
    [anon_sym_BSLASHGLS] = ACTIONS(5961),
    [anon_sym_BSLASHglspl] = ACTIONS(5961),
    [anon_sym_BSLASHGlspl] = ACTIONS(5961),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5961),
    [anon_sym_BSLASHglslink] = ACTIONS(5961),
    [anon_sym_BSLASHglstext] = ACTIONS(5961),
    [anon_sym_BSLASHGlstext] = ACTIONS(5961),
    [anon_sym_BSLASHGLStext] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5961),
    [anon_sym_BSLASHglsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsname] = ACTIONS(5961),
    [anon_sym_BSLASHGlsname] = ACTIONS(5961),
    [anon_sym_BSLASHGLSname] = ACTIONS(5961),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5961),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5961),
    [anon_sym_BSLASHacrshort] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5961),
    [anon_sym_BSLASHACRshort] = ACTIONS(5961),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrlong] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5961),
    [anon_sym_BSLASHACRlong] = ACTIONS(5961),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrfull] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5961),
    [anon_sym_BSLASHACRfull] = ACTIONS(5961),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHacs] = ACTIONS(5961),
    [anon_sym_BSLASHAcs] = ACTIONS(5961),
    [anon_sym_BSLASHacsp] = ACTIONS(5961),
    [anon_sym_BSLASHAcsp] = ACTIONS(5961),
    [anon_sym_BSLASHacl] = ACTIONS(5961),
    [anon_sym_BSLASHAcl] = ACTIONS(5961),
    [anon_sym_BSLASHaclp] = ACTIONS(5961),
    [anon_sym_BSLASHAclp] = ACTIONS(5961),
    [anon_sym_BSLASHacf] = ACTIONS(5961),
    [anon_sym_BSLASHAcf] = ACTIONS(5961),
    [anon_sym_BSLASHacfp] = ACTIONS(5961),
    [anon_sym_BSLASHAcfp] = ACTIONS(5961),
    [anon_sym_BSLASHac] = ACTIONS(5961),
    [anon_sym_BSLASHAc] = ACTIONS(5961),
    [anon_sym_BSLASHacp] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5961),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5961),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5961),
    [anon_sym_BSLASHcolor] = ACTIONS(5961),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5961),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5961),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5961),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5961),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5961),
    [anon_sym_BSLASHtext] = ACTIONS(5961),
    [anon_sym_BSLASHintertext] = ACTIONS(5961),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5961),
    [anon_sym_BSLASHurl] = ACTIONS(5961),
    [anon_sym_BSLASHhref] = ACTIONS(5961),
  },
  [349] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHright] = ACTIONS(5957),
    [anon_sym_BSLASHbigr] = ACTIONS(5957),
    [anon_sym_BSLASHBigr] = ACTIONS(5957),
    [anon_sym_BSLASHbiggr] = ACTIONS(5957),
    [anon_sym_BSLASHBiggr] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [350] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHright] = ACTIONS(2132),
    [anon_sym_BSLASHbigr] = ACTIONS(2132),
    [anon_sym_BSLASHBigr] = ACTIONS(2132),
    [anon_sym_BSLASHbiggr] = ACTIONS(2132),
    [anon_sym_BSLASHBiggr] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [351] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(603),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(597),
    [aux_sym__section_repeat4] = STATE(603),
    [aux_sym__section_repeat5] = STATE(597),
    [ts_builtin_sym_end] = ACTIONS(5959),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [anon_sym_RBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [352] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHright] = ACTIONS(2132),
    [anon_sym_BSLASHbigr] = ACTIONS(2132),
    [anon_sym_BSLASHBigr] = ACTIONS(2132),
    [anon_sym_BSLASHbiggr] = ACTIONS(2132),
    [anon_sym_BSLASHBiggr] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [353] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHright] = ACTIONS(2132),
    [anon_sym_BSLASHbigr] = ACTIONS(2132),
    [anon_sym_BSLASHBigr] = ACTIONS(2132),
    [anon_sym_BSLASHbiggr] = ACTIONS(2132),
    [anon_sym_BSLASHBiggr] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [354] = {
    [sym__section_part] = STATE(443),
    [sym_curly_group] = STATE(445),
    [sym_brack_group] = STATE(2487),
    [sym_command_name] = ACTIONS(5971),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5971),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5973),
    [anon_sym_COMMA] = ACTIONS(5973),
    [anon_sym_EQ] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(5973),
    [anon_sym_RPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHpart] = ACTIONS(5971),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddpart] = ACTIONS(5971),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHchapter] = ACTIONS(5971),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddchap] = ACTIONS(5971),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsection] = ACTIONS(5971),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddsec] = ACTIONS(5971),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHitem] = ACTIONS(5971),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5973),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(5971),
    [sym_placeholder] = ACTIONS(5973),
    [anon_sym_PLUS] = ACTIONS(5973),
    [anon_sym_DASH] = ACTIONS(5973),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5973),
    [anon_sym_LT] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5971),
    [anon_sym_BANG] = ACTIONS(5971),
    [anon_sym_PIPE] = ACTIONS(5971),
    [anon_sym_COLON] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(5971),
    [anon_sym__] = ACTIONS(5973),
    [anon_sym_CARET] = ACTIONS(5973),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5973),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5973),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHbegin] = ACTIONS(5971),
    [anon_sym_BSLASHtitle] = ACTIONS(5971),
    [anon_sym_BSLASHauthor] = ACTIONS(5971),
    [anon_sym_BSLASHusepackage] = ACTIONS(5971),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5971),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5971),
    [anon_sym_BSLASHinclude] = ACTIONS(5971),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5971),
    [anon_sym_BSLASHinput] = ACTIONS(5971),
    [anon_sym_BSLASHsubfile] = ACTIONS(5971),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5971),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5971),
    [anon_sym_BSLASHbibliography] = ACTIONS(5971),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5971),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5971),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5971),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5971),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5971),
    [anon_sym_BSLASHimport] = ACTIONS(5971),
    [anon_sym_BSLASHsubimport] = ACTIONS(5971),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5971),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHcaption] = ACTIONS(5971),
    [anon_sym_BSLASHcite] = ACTIONS(5971),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCite] = ACTIONS(5971),
    [anon_sym_BSLASHnocite] = ACTIONS(5971),
    [anon_sym_BSLASHcitet] = ACTIONS(5971),
    [anon_sym_BSLASHcitep] = ACTIONS(5971),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteA] = ACTIONS(5971),
    [anon_sym_BSLASHciteR] = ACTIONS(5971),
    [anon_sym_BSLASHciteS] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5971),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteyear] = ACTIONS(5971),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitedate] = ACTIONS(5971),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteurl] = ACTIONS(5971),
    [anon_sym_BSLASHfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5971),
    [anon_sym_BSLASHcitealt] = ACTIONS(5971),
    [anon_sym_BSLASHcitealp] = ACTIONS(5971),
    [anon_sym_BSLASHcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHparencite] = ACTIONS(5971),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHParencite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHtextcite] = ACTIONS(5971),
    [anon_sym_BSLASHTextcite] = ACTIONS(5971),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHsupercite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite] = ACTIONS(5971),
    [anon_sym_BSLASHAutocite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHVolcite] = ACTIONS(5971),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHavolcite] = ACTIONS(5971),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHNotecite] = ACTIONS(5971),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHlabel] = ACTIONS(5971),
    [anon_sym_BSLASHref] = ACTIONS(5971),
    [anon_sym_BSLASHeqref] = ACTIONS(5971),
    [anon_sym_BSLASHvref] = ACTIONS(5971),
    [anon_sym_BSLASHVref] = ACTIONS(5971),
    [anon_sym_BSLASHautoref] = ACTIONS(5971),
    [anon_sym_BSLASHpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcref] = ACTIONS(5971),
    [anon_sym_BSLASHCref] = ACTIONS(5971),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnameCref] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHdef] = ACTIONS(5971),
    [anon_sym_BSLASHlet] = ACTIONS(5971),
    [anon_sym_BSLASHleft] = ACTIONS(5971),
    [anon_sym_BSLASHbigl] = ACTIONS(5971),
    [anon_sym_BSLASHBigl] = ACTIONS(5971),
    [anon_sym_BSLASHbiggl] = ACTIONS(5971),
    [anon_sym_BSLASHBiggl] = ACTIONS(5971),
    [anon_sym_BSLASHright] = ACTIONS(5971),
    [anon_sym_BSLASHbigr] = ACTIONS(5971),
    [anon_sym_BSLASHBigr] = ACTIONS(5971),
    [anon_sym_BSLASHbiggr] = ACTIONS(5971),
    [anon_sym_BSLASHBiggr] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5971),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5971),
    [anon_sym_BSLASHgls] = ACTIONS(5971),
    [anon_sym_BSLASHGls] = ACTIONS(5971),
    [anon_sym_BSLASHGLS] = ACTIONS(5971),
    [anon_sym_BSLASHglspl] = ACTIONS(5971),
    [anon_sym_BSLASHGlspl] = ACTIONS(5971),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5971),
    [anon_sym_BSLASHglslink] = ACTIONS(5971),
    [anon_sym_BSLASHglstext] = ACTIONS(5971),
    [anon_sym_BSLASHGlstext] = ACTIONS(5971),
    [anon_sym_BSLASHGLStext] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5971),
    [anon_sym_BSLASHglsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsname] = ACTIONS(5971),
    [anon_sym_BSLASHGlsname] = ACTIONS(5971),
    [anon_sym_BSLASHGLSname] = ACTIONS(5971),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5971),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5971),
    [anon_sym_BSLASHacrshort] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5971),
    [anon_sym_BSLASHACRshort] = ACTIONS(5971),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrlong] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5971),
    [anon_sym_BSLASHACRlong] = ACTIONS(5971),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrfull] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5971),
    [anon_sym_BSLASHACRfull] = ACTIONS(5971),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHacs] = ACTIONS(5971),
    [anon_sym_BSLASHAcs] = ACTIONS(5971),
    [anon_sym_BSLASHacsp] = ACTIONS(5971),
    [anon_sym_BSLASHAcsp] = ACTIONS(5971),
    [anon_sym_BSLASHacl] = ACTIONS(5971),
    [anon_sym_BSLASHAcl] = ACTIONS(5971),
    [anon_sym_BSLASHaclp] = ACTIONS(5971),
    [anon_sym_BSLASHAclp] = ACTIONS(5971),
    [anon_sym_BSLASHacf] = ACTIONS(5971),
    [anon_sym_BSLASHAcf] = ACTIONS(5971),
    [anon_sym_BSLASHacfp] = ACTIONS(5971),
    [anon_sym_BSLASHAcfp] = ACTIONS(5971),
    [anon_sym_BSLASHac] = ACTIONS(5971),
    [anon_sym_BSLASHAc] = ACTIONS(5971),
    [anon_sym_BSLASHacp] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5971),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5971),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5971),
    [anon_sym_BSLASHcolor] = ACTIONS(5971),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5971),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5971),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5971),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5971),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5971),
    [anon_sym_BSLASHtext] = ACTIONS(5971),
    [anon_sym_BSLASHintertext] = ACTIONS(5971),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5971),
    [anon_sym_BSLASHurl] = ACTIONS(5971),
    [anon_sym_BSLASHhref] = ACTIONS(5971),
  },
  [355] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHright] = ACTIONS(2144),
    [anon_sym_BSLASHbigr] = ACTIONS(2144),
    [anon_sym_BSLASHBigr] = ACTIONS(2144),
    [anon_sym_BSLASHbiggr] = ACTIONS(2144),
    [anon_sym_BSLASHBiggr] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [356] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHright] = ACTIONS(2144),
    [anon_sym_BSLASHbigr] = ACTIONS(2144),
    [anon_sym_BSLASHBigr] = ACTIONS(2144),
    [anon_sym_BSLASHbiggr] = ACTIONS(2144),
    [anon_sym_BSLASHBiggr] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [357] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHright] = ACTIONS(2144),
    [anon_sym_BSLASHbigr] = ACTIONS(2144),
    [anon_sym_BSLASHBigr] = ACTIONS(2144),
    [anon_sym_BSLASHbiggr] = ACTIONS(2144),
    [anon_sym_BSLASHBiggr] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [358] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHright] = ACTIONS(2172),
    [anon_sym_BSLASHbigr] = ACTIONS(2172),
    [anon_sym_BSLASHBigr] = ACTIONS(2172),
    [anon_sym_BSLASHbiggr] = ACTIONS(2172),
    [anon_sym_BSLASHBiggr] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [359] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHright] = ACTIONS(2172),
    [anon_sym_BSLASHbigr] = ACTIONS(2172),
    [anon_sym_BSLASHBigr] = ACTIONS(2172),
    [anon_sym_BSLASHbiggr] = ACTIONS(2172),
    [anon_sym_BSLASHBiggr] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [360] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(397),
    [aux_sym__section_repeat5] = STATE(397),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHright] = ACTIONS(2190),
    [anon_sym_BSLASHbigr] = ACTIONS(2190),
    [anon_sym_BSLASHBigr] = ACTIONS(2190),
    [anon_sym_BSLASHbiggr] = ACTIONS(2190),
    [anon_sym_BSLASHBiggr] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [361] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHright] = ACTIONS(2190),
    [anon_sym_BSLASHbigr] = ACTIONS(2190),
    [anon_sym_BSLASHBigr] = ACTIONS(2190),
    [anon_sym_BSLASHbiggr] = ACTIONS(2190),
    [anon_sym_BSLASHBiggr] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [362] = {
    [sym__section_part] = STATE(447),
    [sym_curly_group] = STATE(445),
    [sym_brack_group] = STATE(2487),
    [sym_command_name] = ACTIONS(5975),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5975),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5977),
    [anon_sym_EQ] = ACTIONS(5977),
    [anon_sym_LPAREN] = ACTIONS(5977),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHpart] = ACTIONS(5975),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddpart] = ACTIONS(5975),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHchapter] = ACTIONS(5975),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddchap] = ACTIONS(5975),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsection] = ACTIONS(5975),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddsec] = ACTIONS(5975),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHitem] = ACTIONS(5975),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5977),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(5975),
    [sym_placeholder] = ACTIONS(5977),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_STAR] = ACTIONS(5977),
    [anon_sym_SLASH] = ACTIONS(5977),
    [anon_sym_LT] = ACTIONS(5975),
    [anon_sym_GT] = ACTIONS(5975),
    [anon_sym_BANG] = ACTIONS(5975),
    [anon_sym_PIPE] = ACTIONS(5975),
    [anon_sym_COLON] = ACTIONS(5975),
    [anon_sym_SQUOTE] = ACTIONS(5975),
    [anon_sym__] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5977),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5977),
    [anon_sym_DOLLAR] = ACTIONS(5975),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHbegin] = ACTIONS(5975),
    [anon_sym_BSLASHtitle] = ACTIONS(5975),
    [anon_sym_BSLASHauthor] = ACTIONS(5975),
    [anon_sym_BSLASHusepackage] = ACTIONS(5975),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5975),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5975),
    [anon_sym_BSLASHinclude] = ACTIONS(5975),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5975),
    [anon_sym_BSLASHinput] = ACTIONS(5975),
    [anon_sym_BSLASHsubfile] = ACTIONS(5975),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5975),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5975),
    [anon_sym_BSLASHbibliography] = ACTIONS(5975),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5975),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5975),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5975),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5975),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5975),
    [anon_sym_BSLASHimport] = ACTIONS(5975),
    [anon_sym_BSLASHsubimport] = ACTIONS(5975),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5975),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHcaption] = ACTIONS(5975),
    [anon_sym_BSLASHcite] = ACTIONS(5975),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCite] = ACTIONS(5975),
    [anon_sym_BSLASHnocite] = ACTIONS(5975),
    [anon_sym_BSLASHcitet] = ACTIONS(5975),
    [anon_sym_BSLASHcitep] = ACTIONS(5975),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteA] = ACTIONS(5975),
    [anon_sym_BSLASHciteR] = ACTIONS(5975),
    [anon_sym_BSLASHciteS] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5975),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteyear] = ACTIONS(5975),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitedate] = ACTIONS(5975),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteurl] = ACTIONS(5975),
    [anon_sym_BSLASHfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5975),
    [anon_sym_BSLASHcitealt] = ACTIONS(5975),
    [anon_sym_BSLASHcitealp] = ACTIONS(5975),
    [anon_sym_BSLASHcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHparencite] = ACTIONS(5975),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHParencite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHtextcite] = ACTIONS(5975),
    [anon_sym_BSLASHTextcite] = ACTIONS(5975),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHsupercite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite] = ACTIONS(5975),
    [anon_sym_BSLASHAutocite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHVolcite] = ACTIONS(5975),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHavolcite] = ACTIONS(5975),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHNotecite] = ACTIONS(5975),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHlabel] = ACTIONS(5975),
    [anon_sym_BSLASHref] = ACTIONS(5975),
    [anon_sym_BSLASHeqref] = ACTIONS(5975),
    [anon_sym_BSLASHvref] = ACTIONS(5975),
    [anon_sym_BSLASHVref] = ACTIONS(5975),
    [anon_sym_BSLASHautoref] = ACTIONS(5975),
    [anon_sym_BSLASHpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcref] = ACTIONS(5975),
    [anon_sym_BSLASHCref] = ACTIONS(5975),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnameCref] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHdef] = ACTIONS(5975),
    [anon_sym_BSLASHlet] = ACTIONS(5975),
    [anon_sym_BSLASHleft] = ACTIONS(5975),
    [anon_sym_BSLASHbigl] = ACTIONS(5975),
    [anon_sym_BSLASHBigl] = ACTIONS(5975),
    [anon_sym_BSLASHbiggl] = ACTIONS(5975),
    [anon_sym_BSLASHBiggl] = ACTIONS(5975),
    [anon_sym_BSLASHright] = ACTIONS(5975),
    [anon_sym_BSLASHbigr] = ACTIONS(5975),
    [anon_sym_BSLASHBigr] = ACTIONS(5975),
    [anon_sym_BSLASHbiggr] = ACTIONS(5975),
    [anon_sym_BSLASHBiggr] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5975),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5975),
    [anon_sym_BSLASHgls] = ACTIONS(5975),
    [anon_sym_BSLASHGls] = ACTIONS(5975),
    [anon_sym_BSLASHGLS] = ACTIONS(5975),
    [anon_sym_BSLASHglspl] = ACTIONS(5975),
    [anon_sym_BSLASHGlspl] = ACTIONS(5975),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5975),
    [anon_sym_BSLASHglslink] = ACTIONS(5975),
    [anon_sym_BSLASHglstext] = ACTIONS(5975),
    [anon_sym_BSLASHGlstext] = ACTIONS(5975),
    [anon_sym_BSLASHGLStext] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5975),
    [anon_sym_BSLASHglsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsname] = ACTIONS(5975),
    [anon_sym_BSLASHGlsname] = ACTIONS(5975),
    [anon_sym_BSLASHGLSname] = ACTIONS(5975),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5975),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5975),
    [anon_sym_BSLASHacrshort] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5975),
    [anon_sym_BSLASHACRshort] = ACTIONS(5975),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrlong] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5975),
    [anon_sym_BSLASHACRlong] = ACTIONS(5975),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrfull] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5975),
    [anon_sym_BSLASHACRfull] = ACTIONS(5975),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHacs] = ACTIONS(5975),
    [anon_sym_BSLASHAcs] = ACTIONS(5975),
    [anon_sym_BSLASHacsp] = ACTIONS(5975),
    [anon_sym_BSLASHAcsp] = ACTIONS(5975),
    [anon_sym_BSLASHacl] = ACTIONS(5975),
    [anon_sym_BSLASHAcl] = ACTIONS(5975),
    [anon_sym_BSLASHaclp] = ACTIONS(5975),
    [anon_sym_BSLASHAclp] = ACTIONS(5975),
    [anon_sym_BSLASHacf] = ACTIONS(5975),
    [anon_sym_BSLASHAcf] = ACTIONS(5975),
    [anon_sym_BSLASHacfp] = ACTIONS(5975),
    [anon_sym_BSLASHAcfp] = ACTIONS(5975),
    [anon_sym_BSLASHac] = ACTIONS(5975),
    [anon_sym_BSLASHAc] = ACTIONS(5975),
    [anon_sym_BSLASHacp] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5975),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5975),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5975),
    [anon_sym_BSLASHcolor] = ACTIONS(5975),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5975),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5975),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5975),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5975),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5975),
    [anon_sym_BSLASHtext] = ACTIONS(5975),
    [anon_sym_BSLASHintertext] = ACTIONS(5975),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5975),
    [anon_sym_BSLASHurl] = ACTIONS(5975),
    [anon_sym_BSLASHhref] = ACTIONS(5975),
  },
  [363] = {
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(373),
    [aux_sym__paragraph_repeat2] = STATE(373),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(2232),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHright] = ACTIONS(2232),
    [anon_sym_BSLASHbigr] = ACTIONS(2232),
    [anon_sym_BSLASHBigr] = ACTIONS(2232),
    [anon_sym_BSLASHbiggr] = ACTIONS(2232),
    [anon_sym_BSLASHBiggr] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [364] = {
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(374),
    [aux_sym__paragraph_repeat3] = STATE(374),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHright] = ACTIONS(2232),
    [anon_sym_BSLASHbigr] = ACTIONS(2232),
    [anon_sym_BSLASHBigr] = ACTIONS(2232),
    [anon_sym_BSLASHbiggr] = ACTIONS(2232),
    [anon_sym_BSLASHBiggr] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [365] = {
    [sym__section_part] = STATE(449),
    [sym_curly_group] = STATE(445),
    [sym_brack_group] = STATE(2487),
    [sym_command_name] = ACTIONS(5979),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5979),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5981),
    [anon_sym_COMMA] = ACTIONS(5981),
    [anon_sym_EQ] = ACTIONS(5981),
    [anon_sym_LPAREN] = ACTIONS(5981),
    [anon_sym_RPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHpart] = ACTIONS(5979),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddpart] = ACTIONS(5979),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHchapter] = ACTIONS(5979),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddchap] = ACTIONS(5979),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsection] = ACTIONS(5979),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddsec] = ACTIONS(5979),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHitem] = ACTIONS(5979),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5981),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(5979),
    [sym_placeholder] = ACTIONS(5981),
    [anon_sym_PLUS] = ACTIONS(5981),
    [anon_sym_DASH] = ACTIONS(5981),
    [anon_sym_STAR] = ACTIONS(5981),
    [anon_sym_SLASH] = ACTIONS(5981),
    [anon_sym_LT] = ACTIONS(5979),
    [anon_sym_GT] = ACTIONS(5979),
    [anon_sym_BANG] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5979),
    [anon_sym_SQUOTE] = ACTIONS(5979),
    [anon_sym__] = ACTIONS(5981),
    [anon_sym_CARET] = ACTIONS(5981),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5981),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5979),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHbegin] = ACTIONS(5979),
    [anon_sym_BSLASHtitle] = ACTIONS(5979),
    [anon_sym_BSLASHauthor] = ACTIONS(5979),
    [anon_sym_BSLASHusepackage] = ACTIONS(5979),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5979),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5979),
    [anon_sym_BSLASHinclude] = ACTIONS(5979),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5979),
    [anon_sym_BSLASHinput] = ACTIONS(5979),
    [anon_sym_BSLASHsubfile] = ACTIONS(5979),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5979),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5979),
    [anon_sym_BSLASHbibliography] = ACTIONS(5979),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5979),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5979),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5979),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5979),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5979),
    [anon_sym_BSLASHimport] = ACTIONS(5979),
    [anon_sym_BSLASHsubimport] = ACTIONS(5979),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5979),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHcaption] = ACTIONS(5979),
    [anon_sym_BSLASHcite] = ACTIONS(5979),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCite] = ACTIONS(5979),
    [anon_sym_BSLASHnocite] = ACTIONS(5979),
    [anon_sym_BSLASHcitet] = ACTIONS(5979),
    [anon_sym_BSLASHcitep] = ACTIONS(5979),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteA] = ACTIONS(5979),
    [anon_sym_BSLASHciteR] = ACTIONS(5979),
    [anon_sym_BSLASHciteS] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5979),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteyear] = ACTIONS(5979),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitedate] = ACTIONS(5979),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteurl] = ACTIONS(5979),
    [anon_sym_BSLASHfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5979),
    [anon_sym_BSLASHcitealt] = ACTIONS(5979),
    [anon_sym_BSLASHcitealp] = ACTIONS(5979),
    [anon_sym_BSLASHcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHparencite] = ACTIONS(5979),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHParencite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHtextcite] = ACTIONS(5979),
    [anon_sym_BSLASHTextcite] = ACTIONS(5979),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHsupercite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite] = ACTIONS(5979),
    [anon_sym_BSLASHAutocite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHVolcite] = ACTIONS(5979),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHavolcite] = ACTIONS(5979),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHNotecite] = ACTIONS(5979),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHlabel] = ACTIONS(5979),
    [anon_sym_BSLASHref] = ACTIONS(5979),
    [anon_sym_BSLASHeqref] = ACTIONS(5979),
    [anon_sym_BSLASHvref] = ACTIONS(5979),
    [anon_sym_BSLASHVref] = ACTIONS(5979),
    [anon_sym_BSLASHautoref] = ACTIONS(5979),
    [anon_sym_BSLASHpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcref] = ACTIONS(5979),
    [anon_sym_BSLASHCref] = ACTIONS(5979),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnameCref] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHdef] = ACTIONS(5979),
    [anon_sym_BSLASHlet] = ACTIONS(5979),
    [anon_sym_BSLASHleft] = ACTIONS(5979),
    [anon_sym_BSLASHbigl] = ACTIONS(5979),
    [anon_sym_BSLASHBigl] = ACTIONS(5979),
    [anon_sym_BSLASHbiggl] = ACTIONS(5979),
    [anon_sym_BSLASHBiggl] = ACTIONS(5979),
    [anon_sym_BSLASHright] = ACTIONS(5979),
    [anon_sym_BSLASHbigr] = ACTIONS(5979),
    [anon_sym_BSLASHBigr] = ACTIONS(5979),
    [anon_sym_BSLASHbiggr] = ACTIONS(5979),
    [anon_sym_BSLASHBiggr] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5979),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5979),
    [anon_sym_BSLASHgls] = ACTIONS(5979),
    [anon_sym_BSLASHGls] = ACTIONS(5979),
    [anon_sym_BSLASHGLS] = ACTIONS(5979),
    [anon_sym_BSLASHglspl] = ACTIONS(5979),
    [anon_sym_BSLASHGlspl] = ACTIONS(5979),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5979),
    [anon_sym_BSLASHglslink] = ACTIONS(5979),
    [anon_sym_BSLASHglstext] = ACTIONS(5979),
    [anon_sym_BSLASHGlstext] = ACTIONS(5979),
    [anon_sym_BSLASHGLStext] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5979),
    [anon_sym_BSLASHglsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsname] = ACTIONS(5979),
    [anon_sym_BSLASHGlsname] = ACTIONS(5979),
    [anon_sym_BSLASHGLSname] = ACTIONS(5979),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5979),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5979),
    [anon_sym_BSLASHacrshort] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5979),
    [anon_sym_BSLASHACRshort] = ACTIONS(5979),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrlong] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5979),
    [anon_sym_BSLASHACRlong] = ACTIONS(5979),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrfull] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5979),
    [anon_sym_BSLASHACRfull] = ACTIONS(5979),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHacs] = ACTIONS(5979),
    [anon_sym_BSLASHAcs] = ACTIONS(5979),
    [anon_sym_BSLASHacsp] = ACTIONS(5979),
    [anon_sym_BSLASHAcsp] = ACTIONS(5979),
    [anon_sym_BSLASHacl] = ACTIONS(5979),
    [anon_sym_BSLASHAcl] = ACTIONS(5979),
    [anon_sym_BSLASHaclp] = ACTIONS(5979),
    [anon_sym_BSLASHAclp] = ACTIONS(5979),
    [anon_sym_BSLASHacf] = ACTIONS(5979),
    [anon_sym_BSLASHAcf] = ACTIONS(5979),
    [anon_sym_BSLASHacfp] = ACTIONS(5979),
    [anon_sym_BSLASHAcfp] = ACTIONS(5979),
    [anon_sym_BSLASHac] = ACTIONS(5979),
    [anon_sym_BSLASHAc] = ACTIONS(5979),
    [anon_sym_BSLASHacp] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5979),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5979),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5979),
    [anon_sym_BSLASHcolor] = ACTIONS(5979),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5979),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5979),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5979),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5979),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5979),
    [anon_sym_BSLASHtext] = ACTIONS(5979),
    [anon_sym_BSLASHintertext] = ACTIONS(5979),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5979),
    [anon_sym_BSLASHurl] = ACTIONS(5979),
    [anon_sym_BSLASHhref] = ACTIONS(5979),
  },
  [366] = {
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(374),
    [aux_sym__paragraph_repeat3] = STATE(374),
    [sym_command_name] = ACTIONS(2250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_RBRACK] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [sym_word] = ACTIONS(2250),
    [sym_placeholder] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym__] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2252),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHbegin] = ACTIONS(2250),
    [anon_sym_BSLASHtitle] = ACTIONS(2250),
    [anon_sym_BSLASHauthor] = ACTIONS(2250),
    [anon_sym_BSLASHusepackage] = ACTIONS(2250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2250),
    [anon_sym_BSLASHinclude] = ACTIONS(2250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2250),
    [anon_sym_BSLASHinput] = ACTIONS(2250),
    [anon_sym_BSLASHsubfile] = ACTIONS(2250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2250),
    [anon_sym_BSLASHbibliography] = ACTIONS(2250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2250),
    [anon_sym_BSLASHimport] = ACTIONS(2250),
    [anon_sym_BSLASHsubimport] = ACTIONS(2250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHcaption] = ACTIONS(2250),
    [anon_sym_BSLASHcite] = ACTIONS(2250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCite] = ACTIONS(2250),
    [anon_sym_BSLASHnocite] = ACTIONS(2250),
    [anon_sym_BSLASHcitet] = ACTIONS(2250),
    [anon_sym_BSLASHcitep] = ACTIONS(2250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteA] = ACTIONS(2250),
    [anon_sym_BSLASHciteR] = ACTIONS(2250),
    [anon_sym_BSLASHciteS] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteyear] = ACTIONS(2250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitedate] = ACTIONS(2250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteurl] = ACTIONS(2250),
    [anon_sym_BSLASHfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2250),
    [anon_sym_BSLASHcitealt] = ACTIONS(2250),
    [anon_sym_BSLASHcitealp] = ACTIONS(2250),
    [anon_sym_BSLASHcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHparencite] = ACTIONS(2250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHParencite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHtextcite] = ACTIONS(2250),
    [anon_sym_BSLASHTextcite] = ACTIONS(2250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHsupercite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite] = ACTIONS(2250),
    [anon_sym_BSLASHAutocite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHVolcite] = ACTIONS(2250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHavolcite] = ACTIONS(2250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHNotecite] = ACTIONS(2250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHlabel] = ACTIONS(2250),
    [anon_sym_BSLASHref] = ACTIONS(2250),
    [anon_sym_BSLASHeqref] = ACTIONS(2250),
    [anon_sym_BSLASHvref] = ACTIONS(2250),
    [anon_sym_BSLASHVref] = ACTIONS(2250),
    [anon_sym_BSLASHautoref] = ACTIONS(2250),
    [anon_sym_BSLASHpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcref] = ACTIONS(2250),
    [anon_sym_BSLASHCref] = ACTIONS(2250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnameCref] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHdef] = ACTIONS(2250),
    [anon_sym_BSLASHlet] = ACTIONS(2250),
    [anon_sym_BSLASHleft] = ACTIONS(2250),
    [anon_sym_BSLASHbigl] = ACTIONS(2250),
    [anon_sym_BSLASHBigl] = ACTIONS(2250),
    [anon_sym_BSLASHbiggl] = ACTIONS(2250),
    [anon_sym_BSLASHBiggl] = ACTIONS(2250),
    [anon_sym_BSLASHright] = ACTIONS(2250),
    [anon_sym_BSLASHbigr] = ACTIONS(2250),
    [anon_sym_BSLASHBigr] = ACTIONS(2250),
    [anon_sym_BSLASHbiggr] = ACTIONS(2250),
    [anon_sym_BSLASHBiggr] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2250),
    [anon_sym_BSLASHgls] = ACTIONS(2250),
    [anon_sym_BSLASHGls] = ACTIONS(2250),
    [anon_sym_BSLASHGLS] = ACTIONS(2250),
    [anon_sym_BSLASHglspl] = ACTIONS(2250),
    [anon_sym_BSLASHGlspl] = ACTIONS(2250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2250),
    [anon_sym_BSLASHglslink] = ACTIONS(2250),
    [anon_sym_BSLASHglstext] = ACTIONS(2250),
    [anon_sym_BSLASHGlstext] = ACTIONS(2250),
    [anon_sym_BSLASHGLStext] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2250),
    [anon_sym_BSLASHglsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsname] = ACTIONS(2250),
    [anon_sym_BSLASHGlsname] = ACTIONS(2250),
    [anon_sym_BSLASHGLSname] = ACTIONS(2250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2250),
    [anon_sym_BSLASHacrshort] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2250),
    [anon_sym_BSLASHACRshort] = ACTIONS(2250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrlong] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2250),
    [anon_sym_BSLASHACRlong] = ACTIONS(2250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrfull] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2250),
    [anon_sym_BSLASHACRfull] = ACTIONS(2250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHacs] = ACTIONS(2250),
    [anon_sym_BSLASHAcs] = ACTIONS(2250),
    [anon_sym_BSLASHacsp] = ACTIONS(2250),
    [anon_sym_BSLASHAcsp] = ACTIONS(2250),
    [anon_sym_BSLASHacl] = ACTIONS(2250),
    [anon_sym_BSLASHAcl] = ACTIONS(2250),
    [anon_sym_BSLASHaclp] = ACTIONS(2250),
    [anon_sym_BSLASHAclp] = ACTIONS(2250),
    [anon_sym_BSLASHacf] = ACTIONS(2250),
    [anon_sym_BSLASHAcf] = ACTIONS(2250),
    [anon_sym_BSLASHacfp] = ACTIONS(2250),
    [anon_sym_BSLASHAcfp] = ACTIONS(2250),
    [anon_sym_BSLASHac] = ACTIONS(2250),
    [anon_sym_BSLASHAc] = ACTIONS(2250),
    [anon_sym_BSLASHacp] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2250),
    [anon_sym_BSLASHcolor] = ACTIONS(2250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2250),
    [anon_sym_BSLASHtext] = ACTIONS(2250),
    [anon_sym_BSLASHintertext] = ACTIONS(2250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2250),
    [anon_sym_BSLASHurl] = ACTIONS(2250),
    [anon_sym_BSLASHhref] = ACTIONS(2250),
  },
  [367] = {
    [sym__section_part] = STATE(450),
    [sym_curly_group] = STATE(445),
    [sym_brack_group] = STATE(2487),
    [sym_command_name] = ACTIONS(5983),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5983),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5985),
    [anon_sym_COMMA] = ACTIONS(5985),
    [anon_sym_EQ] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(5985),
    [anon_sym_RPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHpart] = ACTIONS(5983),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddpart] = ACTIONS(5983),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHchapter] = ACTIONS(5983),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddchap] = ACTIONS(5983),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsection] = ACTIONS(5983),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddsec] = ACTIONS(5983),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHitem] = ACTIONS(5983),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(5983),
    [sym_placeholder] = ACTIONS(5985),
    [anon_sym_PLUS] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(5985),
    [anon_sym_SLASH] = ACTIONS(5985),
    [anon_sym_LT] = ACTIONS(5983),
    [anon_sym_GT] = ACTIONS(5983),
    [anon_sym_BANG] = ACTIONS(5983),
    [anon_sym_PIPE] = ACTIONS(5983),
    [anon_sym_COLON] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(5983),
    [anon_sym__] = ACTIONS(5985),
    [anon_sym_CARET] = ACTIONS(5985),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5985),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5985),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHbegin] = ACTIONS(5983),
    [anon_sym_BSLASHtitle] = ACTIONS(5983),
    [anon_sym_BSLASHauthor] = ACTIONS(5983),
    [anon_sym_BSLASHusepackage] = ACTIONS(5983),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5983),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5983),
    [anon_sym_BSLASHinclude] = ACTIONS(5983),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5983),
    [anon_sym_BSLASHinput] = ACTIONS(5983),
    [anon_sym_BSLASHsubfile] = ACTIONS(5983),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5983),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5983),
    [anon_sym_BSLASHbibliography] = ACTIONS(5983),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5983),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5983),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5983),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5983),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5983),
    [anon_sym_BSLASHimport] = ACTIONS(5983),
    [anon_sym_BSLASHsubimport] = ACTIONS(5983),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5983),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHcaption] = ACTIONS(5983),
    [anon_sym_BSLASHcite] = ACTIONS(5983),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCite] = ACTIONS(5983),
    [anon_sym_BSLASHnocite] = ACTIONS(5983),
    [anon_sym_BSLASHcitet] = ACTIONS(5983),
    [anon_sym_BSLASHcitep] = ACTIONS(5983),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteA] = ACTIONS(5983),
    [anon_sym_BSLASHciteR] = ACTIONS(5983),
    [anon_sym_BSLASHciteS] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5983),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteyear] = ACTIONS(5983),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitedate] = ACTIONS(5983),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteurl] = ACTIONS(5983),
    [anon_sym_BSLASHfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5983),
    [anon_sym_BSLASHcitealt] = ACTIONS(5983),
    [anon_sym_BSLASHcitealp] = ACTIONS(5983),
    [anon_sym_BSLASHcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHparencite] = ACTIONS(5983),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHParencite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHtextcite] = ACTIONS(5983),
    [anon_sym_BSLASHTextcite] = ACTIONS(5983),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHsupercite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite] = ACTIONS(5983),
    [anon_sym_BSLASHAutocite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHVolcite] = ACTIONS(5983),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHavolcite] = ACTIONS(5983),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHNotecite] = ACTIONS(5983),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHlabel] = ACTIONS(5983),
    [anon_sym_BSLASHref] = ACTIONS(5983),
    [anon_sym_BSLASHeqref] = ACTIONS(5983),
    [anon_sym_BSLASHvref] = ACTIONS(5983),
    [anon_sym_BSLASHVref] = ACTIONS(5983),
    [anon_sym_BSLASHautoref] = ACTIONS(5983),
    [anon_sym_BSLASHpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcref] = ACTIONS(5983),
    [anon_sym_BSLASHCref] = ACTIONS(5983),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnameCref] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHdef] = ACTIONS(5983),
    [anon_sym_BSLASHlet] = ACTIONS(5983),
    [anon_sym_BSLASHleft] = ACTIONS(5983),
    [anon_sym_BSLASHbigl] = ACTIONS(5983),
    [anon_sym_BSLASHBigl] = ACTIONS(5983),
    [anon_sym_BSLASHbiggl] = ACTIONS(5983),
    [anon_sym_BSLASHBiggl] = ACTIONS(5983),
    [anon_sym_BSLASHright] = ACTIONS(5983),
    [anon_sym_BSLASHbigr] = ACTIONS(5983),
    [anon_sym_BSLASHBigr] = ACTIONS(5983),
    [anon_sym_BSLASHbiggr] = ACTIONS(5983),
    [anon_sym_BSLASHBiggr] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5983),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5983),
    [anon_sym_BSLASHgls] = ACTIONS(5983),
    [anon_sym_BSLASHGls] = ACTIONS(5983),
    [anon_sym_BSLASHGLS] = ACTIONS(5983),
    [anon_sym_BSLASHglspl] = ACTIONS(5983),
    [anon_sym_BSLASHGlspl] = ACTIONS(5983),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5983),
    [anon_sym_BSLASHglslink] = ACTIONS(5983),
    [anon_sym_BSLASHglstext] = ACTIONS(5983),
    [anon_sym_BSLASHGlstext] = ACTIONS(5983),
    [anon_sym_BSLASHGLStext] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5983),
    [anon_sym_BSLASHglsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsname] = ACTIONS(5983),
    [anon_sym_BSLASHGlsname] = ACTIONS(5983),
    [anon_sym_BSLASHGLSname] = ACTIONS(5983),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5983),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5983),
    [anon_sym_BSLASHacrshort] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5983),
    [anon_sym_BSLASHACRshort] = ACTIONS(5983),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrlong] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5983),
    [anon_sym_BSLASHACRlong] = ACTIONS(5983),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrfull] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5983),
    [anon_sym_BSLASHACRfull] = ACTIONS(5983),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHacs] = ACTIONS(5983),
    [anon_sym_BSLASHAcs] = ACTIONS(5983),
    [anon_sym_BSLASHacsp] = ACTIONS(5983),
    [anon_sym_BSLASHAcsp] = ACTIONS(5983),
    [anon_sym_BSLASHacl] = ACTIONS(5983),
    [anon_sym_BSLASHAcl] = ACTIONS(5983),
    [anon_sym_BSLASHaclp] = ACTIONS(5983),
    [anon_sym_BSLASHAclp] = ACTIONS(5983),
    [anon_sym_BSLASHacf] = ACTIONS(5983),
    [anon_sym_BSLASHAcf] = ACTIONS(5983),
    [anon_sym_BSLASHacfp] = ACTIONS(5983),
    [anon_sym_BSLASHAcfp] = ACTIONS(5983),
    [anon_sym_BSLASHac] = ACTIONS(5983),
    [anon_sym_BSLASHAc] = ACTIONS(5983),
    [anon_sym_BSLASHacp] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5983),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5983),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5983),
    [anon_sym_BSLASHcolor] = ACTIONS(5983),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5983),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5983),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5983),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5983),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5983),
    [anon_sym_BSLASHtext] = ACTIONS(5983),
    [anon_sym_BSLASHintertext] = ACTIONS(5983),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5983),
    [anon_sym_BSLASHurl] = ACTIONS(5983),
    [anon_sym_BSLASHhref] = ACTIONS(5983),
  },
  [368] = {
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(368),
    [aux_sym__section_repeat1] = STATE(368),
    [sym_command_name] = ACTIONS(5987),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5987),
    [anon_sym_LBRACK] = ACTIONS(5989),
    [anon_sym_RBRACK] = ACTIONS(5989),
    [anon_sym_COMMA] = ACTIONS(5989),
    [anon_sym_EQ] = ACTIONS(5989),
    [anon_sym_LPAREN] = ACTIONS(5989),
    [anon_sym_RPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHpart] = ACTIONS(5991),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5994),
    [anon_sym_BSLASHaddpart] = ACTIONS(5991),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5994),
    [anon_sym_BSLASHchapter] = ACTIONS(5987),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddchap] = ACTIONS(5987),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsection] = ACTIONS(5987),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddsec] = ACTIONS(5987),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHitem] = ACTIONS(5987),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5989),
    [anon_sym_LBRACE] = ACTIONS(5989),
    [sym_word] = ACTIONS(5987),
    [sym_placeholder] = ACTIONS(5989),
    [anon_sym_PLUS] = ACTIONS(5989),
    [anon_sym_DASH] = ACTIONS(5989),
    [anon_sym_STAR] = ACTIONS(5989),
    [anon_sym_SLASH] = ACTIONS(5989),
    [anon_sym_LT] = ACTIONS(5987),
    [anon_sym_GT] = ACTIONS(5987),
    [anon_sym_BANG] = ACTIONS(5987),
    [anon_sym_PIPE] = ACTIONS(5987),
    [anon_sym_COLON] = ACTIONS(5987),
    [anon_sym_SQUOTE] = ACTIONS(5987),
    [anon_sym__] = ACTIONS(5989),
    [anon_sym_CARET] = ACTIONS(5989),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5989),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5989),
    [anon_sym_DOLLAR] = ACTIONS(5987),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHbegin] = ACTIONS(5987),
    [anon_sym_BSLASHtitle] = ACTIONS(5987),
    [anon_sym_BSLASHauthor] = ACTIONS(5987),
    [anon_sym_BSLASHusepackage] = ACTIONS(5987),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5987),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5987),
    [anon_sym_BSLASHinclude] = ACTIONS(5987),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5987),
    [anon_sym_BSLASHinput] = ACTIONS(5987),
    [anon_sym_BSLASHsubfile] = ACTIONS(5987),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5987),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5987),
    [anon_sym_BSLASHbibliography] = ACTIONS(5987),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5987),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5987),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5987),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5987),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5987),
    [anon_sym_BSLASHimport] = ACTIONS(5987),
    [anon_sym_BSLASHsubimport] = ACTIONS(5987),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5987),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHcaption] = ACTIONS(5987),
    [anon_sym_BSLASHcite] = ACTIONS(5987),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCite] = ACTIONS(5987),
    [anon_sym_BSLASHnocite] = ACTIONS(5987),
    [anon_sym_BSLASHcitet] = ACTIONS(5987),
    [anon_sym_BSLASHcitep] = ACTIONS(5987),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteA] = ACTIONS(5987),
    [anon_sym_BSLASHciteR] = ACTIONS(5987),
    [anon_sym_BSLASHciteS] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5987),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteyear] = ACTIONS(5987),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitedate] = ACTIONS(5987),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteurl] = ACTIONS(5987),
    [anon_sym_BSLASHfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5987),
    [anon_sym_BSLASHcitealt] = ACTIONS(5987),
    [anon_sym_BSLASHcitealp] = ACTIONS(5987),
    [anon_sym_BSLASHcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHparencite] = ACTIONS(5987),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHParencite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHtextcite] = ACTIONS(5987),
    [anon_sym_BSLASHTextcite] = ACTIONS(5987),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHsupercite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite] = ACTIONS(5987),
    [anon_sym_BSLASHAutocite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHVolcite] = ACTIONS(5987),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHavolcite] = ACTIONS(5987),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHNotecite] = ACTIONS(5987),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHlabel] = ACTIONS(5987),
    [anon_sym_BSLASHref] = ACTIONS(5987),
    [anon_sym_BSLASHeqref] = ACTIONS(5987),
    [anon_sym_BSLASHvref] = ACTIONS(5987),
    [anon_sym_BSLASHVref] = ACTIONS(5987),
    [anon_sym_BSLASHautoref] = ACTIONS(5987),
    [anon_sym_BSLASHpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcref] = ACTIONS(5987),
    [anon_sym_BSLASHCref] = ACTIONS(5987),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnameCref] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHdef] = ACTIONS(5987),
    [anon_sym_BSLASHlet] = ACTIONS(5987),
    [anon_sym_BSLASHleft] = ACTIONS(5987),
    [anon_sym_BSLASHbigl] = ACTIONS(5987),
    [anon_sym_BSLASHBigl] = ACTIONS(5987),
    [anon_sym_BSLASHbiggl] = ACTIONS(5987),
    [anon_sym_BSLASHBiggl] = ACTIONS(5987),
    [anon_sym_BSLASHright] = ACTIONS(5987),
    [anon_sym_BSLASHbigr] = ACTIONS(5987),
    [anon_sym_BSLASHBigr] = ACTIONS(5987),
    [anon_sym_BSLASHbiggr] = ACTIONS(5987),
    [anon_sym_BSLASHBiggr] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5987),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5987),
    [anon_sym_BSLASHgls] = ACTIONS(5987),
    [anon_sym_BSLASHGls] = ACTIONS(5987),
    [anon_sym_BSLASHGLS] = ACTIONS(5987),
    [anon_sym_BSLASHglspl] = ACTIONS(5987),
    [anon_sym_BSLASHGlspl] = ACTIONS(5987),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5987),
    [anon_sym_BSLASHglslink] = ACTIONS(5987),
    [anon_sym_BSLASHglstext] = ACTIONS(5987),
    [anon_sym_BSLASHGlstext] = ACTIONS(5987),
    [anon_sym_BSLASHGLStext] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5987),
    [anon_sym_BSLASHglsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsname] = ACTIONS(5987),
    [anon_sym_BSLASHGlsname] = ACTIONS(5987),
    [anon_sym_BSLASHGLSname] = ACTIONS(5987),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5987),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5987),
    [anon_sym_BSLASHacrshort] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5987),
    [anon_sym_BSLASHACRshort] = ACTIONS(5987),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrlong] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5987),
    [anon_sym_BSLASHACRlong] = ACTIONS(5987),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrfull] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5987),
    [anon_sym_BSLASHACRfull] = ACTIONS(5987),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHacs] = ACTIONS(5987),
    [anon_sym_BSLASHAcs] = ACTIONS(5987),
    [anon_sym_BSLASHacsp] = ACTIONS(5987),
    [anon_sym_BSLASHAcsp] = ACTIONS(5987),
    [anon_sym_BSLASHacl] = ACTIONS(5987),
    [anon_sym_BSLASHAcl] = ACTIONS(5987),
    [anon_sym_BSLASHaclp] = ACTIONS(5987),
    [anon_sym_BSLASHAclp] = ACTIONS(5987),
    [anon_sym_BSLASHacf] = ACTIONS(5987),
    [anon_sym_BSLASHAcf] = ACTIONS(5987),
    [anon_sym_BSLASHacfp] = ACTIONS(5987),
    [anon_sym_BSLASHAcfp] = ACTIONS(5987),
    [anon_sym_BSLASHac] = ACTIONS(5987),
    [anon_sym_BSLASHAc] = ACTIONS(5987),
    [anon_sym_BSLASHacp] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5987),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5987),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5987),
    [anon_sym_BSLASHcolor] = ACTIONS(5987),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5987),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5987),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5987),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5987),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5987),
    [anon_sym_BSLASHtext] = ACTIONS(5987),
    [anon_sym_BSLASHintertext] = ACTIONS(5987),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5987),
    [anon_sym_BSLASHurl] = ACTIONS(5987),
    [anon_sym_BSLASHhref] = ACTIONS(5987),
  },
  [369] = {
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(369),
    [aux_sym__section_repeat2] = STATE(369),
    [sym_command_name] = ACTIONS(5997),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_RBRACK] = ACTIONS(5999),
    [anon_sym_COMMA] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(5999),
    [anon_sym_LPAREN] = ACTIONS(5999),
    [anon_sym_RPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHpart] = ACTIONS(5997),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddpart] = ACTIONS(5997),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHchapter] = ACTIONS(6001),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6004),
    [anon_sym_BSLASHaddchap] = ACTIONS(6001),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6004),
    [anon_sym_BSLASHsection] = ACTIONS(5997),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddsec] = ACTIONS(5997),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHitem] = ACTIONS(5997),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5999),
    [anon_sym_LBRACE] = ACTIONS(5999),
    [sym_word] = ACTIONS(5997),
    [sym_placeholder] = ACTIONS(5999),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5999),
    [anon_sym_STAR] = ACTIONS(5999),
    [anon_sym_SLASH] = ACTIONS(5999),
    [anon_sym_LT] = ACTIONS(5997),
    [anon_sym_GT] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5997),
    [anon_sym_PIPE] = ACTIONS(5997),
    [anon_sym_COLON] = ACTIONS(5997),
    [anon_sym_SQUOTE] = ACTIONS(5997),
    [anon_sym__] = ACTIONS(5999),
    [anon_sym_CARET] = ACTIONS(5999),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5999),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5999),
    [anon_sym_DOLLAR] = ACTIONS(5997),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHbegin] = ACTIONS(5997),
    [anon_sym_BSLASHtitle] = ACTIONS(5997),
    [anon_sym_BSLASHauthor] = ACTIONS(5997),
    [anon_sym_BSLASHusepackage] = ACTIONS(5997),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5997),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5997),
    [anon_sym_BSLASHinclude] = ACTIONS(5997),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5997),
    [anon_sym_BSLASHinput] = ACTIONS(5997),
    [anon_sym_BSLASHsubfile] = ACTIONS(5997),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5997),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5997),
    [anon_sym_BSLASHbibliography] = ACTIONS(5997),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5997),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5997),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5997),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5997),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5997),
    [anon_sym_BSLASHimport] = ACTIONS(5997),
    [anon_sym_BSLASHsubimport] = ACTIONS(5997),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5997),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHcaption] = ACTIONS(5997),
    [anon_sym_BSLASHcite] = ACTIONS(5997),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCite] = ACTIONS(5997),
    [anon_sym_BSLASHnocite] = ACTIONS(5997),
    [anon_sym_BSLASHcitet] = ACTIONS(5997),
    [anon_sym_BSLASHcitep] = ACTIONS(5997),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteA] = ACTIONS(5997),
    [anon_sym_BSLASHciteR] = ACTIONS(5997),
    [anon_sym_BSLASHciteS] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5997),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteyear] = ACTIONS(5997),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitedate] = ACTIONS(5997),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteurl] = ACTIONS(5997),
    [anon_sym_BSLASHfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5997),
    [anon_sym_BSLASHcitealt] = ACTIONS(5997),
    [anon_sym_BSLASHcitealp] = ACTIONS(5997),
    [anon_sym_BSLASHcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHparencite] = ACTIONS(5997),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHParencite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHtextcite] = ACTIONS(5997),
    [anon_sym_BSLASHTextcite] = ACTIONS(5997),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHsupercite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite] = ACTIONS(5997),
    [anon_sym_BSLASHAutocite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHVolcite] = ACTIONS(5997),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHavolcite] = ACTIONS(5997),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHNotecite] = ACTIONS(5997),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHlabel] = ACTIONS(5997),
    [anon_sym_BSLASHref] = ACTIONS(5997),
    [anon_sym_BSLASHeqref] = ACTIONS(5997),
    [anon_sym_BSLASHvref] = ACTIONS(5997),
    [anon_sym_BSLASHVref] = ACTIONS(5997),
    [anon_sym_BSLASHautoref] = ACTIONS(5997),
    [anon_sym_BSLASHpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcref] = ACTIONS(5997),
    [anon_sym_BSLASHCref] = ACTIONS(5997),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnameCref] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHdef] = ACTIONS(5997),
    [anon_sym_BSLASHlet] = ACTIONS(5997),
    [anon_sym_BSLASHleft] = ACTIONS(5997),
    [anon_sym_BSLASHbigl] = ACTIONS(5997),
    [anon_sym_BSLASHBigl] = ACTIONS(5997),
    [anon_sym_BSLASHbiggl] = ACTIONS(5997),
    [anon_sym_BSLASHBiggl] = ACTIONS(5997),
    [anon_sym_BSLASHright] = ACTIONS(5997),
    [anon_sym_BSLASHbigr] = ACTIONS(5997),
    [anon_sym_BSLASHBigr] = ACTIONS(5997),
    [anon_sym_BSLASHbiggr] = ACTIONS(5997),
    [anon_sym_BSLASHBiggr] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5997),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5997),
    [anon_sym_BSLASHgls] = ACTIONS(5997),
    [anon_sym_BSLASHGls] = ACTIONS(5997),
    [anon_sym_BSLASHGLS] = ACTIONS(5997),
    [anon_sym_BSLASHglspl] = ACTIONS(5997),
    [anon_sym_BSLASHGlspl] = ACTIONS(5997),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5997),
    [anon_sym_BSLASHglslink] = ACTIONS(5997),
    [anon_sym_BSLASHglstext] = ACTIONS(5997),
    [anon_sym_BSLASHGlstext] = ACTIONS(5997),
    [anon_sym_BSLASHGLStext] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5997),
    [anon_sym_BSLASHglsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsname] = ACTIONS(5997),
    [anon_sym_BSLASHGlsname] = ACTIONS(5997),
    [anon_sym_BSLASHGLSname] = ACTIONS(5997),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5997),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5997),
    [anon_sym_BSLASHacrshort] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5997),
    [anon_sym_BSLASHACRshort] = ACTIONS(5997),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrlong] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5997),
    [anon_sym_BSLASHACRlong] = ACTIONS(5997),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrfull] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5997),
    [anon_sym_BSLASHACRfull] = ACTIONS(5997),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHacs] = ACTIONS(5997),
    [anon_sym_BSLASHAcs] = ACTIONS(5997),
    [anon_sym_BSLASHacsp] = ACTIONS(5997),
    [anon_sym_BSLASHAcsp] = ACTIONS(5997),
    [anon_sym_BSLASHacl] = ACTIONS(5997),
    [anon_sym_BSLASHAcl] = ACTIONS(5997),
    [anon_sym_BSLASHaclp] = ACTIONS(5997),
    [anon_sym_BSLASHAclp] = ACTIONS(5997),
    [anon_sym_BSLASHacf] = ACTIONS(5997),
    [anon_sym_BSLASHAcf] = ACTIONS(5997),
    [anon_sym_BSLASHacfp] = ACTIONS(5997),
    [anon_sym_BSLASHAcfp] = ACTIONS(5997),
    [anon_sym_BSLASHac] = ACTIONS(5997),
    [anon_sym_BSLASHAc] = ACTIONS(5997),
    [anon_sym_BSLASHacp] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5997),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5997),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5997),
    [anon_sym_BSLASHcolor] = ACTIONS(5997),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5997),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5997),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5997),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5997),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5997),
    [anon_sym_BSLASHtext] = ACTIONS(5997),
    [anon_sym_BSLASHintertext] = ACTIONS(5997),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5997),
    [anon_sym_BSLASHurl] = ACTIONS(5997),
    [anon_sym_BSLASHhref] = ACTIONS(5997),
  },
  [370] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(6007),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6007),
    [anon_sym_LBRACK] = ACTIONS(6009),
    [anon_sym_RBRACK] = ACTIONS(6009),
    [anon_sym_COMMA] = ACTIONS(6009),
    [anon_sym_EQ] = ACTIONS(6009),
    [anon_sym_LPAREN] = ACTIONS(6009),
    [anon_sym_RPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHpart] = ACTIONS(6007),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddpart] = ACTIONS(6007),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHchapter] = ACTIONS(6007),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddchap] = ACTIONS(6007),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsection] = ACTIONS(6011),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6014),
    [anon_sym_BSLASHaddsec] = ACTIONS(6011),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6014),
    [anon_sym_BSLASHsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHitem] = ACTIONS(6007),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6009),
    [anon_sym_LBRACE] = ACTIONS(6009),
    [sym_word] = ACTIONS(6007),
    [sym_placeholder] = ACTIONS(6009),
    [anon_sym_PLUS] = ACTIONS(6009),
    [anon_sym_DASH] = ACTIONS(6009),
    [anon_sym_STAR] = ACTIONS(6009),
    [anon_sym_SLASH] = ACTIONS(6009),
    [anon_sym_LT] = ACTIONS(6007),
    [anon_sym_GT] = ACTIONS(6007),
    [anon_sym_BANG] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6007),
    [anon_sym_COLON] = ACTIONS(6007),
    [anon_sym_SQUOTE] = ACTIONS(6007),
    [anon_sym__] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(6009),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6009),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6009),
    [anon_sym_DOLLAR] = ACTIONS(6007),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHbegin] = ACTIONS(6007),
    [anon_sym_BSLASHtitle] = ACTIONS(6007),
    [anon_sym_BSLASHauthor] = ACTIONS(6007),
    [anon_sym_BSLASHusepackage] = ACTIONS(6007),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6007),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6007),
    [anon_sym_BSLASHinclude] = ACTIONS(6007),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6007),
    [anon_sym_BSLASHinput] = ACTIONS(6007),
    [anon_sym_BSLASHsubfile] = ACTIONS(6007),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6007),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6007),
    [anon_sym_BSLASHbibliography] = ACTIONS(6007),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6007),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6007),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6007),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6007),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6007),
    [anon_sym_BSLASHimport] = ACTIONS(6007),
    [anon_sym_BSLASHsubimport] = ACTIONS(6007),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6007),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHcaption] = ACTIONS(6007),
    [anon_sym_BSLASHcite] = ACTIONS(6007),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCite] = ACTIONS(6007),
    [anon_sym_BSLASHnocite] = ACTIONS(6007),
    [anon_sym_BSLASHcitet] = ACTIONS(6007),
    [anon_sym_BSLASHcitep] = ACTIONS(6007),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteA] = ACTIONS(6007),
    [anon_sym_BSLASHciteR] = ACTIONS(6007),
    [anon_sym_BSLASHciteS] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6007),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteyear] = ACTIONS(6007),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitedate] = ACTIONS(6007),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteurl] = ACTIONS(6007),
    [anon_sym_BSLASHfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6007),
    [anon_sym_BSLASHcitealt] = ACTIONS(6007),
    [anon_sym_BSLASHcitealp] = ACTIONS(6007),
    [anon_sym_BSLASHcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHparencite] = ACTIONS(6007),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHParencite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHtextcite] = ACTIONS(6007),
    [anon_sym_BSLASHTextcite] = ACTIONS(6007),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHsupercite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite] = ACTIONS(6007),
    [anon_sym_BSLASHAutocite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHVolcite] = ACTIONS(6007),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHavolcite] = ACTIONS(6007),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHNotecite] = ACTIONS(6007),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHlabel] = ACTIONS(6007),
    [anon_sym_BSLASHref] = ACTIONS(6007),
    [anon_sym_BSLASHeqref] = ACTIONS(6007),
    [anon_sym_BSLASHvref] = ACTIONS(6007),
    [anon_sym_BSLASHVref] = ACTIONS(6007),
    [anon_sym_BSLASHautoref] = ACTIONS(6007),
    [anon_sym_BSLASHpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcref] = ACTIONS(6007),
    [anon_sym_BSLASHCref] = ACTIONS(6007),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnameCref] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHdef] = ACTIONS(6007),
    [anon_sym_BSLASHlet] = ACTIONS(6007),
    [anon_sym_BSLASHleft] = ACTIONS(6007),
    [anon_sym_BSLASHbigl] = ACTIONS(6007),
    [anon_sym_BSLASHBigl] = ACTIONS(6007),
    [anon_sym_BSLASHbiggl] = ACTIONS(6007),
    [anon_sym_BSLASHBiggl] = ACTIONS(6007),
    [anon_sym_BSLASHright] = ACTIONS(6007),
    [anon_sym_BSLASHbigr] = ACTIONS(6007),
    [anon_sym_BSLASHBigr] = ACTIONS(6007),
    [anon_sym_BSLASHbiggr] = ACTIONS(6007),
    [anon_sym_BSLASHBiggr] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6007),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6007),
    [anon_sym_BSLASHgls] = ACTIONS(6007),
    [anon_sym_BSLASHGls] = ACTIONS(6007),
    [anon_sym_BSLASHGLS] = ACTIONS(6007),
    [anon_sym_BSLASHglspl] = ACTIONS(6007),
    [anon_sym_BSLASHGlspl] = ACTIONS(6007),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6007),
    [anon_sym_BSLASHglslink] = ACTIONS(6007),
    [anon_sym_BSLASHglstext] = ACTIONS(6007),
    [anon_sym_BSLASHGlstext] = ACTIONS(6007),
    [anon_sym_BSLASHGLStext] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6007),
    [anon_sym_BSLASHglsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsname] = ACTIONS(6007),
    [anon_sym_BSLASHGlsname] = ACTIONS(6007),
    [anon_sym_BSLASHGLSname] = ACTIONS(6007),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6007),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6007),
    [anon_sym_BSLASHacrshort] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6007),
    [anon_sym_BSLASHACRshort] = ACTIONS(6007),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrlong] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6007),
    [anon_sym_BSLASHACRlong] = ACTIONS(6007),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrfull] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6007),
    [anon_sym_BSLASHACRfull] = ACTIONS(6007),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHacs] = ACTIONS(6007),
    [anon_sym_BSLASHAcs] = ACTIONS(6007),
    [anon_sym_BSLASHacsp] = ACTIONS(6007),
    [anon_sym_BSLASHAcsp] = ACTIONS(6007),
    [anon_sym_BSLASHacl] = ACTIONS(6007),
    [anon_sym_BSLASHAcl] = ACTIONS(6007),
    [anon_sym_BSLASHaclp] = ACTIONS(6007),
    [anon_sym_BSLASHAclp] = ACTIONS(6007),
    [anon_sym_BSLASHacf] = ACTIONS(6007),
    [anon_sym_BSLASHAcf] = ACTIONS(6007),
    [anon_sym_BSLASHacfp] = ACTIONS(6007),
    [anon_sym_BSLASHAcfp] = ACTIONS(6007),
    [anon_sym_BSLASHac] = ACTIONS(6007),
    [anon_sym_BSLASHAc] = ACTIONS(6007),
    [anon_sym_BSLASHacp] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6007),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6007),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6007),
    [anon_sym_BSLASHcolor] = ACTIONS(6007),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6007),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6007),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6007),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6007),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6007),
    [anon_sym_BSLASHtext] = ACTIONS(6007),
    [anon_sym_BSLASHintertext] = ACTIONS(6007),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6007),
    [anon_sym_BSLASHurl] = ACTIONS(6007),
    [anon_sym_BSLASHhref] = ACTIONS(6007),
  },
  [371] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(6017),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6017),
    [anon_sym_LBRACK] = ACTIONS(6019),
    [anon_sym_RBRACK] = ACTIONS(6019),
    [anon_sym_COMMA] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6019),
    [anon_sym_LPAREN] = ACTIONS(6019),
    [anon_sym_RPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHpart] = ACTIONS(6017),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddpart] = ACTIONS(6017),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHchapter] = ACTIONS(6017),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddchap] = ACTIONS(6017),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsection] = ACTIONS(6017),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddsec] = ACTIONS(6017),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsection] = ACTIONS(6017),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6021),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6024),
    [anon_sym_BSLASHparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHitem] = ACTIONS(6017),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6019),
    [anon_sym_LBRACE] = ACTIONS(6019),
    [sym_word] = ACTIONS(6017),
    [sym_placeholder] = ACTIONS(6019),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6019),
    [anon_sym_SLASH] = ACTIONS(6019),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_BANG] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6017),
    [anon_sym_COLON] = ACTIONS(6017),
    [anon_sym_SQUOTE] = ACTIONS(6017),
    [anon_sym__] = ACTIONS(6019),
    [anon_sym_CARET] = ACTIONS(6019),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6019),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6019),
    [anon_sym_DOLLAR] = ACTIONS(6017),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHbegin] = ACTIONS(6017),
    [anon_sym_BSLASHtitle] = ACTIONS(6017),
    [anon_sym_BSLASHauthor] = ACTIONS(6017),
    [anon_sym_BSLASHusepackage] = ACTIONS(6017),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6017),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6017),
    [anon_sym_BSLASHinclude] = ACTIONS(6017),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6017),
    [anon_sym_BSLASHinput] = ACTIONS(6017),
    [anon_sym_BSLASHsubfile] = ACTIONS(6017),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6017),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6017),
    [anon_sym_BSLASHbibliography] = ACTIONS(6017),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6017),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6017),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6017),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6017),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6017),
    [anon_sym_BSLASHimport] = ACTIONS(6017),
    [anon_sym_BSLASHsubimport] = ACTIONS(6017),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6017),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHcaption] = ACTIONS(6017),
    [anon_sym_BSLASHcite] = ACTIONS(6017),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCite] = ACTIONS(6017),
    [anon_sym_BSLASHnocite] = ACTIONS(6017),
    [anon_sym_BSLASHcitet] = ACTIONS(6017),
    [anon_sym_BSLASHcitep] = ACTIONS(6017),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteA] = ACTIONS(6017),
    [anon_sym_BSLASHciteR] = ACTIONS(6017),
    [anon_sym_BSLASHciteS] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6017),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteyear] = ACTIONS(6017),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitedate] = ACTIONS(6017),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteurl] = ACTIONS(6017),
    [anon_sym_BSLASHfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6017),
    [anon_sym_BSLASHcitealt] = ACTIONS(6017),
    [anon_sym_BSLASHcitealp] = ACTIONS(6017),
    [anon_sym_BSLASHcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHparencite] = ACTIONS(6017),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHParencite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHtextcite] = ACTIONS(6017),
    [anon_sym_BSLASHTextcite] = ACTIONS(6017),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHsupercite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite] = ACTIONS(6017),
    [anon_sym_BSLASHAutocite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHVolcite] = ACTIONS(6017),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHavolcite] = ACTIONS(6017),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHNotecite] = ACTIONS(6017),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHlabel] = ACTIONS(6017),
    [anon_sym_BSLASHref] = ACTIONS(6017),
    [anon_sym_BSLASHeqref] = ACTIONS(6017),
    [anon_sym_BSLASHvref] = ACTIONS(6017),
    [anon_sym_BSLASHVref] = ACTIONS(6017),
    [anon_sym_BSLASHautoref] = ACTIONS(6017),
    [anon_sym_BSLASHpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcref] = ACTIONS(6017),
    [anon_sym_BSLASHCref] = ACTIONS(6017),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnameCref] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHdef] = ACTIONS(6017),
    [anon_sym_BSLASHlet] = ACTIONS(6017),
    [anon_sym_BSLASHleft] = ACTIONS(6017),
    [anon_sym_BSLASHbigl] = ACTIONS(6017),
    [anon_sym_BSLASHBigl] = ACTIONS(6017),
    [anon_sym_BSLASHbiggl] = ACTIONS(6017),
    [anon_sym_BSLASHBiggl] = ACTIONS(6017),
    [anon_sym_BSLASHright] = ACTIONS(6017),
    [anon_sym_BSLASHbigr] = ACTIONS(6017),
    [anon_sym_BSLASHBigr] = ACTIONS(6017),
    [anon_sym_BSLASHbiggr] = ACTIONS(6017),
    [anon_sym_BSLASHBiggr] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6017),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6017),
    [anon_sym_BSLASHgls] = ACTIONS(6017),
    [anon_sym_BSLASHGls] = ACTIONS(6017),
    [anon_sym_BSLASHGLS] = ACTIONS(6017),
    [anon_sym_BSLASHglspl] = ACTIONS(6017),
    [anon_sym_BSLASHGlspl] = ACTIONS(6017),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6017),
    [anon_sym_BSLASHglslink] = ACTIONS(6017),
    [anon_sym_BSLASHglstext] = ACTIONS(6017),
    [anon_sym_BSLASHGlstext] = ACTIONS(6017),
    [anon_sym_BSLASHGLStext] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6017),
    [anon_sym_BSLASHglsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsname] = ACTIONS(6017),
    [anon_sym_BSLASHGlsname] = ACTIONS(6017),
    [anon_sym_BSLASHGLSname] = ACTIONS(6017),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6017),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6017),
    [anon_sym_BSLASHacrshort] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6017),
    [anon_sym_BSLASHACRshort] = ACTIONS(6017),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrlong] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6017),
    [anon_sym_BSLASHACRlong] = ACTIONS(6017),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrfull] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6017),
    [anon_sym_BSLASHACRfull] = ACTIONS(6017),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHacs] = ACTIONS(6017),
    [anon_sym_BSLASHAcs] = ACTIONS(6017),
    [anon_sym_BSLASHacsp] = ACTIONS(6017),
    [anon_sym_BSLASHAcsp] = ACTIONS(6017),
    [anon_sym_BSLASHacl] = ACTIONS(6017),
    [anon_sym_BSLASHAcl] = ACTIONS(6017),
    [anon_sym_BSLASHaclp] = ACTIONS(6017),
    [anon_sym_BSLASHAclp] = ACTIONS(6017),
    [anon_sym_BSLASHacf] = ACTIONS(6017),
    [anon_sym_BSLASHAcf] = ACTIONS(6017),
    [anon_sym_BSLASHacfp] = ACTIONS(6017),
    [anon_sym_BSLASHAcfp] = ACTIONS(6017),
    [anon_sym_BSLASHac] = ACTIONS(6017),
    [anon_sym_BSLASHAc] = ACTIONS(6017),
    [anon_sym_BSLASHacp] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6017),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6017),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6017),
    [anon_sym_BSLASHcolor] = ACTIONS(6017),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6017),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6017),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6017),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6017),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6017),
    [anon_sym_BSLASHtext] = ACTIONS(6017),
    [anon_sym_BSLASHintertext] = ACTIONS(6017),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6017),
    [anon_sym_BSLASHurl] = ACTIONS(6017),
    [anon_sym_BSLASHhref] = ACTIONS(6017),
  },
  [372] = {
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(372),
    [aux_sym__paragraph_repeat1] = STATE(372),
    [sym_command_name] = ACTIONS(6027),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6027),
    [anon_sym_LBRACK] = ACTIONS(6029),
    [anon_sym_RBRACK] = ACTIONS(6029),
    [anon_sym_COMMA] = ACTIONS(6029),
    [anon_sym_EQ] = ACTIONS(6029),
    [anon_sym_LPAREN] = ACTIONS(6029),
    [anon_sym_RPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHpart] = ACTIONS(6027),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddpart] = ACTIONS(6027),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHchapter] = ACTIONS(6027),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddchap] = ACTIONS(6027),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsection] = ACTIONS(6027),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddsec] = ACTIONS(6027),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHparagraph] = ACTIONS(6031),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6034),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6027),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHitem] = ACTIONS(6027),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6029),
    [anon_sym_LBRACE] = ACTIONS(6029),
    [sym_word] = ACTIONS(6027),
    [sym_placeholder] = ACTIONS(6029),
    [anon_sym_PLUS] = ACTIONS(6029),
    [anon_sym_DASH] = ACTIONS(6029),
    [anon_sym_STAR] = ACTIONS(6029),
    [anon_sym_SLASH] = ACTIONS(6029),
    [anon_sym_LT] = ACTIONS(6027),
    [anon_sym_GT] = ACTIONS(6027),
    [anon_sym_BANG] = ACTIONS(6027),
    [anon_sym_PIPE] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6027),
    [anon_sym_SQUOTE] = ACTIONS(6027),
    [anon_sym__] = ACTIONS(6029),
    [anon_sym_CARET] = ACTIONS(6029),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6029),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6027),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHbegin] = ACTIONS(6027),
    [anon_sym_BSLASHtitle] = ACTIONS(6027),
    [anon_sym_BSLASHauthor] = ACTIONS(6027),
    [anon_sym_BSLASHusepackage] = ACTIONS(6027),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6027),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6027),
    [anon_sym_BSLASHinclude] = ACTIONS(6027),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6027),
    [anon_sym_BSLASHinput] = ACTIONS(6027),
    [anon_sym_BSLASHsubfile] = ACTIONS(6027),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6027),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6027),
    [anon_sym_BSLASHbibliography] = ACTIONS(6027),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6027),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6027),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6027),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6027),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6027),
    [anon_sym_BSLASHimport] = ACTIONS(6027),
    [anon_sym_BSLASHsubimport] = ACTIONS(6027),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6027),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHcaption] = ACTIONS(6027),
    [anon_sym_BSLASHcite] = ACTIONS(6027),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCite] = ACTIONS(6027),
    [anon_sym_BSLASHnocite] = ACTIONS(6027),
    [anon_sym_BSLASHcitet] = ACTIONS(6027),
    [anon_sym_BSLASHcitep] = ACTIONS(6027),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteA] = ACTIONS(6027),
    [anon_sym_BSLASHciteR] = ACTIONS(6027),
    [anon_sym_BSLASHciteS] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6027),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteyear] = ACTIONS(6027),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitedate] = ACTIONS(6027),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteurl] = ACTIONS(6027),
    [anon_sym_BSLASHfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6027),
    [anon_sym_BSLASHcitealt] = ACTIONS(6027),
    [anon_sym_BSLASHcitealp] = ACTIONS(6027),
    [anon_sym_BSLASHcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHparencite] = ACTIONS(6027),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHParencite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHtextcite] = ACTIONS(6027),
    [anon_sym_BSLASHTextcite] = ACTIONS(6027),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHsupercite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite] = ACTIONS(6027),
    [anon_sym_BSLASHAutocite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHVolcite] = ACTIONS(6027),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHavolcite] = ACTIONS(6027),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHNotecite] = ACTIONS(6027),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHlabel] = ACTIONS(6027),
    [anon_sym_BSLASHref] = ACTIONS(6027),
    [anon_sym_BSLASHeqref] = ACTIONS(6027),
    [anon_sym_BSLASHvref] = ACTIONS(6027),
    [anon_sym_BSLASHVref] = ACTIONS(6027),
    [anon_sym_BSLASHautoref] = ACTIONS(6027),
    [anon_sym_BSLASHpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcref] = ACTIONS(6027),
    [anon_sym_BSLASHCref] = ACTIONS(6027),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnameCref] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHdef] = ACTIONS(6027),
    [anon_sym_BSLASHlet] = ACTIONS(6027),
    [anon_sym_BSLASHleft] = ACTIONS(6027),
    [anon_sym_BSLASHbigl] = ACTIONS(6027),
    [anon_sym_BSLASHBigl] = ACTIONS(6027),
    [anon_sym_BSLASHbiggl] = ACTIONS(6027),
    [anon_sym_BSLASHBiggl] = ACTIONS(6027),
    [anon_sym_BSLASHright] = ACTIONS(6027),
    [anon_sym_BSLASHbigr] = ACTIONS(6027),
    [anon_sym_BSLASHBigr] = ACTIONS(6027),
    [anon_sym_BSLASHbiggr] = ACTIONS(6027),
    [anon_sym_BSLASHBiggr] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6027),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6027),
    [anon_sym_BSLASHgls] = ACTIONS(6027),
    [anon_sym_BSLASHGls] = ACTIONS(6027),
    [anon_sym_BSLASHGLS] = ACTIONS(6027),
    [anon_sym_BSLASHglspl] = ACTIONS(6027),
    [anon_sym_BSLASHGlspl] = ACTIONS(6027),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6027),
    [anon_sym_BSLASHglslink] = ACTIONS(6027),
    [anon_sym_BSLASHglstext] = ACTIONS(6027),
    [anon_sym_BSLASHGlstext] = ACTIONS(6027),
    [anon_sym_BSLASHGLStext] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6027),
    [anon_sym_BSLASHglsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsname] = ACTIONS(6027),
    [anon_sym_BSLASHGlsname] = ACTIONS(6027),
    [anon_sym_BSLASHGLSname] = ACTIONS(6027),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6027),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6027),
    [anon_sym_BSLASHacrshort] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6027),
    [anon_sym_BSLASHACRshort] = ACTIONS(6027),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrlong] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6027),
    [anon_sym_BSLASHACRlong] = ACTIONS(6027),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrfull] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6027),
    [anon_sym_BSLASHACRfull] = ACTIONS(6027),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHacs] = ACTIONS(6027),
    [anon_sym_BSLASHAcs] = ACTIONS(6027),
    [anon_sym_BSLASHacsp] = ACTIONS(6027),
    [anon_sym_BSLASHAcsp] = ACTIONS(6027),
    [anon_sym_BSLASHacl] = ACTIONS(6027),
    [anon_sym_BSLASHAcl] = ACTIONS(6027),
    [anon_sym_BSLASHaclp] = ACTIONS(6027),
    [anon_sym_BSLASHAclp] = ACTIONS(6027),
    [anon_sym_BSLASHacf] = ACTIONS(6027),
    [anon_sym_BSLASHAcf] = ACTIONS(6027),
    [anon_sym_BSLASHacfp] = ACTIONS(6027),
    [anon_sym_BSLASHAcfp] = ACTIONS(6027),
    [anon_sym_BSLASHac] = ACTIONS(6027),
    [anon_sym_BSLASHAc] = ACTIONS(6027),
    [anon_sym_BSLASHacp] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6027),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6027),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6027),
    [anon_sym_BSLASHcolor] = ACTIONS(6027),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6027),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6027),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6027),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6027),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6027),
    [anon_sym_BSLASHtext] = ACTIONS(6027),
    [anon_sym_BSLASHintertext] = ACTIONS(6027),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6027),
    [anon_sym_BSLASHurl] = ACTIONS(6027),
    [anon_sym_BSLASHhref] = ACTIONS(6027),
  },
  [373] = {
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(373),
    [aux_sym__paragraph_repeat2] = STATE(373),
    [sym_command_name] = ACTIONS(6037),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(6039),
    [anon_sym_RBRACK] = ACTIONS(6039),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_EQ] = ACTIONS(6039),
    [anon_sym_LPAREN] = ACTIONS(6039),
    [anon_sym_RPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHpart] = ACTIONS(6037),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddpart] = ACTIONS(6037),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHchapter] = ACTIONS(6037),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddchap] = ACTIONS(6037),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsection] = ACTIONS(6037),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddsec] = ACTIONS(6037),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHparagraph] = ACTIONS(6037),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6041),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6044),
    [anon_sym_BSLASHitem] = ACTIONS(6037),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6039),
    [anon_sym_LBRACE] = ACTIONS(6039),
    [sym_word] = ACTIONS(6037),
    [sym_placeholder] = ACTIONS(6039),
    [anon_sym_PLUS] = ACTIONS(6039),
    [anon_sym_DASH] = ACTIONS(6039),
    [anon_sym_STAR] = ACTIONS(6039),
    [anon_sym_SLASH] = ACTIONS(6039),
    [anon_sym_LT] = ACTIONS(6037),
    [anon_sym_GT] = ACTIONS(6037),
    [anon_sym_BANG] = ACTIONS(6037),
    [anon_sym_PIPE] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6037),
    [anon_sym_SQUOTE] = ACTIONS(6037),
    [anon_sym__] = ACTIONS(6039),
    [anon_sym_CARET] = ACTIONS(6039),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6039),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6039),
    [anon_sym_DOLLAR] = ACTIONS(6037),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHbegin] = ACTIONS(6037),
    [anon_sym_BSLASHtitle] = ACTIONS(6037),
    [anon_sym_BSLASHauthor] = ACTIONS(6037),
    [anon_sym_BSLASHusepackage] = ACTIONS(6037),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6037),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6037),
    [anon_sym_BSLASHinclude] = ACTIONS(6037),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6037),
    [anon_sym_BSLASHinput] = ACTIONS(6037),
    [anon_sym_BSLASHsubfile] = ACTIONS(6037),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6037),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6037),
    [anon_sym_BSLASHbibliography] = ACTIONS(6037),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6037),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6037),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6037),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6037),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6037),
    [anon_sym_BSLASHimport] = ACTIONS(6037),
    [anon_sym_BSLASHsubimport] = ACTIONS(6037),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6037),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHcaption] = ACTIONS(6037),
    [anon_sym_BSLASHcite] = ACTIONS(6037),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCite] = ACTIONS(6037),
    [anon_sym_BSLASHnocite] = ACTIONS(6037),
    [anon_sym_BSLASHcitet] = ACTIONS(6037),
    [anon_sym_BSLASHcitep] = ACTIONS(6037),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteA] = ACTIONS(6037),
    [anon_sym_BSLASHciteR] = ACTIONS(6037),
    [anon_sym_BSLASHciteS] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6037),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteyear] = ACTIONS(6037),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitedate] = ACTIONS(6037),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteurl] = ACTIONS(6037),
    [anon_sym_BSLASHfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6037),
    [anon_sym_BSLASHcitealt] = ACTIONS(6037),
    [anon_sym_BSLASHcitealp] = ACTIONS(6037),
    [anon_sym_BSLASHcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHparencite] = ACTIONS(6037),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHParencite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHtextcite] = ACTIONS(6037),
    [anon_sym_BSLASHTextcite] = ACTIONS(6037),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHsupercite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite] = ACTIONS(6037),
    [anon_sym_BSLASHAutocite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHVolcite] = ACTIONS(6037),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHavolcite] = ACTIONS(6037),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHNotecite] = ACTIONS(6037),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHlabel] = ACTIONS(6037),
    [anon_sym_BSLASHref] = ACTIONS(6037),
    [anon_sym_BSLASHeqref] = ACTIONS(6037),
    [anon_sym_BSLASHvref] = ACTIONS(6037),
    [anon_sym_BSLASHVref] = ACTIONS(6037),
    [anon_sym_BSLASHautoref] = ACTIONS(6037),
    [anon_sym_BSLASHpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcref] = ACTIONS(6037),
    [anon_sym_BSLASHCref] = ACTIONS(6037),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnameCref] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHdef] = ACTIONS(6037),
    [anon_sym_BSLASHlet] = ACTIONS(6037),
    [anon_sym_BSLASHleft] = ACTIONS(6037),
    [anon_sym_BSLASHbigl] = ACTIONS(6037),
    [anon_sym_BSLASHBigl] = ACTIONS(6037),
    [anon_sym_BSLASHbiggl] = ACTIONS(6037),
    [anon_sym_BSLASHBiggl] = ACTIONS(6037),
    [anon_sym_BSLASHright] = ACTIONS(6037),
    [anon_sym_BSLASHbigr] = ACTIONS(6037),
    [anon_sym_BSLASHBigr] = ACTIONS(6037),
    [anon_sym_BSLASHbiggr] = ACTIONS(6037),
    [anon_sym_BSLASHBiggr] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6037),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6037),
    [anon_sym_BSLASHgls] = ACTIONS(6037),
    [anon_sym_BSLASHGls] = ACTIONS(6037),
    [anon_sym_BSLASHGLS] = ACTIONS(6037),
    [anon_sym_BSLASHglspl] = ACTIONS(6037),
    [anon_sym_BSLASHGlspl] = ACTIONS(6037),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6037),
    [anon_sym_BSLASHglslink] = ACTIONS(6037),
    [anon_sym_BSLASHglstext] = ACTIONS(6037),
    [anon_sym_BSLASHGlstext] = ACTIONS(6037),
    [anon_sym_BSLASHGLStext] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6037),
    [anon_sym_BSLASHglsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsname] = ACTIONS(6037),
    [anon_sym_BSLASHGlsname] = ACTIONS(6037),
    [anon_sym_BSLASHGLSname] = ACTIONS(6037),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6037),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6037),
    [anon_sym_BSLASHacrshort] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6037),
    [anon_sym_BSLASHACRshort] = ACTIONS(6037),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrlong] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6037),
    [anon_sym_BSLASHACRlong] = ACTIONS(6037),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrfull] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6037),
    [anon_sym_BSLASHACRfull] = ACTIONS(6037),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHacs] = ACTIONS(6037),
    [anon_sym_BSLASHAcs] = ACTIONS(6037),
    [anon_sym_BSLASHacsp] = ACTIONS(6037),
    [anon_sym_BSLASHAcsp] = ACTIONS(6037),
    [anon_sym_BSLASHacl] = ACTIONS(6037),
    [anon_sym_BSLASHAcl] = ACTIONS(6037),
    [anon_sym_BSLASHaclp] = ACTIONS(6037),
    [anon_sym_BSLASHAclp] = ACTIONS(6037),
    [anon_sym_BSLASHacf] = ACTIONS(6037),
    [anon_sym_BSLASHAcf] = ACTIONS(6037),
    [anon_sym_BSLASHacfp] = ACTIONS(6037),
    [anon_sym_BSLASHAcfp] = ACTIONS(6037),
    [anon_sym_BSLASHac] = ACTIONS(6037),
    [anon_sym_BSLASHAc] = ACTIONS(6037),
    [anon_sym_BSLASHacp] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6037),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6037),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6037),
    [anon_sym_BSLASHcolor] = ACTIONS(6037),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6037),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6037),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6037),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6037),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6037),
    [anon_sym_BSLASHtext] = ACTIONS(6037),
    [anon_sym_BSLASHintertext] = ACTIONS(6037),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6037),
    [anon_sym_BSLASHurl] = ACTIONS(6037),
    [anon_sym_BSLASHhref] = ACTIONS(6037),
  },
  [374] = {
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(374),
    [aux_sym__paragraph_repeat3] = STATE(374),
    [sym_command_name] = ACTIONS(6047),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(6049),
    [anon_sym_RBRACK] = ACTIONS(6049),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(6049),
    [anon_sym_RPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHpart] = ACTIONS(6047),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddpart] = ACTIONS(6047),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHchapter] = ACTIONS(6047),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddchap] = ACTIONS(6047),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsection] = ACTIONS(6047),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddsec] = ACTIONS(6047),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHitem] = ACTIONS(6051),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6054),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_word] = ACTIONS(6047),
    [sym_placeholder] = ACTIONS(6049),
    [anon_sym_PLUS] = ACTIONS(6049),
    [anon_sym_DASH] = ACTIONS(6049),
    [anon_sym_STAR] = ACTIONS(6049),
    [anon_sym_SLASH] = ACTIONS(6049),
    [anon_sym_LT] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6047),
    [anon_sym_BANG] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6047),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SQUOTE] = ACTIONS(6047),
    [anon_sym__] = ACTIONS(6049),
    [anon_sym_CARET] = ACTIONS(6049),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6049),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6049),
    [anon_sym_DOLLAR] = ACTIONS(6047),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHbegin] = ACTIONS(6047),
    [anon_sym_BSLASHtitle] = ACTIONS(6047),
    [anon_sym_BSLASHauthor] = ACTIONS(6047),
    [anon_sym_BSLASHusepackage] = ACTIONS(6047),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6047),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6047),
    [anon_sym_BSLASHinclude] = ACTIONS(6047),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6047),
    [anon_sym_BSLASHinput] = ACTIONS(6047),
    [anon_sym_BSLASHsubfile] = ACTIONS(6047),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6047),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6047),
    [anon_sym_BSLASHbibliography] = ACTIONS(6047),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6047),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6047),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6047),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6047),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6047),
    [anon_sym_BSLASHimport] = ACTIONS(6047),
    [anon_sym_BSLASHsubimport] = ACTIONS(6047),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6047),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHcaption] = ACTIONS(6047),
    [anon_sym_BSLASHcite] = ACTIONS(6047),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCite] = ACTIONS(6047),
    [anon_sym_BSLASHnocite] = ACTIONS(6047),
    [anon_sym_BSLASHcitet] = ACTIONS(6047),
    [anon_sym_BSLASHcitep] = ACTIONS(6047),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteA] = ACTIONS(6047),
    [anon_sym_BSLASHciteR] = ACTIONS(6047),
    [anon_sym_BSLASHciteS] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6047),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteyear] = ACTIONS(6047),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitedate] = ACTIONS(6047),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteurl] = ACTIONS(6047),
    [anon_sym_BSLASHfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6047),
    [anon_sym_BSLASHcitealt] = ACTIONS(6047),
    [anon_sym_BSLASHcitealp] = ACTIONS(6047),
    [anon_sym_BSLASHcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHparencite] = ACTIONS(6047),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHParencite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHtextcite] = ACTIONS(6047),
    [anon_sym_BSLASHTextcite] = ACTIONS(6047),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHsupercite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite] = ACTIONS(6047),
    [anon_sym_BSLASHAutocite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHVolcite] = ACTIONS(6047),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHavolcite] = ACTIONS(6047),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHNotecite] = ACTIONS(6047),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHlabel] = ACTIONS(6047),
    [anon_sym_BSLASHref] = ACTIONS(6047),
    [anon_sym_BSLASHeqref] = ACTIONS(6047),
    [anon_sym_BSLASHvref] = ACTIONS(6047),
    [anon_sym_BSLASHVref] = ACTIONS(6047),
    [anon_sym_BSLASHautoref] = ACTIONS(6047),
    [anon_sym_BSLASHpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcref] = ACTIONS(6047),
    [anon_sym_BSLASHCref] = ACTIONS(6047),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnameCref] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHdef] = ACTIONS(6047),
    [anon_sym_BSLASHlet] = ACTIONS(6047),
    [anon_sym_BSLASHleft] = ACTIONS(6047),
    [anon_sym_BSLASHbigl] = ACTIONS(6047),
    [anon_sym_BSLASHBigl] = ACTIONS(6047),
    [anon_sym_BSLASHbiggl] = ACTIONS(6047),
    [anon_sym_BSLASHBiggl] = ACTIONS(6047),
    [anon_sym_BSLASHright] = ACTIONS(6047),
    [anon_sym_BSLASHbigr] = ACTIONS(6047),
    [anon_sym_BSLASHBigr] = ACTIONS(6047),
    [anon_sym_BSLASHbiggr] = ACTIONS(6047),
    [anon_sym_BSLASHBiggr] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6047),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6047),
    [anon_sym_BSLASHgls] = ACTIONS(6047),
    [anon_sym_BSLASHGls] = ACTIONS(6047),
    [anon_sym_BSLASHGLS] = ACTIONS(6047),
    [anon_sym_BSLASHglspl] = ACTIONS(6047),
    [anon_sym_BSLASHGlspl] = ACTIONS(6047),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6047),
    [anon_sym_BSLASHglslink] = ACTIONS(6047),
    [anon_sym_BSLASHglstext] = ACTIONS(6047),
    [anon_sym_BSLASHGlstext] = ACTIONS(6047),
    [anon_sym_BSLASHGLStext] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6047),
    [anon_sym_BSLASHglsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsname] = ACTIONS(6047),
    [anon_sym_BSLASHGlsname] = ACTIONS(6047),
    [anon_sym_BSLASHGLSname] = ACTIONS(6047),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6047),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6047),
    [anon_sym_BSLASHacrshort] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6047),
    [anon_sym_BSLASHACRshort] = ACTIONS(6047),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrlong] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6047),
    [anon_sym_BSLASHACRlong] = ACTIONS(6047),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrfull] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6047),
    [anon_sym_BSLASHACRfull] = ACTIONS(6047),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHacs] = ACTIONS(6047),
    [anon_sym_BSLASHAcs] = ACTIONS(6047),
    [anon_sym_BSLASHacsp] = ACTIONS(6047),
    [anon_sym_BSLASHAcsp] = ACTIONS(6047),
    [anon_sym_BSLASHacl] = ACTIONS(6047),
    [anon_sym_BSLASHAcl] = ACTIONS(6047),
    [anon_sym_BSLASHaclp] = ACTIONS(6047),
    [anon_sym_BSLASHAclp] = ACTIONS(6047),
    [anon_sym_BSLASHacf] = ACTIONS(6047),
    [anon_sym_BSLASHAcf] = ACTIONS(6047),
    [anon_sym_BSLASHacfp] = ACTIONS(6047),
    [anon_sym_BSLASHAcfp] = ACTIONS(6047),
    [anon_sym_BSLASHac] = ACTIONS(6047),
    [anon_sym_BSLASHAc] = ACTIONS(6047),
    [anon_sym_BSLASHacp] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6047),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6047),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6047),
    [anon_sym_BSLASHcolor] = ACTIONS(6047),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6047),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6047),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6047),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6047),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6047),
    [anon_sym_BSLASHtext] = ACTIONS(6047),
    [anon_sym_BSLASHintertext] = ACTIONS(6047),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6047),
    [anon_sym_BSLASHurl] = ACTIONS(6047),
    [anon_sym_BSLASHhref] = ACTIONS(6047),
  },
  [375] = {
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(369),
    [aux_sym__section_repeat2] = STATE(369),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHright] = ACTIONS(5808),
    [anon_sym_BSLASHbigr] = ACTIONS(5808),
    [anon_sym_BSLASHBigr] = ACTIONS(5808),
    [anon_sym_BSLASHbiggr] = ACTIONS(5808),
    [anon_sym_BSLASHBiggr] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [376] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHright] = ACTIONS(5808),
    [anon_sym_BSLASHbigr] = ACTIONS(5808),
    [anon_sym_BSLASHBigr] = ACTIONS(5808),
    [anon_sym_BSLASHbiggr] = ACTIONS(5808),
    [anon_sym_BSLASHBiggr] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [377] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHright] = ACTIONS(5808),
    [anon_sym_BSLASHbigr] = ACTIONS(5808),
    [anon_sym_BSLASHBigr] = ACTIONS(5808),
    [anon_sym_BSLASHbiggr] = ACTIONS(5808),
    [anon_sym_BSLASHBiggr] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [378] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHright] = ACTIONS(5808),
    [anon_sym_BSLASHbigr] = ACTIONS(5808),
    [anon_sym_BSLASHBigr] = ACTIONS(5808),
    [anon_sym_BSLASHbiggr] = ACTIONS(5808),
    [anon_sym_BSLASHBiggr] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [379] = {
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(369),
    [aux_sym__section_repeat2] = STATE(369),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHright] = ACTIONS(5808),
    [anon_sym_BSLASHbigr] = ACTIONS(5808),
    [anon_sym_BSLASHBigr] = ACTIONS(5808),
    [anon_sym_BSLASHbiggr] = ACTIONS(5808),
    [anon_sym_BSLASHBiggr] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [380] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHright] = ACTIONS(5808),
    [anon_sym_BSLASHbigr] = ACTIONS(5808),
    [anon_sym_BSLASHBigr] = ACTIONS(5808),
    [anon_sym_BSLASHbiggr] = ACTIONS(5808),
    [anon_sym_BSLASHBiggr] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [381] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHright] = ACTIONS(5808),
    [anon_sym_BSLASHbigr] = ACTIONS(5808),
    [anon_sym_BSLASHBigr] = ACTIONS(5808),
    [anon_sym_BSLASHbiggr] = ACTIONS(5808),
    [anon_sym_BSLASHBiggr] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [382] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHright] = ACTIONS(5808),
    [anon_sym_BSLASHbigr] = ACTIONS(5808),
    [anon_sym_BSLASHBigr] = ACTIONS(5808),
    [anon_sym_BSLASHbiggr] = ACTIONS(5808),
    [anon_sym_BSLASHBiggr] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [383] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHright] = ACTIONS(5953),
    [anon_sym_BSLASHbigr] = ACTIONS(5953),
    [anon_sym_BSLASHBigr] = ACTIONS(5953),
    [anon_sym_BSLASHbiggr] = ACTIONS(5953),
    [anon_sym_BSLASHBiggr] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [384] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHright] = ACTIONS(5953),
    [anon_sym_BSLASHbigr] = ACTIONS(5953),
    [anon_sym_BSLASHBigr] = ACTIONS(5953),
    [anon_sym_BSLASHbiggr] = ACTIONS(5953),
    [anon_sym_BSLASHBiggr] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [385] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHright] = ACTIONS(5953),
    [anon_sym_BSLASHbigr] = ACTIONS(5953),
    [anon_sym_BSLASHBigr] = ACTIONS(5953),
    [anon_sym_BSLASHbiggr] = ACTIONS(5953),
    [anon_sym_BSLASHBiggr] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [386] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(581),
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(473),
    [aux_sym__section_repeat4] = STATE(581),
    [aux_sym__section_repeat5] = STATE(473),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [387] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHright] = ACTIONS(5953),
    [anon_sym_BSLASHbigr] = ACTIONS(5953),
    [anon_sym_BSLASHBigr] = ACTIONS(5953),
    [anon_sym_BSLASHbiggr] = ACTIONS(5953),
    [anon_sym_BSLASHBiggr] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [388] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHright] = ACTIONS(5953),
    [anon_sym_BSLASHbigr] = ACTIONS(5953),
    [anon_sym_BSLASHBigr] = ACTIONS(5953),
    [anon_sym_BSLASHbiggr] = ACTIONS(5953),
    [anon_sym_BSLASHBiggr] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [389] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHright] = ACTIONS(5953),
    [anon_sym_BSLASHbigr] = ACTIONS(5953),
    [anon_sym_BSLASHBigr] = ACTIONS(5953),
    [anon_sym_BSLASHbiggr] = ACTIONS(5953),
    [anon_sym_BSLASHBiggr] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [390] = {
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(374),
    [aux_sym__paragraph_repeat3] = STATE(374),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHright] = ACTIONS(6057),
    [anon_sym_BSLASHbigr] = ACTIONS(6057),
    [anon_sym_BSLASHBigr] = ACTIONS(6057),
    [anon_sym_BSLASHbiggr] = ACTIONS(6057),
    [anon_sym_BSLASHBiggr] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [391] = {
    [sym__section_part] = STATE(451),
    [sym_curly_group] = STATE(445),
    [sym_brack_group] = STATE(2487),
    [sym_command_name] = ACTIONS(6061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(6063),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHpart] = ACTIONS(6061),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddpart] = ACTIONS(6061),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHchapter] = ACTIONS(6061),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddchap] = ACTIONS(6061),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsection] = ACTIONS(6061),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddsec] = ACTIONS(6061),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHitem] = ACTIONS(6061),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6063),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6061),
    [sym_placeholder] = ACTIONS(6063),
    [anon_sym_PLUS] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6063),
    [anon_sym_STAR] = ACTIONS(6063),
    [anon_sym_SLASH] = ACTIONS(6063),
    [anon_sym_LT] = ACTIONS(6061),
    [anon_sym_GT] = ACTIONS(6061),
    [anon_sym_BANG] = ACTIONS(6061),
    [anon_sym_PIPE] = ACTIONS(6061),
    [anon_sym_COLON] = ACTIONS(6061),
    [anon_sym_SQUOTE] = ACTIONS(6061),
    [anon_sym__] = ACTIONS(6063),
    [anon_sym_CARET] = ACTIONS(6063),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6063),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6063),
    [anon_sym_DOLLAR] = ACTIONS(6061),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHbegin] = ACTIONS(6061),
    [anon_sym_BSLASHtitle] = ACTIONS(6061),
    [anon_sym_BSLASHauthor] = ACTIONS(6061),
    [anon_sym_BSLASHusepackage] = ACTIONS(6061),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6061),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6061),
    [anon_sym_BSLASHinclude] = ACTIONS(6061),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6061),
    [anon_sym_BSLASHinput] = ACTIONS(6061),
    [anon_sym_BSLASHsubfile] = ACTIONS(6061),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6061),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6061),
    [anon_sym_BSLASHbibliography] = ACTIONS(6061),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6061),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6061),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6061),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6061),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6061),
    [anon_sym_BSLASHimport] = ACTIONS(6061),
    [anon_sym_BSLASHsubimport] = ACTIONS(6061),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6061),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHcaption] = ACTIONS(6061),
    [anon_sym_BSLASHcite] = ACTIONS(6061),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCite] = ACTIONS(6061),
    [anon_sym_BSLASHnocite] = ACTIONS(6061),
    [anon_sym_BSLASHcitet] = ACTIONS(6061),
    [anon_sym_BSLASHcitep] = ACTIONS(6061),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteA] = ACTIONS(6061),
    [anon_sym_BSLASHciteR] = ACTIONS(6061),
    [anon_sym_BSLASHciteS] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6061),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteyear] = ACTIONS(6061),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitedate] = ACTIONS(6061),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteurl] = ACTIONS(6061),
    [anon_sym_BSLASHfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6061),
    [anon_sym_BSLASHcitealt] = ACTIONS(6061),
    [anon_sym_BSLASHcitealp] = ACTIONS(6061),
    [anon_sym_BSLASHcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHparencite] = ACTIONS(6061),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHParencite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHtextcite] = ACTIONS(6061),
    [anon_sym_BSLASHTextcite] = ACTIONS(6061),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHsupercite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite] = ACTIONS(6061),
    [anon_sym_BSLASHAutocite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHVolcite] = ACTIONS(6061),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHavolcite] = ACTIONS(6061),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHNotecite] = ACTIONS(6061),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHlabel] = ACTIONS(6061),
    [anon_sym_BSLASHref] = ACTIONS(6061),
    [anon_sym_BSLASHeqref] = ACTIONS(6061),
    [anon_sym_BSLASHvref] = ACTIONS(6061),
    [anon_sym_BSLASHVref] = ACTIONS(6061),
    [anon_sym_BSLASHautoref] = ACTIONS(6061),
    [anon_sym_BSLASHpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcref] = ACTIONS(6061),
    [anon_sym_BSLASHCref] = ACTIONS(6061),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnameCref] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHdef] = ACTIONS(6061),
    [anon_sym_BSLASHlet] = ACTIONS(6061),
    [anon_sym_BSLASHleft] = ACTIONS(6061),
    [anon_sym_BSLASHbigl] = ACTIONS(6061),
    [anon_sym_BSLASHBigl] = ACTIONS(6061),
    [anon_sym_BSLASHbiggl] = ACTIONS(6061),
    [anon_sym_BSLASHBiggl] = ACTIONS(6061),
    [anon_sym_BSLASHright] = ACTIONS(6061),
    [anon_sym_BSLASHbigr] = ACTIONS(6061),
    [anon_sym_BSLASHBigr] = ACTIONS(6061),
    [anon_sym_BSLASHbiggr] = ACTIONS(6061),
    [anon_sym_BSLASHBiggr] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6061),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6061),
    [anon_sym_BSLASHgls] = ACTIONS(6061),
    [anon_sym_BSLASHGls] = ACTIONS(6061),
    [anon_sym_BSLASHGLS] = ACTIONS(6061),
    [anon_sym_BSLASHglspl] = ACTIONS(6061),
    [anon_sym_BSLASHGlspl] = ACTIONS(6061),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6061),
    [anon_sym_BSLASHglslink] = ACTIONS(6061),
    [anon_sym_BSLASHglstext] = ACTIONS(6061),
    [anon_sym_BSLASHGlstext] = ACTIONS(6061),
    [anon_sym_BSLASHGLStext] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6061),
    [anon_sym_BSLASHglsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsname] = ACTIONS(6061),
    [anon_sym_BSLASHGlsname] = ACTIONS(6061),
    [anon_sym_BSLASHGLSname] = ACTIONS(6061),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6061),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6061),
    [anon_sym_BSLASHacrshort] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6061),
    [anon_sym_BSLASHACRshort] = ACTIONS(6061),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrlong] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6061),
    [anon_sym_BSLASHACRlong] = ACTIONS(6061),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrfull] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6061),
    [anon_sym_BSLASHACRfull] = ACTIONS(6061),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHacs] = ACTIONS(6061),
    [anon_sym_BSLASHAcs] = ACTIONS(6061),
    [anon_sym_BSLASHacsp] = ACTIONS(6061),
    [anon_sym_BSLASHAcsp] = ACTIONS(6061),
    [anon_sym_BSLASHacl] = ACTIONS(6061),
    [anon_sym_BSLASHAcl] = ACTIONS(6061),
    [anon_sym_BSLASHaclp] = ACTIONS(6061),
    [anon_sym_BSLASHAclp] = ACTIONS(6061),
    [anon_sym_BSLASHacf] = ACTIONS(6061),
    [anon_sym_BSLASHAcf] = ACTIONS(6061),
    [anon_sym_BSLASHacfp] = ACTIONS(6061),
    [anon_sym_BSLASHAcfp] = ACTIONS(6061),
    [anon_sym_BSLASHac] = ACTIONS(6061),
    [anon_sym_BSLASHAc] = ACTIONS(6061),
    [anon_sym_BSLASHacp] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6061),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6061),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6061),
    [anon_sym_BSLASHcolor] = ACTIONS(6061),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6061),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6061),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6061),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6061),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6061),
    [anon_sym_BSLASHtext] = ACTIONS(6061),
    [anon_sym_BSLASHintertext] = ACTIONS(6061),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6061),
    [anon_sym_BSLASHurl] = ACTIONS(6061),
    [anon_sym_BSLASHhref] = ACTIONS(6061),
  },
  [392] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHright] = ACTIONS(5957),
    [anon_sym_BSLASHbigr] = ACTIONS(5957),
    [anon_sym_BSLASHBigr] = ACTIONS(5957),
    [anon_sym_BSLASHbiggr] = ACTIONS(5957),
    [anon_sym_BSLASHBiggr] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [393] = {
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(369),
    [aux_sym__section_repeat2] = STATE(369),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHright] = ACTIONS(2132),
    [anon_sym_BSLASHbigr] = ACTIONS(2132),
    [anon_sym_BSLASHBigr] = ACTIONS(2132),
    [anon_sym_BSLASHbiggr] = ACTIONS(2132),
    [anon_sym_BSLASHBiggr] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [394] = {
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(373),
    [aux_sym__paragraph_repeat2] = STATE(373),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHright] = ACTIONS(6057),
    [anon_sym_BSLASHbigr] = ACTIONS(6057),
    [anon_sym_BSLASHBigr] = ACTIONS(6057),
    [anon_sym_BSLASHbiggr] = ACTIONS(6057),
    [anon_sym_BSLASHBiggr] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [395] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHright] = ACTIONS(5957),
    [anon_sym_BSLASHbigr] = ACTIONS(5957),
    [anon_sym_BSLASHBigr] = ACTIONS(5957),
    [anon_sym_BSLASHbiggr] = ACTIONS(5957),
    [anon_sym_BSLASHBiggr] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [396] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHright] = ACTIONS(5957),
    [anon_sym_BSLASHbigr] = ACTIONS(5957),
    [anon_sym_BSLASHBigr] = ACTIONS(5957),
    [anon_sym_BSLASHbiggr] = ACTIONS(5957),
    [anon_sym_BSLASHBiggr] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [397] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHright] = ACTIONS(6065),
    [anon_sym_BSLASHbigr] = ACTIONS(6065),
    [anon_sym_BSLASHBigr] = ACTIONS(6065),
    [anon_sym_BSLASHbiggr] = ACTIONS(6065),
    [anon_sym_BSLASHBiggr] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [398] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(415),
    [aux_sym__section_repeat5] = STATE(415),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHright] = ACTIONS(6065),
    [anon_sym_BSLASHbigr] = ACTIONS(6065),
    [anon_sym_BSLASHBigr] = ACTIONS(6065),
    [anon_sym_BSLASHbiggr] = ACTIONS(6065),
    [anon_sym_BSLASHBiggr] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [399] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHright] = ACTIONS(6065),
    [anon_sym_BSLASHbigr] = ACTIONS(6065),
    [anon_sym_BSLASHBigr] = ACTIONS(6065),
    [anon_sym_BSLASHbiggr] = ACTIONS(6065),
    [anon_sym_BSLASHBiggr] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [400] = {
    [sym__subparagraph_declaration] = STATE(201),
    [sym_subparagraph] = STATE(373),
    [aux_sym__paragraph_repeat2] = STATE(373),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(199),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(201),
    [anon_sym_BSLASHitem] = ACTIONS(6069),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6071),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHright] = ACTIONS(6069),
    [anon_sym_BSLASHbigr] = ACTIONS(6069),
    [anon_sym_BSLASHBigr] = ACTIONS(6069),
    [anon_sym_BSLASHbiggr] = ACTIONS(6069),
    [anon_sym_BSLASHBiggr] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [401] = {
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(374),
    [aux_sym__paragraph_repeat3] = STATE(374),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHright] = ACTIONS(6069),
    [anon_sym_BSLASHbigr] = ACTIONS(6069),
    [anon_sym_BSLASHBigr] = ACTIONS(6069),
    [anon_sym_BSLASHbiggr] = ACTIONS(6069),
    [anon_sym_BSLASHBiggr] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [402] = {
    [sym__enum_itemdeclaration] = STATE(210),
    [sym_enum_item] = STATE(374),
    [aux_sym__paragraph_repeat3] = STATE(374),
    [sym_command_name] = ACTIONS(6073),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6075),
    [anon_sym_RBRACK] = ACTIONS(6075),
    [anon_sym_COMMA] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_LPAREN] = ACTIONS(6075),
    [anon_sym_RPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHpart] = ACTIONS(6073),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddpart] = ACTIONS(6073),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHchapter] = ACTIONS(6073),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddchap] = ACTIONS(6073),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsection] = ACTIONS(6073),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddsec] = ACTIONS(6073),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHitem] = ACTIONS(203),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(6075),
    [sym_word] = ACTIONS(6073),
    [sym_placeholder] = ACTIONS(6075),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_DASH] = ACTIONS(6075),
    [anon_sym_STAR] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6073),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_BANG] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6073),
    [anon_sym_COLON] = ACTIONS(6073),
    [anon_sym_SQUOTE] = ACTIONS(6073),
    [anon_sym__] = ACTIONS(6075),
    [anon_sym_CARET] = ACTIONS(6075),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6075),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6075),
    [anon_sym_DOLLAR] = ACTIONS(6073),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHbegin] = ACTIONS(6073),
    [anon_sym_BSLASHtitle] = ACTIONS(6073),
    [anon_sym_BSLASHauthor] = ACTIONS(6073),
    [anon_sym_BSLASHusepackage] = ACTIONS(6073),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6073),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6073),
    [anon_sym_BSLASHinclude] = ACTIONS(6073),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6073),
    [anon_sym_BSLASHinput] = ACTIONS(6073),
    [anon_sym_BSLASHsubfile] = ACTIONS(6073),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6073),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6073),
    [anon_sym_BSLASHbibliography] = ACTIONS(6073),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6073),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6073),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6073),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6073),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6073),
    [anon_sym_BSLASHimport] = ACTIONS(6073),
    [anon_sym_BSLASHsubimport] = ACTIONS(6073),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6073),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHcaption] = ACTIONS(6073),
    [anon_sym_BSLASHcite] = ACTIONS(6073),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCite] = ACTIONS(6073),
    [anon_sym_BSLASHnocite] = ACTIONS(6073),
    [anon_sym_BSLASHcitet] = ACTIONS(6073),
    [anon_sym_BSLASHcitep] = ACTIONS(6073),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteA] = ACTIONS(6073),
    [anon_sym_BSLASHciteR] = ACTIONS(6073),
    [anon_sym_BSLASHciteS] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6073),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteyear] = ACTIONS(6073),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitedate] = ACTIONS(6073),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteurl] = ACTIONS(6073),
    [anon_sym_BSLASHfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6073),
    [anon_sym_BSLASHcitealt] = ACTIONS(6073),
    [anon_sym_BSLASHcitealp] = ACTIONS(6073),
    [anon_sym_BSLASHcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHparencite] = ACTIONS(6073),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHParencite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHtextcite] = ACTIONS(6073),
    [anon_sym_BSLASHTextcite] = ACTIONS(6073),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHsupercite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite] = ACTIONS(6073),
    [anon_sym_BSLASHAutocite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHVolcite] = ACTIONS(6073),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHavolcite] = ACTIONS(6073),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHNotecite] = ACTIONS(6073),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHlabel] = ACTIONS(6073),
    [anon_sym_BSLASHref] = ACTIONS(6073),
    [anon_sym_BSLASHeqref] = ACTIONS(6073),
    [anon_sym_BSLASHvref] = ACTIONS(6073),
    [anon_sym_BSLASHVref] = ACTIONS(6073),
    [anon_sym_BSLASHautoref] = ACTIONS(6073),
    [anon_sym_BSLASHpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcref] = ACTIONS(6073),
    [anon_sym_BSLASHCref] = ACTIONS(6073),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnameCref] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHdef] = ACTIONS(6073),
    [anon_sym_BSLASHlet] = ACTIONS(6073),
    [anon_sym_BSLASHleft] = ACTIONS(6073),
    [anon_sym_BSLASHbigl] = ACTIONS(6073),
    [anon_sym_BSLASHBigl] = ACTIONS(6073),
    [anon_sym_BSLASHbiggl] = ACTIONS(6073),
    [anon_sym_BSLASHBiggl] = ACTIONS(6073),
    [anon_sym_BSLASHright] = ACTIONS(6073),
    [anon_sym_BSLASHbigr] = ACTIONS(6073),
    [anon_sym_BSLASHBigr] = ACTIONS(6073),
    [anon_sym_BSLASHbiggr] = ACTIONS(6073),
    [anon_sym_BSLASHBiggr] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6073),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6073),
    [anon_sym_BSLASHgls] = ACTIONS(6073),
    [anon_sym_BSLASHGls] = ACTIONS(6073),
    [anon_sym_BSLASHGLS] = ACTIONS(6073),
    [anon_sym_BSLASHglspl] = ACTIONS(6073),
    [anon_sym_BSLASHGlspl] = ACTIONS(6073),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6073),
    [anon_sym_BSLASHglslink] = ACTIONS(6073),
    [anon_sym_BSLASHglstext] = ACTIONS(6073),
    [anon_sym_BSLASHGlstext] = ACTIONS(6073),
    [anon_sym_BSLASHGLStext] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6073),
    [anon_sym_BSLASHglsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsname] = ACTIONS(6073),
    [anon_sym_BSLASHGlsname] = ACTIONS(6073),
    [anon_sym_BSLASHGLSname] = ACTIONS(6073),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6073),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6073),
    [anon_sym_BSLASHacrshort] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6073),
    [anon_sym_BSLASHACRshort] = ACTIONS(6073),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrlong] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6073),
    [anon_sym_BSLASHACRlong] = ACTIONS(6073),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrfull] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6073),
    [anon_sym_BSLASHACRfull] = ACTIONS(6073),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHacs] = ACTIONS(6073),
    [anon_sym_BSLASHAcs] = ACTIONS(6073),
    [anon_sym_BSLASHacsp] = ACTIONS(6073),
    [anon_sym_BSLASHAcsp] = ACTIONS(6073),
    [anon_sym_BSLASHacl] = ACTIONS(6073),
    [anon_sym_BSLASHAcl] = ACTIONS(6073),
    [anon_sym_BSLASHaclp] = ACTIONS(6073),
    [anon_sym_BSLASHAclp] = ACTIONS(6073),
    [anon_sym_BSLASHacf] = ACTIONS(6073),
    [anon_sym_BSLASHAcf] = ACTIONS(6073),
    [anon_sym_BSLASHacfp] = ACTIONS(6073),
    [anon_sym_BSLASHAcfp] = ACTIONS(6073),
    [anon_sym_BSLASHac] = ACTIONS(6073),
    [anon_sym_BSLASHAc] = ACTIONS(6073),
    [anon_sym_BSLASHacp] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6073),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6073),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6073),
    [anon_sym_BSLASHcolor] = ACTIONS(6073),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6073),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6073),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6073),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6073),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6073),
    [anon_sym_BSLASHtext] = ACTIONS(6073),
    [anon_sym_BSLASHintertext] = ACTIONS(6073),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6073),
    [anon_sym_BSLASHurl] = ACTIONS(6073),
    [anon_sym_BSLASHhref] = ACTIONS(6073),
  },
  [403] = {
    [sym__paragraph_declaration] = STATE(192),
    [sym_paragraph] = STATE(372),
    [aux_sym__paragraph_repeat1] = STATE(372),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(195),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(197),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHright] = ACTIONS(6057),
    [anon_sym_BSLASHbigr] = ACTIONS(6057),
    [anon_sym_BSLASHBigr] = ACTIONS(6057),
    [anon_sym_BSLASHbiggr] = ACTIONS(6057),
    [anon_sym_BSLASHBiggr] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [404] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHright] = ACTIONS(6077),
    [anon_sym_BSLASHbigr] = ACTIONS(6077),
    [anon_sym_BSLASHBigr] = ACTIONS(6077),
    [anon_sym_BSLASHbiggr] = ACTIONS(6077),
    [anon_sym_BSLASHBiggr] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [405] = {
    [sym__section_part] = STATE(469),
    [sym_curly_group] = STATE(445),
    [sym_brack_group] = STATE(2487),
    [sym_command_name] = ACTIONS(6081),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6083),
    [anon_sym_COMMA] = ACTIONS(6083),
    [anon_sym_EQ] = ACTIONS(6083),
    [anon_sym_LPAREN] = ACTIONS(6083),
    [anon_sym_RPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHpart] = ACTIONS(6081),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddpart] = ACTIONS(6081),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHchapter] = ACTIONS(6081),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddchap] = ACTIONS(6081),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsection] = ACTIONS(6081),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddsec] = ACTIONS(6081),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHitem] = ACTIONS(6081),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6081),
    [sym_placeholder] = ACTIONS(6083),
    [anon_sym_PLUS] = ACTIONS(6083),
    [anon_sym_DASH] = ACTIONS(6083),
    [anon_sym_STAR] = ACTIONS(6083),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_BANG] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_SQUOTE] = ACTIONS(6081),
    [anon_sym__] = ACTIONS(6083),
    [anon_sym_CARET] = ACTIONS(6083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6083),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6083),
    [anon_sym_DOLLAR] = ACTIONS(6081),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHbegin] = ACTIONS(6081),
    [anon_sym_BSLASHtitle] = ACTIONS(6081),
    [anon_sym_BSLASHauthor] = ACTIONS(6081),
    [anon_sym_BSLASHusepackage] = ACTIONS(6081),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6081),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6081),
    [anon_sym_BSLASHinclude] = ACTIONS(6081),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6081),
    [anon_sym_BSLASHinput] = ACTIONS(6081),
    [anon_sym_BSLASHsubfile] = ACTIONS(6081),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6081),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6081),
    [anon_sym_BSLASHbibliography] = ACTIONS(6081),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6081),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6081),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6081),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6081),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6081),
    [anon_sym_BSLASHimport] = ACTIONS(6081),
    [anon_sym_BSLASHsubimport] = ACTIONS(6081),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6081),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHcaption] = ACTIONS(6081),
    [anon_sym_BSLASHcite] = ACTIONS(6081),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCite] = ACTIONS(6081),
    [anon_sym_BSLASHnocite] = ACTIONS(6081),
    [anon_sym_BSLASHcitet] = ACTIONS(6081),
    [anon_sym_BSLASHcitep] = ACTIONS(6081),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteA] = ACTIONS(6081),
    [anon_sym_BSLASHciteR] = ACTIONS(6081),
    [anon_sym_BSLASHciteS] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6081),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteyear] = ACTIONS(6081),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitedate] = ACTIONS(6081),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteurl] = ACTIONS(6081),
    [anon_sym_BSLASHfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6081),
    [anon_sym_BSLASHcitealt] = ACTIONS(6081),
    [anon_sym_BSLASHcitealp] = ACTIONS(6081),
    [anon_sym_BSLASHcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHparencite] = ACTIONS(6081),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHParencite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHtextcite] = ACTIONS(6081),
    [anon_sym_BSLASHTextcite] = ACTIONS(6081),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHsupercite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite] = ACTIONS(6081),
    [anon_sym_BSLASHAutocite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHVolcite] = ACTIONS(6081),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHavolcite] = ACTIONS(6081),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHNotecite] = ACTIONS(6081),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHlabel] = ACTIONS(6081),
    [anon_sym_BSLASHref] = ACTIONS(6081),
    [anon_sym_BSLASHeqref] = ACTIONS(6081),
    [anon_sym_BSLASHvref] = ACTIONS(6081),
    [anon_sym_BSLASHVref] = ACTIONS(6081),
    [anon_sym_BSLASHautoref] = ACTIONS(6081),
    [anon_sym_BSLASHpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcref] = ACTIONS(6081),
    [anon_sym_BSLASHCref] = ACTIONS(6081),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnameCref] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHdef] = ACTIONS(6081),
    [anon_sym_BSLASHlet] = ACTIONS(6081),
    [anon_sym_BSLASHleft] = ACTIONS(6081),
    [anon_sym_BSLASHbigl] = ACTIONS(6081),
    [anon_sym_BSLASHBigl] = ACTIONS(6081),
    [anon_sym_BSLASHbiggl] = ACTIONS(6081),
    [anon_sym_BSLASHBiggl] = ACTIONS(6081),
    [anon_sym_BSLASHright] = ACTIONS(6081),
    [anon_sym_BSLASHbigr] = ACTIONS(6081),
    [anon_sym_BSLASHBigr] = ACTIONS(6081),
    [anon_sym_BSLASHbiggr] = ACTIONS(6081),
    [anon_sym_BSLASHBiggr] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6081),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6081),
    [anon_sym_BSLASHgls] = ACTIONS(6081),
    [anon_sym_BSLASHGls] = ACTIONS(6081),
    [anon_sym_BSLASHGLS] = ACTIONS(6081),
    [anon_sym_BSLASHglspl] = ACTIONS(6081),
    [anon_sym_BSLASHGlspl] = ACTIONS(6081),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6081),
    [anon_sym_BSLASHglslink] = ACTIONS(6081),
    [anon_sym_BSLASHglstext] = ACTIONS(6081),
    [anon_sym_BSLASHGlstext] = ACTIONS(6081),
    [anon_sym_BSLASHGLStext] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6081),
    [anon_sym_BSLASHglsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsname] = ACTIONS(6081),
    [anon_sym_BSLASHGlsname] = ACTIONS(6081),
    [anon_sym_BSLASHGLSname] = ACTIONS(6081),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6081),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6081),
    [anon_sym_BSLASHacrshort] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6081),
    [anon_sym_BSLASHACRshort] = ACTIONS(6081),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrlong] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6081),
    [anon_sym_BSLASHACRlong] = ACTIONS(6081),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrfull] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6081),
    [anon_sym_BSLASHACRfull] = ACTIONS(6081),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHacs] = ACTIONS(6081),
    [anon_sym_BSLASHAcs] = ACTIONS(6081),
    [anon_sym_BSLASHacsp] = ACTIONS(6081),
    [anon_sym_BSLASHAcsp] = ACTIONS(6081),
    [anon_sym_BSLASHacl] = ACTIONS(6081),
    [anon_sym_BSLASHAcl] = ACTIONS(6081),
    [anon_sym_BSLASHaclp] = ACTIONS(6081),
    [anon_sym_BSLASHAclp] = ACTIONS(6081),
    [anon_sym_BSLASHacf] = ACTIONS(6081),
    [anon_sym_BSLASHAcf] = ACTIONS(6081),
    [anon_sym_BSLASHacfp] = ACTIONS(6081),
    [anon_sym_BSLASHAcfp] = ACTIONS(6081),
    [anon_sym_BSLASHac] = ACTIONS(6081),
    [anon_sym_BSLASHAc] = ACTIONS(6081),
    [anon_sym_BSLASHacp] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6081),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6081),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6081),
    [anon_sym_BSLASHcolor] = ACTIONS(6081),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6081),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6081),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6081),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6081),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6081),
    [anon_sym_BSLASHtext] = ACTIONS(6081),
    [anon_sym_BSLASHintertext] = ACTIONS(6081),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6081),
    [anon_sym_BSLASHurl] = ACTIONS(6081),
    [anon_sym_BSLASHhref] = ACTIONS(6081),
  },
  [406] = {
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(369),
    [aux_sym__section_repeat2] = STATE(369),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHright] = ACTIONS(6085),
    [anon_sym_BSLASHbigr] = ACTIONS(6085),
    [anon_sym_BSLASHBigr] = ACTIONS(6085),
    [anon_sym_BSLASHbiggr] = ACTIONS(6085),
    [anon_sym_BSLASHBiggr] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [407] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHright] = ACTIONS(6085),
    [anon_sym_BSLASHbigr] = ACTIONS(6085),
    [anon_sym_BSLASHBigr] = ACTIONS(6085),
    [anon_sym_BSLASHbiggr] = ACTIONS(6085),
    [anon_sym_BSLASHBiggr] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [408] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHright] = ACTIONS(6085),
    [anon_sym_BSLASHbigr] = ACTIONS(6085),
    [anon_sym_BSLASHBigr] = ACTIONS(6085),
    [anon_sym_BSLASHbiggr] = ACTIONS(6085),
    [anon_sym_BSLASHBiggr] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [409] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHright] = ACTIONS(6085),
    [anon_sym_BSLASHbigr] = ACTIONS(6085),
    [anon_sym_BSLASHBigr] = ACTIONS(6085),
    [anon_sym_BSLASHbiggr] = ACTIONS(6085),
    [anon_sym_BSLASHBiggr] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [410] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHright] = ACTIONS(6089),
    [anon_sym_BSLASHbigr] = ACTIONS(6089),
    [anon_sym_BSLASHBigr] = ACTIONS(6089),
    [anon_sym_BSLASHbiggr] = ACTIONS(6089),
    [anon_sym_BSLASHBiggr] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [411] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHright] = ACTIONS(6089),
    [anon_sym_BSLASHbigr] = ACTIONS(6089),
    [anon_sym_BSLASHBigr] = ACTIONS(6089),
    [anon_sym_BSLASHbiggr] = ACTIONS(6089),
    [anon_sym_BSLASHBiggr] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [412] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHright] = ACTIONS(6089),
    [anon_sym_BSLASHbigr] = ACTIONS(6089),
    [anon_sym_BSLASHBigr] = ACTIONS(6089),
    [anon_sym_BSLASHbiggr] = ACTIONS(6089),
    [anon_sym_BSLASHBiggr] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [413] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHright] = ACTIONS(6093),
    [anon_sym_BSLASHbigr] = ACTIONS(6093),
    [anon_sym_BSLASHBigr] = ACTIONS(6093),
    [anon_sym_BSLASHbiggr] = ACTIONS(6093),
    [anon_sym_BSLASHBiggr] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [414] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHright] = ACTIONS(6093),
    [anon_sym_BSLASHbigr] = ACTIONS(6093),
    [anon_sym_BSLASHBigr] = ACTIONS(6093),
    [anon_sym_BSLASHbiggr] = ACTIONS(6093),
    [anon_sym_BSLASHBiggr] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [415] = {
    [sym__subsubsection_declaration] = STATE(180),
    [sym_subsubsection] = STATE(371),
    [aux_sym__section_repeat5] = STATE(371),
    [sym_command_name] = ACTIONS(6097),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(6099),
    [anon_sym_RBRACK] = ACTIONS(6099),
    [anon_sym_COMMA] = ACTIONS(6099),
    [anon_sym_EQ] = ACTIONS(6099),
    [anon_sym_LPAREN] = ACTIONS(6099),
    [anon_sym_RPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHpart] = ACTIONS(6097),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddpart] = ACTIONS(6097),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHchapter] = ACTIONS(6097),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddchap] = ACTIONS(6097),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsection] = ACTIONS(6097),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddsec] = ACTIONS(6097),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsection] = ACTIONS(6097),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(191),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(193),
    [anon_sym_BSLASHparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHitem] = ACTIONS(6097),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(6099),
    [sym_word] = ACTIONS(6097),
    [sym_placeholder] = ACTIONS(6099),
    [anon_sym_PLUS] = ACTIONS(6099),
    [anon_sym_DASH] = ACTIONS(6099),
    [anon_sym_STAR] = ACTIONS(6099),
    [anon_sym_SLASH] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(6097),
    [anon_sym_GT] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6097),
    [anon_sym_PIPE] = ACTIONS(6097),
    [anon_sym_COLON] = ACTIONS(6097),
    [anon_sym_SQUOTE] = ACTIONS(6097),
    [anon_sym__] = ACTIONS(6099),
    [anon_sym_CARET] = ACTIONS(6099),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6099),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6099),
    [anon_sym_DOLLAR] = ACTIONS(6097),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHbegin] = ACTIONS(6097),
    [anon_sym_BSLASHtitle] = ACTIONS(6097),
    [anon_sym_BSLASHauthor] = ACTIONS(6097),
    [anon_sym_BSLASHusepackage] = ACTIONS(6097),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6097),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6097),
    [anon_sym_BSLASHinclude] = ACTIONS(6097),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6097),
    [anon_sym_BSLASHinput] = ACTIONS(6097),
    [anon_sym_BSLASHsubfile] = ACTIONS(6097),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6097),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6097),
    [anon_sym_BSLASHbibliography] = ACTIONS(6097),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6097),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6097),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6097),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6097),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6097),
    [anon_sym_BSLASHimport] = ACTIONS(6097),
    [anon_sym_BSLASHsubimport] = ACTIONS(6097),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6097),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHcaption] = ACTIONS(6097),
    [anon_sym_BSLASHcite] = ACTIONS(6097),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCite] = ACTIONS(6097),
    [anon_sym_BSLASHnocite] = ACTIONS(6097),
    [anon_sym_BSLASHcitet] = ACTIONS(6097),
    [anon_sym_BSLASHcitep] = ACTIONS(6097),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteA] = ACTIONS(6097),
    [anon_sym_BSLASHciteR] = ACTIONS(6097),
    [anon_sym_BSLASHciteS] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6097),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteyear] = ACTIONS(6097),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitedate] = ACTIONS(6097),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteurl] = ACTIONS(6097),
    [anon_sym_BSLASHfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6097),
    [anon_sym_BSLASHcitealt] = ACTIONS(6097),
    [anon_sym_BSLASHcitealp] = ACTIONS(6097),
    [anon_sym_BSLASHcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHparencite] = ACTIONS(6097),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHParencite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHtextcite] = ACTIONS(6097),
    [anon_sym_BSLASHTextcite] = ACTIONS(6097),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHsupercite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite] = ACTIONS(6097),
    [anon_sym_BSLASHAutocite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHVolcite] = ACTIONS(6097),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHavolcite] = ACTIONS(6097),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHNotecite] = ACTIONS(6097),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHlabel] = ACTIONS(6097),
    [anon_sym_BSLASHref] = ACTIONS(6097),
    [anon_sym_BSLASHeqref] = ACTIONS(6097),
    [anon_sym_BSLASHvref] = ACTIONS(6097),
    [anon_sym_BSLASHVref] = ACTIONS(6097),
    [anon_sym_BSLASHautoref] = ACTIONS(6097),
    [anon_sym_BSLASHpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcref] = ACTIONS(6097),
    [anon_sym_BSLASHCref] = ACTIONS(6097),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnameCref] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHdef] = ACTIONS(6097),
    [anon_sym_BSLASHlet] = ACTIONS(6097),
    [anon_sym_BSLASHleft] = ACTIONS(6097),
    [anon_sym_BSLASHbigl] = ACTIONS(6097),
    [anon_sym_BSLASHBigl] = ACTIONS(6097),
    [anon_sym_BSLASHbiggl] = ACTIONS(6097),
    [anon_sym_BSLASHBiggl] = ACTIONS(6097),
    [anon_sym_BSLASHright] = ACTIONS(6097),
    [anon_sym_BSLASHbigr] = ACTIONS(6097),
    [anon_sym_BSLASHBigr] = ACTIONS(6097),
    [anon_sym_BSLASHbiggr] = ACTIONS(6097),
    [anon_sym_BSLASHBiggr] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6097),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6097),
    [anon_sym_BSLASHgls] = ACTIONS(6097),
    [anon_sym_BSLASHGls] = ACTIONS(6097),
    [anon_sym_BSLASHGLS] = ACTIONS(6097),
    [anon_sym_BSLASHglspl] = ACTIONS(6097),
    [anon_sym_BSLASHGlspl] = ACTIONS(6097),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6097),
    [anon_sym_BSLASHglslink] = ACTIONS(6097),
    [anon_sym_BSLASHglstext] = ACTIONS(6097),
    [anon_sym_BSLASHGlstext] = ACTIONS(6097),
    [anon_sym_BSLASHGLStext] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6097),
    [anon_sym_BSLASHglsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsname] = ACTIONS(6097),
    [anon_sym_BSLASHGlsname] = ACTIONS(6097),
    [anon_sym_BSLASHGLSname] = ACTIONS(6097),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6097),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6097),
    [anon_sym_BSLASHacrshort] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6097),
    [anon_sym_BSLASHACRshort] = ACTIONS(6097),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrlong] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6097),
    [anon_sym_BSLASHACRlong] = ACTIONS(6097),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrfull] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6097),
    [anon_sym_BSLASHACRfull] = ACTIONS(6097),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHacs] = ACTIONS(6097),
    [anon_sym_BSLASHAcs] = ACTIONS(6097),
    [anon_sym_BSLASHacsp] = ACTIONS(6097),
    [anon_sym_BSLASHAcsp] = ACTIONS(6097),
    [anon_sym_BSLASHacl] = ACTIONS(6097),
    [anon_sym_BSLASHAcl] = ACTIONS(6097),
    [anon_sym_BSLASHaclp] = ACTIONS(6097),
    [anon_sym_BSLASHAclp] = ACTIONS(6097),
    [anon_sym_BSLASHacf] = ACTIONS(6097),
    [anon_sym_BSLASHAcf] = ACTIONS(6097),
    [anon_sym_BSLASHacfp] = ACTIONS(6097),
    [anon_sym_BSLASHAcfp] = ACTIONS(6097),
    [anon_sym_BSLASHac] = ACTIONS(6097),
    [anon_sym_BSLASHAc] = ACTIONS(6097),
    [anon_sym_BSLASHacp] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6097),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6097),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6097),
    [anon_sym_BSLASHcolor] = ACTIONS(6097),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6097),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6097),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6097),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6097),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6097),
    [anon_sym_BSLASHtext] = ACTIONS(6097),
    [anon_sym_BSLASHintertext] = ACTIONS(6097),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6097),
    [anon_sym_BSLASHurl] = ACTIONS(6097),
    [anon_sym_BSLASHhref] = ACTIONS(6097),
  },
  [416] = {
    [sym__subsection_declaration] = STATE(173),
    [sym_subsection] = STATE(348),
    [aux_sym__section_repeat4] = STATE(348),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(187),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(189),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHright] = ACTIONS(6077),
    [anon_sym_BSLASHbigr] = ACTIONS(6077),
    [anon_sym_BSLASHBigr] = ACTIONS(6077),
    [anon_sym_BSLASHbiggr] = ACTIONS(6077),
    [anon_sym_BSLASHBiggr] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [417] = {
    [sym__section_declaration] = STATE(163),
    [sym_section] = STATE(370),
    [aux_sym__section_repeat3] = STATE(370),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(183),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(185),
    [anon_sym_BSLASHaddsec] = ACTIONS(183),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(185),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHright] = ACTIONS(6077),
    [anon_sym_BSLASHbigr] = ACTIONS(6077),
    [anon_sym_BSLASHBigr] = ACTIONS(6077),
    [anon_sym_BSLASHbiggr] = ACTIONS(6077),
    [anon_sym_BSLASHBiggr] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [418] = {
    [sym__chapter_declaration] = STATE(152),
    [sym_chapter] = STATE(369),
    [aux_sym__section_repeat2] = STATE(369),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(179),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(181),
    [anon_sym_BSLASHaddchap] = ACTIONS(179),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(181),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHright] = ACTIONS(6077),
    [anon_sym_BSLASHbigr] = ACTIONS(6077),
    [anon_sym_BSLASHBigr] = ACTIONS(6077),
    [anon_sym_BSLASHbiggr] = ACTIONS(6077),
    [anon_sym_BSLASHBiggr] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [419] = {
    [sym__part_declaration] = STATE(149),
    [sym_part] = STATE(368),
    [aux_sym__section_repeat1] = STATE(368),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(175),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHaddpart] = ACTIONS(175),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(177),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHright] = ACTIONS(6077),
    [anon_sym_BSLASHbigr] = ACTIONS(6077),
    [anon_sym_BSLASHBigr] = ACTIONS(6077),
    [anon_sym_BSLASHbiggr] = ACTIONS(6077),
    [anon_sym_BSLASHBiggr] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [420] = {
    [sym__section_part] = STATE(470),
    [sym_curly_group] = STATE(445),
    [sym_brack_group] = STATE(2487),
    [sym_command_name] = ACTIONS(6101),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6103),
    [anon_sym_COMMA] = ACTIONS(6103),
    [anon_sym_EQ] = ACTIONS(6103),
    [anon_sym_LPAREN] = ACTIONS(6103),
    [anon_sym_RPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHpart] = ACTIONS(6101),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddpart] = ACTIONS(6101),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHchapter] = ACTIONS(6101),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddchap] = ACTIONS(6101),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsection] = ACTIONS(6101),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddsec] = ACTIONS(6101),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHitem] = ACTIONS(6101),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6103),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6101),
    [sym_placeholder] = ACTIONS(6103),
    [anon_sym_PLUS] = ACTIONS(6103),
    [anon_sym_DASH] = ACTIONS(6103),
    [anon_sym_STAR] = ACTIONS(6103),
    [anon_sym_SLASH] = ACTIONS(6103),
    [anon_sym_LT] = ACTIONS(6101),
    [anon_sym_GT] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(6101),
    [anon_sym_PIPE] = ACTIONS(6101),
    [anon_sym_COLON] = ACTIONS(6101),
    [anon_sym_SQUOTE] = ACTIONS(6101),
    [anon_sym__] = ACTIONS(6103),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6103),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6103),
    [anon_sym_DOLLAR] = ACTIONS(6101),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHbegin] = ACTIONS(6101),
    [anon_sym_BSLASHtitle] = ACTIONS(6101),
    [anon_sym_BSLASHauthor] = ACTIONS(6101),
    [anon_sym_BSLASHusepackage] = ACTIONS(6101),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6101),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6101),
    [anon_sym_BSLASHinclude] = ACTIONS(6101),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6101),
    [anon_sym_BSLASHinput] = ACTIONS(6101),
    [anon_sym_BSLASHsubfile] = ACTIONS(6101),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6101),
    [anon_sym_BSLASHbibliography] = ACTIONS(6101),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6101),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6101),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6101),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6101),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6101),
    [anon_sym_BSLASHimport] = ACTIONS(6101),
    [anon_sym_BSLASHsubimport] = ACTIONS(6101),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6101),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHcaption] = ACTIONS(6101),
    [anon_sym_BSLASHcite] = ACTIONS(6101),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCite] = ACTIONS(6101),
    [anon_sym_BSLASHnocite] = ACTIONS(6101),
    [anon_sym_BSLASHcitet] = ACTIONS(6101),
    [anon_sym_BSLASHcitep] = ACTIONS(6101),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteA] = ACTIONS(6101),
    [anon_sym_BSLASHciteR] = ACTIONS(6101),
    [anon_sym_BSLASHciteS] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6101),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteyear] = ACTIONS(6101),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitedate] = ACTIONS(6101),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteurl] = ACTIONS(6101),
    [anon_sym_BSLASHfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6101),
    [anon_sym_BSLASHcitealt] = ACTIONS(6101),
    [anon_sym_BSLASHcitealp] = ACTIONS(6101),
    [anon_sym_BSLASHcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHparencite] = ACTIONS(6101),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHParencite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHtextcite] = ACTIONS(6101),
    [anon_sym_BSLASHTextcite] = ACTIONS(6101),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHsupercite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite] = ACTIONS(6101),
    [anon_sym_BSLASHAutocite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHVolcite] = ACTIONS(6101),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHavolcite] = ACTIONS(6101),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHNotecite] = ACTIONS(6101),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHlabel] = ACTIONS(6101),
    [anon_sym_BSLASHref] = ACTIONS(6101),
    [anon_sym_BSLASHeqref] = ACTIONS(6101),
    [anon_sym_BSLASHvref] = ACTIONS(6101),
    [anon_sym_BSLASHVref] = ACTIONS(6101),
    [anon_sym_BSLASHautoref] = ACTIONS(6101),
    [anon_sym_BSLASHpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcref] = ACTIONS(6101),
    [anon_sym_BSLASHCref] = ACTIONS(6101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnameCref] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHdef] = ACTIONS(6101),
    [anon_sym_BSLASHlet] = ACTIONS(6101),
    [anon_sym_BSLASHleft] = ACTIONS(6101),
    [anon_sym_BSLASHbigl] = ACTIONS(6101),
    [anon_sym_BSLASHBigl] = ACTIONS(6101),
    [anon_sym_BSLASHbiggl] = ACTIONS(6101),
    [anon_sym_BSLASHBiggl] = ACTIONS(6101),
    [anon_sym_BSLASHright] = ACTIONS(6101),
    [anon_sym_BSLASHbigr] = ACTIONS(6101),
    [anon_sym_BSLASHBigr] = ACTIONS(6101),
    [anon_sym_BSLASHbiggr] = ACTIONS(6101),
    [anon_sym_BSLASHBiggr] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6101),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6101),
    [anon_sym_BSLASHgls] = ACTIONS(6101),
    [anon_sym_BSLASHGls] = ACTIONS(6101),
    [anon_sym_BSLASHGLS] = ACTIONS(6101),
    [anon_sym_BSLASHglspl] = ACTIONS(6101),
    [anon_sym_BSLASHGlspl] = ACTIONS(6101),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6101),
    [anon_sym_BSLASHglslink] = ACTIONS(6101),
    [anon_sym_BSLASHglstext] = ACTIONS(6101),
    [anon_sym_BSLASHGlstext] = ACTIONS(6101),
    [anon_sym_BSLASHGLStext] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6101),
    [anon_sym_BSLASHglsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsname] = ACTIONS(6101),
    [anon_sym_BSLASHGlsname] = ACTIONS(6101),
    [anon_sym_BSLASHGLSname] = ACTIONS(6101),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6101),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6101),
    [anon_sym_BSLASHacrshort] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6101),
    [anon_sym_BSLASHACRshort] = ACTIONS(6101),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrlong] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6101),
    [anon_sym_BSLASHACRlong] = ACTIONS(6101),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrfull] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6101),
    [anon_sym_BSLASHACRfull] = ACTIONS(6101),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHacs] = ACTIONS(6101),
    [anon_sym_BSLASHAcs] = ACTIONS(6101),
    [anon_sym_BSLASHacsp] = ACTIONS(6101),
    [anon_sym_BSLASHAcsp] = ACTIONS(6101),
    [anon_sym_BSLASHacl] = ACTIONS(6101),
    [anon_sym_BSLASHAcl] = ACTIONS(6101),
    [anon_sym_BSLASHaclp] = ACTIONS(6101),
    [anon_sym_BSLASHAclp] = ACTIONS(6101),
    [anon_sym_BSLASHacf] = ACTIONS(6101),
    [anon_sym_BSLASHAcf] = ACTIONS(6101),
    [anon_sym_BSLASHacfp] = ACTIONS(6101),
    [anon_sym_BSLASHAcfp] = ACTIONS(6101),
    [anon_sym_BSLASHac] = ACTIONS(6101),
    [anon_sym_BSLASHAc] = ACTIONS(6101),
    [anon_sym_BSLASHacp] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6101),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6101),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6101),
    [anon_sym_BSLASHcolor] = ACTIONS(6101),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6101),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6101),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6101),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6101),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6101),
    [anon_sym_BSLASHtext] = ACTIONS(6101),
    [anon_sym_BSLASHintertext] = ACTIONS(6101),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6101),
    [anon_sym_BSLASHurl] = ACTIONS(6101),
    [anon_sym_BSLASHhref] = ACTIONS(6101),
  },
  [421] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(711),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(713),
    [aux_sym__section_repeat4] = STATE(711),
    [aux_sym__section_repeat5] = STATE(713),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [422] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(751),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(749),
    [aux_sym__section_repeat4] = STATE(751),
    [aux_sym__section_repeat5] = STATE(749),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHend] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [423] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(862),
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(658),
    [aux_sym__section_repeat4] = STATE(862),
    [aux_sym__section_repeat5] = STATE(658),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [424] = {
    [sym_curly_group] = STATE(435),
    [sym_brack_group_text] = STATE(2983),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_LPAREN] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHpart] = ACTIONS(6105),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddpart] = ACTIONS(6105),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHchapter] = ACTIONS(6105),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddchap] = ACTIONS(6105),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsection] = ACTIONS(6105),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddsec] = ACTIONS(6105),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHitem] = ACTIONS(6105),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6109),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(6105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHbegin] = ACTIONS(6105),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHleft] = ACTIONS(6105),
    [anon_sym_BSLASHbigl] = ACTIONS(6105),
    [anon_sym_BSLASHBigl] = ACTIONS(6105),
    [anon_sym_BSLASHbiggl] = ACTIONS(6105),
    [anon_sym_BSLASHBiggl] = ACTIONS(6105),
    [anon_sym_BSLASHright] = ACTIONS(6105),
    [anon_sym_BSLASHbigr] = ACTIONS(6105),
    [anon_sym_BSLASHBigr] = ACTIONS(6105),
    [anon_sym_BSLASHbiggr] = ACTIONS(6105),
    [anon_sym_BSLASHBiggr] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHtext] = ACTIONS(6105),
    [anon_sym_BSLASHintertext] = ACTIONS(6105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [425] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(706),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(707),
    [aux_sym__section_repeat4] = STATE(706),
    [aux_sym__section_repeat5] = STATE(707),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [426] = {
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(6113),
    [anon_sym_LBRACK] = ACTIONS(6115),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHpart] = ACTIONS(6111),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddpart] = ACTIONS(6111),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHchapter] = ACTIONS(6111),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddchap] = ACTIONS(6111),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsection] = ACTIONS(6111),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddsec] = ACTIONS(6111),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHitem] = ACTIONS(6111),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6115),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6111),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHbegin] = ACTIONS(6111),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHleft] = ACTIONS(6111),
    [anon_sym_BSLASHbigl] = ACTIONS(6111),
    [anon_sym_BSLASHBigl] = ACTIONS(6111),
    [anon_sym_BSLASHbiggl] = ACTIONS(6111),
    [anon_sym_BSLASHBiggl] = ACTIONS(6111),
    [anon_sym_BSLASHright] = ACTIONS(6111),
    [anon_sym_BSLASHbigr] = ACTIONS(6111),
    [anon_sym_BSLASHBigr] = ACTIONS(6111),
    [anon_sym_BSLASHbiggr] = ACTIONS(6111),
    [anon_sym_BSLASHBiggr] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHtext] = ACTIONS(6111),
    [anon_sym_BSLASHintertext] = ACTIONS(6111),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(6117),
  },
  [427] = {
    [sym_curly_group] = STATE(553),
    [aux_sym_generic_command_repeat1] = STATE(430),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6121),
    [anon_sym_RBRACK] = ACTIONS(6121),
    [anon_sym_COMMA] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHpart] = ACTIONS(6119),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddpart] = ACTIONS(6119),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHchapter] = ACTIONS(6119),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddchap] = ACTIONS(6119),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsection] = ACTIONS(6119),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddsec] = ACTIONS(6119),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHitem] = ACTIONS(6119),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6121),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(6119),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHbegin] = ACTIONS(6119),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHleft] = ACTIONS(6119),
    [anon_sym_BSLASHbigl] = ACTIONS(6119),
    [anon_sym_BSLASHBigl] = ACTIONS(6119),
    [anon_sym_BSLASHbiggl] = ACTIONS(6119),
    [anon_sym_BSLASHBiggl] = ACTIONS(6119),
    [anon_sym_BSLASHright] = ACTIONS(6119),
    [anon_sym_BSLASHbigr] = ACTIONS(6119),
    [anon_sym_BSLASHBigr] = ACTIONS(6119),
    [anon_sym_BSLASHbiggr] = ACTIONS(6119),
    [anon_sym_BSLASHBiggr] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHtext] = ACTIONS(6119),
    [anon_sym_BSLASHintertext] = ACTIONS(6119),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [428] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(684),
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(685),
    [aux_sym__section_repeat4] = STATE(684),
    [aux_sym__section_repeat5] = STATE(685),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [429] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(695),
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(696),
    [aux_sym__section_repeat4] = STATE(695),
    [aux_sym__section_repeat5] = STATE(696),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHend] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [430] = {
    [sym_curly_group] = STATE(553),
    [aux_sym_generic_command_repeat1] = STATE(432),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6125),
    [anon_sym_RBRACK] = ACTIONS(6125),
    [anon_sym_COMMA] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_LPAREN] = ACTIONS(6125),
    [anon_sym_RPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHpart] = ACTIONS(6123),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddpart] = ACTIONS(6123),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHchapter] = ACTIONS(6123),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddchap] = ACTIONS(6123),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsection] = ACTIONS(6123),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddsec] = ACTIONS(6123),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHitem] = ACTIONS(6123),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6125),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6125),
    [anon_sym_DOLLAR] = ACTIONS(6123),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHbegin] = ACTIONS(6123),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHleft] = ACTIONS(6123),
    [anon_sym_BSLASHbigl] = ACTIONS(6123),
    [anon_sym_BSLASHBigl] = ACTIONS(6123),
    [anon_sym_BSLASHbiggl] = ACTIONS(6123),
    [anon_sym_BSLASHBiggl] = ACTIONS(6123),
    [anon_sym_BSLASHright] = ACTIONS(6123),
    [anon_sym_BSLASHbigr] = ACTIONS(6123),
    [anon_sym_BSLASHBigr] = ACTIONS(6123),
    [anon_sym_BSLASHbiggr] = ACTIONS(6123),
    [anon_sym_BSLASHBiggr] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHtext] = ACTIONS(6123),
    [anon_sym_BSLASHintertext] = ACTIONS(6123),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [431] = {
    [sym_curly_group] = STATE(439),
    [sym_brack_group_text] = STATE(2971),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6129),
    [anon_sym_COMMA] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_LPAREN] = ACTIONS(6129),
    [anon_sym_RPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHpart] = ACTIONS(6127),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddpart] = ACTIONS(6127),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHchapter] = ACTIONS(6127),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddchap] = ACTIONS(6127),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsection] = ACTIONS(6127),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddsec] = ACTIONS(6127),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHitem] = ACTIONS(6127),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6129),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHbegin] = ACTIONS(6127),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHleft] = ACTIONS(6127),
    [anon_sym_BSLASHbigl] = ACTIONS(6127),
    [anon_sym_BSLASHBigl] = ACTIONS(6127),
    [anon_sym_BSLASHbiggl] = ACTIONS(6127),
    [anon_sym_BSLASHBiggl] = ACTIONS(6127),
    [anon_sym_BSLASHright] = ACTIONS(6127),
    [anon_sym_BSLASHbigr] = ACTIONS(6127),
    [anon_sym_BSLASHBigr] = ACTIONS(6127),
    [anon_sym_BSLASHbiggr] = ACTIONS(6127),
    [anon_sym_BSLASHBiggr] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHtext] = ACTIONS(6127),
    [anon_sym_BSLASHintertext] = ACTIONS(6127),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [432] = {
    [sym_curly_group] = STATE(553),
    [aux_sym_generic_command_repeat1] = STATE(432),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(6133),
    [anon_sym_COMMA] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHpart] = ACTIONS(6131),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddpart] = ACTIONS(6131),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHchapter] = ACTIONS(6131),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddchap] = ACTIONS(6131),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsection] = ACTIONS(6131),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddsec] = ACTIONS(6131),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHitem] = ACTIONS(6131),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(6135),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6133),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6133),
    [anon_sym_DOLLAR] = ACTIONS(6131),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHbegin] = ACTIONS(6131),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHleft] = ACTIONS(6131),
    [anon_sym_BSLASHbigl] = ACTIONS(6131),
    [anon_sym_BSLASHBigl] = ACTIONS(6131),
    [anon_sym_BSLASHbiggl] = ACTIONS(6131),
    [anon_sym_BSLASHBiggl] = ACTIONS(6131),
    [anon_sym_BSLASHright] = ACTIONS(6131),
    [anon_sym_BSLASHbigr] = ACTIONS(6131),
    [anon_sym_BSLASHBigr] = ACTIONS(6131),
    [anon_sym_BSLASHbiggr] = ACTIONS(6131),
    [anon_sym_BSLASHBiggr] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHtext] = ACTIONS(6131),
    [anon_sym_BSLASHintertext] = ACTIONS(6131),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [433] = {
    [sym_brack_group_text] = STATE(471),
    [sym_command_name] = ACTIONS(6138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(6140),
    [anon_sym_RBRACK] = ACTIONS(6142),
    [anon_sym_COMMA] = ACTIONS(6142),
    [anon_sym_EQ] = ACTIONS(6142),
    [anon_sym_LPAREN] = ACTIONS(6142),
    [anon_sym_RPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHpart] = ACTIONS(6138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddpart] = ACTIONS(6138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHchapter] = ACTIONS(6138),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddchap] = ACTIONS(6138),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsection] = ACTIONS(6138),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddsec] = ACTIONS(6138),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHitem] = ACTIONS(6138),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(6142),
    [sym_word] = ACTIONS(6138),
    [sym_placeholder] = ACTIONS(6142),
    [anon_sym_PLUS] = ACTIONS(6142),
    [anon_sym_DASH] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6142),
    [anon_sym_LT] = ACTIONS(6138),
    [anon_sym_GT] = ACTIONS(6138),
    [anon_sym_BANG] = ACTIONS(6138),
    [anon_sym_PIPE] = ACTIONS(6138),
    [anon_sym_COLON] = ACTIONS(6138),
    [anon_sym_SQUOTE] = ACTIONS(6138),
    [anon_sym__] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6142),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6142),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6142),
    [anon_sym_DOLLAR] = ACTIONS(6138),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHbegin] = ACTIONS(6138),
    [anon_sym_BSLASHtitle] = ACTIONS(6138),
    [anon_sym_BSLASHauthor] = ACTIONS(6138),
    [anon_sym_BSLASHusepackage] = ACTIONS(6138),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6138),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6138),
    [anon_sym_BSLASHinclude] = ACTIONS(6138),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6138),
    [anon_sym_BSLASHinput] = ACTIONS(6138),
    [anon_sym_BSLASHsubfile] = ACTIONS(6138),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6138),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6138),
    [anon_sym_BSLASHbibliography] = ACTIONS(6138),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6138),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6138),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6138),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6138),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6138),
    [anon_sym_BSLASHimport] = ACTIONS(6138),
    [anon_sym_BSLASHsubimport] = ACTIONS(6138),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6138),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHcaption] = ACTIONS(6138),
    [anon_sym_BSLASHcite] = ACTIONS(6138),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCite] = ACTIONS(6138),
    [anon_sym_BSLASHnocite] = ACTIONS(6138),
    [anon_sym_BSLASHcitet] = ACTIONS(6138),
    [anon_sym_BSLASHcitep] = ACTIONS(6138),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteA] = ACTIONS(6138),
    [anon_sym_BSLASHciteR] = ACTIONS(6138),
    [anon_sym_BSLASHciteS] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6138),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteyear] = ACTIONS(6138),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitedate] = ACTIONS(6138),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteurl] = ACTIONS(6138),
    [anon_sym_BSLASHfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6138),
    [anon_sym_BSLASHcitealt] = ACTIONS(6138),
    [anon_sym_BSLASHcitealp] = ACTIONS(6138),
    [anon_sym_BSLASHcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHparencite] = ACTIONS(6138),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHParencite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHtextcite] = ACTIONS(6138),
    [anon_sym_BSLASHTextcite] = ACTIONS(6138),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHsupercite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite] = ACTIONS(6138),
    [anon_sym_BSLASHAutocite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHVolcite] = ACTIONS(6138),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHavolcite] = ACTIONS(6138),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHNotecite] = ACTIONS(6138),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHlabel] = ACTIONS(6138),
    [anon_sym_BSLASHref] = ACTIONS(6138),
    [anon_sym_BSLASHeqref] = ACTIONS(6138),
    [anon_sym_BSLASHvref] = ACTIONS(6138),
    [anon_sym_BSLASHVref] = ACTIONS(6138),
    [anon_sym_BSLASHautoref] = ACTIONS(6138),
    [anon_sym_BSLASHpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcref] = ACTIONS(6138),
    [anon_sym_BSLASHCref] = ACTIONS(6138),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnameCref] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHdef] = ACTIONS(6138),
    [anon_sym_BSLASHlet] = ACTIONS(6138),
    [anon_sym_BSLASHleft] = ACTIONS(6138),
    [anon_sym_BSLASHbigl] = ACTIONS(6138),
    [anon_sym_BSLASHBigl] = ACTIONS(6138),
    [anon_sym_BSLASHbiggl] = ACTIONS(6138),
    [anon_sym_BSLASHBiggl] = ACTIONS(6138),
    [anon_sym_BSLASHright] = ACTIONS(6138),
    [anon_sym_BSLASHbigr] = ACTIONS(6138),
    [anon_sym_BSLASHBigr] = ACTIONS(6138),
    [anon_sym_BSLASHbiggr] = ACTIONS(6138),
    [anon_sym_BSLASHBiggr] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6138),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6138),
    [anon_sym_BSLASHgls] = ACTIONS(6138),
    [anon_sym_BSLASHGls] = ACTIONS(6138),
    [anon_sym_BSLASHGLS] = ACTIONS(6138),
    [anon_sym_BSLASHglspl] = ACTIONS(6138),
    [anon_sym_BSLASHGlspl] = ACTIONS(6138),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6138),
    [anon_sym_BSLASHglslink] = ACTIONS(6138),
    [anon_sym_BSLASHglstext] = ACTIONS(6138),
    [anon_sym_BSLASHGlstext] = ACTIONS(6138),
    [anon_sym_BSLASHGLStext] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6138),
    [anon_sym_BSLASHglsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsname] = ACTIONS(6138),
    [anon_sym_BSLASHGlsname] = ACTIONS(6138),
    [anon_sym_BSLASHGLSname] = ACTIONS(6138),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6138),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6138),
    [anon_sym_BSLASHacrshort] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6138),
    [anon_sym_BSLASHACRshort] = ACTIONS(6138),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrlong] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6138),
    [anon_sym_BSLASHACRlong] = ACTIONS(6138),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrfull] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6138),
    [anon_sym_BSLASHACRfull] = ACTIONS(6138),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHacs] = ACTIONS(6138),
    [anon_sym_BSLASHAcs] = ACTIONS(6138),
    [anon_sym_BSLASHacsp] = ACTIONS(6138),
    [anon_sym_BSLASHAcsp] = ACTIONS(6138),
    [anon_sym_BSLASHacl] = ACTIONS(6138),
    [anon_sym_BSLASHAcl] = ACTIONS(6138),
    [anon_sym_BSLASHaclp] = ACTIONS(6138),
    [anon_sym_BSLASHAclp] = ACTIONS(6138),
    [anon_sym_BSLASHacf] = ACTIONS(6138),
    [anon_sym_BSLASHAcf] = ACTIONS(6138),
    [anon_sym_BSLASHacfp] = ACTIONS(6138),
    [anon_sym_BSLASHAcfp] = ACTIONS(6138),
    [anon_sym_BSLASHac] = ACTIONS(6138),
    [anon_sym_BSLASHAc] = ACTIONS(6138),
    [anon_sym_BSLASHacp] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6138),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6138),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6138),
    [anon_sym_BSLASHcolor] = ACTIONS(6138),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6138),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6138),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6138),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6138),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6138),
    [anon_sym_BSLASHtext] = ACTIONS(6138),
    [anon_sym_BSLASHintertext] = ACTIONS(6138),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6138),
    [anon_sym_BSLASHurl] = ACTIONS(6138),
    [anon_sym_BSLASHhref] = ACTIONS(6138),
  },
  [434] = {
    [sym_curly_group] = STATE(565),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6146),
    [anon_sym_LPAREN] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHpart] = ACTIONS(6144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddpart] = ACTIONS(6144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHchapter] = ACTIONS(6144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddchap] = ACTIONS(6144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsection] = ACTIONS(6144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddsec] = ACTIONS(6144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHitem] = ACTIONS(6144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6146),
    [anon_sym_DOLLAR] = ACTIONS(6144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHbegin] = ACTIONS(6144),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHleft] = ACTIONS(6144),
    [anon_sym_BSLASHbigl] = ACTIONS(6144),
    [anon_sym_BSLASHBigl] = ACTIONS(6144),
    [anon_sym_BSLASHbiggl] = ACTIONS(6144),
    [anon_sym_BSLASHBiggl] = ACTIONS(6144),
    [anon_sym_BSLASHright] = ACTIONS(6144),
    [anon_sym_BSLASHbigr] = ACTIONS(6144),
    [anon_sym_BSLASHBigr] = ACTIONS(6144),
    [anon_sym_BSLASHbiggr] = ACTIONS(6144),
    [anon_sym_BSLASHBiggr] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHtext] = ACTIONS(6144),
    [anon_sym_BSLASHintertext] = ACTIONS(6144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [435] = {
    [sym_brack_group_text] = STATE(530),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(6140),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHpart] = ACTIONS(6148),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddpart] = ACTIONS(6148),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHchapter] = ACTIONS(6148),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddchap] = ACTIONS(6148),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsection] = ACTIONS(6148),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddsec] = ACTIONS(6148),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHitem] = ACTIONS(6148),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6150),
    [anon_sym_LBRACE] = ACTIONS(6150),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6150),
    [anon_sym_DOLLAR] = ACTIONS(6148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHbegin] = ACTIONS(6148),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHleft] = ACTIONS(6148),
    [anon_sym_BSLASHbigl] = ACTIONS(6148),
    [anon_sym_BSLASHBigl] = ACTIONS(6148),
    [anon_sym_BSLASHbiggl] = ACTIONS(6148),
    [anon_sym_BSLASHBiggl] = ACTIONS(6148),
    [anon_sym_BSLASHright] = ACTIONS(6148),
    [anon_sym_BSLASHbigr] = ACTIONS(6148),
    [anon_sym_BSLASHBigr] = ACTIONS(6148),
    [anon_sym_BSLASHbiggr] = ACTIONS(6148),
    [anon_sym_BSLASHBiggr] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHtext] = ACTIONS(6148),
    [anon_sym_BSLASHintertext] = ACTIONS(6148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [436] = {
    [sym_curly_group] = STATE(512),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHpart] = ACTIONS(6152),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddpart] = ACTIONS(6152),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHchapter] = ACTIONS(6152),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddchap] = ACTIONS(6152),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsection] = ACTIONS(6152),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddsec] = ACTIONS(6152),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHitem] = ACTIONS(6152),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6154),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHbegin] = ACTIONS(6152),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHleft] = ACTIONS(6152),
    [anon_sym_BSLASHbigl] = ACTIONS(6152),
    [anon_sym_BSLASHBigl] = ACTIONS(6152),
    [anon_sym_BSLASHbiggl] = ACTIONS(6152),
    [anon_sym_BSLASHBiggl] = ACTIONS(6152),
    [anon_sym_BSLASHright] = ACTIONS(6152),
    [anon_sym_BSLASHbigr] = ACTIONS(6152),
    [anon_sym_BSLASHBigr] = ACTIONS(6152),
    [anon_sym_BSLASHbiggr] = ACTIONS(6152),
    [anon_sym_BSLASHBiggr] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHtext] = ACTIONS(6152),
    [anon_sym_BSLASHintertext] = ACTIONS(6152),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [437] = {
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(6158),
    [anon_sym_LBRACK] = ACTIONS(6160),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHpart] = ACTIONS(6156),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddpart] = ACTIONS(6156),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHchapter] = ACTIONS(6156),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddchap] = ACTIONS(6156),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsection] = ACTIONS(6156),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddsec] = ACTIONS(6156),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHitem] = ACTIONS(6156),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6160),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(6156),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHbegin] = ACTIONS(6156),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHleft] = ACTIONS(6156),
    [anon_sym_BSLASHbigl] = ACTIONS(6156),
    [anon_sym_BSLASHBigl] = ACTIONS(6156),
    [anon_sym_BSLASHbiggl] = ACTIONS(6156),
    [anon_sym_BSLASHBiggl] = ACTIONS(6156),
    [anon_sym_BSLASHright] = ACTIONS(6156),
    [anon_sym_BSLASHbigr] = ACTIONS(6156),
    [anon_sym_BSLASHBigr] = ACTIONS(6156),
    [anon_sym_BSLASHbiggr] = ACTIONS(6156),
    [anon_sym_BSLASHBiggr] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHtext] = ACTIONS(6156),
    [anon_sym_BSLASHintertext] = ACTIONS(6156),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [438] = {
    [sym_curly_group] = STATE(448),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(6164),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHpart] = ACTIONS(6162),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddpart] = ACTIONS(6162),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHchapter] = ACTIONS(6162),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddchap] = ACTIONS(6162),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsection] = ACTIONS(6162),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddsec] = ACTIONS(6162),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHitem] = ACTIONS(6162),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(207),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6164),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6164),
    [anon_sym_DOLLAR] = ACTIONS(6162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHbegin] = ACTIONS(6162),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHleft] = ACTIONS(6162),
    [anon_sym_BSLASHbigl] = ACTIONS(6162),
    [anon_sym_BSLASHBigl] = ACTIONS(6162),
    [anon_sym_BSLASHbiggl] = ACTIONS(6162),
    [anon_sym_BSLASHBiggl] = ACTIONS(6162),
    [anon_sym_BSLASHright] = ACTIONS(6162),
    [anon_sym_BSLASHbigr] = ACTIONS(6162),
    [anon_sym_BSLASHBigr] = ACTIONS(6162),
    [anon_sym_BSLASHbiggr] = ACTIONS(6162),
    [anon_sym_BSLASHBiggr] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHtext] = ACTIONS(6162),
    [anon_sym_BSLASHintertext] = ACTIONS(6162),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [439] = {
    [sym_brack_group_text] = STATE(578),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(6140),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHpart] = ACTIONS(6166),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddpart] = ACTIONS(6166),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHchapter] = ACTIONS(6166),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddchap] = ACTIONS(6166),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsection] = ACTIONS(6166),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddsec] = ACTIONS(6166),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHitem] = ACTIONS(6166),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6168),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6166),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHbegin] = ACTIONS(6166),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHleft] = ACTIONS(6166),
    [anon_sym_BSLASHbigl] = ACTIONS(6166),
    [anon_sym_BSLASHBigl] = ACTIONS(6166),
    [anon_sym_BSLASHbiggl] = ACTIONS(6166),
    [anon_sym_BSLASHBiggl] = ACTIONS(6166),
    [anon_sym_BSLASHright] = ACTIONS(6166),
    [anon_sym_BSLASHbigr] = ACTIONS(6166),
    [anon_sym_BSLASHBigr] = ACTIONS(6166),
    [anon_sym_BSLASHbiggr] = ACTIONS(6166),
    [anon_sym_BSLASHBiggr] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHtext] = ACTIONS(6166),
    [anon_sym_BSLASHintertext] = ACTIONS(6166),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [440] = {
    [sym_command_name] = ACTIONS(6170),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6172),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6172),
    [anon_sym_LPAREN] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHpart] = ACTIONS(6170),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddpart] = ACTIONS(6170),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHchapter] = ACTIONS(6170),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddchap] = ACTIONS(6170),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsection] = ACTIONS(6170),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddsec] = ACTIONS(6170),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHitem] = ACTIONS(6170),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [sym_word] = ACTIONS(6170),
    [sym_placeholder] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_BANG] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_SQUOTE] = ACTIONS(6170),
    [anon_sym__] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6172),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6172),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHbegin] = ACTIONS(6170),
    [anon_sym_BSLASHtitle] = ACTIONS(6170),
    [anon_sym_BSLASHauthor] = ACTIONS(6170),
    [anon_sym_BSLASHusepackage] = ACTIONS(6170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6170),
    [anon_sym_BSLASHinclude] = ACTIONS(6170),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6170),
    [anon_sym_BSLASHinput] = ACTIONS(6170),
    [anon_sym_BSLASHsubfile] = ACTIONS(6170),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6170),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6170),
    [anon_sym_BSLASHbibliography] = ACTIONS(6170),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6170),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6170),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6170),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6170),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6170),
    [anon_sym_BSLASHimport] = ACTIONS(6170),
    [anon_sym_BSLASHsubimport] = ACTIONS(6170),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6170),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHcaption] = ACTIONS(6170),
    [anon_sym_BSLASHcite] = ACTIONS(6170),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCite] = ACTIONS(6170),
    [anon_sym_BSLASHnocite] = ACTIONS(6170),
    [anon_sym_BSLASHcitet] = ACTIONS(6170),
    [anon_sym_BSLASHcitep] = ACTIONS(6170),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteA] = ACTIONS(6170),
    [anon_sym_BSLASHciteR] = ACTIONS(6170),
    [anon_sym_BSLASHciteS] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6170),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteyear] = ACTIONS(6170),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitedate] = ACTIONS(6170),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteurl] = ACTIONS(6170),
    [anon_sym_BSLASHfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6170),
    [anon_sym_BSLASHcitealt] = ACTIONS(6170),
    [anon_sym_BSLASHcitealp] = ACTIONS(6170),
    [anon_sym_BSLASHcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHparencite] = ACTIONS(6170),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHParencite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHtextcite] = ACTIONS(6170),
    [anon_sym_BSLASHTextcite] = ACTIONS(6170),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHsupercite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite] = ACTIONS(6170),
    [anon_sym_BSLASHAutocite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHVolcite] = ACTIONS(6170),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHavolcite] = ACTIONS(6170),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHNotecite] = ACTIONS(6170),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHlabel] = ACTIONS(6170),
    [anon_sym_BSLASHref] = ACTIONS(6170),
    [anon_sym_BSLASHeqref] = ACTIONS(6170),
    [anon_sym_BSLASHvref] = ACTIONS(6170),
    [anon_sym_BSLASHVref] = ACTIONS(6170),
    [anon_sym_BSLASHautoref] = ACTIONS(6170),
    [anon_sym_BSLASHpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcref] = ACTIONS(6170),
    [anon_sym_BSLASHCref] = ACTIONS(6170),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnameCref] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHdef] = ACTIONS(6170),
    [anon_sym_BSLASHlet] = ACTIONS(6170),
    [anon_sym_BSLASHleft] = ACTIONS(6170),
    [anon_sym_BSLASHbigl] = ACTIONS(6170),
    [anon_sym_BSLASHBigl] = ACTIONS(6170),
    [anon_sym_BSLASHbiggl] = ACTIONS(6170),
    [anon_sym_BSLASHBiggl] = ACTIONS(6170),
    [anon_sym_BSLASHright] = ACTIONS(6170),
    [anon_sym_BSLASHbigr] = ACTIONS(6170),
    [anon_sym_BSLASHBigr] = ACTIONS(6170),
    [anon_sym_BSLASHbiggr] = ACTIONS(6170),
    [anon_sym_BSLASHBiggr] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6170),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6170),
    [anon_sym_BSLASHgls] = ACTIONS(6170),
    [anon_sym_BSLASHGls] = ACTIONS(6170),
    [anon_sym_BSLASHGLS] = ACTIONS(6170),
    [anon_sym_BSLASHglspl] = ACTIONS(6170),
    [anon_sym_BSLASHGlspl] = ACTIONS(6170),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6170),
    [anon_sym_BSLASHglslink] = ACTIONS(6170),
    [anon_sym_BSLASHglstext] = ACTIONS(6170),
    [anon_sym_BSLASHGlstext] = ACTIONS(6170),
    [anon_sym_BSLASHGLStext] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6170),
    [anon_sym_BSLASHglsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsname] = ACTIONS(6170),
    [anon_sym_BSLASHGlsname] = ACTIONS(6170),
    [anon_sym_BSLASHGLSname] = ACTIONS(6170),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6170),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6170),
    [anon_sym_BSLASHacrshort] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6170),
    [anon_sym_BSLASHACRshort] = ACTIONS(6170),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrlong] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6170),
    [anon_sym_BSLASHACRlong] = ACTIONS(6170),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrfull] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6170),
    [anon_sym_BSLASHACRfull] = ACTIONS(6170),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHacs] = ACTIONS(6170),
    [anon_sym_BSLASHAcs] = ACTIONS(6170),
    [anon_sym_BSLASHacsp] = ACTIONS(6170),
    [anon_sym_BSLASHAcsp] = ACTIONS(6170),
    [anon_sym_BSLASHacl] = ACTIONS(6170),
    [anon_sym_BSLASHAcl] = ACTIONS(6170),
    [anon_sym_BSLASHaclp] = ACTIONS(6170),
    [anon_sym_BSLASHAclp] = ACTIONS(6170),
    [anon_sym_BSLASHacf] = ACTIONS(6170),
    [anon_sym_BSLASHAcf] = ACTIONS(6170),
    [anon_sym_BSLASHacfp] = ACTIONS(6170),
    [anon_sym_BSLASHAcfp] = ACTIONS(6170),
    [anon_sym_BSLASHac] = ACTIONS(6170),
    [anon_sym_BSLASHAc] = ACTIONS(6170),
    [anon_sym_BSLASHacp] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6170),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6170),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6170),
    [anon_sym_BSLASHcolor] = ACTIONS(6170),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6170),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6170),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6170),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6170),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6170),
    [anon_sym_BSLASHtext] = ACTIONS(6170),
    [anon_sym_BSLASHintertext] = ACTIONS(6170),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6170),
    [anon_sym_BSLASHurl] = ACTIONS(6170),
    [anon_sym_BSLASHhref] = ACTIONS(6170),
  },
  [441] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(6087),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [anon_sym_RBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [442] = {
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_LPAREN] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHpart] = ACTIONS(6174),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddpart] = ACTIONS(6174),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHchapter] = ACTIONS(6174),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddchap] = ACTIONS(6174),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsection] = ACTIONS(6174),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddsec] = ACTIONS(6174),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHitem] = ACTIONS(6174),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6176),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6176),
    [anon_sym_DOLLAR] = ACTIONS(6174),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHbegin] = ACTIONS(6174),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHleft] = ACTIONS(6174),
    [anon_sym_BSLASHbigl] = ACTIONS(6174),
    [anon_sym_BSLASHBigl] = ACTIONS(6174),
    [anon_sym_BSLASHbiggl] = ACTIONS(6174),
    [anon_sym_BSLASHBiggl] = ACTIONS(6174),
    [anon_sym_BSLASHright] = ACTIONS(6174),
    [anon_sym_BSLASHbigr] = ACTIONS(6174),
    [anon_sym_BSLASHBigr] = ACTIONS(6174),
    [anon_sym_BSLASHbiggr] = ACTIONS(6174),
    [anon_sym_BSLASHBiggr] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHtext] = ACTIONS(6174),
    [anon_sym_BSLASHintertext] = ACTIONS(6174),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [443] = {
    [sym_command_name] = ACTIONS(6178),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6178),
    [anon_sym_LBRACK] = ACTIONS(6180),
    [anon_sym_RBRACK] = ACTIONS(6180),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_EQ] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6180),
    [anon_sym_RPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHpart] = ACTIONS(6178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddpart] = ACTIONS(6178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHchapter] = ACTIONS(6178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddchap] = ACTIONS(6178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsection] = ACTIONS(6178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddsec] = ACTIONS(6178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHitem] = ACTIONS(6178),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6180),
    [anon_sym_LBRACE] = ACTIONS(6180),
    [sym_word] = ACTIONS(6178),
    [sym_placeholder] = ACTIONS(6180),
    [anon_sym_PLUS] = ACTIONS(6180),
    [anon_sym_DASH] = ACTIONS(6180),
    [anon_sym_STAR] = ACTIONS(6180),
    [anon_sym_SLASH] = ACTIONS(6180),
    [anon_sym_LT] = ACTIONS(6178),
    [anon_sym_GT] = ACTIONS(6178),
    [anon_sym_BANG] = ACTIONS(6178),
    [anon_sym_PIPE] = ACTIONS(6178),
    [anon_sym_COLON] = ACTIONS(6178),
    [anon_sym_SQUOTE] = ACTIONS(6178),
    [anon_sym__] = ACTIONS(6180),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6180),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6180),
    [anon_sym_DOLLAR] = ACTIONS(6178),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHbegin] = ACTIONS(6178),
    [anon_sym_BSLASHtitle] = ACTIONS(6178),
    [anon_sym_BSLASHauthor] = ACTIONS(6178),
    [anon_sym_BSLASHusepackage] = ACTIONS(6178),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6178),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6178),
    [anon_sym_BSLASHinclude] = ACTIONS(6178),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6178),
    [anon_sym_BSLASHinput] = ACTIONS(6178),
    [anon_sym_BSLASHsubfile] = ACTIONS(6178),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6178),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6178),
    [anon_sym_BSLASHbibliography] = ACTIONS(6178),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6178),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6178),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6178),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6178),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6178),
    [anon_sym_BSLASHimport] = ACTIONS(6178),
    [anon_sym_BSLASHsubimport] = ACTIONS(6178),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6178),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHcaption] = ACTIONS(6178),
    [anon_sym_BSLASHcite] = ACTIONS(6178),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCite] = ACTIONS(6178),
    [anon_sym_BSLASHnocite] = ACTIONS(6178),
    [anon_sym_BSLASHcitet] = ACTIONS(6178),
    [anon_sym_BSLASHcitep] = ACTIONS(6178),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteA] = ACTIONS(6178),
    [anon_sym_BSLASHciteR] = ACTIONS(6178),
    [anon_sym_BSLASHciteS] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6178),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteyear] = ACTIONS(6178),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitedate] = ACTIONS(6178),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteurl] = ACTIONS(6178),
    [anon_sym_BSLASHfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6178),
    [anon_sym_BSLASHcitealt] = ACTIONS(6178),
    [anon_sym_BSLASHcitealp] = ACTIONS(6178),
    [anon_sym_BSLASHcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHparencite] = ACTIONS(6178),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHParencite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHtextcite] = ACTIONS(6178),
    [anon_sym_BSLASHTextcite] = ACTIONS(6178),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHsupercite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite] = ACTIONS(6178),
    [anon_sym_BSLASHAutocite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHVolcite] = ACTIONS(6178),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHavolcite] = ACTIONS(6178),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHNotecite] = ACTIONS(6178),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHlabel] = ACTIONS(6178),
    [anon_sym_BSLASHref] = ACTIONS(6178),
    [anon_sym_BSLASHeqref] = ACTIONS(6178),
    [anon_sym_BSLASHvref] = ACTIONS(6178),
    [anon_sym_BSLASHVref] = ACTIONS(6178),
    [anon_sym_BSLASHautoref] = ACTIONS(6178),
    [anon_sym_BSLASHpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcref] = ACTIONS(6178),
    [anon_sym_BSLASHCref] = ACTIONS(6178),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnameCref] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHdef] = ACTIONS(6178),
    [anon_sym_BSLASHlet] = ACTIONS(6178),
    [anon_sym_BSLASHleft] = ACTIONS(6178),
    [anon_sym_BSLASHbigl] = ACTIONS(6178),
    [anon_sym_BSLASHBigl] = ACTIONS(6178),
    [anon_sym_BSLASHbiggl] = ACTIONS(6178),
    [anon_sym_BSLASHBiggl] = ACTIONS(6178),
    [anon_sym_BSLASHright] = ACTIONS(6178),
    [anon_sym_BSLASHbigr] = ACTIONS(6178),
    [anon_sym_BSLASHBigr] = ACTIONS(6178),
    [anon_sym_BSLASHbiggr] = ACTIONS(6178),
    [anon_sym_BSLASHBiggr] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6178),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6178),
    [anon_sym_BSLASHgls] = ACTIONS(6178),
    [anon_sym_BSLASHGls] = ACTIONS(6178),
    [anon_sym_BSLASHGLS] = ACTIONS(6178),
    [anon_sym_BSLASHglspl] = ACTIONS(6178),
    [anon_sym_BSLASHGlspl] = ACTIONS(6178),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6178),
    [anon_sym_BSLASHglslink] = ACTIONS(6178),
    [anon_sym_BSLASHglstext] = ACTIONS(6178),
    [anon_sym_BSLASHGlstext] = ACTIONS(6178),
    [anon_sym_BSLASHGLStext] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6178),
    [anon_sym_BSLASHglsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsname] = ACTIONS(6178),
    [anon_sym_BSLASHGlsname] = ACTIONS(6178),
    [anon_sym_BSLASHGLSname] = ACTIONS(6178),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6178),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6178),
    [anon_sym_BSLASHacrshort] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6178),
    [anon_sym_BSLASHACRshort] = ACTIONS(6178),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrlong] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6178),
    [anon_sym_BSLASHACRlong] = ACTIONS(6178),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrfull] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6178),
    [anon_sym_BSLASHACRfull] = ACTIONS(6178),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHacs] = ACTIONS(6178),
    [anon_sym_BSLASHAcs] = ACTIONS(6178),
    [anon_sym_BSLASHacsp] = ACTIONS(6178),
    [anon_sym_BSLASHAcsp] = ACTIONS(6178),
    [anon_sym_BSLASHacl] = ACTIONS(6178),
    [anon_sym_BSLASHAcl] = ACTIONS(6178),
    [anon_sym_BSLASHaclp] = ACTIONS(6178),
    [anon_sym_BSLASHAclp] = ACTIONS(6178),
    [anon_sym_BSLASHacf] = ACTIONS(6178),
    [anon_sym_BSLASHAcf] = ACTIONS(6178),
    [anon_sym_BSLASHacfp] = ACTIONS(6178),
    [anon_sym_BSLASHAcfp] = ACTIONS(6178),
    [anon_sym_BSLASHac] = ACTIONS(6178),
    [anon_sym_BSLASHAc] = ACTIONS(6178),
    [anon_sym_BSLASHacp] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6178),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6178),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6178),
    [anon_sym_BSLASHcolor] = ACTIONS(6178),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6178),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6178),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6178),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6178),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6178),
    [anon_sym_BSLASHtext] = ACTIONS(6178),
    [anon_sym_BSLASHintertext] = ACTIONS(6178),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6178),
    [anon_sym_BSLASHurl] = ACTIONS(6178),
    [anon_sym_BSLASHhref] = ACTIONS(6178),
  },
  [444] = {
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_RBRACK] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6184),
    [anon_sym_EQ] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_RPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHpart] = ACTIONS(6182),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddpart] = ACTIONS(6182),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHchapter] = ACTIONS(6182),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddchap] = ACTIONS(6182),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsection] = ACTIONS(6182),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddsec] = ACTIONS(6182),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHitem] = ACTIONS(6182),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6184),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6184),
    [anon_sym_DOLLAR] = ACTIONS(6182),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHbegin] = ACTIONS(6182),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHleft] = ACTIONS(6182),
    [anon_sym_BSLASHbigl] = ACTIONS(6182),
    [anon_sym_BSLASHBigl] = ACTIONS(6182),
    [anon_sym_BSLASHbiggl] = ACTIONS(6182),
    [anon_sym_BSLASHBiggl] = ACTIONS(6182),
    [anon_sym_BSLASHright] = ACTIONS(6182),
    [anon_sym_BSLASHbigr] = ACTIONS(6182),
    [anon_sym_BSLASHBigr] = ACTIONS(6182),
    [anon_sym_BSLASHbiggr] = ACTIONS(6182),
    [anon_sym_BSLASHBiggr] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHtext] = ACTIONS(6182),
    [anon_sym_BSLASHintertext] = ACTIONS(6182),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [445] = {
    [sym_command_name] = ACTIONS(6186),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(6188),
    [anon_sym_RBRACK] = ACTIONS(6188),
    [anon_sym_COMMA] = ACTIONS(6188),
    [anon_sym_EQ] = ACTIONS(6188),
    [anon_sym_LPAREN] = ACTIONS(6188),
    [anon_sym_RPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHpart] = ACTIONS(6186),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddpart] = ACTIONS(6186),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHchapter] = ACTIONS(6186),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddchap] = ACTIONS(6186),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsection] = ACTIONS(6186),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddsec] = ACTIONS(6186),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHitem] = ACTIONS(6186),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6188),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [sym_word] = ACTIONS(6186),
    [sym_placeholder] = ACTIONS(6188),
    [anon_sym_PLUS] = ACTIONS(6188),
    [anon_sym_DASH] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_SLASH] = ACTIONS(6188),
    [anon_sym_LT] = ACTIONS(6186),
    [anon_sym_GT] = ACTIONS(6186),
    [anon_sym_BANG] = ACTIONS(6186),
    [anon_sym_PIPE] = ACTIONS(6186),
    [anon_sym_COLON] = ACTIONS(6186),
    [anon_sym_SQUOTE] = ACTIONS(6186),
    [anon_sym__] = ACTIONS(6188),
    [anon_sym_CARET] = ACTIONS(6188),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6188),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6188),
    [anon_sym_DOLLAR] = ACTIONS(6186),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHbegin] = ACTIONS(6186),
    [anon_sym_BSLASHtitle] = ACTIONS(6186),
    [anon_sym_BSLASHauthor] = ACTIONS(6186),
    [anon_sym_BSLASHusepackage] = ACTIONS(6186),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6186),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6186),
    [anon_sym_BSLASHinclude] = ACTIONS(6186),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6186),
    [anon_sym_BSLASHinput] = ACTIONS(6186),
    [anon_sym_BSLASHsubfile] = ACTIONS(6186),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6186),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6186),
    [anon_sym_BSLASHbibliography] = ACTIONS(6186),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6186),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6186),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6186),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6186),
    [anon_sym_BSLASHimport] = ACTIONS(6186),
    [anon_sym_BSLASHsubimport] = ACTIONS(6186),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6186),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHcaption] = ACTIONS(6186),
    [anon_sym_BSLASHcite] = ACTIONS(6186),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCite] = ACTIONS(6186),
    [anon_sym_BSLASHnocite] = ACTIONS(6186),
    [anon_sym_BSLASHcitet] = ACTIONS(6186),
    [anon_sym_BSLASHcitep] = ACTIONS(6186),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteA] = ACTIONS(6186),
    [anon_sym_BSLASHciteR] = ACTIONS(6186),
    [anon_sym_BSLASHciteS] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6186),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteyear] = ACTIONS(6186),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitedate] = ACTIONS(6186),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteurl] = ACTIONS(6186),
    [anon_sym_BSLASHfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6186),
    [anon_sym_BSLASHcitealt] = ACTIONS(6186),
    [anon_sym_BSLASHcitealp] = ACTIONS(6186),
    [anon_sym_BSLASHcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHparencite] = ACTIONS(6186),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHParencite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHtextcite] = ACTIONS(6186),
    [anon_sym_BSLASHTextcite] = ACTIONS(6186),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHsupercite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite] = ACTIONS(6186),
    [anon_sym_BSLASHAutocite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHVolcite] = ACTIONS(6186),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHavolcite] = ACTIONS(6186),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHNotecite] = ACTIONS(6186),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHlabel] = ACTIONS(6186),
    [anon_sym_BSLASHref] = ACTIONS(6186),
    [anon_sym_BSLASHeqref] = ACTIONS(6186),
    [anon_sym_BSLASHvref] = ACTIONS(6186),
    [anon_sym_BSLASHVref] = ACTIONS(6186),
    [anon_sym_BSLASHautoref] = ACTIONS(6186),
    [anon_sym_BSLASHpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcref] = ACTIONS(6186),
    [anon_sym_BSLASHCref] = ACTIONS(6186),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnameCref] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHdef] = ACTIONS(6186),
    [anon_sym_BSLASHlet] = ACTIONS(6186),
    [anon_sym_BSLASHleft] = ACTIONS(6186),
    [anon_sym_BSLASHbigl] = ACTIONS(6186),
    [anon_sym_BSLASHBigl] = ACTIONS(6186),
    [anon_sym_BSLASHbiggl] = ACTIONS(6186),
    [anon_sym_BSLASHBiggl] = ACTIONS(6186),
    [anon_sym_BSLASHright] = ACTIONS(6186),
    [anon_sym_BSLASHbigr] = ACTIONS(6186),
    [anon_sym_BSLASHBigr] = ACTIONS(6186),
    [anon_sym_BSLASHbiggr] = ACTIONS(6186),
    [anon_sym_BSLASHBiggr] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6186),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6186),
    [anon_sym_BSLASHgls] = ACTIONS(6186),
    [anon_sym_BSLASHGls] = ACTIONS(6186),
    [anon_sym_BSLASHGLS] = ACTIONS(6186),
    [anon_sym_BSLASHglspl] = ACTIONS(6186),
    [anon_sym_BSLASHGlspl] = ACTIONS(6186),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6186),
    [anon_sym_BSLASHglslink] = ACTIONS(6186),
    [anon_sym_BSLASHglstext] = ACTIONS(6186),
    [anon_sym_BSLASHGlstext] = ACTIONS(6186),
    [anon_sym_BSLASHGLStext] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6186),
    [anon_sym_BSLASHglsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsname] = ACTIONS(6186),
    [anon_sym_BSLASHGlsname] = ACTIONS(6186),
    [anon_sym_BSLASHGLSname] = ACTIONS(6186),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6186),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6186),
    [anon_sym_BSLASHacrshort] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6186),
    [anon_sym_BSLASHACRshort] = ACTIONS(6186),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrlong] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6186),
    [anon_sym_BSLASHACRlong] = ACTIONS(6186),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrfull] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6186),
    [anon_sym_BSLASHACRfull] = ACTIONS(6186),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHacs] = ACTIONS(6186),
    [anon_sym_BSLASHAcs] = ACTIONS(6186),
    [anon_sym_BSLASHacsp] = ACTIONS(6186),
    [anon_sym_BSLASHAcsp] = ACTIONS(6186),
    [anon_sym_BSLASHacl] = ACTIONS(6186),
    [anon_sym_BSLASHAcl] = ACTIONS(6186),
    [anon_sym_BSLASHaclp] = ACTIONS(6186),
    [anon_sym_BSLASHAclp] = ACTIONS(6186),
    [anon_sym_BSLASHacf] = ACTIONS(6186),
    [anon_sym_BSLASHAcf] = ACTIONS(6186),
    [anon_sym_BSLASHacfp] = ACTIONS(6186),
    [anon_sym_BSLASHAcfp] = ACTIONS(6186),
    [anon_sym_BSLASHac] = ACTIONS(6186),
    [anon_sym_BSLASHAc] = ACTIONS(6186),
    [anon_sym_BSLASHacp] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6186),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6186),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6186),
    [anon_sym_BSLASHcolor] = ACTIONS(6186),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6186),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6186),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6186),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6186),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6186),
    [anon_sym_BSLASHtext] = ACTIONS(6186),
    [anon_sym_BSLASHintertext] = ACTIONS(6186),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6186),
    [anon_sym_BSLASHurl] = ACTIONS(6186),
    [anon_sym_BSLASHhref] = ACTIONS(6186),
  },
  [446] = {
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_RBRACK] = ACTIONS(6192),
    [anon_sym_COMMA] = ACTIONS(6192),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_RPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHpart] = ACTIONS(6190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddpart] = ACTIONS(6190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHchapter] = ACTIONS(6190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddchap] = ACTIONS(6190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsection] = ACTIONS(6190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddsec] = ACTIONS(6190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHitem] = ACTIONS(6190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6192),
    [anon_sym_DOLLAR] = ACTIONS(6190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHbegin] = ACTIONS(6190),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHleft] = ACTIONS(6190),
    [anon_sym_BSLASHbigl] = ACTIONS(6190),
    [anon_sym_BSLASHBigl] = ACTIONS(6190),
    [anon_sym_BSLASHbiggl] = ACTIONS(6190),
    [anon_sym_BSLASHBiggl] = ACTIONS(6190),
    [anon_sym_BSLASHright] = ACTIONS(6190),
    [anon_sym_BSLASHbigr] = ACTIONS(6190),
    [anon_sym_BSLASHBigr] = ACTIONS(6190),
    [anon_sym_BSLASHbiggr] = ACTIONS(6190),
    [anon_sym_BSLASHBiggr] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHtext] = ACTIONS(6190),
    [anon_sym_BSLASHintertext] = ACTIONS(6190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [447] = {
    [sym_command_name] = ACTIONS(6194),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_RBRACK] = ACTIONS(6196),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_EQ] = ACTIONS(6196),
    [anon_sym_LPAREN] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHpart] = ACTIONS(6194),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddpart] = ACTIONS(6194),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHchapter] = ACTIONS(6194),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddchap] = ACTIONS(6194),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsection] = ACTIONS(6194),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddsec] = ACTIONS(6194),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHitem] = ACTIONS(6194),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [sym_word] = ACTIONS(6194),
    [sym_placeholder] = ACTIONS(6196),
    [anon_sym_PLUS] = ACTIONS(6196),
    [anon_sym_DASH] = ACTIONS(6196),
    [anon_sym_STAR] = ACTIONS(6196),
    [anon_sym_SLASH] = ACTIONS(6196),
    [anon_sym_LT] = ACTIONS(6194),
    [anon_sym_GT] = ACTIONS(6194),
    [anon_sym_BANG] = ACTIONS(6194),
    [anon_sym_PIPE] = ACTIONS(6194),
    [anon_sym_COLON] = ACTIONS(6194),
    [anon_sym_SQUOTE] = ACTIONS(6194),
    [anon_sym__] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6196),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6196),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6196),
    [anon_sym_DOLLAR] = ACTIONS(6194),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHbegin] = ACTIONS(6194),
    [anon_sym_BSLASHtitle] = ACTIONS(6194),
    [anon_sym_BSLASHauthor] = ACTIONS(6194),
    [anon_sym_BSLASHusepackage] = ACTIONS(6194),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6194),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6194),
    [anon_sym_BSLASHinclude] = ACTIONS(6194),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6194),
    [anon_sym_BSLASHinput] = ACTIONS(6194),
    [anon_sym_BSLASHsubfile] = ACTIONS(6194),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6194),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6194),
    [anon_sym_BSLASHbibliography] = ACTIONS(6194),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6194),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6194),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6194),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6194),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6194),
    [anon_sym_BSLASHimport] = ACTIONS(6194),
    [anon_sym_BSLASHsubimport] = ACTIONS(6194),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6194),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHcaption] = ACTIONS(6194),
    [anon_sym_BSLASHcite] = ACTIONS(6194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCite] = ACTIONS(6194),
    [anon_sym_BSLASHnocite] = ACTIONS(6194),
    [anon_sym_BSLASHcitet] = ACTIONS(6194),
    [anon_sym_BSLASHcitep] = ACTIONS(6194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteA] = ACTIONS(6194),
    [anon_sym_BSLASHciteR] = ACTIONS(6194),
    [anon_sym_BSLASHciteS] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteyear] = ACTIONS(6194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitedate] = ACTIONS(6194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteurl] = ACTIONS(6194),
    [anon_sym_BSLASHfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6194),
    [anon_sym_BSLASHcitealt] = ACTIONS(6194),
    [anon_sym_BSLASHcitealp] = ACTIONS(6194),
    [anon_sym_BSLASHcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHparencite] = ACTIONS(6194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHParencite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHtextcite] = ACTIONS(6194),
    [anon_sym_BSLASHTextcite] = ACTIONS(6194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHsupercite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite] = ACTIONS(6194),
    [anon_sym_BSLASHAutocite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHVolcite] = ACTIONS(6194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHavolcite] = ACTIONS(6194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHNotecite] = ACTIONS(6194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHlabel] = ACTIONS(6194),
    [anon_sym_BSLASHref] = ACTIONS(6194),
    [anon_sym_BSLASHeqref] = ACTIONS(6194),
    [anon_sym_BSLASHvref] = ACTIONS(6194),
    [anon_sym_BSLASHVref] = ACTIONS(6194),
    [anon_sym_BSLASHautoref] = ACTIONS(6194),
    [anon_sym_BSLASHpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcref] = ACTIONS(6194),
    [anon_sym_BSLASHCref] = ACTIONS(6194),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnameCref] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHdef] = ACTIONS(6194),
    [anon_sym_BSLASHlet] = ACTIONS(6194),
    [anon_sym_BSLASHleft] = ACTIONS(6194),
    [anon_sym_BSLASHbigl] = ACTIONS(6194),
    [anon_sym_BSLASHBigl] = ACTIONS(6194),
    [anon_sym_BSLASHbiggl] = ACTIONS(6194),
    [anon_sym_BSLASHBiggl] = ACTIONS(6194),
    [anon_sym_BSLASHright] = ACTIONS(6194),
    [anon_sym_BSLASHbigr] = ACTIONS(6194),
    [anon_sym_BSLASHBigr] = ACTIONS(6194),
    [anon_sym_BSLASHbiggr] = ACTIONS(6194),
    [anon_sym_BSLASHBiggr] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6194),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6194),
    [anon_sym_BSLASHgls] = ACTIONS(6194),
    [anon_sym_BSLASHGls] = ACTIONS(6194),
    [anon_sym_BSLASHGLS] = ACTIONS(6194),
    [anon_sym_BSLASHglspl] = ACTIONS(6194),
    [anon_sym_BSLASHGlspl] = ACTIONS(6194),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6194),
    [anon_sym_BSLASHglslink] = ACTIONS(6194),
    [anon_sym_BSLASHglstext] = ACTIONS(6194),
    [anon_sym_BSLASHGlstext] = ACTIONS(6194),
    [anon_sym_BSLASHGLStext] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6194),
    [anon_sym_BSLASHglsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsname] = ACTIONS(6194),
    [anon_sym_BSLASHGlsname] = ACTIONS(6194),
    [anon_sym_BSLASHGLSname] = ACTIONS(6194),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6194),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6194),
    [anon_sym_BSLASHacrshort] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6194),
    [anon_sym_BSLASHACRshort] = ACTIONS(6194),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrlong] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6194),
    [anon_sym_BSLASHACRlong] = ACTIONS(6194),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrfull] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6194),
    [anon_sym_BSLASHACRfull] = ACTIONS(6194),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHacs] = ACTIONS(6194),
    [anon_sym_BSLASHAcs] = ACTIONS(6194),
    [anon_sym_BSLASHacsp] = ACTIONS(6194),
    [anon_sym_BSLASHAcsp] = ACTIONS(6194),
    [anon_sym_BSLASHacl] = ACTIONS(6194),
    [anon_sym_BSLASHAcl] = ACTIONS(6194),
    [anon_sym_BSLASHaclp] = ACTIONS(6194),
    [anon_sym_BSLASHAclp] = ACTIONS(6194),
    [anon_sym_BSLASHacf] = ACTIONS(6194),
    [anon_sym_BSLASHAcf] = ACTIONS(6194),
    [anon_sym_BSLASHacfp] = ACTIONS(6194),
    [anon_sym_BSLASHAcfp] = ACTIONS(6194),
    [anon_sym_BSLASHac] = ACTIONS(6194),
    [anon_sym_BSLASHAc] = ACTIONS(6194),
    [anon_sym_BSLASHacp] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6194),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6194),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6194),
    [anon_sym_BSLASHcolor] = ACTIONS(6194),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6194),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6194),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6194),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6194),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6194),
    [anon_sym_BSLASHtext] = ACTIONS(6194),
    [anon_sym_BSLASHintertext] = ACTIONS(6194),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6194),
    [anon_sym_BSLASHurl] = ACTIONS(6194),
    [anon_sym_BSLASHhref] = ACTIONS(6194),
  },
  [448] = {
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [anon_sym_RPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHpart] = ACTIONS(6198),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddpart] = ACTIONS(6198),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHchapter] = ACTIONS(6198),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddchap] = ACTIONS(6198),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsection] = ACTIONS(6198),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddsec] = ACTIONS(6198),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHitem] = ACTIONS(6198),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6200),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6200),
    [anon_sym_DOLLAR] = ACTIONS(6198),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHbegin] = ACTIONS(6198),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHleft] = ACTIONS(6198),
    [anon_sym_BSLASHbigl] = ACTIONS(6198),
    [anon_sym_BSLASHBigl] = ACTIONS(6198),
    [anon_sym_BSLASHbiggl] = ACTIONS(6198),
    [anon_sym_BSLASHBiggl] = ACTIONS(6198),
    [anon_sym_BSLASHright] = ACTIONS(6198),
    [anon_sym_BSLASHbigr] = ACTIONS(6198),
    [anon_sym_BSLASHBigr] = ACTIONS(6198),
    [anon_sym_BSLASHbiggr] = ACTIONS(6198),
    [anon_sym_BSLASHBiggr] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHtext] = ACTIONS(6198),
    [anon_sym_BSLASHintertext] = ACTIONS(6198),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [449] = {
    [sym_command_name] = ACTIONS(6202),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6202),
    [anon_sym_LBRACK] = ACTIONS(6204),
    [anon_sym_RBRACK] = ACTIONS(6204),
    [anon_sym_COMMA] = ACTIONS(6204),
    [anon_sym_EQ] = ACTIONS(6204),
    [anon_sym_LPAREN] = ACTIONS(6204),
    [anon_sym_RPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHpart] = ACTIONS(6202),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddpart] = ACTIONS(6202),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHchapter] = ACTIONS(6202),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddchap] = ACTIONS(6202),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsection] = ACTIONS(6202),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddsec] = ACTIONS(6202),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHitem] = ACTIONS(6202),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6204),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [sym_word] = ACTIONS(6202),
    [sym_placeholder] = ACTIONS(6204),
    [anon_sym_PLUS] = ACTIONS(6204),
    [anon_sym_DASH] = ACTIONS(6204),
    [anon_sym_STAR] = ACTIONS(6204),
    [anon_sym_SLASH] = ACTIONS(6204),
    [anon_sym_LT] = ACTIONS(6202),
    [anon_sym_GT] = ACTIONS(6202),
    [anon_sym_BANG] = ACTIONS(6202),
    [anon_sym_PIPE] = ACTIONS(6202),
    [anon_sym_COLON] = ACTIONS(6202),
    [anon_sym_SQUOTE] = ACTIONS(6202),
    [anon_sym__] = ACTIONS(6204),
    [anon_sym_CARET] = ACTIONS(6204),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6204),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6204),
    [anon_sym_DOLLAR] = ACTIONS(6202),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHbegin] = ACTIONS(6202),
    [anon_sym_BSLASHtitle] = ACTIONS(6202),
    [anon_sym_BSLASHauthor] = ACTIONS(6202),
    [anon_sym_BSLASHusepackage] = ACTIONS(6202),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6202),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6202),
    [anon_sym_BSLASHinclude] = ACTIONS(6202),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6202),
    [anon_sym_BSLASHinput] = ACTIONS(6202),
    [anon_sym_BSLASHsubfile] = ACTIONS(6202),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6202),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6202),
    [anon_sym_BSLASHbibliography] = ACTIONS(6202),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6202),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6202),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6202),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6202),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6202),
    [anon_sym_BSLASHimport] = ACTIONS(6202),
    [anon_sym_BSLASHsubimport] = ACTIONS(6202),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6202),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHcaption] = ACTIONS(6202),
    [anon_sym_BSLASHcite] = ACTIONS(6202),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCite] = ACTIONS(6202),
    [anon_sym_BSLASHnocite] = ACTIONS(6202),
    [anon_sym_BSLASHcitet] = ACTIONS(6202),
    [anon_sym_BSLASHcitep] = ACTIONS(6202),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteA] = ACTIONS(6202),
    [anon_sym_BSLASHciteR] = ACTIONS(6202),
    [anon_sym_BSLASHciteS] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6202),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteyear] = ACTIONS(6202),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitedate] = ACTIONS(6202),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteurl] = ACTIONS(6202),
    [anon_sym_BSLASHfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6202),
    [anon_sym_BSLASHcitealt] = ACTIONS(6202),
    [anon_sym_BSLASHcitealp] = ACTIONS(6202),
    [anon_sym_BSLASHcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHparencite] = ACTIONS(6202),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHParencite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHtextcite] = ACTIONS(6202),
    [anon_sym_BSLASHTextcite] = ACTIONS(6202),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHsupercite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite] = ACTIONS(6202),
    [anon_sym_BSLASHAutocite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHVolcite] = ACTIONS(6202),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHavolcite] = ACTIONS(6202),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHNotecite] = ACTIONS(6202),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHlabel] = ACTIONS(6202),
    [anon_sym_BSLASHref] = ACTIONS(6202),
    [anon_sym_BSLASHeqref] = ACTIONS(6202),
    [anon_sym_BSLASHvref] = ACTIONS(6202),
    [anon_sym_BSLASHVref] = ACTIONS(6202),
    [anon_sym_BSLASHautoref] = ACTIONS(6202),
    [anon_sym_BSLASHpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcref] = ACTIONS(6202),
    [anon_sym_BSLASHCref] = ACTIONS(6202),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnameCref] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHdef] = ACTIONS(6202),
    [anon_sym_BSLASHlet] = ACTIONS(6202),
    [anon_sym_BSLASHleft] = ACTIONS(6202),
    [anon_sym_BSLASHbigl] = ACTIONS(6202),
    [anon_sym_BSLASHBigl] = ACTIONS(6202),
    [anon_sym_BSLASHbiggl] = ACTIONS(6202),
    [anon_sym_BSLASHBiggl] = ACTIONS(6202),
    [anon_sym_BSLASHright] = ACTIONS(6202),
    [anon_sym_BSLASHbigr] = ACTIONS(6202),
    [anon_sym_BSLASHBigr] = ACTIONS(6202),
    [anon_sym_BSLASHbiggr] = ACTIONS(6202),
    [anon_sym_BSLASHBiggr] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6202),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6202),
    [anon_sym_BSLASHgls] = ACTIONS(6202),
    [anon_sym_BSLASHGls] = ACTIONS(6202),
    [anon_sym_BSLASHGLS] = ACTIONS(6202),
    [anon_sym_BSLASHglspl] = ACTIONS(6202),
    [anon_sym_BSLASHGlspl] = ACTIONS(6202),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6202),
    [anon_sym_BSLASHglslink] = ACTIONS(6202),
    [anon_sym_BSLASHglstext] = ACTIONS(6202),
    [anon_sym_BSLASHGlstext] = ACTIONS(6202),
    [anon_sym_BSLASHGLStext] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6202),
    [anon_sym_BSLASHglsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsname] = ACTIONS(6202),
    [anon_sym_BSLASHGlsname] = ACTIONS(6202),
    [anon_sym_BSLASHGLSname] = ACTIONS(6202),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6202),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6202),
    [anon_sym_BSLASHacrshort] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6202),
    [anon_sym_BSLASHACRshort] = ACTIONS(6202),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrlong] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6202),
    [anon_sym_BSLASHACRlong] = ACTIONS(6202),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrfull] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6202),
    [anon_sym_BSLASHACRfull] = ACTIONS(6202),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHacs] = ACTIONS(6202),
    [anon_sym_BSLASHAcs] = ACTIONS(6202),
    [anon_sym_BSLASHacsp] = ACTIONS(6202),
    [anon_sym_BSLASHAcsp] = ACTIONS(6202),
    [anon_sym_BSLASHacl] = ACTIONS(6202),
    [anon_sym_BSLASHAcl] = ACTIONS(6202),
    [anon_sym_BSLASHaclp] = ACTIONS(6202),
    [anon_sym_BSLASHAclp] = ACTIONS(6202),
    [anon_sym_BSLASHacf] = ACTIONS(6202),
    [anon_sym_BSLASHAcf] = ACTIONS(6202),
    [anon_sym_BSLASHacfp] = ACTIONS(6202),
    [anon_sym_BSLASHAcfp] = ACTIONS(6202),
    [anon_sym_BSLASHac] = ACTIONS(6202),
    [anon_sym_BSLASHAc] = ACTIONS(6202),
    [anon_sym_BSLASHacp] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6202),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6202),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6202),
    [anon_sym_BSLASHcolor] = ACTIONS(6202),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6202),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6202),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6202),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6202),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6202),
    [anon_sym_BSLASHtext] = ACTIONS(6202),
    [anon_sym_BSLASHintertext] = ACTIONS(6202),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6202),
    [anon_sym_BSLASHurl] = ACTIONS(6202),
    [anon_sym_BSLASHhref] = ACTIONS(6202),
  },
  [450] = {
    [sym_command_name] = ACTIONS(6206),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [anon_sym_RBRACK] = ACTIONS(6208),
    [anon_sym_COMMA] = ACTIONS(6208),
    [anon_sym_EQ] = ACTIONS(6208),
    [anon_sym_LPAREN] = ACTIONS(6208),
    [anon_sym_RPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHpart] = ACTIONS(6206),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddpart] = ACTIONS(6206),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHchapter] = ACTIONS(6206),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddchap] = ACTIONS(6206),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsection] = ACTIONS(6206),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddsec] = ACTIONS(6206),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHitem] = ACTIONS(6206),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6208),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [sym_word] = ACTIONS(6206),
    [sym_placeholder] = ACTIONS(6208),
    [anon_sym_PLUS] = ACTIONS(6208),
    [anon_sym_DASH] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_SLASH] = ACTIONS(6208),
    [anon_sym_LT] = ACTIONS(6206),
    [anon_sym_GT] = ACTIONS(6206),
    [anon_sym_BANG] = ACTIONS(6206),
    [anon_sym_PIPE] = ACTIONS(6206),
    [anon_sym_COLON] = ACTIONS(6206),
    [anon_sym_SQUOTE] = ACTIONS(6206),
    [anon_sym__] = ACTIONS(6208),
    [anon_sym_CARET] = ACTIONS(6208),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6208),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6208),
    [anon_sym_DOLLAR] = ACTIONS(6206),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHbegin] = ACTIONS(6206),
    [anon_sym_BSLASHtitle] = ACTIONS(6206),
    [anon_sym_BSLASHauthor] = ACTIONS(6206),
    [anon_sym_BSLASHusepackage] = ACTIONS(6206),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6206),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6206),
    [anon_sym_BSLASHinclude] = ACTIONS(6206),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6206),
    [anon_sym_BSLASHinput] = ACTIONS(6206),
    [anon_sym_BSLASHsubfile] = ACTIONS(6206),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6206),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6206),
    [anon_sym_BSLASHbibliography] = ACTIONS(6206),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6206),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6206),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6206),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6206),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6206),
    [anon_sym_BSLASHimport] = ACTIONS(6206),
    [anon_sym_BSLASHsubimport] = ACTIONS(6206),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6206),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHcaption] = ACTIONS(6206),
    [anon_sym_BSLASHcite] = ACTIONS(6206),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCite] = ACTIONS(6206),
    [anon_sym_BSLASHnocite] = ACTIONS(6206),
    [anon_sym_BSLASHcitet] = ACTIONS(6206),
    [anon_sym_BSLASHcitep] = ACTIONS(6206),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteA] = ACTIONS(6206),
    [anon_sym_BSLASHciteR] = ACTIONS(6206),
    [anon_sym_BSLASHciteS] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6206),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteyear] = ACTIONS(6206),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitedate] = ACTIONS(6206),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteurl] = ACTIONS(6206),
    [anon_sym_BSLASHfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6206),
    [anon_sym_BSLASHcitealt] = ACTIONS(6206),
    [anon_sym_BSLASHcitealp] = ACTIONS(6206),
    [anon_sym_BSLASHcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHparencite] = ACTIONS(6206),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHParencite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHtextcite] = ACTIONS(6206),
    [anon_sym_BSLASHTextcite] = ACTIONS(6206),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHsupercite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite] = ACTIONS(6206),
    [anon_sym_BSLASHAutocite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHVolcite] = ACTIONS(6206),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHavolcite] = ACTIONS(6206),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHNotecite] = ACTIONS(6206),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHlabel] = ACTIONS(6206),
    [anon_sym_BSLASHref] = ACTIONS(6206),
    [anon_sym_BSLASHeqref] = ACTIONS(6206),
    [anon_sym_BSLASHvref] = ACTIONS(6206),
    [anon_sym_BSLASHVref] = ACTIONS(6206),
    [anon_sym_BSLASHautoref] = ACTIONS(6206),
    [anon_sym_BSLASHpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcref] = ACTIONS(6206),
    [anon_sym_BSLASHCref] = ACTIONS(6206),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnameCref] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHdef] = ACTIONS(6206),
    [anon_sym_BSLASHlet] = ACTIONS(6206),
    [anon_sym_BSLASHleft] = ACTIONS(6206),
    [anon_sym_BSLASHbigl] = ACTIONS(6206),
    [anon_sym_BSLASHBigl] = ACTIONS(6206),
    [anon_sym_BSLASHbiggl] = ACTIONS(6206),
    [anon_sym_BSLASHBiggl] = ACTIONS(6206),
    [anon_sym_BSLASHright] = ACTIONS(6206),
    [anon_sym_BSLASHbigr] = ACTIONS(6206),
    [anon_sym_BSLASHBigr] = ACTIONS(6206),
    [anon_sym_BSLASHbiggr] = ACTIONS(6206),
    [anon_sym_BSLASHBiggr] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6206),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6206),
    [anon_sym_BSLASHgls] = ACTIONS(6206),
    [anon_sym_BSLASHGls] = ACTIONS(6206),
    [anon_sym_BSLASHGLS] = ACTIONS(6206),
    [anon_sym_BSLASHglspl] = ACTIONS(6206),
    [anon_sym_BSLASHGlspl] = ACTIONS(6206),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6206),
    [anon_sym_BSLASHglslink] = ACTIONS(6206),
    [anon_sym_BSLASHglstext] = ACTIONS(6206),
    [anon_sym_BSLASHGlstext] = ACTIONS(6206),
    [anon_sym_BSLASHGLStext] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6206),
    [anon_sym_BSLASHglsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsname] = ACTIONS(6206),
    [anon_sym_BSLASHGlsname] = ACTIONS(6206),
    [anon_sym_BSLASHGLSname] = ACTIONS(6206),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6206),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6206),
    [anon_sym_BSLASHacrshort] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6206),
    [anon_sym_BSLASHACRshort] = ACTIONS(6206),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrlong] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6206),
    [anon_sym_BSLASHACRlong] = ACTIONS(6206),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrfull] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6206),
    [anon_sym_BSLASHACRfull] = ACTIONS(6206),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHacs] = ACTIONS(6206),
    [anon_sym_BSLASHAcs] = ACTIONS(6206),
    [anon_sym_BSLASHacsp] = ACTIONS(6206),
    [anon_sym_BSLASHAcsp] = ACTIONS(6206),
    [anon_sym_BSLASHacl] = ACTIONS(6206),
    [anon_sym_BSLASHAcl] = ACTIONS(6206),
    [anon_sym_BSLASHaclp] = ACTIONS(6206),
    [anon_sym_BSLASHAclp] = ACTIONS(6206),
    [anon_sym_BSLASHacf] = ACTIONS(6206),
    [anon_sym_BSLASHAcf] = ACTIONS(6206),
    [anon_sym_BSLASHacfp] = ACTIONS(6206),
    [anon_sym_BSLASHAcfp] = ACTIONS(6206),
    [anon_sym_BSLASHac] = ACTIONS(6206),
    [anon_sym_BSLASHAc] = ACTIONS(6206),
    [anon_sym_BSLASHacp] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6206),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6206),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6206),
    [anon_sym_BSLASHcolor] = ACTIONS(6206),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6206),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6206),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6206),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6206),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6206),
    [anon_sym_BSLASHtext] = ACTIONS(6206),
    [anon_sym_BSLASHintertext] = ACTIONS(6206),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6206),
    [anon_sym_BSLASHurl] = ACTIONS(6206),
    [anon_sym_BSLASHhref] = ACTIONS(6206),
  },
  [451] = {
    [sym_command_name] = ACTIONS(6210),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_EQ] = ACTIONS(6212),
    [anon_sym_LPAREN] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHpart] = ACTIONS(6210),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddpart] = ACTIONS(6210),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHchapter] = ACTIONS(6210),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddchap] = ACTIONS(6210),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsection] = ACTIONS(6210),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddsec] = ACTIONS(6210),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHitem] = ACTIONS(6210),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [sym_word] = ACTIONS(6210),
    [sym_placeholder] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_DASH] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_LT] = ACTIONS(6210),
    [anon_sym_GT] = ACTIONS(6210),
    [anon_sym_BANG] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_COLON] = ACTIONS(6210),
    [anon_sym_SQUOTE] = ACTIONS(6210),
    [anon_sym__] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6212),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6212),
    [anon_sym_DOLLAR] = ACTIONS(6210),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHbegin] = ACTIONS(6210),
    [anon_sym_BSLASHtitle] = ACTIONS(6210),
    [anon_sym_BSLASHauthor] = ACTIONS(6210),
    [anon_sym_BSLASHusepackage] = ACTIONS(6210),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6210),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6210),
    [anon_sym_BSLASHinclude] = ACTIONS(6210),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6210),
    [anon_sym_BSLASHinput] = ACTIONS(6210),
    [anon_sym_BSLASHsubfile] = ACTIONS(6210),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6210),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6210),
    [anon_sym_BSLASHbibliography] = ACTIONS(6210),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6210),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6210),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6210),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6210),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6210),
    [anon_sym_BSLASHimport] = ACTIONS(6210),
    [anon_sym_BSLASHsubimport] = ACTIONS(6210),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6210),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHcaption] = ACTIONS(6210),
    [anon_sym_BSLASHcite] = ACTIONS(6210),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCite] = ACTIONS(6210),
    [anon_sym_BSLASHnocite] = ACTIONS(6210),
    [anon_sym_BSLASHcitet] = ACTIONS(6210),
    [anon_sym_BSLASHcitep] = ACTIONS(6210),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteA] = ACTIONS(6210),
    [anon_sym_BSLASHciteR] = ACTIONS(6210),
    [anon_sym_BSLASHciteS] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6210),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteyear] = ACTIONS(6210),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitedate] = ACTIONS(6210),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteurl] = ACTIONS(6210),
    [anon_sym_BSLASHfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6210),
    [anon_sym_BSLASHcitealt] = ACTIONS(6210),
    [anon_sym_BSLASHcitealp] = ACTIONS(6210),
    [anon_sym_BSLASHcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHparencite] = ACTIONS(6210),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHParencite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHtextcite] = ACTIONS(6210),
    [anon_sym_BSLASHTextcite] = ACTIONS(6210),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHsupercite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite] = ACTIONS(6210),
    [anon_sym_BSLASHAutocite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHVolcite] = ACTIONS(6210),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHavolcite] = ACTIONS(6210),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHNotecite] = ACTIONS(6210),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHlabel] = ACTIONS(6210),
    [anon_sym_BSLASHref] = ACTIONS(6210),
    [anon_sym_BSLASHeqref] = ACTIONS(6210),
    [anon_sym_BSLASHvref] = ACTIONS(6210),
    [anon_sym_BSLASHVref] = ACTIONS(6210),
    [anon_sym_BSLASHautoref] = ACTIONS(6210),
    [anon_sym_BSLASHpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcref] = ACTIONS(6210),
    [anon_sym_BSLASHCref] = ACTIONS(6210),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnameCref] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHdef] = ACTIONS(6210),
    [anon_sym_BSLASHlet] = ACTIONS(6210),
    [anon_sym_BSLASHleft] = ACTIONS(6210),
    [anon_sym_BSLASHbigl] = ACTIONS(6210),
    [anon_sym_BSLASHBigl] = ACTIONS(6210),
    [anon_sym_BSLASHbiggl] = ACTIONS(6210),
    [anon_sym_BSLASHBiggl] = ACTIONS(6210),
    [anon_sym_BSLASHright] = ACTIONS(6210),
    [anon_sym_BSLASHbigr] = ACTIONS(6210),
    [anon_sym_BSLASHBigr] = ACTIONS(6210),
    [anon_sym_BSLASHbiggr] = ACTIONS(6210),
    [anon_sym_BSLASHBiggr] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6210),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6210),
    [anon_sym_BSLASHgls] = ACTIONS(6210),
    [anon_sym_BSLASHGls] = ACTIONS(6210),
    [anon_sym_BSLASHGLS] = ACTIONS(6210),
    [anon_sym_BSLASHglspl] = ACTIONS(6210),
    [anon_sym_BSLASHGlspl] = ACTIONS(6210),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6210),
    [anon_sym_BSLASHglslink] = ACTIONS(6210),
    [anon_sym_BSLASHglstext] = ACTIONS(6210),
    [anon_sym_BSLASHGlstext] = ACTIONS(6210),
    [anon_sym_BSLASHGLStext] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6210),
    [anon_sym_BSLASHglsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsname] = ACTIONS(6210),
    [anon_sym_BSLASHGlsname] = ACTIONS(6210),
    [anon_sym_BSLASHGLSname] = ACTIONS(6210),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6210),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6210),
    [anon_sym_BSLASHacrshort] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6210),
    [anon_sym_BSLASHACRshort] = ACTIONS(6210),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrlong] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6210),
    [anon_sym_BSLASHACRlong] = ACTIONS(6210),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrfull] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6210),
    [anon_sym_BSLASHACRfull] = ACTIONS(6210),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHacs] = ACTIONS(6210),
    [anon_sym_BSLASHAcs] = ACTIONS(6210),
    [anon_sym_BSLASHacsp] = ACTIONS(6210),
    [anon_sym_BSLASHAcsp] = ACTIONS(6210),
    [anon_sym_BSLASHacl] = ACTIONS(6210),
    [anon_sym_BSLASHAcl] = ACTIONS(6210),
    [anon_sym_BSLASHaclp] = ACTIONS(6210),
    [anon_sym_BSLASHAclp] = ACTIONS(6210),
    [anon_sym_BSLASHacf] = ACTIONS(6210),
    [anon_sym_BSLASHAcf] = ACTIONS(6210),
    [anon_sym_BSLASHacfp] = ACTIONS(6210),
    [anon_sym_BSLASHAcfp] = ACTIONS(6210),
    [anon_sym_BSLASHac] = ACTIONS(6210),
    [anon_sym_BSLASHAc] = ACTIONS(6210),
    [anon_sym_BSLASHacp] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6210),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6210),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6210),
    [anon_sym_BSLASHcolor] = ACTIONS(6210),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6210),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6210),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6210),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6210),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6210),
    [anon_sym_BSLASHtext] = ACTIONS(6210),
    [anon_sym_BSLASHintertext] = ACTIONS(6210),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6210),
    [anon_sym_BSLASHurl] = ACTIONS(6210),
    [anon_sym_BSLASHhref] = ACTIONS(6210),
  },
  [452] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(5955),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [anon_sym_RBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [453] = {
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_EQ] = ACTIONS(6216),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [anon_sym_RPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHpart] = ACTIONS(6214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddpart] = ACTIONS(6214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHchapter] = ACTIONS(6214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddchap] = ACTIONS(6214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsection] = ACTIONS(6214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddsec] = ACTIONS(6214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHitem] = ACTIONS(6214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6216),
    [anon_sym_DOLLAR] = ACTIONS(6214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHbegin] = ACTIONS(6214),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHleft] = ACTIONS(6214),
    [anon_sym_BSLASHbigl] = ACTIONS(6214),
    [anon_sym_BSLASHBigl] = ACTIONS(6214),
    [anon_sym_BSLASHbiggl] = ACTIONS(6214),
    [anon_sym_BSLASHBiggl] = ACTIONS(6214),
    [anon_sym_BSLASHright] = ACTIONS(6214),
    [anon_sym_BSLASHbigr] = ACTIONS(6214),
    [anon_sym_BSLASHBigr] = ACTIONS(6214),
    [anon_sym_BSLASHbiggr] = ACTIONS(6214),
    [anon_sym_BSLASHBiggr] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHtext] = ACTIONS(6214),
    [anon_sym_BSLASHintertext] = ACTIONS(6214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [454] = {
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6220),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHpart] = ACTIONS(6218),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddpart] = ACTIONS(6218),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHchapter] = ACTIONS(6218),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddchap] = ACTIONS(6218),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsection] = ACTIONS(6218),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddsec] = ACTIONS(6218),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHitem] = ACTIONS(6218),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6220),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6220),
    [anon_sym_DOLLAR] = ACTIONS(6218),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHbegin] = ACTIONS(6218),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHleft] = ACTIONS(6218),
    [anon_sym_BSLASHbigl] = ACTIONS(6218),
    [anon_sym_BSLASHBigl] = ACTIONS(6218),
    [anon_sym_BSLASHbiggl] = ACTIONS(6218),
    [anon_sym_BSLASHBiggl] = ACTIONS(6218),
    [anon_sym_BSLASHright] = ACTIONS(6218),
    [anon_sym_BSLASHbigr] = ACTIONS(6218),
    [anon_sym_BSLASHBigr] = ACTIONS(6218),
    [anon_sym_BSLASHbiggr] = ACTIONS(6218),
    [anon_sym_BSLASHBiggr] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHtext] = ACTIONS(6218),
    [anon_sym_BSLASHintertext] = ACTIONS(6218),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [455] = {
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6224),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_LPAREN] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHpart] = ACTIONS(6222),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddpart] = ACTIONS(6222),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHchapter] = ACTIONS(6222),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddchap] = ACTIONS(6222),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsection] = ACTIONS(6222),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddsec] = ACTIONS(6222),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHitem] = ACTIONS(6222),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6224),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6224),
    [anon_sym_DOLLAR] = ACTIONS(6222),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHbegin] = ACTIONS(6222),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHleft] = ACTIONS(6222),
    [anon_sym_BSLASHbigl] = ACTIONS(6222),
    [anon_sym_BSLASHBigl] = ACTIONS(6222),
    [anon_sym_BSLASHbiggl] = ACTIONS(6222),
    [anon_sym_BSLASHBiggl] = ACTIONS(6222),
    [anon_sym_BSLASHright] = ACTIONS(6222),
    [anon_sym_BSLASHbigr] = ACTIONS(6222),
    [anon_sym_BSLASHBigr] = ACTIONS(6222),
    [anon_sym_BSLASHbiggr] = ACTIONS(6222),
    [anon_sym_BSLASHBiggr] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHtext] = ACTIONS(6222),
    [anon_sym_BSLASHintertext] = ACTIONS(6222),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [456] = {
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6228),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_LPAREN] = ACTIONS(6228),
    [anon_sym_RPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHpart] = ACTIONS(6226),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddpart] = ACTIONS(6226),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHchapter] = ACTIONS(6226),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddchap] = ACTIONS(6226),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsection] = ACTIONS(6226),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddsec] = ACTIONS(6226),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHitem] = ACTIONS(6226),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(6228),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6228),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(6226),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHbegin] = ACTIONS(6226),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHleft] = ACTIONS(6226),
    [anon_sym_BSLASHbigl] = ACTIONS(6226),
    [anon_sym_BSLASHBigl] = ACTIONS(6226),
    [anon_sym_BSLASHbiggl] = ACTIONS(6226),
    [anon_sym_BSLASHBiggl] = ACTIONS(6226),
    [anon_sym_BSLASHright] = ACTIONS(6226),
    [anon_sym_BSLASHbigr] = ACTIONS(6226),
    [anon_sym_BSLASHBigr] = ACTIONS(6226),
    [anon_sym_BSLASHbiggr] = ACTIONS(6226),
    [anon_sym_BSLASHBiggr] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHtext] = ACTIONS(6226),
    [anon_sym_BSLASHintertext] = ACTIONS(6226),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [457] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(6079),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [anon_sym_RBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [458] = {
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6232),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6232),
    [anon_sym_LPAREN] = ACTIONS(6232),
    [anon_sym_RPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHpart] = ACTIONS(6230),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddpart] = ACTIONS(6230),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHchapter] = ACTIONS(6230),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddchap] = ACTIONS(6230),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsection] = ACTIONS(6230),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddsec] = ACTIONS(6230),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHitem] = ACTIONS(6230),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6232),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6232),
    [anon_sym_DOLLAR] = ACTIONS(6230),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHbegin] = ACTIONS(6230),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHleft] = ACTIONS(6230),
    [anon_sym_BSLASHbigl] = ACTIONS(6230),
    [anon_sym_BSLASHBigl] = ACTIONS(6230),
    [anon_sym_BSLASHbiggl] = ACTIONS(6230),
    [anon_sym_BSLASHBiggl] = ACTIONS(6230),
    [anon_sym_BSLASHright] = ACTIONS(6230),
    [anon_sym_BSLASHbigr] = ACTIONS(6230),
    [anon_sym_BSLASHBigr] = ACTIONS(6230),
    [anon_sym_BSLASHbiggr] = ACTIONS(6230),
    [anon_sym_BSLASHBiggr] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHtext] = ACTIONS(6230),
    [anon_sym_BSLASHintertext] = ACTIONS(6230),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [459] = {
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_LPAREN] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHpart] = ACTIONS(6234),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddpart] = ACTIONS(6234),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHchapter] = ACTIONS(6234),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddchap] = ACTIONS(6234),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsection] = ACTIONS(6234),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddsec] = ACTIONS(6234),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHitem] = ACTIONS(6234),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6236),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(6234),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHbegin] = ACTIONS(6234),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHleft] = ACTIONS(6234),
    [anon_sym_BSLASHbigl] = ACTIONS(6234),
    [anon_sym_BSLASHBigl] = ACTIONS(6234),
    [anon_sym_BSLASHbiggl] = ACTIONS(6234),
    [anon_sym_BSLASHBiggl] = ACTIONS(6234),
    [anon_sym_BSLASHright] = ACTIONS(6234),
    [anon_sym_BSLASHbigr] = ACTIONS(6234),
    [anon_sym_BSLASHBigr] = ACTIONS(6234),
    [anon_sym_BSLASHbiggr] = ACTIONS(6234),
    [anon_sym_BSLASHBiggr] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHtext] = ACTIONS(6234),
    [anon_sym_BSLASHintertext] = ACTIONS(6234),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [460] = {
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6240),
    [anon_sym_RBRACK] = ACTIONS(6240),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_LPAREN] = ACTIONS(6240),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHpart] = ACTIONS(6238),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddpart] = ACTIONS(6238),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHchapter] = ACTIONS(6238),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddchap] = ACTIONS(6238),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsection] = ACTIONS(6238),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddsec] = ACTIONS(6238),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHitem] = ACTIONS(6238),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(6240),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6240),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6240),
    [anon_sym_DOLLAR] = ACTIONS(6238),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHbegin] = ACTIONS(6238),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHleft] = ACTIONS(6238),
    [anon_sym_BSLASHbigl] = ACTIONS(6238),
    [anon_sym_BSLASHBigl] = ACTIONS(6238),
    [anon_sym_BSLASHbiggl] = ACTIONS(6238),
    [anon_sym_BSLASHBiggl] = ACTIONS(6238),
    [anon_sym_BSLASHright] = ACTIONS(6238),
    [anon_sym_BSLASHbigr] = ACTIONS(6238),
    [anon_sym_BSLASHBigr] = ACTIONS(6238),
    [anon_sym_BSLASHbiggr] = ACTIONS(6238),
    [anon_sym_BSLASHBiggr] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHtext] = ACTIONS(6238),
    [anon_sym_BSLASHintertext] = ACTIONS(6238),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [461] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(6079),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [anon_sym_RBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [462] = {
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6244),
    [anon_sym_RBRACK] = ACTIONS(6244),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_LPAREN] = ACTIONS(6244),
    [anon_sym_RPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHpart] = ACTIONS(6242),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddpart] = ACTIONS(6242),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHchapter] = ACTIONS(6242),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddchap] = ACTIONS(6242),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsection] = ACTIONS(6242),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddsec] = ACTIONS(6242),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHitem] = ACTIONS(6242),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6244),
    [anon_sym_LBRACE] = ACTIONS(6244),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6244),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6244),
    [anon_sym_DOLLAR] = ACTIONS(6242),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHbegin] = ACTIONS(6242),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHleft] = ACTIONS(6242),
    [anon_sym_BSLASHbigl] = ACTIONS(6242),
    [anon_sym_BSLASHBigl] = ACTIONS(6242),
    [anon_sym_BSLASHbiggl] = ACTIONS(6242),
    [anon_sym_BSLASHBiggl] = ACTIONS(6242),
    [anon_sym_BSLASHright] = ACTIONS(6242),
    [anon_sym_BSLASHbigr] = ACTIONS(6242),
    [anon_sym_BSLASHBigr] = ACTIONS(6242),
    [anon_sym_BSLASHbiggr] = ACTIONS(6242),
    [anon_sym_BSLASHBiggr] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHtext] = ACTIONS(6242),
    [anon_sym_BSLASHintertext] = ACTIONS(6242),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [463] = {
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_COMMA] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_LPAREN] = ACTIONS(6248),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHpart] = ACTIONS(6246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddpart] = ACTIONS(6246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHchapter] = ACTIONS(6246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddchap] = ACTIONS(6246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsection] = ACTIONS(6246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddsec] = ACTIONS(6246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHitem] = ACTIONS(6246),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6248),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6248),
    [anon_sym_DOLLAR] = ACTIONS(6246),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHbegin] = ACTIONS(6246),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHleft] = ACTIONS(6246),
    [anon_sym_BSLASHbigl] = ACTIONS(6246),
    [anon_sym_BSLASHBigl] = ACTIONS(6246),
    [anon_sym_BSLASHbiggl] = ACTIONS(6246),
    [anon_sym_BSLASHBiggl] = ACTIONS(6246),
    [anon_sym_BSLASHright] = ACTIONS(6246),
    [anon_sym_BSLASHbigr] = ACTIONS(6246),
    [anon_sym_BSLASHBigr] = ACTIONS(6246),
    [anon_sym_BSLASHbiggr] = ACTIONS(6246),
    [anon_sym_BSLASHBiggr] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHtext] = ACTIONS(6246),
    [anon_sym_BSLASHintertext] = ACTIONS(6246),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [464] = {
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(631),
    [aux_sym__paragraph_repeat1] = STATE(631),
    [ts_builtin_sym_end] = ACTIONS(6059),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(33),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(35),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [465] = {
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(600),
    [aux_sym__paragraph_repeat2] = STATE(600),
    [ts_builtin_sym_end] = ACTIONS(6059),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [466] = {
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6252),
    [anon_sym_LPAREN] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHpart] = ACTIONS(6250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddpart] = ACTIONS(6250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHchapter] = ACTIONS(6250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddchap] = ACTIONS(6250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsection] = ACTIONS(6250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddsec] = ACTIONS(6250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHitem] = ACTIONS(6250),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHbegin] = ACTIONS(6250),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHleft] = ACTIONS(6250),
    [anon_sym_BSLASHbigl] = ACTIONS(6250),
    [anon_sym_BSLASHBigl] = ACTIONS(6250),
    [anon_sym_BSLASHbiggl] = ACTIONS(6250),
    [anon_sym_BSLASHBiggl] = ACTIONS(6250),
    [anon_sym_BSLASHright] = ACTIONS(6250),
    [anon_sym_BSLASHbigr] = ACTIONS(6250),
    [anon_sym_BSLASHBigr] = ACTIONS(6250),
    [anon_sym_BSLASHbiggr] = ACTIONS(6250),
    [anon_sym_BSLASHBiggr] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHtext] = ACTIONS(6250),
    [anon_sym_BSLASHintertext] = ACTIONS(6250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
  [467] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(5955),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [anon_sym_RBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [468] = {
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(596),
    [aux_sym__paragraph_repeat3] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(6059),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [anon_sym_RBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [469] = {
    [sym_command_name] = ACTIONS(6254),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6254),
    [anon_sym_LBRACK] = ACTIONS(6256),
    [anon_sym_RBRACK] = ACTIONS(6256),
    [anon_sym_COMMA] = ACTIONS(6256),
    [anon_sym_EQ] = ACTIONS(6256),
    [anon_sym_LPAREN] = ACTIONS(6256),
    [anon_sym_RPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHpart] = ACTIONS(6254),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddpart] = ACTIONS(6254),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHchapter] = ACTIONS(6254),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddchap] = ACTIONS(6254),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsection] = ACTIONS(6254),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddsec] = ACTIONS(6254),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHitem] = ACTIONS(6254),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6256),
    [anon_sym_LBRACE] = ACTIONS(6256),
    [sym_word] = ACTIONS(6254),
    [sym_placeholder] = ACTIONS(6256),
    [anon_sym_PLUS] = ACTIONS(6256),
    [anon_sym_DASH] = ACTIONS(6256),
    [anon_sym_STAR] = ACTIONS(6256),
    [anon_sym_SLASH] = ACTIONS(6256),
    [anon_sym_LT] = ACTIONS(6254),
    [anon_sym_GT] = ACTIONS(6254),
    [anon_sym_BANG] = ACTIONS(6254),
    [anon_sym_PIPE] = ACTIONS(6254),
    [anon_sym_COLON] = ACTIONS(6254),
    [anon_sym_SQUOTE] = ACTIONS(6254),
    [anon_sym__] = ACTIONS(6256),
    [anon_sym_CARET] = ACTIONS(6256),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6256),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6256),
    [anon_sym_DOLLAR] = ACTIONS(6254),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHbegin] = ACTIONS(6254),
    [anon_sym_BSLASHtitle] = ACTIONS(6254),
    [anon_sym_BSLASHauthor] = ACTIONS(6254),
    [anon_sym_BSLASHusepackage] = ACTIONS(6254),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6254),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6254),
    [anon_sym_BSLASHinclude] = ACTIONS(6254),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6254),
    [anon_sym_BSLASHinput] = ACTIONS(6254),
    [anon_sym_BSLASHsubfile] = ACTIONS(6254),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6254),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6254),
    [anon_sym_BSLASHbibliography] = ACTIONS(6254),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6254),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6254),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6254),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6254),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6254),
    [anon_sym_BSLASHimport] = ACTIONS(6254),
    [anon_sym_BSLASHsubimport] = ACTIONS(6254),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6254),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHcaption] = ACTIONS(6254),
    [anon_sym_BSLASHcite] = ACTIONS(6254),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCite] = ACTIONS(6254),
    [anon_sym_BSLASHnocite] = ACTIONS(6254),
    [anon_sym_BSLASHcitet] = ACTIONS(6254),
    [anon_sym_BSLASHcitep] = ACTIONS(6254),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteA] = ACTIONS(6254),
    [anon_sym_BSLASHciteR] = ACTIONS(6254),
    [anon_sym_BSLASHciteS] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6254),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteyear] = ACTIONS(6254),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitedate] = ACTIONS(6254),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteurl] = ACTIONS(6254),
    [anon_sym_BSLASHfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6254),
    [anon_sym_BSLASHcitealt] = ACTIONS(6254),
    [anon_sym_BSLASHcitealp] = ACTIONS(6254),
    [anon_sym_BSLASHcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHparencite] = ACTIONS(6254),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHParencite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHtextcite] = ACTIONS(6254),
    [anon_sym_BSLASHTextcite] = ACTIONS(6254),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHsupercite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite] = ACTIONS(6254),
    [anon_sym_BSLASHAutocite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHVolcite] = ACTIONS(6254),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHavolcite] = ACTIONS(6254),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHNotecite] = ACTIONS(6254),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHlabel] = ACTIONS(6254),
    [anon_sym_BSLASHref] = ACTIONS(6254),
    [anon_sym_BSLASHeqref] = ACTIONS(6254),
    [anon_sym_BSLASHvref] = ACTIONS(6254),
    [anon_sym_BSLASHVref] = ACTIONS(6254),
    [anon_sym_BSLASHautoref] = ACTIONS(6254),
    [anon_sym_BSLASHpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcref] = ACTIONS(6254),
    [anon_sym_BSLASHCref] = ACTIONS(6254),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnameCref] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHdef] = ACTIONS(6254),
    [anon_sym_BSLASHlet] = ACTIONS(6254),
    [anon_sym_BSLASHleft] = ACTIONS(6254),
    [anon_sym_BSLASHbigl] = ACTIONS(6254),
    [anon_sym_BSLASHBigl] = ACTIONS(6254),
    [anon_sym_BSLASHbiggl] = ACTIONS(6254),
    [anon_sym_BSLASHBiggl] = ACTIONS(6254),
    [anon_sym_BSLASHright] = ACTIONS(6254),
    [anon_sym_BSLASHbigr] = ACTIONS(6254),
    [anon_sym_BSLASHBigr] = ACTIONS(6254),
    [anon_sym_BSLASHbiggr] = ACTIONS(6254),
    [anon_sym_BSLASHBiggr] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6254),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6254),
    [anon_sym_BSLASHgls] = ACTIONS(6254),
    [anon_sym_BSLASHGls] = ACTIONS(6254),
    [anon_sym_BSLASHGLS] = ACTIONS(6254),
    [anon_sym_BSLASHglspl] = ACTIONS(6254),
    [anon_sym_BSLASHGlspl] = ACTIONS(6254),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6254),
    [anon_sym_BSLASHglslink] = ACTIONS(6254),
    [anon_sym_BSLASHglstext] = ACTIONS(6254),
    [anon_sym_BSLASHGlstext] = ACTIONS(6254),
    [anon_sym_BSLASHGLStext] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6254),
    [anon_sym_BSLASHglsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsname] = ACTIONS(6254),
    [anon_sym_BSLASHGlsname] = ACTIONS(6254),
    [anon_sym_BSLASHGLSname] = ACTIONS(6254),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6254),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6254),
    [anon_sym_BSLASHacrshort] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6254),
    [anon_sym_BSLASHACRshort] = ACTIONS(6254),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrlong] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6254),
    [anon_sym_BSLASHACRlong] = ACTIONS(6254),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrfull] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6254),
    [anon_sym_BSLASHACRfull] = ACTIONS(6254),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHacs] = ACTIONS(6254),
    [anon_sym_BSLASHAcs] = ACTIONS(6254),
    [anon_sym_BSLASHacsp] = ACTIONS(6254),
    [anon_sym_BSLASHAcsp] = ACTIONS(6254),
    [anon_sym_BSLASHacl] = ACTIONS(6254),
    [anon_sym_BSLASHAcl] = ACTIONS(6254),
    [anon_sym_BSLASHaclp] = ACTIONS(6254),
    [anon_sym_BSLASHAclp] = ACTIONS(6254),
    [anon_sym_BSLASHacf] = ACTIONS(6254),
    [anon_sym_BSLASHAcf] = ACTIONS(6254),
    [anon_sym_BSLASHacfp] = ACTIONS(6254),
    [anon_sym_BSLASHAcfp] = ACTIONS(6254),
    [anon_sym_BSLASHac] = ACTIONS(6254),
    [anon_sym_BSLASHAc] = ACTIONS(6254),
    [anon_sym_BSLASHacp] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6254),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6254),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6254),
    [anon_sym_BSLASHcolor] = ACTIONS(6254),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6254),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6254),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6254),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6254),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6254),
    [anon_sym_BSLASHtext] = ACTIONS(6254),
    [anon_sym_BSLASHintertext] = ACTIONS(6254),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6254),
    [anon_sym_BSLASHurl] = ACTIONS(6254),
    [anon_sym_BSLASHhref] = ACTIONS(6254),
  },
  [470] = {
    [sym_command_name] = ACTIONS(6258),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6258),
    [anon_sym_LBRACK] = ACTIONS(6260),
    [anon_sym_RBRACK] = ACTIONS(6260),
    [anon_sym_COMMA] = ACTIONS(6260),
    [anon_sym_EQ] = ACTIONS(6260),
    [anon_sym_LPAREN] = ACTIONS(6260),
    [anon_sym_RPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHpart] = ACTIONS(6258),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddpart] = ACTIONS(6258),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHchapter] = ACTIONS(6258),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddchap] = ACTIONS(6258),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsection] = ACTIONS(6258),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddsec] = ACTIONS(6258),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHitem] = ACTIONS(6258),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6260),
    [anon_sym_LBRACE] = ACTIONS(6260),
    [sym_word] = ACTIONS(6258),
    [sym_placeholder] = ACTIONS(6260),
    [anon_sym_PLUS] = ACTIONS(6260),
    [anon_sym_DASH] = ACTIONS(6260),
    [anon_sym_STAR] = ACTIONS(6260),
    [anon_sym_SLASH] = ACTIONS(6260),
    [anon_sym_LT] = ACTIONS(6258),
    [anon_sym_GT] = ACTIONS(6258),
    [anon_sym_BANG] = ACTIONS(6258),
    [anon_sym_PIPE] = ACTIONS(6258),
    [anon_sym_COLON] = ACTIONS(6258),
    [anon_sym_SQUOTE] = ACTIONS(6258),
    [anon_sym__] = ACTIONS(6260),
    [anon_sym_CARET] = ACTIONS(6260),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6260),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6260),
    [anon_sym_DOLLAR] = ACTIONS(6258),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHbegin] = ACTIONS(6258),
    [anon_sym_BSLASHtitle] = ACTIONS(6258),
    [anon_sym_BSLASHauthor] = ACTIONS(6258),
    [anon_sym_BSLASHusepackage] = ACTIONS(6258),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6258),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6258),
    [anon_sym_BSLASHinclude] = ACTIONS(6258),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6258),
    [anon_sym_BSLASHinput] = ACTIONS(6258),
    [anon_sym_BSLASHsubfile] = ACTIONS(6258),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6258),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6258),
    [anon_sym_BSLASHbibliography] = ACTIONS(6258),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6258),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6258),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6258),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6258),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6258),
    [anon_sym_BSLASHimport] = ACTIONS(6258),
    [anon_sym_BSLASHsubimport] = ACTIONS(6258),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6258),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHcaption] = ACTIONS(6258),
    [anon_sym_BSLASHcite] = ACTIONS(6258),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCite] = ACTIONS(6258),
    [anon_sym_BSLASHnocite] = ACTIONS(6258),
    [anon_sym_BSLASHcitet] = ACTIONS(6258),
    [anon_sym_BSLASHcitep] = ACTIONS(6258),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteA] = ACTIONS(6258),
    [anon_sym_BSLASHciteR] = ACTIONS(6258),
    [anon_sym_BSLASHciteS] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6258),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteyear] = ACTIONS(6258),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitedate] = ACTIONS(6258),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteurl] = ACTIONS(6258),
    [anon_sym_BSLASHfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6258),
    [anon_sym_BSLASHcitealt] = ACTIONS(6258),
    [anon_sym_BSLASHcitealp] = ACTIONS(6258),
    [anon_sym_BSLASHcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHparencite] = ACTIONS(6258),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHParencite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHtextcite] = ACTIONS(6258),
    [anon_sym_BSLASHTextcite] = ACTIONS(6258),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHsupercite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite] = ACTIONS(6258),
    [anon_sym_BSLASHAutocite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHVolcite] = ACTIONS(6258),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHavolcite] = ACTIONS(6258),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHNotecite] = ACTIONS(6258),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHlabel] = ACTIONS(6258),
    [anon_sym_BSLASHref] = ACTIONS(6258),
    [anon_sym_BSLASHeqref] = ACTIONS(6258),
    [anon_sym_BSLASHvref] = ACTIONS(6258),
    [anon_sym_BSLASHVref] = ACTIONS(6258),
    [anon_sym_BSLASHautoref] = ACTIONS(6258),
    [anon_sym_BSLASHpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcref] = ACTIONS(6258),
    [anon_sym_BSLASHCref] = ACTIONS(6258),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnameCref] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHdef] = ACTIONS(6258),
    [anon_sym_BSLASHlet] = ACTIONS(6258),
    [anon_sym_BSLASHleft] = ACTIONS(6258),
    [anon_sym_BSLASHbigl] = ACTIONS(6258),
    [anon_sym_BSLASHBigl] = ACTIONS(6258),
    [anon_sym_BSLASHbiggl] = ACTIONS(6258),
    [anon_sym_BSLASHBiggl] = ACTIONS(6258),
    [anon_sym_BSLASHright] = ACTIONS(6258),
    [anon_sym_BSLASHbigr] = ACTIONS(6258),
    [anon_sym_BSLASHBigr] = ACTIONS(6258),
    [anon_sym_BSLASHbiggr] = ACTIONS(6258),
    [anon_sym_BSLASHBiggr] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6258),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6258),
    [anon_sym_BSLASHgls] = ACTIONS(6258),
    [anon_sym_BSLASHGls] = ACTIONS(6258),
    [anon_sym_BSLASHGLS] = ACTIONS(6258),
    [anon_sym_BSLASHglspl] = ACTIONS(6258),
    [anon_sym_BSLASHGlspl] = ACTIONS(6258),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6258),
    [anon_sym_BSLASHglslink] = ACTIONS(6258),
    [anon_sym_BSLASHglstext] = ACTIONS(6258),
    [anon_sym_BSLASHGlstext] = ACTIONS(6258),
    [anon_sym_BSLASHGLStext] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6258),
    [anon_sym_BSLASHglsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsname] = ACTIONS(6258),
    [anon_sym_BSLASHGlsname] = ACTIONS(6258),
    [anon_sym_BSLASHGLSname] = ACTIONS(6258),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6258),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6258),
    [anon_sym_BSLASHacrshort] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6258),
    [anon_sym_BSLASHACRshort] = ACTIONS(6258),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrlong] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6258),
    [anon_sym_BSLASHACRlong] = ACTIONS(6258),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrfull] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6258),
    [anon_sym_BSLASHACRfull] = ACTIONS(6258),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHacs] = ACTIONS(6258),
    [anon_sym_BSLASHAcs] = ACTIONS(6258),
    [anon_sym_BSLASHacsp] = ACTIONS(6258),
    [anon_sym_BSLASHAcsp] = ACTIONS(6258),
    [anon_sym_BSLASHacl] = ACTIONS(6258),
    [anon_sym_BSLASHAcl] = ACTIONS(6258),
    [anon_sym_BSLASHaclp] = ACTIONS(6258),
    [anon_sym_BSLASHAclp] = ACTIONS(6258),
    [anon_sym_BSLASHacf] = ACTIONS(6258),
    [anon_sym_BSLASHAcf] = ACTIONS(6258),
    [anon_sym_BSLASHacfp] = ACTIONS(6258),
    [anon_sym_BSLASHAcfp] = ACTIONS(6258),
    [anon_sym_BSLASHac] = ACTIONS(6258),
    [anon_sym_BSLASHAc] = ACTIONS(6258),
    [anon_sym_BSLASHacp] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6258),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6258),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6258),
    [anon_sym_BSLASHcolor] = ACTIONS(6258),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6258),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6258),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6258),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6258),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6258),
    [anon_sym_BSLASHtext] = ACTIONS(6258),
    [anon_sym_BSLASHintertext] = ACTIONS(6258),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6258),
    [anon_sym_BSLASHurl] = ACTIONS(6258),
    [anon_sym_BSLASHhref] = ACTIONS(6258),
  },
  [471] = {
    [sym_command_name] = ACTIONS(6262),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6262),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_RBRACK] = ACTIONS(6264),
    [anon_sym_COMMA] = ACTIONS(6264),
    [anon_sym_EQ] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(6264),
    [anon_sym_RPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHpart] = ACTIONS(6262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddpart] = ACTIONS(6262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHchapter] = ACTIONS(6262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddchap] = ACTIONS(6262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsection] = ACTIONS(6262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddsec] = ACTIONS(6262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHitem] = ACTIONS(6262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6264),
    [anon_sym_LBRACE] = ACTIONS(6264),
    [sym_word] = ACTIONS(6262),
    [sym_placeholder] = ACTIONS(6264),
    [anon_sym_PLUS] = ACTIONS(6264),
    [anon_sym_DASH] = ACTIONS(6264),
    [anon_sym_STAR] = ACTIONS(6264),
    [anon_sym_SLASH] = ACTIONS(6264),
    [anon_sym_LT] = ACTIONS(6262),
    [anon_sym_GT] = ACTIONS(6262),
    [anon_sym_BANG] = ACTIONS(6262),
    [anon_sym_PIPE] = ACTIONS(6262),
    [anon_sym_COLON] = ACTIONS(6262),
    [anon_sym_SQUOTE] = ACTIONS(6262),
    [anon_sym__] = ACTIONS(6264),
    [anon_sym_CARET] = ACTIONS(6264),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6264),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6264),
    [anon_sym_DOLLAR] = ACTIONS(6262),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHbegin] = ACTIONS(6262),
    [anon_sym_BSLASHtitle] = ACTIONS(6262),
    [anon_sym_BSLASHauthor] = ACTIONS(6262),
    [anon_sym_BSLASHusepackage] = ACTIONS(6262),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6262),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6262),
    [anon_sym_BSLASHinclude] = ACTIONS(6262),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6262),
    [anon_sym_BSLASHinput] = ACTIONS(6262),
    [anon_sym_BSLASHsubfile] = ACTIONS(6262),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6262),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6262),
    [anon_sym_BSLASHbibliography] = ACTIONS(6262),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6262),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6262),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6262),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6262),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6262),
    [anon_sym_BSLASHimport] = ACTIONS(6262),
    [anon_sym_BSLASHsubimport] = ACTIONS(6262),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6262),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHcaption] = ACTIONS(6262),
    [anon_sym_BSLASHcite] = ACTIONS(6262),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCite] = ACTIONS(6262),
    [anon_sym_BSLASHnocite] = ACTIONS(6262),
    [anon_sym_BSLASHcitet] = ACTIONS(6262),
    [anon_sym_BSLASHcitep] = ACTIONS(6262),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteA] = ACTIONS(6262),
    [anon_sym_BSLASHciteR] = ACTIONS(6262),
    [anon_sym_BSLASHciteS] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6262),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteyear] = ACTIONS(6262),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitedate] = ACTIONS(6262),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteurl] = ACTIONS(6262),
    [anon_sym_BSLASHfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6262),
    [anon_sym_BSLASHcitealt] = ACTIONS(6262),
    [anon_sym_BSLASHcitealp] = ACTIONS(6262),
    [anon_sym_BSLASHcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHparencite] = ACTIONS(6262),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHParencite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHtextcite] = ACTIONS(6262),
    [anon_sym_BSLASHTextcite] = ACTIONS(6262),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHsupercite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite] = ACTIONS(6262),
    [anon_sym_BSLASHAutocite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHVolcite] = ACTIONS(6262),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHavolcite] = ACTIONS(6262),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHNotecite] = ACTIONS(6262),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHlabel] = ACTIONS(6262),
    [anon_sym_BSLASHref] = ACTIONS(6262),
    [anon_sym_BSLASHeqref] = ACTIONS(6262),
    [anon_sym_BSLASHvref] = ACTIONS(6262),
    [anon_sym_BSLASHVref] = ACTIONS(6262),
    [anon_sym_BSLASHautoref] = ACTIONS(6262),
    [anon_sym_BSLASHpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcref] = ACTIONS(6262),
    [anon_sym_BSLASHCref] = ACTIONS(6262),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnameCref] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHdef] = ACTIONS(6262),
    [anon_sym_BSLASHlet] = ACTIONS(6262),
    [anon_sym_BSLASHleft] = ACTIONS(6262),
    [anon_sym_BSLASHbigl] = ACTIONS(6262),
    [anon_sym_BSLASHBigl] = ACTIONS(6262),
    [anon_sym_BSLASHbiggl] = ACTIONS(6262),
    [anon_sym_BSLASHBiggl] = ACTIONS(6262),
    [anon_sym_BSLASHright] = ACTIONS(6262),
    [anon_sym_BSLASHbigr] = ACTIONS(6262),
    [anon_sym_BSLASHBigr] = ACTIONS(6262),
    [anon_sym_BSLASHbiggr] = ACTIONS(6262),
    [anon_sym_BSLASHBiggr] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6262),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6262),
    [anon_sym_BSLASHgls] = ACTIONS(6262),
    [anon_sym_BSLASHGls] = ACTIONS(6262),
    [anon_sym_BSLASHGLS] = ACTIONS(6262),
    [anon_sym_BSLASHglspl] = ACTIONS(6262),
    [anon_sym_BSLASHGlspl] = ACTIONS(6262),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6262),
    [anon_sym_BSLASHglslink] = ACTIONS(6262),
    [anon_sym_BSLASHglstext] = ACTIONS(6262),
    [anon_sym_BSLASHGlstext] = ACTIONS(6262),
    [anon_sym_BSLASHGLStext] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6262),
    [anon_sym_BSLASHglsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsname] = ACTIONS(6262),
    [anon_sym_BSLASHGlsname] = ACTIONS(6262),
    [anon_sym_BSLASHGLSname] = ACTIONS(6262),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6262),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6262),
    [anon_sym_BSLASHacrshort] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6262),
    [anon_sym_BSLASHACRshort] = ACTIONS(6262),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrlong] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6262),
    [anon_sym_BSLASHACRlong] = ACTIONS(6262),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrfull] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6262),
    [anon_sym_BSLASHACRfull] = ACTIONS(6262),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHacs] = ACTIONS(6262),
    [anon_sym_BSLASHAcs] = ACTIONS(6262),
    [anon_sym_BSLASHacsp] = ACTIONS(6262),
    [anon_sym_BSLASHAcsp] = ACTIONS(6262),
    [anon_sym_BSLASHacl] = ACTIONS(6262),
    [anon_sym_BSLASHAcl] = ACTIONS(6262),
    [anon_sym_BSLASHaclp] = ACTIONS(6262),
    [anon_sym_BSLASHAclp] = ACTIONS(6262),
    [anon_sym_BSLASHacf] = ACTIONS(6262),
    [anon_sym_BSLASHAcf] = ACTIONS(6262),
    [anon_sym_BSLASHacfp] = ACTIONS(6262),
    [anon_sym_BSLASHAcfp] = ACTIONS(6262),
    [anon_sym_BSLASHac] = ACTIONS(6262),
    [anon_sym_BSLASHAc] = ACTIONS(6262),
    [anon_sym_BSLASHacp] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6262),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6262),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6262),
    [anon_sym_BSLASHcolor] = ACTIONS(6262),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6262),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6262),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6262),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6262),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6262),
    [anon_sym_BSLASHtext] = ACTIONS(6262),
    [anon_sym_BSLASHintertext] = ACTIONS(6262),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6262),
    [anon_sym_BSLASHurl] = ACTIONS(6262),
    [anon_sym_BSLASHhref] = ACTIONS(6262),
  },
  [472] = {
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_COMMA] = ACTIONS(6268),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_LPAREN] = ACTIONS(6268),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHpart] = ACTIONS(6266),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddpart] = ACTIONS(6266),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHchapter] = ACTIONS(6266),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddchap] = ACTIONS(6266),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsection] = ACTIONS(6266),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddsec] = ACTIONS(6266),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHitem] = ACTIONS(6266),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6268),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(6266),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHbegin] = ACTIONS(6266),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHleft] = ACTIONS(6266),
    [anon_sym_BSLASHbigl] = ACTIONS(6266),
    [anon_sym_BSLASHBigl] = ACTIONS(6266),
    [anon_sym_BSLASHbiggl] = ACTIONS(6266),
    [anon_sym_BSLASHBiggl] = ACTIONS(6266),
    [anon_sym_BSLASHright] = ACTIONS(6266),
    [anon_sym_BSLASHbigr] = ACTIONS(6266),
    [anon_sym_BSLASHBigr] = ACTIONS(6266),
    [anon_sym_BSLASHbiggr] = ACTIONS(6266),
    [anon_sym_BSLASHBiggr] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHtext] = ACTIONS(6266),
    [anon_sym_BSLASHintertext] = ACTIONS(6266),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [473] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(5959),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [anon_sym_RBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [474] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(5959),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [anon_sym_RBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [475] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(5959),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [anon_sym_RBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [476] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(6067),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [anon_sym_RBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [477] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(520),
    [aux_sym__section_repeat5] = STATE(520),
    [ts_builtin_sym_end] = ACTIONS(6067),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [anon_sym_RBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [478] = {
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_LBRACK] = ACTIONS(6272),
    [anon_sym_RBRACK] = ACTIONS(6272),
    [anon_sym_COMMA] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_LPAREN] = ACTIONS(6272),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHpart] = ACTIONS(6270),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddpart] = ACTIONS(6270),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHchapter] = ACTIONS(6270),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddchap] = ACTIONS(6270),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsection] = ACTIONS(6270),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddsec] = ACTIONS(6270),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHitem] = ACTIONS(6270),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6272),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6272),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6272),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHbegin] = ACTIONS(6270),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHleft] = ACTIONS(6270),
    [anon_sym_BSLASHbigl] = ACTIONS(6270),
    [anon_sym_BSLASHBigl] = ACTIONS(6270),
    [anon_sym_BSLASHbiggl] = ACTIONS(6270),
    [anon_sym_BSLASHBiggl] = ACTIONS(6270),
    [anon_sym_BSLASHright] = ACTIONS(6270),
    [anon_sym_BSLASHbigr] = ACTIONS(6270),
    [anon_sym_BSLASHBigr] = ACTIONS(6270),
    [anon_sym_BSLASHbiggr] = ACTIONS(6270),
    [anon_sym_BSLASHBiggr] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHtext] = ACTIONS(6270),
    [anon_sym_BSLASHintertext] = ACTIONS(6270),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [479] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(5955),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [anon_sym_RBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [480] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(6067),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [anon_sym_RBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [481] = {
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(600),
    [aux_sym__paragraph_repeat2] = STATE(600),
    [ts_builtin_sym_end] = ACTIONS(6071),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(6069),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6071),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [482] = {
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(596),
    [aux_sym__paragraph_repeat3] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(6071),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [anon_sym_RBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [483] = {
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(596),
    [aux_sym__paragraph_repeat3] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(6075),
    [sym_command_name] = ACTIONS(6073),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6075),
    [anon_sym_RBRACK] = ACTIONS(6075),
    [anon_sym_COMMA] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_LPAREN] = ACTIONS(6075),
    [anon_sym_RPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHpart] = ACTIONS(6073),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddpart] = ACTIONS(6073),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHchapter] = ACTIONS(6073),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddchap] = ACTIONS(6073),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsection] = ACTIONS(6073),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddsec] = ACTIONS(6073),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(6075),
    [anon_sym_RBRACE] = ACTIONS(6075),
    [sym_word] = ACTIONS(6073),
    [sym_placeholder] = ACTIONS(6075),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_DASH] = ACTIONS(6075),
    [anon_sym_STAR] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6073),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_BANG] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6073),
    [anon_sym_COLON] = ACTIONS(6073),
    [anon_sym_SQUOTE] = ACTIONS(6073),
    [anon_sym__] = ACTIONS(6075),
    [anon_sym_CARET] = ACTIONS(6075),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6075),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6075),
    [anon_sym_DOLLAR] = ACTIONS(6073),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHbegin] = ACTIONS(6073),
    [anon_sym_BSLASHtitle] = ACTIONS(6073),
    [anon_sym_BSLASHauthor] = ACTIONS(6073),
    [anon_sym_BSLASHusepackage] = ACTIONS(6073),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6073),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6073),
    [anon_sym_BSLASHinclude] = ACTIONS(6073),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6073),
    [anon_sym_BSLASHinput] = ACTIONS(6073),
    [anon_sym_BSLASHsubfile] = ACTIONS(6073),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6073),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6073),
    [anon_sym_BSLASHbibliography] = ACTIONS(6073),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6073),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6073),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6073),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6073),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6073),
    [anon_sym_BSLASHimport] = ACTIONS(6073),
    [anon_sym_BSLASHsubimport] = ACTIONS(6073),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6073),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHcaption] = ACTIONS(6073),
    [anon_sym_BSLASHcite] = ACTIONS(6073),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCite] = ACTIONS(6073),
    [anon_sym_BSLASHnocite] = ACTIONS(6073),
    [anon_sym_BSLASHcitet] = ACTIONS(6073),
    [anon_sym_BSLASHcitep] = ACTIONS(6073),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteA] = ACTIONS(6073),
    [anon_sym_BSLASHciteR] = ACTIONS(6073),
    [anon_sym_BSLASHciteS] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6073),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteyear] = ACTIONS(6073),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitedate] = ACTIONS(6073),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteurl] = ACTIONS(6073),
    [anon_sym_BSLASHfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6073),
    [anon_sym_BSLASHcitealt] = ACTIONS(6073),
    [anon_sym_BSLASHcitealp] = ACTIONS(6073),
    [anon_sym_BSLASHcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHparencite] = ACTIONS(6073),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHParencite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHtextcite] = ACTIONS(6073),
    [anon_sym_BSLASHTextcite] = ACTIONS(6073),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHsupercite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite] = ACTIONS(6073),
    [anon_sym_BSLASHAutocite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHVolcite] = ACTIONS(6073),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHavolcite] = ACTIONS(6073),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHNotecite] = ACTIONS(6073),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHlabel] = ACTIONS(6073),
    [anon_sym_BSLASHref] = ACTIONS(6073),
    [anon_sym_BSLASHeqref] = ACTIONS(6073),
    [anon_sym_BSLASHvref] = ACTIONS(6073),
    [anon_sym_BSLASHVref] = ACTIONS(6073),
    [anon_sym_BSLASHautoref] = ACTIONS(6073),
    [anon_sym_BSLASHpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcref] = ACTIONS(6073),
    [anon_sym_BSLASHCref] = ACTIONS(6073),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnameCref] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHdef] = ACTIONS(6073),
    [anon_sym_BSLASHlet] = ACTIONS(6073),
    [anon_sym_BSLASHleft] = ACTIONS(6073),
    [anon_sym_BSLASHbigl] = ACTIONS(6073),
    [anon_sym_BSLASHBigl] = ACTIONS(6073),
    [anon_sym_BSLASHbiggl] = ACTIONS(6073),
    [anon_sym_BSLASHBiggl] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6073),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6073),
    [anon_sym_BSLASHgls] = ACTIONS(6073),
    [anon_sym_BSLASHGls] = ACTIONS(6073),
    [anon_sym_BSLASHGLS] = ACTIONS(6073),
    [anon_sym_BSLASHglspl] = ACTIONS(6073),
    [anon_sym_BSLASHGlspl] = ACTIONS(6073),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6073),
    [anon_sym_BSLASHglslink] = ACTIONS(6073),
    [anon_sym_BSLASHglstext] = ACTIONS(6073),
    [anon_sym_BSLASHGlstext] = ACTIONS(6073),
    [anon_sym_BSLASHGLStext] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6073),
    [anon_sym_BSLASHglsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsname] = ACTIONS(6073),
    [anon_sym_BSLASHGlsname] = ACTIONS(6073),
    [anon_sym_BSLASHGLSname] = ACTIONS(6073),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6073),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6073),
    [anon_sym_BSLASHacrshort] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6073),
    [anon_sym_BSLASHACRshort] = ACTIONS(6073),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrlong] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6073),
    [anon_sym_BSLASHACRlong] = ACTIONS(6073),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrfull] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6073),
    [anon_sym_BSLASHACRfull] = ACTIONS(6073),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHacs] = ACTIONS(6073),
    [anon_sym_BSLASHAcs] = ACTIONS(6073),
    [anon_sym_BSLASHacsp] = ACTIONS(6073),
    [anon_sym_BSLASHAcsp] = ACTIONS(6073),
    [anon_sym_BSLASHacl] = ACTIONS(6073),
    [anon_sym_BSLASHAcl] = ACTIONS(6073),
    [anon_sym_BSLASHaclp] = ACTIONS(6073),
    [anon_sym_BSLASHAclp] = ACTIONS(6073),
    [anon_sym_BSLASHacf] = ACTIONS(6073),
    [anon_sym_BSLASHAcf] = ACTIONS(6073),
    [anon_sym_BSLASHacfp] = ACTIONS(6073),
    [anon_sym_BSLASHAcfp] = ACTIONS(6073),
    [anon_sym_BSLASHac] = ACTIONS(6073),
    [anon_sym_BSLASHAc] = ACTIONS(6073),
    [anon_sym_BSLASHacp] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6073),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6073),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6073),
    [anon_sym_BSLASHcolor] = ACTIONS(6073),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6073),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6073),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6073),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6073),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6073),
    [anon_sym_BSLASHtext] = ACTIONS(6073),
    [anon_sym_BSLASHintertext] = ACTIONS(6073),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6073),
    [anon_sym_BSLASHurl] = ACTIONS(6073),
    [anon_sym_BSLASHhref] = ACTIONS(6073),
  },
  [484] = {
    [sym__section_part] = STATE(995),
    [sym_curly_group] = STATE(979),
    [sym_brack_group] = STATE(2882),
    [ts_builtin_sym_end] = ACTIONS(5973),
    [sym_command_name] = ACTIONS(5971),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5971),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5973),
    [anon_sym_COMMA] = ACTIONS(5973),
    [anon_sym_EQ] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(5973),
    [anon_sym_RPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHpart] = ACTIONS(5971),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddpart] = ACTIONS(5971),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHchapter] = ACTIONS(5971),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddchap] = ACTIONS(5971),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsection] = ACTIONS(5971),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddsec] = ACTIONS(5971),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHitem] = ACTIONS(5971),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5973),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(5973),
    [sym_word] = ACTIONS(5971),
    [sym_placeholder] = ACTIONS(5973),
    [anon_sym_PLUS] = ACTIONS(5973),
    [anon_sym_DASH] = ACTIONS(5973),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5973),
    [anon_sym_LT] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5971),
    [anon_sym_BANG] = ACTIONS(5971),
    [anon_sym_PIPE] = ACTIONS(5971),
    [anon_sym_COLON] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(5971),
    [anon_sym__] = ACTIONS(5973),
    [anon_sym_CARET] = ACTIONS(5973),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5973),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5973),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHbegin] = ACTIONS(5971),
    [anon_sym_BSLASHtitle] = ACTIONS(5971),
    [anon_sym_BSLASHauthor] = ACTIONS(5971),
    [anon_sym_BSLASHusepackage] = ACTIONS(5971),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5971),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5971),
    [anon_sym_BSLASHinclude] = ACTIONS(5971),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5971),
    [anon_sym_BSLASHinput] = ACTIONS(5971),
    [anon_sym_BSLASHsubfile] = ACTIONS(5971),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5971),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5971),
    [anon_sym_BSLASHbibliography] = ACTIONS(5971),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5971),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5971),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5971),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5971),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5971),
    [anon_sym_BSLASHimport] = ACTIONS(5971),
    [anon_sym_BSLASHsubimport] = ACTIONS(5971),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5971),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHcaption] = ACTIONS(5971),
    [anon_sym_BSLASHcite] = ACTIONS(5971),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCite] = ACTIONS(5971),
    [anon_sym_BSLASHnocite] = ACTIONS(5971),
    [anon_sym_BSLASHcitet] = ACTIONS(5971),
    [anon_sym_BSLASHcitep] = ACTIONS(5971),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteA] = ACTIONS(5971),
    [anon_sym_BSLASHciteR] = ACTIONS(5971),
    [anon_sym_BSLASHciteS] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5971),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteyear] = ACTIONS(5971),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitedate] = ACTIONS(5971),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteurl] = ACTIONS(5971),
    [anon_sym_BSLASHfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5971),
    [anon_sym_BSLASHcitealt] = ACTIONS(5971),
    [anon_sym_BSLASHcitealp] = ACTIONS(5971),
    [anon_sym_BSLASHcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHparencite] = ACTIONS(5971),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHParencite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHtextcite] = ACTIONS(5971),
    [anon_sym_BSLASHTextcite] = ACTIONS(5971),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHsupercite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite] = ACTIONS(5971),
    [anon_sym_BSLASHAutocite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHVolcite] = ACTIONS(5971),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHavolcite] = ACTIONS(5971),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHNotecite] = ACTIONS(5971),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHlabel] = ACTIONS(5971),
    [anon_sym_BSLASHref] = ACTIONS(5971),
    [anon_sym_BSLASHeqref] = ACTIONS(5971),
    [anon_sym_BSLASHvref] = ACTIONS(5971),
    [anon_sym_BSLASHVref] = ACTIONS(5971),
    [anon_sym_BSLASHautoref] = ACTIONS(5971),
    [anon_sym_BSLASHpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcref] = ACTIONS(5971),
    [anon_sym_BSLASHCref] = ACTIONS(5971),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnameCref] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHdef] = ACTIONS(5971),
    [anon_sym_BSLASHlet] = ACTIONS(5971),
    [anon_sym_BSLASHleft] = ACTIONS(5971),
    [anon_sym_BSLASHbigl] = ACTIONS(5971),
    [anon_sym_BSLASHBigl] = ACTIONS(5971),
    [anon_sym_BSLASHbiggl] = ACTIONS(5971),
    [anon_sym_BSLASHBiggl] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5971),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5971),
    [anon_sym_BSLASHgls] = ACTIONS(5971),
    [anon_sym_BSLASHGls] = ACTIONS(5971),
    [anon_sym_BSLASHGLS] = ACTIONS(5971),
    [anon_sym_BSLASHglspl] = ACTIONS(5971),
    [anon_sym_BSLASHGlspl] = ACTIONS(5971),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5971),
    [anon_sym_BSLASHglslink] = ACTIONS(5971),
    [anon_sym_BSLASHglstext] = ACTIONS(5971),
    [anon_sym_BSLASHGlstext] = ACTIONS(5971),
    [anon_sym_BSLASHGLStext] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5971),
    [anon_sym_BSLASHglsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsname] = ACTIONS(5971),
    [anon_sym_BSLASHGlsname] = ACTIONS(5971),
    [anon_sym_BSLASHGLSname] = ACTIONS(5971),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5971),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5971),
    [anon_sym_BSLASHacrshort] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5971),
    [anon_sym_BSLASHACRshort] = ACTIONS(5971),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrlong] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5971),
    [anon_sym_BSLASHACRlong] = ACTIONS(5971),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrfull] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5971),
    [anon_sym_BSLASHACRfull] = ACTIONS(5971),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHacs] = ACTIONS(5971),
    [anon_sym_BSLASHAcs] = ACTIONS(5971),
    [anon_sym_BSLASHacsp] = ACTIONS(5971),
    [anon_sym_BSLASHAcsp] = ACTIONS(5971),
    [anon_sym_BSLASHacl] = ACTIONS(5971),
    [anon_sym_BSLASHAcl] = ACTIONS(5971),
    [anon_sym_BSLASHaclp] = ACTIONS(5971),
    [anon_sym_BSLASHAclp] = ACTIONS(5971),
    [anon_sym_BSLASHacf] = ACTIONS(5971),
    [anon_sym_BSLASHAcf] = ACTIONS(5971),
    [anon_sym_BSLASHacfp] = ACTIONS(5971),
    [anon_sym_BSLASHAcfp] = ACTIONS(5971),
    [anon_sym_BSLASHac] = ACTIONS(5971),
    [anon_sym_BSLASHAc] = ACTIONS(5971),
    [anon_sym_BSLASHacp] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5971),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5971),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5971),
    [anon_sym_BSLASHcolor] = ACTIONS(5971),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5971),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5971),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5971),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5971),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5971),
    [anon_sym_BSLASHtext] = ACTIONS(5971),
    [anon_sym_BSLASHintertext] = ACTIONS(5971),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5971),
    [anon_sym_BSLASHurl] = ACTIONS(5971),
    [anon_sym_BSLASHhref] = ACTIONS(5971),
  },
  [485] = {
    [sym_command_name] = ACTIONS(2214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_RBRACK] = ACTIONS(2216),
    [anon_sym_COMMA] = ACTIONS(2216),
    [anon_sym_EQ] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2216),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHitem] = ACTIONS(2214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [sym_word] = ACTIONS(2214),
    [sym_placeholder] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_COLON] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [anon_sym__] = ACTIONS(2216),
    [anon_sym_CARET] = ACTIONS(2216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2216),
    [anon_sym_DOLLAR] = ACTIONS(2214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHbegin] = ACTIONS(2214),
    [anon_sym_BSLASHtitle] = ACTIONS(2214),
    [anon_sym_BSLASHauthor] = ACTIONS(2214),
    [anon_sym_BSLASHusepackage] = ACTIONS(2214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2214),
    [anon_sym_BSLASHinclude] = ACTIONS(2214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2214),
    [anon_sym_BSLASHinput] = ACTIONS(2214),
    [anon_sym_BSLASHsubfile] = ACTIONS(2214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2214),
    [anon_sym_BSLASHbibliography] = ACTIONS(2214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2214),
    [anon_sym_BSLASHimport] = ACTIONS(2214),
    [anon_sym_BSLASHsubimport] = ACTIONS(2214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHcaption] = ACTIONS(2214),
    [anon_sym_BSLASHcite] = ACTIONS(2214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCite] = ACTIONS(2214),
    [anon_sym_BSLASHnocite] = ACTIONS(2214),
    [anon_sym_BSLASHcitet] = ACTIONS(2214),
    [anon_sym_BSLASHcitep] = ACTIONS(2214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteA] = ACTIONS(2214),
    [anon_sym_BSLASHciteR] = ACTIONS(2214),
    [anon_sym_BSLASHciteS] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteyear] = ACTIONS(2214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitedate] = ACTIONS(2214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteurl] = ACTIONS(2214),
    [anon_sym_BSLASHfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2214),
    [anon_sym_BSLASHcitealt] = ACTIONS(2214),
    [anon_sym_BSLASHcitealp] = ACTIONS(2214),
    [anon_sym_BSLASHcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHparencite] = ACTIONS(2214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHParencite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHtextcite] = ACTIONS(2214),
    [anon_sym_BSLASHTextcite] = ACTIONS(2214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHsupercite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite] = ACTIONS(2214),
    [anon_sym_BSLASHAutocite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHVolcite] = ACTIONS(2214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHavolcite] = ACTIONS(2214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHNotecite] = ACTIONS(2214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHlabel] = ACTIONS(2214),
    [anon_sym_BSLASHref] = ACTIONS(2214),
    [anon_sym_BSLASHeqref] = ACTIONS(2214),
    [anon_sym_BSLASHvref] = ACTIONS(2214),
    [anon_sym_BSLASHVref] = ACTIONS(2214),
    [anon_sym_BSLASHautoref] = ACTIONS(2214),
    [anon_sym_BSLASHpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcref] = ACTIONS(2214),
    [anon_sym_BSLASHCref] = ACTIONS(2214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnameCref] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHdef] = ACTIONS(2214),
    [anon_sym_BSLASHlet] = ACTIONS(2214),
    [anon_sym_BSLASHleft] = ACTIONS(2214),
    [anon_sym_BSLASHbigl] = ACTIONS(2214),
    [anon_sym_BSLASHBigl] = ACTIONS(2214),
    [anon_sym_BSLASHbiggl] = ACTIONS(2214),
    [anon_sym_BSLASHBiggl] = ACTIONS(2214),
    [anon_sym_BSLASHright] = ACTIONS(2214),
    [anon_sym_BSLASHbigr] = ACTIONS(2214),
    [anon_sym_BSLASHBigr] = ACTIONS(2214),
    [anon_sym_BSLASHbiggr] = ACTIONS(2214),
    [anon_sym_BSLASHBiggr] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2214),
    [anon_sym_BSLASHgls] = ACTIONS(2214),
    [anon_sym_BSLASHGls] = ACTIONS(2214),
    [anon_sym_BSLASHGLS] = ACTIONS(2214),
    [anon_sym_BSLASHglspl] = ACTIONS(2214),
    [anon_sym_BSLASHGlspl] = ACTIONS(2214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2214),
    [anon_sym_BSLASHglslink] = ACTIONS(2214),
    [anon_sym_BSLASHglstext] = ACTIONS(2214),
    [anon_sym_BSLASHGlstext] = ACTIONS(2214),
    [anon_sym_BSLASHGLStext] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2214),
    [anon_sym_BSLASHglsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsname] = ACTIONS(2214),
    [anon_sym_BSLASHGlsname] = ACTIONS(2214),
    [anon_sym_BSLASHGLSname] = ACTIONS(2214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2214),
    [anon_sym_BSLASHacrshort] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2214),
    [anon_sym_BSLASHACRshort] = ACTIONS(2214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrlong] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2214),
    [anon_sym_BSLASHACRlong] = ACTIONS(2214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrfull] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2214),
    [anon_sym_BSLASHACRfull] = ACTIONS(2214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHacs] = ACTIONS(2214),
    [anon_sym_BSLASHAcs] = ACTIONS(2214),
    [anon_sym_BSLASHacsp] = ACTIONS(2214),
    [anon_sym_BSLASHAcsp] = ACTIONS(2214),
    [anon_sym_BSLASHacl] = ACTIONS(2214),
    [anon_sym_BSLASHAcl] = ACTIONS(2214),
    [anon_sym_BSLASHaclp] = ACTIONS(2214),
    [anon_sym_BSLASHAclp] = ACTIONS(2214),
    [anon_sym_BSLASHacf] = ACTIONS(2214),
    [anon_sym_BSLASHAcf] = ACTIONS(2214),
    [anon_sym_BSLASHacfp] = ACTIONS(2214),
    [anon_sym_BSLASHAcfp] = ACTIONS(2214),
    [anon_sym_BSLASHac] = ACTIONS(2214),
    [anon_sym_BSLASHAc] = ACTIONS(2214),
    [anon_sym_BSLASHacp] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2214),
    [anon_sym_BSLASHcolor] = ACTIONS(2214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2214),
    [anon_sym_BSLASHtext] = ACTIONS(2214),
    [anon_sym_BSLASHintertext] = ACTIONS(2214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2214),
    [anon_sym_BSLASHurl] = ACTIONS(2214),
    [anon_sym_BSLASHhref] = ACTIONS(2214),
  },
  [486] = {
    [sym__section_part] = STATE(974),
    [sym_curly_group] = STATE(979),
    [sym_brack_group] = STATE(2882),
    [ts_builtin_sym_end] = ACTIONS(5977),
    [sym_command_name] = ACTIONS(5975),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5975),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5977),
    [anon_sym_EQ] = ACTIONS(5977),
    [anon_sym_LPAREN] = ACTIONS(5977),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHpart] = ACTIONS(5975),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddpart] = ACTIONS(5975),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHchapter] = ACTIONS(5975),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddchap] = ACTIONS(5975),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsection] = ACTIONS(5975),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddsec] = ACTIONS(5975),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHitem] = ACTIONS(5975),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5977),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(5977),
    [sym_word] = ACTIONS(5975),
    [sym_placeholder] = ACTIONS(5977),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_STAR] = ACTIONS(5977),
    [anon_sym_SLASH] = ACTIONS(5977),
    [anon_sym_LT] = ACTIONS(5975),
    [anon_sym_GT] = ACTIONS(5975),
    [anon_sym_BANG] = ACTIONS(5975),
    [anon_sym_PIPE] = ACTIONS(5975),
    [anon_sym_COLON] = ACTIONS(5975),
    [anon_sym_SQUOTE] = ACTIONS(5975),
    [anon_sym__] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5977),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5977),
    [anon_sym_DOLLAR] = ACTIONS(5975),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHbegin] = ACTIONS(5975),
    [anon_sym_BSLASHtitle] = ACTIONS(5975),
    [anon_sym_BSLASHauthor] = ACTIONS(5975),
    [anon_sym_BSLASHusepackage] = ACTIONS(5975),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5975),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5975),
    [anon_sym_BSLASHinclude] = ACTIONS(5975),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5975),
    [anon_sym_BSLASHinput] = ACTIONS(5975),
    [anon_sym_BSLASHsubfile] = ACTIONS(5975),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5975),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5975),
    [anon_sym_BSLASHbibliography] = ACTIONS(5975),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5975),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5975),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5975),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5975),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5975),
    [anon_sym_BSLASHimport] = ACTIONS(5975),
    [anon_sym_BSLASHsubimport] = ACTIONS(5975),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5975),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHcaption] = ACTIONS(5975),
    [anon_sym_BSLASHcite] = ACTIONS(5975),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCite] = ACTIONS(5975),
    [anon_sym_BSLASHnocite] = ACTIONS(5975),
    [anon_sym_BSLASHcitet] = ACTIONS(5975),
    [anon_sym_BSLASHcitep] = ACTIONS(5975),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteA] = ACTIONS(5975),
    [anon_sym_BSLASHciteR] = ACTIONS(5975),
    [anon_sym_BSLASHciteS] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5975),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteyear] = ACTIONS(5975),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitedate] = ACTIONS(5975),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteurl] = ACTIONS(5975),
    [anon_sym_BSLASHfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5975),
    [anon_sym_BSLASHcitealt] = ACTIONS(5975),
    [anon_sym_BSLASHcitealp] = ACTIONS(5975),
    [anon_sym_BSLASHcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHparencite] = ACTIONS(5975),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHParencite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHtextcite] = ACTIONS(5975),
    [anon_sym_BSLASHTextcite] = ACTIONS(5975),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHsupercite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite] = ACTIONS(5975),
    [anon_sym_BSLASHAutocite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHVolcite] = ACTIONS(5975),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHavolcite] = ACTIONS(5975),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHNotecite] = ACTIONS(5975),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHlabel] = ACTIONS(5975),
    [anon_sym_BSLASHref] = ACTIONS(5975),
    [anon_sym_BSLASHeqref] = ACTIONS(5975),
    [anon_sym_BSLASHvref] = ACTIONS(5975),
    [anon_sym_BSLASHVref] = ACTIONS(5975),
    [anon_sym_BSLASHautoref] = ACTIONS(5975),
    [anon_sym_BSLASHpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcref] = ACTIONS(5975),
    [anon_sym_BSLASHCref] = ACTIONS(5975),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnameCref] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHdef] = ACTIONS(5975),
    [anon_sym_BSLASHlet] = ACTIONS(5975),
    [anon_sym_BSLASHleft] = ACTIONS(5975),
    [anon_sym_BSLASHbigl] = ACTIONS(5975),
    [anon_sym_BSLASHBigl] = ACTIONS(5975),
    [anon_sym_BSLASHbiggl] = ACTIONS(5975),
    [anon_sym_BSLASHBiggl] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5975),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5975),
    [anon_sym_BSLASHgls] = ACTIONS(5975),
    [anon_sym_BSLASHGls] = ACTIONS(5975),
    [anon_sym_BSLASHGLS] = ACTIONS(5975),
    [anon_sym_BSLASHglspl] = ACTIONS(5975),
    [anon_sym_BSLASHGlspl] = ACTIONS(5975),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5975),
    [anon_sym_BSLASHglslink] = ACTIONS(5975),
    [anon_sym_BSLASHglstext] = ACTIONS(5975),
    [anon_sym_BSLASHGlstext] = ACTIONS(5975),
    [anon_sym_BSLASHGLStext] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5975),
    [anon_sym_BSLASHglsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsname] = ACTIONS(5975),
    [anon_sym_BSLASHGlsname] = ACTIONS(5975),
    [anon_sym_BSLASHGLSname] = ACTIONS(5975),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5975),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5975),
    [anon_sym_BSLASHacrshort] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5975),
    [anon_sym_BSLASHACRshort] = ACTIONS(5975),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrlong] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5975),
    [anon_sym_BSLASHACRlong] = ACTIONS(5975),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrfull] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5975),
    [anon_sym_BSLASHACRfull] = ACTIONS(5975),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHacs] = ACTIONS(5975),
    [anon_sym_BSLASHAcs] = ACTIONS(5975),
    [anon_sym_BSLASHacsp] = ACTIONS(5975),
    [anon_sym_BSLASHAcsp] = ACTIONS(5975),
    [anon_sym_BSLASHacl] = ACTIONS(5975),
    [anon_sym_BSLASHAcl] = ACTIONS(5975),
    [anon_sym_BSLASHaclp] = ACTIONS(5975),
    [anon_sym_BSLASHAclp] = ACTIONS(5975),
    [anon_sym_BSLASHacf] = ACTIONS(5975),
    [anon_sym_BSLASHAcf] = ACTIONS(5975),
    [anon_sym_BSLASHacfp] = ACTIONS(5975),
    [anon_sym_BSLASHAcfp] = ACTIONS(5975),
    [anon_sym_BSLASHac] = ACTIONS(5975),
    [anon_sym_BSLASHAc] = ACTIONS(5975),
    [anon_sym_BSLASHacp] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5975),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5975),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5975),
    [anon_sym_BSLASHcolor] = ACTIONS(5975),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5975),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5975),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5975),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5975),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5975),
    [anon_sym_BSLASHtext] = ACTIONS(5975),
    [anon_sym_BSLASHintertext] = ACTIONS(5975),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5975),
    [anon_sym_BSLASHurl] = ACTIONS(5975),
    [anon_sym_BSLASHhref] = ACTIONS(5975),
  },
  [487] = {
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6276),
    [anon_sym_RBRACK] = ACTIONS(6276),
    [anon_sym_COMMA] = ACTIONS(6276),
    [anon_sym_EQ] = ACTIONS(6276),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHpart] = ACTIONS(6274),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddpart] = ACTIONS(6274),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHchapter] = ACTIONS(6274),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddchap] = ACTIONS(6274),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsection] = ACTIONS(6274),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddsec] = ACTIONS(6274),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHitem] = ACTIONS(6274),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6276),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6276),
    [anon_sym_DOLLAR] = ACTIONS(6274),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHbegin] = ACTIONS(6274),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHleft] = ACTIONS(6274),
    [anon_sym_BSLASHbigl] = ACTIONS(6274),
    [anon_sym_BSLASHBigl] = ACTIONS(6274),
    [anon_sym_BSLASHbiggl] = ACTIONS(6274),
    [anon_sym_BSLASHBiggl] = ACTIONS(6274),
    [anon_sym_BSLASHright] = ACTIONS(6274),
    [anon_sym_BSLASHbigr] = ACTIONS(6274),
    [anon_sym_BSLASHBigr] = ACTIONS(6274),
    [anon_sym_BSLASHbiggr] = ACTIONS(6274),
    [anon_sym_BSLASHBiggr] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHtext] = ACTIONS(6274),
    [anon_sym_BSLASHintertext] = ACTIONS(6274),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [488] = {
    [sym__section_part] = STATE(970),
    [sym_curly_group] = STATE(979),
    [sym_brack_group] = STATE(2882),
    [ts_builtin_sym_end] = ACTIONS(5981),
    [sym_command_name] = ACTIONS(5979),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5979),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5981),
    [anon_sym_COMMA] = ACTIONS(5981),
    [anon_sym_EQ] = ACTIONS(5981),
    [anon_sym_LPAREN] = ACTIONS(5981),
    [anon_sym_RPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHpart] = ACTIONS(5979),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddpart] = ACTIONS(5979),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHchapter] = ACTIONS(5979),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddchap] = ACTIONS(5979),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsection] = ACTIONS(5979),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddsec] = ACTIONS(5979),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHitem] = ACTIONS(5979),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5981),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(5981),
    [sym_word] = ACTIONS(5979),
    [sym_placeholder] = ACTIONS(5981),
    [anon_sym_PLUS] = ACTIONS(5981),
    [anon_sym_DASH] = ACTIONS(5981),
    [anon_sym_STAR] = ACTIONS(5981),
    [anon_sym_SLASH] = ACTIONS(5981),
    [anon_sym_LT] = ACTIONS(5979),
    [anon_sym_GT] = ACTIONS(5979),
    [anon_sym_BANG] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5979),
    [anon_sym_SQUOTE] = ACTIONS(5979),
    [anon_sym__] = ACTIONS(5981),
    [anon_sym_CARET] = ACTIONS(5981),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5981),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5979),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHbegin] = ACTIONS(5979),
    [anon_sym_BSLASHtitle] = ACTIONS(5979),
    [anon_sym_BSLASHauthor] = ACTIONS(5979),
    [anon_sym_BSLASHusepackage] = ACTIONS(5979),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5979),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5979),
    [anon_sym_BSLASHinclude] = ACTIONS(5979),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5979),
    [anon_sym_BSLASHinput] = ACTIONS(5979),
    [anon_sym_BSLASHsubfile] = ACTIONS(5979),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5979),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5979),
    [anon_sym_BSLASHbibliography] = ACTIONS(5979),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5979),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5979),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5979),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5979),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5979),
    [anon_sym_BSLASHimport] = ACTIONS(5979),
    [anon_sym_BSLASHsubimport] = ACTIONS(5979),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5979),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHcaption] = ACTIONS(5979),
    [anon_sym_BSLASHcite] = ACTIONS(5979),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCite] = ACTIONS(5979),
    [anon_sym_BSLASHnocite] = ACTIONS(5979),
    [anon_sym_BSLASHcitet] = ACTIONS(5979),
    [anon_sym_BSLASHcitep] = ACTIONS(5979),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteA] = ACTIONS(5979),
    [anon_sym_BSLASHciteR] = ACTIONS(5979),
    [anon_sym_BSLASHciteS] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5979),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteyear] = ACTIONS(5979),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitedate] = ACTIONS(5979),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteurl] = ACTIONS(5979),
    [anon_sym_BSLASHfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5979),
    [anon_sym_BSLASHcitealt] = ACTIONS(5979),
    [anon_sym_BSLASHcitealp] = ACTIONS(5979),
    [anon_sym_BSLASHcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHparencite] = ACTIONS(5979),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHParencite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHtextcite] = ACTIONS(5979),
    [anon_sym_BSLASHTextcite] = ACTIONS(5979),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHsupercite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite] = ACTIONS(5979),
    [anon_sym_BSLASHAutocite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHVolcite] = ACTIONS(5979),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHavolcite] = ACTIONS(5979),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHNotecite] = ACTIONS(5979),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHlabel] = ACTIONS(5979),
    [anon_sym_BSLASHref] = ACTIONS(5979),
    [anon_sym_BSLASHeqref] = ACTIONS(5979),
    [anon_sym_BSLASHvref] = ACTIONS(5979),
    [anon_sym_BSLASHVref] = ACTIONS(5979),
    [anon_sym_BSLASHautoref] = ACTIONS(5979),
    [anon_sym_BSLASHpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcref] = ACTIONS(5979),
    [anon_sym_BSLASHCref] = ACTIONS(5979),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnameCref] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHdef] = ACTIONS(5979),
    [anon_sym_BSLASHlet] = ACTIONS(5979),
    [anon_sym_BSLASHleft] = ACTIONS(5979),
    [anon_sym_BSLASHbigl] = ACTIONS(5979),
    [anon_sym_BSLASHBigl] = ACTIONS(5979),
    [anon_sym_BSLASHbiggl] = ACTIONS(5979),
    [anon_sym_BSLASHBiggl] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5979),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5979),
    [anon_sym_BSLASHgls] = ACTIONS(5979),
    [anon_sym_BSLASHGls] = ACTIONS(5979),
    [anon_sym_BSLASHGLS] = ACTIONS(5979),
    [anon_sym_BSLASHglspl] = ACTIONS(5979),
    [anon_sym_BSLASHGlspl] = ACTIONS(5979),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5979),
    [anon_sym_BSLASHglslink] = ACTIONS(5979),
    [anon_sym_BSLASHglstext] = ACTIONS(5979),
    [anon_sym_BSLASHGlstext] = ACTIONS(5979),
    [anon_sym_BSLASHGLStext] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5979),
    [anon_sym_BSLASHglsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsname] = ACTIONS(5979),
    [anon_sym_BSLASHGlsname] = ACTIONS(5979),
    [anon_sym_BSLASHGLSname] = ACTIONS(5979),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5979),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5979),
    [anon_sym_BSLASHacrshort] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5979),
    [anon_sym_BSLASHACRshort] = ACTIONS(5979),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrlong] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5979),
    [anon_sym_BSLASHACRlong] = ACTIONS(5979),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrfull] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5979),
    [anon_sym_BSLASHACRfull] = ACTIONS(5979),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHacs] = ACTIONS(5979),
    [anon_sym_BSLASHAcs] = ACTIONS(5979),
    [anon_sym_BSLASHacsp] = ACTIONS(5979),
    [anon_sym_BSLASHAcsp] = ACTIONS(5979),
    [anon_sym_BSLASHacl] = ACTIONS(5979),
    [anon_sym_BSLASHAcl] = ACTIONS(5979),
    [anon_sym_BSLASHaclp] = ACTIONS(5979),
    [anon_sym_BSLASHAclp] = ACTIONS(5979),
    [anon_sym_BSLASHacf] = ACTIONS(5979),
    [anon_sym_BSLASHAcf] = ACTIONS(5979),
    [anon_sym_BSLASHacfp] = ACTIONS(5979),
    [anon_sym_BSLASHAcfp] = ACTIONS(5979),
    [anon_sym_BSLASHac] = ACTIONS(5979),
    [anon_sym_BSLASHAc] = ACTIONS(5979),
    [anon_sym_BSLASHacp] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5979),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5979),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5979),
    [anon_sym_BSLASHcolor] = ACTIONS(5979),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5979),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5979),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5979),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5979),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5979),
    [anon_sym_BSLASHtext] = ACTIONS(5979),
    [anon_sym_BSLASHintertext] = ACTIONS(5979),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5979),
    [anon_sym_BSLASHurl] = ACTIONS(5979),
    [anon_sym_BSLASHhref] = ACTIONS(5979),
  },
  [489] = {
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6280),
    [anon_sym_RBRACK] = ACTIONS(6280),
    [anon_sym_COMMA] = ACTIONS(6280),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_RPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHpart] = ACTIONS(6278),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddpart] = ACTIONS(6278),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHchapter] = ACTIONS(6278),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddchap] = ACTIONS(6278),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsection] = ACTIONS(6278),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddsec] = ACTIONS(6278),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHitem] = ACTIONS(6278),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6280),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6280),
    [anon_sym_DOLLAR] = ACTIONS(6278),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHbegin] = ACTIONS(6278),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHleft] = ACTIONS(6278),
    [anon_sym_BSLASHbigl] = ACTIONS(6278),
    [anon_sym_BSLASHBigl] = ACTIONS(6278),
    [anon_sym_BSLASHbiggl] = ACTIONS(6278),
    [anon_sym_BSLASHBiggl] = ACTIONS(6278),
    [anon_sym_BSLASHright] = ACTIONS(6278),
    [anon_sym_BSLASHbigr] = ACTIONS(6278),
    [anon_sym_BSLASHBigr] = ACTIONS(6278),
    [anon_sym_BSLASHbiggr] = ACTIONS(6278),
    [anon_sym_BSLASHBiggr] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHtext] = ACTIONS(6278),
    [anon_sym_BSLASHintertext] = ACTIONS(6278),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [490] = {
    [sym__section_part] = STATE(924),
    [sym_curly_group] = STATE(979),
    [sym_brack_group] = STATE(2882),
    [ts_builtin_sym_end] = ACTIONS(5985),
    [sym_command_name] = ACTIONS(5983),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5983),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5985),
    [anon_sym_COMMA] = ACTIONS(5985),
    [anon_sym_EQ] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(5985),
    [anon_sym_RPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHpart] = ACTIONS(5983),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddpart] = ACTIONS(5983),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHchapter] = ACTIONS(5983),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddchap] = ACTIONS(5983),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsection] = ACTIONS(5983),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddsec] = ACTIONS(5983),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHitem] = ACTIONS(5983),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(5985),
    [sym_word] = ACTIONS(5983),
    [sym_placeholder] = ACTIONS(5985),
    [anon_sym_PLUS] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(5985),
    [anon_sym_SLASH] = ACTIONS(5985),
    [anon_sym_LT] = ACTIONS(5983),
    [anon_sym_GT] = ACTIONS(5983),
    [anon_sym_BANG] = ACTIONS(5983),
    [anon_sym_PIPE] = ACTIONS(5983),
    [anon_sym_COLON] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(5983),
    [anon_sym__] = ACTIONS(5985),
    [anon_sym_CARET] = ACTIONS(5985),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5985),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5985),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHbegin] = ACTIONS(5983),
    [anon_sym_BSLASHtitle] = ACTIONS(5983),
    [anon_sym_BSLASHauthor] = ACTIONS(5983),
    [anon_sym_BSLASHusepackage] = ACTIONS(5983),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5983),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5983),
    [anon_sym_BSLASHinclude] = ACTIONS(5983),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5983),
    [anon_sym_BSLASHinput] = ACTIONS(5983),
    [anon_sym_BSLASHsubfile] = ACTIONS(5983),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5983),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5983),
    [anon_sym_BSLASHbibliography] = ACTIONS(5983),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5983),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5983),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5983),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5983),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5983),
    [anon_sym_BSLASHimport] = ACTIONS(5983),
    [anon_sym_BSLASHsubimport] = ACTIONS(5983),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5983),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHcaption] = ACTIONS(5983),
    [anon_sym_BSLASHcite] = ACTIONS(5983),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCite] = ACTIONS(5983),
    [anon_sym_BSLASHnocite] = ACTIONS(5983),
    [anon_sym_BSLASHcitet] = ACTIONS(5983),
    [anon_sym_BSLASHcitep] = ACTIONS(5983),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteA] = ACTIONS(5983),
    [anon_sym_BSLASHciteR] = ACTIONS(5983),
    [anon_sym_BSLASHciteS] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5983),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteyear] = ACTIONS(5983),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitedate] = ACTIONS(5983),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteurl] = ACTIONS(5983),
    [anon_sym_BSLASHfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5983),
    [anon_sym_BSLASHcitealt] = ACTIONS(5983),
    [anon_sym_BSLASHcitealp] = ACTIONS(5983),
    [anon_sym_BSLASHcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHparencite] = ACTIONS(5983),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHParencite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHtextcite] = ACTIONS(5983),
    [anon_sym_BSLASHTextcite] = ACTIONS(5983),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHsupercite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite] = ACTIONS(5983),
    [anon_sym_BSLASHAutocite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHVolcite] = ACTIONS(5983),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHavolcite] = ACTIONS(5983),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHNotecite] = ACTIONS(5983),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHlabel] = ACTIONS(5983),
    [anon_sym_BSLASHref] = ACTIONS(5983),
    [anon_sym_BSLASHeqref] = ACTIONS(5983),
    [anon_sym_BSLASHvref] = ACTIONS(5983),
    [anon_sym_BSLASHVref] = ACTIONS(5983),
    [anon_sym_BSLASHautoref] = ACTIONS(5983),
    [anon_sym_BSLASHpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcref] = ACTIONS(5983),
    [anon_sym_BSLASHCref] = ACTIONS(5983),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnameCref] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHdef] = ACTIONS(5983),
    [anon_sym_BSLASHlet] = ACTIONS(5983),
    [anon_sym_BSLASHleft] = ACTIONS(5983),
    [anon_sym_BSLASHbigl] = ACTIONS(5983),
    [anon_sym_BSLASHBigl] = ACTIONS(5983),
    [anon_sym_BSLASHbiggl] = ACTIONS(5983),
    [anon_sym_BSLASHBiggl] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5983),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5983),
    [anon_sym_BSLASHgls] = ACTIONS(5983),
    [anon_sym_BSLASHGls] = ACTIONS(5983),
    [anon_sym_BSLASHGLS] = ACTIONS(5983),
    [anon_sym_BSLASHglspl] = ACTIONS(5983),
    [anon_sym_BSLASHGlspl] = ACTIONS(5983),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5983),
    [anon_sym_BSLASHglslink] = ACTIONS(5983),
    [anon_sym_BSLASHglstext] = ACTIONS(5983),
    [anon_sym_BSLASHGlstext] = ACTIONS(5983),
    [anon_sym_BSLASHGLStext] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5983),
    [anon_sym_BSLASHglsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsname] = ACTIONS(5983),
    [anon_sym_BSLASHGlsname] = ACTIONS(5983),
    [anon_sym_BSLASHGLSname] = ACTIONS(5983),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5983),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5983),
    [anon_sym_BSLASHacrshort] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5983),
    [anon_sym_BSLASHACRshort] = ACTIONS(5983),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrlong] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5983),
    [anon_sym_BSLASHACRlong] = ACTIONS(5983),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrfull] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5983),
    [anon_sym_BSLASHACRfull] = ACTIONS(5983),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHacs] = ACTIONS(5983),
    [anon_sym_BSLASHAcs] = ACTIONS(5983),
    [anon_sym_BSLASHacsp] = ACTIONS(5983),
    [anon_sym_BSLASHAcsp] = ACTIONS(5983),
    [anon_sym_BSLASHacl] = ACTIONS(5983),
    [anon_sym_BSLASHAcl] = ACTIONS(5983),
    [anon_sym_BSLASHaclp] = ACTIONS(5983),
    [anon_sym_BSLASHAclp] = ACTIONS(5983),
    [anon_sym_BSLASHacf] = ACTIONS(5983),
    [anon_sym_BSLASHAcf] = ACTIONS(5983),
    [anon_sym_BSLASHacfp] = ACTIONS(5983),
    [anon_sym_BSLASHAcfp] = ACTIONS(5983),
    [anon_sym_BSLASHac] = ACTIONS(5983),
    [anon_sym_BSLASHAc] = ACTIONS(5983),
    [anon_sym_BSLASHacp] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5983),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5983),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5983),
    [anon_sym_BSLASHcolor] = ACTIONS(5983),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5983),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5983),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5983),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5983),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5983),
    [anon_sym_BSLASHtext] = ACTIONS(5983),
    [anon_sym_BSLASHintertext] = ACTIONS(5983),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5983),
    [anon_sym_BSLASHurl] = ACTIONS(5983),
    [anon_sym_BSLASHhref] = ACTIONS(5983),
  },
  [491] = {
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHpart] = ACTIONS(6282),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddpart] = ACTIONS(6282),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHchapter] = ACTIONS(6282),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddchap] = ACTIONS(6282),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsection] = ACTIONS(6282),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddsec] = ACTIONS(6282),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHitem] = ACTIONS(6282),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6284),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6284),
    [anon_sym_DOLLAR] = ACTIONS(6282),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHbegin] = ACTIONS(6282),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHleft] = ACTIONS(6282),
    [anon_sym_BSLASHbigl] = ACTIONS(6282),
    [anon_sym_BSLASHBigl] = ACTIONS(6282),
    [anon_sym_BSLASHbiggl] = ACTIONS(6282),
    [anon_sym_BSLASHBiggl] = ACTIONS(6282),
    [anon_sym_BSLASHright] = ACTIONS(6282),
    [anon_sym_BSLASHbigr] = ACTIONS(6282),
    [anon_sym_BSLASHBigr] = ACTIONS(6282),
    [anon_sym_BSLASHbiggr] = ACTIONS(6282),
    [anon_sym_BSLASHBiggr] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHtext] = ACTIONS(6282),
    [anon_sym_BSLASHintertext] = ACTIONS(6282),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [492] = {
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6288),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHpart] = ACTIONS(6286),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddpart] = ACTIONS(6286),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHchapter] = ACTIONS(6286),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddchap] = ACTIONS(6286),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsection] = ACTIONS(6286),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddsec] = ACTIONS(6286),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHitem] = ACTIONS(6286),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6288),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6288),
    [anon_sym_DOLLAR] = ACTIONS(6286),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHbegin] = ACTIONS(6286),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHleft] = ACTIONS(6286),
    [anon_sym_BSLASHbigl] = ACTIONS(6286),
    [anon_sym_BSLASHBigl] = ACTIONS(6286),
    [anon_sym_BSLASHbiggl] = ACTIONS(6286),
    [anon_sym_BSLASHBiggl] = ACTIONS(6286),
    [anon_sym_BSLASHright] = ACTIONS(6286),
    [anon_sym_BSLASHbigr] = ACTIONS(6286),
    [anon_sym_BSLASHBigr] = ACTIONS(6286),
    [anon_sym_BSLASHbiggr] = ACTIONS(6286),
    [anon_sym_BSLASHBiggr] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHtext] = ACTIONS(6286),
    [anon_sym_BSLASHintertext] = ACTIONS(6286),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [493] = {
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6292),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_COMMA] = ACTIONS(6292),
    [anon_sym_EQ] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_RPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHpart] = ACTIONS(6290),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddpart] = ACTIONS(6290),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHchapter] = ACTIONS(6290),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddchap] = ACTIONS(6290),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsection] = ACTIONS(6290),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddsec] = ACTIONS(6290),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHitem] = ACTIONS(6290),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6292),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6292),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6292),
    [anon_sym_DOLLAR] = ACTIONS(6290),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHbegin] = ACTIONS(6290),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHleft] = ACTIONS(6290),
    [anon_sym_BSLASHbigl] = ACTIONS(6290),
    [anon_sym_BSLASHBigl] = ACTIONS(6290),
    [anon_sym_BSLASHbiggl] = ACTIONS(6290),
    [anon_sym_BSLASHBiggl] = ACTIONS(6290),
    [anon_sym_BSLASHright] = ACTIONS(6290),
    [anon_sym_BSLASHbigr] = ACTIONS(6290),
    [anon_sym_BSLASHBigr] = ACTIONS(6290),
    [anon_sym_BSLASHbiggr] = ACTIONS(6290),
    [anon_sym_BSLASHBiggr] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHtext] = ACTIONS(6290),
    [anon_sym_BSLASHintertext] = ACTIONS(6290),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [494] = {
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(585),
    [aux_sym__section_repeat2] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [495] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(5955),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [anon_sym_RBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [496] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [497] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [498] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [499] = {
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(585),
    [aux_sym__section_repeat2] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [500] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [501] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [502] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [503] = {
    [sym_command_name] = ACTIONS(6294),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6294),
    [anon_sym_LBRACK] = ACTIONS(6296),
    [anon_sym_RBRACK] = ACTIONS(6296),
    [anon_sym_COMMA] = ACTIONS(6296),
    [anon_sym_EQ] = ACTIONS(6296),
    [anon_sym_LPAREN] = ACTIONS(6296),
    [anon_sym_RPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHpart] = ACTIONS(6294),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddpart] = ACTIONS(6294),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHchapter] = ACTIONS(6294),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddchap] = ACTIONS(6294),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsection] = ACTIONS(6294),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddsec] = ACTIONS(6294),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHitem] = ACTIONS(6294),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6296),
    [anon_sym_LBRACE] = ACTIONS(6296),
    [sym_word] = ACTIONS(6294),
    [sym_placeholder] = ACTIONS(6296),
    [anon_sym_PLUS] = ACTIONS(6296),
    [anon_sym_DASH] = ACTIONS(6296),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_SLASH] = ACTIONS(6296),
    [anon_sym_LT] = ACTIONS(6294),
    [anon_sym_GT] = ACTIONS(6294),
    [anon_sym_BANG] = ACTIONS(6294),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COLON] = ACTIONS(6294),
    [anon_sym_SQUOTE] = ACTIONS(6294),
    [anon_sym__] = ACTIONS(6296),
    [anon_sym_CARET] = ACTIONS(6296),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6296),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6296),
    [anon_sym_DOLLAR] = ACTIONS(6294),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHbegin] = ACTIONS(6294),
    [anon_sym_BSLASHtitle] = ACTIONS(6294),
    [anon_sym_BSLASHauthor] = ACTIONS(6294),
    [anon_sym_BSLASHusepackage] = ACTIONS(6294),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6294),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6294),
    [anon_sym_BSLASHinclude] = ACTIONS(6294),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6294),
    [anon_sym_BSLASHinput] = ACTIONS(6294),
    [anon_sym_BSLASHsubfile] = ACTIONS(6294),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6294),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6294),
    [anon_sym_BSLASHbibliography] = ACTIONS(6294),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6294),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6294),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6294),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6294),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6294),
    [anon_sym_BSLASHimport] = ACTIONS(6294),
    [anon_sym_BSLASHsubimport] = ACTIONS(6294),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6294),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHcaption] = ACTIONS(6294),
    [anon_sym_BSLASHcite] = ACTIONS(6294),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCite] = ACTIONS(6294),
    [anon_sym_BSLASHnocite] = ACTIONS(6294),
    [anon_sym_BSLASHcitet] = ACTIONS(6294),
    [anon_sym_BSLASHcitep] = ACTIONS(6294),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteA] = ACTIONS(6294),
    [anon_sym_BSLASHciteR] = ACTIONS(6294),
    [anon_sym_BSLASHciteS] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6294),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteyear] = ACTIONS(6294),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitedate] = ACTIONS(6294),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteurl] = ACTIONS(6294),
    [anon_sym_BSLASHfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6294),
    [anon_sym_BSLASHcitealt] = ACTIONS(6294),
    [anon_sym_BSLASHcitealp] = ACTIONS(6294),
    [anon_sym_BSLASHcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHparencite] = ACTIONS(6294),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHParencite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHtextcite] = ACTIONS(6294),
    [anon_sym_BSLASHTextcite] = ACTIONS(6294),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHsupercite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite] = ACTIONS(6294),
    [anon_sym_BSLASHAutocite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHVolcite] = ACTIONS(6294),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHavolcite] = ACTIONS(6294),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHNotecite] = ACTIONS(6294),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHlabel] = ACTIONS(6294),
    [anon_sym_BSLASHref] = ACTIONS(6294),
    [anon_sym_BSLASHeqref] = ACTIONS(6294),
    [anon_sym_BSLASHvref] = ACTIONS(6294),
    [anon_sym_BSLASHVref] = ACTIONS(6294),
    [anon_sym_BSLASHautoref] = ACTIONS(6294),
    [anon_sym_BSLASHpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcref] = ACTIONS(6294),
    [anon_sym_BSLASHCref] = ACTIONS(6294),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnameCref] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHdef] = ACTIONS(6294),
    [anon_sym_BSLASHlet] = ACTIONS(6294),
    [anon_sym_BSLASHleft] = ACTIONS(6294),
    [anon_sym_BSLASHbigl] = ACTIONS(6294),
    [anon_sym_BSLASHBigl] = ACTIONS(6294),
    [anon_sym_BSLASHbiggl] = ACTIONS(6294),
    [anon_sym_BSLASHBiggl] = ACTIONS(6294),
    [anon_sym_BSLASHright] = ACTIONS(6294),
    [anon_sym_BSLASHbigr] = ACTIONS(6294),
    [anon_sym_BSLASHBigr] = ACTIONS(6294),
    [anon_sym_BSLASHbiggr] = ACTIONS(6294),
    [anon_sym_BSLASHBiggr] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6294),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6294),
    [anon_sym_BSLASHgls] = ACTIONS(6294),
    [anon_sym_BSLASHGls] = ACTIONS(6294),
    [anon_sym_BSLASHGLS] = ACTIONS(6294),
    [anon_sym_BSLASHglspl] = ACTIONS(6294),
    [anon_sym_BSLASHGlspl] = ACTIONS(6294),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6294),
    [anon_sym_BSLASHglslink] = ACTIONS(6294),
    [anon_sym_BSLASHglstext] = ACTIONS(6294),
    [anon_sym_BSLASHGlstext] = ACTIONS(6294),
    [anon_sym_BSLASHGLStext] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6294),
    [anon_sym_BSLASHglsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsname] = ACTIONS(6294),
    [anon_sym_BSLASHGlsname] = ACTIONS(6294),
    [anon_sym_BSLASHGLSname] = ACTIONS(6294),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6294),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6294),
    [anon_sym_BSLASHacrshort] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6294),
    [anon_sym_BSLASHACRshort] = ACTIONS(6294),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrlong] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6294),
    [anon_sym_BSLASHACRlong] = ACTIONS(6294),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrfull] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6294),
    [anon_sym_BSLASHACRfull] = ACTIONS(6294),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHacs] = ACTIONS(6294),
    [anon_sym_BSLASHAcs] = ACTIONS(6294),
    [anon_sym_BSLASHacsp] = ACTIONS(6294),
    [anon_sym_BSLASHAcsp] = ACTIONS(6294),
    [anon_sym_BSLASHacl] = ACTIONS(6294),
    [anon_sym_BSLASHAcl] = ACTIONS(6294),
    [anon_sym_BSLASHaclp] = ACTIONS(6294),
    [anon_sym_BSLASHAclp] = ACTIONS(6294),
    [anon_sym_BSLASHacf] = ACTIONS(6294),
    [anon_sym_BSLASHAcf] = ACTIONS(6294),
    [anon_sym_BSLASHacfp] = ACTIONS(6294),
    [anon_sym_BSLASHAcfp] = ACTIONS(6294),
    [anon_sym_BSLASHac] = ACTIONS(6294),
    [anon_sym_BSLASHAc] = ACTIONS(6294),
    [anon_sym_BSLASHacp] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6294),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6294),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6294),
    [anon_sym_BSLASHcolor] = ACTIONS(6294),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6294),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6294),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6294),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6294),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6294),
    [anon_sym_BSLASHtext] = ACTIONS(6294),
    [anon_sym_BSLASHintertext] = ACTIONS(6294),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6294),
    [anon_sym_BSLASHurl] = ACTIONS(6294),
    [anon_sym_BSLASHhref] = ACTIONS(6294),
  },
  [504] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [505] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [506] = {
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHpart] = ACTIONS(6298),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddpart] = ACTIONS(6298),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHchapter] = ACTIONS(6298),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddchap] = ACTIONS(6298),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsection] = ACTIONS(6298),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddsec] = ACTIONS(6298),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHitem] = ACTIONS(6298),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6300),
    [anon_sym_DOLLAR] = ACTIONS(6298),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHbegin] = ACTIONS(6298),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHleft] = ACTIONS(6298),
    [anon_sym_BSLASHbigl] = ACTIONS(6298),
    [anon_sym_BSLASHBigl] = ACTIONS(6298),
    [anon_sym_BSLASHbiggl] = ACTIONS(6298),
    [anon_sym_BSLASHBiggl] = ACTIONS(6298),
    [anon_sym_BSLASHright] = ACTIONS(6298),
    [anon_sym_BSLASHbigr] = ACTIONS(6298),
    [anon_sym_BSLASHBigr] = ACTIONS(6298),
    [anon_sym_BSLASHbiggr] = ACTIONS(6298),
    [anon_sym_BSLASHBiggr] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHtext] = ACTIONS(6298),
    [anon_sym_BSLASHintertext] = ACTIONS(6298),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [507] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(2134),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [anon_sym_RBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [508] = {
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_LPAREN] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHpart] = ACTIONS(6302),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddpart] = ACTIONS(6302),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHchapter] = ACTIONS(6302),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddchap] = ACTIONS(6302),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsection] = ACTIONS(6302),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddsec] = ACTIONS(6302),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHitem] = ACTIONS(6302),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6304),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6304),
    [anon_sym_DOLLAR] = ACTIONS(6302),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHbegin] = ACTIONS(6302),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHleft] = ACTIONS(6302),
    [anon_sym_BSLASHbigl] = ACTIONS(6302),
    [anon_sym_BSLASHBigl] = ACTIONS(6302),
    [anon_sym_BSLASHbiggl] = ACTIONS(6302),
    [anon_sym_BSLASHBiggl] = ACTIONS(6302),
    [anon_sym_BSLASHright] = ACTIONS(6302),
    [anon_sym_BSLASHbigr] = ACTIONS(6302),
    [anon_sym_BSLASHBigr] = ACTIONS(6302),
    [anon_sym_BSLASHbiggr] = ACTIONS(6302),
    [anon_sym_BSLASHBiggr] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHtext] = ACTIONS(6302),
    [anon_sym_BSLASHintertext] = ACTIONS(6302),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [509] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [510] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [511] = {
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(585),
    [aux_sym__section_repeat2] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(5810),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [anon_sym_RBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [512] = {
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6308),
    [anon_sym_RBRACK] = ACTIONS(6308),
    [anon_sym_COMMA] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(6308),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_RPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHpart] = ACTIONS(6306),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddpart] = ACTIONS(6306),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHchapter] = ACTIONS(6306),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddchap] = ACTIONS(6306),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsection] = ACTIONS(6306),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddsec] = ACTIONS(6306),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHitem] = ACTIONS(6306),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6308),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6308),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6308),
    [anon_sym_DOLLAR] = ACTIONS(6306),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHbegin] = ACTIONS(6306),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHleft] = ACTIONS(6306),
    [anon_sym_BSLASHbigl] = ACTIONS(6306),
    [anon_sym_BSLASHBigl] = ACTIONS(6306),
    [anon_sym_BSLASHbiggl] = ACTIONS(6306),
    [anon_sym_BSLASHBiggl] = ACTIONS(6306),
    [anon_sym_BSLASHright] = ACTIONS(6306),
    [anon_sym_BSLASHbigr] = ACTIONS(6306),
    [anon_sym_BSLASHBigr] = ACTIONS(6306),
    [anon_sym_BSLASHbiggr] = ACTIONS(6306),
    [anon_sym_BSLASHBiggr] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHtext] = ACTIONS(6306),
    [anon_sym_BSLASHintertext] = ACTIONS(6306),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [513] = {
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6312),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6312),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHpart] = ACTIONS(6310),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddpart] = ACTIONS(6310),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHchapter] = ACTIONS(6310),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddchap] = ACTIONS(6310),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsection] = ACTIONS(6310),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddsec] = ACTIONS(6310),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHitem] = ACTIONS(6310),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6312),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6312),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6312),
    [anon_sym_DOLLAR] = ACTIONS(6310),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHbegin] = ACTIONS(6310),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHleft] = ACTIONS(6310),
    [anon_sym_BSLASHbigl] = ACTIONS(6310),
    [anon_sym_BSLASHBigl] = ACTIONS(6310),
    [anon_sym_BSLASHbiggl] = ACTIONS(6310),
    [anon_sym_BSLASHBiggl] = ACTIONS(6310),
    [anon_sym_BSLASHright] = ACTIONS(6310),
    [anon_sym_BSLASHbigr] = ACTIONS(6310),
    [anon_sym_BSLASHBigr] = ACTIONS(6310),
    [anon_sym_BSLASHbiggr] = ACTIONS(6310),
    [anon_sym_BSLASHBiggr] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHtext] = ACTIONS(6310),
    [anon_sym_BSLASHintertext] = ACTIONS(6310),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [514] = {
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_COMMA] = ACTIONS(6316),
    [anon_sym_EQ] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6316),
    [anon_sym_RPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHpart] = ACTIONS(6314),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddpart] = ACTIONS(6314),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHchapter] = ACTIONS(6314),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddchap] = ACTIONS(6314),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsection] = ACTIONS(6314),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddsec] = ACTIONS(6314),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHitem] = ACTIONS(6314),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6316),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6316),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6316),
    [anon_sym_DOLLAR] = ACTIONS(6314),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHbegin] = ACTIONS(6314),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHleft] = ACTIONS(6314),
    [anon_sym_BSLASHbigl] = ACTIONS(6314),
    [anon_sym_BSLASHBigl] = ACTIONS(6314),
    [anon_sym_BSLASHbiggl] = ACTIONS(6314),
    [anon_sym_BSLASHBiggl] = ACTIONS(6314),
    [anon_sym_BSLASHright] = ACTIONS(6314),
    [anon_sym_BSLASHbigr] = ACTIONS(6314),
    [anon_sym_BSLASHBigr] = ACTIONS(6314),
    [anon_sym_BSLASHbiggr] = ACTIONS(6314),
    [anon_sym_BSLASHBiggr] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHtext] = ACTIONS(6314),
    [anon_sym_BSLASHintertext] = ACTIONS(6314),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [515] = {
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_RBRACK] = ACTIONS(6320),
    [anon_sym_COMMA] = ACTIONS(6320),
    [anon_sym_EQ] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(6320),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHpart] = ACTIONS(6318),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddpart] = ACTIONS(6318),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHchapter] = ACTIONS(6318),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddchap] = ACTIONS(6318),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsection] = ACTIONS(6318),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddsec] = ACTIONS(6318),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHitem] = ACTIONS(6318),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6320),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6320),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHbegin] = ACTIONS(6318),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHleft] = ACTIONS(6318),
    [anon_sym_BSLASHbigl] = ACTIONS(6318),
    [anon_sym_BSLASHBigl] = ACTIONS(6318),
    [anon_sym_BSLASHbiggl] = ACTIONS(6318),
    [anon_sym_BSLASHBiggl] = ACTIONS(6318),
    [anon_sym_BSLASHright] = ACTIONS(6318),
    [anon_sym_BSLASHbigr] = ACTIONS(6318),
    [anon_sym_BSLASHBigr] = ACTIONS(6318),
    [anon_sym_BSLASHbiggr] = ACTIONS(6318),
    [anon_sym_BSLASHBiggr] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHtext] = ACTIONS(6318),
    [anon_sym_BSLASHintertext] = ACTIONS(6318),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [516] = {
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHpart] = ACTIONS(6322),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddpart] = ACTIONS(6322),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHchapter] = ACTIONS(6322),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddchap] = ACTIONS(6322),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsection] = ACTIONS(6322),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddsec] = ACTIONS(6322),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHitem] = ACTIONS(6322),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6324),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6324),
    [anon_sym_DOLLAR] = ACTIONS(6322),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHbegin] = ACTIONS(6322),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHleft] = ACTIONS(6322),
    [anon_sym_BSLASHbigl] = ACTIONS(6322),
    [anon_sym_BSLASHBigl] = ACTIONS(6322),
    [anon_sym_BSLASHbiggl] = ACTIONS(6322),
    [anon_sym_BSLASHBiggl] = ACTIONS(6322),
    [anon_sym_BSLASHright] = ACTIONS(6322),
    [anon_sym_BSLASHbigr] = ACTIONS(6322),
    [anon_sym_BSLASHBigr] = ACTIONS(6322),
    [anon_sym_BSLASHbiggr] = ACTIONS(6322),
    [anon_sym_BSLASHBiggr] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHtext] = ACTIONS(6322),
    [anon_sym_BSLASHintertext] = ACTIONS(6322),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [517] = {
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6328),
    [anon_sym_RBRACK] = ACTIONS(6328),
    [anon_sym_COMMA] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6328),
    [anon_sym_RPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHpart] = ACTIONS(6326),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddpart] = ACTIONS(6326),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHchapter] = ACTIONS(6326),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddchap] = ACTIONS(6326),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsection] = ACTIONS(6326),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddsec] = ACTIONS(6326),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHitem] = ACTIONS(6326),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6328),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6328),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6328),
    [anon_sym_DOLLAR] = ACTIONS(6326),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHbegin] = ACTIONS(6326),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHleft] = ACTIONS(6326),
    [anon_sym_BSLASHbigl] = ACTIONS(6326),
    [anon_sym_BSLASHBigl] = ACTIONS(6326),
    [anon_sym_BSLASHbiggl] = ACTIONS(6326),
    [anon_sym_BSLASHBiggl] = ACTIONS(6326),
    [anon_sym_BSLASHright] = ACTIONS(6326),
    [anon_sym_BSLASHbigr] = ACTIONS(6326),
    [anon_sym_BSLASHBigr] = ACTIONS(6326),
    [anon_sym_BSLASHbiggr] = ACTIONS(6326),
    [anon_sym_BSLASHBiggr] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHtext] = ACTIONS(6326),
    [anon_sym_BSLASHintertext] = ACTIONS(6326),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [518] = {
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6332),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_EQ] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6332),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHpart] = ACTIONS(6330),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddpart] = ACTIONS(6330),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHchapter] = ACTIONS(6330),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddchap] = ACTIONS(6330),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsection] = ACTIONS(6330),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddsec] = ACTIONS(6330),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHitem] = ACTIONS(6330),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6332),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6330),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHbegin] = ACTIONS(6330),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHleft] = ACTIONS(6330),
    [anon_sym_BSLASHbigl] = ACTIONS(6330),
    [anon_sym_BSLASHBigl] = ACTIONS(6330),
    [anon_sym_BSLASHbiggl] = ACTIONS(6330),
    [anon_sym_BSLASHBiggl] = ACTIONS(6330),
    [anon_sym_BSLASHright] = ACTIONS(6330),
    [anon_sym_BSLASHbigr] = ACTIONS(6330),
    [anon_sym_BSLASHBigr] = ACTIONS(6330),
    [anon_sym_BSLASHbiggr] = ACTIONS(6330),
    [anon_sym_BSLASHBiggr] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHtext] = ACTIONS(6330),
    [anon_sym_BSLASHintertext] = ACTIONS(6330),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [519] = {
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6336),
    [anon_sym_RBRACK] = ACTIONS(6336),
    [anon_sym_COMMA] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_RPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHpart] = ACTIONS(6334),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddpart] = ACTIONS(6334),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHchapter] = ACTIONS(6334),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddchap] = ACTIONS(6334),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsection] = ACTIONS(6334),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddsec] = ACTIONS(6334),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHitem] = ACTIONS(6334),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6336),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHbegin] = ACTIONS(6334),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHleft] = ACTIONS(6334),
    [anon_sym_BSLASHbigl] = ACTIONS(6334),
    [anon_sym_BSLASHBigl] = ACTIONS(6334),
    [anon_sym_BSLASHbiggl] = ACTIONS(6334),
    [anon_sym_BSLASHBiggl] = ACTIONS(6334),
    [anon_sym_BSLASHright] = ACTIONS(6334),
    [anon_sym_BSLASHbigr] = ACTIONS(6334),
    [anon_sym_BSLASHBigr] = ACTIONS(6334),
    [anon_sym_BSLASHbiggr] = ACTIONS(6334),
    [anon_sym_BSLASHBiggr] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHtext] = ACTIONS(6334),
    [anon_sym_BSLASHintertext] = ACTIONS(6334),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [520] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(6099),
    [sym_command_name] = ACTIONS(6097),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(6099),
    [anon_sym_RBRACK] = ACTIONS(6099),
    [anon_sym_COMMA] = ACTIONS(6099),
    [anon_sym_EQ] = ACTIONS(6099),
    [anon_sym_LPAREN] = ACTIONS(6099),
    [anon_sym_RPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHpart] = ACTIONS(6097),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddpart] = ACTIONS(6097),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHchapter] = ACTIONS(6097),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddchap] = ACTIONS(6097),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsection] = ACTIONS(6097),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddsec] = ACTIONS(6097),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsection] = ACTIONS(6097),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHitem] = ACTIONS(6097),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(6099),
    [anon_sym_RBRACE] = ACTIONS(6099),
    [sym_word] = ACTIONS(6097),
    [sym_placeholder] = ACTIONS(6099),
    [anon_sym_PLUS] = ACTIONS(6099),
    [anon_sym_DASH] = ACTIONS(6099),
    [anon_sym_STAR] = ACTIONS(6099),
    [anon_sym_SLASH] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(6097),
    [anon_sym_GT] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6097),
    [anon_sym_PIPE] = ACTIONS(6097),
    [anon_sym_COLON] = ACTIONS(6097),
    [anon_sym_SQUOTE] = ACTIONS(6097),
    [anon_sym__] = ACTIONS(6099),
    [anon_sym_CARET] = ACTIONS(6099),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6099),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6099),
    [anon_sym_DOLLAR] = ACTIONS(6097),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHbegin] = ACTIONS(6097),
    [anon_sym_BSLASHtitle] = ACTIONS(6097),
    [anon_sym_BSLASHauthor] = ACTIONS(6097),
    [anon_sym_BSLASHusepackage] = ACTIONS(6097),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6097),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6097),
    [anon_sym_BSLASHinclude] = ACTIONS(6097),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6097),
    [anon_sym_BSLASHinput] = ACTIONS(6097),
    [anon_sym_BSLASHsubfile] = ACTIONS(6097),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6097),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6097),
    [anon_sym_BSLASHbibliography] = ACTIONS(6097),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6097),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6097),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6097),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6097),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6097),
    [anon_sym_BSLASHimport] = ACTIONS(6097),
    [anon_sym_BSLASHsubimport] = ACTIONS(6097),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6097),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHcaption] = ACTIONS(6097),
    [anon_sym_BSLASHcite] = ACTIONS(6097),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCite] = ACTIONS(6097),
    [anon_sym_BSLASHnocite] = ACTIONS(6097),
    [anon_sym_BSLASHcitet] = ACTIONS(6097),
    [anon_sym_BSLASHcitep] = ACTIONS(6097),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteA] = ACTIONS(6097),
    [anon_sym_BSLASHciteR] = ACTIONS(6097),
    [anon_sym_BSLASHciteS] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6097),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteyear] = ACTIONS(6097),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitedate] = ACTIONS(6097),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteurl] = ACTIONS(6097),
    [anon_sym_BSLASHfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6097),
    [anon_sym_BSLASHcitealt] = ACTIONS(6097),
    [anon_sym_BSLASHcitealp] = ACTIONS(6097),
    [anon_sym_BSLASHcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHparencite] = ACTIONS(6097),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHParencite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHtextcite] = ACTIONS(6097),
    [anon_sym_BSLASHTextcite] = ACTIONS(6097),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHsupercite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite] = ACTIONS(6097),
    [anon_sym_BSLASHAutocite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHVolcite] = ACTIONS(6097),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHavolcite] = ACTIONS(6097),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHNotecite] = ACTIONS(6097),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHlabel] = ACTIONS(6097),
    [anon_sym_BSLASHref] = ACTIONS(6097),
    [anon_sym_BSLASHeqref] = ACTIONS(6097),
    [anon_sym_BSLASHvref] = ACTIONS(6097),
    [anon_sym_BSLASHVref] = ACTIONS(6097),
    [anon_sym_BSLASHautoref] = ACTIONS(6097),
    [anon_sym_BSLASHpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcref] = ACTIONS(6097),
    [anon_sym_BSLASHCref] = ACTIONS(6097),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnameCref] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHdef] = ACTIONS(6097),
    [anon_sym_BSLASHlet] = ACTIONS(6097),
    [anon_sym_BSLASHleft] = ACTIONS(6097),
    [anon_sym_BSLASHbigl] = ACTIONS(6097),
    [anon_sym_BSLASHBigl] = ACTIONS(6097),
    [anon_sym_BSLASHbiggl] = ACTIONS(6097),
    [anon_sym_BSLASHBiggl] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6097),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6097),
    [anon_sym_BSLASHgls] = ACTIONS(6097),
    [anon_sym_BSLASHGls] = ACTIONS(6097),
    [anon_sym_BSLASHGLS] = ACTIONS(6097),
    [anon_sym_BSLASHglspl] = ACTIONS(6097),
    [anon_sym_BSLASHGlspl] = ACTIONS(6097),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6097),
    [anon_sym_BSLASHglslink] = ACTIONS(6097),
    [anon_sym_BSLASHglstext] = ACTIONS(6097),
    [anon_sym_BSLASHGlstext] = ACTIONS(6097),
    [anon_sym_BSLASHGLStext] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6097),
    [anon_sym_BSLASHglsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsname] = ACTIONS(6097),
    [anon_sym_BSLASHGlsname] = ACTIONS(6097),
    [anon_sym_BSLASHGLSname] = ACTIONS(6097),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6097),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6097),
    [anon_sym_BSLASHacrshort] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6097),
    [anon_sym_BSLASHACRshort] = ACTIONS(6097),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrlong] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6097),
    [anon_sym_BSLASHACRlong] = ACTIONS(6097),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrfull] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6097),
    [anon_sym_BSLASHACRfull] = ACTIONS(6097),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHacs] = ACTIONS(6097),
    [anon_sym_BSLASHAcs] = ACTIONS(6097),
    [anon_sym_BSLASHacsp] = ACTIONS(6097),
    [anon_sym_BSLASHAcsp] = ACTIONS(6097),
    [anon_sym_BSLASHacl] = ACTIONS(6097),
    [anon_sym_BSLASHAcl] = ACTIONS(6097),
    [anon_sym_BSLASHaclp] = ACTIONS(6097),
    [anon_sym_BSLASHAclp] = ACTIONS(6097),
    [anon_sym_BSLASHacf] = ACTIONS(6097),
    [anon_sym_BSLASHAcf] = ACTIONS(6097),
    [anon_sym_BSLASHacfp] = ACTIONS(6097),
    [anon_sym_BSLASHAcfp] = ACTIONS(6097),
    [anon_sym_BSLASHac] = ACTIONS(6097),
    [anon_sym_BSLASHAc] = ACTIONS(6097),
    [anon_sym_BSLASHacp] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6097),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6097),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6097),
    [anon_sym_BSLASHcolor] = ACTIONS(6097),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6097),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6097),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6097),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6097),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6097),
    [anon_sym_BSLASHtext] = ACTIONS(6097),
    [anon_sym_BSLASHintertext] = ACTIONS(6097),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6097),
    [anon_sym_BSLASHurl] = ACTIONS(6097),
    [anon_sym_BSLASHhref] = ACTIONS(6097),
  },
  [521] = {
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_RBRACK] = ACTIONS(6340),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_EQ] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHpart] = ACTIONS(6338),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddpart] = ACTIONS(6338),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHchapter] = ACTIONS(6338),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddchap] = ACTIONS(6338),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsection] = ACTIONS(6338),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddsec] = ACTIONS(6338),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHitem] = ACTIONS(6338),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6340),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6340),
    [anon_sym_DOLLAR] = ACTIONS(6338),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHbegin] = ACTIONS(6338),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHleft] = ACTIONS(6338),
    [anon_sym_BSLASHbigl] = ACTIONS(6338),
    [anon_sym_BSLASHBigl] = ACTIONS(6338),
    [anon_sym_BSLASHbiggl] = ACTIONS(6338),
    [anon_sym_BSLASHBiggl] = ACTIONS(6338),
    [anon_sym_BSLASHright] = ACTIONS(6338),
    [anon_sym_BSLASHbigr] = ACTIONS(6338),
    [anon_sym_BSLASHBigr] = ACTIONS(6338),
    [anon_sym_BSLASHbiggr] = ACTIONS(6338),
    [anon_sym_BSLASHBiggr] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHtext] = ACTIONS(6338),
    [anon_sym_BSLASHintertext] = ACTIONS(6338),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [522] = {
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_RPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHpart] = ACTIONS(6342),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddpart] = ACTIONS(6342),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHchapter] = ACTIONS(6342),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddchap] = ACTIONS(6342),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsection] = ACTIONS(6342),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddsec] = ACTIONS(6342),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHitem] = ACTIONS(6342),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6344),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6344),
    [anon_sym_DOLLAR] = ACTIONS(6342),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHbegin] = ACTIONS(6342),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHleft] = ACTIONS(6342),
    [anon_sym_BSLASHbigl] = ACTIONS(6342),
    [anon_sym_BSLASHBigl] = ACTIONS(6342),
    [anon_sym_BSLASHbiggl] = ACTIONS(6342),
    [anon_sym_BSLASHBiggl] = ACTIONS(6342),
    [anon_sym_BSLASHright] = ACTIONS(6342),
    [anon_sym_BSLASHbigr] = ACTIONS(6342),
    [anon_sym_BSLASHBigr] = ACTIONS(6342),
    [anon_sym_BSLASHbiggr] = ACTIONS(6342),
    [anon_sym_BSLASHBiggr] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHtext] = ACTIONS(6342),
    [anon_sym_BSLASHintertext] = ACTIONS(6342),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [523] = {
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [anon_sym_RPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHpart] = ACTIONS(6346),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddpart] = ACTIONS(6346),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHchapter] = ACTIONS(6346),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddchap] = ACTIONS(6346),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsection] = ACTIONS(6346),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddsec] = ACTIONS(6346),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHitem] = ACTIONS(6346),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6348),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6348),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6348),
    [anon_sym_DOLLAR] = ACTIONS(6346),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHbegin] = ACTIONS(6346),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHleft] = ACTIONS(6346),
    [anon_sym_BSLASHbigl] = ACTIONS(6346),
    [anon_sym_BSLASHBigl] = ACTIONS(6346),
    [anon_sym_BSLASHbiggl] = ACTIONS(6346),
    [anon_sym_BSLASHBiggl] = ACTIONS(6346),
    [anon_sym_BSLASHright] = ACTIONS(6346),
    [anon_sym_BSLASHbigr] = ACTIONS(6346),
    [anon_sym_BSLASHBigr] = ACTIONS(6346),
    [anon_sym_BSLASHbiggr] = ACTIONS(6346),
    [anon_sym_BSLASHBiggr] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHtext] = ACTIONS(6346),
    [anon_sym_BSLASHintertext] = ACTIONS(6346),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [524] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(5955),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [anon_sym_RBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [525] = {
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_RBRACK] = ACTIONS(6352),
    [anon_sym_COMMA] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_LPAREN] = ACTIONS(6352),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHpart] = ACTIONS(6350),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddpart] = ACTIONS(6350),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHchapter] = ACTIONS(6350),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddchap] = ACTIONS(6350),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsection] = ACTIONS(6350),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddsec] = ACTIONS(6350),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHitem] = ACTIONS(6350),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6352),
    [anon_sym_LBRACE] = ACTIONS(6352),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6352),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6352),
    [anon_sym_DOLLAR] = ACTIONS(6350),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHbegin] = ACTIONS(6350),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHleft] = ACTIONS(6350),
    [anon_sym_BSLASHbigl] = ACTIONS(6350),
    [anon_sym_BSLASHBigl] = ACTIONS(6350),
    [anon_sym_BSLASHbiggl] = ACTIONS(6350),
    [anon_sym_BSLASHBiggl] = ACTIONS(6350),
    [anon_sym_BSLASHright] = ACTIONS(6350),
    [anon_sym_BSLASHbigr] = ACTIONS(6350),
    [anon_sym_BSLASHBigr] = ACTIONS(6350),
    [anon_sym_BSLASHbiggr] = ACTIONS(6350),
    [anon_sym_BSLASHBiggr] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHtext] = ACTIONS(6350),
    [anon_sym_BSLASHintertext] = ACTIONS(6350),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [526] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(2146),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [anon_sym_RBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [527] = {
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_RBRACK] = ACTIONS(6356),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_EQ] = ACTIONS(6356),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_RPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHpart] = ACTIONS(6354),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddpart] = ACTIONS(6354),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHchapter] = ACTIONS(6354),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddchap] = ACTIONS(6354),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsection] = ACTIONS(6354),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddsec] = ACTIONS(6354),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHitem] = ACTIONS(6354),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6356),
    [anon_sym_LBRACE] = ACTIONS(6356),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6356),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6356),
    [anon_sym_DOLLAR] = ACTIONS(6354),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHbegin] = ACTIONS(6354),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHleft] = ACTIONS(6354),
    [anon_sym_BSLASHbigl] = ACTIONS(6354),
    [anon_sym_BSLASHBigl] = ACTIONS(6354),
    [anon_sym_BSLASHbiggl] = ACTIONS(6354),
    [anon_sym_BSLASHBiggl] = ACTIONS(6354),
    [anon_sym_BSLASHright] = ACTIONS(6354),
    [anon_sym_BSLASHbigr] = ACTIONS(6354),
    [anon_sym_BSLASHBigr] = ACTIONS(6354),
    [anon_sym_BSLASHbiggr] = ACTIONS(6354),
    [anon_sym_BSLASHBiggr] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHtext] = ACTIONS(6354),
    [anon_sym_BSLASHintertext] = ACTIONS(6354),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [528] = {
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_RBRACK] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LPAREN] = ACTIONS(6360),
    [anon_sym_RPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHpart] = ACTIONS(6358),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddpart] = ACTIONS(6358),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHchapter] = ACTIONS(6358),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddchap] = ACTIONS(6358),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsection] = ACTIONS(6358),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddsec] = ACTIONS(6358),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHitem] = ACTIONS(6358),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(6360),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6360),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6358),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHbegin] = ACTIONS(6358),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHleft] = ACTIONS(6358),
    [anon_sym_BSLASHbigl] = ACTIONS(6358),
    [anon_sym_BSLASHBigl] = ACTIONS(6358),
    [anon_sym_BSLASHbiggl] = ACTIONS(6358),
    [anon_sym_BSLASHBiggl] = ACTIONS(6358),
    [anon_sym_BSLASHright] = ACTIONS(6358),
    [anon_sym_BSLASHbigr] = ACTIONS(6358),
    [anon_sym_BSLASHBigr] = ACTIONS(6358),
    [anon_sym_BSLASHbiggr] = ACTIONS(6358),
    [anon_sym_BSLASHBiggr] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHtext] = ACTIONS(6358),
    [anon_sym_BSLASHintertext] = ACTIONS(6358),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [529] = {
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LPAREN] = ACTIONS(6364),
    [anon_sym_RPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHpart] = ACTIONS(6362),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddpart] = ACTIONS(6362),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHchapter] = ACTIONS(6362),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddchap] = ACTIONS(6362),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsection] = ACTIONS(6362),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddsec] = ACTIONS(6362),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHitem] = ACTIONS(6362),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6364),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6364),
    [anon_sym_DOLLAR] = ACTIONS(6362),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHbegin] = ACTIONS(6362),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHleft] = ACTIONS(6362),
    [anon_sym_BSLASHbigl] = ACTIONS(6362),
    [anon_sym_BSLASHBigl] = ACTIONS(6362),
    [anon_sym_BSLASHbiggl] = ACTIONS(6362),
    [anon_sym_BSLASHBiggl] = ACTIONS(6362),
    [anon_sym_BSLASHright] = ACTIONS(6362),
    [anon_sym_BSLASHbigr] = ACTIONS(6362),
    [anon_sym_BSLASHBigr] = ACTIONS(6362),
    [anon_sym_BSLASHbiggr] = ACTIONS(6362),
    [anon_sym_BSLASHBiggr] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHtext] = ACTIONS(6362),
    [anon_sym_BSLASHintertext] = ACTIONS(6362),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [530] = {
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_RBRACK] = ACTIONS(6368),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_LPAREN] = ACTIONS(6368),
    [anon_sym_RPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHpart] = ACTIONS(6366),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddpart] = ACTIONS(6366),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHchapter] = ACTIONS(6366),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddchap] = ACTIONS(6366),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsection] = ACTIONS(6366),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddsec] = ACTIONS(6366),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHitem] = ACTIONS(6366),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6368),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6368),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6366),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHbegin] = ACTIONS(6366),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHleft] = ACTIONS(6366),
    [anon_sym_BSLASHbigl] = ACTIONS(6366),
    [anon_sym_BSLASHBigl] = ACTIONS(6366),
    [anon_sym_BSLASHbiggl] = ACTIONS(6366),
    [anon_sym_BSLASHBiggl] = ACTIONS(6366),
    [anon_sym_BSLASHright] = ACTIONS(6366),
    [anon_sym_BSLASHbigr] = ACTIONS(6366),
    [anon_sym_BSLASHBigr] = ACTIONS(6366),
    [anon_sym_BSLASHbiggr] = ACTIONS(6366),
    [anon_sym_BSLASHBiggr] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHtext] = ACTIONS(6366),
    [anon_sym_BSLASHintertext] = ACTIONS(6366),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [531] = {
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_RBRACK] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LPAREN] = ACTIONS(6372),
    [anon_sym_RPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHpart] = ACTIONS(6370),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddpart] = ACTIONS(6370),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHchapter] = ACTIONS(6370),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddchap] = ACTIONS(6370),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsection] = ACTIONS(6370),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddsec] = ACTIONS(6370),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHitem] = ACTIONS(6370),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6372),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6370),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHbegin] = ACTIONS(6370),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHleft] = ACTIONS(6370),
    [anon_sym_BSLASHbigl] = ACTIONS(6370),
    [anon_sym_BSLASHBigl] = ACTIONS(6370),
    [anon_sym_BSLASHbiggl] = ACTIONS(6370),
    [anon_sym_BSLASHBiggl] = ACTIONS(6370),
    [anon_sym_BSLASHright] = ACTIONS(6370),
    [anon_sym_BSLASHbigr] = ACTIONS(6370),
    [anon_sym_BSLASHBigr] = ACTIONS(6370),
    [anon_sym_BSLASHbiggr] = ACTIONS(6370),
    [anon_sym_BSLASHBiggr] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHtext] = ACTIONS(6370),
    [anon_sym_BSLASHintertext] = ACTIONS(6370),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [532] = {
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_LBRACK] = ACTIONS(6376),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_EQ] = ACTIONS(6376),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHpart] = ACTIONS(6374),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddpart] = ACTIONS(6374),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHchapter] = ACTIONS(6374),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddchap] = ACTIONS(6374),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsection] = ACTIONS(6374),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddsec] = ACTIONS(6374),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHitem] = ACTIONS(6374),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6376),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6376),
    [anon_sym_DOLLAR] = ACTIONS(6374),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHbegin] = ACTIONS(6374),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHleft] = ACTIONS(6374),
    [anon_sym_BSLASHbigl] = ACTIONS(6374),
    [anon_sym_BSLASHBigl] = ACTIONS(6374),
    [anon_sym_BSLASHbiggl] = ACTIONS(6374),
    [anon_sym_BSLASHBiggl] = ACTIONS(6374),
    [anon_sym_BSLASHright] = ACTIONS(6374),
    [anon_sym_BSLASHbigr] = ACTIONS(6374),
    [anon_sym_BSLASHBigr] = ACTIONS(6374),
    [anon_sym_BSLASHbiggr] = ACTIONS(6374),
    [anon_sym_BSLASHBiggr] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHtext] = ACTIONS(6374),
    [anon_sym_BSLASHintertext] = ACTIONS(6374),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [533] = {
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_LBRACK] = ACTIONS(6380),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_EQ] = ACTIONS(6380),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHpart] = ACTIONS(6378),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddpart] = ACTIONS(6378),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHchapter] = ACTIONS(6378),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddchap] = ACTIONS(6378),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsection] = ACTIONS(6378),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddsec] = ACTIONS(6378),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHitem] = ACTIONS(6378),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6380),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6380),
    [anon_sym_DOLLAR] = ACTIONS(6378),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHbegin] = ACTIONS(6378),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHleft] = ACTIONS(6378),
    [anon_sym_BSLASHbigl] = ACTIONS(6378),
    [anon_sym_BSLASHBigl] = ACTIONS(6378),
    [anon_sym_BSLASHbiggl] = ACTIONS(6378),
    [anon_sym_BSLASHBiggl] = ACTIONS(6378),
    [anon_sym_BSLASHright] = ACTIONS(6378),
    [anon_sym_BSLASHbigr] = ACTIONS(6378),
    [anon_sym_BSLASHBigr] = ACTIONS(6378),
    [anon_sym_BSLASHbiggr] = ACTIONS(6378),
    [anon_sym_BSLASHBiggr] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHtext] = ACTIONS(6378),
    [anon_sym_BSLASHintertext] = ACTIONS(6378),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [534] = {
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_LBRACK] = ACTIONS(6384),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_EQ] = ACTIONS(6384),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_RPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHpart] = ACTIONS(6382),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddpart] = ACTIONS(6382),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHchapter] = ACTIONS(6382),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddchap] = ACTIONS(6382),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsection] = ACTIONS(6382),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddsec] = ACTIONS(6382),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHitem] = ACTIONS(6382),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6384),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6384),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(6382),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHbegin] = ACTIONS(6382),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHleft] = ACTIONS(6382),
    [anon_sym_BSLASHbigl] = ACTIONS(6382),
    [anon_sym_BSLASHBigl] = ACTIONS(6382),
    [anon_sym_BSLASHbiggl] = ACTIONS(6382),
    [anon_sym_BSLASHBiggl] = ACTIONS(6382),
    [anon_sym_BSLASHright] = ACTIONS(6382),
    [anon_sym_BSLASHbigr] = ACTIONS(6382),
    [anon_sym_BSLASHBigr] = ACTIONS(6382),
    [anon_sym_BSLASHbiggr] = ACTIONS(6382),
    [anon_sym_BSLASHBiggr] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHtext] = ACTIONS(6382),
    [anon_sym_BSLASHintertext] = ACTIONS(6382),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [535] = {
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_COMMA] = ACTIONS(6388),
    [anon_sym_EQ] = ACTIONS(6388),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHpart] = ACTIONS(6386),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddpart] = ACTIONS(6386),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHchapter] = ACTIONS(6386),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddchap] = ACTIONS(6386),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsection] = ACTIONS(6386),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddsec] = ACTIONS(6386),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHitem] = ACTIONS(6386),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6388),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(6386),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHbegin] = ACTIONS(6386),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHleft] = ACTIONS(6386),
    [anon_sym_BSLASHbigl] = ACTIONS(6386),
    [anon_sym_BSLASHBigl] = ACTIONS(6386),
    [anon_sym_BSLASHbiggl] = ACTIONS(6386),
    [anon_sym_BSLASHBiggl] = ACTIONS(6386),
    [anon_sym_BSLASHright] = ACTIONS(6386),
    [anon_sym_BSLASHbigr] = ACTIONS(6386),
    [anon_sym_BSLASHBigr] = ACTIONS(6386),
    [anon_sym_BSLASHbiggr] = ACTIONS(6386),
    [anon_sym_BSLASHBiggr] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHtext] = ACTIONS(6386),
    [anon_sym_BSLASHintertext] = ACTIONS(6386),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [536] = {
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_COMMA] = ACTIONS(6392),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHpart] = ACTIONS(6390),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddpart] = ACTIONS(6390),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHchapter] = ACTIONS(6390),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddchap] = ACTIONS(6390),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsection] = ACTIONS(6390),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddsec] = ACTIONS(6390),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHitem] = ACTIONS(6390),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6392),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(6390),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHbegin] = ACTIONS(6390),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHleft] = ACTIONS(6390),
    [anon_sym_BSLASHbigl] = ACTIONS(6390),
    [anon_sym_BSLASHBigl] = ACTIONS(6390),
    [anon_sym_BSLASHbiggl] = ACTIONS(6390),
    [anon_sym_BSLASHBiggl] = ACTIONS(6390),
    [anon_sym_BSLASHright] = ACTIONS(6390),
    [anon_sym_BSLASHbigr] = ACTIONS(6390),
    [anon_sym_BSLASHBigr] = ACTIONS(6390),
    [anon_sym_BSLASHbiggr] = ACTIONS(6390),
    [anon_sym_BSLASHBiggr] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHtext] = ACTIONS(6390),
    [anon_sym_BSLASHintertext] = ACTIONS(6390),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [537] = {
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6396),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6396),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHpart] = ACTIONS(6394),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddpart] = ACTIONS(6394),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHchapter] = ACTIONS(6394),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddchap] = ACTIONS(6394),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsection] = ACTIONS(6394),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddsec] = ACTIONS(6394),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHitem] = ACTIONS(6394),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6396),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6396),
    [anon_sym_DOLLAR] = ACTIONS(6394),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHbegin] = ACTIONS(6394),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHleft] = ACTIONS(6394),
    [anon_sym_BSLASHbigl] = ACTIONS(6394),
    [anon_sym_BSLASHBigl] = ACTIONS(6394),
    [anon_sym_BSLASHbiggl] = ACTIONS(6394),
    [anon_sym_BSLASHBiggl] = ACTIONS(6394),
    [anon_sym_BSLASHright] = ACTIONS(6394),
    [anon_sym_BSLASHbigr] = ACTIONS(6394),
    [anon_sym_BSLASHBigr] = ACTIONS(6394),
    [anon_sym_BSLASHbiggr] = ACTIONS(6394),
    [anon_sym_BSLASHBiggr] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHtext] = ACTIONS(6394),
    [anon_sym_BSLASHintertext] = ACTIONS(6394),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [538] = {
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6400),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHpart] = ACTIONS(6398),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddpart] = ACTIONS(6398),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHchapter] = ACTIONS(6398),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddchap] = ACTIONS(6398),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsection] = ACTIONS(6398),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddsec] = ACTIONS(6398),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHitem] = ACTIONS(6398),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6400),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHbegin] = ACTIONS(6398),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHleft] = ACTIONS(6398),
    [anon_sym_BSLASHbigl] = ACTIONS(6398),
    [anon_sym_BSLASHBigl] = ACTIONS(6398),
    [anon_sym_BSLASHbiggl] = ACTIONS(6398),
    [anon_sym_BSLASHBiggl] = ACTIONS(6398),
    [anon_sym_BSLASHright] = ACTIONS(6398),
    [anon_sym_BSLASHbigr] = ACTIONS(6398),
    [anon_sym_BSLASHBigr] = ACTIONS(6398),
    [anon_sym_BSLASHbiggr] = ACTIONS(6398),
    [anon_sym_BSLASHBiggr] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHtext] = ACTIONS(6398),
    [anon_sym_BSLASHintertext] = ACTIONS(6398),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [539] = {
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6404),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6404),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHpart] = ACTIONS(6402),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddpart] = ACTIONS(6402),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHchapter] = ACTIONS(6402),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddchap] = ACTIONS(6402),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsection] = ACTIONS(6402),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddsec] = ACTIONS(6402),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHitem] = ACTIONS(6402),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6404),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6404),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6404),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHbegin] = ACTIONS(6402),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHleft] = ACTIONS(6402),
    [anon_sym_BSLASHbigl] = ACTIONS(6402),
    [anon_sym_BSLASHBigl] = ACTIONS(6402),
    [anon_sym_BSLASHbiggl] = ACTIONS(6402),
    [anon_sym_BSLASHBiggl] = ACTIONS(6402),
    [anon_sym_BSLASHright] = ACTIONS(6402),
    [anon_sym_BSLASHbigr] = ACTIONS(6402),
    [anon_sym_BSLASHBigr] = ACTIONS(6402),
    [anon_sym_BSLASHbiggr] = ACTIONS(6402),
    [anon_sym_BSLASHBiggr] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHtext] = ACTIONS(6402),
    [anon_sym_BSLASHintertext] = ACTIONS(6402),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [540] = {
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHpart] = ACTIONS(6406),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddpart] = ACTIONS(6406),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHchapter] = ACTIONS(6406),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddchap] = ACTIONS(6406),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsection] = ACTIONS(6406),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddsec] = ACTIONS(6406),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHitem] = ACTIONS(6406),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6408),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6408),
    [anon_sym_DOLLAR] = ACTIONS(6406),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHbegin] = ACTIONS(6406),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHleft] = ACTIONS(6406),
    [anon_sym_BSLASHbigl] = ACTIONS(6406),
    [anon_sym_BSLASHBigl] = ACTIONS(6406),
    [anon_sym_BSLASHbiggl] = ACTIONS(6406),
    [anon_sym_BSLASHBiggl] = ACTIONS(6406),
    [anon_sym_BSLASHright] = ACTIONS(6406),
    [anon_sym_BSLASHbigr] = ACTIONS(6406),
    [anon_sym_BSLASHBigr] = ACTIONS(6406),
    [anon_sym_BSLASHbiggr] = ACTIONS(6406),
    [anon_sym_BSLASHBiggr] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHtext] = ACTIONS(6406),
    [anon_sym_BSLASHintertext] = ACTIONS(6406),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [541] = {
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6412),
    [anon_sym_RBRACK] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHpart] = ACTIONS(6410),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddpart] = ACTIONS(6410),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHchapter] = ACTIONS(6410),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddchap] = ACTIONS(6410),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsection] = ACTIONS(6410),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddsec] = ACTIONS(6410),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHitem] = ACTIONS(6410),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6412),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6412),
    [anon_sym_DOLLAR] = ACTIONS(6410),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHbegin] = ACTIONS(6410),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHleft] = ACTIONS(6410),
    [anon_sym_BSLASHbigl] = ACTIONS(6410),
    [anon_sym_BSLASHBigl] = ACTIONS(6410),
    [anon_sym_BSLASHbiggl] = ACTIONS(6410),
    [anon_sym_BSLASHBiggl] = ACTIONS(6410),
    [anon_sym_BSLASHright] = ACTIONS(6410),
    [anon_sym_BSLASHbigr] = ACTIONS(6410),
    [anon_sym_BSLASHBigr] = ACTIONS(6410),
    [anon_sym_BSLASHbiggr] = ACTIONS(6410),
    [anon_sym_BSLASHBiggr] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHtext] = ACTIONS(6410),
    [anon_sym_BSLASHintertext] = ACTIONS(6410),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [542] = {
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6416),
    [anon_sym_EQ] = ACTIONS(6416),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_RPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHpart] = ACTIONS(6414),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddpart] = ACTIONS(6414),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHchapter] = ACTIONS(6414),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddchap] = ACTIONS(6414),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsection] = ACTIONS(6414),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddsec] = ACTIONS(6414),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHitem] = ACTIONS(6414),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6416),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(6414),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHbegin] = ACTIONS(6414),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHleft] = ACTIONS(6414),
    [anon_sym_BSLASHbigl] = ACTIONS(6414),
    [anon_sym_BSLASHBigl] = ACTIONS(6414),
    [anon_sym_BSLASHbiggl] = ACTIONS(6414),
    [anon_sym_BSLASHBiggl] = ACTIONS(6414),
    [anon_sym_BSLASHright] = ACTIONS(6414),
    [anon_sym_BSLASHbigr] = ACTIONS(6414),
    [anon_sym_BSLASHBigr] = ACTIONS(6414),
    [anon_sym_BSLASHbiggr] = ACTIONS(6414),
    [anon_sym_BSLASHBiggr] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHtext] = ACTIONS(6414),
    [anon_sym_BSLASHintertext] = ACTIONS(6414),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [543] = {
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_RBRACK] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHpart] = ACTIONS(6418),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddpart] = ACTIONS(6418),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHchapter] = ACTIONS(6418),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddchap] = ACTIONS(6418),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsection] = ACTIONS(6418),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddsec] = ACTIONS(6418),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHitem] = ACTIONS(6418),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6420),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6420),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(6418),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHbegin] = ACTIONS(6418),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHleft] = ACTIONS(6418),
    [anon_sym_BSLASHbigl] = ACTIONS(6418),
    [anon_sym_BSLASHBigl] = ACTIONS(6418),
    [anon_sym_BSLASHbiggl] = ACTIONS(6418),
    [anon_sym_BSLASHBiggl] = ACTIONS(6418),
    [anon_sym_BSLASHright] = ACTIONS(6418),
    [anon_sym_BSLASHbigr] = ACTIONS(6418),
    [anon_sym_BSLASHBigr] = ACTIONS(6418),
    [anon_sym_BSLASHbiggr] = ACTIONS(6418),
    [anon_sym_BSLASHBiggr] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHtext] = ACTIONS(6418),
    [anon_sym_BSLASHintertext] = ACTIONS(6418),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [544] = {
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_LBRACK] = ACTIONS(6424),
    [anon_sym_RBRACK] = ACTIONS(6424),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_EQ] = ACTIONS(6424),
    [anon_sym_LPAREN] = ACTIONS(6424),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHpart] = ACTIONS(6422),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddpart] = ACTIONS(6422),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHchapter] = ACTIONS(6422),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddchap] = ACTIONS(6422),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsection] = ACTIONS(6422),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddsec] = ACTIONS(6422),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHitem] = ACTIONS(6422),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6424),
    [anon_sym_LBRACE] = ACTIONS(6424),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6424),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6424),
    [anon_sym_DOLLAR] = ACTIONS(6422),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHbegin] = ACTIONS(6422),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHleft] = ACTIONS(6422),
    [anon_sym_BSLASHbigl] = ACTIONS(6422),
    [anon_sym_BSLASHBigl] = ACTIONS(6422),
    [anon_sym_BSLASHbiggl] = ACTIONS(6422),
    [anon_sym_BSLASHBiggl] = ACTIONS(6422),
    [anon_sym_BSLASHright] = ACTIONS(6422),
    [anon_sym_BSLASHbigr] = ACTIONS(6422),
    [anon_sym_BSLASHBigr] = ACTIONS(6422),
    [anon_sym_BSLASHbiggr] = ACTIONS(6422),
    [anon_sym_BSLASHBiggr] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHtext] = ACTIONS(6422),
    [anon_sym_BSLASHintertext] = ACTIONS(6422),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [545] = {
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_RBRACK] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6428),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_RPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHpart] = ACTIONS(6426),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddpart] = ACTIONS(6426),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHchapter] = ACTIONS(6426),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddchap] = ACTIONS(6426),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsection] = ACTIONS(6426),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddsec] = ACTIONS(6426),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHitem] = ACTIONS(6426),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6428),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6428),
    [anon_sym_DOLLAR] = ACTIONS(6426),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHbegin] = ACTIONS(6426),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHleft] = ACTIONS(6426),
    [anon_sym_BSLASHbigl] = ACTIONS(6426),
    [anon_sym_BSLASHBigl] = ACTIONS(6426),
    [anon_sym_BSLASHbiggl] = ACTIONS(6426),
    [anon_sym_BSLASHBiggl] = ACTIONS(6426),
    [anon_sym_BSLASHright] = ACTIONS(6426),
    [anon_sym_BSLASHbigr] = ACTIONS(6426),
    [anon_sym_BSLASHBigr] = ACTIONS(6426),
    [anon_sym_BSLASHbiggr] = ACTIONS(6426),
    [anon_sym_BSLASHBiggr] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHtext] = ACTIONS(6426),
    [anon_sym_BSLASHintertext] = ACTIONS(6426),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [546] = {
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHpart] = ACTIONS(6430),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddpart] = ACTIONS(6430),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHchapter] = ACTIONS(6430),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddchap] = ACTIONS(6430),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsection] = ACTIONS(6430),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddsec] = ACTIONS(6430),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHitem] = ACTIONS(6430),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6432),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6432),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6432),
    [anon_sym_DOLLAR] = ACTIONS(6430),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHbegin] = ACTIONS(6430),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHleft] = ACTIONS(6430),
    [anon_sym_BSLASHbigl] = ACTIONS(6430),
    [anon_sym_BSLASHBigl] = ACTIONS(6430),
    [anon_sym_BSLASHbiggl] = ACTIONS(6430),
    [anon_sym_BSLASHBiggl] = ACTIONS(6430),
    [anon_sym_BSLASHright] = ACTIONS(6430),
    [anon_sym_BSLASHbigr] = ACTIONS(6430),
    [anon_sym_BSLASHBigr] = ACTIONS(6430),
    [anon_sym_BSLASHbiggr] = ACTIONS(6430),
    [anon_sym_BSLASHBiggr] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHtext] = ACTIONS(6430),
    [anon_sym_BSLASHintertext] = ACTIONS(6430),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [547] = {
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6436),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_EQ] = ACTIONS(6436),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHpart] = ACTIONS(6434),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddpart] = ACTIONS(6434),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHchapter] = ACTIONS(6434),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddchap] = ACTIONS(6434),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsection] = ACTIONS(6434),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddsec] = ACTIONS(6434),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHitem] = ACTIONS(6434),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6436),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6436),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6436),
    [anon_sym_DOLLAR] = ACTIONS(6434),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHbegin] = ACTIONS(6434),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHleft] = ACTIONS(6434),
    [anon_sym_BSLASHbigl] = ACTIONS(6434),
    [anon_sym_BSLASHBigl] = ACTIONS(6434),
    [anon_sym_BSLASHbiggl] = ACTIONS(6434),
    [anon_sym_BSLASHBiggl] = ACTIONS(6434),
    [anon_sym_BSLASHright] = ACTIONS(6434),
    [anon_sym_BSLASHbigr] = ACTIONS(6434),
    [anon_sym_BSLASHBigr] = ACTIONS(6434),
    [anon_sym_BSLASHbiggr] = ACTIONS(6434),
    [anon_sym_BSLASHBiggr] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHtext] = ACTIONS(6434),
    [anon_sym_BSLASHintertext] = ACTIONS(6434),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [548] = {
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_LBRACK] = ACTIONS(6440),
    [anon_sym_RBRACK] = ACTIONS(6440),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6440),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_RPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHpart] = ACTIONS(6438),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddpart] = ACTIONS(6438),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHchapter] = ACTIONS(6438),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddchap] = ACTIONS(6438),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsection] = ACTIONS(6438),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddsec] = ACTIONS(6438),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHitem] = ACTIONS(6438),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6440),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6440),
    [anon_sym_DOLLAR] = ACTIONS(6438),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHbegin] = ACTIONS(6438),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHleft] = ACTIONS(6438),
    [anon_sym_BSLASHbigl] = ACTIONS(6438),
    [anon_sym_BSLASHBigl] = ACTIONS(6438),
    [anon_sym_BSLASHbiggl] = ACTIONS(6438),
    [anon_sym_BSLASHBiggl] = ACTIONS(6438),
    [anon_sym_BSLASHright] = ACTIONS(6438),
    [anon_sym_BSLASHbigr] = ACTIONS(6438),
    [anon_sym_BSLASHBigr] = ACTIONS(6438),
    [anon_sym_BSLASHbiggr] = ACTIONS(6438),
    [anon_sym_BSLASHBiggr] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHtext] = ACTIONS(6438),
    [anon_sym_BSLASHintertext] = ACTIONS(6438),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [549] = {
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6444),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHpart] = ACTIONS(6442),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddpart] = ACTIONS(6442),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHchapter] = ACTIONS(6442),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddchap] = ACTIONS(6442),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsection] = ACTIONS(6442),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddsec] = ACTIONS(6442),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHitem] = ACTIONS(6442),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6444),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6444),
    [anon_sym_DOLLAR] = ACTIONS(6442),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHbegin] = ACTIONS(6442),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHleft] = ACTIONS(6442),
    [anon_sym_BSLASHbigl] = ACTIONS(6442),
    [anon_sym_BSLASHBigl] = ACTIONS(6442),
    [anon_sym_BSLASHbiggl] = ACTIONS(6442),
    [anon_sym_BSLASHBiggl] = ACTIONS(6442),
    [anon_sym_BSLASHright] = ACTIONS(6442),
    [anon_sym_BSLASHbigr] = ACTIONS(6442),
    [anon_sym_BSLASHBigr] = ACTIONS(6442),
    [anon_sym_BSLASHbiggr] = ACTIONS(6442),
    [anon_sym_BSLASHBiggr] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHtext] = ACTIONS(6442),
    [anon_sym_BSLASHintertext] = ACTIONS(6442),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [550] = {
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6448),
    [anon_sym_RBRACK] = ACTIONS(6448),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(6448),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHpart] = ACTIONS(6446),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddpart] = ACTIONS(6446),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHchapter] = ACTIONS(6446),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddchap] = ACTIONS(6446),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsection] = ACTIONS(6446),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddsec] = ACTIONS(6446),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHitem] = ACTIONS(6446),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6448),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6448),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6448),
    [anon_sym_DOLLAR] = ACTIONS(6446),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHbegin] = ACTIONS(6446),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHleft] = ACTIONS(6446),
    [anon_sym_BSLASHbigl] = ACTIONS(6446),
    [anon_sym_BSLASHBigl] = ACTIONS(6446),
    [anon_sym_BSLASHbiggl] = ACTIONS(6446),
    [anon_sym_BSLASHBiggl] = ACTIONS(6446),
    [anon_sym_BSLASHright] = ACTIONS(6446),
    [anon_sym_BSLASHbigr] = ACTIONS(6446),
    [anon_sym_BSLASHBigr] = ACTIONS(6446),
    [anon_sym_BSLASHbiggr] = ACTIONS(6446),
    [anon_sym_BSLASHBiggr] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHtext] = ACTIONS(6446),
    [anon_sym_BSLASHintertext] = ACTIONS(6446),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [551] = {
    [sym__section_part] = STATE(923),
    [sym_curly_group] = STATE(979),
    [sym_brack_group] = STATE(2882),
    [ts_builtin_sym_end] = ACTIONS(6063),
    [sym_command_name] = ACTIONS(6061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(6063),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHpart] = ACTIONS(6061),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddpart] = ACTIONS(6061),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHchapter] = ACTIONS(6061),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddchap] = ACTIONS(6061),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsection] = ACTIONS(6061),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddsec] = ACTIONS(6061),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHitem] = ACTIONS(6061),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6063),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6063),
    [sym_word] = ACTIONS(6061),
    [sym_placeholder] = ACTIONS(6063),
    [anon_sym_PLUS] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6063),
    [anon_sym_STAR] = ACTIONS(6063),
    [anon_sym_SLASH] = ACTIONS(6063),
    [anon_sym_LT] = ACTIONS(6061),
    [anon_sym_GT] = ACTIONS(6061),
    [anon_sym_BANG] = ACTIONS(6061),
    [anon_sym_PIPE] = ACTIONS(6061),
    [anon_sym_COLON] = ACTIONS(6061),
    [anon_sym_SQUOTE] = ACTIONS(6061),
    [anon_sym__] = ACTIONS(6063),
    [anon_sym_CARET] = ACTIONS(6063),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6063),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6063),
    [anon_sym_DOLLAR] = ACTIONS(6061),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHbegin] = ACTIONS(6061),
    [anon_sym_BSLASHtitle] = ACTIONS(6061),
    [anon_sym_BSLASHauthor] = ACTIONS(6061),
    [anon_sym_BSLASHusepackage] = ACTIONS(6061),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6061),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6061),
    [anon_sym_BSLASHinclude] = ACTIONS(6061),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6061),
    [anon_sym_BSLASHinput] = ACTIONS(6061),
    [anon_sym_BSLASHsubfile] = ACTIONS(6061),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6061),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6061),
    [anon_sym_BSLASHbibliography] = ACTIONS(6061),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6061),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6061),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6061),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6061),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6061),
    [anon_sym_BSLASHimport] = ACTIONS(6061),
    [anon_sym_BSLASHsubimport] = ACTIONS(6061),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6061),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHcaption] = ACTIONS(6061),
    [anon_sym_BSLASHcite] = ACTIONS(6061),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCite] = ACTIONS(6061),
    [anon_sym_BSLASHnocite] = ACTIONS(6061),
    [anon_sym_BSLASHcitet] = ACTIONS(6061),
    [anon_sym_BSLASHcitep] = ACTIONS(6061),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteA] = ACTIONS(6061),
    [anon_sym_BSLASHciteR] = ACTIONS(6061),
    [anon_sym_BSLASHciteS] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6061),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteyear] = ACTIONS(6061),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitedate] = ACTIONS(6061),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteurl] = ACTIONS(6061),
    [anon_sym_BSLASHfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6061),
    [anon_sym_BSLASHcitealt] = ACTIONS(6061),
    [anon_sym_BSLASHcitealp] = ACTIONS(6061),
    [anon_sym_BSLASHcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHparencite] = ACTIONS(6061),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHParencite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHtextcite] = ACTIONS(6061),
    [anon_sym_BSLASHTextcite] = ACTIONS(6061),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHsupercite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite] = ACTIONS(6061),
    [anon_sym_BSLASHAutocite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHVolcite] = ACTIONS(6061),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHavolcite] = ACTIONS(6061),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHNotecite] = ACTIONS(6061),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHlabel] = ACTIONS(6061),
    [anon_sym_BSLASHref] = ACTIONS(6061),
    [anon_sym_BSLASHeqref] = ACTIONS(6061),
    [anon_sym_BSLASHvref] = ACTIONS(6061),
    [anon_sym_BSLASHVref] = ACTIONS(6061),
    [anon_sym_BSLASHautoref] = ACTIONS(6061),
    [anon_sym_BSLASHpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcref] = ACTIONS(6061),
    [anon_sym_BSLASHCref] = ACTIONS(6061),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnameCref] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHdef] = ACTIONS(6061),
    [anon_sym_BSLASHlet] = ACTIONS(6061),
    [anon_sym_BSLASHleft] = ACTIONS(6061),
    [anon_sym_BSLASHbigl] = ACTIONS(6061),
    [anon_sym_BSLASHBigl] = ACTIONS(6061),
    [anon_sym_BSLASHbiggl] = ACTIONS(6061),
    [anon_sym_BSLASHBiggl] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6061),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6061),
    [anon_sym_BSLASHgls] = ACTIONS(6061),
    [anon_sym_BSLASHGls] = ACTIONS(6061),
    [anon_sym_BSLASHGLS] = ACTIONS(6061),
    [anon_sym_BSLASHglspl] = ACTIONS(6061),
    [anon_sym_BSLASHGlspl] = ACTIONS(6061),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6061),
    [anon_sym_BSLASHglslink] = ACTIONS(6061),
    [anon_sym_BSLASHglstext] = ACTIONS(6061),
    [anon_sym_BSLASHGlstext] = ACTIONS(6061),
    [anon_sym_BSLASHGLStext] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6061),
    [anon_sym_BSLASHglsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsname] = ACTIONS(6061),
    [anon_sym_BSLASHGlsname] = ACTIONS(6061),
    [anon_sym_BSLASHGLSname] = ACTIONS(6061),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6061),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6061),
    [anon_sym_BSLASHacrshort] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6061),
    [anon_sym_BSLASHACRshort] = ACTIONS(6061),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrlong] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6061),
    [anon_sym_BSLASHACRlong] = ACTIONS(6061),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrfull] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6061),
    [anon_sym_BSLASHACRfull] = ACTIONS(6061),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHacs] = ACTIONS(6061),
    [anon_sym_BSLASHAcs] = ACTIONS(6061),
    [anon_sym_BSLASHacsp] = ACTIONS(6061),
    [anon_sym_BSLASHAcsp] = ACTIONS(6061),
    [anon_sym_BSLASHacl] = ACTIONS(6061),
    [anon_sym_BSLASHAcl] = ACTIONS(6061),
    [anon_sym_BSLASHaclp] = ACTIONS(6061),
    [anon_sym_BSLASHAclp] = ACTIONS(6061),
    [anon_sym_BSLASHacf] = ACTIONS(6061),
    [anon_sym_BSLASHAcf] = ACTIONS(6061),
    [anon_sym_BSLASHacfp] = ACTIONS(6061),
    [anon_sym_BSLASHAcfp] = ACTIONS(6061),
    [anon_sym_BSLASHac] = ACTIONS(6061),
    [anon_sym_BSLASHAc] = ACTIONS(6061),
    [anon_sym_BSLASHacp] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6061),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6061),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6061),
    [anon_sym_BSLASHcolor] = ACTIONS(6061),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6061),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6061),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6061),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6061),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6061),
    [anon_sym_BSLASHtext] = ACTIONS(6061),
    [anon_sym_BSLASHintertext] = ACTIONS(6061),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6061),
    [anon_sym_BSLASHurl] = ACTIONS(6061),
    [anon_sym_BSLASHhref] = ACTIONS(6061),
  },
  [552] = {
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_RBRACK] = ACTIONS(6452),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6452),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHpart] = ACTIONS(6450),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddpart] = ACTIONS(6450),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHchapter] = ACTIONS(6450),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddchap] = ACTIONS(6450),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsection] = ACTIONS(6450),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddsec] = ACTIONS(6450),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHitem] = ACTIONS(6450),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6452),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(6450),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHbegin] = ACTIONS(6450),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHleft] = ACTIONS(6450),
    [anon_sym_BSLASHbigl] = ACTIONS(6450),
    [anon_sym_BSLASHBigl] = ACTIONS(6450),
    [anon_sym_BSLASHbiggl] = ACTIONS(6450),
    [anon_sym_BSLASHBiggl] = ACTIONS(6450),
    [anon_sym_BSLASHright] = ACTIONS(6450),
    [anon_sym_BSLASHbigr] = ACTIONS(6450),
    [anon_sym_BSLASHBigr] = ACTIONS(6450),
    [anon_sym_BSLASHbiggr] = ACTIONS(6450),
    [anon_sym_BSLASHBiggr] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHtext] = ACTIONS(6450),
    [anon_sym_BSLASHintertext] = ACTIONS(6450),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [553] = {
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHpart] = ACTIONS(6454),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddpart] = ACTIONS(6454),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHchapter] = ACTIONS(6454),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddchap] = ACTIONS(6454),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsection] = ACTIONS(6454),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddsec] = ACTIONS(6454),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHitem] = ACTIONS(6454),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6456),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(6454),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHbegin] = ACTIONS(6454),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHleft] = ACTIONS(6454),
    [anon_sym_BSLASHbigl] = ACTIONS(6454),
    [anon_sym_BSLASHBigl] = ACTIONS(6454),
    [anon_sym_BSLASHbiggl] = ACTIONS(6454),
    [anon_sym_BSLASHBiggl] = ACTIONS(6454),
    [anon_sym_BSLASHright] = ACTIONS(6454),
    [anon_sym_BSLASHbigr] = ACTIONS(6454),
    [anon_sym_BSLASHBigr] = ACTIONS(6454),
    [anon_sym_BSLASHbiggr] = ACTIONS(6454),
    [anon_sym_BSLASHBiggr] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHtext] = ACTIONS(6454),
    [anon_sym_BSLASHintertext] = ACTIONS(6454),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [554] = {
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6460),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_COMMA] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_LPAREN] = ACTIONS(6460),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHpart] = ACTIONS(6458),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddpart] = ACTIONS(6458),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHchapter] = ACTIONS(6458),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddchap] = ACTIONS(6458),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsection] = ACTIONS(6458),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddsec] = ACTIONS(6458),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHitem] = ACTIONS(6458),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6460),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6460),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6460),
    [anon_sym_DOLLAR] = ACTIONS(6458),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHbegin] = ACTIONS(6458),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHleft] = ACTIONS(6458),
    [anon_sym_BSLASHbigl] = ACTIONS(6458),
    [anon_sym_BSLASHBigl] = ACTIONS(6458),
    [anon_sym_BSLASHbiggl] = ACTIONS(6458),
    [anon_sym_BSLASHBiggl] = ACTIONS(6458),
    [anon_sym_BSLASHright] = ACTIONS(6458),
    [anon_sym_BSLASHbigr] = ACTIONS(6458),
    [anon_sym_BSLASHBigr] = ACTIONS(6458),
    [anon_sym_BSLASHbiggr] = ACTIONS(6458),
    [anon_sym_BSLASHBiggr] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHtext] = ACTIONS(6458),
    [anon_sym_BSLASHintertext] = ACTIONS(6458),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [555] = {
    [sym__section_part] = STATE(922),
    [sym_curly_group] = STATE(979),
    [sym_brack_group] = STATE(2882),
    [ts_builtin_sym_end] = ACTIONS(6083),
    [sym_command_name] = ACTIONS(6081),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6083),
    [anon_sym_COMMA] = ACTIONS(6083),
    [anon_sym_EQ] = ACTIONS(6083),
    [anon_sym_LPAREN] = ACTIONS(6083),
    [anon_sym_RPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHpart] = ACTIONS(6081),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddpart] = ACTIONS(6081),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHchapter] = ACTIONS(6081),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddchap] = ACTIONS(6081),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsection] = ACTIONS(6081),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddsec] = ACTIONS(6081),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHitem] = ACTIONS(6081),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6083),
    [sym_word] = ACTIONS(6081),
    [sym_placeholder] = ACTIONS(6083),
    [anon_sym_PLUS] = ACTIONS(6083),
    [anon_sym_DASH] = ACTIONS(6083),
    [anon_sym_STAR] = ACTIONS(6083),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_BANG] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_SQUOTE] = ACTIONS(6081),
    [anon_sym__] = ACTIONS(6083),
    [anon_sym_CARET] = ACTIONS(6083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6083),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6083),
    [anon_sym_DOLLAR] = ACTIONS(6081),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHbegin] = ACTIONS(6081),
    [anon_sym_BSLASHtitle] = ACTIONS(6081),
    [anon_sym_BSLASHauthor] = ACTIONS(6081),
    [anon_sym_BSLASHusepackage] = ACTIONS(6081),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6081),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6081),
    [anon_sym_BSLASHinclude] = ACTIONS(6081),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6081),
    [anon_sym_BSLASHinput] = ACTIONS(6081),
    [anon_sym_BSLASHsubfile] = ACTIONS(6081),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6081),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6081),
    [anon_sym_BSLASHbibliography] = ACTIONS(6081),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6081),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6081),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6081),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6081),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6081),
    [anon_sym_BSLASHimport] = ACTIONS(6081),
    [anon_sym_BSLASHsubimport] = ACTIONS(6081),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6081),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHcaption] = ACTIONS(6081),
    [anon_sym_BSLASHcite] = ACTIONS(6081),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCite] = ACTIONS(6081),
    [anon_sym_BSLASHnocite] = ACTIONS(6081),
    [anon_sym_BSLASHcitet] = ACTIONS(6081),
    [anon_sym_BSLASHcitep] = ACTIONS(6081),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteA] = ACTIONS(6081),
    [anon_sym_BSLASHciteR] = ACTIONS(6081),
    [anon_sym_BSLASHciteS] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6081),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteyear] = ACTIONS(6081),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitedate] = ACTIONS(6081),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteurl] = ACTIONS(6081),
    [anon_sym_BSLASHfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6081),
    [anon_sym_BSLASHcitealt] = ACTIONS(6081),
    [anon_sym_BSLASHcitealp] = ACTIONS(6081),
    [anon_sym_BSLASHcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHparencite] = ACTIONS(6081),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHParencite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHtextcite] = ACTIONS(6081),
    [anon_sym_BSLASHTextcite] = ACTIONS(6081),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHsupercite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite] = ACTIONS(6081),
    [anon_sym_BSLASHAutocite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHVolcite] = ACTIONS(6081),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHavolcite] = ACTIONS(6081),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHNotecite] = ACTIONS(6081),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHlabel] = ACTIONS(6081),
    [anon_sym_BSLASHref] = ACTIONS(6081),
    [anon_sym_BSLASHeqref] = ACTIONS(6081),
    [anon_sym_BSLASHvref] = ACTIONS(6081),
    [anon_sym_BSLASHVref] = ACTIONS(6081),
    [anon_sym_BSLASHautoref] = ACTIONS(6081),
    [anon_sym_BSLASHpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcref] = ACTIONS(6081),
    [anon_sym_BSLASHCref] = ACTIONS(6081),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnameCref] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHdef] = ACTIONS(6081),
    [anon_sym_BSLASHlet] = ACTIONS(6081),
    [anon_sym_BSLASHleft] = ACTIONS(6081),
    [anon_sym_BSLASHbigl] = ACTIONS(6081),
    [anon_sym_BSLASHBigl] = ACTIONS(6081),
    [anon_sym_BSLASHbiggl] = ACTIONS(6081),
    [anon_sym_BSLASHBiggl] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6081),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6081),
    [anon_sym_BSLASHgls] = ACTIONS(6081),
    [anon_sym_BSLASHGls] = ACTIONS(6081),
    [anon_sym_BSLASHGLS] = ACTIONS(6081),
    [anon_sym_BSLASHglspl] = ACTIONS(6081),
    [anon_sym_BSLASHGlspl] = ACTIONS(6081),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6081),
    [anon_sym_BSLASHglslink] = ACTIONS(6081),
    [anon_sym_BSLASHglstext] = ACTIONS(6081),
    [anon_sym_BSLASHGlstext] = ACTIONS(6081),
    [anon_sym_BSLASHGLStext] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6081),
    [anon_sym_BSLASHglsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsname] = ACTIONS(6081),
    [anon_sym_BSLASHGlsname] = ACTIONS(6081),
    [anon_sym_BSLASHGLSname] = ACTIONS(6081),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6081),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6081),
    [anon_sym_BSLASHacrshort] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6081),
    [anon_sym_BSLASHACRshort] = ACTIONS(6081),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrlong] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6081),
    [anon_sym_BSLASHACRlong] = ACTIONS(6081),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrfull] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6081),
    [anon_sym_BSLASHACRfull] = ACTIONS(6081),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHacs] = ACTIONS(6081),
    [anon_sym_BSLASHAcs] = ACTIONS(6081),
    [anon_sym_BSLASHacsp] = ACTIONS(6081),
    [anon_sym_BSLASHAcsp] = ACTIONS(6081),
    [anon_sym_BSLASHacl] = ACTIONS(6081),
    [anon_sym_BSLASHAcl] = ACTIONS(6081),
    [anon_sym_BSLASHaclp] = ACTIONS(6081),
    [anon_sym_BSLASHAclp] = ACTIONS(6081),
    [anon_sym_BSLASHacf] = ACTIONS(6081),
    [anon_sym_BSLASHAcf] = ACTIONS(6081),
    [anon_sym_BSLASHacfp] = ACTIONS(6081),
    [anon_sym_BSLASHAcfp] = ACTIONS(6081),
    [anon_sym_BSLASHac] = ACTIONS(6081),
    [anon_sym_BSLASHAc] = ACTIONS(6081),
    [anon_sym_BSLASHacp] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6081),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6081),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6081),
    [anon_sym_BSLASHcolor] = ACTIONS(6081),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6081),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6081),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6081),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6081),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6081),
    [anon_sym_BSLASHtext] = ACTIONS(6081),
    [anon_sym_BSLASHintertext] = ACTIONS(6081),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6081),
    [anon_sym_BSLASHurl] = ACTIONS(6081),
    [anon_sym_BSLASHhref] = ACTIONS(6081),
  },
  [556] = {
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6464),
    [anon_sym_RBRACK] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_EQ] = ACTIONS(6464),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHpart] = ACTIONS(6462),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddpart] = ACTIONS(6462),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHchapter] = ACTIONS(6462),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddchap] = ACTIONS(6462),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsection] = ACTIONS(6462),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddsec] = ACTIONS(6462),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHitem] = ACTIONS(6462),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6464),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(6462),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHbegin] = ACTIONS(6462),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHleft] = ACTIONS(6462),
    [anon_sym_BSLASHbigl] = ACTIONS(6462),
    [anon_sym_BSLASHBigl] = ACTIONS(6462),
    [anon_sym_BSLASHbiggl] = ACTIONS(6462),
    [anon_sym_BSLASHBiggl] = ACTIONS(6462),
    [anon_sym_BSLASHright] = ACTIONS(6462),
    [anon_sym_BSLASHbigr] = ACTIONS(6462),
    [anon_sym_BSLASHBigr] = ACTIONS(6462),
    [anon_sym_BSLASHbiggr] = ACTIONS(6462),
    [anon_sym_BSLASHBiggr] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHtext] = ACTIONS(6462),
    [anon_sym_BSLASHintertext] = ACTIONS(6462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [557] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [558] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(2174),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [559] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(476),
    [aux_sym__section_repeat5] = STATE(476),
    [ts_builtin_sym_end] = ACTIONS(2192),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [560] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(2192),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [anon_sym_RBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [561] = {
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(600),
    [aux_sym__paragraph_repeat2] = STATE(600),
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(37),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(39),
    [anon_sym_BSLASHitem] = ACTIONS(2232),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [562] = {
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(596),
    [aux_sym__paragraph_repeat3] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(2234),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [anon_sym_RBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [563] = {
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(596),
    [aux_sym__paragraph_repeat3] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(2252),
    [sym_command_name] = ACTIONS(2250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_RBRACK] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(41),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [anon_sym_RBRACE] = ACTIONS(2252),
    [sym_word] = ACTIONS(2250),
    [sym_placeholder] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym__] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2252),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHbegin] = ACTIONS(2250),
    [anon_sym_BSLASHtitle] = ACTIONS(2250),
    [anon_sym_BSLASHauthor] = ACTIONS(2250),
    [anon_sym_BSLASHusepackage] = ACTIONS(2250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2250),
    [anon_sym_BSLASHinclude] = ACTIONS(2250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2250),
    [anon_sym_BSLASHinput] = ACTIONS(2250),
    [anon_sym_BSLASHsubfile] = ACTIONS(2250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2250),
    [anon_sym_BSLASHbibliography] = ACTIONS(2250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2250),
    [anon_sym_BSLASHimport] = ACTIONS(2250),
    [anon_sym_BSLASHsubimport] = ACTIONS(2250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHcaption] = ACTIONS(2250),
    [anon_sym_BSLASHcite] = ACTIONS(2250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCite] = ACTIONS(2250),
    [anon_sym_BSLASHnocite] = ACTIONS(2250),
    [anon_sym_BSLASHcitet] = ACTIONS(2250),
    [anon_sym_BSLASHcitep] = ACTIONS(2250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteA] = ACTIONS(2250),
    [anon_sym_BSLASHciteR] = ACTIONS(2250),
    [anon_sym_BSLASHciteS] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteyear] = ACTIONS(2250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitedate] = ACTIONS(2250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteurl] = ACTIONS(2250),
    [anon_sym_BSLASHfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2250),
    [anon_sym_BSLASHcitealt] = ACTIONS(2250),
    [anon_sym_BSLASHcitealp] = ACTIONS(2250),
    [anon_sym_BSLASHcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHparencite] = ACTIONS(2250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHParencite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHtextcite] = ACTIONS(2250),
    [anon_sym_BSLASHTextcite] = ACTIONS(2250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHsupercite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite] = ACTIONS(2250),
    [anon_sym_BSLASHAutocite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHVolcite] = ACTIONS(2250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHavolcite] = ACTIONS(2250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHNotecite] = ACTIONS(2250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHlabel] = ACTIONS(2250),
    [anon_sym_BSLASHref] = ACTIONS(2250),
    [anon_sym_BSLASHeqref] = ACTIONS(2250),
    [anon_sym_BSLASHvref] = ACTIONS(2250),
    [anon_sym_BSLASHVref] = ACTIONS(2250),
    [anon_sym_BSLASHautoref] = ACTIONS(2250),
    [anon_sym_BSLASHpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcref] = ACTIONS(2250),
    [anon_sym_BSLASHCref] = ACTIONS(2250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnameCref] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHdef] = ACTIONS(2250),
    [anon_sym_BSLASHlet] = ACTIONS(2250),
    [anon_sym_BSLASHleft] = ACTIONS(2250),
    [anon_sym_BSLASHbigl] = ACTIONS(2250),
    [anon_sym_BSLASHBigl] = ACTIONS(2250),
    [anon_sym_BSLASHbiggl] = ACTIONS(2250),
    [anon_sym_BSLASHBiggl] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2250),
    [anon_sym_BSLASHgls] = ACTIONS(2250),
    [anon_sym_BSLASHGls] = ACTIONS(2250),
    [anon_sym_BSLASHGLS] = ACTIONS(2250),
    [anon_sym_BSLASHglspl] = ACTIONS(2250),
    [anon_sym_BSLASHGlspl] = ACTIONS(2250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2250),
    [anon_sym_BSLASHglslink] = ACTIONS(2250),
    [anon_sym_BSLASHglstext] = ACTIONS(2250),
    [anon_sym_BSLASHGlstext] = ACTIONS(2250),
    [anon_sym_BSLASHGLStext] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2250),
    [anon_sym_BSLASHglsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsname] = ACTIONS(2250),
    [anon_sym_BSLASHGlsname] = ACTIONS(2250),
    [anon_sym_BSLASHGLSname] = ACTIONS(2250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2250),
    [anon_sym_BSLASHacrshort] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2250),
    [anon_sym_BSLASHACRshort] = ACTIONS(2250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrlong] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2250),
    [anon_sym_BSLASHACRlong] = ACTIONS(2250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrfull] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2250),
    [anon_sym_BSLASHACRfull] = ACTIONS(2250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHacs] = ACTIONS(2250),
    [anon_sym_BSLASHAcs] = ACTIONS(2250),
    [anon_sym_BSLASHacsp] = ACTIONS(2250),
    [anon_sym_BSLASHAcsp] = ACTIONS(2250),
    [anon_sym_BSLASHacl] = ACTIONS(2250),
    [anon_sym_BSLASHAcl] = ACTIONS(2250),
    [anon_sym_BSLASHaclp] = ACTIONS(2250),
    [anon_sym_BSLASHAclp] = ACTIONS(2250),
    [anon_sym_BSLASHacf] = ACTIONS(2250),
    [anon_sym_BSLASHAcf] = ACTIONS(2250),
    [anon_sym_BSLASHacfp] = ACTIONS(2250),
    [anon_sym_BSLASHAcfp] = ACTIONS(2250),
    [anon_sym_BSLASHac] = ACTIONS(2250),
    [anon_sym_BSLASHAc] = ACTIONS(2250),
    [anon_sym_BSLASHacp] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2250),
    [anon_sym_BSLASHcolor] = ACTIONS(2250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2250),
    [anon_sym_BSLASHtext] = ACTIONS(2250),
    [anon_sym_BSLASHintertext] = ACTIONS(2250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2250),
    [anon_sym_BSLASHurl] = ACTIONS(2250),
    [anon_sym_BSLASHhref] = ACTIONS(2250),
  },
  [564] = {
    [sym__section_part] = STATE(921),
    [sym_curly_group] = STATE(979),
    [sym_brack_group] = STATE(2882),
    [ts_builtin_sym_end] = ACTIONS(6103),
    [sym_command_name] = ACTIONS(6101),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6103),
    [anon_sym_COMMA] = ACTIONS(6103),
    [anon_sym_EQ] = ACTIONS(6103),
    [anon_sym_LPAREN] = ACTIONS(6103),
    [anon_sym_RPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHpart] = ACTIONS(6101),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddpart] = ACTIONS(6101),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHchapter] = ACTIONS(6101),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddchap] = ACTIONS(6101),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsection] = ACTIONS(6101),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddsec] = ACTIONS(6101),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHitem] = ACTIONS(6101),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6103),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6103),
    [sym_word] = ACTIONS(6101),
    [sym_placeholder] = ACTIONS(6103),
    [anon_sym_PLUS] = ACTIONS(6103),
    [anon_sym_DASH] = ACTIONS(6103),
    [anon_sym_STAR] = ACTIONS(6103),
    [anon_sym_SLASH] = ACTIONS(6103),
    [anon_sym_LT] = ACTIONS(6101),
    [anon_sym_GT] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(6101),
    [anon_sym_PIPE] = ACTIONS(6101),
    [anon_sym_COLON] = ACTIONS(6101),
    [anon_sym_SQUOTE] = ACTIONS(6101),
    [anon_sym__] = ACTIONS(6103),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6103),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6103),
    [anon_sym_DOLLAR] = ACTIONS(6101),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHbegin] = ACTIONS(6101),
    [anon_sym_BSLASHtitle] = ACTIONS(6101),
    [anon_sym_BSLASHauthor] = ACTIONS(6101),
    [anon_sym_BSLASHusepackage] = ACTIONS(6101),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6101),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6101),
    [anon_sym_BSLASHinclude] = ACTIONS(6101),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6101),
    [anon_sym_BSLASHinput] = ACTIONS(6101),
    [anon_sym_BSLASHsubfile] = ACTIONS(6101),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6101),
    [anon_sym_BSLASHbibliography] = ACTIONS(6101),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6101),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6101),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6101),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6101),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6101),
    [anon_sym_BSLASHimport] = ACTIONS(6101),
    [anon_sym_BSLASHsubimport] = ACTIONS(6101),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6101),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHcaption] = ACTIONS(6101),
    [anon_sym_BSLASHcite] = ACTIONS(6101),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCite] = ACTIONS(6101),
    [anon_sym_BSLASHnocite] = ACTIONS(6101),
    [anon_sym_BSLASHcitet] = ACTIONS(6101),
    [anon_sym_BSLASHcitep] = ACTIONS(6101),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteA] = ACTIONS(6101),
    [anon_sym_BSLASHciteR] = ACTIONS(6101),
    [anon_sym_BSLASHciteS] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6101),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteyear] = ACTIONS(6101),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitedate] = ACTIONS(6101),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteurl] = ACTIONS(6101),
    [anon_sym_BSLASHfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6101),
    [anon_sym_BSLASHcitealt] = ACTIONS(6101),
    [anon_sym_BSLASHcitealp] = ACTIONS(6101),
    [anon_sym_BSLASHcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHparencite] = ACTIONS(6101),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHParencite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHtextcite] = ACTIONS(6101),
    [anon_sym_BSLASHTextcite] = ACTIONS(6101),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHsupercite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite] = ACTIONS(6101),
    [anon_sym_BSLASHAutocite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHVolcite] = ACTIONS(6101),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHavolcite] = ACTIONS(6101),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHNotecite] = ACTIONS(6101),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHlabel] = ACTIONS(6101),
    [anon_sym_BSLASHref] = ACTIONS(6101),
    [anon_sym_BSLASHeqref] = ACTIONS(6101),
    [anon_sym_BSLASHvref] = ACTIONS(6101),
    [anon_sym_BSLASHVref] = ACTIONS(6101),
    [anon_sym_BSLASHautoref] = ACTIONS(6101),
    [anon_sym_BSLASHpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcref] = ACTIONS(6101),
    [anon_sym_BSLASHCref] = ACTIONS(6101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnameCref] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHdef] = ACTIONS(6101),
    [anon_sym_BSLASHlet] = ACTIONS(6101),
    [anon_sym_BSLASHleft] = ACTIONS(6101),
    [anon_sym_BSLASHbigl] = ACTIONS(6101),
    [anon_sym_BSLASHBigl] = ACTIONS(6101),
    [anon_sym_BSLASHbiggl] = ACTIONS(6101),
    [anon_sym_BSLASHBiggl] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6101),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6101),
    [anon_sym_BSLASHgls] = ACTIONS(6101),
    [anon_sym_BSLASHGls] = ACTIONS(6101),
    [anon_sym_BSLASHGLS] = ACTIONS(6101),
    [anon_sym_BSLASHglspl] = ACTIONS(6101),
    [anon_sym_BSLASHGlspl] = ACTIONS(6101),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6101),
    [anon_sym_BSLASHglslink] = ACTIONS(6101),
    [anon_sym_BSLASHglstext] = ACTIONS(6101),
    [anon_sym_BSLASHGlstext] = ACTIONS(6101),
    [anon_sym_BSLASHGLStext] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6101),
    [anon_sym_BSLASHglsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsname] = ACTIONS(6101),
    [anon_sym_BSLASHGlsname] = ACTIONS(6101),
    [anon_sym_BSLASHGLSname] = ACTIONS(6101),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6101),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6101),
    [anon_sym_BSLASHacrshort] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6101),
    [anon_sym_BSLASHACRshort] = ACTIONS(6101),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrlong] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6101),
    [anon_sym_BSLASHACRlong] = ACTIONS(6101),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrfull] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6101),
    [anon_sym_BSLASHACRfull] = ACTIONS(6101),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHacs] = ACTIONS(6101),
    [anon_sym_BSLASHAcs] = ACTIONS(6101),
    [anon_sym_BSLASHacsp] = ACTIONS(6101),
    [anon_sym_BSLASHAcsp] = ACTIONS(6101),
    [anon_sym_BSLASHacl] = ACTIONS(6101),
    [anon_sym_BSLASHAcl] = ACTIONS(6101),
    [anon_sym_BSLASHaclp] = ACTIONS(6101),
    [anon_sym_BSLASHAclp] = ACTIONS(6101),
    [anon_sym_BSLASHacf] = ACTIONS(6101),
    [anon_sym_BSLASHAcf] = ACTIONS(6101),
    [anon_sym_BSLASHacfp] = ACTIONS(6101),
    [anon_sym_BSLASHAcfp] = ACTIONS(6101),
    [anon_sym_BSLASHac] = ACTIONS(6101),
    [anon_sym_BSLASHAc] = ACTIONS(6101),
    [anon_sym_BSLASHacp] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6101),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6101),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6101),
    [anon_sym_BSLASHcolor] = ACTIONS(6101),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6101),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6101),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6101),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6101),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6101),
    [anon_sym_BSLASHtext] = ACTIONS(6101),
    [anon_sym_BSLASHintertext] = ACTIONS(6101),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6101),
    [anon_sym_BSLASHurl] = ACTIONS(6101),
    [anon_sym_BSLASHhref] = ACTIONS(6101),
  },
  [565] = {
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_LBRACK] = ACTIONS(6468),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_COMMA] = ACTIONS(6468),
    [anon_sym_EQ] = ACTIONS(6468),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHpart] = ACTIONS(6466),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddpart] = ACTIONS(6466),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHchapter] = ACTIONS(6466),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddchap] = ACTIONS(6466),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsection] = ACTIONS(6466),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddsec] = ACTIONS(6466),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHitem] = ACTIONS(6466),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6468),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6466),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHbegin] = ACTIONS(6466),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHleft] = ACTIONS(6466),
    [anon_sym_BSLASHbigl] = ACTIONS(6466),
    [anon_sym_BSLASHBigl] = ACTIONS(6466),
    [anon_sym_BSLASHbiggl] = ACTIONS(6466),
    [anon_sym_BSLASHBiggl] = ACTIONS(6466),
    [anon_sym_BSLASHright] = ACTIONS(6466),
    [anon_sym_BSLASHbigr] = ACTIONS(6466),
    [anon_sym_BSLASHBigr] = ACTIONS(6466),
    [anon_sym_BSLASHbiggr] = ACTIONS(6466),
    [anon_sym_BSLASHBiggr] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHtext] = ACTIONS(6466),
    [anon_sym_BSLASHintertext] = ACTIONS(6466),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [566] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(6079),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [anon_sym_RBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [567] = {
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_LBRACK] = ACTIONS(6472),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_EQ] = ACTIONS(6472),
    [anon_sym_LPAREN] = ACTIONS(6472),
    [anon_sym_RPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHpart] = ACTIONS(6470),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddpart] = ACTIONS(6470),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHchapter] = ACTIONS(6470),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddchap] = ACTIONS(6470),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsection] = ACTIONS(6470),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddsec] = ACTIONS(6470),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHitem] = ACTIONS(6470),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6472),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6472),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHbegin] = ACTIONS(6470),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHleft] = ACTIONS(6470),
    [anon_sym_BSLASHbigl] = ACTIONS(6470),
    [anon_sym_BSLASHBigl] = ACTIONS(6470),
    [anon_sym_BSLASHbiggl] = ACTIONS(6470),
    [anon_sym_BSLASHBiggl] = ACTIONS(6470),
    [anon_sym_BSLASHright] = ACTIONS(6470),
    [anon_sym_BSLASHbigr] = ACTIONS(6470),
    [anon_sym_BSLASHBigr] = ACTIONS(6470),
    [anon_sym_BSLASHbiggr] = ACTIONS(6470),
    [anon_sym_BSLASHBiggr] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHtext] = ACTIONS(6470),
    [anon_sym_BSLASHintertext] = ACTIONS(6470),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [568] = {
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_LBRACK] = ACTIONS(6476),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_RPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHpart] = ACTIONS(6474),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddpart] = ACTIONS(6474),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHchapter] = ACTIONS(6474),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddchap] = ACTIONS(6474),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsection] = ACTIONS(6474),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddsec] = ACTIONS(6474),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHitem] = ACTIONS(6474),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6476),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6476),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHbegin] = ACTIONS(6474),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHleft] = ACTIONS(6474),
    [anon_sym_BSLASHbigl] = ACTIONS(6474),
    [anon_sym_BSLASHBigl] = ACTIONS(6474),
    [anon_sym_BSLASHbiggl] = ACTIONS(6474),
    [anon_sym_BSLASHBiggl] = ACTIONS(6474),
    [anon_sym_BSLASHright] = ACTIONS(6474),
    [anon_sym_BSLASHbigr] = ACTIONS(6474),
    [anon_sym_BSLASHBigr] = ACTIONS(6474),
    [anon_sym_BSLASHbiggr] = ACTIONS(6474),
    [anon_sym_BSLASHBiggr] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHtext] = ACTIONS(6474),
    [anon_sym_BSLASHintertext] = ACTIONS(6474),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [569] = {
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6480),
    [anon_sym_EQ] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6480),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHpart] = ACTIONS(6478),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddpart] = ACTIONS(6478),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHchapter] = ACTIONS(6478),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddchap] = ACTIONS(6478),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsection] = ACTIONS(6478),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddsec] = ACTIONS(6478),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHitem] = ACTIONS(6478),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6480),
    [anon_sym_DOLLAR] = ACTIONS(6478),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHbegin] = ACTIONS(6478),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHleft] = ACTIONS(6478),
    [anon_sym_BSLASHbigl] = ACTIONS(6478),
    [anon_sym_BSLASHBigl] = ACTIONS(6478),
    [anon_sym_BSLASHbiggl] = ACTIONS(6478),
    [anon_sym_BSLASHBiggl] = ACTIONS(6478),
    [anon_sym_BSLASHright] = ACTIONS(6478),
    [anon_sym_BSLASHbigr] = ACTIONS(6478),
    [anon_sym_BSLASHBigr] = ACTIONS(6478),
    [anon_sym_BSLASHbiggr] = ACTIONS(6478),
    [anon_sym_BSLASHBiggr] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHtext] = ACTIONS(6478),
    [anon_sym_BSLASHintertext] = ACTIONS(6478),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [570] = {
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6484),
    [anon_sym_RBRACK] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6484),
    [anon_sym_EQ] = ACTIONS(6484),
    [anon_sym_LPAREN] = ACTIONS(6484),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHpart] = ACTIONS(6482),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddpart] = ACTIONS(6482),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHchapter] = ACTIONS(6482),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddchap] = ACTIONS(6482),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsection] = ACTIONS(6482),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddsec] = ACTIONS(6482),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHitem] = ACTIONS(6482),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6484),
    [anon_sym_LBRACE] = ACTIONS(6484),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6484),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6484),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHbegin] = ACTIONS(6482),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHleft] = ACTIONS(6482),
    [anon_sym_BSLASHbigl] = ACTIONS(6482),
    [anon_sym_BSLASHBigl] = ACTIONS(6482),
    [anon_sym_BSLASHbiggl] = ACTIONS(6482),
    [anon_sym_BSLASHBiggl] = ACTIONS(6482),
    [anon_sym_BSLASHright] = ACTIONS(6482),
    [anon_sym_BSLASHbigr] = ACTIONS(6482),
    [anon_sym_BSLASHBigr] = ACTIONS(6482),
    [anon_sym_BSLASHbiggr] = ACTIONS(6482),
    [anon_sym_BSLASHBiggr] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHtext] = ACTIONS(6482),
    [anon_sym_BSLASHintertext] = ACTIONS(6482),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [571] = {
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_LBRACK] = ACTIONS(6488),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_COMMA] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6488),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHpart] = ACTIONS(6486),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddpart] = ACTIONS(6486),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHchapter] = ACTIONS(6486),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddchap] = ACTIONS(6486),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsection] = ACTIONS(6486),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddsec] = ACTIONS(6486),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHitem] = ACTIONS(6486),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6488),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(6486),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHbegin] = ACTIONS(6486),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHleft] = ACTIONS(6486),
    [anon_sym_BSLASHbigl] = ACTIONS(6486),
    [anon_sym_BSLASHBigl] = ACTIONS(6486),
    [anon_sym_BSLASHbiggl] = ACTIONS(6486),
    [anon_sym_BSLASHBiggl] = ACTIONS(6486),
    [anon_sym_BSLASHright] = ACTIONS(6486),
    [anon_sym_BSLASHbigr] = ACTIONS(6486),
    [anon_sym_BSLASHBigr] = ACTIONS(6486),
    [anon_sym_BSLASHbiggr] = ACTIONS(6486),
    [anon_sym_BSLASHBiggr] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHtext] = ACTIONS(6486),
    [anon_sym_BSLASHintertext] = ACTIONS(6486),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [572] = {
    [sym_command_name] = ACTIONS(6490),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6490),
    [anon_sym_LBRACK] = ACTIONS(6492),
    [anon_sym_RBRACK] = ACTIONS(6492),
    [anon_sym_COMMA] = ACTIONS(6492),
    [anon_sym_EQ] = ACTIONS(6492),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [anon_sym_RPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHpart] = ACTIONS(6490),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddpart] = ACTIONS(6490),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHchapter] = ACTIONS(6490),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddchap] = ACTIONS(6490),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsection] = ACTIONS(6490),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddsec] = ACTIONS(6490),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHitem] = ACTIONS(6490),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6492),
    [anon_sym_LBRACE] = ACTIONS(6492),
    [sym_word] = ACTIONS(6490),
    [sym_placeholder] = ACTIONS(6492),
    [anon_sym_PLUS] = ACTIONS(6492),
    [anon_sym_DASH] = ACTIONS(6492),
    [anon_sym_STAR] = ACTIONS(6492),
    [anon_sym_SLASH] = ACTIONS(6492),
    [anon_sym_LT] = ACTIONS(6490),
    [anon_sym_GT] = ACTIONS(6490),
    [anon_sym_BANG] = ACTIONS(6490),
    [anon_sym_PIPE] = ACTIONS(6490),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_SQUOTE] = ACTIONS(6490),
    [anon_sym__] = ACTIONS(6492),
    [anon_sym_CARET] = ACTIONS(6492),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6492),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6492),
    [anon_sym_DOLLAR] = ACTIONS(6490),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHbegin] = ACTIONS(6490),
    [anon_sym_BSLASHtitle] = ACTIONS(6490),
    [anon_sym_BSLASHauthor] = ACTIONS(6490),
    [anon_sym_BSLASHusepackage] = ACTIONS(6490),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6490),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6490),
    [anon_sym_BSLASHinclude] = ACTIONS(6490),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6490),
    [anon_sym_BSLASHinput] = ACTIONS(6490),
    [anon_sym_BSLASHsubfile] = ACTIONS(6490),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6490),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6490),
    [anon_sym_BSLASHbibliography] = ACTIONS(6490),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6490),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6490),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6490),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6490),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6490),
    [anon_sym_BSLASHimport] = ACTIONS(6490),
    [anon_sym_BSLASHsubimport] = ACTIONS(6490),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6490),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHcaption] = ACTIONS(6490),
    [anon_sym_BSLASHcite] = ACTIONS(6490),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCite] = ACTIONS(6490),
    [anon_sym_BSLASHnocite] = ACTIONS(6490),
    [anon_sym_BSLASHcitet] = ACTIONS(6490),
    [anon_sym_BSLASHcitep] = ACTIONS(6490),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteA] = ACTIONS(6490),
    [anon_sym_BSLASHciteR] = ACTIONS(6490),
    [anon_sym_BSLASHciteS] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6490),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteyear] = ACTIONS(6490),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitedate] = ACTIONS(6490),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteurl] = ACTIONS(6490),
    [anon_sym_BSLASHfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6490),
    [anon_sym_BSLASHcitealt] = ACTIONS(6490),
    [anon_sym_BSLASHcitealp] = ACTIONS(6490),
    [anon_sym_BSLASHcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHparencite] = ACTIONS(6490),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHParencite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHtextcite] = ACTIONS(6490),
    [anon_sym_BSLASHTextcite] = ACTIONS(6490),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHsupercite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite] = ACTIONS(6490),
    [anon_sym_BSLASHAutocite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHVolcite] = ACTIONS(6490),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHavolcite] = ACTIONS(6490),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHNotecite] = ACTIONS(6490),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHlabel] = ACTIONS(6490),
    [anon_sym_BSLASHref] = ACTIONS(6490),
    [anon_sym_BSLASHeqref] = ACTIONS(6490),
    [anon_sym_BSLASHvref] = ACTIONS(6490),
    [anon_sym_BSLASHVref] = ACTIONS(6490),
    [anon_sym_BSLASHautoref] = ACTIONS(6490),
    [anon_sym_BSLASHpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcref] = ACTIONS(6490),
    [anon_sym_BSLASHCref] = ACTIONS(6490),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnameCref] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHdef] = ACTIONS(6490),
    [anon_sym_BSLASHlet] = ACTIONS(6490),
    [anon_sym_BSLASHleft] = ACTIONS(6490),
    [anon_sym_BSLASHbigl] = ACTIONS(6490),
    [anon_sym_BSLASHBigl] = ACTIONS(6490),
    [anon_sym_BSLASHbiggl] = ACTIONS(6490),
    [anon_sym_BSLASHBiggl] = ACTIONS(6490),
    [anon_sym_BSLASHright] = ACTIONS(6490),
    [anon_sym_BSLASHbigr] = ACTIONS(6490),
    [anon_sym_BSLASHBigr] = ACTIONS(6490),
    [anon_sym_BSLASHbiggr] = ACTIONS(6490),
    [anon_sym_BSLASHBiggr] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6490),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6490),
    [anon_sym_BSLASHgls] = ACTIONS(6490),
    [anon_sym_BSLASHGls] = ACTIONS(6490),
    [anon_sym_BSLASHGLS] = ACTIONS(6490),
    [anon_sym_BSLASHglspl] = ACTIONS(6490),
    [anon_sym_BSLASHGlspl] = ACTIONS(6490),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6490),
    [anon_sym_BSLASHglslink] = ACTIONS(6490),
    [anon_sym_BSLASHglstext] = ACTIONS(6490),
    [anon_sym_BSLASHGlstext] = ACTIONS(6490),
    [anon_sym_BSLASHGLStext] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6490),
    [anon_sym_BSLASHglsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsname] = ACTIONS(6490),
    [anon_sym_BSLASHGlsname] = ACTIONS(6490),
    [anon_sym_BSLASHGLSname] = ACTIONS(6490),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6490),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6490),
    [anon_sym_BSLASHacrshort] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6490),
    [anon_sym_BSLASHACRshort] = ACTIONS(6490),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrlong] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6490),
    [anon_sym_BSLASHACRlong] = ACTIONS(6490),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrfull] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6490),
    [anon_sym_BSLASHACRfull] = ACTIONS(6490),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHacs] = ACTIONS(6490),
    [anon_sym_BSLASHAcs] = ACTIONS(6490),
    [anon_sym_BSLASHacsp] = ACTIONS(6490),
    [anon_sym_BSLASHAcsp] = ACTIONS(6490),
    [anon_sym_BSLASHacl] = ACTIONS(6490),
    [anon_sym_BSLASHAcl] = ACTIONS(6490),
    [anon_sym_BSLASHaclp] = ACTIONS(6490),
    [anon_sym_BSLASHAclp] = ACTIONS(6490),
    [anon_sym_BSLASHacf] = ACTIONS(6490),
    [anon_sym_BSLASHAcf] = ACTIONS(6490),
    [anon_sym_BSLASHacfp] = ACTIONS(6490),
    [anon_sym_BSLASHAcfp] = ACTIONS(6490),
    [anon_sym_BSLASHac] = ACTIONS(6490),
    [anon_sym_BSLASHAc] = ACTIONS(6490),
    [anon_sym_BSLASHacp] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6490),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6490),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6490),
    [anon_sym_BSLASHcolor] = ACTIONS(6490),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6490),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6490),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6490),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6490),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6490),
    [anon_sym_BSLASHtext] = ACTIONS(6490),
    [anon_sym_BSLASHintertext] = ACTIONS(6490),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6490),
    [anon_sym_BSLASHurl] = ACTIONS(6490),
    [anon_sym_BSLASHhref] = ACTIONS(6490),
  },
  [573] = {
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_LBRACK] = ACTIONS(6496),
    [anon_sym_RBRACK] = ACTIONS(6496),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6496),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_RPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHpart] = ACTIONS(6494),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddpart] = ACTIONS(6494),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHchapter] = ACTIONS(6494),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddchap] = ACTIONS(6494),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsection] = ACTIONS(6494),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddsec] = ACTIONS(6494),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHitem] = ACTIONS(6494),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6496),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6496),
    [anon_sym_DOLLAR] = ACTIONS(6494),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHbegin] = ACTIONS(6494),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHleft] = ACTIONS(6494),
    [anon_sym_BSLASHbigl] = ACTIONS(6494),
    [anon_sym_BSLASHBigl] = ACTIONS(6494),
    [anon_sym_BSLASHbiggl] = ACTIONS(6494),
    [anon_sym_BSLASHBiggl] = ACTIONS(6494),
    [anon_sym_BSLASHright] = ACTIONS(6494),
    [anon_sym_BSLASHbigr] = ACTIONS(6494),
    [anon_sym_BSLASHBigr] = ACTIONS(6494),
    [anon_sym_BSLASHbiggr] = ACTIONS(6494),
    [anon_sym_BSLASHBiggr] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHtext] = ACTIONS(6494),
    [anon_sym_BSLASHintertext] = ACTIONS(6494),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [574] = {
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_LBRACK] = ACTIONS(6500),
    [anon_sym_RBRACK] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [anon_sym_EQ] = ACTIONS(6500),
    [anon_sym_LPAREN] = ACTIONS(6500),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHpart] = ACTIONS(6498),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddpart] = ACTIONS(6498),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHchapter] = ACTIONS(6498),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddchap] = ACTIONS(6498),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsection] = ACTIONS(6498),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddsec] = ACTIONS(6498),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHitem] = ACTIONS(6498),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6500),
    [anon_sym_LBRACE] = ACTIONS(6500),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6500),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6500),
    [anon_sym_DOLLAR] = ACTIONS(6498),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHbegin] = ACTIONS(6498),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHleft] = ACTIONS(6498),
    [anon_sym_BSLASHbigl] = ACTIONS(6498),
    [anon_sym_BSLASHBigl] = ACTIONS(6498),
    [anon_sym_BSLASHbiggl] = ACTIONS(6498),
    [anon_sym_BSLASHBiggl] = ACTIONS(6498),
    [anon_sym_BSLASHright] = ACTIONS(6498),
    [anon_sym_BSLASHbigr] = ACTIONS(6498),
    [anon_sym_BSLASHBigr] = ACTIONS(6498),
    [anon_sym_BSLASHbiggr] = ACTIONS(6498),
    [anon_sym_BSLASHBiggr] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHtext] = ACTIONS(6498),
    [anon_sym_BSLASHintertext] = ACTIONS(6498),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [575] = {
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHpart] = ACTIONS(6502),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddpart] = ACTIONS(6502),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHchapter] = ACTIONS(6502),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddchap] = ACTIONS(6502),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsection] = ACTIONS(6502),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddsec] = ACTIONS(6502),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHitem] = ACTIONS(6502),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6504),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6504),
    [anon_sym_DOLLAR] = ACTIONS(6502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHbegin] = ACTIONS(6502),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHleft] = ACTIONS(6502),
    [anon_sym_BSLASHbigl] = ACTIONS(6502),
    [anon_sym_BSLASHBigl] = ACTIONS(6502),
    [anon_sym_BSLASHbiggl] = ACTIONS(6502),
    [anon_sym_BSLASHBiggl] = ACTIONS(6502),
    [anon_sym_BSLASHright] = ACTIONS(6502),
    [anon_sym_BSLASHbigr] = ACTIONS(6502),
    [anon_sym_BSLASHBigr] = ACTIONS(6502),
    [anon_sym_BSLASHbiggr] = ACTIONS(6502),
    [anon_sym_BSLASHBiggr] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHtext] = ACTIONS(6502),
    [anon_sym_BSLASHintertext] = ACTIONS(6502),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [576] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(5955),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [anon_sym_RBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [577] = {
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_LBRACK] = ACTIONS(6508),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [anon_sym_COMMA] = ACTIONS(6508),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_RPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHpart] = ACTIONS(6506),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddpart] = ACTIONS(6506),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHchapter] = ACTIONS(6506),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddchap] = ACTIONS(6506),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsection] = ACTIONS(6506),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddsec] = ACTIONS(6506),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHitem] = ACTIONS(6506),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6508),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(6506),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHbegin] = ACTIONS(6506),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHleft] = ACTIONS(6506),
    [anon_sym_BSLASHbigl] = ACTIONS(6506),
    [anon_sym_BSLASHBigl] = ACTIONS(6506),
    [anon_sym_BSLASHbiggl] = ACTIONS(6506),
    [anon_sym_BSLASHBiggl] = ACTIONS(6506),
    [anon_sym_BSLASHright] = ACTIONS(6506),
    [anon_sym_BSLASHbigr] = ACTIONS(6506),
    [anon_sym_BSLASHBigr] = ACTIONS(6506),
    [anon_sym_BSLASHbiggr] = ACTIONS(6506),
    [anon_sym_BSLASHBiggr] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHtext] = ACTIONS(6506),
    [anon_sym_BSLASHintertext] = ACTIONS(6506),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [578] = {
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_LBRACK] = ACTIONS(6512),
    [anon_sym_RBRACK] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHpart] = ACTIONS(6510),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddpart] = ACTIONS(6510),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHchapter] = ACTIONS(6510),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddchap] = ACTIONS(6510),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsection] = ACTIONS(6510),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddsec] = ACTIONS(6510),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHitem] = ACTIONS(6510),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6512),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6512),
    [anon_sym_DOLLAR] = ACTIONS(6510),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHbegin] = ACTIONS(6510),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHleft] = ACTIONS(6510),
    [anon_sym_BSLASHbigl] = ACTIONS(6510),
    [anon_sym_BSLASHBigl] = ACTIONS(6510),
    [anon_sym_BSLASHbiggl] = ACTIONS(6510),
    [anon_sym_BSLASHBiggl] = ACTIONS(6510),
    [anon_sym_BSLASHright] = ACTIONS(6510),
    [anon_sym_BSLASHbigr] = ACTIONS(6510),
    [anon_sym_BSLASHBigr] = ACTIONS(6510),
    [anon_sym_BSLASHbiggr] = ACTIONS(6510),
    [anon_sym_BSLASHBiggr] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHtext] = ACTIONS(6510),
    [anon_sym_BSLASHintertext] = ACTIONS(6510),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [579] = {
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_LBRACK] = ACTIONS(6516),
    [anon_sym_RBRACK] = ACTIONS(6516),
    [anon_sym_COMMA] = ACTIONS(6516),
    [anon_sym_EQ] = ACTIONS(6516),
    [anon_sym_LPAREN] = ACTIONS(6516),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHpart] = ACTIONS(6514),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddpart] = ACTIONS(6514),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHchapter] = ACTIONS(6514),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddchap] = ACTIONS(6514),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsection] = ACTIONS(6514),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddsec] = ACTIONS(6514),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHitem] = ACTIONS(6514),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6516),
    [anon_sym_LBRACE] = ACTIONS(6516),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6516),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(6514),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHbegin] = ACTIONS(6514),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHleft] = ACTIONS(6514),
    [anon_sym_BSLASHbigl] = ACTIONS(6514),
    [anon_sym_BSLASHBigl] = ACTIONS(6514),
    [anon_sym_BSLASHbiggl] = ACTIONS(6514),
    [anon_sym_BSLASHBiggl] = ACTIONS(6514),
    [anon_sym_BSLASHright] = ACTIONS(6514),
    [anon_sym_BSLASHbigr] = ACTIONS(6514),
    [anon_sym_BSLASHBigr] = ACTIONS(6514),
    [anon_sym_BSLASHbiggr] = ACTIONS(6514),
    [anon_sym_BSLASHBiggr] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHtext] = ACTIONS(6514),
    [anon_sym_BSLASHintertext] = ACTIONS(6514),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [580] = {
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_LBRACK] = ACTIONS(6520),
    [anon_sym_RBRACK] = ACTIONS(6520),
    [anon_sym_COMMA] = ACTIONS(6520),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_LPAREN] = ACTIONS(6520),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHpart] = ACTIONS(6518),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddpart] = ACTIONS(6518),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHchapter] = ACTIONS(6518),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddchap] = ACTIONS(6518),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsection] = ACTIONS(6518),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddsec] = ACTIONS(6518),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHitem] = ACTIONS(6518),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6520),
    [anon_sym_LBRACE] = ACTIONS(6520),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6520),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6520),
    [anon_sym_DOLLAR] = ACTIONS(6518),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHbegin] = ACTIONS(6518),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHleft] = ACTIONS(6518),
    [anon_sym_BSLASHbigl] = ACTIONS(6518),
    [anon_sym_BSLASHBigl] = ACTIONS(6518),
    [anon_sym_BSLASHbiggl] = ACTIONS(6518),
    [anon_sym_BSLASHBiggl] = ACTIONS(6518),
    [anon_sym_BSLASHright] = ACTIONS(6518),
    [anon_sym_BSLASHbigr] = ACTIONS(6518),
    [anon_sym_BSLASHBigr] = ACTIONS(6518),
    [anon_sym_BSLASHbiggr] = ACTIONS(6518),
    [anon_sym_BSLASHBiggr] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHtext] = ACTIONS(6518),
    [anon_sym_BSLASHintertext] = ACTIONS(6518),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [581] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(5959),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [anon_sym_RBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [582] = {
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_LBRACK] = ACTIONS(6524),
    [anon_sym_RBRACK] = ACTIONS(6524),
    [anon_sym_COMMA] = ACTIONS(6524),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6524),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHpart] = ACTIONS(6522),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddpart] = ACTIONS(6522),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHchapter] = ACTIONS(6522),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddchap] = ACTIONS(6522),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsection] = ACTIONS(6522),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddsec] = ACTIONS(6522),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHitem] = ACTIONS(6522),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6524),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6524),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6524),
    [anon_sym_DOLLAR] = ACTIONS(6522),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHbegin] = ACTIONS(6522),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHleft] = ACTIONS(6522),
    [anon_sym_BSLASHbigl] = ACTIONS(6522),
    [anon_sym_BSLASHBigl] = ACTIONS(6522),
    [anon_sym_BSLASHbiggl] = ACTIONS(6522),
    [anon_sym_BSLASHBiggl] = ACTIONS(6522),
    [anon_sym_BSLASHright] = ACTIONS(6522),
    [anon_sym_BSLASHbigr] = ACTIONS(6522),
    [anon_sym_BSLASHBigr] = ACTIONS(6522),
    [anon_sym_BSLASHbiggr] = ACTIONS(6522),
    [anon_sym_BSLASHBiggr] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHtext] = ACTIONS(6522),
    [anon_sym_BSLASHintertext] = ACTIONS(6522),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [583] = {
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6528),
    [anon_sym_RBRACK] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6528),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [anon_sym_RPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHpart] = ACTIONS(6526),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddpart] = ACTIONS(6526),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHchapter] = ACTIONS(6526),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddchap] = ACTIONS(6526),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsection] = ACTIONS(6526),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddsec] = ACTIONS(6526),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHitem] = ACTIONS(6526),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6528),
    [anon_sym_LBRACE] = ACTIONS(6528),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6528),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(6526),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHbegin] = ACTIONS(6526),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHleft] = ACTIONS(6526),
    [anon_sym_BSLASHbigl] = ACTIONS(6526),
    [anon_sym_BSLASHBigl] = ACTIONS(6526),
    [anon_sym_BSLASHbiggl] = ACTIONS(6526),
    [anon_sym_BSLASHBiggl] = ACTIONS(6526),
    [anon_sym_BSLASHright] = ACTIONS(6526),
    [anon_sym_BSLASHbigr] = ACTIONS(6526),
    [anon_sym_BSLASHBigr] = ACTIONS(6526),
    [anon_sym_BSLASHbiggr] = ACTIONS(6526),
    [anon_sym_BSLASHBiggr] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHtext] = ACTIONS(6526),
    [anon_sym_BSLASHintertext] = ACTIONS(6526),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [584] = {
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(584),
    [aux_sym__section_repeat1] = STATE(584),
    [ts_builtin_sym_end] = ACTIONS(5989),
    [sym_command_name] = ACTIONS(5987),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5987),
    [anon_sym_LBRACK] = ACTIONS(5989),
    [anon_sym_RBRACK] = ACTIONS(5989),
    [anon_sym_COMMA] = ACTIONS(5989),
    [anon_sym_EQ] = ACTIONS(5989),
    [anon_sym_LPAREN] = ACTIONS(5989),
    [anon_sym_RPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHpart] = ACTIONS(6530),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6533),
    [anon_sym_BSLASHaddpart] = ACTIONS(6530),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6533),
    [anon_sym_BSLASHchapter] = ACTIONS(5987),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddchap] = ACTIONS(5987),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsection] = ACTIONS(5987),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddsec] = ACTIONS(5987),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHitem] = ACTIONS(5987),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5989),
    [anon_sym_LBRACE] = ACTIONS(5989),
    [anon_sym_RBRACE] = ACTIONS(5989),
    [sym_word] = ACTIONS(5987),
    [sym_placeholder] = ACTIONS(5989),
    [anon_sym_PLUS] = ACTIONS(5989),
    [anon_sym_DASH] = ACTIONS(5989),
    [anon_sym_STAR] = ACTIONS(5989),
    [anon_sym_SLASH] = ACTIONS(5989),
    [anon_sym_LT] = ACTIONS(5987),
    [anon_sym_GT] = ACTIONS(5987),
    [anon_sym_BANG] = ACTIONS(5987),
    [anon_sym_PIPE] = ACTIONS(5987),
    [anon_sym_COLON] = ACTIONS(5987),
    [anon_sym_SQUOTE] = ACTIONS(5987),
    [anon_sym__] = ACTIONS(5989),
    [anon_sym_CARET] = ACTIONS(5989),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5989),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5989),
    [anon_sym_DOLLAR] = ACTIONS(5987),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHbegin] = ACTIONS(5987),
    [anon_sym_BSLASHtitle] = ACTIONS(5987),
    [anon_sym_BSLASHauthor] = ACTIONS(5987),
    [anon_sym_BSLASHusepackage] = ACTIONS(5987),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5987),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5987),
    [anon_sym_BSLASHinclude] = ACTIONS(5987),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5987),
    [anon_sym_BSLASHinput] = ACTIONS(5987),
    [anon_sym_BSLASHsubfile] = ACTIONS(5987),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5987),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5987),
    [anon_sym_BSLASHbibliography] = ACTIONS(5987),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5987),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5987),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5987),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5987),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5987),
    [anon_sym_BSLASHimport] = ACTIONS(5987),
    [anon_sym_BSLASHsubimport] = ACTIONS(5987),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5987),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHcaption] = ACTIONS(5987),
    [anon_sym_BSLASHcite] = ACTIONS(5987),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCite] = ACTIONS(5987),
    [anon_sym_BSLASHnocite] = ACTIONS(5987),
    [anon_sym_BSLASHcitet] = ACTIONS(5987),
    [anon_sym_BSLASHcitep] = ACTIONS(5987),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteA] = ACTIONS(5987),
    [anon_sym_BSLASHciteR] = ACTIONS(5987),
    [anon_sym_BSLASHciteS] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5987),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteyear] = ACTIONS(5987),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitedate] = ACTIONS(5987),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteurl] = ACTIONS(5987),
    [anon_sym_BSLASHfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5987),
    [anon_sym_BSLASHcitealt] = ACTIONS(5987),
    [anon_sym_BSLASHcitealp] = ACTIONS(5987),
    [anon_sym_BSLASHcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHparencite] = ACTIONS(5987),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHParencite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHtextcite] = ACTIONS(5987),
    [anon_sym_BSLASHTextcite] = ACTIONS(5987),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHsupercite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite] = ACTIONS(5987),
    [anon_sym_BSLASHAutocite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHVolcite] = ACTIONS(5987),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHavolcite] = ACTIONS(5987),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHNotecite] = ACTIONS(5987),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHlabel] = ACTIONS(5987),
    [anon_sym_BSLASHref] = ACTIONS(5987),
    [anon_sym_BSLASHeqref] = ACTIONS(5987),
    [anon_sym_BSLASHvref] = ACTIONS(5987),
    [anon_sym_BSLASHVref] = ACTIONS(5987),
    [anon_sym_BSLASHautoref] = ACTIONS(5987),
    [anon_sym_BSLASHpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcref] = ACTIONS(5987),
    [anon_sym_BSLASHCref] = ACTIONS(5987),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnameCref] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHdef] = ACTIONS(5987),
    [anon_sym_BSLASHlet] = ACTIONS(5987),
    [anon_sym_BSLASHleft] = ACTIONS(5987),
    [anon_sym_BSLASHbigl] = ACTIONS(5987),
    [anon_sym_BSLASHBigl] = ACTIONS(5987),
    [anon_sym_BSLASHbiggl] = ACTIONS(5987),
    [anon_sym_BSLASHBiggl] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5987),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5987),
    [anon_sym_BSLASHgls] = ACTIONS(5987),
    [anon_sym_BSLASHGls] = ACTIONS(5987),
    [anon_sym_BSLASHGLS] = ACTIONS(5987),
    [anon_sym_BSLASHglspl] = ACTIONS(5987),
    [anon_sym_BSLASHGlspl] = ACTIONS(5987),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5987),
    [anon_sym_BSLASHglslink] = ACTIONS(5987),
    [anon_sym_BSLASHglstext] = ACTIONS(5987),
    [anon_sym_BSLASHGlstext] = ACTIONS(5987),
    [anon_sym_BSLASHGLStext] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5987),
    [anon_sym_BSLASHglsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsname] = ACTIONS(5987),
    [anon_sym_BSLASHGlsname] = ACTIONS(5987),
    [anon_sym_BSLASHGLSname] = ACTIONS(5987),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5987),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5987),
    [anon_sym_BSLASHacrshort] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5987),
    [anon_sym_BSLASHACRshort] = ACTIONS(5987),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrlong] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5987),
    [anon_sym_BSLASHACRlong] = ACTIONS(5987),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrfull] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5987),
    [anon_sym_BSLASHACRfull] = ACTIONS(5987),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHacs] = ACTIONS(5987),
    [anon_sym_BSLASHAcs] = ACTIONS(5987),
    [anon_sym_BSLASHacsp] = ACTIONS(5987),
    [anon_sym_BSLASHAcsp] = ACTIONS(5987),
    [anon_sym_BSLASHacl] = ACTIONS(5987),
    [anon_sym_BSLASHAcl] = ACTIONS(5987),
    [anon_sym_BSLASHaclp] = ACTIONS(5987),
    [anon_sym_BSLASHAclp] = ACTIONS(5987),
    [anon_sym_BSLASHacf] = ACTIONS(5987),
    [anon_sym_BSLASHAcf] = ACTIONS(5987),
    [anon_sym_BSLASHacfp] = ACTIONS(5987),
    [anon_sym_BSLASHAcfp] = ACTIONS(5987),
    [anon_sym_BSLASHac] = ACTIONS(5987),
    [anon_sym_BSLASHAc] = ACTIONS(5987),
    [anon_sym_BSLASHacp] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5987),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5987),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5987),
    [anon_sym_BSLASHcolor] = ACTIONS(5987),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5987),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5987),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5987),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5987),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5987),
    [anon_sym_BSLASHtext] = ACTIONS(5987),
    [anon_sym_BSLASHintertext] = ACTIONS(5987),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5987),
    [anon_sym_BSLASHurl] = ACTIONS(5987),
    [anon_sym_BSLASHhref] = ACTIONS(5987),
  },
  [585] = {
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(585),
    [aux_sym__section_repeat2] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(5999),
    [sym_command_name] = ACTIONS(5997),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_RBRACK] = ACTIONS(5999),
    [anon_sym_COMMA] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(5999),
    [anon_sym_LPAREN] = ACTIONS(5999),
    [anon_sym_RPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHpart] = ACTIONS(5997),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddpart] = ACTIONS(5997),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHchapter] = ACTIONS(6536),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6539),
    [anon_sym_BSLASHaddchap] = ACTIONS(6536),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6539),
    [anon_sym_BSLASHsection] = ACTIONS(5997),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddsec] = ACTIONS(5997),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHitem] = ACTIONS(5997),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5999),
    [anon_sym_LBRACE] = ACTIONS(5999),
    [anon_sym_RBRACE] = ACTIONS(5999),
    [sym_word] = ACTIONS(5997),
    [sym_placeholder] = ACTIONS(5999),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5999),
    [anon_sym_STAR] = ACTIONS(5999),
    [anon_sym_SLASH] = ACTIONS(5999),
    [anon_sym_LT] = ACTIONS(5997),
    [anon_sym_GT] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5997),
    [anon_sym_PIPE] = ACTIONS(5997),
    [anon_sym_COLON] = ACTIONS(5997),
    [anon_sym_SQUOTE] = ACTIONS(5997),
    [anon_sym__] = ACTIONS(5999),
    [anon_sym_CARET] = ACTIONS(5999),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5999),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5999),
    [anon_sym_DOLLAR] = ACTIONS(5997),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHbegin] = ACTIONS(5997),
    [anon_sym_BSLASHtitle] = ACTIONS(5997),
    [anon_sym_BSLASHauthor] = ACTIONS(5997),
    [anon_sym_BSLASHusepackage] = ACTIONS(5997),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5997),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5997),
    [anon_sym_BSLASHinclude] = ACTIONS(5997),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5997),
    [anon_sym_BSLASHinput] = ACTIONS(5997),
    [anon_sym_BSLASHsubfile] = ACTIONS(5997),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5997),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5997),
    [anon_sym_BSLASHbibliography] = ACTIONS(5997),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5997),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5997),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5997),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5997),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5997),
    [anon_sym_BSLASHimport] = ACTIONS(5997),
    [anon_sym_BSLASHsubimport] = ACTIONS(5997),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5997),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHcaption] = ACTIONS(5997),
    [anon_sym_BSLASHcite] = ACTIONS(5997),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCite] = ACTIONS(5997),
    [anon_sym_BSLASHnocite] = ACTIONS(5997),
    [anon_sym_BSLASHcitet] = ACTIONS(5997),
    [anon_sym_BSLASHcitep] = ACTIONS(5997),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteA] = ACTIONS(5997),
    [anon_sym_BSLASHciteR] = ACTIONS(5997),
    [anon_sym_BSLASHciteS] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5997),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteyear] = ACTIONS(5997),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitedate] = ACTIONS(5997),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteurl] = ACTIONS(5997),
    [anon_sym_BSLASHfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5997),
    [anon_sym_BSLASHcitealt] = ACTIONS(5997),
    [anon_sym_BSLASHcitealp] = ACTIONS(5997),
    [anon_sym_BSLASHcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHparencite] = ACTIONS(5997),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHParencite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHtextcite] = ACTIONS(5997),
    [anon_sym_BSLASHTextcite] = ACTIONS(5997),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHsupercite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite] = ACTIONS(5997),
    [anon_sym_BSLASHAutocite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHVolcite] = ACTIONS(5997),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHavolcite] = ACTIONS(5997),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHNotecite] = ACTIONS(5997),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHlabel] = ACTIONS(5997),
    [anon_sym_BSLASHref] = ACTIONS(5997),
    [anon_sym_BSLASHeqref] = ACTIONS(5997),
    [anon_sym_BSLASHvref] = ACTIONS(5997),
    [anon_sym_BSLASHVref] = ACTIONS(5997),
    [anon_sym_BSLASHautoref] = ACTIONS(5997),
    [anon_sym_BSLASHpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcref] = ACTIONS(5997),
    [anon_sym_BSLASHCref] = ACTIONS(5997),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnameCref] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHdef] = ACTIONS(5997),
    [anon_sym_BSLASHlet] = ACTIONS(5997),
    [anon_sym_BSLASHleft] = ACTIONS(5997),
    [anon_sym_BSLASHbigl] = ACTIONS(5997),
    [anon_sym_BSLASHBigl] = ACTIONS(5997),
    [anon_sym_BSLASHbiggl] = ACTIONS(5997),
    [anon_sym_BSLASHBiggl] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5997),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5997),
    [anon_sym_BSLASHgls] = ACTIONS(5997),
    [anon_sym_BSLASHGls] = ACTIONS(5997),
    [anon_sym_BSLASHGLS] = ACTIONS(5997),
    [anon_sym_BSLASHglspl] = ACTIONS(5997),
    [anon_sym_BSLASHGlspl] = ACTIONS(5997),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5997),
    [anon_sym_BSLASHglslink] = ACTIONS(5997),
    [anon_sym_BSLASHglstext] = ACTIONS(5997),
    [anon_sym_BSLASHGlstext] = ACTIONS(5997),
    [anon_sym_BSLASHGLStext] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5997),
    [anon_sym_BSLASHglsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsname] = ACTIONS(5997),
    [anon_sym_BSLASHGlsname] = ACTIONS(5997),
    [anon_sym_BSLASHGLSname] = ACTIONS(5997),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5997),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5997),
    [anon_sym_BSLASHacrshort] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5997),
    [anon_sym_BSLASHACRshort] = ACTIONS(5997),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrlong] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5997),
    [anon_sym_BSLASHACRlong] = ACTIONS(5997),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrfull] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5997),
    [anon_sym_BSLASHACRfull] = ACTIONS(5997),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHacs] = ACTIONS(5997),
    [anon_sym_BSLASHAcs] = ACTIONS(5997),
    [anon_sym_BSLASHacsp] = ACTIONS(5997),
    [anon_sym_BSLASHAcsp] = ACTIONS(5997),
    [anon_sym_BSLASHacl] = ACTIONS(5997),
    [anon_sym_BSLASHAcl] = ACTIONS(5997),
    [anon_sym_BSLASHaclp] = ACTIONS(5997),
    [anon_sym_BSLASHAclp] = ACTIONS(5997),
    [anon_sym_BSLASHacf] = ACTIONS(5997),
    [anon_sym_BSLASHAcf] = ACTIONS(5997),
    [anon_sym_BSLASHacfp] = ACTIONS(5997),
    [anon_sym_BSLASHAcfp] = ACTIONS(5997),
    [anon_sym_BSLASHac] = ACTIONS(5997),
    [anon_sym_BSLASHAc] = ACTIONS(5997),
    [anon_sym_BSLASHacp] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5997),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5997),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5997),
    [anon_sym_BSLASHcolor] = ACTIONS(5997),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5997),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5997),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5997),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5997),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5997),
    [anon_sym_BSLASHtext] = ACTIONS(5997),
    [anon_sym_BSLASHintertext] = ACTIONS(5997),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5997),
    [anon_sym_BSLASHurl] = ACTIONS(5997),
    [anon_sym_BSLASHhref] = ACTIONS(5997),
  },
  [586] = {
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(585),
    [aux_sym__section_repeat2] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(6087),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [anon_sym_RBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [587] = {
    [sym__chapter_declaration] = STATE(160),
    [sym_chapter] = STATE(585),
    [aux_sym__section_repeat2] = STATE(585),
    [ts_builtin_sym_end] = ACTIONS(6079),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(17),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(19),
    [anon_sym_BSLASHaddchap] = ACTIONS(17),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(19),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [anon_sym_RBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [588] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(6091),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [589] = {
    [sym_command_name] = ACTIONS(6542),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6544),
    [anon_sym_RBRACK] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LPAREN] = ACTIONS(6544),
    [anon_sym_RPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHpart] = ACTIONS(6542),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddpart] = ACTIONS(6542),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHchapter] = ACTIONS(6542),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddchap] = ACTIONS(6542),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsection] = ACTIONS(6542),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddsec] = ACTIONS(6542),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHitem] = ACTIONS(6542),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6544),
    [anon_sym_LBRACE] = ACTIONS(6544),
    [sym_word] = ACTIONS(6542),
    [sym_placeholder] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_DASH] = ACTIONS(6544),
    [anon_sym_STAR] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6542),
    [anon_sym_GT] = ACTIONS(6542),
    [anon_sym_BANG] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6542),
    [anon_sym_COLON] = ACTIONS(6542),
    [anon_sym_SQUOTE] = ACTIONS(6542),
    [anon_sym__] = ACTIONS(6544),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6544),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6544),
    [anon_sym_DOLLAR] = ACTIONS(6542),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHbegin] = ACTIONS(6542),
    [anon_sym_BSLASHtitle] = ACTIONS(6542),
    [anon_sym_BSLASHauthor] = ACTIONS(6542),
    [anon_sym_BSLASHusepackage] = ACTIONS(6542),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6542),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6542),
    [anon_sym_BSLASHinclude] = ACTIONS(6542),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6542),
    [anon_sym_BSLASHinput] = ACTIONS(6542),
    [anon_sym_BSLASHsubfile] = ACTIONS(6542),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6542),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6542),
    [anon_sym_BSLASHbibliography] = ACTIONS(6542),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6542),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6542),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6542),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6542),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6542),
    [anon_sym_BSLASHimport] = ACTIONS(6542),
    [anon_sym_BSLASHsubimport] = ACTIONS(6542),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6542),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHcaption] = ACTIONS(6542),
    [anon_sym_BSLASHcite] = ACTIONS(6542),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCite] = ACTIONS(6542),
    [anon_sym_BSLASHnocite] = ACTIONS(6542),
    [anon_sym_BSLASHcitet] = ACTIONS(6542),
    [anon_sym_BSLASHcitep] = ACTIONS(6542),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteA] = ACTIONS(6542),
    [anon_sym_BSLASHciteR] = ACTIONS(6542),
    [anon_sym_BSLASHciteS] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6542),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteyear] = ACTIONS(6542),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitedate] = ACTIONS(6542),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteurl] = ACTIONS(6542),
    [anon_sym_BSLASHfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6542),
    [anon_sym_BSLASHcitealt] = ACTIONS(6542),
    [anon_sym_BSLASHcitealp] = ACTIONS(6542),
    [anon_sym_BSLASHcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHparencite] = ACTIONS(6542),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHParencite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHtextcite] = ACTIONS(6542),
    [anon_sym_BSLASHTextcite] = ACTIONS(6542),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHsupercite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite] = ACTIONS(6542),
    [anon_sym_BSLASHAutocite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHVolcite] = ACTIONS(6542),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHavolcite] = ACTIONS(6542),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHNotecite] = ACTIONS(6542),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHlabel] = ACTIONS(6542),
    [anon_sym_BSLASHref] = ACTIONS(6542),
    [anon_sym_BSLASHeqref] = ACTIONS(6542),
    [anon_sym_BSLASHvref] = ACTIONS(6542),
    [anon_sym_BSLASHVref] = ACTIONS(6542),
    [anon_sym_BSLASHautoref] = ACTIONS(6542),
    [anon_sym_BSLASHpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcref] = ACTIONS(6542),
    [anon_sym_BSLASHCref] = ACTIONS(6542),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnameCref] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHdef] = ACTIONS(6542),
    [anon_sym_BSLASHlet] = ACTIONS(6542),
    [anon_sym_BSLASHleft] = ACTIONS(6542),
    [anon_sym_BSLASHbigl] = ACTIONS(6542),
    [anon_sym_BSLASHBigl] = ACTIONS(6542),
    [anon_sym_BSLASHbiggl] = ACTIONS(6542),
    [anon_sym_BSLASHBiggl] = ACTIONS(6542),
    [anon_sym_BSLASHright] = ACTIONS(6542),
    [anon_sym_BSLASHbigr] = ACTIONS(6542),
    [anon_sym_BSLASHBigr] = ACTIONS(6542),
    [anon_sym_BSLASHbiggr] = ACTIONS(6542),
    [anon_sym_BSLASHBiggr] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6542),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6542),
    [anon_sym_BSLASHgls] = ACTIONS(6542),
    [anon_sym_BSLASHGls] = ACTIONS(6542),
    [anon_sym_BSLASHGLS] = ACTIONS(6542),
    [anon_sym_BSLASHglspl] = ACTIONS(6542),
    [anon_sym_BSLASHGlspl] = ACTIONS(6542),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6542),
    [anon_sym_BSLASHglslink] = ACTIONS(6542),
    [anon_sym_BSLASHglstext] = ACTIONS(6542),
    [anon_sym_BSLASHGlstext] = ACTIONS(6542),
    [anon_sym_BSLASHGLStext] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6542),
    [anon_sym_BSLASHglsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsname] = ACTIONS(6542),
    [anon_sym_BSLASHGlsname] = ACTIONS(6542),
    [anon_sym_BSLASHGLSname] = ACTIONS(6542),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6542),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6542),
    [anon_sym_BSLASHacrshort] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6542),
    [anon_sym_BSLASHACRshort] = ACTIONS(6542),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrlong] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6542),
    [anon_sym_BSLASHACRlong] = ACTIONS(6542),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrfull] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6542),
    [anon_sym_BSLASHACRfull] = ACTIONS(6542),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHacs] = ACTIONS(6542),
    [anon_sym_BSLASHAcs] = ACTIONS(6542),
    [anon_sym_BSLASHacsp] = ACTIONS(6542),
    [anon_sym_BSLASHAcsp] = ACTIONS(6542),
    [anon_sym_BSLASHacl] = ACTIONS(6542),
    [anon_sym_BSLASHAcl] = ACTIONS(6542),
    [anon_sym_BSLASHaclp] = ACTIONS(6542),
    [anon_sym_BSLASHAclp] = ACTIONS(6542),
    [anon_sym_BSLASHacf] = ACTIONS(6542),
    [anon_sym_BSLASHAcf] = ACTIONS(6542),
    [anon_sym_BSLASHacfp] = ACTIONS(6542),
    [anon_sym_BSLASHAcfp] = ACTIONS(6542),
    [anon_sym_BSLASHac] = ACTIONS(6542),
    [anon_sym_BSLASHAc] = ACTIONS(6542),
    [anon_sym_BSLASHacp] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6542),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6542),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6542),
    [anon_sym_BSLASHcolor] = ACTIONS(6542),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6542),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6542),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6542),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6542),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6542),
    [anon_sym_BSLASHtext] = ACTIONS(6542),
    [anon_sym_BSLASHintertext] = ACTIONS(6542),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6542),
    [anon_sym_BSLASHurl] = ACTIONS(6542),
    [anon_sym_BSLASHhref] = ACTIONS(6542),
  },
  [590] = {
    [sym_command_name] = ACTIONS(6546),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6548),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LPAREN] = ACTIONS(6548),
    [anon_sym_RPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHpart] = ACTIONS(6546),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddpart] = ACTIONS(6546),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHchapter] = ACTIONS(6546),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddchap] = ACTIONS(6546),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsection] = ACTIONS(6546),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddsec] = ACTIONS(6546),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHitem] = ACTIONS(6546),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6548),
    [anon_sym_LBRACE] = ACTIONS(6548),
    [sym_word] = ACTIONS(6546),
    [sym_placeholder] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_DASH] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6546),
    [anon_sym_GT] = ACTIONS(6546),
    [anon_sym_BANG] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6546),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_SQUOTE] = ACTIONS(6546),
    [anon_sym__] = ACTIONS(6548),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6548),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6548),
    [anon_sym_DOLLAR] = ACTIONS(6546),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHbegin] = ACTIONS(6546),
    [anon_sym_BSLASHtitle] = ACTIONS(6546),
    [anon_sym_BSLASHauthor] = ACTIONS(6546),
    [anon_sym_BSLASHusepackage] = ACTIONS(6546),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6546),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6546),
    [anon_sym_BSLASHinclude] = ACTIONS(6546),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6546),
    [anon_sym_BSLASHinput] = ACTIONS(6546),
    [anon_sym_BSLASHsubfile] = ACTIONS(6546),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6546),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6546),
    [anon_sym_BSLASHbibliography] = ACTIONS(6546),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6546),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6546),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6546),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6546),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6546),
    [anon_sym_BSLASHimport] = ACTIONS(6546),
    [anon_sym_BSLASHsubimport] = ACTIONS(6546),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6546),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHcaption] = ACTIONS(6546),
    [anon_sym_BSLASHcite] = ACTIONS(6546),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCite] = ACTIONS(6546),
    [anon_sym_BSLASHnocite] = ACTIONS(6546),
    [anon_sym_BSLASHcitet] = ACTIONS(6546),
    [anon_sym_BSLASHcitep] = ACTIONS(6546),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteA] = ACTIONS(6546),
    [anon_sym_BSLASHciteR] = ACTIONS(6546),
    [anon_sym_BSLASHciteS] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6546),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteyear] = ACTIONS(6546),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitedate] = ACTIONS(6546),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteurl] = ACTIONS(6546),
    [anon_sym_BSLASHfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6546),
    [anon_sym_BSLASHcitealt] = ACTIONS(6546),
    [anon_sym_BSLASHcitealp] = ACTIONS(6546),
    [anon_sym_BSLASHcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHparencite] = ACTIONS(6546),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHParencite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHtextcite] = ACTIONS(6546),
    [anon_sym_BSLASHTextcite] = ACTIONS(6546),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHsupercite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite] = ACTIONS(6546),
    [anon_sym_BSLASHAutocite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHVolcite] = ACTIONS(6546),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHavolcite] = ACTIONS(6546),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHNotecite] = ACTIONS(6546),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHlabel] = ACTIONS(6546),
    [anon_sym_BSLASHref] = ACTIONS(6546),
    [anon_sym_BSLASHeqref] = ACTIONS(6546),
    [anon_sym_BSLASHvref] = ACTIONS(6546),
    [anon_sym_BSLASHVref] = ACTIONS(6546),
    [anon_sym_BSLASHautoref] = ACTIONS(6546),
    [anon_sym_BSLASHpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcref] = ACTIONS(6546),
    [anon_sym_BSLASHCref] = ACTIONS(6546),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnameCref] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHdef] = ACTIONS(6546),
    [anon_sym_BSLASHlet] = ACTIONS(6546),
    [anon_sym_BSLASHleft] = ACTIONS(6546),
    [anon_sym_BSLASHbigl] = ACTIONS(6546),
    [anon_sym_BSLASHBigl] = ACTIONS(6546),
    [anon_sym_BSLASHbiggl] = ACTIONS(6546),
    [anon_sym_BSLASHBiggl] = ACTIONS(6546),
    [anon_sym_BSLASHright] = ACTIONS(6546),
    [anon_sym_BSLASHbigr] = ACTIONS(6546),
    [anon_sym_BSLASHBigr] = ACTIONS(6546),
    [anon_sym_BSLASHbiggr] = ACTIONS(6546),
    [anon_sym_BSLASHBiggr] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6546),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6546),
    [anon_sym_BSLASHgls] = ACTIONS(6546),
    [anon_sym_BSLASHGls] = ACTIONS(6546),
    [anon_sym_BSLASHGLS] = ACTIONS(6546),
    [anon_sym_BSLASHglspl] = ACTIONS(6546),
    [anon_sym_BSLASHGlspl] = ACTIONS(6546),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6546),
    [anon_sym_BSLASHglslink] = ACTIONS(6546),
    [anon_sym_BSLASHglstext] = ACTIONS(6546),
    [anon_sym_BSLASHGlstext] = ACTIONS(6546),
    [anon_sym_BSLASHGLStext] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6546),
    [anon_sym_BSLASHglsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsname] = ACTIONS(6546),
    [anon_sym_BSLASHGlsname] = ACTIONS(6546),
    [anon_sym_BSLASHGLSname] = ACTIONS(6546),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6546),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6546),
    [anon_sym_BSLASHacrshort] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6546),
    [anon_sym_BSLASHACRshort] = ACTIONS(6546),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrlong] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6546),
    [anon_sym_BSLASHACRlong] = ACTIONS(6546),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrfull] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6546),
    [anon_sym_BSLASHACRfull] = ACTIONS(6546),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHacs] = ACTIONS(6546),
    [anon_sym_BSLASHAcs] = ACTIONS(6546),
    [anon_sym_BSLASHacsp] = ACTIONS(6546),
    [anon_sym_BSLASHAcsp] = ACTIONS(6546),
    [anon_sym_BSLASHacl] = ACTIONS(6546),
    [anon_sym_BSLASHAcl] = ACTIONS(6546),
    [anon_sym_BSLASHaclp] = ACTIONS(6546),
    [anon_sym_BSLASHAclp] = ACTIONS(6546),
    [anon_sym_BSLASHacf] = ACTIONS(6546),
    [anon_sym_BSLASHAcf] = ACTIONS(6546),
    [anon_sym_BSLASHacfp] = ACTIONS(6546),
    [anon_sym_BSLASHAcfp] = ACTIONS(6546),
    [anon_sym_BSLASHac] = ACTIONS(6546),
    [anon_sym_BSLASHAc] = ACTIONS(6546),
    [anon_sym_BSLASHacp] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6546),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6546),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6546),
    [anon_sym_BSLASHcolor] = ACTIONS(6546),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6546),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6546),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6546),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6546),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6546),
    [anon_sym_BSLASHtext] = ACTIONS(6546),
    [anon_sym_BSLASHintertext] = ACTIONS(6546),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6546),
    [anon_sym_BSLASHurl] = ACTIONS(6546),
    [anon_sym_BSLASHhref] = ACTIONS(6546),
  },
  [591] = {
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6552),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHpart] = ACTIONS(6550),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddpart] = ACTIONS(6550),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHchapter] = ACTIONS(6550),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddchap] = ACTIONS(6550),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsection] = ACTIONS(6550),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddsec] = ACTIONS(6550),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHitem] = ACTIONS(6550),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6552),
    [anon_sym_DOLLAR] = ACTIONS(6550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHbegin] = ACTIONS(6550),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHleft] = ACTIONS(6550),
    [anon_sym_BSLASHbigl] = ACTIONS(6550),
    [anon_sym_BSLASHBigl] = ACTIONS(6550),
    [anon_sym_BSLASHbiggl] = ACTIONS(6550),
    [anon_sym_BSLASHBiggl] = ACTIONS(6550),
    [anon_sym_BSLASHright] = ACTIONS(6550),
    [anon_sym_BSLASHbigr] = ACTIONS(6550),
    [anon_sym_BSLASHBigr] = ACTIONS(6550),
    [anon_sym_BSLASHbiggr] = ACTIONS(6550),
    [anon_sym_BSLASHBiggr] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHtext] = ACTIONS(6550),
    [anon_sym_BSLASHintertext] = ACTIONS(6550),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [592] = {
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6556),
    [anon_sym_RBRACK] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6556),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHpart] = ACTIONS(6554),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddpart] = ACTIONS(6554),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHchapter] = ACTIONS(6554),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddchap] = ACTIONS(6554),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsection] = ACTIONS(6554),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddsec] = ACTIONS(6554),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHitem] = ACTIONS(6554),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6556),
    [anon_sym_LBRACE] = ACTIONS(6556),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6556),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6556),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHbegin] = ACTIONS(6554),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHleft] = ACTIONS(6554),
    [anon_sym_BSLASHbigl] = ACTIONS(6554),
    [anon_sym_BSLASHBigl] = ACTIONS(6554),
    [anon_sym_BSLASHbiggl] = ACTIONS(6554),
    [anon_sym_BSLASHBiggl] = ACTIONS(6554),
    [anon_sym_BSLASHright] = ACTIONS(6554),
    [anon_sym_BSLASHbigr] = ACTIONS(6554),
    [anon_sym_BSLASHBigr] = ACTIONS(6554),
    [anon_sym_BSLASHbiggr] = ACTIONS(6554),
    [anon_sym_BSLASHBiggr] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHtext] = ACTIONS(6554),
    [anon_sym_BSLASHintertext] = ACTIONS(6554),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [593] = {
    [sym__part_declaration] = STATE(153),
    [sym_part] = STATE(584),
    [aux_sym__section_repeat1] = STATE(584),
    [ts_builtin_sym_end] = ACTIONS(6079),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(13),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHaddpart] = ACTIONS(13),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(15),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [anon_sym_RBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [594] = {
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_LBRACK] = ACTIONS(6560),
    [anon_sym_RBRACK] = ACTIONS(6560),
    [anon_sym_COMMA] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHpart] = ACTIONS(6558),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddpart] = ACTIONS(6558),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHchapter] = ACTIONS(6558),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddchap] = ACTIONS(6558),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsection] = ACTIONS(6558),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddsec] = ACTIONS(6558),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHitem] = ACTIONS(6558),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6560),
    [anon_sym_LBRACE] = ACTIONS(6560),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6560),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(6558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHbegin] = ACTIONS(6558),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHleft] = ACTIONS(6558),
    [anon_sym_BSLASHbigl] = ACTIONS(6558),
    [anon_sym_BSLASHBigl] = ACTIONS(6558),
    [anon_sym_BSLASHbiggl] = ACTIONS(6558),
    [anon_sym_BSLASHBiggl] = ACTIONS(6558),
    [anon_sym_BSLASHright] = ACTIONS(6558),
    [anon_sym_BSLASHbigr] = ACTIONS(6558),
    [anon_sym_BSLASHBigr] = ACTIONS(6558),
    [anon_sym_BSLASHbiggr] = ACTIONS(6558),
    [anon_sym_BSLASHBiggr] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHtext] = ACTIONS(6558),
    [anon_sym_BSLASHintertext] = ACTIONS(6558),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [595] = {
    [sym_command_name] = ACTIONS(6562),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6562),
    [anon_sym_LBRACK] = ACTIONS(6564),
    [anon_sym_RBRACK] = ACTIONS(6564),
    [anon_sym_COMMA] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6564),
    [anon_sym_RPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHpart] = ACTIONS(6562),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddpart] = ACTIONS(6562),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHchapter] = ACTIONS(6562),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddchap] = ACTIONS(6562),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsection] = ACTIONS(6562),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddsec] = ACTIONS(6562),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHitem] = ACTIONS(6562),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6564),
    [anon_sym_LBRACE] = ACTIONS(6564),
    [sym_word] = ACTIONS(6562),
    [sym_placeholder] = ACTIONS(6564),
    [anon_sym_PLUS] = ACTIONS(6564),
    [anon_sym_DASH] = ACTIONS(6564),
    [anon_sym_STAR] = ACTIONS(6564),
    [anon_sym_SLASH] = ACTIONS(6564),
    [anon_sym_LT] = ACTIONS(6562),
    [anon_sym_GT] = ACTIONS(6562),
    [anon_sym_BANG] = ACTIONS(6562),
    [anon_sym_PIPE] = ACTIONS(6562),
    [anon_sym_COLON] = ACTIONS(6562),
    [anon_sym_SQUOTE] = ACTIONS(6562),
    [anon_sym__] = ACTIONS(6564),
    [anon_sym_CARET] = ACTIONS(6564),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6564),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6564),
    [anon_sym_DOLLAR] = ACTIONS(6562),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHbegin] = ACTIONS(6562),
    [anon_sym_BSLASHtitle] = ACTIONS(6562),
    [anon_sym_BSLASHauthor] = ACTIONS(6562),
    [anon_sym_BSLASHusepackage] = ACTIONS(6562),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6562),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6562),
    [anon_sym_BSLASHinclude] = ACTIONS(6562),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6562),
    [anon_sym_BSLASHinput] = ACTIONS(6562),
    [anon_sym_BSLASHsubfile] = ACTIONS(6562),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6562),
    [anon_sym_BSLASHbibliography] = ACTIONS(6562),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6562),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6562),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6562),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6562),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6562),
    [anon_sym_BSLASHimport] = ACTIONS(6562),
    [anon_sym_BSLASHsubimport] = ACTIONS(6562),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6562),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHcaption] = ACTIONS(6562),
    [anon_sym_BSLASHcite] = ACTIONS(6562),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCite] = ACTIONS(6562),
    [anon_sym_BSLASHnocite] = ACTIONS(6562),
    [anon_sym_BSLASHcitet] = ACTIONS(6562),
    [anon_sym_BSLASHcitep] = ACTIONS(6562),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteA] = ACTIONS(6562),
    [anon_sym_BSLASHciteR] = ACTIONS(6562),
    [anon_sym_BSLASHciteS] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6562),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteyear] = ACTIONS(6562),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitedate] = ACTIONS(6562),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteurl] = ACTIONS(6562),
    [anon_sym_BSLASHfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6562),
    [anon_sym_BSLASHcitealt] = ACTIONS(6562),
    [anon_sym_BSLASHcitealp] = ACTIONS(6562),
    [anon_sym_BSLASHcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHparencite] = ACTIONS(6562),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHParencite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHtextcite] = ACTIONS(6562),
    [anon_sym_BSLASHTextcite] = ACTIONS(6562),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHsupercite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite] = ACTIONS(6562),
    [anon_sym_BSLASHAutocite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHVolcite] = ACTIONS(6562),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHavolcite] = ACTIONS(6562),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHNotecite] = ACTIONS(6562),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHlabel] = ACTIONS(6562),
    [anon_sym_BSLASHref] = ACTIONS(6562),
    [anon_sym_BSLASHeqref] = ACTIONS(6562),
    [anon_sym_BSLASHvref] = ACTIONS(6562),
    [anon_sym_BSLASHVref] = ACTIONS(6562),
    [anon_sym_BSLASHautoref] = ACTIONS(6562),
    [anon_sym_BSLASHpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcref] = ACTIONS(6562),
    [anon_sym_BSLASHCref] = ACTIONS(6562),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnameCref] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHdef] = ACTIONS(6562),
    [anon_sym_BSLASHlet] = ACTIONS(6562),
    [anon_sym_BSLASHleft] = ACTIONS(6562),
    [anon_sym_BSLASHbigl] = ACTIONS(6562),
    [anon_sym_BSLASHBigl] = ACTIONS(6562),
    [anon_sym_BSLASHbiggl] = ACTIONS(6562),
    [anon_sym_BSLASHBiggl] = ACTIONS(6562),
    [anon_sym_BSLASHright] = ACTIONS(6562),
    [anon_sym_BSLASHbigr] = ACTIONS(6562),
    [anon_sym_BSLASHBigr] = ACTIONS(6562),
    [anon_sym_BSLASHbiggr] = ACTIONS(6562),
    [anon_sym_BSLASHBiggr] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6562),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6562),
    [anon_sym_BSLASHgls] = ACTIONS(6562),
    [anon_sym_BSLASHGls] = ACTIONS(6562),
    [anon_sym_BSLASHGLS] = ACTIONS(6562),
    [anon_sym_BSLASHglspl] = ACTIONS(6562),
    [anon_sym_BSLASHGlspl] = ACTIONS(6562),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6562),
    [anon_sym_BSLASHglslink] = ACTIONS(6562),
    [anon_sym_BSLASHglstext] = ACTIONS(6562),
    [anon_sym_BSLASHGlstext] = ACTIONS(6562),
    [anon_sym_BSLASHGLStext] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6562),
    [anon_sym_BSLASHglsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsname] = ACTIONS(6562),
    [anon_sym_BSLASHGlsname] = ACTIONS(6562),
    [anon_sym_BSLASHGLSname] = ACTIONS(6562),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6562),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6562),
    [anon_sym_BSLASHacrshort] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6562),
    [anon_sym_BSLASHACRshort] = ACTIONS(6562),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrlong] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6562),
    [anon_sym_BSLASHACRlong] = ACTIONS(6562),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrfull] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6562),
    [anon_sym_BSLASHACRfull] = ACTIONS(6562),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHacs] = ACTIONS(6562),
    [anon_sym_BSLASHAcs] = ACTIONS(6562),
    [anon_sym_BSLASHacsp] = ACTIONS(6562),
    [anon_sym_BSLASHAcsp] = ACTIONS(6562),
    [anon_sym_BSLASHacl] = ACTIONS(6562),
    [anon_sym_BSLASHAcl] = ACTIONS(6562),
    [anon_sym_BSLASHaclp] = ACTIONS(6562),
    [anon_sym_BSLASHAclp] = ACTIONS(6562),
    [anon_sym_BSLASHacf] = ACTIONS(6562),
    [anon_sym_BSLASHAcf] = ACTIONS(6562),
    [anon_sym_BSLASHacfp] = ACTIONS(6562),
    [anon_sym_BSLASHAcfp] = ACTIONS(6562),
    [anon_sym_BSLASHac] = ACTIONS(6562),
    [anon_sym_BSLASHAc] = ACTIONS(6562),
    [anon_sym_BSLASHacp] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6562),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6562),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6562),
    [anon_sym_BSLASHcolor] = ACTIONS(6562),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6562),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6562),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6562),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6562),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6562),
    [anon_sym_BSLASHtext] = ACTIONS(6562),
    [anon_sym_BSLASHintertext] = ACTIONS(6562),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6562),
    [anon_sym_BSLASHurl] = ACTIONS(6562),
    [anon_sym_BSLASHhref] = ACTIONS(6562),
  },
  [596] = {
    [sym__enum_itemdeclaration] = STATE(223),
    [sym_enum_item] = STATE(596),
    [aux_sym__paragraph_repeat3] = STATE(596),
    [ts_builtin_sym_end] = ACTIONS(6049),
    [sym_command_name] = ACTIONS(6047),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(6049),
    [anon_sym_RBRACK] = ACTIONS(6049),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(6049),
    [anon_sym_RPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHpart] = ACTIONS(6047),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddpart] = ACTIONS(6047),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHchapter] = ACTIONS(6047),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddchap] = ACTIONS(6047),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsection] = ACTIONS(6047),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddsec] = ACTIONS(6047),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHitem] = ACTIONS(6566),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6569),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [anon_sym_RBRACE] = ACTIONS(6049),
    [sym_word] = ACTIONS(6047),
    [sym_placeholder] = ACTIONS(6049),
    [anon_sym_PLUS] = ACTIONS(6049),
    [anon_sym_DASH] = ACTIONS(6049),
    [anon_sym_STAR] = ACTIONS(6049),
    [anon_sym_SLASH] = ACTIONS(6049),
    [anon_sym_LT] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6047),
    [anon_sym_BANG] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6047),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SQUOTE] = ACTIONS(6047),
    [anon_sym__] = ACTIONS(6049),
    [anon_sym_CARET] = ACTIONS(6049),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6049),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6049),
    [anon_sym_DOLLAR] = ACTIONS(6047),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHbegin] = ACTIONS(6047),
    [anon_sym_BSLASHtitle] = ACTIONS(6047),
    [anon_sym_BSLASHauthor] = ACTIONS(6047),
    [anon_sym_BSLASHusepackage] = ACTIONS(6047),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6047),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6047),
    [anon_sym_BSLASHinclude] = ACTIONS(6047),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6047),
    [anon_sym_BSLASHinput] = ACTIONS(6047),
    [anon_sym_BSLASHsubfile] = ACTIONS(6047),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6047),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6047),
    [anon_sym_BSLASHbibliography] = ACTIONS(6047),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6047),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6047),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6047),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6047),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6047),
    [anon_sym_BSLASHimport] = ACTIONS(6047),
    [anon_sym_BSLASHsubimport] = ACTIONS(6047),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6047),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHcaption] = ACTIONS(6047),
    [anon_sym_BSLASHcite] = ACTIONS(6047),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCite] = ACTIONS(6047),
    [anon_sym_BSLASHnocite] = ACTIONS(6047),
    [anon_sym_BSLASHcitet] = ACTIONS(6047),
    [anon_sym_BSLASHcitep] = ACTIONS(6047),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteA] = ACTIONS(6047),
    [anon_sym_BSLASHciteR] = ACTIONS(6047),
    [anon_sym_BSLASHciteS] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6047),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteyear] = ACTIONS(6047),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitedate] = ACTIONS(6047),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteurl] = ACTIONS(6047),
    [anon_sym_BSLASHfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6047),
    [anon_sym_BSLASHcitealt] = ACTIONS(6047),
    [anon_sym_BSLASHcitealp] = ACTIONS(6047),
    [anon_sym_BSLASHcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHparencite] = ACTIONS(6047),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHParencite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHtextcite] = ACTIONS(6047),
    [anon_sym_BSLASHTextcite] = ACTIONS(6047),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHsupercite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite] = ACTIONS(6047),
    [anon_sym_BSLASHAutocite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHVolcite] = ACTIONS(6047),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHavolcite] = ACTIONS(6047),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHNotecite] = ACTIONS(6047),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHlabel] = ACTIONS(6047),
    [anon_sym_BSLASHref] = ACTIONS(6047),
    [anon_sym_BSLASHeqref] = ACTIONS(6047),
    [anon_sym_BSLASHvref] = ACTIONS(6047),
    [anon_sym_BSLASHVref] = ACTIONS(6047),
    [anon_sym_BSLASHautoref] = ACTIONS(6047),
    [anon_sym_BSLASHpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcref] = ACTIONS(6047),
    [anon_sym_BSLASHCref] = ACTIONS(6047),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnameCref] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHdef] = ACTIONS(6047),
    [anon_sym_BSLASHlet] = ACTIONS(6047),
    [anon_sym_BSLASHleft] = ACTIONS(6047),
    [anon_sym_BSLASHbigl] = ACTIONS(6047),
    [anon_sym_BSLASHBigl] = ACTIONS(6047),
    [anon_sym_BSLASHbiggl] = ACTIONS(6047),
    [anon_sym_BSLASHBiggl] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6047),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6047),
    [anon_sym_BSLASHgls] = ACTIONS(6047),
    [anon_sym_BSLASHGls] = ACTIONS(6047),
    [anon_sym_BSLASHGLS] = ACTIONS(6047),
    [anon_sym_BSLASHglspl] = ACTIONS(6047),
    [anon_sym_BSLASHGlspl] = ACTIONS(6047),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6047),
    [anon_sym_BSLASHglslink] = ACTIONS(6047),
    [anon_sym_BSLASHglstext] = ACTIONS(6047),
    [anon_sym_BSLASHGlstext] = ACTIONS(6047),
    [anon_sym_BSLASHGLStext] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6047),
    [anon_sym_BSLASHglsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsname] = ACTIONS(6047),
    [anon_sym_BSLASHGlsname] = ACTIONS(6047),
    [anon_sym_BSLASHGLSname] = ACTIONS(6047),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6047),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6047),
    [anon_sym_BSLASHacrshort] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6047),
    [anon_sym_BSLASHACRshort] = ACTIONS(6047),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrlong] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6047),
    [anon_sym_BSLASHACRlong] = ACTIONS(6047),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrfull] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6047),
    [anon_sym_BSLASHACRfull] = ACTIONS(6047),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHacs] = ACTIONS(6047),
    [anon_sym_BSLASHAcs] = ACTIONS(6047),
    [anon_sym_BSLASHacsp] = ACTIONS(6047),
    [anon_sym_BSLASHAcsp] = ACTIONS(6047),
    [anon_sym_BSLASHacl] = ACTIONS(6047),
    [anon_sym_BSLASHAcl] = ACTIONS(6047),
    [anon_sym_BSLASHaclp] = ACTIONS(6047),
    [anon_sym_BSLASHAclp] = ACTIONS(6047),
    [anon_sym_BSLASHacf] = ACTIONS(6047),
    [anon_sym_BSLASHAcf] = ACTIONS(6047),
    [anon_sym_BSLASHacfp] = ACTIONS(6047),
    [anon_sym_BSLASHAcfp] = ACTIONS(6047),
    [anon_sym_BSLASHac] = ACTIONS(6047),
    [anon_sym_BSLASHAc] = ACTIONS(6047),
    [anon_sym_BSLASHacp] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6047),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6047),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6047),
    [anon_sym_BSLASHcolor] = ACTIONS(6047),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6047),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6047),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6047),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6047),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6047),
    [anon_sym_BSLASHtext] = ACTIONS(6047),
    [anon_sym_BSLASHintertext] = ACTIONS(6047),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6047),
    [anon_sym_BSLASHurl] = ACTIONS(6047),
    [anon_sym_BSLASHhref] = ACTIONS(6047),
  },
  [597] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(6095),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [anon_sym_RBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [598] = {
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_LBRACK] = ACTIONS(6574),
    [anon_sym_RBRACK] = ACTIONS(6574),
    [anon_sym_COMMA] = ACTIONS(6574),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_RPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHpart] = ACTIONS(6572),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddpart] = ACTIONS(6572),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHchapter] = ACTIONS(6572),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddchap] = ACTIONS(6572),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsection] = ACTIONS(6572),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddsec] = ACTIONS(6572),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHitem] = ACTIONS(6572),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6574),
    [anon_sym_LBRACE] = ACTIONS(6574),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6574),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6574),
    [anon_sym_DOLLAR] = ACTIONS(6572),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHbegin] = ACTIONS(6572),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHleft] = ACTIONS(6572),
    [anon_sym_BSLASHbigl] = ACTIONS(6572),
    [anon_sym_BSLASHBigl] = ACTIONS(6572),
    [anon_sym_BSLASHbiggl] = ACTIONS(6572),
    [anon_sym_BSLASHBiggl] = ACTIONS(6572),
    [anon_sym_BSLASHright] = ACTIONS(6572),
    [anon_sym_BSLASHbigr] = ACTIONS(6572),
    [anon_sym_BSLASHBigr] = ACTIONS(6572),
    [anon_sym_BSLASHbiggr] = ACTIONS(6572),
    [anon_sym_BSLASHBiggr] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHtext] = ACTIONS(6572),
    [anon_sym_BSLASHintertext] = ACTIONS(6572),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [599] = {
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(6578),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6578),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_LPAREN] = ACTIONS(6578),
    [anon_sym_RPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHpart] = ACTIONS(6576),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddpart] = ACTIONS(6576),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHchapter] = ACTIONS(6576),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddchap] = ACTIONS(6576),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsection] = ACTIONS(6576),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddsec] = ACTIONS(6576),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHitem] = ACTIONS(6576),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6578),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHbegin] = ACTIONS(6576),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHleft] = ACTIONS(6576),
    [anon_sym_BSLASHbigl] = ACTIONS(6576),
    [anon_sym_BSLASHBigl] = ACTIONS(6576),
    [anon_sym_BSLASHbiggl] = ACTIONS(6576),
    [anon_sym_BSLASHBiggl] = ACTIONS(6576),
    [anon_sym_BSLASHright] = ACTIONS(6576),
    [anon_sym_BSLASHbigr] = ACTIONS(6576),
    [anon_sym_BSLASHBigr] = ACTIONS(6576),
    [anon_sym_BSLASHbiggr] = ACTIONS(6576),
    [anon_sym_BSLASHBiggr] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHtext] = ACTIONS(6576),
    [anon_sym_BSLASHintertext] = ACTIONS(6576),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [600] = {
    [sym__subparagraph_declaration] = STATE(214),
    [sym_subparagraph] = STATE(600),
    [aux_sym__paragraph_repeat2] = STATE(600),
    [ts_builtin_sym_end] = ACTIONS(6039),
    [sym_command_name] = ACTIONS(6037),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(6039),
    [anon_sym_RBRACK] = ACTIONS(6039),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_EQ] = ACTIONS(6039),
    [anon_sym_LPAREN] = ACTIONS(6039),
    [anon_sym_RPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHpart] = ACTIONS(6037),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddpart] = ACTIONS(6037),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHchapter] = ACTIONS(6037),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddchap] = ACTIONS(6037),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsection] = ACTIONS(6037),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddsec] = ACTIONS(6037),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHparagraph] = ACTIONS(6037),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6580),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6583),
    [anon_sym_BSLASHitem] = ACTIONS(6037),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6039),
    [anon_sym_LBRACE] = ACTIONS(6039),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [sym_word] = ACTIONS(6037),
    [sym_placeholder] = ACTIONS(6039),
    [anon_sym_PLUS] = ACTIONS(6039),
    [anon_sym_DASH] = ACTIONS(6039),
    [anon_sym_STAR] = ACTIONS(6039),
    [anon_sym_SLASH] = ACTIONS(6039),
    [anon_sym_LT] = ACTIONS(6037),
    [anon_sym_GT] = ACTIONS(6037),
    [anon_sym_BANG] = ACTIONS(6037),
    [anon_sym_PIPE] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6037),
    [anon_sym_SQUOTE] = ACTIONS(6037),
    [anon_sym__] = ACTIONS(6039),
    [anon_sym_CARET] = ACTIONS(6039),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6039),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6039),
    [anon_sym_DOLLAR] = ACTIONS(6037),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHbegin] = ACTIONS(6037),
    [anon_sym_BSLASHtitle] = ACTIONS(6037),
    [anon_sym_BSLASHauthor] = ACTIONS(6037),
    [anon_sym_BSLASHusepackage] = ACTIONS(6037),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6037),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6037),
    [anon_sym_BSLASHinclude] = ACTIONS(6037),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6037),
    [anon_sym_BSLASHinput] = ACTIONS(6037),
    [anon_sym_BSLASHsubfile] = ACTIONS(6037),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6037),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6037),
    [anon_sym_BSLASHbibliography] = ACTIONS(6037),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6037),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6037),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6037),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6037),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6037),
    [anon_sym_BSLASHimport] = ACTIONS(6037),
    [anon_sym_BSLASHsubimport] = ACTIONS(6037),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6037),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHcaption] = ACTIONS(6037),
    [anon_sym_BSLASHcite] = ACTIONS(6037),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCite] = ACTIONS(6037),
    [anon_sym_BSLASHnocite] = ACTIONS(6037),
    [anon_sym_BSLASHcitet] = ACTIONS(6037),
    [anon_sym_BSLASHcitep] = ACTIONS(6037),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteA] = ACTIONS(6037),
    [anon_sym_BSLASHciteR] = ACTIONS(6037),
    [anon_sym_BSLASHciteS] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6037),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteyear] = ACTIONS(6037),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitedate] = ACTIONS(6037),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteurl] = ACTIONS(6037),
    [anon_sym_BSLASHfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6037),
    [anon_sym_BSLASHcitealt] = ACTIONS(6037),
    [anon_sym_BSLASHcitealp] = ACTIONS(6037),
    [anon_sym_BSLASHcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHparencite] = ACTIONS(6037),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHParencite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHtextcite] = ACTIONS(6037),
    [anon_sym_BSLASHTextcite] = ACTIONS(6037),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHsupercite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite] = ACTIONS(6037),
    [anon_sym_BSLASHAutocite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHVolcite] = ACTIONS(6037),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHavolcite] = ACTIONS(6037),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHNotecite] = ACTIONS(6037),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHlabel] = ACTIONS(6037),
    [anon_sym_BSLASHref] = ACTIONS(6037),
    [anon_sym_BSLASHeqref] = ACTIONS(6037),
    [anon_sym_BSLASHvref] = ACTIONS(6037),
    [anon_sym_BSLASHVref] = ACTIONS(6037),
    [anon_sym_BSLASHautoref] = ACTIONS(6037),
    [anon_sym_BSLASHpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcref] = ACTIONS(6037),
    [anon_sym_BSLASHCref] = ACTIONS(6037),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnameCref] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHdef] = ACTIONS(6037),
    [anon_sym_BSLASHlet] = ACTIONS(6037),
    [anon_sym_BSLASHleft] = ACTIONS(6037),
    [anon_sym_BSLASHbigl] = ACTIONS(6037),
    [anon_sym_BSLASHBigl] = ACTIONS(6037),
    [anon_sym_BSLASHbiggl] = ACTIONS(6037),
    [anon_sym_BSLASHBiggl] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6037),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6037),
    [anon_sym_BSLASHgls] = ACTIONS(6037),
    [anon_sym_BSLASHGls] = ACTIONS(6037),
    [anon_sym_BSLASHGLS] = ACTIONS(6037),
    [anon_sym_BSLASHglspl] = ACTIONS(6037),
    [anon_sym_BSLASHGlspl] = ACTIONS(6037),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6037),
    [anon_sym_BSLASHglslink] = ACTIONS(6037),
    [anon_sym_BSLASHglstext] = ACTIONS(6037),
    [anon_sym_BSLASHGlstext] = ACTIONS(6037),
    [anon_sym_BSLASHGLStext] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6037),
    [anon_sym_BSLASHglsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsname] = ACTIONS(6037),
    [anon_sym_BSLASHGlsname] = ACTIONS(6037),
    [anon_sym_BSLASHGLSname] = ACTIONS(6037),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6037),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6037),
    [anon_sym_BSLASHacrshort] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6037),
    [anon_sym_BSLASHACRshort] = ACTIONS(6037),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrlong] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6037),
    [anon_sym_BSLASHACRlong] = ACTIONS(6037),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrfull] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6037),
    [anon_sym_BSLASHACRfull] = ACTIONS(6037),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHacs] = ACTIONS(6037),
    [anon_sym_BSLASHAcs] = ACTIONS(6037),
    [anon_sym_BSLASHacsp] = ACTIONS(6037),
    [anon_sym_BSLASHAcsp] = ACTIONS(6037),
    [anon_sym_BSLASHacl] = ACTIONS(6037),
    [anon_sym_BSLASHAcl] = ACTIONS(6037),
    [anon_sym_BSLASHaclp] = ACTIONS(6037),
    [anon_sym_BSLASHAclp] = ACTIONS(6037),
    [anon_sym_BSLASHacf] = ACTIONS(6037),
    [anon_sym_BSLASHAcf] = ACTIONS(6037),
    [anon_sym_BSLASHacfp] = ACTIONS(6037),
    [anon_sym_BSLASHAcfp] = ACTIONS(6037),
    [anon_sym_BSLASHac] = ACTIONS(6037),
    [anon_sym_BSLASHAc] = ACTIONS(6037),
    [anon_sym_BSLASHacp] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6037),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6037),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6037),
    [anon_sym_BSLASHcolor] = ACTIONS(6037),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6037),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6037),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6037),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6037),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6037),
    [anon_sym_BSLASHtext] = ACTIONS(6037),
    [anon_sym_BSLASHintertext] = ACTIONS(6037),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6037),
    [anon_sym_BSLASHurl] = ACTIONS(6037),
    [anon_sym_BSLASHhref] = ACTIONS(6037),
  },
  [601] = {
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHpart] = ACTIONS(6586),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddpart] = ACTIONS(6586),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHchapter] = ACTIONS(6586),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddchap] = ACTIONS(6586),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsection] = ACTIONS(6586),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddsec] = ACTIONS(6586),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHitem] = ACTIONS(6586),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6588),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6588),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHbegin] = ACTIONS(6586),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHleft] = ACTIONS(6586),
    [anon_sym_BSLASHbigl] = ACTIONS(6586),
    [anon_sym_BSLASHBigl] = ACTIONS(6586),
    [anon_sym_BSLASHbiggl] = ACTIONS(6586),
    [anon_sym_BSLASHBiggl] = ACTIONS(6586),
    [anon_sym_BSLASHright] = ACTIONS(6586),
    [anon_sym_BSLASHbigr] = ACTIONS(6586),
    [anon_sym_BSLASHBigr] = ACTIONS(6586),
    [anon_sym_BSLASHbiggr] = ACTIONS(6586),
    [anon_sym_BSLASHBiggr] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHtext] = ACTIONS(6586),
    [anon_sym_BSLASHintertext] = ACTIONS(6586),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [602] = {
    [sym_command_name] = ACTIONS(6590),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6590),
    [anon_sym_LBRACK] = ACTIONS(6592),
    [anon_sym_RBRACK] = ACTIONS(6592),
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(6592),
    [anon_sym_LPAREN] = ACTIONS(6592),
    [anon_sym_RPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHpart] = ACTIONS(6590),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddpart] = ACTIONS(6590),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHchapter] = ACTIONS(6590),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddchap] = ACTIONS(6590),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsection] = ACTIONS(6590),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddsec] = ACTIONS(6590),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHitem] = ACTIONS(6590),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6592),
    [anon_sym_LBRACE] = ACTIONS(6592),
    [sym_word] = ACTIONS(6590),
    [sym_placeholder] = ACTIONS(6592),
    [anon_sym_PLUS] = ACTIONS(6592),
    [anon_sym_DASH] = ACTIONS(6592),
    [anon_sym_STAR] = ACTIONS(6592),
    [anon_sym_SLASH] = ACTIONS(6592),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6592),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6592),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6592),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHbegin] = ACTIONS(6590),
    [anon_sym_BSLASHtitle] = ACTIONS(6590),
    [anon_sym_BSLASHauthor] = ACTIONS(6590),
    [anon_sym_BSLASHusepackage] = ACTIONS(6590),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6590),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6590),
    [anon_sym_BSLASHinclude] = ACTIONS(6590),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6590),
    [anon_sym_BSLASHinput] = ACTIONS(6590),
    [anon_sym_BSLASHsubfile] = ACTIONS(6590),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6590),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6590),
    [anon_sym_BSLASHbibliography] = ACTIONS(6590),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6590),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6590),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6590),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6590),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6590),
    [anon_sym_BSLASHimport] = ACTIONS(6590),
    [anon_sym_BSLASHsubimport] = ACTIONS(6590),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6590),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHcaption] = ACTIONS(6590),
    [anon_sym_BSLASHcite] = ACTIONS(6590),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCite] = ACTIONS(6590),
    [anon_sym_BSLASHnocite] = ACTIONS(6590),
    [anon_sym_BSLASHcitet] = ACTIONS(6590),
    [anon_sym_BSLASHcitep] = ACTIONS(6590),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteA] = ACTIONS(6590),
    [anon_sym_BSLASHciteR] = ACTIONS(6590),
    [anon_sym_BSLASHciteS] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6590),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteyear] = ACTIONS(6590),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitedate] = ACTIONS(6590),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteurl] = ACTIONS(6590),
    [anon_sym_BSLASHfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6590),
    [anon_sym_BSLASHcitealt] = ACTIONS(6590),
    [anon_sym_BSLASHcitealp] = ACTIONS(6590),
    [anon_sym_BSLASHcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHparencite] = ACTIONS(6590),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHParencite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHtextcite] = ACTIONS(6590),
    [anon_sym_BSLASHTextcite] = ACTIONS(6590),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHsupercite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite] = ACTIONS(6590),
    [anon_sym_BSLASHAutocite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHVolcite] = ACTIONS(6590),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHavolcite] = ACTIONS(6590),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHNotecite] = ACTIONS(6590),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHlabel] = ACTIONS(6590),
    [anon_sym_BSLASHref] = ACTIONS(6590),
    [anon_sym_BSLASHeqref] = ACTIONS(6590),
    [anon_sym_BSLASHvref] = ACTIONS(6590),
    [anon_sym_BSLASHVref] = ACTIONS(6590),
    [anon_sym_BSLASHautoref] = ACTIONS(6590),
    [anon_sym_BSLASHpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcref] = ACTIONS(6590),
    [anon_sym_BSLASHCref] = ACTIONS(6590),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnameCref] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHdef] = ACTIONS(6590),
    [anon_sym_BSLASHlet] = ACTIONS(6590),
    [anon_sym_BSLASHleft] = ACTIONS(6590),
    [anon_sym_BSLASHbigl] = ACTIONS(6590),
    [anon_sym_BSLASHBigl] = ACTIONS(6590),
    [anon_sym_BSLASHbiggl] = ACTIONS(6590),
    [anon_sym_BSLASHBiggl] = ACTIONS(6590),
    [anon_sym_BSLASHright] = ACTIONS(6590),
    [anon_sym_BSLASHbigr] = ACTIONS(6590),
    [anon_sym_BSLASHBigr] = ACTIONS(6590),
    [anon_sym_BSLASHbiggr] = ACTIONS(6590),
    [anon_sym_BSLASHBiggr] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6590),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6590),
    [anon_sym_BSLASHgls] = ACTIONS(6590),
    [anon_sym_BSLASHGls] = ACTIONS(6590),
    [anon_sym_BSLASHGLS] = ACTIONS(6590),
    [anon_sym_BSLASHglspl] = ACTIONS(6590),
    [anon_sym_BSLASHGlspl] = ACTIONS(6590),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6590),
    [anon_sym_BSLASHglslink] = ACTIONS(6590),
    [anon_sym_BSLASHglstext] = ACTIONS(6590),
    [anon_sym_BSLASHGlstext] = ACTIONS(6590),
    [anon_sym_BSLASHGLStext] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6590),
    [anon_sym_BSLASHglsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsname] = ACTIONS(6590),
    [anon_sym_BSLASHGlsname] = ACTIONS(6590),
    [anon_sym_BSLASHGLSname] = ACTIONS(6590),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6590),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6590),
    [anon_sym_BSLASHacrshort] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6590),
    [anon_sym_BSLASHACRshort] = ACTIONS(6590),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrlong] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6590),
    [anon_sym_BSLASHACRlong] = ACTIONS(6590),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrfull] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6590),
    [anon_sym_BSLASHACRfull] = ACTIONS(6590),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHacs] = ACTIONS(6590),
    [anon_sym_BSLASHAcs] = ACTIONS(6590),
    [anon_sym_BSLASHacsp] = ACTIONS(6590),
    [anon_sym_BSLASHAcsp] = ACTIONS(6590),
    [anon_sym_BSLASHacl] = ACTIONS(6590),
    [anon_sym_BSLASHAcl] = ACTIONS(6590),
    [anon_sym_BSLASHaclp] = ACTIONS(6590),
    [anon_sym_BSLASHAclp] = ACTIONS(6590),
    [anon_sym_BSLASHacf] = ACTIONS(6590),
    [anon_sym_BSLASHAcf] = ACTIONS(6590),
    [anon_sym_BSLASHacfp] = ACTIONS(6590),
    [anon_sym_BSLASHAcfp] = ACTIONS(6590),
    [anon_sym_BSLASHac] = ACTIONS(6590),
    [anon_sym_BSLASHAc] = ACTIONS(6590),
    [anon_sym_BSLASHacp] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6590),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6590),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6590),
    [anon_sym_BSLASHcolor] = ACTIONS(6590),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6590),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6590),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6590),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6590),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6590),
    [anon_sym_BSLASHtext] = ACTIONS(6590),
    [anon_sym_BSLASHintertext] = ACTIONS(6590),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6590),
    [anon_sym_BSLASHurl] = ACTIONS(6590),
    [anon_sym_BSLASHhref] = ACTIONS(6590),
  },
  [603] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(6095),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [anon_sym_RBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [604] = {
    [sym_command_name] = ACTIONS(6594),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6596),
    [anon_sym_LPAREN] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHpart] = ACTIONS(6594),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddpart] = ACTIONS(6594),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHchapter] = ACTIONS(6594),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddchap] = ACTIONS(6594),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsection] = ACTIONS(6594),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddsec] = ACTIONS(6594),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHitem] = ACTIONS(6594),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6596),
    [anon_sym_LBRACE] = ACTIONS(6596),
    [sym_word] = ACTIONS(6594),
    [sym_placeholder] = ACTIONS(6596),
    [anon_sym_PLUS] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6596),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_SLASH] = ACTIONS(6596),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_BANG] = ACTIONS(6594),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SQUOTE] = ACTIONS(6594),
    [anon_sym__] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(6596),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6596),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(6594),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHbegin] = ACTIONS(6594),
    [anon_sym_BSLASHtitle] = ACTIONS(6594),
    [anon_sym_BSLASHauthor] = ACTIONS(6594),
    [anon_sym_BSLASHusepackage] = ACTIONS(6594),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6594),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6594),
    [anon_sym_BSLASHinclude] = ACTIONS(6594),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6594),
    [anon_sym_BSLASHinput] = ACTIONS(6594),
    [anon_sym_BSLASHsubfile] = ACTIONS(6594),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6594),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6594),
    [anon_sym_BSLASHbibliography] = ACTIONS(6594),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6594),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6594),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6594),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6594),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6594),
    [anon_sym_BSLASHimport] = ACTIONS(6594),
    [anon_sym_BSLASHsubimport] = ACTIONS(6594),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6594),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHcaption] = ACTIONS(6594),
    [anon_sym_BSLASHcite] = ACTIONS(6594),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCite] = ACTIONS(6594),
    [anon_sym_BSLASHnocite] = ACTIONS(6594),
    [anon_sym_BSLASHcitet] = ACTIONS(6594),
    [anon_sym_BSLASHcitep] = ACTIONS(6594),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteA] = ACTIONS(6594),
    [anon_sym_BSLASHciteR] = ACTIONS(6594),
    [anon_sym_BSLASHciteS] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6594),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteyear] = ACTIONS(6594),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitedate] = ACTIONS(6594),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteurl] = ACTIONS(6594),
    [anon_sym_BSLASHfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6594),
    [anon_sym_BSLASHcitealt] = ACTIONS(6594),
    [anon_sym_BSLASHcitealp] = ACTIONS(6594),
    [anon_sym_BSLASHcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHparencite] = ACTIONS(6594),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHParencite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHtextcite] = ACTIONS(6594),
    [anon_sym_BSLASHTextcite] = ACTIONS(6594),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHsupercite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite] = ACTIONS(6594),
    [anon_sym_BSLASHAutocite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHVolcite] = ACTIONS(6594),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHavolcite] = ACTIONS(6594),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHNotecite] = ACTIONS(6594),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHlabel] = ACTIONS(6594),
    [anon_sym_BSLASHref] = ACTIONS(6594),
    [anon_sym_BSLASHeqref] = ACTIONS(6594),
    [anon_sym_BSLASHvref] = ACTIONS(6594),
    [anon_sym_BSLASHVref] = ACTIONS(6594),
    [anon_sym_BSLASHautoref] = ACTIONS(6594),
    [anon_sym_BSLASHpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcref] = ACTIONS(6594),
    [anon_sym_BSLASHCref] = ACTIONS(6594),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnameCref] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHdef] = ACTIONS(6594),
    [anon_sym_BSLASHlet] = ACTIONS(6594),
    [anon_sym_BSLASHleft] = ACTIONS(6594),
    [anon_sym_BSLASHbigl] = ACTIONS(6594),
    [anon_sym_BSLASHBigl] = ACTIONS(6594),
    [anon_sym_BSLASHbiggl] = ACTIONS(6594),
    [anon_sym_BSLASHBiggl] = ACTIONS(6594),
    [anon_sym_BSLASHright] = ACTIONS(6594),
    [anon_sym_BSLASHbigr] = ACTIONS(6594),
    [anon_sym_BSLASHBigr] = ACTIONS(6594),
    [anon_sym_BSLASHbiggr] = ACTIONS(6594),
    [anon_sym_BSLASHBiggr] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6594),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6594),
    [anon_sym_BSLASHgls] = ACTIONS(6594),
    [anon_sym_BSLASHGls] = ACTIONS(6594),
    [anon_sym_BSLASHGLS] = ACTIONS(6594),
    [anon_sym_BSLASHglspl] = ACTIONS(6594),
    [anon_sym_BSLASHGlspl] = ACTIONS(6594),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6594),
    [anon_sym_BSLASHglslink] = ACTIONS(6594),
    [anon_sym_BSLASHglstext] = ACTIONS(6594),
    [anon_sym_BSLASHGlstext] = ACTIONS(6594),
    [anon_sym_BSLASHGLStext] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6594),
    [anon_sym_BSLASHglsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsname] = ACTIONS(6594),
    [anon_sym_BSLASHGlsname] = ACTIONS(6594),
    [anon_sym_BSLASHGLSname] = ACTIONS(6594),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6594),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6594),
    [anon_sym_BSLASHacrshort] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6594),
    [anon_sym_BSLASHACRshort] = ACTIONS(6594),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrlong] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6594),
    [anon_sym_BSLASHACRlong] = ACTIONS(6594),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrfull] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6594),
    [anon_sym_BSLASHACRfull] = ACTIONS(6594),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHacs] = ACTIONS(6594),
    [anon_sym_BSLASHAcs] = ACTIONS(6594),
    [anon_sym_BSLASHacsp] = ACTIONS(6594),
    [anon_sym_BSLASHAcsp] = ACTIONS(6594),
    [anon_sym_BSLASHacl] = ACTIONS(6594),
    [anon_sym_BSLASHAcl] = ACTIONS(6594),
    [anon_sym_BSLASHaclp] = ACTIONS(6594),
    [anon_sym_BSLASHAclp] = ACTIONS(6594),
    [anon_sym_BSLASHacf] = ACTIONS(6594),
    [anon_sym_BSLASHAcf] = ACTIONS(6594),
    [anon_sym_BSLASHacfp] = ACTIONS(6594),
    [anon_sym_BSLASHAcfp] = ACTIONS(6594),
    [anon_sym_BSLASHac] = ACTIONS(6594),
    [anon_sym_BSLASHAc] = ACTIONS(6594),
    [anon_sym_BSLASHacp] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6594),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6594),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6594),
    [anon_sym_BSLASHcolor] = ACTIONS(6594),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6594),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6594),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6594),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6594),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6594),
    [anon_sym_BSLASHtext] = ACTIONS(6594),
    [anon_sym_BSLASHintertext] = ACTIONS(6594),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6594),
    [anon_sym_BSLASHurl] = ACTIONS(6594),
    [anon_sym_BSLASHhref] = ACTIONS(6594),
  },
  [605] = {
    [sym_command_name] = ACTIONS(6598),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6598),
    [anon_sym_LBRACK] = ACTIONS(6600),
    [anon_sym_RBRACK] = ACTIONS(6600),
    [anon_sym_COMMA] = ACTIONS(6600),
    [anon_sym_EQ] = ACTIONS(6600),
    [anon_sym_LPAREN] = ACTIONS(6600),
    [anon_sym_RPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHpart] = ACTIONS(6598),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddpart] = ACTIONS(6598),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHchapter] = ACTIONS(6598),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddchap] = ACTIONS(6598),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsection] = ACTIONS(6598),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddsec] = ACTIONS(6598),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHitem] = ACTIONS(6598),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6600),
    [anon_sym_LBRACE] = ACTIONS(6600),
    [sym_word] = ACTIONS(6598),
    [sym_placeholder] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6600),
    [anon_sym_DASH] = ACTIONS(6600),
    [anon_sym_STAR] = ACTIONS(6600),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_BANG] = ACTIONS(6598),
    [anon_sym_PIPE] = ACTIONS(6598),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_SQUOTE] = ACTIONS(6598),
    [anon_sym__] = ACTIONS(6600),
    [anon_sym_CARET] = ACTIONS(6600),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6600),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6600),
    [anon_sym_DOLLAR] = ACTIONS(6598),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHbegin] = ACTIONS(6598),
    [anon_sym_BSLASHtitle] = ACTIONS(6598),
    [anon_sym_BSLASHauthor] = ACTIONS(6598),
    [anon_sym_BSLASHusepackage] = ACTIONS(6598),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6598),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6598),
    [anon_sym_BSLASHinclude] = ACTIONS(6598),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6598),
    [anon_sym_BSLASHinput] = ACTIONS(6598),
    [anon_sym_BSLASHsubfile] = ACTIONS(6598),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6598),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6598),
    [anon_sym_BSLASHbibliography] = ACTIONS(6598),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6598),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6598),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6598),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6598),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6598),
    [anon_sym_BSLASHimport] = ACTIONS(6598),
    [anon_sym_BSLASHsubimport] = ACTIONS(6598),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6598),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHcaption] = ACTIONS(6598),
    [anon_sym_BSLASHcite] = ACTIONS(6598),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCite] = ACTIONS(6598),
    [anon_sym_BSLASHnocite] = ACTIONS(6598),
    [anon_sym_BSLASHcitet] = ACTIONS(6598),
    [anon_sym_BSLASHcitep] = ACTIONS(6598),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteA] = ACTIONS(6598),
    [anon_sym_BSLASHciteR] = ACTIONS(6598),
    [anon_sym_BSLASHciteS] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6598),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteyear] = ACTIONS(6598),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitedate] = ACTIONS(6598),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteurl] = ACTIONS(6598),
    [anon_sym_BSLASHfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6598),
    [anon_sym_BSLASHcitealt] = ACTIONS(6598),
    [anon_sym_BSLASHcitealp] = ACTIONS(6598),
    [anon_sym_BSLASHcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHparencite] = ACTIONS(6598),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHParencite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHtextcite] = ACTIONS(6598),
    [anon_sym_BSLASHTextcite] = ACTIONS(6598),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHsupercite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite] = ACTIONS(6598),
    [anon_sym_BSLASHAutocite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHVolcite] = ACTIONS(6598),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHavolcite] = ACTIONS(6598),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHNotecite] = ACTIONS(6598),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHlabel] = ACTIONS(6598),
    [anon_sym_BSLASHref] = ACTIONS(6598),
    [anon_sym_BSLASHeqref] = ACTIONS(6598),
    [anon_sym_BSLASHvref] = ACTIONS(6598),
    [anon_sym_BSLASHVref] = ACTIONS(6598),
    [anon_sym_BSLASHautoref] = ACTIONS(6598),
    [anon_sym_BSLASHpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcref] = ACTIONS(6598),
    [anon_sym_BSLASHCref] = ACTIONS(6598),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnameCref] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHdef] = ACTIONS(6598),
    [anon_sym_BSLASHlet] = ACTIONS(6598),
    [anon_sym_BSLASHleft] = ACTIONS(6598),
    [anon_sym_BSLASHbigl] = ACTIONS(6598),
    [anon_sym_BSLASHBigl] = ACTIONS(6598),
    [anon_sym_BSLASHbiggl] = ACTIONS(6598),
    [anon_sym_BSLASHBiggl] = ACTIONS(6598),
    [anon_sym_BSLASHright] = ACTIONS(6598),
    [anon_sym_BSLASHbigr] = ACTIONS(6598),
    [anon_sym_BSLASHBigr] = ACTIONS(6598),
    [anon_sym_BSLASHbiggr] = ACTIONS(6598),
    [anon_sym_BSLASHBiggr] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6598),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6598),
    [anon_sym_BSLASHgls] = ACTIONS(6598),
    [anon_sym_BSLASHGls] = ACTIONS(6598),
    [anon_sym_BSLASHGLS] = ACTIONS(6598),
    [anon_sym_BSLASHglspl] = ACTIONS(6598),
    [anon_sym_BSLASHGlspl] = ACTIONS(6598),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6598),
    [anon_sym_BSLASHglslink] = ACTIONS(6598),
    [anon_sym_BSLASHglstext] = ACTIONS(6598),
    [anon_sym_BSLASHGlstext] = ACTIONS(6598),
    [anon_sym_BSLASHGLStext] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6598),
    [anon_sym_BSLASHglsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsname] = ACTIONS(6598),
    [anon_sym_BSLASHGlsname] = ACTIONS(6598),
    [anon_sym_BSLASHGLSname] = ACTIONS(6598),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6598),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6598),
    [anon_sym_BSLASHacrshort] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6598),
    [anon_sym_BSLASHACRshort] = ACTIONS(6598),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrlong] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6598),
    [anon_sym_BSLASHACRlong] = ACTIONS(6598),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrfull] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6598),
    [anon_sym_BSLASHACRfull] = ACTIONS(6598),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHacs] = ACTIONS(6598),
    [anon_sym_BSLASHAcs] = ACTIONS(6598),
    [anon_sym_BSLASHacsp] = ACTIONS(6598),
    [anon_sym_BSLASHAcsp] = ACTIONS(6598),
    [anon_sym_BSLASHacl] = ACTIONS(6598),
    [anon_sym_BSLASHAcl] = ACTIONS(6598),
    [anon_sym_BSLASHaclp] = ACTIONS(6598),
    [anon_sym_BSLASHAclp] = ACTIONS(6598),
    [anon_sym_BSLASHacf] = ACTIONS(6598),
    [anon_sym_BSLASHAcf] = ACTIONS(6598),
    [anon_sym_BSLASHacfp] = ACTIONS(6598),
    [anon_sym_BSLASHAcfp] = ACTIONS(6598),
    [anon_sym_BSLASHac] = ACTIONS(6598),
    [anon_sym_BSLASHAc] = ACTIONS(6598),
    [anon_sym_BSLASHacp] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6598),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6598),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6598),
    [anon_sym_BSLASHcolor] = ACTIONS(6598),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6598),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6598),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6598),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6598),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6598),
    [anon_sym_BSLASHtext] = ACTIONS(6598),
    [anon_sym_BSLASHintertext] = ACTIONS(6598),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6598),
    [anon_sym_BSLASHurl] = ACTIONS(6598),
    [anon_sym_BSLASHhref] = ACTIONS(6598),
  },
  [606] = {
    [sym_command_name] = ACTIONS(6602),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6602),
    [anon_sym_LBRACK] = ACTIONS(6604),
    [anon_sym_RBRACK] = ACTIONS(6604),
    [anon_sym_COMMA] = ACTIONS(6604),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(6604),
    [anon_sym_RPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHpart] = ACTIONS(6602),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddpart] = ACTIONS(6602),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHchapter] = ACTIONS(6602),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddchap] = ACTIONS(6602),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsection] = ACTIONS(6602),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddsec] = ACTIONS(6602),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHitem] = ACTIONS(6602),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6604),
    [anon_sym_LBRACE] = ACTIONS(6604),
    [sym_word] = ACTIONS(6602),
    [sym_placeholder] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6602),
    [anon_sym_GT] = ACTIONS(6602),
    [anon_sym_BANG] = ACTIONS(6602),
    [anon_sym_PIPE] = ACTIONS(6602),
    [anon_sym_COLON] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(6602),
    [anon_sym__] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6604),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6604),
    [anon_sym_DOLLAR] = ACTIONS(6602),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHbegin] = ACTIONS(6602),
    [anon_sym_BSLASHtitle] = ACTIONS(6602),
    [anon_sym_BSLASHauthor] = ACTIONS(6602),
    [anon_sym_BSLASHusepackage] = ACTIONS(6602),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6602),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6602),
    [anon_sym_BSLASHinclude] = ACTIONS(6602),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6602),
    [anon_sym_BSLASHinput] = ACTIONS(6602),
    [anon_sym_BSLASHsubfile] = ACTIONS(6602),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6602),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6602),
    [anon_sym_BSLASHbibliography] = ACTIONS(6602),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6602),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6602),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6602),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6602),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6602),
    [anon_sym_BSLASHimport] = ACTIONS(6602),
    [anon_sym_BSLASHsubimport] = ACTIONS(6602),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6602),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHcaption] = ACTIONS(6602),
    [anon_sym_BSLASHcite] = ACTIONS(6602),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCite] = ACTIONS(6602),
    [anon_sym_BSLASHnocite] = ACTIONS(6602),
    [anon_sym_BSLASHcitet] = ACTIONS(6602),
    [anon_sym_BSLASHcitep] = ACTIONS(6602),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteA] = ACTIONS(6602),
    [anon_sym_BSLASHciteR] = ACTIONS(6602),
    [anon_sym_BSLASHciteS] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6602),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteyear] = ACTIONS(6602),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitedate] = ACTIONS(6602),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteurl] = ACTIONS(6602),
    [anon_sym_BSLASHfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6602),
    [anon_sym_BSLASHcitealt] = ACTIONS(6602),
    [anon_sym_BSLASHcitealp] = ACTIONS(6602),
    [anon_sym_BSLASHcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHparencite] = ACTIONS(6602),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHParencite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHtextcite] = ACTIONS(6602),
    [anon_sym_BSLASHTextcite] = ACTIONS(6602),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHsupercite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite] = ACTIONS(6602),
    [anon_sym_BSLASHAutocite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHVolcite] = ACTIONS(6602),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHavolcite] = ACTIONS(6602),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHNotecite] = ACTIONS(6602),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHlabel] = ACTIONS(6602),
    [anon_sym_BSLASHref] = ACTIONS(6602),
    [anon_sym_BSLASHeqref] = ACTIONS(6602),
    [anon_sym_BSLASHvref] = ACTIONS(6602),
    [anon_sym_BSLASHVref] = ACTIONS(6602),
    [anon_sym_BSLASHautoref] = ACTIONS(6602),
    [anon_sym_BSLASHpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcref] = ACTIONS(6602),
    [anon_sym_BSLASHCref] = ACTIONS(6602),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnameCref] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHdef] = ACTIONS(6602),
    [anon_sym_BSLASHlet] = ACTIONS(6602),
    [anon_sym_BSLASHleft] = ACTIONS(6602),
    [anon_sym_BSLASHbigl] = ACTIONS(6602),
    [anon_sym_BSLASHBigl] = ACTIONS(6602),
    [anon_sym_BSLASHbiggl] = ACTIONS(6602),
    [anon_sym_BSLASHBiggl] = ACTIONS(6602),
    [anon_sym_BSLASHright] = ACTIONS(6602),
    [anon_sym_BSLASHbigr] = ACTIONS(6602),
    [anon_sym_BSLASHBigr] = ACTIONS(6602),
    [anon_sym_BSLASHbiggr] = ACTIONS(6602),
    [anon_sym_BSLASHBiggr] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6602),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6602),
    [anon_sym_BSLASHgls] = ACTIONS(6602),
    [anon_sym_BSLASHGls] = ACTIONS(6602),
    [anon_sym_BSLASHGLS] = ACTIONS(6602),
    [anon_sym_BSLASHglspl] = ACTIONS(6602),
    [anon_sym_BSLASHGlspl] = ACTIONS(6602),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6602),
    [anon_sym_BSLASHglslink] = ACTIONS(6602),
    [anon_sym_BSLASHglstext] = ACTIONS(6602),
    [anon_sym_BSLASHGlstext] = ACTIONS(6602),
    [anon_sym_BSLASHGLStext] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6602),
    [anon_sym_BSLASHglsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsname] = ACTIONS(6602),
    [anon_sym_BSLASHGlsname] = ACTIONS(6602),
    [anon_sym_BSLASHGLSname] = ACTIONS(6602),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6602),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6602),
    [anon_sym_BSLASHacrshort] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6602),
    [anon_sym_BSLASHACRshort] = ACTIONS(6602),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrlong] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6602),
    [anon_sym_BSLASHACRlong] = ACTIONS(6602),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrfull] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6602),
    [anon_sym_BSLASHACRfull] = ACTIONS(6602),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHacs] = ACTIONS(6602),
    [anon_sym_BSLASHAcs] = ACTIONS(6602),
    [anon_sym_BSLASHacsp] = ACTIONS(6602),
    [anon_sym_BSLASHAcsp] = ACTIONS(6602),
    [anon_sym_BSLASHacl] = ACTIONS(6602),
    [anon_sym_BSLASHAcl] = ACTIONS(6602),
    [anon_sym_BSLASHaclp] = ACTIONS(6602),
    [anon_sym_BSLASHAclp] = ACTIONS(6602),
    [anon_sym_BSLASHacf] = ACTIONS(6602),
    [anon_sym_BSLASHAcf] = ACTIONS(6602),
    [anon_sym_BSLASHacfp] = ACTIONS(6602),
    [anon_sym_BSLASHAcfp] = ACTIONS(6602),
    [anon_sym_BSLASHac] = ACTIONS(6602),
    [anon_sym_BSLASHAc] = ACTIONS(6602),
    [anon_sym_BSLASHacp] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6602),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6602),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6602),
    [anon_sym_BSLASHcolor] = ACTIONS(6602),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6602),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6602),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6602),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6602),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6602),
    [anon_sym_BSLASHtext] = ACTIONS(6602),
    [anon_sym_BSLASHintertext] = ACTIONS(6602),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6602),
    [anon_sym_BSLASHurl] = ACTIONS(6602),
    [anon_sym_BSLASHhref] = ACTIONS(6602),
  },
  [607] = {
    [sym_command_name] = ACTIONS(6606),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6606),
    [anon_sym_LBRACK] = ACTIONS(6608),
    [anon_sym_RBRACK] = ACTIONS(6608),
    [anon_sym_COMMA] = ACTIONS(6608),
    [anon_sym_EQ] = ACTIONS(6608),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_RPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHpart] = ACTIONS(6606),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddpart] = ACTIONS(6606),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHchapter] = ACTIONS(6606),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddchap] = ACTIONS(6606),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsection] = ACTIONS(6606),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddsec] = ACTIONS(6606),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHitem] = ACTIONS(6606),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6608),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [sym_word] = ACTIONS(6606),
    [sym_placeholder] = ACTIONS(6608),
    [anon_sym_PLUS] = ACTIONS(6608),
    [anon_sym_DASH] = ACTIONS(6608),
    [anon_sym_STAR] = ACTIONS(6608),
    [anon_sym_SLASH] = ACTIONS(6608),
    [anon_sym_LT] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6606),
    [anon_sym_BANG] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6606),
    [anon_sym_COLON] = ACTIONS(6606),
    [anon_sym_SQUOTE] = ACTIONS(6606),
    [anon_sym__] = ACTIONS(6608),
    [anon_sym_CARET] = ACTIONS(6608),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6608),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(6606),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHbegin] = ACTIONS(6606),
    [anon_sym_BSLASHtitle] = ACTIONS(6606),
    [anon_sym_BSLASHauthor] = ACTIONS(6606),
    [anon_sym_BSLASHusepackage] = ACTIONS(6606),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6606),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6606),
    [anon_sym_BSLASHinclude] = ACTIONS(6606),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6606),
    [anon_sym_BSLASHinput] = ACTIONS(6606),
    [anon_sym_BSLASHsubfile] = ACTIONS(6606),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6606),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6606),
    [anon_sym_BSLASHbibliography] = ACTIONS(6606),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6606),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6606),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6606),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6606),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6606),
    [anon_sym_BSLASHimport] = ACTIONS(6606),
    [anon_sym_BSLASHsubimport] = ACTIONS(6606),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6606),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHcaption] = ACTIONS(6606),
    [anon_sym_BSLASHcite] = ACTIONS(6606),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCite] = ACTIONS(6606),
    [anon_sym_BSLASHnocite] = ACTIONS(6606),
    [anon_sym_BSLASHcitet] = ACTIONS(6606),
    [anon_sym_BSLASHcitep] = ACTIONS(6606),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteA] = ACTIONS(6606),
    [anon_sym_BSLASHciteR] = ACTIONS(6606),
    [anon_sym_BSLASHciteS] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6606),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteyear] = ACTIONS(6606),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitedate] = ACTIONS(6606),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteurl] = ACTIONS(6606),
    [anon_sym_BSLASHfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6606),
    [anon_sym_BSLASHcitealt] = ACTIONS(6606),
    [anon_sym_BSLASHcitealp] = ACTIONS(6606),
    [anon_sym_BSLASHcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHparencite] = ACTIONS(6606),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHParencite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHtextcite] = ACTIONS(6606),
    [anon_sym_BSLASHTextcite] = ACTIONS(6606),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHsupercite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite] = ACTIONS(6606),
    [anon_sym_BSLASHAutocite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHVolcite] = ACTIONS(6606),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHavolcite] = ACTIONS(6606),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHNotecite] = ACTIONS(6606),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHlabel] = ACTIONS(6606),
    [anon_sym_BSLASHref] = ACTIONS(6606),
    [anon_sym_BSLASHeqref] = ACTIONS(6606),
    [anon_sym_BSLASHvref] = ACTIONS(6606),
    [anon_sym_BSLASHVref] = ACTIONS(6606),
    [anon_sym_BSLASHautoref] = ACTIONS(6606),
    [anon_sym_BSLASHpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcref] = ACTIONS(6606),
    [anon_sym_BSLASHCref] = ACTIONS(6606),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnameCref] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHdef] = ACTIONS(6606),
    [anon_sym_BSLASHlet] = ACTIONS(6606),
    [anon_sym_BSLASHleft] = ACTIONS(6606),
    [anon_sym_BSLASHbigl] = ACTIONS(6606),
    [anon_sym_BSLASHBigl] = ACTIONS(6606),
    [anon_sym_BSLASHbiggl] = ACTIONS(6606),
    [anon_sym_BSLASHBiggl] = ACTIONS(6606),
    [anon_sym_BSLASHright] = ACTIONS(6606),
    [anon_sym_BSLASHbigr] = ACTIONS(6606),
    [anon_sym_BSLASHBigr] = ACTIONS(6606),
    [anon_sym_BSLASHbiggr] = ACTIONS(6606),
    [anon_sym_BSLASHBiggr] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6606),
    [anon_sym_BSLASHgls] = ACTIONS(6606),
    [anon_sym_BSLASHGls] = ACTIONS(6606),
    [anon_sym_BSLASHGLS] = ACTIONS(6606),
    [anon_sym_BSLASHglspl] = ACTIONS(6606),
    [anon_sym_BSLASHGlspl] = ACTIONS(6606),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6606),
    [anon_sym_BSLASHglslink] = ACTIONS(6606),
    [anon_sym_BSLASHglstext] = ACTIONS(6606),
    [anon_sym_BSLASHGlstext] = ACTIONS(6606),
    [anon_sym_BSLASHGLStext] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6606),
    [anon_sym_BSLASHglsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsname] = ACTIONS(6606),
    [anon_sym_BSLASHGlsname] = ACTIONS(6606),
    [anon_sym_BSLASHGLSname] = ACTIONS(6606),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6606),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6606),
    [anon_sym_BSLASHacrshort] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6606),
    [anon_sym_BSLASHACRshort] = ACTIONS(6606),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrlong] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6606),
    [anon_sym_BSLASHACRlong] = ACTIONS(6606),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrfull] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6606),
    [anon_sym_BSLASHACRfull] = ACTIONS(6606),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHacs] = ACTIONS(6606),
    [anon_sym_BSLASHAcs] = ACTIONS(6606),
    [anon_sym_BSLASHacsp] = ACTIONS(6606),
    [anon_sym_BSLASHAcsp] = ACTIONS(6606),
    [anon_sym_BSLASHacl] = ACTIONS(6606),
    [anon_sym_BSLASHAcl] = ACTIONS(6606),
    [anon_sym_BSLASHaclp] = ACTIONS(6606),
    [anon_sym_BSLASHAclp] = ACTIONS(6606),
    [anon_sym_BSLASHacf] = ACTIONS(6606),
    [anon_sym_BSLASHAcf] = ACTIONS(6606),
    [anon_sym_BSLASHacfp] = ACTIONS(6606),
    [anon_sym_BSLASHAcfp] = ACTIONS(6606),
    [anon_sym_BSLASHac] = ACTIONS(6606),
    [anon_sym_BSLASHAc] = ACTIONS(6606),
    [anon_sym_BSLASHacp] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6606),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6606),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6606),
    [anon_sym_BSLASHcolor] = ACTIONS(6606),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6606),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6606),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6606),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6606),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6606),
    [anon_sym_BSLASHtext] = ACTIONS(6606),
    [anon_sym_BSLASHintertext] = ACTIONS(6606),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6606),
    [anon_sym_BSLASHurl] = ACTIONS(6606),
    [anon_sym_BSLASHhref] = ACTIONS(6606),
  },
  [608] = {
    [sym_command_name] = ACTIONS(6610),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6610),
    [anon_sym_LBRACK] = ACTIONS(6612),
    [anon_sym_RBRACK] = ACTIONS(6612),
    [anon_sym_COMMA] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6612),
    [anon_sym_RPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHpart] = ACTIONS(6610),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddpart] = ACTIONS(6610),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHchapter] = ACTIONS(6610),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddchap] = ACTIONS(6610),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsection] = ACTIONS(6610),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddsec] = ACTIONS(6610),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHitem] = ACTIONS(6610),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6612),
    [anon_sym_LBRACE] = ACTIONS(6612),
    [sym_word] = ACTIONS(6610),
    [sym_placeholder] = ACTIONS(6612),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_DASH] = ACTIONS(6612),
    [anon_sym_STAR] = ACTIONS(6612),
    [anon_sym_SLASH] = ACTIONS(6612),
    [anon_sym_LT] = ACTIONS(6610),
    [anon_sym_GT] = ACTIONS(6610),
    [anon_sym_BANG] = ACTIONS(6610),
    [anon_sym_PIPE] = ACTIONS(6610),
    [anon_sym_COLON] = ACTIONS(6610),
    [anon_sym_SQUOTE] = ACTIONS(6610),
    [anon_sym__] = ACTIONS(6612),
    [anon_sym_CARET] = ACTIONS(6612),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6612),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6612),
    [anon_sym_DOLLAR] = ACTIONS(6610),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHbegin] = ACTIONS(6610),
    [anon_sym_BSLASHtitle] = ACTIONS(6610),
    [anon_sym_BSLASHauthor] = ACTIONS(6610),
    [anon_sym_BSLASHusepackage] = ACTIONS(6610),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6610),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6610),
    [anon_sym_BSLASHinclude] = ACTIONS(6610),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6610),
    [anon_sym_BSLASHinput] = ACTIONS(6610),
    [anon_sym_BSLASHsubfile] = ACTIONS(6610),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6610),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6610),
    [anon_sym_BSLASHbibliography] = ACTIONS(6610),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6610),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6610),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6610),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6610),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6610),
    [anon_sym_BSLASHimport] = ACTIONS(6610),
    [anon_sym_BSLASHsubimport] = ACTIONS(6610),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6610),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHcaption] = ACTIONS(6610),
    [anon_sym_BSLASHcite] = ACTIONS(6610),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCite] = ACTIONS(6610),
    [anon_sym_BSLASHnocite] = ACTIONS(6610),
    [anon_sym_BSLASHcitet] = ACTIONS(6610),
    [anon_sym_BSLASHcitep] = ACTIONS(6610),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteA] = ACTIONS(6610),
    [anon_sym_BSLASHciteR] = ACTIONS(6610),
    [anon_sym_BSLASHciteS] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6610),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteyear] = ACTIONS(6610),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitedate] = ACTIONS(6610),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteurl] = ACTIONS(6610),
    [anon_sym_BSLASHfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6610),
    [anon_sym_BSLASHcitealt] = ACTIONS(6610),
    [anon_sym_BSLASHcitealp] = ACTIONS(6610),
    [anon_sym_BSLASHcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHparencite] = ACTIONS(6610),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHParencite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHtextcite] = ACTIONS(6610),
    [anon_sym_BSLASHTextcite] = ACTIONS(6610),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHsupercite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite] = ACTIONS(6610),
    [anon_sym_BSLASHAutocite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHVolcite] = ACTIONS(6610),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHavolcite] = ACTIONS(6610),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHNotecite] = ACTIONS(6610),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHlabel] = ACTIONS(6610),
    [anon_sym_BSLASHref] = ACTIONS(6610),
    [anon_sym_BSLASHeqref] = ACTIONS(6610),
    [anon_sym_BSLASHvref] = ACTIONS(6610),
    [anon_sym_BSLASHVref] = ACTIONS(6610),
    [anon_sym_BSLASHautoref] = ACTIONS(6610),
    [anon_sym_BSLASHpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcref] = ACTIONS(6610),
    [anon_sym_BSLASHCref] = ACTIONS(6610),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnameCref] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHdef] = ACTIONS(6610),
    [anon_sym_BSLASHlet] = ACTIONS(6610),
    [anon_sym_BSLASHleft] = ACTIONS(6610),
    [anon_sym_BSLASHbigl] = ACTIONS(6610),
    [anon_sym_BSLASHBigl] = ACTIONS(6610),
    [anon_sym_BSLASHbiggl] = ACTIONS(6610),
    [anon_sym_BSLASHBiggl] = ACTIONS(6610),
    [anon_sym_BSLASHright] = ACTIONS(6610),
    [anon_sym_BSLASHbigr] = ACTIONS(6610),
    [anon_sym_BSLASHBigr] = ACTIONS(6610),
    [anon_sym_BSLASHbiggr] = ACTIONS(6610),
    [anon_sym_BSLASHBiggr] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6610),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6610),
    [anon_sym_BSLASHgls] = ACTIONS(6610),
    [anon_sym_BSLASHGls] = ACTIONS(6610),
    [anon_sym_BSLASHGLS] = ACTIONS(6610),
    [anon_sym_BSLASHglspl] = ACTIONS(6610),
    [anon_sym_BSLASHGlspl] = ACTIONS(6610),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6610),
    [anon_sym_BSLASHglslink] = ACTIONS(6610),
    [anon_sym_BSLASHglstext] = ACTIONS(6610),
    [anon_sym_BSLASHGlstext] = ACTIONS(6610),
    [anon_sym_BSLASHGLStext] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6610),
    [anon_sym_BSLASHglsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsname] = ACTIONS(6610),
    [anon_sym_BSLASHGlsname] = ACTIONS(6610),
    [anon_sym_BSLASHGLSname] = ACTIONS(6610),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6610),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6610),
    [anon_sym_BSLASHacrshort] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6610),
    [anon_sym_BSLASHACRshort] = ACTIONS(6610),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrlong] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6610),
    [anon_sym_BSLASHACRlong] = ACTIONS(6610),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrfull] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6610),
    [anon_sym_BSLASHACRfull] = ACTIONS(6610),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHacs] = ACTIONS(6610),
    [anon_sym_BSLASHAcs] = ACTIONS(6610),
    [anon_sym_BSLASHacsp] = ACTIONS(6610),
    [anon_sym_BSLASHAcsp] = ACTIONS(6610),
    [anon_sym_BSLASHacl] = ACTIONS(6610),
    [anon_sym_BSLASHAcl] = ACTIONS(6610),
    [anon_sym_BSLASHaclp] = ACTIONS(6610),
    [anon_sym_BSLASHAclp] = ACTIONS(6610),
    [anon_sym_BSLASHacf] = ACTIONS(6610),
    [anon_sym_BSLASHAcf] = ACTIONS(6610),
    [anon_sym_BSLASHacfp] = ACTIONS(6610),
    [anon_sym_BSLASHAcfp] = ACTIONS(6610),
    [anon_sym_BSLASHac] = ACTIONS(6610),
    [anon_sym_BSLASHAc] = ACTIONS(6610),
    [anon_sym_BSLASHacp] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6610),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6610),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6610),
    [anon_sym_BSLASHcolor] = ACTIONS(6610),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6610),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6610),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6610),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6610),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6610),
    [anon_sym_BSLASHtext] = ACTIONS(6610),
    [anon_sym_BSLASHintertext] = ACTIONS(6610),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6610),
    [anon_sym_BSLASHurl] = ACTIONS(6610),
    [anon_sym_BSLASHhref] = ACTIONS(6610),
  },
  [609] = {
    [sym_command_name] = ACTIONS(6614),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6614),
    [anon_sym_LBRACK] = ACTIONS(6616),
    [anon_sym_RBRACK] = ACTIONS(6616),
    [anon_sym_COMMA] = ACTIONS(6616),
    [anon_sym_EQ] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6616),
    [anon_sym_RPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHpart] = ACTIONS(6614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddpart] = ACTIONS(6614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHchapter] = ACTIONS(6614),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddchap] = ACTIONS(6614),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsection] = ACTIONS(6614),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddsec] = ACTIONS(6614),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHitem] = ACTIONS(6614),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(6616),
    [sym_word] = ACTIONS(6614),
    [sym_placeholder] = ACTIONS(6616),
    [anon_sym_PLUS] = ACTIONS(6616),
    [anon_sym_DASH] = ACTIONS(6616),
    [anon_sym_STAR] = ACTIONS(6616),
    [anon_sym_SLASH] = ACTIONS(6616),
    [anon_sym_LT] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6614),
    [anon_sym_BANG] = ACTIONS(6614),
    [anon_sym_PIPE] = ACTIONS(6614),
    [anon_sym_COLON] = ACTIONS(6614),
    [anon_sym_SQUOTE] = ACTIONS(6614),
    [anon_sym__] = ACTIONS(6616),
    [anon_sym_CARET] = ACTIONS(6616),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6616),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6616),
    [anon_sym_DOLLAR] = ACTIONS(6614),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHbegin] = ACTIONS(6614),
    [anon_sym_BSLASHtitle] = ACTIONS(6614),
    [anon_sym_BSLASHauthor] = ACTIONS(6614),
    [anon_sym_BSLASHusepackage] = ACTIONS(6614),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6614),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6614),
    [anon_sym_BSLASHinclude] = ACTIONS(6614),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6614),
    [anon_sym_BSLASHinput] = ACTIONS(6614),
    [anon_sym_BSLASHsubfile] = ACTIONS(6614),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6614),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6614),
    [anon_sym_BSLASHbibliography] = ACTIONS(6614),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6614),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6614),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6614),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6614),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6614),
    [anon_sym_BSLASHimport] = ACTIONS(6614),
    [anon_sym_BSLASHsubimport] = ACTIONS(6614),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6614),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHcaption] = ACTIONS(6614),
    [anon_sym_BSLASHcite] = ACTIONS(6614),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCite] = ACTIONS(6614),
    [anon_sym_BSLASHnocite] = ACTIONS(6614),
    [anon_sym_BSLASHcitet] = ACTIONS(6614),
    [anon_sym_BSLASHcitep] = ACTIONS(6614),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteA] = ACTIONS(6614),
    [anon_sym_BSLASHciteR] = ACTIONS(6614),
    [anon_sym_BSLASHciteS] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6614),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteyear] = ACTIONS(6614),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitedate] = ACTIONS(6614),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteurl] = ACTIONS(6614),
    [anon_sym_BSLASHfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6614),
    [anon_sym_BSLASHcitealt] = ACTIONS(6614),
    [anon_sym_BSLASHcitealp] = ACTIONS(6614),
    [anon_sym_BSLASHcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHparencite] = ACTIONS(6614),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHParencite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHtextcite] = ACTIONS(6614),
    [anon_sym_BSLASHTextcite] = ACTIONS(6614),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHsupercite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite] = ACTIONS(6614),
    [anon_sym_BSLASHAutocite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHVolcite] = ACTIONS(6614),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHavolcite] = ACTIONS(6614),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHNotecite] = ACTIONS(6614),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHlabel] = ACTIONS(6614),
    [anon_sym_BSLASHref] = ACTIONS(6614),
    [anon_sym_BSLASHeqref] = ACTIONS(6614),
    [anon_sym_BSLASHvref] = ACTIONS(6614),
    [anon_sym_BSLASHVref] = ACTIONS(6614),
    [anon_sym_BSLASHautoref] = ACTIONS(6614),
    [anon_sym_BSLASHpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcref] = ACTIONS(6614),
    [anon_sym_BSLASHCref] = ACTIONS(6614),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnameCref] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHdef] = ACTIONS(6614),
    [anon_sym_BSLASHlet] = ACTIONS(6614),
    [anon_sym_BSLASHleft] = ACTIONS(6614),
    [anon_sym_BSLASHbigl] = ACTIONS(6614),
    [anon_sym_BSLASHBigl] = ACTIONS(6614),
    [anon_sym_BSLASHbiggl] = ACTIONS(6614),
    [anon_sym_BSLASHBiggl] = ACTIONS(6614),
    [anon_sym_BSLASHright] = ACTIONS(6614),
    [anon_sym_BSLASHbigr] = ACTIONS(6614),
    [anon_sym_BSLASHBigr] = ACTIONS(6614),
    [anon_sym_BSLASHbiggr] = ACTIONS(6614),
    [anon_sym_BSLASHBiggr] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6614),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6614),
    [anon_sym_BSLASHgls] = ACTIONS(6614),
    [anon_sym_BSLASHGls] = ACTIONS(6614),
    [anon_sym_BSLASHGLS] = ACTIONS(6614),
    [anon_sym_BSLASHglspl] = ACTIONS(6614),
    [anon_sym_BSLASHGlspl] = ACTIONS(6614),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6614),
    [anon_sym_BSLASHglslink] = ACTIONS(6614),
    [anon_sym_BSLASHglstext] = ACTIONS(6614),
    [anon_sym_BSLASHGlstext] = ACTIONS(6614),
    [anon_sym_BSLASHGLStext] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6614),
    [anon_sym_BSLASHglsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsname] = ACTIONS(6614),
    [anon_sym_BSLASHGlsname] = ACTIONS(6614),
    [anon_sym_BSLASHGLSname] = ACTIONS(6614),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6614),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6614),
    [anon_sym_BSLASHacrshort] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6614),
    [anon_sym_BSLASHACRshort] = ACTIONS(6614),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrlong] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6614),
    [anon_sym_BSLASHACRlong] = ACTIONS(6614),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrfull] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6614),
    [anon_sym_BSLASHACRfull] = ACTIONS(6614),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHacs] = ACTIONS(6614),
    [anon_sym_BSLASHAcs] = ACTIONS(6614),
    [anon_sym_BSLASHacsp] = ACTIONS(6614),
    [anon_sym_BSLASHAcsp] = ACTIONS(6614),
    [anon_sym_BSLASHacl] = ACTIONS(6614),
    [anon_sym_BSLASHAcl] = ACTIONS(6614),
    [anon_sym_BSLASHaclp] = ACTIONS(6614),
    [anon_sym_BSLASHAclp] = ACTIONS(6614),
    [anon_sym_BSLASHacf] = ACTIONS(6614),
    [anon_sym_BSLASHAcf] = ACTIONS(6614),
    [anon_sym_BSLASHacfp] = ACTIONS(6614),
    [anon_sym_BSLASHAcfp] = ACTIONS(6614),
    [anon_sym_BSLASHac] = ACTIONS(6614),
    [anon_sym_BSLASHAc] = ACTIONS(6614),
    [anon_sym_BSLASHacp] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6614),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6614),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6614),
    [anon_sym_BSLASHcolor] = ACTIONS(6614),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6614),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6614),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6614),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6614),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6614),
    [anon_sym_BSLASHtext] = ACTIONS(6614),
    [anon_sym_BSLASHintertext] = ACTIONS(6614),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6614),
    [anon_sym_BSLASHurl] = ACTIONS(6614),
    [anon_sym_BSLASHhref] = ACTIONS(6614),
  },
  [610] = {
    [sym_command_name] = ACTIONS(6618),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(6620),
    [anon_sym_RBRACK] = ACTIONS(6620),
    [anon_sym_COMMA] = ACTIONS(6620),
    [anon_sym_EQ] = ACTIONS(6620),
    [anon_sym_LPAREN] = ACTIONS(6620),
    [anon_sym_RPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHpart] = ACTIONS(6618),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddpart] = ACTIONS(6618),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHchapter] = ACTIONS(6618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddchap] = ACTIONS(6618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsection] = ACTIONS(6618),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddsec] = ACTIONS(6618),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHitem] = ACTIONS(6618),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6620),
    [anon_sym_LBRACE] = ACTIONS(6620),
    [sym_word] = ACTIONS(6618),
    [sym_placeholder] = ACTIONS(6620),
    [anon_sym_PLUS] = ACTIONS(6620),
    [anon_sym_DASH] = ACTIONS(6620),
    [anon_sym_STAR] = ACTIONS(6620),
    [anon_sym_SLASH] = ACTIONS(6620),
    [anon_sym_LT] = ACTIONS(6618),
    [anon_sym_GT] = ACTIONS(6618),
    [anon_sym_BANG] = ACTIONS(6618),
    [anon_sym_PIPE] = ACTIONS(6618),
    [anon_sym_COLON] = ACTIONS(6618),
    [anon_sym_SQUOTE] = ACTIONS(6618),
    [anon_sym__] = ACTIONS(6620),
    [anon_sym_CARET] = ACTIONS(6620),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6620),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6620),
    [anon_sym_DOLLAR] = ACTIONS(6618),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHbegin] = ACTIONS(6618),
    [anon_sym_BSLASHtitle] = ACTIONS(6618),
    [anon_sym_BSLASHauthor] = ACTIONS(6618),
    [anon_sym_BSLASHusepackage] = ACTIONS(6618),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6618),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6618),
    [anon_sym_BSLASHinclude] = ACTIONS(6618),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6618),
    [anon_sym_BSLASHinput] = ACTIONS(6618),
    [anon_sym_BSLASHsubfile] = ACTIONS(6618),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6618),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6618),
    [anon_sym_BSLASHbibliography] = ACTIONS(6618),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6618),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6618),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6618),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6618),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6618),
    [anon_sym_BSLASHimport] = ACTIONS(6618),
    [anon_sym_BSLASHsubimport] = ACTIONS(6618),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6618),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHcaption] = ACTIONS(6618),
    [anon_sym_BSLASHcite] = ACTIONS(6618),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCite] = ACTIONS(6618),
    [anon_sym_BSLASHnocite] = ACTIONS(6618),
    [anon_sym_BSLASHcitet] = ACTIONS(6618),
    [anon_sym_BSLASHcitep] = ACTIONS(6618),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteA] = ACTIONS(6618),
    [anon_sym_BSLASHciteR] = ACTIONS(6618),
    [anon_sym_BSLASHciteS] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6618),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteyear] = ACTIONS(6618),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitedate] = ACTIONS(6618),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteurl] = ACTIONS(6618),
    [anon_sym_BSLASHfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6618),
    [anon_sym_BSLASHcitealt] = ACTIONS(6618),
    [anon_sym_BSLASHcitealp] = ACTIONS(6618),
    [anon_sym_BSLASHcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHparencite] = ACTIONS(6618),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHParencite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHtextcite] = ACTIONS(6618),
    [anon_sym_BSLASHTextcite] = ACTIONS(6618),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHsupercite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite] = ACTIONS(6618),
    [anon_sym_BSLASHAutocite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHVolcite] = ACTIONS(6618),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHavolcite] = ACTIONS(6618),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHNotecite] = ACTIONS(6618),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHlabel] = ACTIONS(6618),
    [anon_sym_BSLASHref] = ACTIONS(6618),
    [anon_sym_BSLASHeqref] = ACTIONS(6618),
    [anon_sym_BSLASHvref] = ACTIONS(6618),
    [anon_sym_BSLASHVref] = ACTIONS(6618),
    [anon_sym_BSLASHautoref] = ACTIONS(6618),
    [anon_sym_BSLASHpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcref] = ACTIONS(6618),
    [anon_sym_BSLASHCref] = ACTIONS(6618),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnameCref] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHdef] = ACTIONS(6618),
    [anon_sym_BSLASHlet] = ACTIONS(6618),
    [anon_sym_BSLASHleft] = ACTIONS(6618),
    [anon_sym_BSLASHbigl] = ACTIONS(6618),
    [anon_sym_BSLASHBigl] = ACTIONS(6618),
    [anon_sym_BSLASHbiggl] = ACTIONS(6618),
    [anon_sym_BSLASHBiggl] = ACTIONS(6618),
    [anon_sym_BSLASHright] = ACTIONS(6618),
    [anon_sym_BSLASHbigr] = ACTIONS(6618),
    [anon_sym_BSLASHBigr] = ACTIONS(6618),
    [anon_sym_BSLASHbiggr] = ACTIONS(6618),
    [anon_sym_BSLASHBiggr] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6618),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6618),
    [anon_sym_BSLASHgls] = ACTIONS(6618),
    [anon_sym_BSLASHGls] = ACTIONS(6618),
    [anon_sym_BSLASHGLS] = ACTIONS(6618),
    [anon_sym_BSLASHglspl] = ACTIONS(6618),
    [anon_sym_BSLASHGlspl] = ACTIONS(6618),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6618),
    [anon_sym_BSLASHglslink] = ACTIONS(6618),
    [anon_sym_BSLASHglstext] = ACTIONS(6618),
    [anon_sym_BSLASHGlstext] = ACTIONS(6618),
    [anon_sym_BSLASHGLStext] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6618),
    [anon_sym_BSLASHglsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsname] = ACTIONS(6618),
    [anon_sym_BSLASHGlsname] = ACTIONS(6618),
    [anon_sym_BSLASHGLSname] = ACTIONS(6618),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6618),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6618),
    [anon_sym_BSLASHacrshort] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6618),
    [anon_sym_BSLASHACRshort] = ACTIONS(6618),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrlong] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6618),
    [anon_sym_BSLASHACRlong] = ACTIONS(6618),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrfull] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6618),
    [anon_sym_BSLASHACRfull] = ACTIONS(6618),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHacs] = ACTIONS(6618),
    [anon_sym_BSLASHAcs] = ACTIONS(6618),
    [anon_sym_BSLASHacsp] = ACTIONS(6618),
    [anon_sym_BSLASHAcsp] = ACTIONS(6618),
    [anon_sym_BSLASHacl] = ACTIONS(6618),
    [anon_sym_BSLASHAcl] = ACTIONS(6618),
    [anon_sym_BSLASHaclp] = ACTIONS(6618),
    [anon_sym_BSLASHAclp] = ACTIONS(6618),
    [anon_sym_BSLASHacf] = ACTIONS(6618),
    [anon_sym_BSLASHAcf] = ACTIONS(6618),
    [anon_sym_BSLASHacfp] = ACTIONS(6618),
    [anon_sym_BSLASHAcfp] = ACTIONS(6618),
    [anon_sym_BSLASHac] = ACTIONS(6618),
    [anon_sym_BSLASHAc] = ACTIONS(6618),
    [anon_sym_BSLASHacp] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6618),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6618),
    [anon_sym_BSLASHcolor] = ACTIONS(6618),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6618),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6618),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6618),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6618),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6618),
    [anon_sym_BSLASHtext] = ACTIONS(6618),
    [anon_sym_BSLASHintertext] = ACTIONS(6618),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6618),
    [anon_sym_BSLASHurl] = ACTIONS(6618),
    [anon_sym_BSLASHhref] = ACTIONS(6618),
  },
  [611] = {
    [sym_command_name] = ACTIONS(6622),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6622),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_RBRACK] = ACTIONS(6624),
    [anon_sym_COMMA] = ACTIONS(6624),
    [anon_sym_EQ] = ACTIONS(6624),
    [anon_sym_LPAREN] = ACTIONS(6624),
    [anon_sym_RPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHpart] = ACTIONS(6622),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddpart] = ACTIONS(6622),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHchapter] = ACTIONS(6622),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddchap] = ACTIONS(6622),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsection] = ACTIONS(6622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddsec] = ACTIONS(6622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHitem] = ACTIONS(6622),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(6624),
    [sym_word] = ACTIONS(6622),
    [sym_placeholder] = ACTIONS(6624),
    [anon_sym_PLUS] = ACTIONS(6624),
    [anon_sym_DASH] = ACTIONS(6624),
    [anon_sym_STAR] = ACTIONS(6624),
    [anon_sym_SLASH] = ACTIONS(6624),
    [anon_sym_LT] = ACTIONS(6622),
    [anon_sym_GT] = ACTIONS(6622),
    [anon_sym_BANG] = ACTIONS(6622),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_COLON] = ACTIONS(6622),
    [anon_sym_SQUOTE] = ACTIONS(6622),
    [anon_sym__] = ACTIONS(6624),
    [anon_sym_CARET] = ACTIONS(6624),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6624),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6624),
    [anon_sym_DOLLAR] = ACTIONS(6622),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHbegin] = ACTIONS(6622),
    [anon_sym_BSLASHtitle] = ACTIONS(6622),
    [anon_sym_BSLASHauthor] = ACTIONS(6622),
    [anon_sym_BSLASHusepackage] = ACTIONS(6622),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6622),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6622),
    [anon_sym_BSLASHinclude] = ACTIONS(6622),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6622),
    [anon_sym_BSLASHinput] = ACTIONS(6622),
    [anon_sym_BSLASHsubfile] = ACTIONS(6622),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6622),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6622),
    [anon_sym_BSLASHbibliography] = ACTIONS(6622),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6622),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6622),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6622),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6622),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6622),
    [anon_sym_BSLASHimport] = ACTIONS(6622),
    [anon_sym_BSLASHsubimport] = ACTIONS(6622),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6622),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHcaption] = ACTIONS(6622),
    [anon_sym_BSLASHcite] = ACTIONS(6622),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCite] = ACTIONS(6622),
    [anon_sym_BSLASHnocite] = ACTIONS(6622),
    [anon_sym_BSLASHcitet] = ACTIONS(6622),
    [anon_sym_BSLASHcitep] = ACTIONS(6622),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteA] = ACTIONS(6622),
    [anon_sym_BSLASHciteR] = ACTIONS(6622),
    [anon_sym_BSLASHciteS] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6622),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteyear] = ACTIONS(6622),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitedate] = ACTIONS(6622),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteurl] = ACTIONS(6622),
    [anon_sym_BSLASHfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6622),
    [anon_sym_BSLASHcitealt] = ACTIONS(6622),
    [anon_sym_BSLASHcitealp] = ACTIONS(6622),
    [anon_sym_BSLASHcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHparencite] = ACTIONS(6622),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHParencite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHtextcite] = ACTIONS(6622),
    [anon_sym_BSLASHTextcite] = ACTIONS(6622),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHsupercite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite] = ACTIONS(6622),
    [anon_sym_BSLASHAutocite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHVolcite] = ACTIONS(6622),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHavolcite] = ACTIONS(6622),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHNotecite] = ACTIONS(6622),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHlabel] = ACTIONS(6622),
    [anon_sym_BSLASHref] = ACTIONS(6622),
    [anon_sym_BSLASHeqref] = ACTIONS(6622),
    [anon_sym_BSLASHvref] = ACTIONS(6622),
    [anon_sym_BSLASHVref] = ACTIONS(6622),
    [anon_sym_BSLASHautoref] = ACTIONS(6622),
    [anon_sym_BSLASHpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcref] = ACTIONS(6622),
    [anon_sym_BSLASHCref] = ACTIONS(6622),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnameCref] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHdef] = ACTIONS(6622),
    [anon_sym_BSLASHlet] = ACTIONS(6622),
    [anon_sym_BSLASHleft] = ACTIONS(6622),
    [anon_sym_BSLASHbigl] = ACTIONS(6622),
    [anon_sym_BSLASHBigl] = ACTIONS(6622),
    [anon_sym_BSLASHbiggl] = ACTIONS(6622),
    [anon_sym_BSLASHBiggl] = ACTIONS(6622),
    [anon_sym_BSLASHright] = ACTIONS(6622),
    [anon_sym_BSLASHbigr] = ACTIONS(6622),
    [anon_sym_BSLASHBigr] = ACTIONS(6622),
    [anon_sym_BSLASHbiggr] = ACTIONS(6622),
    [anon_sym_BSLASHBiggr] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6622),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6622),
    [anon_sym_BSLASHgls] = ACTIONS(6622),
    [anon_sym_BSLASHGls] = ACTIONS(6622),
    [anon_sym_BSLASHGLS] = ACTIONS(6622),
    [anon_sym_BSLASHglspl] = ACTIONS(6622),
    [anon_sym_BSLASHGlspl] = ACTIONS(6622),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6622),
    [anon_sym_BSLASHglslink] = ACTIONS(6622),
    [anon_sym_BSLASHglstext] = ACTIONS(6622),
    [anon_sym_BSLASHGlstext] = ACTIONS(6622),
    [anon_sym_BSLASHGLStext] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6622),
    [anon_sym_BSLASHglsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsname] = ACTIONS(6622),
    [anon_sym_BSLASHGlsname] = ACTIONS(6622),
    [anon_sym_BSLASHGLSname] = ACTIONS(6622),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6622),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6622),
    [anon_sym_BSLASHacrshort] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6622),
    [anon_sym_BSLASHACRshort] = ACTIONS(6622),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrlong] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6622),
    [anon_sym_BSLASHACRlong] = ACTIONS(6622),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrfull] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6622),
    [anon_sym_BSLASHACRfull] = ACTIONS(6622),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHacs] = ACTIONS(6622),
    [anon_sym_BSLASHAcs] = ACTIONS(6622),
    [anon_sym_BSLASHacsp] = ACTIONS(6622),
    [anon_sym_BSLASHAcsp] = ACTIONS(6622),
    [anon_sym_BSLASHacl] = ACTIONS(6622),
    [anon_sym_BSLASHAcl] = ACTIONS(6622),
    [anon_sym_BSLASHaclp] = ACTIONS(6622),
    [anon_sym_BSLASHAclp] = ACTIONS(6622),
    [anon_sym_BSLASHacf] = ACTIONS(6622),
    [anon_sym_BSLASHAcf] = ACTIONS(6622),
    [anon_sym_BSLASHacfp] = ACTIONS(6622),
    [anon_sym_BSLASHAcfp] = ACTIONS(6622),
    [anon_sym_BSLASHac] = ACTIONS(6622),
    [anon_sym_BSLASHAc] = ACTIONS(6622),
    [anon_sym_BSLASHacp] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6622),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6622),
    [anon_sym_BSLASHcolor] = ACTIONS(6622),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6622),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6622),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6622),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6622),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6622),
    [anon_sym_BSLASHtext] = ACTIONS(6622),
    [anon_sym_BSLASHintertext] = ACTIONS(6622),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6622),
    [anon_sym_BSLASHurl] = ACTIONS(6622),
    [anon_sym_BSLASHhref] = ACTIONS(6622),
  },
  [612] = {
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHright] = ACTIONS(161),
    [anon_sym_BSLASHbigr] = ACTIONS(161),
    [anon_sym_BSLASHBigr] = ACTIONS(161),
    [anon_sym_BSLASHbiggr] = ACTIONS(161),
    [anon_sym_BSLASHBiggr] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [613] = {
    [sym_command_name] = ACTIONS(6626),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6628),
    [anon_sym_RBRACK] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LPAREN] = ACTIONS(6628),
    [anon_sym_RPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHpart] = ACTIONS(6626),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddpart] = ACTIONS(6626),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHchapter] = ACTIONS(6626),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddchap] = ACTIONS(6626),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsection] = ACTIONS(6626),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddsec] = ACTIONS(6626),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHitem] = ACTIONS(6626),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6628),
    [anon_sym_LBRACE] = ACTIONS(6628),
    [sym_word] = ACTIONS(6626),
    [sym_placeholder] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_DASH] = ACTIONS(6628),
    [anon_sym_STAR] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6626),
    [anon_sym_GT] = ACTIONS(6626),
    [anon_sym_BANG] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6626),
    [anon_sym_COLON] = ACTIONS(6626),
    [anon_sym_SQUOTE] = ACTIONS(6626),
    [anon_sym__] = ACTIONS(6628),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6628),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6628),
    [anon_sym_DOLLAR] = ACTIONS(6626),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHbegin] = ACTIONS(6626),
    [anon_sym_BSLASHtitle] = ACTIONS(6626),
    [anon_sym_BSLASHauthor] = ACTIONS(6626),
    [anon_sym_BSLASHusepackage] = ACTIONS(6626),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6626),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6626),
    [anon_sym_BSLASHinclude] = ACTIONS(6626),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6626),
    [anon_sym_BSLASHinput] = ACTIONS(6626),
    [anon_sym_BSLASHsubfile] = ACTIONS(6626),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6626),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6626),
    [anon_sym_BSLASHbibliography] = ACTIONS(6626),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6626),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6626),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6626),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6626),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6626),
    [anon_sym_BSLASHimport] = ACTIONS(6626),
    [anon_sym_BSLASHsubimport] = ACTIONS(6626),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6626),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHcaption] = ACTIONS(6626),
    [anon_sym_BSLASHcite] = ACTIONS(6626),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCite] = ACTIONS(6626),
    [anon_sym_BSLASHnocite] = ACTIONS(6626),
    [anon_sym_BSLASHcitet] = ACTIONS(6626),
    [anon_sym_BSLASHcitep] = ACTIONS(6626),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteA] = ACTIONS(6626),
    [anon_sym_BSLASHciteR] = ACTIONS(6626),
    [anon_sym_BSLASHciteS] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6626),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteyear] = ACTIONS(6626),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitedate] = ACTIONS(6626),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteurl] = ACTIONS(6626),
    [anon_sym_BSLASHfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6626),
    [anon_sym_BSLASHcitealt] = ACTIONS(6626),
    [anon_sym_BSLASHcitealp] = ACTIONS(6626),
    [anon_sym_BSLASHcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHparencite] = ACTIONS(6626),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHParencite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHtextcite] = ACTIONS(6626),
    [anon_sym_BSLASHTextcite] = ACTIONS(6626),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHsupercite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite] = ACTIONS(6626),
    [anon_sym_BSLASHAutocite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHVolcite] = ACTIONS(6626),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHavolcite] = ACTIONS(6626),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHNotecite] = ACTIONS(6626),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHlabel] = ACTIONS(6626),
    [anon_sym_BSLASHref] = ACTIONS(6626),
    [anon_sym_BSLASHeqref] = ACTIONS(6626),
    [anon_sym_BSLASHvref] = ACTIONS(6626),
    [anon_sym_BSLASHVref] = ACTIONS(6626),
    [anon_sym_BSLASHautoref] = ACTIONS(6626),
    [anon_sym_BSLASHpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcref] = ACTIONS(6626),
    [anon_sym_BSLASHCref] = ACTIONS(6626),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnameCref] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHdef] = ACTIONS(6626),
    [anon_sym_BSLASHlet] = ACTIONS(6626),
    [anon_sym_BSLASHleft] = ACTIONS(6626),
    [anon_sym_BSLASHbigl] = ACTIONS(6626),
    [anon_sym_BSLASHBigl] = ACTIONS(6626),
    [anon_sym_BSLASHbiggl] = ACTIONS(6626),
    [anon_sym_BSLASHBiggl] = ACTIONS(6626),
    [anon_sym_BSLASHright] = ACTIONS(6626),
    [anon_sym_BSLASHbigr] = ACTIONS(6626),
    [anon_sym_BSLASHBigr] = ACTIONS(6626),
    [anon_sym_BSLASHbiggr] = ACTIONS(6626),
    [anon_sym_BSLASHBiggr] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6626),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6626),
    [anon_sym_BSLASHgls] = ACTIONS(6626),
    [anon_sym_BSLASHGls] = ACTIONS(6626),
    [anon_sym_BSLASHGLS] = ACTIONS(6626),
    [anon_sym_BSLASHglspl] = ACTIONS(6626),
    [anon_sym_BSLASHGlspl] = ACTIONS(6626),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6626),
    [anon_sym_BSLASHglslink] = ACTIONS(6626),
    [anon_sym_BSLASHglstext] = ACTIONS(6626),
    [anon_sym_BSLASHGlstext] = ACTIONS(6626),
    [anon_sym_BSLASHGLStext] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6626),
    [anon_sym_BSLASHglsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsname] = ACTIONS(6626),
    [anon_sym_BSLASHGlsname] = ACTIONS(6626),
    [anon_sym_BSLASHGLSname] = ACTIONS(6626),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6626),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6626),
    [anon_sym_BSLASHacrshort] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6626),
    [anon_sym_BSLASHACRshort] = ACTIONS(6626),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrlong] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6626),
    [anon_sym_BSLASHACRlong] = ACTIONS(6626),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrfull] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6626),
    [anon_sym_BSLASHACRfull] = ACTIONS(6626),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHacs] = ACTIONS(6626),
    [anon_sym_BSLASHAcs] = ACTIONS(6626),
    [anon_sym_BSLASHacsp] = ACTIONS(6626),
    [anon_sym_BSLASHAcsp] = ACTIONS(6626),
    [anon_sym_BSLASHacl] = ACTIONS(6626),
    [anon_sym_BSLASHAcl] = ACTIONS(6626),
    [anon_sym_BSLASHaclp] = ACTIONS(6626),
    [anon_sym_BSLASHAclp] = ACTIONS(6626),
    [anon_sym_BSLASHacf] = ACTIONS(6626),
    [anon_sym_BSLASHAcf] = ACTIONS(6626),
    [anon_sym_BSLASHacfp] = ACTIONS(6626),
    [anon_sym_BSLASHAcfp] = ACTIONS(6626),
    [anon_sym_BSLASHac] = ACTIONS(6626),
    [anon_sym_BSLASHAc] = ACTIONS(6626),
    [anon_sym_BSLASHacp] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6626),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6626),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6626),
    [anon_sym_BSLASHcolor] = ACTIONS(6626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6626),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6626),
    [anon_sym_BSLASHtext] = ACTIONS(6626),
    [anon_sym_BSLASHintertext] = ACTIONS(6626),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6626),
    [anon_sym_BSLASHurl] = ACTIONS(6626),
    [anon_sym_BSLASHhref] = ACTIONS(6626),
  },
  [614] = {
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHright] = ACTIONS(149),
    [anon_sym_BSLASHbigr] = ACTIONS(149),
    [anon_sym_BSLASHBigr] = ACTIONS(149),
    [anon_sym_BSLASHbiggr] = ACTIONS(149),
    [anon_sym_BSLASHBiggr] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [615] = {
    [sym_command_name] = ACTIONS(6630),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LPAREN] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHpart] = ACTIONS(6630),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddpart] = ACTIONS(6630),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHchapter] = ACTIONS(6630),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddchap] = ACTIONS(6630),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsection] = ACTIONS(6630),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddsec] = ACTIONS(6630),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHitem] = ACTIONS(6630),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [sym_word] = ACTIONS(6630),
    [sym_placeholder] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [anon_sym_STAR] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_BANG] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_COLON] = ACTIONS(6630),
    [anon_sym_SQUOTE] = ACTIONS(6630),
    [anon_sym__] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6632),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6632),
    [anon_sym_DOLLAR] = ACTIONS(6630),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHbegin] = ACTIONS(6630),
    [anon_sym_BSLASHtitle] = ACTIONS(6630),
    [anon_sym_BSLASHauthor] = ACTIONS(6630),
    [anon_sym_BSLASHusepackage] = ACTIONS(6630),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6630),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6630),
    [anon_sym_BSLASHinclude] = ACTIONS(6630),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6630),
    [anon_sym_BSLASHinput] = ACTIONS(6630),
    [anon_sym_BSLASHsubfile] = ACTIONS(6630),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6630),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6630),
    [anon_sym_BSLASHbibliography] = ACTIONS(6630),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6630),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6630),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6630),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6630),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6630),
    [anon_sym_BSLASHimport] = ACTIONS(6630),
    [anon_sym_BSLASHsubimport] = ACTIONS(6630),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6630),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHcaption] = ACTIONS(6630),
    [anon_sym_BSLASHcite] = ACTIONS(6630),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCite] = ACTIONS(6630),
    [anon_sym_BSLASHnocite] = ACTIONS(6630),
    [anon_sym_BSLASHcitet] = ACTIONS(6630),
    [anon_sym_BSLASHcitep] = ACTIONS(6630),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteA] = ACTIONS(6630),
    [anon_sym_BSLASHciteR] = ACTIONS(6630),
    [anon_sym_BSLASHciteS] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6630),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteyear] = ACTIONS(6630),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitedate] = ACTIONS(6630),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteurl] = ACTIONS(6630),
    [anon_sym_BSLASHfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6630),
    [anon_sym_BSLASHcitealt] = ACTIONS(6630),
    [anon_sym_BSLASHcitealp] = ACTIONS(6630),
    [anon_sym_BSLASHcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHparencite] = ACTIONS(6630),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHParencite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHtextcite] = ACTIONS(6630),
    [anon_sym_BSLASHTextcite] = ACTIONS(6630),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHsupercite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite] = ACTIONS(6630),
    [anon_sym_BSLASHAutocite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHVolcite] = ACTIONS(6630),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHavolcite] = ACTIONS(6630),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHNotecite] = ACTIONS(6630),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHlabel] = ACTIONS(6630),
    [anon_sym_BSLASHref] = ACTIONS(6630),
    [anon_sym_BSLASHeqref] = ACTIONS(6630),
    [anon_sym_BSLASHvref] = ACTIONS(6630),
    [anon_sym_BSLASHVref] = ACTIONS(6630),
    [anon_sym_BSLASHautoref] = ACTIONS(6630),
    [anon_sym_BSLASHpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcref] = ACTIONS(6630),
    [anon_sym_BSLASHCref] = ACTIONS(6630),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnameCref] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHdef] = ACTIONS(6630),
    [anon_sym_BSLASHlet] = ACTIONS(6630),
    [anon_sym_BSLASHleft] = ACTIONS(6630),
    [anon_sym_BSLASHbigl] = ACTIONS(6630),
    [anon_sym_BSLASHBigl] = ACTIONS(6630),
    [anon_sym_BSLASHbiggl] = ACTIONS(6630),
    [anon_sym_BSLASHBiggl] = ACTIONS(6630),
    [anon_sym_BSLASHright] = ACTIONS(6630),
    [anon_sym_BSLASHbigr] = ACTIONS(6630),
    [anon_sym_BSLASHBigr] = ACTIONS(6630),
    [anon_sym_BSLASHbiggr] = ACTIONS(6630),
    [anon_sym_BSLASHBiggr] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6630),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6630),
    [anon_sym_BSLASHgls] = ACTIONS(6630),
    [anon_sym_BSLASHGls] = ACTIONS(6630),
    [anon_sym_BSLASHGLS] = ACTIONS(6630),
    [anon_sym_BSLASHglspl] = ACTIONS(6630),
    [anon_sym_BSLASHGlspl] = ACTIONS(6630),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6630),
    [anon_sym_BSLASHglslink] = ACTIONS(6630),
    [anon_sym_BSLASHglstext] = ACTIONS(6630),
    [anon_sym_BSLASHGlstext] = ACTIONS(6630),
    [anon_sym_BSLASHGLStext] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6630),
    [anon_sym_BSLASHglsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsname] = ACTIONS(6630),
    [anon_sym_BSLASHGlsname] = ACTIONS(6630),
    [anon_sym_BSLASHGLSname] = ACTIONS(6630),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6630),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6630),
    [anon_sym_BSLASHacrshort] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6630),
    [anon_sym_BSLASHACRshort] = ACTIONS(6630),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrlong] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6630),
    [anon_sym_BSLASHACRlong] = ACTIONS(6630),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrfull] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6630),
    [anon_sym_BSLASHACRfull] = ACTIONS(6630),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHacs] = ACTIONS(6630),
    [anon_sym_BSLASHAcs] = ACTIONS(6630),
    [anon_sym_BSLASHacsp] = ACTIONS(6630),
    [anon_sym_BSLASHAcsp] = ACTIONS(6630),
    [anon_sym_BSLASHacl] = ACTIONS(6630),
    [anon_sym_BSLASHAcl] = ACTIONS(6630),
    [anon_sym_BSLASHaclp] = ACTIONS(6630),
    [anon_sym_BSLASHAclp] = ACTIONS(6630),
    [anon_sym_BSLASHacf] = ACTIONS(6630),
    [anon_sym_BSLASHAcf] = ACTIONS(6630),
    [anon_sym_BSLASHacfp] = ACTIONS(6630),
    [anon_sym_BSLASHAcfp] = ACTIONS(6630),
    [anon_sym_BSLASHac] = ACTIONS(6630),
    [anon_sym_BSLASHAc] = ACTIONS(6630),
    [anon_sym_BSLASHacp] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6630),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6630),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6630),
    [anon_sym_BSLASHcolor] = ACTIONS(6630),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6630),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6630),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6630),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6630),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6630),
    [anon_sym_BSLASHtext] = ACTIONS(6630),
    [anon_sym_BSLASHintertext] = ACTIONS(6630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6630),
    [anon_sym_BSLASHurl] = ACTIONS(6630),
    [anon_sym_BSLASHhref] = ACTIONS(6630),
  },
  [616] = {
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_RBRACK] = ACTIONS(6636),
    [anon_sym_COMMA] = ACTIONS(6636),
    [anon_sym_EQ] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(6636),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHpart] = ACTIONS(6634),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddpart] = ACTIONS(6634),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHchapter] = ACTIONS(6634),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddchap] = ACTIONS(6634),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsection] = ACTIONS(6634),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddsec] = ACTIONS(6634),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHitem] = ACTIONS(6634),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6636),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(6634),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHbegin] = ACTIONS(6634),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHleft] = ACTIONS(6634),
    [anon_sym_BSLASHbigl] = ACTIONS(6634),
    [anon_sym_BSLASHBigl] = ACTIONS(6634),
    [anon_sym_BSLASHbiggl] = ACTIONS(6634),
    [anon_sym_BSLASHBiggl] = ACTIONS(6634),
    [anon_sym_BSLASHright] = ACTIONS(6634),
    [anon_sym_BSLASHbigr] = ACTIONS(6634),
    [anon_sym_BSLASHBigr] = ACTIONS(6634),
    [anon_sym_BSLASHbiggr] = ACTIONS(6634),
    [anon_sym_BSLASHBiggr] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHtext] = ACTIONS(6634),
    [anon_sym_BSLASHintertext] = ACTIONS(6634),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [617] = {
    [sym_command_name] = ACTIONS(6638),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6640),
    [anon_sym_RBRACK] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LPAREN] = ACTIONS(6640),
    [anon_sym_RPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHpart] = ACTIONS(6638),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddpart] = ACTIONS(6638),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHchapter] = ACTIONS(6638),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddchap] = ACTIONS(6638),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsection] = ACTIONS(6638),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddsec] = ACTIONS(6638),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHitem] = ACTIONS(6638),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(6640),
    [sym_word] = ACTIONS(6638),
    [sym_placeholder] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_DASH] = ACTIONS(6640),
    [anon_sym_STAR] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6638),
    [anon_sym_GT] = ACTIONS(6638),
    [anon_sym_BANG] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6638),
    [anon_sym_COLON] = ACTIONS(6638),
    [anon_sym_SQUOTE] = ACTIONS(6638),
    [anon_sym__] = ACTIONS(6640),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6640),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6640),
    [anon_sym_DOLLAR] = ACTIONS(6638),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHbegin] = ACTIONS(6638),
    [anon_sym_BSLASHtitle] = ACTIONS(6638),
    [anon_sym_BSLASHauthor] = ACTIONS(6638),
    [anon_sym_BSLASHusepackage] = ACTIONS(6638),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6638),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6638),
    [anon_sym_BSLASHinclude] = ACTIONS(6638),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6638),
    [anon_sym_BSLASHinput] = ACTIONS(6638),
    [anon_sym_BSLASHsubfile] = ACTIONS(6638),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6638),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6638),
    [anon_sym_BSLASHbibliography] = ACTIONS(6638),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6638),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6638),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6638),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6638),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6638),
    [anon_sym_BSLASHimport] = ACTIONS(6638),
    [anon_sym_BSLASHsubimport] = ACTIONS(6638),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6638),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHcaption] = ACTIONS(6638),
    [anon_sym_BSLASHcite] = ACTIONS(6638),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCite] = ACTIONS(6638),
    [anon_sym_BSLASHnocite] = ACTIONS(6638),
    [anon_sym_BSLASHcitet] = ACTIONS(6638),
    [anon_sym_BSLASHcitep] = ACTIONS(6638),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteA] = ACTIONS(6638),
    [anon_sym_BSLASHciteR] = ACTIONS(6638),
    [anon_sym_BSLASHciteS] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6638),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteyear] = ACTIONS(6638),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitedate] = ACTIONS(6638),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteurl] = ACTIONS(6638),
    [anon_sym_BSLASHfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6638),
    [anon_sym_BSLASHcitealt] = ACTIONS(6638),
    [anon_sym_BSLASHcitealp] = ACTIONS(6638),
    [anon_sym_BSLASHcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHparencite] = ACTIONS(6638),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHParencite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHtextcite] = ACTIONS(6638),
    [anon_sym_BSLASHTextcite] = ACTIONS(6638),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHsupercite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite] = ACTIONS(6638),
    [anon_sym_BSLASHAutocite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHVolcite] = ACTIONS(6638),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHavolcite] = ACTIONS(6638),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHNotecite] = ACTIONS(6638),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHlabel] = ACTIONS(6638),
    [anon_sym_BSLASHref] = ACTIONS(6638),
    [anon_sym_BSLASHeqref] = ACTIONS(6638),
    [anon_sym_BSLASHvref] = ACTIONS(6638),
    [anon_sym_BSLASHVref] = ACTIONS(6638),
    [anon_sym_BSLASHautoref] = ACTIONS(6638),
    [anon_sym_BSLASHpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcref] = ACTIONS(6638),
    [anon_sym_BSLASHCref] = ACTIONS(6638),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnameCref] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHdef] = ACTIONS(6638),
    [anon_sym_BSLASHlet] = ACTIONS(6638),
    [anon_sym_BSLASHleft] = ACTIONS(6638),
    [anon_sym_BSLASHbigl] = ACTIONS(6638),
    [anon_sym_BSLASHBigl] = ACTIONS(6638),
    [anon_sym_BSLASHbiggl] = ACTIONS(6638),
    [anon_sym_BSLASHBiggl] = ACTIONS(6638),
    [anon_sym_BSLASHright] = ACTIONS(6638),
    [anon_sym_BSLASHbigr] = ACTIONS(6638),
    [anon_sym_BSLASHBigr] = ACTIONS(6638),
    [anon_sym_BSLASHbiggr] = ACTIONS(6638),
    [anon_sym_BSLASHBiggr] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6638),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6638),
    [anon_sym_BSLASHgls] = ACTIONS(6638),
    [anon_sym_BSLASHGls] = ACTIONS(6638),
    [anon_sym_BSLASHGLS] = ACTIONS(6638),
    [anon_sym_BSLASHglspl] = ACTIONS(6638),
    [anon_sym_BSLASHGlspl] = ACTIONS(6638),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6638),
    [anon_sym_BSLASHglslink] = ACTIONS(6638),
    [anon_sym_BSLASHglstext] = ACTIONS(6638),
    [anon_sym_BSLASHGlstext] = ACTIONS(6638),
    [anon_sym_BSLASHGLStext] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6638),
    [anon_sym_BSLASHglsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsname] = ACTIONS(6638),
    [anon_sym_BSLASHGlsname] = ACTIONS(6638),
    [anon_sym_BSLASHGLSname] = ACTIONS(6638),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6638),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6638),
    [anon_sym_BSLASHacrshort] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6638),
    [anon_sym_BSLASHACRshort] = ACTIONS(6638),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrlong] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6638),
    [anon_sym_BSLASHACRlong] = ACTIONS(6638),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrfull] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6638),
    [anon_sym_BSLASHACRfull] = ACTIONS(6638),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHacs] = ACTIONS(6638),
    [anon_sym_BSLASHAcs] = ACTIONS(6638),
    [anon_sym_BSLASHacsp] = ACTIONS(6638),
    [anon_sym_BSLASHAcsp] = ACTIONS(6638),
    [anon_sym_BSLASHacl] = ACTIONS(6638),
    [anon_sym_BSLASHAcl] = ACTIONS(6638),
    [anon_sym_BSLASHaclp] = ACTIONS(6638),
    [anon_sym_BSLASHAclp] = ACTIONS(6638),
    [anon_sym_BSLASHacf] = ACTIONS(6638),
    [anon_sym_BSLASHAcf] = ACTIONS(6638),
    [anon_sym_BSLASHacfp] = ACTIONS(6638),
    [anon_sym_BSLASHAcfp] = ACTIONS(6638),
    [anon_sym_BSLASHac] = ACTIONS(6638),
    [anon_sym_BSLASHAc] = ACTIONS(6638),
    [anon_sym_BSLASHacp] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6638),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6638),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6638),
    [anon_sym_BSLASHcolor] = ACTIONS(6638),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6638),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6638),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6638),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6638),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6638),
    [anon_sym_BSLASHtext] = ACTIONS(6638),
    [anon_sym_BSLASHintertext] = ACTIONS(6638),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6638),
    [anon_sym_BSLASHurl] = ACTIONS(6638),
    [anon_sym_BSLASHhref] = ACTIONS(6638),
  },
  [618] = {
    [sym_command_name] = ACTIONS(6642),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6642),
    [anon_sym_LBRACK] = ACTIONS(6644),
    [anon_sym_RBRACK] = ACTIONS(6644),
    [anon_sym_COMMA] = ACTIONS(6644),
    [anon_sym_EQ] = ACTIONS(6644),
    [anon_sym_LPAREN] = ACTIONS(6644),
    [anon_sym_RPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHpart] = ACTIONS(6642),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddpart] = ACTIONS(6642),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHchapter] = ACTIONS(6642),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddchap] = ACTIONS(6642),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsection] = ACTIONS(6642),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddsec] = ACTIONS(6642),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHitem] = ACTIONS(6642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6644),
    [anon_sym_LBRACE] = ACTIONS(6644),
    [sym_word] = ACTIONS(6642),
    [sym_placeholder] = ACTIONS(6644),
    [anon_sym_PLUS] = ACTIONS(6644),
    [anon_sym_DASH] = ACTIONS(6644),
    [anon_sym_STAR] = ACTIONS(6644),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_LT] = ACTIONS(6642),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_BANG] = ACTIONS(6642),
    [anon_sym_PIPE] = ACTIONS(6642),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_SQUOTE] = ACTIONS(6642),
    [anon_sym__] = ACTIONS(6644),
    [anon_sym_CARET] = ACTIONS(6644),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6644),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6644),
    [anon_sym_DOLLAR] = ACTIONS(6642),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHbegin] = ACTIONS(6642),
    [anon_sym_BSLASHtitle] = ACTIONS(6642),
    [anon_sym_BSLASHauthor] = ACTIONS(6642),
    [anon_sym_BSLASHusepackage] = ACTIONS(6642),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6642),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6642),
    [anon_sym_BSLASHinclude] = ACTIONS(6642),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6642),
    [anon_sym_BSLASHinput] = ACTIONS(6642),
    [anon_sym_BSLASHsubfile] = ACTIONS(6642),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6642),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6642),
    [anon_sym_BSLASHbibliography] = ACTIONS(6642),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6642),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6642),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6642),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6642),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6642),
    [anon_sym_BSLASHimport] = ACTIONS(6642),
    [anon_sym_BSLASHsubimport] = ACTIONS(6642),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6642),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHcaption] = ACTIONS(6642),
    [anon_sym_BSLASHcite] = ACTIONS(6642),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCite] = ACTIONS(6642),
    [anon_sym_BSLASHnocite] = ACTIONS(6642),
    [anon_sym_BSLASHcitet] = ACTIONS(6642),
    [anon_sym_BSLASHcitep] = ACTIONS(6642),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteA] = ACTIONS(6642),
    [anon_sym_BSLASHciteR] = ACTIONS(6642),
    [anon_sym_BSLASHciteS] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6642),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteyear] = ACTIONS(6642),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitedate] = ACTIONS(6642),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteurl] = ACTIONS(6642),
    [anon_sym_BSLASHfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6642),
    [anon_sym_BSLASHcitealt] = ACTIONS(6642),
    [anon_sym_BSLASHcitealp] = ACTIONS(6642),
    [anon_sym_BSLASHcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHparencite] = ACTIONS(6642),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHParencite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHtextcite] = ACTIONS(6642),
    [anon_sym_BSLASHTextcite] = ACTIONS(6642),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHsupercite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite] = ACTIONS(6642),
    [anon_sym_BSLASHAutocite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHVolcite] = ACTIONS(6642),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHavolcite] = ACTIONS(6642),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHNotecite] = ACTIONS(6642),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHlabel] = ACTIONS(6642),
    [anon_sym_BSLASHref] = ACTIONS(6642),
    [anon_sym_BSLASHeqref] = ACTIONS(6642),
    [anon_sym_BSLASHvref] = ACTIONS(6642),
    [anon_sym_BSLASHVref] = ACTIONS(6642),
    [anon_sym_BSLASHautoref] = ACTIONS(6642),
    [anon_sym_BSLASHpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcref] = ACTIONS(6642),
    [anon_sym_BSLASHCref] = ACTIONS(6642),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnameCref] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHdef] = ACTIONS(6642),
    [anon_sym_BSLASHlet] = ACTIONS(6642),
    [anon_sym_BSLASHleft] = ACTIONS(6642),
    [anon_sym_BSLASHbigl] = ACTIONS(6642),
    [anon_sym_BSLASHBigl] = ACTIONS(6642),
    [anon_sym_BSLASHbiggl] = ACTIONS(6642),
    [anon_sym_BSLASHBiggl] = ACTIONS(6642),
    [anon_sym_BSLASHright] = ACTIONS(6642),
    [anon_sym_BSLASHbigr] = ACTIONS(6642),
    [anon_sym_BSLASHBigr] = ACTIONS(6642),
    [anon_sym_BSLASHbiggr] = ACTIONS(6642),
    [anon_sym_BSLASHBiggr] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6642),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6642),
    [anon_sym_BSLASHgls] = ACTIONS(6642),
    [anon_sym_BSLASHGls] = ACTIONS(6642),
    [anon_sym_BSLASHGLS] = ACTIONS(6642),
    [anon_sym_BSLASHglspl] = ACTIONS(6642),
    [anon_sym_BSLASHGlspl] = ACTIONS(6642),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6642),
    [anon_sym_BSLASHglslink] = ACTIONS(6642),
    [anon_sym_BSLASHglstext] = ACTIONS(6642),
    [anon_sym_BSLASHGlstext] = ACTIONS(6642),
    [anon_sym_BSLASHGLStext] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6642),
    [anon_sym_BSLASHglsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsname] = ACTIONS(6642),
    [anon_sym_BSLASHGlsname] = ACTIONS(6642),
    [anon_sym_BSLASHGLSname] = ACTIONS(6642),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6642),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6642),
    [anon_sym_BSLASHacrshort] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6642),
    [anon_sym_BSLASHACRshort] = ACTIONS(6642),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrlong] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6642),
    [anon_sym_BSLASHACRlong] = ACTIONS(6642),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrfull] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6642),
    [anon_sym_BSLASHACRfull] = ACTIONS(6642),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHacs] = ACTIONS(6642),
    [anon_sym_BSLASHAcs] = ACTIONS(6642),
    [anon_sym_BSLASHacsp] = ACTIONS(6642),
    [anon_sym_BSLASHAcsp] = ACTIONS(6642),
    [anon_sym_BSLASHacl] = ACTIONS(6642),
    [anon_sym_BSLASHAcl] = ACTIONS(6642),
    [anon_sym_BSLASHaclp] = ACTIONS(6642),
    [anon_sym_BSLASHAclp] = ACTIONS(6642),
    [anon_sym_BSLASHacf] = ACTIONS(6642),
    [anon_sym_BSLASHAcf] = ACTIONS(6642),
    [anon_sym_BSLASHacfp] = ACTIONS(6642),
    [anon_sym_BSLASHAcfp] = ACTIONS(6642),
    [anon_sym_BSLASHac] = ACTIONS(6642),
    [anon_sym_BSLASHAc] = ACTIONS(6642),
    [anon_sym_BSLASHacp] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6642),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6642),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6642),
    [anon_sym_BSLASHcolor] = ACTIONS(6642),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6642),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6642),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6642),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6642),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6642),
    [anon_sym_BSLASHtext] = ACTIONS(6642),
    [anon_sym_BSLASHintertext] = ACTIONS(6642),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6642),
    [anon_sym_BSLASHurl] = ACTIONS(6642),
    [anon_sym_BSLASHhref] = ACTIONS(6642),
  },
  [619] = {
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHright] = ACTIONS(155),
    [anon_sym_BSLASHbigr] = ACTIONS(155),
    [anon_sym_BSLASHBigr] = ACTIONS(155),
    [anon_sym_BSLASHbiggr] = ACTIONS(155),
    [anon_sym_BSLASHBiggr] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [620] = {
    [sym_command_name] = ACTIONS(6646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6646),
    [anon_sym_LBRACK] = ACTIONS(6648),
    [anon_sym_RBRACK] = ACTIONS(6648),
    [anon_sym_COMMA] = ACTIONS(6648),
    [anon_sym_EQ] = ACTIONS(6648),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [anon_sym_RPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHpart] = ACTIONS(6646),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddpart] = ACTIONS(6646),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHchapter] = ACTIONS(6646),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddchap] = ACTIONS(6646),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsection] = ACTIONS(6646),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddsec] = ACTIONS(6646),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHitem] = ACTIONS(6646),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6648),
    [anon_sym_LBRACE] = ACTIONS(6648),
    [sym_word] = ACTIONS(6646),
    [sym_placeholder] = ACTIONS(6648),
    [anon_sym_PLUS] = ACTIONS(6648),
    [anon_sym_DASH] = ACTIONS(6648),
    [anon_sym_STAR] = ACTIONS(6648),
    [anon_sym_SLASH] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6646),
    [anon_sym_GT] = ACTIONS(6646),
    [anon_sym_BANG] = ACTIONS(6646),
    [anon_sym_PIPE] = ACTIONS(6646),
    [anon_sym_COLON] = ACTIONS(6646),
    [anon_sym_SQUOTE] = ACTIONS(6646),
    [anon_sym__] = ACTIONS(6648),
    [anon_sym_CARET] = ACTIONS(6648),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6648),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6648),
    [anon_sym_DOLLAR] = ACTIONS(6646),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHbegin] = ACTIONS(6646),
    [anon_sym_BSLASHtitle] = ACTIONS(6646),
    [anon_sym_BSLASHauthor] = ACTIONS(6646),
    [anon_sym_BSLASHusepackage] = ACTIONS(6646),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6646),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6646),
    [anon_sym_BSLASHinclude] = ACTIONS(6646),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6646),
    [anon_sym_BSLASHinput] = ACTIONS(6646),
    [anon_sym_BSLASHsubfile] = ACTIONS(6646),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6646),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6646),
    [anon_sym_BSLASHbibliography] = ACTIONS(6646),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6646),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6646),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6646),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6646),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6646),
    [anon_sym_BSLASHimport] = ACTIONS(6646),
    [anon_sym_BSLASHsubimport] = ACTIONS(6646),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6646),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHcaption] = ACTIONS(6646),
    [anon_sym_BSLASHcite] = ACTIONS(6646),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCite] = ACTIONS(6646),
    [anon_sym_BSLASHnocite] = ACTIONS(6646),
    [anon_sym_BSLASHcitet] = ACTIONS(6646),
    [anon_sym_BSLASHcitep] = ACTIONS(6646),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteA] = ACTIONS(6646),
    [anon_sym_BSLASHciteR] = ACTIONS(6646),
    [anon_sym_BSLASHciteS] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6646),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteyear] = ACTIONS(6646),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitedate] = ACTIONS(6646),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteurl] = ACTIONS(6646),
    [anon_sym_BSLASHfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6646),
    [anon_sym_BSLASHcitealt] = ACTIONS(6646),
    [anon_sym_BSLASHcitealp] = ACTIONS(6646),
    [anon_sym_BSLASHcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHparencite] = ACTIONS(6646),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHParencite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHtextcite] = ACTIONS(6646),
    [anon_sym_BSLASHTextcite] = ACTIONS(6646),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHsupercite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite] = ACTIONS(6646),
    [anon_sym_BSLASHAutocite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHVolcite] = ACTIONS(6646),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHavolcite] = ACTIONS(6646),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHNotecite] = ACTIONS(6646),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHlabel] = ACTIONS(6646),
    [anon_sym_BSLASHref] = ACTIONS(6646),
    [anon_sym_BSLASHeqref] = ACTIONS(6646),
    [anon_sym_BSLASHvref] = ACTIONS(6646),
    [anon_sym_BSLASHVref] = ACTIONS(6646),
    [anon_sym_BSLASHautoref] = ACTIONS(6646),
    [anon_sym_BSLASHpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcref] = ACTIONS(6646),
    [anon_sym_BSLASHCref] = ACTIONS(6646),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnameCref] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHdef] = ACTIONS(6646),
    [anon_sym_BSLASHlet] = ACTIONS(6646),
    [anon_sym_BSLASHleft] = ACTIONS(6646),
    [anon_sym_BSLASHbigl] = ACTIONS(6646),
    [anon_sym_BSLASHBigl] = ACTIONS(6646),
    [anon_sym_BSLASHbiggl] = ACTIONS(6646),
    [anon_sym_BSLASHBiggl] = ACTIONS(6646),
    [anon_sym_BSLASHright] = ACTIONS(6646),
    [anon_sym_BSLASHbigr] = ACTIONS(6646),
    [anon_sym_BSLASHBigr] = ACTIONS(6646),
    [anon_sym_BSLASHbiggr] = ACTIONS(6646),
    [anon_sym_BSLASHBiggr] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6646),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6646),
    [anon_sym_BSLASHgls] = ACTIONS(6646),
    [anon_sym_BSLASHGls] = ACTIONS(6646),
    [anon_sym_BSLASHGLS] = ACTIONS(6646),
    [anon_sym_BSLASHglspl] = ACTIONS(6646),
    [anon_sym_BSLASHGlspl] = ACTIONS(6646),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6646),
    [anon_sym_BSLASHglslink] = ACTIONS(6646),
    [anon_sym_BSLASHglstext] = ACTIONS(6646),
    [anon_sym_BSLASHGlstext] = ACTIONS(6646),
    [anon_sym_BSLASHGLStext] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6646),
    [anon_sym_BSLASHglsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsname] = ACTIONS(6646),
    [anon_sym_BSLASHGlsname] = ACTIONS(6646),
    [anon_sym_BSLASHGLSname] = ACTIONS(6646),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6646),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6646),
    [anon_sym_BSLASHacrshort] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6646),
    [anon_sym_BSLASHACRshort] = ACTIONS(6646),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrlong] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6646),
    [anon_sym_BSLASHACRlong] = ACTIONS(6646),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrfull] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6646),
    [anon_sym_BSLASHACRfull] = ACTIONS(6646),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHacs] = ACTIONS(6646),
    [anon_sym_BSLASHAcs] = ACTIONS(6646),
    [anon_sym_BSLASHacsp] = ACTIONS(6646),
    [anon_sym_BSLASHAcsp] = ACTIONS(6646),
    [anon_sym_BSLASHacl] = ACTIONS(6646),
    [anon_sym_BSLASHAcl] = ACTIONS(6646),
    [anon_sym_BSLASHaclp] = ACTIONS(6646),
    [anon_sym_BSLASHAclp] = ACTIONS(6646),
    [anon_sym_BSLASHacf] = ACTIONS(6646),
    [anon_sym_BSLASHAcf] = ACTIONS(6646),
    [anon_sym_BSLASHacfp] = ACTIONS(6646),
    [anon_sym_BSLASHAcfp] = ACTIONS(6646),
    [anon_sym_BSLASHac] = ACTIONS(6646),
    [anon_sym_BSLASHAc] = ACTIONS(6646),
    [anon_sym_BSLASHacp] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6646),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6646),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6646),
    [anon_sym_BSLASHcolor] = ACTIONS(6646),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6646),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6646),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6646),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6646),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6646),
    [anon_sym_BSLASHtext] = ACTIONS(6646),
    [anon_sym_BSLASHintertext] = ACTIONS(6646),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6646),
    [anon_sym_BSLASHurl] = ACTIONS(6646),
    [anon_sym_BSLASHhref] = ACTIONS(6646),
  },
  [621] = {
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHright] = ACTIONS(165),
    [anon_sym_BSLASHbigr] = ACTIONS(165),
    [anon_sym_BSLASHBigr] = ACTIONS(165),
    [anon_sym_BSLASHbiggr] = ACTIONS(165),
    [anon_sym_BSLASHBiggr] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [622] = {
    [sym_command_name] = ACTIONS(6650),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6650),
    [anon_sym_LBRACK] = ACTIONS(6652),
    [anon_sym_RBRACK] = ACTIONS(6652),
    [anon_sym_COMMA] = ACTIONS(6652),
    [anon_sym_EQ] = ACTIONS(6652),
    [anon_sym_LPAREN] = ACTIONS(6652),
    [anon_sym_RPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHpart] = ACTIONS(6650),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddpart] = ACTIONS(6650),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHchapter] = ACTIONS(6650),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddchap] = ACTIONS(6650),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsection] = ACTIONS(6650),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddsec] = ACTIONS(6650),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHitem] = ACTIONS(6650),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6652),
    [anon_sym_LBRACE] = ACTIONS(6652),
    [sym_word] = ACTIONS(6650),
    [sym_placeholder] = ACTIONS(6652),
    [anon_sym_PLUS] = ACTIONS(6652),
    [anon_sym_DASH] = ACTIONS(6652),
    [anon_sym_STAR] = ACTIONS(6652),
    [anon_sym_SLASH] = ACTIONS(6652),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_BANG] = ACTIONS(6650),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_COLON] = ACTIONS(6650),
    [anon_sym_SQUOTE] = ACTIONS(6650),
    [anon_sym__] = ACTIONS(6652),
    [anon_sym_CARET] = ACTIONS(6652),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6652),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6652),
    [anon_sym_DOLLAR] = ACTIONS(6650),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHbegin] = ACTIONS(6650),
    [anon_sym_BSLASHtitle] = ACTIONS(6650),
    [anon_sym_BSLASHauthor] = ACTIONS(6650),
    [anon_sym_BSLASHusepackage] = ACTIONS(6650),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6650),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6650),
    [anon_sym_BSLASHinclude] = ACTIONS(6650),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6650),
    [anon_sym_BSLASHinput] = ACTIONS(6650),
    [anon_sym_BSLASHsubfile] = ACTIONS(6650),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6650),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6650),
    [anon_sym_BSLASHbibliography] = ACTIONS(6650),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6650),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6650),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6650),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6650),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6650),
    [anon_sym_BSLASHimport] = ACTIONS(6650),
    [anon_sym_BSLASHsubimport] = ACTIONS(6650),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6650),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHcaption] = ACTIONS(6650),
    [anon_sym_BSLASHcite] = ACTIONS(6650),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCite] = ACTIONS(6650),
    [anon_sym_BSLASHnocite] = ACTIONS(6650),
    [anon_sym_BSLASHcitet] = ACTIONS(6650),
    [anon_sym_BSLASHcitep] = ACTIONS(6650),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteA] = ACTIONS(6650),
    [anon_sym_BSLASHciteR] = ACTIONS(6650),
    [anon_sym_BSLASHciteS] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6650),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteyear] = ACTIONS(6650),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitedate] = ACTIONS(6650),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteurl] = ACTIONS(6650),
    [anon_sym_BSLASHfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6650),
    [anon_sym_BSLASHcitealt] = ACTIONS(6650),
    [anon_sym_BSLASHcitealp] = ACTIONS(6650),
    [anon_sym_BSLASHcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHparencite] = ACTIONS(6650),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHParencite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHtextcite] = ACTIONS(6650),
    [anon_sym_BSLASHTextcite] = ACTIONS(6650),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHsupercite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite] = ACTIONS(6650),
    [anon_sym_BSLASHAutocite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHVolcite] = ACTIONS(6650),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHavolcite] = ACTIONS(6650),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHNotecite] = ACTIONS(6650),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHlabel] = ACTIONS(6650),
    [anon_sym_BSLASHref] = ACTIONS(6650),
    [anon_sym_BSLASHeqref] = ACTIONS(6650),
    [anon_sym_BSLASHvref] = ACTIONS(6650),
    [anon_sym_BSLASHVref] = ACTIONS(6650),
    [anon_sym_BSLASHautoref] = ACTIONS(6650),
    [anon_sym_BSLASHpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcref] = ACTIONS(6650),
    [anon_sym_BSLASHCref] = ACTIONS(6650),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnameCref] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHdef] = ACTIONS(6650),
    [anon_sym_BSLASHlet] = ACTIONS(6650),
    [anon_sym_BSLASHleft] = ACTIONS(6650),
    [anon_sym_BSLASHbigl] = ACTIONS(6650),
    [anon_sym_BSLASHBigl] = ACTIONS(6650),
    [anon_sym_BSLASHbiggl] = ACTIONS(6650),
    [anon_sym_BSLASHBiggl] = ACTIONS(6650),
    [anon_sym_BSLASHright] = ACTIONS(6650),
    [anon_sym_BSLASHbigr] = ACTIONS(6650),
    [anon_sym_BSLASHBigr] = ACTIONS(6650),
    [anon_sym_BSLASHbiggr] = ACTIONS(6650),
    [anon_sym_BSLASHBiggr] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6650),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6650),
    [anon_sym_BSLASHgls] = ACTIONS(6650),
    [anon_sym_BSLASHGls] = ACTIONS(6650),
    [anon_sym_BSLASHGLS] = ACTIONS(6650),
    [anon_sym_BSLASHglspl] = ACTIONS(6650),
    [anon_sym_BSLASHGlspl] = ACTIONS(6650),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6650),
    [anon_sym_BSLASHglslink] = ACTIONS(6650),
    [anon_sym_BSLASHglstext] = ACTIONS(6650),
    [anon_sym_BSLASHGlstext] = ACTIONS(6650),
    [anon_sym_BSLASHGLStext] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6650),
    [anon_sym_BSLASHglsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsname] = ACTIONS(6650),
    [anon_sym_BSLASHGlsname] = ACTIONS(6650),
    [anon_sym_BSLASHGLSname] = ACTIONS(6650),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6650),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6650),
    [anon_sym_BSLASHacrshort] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6650),
    [anon_sym_BSLASHACRshort] = ACTIONS(6650),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrlong] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6650),
    [anon_sym_BSLASHACRlong] = ACTIONS(6650),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrfull] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6650),
    [anon_sym_BSLASHACRfull] = ACTIONS(6650),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHacs] = ACTIONS(6650),
    [anon_sym_BSLASHAcs] = ACTIONS(6650),
    [anon_sym_BSLASHacsp] = ACTIONS(6650),
    [anon_sym_BSLASHAcsp] = ACTIONS(6650),
    [anon_sym_BSLASHacl] = ACTIONS(6650),
    [anon_sym_BSLASHAcl] = ACTIONS(6650),
    [anon_sym_BSLASHaclp] = ACTIONS(6650),
    [anon_sym_BSLASHAclp] = ACTIONS(6650),
    [anon_sym_BSLASHacf] = ACTIONS(6650),
    [anon_sym_BSLASHAcf] = ACTIONS(6650),
    [anon_sym_BSLASHacfp] = ACTIONS(6650),
    [anon_sym_BSLASHAcfp] = ACTIONS(6650),
    [anon_sym_BSLASHac] = ACTIONS(6650),
    [anon_sym_BSLASHAc] = ACTIONS(6650),
    [anon_sym_BSLASHacp] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6650),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6650),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6650),
    [anon_sym_BSLASHcolor] = ACTIONS(6650),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6650),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6650),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6650),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6650),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6650),
    [anon_sym_BSLASHtext] = ACTIONS(6650),
    [anon_sym_BSLASHintertext] = ACTIONS(6650),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6650),
    [anon_sym_BSLASHurl] = ACTIONS(6650),
    [anon_sym_BSLASHhref] = ACTIONS(6650),
  },
  [623] = {
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_RBRACK] = ACTIONS(6656),
    [anon_sym_COMMA] = ACTIONS(6656),
    [anon_sym_EQ] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(6656),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHpart] = ACTIONS(6654),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddpart] = ACTIONS(6654),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHchapter] = ACTIONS(6654),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddchap] = ACTIONS(6654),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsection] = ACTIONS(6654),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddsec] = ACTIONS(6654),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHitem] = ACTIONS(6654),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6656),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6656),
    [anon_sym_DOLLAR] = ACTIONS(6654),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHbegin] = ACTIONS(6654),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHleft] = ACTIONS(6654),
    [anon_sym_BSLASHbigl] = ACTIONS(6654),
    [anon_sym_BSLASHBigl] = ACTIONS(6654),
    [anon_sym_BSLASHbiggl] = ACTIONS(6654),
    [anon_sym_BSLASHBiggl] = ACTIONS(6654),
    [anon_sym_BSLASHright] = ACTIONS(6654),
    [anon_sym_BSLASHbigr] = ACTIONS(6654),
    [anon_sym_BSLASHBigr] = ACTIONS(6654),
    [anon_sym_BSLASHbiggr] = ACTIONS(6654),
    [anon_sym_BSLASHBiggr] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHtext] = ACTIONS(6654),
    [anon_sym_BSLASHintertext] = ACTIONS(6654),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [624] = {
    [sym_command_name] = ACTIONS(6658),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6658),
    [anon_sym_LBRACK] = ACTIONS(6660),
    [anon_sym_RBRACK] = ACTIONS(6660),
    [anon_sym_COMMA] = ACTIONS(6660),
    [anon_sym_EQ] = ACTIONS(6660),
    [anon_sym_LPAREN] = ACTIONS(6660),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHpart] = ACTIONS(6658),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddpart] = ACTIONS(6658),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHchapter] = ACTIONS(6658),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddchap] = ACTIONS(6658),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsection] = ACTIONS(6658),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddsec] = ACTIONS(6658),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHitem] = ACTIONS(6658),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6660),
    [anon_sym_LBRACE] = ACTIONS(6660),
    [sym_word] = ACTIONS(6658),
    [sym_placeholder] = ACTIONS(6660),
    [anon_sym_PLUS] = ACTIONS(6660),
    [anon_sym_DASH] = ACTIONS(6660),
    [anon_sym_STAR] = ACTIONS(6660),
    [anon_sym_SLASH] = ACTIONS(6660),
    [anon_sym_LT] = ACTIONS(6658),
    [anon_sym_GT] = ACTIONS(6658),
    [anon_sym_BANG] = ACTIONS(6658),
    [anon_sym_PIPE] = ACTIONS(6658),
    [anon_sym_COLON] = ACTIONS(6658),
    [anon_sym_SQUOTE] = ACTIONS(6658),
    [anon_sym__] = ACTIONS(6660),
    [anon_sym_CARET] = ACTIONS(6660),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6660),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6660),
    [anon_sym_DOLLAR] = ACTIONS(6658),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHbegin] = ACTIONS(6658),
    [anon_sym_BSLASHtitle] = ACTIONS(6658),
    [anon_sym_BSLASHauthor] = ACTIONS(6658),
    [anon_sym_BSLASHusepackage] = ACTIONS(6658),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6658),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6658),
    [anon_sym_BSLASHinclude] = ACTIONS(6658),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6658),
    [anon_sym_BSLASHinput] = ACTIONS(6658),
    [anon_sym_BSLASHsubfile] = ACTIONS(6658),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6658),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6658),
    [anon_sym_BSLASHbibliography] = ACTIONS(6658),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6658),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6658),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6658),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6658),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6658),
    [anon_sym_BSLASHimport] = ACTIONS(6658),
    [anon_sym_BSLASHsubimport] = ACTIONS(6658),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6658),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHcaption] = ACTIONS(6658),
    [anon_sym_BSLASHcite] = ACTIONS(6658),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCite] = ACTIONS(6658),
    [anon_sym_BSLASHnocite] = ACTIONS(6658),
    [anon_sym_BSLASHcitet] = ACTIONS(6658),
    [anon_sym_BSLASHcitep] = ACTIONS(6658),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteA] = ACTIONS(6658),
    [anon_sym_BSLASHciteR] = ACTIONS(6658),
    [anon_sym_BSLASHciteS] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6658),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteyear] = ACTIONS(6658),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitedate] = ACTIONS(6658),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteurl] = ACTIONS(6658),
    [anon_sym_BSLASHfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6658),
    [anon_sym_BSLASHcitealt] = ACTIONS(6658),
    [anon_sym_BSLASHcitealp] = ACTIONS(6658),
    [anon_sym_BSLASHcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHparencite] = ACTIONS(6658),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHParencite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHtextcite] = ACTIONS(6658),
    [anon_sym_BSLASHTextcite] = ACTIONS(6658),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHsupercite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite] = ACTIONS(6658),
    [anon_sym_BSLASHAutocite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHVolcite] = ACTIONS(6658),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHavolcite] = ACTIONS(6658),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHNotecite] = ACTIONS(6658),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHlabel] = ACTIONS(6658),
    [anon_sym_BSLASHref] = ACTIONS(6658),
    [anon_sym_BSLASHeqref] = ACTIONS(6658),
    [anon_sym_BSLASHvref] = ACTIONS(6658),
    [anon_sym_BSLASHVref] = ACTIONS(6658),
    [anon_sym_BSLASHautoref] = ACTIONS(6658),
    [anon_sym_BSLASHpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcref] = ACTIONS(6658),
    [anon_sym_BSLASHCref] = ACTIONS(6658),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnameCref] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHdef] = ACTIONS(6658),
    [anon_sym_BSLASHlet] = ACTIONS(6658),
    [anon_sym_BSLASHleft] = ACTIONS(6658),
    [anon_sym_BSLASHbigl] = ACTIONS(6658),
    [anon_sym_BSLASHBigl] = ACTIONS(6658),
    [anon_sym_BSLASHbiggl] = ACTIONS(6658),
    [anon_sym_BSLASHBiggl] = ACTIONS(6658),
    [anon_sym_BSLASHright] = ACTIONS(6658),
    [anon_sym_BSLASHbigr] = ACTIONS(6658),
    [anon_sym_BSLASHBigr] = ACTIONS(6658),
    [anon_sym_BSLASHbiggr] = ACTIONS(6658),
    [anon_sym_BSLASHBiggr] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6658),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6658),
    [anon_sym_BSLASHgls] = ACTIONS(6658),
    [anon_sym_BSLASHGls] = ACTIONS(6658),
    [anon_sym_BSLASHGLS] = ACTIONS(6658),
    [anon_sym_BSLASHglspl] = ACTIONS(6658),
    [anon_sym_BSLASHGlspl] = ACTIONS(6658),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6658),
    [anon_sym_BSLASHglslink] = ACTIONS(6658),
    [anon_sym_BSLASHglstext] = ACTIONS(6658),
    [anon_sym_BSLASHGlstext] = ACTIONS(6658),
    [anon_sym_BSLASHGLStext] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6658),
    [anon_sym_BSLASHglsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsname] = ACTIONS(6658),
    [anon_sym_BSLASHGlsname] = ACTIONS(6658),
    [anon_sym_BSLASHGLSname] = ACTIONS(6658),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6658),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6658),
    [anon_sym_BSLASHacrshort] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6658),
    [anon_sym_BSLASHACRshort] = ACTIONS(6658),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrlong] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6658),
    [anon_sym_BSLASHACRlong] = ACTIONS(6658),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrfull] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6658),
    [anon_sym_BSLASHACRfull] = ACTIONS(6658),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHacs] = ACTIONS(6658),
    [anon_sym_BSLASHAcs] = ACTIONS(6658),
    [anon_sym_BSLASHacsp] = ACTIONS(6658),
    [anon_sym_BSLASHAcsp] = ACTIONS(6658),
    [anon_sym_BSLASHacl] = ACTIONS(6658),
    [anon_sym_BSLASHAcl] = ACTIONS(6658),
    [anon_sym_BSLASHaclp] = ACTIONS(6658),
    [anon_sym_BSLASHAclp] = ACTIONS(6658),
    [anon_sym_BSLASHacf] = ACTIONS(6658),
    [anon_sym_BSLASHAcf] = ACTIONS(6658),
    [anon_sym_BSLASHacfp] = ACTIONS(6658),
    [anon_sym_BSLASHAcfp] = ACTIONS(6658),
    [anon_sym_BSLASHac] = ACTIONS(6658),
    [anon_sym_BSLASHAc] = ACTIONS(6658),
    [anon_sym_BSLASHacp] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6658),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6658),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6658),
    [anon_sym_BSLASHcolor] = ACTIONS(6658),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6658),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6658),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6658),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6658),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6658),
    [anon_sym_BSLASHtext] = ACTIONS(6658),
    [anon_sym_BSLASHintertext] = ACTIONS(6658),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6658),
    [anon_sym_BSLASHurl] = ACTIONS(6658),
    [anon_sym_BSLASHhref] = ACTIONS(6658),
  },
  [625] = {
    [sym_command_name] = ACTIONS(6662),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6662),
    [anon_sym_LBRACK] = ACTIONS(6664),
    [anon_sym_RBRACK] = ACTIONS(6664),
    [anon_sym_COMMA] = ACTIONS(6664),
    [anon_sym_EQ] = ACTIONS(6664),
    [anon_sym_LPAREN] = ACTIONS(6664),
    [anon_sym_RPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHpart] = ACTIONS(6662),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddpart] = ACTIONS(6662),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHchapter] = ACTIONS(6662),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddchap] = ACTIONS(6662),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsection] = ACTIONS(6662),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddsec] = ACTIONS(6662),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHitem] = ACTIONS(6662),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6664),
    [anon_sym_LBRACE] = ACTIONS(6664),
    [sym_word] = ACTIONS(6662),
    [sym_placeholder] = ACTIONS(6664),
    [anon_sym_PLUS] = ACTIONS(6664),
    [anon_sym_DASH] = ACTIONS(6664),
    [anon_sym_STAR] = ACTIONS(6664),
    [anon_sym_SLASH] = ACTIONS(6664),
    [anon_sym_LT] = ACTIONS(6662),
    [anon_sym_GT] = ACTIONS(6662),
    [anon_sym_BANG] = ACTIONS(6662),
    [anon_sym_PIPE] = ACTIONS(6662),
    [anon_sym_COLON] = ACTIONS(6662),
    [anon_sym_SQUOTE] = ACTIONS(6662),
    [anon_sym__] = ACTIONS(6664),
    [anon_sym_CARET] = ACTIONS(6664),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6664),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6664),
    [anon_sym_DOLLAR] = ACTIONS(6662),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHbegin] = ACTIONS(6662),
    [anon_sym_BSLASHtitle] = ACTIONS(6662),
    [anon_sym_BSLASHauthor] = ACTIONS(6662),
    [anon_sym_BSLASHusepackage] = ACTIONS(6662),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6662),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6662),
    [anon_sym_BSLASHinclude] = ACTIONS(6662),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6662),
    [anon_sym_BSLASHinput] = ACTIONS(6662),
    [anon_sym_BSLASHsubfile] = ACTIONS(6662),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6662),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6662),
    [anon_sym_BSLASHbibliography] = ACTIONS(6662),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6662),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6662),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6662),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6662),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6662),
    [anon_sym_BSLASHimport] = ACTIONS(6662),
    [anon_sym_BSLASHsubimport] = ACTIONS(6662),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6662),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHcaption] = ACTIONS(6662),
    [anon_sym_BSLASHcite] = ACTIONS(6662),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCite] = ACTIONS(6662),
    [anon_sym_BSLASHnocite] = ACTIONS(6662),
    [anon_sym_BSLASHcitet] = ACTIONS(6662),
    [anon_sym_BSLASHcitep] = ACTIONS(6662),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteA] = ACTIONS(6662),
    [anon_sym_BSLASHciteR] = ACTIONS(6662),
    [anon_sym_BSLASHciteS] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6662),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteyear] = ACTIONS(6662),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitedate] = ACTIONS(6662),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteurl] = ACTIONS(6662),
    [anon_sym_BSLASHfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6662),
    [anon_sym_BSLASHcitealt] = ACTIONS(6662),
    [anon_sym_BSLASHcitealp] = ACTIONS(6662),
    [anon_sym_BSLASHcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHparencite] = ACTIONS(6662),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHParencite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHtextcite] = ACTIONS(6662),
    [anon_sym_BSLASHTextcite] = ACTIONS(6662),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHsupercite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite] = ACTIONS(6662),
    [anon_sym_BSLASHAutocite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHVolcite] = ACTIONS(6662),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHavolcite] = ACTIONS(6662),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHNotecite] = ACTIONS(6662),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHlabel] = ACTIONS(6662),
    [anon_sym_BSLASHref] = ACTIONS(6662),
    [anon_sym_BSLASHeqref] = ACTIONS(6662),
    [anon_sym_BSLASHvref] = ACTIONS(6662),
    [anon_sym_BSLASHVref] = ACTIONS(6662),
    [anon_sym_BSLASHautoref] = ACTIONS(6662),
    [anon_sym_BSLASHpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcref] = ACTIONS(6662),
    [anon_sym_BSLASHCref] = ACTIONS(6662),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnameCref] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHdef] = ACTIONS(6662),
    [anon_sym_BSLASHlet] = ACTIONS(6662),
    [anon_sym_BSLASHleft] = ACTIONS(6662),
    [anon_sym_BSLASHbigl] = ACTIONS(6662),
    [anon_sym_BSLASHBigl] = ACTIONS(6662),
    [anon_sym_BSLASHbiggl] = ACTIONS(6662),
    [anon_sym_BSLASHBiggl] = ACTIONS(6662),
    [anon_sym_BSLASHright] = ACTIONS(6662),
    [anon_sym_BSLASHbigr] = ACTIONS(6662),
    [anon_sym_BSLASHBigr] = ACTIONS(6662),
    [anon_sym_BSLASHbiggr] = ACTIONS(6662),
    [anon_sym_BSLASHBiggr] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6662),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6662),
    [anon_sym_BSLASHgls] = ACTIONS(6662),
    [anon_sym_BSLASHGls] = ACTIONS(6662),
    [anon_sym_BSLASHGLS] = ACTIONS(6662),
    [anon_sym_BSLASHglspl] = ACTIONS(6662),
    [anon_sym_BSLASHGlspl] = ACTIONS(6662),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6662),
    [anon_sym_BSLASHglslink] = ACTIONS(6662),
    [anon_sym_BSLASHglstext] = ACTIONS(6662),
    [anon_sym_BSLASHGlstext] = ACTIONS(6662),
    [anon_sym_BSLASHGLStext] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6662),
    [anon_sym_BSLASHglsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsname] = ACTIONS(6662),
    [anon_sym_BSLASHGlsname] = ACTIONS(6662),
    [anon_sym_BSLASHGLSname] = ACTIONS(6662),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6662),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6662),
    [anon_sym_BSLASHacrshort] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6662),
    [anon_sym_BSLASHACRshort] = ACTIONS(6662),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrlong] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6662),
    [anon_sym_BSLASHACRlong] = ACTIONS(6662),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrfull] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6662),
    [anon_sym_BSLASHACRfull] = ACTIONS(6662),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHacs] = ACTIONS(6662),
    [anon_sym_BSLASHAcs] = ACTIONS(6662),
    [anon_sym_BSLASHacsp] = ACTIONS(6662),
    [anon_sym_BSLASHAcsp] = ACTIONS(6662),
    [anon_sym_BSLASHacl] = ACTIONS(6662),
    [anon_sym_BSLASHAcl] = ACTIONS(6662),
    [anon_sym_BSLASHaclp] = ACTIONS(6662),
    [anon_sym_BSLASHAclp] = ACTIONS(6662),
    [anon_sym_BSLASHacf] = ACTIONS(6662),
    [anon_sym_BSLASHAcf] = ACTIONS(6662),
    [anon_sym_BSLASHacfp] = ACTIONS(6662),
    [anon_sym_BSLASHAcfp] = ACTIONS(6662),
    [anon_sym_BSLASHac] = ACTIONS(6662),
    [anon_sym_BSLASHAc] = ACTIONS(6662),
    [anon_sym_BSLASHacp] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6662),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6662),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6662),
    [anon_sym_BSLASHcolor] = ACTIONS(6662),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6662),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6662),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6662),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6662),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6662),
    [anon_sym_BSLASHtext] = ACTIONS(6662),
    [anon_sym_BSLASHintertext] = ACTIONS(6662),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6662),
    [anon_sym_BSLASHurl] = ACTIONS(6662),
    [anon_sym_BSLASHhref] = ACTIONS(6662),
  },
  [626] = {
    [sym_command_name] = ACTIONS(6666),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6666),
    [anon_sym_LBRACK] = ACTIONS(6668),
    [anon_sym_RBRACK] = ACTIONS(6668),
    [anon_sym_COMMA] = ACTIONS(6668),
    [anon_sym_EQ] = ACTIONS(6668),
    [anon_sym_LPAREN] = ACTIONS(6668),
    [anon_sym_RPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHpart] = ACTIONS(6666),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddpart] = ACTIONS(6666),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHchapter] = ACTIONS(6666),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddchap] = ACTIONS(6666),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsection] = ACTIONS(6666),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddsec] = ACTIONS(6666),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHitem] = ACTIONS(6666),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6668),
    [anon_sym_LBRACE] = ACTIONS(6668),
    [sym_word] = ACTIONS(6666),
    [sym_placeholder] = ACTIONS(6668),
    [anon_sym_PLUS] = ACTIONS(6668),
    [anon_sym_DASH] = ACTIONS(6668),
    [anon_sym_STAR] = ACTIONS(6668),
    [anon_sym_SLASH] = ACTIONS(6668),
    [anon_sym_LT] = ACTIONS(6666),
    [anon_sym_GT] = ACTIONS(6666),
    [anon_sym_BANG] = ACTIONS(6666),
    [anon_sym_PIPE] = ACTIONS(6666),
    [anon_sym_COLON] = ACTIONS(6666),
    [anon_sym_SQUOTE] = ACTIONS(6666),
    [anon_sym__] = ACTIONS(6668),
    [anon_sym_CARET] = ACTIONS(6668),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6668),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6668),
    [anon_sym_DOLLAR] = ACTIONS(6666),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHbegin] = ACTIONS(6666),
    [anon_sym_BSLASHtitle] = ACTIONS(6666),
    [anon_sym_BSLASHauthor] = ACTIONS(6666),
    [anon_sym_BSLASHusepackage] = ACTIONS(6666),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6666),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6666),
    [anon_sym_BSLASHinclude] = ACTIONS(6666),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6666),
    [anon_sym_BSLASHinput] = ACTIONS(6666),
    [anon_sym_BSLASHsubfile] = ACTIONS(6666),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6666),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6666),
    [anon_sym_BSLASHbibliography] = ACTIONS(6666),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6666),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6666),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6666),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6666),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6666),
    [anon_sym_BSLASHimport] = ACTIONS(6666),
    [anon_sym_BSLASHsubimport] = ACTIONS(6666),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6666),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHcaption] = ACTIONS(6666),
    [anon_sym_BSLASHcite] = ACTIONS(6666),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCite] = ACTIONS(6666),
    [anon_sym_BSLASHnocite] = ACTIONS(6666),
    [anon_sym_BSLASHcitet] = ACTIONS(6666),
    [anon_sym_BSLASHcitep] = ACTIONS(6666),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteA] = ACTIONS(6666),
    [anon_sym_BSLASHciteR] = ACTIONS(6666),
    [anon_sym_BSLASHciteS] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6666),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteyear] = ACTIONS(6666),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitedate] = ACTIONS(6666),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteurl] = ACTIONS(6666),
    [anon_sym_BSLASHfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6666),
    [anon_sym_BSLASHcitealt] = ACTIONS(6666),
    [anon_sym_BSLASHcitealp] = ACTIONS(6666),
    [anon_sym_BSLASHcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHparencite] = ACTIONS(6666),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHParencite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHtextcite] = ACTIONS(6666),
    [anon_sym_BSLASHTextcite] = ACTIONS(6666),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHsupercite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite] = ACTIONS(6666),
    [anon_sym_BSLASHAutocite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHVolcite] = ACTIONS(6666),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHavolcite] = ACTIONS(6666),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHNotecite] = ACTIONS(6666),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHlabel] = ACTIONS(6666),
    [anon_sym_BSLASHref] = ACTIONS(6666),
    [anon_sym_BSLASHeqref] = ACTIONS(6666),
    [anon_sym_BSLASHvref] = ACTIONS(6666),
    [anon_sym_BSLASHVref] = ACTIONS(6666),
    [anon_sym_BSLASHautoref] = ACTIONS(6666),
    [anon_sym_BSLASHpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcref] = ACTIONS(6666),
    [anon_sym_BSLASHCref] = ACTIONS(6666),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnameCref] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHdef] = ACTIONS(6666),
    [anon_sym_BSLASHlet] = ACTIONS(6666),
    [anon_sym_BSLASHleft] = ACTIONS(6666),
    [anon_sym_BSLASHbigl] = ACTIONS(6666),
    [anon_sym_BSLASHBigl] = ACTIONS(6666),
    [anon_sym_BSLASHbiggl] = ACTIONS(6666),
    [anon_sym_BSLASHBiggl] = ACTIONS(6666),
    [anon_sym_BSLASHright] = ACTIONS(6666),
    [anon_sym_BSLASHbigr] = ACTIONS(6666),
    [anon_sym_BSLASHBigr] = ACTIONS(6666),
    [anon_sym_BSLASHbiggr] = ACTIONS(6666),
    [anon_sym_BSLASHBiggr] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6666),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6666),
    [anon_sym_BSLASHgls] = ACTIONS(6666),
    [anon_sym_BSLASHGls] = ACTIONS(6666),
    [anon_sym_BSLASHGLS] = ACTIONS(6666),
    [anon_sym_BSLASHglspl] = ACTIONS(6666),
    [anon_sym_BSLASHGlspl] = ACTIONS(6666),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6666),
    [anon_sym_BSLASHglslink] = ACTIONS(6666),
    [anon_sym_BSLASHglstext] = ACTIONS(6666),
    [anon_sym_BSLASHGlstext] = ACTIONS(6666),
    [anon_sym_BSLASHGLStext] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6666),
    [anon_sym_BSLASHglsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsname] = ACTIONS(6666),
    [anon_sym_BSLASHGlsname] = ACTIONS(6666),
    [anon_sym_BSLASHGLSname] = ACTIONS(6666),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6666),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6666),
    [anon_sym_BSLASHacrshort] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6666),
    [anon_sym_BSLASHACRshort] = ACTIONS(6666),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrlong] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6666),
    [anon_sym_BSLASHACRlong] = ACTIONS(6666),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrfull] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6666),
    [anon_sym_BSLASHACRfull] = ACTIONS(6666),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHacs] = ACTIONS(6666),
    [anon_sym_BSLASHAcs] = ACTIONS(6666),
    [anon_sym_BSLASHacsp] = ACTIONS(6666),
    [anon_sym_BSLASHAcsp] = ACTIONS(6666),
    [anon_sym_BSLASHacl] = ACTIONS(6666),
    [anon_sym_BSLASHAcl] = ACTIONS(6666),
    [anon_sym_BSLASHaclp] = ACTIONS(6666),
    [anon_sym_BSLASHAclp] = ACTIONS(6666),
    [anon_sym_BSLASHacf] = ACTIONS(6666),
    [anon_sym_BSLASHAcf] = ACTIONS(6666),
    [anon_sym_BSLASHacfp] = ACTIONS(6666),
    [anon_sym_BSLASHAcfp] = ACTIONS(6666),
    [anon_sym_BSLASHac] = ACTIONS(6666),
    [anon_sym_BSLASHAc] = ACTIONS(6666),
    [anon_sym_BSLASHacp] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6666),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6666),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6666),
    [anon_sym_BSLASHcolor] = ACTIONS(6666),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6666),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6666),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6666),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6666),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6666),
    [anon_sym_BSLASHtext] = ACTIONS(6666),
    [anon_sym_BSLASHintertext] = ACTIONS(6666),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6666),
    [anon_sym_BSLASHurl] = ACTIONS(6666),
    [anon_sym_BSLASHhref] = ACTIONS(6666),
  },
  [627] = {
    [sym_command_name] = ACTIONS(6670),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6670),
    [anon_sym_LBRACK] = ACTIONS(6672),
    [anon_sym_RBRACK] = ACTIONS(6672),
    [anon_sym_COMMA] = ACTIONS(6672),
    [anon_sym_EQ] = ACTIONS(6672),
    [anon_sym_LPAREN] = ACTIONS(6672),
    [anon_sym_RPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHpart] = ACTIONS(6670),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddpart] = ACTIONS(6670),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHchapter] = ACTIONS(6670),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddchap] = ACTIONS(6670),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsection] = ACTIONS(6670),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddsec] = ACTIONS(6670),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHitem] = ACTIONS(6670),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6672),
    [anon_sym_LBRACE] = ACTIONS(6672),
    [sym_word] = ACTIONS(6670),
    [sym_placeholder] = ACTIONS(6672),
    [anon_sym_PLUS] = ACTIONS(6672),
    [anon_sym_DASH] = ACTIONS(6672),
    [anon_sym_STAR] = ACTIONS(6672),
    [anon_sym_SLASH] = ACTIONS(6672),
    [anon_sym_LT] = ACTIONS(6670),
    [anon_sym_GT] = ACTIONS(6670),
    [anon_sym_BANG] = ACTIONS(6670),
    [anon_sym_PIPE] = ACTIONS(6670),
    [anon_sym_COLON] = ACTIONS(6670),
    [anon_sym_SQUOTE] = ACTIONS(6670),
    [anon_sym__] = ACTIONS(6672),
    [anon_sym_CARET] = ACTIONS(6672),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6672),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6672),
    [anon_sym_DOLLAR] = ACTIONS(6670),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHbegin] = ACTIONS(6670),
    [anon_sym_BSLASHtitle] = ACTIONS(6670),
    [anon_sym_BSLASHauthor] = ACTIONS(6670),
    [anon_sym_BSLASHusepackage] = ACTIONS(6670),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6670),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6670),
    [anon_sym_BSLASHinclude] = ACTIONS(6670),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6670),
    [anon_sym_BSLASHinput] = ACTIONS(6670),
    [anon_sym_BSLASHsubfile] = ACTIONS(6670),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6670),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6670),
    [anon_sym_BSLASHbibliography] = ACTIONS(6670),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6670),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6670),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6670),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6670),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6670),
    [anon_sym_BSLASHimport] = ACTIONS(6670),
    [anon_sym_BSLASHsubimport] = ACTIONS(6670),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6670),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHcaption] = ACTIONS(6670),
    [anon_sym_BSLASHcite] = ACTIONS(6670),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCite] = ACTIONS(6670),
    [anon_sym_BSLASHnocite] = ACTIONS(6670),
    [anon_sym_BSLASHcitet] = ACTIONS(6670),
    [anon_sym_BSLASHcitep] = ACTIONS(6670),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteA] = ACTIONS(6670),
    [anon_sym_BSLASHciteR] = ACTIONS(6670),
    [anon_sym_BSLASHciteS] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6670),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteyear] = ACTIONS(6670),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitedate] = ACTIONS(6670),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteurl] = ACTIONS(6670),
    [anon_sym_BSLASHfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6670),
    [anon_sym_BSLASHcitealt] = ACTIONS(6670),
    [anon_sym_BSLASHcitealp] = ACTIONS(6670),
    [anon_sym_BSLASHcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHparencite] = ACTIONS(6670),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHParencite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHtextcite] = ACTIONS(6670),
    [anon_sym_BSLASHTextcite] = ACTIONS(6670),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHsupercite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite] = ACTIONS(6670),
    [anon_sym_BSLASHAutocite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHVolcite] = ACTIONS(6670),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHavolcite] = ACTIONS(6670),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHNotecite] = ACTIONS(6670),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHlabel] = ACTIONS(6670),
    [anon_sym_BSLASHref] = ACTIONS(6670),
    [anon_sym_BSLASHeqref] = ACTIONS(6670),
    [anon_sym_BSLASHvref] = ACTIONS(6670),
    [anon_sym_BSLASHVref] = ACTIONS(6670),
    [anon_sym_BSLASHautoref] = ACTIONS(6670),
    [anon_sym_BSLASHpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcref] = ACTIONS(6670),
    [anon_sym_BSLASHCref] = ACTIONS(6670),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnameCref] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHdef] = ACTIONS(6670),
    [anon_sym_BSLASHlet] = ACTIONS(6670),
    [anon_sym_BSLASHleft] = ACTIONS(6670),
    [anon_sym_BSLASHbigl] = ACTIONS(6670),
    [anon_sym_BSLASHBigl] = ACTIONS(6670),
    [anon_sym_BSLASHbiggl] = ACTIONS(6670),
    [anon_sym_BSLASHBiggl] = ACTIONS(6670),
    [anon_sym_BSLASHright] = ACTIONS(6670),
    [anon_sym_BSLASHbigr] = ACTIONS(6670),
    [anon_sym_BSLASHBigr] = ACTIONS(6670),
    [anon_sym_BSLASHbiggr] = ACTIONS(6670),
    [anon_sym_BSLASHBiggr] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6670),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6670),
    [anon_sym_BSLASHgls] = ACTIONS(6670),
    [anon_sym_BSLASHGls] = ACTIONS(6670),
    [anon_sym_BSLASHGLS] = ACTIONS(6670),
    [anon_sym_BSLASHglspl] = ACTIONS(6670),
    [anon_sym_BSLASHGlspl] = ACTIONS(6670),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6670),
    [anon_sym_BSLASHglslink] = ACTIONS(6670),
    [anon_sym_BSLASHglstext] = ACTIONS(6670),
    [anon_sym_BSLASHGlstext] = ACTIONS(6670),
    [anon_sym_BSLASHGLStext] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6670),
    [anon_sym_BSLASHglsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsname] = ACTIONS(6670),
    [anon_sym_BSLASHGlsname] = ACTIONS(6670),
    [anon_sym_BSLASHGLSname] = ACTIONS(6670),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6670),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6670),
    [anon_sym_BSLASHacrshort] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6670),
    [anon_sym_BSLASHACRshort] = ACTIONS(6670),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrlong] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6670),
    [anon_sym_BSLASHACRlong] = ACTIONS(6670),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrfull] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6670),
    [anon_sym_BSLASHACRfull] = ACTIONS(6670),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHacs] = ACTIONS(6670),
    [anon_sym_BSLASHAcs] = ACTIONS(6670),
    [anon_sym_BSLASHacsp] = ACTIONS(6670),
    [anon_sym_BSLASHAcsp] = ACTIONS(6670),
    [anon_sym_BSLASHacl] = ACTIONS(6670),
    [anon_sym_BSLASHAcl] = ACTIONS(6670),
    [anon_sym_BSLASHaclp] = ACTIONS(6670),
    [anon_sym_BSLASHAclp] = ACTIONS(6670),
    [anon_sym_BSLASHacf] = ACTIONS(6670),
    [anon_sym_BSLASHAcf] = ACTIONS(6670),
    [anon_sym_BSLASHacfp] = ACTIONS(6670),
    [anon_sym_BSLASHAcfp] = ACTIONS(6670),
    [anon_sym_BSLASHac] = ACTIONS(6670),
    [anon_sym_BSLASHAc] = ACTIONS(6670),
    [anon_sym_BSLASHacp] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6670),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6670),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6670),
    [anon_sym_BSLASHcolor] = ACTIONS(6670),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6670),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6670),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6670),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6670),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6670),
    [anon_sym_BSLASHtext] = ACTIONS(6670),
    [anon_sym_BSLASHintertext] = ACTIONS(6670),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6670),
    [anon_sym_BSLASHurl] = ACTIONS(6670),
    [anon_sym_BSLASHhref] = ACTIONS(6670),
  },
  [628] = {
    [sym_command_name] = ACTIONS(6674),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6674),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_RBRACK] = ACTIONS(6676),
    [anon_sym_COMMA] = ACTIONS(6676),
    [anon_sym_EQ] = ACTIONS(6676),
    [anon_sym_LPAREN] = ACTIONS(6676),
    [anon_sym_RPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHpart] = ACTIONS(6674),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddpart] = ACTIONS(6674),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHchapter] = ACTIONS(6674),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddchap] = ACTIONS(6674),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsection] = ACTIONS(6674),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddsec] = ACTIONS(6674),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHitem] = ACTIONS(6674),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(6676),
    [sym_word] = ACTIONS(6674),
    [sym_placeholder] = ACTIONS(6676),
    [anon_sym_PLUS] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6676),
    [anon_sym_STAR] = ACTIONS(6676),
    [anon_sym_SLASH] = ACTIONS(6676),
    [anon_sym_LT] = ACTIONS(6674),
    [anon_sym_GT] = ACTIONS(6674),
    [anon_sym_BANG] = ACTIONS(6674),
    [anon_sym_PIPE] = ACTIONS(6674),
    [anon_sym_COLON] = ACTIONS(6674),
    [anon_sym_SQUOTE] = ACTIONS(6674),
    [anon_sym__] = ACTIONS(6676),
    [anon_sym_CARET] = ACTIONS(6676),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6676),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6676),
    [anon_sym_DOLLAR] = ACTIONS(6674),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHbegin] = ACTIONS(6674),
    [anon_sym_BSLASHtitle] = ACTIONS(6674),
    [anon_sym_BSLASHauthor] = ACTIONS(6674),
    [anon_sym_BSLASHusepackage] = ACTIONS(6674),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6674),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6674),
    [anon_sym_BSLASHinclude] = ACTIONS(6674),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6674),
    [anon_sym_BSLASHinput] = ACTIONS(6674),
    [anon_sym_BSLASHsubfile] = ACTIONS(6674),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6674),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6674),
    [anon_sym_BSLASHbibliography] = ACTIONS(6674),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6674),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6674),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6674),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6674),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6674),
    [anon_sym_BSLASHimport] = ACTIONS(6674),
    [anon_sym_BSLASHsubimport] = ACTIONS(6674),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6674),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHcaption] = ACTIONS(6674),
    [anon_sym_BSLASHcite] = ACTIONS(6674),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCite] = ACTIONS(6674),
    [anon_sym_BSLASHnocite] = ACTIONS(6674),
    [anon_sym_BSLASHcitet] = ACTIONS(6674),
    [anon_sym_BSLASHcitep] = ACTIONS(6674),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteA] = ACTIONS(6674),
    [anon_sym_BSLASHciteR] = ACTIONS(6674),
    [anon_sym_BSLASHciteS] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6674),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteyear] = ACTIONS(6674),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitedate] = ACTIONS(6674),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteurl] = ACTIONS(6674),
    [anon_sym_BSLASHfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6674),
    [anon_sym_BSLASHcitealt] = ACTIONS(6674),
    [anon_sym_BSLASHcitealp] = ACTIONS(6674),
    [anon_sym_BSLASHcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHparencite] = ACTIONS(6674),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHParencite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHtextcite] = ACTIONS(6674),
    [anon_sym_BSLASHTextcite] = ACTIONS(6674),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHsupercite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite] = ACTIONS(6674),
    [anon_sym_BSLASHAutocite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHVolcite] = ACTIONS(6674),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHavolcite] = ACTIONS(6674),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHNotecite] = ACTIONS(6674),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHlabel] = ACTIONS(6674),
    [anon_sym_BSLASHref] = ACTIONS(6674),
    [anon_sym_BSLASHeqref] = ACTIONS(6674),
    [anon_sym_BSLASHvref] = ACTIONS(6674),
    [anon_sym_BSLASHVref] = ACTIONS(6674),
    [anon_sym_BSLASHautoref] = ACTIONS(6674),
    [anon_sym_BSLASHpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcref] = ACTIONS(6674),
    [anon_sym_BSLASHCref] = ACTIONS(6674),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnameCref] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHdef] = ACTIONS(6674),
    [anon_sym_BSLASHlet] = ACTIONS(6674),
    [anon_sym_BSLASHleft] = ACTIONS(6674),
    [anon_sym_BSLASHbigl] = ACTIONS(6674),
    [anon_sym_BSLASHBigl] = ACTIONS(6674),
    [anon_sym_BSLASHbiggl] = ACTIONS(6674),
    [anon_sym_BSLASHBiggl] = ACTIONS(6674),
    [anon_sym_BSLASHright] = ACTIONS(6674),
    [anon_sym_BSLASHbigr] = ACTIONS(6674),
    [anon_sym_BSLASHBigr] = ACTIONS(6674),
    [anon_sym_BSLASHbiggr] = ACTIONS(6674),
    [anon_sym_BSLASHBiggr] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6674),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6674),
    [anon_sym_BSLASHgls] = ACTIONS(6674),
    [anon_sym_BSLASHGls] = ACTIONS(6674),
    [anon_sym_BSLASHGLS] = ACTIONS(6674),
    [anon_sym_BSLASHglspl] = ACTIONS(6674),
    [anon_sym_BSLASHGlspl] = ACTIONS(6674),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6674),
    [anon_sym_BSLASHglslink] = ACTIONS(6674),
    [anon_sym_BSLASHglstext] = ACTIONS(6674),
    [anon_sym_BSLASHGlstext] = ACTIONS(6674),
    [anon_sym_BSLASHGLStext] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6674),
    [anon_sym_BSLASHglsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsname] = ACTIONS(6674),
    [anon_sym_BSLASHGlsname] = ACTIONS(6674),
    [anon_sym_BSLASHGLSname] = ACTIONS(6674),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6674),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6674),
    [anon_sym_BSLASHacrshort] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6674),
    [anon_sym_BSLASHACRshort] = ACTIONS(6674),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrlong] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6674),
    [anon_sym_BSLASHACRlong] = ACTIONS(6674),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrfull] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6674),
    [anon_sym_BSLASHACRfull] = ACTIONS(6674),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHacs] = ACTIONS(6674),
    [anon_sym_BSLASHAcs] = ACTIONS(6674),
    [anon_sym_BSLASHacsp] = ACTIONS(6674),
    [anon_sym_BSLASHAcsp] = ACTIONS(6674),
    [anon_sym_BSLASHacl] = ACTIONS(6674),
    [anon_sym_BSLASHAcl] = ACTIONS(6674),
    [anon_sym_BSLASHaclp] = ACTIONS(6674),
    [anon_sym_BSLASHAclp] = ACTIONS(6674),
    [anon_sym_BSLASHacf] = ACTIONS(6674),
    [anon_sym_BSLASHAcf] = ACTIONS(6674),
    [anon_sym_BSLASHacfp] = ACTIONS(6674),
    [anon_sym_BSLASHAcfp] = ACTIONS(6674),
    [anon_sym_BSLASHac] = ACTIONS(6674),
    [anon_sym_BSLASHAc] = ACTIONS(6674),
    [anon_sym_BSLASHacp] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6674),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6674),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6674),
    [anon_sym_BSLASHcolor] = ACTIONS(6674),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6674),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6674),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6674),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6674),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6674),
    [anon_sym_BSLASHtext] = ACTIONS(6674),
    [anon_sym_BSLASHintertext] = ACTIONS(6674),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6674),
    [anon_sym_BSLASHurl] = ACTIONS(6674),
    [anon_sym_BSLASHhref] = ACTIONS(6674),
  },
  [629] = {
    [sym_command_name] = ACTIONS(6678),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6678),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6680),
    [anon_sym_COMMA] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LPAREN] = ACTIONS(6680),
    [anon_sym_RPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHpart] = ACTIONS(6678),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddpart] = ACTIONS(6678),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHchapter] = ACTIONS(6678),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddchap] = ACTIONS(6678),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsection] = ACTIONS(6678),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddsec] = ACTIONS(6678),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHitem] = ACTIONS(6678),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6680),
    [anon_sym_LBRACE] = ACTIONS(6680),
    [sym_word] = ACTIONS(6678),
    [sym_placeholder] = ACTIONS(6680),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_DASH] = ACTIONS(6680),
    [anon_sym_STAR] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6678),
    [anon_sym_GT] = ACTIONS(6678),
    [anon_sym_BANG] = ACTIONS(6678),
    [anon_sym_PIPE] = ACTIONS(6678),
    [anon_sym_COLON] = ACTIONS(6678),
    [anon_sym_SQUOTE] = ACTIONS(6678),
    [anon_sym__] = ACTIONS(6680),
    [anon_sym_CARET] = ACTIONS(6680),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6680),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6680),
    [anon_sym_DOLLAR] = ACTIONS(6678),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHbegin] = ACTIONS(6678),
    [anon_sym_BSLASHtitle] = ACTIONS(6678),
    [anon_sym_BSLASHauthor] = ACTIONS(6678),
    [anon_sym_BSLASHusepackage] = ACTIONS(6678),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6678),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6678),
    [anon_sym_BSLASHinclude] = ACTIONS(6678),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6678),
    [anon_sym_BSLASHinput] = ACTIONS(6678),
    [anon_sym_BSLASHsubfile] = ACTIONS(6678),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6678),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6678),
    [anon_sym_BSLASHbibliography] = ACTIONS(6678),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6678),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6678),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6678),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6678),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6678),
    [anon_sym_BSLASHimport] = ACTIONS(6678),
    [anon_sym_BSLASHsubimport] = ACTIONS(6678),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6678),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHcaption] = ACTIONS(6678),
    [anon_sym_BSLASHcite] = ACTIONS(6678),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCite] = ACTIONS(6678),
    [anon_sym_BSLASHnocite] = ACTIONS(6678),
    [anon_sym_BSLASHcitet] = ACTIONS(6678),
    [anon_sym_BSLASHcitep] = ACTIONS(6678),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteA] = ACTIONS(6678),
    [anon_sym_BSLASHciteR] = ACTIONS(6678),
    [anon_sym_BSLASHciteS] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6678),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteyear] = ACTIONS(6678),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitedate] = ACTIONS(6678),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteurl] = ACTIONS(6678),
    [anon_sym_BSLASHfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6678),
    [anon_sym_BSLASHcitealt] = ACTIONS(6678),
    [anon_sym_BSLASHcitealp] = ACTIONS(6678),
    [anon_sym_BSLASHcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHparencite] = ACTIONS(6678),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHParencite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHtextcite] = ACTIONS(6678),
    [anon_sym_BSLASHTextcite] = ACTIONS(6678),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHsupercite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite] = ACTIONS(6678),
    [anon_sym_BSLASHAutocite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHVolcite] = ACTIONS(6678),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHavolcite] = ACTIONS(6678),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHNotecite] = ACTIONS(6678),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHlabel] = ACTIONS(6678),
    [anon_sym_BSLASHref] = ACTIONS(6678),
    [anon_sym_BSLASHeqref] = ACTIONS(6678),
    [anon_sym_BSLASHvref] = ACTIONS(6678),
    [anon_sym_BSLASHVref] = ACTIONS(6678),
    [anon_sym_BSLASHautoref] = ACTIONS(6678),
    [anon_sym_BSLASHpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcref] = ACTIONS(6678),
    [anon_sym_BSLASHCref] = ACTIONS(6678),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnameCref] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHdef] = ACTIONS(6678),
    [anon_sym_BSLASHlet] = ACTIONS(6678),
    [anon_sym_BSLASHleft] = ACTIONS(6678),
    [anon_sym_BSLASHbigl] = ACTIONS(6678),
    [anon_sym_BSLASHBigl] = ACTIONS(6678),
    [anon_sym_BSLASHbiggl] = ACTIONS(6678),
    [anon_sym_BSLASHBiggl] = ACTIONS(6678),
    [anon_sym_BSLASHright] = ACTIONS(6678),
    [anon_sym_BSLASHbigr] = ACTIONS(6678),
    [anon_sym_BSLASHBigr] = ACTIONS(6678),
    [anon_sym_BSLASHbiggr] = ACTIONS(6678),
    [anon_sym_BSLASHBiggr] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6678),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6678),
    [anon_sym_BSLASHgls] = ACTIONS(6678),
    [anon_sym_BSLASHGls] = ACTIONS(6678),
    [anon_sym_BSLASHGLS] = ACTIONS(6678),
    [anon_sym_BSLASHglspl] = ACTIONS(6678),
    [anon_sym_BSLASHGlspl] = ACTIONS(6678),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6678),
    [anon_sym_BSLASHglslink] = ACTIONS(6678),
    [anon_sym_BSLASHglstext] = ACTIONS(6678),
    [anon_sym_BSLASHGlstext] = ACTIONS(6678),
    [anon_sym_BSLASHGLStext] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6678),
    [anon_sym_BSLASHglsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsname] = ACTIONS(6678),
    [anon_sym_BSLASHGlsname] = ACTIONS(6678),
    [anon_sym_BSLASHGLSname] = ACTIONS(6678),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6678),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6678),
    [anon_sym_BSLASHacrshort] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6678),
    [anon_sym_BSLASHACRshort] = ACTIONS(6678),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrlong] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6678),
    [anon_sym_BSLASHACRlong] = ACTIONS(6678),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrfull] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6678),
    [anon_sym_BSLASHACRfull] = ACTIONS(6678),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHacs] = ACTIONS(6678),
    [anon_sym_BSLASHAcs] = ACTIONS(6678),
    [anon_sym_BSLASHacsp] = ACTIONS(6678),
    [anon_sym_BSLASHAcsp] = ACTIONS(6678),
    [anon_sym_BSLASHacl] = ACTIONS(6678),
    [anon_sym_BSLASHAcl] = ACTIONS(6678),
    [anon_sym_BSLASHaclp] = ACTIONS(6678),
    [anon_sym_BSLASHAclp] = ACTIONS(6678),
    [anon_sym_BSLASHacf] = ACTIONS(6678),
    [anon_sym_BSLASHAcf] = ACTIONS(6678),
    [anon_sym_BSLASHacfp] = ACTIONS(6678),
    [anon_sym_BSLASHAcfp] = ACTIONS(6678),
    [anon_sym_BSLASHac] = ACTIONS(6678),
    [anon_sym_BSLASHAc] = ACTIONS(6678),
    [anon_sym_BSLASHacp] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6678),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6678),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6678),
    [anon_sym_BSLASHcolor] = ACTIONS(6678),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6678),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6678),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6678),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6678),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6678),
    [anon_sym_BSLASHtext] = ACTIONS(6678),
    [anon_sym_BSLASHintertext] = ACTIONS(6678),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6678),
    [anon_sym_BSLASHurl] = ACTIONS(6678),
    [anon_sym_BSLASHhref] = ACTIONS(6678),
  },
  [630] = {
    [sym_command_name] = ACTIONS(6682),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6684),
    [anon_sym_RBRACK] = ACTIONS(6684),
    [anon_sym_COMMA] = ACTIONS(6684),
    [anon_sym_EQ] = ACTIONS(6684),
    [anon_sym_LPAREN] = ACTIONS(6684),
    [anon_sym_RPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHpart] = ACTIONS(6682),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddpart] = ACTIONS(6682),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHchapter] = ACTIONS(6682),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddchap] = ACTIONS(6682),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsection] = ACTIONS(6682),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddsec] = ACTIONS(6682),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHitem] = ACTIONS(6682),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6684),
    [anon_sym_LBRACE] = ACTIONS(6684),
    [sym_word] = ACTIONS(6682),
    [sym_placeholder] = ACTIONS(6684),
    [anon_sym_PLUS] = ACTIONS(6684),
    [anon_sym_DASH] = ACTIONS(6684),
    [anon_sym_STAR] = ACTIONS(6684),
    [anon_sym_SLASH] = ACTIONS(6684),
    [anon_sym_LT] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6682),
    [anon_sym_BANG] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6682),
    [anon_sym_COLON] = ACTIONS(6682),
    [anon_sym_SQUOTE] = ACTIONS(6682),
    [anon_sym__] = ACTIONS(6684),
    [anon_sym_CARET] = ACTIONS(6684),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6684),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6684),
    [anon_sym_DOLLAR] = ACTIONS(6682),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHbegin] = ACTIONS(6682),
    [anon_sym_BSLASHtitle] = ACTIONS(6682),
    [anon_sym_BSLASHauthor] = ACTIONS(6682),
    [anon_sym_BSLASHusepackage] = ACTIONS(6682),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6682),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6682),
    [anon_sym_BSLASHinclude] = ACTIONS(6682),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6682),
    [anon_sym_BSLASHinput] = ACTIONS(6682),
    [anon_sym_BSLASHsubfile] = ACTIONS(6682),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6682),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6682),
    [anon_sym_BSLASHbibliography] = ACTIONS(6682),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6682),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6682),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6682),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6682),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6682),
    [anon_sym_BSLASHimport] = ACTIONS(6682),
    [anon_sym_BSLASHsubimport] = ACTIONS(6682),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6682),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHcaption] = ACTIONS(6682),
    [anon_sym_BSLASHcite] = ACTIONS(6682),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCite] = ACTIONS(6682),
    [anon_sym_BSLASHnocite] = ACTIONS(6682),
    [anon_sym_BSLASHcitet] = ACTIONS(6682),
    [anon_sym_BSLASHcitep] = ACTIONS(6682),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteA] = ACTIONS(6682),
    [anon_sym_BSLASHciteR] = ACTIONS(6682),
    [anon_sym_BSLASHciteS] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6682),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteyear] = ACTIONS(6682),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitedate] = ACTIONS(6682),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteurl] = ACTIONS(6682),
    [anon_sym_BSLASHfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6682),
    [anon_sym_BSLASHcitealt] = ACTIONS(6682),
    [anon_sym_BSLASHcitealp] = ACTIONS(6682),
    [anon_sym_BSLASHcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHparencite] = ACTIONS(6682),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHParencite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHtextcite] = ACTIONS(6682),
    [anon_sym_BSLASHTextcite] = ACTIONS(6682),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHsupercite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite] = ACTIONS(6682),
    [anon_sym_BSLASHAutocite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHVolcite] = ACTIONS(6682),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHavolcite] = ACTIONS(6682),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHNotecite] = ACTIONS(6682),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHlabel] = ACTIONS(6682),
    [anon_sym_BSLASHref] = ACTIONS(6682),
    [anon_sym_BSLASHeqref] = ACTIONS(6682),
    [anon_sym_BSLASHvref] = ACTIONS(6682),
    [anon_sym_BSLASHVref] = ACTIONS(6682),
    [anon_sym_BSLASHautoref] = ACTIONS(6682),
    [anon_sym_BSLASHpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcref] = ACTIONS(6682),
    [anon_sym_BSLASHCref] = ACTIONS(6682),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnameCref] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHdef] = ACTIONS(6682),
    [anon_sym_BSLASHlet] = ACTIONS(6682),
    [anon_sym_BSLASHleft] = ACTIONS(6682),
    [anon_sym_BSLASHbigl] = ACTIONS(6682),
    [anon_sym_BSLASHBigl] = ACTIONS(6682),
    [anon_sym_BSLASHbiggl] = ACTIONS(6682),
    [anon_sym_BSLASHBiggl] = ACTIONS(6682),
    [anon_sym_BSLASHright] = ACTIONS(6682),
    [anon_sym_BSLASHbigr] = ACTIONS(6682),
    [anon_sym_BSLASHBigr] = ACTIONS(6682),
    [anon_sym_BSLASHbiggr] = ACTIONS(6682),
    [anon_sym_BSLASHBiggr] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6682),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6682),
    [anon_sym_BSLASHgls] = ACTIONS(6682),
    [anon_sym_BSLASHGls] = ACTIONS(6682),
    [anon_sym_BSLASHGLS] = ACTIONS(6682),
    [anon_sym_BSLASHglspl] = ACTIONS(6682),
    [anon_sym_BSLASHGlspl] = ACTIONS(6682),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6682),
    [anon_sym_BSLASHglslink] = ACTIONS(6682),
    [anon_sym_BSLASHglstext] = ACTIONS(6682),
    [anon_sym_BSLASHGlstext] = ACTIONS(6682),
    [anon_sym_BSLASHGLStext] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6682),
    [anon_sym_BSLASHglsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsname] = ACTIONS(6682),
    [anon_sym_BSLASHGlsname] = ACTIONS(6682),
    [anon_sym_BSLASHGLSname] = ACTIONS(6682),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6682),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6682),
    [anon_sym_BSLASHacrshort] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6682),
    [anon_sym_BSLASHACRshort] = ACTIONS(6682),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrlong] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6682),
    [anon_sym_BSLASHACRlong] = ACTIONS(6682),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrfull] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6682),
    [anon_sym_BSLASHACRfull] = ACTIONS(6682),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHacs] = ACTIONS(6682),
    [anon_sym_BSLASHAcs] = ACTIONS(6682),
    [anon_sym_BSLASHacsp] = ACTIONS(6682),
    [anon_sym_BSLASHAcsp] = ACTIONS(6682),
    [anon_sym_BSLASHacl] = ACTIONS(6682),
    [anon_sym_BSLASHAcl] = ACTIONS(6682),
    [anon_sym_BSLASHaclp] = ACTIONS(6682),
    [anon_sym_BSLASHAclp] = ACTIONS(6682),
    [anon_sym_BSLASHacf] = ACTIONS(6682),
    [anon_sym_BSLASHAcf] = ACTIONS(6682),
    [anon_sym_BSLASHacfp] = ACTIONS(6682),
    [anon_sym_BSLASHAcfp] = ACTIONS(6682),
    [anon_sym_BSLASHac] = ACTIONS(6682),
    [anon_sym_BSLASHAc] = ACTIONS(6682),
    [anon_sym_BSLASHacp] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6682),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6682),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6682),
    [anon_sym_BSLASHcolor] = ACTIONS(6682),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6682),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6682),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6682),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6682),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6682),
    [anon_sym_BSLASHtext] = ACTIONS(6682),
    [anon_sym_BSLASHintertext] = ACTIONS(6682),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6682),
    [anon_sym_BSLASHurl] = ACTIONS(6682),
    [anon_sym_BSLASHhref] = ACTIONS(6682),
  },
  [631] = {
    [sym__paragraph_declaration] = STATE(200),
    [sym_paragraph] = STATE(631),
    [aux_sym__paragraph_repeat1] = STATE(631),
    [ts_builtin_sym_end] = ACTIONS(6029),
    [sym_command_name] = ACTIONS(6027),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6027),
    [anon_sym_LBRACK] = ACTIONS(6029),
    [anon_sym_RBRACK] = ACTIONS(6029),
    [anon_sym_COMMA] = ACTIONS(6029),
    [anon_sym_EQ] = ACTIONS(6029),
    [anon_sym_LPAREN] = ACTIONS(6029),
    [anon_sym_RPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHpart] = ACTIONS(6027),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddpart] = ACTIONS(6027),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHchapter] = ACTIONS(6027),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddchap] = ACTIONS(6027),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsection] = ACTIONS(6027),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddsec] = ACTIONS(6027),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHparagraph] = ACTIONS(6686),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6689),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6027),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHitem] = ACTIONS(6027),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6029),
    [anon_sym_LBRACE] = ACTIONS(6029),
    [anon_sym_RBRACE] = ACTIONS(6029),
    [sym_word] = ACTIONS(6027),
    [sym_placeholder] = ACTIONS(6029),
    [anon_sym_PLUS] = ACTIONS(6029),
    [anon_sym_DASH] = ACTIONS(6029),
    [anon_sym_STAR] = ACTIONS(6029),
    [anon_sym_SLASH] = ACTIONS(6029),
    [anon_sym_LT] = ACTIONS(6027),
    [anon_sym_GT] = ACTIONS(6027),
    [anon_sym_BANG] = ACTIONS(6027),
    [anon_sym_PIPE] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6027),
    [anon_sym_SQUOTE] = ACTIONS(6027),
    [anon_sym__] = ACTIONS(6029),
    [anon_sym_CARET] = ACTIONS(6029),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6029),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6027),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHbegin] = ACTIONS(6027),
    [anon_sym_BSLASHtitle] = ACTIONS(6027),
    [anon_sym_BSLASHauthor] = ACTIONS(6027),
    [anon_sym_BSLASHusepackage] = ACTIONS(6027),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6027),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6027),
    [anon_sym_BSLASHinclude] = ACTIONS(6027),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6027),
    [anon_sym_BSLASHinput] = ACTIONS(6027),
    [anon_sym_BSLASHsubfile] = ACTIONS(6027),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6027),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6027),
    [anon_sym_BSLASHbibliography] = ACTIONS(6027),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6027),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6027),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6027),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6027),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6027),
    [anon_sym_BSLASHimport] = ACTIONS(6027),
    [anon_sym_BSLASHsubimport] = ACTIONS(6027),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6027),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHcaption] = ACTIONS(6027),
    [anon_sym_BSLASHcite] = ACTIONS(6027),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCite] = ACTIONS(6027),
    [anon_sym_BSLASHnocite] = ACTIONS(6027),
    [anon_sym_BSLASHcitet] = ACTIONS(6027),
    [anon_sym_BSLASHcitep] = ACTIONS(6027),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteA] = ACTIONS(6027),
    [anon_sym_BSLASHciteR] = ACTIONS(6027),
    [anon_sym_BSLASHciteS] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6027),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteyear] = ACTIONS(6027),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitedate] = ACTIONS(6027),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteurl] = ACTIONS(6027),
    [anon_sym_BSLASHfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6027),
    [anon_sym_BSLASHcitealt] = ACTIONS(6027),
    [anon_sym_BSLASHcitealp] = ACTIONS(6027),
    [anon_sym_BSLASHcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHparencite] = ACTIONS(6027),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHParencite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHtextcite] = ACTIONS(6027),
    [anon_sym_BSLASHTextcite] = ACTIONS(6027),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHsupercite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite] = ACTIONS(6027),
    [anon_sym_BSLASHAutocite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHVolcite] = ACTIONS(6027),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHavolcite] = ACTIONS(6027),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHNotecite] = ACTIONS(6027),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHlabel] = ACTIONS(6027),
    [anon_sym_BSLASHref] = ACTIONS(6027),
    [anon_sym_BSLASHeqref] = ACTIONS(6027),
    [anon_sym_BSLASHvref] = ACTIONS(6027),
    [anon_sym_BSLASHVref] = ACTIONS(6027),
    [anon_sym_BSLASHautoref] = ACTIONS(6027),
    [anon_sym_BSLASHpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcref] = ACTIONS(6027),
    [anon_sym_BSLASHCref] = ACTIONS(6027),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnameCref] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHdef] = ACTIONS(6027),
    [anon_sym_BSLASHlet] = ACTIONS(6027),
    [anon_sym_BSLASHleft] = ACTIONS(6027),
    [anon_sym_BSLASHbigl] = ACTIONS(6027),
    [anon_sym_BSLASHBigl] = ACTIONS(6027),
    [anon_sym_BSLASHbiggl] = ACTIONS(6027),
    [anon_sym_BSLASHBiggl] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6027),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6027),
    [anon_sym_BSLASHgls] = ACTIONS(6027),
    [anon_sym_BSLASHGls] = ACTIONS(6027),
    [anon_sym_BSLASHGLS] = ACTIONS(6027),
    [anon_sym_BSLASHglspl] = ACTIONS(6027),
    [anon_sym_BSLASHGlspl] = ACTIONS(6027),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6027),
    [anon_sym_BSLASHglslink] = ACTIONS(6027),
    [anon_sym_BSLASHglstext] = ACTIONS(6027),
    [anon_sym_BSLASHGlstext] = ACTIONS(6027),
    [anon_sym_BSLASHGLStext] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6027),
    [anon_sym_BSLASHglsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsname] = ACTIONS(6027),
    [anon_sym_BSLASHGlsname] = ACTIONS(6027),
    [anon_sym_BSLASHGLSname] = ACTIONS(6027),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6027),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6027),
    [anon_sym_BSLASHacrshort] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6027),
    [anon_sym_BSLASHACRshort] = ACTIONS(6027),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrlong] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6027),
    [anon_sym_BSLASHACRlong] = ACTIONS(6027),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrfull] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6027),
    [anon_sym_BSLASHACRfull] = ACTIONS(6027),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHacs] = ACTIONS(6027),
    [anon_sym_BSLASHAcs] = ACTIONS(6027),
    [anon_sym_BSLASHacsp] = ACTIONS(6027),
    [anon_sym_BSLASHAcsp] = ACTIONS(6027),
    [anon_sym_BSLASHacl] = ACTIONS(6027),
    [anon_sym_BSLASHAcl] = ACTIONS(6027),
    [anon_sym_BSLASHaclp] = ACTIONS(6027),
    [anon_sym_BSLASHAclp] = ACTIONS(6027),
    [anon_sym_BSLASHacf] = ACTIONS(6027),
    [anon_sym_BSLASHAcf] = ACTIONS(6027),
    [anon_sym_BSLASHacfp] = ACTIONS(6027),
    [anon_sym_BSLASHAcfp] = ACTIONS(6027),
    [anon_sym_BSLASHac] = ACTIONS(6027),
    [anon_sym_BSLASHAc] = ACTIONS(6027),
    [anon_sym_BSLASHacp] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6027),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6027),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6027),
    [anon_sym_BSLASHcolor] = ACTIONS(6027),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6027),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6027),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6027),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6027),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6027),
    [anon_sym_BSLASHtext] = ACTIONS(6027),
    [anon_sym_BSLASHintertext] = ACTIONS(6027),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6027),
    [anon_sym_BSLASHurl] = ACTIONS(6027),
    [anon_sym_BSLASHhref] = ACTIONS(6027),
  },
  [632] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(6019),
    [sym_command_name] = ACTIONS(6017),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6017),
    [anon_sym_LBRACK] = ACTIONS(6019),
    [anon_sym_RBRACK] = ACTIONS(6019),
    [anon_sym_COMMA] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6019),
    [anon_sym_LPAREN] = ACTIONS(6019),
    [anon_sym_RPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHpart] = ACTIONS(6017),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddpart] = ACTIONS(6017),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHchapter] = ACTIONS(6017),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddchap] = ACTIONS(6017),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsection] = ACTIONS(6017),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddsec] = ACTIONS(6017),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsection] = ACTIONS(6017),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6692),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6695),
    [anon_sym_BSLASHparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHitem] = ACTIONS(6017),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6019),
    [anon_sym_LBRACE] = ACTIONS(6019),
    [anon_sym_RBRACE] = ACTIONS(6019),
    [sym_word] = ACTIONS(6017),
    [sym_placeholder] = ACTIONS(6019),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6019),
    [anon_sym_SLASH] = ACTIONS(6019),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_BANG] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6017),
    [anon_sym_COLON] = ACTIONS(6017),
    [anon_sym_SQUOTE] = ACTIONS(6017),
    [anon_sym__] = ACTIONS(6019),
    [anon_sym_CARET] = ACTIONS(6019),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6019),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6019),
    [anon_sym_DOLLAR] = ACTIONS(6017),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHbegin] = ACTIONS(6017),
    [anon_sym_BSLASHtitle] = ACTIONS(6017),
    [anon_sym_BSLASHauthor] = ACTIONS(6017),
    [anon_sym_BSLASHusepackage] = ACTIONS(6017),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6017),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6017),
    [anon_sym_BSLASHinclude] = ACTIONS(6017),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6017),
    [anon_sym_BSLASHinput] = ACTIONS(6017),
    [anon_sym_BSLASHsubfile] = ACTIONS(6017),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6017),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6017),
    [anon_sym_BSLASHbibliography] = ACTIONS(6017),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6017),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6017),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6017),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6017),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6017),
    [anon_sym_BSLASHimport] = ACTIONS(6017),
    [anon_sym_BSLASHsubimport] = ACTIONS(6017),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6017),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHcaption] = ACTIONS(6017),
    [anon_sym_BSLASHcite] = ACTIONS(6017),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCite] = ACTIONS(6017),
    [anon_sym_BSLASHnocite] = ACTIONS(6017),
    [anon_sym_BSLASHcitet] = ACTIONS(6017),
    [anon_sym_BSLASHcitep] = ACTIONS(6017),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteA] = ACTIONS(6017),
    [anon_sym_BSLASHciteR] = ACTIONS(6017),
    [anon_sym_BSLASHciteS] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6017),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteyear] = ACTIONS(6017),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitedate] = ACTIONS(6017),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteurl] = ACTIONS(6017),
    [anon_sym_BSLASHfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6017),
    [anon_sym_BSLASHcitealt] = ACTIONS(6017),
    [anon_sym_BSLASHcitealp] = ACTIONS(6017),
    [anon_sym_BSLASHcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHparencite] = ACTIONS(6017),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHParencite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHtextcite] = ACTIONS(6017),
    [anon_sym_BSLASHTextcite] = ACTIONS(6017),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHsupercite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite] = ACTIONS(6017),
    [anon_sym_BSLASHAutocite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHVolcite] = ACTIONS(6017),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHavolcite] = ACTIONS(6017),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHNotecite] = ACTIONS(6017),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHlabel] = ACTIONS(6017),
    [anon_sym_BSLASHref] = ACTIONS(6017),
    [anon_sym_BSLASHeqref] = ACTIONS(6017),
    [anon_sym_BSLASHvref] = ACTIONS(6017),
    [anon_sym_BSLASHVref] = ACTIONS(6017),
    [anon_sym_BSLASHautoref] = ACTIONS(6017),
    [anon_sym_BSLASHpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcref] = ACTIONS(6017),
    [anon_sym_BSLASHCref] = ACTIONS(6017),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnameCref] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHdef] = ACTIONS(6017),
    [anon_sym_BSLASHlet] = ACTIONS(6017),
    [anon_sym_BSLASHleft] = ACTIONS(6017),
    [anon_sym_BSLASHbigl] = ACTIONS(6017),
    [anon_sym_BSLASHBigl] = ACTIONS(6017),
    [anon_sym_BSLASHbiggl] = ACTIONS(6017),
    [anon_sym_BSLASHBiggl] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6017),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6017),
    [anon_sym_BSLASHgls] = ACTIONS(6017),
    [anon_sym_BSLASHGls] = ACTIONS(6017),
    [anon_sym_BSLASHGLS] = ACTIONS(6017),
    [anon_sym_BSLASHglspl] = ACTIONS(6017),
    [anon_sym_BSLASHGlspl] = ACTIONS(6017),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6017),
    [anon_sym_BSLASHglslink] = ACTIONS(6017),
    [anon_sym_BSLASHglstext] = ACTIONS(6017),
    [anon_sym_BSLASHGlstext] = ACTIONS(6017),
    [anon_sym_BSLASHGLStext] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6017),
    [anon_sym_BSLASHglsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsname] = ACTIONS(6017),
    [anon_sym_BSLASHGlsname] = ACTIONS(6017),
    [anon_sym_BSLASHGLSname] = ACTIONS(6017),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6017),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6017),
    [anon_sym_BSLASHacrshort] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6017),
    [anon_sym_BSLASHACRshort] = ACTIONS(6017),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrlong] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6017),
    [anon_sym_BSLASHACRlong] = ACTIONS(6017),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrfull] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6017),
    [anon_sym_BSLASHACRfull] = ACTIONS(6017),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHacs] = ACTIONS(6017),
    [anon_sym_BSLASHAcs] = ACTIONS(6017),
    [anon_sym_BSLASHacsp] = ACTIONS(6017),
    [anon_sym_BSLASHAcsp] = ACTIONS(6017),
    [anon_sym_BSLASHacl] = ACTIONS(6017),
    [anon_sym_BSLASHAcl] = ACTIONS(6017),
    [anon_sym_BSLASHaclp] = ACTIONS(6017),
    [anon_sym_BSLASHAclp] = ACTIONS(6017),
    [anon_sym_BSLASHacf] = ACTIONS(6017),
    [anon_sym_BSLASHAcf] = ACTIONS(6017),
    [anon_sym_BSLASHacfp] = ACTIONS(6017),
    [anon_sym_BSLASHAcfp] = ACTIONS(6017),
    [anon_sym_BSLASHac] = ACTIONS(6017),
    [anon_sym_BSLASHAc] = ACTIONS(6017),
    [anon_sym_BSLASHacp] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6017),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6017),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6017),
    [anon_sym_BSLASHcolor] = ACTIONS(6017),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6017),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6017),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6017),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6017),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6017),
    [anon_sym_BSLASHtext] = ACTIONS(6017),
    [anon_sym_BSLASHintertext] = ACTIONS(6017),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6017),
    [anon_sym_BSLASHurl] = ACTIONS(6017),
    [anon_sym_BSLASHhref] = ACTIONS(6017),
  },
  [633] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(6009),
    [sym_command_name] = ACTIONS(6007),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6007),
    [anon_sym_LBRACK] = ACTIONS(6009),
    [anon_sym_RBRACK] = ACTIONS(6009),
    [anon_sym_COMMA] = ACTIONS(6009),
    [anon_sym_EQ] = ACTIONS(6009),
    [anon_sym_LPAREN] = ACTIONS(6009),
    [anon_sym_RPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHpart] = ACTIONS(6007),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddpart] = ACTIONS(6007),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHchapter] = ACTIONS(6007),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddchap] = ACTIONS(6007),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsection] = ACTIONS(6698),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6701),
    [anon_sym_BSLASHaddsec] = ACTIONS(6698),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6701),
    [anon_sym_BSLASHsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHitem] = ACTIONS(6007),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6009),
    [anon_sym_LBRACE] = ACTIONS(6009),
    [anon_sym_RBRACE] = ACTIONS(6009),
    [sym_word] = ACTIONS(6007),
    [sym_placeholder] = ACTIONS(6009),
    [anon_sym_PLUS] = ACTIONS(6009),
    [anon_sym_DASH] = ACTIONS(6009),
    [anon_sym_STAR] = ACTIONS(6009),
    [anon_sym_SLASH] = ACTIONS(6009),
    [anon_sym_LT] = ACTIONS(6007),
    [anon_sym_GT] = ACTIONS(6007),
    [anon_sym_BANG] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6007),
    [anon_sym_COLON] = ACTIONS(6007),
    [anon_sym_SQUOTE] = ACTIONS(6007),
    [anon_sym__] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(6009),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6009),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6009),
    [anon_sym_DOLLAR] = ACTIONS(6007),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHbegin] = ACTIONS(6007),
    [anon_sym_BSLASHtitle] = ACTIONS(6007),
    [anon_sym_BSLASHauthor] = ACTIONS(6007),
    [anon_sym_BSLASHusepackage] = ACTIONS(6007),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6007),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6007),
    [anon_sym_BSLASHinclude] = ACTIONS(6007),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6007),
    [anon_sym_BSLASHinput] = ACTIONS(6007),
    [anon_sym_BSLASHsubfile] = ACTIONS(6007),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6007),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6007),
    [anon_sym_BSLASHbibliography] = ACTIONS(6007),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6007),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6007),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6007),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6007),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6007),
    [anon_sym_BSLASHimport] = ACTIONS(6007),
    [anon_sym_BSLASHsubimport] = ACTIONS(6007),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6007),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHcaption] = ACTIONS(6007),
    [anon_sym_BSLASHcite] = ACTIONS(6007),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCite] = ACTIONS(6007),
    [anon_sym_BSLASHnocite] = ACTIONS(6007),
    [anon_sym_BSLASHcitet] = ACTIONS(6007),
    [anon_sym_BSLASHcitep] = ACTIONS(6007),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteA] = ACTIONS(6007),
    [anon_sym_BSLASHciteR] = ACTIONS(6007),
    [anon_sym_BSLASHciteS] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6007),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteyear] = ACTIONS(6007),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitedate] = ACTIONS(6007),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteurl] = ACTIONS(6007),
    [anon_sym_BSLASHfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6007),
    [anon_sym_BSLASHcitealt] = ACTIONS(6007),
    [anon_sym_BSLASHcitealp] = ACTIONS(6007),
    [anon_sym_BSLASHcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHparencite] = ACTIONS(6007),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHParencite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHtextcite] = ACTIONS(6007),
    [anon_sym_BSLASHTextcite] = ACTIONS(6007),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHsupercite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite] = ACTIONS(6007),
    [anon_sym_BSLASHAutocite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHVolcite] = ACTIONS(6007),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHavolcite] = ACTIONS(6007),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHNotecite] = ACTIONS(6007),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHlabel] = ACTIONS(6007),
    [anon_sym_BSLASHref] = ACTIONS(6007),
    [anon_sym_BSLASHeqref] = ACTIONS(6007),
    [anon_sym_BSLASHvref] = ACTIONS(6007),
    [anon_sym_BSLASHVref] = ACTIONS(6007),
    [anon_sym_BSLASHautoref] = ACTIONS(6007),
    [anon_sym_BSLASHpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcref] = ACTIONS(6007),
    [anon_sym_BSLASHCref] = ACTIONS(6007),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnameCref] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHdef] = ACTIONS(6007),
    [anon_sym_BSLASHlet] = ACTIONS(6007),
    [anon_sym_BSLASHleft] = ACTIONS(6007),
    [anon_sym_BSLASHbigl] = ACTIONS(6007),
    [anon_sym_BSLASHBigl] = ACTIONS(6007),
    [anon_sym_BSLASHbiggl] = ACTIONS(6007),
    [anon_sym_BSLASHBiggl] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6007),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6007),
    [anon_sym_BSLASHgls] = ACTIONS(6007),
    [anon_sym_BSLASHGls] = ACTIONS(6007),
    [anon_sym_BSLASHGLS] = ACTIONS(6007),
    [anon_sym_BSLASHglspl] = ACTIONS(6007),
    [anon_sym_BSLASHGlspl] = ACTIONS(6007),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6007),
    [anon_sym_BSLASHglslink] = ACTIONS(6007),
    [anon_sym_BSLASHglstext] = ACTIONS(6007),
    [anon_sym_BSLASHGlstext] = ACTIONS(6007),
    [anon_sym_BSLASHGLStext] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6007),
    [anon_sym_BSLASHglsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsname] = ACTIONS(6007),
    [anon_sym_BSLASHGlsname] = ACTIONS(6007),
    [anon_sym_BSLASHGLSname] = ACTIONS(6007),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6007),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6007),
    [anon_sym_BSLASHacrshort] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6007),
    [anon_sym_BSLASHACRshort] = ACTIONS(6007),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrlong] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6007),
    [anon_sym_BSLASHACRlong] = ACTIONS(6007),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrfull] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6007),
    [anon_sym_BSLASHACRfull] = ACTIONS(6007),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHacs] = ACTIONS(6007),
    [anon_sym_BSLASHAcs] = ACTIONS(6007),
    [anon_sym_BSLASHacsp] = ACTIONS(6007),
    [anon_sym_BSLASHAcsp] = ACTIONS(6007),
    [anon_sym_BSLASHacl] = ACTIONS(6007),
    [anon_sym_BSLASHAcl] = ACTIONS(6007),
    [anon_sym_BSLASHaclp] = ACTIONS(6007),
    [anon_sym_BSLASHAclp] = ACTIONS(6007),
    [anon_sym_BSLASHacf] = ACTIONS(6007),
    [anon_sym_BSLASHAcf] = ACTIONS(6007),
    [anon_sym_BSLASHacfp] = ACTIONS(6007),
    [anon_sym_BSLASHAcfp] = ACTIONS(6007),
    [anon_sym_BSLASHac] = ACTIONS(6007),
    [anon_sym_BSLASHAc] = ACTIONS(6007),
    [anon_sym_BSLASHacp] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6007),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6007),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6007),
    [anon_sym_BSLASHcolor] = ACTIONS(6007),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6007),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6007),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6007),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6007),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6007),
    [anon_sym_BSLASHtext] = ACTIONS(6007),
    [anon_sym_BSLASHintertext] = ACTIONS(6007),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6007),
    [anon_sym_BSLASHurl] = ACTIONS(6007),
    [anon_sym_BSLASHhref] = ACTIONS(6007),
  },
  [634] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(5963),
    [sym_command_name] = ACTIONS(5961),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5963),
    [anon_sym_RBRACK] = ACTIONS(5963),
    [anon_sym_COMMA] = ACTIONS(5963),
    [anon_sym_EQ] = ACTIONS(5963),
    [anon_sym_LPAREN] = ACTIONS(5963),
    [anon_sym_RPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHpart] = ACTIONS(5961),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddpart] = ACTIONS(5961),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHchapter] = ACTIONS(5961),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddchap] = ACTIONS(5961),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsection] = ACTIONS(5961),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddsec] = ACTIONS(5961),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubsection] = ACTIONS(6704),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6707),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5961),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHitem] = ACTIONS(5961),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5963),
    [anon_sym_LBRACE] = ACTIONS(5963),
    [anon_sym_RBRACE] = ACTIONS(5963),
    [sym_word] = ACTIONS(5961),
    [sym_placeholder] = ACTIONS(5963),
    [anon_sym_PLUS] = ACTIONS(5963),
    [anon_sym_DASH] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_SLASH] = ACTIONS(5963),
    [anon_sym_LT] = ACTIONS(5961),
    [anon_sym_GT] = ACTIONS(5961),
    [anon_sym_BANG] = ACTIONS(5961),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_COLON] = ACTIONS(5961),
    [anon_sym_SQUOTE] = ACTIONS(5961),
    [anon_sym__] = ACTIONS(5963),
    [anon_sym_CARET] = ACTIONS(5963),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5963),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5963),
    [anon_sym_DOLLAR] = ACTIONS(5961),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHbegin] = ACTIONS(5961),
    [anon_sym_BSLASHtitle] = ACTIONS(5961),
    [anon_sym_BSLASHauthor] = ACTIONS(5961),
    [anon_sym_BSLASHusepackage] = ACTIONS(5961),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5961),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5961),
    [anon_sym_BSLASHinclude] = ACTIONS(5961),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5961),
    [anon_sym_BSLASHinput] = ACTIONS(5961),
    [anon_sym_BSLASHsubfile] = ACTIONS(5961),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5961),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5961),
    [anon_sym_BSLASHbibliography] = ACTIONS(5961),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5961),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5961),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5961),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5961),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5961),
    [anon_sym_BSLASHimport] = ACTIONS(5961),
    [anon_sym_BSLASHsubimport] = ACTIONS(5961),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5961),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHcaption] = ACTIONS(5961),
    [anon_sym_BSLASHcite] = ACTIONS(5961),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCite] = ACTIONS(5961),
    [anon_sym_BSLASHnocite] = ACTIONS(5961),
    [anon_sym_BSLASHcitet] = ACTIONS(5961),
    [anon_sym_BSLASHcitep] = ACTIONS(5961),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteA] = ACTIONS(5961),
    [anon_sym_BSLASHciteR] = ACTIONS(5961),
    [anon_sym_BSLASHciteS] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5961),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteyear] = ACTIONS(5961),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitedate] = ACTIONS(5961),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteurl] = ACTIONS(5961),
    [anon_sym_BSLASHfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5961),
    [anon_sym_BSLASHcitealt] = ACTIONS(5961),
    [anon_sym_BSLASHcitealp] = ACTIONS(5961),
    [anon_sym_BSLASHcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHparencite] = ACTIONS(5961),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHParencite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHtextcite] = ACTIONS(5961),
    [anon_sym_BSLASHTextcite] = ACTIONS(5961),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHsupercite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite] = ACTIONS(5961),
    [anon_sym_BSLASHAutocite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHVolcite] = ACTIONS(5961),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHavolcite] = ACTIONS(5961),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHNotecite] = ACTIONS(5961),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHlabel] = ACTIONS(5961),
    [anon_sym_BSLASHref] = ACTIONS(5961),
    [anon_sym_BSLASHeqref] = ACTIONS(5961),
    [anon_sym_BSLASHvref] = ACTIONS(5961),
    [anon_sym_BSLASHVref] = ACTIONS(5961),
    [anon_sym_BSLASHautoref] = ACTIONS(5961),
    [anon_sym_BSLASHpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcref] = ACTIONS(5961),
    [anon_sym_BSLASHCref] = ACTIONS(5961),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnameCref] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHdef] = ACTIONS(5961),
    [anon_sym_BSLASHlet] = ACTIONS(5961),
    [anon_sym_BSLASHleft] = ACTIONS(5961),
    [anon_sym_BSLASHbigl] = ACTIONS(5961),
    [anon_sym_BSLASHBigl] = ACTIONS(5961),
    [anon_sym_BSLASHbiggl] = ACTIONS(5961),
    [anon_sym_BSLASHBiggl] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5961),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5961),
    [anon_sym_BSLASHgls] = ACTIONS(5961),
    [anon_sym_BSLASHGls] = ACTIONS(5961),
    [anon_sym_BSLASHGLS] = ACTIONS(5961),
    [anon_sym_BSLASHglspl] = ACTIONS(5961),
    [anon_sym_BSLASHGlspl] = ACTIONS(5961),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5961),
    [anon_sym_BSLASHglslink] = ACTIONS(5961),
    [anon_sym_BSLASHglstext] = ACTIONS(5961),
    [anon_sym_BSLASHGlstext] = ACTIONS(5961),
    [anon_sym_BSLASHGLStext] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5961),
    [anon_sym_BSLASHglsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsname] = ACTIONS(5961),
    [anon_sym_BSLASHGlsname] = ACTIONS(5961),
    [anon_sym_BSLASHGLSname] = ACTIONS(5961),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5961),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5961),
    [anon_sym_BSLASHacrshort] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5961),
    [anon_sym_BSLASHACRshort] = ACTIONS(5961),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrlong] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5961),
    [anon_sym_BSLASHACRlong] = ACTIONS(5961),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrfull] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5961),
    [anon_sym_BSLASHACRfull] = ACTIONS(5961),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHacs] = ACTIONS(5961),
    [anon_sym_BSLASHAcs] = ACTIONS(5961),
    [anon_sym_BSLASHacsp] = ACTIONS(5961),
    [anon_sym_BSLASHAcsp] = ACTIONS(5961),
    [anon_sym_BSLASHacl] = ACTIONS(5961),
    [anon_sym_BSLASHAcl] = ACTIONS(5961),
    [anon_sym_BSLASHaclp] = ACTIONS(5961),
    [anon_sym_BSLASHAclp] = ACTIONS(5961),
    [anon_sym_BSLASHacf] = ACTIONS(5961),
    [anon_sym_BSLASHAcf] = ACTIONS(5961),
    [anon_sym_BSLASHacfp] = ACTIONS(5961),
    [anon_sym_BSLASHAcfp] = ACTIONS(5961),
    [anon_sym_BSLASHac] = ACTIONS(5961),
    [anon_sym_BSLASHAc] = ACTIONS(5961),
    [anon_sym_BSLASHacp] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5961),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5961),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5961),
    [anon_sym_BSLASHcolor] = ACTIONS(5961),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5961),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5961),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5961),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5961),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5961),
    [anon_sym_BSLASHtext] = ACTIONS(5961),
    [anon_sym_BSLASHintertext] = ACTIONS(5961),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5961),
    [anon_sym_BSLASHurl] = ACTIONS(5961),
    [anon_sym_BSLASHhref] = ACTIONS(5961),
  },
  [635] = {
    [sym_command_name] = ACTIONS(6710),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(6712),
    [anon_sym_RBRACK] = ACTIONS(6712),
    [anon_sym_COMMA] = ACTIONS(6712),
    [anon_sym_EQ] = ACTIONS(6712),
    [anon_sym_LPAREN] = ACTIONS(6712),
    [anon_sym_RPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHpart] = ACTIONS(6710),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddpart] = ACTIONS(6710),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHchapter] = ACTIONS(6710),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddchap] = ACTIONS(6710),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsection] = ACTIONS(6710),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddsec] = ACTIONS(6710),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHitem] = ACTIONS(6710),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6712),
    [anon_sym_LBRACE] = ACTIONS(6712),
    [sym_word] = ACTIONS(6710),
    [sym_placeholder] = ACTIONS(6712),
    [anon_sym_PLUS] = ACTIONS(6712),
    [anon_sym_DASH] = ACTIONS(6712),
    [anon_sym_STAR] = ACTIONS(6712),
    [anon_sym_SLASH] = ACTIONS(6712),
    [anon_sym_LT] = ACTIONS(6710),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_PIPE] = ACTIONS(6710),
    [anon_sym_COLON] = ACTIONS(6710),
    [anon_sym_SQUOTE] = ACTIONS(6710),
    [anon_sym__] = ACTIONS(6712),
    [anon_sym_CARET] = ACTIONS(6712),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6712),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6712),
    [anon_sym_DOLLAR] = ACTIONS(6710),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHbegin] = ACTIONS(6710),
    [anon_sym_BSLASHtitle] = ACTIONS(6710),
    [anon_sym_BSLASHauthor] = ACTIONS(6710),
    [anon_sym_BSLASHusepackage] = ACTIONS(6710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6710),
    [anon_sym_BSLASHinclude] = ACTIONS(6710),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6710),
    [anon_sym_BSLASHinput] = ACTIONS(6710),
    [anon_sym_BSLASHsubfile] = ACTIONS(6710),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6710),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6710),
    [anon_sym_BSLASHbibliography] = ACTIONS(6710),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6710),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6710),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6710),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6710),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6710),
    [anon_sym_BSLASHimport] = ACTIONS(6710),
    [anon_sym_BSLASHsubimport] = ACTIONS(6710),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6710),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHcaption] = ACTIONS(6710),
    [anon_sym_BSLASHcite] = ACTIONS(6710),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCite] = ACTIONS(6710),
    [anon_sym_BSLASHnocite] = ACTIONS(6710),
    [anon_sym_BSLASHcitet] = ACTIONS(6710),
    [anon_sym_BSLASHcitep] = ACTIONS(6710),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteA] = ACTIONS(6710),
    [anon_sym_BSLASHciteR] = ACTIONS(6710),
    [anon_sym_BSLASHciteS] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6710),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteyear] = ACTIONS(6710),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitedate] = ACTIONS(6710),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteurl] = ACTIONS(6710),
    [anon_sym_BSLASHfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6710),
    [anon_sym_BSLASHcitealt] = ACTIONS(6710),
    [anon_sym_BSLASHcitealp] = ACTIONS(6710),
    [anon_sym_BSLASHcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHparencite] = ACTIONS(6710),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHParencite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHtextcite] = ACTIONS(6710),
    [anon_sym_BSLASHTextcite] = ACTIONS(6710),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHsupercite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite] = ACTIONS(6710),
    [anon_sym_BSLASHAutocite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHVolcite] = ACTIONS(6710),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHavolcite] = ACTIONS(6710),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHNotecite] = ACTIONS(6710),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHlabel] = ACTIONS(6710),
    [anon_sym_BSLASHref] = ACTIONS(6710),
    [anon_sym_BSLASHeqref] = ACTIONS(6710),
    [anon_sym_BSLASHvref] = ACTIONS(6710),
    [anon_sym_BSLASHVref] = ACTIONS(6710),
    [anon_sym_BSLASHautoref] = ACTIONS(6710),
    [anon_sym_BSLASHpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcref] = ACTIONS(6710),
    [anon_sym_BSLASHCref] = ACTIONS(6710),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnameCref] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHdef] = ACTIONS(6710),
    [anon_sym_BSLASHlet] = ACTIONS(6710),
    [anon_sym_BSLASHleft] = ACTIONS(6710),
    [anon_sym_BSLASHbigl] = ACTIONS(6710),
    [anon_sym_BSLASHBigl] = ACTIONS(6710),
    [anon_sym_BSLASHbiggl] = ACTIONS(6710),
    [anon_sym_BSLASHBiggl] = ACTIONS(6710),
    [anon_sym_BSLASHright] = ACTIONS(6710),
    [anon_sym_BSLASHbigr] = ACTIONS(6710),
    [anon_sym_BSLASHBigr] = ACTIONS(6710),
    [anon_sym_BSLASHbiggr] = ACTIONS(6710),
    [anon_sym_BSLASHBiggr] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6710),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6710),
    [anon_sym_BSLASHgls] = ACTIONS(6710),
    [anon_sym_BSLASHGls] = ACTIONS(6710),
    [anon_sym_BSLASHGLS] = ACTIONS(6710),
    [anon_sym_BSLASHglspl] = ACTIONS(6710),
    [anon_sym_BSLASHGlspl] = ACTIONS(6710),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6710),
    [anon_sym_BSLASHglslink] = ACTIONS(6710),
    [anon_sym_BSLASHglstext] = ACTIONS(6710),
    [anon_sym_BSLASHGlstext] = ACTIONS(6710),
    [anon_sym_BSLASHGLStext] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6710),
    [anon_sym_BSLASHglsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsname] = ACTIONS(6710),
    [anon_sym_BSLASHGlsname] = ACTIONS(6710),
    [anon_sym_BSLASHGLSname] = ACTIONS(6710),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6710),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6710),
    [anon_sym_BSLASHacrshort] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6710),
    [anon_sym_BSLASHACRshort] = ACTIONS(6710),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrlong] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6710),
    [anon_sym_BSLASHACRlong] = ACTIONS(6710),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrfull] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6710),
    [anon_sym_BSLASHACRfull] = ACTIONS(6710),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHacs] = ACTIONS(6710),
    [anon_sym_BSLASHAcs] = ACTIONS(6710),
    [anon_sym_BSLASHacsp] = ACTIONS(6710),
    [anon_sym_BSLASHAcsp] = ACTIONS(6710),
    [anon_sym_BSLASHacl] = ACTIONS(6710),
    [anon_sym_BSLASHAcl] = ACTIONS(6710),
    [anon_sym_BSLASHaclp] = ACTIONS(6710),
    [anon_sym_BSLASHAclp] = ACTIONS(6710),
    [anon_sym_BSLASHacf] = ACTIONS(6710),
    [anon_sym_BSLASHAcf] = ACTIONS(6710),
    [anon_sym_BSLASHacfp] = ACTIONS(6710),
    [anon_sym_BSLASHAcfp] = ACTIONS(6710),
    [anon_sym_BSLASHac] = ACTIONS(6710),
    [anon_sym_BSLASHAc] = ACTIONS(6710),
    [anon_sym_BSLASHacp] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6710),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6710),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6710),
    [anon_sym_BSLASHcolor] = ACTIONS(6710),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6710),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6710),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6710),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6710),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6710),
    [anon_sym_BSLASHtext] = ACTIONS(6710),
    [anon_sym_BSLASHintertext] = ACTIONS(6710),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6710),
    [anon_sym_BSLASHurl] = ACTIONS(6710),
    [anon_sym_BSLASHhref] = ACTIONS(6710),
  },
  [636] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(6091),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [637] = {
    [sym__section_declaration] = STATE(171),
    [sym_section] = STATE(633),
    [aux_sym__section_repeat3] = STATE(633),
    [ts_builtin_sym_end] = ACTIONS(6091),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(21),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(23),
    [anon_sym_BSLASHaddsec] = ACTIONS(21),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(23),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [anon_sym_RBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [638] = {
    [sym__subsubsection_declaration] = STATE(190),
    [sym_subsubsection] = STATE(632),
    [aux_sym__section_repeat5] = STATE(632),
    [ts_builtin_sym_end] = ACTIONS(6087),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(29),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(31),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [anon_sym_RBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [639] = {
    [sym__subsection_declaration] = STATE(182),
    [sym_subsection] = STATE(634),
    [aux_sym__section_repeat4] = STATE(634),
    [ts_builtin_sym_end] = ACTIONS(6087),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(25),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(27),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [anon_sym_RBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [640] = {
    [sym_command_name] = ACTIONS(6714),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6714),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_RBRACK] = ACTIONS(6716),
    [anon_sym_COMMA] = ACTIONS(6716),
    [anon_sym_EQ] = ACTIONS(6716),
    [anon_sym_LPAREN] = ACTIONS(6716),
    [anon_sym_RPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHpart] = ACTIONS(6714),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddpart] = ACTIONS(6714),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHchapter] = ACTIONS(6714),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddchap] = ACTIONS(6714),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsection] = ACTIONS(6714),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddsec] = ACTIONS(6714),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHitem] = ACTIONS(6714),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(6716),
    [sym_word] = ACTIONS(6714),
    [sym_placeholder] = ACTIONS(6716),
    [anon_sym_PLUS] = ACTIONS(6716),
    [anon_sym_DASH] = ACTIONS(6716),
    [anon_sym_STAR] = ACTIONS(6716),
    [anon_sym_SLASH] = ACTIONS(6716),
    [anon_sym_LT] = ACTIONS(6714),
    [anon_sym_GT] = ACTIONS(6714),
    [anon_sym_BANG] = ACTIONS(6714),
    [anon_sym_PIPE] = ACTIONS(6714),
    [anon_sym_COLON] = ACTIONS(6714),
    [anon_sym_SQUOTE] = ACTIONS(6714),
    [anon_sym__] = ACTIONS(6716),
    [anon_sym_CARET] = ACTIONS(6716),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6716),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6716),
    [anon_sym_DOLLAR] = ACTIONS(6714),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHbegin] = ACTIONS(6714),
    [anon_sym_BSLASHtitle] = ACTIONS(6714),
    [anon_sym_BSLASHauthor] = ACTIONS(6714),
    [anon_sym_BSLASHusepackage] = ACTIONS(6714),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6714),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6714),
    [anon_sym_BSLASHinclude] = ACTIONS(6714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6714),
    [anon_sym_BSLASHinput] = ACTIONS(6714),
    [anon_sym_BSLASHsubfile] = ACTIONS(6714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6714),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6714),
    [anon_sym_BSLASHbibliography] = ACTIONS(6714),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6714),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6714),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6714),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6714),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6714),
    [anon_sym_BSLASHimport] = ACTIONS(6714),
    [anon_sym_BSLASHsubimport] = ACTIONS(6714),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6714),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHcaption] = ACTIONS(6714),
    [anon_sym_BSLASHcite] = ACTIONS(6714),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCite] = ACTIONS(6714),
    [anon_sym_BSLASHnocite] = ACTIONS(6714),
    [anon_sym_BSLASHcitet] = ACTIONS(6714),
    [anon_sym_BSLASHcitep] = ACTIONS(6714),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteA] = ACTIONS(6714),
    [anon_sym_BSLASHciteR] = ACTIONS(6714),
    [anon_sym_BSLASHciteS] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6714),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteyear] = ACTIONS(6714),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitedate] = ACTIONS(6714),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteurl] = ACTIONS(6714),
    [anon_sym_BSLASHfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6714),
    [anon_sym_BSLASHcitealt] = ACTIONS(6714),
    [anon_sym_BSLASHcitealp] = ACTIONS(6714),
    [anon_sym_BSLASHcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHparencite] = ACTIONS(6714),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHParencite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHtextcite] = ACTIONS(6714),
    [anon_sym_BSLASHTextcite] = ACTIONS(6714),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHsupercite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite] = ACTIONS(6714),
    [anon_sym_BSLASHAutocite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHVolcite] = ACTIONS(6714),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHavolcite] = ACTIONS(6714),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHNotecite] = ACTIONS(6714),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHlabel] = ACTIONS(6714),
    [anon_sym_BSLASHref] = ACTIONS(6714),
    [anon_sym_BSLASHeqref] = ACTIONS(6714),
    [anon_sym_BSLASHvref] = ACTIONS(6714),
    [anon_sym_BSLASHVref] = ACTIONS(6714),
    [anon_sym_BSLASHautoref] = ACTIONS(6714),
    [anon_sym_BSLASHpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcref] = ACTIONS(6714),
    [anon_sym_BSLASHCref] = ACTIONS(6714),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnameCref] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHdef] = ACTIONS(6714),
    [anon_sym_BSLASHlet] = ACTIONS(6714),
    [anon_sym_BSLASHleft] = ACTIONS(6714),
    [anon_sym_BSLASHbigl] = ACTIONS(6714),
    [anon_sym_BSLASHBigl] = ACTIONS(6714),
    [anon_sym_BSLASHbiggl] = ACTIONS(6714),
    [anon_sym_BSLASHBiggl] = ACTIONS(6714),
    [anon_sym_BSLASHright] = ACTIONS(6714),
    [anon_sym_BSLASHbigr] = ACTIONS(6714),
    [anon_sym_BSLASHBigr] = ACTIONS(6714),
    [anon_sym_BSLASHbiggr] = ACTIONS(6714),
    [anon_sym_BSLASHBiggr] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6714),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6714),
    [anon_sym_BSLASHgls] = ACTIONS(6714),
    [anon_sym_BSLASHGls] = ACTIONS(6714),
    [anon_sym_BSLASHGLS] = ACTIONS(6714),
    [anon_sym_BSLASHglspl] = ACTIONS(6714),
    [anon_sym_BSLASHGlspl] = ACTIONS(6714),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6714),
    [anon_sym_BSLASHglslink] = ACTIONS(6714),
    [anon_sym_BSLASHglstext] = ACTIONS(6714),
    [anon_sym_BSLASHGlstext] = ACTIONS(6714),
    [anon_sym_BSLASHGLStext] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6714),
    [anon_sym_BSLASHglsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsname] = ACTIONS(6714),
    [anon_sym_BSLASHGlsname] = ACTIONS(6714),
    [anon_sym_BSLASHGLSname] = ACTIONS(6714),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6714),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6714),
    [anon_sym_BSLASHacrshort] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6714),
    [anon_sym_BSLASHACRshort] = ACTIONS(6714),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrlong] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6714),
    [anon_sym_BSLASHACRlong] = ACTIONS(6714),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrfull] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6714),
    [anon_sym_BSLASHACRfull] = ACTIONS(6714),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHacs] = ACTIONS(6714),
    [anon_sym_BSLASHAcs] = ACTIONS(6714),
    [anon_sym_BSLASHacsp] = ACTIONS(6714),
    [anon_sym_BSLASHAcsp] = ACTIONS(6714),
    [anon_sym_BSLASHacl] = ACTIONS(6714),
    [anon_sym_BSLASHAcl] = ACTIONS(6714),
    [anon_sym_BSLASHaclp] = ACTIONS(6714),
    [anon_sym_BSLASHAclp] = ACTIONS(6714),
    [anon_sym_BSLASHacf] = ACTIONS(6714),
    [anon_sym_BSLASHAcf] = ACTIONS(6714),
    [anon_sym_BSLASHacfp] = ACTIONS(6714),
    [anon_sym_BSLASHAcfp] = ACTIONS(6714),
    [anon_sym_BSLASHac] = ACTIONS(6714),
    [anon_sym_BSLASHAc] = ACTIONS(6714),
    [anon_sym_BSLASHacp] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6714),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6714),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6714),
    [anon_sym_BSLASHcolor] = ACTIONS(6714),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6714),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6714),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6714),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6714),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6714),
    [anon_sym_BSLASHtext] = ACTIONS(6714),
    [anon_sym_BSLASHintertext] = ACTIONS(6714),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6714),
    [anon_sym_BSLASHurl] = ACTIONS(6714),
    [anon_sym_BSLASHhref] = ACTIONS(6714),
  },
  [641] = {
    [sym_command_name] = ACTIONS(6718),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6718),
    [anon_sym_LBRACK] = ACTIONS(6720),
    [anon_sym_RBRACK] = ACTIONS(6720),
    [anon_sym_COMMA] = ACTIONS(6720),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_LPAREN] = ACTIONS(6720),
    [anon_sym_RPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHpart] = ACTIONS(6718),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddpart] = ACTIONS(6718),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHchapter] = ACTIONS(6718),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddchap] = ACTIONS(6718),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsection] = ACTIONS(6718),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddsec] = ACTIONS(6718),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHitem] = ACTIONS(6718),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6720),
    [anon_sym_LBRACE] = ACTIONS(6720),
    [sym_word] = ACTIONS(6718),
    [sym_placeholder] = ACTIONS(6720),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_LT] = ACTIONS(6718),
    [anon_sym_GT] = ACTIONS(6718),
    [anon_sym_BANG] = ACTIONS(6718),
    [anon_sym_PIPE] = ACTIONS(6718),
    [anon_sym_COLON] = ACTIONS(6718),
    [anon_sym_SQUOTE] = ACTIONS(6718),
    [anon_sym__] = ACTIONS(6720),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6720),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6720),
    [anon_sym_DOLLAR] = ACTIONS(6718),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHbegin] = ACTIONS(6718),
    [anon_sym_BSLASHtitle] = ACTIONS(6718),
    [anon_sym_BSLASHauthor] = ACTIONS(6718),
    [anon_sym_BSLASHusepackage] = ACTIONS(6718),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6718),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6718),
    [anon_sym_BSLASHinclude] = ACTIONS(6718),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6718),
    [anon_sym_BSLASHinput] = ACTIONS(6718),
    [anon_sym_BSLASHsubfile] = ACTIONS(6718),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6718),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6718),
    [anon_sym_BSLASHbibliography] = ACTIONS(6718),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6718),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6718),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6718),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6718),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6718),
    [anon_sym_BSLASHimport] = ACTIONS(6718),
    [anon_sym_BSLASHsubimport] = ACTIONS(6718),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6718),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHcaption] = ACTIONS(6718),
    [anon_sym_BSLASHcite] = ACTIONS(6718),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCite] = ACTIONS(6718),
    [anon_sym_BSLASHnocite] = ACTIONS(6718),
    [anon_sym_BSLASHcitet] = ACTIONS(6718),
    [anon_sym_BSLASHcitep] = ACTIONS(6718),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteA] = ACTIONS(6718),
    [anon_sym_BSLASHciteR] = ACTIONS(6718),
    [anon_sym_BSLASHciteS] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6718),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteyear] = ACTIONS(6718),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitedate] = ACTIONS(6718),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteurl] = ACTIONS(6718),
    [anon_sym_BSLASHfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6718),
    [anon_sym_BSLASHcitealt] = ACTIONS(6718),
    [anon_sym_BSLASHcitealp] = ACTIONS(6718),
    [anon_sym_BSLASHcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHparencite] = ACTIONS(6718),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHParencite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHtextcite] = ACTIONS(6718),
    [anon_sym_BSLASHTextcite] = ACTIONS(6718),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHsupercite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite] = ACTIONS(6718),
    [anon_sym_BSLASHAutocite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHVolcite] = ACTIONS(6718),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHavolcite] = ACTIONS(6718),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHNotecite] = ACTIONS(6718),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHlabel] = ACTIONS(6718),
    [anon_sym_BSLASHref] = ACTIONS(6718),
    [anon_sym_BSLASHeqref] = ACTIONS(6718),
    [anon_sym_BSLASHvref] = ACTIONS(6718),
    [anon_sym_BSLASHVref] = ACTIONS(6718),
    [anon_sym_BSLASHautoref] = ACTIONS(6718),
    [anon_sym_BSLASHpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcref] = ACTIONS(6718),
    [anon_sym_BSLASHCref] = ACTIONS(6718),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnameCref] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHdef] = ACTIONS(6718),
    [anon_sym_BSLASHlet] = ACTIONS(6718),
    [anon_sym_BSLASHleft] = ACTIONS(6718),
    [anon_sym_BSLASHbigl] = ACTIONS(6718),
    [anon_sym_BSLASHBigl] = ACTIONS(6718),
    [anon_sym_BSLASHbiggl] = ACTIONS(6718),
    [anon_sym_BSLASHBiggl] = ACTIONS(6718),
    [anon_sym_BSLASHright] = ACTIONS(6718),
    [anon_sym_BSLASHbigr] = ACTIONS(6718),
    [anon_sym_BSLASHBigr] = ACTIONS(6718),
    [anon_sym_BSLASHbiggr] = ACTIONS(6718),
    [anon_sym_BSLASHBiggr] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6718),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6718),
    [anon_sym_BSLASHgls] = ACTIONS(6718),
    [anon_sym_BSLASHGls] = ACTIONS(6718),
    [anon_sym_BSLASHGLS] = ACTIONS(6718),
    [anon_sym_BSLASHglspl] = ACTIONS(6718),
    [anon_sym_BSLASHGlspl] = ACTIONS(6718),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6718),
    [anon_sym_BSLASHglslink] = ACTIONS(6718),
    [anon_sym_BSLASHglstext] = ACTIONS(6718),
    [anon_sym_BSLASHGlstext] = ACTIONS(6718),
    [anon_sym_BSLASHGLStext] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6718),
    [anon_sym_BSLASHglsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsname] = ACTIONS(6718),
    [anon_sym_BSLASHGlsname] = ACTIONS(6718),
    [anon_sym_BSLASHGLSname] = ACTIONS(6718),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6718),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6718),
    [anon_sym_BSLASHacrshort] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6718),
    [anon_sym_BSLASHACRshort] = ACTIONS(6718),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrlong] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6718),
    [anon_sym_BSLASHACRlong] = ACTIONS(6718),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrfull] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6718),
    [anon_sym_BSLASHACRfull] = ACTIONS(6718),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHacs] = ACTIONS(6718),
    [anon_sym_BSLASHAcs] = ACTIONS(6718),
    [anon_sym_BSLASHacsp] = ACTIONS(6718),
    [anon_sym_BSLASHAcsp] = ACTIONS(6718),
    [anon_sym_BSLASHacl] = ACTIONS(6718),
    [anon_sym_BSLASHAcl] = ACTIONS(6718),
    [anon_sym_BSLASHaclp] = ACTIONS(6718),
    [anon_sym_BSLASHAclp] = ACTIONS(6718),
    [anon_sym_BSLASHacf] = ACTIONS(6718),
    [anon_sym_BSLASHAcf] = ACTIONS(6718),
    [anon_sym_BSLASHacfp] = ACTIONS(6718),
    [anon_sym_BSLASHAcfp] = ACTIONS(6718),
    [anon_sym_BSLASHac] = ACTIONS(6718),
    [anon_sym_BSLASHAc] = ACTIONS(6718),
    [anon_sym_BSLASHacp] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6718),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6718),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6718),
    [anon_sym_BSLASHcolor] = ACTIONS(6718),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6718),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6718),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6718),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6718),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6718),
    [anon_sym_BSLASHtext] = ACTIONS(6718),
    [anon_sym_BSLASHintertext] = ACTIONS(6718),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6718),
    [anon_sym_BSLASHurl] = ACTIONS(6718),
    [anon_sym_BSLASHhref] = ACTIONS(6718),
  },
  [642] = {
    [sym_command_name] = ACTIONS(6722),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6722),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_RBRACK] = ACTIONS(6724),
    [anon_sym_COMMA] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6724),
    [anon_sym_LPAREN] = ACTIONS(6724),
    [anon_sym_RPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHpart] = ACTIONS(6722),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddpart] = ACTIONS(6722),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHchapter] = ACTIONS(6722),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddchap] = ACTIONS(6722),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsection] = ACTIONS(6722),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddsec] = ACTIONS(6722),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHitem] = ACTIONS(6722),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(6724),
    [sym_word] = ACTIONS(6722),
    [sym_placeholder] = ACTIONS(6724),
    [anon_sym_PLUS] = ACTIONS(6724),
    [anon_sym_DASH] = ACTIONS(6724),
    [anon_sym_STAR] = ACTIONS(6724),
    [anon_sym_SLASH] = ACTIONS(6724),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_BANG] = ACTIONS(6722),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_COLON] = ACTIONS(6722),
    [anon_sym_SQUOTE] = ACTIONS(6722),
    [anon_sym__] = ACTIONS(6724),
    [anon_sym_CARET] = ACTIONS(6724),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6724),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6724),
    [anon_sym_DOLLAR] = ACTIONS(6722),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHbegin] = ACTIONS(6722),
    [anon_sym_BSLASHtitle] = ACTIONS(6722),
    [anon_sym_BSLASHauthor] = ACTIONS(6722),
    [anon_sym_BSLASHusepackage] = ACTIONS(6722),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6722),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6722),
    [anon_sym_BSLASHinclude] = ACTIONS(6722),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6722),
    [anon_sym_BSLASHinput] = ACTIONS(6722),
    [anon_sym_BSLASHsubfile] = ACTIONS(6722),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6722),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6722),
    [anon_sym_BSLASHbibliography] = ACTIONS(6722),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6722),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6722),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6722),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6722),
    [anon_sym_BSLASHimport] = ACTIONS(6722),
    [anon_sym_BSLASHsubimport] = ACTIONS(6722),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6722),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHcaption] = ACTIONS(6722),
    [anon_sym_BSLASHcite] = ACTIONS(6722),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCite] = ACTIONS(6722),
    [anon_sym_BSLASHnocite] = ACTIONS(6722),
    [anon_sym_BSLASHcitet] = ACTIONS(6722),
    [anon_sym_BSLASHcitep] = ACTIONS(6722),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteA] = ACTIONS(6722),
    [anon_sym_BSLASHciteR] = ACTIONS(6722),
    [anon_sym_BSLASHciteS] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6722),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteyear] = ACTIONS(6722),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitedate] = ACTIONS(6722),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteurl] = ACTIONS(6722),
    [anon_sym_BSLASHfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6722),
    [anon_sym_BSLASHcitealt] = ACTIONS(6722),
    [anon_sym_BSLASHcitealp] = ACTIONS(6722),
    [anon_sym_BSLASHcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHparencite] = ACTIONS(6722),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHParencite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHtextcite] = ACTIONS(6722),
    [anon_sym_BSLASHTextcite] = ACTIONS(6722),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHsupercite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite] = ACTIONS(6722),
    [anon_sym_BSLASHAutocite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHVolcite] = ACTIONS(6722),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHavolcite] = ACTIONS(6722),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHNotecite] = ACTIONS(6722),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHlabel] = ACTIONS(6722),
    [anon_sym_BSLASHref] = ACTIONS(6722),
    [anon_sym_BSLASHeqref] = ACTIONS(6722),
    [anon_sym_BSLASHvref] = ACTIONS(6722),
    [anon_sym_BSLASHVref] = ACTIONS(6722),
    [anon_sym_BSLASHautoref] = ACTIONS(6722),
    [anon_sym_BSLASHpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcref] = ACTIONS(6722),
    [anon_sym_BSLASHCref] = ACTIONS(6722),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnameCref] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHdef] = ACTIONS(6722),
    [anon_sym_BSLASHlet] = ACTIONS(6722),
    [anon_sym_BSLASHleft] = ACTIONS(6722),
    [anon_sym_BSLASHbigl] = ACTIONS(6722),
    [anon_sym_BSLASHBigl] = ACTIONS(6722),
    [anon_sym_BSLASHbiggl] = ACTIONS(6722),
    [anon_sym_BSLASHBiggl] = ACTIONS(6722),
    [anon_sym_BSLASHright] = ACTIONS(6722),
    [anon_sym_BSLASHbigr] = ACTIONS(6722),
    [anon_sym_BSLASHBigr] = ACTIONS(6722),
    [anon_sym_BSLASHbiggr] = ACTIONS(6722),
    [anon_sym_BSLASHBiggr] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6722),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6722),
    [anon_sym_BSLASHgls] = ACTIONS(6722),
    [anon_sym_BSLASHGls] = ACTIONS(6722),
    [anon_sym_BSLASHGLS] = ACTIONS(6722),
    [anon_sym_BSLASHglspl] = ACTIONS(6722),
    [anon_sym_BSLASHGlspl] = ACTIONS(6722),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6722),
    [anon_sym_BSLASHglslink] = ACTIONS(6722),
    [anon_sym_BSLASHglstext] = ACTIONS(6722),
    [anon_sym_BSLASHGlstext] = ACTIONS(6722),
    [anon_sym_BSLASHGLStext] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6722),
    [anon_sym_BSLASHglsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsname] = ACTIONS(6722),
    [anon_sym_BSLASHGlsname] = ACTIONS(6722),
    [anon_sym_BSLASHGLSname] = ACTIONS(6722),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6722),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6722),
    [anon_sym_BSLASHacrshort] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6722),
    [anon_sym_BSLASHACRshort] = ACTIONS(6722),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrlong] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6722),
    [anon_sym_BSLASHACRlong] = ACTIONS(6722),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrfull] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6722),
    [anon_sym_BSLASHACRfull] = ACTIONS(6722),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHacs] = ACTIONS(6722),
    [anon_sym_BSLASHAcs] = ACTIONS(6722),
    [anon_sym_BSLASHacsp] = ACTIONS(6722),
    [anon_sym_BSLASHAcsp] = ACTIONS(6722),
    [anon_sym_BSLASHacl] = ACTIONS(6722),
    [anon_sym_BSLASHAcl] = ACTIONS(6722),
    [anon_sym_BSLASHaclp] = ACTIONS(6722),
    [anon_sym_BSLASHAclp] = ACTIONS(6722),
    [anon_sym_BSLASHacf] = ACTIONS(6722),
    [anon_sym_BSLASHAcf] = ACTIONS(6722),
    [anon_sym_BSLASHacfp] = ACTIONS(6722),
    [anon_sym_BSLASHAcfp] = ACTIONS(6722),
    [anon_sym_BSLASHac] = ACTIONS(6722),
    [anon_sym_BSLASHAc] = ACTIONS(6722),
    [anon_sym_BSLASHacp] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6722),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6722),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6722),
    [anon_sym_BSLASHcolor] = ACTIONS(6722),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6722),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6722),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6722),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6722),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6722),
    [anon_sym_BSLASHtext] = ACTIONS(6722),
    [anon_sym_BSLASHintertext] = ACTIONS(6722),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6722),
    [anon_sym_BSLASHurl] = ACTIONS(6722),
    [anon_sym_BSLASHhref] = ACTIONS(6722),
  },
  [643] = {
    [sym_command_name] = ACTIONS(6726),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6726),
    [anon_sym_LBRACK] = ACTIONS(6728),
    [anon_sym_RBRACK] = ACTIONS(6728),
    [anon_sym_COMMA] = ACTIONS(6728),
    [anon_sym_EQ] = ACTIONS(6728),
    [anon_sym_LPAREN] = ACTIONS(6728),
    [anon_sym_RPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHpart] = ACTIONS(6726),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddpart] = ACTIONS(6726),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHchapter] = ACTIONS(6726),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddchap] = ACTIONS(6726),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsection] = ACTIONS(6726),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddsec] = ACTIONS(6726),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHitem] = ACTIONS(6726),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6728),
    [anon_sym_LBRACE] = ACTIONS(6728),
    [sym_word] = ACTIONS(6726),
    [sym_placeholder] = ACTIONS(6728),
    [anon_sym_PLUS] = ACTIONS(6728),
    [anon_sym_DASH] = ACTIONS(6728),
    [anon_sym_STAR] = ACTIONS(6728),
    [anon_sym_SLASH] = ACTIONS(6728),
    [anon_sym_LT] = ACTIONS(6726),
    [anon_sym_GT] = ACTIONS(6726),
    [anon_sym_BANG] = ACTIONS(6726),
    [anon_sym_PIPE] = ACTIONS(6726),
    [anon_sym_COLON] = ACTIONS(6726),
    [anon_sym_SQUOTE] = ACTIONS(6726),
    [anon_sym__] = ACTIONS(6728),
    [anon_sym_CARET] = ACTIONS(6728),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6728),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6728),
    [anon_sym_DOLLAR] = ACTIONS(6726),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHbegin] = ACTIONS(6726),
    [anon_sym_BSLASHtitle] = ACTIONS(6726),
    [anon_sym_BSLASHauthor] = ACTIONS(6726),
    [anon_sym_BSLASHusepackage] = ACTIONS(6726),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6726),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6726),
    [anon_sym_BSLASHinclude] = ACTIONS(6726),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6726),
    [anon_sym_BSLASHinput] = ACTIONS(6726),
    [anon_sym_BSLASHsubfile] = ACTIONS(6726),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6726),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6726),
    [anon_sym_BSLASHbibliography] = ACTIONS(6726),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6726),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6726),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6726),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6726),
    [anon_sym_BSLASHimport] = ACTIONS(6726),
    [anon_sym_BSLASHsubimport] = ACTIONS(6726),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6726),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHcaption] = ACTIONS(6726),
    [anon_sym_BSLASHcite] = ACTIONS(6726),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCite] = ACTIONS(6726),
    [anon_sym_BSLASHnocite] = ACTIONS(6726),
    [anon_sym_BSLASHcitet] = ACTIONS(6726),
    [anon_sym_BSLASHcitep] = ACTIONS(6726),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteA] = ACTIONS(6726),
    [anon_sym_BSLASHciteR] = ACTIONS(6726),
    [anon_sym_BSLASHciteS] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6726),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteyear] = ACTIONS(6726),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitedate] = ACTIONS(6726),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteurl] = ACTIONS(6726),
    [anon_sym_BSLASHfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6726),
    [anon_sym_BSLASHcitealt] = ACTIONS(6726),
    [anon_sym_BSLASHcitealp] = ACTIONS(6726),
    [anon_sym_BSLASHcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHparencite] = ACTIONS(6726),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHParencite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHtextcite] = ACTIONS(6726),
    [anon_sym_BSLASHTextcite] = ACTIONS(6726),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHsupercite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite] = ACTIONS(6726),
    [anon_sym_BSLASHAutocite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHVolcite] = ACTIONS(6726),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHavolcite] = ACTIONS(6726),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHNotecite] = ACTIONS(6726),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHlabel] = ACTIONS(6726),
    [anon_sym_BSLASHref] = ACTIONS(6726),
    [anon_sym_BSLASHeqref] = ACTIONS(6726),
    [anon_sym_BSLASHvref] = ACTIONS(6726),
    [anon_sym_BSLASHVref] = ACTIONS(6726),
    [anon_sym_BSLASHautoref] = ACTIONS(6726),
    [anon_sym_BSLASHpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcref] = ACTIONS(6726),
    [anon_sym_BSLASHCref] = ACTIONS(6726),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnameCref] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHdef] = ACTIONS(6726),
    [anon_sym_BSLASHlet] = ACTIONS(6726),
    [anon_sym_BSLASHleft] = ACTIONS(6726),
    [anon_sym_BSLASHbigl] = ACTIONS(6726),
    [anon_sym_BSLASHBigl] = ACTIONS(6726),
    [anon_sym_BSLASHbiggl] = ACTIONS(6726),
    [anon_sym_BSLASHBiggl] = ACTIONS(6726),
    [anon_sym_BSLASHright] = ACTIONS(6726),
    [anon_sym_BSLASHbigr] = ACTIONS(6726),
    [anon_sym_BSLASHBigr] = ACTIONS(6726),
    [anon_sym_BSLASHbiggr] = ACTIONS(6726),
    [anon_sym_BSLASHBiggr] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6726),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6726),
    [anon_sym_BSLASHgls] = ACTIONS(6726),
    [anon_sym_BSLASHGls] = ACTIONS(6726),
    [anon_sym_BSLASHGLS] = ACTIONS(6726),
    [anon_sym_BSLASHglspl] = ACTIONS(6726),
    [anon_sym_BSLASHGlspl] = ACTIONS(6726),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6726),
    [anon_sym_BSLASHglslink] = ACTIONS(6726),
    [anon_sym_BSLASHglstext] = ACTIONS(6726),
    [anon_sym_BSLASHGlstext] = ACTIONS(6726),
    [anon_sym_BSLASHGLStext] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6726),
    [anon_sym_BSLASHglsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsname] = ACTIONS(6726),
    [anon_sym_BSLASHGlsname] = ACTIONS(6726),
    [anon_sym_BSLASHGLSname] = ACTIONS(6726),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6726),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6726),
    [anon_sym_BSLASHacrshort] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6726),
    [anon_sym_BSLASHACRshort] = ACTIONS(6726),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrlong] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6726),
    [anon_sym_BSLASHACRlong] = ACTIONS(6726),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrfull] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6726),
    [anon_sym_BSLASHACRfull] = ACTIONS(6726),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHacs] = ACTIONS(6726),
    [anon_sym_BSLASHAcs] = ACTIONS(6726),
    [anon_sym_BSLASHacsp] = ACTIONS(6726),
    [anon_sym_BSLASHAcsp] = ACTIONS(6726),
    [anon_sym_BSLASHacl] = ACTIONS(6726),
    [anon_sym_BSLASHAcl] = ACTIONS(6726),
    [anon_sym_BSLASHaclp] = ACTIONS(6726),
    [anon_sym_BSLASHAclp] = ACTIONS(6726),
    [anon_sym_BSLASHacf] = ACTIONS(6726),
    [anon_sym_BSLASHAcf] = ACTIONS(6726),
    [anon_sym_BSLASHacfp] = ACTIONS(6726),
    [anon_sym_BSLASHAcfp] = ACTIONS(6726),
    [anon_sym_BSLASHac] = ACTIONS(6726),
    [anon_sym_BSLASHAc] = ACTIONS(6726),
    [anon_sym_BSLASHacp] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6726),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6726),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6726),
    [anon_sym_BSLASHcolor] = ACTIONS(6726),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6726),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6726),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6726),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6726),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6726),
    [anon_sym_BSLASHtext] = ACTIONS(6726),
    [anon_sym_BSLASHintertext] = ACTIONS(6726),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6726),
    [anon_sym_BSLASHurl] = ACTIONS(6726),
    [anon_sym_BSLASHhref] = ACTIONS(6726),
  },
  [644] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(708),
    [aux_sym__section_repeat5] = STATE(708),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [645] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [646] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(6007),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6007),
    [anon_sym_LBRACK] = ACTIONS(6009),
    [anon_sym_RBRACK] = ACTIONS(6009),
    [anon_sym_COMMA] = ACTIONS(6009),
    [anon_sym_EQ] = ACTIONS(6009),
    [anon_sym_LPAREN] = ACTIONS(6009),
    [anon_sym_RPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHpart] = ACTIONS(6007),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddpart] = ACTIONS(6007),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHchapter] = ACTIONS(6007),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddchap] = ACTIONS(6007),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsection] = ACTIONS(6730),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6733),
    [anon_sym_BSLASHaddsec] = ACTIONS(6730),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6733),
    [anon_sym_BSLASHsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHitem] = ACTIONS(6007),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6009),
    [anon_sym_LBRACE] = ACTIONS(6009),
    [sym_word] = ACTIONS(6007),
    [sym_placeholder] = ACTIONS(6009),
    [anon_sym_PLUS] = ACTIONS(6009),
    [anon_sym_DASH] = ACTIONS(6009),
    [anon_sym_STAR] = ACTIONS(6009),
    [anon_sym_SLASH] = ACTIONS(6009),
    [anon_sym_LT] = ACTIONS(6007),
    [anon_sym_GT] = ACTIONS(6007),
    [anon_sym_BANG] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6007),
    [anon_sym_COLON] = ACTIONS(6007),
    [anon_sym_SQUOTE] = ACTIONS(6007),
    [anon_sym__] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(6009),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6009),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6009),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6009),
    [anon_sym_DOLLAR] = ACTIONS(6007),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHbegin] = ACTIONS(6007),
    [anon_sym_BSLASHtitle] = ACTIONS(6007),
    [anon_sym_BSLASHauthor] = ACTIONS(6007),
    [anon_sym_BSLASHusepackage] = ACTIONS(6007),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6007),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6007),
    [anon_sym_BSLASHinclude] = ACTIONS(6007),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6007),
    [anon_sym_BSLASHinput] = ACTIONS(6007),
    [anon_sym_BSLASHsubfile] = ACTIONS(6007),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6007),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6007),
    [anon_sym_BSLASHbibliography] = ACTIONS(6007),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6007),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6007),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6007),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6007),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6007),
    [anon_sym_BSLASHimport] = ACTIONS(6007),
    [anon_sym_BSLASHsubimport] = ACTIONS(6007),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6007),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHcaption] = ACTIONS(6007),
    [anon_sym_BSLASHcite] = ACTIONS(6007),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCite] = ACTIONS(6007),
    [anon_sym_BSLASHnocite] = ACTIONS(6007),
    [anon_sym_BSLASHcitet] = ACTIONS(6007),
    [anon_sym_BSLASHcitep] = ACTIONS(6007),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteA] = ACTIONS(6007),
    [anon_sym_BSLASHciteR] = ACTIONS(6007),
    [anon_sym_BSLASHciteS] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6007),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteyear] = ACTIONS(6007),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitedate] = ACTIONS(6007),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteurl] = ACTIONS(6007),
    [anon_sym_BSLASHfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6007),
    [anon_sym_BSLASHcitealt] = ACTIONS(6007),
    [anon_sym_BSLASHcitealp] = ACTIONS(6007),
    [anon_sym_BSLASHcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHparencite] = ACTIONS(6007),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHParencite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHtextcite] = ACTIONS(6007),
    [anon_sym_BSLASHTextcite] = ACTIONS(6007),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHsupercite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite] = ACTIONS(6007),
    [anon_sym_BSLASHAutocite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHVolcite] = ACTIONS(6007),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHavolcite] = ACTIONS(6007),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHNotecite] = ACTIONS(6007),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHlabel] = ACTIONS(6007),
    [anon_sym_BSLASHref] = ACTIONS(6007),
    [anon_sym_BSLASHeqref] = ACTIONS(6007),
    [anon_sym_BSLASHvref] = ACTIONS(6007),
    [anon_sym_BSLASHVref] = ACTIONS(6007),
    [anon_sym_BSLASHautoref] = ACTIONS(6007),
    [anon_sym_BSLASHpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcref] = ACTIONS(6007),
    [anon_sym_BSLASHCref] = ACTIONS(6007),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnameCref] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHdef] = ACTIONS(6007),
    [anon_sym_BSLASHlet] = ACTIONS(6007),
    [anon_sym_BSLASHleft] = ACTIONS(6007),
    [anon_sym_BSLASHbigl] = ACTIONS(6007),
    [anon_sym_BSLASHBigl] = ACTIONS(6007),
    [anon_sym_BSLASHbiggl] = ACTIONS(6007),
    [anon_sym_BSLASHBiggl] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6007),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6007),
    [anon_sym_BSLASHgls] = ACTIONS(6007),
    [anon_sym_BSLASHGls] = ACTIONS(6007),
    [anon_sym_BSLASHGLS] = ACTIONS(6007),
    [anon_sym_BSLASHglspl] = ACTIONS(6007),
    [anon_sym_BSLASHGlspl] = ACTIONS(6007),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6007),
    [anon_sym_BSLASHglslink] = ACTIONS(6007),
    [anon_sym_BSLASHglstext] = ACTIONS(6007),
    [anon_sym_BSLASHGlstext] = ACTIONS(6007),
    [anon_sym_BSLASHGLStext] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6007),
    [anon_sym_BSLASHglsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsname] = ACTIONS(6007),
    [anon_sym_BSLASHGlsname] = ACTIONS(6007),
    [anon_sym_BSLASHGLSname] = ACTIONS(6007),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6007),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6007),
    [anon_sym_BSLASHacrshort] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6007),
    [anon_sym_BSLASHACRshort] = ACTIONS(6007),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrlong] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6007),
    [anon_sym_BSLASHACRlong] = ACTIONS(6007),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrfull] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6007),
    [anon_sym_BSLASHACRfull] = ACTIONS(6007),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHacs] = ACTIONS(6007),
    [anon_sym_BSLASHAcs] = ACTIONS(6007),
    [anon_sym_BSLASHacsp] = ACTIONS(6007),
    [anon_sym_BSLASHAcsp] = ACTIONS(6007),
    [anon_sym_BSLASHacl] = ACTIONS(6007),
    [anon_sym_BSLASHAcl] = ACTIONS(6007),
    [anon_sym_BSLASHaclp] = ACTIONS(6007),
    [anon_sym_BSLASHAclp] = ACTIONS(6007),
    [anon_sym_BSLASHacf] = ACTIONS(6007),
    [anon_sym_BSLASHAcf] = ACTIONS(6007),
    [anon_sym_BSLASHacfp] = ACTIONS(6007),
    [anon_sym_BSLASHAcfp] = ACTIONS(6007),
    [anon_sym_BSLASHac] = ACTIONS(6007),
    [anon_sym_BSLASHAc] = ACTIONS(6007),
    [anon_sym_BSLASHacp] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6007),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6007),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6007),
    [anon_sym_BSLASHcolor] = ACTIONS(6007),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6007),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6007),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6007),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6007),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6007),
    [anon_sym_BSLASHtext] = ACTIONS(6007),
    [anon_sym_BSLASHintertext] = ACTIONS(6007),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6007),
    [anon_sym_BSLASHurl] = ACTIONS(6007),
    [anon_sym_BSLASHhref] = ACTIONS(6007),
  },
  [647] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(5961),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5963),
    [anon_sym_RBRACK] = ACTIONS(5963),
    [anon_sym_COMMA] = ACTIONS(5963),
    [anon_sym_EQ] = ACTIONS(5963),
    [anon_sym_LPAREN] = ACTIONS(5963),
    [anon_sym_RPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHpart] = ACTIONS(5961),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddpart] = ACTIONS(5961),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHchapter] = ACTIONS(5961),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddchap] = ACTIONS(5961),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsection] = ACTIONS(5961),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddsec] = ACTIONS(5961),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubsection] = ACTIONS(6736),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6739),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5961),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHitem] = ACTIONS(5961),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5963),
    [anon_sym_LBRACE] = ACTIONS(5963),
    [sym_word] = ACTIONS(5961),
    [sym_placeholder] = ACTIONS(5963),
    [anon_sym_PLUS] = ACTIONS(5963),
    [anon_sym_DASH] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_SLASH] = ACTIONS(5963),
    [anon_sym_LT] = ACTIONS(5961),
    [anon_sym_GT] = ACTIONS(5961),
    [anon_sym_BANG] = ACTIONS(5961),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_COLON] = ACTIONS(5961),
    [anon_sym_SQUOTE] = ACTIONS(5961),
    [anon_sym__] = ACTIONS(5963),
    [anon_sym_CARET] = ACTIONS(5963),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5963),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5963),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5963),
    [anon_sym_DOLLAR] = ACTIONS(5961),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHbegin] = ACTIONS(5961),
    [anon_sym_BSLASHtitle] = ACTIONS(5961),
    [anon_sym_BSLASHauthor] = ACTIONS(5961),
    [anon_sym_BSLASHusepackage] = ACTIONS(5961),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5961),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5961),
    [anon_sym_BSLASHinclude] = ACTIONS(5961),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5961),
    [anon_sym_BSLASHinput] = ACTIONS(5961),
    [anon_sym_BSLASHsubfile] = ACTIONS(5961),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5961),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5961),
    [anon_sym_BSLASHbibliography] = ACTIONS(5961),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5961),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5961),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5961),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5961),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5961),
    [anon_sym_BSLASHimport] = ACTIONS(5961),
    [anon_sym_BSLASHsubimport] = ACTIONS(5961),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5961),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHcaption] = ACTIONS(5961),
    [anon_sym_BSLASHcite] = ACTIONS(5961),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCite] = ACTIONS(5961),
    [anon_sym_BSLASHnocite] = ACTIONS(5961),
    [anon_sym_BSLASHcitet] = ACTIONS(5961),
    [anon_sym_BSLASHcitep] = ACTIONS(5961),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteA] = ACTIONS(5961),
    [anon_sym_BSLASHciteR] = ACTIONS(5961),
    [anon_sym_BSLASHciteS] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5961),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteyear] = ACTIONS(5961),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitedate] = ACTIONS(5961),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteurl] = ACTIONS(5961),
    [anon_sym_BSLASHfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5961),
    [anon_sym_BSLASHcitealt] = ACTIONS(5961),
    [anon_sym_BSLASHcitealp] = ACTIONS(5961),
    [anon_sym_BSLASHcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHparencite] = ACTIONS(5961),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHParencite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHtextcite] = ACTIONS(5961),
    [anon_sym_BSLASHTextcite] = ACTIONS(5961),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHsupercite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite] = ACTIONS(5961),
    [anon_sym_BSLASHAutocite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHVolcite] = ACTIONS(5961),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHavolcite] = ACTIONS(5961),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHNotecite] = ACTIONS(5961),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHlabel] = ACTIONS(5961),
    [anon_sym_BSLASHref] = ACTIONS(5961),
    [anon_sym_BSLASHeqref] = ACTIONS(5961),
    [anon_sym_BSLASHvref] = ACTIONS(5961),
    [anon_sym_BSLASHVref] = ACTIONS(5961),
    [anon_sym_BSLASHautoref] = ACTIONS(5961),
    [anon_sym_BSLASHpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcref] = ACTIONS(5961),
    [anon_sym_BSLASHCref] = ACTIONS(5961),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnameCref] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHdef] = ACTIONS(5961),
    [anon_sym_BSLASHlet] = ACTIONS(5961),
    [anon_sym_BSLASHleft] = ACTIONS(5961),
    [anon_sym_BSLASHbigl] = ACTIONS(5961),
    [anon_sym_BSLASHBigl] = ACTIONS(5961),
    [anon_sym_BSLASHbiggl] = ACTIONS(5961),
    [anon_sym_BSLASHBiggl] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5961),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5961),
    [anon_sym_BSLASHgls] = ACTIONS(5961),
    [anon_sym_BSLASHGls] = ACTIONS(5961),
    [anon_sym_BSLASHGLS] = ACTIONS(5961),
    [anon_sym_BSLASHglspl] = ACTIONS(5961),
    [anon_sym_BSLASHGlspl] = ACTIONS(5961),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5961),
    [anon_sym_BSLASHglslink] = ACTIONS(5961),
    [anon_sym_BSLASHglstext] = ACTIONS(5961),
    [anon_sym_BSLASHGlstext] = ACTIONS(5961),
    [anon_sym_BSLASHGLStext] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5961),
    [anon_sym_BSLASHglsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsname] = ACTIONS(5961),
    [anon_sym_BSLASHGlsname] = ACTIONS(5961),
    [anon_sym_BSLASHGLSname] = ACTIONS(5961),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5961),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5961),
    [anon_sym_BSLASHacrshort] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5961),
    [anon_sym_BSLASHACRshort] = ACTIONS(5961),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrlong] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5961),
    [anon_sym_BSLASHACRlong] = ACTIONS(5961),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrfull] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5961),
    [anon_sym_BSLASHACRfull] = ACTIONS(5961),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHacs] = ACTIONS(5961),
    [anon_sym_BSLASHAcs] = ACTIONS(5961),
    [anon_sym_BSLASHacsp] = ACTIONS(5961),
    [anon_sym_BSLASHAcsp] = ACTIONS(5961),
    [anon_sym_BSLASHacl] = ACTIONS(5961),
    [anon_sym_BSLASHAcl] = ACTIONS(5961),
    [anon_sym_BSLASHaclp] = ACTIONS(5961),
    [anon_sym_BSLASHAclp] = ACTIONS(5961),
    [anon_sym_BSLASHacf] = ACTIONS(5961),
    [anon_sym_BSLASHAcf] = ACTIONS(5961),
    [anon_sym_BSLASHacfp] = ACTIONS(5961),
    [anon_sym_BSLASHAcfp] = ACTIONS(5961),
    [anon_sym_BSLASHac] = ACTIONS(5961),
    [anon_sym_BSLASHAc] = ACTIONS(5961),
    [anon_sym_BSLASHacp] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5961),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5961),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5961),
    [anon_sym_BSLASHcolor] = ACTIONS(5961),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5961),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5961),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5961),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5961),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5961),
    [anon_sym_BSLASHtext] = ACTIONS(5961),
    [anon_sym_BSLASHintertext] = ACTIONS(5961),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5961),
    [anon_sym_BSLASHurl] = ACTIONS(5961),
    [anon_sym_BSLASHhref] = ACTIONS(5961),
  },
  [648] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(6017),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6017),
    [anon_sym_LBRACK] = ACTIONS(6019),
    [anon_sym_RBRACK] = ACTIONS(6019),
    [anon_sym_COMMA] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6019),
    [anon_sym_LPAREN] = ACTIONS(6019),
    [anon_sym_RPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHpart] = ACTIONS(6017),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddpart] = ACTIONS(6017),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHchapter] = ACTIONS(6017),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddchap] = ACTIONS(6017),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsection] = ACTIONS(6017),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddsec] = ACTIONS(6017),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsection] = ACTIONS(6017),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6742),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6745),
    [anon_sym_BSLASHparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHitem] = ACTIONS(6017),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6019),
    [anon_sym_LBRACE] = ACTIONS(6019),
    [sym_word] = ACTIONS(6017),
    [sym_placeholder] = ACTIONS(6019),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6019),
    [anon_sym_SLASH] = ACTIONS(6019),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_BANG] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6017),
    [anon_sym_COLON] = ACTIONS(6017),
    [anon_sym_SQUOTE] = ACTIONS(6017),
    [anon_sym__] = ACTIONS(6019),
    [anon_sym_CARET] = ACTIONS(6019),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6019),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6019),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6019),
    [anon_sym_DOLLAR] = ACTIONS(6017),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHbegin] = ACTIONS(6017),
    [anon_sym_BSLASHtitle] = ACTIONS(6017),
    [anon_sym_BSLASHauthor] = ACTIONS(6017),
    [anon_sym_BSLASHusepackage] = ACTIONS(6017),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6017),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6017),
    [anon_sym_BSLASHinclude] = ACTIONS(6017),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6017),
    [anon_sym_BSLASHinput] = ACTIONS(6017),
    [anon_sym_BSLASHsubfile] = ACTIONS(6017),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6017),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6017),
    [anon_sym_BSLASHbibliography] = ACTIONS(6017),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6017),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6017),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6017),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6017),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6017),
    [anon_sym_BSLASHimport] = ACTIONS(6017),
    [anon_sym_BSLASHsubimport] = ACTIONS(6017),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6017),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHcaption] = ACTIONS(6017),
    [anon_sym_BSLASHcite] = ACTIONS(6017),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCite] = ACTIONS(6017),
    [anon_sym_BSLASHnocite] = ACTIONS(6017),
    [anon_sym_BSLASHcitet] = ACTIONS(6017),
    [anon_sym_BSLASHcitep] = ACTIONS(6017),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteA] = ACTIONS(6017),
    [anon_sym_BSLASHciteR] = ACTIONS(6017),
    [anon_sym_BSLASHciteS] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6017),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteyear] = ACTIONS(6017),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitedate] = ACTIONS(6017),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteurl] = ACTIONS(6017),
    [anon_sym_BSLASHfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6017),
    [anon_sym_BSLASHcitealt] = ACTIONS(6017),
    [anon_sym_BSLASHcitealp] = ACTIONS(6017),
    [anon_sym_BSLASHcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHparencite] = ACTIONS(6017),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHParencite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHtextcite] = ACTIONS(6017),
    [anon_sym_BSLASHTextcite] = ACTIONS(6017),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHsupercite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite] = ACTIONS(6017),
    [anon_sym_BSLASHAutocite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHVolcite] = ACTIONS(6017),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHavolcite] = ACTIONS(6017),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHNotecite] = ACTIONS(6017),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHlabel] = ACTIONS(6017),
    [anon_sym_BSLASHref] = ACTIONS(6017),
    [anon_sym_BSLASHeqref] = ACTIONS(6017),
    [anon_sym_BSLASHvref] = ACTIONS(6017),
    [anon_sym_BSLASHVref] = ACTIONS(6017),
    [anon_sym_BSLASHautoref] = ACTIONS(6017),
    [anon_sym_BSLASHpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcref] = ACTIONS(6017),
    [anon_sym_BSLASHCref] = ACTIONS(6017),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnameCref] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHdef] = ACTIONS(6017),
    [anon_sym_BSLASHlet] = ACTIONS(6017),
    [anon_sym_BSLASHleft] = ACTIONS(6017),
    [anon_sym_BSLASHbigl] = ACTIONS(6017),
    [anon_sym_BSLASHBigl] = ACTIONS(6017),
    [anon_sym_BSLASHbiggl] = ACTIONS(6017),
    [anon_sym_BSLASHBiggl] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6017),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6017),
    [anon_sym_BSLASHgls] = ACTIONS(6017),
    [anon_sym_BSLASHGls] = ACTIONS(6017),
    [anon_sym_BSLASHGLS] = ACTIONS(6017),
    [anon_sym_BSLASHglspl] = ACTIONS(6017),
    [anon_sym_BSLASHGlspl] = ACTIONS(6017),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6017),
    [anon_sym_BSLASHglslink] = ACTIONS(6017),
    [anon_sym_BSLASHglstext] = ACTIONS(6017),
    [anon_sym_BSLASHGlstext] = ACTIONS(6017),
    [anon_sym_BSLASHGLStext] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6017),
    [anon_sym_BSLASHglsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsname] = ACTIONS(6017),
    [anon_sym_BSLASHGlsname] = ACTIONS(6017),
    [anon_sym_BSLASHGLSname] = ACTIONS(6017),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6017),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6017),
    [anon_sym_BSLASHacrshort] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6017),
    [anon_sym_BSLASHACRshort] = ACTIONS(6017),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrlong] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6017),
    [anon_sym_BSLASHACRlong] = ACTIONS(6017),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrfull] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6017),
    [anon_sym_BSLASHACRfull] = ACTIONS(6017),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHacs] = ACTIONS(6017),
    [anon_sym_BSLASHAcs] = ACTIONS(6017),
    [anon_sym_BSLASHacsp] = ACTIONS(6017),
    [anon_sym_BSLASHAcsp] = ACTIONS(6017),
    [anon_sym_BSLASHacl] = ACTIONS(6017),
    [anon_sym_BSLASHAcl] = ACTIONS(6017),
    [anon_sym_BSLASHaclp] = ACTIONS(6017),
    [anon_sym_BSLASHAclp] = ACTIONS(6017),
    [anon_sym_BSLASHacf] = ACTIONS(6017),
    [anon_sym_BSLASHAcf] = ACTIONS(6017),
    [anon_sym_BSLASHacfp] = ACTIONS(6017),
    [anon_sym_BSLASHAcfp] = ACTIONS(6017),
    [anon_sym_BSLASHac] = ACTIONS(6017),
    [anon_sym_BSLASHAc] = ACTIONS(6017),
    [anon_sym_BSLASHacp] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6017),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6017),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6017),
    [anon_sym_BSLASHcolor] = ACTIONS(6017),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6017),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6017),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6017),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6017),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6017),
    [anon_sym_BSLASHtext] = ACTIONS(6017),
    [anon_sym_BSLASHintertext] = ACTIONS(6017),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6017),
    [anon_sym_BSLASHurl] = ACTIONS(6017),
    [anon_sym_BSLASHhref] = ACTIONS(6017),
  },
  [649] = {
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(649),
    [aux_sym__paragraph_repeat1] = STATE(649),
    [sym_command_name] = ACTIONS(6027),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6027),
    [anon_sym_LBRACK] = ACTIONS(6029),
    [anon_sym_RBRACK] = ACTIONS(6029),
    [anon_sym_COMMA] = ACTIONS(6029),
    [anon_sym_EQ] = ACTIONS(6029),
    [anon_sym_LPAREN] = ACTIONS(6029),
    [anon_sym_RPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHpart] = ACTIONS(6027),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddpart] = ACTIONS(6027),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHchapter] = ACTIONS(6027),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddchap] = ACTIONS(6027),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsection] = ACTIONS(6027),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddsec] = ACTIONS(6027),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHparagraph] = ACTIONS(6748),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6751),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6027),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHitem] = ACTIONS(6027),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6029),
    [anon_sym_LBRACE] = ACTIONS(6029),
    [sym_word] = ACTIONS(6027),
    [sym_placeholder] = ACTIONS(6029),
    [anon_sym_PLUS] = ACTIONS(6029),
    [anon_sym_DASH] = ACTIONS(6029),
    [anon_sym_STAR] = ACTIONS(6029),
    [anon_sym_SLASH] = ACTIONS(6029),
    [anon_sym_LT] = ACTIONS(6027),
    [anon_sym_GT] = ACTIONS(6027),
    [anon_sym_BANG] = ACTIONS(6027),
    [anon_sym_PIPE] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6027),
    [anon_sym_SQUOTE] = ACTIONS(6027),
    [anon_sym__] = ACTIONS(6029),
    [anon_sym_CARET] = ACTIONS(6029),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6029),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6029),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6027),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHbegin] = ACTIONS(6027),
    [anon_sym_BSLASHtitle] = ACTIONS(6027),
    [anon_sym_BSLASHauthor] = ACTIONS(6027),
    [anon_sym_BSLASHusepackage] = ACTIONS(6027),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6027),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6027),
    [anon_sym_BSLASHinclude] = ACTIONS(6027),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6027),
    [anon_sym_BSLASHinput] = ACTIONS(6027),
    [anon_sym_BSLASHsubfile] = ACTIONS(6027),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6027),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6027),
    [anon_sym_BSLASHbibliography] = ACTIONS(6027),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6027),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6027),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6027),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6027),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6027),
    [anon_sym_BSLASHimport] = ACTIONS(6027),
    [anon_sym_BSLASHsubimport] = ACTIONS(6027),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6027),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHcaption] = ACTIONS(6027),
    [anon_sym_BSLASHcite] = ACTIONS(6027),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCite] = ACTIONS(6027),
    [anon_sym_BSLASHnocite] = ACTIONS(6027),
    [anon_sym_BSLASHcitet] = ACTIONS(6027),
    [anon_sym_BSLASHcitep] = ACTIONS(6027),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteA] = ACTIONS(6027),
    [anon_sym_BSLASHciteR] = ACTIONS(6027),
    [anon_sym_BSLASHciteS] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6027),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteyear] = ACTIONS(6027),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitedate] = ACTIONS(6027),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteurl] = ACTIONS(6027),
    [anon_sym_BSLASHfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6027),
    [anon_sym_BSLASHcitealt] = ACTIONS(6027),
    [anon_sym_BSLASHcitealp] = ACTIONS(6027),
    [anon_sym_BSLASHcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHparencite] = ACTIONS(6027),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHParencite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHtextcite] = ACTIONS(6027),
    [anon_sym_BSLASHTextcite] = ACTIONS(6027),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHsupercite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite] = ACTIONS(6027),
    [anon_sym_BSLASHAutocite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHVolcite] = ACTIONS(6027),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHavolcite] = ACTIONS(6027),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHNotecite] = ACTIONS(6027),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHlabel] = ACTIONS(6027),
    [anon_sym_BSLASHref] = ACTIONS(6027),
    [anon_sym_BSLASHeqref] = ACTIONS(6027),
    [anon_sym_BSLASHvref] = ACTIONS(6027),
    [anon_sym_BSLASHVref] = ACTIONS(6027),
    [anon_sym_BSLASHautoref] = ACTIONS(6027),
    [anon_sym_BSLASHpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcref] = ACTIONS(6027),
    [anon_sym_BSLASHCref] = ACTIONS(6027),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnameCref] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHdef] = ACTIONS(6027),
    [anon_sym_BSLASHlet] = ACTIONS(6027),
    [anon_sym_BSLASHleft] = ACTIONS(6027),
    [anon_sym_BSLASHbigl] = ACTIONS(6027),
    [anon_sym_BSLASHBigl] = ACTIONS(6027),
    [anon_sym_BSLASHbiggl] = ACTIONS(6027),
    [anon_sym_BSLASHBiggl] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6027),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6027),
    [anon_sym_BSLASHgls] = ACTIONS(6027),
    [anon_sym_BSLASHGls] = ACTIONS(6027),
    [anon_sym_BSLASHGLS] = ACTIONS(6027),
    [anon_sym_BSLASHglspl] = ACTIONS(6027),
    [anon_sym_BSLASHGlspl] = ACTIONS(6027),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6027),
    [anon_sym_BSLASHglslink] = ACTIONS(6027),
    [anon_sym_BSLASHglstext] = ACTIONS(6027),
    [anon_sym_BSLASHGlstext] = ACTIONS(6027),
    [anon_sym_BSLASHGLStext] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6027),
    [anon_sym_BSLASHglsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsname] = ACTIONS(6027),
    [anon_sym_BSLASHGlsname] = ACTIONS(6027),
    [anon_sym_BSLASHGLSname] = ACTIONS(6027),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6027),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6027),
    [anon_sym_BSLASHacrshort] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6027),
    [anon_sym_BSLASHACRshort] = ACTIONS(6027),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrlong] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6027),
    [anon_sym_BSLASHACRlong] = ACTIONS(6027),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrfull] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6027),
    [anon_sym_BSLASHACRfull] = ACTIONS(6027),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHacs] = ACTIONS(6027),
    [anon_sym_BSLASHAcs] = ACTIONS(6027),
    [anon_sym_BSLASHacsp] = ACTIONS(6027),
    [anon_sym_BSLASHAcsp] = ACTIONS(6027),
    [anon_sym_BSLASHacl] = ACTIONS(6027),
    [anon_sym_BSLASHAcl] = ACTIONS(6027),
    [anon_sym_BSLASHaclp] = ACTIONS(6027),
    [anon_sym_BSLASHAclp] = ACTIONS(6027),
    [anon_sym_BSLASHacf] = ACTIONS(6027),
    [anon_sym_BSLASHAcf] = ACTIONS(6027),
    [anon_sym_BSLASHacfp] = ACTIONS(6027),
    [anon_sym_BSLASHAcfp] = ACTIONS(6027),
    [anon_sym_BSLASHac] = ACTIONS(6027),
    [anon_sym_BSLASHAc] = ACTIONS(6027),
    [anon_sym_BSLASHacp] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6027),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6027),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6027),
    [anon_sym_BSLASHcolor] = ACTIONS(6027),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6027),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6027),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6027),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6027),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6027),
    [anon_sym_BSLASHtext] = ACTIONS(6027),
    [anon_sym_BSLASHintertext] = ACTIONS(6027),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6027),
    [anon_sym_BSLASHurl] = ACTIONS(6027),
    [anon_sym_BSLASHhref] = ACTIONS(6027),
  },
  [650] = {
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(650),
    [aux_sym__paragraph_repeat2] = STATE(650),
    [sym_command_name] = ACTIONS(6037),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(6039),
    [anon_sym_RBRACK] = ACTIONS(6039),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_EQ] = ACTIONS(6039),
    [anon_sym_LPAREN] = ACTIONS(6039),
    [anon_sym_RPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHpart] = ACTIONS(6037),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddpart] = ACTIONS(6037),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHchapter] = ACTIONS(6037),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddchap] = ACTIONS(6037),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsection] = ACTIONS(6037),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddsec] = ACTIONS(6037),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHparagraph] = ACTIONS(6037),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6754),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6757),
    [anon_sym_BSLASHitem] = ACTIONS(6037),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6039),
    [anon_sym_LBRACE] = ACTIONS(6039),
    [sym_word] = ACTIONS(6037),
    [sym_placeholder] = ACTIONS(6039),
    [anon_sym_PLUS] = ACTIONS(6039),
    [anon_sym_DASH] = ACTIONS(6039),
    [anon_sym_STAR] = ACTIONS(6039),
    [anon_sym_SLASH] = ACTIONS(6039),
    [anon_sym_LT] = ACTIONS(6037),
    [anon_sym_GT] = ACTIONS(6037),
    [anon_sym_BANG] = ACTIONS(6037),
    [anon_sym_PIPE] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6037),
    [anon_sym_SQUOTE] = ACTIONS(6037),
    [anon_sym__] = ACTIONS(6039),
    [anon_sym_CARET] = ACTIONS(6039),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6039),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6039),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6039),
    [anon_sym_DOLLAR] = ACTIONS(6037),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHbegin] = ACTIONS(6037),
    [anon_sym_BSLASHtitle] = ACTIONS(6037),
    [anon_sym_BSLASHauthor] = ACTIONS(6037),
    [anon_sym_BSLASHusepackage] = ACTIONS(6037),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6037),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6037),
    [anon_sym_BSLASHinclude] = ACTIONS(6037),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6037),
    [anon_sym_BSLASHinput] = ACTIONS(6037),
    [anon_sym_BSLASHsubfile] = ACTIONS(6037),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6037),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6037),
    [anon_sym_BSLASHbibliography] = ACTIONS(6037),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6037),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6037),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6037),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6037),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6037),
    [anon_sym_BSLASHimport] = ACTIONS(6037),
    [anon_sym_BSLASHsubimport] = ACTIONS(6037),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6037),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHcaption] = ACTIONS(6037),
    [anon_sym_BSLASHcite] = ACTIONS(6037),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCite] = ACTIONS(6037),
    [anon_sym_BSLASHnocite] = ACTIONS(6037),
    [anon_sym_BSLASHcitet] = ACTIONS(6037),
    [anon_sym_BSLASHcitep] = ACTIONS(6037),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteA] = ACTIONS(6037),
    [anon_sym_BSLASHciteR] = ACTIONS(6037),
    [anon_sym_BSLASHciteS] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6037),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteyear] = ACTIONS(6037),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitedate] = ACTIONS(6037),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteurl] = ACTIONS(6037),
    [anon_sym_BSLASHfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6037),
    [anon_sym_BSLASHcitealt] = ACTIONS(6037),
    [anon_sym_BSLASHcitealp] = ACTIONS(6037),
    [anon_sym_BSLASHcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHparencite] = ACTIONS(6037),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHParencite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHtextcite] = ACTIONS(6037),
    [anon_sym_BSLASHTextcite] = ACTIONS(6037),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHsupercite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite] = ACTIONS(6037),
    [anon_sym_BSLASHAutocite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHVolcite] = ACTIONS(6037),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHavolcite] = ACTIONS(6037),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHNotecite] = ACTIONS(6037),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHlabel] = ACTIONS(6037),
    [anon_sym_BSLASHref] = ACTIONS(6037),
    [anon_sym_BSLASHeqref] = ACTIONS(6037),
    [anon_sym_BSLASHvref] = ACTIONS(6037),
    [anon_sym_BSLASHVref] = ACTIONS(6037),
    [anon_sym_BSLASHautoref] = ACTIONS(6037),
    [anon_sym_BSLASHpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcref] = ACTIONS(6037),
    [anon_sym_BSLASHCref] = ACTIONS(6037),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnameCref] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHdef] = ACTIONS(6037),
    [anon_sym_BSLASHlet] = ACTIONS(6037),
    [anon_sym_BSLASHleft] = ACTIONS(6037),
    [anon_sym_BSLASHbigl] = ACTIONS(6037),
    [anon_sym_BSLASHBigl] = ACTIONS(6037),
    [anon_sym_BSLASHbiggl] = ACTIONS(6037),
    [anon_sym_BSLASHBiggl] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6037),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6037),
    [anon_sym_BSLASHgls] = ACTIONS(6037),
    [anon_sym_BSLASHGls] = ACTIONS(6037),
    [anon_sym_BSLASHGLS] = ACTIONS(6037),
    [anon_sym_BSLASHglspl] = ACTIONS(6037),
    [anon_sym_BSLASHGlspl] = ACTIONS(6037),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6037),
    [anon_sym_BSLASHglslink] = ACTIONS(6037),
    [anon_sym_BSLASHglstext] = ACTIONS(6037),
    [anon_sym_BSLASHGlstext] = ACTIONS(6037),
    [anon_sym_BSLASHGLStext] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6037),
    [anon_sym_BSLASHglsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsname] = ACTIONS(6037),
    [anon_sym_BSLASHGlsname] = ACTIONS(6037),
    [anon_sym_BSLASHGLSname] = ACTIONS(6037),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6037),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6037),
    [anon_sym_BSLASHacrshort] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6037),
    [anon_sym_BSLASHACRshort] = ACTIONS(6037),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrlong] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6037),
    [anon_sym_BSLASHACRlong] = ACTIONS(6037),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrfull] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6037),
    [anon_sym_BSLASHACRfull] = ACTIONS(6037),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHacs] = ACTIONS(6037),
    [anon_sym_BSLASHAcs] = ACTIONS(6037),
    [anon_sym_BSLASHacsp] = ACTIONS(6037),
    [anon_sym_BSLASHAcsp] = ACTIONS(6037),
    [anon_sym_BSLASHacl] = ACTIONS(6037),
    [anon_sym_BSLASHAcl] = ACTIONS(6037),
    [anon_sym_BSLASHaclp] = ACTIONS(6037),
    [anon_sym_BSLASHAclp] = ACTIONS(6037),
    [anon_sym_BSLASHacf] = ACTIONS(6037),
    [anon_sym_BSLASHAcf] = ACTIONS(6037),
    [anon_sym_BSLASHacfp] = ACTIONS(6037),
    [anon_sym_BSLASHAcfp] = ACTIONS(6037),
    [anon_sym_BSLASHac] = ACTIONS(6037),
    [anon_sym_BSLASHAc] = ACTIONS(6037),
    [anon_sym_BSLASHacp] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6037),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6037),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6037),
    [anon_sym_BSLASHcolor] = ACTIONS(6037),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6037),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6037),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6037),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6037),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6037),
    [anon_sym_BSLASHtext] = ACTIONS(6037),
    [anon_sym_BSLASHintertext] = ACTIONS(6037),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6037),
    [anon_sym_BSLASHurl] = ACTIONS(6037),
    [anon_sym_BSLASHhref] = ACTIONS(6037),
  },
  [651] = {
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(651),
    [aux_sym__paragraph_repeat3] = STATE(651),
    [sym_command_name] = ACTIONS(6047),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(6049),
    [anon_sym_RBRACK] = ACTIONS(6049),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(6049),
    [anon_sym_RPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHpart] = ACTIONS(6047),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddpart] = ACTIONS(6047),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHchapter] = ACTIONS(6047),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddchap] = ACTIONS(6047),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsection] = ACTIONS(6047),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddsec] = ACTIONS(6047),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHitem] = ACTIONS(6760),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6763),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_word] = ACTIONS(6047),
    [sym_placeholder] = ACTIONS(6049),
    [anon_sym_PLUS] = ACTIONS(6049),
    [anon_sym_DASH] = ACTIONS(6049),
    [anon_sym_STAR] = ACTIONS(6049),
    [anon_sym_SLASH] = ACTIONS(6049),
    [anon_sym_LT] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6047),
    [anon_sym_BANG] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6047),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SQUOTE] = ACTIONS(6047),
    [anon_sym__] = ACTIONS(6049),
    [anon_sym_CARET] = ACTIONS(6049),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6049),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6049),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6049),
    [anon_sym_DOLLAR] = ACTIONS(6047),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHbegin] = ACTIONS(6047),
    [anon_sym_BSLASHtitle] = ACTIONS(6047),
    [anon_sym_BSLASHauthor] = ACTIONS(6047),
    [anon_sym_BSLASHusepackage] = ACTIONS(6047),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6047),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6047),
    [anon_sym_BSLASHinclude] = ACTIONS(6047),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6047),
    [anon_sym_BSLASHinput] = ACTIONS(6047),
    [anon_sym_BSLASHsubfile] = ACTIONS(6047),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6047),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6047),
    [anon_sym_BSLASHbibliography] = ACTIONS(6047),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6047),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6047),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6047),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6047),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6047),
    [anon_sym_BSLASHimport] = ACTIONS(6047),
    [anon_sym_BSLASHsubimport] = ACTIONS(6047),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6047),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHcaption] = ACTIONS(6047),
    [anon_sym_BSLASHcite] = ACTIONS(6047),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCite] = ACTIONS(6047),
    [anon_sym_BSLASHnocite] = ACTIONS(6047),
    [anon_sym_BSLASHcitet] = ACTIONS(6047),
    [anon_sym_BSLASHcitep] = ACTIONS(6047),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteA] = ACTIONS(6047),
    [anon_sym_BSLASHciteR] = ACTIONS(6047),
    [anon_sym_BSLASHciteS] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6047),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteyear] = ACTIONS(6047),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitedate] = ACTIONS(6047),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteurl] = ACTIONS(6047),
    [anon_sym_BSLASHfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6047),
    [anon_sym_BSLASHcitealt] = ACTIONS(6047),
    [anon_sym_BSLASHcitealp] = ACTIONS(6047),
    [anon_sym_BSLASHcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHparencite] = ACTIONS(6047),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHParencite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHtextcite] = ACTIONS(6047),
    [anon_sym_BSLASHTextcite] = ACTIONS(6047),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHsupercite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite] = ACTIONS(6047),
    [anon_sym_BSLASHAutocite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHVolcite] = ACTIONS(6047),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHavolcite] = ACTIONS(6047),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHNotecite] = ACTIONS(6047),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHlabel] = ACTIONS(6047),
    [anon_sym_BSLASHref] = ACTIONS(6047),
    [anon_sym_BSLASHeqref] = ACTIONS(6047),
    [anon_sym_BSLASHvref] = ACTIONS(6047),
    [anon_sym_BSLASHVref] = ACTIONS(6047),
    [anon_sym_BSLASHautoref] = ACTIONS(6047),
    [anon_sym_BSLASHpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcref] = ACTIONS(6047),
    [anon_sym_BSLASHCref] = ACTIONS(6047),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnameCref] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHdef] = ACTIONS(6047),
    [anon_sym_BSLASHlet] = ACTIONS(6047),
    [anon_sym_BSLASHleft] = ACTIONS(6047),
    [anon_sym_BSLASHbigl] = ACTIONS(6047),
    [anon_sym_BSLASHBigl] = ACTIONS(6047),
    [anon_sym_BSLASHbiggl] = ACTIONS(6047),
    [anon_sym_BSLASHBiggl] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6047),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6047),
    [anon_sym_BSLASHgls] = ACTIONS(6047),
    [anon_sym_BSLASHGls] = ACTIONS(6047),
    [anon_sym_BSLASHGLS] = ACTIONS(6047),
    [anon_sym_BSLASHglspl] = ACTIONS(6047),
    [anon_sym_BSLASHGlspl] = ACTIONS(6047),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6047),
    [anon_sym_BSLASHglslink] = ACTIONS(6047),
    [anon_sym_BSLASHglstext] = ACTIONS(6047),
    [anon_sym_BSLASHGlstext] = ACTIONS(6047),
    [anon_sym_BSLASHGLStext] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6047),
    [anon_sym_BSLASHglsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsname] = ACTIONS(6047),
    [anon_sym_BSLASHGlsname] = ACTIONS(6047),
    [anon_sym_BSLASHGLSname] = ACTIONS(6047),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6047),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6047),
    [anon_sym_BSLASHacrshort] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6047),
    [anon_sym_BSLASHACRshort] = ACTIONS(6047),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrlong] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6047),
    [anon_sym_BSLASHACRlong] = ACTIONS(6047),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrfull] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6047),
    [anon_sym_BSLASHACRfull] = ACTIONS(6047),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHacs] = ACTIONS(6047),
    [anon_sym_BSLASHAcs] = ACTIONS(6047),
    [anon_sym_BSLASHacsp] = ACTIONS(6047),
    [anon_sym_BSLASHAcsp] = ACTIONS(6047),
    [anon_sym_BSLASHacl] = ACTIONS(6047),
    [anon_sym_BSLASHAcl] = ACTIONS(6047),
    [anon_sym_BSLASHaclp] = ACTIONS(6047),
    [anon_sym_BSLASHAclp] = ACTIONS(6047),
    [anon_sym_BSLASHacf] = ACTIONS(6047),
    [anon_sym_BSLASHAcf] = ACTIONS(6047),
    [anon_sym_BSLASHacfp] = ACTIONS(6047),
    [anon_sym_BSLASHAcfp] = ACTIONS(6047),
    [anon_sym_BSLASHac] = ACTIONS(6047),
    [anon_sym_BSLASHAc] = ACTIONS(6047),
    [anon_sym_BSLASHacp] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6047),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6047),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6047),
    [anon_sym_BSLASHcolor] = ACTIONS(6047),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6047),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6047),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6047),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6047),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6047),
    [anon_sym_BSLASHtext] = ACTIONS(6047),
    [anon_sym_BSLASHintertext] = ACTIONS(6047),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6047),
    [anon_sym_BSLASHurl] = ACTIONS(6047),
    [anon_sym_BSLASHhref] = ACTIONS(6047),
  },
  [652] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [653] = {
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(653),
    [aux_sym__paragraph_repeat2] = STATE(653),
    [sym_command_name] = ACTIONS(6037),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(6039),
    [anon_sym_RBRACK] = ACTIONS(6039),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_EQ] = ACTIONS(6039),
    [anon_sym_LPAREN] = ACTIONS(6039),
    [anon_sym_RPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHpart] = ACTIONS(6037),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddpart] = ACTIONS(6037),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHchapter] = ACTIONS(6037),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddchap] = ACTIONS(6037),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsection] = ACTIONS(6037),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddsec] = ACTIONS(6037),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHparagraph] = ACTIONS(6037),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6766),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6769),
    [anon_sym_BSLASHitem] = ACTIONS(6037),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6039),
    [anon_sym_LBRACE] = ACTIONS(6039),
    [sym_word] = ACTIONS(6037),
    [sym_placeholder] = ACTIONS(6039),
    [anon_sym_PLUS] = ACTIONS(6039),
    [anon_sym_DASH] = ACTIONS(6039),
    [anon_sym_STAR] = ACTIONS(6039),
    [anon_sym_SLASH] = ACTIONS(6039),
    [anon_sym_LT] = ACTIONS(6037),
    [anon_sym_GT] = ACTIONS(6037),
    [anon_sym_BANG] = ACTIONS(6037),
    [anon_sym_PIPE] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6037),
    [anon_sym_SQUOTE] = ACTIONS(6037),
    [anon_sym__] = ACTIONS(6039),
    [anon_sym_CARET] = ACTIONS(6039),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6039),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6039),
    [anon_sym_DOLLAR] = ACTIONS(6037),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHbegin] = ACTIONS(6037),
    [anon_sym_BSLASHend] = ACTIONS(6037),
    [anon_sym_BSLASHtitle] = ACTIONS(6037),
    [anon_sym_BSLASHauthor] = ACTIONS(6037),
    [anon_sym_BSLASHusepackage] = ACTIONS(6037),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6037),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6037),
    [anon_sym_BSLASHinclude] = ACTIONS(6037),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6037),
    [anon_sym_BSLASHinput] = ACTIONS(6037),
    [anon_sym_BSLASHsubfile] = ACTIONS(6037),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6037),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6037),
    [anon_sym_BSLASHbibliography] = ACTIONS(6037),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6037),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6037),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6037),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6037),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6037),
    [anon_sym_BSLASHimport] = ACTIONS(6037),
    [anon_sym_BSLASHsubimport] = ACTIONS(6037),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6037),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHcaption] = ACTIONS(6037),
    [anon_sym_BSLASHcite] = ACTIONS(6037),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCite] = ACTIONS(6037),
    [anon_sym_BSLASHnocite] = ACTIONS(6037),
    [anon_sym_BSLASHcitet] = ACTIONS(6037),
    [anon_sym_BSLASHcitep] = ACTIONS(6037),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteA] = ACTIONS(6037),
    [anon_sym_BSLASHciteR] = ACTIONS(6037),
    [anon_sym_BSLASHciteS] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6037),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteyear] = ACTIONS(6037),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitedate] = ACTIONS(6037),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteurl] = ACTIONS(6037),
    [anon_sym_BSLASHfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6037),
    [anon_sym_BSLASHcitealt] = ACTIONS(6037),
    [anon_sym_BSLASHcitealp] = ACTIONS(6037),
    [anon_sym_BSLASHcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHparencite] = ACTIONS(6037),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHParencite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHtextcite] = ACTIONS(6037),
    [anon_sym_BSLASHTextcite] = ACTIONS(6037),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHsupercite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite] = ACTIONS(6037),
    [anon_sym_BSLASHAutocite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHVolcite] = ACTIONS(6037),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHavolcite] = ACTIONS(6037),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHNotecite] = ACTIONS(6037),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHlabel] = ACTIONS(6037),
    [anon_sym_BSLASHref] = ACTIONS(6037),
    [anon_sym_BSLASHeqref] = ACTIONS(6037),
    [anon_sym_BSLASHvref] = ACTIONS(6037),
    [anon_sym_BSLASHVref] = ACTIONS(6037),
    [anon_sym_BSLASHautoref] = ACTIONS(6037),
    [anon_sym_BSLASHpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcref] = ACTIONS(6037),
    [anon_sym_BSLASHCref] = ACTIONS(6037),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnameCref] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHdef] = ACTIONS(6037),
    [anon_sym_BSLASHlet] = ACTIONS(6037),
    [anon_sym_BSLASHleft] = ACTIONS(6037),
    [anon_sym_BSLASHbigl] = ACTIONS(6037),
    [anon_sym_BSLASHBigl] = ACTIONS(6037),
    [anon_sym_BSLASHbiggl] = ACTIONS(6037),
    [anon_sym_BSLASHBiggl] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6037),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6037),
    [anon_sym_BSLASHgls] = ACTIONS(6037),
    [anon_sym_BSLASHGls] = ACTIONS(6037),
    [anon_sym_BSLASHGLS] = ACTIONS(6037),
    [anon_sym_BSLASHglspl] = ACTIONS(6037),
    [anon_sym_BSLASHGlspl] = ACTIONS(6037),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6037),
    [anon_sym_BSLASHglslink] = ACTIONS(6037),
    [anon_sym_BSLASHglstext] = ACTIONS(6037),
    [anon_sym_BSLASHGlstext] = ACTIONS(6037),
    [anon_sym_BSLASHGLStext] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6037),
    [anon_sym_BSLASHglsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsname] = ACTIONS(6037),
    [anon_sym_BSLASHGlsname] = ACTIONS(6037),
    [anon_sym_BSLASHGLSname] = ACTIONS(6037),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6037),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6037),
    [anon_sym_BSLASHacrshort] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6037),
    [anon_sym_BSLASHACRshort] = ACTIONS(6037),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrlong] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6037),
    [anon_sym_BSLASHACRlong] = ACTIONS(6037),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrfull] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6037),
    [anon_sym_BSLASHACRfull] = ACTIONS(6037),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHacs] = ACTIONS(6037),
    [anon_sym_BSLASHAcs] = ACTIONS(6037),
    [anon_sym_BSLASHacsp] = ACTIONS(6037),
    [anon_sym_BSLASHAcsp] = ACTIONS(6037),
    [anon_sym_BSLASHacl] = ACTIONS(6037),
    [anon_sym_BSLASHAcl] = ACTIONS(6037),
    [anon_sym_BSLASHaclp] = ACTIONS(6037),
    [anon_sym_BSLASHAclp] = ACTIONS(6037),
    [anon_sym_BSLASHacf] = ACTIONS(6037),
    [anon_sym_BSLASHAcf] = ACTIONS(6037),
    [anon_sym_BSLASHacfp] = ACTIONS(6037),
    [anon_sym_BSLASHAcfp] = ACTIONS(6037),
    [anon_sym_BSLASHac] = ACTIONS(6037),
    [anon_sym_BSLASHAc] = ACTIONS(6037),
    [anon_sym_BSLASHacp] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6037),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6037),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6037),
    [anon_sym_BSLASHcolor] = ACTIONS(6037),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6037),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6037),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6037),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6037),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6037),
    [anon_sym_BSLASHtext] = ACTIONS(6037),
    [anon_sym_BSLASHintertext] = ACTIONS(6037),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6037),
    [anon_sym_BSLASHurl] = ACTIONS(6037),
    [anon_sym_BSLASHhref] = ACTIONS(6037),
  },
  [654] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [655] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [656] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [657] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [658] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [659] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [660] = {
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(822),
    [aux_sym__section_repeat2] = STATE(822),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [661] = {
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(653),
    [aux_sym__paragraph_repeat2] = STATE(653),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(6069),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6071),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHend] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [662] = {
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(698),
    [aux_sym__paragraph_repeat3] = STATE(698),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHend] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [663] = {
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(698),
    [aux_sym__paragraph_repeat3] = STATE(698),
    [sym_command_name] = ACTIONS(6073),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6075),
    [anon_sym_RBRACK] = ACTIONS(6075),
    [anon_sym_COMMA] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_LPAREN] = ACTIONS(6075),
    [anon_sym_RPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHpart] = ACTIONS(6073),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddpart] = ACTIONS(6073),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHchapter] = ACTIONS(6073),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddchap] = ACTIONS(6073),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsection] = ACTIONS(6073),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddsec] = ACTIONS(6073),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(6075),
    [sym_word] = ACTIONS(6073),
    [sym_placeholder] = ACTIONS(6075),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_DASH] = ACTIONS(6075),
    [anon_sym_STAR] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6073),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_BANG] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6073),
    [anon_sym_COLON] = ACTIONS(6073),
    [anon_sym_SQUOTE] = ACTIONS(6073),
    [anon_sym__] = ACTIONS(6075),
    [anon_sym_CARET] = ACTIONS(6075),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6075),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6075),
    [anon_sym_DOLLAR] = ACTIONS(6073),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHbegin] = ACTIONS(6073),
    [anon_sym_BSLASHend] = ACTIONS(6073),
    [anon_sym_BSLASHtitle] = ACTIONS(6073),
    [anon_sym_BSLASHauthor] = ACTIONS(6073),
    [anon_sym_BSLASHusepackage] = ACTIONS(6073),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6073),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6073),
    [anon_sym_BSLASHinclude] = ACTIONS(6073),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6073),
    [anon_sym_BSLASHinput] = ACTIONS(6073),
    [anon_sym_BSLASHsubfile] = ACTIONS(6073),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6073),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6073),
    [anon_sym_BSLASHbibliography] = ACTIONS(6073),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6073),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6073),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6073),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6073),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6073),
    [anon_sym_BSLASHimport] = ACTIONS(6073),
    [anon_sym_BSLASHsubimport] = ACTIONS(6073),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6073),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHcaption] = ACTIONS(6073),
    [anon_sym_BSLASHcite] = ACTIONS(6073),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCite] = ACTIONS(6073),
    [anon_sym_BSLASHnocite] = ACTIONS(6073),
    [anon_sym_BSLASHcitet] = ACTIONS(6073),
    [anon_sym_BSLASHcitep] = ACTIONS(6073),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteA] = ACTIONS(6073),
    [anon_sym_BSLASHciteR] = ACTIONS(6073),
    [anon_sym_BSLASHciteS] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6073),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteyear] = ACTIONS(6073),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitedate] = ACTIONS(6073),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteurl] = ACTIONS(6073),
    [anon_sym_BSLASHfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6073),
    [anon_sym_BSLASHcitealt] = ACTIONS(6073),
    [anon_sym_BSLASHcitealp] = ACTIONS(6073),
    [anon_sym_BSLASHcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHparencite] = ACTIONS(6073),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHParencite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHtextcite] = ACTIONS(6073),
    [anon_sym_BSLASHTextcite] = ACTIONS(6073),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHsupercite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite] = ACTIONS(6073),
    [anon_sym_BSLASHAutocite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHVolcite] = ACTIONS(6073),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHavolcite] = ACTIONS(6073),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHNotecite] = ACTIONS(6073),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHlabel] = ACTIONS(6073),
    [anon_sym_BSLASHref] = ACTIONS(6073),
    [anon_sym_BSLASHeqref] = ACTIONS(6073),
    [anon_sym_BSLASHvref] = ACTIONS(6073),
    [anon_sym_BSLASHVref] = ACTIONS(6073),
    [anon_sym_BSLASHautoref] = ACTIONS(6073),
    [anon_sym_BSLASHpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcref] = ACTIONS(6073),
    [anon_sym_BSLASHCref] = ACTIONS(6073),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnameCref] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHdef] = ACTIONS(6073),
    [anon_sym_BSLASHlet] = ACTIONS(6073),
    [anon_sym_BSLASHleft] = ACTIONS(6073),
    [anon_sym_BSLASHbigl] = ACTIONS(6073),
    [anon_sym_BSLASHBigl] = ACTIONS(6073),
    [anon_sym_BSLASHbiggl] = ACTIONS(6073),
    [anon_sym_BSLASHBiggl] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6073),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6073),
    [anon_sym_BSLASHgls] = ACTIONS(6073),
    [anon_sym_BSLASHGls] = ACTIONS(6073),
    [anon_sym_BSLASHGLS] = ACTIONS(6073),
    [anon_sym_BSLASHglspl] = ACTIONS(6073),
    [anon_sym_BSLASHGlspl] = ACTIONS(6073),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6073),
    [anon_sym_BSLASHglslink] = ACTIONS(6073),
    [anon_sym_BSLASHglstext] = ACTIONS(6073),
    [anon_sym_BSLASHGlstext] = ACTIONS(6073),
    [anon_sym_BSLASHGLStext] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6073),
    [anon_sym_BSLASHglsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsname] = ACTIONS(6073),
    [anon_sym_BSLASHGlsname] = ACTIONS(6073),
    [anon_sym_BSLASHGLSname] = ACTIONS(6073),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6073),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6073),
    [anon_sym_BSLASHacrshort] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6073),
    [anon_sym_BSLASHACRshort] = ACTIONS(6073),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrlong] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6073),
    [anon_sym_BSLASHACRlong] = ACTIONS(6073),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrfull] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6073),
    [anon_sym_BSLASHACRfull] = ACTIONS(6073),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHacs] = ACTIONS(6073),
    [anon_sym_BSLASHAcs] = ACTIONS(6073),
    [anon_sym_BSLASHacsp] = ACTIONS(6073),
    [anon_sym_BSLASHAcsp] = ACTIONS(6073),
    [anon_sym_BSLASHacl] = ACTIONS(6073),
    [anon_sym_BSLASHAcl] = ACTIONS(6073),
    [anon_sym_BSLASHaclp] = ACTIONS(6073),
    [anon_sym_BSLASHAclp] = ACTIONS(6073),
    [anon_sym_BSLASHacf] = ACTIONS(6073),
    [anon_sym_BSLASHAcf] = ACTIONS(6073),
    [anon_sym_BSLASHacfp] = ACTIONS(6073),
    [anon_sym_BSLASHAcfp] = ACTIONS(6073),
    [anon_sym_BSLASHac] = ACTIONS(6073),
    [anon_sym_BSLASHAc] = ACTIONS(6073),
    [anon_sym_BSLASHacp] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6073),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6073),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6073),
    [anon_sym_BSLASHcolor] = ACTIONS(6073),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6073),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6073),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6073),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6073),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6073),
    [anon_sym_BSLASHtext] = ACTIONS(6073),
    [anon_sym_BSLASHintertext] = ACTIONS(6073),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6073),
    [anon_sym_BSLASHurl] = ACTIONS(6073),
    [anon_sym_BSLASHhref] = ACTIONS(6073),
  },
  [664] = {
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(720),
    [aux_sym__section_repeat2] = STATE(720),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHend] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [665] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHend] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [666] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHend] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [667] = {
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(753),
    [aux_sym__section_repeat2] = STATE(753),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [668] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [669] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [670] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [671] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHend] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [672] = {
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(753),
    [aux_sym__section_repeat2] = STATE(753),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [673] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [674] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [675] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [676] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHend] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [677] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [678] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [679] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [680] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHend] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [681] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [682] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [683] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [684] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [685] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [686] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [687] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [688] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [689] = {
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(653),
    [aux_sym__paragraph_repeat2] = STATE(653),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHend] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [690] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [691] = {
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(650),
    [aux_sym__paragraph_repeat2] = STATE(650),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(6069),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6071),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [692] = {
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(651),
    [aux_sym__paragraph_repeat3] = STATE(651),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [693] = {
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(651),
    [aux_sym__paragraph_repeat3] = STATE(651),
    [sym_command_name] = ACTIONS(6073),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6075),
    [anon_sym_RBRACK] = ACTIONS(6075),
    [anon_sym_COMMA] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_LPAREN] = ACTIONS(6075),
    [anon_sym_RPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHpart] = ACTIONS(6073),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddpart] = ACTIONS(6073),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHchapter] = ACTIONS(6073),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddchap] = ACTIONS(6073),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsection] = ACTIONS(6073),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddsec] = ACTIONS(6073),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(6075),
    [sym_word] = ACTIONS(6073),
    [sym_placeholder] = ACTIONS(6075),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_DASH] = ACTIONS(6075),
    [anon_sym_STAR] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6073),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_BANG] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6073),
    [anon_sym_COLON] = ACTIONS(6073),
    [anon_sym_SQUOTE] = ACTIONS(6073),
    [anon_sym__] = ACTIONS(6075),
    [anon_sym_CARET] = ACTIONS(6075),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6075),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6075),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6075),
    [anon_sym_DOLLAR] = ACTIONS(6073),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHbegin] = ACTIONS(6073),
    [anon_sym_BSLASHtitle] = ACTIONS(6073),
    [anon_sym_BSLASHauthor] = ACTIONS(6073),
    [anon_sym_BSLASHusepackage] = ACTIONS(6073),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6073),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6073),
    [anon_sym_BSLASHinclude] = ACTIONS(6073),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6073),
    [anon_sym_BSLASHinput] = ACTIONS(6073),
    [anon_sym_BSLASHsubfile] = ACTIONS(6073),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6073),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6073),
    [anon_sym_BSLASHbibliography] = ACTIONS(6073),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6073),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6073),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6073),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6073),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6073),
    [anon_sym_BSLASHimport] = ACTIONS(6073),
    [anon_sym_BSLASHsubimport] = ACTIONS(6073),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6073),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHcaption] = ACTIONS(6073),
    [anon_sym_BSLASHcite] = ACTIONS(6073),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCite] = ACTIONS(6073),
    [anon_sym_BSLASHnocite] = ACTIONS(6073),
    [anon_sym_BSLASHcitet] = ACTIONS(6073),
    [anon_sym_BSLASHcitep] = ACTIONS(6073),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteA] = ACTIONS(6073),
    [anon_sym_BSLASHciteR] = ACTIONS(6073),
    [anon_sym_BSLASHciteS] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6073),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteyear] = ACTIONS(6073),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitedate] = ACTIONS(6073),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteurl] = ACTIONS(6073),
    [anon_sym_BSLASHfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6073),
    [anon_sym_BSLASHcitealt] = ACTIONS(6073),
    [anon_sym_BSLASHcitealp] = ACTIONS(6073),
    [anon_sym_BSLASHcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHparencite] = ACTIONS(6073),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHParencite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHtextcite] = ACTIONS(6073),
    [anon_sym_BSLASHTextcite] = ACTIONS(6073),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHsupercite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite] = ACTIONS(6073),
    [anon_sym_BSLASHAutocite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHVolcite] = ACTIONS(6073),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHavolcite] = ACTIONS(6073),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHNotecite] = ACTIONS(6073),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHlabel] = ACTIONS(6073),
    [anon_sym_BSLASHref] = ACTIONS(6073),
    [anon_sym_BSLASHeqref] = ACTIONS(6073),
    [anon_sym_BSLASHvref] = ACTIONS(6073),
    [anon_sym_BSLASHVref] = ACTIONS(6073),
    [anon_sym_BSLASHautoref] = ACTIONS(6073),
    [anon_sym_BSLASHpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcref] = ACTIONS(6073),
    [anon_sym_BSLASHCref] = ACTIONS(6073),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnameCref] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHdef] = ACTIONS(6073),
    [anon_sym_BSLASHlet] = ACTIONS(6073),
    [anon_sym_BSLASHleft] = ACTIONS(6073),
    [anon_sym_BSLASHbigl] = ACTIONS(6073),
    [anon_sym_BSLASHBigl] = ACTIONS(6073),
    [anon_sym_BSLASHbiggl] = ACTIONS(6073),
    [anon_sym_BSLASHBiggl] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6073),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6073),
    [anon_sym_BSLASHgls] = ACTIONS(6073),
    [anon_sym_BSLASHGls] = ACTIONS(6073),
    [anon_sym_BSLASHGLS] = ACTIONS(6073),
    [anon_sym_BSLASHglspl] = ACTIONS(6073),
    [anon_sym_BSLASHGlspl] = ACTIONS(6073),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6073),
    [anon_sym_BSLASHglslink] = ACTIONS(6073),
    [anon_sym_BSLASHglstext] = ACTIONS(6073),
    [anon_sym_BSLASHGlstext] = ACTIONS(6073),
    [anon_sym_BSLASHGLStext] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6073),
    [anon_sym_BSLASHglsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsname] = ACTIONS(6073),
    [anon_sym_BSLASHGlsname] = ACTIONS(6073),
    [anon_sym_BSLASHGLSname] = ACTIONS(6073),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6073),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6073),
    [anon_sym_BSLASHacrshort] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6073),
    [anon_sym_BSLASHACRshort] = ACTIONS(6073),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrlong] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6073),
    [anon_sym_BSLASHACRlong] = ACTIONS(6073),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrfull] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6073),
    [anon_sym_BSLASHACRfull] = ACTIONS(6073),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHacs] = ACTIONS(6073),
    [anon_sym_BSLASHAcs] = ACTIONS(6073),
    [anon_sym_BSLASHacsp] = ACTIONS(6073),
    [anon_sym_BSLASHAcsp] = ACTIONS(6073),
    [anon_sym_BSLASHacl] = ACTIONS(6073),
    [anon_sym_BSLASHAcl] = ACTIONS(6073),
    [anon_sym_BSLASHaclp] = ACTIONS(6073),
    [anon_sym_BSLASHAclp] = ACTIONS(6073),
    [anon_sym_BSLASHacf] = ACTIONS(6073),
    [anon_sym_BSLASHAcf] = ACTIONS(6073),
    [anon_sym_BSLASHacfp] = ACTIONS(6073),
    [anon_sym_BSLASHAcfp] = ACTIONS(6073),
    [anon_sym_BSLASHac] = ACTIONS(6073),
    [anon_sym_BSLASHAc] = ACTIONS(6073),
    [anon_sym_BSLASHacp] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6073),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6073),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6073),
    [anon_sym_BSLASHcolor] = ACTIONS(6073),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6073),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6073),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6073),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6073),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6073),
    [anon_sym_BSLASHtext] = ACTIONS(6073),
    [anon_sym_BSLASHintertext] = ACTIONS(6073),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6073),
    [anon_sym_BSLASHurl] = ACTIONS(6073),
    [anon_sym_BSLASHhref] = ACTIONS(6073),
  },
  [694] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHend] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [695] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHend] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [696] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHend] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [697] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(6097),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(6099),
    [anon_sym_RBRACK] = ACTIONS(6099),
    [anon_sym_COMMA] = ACTIONS(6099),
    [anon_sym_EQ] = ACTIONS(6099),
    [anon_sym_LPAREN] = ACTIONS(6099),
    [anon_sym_RPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHpart] = ACTIONS(6097),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddpart] = ACTIONS(6097),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHchapter] = ACTIONS(6097),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddchap] = ACTIONS(6097),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsection] = ACTIONS(6097),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddsec] = ACTIONS(6097),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsection] = ACTIONS(6097),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHitem] = ACTIONS(6097),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(6099),
    [sym_word] = ACTIONS(6097),
    [sym_placeholder] = ACTIONS(6099),
    [anon_sym_PLUS] = ACTIONS(6099),
    [anon_sym_DASH] = ACTIONS(6099),
    [anon_sym_STAR] = ACTIONS(6099),
    [anon_sym_SLASH] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(6097),
    [anon_sym_GT] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6097),
    [anon_sym_PIPE] = ACTIONS(6097),
    [anon_sym_COLON] = ACTIONS(6097),
    [anon_sym_SQUOTE] = ACTIONS(6097),
    [anon_sym__] = ACTIONS(6099),
    [anon_sym_CARET] = ACTIONS(6099),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6099),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6099),
    [anon_sym_DOLLAR] = ACTIONS(6097),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHbegin] = ACTIONS(6097),
    [anon_sym_BSLASHend] = ACTIONS(6097),
    [anon_sym_BSLASHtitle] = ACTIONS(6097),
    [anon_sym_BSLASHauthor] = ACTIONS(6097),
    [anon_sym_BSLASHusepackage] = ACTIONS(6097),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6097),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6097),
    [anon_sym_BSLASHinclude] = ACTIONS(6097),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6097),
    [anon_sym_BSLASHinput] = ACTIONS(6097),
    [anon_sym_BSLASHsubfile] = ACTIONS(6097),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6097),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6097),
    [anon_sym_BSLASHbibliography] = ACTIONS(6097),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6097),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6097),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6097),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6097),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6097),
    [anon_sym_BSLASHimport] = ACTIONS(6097),
    [anon_sym_BSLASHsubimport] = ACTIONS(6097),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6097),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHcaption] = ACTIONS(6097),
    [anon_sym_BSLASHcite] = ACTIONS(6097),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCite] = ACTIONS(6097),
    [anon_sym_BSLASHnocite] = ACTIONS(6097),
    [anon_sym_BSLASHcitet] = ACTIONS(6097),
    [anon_sym_BSLASHcitep] = ACTIONS(6097),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteA] = ACTIONS(6097),
    [anon_sym_BSLASHciteR] = ACTIONS(6097),
    [anon_sym_BSLASHciteS] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6097),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteyear] = ACTIONS(6097),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitedate] = ACTIONS(6097),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteurl] = ACTIONS(6097),
    [anon_sym_BSLASHfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6097),
    [anon_sym_BSLASHcitealt] = ACTIONS(6097),
    [anon_sym_BSLASHcitealp] = ACTIONS(6097),
    [anon_sym_BSLASHcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHparencite] = ACTIONS(6097),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHParencite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHtextcite] = ACTIONS(6097),
    [anon_sym_BSLASHTextcite] = ACTIONS(6097),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHsupercite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite] = ACTIONS(6097),
    [anon_sym_BSLASHAutocite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHVolcite] = ACTIONS(6097),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHavolcite] = ACTIONS(6097),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHNotecite] = ACTIONS(6097),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHlabel] = ACTIONS(6097),
    [anon_sym_BSLASHref] = ACTIONS(6097),
    [anon_sym_BSLASHeqref] = ACTIONS(6097),
    [anon_sym_BSLASHvref] = ACTIONS(6097),
    [anon_sym_BSLASHVref] = ACTIONS(6097),
    [anon_sym_BSLASHautoref] = ACTIONS(6097),
    [anon_sym_BSLASHpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcref] = ACTIONS(6097),
    [anon_sym_BSLASHCref] = ACTIONS(6097),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnameCref] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHdef] = ACTIONS(6097),
    [anon_sym_BSLASHlet] = ACTIONS(6097),
    [anon_sym_BSLASHleft] = ACTIONS(6097),
    [anon_sym_BSLASHbigl] = ACTIONS(6097),
    [anon_sym_BSLASHBigl] = ACTIONS(6097),
    [anon_sym_BSLASHbiggl] = ACTIONS(6097),
    [anon_sym_BSLASHBiggl] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6097),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6097),
    [anon_sym_BSLASHgls] = ACTIONS(6097),
    [anon_sym_BSLASHGls] = ACTIONS(6097),
    [anon_sym_BSLASHGLS] = ACTIONS(6097),
    [anon_sym_BSLASHglspl] = ACTIONS(6097),
    [anon_sym_BSLASHGlspl] = ACTIONS(6097),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6097),
    [anon_sym_BSLASHglslink] = ACTIONS(6097),
    [anon_sym_BSLASHglstext] = ACTIONS(6097),
    [anon_sym_BSLASHGlstext] = ACTIONS(6097),
    [anon_sym_BSLASHGLStext] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6097),
    [anon_sym_BSLASHglsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsname] = ACTIONS(6097),
    [anon_sym_BSLASHGlsname] = ACTIONS(6097),
    [anon_sym_BSLASHGLSname] = ACTIONS(6097),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6097),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6097),
    [anon_sym_BSLASHacrshort] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6097),
    [anon_sym_BSLASHACRshort] = ACTIONS(6097),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrlong] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6097),
    [anon_sym_BSLASHACRlong] = ACTIONS(6097),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrfull] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6097),
    [anon_sym_BSLASHACRfull] = ACTIONS(6097),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHacs] = ACTIONS(6097),
    [anon_sym_BSLASHAcs] = ACTIONS(6097),
    [anon_sym_BSLASHacsp] = ACTIONS(6097),
    [anon_sym_BSLASHAcsp] = ACTIONS(6097),
    [anon_sym_BSLASHacl] = ACTIONS(6097),
    [anon_sym_BSLASHAcl] = ACTIONS(6097),
    [anon_sym_BSLASHaclp] = ACTIONS(6097),
    [anon_sym_BSLASHAclp] = ACTIONS(6097),
    [anon_sym_BSLASHacf] = ACTIONS(6097),
    [anon_sym_BSLASHAcf] = ACTIONS(6097),
    [anon_sym_BSLASHacfp] = ACTIONS(6097),
    [anon_sym_BSLASHAcfp] = ACTIONS(6097),
    [anon_sym_BSLASHac] = ACTIONS(6097),
    [anon_sym_BSLASHAc] = ACTIONS(6097),
    [anon_sym_BSLASHacp] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6097),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6097),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6097),
    [anon_sym_BSLASHcolor] = ACTIONS(6097),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6097),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6097),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6097),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6097),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6097),
    [anon_sym_BSLASHtext] = ACTIONS(6097),
    [anon_sym_BSLASHintertext] = ACTIONS(6097),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6097),
    [anon_sym_BSLASHurl] = ACTIONS(6097),
    [anon_sym_BSLASHhref] = ACTIONS(6097),
  },
  [698] = {
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(698),
    [aux_sym__paragraph_repeat3] = STATE(698),
    [sym_command_name] = ACTIONS(6047),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(6049),
    [anon_sym_RBRACK] = ACTIONS(6049),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(6049),
    [anon_sym_RPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHpart] = ACTIONS(6047),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddpart] = ACTIONS(6047),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHchapter] = ACTIONS(6047),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddchap] = ACTIONS(6047),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsection] = ACTIONS(6047),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddsec] = ACTIONS(6047),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHitem] = ACTIONS(6772),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6775),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_word] = ACTIONS(6047),
    [sym_placeholder] = ACTIONS(6049),
    [anon_sym_PLUS] = ACTIONS(6049),
    [anon_sym_DASH] = ACTIONS(6049),
    [anon_sym_STAR] = ACTIONS(6049),
    [anon_sym_SLASH] = ACTIONS(6049),
    [anon_sym_LT] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6047),
    [anon_sym_BANG] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6047),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SQUOTE] = ACTIONS(6047),
    [anon_sym__] = ACTIONS(6049),
    [anon_sym_CARET] = ACTIONS(6049),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6049),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6049),
    [anon_sym_DOLLAR] = ACTIONS(6047),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHbegin] = ACTIONS(6047),
    [anon_sym_BSLASHend] = ACTIONS(6047),
    [anon_sym_BSLASHtitle] = ACTIONS(6047),
    [anon_sym_BSLASHauthor] = ACTIONS(6047),
    [anon_sym_BSLASHusepackage] = ACTIONS(6047),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6047),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6047),
    [anon_sym_BSLASHinclude] = ACTIONS(6047),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6047),
    [anon_sym_BSLASHinput] = ACTIONS(6047),
    [anon_sym_BSLASHsubfile] = ACTIONS(6047),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6047),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6047),
    [anon_sym_BSLASHbibliography] = ACTIONS(6047),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6047),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6047),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6047),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6047),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6047),
    [anon_sym_BSLASHimport] = ACTIONS(6047),
    [anon_sym_BSLASHsubimport] = ACTIONS(6047),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6047),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHcaption] = ACTIONS(6047),
    [anon_sym_BSLASHcite] = ACTIONS(6047),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCite] = ACTIONS(6047),
    [anon_sym_BSLASHnocite] = ACTIONS(6047),
    [anon_sym_BSLASHcitet] = ACTIONS(6047),
    [anon_sym_BSLASHcitep] = ACTIONS(6047),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteA] = ACTIONS(6047),
    [anon_sym_BSLASHciteR] = ACTIONS(6047),
    [anon_sym_BSLASHciteS] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6047),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteyear] = ACTIONS(6047),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitedate] = ACTIONS(6047),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteurl] = ACTIONS(6047),
    [anon_sym_BSLASHfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6047),
    [anon_sym_BSLASHcitealt] = ACTIONS(6047),
    [anon_sym_BSLASHcitealp] = ACTIONS(6047),
    [anon_sym_BSLASHcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHparencite] = ACTIONS(6047),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHParencite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHtextcite] = ACTIONS(6047),
    [anon_sym_BSLASHTextcite] = ACTIONS(6047),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHsupercite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite] = ACTIONS(6047),
    [anon_sym_BSLASHAutocite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHVolcite] = ACTIONS(6047),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHavolcite] = ACTIONS(6047),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHNotecite] = ACTIONS(6047),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHlabel] = ACTIONS(6047),
    [anon_sym_BSLASHref] = ACTIONS(6047),
    [anon_sym_BSLASHeqref] = ACTIONS(6047),
    [anon_sym_BSLASHvref] = ACTIONS(6047),
    [anon_sym_BSLASHVref] = ACTIONS(6047),
    [anon_sym_BSLASHautoref] = ACTIONS(6047),
    [anon_sym_BSLASHpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcref] = ACTIONS(6047),
    [anon_sym_BSLASHCref] = ACTIONS(6047),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnameCref] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHdef] = ACTIONS(6047),
    [anon_sym_BSLASHlet] = ACTIONS(6047),
    [anon_sym_BSLASHleft] = ACTIONS(6047),
    [anon_sym_BSLASHbigl] = ACTIONS(6047),
    [anon_sym_BSLASHBigl] = ACTIONS(6047),
    [anon_sym_BSLASHbiggl] = ACTIONS(6047),
    [anon_sym_BSLASHBiggl] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6047),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6047),
    [anon_sym_BSLASHgls] = ACTIONS(6047),
    [anon_sym_BSLASHGls] = ACTIONS(6047),
    [anon_sym_BSLASHGLS] = ACTIONS(6047),
    [anon_sym_BSLASHglspl] = ACTIONS(6047),
    [anon_sym_BSLASHGlspl] = ACTIONS(6047),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6047),
    [anon_sym_BSLASHglslink] = ACTIONS(6047),
    [anon_sym_BSLASHglstext] = ACTIONS(6047),
    [anon_sym_BSLASHGlstext] = ACTIONS(6047),
    [anon_sym_BSLASHGLStext] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6047),
    [anon_sym_BSLASHglsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsname] = ACTIONS(6047),
    [anon_sym_BSLASHGlsname] = ACTIONS(6047),
    [anon_sym_BSLASHGLSname] = ACTIONS(6047),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6047),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6047),
    [anon_sym_BSLASHacrshort] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6047),
    [anon_sym_BSLASHACRshort] = ACTIONS(6047),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrlong] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6047),
    [anon_sym_BSLASHACRlong] = ACTIONS(6047),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrfull] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6047),
    [anon_sym_BSLASHACRfull] = ACTIONS(6047),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHacs] = ACTIONS(6047),
    [anon_sym_BSLASHAcs] = ACTIONS(6047),
    [anon_sym_BSLASHacsp] = ACTIONS(6047),
    [anon_sym_BSLASHAcsp] = ACTIONS(6047),
    [anon_sym_BSLASHacl] = ACTIONS(6047),
    [anon_sym_BSLASHAcl] = ACTIONS(6047),
    [anon_sym_BSLASHaclp] = ACTIONS(6047),
    [anon_sym_BSLASHAclp] = ACTIONS(6047),
    [anon_sym_BSLASHacf] = ACTIONS(6047),
    [anon_sym_BSLASHAcf] = ACTIONS(6047),
    [anon_sym_BSLASHacfp] = ACTIONS(6047),
    [anon_sym_BSLASHAcfp] = ACTIONS(6047),
    [anon_sym_BSLASHac] = ACTIONS(6047),
    [anon_sym_BSLASHAc] = ACTIONS(6047),
    [anon_sym_BSLASHacp] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6047),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6047),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6047),
    [anon_sym_BSLASHcolor] = ACTIONS(6047),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6047),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6047),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6047),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6047),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6047),
    [anon_sym_BSLASHtext] = ACTIONS(6047),
    [anon_sym_BSLASHintertext] = ACTIONS(6047),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6047),
    [anon_sym_BSLASHurl] = ACTIONS(6047),
    [anon_sym_BSLASHhref] = ACTIONS(6047),
  },
  [699] = {
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(753),
    [aux_sym__section_repeat2] = STATE(753),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [700] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [701] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [702] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(6085),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6085),
    [anon_sym_LBRACK] = ACTIONS(6087),
    [anon_sym_RBRACK] = ACTIONS(6087),
    [anon_sym_COMMA] = ACTIONS(6087),
    [anon_sym_EQ] = ACTIONS(6087),
    [anon_sym_LPAREN] = ACTIONS(6087),
    [anon_sym_RPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHpart] = ACTIONS(6085),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddpart] = ACTIONS(6085),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHchapter] = ACTIONS(6085),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddchap] = ACTIONS(6085),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsection] = ACTIONS(6085),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHaddsec] = ACTIONS(6085),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsection] = ACTIONS(6085),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6085),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHitem] = ACTIONS(6085),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6087),
    [anon_sym_LBRACE] = ACTIONS(6087),
    [sym_word] = ACTIONS(6085),
    [sym_placeholder] = ACTIONS(6087),
    [anon_sym_PLUS] = ACTIONS(6087),
    [anon_sym_DASH] = ACTIONS(6087),
    [anon_sym_STAR] = ACTIONS(6087),
    [anon_sym_SLASH] = ACTIONS(6087),
    [anon_sym_LT] = ACTIONS(6085),
    [anon_sym_GT] = ACTIONS(6085),
    [anon_sym_BANG] = ACTIONS(6085),
    [anon_sym_PIPE] = ACTIONS(6085),
    [anon_sym_COLON] = ACTIONS(6085),
    [anon_sym_SQUOTE] = ACTIONS(6085),
    [anon_sym__] = ACTIONS(6087),
    [anon_sym_CARET] = ACTIONS(6087),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6087),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6087),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6087),
    [anon_sym_DOLLAR] = ACTIONS(6085),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6087),
    [anon_sym_BSLASHbegin] = ACTIONS(6085),
    [anon_sym_BSLASHtitle] = ACTIONS(6085),
    [anon_sym_BSLASHauthor] = ACTIONS(6085),
    [anon_sym_BSLASHusepackage] = ACTIONS(6085),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6085),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6085),
    [anon_sym_BSLASHinclude] = ACTIONS(6085),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6085),
    [anon_sym_BSLASHinput] = ACTIONS(6085),
    [anon_sym_BSLASHsubfile] = ACTIONS(6085),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6085),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6085),
    [anon_sym_BSLASHbibliography] = ACTIONS(6085),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6085),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6085),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6085),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6085),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6085),
    [anon_sym_BSLASHimport] = ACTIONS(6085),
    [anon_sym_BSLASHsubimport] = ACTIONS(6085),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6085),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6085),
    [anon_sym_BSLASHcaption] = ACTIONS(6085),
    [anon_sym_BSLASHcite] = ACTIONS(6085),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCite] = ACTIONS(6085),
    [anon_sym_BSLASHnocite] = ACTIONS(6085),
    [anon_sym_BSLASHcitet] = ACTIONS(6085),
    [anon_sym_BSLASHcitep] = ACTIONS(6085),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteA] = ACTIONS(6085),
    [anon_sym_BSLASHciteR] = ACTIONS(6085),
    [anon_sym_BSLASHciteS] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6085),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6085),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteyear] = ACTIONS(6085),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHcitedate] = ACTIONS(6085),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHciteurl] = ACTIONS(6085),
    [anon_sym_BSLASHfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6085),
    [anon_sym_BSLASHcitealt] = ACTIONS(6085),
    [anon_sym_BSLASHcitealp] = ACTIONS(6085),
    [anon_sym_BSLASHcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHparencite] = ACTIONS(6085),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHParencite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6085),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6085),
    [anon_sym_BSLASHtextcite] = ACTIONS(6085),
    [anon_sym_BSLASHTextcite] = ACTIONS(6085),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6085),
    [anon_sym_BSLASHsupercite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite] = ACTIONS(6085),
    [anon_sym_BSLASHAutocite] = ACTIONS(6085),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHVolcite] = ACTIONS(6085),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHavolcite] = ACTIONS(6085),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6085),
    [anon_sym_BSLASHnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHNotecite] = ACTIONS(6085),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6085),
    [anon_sym_BSLASHlabel] = ACTIONS(6085),
    [anon_sym_BSLASHref] = ACTIONS(6085),
    [anon_sym_BSLASHeqref] = ACTIONS(6085),
    [anon_sym_BSLASHvref] = ACTIONS(6085),
    [anon_sym_BSLASHVref] = ACTIONS(6085),
    [anon_sym_BSLASHautoref] = ACTIONS(6085),
    [anon_sym_BSLASHpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcref] = ACTIONS(6085),
    [anon_sym_BSLASHCref] = ACTIONS(6085),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnameCref] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6085),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6085),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6085),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6085),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6085),
    [anon_sym_BSLASHdef] = ACTIONS(6085),
    [anon_sym_BSLASHlet] = ACTIONS(6085),
    [anon_sym_BSLASHleft] = ACTIONS(6085),
    [anon_sym_BSLASHbigl] = ACTIONS(6085),
    [anon_sym_BSLASHBigl] = ACTIONS(6085),
    [anon_sym_BSLASHbiggl] = ACTIONS(6085),
    [anon_sym_BSLASHBiggl] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6085),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6085),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6085),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6085),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6085),
    [anon_sym_BSLASHgls] = ACTIONS(6085),
    [anon_sym_BSLASHGls] = ACTIONS(6085),
    [anon_sym_BSLASHGLS] = ACTIONS(6085),
    [anon_sym_BSLASHglspl] = ACTIONS(6085),
    [anon_sym_BSLASHGlspl] = ACTIONS(6085),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6085),
    [anon_sym_BSLASHglslink] = ACTIONS(6085),
    [anon_sym_BSLASHglstext] = ACTIONS(6085),
    [anon_sym_BSLASHGlstext] = ACTIONS(6085),
    [anon_sym_BSLASHGLStext] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6085),
    [anon_sym_BSLASHglsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6085),
    [anon_sym_BSLASHglsname] = ACTIONS(6085),
    [anon_sym_BSLASHGlsname] = ACTIONS(6085),
    [anon_sym_BSLASHGLSname] = ACTIONS(6085),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6085),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6085),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6085),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6085),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6085),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6085),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6085),
    [anon_sym_BSLASHacrshort] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6085),
    [anon_sym_BSLASHACRshort] = ACTIONS(6085),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrlong] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6085),
    [anon_sym_BSLASHACRlong] = ACTIONS(6085),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6085),
    [anon_sym_BSLASHacrfull] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6085),
    [anon_sym_BSLASHACRfull] = ACTIONS(6085),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHacs] = ACTIONS(6085),
    [anon_sym_BSLASHAcs] = ACTIONS(6085),
    [anon_sym_BSLASHacsp] = ACTIONS(6085),
    [anon_sym_BSLASHAcsp] = ACTIONS(6085),
    [anon_sym_BSLASHacl] = ACTIONS(6085),
    [anon_sym_BSLASHAcl] = ACTIONS(6085),
    [anon_sym_BSLASHaclp] = ACTIONS(6085),
    [anon_sym_BSLASHAclp] = ACTIONS(6085),
    [anon_sym_BSLASHacf] = ACTIONS(6085),
    [anon_sym_BSLASHAcf] = ACTIONS(6085),
    [anon_sym_BSLASHacfp] = ACTIONS(6085),
    [anon_sym_BSLASHAcfp] = ACTIONS(6085),
    [anon_sym_BSLASHac] = ACTIONS(6085),
    [anon_sym_BSLASHAc] = ACTIONS(6085),
    [anon_sym_BSLASHacp] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6085),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6085),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6085),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6085),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6087),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6085),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6085),
    [anon_sym_BSLASHcolor] = ACTIONS(6085),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6085),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6085),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6085),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6085),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6085),
    [anon_sym_BSLASHtext] = ACTIONS(6085),
    [anon_sym_BSLASHintertext] = ACTIONS(6085),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6085),
    [anon_sym_BSLASHurl] = ACTIONS(6085),
    [anon_sym_BSLASHhref] = ACTIONS(6085),
  },
  [703] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [704] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [705] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(6089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6089),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(6091),
    [anon_sym_COMMA] = ACTIONS(6091),
    [anon_sym_EQ] = ACTIONS(6091),
    [anon_sym_LPAREN] = ACTIONS(6091),
    [anon_sym_RPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHpart] = ACTIONS(6089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddpart] = ACTIONS(6089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHchapter] = ACTIONS(6089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddchap] = ACTIONS(6089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsection] = ACTIONS(6089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHaddsec] = ACTIONS(6089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsection] = ACTIONS(6089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHitem] = ACTIONS(6089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6091),
    [anon_sym_LBRACE] = ACTIONS(6091),
    [sym_word] = ACTIONS(6089),
    [sym_placeholder] = ACTIONS(6091),
    [anon_sym_PLUS] = ACTIONS(6091),
    [anon_sym_DASH] = ACTIONS(6091),
    [anon_sym_STAR] = ACTIONS(6091),
    [anon_sym_SLASH] = ACTIONS(6091),
    [anon_sym_LT] = ACTIONS(6089),
    [anon_sym_GT] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6089),
    [anon_sym_PIPE] = ACTIONS(6089),
    [anon_sym_COLON] = ACTIONS(6089),
    [anon_sym_SQUOTE] = ACTIONS(6089),
    [anon_sym__] = ACTIONS(6091),
    [anon_sym_CARET] = ACTIONS(6091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6091),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6091),
    [anon_sym_DOLLAR] = ACTIONS(6089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6091),
    [anon_sym_BSLASHbegin] = ACTIONS(6089),
    [anon_sym_BSLASHtitle] = ACTIONS(6089),
    [anon_sym_BSLASHauthor] = ACTIONS(6089),
    [anon_sym_BSLASHusepackage] = ACTIONS(6089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6089),
    [anon_sym_BSLASHinclude] = ACTIONS(6089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6089),
    [anon_sym_BSLASHinput] = ACTIONS(6089),
    [anon_sym_BSLASHsubfile] = ACTIONS(6089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6089),
    [anon_sym_BSLASHbibliography] = ACTIONS(6089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6089),
    [anon_sym_BSLASHimport] = ACTIONS(6089),
    [anon_sym_BSLASHsubimport] = ACTIONS(6089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6089),
    [anon_sym_BSLASHcaption] = ACTIONS(6089),
    [anon_sym_BSLASHcite] = ACTIONS(6089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCite] = ACTIONS(6089),
    [anon_sym_BSLASHnocite] = ACTIONS(6089),
    [anon_sym_BSLASHcitet] = ACTIONS(6089),
    [anon_sym_BSLASHcitep] = ACTIONS(6089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteA] = ACTIONS(6089),
    [anon_sym_BSLASHciteR] = ACTIONS(6089),
    [anon_sym_BSLASHciteS] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteyear] = ACTIONS(6089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHcitedate] = ACTIONS(6089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHciteurl] = ACTIONS(6089),
    [anon_sym_BSLASHfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6089),
    [anon_sym_BSLASHcitealt] = ACTIONS(6089),
    [anon_sym_BSLASHcitealp] = ACTIONS(6089),
    [anon_sym_BSLASHcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHparencite] = ACTIONS(6089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHParencite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6089),
    [anon_sym_BSLASHtextcite] = ACTIONS(6089),
    [anon_sym_BSLASHTextcite] = ACTIONS(6089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6089),
    [anon_sym_BSLASHsupercite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite] = ACTIONS(6089),
    [anon_sym_BSLASHAutocite] = ACTIONS(6089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHVolcite] = ACTIONS(6089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHavolcite] = ACTIONS(6089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6089),
    [anon_sym_BSLASHnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHNotecite] = ACTIONS(6089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6089),
    [anon_sym_BSLASHlabel] = ACTIONS(6089),
    [anon_sym_BSLASHref] = ACTIONS(6089),
    [anon_sym_BSLASHeqref] = ACTIONS(6089),
    [anon_sym_BSLASHvref] = ACTIONS(6089),
    [anon_sym_BSLASHVref] = ACTIONS(6089),
    [anon_sym_BSLASHautoref] = ACTIONS(6089),
    [anon_sym_BSLASHpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcref] = ACTIONS(6089),
    [anon_sym_BSLASHCref] = ACTIONS(6089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnameCref] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6089),
    [anon_sym_BSLASHdef] = ACTIONS(6089),
    [anon_sym_BSLASHlet] = ACTIONS(6089),
    [anon_sym_BSLASHleft] = ACTIONS(6089),
    [anon_sym_BSLASHbigl] = ACTIONS(6089),
    [anon_sym_BSLASHBigl] = ACTIONS(6089),
    [anon_sym_BSLASHbiggl] = ACTIONS(6089),
    [anon_sym_BSLASHBiggl] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6089),
    [anon_sym_BSLASHgls] = ACTIONS(6089),
    [anon_sym_BSLASHGls] = ACTIONS(6089),
    [anon_sym_BSLASHGLS] = ACTIONS(6089),
    [anon_sym_BSLASHglspl] = ACTIONS(6089),
    [anon_sym_BSLASHGlspl] = ACTIONS(6089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6089),
    [anon_sym_BSLASHglslink] = ACTIONS(6089),
    [anon_sym_BSLASHglstext] = ACTIONS(6089),
    [anon_sym_BSLASHGlstext] = ACTIONS(6089),
    [anon_sym_BSLASHGLStext] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6089),
    [anon_sym_BSLASHglsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6089),
    [anon_sym_BSLASHglsname] = ACTIONS(6089),
    [anon_sym_BSLASHGlsname] = ACTIONS(6089),
    [anon_sym_BSLASHGLSname] = ACTIONS(6089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6089),
    [anon_sym_BSLASHacrshort] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6089),
    [anon_sym_BSLASHACRshort] = ACTIONS(6089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrlong] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6089),
    [anon_sym_BSLASHACRlong] = ACTIONS(6089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6089),
    [anon_sym_BSLASHacrfull] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6089),
    [anon_sym_BSLASHACRfull] = ACTIONS(6089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHacs] = ACTIONS(6089),
    [anon_sym_BSLASHAcs] = ACTIONS(6089),
    [anon_sym_BSLASHacsp] = ACTIONS(6089),
    [anon_sym_BSLASHAcsp] = ACTIONS(6089),
    [anon_sym_BSLASHacl] = ACTIONS(6089),
    [anon_sym_BSLASHAcl] = ACTIONS(6089),
    [anon_sym_BSLASHaclp] = ACTIONS(6089),
    [anon_sym_BSLASHAclp] = ACTIONS(6089),
    [anon_sym_BSLASHacf] = ACTIONS(6089),
    [anon_sym_BSLASHAcf] = ACTIONS(6089),
    [anon_sym_BSLASHacfp] = ACTIONS(6089),
    [anon_sym_BSLASHAcfp] = ACTIONS(6089),
    [anon_sym_BSLASHac] = ACTIONS(6089),
    [anon_sym_BSLASHAc] = ACTIONS(6089),
    [anon_sym_BSLASHacp] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6089),
    [anon_sym_BSLASHcolor] = ACTIONS(6089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6089),
    [anon_sym_BSLASHtext] = ACTIONS(6089),
    [anon_sym_BSLASHintertext] = ACTIONS(6089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6089),
    [anon_sym_BSLASHurl] = ACTIONS(6089),
    [anon_sym_BSLASHhref] = ACTIONS(6089),
  },
  [706] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [707] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [708] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(6097),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(6099),
    [anon_sym_RBRACK] = ACTIONS(6099),
    [anon_sym_COMMA] = ACTIONS(6099),
    [anon_sym_EQ] = ACTIONS(6099),
    [anon_sym_LPAREN] = ACTIONS(6099),
    [anon_sym_RPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHpart] = ACTIONS(6097),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddpart] = ACTIONS(6097),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHchapter] = ACTIONS(6097),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddchap] = ACTIONS(6097),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsection] = ACTIONS(6097),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddsec] = ACTIONS(6097),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsection] = ACTIONS(6097),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHitem] = ACTIONS(6097),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(6099),
    [sym_word] = ACTIONS(6097),
    [sym_placeholder] = ACTIONS(6099),
    [anon_sym_PLUS] = ACTIONS(6099),
    [anon_sym_DASH] = ACTIONS(6099),
    [anon_sym_STAR] = ACTIONS(6099),
    [anon_sym_SLASH] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(6097),
    [anon_sym_GT] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6097),
    [anon_sym_PIPE] = ACTIONS(6097),
    [anon_sym_COLON] = ACTIONS(6097),
    [anon_sym_SQUOTE] = ACTIONS(6097),
    [anon_sym__] = ACTIONS(6099),
    [anon_sym_CARET] = ACTIONS(6099),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6099),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6099),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6099),
    [anon_sym_DOLLAR] = ACTIONS(6097),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHbegin] = ACTIONS(6097),
    [anon_sym_BSLASHtitle] = ACTIONS(6097),
    [anon_sym_BSLASHauthor] = ACTIONS(6097),
    [anon_sym_BSLASHusepackage] = ACTIONS(6097),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6097),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6097),
    [anon_sym_BSLASHinclude] = ACTIONS(6097),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6097),
    [anon_sym_BSLASHinput] = ACTIONS(6097),
    [anon_sym_BSLASHsubfile] = ACTIONS(6097),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6097),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6097),
    [anon_sym_BSLASHbibliography] = ACTIONS(6097),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6097),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6097),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6097),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6097),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6097),
    [anon_sym_BSLASHimport] = ACTIONS(6097),
    [anon_sym_BSLASHsubimport] = ACTIONS(6097),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6097),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHcaption] = ACTIONS(6097),
    [anon_sym_BSLASHcite] = ACTIONS(6097),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCite] = ACTIONS(6097),
    [anon_sym_BSLASHnocite] = ACTIONS(6097),
    [anon_sym_BSLASHcitet] = ACTIONS(6097),
    [anon_sym_BSLASHcitep] = ACTIONS(6097),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteA] = ACTIONS(6097),
    [anon_sym_BSLASHciteR] = ACTIONS(6097),
    [anon_sym_BSLASHciteS] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6097),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteyear] = ACTIONS(6097),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitedate] = ACTIONS(6097),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteurl] = ACTIONS(6097),
    [anon_sym_BSLASHfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6097),
    [anon_sym_BSLASHcitealt] = ACTIONS(6097),
    [anon_sym_BSLASHcitealp] = ACTIONS(6097),
    [anon_sym_BSLASHcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHparencite] = ACTIONS(6097),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHParencite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHtextcite] = ACTIONS(6097),
    [anon_sym_BSLASHTextcite] = ACTIONS(6097),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHsupercite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite] = ACTIONS(6097),
    [anon_sym_BSLASHAutocite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHVolcite] = ACTIONS(6097),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHavolcite] = ACTIONS(6097),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHNotecite] = ACTIONS(6097),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHlabel] = ACTIONS(6097),
    [anon_sym_BSLASHref] = ACTIONS(6097),
    [anon_sym_BSLASHeqref] = ACTIONS(6097),
    [anon_sym_BSLASHvref] = ACTIONS(6097),
    [anon_sym_BSLASHVref] = ACTIONS(6097),
    [anon_sym_BSLASHautoref] = ACTIONS(6097),
    [anon_sym_BSLASHpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcref] = ACTIONS(6097),
    [anon_sym_BSLASHCref] = ACTIONS(6097),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnameCref] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHdef] = ACTIONS(6097),
    [anon_sym_BSLASHlet] = ACTIONS(6097),
    [anon_sym_BSLASHleft] = ACTIONS(6097),
    [anon_sym_BSLASHbigl] = ACTIONS(6097),
    [anon_sym_BSLASHBigl] = ACTIONS(6097),
    [anon_sym_BSLASHbiggl] = ACTIONS(6097),
    [anon_sym_BSLASHBiggl] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6097),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6097),
    [anon_sym_BSLASHgls] = ACTIONS(6097),
    [anon_sym_BSLASHGls] = ACTIONS(6097),
    [anon_sym_BSLASHGLS] = ACTIONS(6097),
    [anon_sym_BSLASHglspl] = ACTIONS(6097),
    [anon_sym_BSLASHGlspl] = ACTIONS(6097),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6097),
    [anon_sym_BSLASHglslink] = ACTIONS(6097),
    [anon_sym_BSLASHglstext] = ACTIONS(6097),
    [anon_sym_BSLASHGlstext] = ACTIONS(6097),
    [anon_sym_BSLASHGLStext] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6097),
    [anon_sym_BSLASHglsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsname] = ACTIONS(6097),
    [anon_sym_BSLASHGlsname] = ACTIONS(6097),
    [anon_sym_BSLASHGLSname] = ACTIONS(6097),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6097),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6097),
    [anon_sym_BSLASHacrshort] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6097),
    [anon_sym_BSLASHACRshort] = ACTIONS(6097),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrlong] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6097),
    [anon_sym_BSLASHACRlong] = ACTIONS(6097),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrfull] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6097),
    [anon_sym_BSLASHACRfull] = ACTIONS(6097),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHacs] = ACTIONS(6097),
    [anon_sym_BSLASHAcs] = ACTIONS(6097),
    [anon_sym_BSLASHacsp] = ACTIONS(6097),
    [anon_sym_BSLASHAcsp] = ACTIONS(6097),
    [anon_sym_BSLASHacl] = ACTIONS(6097),
    [anon_sym_BSLASHAcl] = ACTIONS(6097),
    [anon_sym_BSLASHaclp] = ACTIONS(6097),
    [anon_sym_BSLASHAclp] = ACTIONS(6097),
    [anon_sym_BSLASHacf] = ACTIONS(6097),
    [anon_sym_BSLASHAcf] = ACTIONS(6097),
    [anon_sym_BSLASHacfp] = ACTIONS(6097),
    [anon_sym_BSLASHAcfp] = ACTIONS(6097),
    [anon_sym_BSLASHac] = ACTIONS(6097),
    [anon_sym_BSLASHAc] = ACTIONS(6097),
    [anon_sym_BSLASHacp] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6097),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6097),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6097),
    [anon_sym_BSLASHcolor] = ACTIONS(6097),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6097),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6097),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6097),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6097),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6097),
    [anon_sym_BSLASHtext] = ACTIONS(6097),
    [anon_sym_BSLASHintertext] = ACTIONS(6097),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6097),
    [anon_sym_BSLASHurl] = ACTIONS(6097),
    [anon_sym_BSLASHhref] = ACTIONS(6097),
  },
  [709] = {
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(651),
    [aux_sym__paragraph_repeat3] = STATE(651),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [710] = {
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(710),
    [aux_sym__section_repeat1] = STATE(710),
    [sym_command_name] = ACTIONS(5987),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5987),
    [anon_sym_LBRACK] = ACTIONS(5989),
    [anon_sym_RBRACK] = ACTIONS(5989),
    [anon_sym_COMMA] = ACTIONS(5989),
    [anon_sym_EQ] = ACTIONS(5989),
    [anon_sym_LPAREN] = ACTIONS(5989),
    [anon_sym_RPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHpart] = ACTIONS(6778),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6781),
    [anon_sym_BSLASHaddpart] = ACTIONS(6778),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6781),
    [anon_sym_BSLASHchapter] = ACTIONS(5987),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddchap] = ACTIONS(5987),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsection] = ACTIONS(5987),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddsec] = ACTIONS(5987),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHitem] = ACTIONS(5987),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5989),
    [anon_sym_LBRACE] = ACTIONS(5989),
    [sym_word] = ACTIONS(5987),
    [sym_placeholder] = ACTIONS(5989),
    [anon_sym_PLUS] = ACTIONS(5989),
    [anon_sym_DASH] = ACTIONS(5989),
    [anon_sym_STAR] = ACTIONS(5989),
    [anon_sym_SLASH] = ACTIONS(5989),
    [anon_sym_LT] = ACTIONS(5987),
    [anon_sym_GT] = ACTIONS(5987),
    [anon_sym_BANG] = ACTIONS(5987),
    [anon_sym_PIPE] = ACTIONS(5987),
    [anon_sym_COLON] = ACTIONS(5987),
    [anon_sym_SQUOTE] = ACTIONS(5987),
    [anon_sym__] = ACTIONS(5989),
    [anon_sym_CARET] = ACTIONS(5989),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5989),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5989),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5989),
    [anon_sym_DOLLAR] = ACTIONS(5987),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHbegin] = ACTIONS(5987),
    [anon_sym_BSLASHtitle] = ACTIONS(5987),
    [anon_sym_BSLASHauthor] = ACTIONS(5987),
    [anon_sym_BSLASHusepackage] = ACTIONS(5987),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5987),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5987),
    [anon_sym_BSLASHinclude] = ACTIONS(5987),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5987),
    [anon_sym_BSLASHinput] = ACTIONS(5987),
    [anon_sym_BSLASHsubfile] = ACTIONS(5987),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5987),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5987),
    [anon_sym_BSLASHbibliography] = ACTIONS(5987),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5987),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5987),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5987),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5987),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5987),
    [anon_sym_BSLASHimport] = ACTIONS(5987),
    [anon_sym_BSLASHsubimport] = ACTIONS(5987),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5987),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHcaption] = ACTIONS(5987),
    [anon_sym_BSLASHcite] = ACTIONS(5987),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCite] = ACTIONS(5987),
    [anon_sym_BSLASHnocite] = ACTIONS(5987),
    [anon_sym_BSLASHcitet] = ACTIONS(5987),
    [anon_sym_BSLASHcitep] = ACTIONS(5987),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteA] = ACTIONS(5987),
    [anon_sym_BSLASHciteR] = ACTIONS(5987),
    [anon_sym_BSLASHciteS] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5987),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteyear] = ACTIONS(5987),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitedate] = ACTIONS(5987),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteurl] = ACTIONS(5987),
    [anon_sym_BSLASHfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5987),
    [anon_sym_BSLASHcitealt] = ACTIONS(5987),
    [anon_sym_BSLASHcitealp] = ACTIONS(5987),
    [anon_sym_BSLASHcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHparencite] = ACTIONS(5987),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHParencite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHtextcite] = ACTIONS(5987),
    [anon_sym_BSLASHTextcite] = ACTIONS(5987),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHsupercite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite] = ACTIONS(5987),
    [anon_sym_BSLASHAutocite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHVolcite] = ACTIONS(5987),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHavolcite] = ACTIONS(5987),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHNotecite] = ACTIONS(5987),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHlabel] = ACTIONS(5987),
    [anon_sym_BSLASHref] = ACTIONS(5987),
    [anon_sym_BSLASHeqref] = ACTIONS(5987),
    [anon_sym_BSLASHvref] = ACTIONS(5987),
    [anon_sym_BSLASHVref] = ACTIONS(5987),
    [anon_sym_BSLASHautoref] = ACTIONS(5987),
    [anon_sym_BSLASHpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcref] = ACTIONS(5987),
    [anon_sym_BSLASHCref] = ACTIONS(5987),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnameCref] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHdef] = ACTIONS(5987),
    [anon_sym_BSLASHlet] = ACTIONS(5987),
    [anon_sym_BSLASHleft] = ACTIONS(5987),
    [anon_sym_BSLASHbigl] = ACTIONS(5987),
    [anon_sym_BSLASHBigl] = ACTIONS(5987),
    [anon_sym_BSLASHbiggl] = ACTIONS(5987),
    [anon_sym_BSLASHBiggl] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5987),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5987),
    [anon_sym_BSLASHgls] = ACTIONS(5987),
    [anon_sym_BSLASHGls] = ACTIONS(5987),
    [anon_sym_BSLASHGLS] = ACTIONS(5987),
    [anon_sym_BSLASHglspl] = ACTIONS(5987),
    [anon_sym_BSLASHGlspl] = ACTIONS(5987),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5987),
    [anon_sym_BSLASHglslink] = ACTIONS(5987),
    [anon_sym_BSLASHglstext] = ACTIONS(5987),
    [anon_sym_BSLASHGlstext] = ACTIONS(5987),
    [anon_sym_BSLASHGLStext] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5987),
    [anon_sym_BSLASHglsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsname] = ACTIONS(5987),
    [anon_sym_BSLASHGlsname] = ACTIONS(5987),
    [anon_sym_BSLASHGLSname] = ACTIONS(5987),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5987),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5987),
    [anon_sym_BSLASHacrshort] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5987),
    [anon_sym_BSLASHACRshort] = ACTIONS(5987),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrlong] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5987),
    [anon_sym_BSLASHACRlong] = ACTIONS(5987),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrfull] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5987),
    [anon_sym_BSLASHACRfull] = ACTIONS(5987),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHacs] = ACTIONS(5987),
    [anon_sym_BSLASHAcs] = ACTIONS(5987),
    [anon_sym_BSLASHacsp] = ACTIONS(5987),
    [anon_sym_BSLASHAcsp] = ACTIONS(5987),
    [anon_sym_BSLASHacl] = ACTIONS(5987),
    [anon_sym_BSLASHAcl] = ACTIONS(5987),
    [anon_sym_BSLASHaclp] = ACTIONS(5987),
    [anon_sym_BSLASHAclp] = ACTIONS(5987),
    [anon_sym_BSLASHacf] = ACTIONS(5987),
    [anon_sym_BSLASHAcf] = ACTIONS(5987),
    [anon_sym_BSLASHacfp] = ACTIONS(5987),
    [anon_sym_BSLASHAcfp] = ACTIONS(5987),
    [anon_sym_BSLASHac] = ACTIONS(5987),
    [anon_sym_BSLASHAc] = ACTIONS(5987),
    [anon_sym_BSLASHacp] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5987),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5987),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5987),
    [anon_sym_BSLASHcolor] = ACTIONS(5987),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5987),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5987),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5987),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5987),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5987),
    [anon_sym_BSLASHtext] = ACTIONS(5987),
    [anon_sym_BSLASHintertext] = ACTIONS(5987),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5987),
    [anon_sym_BSLASHurl] = ACTIONS(5987),
    [anon_sym_BSLASHhref] = ACTIONS(5987),
  },
  [711] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [712] = {
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(712),
    [aux_sym__paragraph_repeat1] = STATE(712),
    [sym_command_name] = ACTIONS(6027),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6027),
    [anon_sym_LBRACK] = ACTIONS(6029),
    [anon_sym_RBRACK] = ACTIONS(6029),
    [anon_sym_COMMA] = ACTIONS(6029),
    [anon_sym_EQ] = ACTIONS(6029),
    [anon_sym_LPAREN] = ACTIONS(6029),
    [anon_sym_RPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHpart] = ACTIONS(6027),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddpart] = ACTIONS(6027),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHchapter] = ACTIONS(6027),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddchap] = ACTIONS(6027),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsection] = ACTIONS(6027),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddsec] = ACTIONS(6027),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHparagraph] = ACTIONS(6784),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6787),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6027),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHitem] = ACTIONS(6027),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6029),
    [anon_sym_LBRACE] = ACTIONS(6029),
    [sym_word] = ACTIONS(6027),
    [sym_placeholder] = ACTIONS(6029),
    [anon_sym_PLUS] = ACTIONS(6029),
    [anon_sym_DASH] = ACTIONS(6029),
    [anon_sym_STAR] = ACTIONS(6029),
    [anon_sym_SLASH] = ACTIONS(6029),
    [anon_sym_LT] = ACTIONS(6027),
    [anon_sym_GT] = ACTIONS(6027),
    [anon_sym_BANG] = ACTIONS(6027),
    [anon_sym_PIPE] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6027),
    [anon_sym_SQUOTE] = ACTIONS(6027),
    [anon_sym__] = ACTIONS(6029),
    [anon_sym_CARET] = ACTIONS(6029),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6029),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6027),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHbegin] = ACTIONS(6027),
    [anon_sym_BSLASHend] = ACTIONS(6027),
    [anon_sym_BSLASHtitle] = ACTIONS(6027),
    [anon_sym_BSLASHauthor] = ACTIONS(6027),
    [anon_sym_BSLASHusepackage] = ACTIONS(6027),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6027),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6027),
    [anon_sym_BSLASHinclude] = ACTIONS(6027),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6027),
    [anon_sym_BSLASHinput] = ACTIONS(6027),
    [anon_sym_BSLASHsubfile] = ACTIONS(6027),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6027),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6027),
    [anon_sym_BSLASHbibliography] = ACTIONS(6027),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6027),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6027),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6027),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6027),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6027),
    [anon_sym_BSLASHimport] = ACTIONS(6027),
    [anon_sym_BSLASHsubimport] = ACTIONS(6027),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6027),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHcaption] = ACTIONS(6027),
    [anon_sym_BSLASHcite] = ACTIONS(6027),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCite] = ACTIONS(6027),
    [anon_sym_BSLASHnocite] = ACTIONS(6027),
    [anon_sym_BSLASHcitet] = ACTIONS(6027),
    [anon_sym_BSLASHcitep] = ACTIONS(6027),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteA] = ACTIONS(6027),
    [anon_sym_BSLASHciteR] = ACTIONS(6027),
    [anon_sym_BSLASHciteS] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6027),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteyear] = ACTIONS(6027),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitedate] = ACTIONS(6027),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteurl] = ACTIONS(6027),
    [anon_sym_BSLASHfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6027),
    [anon_sym_BSLASHcitealt] = ACTIONS(6027),
    [anon_sym_BSLASHcitealp] = ACTIONS(6027),
    [anon_sym_BSLASHcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHparencite] = ACTIONS(6027),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHParencite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHtextcite] = ACTIONS(6027),
    [anon_sym_BSLASHTextcite] = ACTIONS(6027),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHsupercite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite] = ACTIONS(6027),
    [anon_sym_BSLASHAutocite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHVolcite] = ACTIONS(6027),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHavolcite] = ACTIONS(6027),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHNotecite] = ACTIONS(6027),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHlabel] = ACTIONS(6027),
    [anon_sym_BSLASHref] = ACTIONS(6027),
    [anon_sym_BSLASHeqref] = ACTIONS(6027),
    [anon_sym_BSLASHvref] = ACTIONS(6027),
    [anon_sym_BSLASHVref] = ACTIONS(6027),
    [anon_sym_BSLASHautoref] = ACTIONS(6027),
    [anon_sym_BSLASHpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcref] = ACTIONS(6027),
    [anon_sym_BSLASHCref] = ACTIONS(6027),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnameCref] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHdef] = ACTIONS(6027),
    [anon_sym_BSLASHlet] = ACTIONS(6027),
    [anon_sym_BSLASHleft] = ACTIONS(6027),
    [anon_sym_BSLASHbigl] = ACTIONS(6027),
    [anon_sym_BSLASHBigl] = ACTIONS(6027),
    [anon_sym_BSLASHbiggl] = ACTIONS(6027),
    [anon_sym_BSLASHBiggl] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6027),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6027),
    [anon_sym_BSLASHgls] = ACTIONS(6027),
    [anon_sym_BSLASHGls] = ACTIONS(6027),
    [anon_sym_BSLASHGLS] = ACTIONS(6027),
    [anon_sym_BSLASHglspl] = ACTIONS(6027),
    [anon_sym_BSLASHGlspl] = ACTIONS(6027),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6027),
    [anon_sym_BSLASHglslink] = ACTIONS(6027),
    [anon_sym_BSLASHglstext] = ACTIONS(6027),
    [anon_sym_BSLASHGlstext] = ACTIONS(6027),
    [anon_sym_BSLASHGLStext] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6027),
    [anon_sym_BSLASHglsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsname] = ACTIONS(6027),
    [anon_sym_BSLASHGlsname] = ACTIONS(6027),
    [anon_sym_BSLASHGLSname] = ACTIONS(6027),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6027),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6027),
    [anon_sym_BSLASHacrshort] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6027),
    [anon_sym_BSLASHACRshort] = ACTIONS(6027),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrlong] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6027),
    [anon_sym_BSLASHACRlong] = ACTIONS(6027),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrfull] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6027),
    [anon_sym_BSLASHACRfull] = ACTIONS(6027),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHacs] = ACTIONS(6027),
    [anon_sym_BSLASHAcs] = ACTIONS(6027),
    [anon_sym_BSLASHacsp] = ACTIONS(6027),
    [anon_sym_BSLASHAcsp] = ACTIONS(6027),
    [anon_sym_BSLASHacl] = ACTIONS(6027),
    [anon_sym_BSLASHAcl] = ACTIONS(6027),
    [anon_sym_BSLASHaclp] = ACTIONS(6027),
    [anon_sym_BSLASHAclp] = ACTIONS(6027),
    [anon_sym_BSLASHacf] = ACTIONS(6027),
    [anon_sym_BSLASHAcf] = ACTIONS(6027),
    [anon_sym_BSLASHacfp] = ACTIONS(6027),
    [anon_sym_BSLASHAcfp] = ACTIONS(6027),
    [anon_sym_BSLASHac] = ACTIONS(6027),
    [anon_sym_BSLASHAc] = ACTIONS(6027),
    [anon_sym_BSLASHacp] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6027),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6027),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6027),
    [anon_sym_BSLASHcolor] = ACTIONS(6027),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6027),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6027),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6027),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6027),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6027),
    [anon_sym_BSLASHtext] = ACTIONS(6027),
    [anon_sym_BSLASHintertext] = ACTIONS(6027),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6027),
    [anon_sym_BSLASHurl] = ACTIONS(6027),
    [anon_sym_BSLASHhref] = ACTIONS(6027),
  },
  [713] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(6093),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6093),
    [anon_sym_LBRACK] = ACTIONS(6095),
    [anon_sym_RBRACK] = ACTIONS(6095),
    [anon_sym_COMMA] = ACTIONS(6095),
    [anon_sym_EQ] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6095),
    [anon_sym_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHpart] = ACTIONS(6093),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddpart] = ACTIONS(6093),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHchapter] = ACTIONS(6093),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddchap] = ACTIONS(6093),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsection] = ACTIONS(6093),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHaddsec] = ACTIONS(6093),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsection] = ACTIONS(6093),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6093),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHitem] = ACTIONS(6093),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6095),
    [anon_sym_LBRACE] = ACTIONS(6095),
    [sym_word] = ACTIONS(6093),
    [sym_placeholder] = ACTIONS(6095),
    [anon_sym_PLUS] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_STAR] = ACTIONS(6095),
    [anon_sym_SLASH] = ACTIONS(6095),
    [anon_sym_LT] = ACTIONS(6093),
    [anon_sym_GT] = ACTIONS(6093),
    [anon_sym_BANG] = ACTIONS(6093),
    [anon_sym_PIPE] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_SQUOTE] = ACTIONS(6093),
    [anon_sym__] = ACTIONS(6095),
    [anon_sym_CARET] = ACTIONS(6095),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6095),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6095),
    [anon_sym_DOLLAR] = ACTIONS(6093),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6095),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6095),
    [anon_sym_BSLASHbegin] = ACTIONS(6093),
    [anon_sym_BSLASHtitle] = ACTIONS(6093),
    [anon_sym_BSLASHauthor] = ACTIONS(6093),
    [anon_sym_BSLASHusepackage] = ACTIONS(6093),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6093),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6093),
    [anon_sym_BSLASHinclude] = ACTIONS(6093),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6093),
    [anon_sym_BSLASHinput] = ACTIONS(6093),
    [anon_sym_BSLASHsubfile] = ACTIONS(6093),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6093),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6093),
    [anon_sym_BSLASHbibliography] = ACTIONS(6093),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6093),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6093),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6093),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6093),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6093),
    [anon_sym_BSLASHimport] = ACTIONS(6093),
    [anon_sym_BSLASHsubimport] = ACTIONS(6093),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6093),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6093),
    [anon_sym_BSLASHcaption] = ACTIONS(6093),
    [anon_sym_BSLASHcite] = ACTIONS(6093),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCite] = ACTIONS(6093),
    [anon_sym_BSLASHnocite] = ACTIONS(6093),
    [anon_sym_BSLASHcitet] = ACTIONS(6093),
    [anon_sym_BSLASHcitep] = ACTIONS(6093),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteA] = ACTIONS(6093),
    [anon_sym_BSLASHciteR] = ACTIONS(6093),
    [anon_sym_BSLASHciteS] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6093),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6093),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteyear] = ACTIONS(6093),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHcitedate] = ACTIONS(6093),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHciteurl] = ACTIONS(6093),
    [anon_sym_BSLASHfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6093),
    [anon_sym_BSLASHcitealt] = ACTIONS(6093),
    [anon_sym_BSLASHcitealp] = ACTIONS(6093),
    [anon_sym_BSLASHcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHparencite] = ACTIONS(6093),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHParencite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6093),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6093),
    [anon_sym_BSLASHtextcite] = ACTIONS(6093),
    [anon_sym_BSLASHTextcite] = ACTIONS(6093),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6093),
    [anon_sym_BSLASHsupercite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite] = ACTIONS(6093),
    [anon_sym_BSLASHAutocite] = ACTIONS(6093),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHVolcite] = ACTIONS(6093),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHavolcite] = ACTIONS(6093),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6093),
    [anon_sym_BSLASHnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHNotecite] = ACTIONS(6093),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6093),
    [anon_sym_BSLASHlabel] = ACTIONS(6093),
    [anon_sym_BSLASHref] = ACTIONS(6093),
    [anon_sym_BSLASHeqref] = ACTIONS(6093),
    [anon_sym_BSLASHvref] = ACTIONS(6093),
    [anon_sym_BSLASHVref] = ACTIONS(6093),
    [anon_sym_BSLASHautoref] = ACTIONS(6093),
    [anon_sym_BSLASHpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcref] = ACTIONS(6093),
    [anon_sym_BSLASHCref] = ACTIONS(6093),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnameCref] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6093),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6093),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6093),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6093),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6093),
    [anon_sym_BSLASHdef] = ACTIONS(6093),
    [anon_sym_BSLASHlet] = ACTIONS(6093),
    [anon_sym_BSLASHleft] = ACTIONS(6093),
    [anon_sym_BSLASHbigl] = ACTIONS(6093),
    [anon_sym_BSLASHBigl] = ACTIONS(6093),
    [anon_sym_BSLASHbiggl] = ACTIONS(6093),
    [anon_sym_BSLASHBiggl] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6093),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6093),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6093),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6093),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6093),
    [anon_sym_BSLASHgls] = ACTIONS(6093),
    [anon_sym_BSLASHGls] = ACTIONS(6093),
    [anon_sym_BSLASHGLS] = ACTIONS(6093),
    [anon_sym_BSLASHglspl] = ACTIONS(6093),
    [anon_sym_BSLASHGlspl] = ACTIONS(6093),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6093),
    [anon_sym_BSLASHglslink] = ACTIONS(6093),
    [anon_sym_BSLASHglstext] = ACTIONS(6093),
    [anon_sym_BSLASHGlstext] = ACTIONS(6093),
    [anon_sym_BSLASHGLStext] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6093),
    [anon_sym_BSLASHglsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6093),
    [anon_sym_BSLASHglsname] = ACTIONS(6093),
    [anon_sym_BSLASHGlsname] = ACTIONS(6093),
    [anon_sym_BSLASHGLSname] = ACTIONS(6093),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6093),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6093),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6093),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6093),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6093),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6093),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6093),
    [anon_sym_BSLASHacrshort] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6093),
    [anon_sym_BSLASHACRshort] = ACTIONS(6093),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrlong] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6093),
    [anon_sym_BSLASHACRlong] = ACTIONS(6093),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6093),
    [anon_sym_BSLASHacrfull] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6093),
    [anon_sym_BSLASHACRfull] = ACTIONS(6093),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHacs] = ACTIONS(6093),
    [anon_sym_BSLASHAcs] = ACTIONS(6093),
    [anon_sym_BSLASHacsp] = ACTIONS(6093),
    [anon_sym_BSLASHAcsp] = ACTIONS(6093),
    [anon_sym_BSLASHacl] = ACTIONS(6093),
    [anon_sym_BSLASHAcl] = ACTIONS(6093),
    [anon_sym_BSLASHaclp] = ACTIONS(6093),
    [anon_sym_BSLASHAclp] = ACTIONS(6093),
    [anon_sym_BSLASHacf] = ACTIONS(6093),
    [anon_sym_BSLASHAcf] = ACTIONS(6093),
    [anon_sym_BSLASHacfp] = ACTIONS(6093),
    [anon_sym_BSLASHAcfp] = ACTIONS(6093),
    [anon_sym_BSLASHac] = ACTIONS(6093),
    [anon_sym_BSLASHAc] = ACTIONS(6093),
    [anon_sym_BSLASHacp] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6093),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6093),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6093),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6093),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6095),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6093),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6093),
    [anon_sym_BSLASHcolor] = ACTIONS(6093),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6093),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6093),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6093),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6093),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6093),
    [anon_sym_BSLASHtext] = ACTIONS(6093),
    [anon_sym_BSLASHintertext] = ACTIONS(6093),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6093),
    [anon_sym_BSLASHurl] = ACTIONS(6093),
    [anon_sym_BSLASHhref] = ACTIONS(6093),
  },
  [714] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(6017),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6017),
    [anon_sym_LBRACK] = ACTIONS(6019),
    [anon_sym_RBRACK] = ACTIONS(6019),
    [anon_sym_COMMA] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6019),
    [anon_sym_LPAREN] = ACTIONS(6019),
    [anon_sym_RPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHpart] = ACTIONS(6017),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddpart] = ACTIONS(6017),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHchapter] = ACTIONS(6017),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddchap] = ACTIONS(6017),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsection] = ACTIONS(6017),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddsec] = ACTIONS(6017),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsection] = ACTIONS(6017),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6790),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6793),
    [anon_sym_BSLASHparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHitem] = ACTIONS(6017),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6019),
    [anon_sym_LBRACE] = ACTIONS(6019),
    [sym_word] = ACTIONS(6017),
    [sym_placeholder] = ACTIONS(6019),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6019),
    [anon_sym_SLASH] = ACTIONS(6019),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_BANG] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6017),
    [anon_sym_COLON] = ACTIONS(6017),
    [anon_sym_SQUOTE] = ACTIONS(6017),
    [anon_sym__] = ACTIONS(6019),
    [anon_sym_CARET] = ACTIONS(6019),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6019),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6019),
    [anon_sym_DOLLAR] = ACTIONS(6017),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHbegin] = ACTIONS(6017),
    [anon_sym_BSLASHend] = ACTIONS(6017),
    [anon_sym_BSLASHtitle] = ACTIONS(6017),
    [anon_sym_BSLASHauthor] = ACTIONS(6017),
    [anon_sym_BSLASHusepackage] = ACTIONS(6017),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6017),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6017),
    [anon_sym_BSLASHinclude] = ACTIONS(6017),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6017),
    [anon_sym_BSLASHinput] = ACTIONS(6017),
    [anon_sym_BSLASHsubfile] = ACTIONS(6017),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6017),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6017),
    [anon_sym_BSLASHbibliography] = ACTIONS(6017),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6017),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6017),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6017),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6017),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6017),
    [anon_sym_BSLASHimport] = ACTIONS(6017),
    [anon_sym_BSLASHsubimport] = ACTIONS(6017),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6017),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHcaption] = ACTIONS(6017),
    [anon_sym_BSLASHcite] = ACTIONS(6017),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCite] = ACTIONS(6017),
    [anon_sym_BSLASHnocite] = ACTIONS(6017),
    [anon_sym_BSLASHcitet] = ACTIONS(6017),
    [anon_sym_BSLASHcitep] = ACTIONS(6017),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteA] = ACTIONS(6017),
    [anon_sym_BSLASHciteR] = ACTIONS(6017),
    [anon_sym_BSLASHciteS] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6017),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteyear] = ACTIONS(6017),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitedate] = ACTIONS(6017),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteurl] = ACTIONS(6017),
    [anon_sym_BSLASHfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6017),
    [anon_sym_BSLASHcitealt] = ACTIONS(6017),
    [anon_sym_BSLASHcitealp] = ACTIONS(6017),
    [anon_sym_BSLASHcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHparencite] = ACTIONS(6017),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHParencite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHtextcite] = ACTIONS(6017),
    [anon_sym_BSLASHTextcite] = ACTIONS(6017),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHsupercite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite] = ACTIONS(6017),
    [anon_sym_BSLASHAutocite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHVolcite] = ACTIONS(6017),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHavolcite] = ACTIONS(6017),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHNotecite] = ACTIONS(6017),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHlabel] = ACTIONS(6017),
    [anon_sym_BSLASHref] = ACTIONS(6017),
    [anon_sym_BSLASHeqref] = ACTIONS(6017),
    [anon_sym_BSLASHvref] = ACTIONS(6017),
    [anon_sym_BSLASHVref] = ACTIONS(6017),
    [anon_sym_BSLASHautoref] = ACTIONS(6017),
    [anon_sym_BSLASHpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcref] = ACTIONS(6017),
    [anon_sym_BSLASHCref] = ACTIONS(6017),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnameCref] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHdef] = ACTIONS(6017),
    [anon_sym_BSLASHlet] = ACTIONS(6017),
    [anon_sym_BSLASHleft] = ACTIONS(6017),
    [anon_sym_BSLASHbigl] = ACTIONS(6017),
    [anon_sym_BSLASHBigl] = ACTIONS(6017),
    [anon_sym_BSLASHbiggl] = ACTIONS(6017),
    [anon_sym_BSLASHBiggl] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6017),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6017),
    [anon_sym_BSLASHgls] = ACTIONS(6017),
    [anon_sym_BSLASHGls] = ACTIONS(6017),
    [anon_sym_BSLASHGLS] = ACTIONS(6017),
    [anon_sym_BSLASHglspl] = ACTIONS(6017),
    [anon_sym_BSLASHGlspl] = ACTIONS(6017),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6017),
    [anon_sym_BSLASHglslink] = ACTIONS(6017),
    [anon_sym_BSLASHglstext] = ACTIONS(6017),
    [anon_sym_BSLASHGlstext] = ACTIONS(6017),
    [anon_sym_BSLASHGLStext] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6017),
    [anon_sym_BSLASHglsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsname] = ACTIONS(6017),
    [anon_sym_BSLASHGlsname] = ACTIONS(6017),
    [anon_sym_BSLASHGLSname] = ACTIONS(6017),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6017),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6017),
    [anon_sym_BSLASHacrshort] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6017),
    [anon_sym_BSLASHACRshort] = ACTIONS(6017),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrlong] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6017),
    [anon_sym_BSLASHACRlong] = ACTIONS(6017),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrfull] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6017),
    [anon_sym_BSLASHACRfull] = ACTIONS(6017),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHacs] = ACTIONS(6017),
    [anon_sym_BSLASHAcs] = ACTIONS(6017),
    [anon_sym_BSLASHacsp] = ACTIONS(6017),
    [anon_sym_BSLASHAcsp] = ACTIONS(6017),
    [anon_sym_BSLASHacl] = ACTIONS(6017),
    [anon_sym_BSLASHAcl] = ACTIONS(6017),
    [anon_sym_BSLASHaclp] = ACTIONS(6017),
    [anon_sym_BSLASHAclp] = ACTIONS(6017),
    [anon_sym_BSLASHacf] = ACTIONS(6017),
    [anon_sym_BSLASHAcf] = ACTIONS(6017),
    [anon_sym_BSLASHacfp] = ACTIONS(6017),
    [anon_sym_BSLASHAcfp] = ACTIONS(6017),
    [anon_sym_BSLASHac] = ACTIONS(6017),
    [anon_sym_BSLASHAc] = ACTIONS(6017),
    [anon_sym_BSLASHacp] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6017),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6017),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6017),
    [anon_sym_BSLASHcolor] = ACTIONS(6017),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6017),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6017),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6017),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6017),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6017),
    [anon_sym_BSLASHtext] = ACTIONS(6017),
    [anon_sym_BSLASHintertext] = ACTIONS(6017),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6017),
    [anon_sym_BSLASHurl] = ACTIONS(6017),
    [anon_sym_BSLASHhref] = ACTIONS(6017),
  },
  [715] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(6097),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6097),
    [anon_sym_LBRACK] = ACTIONS(6099),
    [anon_sym_RBRACK] = ACTIONS(6099),
    [anon_sym_COMMA] = ACTIONS(6099),
    [anon_sym_EQ] = ACTIONS(6099),
    [anon_sym_LPAREN] = ACTIONS(6099),
    [anon_sym_RPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHpart] = ACTIONS(6097),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddpart] = ACTIONS(6097),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHchapter] = ACTIONS(6097),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddchap] = ACTIONS(6097),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsection] = ACTIONS(6097),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHaddsec] = ACTIONS(6097),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsection] = ACTIONS(6097),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6097),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHitem] = ACTIONS(6097),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6099),
    [anon_sym_LBRACE] = ACTIONS(6099),
    [sym_word] = ACTIONS(6097),
    [sym_placeholder] = ACTIONS(6099),
    [anon_sym_PLUS] = ACTIONS(6099),
    [anon_sym_DASH] = ACTIONS(6099),
    [anon_sym_STAR] = ACTIONS(6099),
    [anon_sym_SLASH] = ACTIONS(6099),
    [anon_sym_LT] = ACTIONS(6097),
    [anon_sym_GT] = ACTIONS(6097),
    [anon_sym_BANG] = ACTIONS(6097),
    [anon_sym_PIPE] = ACTIONS(6097),
    [anon_sym_COLON] = ACTIONS(6097),
    [anon_sym_SQUOTE] = ACTIONS(6097),
    [anon_sym__] = ACTIONS(6099),
    [anon_sym_CARET] = ACTIONS(6099),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6099),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6099),
    [anon_sym_DOLLAR] = ACTIONS(6097),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6099),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6099),
    [anon_sym_BSLASHbegin] = ACTIONS(6097),
    [anon_sym_BSLASHtitle] = ACTIONS(6097),
    [anon_sym_BSLASHauthor] = ACTIONS(6097),
    [anon_sym_BSLASHusepackage] = ACTIONS(6097),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6097),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6097),
    [anon_sym_BSLASHinclude] = ACTIONS(6097),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6097),
    [anon_sym_BSLASHinput] = ACTIONS(6097),
    [anon_sym_BSLASHsubfile] = ACTIONS(6097),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6097),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6097),
    [anon_sym_BSLASHbibliography] = ACTIONS(6097),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6097),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6097),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6097),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6097),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6097),
    [anon_sym_BSLASHimport] = ACTIONS(6097),
    [anon_sym_BSLASHsubimport] = ACTIONS(6097),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6097),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6097),
    [anon_sym_BSLASHcaption] = ACTIONS(6097),
    [anon_sym_BSLASHcite] = ACTIONS(6097),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCite] = ACTIONS(6097),
    [anon_sym_BSLASHnocite] = ACTIONS(6097),
    [anon_sym_BSLASHcitet] = ACTIONS(6097),
    [anon_sym_BSLASHcitep] = ACTIONS(6097),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteA] = ACTIONS(6097),
    [anon_sym_BSLASHciteR] = ACTIONS(6097),
    [anon_sym_BSLASHciteS] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6097),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6097),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteyear] = ACTIONS(6097),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHcitedate] = ACTIONS(6097),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHciteurl] = ACTIONS(6097),
    [anon_sym_BSLASHfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6097),
    [anon_sym_BSLASHcitealt] = ACTIONS(6097),
    [anon_sym_BSLASHcitealp] = ACTIONS(6097),
    [anon_sym_BSLASHcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHparencite] = ACTIONS(6097),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHParencite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6097),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6097),
    [anon_sym_BSLASHtextcite] = ACTIONS(6097),
    [anon_sym_BSLASHTextcite] = ACTIONS(6097),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6097),
    [anon_sym_BSLASHsupercite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite] = ACTIONS(6097),
    [anon_sym_BSLASHAutocite] = ACTIONS(6097),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHVolcite] = ACTIONS(6097),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHavolcite] = ACTIONS(6097),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6097),
    [anon_sym_BSLASHnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHNotecite] = ACTIONS(6097),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6097),
    [anon_sym_BSLASHlabel] = ACTIONS(6097),
    [anon_sym_BSLASHref] = ACTIONS(6097),
    [anon_sym_BSLASHeqref] = ACTIONS(6097),
    [anon_sym_BSLASHvref] = ACTIONS(6097),
    [anon_sym_BSLASHVref] = ACTIONS(6097),
    [anon_sym_BSLASHautoref] = ACTIONS(6097),
    [anon_sym_BSLASHpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcref] = ACTIONS(6097),
    [anon_sym_BSLASHCref] = ACTIONS(6097),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnameCref] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6097),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6097),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6097),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6097),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6097),
    [anon_sym_BSLASHdef] = ACTIONS(6097),
    [anon_sym_BSLASHlet] = ACTIONS(6097),
    [anon_sym_BSLASHleft] = ACTIONS(6097),
    [anon_sym_BSLASHbigl] = ACTIONS(6097),
    [anon_sym_BSLASHBigl] = ACTIONS(6097),
    [anon_sym_BSLASHbiggl] = ACTIONS(6097),
    [anon_sym_BSLASHBiggl] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6097),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6097),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6097),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6097),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6097),
    [anon_sym_BSLASHgls] = ACTIONS(6097),
    [anon_sym_BSLASHGls] = ACTIONS(6097),
    [anon_sym_BSLASHGLS] = ACTIONS(6097),
    [anon_sym_BSLASHglspl] = ACTIONS(6097),
    [anon_sym_BSLASHGlspl] = ACTIONS(6097),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6097),
    [anon_sym_BSLASHglslink] = ACTIONS(6097),
    [anon_sym_BSLASHglstext] = ACTIONS(6097),
    [anon_sym_BSLASHGlstext] = ACTIONS(6097),
    [anon_sym_BSLASHGLStext] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6097),
    [anon_sym_BSLASHglsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6097),
    [anon_sym_BSLASHglsname] = ACTIONS(6097),
    [anon_sym_BSLASHGlsname] = ACTIONS(6097),
    [anon_sym_BSLASHGLSname] = ACTIONS(6097),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6097),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6097),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6097),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6097),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6097),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6097),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6097),
    [anon_sym_BSLASHacrshort] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6097),
    [anon_sym_BSLASHACRshort] = ACTIONS(6097),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrlong] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6097),
    [anon_sym_BSLASHACRlong] = ACTIONS(6097),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6097),
    [anon_sym_BSLASHacrfull] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6097),
    [anon_sym_BSLASHACRfull] = ACTIONS(6097),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHacs] = ACTIONS(6097),
    [anon_sym_BSLASHAcs] = ACTIONS(6097),
    [anon_sym_BSLASHacsp] = ACTIONS(6097),
    [anon_sym_BSLASHAcsp] = ACTIONS(6097),
    [anon_sym_BSLASHacl] = ACTIONS(6097),
    [anon_sym_BSLASHAcl] = ACTIONS(6097),
    [anon_sym_BSLASHaclp] = ACTIONS(6097),
    [anon_sym_BSLASHAclp] = ACTIONS(6097),
    [anon_sym_BSLASHacf] = ACTIONS(6097),
    [anon_sym_BSLASHAcf] = ACTIONS(6097),
    [anon_sym_BSLASHacfp] = ACTIONS(6097),
    [anon_sym_BSLASHAcfp] = ACTIONS(6097),
    [anon_sym_BSLASHac] = ACTIONS(6097),
    [anon_sym_BSLASHAc] = ACTIONS(6097),
    [anon_sym_BSLASHacp] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6097),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6097),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6097),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6097),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6099),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6097),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6097),
    [anon_sym_BSLASHcolor] = ACTIONS(6097),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6097),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6097),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6097),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6097),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6097),
    [anon_sym_BSLASHtext] = ACTIONS(6097),
    [anon_sym_BSLASHintertext] = ACTIONS(6097),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6097),
    [anon_sym_BSLASHurl] = ACTIONS(6097),
    [anon_sym_BSLASHhref] = ACTIONS(6097),
  },
  [716] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(5961),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5963),
    [anon_sym_RBRACK] = ACTIONS(5963),
    [anon_sym_COMMA] = ACTIONS(5963),
    [anon_sym_EQ] = ACTIONS(5963),
    [anon_sym_LPAREN] = ACTIONS(5963),
    [anon_sym_RPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHpart] = ACTIONS(5961),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddpart] = ACTIONS(5961),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHchapter] = ACTIONS(5961),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddchap] = ACTIONS(5961),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsection] = ACTIONS(5961),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddsec] = ACTIONS(5961),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubsection] = ACTIONS(6796),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6799),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5961),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHitem] = ACTIONS(5961),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5963),
    [anon_sym_LBRACE] = ACTIONS(5963),
    [sym_word] = ACTIONS(5961),
    [sym_placeholder] = ACTIONS(5963),
    [anon_sym_PLUS] = ACTIONS(5963),
    [anon_sym_DASH] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_SLASH] = ACTIONS(5963),
    [anon_sym_LT] = ACTIONS(5961),
    [anon_sym_GT] = ACTIONS(5961),
    [anon_sym_BANG] = ACTIONS(5961),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_COLON] = ACTIONS(5961),
    [anon_sym_SQUOTE] = ACTIONS(5961),
    [anon_sym__] = ACTIONS(5963),
    [anon_sym_CARET] = ACTIONS(5963),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5963),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5963),
    [anon_sym_DOLLAR] = ACTIONS(5961),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHbegin] = ACTIONS(5961),
    [anon_sym_BSLASHend] = ACTIONS(5961),
    [anon_sym_BSLASHtitle] = ACTIONS(5961),
    [anon_sym_BSLASHauthor] = ACTIONS(5961),
    [anon_sym_BSLASHusepackage] = ACTIONS(5961),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5961),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5961),
    [anon_sym_BSLASHinclude] = ACTIONS(5961),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5961),
    [anon_sym_BSLASHinput] = ACTIONS(5961),
    [anon_sym_BSLASHsubfile] = ACTIONS(5961),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5961),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5961),
    [anon_sym_BSLASHbibliography] = ACTIONS(5961),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5961),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5961),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5961),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5961),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5961),
    [anon_sym_BSLASHimport] = ACTIONS(5961),
    [anon_sym_BSLASHsubimport] = ACTIONS(5961),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5961),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHcaption] = ACTIONS(5961),
    [anon_sym_BSLASHcite] = ACTIONS(5961),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCite] = ACTIONS(5961),
    [anon_sym_BSLASHnocite] = ACTIONS(5961),
    [anon_sym_BSLASHcitet] = ACTIONS(5961),
    [anon_sym_BSLASHcitep] = ACTIONS(5961),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteA] = ACTIONS(5961),
    [anon_sym_BSLASHciteR] = ACTIONS(5961),
    [anon_sym_BSLASHciteS] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5961),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteyear] = ACTIONS(5961),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitedate] = ACTIONS(5961),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteurl] = ACTIONS(5961),
    [anon_sym_BSLASHfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5961),
    [anon_sym_BSLASHcitealt] = ACTIONS(5961),
    [anon_sym_BSLASHcitealp] = ACTIONS(5961),
    [anon_sym_BSLASHcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHparencite] = ACTIONS(5961),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHParencite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHtextcite] = ACTIONS(5961),
    [anon_sym_BSLASHTextcite] = ACTIONS(5961),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHsupercite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite] = ACTIONS(5961),
    [anon_sym_BSLASHAutocite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHVolcite] = ACTIONS(5961),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHavolcite] = ACTIONS(5961),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHNotecite] = ACTIONS(5961),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHlabel] = ACTIONS(5961),
    [anon_sym_BSLASHref] = ACTIONS(5961),
    [anon_sym_BSLASHeqref] = ACTIONS(5961),
    [anon_sym_BSLASHvref] = ACTIONS(5961),
    [anon_sym_BSLASHVref] = ACTIONS(5961),
    [anon_sym_BSLASHautoref] = ACTIONS(5961),
    [anon_sym_BSLASHpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcref] = ACTIONS(5961),
    [anon_sym_BSLASHCref] = ACTIONS(5961),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnameCref] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHdef] = ACTIONS(5961),
    [anon_sym_BSLASHlet] = ACTIONS(5961),
    [anon_sym_BSLASHleft] = ACTIONS(5961),
    [anon_sym_BSLASHbigl] = ACTIONS(5961),
    [anon_sym_BSLASHBigl] = ACTIONS(5961),
    [anon_sym_BSLASHbiggl] = ACTIONS(5961),
    [anon_sym_BSLASHBiggl] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5961),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5961),
    [anon_sym_BSLASHgls] = ACTIONS(5961),
    [anon_sym_BSLASHGls] = ACTIONS(5961),
    [anon_sym_BSLASHGLS] = ACTIONS(5961),
    [anon_sym_BSLASHglspl] = ACTIONS(5961),
    [anon_sym_BSLASHGlspl] = ACTIONS(5961),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5961),
    [anon_sym_BSLASHglslink] = ACTIONS(5961),
    [anon_sym_BSLASHglstext] = ACTIONS(5961),
    [anon_sym_BSLASHGlstext] = ACTIONS(5961),
    [anon_sym_BSLASHGLStext] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5961),
    [anon_sym_BSLASHglsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsname] = ACTIONS(5961),
    [anon_sym_BSLASHGlsname] = ACTIONS(5961),
    [anon_sym_BSLASHGLSname] = ACTIONS(5961),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5961),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5961),
    [anon_sym_BSLASHacrshort] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5961),
    [anon_sym_BSLASHACRshort] = ACTIONS(5961),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrlong] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5961),
    [anon_sym_BSLASHACRlong] = ACTIONS(5961),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrfull] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5961),
    [anon_sym_BSLASHACRfull] = ACTIONS(5961),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHacs] = ACTIONS(5961),
    [anon_sym_BSLASHAcs] = ACTIONS(5961),
    [anon_sym_BSLASHacsp] = ACTIONS(5961),
    [anon_sym_BSLASHAcsp] = ACTIONS(5961),
    [anon_sym_BSLASHacl] = ACTIONS(5961),
    [anon_sym_BSLASHAcl] = ACTIONS(5961),
    [anon_sym_BSLASHaclp] = ACTIONS(5961),
    [anon_sym_BSLASHAclp] = ACTIONS(5961),
    [anon_sym_BSLASHacf] = ACTIONS(5961),
    [anon_sym_BSLASHAcf] = ACTIONS(5961),
    [anon_sym_BSLASHacfp] = ACTIONS(5961),
    [anon_sym_BSLASHAcfp] = ACTIONS(5961),
    [anon_sym_BSLASHac] = ACTIONS(5961),
    [anon_sym_BSLASHAc] = ACTIONS(5961),
    [anon_sym_BSLASHacp] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5961),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5961),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5961),
    [anon_sym_BSLASHcolor] = ACTIONS(5961),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5961),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5961),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5961),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5961),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5961),
    [anon_sym_BSLASHtext] = ACTIONS(5961),
    [anon_sym_BSLASHintertext] = ACTIONS(5961),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5961),
    [anon_sym_BSLASHurl] = ACTIONS(5961),
    [anon_sym_BSLASHhref] = ACTIONS(5961),
  },
  [717] = {
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(651),
    [aux_sym__paragraph_repeat3] = STATE(651),
    [sym_command_name] = ACTIONS(2250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_RBRACK] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [sym_word] = ACTIONS(2250),
    [sym_placeholder] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym__] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2252),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2252),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHbegin] = ACTIONS(2250),
    [anon_sym_BSLASHtitle] = ACTIONS(2250),
    [anon_sym_BSLASHauthor] = ACTIONS(2250),
    [anon_sym_BSLASHusepackage] = ACTIONS(2250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2250),
    [anon_sym_BSLASHinclude] = ACTIONS(2250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2250),
    [anon_sym_BSLASHinput] = ACTIONS(2250),
    [anon_sym_BSLASHsubfile] = ACTIONS(2250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2250),
    [anon_sym_BSLASHbibliography] = ACTIONS(2250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2250),
    [anon_sym_BSLASHimport] = ACTIONS(2250),
    [anon_sym_BSLASHsubimport] = ACTIONS(2250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHcaption] = ACTIONS(2250),
    [anon_sym_BSLASHcite] = ACTIONS(2250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCite] = ACTIONS(2250),
    [anon_sym_BSLASHnocite] = ACTIONS(2250),
    [anon_sym_BSLASHcitet] = ACTIONS(2250),
    [anon_sym_BSLASHcitep] = ACTIONS(2250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteA] = ACTIONS(2250),
    [anon_sym_BSLASHciteR] = ACTIONS(2250),
    [anon_sym_BSLASHciteS] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteyear] = ACTIONS(2250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitedate] = ACTIONS(2250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteurl] = ACTIONS(2250),
    [anon_sym_BSLASHfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2250),
    [anon_sym_BSLASHcitealt] = ACTIONS(2250),
    [anon_sym_BSLASHcitealp] = ACTIONS(2250),
    [anon_sym_BSLASHcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHparencite] = ACTIONS(2250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHParencite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHtextcite] = ACTIONS(2250),
    [anon_sym_BSLASHTextcite] = ACTIONS(2250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHsupercite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite] = ACTIONS(2250),
    [anon_sym_BSLASHAutocite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHVolcite] = ACTIONS(2250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHavolcite] = ACTIONS(2250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHNotecite] = ACTIONS(2250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHlabel] = ACTIONS(2250),
    [anon_sym_BSLASHref] = ACTIONS(2250),
    [anon_sym_BSLASHeqref] = ACTIONS(2250),
    [anon_sym_BSLASHvref] = ACTIONS(2250),
    [anon_sym_BSLASHVref] = ACTIONS(2250),
    [anon_sym_BSLASHautoref] = ACTIONS(2250),
    [anon_sym_BSLASHpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcref] = ACTIONS(2250),
    [anon_sym_BSLASHCref] = ACTIONS(2250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnameCref] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHdef] = ACTIONS(2250),
    [anon_sym_BSLASHlet] = ACTIONS(2250),
    [anon_sym_BSLASHleft] = ACTIONS(2250),
    [anon_sym_BSLASHbigl] = ACTIONS(2250),
    [anon_sym_BSLASHBigl] = ACTIONS(2250),
    [anon_sym_BSLASHbiggl] = ACTIONS(2250),
    [anon_sym_BSLASHBiggl] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2250),
    [anon_sym_BSLASHgls] = ACTIONS(2250),
    [anon_sym_BSLASHGls] = ACTIONS(2250),
    [anon_sym_BSLASHGLS] = ACTIONS(2250),
    [anon_sym_BSLASHglspl] = ACTIONS(2250),
    [anon_sym_BSLASHGlspl] = ACTIONS(2250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2250),
    [anon_sym_BSLASHglslink] = ACTIONS(2250),
    [anon_sym_BSLASHglstext] = ACTIONS(2250),
    [anon_sym_BSLASHGlstext] = ACTIONS(2250),
    [anon_sym_BSLASHGLStext] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2250),
    [anon_sym_BSLASHglsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsname] = ACTIONS(2250),
    [anon_sym_BSLASHGlsname] = ACTIONS(2250),
    [anon_sym_BSLASHGLSname] = ACTIONS(2250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2250),
    [anon_sym_BSLASHacrshort] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2250),
    [anon_sym_BSLASHACRshort] = ACTIONS(2250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrlong] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2250),
    [anon_sym_BSLASHACRlong] = ACTIONS(2250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrfull] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2250),
    [anon_sym_BSLASHACRfull] = ACTIONS(2250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHacs] = ACTIONS(2250),
    [anon_sym_BSLASHAcs] = ACTIONS(2250),
    [anon_sym_BSLASHacsp] = ACTIONS(2250),
    [anon_sym_BSLASHAcsp] = ACTIONS(2250),
    [anon_sym_BSLASHacl] = ACTIONS(2250),
    [anon_sym_BSLASHAcl] = ACTIONS(2250),
    [anon_sym_BSLASHaclp] = ACTIONS(2250),
    [anon_sym_BSLASHAclp] = ACTIONS(2250),
    [anon_sym_BSLASHacf] = ACTIONS(2250),
    [anon_sym_BSLASHAcf] = ACTIONS(2250),
    [anon_sym_BSLASHacfp] = ACTIONS(2250),
    [anon_sym_BSLASHAcfp] = ACTIONS(2250),
    [anon_sym_BSLASHac] = ACTIONS(2250),
    [anon_sym_BSLASHAc] = ACTIONS(2250),
    [anon_sym_BSLASHacp] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2250),
    [anon_sym_BSLASHcolor] = ACTIONS(2250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2250),
    [anon_sym_BSLASHtext] = ACTIONS(2250),
    [anon_sym_BSLASHintertext] = ACTIONS(2250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2250),
    [anon_sym_BSLASHurl] = ACTIONS(2250),
    [anon_sym_BSLASHhref] = ACTIONS(2250),
  },
  [718] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(6007),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6007),
    [anon_sym_LBRACK] = ACTIONS(6009),
    [anon_sym_RBRACK] = ACTIONS(6009),
    [anon_sym_COMMA] = ACTIONS(6009),
    [anon_sym_EQ] = ACTIONS(6009),
    [anon_sym_LPAREN] = ACTIONS(6009),
    [anon_sym_RPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHpart] = ACTIONS(6007),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddpart] = ACTIONS(6007),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHchapter] = ACTIONS(6007),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddchap] = ACTIONS(6007),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsection] = ACTIONS(6802),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6805),
    [anon_sym_BSLASHaddsec] = ACTIONS(6802),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6805),
    [anon_sym_BSLASHsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHitem] = ACTIONS(6007),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6009),
    [anon_sym_LBRACE] = ACTIONS(6009),
    [sym_word] = ACTIONS(6007),
    [sym_placeholder] = ACTIONS(6009),
    [anon_sym_PLUS] = ACTIONS(6009),
    [anon_sym_DASH] = ACTIONS(6009),
    [anon_sym_STAR] = ACTIONS(6009),
    [anon_sym_SLASH] = ACTIONS(6009),
    [anon_sym_LT] = ACTIONS(6007),
    [anon_sym_GT] = ACTIONS(6007),
    [anon_sym_BANG] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6007),
    [anon_sym_COLON] = ACTIONS(6007),
    [anon_sym_SQUOTE] = ACTIONS(6007),
    [anon_sym__] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(6009),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6009),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6009),
    [anon_sym_DOLLAR] = ACTIONS(6007),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHbegin] = ACTIONS(6007),
    [anon_sym_BSLASHend] = ACTIONS(6007),
    [anon_sym_BSLASHtitle] = ACTIONS(6007),
    [anon_sym_BSLASHauthor] = ACTIONS(6007),
    [anon_sym_BSLASHusepackage] = ACTIONS(6007),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6007),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6007),
    [anon_sym_BSLASHinclude] = ACTIONS(6007),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6007),
    [anon_sym_BSLASHinput] = ACTIONS(6007),
    [anon_sym_BSLASHsubfile] = ACTIONS(6007),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6007),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6007),
    [anon_sym_BSLASHbibliography] = ACTIONS(6007),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6007),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6007),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6007),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6007),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6007),
    [anon_sym_BSLASHimport] = ACTIONS(6007),
    [anon_sym_BSLASHsubimport] = ACTIONS(6007),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6007),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHcaption] = ACTIONS(6007),
    [anon_sym_BSLASHcite] = ACTIONS(6007),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCite] = ACTIONS(6007),
    [anon_sym_BSLASHnocite] = ACTIONS(6007),
    [anon_sym_BSLASHcitet] = ACTIONS(6007),
    [anon_sym_BSLASHcitep] = ACTIONS(6007),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteA] = ACTIONS(6007),
    [anon_sym_BSLASHciteR] = ACTIONS(6007),
    [anon_sym_BSLASHciteS] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6007),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteyear] = ACTIONS(6007),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitedate] = ACTIONS(6007),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteurl] = ACTIONS(6007),
    [anon_sym_BSLASHfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6007),
    [anon_sym_BSLASHcitealt] = ACTIONS(6007),
    [anon_sym_BSLASHcitealp] = ACTIONS(6007),
    [anon_sym_BSLASHcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHparencite] = ACTIONS(6007),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHParencite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHtextcite] = ACTIONS(6007),
    [anon_sym_BSLASHTextcite] = ACTIONS(6007),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHsupercite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite] = ACTIONS(6007),
    [anon_sym_BSLASHAutocite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHVolcite] = ACTIONS(6007),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHavolcite] = ACTIONS(6007),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHNotecite] = ACTIONS(6007),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHlabel] = ACTIONS(6007),
    [anon_sym_BSLASHref] = ACTIONS(6007),
    [anon_sym_BSLASHeqref] = ACTIONS(6007),
    [anon_sym_BSLASHvref] = ACTIONS(6007),
    [anon_sym_BSLASHVref] = ACTIONS(6007),
    [anon_sym_BSLASHautoref] = ACTIONS(6007),
    [anon_sym_BSLASHpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcref] = ACTIONS(6007),
    [anon_sym_BSLASHCref] = ACTIONS(6007),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnameCref] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHdef] = ACTIONS(6007),
    [anon_sym_BSLASHlet] = ACTIONS(6007),
    [anon_sym_BSLASHleft] = ACTIONS(6007),
    [anon_sym_BSLASHbigl] = ACTIONS(6007),
    [anon_sym_BSLASHBigl] = ACTIONS(6007),
    [anon_sym_BSLASHbiggl] = ACTIONS(6007),
    [anon_sym_BSLASHBiggl] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6007),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6007),
    [anon_sym_BSLASHgls] = ACTIONS(6007),
    [anon_sym_BSLASHGls] = ACTIONS(6007),
    [anon_sym_BSLASHGLS] = ACTIONS(6007),
    [anon_sym_BSLASHglspl] = ACTIONS(6007),
    [anon_sym_BSLASHGlspl] = ACTIONS(6007),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6007),
    [anon_sym_BSLASHglslink] = ACTIONS(6007),
    [anon_sym_BSLASHglstext] = ACTIONS(6007),
    [anon_sym_BSLASHGlstext] = ACTIONS(6007),
    [anon_sym_BSLASHGLStext] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6007),
    [anon_sym_BSLASHglsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsname] = ACTIONS(6007),
    [anon_sym_BSLASHGlsname] = ACTIONS(6007),
    [anon_sym_BSLASHGLSname] = ACTIONS(6007),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6007),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6007),
    [anon_sym_BSLASHacrshort] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6007),
    [anon_sym_BSLASHACRshort] = ACTIONS(6007),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrlong] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6007),
    [anon_sym_BSLASHACRlong] = ACTIONS(6007),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrfull] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6007),
    [anon_sym_BSLASHACRfull] = ACTIONS(6007),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHacs] = ACTIONS(6007),
    [anon_sym_BSLASHAcs] = ACTIONS(6007),
    [anon_sym_BSLASHacsp] = ACTIONS(6007),
    [anon_sym_BSLASHAcsp] = ACTIONS(6007),
    [anon_sym_BSLASHacl] = ACTIONS(6007),
    [anon_sym_BSLASHAcl] = ACTIONS(6007),
    [anon_sym_BSLASHaclp] = ACTIONS(6007),
    [anon_sym_BSLASHAclp] = ACTIONS(6007),
    [anon_sym_BSLASHacf] = ACTIONS(6007),
    [anon_sym_BSLASHAcf] = ACTIONS(6007),
    [anon_sym_BSLASHacfp] = ACTIONS(6007),
    [anon_sym_BSLASHAcfp] = ACTIONS(6007),
    [anon_sym_BSLASHac] = ACTIONS(6007),
    [anon_sym_BSLASHAc] = ACTIONS(6007),
    [anon_sym_BSLASHacp] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6007),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6007),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6007),
    [anon_sym_BSLASHcolor] = ACTIONS(6007),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6007),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6007),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6007),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6007),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6007),
    [anon_sym_BSLASHtext] = ACTIONS(6007),
    [anon_sym_BSLASHintertext] = ACTIONS(6007),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6007),
    [anon_sym_BSLASHurl] = ACTIONS(6007),
    [anon_sym_BSLASHhref] = ACTIONS(6007),
  },
  [719] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHend] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [720] = {
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(720),
    [aux_sym__section_repeat2] = STATE(720),
    [sym_command_name] = ACTIONS(5997),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_RBRACK] = ACTIONS(5999),
    [anon_sym_COMMA] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(5999),
    [anon_sym_LPAREN] = ACTIONS(5999),
    [anon_sym_RPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHpart] = ACTIONS(5997),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddpart] = ACTIONS(5997),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHchapter] = ACTIONS(6808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6811),
    [anon_sym_BSLASHaddchap] = ACTIONS(6808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6811),
    [anon_sym_BSLASHsection] = ACTIONS(5997),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddsec] = ACTIONS(5997),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHitem] = ACTIONS(5997),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5999),
    [anon_sym_LBRACE] = ACTIONS(5999),
    [sym_word] = ACTIONS(5997),
    [sym_placeholder] = ACTIONS(5999),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5999),
    [anon_sym_STAR] = ACTIONS(5999),
    [anon_sym_SLASH] = ACTIONS(5999),
    [anon_sym_LT] = ACTIONS(5997),
    [anon_sym_GT] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5997),
    [anon_sym_PIPE] = ACTIONS(5997),
    [anon_sym_COLON] = ACTIONS(5997),
    [anon_sym_SQUOTE] = ACTIONS(5997),
    [anon_sym__] = ACTIONS(5999),
    [anon_sym_CARET] = ACTIONS(5999),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5999),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5999),
    [anon_sym_DOLLAR] = ACTIONS(5997),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHbegin] = ACTIONS(5997),
    [anon_sym_BSLASHend] = ACTIONS(5997),
    [anon_sym_BSLASHtitle] = ACTIONS(5997),
    [anon_sym_BSLASHauthor] = ACTIONS(5997),
    [anon_sym_BSLASHusepackage] = ACTIONS(5997),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5997),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5997),
    [anon_sym_BSLASHinclude] = ACTIONS(5997),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5997),
    [anon_sym_BSLASHinput] = ACTIONS(5997),
    [anon_sym_BSLASHsubfile] = ACTIONS(5997),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5997),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5997),
    [anon_sym_BSLASHbibliography] = ACTIONS(5997),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5997),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5997),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5997),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5997),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5997),
    [anon_sym_BSLASHimport] = ACTIONS(5997),
    [anon_sym_BSLASHsubimport] = ACTIONS(5997),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5997),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHcaption] = ACTIONS(5997),
    [anon_sym_BSLASHcite] = ACTIONS(5997),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCite] = ACTIONS(5997),
    [anon_sym_BSLASHnocite] = ACTIONS(5997),
    [anon_sym_BSLASHcitet] = ACTIONS(5997),
    [anon_sym_BSLASHcitep] = ACTIONS(5997),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteA] = ACTIONS(5997),
    [anon_sym_BSLASHciteR] = ACTIONS(5997),
    [anon_sym_BSLASHciteS] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5997),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteyear] = ACTIONS(5997),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitedate] = ACTIONS(5997),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteurl] = ACTIONS(5997),
    [anon_sym_BSLASHfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5997),
    [anon_sym_BSLASHcitealt] = ACTIONS(5997),
    [anon_sym_BSLASHcitealp] = ACTIONS(5997),
    [anon_sym_BSLASHcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHparencite] = ACTIONS(5997),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHParencite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHtextcite] = ACTIONS(5997),
    [anon_sym_BSLASHTextcite] = ACTIONS(5997),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHsupercite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite] = ACTIONS(5997),
    [anon_sym_BSLASHAutocite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHVolcite] = ACTIONS(5997),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHavolcite] = ACTIONS(5997),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHNotecite] = ACTIONS(5997),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHlabel] = ACTIONS(5997),
    [anon_sym_BSLASHref] = ACTIONS(5997),
    [anon_sym_BSLASHeqref] = ACTIONS(5997),
    [anon_sym_BSLASHvref] = ACTIONS(5997),
    [anon_sym_BSLASHVref] = ACTIONS(5997),
    [anon_sym_BSLASHautoref] = ACTIONS(5997),
    [anon_sym_BSLASHpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcref] = ACTIONS(5997),
    [anon_sym_BSLASHCref] = ACTIONS(5997),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnameCref] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHdef] = ACTIONS(5997),
    [anon_sym_BSLASHlet] = ACTIONS(5997),
    [anon_sym_BSLASHleft] = ACTIONS(5997),
    [anon_sym_BSLASHbigl] = ACTIONS(5997),
    [anon_sym_BSLASHBigl] = ACTIONS(5997),
    [anon_sym_BSLASHbiggl] = ACTIONS(5997),
    [anon_sym_BSLASHBiggl] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5997),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5997),
    [anon_sym_BSLASHgls] = ACTIONS(5997),
    [anon_sym_BSLASHGls] = ACTIONS(5997),
    [anon_sym_BSLASHGLS] = ACTIONS(5997),
    [anon_sym_BSLASHglspl] = ACTIONS(5997),
    [anon_sym_BSLASHGlspl] = ACTIONS(5997),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5997),
    [anon_sym_BSLASHglslink] = ACTIONS(5997),
    [anon_sym_BSLASHglstext] = ACTIONS(5997),
    [anon_sym_BSLASHGlstext] = ACTIONS(5997),
    [anon_sym_BSLASHGLStext] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5997),
    [anon_sym_BSLASHglsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsname] = ACTIONS(5997),
    [anon_sym_BSLASHGlsname] = ACTIONS(5997),
    [anon_sym_BSLASHGLSname] = ACTIONS(5997),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5997),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5997),
    [anon_sym_BSLASHacrshort] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5997),
    [anon_sym_BSLASHACRshort] = ACTIONS(5997),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrlong] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5997),
    [anon_sym_BSLASHACRlong] = ACTIONS(5997),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrfull] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5997),
    [anon_sym_BSLASHACRfull] = ACTIONS(5997),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHacs] = ACTIONS(5997),
    [anon_sym_BSLASHAcs] = ACTIONS(5997),
    [anon_sym_BSLASHacsp] = ACTIONS(5997),
    [anon_sym_BSLASHAcsp] = ACTIONS(5997),
    [anon_sym_BSLASHacl] = ACTIONS(5997),
    [anon_sym_BSLASHAcl] = ACTIONS(5997),
    [anon_sym_BSLASHaclp] = ACTIONS(5997),
    [anon_sym_BSLASHAclp] = ACTIONS(5997),
    [anon_sym_BSLASHacf] = ACTIONS(5997),
    [anon_sym_BSLASHAcf] = ACTIONS(5997),
    [anon_sym_BSLASHacfp] = ACTIONS(5997),
    [anon_sym_BSLASHAcfp] = ACTIONS(5997),
    [anon_sym_BSLASHac] = ACTIONS(5997),
    [anon_sym_BSLASHAc] = ACTIONS(5997),
    [anon_sym_BSLASHacp] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5997),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5997),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5997),
    [anon_sym_BSLASHcolor] = ACTIONS(5997),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5997),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5997),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5997),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5997),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5997),
    [anon_sym_BSLASHtext] = ACTIONS(5997),
    [anon_sym_BSLASHintertext] = ACTIONS(5997),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5997),
    [anon_sym_BSLASHurl] = ACTIONS(5997),
    [anon_sym_BSLASHhref] = ACTIONS(5997),
  },
  [721] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(688),
    [aux_sym__section_repeat5] = STATE(688),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [722] = {
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(650),
    [aux_sym__paragraph_repeat2] = STATE(650),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(2232),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [723] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(697),
    [aux_sym__section_repeat5] = STATE(697),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHend] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [724] = {
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(724),
    [aux_sym__section_repeat1] = STATE(724),
    [sym_command_name] = ACTIONS(5987),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5987),
    [anon_sym_LBRACK] = ACTIONS(5989),
    [anon_sym_RBRACK] = ACTIONS(5989),
    [anon_sym_COMMA] = ACTIONS(5989),
    [anon_sym_EQ] = ACTIONS(5989),
    [anon_sym_LPAREN] = ACTIONS(5989),
    [anon_sym_RPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHpart] = ACTIONS(6814),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6817),
    [anon_sym_BSLASHaddpart] = ACTIONS(6814),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6817),
    [anon_sym_BSLASHchapter] = ACTIONS(5987),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddchap] = ACTIONS(5987),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsection] = ACTIONS(5987),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddsec] = ACTIONS(5987),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHitem] = ACTIONS(5987),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5989),
    [anon_sym_LBRACE] = ACTIONS(5989),
    [sym_word] = ACTIONS(5987),
    [sym_placeholder] = ACTIONS(5989),
    [anon_sym_PLUS] = ACTIONS(5989),
    [anon_sym_DASH] = ACTIONS(5989),
    [anon_sym_STAR] = ACTIONS(5989),
    [anon_sym_SLASH] = ACTIONS(5989),
    [anon_sym_LT] = ACTIONS(5987),
    [anon_sym_GT] = ACTIONS(5987),
    [anon_sym_BANG] = ACTIONS(5987),
    [anon_sym_PIPE] = ACTIONS(5987),
    [anon_sym_COLON] = ACTIONS(5987),
    [anon_sym_SQUOTE] = ACTIONS(5987),
    [anon_sym__] = ACTIONS(5989),
    [anon_sym_CARET] = ACTIONS(5989),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5989),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5989),
    [anon_sym_DOLLAR] = ACTIONS(5987),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHbegin] = ACTIONS(5987),
    [anon_sym_BSLASHend] = ACTIONS(5987),
    [anon_sym_BSLASHtitle] = ACTIONS(5987),
    [anon_sym_BSLASHauthor] = ACTIONS(5987),
    [anon_sym_BSLASHusepackage] = ACTIONS(5987),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5987),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5987),
    [anon_sym_BSLASHinclude] = ACTIONS(5987),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5987),
    [anon_sym_BSLASHinput] = ACTIONS(5987),
    [anon_sym_BSLASHsubfile] = ACTIONS(5987),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5987),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5987),
    [anon_sym_BSLASHbibliography] = ACTIONS(5987),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5987),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5987),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5987),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5987),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5987),
    [anon_sym_BSLASHimport] = ACTIONS(5987),
    [anon_sym_BSLASHsubimport] = ACTIONS(5987),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5987),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHcaption] = ACTIONS(5987),
    [anon_sym_BSLASHcite] = ACTIONS(5987),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCite] = ACTIONS(5987),
    [anon_sym_BSLASHnocite] = ACTIONS(5987),
    [anon_sym_BSLASHcitet] = ACTIONS(5987),
    [anon_sym_BSLASHcitep] = ACTIONS(5987),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteA] = ACTIONS(5987),
    [anon_sym_BSLASHciteR] = ACTIONS(5987),
    [anon_sym_BSLASHciteS] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5987),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteyear] = ACTIONS(5987),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitedate] = ACTIONS(5987),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteurl] = ACTIONS(5987),
    [anon_sym_BSLASHfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5987),
    [anon_sym_BSLASHcitealt] = ACTIONS(5987),
    [anon_sym_BSLASHcitealp] = ACTIONS(5987),
    [anon_sym_BSLASHcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHparencite] = ACTIONS(5987),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHParencite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHtextcite] = ACTIONS(5987),
    [anon_sym_BSLASHTextcite] = ACTIONS(5987),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHsupercite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite] = ACTIONS(5987),
    [anon_sym_BSLASHAutocite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHVolcite] = ACTIONS(5987),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHavolcite] = ACTIONS(5987),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHNotecite] = ACTIONS(5987),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHlabel] = ACTIONS(5987),
    [anon_sym_BSLASHref] = ACTIONS(5987),
    [anon_sym_BSLASHeqref] = ACTIONS(5987),
    [anon_sym_BSLASHvref] = ACTIONS(5987),
    [anon_sym_BSLASHVref] = ACTIONS(5987),
    [anon_sym_BSLASHautoref] = ACTIONS(5987),
    [anon_sym_BSLASHpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcref] = ACTIONS(5987),
    [anon_sym_BSLASHCref] = ACTIONS(5987),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnameCref] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHdef] = ACTIONS(5987),
    [anon_sym_BSLASHlet] = ACTIONS(5987),
    [anon_sym_BSLASHleft] = ACTIONS(5987),
    [anon_sym_BSLASHbigl] = ACTIONS(5987),
    [anon_sym_BSLASHBigl] = ACTIONS(5987),
    [anon_sym_BSLASHbiggl] = ACTIONS(5987),
    [anon_sym_BSLASHBiggl] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5987),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5987),
    [anon_sym_BSLASHgls] = ACTIONS(5987),
    [anon_sym_BSLASHGls] = ACTIONS(5987),
    [anon_sym_BSLASHGLS] = ACTIONS(5987),
    [anon_sym_BSLASHglspl] = ACTIONS(5987),
    [anon_sym_BSLASHGlspl] = ACTIONS(5987),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5987),
    [anon_sym_BSLASHglslink] = ACTIONS(5987),
    [anon_sym_BSLASHglstext] = ACTIONS(5987),
    [anon_sym_BSLASHGlstext] = ACTIONS(5987),
    [anon_sym_BSLASHGLStext] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5987),
    [anon_sym_BSLASHglsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsname] = ACTIONS(5987),
    [anon_sym_BSLASHGlsname] = ACTIONS(5987),
    [anon_sym_BSLASHGLSname] = ACTIONS(5987),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5987),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5987),
    [anon_sym_BSLASHacrshort] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5987),
    [anon_sym_BSLASHACRshort] = ACTIONS(5987),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrlong] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5987),
    [anon_sym_BSLASHACRlong] = ACTIONS(5987),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrfull] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5987),
    [anon_sym_BSLASHACRfull] = ACTIONS(5987),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHacs] = ACTIONS(5987),
    [anon_sym_BSLASHAcs] = ACTIONS(5987),
    [anon_sym_BSLASHacsp] = ACTIONS(5987),
    [anon_sym_BSLASHAcsp] = ACTIONS(5987),
    [anon_sym_BSLASHacl] = ACTIONS(5987),
    [anon_sym_BSLASHAcl] = ACTIONS(5987),
    [anon_sym_BSLASHaclp] = ACTIONS(5987),
    [anon_sym_BSLASHAclp] = ACTIONS(5987),
    [anon_sym_BSLASHacf] = ACTIONS(5987),
    [anon_sym_BSLASHAcf] = ACTIONS(5987),
    [anon_sym_BSLASHacfp] = ACTIONS(5987),
    [anon_sym_BSLASHAcfp] = ACTIONS(5987),
    [anon_sym_BSLASHac] = ACTIONS(5987),
    [anon_sym_BSLASHAc] = ACTIONS(5987),
    [anon_sym_BSLASHacp] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5987),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5987),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5987),
    [anon_sym_BSLASHcolor] = ACTIONS(5987),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5987),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5987),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5987),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5987),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5987),
    [anon_sym_BSLASHtext] = ACTIONS(5987),
    [anon_sym_BSLASHintertext] = ACTIONS(5987),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5987),
    [anon_sym_BSLASHurl] = ACTIONS(5987),
    [anon_sym_BSLASHhref] = ACTIONS(5987),
  },
  [725] = {
    [sym_curly_group] = STATE(993),
    [aux_sym_generic_command_repeat1] = STATE(840),
    [ts_builtin_sym_end] = ACTIONS(6121),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6121),
    [anon_sym_RBRACK] = ACTIONS(6121),
    [anon_sym_COMMA] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHpart] = ACTIONS(6119),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddpart] = ACTIONS(6119),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHchapter] = ACTIONS(6119),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddchap] = ACTIONS(6119),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsection] = ACTIONS(6119),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddsec] = ACTIONS(6119),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHitem] = ACTIONS(6119),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6121),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6121),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(6119),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHbegin] = ACTIONS(6119),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHleft] = ACTIONS(6119),
    [anon_sym_BSLASHbigl] = ACTIONS(6119),
    [anon_sym_BSLASHBigl] = ACTIONS(6119),
    [anon_sym_BSLASHbiggl] = ACTIONS(6119),
    [anon_sym_BSLASHBiggl] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHtext] = ACTIONS(6119),
    [anon_sym_BSLASHintertext] = ACTIONS(6119),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [726] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHend] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [727] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHend] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [728] = {
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(698),
    [aux_sym__paragraph_repeat3] = STATE(698),
    [sym_command_name] = ACTIONS(2250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_RBRACK] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [sym_word] = ACTIONS(2250),
    [sym_placeholder] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym__] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2252),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHbegin] = ACTIONS(2250),
    [anon_sym_BSLASHend] = ACTIONS(2250),
    [anon_sym_BSLASHtitle] = ACTIONS(2250),
    [anon_sym_BSLASHauthor] = ACTIONS(2250),
    [anon_sym_BSLASHusepackage] = ACTIONS(2250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2250),
    [anon_sym_BSLASHinclude] = ACTIONS(2250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2250),
    [anon_sym_BSLASHinput] = ACTIONS(2250),
    [anon_sym_BSLASHsubfile] = ACTIONS(2250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2250),
    [anon_sym_BSLASHbibliography] = ACTIONS(2250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2250),
    [anon_sym_BSLASHimport] = ACTIONS(2250),
    [anon_sym_BSLASHsubimport] = ACTIONS(2250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHcaption] = ACTIONS(2250),
    [anon_sym_BSLASHcite] = ACTIONS(2250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCite] = ACTIONS(2250),
    [anon_sym_BSLASHnocite] = ACTIONS(2250),
    [anon_sym_BSLASHcitet] = ACTIONS(2250),
    [anon_sym_BSLASHcitep] = ACTIONS(2250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteA] = ACTIONS(2250),
    [anon_sym_BSLASHciteR] = ACTIONS(2250),
    [anon_sym_BSLASHciteS] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteyear] = ACTIONS(2250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitedate] = ACTIONS(2250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteurl] = ACTIONS(2250),
    [anon_sym_BSLASHfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2250),
    [anon_sym_BSLASHcitealt] = ACTIONS(2250),
    [anon_sym_BSLASHcitealp] = ACTIONS(2250),
    [anon_sym_BSLASHcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHparencite] = ACTIONS(2250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHParencite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHtextcite] = ACTIONS(2250),
    [anon_sym_BSLASHTextcite] = ACTIONS(2250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHsupercite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite] = ACTIONS(2250),
    [anon_sym_BSLASHAutocite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHVolcite] = ACTIONS(2250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHavolcite] = ACTIONS(2250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHNotecite] = ACTIONS(2250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHlabel] = ACTIONS(2250),
    [anon_sym_BSLASHref] = ACTIONS(2250),
    [anon_sym_BSLASHeqref] = ACTIONS(2250),
    [anon_sym_BSLASHvref] = ACTIONS(2250),
    [anon_sym_BSLASHVref] = ACTIONS(2250),
    [anon_sym_BSLASHautoref] = ACTIONS(2250),
    [anon_sym_BSLASHpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcref] = ACTIONS(2250),
    [anon_sym_BSLASHCref] = ACTIONS(2250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnameCref] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHdef] = ACTIONS(2250),
    [anon_sym_BSLASHlet] = ACTIONS(2250),
    [anon_sym_BSLASHleft] = ACTIONS(2250),
    [anon_sym_BSLASHbigl] = ACTIONS(2250),
    [anon_sym_BSLASHBigl] = ACTIONS(2250),
    [anon_sym_BSLASHbiggl] = ACTIONS(2250),
    [anon_sym_BSLASHBiggl] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2250),
    [anon_sym_BSLASHgls] = ACTIONS(2250),
    [anon_sym_BSLASHGls] = ACTIONS(2250),
    [anon_sym_BSLASHGLS] = ACTIONS(2250),
    [anon_sym_BSLASHglspl] = ACTIONS(2250),
    [anon_sym_BSLASHGlspl] = ACTIONS(2250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2250),
    [anon_sym_BSLASHglslink] = ACTIONS(2250),
    [anon_sym_BSLASHglstext] = ACTIONS(2250),
    [anon_sym_BSLASHGlstext] = ACTIONS(2250),
    [anon_sym_BSLASHGLStext] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2250),
    [anon_sym_BSLASHglsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsname] = ACTIONS(2250),
    [anon_sym_BSLASHGlsname] = ACTIONS(2250),
    [anon_sym_BSLASHGLSname] = ACTIONS(2250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2250),
    [anon_sym_BSLASHacrshort] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2250),
    [anon_sym_BSLASHACRshort] = ACTIONS(2250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrlong] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2250),
    [anon_sym_BSLASHACRlong] = ACTIONS(2250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrfull] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2250),
    [anon_sym_BSLASHACRfull] = ACTIONS(2250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHacs] = ACTIONS(2250),
    [anon_sym_BSLASHAcs] = ACTIONS(2250),
    [anon_sym_BSLASHacsp] = ACTIONS(2250),
    [anon_sym_BSLASHAcsp] = ACTIONS(2250),
    [anon_sym_BSLASHacl] = ACTIONS(2250),
    [anon_sym_BSLASHAcl] = ACTIONS(2250),
    [anon_sym_BSLASHaclp] = ACTIONS(2250),
    [anon_sym_BSLASHAclp] = ACTIONS(2250),
    [anon_sym_BSLASHacf] = ACTIONS(2250),
    [anon_sym_BSLASHAcf] = ACTIONS(2250),
    [anon_sym_BSLASHacfp] = ACTIONS(2250),
    [anon_sym_BSLASHAcfp] = ACTIONS(2250),
    [anon_sym_BSLASHac] = ACTIONS(2250),
    [anon_sym_BSLASHAc] = ACTIONS(2250),
    [anon_sym_BSLASHacp] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2250),
    [anon_sym_BSLASHcolor] = ACTIONS(2250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2250),
    [anon_sym_BSLASHtext] = ACTIONS(2250),
    [anon_sym_BSLASHintertext] = ACTIONS(2250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2250),
    [anon_sym_BSLASHurl] = ACTIONS(2250),
    [anon_sym_BSLASHhref] = ACTIONS(2250),
  },
  [729] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [730] = {
    [sym__paragraph_declaration] = STATE(209),
    [sym_paragraph] = STATE(712),
    [aux_sym__paragraph_repeat1] = STATE(712),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(672),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(674),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHend] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [731] = {
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(698),
    [aux_sym__paragraph_repeat3] = STATE(698),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHend] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [732] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHend] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [733] = {
    [sym__subparagraph_declaration] = STATE(217),
    [sym_subparagraph] = STATE(653),
    [aux_sym__paragraph_repeat2] = STATE(653),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(676),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(678),
    [anon_sym_BSLASHitem] = ACTIONS(2232),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHend] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [734] = {
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(828),
    [aux_sym__paragraph_repeat3] = STATE(828),
    [sym_command_name] = ACTIONS(6073),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6073),
    [anon_sym_LBRACK] = ACTIONS(6075),
    [anon_sym_RBRACK] = ACTIONS(6075),
    [anon_sym_COMMA] = ACTIONS(6075),
    [anon_sym_EQ] = ACTIONS(6075),
    [anon_sym_LPAREN] = ACTIONS(6075),
    [anon_sym_RPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHpart] = ACTIONS(6073),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddpart] = ACTIONS(6073),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHchapter] = ACTIONS(6073),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddchap] = ACTIONS(6073),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsection] = ACTIONS(6073),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHaddsec] = ACTIONS(6073),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6073),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6073),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(6075),
    [sym_word] = ACTIONS(6073),
    [sym_placeholder] = ACTIONS(6075),
    [anon_sym_PLUS] = ACTIONS(6075),
    [anon_sym_DASH] = ACTIONS(6075),
    [anon_sym_STAR] = ACTIONS(6075),
    [anon_sym_SLASH] = ACTIONS(6075),
    [anon_sym_LT] = ACTIONS(6073),
    [anon_sym_GT] = ACTIONS(6073),
    [anon_sym_BANG] = ACTIONS(6073),
    [anon_sym_PIPE] = ACTIONS(6073),
    [anon_sym_COLON] = ACTIONS(6073),
    [anon_sym_SQUOTE] = ACTIONS(6073),
    [anon_sym__] = ACTIONS(6075),
    [anon_sym_CARET] = ACTIONS(6075),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6075),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6075),
    [anon_sym_DOLLAR] = ACTIONS(6073),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6075),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6075),
    [anon_sym_BSLASHbegin] = ACTIONS(6073),
    [anon_sym_BSLASHtitle] = ACTIONS(6073),
    [anon_sym_BSLASHauthor] = ACTIONS(6073),
    [anon_sym_BSLASHusepackage] = ACTIONS(6073),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6073),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6073),
    [anon_sym_BSLASHinclude] = ACTIONS(6073),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6073),
    [anon_sym_BSLASHinput] = ACTIONS(6073),
    [anon_sym_BSLASHsubfile] = ACTIONS(6073),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6073),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6073),
    [anon_sym_BSLASHbibliography] = ACTIONS(6073),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6073),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6073),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6073),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6073),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6073),
    [anon_sym_BSLASHimport] = ACTIONS(6073),
    [anon_sym_BSLASHsubimport] = ACTIONS(6073),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6073),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6073),
    [anon_sym_BSLASHcaption] = ACTIONS(6073),
    [anon_sym_BSLASHcite] = ACTIONS(6073),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCite] = ACTIONS(6073),
    [anon_sym_BSLASHnocite] = ACTIONS(6073),
    [anon_sym_BSLASHcitet] = ACTIONS(6073),
    [anon_sym_BSLASHcitep] = ACTIONS(6073),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteA] = ACTIONS(6073),
    [anon_sym_BSLASHciteR] = ACTIONS(6073),
    [anon_sym_BSLASHciteS] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6073),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6073),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteyear] = ACTIONS(6073),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHcitedate] = ACTIONS(6073),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHciteurl] = ACTIONS(6073),
    [anon_sym_BSLASHfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6073),
    [anon_sym_BSLASHcitealt] = ACTIONS(6073),
    [anon_sym_BSLASHcitealp] = ACTIONS(6073),
    [anon_sym_BSLASHcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHparencite] = ACTIONS(6073),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHParencite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6073),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6073),
    [anon_sym_BSLASHtextcite] = ACTIONS(6073),
    [anon_sym_BSLASHTextcite] = ACTIONS(6073),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6073),
    [anon_sym_BSLASHsupercite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite] = ACTIONS(6073),
    [anon_sym_BSLASHAutocite] = ACTIONS(6073),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHVolcite] = ACTIONS(6073),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHavolcite] = ACTIONS(6073),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6073),
    [anon_sym_BSLASHnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHNotecite] = ACTIONS(6073),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6073),
    [anon_sym_BSLASHlabel] = ACTIONS(6073),
    [anon_sym_BSLASHref] = ACTIONS(6073),
    [anon_sym_BSLASHeqref] = ACTIONS(6073),
    [anon_sym_BSLASHvref] = ACTIONS(6073),
    [anon_sym_BSLASHVref] = ACTIONS(6073),
    [anon_sym_BSLASHautoref] = ACTIONS(6073),
    [anon_sym_BSLASHpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcref] = ACTIONS(6073),
    [anon_sym_BSLASHCref] = ACTIONS(6073),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnameCref] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6073),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6073),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6073),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6073),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6073),
    [anon_sym_BSLASHdef] = ACTIONS(6073),
    [anon_sym_BSLASHlet] = ACTIONS(6073),
    [anon_sym_BSLASHleft] = ACTIONS(6073),
    [anon_sym_BSLASHbigl] = ACTIONS(6073),
    [anon_sym_BSLASHBigl] = ACTIONS(6073),
    [anon_sym_BSLASHbiggl] = ACTIONS(6073),
    [anon_sym_BSLASHBiggl] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6073),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6073),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6073),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6073),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6073),
    [anon_sym_BSLASHgls] = ACTIONS(6073),
    [anon_sym_BSLASHGls] = ACTIONS(6073),
    [anon_sym_BSLASHGLS] = ACTIONS(6073),
    [anon_sym_BSLASHglspl] = ACTIONS(6073),
    [anon_sym_BSLASHGlspl] = ACTIONS(6073),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6073),
    [anon_sym_BSLASHglslink] = ACTIONS(6073),
    [anon_sym_BSLASHglstext] = ACTIONS(6073),
    [anon_sym_BSLASHGlstext] = ACTIONS(6073),
    [anon_sym_BSLASHGLStext] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6073),
    [anon_sym_BSLASHglsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6073),
    [anon_sym_BSLASHglsname] = ACTIONS(6073),
    [anon_sym_BSLASHGlsname] = ACTIONS(6073),
    [anon_sym_BSLASHGLSname] = ACTIONS(6073),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6073),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6073),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6073),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6073),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6073),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6073),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6073),
    [anon_sym_BSLASHacrshort] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6073),
    [anon_sym_BSLASHACRshort] = ACTIONS(6073),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrlong] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6073),
    [anon_sym_BSLASHACRlong] = ACTIONS(6073),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6073),
    [anon_sym_BSLASHacrfull] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6073),
    [anon_sym_BSLASHACRfull] = ACTIONS(6073),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHacs] = ACTIONS(6073),
    [anon_sym_BSLASHAcs] = ACTIONS(6073),
    [anon_sym_BSLASHacsp] = ACTIONS(6073),
    [anon_sym_BSLASHAcsp] = ACTIONS(6073),
    [anon_sym_BSLASHacl] = ACTIONS(6073),
    [anon_sym_BSLASHAcl] = ACTIONS(6073),
    [anon_sym_BSLASHaclp] = ACTIONS(6073),
    [anon_sym_BSLASHAclp] = ACTIONS(6073),
    [anon_sym_BSLASHacf] = ACTIONS(6073),
    [anon_sym_BSLASHAcf] = ACTIONS(6073),
    [anon_sym_BSLASHacfp] = ACTIONS(6073),
    [anon_sym_BSLASHAcfp] = ACTIONS(6073),
    [anon_sym_BSLASHac] = ACTIONS(6073),
    [anon_sym_BSLASHAc] = ACTIONS(6073),
    [anon_sym_BSLASHacp] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6073),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6073),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6073),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6073),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6075),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6073),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6073),
    [anon_sym_BSLASHcolor] = ACTIONS(6073),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6073),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6073),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6073),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6073),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6073),
    [anon_sym_BSLASHtext] = ACTIONS(6073),
    [anon_sym_BSLASHintertext] = ACTIONS(6073),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6073),
    [anon_sym_BSLASHurl] = ACTIONS(6073),
    [anon_sym_BSLASHhref] = ACTIONS(6073),
  },
  [735] = {
    [sym__section_part] = STATE(1389),
    [sym_curly_group] = STATE(1388),
    [sym_brack_group] = STATE(2998),
    [sym_command_name] = ACTIONS(5971),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5971),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5973),
    [anon_sym_COMMA] = ACTIONS(5973),
    [anon_sym_EQ] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(5973),
    [anon_sym_RPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHpart] = ACTIONS(5971),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddpart] = ACTIONS(5971),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHchapter] = ACTIONS(5971),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddchap] = ACTIONS(5971),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsection] = ACTIONS(5971),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddsec] = ACTIONS(5971),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHitem] = ACTIONS(5971),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5973),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(5971),
    [sym_placeholder] = ACTIONS(5973),
    [anon_sym_PLUS] = ACTIONS(5973),
    [anon_sym_DASH] = ACTIONS(5973),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5973),
    [anon_sym_LT] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5971),
    [anon_sym_BANG] = ACTIONS(5971),
    [anon_sym_PIPE] = ACTIONS(5971),
    [anon_sym_COLON] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(5971),
    [anon_sym__] = ACTIONS(5973),
    [anon_sym_CARET] = ACTIONS(5973),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5973),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5973),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5973),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHbegin] = ACTIONS(5971),
    [anon_sym_BSLASHtitle] = ACTIONS(5971),
    [anon_sym_BSLASHauthor] = ACTIONS(5971),
    [anon_sym_BSLASHusepackage] = ACTIONS(5971),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5971),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5971),
    [anon_sym_BSLASHinclude] = ACTIONS(5971),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5971),
    [anon_sym_BSLASHinput] = ACTIONS(5971),
    [anon_sym_BSLASHsubfile] = ACTIONS(5971),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5971),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5971),
    [anon_sym_BSLASHbibliography] = ACTIONS(5971),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5971),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5971),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5971),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5971),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5971),
    [anon_sym_BSLASHimport] = ACTIONS(5971),
    [anon_sym_BSLASHsubimport] = ACTIONS(5971),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5971),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHcaption] = ACTIONS(5971),
    [anon_sym_BSLASHcite] = ACTIONS(5971),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCite] = ACTIONS(5971),
    [anon_sym_BSLASHnocite] = ACTIONS(5971),
    [anon_sym_BSLASHcitet] = ACTIONS(5971),
    [anon_sym_BSLASHcitep] = ACTIONS(5971),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteA] = ACTIONS(5971),
    [anon_sym_BSLASHciteR] = ACTIONS(5971),
    [anon_sym_BSLASHciteS] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5971),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteyear] = ACTIONS(5971),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitedate] = ACTIONS(5971),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteurl] = ACTIONS(5971),
    [anon_sym_BSLASHfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5971),
    [anon_sym_BSLASHcitealt] = ACTIONS(5971),
    [anon_sym_BSLASHcitealp] = ACTIONS(5971),
    [anon_sym_BSLASHcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHparencite] = ACTIONS(5971),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHParencite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHtextcite] = ACTIONS(5971),
    [anon_sym_BSLASHTextcite] = ACTIONS(5971),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHsupercite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite] = ACTIONS(5971),
    [anon_sym_BSLASHAutocite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHVolcite] = ACTIONS(5971),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHavolcite] = ACTIONS(5971),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHNotecite] = ACTIONS(5971),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHlabel] = ACTIONS(5971),
    [anon_sym_BSLASHref] = ACTIONS(5971),
    [anon_sym_BSLASHeqref] = ACTIONS(5971),
    [anon_sym_BSLASHvref] = ACTIONS(5971),
    [anon_sym_BSLASHVref] = ACTIONS(5971),
    [anon_sym_BSLASHautoref] = ACTIONS(5971),
    [anon_sym_BSLASHpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcref] = ACTIONS(5971),
    [anon_sym_BSLASHCref] = ACTIONS(5971),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnameCref] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHdef] = ACTIONS(5971),
    [anon_sym_BSLASHlet] = ACTIONS(5971),
    [anon_sym_BSLASHleft] = ACTIONS(5971),
    [anon_sym_BSLASHbigl] = ACTIONS(5971),
    [anon_sym_BSLASHBigl] = ACTIONS(5971),
    [anon_sym_BSLASHbiggl] = ACTIONS(5971),
    [anon_sym_BSLASHBiggl] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5971),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5971),
    [anon_sym_BSLASHgls] = ACTIONS(5971),
    [anon_sym_BSLASHGls] = ACTIONS(5971),
    [anon_sym_BSLASHGLS] = ACTIONS(5971),
    [anon_sym_BSLASHglspl] = ACTIONS(5971),
    [anon_sym_BSLASHGlspl] = ACTIONS(5971),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5971),
    [anon_sym_BSLASHglslink] = ACTIONS(5971),
    [anon_sym_BSLASHglstext] = ACTIONS(5971),
    [anon_sym_BSLASHGlstext] = ACTIONS(5971),
    [anon_sym_BSLASHGLStext] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5971),
    [anon_sym_BSLASHglsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsname] = ACTIONS(5971),
    [anon_sym_BSLASHGlsname] = ACTIONS(5971),
    [anon_sym_BSLASHGLSname] = ACTIONS(5971),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5971),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5971),
    [anon_sym_BSLASHacrshort] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5971),
    [anon_sym_BSLASHACRshort] = ACTIONS(5971),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrlong] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5971),
    [anon_sym_BSLASHACRlong] = ACTIONS(5971),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrfull] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5971),
    [anon_sym_BSLASHACRfull] = ACTIONS(5971),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHacs] = ACTIONS(5971),
    [anon_sym_BSLASHAcs] = ACTIONS(5971),
    [anon_sym_BSLASHacsp] = ACTIONS(5971),
    [anon_sym_BSLASHAcsp] = ACTIONS(5971),
    [anon_sym_BSLASHacl] = ACTIONS(5971),
    [anon_sym_BSLASHAcl] = ACTIONS(5971),
    [anon_sym_BSLASHaclp] = ACTIONS(5971),
    [anon_sym_BSLASHAclp] = ACTIONS(5971),
    [anon_sym_BSLASHacf] = ACTIONS(5971),
    [anon_sym_BSLASHAcf] = ACTIONS(5971),
    [anon_sym_BSLASHacfp] = ACTIONS(5971),
    [anon_sym_BSLASHAcfp] = ACTIONS(5971),
    [anon_sym_BSLASHac] = ACTIONS(5971),
    [anon_sym_BSLASHAc] = ACTIONS(5971),
    [anon_sym_BSLASHacp] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5971),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5971),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5971),
    [anon_sym_BSLASHcolor] = ACTIONS(5971),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5971),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5971),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5971),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5971),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5971),
    [anon_sym_BSLASHtext] = ACTIONS(5971),
    [anon_sym_BSLASHintertext] = ACTIONS(5971),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5971),
    [anon_sym_BSLASHurl] = ACTIONS(5971),
    [anon_sym_BSLASHhref] = ACTIONS(5971),
  },
  [736] = {
    [sym__section_part] = STATE(1387),
    [sym_curly_group] = STATE(1388),
    [sym_brack_group] = STATE(2998),
    [sym_command_name] = ACTIONS(5975),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5975),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5977),
    [anon_sym_EQ] = ACTIONS(5977),
    [anon_sym_LPAREN] = ACTIONS(5977),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHpart] = ACTIONS(5975),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddpart] = ACTIONS(5975),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHchapter] = ACTIONS(5975),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddchap] = ACTIONS(5975),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsection] = ACTIONS(5975),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddsec] = ACTIONS(5975),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHitem] = ACTIONS(5975),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5977),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(5975),
    [sym_placeholder] = ACTIONS(5977),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_STAR] = ACTIONS(5977),
    [anon_sym_SLASH] = ACTIONS(5977),
    [anon_sym_LT] = ACTIONS(5975),
    [anon_sym_GT] = ACTIONS(5975),
    [anon_sym_BANG] = ACTIONS(5975),
    [anon_sym_PIPE] = ACTIONS(5975),
    [anon_sym_COLON] = ACTIONS(5975),
    [anon_sym_SQUOTE] = ACTIONS(5975),
    [anon_sym__] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5977),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5977),
    [anon_sym_DOLLAR] = ACTIONS(5975),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5977),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHbegin] = ACTIONS(5975),
    [anon_sym_BSLASHtitle] = ACTIONS(5975),
    [anon_sym_BSLASHauthor] = ACTIONS(5975),
    [anon_sym_BSLASHusepackage] = ACTIONS(5975),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5975),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5975),
    [anon_sym_BSLASHinclude] = ACTIONS(5975),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5975),
    [anon_sym_BSLASHinput] = ACTIONS(5975),
    [anon_sym_BSLASHsubfile] = ACTIONS(5975),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5975),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5975),
    [anon_sym_BSLASHbibliography] = ACTIONS(5975),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5975),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5975),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5975),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5975),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5975),
    [anon_sym_BSLASHimport] = ACTIONS(5975),
    [anon_sym_BSLASHsubimport] = ACTIONS(5975),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5975),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHcaption] = ACTIONS(5975),
    [anon_sym_BSLASHcite] = ACTIONS(5975),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCite] = ACTIONS(5975),
    [anon_sym_BSLASHnocite] = ACTIONS(5975),
    [anon_sym_BSLASHcitet] = ACTIONS(5975),
    [anon_sym_BSLASHcitep] = ACTIONS(5975),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteA] = ACTIONS(5975),
    [anon_sym_BSLASHciteR] = ACTIONS(5975),
    [anon_sym_BSLASHciteS] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5975),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteyear] = ACTIONS(5975),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitedate] = ACTIONS(5975),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteurl] = ACTIONS(5975),
    [anon_sym_BSLASHfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5975),
    [anon_sym_BSLASHcitealt] = ACTIONS(5975),
    [anon_sym_BSLASHcitealp] = ACTIONS(5975),
    [anon_sym_BSLASHcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHparencite] = ACTIONS(5975),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHParencite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHtextcite] = ACTIONS(5975),
    [anon_sym_BSLASHTextcite] = ACTIONS(5975),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHsupercite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite] = ACTIONS(5975),
    [anon_sym_BSLASHAutocite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHVolcite] = ACTIONS(5975),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHavolcite] = ACTIONS(5975),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHNotecite] = ACTIONS(5975),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHlabel] = ACTIONS(5975),
    [anon_sym_BSLASHref] = ACTIONS(5975),
    [anon_sym_BSLASHeqref] = ACTIONS(5975),
    [anon_sym_BSLASHvref] = ACTIONS(5975),
    [anon_sym_BSLASHVref] = ACTIONS(5975),
    [anon_sym_BSLASHautoref] = ACTIONS(5975),
    [anon_sym_BSLASHpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcref] = ACTIONS(5975),
    [anon_sym_BSLASHCref] = ACTIONS(5975),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnameCref] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHdef] = ACTIONS(5975),
    [anon_sym_BSLASHlet] = ACTIONS(5975),
    [anon_sym_BSLASHleft] = ACTIONS(5975),
    [anon_sym_BSLASHbigl] = ACTIONS(5975),
    [anon_sym_BSLASHBigl] = ACTIONS(5975),
    [anon_sym_BSLASHbiggl] = ACTIONS(5975),
    [anon_sym_BSLASHBiggl] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5975),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5975),
    [anon_sym_BSLASHgls] = ACTIONS(5975),
    [anon_sym_BSLASHGls] = ACTIONS(5975),
    [anon_sym_BSLASHGLS] = ACTIONS(5975),
    [anon_sym_BSLASHglspl] = ACTIONS(5975),
    [anon_sym_BSLASHGlspl] = ACTIONS(5975),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5975),
    [anon_sym_BSLASHglslink] = ACTIONS(5975),
    [anon_sym_BSLASHglstext] = ACTIONS(5975),
    [anon_sym_BSLASHGlstext] = ACTIONS(5975),
    [anon_sym_BSLASHGLStext] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5975),
    [anon_sym_BSLASHglsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsname] = ACTIONS(5975),
    [anon_sym_BSLASHGlsname] = ACTIONS(5975),
    [anon_sym_BSLASHGLSname] = ACTIONS(5975),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5975),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5975),
    [anon_sym_BSLASHacrshort] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5975),
    [anon_sym_BSLASHACRshort] = ACTIONS(5975),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrlong] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5975),
    [anon_sym_BSLASHACRlong] = ACTIONS(5975),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrfull] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5975),
    [anon_sym_BSLASHACRfull] = ACTIONS(5975),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHacs] = ACTIONS(5975),
    [anon_sym_BSLASHAcs] = ACTIONS(5975),
    [anon_sym_BSLASHacsp] = ACTIONS(5975),
    [anon_sym_BSLASHAcsp] = ACTIONS(5975),
    [anon_sym_BSLASHacl] = ACTIONS(5975),
    [anon_sym_BSLASHAcl] = ACTIONS(5975),
    [anon_sym_BSLASHaclp] = ACTIONS(5975),
    [anon_sym_BSLASHAclp] = ACTIONS(5975),
    [anon_sym_BSLASHacf] = ACTIONS(5975),
    [anon_sym_BSLASHAcf] = ACTIONS(5975),
    [anon_sym_BSLASHacfp] = ACTIONS(5975),
    [anon_sym_BSLASHAcfp] = ACTIONS(5975),
    [anon_sym_BSLASHac] = ACTIONS(5975),
    [anon_sym_BSLASHAc] = ACTIONS(5975),
    [anon_sym_BSLASHacp] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5975),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5975),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5975),
    [anon_sym_BSLASHcolor] = ACTIONS(5975),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5975),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5975),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5975),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5975),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5975),
    [anon_sym_BSLASHtext] = ACTIONS(5975),
    [anon_sym_BSLASHintertext] = ACTIONS(5975),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5975),
    [anon_sym_BSLASHurl] = ACTIONS(5975),
    [anon_sym_BSLASHhref] = ACTIONS(5975),
  },
  [737] = {
    [sym__section_part] = STATE(1386),
    [sym_curly_group] = STATE(1388),
    [sym_brack_group] = STATE(2998),
    [sym_command_name] = ACTIONS(5979),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5979),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5981),
    [anon_sym_COMMA] = ACTIONS(5981),
    [anon_sym_EQ] = ACTIONS(5981),
    [anon_sym_LPAREN] = ACTIONS(5981),
    [anon_sym_RPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHpart] = ACTIONS(5979),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddpart] = ACTIONS(5979),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHchapter] = ACTIONS(5979),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddchap] = ACTIONS(5979),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsection] = ACTIONS(5979),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddsec] = ACTIONS(5979),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHitem] = ACTIONS(5979),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5981),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(5979),
    [sym_placeholder] = ACTIONS(5981),
    [anon_sym_PLUS] = ACTIONS(5981),
    [anon_sym_DASH] = ACTIONS(5981),
    [anon_sym_STAR] = ACTIONS(5981),
    [anon_sym_SLASH] = ACTIONS(5981),
    [anon_sym_LT] = ACTIONS(5979),
    [anon_sym_GT] = ACTIONS(5979),
    [anon_sym_BANG] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5979),
    [anon_sym_SQUOTE] = ACTIONS(5979),
    [anon_sym__] = ACTIONS(5981),
    [anon_sym_CARET] = ACTIONS(5981),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5981),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5979),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5981),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHbegin] = ACTIONS(5979),
    [anon_sym_BSLASHtitle] = ACTIONS(5979),
    [anon_sym_BSLASHauthor] = ACTIONS(5979),
    [anon_sym_BSLASHusepackage] = ACTIONS(5979),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5979),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5979),
    [anon_sym_BSLASHinclude] = ACTIONS(5979),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5979),
    [anon_sym_BSLASHinput] = ACTIONS(5979),
    [anon_sym_BSLASHsubfile] = ACTIONS(5979),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5979),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5979),
    [anon_sym_BSLASHbibliography] = ACTIONS(5979),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5979),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5979),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5979),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5979),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5979),
    [anon_sym_BSLASHimport] = ACTIONS(5979),
    [anon_sym_BSLASHsubimport] = ACTIONS(5979),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5979),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHcaption] = ACTIONS(5979),
    [anon_sym_BSLASHcite] = ACTIONS(5979),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCite] = ACTIONS(5979),
    [anon_sym_BSLASHnocite] = ACTIONS(5979),
    [anon_sym_BSLASHcitet] = ACTIONS(5979),
    [anon_sym_BSLASHcitep] = ACTIONS(5979),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteA] = ACTIONS(5979),
    [anon_sym_BSLASHciteR] = ACTIONS(5979),
    [anon_sym_BSLASHciteS] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5979),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteyear] = ACTIONS(5979),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitedate] = ACTIONS(5979),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteurl] = ACTIONS(5979),
    [anon_sym_BSLASHfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5979),
    [anon_sym_BSLASHcitealt] = ACTIONS(5979),
    [anon_sym_BSLASHcitealp] = ACTIONS(5979),
    [anon_sym_BSLASHcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHparencite] = ACTIONS(5979),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHParencite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHtextcite] = ACTIONS(5979),
    [anon_sym_BSLASHTextcite] = ACTIONS(5979),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHsupercite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite] = ACTIONS(5979),
    [anon_sym_BSLASHAutocite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHVolcite] = ACTIONS(5979),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHavolcite] = ACTIONS(5979),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHNotecite] = ACTIONS(5979),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHlabel] = ACTIONS(5979),
    [anon_sym_BSLASHref] = ACTIONS(5979),
    [anon_sym_BSLASHeqref] = ACTIONS(5979),
    [anon_sym_BSLASHvref] = ACTIONS(5979),
    [anon_sym_BSLASHVref] = ACTIONS(5979),
    [anon_sym_BSLASHautoref] = ACTIONS(5979),
    [anon_sym_BSLASHpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcref] = ACTIONS(5979),
    [anon_sym_BSLASHCref] = ACTIONS(5979),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnameCref] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHdef] = ACTIONS(5979),
    [anon_sym_BSLASHlet] = ACTIONS(5979),
    [anon_sym_BSLASHleft] = ACTIONS(5979),
    [anon_sym_BSLASHbigl] = ACTIONS(5979),
    [anon_sym_BSLASHBigl] = ACTIONS(5979),
    [anon_sym_BSLASHbiggl] = ACTIONS(5979),
    [anon_sym_BSLASHBiggl] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5979),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5979),
    [anon_sym_BSLASHgls] = ACTIONS(5979),
    [anon_sym_BSLASHGls] = ACTIONS(5979),
    [anon_sym_BSLASHGLS] = ACTIONS(5979),
    [anon_sym_BSLASHglspl] = ACTIONS(5979),
    [anon_sym_BSLASHGlspl] = ACTIONS(5979),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5979),
    [anon_sym_BSLASHglslink] = ACTIONS(5979),
    [anon_sym_BSLASHglstext] = ACTIONS(5979),
    [anon_sym_BSLASHGlstext] = ACTIONS(5979),
    [anon_sym_BSLASHGLStext] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5979),
    [anon_sym_BSLASHglsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsname] = ACTIONS(5979),
    [anon_sym_BSLASHGlsname] = ACTIONS(5979),
    [anon_sym_BSLASHGLSname] = ACTIONS(5979),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5979),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5979),
    [anon_sym_BSLASHacrshort] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5979),
    [anon_sym_BSLASHACRshort] = ACTIONS(5979),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrlong] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5979),
    [anon_sym_BSLASHACRlong] = ACTIONS(5979),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrfull] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5979),
    [anon_sym_BSLASHACRfull] = ACTIONS(5979),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHacs] = ACTIONS(5979),
    [anon_sym_BSLASHAcs] = ACTIONS(5979),
    [anon_sym_BSLASHacsp] = ACTIONS(5979),
    [anon_sym_BSLASHAcsp] = ACTIONS(5979),
    [anon_sym_BSLASHacl] = ACTIONS(5979),
    [anon_sym_BSLASHAcl] = ACTIONS(5979),
    [anon_sym_BSLASHaclp] = ACTIONS(5979),
    [anon_sym_BSLASHAclp] = ACTIONS(5979),
    [anon_sym_BSLASHacf] = ACTIONS(5979),
    [anon_sym_BSLASHAcf] = ACTIONS(5979),
    [anon_sym_BSLASHacfp] = ACTIONS(5979),
    [anon_sym_BSLASHAcfp] = ACTIONS(5979),
    [anon_sym_BSLASHac] = ACTIONS(5979),
    [anon_sym_BSLASHAc] = ACTIONS(5979),
    [anon_sym_BSLASHacp] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5979),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5979),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5979),
    [anon_sym_BSLASHcolor] = ACTIONS(5979),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5979),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5979),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5979),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5979),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5979),
    [anon_sym_BSLASHtext] = ACTIONS(5979),
    [anon_sym_BSLASHintertext] = ACTIONS(5979),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5979),
    [anon_sym_BSLASHurl] = ACTIONS(5979),
    [anon_sym_BSLASHhref] = ACTIONS(5979),
  },
  [738] = {
    [sym__section_part] = STATE(1385),
    [sym_curly_group] = STATE(1388),
    [sym_brack_group] = STATE(2998),
    [sym_command_name] = ACTIONS(5983),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5983),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5985),
    [anon_sym_COMMA] = ACTIONS(5985),
    [anon_sym_EQ] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(5985),
    [anon_sym_RPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHpart] = ACTIONS(5983),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddpart] = ACTIONS(5983),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHchapter] = ACTIONS(5983),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddchap] = ACTIONS(5983),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsection] = ACTIONS(5983),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddsec] = ACTIONS(5983),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHitem] = ACTIONS(5983),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(5983),
    [sym_placeholder] = ACTIONS(5985),
    [anon_sym_PLUS] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(5985),
    [anon_sym_SLASH] = ACTIONS(5985),
    [anon_sym_LT] = ACTIONS(5983),
    [anon_sym_GT] = ACTIONS(5983),
    [anon_sym_BANG] = ACTIONS(5983),
    [anon_sym_PIPE] = ACTIONS(5983),
    [anon_sym_COLON] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(5983),
    [anon_sym__] = ACTIONS(5985),
    [anon_sym_CARET] = ACTIONS(5985),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5985),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5985),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5985),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHbegin] = ACTIONS(5983),
    [anon_sym_BSLASHtitle] = ACTIONS(5983),
    [anon_sym_BSLASHauthor] = ACTIONS(5983),
    [anon_sym_BSLASHusepackage] = ACTIONS(5983),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5983),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5983),
    [anon_sym_BSLASHinclude] = ACTIONS(5983),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5983),
    [anon_sym_BSLASHinput] = ACTIONS(5983),
    [anon_sym_BSLASHsubfile] = ACTIONS(5983),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5983),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5983),
    [anon_sym_BSLASHbibliography] = ACTIONS(5983),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5983),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5983),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5983),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5983),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5983),
    [anon_sym_BSLASHimport] = ACTIONS(5983),
    [anon_sym_BSLASHsubimport] = ACTIONS(5983),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5983),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHcaption] = ACTIONS(5983),
    [anon_sym_BSLASHcite] = ACTIONS(5983),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCite] = ACTIONS(5983),
    [anon_sym_BSLASHnocite] = ACTIONS(5983),
    [anon_sym_BSLASHcitet] = ACTIONS(5983),
    [anon_sym_BSLASHcitep] = ACTIONS(5983),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteA] = ACTIONS(5983),
    [anon_sym_BSLASHciteR] = ACTIONS(5983),
    [anon_sym_BSLASHciteS] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5983),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteyear] = ACTIONS(5983),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitedate] = ACTIONS(5983),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteurl] = ACTIONS(5983),
    [anon_sym_BSLASHfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5983),
    [anon_sym_BSLASHcitealt] = ACTIONS(5983),
    [anon_sym_BSLASHcitealp] = ACTIONS(5983),
    [anon_sym_BSLASHcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHparencite] = ACTIONS(5983),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHParencite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHtextcite] = ACTIONS(5983),
    [anon_sym_BSLASHTextcite] = ACTIONS(5983),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHsupercite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite] = ACTIONS(5983),
    [anon_sym_BSLASHAutocite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHVolcite] = ACTIONS(5983),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHavolcite] = ACTIONS(5983),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHNotecite] = ACTIONS(5983),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHlabel] = ACTIONS(5983),
    [anon_sym_BSLASHref] = ACTIONS(5983),
    [anon_sym_BSLASHeqref] = ACTIONS(5983),
    [anon_sym_BSLASHvref] = ACTIONS(5983),
    [anon_sym_BSLASHVref] = ACTIONS(5983),
    [anon_sym_BSLASHautoref] = ACTIONS(5983),
    [anon_sym_BSLASHpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcref] = ACTIONS(5983),
    [anon_sym_BSLASHCref] = ACTIONS(5983),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnameCref] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHdef] = ACTIONS(5983),
    [anon_sym_BSLASHlet] = ACTIONS(5983),
    [anon_sym_BSLASHleft] = ACTIONS(5983),
    [anon_sym_BSLASHbigl] = ACTIONS(5983),
    [anon_sym_BSLASHBigl] = ACTIONS(5983),
    [anon_sym_BSLASHbiggl] = ACTIONS(5983),
    [anon_sym_BSLASHBiggl] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5983),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5983),
    [anon_sym_BSLASHgls] = ACTIONS(5983),
    [anon_sym_BSLASHGls] = ACTIONS(5983),
    [anon_sym_BSLASHGLS] = ACTIONS(5983),
    [anon_sym_BSLASHglspl] = ACTIONS(5983),
    [anon_sym_BSLASHGlspl] = ACTIONS(5983),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5983),
    [anon_sym_BSLASHglslink] = ACTIONS(5983),
    [anon_sym_BSLASHglstext] = ACTIONS(5983),
    [anon_sym_BSLASHGlstext] = ACTIONS(5983),
    [anon_sym_BSLASHGLStext] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5983),
    [anon_sym_BSLASHglsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsname] = ACTIONS(5983),
    [anon_sym_BSLASHGlsname] = ACTIONS(5983),
    [anon_sym_BSLASHGLSname] = ACTIONS(5983),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5983),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5983),
    [anon_sym_BSLASHacrshort] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5983),
    [anon_sym_BSLASHACRshort] = ACTIONS(5983),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrlong] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5983),
    [anon_sym_BSLASHACRlong] = ACTIONS(5983),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrfull] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5983),
    [anon_sym_BSLASHACRfull] = ACTIONS(5983),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHacs] = ACTIONS(5983),
    [anon_sym_BSLASHAcs] = ACTIONS(5983),
    [anon_sym_BSLASHacsp] = ACTIONS(5983),
    [anon_sym_BSLASHAcsp] = ACTIONS(5983),
    [anon_sym_BSLASHacl] = ACTIONS(5983),
    [anon_sym_BSLASHAcl] = ACTIONS(5983),
    [anon_sym_BSLASHaclp] = ACTIONS(5983),
    [anon_sym_BSLASHAclp] = ACTIONS(5983),
    [anon_sym_BSLASHacf] = ACTIONS(5983),
    [anon_sym_BSLASHAcf] = ACTIONS(5983),
    [anon_sym_BSLASHacfp] = ACTIONS(5983),
    [anon_sym_BSLASHAcfp] = ACTIONS(5983),
    [anon_sym_BSLASHac] = ACTIONS(5983),
    [anon_sym_BSLASHAc] = ACTIONS(5983),
    [anon_sym_BSLASHacp] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5983),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5983),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5983),
    [anon_sym_BSLASHcolor] = ACTIONS(5983),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5983),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5983),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5983),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5983),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5983),
    [anon_sym_BSLASHtext] = ACTIONS(5983),
    [anon_sym_BSLASHintertext] = ACTIONS(5983),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5983),
    [anon_sym_BSLASHurl] = ACTIONS(5983),
    [anon_sym_BSLASHhref] = ACTIONS(5983),
  },
  [739] = {
    [sym__section_part] = STATE(1384),
    [sym_curly_group] = STATE(1388),
    [sym_brack_group] = STATE(2998),
    [sym_command_name] = ACTIONS(6061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(6063),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHpart] = ACTIONS(6061),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddpart] = ACTIONS(6061),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHchapter] = ACTIONS(6061),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddchap] = ACTIONS(6061),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsection] = ACTIONS(6061),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddsec] = ACTIONS(6061),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHitem] = ACTIONS(6061),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6063),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6061),
    [sym_placeholder] = ACTIONS(6063),
    [anon_sym_PLUS] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6063),
    [anon_sym_STAR] = ACTIONS(6063),
    [anon_sym_SLASH] = ACTIONS(6063),
    [anon_sym_LT] = ACTIONS(6061),
    [anon_sym_GT] = ACTIONS(6061),
    [anon_sym_BANG] = ACTIONS(6061),
    [anon_sym_PIPE] = ACTIONS(6061),
    [anon_sym_COLON] = ACTIONS(6061),
    [anon_sym_SQUOTE] = ACTIONS(6061),
    [anon_sym__] = ACTIONS(6063),
    [anon_sym_CARET] = ACTIONS(6063),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6063),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6063),
    [anon_sym_DOLLAR] = ACTIONS(6061),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6063),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHbegin] = ACTIONS(6061),
    [anon_sym_BSLASHtitle] = ACTIONS(6061),
    [anon_sym_BSLASHauthor] = ACTIONS(6061),
    [anon_sym_BSLASHusepackage] = ACTIONS(6061),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6061),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6061),
    [anon_sym_BSLASHinclude] = ACTIONS(6061),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6061),
    [anon_sym_BSLASHinput] = ACTIONS(6061),
    [anon_sym_BSLASHsubfile] = ACTIONS(6061),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6061),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6061),
    [anon_sym_BSLASHbibliography] = ACTIONS(6061),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6061),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6061),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6061),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6061),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6061),
    [anon_sym_BSLASHimport] = ACTIONS(6061),
    [anon_sym_BSLASHsubimport] = ACTIONS(6061),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6061),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHcaption] = ACTIONS(6061),
    [anon_sym_BSLASHcite] = ACTIONS(6061),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCite] = ACTIONS(6061),
    [anon_sym_BSLASHnocite] = ACTIONS(6061),
    [anon_sym_BSLASHcitet] = ACTIONS(6061),
    [anon_sym_BSLASHcitep] = ACTIONS(6061),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteA] = ACTIONS(6061),
    [anon_sym_BSLASHciteR] = ACTIONS(6061),
    [anon_sym_BSLASHciteS] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6061),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteyear] = ACTIONS(6061),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitedate] = ACTIONS(6061),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteurl] = ACTIONS(6061),
    [anon_sym_BSLASHfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6061),
    [anon_sym_BSLASHcitealt] = ACTIONS(6061),
    [anon_sym_BSLASHcitealp] = ACTIONS(6061),
    [anon_sym_BSLASHcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHparencite] = ACTIONS(6061),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHParencite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHtextcite] = ACTIONS(6061),
    [anon_sym_BSLASHTextcite] = ACTIONS(6061),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHsupercite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite] = ACTIONS(6061),
    [anon_sym_BSLASHAutocite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHVolcite] = ACTIONS(6061),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHavolcite] = ACTIONS(6061),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHNotecite] = ACTIONS(6061),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHlabel] = ACTIONS(6061),
    [anon_sym_BSLASHref] = ACTIONS(6061),
    [anon_sym_BSLASHeqref] = ACTIONS(6061),
    [anon_sym_BSLASHvref] = ACTIONS(6061),
    [anon_sym_BSLASHVref] = ACTIONS(6061),
    [anon_sym_BSLASHautoref] = ACTIONS(6061),
    [anon_sym_BSLASHpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcref] = ACTIONS(6061),
    [anon_sym_BSLASHCref] = ACTIONS(6061),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnameCref] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHdef] = ACTIONS(6061),
    [anon_sym_BSLASHlet] = ACTIONS(6061),
    [anon_sym_BSLASHleft] = ACTIONS(6061),
    [anon_sym_BSLASHbigl] = ACTIONS(6061),
    [anon_sym_BSLASHBigl] = ACTIONS(6061),
    [anon_sym_BSLASHbiggl] = ACTIONS(6061),
    [anon_sym_BSLASHBiggl] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6061),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6061),
    [anon_sym_BSLASHgls] = ACTIONS(6061),
    [anon_sym_BSLASHGls] = ACTIONS(6061),
    [anon_sym_BSLASHGLS] = ACTIONS(6061),
    [anon_sym_BSLASHglspl] = ACTIONS(6061),
    [anon_sym_BSLASHGlspl] = ACTIONS(6061),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6061),
    [anon_sym_BSLASHglslink] = ACTIONS(6061),
    [anon_sym_BSLASHglstext] = ACTIONS(6061),
    [anon_sym_BSLASHGlstext] = ACTIONS(6061),
    [anon_sym_BSLASHGLStext] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6061),
    [anon_sym_BSLASHglsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsname] = ACTIONS(6061),
    [anon_sym_BSLASHGlsname] = ACTIONS(6061),
    [anon_sym_BSLASHGLSname] = ACTIONS(6061),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6061),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6061),
    [anon_sym_BSLASHacrshort] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6061),
    [anon_sym_BSLASHACRshort] = ACTIONS(6061),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrlong] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6061),
    [anon_sym_BSLASHACRlong] = ACTIONS(6061),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrfull] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6061),
    [anon_sym_BSLASHACRfull] = ACTIONS(6061),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHacs] = ACTIONS(6061),
    [anon_sym_BSLASHAcs] = ACTIONS(6061),
    [anon_sym_BSLASHacsp] = ACTIONS(6061),
    [anon_sym_BSLASHAcsp] = ACTIONS(6061),
    [anon_sym_BSLASHacl] = ACTIONS(6061),
    [anon_sym_BSLASHAcl] = ACTIONS(6061),
    [anon_sym_BSLASHaclp] = ACTIONS(6061),
    [anon_sym_BSLASHAclp] = ACTIONS(6061),
    [anon_sym_BSLASHacf] = ACTIONS(6061),
    [anon_sym_BSLASHAcf] = ACTIONS(6061),
    [anon_sym_BSLASHacfp] = ACTIONS(6061),
    [anon_sym_BSLASHAcfp] = ACTIONS(6061),
    [anon_sym_BSLASHac] = ACTIONS(6061),
    [anon_sym_BSLASHAc] = ACTIONS(6061),
    [anon_sym_BSLASHacp] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6061),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6061),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6061),
    [anon_sym_BSLASHcolor] = ACTIONS(6061),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6061),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6061),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6061),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6061),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6061),
    [anon_sym_BSLASHtext] = ACTIONS(6061),
    [anon_sym_BSLASHintertext] = ACTIONS(6061),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6061),
    [anon_sym_BSLASHurl] = ACTIONS(6061),
    [anon_sym_BSLASHhref] = ACTIONS(6061),
  },
  [740] = {
    [sym__section_part] = STATE(1383),
    [sym_curly_group] = STATE(1388),
    [sym_brack_group] = STATE(2998),
    [sym_command_name] = ACTIONS(6081),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6083),
    [anon_sym_COMMA] = ACTIONS(6083),
    [anon_sym_EQ] = ACTIONS(6083),
    [anon_sym_LPAREN] = ACTIONS(6083),
    [anon_sym_RPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHpart] = ACTIONS(6081),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddpart] = ACTIONS(6081),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHchapter] = ACTIONS(6081),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddchap] = ACTIONS(6081),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsection] = ACTIONS(6081),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddsec] = ACTIONS(6081),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHitem] = ACTIONS(6081),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6081),
    [sym_placeholder] = ACTIONS(6083),
    [anon_sym_PLUS] = ACTIONS(6083),
    [anon_sym_DASH] = ACTIONS(6083),
    [anon_sym_STAR] = ACTIONS(6083),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_BANG] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_SQUOTE] = ACTIONS(6081),
    [anon_sym__] = ACTIONS(6083),
    [anon_sym_CARET] = ACTIONS(6083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6083),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6083),
    [anon_sym_DOLLAR] = ACTIONS(6081),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6083),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHbegin] = ACTIONS(6081),
    [anon_sym_BSLASHtitle] = ACTIONS(6081),
    [anon_sym_BSLASHauthor] = ACTIONS(6081),
    [anon_sym_BSLASHusepackage] = ACTIONS(6081),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6081),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6081),
    [anon_sym_BSLASHinclude] = ACTIONS(6081),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6081),
    [anon_sym_BSLASHinput] = ACTIONS(6081),
    [anon_sym_BSLASHsubfile] = ACTIONS(6081),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6081),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6081),
    [anon_sym_BSLASHbibliography] = ACTIONS(6081),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6081),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6081),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6081),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6081),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6081),
    [anon_sym_BSLASHimport] = ACTIONS(6081),
    [anon_sym_BSLASHsubimport] = ACTIONS(6081),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6081),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHcaption] = ACTIONS(6081),
    [anon_sym_BSLASHcite] = ACTIONS(6081),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCite] = ACTIONS(6081),
    [anon_sym_BSLASHnocite] = ACTIONS(6081),
    [anon_sym_BSLASHcitet] = ACTIONS(6081),
    [anon_sym_BSLASHcitep] = ACTIONS(6081),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteA] = ACTIONS(6081),
    [anon_sym_BSLASHciteR] = ACTIONS(6081),
    [anon_sym_BSLASHciteS] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6081),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteyear] = ACTIONS(6081),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitedate] = ACTIONS(6081),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteurl] = ACTIONS(6081),
    [anon_sym_BSLASHfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6081),
    [anon_sym_BSLASHcitealt] = ACTIONS(6081),
    [anon_sym_BSLASHcitealp] = ACTIONS(6081),
    [anon_sym_BSLASHcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHparencite] = ACTIONS(6081),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHParencite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHtextcite] = ACTIONS(6081),
    [anon_sym_BSLASHTextcite] = ACTIONS(6081),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHsupercite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite] = ACTIONS(6081),
    [anon_sym_BSLASHAutocite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHVolcite] = ACTIONS(6081),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHavolcite] = ACTIONS(6081),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHNotecite] = ACTIONS(6081),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHlabel] = ACTIONS(6081),
    [anon_sym_BSLASHref] = ACTIONS(6081),
    [anon_sym_BSLASHeqref] = ACTIONS(6081),
    [anon_sym_BSLASHvref] = ACTIONS(6081),
    [anon_sym_BSLASHVref] = ACTIONS(6081),
    [anon_sym_BSLASHautoref] = ACTIONS(6081),
    [anon_sym_BSLASHpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcref] = ACTIONS(6081),
    [anon_sym_BSLASHCref] = ACTIONS(6081),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnameCref] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHdef] = ACTIONS(6081),
    [anon_sym_BSLASHlet] = ACTIONS(6081),
    [anon_sym_BSLASHleft] = ACTIONS(6081),
    [anon_sym_BSLASHbigl] = ACTIONS(6081),
    [anon_sym_BSLASHBigl] = ACTIONS(6081),
    [anon_sym_BSLASHbiggl] = ACTIONS(6081),
    [anon_sym_BSLASHBiggl] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6081),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6081),
    [anon_sym_BSLASHgls] = ACTIONS(6081),
    [anon_sym_BSLASHGls] = ACTIONS(6081),
    [anon_sym_BSLASHGLS] = ACTIONS(6081),
    [anon_sym_BSLASHglspl] = ACTIONS(6081),
    [anon_sym_BSLASHGlspl] = ACTIONS(6081),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6081),
    [anon_sym_BSLASHglslink] = ACTIONS(6081),
    [anon_sym_BSLASHglstext] = ACTIONS(6081),
    [anon_sym_BSLASHGlstext] = ACTIONS(6081),
    [anon_sym_BSLASHGLStext] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6081),
    [anon_sym_BSLASHglsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsname] = ACTIONS(6081),
    [anon_sym_BSLASHGlsname] = ACTIONS(6081),
    [anon_sym_BSLASHGLSname] = ACTIONS(6081),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6081),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6081),
    [anon_sym_BSLASHacrshort] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6081),
    [anon_sym_BSLASHACRshort] = ACTIONS(6081),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrlong] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6081),
    [anon_sym_BSLASHACRlong] = ACTIONS(6081),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrfull] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6081),
    [anon_sym_BSLASHACRfull] = ACTIONS(6081),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHacs] = ACTIONS(6081),
    [anon_sym_BSLASHAcs] = ACTIONS(6081),
    [anon_sym_BSLASHacsp] = ACTIONS(6081),
    [anon_sym_BSLASHAcsp] = ACTIONS(6081),
    [anon_sym_BSLASHacl] = ACTIONS(6081),
    [anon_sym_BSLASHAcl] = ACTIONS(6081),
    [anon_sym_BSLASHaclp] = ACTIONS(6081),
    [anon_sym_BSLASHAclp] = ACTIONS(6081),
    [anon_sym_BSLASHacf] = ACTIONS(6081),
    [anon_sym_BSLASHAcf] = ACTIONS(6081),
    [anon_sym_BSLASHacfp] = ACTIONS(6081),
    [anon_sym_BSLASHAcfp] = ACTIONS(6081),
    [anon_sym_BSLASHac] = ACTIONS(6081),
    [anon_sym_BSLASHAc] = ACTIONS(6081),
    [anon_sym_BSLASHacp] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6081),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6081),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6081),
    [anon_sym_BSLASHcolor] = ACTIONS(6081),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6081),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6081),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6081),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6081),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6081),
    [anon_sym_BSLASHtext] = ACTIONS(6081),
    [anon_sym_BSLASHintertext] = ACTIONS(6081),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6081),
    [anon_sym_BSLASHurl] = ACTIONS(6081),
    [anon_sym_BSLASHhref] = ACTIONS(6081),
  },
  [741] = {
    [sym__section_part] = STATE(1382),
    [sym_curly_group] = STATE(1388),
    [sym_brack_group] = STATE(2998),
    [sym_command_name] = ACTIONS(6101),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6103),
    [anon_sym_COMMA] = ACTIONS(6103),
    [anon_sym_EQ] = ACTIONS(6103),
    [anon_sym_LPAREN] = ACTIONS(6103),
    [anon_sym_RPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHpart] = ACTIONS(6101),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddpart] = ACTIONS(6101),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHchapter] = ACTIONS(6101),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddchap] = ACTIONS(6101),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsection] = ACTIONS(6101),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddsec] = ACTIONS(6101),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHitem] = ACTIONS(6101),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6103),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6101),
    [sym_placeholder] = ACTIONS(6103),
    [anon_sym_PLUS] = ACTIONS(6103),
    [anon_sym_DASH] = ACTIONS(6103),
    [anon_sym_STAR] = ACTIONS(6103),
    [anon_sym_SLASH] = ACTIONS(6103),
    [anon_sym_LT] = ACTIONS(6101),
    [anon_sym_GT] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(6101),
    [anon_sym_PIPE] = ACTIONS(6101),
    [anon_sym_COLON] = ACTIONS(6101),
    [anon_sym_SQUOTE] = ACTIONS(6101),
    [anon_sym__] = ACTIONS(6103),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6103),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6103),
    [anon_sym_DOLLAR] = ACTIONS(6101),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6103),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHbegin] = ACTIONS(6101),
    [anon_sym_BSLASHtitle] = ACTIONS(6101),
    [anon_sym_BSLASHauthor] = ACTIONS(6101),
    [anon_sym_BSLASHusepackage] = ACTIONS(6101),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6101),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6101),
    [anon_sym_BSLASHinclude] = ACTIONS(6101),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6101),
    [anon_sym_BSLASHinput] = ACTIONS(6101),
    [anon_sym_BSLASHsubfile] = ACTIONS(6101),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6101),
    [anon_sym_BSLASHbibliography] = ACTIONS(6101),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6101),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6101),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6101),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6101),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6101),
    [anon_sym_BSLASHimport] = ACTIONS(6101),
    [anon_sym_BSLASHsubimport] = ACTIONS(6101),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6101),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHcaption] = ACTIONS(6101),
    [anon_sym_BSLASHcite] = ACTIONS(6101),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCite] = ACTIONS(6101),
    [anon_sym_BSLASHnocite] = ACTIONS(6101),
    [anon_sym_BSLASHcitet] = ACTIONS(6101),
    [anon_sym_BSLASHcitep] = ACTIONS(6101),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteA] = ACTIONS(6101),
    [anon_sym_BSLASHciteR] = ACTIONS(6101),
    [anon_sym_BSLASHciteS] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6101),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteyear] = ACTIONS(6101),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitedate] = ACTIONS(6101),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteurl] = ACTIONS(6101),
    [anon_sym_BSLASHfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6101),
    [anon_sym_BSLASHcitealt] = ACTIONS(6101),
    [anon_sym_BSLASHcitealp] = ACTIONS(6101),
    [anon_sym_BSLASHcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHparencite] = ACTIONS(6101),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHParencite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHtextcite] = ACTIONS(6101),
    [anon_sym_BSLASHTextcite] = ACTIONS(6101),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHsupercite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite] = ACTIONS(6101),
    [anon_sym_BSLASHAutocite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHVolcite] = ACTIONS(6101),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHavolcite] = ACTIONS(6101),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHNotecite] = ACTIONS(6101),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHlabel] = ACTIONS(6101),
    [anon_sym_BSLASHref] = ACTIONS(6101),
    [anon_sym_BSLASHeqref] = ACTIONS(6101),
    [anon_sym_BSLASHvref] = ACTIONS(6101),
    [anon_sym_BSLASHVref] = ACTIONS(6101),
    [anon_sym_BSLASHautoref] = ACTIONS(6101),
    [anon_sym_BSLASHpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcref] = ACTIONS(6101),
    [anon_sym_BSLASHCref] = ACTIONS(6101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnameCref] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHdef] = ACTIONS(6101),
    [anon_sym_BSLASHlet] = ACTIONS(6101),
    [anon_sym_BSLASHleft] = ACTIONS(6101),
    [anon_sym_BSLASHbigl] = ACTIONS(6101),
    [anon_sym_BSLASHBigl] = ACTIONS(6101),
    [anon_sym_BSLASHbiggl] = ACTIONS(6101),
    [anon_sym_BSLASHBiggl] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6101),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6101),
    [anon_sym_BSLASHgls] = ACTIONS(6101),
    [anon_sym_BSLASHGls] = ACTIONS(6101),
    [anon_sym_BSLASHGLS] = ACTIONS(6101),
    [anon_sym_BSLASHglspl] = ACTIONS(6101),
    [anon_sym_BSLASHGlspl] = ACTIONS(6101),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6101),
    [anon_sym_BSLASHglslink] = ACTIONS(6101),
    [anon_sym_BSLASHglstext] = ACTIONS(6101),
    [anon_sym_BSLASHGlstext] = ACTIONS(6101),
    [anon_sym_BSLASHGLStext] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6101),
    [anon_sym_BSLASHglsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsname] = ACTIONS(6101),
    [anon_sym_BSLASHGlsname] = ACTIONS(6101),
    [anon_sym_BSLASHGLSname] = ACTIONS(6101),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6101),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6101),
    [anon_sym_BSLASHacrshort] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6101),
    [anon_sym_BSLASHACRshort] = ACTIONS(6101),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrlong] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6101),
    [anon_sym_BSLASHACRlong] = ACTIONS(6101),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrfull] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6101),
    [anon_sym_BSLASHACRfull] = ACTIONS(6101),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHacs] = ACTIONS(6101),
    [anon_sym_BSLASHAcs] = ACTIONS(6101),
    [anon_sym_BSLASHacsp] = ACTIONS(6101),
    [anon_sym_BSLASHAcsp] = ACTIONS(6101),
    [anon_sym_BSLASHacl] = ACTIONS(6101),
    [anon_sym_BSLASHAcl] = ACTIONS(6101),
    [anon_sym_BSLASHaclp] = ACTIONS(6101),
    [anon_sym_BSLASHAclp] = ACTIONS(6101),
    [anon_sym_BSLASHacf] = ACTIONS(6101),
    [anon_sym_BSLASHAcf] = ACTIONS(6101),
    [anon_sym_BSLASHacfp] = ACTIONS(6101),
    [anon_sym_BSLASHAcfp] = ACTIONS(6101),
    [anon_sym_BSLASHac] = ACTIONS(6101),
    [anon_sym_BSLASHAc] = ACTIONS(6101),
    [anon_sym_BSLASHacp] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6101),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6101),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6101),
    [anon_sym_BSLASHcolor] = ACTIONS(6101),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6101),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6101),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6101),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6101),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6101),
    [anon_sym_BSLASHtext] = ACTIONS(6101),
    [anon_sym_BSLASHintertext] = ACTIONS(6101),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6101),
    [anon_sym_BSLASHurl] = ACTIONS(6101),
    [anon_sym_BSLASHhref] = ACTIONS(6101),
  },
  [742] = {
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(828),
    [aux_sym__paragraph_repeat3] = STATE(828),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [743] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [744] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [745] = {
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(827),
    [aux_sym__paragraph_repeat2] = STATE(827),
    [sym_command_name] = ACTIONS(6069),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACK] = ACTIONS(6071),
    [anon_sym_COMMA] = ACTIONS(6071),
    [anon_sym_EQ] = ACTIONS(6071),
    [anon_sym_LPAREN] = ACTIONS(6071),
    [anon_sym_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHpart] = ACTIONS(6069),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddpart] = ACTIONS(6069),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHchapter] = ACTIONS(6069),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddchap] = ACTIONS(6069),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsection] = ACTIONS(6069),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHaddsec] = ACTIONS(6069),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6069),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHparagraph] = ACTIONS(6069),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(6069),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6071),
    [anon_sym_LBRACE] = ACTIONS(6071),
    [sym_word] = ACTIONS(6069),
    [sym_placeholder] = ACTIONS(6071),
    [anon_sym_PLUS] = ACTIONS(6071),
    [anon_sym_DASH] = ACTIONS(6071),
    [anon_sym_STAR] = ACTIONS(6071),
    [anon_sym_SLASH] = ACTIONS(6071),
    [anon_sym_LT] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6069),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6069),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_SQUOTE] = ACTIONS(6069),
    [anon_sym__] = ACTIONS(6071),
    [anon_sym_CARET] = ACTIONS(6071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6069),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6071),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6071),
    [anon_sym_BSLASHbegin] = ACTIONS(6069),
    [anon_sym_BSLASHtitle] = ACTIONS(6069),
    [anon_sym_BSLASHauthor] = ACTIONS(6069),
    [anon_sym_BSLASHusepackage] = ACTIONS(6069),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6069),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6069),
    [anon_sym_BSLASHinclude] = ACTIONS(6069),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6069),
    [anon_sym_BSLASHinput] = ACTIONS(6069),
    [anon_sym_BSLASHsubfile] = ACTIONS(6069),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6069),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6069),
    [anon_sym_BSLASHbibliography] = ACTIONS(6069),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6069),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6069),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6069),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6069),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6069),
    [anon_sym_BSLASHimport] = ACTIONS(6069),
    [anon_sym_BSLASHsubimport] = ACTIONS(6069),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6069),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6069),
    [anon_sym_BSLASHcaption] = ACTIONS(6069),
    [anon_sym_BSLASHcite] = ACTIONS(6069),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCite] = ACTIONS(6069),
    [anon_sym_BSLASHnocite] = ACTIONS(6069),
    [anon_sym_BSLASHcitet] = ACTIONS(6069),
    [anon_sym_BSLASHcitep] = ACTIONS(6069),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteA] = ACTIONS(6069),
    [anon_sym_BSLASHciteR] = ACTIONS(6069),
    [anon_sym_BSLASHciteS] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6069),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6069),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteyear] = ACTIONS(6069),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHcitedate] = ACTIONS(6069),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHciteurl] = ACTIONS(6069),
    [anon_sym_BSLASHfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6069),
    [anon_sym_BSLASHcitealt] = ACTIONS(6069),
    [anon_sym_BSLASHcitealp] = ACTIONS(6069),
    [anon_sym_BSLASHcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHparencite] = ACTIONS(6069),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHParencite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6069),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6069),
    [anon_sym_BSLASHtextcite] = ACTIONS(6069),
    [anon_sym_BSLASHTextcite] = ACTIONS(6069),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6069),
    [anon_sym_BSLASHsupercite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite] = ACTIONS(6069),
    [anon_sym_BSLASHAutocite] = ACTIONS(6069),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHVolcite] = ACTIONS(6069),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHavolcite] = ACTIONS(6069),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6069),
    [anon_sym_BSLASHnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHNotecite] = ACTIONS(6069),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6069),
    [anon_sym_BSLASHlabel] = ACTIONS(6069),
    [anon_sym_BSLASHref] = ACTIONS(6069),
    [anon_sym_BSLASHeqref] = ACTIONS(6069),
    [anon_sym_BSLASHvref] = ACTIONS(6069),
    [anon_sym_BSLASHVref] = ACTIONS(6069),
    [anon_sym_BSLASHautoref] = ACTIONS(6069),
    [anon_sym_BSLASHpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcref] = ACTIONS(6069),
    [anon_sym_BSLASHCref] = ACTIONS(6069),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnameCref] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6069),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6069),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6069),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6069),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6069),
    [anon_sym_BSLASHdef] = ACTIONS(6069),
    [anon_sym_BSLASHlet] = ACTIONS(6069),
    [anon_sym_BSLASHleft] = ACTIONS(6069),
    [anon_sym_BSLASHbigl] = ACTIONS(6069),
    [anon_sym_BSLASHBigl] = ACTIONS(6069),
    [anon_sym_BSLASHbiggl] = ACTIONS(6069),
    [anon_sym_BSLASHBiggl] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6069),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6069),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6069),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6069),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6069),
    [anon_sym_BSLASHgls] = ACTIONS(6069),
    [anon_sym_BSLASHGls] = ACTIONS(6069),
    [anon_sym_BSLASHGLS] = ACTIONS(6069),
    [anon_sym_BSLASHglspl] = ACTIONS(6069),
    [anon_sym_BSLASHGlspl] = ACTIONS(6069),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6069),
    [anon_sym_BSLASHglslink] = ACTIONS(6069),
    [anon_sym_BSLASHglstext] = ACTIONS(6069),
    [anon_sym_BSLASHGlstext] = ACTIONS(6069),
    [anon_sym_BSLASHGLStext] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6069),
    [anon_sym_BSLASHglsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6069),
    [anon_sym_BSLASHglsname] = ACTIONS(6069),
    [anon_sym_BSLASHGlsname] = ACTIONS(6069),
    [anon_sym_BSLASHGLSname] = ACTIONS(6069),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6069),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6069),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6069),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6069),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6069),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6069),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6069),
    [anon_sym_BSLASHacrshort] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6069),
    [anon_sym_BSLASHACRshort] = ACTIONS(6069),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrlong] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6069),
    [anon_sym_BSLASHACRlong] = ACTIONS(6069),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6069),
    [anon_sym_BSLASHacrfull] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6069),
    [anon_sym_BSLASHACRfull] = ACTIONS(6069),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHacs] = ACTIONS(6069),
    [anon_sym_BSLASHAcs] = ACTIONS(6069),
    [anon_sym_BSLASHacsp] = ACTIONS(6069),
    [anon_sym_BSLASHAcsp] = ACTIONS(6069),
    [anon_sym_BSLASHacl] = ACTIONS(6069),
    [anon_sym_BSLASHAcl] = ACTIONS(6069),
    [anon_sym_BSLASHaclp] = ACTIONS(6069),
    [anon_sym_BSLASHAclp] = ACTIONS(6069),
    [anon_sym_BSLASHacf] = ACTIONS(6069),
    [anon_sym_BSLASHAcf] = ACTIONS(6069),
    [anon_sym_BSLASHacfp] = ACTIONS(6069),
    [anon_sym_BSLASHAcfp] = ACTIONS(6069),
    [anon_sym_BSLASHac] = ACTIONS(6069),
    [anon_sym_BSLASHAc] = ACTIONS(6069),
    [anon_sym_BSLASHacp] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6069),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6069),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6069),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6069),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6069),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6069),
    [anon_sym_BSLASHcolor] = ACTIONS(6069),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6069),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6069),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6069),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6069),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6069),
    [anon_sym_BSLASHtext] = ACTIONS(6069),
    [anon_sym_BSLASHintertext] = ACTIONS(6069),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6069),
    [anon_sym_BSLASHurl] = ACTIONS(6069),
    [anon_sym_BSLASHhref] = ACTIONS(6069),
  },
  [746] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [747] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [748] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [749] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHend] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [750] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [751] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHend] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [752] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [753] = {
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(753),
    [aux_sym__section_repeat2] = STATE(753),
    [sym_command_name] = ACTIONS(5997),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_RBRACK] = ACTIONS(5999),
    [anon_sym_COMMA] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(5999),
    [anon_sym_LPAREN] = ACTIONS(5999),
    [anon_sym_RPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHpart] = ACTIONS(5997),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddpart] = ACTIONS(5997),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHchapter] = ACTIONS(6820),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6823),
    [anon_sym_BSLASHaddchap] = ACTIONS(6820),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6823),
    [anon_sym_BSLASHsection] = ACTIONS(5997),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddsec] = ACTIONS(5997),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHitem] = ACTIONS(5997),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5999),
    [anon_sym_LBRACE] = ACTIONS(5999),
    [sym_word] = ACTIONS(5997),
    [sym_placeholder] = ACTIONS(5999),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5999),
    [anon_sym_STAR] = ACTIONS(5999),
    [anon_sym_SLASH] = ACTIONS(5999),
    [anon_sym_LT] = ACTIONS(5997),
    [anon_sym_GT] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5997),
    [anon_sym_PIPE] = ACTIONS(5997),
    [anon_sym_COLON] = ACTIONS(5997),
    [anon_sym_SQUOTE] = ACTIONS(5997),
    [anon_sym__] = ACTIONS(5999),
    [anon_sym_CARET] = ACTIONS(5999),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5999),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5999),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5999),
    [anon_sym_DOLLAR] = ACTIONS(5997),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHbegin] = ACTIONS(5997),
    [anon_sym_BSLASHtitle] = ACTIONS(5997),
    [anon_sym_BSLASHauthor] = ACTIONS(5997),
    [anon_sym_BSLASHusepackage] = ACTIONS(5997),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5997),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5997),
    [anon_sym_BSLASHinclude] = ACTIONS(5997),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5997),
    [anon_sym_BSLASHinput] = ACTIONS(5997),
    [anon_sym_BSLASHsubfile] = ACTIONS(5997),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5997),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5997),
    [anon_sym_BSLASHbibliography] = ACTIONS(5997),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5997),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5997),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5997),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5997),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5997),
    [anon_sym_BSLASHimport] = ACTIONS(5997),
    [anon_sym_BSLASHsubimport] = ACTIONS(5997),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5997),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHcaption] = ACTIONS(5997),
    [anon_sym_BSLASHcite] = ACTIONS(5997),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCite] = ACTIONS(5997),
    [anon_sym_BSLASHnocite] = ACTIONS(5997),
    [anon_sym_BSLASHcitet] = ACTIONS(5997),
    [anon_sym_BSLASHcitep] = ACTIONS(5997),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteA] = ACTIONS(5997),
    [anon_sym_BSLASHciteR] = ACTIONS(5997),
    [anon_sym_BSLASHciteS] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5997),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteyear] = ACTIONS(5997),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitedate] = ACTIONS(5997),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteurl] = ACTIONS(5997),
    [anon_sym_BSLASHfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5997),
    [anon_sym_BSLASHcitealt] = ACTIONS(5997),
    [anon_sym_BSLASHcitealp] = ACTIONS(5997),
    [anon_sym_BSLASHcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHparencite] = ACTIONS(5997),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHParencite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHtextcite] = ACTIONS(5997),
    [anon_sym_BSLASHTextcite] = ACTIONS(5997),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHsupercite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite] = ACTIONS(5997),
    [anon_sym_BSLASHAutocite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHVolcite] = ACTIONS(5997),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHavolcite] = ACTIONS(5997),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHNotecite] = ACTIONS(5997),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHlabel] = ACTIONS(5997),
    [anon_sym_BSLASHref] = ACTIONS(5997),
    [anon_sym_BSLASHeqref] = ACTIONS(5997),
    [anon_sym_BSLASHvref] = ACTIONS(5997),
    [anon_sym_BSLASHVref] = ACTIONS(5997),
    [anon_sym_BSLASHautoref] = ACTIONS(5997),
    [anon_sym_BSLASHpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcref] = ACTIONS(5997),
    [anon_sym_BSLASHCref] = ACTIONS(5997),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnameCref] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHdef] = ACTIONS(5997),
    [anon_sym_BSLASHlet] = ACTIONS(5997),
    [anon_sym_BSLASHleft] = ACTIONS(5997),
    [anon_sym_BSLASHbigl] = ACTIONS(5997),
    [anon_sym_BSLASHBigl] = ACTIONS(5997),
    [anon_sym_BSLASHbiggl] = ACTIONS(5997),
    [anon_sym_BSLASHBiggl] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5997),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5997),
    [anon_sym_BSLASHgls] = ACTIONS(5997),
    [anon_sym_BSLASHGls] = ACTIONS(5997),
    [anon_sym_BSLASHGLS] = ACTIONS(5997),
    [anon_sym_BSLASHglspl] = ACTIONS(5997),
    [anon_sym_BSLASHGlspl] = ACTIONS(5997),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5997),
    [anon_sym_BSLASHglslink] = ACTIONS(5997),
    [anon_sym_BSLASHglstext] = ACTIONS(5997),
    [anon_sym_BSLASHGlstext] = ACTIONS(5997),
    [anon_sym_BSLASHGLStext] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5997),
    [anon_sym_BSLASHglsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsname] = ACTIONS(5997),
    [anon_sym_BSLASHGlsname] = ACTIONS(5997),
    [anon_sym_BSLASHGLSname] = ACTIONS(5997),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5997),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5997),
    [anon_sym_BSLASHacrshort] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5997),
    [anon_sym_BSLASHACRshort] = ACTIONS(5997),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrlong] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5997),
    [anon_sym_BSLASHACRlong] = ACTIONS(5997),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrfull] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5997),
    [anon_sym_BSLASHACRfull] = ACTIONS(5997),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHacs] = ACTIONS(5997),
    [anon_sym_BSLASHAcs] = ACTIONS(5997),
    [anon_sym_BSLASHacsp] = ACTIONS(5997),
    [anon_sym_BSLASHAcsp] = ACTIONS(5997),
    [anon_sym_BSLASHacl] = ACTIONS(5997),
    [anon_sym_BSLASHAcl] = ACTIONS(5997),
    [anon_sym_BSLASHaclp] = ACTIONS(5997),
    [anon_sym_BSLASHAclp] = ACTIONS(5997),
    [anon_sym_BSLASHacf] = ACTIONS(5997),
    [anon_sym_BSLASHAcf] = ACTIONS(5997),
    [anon_sym_BSLASHacfp] = ACTIONS(5997),
    [anon_sym_BSLASHAcfp] = ACTIONS(5997),
    [anon_sym_BSLASHac] = ACTIONS(5997),
    [anon_sym_BSLASHAc] = ACTIONS(5997),
    [anon_sym_BSLASHacp] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5997),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5997),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5997),
    [anon_sym_BSLASHcolor] = ACTIONS(5997),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5997),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5997),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5997),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5997),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5997),
    [anon_sym_BSLASHtext] = ACTIONS(5997),
    [anon_sym_BSLASHintertext] = ACTIONS(5997),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5997),
    [anon_sym_BSLASHurl] = ACTIONS(5997),
    [anon_sym_BSLASHhref] = ACTIONS(5997),
  },
  [754] = {
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(821),
    [aux_sym__section_repeat1] = STATE(821),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHaddpart] = ACTIONS(614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(616),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [755] = {
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(822),
    [aux_sym__section_repeat2] = STATE(822),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [756] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [757] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [758] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [759] = {
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(826),
    [aux_sym__paragraph_repeat1] = STATE(826),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [760] = {
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(827),
    [aux_sym__paragraph_repeat2] = STATE(827),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [761] = {
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(828),
    [aux_sym__paragraph_repeat3] = STATE(828),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [762] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [763] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(715),
    [aux_sym__section_repeat5] = STATE(715),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [764] = {
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(753),
    [aux_sym__section_repeat2] = STATE(753),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [765] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHend] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [766] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHend] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [767] = {
    [sym_curly_group] = STATE(993),
    [aux_sym_generic_command_repeat1] = STATE(767),
    [ts_builtin_sym_end] = ACTIONS(6133),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(6133),
    [anon_sym_COMMA] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHpart] = ACTIONS(6131),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddpart] = ACTIONS(6131),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHchapter] = ACTIONS(6131),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddchap] = ACTIONS(6131),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsection] = ACTIONS(6131),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddsec] = ACTIONS(6131),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHitem] = ACTIONS(6131),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(6826),
    [anon_sym_RBRACE] = ACTIONS(6133),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6133),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6133),
    [anon_sym_DOLLAR] = ACTIONS(6131),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHbegin] = ACTIONS(6131),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHleft] = ACTIONS(6131),
    [anon_sym_BSLASHbigl] = ACTIONS(6131),
    [anon_sym_BSLASHBigl] = ACTIONS(6131),
    [anon_sym_BSLASHbiggl] = ACTIONS(6131),
    [anon_sym_BSLASHBiggl] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHtext] = ACTIONS(6131),
    [anon_sym_BSLASHintertext] = ACTIONS(6131),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [768] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHend] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [769] = {
    [ts_builtin_sym_end] = ACTIONS(6115),
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(6829),
    [anon_sym_LBRACK] = ACTIONS(6115),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHpart] = ACTIONS(6111),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddpart] = ACTIONS(6111),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHchapter] = ACTIONS(6111),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddchap] = ACTIONS(6111),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsection] = ACTIONS(6111),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddsec] = ACTIONS(6111),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHitem] = ACTIONS(6111),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [anon_sym_RBRACE] = ACTIONS(6115),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6115),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6111),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHbegin] = ACTIONS(6111),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHleft] = ACTIONS(6111),
    [anon_sym_BSLASHbigl] = ACTIONS(6111),
    [anon_sym_BSLASHBigl] = ACTIONS(6111),
    [anon_sym_BSLASHbiggl] = ACTIONS(6111),
    [anon_sym_BSLASHBiggl] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHtext] = ACTIONS(6111),
    [anon_sym_BSLASHintertext] = ACTIONS(6111),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(6831),
  },
  [770] = {
    [sym__enum_itemdeclaration] = STATE(227),
    [sym_enum_item] = STATE(698),
    [aux_sym__paragraph_repeat3] = STATE(698),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(680),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(682),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHend] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [771] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHend] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [772] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHend] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [773] = {
    [sym_curly_group] = STATE(870),
    [sym_brack_group_text] = STATE(2645),
    [ts_builtin_sym_end] = ACTIONS(6109),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_LPAREN] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHpart] = ACTIONS(6105),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddpart] = ACTIONS(6105),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHchapter] = ACTIONS(6105),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddchap] = ACTIONS(6105),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsection] = ACTIONS(6105),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddsec] = ACTIONS(6105),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHitem] = ACTIONS(6105),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6109),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6109),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(6105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHbegin] = ACTIONS(6105),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHleft] = ACTIONS(6105),
    [anon_sym_BSLASHbigl] = ACTIONS(6105),
    [anon_sym_BSLASHBigl] = ACTIONS(6105),
    [anon_sym_BSLASHbiggl] = ACTIONS(6105),
    [anon_sym_BSLASHBiggl] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHtext] = ACTIONS(6105),
    [anon_sym_BSLASHintertext] = ACTIONS(6105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [774] = {
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(720),
    [aux_sym__section_repeat2] = STATE(720),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHend] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [775] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHend] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [776] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHend] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [777] = {
    [sym__enum_itemdeclaration] = STATE(230),
    [sym_enum_item] = STATE(651),
    [aux_sym__paragraph_repeat3] = STATE(651),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(608),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(610),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [778] = {
    [sym__subparagraph_declaration] = STATE(220),
    [sym_subparagraph] = STATE(650),
    [aux_sym__paragraph_repeat2] = STATE(650),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(604),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(606),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [779] = {
    [sym__paragraph_declaration] = STATE(207),
    [sym_paragraph] = STATE(649),
    [aux_sym__paragraph_repeat1] = STATE(649),
    [sym_command_name] = ACTIONS(6057),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6059),
    [anon_sym_RBRACK] = ACTIONS(6059),
    [anon_sym_COMMA] = ACTIONS(6059),
    [anon_sym_EQ] = ACTIONS(6059),
    [anon_sym_LPAREN] = ACTIONS(6059),
    [anon_sym_RPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHpart] = ACTIONS(6057),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddpart] = ACTIONS(6057),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHchapter] = ACTIONS(6057),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddchap] = ACTIONS(6057),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsection] = ACTIONS(6057),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHaddsec] = ACTIONS(6057),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6057),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHparagraph] = ACTIONS(600),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(602),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6057),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHitem] = ACTIONS(6057),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6059),
    [anon_sym_LBRACE] = ACTIONS(6059),
    [sym_word] = ACTIONS(6057),
    [sym_placeholder] = ACTIONS(6059),
    [anon_sym_PLUS] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_SLASH] = ACTIONS(6059),
    [anon_sym_LT] = ACTIONS(6057),
    [anon_sym_GT] = ACTIONS(6057),
    [anon_sym_BANG] = ACTIONS(6057),
    [anon_sym_PIPE] = ACTIONS(6057),
    [anon_sym_COLON] = ACTIONS(6057),
    [anon_sym_SQUOTE] = ACTIONS(6057),
    [anon_sym__] = ACTIONS(6059),
    [anon_sym_CARET] = ACTIONS(6059),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6059),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6059),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6059),
    [anon_sym_DOLLAR] = ACTIONS(6057),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6059),
    [anon_sym_BSLASHbegin] = ACTIONS(6057),
    [anon_sym_BSLASHtitle] = ACTIONS(6057),
    [anon_sym_BSLASHauthor] = ACTIONS(6057),
    [anon_sym_BSLASHusepackage] = ACTIONS(6057),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6057),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6057),
    [anon_sym_BSLASHinclude] = ACTIONS(6057),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6057),
    [anon_sym_BSLASHinput] = ACTIONS(6057),
    [anon_sym_BSLASHsubfile] = ACTIONS(6057),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6057),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6057),
    [anon_sym_BSLASHbibliography] = ACTIONS(6057),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6057),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6057),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6057),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6057),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6057),
    [anon_sym_BSLASHimport] = ACTIONS(6057),
    [anon_sym_BSLASHsubimport] = ACTIONS(6057),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6057),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6057),
    [anon_sym_BSLASHcaption] = ACTIONS(6057),
    [anon_sym_BSLASHcite] = ACTIONS(6057),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCite] = ACTIONS(6057),
    [anon_sym_BSLASHnocite] = ACTIONS(6057),
    [anon_sym_BSLASHcitet] = ACTIONS(6057),
    [anon_sym_BSLASHcitep] = ACTIONS(6057),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteA] = ACTIONS(6057),
    [anon_sym_BSLASHciteR] = ACTIONS(6057),
    [anon_sym_BSLASHciteS] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6057),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6057),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteyear] = ACTIONS(6057),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHcitedate] = ACTIONS(6057),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHciteurl] = ACTIONS(6057),
    [anon_sym_BSLASHfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6057),
    [anon_sym_BSLASHcitealt] = ACTIONS(6057),
    [anon_sym_BSLASHcitealp] = ACTIONS(6057),
    [anon_sym_BSLASHcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHparencite] = ACTIONS(6057),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHParencite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6057),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6057),
    [anon_sym_BSLASHtextcite] = ACTIONS(6057),
    [anon_sym_BSLASHTextcite] = ACTIONS(6057),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6057),
    [anon_sym_BSLASHsupercite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite] = ACTIONS(6057),
    [anon_sym_BSLASHAutocite] = ACTIONS(6057),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHVolcite] = ACTIONS(6057),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHavolcite] = ACTIONS(6057),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6057),
    [anon_sym_BSLASHnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHNotecite] = ACTIONS(6057),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6057),
    [anon_sym_BSLASHlabel] = ACTIONS(6057),
    [anon_sym_BSLASHref] = ACTIONS(6057),
    [anon_sym_BSLASHeqref] = ACTIONS(6057),
    [anon_sym_BSLASHvref] = ACTIONS(6057),
    [anon_sym_BSLASHVref] = ACTIONS(6057),
    [anon_sym_BSLASHautoref] = ACTIONS(6057),
    [anon_sym_BSLASHpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcref] = ACTIONS(6057),
    [anon_sym_BSLASHCref] = ACTIONS(6057),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnameCref] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6057),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6057),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6057),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6057),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6057),
    [anon_sym_BSLASHdef] = ACTIONS(6057),
    [anon_sym_BSLASHlet] = ACTIONS(6057),
    [anon_sym_BSLASHleft] = ACTIONS(6057),
    [anon_sym_BSLASHbigl] = ACTIONS(6057),
    [anon_sym_BSLASHBigl] = ACTIONS(6057),
    [anon_sym_BSLASHbiggl] = ACTIONS(6057),
    [anon_sym_BSLASHBiggl] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6057),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6057),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6057),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6057),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6057),
    [anon_sym_BSLASHgls] = ACTIONS(6057),
    [anon_sym_BSLASHGls] = ACTIONS(6057),
    [anon_sym_BSLASHGLS] = ACTIONS(6057),
    [anon_sym_BSLASHglspl] = ACTIONS(6057),
    [anon_sym_BSLASHGlspl] = ACTIONS(6057),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6057),
    [anon_sym_BSLASHglslink] = ACTIONS(6057),
    [anon_sym_BSLASHglstext] = ACTIONS(6057),
    [anon_sym_BSLASHGlstext] = ACTIONS(6057),
    [anon_sym_BSLASHGLStext] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6057),
    [anon_sym_BSLASHglsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6057),
    [anon_sym_BSLASHglsname] = ACTIONS(6057),
    [anon_sym_BSLASHGlsname] = ACTIONS(6057),
    [anon_sym_BSLASHGLSname] = ACTIONS(6057),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6057),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6057),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6057),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6057),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6057),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6057),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6057),
    [anon_sym_BSLASHacrshort] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6057),
    [anon_sym_BSLASHACRshort] = ACTIONS(6057),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrlong] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6057),
    [anon_sym_BSLASHACRlong] = ACTIONS(6057),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6057),
    [anon_sym_BSLASHacrfull] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6057),
    [anon_sym_BSLASHACRfull] = ACTIONS(6057),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHacs] = ACTIONS(6057),
    [anon_sym_BSLASHAcs] = ACTIONS(6057),
    [anon_sym_BSLASHacsp] = ACTIONS(6057),
    [anon_sym_BSLASHAcsp] = ACTIONS(6057),
    [anon_sym_BSLASHacl] = ACTIONS(6057),
    [anon_sym_BSLASHAcl] = ACTIONS(6057),
    [anon_sym_BSLASHaclp] = ACTIONS(6057),
    [anon_sym_BSLASHAclp] = ACTIONS(6057),
    [anon_sym_BSLASHacf] = ACTIONS(6057),
    [anon_sym_BSLASHAcf] = ACTIONS(6057),
    [anon_sym_BSLASHacfp] = ACTIONS(6057),
    [anon_sym_BSLASHAcfp] = ACTIONS(6057),
    [anon_sym_BSLASHac] = ACTIONS(6057),
    [anon_sym_BSLASHAc] = ACTIONS(6057),
    [anon_sym_BSLASHacp] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6057),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6057),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6057),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6057),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6059),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6057),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6057),
    [anon_sym_BSLASHcolor] = ACTIONS(6057),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6057),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6057),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6057),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6057),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6057),
    [anon_sym_BSLASHtext] = ACTIONS(6057),
    [anon_sym_BSLASHintertext] = ACTIONS(6057),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6057),
    [anon_sym_BSLASHurl] = ACTIONS(6057),
    [anon_sym_BSLASHhref] = ACTIONS(6057),
  },
  [780] = {
    [sym__subsubsection_declaration] = STATE(198),
    [sym_subsubsection] = STATE(648),
    [aux_sym__section_repeat5] = STATE(648),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(596),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(598),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [781] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHend] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [782] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(6065),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6065),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6067),
    [anon_sym_COMMA] = ACTIONS(6067),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_LPAREN] = ACTIONS(6067),
    [anon_sym_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHpart] = ACTIONS(6065),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddpart] = ACTIONS(6065),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHchapter] = ACTIONS(6065),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddchap] = ACTIONS(6065),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsection] = ACTIONS(6065),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHaddsec] = ACTIONS(6065),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsection] = ACTIONS(6065),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6065),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHitem] = ACTIONS(6065),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6067),
    [anon_sym_LBRACE] = ACTIONS(6067),
    [sym_word] = ACTIONS(6065),
    [sym_placeholder] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6065),
    [anon_sym_GT] = ACTIONS(6065),
    [anon_sym_BANG] = ACTIONS(6065),
    [anon_sym_PIPE] = ACTIONS(6065),
    [anon_sym_COLON] = ACTIONS(6065),
    [anon_sym_SQUOTE] = ACTIONS(6065),
    [anon_sym__] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6067),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6067),
    [anon_sym_DOLLAR] = ACTIONS(6065),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6067),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6067),
    [anon_sym_BSLASHbegin] = ACTIONS(6065),
    [anon_sym_BSLASHtitle] = ACTIONS(6065),
    [anon_sym_BSLASHauthor] = ACTIONS(6065),
    [anon_sym_BSLASHusepackage] = ACTIONS(6065),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6065),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6065),
    [anon_sym_BSLASHinclude] = ACTIONS(6065),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6065),
    [anon_sym_BSLASHinput] = ACTIONS(6065),
    [anon_sym_BSLASHsubfile] = ACTIONS(6065),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6065),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6065),
    [anon_sym_BSLASHbibliography] = ACTIONS(6065),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6065),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6065),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6065),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6065),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6065),
    [anon_sym_BSLASHimport] = ACTIONS(6065),
    [anon_sym_BSLASHsubimport] = ACTIONS(6065),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6065),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6065),
    [anon_sym_BSLASHcaption] = ACTIONS(6065),
    [anon_sym_BSLASHcite] = ACTIONS(6065),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCite] = ACTIONS(6065),
    [anon_sym_BSLASHnocite] = ACTIONS(6065),
    [anon_sym_BSLASHcitet] = ACTIONS(6065),
    [anon_sym_BSLASHcitep] = ACTIONS(6065),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteA] = ACTIONS(6065),
    [anon_sym_BSLASHciteR] = ACTIONS(6065),
    [anon_sym_BSLASHciteS] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6065),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6065),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteyear] = ACTIONS(6065),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHcitedate] = ACTIONS(6065),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHciteurl] = ACTIONS(6065),
    [anon_sym_BSLASHfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6065),
    [anon_sym_BSLASHcitealt] = ACTIONS(6065),
    [anon_sym_BSLASHcitealp] = ACTIONS(6065),
    [anon_sym_BSLASHcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHparencite] = ACTIONS(6065),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHParencite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6065),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6065),
    [anon_sym_BSLASHtextcite] = ACTIONS(6065),
    [anon_sym_BSLASHTextcite] = ACTIONS(6065),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6065),
    [anon_sym_BSLASHsupercite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite] = ACTIONS(6065),
    [anon_sym_BSLASHAutocite] = ACTIONS(6065),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHVolcite] = ACTIONS(6065),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHavolcite] = ACTIONS(6065),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6065),
    [anon_sym_BSLASHnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHNotecite] = ACTIONS(6065),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6065),
    [anon_sym_BSLASHlabel] = ACTIONS(6065),
    [anon_sym_BSLASHref] = ACTIONS(6065),
    [anon_sym_BSLASHeqref] = ACTIONS(6065),
    [anon_sym_BSLASHvref] = ACTIONS(6065),
    [anon_sym_BSLASHVref] = ACTIONS(6065),
    [anon_sym_BSLASHautoref] = ACTIONS(6065),
    [anon_sym_BSLASHpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcref] = ACTIONS(6065),
    [anon_sym_BSLASHCref] = ACTIONS(6065),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnameCref] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6065),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6065),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6065),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6065),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6065),
    [anon_sym_BSLASHdef] = ACTIONS(6065),
    [anon_sym_BSLASHlet] = ACTIONS(6065),
    [anon_sym_BSLASHleft] = ACTIONS(6065),
    [anon_sym_BSLASHbigl] = ACTIONS(6065),
    [anon_sym_BSLASHBigl] = ACTIONS(6065),
    [anon_sym_BSLASHbiggl] = ACTIONS(6065),
    [anon_sym_BSLASHBiggl] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6065),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6065),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6065),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6065),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6065),
    [anon_sym_BSLASHgls] = ACTIONS(6065),
    [anon_sym_BSLASHGls] = ACTIONS(6065),
    [anon_sym_BSLASHGLS] = ACTIONS(6065),
    [anon_sym_BSLASHglspl] = ACTIONS(6065),
    [anon_sym_BSLASHGlspl] = ACTIONS(6065),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6065),
    [anon_sym_BSLASHglslink] = ACTIONS(6065),
    [anon_sym_BSLASHglstext] = ACTIONS(6065),
    [anon_sym_BSLASHGlstext] = ACTIONS(6065),
    [anon_sym_BSLASHGLStext] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6065),
    [anon_sym_BSLASHglsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6065),
    [anon_sym_BSLASHglsname] = ACTIONS(6065),
    [anon_sym_BSLASHGlsname] = ACTIONS(6065),
    [anon_sym_BSLASHGLSname] = ACTIONS(6065),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6065),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6065),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6065),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6065),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6065),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6065),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6065),
    [anon_sym_BSLASHacrshort] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6065),
    [anon_sym_BSLASHACRshort] = ACTIONS(6065),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrlong] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6065),
    [anon_sym_BSLASHACRlong] = ACTIONS(6065),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6065),
    [anon_sym_BSLASHacrfull] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6065),
    [anon_sym_BSLASHACRfull] = ACTIONS(6065),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHacs] = ACTIONS(6065),
    [anon_sym_BSLASHAcs] = ACTIONS(6065),
    [anon_sym_BSLASHacsp] = ACTIONS(6065),
    [anon_sym_BSLASHAcsp] = ACTIONS(6065),
    [anon_sym_BSLASHacl] = ACTIONS(6065),
    [anon_sym_BSLASHAcl] = ACTIONS(6065),
    [anon_sym_BSLASHaclp] = ACTIONS(6065),
    [anon_sym_BSLASHAclp] = ACTIONS(6065),
    [anon_sym_BSLASHacf] = ACTIONS(6065),
    [anon_sym_BSLASHAcf] = ACTIONS(6065),
    [anon_sym_BSLASHacfp] = ACTIONS(6065),
    [anon_sym_BSLASHAcfp] = ACTIONS(6065),
    [anon_sym_BSLASHac] = ACTIONS(6065),
    [anon_sym_BSLASHAc] = ACTIONS(6065),
    [anon_sym_BSLASHacp] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6065),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6065),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6065),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6065),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6067),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6065),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6065),
    [anon_sym_BSLASHcolor] = ACTIONS(6065),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6065),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6065),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6065),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6065),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6065),
    [anon_sym_BSLASHtext] = ACTIONS(6065),
    [anon_sym_BSLASHintertext] = ACTIONS(6065),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6065),
    [anon_sym_BSLASHurl] = ACTIONS(6065),
    [anon_sym_BSLASHhref] = ACTIONS(6065),
  },
  [783] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHend] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [784] = {
    [sym__subsection_declaration] = STATE(186),
    [sym_subsection] = STATE(647),
    [aux_sym__section_repeat4] = STATE(647),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(592),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(594),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [785] = {
    [sym__section_declaration] = STATE(177),
    [sym_section] = STATE(646),
    [aux_sym__section_repeat3] = STATE(646),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(588),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(590),
    [anon_sym_BSLASHaddsec] = ACTIONS(588),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(590),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [786] = {
    [sym__chapter_declaration] = STATE(167),
    [sym_chapter] = STATE(753),
    [aux_sym__section_repeat2] = STATE(753),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(584),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(586),
    [anon_sym_BSLASHaddchap] = ACTIONS(584),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(586),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [787] = {
    [sym__part_declaration] = STATE(157),
    [sym_part] = STATE(710),
    [aux_sym__section_repeat1] = STATE(710),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(580),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHaddpart] = ACTIONS(580),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(582),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [788] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHend] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [789] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHend] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [790] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHend] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [791] = {
    [sym__section_part] = STATE(1270),
    [sym_curly_group] = STATE(1360),
    [sym_brack_group] = STATE(2965),
    [sym_command_name] = ACTIONS(6101),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6103),
    [anon_sym_COMMA] = ACTIONS(6103),
    [anon_sym_EQ] = ACTIONS(6103),
    [anon_sym_LPAREN] = ACTIONS(6103),
    [anon_sym_RPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHpart] = ACTIONS(6101),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddpart] = ACTIONS(6101),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHchapter] = ACTIONS(6101),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddchap] = ACTIONS(6101),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsection] = ACTIONS(6101),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddsec] = ACTIONS(6101),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHitem] = ACTIONS(6101),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6103),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6101),
    [sym_placeholder] = ACTIONS(6103),
    [anon_sym_PLUS] = ACTIONS(6103),
    [anon_sym_DASH] = ACTIONS(6103),
    [anon_sym_STAR] = ACTIONS(6103),
    [anon_sym_SLASH] = ACTIONS(6103),
    [anon_sym_LT] = ACTIONS(6101),
    [anon_sym_GT] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(6101),
    [anon_sym_PIPE] = ACTIONS(6101),
    [anon_sym_COLON] = ACTIONS(6101),
    [anon_sym_SQUOTE] = ACTIONS(6101),
    [anon_sym__] = ACTIONS(6103),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6103),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6103),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6103),
    [anon_sym_DOLLAR] = ACTIONS(6101),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHbegin] = ACTIONS(6101),
    [anon_sym_BSLASHtitle] = ACTIONS(6101),
    [anon_sym_BSLASHauthor] = ACTIONS(6101),
    [anon_sym_BSLASHusepackage] = ACTIONS(6101),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6101),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6101),
    [anon_sym_BSLASHinclude] = ACTIONS(6101),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6101),
    [anon_sym_BSLASHinput] = ACTIONS(6101),
    [anon_sym_BSLASHsubfile] = ACTIONS(6101),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6101),
    [anon_sym_BSLASHbibliography] = ACTIONS(6101),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6101),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6101),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6101),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6101),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6101),
    [anon_sym_BSLASHimport] = ACTIONS(6101),
    [anon_sym_BSLASHsubimport] = ACTIONS(6101),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6101),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHcaption] = ACTIONS(6101),
    [anon_sym_BSLASHcite] = ACTIONS(6101),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCite] = ACTIONS(6101),
    [anon_sym_BSLASHnocite] = ACTIONS(6101),
    [anon_sym_BSLASHcitet] = ACTIONS(6101),
    [anon_sym_BSLASHcitep] = ACTIONS(6101),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteA] = ACTIONS(6101),
    [anon_sym_BSLASHciteR] = ACTIONS(6101),
    [anon_sym_BSLASHciteS] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6101),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteyear] = ACTIONS(6101),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitedate] = ACTIONS(6101),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteurl] = ACTIONS(6101),
    [anon_sym_BSLASHfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6101),
    [anon_sym_BSLASHcitealt] = ACTIONS(6101),
    [anon_sym_BSLASHcitealp] = ACTIONS(6101),
    [anon_sym_BSLASHcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHparencite] = ACTIONS(6101),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHParencite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHtextcite] = ACTIONS(6101),
    [anon_sym_BSLASHTextcite] = ACTIONS(6101),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHsupercite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite] = ACTIONS(6101),
    [anon_sym_BSLASHAutocite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHVolcite] = ACTIONS(6101),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHavolcite] = ACTIONS(6101),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHNotecite] = ACTIONS(6101),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHlabel] = ACTIONS(6101),
    [anon_sym_BSLASHref] = ACTIONS(6101),
    [anon_sym_BSLASHeqref] = ACTIONS(6101),
    [anon_sym_BSLASHvref] = ACTIONS(6101),
    [anon_sym_BSLASHVref] = ACTIONS(6101),
    [anon_sym_BSLASHautoref] = ACTIONS(6101),
    [anon_sym_BSLASHpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcref] = ACTIONS(6101),
    [anon_sym_BSLASHCref] = ACTIONS(6101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnameCref] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHdef] = ACTIONS(6101),
    [anon_sym_BSLASHlet] = ACTIONS(6101),
    [anon_sym_BSLASHleft] = ACTIONS(6101),
    [anon_sym_BSLASHbigl] = ACTIONS(6101),
    [anon_sym_BSLASHBigl] = ACTIONS(6101),
    [anon_sym_BSLASHbiggl] = ACTIONS(6101),
    [anon_sym_BSLASHBiggl] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6101),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6101),
    [anon_sym_BSLASHgls] = ACTIONS(6101),
    [anon_sym_BSLASHGls] = ACTIONS(6101),
    [anon_sym_BSLASHGLS] = ACTIONS(6101),
    [anon_sym_BSLASHglspl] = ACTIONS(6101),
    [anon_sym_BSLASHGlspl] = ACTIONS(6101),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6101),
    [anon_sym_BSLASHglslink] = ACTIONS(6101),
    [anon_sym_BSLASHglstext] = ACTIONS(6101),
    [anon_sym_BSLASHGlstext] = ACTIONS(6101),
    [anon_sym_BSLASHGLStext] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6101),
    [anon_sym_BSLASHglsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsname] = ACTIONS(6101),
    [anon_sym_BSLASHGlsname] = ACTIONS(6101),
    [anon_sym_BSLASHGLSname] = ACTIONS(6101),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6101),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6101),
    [anon_sym_BSLASHacrshort] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6101),
    [anon_sym_BSLASHACRshort] = ACTIONS(6101),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrlong] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6101),
    [anon_sym_BSLASHACRlong] = ACTIONS(6101),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrfull] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6101),
    [anon_sym_BSLASHACRfull] = ACTIONS(6101),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHacs] = ACTIONS(6101),
    [anon_sym_BSLASHAcs] = ACTIONS(6101),
    [anon_sym_BSLASHacsp] = ACTIONS(6101),
    [anon_sym_BSLASHAcsp] = ACTIONS(6101),
    [anon_sym_BSLASHacl] = ACTIONS(6101),
    [anon_sym_BSLASHAcl] = ACTIONS(6101),
    [anon_sym_BSLASHaclp] = ACTIONS(6101),
    [anon_sym_BSLASHAclp] = ACTIONS(6101),
    [anon_sym_BSLASHacf] = ACTIONS(6101),
    [anon_sym_BSLASHAcf] = ACTIONS(6101),
    [anon_sym_BSLASHacfp] = ACTIONS(6101),
    [anon_sym_BSLASHAcfp] = ACTIONS(6101),
    [anon_sym_BSLASHac] = ACTIONS(6101),
    [anon_sym_BSLASHAc] = ACTIONS(6101),
    [anon_sym_BSLASHacp] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6101),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6101),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6101),
    [anon_sym_BSLASHcolor] = ACTIONS(6101),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6101),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6101),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6101),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6101),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6101),
    [anon_sym_BSLASHtext] = ACTIONS(6101),
    [anon_sym_BSLASHintertext] = ACTIONS(6101),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6101),
    [anon_sym_BSLASHurl] = ACTIONS(6101),
    [anon_sym_BSLASHhref] = ACTIONS(6101),
  },
  [792] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHend] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [793] = {
    [sym__section_part] = STATE(1260),
    [sym_curly_group] = STATE(1360),
    [sym_brack_group] = STATE(2965),
    [sym_command_name] = ACTIONS(6081),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6083),
    [anon_sym_COMMA] = ACTIONS(6083),
    [anon_sym_EQ] = ACTIONS(6083),
    [anon_sym_LPAREN] = ACTIONS(6083),
    [anon_sym_RPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHpart] = ACTIONS(6081),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddpart] = ACTIONS(6081),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHchapter] = ACTIONS(6081),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddchap] = ACTIONS(6081),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsection] = ACTIONS(6081),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddsec] = ACTIONS(6081),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHitem] = ACTIONS(6081),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6081),
    [sym_placeholder] = ACTIONS(6083),
    [anon_sym_PLUS] = ACTIONS(6083),
    [anon_sym_DASH] = ACTIONS(6083),
    [anon_sym_STAR] = ACTIONS(6083),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_BANG] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_SQUOTE] = ACTIONS(6081),
    [anon_sym__] = ACTIONS(6083),
    [anon_sym_CARET] = ACTIONS(6083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6083),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6083),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6083),
    [anon_sym_DOLLAR] = ACTIONS(6081),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHbegin] = ACTIONS(6081),
    [anon_sym_BSLASHtitle] = ACTIONS(6081),
    [anon_sym_BSLASHauthor] = ACTIONS(6081),
    [anon_sym_BSLASHusepackage] = ACTIONS(6081),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6081),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6081),
    [anon_sym_BSLASHinclude] = ACTIONS(6081),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6081),
    [anon_sym_BSLASHinput] = ACTIONS(6081),
    [anon_sym_BSLASHsubfile] = ACTIONS(6081),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6081),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6081),
    [anon_sym_BSLASHbibliography] = ACTIONS(6081),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6081),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6081),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6081),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6081),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6081),
    [anon_sym_BSLASHimport] = ACTIONS(6081),
    [anon_sym_BSLASHsubimport] = ACTIONS(6081),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6081),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHcaption] = ACTIONS(6081),
    [anon_sym_BSLASHcite] = ACTIONS(6081),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCite] = ACTIONS(6081),
    [anon_sym_BSLASHnocite] = ACTIONS(6081),
    [anon_sym_BSLASHcitet] = ACTIONS(6081),
    [anon_sym_BSLASHcitep] = ACTIONS(6081),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteA] = ACTIONS(6081),
    [anon_sym_BSLASHciteR] = ACTIONS(6081),
    [anon_sym_BSLASHciteS] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6081),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteyear] = ACTIONS(6081),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitedate] = ACTIONS(6081),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteurl] = ACTIONS(6081),
    [anon_sym_BSLASHfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6081),
    [anon_sym_BSLASHcitealt] = ACTIONS(6081),
    [anon_sym_BSLASHcitealp] = ACTIONS(6081),
    [anon_sym_BSLASHcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHparencite] = ACTIONS(6081),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHParencite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHtextcite] = ACTIONS(6081),
    [anon_sym_BSLASHTextcite] = ACTIONS(6081),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHsupercite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite] = ACTIONS(6081),
    [anon_sym_BSLASHAutocite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHVolcite] = ACTIONS(6081),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHavolcite] = ACTIONS(6081),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHNotecite] = ACTIONS(6081),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHlabel] = ACTIONS(6081),
    [anon_sym_BSLASHref] = ACTIONS(6081),
    [anon_sym_BSLASHeqref] = ACTIONS(6081),
    [anon_sym_BSLASHvref] = ACTIONS(6081),
    [anon_sym_BSLASHVref] = ACTIONS(6081),
    [anon_sym_BSLASHautoref] = ACTIONS(6081),
    [anon_sym_BSLASHpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcref] = ACTIONS(6081),
    [anon_sym_BSLASHCref] = ACTIONS(6081),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnameCref] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHdef] = ACTIONS(6081),
    [anon_sym_BSLASHlet] = ACTIONS(6081),
    [anon_sym_BSLASHleft] = ACTIONS(6081),
    [anon_sym_BSLASHbigl] = ACTIONS(6081),
    [anon_sym_BSLASHBigl] = ACTIONS(6081),
    [anon_sym_BSLASHbiggl] = ACTIONS(6081),
    [anon_sym_BSLASHBiggl] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6081),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6081),
    [anon_sym_BSLASHgls] = ACTIONS(6081),
    [anon_sym_BSLASHGls] = ACTIONS(6081),
    [anon_sym_BSLASHGLS] = ACTIONS(6081),
    [anon_sym_BSLASHglspl] = ACTIONS(6081),
    [anon_sym_BSLASHGlspl] = ACTIONS(6081),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6081),
    [anon_sym_BSLASHglslink] = ACTIONS(6081),
    [anon_sym_BSLASHglstext] = ACTIONS(6081),
    [anon_sym_BSLASHGlstext] = ACTIONS(6081),
    [anon_sym_BSLASHGLStext] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6081),
    [anon_sym_BSLASHglsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsname] = ACTIONS(6081),
    [anon_sym_BSLASHGlsname] = ACTIONS(6081),
    [anon_sym_BSLASHGLSname] = ACTIONS(6081),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6081),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6081),
    [anon_sym_BSLASHacrshort] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6081),
    [anon_sym_BSLASHACRshort] = ACTIONS(6081),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrlong] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6081),
    [anon_sym_BSLASHACRlong] = ACTIONS(6081),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrfull] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6081),
    [anon_sym_BSLASHACRfull] = ACTIONS(6081),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHacs] = ACTIONS(6081),
    [anon_sym_BSLASHAcs] = ACTIONS(6081),
    [anon_sym_BSLASHacsp] = ACTIONS(6081),
    [anon_sym_BSLASHAcsp] = ACTIONS(6081),
    [anon_sym_BSLASHacl] = ACTIONS(6081),
    [anon_sym_BSLASHAcl] = ACTIONS(6081),
    [anon_sym_BSLASHaclp] = ACTIONS(6081),
    [anon_sym_BSLASHAclp] = ACTIONS(6081),
    [anon_sym_BSLASHacf] = ACTIONS(6081),
    [anon_sym_BSLASHAcf] = ACTIONS(6081),
    [anon_sym_BSLASHacfp] = ACTIONS(6081),
    [anon_sym_BSLASHAcfp] = ACTIONS(6081),
    [anon_sym_BSLASHac] = ACTIONS(6081),
    [anon_sym_BSLASHAc] = ACTIONS(6081),
    [anon_sym_BSLASHacp] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6081),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6081),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6081),
    [anon_sym_BSLASHcolor] = ACTIONS(6081),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6081),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6081),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6081),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6081),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6081),
    [anon_sym_BSLASHtext] = ACTIONS(6081),
    [anon_sym_BSLASHintertext] = ACTIONS(6081),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6081),
    [anon_sym_BSLASHurl] = ACTIONS(6081),
    [anon_sym_BSLASHhref] = ACTIONS(6081),
  },
  [794] = {
    [sym__section_part] = STATE(1259),
    [sym_curly_group] = STATE(1360),
    [sym_brack_group] = STATE(2965),
    [sym_command_name] = ACTIONS(6061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(6063),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHpart] = ACTIONS(6061),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddpart] = ACTIONS(6061),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHchapter] = ACTIONS(6061),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddchap] = ACTIONS(6061),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsection] = ACTIONS(6061),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddsec] = ACTIONS(6061),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHitem] = ACTIONS(6061),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6063),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6061),
    [sym_placeholder] = ACTIONS(6063),
    [anon_sym_PLUS] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6063),
    [anon_sym_STAR] = ACTIONS(6063),
    [anon_sym_SLASH] = ACTIONS(6063),
    [anon_sym_LT] = ACTIONS(6061),
    [anon_sym_GT] = ACTIONS(6061),
    [anon_sym_BANG] = ACTIONS(6061),
    [anon_sym_PIPE] = ACTIONS(6061),
    [anon_sym_COLON] = ACTIONS(6061),
    [anon_sym_SQUOTE] = ACTIONS(6061),
    [anon_sym__] = ACTIONS(6063),
    [anon_sym_CARET] = ACTIONS(6063),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6063),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6063),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6063),
    [anon_sym_DOLLAR] = ACTIONS(6061),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHbegin] = ACTIONS(6061),
    [anon_sym_BSLASHtitle] = ACTIONS(6061),
    [anon_sym_BSLASHauthor] = ACTIONS(6061),
    [anon_sym_BSLASHusepackage] = ACTIONS(6061),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6061),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6061),
    [anon_sym_BSLASHinclude] = ACTIONS(6061),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6061),
    [anon_sym_BSLASHinput] = ACTIONS(6061),
    [anon_sym_BSLASHsubfile] = ACTIONS(6061),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6061),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6061),
    [anon_sym_BSLASHbibliography] = ACTIONS(6061),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6061),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6061),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6061),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6061),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6061),
    [anon_sym_BSLASHimport] = ACTIONS(6061),
    [anon_sym_BSLASHsubimport] = ACTIONS(6061),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6061),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHcaption] = ACTIONS(6061),
    [anon_sym_BSLASHcite] = ACTIONS(6061),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCite] = ACTIONS(6061),
    [anon_sym_BSLASHnocite] = ACTIONS(6061),
    [anon_sym_BSLASHcitet] = ACTIONS(6061),
    [anon_sym_BSLASHcitep] = ACTIONS(6061),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteA] = ACTIONS(6061),
    [anon_sym_BSLASHciteR] = ACTIONS(6061),
    [anon_sym_BSLASHciteS] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6061),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteyear] = ACTIONS(6061),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitedate] = ACTIONS(6061),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteurl] = ACTIONS(6061),
    [anon_sym_BSLASHfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6061),
    [anon_sym_BSLASHcitealt] = ACTIONS(6061),
    [anon_sym_BSLASHcitealp] = ACTIONS(6061),
    [anon_sym_BSLASHcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHparencite] = ACTIONS(6061),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHParencite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHtextcite] = ACTIONS(6061),
    [anon_sym_BSLASHTextcite] = ACTIONS(6061),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHsupercite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite] = ACTIONS(6061),
    [anon_sym_BSLASHAutocite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHVolcite] = ACTIONS(6061),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHavolcite] = ACTIONS(6061),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHNotecite] = ACTIONS(6061),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHlabel] = ACTIONS(6061),
    [anon_sym_BSLASHref] = ACTIONS(6061),
    [anon_sym_BSLASHeqref] = ACTIONS(6061),
    [anon_sym_BSLASHvref] = ACTIONS(6061),
    [anon_sym_BSLASHVref] = ACTIONS(6061),
    [anon_sym_BSLASHautoref] = ACTIONS(6061),
    [anon_sym_BSLASHpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcref] = ACTIONS(6061),
    [anon_sym_BSLASHCref] = ACTIONS(6061),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnameCref] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHdef] = ACTIONS(6061),
    [anon_sym_BSLASHlet] = ACTIONS(6061),
    [anon_sym_BSLASHleft] = ACTIONS(6061),
    [anon_sym_BSLASHbigl] = ACTIONS(6061),
    [anon_sym_BSLASHBigl] = ACTIONS(6061),
    [anon_sym_BSLASHbiggl] = ACTIONS(6061),
    [anon_sym_BSLASHBiggl] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6061),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6061),
    [anon_sym_BSLASHgls] = ACTIONS(6061),
    [anon_sym_BSLASHGls] = ACTIONS(6061),
    [anon_sym_BSLASHGLS] = ACTIONS(6061),
    [anon_sym_BSLASHglspl] = ACTIONS(6061),
    [anon_sym_BSLASHGlspl] = ACTIONS(6061),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6061),
    [anon_sym_BSLASHglslink] = ACTIONS(6061),
    [anon_sym_BSLASHglstext] = ACTIONS(6061),
    [anon_sym_BSLASHGlstext] = ACTIONS(6061),
    [anon_sym_BSLASHGLStext] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6061),
    [anon_sym_BSLASHglsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsname] = ACTIONS(6061),
    [anon_sym_BSLASHGlsname] = ACTIONS(6061),
    [anon_sym_BSLASHGLSname] = ACTIONS(6061),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6061),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6061),
    [anon_sym_BSLASHacrshort] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6061),
    [anon_sym_BSLASHACRshort] = ACTIONS(6061),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrlong] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6061),
    [anon_sym_BSLASHACRlong] = ACTIONS(6061),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrfull] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6061),
    [anon_sym_BSLASHACRfull] = ACTIONS(6061),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHacs] = ACTIONS(6061),
    [anon_sym_BSLASHAcs] = ACTIONS(6061),
    [anon_sym_BSLASHacsp] = ACTIONS(6061),
    [anon_sym_BSLASHAcsp] = ACTIONS(6061),
    [anon_sym_BSLASHacl] = ACTIONS(6061),
    [anon_sym_BSLASHAcl] = ACTIONS(6061),
    [anon_sym_BSLASHaclp] = ACTIONS(6061),
    [anon_sym_BSLASHAclp] = ACTIONS(6061),
    [anon_sym_BSLASHacf] = ACTIONS(6061),
    [anon_sym_BSLASHAcf] = ACTIONS(6061),
    [anon_sym_BSLASHacfp] = ACTIONS(6061),
    [anon_sym_BSLASHAcfp] = ACTIONS(6061),
    [anon_sym_BSLASHac] = ACTIONS(6061),
    [anon_sym_BSLASHAc] = ACTIONS(6061),
    [anon_sym_BSLASHacp] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6061),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6061),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6061),
    [anon_sym_BSLASHcolor] = ACTIONS(6061),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6061),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6061),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6061),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6061),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6061),
    [anon_sym_BSLASHtext] = ACTIONS(6061),
    [anon_sym_BSLASHintertext] = ACTIONS(6061),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6061),
    [anon_sym_BSLASHurl] = ACTIONS(6061),
    [anon_sym_BSLASHhref] = ACTIONS(6061),
  },
  [795] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHend] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [796] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [797] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [798] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHend] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [799] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHend] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [800] = {
    [sym__section_part] = STATE(1356),
    [sym_curly_group] = STATE(1360),
    [sym_brack_group] = STATE(2965),
    [sym_command_name] = ACTIONS(5983),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5983),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5985),
    [anon_sym_COMMA] = ACTIONS(5985),
    [anon_sym_EQ] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(5985),
    [anon_sym_RPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHpart] = ACTIONS(5983),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddpart] = ACTIONS(5983),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHchapter] = ACTIONS(5983),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddchap] = ACTIONS(5983),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsection] = ACTIONS(5983),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddsec] = ACTIONS(5983),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHitem] = ACTIONS(5983),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(5983),
    [sym_placeholder] = ACTIONS(5985),
    [anon_sym_PLUS] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(5985),
    [anon_sym_SLASH] = ACTIONS(5985),
    [anon_sym_LT] = ACTIONS(5983),
    [anon_sym_GT] = ACTIONS(5983),
    [anon_sym_BANG] = ACTIONS(5983),
    [anon_sym_PIPE] = ACTIONS(5983),
    [anon_sym_COLON] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(5983),
    [anon_sym__] = ACTIONS(5985),
    [anon_sym_CARET] = ACTIONS(5985),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5985),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5985),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5985),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHbegin] = ACTIONS(5983),
    [anon_sym_BSLASHtitle] = ACTIONS(5983),
    [anon_sym_BSLASHauthor] = ACTIONS(5983),
    [anon_sym_BSLASHusepackage] = ACTIONS(5983),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5983),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5983),
    [anon_sym_BSLASHinclude] = ACTIONS(5983),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5983),
    [anon_sym_BSLASHinput] = ACTIONS(5983),
    [anon_sym_BSLASHsubfile] = ACTIONS(5983),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5983),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5983),
    [anon_sym_BSLASHbibliography] = ACTIONS(5983),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5983),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5983),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5983),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5983),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5983),
    [anon_sym_BSLASHimport] = ACTIONS(5983),
    [anon_sym_BSLASHsubimport] = ACTIONS(5983),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5983),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHcaption] = ACTIONS(5983),
    [anon_sym_BSLASHcite] = ACTIONS(5983),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCite] = ACTIONS(5983),
    [anon_sym_BSLASHnocite] = ACTIONS(5983),
    [anon_sym_BSLASHcitet] = ACTIONS(5983),
    [anon_sym_BSLASHcitep] = ACTIONS(5983),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteA] = ACTIONS(5983),
    [anon_sym_BSLASHciteR] = ACTIONS(5983),
    [anon_sym_BSLASHciteS] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5983),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteyear] = ACTIONS(5983),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitedate] = ACTIONS(5983),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteurl] = ACTIONS(5983),
    [anon_sym_BSLASHfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5983),
    [anon_sym_BSLASHcitealt] = ACTIONS(5983),
    [anon_sym_BSLASHcitealp] = ACTIONS(5983),
    [anon_sym_BSLASHcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHparencite] = ACTIONS(5983),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHParencite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHtextcite] = ACTIONS(5983),
    [anon_sym_BSLASHTextcite] = ACTIONS(5983),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHsupercite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite] = ACTIONS(5983),
    [anon_sym_BSLASHAutocite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHVolcite] = ACTIONS(5983),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHavolcite] = ACTIONS(5983),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHNotecite] = ACTIONS(5983),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHlabel] = ACTIONS(5983),
    [anon_sym_BSLASHref] = ACTIONS(5983),
    [anon_sym_BSLASHeqref] = ACTIONS(5983),
    [anon_sym_BSLASHvref] = ACTIONS(5983),
    [anon_sym_BSLASHVref] = ACTIONS(5983),
    [anon_sym_BSLASHautoref] = ACTIONS(5983),
    [anon_sym_BSLASHpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcref] = ACTIONS(5983),
    [anon_sym_BSLASHCref] = ACTIONS(5983),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnameCref] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHdef] = ACTIONS(5983),
    [anon_sym_BSLASHlet] = ACTIONS(5983),
    [anon_sym_BSLASHleft] = ACTIONS(5983),
    [anon_sym_BSLASHbigl] = ACTIONS(5983),
    [anon_sym_BSLASHBigl] = ACTIONS(5983),
    [anon_sym_BSLASHbiggl] = ACTIONS(5983),
    [anon_sym_BSLASHBiggl] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5983),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5983),
    [anon_sym_BSLASHgls] = ACTIONS(5983),
    [anon_sym_BSLASHGls] = ACTIONS(5983),
    [anon_sym_BSLASHGLS] = ACTIONS(5983),
    [anon_sym_BSLASHglspl] = ACTIONS(5983),
    [anon_sym_BSLASHGlspl] = ACTIONS(5983),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5983),
    [anon_sym_BSLASHglslink] = ACTIONS(5983),
    [anon_sym_BSLASHglstext] = ACTIONS(5983),
    [anon_sym_BSLASHGlstext] = ACTIONS(5983),
    [anon_sym_BSLASHGLStext] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5983),
    [anon_sym_BSLASHglsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsname] = ACTIONS(5983),
    [anon_sym_BSLASHGlsname] = ACTIONS(5983),
    [anon_sym_BSLASHGLSname] = ACTIONS(5983),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5983),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5983),
    [anon_sym_BSLASHacrshort] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5983),
    [anon_sym_BSLASHACRshort] = ACTIONS(5983),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrlong] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5983),
    [anon_sym_BSLASHACRlong] = ACTIONS(5983),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrfull] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5983),
    [anon_sym_BSLASHACRfull] = ACTIONS(5983),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHacs] = ACTIONS(5983),
    [anon_sym_BSLASHAcs] = ACTIONS(5983),
    [anon_sym_BSLASHacsp] = ACTIONS(5983),
    [anon_sym_BSLASHAcsp] = ACTIONS(5983),
    [anon_sym_BSLASHacl] = ACTIONS(5983),
    [anon_sym_BSLASHAcl] = ACTIONS(5983),
    [anon_sym_BSLASHaclp] = ACTIONS(5983),
    [anon_sym_BSLASHAclp] = ACTIONS(5983),
    [anon_sym_BSLASHacf] = ACTIONS(5983),
    [anon_sym_BSLASHAcf] = ACTIONS(5983),
    [anon_sym_BSLASHacfp] = ACTIONS(5983),
    [anon_sym_BSLASHAcfp] = ACTIONS(5983),
    [anon_sym_BSLASHac] = ACTIONS(5983),
    [anon_sym_BSLASHAc] = ACTIONS(5983),
    [anon_sym_BSLASHacp] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5983),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5983),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5983),
    [anon_sym_BSLASHcolor] = ACTIONS(5983),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5983),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5983),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5983),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5983),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5983),
    [anon_sym_BSLASHtext] = ACTIONS(5983),
    [anon_sym_BSLASHintertext] = ACTIONS(5983),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5983),
    [anon_sym_BSLASHurl] = ACTIONS(5983),
    [anon_sym_BSLASHhref] = ACTIONS(5983),
  },
  [801] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHend] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [802] = {
    [sym__section_part] = STATE(1276),
    [sym_curly_group] = STATE(1360),
    [sym_brack_group] = STATE(2965),
    [sym_command_name] = ACTIONS(5979),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5979),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5981),
    [anon_sym_COMMA] = ACTIONS(5981),
    [anon_sym_EQ] = ACTIONS(5981),
    [anon_sym_LPAREN] = ACTIONS(5981),
    [anon_sym_RPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHpart] = ACTIONS(5979),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddpart] = ACTIONS(5979),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHchapter] = ACTIONS(5979),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddchap] = ACTIONS(5979),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsection] = ACTIONS(5979),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddsec] = ACTIONS(5979),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHitem] = ACTIONS(5979),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5981),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(5979),
    [sym_placeholder] = ACTIONS(5981),
    [anon_sym_PLUS] = ACTIONS(5981),
    [anon_sym_DASH] = ACTIONS(5981),
    [anon_sym_STAR] = ACTIONS(5981),
    [anon_sym_SLASH] = ACTIONS(5981),
    [anon_sym_LT] = ACTIONS(5979),
    [anon_sym_GT] = ACTIONS(5979),
    [anon_sym_BANG] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5979),
    [anon_sym_SQUOTE] = ACTIONS(5979),
    [anon_sym__] = ACTIONS(5981),
    [anon_sym_CARET] = ACTIONS(5981),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5981),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5981),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5979),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHbegin] = ACTIONS(5979),
    [anon_sym_BSLASHtitle] = ACTIONS(5979),
    [anon_sym_BSLASHauthor] = ACTIONS(5979),
    [anon_sym_BSLASHusepackage] = ACTIONS(5979),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5979),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5979),
    [anon_sym_BSLASHinclude] = ACTIONS(5979),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5979),
    [anon_sym_BSLASHinput] = ACTIONS(5979),
    [anon_sym_BSLASHsubfile] = ACTIONS(5979),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5979),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5979),
    [anon_sym_BSLASHbibliography] = ACTIONS(5979),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5979),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5979),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5979),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5979),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5979),
    [anon_sym_BSLASHimport] = ACTIONS(5979),
    [anon_sym_BSLASHsubimport] = ACTIONS(5979),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5979),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHcaption] = ACTIONS(5979),
    [anon_sym_BSLASHcite] = ACTIONS(5979),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCite] = ACTIONS(5979),
    [anon_sym_BSLASHnocite] = ACTIONS(5979),
    [anon_sym_BSLASHcitet] = ACTIONS(5979),
    [anon_sym_BSLASHcitep] = ACTIONS(5979),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteA] = ACTIONS(5979),
    [anon_sym_BSLASHciteR] = ACTIONS(5979),
    [anon_sym_BSLASHciteS] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5979),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteyear] = ACTIONS(5979),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitedate] = ACTIONS(5979),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteurl] = ACTIONS(5979),
    [anon_sym_BSLASHfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5979),
    [anon_sym_BSLASHcitealt] = ACTIONS(5979),
    [anon_sym_BSLASHcitealp] = ACTIONS(5979),
    [anon_sym_BSLASHcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHparencite] = ACTIONS(5979),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHParencite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHtextcite] = ACTIONS(5979),
    [anon_sym_BSLASHTextcite] = ACTIONS(5979),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHsupercite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite] = ACTIONS(5979),
    [anon_sym_BSLASHAutocite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHVolcite] = ACTIONS(5979),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHavolcite] = ACTIONS(5979),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHNotecite] = ACTIONS(5979),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHlabel] = ACTIONS(5979),
    [anon_sym_BSLASHref] = ACTIONS(5979),
    [anon_sym_BSLASHeqref] = ACTIONS(5979),
    [anon_sym_BSLASHvref] = ACTIONS(5979),
    [anon_sym_BSLASHVref] = ACTIONS(5979),
    [anon_sym_BSLASHautoref] = ACTIONS(5979),
    [anon_sym_BSLASHpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcref] = ACTIONS(5979),
    [anon_sym_BSLASHCref] = ACTIONS(5979),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnameCref] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHdef] = ACTIONS(5979),
    [anon_sym_BSLASHlet] = ACTIONS(5979),
    [anon_sym_BSLASHleft] = ACTIONS(5979),
    [anon_sym_BSLASHbigl] = ACTIONS(5979),
    [anon_sym_BSLASHBigl] = ACTIONS(5979),
    [anon_sym_BSLASHbiggl] = ACTIONS(5979),
    [anon_sym_BSLASHBiggl] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5979),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5979),
    [anon_sym_BSLASHgls] = ACTIONS(5979),
    [anon_sym_BSLASHGls] = ACTIONS(5979),
    [anon_sym_BSLASHGLS] = ACTIONS(5979),
    [anon_sym_BSLASHglspl] = ACTIONS(5979),
    [anon_sym_BSLASHGlspl] = ACTIONS(5979),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5979),
    [anon_sym_BSLASHglslink] = ACTIONS(5979),
    [anon_sym_BSLASHglstext] = ACTIONS(5979),
    [anon_sym_BSLASHGlstext] = ACTIONS(5979),
    [anon_sym_BSLASHGLStext] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5979),
    [anon_sym_BSLASHglsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsname] = ACTIONS(5979),
    [anon_sym_BSLASHGlsname] = ACTIONS(5979),
    [anon_sym_BSLASHGLSname] = ACTIONS(5979),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5979),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5979),
    [anon_sym_BSLASHacrshort] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5979),
    [anon_sym_BSLASHACRshort] = ACTIONS(5979),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrlong] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5979),
    [anon_sym_BSLASHACRlong] = ACTIONS(5979),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrfull] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5979),
    [anon_sym_BSLASHACRfull] = ACTIONS(5979),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHacs] = ACTIONS(5979),
    [anon_sym_BSLASHAcs] = ACTIONS(5979),
    [anon_sym_BSLASHacsp] = ACTIONS(5979),
    [anon_sym_BSLASHAcsp] = ACTIONS(5979),
    [anon_sym_BSLASHacl] = ACTIONS(5979),
    [anon_sym_BSLASHAcl] = ACTIONS(5979),
    [anon_sym_BSLASHaclp] = ACTIONS(5979),
    [anon_sym_BSLASHAclp] = ACTIONS(5979),
    [anon_sym_BSLASHacf] = ACTIONS(5979),
    [anon_sym_BSLASHAcf] = ACTIONS(5979),
    [anon_sym_BSLASHacfp] = ACTIONS(5979),
    [anon_sym_BSLASHAcfp] = ACTIONS(5979),
    [anon_sym_BSLASHac] = ACTIONS(5979),
    [anon_sym_BSLASHAc] = ACTIONS(5979),
    [anon_sym_BSLASHacp] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5979),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5979),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5979),
    [anon_sym_BSLASHcolor] = ACTIONS(5979),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5979),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5979),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5979),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5979),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5979),
    [anon_sym_BSLASHtext] = ACTIONS(5979),
    [anon_sym_BSLASHintertext] = ACTIONS(5979),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5979),
    [anon_sym_BSLASHurl] = ACTIONS(5979),
    [anon_sym_BSLASHhref] = ACTIONS(5979),
  },
  [803] = {
    [sym_curly_group] = STATE(863),
    [sym_brack_group_text] = STATE(3009),
    [ts_builtin_sym_end] = ACTIONS(6129),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6129),
    [anon_sym_COMMA] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_LPAREN] = ACTIONS(6129),
    [anon_sym_RPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHpart] = ACTIONS(6127),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddpart] = ACTIONS(6127),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHchapter] = ACTIONS(6127),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddchap] = ACTIONS(6127),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsection] = ACTIONS(6127),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddsec] = ACTIONS(6127),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHitem] = ACTIONS(6127),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6129),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6129),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHbegin] = ACTIONS(6127),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHleft] = ACTIONS(6127),
    [anon_sym_BSLASHbigl] = ACTIONS(6127),
    [anon_sym_BSLASHBigl] = ACTIONS(6127),
    [anon_sym_BSLASHbiggl] = ACTIONS(6127),
    [anon_sym_BSLASHBiggl] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHtext] = ACTIONS(6127),
    [anon_sym_BSLASHintertext] = ACTIONS(6127),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [804] = {
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(822),
    [aux_sym__section_repeat2] = STATE(822),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [805] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [806] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [807] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(2132),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2134),
    [anon_sym_RBRACK] = ACTIONS(2134),
    [anon_sym_COMMA] = ACTIONS(2134),
    [anon_sym_EQ] = ACTIONS(2134),
    [anon_sym_LPAREN] = ACTIONS(2134),
    [anon_sym_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHpart] = ACTIONS(2132),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddpart] = ACTIONS(2132),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHchapter] = ACTIONS(2132),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddchap] = ACTIONS(2132),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsection] = ACTIONS(2132),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHaddsec] = ACTIONS(2132),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsection] = ACTIONS(2132),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2132),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHitem] = ACTIONS(2132),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2134),
    [anon_sym_LBRACE] = ACTIONS(2134),
    [sym_word] = ACTIONS(2132),
    [sym_placeholder] = ACTIONS(2134),
    [anon_sym_PLUS] = ACTIONS(2134),
    [anon_sym_DASH] = ACTIONS(2134),
    [anon_sym_STAR] = ACTIONS(2134),
    [anon_sym_SLASH] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_GT] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_COLON] = ACTIONS(2132),
    [anon_sym_SQUOTE] = ACTIONS(2132),
    [anon_sym__] = ACTIONS(2134),
    [anon_sym_CARET] = ACTIONS(2134),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2134),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2134),
    [anon_sym_DOLLAR] = ACTIONS(2132),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2134),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2134),
    [anon_sym_BSLASHbegin] = ACTIONS(2132),
    [anon_sym_BSLASHtitle] = ACTIONS(2132),
    [anon_sym_BSLASHauthor] = ACTIONS(2132),
    [anon_sym_BSLASHusepackage] = ACTIONS(2132),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2132),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2132),
    [anon_sym_BSLASHinclude] = ACTIONS(2132),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2132),
    [anon_sym_BSLASHinput] = ACTIONS(2132),
    [anon_sym_BSLASHsubfile] = ACTIONS(2132),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2132),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2132),
    [anon_sym_BSLASHbibliography] = ACTIONS(2132),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2132),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2132),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2132),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2132),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2132),
    [anon_sym_BSLASHimport] = ACTIONS(2132),
    [anon_sym_BSLASHsubimport] = ACTIONS(2132),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2132),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2132),
    [anon_sym_BSLASHcaption] = ACTIONS(2132),
    [anon_sym_BSLASHcite] = ACTIONS(2132),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCite] = ACTIONS(2132),
    [anon_sym_BSLASHnocite] = ACTIONS(2132),
    [anon_sym_BSLASHcitet] = ACTIONS(2132),
    [anon_sym_BSLASHcitep] = ACTIONS(2132),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteA] = ACTIONS(2132),
    [anon_sym_BSLASHciteR] = ACTIONS(2132),
    [anon_sym_BSLASHciteS] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2132),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2132),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteyear] = ACTIONS(2132),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHcitedate] = ACTIONS(2132),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHciteurl] = ACTIONS(2132),
    [anon_sym_BSLASHfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2132),
    [anon_sym_BSLASHcitealt] = ACTIONS(2132),
    [anon_sym_BSLASHcitealp] = ACTIONS(2132),
    [anon_sym_BSLASHcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHparencite] = ACTIONS(2132),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHParencite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2132),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2132),
    [anon_sym_BSLASHtextcite] = ACTIONS(2132),
    [anon_sym_BSLASHTextcite] = ACTIONS(2132),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2132),
    [anon_sym_BSLASHsupercite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite] = ACTIONS(2132),
    [anon_sym_BSLASHAutocite] = ACTIONS(2132),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHVolcite] = ACTIONS(2132),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHavolcite] = ACTIONS(2132),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2132),
    [anon_sym_BSLASHnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHNotecite] = ACTIONS(2132),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2132),
    [anon_sym_BSLASHlabel] = ACTIONS(2132),
    [anon_sym_BSLASHref] = ACTIONS(2132),
    [anon_sym_BSLASHeqref] = ACTIONS(2132),
    [anon_sym_BSLASHvref] = ACTIONS(2132),
    [anon_sym_BSLASHVref] = ACTIONS(2132),
    [anon_sym_BSLASHautoref] = ACTIONS(2132),
    [anon_sym_BSLASHpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcref] = ACTIONS(2132),
    [anon_sym_BSLASHCref] = ACTIONS(2132),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnameCref] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2132),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2132),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2132),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2132),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2132),
    [anon_sym_BSLASHdef] = ACTIONS(2132),
    [anon_sym_BSLASHlet] = ACTIONS(2132),
    [anon_sym_BSLASHleft] = ACTIONS(2132),
    [anon_sym_BSLASHbigl] = ACTIONS(2132),
    [anon_sym_BSLASHBigl] = ACTIONS(2132),
    [anon_sym_BSLASHbiggl] = ACTIONS(2132),
    [anon_sym_BSLASHBiggl] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2132),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2132),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2132),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2132),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2132),
    [anon_sym_BSLASHgls] = ACTIONS(2132),
    [anon_sym_BSLASHGls] = ACTIONS(2132),
    [anon_sym_BSLASHGLS] = ACTIONS(2132),
    [anon_sym_BSLASHglspl] = ACTIONS(2132),
    [anon_sym_BSLASHGlspl] = ACTIONS(2132),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2132),
    [anon_sym_BSLASHglslink] = ACTIONS(2132),
    [anon_sym_BSLASHglstext] = ACTIONS(2132),
    [anon_sym_BSLASHGlstext] = ACTIONS(2132),
    [anon_sym_BSLASHGLStext] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2132),
    [anon_sym_BSLASHglsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2132),
    [anon_sym_BSLASHglsname] = ACTIONS(2132),
    [anon_sym_BSLASHGlsname] = ACTIONS(2132),
    [anon_sym_BSLASHGLSname] = ACTIONS(2132),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2132),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2132),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2132),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2132),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2132),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2132),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2132),
    [anon_sym_BSLASHacrshort] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2132),
    [anon_sym_BSLASHACRshort] = ACTIONS(2132),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrlong] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2132),
    [anon_sym_BSLASHACRlong] = ACTIONS(2132),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2132),
    [anon_sym_BSLASHacrfull] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2132),
    [anon_sym_BSLASHACRfull] = ACTIONS(2132),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHacs] = ACTIONS(2132),
    [anon_sym_BSLASHAcs] = ACTIONS(2132),
    [anon_sym_BSLASHacsp] = ACTIONS(2132),
    [anon_sym_BSLASHAcsp] = ACTIONS(2132),
    [anon_sym_BSLASHacl] = ACTIONS(2132),
    [anon_sym_BSLASHAcl] = ACTIONS(2132),
    [anon_sym_BSLASHaclp] = ACTIONS(2132),
    [anon_sym_BSLASHAclp] = ACTIONS(2132),
    [anon_sym_BSLASHacf] = ACTIONS(2132),
    [anon_sym_BSLASHAcf] = ACTIONS(2132),
    [anon_sym_BSLASHacfp] = ACTIONS(2132),
    [anon_sym_BSLASHAcfp] = ACTIONS(2132),
    [anon_sym_BSLASHac] = ACTIONS(2132),
    [anon_sym_BSLASHAc] = ACTIONS(2132),
    [anon_sym_BSLASHacp] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2132),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2132),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2132),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2132),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2134),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2132),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2132),
    [anon_sym_BSLASHcolor] = ACTIONS(2132),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2132),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2132),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2132),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2132),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2132),
    [anon_sym_BSLASHtext] = ACTIONS(2132),
    [anon_sym_BSLASHintertext] = ACTIONS(2132),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2132),
    [anon_sym_BSLASHurl] = ACTIONS(2132),
    [anon_sym_BSLASHhref] = ACTIONS(2132),
  },
  [808] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [809] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [810] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(2144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2146),
    [anon_sym_RBRACK] = ACTIONS(2146),
    [anon_sym_COMMA] = ACTIONS(2146),
    [anon_sym_EQ] = ACTIONS(2146),
    [anon_sym_LPAREN] = ACTIONS(2146),
    [anon_sym_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHpart] = ACTIONS(2144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddpart] = ACTIONS(2144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHchapter] = ACTIONS(2144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddchap] = ACTIONS(2144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsection] = ACTIONS(2144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHaddsec] = ACTIONS(2144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsection] = ACTIONS(2144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHitem] = ACTIONS(2144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(2146),
    [sym_word] = ACTIONS(2144),
    [sym_placeholder] = ACTIONS(2146),
    [anon_sym_PLUS] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2146),
    [anon_sym_STAR] = ACTIONS(2146),
    [anon_sym_SLASH] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_GT] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_SQUOTE] = ACTIONS(2144),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_CARET] = ACTIONS(2146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2146),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2146),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2146),
    [anon_sym_BSLASHbegin] = ACTIONS(2144),
    [anon_sym_BSLASHtitle] = ACTIONS(2144),
    [anon_sym_BSLASHauthor] = ACTIONS(2144),
    [anon_sym_BSLASHusepackage] = ACTIONS(2144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2144),
    [anon_sym_BSLASHinclude] = ACTIONS(2144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2144),
    [anon_sym_BSLASHinput] = ACTIONS(2144),
    [anon_sym_BSLASHsubfile] = ACTIONS(2144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2144),
    [anon_sym_BSLASHbibliography] = ACTIONS(2144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2144),
    [anon_sym_BSLASHimport] = ACTIONS(2144),
    [anon_sym_BSLASHsubimport] = ACTIONS(2144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2144),
    [anon_sym_BSLASHcaption] = ACTIONS(2144),
    [anon_sym_BSLASHcite] = ACTIONS(2144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCite] = ACTIONS(2144),
    [anon_sym_BSLASHnocite] = ACTIONS(2144),
    [anon_sym_BSLASHcitet] = ACTIONS(2144),
    [anon_sym_BSLASHcitep] = ACTIONS(2144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteA] = ACTIONS(2144),
    [anon_sym_BSLASHciteR] = ACTIONS(2144),
    [anon_sym_BSLASHciteS] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteyear] = ACTIONS(2144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHcitedate] = ACTIONS(2144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHciteurl] = ACTIONS(2144),
    [anon_sym_BSLASHfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2144),
    [anon_sym_BSLASHcitealt] = ACTIONS(2144),
    [anon_sym_BSLASHcitealp] = ACTIONS(2144),
    [anon_sym_BSLASHcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHparencite] = ACTIONS(2144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHParencite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2144),
    [anon_sym_BSLASHtextcite] = ACTIONS(2144),
    [anon_sym_BSLASHTextcite] = ACTIONS(2144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2144),
    [anon_sym_BSLASHsupercite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite] = ACTIONS(2144),
    [anon_sym_BSLASHAutocite] = ACTIONS(2144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHVolcite] = ACTIONS(2144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHavolcite] = ACTIONS(2144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2144),
    [anon_sym_BSLASHnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHNotecite] = ACTIONS(2144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2144),
    [anon_sym_BSLASHlabel] = ACTIONS(2144),
    [anon_sym_BSLASHref] = ACTIONS(2144),
    [anon_sym_BSLASHeqref] = ACTIONS(2144),
    [anon_sym_BSLASHvref] = ACTIONS(2144),
    [anon_sym_BSLASHVref] = ACTIONS(2144),
    [anon_sym_BSLASHautoref] = ACTIONS(2144),
    [anon_sym_BSLASHpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcref] = ACTIONS(2144),
    [anon_sym_BSLASHCref] = ACTIONS(2144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnameCref] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2144),
    [anon_sym_BSLASHdef] = ACTIONS(2144),
    [anon_sym_BSLASHlet] = ACTIONS(2144),
    [anon_sym_BSLASHleft] = ACTIONS(2144),
    [anon_sym_BSLASHbigl] = ACTIONS(2144),
    [anon_sym_BSLASHBigl] = ACTIONS(2144),
    [anon_sym_BSLASHbiggl] = ACTIONS(2144),
    [anon_sym_BSLASHBiggl] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2144),
    [anon_sym_BSLASHgls] = ACTIONS(2144),
    [anon_sym_BSLASHGls] = ACTIONS(2144),
    [anon_sym_BSLASHGLS] = ACTIONS(2144),
    [anon_sym_BSLASHglspl] = ACTIONS(2144),
    [anon_sym_BSLASHGlspl] = ACTIONS(2144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2144),
    [anon_sym_BSLASHglslink] = ACTIONS(2144),
    [anon_sym_BSLASHglstext] = ACTIONS(2144),
    [anon_sym_BSLASHGlstext] = ACTIONS(2144),
    [anon_sym_BSLASHGLStext] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2144),
    [anon_sym_BSLASHglsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2144),
    [anon_sym_BSLASHglsname] = ACTIONS(2144),
    [anon_sym_BSLASHGlsname] = ACTIONS(2144),
    [anon_sym_BSLASHGLSname] = ACTIONS(2144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2144),
    [anon_sym_BSLASHacrshort] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2144),
    [anon_sym_BSLASHACRshort] = ACTIONS(2144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrlong] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2144),
    [anon_sym_BSLASHACRlong] = ACTIONS(2144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2144),
    [anon_sym_BSLASHacrfull] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2144),
    [anon_sym_BSLASHACRfull] = ACTIONS(2144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHacs] = ACTIONS(2144),
    [anon_sym_BSLASHAcs] = ACTIONS(2144),
    [anon_sym_BSLASHacsp] = ACTIONS(2144),
    [anon_sym_BSLASHAcsp] = ACTIONS(2144),
    [anon_sym_BSLASHacl] = ACTIONS(2144),
    [anon_sym_BSLASHAcl] = ACTIONS(2144),
    [anon_sym_BSLASHaclp] = ACTIONS(2144),
    [anon_sym_BSLASHAclp] = ACTIONS(2144),
    [anon_sym_BSLASHacf] = ACTIONS(2144),
    [anon_sym_BSLASHAcf] = ACTIONS(2144),
    [anon_sym_BSLASHacfp] = ACTIONS(2144),
    [anon_sym_BSLASHAcfp] = ACTIONS(2144),
    [anon_sym_BSLASHac] = ACTIONS(2144),
    [anon_sym_BSLASHAc] = ACTIONS(2144),
    [anon_sym_BSLASHacp] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2144),
    [anon_sym_BSLASHcolor] = ACTIONS(2144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2144),
    [anon_sym_BSLASHtext] = ACTIONS(2144),
    [anon_sym_BSLASHintertext] = ACTIONS(2144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2144),
    [anon_sym_BSLASHurl] = ACTIONS(2144),
    [anon_sym_BSLASHhref] = ACTIONS(2144),
  },
  [811] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHend] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [812] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [813] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(2172),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2174),
    [anon_sym_RBRACK] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [anon_sym_EQ] = ACTIONS(2174),
    [anon_sym_LPAREN] = ACTIONS(2174),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHpart] = ACTIONS(2172),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddpart] = ACTIONS(2172),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHchapter] = ACTIONS(2172),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddchap] = ACTIONS(2172),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsection] = ACTIONS(2172),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHaddsec] = ACTIONS(2172),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsection] = ACTIONS(2172),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2172),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHitem] = ACTIONS(2172),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2174),
    [anon_sym_LBRACE] = ACTIONS(2174),
    [sym_word] = ACTIONS(2172),
    [sym_placeholder] = ACTIONS(2174),
    [anon_sym_PLUS] = ACTIONS(2174),
    [anon_sym_DASH] = ACTIONS(2174),
    [anon_sym_STAR] = ACTIONS(2174),
    [anon_sym_SLASH] = ACTIONS(2174),
    [anon_sym_LT] = ACTIONS(2172),
    [anon_sym_GT] = ACTIONS(2172),
    [anon_sym_BANG] = ACTIONS(2172),
    [anon_sym_PIPE] = ACTIONS(2172),
    [anon_sym_COLON] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2172),
    [anon_sym__] = ACTIONS(2174),
    [anon_sym_CARET] = ACTIONS(2174),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2174),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2172),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2174),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2174),
    [anon_sym_BSLASHbegin] = ACTIONS(2172),
    [anon_sym_BSLASHtitle] = ACTIONS(2172),
    [anon_sym_BSLASHauthor] = ACTIONS(2172),
    [anon_sym_BSLASHusepackage] = ACTIONS(2172),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2172),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2172),
    [anon_sym_BSLASHinclude] = ACTIONS(2172),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2172),
    [anon_sym_BSLASHinput] = ACTIONS(2172),
    [anon_sym_BSLASHsubfile] = ACTIONS(2172),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2172),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2172),
    [anon_sym_BSLASHbibliography] = ACTIONS(2172),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2172),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2172),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2172),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2172),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2172),
    [anon_sym_BSLASHimport] = ACTIONS(2172),
    [anon_sym_BSLASHsubimport] = ACTIONS(2172),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2172),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2172),
    [anon_sym_BSLASHcaption] = ACTIONS(2172),
    [anon_sym_BSLASHcite] = ACTIONS(2172),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCite] = ACTIONS(2172),
    [anon_sym_BSLASHnocite] = ACTIONS(2172),
    [anon_sym_BSLASHcitet] = ACTIONS(2172),
    [anon_sym_BSLASHcitep] = ACTIONS(2172),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteA] = ACTIONS(2172),
    [anon_sym_BSLASHciteR] = ACTIONS(2172),
    [anon_sym_BSLASHciteS] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2172),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2172),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteyear] = ACTIONS(2172),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHcitedate] = ACTIONS(2172),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHciteurl] = ACTIONS(2172),
    [anon_sym_BSLASHfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2172),
    [anon_sym_BSLASHcitealt] = ACTIONS(2172),
    [anon_sym_BSLASHcitealp] = ACTIONS(2172),
    [anon_sym_BSLASHcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHparencite] = ACTIONS(2172),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHParencite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2172),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2172),
    [anon_sym_BSLASHtextcite] = ACTIONS(2172),
    [anon_sym_BSLASHTextcite] = ACTIONS(2172),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2172),
    [anon_sym_BSLASHsupercite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite] = ACTIONS(2172),
    [anon_sym_BSLASHAutocite] = ACTIONS(2172),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHVolcite] = ACTIONS(2172),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHavolcite] = ACTIONS(2172),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2172),
    [anon_sym_BSLASHnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHNotecite] = ACTIONS(2172),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2172),
    [anon_sym_BSLASHlabel] = ACTIONS(2172),
    [anon_sym_BSLASHref] = ACTIONS(2172),
    [anon_sym_BSLASHeqref] = ACTIONS(2172),
    [anon_sym_BSLASHvref] = ACTIONS(2172),
    [anon_sym_BSLASHVref] = ACTIONS(2172),
    [anon_sym_BSLASHautoref] = ACTIONS(2172),
    [anon_sym_BSLASHpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcref] = ACTIONS(2172),
    [anon_sym_BSLASHCref] = ACTIONS(2172),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnameCref] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2172),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2172),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2172),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2172),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2172),
    [anon_sym_BSLASHdef] = ACTIONS(2172),
    [anon_sym_BSLASHlet] = ACTIONS(2172),
    [anon_sym_BSLASHleft] = ACTIONS(2172),
    [anon_sym_BSLASHbigl] = ACTIONS(2172),
    [anon_sym_BSLASHBigl] = ACTIONS(2172),
    [anon_sym_BSLASHbiggl] = ACTIONS(2172),
    [anon_sym_BSLASHBiggl] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2172),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2172),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2172),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2172),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2172),
    [anon_sym_BSLASHgls] = ACTIONS(2172),
    [anon_sym_BSLASHGls] = ACTIONS(2172),
    [anon_sym_BSLASHGLS] = ACTIONS(2172),
    [anon_sym_BSLASHglspl] = ACTIONS(2172),
    [anon_sym_BSLASHGlspl] = ACTIONS(2172),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2172),
    [anon_sym_BSLASHglslink] = ACTIONS(2172),
    [anon_sym_BSLASHglstext] = ACTIONS(2172),
    [anon_sym_BSLASHGlstext] = ACTIONS(2172),
    [anon_sym_BSLASHGLStext] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2172),
    [anon_sym_BSLASHglsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2172),
    [anon_sym_BSLASHglsname] = ACTIONS(2172),
    [anon_sym_BSLASHGlsname] = ACTIONS(2172),
    [anon_sym_BSLASHGLSname] = ACTIONS(2172),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2172),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2172),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2172),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2172),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2172),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2172),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2172),
    [anon_sym_BSLASHacrshort] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2172),
    [anon_sym_BSLASHACRshort] = ACTIONS(2172),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrlong] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2172),
    [anon_sym_BSLASHACRlong] = ACTIONS(2172),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2172),
    [anon_sym_BSLASHacrfull] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2172),
    [anon_sym_BSLASHACRfull] = ACTIONS(2172),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHacs] = ACTIONS(2172),
    [anon_sym_BSLASHAcs] = ACTIONS(2172),
    [anon_sym_BSLASHacsp] = ACTIONS(2172),
    [anon_sym_BSLASHAcsp] = ACTIONS(2172),
    [anon_sym_BSLASHacl] = ACTIONS(2172),
    [anon_sym_BSLASHAcl] = ACTIONS(2172),
    [anon_sym_BSLASHaclp] = ACTIONS(2172),
    [anon_sym_BSLASHAclp] = ACTIONS(2172),
    [anon_sym_BSLASHacf] = ACTIONS(2172),
    [anon_sym_BSLASHAcf] = ACTIONS(2172),
    [anon_sym_BSLASHacfp] = ACTIONS(2172),
    [anon_sym_BSLASHAcfp] = ACTIONS(2172),
    [anon_sym_BSLASHac] = ACTIONS(2172),
    [anon_sym_BSLASHAc] = ACTIONS(2172),
    [anon_sym_BSLASHacp] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2172),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2172),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2172),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2172),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2174),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2172),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2172),
    [anon_sym_BSLASHcolor] = ACTIONS(2172),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2172),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2172),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2172),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2172),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2172),
    [anon_sym_BSLASHtext] = ACTIONS(2172),
    [anon_sym_BSLASHintertext] = ACTIONS(2172),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2172),
    [anon_sym_BSLASHurl] = ACTIONS(2172),
    [anon_sym_BSLASHhref] = ACTIONS(2172),
  },
  [814] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(782),
    [aux_sym__section_repeat5] = STATE(782),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [815] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [816] = {
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(827),
    [aux_sym__paragraph_repeat2] = STATE(827),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(640),
    [anon_sym_BSLASHitem] = ACTIONS(2232),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2234),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [817] = {
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(828),
    [aux_sym__paragraph_repeat3] = STATE(828),
    [sym_command_name] = ACTIONS(2232),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2232),
    [anon_sym_LBRACK] = ACTIONS(2234),
    [anon_sym_RBRACK] = ACTIONS(2234),
    [anon_sym_COMMA] = ACTIONS(2234),
    [anon_sym_EQ] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2234),
    [anon_sym_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHpart] = ACTIONS(2232),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddpart] = ACTIONS(2232),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHchapter] = ACTIONS(2232),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddchap] = ACTIONS(2232),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsection] = ACTIONS(2232),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHaddsec] = ACTIONS(2232),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2232),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2232),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(2234),
    [sym_word] = ACTIONS(2232),
    [sym_placeholder] = ACTIONS(2234),
    [anon_sym_PLUS] = ACTIONS(2234),
    [anon_sym_DASH] = ACTIONS(2234),
    [anon_sym_STAR] = ACTIONS(2234),
    [anon_sym_SLASH] = ACTIONS(2234),
    [anon_sym_LT] = ACTIONS(2232),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2234),
    [anon_sym_CARET] = ACTIONS(2234),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2234),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2234),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2234),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2234),
    [anon_sym_BSLASHbegin] = ACTIONS(2232),
    [anon_sym_BSLASHtitle] = ACTIONS(2232),
    [anon_sym_BSLASHauthor] = ACTIONS(2232),
    [anon_sym_BSLASHusepackage] = ACTIONS(2232),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2232),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2232),
    [anon_sym_BSLASHinclude] = ACTIONS(2232),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2232),
    [anon_sym_BSLASHinput] = ACTIONS(2232),
    [anon_sym_BSLASHsubfile] = ACTIONS(2232),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2232),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2232),
    [anon_sym_BSLASHbibliography] = ACTIONS(2232),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2232),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2232),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2232),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2232),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2232),
    [anon_sym_BSLASHimport] = ACTIONS(2232),
    [anon_sym_BSLASHsubimport] = ACTIONS(2232),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2232),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2232),
    [anon_sym_BSLASHcaption] = ACTIONS(2232),
    [anon_sym_BSLASHcite] = ACTIONS(2232),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCite] = ACTIONS(2232),
    [anon_sym_BSLASHnocite] = ACTIONS(2232),
    [anon_sym_BSLASHcitet] = ACTIONS(2232),
    [anon_sym_BSLASHcitep] = ACTIONS(2232),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteA] = ACTIONS(2232),
    [anon_sym_BSLASHciteR] = ACTIONS(2232),
    [anon_sym_BSLASHciteS] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2232),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2232),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteyear] = ACTIONS(2232),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHcitedate] = ACTIONS(2232),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHciteurl] = ACTIONS(2232),
    [anon_sym_BSLASHfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2232),
    [anon_sym_BSLASHcitealt] = ACTIONS(2232),
    [anon_sym_BSLASHcitealp] = ACTIONS(2232),
    [anon_sym_BSLASHcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHparencite] = ACTIONS(2232),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHParencite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2232),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2232),
    [anon_sym_BSLASHtextcite] = ACTIONS(2232),
    [anon_sym_BSLASHTextcite] = ACTIONS(2232),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2232),
    [anon_sym_BSLASHsupercite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite] = ACTIONS(2232),
    [anon_sym_BSLASHAutocite] = ACTIONS(2232),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHVolcite] = ACTIONS(2232),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHavolcite] = ACTIONS(2232),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2232),
    [anon_sym_BSLASHnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHNotecite] = ACTIONS(2232),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2232),
    [anon_sym_BSLASHlabel] = ACTIONS(2232),
    [anon_sym_BSLASHref] = ACTIONS(2232),
    [anon_sym_BSLASHeqref] = ACTIONS(2232),
    [anon_sym_BSLASHvref] = ACTIONS(2232),
    [anon_sym_BSLASHVref] = ACTIONS(2232),
    [anon_sym_BSLASHautoref] = ACTIONS(2232),
    [anon_sym_BSLASHpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcref] = ACTIONS(2232),
    [anon_sym_BSLASHCref] = ACTIONS(2232),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnameCref] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2232),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2232),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2232),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2232),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2232),
    [anon_sym_BSLASHdef] = ACTIONS(2232),
    [anon_sym_BSLASHlet] = ACTIONS(2232),
    [anon_sym_BSLASHleft] = ACTIONS(2232),
    [anon_sym_BSLASHbigl] = ACTIONS(2232),
    [anon_sym_BSLASHBigl] = ACTIONS(2232),
    [anon_sym_BSLASHbiggl] = ACTIONS(2232),
    [anon_sym_BSLASHBiggl] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2232),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2232),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2232),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2232),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2232),
    [anon_sym_BSLASHgls] = ACTIONS(2232),
    [anon_sym_BSLASHGls] = ACTIONS(2232),
    [anon_sym_BSLASHGLS] = ACTIONS(2232),
    [anon_sym_BSLASHglspl] = ACTIONS(2232),
    [anon_sym_BSLASHGlspl] = ACTIONS(2232),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2232),
    [anon_sym_BSLASHglslink] = ACTIONS(2232),
    [anon_sym_BSLASHglstext] = ACTIONS(2232),
    [anon_sym_BSLASHGlstext] = ACTIONS(2232),
    [anon_sym_BSLASHGLStext] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2232),
    [anon_sym_BSLASHglsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2232),
    [anon_sym_BSLASHglsname] = ACTIONS(2232),
    [anon_sym_BSLASHGlsname] = ACTIONS(2232),
    [anon_sym_BSLASHGLSname] = ACTIONS(2232),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2232),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2232),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2232),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2232),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2232),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2232),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2232),
    [anon_sym_BSLASHacrshort] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2232),
    [anon_sym_BSLASHACRshort] = ACTIONS(2232),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrlong] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2232),
    [anon_sym_BSLASHACRlong] = ACTIONS(2232),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2232),
    [anon_sym_BSLASHacrfull] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2232),
    [anon_sym_BSLASHACRfull] = ACTIONS(2232),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHacs] = ACTIONS(2232),
    [anon_sym_BSLASHAcs] = ACTIONS(2232),
    [anon_sym_BSLASHacsp] = ACTIONS(2232),
    [anon_sym_BSLASHAcsp] = ACTIONS(2232),
    [anon_sym_BSLASHacl] = ACTIONS(2232),
    [anon_sym_BSLASHAcl] = ACTIONS(2232),
    [anon_sym_BSLASHaclp] = ACTIONS(2232),
    [anon_sym_BSLASHAclp] = ACTIONS(2232),
    [anon_sym_BSLASHacf] = ACTIONS(2232),
    [anon_sym_BSLASHAcf] = ACTIONS(2232),
    [anon_sym_BSLASHacfp] = ACTIONS(2232),
    [anon_sym_BSLASHAcfp] = ACTIONS(2232),
    [anon_sym_BSLASHac] = ACTIONS(2232),
    [anon_sym_BSLASHAc] = ACTIONS(2232),
    [anon_sym_BSLASHacp] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2232),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2232),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2232),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2232),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2234),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2232),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2232),
    [anon_sym_BSLASHcolor] = ACTIONS(2232),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2232),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2232),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2232),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2232),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2232),
    [anon_sym_BSLASHtext] = ACTIONS(2232),
    [anon_sym_BSLASHintertext] = ACTIONS(2232),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2232),
    [anon_sym_BSLASHurl] = ACTIONS(2232),
    [anon_sym_BSLASHhref] = ACTIONS(2232),
  },
  [818] = {
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(828),
    [aux_sym__paragraph_repeat3] = STATE(828),
    [sym_command_name] = ACTIONS(2250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2250),
    [anon_sym_LBRACK] = ACTIONS(2252),
    [anon_sym_RBRACK] = ACTIONS(2252),
    [anon_sym_COMMA] = ACTIONS(2252),
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_RPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHpart] = ACTIONS(2250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddpart] = ACTIONS(2250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHchapter] = ACTIONS(2250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddchap] = ACTIONS(2250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsection] = ACTIONS(2250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHaddsec] = ACTIONS(2250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHitem] = ACTIONS(642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(644),
    [anon_sym_LBRACE] = ACTIONS(2252),
    [sym_word] = ACTIONS(2250),
    [sym_placeholder] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2252),
    [anon_sym_SLASH] = ACTIONS(2252),
    [anon_sym_LT] = ACTIONS(2250),
    [anon_sym_GT] = ACTIONS(2250),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_PIPE] = ACTIONS(2250),
    [anon_sym_COLON] = ACTIONS(2250),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [anon_sym__] = ACTIONS(2252),
    [anon_sym_CARET] = ACTIONS(2252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2252),
    [anon_sym_DOLLAR] = ACTIONS(2250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2252),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2252),
    [anon_sym_BSLASHbegin] = ACTIONS(2250),
    [anon_sym_BSLASHtitle] = ACTIONS(2250),
    [anon_sym_BSLASHauthor] = ACTIONS(2250),
    [anon_sym_BSLASHusepackage] = ACTIONS(2250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2250),
    [anon_sym_BSLASHinclude] = ACTIONS(2250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2250),
    [anon_sym_BSLASHinput] = ACTIONS(2250),
    [anon_sym_BSLASHsubfile] = ACTIONS(2250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2250),
    [anon_sym_BSLASHbibliography] = ACTIONS(2250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2250),
    [anon_sym_BSLASHimport] = ACTIONS(2250),
    [anon_sym_BSLASHsubimport] = ACTIONS(2250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2250),
    [anon_sym_BSLASHcaption] = ACTIONS(2250),
    [anon_sym_BSLASHcite] = ACTIONS(2250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCite] = ACTIONS(2250),
    [anon_sym_BSLASHnocite] = ACTIONS(2250),
    [anon_sym_BSLASHcitet] = ACTIONS(2250),
    [anon_sym_BSLASHcitep] = ACTIONS(2250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteA] = ACTIONS(2250),
    [anon_sym_BSLASHciteR] = ACTIONS(2250),
    [anon_sym_BSLASHciteS] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteyear] = ACTIONS(2250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHcitedate] = ACTIONS(2250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHciteurl] = ACTIONS(2250),
    [anon_sym_BSLASHfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2250),
    [anon_sym_BSLASHcitealt] = ACTIONS(2250),
    [anon_sym_BSLASHcitealp] = ACTIONS(2250),
    [anon_sym_BSLASHcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHparencite] = ACTIONS(2250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHParencite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2250),
    [anon_sym_BSLASHtextcite] = ACTIONS(2250),
    [anon_sym_BSLASHTextcite] = ACTIONS(2250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2250),
    [anon_sym_BSLASHsupercite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite] = ACTIONS(2250),
    [anon_sym_BSLASHAutocite] = ACTIONS(2250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHVolcite] = ACTIONS(2250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHavolcite] = ACTIONS(2250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2250),
    [anon_sym_BSLASHnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHNotecite] = ACTIONS(2250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2250),
    [anon_sym_BSLASHlabel] = ACTIONS(2250),
    [anon_sym_BSLASHref] = ACTIONS(2250),
    [anon_sym_BSLASHeqref] = ACTIONS(2250),
    [anon_sym_BSLASHvref] = ACTIONS(2250),
    [anon_sym_BSLASHVref] = ACTIONS(2250),
    [anon_sym_BSLASHautoref] = ACTIONS(2250),
    [anon_sym_BSLASHpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcref] = ACTIONS(2250),
    [anon_sym_BSLASHCref] = ACTIONS(2250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnameCref] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2250),
    [anon_sym_BSLASHdef] = ACTIONS(2250),
    [anon_sym_BSLASHlet] = ACTIONS(2250),
    [anon_sym_BSLASHleft] = ACTIONS(2250),
    [anon_sym_BSLASHbigl] = ACTIONS(2250),
    [anon_sym_BSLASHBigl] = ACTIONS(2250),
    [anon_sym_BSLASHbiggl] = ACTIONS(2250),
    [anon_sym_BSLASHBiggl] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2250),
    [anon_sym_BSLASHgls] = ACTIONS(2250),
    [anon_sym_BSLASHGls] = ACTIONS(2250),
    [anon_sym_BSLASHGLS] = ACTIONS(2250),
    [anon_sym_BSLASHglspl] = ACTIONS(2250),
    [anon_sym_BSLASHGlspl] = ACTIONS(2250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2250),
    [anon_sym_BSLASHglslink] = ACTIONS(2250),
    [anon_sym_BSLASHglstext] = ACTIONS(2250),
    [anon_sym_BSLASHGlstext] = ACTIONS(2250),
    [anon_sym_BSLASHGLStext] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2250),
    [anon_sym_BSLASHglsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2250),
    [anon_sym_BSLASHglsname] = ACTIONS(2250),
    [anon_sym_BSLASHGlsname] = ACTIONS(2250),
    [anon_sym_BSLASHGLSname] = ACTIONS(2250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2250),
    [anon_sym_BSLASHacrshort] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2250),
    [anon_sym_BSLASHACRshort] = ACTIONS(2250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrlong] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2250),
    [anon_sym_BSLASHACRlong] = ACTIONS(2250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2250),
    [anon_sym_BSLASHacrfull] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2250),
    [anon_sym_BSLASHACRfull] = ACTIONS(2250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHacs] = ACTIONS(2250),
    [anon_sym_BSLASHAcs] = ACTIONS(2250),
    [anon_sym_BSLASHacsp] = ACTIONS(2250),
    [anon_sym_BSLASHAcsp] = ACTIONS(2250),
    [anon_sym_BSLASHacl] = ACTIONS(2250),
    [anon_sym_BSLASHAcl] = ACTIONS(2250),
    [anon_sym_BSLASHaclp] = ACTIONS(2250),
    [anon_sym_BSLASHAclp] = ACTIONS(2250),
    [anon_sym_BSLASHacf] = ACTIONS(2250),
    [anon_sym_BSLASHAcf] = ACTIONS(2250),
    [anon_sym_BSLASHacfp] = ACTIONS(2250),
    [anon_sym_BSLASHAcfp] = ACTIONS(2250),
    [anon_sym_BSLASHac] = ACTIONS(2250),
    [anon_sym_BSLASHAc] = ACTIONS(2250),
    [anon_sym_BSLASHacp] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2250),
    [anon_sym_BSLASHcolor] = ACTIONS(2250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2250),
    [anon_sym_BSLASHtext] = ACTIONS(2250),
    [anon_sym_BSLASHintertext] = ACTIONS(2250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2250),
    [anon_sym_BSLASHurl] = ACTIONS(2250),
    [anon_sym_BSLASHhref] = ACTIONS(2250),
  },
  [819] = {
    [sym__section_part] = STATE(1274),
    [sym_curly_group] = STATE(1360),
    [sym_brack_group] = STATE(2965),
    [sym_command_name] = ACTIONS(5975),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5975),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5977),
    [anon_sym_EQ] = ACTIONS(5977),
    [anon_sym_LPAREN] = ACTIONS(5977),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHpart] = ACTIONS(5975),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddpart] = ACTIONS(5975),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHchapter] = ACTIONS(5975),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddchap] = ACTIONS(5975),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsection] = ACTIONS(5975),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddsec] = ACTIONS(5975),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHitem] = ACTIONS(5975),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5977),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(5975),
    [sym_placeholder] = ACTIONS(5977),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_STAR] = ACTIONS(5977),
    [anon_sym_SLASH] = ACTIONS(5977),
    [anon_sym_LT] = ACTIONS(5975),
    [anon_sym_GT] = ACTIONS(5975),
    [anon_sym_BANG] = ACTIONS(5975),
    [anon_sym_PIPE] = ACTIONS(5975),
    [anon_sym_COLON] = ACTIONS(5975),
    [anon_sym_SQUOTE] = ACTIONS(5975),
    [anon_sym__] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5977),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5977),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5977),
    [anon_sym_DOLLAR] = ACTIONS(5975),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHbegin] = ACTIONS(5975),
    [anon_sym_BSLASHtitle] = ACTIONS(5975),
    [anon_sym_BSLASHauthor] = ACTIONS(5975),
    [anon_sym_BSLASHusepackage] = ACTIONS(5975),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5975),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5975),
    [anon_sym_BSLASHinclude] = ACTIONS(5975),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5975),
    [anon_sym_BSLASHinput] = ACTIONS(5975),
    [anon_sym_BSLASHsubfile] = ACTIONS(5975),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5975),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5975),
    [anon_sym_BSLASHbibliography] = ACTIONS(5975),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5975),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5975),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5975),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5975),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5975),
    [anon_sym_BSLASHimport] = ACTIONS(5975),
    [anon_sym_BSLASHsubimport] = ACTIONS(5975),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5975),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHcaption] = ACTIONS(5975),
    [anon_sym_BSLASHcite] = ACTIONS(5975),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCite] = ACTIONS(5975),
    [anon_sym_BSLASHnocite] = ACTIONS(5975),
    [anon_sym_BSLASHcitet] = ACTIONS(5975),
    [anon_sym_BSLASHcitep] = ACTIONS(5975),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteA] = ACTIONS(5975),
    [anon_sym_BSLASHciteR] = ACTIONS(5975),
    [anon_sym_BSLASHciteS] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5975),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteyear] = ACTIONS(5975),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitedate] = ACTIONS(5975),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteurl] = ACTIONS(5975),
    [anon_sym_BSLASHfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5975),
    [anon_sym_BSLASHcitealt] = ACTIONS(5975),
    [anon_sym_BSLASHcitealp] = ACTIONS(5975),
    [anon_sym_BSLASHcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHparencite] = ACTIONS(5975),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHParencite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHtextcite] = ACTIONS(5975),
    [anon_sym_BSLASHTextcite] = ACTIONS(5975),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHsupercite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite] = ACTIONS(5975),
    [anon_sym_BSLASHAutocite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHVolcite] = ACTIONS(5975),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHavolcite] = ACTIONS(5975),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHNotecite] = ACTIONS(5975),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHlabel] = ACTIONS(5975),
    [anon_sym_BSLASHref] = ACTIONS(5975),
    [anon_sym_BSLASHeqref] = ACTIONS(5975),
    [anon_sym_BSLASHvref] = ACTIONS(5975),
    [anon_sym_BSLASHVref] = ACTIONS(5975),
    [anon_sym_BSLASHautoref] = ACTIONS(5975),
    [anon_sym_BSLASHpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcref] = ACTIONS(5975),
    [anon_sym_BSLASHCref] = ACTIONS(5975),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnameCref] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHdef] = ACTIONS(5975),
    [anon_sym_BSLASHlet] = ACTIONS(5975),
    [anon_sym_BSLASHleft] = ACTIONS(5975),
    [anon_sym_BSLASHbigl] = ACTIONS(5975),
    [anon_sym_BSLASHBigl] = ACTIONS(5975),
    [anon_sym_BSLASHbiggl] = ACTIONS(5975),
    [anon_sym_BSLASHBiggl] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5975),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5975),
    [anon_sym_BSLASHgls] = ACTIONS(5975),
    [anon_sym_BSLASHGls] = ACTIONS(5975),
    [anon_sym_BSLASHGLS] = ACTIONS(5975),
    [anon_sym_BSLASHglspl] = ACTIONS(5975),
    [anon_sym_BSLASHGlspl] = ACTIONS(5975),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5975),
    [anon_sym_BSLASHglslink] = ACTIONS(5975),
    [anon_sym_BSLASHglstext] = ACTIONS(5975),
    [anon_sym_BSLASHGlstext] = ACTIONS(5975),
    [anon_sym_BSLASHGLStext] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5975),
    [anon_sym_BSLASHglsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsname] = ACTIONS(5975),
    [anon_sym_BSLASHGlsname] = ACTIONS(5975),
    [anon_sym_BSLASHGLSname] = ACTIONS(5975),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5975),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5975),
    [anon_sym_BSLASHacrshort] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5975),
    [anon_sym_BSLASHACRshort] = ACTIONS(5975),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrlong] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5975),
    [anon_sym_BSLASHACRlong] = ACTIONS(5975),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrfull] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5975),
    [anon_sym_BSLASHACRfull] = ACTIONS(5975),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHacs] = ACTIONS(5975),
    [anon_sym_BSLASHAcs] = ACTIONS(5975),
    [anon_sym_BSLASHacsp] = ACTIONS(5975),
    [anon_sym_BSLASHAcsp] = ACTIONS(5975),
    [anon_sym_BSLASHacl] = ACTIONS(5975),
    [anon_sym_BSLASHAcl] = ACTIONS(5975),
    [anon_sym_BSLASHaclp] = ACTIONS(5975),
    [anon_sym_BSLASHAclp] = ACTIONS(5975),
    [anon_sym_BSLASHacf] = ACTIONS(5975),
    [anon_sym_BSLASHAcf] = ACTIONS(5975),
    [anon_sym_BSLASHacfp] = ACTIONS(5975),
    [anon_sym_BSLASHAcfp] = ACTIONS(5975),
    [anon_sym_BSLASHac] = ACTIONS(5975),
    [anon_sym_BSLASHAc] = ACTIONS(5975),
    [anon_sym_BSLASHacp] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5975),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5975),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5975),
    [anon_sym_BSLASHcolor] = ACTIONS(5975),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5975),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5975),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5975),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5975),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5975),
    [anon_sym_BSLASHtext] = ACTIONS(5975),
    [anon_sym_BSLASHintertext] = ACTIONS(5975),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5975),
    [anon_sym_BSLASHurl] = ACTIONS(5975),
    [anon_sym_BSLASHhref] = ACTIONS(5975),
  },
  [820] = {
    [sym__section_part] = STATE(1361),
    [sym_curly_group] = STATE(1360),
    [sym_brack_group] = STATE(2965),
    [sym_command_name] = ACTIONS(5971),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5971),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5973),
    [anon_sym_COMMA] = ACTIONS(5973),
    [anon_sym_EQ] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(5973),
    [anon_sym_RPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHpart] = ACTIONS(5971),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddpart] = ACTIONS(5971),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHchapter] = ACTIONS(5971),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddchap] = ACTIONS(5971),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsection] = ACTIONS(5971),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddsec] = ACTIONS(5971),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHitem] = ACTIONS(5971),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5973),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(5971),
    [sym_placeholder] = ACTIONS(5973),
    [anon_sym_PLUS] = ACTIONS(5973),
    [anon_sym_DASH] = ACTIONS(5973),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5973),
    [anon_sym_LT] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5971),
    [anon_sym_BANG] = ACTIONS(5971),
    [anon_sym_PIPE] = ACTIONS(5971),
    [anon_sym_COLON] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(5971),
    [anon_sym__] = ACTIONS(5973),
    [anon_sym_CARET] = ACTIONS(5973),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5973),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5973),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(5973),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHbegin] = ACTIONS(5971),
    [anon_sym_BSLASHtitle] = ACTIONS(5971),
    [anon_sym_BSLASHauthor] = ACTIONS(5971),
    [anon_sym_BSLASHusepackage] = ACTIONS(5971),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5971),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5971),
    [anon_sym_BSLASHinclude] = ACTIONS(5971),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5971),
    [anon_sym_BSLASHinput] = ACTIONS(5971),
    [anon_sym_BSLASHsubfile] = ACTIONS(5971),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5971),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5971),
    [anon_sym_BSLASHbibliography] = ACTIONS(5971),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5971),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5971),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5971),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5971),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5971),
    [anon_sym_BSLASHimport] = ACTIONS(5971),
    [anon_sym_BSLASHsubimport] = ACTIONS(5971),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5971),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHcaption] = ACTIONS(5971),
    [anon_sym_BSLASHcite] = ACTIONS(5971),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCite] = ACTIONS(5971),
    [anon_sym_BSLASHnocite] = ACTIONS(5971),
    [anon_sym_BSLASHcitet] = ACTIONS(5971),
    [anon_sym_BSLASHcitep] = ACTIONS(5971),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteA] = ACTIONS(5971),
    [anon_sym_BSLASHciteR] = ACTIONS(5971),
    [anon_sym_BSLASHciteS] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5971),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteyear] = ACTIONS(5971),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitedate] = ACTIONS(5971),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteurl] = ACTIONS(5971),
    [anon_sym_BSLASHfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5971),
    [anon_sym_BSLASHcitealt] = ACTIONS(5971),
    [anon_sym_BSLASHcitealp] = ACTIONS(5971),
    [anon_sym_BSLASHcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHparencite] = ACTIONS(5971),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHParencite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHtextcite] = ACTIONS(5971),
    [anon_sym_BSLASHTextcite] = ACTIONS(5971),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHsupercite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite] = ACTIONS(5971),
    [anon_sym_BSLASHAutocite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHVolcite] = ACTIONS(5971),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHavolcite] = ACTIONS(5971),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHNotecite] = ACTIONS(5971),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHlabel] = ACTIONS(5971),
    [anon_sym_BSLASHref] = ACTIONS(5971),
    [anon_sym_BSLASHeqref] = ACTIONS(5971),
    [anon_sym_BSLASHvref] = ACTIONS(5971),
    [anon_sym_BSLASHVref] = ACTIONS(5971),
    [anon_sym_BSLASHautoref] = ACTIONS(5971),
    [anon_sym_BSLASHpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcref] = ACTIONS(5971),
    [anon_sym_BSLASHCref] = ACTIONS(5971),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnameCref] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHdef] = ACTIONS(5971),
    [anon_sym_BSLASHlet] = ACTIONS(5971),
    [anon_sym_BSLASHleft] = ACTIONS(5971),
    [anon_sym_BSLASHbigl] = ACTIONS(5971),
    [anon_sym_BSLASHBigl] = ACTIONS(5971),
    [anon_sym_BSLASHbiggl] = ACTIONS(5971),
    [anon_sym_BSLASHBiggl] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5971),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5971),
    [anon_sym_BSLASHgls] = ACTIONS(5971),
    [anon_sym_BSLASHGls] = ACTIONS(5971),
    [anon_sym_BSLASHGLS] = ACTIONS(5971),
    [anon_sym_BSLASHglspl] = ACTIONS(5971),
    [anon_sym_BSLASHGlspl] = ACTIONS(5971),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5971),
    [anon_sym_BSLASHglslink] = ACTIONS(5971),
    [anon_sym_BSLASHglstext] = ACTIONS(5971),
    [anon_sym_BSLASHGlstext] = ACTIONS(5971),
    [anon_sym_BSLASHGLStext] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5971),
    [anon_sym_BSLASHglsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsname] = ACTIONS(5971),
    [anon_sym_BSLASHGlsname] = ACTIONS(5971),
    [anon_sym_BSLASHGLSname] = ACTIONS(5971),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5971),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5971),
    [anon_sym_BSLASHacrshort] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5971),
    [anon_sym_BSLASHACRshort] = ACTIONS(5971),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrlong] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5971),
    [anon_sym_BSLASHACRlong] = ACTIONS(5971),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrfull] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5971),
    [anon_sym_BSLASHACRfull] = ACTIONS(5971),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHacs] = ACTIONS(5971),
    [anon_sym_BSLASHAcs] = ACTIONS(5971),
    [anon_sym_BSLASHacsp] = ACTIONS(5971),
    [anon_sym_BSLASHAcsp] = ACTIONS(5971),
    [anon_sym_BSLASHacl] = ACTIONS(5971),
    [anon_sym_BSLASHAcl] = ACTIONS(5971),
    [anon_sym_BSLASHaclp] = ACTIONS(5971),
    [anon_sym_BSLASHAclp] = ACTIONS(5971),
    [anon_sym_BSLASHacf] = ACTIONS(5971),
    [anon_sym_BSLASHAcf] = ACTIONS(5971),
    [anon_sym_BSLASHacfp] = ACTIONS(5971),
    [anon_sym_BSLASHAcfp] = ACTIONS(5971),
    [anon_sym_BSLASHac] = ACTIONS(5971),
    [anon_sym_BSLASHAc] = ACTIONS(5971),
    [anon_sym_BSLASHacp] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5971),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5971),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5971),
    [anon_sym_BSLASHcolor] = ACTIONS(5971),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5971),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5971),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5971),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5971),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5971),
    [anon_sym_BSLASHtext] = ACTIONS(5971),
    [anon_sym_BSLASHintertext] = ACTIONS(5971),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5971),
    [anon_sym_BSLASHurl] = ACTIONS(5971),
    [anon_sym_BSLASHhref] = ACTIONS(5971),
  },
  [821] = {
    [sym__part_declaration] = STATE(156),
    [sym_part] = STATE(821),
    [aux_sym__section_repeat1] = STATE(821),
    [sym_command_name] = ACTIONS(5987),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5987),
    [anon_sym_LBRACK] = ACTIONS(5989),
    [anon_sym_RBRACK] = ACTIONS(5989),
    [anon_sym_COMMA] = ACTIONS(5989),
    [anon_sym_EQ] = ACTIONS(5989),
    [anon_sym_LPAREN] = ACTIONS(5989),
    [anon_sym_RPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHpart] = ACTIONS(6833),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6836),
    [anon_sym_BSLASHaddpart] = ACTIONS(6833),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6836),
    [anon_sym_BSLASHchapter] = ACTIONS(5987),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddchap] = ACTIONS(5987),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsection] = ACTIONS(5987),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHaddsec] = ACTIONS(5987),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5987),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5987),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHitem] = ACTIONS(5987),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5989),
    [anon_sym_LBRACE] = ACTIONS(5989),
    [sym_word] = ACTIONS(5987),
    [sym_placeholder] = ACTIONS(5989),
    [anon_sym_PLUS] = ACTIONS(5989),
    [anon_sym_DASH] = ACTIONS(5989),
    [anon_sym_STAR] = ACTIONS(5989),
    [anon_sym_SLASH] = ACTIONS(5989),
    [anon_sym_LT] = ACTIONS(5987),
    [anon_sym_GT] = ACTIONS(5987),
    [anon_sym_BANG] = ACTIONS(5987),
    [anon_sym_PIPE] = ACTIONS(5987),
    [anon_sym_COLON] = ACTIONS(5987),
    [anon_sym_SQUOTE] = ACTIONS(5987),
    [anon_sym__] = ACTIONS(5989),
    [anon_sym_CARET] = ACTIONS(5989),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5989),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5989),
    [anon_sym_DOLLAR] = ACTIONS(5987),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5989),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5989),
    [anon_sym_BSLASHbegin] = ACTIONS(5987),
    [anon_sym_BSLASHtitle] = ACTIONS(5987),
    [anon_sym_BSLASHauthor] = ACTIONS(5987),
    [anon_sym_BSLASHusepackage] = ACTIONS(5987),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5987),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5987),
    [anon_sym_BSLASHinclude] = ACTIONS(5987),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5987),
    [anon_sym_BSLASHinput] = ACTIONS(5987),
    [anon_sym_BSLASHsubfile] = ACTIONS(5987),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5987),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5987),
    [anon_sym_BSLASHbibliography] = ACTIONS(5987),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5987),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5987),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5987),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5987),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5987),
    [anon_sym_BSLASHimport] = ACTIONS(5987),
    [anon_sym_BSLASHsubimport] = ACTIONS(5987),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5987),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5987),
    [anon_sym_BSLASHcaption] = ACTIONS(5987),
    [anon_sym_BSLASHcite] = ACTIONS(5987),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCite] = ACTIONS(5987),
    [anon_sym_BSLASHnocite] = ACTIONS(5987),
    [anon_sym_BSLASHcitet] = ACTIONS(5987),
    [anon_sym_BSLASHcitep] = ACTIONS(5987),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteA] = ACTIONS(5987),
    [anon_sym_BSLASHciteR] = ACTIONS(5987),
    [anon_sym_BSLASHciteS] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5987),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5987),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteyear] = ACTIONS(5987),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHcitedate] = ACTIONS(5987),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHciteurl] = ACTIONS(5987),
    [anon_sym_BSLASHfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5987),
    [anon_sym_BSLASHcitealt] = ACTIONS(5987),
    [anon_sym_BSLASHcitealp] = ACTIONS(5987),
    [anon_sym_BSLASHcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHparencite] = ACTIONS(5987),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHParencite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5987),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5987),
    [anon_sym_BSLASHtextcite] = ACTIONS(5987),
    [anon_sym_BSLASHTextcite] = ACTIONS(5987),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5987),
    [anon_sym_BSLASHsupercite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite] = ACTIONS(5987),
    [anon_sym_BSLASHAutocite] = ACTIONS(5987),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHVolcite] = ACTIONS(5987),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHavolcite] = ACTIONS(5987),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5987),
    [anon_sym_BSLASHnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHNotecite] = ACTIONS(5987),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5987),
    [anon_sym_BSLASHlabel] = ACTIONS(5987),
    [anon_sym_BSLASHref] = ACTIONS(5987),
    [anon_sym_BSLASHeqref] = ACTIONS(5987),
    [anon_sym_BSLASHvref] = ACTIONS(5987),
    [anon_sym_BSLASHVref] = ACTIONS(5987),
    [anon_sym_BSLASHautoref] = ACTIONS(5987),
    [anon_sym_BSLASHpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcref] = ACTIONS(5987),
    [anon_sym_BSLASHCref] = ACTIONS(5987),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnameCref] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5987),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5987),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5987),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5987),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5987),
    [anon_sym_BSLASHdef] = ACTIONS(5987),
    [anon_sym_BSLASHlet] = ACTIONS(5987),
    [anon_sym_BSLASHleft] = ACTIONS(5987),
    [anon_sym_BSLASHbigl] = ACTIONS(5987),
    [anon_sym_BSLASHBigl] = ACTIONS(5987),
    [anon_sym_BSLASHbiggl] = ACTIONS(5987),
    [anon_sym_BSLASHBiggl] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5987),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5987),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5987),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5987),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5987),
    [anon_sym_BSLASHgls] = ACTIONS(5987),
    [anon_sym_BSLASHGls] = ACTIONS(5987),
    [anon_sym_BSLASHGLS] = ACTIONS(5987),
    [anon_sym_BSLASHglspl] = ACTIONS(5987),
    [anon_sym_BSLASHGlspl] = ACTIONS(5987),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5987),
    [anon_sym_BSLASHglslink] = ACTIONS(5987),
    [anon_sym_BSLASHglstext] = ACTIONS(5987),
    [anon_sym_BSLASHGlstext] = ACTIONS(5987),
    [anon_sym_BSLASHGLStext] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5987),
    [anon_sym_BSLASHglsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5987),
    [anon_sym_BSLASHglsname] = ACTIONS(5987),
    [anon_sym_BSLASHGlsname] = ACTIONS(5987),
    [anon_sym_BSLASHGLSname] = ACTIONS(5987),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5987),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5987),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5987),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5987),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5987),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5987),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5987),
    [anon_sym_BSLASHacrshort] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5987),
    [anon_sym_BSLASHACRshort] = ACTIONS(5987),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrlong] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5987),
    [anon_sym_BSLASHACRlong] = ACTIONS(5987),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5987),
    [anon_sym_BSLASHacrfull] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5987),
    [anon_sym_BSLASHACRfull] = ACTIONS(5987),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHacs] = ACTIONS(5987),
    [anon_sym_BSLASHAcs] = ACTIONS(5987),
    [anon_sym_BSLASHacsp] = ACTIONS(5987),
    [anon_sym_BSLASHAcsp] = ACTIONS(5987),
    [anon_sym_BSLASHacl] = ACTIONS(5987),
    [anon_sym_BSLASHAcl] = ACTIONS(5987),
    [anon_sym_BSLASHaclp] = ACTIONS(5987),
    [anon_sym_BSLASHAclp] = ACTIONS(5987),
    [anon_sym_BSLASHacf] = ACTIONS(5987),
    [anon_sym_BSLASHAcf] = ACTIONS(5987),
    [anon_sym_BSLASHacfp] = ACTIONS(5987),
    [anon_sym_BSLASHAcfp] = ACTIONS(5987),
    [anon_sym_BSLASHac] = ACTIONS(5987),
    [anon_sym_BSLASHAc] = ACTIONS(5987),
    [anon_sym_BSLASHacp] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5987),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5987),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5987),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5987),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5989),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5987),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5987),
    [anon_sym_BSLASHcolor] = ACTIONS(5987),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5987),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5987),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5987),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5987),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5987),
    [anon_sym_BSLASHtext] = ACTIONS(5987),
    [anon_sym_BSLASHintertext] = ACTIONS(5987),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5987),
    [anon_sym_BSLASHurl] = ACTIONS(5987),
    [anon_sym_BSLASHhref] = ACTIONS(5987),
  },
  [822] = {
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(822),
    [aux_sym__section_repeat2] = STATE(822),
    [sym_command_name] = ACTIONS(5997),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5997),
    [anon_sym_LBRACK] = ACTIONS(5999),
    [anon_sym_RBRACK] = ACTIONS(5999),
    [anon_sym_COMMA] = ACTIONS(5999),
    [anon_sym_EQ] = ACTIONS(5999),
    [anon_sym_LPAREN] = ACTIONS(5999),
    [anon_sym_RPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHpart] = ACTIONS(5997),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddpart] = ACTIONS(5997),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHchapter] = ACTIONS(6839),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6842),
    [anon_sym_BSLASHaddchap] = ACTIONS(6839),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6842),
    [anon_sym_BSLASHsection] = ACTIONS(5997),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHaddsec] = ACTIONS(5997),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5997),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5997),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHitem] = ACTIONS(5997),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5999),
    [anon_sym_LBRACE] = ACTIONS(5999),
    [sym_word] = ACTIONS(5997),
    [sym_placeholder] = ACTIONS(5999),
    [anon_sym_PLUS] = ACTIONS(5999),
    [anon_sym_DASH] = ACTIONS(5999),
    [anon_sym_STAR] = ACTIONS(5999),
    [anon_sym_SLASH] = ACTIONS(5999),
    [anon_sym_LT] = ACTIONS(5997),
    [anon_sym_GT] = ACTIONS(5997),
    [anon_sym_BANG] = ACTIONS(5997),
    [anon_sym_PIPE] = ACTIONS(5997),
    [anon_sym_COLON] = ACTIONS(5997),
    [anon_sym_SQUOTE] = ACTIONS(5997),
    [anon_sym__] = ACTIONS(5999),
    [anon_sym_CARET] = ACTIONS(5999),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5999),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5999),
    [anon_sym_DOLLAR] = ACTIONS(5997),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5999),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5999),
    [anon_sym_BSLASHbegin] = ACTIONS(5997),
    [anon_sym_BSLASHtitle] = ACTIONS(5997),
    [anon_sym_BSLASHauthor] = ACTIONS(5997),
    [anon_sym_BSLASHusepackage] = ACTIONS(5997),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5997),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5997),
    [anon_sym_BSLASHinclude] = ACTIONS(5997),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5997),
    [anon_sym_BSLASHinput] = ACTIONS(5997),
    [anon_sym_BSLASHsubfile] = ACTIONS(5997),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5997),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5997),
    [anon_sym_BSLASHbibliography] = ACTIONS(5997),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5997),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5997),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5997),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5997),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5997),
    [anon_sym_BSLASHimport] = ACTIONS(5997),
    [anon_sym_BSLASHsubimport] = ACTIONS(5997),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5997),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5997),
    [anon_sym_BSLASHcaption] = ACTIONS(5997),
    [anon_sym_BSLASHcite] = ACTIONS(5997),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCite] = ACTIONS(5997),
    [anon_sym_BSLASHnocite] = ACTIONS(5997),
    [anon_sym_BSLASHcitet] = ACTIONS(5997),
    [anon_sym_BSLASHcitep] = ACTIONS(5997),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteA] = ACTIONS(5997),
    [anon_sym_BSLASHciteR] = ACTIONS(5997),
    [anon_sym_BSLASHciteS] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5997),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5997),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteyear] = ACTIONS(5997),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHcitedate] = ACTIONS(5997),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHciteurl] = ACTIONS(5997),
    [anon_sym_BSLASHfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5997),
    [anon_sym_BSLASHcitealt] = ACTIONS(5997),
    [anon_sym_BSLASHcitealp] = ACTIONS(5997),
    [anon_sym_BSLASHcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHparencite] = ACTIONS(5997),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHParencite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5997),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5997),
    [anon_sym_BSLASHtextcite] = ACTIONS(5997),
    [anon_sym_BSLASHTextcite] = ACTIONS(5997),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5997),
    [anon_sym_BSLASHsupercite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite] = ACTIONS(5997),
    [anon_sym_BSLASHAutocite] = ACTIONS(5997),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHVolcite] = ACTIONS(5997),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHavolcite] = ACTIONS(5997),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5997),
    [anon_sym_BSLASHnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHNotecite] = ACTIONS(5997),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5997),
    [anon_sym_BSLASHlabel] = ACTIONS(5997),
    [anon_sym_BSLASHref] = ACTIONS(5997),
    [anon_sym_BSLASHeqref] = ACTIONS(5997),
    [anon_sym_BSLASHvref] = ACTIONS(5997),
    [anon_sym_BSLASHVref] = ACTIONS(5997),
    [anon_sym_BSLASHautoref] = ACTIONS(5997),
    [anon_sym_BSLASHpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcref] = ACTIONS(5997),
    [anon_sym_BSLASHCref] = ACTIONS(5997),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnameCref] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5997),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5997),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5997),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5997),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5997),
    [anon_sym_BSLASHdef] = ACTIONS(5997),
    [anon_sym_BSLASHlet] = ACTIONS(5997),
    [anon_sym_BSLASHleft] = ACTIONS(5997),
    [anon_sym_BSLASHbigl] = ACTIONS(5997),
    [anon_sym_BSLASHBigl] = ACTIONS(5997),
    [anon_sym_BSLASHbiggl] = ACTIONS(5997),
    [anon_sym_BSLASHBiggl] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5997),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5997),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5997),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5997),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5997),
    [anon_sym_BSLASHgls] = ACTIONS(5997),
    [anon_sym_BSLASHGls] = ACTIONS(5997),
    [anon_sym_BSLASHGLS] = ACTIONS(5997),
    [anon_sym_BSLASHglspl] = ACTIONS(5997),
    [anon_sym_BSLASHGlspl] = ACTIONS(5997),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5997),
    [anon_sym_BSLASHglslink] = ACTIONS(5997),
    [anon_sym_BSLASHglstext] = ACTIONS(5997),
    [anon_sym_BSLASHGlstext] = ACTIONS(5997),
    [anon_sym_BSLASHGLStext] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5997),
    [anon_sym_BSLASHglsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5997),
    [anon_sym_BSLASHglsname] = ACTIONS(5997),
    [anon_sym_BSLASHGlsname] = ACTIONS(5997),
    [anon_sym_BSLASHGLSname] = ACTIONS(5997),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5997),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5997),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5997),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5997),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5997),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5997),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5997),
    [anon_sym_BSLASHacrshort] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5997),
    [anon_sym_BSLASHACRshort] = ACTIONS(5997),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrlong] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5997),
    [anon_sym_BSLASHACRlong] = ACTIONS(5997),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5997),
    [anon_sym_BSLASHacrfull] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5997),
    [anon_sym_BSLASHACRfull] = ACTIONS(5997),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHacs] = ACTIONS(5997),
    [anon_sym_BSLASHAcs] = ACTIONS(5997),
    [anon_sym_BSLASHacsp] = ACTIONS(5997),
    [anon_sym_BSLASHAcsp] = ACTIONS(5997),
    [anon_sym_BSLASHacl] = ACTIONS(5997),
    [anon_sym_BSLASHAcl] = ACTIONS(5997),
    [anon_sym_BSLASHaclp] = ACTIONS(5997),
    [anon_sym_BSLASHAclp] = ACTIONS(5997),
    [anon_sym_BSLASHacf] = ACTIONS(5997),
    [anon_sym_BSLASHAcf] = ACTIONS(5997),
    [anon_sym_BSLASHacfp] = ACTIONS(5997),
    [anon_sym_BSLASHAcfp] = ACTIONS(5997),
    [anon_sym_BSLASHac] = ACTIONS(5997),
    [anon_sym_BSLASHAc] = ACTIONS(5997),
    [anon_sym_BSLASHacp] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5997),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5997),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5997),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5997),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5999),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5997),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5997),
    [anon_sym_BSLASHcolor] = ACTIONS(5997),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5997),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5997),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5997),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5997),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5997),
    [anon_sym_BSLASHtext] = ACTIONS(5997),
    [anon_sym_BSLASHintertext] = ACTIONS(5997),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5997),
    [anon_sym_BSLASHurl] = ACTIONS(5997),
    [anon_sym_BSLASHhref] = ACTIONS(5997),
  },
  [823] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(6007),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6007),
    [anon_sym_LBRACK] = ACTIONS(6009),
    [anon_sym_RBRACK] = ACTIONS(6009),
    [anon_sym_COMMA] = ACTIONS(6009),
    [anon_sym_EQ] = ACTIONS(6009),
    [anon_sym_LPAREN] = ACTIONS(6009),
    [anon_sym_RPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHpart] = ACTIONS(6007),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddpart] = ACTIONS(6007),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHchapter] = ACTIONS(6007),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHaddchap] = ACTIONS(6007),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsection] = ACTIONS(6845),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6848),
    [anon_sym_BSLASHaddsec] = ACTIONS(6845),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6848),
    [anon_sym_BSLASHsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6007),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6007),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHitem] = ACTIONS(6007),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6009),
    [anon_sym_LBRACE] = ACTIONS(6009),
    [sym_word] = ACTIONS(6007),
    [sym_placeholder] = ACTIONS(6009),
    [anon_sym_PLUS] = ACTIONS(6009),
    [anon_sym_DASH] = ACTIONS(6009),
    [anon_sym_STAR] = ACTIONS(6009),
    [anon_sym_SLASH] = ACTIONS(6009),
    [anon_sym_LT] = ACTIONS(6007),
    [anon_sym_GT] = ACTIONS(6007),
    [anon_sym_BANG] = ACTIONS(6007),
    [anon_sym_PIPE] = ACTIONS(6007),
    [anon_sym_COLON] = ACTIONS(6007),
    [anon_sym_SQUOTE] = ACTIONS(6007),
    [anon_sym__] = ACTIONS(6009),
    [anon_sym_CARET] = ACTIONS(6009),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6009),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6009),
    [anon_sym_DOLLAR] = ACTIONS(6007),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6009),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6009),
    [anon_sym_BSLASHbegin] = ACTIONS(6007),
    [anon_sym_BSLASHtitle] = ACTIONS(6007),
    [anon_sym_BSLASHauthor] = ACTIONS(6007),
    [anon_sym_BSLASHusepackage] = ACTIONS(6007),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6007),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6007),
    [anon_sym_BSLASHinclude] = ACTIONS(6007),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6007),
    [anon_sym_BSLASHinput] = ACTIONS(6007),
    [anon_sym_BSLASHsubfile] = ACTIONS(6007),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6007),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6007),
    [anon_sym_BSLASHbibliography] = ACTIONS(6007),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6007),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6007),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6007),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6007),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6007),
    [anon_sym_BSLASHimport] = ACTIONS(6007),
    [anon_sym_BSLASHsubimport] = ACTIONS(6007),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6007),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6007),
    [anon_sym_BSLASHcaption] = ACTIONS(6007),
    [anon_sym_BSLASHcite] = ACTIONS(6007),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCite] = ACTIONS(6007),
    [anon_sym_BSLASHnocite] = ACTIONS(6007),
    [anon_sym_BSLASHcitet] = ACTIONS(6007),
    [anon_sym_BSLASHcitep] = ACTIONS(6007),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteA] = ACTIONS(6007),
    [anon_sym_BSLASHciteR] = ACTIONS(6007),
    [anon_sym_BSLASHciteS] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6007),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6007),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteyear] = ACTIONS(6007),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHcitedate] = ACTIONS(6007),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHciteurl] = ACTIONS(6007),
    [anon_sym_BSLASHfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6007),
    [anon_sym_BSLASHcitealt] = ACTIONS(6007),
    [anon_sym_BSLASHcitealp] = ACTIONS(6007),
    [anon_sym_BSLASHcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHparencite] = ACTIONS(6007),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHParencite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6007),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6007),
    [anon_sym_BSLASHtextcite] = ACTIONS(6007),
    [anon_sym_BSLASHTextcite] = ACTIONS(6007),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6007),
    [anon_sym_BSLASHsupercite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite] = ACTIONS(6007),
    [anon_sym_BSLASHAutocite] = ACTIONS(6007),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHVolcite] = ACTIONS(6007),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHavolcite] = ACTIONS(6007),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6007),
    [anon_sym_BSLASHnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHNotecite] = ACTIONS(6007),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6007),
    [anon_sym_BSLASHlabel] = ACTIONS(6007),
    [anon_sym_BSLASHref] = ACTIONS(6007),
    [anon_sym_BSLASHeqref] = ACTIONS(6007),
    [anon_sym_BSLASHvref] = ACTIONS(6007),
    [anon_sym_BSLASHVref] = ACTIONS(6007),
    [anon_sym_BSLASHautoref] = ACTIONS(6007),
    [anon_sym_BSLASHpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcref] = ACTIONS(6007),
    [anon_sym_BSLASHCref] = ACTIONS(6007),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnameCref] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6007),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6007),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6007),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6007),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6007),
    [anon_sym_BSLASHdef] = ACTIONS(6007),
    [anon_sym_BSLASHlet] = ACTIONS(6007),
    [anon_sym_BSLASHleft] = ACTIONS(6007),
    [anon_sym_BSLASHbigl] = ACTIONS(6007),
    [anon_sym_BSLASHBigl] = ACTIONS(6007),
    [anon_sym_BSLASHbiggl] = ACTIONS(6007),
    [anon_sym_BSLASHBiggl] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6007),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6007),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6007),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6007),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6007),
    [anon_sym_BSLASHgls] = ACTIONS(6007),
    [anon_sym_BSLASHGls] = ACTIONS(6007),
    [anon_sym_BSLASHGLS] = ACTIONS(6007),
    [anon_sym_BSLASHglspl] = ACTIONS(6007),
    [anon_sym_BSLASHGlspl] = ACTIONS(6007),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6007),
    [anon_sym_BSLASHglslink] = ACTIONS(6007),
    [anon_sym_BSLASHglstext] = ACTIONS(6007),
    [anon_sym_BSLASHGlstext] = ACTIONS(6007),
    [anon_sym_BSLASHGLStext] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6007),
    [anon_sym_BSLASHglsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6007),
    [anon_sym_BSLASHglsname] = ACTIONS(6007),
    [anon_sym_BSLASHGlsname] = ACTIONS(6007),
    [anon_sym_BSLASHGLSname] = ACTIONS(6007),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6007),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6007),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6007),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6007),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6007),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6007),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6007),
    [anon_sym_BSLASHacrshort] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6007),
    [anon_sym_BSLASHACRshort] = ACTIONS(6007),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrlong] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6007),
    [anon_sym_BSLASHACRlong] = ACTIONS(6007),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6007),
    [anon_sym_BSLASHacrfull] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6007),
    [anon_sym_BSLASHACRfull] = ACTIONS(6007),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHacs] = ACTIONS(6007),
    [anon_sym_BSLASHAcs] = ACTIONS(6007),
    [anon_sym_BSLASHacsp] = ACTIONS(6007),
    [anon_sym_BSLASHAcsp] = ACTIONS(6007),
    [anon_sym_BSLASHacl] = ACTIONS(6007),
    [anon_sym_BSLASHAcl] = ACTIONS(6007),
    [anon_sym_BSLASHaclp] = ACTIONS(6007),
    [anon_sym_BSLASHAclp] = ACTIONS(6007),
    [anon_sym_BSLASHacf] = ACTIONS(6007),
    [anon_sym_BSLASHAcf] = ACTIONS(6007),
    [anon_sym_BSLASHacfp] = ACTIONS(6007),
    [anon_sym_BSLASHAcfp] = ACTIONS(6007),
    [anon_sym_BSLASHac] = ACTIONS(6007),
    [anon_sym_BSLASHAc] = ACTIONS(6007),
    [anon_sym_BSLASHacp] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6007),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6007),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6007),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6007),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6009),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6007),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6007),
    [anon_sym_BSLASHcolor] = ACTIONS(6007),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6007),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6007),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6007),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6007),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6007),
    [anon_sym_BSLASHtext] = ACTIONS(6007),
    [anon_sym_BSLASHintertext] = ACTIONS(6007),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6007),
    [anon_sym_BSLASHurl] = ACTIONS(6007),
    [anon_sym_BSLASHhref] = ACTIONS(6007),
  },
  [824] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(5961),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5961),
    [anon_sym_LBRACK] = ACTIONS(5963),
    [anon_sym_RBRACK] = ACTIONS(5963),
    [anon_sym_COMMA] = ACTIONS(5963),
    [anon_sym_EQ] = ACTIONS(5963),
    [anon_sym_LPAREN] = ACTIONS(5963),
    [anon_sym_RPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHpart] = ACTIONS(5961),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddpart] = ACTIONS(5961),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHchapter] = ACTIONS(5961),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddchap] = ACTIONS(5961),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsection] = ACTIONS(5961),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHaddsec] = ACTIONS(5961),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubsection] = ACTIONS(6851),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6854),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5961),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5961),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHitem] = ACTIONS(5961),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5963),
    [anon_sym_LBRACE] = ACTIONS(5963),
    [sym_word] = ACTIONS(5961),
    [sym_placeholder] = ACTIONS(5963),
    [anon_sym_PLUS] = ACTIONS(5963),
    [anon_sym_DASH] = ACTIONS(5963),
    [anon_sym_STAR] = ACTIONS(5963),
    [anon_sym_SLASH] = ACTIONS(5963),
    [anon_sym_LT] = ACTIONS(5961),
    [anon_sym_GT] = ACTIONS(5961),
    [anon_sym_BANG] = ACTIONS(5961),
    [anon_sym_PIPE] = ACTIONS(5961),
    [anon_sym_COLON] = ACTIONS(5961),
    [anon_sym_SQUOTE] = ACTIONS(5961),
    [anon_sym__] = ACTIONS(5963),
    [anon_sym_CARET] = ACTIONS(5963),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5963),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5963),
    [anon_sym_DOLLAR] = ACTIONS(5961),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5963),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5963),
    [anon_sym_BSLASHbegin] = ACTIONS(5961),
    [anon_sym_BSLASHtitle] = ACTIONS(5961),
    [anon_sym_BSLASHauthor] = ACTIONS(5961),
    [anon_sym_BSLASHusepackage] = ACTIONS(5961),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5961),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5961),
    [anon_sym_BSLASHinclude] = ACTIONS(5961),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5961),
    [anon_sym_BSLASHinput] = ACTIONS(5961),
    [anon_sym_BSLASHsubfile] = ACTIONS(5961),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5961),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5961),
    [anon_sym_BSLASHbibliography] = ACTIONS(5961),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5961),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5961),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5961),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5961),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5961),
    [anon_sym_BSLASHimport] = ACTIONS(5961),
    [anon_sym_BSLASHsubimport] = ACTIONS(5961),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5961),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5961),
    [anon_sym_BSLASHcaption] = ACTIONS(5961),
    [anon_sym_BSLASHcite] = ACTIONS(5961),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCite] = ACTIONS(5961),
    [anon_sym_BSLASHnocite] = ACTIONS(5961),
    [anon_sym_BSLASHcitet] = ACTIONS(5961),
    [anon_sym_BSLASHcitep] = ACTIONS(5961),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteA] = ACTIONS(5961),
    [anon_sym_BSLASHciteR] = ACTIONS(5961),
    [anon_sym_BSLASHciteS] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5961),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5961),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteyear] = ACTIONS(5961),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHcitedate] = ACTIONS(5961),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHciteurl] = ACTIONS(5961),
    [anon_sym_BSLASHfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5961),
    [anon_sym_BSLASHcitealt] = ACTIONS(5961),
    [anon_sym_BSLASHcitealp] = ACTIONS(5961),
    [anon_sym_BSLASHcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHparencite] = ACTIONS(5961),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHParencite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5961),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5961),
    [anon_sym_BSLASHtextcite] = ACTIONS(5961),
    [anon_sym_BSLASHTextcite] = ACTIONS(5961),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5961),
    [anon_sym_BSLASHsupercite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite] = ACTIONS(5961),
    [anon_sym_BSLASHAutocite] = ACTIONS(5961),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHVolcite] = ACTIONS(5961),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHavolcite] = ACTIONS(5961),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5961),
    [anon_sym_BSLASHnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHNotecite] = ACTIONS(5961),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5961),
    [anon_sym_BSLASHlabel] = ACTIONS(5961),
    [anon_sym_BSLASHref] = ACTIONS(5961),
    [anon_sym_BSLASHeqref] = ACTIONS(5961),
    [anon_sym_BSLASHvref] = ACTIONS(5961),
    [anon_sym_BSLASHVref] = ACTIONS(5961),
    [anon_sym_BSLASHautoref] = ACTIONS(5961),
    [anon_sym_BSLASHpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcref] = ACTIONS(5961),
    [anon_sym_BSLASHCref] = ACTIONS(5961),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnameCref] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5961),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5961),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5961),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5961),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5961),
    [anon_sym_BSLASHdef] = ACTIONS(5961),
    [anon_sym_BSLASHlet] = ACTIONS(5961),
    [anon_sym_BSLASHleft] = ACTIONS(5961),
    [anon_sym_BSLASHbigl] = ACTIONS(5961),
    [anon_sym_BSLASHBigl] = ACTIONS(5961),
    [anon_sym_BSLASHbiggl] = ACTIONS(5961),
    [anon_sym_BSLASHBiggl] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5961),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5961),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5961),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5961),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5961),
    [anon_sym_BSLASHgls] = ACTIONS(5961),
    [anon_sym_BSLASHGls] = ACTIONS(5961),
    [anon_sym_BSLASHGLS] = ACTIONS(5961),
    [anon_sym_BSLASHglspl] = ACTIONS(5961),
    [anon_sym_BSLASHGlspl] = ACTIONS(5961),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5961),
    [anon_sym_BSLASHglslink] = ACTIONS(5961),
    [anon_sym_BSLASHglstext] = ACTIONS(5961),
    [anon_sym_BSLASHGlstext] = ACTIONS(5961),
    [anon_sym_BSLASHGLStext] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5961),
    [anon_sym_BSLASHglsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5961),
    [anon_sym_BSLASHglsname] = ACTIONS(5961),
    [anon_sym_BSLASHGlsname] = ACTIONS(5961),
    [anon_sym_BSLASHGLSname] = ACTIONS(5961),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5961),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5961),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5961),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5961),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5961),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5961),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5961),
    [anon_sym_BSLASHacrshort] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5961),
    [anon_sym_BSLASHACRshort] = ACTIONS(5961),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrlong] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5961),
    [anon_sym_BSLASHACRlong] = ACTIONS(5961),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5961),
    [anon_sym_BSLASHacrfull] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5961),
    [anon_sym_BSLASHACRfull] = ACTIONS(5961),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHacs] = ACTIONS(5961),
    [anon_sym_BSLASHAcs] = ACTIONS(5961),
    [anon_sym_BSLASHacsp] = ACTIONS(5961),
    [anon_sym_BSLASHAcsp] = ACTIONS(5961),
    [anon_sym_BSLASHacl] = ACTIONS(5961),
    [anon_sym_BSLASHAcl] = ACTIONS(5961),
    [anon_sym_BSLASHaclp] = ACTIONS(5961),
    [anon_sym_BSLASHAclp] = ACTIONS(5961),
    [anon_sym_BSLASHacf] = ACTIONS(5961),
    [anon_sym_BSLASHAcf] = ACTIONS(5961),
    [anon_sym_BSLASHacfp] = ACTIONS(5961),
    [anon_sym_BSLASHAcfp] = ACTIONS(5961),
    [anon_sym_BSLASHac] = ACTIONS(5961),
    [anon_sym_BSLASHAc] = ACTIONS(5961),
    [anon_sym_BSLASHacp] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5961),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5961),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5961),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5961),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5963),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5961),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5961),
    [anon_sym_BSLASHcolor] = ACTIONS(5961),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5961),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5961),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5961),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5961),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5961),
    [anon_sym_BSLASHtext] = ACTIONS(5961),
    [anon_sym_BSLASHintertext] = ACTIONS(5961),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5961),
    [anon_sym_BSLASHurl] = ACTIONS(5961),
    [anon_sym_BSLASHhref] = ACTIONS(5961),
  },
  [825] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(6017),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6017),
    [anon_sym_LBRACK] = ACTIONS(6019),
    [anon_sym_RBRACK] = ACTIONS(6019),
    [anon_sym_COMMA] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6019),
    [anon_sym_LPAREN] = ACTIONS(6019),
    [anon_sym_RPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHpart] = ACTIONS(6017),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddpart] = ACTIONS(6017),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHchapter] = ACTIONS(6017),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddchap] = ACTIONS(6017),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsection] = ACTIONS(6017),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHaddsec] = ACTIONS(6017),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsection] = ACTIONS(6017),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6857),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6860),
    [anon_sym_BSLASHparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6017),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHitem] = ACTIONS(6017),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6019),
    [anon_sym_LBRACE] = ACTIONS(6019),
    [sym_word] = ACTIONS(6017),
    [sym_placeholder] = ACTIONS(6019),
    [anon_sym_PLUS] = ACTIONS(6019),
    [anon_sym_DASH] = ACTIONS(6019),
    [anon_sym_STAR] = ACTIONS(6019),
    [anon_sym_SLASH] = ACTIONS(6019),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_BANG] = ACTIONS(6017),
    [anon_sym_PIPE] = ACTIONS(6017),
    [anon_sym_COLON] = ACTIONS(6017),
    [anon_sym_SQUOTE] = ACTIONS(6017),
    [anon_sym__] = ACTIONS(6019),
    [anon_sym_CARET] = ACTIONS(6019),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6019),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6019),
    [anon_sym_DOLLAR] = ACTIONS(6017),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6019),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6019),
    [anon_sym_BSLASHbegin] = ACTIONS(6017),
    [anon_sym_BSLASHtitle] = ACTIONS(6017),
    [anon_sym_BSLASHauthor] = ACTIONS(6017),
    [anon_sym_BSLASHusepackage] = ACTIONS(6017),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6017),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6017),
    [anon_sym_BSLASHinclude] = ACTIONS(6017),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6017),
    [anon_sym_BSLASHinput] = ACTIONS(6017),
    [anon_sym_BSLASHsubfile] = ACTIONS(6017),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6017),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6017),
    [anon_sym_BSLASHbibliography] = ACTIONS(6017),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6017),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6017),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6017),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6017),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6017),
    [anon_sym_BSLASHimport] = ACTIONS(6017),
    [anon_sym_BSLASHsubimport] = ACTIONS(6017),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6017),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6017),
    [anon_sym_BSLASHcaption] = ACTIONS(6017),
    [anon_sym_BSLASHcite] = ACTIONS(6017),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCite] = ACTIONS(6017),
    [anon_sym_BSLASHnocite] = ACTIONS(6017),
    [anon_sym_BSLASHcitet] = ACTIONS(6017),
    [anon_sym_BSLASHcitep] = ACTIONS(6017),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteA] = ACTIONS(6017),
    [anon_sym_BSLASHciteR] = ACTIONS(6017),
    [anon_sym_BSLASHciteS] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6017),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6017),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteyear] = ACTIONS(6017),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHcitedate] = ACTIONS(6017),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHciteurl] = ACTIONS(6017),
    [anon_sym_BSLASHfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6017),
    [anon_sym_BSLASHcitealt] = ACTIONS(6017),
    [anon_sym_BSLASHcitealp] = ACTIONS(6017),
    [anon_sym_BSLASHcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHparencite] = ACTIONS(6017),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHParencite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6017),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6017),
    [anon_sym_BSLASHtextcite] = ACTIONS(6017),
    [anon_sym_BSLASHTextcite] = ACTIONS(6017),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6017),
    [anon_sym_BSLASHsupercite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite] = ACTIONS(6017),
    [anon_sym_BSLASHAutocite] = ACTIONS(6017),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHVolcite] = ACTIONS(6017),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHavolcite] = ACTIONS(6017),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6017),
    [anon_sym_BSLASHnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHNotecite] = ACTIONS(6017),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6017),
    [anon_sym_BSLASHlabel] = ACTIONS(6017),
    [anon_sym_BSLASHref] = ACTIONS(6017),
    [anon_sym_BSLASHeqref] = ACTIONS(6017),
    [anon_sym_BSLASHvref] = ACTIONS(6017),
    [anon_sym_BSLASHVref] = ACTIONS(6017),
    [anon_sym_BSLASHautoref] = ACTIONS(6017),
    [anon_sym_BSLASHpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcref] = ACTIONS(6017),
    [anon_sym_BSLASHCref] = ACTIONS(6017),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnameCref] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6017),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6017),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6017),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6017),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6017),
    [anon_sym_BSLASHdef] = ACTIONS(6017),
    [anon_sym_BSLASHlet] = ACTIONS(6017),
    [anon_sym_BSLASHleft] = ACTIONS(6017),
    [anon_sym_BSLASHbigl] = ACTIONS(6017),
    [anon_sym_BSLASHBigl] = ACTIONS(6017),
    [anon_sym_BSLASHbiggl] = ACTIONS(6017),
    [anon_sym_BSLASHBiggl] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6017),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6017),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6017),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6017),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6017),
    [anon_sym_BSLASHgls] = ACTIONS(6017),
    [anon_sym_BSLASHGls] = ACTIONS(6017),
    [anon_sym_BSLASHGLS] = ACTIONS(6017),
    [anon_sym_BSLASHglspl] = ACTIONS(6017),
    [anon_sym_BSLASHGlspl] = ACTIONS(6017),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6017),
    [anon_sym_BSLASHglslink] = ACTIONS(6017),
    [anon_sym_BSLASHglstext] = ACTIONS(6017),
    [anon_sym_BSLASHGlstext] = ACTIONS(6017),
    [anon_sym_BSLASHGLStext] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6017),
    [anon_sym_BSLASHglsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6017),
    [anon_sym_BSLASHglsname] = ACTIONS(6017),
    [anon_sym_BSLASHGlsname] = ACTIONS(6017),
    [anon_sym_BSLASHGLSname] = ACTIONS(6017),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6017),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6017),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6017),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6017),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6017),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6017),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6017),
    [anon_sym_BSLASHacrshort] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6017),
    [anon_sym_BSLASHACRshort] = ACTIONS(6017),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrlong] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6017),
    [anon_sym_BSLASHACRlong] = ACTIONS(6017),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6017),
    [anon_sym_BSLASHacrfull] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6017),
    [anon_sym_BSLASHACRfull] = ACTIONS(6017),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHacs] = ACTIONS(6017),
    [anon_sym_BSLASHAcs] = ACTIONS(6017),
    [anon_sym_BSLASHacsp] = ACTIONS(6017),
    [anon_sym_BSLASHAcsp] = ACTIONS(6017),
    [anon_sym_BSLASHacl] = ACTIONS(6017),
    [anon_sym_BSLASHAcl] = ACTIONS(6017),
    [anon_sym_BSLASHaclp] = ACTIONS(6017),
    [anon_sym_BSLASHAclp] = ACTIONS(6017),
    [anon_sym_BSLASHacf] = ACTIONS(6017),
    [anon_sym_BSLASHAcf] = ACTIONS(6017),
    [anon_sym_BSLASHacfp] = ACTIONS(6017),
    [anon_sym_BSLASHAcfp] = ACTIONS(6017),
    [anon_sym_BSLASHac] = ACTIONS(6017),
    [anon_sym_BSLASHAc] = ACTIONS(6017),
    [anon_sym_BSLASHacp] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6017),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6017),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6017),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6017),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6019),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6017),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6017),
    [anon_sym_BSLASHcolor] = ACTIONS(6017),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6017),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6017),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6017),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6017),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6017),
    [anon_sym_BSLASHtext] = ACTIONS(6017),
    [anon_sym_BSLASHintertext] = ACTIONS(6017),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6017),
    [anon_sym_BSLASHurl] = ACTIONS(6017),
    [anon_sym_BSLASHhref] = ACTIONS(6017),
  },
  [826] = {
    [sym__paragraph_declaration] = STATE(208),
    [sym_paragraph] = STATE(826),
    [aux_sym__paragraph_repeat1] = STATE(826),
    [sym_command_name] = ACTIONS(6027),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6027),
    [anon_sym_LBRACK] = ACTIONS(6029),
    [anon_sym_RBRACK] = ACTIONS(6029),
    [anon_sym_COMMA] = ACTIONS(6029),
    [anon_sym_EQ] = ACTIONS(6029),
    [anon_sym_LPAREN] = ACTIONS(6029),
    [anon_sym_RPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHpart] = ACTIONS(6027),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddpart] = ACTIONS(6027),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHchapter] = ACTIONS(6027),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddchap] = ACTIONS(6027),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsection] = ACTIONS(6027),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHaddsec] = ACTIONS(6027),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6027),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHparagraph] = ACTIONS(6863),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6866),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6027),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHitem] = ACTIONS(6027),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6029),
    [anon_sym_LBRACE] = ACTIONS(6029),
    [sym_word] = ACTIONS(6027),
    [sym_placeholder] = ACTIONS(6029),
    [anon_sym_PLUS] = ACTIONS(6029),
    [anon_sym_DASH] = ACTIONS(6029),
    [anon_sym_STAR] = ACTIONS(6029),
    [anon_sym_SLASH] = ACTIONS(6029),
    [anon_sym_LT] = ACTIONS(6027),
    [anon_sym_GT] = ACTIONS(6027),
    [anon_sym_BANG] = ACTIONS(6027),
    [anon_sym_PIPE] = ACTIONS(6027),
    [anon_sym_COLON] = ACTIONS(6027),
    [anon_sym_SQUOTE] = ACTIONS(6027),
    [anon_sym__] = ACTIONS(6029),
    [anon_sym_CARET] = ACTIONS(6029),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6029),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6029),
    [anon_sym_DOLLAR] = ACTIONS(6027),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6029),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6029),
    [anon_sym_BSLASHbegin] = ACTIONS(6027),
    [anon_sym_BSLASHtitle] = ACTIONS(6027),
    [anon_sym_BSLASHauthor] = ACTIONS(6027),
    [anon_sym_BSLASHusepackage] = ACTIONS(6027),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6027),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6027),
    [anon_sym_BSLASHinclude] = ACTIONS(6027),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6027),
    [anon_sym_BSLASHinput] = ACTIONS(6027),
    [anon_sym_BSLASHsubfile] = ACTIONS(6027),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6027),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6027),
    [anon_sym_BSLASHbibliography] = ACTIONS(6027),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6027),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6027),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6027),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6027),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6027),
    [anon_sym_BSLASHimport] = ACTIONS(6027),
    [anon_sym_BSLASHsubimport] = ACTIONS(6027),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6027),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6027),
    [anon_sym_BSLASHcaption] = ACTIONS(6027),
    [anon_sym_BSLASHcite] = ACTIONS(6027),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCite] = ACTIONS(6027),
    [anon_sym_BSLASHnocite] = ACTIONS(6027),
    [anon_sym_BSLASHcitet] = ACTIONS(6027),
    [anon_sym_BSLASHcitep] = ACTIONS(6027),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteA] = ACTIONS(6027),
    [anon_sym_BSLASHciteR] = ACTIONS(6027),
    [anon_sym_BSLASHciteS] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6027),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6027),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteyear] = ACTIONS(6027),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHcitedate] = ACTIONS(6027),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHciteurl] = ACTIONS(6027),
    [anon_sym_BSLASHfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6027),
    [anon_sym_BSLASHcitealt] = ACTIONS(6027),
    [anon_sym_BSLASHcitealp] = ACTIONS(6027),
    [anon_sym_BSLASHcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHparencite] = ACTIONS(6027),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHParencite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6027),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6027),
    [anon_sym_BSLASHtextcite] = ACTIONS(6027),
    [anon_sym_BSLASHTextcite] = ACTIONS(6027),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6027),
    [anon_sym_BSLASHsupercite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite] = ACTIONS(6027),
    [anon_sym_BSLASHAutocite] = ACTIONS(6027),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHVolcite] = ACTIONS(6027),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHavolcite] = ACTIONS(6027),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6027),
    [anon_sym_BSLASHnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHNotecite] = ACTIONS(6027),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6027),
    [anon_sym_BSLASHlabel] = ACTIONS(6027),
    [anon_sym_BSLASHref] = ACTIONS(6027),
    [anon_sym_BSLASHeqref] = ACTIONS(6027),
    [anon_sym_BSLASHvref] = ACTIONS(6027),
    [anon_sym_BSLASHVref] = ACTIONS(6027),
    [anon_sym_BSLASHautoref] = ACTIONS(6027),
    [anon_sym_BSLASHpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcref] = ACTIONS(6027),
    [anon_sym_BSLASHCref] = ACTIONS(6027),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnameCref] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6027),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6027),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6027),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6027),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6027),
    [anon_sym_BSLASHdef] = ACTIONS(6027),
    [anon_sym_BSLASHlet] = ACTIONS(6027),
    [anon_sym_BSLASHleft] = ACTIONS(6027),
    [anon_sym_BSLASHbigl] = ACTIONS(6027),
    [anon_sym_BSLASHBigl] = ACTIONS(6027),
    [anon_sym_BSLASHbiggl] = ACTIONS(6027),
    [anon_sym_BSLASHBiggl] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6027),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6027),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6027),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6027),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6027),
    [anon_sym_BSLASHgls] = ACTIONS(6027),
    [anon_sym_BSLASHGls] = ACTIONS(6027),
    [anon_sym_BSLASHGLS] = ACTIONS(6027),
    [anon_sym_BSLASHglspl] = ACTIONS(6027),
    [anon_sym_BSLASHGlspl] = ACTIONS(6027),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6027),
    [anon_sym_BSLASHglslink] = ACTIONS(6027),
    [anon_sym_BSLASHglstext] = ACTIONS(6027),
    [anon_sym_BSLASHGlstext] = ACTIONS(6027),
    [anon_sym_BSLASHGLStext] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6027),
    [anon_sym_BSLASHglsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6027),
    [anon_sym_BSLASHglsname] = ACTIONS(6027),
    [anon_sym_BSLASHGlsname] = ACTIONS(6027),
    [anon_sym_BSLASHGLSname] = ACTIONS(6027),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6027),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6027),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6027),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6027),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6027),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6027),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6027),
    [anon_sym_BSLASHacrshort] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6027),
    [anon_sym_BSLASHACRshort] = ACTIONS(6027),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrlong] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6027),
    [anon_sym_BSLASHACRlong] = ACTIONS(6027),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6027),
    [anon_sym_BSLASHacrfull] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6027),
    [anon_sym_BSLASHACRfull] = ACTIONS(6027),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHacs] = ACTIONS(6027),
    [anon_sym_BSLASHAcs] = ACTIONS(6027),
    [anon_sym_BSLASHacsp] = ACTIONS(6027),
    [anon_sym_BSLASHAcsp] = ACTIONS(6027),
    [anon_sym_BSLASHacl] = ACTIONS(6027),
    [anon_sym_BSLASHAcl] = ACTIONS(6027),
    [anon_sym_BSLASHaclp] = ACTIONS(6027),
    [anon_sym_BSLASHAclp] = ACTIONS(6027),
    [anon_sym_BSLASHacf] = ACTIONS(6027),
    [anon_sym_BSLASHAcf] = ACTIONS(6027),
    [anon_sym_BSLASHacfp] = ACTIONS(6027),
    [anon_sym_BSLASHAcfp] = ACTIONS(6027),
    [anon_sym_BSLASHac] = ACTIONS(6027),
    [anon_sym_BSLASHAc] = ACTIONS(6027),
    [anon_sym_BSLASHacp] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6027),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6027),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6027),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6027),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6029),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6027),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6027),
    [anon_sym_BSLASHcolor] = ACTIONS(6027),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6027),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6027),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6027),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6027),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6027),
    [anon_sym_BSLASHtext] = ACTIONS(6027),
    [anon_sym_BSLASHintertext] = ACTIONS(6027),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6027),
    [anon_sym_BSLASHurl] = ACTIONS(6027),
    [anon_sym_BSLASHhref] = ACTIONS(6027),
  },
  [827] = {
    [sym__subparagraph_declaration] = STATE(216),
    [sym_subparagraph] = STATE(827),
    [aux_sym__paragraph_repeat2] = STATE(827),
    [sym_command_name] = ACTIONS(6037),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6037),
    [anon_sym_LBRACK] = ACTIONS(6039),
    [anon_sym_RBRACK] = ACTIONS(6039),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_EQ] = ACTIONS(6039),
    [anon_sym_LPAREN] = ACTIONS(6039),
    [anon_sym_RPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHpart] = ACTIONS(6037),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddpart] = ACTIONS(6037),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHchapter] = ACTIONS(6037),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddchap] = ACTIONS(6037),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsection] = ACTIONS(6037),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHaddsec] = ACTIONS(6037),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6037),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHparagraph] = ACTIONS(6037),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6869),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6872),
    [anon_sym_BSLASHitem] = ACTIONS(6037),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6039),
    [anon_sym_LBRACE] = ACTIONS(6039),
    [sym_word] = ACTIONS(6037),
    [sym_placeholder] = ACTIONS(6039),
    [anon_sym_PLUS] = ACTIONS(6039),
    [anon_sym_DASH] = ACTIONS(6039),
    [anon_sym_STAR] = ACTIONS(6039),
    [anon_sym_SLASH] = ACTIONS(6039),
    [anon_sym_LT] = ACTIONS(6037),
    [anon_sym_GT] = ACTIONS(6037),
    [anon_sym_BANG] = ACTIONS(6037),
    [anon_sym_PIPE] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6037),
    [anon_sym_SQUOTE] = ACTIONS(6037),
    [anon_sym__] = ACTIONS(6039),
    [anon_sym_CARET] = ACTIONS(6039),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6039),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6039),
    [anon_sym_DOLLAR] = ACTIONS(6037),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6039),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6039),
    [anon_sym_BSLASHbegin] = ACTIONS(6037),
    [anon_sym_BSLASHtitle] = ACTIONS(6037),
    [anon_sym_BSLASHauthor] = ACTIONS(6037),
    [anon_sym_BSLASHusepackage] = ACTIONS(6037),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6037),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6037),
    [anon_sym_BSLASHinclude] = ACTIONS(6037),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6037),
    [anon_sym_BSLASHinput] = ACTIONS(6037),
    [anon_sym_BSLASHsubfile] = ACTIONS(6037),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6037),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6037),
    [anon_sym_BSLASHbibliography] = ACTIONS(6037),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6037),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6037),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6037),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6037),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6037),
    [anon_sym_BSLASHimport] = ACTIONS(6037),
    [anon_sym_BSLASHsubimport] = ACTIONS(6037),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6037),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6037),
    [anon_sym_BSLASHcaption] = ACTIONS(6037),
    [anon_sym_BSLASHcite] = ACTIONS(6037),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCite] = ACTIONS(6037),
    [anon_sym_BSLASHnocite] = ACTIONS(6037),
    [anon_sym_BSLASHcitet] = ACTIONS(6037),
    [anon_sym_BSLASHcitep] = ACTIONS(6037),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteA] = ACTIONS(6037),
    [anon_sym_BSLASHciteR] = ACTIONS(6037),
    [anon_sym_BSLASHciteS] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6037),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6037),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteyear] = ACTIONS(6037),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHcitedate] = ACTIONS(6037),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHciteurl] = ACTIONS(6037),
    [anon_sym_BSLASHfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6037),
    [anon_sym_BSLASHcitealt] = ACTIONS(6037),
    [anon_sym_BSLASHcitealp] = ACTIONS(6037),
    [anon_sym_BSLASHcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHparencite] = ACTIONS(6037),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHParencite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6037),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6037),
    [anon_sym_BSLASHtextcite] = ACTIONS(6037),
    [anon_sym_BSLASHTextcite] = ACTIONS(6037),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6037),
    [anon_sym_BSLASHsupercite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite] = ACTIONS(6037),
    [anon_sym_BSLASHAutocite] = ACTIONS(6037),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHVolcite] = ACTIONS(6037),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHavolcite] = ACTIONS(6037),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6037),
    [anon_sym_BSLASHnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHNotecite] = ACTIONS(6037),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6037),
    [anon_sym_BSLASHlabel] = ACTIONS(6037),
    [anon_sym_BSLASHref] = ACTIONS(6037),
    [anon_sym_BSLASHeqref] = ACTIONS(6037),
    [anon_sym_BSLASHvref] = ACTIONS(6037),
    [anon_sym_BSLASHVref] = ACTIONS(6037),
    [anon_sym_BSLASHautoref] = ACTIONS(6037),
    [anon_sym_BSLASHpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcref] = ACTIONS(6037),
    [anon_sym_BSLASHCref] = ACTIONS(6037),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnameCref] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6037),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6037),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6037),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6037),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6037),
    [anon_sym_BSLASHdef] = ACTIONS(6037),
    [anon_sym_BSLASHlet] = ACTIONS(6037),
    [anon_sym_BSLASHleft] = ACTIONS(6037),
    [anon_sym_BSLASHbigl] = ACTIONS(6037),
    [anon_sym_BSLASHBigl] = ACTIONS(6037),
    [anon_sym_BSLASHbiggl] = ACTIONS(6037),
    [anon_sym_BSLASHBiggl] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6037),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6037),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6037),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6037),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6037),
    [anon_sym_BSLASHgls] = ACTIONS(6037),
    [anon_sym_BSLASHGls] = ACTIONS(6037),
    [anon_sym_BSLASHGLS] = ACTIONS(6037),
    [anon_sym_BSLASHglspl] = ACTIONS(6037),
    [anon_sym_BSLASHGlspl] = ACTIONS(6037),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6037),
    [anon_sym_BSLASHglslink] = ACTIONS(6037),
    [anon_sym_BSLASHglstext] = ACTIONS(6037),
    [anon_sym_BSLASHGlstext] = ACTIONS(6037),
    [anon_sym_BSLASHGLStext] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6037),
    [anon_sym_BSLASHglsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6037),
    [anon_sym_BSLASHglsname] = ACTIONS(6037),
    [anon_sym_BSLASHGlsname] = ACTIONS(6037),
    [anon_sym_BSLASHGLSname] = ACTIONS(6037),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6037),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6037),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6037),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6037),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6037),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6037),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6037),
    [anon_sym_BSLASHacrshort] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6037),
    [anon_sym_BSLASHACRshort] = ACTIONS(6037),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrlong] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6037),
    [anon_sym_BSLASHACRlong] = ACTIONS(6037),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6037),
    [anon_sym_BSLASHacrfull] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6037),
    [anon_sym_BSLASHACRfull] = ACTIONS(6037),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHacs] = ACTIONS(6037),
    [anon_sym_BSLASHAcs] = ACTIONS(6037),
    [anon_sym_BSLASHacsp] = ACTIONS(6037),
    [anon_sym_BSLASHAcsp] = ACTIONS(6037),
    [anon_sym_BSLASHacl] = ACTIONS(6037),
    [anon_sym_BSLASHAcl] = ACTIONS(6037),
    [anon_sym_BSLASHaclp] = ACTIONS(6037),
    [anon_sym_BSLASHAclp] = ACTIONS(6037),
    [anon_sym_BSLASHacf] = ACTIONS(6037),
    [anon_sym_BSLASHAcf] = ACTIONS(6037),
    [anon_sym_BSLASHacfp] = ACTIONS(6037),
    [anon_sym_BSLASHAcfp] = ACTIONS(6037),
    [anon_sym_BSLASHac] = ACTIONS(6037),
    [anon_sym_BSLASHAc] = ACTIONS(6037),
    [anon_sym_BSLASHacp] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6037),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6037),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6037),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6037),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6039),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6037),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6037),
    [anon_sym_BSLASHcolor] = ACTIONS(6037),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6037),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6037),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6037),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6037),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6037),
    [anon_sym_BSLASHtext] = ACTIONS(6037),
    [anon_sym_BSLASHintertext] = ACTIONS(6037),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6037),
    [anon_sym_BSLASHurl] = ACTIONS(6037),
    [anon_sym_BSLASHhref] = ACTIONS(6037),
  },
  [828] = {
    [sym__enum_itemdeclaration] = STATE(229),
    [sym_enum_item] = STATE(828),
    [aux_sym__paragraph_repeat3] = STATE(828),
    [sym_command_name] = ACTIONS(6047),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(6049),
    [anon_sym_RBRACK] = ACTIONS(6049),
    [anon_sym_COMMA] = ACTIONS(6049),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_LPAREN] = ACTIONS(6049),
    [anon_sym_RPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHpart] = ACTIONS(6047),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddpart] = ACTIONS(6047),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHchapter] = ACTIONS(6047),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddchap] = ACTIONS(6047),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsection] = ACTIONS(6047),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHaddsec] = ACTIONS(6047),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6047),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6047),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHitem] = ACTIONS(6875),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6878),
    [anon_sym_LBRACE] = ACTIONS(6049),
    [sym_word] = ACTIONS(6047),
    [sym_placeholder] = ACTIONS(6049),
    [anon_sym_PLUS] = ACTIONS(6049),
    [anon_sym_DASH] = ACTIONS(6049),
    [anon_sym_STAR] = ACTIONS(6049),
    [anon_sym_SLASH] = ACTIONS(6049),
    [anon_sym_LT] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6047),
    [anon_sym_BANG] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6047),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_SQUOTE] = ACTIONS(6047),
    [anon_sym__] = ACTIONS(6049),
    [anon_sym_CARET] = ACTIONS(6049),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6049),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6049),
    [anon_sym_DOLLAR] = ACTIONS(6047),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6049),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6049),
    [anon_sym_BSLASHbegin] = ACTIONS(6047),
    [anon_sym_BSLASHtitle] = ACTIONS(6047),
    [anon_sym_BSLASHauthor] = ACTIONS(6047),
    [anon_sym_BSLASHusepackage] = ACTIONS(6047),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6047),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6047),
    [anon_sym_BSLASHinclude] = ACTIONS(6047),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6047),
    [anon_sym_BSLASHinput] = ACTIONS(6047),
    [anon_sym_BSLASHsubfile] = ACTIONS(6047),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6047),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6047),
    [anon_sym_BSLASHbibliography] = ACTIONS(6047),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6047),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6047),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6047),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6047),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6047),
    [anon_sym_BSLASHimport] = ACTIONS(6047),
    [anon_sym_BSLASHsubimport] = ACTIONS(6047),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6047),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6047),
    [anon_sym_BSLASHcaption] = ACTIONS(6047),
    [anon_sym_BSLASHcite] = ACTIONS(6047),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCite] = ACTIONS(6047),
    [anon_sym_BSLASHnocite] = ACTIONS(6047),
    [anon_sym_BSLASHcitet] = ACTIONS(6047),
    [anon_sym_BSLASHcitep] = ACTIONS(6047),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteA] = ACTIONS(6047),
    [anon_sym_BSLASHciteR] = ACTIONS(6047),
    [anon_sym_BSLASHciteS] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6047),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6047),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteyear] = ACTIONS(6047),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHcitedate] = ACTIONS(6047),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHciteurl] = ACTIONS(6047),
    [anon_sym_BSLASHfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6047),
    [anon_sym_BSLASHcitealt] = ACTIONS(6047),
    [anon_sym_BSLASHcitealp] = ACTIONS(6047),
    [anon_sym_BSLASHcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHparencite] = ACTIONS(6047),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHParencite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6047),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6047),
    [anon_sym_BSLASHtextcite] = ACTIONS(6047),
    [anon_sym_BSLASHTextcite] = ACTIONS(6047),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6047),
    [anon_sym_BSLASHsupercite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite] = ACTIONS(6047),
    [anon_sym_BSLASHAutocite] = ACTIONS(6047),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHVolcite] = ACTIONS(6047),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHavolcite] = ACTIONS(6047),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6047),
    [anon_sym_BSLASHnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHNotecite] = ACTIONS(6047),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6047),
    [anon_sym_BSLASHlabel] = ACTIONS(6047),
    [anon_sym_BSLASHref] = ACTIONS(6047),
    [anon_sym_BSLASHeqref] = ACTIONS(6047),
    [anon_sym_BSLASHvref] = ACTIONS(6047),
    [anon_sym_BSLASHVref] = ACTIONS(6047),
    [anon_sym_BSLASHautoref] = ACTIONS(6047),
    [anon_sym_BSLASHpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcref] = ACTIONS(6047),
    [anon_sym_BSLASHCref] = ACTIONS(6047),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnameCref] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6047),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6047),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6047),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6047),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6047),
    [anon_sym_BSLASHdef] = ACTIONS(6047),
    [anon_sym_BSLASHlet] = ACTIONS(6047),
    [anon_sym_BSLASHleft] = ACTIONS(6047),
    [anon_sym_BSLASHbigl] = ACTIONS(6047),
    [anon_sym_BSLASHBigl] = ACTIONS(6047),
    [anon_sym_BSLASHbiggl] = ACTIONS(6047),
    [anon_sym_BSLASHBiggl] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6047),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6047),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6047),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6047),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6047),
    [anon_sym_BSLASHgls] = ACTIONS(6047),
    [anon_sym_BSLASHGls] = ACTIONS(6047),
    [anon_sym_BSLASHGLS] = ACTIONS(6047),
    [anon_sym_BSLASHglspl] = ACTIONS(6047),
    [anon_sym_BSLASHGlspl] = ACTIONS(6047),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6047),
    [anon_sym_BSLASHglslink] = ACTIONS(6047),
    [anon_sym_BSLASHglstext] = ACTIONS(6047),
    [anon_sym_BSLASHGlstext] = ACTIONS(6047),
    [anon_sym_BSLASHGLStext] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6047),
    [anon_sym_BSLASHglsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6047),
    [anon_sym_BSLASHglsname] = ACTIONS(6047),
    [anon_sym_BSLASHGlsname] = ACTIONS(6047),
    [anon_sym_BSLASHGLSname] = ACTIONS(6047),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6047),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6047),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6047),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6047),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6047),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6047),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6047),
    [anon_sym_BSLASHacrshort] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6047),
    [anon_sym_BSLASHACRshort] = ACTIONS(6047),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrlong] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6047),
    [anon_sym_BSLASHACRlong] = ACTIONS(6047),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6047),
    [anon_sym_BSLASHacrfull] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6047),
    [anon_sym_BSLASHACRfull] = ACTIONS(6047),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHacs] = ACTIONS(6047),
    [anon_sym_BSLASHAcs] = ACTIONS(6047),
    [anon_sym_BSLASHacsp] = ACTIONS(6047),
    [anon_sym_BSLASHAcsp] = ACTIONS(6047),
    [anon_sym_BSLASHacl] = ACTIONS(6047),
    [anon_sym_BSLASHAcl] = ACTIONS(6047),
    [anon_sym_BSLASHaclp] = ACTIONS(6047),
    [anon_sym_BSLASHAclp] = ACTIONS(6047),
    [anon_sym_BSLASHacf] = ACTIONS(6047),
    [anon_sym_BSLASHAcf] = ACTIONS(6047),
    [anon_sym_BSLASHacfp] = ACTIONS(6047),
    [anon_sym_BSLASHAcfp] = ACTIONS(6047),
    [anon_sym_BSLASHac] = ACTIONS(6047),
    [anon_sym_BSLASHAc] = ACTIONS(6047),
    [anon_sym_BSLASHacp] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6047),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6047),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6047),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6047),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6049),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6047),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6047),
    [anon_sym_BSLASHcolor] = ACTIONS(6047),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6047),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6047),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6047),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6047),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6047),
    [anon_sym_BSLASHtext] = ACTIONS(6047),
    [anon_sym_BSLASHintertext] = ACTIONS(6047),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6047),
    [anon_sym_BSLASHurl] = ACTIONS(6047),
    [anon_sym_BSLASHhref] = ACTIONS(6047),
  },
  [829] = {
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(720),
    [aux_sym__section_repeat2] = STATE(720),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHend] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [830] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHend] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [831] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(726),
    [aux_sym__section_repeat5] = STATE(726),
    [sym_command_name] = ACTIONS(2190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2190),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_RBRACK] = ACTIONS(2192),
    [anon_sym_COMMA] = ACTIONS(2192),
    [anon_sym_EQ] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2192),
    [anon_sym_RPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHpart] = ACTIONS(2190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddpart] = ACTIONS(2190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHchapter] = ACTIONS(2190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddchap] = ACTIONS(2190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsection] = ACTIONS(2190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHaddsec] = ACTIONS(2190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsection] = ACTIONS(2190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHitem] = ACTIONS(2190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2192),
    [anon_sym_LBRACE] = ACTIONS(2192),
    [sym_word] = ACTIONS(2190),
    [sym_placeholder] = ACTIONS(2192),
    [anon_sym_PLUS] = ACTIONS(2192),
    [anon_sym_DASH] = ACTIONS(2192),
    [anon_sym_STAR] = ACTIONS(2192),
    [anon_sym_SLASH] = ACTIONS(2192),
    [anon_sym_LT] = ACTIONS(2190),
    [anon_sym_GT] = ACTIONS(2190),
    [anon_sym_BANG] = ACTIONS(2190),
    [anon_sym_PIPE] = ACTIONS(2190),
    [anon_sym_COLON] = ACTIONS(2190),
    [anon_sym_SQUOTE] = ACTIONS(2190),
    [anon_sym__] = ACTIONS(2192),
    [anon_sym_CARET] = ACTIONS(2192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2192),
    [anon_sym_DOLLAR] = ACTIONS(2190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2192),
    [anon_sym_BSLASHbegin] = ACTIONS(2190),
    [anon_sym_BSLASHend] = ACTIONS(2190),
    [anon_sym_BSLASHtitle] = ACTIONS(2190),
    [anon_sym_BSLASHauthor] = ACTIONS(2190),
    [anon_sym_BSLASHusepackage] = ACTIONS(2190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2190),
    [anon_sym_BSLASHinclude] = ACTIONS(2190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2190),
    [anon_sym_BSLASHinput] = ACTIONS(2190),
    [anon_sym_BSLASHsubfile] = ACTIONS(2190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2190),
    [anon_sym_BSLASHbibliography] = ACTIONS(2190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2190),
    [anon_sym_BSLASHimport] = ACTIONS(2190),
    [anon_sym_BSLASHsubimport] = ACTIONS(2190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2190),
    [anon_sym_BSLASHcaption] = ACTIONS(2190),
    [anon_sym_BSLASHcite] = ACTIONS(2190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCite] = ACTIONS(2190),
    [anon_sym_BSLASHnocite] = ACTIONS(2190),
    [anon_sym_BSLASHcitet] = ACTIONS(2190),
    [anon_sym_BSLASHcitep] = ACTIONS(2190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteA] = ACTIONS(2190),
    [anon_sym_BSLASHciteR] = ACTIONS(2190),
    [anon_sym_BSLASHciteS] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteyear] = ACTIONS(2190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHcitedate] = ACTIONS(2190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHciteurl] = ACTIONS(2190),
    [anon_sym_BSLASHfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2190),
    [anon_sym_BSLASHcitealt] = ACTIONS(2190),
    [anon_sym_BSLASHcitealp] = ACTIONS(2190),
    [anon_sym_BSLASHcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHparencite] = ACTIONS(2190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHParencite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2190),
    [anon_sym_BSLASHtextcite] = ACTIONS(2190),
    [anon_sym_BSLASHTextcite] = ACTIONS(2190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2190),
    [anon_sym_BSLASHsupercite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite] = ACTIONS(2190),
    [anon_sym_BSLASHAutocite] = ACTIONS(2190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHVolcite] = ACTIONS(2190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHavolcite] = ACTIONS(2190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2190),
    [anon_sym_BSLASHnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHNotecite] = ACTIONS(2190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2190),
    [anon_sym_BSLASHlabel] = ACTIONS(2190),
    [anon_sym_BSLASHref] = ACTIONS(2190),
    [anon_sym_BSLASHeqref] = ACTIONS(2190),
    [anon_sym_BSLASHvref] = ACTIONS(2190),
    [anon_sym_BSLASHVref] = ACTIONS(2190),
    [anon_sym_BSLASHautoref] = ACTIONS(2190),
    [anon_sym_BSLASHpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcref] = ACTIONS(2190),
    [anon_sym_BSLASHCref] = ACTIONS(2190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnameCref] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2190),
    [anon_sym_BSLASHdef] = ACTIONS(2190),
    [anon_sym_BSLASHlet] = ACTIONS(2190),
    [anon_sym_BSLASHleft] = ACTIONS(2190),
    [anon_sym_BSLASHbigl] = ACTIONS(2190),
    [anon_sym_BSLASHBigl] = ACTIONS(2190),
    [anon_sym_BSLASHbiggl] = ACTIONS(2190),
    [anon_sym_BSLASHBiggl] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2190),
    [anon_sym_BSLASHgls] = ACTIONS(2190),
    [anon_sym_BSLASHGls] = ACTIONS(2190),
    [anon_sym_BSLASHGLS] = ACTIONS(2190),
    [anon_sym_BSLASHglspl] = ACTIONS(2190),
    [anon_sym_BSLASHGlspl] = ACTIONS(2190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2190),
    [anon_sym_BSLASHglslink] = ACTIONS(2190),
    [anon_sym_BSLASHglstext] = ACTIONS(2190),
    [anon_sym_BSLASHGlstext] = ACTIONS(2190),
    [anon_sym_BSLASHGLStext] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2190),
    [anon_sym_BSLASHglsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2190),
    [anon_sym_BSLASHglsname] = ACTIONS(2190),
    [anon_sym_BSLASHGlsname] = ACTIONS(2190),
    [anon_sym_BSLASHGLSname] = ACTIONS(2190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2190),
    [anon_sym_BSLASHacrshort] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2190),
    [anon_sym_BSLASHACRshort] = ACTIONS(2190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrlong] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2190),
    [anon_sym_BSLASHACRlong] = ACTIONS(2190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2190),
    [anon_sym_BSLASHacrfull] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2190),
    [anon_sym_BSLASHACRfull] = ACTIONS(2190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHacs] = ACTIONS(2190),
    [anon_sym_BSLASHAcs] = ACTIONS(2190),
    [anon_sym_BSLASHacsp] = ACTIONS(2190),
    [anon_sym_BSLASHAcsp] = ACTIONS(2190),
    [anon_sym_BSLASHacl] = ACTIONS(2190),
    [anon_sym_BSLASHAcl] = ACTIONS(2190),
    [anon_sym_BSLASHaclp] = ACTIONS(2190),
    [anon_sym_BSLASHAclp] = ACTIONS(2190),
    [anon_sym_BSLASHacf] = ACTIONS(2190),
    [anon_sym_BSLASHAcf] = ACTIONS(2190),
    [anon_sym_BSLASHacfp] = ACTIONS(2190),
    [anon_sym_BSLASHAcfp] = ACTIONS(2190),
    [anon_sym_BSLASHac] = ACTIONS(2190),
    [anon_sym_BSLASHAc] = ACTIONS(2190),
    [anon_sym_BSLASHacp] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2190),
    [anon_sym_BSLASHcolor] = ACTIONS(2190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2190),
    [anon_sym_BSLASHtext] = ACTIONS(2190),
    [anon_sym_BSLASHintertext] = ACTIONS(2190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2190),
    [anon_sym_BSLASHurl] = ACTIONS(2190),
    [anon_sym_BSLASHhref] = ACTIONS(2190),
  },
  [832] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHend] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [833] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHend] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [834] = {
    [sym__section_part] = STATE(1123),
    [sym_curly_group] = STATE(1101),
    [sym_brack_group] = STATE(2738),
    [sym_command_name] = ACTIONS(5971),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5971),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5973),
    [anon_sym_COMMA] = ACTIONS(5973),
    [anon_sym_EQ] = ACTIONS(5973),
    [anon_sym_LPAREN] = ACTIONS(5973),
    [anon_sym_RPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHpart] = ACTIONS(5971),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddpart] = ACTIONS(5971),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHchapter] = ACTIONS(5971),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddchap] = ACTIONS(5971),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsection] = ACTIONS(5971),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHaddsec] = ACTIONS(5971),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5971),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5971),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHitem] = ACTIONS(5971),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5973),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(5971),
    [sym_placeholder] = ACTIONS(5973),
    [anon_sym_PLUS] = ACTIONS(5973),
    [anon_sym_DASH] = ACTIONS(5973),
    [anon_sym_STAR] = ACTIONS(5973),
    [anon_sym_SLASH] = ACTIONS(5973),
    [anon_sym_LT] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5971),
    [anon_sym_BANG] = ACTIONS(5971),
    [anon_sym_PIPE] = ACTIONS(5971),
    [anon_sym_COLON] = ACTIONS(5971),
    [anon_sym_SQUOTE] = ACTIONS(5971),
    [anon_sym__] = ACTIONS(5973),
    [anon_sym_CARET] = ACTIONS(5973),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5973),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5973),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5973),
    [anon_sym_BSLASHbegin] = ACTIONS(5971),
    [anon_sym_BSLASHend] = ACTIONS(5971),
    [anon_sym_BSLASHtitle] = ACTIONS(5971),
    [anon_sym_BSLASHauthor] = ACTIONS(5971),
    [anon_sym_BSLASHusepackage] = ACTIONS(5971),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5971),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5971),
    [anon_sym_BSLASHinclude] = ACTIONS(5971),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5971),
    [anon_sym_BSLASHinput] = ACTIONS(5971),
    [anon_sym_BSLASHsubfile] = ACTIONS(5971),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5971),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5971),
    [anon_sym_BSLASHbibliography] = ACTIONS(5971),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5971),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5971),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5971),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5971),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5971),
    [anon_sym_BSLASHimport] = ACTIONS(5971),
    [anon_sym_BSLASHsubimport] = ACTIONS(5971),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5971),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5971),
    [anon_sym_BSLASHcaption] = ACTIONS(5971),
    [anon_sym_BSLASHcite] = ACTIONS(5971),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCite] = ACTIONS(5971),
    [anon_sym_BSLASHnocite] = ACTIONS(5971),
    [anon_sym_BSLASHcitet] = ACTIONS(5971),
    [anon_sym_BSLASHcitep] = ACTIONS(5971),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteA] = ACTIONS(5971),
    [anon_sym_BSLASHciteR] = ACTIONS(5971),
    [anon_sym_BSLASHciteS] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5971),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5971),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteyear] = ACTIONS(5971),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHcitedate] = ACTIONS(5971),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHciteurl] = ACTIONS(5971),
    [anon_sym_BSLASHfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5971),
    [anon_sym_BSLASHcitealt] = ACTIONS(5971),
    [anon_sym_BSLASHcitealp] = ACTIONS(5971),
    [anon_sym_BSLASHcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHparencite] = ACTIONS(5971),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHParencite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5971),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5971),
    [anon_sym_BSLASHtextcite] = ACTIONS(5971),
    [anon_sym_BSLASHTextcite] = ACTIONS(5971),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5971),
    [anon_sym_BSLASHsupercite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite] = ACTIONS(5971),
    [anon_sym_BSLASHAutocite] = ACTIONS(5971),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHVolcite] = ACTIONS(5971),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHavolcite] = ACTIONS(5971),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5971),
    [anon_sym_BSLASHnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHNotecite] = ACTIONS(5971),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5971),
    [anon_sym_BSLASHlabel] = ACTIONS(5971),
    [anon_sym_BSLASHref] = ACTIONS(5971),
    [anon_sym_BSLASHeqref] = ACTIONS(5971),
    [anon_sym_BSLASHvref] = ACTIONS(5971),
    [anon_sym_BSLASHVref] = ACTIONS(5971),
    [anon_sym_BSLASHautoref] = ACTIONS(5971),
    [anon_sym_BSLASHpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcref] = ACTIONS(5971),
    [anon_sym_BSLASHCref] = ACTIONS(5971),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnameCref] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5971),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5971),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5971),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5971),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5971),
    [anon_sym_BSLASHdef] = ACTIONS(5971),
    [anon_sym_BSLASHlet] = ACTIONS(5971),
    [anon_sym_BSLASHleft] = ACTIONS(5971),
    [anon_sym_BSLASHbigl] = ACTIONS(5971),
    [anon_sym_BSLASHBigl] = ACTIONS(5971),
    [anon_sym_BSLASHbiggl] = ACTIONS(5971),
    [anon_sym_BSLASHBiggl] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5971),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5971),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5971),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5971),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5971),
    [anon_sym_BSLASHgls] = ACTIONS(5971),
    [anon_sym_BSLASHGls] = ACTIONS(5971),
    [anon_sym_BSLASHGLS] = ACTIONS(5971),
    [anon_sym_BSLASHglspl] = ACTIONS(5971),
    [anon_sym_BSLASHGlspl] = ACTIONS(5971),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5971),
    [anon_sym_BSLASHglslink] = ACTIONS(5971),
    [anon_sym_BSLASHglstext] = ACTIONS(5971),
    [anon_sym_BSLASHGlstext] = ACTIONS(5971),
    [anon_sym_BSLASHGLStext] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5971),
    [anon_sym_BSLASHglsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5971),
    [anon_sym_BSLASHglsname] = ACTIONS(5971),
    [anon_sym_BSLASHGlsname] = ACTIONS(5971),
    [anon_sym_BSLASHGLSname] = ACTIONS(5971),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5971),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5971),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5971),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5971),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5971),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5971),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5971),
    [anon_sym_BSLASHacrshort] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5971),
    [anon_sym_BSLASHACRshort] = ACTIONS(5971),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrlong] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5971),
    [anon_sym_BSLASHACRlong] = ACTIONS(5971),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5971),
    [anon_sym_BSLASHacrfull] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5971),
    [anon_sym_BSLASHACRfull] = ACTIONS(5971),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHacs] = ACTIONS(5971),
    [anon_sym_BSLASHAcs] = ACTIONS(5971),
    [anon_sym_BSLASHacsp] = ACTIONS(5971),
    [anon_sym_BSLASHAcsp] = ACTIONS(5971),
    [anon_sym_BSLASHacl] = ACTIONS(5971),
    [anon_sym_BSLASHAcl] = ACTIONS(5971),
    [anon_sym_BSLASHaclp] = ACTIONS(5971),
    [anon_sym_BSLASHAclp] = ACTIONS(5971),
    [anon_sym_BSLASHacf] = ACTIONS(5971),
    [anon_sym_BSLASHAcf] = ACTIONS(5971),
    [anon_sym_BSLASHacfp] = ACTIONS(5971),
    [anon_sym_BSLASHAcfp] = ACTIONS(5971),
    [anon_sym_BSLASHac] = ACTIONS(5971),
    [anon_sym_BSLASHAc] = ACTIONS(5971),
    [anon_sym_BSLASHacp] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5971),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5971),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5971),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5971),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5973),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5971),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5971),
    [anon_sym_BSLASHcolor] = ACTIONS(5971),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5971),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5971),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5971),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5971),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5971),
    [anon_sym_BSLASHtext] = ACTIONS(5971),
    [anon_sym_BSLASHintertext] = ACTIONS(5971),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5971),
    [anon_sym_BSLASHurl] = ACTIONS(5971),
    [anon_sym_BSLASHhref] = ACTIONS(5971),
  },
  [835] = {
    [sym__section_part] = STATE(1099),
    [sym_curly_group] = STATE(1101),
    [sym_brack_group] = STATE(2738),
    [sym_command_name] = ACTIONS(5975),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5975),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5977),
    [anon_sym_COMMA] = ACTIONS(5977),
    [anon_sym_EQ] = ACTIONS(5977),
    [anon_sym_LPAREN] = ACTIONS(5977),
    [anon_sym_RPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHpart] = ACTIONS(5975),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddpart] = ACTIONS(5975),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHchapter] = ACTIONS(5975),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddchap] = ACTIONS(5975),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsection] = ACTIONS(5975),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHaddsec] = ACTIONS(5975),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5975),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5975),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHitem] = ACTIONS(5975),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5977),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(5975),
    [sym_placeholder] = ACTIONS(5977),
    [anon_sym_PLUS] = ACTIONS(5977),
    [anon_sym_DASH] = ACTIONS(5977),
    [anon_sym_STAR] = ACTIONS(5977),
    [anon_sym_SLASH] = ACTIONS(5977),
    [anon_sym_LT] = ACTIONS(5975),
    [anon_sym_GT] = ACTIONS(5975),
    [anon_sym_BANG] = ACTIONS(5975),
    [anon_sym_PIPE] = ACTIONS(5975),
    [anon_sym_COLON] = ACTIONS(5975),
    [anon_sym_SQUOTE] = ACTIONS(5975),
    [anon_sym__] = ACTIONS(5977),
    [anon_sym_CARET] = ACTIONS(5977),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5977),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5977),
    [anon_sym_DOLLAR] = ACTIONS(5975),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5977),
    [anon_sym_BSLASHbegin] = ACTIONS(5975),
    [anon_sym_BSLASHend] = ACTIONS(5975),
    [anon_sym_BSLASHtitle] = ACTIONS(5975),
    [anon_sym_BSLASHauthor] = ACTIONS(5975),
    [anon_sym_BSLASHusepackage] = ACTIONS(5975),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5975),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5975),
    [anon_sym_BSLASHinclude] = ACTIONS(5975),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5975),
    [anon_sym_BSLASHinput] = ACTIONS(5975),
    [anon_sym_BSLASHsubfile] = ACTIONS(5975),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5975),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5975),
    [anon_sym_BSLASHbibliography] = ACTIONS(5975),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5975),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5975),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5975),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5975),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5975),
    [anon_sym_BSLASHimport] = ACTIONS(5975),
    [anon_sym_BSLASHsubimport] = ACTIONS(5975),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5975),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5975),
    [anon_sym_BSLASHcaption] = ACTIONS(5975),
    [anon_sym_BSLASHcite] = ACTIONS(5975),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCite] = ACTIONS(5975),
    [anon_sym_BSLASHnocite] = ACTIONS(5975),
    [anon_sym_BSLASHcitet] = ACTIONS(5975),
    [anon_sym_BSLASHcitep] = ACTIONS(5975),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteA] = ACTIONS(5975),
    [anon_sym_BSLASHciteR] = ACTIONS(5975),
    [anon_sym_BSLASHciteS] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5975),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5975),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteyear] = ACTIONS(5975),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHcitedate] = ACTIONS(5975),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHciteurl] = ACTIONS(5975),
    [anon_sym_BSLASHfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5975),
    [anon_sym_BSLASHcitealt] = ACTIONS(5975),
    [anon_sym_BSLASHcitealp] = ACTIONS(5975),
    [anon_sym_BSLASHcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHparencite] = ACTIONS(5975),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHParencite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5975),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5975),
    [anon_sym_BSLASHtextcite] = ACTIONS(5975),
    [anon_sym_BSLASHTextcite] = ACTIONS(5975),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5975),
    [anon_sym_BSLASHsupercite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite] = ACTIONS(5975),
    [anon_sym_BSLASHAutocite] = ACTIONS(5975),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHVolcite] = ACTIONS(5975),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHavolcite] = ACTIONS(5975),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5975),
    [anon_sym_BSLASHnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHNotecite] = ACTIONS(5975),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5975),
    [anon_sym_BSLASHlabel] = ACTIONS(5975),
    [anon_sym_BSLASHref] = ACTIONS(5975),
    [anon_sym_BSLASHeqref] = ACTIONS(5975),
    [anon_sym_BSLASHvref] = ACTIONS(5975),
    [anon_sym_BSLASHVref] = ACTIONS(5975),
    [anon_sym_BSLASHautoref] = ACTIONS(5975),
    [anon_sym_BSLASHpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcref] = ACTIONS(5975),
    [anon_sym_BSLASHCref] = ACTIONS(5975),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnameCref] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5975),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5975),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5975),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5975),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5975),
    [anon_sym_BSLASHdef] = ACTIONS(5975),
    [anon_sym_BSLASHlet] = ACTIONS(5975),
    [anon_sym_BSLASHleft] = ACTIONS(5975),
    [anon_sym_BSLASHbigl] = ACTIONS(5975),
    [anon_sym_BSLASHBigl] = ACTIONS(5975),
    [anon_sym_BSLASHbiggl] = ACTIONS(5975),
    [anon_sym_BSLASHBiggl] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5975),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5975),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5975),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5975),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5975),
    [anon_sym_BSLASHgls] = ACTIONS(5975),
    [anon_sym_BSLASHGls] = ACTIONS(5975),
    [anon_sym_BSLASHGLS] = ACTIONS(5975),
    [anon_sym_BSLASHglspl] = ACTIONS(5975),
    [anon_sym_BSLASHGlspl] = ACTIONS(5975),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5975),
    [anon_sym_BSLASHglslink] = ACTIONS(5975),
    [anon_sym_BSLASHglstext] = ACTIONS(5975),
    [anon_sym_BSLASHGlstext] = ACTIONS(5975),
    [anon_sym_BSLASHGLStext] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5975),
    [anon_sym_BSLASHglsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5975),
    [anon_sym_BSLASHglsname] = ACTIONS(5975),
    [anon_sym_BSLASHGlsname] = ACTIONS(5975),
    [anon_sym_BSLASHGLSname] = ACTIONS(5975),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5975),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5975),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5975),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5975),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5975),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5975),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5975),
    [anon_sym_BSLASHacrshort] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5975),
    [anon_sym_BSLASHACRshort] = ACTIONS(5975),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrlong] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5975),
    [anon_sym_BSLASHACRlong] = ACTIONS(5975),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5975),
    [anon_sym_BSLASHacrfull] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5975),
    [anon_sym_BSLASHACRfull] = ACTIONS(5975),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHacs] = ACTIONS(5975),
    [anon_sym_BSLASHAcs] = ACTIONS(5975),
    [anon_sym_BSLASHacsp] = ACTIONS(5975),
    [anon_sym_BSLASHAcsp] = ACTIONS(5975),
    [anon_sym_BSLASHacl] = ACTIONS(5975),
    [anon_sym_BSLASHAcl] = ACTIONS(5975),
    [anon_sym_BSLASHaclp] = ACTIONS(5975),
    [anon_sym_BSLASHAclp] = ACTIONS(5975),
    [anon_sym_BSLASHacf] = ACTIONS(5975),
    [anon_sym_BSLASHAcf] = ACTIONS(5975),
    [anon_sym_BSLASHacfp] = ACTIONS(5975),
    [anon_sym_BSLASHAcfp] = ACTIONS(5975),
    [anon_sym_BSLASHac] = ACTIONS(5975),
    [anon_sym_BSLASHAc] = ACTIONS(5975),
    [anon_sym_BSLASHacp] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5975),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5975),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5975),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5975),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5977),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5975),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5975),
    [anon_sym_BSLASHcolor] = ACTIONS(5975),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5975),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5975),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5975),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5975),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5975),
    [anon_sym_BSLASHtext] = ACTIONS(5975),
    [anon_sym_BSLASHintertext] = ACTIONS(5975),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5975),
    [anon_sym_BSLASHurl] = ACTIONS(5975),
    [anon_sym_BSLASHhref] = ACTIONS(5975),
  },
  [836] = {
    [sym__section_part] = STATE(1097),
    [sym_curly_group] = STATE(1101),
    [sym_brack_group] = STATE(2738),
    [sym_command_name] = ACTIONS(5979),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5979),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5981),
    [anon_sym_COMMA] = ACTIONS(5981),
    [anon_sym_EQ] = ACTIONS(5981),
    [anon_sym_LPAREN] = ACTIONS(5981),
    [anon_sym_RPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHpart] = ACTIONS(5979),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddpart] = ACTIONS(5979),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHchapter] = ACTIONS(5979),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddchap] = ACTIONS(5979),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsection] = ACTIONS(5979),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHaddsec] = ACTIONS(5979),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5979),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5979),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHitem] = ACTIONS(5979),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5981),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(5979),
    [sym_placeholder] = ACTIONS(5981),
    [anon_sym_PLUS] = ACTIONS(5981),
    [anon_sym_DASH] = ACTIONS(5981),
    [anon_sym_STAR] = ACTIONS(5981),
    [anon_sym_SLASH] = ACTIONS(5981),
    [anon_sym_LT] = ACTIONS(5979),
    [anon_sym_GT] = ACTIONS(5979),
    [anon_sym_BANG] = ACTIONS(5979),
    [anon_sym_PIPE] = ACTIONS(5979),
    [anon_sym_COLON] = ACTIONS(5979),
    [anon_sym_SQUOTE] = ACTIONS(5979),
    [anon_sym__] = ACTIONS(5981),
    [anon_sym_CARET] = ACTIONS(5981),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5981),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5981),
    [anon_sym_DOLLAR] = ACTIONS(5979),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5981),
    [anon_sym_BSLASHbegin] = ACTIONS(5979),
    [anon_sym_BSLASHend] = ACTIONS(5979),
    [anon_sym_BSLASHtitle] = ACTIONS(5979),
    [anon_sym_BSLASHauthor] = ACTIONS(5979),
    [anon_sym_BSLASHusepackage] = ACTIONS(5979),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5979),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5979),
    [anon_sym_BSLASHinclude] = ACTIONS(5979),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5979),
    [anon_sym_BSLASHinput] = ACTIONS(5979),
    [anon_sym_BSLASHsubfile] = ACTIONS(5979),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5979),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5979),
    [anon_sym_BSLASHbibliography] = ACTIONS(5979),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5979),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5979),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5979),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5979),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5979),
    [anon_sym_BSLASHimport] = ACTIONS(5979),
    [anon_sym_BSLASHsubimport] = ACTIONS(5979),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5979),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5979),
    [anon_sym_BSLASHcaption] = ACTIONS(5979),
    [anon_sym_BSLASHcite] = ACTIONS(5979),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCite] = ACTIONS(5979),
    [anon_sym_BSLASHnocite] = ACTIONS(5979),
    [anon_sym_BSLASHcitet] = ACTIONS(5979),
    [anon_sym_BSLASHcitep] = ACTIONS(5979),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteA] = ACTIONS(5979),
    [anon_sym_BSLASHciteR] = ACTIONS(5979),
    [anon_sym_BSLASHciteS] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5979),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5979),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteyear] = ACTIONS(5979),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHcitedate] = ACTIONS(5979),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHciteurl] = ACTIONS(5979),
    [anon_sym_BSLASHfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5979),
    [anon_sym_BSLASHcitealt] = ACTIONS(5979),
    [anon_sym_BSLASHcitealp] = ACTIONS(5979),
    [anon_sym_BSLASHcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHparencite] = ACTIONS(5979),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHParencite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5979),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5979),
    [anon_sym_BSLASHtextcite] = ACTIONS(5979),
    [anon_sym_BSLASHTextcite] = ACTIONS(5979),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5979),
    [anon_sym_BSLASHsupercite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite] = ACTIONS(5979),
    [anon_sym_BSLASHAutocite] = ACTIONS(5979),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHVolcite] = ACTIONS(5979),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHavolcite] = ACTIONS(5979),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5979),
    [anon_sym_BSLASHnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHNotecite] = ACTIONS(5979),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5979),
    [anon_sym_BSLASHlabel] = ACTIONS(5979),
    [anon_sym_BSLASHref] = ACTIONS(5979),
    [anon_sym_BSLASHeqref] = ACTIONS(5979),
    [anon_sym_BSLASHvref] = ACTIONS(5979),
    [anon_sym_BSLASHVref] = ACTIONS(5979),
    [anon_sym_BSLASHautoref] = ACTIONS(5979),
    [anon_sym_BSLASHpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcref] = ACTIONS(5979),
    [anon_sym_BSLASHCref] = ACTIONS(5979),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnameCref] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5979),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5979),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5979),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5979),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5979),
    [anon_sym_BSLASHdef] = ACTIONS(5979),
    [anon_sym_BSLASHlet] = ACTIONS(5979),
    [anon_sym_BSLASHleft] = ACTIONS(5979),
    [anon_sym_BSLASHbigl] = ACTIONS(5979),
    [anon_sym_BSLASHBigl] = ACTIONS(5979),
    [anon_sym_BSLASHbiggl] = ACTIONS(5979),
    [anon_sym_BSLASHBiggl] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5979),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5979),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5979),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5979),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5979),
    [anon_sym_BSLASHgls] = ACTIONS(5979),
    [anon_sym_BSLASHGls] = ACTIONS(5979),
    [anon_sym_BSLASHGLS] = ACTIONS(5979),
    [anon_sym_BSLASHglspl] = ACTIONS(5979),
    [anon_sym_BSLASHGlspl] = ACTIONS(5979),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5979),
    [anon_sym_BSLASHglslink] = ACTIONS(5979),
    [anon_sym_BSLASHglstext] = ACTIONS(5979),
    [anon_sym_BSLASHGlstext] = ACTIONS(5979),
    [anon_sym_BSLASHGLStext] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5979),
    [anon_sym_BSLASHglsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5979),
    [anon_sym_BSLASHglsname] = ACTIONS(5979),
    [anon_sym_BSLASHGlsname] = ACTIONS(5979),
    [anon_sym_BSLASHGLSname] = ACTIONS(5979),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5979),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5979),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5979),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5979),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5979),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5979),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5979),
    [anon_sym_BSLASHacrshort] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5979),
    [anon_sym_BSLASHACRshort] = ACTIONS(5979),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrlong] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5979),
    [anon_sym_BSLASHACRlong] = ACTIONS(5979),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5979),
    [anon_sym_BSLASHacrfull] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5979),
    [anon_sym_BSLASHACRfull] = ACTIONS(5979),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHacs] = ACTIONS(5979),
    [anon_sym_BSLASHAcs] = ACTIONS(5979),
    [anon_sym_BSLASHacsp] = ACTIONS(5979),
    [anon_sym_BSLASHAcsp] = ACTIONS(5979),
    [anon_sym_BSLASHacl] = ACTIONS(5979),
    [anon_sym_BSLASHAcl] = ACTIONS(5979),
    [anon_sym_BSLASHaclp] = ACTIONS(5979),
    [anon_sym_BSLASHAclp] = ACTIONS(5979),
    [anon_sym_BSLASHacf] = ACTIONS(5979),
    [anon_sym_BSLASHAcf] = ACTIONS(5979),
    [anon_sym_BSLASHacfp] = ACTIONS(5979),
    [anon_sym_BSLASHAcfp] = ACTIONS(5979),
    [anon_sym_BSLASHac] = ACTIONS(5979),
    [anon_sym_BSLASHAc] = ACTIONS(5979),
    [anon_sym_BSLASHacp] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5979),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5979),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5979),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5979),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5981),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5979),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5979),
    [anon_sym_BSLASHcolor] = ACTIONS(5979),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5979),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5979),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5979),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5979),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5979),
    [anon_sym_BSLASHtext] = ACTIONS(5979),
    [anon_sym_BSLASHintertext] = ACTIONS(5979),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5979),
    [anon_sym_BSLASHurl] = ACTIONS(5979),
    [anon_sym_BSLASHhref] = ACTIONS(5979),
  },
  [837] = {
    [sym__section_part] = STATE(1093),
    [sym_curly_group] = STATE(1101),
    [sym_brack_group] = STATE(2738),
    [sym_command_name] = ACTIONS(5983),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5983),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(5985),
    [anon_sym_COMMA] = ACTIONS(5985),
    [anon_sym_EQ] = ACTIONS(5985),
    [anon_sym_LPAREN] = ACTIONS(5985),
    [anon_sym_RPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHpart] = ACTIONS(5983),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddpart] = ACTIONS(5983),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHchapter] = ACTIONS(5983),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddchap] = ACTIONS(5983),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsection] = ACTIONS(5983),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHaddsec] = ACTIONS(5983),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5983),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5983),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHitem] = ACTIONS(5983),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5985),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(5983),
    [sym_placeholder] = ACTIONS(5985),
    [anon_sym_PLUS] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5985),
    [anon_sym_STAR] = ACTIONS(5985),
    [anon_sym_SLASH] = ACTIONS(5985),
    [anon_sym_LT] = ACTIONS(5983),
    [anon_sym_GT] = ACTIONS(5983),
    [anon_sym_BANG] = ACTIONS(5983),
    [anon_sym_PIPE] = ACTIONS(5983),
    [anon_sym_COLON] = ACTIONS(5983),
    [anon_sym_SQUOTE] = ACTIONS(5983),
    [anon_sym__] = ACTIONS(5985),
    [anon_sym_CARET] = ACTIONS(5985),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5985),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5985),
    [anon_sym_DOLLAR] = ACTIONS(5983),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5985),
    [anon_sym_BSLASHbegin] = ACTIONS(5983),
    [anon_sym_BSLASHend] = ACTIONS(5983),
    [anon_sym_BSLASHtitle] = ACTIONS(5983),
    [anon_sym_BSLASHauthor] = ACTIONS(5983),
    [anon_sym_BSLASHusepackage] = ACTIONS(5983),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5983),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5983),
    [anon_sym_BSLASHinclude] = ACTIONS(5983),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5983),
    [anon_sym_BSLASHinput] = ACTIONS(5983),
    [anon_sym_BSLASHsubfile] = ACTIONS(5983),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5983),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5983),
    [anon_sym_BSLASHbibliography] = ACTIONS(5983),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5983),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5983),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5983),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5983),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5983),
    [anon_sym_BSLASHimport] = ACTIONS(5983),
    [anon_sym_BSLASHsubimport] = ACTIONS(5983),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5983),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5983),
    [anon_sym_BSLASHcaption] = ACTIONS(5983),
    [anon_sym_BSLASHcite] = ACTIONS(5983),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCite] = ACTIONS(5983),
    [anon_sym_BSLASHnocite] = ACTIONS(5983),
    [anon_sym_BSLASHcitet] = ACTIONS(5983),
    [anon_sym_BSLASHcitep] = ACTIONS(5983),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteA] = ACTIONS(5983),
    [anon_sym_BSLASHciteR] = ACTIONS(5983),
    [anon_sym_BSLASHciteS] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5983),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5983),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteyear] = ACTIONS(5983),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHcitedate] = ACTIONS(5983),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHciteurl] = ACTIONS(5983),
    [anon_sym_BSLASHfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5983),
    [anon_sym_BSLASHcitealt] = ACTIONS(5983),
    [anon_sym_BSLASHcitealp] = ACTIONS(5983),
    [anon_sym_BSLASHcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHparencite] = ACTIONS(5983),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHParencite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5983),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5983),
    [anon_sym_BSLASHtextcite] = ACTIONS(5983),
    [anon_sym_BSLASHTextcite] = ACTIONS(5983),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5983),
    [anon_sym_BSLASHsupercite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite] = ACTIONS(5983),
    [anon_sym_BSLASHAutocite] = ACTIONS(5983),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHVolcite] = ACTIONS(5983),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHavolcite] = ACTIONS(5983),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5983),
    [anon_sym_BSLASHnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHNotecite] = ACTIONS(5983),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5983),
    [anon_sym_BSLASHlabel] = ACTIONS(5983),
    [anon_sym_BSLASHref] = ACTIONS(5983),
    [anon_sym_BSLASHeqref] = ACTIONS(5983),
    [anon_sym_BSLASHvref] = ACTIONS(5983),
    [anon_sym_BSLASHVref] = ACTIONS(5983),
    [anon_sym_BSLASHautoref] = ACTIONS(5983),
    [anon_sym_BSLASHpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcref] = ACTIONS(5983),
    [anon_sym_BSLASHCref] = ACTIONS(5983),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnameCref] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5983),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5983),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5983),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5983),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5983),
    [anon_sym_BSLASHdef] = ACTIONS(5983),
    [anon_sym_BSLASHlet] = ACTIONS(5983),
    [anon_sym_BSLASHleft] = ACTIONS(5983),
    [anon_sym_BSLASHbigl] = ACTIONS(5983),
    [anon_sym_BSLASHBigl] = ACTIONS(5983),
    [anon_sym_BSLASHbiggl] = ACTIONS(5983),
    [anon_sym_BSLASHBiggl] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5983),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5983),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5983),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5983),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5983),
    [anon_sym_BSLASHgls] = ACTIONS(5983),
    [anon_sym_BSLASHGls] = ACTIONS(5983),
    [anon_sym_BSLASHGLS] = ACTIONS(5983),
    [anon_sym_BSLASHglspl] = ACTIONS(5983),
    [anon_sym_BSLASHGlspl] = ACTIONS(5983),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5983),
    [anon_sym_BSLASHglslink] = ACTIONS(5983),
    [anon_sym_BSLASHglstext] = ACTIONS(5983),
    [anon_sym_BSLASHGlstext] = ACTIONS(5983),
    [anon_sym_BSLASHGLStext] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5983),
    [anon_sym_BSLASHglsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5983),
    [anon_sym_BSLASHglsname] = ACTIONS(5983),
    [anon_sym_BSLASHGlsname] = ACTIONS(5983),
    [anon_sym_BSLASHGLSname] = ACTIONS(5983),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5983),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5983),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5983),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5983),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5983),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5983),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5983),
    [anon_sym_BSLASHacrshort] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5983),
    [anon_sym_BSLASHACRshort] = ACTIONS(5983),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrlong] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5983),
    [anon_sym_BSLASHACRlong] = ACTIONS(5983),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5983),
    [anon_sym_BSLASHacrfull] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5983),
    [anon_sym_BSLASHACRfull] = ACTIONS(5983),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHacs] = ACTIONS(5983),
    [anon_sym_BSLASHAcs] = ACTIONS(5983),
    [anon_sym_BSLASHacsp] = ACTIONS(5983),
    [anon_sym_BSLASHAcsp] = ACTIONS(5983),
    [anon_sym_BSLASHacl] = ACTIONS(5983),
    [anon_sym_BSLASHAcl] = ACTIONS(5983),
    [anon_sym_BSLASHaclp] = ACTIONS(5983),
    [anon_sym_BSLASHAclp] = ACTIONS(5983),
    [anon_sym_BSLASHacf] = ACTIONS(5983),
    [anon_sym_BSLASHAcf] = ACTIONS(5983),
    [anon_sym_BSLASHacfp] = ACTIONS(5983),
    [anon_sym_BSLASHAcfp] = ACTIONS(5983),
    [anon_sym_BSLASHac] = ACTIONS(5983),
    [anon_sym_BSLASHAc] = ACTIONS(5983),
    [anon_sym_BSLASHacp] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5983),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5983),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5983),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5983),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5985),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5983),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5983),
    [anon_sym_BSLASHcolor] = ACTIONS(5983),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5983),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5983),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5983),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5983),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5983),
    [anon_sym_BSLASHtext] = ACTIONS(5983),
    [anon_sym_BSLASHintertext] = ACTIONS(5983),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5983),
    [anon_sym_BSLASHurl] = ACTIONS(5983),
    [anon_sym_BSLASHhref] = ACTIONS(5983),
  },
  [838] = {
    [sym__section_part] = STATE(1092),
    [sym_curly_group] = STATE(1101),
    [sym_brack_group] = STATE(2738),
    [sym_command_name] = ACTIONS(6061),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6061),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6063),
    [anon_sym_COMMA] = ACTIONS(6063),
    [anon_sym_EQ] = ACTIONS(6063),
    [anon_sym_LPAREN] = ACTIONS(6063),
    [anon_sym_RPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHpart] = ACTIONS(6061),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddpart] = ACTIONS(6061),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHchapter] = ACTIONS(6061),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddchap] = ACTIONS(6061),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsection] = ACTIONS(6061),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHaddsec] = ACTIONS(6061),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6061),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6061),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHitem] = ACTIONS(6061),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6063),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6061),
    [sym_placeholder] = ACTIONS(6063),
    [anon_sym_PLUS] = ACTIONS(6063),
    [anon_sym_DASH] = ACTIONS(6063),
    [anon_sym_STAR] = ACTIONS(6063),
    [anon_sym_SLASH] = ACTIONS(6063),
    [anon_sym_LT] = ACTIONS(6061),
    [anon_sym_GT] = ACTIONS(6061),
    [anon_sym_BANG] = ACTIONS(6061),
    [anon_sym_PIPE] = ACTIONS(6061),
    [anon_sym_COLON] = ACTIONS(6061),
    [anon_sym_SQUOTE] = ACTIONS(6061),
    [anon_sym__] = ACTIONS(6063),
    [anon_sym_CARET] = ACTIONS(6063),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6063),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6063),
    [anon_sym_DOLLAR] = ACTIONS(6061),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6063),
    [anon_sym_BSLASHbegin] = ACTIONS(6061),
    [anon_sym_BSLASHend] = ACTIONS(6061),
    [anon_sym_BSLASHtitle] = ACTIONS(6061),
    [anon_sym_BSLASHauthor] = ACTIONS(6061),
    [anon_sym_BSLASHusepackage] = ACTIONS(6061),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6061),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6061),
    [anon_sym_BSLASHinclude] = ACTIONS(6061),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6061),
    [anon_sym_BSLASHinput] = ACTIONS(6061),
    [anon_sym_BSLASHsubfile] = ACTIONS(6061),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6061),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6061),
    [anon_sym_BSLASHbibliography] = ACTIONS(6061),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6061),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6061),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6061),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6061),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6061),
    [anon_sym_BSLASHimport] = ACTIONS(6061),
    [anon_sym_BSLASHsubimport] = ACTIONS(6061),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6061),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6061),
    [anon_sym_BSLASHcaption] = ACTIONS(6061),
    [anon_sym_BSLASHcite] = ACTIONS(6061),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCite] = ACTIONS(6061),
    [anon_sym_BSLASHnocite] = ACTIONS(6061),
    [anon_sym_BSLASHcitet] = ACTIONS(6061),
    [anon_sym_BSLASHcitep] = ACTIONS(6061),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteA] = ACTIONS(6061),
    [anon_sym_BSLASHciteR] = ACTIONS(6061),
    [anon_sym_BSLASHciteS] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6061),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6061),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteyear] = ACTIONS(6061),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHcitedate] = ACTIONS(6061),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHciteurl] = ACTIONS(6061),
    [anon_sym_BSLASHfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6061),
    [anon_sym_BSLASHcitealt] = ACTIONS(6061),
    [anon_sym_BSLASHcitealp] = ACTIONS(6061),
    [anon_sym_BSLASHcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHparencite] = ACTIONS(6061),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHParencite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6061),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6061),
    [anon_sym_BSLASHtextcite] = ACTIONS(6061),
    [anon_sym_BSLASHTextcite] = ACTIONS(6061),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6061),
    [anon_sym_BSLASHsupercite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite] = ACTIONS(6061),
    [anon_sym_BSLASHAutocite] = ACTIONS(6061),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHVolcite] = ACTIONS(6061),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHavolcite] = ACTIONS(6061),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6061),
    [anon_sym_BSLASHnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHNotecite] = ACTIONS(6061),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6061),
    [anon_sym_BSLASHlabel] = ACTIONS(6061),
    [anon_sym_BSLASHref] = ACTIONS(6061),
    [anon_sym_BSLASHeqref] = ACTIONS(6061),
    [anon_sym_BSLASHvref] = ACTIONS(6061),
    [anon_sym_BSLASHVref] = ACTIONS(6061),
    [anon_sym_BSLASHautoref] = ACTIONS(6061),
    [anon_sym_BSLASHpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcref] = ACTIONS(6061),
    [anon_sym_BSLASHCref] = ACTIONS(6061),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnameCref] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6061),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6061),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6061),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6061),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6061),
    [anon_sym_BSLASHdef] = ACTIONS(6061),
    [anon_sym_BSLASHlet] = ACTIONS(6061),
    [anon_sym_BSLASHleft] = ACTIONS(6061),
    [anon_sym_BSLASHbigl] = ACTIONS(6061),
    [anon_sym_BSLASHBigl] = ACTIONS(6061),
    [anon_sym_BSLASHbiggl] = ACTIONS(6061),
    [anon_sym_BSLASHBiggl] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6061),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6061),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6061),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6061),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6061),
    [anon_sym_BSLASHgls] = ACTIONS(6061),
    [anon_sym_BSLASHGls] = ACTIONS(6061),
    [anon_sym_BSLASHGLS] = ACTIONS(6061),
    [anon_sym_BSLASHglspl] = ACTIONS(6061),
    [anon_sym_BSLASHGlspl] = ACTIONS(6061),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6061),
    [anon_sym_BSLASHglslink] = ACTIONS(6061),
    [anon_sym_BSLASHglstext] = ACTIONS(6061),
    [anon_sym_BSLASHGlstext] = ACTIONS(6061),
    [anon_sym_BSLASHGLStext] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6061),
    [anon_sym_BSLASHglsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6061),
    [anon_sym_BSLASHglsname] = ACTIONS(6061),
    [anon_sym_BSLASHGlsname] = ACTIONS(6061),
    [anon_sym_BSLASHGLSname] = ACTIONS(6061),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6061),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6061),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6061),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6061),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6061),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6061),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6061),
    [anon_sym_BSLASHacrshort] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6061),
    [anon_sym_BSLASHACRshort] = ACTIONS(6061),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrlong] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6061),
    [anon_sym_BSLASHACRlong] = ACTIONS(6061),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6061),
    [anon_sym_BSLASHacrfull] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6061),
    [anon_sym_BSLASHACRfull] = ACTIONS(6061),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHacs] = ACTIONS(6061),
    [anon_sym_BSLASHAcs] = ACTIONS(6061),
    [anon_sym_BSLASHacsp] = ACTIONS(6061),
    [anon_sym_BSLASHAcsp] = ACTIONS(6061),
    [anon_sym_BSLASHacl] = ACTIONS(6061),
    [anon_sym_BSLASHAcl] = ACTIONS(6061),
    [anon_sym_BSLASHaclp] = ACTIONS(6061),
    [anon_sym_BSLASHAclp] = ACTIONS(6061),
    [anon_sym_BSLASHacf] = ACTIONS(6061),
    [anon_sym_BSLASHAcf] = ACTIONS(6061),
    [anon_sym_BSLASHacfp] = ACTIONS(6061),
    [anon_sym_BSLASHAcfp] = ACTIONS(6061),
    [anon_sym_BSLASHac] = ACTIONS(6061),
    [anon_sym_BSLASHAc] = ACTIONS(6061),
    [anon_sym_BSLASHacp] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6061),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6061),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6061),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6061),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6063),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6061),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6061),
    [anon_sym_BSLASHcolor] = ACTIONS(6061),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6061),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6061),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6061),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6061),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6061),
    [anon_sym_BSLASHtext] = ACTIONS(6061),
    [anon_sym_BSLASHintertext] = ACTIONS(6061),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6061),
    [anon_sym_BSLASHurl] = ACTIONS(6061),
    [anon_sym_BSLASHhref] = ACTIONS(6061),
  },
  [839] = {
    [sym__section_part] = STATE(1091),
    [sym_curly_group] = STATE(1101),
    [sym_brack_group] = STATE(2738),
    [sym_command_name] = ACTIONS(6081),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6083),
    [anon_sym_COMMA] = ACTIONS(6083),
    [anon_sym_EQ] = ACTIONS(6083),
    [anon_sym_LPAREN] = ACTIONS(6083),
    [anon_sym_RPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHpart] = ACTIONS(6081),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddpart] = ACTIONS(6081),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHchapter] = ACTIONS(6081),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddchap] = ACTIONS(6081),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsection] = ACTIONS(6081),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHaddsec] = ACTIONS(6081),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6081),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6081),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHitem] = ACTIONS(6081),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6083),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6081),
    [sym_placeholder] = ACTIONS(6083),
    [anon_sym_PLUS] = ACTIONS(6083),
    [anon_sym_DASH] = ACTIONS(6083),
    [anon_sym_STAR] = ACTIONS(6083),
    [anon_sym_SLASH] = ACTIONS(6083),
    [anon_sym_LT] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6081),
    [anon_sym_BANG] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6081),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_SQUOTE] = ACTIONS(6081),
    [anon_sym__] = ACTIONS(6083),
    [anon_sym_CARET] = ACTIONS(6083),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6083),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6083),
    [anon_sym_DOLLAR] = ACTIONS(6081),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6083),
    [anon_sym_BSLASHbegin] = ACTIONS(6081),
    [anon_sym_BSLASHend] = ACTIONS(6081),
    [anon_sym_BSLASHtitle] = ACTIONS(6081),
    [anon_sym_BSLASHauthor] = ACTIONS(6081),
    [anon_sym_BSLASHusepackage] = ACTIONS(6081),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6081),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6081),
    [anon_sym_BSLASHinclude] = ACTIONS(6081),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6081),
    [anon_sym_BSLASHinput] = ACTIONS(6081),
    [anon_sym_BSLASHsubfile] = ACTIONS(6081),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6081),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6081),
    [anon_sym_BSLASHbibliography] = ACTIONS(6081),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6081),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6081),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6081),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6081),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6081),
    [anon_sym_BSLASHimport] = ACTIONS(6081),
    [anon_sym_BSLASHsubimport] = ACTIONS(6081),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6081),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6081),
    [anon_sym_BSLASHcaption] = ACTIONS(6081),
    [anon_sym_BSLASHcite] = ACTIONS(6081),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCite] = ACTIONS(6081),
    [anon_sym_BSLASHnocite] = ACTIONS(6081),
    [anon_sym_BSLASHcitet] = ACTIONS(6081),
    [anon_sym_BSLASHcitep] = ACTIONS(6081),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteA] = ACTIONS(6081),
    [anon_sym_BSLASHciteR] = ACTIONS(6081),
    [anon_sym_BSLASHciteS] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6081),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6081),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteyear] = ACTIONS(6081),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHcitedate] = ACTIONS(6081),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHciteurl] = ACTIONS(6081),
    [anon_sym_BSLASHfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6081),
    [anon_sym_BSLASHcitealt] = ACTIONS(6081),
    [anon_sym_BSLASHcitealp] = ACTIONS(6081),
    [anon_sym_BSLASHcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHparencite] = ACTIONS(6081),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHParencite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6081),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6081),
    [anon_sym_BSLASHtextcite] = ACTIONS(6081),
    [anon_sym_BSLASHTextcite] = ACTIONS(6081),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6081),
    [anon_sym_BSLASHsupercite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite] = ACTIONS(6081),
    [anon_sym_BSLASHAutocite] = ACTIONS(6081),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHVolcite] = ACTIONS(6081),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHavolcite] = ACTIONS(6081),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6081),
    [anon_sym_BSLASHnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHNotecite] = ACTIONS(6081),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6081),
    [anon_sym_BSLASHlabel] = ACTIONS(6081),
    [anon_sym_BSLASHref] = ACTIONS(6081),
    [anon_sym_BSLASHeqref] = ACTIONS(6081),
    [anon_sym_BSLASHvref] = ACTIONS(6081),
    [anon_sym_BSLASHVref] = ACTIONS(6081),
    [anon_sym_BSLASHautoref] = ACTIONS(6081),
    [anon_sym_BSLASHpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcref] = ACTIONS(6081),
    [anon_sym_BSLASHCref] = ACTIONS(6081),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnameCref] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6081),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6081),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6081),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6081),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6081),
    [anon_sym_BSLASHdef] = ACTIONS(6081),
    [anon_sym_BSLASHlet] = ACTIONS(6081),
    [anon_sym_BSLASHleft] = ACTIONS(6081),
    [anon_sym_BSLASHbigl] = ACTIONS(6081),
    [anon_sym_BSLASHBigl] = ACTIONS(6081),
    [anon_sym_BSLASHbiggl] = ACTIONS(6081),
    [anon_sym_BSLASHBiggl] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6081),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6081),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6081),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6081),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6081),
    [anon_sym_BSLASHgls] = ACTIONS(6081),
    [anon_sym_BSLASHGls] = ACTIONS(6081),
    [anon_sym_BSLASHGLS] = ACTIONS(6081),
    [anon_sym_BSLASHglspl] = ACTIONS(6081),
    [anon_sym_BSLASHGlspl] = ACTIONS(6081),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6081),
    [anon_sym_BSLASHglslink] = ACTIONS(6081),
    [anon_sym_BSLASHglstext] = ACTIONS(6081),
    [anon_sym_BSLASHGlstext] = ACTIONS(6081),
    [anon_sym_BSLASHGLStext] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6081),
    [anon_sym_BSLASHglsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6081),
    [anon_sym_BSLASHglsname] = ACTIONS(6081),
    [anon_sym_BSLASHGlsname] = ACTIONS(6081),
    [anon_sym_BSLASHGLSname] = ACTIONS(6081),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6081),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6081),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6081),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6081),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6081),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6081),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6081),
    [anon_sym_BSLASHacrshort] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6081),
    [anon_sym_BSLASHACRshort] = ACTIONS(6081),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrlong] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6081),
    [anon_sym_BSLASHACRlong] = ACTIONS(6081),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6081),
    [anon_sym_BSLASHacrfull] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6081),
    [anon_sym_BSLASHACRfull] = ACTIONS(6081),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHacs] = ACTIONS(6081),
    [anon_sym_BSLASHAcs] = ACTIONS(6081),
    [anon_sym_BSLASHacsp] = ACTIONS(6081),
    [anon_sym_BSLASHAcsp] = ACTIONS(6081),
    [anon_sym_BSLASHacl] = ACTIONS(6081),
    [anon_sym_BSLASHAcl] = ACTIONS(6081),
    [anon_sym_BSLASHaclp] = ACTIONS(6081),
    [anon_sym_BSLASHAclp] = ACTIONS(6081),
    [anon_sym_BSLASHacf] = ACTIONS(6081),
    [anon_sym_BSLASHAcf] = ACTIONS(6081),
    [anon_sym_BSLASHacfp] = ACTIONS(6081),
    [anon_sym_BSLASHAcfp] = ACTIONS(6081),
    [anon_sym_BSLASHac] = ACTIONS(6081),
    [anon_sym_BSLASHAc] = ACTIONS(6081),
    [anon_sym_BSLASHacp] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6081),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6081),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6081),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6081),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6083),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6081),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6081),
    [anon_sym_BSLASHcolor] = ACTIONS(6081),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6081),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6081),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6081),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6081),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6081),
    [anon_sym_BSLASHtext] = ACTIONS(6081),
    [anon_sym_BSLASHintertext] = ACTIONS(6081),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6081),
    [anon_sym_BSLASHurl] = ACTIONS(6081),
    [anon_sym_BSLASHhref] = ACTIONS(6081),
  },
  [840] = {
    [sym_curly_group] = STATE(993),
    [aux_sym_generic_command_repeat1] = STATE(767),
    [ts_builtin_sym_end] = ACTIONS(6125),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6125),
    [anon_sym_RBRACK] = ACTIONS(6125),
    [anon_sym_COMMA] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_LPAREN] = ACTIONS(6125),
    [anon_sym_RPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHpart] = ACTIONS(6123),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddpart] = ACTIONS(6123),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHchapter] = ACTIONS(6123),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddchap] = ACTIONS(6123),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsection] = ACTIONS(6123),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddsec] = ACTIONS(6123),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHitem] = ACTIONS(6123),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6125),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6125),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6125),
    [anon_sym_DOLLAR] = ACTIONS(6123),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHbegin] = ACTIONS(6123),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHleft] = ACTIONS(6123),
    [anon_sym_BSLASHbigl] = ACTIONS(6123),
    [anon_sym_BSLASHBigl] = ACTIONS(6123),
    [anon_sym_BSLASHbiggl] = ACTIONS(6123),
    [anon_sym_BSLASHBiggl] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHtext] = ACTIONS(6123),
    [anon_sym_BSLASHintertext] = ACTIONS(6123),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [841] = {
    [sym__section_part] = STATE(1090),
    [sym_curly_group] = STATE(1101),
    [sym_brack_group] = STATE(2738),
    [sym_command_name] = ACTIONS(6101),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6101),
    [anon_sym_LBRACK] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(6103),
    [anon_sym_COMMA] = ACTIONS(6103),
    [anon_sym_EQ] = ACTIONS(6103),
    [anon_sym_LPAREN] = ACTIONS(6103),
    [anon_sym_RPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHpart] = ACTIONS(6101),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddpart] = ACTIONS(6101),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHchapter] = ACTIONS(6101),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddchap] = ACTIONS(6101),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsection] = ACTIONS(6101),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHaddsec] = ACTIONS(6101),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6101),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6101),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHitem] = ACTIONS(6101),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6103),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6101),
    [sym_placeholder] = ACTIONS(6103),
    [anon_sym_PLUS] = ACTIONS(6103),
    [anon_sym_DASH] = ACTIONS(6103),
    [anon_sym_STAR] = ACTIONS(6103),
    [anon_sym_SLASH] = ACTIONS(6103),
    [anon_sym_LT] = ACTIONS(6101),
    [anon_sym_GT] = ACTIONS(6101),
    [anon_sym_BANG] = ACTIONS(6101),
    [anon_sym_PIPE] = ACTIONS(6101),
    [anon_sym_COLON] = ACTIONS(6101),
    [anon_sym_SQUOTE] = ACTIONS(6101),
    [anon_sym__] = ACTIONS(6103),
    [anon_sym_CARET] = ACTIONS(6103),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6103),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6103),
    [anon_sym_DOLLAR] = ACTIONS(6101),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6103),
    [anon_sym_BSLASHbegin] = ACTIONS(6101),
    [anon_sym_BSLASHend] = ACTIONS(6101),
    [anon_sym_BSLASHtitle] = ACTIONS(6101),
    [anon_sym_BSLASHauthor] = ACTIONS(6101),
    [anon_sym_BSLASHusepackage] = ACTIONS(6101),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6101),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6101),
    [anon_sym_BSLASHinclude] = ACTIONS(6101),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6101),
    [anon_sym_BSLASHinput] = ACTIONS(6101),
    [anon_sym_BSLASHsubfile] = ACTIONS(6101),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6101),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6101),
    [anon_sym_BSLASHbibliography] = ACTIONS(6101),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6101),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6101),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6101),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6101),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6101),
    [anon_sym_BSLASHimport] = ACTIONS(6101),
    [anon_sym_BSLASHsubimport] = ACTIONS(6101),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6101),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6101),
    [anon_sym_BSLASHcaption] = ACTIONS(6101),
    [anon_sym_BSLASHcite] = ACTIONS(6101),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCite] = ACTIONS(6101),
    [anon_sym_BSLASHnocite] = ACTIONS(6101),
    [anon_sym_BSLASHcitet] = ACTIONS(6101),
    [anon_sym_BSLASHcitep] = ACTIONS(6101),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteA] = ACTIONS(6101),
    [anon_sym_BSLASHciteR] = ACTIONS(6101),
    [anon_sym_BSLASHciteS] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6101),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6101),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteyear] = ACTIONS(6101),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHcitedate] = ACTIONS(6101),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHciteurl] = ACTIONS(6101),
    [anon_sym_BSLASHfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6101),
    [anon_sym_BSLASHcitealt] = ACTIONS(6101),
    [anon_sym_BSLASHcitealp] = ACTIONS(6101),
    [anon_sym_BSLASHcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHparencite] = ACTIONS(6101),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHParencite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6101),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6101),
    [anon_sym_BSLASHtextcite] = ACTIONS(6101),
    [anon_sym_BSLASHTextcite] = ACTIONS(6101),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6101),
    [anon_sym_BSLASHsupercite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite] = ACTIONS(6101),
    [anon_sym_BSLASHAutocite] = ACTIONS(6101),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHVolcite] = ACTIONS(6101),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHavolcite] = ACTIONS(6101),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6101),
    [anon_sym_BSLASHnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHNotecite] = ACTIONS(6101),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6101),
    [anon_sym_BSLASHlabel] = ACTIONS(6101),
    [anon_sym_BSLASHref] = ACTIONS(6101),
    [anon_sym_BSLASHeqref] = ACTIONS(6101),
    [anon_sym_BSLASHvref] = ACTIONS(6101),
    [anon_sym_BSLASHVref] = ACTIONS(6101),
    [anon_sym_BSLASHautoref] = ACTIONS(6101),
    [anon_sym_BSLASHpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcref] = ACTIONS(6101),
    [anon_sym_BSLASHCref] = ACTIONS(6101),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnameCref] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6101),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6101),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6101),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6101),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6101),
    [anon_sym_BSLASHdef] = ACTIONS(6101),
    [anon_sym_BSLASHlet] = ACTIONS(6101),
    [anon_sym_BSLASHleft] = ACTIONS(6101),
    [anon_sym_BSLASHbigl] = ACTIONS(6101),
    [anon_sym_BSLASHBigl] = ACTIONS(6101),
    [anon_sym_BSLASHbiggl] = ACTIONS(6101),
    [anon_sym_BSLASHBiggl] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6101),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6101),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6101),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6101),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6101),
    [anon_sym_BSLASHgls] = ACTIONS(6101),
    [anon_sym_BSLASHGls] = ACTIONS(6101),
    [anon_sym_BSLASHGLS] = ACTIONS(6101),
    [anon_sym_BSLASHglspl] = ACTIONS(6101),
    [anon_sym_BSLASHGlspl] = ACTIONS(6101),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6101),
    [anon_sym_BSLASHglslink] = ACTIONS(6101),
    [anon_sym_BSLASHglstext] = ACTIONS(6101),
    [anon_sym_BSLASHGlstext] = ACTIONS(6101),
    [anon_sym_BSLASHGLStext] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6101),
    [anon_sym_BSLASHglsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6101),
    [anon_sym_BSLASHglsname] = ACTIONS(6101),
    [anon_sym_BSLASHGlsname] = ACTIONS(6101),
    [anon_sym_BSLASHGLSname] = ACTIONS(6101),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6101),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6101),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6101),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6101),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6101),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6101),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6101),
    [anon_sym_BSLASHacrshort] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6101),
    [anon_sym_BSLASHACRshort] = ACTIONS(6101),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrlong] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6101),
    [anon_sym_BSLASHACRlong] = ACTIONS(6101),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6101),
    [anon_sym_BSLASHacrfull] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6101),
    [anon_sym_BSLASHACRfull] = ACTIONS(6101),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHacs] = ACTIONS(6101),
    [anon_sym_BSLASHAcs] = ACTIONS(6101),
    [anon_sym_BSLASHacsp] = ACTIONS(6101),
    [anon_sym_BSLASHAcsp] = ACTIONS(6101),
    [anon_sym_BSLASHacl] = ACTIONS(6101),
    [anon_sym_BSLASHAcl] = ACTIONS(6101),
    [anon_sym_BSLASHaclp] = ACTIONS(6101),
    [anon_sym_BSLASHAclp] = ACTIONS(6101),
    [anon_sym_BSLASHacf] = ACTIONS(6101),
    [anon_sym_BSLASHAcf] = ACTIONS(6101),
    [anon_sym_BSLASHacfp] = ACTIONS(6101),
    [anon_sym_BSLASHAcfp] = ACTIONS(6101),
    [anon_sym_BSLASHac] = ACTIONS(6101),
    [anon_sym_BSLASHAc] = ACTIONS(6101),
    [anon_sym_BSLASHacp] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6101),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6101),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6101),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6101),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6103),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6101),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6101),
    [anon_sym_BSLASHcolor] = ACTIONS(6101),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6101),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6101),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6101),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6101),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6101),
    [anon_sym_BSLASHtext] = ACTIONS(6101),
    [anon_sym_BSLASHintertext] = ACTIONS(6101),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6101),
    [anon_sym_BSLASHurl] = ACTIONS(6101),
    [anon_sym_BSLASHhref] = ACTIONS(6101),
  },
  [842] = {
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(720),
    [aux_sym__section_repeat2] = STATE(720),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHend] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [843] = {
    [sym__part_declaration] = STATE(159),
    [sym_part] = STATE(724),
    [aux_sym__section_repeat1] = STATE(724),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(652),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHaddpart] = ACTIONS(652),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(654),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHend] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [844] = {
    [sym__chapter_declaration] = STATE(169),
    [sym_chapter] = STATE(720),
    [aux_sym__section_repeat2] = STATE(720),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(656),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(658),
    [anon_sym_BSLASHaddchap] = ACTIONS(656),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(658),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHend] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [845] = {
    [sym__section_declaration] = STATE(179),
    [sym_section] = STATE(718),
    [aux_sym__section_repeat3] = STATE(718),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(660),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(662),
    [anon_sym_BSLASHaddsec] = ACTIONS(660),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(662),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHend] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [846] = {
    [sym__subsection_declaration] = STATE(187),
    [sym_subsection] = STATE(716),
    [aux_sym__section_repeat4] = STATE(716),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(664),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(666),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHend] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [847] = {
    [sym__subsubsection_declaration] = STATE(194),
    [sym_subsubsection] = STATE(714),
    [aux_sym__section_repeat5] = STATE(714),
    [sym_command_name] = ACTIONS(6077),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6077),
    [anon_sym_LBRACK] = ACTIONS(6079),
    [anon_sym_RBRACK] = ACTIONS(6079),
    [anon_sym_COMMA] = ACTIONS(6079),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_LPAREN] = ACTIONS(6079),
    [anon_sym_RPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHpart] = ACTIONS(6077),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddpart] = ACTIONS(6077),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHchapter] = ACTIONS(6077),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddchap] = ACTIONS(6077),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsection] = ACTIONS(6077),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHaddsec] = ACTIONS(6077),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsection] = ACTIONS(6077),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(668),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(670),
    [anon_sym_BSLASHparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6077),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHitem] = ACTIONS(6077),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(6079),
    [sym_word] = ACTIONS(6077),
    [sym_placeholder] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6077),
    [anon_sym_GT] = ACTIONS(6077),
    [anon_sym_BANG] = ACTIONS(6077),
    [anon_sym_PIPE] = ACTIONS(6077),
    [anon_sym_COLON] = ACTIONS(6077),
    [anon_sym_SQUOTE] = ACTIONS(6077),
    [anon_sym__] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6079),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6077),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6079),
    [anon_sym_BSLASHbegin] = ACTIONS(6077),
    [anon_sym_BSLASHend] = ACTIONS(6077),
    [anon_sym_BSLASHtitle] = ACTIONS(6077),
    [anon_sym_BSLASHauthor] = ACTIONS(6077),
    [anon_sym_BSLASHusepackage] = ACTIONS(6077),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6077),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6077),
    [anon_sym_BSLASHinclude] = ACTIONS(6077),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6077),
    [anon_sym_BSLASHinput] = ACTIONS(6077),
    [anon_sym_BSLASHsubfile] = ACTIONS(6077),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6077),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6077),
    [anon_sym_BSLASHbibliography] = ACTIONS(6077),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6077),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6077),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6077),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6077),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6077),
    [anon_sym_BSLASHimport] = ACTIONS(6077),
    [anon_sym_BSLASHsubimport] = ACTIONS(6077),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6077),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6077),
    [anon_sym_BSLASHcaption] = ACTIONS(6077),
    [anon_sym_BSLASHcite] = ACTIONS(6077),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCite] = ACTIONS(6077),
    [anon_sym_BSLASHnocite] = ACTIONS(6077),
    [anon_sym_BSLASHcitet] = ACTIONS(6077),
    [anon_sym_BSLASHcitep] = ACTIONS(6077),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteA] = ACTIONS(6077),
    [anon_sym_BSLASHciteR] = ACTIONS(6077),
    [anon_sym_BSLASHciteS] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6077),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6077),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteyear] = ACTIONS(6077),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHcitedate] = ACTIONS(6077),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHciteurl] = ACTIONS(6077),
    [anon_sym_BSLASHfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6077),
    [anon_sym_BSLASHcitealt] = ACTIONS(6077),
    [anon_sym_BSLASHcitealp] = ACTIONS(6077),
    [anon_sym_BSLASHcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHparencite] = ACTIONS(6077),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHParencite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6077),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6077),
    [anon_sym_BSLASHtextcite] = ACTIONS(6077),
    [anon_sym_BSLASHTextcite] = ACTIONS(6077),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6077),
    [anon_sym_BSLASHsupercite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite] = ACTIONS(6077),
    [anon_sym_BSLASHAutocite] = ACTIONS(6077),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHVolcite] = ACTIONS(6077),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHavolcite] = ACTIONS(6077),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6077),
    [anon_sym_BSLASHnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHNotecite] = ACTIONS(6077),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6077),
    [anon_sym_BSLASHlabel] = ACTIONS(6077),
    [anon_sym_BSLASHref] = ACTIONS(6077),
    [anon_sym_BSLASHeqref] = ACTIONS(6077),
    [anon_sym_BSLASHvref] = ACTIONS(6077),
    [anon_sym_BSLASHVref] = ACTIONS(6077),
    [anon_sym_BSLASHautoref] = ACTIONS(6077),
    [anon_sym_BSLASHpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcref] = ACTIONS(6077),
    [anon_sym_BSLASHCref] = ACTIONS(6077),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnameCref] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6077),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6077),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6077),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6077),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6077),
    [anon_sym_BSLASHdef] = ACTIONS(6077),
    [anon_sym_BSLASHlet] = ACTIONS(6077),
    [anon_sym_BSLASHleft] = ACTIONS(6077),
    [anon_sym_BSLASHbigl] = ACTIONS(6077),
    [anon_sym_BSLASHBigl] = ACTIONS(6077),
    [anon_sym_BSLASHbiggl] = ACTIONS(6077),
    [anon_sym_BSLASHBiggl] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6077),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6077),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6077),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6077),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6077),
    [anon_sym_BSLASHgls] = ACTIONS(6077),
    [anon_sym_BSLASHGls] = ACTIONS(6077),
    [anon_sym_BSLASHGLS] = ACTIONS(6077),
    [anon_sym_BSLASHglspl] = ACTIONS(6077),
    [anon_sym_BSLASHGlspl] = ACTIONS(6077),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6077),
    [anon_sym_BSLASHglslink] = ACTIONS(6077),
    [anon_sym_BSLASHglstext] = ACTIONS(6077),
    [anon_sym_BSLASHGlstext] = ACTIONS(6077),
    [anon_sym_BSLASHGLStext] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6077),
    [anon_sym_BSLASHglsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6077),
    [anon_sym_BSLASHglsname] = ACTIONS(6077),
    [anon_sym_BSLASHGlsname] = ACTIONS(6077),
    [anon_sym_BSLASHGLSname] = ACTIONS(6077),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6077),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6077),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6077),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6077),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6077),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6077),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6077),
    [anon_sym_BSLASHacrshort] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6077),
    [anon_sym_BSLASHACRshort] = ACTIONS(6077),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrlong] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6077),
    [anon_sym_BSLASHACRlong] = ACTIONS(6077),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6077),
    [anon_sym_BSLASHacrfull] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6077),
    [anon_sym_BSLASHACRfull] = ACTIONS(6077),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHacs] = ACTIONS(6077),
    [anon_sym_BSLASHAcs] = ACTIONS(6077),
    [anon_sym_BSLASHacsp] = ACTIONS(6077),
    [anon_sym_BSLASHAcsp] = ACTIONS(6077),
    [anon_sym_BSLASHacl] = ACTIONS(6077),
    [anon_sym_BSLASHAcl] = ACTIONS(6077),
    [anon_sym_BSLASHaclp] = ACTIONS(6077),
    [anon_sym_BSLASHAclp] = ACTIONS(6077),
    [anon_sym_BSLASHacf] = ACTIONS(6077),
    [anon_sym_BSLASHAcf] = ACTIONS(6077),
    [anon_sym_BSLASHacfp] = ACTIONS(6077),
    [anon_sym_BSLASHAcfp] = ACTIONS(6077),
    [anon_sym_BSLASHac] = ACTIONS(6077),
    [anon_sym_BSLASHAc] = ACTIONS(6077),
    [anon_sym_BSLASHacp] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6077),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6077),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6077),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6077),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6079),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6077),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6077),
    [anon_sym_BSLASHcolor] = ACTIONS(6077),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6077),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6077),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6077),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6077),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6077),
    [anon_sym_BSLASHtext] = ACTIONS(6077),
    [anon_sym_BSLASHintertext] = ACTIONS(6077),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6077),
    [anon_sym_BSLASHurl] = ACTIONS(6077),
    [anon_sym_BSLASHhref] = ACTIONS(6077),
  },
  [848] = {
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(822),
    [aux_sym__section_repeat2] = STATE(822),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [849] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [850] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [851] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [852] = {
    [sym__chapter_declaration] = STATE(165),
    [sym_chapter] = STATE(822),
    [aux_sym__section_repeat2] = STATE(822),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(620),
    [anon_sym_BSLASHaddchap] = ACTIONS(618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(620),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [853] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [854] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [855] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(5808),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5810),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_COMMA] = ACTIONS(5810),
    [anon_sym_EQ] = ACTIONS(5810),
    [anon_sym_LPAREN] = ACTIONS(5810),
    [anon_sym_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHpart] = ACTIONS(5808),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddpart] = ACTIONS(5808),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHchapter] = ACTIONS(5808),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddchap] = ACTIONS(5808),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsection] = ACTIONS(5808),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHaddsec] = ACTIONS(5808),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsection] = ACTIONS(5808),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5808),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHitem] = ACTIONS(5808),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(5810),
    [sym_word] = ACTIONS(5808),
    [sym_placeholder] = ACTIONS(5810),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_DASH] = ACTIONS(5810),
    [anon_sym_STAR] = ACTIONS(5810),
    [anon_sym_SLASH] = ACTIONS(5810),
    [anon_sym_LT] = ACTIONS(5808),
    [anon_sym_GT] = ACTIONS(5808),
    [anon_sym_BANG] = ACTIONS(5808),
    [anon_sym_PIPE] = ACTIONS(5808),
    [anon_sym_COLON] = ACTIONS(5808),
    [anon_sym_SQUOTE] = ACTIONS(5808),
    [anon_sym__] = ACTIONS(5810),
    [anon_sym_CARET] = ACTIONS(5810),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5810),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5810),
    [anon_sym_DOLLAR] = ACTIONS(5808),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5810),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5810),
    [anon_sym_BSLASHbegin] = ACTIONS(5808),
    [anon_sym_BSLASHtitle] = ACTIONS(5808),
    [anon_sym_BSLASHauthor] = ACTIONS(5808),
    [anon_sym_BSLASHusepackage] = ACTIONS(5808),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5808),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5808),
    [anon_sym_BSLASHinclude] = ACTIONS(5808),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5808),
    [anon_sym_BSLASHinput] = ACTIONS(5808),
    [anon_sym_BSLASHsubfile] = ACTIONS(5808),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5808),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5808),
    [anon_sym_BSLASHbibliography] = ACTIONS(5808),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5808),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5808),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5808),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5808),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5808),
    [anon_sym_BSLASHimport] = ACTIONS(5808),
    [anon_sym_BSLASHsubimport] = ACTIONS(5808),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5808),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5808),
    [anon_sym_BSLASHcaption] = ACTIONS(5808),
    [anon_sym_BSLASHcite] = ACTIONS(5808),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCite] = ACTIONS(5808),
    [anon_sym_BSLASHnocite] = ACTIONS(5808),
    [anon_sym_BSLASHcitet] = ACTIONS(5808),
    [anon_sym_BSLASHcitep] = ACTIONS(5808),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteA] = ACTIONS(5808),
    [anon_sym_BSLASHciteR] = ACTIONS(5808),
    [anon_sym_BSLASHciteS] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5808),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5808),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteyear] = ACTIONS(5808),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHcitedate] = ACTIONS(5808),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHciteurl] = ACTIONS(5808),
    [anon_sym_BSLASHfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5808),
    [anon_sym_BSLASHcitealt] = ACTIONS(5808),
    [anon_sym_BSLASHcitealp] = ACTIONS(5808),
    [anon_sym_BSLASHcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHparencite] = ACTIONS(5808),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHParencite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5808),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5808),
    [anon_sym_BSLASHtextcite] = ACTIONS(5808),
    [anon_sym_BSLASHTextcite] = ACTIONS(5808),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5808),
    [anon_sym_BSLASHsupercite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite] = ACTIONS(5808),
    [anon_sym_BSLASHAutocite] = ACTIONS(5808),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHVolcite] = ACTIONS(5808),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHavolcite] = ACTIONS(5808),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5808),
    [anon_sym_BSLASHnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHNotecite] = ACTIONS(5808),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5808),
    [anon_sym_BSLASHlabel] = ACTIONS(5808),
    [anon_sym_BSLASHref] = ACTIONS(5808),
    [anon_sym_BSLASHeqref] = ACTIONS(5808),
    [anon_sym_BSLASHvref] = ACTIONS(5808),
    [anon_sym_BSLASHVref] = ACTIONS(5808),
    [anon_sym_BSLASHautoref] = ACTIONS(5808),
    [anon_sym_BSLASHpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcref] = ACTIONS(5808),
    [anon_sym_BSLASHCref] = ACTIONS(5808),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnameCref] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5808),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5808),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5808),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5808),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5808),
    [anon_sym_BSLASHdef] = ACTIONS(5808),
    [anon_sym_BSLASHlet] = ACTIONS(5808),
    [anon_sym_BSLASHleft] = ACTIONS(5808),
    [anon_sym_BSLASHbigl] = ACTIONS(5808),
    [anon_sym_BSLASHBigl] = ACTIONS(5808),
    [anon_sym_BSLASHbiggl] = ACTIONS(5808),
    [anon_sym_BSLASHBiggl] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5808),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5808),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5808),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5808),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5808),
    [anon_sym_BSLASHgls] = ACTIONS(5808),
    [anon_sym_BSLASHGls] = ACTIONS(5808),
    [anon_sym_BSLASHGLS] = ACTIONS(5808),
    [anon_sym_BSLASHglspl] = ACTIONS(5808),
    [anon_sym_BSLASHGlspl] = ACTIONS(5808),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5808),
    [anon_sym_BSLASHglslink] = ACTIONS(5808),
    [anon_sym_BSLASHglstext] = ACTIONS(5808),
    [anon_sym_BSLASHGlstext] = ACTIONS(5808),
    [anon_sym_BSLASHGLStext] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5808),
    [anon_sym_BSLASHglsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5808),
    [anon_sym_BSLASHglsname] = ACTIONS(5808),
    [anon_sym_BSLASHGlsname] = ACTIONS(5808),
    [anon_sym_BSLASHGLSname] = ACTIONS(5808),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5808),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5808),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5808),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5808),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5808),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5808),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5808),
    [anon_sym_BSLASHacrshort] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5808),
    [anon_sym_BSLASHACRshort] = ACTIONS(5808),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrlong] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5808),
    [anon_sym_BSLASHACRlong] = ACTIONS(5808),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5808),
    [anon_sym_BSLASHacrfull] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5808),
    [anon_sym_BSLASHACRfull] = ACTIONS(5808),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHacs] = ACTIONS(5808),
    [anon_sym_BSLASHAcs] = ACTIONS(5808),
    [anon_sym_BSLASHacsp] = ACTIONS(5808),
    [anon_sym_BSLASHAcsp] = ACTIONS(5808),
    [anon_sym_BSLASHacl] = ACTIONS(5808),
    [anon_sym_BSLASHAcl] = ACTIONS(5808),
    [anon_sym_BSLASHaclp] = ACTIONS(5808),
    [anon_sym_BSLASHAclp] = ACTIONS(5808),
    [anon_sym_BSLASHacf] = ACTIONS(5808),
    [anon_sym_BSLASHAcf] = ACTIONS(5808),
    [anon_sym_BSLASHacfp] = ACTIONS(5808),
    [anon_sym_BSLASHAcfp] = ACTIONS(5808),
    [anon_sym_BSLASHac] = ACTIONS(5808),
    [anon_sym_BSLASHAc] = ACTIONS(5808),
    [anon_sym_BSLASHacp] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5808),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5808),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5808),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5808),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5810),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5808),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5808),
    [anon_sym_BSLASHcolor] = ACTIONS(5808),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5808),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5808),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5808),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5808),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5808),
    [anon_sym_BSLASHtext] = ACTIONS(5808),
    [anon_sym_BSLASHintertext] = ACTIONS(5808),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5808),
    [anon_sym_BSLASHurl] = ACTIONS(5808),
    [anon_sym_BSLASHhref] = ACTIONS(5808),
  },
  [856] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [857] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [858] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [859] = {
    [sym__section_declaration] = STATE(175),
    [sym_section] = STATE(823),
    [aux_sym__section_repeat3] = STATE(823),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(624),
    [anon_sym_BSLASHaddsec] = ACTIONS(622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(624),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [860] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [861] = {
    [sym__subsubsection_declaration] = STATE(199),
    [sym_subsubsection] = STATE(825),
    [aux_sym__section_repeat5] = STATE(825),
    [sym_command_name] = ACTIONS(5953),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5955),
    [anon_sym_RBRACK] = ACTIONS(5955),
    [anon_sym_COMMA] = ACTIONS(5955),
    [anon_sym_EQ] = ACTIONS(5955),
    [anon_sym_LPAREN] = ACTIONS(5955),
    [anon_sym_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHpart] = ACTIONS(5953),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddpart] = ACTIONS(5953),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHchapter] = ACTIONS(5953),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddchap] = ACTIONS(5953),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsection] = ACTIONS(5953),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHaddsec] = ACTIONS(5953),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsection] = ACTIONS(5953),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(632),
    [anon_sym_BSLASHparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5953),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHitem] = ACTIONS(5953),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5955),
    [anon_sym_LBRACE] = ACTIONS(5955),
    [sym_word] = ACTIONS(5953),
    [sym_placeholder] = ACTIONS(5955),
    [anon_sym_PLUS] = ACTIONS(5955),
    [anon_sym_DASH] = ACTIONS(5955),
    [anon_sym_STAR] = ACTIONS(5955),
    [anon_sym_SLASH] = ACTIONS(5955),
    [anon_sym_LT] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5953),
    [anon_sym_BANG] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_SQUOTE] = ACTIONS(5953),
    [anon_sym__] = ACTIONS(5955),
    [anon_sym_CARET] = ACTIONS(5955),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5955),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5955),
    [anon_sym_DOLLAR] = ACTIONS(5953),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5955),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5955),
    [anon_sym_BSLASHbegin] = ACTIONS(5953),
    [anon_sym_BSLASHtitle] = ACTIONS(5953),
    [anon_sym_BSLASHauthor] = ACTIONS(5953),
    [anon_sym_BSLASHusepackage] = ACTIONS(5953),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5953),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5953),
    [anon_sym_BSLASHinclude] = ACTIONS(5953),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5953),
    [anon_sym_BSLASHinput] = ACTIONS(5953),
    [anon_sym_BSLASHsubfile] = ACTIONS(5953),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5953),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5953),
    [anon_sym_BSLASHbibliography] = ACTIONS(5953),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5953),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5953),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5953),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5953),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5953),
    [anon_sym_BSLASHimport] = ACTIONS(5953),
    [anon_sym_BSLASHsubimport] = ACTIONS(5953),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5953),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5953),
    [anon_sym_BSLASHcaption] = ACTIONS(5953),
    [anon_sym_BSLASHcite] = ACTIONS(5953),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCite] = ACTIONS(5953),
    [anon_sym_BSLASHnocite] = ACTIONS(5953),
    [anon_sym_BSLASHcitet] = ACTIONS(5953),
    [anon_sym_BSLASHcitep] = ACTIONS(5953),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteA] = ACTIONS(5953),
    [anon_sym_BSLASHciteR] = ACTIONS(5953),
    [anon_sym_BSLASHciteS] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5953),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5953),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteyear] = ACTIONS(5953),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHcitedate] = ACTIONS(5953),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHciteurl] = ACTIONS(5953),
    [anon_sym_BSLASHfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5953),
    [anon_sym_BSLASHcitealt] = ACTIONS(5953),
    [anon_sym_BSLASHcitealp] = ACTIONS(5953),
    [anon_sym_BSLASHcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHparencite] = ACTIONS(5953),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHParencite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5953),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5953),
    [anon_sym_BSLASHtextcite] = ACTIONS(5953),
    [anon_sym_BSLASHTextcite] = ACTIONS(5953),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5953),
    [anon_sym_BSLASHsupercite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite] = ACTIONS(5953),
    [anon_sym_BSLASHAutocite] = ACTIONS(5953),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHVolcite] = ACTIONS(5953),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHavolcite] = ACTIONS(5953),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5953),
    [anon_sym_BSLASHnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHNotecite] = ACTIONS(5953),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5953),
    [anon_sym_BSLASHlabel] = ACTIONS(5953),
    [anon_sym_BSLASHref] = ACTIONS(5953),
    [anon_sym_BSLASHeqref] = ACTIONS(5953),
    [anon_sym_BSLASHvref] = ACTIONS(5953),
    [anon_sym_BSLASHVref] = ACTIONS(5953),
    [anon_sym_BSLASHautoref] = ACTIONS(5953),
    [anon_sym_BSLASHpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcref] = ACTIONS(5953),
    [anon_sym_BSLASHCref] = ACTIONS(5953),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnameCref] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5953),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5953),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5953),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5953),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5953),
    [anon_sym_BSLASHdef] = ACTIONS(5953),
    [anon_sym_BSLASHlet] = ACTIONS(5953),
    [anon_sym_BSLASHleft] = ACTIONS(5953),
    [anon_sym_BSLASHbigl] = ACTIONS(5953),
    [anon_sym_BSLASHBigl] = ACTIONS(5953),
    [anon_sym_BSLASHbiggl] = ACTIONS(5953),
    [anon_sym_BSLASHBiggl] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5953),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5953),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5953),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5953),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5953),
    [anon_sym_BSLASHgls] = ACTIONS(5953),
    [anon_sym_BSLASHGls] = ACTIONS(5953),
    [anon_sym_BSLASHGLS] = ACTIONS(5953),
    [anon_sym_BSLASHglspl] = ACTIONS(5953),
    [anon_sym_BSLASHGlspl] = ACTIONS(5953),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5953),
    [anon_sym_BSLASHglslink] = ACTIONS(5953),
    [anon_sym_BSLASHglstext] = ACTIONS(5953),
    [anon_sym_BSLASHGlstext] = ACTIONS(5953),
    [anon_sym_BSLASHGLStext] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5953),
    [anon_sym_BSLASHglsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5953),
    [anon_sym_BSLASHglsname] = ACTIONS(5953),
    [anon_sym_BSLASHGlsname] = ACTIONS(5953),
    [anon_sym_BSLASHGLSname] = ACTIONS(5953),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5953),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5953),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5953),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5953),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5953),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5953),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5953),
    [anon_sym_BSLASHacrshort] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5953),
    [anon_sym_BSLASHACRshort] = ACTIONS(5953),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrlong] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5953),
    [anon_sym_BSLASHACRlong] = ACTIONS(5953),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5953),
    [anon_sym_BSLASHacrfull] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5953),
    [anon_sym_BSLASHACRfull] = ACTIONS(5953),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHacs] = ACTIONS(5953),
    [anon_sym_BSLASHAcs] = ACTIONS(5953),
    [anon_sym_BSLASHacsp] = ACTIONS(5953),
    [anon_sym_BSLASHAcsp] = ACTIONS(5953),
    [anon_sym_BSLASHacl] = ACTIONS(5953),
    [anon_sym_BSLASHAcl] = ACTIONS(5953),
    [anon_sym_BSLASHaclp] = ACTIONS(5953),
    [anon_sym_BSLASHAclp] = ACTIONS(5953),
    [anon_sym_BSLASHacf] = ACTIONS(5953),
    [anon_sym_BSLASHAcf] = ACTIONS(5953),
    [anon_sym_BSLASHacfp] = ACTIONS(5953),
    [anon_sym_BSLASHAcfp] = ACTIONS(5953),
    [anon_sym_BSLASHac] = ACTIONS(5953),
    [anon_sym_BSLASHAc] = ACTIONS(5953),
    [anon_sym_BSLASHacp] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5953),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5953),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5953),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5953),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5955),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5953),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5953),
    [anon_sym_BSLASHcolor] = ACTIONS(5953),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5953),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5953),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5953),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5953),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5953),
    [anon_sym_BSLASHtext] = ACTIONS(5953),
    [anon_sym_BSLASHintertext] = ACTIONS(5953),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5953),
    [anon_sym_BSLASHurl] = ACTIONS(5953),
    [anon_sym_BSLASHhref] = ACTIONS(5953),
  },
  [862] = {
    [sym__subsection_declaration] = STATE(189),
    [sym_subsection] = STATE(824),
    [aux_sym__section_repeat4] = STATE(824),
    [sym_command_name] = ACTIONS(5957),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(5957),
    [anon_sym_LBRACK] = ACTIONS(5959),
    [anon_sym_RBRACK] = ACTIONS(5959),
    [anon_sym_COMMA] = ACTIONS(5959),
    [anon_sym_EQ] = ACTIONS(5959),
    [anon_sym_LPAREN] = ACTIONS(5959),
    [anon_sym_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHpart] = ACTIONS(5957),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddpart] = ACTIONS(5957),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHchapter] = ACTIONS(5957),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddchap] = ACTIONS(5957),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsection] = ACTIONS(5957),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHaddsec] = ACTIONS(5957),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubsection] = ACTIONS(626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(5957),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(5957),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHitem] = ACTIONS(5957),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(5959),
    [anon_sym_LBRACE] = ACTIONS(5959),
    [sym_word] = ACTIONS(5957),
    [sym_placeholder] = ACTIONS(5959),
    [anon_sym_PLUS] = ACTIONS(5959),
    [anon_sym_DASH] = ACTIONS(5959),
    [anon_sym_STAR] = ACTIONS(5959),
    [anon_sym_SLASH] = ACTIONS(5959),
    [anon_sym_LT] = ACTIONS(5957),
    [anon_sym_GT] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5957),
    [anon_sym_PIPE] = ACTIONS(5957),
    [anon_sym_COLON] = ACTIONS(5957),
    [anon_sym_SQUOTE] = ACTIONS(5957),
    [anon_sym__] = ACTIONS(5959),
    [anon_sym_CARET] = ACTIONS(5959),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(5959),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(5959),
    [anon_sym_DOLLAR] = ACTIONS(5957),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(5959),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(5959),
    [anon_sym_BSLASHbegin] = ACTIONS(5957),
    [anon_sym_BSLASHtitle] = ACTIONS(5957),
    [anon_sym_BSLASHauthor] = ACTIONS(5957),
    [anon_sym_BSLASHusepackage] = ACTIONS(5957),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(5957),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(5957),
    [anon_sym_BSLASHinclude] = ACTIONS(5957),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(5957),
    [anon_sym_BSLASHinput] = ACTIONS(5957),
    [anon_sym_BSLASHsubfile] = ACTIONS(5957),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(5957),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(5957),
    [anon_sym_BSLASHbibliography] = ACTIONS(5957),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(5957),
    [anon_sym_BSLASHincludesvg] = ACTIONS(5957),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(5957),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(5957),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(5957),
    [anon_sym_BSLASHimport] = ACTIONS(5957),
    [anon_sym_BSLASHsubimport] = ACTIONS(5957),
    [anon_sym_BSLASHinputfrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(5957),
    [anon_sym_BSLASHincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(5957),
    [anon_sym_BSLASHcaption] = ACTIONS(5957),
    [anon_sym_BSLASHcite] = ACTIONS(5957),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCite] = ACTIONS(5957),
    [anon_sym_BSLASHnocite] = ACTIONS(5957),
    [anon_sym_BSLASHcitet] = ACTIONS(5957),
    [anon_sym_BSLASHcitep] = ACTIONS(5957),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteA] = ACTIONS(5957),
    [anon_sym_BSLASHciteR] = ACTIONS(5957),
    [anon_sym_BSLASHciteS] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearR] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(5957),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitetitle] = ACTIONS(5957),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteyear] = ACTIONS(5957),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHcitedate] = ACTIONS(5957),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHciteurl] = ACTIONS(5957),
    [anon_sym_BSLASHfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(5957),
    [anon_sym_BSLASHcitealt] = ACTIONS(5957),
    [anon_sym_BSLASHcitealp] = ACTIONS(5957),
    [anon_sym_BSLASHcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHparencite] = ACTIONS(5957),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHParencite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(5957),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(5957),
    [anon_sym_BSLASHtextcite] = ACTIONS(5957),
    [anon_sym_BSLASHTextcite] = ACTIONS(5957),
    [anon_sym_BSLASHsmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHSmartcite] = ACTIONS(5957),
    [anon_sym_BSLASHsupercite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite] = ACTIONS(5957),
    [anon_sym_BSLASHAutocite] = ACTIONS(5957),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHVolcite] = ACTIONS(5957),
    [anon_sym_BSLASHpvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHPvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHfvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHftvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHsvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHSvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHtvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHTvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHavolcite] = ACTIONS(5957),
    [anon_sym_BSLASHAvolcite] = ACTIONS(5957),
    [anon_sym_BSLASHnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHNotecite] = ACTIONS(5957),
    [anon_sym_BSLASHpnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHPnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHfnotecite] = ACTIONS(5957),
    [anon_sym_BSLASHlabel] = ACTIONS(5957),
    [anon_sym_BSLASHref] = ACTIONS(5957),
    [anon_sym_BSLASHeqref] = ACTIONS(5957),
    [anon_sym_BSLASHvref] = ACTIONS(5957),
    [anon_sym_BSLASHVref] = ACTIONS(5957),
    [anon_sym_BSLASHautoref] = ACTIONS(5957),
    [anon_sym_BSLASHpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcref] = ACTIONS(5957),
    [anon_sym_BSLASHCref] = ACTIONS(5957),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnameCref] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(5957),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcref] = ACTIONS(5957),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHCrefrange] = ACTIONS(5957),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHnewlabel] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(5957),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(5957),
    [anon_sym_BSLASHdef] = ACTIONS(5957),
    [anon_sym_BSLASHlet] = ACTIONS(5957),
    [anon_sym_BSLASHleft] = ACTIONS(5957),
    [anon_sym_BSLASHbigl] = ACTIONS(5957),
    [anon_sym_BSLASHBigl] = ACTIONS(5957),
    [anon_sym_BSLASHbiggl] = ACTIONS(5957),
    [anon_sym_BSLASHBiggl] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(5957),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(5957),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(5957),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(5957),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(5957),
    [anon_sym_BSLASHgls] = ACTIONS(5957),
    [anon_sym_BSLASHGls] = ACTIONS(5957),
    [anon_sym_BSLASHGLS] = ACTIONS(5957),
    [anon_sym_BSLASHglspl] = ACTIONS(5957),
    [anon_sym_BSLASHGlspl] = ACTIONS(5957),
    [anon_sym_BSLASHGLSpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsdisp] = ACTIONS(5957),
    [anon_sym_BSLASHglslink] = ACTIONS(5957),
    [anon_sym_BSLASHglstext] = ACTIONS(5957),
    [anon_sym_BSLASHGlstext] = ACTIONS(5957),
    [anon_sym_BSLASHGLStext] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(5957),
    [anon_sym_BSLASHglsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(5957),
    [anon_sym_BSLASHglsname] = ACTIONS(5957),
    [anon_sym_BSLASHGlsname] = ACTIONS(5957),
    [anon_sym_BSLASHGLSname] = ACTIONS(5957),
    [anon_sym_BSLASHglssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(5957),
    [anon_sym_BSLASHglsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(5957),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(5957),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(5957),
    [anon_sym_BSLASHglsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(5957),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(5957),
    [anon_sym_BSLASHnewacronym] = ACTIONS(5957),
    [anon_sym_BSLASHacrshort] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshort] = ACTIONS(5957),
    [anon_sym_BSLASHACRshort] = ACTIONS(5957),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrlong] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlong] = ACTIONS(5957),
    [anon_sym_BSLASHACRlong] = ACTIONS(5957),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(5957),
    [anon_sym_BSLASHacrfull] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfull] = ACTIONS(5957),
    [anon_sym_BSLASHACRfull] = ACTIONS(5957),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHacs] = ACTIONS(5957),
    [anon_sym_BSLASHAcs] = ACTIONS(5957),
    [anon_sym_BSLASHacsp] = ACTIONS(5957),
    [anon_sym_BSLASHAcsp] = ACTIONS(5957),
    [anon_sym_BSLASHacl] = ACTIONS(5957),
    [anon_sym_BSLASHAcl] = ACTIONS(5957),
    [anon_sym_BSLASHaclp] = ACTIONS(5957),
    [anon_sym_BSLASHAclp] = ACTIONS(5957),
    [anon_sym_BSLASHacf] = ACTIONS(5957),
    [anon_sym_BSLASHAcf] = ACTIONS(5957),
    [anon_sym_BSLASHacfp] = ACTIONS(5957),
    [anon_sym_BSLASHAcfp] = ACTIONS(5957),
    [anon_sym_BSLASHac] = ACTIONS(5957),
    [anon_sym_BSLASHAc] = ACTIONS(5957),
    [anon_sym_BSLASHacp] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(5957),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(5957),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(5957),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(5957),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(5959),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(5957),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(5957),
    [anon_sym_BSLASHcolor] = ACTIONS(5957),
    [anon_sym_BSLASHcolorbox] = ACTIONS(5957),
    [anon_sym_BSLASHtextcolor] = ACTIONS(5957),
    [anon_sym_BSLASHpagecolor] = ACTIONS(5957),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(5957),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(5957),
    [anon_sym_BSLASHtext] = ACTIONS(5957),
    [anon_sym_BSLASHintertext] = ACTIONS(5957),
    [anon_sym_BSLASHshortintertext] = ACTIONS(5957),
    [anon_sym_BSLASHurl] = ACTIONS(5957),
    [anon_sym_BSLASHhref] = ACTIONS(5957),
  },
  [863] = {
    [sym_brack_group_text] = STATE(1021),
    [ts_builtin_sym_end] = ACTIONS(6168),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHpart] = ACTIONS(6166),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddpart] = ACTIONS(6166),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHchapter] = ACTIONS(6166),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddchap] = ACTIONS(6166),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsection] = ACTIONS(6166),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddsec] = ACTIONS(6166),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHitem] = ACTIONS(6166),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [anon_sym_RBRACE] = ACTIONS(6168),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6168),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6166),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHbegin] = ACTIONS(6166),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHleft] = ACTIONS(6166),
    [anon_sym_BSLASHbigl] = ACTIONS(6166),
    [anon_sym_BSLASHBigl] = ACTIONS(6166),
    [anon_sym_BSLASHbiggl] = ACTIONS(6166),
    [anon_sym_BSLASHBiggl] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHtext] = ACTIONS(6166),
    [anon_sym_BSLASHintertext] = ACTIONS(6166),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [864] = {
    [sym_block_comment] = STATE(2022),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(864),
    [sym_command_name] = ACTIONS(6881),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6884),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [sym_word] = ACTIONS(6887),
    [sym_placeholder] = ACTIONS(6890),
    [anon_sym_PLUS] = ACTIONS(6893),
    [anon_sym_DASH] = ACTIONS(6893),
    [anon_sym_STAR] = ACTIONS(6893),
    [anon_sym_SLASH] = ACTIONS(6893),
    [anon_sym_LT] = ACTIONS(6896),
    [anon_sym_GT] = ACTIONS(6896),
    [anon_sym_BANG] = ACTIONS(6896),
    [anon_sym_PIPE] = ACTIONS(6896),
    [anon_sym_COLON] = ACTIONS(6896),
    [anon_sym_SQUOTE] = ACTIONS(6896),
    [anon_sym__] = ACTIONS(6899),
    [anon_sym_CARET] = ACTIONS(6902),
    [anon_sym_BSLASHtitle] = ACTIONS(6905),
    [anon_sym_BSLASHauthor] = ACTIONS(6908),
    [anon_sym_BSLASHusepackage] = ACTIONS(6911),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6911),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6914),
    [anon_sym_BSLASHinclude] = ACTIONS(6917),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6917),
    [anon_sym_BSLASHinput] = ACTIONS(6917),
    [anon_sym_BSLASHsubfile] = ACTIONS(6917),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6920),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6923),
    [anon_sym_BSLASHbibliography] = ACTIONS(6926),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6929),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6932),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6935),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6938),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6938),
    [anon_sym_BSLASHimport] = ACTIONS(6941),
    [anon_sym_BSLASHsubimport] = ACTIONS(6941),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6941),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6941),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6941),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6941),
    [anon_sym_BSLASHcaption] = ACTIONS(6944),
    [anon_sym_BSLASHcite] = ACTIONS(6947),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHCite] = ACTIONS(6947),
    [anon_sym_BSLASHnocite] = ACTIONS(6947),
    [anon_sym_BSLASHcitet] = ACTIONS(6947),
    [anon_sym_BSLASHcitep] = ACTIONS(6947),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHciteA] = ACTIONS(6947),
    [anon_sym_BSLASHciteR] = ACTIONS(6947),
    [anon_sym_BSLASHciteS] = ACTIONS(6947),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6947),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6947),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6947),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6947),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHciteyear] = ACTIONS(6947),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHcitedate] = ACTIONS(6947),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHciteurl] = ACTIONS(6947),
    [anon_sym_BSLASHfullcite] = ACTIONS(6947),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6947),
    [anon_sym_BSLASHcitealt] = ACTIONS(6947),
    [anon_sym_BSLASHcitealp] = ACTIONS(6947),
    [anon_sym_BSLASHcitetext] = ACTIONS(6947),
    [anon_sym_BSLASHparencite] = ACTIONS(6947),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHParencite] = ACTIONS(6947),
    [anon_sym_BSLASHfootcite] = ACTIONS(6947),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6947),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6947),
    [anon_sym_BSLASHtextcite] = ACTIONS(6947),
    [anon_sym_BSLASHTextcite] = ACTIONS(6947),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6947),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6947),
    [anon_sym_BSLASHsupercite] = ACTIONS(6947),
    [anon_sym_BSLASHautocite] = ACTIONS(6947),
    [anon_sym_BSLASHAutocite] = ACTIONS(6947),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6950),
    [anon_sym_BSLASHvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHVolcite] = ACTIONS(6947),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHavolcite] = ACTIONS(6947),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6947),
    [anon_sym_BSLASHnotecite] = ACTIONS(6947),
    [anon_sym_BSLASHNotecite] = ACTIONS(6947),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6947),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6947),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6947),
    [anon_sym_BSLASHlabel] = ACTIONS(6953),
    [anon_sym_BSLASHref] = ACTIONS(6956),
    [anon_sym_BSLASHeqref] = ACTIONS(6956),
    [anon_sym_BSLASHvref] = ACTIONS(6956),
    [anon_sym_BSLASHVref] = ACTIONS(6956),
    [anon_sym_BSLASHautoref] = ACTIONS(6956),
    [anon_sym_BSLASHpageref] = ACTIONS(6956),
    [anon_sym_BSLASHcref] = ACTIONS(6956),
    [anon_sym_BSLASHCref] = ACTIONS(6956),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6959),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6959),
    [anon_sym_BSLASHnamecref] = ACTIONS(6956),
    [anon_sym_BSLASHnameCref] = ACTIONS(6956),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6956),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6956),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6956),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6956),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6956),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6956),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6962),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6965),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6962),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6965),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6968),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6971),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6974),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6971),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6974),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6971),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6974),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6971),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6974),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6971),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6971),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6971),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6971),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6971),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6971),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6971),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6971),
    [anon_sym_BSLASHdef] = ACTIONS(6977),
    [anon_sym_BSLASHlet] = ACTIONS(6980),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6983),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6983),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6986),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6986),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6986),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6986),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6986),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6986),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6989),
    [anon_sym_BSLASHgls] = ACTIONS(6992),
    [anon_sym_BSLASHGls] = ACTIONS(6992),
    [anon_sym_BSLASHGLS] = ACTIONS(6992),
    [anon_sym_BSLASHglspl] = ACTIONS(6992),
    [anon_sym_BSLASHGlspl] = ACTIONS(6992),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6992),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6992),
    [anon_sym_BSLASHglslink] = ACTIONS(6992),
    [anon_sym_BSLASHglstext] = ACTIONS(6992),
    [anon_sym_BSLASHGlstext] = ACTIONS(6992),
    [anon_sym_BSLASHGLStext] = ACTIONS(6992),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6992),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6992),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6992),
    [anon_sym_BSLASHglsplural] = ACTIONS(6992),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6992),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6992),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6992),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6992),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6992),
    [anon_sym_BSLASHglsname] = ACTIONS(6992),
    [anon_sym_BSLASHGlsname] = ACTIONS(6992),
    [anon_sym_BSLASHGLSname] = ACTIONS(6992),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6992),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6992),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6992),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6992),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6992),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6992),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6992),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6992),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6992),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6992),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6992),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6992),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6992),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6992),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6992),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6992),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6992),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6992),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6992),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6992),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6992),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6992),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6992),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6995),
    [anon_sym_BSLASHacrshort] = ACTIONS(6998),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6998),
    [anon_sym_BSLASHACRshort] = ACTIONS(6998),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6998),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6998),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6998),
    [anon_sym_BSLASHacrlong] = ACTIONS(6998),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6998),
    [anon_sym_BSLASHACRlong] = ACTIONS(6998),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6998),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6998),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6998),
    [anon_sym_BSLASHacrfull] = ACTIONS(6998),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6998),
    [anon_sym_BSLASHACRfull] = ACTIONS(6998),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6998),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6998),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6998),
    [anon_sym_BSLASHacs] = ACTIONS(6998),
    [anon_sym_BSLASHAcs] = ACTIONS(6998),
    [anon_sym_BSLASHacsp] = ACTIONS(6998),
    [anon_sym_BSLASHAcsp] = ACTIONS(6998),
    [anon_sym_BSLASHacl] = ACTIONS(6998),
    [anon_sym_BSLASHAcl] = ACTIONS(6998),
    [anon_sym_BSLASHaclp] = ACTIONS(6998),
    [anon_sym_BSLASHAclp] = ACTIONS(6998),
    [anon_sym_BSLASHacf] = ACTIONS(6998),
    [anon_sym_BSLASHAcf] = ACTIONS(6998),
    [anon_sym_BSLASHacfp] = ACTIONS(6998),
    [anon_sym_BSLASHAcfp] = ACTIONS(6998),
    [anon_sym_BSLASHac] = ACTIONS(6998),
    [anon_sym_BSLASHAc] = ACTIONS(6998),
    [anon_sym_BSLASHacp] = ACTIONS(6998),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6998),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6998),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6998),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6998),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6998),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6998),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6998),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6998),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6998),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6998),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7001),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7004),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7001),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7004),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7007),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7010),
    [anon_sym_BSLASHcolor] = ACTIONS(7013),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7013),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7013),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7013),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7016),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7016),
    [anon_sym_BSLASHurl] = ACTIONS(7019),
    [anon_sym_BSLASHhref] = ACTIONS(7019),
  },
  [865] = {
    [sym_curly_group] = STATE(994),
    [sym_brack_group_text] = STATE(2874),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6129),
    [anon_sym_COMMA] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_LPAREN] = ACTIONS(6129),
    [anon_sym_RPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHpart] = ACTIONS(6127),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddpart] = ACTIONS(6127),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHchapter] = ACTIONS(6127),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddchap] = ACTIONS(6127),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsection] = ACTIONS(6127),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddsec] = ACTIONS(6127),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHitem] = ACTIONS(6127),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6129),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6129),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHbegin] = ACTIONS(6127),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHleft] = ACTIONS(6127),
    [anon_sym_BSLASHbigl] = ACTIONS(6127),
    [anon_sym_BSLASHBigl] = ACTIONS(6127),
    [anon_sym_BSLASHbiggl] = ACTIONS(6127),
    [anon_sym_BSLASHBiggl] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHtext] = ACTIONS(6127),
    [anon_sym_BSLASHintertext] = ACTIONS(6127),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [866] = {
    [sym_curly_group] = STATE(1013),
    [sym_brack_group_text] = STATE(2572),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6129),
    [anon_sym_COMMA] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_LPAREN] = ACTIONS(6129),
    [anon_sym_RPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHpart] = ACTIONS(6127),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddpart] = ACTIONS(6127),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHchapter] = ACTIONS(6127),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddchap] = ACTIONS(6127),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsection] = ACTIONS(6127),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddsec] = ACTIONS(6127),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHitem] = ACTIONS(6127),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6129),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHbegin] = ACTIONS(6127),
    [anon_sym_BSLASHend] = ACTIONS(6127),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHleft] = ACTIONS(6127),
    [anon_sym_BSLASHbigl] = ACTIONS(6127),
    [anon_sym_BSLASHBigl] = ACTIONS(6127),
    [anon_sym_BSLASHbiggl] = ACTIONS(6127),
    [anon_sym_BSLASHBiggl] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHtext] = ACTIONS(6127),
    [anon_sym_BSLASHintertext] = ACTIONS(6127),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [867] = {
    [sym_brack_group_text] = STATE(920),
    [ts_builtin_sym_end] = ACTIONS(6142),
    [sym_command_name] = ACTIONS(6138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6142),
    [anon_sym_COMMA] = ACTIONS(6142),
    [anon_sym_EQ] = ACTIONS(6142),
    [anon_sym_LPAREN] = ACTIONS(6142),
    [anon_sym_RPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHpart] = ACTIONS(6138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddpart] = ACTIONS(6138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHchapter] = ACTIONS(6138),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddchap] = ACTIONS(6138),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsection] = ACTIONS(6138),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddsec] = ACTIONS(6138),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHitem] = ACTIONS(6138),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(6142),
    [anon_sym_RBRACE] = ACTIONS(6142),
    [sym_word] = ACTIONS(6138),
    [sym_placeholder] = ACTIONS(6142),
    [anon_sym_PLUS] = ACTIONS(6142),
    [anon_sym_DASH] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6142),
    [anon_sym_LT] = ACTIONS(6138),
    [anon_sym_GT] = ACTIONS(6138),
    [anon_sym_BANG] = ACTIONS(6138),
    [anon_sym_PIPE] = ACTIONS(6138),
    [anon_sym_COLON] = ACTIONS(6138),
    [anon_sym_SQUOTE] = ACTIONS(6138),
    [anon_sym__] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6142),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6142),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6142),
    [anon_sym_DOLLAR] = ACTIONS(6138),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHbegin] = ACTIONS(6138),
    [anon_sym_BSLASHtitle] = ACTIONS(6138),
    [anon_sym_BSLASHauthor] = ACTIONS(6138),
    [anon_sym_BSLASHusepackage] = ACTIONS(6138),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6138),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6138),
    [anon_sym_BSLASHinclude] = ACTIONS(6138),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6138),
    [anon_sym_BSLASHinput] = ACTIONS(6138),
    [anon_sym_BSLASHsubfile] = ACTIONS(6138),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6138),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6138),
    [anon_sym_BSLASHbibliography] = ACTIONS(6138),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6138),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6138),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6138),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6138),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6138),
    [anon_sym_BSLASHimport] = ACTIONS(6138),
    [anon_sym_BSLASHsubimport] = ACTIONS(6138),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6138),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHcaption] = ACTIONS(6138),
    [anon_sym_BSLASHcite] = ACTIONS(6138),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCite] = ACTIONS(6138),
    [anon_sym_BSLASHnocite] = ACTIONS(6138),
    [anon_sym_BSLASHcitet] = ACTIONS(6138),
    [anon_sym_BSLASHcitep] = ACTIONS(6138),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteA] = ACTIONS(6138),
    [anon_sym_BSLASHciteR] = ACTIONS(6138),
    [anon_sym_BSLASHciteS] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6138),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteyear] = ACTIONS(6138),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitedate] = ACTIONS(6138),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteurl] = ACTIONS(6138),
    [anon_sym_BSLASHfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6138),
    [anon_sym_BSLASHcitealt] = ACTIONS(6138),
    [anon_sym_BSLASHcitealp] = ACTIONS(6138),
    [anon_sym_BSLASHcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHparencite] = ACTIONS(6138),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHParencite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHtextcite] = ACTIONS(6138),
    [anon_sym_BSLASHTextcite] = ACTIONS(6138),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHsupercite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite] = ACTIONS(6138),
    [anon_sym_BSLASHAutocite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHVolcite] = ACTIONS(6138),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHavolcite] = ACTIONS(6138),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHNotecite] = ACTIONS(6138),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHlabel] = ACTIONS(6138),
    [anon_sym_BSLASHref] = ACTIONS(6138),
    [anon_sym_BSLASHeqref] = ACTIONS(6138),
    [anon_sym_BSLASHvref] = ACTIONS(6138),
    [anon_sym_BSLASHVref] = ACTIONS(6138),
    [anon_sym_BSLASHautoref] = ACTIONS(6138),
    [anon_sym_BSLASHpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcref] = ACTIONS(6138),
    [anon_sym_BSLASHCref] = ACTIONS(6138),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnameCref] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHdef] = ACTIONS(6138),
    [anon_sym_BSLASHlet] = ACTIONS(6138),
    [anon_sym_BSLASHleft] = ACTIONS(6138),
    [anon_sym_BSLASHbigl] = ACTIONS(6138),
    [anon_sym_BSLASHBigl] = ACTIONS(6138),
    [anon_sym_BSLASHbiggl] = ACTIONS(6138),
    [anon_sym_BSLASHBiggl] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6138),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6138),
    [anon_sym_BSLASHgls] = ACTIONS(6138),
    [anon_sym_BSLASHGls] = ACTIONS(6138),
    [anon_sym_BSLASHGLS] = ACTIONS(6138),
    [anon_sym_BSLASHglspl] = ACTIONS(6138),
    [anon_sym_BSLASHGlspl] = ACTIONS(6138),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6138),
    [anon_sym_BSLASHglslink] = ACTIONS(6138),
    [anon_sym_BSLASHglstext] = ACTIONS(6138),
    [anon_sym_BSLASHGlstext] = ACTIONS(6138),
    [anon_sym_BSLASHGLStext] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6138),
    [anon_sym_BSLASHglsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsname] = ACTIONS(6138),
    [anon_sym_BSLASHGlsname] = ACTIONS(6138),
    [anon_sym_BSLASHGLSname] = ACTIONS(6138),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6138),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6138),
    [anon_sym_BSLASHacrshort] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6138),
    [anon_sym_BSLASHACRshort] = ACTIONS(6138),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrlong] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6138),
    [anon_sym_BSLASHACRlong] = ACTIONS(6138),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrfull] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6138),
    [anon_sym_BSLASHACRfull] = ACTIONS(6138),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHacs] = ACTIONS(6138),
    [anon_sym_BSLASHAcs] = ACTIONS(6138),
    [anon_sym_BSLASHacsp] = ACTIONS(6138),
    [anon_sym_BSLASHAcsp] = ACTIONS(6138),
    [anon_sym_BSLASHacl] = ACTIONS(6138),
    [anon_sym_BSLASHAcl] = ACTIONS(6138),
    [anon_sym_BSLASHaclp] = ACTIONS(6138),
    [anon_sym_BSLASHAclp] = ACTIONS(6138),
    [anon_sym_BSLASHacf] = ACTIONS(6138),
    [anon_sym_BSLASHAcf] = ACTIONS(6138),
    [anon_sym_BSLASHacfp] = ACTIONS(6138),
    [anon_sym_BSLASHAcfp] = ACTIONS(6138),
    [anon_sym_BSLASHac] = ACTIONS(6138),
    [anon_sym_BSLASHAc] = ACTIONS(6138),
    [anon_sym_BSLASHacp] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6138),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6138),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6138),
    [anon_sym_BSLASHcolor] = ACTIONS(6138),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6138),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6138),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6138),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6138),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6138),
    [anon_sym_BSLASHtext] = ACTIONS(6138),
    [anon_sym_BSLASHintertext] = ACTIONS(6138),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6138),
    [anon_sym_BSLASHurl] = ACTIONS(6138),
    [anon_sym_BSLASHhref] = ACTIONS(6138),
  },
  [868] = {
    [sym_curly_group] = STATE(1081),
    [aux_sym_generic_command_repeat1] = STATE(871),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6125),
    [anon_sym_RBRACK] = ACTIONS(6125),
    [anon_sym_COMMA] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_LPAREN] = ACTIONS(6125),
    [anon_sym_RPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHpart] = ACTIONS(6123),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddpart] = ACTIONS(6123),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHchapter] = ACTIONS(6123),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddchap] = ACTIONS(6123),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsection] = ACTIONS(6123),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddsec] = ACTIONS(6123),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHitem] = ACTIONS(6123),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6125),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6125),
    [anon_sym_DOLLAR] = ACTIONS(6123),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHbegin] = ACTIONS(6123),
    [anon_sym_BSLASHend] = ACTIONS(6123),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHleft] = ACTIONS(6123),
    [anon_sym_BSLASHbigl] = ACTIONS(6123),
    [anon_sym_BSLASHBigl] = ACTIONS(6123),
    [anon_sym_BSLASHbiggl] = ACTIONS(6123),
    [anon_sym_BSLASHBiggl] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHtext] = ACTIONS(6123),
    [anon_sym_BSLASHintertext] = ACTIONS(6123),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [869] = {
    [sym_curly_group] = STATE(999),
    [ts_builtin_sym_end] = ACTIONS(6146),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6146),
    [anon_sym_LPAREN] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHpart] = ACTIONS(6144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddpart] = ACTIONS(6144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHchapter] = ACTIONS(6144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddchap] = ACTIONS(6144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsection] = ACTIONS(6144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddsec] = ACTIONS(6144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHitem] = ACTIONS(6144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6146),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6146),
    [anon_sym_DOLLAR] = ACTIONS(6144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHbegin] = ACTIONS(6144),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHleft] = ACTIONS(6144),
    [anon_sym_BSLASHbigl] = ACTIONS(6144),
    [anon_sym_BSLASHBigl] = ACTIONS(6144),
    [anon_sym_BSLASHbiggl] = ACTIONS(6144),
    [anon_sym_BSLASHBiggl] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHtext] = ACTIONS(6144),
    [anon_sym_BSLASHintertext] = ACTIONS(6144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [870] = {
    [sym_brack_group_text] = STATE(988),
    [ts_builtin_sym_end] = ACTIONS(6150),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHpart] = ACTIONS(6148),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddpart] = ACTIONS(6148),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHchapter] = ACTIONS(6148),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddchap] = ACTIONS(6148),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsection] = ACTIONS(6148),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddsec] = ACTIONS(6148),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHitem] = ACTIONS(6148),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6150),
    [anon_sym_LBRACE] = ACTIONS(6150),
    [anon_sym_RBRACE] = ACTIONS(6150),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6150),
    [anon_sym_DOLLAR] = ACTIONS(6148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHbegin] = ACTIONS(6148),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHleft] = ACTIONS(6148),
    [anon_sym_BSLASHbigl] = ACTIONS(6148),
    [anon_sym_BSLASHBigl] = ACTIONS(6148),
    [anon_sym_BSLASHbiggl] = ACTIONS(6148),
    [anon_sym_BSLASHBiggl] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHtext] = ACTIONS(6148),
    [anon_sym_BSLASHintertext] = ACTIONS(6148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [871] = {
    [sym_curly_group] = STATE(1081),
    [aux_sym_generic_command_repeat1] = STATE(871),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(6133),
    [anon_sym_COMMA] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHpart] = ACTIONS(6131),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddpart] = ACTIONS(6131),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHchapter] = ACTIONS(6131),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddchap] = ACTIONS(6131),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsection] = ACTIONS(6131),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddsec] = ACTIONS(6131),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHitem] = ACTIONS(6131),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(7022),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6133),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6133),
    [anon_sym_DOLLAR] = ACTIONS(6131),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHbegin] = ACTIONS(6131),
    [anon_sym_BSLASHend] = ACTIONS(6131),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHleft] = ACTIONS(6131),
    [anon_sym_BSLASHbigl] = ACTIONS(6131),
    [anon_sym_BSLASHBigl] = ACTIONS(6131),
    [anon_sym_BSLASHbiggl] = ACTIONS(6131),
    [anon_sym_BSLASHBiggl] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHtext] = ACTIONS(6131),
    [anon_sym_BSLASHintertext] = ACTIONS(6131),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [872] = {
    [sym_curly_group] = STATE(984),
    [ts_builtin_sym_end] = ACTIONS(6154),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHpart] = ACTIONS(6152),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddpart] = ACTIONS(6152),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHchapter] = ACTIONS(6152),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddchap] = ACTIONS(6152),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsection] = ACTIONS(6152),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddsec] = ACTIONS(6152),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHitem] = ACTIONS(6152),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6154),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6154),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHbegin] = ACTIONS(6152),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHleft] = ACTIONS(6152),
    [anon_sym_BSLASHbigl] = ACTIONS(6152),
    [anon_sym_BSLASHBigl] = ACTIONS(6152),
    [anon_sym_BSLASHbiggl] = ACTIONS(6152),
    [anon_sym_BSLASHBiggl] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHtext] = ACTIONS(6152),
    [anon_sym_BSLASHintertext] = ACTIONS(6152),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [873] = {
    [ts_builtin_sym_end] = ACTIONS(6160),
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(7025),
    [anon_sym_LBRACK] = ACTIONS(6160),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHpart] = ACTIONS(6156),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddpart] = ACTIONS(6156),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHchapter] = ACTIONS(6156),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddchap] = ACTIONS(6156),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsection] = ACTIONS(6156),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddsec] = ACTIONS(6156),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHitem] = ACTIONS(6156),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [anon_sym_RBRACE] = ACTIONS(6160),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6160),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(6156),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHbegin] = ACTIONS(6156),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHleft] = ACTIONS(6156),
    [anon_sym_BSLASHbigl] = ACTIONS(6156),
    [anon_sym_BSLASHBigl] = ACTIONS(6156),
    [anon_sym_BSLASHbiggl] = ACTIONS(6156),
    [anon_sym_BSLASHBiggl] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHtext] = ACTIONS(6156),
    [anon_sym_BSLASHintertext] = ACTIONS(6156),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [874] = {
    [sym_curly_group] = STATE(1081),
    [aux_sym_generic_command_repeat1] = STATE(868),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6121),
    [anon_sym_RBRACK] = ACTIONS(6121),
    [anon_sym_COMMA] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHpart] = ACTIONS(6119),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddpart] = ACTIONS(6119),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHchapter] = ACTIONS(6119),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddchap] = ACTIONS(6119),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsection] = ACTIONS(6119),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddsec] = ACTIONS(6119),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHitem] = ACTIONS(6119),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6121),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(6119),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHbegin] = ACTIONS(6119),
    [anon_sym_BSLASHend] = ACTIONS(6119),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHleft] = ACTIONS(6119),
    [anon_sym_BSLASHbigl] = ACTIONS(6119),
    [anon_sym_BSLASHBigl] = ACTIONS(6119),
    [anon_sym_BSLASHbiggl] = ACTIONS(6119),
    [anon_sym_BSLASHBiggl] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHtext] = ACTIONS(6119),
    [anon_sym_BSLASHintertext] = ACTIONS(6119),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [875] = {
    [sym_curly_group] = STATE(943),
    [sym_brack_group_text] = STATE(2470),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_LPAREN] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHpart] = ACTIONS(6105),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddpart] = ACTIONS(6105),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHchapter] = ACTIONS(6105),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddchap] = ACTIONS(6105),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsection] = ACTIONS(6105),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddsec] = ACTIONS(6105),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHitem] = ACTIONS(6105),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6109),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(6105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHbegin] = ACTIONS(6105),
    [anon_sym_BSLASHend] = ACTIONS(6105),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHleft] = ACTIONS(6105),
    [anon_sym_BSLASHbigl] = ACTIONS(6105),
    [anon_sym_BSLASHBigl] = ACTIONS(6105),
    [anon_sym_BSLASHbiggl] = ACTIONS(6105),
    [anon_sym_BSLASHBiggl] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHtext] = ACTIONS(6105),
    [anon_sym_BSLASHintertext] = ACTIONS(6105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [876] = {
    [sym_curly_group] = STATE(946),
    [sym_brack_group_text] = STATE(2818),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_LPAREN] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHpart] = ACTIONS(6105),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddpart] = ACTIONS(6105),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHchapter] = ACTIONS(6105),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddchap] = ACTIONS(6105),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsection] = ACTIONS(6105),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddsec] = ACTIONS(6105),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHitem] = ACTIONS(6105),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6109),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(6105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6109),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHbegin] = ACTIONS(6105),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHleft] = ACTIONS(6105),
    [anon_sym_BSLASHbigl] = ACTIONS(6105),
    [anon_sym_BSLASHBigl] = ACTIONS(6105),
    [anon_sym_BSLASHbiggl] = ACTIONS(6105),
    [anon_sym_BSLASHBiggl] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHtext] = ACTIONS(6105),
    [anon_sym_BSLASHintertext] = ACTIONS(6105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [877] = {
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(7027),
    [anon_sym_LBRACK] = ACTIONS(6115),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHpart] = ACTIONS(6111),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddpart] = ACTIONS(6111),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHchapter] = ACTIONS(6111),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddchap] = ACTIONS(6111),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsection] = ACTIONS(6111),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddsec] = ACTIONS(6111),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHitem] = ACTIONS(6111),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6115),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6111),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHbegin] = ACTIONS(6111),
    [anon_sym_BSLASHend] = ACTIONS(6111),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHleft] = ACTIONS(6111),
    [anon_sym_BSLASHbigl] = ACTIONS(6111),
    [anon_sym_BSLASHBigl] = ACTIONS(6111),
    [anon_sym_BSLASHbiggl] = ACTIONS(6111),
    [anon_sym_BSLASHBiggl] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHtext] = ACTIONS(6111),
    [anon_sym_BSLASHintertext] = ACTIONS(6111),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(7029),
  },
  [878] = {
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(7031),
    [anon_sym_LBRACK] = ACTIONS(6115),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHpart] = ACTIONS(6111),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddpart] = ACTIONS(6111),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHchapter] = ACTIONS(6111),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddchap] = ACTIONS(6111),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsection] = ACTIONS(6111),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddsec] = ACTIONS(6111),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHitem] = ACTIONS(6111),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6115),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6115),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6111),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHbegin] = ACTIONS(6111),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHleft] = ACTIONS(6111),
    [anon_sym_BSLASHbigl] = ACTIONS(6111),
    [anon_sym_BSLASHBigl] = ACTIONS(6111),
    [anon_sym_BSLASHbiggl] = ACTIONS(6111),
    [anon_sym_BSLASHBiggl] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHtext] = ACTIONS(6111),
    [anon_sym_BSLASHintertext] = ACTIONS(6111),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(7033),
  },
  [879] = {
    [sym_curly_group] = STATE(1282),
    [aux_sym_generic_command_repeat1] = STATE(880),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6121),
    [anon_sym_RBRACK] = ACTIONS(6121),
    [anon_sym_COMMA] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHpart] = ACTIONS(6119),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddpart] = ACTIONS(6119),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHchapter] = ACTIONS(6119),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddchap] = ACTIONS(6119),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsection] = ACTIONS(6119),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddsec] = ACTIONS(6119),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHitem] = ACTIONS(6119),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6121),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6121),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(6119),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHbegin] = ACTIONS(6119),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHleft] = ACTIONS(6119),
    [anon_sym_BSLASHbigl] = ACTIONS(6119),
    [anon_sym_BSLASHBigl] = ACTIONS(6119),
    [anon_sym_BSLASHbiggl] = ACTIONS(6119),
    [anon_sym_BSLASHBiggl] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHtext] = ACTIONS(6119),
    [anon_sym_BSLASHintertext] = ACTIONS(6119),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [880] = {
    [sym_curly_group] = STATE(1282),
    [aux_sym_generic_command_repeat1] = STATE(887),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6125),
    [anon_sym_RBRACK] = ACTIONS(6125),
    [anon_sym_COMMA] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_LPAREN] = ACTIONS(6125),
    [anon_sym_RPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHpart] = ACTIONS(6123),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddpart] = ACTIONS(6123),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHchapter] = ACTIONS(6123),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddchap] = ACTIONS(6123),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsection] = ACTIONS(6123),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddsec] = ACTIONS(6123),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHitem] = ACTIONS(6123),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6125),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6125),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6125),
    [anon_sym_DOLLAR] = ACTIONS(6123),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHbegin] = ACTIONS(6123),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHleft] = ACTIONS(6123),
    [anon_sym_BSLASHbigl] = ACTIONS(6123),
    [anon_sym_BSLASHBigl] = ACTIONS(6123),
    [anon_sym_BSLASHbiggl] = ACTIONS(6123),
    [anon_sym_BSLASHBiggl] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHtext] = ACTIONS(6123),
    [anon_sym_BSLASHintertext] = ACTIONS(6123),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [881] = {
    [sym_curly_group] = STATE(942),
    [sym_brack_group_text] = STATE(3100),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6129),
    [anon_sym_COMMA] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_LPAREN] = ACTIONS(6129),
    [anon_sym_RPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHpart] = ACTIONS(6127),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddpart] = ACTIONS(6127),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHchapter] = ACTIONS(6127),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddchap] = ACTIONS(6127),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsection] = ACTIONS(6127),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHaddsec] = ACTIONS(6127),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6127),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6127),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHitem] = ACTIONS(6127),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6129),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6129),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHbegin] = ACTIONS(6127),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHleft] = ACTIONS(6127),
    [anon_sym_BSLASHbigl] = ACTIONS(6127),
    [anon_sym_BSLASHBigl] = ACTIONS(6127),
    [anon_sym_BSLASHbiggl] = ACTIONS(6127),
    [anon_sym_BSLASHBiggl] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHtext] = ACTIONS(6127),
    [anon_sym_BSLASHintertext] = ACTIONS(6127),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [882] = {
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(7035),
    [anon_sym_LBRACK] = ACTIONS(6115),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHpart] = ACTIONS(6111),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddpart] = ACTIONS(6111),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHchapter] = ACTIONS(6111),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddchap] = ACTIONS(6111),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsection] = ACTIONS(6111),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHaddsec] = ACTIONS(6111),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6111),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6111),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHitem] = ACTIONS(6111),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6115),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6111),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6115),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHbegin] = ACTIONS(6111),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHleft] = ACTIONS(6111),
    [anon_sym_BSLASHbigl] = ACTIONS(6111),
    [anon_sym_BSLASHBigl] = ACTIONS(6111),
    [anon_sym_BSLASHbiggl] = ACTIONS(6111),
    [anon_sym_BSLASHBiggl] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHtext] = ACTIONS(6111),
    [anon_sym_BSLASHintertext] = ACTIONS(6111),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(7037),
  },
  [883] = {
    [sym_curly_group] = STATE(975),
    [ts_builtin_sym_end] = ACTIONS(6164),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(6164),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHpart] = ACTIONS(6162),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddpart] = ACTIONS(6162),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHchapter] = ACTIONS(6162),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddchap] = ACTIONS(6162),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsection] = ACTIONS(6162),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddsec] = ACTIONS(6162),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHitem] = ACTIONS(6162),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(6164),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6164),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6164),
    [anon_sym_DOLLAR] = ACTIONS(6162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHbegin] = ACTIONS(6162),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHleft] = ACTIONS(6162),
    [anon_sym_BSLASHbigl] = ACTIONS(6162),
    [anon_sym_BSLASHBigl] = ACTIONS(6162),
    [anon_sym_BSLASHbiggl] = ACTIONS(6162),
    [anon_sym_BSLASHBiggl] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHtext] = ACTIONS(6162),
    [anon_sym_BSLASHintertext] = ACTIONS(6162),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [884] = {
    [sym_curly_group] = STATE(1375),
    [aux_sym_generic_command_repeat1] = STATE(884),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(6133),
    [anon_sym_COMMA] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHpart] = ACTIONS(6131),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddpart] = ACTIONS(6131),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHchapter] = ACTIONS(6131),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddchap] = ACTIONS(6131),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsection] = ACTIONS(6131),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddsec] = ACTIONS(6131),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHitem] = ACTIONS(6131),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(7039),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6133),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6133),
    [anon_sym_DOLLAR] = ACTIONS(6131),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6133),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHbegin] = ACTIONS(6131),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHleft] = ACTIONS(6131),
    [anon_sym_BSLASHbigl] = ACTIONS(6131),
    [anon_sym_BSLASHBigl] = ACTIONS(6131),
    [anon_sym_BSLASHbiggl] = ACTIONS(6131),
    [anon_sym_BSLASHBiggl] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHtext] = ACTIONS(6131),
    [anon_sym_BSLASHintertext] = ACTIONS(6131),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [885] = {
    [sym_curly_group] = STATE(1375),
    [aux_sym_generic_command_repeat1] = STATE(884),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6125),
    [anon_sym_RBRACK] = ACTIONS(6125),
    [anon_sym_COMMA] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_LPAREN] = ACTIONS(6125),
    [anon_sym_RPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHpart] = ACTIONS(6123),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddpart] = ACTIONS(6123),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHchapter] = ACTIONS(6123),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddchap] = ACTIONS(6123),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsection] = ACTIONS(6123),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHaddsec] = ACTIONS(6123),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6123),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6123),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHitem] = ACTIONS(6123),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6125),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6125),
    [anon_sym_DOLLAR] = ACTIONS(6123),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6125),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHbegin] = ACTIONS(6123),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHleft] = ACTIONS(6123),
    [anon_sym_BSLASHbigl] = ACTIONS(6123),
    [anon_sym_BSLASHBigl] = ACTIONS(6123),
    [anon_sym_BSLASHbiggl] = ACTIONS(6123),
    [anon_sym_BSLASHBiggl] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHtext] = ACTIONS(6123),
    [anon_sym_BSLASHintertext] = ACTIONS(6123),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [886] = {
    [sym_block_comment] = STATE(2022),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(864),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACK] = ACTIONS(3844),
    [anon_sym_COMMA] = ACTIONS(3844),
    [anon_sym_EQ] = ACTIONS(3844),
    [anon_sym_RBRACE] = ACTIONS(3844),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [887] = {
    [sym_curly_group] = STATE(1282),
    [aux_sym_generic_command_repeat1] = STATE(887),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(6133),
    [anon_sym_COMMA] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHpart] = ACTIONS(6131),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddpart] = ACTIONS(6131),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHchapter] = ACTIONS(6131),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddchap] = ACTIONS(6131),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsection] = ACTIONS(6131),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHaddsec] = ACTIONS(6131),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6131),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6131),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHitem] = ACTIONS(6131),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(7042),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6133),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6133),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6133),
    [anon_sym_DOLLAR] = ACTIONS(6131),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHbegin] = ACTIONS(6131),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHleft] = ACTIONS(6131),
    [anon_sym_BSLASHbigl] = ACTIONS(6131),
    [anon_sym_BSLASHBigl] = ACTIONS(6131),
    [anon_sym_BSLASHbiggl] = ACTIONS(6131),
    [anon_sym_BSLASHBiggl] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHtext] = ACTIONS(6131),
    [anon_sym_BSLASHintertext] = ACTIONS(6131),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [888] = {
    [sym_curly_group] = STATE(915),
    [sym_brack_group_text] = STATE(3054),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_LPAREN] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHpart] = ACTIONS(6105),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddpart] = ACTIONS(6105),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHchapter] = ACTIONS(6105),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddchap] = ACTIONS(6105),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsection] = ACTIONS(6105),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHaddsec] = ACTIONS(6105),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6105),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6105),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHitem] = ACTIONS(6105),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6109),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6109),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(6105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHbegin] = ACTIONS(6105),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHleft] = ACTIONS(6105),
    [anon_sym_BSLASHbigl] = ACTIONS(6105),
    [anon_sym_BSLASHBigl] = ACTIONS(6105),
    [anon_sym_BSLASHbiggl] = ACTIONS(6105),
    [anon_sym_BSLASHBiggl] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHtext] = ACTIONS(6105),
    [anon_sym_BSLASHintertext] = ACTIONS(6105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [889] = {
    [sym_curly_group] = STATE(1375),
    [aux_sym_generic_command_repeat1] = STATE(885),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6121),
    [anon_sym_RBRACK] = ACTIONS(6121),
    [anon_sym_COMMA] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHpart] = ACTIONS(6119),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddpart] = ACTIONS(6119),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHchapter] = ACTIONS(6119),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddchap] = ACTIONS(6119),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsection] = ACTIONS(6119),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHaddsec] = ACTIONS(6119),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6119),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6119),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHitem] = ACTIONS(6119),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6121),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(6119),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6121),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHbegin] = ACTIONS(6119),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHleft] = ACTIONS(6119),
    [anon_sym_BSLASHbigl] = ACTIONS(6119),
    [anon_sym_BSLASHBigl] = ACTIONS(6119),
    [anon_sym_BSLASHbiggl] = ACTIONS(6119),
    [anon_sym_BSLASHBiggl] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHtext] = ACTIONS(6119),
    [anon_sym_BSLASHintertext] = ACTIONS(6119),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [890] = {
    [ts_builtin_sym_end] = ACTIONS(6248),
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_COMMA] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_LPAREN] = ACTIONS(6248),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHpart] = ACTIONS(6246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddpart] = ACTIONS(6246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHchapter] = ACTIONS(6246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddchap] = ACTIONS(6246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsection] = ACTIONS(6246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddsec] = ACTIONS(6246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHitem] = ACTIONS(6246),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [anon_sym_RBRACE] = ACTIONS(6248),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6248),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6248),
    [anon_sym_DOLLAR] = ACTIONS(6246),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHbegin] = ACTIONS(6246),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHleft] = ACTIONS(6246),
    [anon_sym_BSLASHbigl] = ACTIONS(6246),
    [anon_sym_BSLASHBigl] = ACTIONS(6246),
    [anon_sym_BSLASHbiggl] = ACTIONS(6246),
    [anon_sym_BSLASHBiggl] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHtext] = ACTIONS(6246),
    [anon_sym_BSLASHintertext] = ACTIONS(6246),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [891] = {
    [ts_builtin_sym_end] = ACTIONS(6216),
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_EQ] = ACTIONS(6216),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [anon_sym_RPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHpart] = ACTIONS(6214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddpart] = ACTIONS(6214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHchapter] = ACTIONS(6214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddchap] = ACTIONS(6214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsection] = ACTIONS(6214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddsec] = ACTIONS(6214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHitem] = ACTIONS(6214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6216),
    [anon_sym_DOLLAR] = ACTIONS(6214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHbegin] = ACTIONS(6214),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHleft] = ACTIONS(6214),
    [anon_sym_BSLASHbigl] = ACTIONS(6214),
    [anon_sym_BSLASHBigl] = ACTIONS(6214),
    [anon_sym_BSLASHbiggl] = ACTIONS(6214),
    [anon_sym_BSLASHBiggl] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHtext] = ACTIONS(6214),
    [anon_sym_BSLASHintertext] = ACTIONS(6214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [892] = {
    [ts_builtin_sym_end] = ACTIONS(6404),
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6404),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6404),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHpart] = ACTIONS(6402),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddpart] = ACTIONS(6402),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHchapter] = ACTIONS(6402),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddchap] = ACTIONS(6402),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsection] = ACTIONS(6402),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddsec] = ACTIONS(6402),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHitem] = ACTIONS(6402),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6404),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [anon_sym_RBRACE] = ACTIONS(6404),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6404),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6404),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHbegin] = ACTIONS(6402),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHleft] = ACTIONS(6402),
    [anon_sym_BSLASHbigl] = ACTIONS(6402),
    [anon_sym_BSLASHBigl] = ACTIONS(6402),
    [anon_sym_BSLASHbiggl] = ACTIONS(6402),
    [anon_sym_BSLASHBiggl] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHtext] = ACTIONS(6402),
    [anon_sym_BSLASHintertext] = ACTIONS(6402),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [893] = {
    [ts_builtin_sym_end] = ACTIONS(6408),
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHpart] = ACTIONS(6406),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddpart] = ACTIONS(6406),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHchapter] = ACTIONS(6406),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddchap] = ACTIONS(6406),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsection] = ACTIONS(6406),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddsec] = ACTIONS(6406),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHitem] = ACTIONS(6406),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [anon_sym_RBRACE] = ACTIONS(6408),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6408),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6408),
    [anon_sym_DOLLAR] = ACTIONS(6406),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHbegin] = ACTIONS(6406),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHleft] = ACTIONS(6406),
    [anon_sym_BSLASHbigl] = ACTIONS(6406),
    [anon_sym_BSLASHBigl] = ACTIONS(6406),
    [anon_sym_BSLASHbiggl] = ACTIONS(6406),
    [anon_sym_BSLASHBiggl] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHtext] = ACTIONS(6406),
    [anon_sym_BSLASHintertext] = ACTIONS(6406),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [894] = {
    [ts_builtin_sym_end] = ACTIONS(6376),
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_LBRACK] = ACTIONS(6376),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_EQ] = ACTIONS(6376),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHpart] = ACTIONS(6374),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddpart] = ACTIONS(6374),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHchapter] = ACTIONS(6374),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddchap] = ACTIONS(6374),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsection] = ACTIONS(6374),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddsec] = ACTIONS(6374),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHitem] = ACTIONS(6374),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [anon_sym_RBRACE] = ACTIONS(6376),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6376),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6376),
    [anon_sym_DOLLAR] = ACTIONS(6374),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHbegin] = ACTIONS(6374),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHleft] = ACTIONS(6374),
    [anon_sym_BSLASHbigl] = ACTIONS(6374),
    [anon_sym_BSLASHBigl] = ACTIONS(6374),
    [anon_sym_BSLASHbiggl] = ACTIONS(6374),
    [anon_sym_BSLASHBiggl] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHtext] = ACTIONS(6374),
    [anon_sym_BSLASHintertext] = ACTIONS(6374),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [895] = {
    [ts_builtin_sym_end] = ACTIONS(157),
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_RBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [896] = {
    [ts_builtin_sym_end] = ACTIONS(6440),
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_LBRACK] = ACTIONS(6440),
    [anon_sym_RBRACK] = ACTIONS(6440),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6440),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_RPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHpart] = ACTIONS(6438),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddpart] = ACTIONS(6438),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHchapter] = ACTIONS(6438),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddchap] = ACTIONS(6438),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsection] = ACTIONS(6438),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddsec] = ACTIONS(6438),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHitem] = ACTIONS(6438),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [anon_sym_RBRACE] = ACTIONS(6440),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6440),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6440),
    [anon_sym_DOLLAR] = ACTIONS(6438),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHbegin] = ACTIONS(6438),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHleft] = ACTIONS(6438),
    [anon_sym_BSLASHbigl] = ACTIONS(6438),
    [anon_sym_BSLASHBigl] = ACTIONS(6438),
    [anon_sym_BSLASHbiggl] = ACTIONS(6438),
    [anon_sym_BSLASHBiggl] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHtext] = ACTIONS(6438),
    [anon_sym_BSLASHintertext] = ACTIONS(6438),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [897] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2408),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2409),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACK] = ACTIONS(7045),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [898] = {
    [ts_builtin_sym_end] = ACTIONS(6380),
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_LBRACK] = ACTIONS(6380),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_EQ] = ACTIONS(6380),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHpart] = ACTIONS(6378),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddpart] = ACTIONS(6378),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHchapter] = ACTIONS(6378),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddchap] = ACTIONS(6378),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsection] = ACTIONS(6378),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddsec] = ACTIONS(6378),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHitem] = ACTIONS(6378),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [anon_sym_RBRACE] = ACTIONS(6380),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6380),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6380),
    [anon_sym_DOLLAR] = ACTIONS(6378),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHbegin] = ACTIONS(6378),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHleft] = ACTIONS(6378),
    [anon_sym_BSLASHbigl] = ACTIONS(6378),
    [anon_sym_BSLASHBigl] = ACTIONS(6378),
    [anon_sym_BSLASHbiggl] = ACTIONS(6378),
    [anon_sym_BSLASHBiggl] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHtext] = ACTIONS(6378),
    [anon_sym_BSLASHintertext] = ACTIONS(6378),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [899] = {
    [ts_builtin_sym_end] = ACTIONS(167),
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [anon_sym_RBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [900] = {
    [ts_builtin_sym_end] = ACTIONS(6412),
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6412),
    [anon_sym_RBRACK] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHpart] = ACTIONS(6410),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddpart] = ACTIONS(6410),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHchapter] = ACTIONS(6410),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddchap] = ACTIONS(6410),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsection] = ACTIONS(6410),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddsec] = ACTIONS(6410),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHitem] = ACTIONS(6410),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [anon_sym_RBRACE] = ACTIONS(6412),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6412),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6412),
    [anon_sym_DOLLAR] = ACTIONS(6410),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHbegin] = ACTIONS(6410),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHleft] = ACTIONS(6410),
    [anon_sym_BSLASHbigl] = ACTIONS(6410),
    [anon_sym_BSLASHBigl] = ACTIONS(6410),
    [anon_sym_BSLASHbiggl] = ACTIONS(6410),
    [anon_sym_BSLASHBiggl] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHtext] = ACTIONS(6410),
    [anon_sym_BSLASHintertext] = ACTIONS(6410),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [901] = {
    [ts_builtin_sym_end] = ACTIONS(6388),
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_COMMA] = ACTIONS(6388),
    [anon_sym_EQ] = ACTIONS(6388),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHpart] = ACTIONS(6386),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddpart] = ACTIONS(6386),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHchapter] = ACTIONS(6386),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddchap] = ACTIONS(6386),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsection] = ACTIONS(6386),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddsec] = ACTIONS(6386),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHitem] = ACTIONS(6386),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [anon_sym_RBRACE] = ACTIONS(6388),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6388),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(6386),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHbegin] = ACTIONS(6386),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHleft] = ACTIONS(6386),
    [anon_sym_BSLASHbigl] = ACTIONS(6386),
    [anon_sym_BSLASHBigl] = ACTIONS(6386),
    [anon_sym_BSLASHbiggl] = ACTIONS(6386),
    [anon_sym_BSLASHBiggl] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHtext] = ACTIONS(6386),
    [anon_sym_BSLASHintertext] = ACTIONS(6386),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [902] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2430),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [903] = {
    [ts_builtin_sym_end] = ACTIONS(6444),
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6444),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHpart] = ACTIONS(6442),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddpart] = ACTIONS(6442),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHchapter] = ACTIONS(6442),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddchap] = ACTIONS(6442),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsection] = ACTIONS(6442),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddsec] = ACTIONS(6442),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHitem] = ACTIONS(6442),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [anon_sym_RBRACE] = ACTIONS(6444),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6444),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6444),
    [anon_sym_DOLLAR] = ACTIONS(6442),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHbegin] = ACTIONS(6442),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHleft] = ACTIONS(6442),
    [anon_sym_BSLASHbigl] = ACTIONS(6442),
    [anon_sym_BSLASHBigl] = ACTIONS(6442),
    [anon_sym_BSLASHbiggl] = ACTIONS(6442),
    [anon_sym_BSLASHBiggl] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHtext] = ACTIONS(6442),
    [anon_sym_BSLASHintertext] = ACTIONS(6442),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [904] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2353),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7049),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [905] = {
    [sym_brack_group_text] = STATE(1381),
    [sym_command_name] = ACTIONS(6138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(7051),
    [anon_sym_RBRACK] = ACTIONS(6142),
    [anon_sym_COMMA] = ACTIONS(6142),
    [anon_sym_EQ] = ACTIONS(6142),
    [anon_sym_LPAREN] = ACTIONS(6142),
    [anon_sym_RPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHpart] = ACTIONS(6138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddpart] = ACTIONS(6138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHchapter] = ACTIONS(6138),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddchap] = ACTIONS(6138),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsection] = ACTIONS(6138),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddsec] = ACTIONS(6138),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHitem] = ACTIONS(6138),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(6142),
    [sym_word] = ACTIONS(6138),
    [sym_placeholder] = ACTIONS(6142),
    [anon_sym_PLUS] = ACTIONS(6142),
    [anon_sym_DASH] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6142),
    [anon_sym_LT] = ACTIONS(6138),
    [anon_sym_GT] = ACTIONS(6138),
    [anon_sym_BANG] = ACTIONS(6138),
    [anon_sym_PIPE] = ACTIONS(6138),
    [anon_sym_COLON] = ACTIONS(6138),
    [anon_sym_SQUOTE] = ACTIONS(6138),
    [anon_sym__] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6142),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6142),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6142),
    [anon_sym_DOLLAR] = ACTIONS(6138),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6142),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHbegin] = ACTIONS(6138),
    [anon_sym_BSLASHtitle] = ACTIONS(6138),
    [anon_sym_BSLASHauthor] = ACTIONS(6138),
    [anon_sym_BSLASHusepackage] = ACTIONS(6138),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6138),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6138),
    [anon_sym_BSLASHinclude] = ACTIONS(6138),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6138),
    [anon_sym_BSLASHinput] = ACTIONS(6138),
    [anon_sym_BSLASHsubfile] = ACTIONS(6138),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6138),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6138),
    [anon_sym_BSLASHbibliography] = ACTIONS(6138),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6138),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6138),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6138),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6138),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6138),
    [anon_sym_BSLASHimport] = ACTIONS(6138),
    [anon_sym_BSLASHsubimport] = ACTIONS(6138),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6138),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHcaption] = ACTIONS(6138),
    [anon_sym_BSLASHcite] = ACTIONS(6138),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCite] = ACTIONS(6138),
    [anon_sym_BSLASHnocite] = ACTIONS(6138),
    [anon_sym_BSLASHcitet] = ACTIONS(6138),
    [anon_sym_BSLASHcitep] = ACTIONS(6138),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteA] = ACTIONS(6138),
    [anon_sym_BSLASHciteR] = ACTIONS(6138),
    [anon_sym_BSLASHciteS] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6138),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteyear] = ACTIONS(6138),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitedate] = ACTIONS(6138),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteurl] = ACTIONS(6138),
    [anon_sym_BSLASHfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6138),
    [anon_sym_BSLASHcitealt] = ACTIONS(6138),
    [anon_sym_BSLASHcitealp] = ACTIONS(6138),
    [anon_sym_BSLASHcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHparencite] = ACTIONS(6138),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHParencite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHtextcite] = ACTIONS(6138),
    [anon_sym_BSLASHTextcite] = ACTIONS(6138),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHsupercite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite] = ACTIONS(6138),
    [anon_sym_BSLASHAutocite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHVolcite] = ACTIONS(6138),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHavolcite] = ACTIONS(6138),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHNotecite] = ACTIONS(6138),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHlabel] = ACTIONS(6138),
    [anon_sym_BSLASHref] = ACTIONS(6138),
    [anon_sym_BSLASHeqref] = ACTIONS(6138),
    [anon_sym_BSLASHvref] = ACTIONS(6138),
    [anon_sym_BSLASHVref] = ACTIONS(6138),
    [anon_sym_BSLASHautoref] = ACTIONS(6138),
    [anon_sym_BSLASHpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcref] = ACTIONS(6138),
    [anon_sym_BSLASHCref] = ACTIONS(6138),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnameCref] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHdef] = ACTIONS(6138),
    [anon_sym_BSLASHlet] = ACTIONS(6138),
    [anon_sym_BSLASHleft] = ACTIONS(6138),
    [anon_sym_BSLASHbigl] = ACTIONS(6138),
    [anon_sym_BSLASHBigl] = ACTIONS(6138),
    [anon_sym_BSLASHbiggl] = ACTIONS(6138),
    [anon_sym_BSLASHBiggl] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6138),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6138),
    [anon_sym_BSLASHgls] = ACTIONS(6138),
    [anon_sym_BSLASHGls] = ACTIONS(6138),
    [anon_sym_BSLASHGLS] = ACTIONS(6138),
    [anon_sym_BSLASHglspl] = ACTIONS(6138),
    [anon_sym_BSLASHGlspl] = ACTIONS(6138),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6138),
    [anon_sym_BSLASHglslink] = ACTIONS(6138),
    [anon_sym_BSLASHglstext] = ACTIONS(6138),
    [anon_sym_BSLASHGlstext] = ACTIONS(6138),
    [anon_sym_BSLASHGLStext] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6138),
    [anon_sym_BSLASHglsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsname] = ACTIONS(6138),
    [anon_sym_BSLASHGlsname] = ACTIONS(6138),
    [anon_sym_BSLASHGLSname] = ACTIONS(6138),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6138),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6138),
    [anon_sym_BSLASHacrshort] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6138),
    [anon_sym_BSLASHACRshort] = ACTIONS(6138),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrlong] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6138),
    [anon_sym_BSLASHACRlong] = ACTIONS(6138),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrfull] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6138),
    [anon_sym_BSLASHACRfull] = ACTIONS(6138),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHacs] = ACTIONS(6138),
    [anon_sym_BSLASHAcs] = ACTIONS(6138),
    [anon_sym_BSLASHacsp] = ACTIONS(6138),
    [anon_sym_BSLASHAcsp] = ACTIONS(6138),
    [anon_sym_BSLASHacl] = ACTIONS(6138),
    [anon_sym_BSLASHAcl] = ACTIONS(6138),
    [anon_sym_BSLASHaclp] = ACTIONS(6138),
    [anon_sym_BSLASHAclp] = ACTIONS(6138),
    [anon_sym_BSLASHacf] = ACTIONS(6138),
    [anon_sym_BSLASHAcf] = ACTIONS(6138),
    [anon_sym_BSLASHacfp] = ACTIONS(6138),
    [anon_sym_BSLASHAcfp] = ACTIONS(6138),
    [anon_sym_BSLASHac] = ACTIONS(6138),
    [anon_sym_BSLASHAc] = ACTIONS(6138),
    [anon_sym_BSLASHacp] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6138),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6138),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6138),
    [anon_sym_BSLASHcolor] = ACTIONS(6138),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6138),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6138),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6138),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6138),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6138),
    [anon_sym_BSLASHtext] = ACTIONS(6138),
    [anon_sym_BSLASHintertext] = ACTIONS(6138),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6138),
    [anon_sym_BSLASHurl] = ACTIONS(6138),
    [anon_sym_BSLASHhref] = ACTIONS(6138),
  },
  [906] = {
    [ts_builtin_sym_end] = ACTIONS(6356),
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_RBRACK] = ACTIONS(6356),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_EQ] = ACTIONS(6356),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_RPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHpart] = ACTIONS(6354),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddpart] = ACTIONS(6354),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHchapter] = ACTIONS(6354),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddchap] = ACTIONS(6354),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsection] = ACTIONS(6354),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddsec] = ACTIONS(6354),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHitem] = ACTIONS(6354),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6356),
    [anon_sym_LBRACE] = ACTIONS(6356),
    [anon_sym_RBRACE] = ACTIONS(6356),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6356),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6356),
    [anon_sym_DOLLAR] = ACTIONS(6354),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHbegin] = ACTIONS(6354),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHleft] = ACTIONS(6354),
    [anon_sym_BSLASHbigl] = ACTIONS(6354),
    [anon_sym_BSLASHBigl] = ACTIONS(6354),
    [anon_sym_BSLASHbiggl] = ACTIONS(6354),
    [anon_sym_BSLASHBiggl] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHtext] = ACTIONS(6354),
    [anon_sym_BSLASHintertext] = ACTIONS(6354),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [907] = {
    [ts_builtin_sym_end] = ACTIONS(6644),
    [sym_command_name] = ACTIONS(6642),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6642),
    [anon_sym_LBRACK] = ACTIONS(6644),
    [anon_sym_RBRACK] = ACTIONS(6644),
    [anon_sym_COMMA] = ACTIONS(6644),
    [anon_sym_EQ] = ACTIONS(6644),
    [anon_sym_LPAREN] = ACTIONS(6644),
    [anon_sym_RPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHpart] = ACTIONS(6642),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddpart] = ACTIONS(6642),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHchapter] = ACTIONS(6642),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddchap] = ACTIONS(6642),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsection] = ACTIONS(6642),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddsec] = ACTIONS(6642),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHitem] = ACTIONS(6642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6644),
    [anon_sym_LBRACE] = ACTIONS(6644),
    [anon_sym_RBRACE] = ACTIONS(6644),
    [sym_word] = ACTIONS(6642),
    [sym_placeholder] = ACTIONS(6644),
    [anon_sym_PLUS] = ACTIONS(6644),
    [anon_sym_DASH] = ACTIONS(6644),
    [anon_sym_STAR] = ACTIONS(6644),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_LT] = ACTIONS(6642),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_BANG] = ACTIONS(6642),
    [anon_sym_PIPE] = ACTIONS(6642),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_SQUOTE] = ACTIONS(6642),
    [anon_sym__] = ACTIONS(6644),
    [anon_sym_CARET] = ACTIONS(6644),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6644),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6644),
    [anon_sym_DOLLAR] = ACTIONS(6642),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHbegin] = ACTIONS(6642),
    [anon_sym_BSLASHtitle] = ACTIONS(6642),
    [anon_sym_BSLASHauthor] = ACTIONS(6642),
    [anon_sym_BSLASHusepackage] = ACTIONS(6642),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6642),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6642),
    [anon_sym_BSLASHinclude] = ACTIONS(6642),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6642),
    [anon_sym_BSLASHinput] = ACTIONS(6642),
    [anon_sym_BSLASHsubfile] = ACTIONS(6642),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6642),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6642),
    [anon_sym_BSLASHbibliography] = ACTIONS(6642),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6642),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6642),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6642),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6642),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6642),
    [anon_sym_BSLASHimport] = ACTIONS(6642),
    [anon_sym_BSLASHsubimport] = ACTIONS(6642),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6642),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHcaption] = ACTIONS(6642),
    [anon_sym_BSLASHcite] = ACTIONS(6642),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCite] = ACTIONS(6642),
    [anon_sym_BSLASHnocite] = ACTIONS(6642),
    [anon_sym_BSLASHcitet] = ACTIONS(6642),
    [anon_sym_BSLASHcitep] = ACTIONS(6642),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteA] = ACTIONS(6642),
    [anon_sym_BSLASHciteR] = ACTIONS(6642),
    [anon_sym_BSLASHciteS] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6642),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteyear] = ACTIONS(6642),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitedate] = ACTIONS(6642),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteurl] = ACTIONS(6642),
    [anon_sym_BSLASHfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6642),
    [anon_sym_BSLASHcitealt] = ACTIONS(6642),
    [anon_sym_BSLASHcitealp] = ACTIONS(6642),
    [anon_sym_BSLASHcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHparencite] = ACTIONS(6642),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHParencite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHtextcite] = ACTIONS(6642),
    [anon_sym_BSLASHTextcite] = ACTIONS(6642),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHsupercite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite] = ACTIONS(6642),
    [anon_sym_BSLASHAutocite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHVolcite] = ACTIONS(6642),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHavolcite] = ACTIONS(6642),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHNotecite] = ACTIONS(6642),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHlabel] = ACTIONS(6642),
    [anon_sym_BSLASHref] = ACTIONS(6642),
    [anon_sym_BSLASHeqref] = ACTIONS(6642),
    [anon_sym_BSLASHvref] = ACTIONS(6642),
    [anon_sym_BSLASHVref] = ACTIONS(6642),
    [anon_sym_BSLASHautoref] = ACTIONS(6642),
    [anon_sym_BSLASHpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcref] = ACTIONS(6642),
    [anon_sym_BSLASHCref] = ACTIONS(6642),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnameCref] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHdef] = ACTIONS(6642),
    [anon_sym_BSLASHlet] = ACTIONS(6642),
    [anon_sym_BSLASHleft] = ACTIONS(6642),
    [anon_sym_BSLASHbigl] = ACTIONS(6642),
    [anon_sym_BSLASHBigl] = ACTIONS(6642),
    [anon_sym_BSLASHbiggl] = ACTIONS(6642),
    [anon_sym_BSLASHBiggl] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6642),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6642),
    [anon_sym_BSLASHgls] = ACTIONS(6642),
    [anon_sym_BSLASHGls] = ACTIONS(6642),
    [anon_sym_BSLASHGLS] = ACTIONS(6642),
    [anon_sym_BSLASHglspl] = ACTIONS(6642),
    [anon_sym_BSLASHGlspl] = ACTIONS(6642),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6642),
    [anon_sym_BSLASHglslink] = ACTIONS(6642),
    [anon_sym_BSLASHglstext] = ACTIONS(6642),
    [anon_sym_BSLASHGlstext] = ACTIONS(6642),
    [anon_sym_BSLASHGLStext] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6642),
    [anon_sym_BSLASHglsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsname] = ACTIONS(6642),
    [anon_sym_BSLASHGlsname] = ACTIONS(6642),
    [anon_sym_BSLASHGLSname] = ACTIONS(6642),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6642),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6642),
    [anon_sym_BSLASHacrshort] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6642),
    [anon_sym_BSLASHACRshort] = ACTIONS(6642),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrlong] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6642),
    [anon_sym_BSLASHACRlong] = ACTIONS(6642),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrfull] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6642),
    [anon_sym_BSLASHACRfull] = ACTIONS(6642),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHacs] = ACTIONS(6642),
    [anon_sym_BSLASHAcs] = ACTIONS(6642),
    [anon_sym_BSLASHacsp] = ACTIONS(6642),
    [anon_sym_BSLASHAcsp] = ACTIONS(6642),
    [anon_sym_BSLASHacl] = ACTIONS(6642),
    [anon_sym_BSLASHAcl] = ACTIONS(6642),
    [anon_sym_BSLASHaclp] = ACTIONS(6642),
    [anon_sym_BSLASHAclp] = ACTIONS(6642),
    [anon_sym_BSLASHacf] = ACTIONS(6642),
    [anon_sym_BSLASHAcf] = ACTIONS(6642),
    [anon_sym_BSLASHacfp] = ACTIONS(6642),
    [anon_sym_BSLASHAcfp] = ACTIONS(6642),
    [anon_sym_BSLASHac] = ACTIONS(6642),
    [anon_sym_BSLASHAc] = ACTIONS(6642),
    [anon_sym_BSLASHacp] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6642),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6642),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6642),
    [anon_sym_BSLASHcolor] = ACTIONS(6642),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6642),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6642),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6642),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6642),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6642),
    [anon_sym_BSLASHtext] = ACTIONS(6642),
    [anon_sym_BSLASHintertext] = ACTIONS(6642),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6642),
    [anon_sym_BSLASHurl] = ACTIONS(6642),
    [anon_sym_BSLASHhref] = ACTIONS(6642),
  },
  [908] = {
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(7053),
    [anon_sym_LBRACK] = ACTIONS(6160),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHpart] = ACTIONS(6156),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddpart] = ACTIONS(6156),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHchapter] = ACTIONS(6156),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddchap] = ACTIONS(6156),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsection] = ACTIONS(6156),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddsec] = ACTIONS(6156),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHitem] = ACTIONS(6156),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6160),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(6156),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6160),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHbegin] = ACTIONS(6156),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHleft] = ACTIONS(6156),
    [anon_sym_BSLASHbigl] = ACTIONS(6156),
    [anon_sym_BSLASHBigl] = ACTIONS(6156),
    [anon_sym_BSLASHbiggl] = ACTIONS(6156),
    [anon_sym_BSLASHBiggl] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHtext] = ACTIONS(6156),
    [anon_sym_BSLASHintertext] = ACTIONS(6156),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [909] = {
    [ts_builtin_sym_end] = ACTIONS(2216),
    [sym_command_name] = ACTIONS(2214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_RBRACK] = ACTIONS(2216),
    [anon_sym_COMMA] = ACTIONS(2216),
    [anon_sym_EQ] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2216),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHitem] = ACTIONS(2214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [anon_sym_RBRACE] = ACTIONS(2216),
    [sym_word] = ACTIONS(2214),
    [sym_placeholder] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_COLON] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [anon_sym__] = ACTIONS(2216),
    [anon_sym_CARET] = ACTIONS(2216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2216),
    [anon_sym_DOLLAR] = ACTIONS(2214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHbegin] = ACTIONS(2214),
    [anon_sym_BSLASHtitle] = ACTIONS(2214),
    [anon_sym_BSLASHauthor] = ACTIONS(2214),
    [anon_sym_BSLASHusepackage] = ACTIONS(2214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2214),
    [anon_sym_BSLASHinclude] = ACTIONS(2214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2214),
    [anon_sym_BSLASHinput] = ACTIONS(2214),
    [anon_sym_BSLASHsubfile] = ACTIONS(2214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2214),
    [anon_sym_BSLASHbibliography] = ACTIONS(2214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2214),
    [anon_sym_BSLASHimport] = ACTIONS(2214),
    [anon_sym_BSLASHsubimport] = ACTIONS(2214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHcaption] = ACTIONS(2214),
    [anon_sym_BSLASHcite] = ACTIONS(2214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCite] = ACTIONS(2214),
    [anon_sym_BSLASHnocite] = ACTIONS(2214),
    [anon_sym_BSLASHcitet] = ACTIONS(2214),
    [anon_sym_BSLASHcitep] = ACTIONS(2214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteA] = ACTIONS(2214),
    [anon_sym_BSLASHciteR] = ACTIONS(2214),
    [anon_sym_BSLASHciteS] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteyear] = ACTIONS(2214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitedate] = ACTIONS(2214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteurl] = ACTIONS(2214),
    [anon_sym_BSLASHfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2214),
    [anon_sym_BSLASHcitealt] = ACTIONS(2214),
    [anon_sym_BSLASHcitealp] = ACTIONS(2214),
    [anon_sym_BSLASHcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHparencite] = ACTIONS(2214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHParencite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHtextcite] = ACTIONS(2214),
    [anon_sym_BSLASHTextcite] = ACTIONS(2214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHsupercite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite] = ACTIONS(2214),
    [anon_sym_BSLASHAutocite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHVolcite] = ACTIONS(2214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHavolcite] = ACTIONS(2214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHNotecite] = ACTIONS(2214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHlabel] = ACTIONS(2214),
    [anon_sym_BSLASHref] = ACTIONS(2214),
    [anon_sym_BSLASHeqref] = ACTIONS(2214),
    [anon_sym_BSLASHvref] = ACTIONS(2214),
    [anon_sym_BSLASHVref] = ACTIONS(2214),
    [anon_sym_BSLASHautoref] = ACTIONS(2214),
    [anon_sym_BSLASHpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcref] = ACTIONS(2214),
    [anon_sym_BSLASHCref] = ACTIONS(2214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnameCref] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHdef] = ACTIONS(2214),
    [anon_sym_BSLASHlet] = ACTIONS(2214),
    [anon_sym_BSLASHleft] = ACTIONS(2214),
    [anon_sym_BSLASHbigl] = ACTIONS(2214),
    [anon_sym_BSLASHBigl] = ACTIONS(2214),
    [anon_sym_BSLASHbiggl] = ACTIONS(2214),
    [anon_sym_BSLASHBiggl] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2214),
    [anon_sym_BSLASHgls] = ACTIONS(2214),
    [anon_sym_BSLASHGls] = ACTIONS(2214),
    [anon_sym_BSLASHGLS] = ACTIONS(2214),
    [anon_sym_BSLASHglspl] = ACTIONS(2214),
    [anon_sym_BSLASHGlspl] = ACTIONS(2214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2214),
    [anon_sym_BSLASHglslink] = ACTIONS(2214),
    [anon_sym_BSLASHglstext] = ACTIONS(2214),
    [anon_sym_BSLASHGlstext] = ACTIONS(2214),
    [anon_sym_BSLASHGLStext] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2214),
    [anon_sym_BSLASHglsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsname] = ACTIONS(2214),
    [anon_sym_BSLASHGlsname] = ACTIONS(2214),
    [anon_sym_BSLASHGLSname] = ACTIONS(2214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2214),
    [anon_sym_BSLASHacrshort] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2214),
    [anon_sym_BSLASHACRshort] = ACTIONS(2214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrlong] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2214),
    [anon_sym_BSLASHACRlong] = ACTIONS(2214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrfull] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2214),
    [anon_sym_BSLASHACRfull] = ACTIONS(2214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHacs] = ACTIONS(2214),
    [anon_sym_BSLASHAcs] = ACTIONS(2214),
    [anon_sym_BSLASHacsp] = ACTIONS(2214),
    [anon_sym_BSLASHAcsp] = ACTIONS(2214),
    [anon_sym_BSLASHacl] = ACTIONS(2214),
    [anon_sym_BSLASHAcl] = ACTIONS(2214),
    [anon_sym_BSLASHaclp] = ACTIONS(2214),
    [anon_sym_BSLASHAclp] = ACTIONS(2214),
    [anon_sym_BSLASHacf] = ACTIONS(2214),
    [anon_sym_BSLASHAcf] = ACTIONS(2214),
    [anon_sym_BSLASHacfp] = ACTIONS(2214),
    [anon_sym_BSLASHAcfp] = ACTIONS(2214),
    [anon_sym_BSLASHac] = ACTIONS(2214),
    [anon_sym_BSLASHAc] = ACTIONS(2214),
    [anon_sym_BSLASHacp] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2214),
    [anon_sym_BSLASHcolor] = ACTIONS(2214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2214),
    [anon_sym_BSLASHtext] = ACTIONS(2214),
    [anon_sym_BSLASHintertext] = ACTIONS(2214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2214),
    [anon_sym_BSLASHurl] = ACTIONS(2214),
    [anon_sym_BSLASHhref] = ACTIONS(2214),
  },
  [910] = {
    [ts_builtin_sym_end] = ACTIONS(6548),
    [sym_command_name] = ACTIONS(6546),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6548),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LPAREN] = ACTIONS(6548),
    [anon_sym_RPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHpart] = ACTIONS(6546),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddpart] = ACTIONS(6546),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHchapter] = ACTIONS(6546),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddchap] = ACTIONS(6546),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsection] = ACTIONS(6546),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddsec] = ACTIONS(6546),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHitem] = ACTIONS(6546),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6548),
    [anon_sym_LBRACE] = ACTIONS(6548),
    [anon_sym_RBRACE] = ACTIONS(6548),
    [sym_word] = ACTIONS(6546),
    [sym_placeholder] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_DASH] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6546),
    [anon_sym_GT] = ACTIONS(6546),
    [anon_sym_BANG] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6546),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_SQUOTE] = ACTIONS(6546),
    [anon_sym__] = ACTIONS(6548),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6548),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6548),
    [anon_sym_DOLLAR] = ACTIONS(6546),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHbegin] = ACTIONS(6546),
    [anon_sym_BSLASHtitle] = ACTIONS(6546),
    [anon_sym_BSLASHauthor] = ACTIONS(6546),
    [anon_sym_BSLASHusepackage] = ACTIONS(6546),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6546),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6546),
    [anon_sym_BSLASHinclude] = ACTIONS(6546),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6546),
    [anon_sym_BSLASHinput] = ACTIONS(6546),
    [anon_sym_BSLASHsubfile] = ACTIONS(6546),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6546),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6546),
    [anon_sym_BSLASHbibliography] = ACTIONS(6546),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6546),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6546),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6546),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6546),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6546),
    [anon_sym_BSLASHimport] = ACTIONS(6546),
    [anon_sym_BSLASHsubimport] = ACTIONS(6546),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6546),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHcaption] = ACTIONS(6546),
    [anon_sym_BSLASHcite] = ACTIONS(6546),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCite] = ACTIONS(6546),
    [anon_sym_BSLASHnocite] = ACTIONS(6546),
    [anon_sym_BSLASHcitet] = ACTIONS(6546),
    [anon_sym_BSLASHcitep] = ACTIONS(6546),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteA] = ACTIONS(6546),
    [anon_sym_BSLASHciteR] = ACTIONS(6546),
    [anon_sym_BSLASHciteS] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6546),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteyear] = ACTIONS(6546),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitedate] = ACTIONS(6546),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteurl] = ACTIONS(6546),
    [anon_sym_BSLASHfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6546),
    [anon_sym_BSLASHcitealt] = ACTIONS(6546),
    [anon_sym_BSLASHcitealp] = ACTIONS(6546),
    [anon_sym_BSLASHcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHparencite] = ACTIONS(6546),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHParencite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHtextcite] = ACTIONS(6546),
    [anon_sym_BSLASHTextcite] = ACTIONS(6546),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHsupercite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite] = ACTIONS(6546),
    [anon_sym_BSLASHAutocite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHVolcite] = ACTIONS(6546),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHavolcite] = ACTIONS(6546),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHNotecite] = ACTIONS(6546),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHlabel] = ACTIONS(6546),
    [anon_sym_BSLASHref] = ACTIONS(6546),
    [anon_sym_BSLASHeqref] = ACTIONS(6546),
    [anon_sym_BSLASHvref] = ACTIONS(6546),
    [anon_sym_BSLASHVref] = ACTIONS(6546),
    [anon_sym_BSLASHautoref] = ACTIONS(6546),
    [anon_sym_BSLASHpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcref] = ACTIONS(6546),
    [anon_sym_BSLASHCref] = ACTIONS(6546),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnameCref] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHdef] = ACTIONS(6546),
    [anon_sym_BSLASHlet] = ACTIONS(6546),
    [anon_sym_BSLASHleft] = ACTIONS(6546),
    [anon_sym_BSLASHbigl] = ACTIONS(6546),
    [anon_sym_BSLASHBigl] = ACTIONS(6546),
    [anon_sym_BSLASHbiggl] = ACTIONS(6546),
    [anon_sym_BSLASHBiggl] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6546),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6546),
    [anon_sym_BSLASHgls] = ACTIONS(6546),
    [anon_sym_BSLASHGls] = ACTIONS(6546),
    [anon_sym_BSLASHGLS] = ACTIONS(6546),
    [anon_sym_BSLASHglspl] = ACTIONS(6546),
    [anon_sym_BSLASHGlspl] = ACTIONS(6546),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6546),
    [anon_sym_BSLASHglslink] = ACTIONS(6546),
    [anon_sym_BSLASHglstext] = ACTIONS(6546),
    [anon_sym_BSLASHGlstext] = ACTIONS(6546),
    [anon_sym_BSLASHGLStext] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6546),
    [anon_sym_BSLASHglsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsname] = ACTIONS(6546),
    [anon_sym_BSLASHGlsname] = ACTIONS(6546),
    [anon_sym_BSLASHGLSname] = ACTIONS(6546),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6546),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6546),
    [anon_sym_BSLASHacrshort] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6546),
    [anon_sym_BSLASHACRshort] = ACTIONS(6546),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrlong] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6546),
    [anon_sym_BSLASHACRlong] = ACTIONS(6546),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrfull] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6546),
    [anon_sym_BSLASHACRfull] = ACTIONS(6546),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHacs] = ACTIONS(6546),
    [anon_sym_BSLASHAcs] = ACTIONS(6546),
    [anon_sym_BSLASHacsp] = ACTIONS(6546),
    [anon_sym_BSLASHAcsp] = ACTIONS(6546),
    [anon_sym_BSLASHacl] = ACTIONS(6546),
    [anon_sym_BSLASHAcl] = ACTIONS(6546),
    [anon_sym_BSLASHaclp] = ACTIONS(6546),
    [anon_sym_BSLASHAclp] = ACTIONS(6546),
    [anon_sym_BSLASHacf] = ACTIONS(6546),
    [anon_sym_BSLASHAcf] = ACTIONS(6546),
    [anon_sym_BSLASHacfp] = ACTIONS(6546),
    [anon_sym_BSLASHAcfp] = ACTIONS(6546),
    [anon_sym_BSLASHac] = ACTIONS(6546),
    [anon_sym_BSLASHAc] = ACTIONS(6546),
    [anon_sym_BSLASHacp] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6546),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6546),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6546),
    [anon_sym_BSLASHcolor] = ACTIONS(6546),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6546),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6546),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6546),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6546),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6546),
    [anon_sym_BSLASHtext] = ACTIONS(6546),
    [anon_sym_BSLASHintertext] = ACTIONS(6546),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6546),
    [anon_sym_BSLASHurl] = ACTIONS(6546),
    [anon_sym_BSLASHhref] = ACTIONS(6546),
  },
  [911] = {
    [ts_builtin_sym_end] = ACTIONS(6604),
    [sym_command_name] = ACTIONS(6602),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6602),
    [anon_sym_LBRACK] = ACTIONS(6604),
    [anon_sym_RBRACK] = ACTIONS(6604),
    [anon_sym_COMMA] = ACTIONS(6604),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(6604),
    [anon_sym_RPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHpart] = ACTIONS(6602),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddpart] = ACTIONS(6602),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHchapter] = ACTIONS(6602),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddchap] = ACTIONS(6602),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsection] = ACTIONS(6602),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddsec] = ACTIONS(6602),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHitem] = ACTIONS(6602),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6604),
    [anon_sym_LBRACE] = ACTIONS(6604),
    [anon_sym_RBRACE] = ACTIONS(6604),
    [sym_word] = ACTIONS(6602),
    [sym_placeholder] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6602),
    [anon_sym_GT] = ACTIONS(6602),
    [anon_sym_BANG] = ACTIONS(6602),
    [anon_sym_PIPE] = ACTIONS(6602),
    [anon_sym_COLON] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(6602),
    [anon_sym__] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6604),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6604),
    [anon_sym_DOLLAR] = ACTIONS(6602),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHbegin] = ACTIONS(6602),
    [anon_sym_BSLASHtitle] = ACTIONS(6602),
    [anon_sym_BSLASHauthor] = ACTIONS(6602),
    [anon_sym_BSLASHusepackage] = ACTIONS(6602),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6602),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6602),
    [anon_sym_BSLASHinclude] = ACTIONS(6602),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6602),
    [anon_sym_BSLASHinput] = ACTIONS(6602),
    [anon_sym_BSLASHsubfile] = ACTIONS(6602),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6602),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6602),
    [anon_sym_BSLASHbibliography] = ACTIONS(6602),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6602),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6602),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6602),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6602),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6602),
    [anon_sym_BSLASHimport] = ACTIONS(6602),
    [anon_sym_BSLASHsubimport] = ACTIONS(6602),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6602),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHcaption] = ACTIONS(6602),
    [anon_sym_BSLASHcite] = ACTIONS(6602),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCite] = ACTIONS(6602),
    [anon_sym_BSLASHnocite] = ACTIONS(6602),
    [anon_sym_BSLASHcitet] = ACTIONS(6602),
    [anon_sym_BSLASHcitep] = ACTIONS(6602),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteA] = ACTIONS(6602),
    [anon_sym_BSLASHciteR] = ACTIONS(6602),
    [anon_sym_BSLASHciteS] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6602),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteyear] = ACTIONS(6602),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitedate] = ACTIONS(6602),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteurl] = ACTIONS(6602),
    [anon_sym_BSLASHfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6602),
    [anon_sym_BSLASHcitealt] = ACTIONS(6602),
    [anon_sym_BSLASHcitealp] = ACTIONS(6602),
    [anon_sym_BSLASHcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHparencite] = ACTIONS(6602),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHParencite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHtextcite] = ACTIONS(6602),
    [anon_sym_BSLASHTextcite] = ACTIONS(6602),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHsupercite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite] = ACTIONS(6602),
    [anon_sym_BSLASHAutocite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHVolcite] = ACTIONS(6602),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHavolcite] = ACTIONS(6602),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHNotecite] = ACTIONS(6602),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHlabel] = ACTIONS(6602),
    [anon_sym_BSLASHref] = ACTIONS(6602),
    [anon_sym_BSLASHeqref] = ACTIONS(6602),
    [anon_sym_BSLASHvref] = ACTIONS(6602),
    [anon_sym_BSLASHVref] = ACTIONS(6602),
    [anon_sym_BSLASHautoref] = ACTIONS(6602),
    [anon_sym_BSLASHpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcref] = ACTIONS(6602),
    [anon_sym_BSLASHCref] = ACTIONS(6602),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnameCref] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHdef] = ACTIONS(6602),
    [anon_sym_BSLASHlet] = ACTIONS(6602),
    [anon_sym_BSLASHleft] = ACTIONS(6602),
    [anon_sym_BSLASHbigl] = ACTIONS(6602),
    [anon_sym_BSLASHBigl] = ACTIONS(6602),
    [anon_sym_BSLASHbiggl] = ACTIONS(6602),
    [anon_sym_BSLASHBiggl] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6602),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6602),
    [anon_sym_BSLASHgls] = ACTIONS(6602),
    [anon_sym_BSLASHGls] = ACTIONS(6602),
    [anon_sym_BSLASHGLS] = ACTIONS(6602),
    [anon_sym_BSLASHglspl] = ACTIONS(6602),
    [anon_sym_BSLASHGlspl] = ACTIONS(6602),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6602),
    [anon_sym_BSLASHglslink] = ACTIONS(6602),
    [anon_sym_BSLASHglstext] = ACTIONS(6602),
    [anon_sym_BSLASHGlstext] = ACTIONS(6602),
    [anon_sym_BSLASHGLStext] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6602),
    [anon_sym_BSLASHglsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsname] = ACTIONS(6602),
    [anon_sym_BSLASHGlsname] = ACTIONS(6602),
    [anon_sym_BSLASHGLSname] = ACTIONS(6602),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6602),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6602),
    [anon_sym_BSLASHacrshort] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6602),
    [anon_sym_BSLASHACRshort] = ACTIONS(6602),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrlong] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6602),
    [anon_sym_BSLASHACRlong] = ACTIONS(6602),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrfull] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6602),
    [anon_sym_BSLASHACRfull] = ACTIONS(6602),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHacs] = ACTIONS(6602),
    [anon_sym_BSLASHAcs] = ACTIONS(6602),
    [anon_sym_BSLASHacsp] = ACTIONS(6602),
    [anon_sym_BSLASHAcsp] = ACTIONS(6602),
    [anon_sym_BSLASHacl] = ACTIONS(6602),
    [anon_sym_BSLASHAcl] = ACTIONS(6602),
    [anon_sym_BSLASHaclp] = ACTIONS(6602),
    [anon_sym_BSLASHAclp] = ACTIONS(6602),
    [anon_sym_BSLASHacf] = ACTIONS(6602),
    [anon_sym_BSLASHAcf] = ACTIONS(6602),
    [anon_sym_BSLASHacfp] = ACTIONS(6602),
    [anon_sym_BSLASHAcfp] = ACTIONS(6602),
    [anon_sym_BSLASHac] = ACTIONS(6602),
    [anon_sym_BSLASHAc] = ACTIONS(6602),
    [anon_sym_BSLASHacp] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6602),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6602),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6602),
    [anon_sym_BSLASHcolor] = ACTIONS(6602),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6602),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6602),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6602),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6602),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6602),
    [anon_sym_BSLASHtext] = ACTIONS(6602),
    [anon_sym_BSLASHintertext] = ACTIONS(6602),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6602),
    [anon_sym_BSLASHurl] = ACTIONS(6602),
    [anon_sym_BSLASHhref] = ACTIONS(6602),
  },
  [912] = {
    [ts_builtin_sym_end] = ACTIONS(6544),
    [sym_command_name] = ACTIONS(6542),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6544),
    [anon_sym_RBRACK] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LPAREN] = ACTIONS(6544),
    [anon_sym_RPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHpart] = ACTIONS(6542),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddpart] = ACTIONS(6542),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHchapter] = ACTIONS(6542),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddchap] = ACTIONS(6542),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsection] = ACTIONS(6542),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddsec] = ACTIONS(6542),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHitem] = ACTIONS(6542),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6544),
    [anon_sym_LBRACE] = ACTIONS(6544),
    [anon_sym_RBRACE] = ACTIONS(6544),
    [sym_word] = ACTIONS(6542),
    [sym_placeholder] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_DASH] = ACTIONS(6544),
    [anon_sym_STAR] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6542),
    [anon_sym_GT] = ACTIONS(6542),
    [anon_sym_BANG] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6542),
    [anon_sym_COLON] = ACTIONS(6542),
    [anon_sym_SQUOTE] = ACTIONS(6542),
    [anon_sym__] = ACTIONS(6544),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6544),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6544),
    [anon_sym_DOLLAR] = ACTIONS(6542),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHbegin] = ACTIONS(6542),
    [anon_sym_BSLASHtitle] = ACTIONS(6542),
    [anon_sym_BSLASHauthor] = ACTIONS(6542),
    [anon_sym_BSLASHusepackage] = ACTIONS(6542),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6542),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6542),
    [anon_sym_BSLASHinclude] = ACTIONS(6542),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6542),
    [anon_sym_BSLASHinput] = ACTIONS(6542),
    [anon_sym_BSLASHsubfile] = ACTIONS(6542),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6542),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6542),
    [anon_sym_BSLASHbibliography] = ACTIONS(6542),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6542),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6542),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6542),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6542),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6542),
    [anon_sym_BSLASHimport] = ACTIONS(6542),
    [anon_sym_BSLASHsubimport] = ACTIONS(6542),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6542),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHcaption] = ACTIONS(6542),
    [anon_sym_BSLASHcite] = ACTIONS(6542),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCite] = ACTIONS(6542),
    [anon_sym_BSLASHnocite] = ACTIONS(6542),
    [anon_sym_BSLASHcitet] = ACTIONS(6542),
    [anon_sym_BSLASHcitep] = ACTIONS(6542),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteA] = ACTIONS(6542),
    [anon_sym_BSLASHciteR] = ACTIONS(6542),
    [anon_sym_BSLASHciteS] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6542),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteyear] = ACTIONS(6542),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitedate] = ACTIONS(6542),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteurl] = ACTIONS(6542),
    [anon_sym_BSLASHfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6542),
    [anon_sym_BSLASHcitealt] = ACTIONS(6542),
    [anon_sym_BSLASHcitealp] = ACTIONS(6542),
    [anon_sym_BSLASHcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHparencite] = ACTIONS(6542),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHParencite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHtextcite] = ACTIONS(6542),
    [anon_sym_BSLASHTextcite] = ACTIONS(6542),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHsupercite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite] = ACTIONS(6542),
    [anon_sym_BSLASHAutocite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHVolcite] = ACTIONS(6542),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHavolcite] = ACTIONS(6542),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHNotecite] = ACTIONS(6542),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHlabel] = ACTIONS(6542),
    [anon_sym_BSLASHref] = ACTIONS(6542),
    [anon_sym_BSLASHeqref] = ACTIONS(6542),
    [anon_sym_BSLASHvref] = ACTIONS(6542),
    [anon_sym_BSLASHVref] = ACTIONS(6542),
    [anon_sym_BSLASHautoref] = ACTIONS(6542),
    [anon_sym_BSLASHpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcref] = ACTIONS(6542),
    [anon_sym_BSLASHCref] = ACTIONS(6542),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnameCref] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHdef] = ACTIONS(6542),
    [anon_sym_BSLASHlet] = ACTIONS(6542),
    [anon_sym_BSLASHleft] = ACTIONS(6542),
    [anon_sym_BSLASHbigl] = ACTIONS(6542),
    [anon_sym_BSLASHBigl] = ACTIONS(6542),
    [anon_sym_BSLASHbiggl] = ACTIONS(6542),
    [anon_sym_BSLASHBiggl] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6542),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6542),
    [anon_sym_BSLASHgls] = ACTIONS(6542),
    [anon_sym_BSLASHGls] = ACTIONS(6542),
    [anon_sym_BSLASHGLS] = ACTIONS(6542),
    [anon_sym_BSLASHglspl] = ACTIONS(6542),
    [anon_sym_BSLASHGlspl] = ACTIONS(6542),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6542),
    [anon_sym_BSLASHglslink] = ACTIONS(6542),
    [anon_sym_BSLASHglstext] = ACTIONS(6542),
    [anon_sym_BSLASHGlstext] = ACTIONS(6542),
    [anon_sym_BSLASHGLStext] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6542),
    [anon_sym_BSLASHglsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsname] = ACTIONS(6542),
    [anon_sym_BSLASHGlsname] = ACTIONS(6542),
    [anon_sym_BSLASHGLSname] = ACTIONS(6542),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6542),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6542),
    [anon_sym_BSLASHacrshort] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6542),
    [anon_sym_BSLASHACRshort] = ACTIONS(6542),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrlong] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6542),
    [anon_sym_BSLASHACRlong] = ACTIONS(6542),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrfull] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6542),
    [anon_sym_BSLASHACRfull] = ACTIONS(6542),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHacs] = ACTIONS(6542),
    [anon_sym_BSLASHAcs] = ACTIONS(6542),
    [anon_sym_BSLASHacsp] = ACTIONS(6542),
    [anon_sym_BSLASHAcsp] = ACTIONS(6542),
    [anon_sym_BSLASHacl] = ACTIONS(6542),
    [anon_sym_BSLASHAcl] = ACTIONS(6542),
    [anon_sym_BSLASHaclp] = ACTIONS(6542),
    [anon_sym_BSLASHAclp] = ACTIONS(6542),
    [anon_sym_BSLASHacf] = ACTIONS(6542),
    [anon_sym_BSLASHAcf] = ACTIONS(6542),
    [anon_sym_BSLASHacfp] = ACTIONS(6542),
    [anon_sym_BSLASHAcfp] = ACTIONS(6542),
    [anon_sym_BSLASHac] = ACTIONS(6542),
    [anon_sym_BSLASHAc] = ACTIONS(6542),
    [anon_sym_BSLASHacp] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6542),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6542),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6542),
    [anon_sym_BSLASHcolor] = ACTIONS(6542),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6542),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6542),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6542),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6542),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6542),
    [anon_sym_BSLASHtext] = ACTIONS(6542),
    [anon_sym_BSLASHintertext] = ACTIONS(6542),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6542),
    [anon_sym_BSLASHurl] = ACTIONS(6542),
    [anon_sym_BSLASHhref] = ACTIONS(6542),
  },
  [913] = {
    [sym_curly_group] = STATE(1395),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHpart] = ACTIONS(6152),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddpart] = ACTIONS(6152),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHchapter] = ACTIONS(6152),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddchap] = ACTIONS(6152),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsection] = ACTIONS(6152),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddsec] = ACTIONS(6152),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHitem] = ACTIONS(6152),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6154),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6154),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHbegin] = ACTIONS(6152),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHleft] = ACTIONS(6152),
    [anon_sym_BSLASHbigl] = ACTIONS(6152),
    [anon_sym_BSLASHBigl] = ACTIONS(6152),
    [anon_sym_BSLASHbiggl] = ACTIONS(6152),
    [anon_sym_BSLASHBiggl] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHtext] = ACTIONS(6152),
    [anon_sym_BSLASHintertext] = ACTIONS(6152),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [914] = {
    [ts_builtin_sym_end] = ACTIONS(6276),
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6276),
    [anon_sym_RBRACK] = ACTIONS(6276),
    [anon_sym_COMMA] = ACTIONS(6276),
    [anon_sym_EQ] = ACTIONS(6276),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHpart] = ACTIONS(6274),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddpart] = ACTIONS(6274),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHchapter] = ACTIONS(6274),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddchap] = ACTIONS(6274),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsection] = ACTIONS(6274),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddsec] = ACTIONS(6274),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHitem] = ACTIONS(6274),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [anon_sym_RBRACE] = ACTIONS(6276),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6276),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6276),
    [anon_sym_DOLLAR] = ACTIONS(6274),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHbegin] = ACTIONS(6274),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHleft] = ACTIONS(6274),
    [anon_sym_BSLASHbigl] = ACTIONS(6274),
    [anon_sym_BSLASHBigl] = ACTIONS(6274),
    [anon_sym_BSLASHbiggl] = ACTIONS(6274),
    [anon_sym_BSLASHBiggl] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHtext] = ACTIONS(6274),
    [anon_sym_BSLASHintertext] = ACTIONS(6274),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [915] = {
    [sym_brack_group_text] = STATE(1399),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(7055),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHpart] = ACTIONS(6148),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddpart] = ACTIONS(6148),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHchapter] = ACTIONS(6148),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddchap] = ACTIONS(6148),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsection] = ACTIONS(6148),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddsec] = ACTIONS(6148),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHitem] = ACTIONS(6148),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6150),
    [anon_sym_LBRACE] = ACTIONS(6150),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6150),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6150),
    [anon_sym_DOLLAR] = ACTIONS(6148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHbegin] = ACTIONS(6148),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHleft] = ACTIONS(6148),
    [anon_sym_BSLASHbigl] = ACTIONS(6148),
    [anon_sym_BSLASHBigl] = ACTIONS(6148),
    [anon_sym_BSLASHbiggl] = ACTIONS(6148),
    [anon_sym_BSLASHBiggl] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHtext] = ACTIONS(6148),
    [anon_sym_BSLASHintertext] = ACTIONS(6148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [916] = {
    [sym_curly_group] = STATE(1442),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6146),
    [anon_sym_LPAREN] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHpart] = ACTIONS(6144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddpart] = ACTIONS(6144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHchapter] = ACTIONS(6144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddchap] = ACTIONS(6144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsection] = ACTIONS(6144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddsec] = ACTIONS(6144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHitem] = ACTIONS(6144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6146),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6146),
    [anon_sym_DOLLAR] = ACTIONS(6144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHbegin] = ACTIONS(6144),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHleft] = ACTIONS(6144),
    [anon_sym_BSLASHbigl] = ACTIONS(6144),
    [anon_sym_BSLASHBigl] = ACTIONS(6144),
    [anon_sym_BSLASHbiggl] = ACTIONS(6144),
    [anon_sym_BSLASHBiggl] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHtext] = ACTIONS(6144),
    [anon_sym_BSLASHintertext] = ACTIONS(6144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [917] = {
    [ts_builtin_sym_end] = ACTIONS(6524),
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_LBRACK] = ACTIONS(6524),
    [anon_sym_RBRACK] = ACTIONS(6524),
    [anon_sym_COMMA] = ACTIONS(6524),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6524),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHpart] = ACTIONS(6522),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddpart] = ACTIONS(6522),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHchapter] = ACTIONS(6522),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddchap] = ACTIONS(6522),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsection] = ACTIONS(6522),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddsec] = ACTIONS(6522),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHitem] = ACTIONS(6522),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6524),
    [anon_sym_RBRACE] = ACTIONS(6524),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6524),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6524),
    [anon_sym_DOLLAR] = ACTIONS(6522),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHbegin] = ACTIONS(6522),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHleft] = ACTIONS(6522),
    [anon_sym_BSLASHbigl] = ACTIONS(6522),
    [anon_sym_BSLASHBigl] = ACTIONS(6522),
    [anon_sym_BSLASHbiggl] = ACTIONS(6522),
    [anon_sym_BSLASHBiggl] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHtext] = ACTIONS(6522),
    [anon_sym_BSLASHintertext] = ACTIONS(6522),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [918] = {
    [ts_builtin_sym_end] = ACTIONS(6528),
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6528),
    [anon_sym_RBRACK] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6528),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [anon_sym_RPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHpart] = ACTIONS(6526),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddpart] = ACTIONS(6526),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHchapter] = ACTIONS(6526),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddchap] = ACTIONS(6526),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsection] = ACTIONS(6526),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddsec] = ACTIONS(6526),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHitem] = ACTIONS(6526),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6528),
    [anon_sym_LBRACE] = ACTIONS(6528),
    [anon_sym_RBRACE] = ACTIONS(6528),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6528),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(6526),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHbegin] = ACTIONS(6526),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHleft] = ACTIONS(6526),
    [anon_sym_BSLASHbigl] = ACTIONS(6526),
    [anon_sym_BSLASHBigl] = ACTIONS(6526),
    [anon_sym_BSLASHbiggl] = ACTIONS(6526),
    [anon_sym_BSLASHBiggl] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHtext] = ACTIONS(6526),
    [anon_sym_BSLASHintertext] = ACTIONS(6526),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [919] = {
    [ts_builtin_sym_end] = ACTIONS(6656),
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_RBRACK] = ACTIONS(6656),
    [anon_sym_COMMA] = ACTIONS(6656),
    [anon_sym_EQ] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(6656),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHpart] = ACTIONS(6654),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddpart] = ACTIONS(6654),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHchapter] = ACTIONS(6654),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddchap] = ACTIONS(6654),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsection] = ACTIONS(6654),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddsec] = ACTIONS(6654),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHitem] = ACTIONS(6654),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [anon_sym_RBRACE] = ACTIONS(6656),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6656),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6656),
    [anon_sym_DOLLAR] = ACTIONS(6654),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHbegin] = ACTIONS(6654),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHleft] = ACTIONS(6654),
    [anon_sym_BSLASHbigl] = ACTIONS(6654),
    [anon_sym_BSLASHBigl] = ACTIONS(6654),
    [anon_sym_BSLASHbiggl] = ACTIONS(6654),
    [anon_sym_BSLASHBiggl] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHtext] = ACTIONS(6654),
    [anon_sym_BSLASHintertext] = ACTIONS(6654),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [920] = {
    [ts_builtin_sym_end] = ACTIONS(6264),
    [sym_command_name] = ACTIONS(6262),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6262),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_RBRACK] = ACTIONS(6264),
    [anon_sym_COMMA] = ACTIONS(6264),
    [anon_sym_EQ] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(6264),
    [anon_sym_RPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHpart] = ACTIONS(6262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddpart] = ACTIONS(6262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHchapter] = ACTIONS(6262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddchap] = ACTIONS(6262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsection] = ACTIONS(6262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddsec] = ACTIONS(6262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHitem] = ACTIONS(6262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6264),
    [anon_sym_LBRACE] = ACTIONS(6264),
    [anon_sym_RBRACE] = ACTIONS(6264),
    [sym_word] = ACTIONS(6262),
    [sym_placeholder] = ACTIONS(6264),
    [anon_sym_PLUS] = ACTIONS(6264),
    [anon_sym_DASH] = ACTIONS(6264),
    [anon_sym_STAR] = ACTIONS(6264),
    [anon_sym_SLASH] = ACTIONS(6264),
    [anon_sym_LT] = ACTIONS(6262),
    [anon_sym_GT] = ACTIONS(6262),
    [anon_sym_BANG] = ACTIONS(6262),
    [anon_sym_PIPE] = ACTIONS(6262),
    [anon_sym_COLON] = ACTIONS(6262),
    [anon_sym_SQUOTE] = ACTIONS(6262),
    [anon_sym__] = ACTIONS(6264),
    [anon_sym_CARET] = ACTIONS(6264),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6264),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6264),
    [anon_sym_DOLLAR] = ACTIONS(6262),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHbegin] = ACTIONS(6262),
    [anon_sym_BSLASHtitle] = ACTIONS(6262),
    [anon_sym_BSLASHauthor] = ACTIONS(6262),
    [anon_sym_BSLASHusepackage] = ACTIONS(6262),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6262),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6262),
    [anon_sym_BSLASHinclude] = ACTIONS(6262),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6262),
    [anon_sym_BSLASHinput] = ACTIONS(6262),
    [anon_sym_BSLASHsubfile] = ACTIONS(6262),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6262),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6262),
    [anon_sym_BSLASHbibliography] = ACTIONS(6262),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6262),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6262),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6262),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6262),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6262),
    [anon_sym_BSLASHimport] = ACTIONS(6262),
    [anon_sym_BSLASHsubimport] = ACTIONS(6262),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6262),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHcaption] = ACTIONS(6262),
    [anon_sym_BSLASHcite] = ACTIONS(6262),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCite] = ACTIONS(6262),
    [anon_sym_BSLASHnocite] = ACTIONS(6262),
    [anon_sym_BSLASHcitet] = ACTIONS(6262),
    [anon_sym_BSLASHcitep] = ACTIONS(6262),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteA] = ACTIONS(6262),
    [anon_sym_BSLASHciteR] = ACTIONS(6262),
    [anon_sym_BSLASHciteS] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6262),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteyear] = ACTIONS(6262),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitedate] = ACTIONS(6262),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteurl] = ACTIONS(6262),
    [anon_sym_BSLASHfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6262),
    [anon_sym_BSLASHcitealt] = ACTIONS(6262),
    [anon_sym_BSLASHcitealp] = ACTIONS(6262),
    [anon_sym_BSLASHcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHparencite] = ACTIONS(6262),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHParencite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHtextcite] = ACTIONS(6262),
    [anon_sym_BSLASHTextcite] = ACTIONS(6262),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHsupercite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite] = ACTIONS(6262),
    [anon_sym_BSLASHAutocite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHVolcite] = ACTIONS(6262),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHavolcite] = ACTIONS(6262),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHNotecite] = ACTIONS(6262),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHlabel] = ACTIONS(6262),
    [anon_sym_BSLASHref] = ACTIONS(6262),
    [anon_sym_BSLASHeqref] = ACTIONS(6262),
    [anon_sym_BSLASHvref] = ACTIONS(6262),
    [anon_sym_BSLASHVref] = ACTIONS(6262),
    [anon_sym_BSLASHautoref] = ACTIONS(6262),
    [anon_sym_BSLASHpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcref] = ACTIONS(6262),
    [anon_sym_BSLASHCref] = ACTIONS(6262),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnameCref] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHdef] = ACTIONS(6262),
    [anon_sym_BSLASHlet] = ACTIONS(6262),
    [anon_sym_BSLASHleft] = ACTIONS(6262),
    [anon_sym_BSLASHbigl] = ACTIONS(6262),
    [anon_sym_BSLASHBigl] = ACTIONS(6262),
    [anon_sym_BSLASHbiggl] = ACTIONS(6262),
    [anon_sym_BSLASHBiggl] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6262),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6262),
    [anon_sym_BSLASHgls] = ACTIONS(6262),
    [anon_sym_BSLASHGls] = ACTIONS(6262),
    [anon_sym_BSLASHGLS] = ACTIONS(6262),
    [anon_sym_BSLASHglspl] = ACTIONS(6262),
    [anon_sym_BSLASHGlspl] = ACTIONS(6262),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6262),
    [anon_sym_BSLASHglslink] = ACTIONS(6262),
    [anon_sym_BSLASHglstext] = ACTIONS(6262),
    [anon_sym_BSLASHGlstext] = ACTIONS(6262),
    [anon_sym_BSLASHGLStext] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6262),
    [anon_sym_BSLASHglsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsname] = ACTIONS(6262),
    [anon_sym_BSLASHGlsname] = ACTIONS(6262),
    [anon_sym_BSLASHGLSname] = ACTIONS(6262),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6262),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6262),
    [anon_sym_BSLASHacrshort] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6262),
    [anon_sym_BSLASHACRshort] = ACTIONS(6262),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrlong] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6262),
    [anon_sym_BSLASHACRlong] = ACTIONS(6262),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrfull] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6262),
    [anon_sym_BSLASHACRfull] = ACTIONS(6262),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHacs] = ACTIONS(6262),
    [anon_sym_BSLASHAcs] = ACTIONS(6262),
    [anon_sym_BSLASHacsp] = ACTIONS(6262),
    [anon_sym_BSLASHAcsp] = ACTIONS(6262),
    [anon_sym_BSLASHacl] = ACTIONS(6262),
    [anon_sym_BSLASHAcl] = ACTIONS(6262),
    [anon_sym_BSLASHaclp] = ACTIONS(6262),
    [anon_sym_BSLASHAclp] = ACTIONS(6262),
    [anon_sym_BSLASHacf] = ACTIONS(6262),
    [anon_sym_BSLASHAcf] = ACTIONS(6262),
    [anon_sym_BSLASHacfp] = ACTIONS(6262),
    [anon_sym_BSLASHAcfp] = ACTIONS(6262),
    [anon_sym_BSLASHac] = ACTIONS(6262),
    [anon_sym_BSLASHAc] = ACTIONS(6262),
    [anon_sym_BSLASHacp] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6262),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6262),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6262),
    [anon_sym_BSLASHcolor] = ACTIONS(6262),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6262),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6262),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6262),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6262),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6262),
    [anon_sym_BSLASHtext] = ACTIONS(6262),
    [anon_sym_BSLASHintertext] = ACTIONS(6262),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6262),
    [anon_sym_BSLASHurl] = ACTIONS(6262),
    [anon_sym_BSLASHhref] = ACTIONS(6262),
  },
  [921] = {
    [ts_builtin_sym_end] = ACTIONS(6260),
    [sym_command_name] = ACTIONS(6258),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6258),
    [anon_sym_LBRACK] = ACTIONS(6260),
    [anon_sym_RBRACK] = ACTIONS(6260),
    [anon_sym_COMMA] = ACTIONS(6260),
    [anon_sym_EQ] = ACTIONS(6260),
    [anon_sym_LPAREN] = ACTIONS(6260),
    [anon_sym_RPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHpart] = ACTIONS(6258),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddpart] = ACTIONS(6258),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHchapter] = ACTIONS(6258),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddchap] = ACTIONS(6258),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsection] = ACTIONS(6258),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddsec] = ACTIONS(6258),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHitem] = ACTIONS(6258),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6260),
    [anon_sym_LBRACE] = ACTIONS(6260),
    [anon_sym_RBRACE] = ACTIONS(6260),
    [sym_word] = ACTIONS(6258),
    [sym_placeholder] = ACTIONS(6260),
    [anon_sym_PLUS] = ACTIONS(6260),
    [anon_sym_DASH] = ACTIONS(6260),
    [anon_sym_STAR] = ACTIONS(6260),
    [anon_sym_SLASH] = ACTIONS(6260),
    [anon_sym_LT] = ACTIONS(6258),
    [anon_sym_GT] = ACTIONS(6258),
    [anon_sym_BANG] = ACTIONS(6258),
    [anon_sym_PIPE] = ACTIONS(6258),
    [anon_sym_COLON] = ACTIONS(6258),
    [anon_sym_SQUOTE] = ACTIONS(6258),
    [anon_sym__] = ACTIONS(6260),
    [anon_sym_CARET] = ACTIONS(6260),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6260),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6260),
    [anon_sym_DOLLAR] = ACTIONS(6258),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHbegin] = ACTIONS(6258),
    [anon_sym_BSLASHtitle] = ACTIONS(6258),
    [anon_sym_BSLASHauthor] = ACTIONS(6258),
    [anon_sym_BSLASHusepackage] = ACTIONS(6258),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6258),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6258),
    [anon_sym_BSLASHinclude] = ACTIONS(6258),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6258),
    [anon_sym_BSLASHinput] = ACTIONS(6258),
    [anon_sym_BSLASHsubfile] = ACTIONS(6258),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6258),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6258),
    [anon_sym_BSLASHbibliography] = ACTIONS(6258),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6258),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6258),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6258),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6258),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6258),
    [anon_sym_BSLASHimport] = ACTIONS(6258),
    [anon_sym_BSLASHsubimport] = ACTIONS(6258),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6258),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHcaption] = ACTIONS(6258),
    [anon_sym_BSLASHcite] = ACTIONS(6258),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCite] = ACTIONS(6258),
    [anon_sym_BSLASHnocite] = ACTIONS(6258),
    [anon_sym_BSLASHcitet] = ACTIONS(6258),
    [anon_sym_BSLASHcitep] = ACTIONS(6258),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteA] = ACTIONS(6258),
    [anon_sym_BSLASHciteR] = ACTIONS(6258),
    [anon_sym_BSLASHciteS] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6258),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteyear] = ACTIONS(6258),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitedate] = ACTIONS(6258),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteurl] = ACTIONS(6258),
    [anon_sym_BSLASHfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6258),
    [anon_sym_BSLASHcitealt] = ACTIONS(6258),
    [anon_sym_BSLASHcitealp] = ACTIONS(6258),
    [anon_sym_BSLASHcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHparencite] = ACTIONS(6258),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHParencite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHtextcite] = ACTIONS(6258),
    [anon_sym_BSLASHTextcite] = ACTIONS(6258),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHsupercite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite] = ACTIONS(6258),
    [anon_sym_BSLASHAutocite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHVolcite] = ACTIONS(6258),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHavolcite] = ACTIONS(6258),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHNotecite] = ACTIONS(6258),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHlabel] = ACTIONS(6258),
    [anon_sym_BSLASHref] = ACTIONS(6258),
    [anon_sym_BSLASHeqref] = ACTIONS(6258),
    [anon_sym_BSLASHvref] = ACTIONS(6258),
    [anon_sym_BSLASHVref] = ACTIONS(6258),
    [anon_sym_BSLASHautoref] = ACTIONS(6258),
    [anon_sym_BSLASHpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcref] = ACTIONS(6258),
    [anon_sym_BSLASHCref] = ACTIONS(6258),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnameCref] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHdef] = ACTIONS(6258),
    [anon_sym_BSLASHlet] = ACTIONS(6258),
    [anon_sym_BSLASHleft] = ACTIONS(6258),
    [anon_sym_BSLASHbigl] = ACTIONS(6258),
    [anon_sym_BSLASHBigl] = ACTIONS(6258),
    [anon_sym_BSLASHbiggl] = ACTIONS(6258),
    [anon_sym_BSLASHBiggl] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6258),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6258),
    [anon_sym_BSLASHgls] = ACTIONS(6258),
    [anon_sym_BSLASHGls] = ACTIONS(6258),
    [anon_sym_BSLASHGLS] = ACTIONS(6258),
    [anon_sym_BSLASHglspl] = ACTIONS(6258),
    [anon_sym_BSLASHGlspl] = ACTIONS(6258),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6258),
    [anon_sym_BSLASHglslink] = ACTIONS(6258),
    [anon_sym_BSLASHglstext] = ACTIONS(6258),
    [anon_sym_BSLASHGlstext] = ACTIONS(6258),
    [anon_sym_BSLASHGLStext] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6258),
    [anon_sym_BSLASHglsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsname] = ACTIONS(6258),
    [anon_sym_BSLASHGlsname] = ACTIONS(6258),
    [anon_sym_BSLASHGLSname] = ACTIONS(6258),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6258),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6258),
    [anon_sym_BSLASHacrshort] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6258),
    [anon_sym_BSLASHACRshort] = ACTIONS(6258),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrlong] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6258),
    [anon_sym_BSLASHACRlong] = ACTIONS(6258),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrfull] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6258),
    [anon_sym_BSLASHACRfull] = ACTIONS(6258),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHacs] = ACTIONS(6258),
    [anon_sym_BSLASHAcs] = ACTIONS(6258),
    [anon_sym_BSLASHacsp] = ACTIONS(6258),
    [anon_sym_BSLASHAcsp] = ACTIONS(6258),
    [anon_sym_BSLASHacl] = ACTIONS(6258),
    [anon_sym_BSLASHAcl] = ACTIONS(6258),
    [anon_sym_BSLASHaclp] = ACTIONS(6258),
    [anon_sym_BSLASHAclp] = ACTIONS(6258),
    [anon_sym_BSLASHacf] = ACTIONS(6258),
    [anon_sym_BSLASHAcf] = ACTIONS(6258),
    [anon_sym_BSLASHacfp] = ACTIONS(6258),
    [anon_sym_BSLASHAcfp] = ACTIONS(6258),
    [anon_sym_BSLASHac] = ACTIONS(6258),
    [anon_sym_BSLASHAc] = ACTIONS(6258),
    [anon_sym_BSLASHacp] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6258),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6258),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6258),
    [anon_sym_BSLASHcolor] = ACTIONS(6258),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6258),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6258),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6258),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6258),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6258),
    [anon_sym_BSLASHtext] = ACTIONS(6258),
    [anon_sym_BSLASHintertext] = ACTIONS(6258),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6258),
    [anon_sym_BSLASHurl] = ACTIONS(6258),
    [anon_sym_BSLASHhref] = ACTIONS(6258),
  },
  [922] = {
    [ts_builtin_sym_end] = ACTIONS(6256),
    [sym_command_name] = ACTIONS(6254),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6254),
    [anon_sym_LBRACK] = ACTIONS(6256),
    [anon_sym_RBRACK] = ACTIONS(6256),
    [anon_sym_COMMA] = ACTIONS(6256),
    [anon_sym_EQ] = ACTIONS(6256),
    [anon_sym_LPAREN] = ACTIONS(6256),
    [anon_sym_RPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHpart] = ACTIONS(6254),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddpart] = ACTIONS(6254),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHchapter] = ACTIONS(6254),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddchap] = ACTIONS(6254),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsection] = ACTIONS(6254),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddsec] = ACTIONS(6254),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHitem] = ACTIONS(6254),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6256),
    [anon_sym_LBRACE] = ACTIONS(6256),
    [anon_sym_RBRACE] = ACTIONS(6256),
    [sym_word] = ACTIONS(6254),
    [sym_placeholder] = ACTIONS(6256),
    [anon_sym_PLUS] = ACTIONS(6256),
    [anon_sym_DASH] = ACTIONS(6256),
    [anon_sym_STAR] = ACTIONS(6256),
    [anon_sym_SLASH] = ACTIONS(6256),
    [anon_sym_LT] = ACTIONS(6254),
    [anon_sym_GT] = ACTIONS(6254),
    [anon_sym_BANG] = ACTIONS(6254),
    [anon_sym_PIPE] = ACTIONS(6254),
    [anon_sym_COLON] = ACTIONS(6254),
    [anon_sym_SQUOTE] = ACTIONS(6254),
    [anon_sym__] = ACTIONS(6256),
    [anon_sym_CARET] = ACTIONS(6256),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6256),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6256),
    [anon_sym_DOLLAR] = ACTIONS(6254),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHbegin] = ACTIONS(6254),
    [anon_sym_BSLASHtitle] = ACTIONS(6254),
    [anon_sym_BSLASHauthor] = ACTIONS(6254),
    [anon_sym_BSLASHusepackage] = ACTIONS(6254),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6254),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6254),
    [anon_sym_BSLASHinclude] = ACTIONS(6254),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6254),
    [anon_sym_BSLASHinput] = ACTIONS(6254),
    [anon_sym_BSLASHsubfile] = ACTIONS(6254),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6254),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6254),
    [anon_sym_BSLASHbibliography] = ACTIONS(6254),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6254),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6254),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6254),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6254),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6254),
    [anon_sym_BSLASHimport] = ACTIONS(6254),
    [anon_sym_BSLASHsubimport] = ACTIONS(6254),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6254),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHcaption] = ACTIONS(6254),
    [anon_sym_BSLASHcite] = ACTIONS(6254),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCite] = ACTIONS(6254),
    [anon_sym_BSLASHnocite] = ACTIONS(6254),
    [anon_sym_BSLASHcitet] = ACTIONS(6254),
    [anon_sym_BSLASHcitep] = ACTIONS(6254),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteA] = ACTIONS(6254),
    [anon_sym_BSLASHciteR] = ACTIONS(6254),
    [anon_sym_BSLASHciteS] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6254),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteyear] = ACTIONS(6254),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitedate] = ACTIONS(6254),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteurl] = ACTIONS(6254),
    [anon_sym_BSLASHfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6254),
    [anon_sym_BSLASHcitealt] = ACTIONS(6254),
    [anon_sym_BSLASHcitealp] = ACTIONS(6254),
    [anon_sym_BSLASHcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHparencite] = ACTIONS(6254),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHParencite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHtextcite] = ACTIONS(6254),
    [anon_sym_BSLASHTextcite] = ACTIONS(6254),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHsupercite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite] = ACTIONS(6254),
    [anon_sym_BSLASHAutocite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHVolcite] = ACTIONS(6254),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHavolcite] = ACTIONS(6254),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHNotecite] = ACTIONS(6254),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHlabel] = ACTIONS(6254),
    [anon_sym_BSLASHref] = ACTIONS(6254),
    [anon_sym_BSLASHeqref] = ACTIONS(6254),
    [anon_sym_BSLASHvref] = ACTIONS(6254),
    [anon_sym_BSLASHVref] = ACTIONS(6254),
    [anon_sym_BSLASHautoref] = ACTIONS(6254),
    [anon_sym_BSLASHpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcref] = ACTIONS(6254),
    [anon_sym_BSLASHCref] = ACTIONS(6254),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnameCref] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHdef] = ACTIONS(6254),
    [anon_sym_BSLASHlet] = ACTIONS(6254),
    [anon_sym_BSLASHleft] = ACTIONS(6254),
    [anon_sym_BSLASHbigl] = ACTIONS(6254),
    [anon_sym_BSLASHBigl] = ACTIONS(6254),
    [anon_sym_BSLASHbiggl] = ACTIONS(6254),
    [anon_sym_BSLASHBiggl] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6254),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6254),
    [anon_sym_BSLASHgls] = ACTIONS(6254),
    [anon_sym_BSLASHGls] = ACTIONS(6254),
    [anon_sym_BSLASHGLS] = ACTIONS(6254),
    [anon_sym_BSLASHglspl] = ACTIONS(6254),
    [anon_sym_BSLASHGlspl] = ACTIONS(6254),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6254),
    [anon_sym_BSLASHglslink] = ACTIONS(6254),
    [anon_sym_BSLASHglstext] = ACTIONS(6254),
    [anon_sym_BSLASHGlstext] = ACTIONS(6254),
    [anon_sym_BSLASHGLStext] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6254),
    [anon_sym_BSLASHglsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsname] = ACTIONS(6254),
    [anon_sym_BSLASHGlsname] = ACTIONS(6254),
    [anon_sym_BSLASHGLSname] = ACTIONS(6254),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6254),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6254),
    [anon_sym_BSLASHacrshort] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6254),
    [anon_sym_BSLASHACRshort] = ACTIONS(6254),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrlong] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6254),
    [anon_sym_BSLASHACRlong] = ACTIONS(6254),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrfull] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6254),
    [anon_sym_BSLASHACRfull] = ACTIONS(6254),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHacs] = ACTIONS(6254),
    [anon_sym_BSLASHAcs] = ACTIONS(6254),
    [anon_sym_BSLASHacsp] = ACTIONS(6254),
    [anon_sym_BSLASHAcsp] = ACTIONS(6254),
    [anon_sym_BSLASHacl] = ACTIONS(6254),
    [anon_sym_BSLASHAcl] = ACTIONS(6254),
    [anon_sym_BSLASHaclp] = ACTIONS(6254),
    [anon_sym_BSLASHAclp] = ACTIONS(6254),
    [anon_sym_BSLASHacf] = ACTIONS(6254),
    [anon_sym_BSLASHAcf] = ACTIONS(6254),
    [anon_sym_BSLASHacfp] = ACTIONS(6254),
    [anon_sym_BSLASHAcfp] = ACTIONS(6254),
    [anon_sym_BSLASHac] = ACTIONS(6254),
    [anon_sym_BSLASHAc] = ACTIONS(6254),
    [anon_sym_BSLASHacp] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6254),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6254),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6254),
    [anon_sym_BSLASHcolor] = ACTIONS(6254),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6254),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6254),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6254),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6254),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6254),
    [anon_sym_BSLASHtext] = ACTIONS(6254),
    [anon_sym_BSLASHintertext] = ACTIONS(6254),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6254),
    [anon_sym_BSLASHurl] = ACTIONS(6254),
    [anon_sym_BSLASHhref] = ACTIONS(6254),
  },
  [923] = {
    [ts_builtin_sym_end] = ACTIONS(6212),
    [sym_command_name] = ACTIONS(6210),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_EQ] = ACTIONS(6212),
    [anon_sym_LPAREN] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHpart] = ACTIONS(6210),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddpart] = ACTIONS(6210),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHchapter] = ACTIONS(6210),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddchap] = ACTIONS(6210),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsection] = ACTIONS(6210),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddsec] = ACTIONS(6210),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHitem] = ACTIONS(6210),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [anon_sym_RBRACE] = ACTIONS(6212),
    [sym_word] = ACTIONS(6210),
    [sym_placeholder] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_DASH] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_LT] = ACTIONS(6210),
    [anon_sym_GT] = ACTIONS(6210),
    [anon_sym_BANG] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_COLON] = ACTIONS(6210),
    [anon_sym_SQUOTE] = ACTIONS(6210),
    [anon_sym__] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6212),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6212),
    [anon_sym_DOLLAR] = ACTIONS(6210),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHbegin] = ACTIONS(6210),
    [anon_sym_BSLASHtitle] = ACTIONS(6210),
    [anon_sym_BSLASHauthor] = ACTIONS(6210),
    [anon_sym_BSLASHusepackage] = ACTIONS(6210),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6210),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6210),
    [anon_sym_BSLASHinclude] = ACTIONS(6210),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6210),
    [anon_sym_BSLASHinput] = ACTIONS(6210),
    [anon_sym_BSLASHsubfile] = ACTIONS(6210),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6210),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6210),
    [anon_sym_BSLASHbibliography] = ACTIONS(6210),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6210),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6210),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6210),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6210),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6210),
    [anon_sym_BSLASHimport] = ACTIONS(6210),
    [anon_sym_BSLASHsubimport] = ACTIONS(6210),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6210),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHcaption] = ACTIONS(6210),
    [anon_sym_BSLASHcite] = ACTIONS(6210),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCite] = ACTIONS(6210),
    [anon_sym_BSLASHnocite] = ACTIONS(6210),
    [anon_sym_BSLASHcitet] = ACTIONS(6210),
    [anon_sym_BSLASHcitep] = ACTIONS(6210),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteA] = ACTIONS(6210),
    [anon_sym_BSLASHciteR] = ACTIONS(6210),
    [anon_sym_BSLASHciteS] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6210),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteyear] = ACTIONS(6210),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitedate] = ACTIONS(6210),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteurl] = ACTIONS(6210),
    [anon_sym_BSLASHfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6210),
    [anon_sym_BSLASHcitealt] = ACTIONS(6210),
    [anon_sym_BSLASHcitealp] = ACTIONS(6210),
    [anon_sym_BSLASHcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHparencite] = ACTIONS(6210),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHParencite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHtextcite] = ACTIONS(6210),
    [anon_sym_BSLASHTextcite] = ACTIONS(6210),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHsupercite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite] = ACTIONS(6210),
    [anon_sym_BSLASHAutocite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHVolcite] = ACTIONS(6210),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHavolcite] = ACTIONS(6210),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHNotecite] = ACTIONS(6210),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHlabel] = ACTIONS(6210),
    [anon_sym_BSLASHref] = ACTIONS(6210),
    [anon_sym_BSLASHeqref] = ACTIONS(6210),
    [anon_sym_BSLASHvref] = ACTIONS(6210),
    [anon_sym_BSLASHVref] = ACTIONS(6210),
    [anon_sym_BSLASHautoref] = ACTIONS(6210),
    [anon_sym_BSLASHpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcref] = ACTIONS(6210),
    [anon_sym_BSLASHCref] = ACTIONS(6210),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnameCref] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHdef] = ACTIONS(6210),
    [anon_sym_BSLASHlet] = ACTIONS(6210),
    [anon_sym_BSLASHleft] = ACTIONS(6210),
    [anon_sym_BSLASHbigl] = ACTIONS(6210),
    [anon_sym_BSLASHBigl] = ACTIONS(6210),
    [anon_sym_BSLASHbiggl] = ACTIONS(6210),
    [anon_sym_BSLASHBiggl] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6210),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6210),
    [anon_sym_BSLASHgls] = ACTIONS(6210),
    [anon_sym_BSLASHGls] = ACTIONS(6210),
    [anon_sym_BSLASHGLS] = ACTIONS(6210),
    [anon_sym_BSLASHglspl] = ACTIONS(6210),
    [anon_sym_BSLASHGlspl] = ACTIONS(6210),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6210),
    [anon_sym_BSLASHglslink] = ACTIONS(6210),
    [anon_sym_BSLASHglstext] = ACTIONS(6210),
    [anon_sym_BSLASHGlstext] = ACTIONS(6210),
    [anon_sym_BSLASHGLStext] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6210),
    [anon_sym_BSLASHglsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsname] = ACTIONS(6210),
    [anon_sym_BSLASHGlsname] = ACTIONS(6210),
    [anon_sym_BSLASHGLSname] = ACTIONS(6210),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6210),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6210),
    [anon_sym_BSLASHacrshort] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6210),
    [anon_sym_BSLASHACRshort] = ACTIONS(6210),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrlong] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6210),
    [anon_sym_BSLASHACRlong] = ACTIONS(6210),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrfull] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6210),
    [anon_sym_BSLASHACRfull] = ACTIONS(6210),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHacs] = ACTIONS(6210),
    [anon_sym_BSLASHAcs] = ACTIONS(6210),
    [anon_sym_BSLASHacsp] = ACTIONS(6210),
    [anon_sym_BSLASHAcsp] = ACTIONS(6210),
    [anon_sym_BSLASHacl] = ACTIONS(6210),
    [anon_sym_BSLASHAcl] = ACTIONS(6210),
    [anon_sym_BSLASHaclp] = ACTIONS(6210),
    [anon_sym_BSLASHAclp] = ACTIONS(6210),
    [anon_sym_BSLASHacf] = ACTIONS(6210),
    [anon_sym_BSLASHAcf] = ACTIONS(6210),
    [anon_sym_BSLASHacfp] = ACTIONS(6210),
    [anon_sym_BSLASHAcfp] = ACTIONS(6210),
    [anon_sym_BSLASHac] = ACTIONS(6210),
    [anon_sym_BSLASHAc] = ACTIONS(6210),
    [anon_sym_BSLASHacp] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6210),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6210),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6210),
    [anon_sym_BSLASHcolor] = ACTIONS(6210),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6210),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6210),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6210),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6210),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6210),
    [anon_sym_BSLASHtext] = ACTIONS(6210),
    [anon_sym_BSLASHintertext] = ACTIONS(6210),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6210),
    [anon_sym_BSLASHurl] = ACTIONS(6210),
    [anon_sym_BSLASHhref] = ACTIONS(6210),
  },
  [924] = {
    [ts_builtin_sym_end] = ACTIONS(6208),
    [sym_command_name] = ACTIONS(6206),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [anon_sym_RBRACK] = ACTIONS(6208),
    [anon_sym_COMMA] = ACTIONS(6208),
    [anon_sym_EQ] = ACTIONS(6208),
    [anon_sym_LPAREN] = ACTIONS(6208),
    [anon_sym_RPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHpart] = ACTIONS(6206),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddpart] = ACTIONS(6206),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHchapter] = ACTIONS(6206),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddchap] = ACTIONS(6206),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsection] = ACTIONS(6206),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddsec] = ACTIONS(6206),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHitem] = ACTIONS(6206),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6208),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [anon_sym_RBRACE] = ACTIONS(6208),
    [sym_word] = ACTIONS(6206),
    [sym_placeholder] = ACTIONS(6208),
    [anon_sym_PLUS] = ACTIONS(6208),
    [anon_sym_DASH] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_SLASH] = ACTIONS(6208),
    [anon_sym_LT] = ACTIONS(6206),
    [anon_sym_GT] = ACTIONS(6206),
    [anon_sym_BANG] = ACTIONS(6206),
    [anon_sym_PIPE] = ACTIONS(6206),
    [anon_sym_COLON] = ACTIONS(6206),
    [anon_sym_SQUOTE] = ACTIONS(6206),
    [anon_sym__] = ACTIONS(6208),
    [anon_sym_CARET] = ACTIONS(6208),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6208),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6208),
    [anon_sym_DOLLAR] = ACTIONS(6206),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHbegin] = ACTIONS(6206),
    [anon_sym_BSLASHtitle] = ACTIONS(6206),
    [anon_sym_BSLASHauthor] = ACTIONS(6206),
    [anon_sym_BSLASHusepackage] = ACTIONS(6206),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6206),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6206),
    [anon_sym_BSLASHinclude] = ACTIONS(6206),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6206),
    [anon_sym_BSLASHinput] = ACTIONS(6206),
    [anon_sym_BSLASHsubfile] = ACTIONS(6206),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6206),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6206),
    [anon_sym_BSLASHbibliography] = ACTIONS(6206),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6206),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6206),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6206),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6206),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6206),
    [anon_sym_BSLASHimport] = ACTIONS(6206),
    [anon_sym_BSLASHsubimport] = ACTIONS(6206),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6206),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHcaption] = ACTIONS(6206),
    [anon_sym_BSLASHcite] = ACTIONS(6206),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCite] = ACTIONS(6206),
    [anon_sym_BSLASHnocite] = ACTIONS(6206),
    [anon_sym_BSLASHcitet] = ACTIONS(6206),
    [anon_sym_BSLASHcitep] = ACTIONS(6206),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteA] = ACTIONS(6206),
    [anon_sym_BSLASHciteR] = ACTIONS(6206),
    [anon_sym_BSLASHciteS] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6206),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteyear] = ACTIONS(6206),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitedate] = ACTIONS(6206),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteurl] = ACTIONS(6206),
    [anon_sym_BSLASHfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6206),
    [anon_sym_BSLASHcitealt] = ACTIONS(6206),
    [anon_sym_BSLASHcitealp] = ACTIONS(6206),
    [anon_sym_BSLASHcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHparencite] = ACTIONS(6206),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHParencite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHtextcite] = ACTIONS(6206),
    [anon_sym_BSLASHTextcite] = ACTIONS(6206),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHsupercite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite] = ACTIONS(6206),
    [anon_sym_BSLASHAutocite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHVolcite] = ACTIONS(6206),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHavolcite] = ACTIONS(6206),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHNotecite] = ACTIONS(6206),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHlabel] = ACTIONS(6206),
    [anon_sym_BSLASHref] = ACTIONS(6206),
    [anon_sym_BSLASHeqref] = ACTIONS(6206),
    [anon_sym_BSLASHvref] = ACTIONS(6206),
    [anon_sym_BSLASHVref] = ACTIONS(6206),
    [anon_sym_BSLASHautoref] = ACTIONS(6206),
    [anon_sym_BSLASHpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcref] = ACTIONS(6206),
    [anon_sym_BSLASHCref] = ACTIONS(6206),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnameCref] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHdef] = ACTIONS(6206),
    [anon_sym_BSLASHlet] = ACTIONS(6206),
    [anon_sym_BSLASHleft] = ACTIONS(6206),
    [anon_sym_BSLASHbigl] = ACTIONS(6206),
    [anon_sym_BSLASHBigl] = ACTIONS(6206),
    [anon_sym_BSLASHbiggl] = ACTIONS(6206),
    [anon_sym_BSLASHBiggl] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6206),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6206),
    [anon_sym_BSLASHgls] = ACTIONS(6206),
    [anon_sym_BSLASHGls] = ACTIONS(6206),
    [anon_sym_BSLASHGLS] = ACTIONS(6206),
    [anon_sym_BSLASHglspl] = ACTIONS(6206),
    [anon_sym_BSLASHGlspl] = ACTIONS(6206),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6206),
    [anon_sym_BSLASHglslink] = ACTIONS(6206),
    [anon_sym_BSLASHglstext] = ACTIONS(6206),
    [anon_sym_BSLASHGlstext] = ACTIONS(6206),
    [anon_sym_BSLASHGLStext] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6206),
    [anon_sym_BSLASHglsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsname] = ACTIONS(6206),
    [anon_sym_BSLASHGlsname] = ACTIONS(6206),
    [anon_sym_BSLASHGLSname] = ACTIONS(6206),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6206),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6206),
    [anon_sym_BSLASHacrshort] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6206),
    [anon_sym_BSLASHACRshort] = ACTIONS(6206),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrlong] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6206),
    [anon_sym_BSLASHACRlong] = ACTIONS(6206),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrfull] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6206),
    [anon_sym_BSLASHACRfull] = ACTIONS(6206),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHacs] = ACTIONS(6206),
    [anon_sym_BSLASHAcs] = ACTIONS(6206),
    [anon_sym_BSLASHacsp] = ACTIONS(6206),
    [anon_sym_BSLASHAcsp] = ACTIONS(6206),
    [anon_sym_BSLASHacl] = ACTIONS(6206),
    [anon_sym_BSLASHAcl] = ACTIONS(6206),
    [anon_sym_BSLASHaclp] = ACTIONS(6206),
    [anon_sym_BSLASHAclp] = ACTIONS(6206),
    [anon_sym_BSLASHacf] = ACTIONS(6206),
    [anon_sym_BSLASHAcf] = ACTIONS(6206),
    [anon_sym_BSLASHacfp] = ACTIONS(6206),
    [anon_sym_BSLASHAcfp] = ACTIONS(6206),
    [anon_sym_BSLASHac] = ACTIONS(6206),
    [anon_sym_BSLASHAc] = ACTIONS(6206),
    [anon_sym_BSLASHacp] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6206),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6206),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6206),
    [anon_sym_BSLASHcolor] = ACTIONS(6206),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6206),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6206),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6206),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6206),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6206),
    [anon_sym_BSLASHtext] = ACTIONS(6206),
    [anon_sym_BSLASHintertext] = ACTIONS(6206),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6206),
    [anon_sym_BSLASHurl] = ACTIONS(6206),
    [anon_sym_BSLASHhref] = ACTIONS(6206),
  },
  [925] = {
    [ts_builtin_sym_end] = ACTIONS(6280),
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6280),
    [anon_sym_RBRACK] = ACTIONS(6280),
    [anon_sym_COMMA] = ACTIONS(6280),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_RPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHpart] = ACTIONS(6278),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddpart] = ACTIONS(6278),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHchapter] = ACTIONS(6278),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddchap] = ACTIONS(6278),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsection] = ACTIONS(6278),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddsec] = ACTIONS(6278),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHitem] = ACTIONS(6278),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [anon_sym_RBRACE] = ACTIONS(6280),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6280),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6280),
    [anon_sym_DOLLAR] = ACTIONS(6278),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHbegin] = ACTIONS(6278),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHleft] = ACTIONS(6278),
    [anon_sym_BSLASHbigl] = ACTIONS(6278),
    [anon_sym_BSLASHBigl] = ACTIONS(6278),
    [anon_sym_BSLASHbiggl] = ACTIONS(6278),
    [anon_sym_BSLASHBiggl] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHtext] = ACTIONS(6278),
    [anon_sym_BSLASHintertext] = ACTIONS(6278),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [926] = {
    [ts_builtin_sym_end] = ACTIONS(6348),
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [anon_sym_RPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHpart] = ACTIONS(6346),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddpart] = ACTIONS(6346),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHchapter] = ACTIONS(6346),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddchap] = ACTIONS(6346),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsection] = ACTIONS(6346),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddsec] = ACTIONS(6346),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHitem] = ACTIONS(6346),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6348),
    [anon_sym_RBRACE] = ACTIONS(6348),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6348),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6348),
    [anon_sym_DOLLAR] = ACTIONS(6346),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHbegin] = ACTIONS(6346),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHleft] = ACTIONS(6346),
    [anon_sym_BSLASHbigl] = ACTIONS(6346),
    [anon_sym_BSLASHBigl] = ACTIONS(6346),
    [anon_sym_BSLASHbiggl] = ACTIONS(6346),
    [anon_sym_BSLASHBiggl] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHtext] = ACTIONS(6346),
    [anon_sym_BSLASHintertext] = ACTIONS(6346),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [927] = {
    [ts_builtin_sym_end] = ACTIONS(6296),
    [sym_command_name] = ACTIONS(6294),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6294),
    [anon_sym_LBRACK] = ACTIONS(6296),
    [anon_sym_RBRACK] = ACTIONS(6296),
    [anon_sym_COMMA] = ACTIONS(6296),
    [anon_sym_EQ] = ACTIONS(6296),
    [anon_sym_LPAREN] = ACTIONS(6296),
    [anon_sym_RPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHpart] = ACTIONS(6294),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddpart] = ACTIONS(6294),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHchapter] = ACTIONS(6294),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddchap] = ACTIONS(6294),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsection] = ACTIONS(6294),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddsec] = ACTIONS(6294),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHitem] = ACTIONS(6294),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6296),
    [anon_sym_LBRACE] = ACTIONS(6296),
    [anon_sym_RBRACE] = ACTIONS(6296),
    [sym_word] = ACTIONS(6294),
    [sym_placeholder] = ACTIONS(6296),
    [anon_sym_PLUS] = ACTIONS(6296),
    [anon_sym_DASH] = ACTIONS(6296),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_SLASH] = ACTIONS(6296),
    [anon_sym_LT] = ACTIONS(6294),
    [anon_sym_GT] = ACTIONS(6294),
    [anon_sym_BANG] = ACTIONS(6294),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COLON] = ACTIONS(6294),
    [anon_sym_SQUOTE] = ACTIONS(6294),
    [anon_sym__] = ACTIONS(6296),
    [anon_sym_CARET] = ACTIONS(6296),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6296),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6296),
    [anon_sym_DOLLAR] = ACTIONS(6294),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHbegin] = ACTIONS(6294),
    [anon_sym_BSLASHtitle] = ACTIONS(6294),
    [anon_sym_BSLASHauthor] = ACTIONS(6294),
    [anon_sym_BSLASHusepackage] = ACTIONS(6294),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6294),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6294),
    [anon_sym_BSLASHinclude] = ACTIONS(6294),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6294),
    [anon_sym_BSLASHinput] = ACTIONS(6294),
    [anon_sym_BSLASHsubfile] = ACTIONS(6294),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6294),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6294),
    [anon_sym_BSLASHbibliography] = ACTIONS(6294),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6294),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6294),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6294),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6294),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6294),
    [anon_sym_BSLASHimport] = ACTIONS(6294),
    [anon_sym_BSLASHsubimport] = ACTIONS(6294),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6294),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHcaption] = ACTIONS(6294),
    [anon_sym_BSLASHcite] = ACTIONS(6294),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCite] = ACTIONS(6294),
    [anon_sym_BSLASHnocite] = ACTIONS(6294),
    [anon_sym_BSLASHcitet] = ACTIONS(6294),
    [anon_sym_BSLASHcitep] = ACTIONS(6294),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteA] = ACTIONS(6294),
    [anon_sym_BSLASHciteR] = ACTIONS(6294),
    [anon_sym_BSLASHciteS] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6294),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteyear] = ACTIONS(6294),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitedate] = ACTIONS(6294),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteurl] = ACTIONS(6294),
    [anon_sym_BSLASHfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6294),
    [anon_sym_BSLASHcitealt] = ACTIONS(6294),
    [anon_sym_BSLASHcitealp] = ACTIONS(6294),
    [anon_sym_BSLASHcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHparencite] = ACTIONS(6294),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHParencite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHtextcite] = ACTIONS(6294),
    [anon_sym_BSLASHTextcite] = ACTIONS(6294),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHsupercite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite] = ACTIONS(6294),
    [anon_sym_BSLASHAutocite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHVolcite] = ACTIONS(6294),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHavolcite] = ACTIONS(6294),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHNotecite] = ACTIONS(6294),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHlabel] = ACTIONS(6294),
    [anon_sym_BSLASHref] = ACTIONS(6294),
    [anon_sym_BSLASHeqref] = ACTIONS(6294),
    [anon_sym_BSLASHvref] = ACTIONS(6294),
    [anon_sym_BSLASHVref] = ACTIONS(6294),
    [anon_sym_BSLASHautoref] = ACTIONS(6294),
    [anon_sym_BSLASHpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcref] = ACTIONS(6294),
    [anon_sym_BSLASHCref] = ACTIONS(6294),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnameCref] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHdef] = ACTIONS(6294),
    [anon_sym_BSLASHlet] = ACTIONS(6294),
    [anon_sym_BSLASHleft] = ACTIONS(6294),
    [anon_sym_BSLASHbigl] = ACTIONS(6294),
    [anon_sym_BSLASHBigl] = ACTIONS(6294),
    [anon_sym_BSLASHbiggl] = ACTIONS(6294),
    [anon_sym_BSLASHBiggl] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6294),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6294),
    [anon_sym_BSLASHgls] = ACTIONS(6294),
    [anon_sym_BSLASHGls] = ACTIONS(6294),
    [anon_sym_BSLASHGLS] = ACTIONS(6294),
    [anon_sym_BSLASHglspl] = ACTIONS(6294),
    [anon_sym_BSLASHGlspl] = ACTIONS(6294),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6294),
    [anon_sym_BSLASHglslink] = ACTIONS(6294),
    [anon_sym_BSLASHglstext] = ACTIONS(6294),
    [anon_sym_BSLASHGlstext] = ACTIONS(6294),
    [anon_sym_BSLASHGLStext] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6294),
    [anon_sym_BSLASHglsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsname] = ACTIONS(6294),
    [anon_sym_BSLASHGlsname] = ACTIONS(6294),
    [anon_sym_BSLASHGLSname] = ACTIONS(6294),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6294),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6294),
    [anon_sym_BSLASHacrshort] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6294),
    [anon_sym_BSLASHACRshort] = ACTIONS(6294),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrlong] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6294),
    [anon_sym_BSLASHACRlong] = ACTIONS(6294),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrfull] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6294),
    [anon_sym_BSLASHACRfull] = ACTIONS(6294),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHacs] = ACTIONS(6294),
    [anon_sym_BSLASHAcs] = ACTIONS(6294),
    [anon_sym_BSLASHacsp] = ACTIONS(6294),
    [anon_sym_BSLASHAcsp] = ACTIONS(6294),
    [anon_sym_BSLASHacl] = ACTIONS(6294),
    [anon_sym_BSLASHAcl] = ACTIONS(6294),
    [anon_sym_BSLASHaclp] = ACTIONS(6294),
    [anon_sym_BSLASHAclp] = ACTIONS(6294),
    [anon_sym_BSLASHacf] = ACTIONS(6294),
    [anon_sym_BSLASHAcf] = ACTIONS(6294),
    [anon_sym_BSLASHacfp] = ACTIONS(6294),
    [anon_sym_BSLASHAcfp] = ACTIONS(6294),
    [anon_sym_BSLASHac] = ACTIONS(6294),
    [anon_sym_BSLASHAc] = ACTIONS(6294),
    [anon_sym_BSLASHacp] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6294),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6294),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6294),
    [anon_sym_BSLASHcolor] = ACTIONS(6294),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6294),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6294),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6294),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6294),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6294),
    [anon_sym_BSLASHtext] = ACTIONS(6294),
    [anon_sym_BSLASHintertext] = ACTIONS(6294),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6294),
    [anon_sym_BSLASHurl] = ACTIONS(6294),
    [anon_sym_BSLASHhref] = ACTIONS(6294),
  },
  [928] = {
    [ts_builtin_sym_end] = ACTIONS(6364),
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LPAREN] = ACTIONS(6364),
    [anon_sym_RPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHpart] = ACTIONS(6362),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddpart] = ACTIONS(6362),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHchapter] = ACTIONS(6362),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddchap] = ACTIONS(6362),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsection] = ACTIONS(6362),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddsec] = ACTIONS(6362),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHitem] = ACTIONS(6362),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [anon_sym_RBRACE] = ACTIONS(6364),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6364),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6364),
    [anon_sym_DOLLAR] = ACTIONS(6362),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHbegin] = ACTIONS(6362),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHleft] = ACTIONS(6362),
    [anon_sym_BSLASHbigl] = ACTIONS(6362),
    [anon_sym_BSLASHBigl] = ACTIONS(6362),
    [anon_sym_BSLASHbiggl] = ACTIONS(6362),
    [anon_sym_BSLASHBiggl] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHtext] = ACTIONS(6362),
    [anon_sym_BSLASHintertext] = ACTIONS(6362),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [929] = {
    [ts_builtin_sym_end] = ACTIONS(6648),
    [sym_command_name] = ACTIONS(6646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6646),
    [anon_sym_LBRACK] = ACTIONS(6648),
    [anon_sym_RBRACK] = ACTIONS(6648),
    [anon_sym_COMMA] = ACTIONS(6648),
    [anon_sym_EQ] = ACTIONS(6648),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [anon_sym_RPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHpart] = ACTIONS(6646),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddpart] = ACTIONS(6646),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHchapter] = ACTIONS(6646),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddchap] = ACTIONS(6646),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsection] = ACTIONS(6646),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddsec] = ACTIONS(6646),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHitem] = ACTIONS(6646),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6648),
    [anon_sym_LBRACE] = ACTIONS(6648),
    [anon_sym_RBRACE] = ACTIONS(6648),
    [sym_word] = ACTIONS(6646),
    [sym_placeholder] = ACTIONS(6648),
    [anon_sym_PLUS] = ACTIONS(6648),
    [anon_sym_DASH] = ACTIONS(6648),
    [anon_sym_STAR] = ACTIONS(6648),
    [anon_sym_SLASH] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6646),
    [anon_sym_GT] = ACTIONS(6646),
    [anon_sym_BANG] = ACTIONS(6646),
    [anon_sym_PIPE] = ACTIONS(6646),
    [anon_sym_COLON] = ACTIONS(6646),
    [anon_sym_SQUOTE] = ACTIONS(6646),
    [anon_sym__] = ACTIONS(6648),
    [anon_sym_CARET] = ACTIONS(6648),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6648),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6648),
    [anon_sym_DOLLAR] = ACTIONS(6646),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHbegin] = ACTIONS(6646),
    [anon_sym_BSLASHtitle] = ACTIONS(6646),
    [anon_sym_BSLASHauthor] = ACTIONS(6646),
    [anon_sym_BSLASHusepackage] = ACTIONS(6646),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6646),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6646),
    [anon_sym_BSLASHinclude] = ACTIONS(6646),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6646),
    [anon_sym_BSLASHinput] = ACTIONS(6646),
    [anon_sym_BSLASHsubfile] = ACTIONS(6646),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6646),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6646),
    [anon_sym_BSLASHbibliography] = ACTIONS(6646),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6646),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6646),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6646),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6646),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6646),
    [anon_sym_BSLASHimport] = ACTIONS(6646),
    [anon_sym_BSLASHsubimport] = ACTIONS(6646),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6646),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHcaption] = ACTIONS(6646),
    [anon_sym_BSLASHcite] = ACTIONS(6646),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCite] = ACTIONS(6646),
    [anon_sym_BSLASHnocite] = ACTIONS(6646),
    [anon_sym_BSLASHcitet] = ACTIONS(6646),
    [anon_sym_BSLASHcitep] = ACTIONS(6646),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteA] = ACTIONS(6646),
    [anon_sym_BSLASHciteR] = ACTIONS(6646),
    [anon_sym_BSLASHciteS] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6646),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteyear] = ACTIONS(6646),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitedate] = ACTIONS(6646),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteurl] = ACTIONS(6646),
    [anon_sym_BSLASHfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6646),
    [anon_sym_BSLASHcitealt] = ACTIONS(6646),
    [anon_sym_BSLASHcitealp] = ACTIONS(6646),
    [anon_sym_BSLASHcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHparencite] = ACTIONS(6646),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHParencite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHtextcite] = ACTIONS(6646),
    [anon_sym_BSLASHTextcite] = ACTIONS(6646),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHsupercite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite] = ACTIONS(6646),
    [anon_sym_BSLASHAutocite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHVolcite] = ACTIONS(6646),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHavolcite] = ACTIONS(6646),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHNotecite] = ACTIONS(6646),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHlabel] = ACTIONS(6646),
    [anon_sym_BSLASHref] = ACTIONS(6646),
    [anon_sym_BSLASHeqref] = ACTIONS(6646),
    [anon_sym_BSLASHvref] = ACTIONS(6646),
    [anon_sym_BSLASHVref] = ACTIONS(6646),
    [anon_sym_BSLASHautoref] = ACTIONS(6646),
    [anon_sym_BSLASHpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcref] = ACTIONS(6646),
    [anon_sym_BSLASHCref] = ACTIONS(6646),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnameCref] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHdef] = ACTIONS(6646),
    [anon_sym_BSLASHlet] = ACTIONS(6646),
    [anon_sym_BSLASHleft] = ACTIONS(6646),
    [anon_sym_BSLASHbigl] = ACTIONS(6646),
    [anon_sym_BSLASHBigl] = ACTIONS(6646),
    [anon_sym_BSLASHbiggl] = ACTIONS(6646),
    [anon_sym_BSLASHBiggl] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6646),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6646),
    [anon_sym_BSLASHgls] = ACTIONS(6646),
    [anon_sym_BSLASHGls] = ACTIONS(6646),
    [anon_sym_BSLASHGLS] = ACTIONS(6646),
    [anon_sym_BSLASHglspl] = ACTIONS(6646),
    [anon_sym_BSLASHGlspl] = ACTIONS(6646),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6646),
    [anon_sym_BSLASHglslink] = ACTIONS(6646),
    [anon_sym_BSLASHglstext] = ACTIONS(6646),
    [anon_sym_BSLASHGlstext] = ACTIONS(6646),
    [anon_sym_BSLASHGLStext] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6646),
    [anon_sym_BSLASHglsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsname] = ACTIONS(6646),
    [anon_sym_BSLASHGlsname] = ACTIONS(6646),
    [anon_sym_BSLASHGLSname] = ACTIONS(6646),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6646),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6646),
    [anon_sym_BSLASHacrshort] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6646),
    [anon_sym_BSLASHACRshort] = ACTIONS(6646),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrlong] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6646),
    [anon_sym_BSLASHACRlong] = ACTIONS(6646),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrfull] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6646),
    [anon_sym_BSLASHACRfull] = ACTIONS(6646),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHacs] = ACTIONS(6646),
    [anon_sym_BSLASHAcs] = ACTIONS(6646),
    [anon_sym_BSLASHacsp] = ACTIONS(6646),
    [anon_sym_BSLASHAcsp] = ACTIONS(6646),
    [anon_sym_BSLASHacl] = ACTIONS(6646),
    [anon_sym_BSLASHAcl] = ACTIONS(6646),
    [anon_sym_BSLASHaclp] = ACTIONS(6646),
    [anon_sym_BSLASHAclp] = ACTIONS(6646),
    [anon_sym_BSLASHacf] = ACTIONS(6646),
    [anon_sym_BSLASHAcf] = ACTIONS(6646),
    [anon_sym_BSLASHacfp] = ACTIONS(6646),
    [anon_sym_BSLASHAcfp] = ACTIONS(6646),
    [anon_sym_BSLASHac] = ACTIONS(6646),
    [anon_sym_BSLASHAc] = ACTIONS(6646),
    [anon_sym_BSLASHacp] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6646),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6646),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6646),
    [anon_sym_BSLASHcolor] = ACTIONS(6646),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6646),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6646),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6646),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6646),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6646),
    [anon_sym_BSLASHtext] = ACTIONS(6646),
    [anon_sym_BSLASHintertext] = ACTIONS(6646),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6646),
    [anon_sym_BSLASHurl] = ACTIONS(6646),
    [anon_sym_BSLASHhref] = ACTIONS(6646),
  },
  [930] = {
    [ts_builtin_sym_end] = ACTIONS(6328),
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6328),
    [anon_sym_RBRACK] = ACTIONS(6328),
    [anon_sym_COMMA] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6328),
    [anon_sym_RPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHpart] = ACTIONS(6326),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddpart] = ACTIONS(6326),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHchapter] = ACTIONS(6326),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddchap] = ACTIONS(6326),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsection] = ACTIONS(6326),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddsec] = ACTIONS(6326),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHitem] = ACTIONS(6326),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6328),
    [anon_sym_RBRACE] = ACTIONS(6328),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6328),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6328),
    [anon_sym_DOLLAR] = ACTIONS(6326),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHbegin] = ACTIONS(6326),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHleft] = ACTIONS(6326),
    [anon_sym_BSLASHbigl] = ACTIONS(6326),
    [anon_sym_BSLASHBigl] = ACTIONS(6326),
    [anon_sym_BSLASHbiggl] = ACTIONS(6326),
    [anon_sym_BSLASHBiggl] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHtext] = ACTIONS(6326),
    [anon_sym_BSLASHintertext] = ACTIONS(6326),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [931] = {
    [ts_builtin_sym_end] = ACTIONS(6608),
    [sym_command_name] = ACTIONS(6606),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6606),
    [anon_sym_LBRACK] = ACTIONS(6608),
    [anon_sym_RBRACK] = ACTIONS(6608),
    [anon_sym_COMMA] = ACTIONS(6608),
    [anon_sym_EQ] = ACTIONS(6608),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_RPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHpart] = ACTIONS(6606),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddpart] = ACTIONS(6606),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHchapter] = ACTIONS(6606),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddchap] = ACTIONS(6606),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsection] = ACTIONS(6606),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddsec] = ACTIONS(6606),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHitem] = ACTIONS(6606),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6608),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [anon_sym_RBRACE] = ACTIONS(6608),
    [sym_word] = ACTIONS(6606),
    [sym_placeholder] = ACTIONS(6608),
    [anon_sym_PLUS] = ACTIONS(6608),
    [anon_sym_DASH] = ACTIONS(6608),
    [anon_sym_STAR] = ACTIONS(6608),
    [anon_sym_SLASH] = ACTIONS(6608),
    [anon_sym_LT] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6606),
    [anon_sym_BANG] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6606),
    [anon_sym_COLON] = ACTIONS(6606),
    [anon_sym_SQUOTE] = ACTIONS(6606),
    [anon_sym__] = ACTIONS(6608),
    [anon_sym_CARET] = ACTIONS(6608),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6608),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(6606),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHbegin] = ACTIONS(6606),
    [anon_sym_BSLASHtitle] = ACTIONS(6606),
    [anon_sym_BSLASHauthor] = ACTIONS(6606),
    [anon_sym_BSLASHusepackage] = ACTIONS(6606),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6606),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6606),
    [anon_sym_BSLASHinclude] = ACTIONS(6606),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6606),
    [anon_sym_BSLASHinput] = ACTIONS(6606),
    [anon_sym_BSLASHsubfile] = ACTIONS(6606),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6606),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6606),
    [anon_sym_BSLASHbibliography] = ACTIONS(6606),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6606),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6606),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6606),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6606),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6606),
    [anon_sym_BSLASHimport] = ACTIONS(6606),
    [anon_sym_BSLASHsubimport] = ACTIONS(6606),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6606),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHcaption] = ACTIONS(6606),
    [anon_sym_BSLASHcite] = ACTIONS(6606),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCite] = ACTIONS(6606),
    [anon_sym_BSLASHnocite] = ACTIONS(6606),
    [anon_sym_BSLASHcitet] = ACTIONS(6606),
    [anon_sym_BSLASHcitep] = ACTIONS(6606),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteA] = ACTIONS(6606),
    [anon_sym_BSLASHciteR] = ACTIONS(6606),
    [anon_sym_BSLASHciteS] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6606),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteyear] = ACTIONS(6606),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitedate] = ACTIONS(6606),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteurl] = ACTIONS(6606),
    [anon_sym_BSLASHfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6606),
    [anon_sym_BSLASHcitealt] = ACTIONS(6606),
    [anon_sym_BSLASHcitealp] = ACTIONS(6606),
    [anon_sym_BSLASHcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHparencite] = ACTIONS(6606),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHParencite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHtextcite] = ACTIONS(6606),
    [anon_sym_BSLASHTextcite] = ACTIONS(6606),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHsupercite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite] = ACTIONS(6606),
    [anon_sym_BSLASHAutocite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHVolcite] = ACTIONS(6606),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHavolcite] = ACTIONS(6606),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHNotecite] = ACTIONS(6606),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHlabel] = ACTIONS(6606),
    [anon_sym_BSLASHref] = ACTIONS(6606),
    [anon_sym_BSLASHeqref] = ACTIONS(6606),
    [anon_sym_BSLASHvref] = ACTIONS(6606),
    [anon_sym_BSLASHVref] = ACTIONS(6606),
    [anon_sym_BSLASHautoref] = ACTIONS(6606),
    [anon_sym_BSLASHpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcref] = ACTIONS(6606),
    [anon_sym_BSLASHCref] = ACTIONS(6606),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnameCref] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHdef] = ACTIONS(6606),
    [anon_sym_BSLASHlet] = ACTIONS(6606),
    [anon_sym_BSLASHleft] = ACTIONS(6606),
    [anon_sym_BSLASHbigl] = ACTIONS(6606),
    [anon_sym_BSLASHBigl] = ACTIONS(6606),
    [anon_sym_BSLASHbiggl] = ACTIONS(6606),
    [anon_sym_BSLASHBiggl] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6606),
    [anon_sym_BSLASHgls] = ACTIONS(6606),
    [anon_sym_BSLASHGls] = ACTIONS(6606),
    [anon_sym_BSLASHGLS] = ACTIONS(6606),
    [anon_sym_BSLASHglspl] = ACTIONS(6606),
    [anon_sym_BSLASHGlspl] = ACTIONS(6606),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6606),
    [anon_sym_BSLASHglslink] = ACTIONS(6606),
    [anon_sym_BSLASHglstext] = ACTIONS(6606),
    [anon_sym_BSLASHGlstext] = ACTIONS(6606),
    [anon_sym_BSLASHGLStext] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6606),
    [anon_sym_BSLASHglsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsname] = ACTIONS(6606),
    [anon_sym_BSLASHGlsname] = ACTIONS(6606),
    [anon_sym_BSLASHGLSname] = ACTIONS(6606),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6606),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6606),
    [anon_sym_BSLASHacrshort] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6606),
    [anon_sym_BSLASHACRshort] = ACTIONS(6606),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrlong] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6606),
    [anon_sym_BSLASHACRlong] = ACTIONS(6606),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrfull] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6606),
    [anon_sym_BSLASHACRfull] = ACTIONS(6606),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHacs] = ACTIONS(6606),
    [anon_sym_BSLASHAcs] = ACTIONS(6606),
    [anon_sym_BSLASHacsp] = ACTIONS(6606),
    [anon_sym_BSLASHAcsp] = ACTIONS(6606),
    [anon_sym_BSLASHacl] = ACTIONS(6606),
    [anon_sym_BSLASHAcl] = ACTIONS(6606),
    [anon_sym_BSLASHaclp] = ACTIONS(6606),
    [anon_sym_BSLASHAclp] = ACTIONS(6606),
    [anon_sym_BSLASHacf] = ACTIONS(6606),
    [anon_sym_BSLASHAcf] = ACTIONS(6606),
    [anon_sym_BSLASHacfp] = ACTIONS(6606),
    [anon_sym_BSLASHAcfp] = ACTIONS(6606),
    [anon_sym_BSLASHac] = ACTIONS(6606),
    [anon_sym_BSLASHAc] = ACTIONS(6606),
    [anon_sym_BSLASHacp] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6606),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6606),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6606),
    [anon_sym_BSLASHcolor] = ACTIONS(6606),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6606),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6606),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6606),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6606),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6606),
    [anon_sym_BSLASHtext] = ACTIONS(6606),
    [anon_sym_BSLASHintertext] = ACTIONS(6606),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6606),
    [anon_sym_BSLASHurl] = ACTIONS(6606),
    [anon_sym_BSLASHhref] = ACTIONS(6606),
  },
  [932] = {
    [sym_curly_group] = STATE(1227),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHpart] = ACTIONS(6152),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddpart] = ACTIONS(6152),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHchapter] = ACTIONS(6152),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddchap] = ACTIONS(6152),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsection] = ACTIONS(6152),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddsec] = ACTIONS(6152),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHitem] = ACTIONS(6152),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6154),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHbegin] = ACTIONS(6152),
    [anon_sym_BSLASHend] = ACTIONS(6152),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHleft] = ACTIONS(6152),
    [anon_sym_BSLASHbigl] = ACTIONS(6152),
    [anon_sym_BSLASHBigl] = ACTIONS(6152),
    [anon_sym_BSLASHbiggl] = ACTIONS(6152),
    [anon_sym_BSLASHBiggl] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHtext] = ACTIONS(6152),
    [anon_sym_BSLASHintertext] = ACTIONS(6152),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [933] = {
    [ts_builtin_sym_end] = ACTIONS(6612),
    [sym_command_name] = ACTIONS(6610),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6610),
    [anon_sym_LBRACK] = ACTIONS(6612),
    [anon_sym_RBRACK] = ACTIONS(6612),
    [anon_sym_COMMA] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6612),
    [anon_sym_RPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHpart] = ACTIONS(6610),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddpart] = ACTIONS(6610),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHchapter] = ACTIONS(6610),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddchap] = ACTIONS(6610),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsection] = ACTIONS(6610),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddsec] = ACTIONS(6610),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHitem] = ACTIONS(6610),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6612),
    [anon_sym_LBRACE] = ACTIONS(6612),
    [anon_sym_RBRACE] = ACTIONS(6612),
    [sym_word] = ACTIONS(6610),
    [sym_placeholder] = ACTIONS(6612),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_DASH] = ACTIONS(6612),
    [anon_sym_STAR] = ACTIONS(6612),
    [anon_sym_SLASH] = ACTIONS(6612),
    [anon_sym_LT] = ACTIONS(6610),
    [anon_sym_GT] = ACTIONS(6610),
    [anon_sym_BANG] = ACTIONS(6610),
    [anon_sym_PIPE] = ACTIONS(6610),
    [anon_sym_COLON] = ACTIONS(6610),
    [anon_sym_SQUOTE] = ACTIONS(6610),
    [anon_sym__] = ACTIONS(6612),
    [anon_sym_CARET] = ACTIONS(6612),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6612),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6612),
    [anon_sym_DOLLAR] = ACTIONS(6610),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHbegin] = ACTIONS(6610),
    [anon_sym_BSLASHtitle] = ACTIONS(6610),
    [anon_sym_BSLASHauthor] = ACTIONS(6610),
    [anon_sym_BSLASHusepackage] = ACTIONS(6610),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6610),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6610),
    [anon_sym_BSLASHinclude] = ACTIONS(6610),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6610),
    [anon_sym_BSLASHinput] = ACTIONS(6610),
    [anon_sym_BSLASHsubfile] = ACTIONS(6610),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6610),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6610),
    [anon_sym_BSLASHbibliography] = ACTIONS(6610),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6610),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6610),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6610),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6610),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6610),
    [anon_sym_BSLASHimport] = ACTIONS(6610),
    [anon_sym_BSLASHsubimport] = ACTIONS(6610),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6610),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHcaption] = ACTIONS(6610),
    [anon_sym_BSLASHcite] = ACTIONS(6610),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCite] = ACTIONS(6610),
    [anon_sym_BSLASHnocite] = ACTIONS(6610),
    [anon_sym_BSLASHcitet] = ACTIONS(6610),
    [anon_sym_BSLASHcitep] = ACTIONS(6610),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteA] = ACTIONS(6610),
    [anon_sym_BSLASHciteR] = ACTIONS(6610),
    [anon_sym_BSLASHciteS] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6610),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteyear] = ACTIONS(6610),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitedate] = ACTIONS(6610),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteurl] = ACTIONS(6610),
    [anon_sym_BSLASHfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6610),
    [anon_sym_BSLASHcitealt] = ACTIONS(6610),
    [anon_sym_BSLASHcitealp] = ACTIONS(6610),
    [anon_sym_BSLASHcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHparencite] = ACTIONS(6610),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHParencite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHtextcite] = ACTIONS(6610),
    [anon_sym_BSLASHTextcite] = ACTIONS(6610),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHsupercite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite] = ACTIONS(6610),
    [anon_sym_BSLASHAutocite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHVolcite] = ACTIONS(6610),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHavolcite] = ACTIONS(6610),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHNotecite] = ACTIONS(6610),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHlabel] = ACTIONS(6610),
    [anon_sym_BSLASHref] = ACTIONS(6610),
    [anon_sym_BSLASHeqref] = ACTIONS(6610),
    [anon_sym_BSLASHvref] = ACTIONS(6610),
    [anon_sym_BSLASHVref] = ACTIONS(6610),
    [anon_sym_BSLASHautoref] = ACTIONS(6610),
    [anon_sym_BSLASHpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcref] = ACTIONS(6610),
    [anon_sym_BSLASHCref] = ACTIONS(6610),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnameCref] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHdef] = ACTIONS(6610),
    [anon_sym_BSLASHlet] = ACTIONS(6610),
    [anon_sym_BSLASHleft] = ACTIONS(6610),
    [anon_sym_BSLASHbigl] = ACTIONS(6610),
    [anon_sym_BSLASHBigl] = ACTIONS(6610),
    [anon_sym_BSLASHbiggl] = ACTIONS(6610),
    [anon_sym_BSLASHBiggl] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6610),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6610),
    [anon_sym_BSLASHgls] = ACTIONS(6610),
    [anon_sym_BSLASHGls] = ACTIONS(6610),
    [anon_sym_BSLASHGLS] = ACTIONS(6610),
    [anon_sym_BSLASHglspl] = ACTIONS(6610),
    [anon_sym_BSLASHGlspl] = ACTIONS(6610),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6610),
    [anon_sym_BSLASHglslink] = ACTIONS(6610),
    [anon_sym_BSLASHglstext] = ACTIONS(6610),
    [anon_sym_BSLASHGlstext] = ACTIONS(6610),
    [anon_sym_BSLASHGLStext] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6610),
    [anon_sym_BSLASHglsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsname] = ACTIONS(6610),
    [anon_sym_BSLASHGlsname] = ACTIONS(6610),
    [anon_sym_BSLASHGLSname] = ACTIONS(6610),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6610),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6610),
    [anon_sym_BSLASHacrshort] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6610),
    [anon_sym_BSLASHACRshort] = ACTIONS(6610),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrlong] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6610),
    [anon_sym_BSLASHACRlong] = ACTIONS(6610),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrfull] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6610),
    [anon_sym_BSLASHACRfull] = ACTIONS(6610),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHacs] = ACTIONS(6610),
    [anon_sym_BSLASHAcs] = ACTIONS(6610),
    [anon_sym_BSLASHacsp] = ACTIONS(6610),
    [anon_sym_BSLASHAcsp] = ACTIONS(6610),
    [anon_sym_BSLASHacl] = ACTIONS(6610),
    [anon_sym_BSLASHAcl] = ACTIONS(6610),
    [anon_sym_BSLASHaclp] = ACTIONS(6610),
    [anon_sym_BSLASHAclp] = ACTIONS(6610),
    [anon_sym_BSLASHacf] = ACTIONS(6610),
    [anon_sym_BSLASHAcf] = ACTIONS(6610),
    [anon_sym_BSLASHacfp] = ACTIONS(6610),
    [anon_sym_BSLASHAcfp] = ACTIONS(6610),
    [anon_sym_BSLASHac] = ACTIONS(6610),
    [anon_sym_BSLASHAc] = ACTIONS(6610),
    [anon_sym_BSLASHacp] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6610),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6610),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6610),
    [anon_sym_BSLASHcolor] = ACTIONS(6610),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6610),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6610),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6610),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6610),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6610),
    [anon_sym_BSLASHtext] = ACTIONS(6610),
    [anon_sym_BSLASHintertext] = ACTIONS(6610),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6610),
    [anon_sym_BSLASHurl] = ACTIONS(6610),
    [anon_sym_BSLASHhref] = ACTIONS(6610),
  },
  [934] = {
    [ts_builtin_sym_end] = ACTIONS(6616),
    [sym_command_name] = ACTIONS(6614),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6614),
    [anon_sym_LBRACK] = ACTIONS(6616),
    [anon_sym_RBRACK] = ACTIONS(6616),
    [anon_sym_COMMA] = ACTIONS(6616),
    [anon_sym_EQ] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6616),
    [anon_sym_RPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHpart] = ACTIONS(6614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddpart] = ACTIONS(6614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHchapter] = ACTIONS(6614),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddchap] = ACTIONS(6614),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsection] = ACTIONS(6614),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddsec] = ACTIONS(6614),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHitem] = ACTIONS(6614),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(6616),
    [anon_sym_RBRACE] = ACTIONS(6616),
    [sym_word] = ACTIONS(6614),
    [sym_placeholder] = ACTIONS(6616),
    [anon_sym_PLUS] = ACTIONS(6616),
    [anon_sym_DASH] = ACTIONS(6616),
    [anon_sym_STAR] = ACTIONS(6616),
    [anon_sym_SLASH] = ACTIONS(6616),
    [anon_sym_LT] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6614),
    [anon_sym_BANG] = ACTIONS(6614),
    [anon_sym_PIPE] = ACTIONS(6614),
    [anon_sym_COLON] = ACTIONS(6614),
    [anon_sym_SQUOTE] = ACTIONS(6614),
    [anon_sym__] = ACTIONS(6616),
    [anon_sym_CARET] = ACTIONS(6616),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6616),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6616),
    [anon_sym_DOLLAR] = ACTIONS(6614),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHbegin] = ACTIONS(6614),
    [anon_sym_BSLASHtitle] = ACTIONS(6614),
    [anon_sym_BSLASHauthor] = ACTIONS(6614),
    [anon_sym_BSLASHusepackage] = ACTIONS(6614),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6614),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6614),
    [anon_sym_BSLASHinclude] = ACTIONS(6614),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6614),
    [anon_sym_BSLASHinput] = ACTIONS(6614),
    [anon_sym_BSLASHsubfile] = ACTIONS(6614),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6614),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6614),
    [anon_sym_BSLASHbibliography] = ACTIONS(6614),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6614),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6614),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6614),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6614),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6614),
    [anon_sym_BSLASHimport] = ACTIONS(6614),
    [anon_sym_BSLASHsubimport] = ACTIONS(6614),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6614),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHcaption] = ACTIONS(6614),
    [anon_sym_BSLASHcite] = ACTIONS(6614),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCite] = ACTIONS(6614),
    [anon_sym_BSLASHnocite] = ACTIONS(6614),
    [anon_sym_BSLASHcitet] = ACTIONS(6614),
    [anon_sym_BSLASHcitep] = ACTIONS(6614),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteA] = ACTIONS(6614),
    [anon_sym_BSLASHciteR] = ACTIONS(6614),
    [anon_sym_BSLASHciteS] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6614),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteyear] = ACTIONS(6614),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitedate] = ACTIONS(6614),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteurl] = ACTIONS(6614),
    [anon_sym_BSLASHfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6614),
    [anon_sym_BSLASHcitealt] = ACTIONS(6614),
    [anon_sym_BSLASHcitealp] = ACTIONS(6614),
    [anon_sym_BSLASHcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHparencite] = ACTIONS(6614),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHParencite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHtextcite] = ACTIONS(6614),
    [anon_sym_BSLASHTextcite] = ACTIONS(6614),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHsupercite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite] = ACTIONS(6614),
    [anon_sym_BSLASHAutocite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHVolcite] = ACTIONS(6614),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHavolcite] = ACTIONS(6614),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHNotecite] = ACTIONS(6614),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHlabel] = ACTIONS(6614),
    [anon_sym_BSLASHref] = ACTIONS(6614),
    [anon_sym_BSLASHeqref] = ACTIONS(6614),
    [anon_sym_BSLASHvref] = ACTIONS(6614),
    [anon_sym_BSLASHVref] = ACTIONS(6614),
    [anon_sym_BSLASHautoref] = ACTIONS(6614),
    [anon_sym_BSLASHpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcref] = ACTIONS(6614),
    [anon_sym_BSLASHCref] = ACTIONS(6614),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnameCref] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHdef] = ACTIONS(6614),
    [anon_sym_BSLASHlet] = ACTIONS(6614),
    [anon_sym_BSLASHleft] = ACTIONS(6614),
    [anon_sym_BSLASHbigl] = ACTIONS(6614),
    [anon_sym_BSLASHBigl] = ACTIONS(6614),
    [anon_sym_BSLASHbiggl] = ACTIONS(6614),
    [anon_sym_BSLASHBiggl] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6614),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6614),
    [anon_sym_BSLASHgls] = ACTIONS(6614),
    [anon_sym_BSLASHGls] = ACTIONS(6614),
    [anon_sym_BSLASHGLS] = ACTIONS(6614),
    [anon_sym_BSLASHglspl] = ACTIONS(6614),
    [anon_sym_BSLASHGlspl] = ACTIONS(6614),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6614),
    [anon_sym_BSLASHglslink] = ACTIONS(6614),
    [anon_sym_BSLASHglstext] = ACTIONS(6614),
    [anon_sym_BSLASHGlstext] = ACTIONS(6614),
    [anon_sym_BSLASHGLStext] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6614),
    [anon_sym_BSLASHglsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsname] = ACTIONS(6614),
    [anon_sym_BSLASHGlsname] = ACTIONS(6614),
    [anon_sym_BSLASHGLSname] = ACTIONS(6614),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6614),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6614),
    [anon_sym_BSLASHacrshort] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6614),
    [anon_sym_BSLASHACRshort] = ACTIONS(6614),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrlong] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6614),
    [anon_sym_BSLASHACRlong] = ACTIONS(6614),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrfull] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6614),
    [anon_sym_BSLASHACRfull] = ACTIONS(6614),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHacs] = ACTIONS(6614),
    [anon_sym_BSLASHAcs] = ACTIONS(6614),
    [anon_sym_BSLASHacsp] = ACTIONS(6614),
    [anon_sym_BSLASHAcsp] = ACTIONS(6614),
    [anon_sym_BSLASHacl] = ACTIONS(6614),
    [anon_sym_BSLASHAcl] = ACTIONS(6614),
    [anon_sym_BSLASHaclp] = ACTIONS(6614),
    [anon_sym_BSLASHAclp] = ACTIONS(6614),
    [anon_sym_BSLASHacf] = ACTIONS(6614),
    [anon_sym_BSLASHAcf] = ACTIONS(6614),
    [anon_sym_BSLASHacfp] = ACTIONS(6614),
    [anon_sym_BSLASHAcfp] = ACTIONS(6614),
    [anon_sym_BSLASHac] = ACTIONS(6614),
    [anon_sym_BSLASHAc] = ACTIONS(6614),
    [anon_sym_BSLASHacp] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6614),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6614),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6614),
    [anon_sym_BSLASHcolor] = ACTIONS(6614),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6614),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6614),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6614),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6614),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6614),
    [anon_sym_BSLASHtext] = ACTIONS(6614),
    [anon_sym_BSLASHintertext] = ACTIONS(6614),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6614),
    [anon_sym_BSLASHurl] = ACTIONS(6614),
    [anon_sym_BSLASHhref] = ACTIONS(6614),
  },
  [935] = {
    [ts_builtin_sym_end] = ACTIONS(6620),
    [sym_command_name] = ACTIONS(6618),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(6620),
    [anon_sym_RBRACK] = ACTIONS(6620),
    [anon_sym_COMMA] = ACTIONS(6620),
    [anon_sym_EQ] = ACTIONS(6620),
    [anon_sym_LPAREN] = ACTIONS(6620),
    [anon_sym_RPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHpart] = ACTIONS(6618),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddpart] = ACTIONS(6618),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHchapter] = ACTIONS(6618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddchap] = ACTIONS(6618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsection] = ACTIONS(6618),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddsec] = ACTIONS(6618),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHitem] = ACTIONS(6618),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6620),
    [anon_sym_LBRACE] = ACTIONS(6620),
    [anon_sym_RBRACE] = ACTIONS(6620),
    [sym_word] = ACTIONS(6618),
    [sym_placeholder] = ACTIONS(6620),
    [anon_sym_PLUS] = ACTIONS(6620),
    [anon_sym_DASH] = ACTIONS(6620),
    [anon_sym_STAR] = ACTIONS(6620),
    [anon_sym_SLASH] = ACTIONS(6620),
    [anon_sym_LT] = ACTIONS(6618),
    [anon_sym_GT] = ACTIONS(6618),
    [anon_sym_BANG] = ACTIONS(6618),
    [anon_sym_PIPE] = ACTIONS(6618),
    [anon_sym_COLON] = ACTIONS(6618),
    [anon_sym_SQUOTE] = ACTIONS(6618),
    [anon_sym__] = ACTIONS(6620),
    [anon_sym_CARET] = ACTIONS(6620),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6620),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6620),
    [anon_sym_DOLLAR] = ACTIONS(6618),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHbegin] = ACTIONS(6618),
    [anon_sym_BSLASHtitle] = ACTIONS(6618),
    [anon_sym_BSLASHauthor] = ACTIONS(6618),
    [anon_sym_BSLASHusepackage] = ACTIONS(6618),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6618),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6618),
    [anon_sym_BSLASHinclude] = ACTIONS(6618),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6618),
    [anon_sym_BSLASHinput] = ACTIONS(6618),
    [anon_sym_BSLASHsubfile] = ACTIONS(6618),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6618),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6618),
    [anon_sym_BSLASHbibliography] = ACTIONS(6618),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6618),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6618),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6618),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6618),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6618),
    [anon_sym_BSLASHimport] = ACTIONS(6618),
    [anon_sym_BSLASHsubimport] = ACTIONS(6618),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6618),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHcaption] = ACTIONS(6618),
    [anon_sym_BSLASHcite] = ACTIONS(6618),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCite] = ACTIONS(6618),
    [anon_sym_BSLASHnocite] = ACTIONS(6618),
    [anon_sym_BSLASHcitet] = ACTIONS(6618),
    [anon_sym_BSLASHcitep] = ACTIONS(6618),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteA] = ACTIONS(6618),
    [anon_sym_BSLASHciteR] = ACTIONS(6618),
    [anon_sym_BSLASHciteS] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6618),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteyear] = ACTIONS(6618),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitedate] = ACTIONS(6618),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteurl] = ACTIONS(6618),
    [anon_sym_BSLASHfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6618),
    [anon_sym_BSLASHcitealt] = ACTIONS(6618),
    [anon_sym_BSLASHcitealp] = ACTIONS(6618),
    [anon_sym_BSLASHcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHparencite] = ACTIONS(6618),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHParencite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHtextcite] = ACTIONS(6618),
    [anon_sym_BSLASHTextcite] = ACTIONS(6618),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHsupercite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite] = ACTIONS(6618),
    [anon_sym_BSLASHAutocite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHVolcite] = ACTIONS(6618),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHavolcite] = ACTIONS(6618),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHNotecite] = ACTIONS(6618),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHlabel] = ACTIONS(6618),
    [anon_sym_BSLASHref] = ACTIONS(6618),
    [anon_sym_BSLASHeqref] = ACTIONS(6618),
    [anon_sym_BSLASHvref] = ACTIONS(6618),
    [anon_sym_BSLASHVref] = ACTIONS(6618),
    [anon_sym_BSLASHautoref] = ACTIONS(6618),
    [anon_sym_BSLASHpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcref] = ACTIONS(6618),
    [anon_sym_BSLASHCref] = ACTIONS(6618),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnameCref] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHdef] = ACTIONS(6618),
    [anon_sym_BSLASHlet] = ACTIONS(6618),
    [anon_sym_BSLASHleft] = ACTIONS(6618),
    [anon_sym_BSLASHbigl] = ACTIONS(6618),
    [anon_sym_BSLASHBigl] = ACTIONS(6618),
    [anon_sym_BSLASHbiggl] = ACTIONS(6618),
    [anon_sym_BSLASHBiggl] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6618),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6618),
    [anon_sym_BSLASHgls] = ACTIONS(6618),
    [anon_sym_BSLASHGls] = ACTIONS(6618),
    [anon_sym_BSLASHGLS] = ACTIONS(6618),
    [anon_sym_BSLASHglspl] = ACTIONS(6618),
    [anon_sym_BSLASHGlspl] = ACTIONS(6618),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6618),
    [anon_sym_BSLASHglslink] = ACTIONS(6618),
    [anon_sym_BSLASHglstext] = ACTIONS(6618),
    [anon_sym_BSLASHGlstext] = ACTIONS(6618),
    [anon_sym_BSLASHGLStext] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6618),
    [anon_sym_BSLASHglsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsname] = ACTIONS(6618),
    [anon_sym_BSLASHGlsname] = ACTIONS(6618),
    [anon_sym_BSLASHGLSname] = ACTIONS(6618),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6618),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6618),
    [anon_sym_BSLASHacrshort] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6618),
    [anon_sym_BSLASHACRshort] = ACTIONS(6618),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrlong] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6618),
    [anon_sym_BSLASHACRlong] = ACTIONS(6618),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrfull] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6618),
    [anon_sym_BSLASHACRfull] = ACTIONS(6618),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHacs] = ACTIONS(6618),
    [anon_sym_BSLASHAcs] = ACTIONS(6618),
    [anon_sym_BSLASHacsp] = ACTIONS(6618),
    [anon_sym_BSLASHAcsp] = ACTIONS(6618),
    [anon_sym_BSLASHacl] = ACTIONS(6618),
    [anon_sym_BSLASHAcl] = ACTIONS(6618),
    [anon_sym_BSLASHaclp] = ACTIONS(6618),
    [anon_sym_BSLASHAclp] = ACTIONS(6618),
    [anon_sym_BSLASHacf] = ACTIONS(6618),
    [anon_sym_BSLASHAcf] = ACTIONS(6618),
    [anon_sym_BSLASHacfp] = ACTIONS(6618),
    [anon_sym_BSLASHAcfp] = ACTIONS(6618),
    [anon_sym_BSLASHac] = ACTIONS(6618),
    [anon_sym_BSLASHAc] = ACTIONS(6618),
    [anon_sym_BSLASHacp] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6618),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6618),
    [anon_sym_BSLASHcolor] = ACTIONS(6618),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6618),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6618),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6618),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6618),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6618),
    [anon_sym_BSLASHtext] = ACTIONS(6618),
    [anon_sym_BSLASHintertext] = ACTIONS(6618),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6618),
    [anon_sym_BSLASHurl] = ACTIONS(6618),
    [anon_sym_BSLASHhref] = ACTIONS(6618),
  },
  [936] = {
    [ts_builtin_sym_end] = ACTIONS(6624),
    [sym_command_name] = ACTIONS(6622),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6622),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_RBRACK] = ACTIONS(6624),
    [anon_sym_COMMA] = ACTIONS(6624),
    [anon_sym_EQ] = ACTIONS(6624),
    [anon_sym_LPAREN] = ACTIONS(6624),
    [anon_sym_RPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHpart] = ACTIONS(6622),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddpart] = ACTIONS(6622),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHchapter] = ACTIONS(6622),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddchap] = ACTIONS(6622),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsection] = ACTIONS(6622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddsec] = ACTIONS(6622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHitem] = ACTIONS(6622),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(6624),
    [anon_sym_RBRACE] = ACTIONS(6624),
    [sym_word] = ACTIONS(6622),
    [sym_placeholder] = ACTIONS(6624),
    [anon_sym_PLUS] = ACTIONS(6624),
    [anon_sym_DASH] = ACTIONS(6624),
    [anon_sym_STAR] = ACTIONS(6624),
    [anon_sym_SLASH] = ACTIONS(6624),
    [anon_sym_LT] = ACTIONS(6622),
    [anon_sym_GT] = ACTIONS(6622),
    [anon_sym_BANG] = ACTIONS(6622),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_COLON] = ACTIONS(6622),
    [anon_sym_SQUOTE] = ACTIONS(6622),
    [anon_sym__] = ACTIONS(6624),
    [anon_sym_CARET] = ACTIONS(6624),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6624),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6624),
    [anon_sym_DOLLAR] = ACTIONS(6622),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHbegin] = ACTIONS(6622),
    [anon_sym_BSLASHtitle] = ACTIONS(6622),
    [anon_sym_BSLASHauthor] = ACTIONS(6622),
    [anon_sym_BSLASHusepackage] = ACTIONS(6622),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6622),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6622),
    [anon_sym_BSLASHinclude] = ACTIONS(6622),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6622),
    [anon_sym_BSLASHinput] = ACTIONS(6622),
    [anon_sym_BSLASHsubfile] = ACTIONS(6622),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6622),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6622),
    [anon_sym_BSLASHbibliography] = ACTIONS(6622),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6622),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6622),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6622),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6622),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6622),
    [anon_sym_BSLASHimport] = ACTIONS(6622),
    [anon_sym_BSLASHsubimport] = ACTIONS(6622),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6622),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHcaption] = ACTIONS(6622),
    [anon_sym_BSLASHcite] = ACTIONS(6622),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCite] = ACTIONS(6622),
    [anon_sym_BSLASHnocite] = ACTIONS(6622),
    [anon_sym_BSLASHcitet] = ACTIONS(6622),
    [anon_sym_BSLASHcitep] = ACTIONS(6622),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteA] = ACTIONS(6622),
    [anon_sym_BSLASHciteR] = ACTIONS(6622),
    [anon_sym_BSLASHciteS] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6622),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteyear] = ACTIONS(6622),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitedate] = ACTIONS(6622),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteurl] = ACTIONS(6622),
    [anon_sym_BSLASHfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6622),
    [anon_sym_BSLASHcitealt] = ACTIONS(6622),
    [anon_sym_BSLASHcitealp] = ACTIONS(6622),
    [anon_sym_BSLASHcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHparencite] = ACTIONS(6622),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHParencite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHtextcite] = ACTIONS(6622),
    [anon_sym_BSLASHTextcite] = ACTIONS(6622),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHsupercite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite] = ACTIONS(6622),
    [anon_sym_BSLASHAutocite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHVolcite] = ACTIONS(6622),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHavolcite] = ACTIONS(6622),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHNotecite] = ACTIONS(6622),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHlabel] = ACTIONS(6622),
    [anon_sym_BSLASHref] = ACTIONS(6622),
    [anon_sym_BSLASHeqref] = ACTIONS(6622),
    [anon_sym_BSLASHvref] = ACTIONS(6622),
    [anon_sym_BSLASHVref] = ACTIONS(6622),
    [anon_sym_BSLASHautoref] = ACTIONS(6622),
    [anon_sym_BSLASHpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcref] = ACTIONS(6622),
    [anon_sym_BSLASHCref] = ACTIONS(6622),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnameCref] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHdef] = ACTIONS(6622),
    [anon_sym_BSLASHlet] = ACTIONS(6622),
    [anon_sym_BSLASHleft] = ACTIONS(6622),
    [anon_sym_BSLASHbigl] = ACTIONS(6622),
    [anon_sym_BSLASHBigl] = ACTIONS(6622),
    [anon_sym_BSLASHbiggl] = ACTIONS(6622),
    [anon_sym_BSLASHBiggl] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6622),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6622),
    [anon_sym_BSLASHgls] = ACTIONS(6622),
    [anon_sym_BSLASHGls] = ACTIONS(6622),
    [anon_sym_BSLASHGLS] = ACTIONS(6622),
    [anon_sym_BSLASHglspl] = ACTIONS(6622),
    [anon_sym_BSLASHGlspl] = ACTIONS(6622),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6622),
    [anon_sym_BSLASHglslink] = ACTIONS(6622),
    [anon_sym_BSLASHglstext] = ACTIONS(6622),
    [anon_sym_BSLASHGlstext] = ACTIONS(6622),
    [anon_sym_BSLASHGLStext] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6622),
    [anon_sym_BSLASHglsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsname] = ACTIONS(6622),
    [anon_sym_BSLASHGlsname] = ACTIONS(6622),
    [anon_sym_BSLASHGLSname] = ACTIONS(6622),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6622),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6622),
    [anon_sym_BSLASHacrshort] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6622),
    [anon_sym_BSLASHACRshort] = ACTIONS(6622),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrlong] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6622),
    [anon_sym_BSLASHACRlong] = ACTIONS(6622),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrfull] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6622),
    [anon_sym_BSLASHACRfull] = ACTIONS(6622),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHacs] = ACTIONS(6622),
    [anon_sym_BSLASHAcs] = ACTIONS(6622),
    [anon_sym_BSLASHacsp] = ACTIONS(6622),
    [anon_sym_BSLASHAcsp] = ACTIONS(6622),
    [anon_sym_BSLASHacl] = ACTIONS(6622),
    [anon_sym_BSLASHAcl] = ACTIONS(6622),
    [anon_sym_BSLASHaclp] = ACTIONS(6622),
    [anon_sym_BSLASHAclp] = ACTIONS(6622),
    [anon_sym_BSLASHacf] = ACTIONS(6622),
    [anon_sym_BSLASHAcf] = ACTIONS(6622),
    [anon_sym_BSLASHacfp] = ACTIONS(6622),
    [anon_sym_BSLASHAcfp] = ACTIONS(6622),
    [anon_sym_BSLASHac] = ACTIONS(6622),
    [anon_sym_BSLASHAc] = ACTIONS(6622),
    [anon_sym_BSLASHacp] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6622),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6622),
    [anon_sym_BSLASHcolor] = ACTIONS(6622),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6622),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6622),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6622),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6622),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6622),
    [anon_sym_BSLASHtext] = ACTIONS(6622),
    [anon_sym_BSLASHintertext] = ACTIONS(6622),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6622),
    [anon_sym_BSLASHurl] = ACTIONS(6622),
    [anon_sym_BSLASHhref] = ACTIONS(6622),
  },
  [937] = {
    [ts_builtin_sym_end] = ACTIONS(6284),
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHpart] = ACTIONS(6282),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddpart] = ACTIONS(6282),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHchapter] = ACTIONS(6282),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddchap] = ACTIONS(6282),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsection] = ACTIONS(6282),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddsec] = ACTIONS(6282),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHitem] = ACTIONS(6282),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [anon_sym_RBRACE] = ACTIONS(6284),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6284),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6284),
    [anon_sym_DOLLAR] = ACTIONS(6282),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHbegin] = ACTIONS(6282),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHleft] = ACTIONS(6282),
    [anon_sym_BSLASHbigl] = ACTIONS(6282),
    [anon_sym_BSLASHBigl] = ACTIONS(6282),
    [anon_sym_BSLASHbiggl] = ACTIONS(6282),
    [anon_sym_BSLASHBiggl] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHtext] = ACTIONS(6282),
    [anon_sym_BSLASHintertext] = ACTIONS(6282),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [938] = {
    [ts_builtin_sym_end] = ACTIONS(151),
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [939] = {
    [ts_builtin_sym_end] = ACTIONS(163),
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [940] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2447),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7057),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [941] = {
    [sym_curly_group] = STATE(1138),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6146),
    [anon_sym_LPAREN] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHpart] = ACTIONS(6144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddpart] = ACTIONS(6144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHchapter] = ACTIONS(6144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddchap] = ACTIONS(6144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsection] = ACTIONS(6144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddsec] = ACTIONS(6144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHitem] = ACTIONS(6144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6146),
    [anon_sym_DOLLAR] = ACTIONS(6144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6146),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHbegin] = ACTIONS(6144),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHleft] = ACTIONS(6144),
    [anon_sym_BSLASHbigl] = ACTIONS(6144),
    [anon_sym_BSLASHBigl] = ACTIONS(6144),
    [anon_sym_BSLASHbiggl] = ACTIONS(6144),
    [anon_sym_BSLASHBiggl] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHtext] = ACTIONS(6144),
    [anon_sym_BSLASHintertext] = ACTIONS(6144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [942] = {
    [sym_brack_group_text] = STATE(1413),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(7055),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHpart] = ACTIONS(6166),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddpart] = ACTIONS(6166),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHchapter] = ACTIONS(6166),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddchap] = ACTIONS(6166),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsection] = ACTIONS(6166),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddsec] = ACTIONS(6166),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHitem] = ACTIONS(6166),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6168),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6168),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6166),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHbegin] = ACTIONS(6166),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHleft] = ACTIONS(6166),
    [anon_sym_BSLASHbigl] = ACTIONS(6166),
    [anon_sym_BSLASHBigl] = ACTIONS(6166),
    [anon_sym_BSLASHbiggl] = ACTIONS(6166),
    [anon_sym_BSLASHBiggl] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHtext] = ACTIONS(6166),
    [anon_sym_BSLASHintertext] = ACTIONS(6166),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [943] = {
    [sym_brack_group_text] = STATE(1223),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(7059),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHpart] = ACTIONS(6148),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddpart] = ACTIONS(6148),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHchapter] = ACTIONS(6148),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddchap] = ACTIONS(6148),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsection] = ACTIONS(6148),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddsec] = ACTIONS(6148),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHitem] = ACTIONS(6148),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6150),
    [anon_sym_LBRACE] = ACTIONS(6150),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6150),
    [anon_sym_DOLLAR] = ACTIONS(6148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHbegin] = ACTIONS(6148),
    [anon_sym_BSLASHend] = ACTIONS(6148),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHleft] = ACTIONS(6148),
    [anon_sym_BSLASHbigl] = ACTIONS(6148),
    [anon_sym_BSLASHBigl] = ACTIONS(6148),
    [anon_sym_BSLASHbiggl] = ACTIONS(6148),
    [anon_sym_BSLASHBiggl] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHtext] = ACTIONS(6148),
    [anon_sym_BSLASHintertext] = ACTIONS(6148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [944] = {
    [sym_curly_group] = STATE(1218),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6146),
    [anon_sym_LPAREN] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHpart] = ACTIONS(6144),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddpart] = ACTIONS(6144),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHchapter] = ACTIONS(6144),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddchap] = ACTIONS(6144),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsection] = ACTIONS(6144),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHaddsec] = ACTIONS(6144),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6144),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6144),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHitem] = ACTIONS(6144),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6146),
    [anon_sym_DOLLAR] = ACTIONS(6144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHbegin] = ACTIONS(6144),
    [anon_sym_BSLASHend] = ACTIONS(6144),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHleft] = ACTIONS(6144),
    [anon_sym_BSLASHbigl] = ACTIONS(6144),
    [anon_sym_BSLASHBigl] = ACTIONS(6144),
    [anon_sym_BSLASHbiggl] = ACTIONS(6144),
    [anon_sym_BSLASHBiggl] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHtext] = ACTIONS(6144),
    [anon_sym_BSLASHintertext] = ACTIONS(6144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [945] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2362),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7061),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [946] = {
    [sym_brack_group_text] = STATE(1134),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(7051),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHpart] = ACTIONS(6148),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddpart] = ACTIONS(6148),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHchapter] = ACTIONS(6148),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddchap] = ACTIONS(6148),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsection] = ACTIONS(6148),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHaddsec] = ACTIONS(6148),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6148),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6148),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHitem] = ACTIONS(6148),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6150),
    [anon_sym_LBRACE] = ACTIONS(6150),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6150),
    [anon_sym_DOLLAR] = ACTIONS(6148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6150),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHbegin] = ACTIONS(6148),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHleft] = ACTIONS(6148),
    [anon_sym_BSLASHbigl] = ACTIONS(6148),
    [anon_sym_BSLASHBigl] = ACTIONS(6148),
    [anon_sym_BSLASHbiggl] = ACTIONS(6148),
    [anon_sym_BSLASHBiggl] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHtext] = ACTIONS(6148),
    [anon_sym_BSLASHintertext] = ACTIONS(6148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [947] = {
    [ts_builtin_sym_end] = ACTIONS(6636),
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_RBRACK] = ACTIONS(6636),
    [anon_sym_COMMA] = ACTIONS(6636),
    [anon_sym_EQ] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(6636),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHpart] = ACTIONS(6634),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddpart] = ACTIONS(6634),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHchapter] = ACTIONS(6634),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddchap] = ACTIONS(6634),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsection] = ACTIONS(6634),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddsec] = ACTIONS(6634),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHitem] = ACTIONS(6634),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [anon_sym_RBRACE] = ACTIONS(6636),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6636),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(6634),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHbegin] = ACTIONS(6634),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHleft] = ACTIONS(6634),
    [anon_sym_BSLASHbigl] = ACTIONS(6634),
    [anon_sym_BSLASHBigl] = ACTIONS(6634),
    [anon_sym_BSLASHbiggl] = ACTIONS(6634),
    [anon_sym_BSLASHBiggl] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHtext] = ACTIONS(6634),
    [anon_sym_BSLASHintertext] = ACTIONS(6634),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [948] = {
    [ts_builtin_sym_end] = ACTIONS(6336),
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6336),
    [anon_sym_RBRACK] = ACTIONS(6336),
    [anon_sym_COMMA] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_RPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHpart] = ACTIONS(6334),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddpart] = ACTIONS(6334),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHchapter] = ACTIONS(6334),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddchap] = ACTIONS(6334),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsection] = ACTIONS(6334),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddsec] = ACTIONS(6334),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHitem] = ACTIONS(6334),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [anon_sym_RBRACE] = ACTIONS(6336),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6336),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHbegin] = ACTIONS(6334),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHleft] = ACTIONS(6334),
    [anon_sym_BSLASHbigl] = ACTIONS(6334),
    [anon_sym_BSLASHBigl] = ACTIONS(6334),
    [anon_sym_BSLASHbiggl] = ACTIONS(6334),
    [anon_sym_BSLASHBiggl] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHtext] = ACTIONS(6334),
    [anon_sym_BSLASHintertext] = ACTIONS(6334),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [949] = {
    [ts_builtin_sym_end] = ACTIONS(6332),
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6332),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_EQ] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6332),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHpart] = ACTIONS(6330),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddpart] = ACTIONS(6330),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHchapter] = ACTIONS(6330),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddchap] = ACTIONS(6330),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsection] = ACTIONS(6330),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddsec] = ACTIONS(6330),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHitem] = ACTIONS(6330),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [anon_sym_RBRACE] = ACTIONS(6332),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6332),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6330),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHbegin] = ACTIONS(6330),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHleft] = ACTIONS(6330),
    [anon_sym_BSLASHbigl] = ACTIONS(6330),
    [anon_sym_BSLASHBigl] = ACTIONS(6330),
    [anon_sym_BSLASHbiggl] = ACTIONS(6330),
    [anon_sym_BSLASHBiggl] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHtext] = ACTIONS(6330),
    [anon_sym_BSLASHintertext] = ACTIONS(6330),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [950] = {
    [sym_brack_group_text] = STATE(1271),
    [sym_command_name] = ACTIONS(6138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(7055),
    [anon_sym_RBRACK] = ACTIONS(6142),
    [anon_sym_COMMA] = ACTIONS(6142),
    [anon_sym_EQ] = ACTIONS(6142),
    [anon_sym_LPAREN] = ACTIONS(6142),
    [anon_sym_RPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHpart] = ACTIONS(6138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddpart] = ACTIONS(6138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHchapter] = ACTIONS(6138),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddchap] = ACTIONS(6138),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsection] = ACTIONS(6138),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddsec] = ACTIONS(6138),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHitem] = ACTIONS(6138),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(6142),
    [sym_word] = ACTIONS(6138),
    [sym_placeholder] = ACTIONS(6142),
    [anon_sym_PLUS] = ACTIONS(6142),
    [anon_sym_DASH] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6142),
    [anon_sym_LT] = ACTIONS(6138),
    [anon_sym_GT] = ACTIONS(6138),
    [anon_sym_BANG] = ACTIONS(6138),
    [anon_sym_PIPE] = ACTIONS(6138),
    [anon_sym_COLON] = ACTIONS(6138),
    [anon_sym_SQUOTE] = ACTIONS(6138),
    [anon_sym__] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6142),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6142),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6142),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6142),
    [anon_sym_DOLLAR] = ACTIONS(6138),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHbegin] = ACTIONS(6138),
    [anon_sym_BSLASHtitle] = ACTIONS(6138),
    [anon_sym_BSLASHauthor] = ACTIONS(6138),
    [anon_sym_BSLASHusepackage] = ACTIONS(6138),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6138),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6138),
    [anon_sym_BSLASHinclude] = ACTIONS(6138),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6138),
    [anon_sym_BSLASHinput] = ACTIONS(6138),
    [anon_sym_BSLASHsubfile] = ACTIONS(6138),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6138),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6138),
    [anon_sym_BSLASHbibliography] = ACTIONS(6138),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6138),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6138),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6138),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6138),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6138),
    [anon_sym_BSLASHimport] = ACTIONS(6138),
    [anon_sym_BSLASHsubimport] = ACTIONS(6138),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6138),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHcaption] = ACTIONS(6138),
    [anon_sym_BSLASHcite] = ACTIONS(6138),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCite] = ACTIONS(6138),
    [anon_sym_BSLASHnocite] = ACTIONS(6138),
    [anon_sym_BSLASHcitet] = ACTIONS(6138),
    [anon_sym_BSLASHcitep] = ACTIONS(6138),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteA] = ACTIONS(6138),
    [anon_sym_BSLASHciteR] = ACTIONS(6138),
    [anon_sym_BSLASHciteS] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6138),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteyear] = ACTIONS(6138),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitedate] = ACTIONS(6138),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteurl] = ACTIONS(6138),
    [anon_sym_BSLASHfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6138),
    [anon_sym_BSLASHcitealt] = ACTIONS(6138),
    [anon_sym_BSLASHcitealp] = ACTIONS(6138),
    [anon_sym_BSLASHcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHparencite] = ACTIONS(6138),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHParencite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHtextcite] = ACTIONS(6138),
    [anon_sym_BSLASHTextcite] = ACTIONS(6138),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHsupercite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite] = ACTIONS(6138),
    [anon_sym_BSLASHAutocite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHVolcite] = ACTIONS(6138),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHavolcite] = ACTIONS(6138),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHNotecite] = ACTIONS(6138),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHlabel] = ACTIONS(6138),
    [anon_sym_BSLASHref] = ACTIONS(6138),
    [anon_sym_BSLASHeqref] = ACTIONS(6138),
    [anon_sym_BSLASHvref] = ACTIONS(6138),
    [anon_sym_BSLASHVref] = ACTIONS(6138),
    [anon_sym_BSLASHautoref] = ACTIONS(6138),
    [anon_sym_BSLASHpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcref] = ACTIONS(6138),
    [anon_sym_BSLASHCref] = ACTIONS(6138),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnameCref] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHdef] = ACTIONS(6138),
    [anon_sym_BSLASHlet] = ACTIONS(6138),
    [anon_sym_BSLASHleft] = ACTIONS(6138),
    [anon_sym_BSLASHbigl] = ACTIONS(6138),
    [anon_sym_BSLASHBigl] = ACTIONS(6138),
    [anon_sym_BSLASHbiggl] = ACTIONS(6138),
    [anon_sym_BSLASHBiggl] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6138),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6138),
    [anon_sym_BSLASHgls] = ACTIONS(6138),
    [anon_sym_BSLASHGls] = ACTIONS(6138),
    [anon_sym_BSLASHGLS] = ACTIONS(6138),
    [anon_sym_BSLASHglspl] = ACTIONS(6138),
    [anon_sym_BSLASHGlspl] = ACTIONS(6138),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6138),
    [anon_sym_BSLASHglslink] = ACTIONS(6138),
    [anon_sym_BSLASHglstext] = ACTIONS(6138),
    [anon_sym_BSLASHGlstext] = ACTIONS(6138),
    [anon_sym_BSLASHGLStext] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6138),
    [anon_sym_BSLASHglsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsname] = ACTIONS(6138),
    [anon_sym_BSLASHGlsname] = ACTIONS(6138),
    [anon_sym_BSLASHGLSname] = ACTIONS(6138),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6138),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6138),
    [anon_sym_BSLASHacrshort] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6138),
    [anon_sym_BSLASHACRshort] = ACTIONS(6138),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrlong] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6138),
    [anon_sym_BSLASHACRlong] = ACTIONS(6138),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrfull] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6138),
    [anon_sym_BSLASHACRfull] = ACTIONS(6138),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHacs] = ACTIONS(6138),
    [anon_sym_BSLASHAcs] = ACTIONS(6138),
    [anon_sym_BSLASHacsp] = ACTIONS(6138),
    [anon_sym_BSLASHAcsp] = ACTIONS(6138),
    [anon_sym_BSLASHacl] = ACTIONS(6138),
    [anon_sym_BSLASHAcl] = ACTIONS(6138),
    [anon_sym_BSLASHaclp] = ACTIONS(6138),
    [anon_sym_BSLASHAclp] = ACTIONS(6138),
    [anon_sym_BSLASHacf] = ACTIONS(6138),
    [anon_sym_BSLASHAcf] = ACTIONS(6138),
    [anon_sym_BSLASHacfp] = ACTIONS(6138),
    [anon_sym_BSLASHAcfp] = ACTIONS(6138),
    [anon_sym_BSLASHac] = ACTIONS(6138),
    [anon_sym_BSLASHAc] = ACTIONS(6138),
    [anon_sym_BSLASHacp] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6138),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6138),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6138),
    [anon_sym_BSLASHcolor] = ACTIONS(6138),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6138),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6138),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6138),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6138),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6138),
    [anon_sym_BSLASHtext] = ACTIONS(6138),
    [anon_sym_BSLASHintertext] = ACTIONS(6138),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6138),
    [anon_sym_BSLASHurl] = ACTIONS(6138),
    [anon_sym_BSLASHhref] = ACTIONS(6138),
  },
  [951] = {
    [ts_builtin_sym_end] = ACTIONS(6324),
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHpart] = ACTIONS(6322),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddpart] = ACTIONS(6322),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHchapter] = ACTIONS(6322),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddchap] = ACTIONS(6322),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsection] = ACTIONS(6322),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddsec] = ACTIONS(6322),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHitem] = ACTIONS(6322),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [anon_sym_RBRACE] = ACTIONS(6324),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6324),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6324),
    [anon_sym_DOLLAR] = ACTIONS(6322),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHbegin] = ACTIONS(6322),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHleft] = ACTIONS(6322),
    [anon_sym_BSLASHbigl] = ACTIONS(6322),
    [anon_sym_BSLASHBigl] = ACTIONS(6322),
    [anon_sym_BSLASHbiggl] = ACTIONS(6322),
    [anon_sym_BSLASHBiggl] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHtext] = ACTIONS(6322),
    [anon_sym_BSLASHintertext] = ACTIONS(6322),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [952] = {
    [ts_builtin_sym_end] = ACTIONS(6320),
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_RBRACK] = ACTIONS(6320),
    [anon_sym_COMMA] = ACTIONS(6320),
    [anon_sym_EQ] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(6320),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHpart] = ACTIONS(6318),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddpart] = ACTIONS(6318),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHchapter] = ACTIONS(6318),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddchap] = ACTIONS(6318),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsection] = ACTIONS(6318),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddsec] = ACTIONS(6318),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHitem] = ACTIONS(6318),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [anon_sym_RBRACE] = ACTIONS(6320),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6320),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6320),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHbegin] = ACTIONS(6318),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHleft] = ACTIONS(6318),
    [anon_sym_BSLASHbigl] = ACTIONS(6318),
    [anon_sym_BSLASHBigl] = ACTIONS(6318),
    [anon_sym_BSLASHbiggl] = ACTIONS(6318),
    [anon_sym_BSLASHBiggl] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHtext] = ACTIONS(6318),
    [anon_sym_BSLASHintertext] = ACTIONS(6318),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [953] = {
    [ts_builtin_sym_end] = ACTIONS(6316),
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_COMMA] = ACTIONS(6316),
    [anon_sym_EQ] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6316),
    [anon_sym_RPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHpart] = ACTIONS(6314),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddpart] = ACTIONS(6314),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHchapter] = ACTIONS(6314),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddchap] = ACTIONS(6314),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsection] = ACTIONS(6314),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddsec] = ACTIONS(6314),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHitem] = ACTIONS(6314),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6316),
    [anon_sym_RBRACE] = ACTIONS(6316),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6316),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6316),
    [anon_sym_DOLLAR] = ACTIONS(6314),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHbegin] = ACTIONS(6314),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHleft] = ACTIONS(6314),
    [anon_sym_BSLASHbigl] = ACTIONS(6314),
    [anon_sym_BSLASHBigl] = ACTIONS(6314),
    [anon_sym_BSLASHbiggl] = ACTIONS(6314),
    [anon_sym_BSLASHBiggl] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHtext] = ACTIONS(6314),
    [anon_sym_BSLASHintertext] = ACTIONS(6314),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [954] = {
    [ts_builtin_sym_end] = ACTIONS(6312),
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6312),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6312),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHpart] = ACTIONS(6310),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddpart] = ACTIONS(6310),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHchapter] = ACTIONS(6310),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddchap] = ACTIONS(6310),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsection] = ACTIONS(6310),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddsec] = ACTIONS(6310),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHitem] = ACTIONS(6310),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6312),
    [anon_sym_RBRACE] = ACTIONS(6312),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6312),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6312),
    [anon_sym_DOLLAR] = ACTIONS(6310),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHbegin] = ACTIONS(6310),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHleft] = ACTIONS(6310),
    [anon_sym_BSLASHbigl] = ACTIONS(6310),
    [anon_sym_BSLASHBigl] = ACTIONS(6310),
    [anon_sym_BSLASHbiggl] = ACTIONS(6310),
    [anon_sym_BSLASHBiggl] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHtext] = ACTIONS(6310),
    [anon_sym_BSLASHintertext] = ACTIONS(6310),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [955] = {
    [ts_builtin_sym_end] = ACTIONS(6292),
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6292),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_COMMA] = ACTIONS(6292),
    [anon_sym_EQ] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_RPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHpart] = ACTIONS(6290),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddpart] = ACTIONS(6290),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHchapter] = ACTIONS(6290),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddchap] = ACTIONS(6290),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsection] = ACTIONS(6290),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddsec] = ACTIONS(6290),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHitem] = ACTIONS(6290),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6292),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [anon_sym_RBRACE] = ACTIONS(6292),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6292),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6292),
    [anon_sym_DOLLAR] = ACTIONS(6290),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHbegin] = ACTIONS(6290),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHleft] = ACTIONS(6290),
    [anon_sym_BSLASHbigl] = ACTIONS(6290),
    [anon_sym_BSLASHBigl] = ACTIONS(6290),
    [anon_sym_BSLASHbiggl] = ACTIONS(6290),
    [anon_sym_BSLASHBiggl] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHtext] = ACTIONS(6290),
    [anon_sym_BSLASHintertext] = ACTIONS(6290),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [956] = {
    [ts_builtin_sym_end] = ACTIONS(6288),
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6288),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHpart] = ACTIONS(6286),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddpart] = ACTIONS(6286),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHchapter] = ACTIONS(6286),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddchap] = ACTIONS(6286),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsection] = ACTIONS(6286),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddsec] = ACTIONS(6286),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHitem] = ACTIONS(6286),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_RBRACE] = ACTIONS(6288),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6288),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6288),
    [anon_sym_DOLLAR] = ACTIONS(6286),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHbegin] = ACTIONS(6286),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHleft] = ACTIONS(6286),
    [anon_sym_BSLASHbigl] = ACTIONS(6286),
    [anon_sym_BSLASHBigl] = ACTIONS(6286),
    [anon_sym_BSLASHbiggl] = ACTIONS(6286),
    [anon_sym_BSLASHBiggl] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHtext] = ACTIONS(6286),
    [anon_sym_BSLASHintertext] = ACTIONS(6286),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [957] = {
    [ts_builtin_sym_end] = ACTIONS(6272),
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_LBRACK] = ACTIONS(6272),
    [anon_sym_RBRACK] = ACTIONS(6272),
    [anon_sym_COMMA] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_LPAREN] = ACTIONS(6272),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHpart] = ACTIONS(6270),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddpart] = ACTIONS(6270),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHchapter] = ACTIONS(6270),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddchap] = ACTIONS(6270),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsection] = ACTIONS(6270),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddsec] = ACTIONS(6270),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHitem] = ACTIONS(6270),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6272),
    [anon_sym_RBRACE] = ACTIONS(6272),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6272),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6272),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHbegin] = ACTIONS(6270),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHleft] = ACTIONS(6270),
    [anon_sym_BSLASHbigl] = ACTIONS(6270),
    [anon_sym_BSLASHBigl] = ACTIONS(6270),
    [anon_sym_BSLASHbiggl] = ACTIONS(6270),
    [anon_sym_BSLASHBiggl] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHtext] = ACTIONS(6270),
    [anon_sym_BSLASHintertext] = ACTIONS(6270),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [958] = {
    [ts_builtin_sym_end] = ACTIONS(6268),
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_COMMA] = ACTIONS(6268),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_LPAREN] = ACTIONS(6268),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHpart] = ACTIONS(6266),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddpart] = ACTIONS(6266),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHchapter] = ACTIONS(6266),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddchap] = ACTIONS(6266),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsection] = ACTIONS(6266),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddsec] = ACTIONS(6266),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHitem] = ACTIONS(6266),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [anon_sym_RBRACE] = ACTIONS(6268),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6268),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(6266),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHbegin] = ACTIONS(6266),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHleft] = ACTIONS(6266),
    [anon_sym_BSLASHbigl] = ACTIONS(6266),
    [anon_sym_BSLASHBigl] = ACTIONS(6266),
    [anon_sym_BSLASHbiggl] = ACTIONS(6266),
    [anon_sym_BSLASHBiggl] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHtext] = ACTIONS(6266),
    [anon_sym_BSLASHintertext] = ACTIONS(6266),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [959] = {
    [ts_builtin_sym_end] = ACTIONS(6252),
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6252),
    [anon_sym_LPAREN] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHpart] = ACTIONS(6250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddpart] = ACTIONS(6250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHchapter] = ACTIONS(6250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddchap] = ACTIONS(6250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsection] = ACTIONS(6250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddsec] = ACTIONS(6250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHitem] = ACTIONS(6250),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHbegin] = ACTIONS(6250),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHleft] = ACTIONS(6250),
    [anon_sym_BSLASHbigl] = ACTIONS(6250),
    [anon_sym_BSLASHBigl] = ACTIONS(6250),
    [anon_sym_BSLASHbiggl] = ACTIONS(6250),
    [anon_sym_BSLASHBiggl] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHtext] = ACTIONS(6250),
    [anon_sym_BSLASHintertext] = ACTIONS(6250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
  [960] = {
    [ts_builtin_sym_end] = ACTIONS(6448),
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6448),
    [anon_sym_RBRACK] = ACTIONS(6448),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(6448),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHpart] = ACTIONS(6446),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddpart] = ACTIONS(6446),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHchapter] = ACTIONS(6446),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddchap] = ACTIONS(6446),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsection] = ACTIONS(6446),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddsec] = ACTIONS(6446),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHitem] = ACTIONS(6446),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6448),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [anon_sym_RBRACE] = ACTIONS(6448),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6448),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6448),
    [anon_sym_DOLLAR] = ACTIONS(6446),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHbegin] = ACTIONS(6446),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHleft] = ACTIONS(6446),
    [anon_sym_BSLASHbigl] = ACTIONS(6446),
    [anon_sym_BSLASHBigl] = ACTIONS(6446),
    [anon_sym_BSLASHbiggl] = ACTIONS(6446),
    [anon_sym_BSLASHBiggl] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHtext] = ACTIONS(6446),
    [anon_sym_BSLASHintertext] = ACTIONS(6446),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [961] = {
    [ts_builtin_sym_end] = ACTIONS(6244),
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6244),
    [anon_sym_RBRACK] = ACTIONS(6244),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_LPAREN] = ACTIONS(6244),
    [anon_sym_RPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHpart] = ACTIONS(6242),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddpart] = ACTIONS(6242),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHchapter] = ACTIONS(6242),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddchap] = ACTIONS(6242),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsection] = ACTIONS(6242),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddsec] = ACTIONS(6242),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHitem] = ACTIONS(6242),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6244),
    [anon_sym_LBRACE] = ACTIONS(6244),
    [anon_sym_RBRACE] = ACTIONS(6244),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6244),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6244),
    [anon_sym_DOLLAR] = ACTIONS(6242),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHbegin] = ACTIONS(6242),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHleft] = ACTIONS(6242),
    [anon_sym_BSLASHbigl] = ACTIONS(6242),
    [anon_sym_BSLASHBigl] = ACTIONS(6242),
    [anon_sym_BSLASHbiggl] = ACTIONS(6242),
    [anon_sym_BSLASHBiggl] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHtext] = ACTIONS(6242),
    [anon_sym_BSLASHintertext] = ACTIONS(6242),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [962] = {
    [ts_builtin_sym_end] = ACTIONS(6240),
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6240),
    [anon_sym_RBRACK] = ACTIONS(6240),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_LPAREN] = ACTIONS(6240),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHpart] = ACTIONS(6238),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddpart] = ACTIONS(6238),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHchapter] = ACTIONS(6238),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddchap] = ACTIONS(6238),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsection] = ACTIONS(6238),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddsec] = ACTIONS(6238),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHitem] = ACTIONS(6238),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(6240),
    [anon_sym_RBRACE] = ACTIONS(6240),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6240),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6240),
    [anon_sym_DOLLAR] = ACTIONS(6238),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHbegin] = ACTIONS(6238),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHleft] = ACTIONS(6238),
    [anon_sym_BSLASHbigl] = ACTIONS(6238),
    [anon_sym_BSLASHBigl] = ACTIONS(6238),
    [anon_sym_BSLASHbiggl] = ACTIONS(6238),
    [anon_sym_BSLASHBiggl] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHtext] = ACTIONS(6238),
    [anon_sym_BSLASHintertext] = ACTIONS(6238),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [963] = {
    [ts_builtin_sym_end] = ACTIONS(6236),
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_LPAREN] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHpart] = ACTIONS(6234),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddpart] = ACTIONS(6234),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHchapter] = ACTIONS(6234),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddchap] = ACTIONS(6234),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsection] = ACTIONS(6234),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddsec] = ACTIONS(6234),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHitem] = ACTIONS(6234),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6236),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(6234),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHbegin] = ACTIONS(6234),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHleft] = ACTIONS(6234),
    [anon_sym_BSLASHbigl] = ACTIONS(6234),
    [anon_sym_BSLASHBigl] = ACTIONS(6234),
    [anon_sym_BSLASHbiggl] = ACTIONS(6234),
    [anon_sym_BSLASHBiggl] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHtext] = ACTIONS(6234),
    [anon_sym_BSLASHintertext] = ACTIONS(6234),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [964] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2418),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7063),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [965] = {
    [ts_builtin_sym_end] = ACTIONS(6232),
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6232),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6232),
    [anon_sym_LPAREN] = ACTIONS(6232),
    [anon_sym_RPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHpart] = ACTIONS(6230),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddpart] = ACTIONS(6230),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHchapter] = ACTIONS(6230),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddchap] = ACTIONS(6230),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsection] = ACTIONS(6230),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddsec] = ACTIONS(6230),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHitem] = ACTIONS(6230),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [anon_sym_RBRACE] = ACTIONS(6232),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6232),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6232),
    [anon_sym_DOLLAR] = ACTIONS(6230),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHbegin] = ACTIONS(6230),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHleft] = ACTIONS(6230),
    [anon_sym_BSLASHbigl] = ACTIONS(6230),
    [anon_sym_BSLASHBigl] = ACTIONS(6230),
    [anon_sym_BSLASHbiggl] = ACTIONS(6230),
    [anon_sym_BSLASHBiggl] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHtext] = ACTIONS(6230),
    [anon_sym_BSLASHintertext] = ACTIONS(6230),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [966] = {
    [ts_builtin_sym_end] = ACTIONS(6228),
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6228),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_LPAREN] = ACTIONS(6228),
    [anon_sym_RPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHpart] = ACTIONS(6226),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddpart] = ACTIONS(6226),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHchapter] = ACTIONS(6226),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddchap] = ACTIONS(6226),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsection] = ACTIONS(6226),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddsec] = ACTIONS(6226),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHitem] = ACTIONS(6226),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(6228),
    [anon_sym_RBRACE] = ACTIONS(6228),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6228),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(6226),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHbegin] = ACTIONS(6226),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHleft] = ACTIONS(6226),
    [anon_sym_BSLASHbigl] = ACTIONS(6226),
    [anon_sym_BSLASHBigl] = ACTIONS(6226),
    [anon_sym_BSLASHbiggl] = ACTIONS(6226),
    [anon_sym_BSLASHBiggl] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHtext] = ACTIONS(6226),
    [anon_sym_BSLASHintertext] = ACTIONS(6226),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [967] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2385),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7065),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [968] = {
    [sym_curly_group] = STATE(1409),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(6164),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHpart] = ACTIONS(6162),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddpart] = ACTIONS(6162),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHchapter] = ACTIONS(6162),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddchap] = ACTIONS(6162),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsection] = ACTIONS(6162),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddsec] = ACTIONS(6162),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHitem] = ACTIONS(6162),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6164),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6164),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6164),
    [anon_sym_DOLLAR] = ACTIONS(6162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHbegin] = ACTIONS(6162),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHleft] = ACTIONS(6162),
    [anon_sym_BSLASHbigl] = ACTIONS(6162),
    [anon_sym_BSLASHBigl] = ACTIONS(6162),
    [anon_sym_BSLASHbiggl] = ACTIONS(6162),
    [anon_sym_BSLASHBiggl] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHtext] = ACTIONS(6162),
    [anon_sym_BSLASHintertext] = ACTIONS(6162),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [969] = {
    [ts_builtin_sym_end] = ACTIONS(6392),
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_COMMA] = ACTIONS(6392),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHpart] = ACTIONS(6390),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddpart] = ACTIONS(6390),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHchapter] = ACTIONS(6390),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddchap] = ACTIONS(6390),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsection] = ACTIONS(6390),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddsec] = ACTIONS(6390),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHitem] = ACTIONS(6390),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [anon_sym_RBRACE] = ACTIONS(6392),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6392),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(6390),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHbegin] = ACTIONS(6390),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHleft] = ACTIONS(6390),
    [anon_sym_BSLASHbigl] = ACTIONS(6390),
    [anon_sym_BSLASHBigl] = ACTIONS(6390),
    [anon_sym_BSLASHbiggl] = ACTIONS(6390),
    [anon_sym_BSLASHBiggl] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHtext] = ACTIONS(6390),
    [anon_sym_BSLASHintertext] = ACTIONS(6390),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [970] = {
    [ts_builtin_sym_end] = ACTIONS(6204),
    [sym_command_name] = ACTIONS(6202),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6202),
    [anon_sym_LBRACK] = ACTIONS(6204),
    [anon_sym_RBRACK] = ACTIONS(6204),
    [anon_sym_COMMA] = ACTIONS(6204),
    [anon_sym_EQ] = ACTIONS(6204),
    [anon_sym_LPAREN] = ACTIONS(6204),
    [anon_sym_RPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHpart] = ACTIONS(6202),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddpart] = ACTIONS(6202),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHchapter] = ACTIONS(6202),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddchap] = ACTIONS(6202),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsection] = ACTIONS(6202),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddsec] = ACTIONS(6202),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHitem] = ACTIONS(6202),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6204),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [anon_sym_RBRACE] = ACTIONS(6204),
    [sym_word] = ACTIONS(6202),
    [sym_placeholder] = ACTIONS(6204),
    [anon_sym_PLUS] = ACTIONS(6204),
    [anon_sym_DASH] = ACTIONS(6204),
    [anon_sym_STAR] = ACTIONS(6204),
    [anon_sym_SLASH] = ACTIONS(6204),
    [anon_sym_LT] = ACTIONS(6202),
    [anon_sym_GT] = ACTIONS(6202),
    [anon_sym_BANG] = ACTIONS(6202),
    [anon_sym_PIPE] = ACTIONS(6202),
    [anon_sym_COLON] = ACTIONS(6202),
    [anon_sym_SQUOTE] = ACTIONS(6202),
    [anon_sym__] = ACTIONS(6204),
    [anon_sym_CARET] = ACTIONS(6204),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6204),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6204),
    [anon_sym_DOLLAR] = ACTIONS(6202),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHbegin] = ACTIONS(6202),
    [anon_sym_BSLASHtitle] = ACTIONS(6202),
    [anon_sym_BSLASHauthor] = ACTIONS(6202),
    [anon_sym_BSLASHusepackage] = ACTIONS(6202),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6202),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6202),
    [anon_sym_BSLASHinclude] = ACTIONS(6202),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6202),
    [anon_sym_BSLASHinput] = ACTIONS(6202),
    [anon_sym_BSLASHsubfile] = ACTIONS(6202),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6202),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6202),
    [anon_sym_BSLASHbibliography] = ACTIONS(6202),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6202),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6202),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6202),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6202),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6202),
    [anon_sym_BSLASHimport] = ACTIONS(6202),
    [anon_sym_BSLASHsubimport] = ACTIONS(6202),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6202),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHcaption] = ACTIONS(6202),
    [anon_sym_BSLASHcite] = ACTIONS(6202),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCite] = ACTIONS(6202),
    [anon_sym_BSLASHnocite] = ACTIONS(6202),
    [anon_sym_BSLASHcitet] = ACTIONS(6202),
    [anon_sym_BSLASHcitep] = ACTIONS(6202),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteA] = ACTIONS(6202),
    [anon_sym_BSLASHciteR] = ACTIONS(6202),
    [anon_sym_BSLASHciteS] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6202),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteyear] = ACTIONS(6202),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitedate] = ACTIONS(6202),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteurl] = ACTIONS(6202),
    [anon_sym_BSLASHfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6202),
    [anon_sym_BSLASHcitealt] = ACTIONS(6202),
    [anon_sym_BSLASHcitealp] = ACTIONS(6202),
    [anon_sym_BSLASHcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHparencite] = ACTIONS(6202),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHParencite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHtextcite] = ACTIONS(6202),
    [anon_sym_BSLASHTextcite] = ACTIONS(6202),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHsupercite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite] = ACTIONS(6202),
    [anon_sym_BSLASHAutocite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHVolcite] = ACTIONS(6202),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHavolcite] = ACTIONS(6202),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHNotecite] = ACTIONS(6202),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHlabel] = ACTIONS(6202),
    [anon_sym_BSLASHref] = ACTIONS(6202),
    [anon_sym_BSLASHeqref] = ACTIONS(6202),
    [anon_sym_BSLASHvref] = ACTIONS(6202),
    [anon_sym_BSLASHVref] = ACTIONS(6202),
    [anon_sym_BSLASHautoref] = ACTIONS(6202),
    [anon_sym_BSLASHpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcref] = ACTIONS(6202),
    [anon_sym_BSLASHCref] = ACTIONS(6202),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnameCref] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHdef] = ACTIONS(6202),
    [anon_sym_BSLASHlet] = ACTIONS(6202),
    [anon_sym_BSLASHleft] = ACTIONS(6202),
    [anon_sym_BSLASHbigl] = ACTIONS(6202),
    [anon_sym_BSLASHBigl] = ACTIONS(6202),
    [anon_sym_BSLASHbiggl] = ACTIONS(6202),
    [anon_sym_BSLASHBiggl] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6202),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6202),
    [anon_sym_BSLASHgls] = ACTIONS(6202),
    [anon_sym_BSLASHGls] = ACTIONS(6202),
    [anon_sym_BSLASHGLS] = ACTIONS(6202),
    [anon_sym_BSLASHglspl] = ACTIONS(6202),
    [anon_sym_BSLASHGlspl] = ACTIONS(6202),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6202),
    [anon_sym_BSLASHglslink] = ACTIONS(6202),
    [anon_sym_BSLASHglstext] = ACTIONS(6202),
    [anon_sym_BSLASHGlstext] = ACTIONS(6202),
    [anon_sym_BSLASHGLStext] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6202),
    [anon_sym_BSLASHglsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsname] = ACTIONS(6202),
    [anon_sym_BSLASHGlsname] = ACTIONS(6202),
    [anon_sym_BSLASHGLSname] = ACTIONS(6202),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6202),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6202),
    [anon_sym_BSLASHacrshort] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6202),
    [anon_sym_BSLASHACRshort] = ACTIONS(6202),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrlong] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6202),
    [anon_sym_BSLASHACRlong] = ACTIONS(6202),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrfull] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6202),
    [anon_sym_BSLASHACRfull] = ACTIONS(6202),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHacs] = ACTIONS(6202),
    [anon_sym_BSLASHAcs] = ACTIONS(6202),
    [anon_sym_BSLASHacsp] = ACTIONS(6202),
    [anon_sym_BSLASHAcsp] = ACTIONS(6202),
    [anon_sym_BSLASHacl] = ACTIONS(6202),
    [anon_sym_BSLASHAcl] = ACTIONS(6202),
    [anon_sym_BSLASHaclp] = ACTIONS(6202),
    [anon_sym_BSLASHAclp] = ACTIONS(6202),
    [anon_sym_BSLASHacf] = ACTIONS(6202),
    [anon_sym_BSLASHAcf] = ACTIONS(6202),
    [anon_sym_BSLASHacfp] = ACTIONS(6202),
    [anon_sym_BSLASHAcfp] = ACTIONS(6202),
    [anon_sym_BSLASHac] = ACTIONS(6202),
    [anon_sym_BSLASHAc] = ACTIONS(6202),
    [anon_sym_BSLASHacp] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6202),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6202),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6202),
    [anon_sym_BSLASHcolor] = ACTIONS(6202),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6202),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6202),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6202),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6202),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6202),
    [anon_sym_BSLASHtext] = ACTIONS(6202),
    [anon_sym_BSLASHintertext] = ACTIONS(6202),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6202),
    [anon_sym_BSLASHurl] = ACTIONS(6202),
    [anon_sym_BSLASHhref] = ACTIONS(6202),
  },
  [971] = {
    [ts_builtin_sym_end] = ACTIONS(6220),
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6220),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHpart] = ACTIONS(6218),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddpart] = ACTIONS(6218),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHchapter] = ACTIONS(6218),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddchap] = ACTIONS(6218),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsection] = ACTIONS(6218),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddsec] = ACTIONS(6218),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHitem] = ACTIONS(6218),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [anon_sym_RBRACE] = ACTIONS(6220),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6220),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6220),
    [anon_sym_DOLLAR] = ACTIONS(6218),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHbegin] = ACTIONS(6218),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHleft] = ACTIONS(6218),
    [anon_sym_BSLASHbigl] = ACTIONS(6218),
    [anon_sym_BSLASHBigl] = ACTIONS(6218),
    [anon_sym_BSLASHbiggl] = ACTIONS(6218),
    [anon_sym_BSLASHBiggl] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHtext] = ACTIONS(6218),
    [anon_sym_BSLASHintertext] = ACTIONS(6218),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [972] = {
    [sym_curly_group] = STATE(1130),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHpart] = ACTIONS(6152),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddpart] = ACTIONS(6152),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHchapter] = ACTIONS(6152),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddchap] = ACTIONS(6152),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsection] = ACTIONS(6152),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHaddsec] = ACTIONS(6152),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6152),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6152),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHitem] = ACTIONS(6152),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6154),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6154),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHbegin] = ACTIONS(6152),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHleft] = ACTIONS(6152),
    [anon_sym_BSLASHbigl] = ACTIONS(6152),
    [anon_sym_BSLASHBigl] = ACTIONS(6152),
    [anon_sym_BSLASHbiggl] = ACTIONS(6152),
    [anon_sym_BSLASHBiggl] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHtext] = ACTIONS(6152),
    [anon_sym_BSLASHintertext] = ACTIONS(6152),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [973] = {
    [sym_brack_group] = STATE(1459),
    [sym_command_name] = ACTIONS(7067),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7067),
    [anon_sym_LBRACK] = ACTIONS(7069),
    [anon_sym_RBRACK] = ACTIONS(7071),
    [anon_sym_COMMA] = ACTIONS(7071),
    [anon_sym_EQ] = ACTIONS(7071),
    [anon_sym_LPAREN] = ACTIONS(7071),
    [anon_sym_RPAREN] = ACTIONS(7071),
    [anon_sym_BSLASHpart] = ACTIONS(7067),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHaddpart] = ACTIONS(7067),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHchapter] = ACTIONS(7067),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHaddchap] = ACTIONS(7067),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHsection] = ACTIONS(7067),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHaddsec] = ACTIONS(7067),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHsubsection] = ACTIONS(7067),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(7067),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHparagraph] = ACTIONS(7067),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(7067),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHitem] = ACTIONS(7067),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(7071),
    [anon_sym_LBRACE] = ACTIONS(7071),
    [sym_word] = ACTIONS(7067),
    [sym_placeholder] = ACTIONS(7071),
    [anon_sym_PLUS] = ACTIONS(7071),
    [anon_sym_DASH] = ACTIONS(7071),
    [anon_sym_STAR] = ACTIONS(7071),
    [anon_sym_SLASH] = ACTIONS(7071),
    [anon_sym_LT] = ACTIONS(7067),
    [anon_sym_GT] = ACTIONS(7067),
    [anon_sym_BANG] = ACTIONS(7067),
    [anon_sym_PIPE] = ACTIONS(7067),
    [anon_sym_COLON] = ACTIONS(7067),
    [anon_sym_SQUOTE] = ACTIONS(7067),
    [anon_sym__] = ACTIONS(7071),
    [anon_sym_CARET] = ACTIONS(7071),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7071),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7071),
    [anon_sym_DOLLAR] = ACTIONS(7067),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7071),
    [anon_sym_BSLASHbegin] = ACTIONS(7067),
    [anon_sym_BSLASHend] = ACTIONS(7067),
    [anon_sym_BSLASHtitle] = ACTIONS(7067),
    [anon_sym_BSLASHauthor] = ACTIONS(7067),
    [anon_sym_BSLASHusepackage] = ACTIONS(7067),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7067),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7067),
    [anon_sym_BSLASHinclude] = ACTIONS(7067),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7067),
    [anon_sym_BSLASHinput] = ACTIONS(7067),
    [anon_sym_BSLASHsubfile] = ACTIONS(7067),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7067),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7067),
    [anon_sym_BSLASHbibliography] = ACTIONS(7067),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7067),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7067),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7067),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7067),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7067),
    [anon_sym_BSLASHimport] = ACTIONS(7067),
    [anon_sym_BSLASHsubimport] = ACTIONS(7067),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7067),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7067),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7067),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7067),
    [anon_sym_BSLASHcaption] = ACTIONS(7067),
    [anon_sym_BSLASHcite] = ACTIONS(7067),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHCite] = ACTIONS(7067),
    [anon_sym_BSLASHnocite] = ACTIONS(7067),
    [anon_sym_BSLASHcitet] = ACTIONS(7067),
    [anon_sym_BSLASHcitep] = ACTIONS(7067),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHciteA] = ACTIONS(7067),
    [anon_sym_BSLASHciteR] = ACTIONS(7067),
    [anon_sym_BSLASHciteS] = ACTIONS(7067),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7067),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7067),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7067),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7067),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHciteyear] = ACTIONS(7067),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHcitedate] = ACTIONS(7067),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHciteurl] = ACTIONS(7067),
    [anon_sym_BSLASHfullcite] = ACTIONS(7067),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7067),
    [anon_sym_BSLASHcitealt] = ACTIONS(7067),
    [anon_sym_BSLASHcitealp] = ACTIONS(7067),
    [anon_sym_BSLASHcitetext] = ACTIONS(7067),
    [anon_sym_BSLASHparencite] = ACTIONS(7067),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHParencite] = ACTIONS(7067),
    [anon_sym_BSLASHfootcite] = ACTIONS(7067),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7067),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7067),
    [anon_sym_BSLASHtextcite] = ACTIONS(7067),
    [anon_sym_BSLASHTextcite] = ACTIONS(7067),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7067),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7067),
    [anon_sym_BSLASHsupercite] = ACTIONS(7067),
    [anon_sym_BSLASHautocite] = ACTIONS(7067),
    [anon_sym_BSLASHAutocite] = ACTIONS(7067),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHVolcite] = ACTIONS(7067),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHavolcite] = ACTIONS(7067),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7067),
    [anon_sym_BSLASHnotecite] = ACTIONS(7067),
    [anon_sym_BSLASHNotecite] = ACTIONS(7067),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7067),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7067),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7067),
    [anon_sym_BSLASHlabel] = ACTIONS(7067),
    [anon_sym_BSLASHref] = ACTIONS(7067),
    [anon_sym_BSLASHeqref] = ACTIONS(7067),
    [anon_sym_BSLASHvref] = ACTIONS(7067),
    [anon_sym_BSLASHVref] = ACTIONS(7067),
    [anon_sym_BSLASHautoref] = ACTIONS(7067),
    [anon_sym_BSLASHpageref] = ACTIONS(7067),
    [anon_sym_BSLASHcref] = ACTIONS(7067),
    [anon_sym_BSLASHCref] = ACTIONS(7067),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHnamecref] = ACTIONS(7067),
    [anon_sym_BSLASHnameCref] = ACTIONS(7067),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7067),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7067),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7067),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7067),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7067),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7067),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7067),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7067),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7067),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7067),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7067),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7067),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7067),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7067),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7067),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7067),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7067),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7067),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7067),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7067),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7067),
    [anon_sym_BSLASHdef] = ACTIONS(7067),
    [anon_sym_BSLASHlet] = ACTIONS(7067),
    [anon_sym_BSLASHleft] = ACTIONS(7067),
    [anon_sym_BSLASHbigl] = ACTIONS(7067),
    [anon_sym_BSLASHBigl] = ACTIONS(7067),
    [anon_sym_BSLASHbiggl] = ACTIONS(7067),
    [anon_sym_BSLASHBiggl] = ACTIONS(7067),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7067),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7067),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7067),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7067),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7067),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7067),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7067),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7067),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7067),
    [anon_sym_BSLASHgls] = ACTIONS(7067),
    [anon_sym_BSLASHGls] = ACTIONS(7067),
    [anon_sym_BSLASHGLS] = ACTIONS(7067),
    [anon_sym_BSLASHglspl] = ACTIONS(7067),
    [anon_sym_BSLASHGlspl] = ACTIONS(7067),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7067),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7067),
    [anon_sym_BSLASHglslink] = ACTIONS(7067),
    [anon_sym_BSLASHglstext] = ACTIONS(7067),
    [anon_sym_BSLASHGlstext] = ACTIONS(7067),
    [anon_sym_BSLASHGLStext] = ACTIONS(7067),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7067),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7067),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7067),
    [anon_sym_BSLASHglsplural] = ACTIONS(7067),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7067),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7067),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7067),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7067),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7067),
    [anon_sym_BSLASHglsname] = ACTIONS(7067),
    [anon_sym_BSLASHGlsname] = ACTIONS(7067),
    [anon_sym_BSLASHGLSname] = ACTIONS(7067),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7067),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7067),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7067),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7067),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7067),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7067),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7067),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7067),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7067),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7067),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7067),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7067),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7067),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7067),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7067),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7067),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7067),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7067),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7067),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7067),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7067),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7067),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7067),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7067),
    [anon_sym_BSLASHacrshort] = ACTIONS(7067),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7067),
    [anon_sym_BSLASHACRshort] = ACTIONS(7067),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7067),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7067),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7067),
    [anon_sym_BSLASHacrlong] = ACTIONS(7067),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7067),
    [anon_sym_BSLASHACRlong] = ACTIONS(7067),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7067),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7067),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7067),
    [anon_sym_BSLASHacrfull] = ACTIONS(7067),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7067),
    [anon_sym_BSLASHACRfull] = ACTIONS(7067),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7067),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7067),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7067),
    [anon_sym_BSLASHacs] = ACTIONS(7067),
    [anon_sym_BSLASHAcs] = ACTIONS(7067),
    [anon_sym_BSLASHacsp] = ACTIONS(7067),
    [anon_sym_BSLASHAcsp] = ACTIONS(7067),
    [anon_sym_BSLASHacl] = ACTIONS(7067),
    [anon_sym_BSLASHAcl] = ACTIONS(7067),
    [anon_sym_BSLASHaclp] = ACTIONS(7067),
    [anon_sym_BSLASHAclp] = ACTIONS(7067),
    [anon_sym_BSLASHacf] = ACTIONS(7067),
    [anon_sym_BSLASHAcf] = ACTIONS(7067),
    [anon_sym_BSLASHacfp] = ACTIONS(7067),
    [anon_sym_BSLASHAcfp] = ACTIONS(7067),
    [anon_sym_BSLASHac] = ACTIONS(7067),
    [anon_sym_BSLASHAc] = ACTIONS(7067),
    [anon_sym_BSLASHacp] = ACTIONS(7067),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7067),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7067),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7067),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7067),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7067),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7067),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7067),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7067),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7067),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7067),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7067),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7067),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7071),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7067),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7067),
    [anon_sym_BSLASHcolor] = ACTIONS(7067),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7067),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7067),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7067),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7067),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7067),
    [anon_sym_BSLASHtext] = ACTIONS(7067),
    [anon_sym_BSLASHintertext] = ACTIONS(7067),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7067),
    [anon_sym_BSLASHurl] = ACTIONS(7067),
    [anon_sym_BSLASHhref] = ACTIONS(7067),
  },
  [974] = {
    [ts_builtin_sym_end] = ACTIONS(6196),
    [sym_command_name] = ACTIONS(6194),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_RBRACK] = ACTIONS(6196),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_EQ] = ACTIONS(6196),
    [anon_sym_LPAREN] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHpart] = ACTIONS(6194),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddpart] = ACTIONS(6194),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHchapter] = ACTIONS(6194),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddchap] = ACTIONS(6194),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsection] = ACTIONS(6194),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddsec] = ACTIONS(6194),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHitem] = ACTIONS(6194),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [sym_word] = ACTIONS(6194),
    [sym_placeholder] = ACTIONS(6196),
    [anon_sym_PLUS] = ACTIONS(6196),
    [anon_sym_DASH] = ACTIONS(6196),
    [anon_sym_STAR] = ACTIONS(6196),
    [anon_sym_SLASH] = ACTIONS(6196),
    [anon_sym_LT] = ACTIONS(6194),
    [anon_sym_GT] = ACTIONS(6194),
    [anon_sym_BANG] = ACTIONS(6194),
    [anon_sym_PIPE] = ACTIONS(6194),
    [anon_sym_COLON] = ACTIONS(6194),
    [anon_sym_SQUOTE] = ACTIONS(6194),
    [anon_sym__] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6196),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6196),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6196),
    [anon_sym_DOLLAR] = ACTIONS(6194),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHbegin] = ACTIONS(6194),
    [anon_sym_BSLASHtitle] = ACTIONS(6194),
    [anon_sym_BSLASHauthor] = ACTIONS(6194),
    [anon_sym_BSLASHusepackage] = ACTIONS(6194),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6194),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6194),
    [anon_sym_BSLASHinclude] = ACTIONS(6194),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6194),
    [anon_sym_BSLASHinput] = ACTIONS(6194),
    [anon_sym_BSLASHsubfile] = ACTIONS(6194),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6194),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6194),
    [anon_sym_BSLASHbibliography] = ACTIONS(6194),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6194),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6194),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6194),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6194),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6194),
    [anon_sym_BSLASHimport] = ACTIONS(6194),
    [anon_sym_BSLASHsubimport] = ACTIONS(6194),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6194),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHcaption] = ACTIONS(6194),
    [anon_sym_BSLASHcite] = ACTIONS(6194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCite] = ACTIONS(6194),
    [anon_sym_BSLASHnocite] = ACTIONS(6194),
    [anon_sym_BSLASHcitet] = ACTIONS(6194),
    [anon_sym_BSLASHcitep] = ACTIONS(6194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteA] = ACTIONS(6194),
    [anon_sym_BSLASHciteR] = ACTIONS(6194),
    [anon_sym_BSLASHciteS] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteyear] = ACTIONS(6194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitedate] = ACTIONS(6194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteurl] = ACTIONS(6194),
    [anon_sym_BSLASHfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6194),
    [anon_sym_BSLASHcitealt] = ACTIONS(6194),
    [anon_sym_BSLASHcitealp] = ACTIONS(6194),
    [anon_sym_BSLASHcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHparencite] = ACTIONS(6194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHParencite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHtextcite] = ACTIONS(6194),
    [anon_sym_BSLASHTextcite] = ACTIONS(6194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHsupercite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite] = ACTIONS(6194),
    [anon_sym_BSLASHAutocite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHVolcite] = ACTIONS(6194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHavolcite] = ACTIONS(6194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHNotecite] = ACTIONS(6194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHlabel] = ACTIONS(6194),
    [anon_sym_BSLASHref] = ACTIONS(6194),
    [anon_sym_BSLASHeqref] = ACTIONS(6194),
    [anon_sym_BSLASHvref] = ACTIONS(6194),
    [anon_sym_BSLASHVref] = ACTIONS(6194),
    [anon_sym_BSLASHautoref] = ACTIONS(6194),
    [anon_sym_BSLASHpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcref] = ACTIONS(6194),
    [anon_sym_BSLASHCref] = ACTIONS(6194),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnameCref] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHdef] = ACTIONS(6194),
    [anon_sym_BSLASHlet] = ACTIONS(6194),
    [anon_sym_BSLASHleft] = ACTIONS(6194),
    [anon_sym_BSLASHbigl] = ACTIONS(6194),
    [anon_sym_BSLASHBigl] = ACTIONS(6194),
    [anon_sym_BSLASHbiggl] = ACTIONS(6194),
    [anon_sym_BSLASHBiggl] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6194),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6194),
    [anon_sym_BSLASHgls] = ACTIONS(6194),
    [anon_sym_BSLASHGls] = ACTIONS(6194),
    [anon_sym_BSLASHGLS] = ACTIONS(6194),
    [anon_sym_BSLASHglspl] = ACTIONS(6194),
    [anon_sym_BSLASHGlspl] = ACTIONS(6194),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6194),
    [anon_sym_BSLASHglslink] = ACTIONS(6194),
    [anon_sym_BSLASHglstext] = ACTIONS(6194),
    [anon_sym_BSLASHGlstext] = ACTIONS(6194),
    [anon_sym_BSLASHGLStext] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6194),
    [anon_sym_BSLASHglsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsname] = ACTIONS(6194),
    [anon_sym_BSLASHGlsname] = ACTIONS(6194),
    [anon_sym_BSLASHGLSname] = ACTIONS(6194),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6194),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6194),
    [anon_sym_BSLASHacrshort] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6194),
    [anon_sym_BSLASHACRshort] = ACTIONS(6194),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrlong] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6194),
    [anon_sym_BSLASHACRlong] = ACTIONS(6194),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrfull] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6194),
    [anon_sym_BSLASHACRfull] = ACTIONS(6194),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHacs] = ACTIONS(6194),
    [anon_sym_BSLASHAcs] = ACTIONS(6194),
    [anon_sym_BSLASHacsp] = ACTIONS(6194),
    [anon_sym_BSLASHAcsp] = ACTIONS(6194),
    [anon_sym_BSLASHacl] = ACTIONS(6194),
    [anon_sym_BSLASHAcl] = ACTIONS(6194),
    [anon_sym_BSLASHaclp] = ACTIONS(6194),
    [anon_sym_BSLASHAclp] = ACTIONS(6194),
    [anon_sym_BSLASHacf] = ACTIONS(6194),
    [anon_sym_BSLASHAcf] = ACTIONS(6194),
    [anon_sym_BSLASHacfp] = ACTIONS(6194),
    [anon_sym_BSLASHAcfp] = ACTIONS(6194),
    [anon_sym_BSLASHac] = ACTIONS(6194),
    [anon_sym_BSLASHAc] = ACTIONS(6194),
    [anon_sym_BSLASHacp] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6194),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6194),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6194),
    [anon_sym_BSLASHcolor] = ACTIONS(6194),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6194),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6194),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6194),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6194),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6194),
    [anon_sym_BSLASHtext] = ACTIONS(6194),
    [anon_sym_BSLASHintertext] = ACTIONS(6194),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6194),
    [anon_sym_BSLASHurl] = ACTIONS(6194),
    [anon_sym_BSLASHhref] = ACTIONS(6194),
  },
  [975] = {
    [ts_builtin_sym_end] = ACTIONS(6200),
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [anon_sym_RPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHpart] = ACTIONS(6198),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddpart] = ACTIONS(6198),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHchapter] = ACTIONS(6198),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddchap] = ACTIONS(6198),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsection] = ACTIONS(6198),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddsec] = ACTIONS(6198),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHitem] = ACTIONS(6198),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [anon_sym_RBRACE] = ACTIONS(6200),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6200),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6200),
    [anon_sym_DOLLAR] = ACTIONS(6198),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHbegin] = ACTIONS(6198),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHleft] = ACTIONS(6198),
    [anon_sym_BSLASHbigl] = ACTIONS(6198),
    [anon_sym_BSLASHBigl] = ACTIONS(6198),
    [anon_sym_BSLASHbiggl] = ACTIONS(6198),
    [anon_sym_BSLASHBiggl] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHtext] = ACTIONS(6198),
    [anon_sym_BSLASHintertext] = ACTIONS(6198),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [976] = {
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(7073),
    [anon_sym_LBRACK] = ACTIONS(6160),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHpart] = ACTIONS(6156),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddpart] = ACTIONS(6156),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHchapter] = ACTIONS(6156),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddchap] = ACTIONS(6156),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsection] = ACTIONS(6156),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddsec] = ACTIONS(6156),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHitem] = ACTIONS(6156),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6160),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6160),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(6156),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHbegin] = ACTIONS(6156),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHleft] = ACTIONS(6156),
    [anon_sym_BSLASHbigl] = ACTIONS(6156),
    [anon_sym_BSLASHBigl] = ACTIONS(6156),
    [anon_sym_BSLASHbiggl] = ACTIONS(6156),
    [anon_sym_BSLASHBiggl] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHtext] = ACTIONS(6156),
    [anon_sym_BSLASHintertext] = ACTIONS(6156),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [977] = {
    [ts_builtin_sym_end] = ACTIONS(6432),
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHpart] = ACTIONS(6430),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddpart] = ACTIONS(6430),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHchapter] = ACTIONS(6430),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddchap] = ACTIONS(6430),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsection] = ACTIONS(6430),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddsec] = ACTIONS(6430),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHitem] = ACTIONS(6430),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6432),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [anon_sym_RBRACE] = ACTIONS(6432),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6432),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6432),
    [anon_sym_DOLLAR] = ACTIONS(6430),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHbegin] = ACTIONS(6430),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHleft] = ACTIONS(6430),
    [anon_sym_BSLASHbigl] = ACTIONS(6430),
    [anon_sym_BSLASHBigl] = ACTIONS(6430),
    [anon_sym_BSLASHbiggl] = ACTIONS(6430),
    [anon_sym_BSLASHBiggl] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHtext] = ACTIONS(6430),
    [anon_sym_BSLASHintertext] = ACTIONS(6430),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [978] = {
    [ts_builtin_sym_end] = ACTIONS(6492),
    [sym_command_name] = ACTIONS(6490),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6490),
    [anon_sym_LBRACK] = ACTIONS(6492),
    [anon_sym_RBRACK] = ACTIONS(6492),
    [anon_sym_COMMA] = ACTIONS(6492),
    [anon_sym_EQ] = ACTIONS(6492),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [anon_sym_RPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHpart] = ACTIONS(6490),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddpart] = ACTIONS(6490),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHchapter] = ACTIONS(6490),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddchap] = ACTIONS(6490),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsection] = ACTIONS(6490),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddsec] = ACTIONS(6490),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHitem] = ACTIONS(6490),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6492),
    [anon_sym_LBRACE] = ACTIONS(6492),
    [anon_sym_RBRACE] = ACTIONS(6492),
    [sym_word] = ACTIONS(6490),
    [sym_placeholder] = ACTIONS(6492),
    [anon_sym_PLUS] = ACTIONS(6492),
    [anon_sym_DASH] = ACTIONS(6492),
    [anon_sym_STAR] = ACTIONS(6492),
    [anon_sym_SLASH] = ACTIONS(6492),
    [anon_sym_LT] = ACTIONS(6490),
    [anon_sym_GT] = ACTIONS(6490),
    [anon_sym_BANG] = ACTIONS(6490),
    [anon_sym_PIPE] = ACTIONS(6490),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_SQUOTE] = ACTIONS(6490),
    [anon_sym__] = ACTIONS(6492),
    [anon_sym_CARET] = ACTIONS(6492),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6492),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6492),
    [anon_sym_DOLLAR] = ACTIONS(6490),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHbegin] = ACTIONS(6490),
    [anon_sym_BSLASHtitle] = ACTIONS(6490),
    [anon_sym_BSLASHauthor] = ACTIONS(6490),
    [anon_sym_BSLASHusepackage] = ACTIONS(6490),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6490),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6490),
    [anon_sym_BSLASHinclude] = ACTIONS(6490),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6490),
    [anon_sym_BSLASHinput] = ACTIONS(6490),
    [anon_sym_BSLASHsubfile] = ACTIONS(6490),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6490),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6490),
    [anon_sym_BSLASHbibliography] = ACTIONS(6490),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6490),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6490),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6490),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6490),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6490),
    [anon_sym_BSLASHimport] = ACTIONS(6490),
    [anon_sym_BSLASHsubimport] = ACTIONS(6490),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6490),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHcaption] = ACTIONS(6490),
    [anon_sym_BSLASHcite] = ACTIONS(6490),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCite] = ACTIONS(6490),
    [anon_sym_BSLASHnocite] = ACTIONS(6490),
    [anon_sym_BSLASHcitet] = ACTIONS(6490),
    [anon_sym_BSLASHcitep] = ACTIONS(6490),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteA] = ACTIONS(6490),
    [anon_sym_BSLASHciteR] = ACTIONS(6490),
    [anon_sym_BSLASHciteS] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6490),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteyear] = ACTIONS(6490),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitedate] = ACTIONS(6490),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteurl] = ACTIONS(6490),
    [anon_sym_BSLASHfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6490),
    [anon_sym_BSLASHcitealt] = ACTIONS(6490),
    [anon_sym_BSLASHcitealp] = ACTIONS(6490),
    [anon_sym_BSLASHcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHparencite] = ACTIONS(6490),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHParencite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHtextcite] = ACTIONS(6490),
    [anon_sym_BSLASHTextcite] = ACTIONS(6490),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHsupercite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite] = ACTIONS(6490),
    [anon_sym_BSLASHAutocite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHVolcite] = ACTIONS(6490),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHavolcite] = ACTIONS(6490),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHNotecite] = ACTIONS(6490),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHlabel] = ACTIONS(6490),
    [anon_sym_BSLASHref] = ACTIONS(6490),
    [anon_sym_BSLASHeqref] = ACTIONS(6490),
    [anon_sym_BSLASHvref] = ACTIONS(6490),
    [anon_sym_BSLASHVref] = ACTIONS(6490),
    [anon_sym_BSLASHautoref] = ACTIONS(6490),
    [anon_sym_BSLASHpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcref] = ACTIONS(6490),
    [anon_sym_BSLASHCref] = ACTIONS(6490),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnameCref] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHdef] = ACTIONS(6490),
    [anon_sym_BSLASHlet] = ACTIONS(6490),
    [anon_sym_BSLASHleft] = ACTIONS(6490),
    [anon_sym_BSLASHbigl] = ACTIONS(6490),
    [anon_sym_BSLASHBigl] = ACTIONS(6490),
    [anon_sym_BSLASHbiggl] = ACTIONS(6490),
    [anon_sym_BSLASHBiggl] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6490),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6490),
    [anon_sym_BSLASHgls] = ACTIONS(6490),
    [anon_sym_BSLASHGls] = ACTIONS(6490),
    [anon_sym_BSLASHGLS] = ACTIONS(6490),
    [anon_sym_BSLASHglspl] = ACTIONS(6490),
    [anon_sym_BSLASHGlspl] = ACTIONS(6490),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6490),
    [anon_sym_BSLASHglslink] = ACTIONS(6490),
    [anon_sym_BSLASHglstext] = ACTIONS(6490),
    [anon_sym_BSLASHGlstext] = ACTIONS(6490),
    [anon_sym_BSLASHGLStext] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6490),
    [anon_sym_BSLASHglsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsname] = ACTIONS(6490),
    [anon_sym_BSLASHGlsname] = ACTIONS(6490),
    [anon_sym_BSLASHGLSname] = ACTIONS(6490),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6490),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6490),
    [anon_sym_BSLASHacrshort] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6490),
    [anon_sym_BSLASHACRshort] = ACTIONS(6490),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrlong] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6490),
    [anon_sym_BSLASHACRlong] = ACTIONS(6490),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrfull] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6490),
    [anon_sym_BSLASHACRfull] = ACTIONS(6490),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHacs] = ACTIONS(6490),
    [anon_sym_BSLASHAcs] = ACTIONS(6490),
    [anon_sym_BSLASHacsp] = ACTIONS(6490),
    [anon_sym_BSLASHAcsp] = ACTIONS(6490),
    [anon_sym_BSLASHacl] = ACTIONS(6490),
    [anon_sym_BSLASHAcl] = ACTIONS(6490),
    [anon_sym_BSLASHaclp] = ACTIONS(6490),
    [anon_sym_BSLASHAclp] = ACTIONS(6490),
    [anon_sym_BSLASHacf] = ACTIONS(6490),
    [anon_sym_BSLASHAcf] = ACTIONS(6490),
    [anon_sym_BSLASHacfp] = ACTIONS(6490),
    [anon_sym_BSLASHAcfp] = ACTIONS(6490),
    [anon_sym_BSLASHac] = ACTIONS(6490),
    [anon_sym_BSLASHAc] = ACTIONS(6490),
    [anon_sym_BSLASHacp] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6490),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6490),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6490),
    [anon_sym_BSLASHcolor] = ACTIONS(6490),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6490),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6490),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6490),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6490),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6490),
    [anon_sym_BSLASHtext] = ACTIONS(6490),
    [anon_sym_BSLASHintertext] = ACTIONS(6490),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6490),
    [anon_sym_BSLASHurl] = ACTIONS(6490),
    [anon_sym_BSLASHhref] = ACTIONS(6490),
  },
  [979] = {
    [ts_builtin_sym_end] = ACTIONS(6188),
    [sym_command_name] = ACTIONS(6186),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(6188),
    [anon_sym_RBRACK] = ACTIONS(6188),
    [anon_sym_COMMA] = ACTIONS(6188),
    [anon_sym_EQ] = ACTIONS(6188),
    [anon_sym_LPAREN] = ACTIONS(6188),
    [anon_sym_RPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHpart] = ACTIONS(6186),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddpart] = ACTIONS(6186),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHchapter] = ACTIONS(6186),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddchap] = ACTIONS(6186),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsection] = ACTIONS(6186),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddsec] = ACTIONS(6186),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHitem] = ACTIONS(6186),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6188),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [anon_sym_RBRACE] = ACTIONS(6188),
    [sym_word] = ACTIONS(6186),
    [sym_placeholder] = ACTIONS(6188),
    [anon_sym_PLUS] = ACTIONS(6188),
    [anon_sym_DASH] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_SLASH] = ACTIONS(6188),
    [anon_sym_LT] = ACTIONS(6186),
    [anon_sym_GT] = ACTIONS(6186),
    [anon_sym_BANG] = ACTIONS(6186),
    [anon_sym_PIPE] = ACTIONS(6186),
    [anon_sym_COLON] = ACTIONS(6186),
    [anon_sym_SQUOTE] = ACTIONS(6186),
    [anon_sym__] = ACTIONS(6188),
    [anon_sym_CARET] = ACTIONS(6188),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6188),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6188),
    [anon_sym_DOLLAR] = ACTIONS(6186),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHbegin] = ACTIONS(6186),
    [anon_sym_BSLASHtitle] = ACTIONS(6186),
    [anon_sym_BSLASHauthor] = ACTIONS(6186),
    [anon_sym_BSLASHusepackage] = ACTIONS(6186),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6186),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6186),
    [anon_sym_BSLASHinclude] = ACTIONS(6186),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6186),
    [anon_sym_BSLASHinput] = ACTIONS(6186),
    [anon_sym_BSLASHsubfile] = ACTIONS(6186),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6186),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6186),
    [anon_sym_BSLASHbibliography] = ACTIONS(6186),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6186),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6186),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6186),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6186),
    [anon_sym_BSLASHimport] = ACTIONS(6186),
    [anon_sym_BSLASHsubimport] = ACTIONS(6186),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6186),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHcaption] = ACTIONS(6186),
    [anon_sym_BSLASHcite] = ACTIONS(6186),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCite] = ACTIONS(6186),
    [anon_sym_BSLASHnocite] = ACTIONS(6186),
    [anon_sym_BSLASHcitet] = ACTIONS(6186),
    [anon_sym_BSLASHcitep] = ACTIONS(6186),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteA] = ACTIONS(6186),
    [anon_sym_BSLASHciteR] = ACTIONS(6186),
    [anon_sym_BSLASHciteS] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6186),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteyear] = ACTIONS(6186),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitedate] = ACTIONS(6186),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteurl] = ACTIONS(6186),
    [anon_sym_BSLASHfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6186),
    [anon_sym_BSLASHcitealt] = ACTIONS(6186),
    [anon_sym_BSLASHcitealp] = ACTIONS(6186),
    [anon_sym_BSLASHcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHparencite] = ACTIONS(6186),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHParencite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHtextcite] = ACTIONS(6186),
    [anon_sym_BSLASHTextcite] = ACTIONS(6186),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHsupercite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite] = ACTIONS(6186),
    [anon_sym_BSLASHAutocite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHVolcite] = ACTIONS(6186),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHavolcite] = ACTIONS(6186),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHNotecite] = ACTIONS(6186),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHlabel] = ACTIONS(6186),
    [anon_sym_BSLASHref] = ACTIONS(6186),
    [anon_sym_BSLASHeqref] = ACTIONS(6186),
    [anon_sym_BSLASHvref] = ACTIONS(6186),
    [anon_sym_BSLASHVref] = ACTIONS(6186),
    [anon_sym_BSLASHautoref] = ACTIONS(6186),
    [anon_sym_BSLASHpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcref] = ACTIONS(6186),
    [anon_sym_BSLASHCref] = ACTIONS(6186),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnameCref] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHdef] = ACTIONS(6186),
    [anon_sym_BSLASHlet] = ACTIONS(6186),
    [anon_sym_BSLASHleft] = ACTIONS(6186),
    [anon_sym_BSLASHbigl] = ACTIONS(6186),
    [anon_sym_BSLASHBigl] = ACTIONS(6186),
    [anon_sym_BSLASHbiggl] = ACTIONS(6186),
    [anon_sym_BSLASHBiggl] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6186),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6186),
    [anon_sym_BSLASHgls] = ACTIONS(6186),
    [anon_sym_BSLASHGls] = ACTIONS(6186),
    [anon_sym_BSLASHGLS] = ACTIONS(6186),
    [anon_sym_BSLASHglspl] = ACTIONS(6186),
    [anon_sym_BSLASHGlspl] = ACTIONS(6186),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6186),
    [anon_sym_BSLASHglslink] = ACTIONS(6186),
    [anon_sym_BSLASHglstext] = ACTIONS(6186),
    [anon_sym_BSLASHGlstext] = ACTIONS(6186),
    [anon_sym_BSLASHGLStext] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6186),
    [anon_sym_BSLASHglsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsname] = ACTIONS(6186),
    [anon_sym_BSLASHGlsname] = ACTIONS(6186),
    [anon_sym_BSLASHGLSname] = ACTIONS(6186),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6186),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6186),
    [anon_sym_BSLASHacrshort] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6186),
    [anon_sym_BSLASHACRshort] = ACTIONS(6186),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrlong] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6186),
    [anon_sym_BSLASHACRlong] = ACTIONS(6186),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrfull] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6186),
    [anon_sym_BSLASHACRfull] = ACTIONS(6186),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHacs] = ACTIONS(6186),
    [anon_sym_BSLASHAcs] = ACTIONS(6186),
    [anon_sym_BSLASHacsp] = ACTIONS(6186),
    [anon_sym_BSLASHAcsp] = ACTIONS(6186),
    [anon_sym_BSLASHacl] = ACTIONS(6186),
    [anon_sym_BSLASHAcl] = ACTIONS(6186),
    [anon_sym_BSLASHaclp] = ACTIONS(6186),
    [anon_sym_BSLASHAclp] = ACTIONS(6186),
    [anon_sym_BSLASHacf] = ACTIONS(6186),
    [anon_sym_BSLASHAcf] = ACTIONS(6186),
    [anon_sym_BSLASHacfp] = ACTIONS(6186),
    [anon_sym_BSLASHAcfp] = ACTIONS(6186),
    [anon_sym_BSLASHac] = ACTIONS(6186),
    [anon_sym_BSLASHAc] = ACTIONS(6186),
    [anon_sym_BSLASHacp] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6186),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6186),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6186),
    [anon_sym_BSLASHcolor] = ACTIONS(6186),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6186),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6186),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6186),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6186),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6186),
    [anon_sym_BSLASHtext] = ACTIONS(6186),
    [anon_sym_BSLASHintertext] = ACTIONS(6186),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6186),
    [anon_sym_BSLASHurl] = ACTIONS(6186),
    [anon_sym_BSLASHhref] = ACTIONS(6186),
  },
  [980] = {
    [ts_builtin_sym_end] = ACTIONS(6428),
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_RBRACK] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6428),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_RPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHpart] = ACTIONS(6426),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddpart] = ACTIONS(6426),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHchapter] = ACTIONS(6426),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddchap] = ACTIONS(6426),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsection] = ACTIONS(6426),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddsec] = ACTIONS(6426),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHitem] = ACTIONS(6426),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [anon_sym_RBRACE] = ACTIONS(6428),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6428),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6428),
    [anon_sym_DOLLAR] = ACTIONS(6426),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHbegin] = ACTIONS(6426),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHleft] = ACTIONS(6426),
    [anon_sym_BSLASHbigl] = ACTIONS(6426),
    [anon_sym_BSLASHBigl] = ACTIONS(6426),
    [anon_sym_BSLASHbiggl] = ACTIONS(6426),
    [anon_sym_BSLASHBiggl] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHtext] = ACTIONS(6426),
    [anon_sym_BSLASHintertext] = ACTIONS(6426),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [981] = {
    [ts_builtin_sym_end] = ACTIONS(6300),
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHpart] = ACTIONS(6298),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddpart] = ACTIONS(6298),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHchapter] = ACTIONS(6298),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddchap] = ACTIONS(6298),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsection] = ACTIONS(6298),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddsec] = ACTIONS(6298),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHitem] = ACTIONS(6298),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_RBRACE] = ACTIONS(6300),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6300),
    [anon_sym_DOLLAR] = ACTIONS(6298),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHbegin] = ACTIONS(6298),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHleft] = ACTIONS(6298),
    [anon_sym_BSLASHbigl] = ACTIONS(6298),
    [anon_sym_BSLASHBigl] = ACTIONS(6298),
    [anon_sym_BSLASHbiggl] = ACTIONS(6298),
    [anon_sym_BSLASHBiggl] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHtext] = ACTIONS(6298),
    [anon_sym_BSLASHintertext] = ACTIONS(6298),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [982] = {
    [ts_builtin_sym_end] = ACTIONS(6304),
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_LPAREN] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHpart] = ACTIONS(6302),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddpart] = ACTIONS(6302),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHchapter] = ACTIONS(6302),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddchap] = ACTIONS(6302),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsection] = ACTIONS(6302),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddsec] = ACTIONS(6302),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHitem] = ACTIONS(6302),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [anon_sym_RBRACE] = ACTIONS(6304),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6304),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6304),
    [anon_sym_DOLLAR] = ACTIONS(6302),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHbegin] = ACTIONS(6302),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHleft] = ACTIONS(6302),
    [anon_sym_BSLASHbigl] = ACTIONS(6302),
    [anon_sym_BSLASHBigl] = ACTIONS(6302),
    [anon_sym_BSLASHbiggl] = ACTIONS(6302),
    [anon_sym_BSLASHBiggl] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHtext] = ACTIONS(6302),
    [anon_sym_BSLASHintertext] = ACTIONS(6302),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [983] = {
    [ts_builtin_sym_end] = ACTIONS(6424),
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_LBRACK] = ACTIONS(6424),
    [anon_sym_RBRACK] = ACTIONS(6424),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_EQ] = ACTIONS(6424),
    [anon_sym_LPAREN] = ACTIONS(6424),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHpart] = ACTIONS(6422),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddpart] = ACTIONS(6422),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHchapter] = ACTIONS(6422),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddchap] = ACTIONS(6422),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsection] = ACTIONS(6422),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddsec] = ACTIONS(6422),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHitem] = ACTIONS(6422),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6424),
    [anon_sym_LBRACE] = ACTIONS(6424),
    [anon_sym_RBRACE] = ACTIONS(6424),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6424),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6424),
    [anon_sym_DOLLAR] = ACTIONS(6422),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHbegin] = ACTIONS(6422),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHleft] = ACTIONS(6422),
    [anon_sym_BSLASHbigl] = ACTIONS(6422),
    [anon_sym_BSLASHBigl] = ACTIONS(6422),
    [anon_sym_BSLASHbiggl] = ACTIONS(6422),
    [anon_sym_BSLASHBiggl] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHtext] = ACTIONS(6422),
    [anon_sym_BSLASHintertext] = ACTIONS(6422),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [984] = {
    [ts_builtin_sym_end] = ACTIONS(6308),
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6308),
    [anon_sym_RBRACK] = ACTIONS(6308),
    [anon_sym_COMMA] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(6308),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_RPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHpart] = ACTIONS(6306),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddpart] = ACTIONS(6306),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHchapter] = ACTIONS(6306),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddchap] = ACTIONS(6306),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsection] = ACTIONS(6306),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddsec] = ACTIONS(6306),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHitem] = ACTIONS(6306),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6308),
    [anon_sym_RBRACE] = ACTIONS(6308),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6308),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6308),
    [anon_sym_DOLLAR] = ACTIONS(6306),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHbegin] = ACTIONS(6306),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHleft] = ACTIONS(6306),
    [anon_sym_BSLASHbigl] = ACTIONS(6306),
    [anon_sym_BSLASHBigl] = ACTIONS(6306),
    [anon_sym_BSLASHbiggl] = ACTIONS(6306),
    [anon_sym_BSLASHBiggl] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHtext] = ACTIONS(6306),
    [anon_sym_BSLASHintertext] = ACTIONS(6306),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [985] = {
    [ts_builtin_sym_end] = ACTIONS(6340),
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_RBRACK] = ACTIONS(6340),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_EQ] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHpart] = ACTIONS(6338),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddpart] = ACTIONS(6338),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHchapter] = ACTIONS(6338),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddchap] = ACTIONS(6338),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsection] = ACTIONS(6338),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddsec] = ACTIONS(6338),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHitem] = ACTIONS(6338),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [anon_sym_RBRACE] = ACTIONS(6340),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6340),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6340),
    [anon_sym_DOLLAR] = ACTIONS(6338),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHbegin] = ACTIONS(6338),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHleft] = ACTIONS(6338),
    [anon_sym_BSLASHbigl] = ACTIONS(6338),
    [anon_sym_BSLASHBigl] = ACTIONS(6338),
    [anon_sym_BSLASHbiggl] = ACTIONS(6338),
    [anon_sym_BSLASHBiggl] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHtext] = ACTIONS(6338),
    [anon_sym_BSLASHintertext] = ACTIONS(6338),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [986] = {
    [ts_builtin_sym_end] = ACTIONS(6344),
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_RPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHpart] = ACTIONS(6342),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddpart] = ACTIONS(6342),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHchapter] = ACTIONS(6342),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddchap] = ACTIONS(6342),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsection] = ACTIONS(6342),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddsec] = ACTIONS(6342),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHitem] = ACTIONS(6342),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [anon_sym_RBRACE] = ACTIONS(6344),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6344),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6344),
    [anon_sym_DOLLAR] = ACTIONS(6342),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHbegin] = ACTIONS(6342),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHleft] = ACTIONS(6342),
    [anon_sym_BSLASHbigl] = ACTIONS(6342),
    [anon_sym_BSLASHBigl] = ACTIONS(6342),
    [anon_sym_BSLASHbiggl] = ACTIONS(6342),
    [anon_sym_BSLASHBiggl] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHtext] = ACTIONS(6342),
    [anon_sym_BSLASHintertext] = ACTIONS(6342),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [987] = {
    [ts_builtin_sym_end] = ACTIONS(6360),
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_RBRACK] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LPAREN] = ACTIONS(6360),
    [anon_sym_RPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHpart] = ACTIONS(6358),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddpart] = ACTIONS(6358),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHchapter] = ACTIONS(6358),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddchap] = ACTIONS(6358),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsection] = ACTIONS(6358),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddsec] = ACTIONS(6358),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHitem] = ACTIONS(6358),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(6360),
    [anon_sym_RBRACE] = ACTIONS(6360),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6360),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6358),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHbegin] = ACTIONS(6358),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHleft] = ACTIONS(6358),
    [anon_sym_BSLASHbigl] = ACTIONS(6358),
    [anon_sym_BSLASHBigl] = ACTIONS(6358),
    [anon_sym_BSLASHbiggl] = ACTIONS(6358),
    [anon_sym_BSLASHBiggl] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHtext] = ACTIONS(6358),
    [anon_sym_BSLASHintertext] = ACTIONS(6358),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [988] = {
    [ts_builtin_sym_end] = ACTIONS(6368),
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_RBRACK] = ACTIONS(6368),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_LPAREN] = ACTIONS(6368),
    [anon_sym_RPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHpart] = ACTIONS(6366),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddpart] = ACTIONS(6366),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHchapter] = ACTIONS(6366),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddchap] = ACTIONS(6366),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsection] = ACTIONS(6366),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddsec] = ACTIONS(6366),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHitem] = ACTIONS(6366),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6368),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [anon_sym_RBRACE] = ACTIONS(6368),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6368),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6366),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHbegin] = ACTIONS(6366),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHleft] = ACTIONS(6366),
    [anon_sym_BSLASHbigl] = ACTIONS(6366),
    [anon_sym_BSLASHBigl] = ACTIONS(6366),
    [anon_sym_BSLASHbiggl] = ACTIONS(6366),
    [anon_sym_BSLASHBiggl] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHtext] = ACTIONS(6366),
    [anon_sym_BSLASHintertext] = ACTIONS(6366),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [989] = {
    [ts_builtin_sym_end] = ACTIONS(6372),
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_RBRACK] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LPAREN] = ACTIONS(6372),
    [anon_sym_RPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHpart] = ACTIONS(6370),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddpart] = ACTIONS(6370),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHchapter] = ACTIONS(6370),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddchap] = ACTIONS(6370),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsection] = ACTIONS(6370),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddsec] = ACTIONS(6370),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHitem] = ACTIONS(6370),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [anon_sym_RBRACE] = ACTIONS(6372),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6372),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6370),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHbegin] = ACTIONS(6370),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHleft] = ACTIONS(6370),
    [anon_sym_BSLASHbigl] = ACTIONS(6370),
    [anon_sym_BSLASHBigl] = ACTIONS(6370),
    [anon_sym_BSLASHbiggl] = ACTIONS(6370),
    [anon_sym_BSLASHBiggl] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHtext] = ACTIONS(6370),
    [anon_sym_BSLASHintertext] = ACTIONS(6370),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [990] = {
    [ts_builtin_sym_end] = ACTIONS(6460),
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6460),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_COMMA] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_LPAREN] = ACTIONS(6460),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHpart] = ACTIONS(6458),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddpart] = ACTIONS(6458),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHchapter] = ACTIONS(6458),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddchap] = ACTIONS(6458),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsection] = ACTIONS(6458),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddsec] = ACTIONS(6458),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHitem] = ACTIONS(6458),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6460),
    [anon_sym_RBRACE] = ACTIONS(6460),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6460),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6460),
    [anon_sym_DOLLAR] = ACTIONS(6458),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHbegin] = ACTIONS(6458),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHleft] = ACTIONS(6458),
    [anon_sym_BSLASHbigl] = ACTIONS(6458),
    [anon_sym_BSLASHBigl] = ACTIONS(6458),
    [anon_sym_BSLASHbiggl] = ACTIONS(6458),
    [anon_sym_BSLASHBiggl] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHtext] = ACTIONS(6458),
    [anon_sym_BSLASHintertext] = ACTIONS(6458),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [991] = {
    [sym_brack_group_text] = STATE(1089),
    [sym_command_name] = ACTIONS(6138),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(7059),
    [anon_sym_RBRACK] = ACTIONS(6142),
    [anon_sym_COMMA] = ACTIONS(6142),
    [anon_sym_EQ] = ACTIONS(6142),
    [anon_sym_LPAREN] = ACTIONS(6142),
    [anon_sym_RPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHpart] = ACTIONS(6138),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddpart] = ACTIONS(6138),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHchapter] = ACTIONS(6138),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddchap] = ACTIONS(6138),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsection] = ACTIONS(6138),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHaddsec] = ACTIONS(6138),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6138),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6138),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHitem] = ACTIONS(6138),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(6142),
    [sym_word] = ACTIONS(6138),
    [sym_placeholder] = ACTIONS(6142),
    [anon_sym_PLUS] = ACTIONS(6142),
    [anon_sym_DASH] = ACTIONS(6142),
    [anon_sym_STAR] = ACTIONS(6142),
    [anon_sym_SLASH] = ACTIONS(6142),
    [anon_sym_LT] = ACTIONS(6138),
    [anon_sym_GT] = ACTIONS(6138),
    [anon_sym_BANG] = ACTIONS(6138),
    [anon_sym_PIPE] = ACTIONS(6138),
    [anon_sym_COLON] = ACTIONS(6138),
    [anon_sym_SQUOTE] = ACTIONS(6138),
    [anon_sym__] = ACTIONS(6142),
    [anon_sym_CARET] = ACTIONS(6142),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6142),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6142),
    [anon_sym_DOLLAR] = ACTIONS(6138),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6142),
    [anon_sym_BSLASHbegin] = ACTIONS(6138),
    [anon_sym_BSLASHend] = ACTIONS(6138),
    [anon_sym_BSLASHtitle] = ACTIONS(6138),
    [anon_sym_BSLASHauthor] = ACTIONS(6138),
    [anon_sym_BSLASHusepackage] = ACTIONS(6138),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6138),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6138),
    [anon_sym_BSLASHinclude] = ACTIONS(6138),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6138),
    [anon_sym_BSLASHinput] = ACTIONS(6138),
    [anon_sym_BSLASHsubfile] = ACTIONS(6138),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6138),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6138),
    [anon_sym_BSLASHbibliography] = ACTIONS(6138),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6138),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6138),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6138),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6138),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6138),
    [anon_sym_BSLASHimport] = ACTIONS(6138),
    [anon_sym_BSLASHsubimport] = ACTIONS(6138),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6138),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6138),
    [anon_sym_BSLASHcaption] = ACTIONS(6138),
    [anon_sym_BSLASHcite] = ACTIONS(6138),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCite] = ACTIONS(6138),
    [anon_sym_BSLASHnocite] = ACTIONS(6138),
    [anon_sym_BSLASHcitet] = ACTIONS(6138),
    [anon_sym_BSLASHcitep] = ACTIONS(6138),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteA] = ACTIONS(6138),
    [anon_sym_BSLASHciteR] = ACTIONS(6138),
    [anon_sym_BSLASHciteS] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6138),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6138),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteyear] = ACTIONS(6138),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHcitedate] = ACTIONS(6138),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHciteurl] = ACTIONS(6138),
    [anon_sym_BSLASHfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6138),
    [anon_sym_BSLASHcitealt] = ACTIONS(6138),
    [anon_sym_BSLASHcitealp] = ACTIONS(6138),
    [anon_sym_BSLASHcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHparencite] = ACTIONS(6138),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHParencite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6138),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6138),
    [anon_sym_BSLASHtextcite] = ACTIONS(6138),
    [anon_sym_BSLASHTextcite] = ACTIONS(6138),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6138),
    [anon_sym_BSLASHsupercite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite] = ACTIONS(6138),
    [anon_sym_BSLASHAutocite] = ACTIONS(6138),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHVolcite] = ACTIONS(6138),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHavolcite] = ACTIONS(6138),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6138),
    [anon_sym_BSLASHnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHNotecite] = ACTIONS(6138),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6138),
    [anon_sym_BSLASHlabel] = ACTIONS(6138),
    [anon_sym_BSLASHref] = ACTIONS(6138),
    [anon_sym_BSLASHeqref] = ACTIONS(6138),
    [anon_sym_BSLASHvref] = ACTIONS(6138),
    [anon_sym_BSLASHVref] = ACTIONS(6138),
    [anon_sym_BSLASHautoref] = ACTIONS(6138),
    [anon_sym_BSLASHpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcref] = ACTIONS(6138),
    [anon_sym_BSLASHCref] = ACTIONS(6138),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnameCref] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6138),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6138),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6138),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6138),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6138),
    [anon_sym_BSLASHdef] = ACTIONS(6138),
    [anon_sym_BSLASHlet] = ACTIONS(6138),
    [anon_sym_BSLASHleft] = ACTIONS(6138),
    [anon_sym_BSLASHbigl] = ACTIONS(6138),
    [anon_sym_BSLASHBigl] = ACTIONS(6138),
    [anon_sym_BSLASHbiggl] = ACTIONS(6138),
    [anon_sym_BSLASHBiggl] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6138),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6138),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6138),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6138),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6138),
    [anon_sym_BSLASHgls] = ACTIONS(6138),
    [anon_sym_BSLASHGls] = ACTIONS(6138),
    [anon_sym_BSLASHGLS] = ACTIONS(6138),
    [anon_sym_BSLASHglspl] = ACTIONS(6138),
    [anon_sym_BSLASHGlspl] = ACTIONS(6138),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6138),
    [anon_sym_BSLASHglslink] = ACTIONS(6138),
    [anon_sym_BSLASHglstext] = ACTIONS(6138),
    [anon_sym_BSLASHGlstext] = ACTIONS(6138),
    [anon_sym_BSLASHGLStext] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6138),
    [anon_sym_BSLASHglsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6138),
    [anon_sym_BSLASHglsname] = ACTIONS(6138),
    [anon_sym_BSLASHGlsname] = ACTIONS(6138),
    [anon_sym_BSLASHGLSname] = ACTIONS(6138),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6138),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6138),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6138),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6138),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6138),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6138),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6138),
    [anon_sym_BSLASHacrshort] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6138),
    [anon_sym_BSLASHACRshort] = ACTIONS(6138),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrlong] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6138),
    [anon_sym_BSLASHACRlong] = ACTIONS(6138),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6138),
    [anon_sym_BSLASHacrfull] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6138),
    [anon_sym_BSLASHACRfull] = ACTIONS(6138),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHacs] = ACTIONS(6138),
    [anon_sym_BSLASHAcs] = ACTIONS(6138),
    [anon_sym_BSLASHacsp] = ACTIONS(6138),
    [anon_sym_BSLASHAcsp] = ACTIONS(6138),
    [anon_sym_BSLASHacl] = ACTIONS(6138),
    [anon_sym_BSLASHAcl] = ACTIONS(6138),
    [anon_sym_BSLASHaclp] = ACTIONS(6138),
    [anon_sym_BSLASHAclp] = ACTIONS(6138),
    [anon_sym_BSLASHacf] = ACTIONS(6138),
    [anon_sym_BSLASHAcf] = ACTIONS(6138),
    [anon_sym_BSLASHacfp] = ACTIONS(6138),
    [anon_sym_BSLASHAcfp] = ACTIONS(6138),
    [anon_sym_BSLASHac] = ACTIONS(6138),
    [anon_sym_BSLASHAc] = ACTIONS(6138),
    [anon_sym_BSLASHacp] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6138),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6138),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6138),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6138),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6142),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6138),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6138),
    [anon_sym_BSLASHcolor] = ACTIONS(6138),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6138),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6138),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6138),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6138),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6138),
    [anon_sym_BSLASHtext] = ACTIONS(6138),
    [anon_sym_BSLASHintertext] = ACTIONS(6138),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6138),
    [anon_sym_BSLASHurl] = ACTIONS(6138),
    [anon_sym_BSLASHhref] = ACTIONS(6138),
  },
  [992] = {
    [ts_builtin_sym_end] = ACTIONS(6464),
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6464),
    [anon_sym_RBRACK] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_EQ] = ACTIONS(6464),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHpart] = ACTIONS(6462),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddpart] = ACTIONS(6462),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHchapter] = ACTIONS(6462),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddchap] = ACTIONS(6462),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsection] = ACTIONS(6462),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddsec] = ACTIONS(6462),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHitem] = ACTIONS(6462),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [anon_sym_RBRACE] = ACTIONS(6464),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6464),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(6462),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHbegin] = ACTIONS(6462),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHleft] = ACTIONS(6462),
    [anon_sym_BSLASHbigl] = ACTIONS(6462),
    [anon_sym_BSLASHBigl] = ACTIONS(6462),
    [anon_sym_BSLASHbiggl] = ACTIONS(6462),
    [anon_sym_BSLASHBiggl] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHtext] = ACTIONS(6462),
    [anon_sym_BSLASHintertext] = ACTIONS(6462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [993] = {
    [ts_builtin_sym_end] = ACTIONS(6456),
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHpart] = ACTIONS(6454),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddpart] = ACTIONS(6454),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHchapter] = ACTIONS(6454),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddchap] = ACTIONS(6454),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsection] = ACTIONS(6454),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddsec] = ACTIONS(6454),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHitem] = ACTIONS(6454),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [anon_sym_RBRACE] = ACTIONS(6456),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6456),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(6454),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHbegin] = ACTIONS(6454),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHleft] = ACTIONS(6454),
    [anon_sym_BSLASHbigl] = ACTIONS(6454),
    [anon_sym_BSLASHBigl] = ACTIONS(6454),
    [anon_sym_BSLASHbiggl] = ACTIONS(6454),
    [anon_sym_BSLASHBiggl] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHtext] = ACTIONS(6454),
    [anon_sym_BSLASHintertext] = ACTIONS(6454),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [994] = {
    [sym_brack_group_text] = STATE(1192),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(7051),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHpart] = ACTIONS(6166),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddpart] = ACTIONS(6166),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHchapter] = ACTIONS(6166),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddchap] = ACTIONS(6166),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsection] = ACTIONS(6166),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddsec] = ACTIONS(6166),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHitem] = ACTIONS(6166),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6168),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6166),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6168),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHbegin] = ACTIONS(6166),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHleft] = ACTIONS(6166),
    [anon_sym_BSLASHbigl] = ACTIONS(6166),
    [anon_sym_BSLASHBigl] = ACTIONS(6166),
    [anon_sym_BSLASHbiggl] = ACTIONS(6166),
    [anon_sym_BSLASHBiggl] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHtext] = ACTIONS(6166),
    [anon_sym_BSLASHintertext] = ACTIONS(6166),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [995] = {
    [ts_builtin_sym_end] = ACTIONS(6180),
    [sym_command_name] = ACTIONS(6178),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6178),
    [anon_sym_LBRACK] = ACTIONS(6180),
    [anon_sym_RBRACK] = ACTIONS(6180),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_EQ] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6180),
    [anon_sym_RPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHpart] = ACTIONS(6178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddpart] = ACTIONS(6178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHchapter] = ACTIONS(6178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddchap] = ACTIONS(6178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsection] = ACTIONS(6178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddsec] = ACTIONS(6178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHitem] = ACTIONS(6178),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6180),
    [anon_sym_LBRACE] = ACTIONS(6180),
    [anon_sym_RBRACE] = ACTIONS(6180),
    [sym_word] = ACTIONS(6178),
    [sym_placeholder] = ACTIONS(6180),
    [anon_sym_PLUS] = ACTIONS(6180),
    [anon_sym_DASH] = ACTIONS(6180),
    [anon_sym_STAR] = ACTIONS(6180),
    [anon_sym_SLASH] = ACTIONS(6180),
    [anon_sym_LT] = ACTIONS(6178),
    [anon_sym_GT] = ACTIONS(6178),
    [anon_sym_BANG] = ACTIONS(6178),
    [anon_sym_PIPE] = ACTIONS(6178),
    [anon_sym_COLON] = ACTIONS(6178),
    [anon_sym_SQUOTE] = ACTIONS(6178),
    [anon_sym__] = ACTIONS(6180),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6180),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6180),
    [anon_sym_DOLLAR] = ACTIONS(6178),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHbegin] = ACTIONS(6178),
    [anon_sym_BSLASHtitle] = ACTIONS(6178),
    [anon_sym_BSLASHauthor] = ACTIONS(6178),
    [anon_sym_BSLASHusepackage] = ACTIONS(6178),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6178),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6178),
    [anon_sym_BSLASHinclude] = ACTIONS(6178),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6178),
    [anon_sym_BSLASHinput] = ACTIONS(6178),
    [anon_sym_BSLASHsubfile] = ACTIONS(6178),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6178),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6178),
    [anon_sym_BSLASHbibliography] = ACTIONS(6178),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6178),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6178),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6178),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6178),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6178),
    [anon_sym_BSLASHimport] = ACTIONS(6178),
    [anon_sym_BSLASHsubimport] = ACTIONS(6178),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6178),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHcaption] = ACTIONS(6178),
    [anon_sym_BSLASHcite] = ACTIONS(6178),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCite] = ACTIONS(6178),
    [anon_sym_BSLASHnocite] = ACTIONS(6178),
    [anon_sym_BSLASHcitet] = ACTIONS(6178),
    [anon_sym_BSLASHcitep] = ACTIONS(6178),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteA] = ACTIONS(6178),
    [anon_sym_BSLASHciteR] = ACTIONS(6178),
    [anon_sym_BSLASHciteS] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6178),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteyear] = ACTIONS(6178),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitedate] = ACTIONS(6178),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteurl] = ACTIONS(6178),
    [anon_sym_BSLASHfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6178),
    [anon_sym_BSLASHcitealt] = ACTIONS(6178),
    [anon_sym_BSLASHcitealp] = ACTIONS(6178),
    [anon_sym_BSLASHcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHparencite] = ACTIONS(6178),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHParencite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHtextcite] = ACTIONS(6178),
    [anon_sym_BSLASHTextcite] = ACTIONS(6178),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHsupercite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite] = ACTIONS(6178),
    [anon_sym_BSLASHAutocite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHVolcite] = ACTIONS(6178),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHavolcite] = ACTIONS(6178),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHNotecite] = ACTIONS(6178),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHlabel] = ACTIONS(6178),
    [anon_sym_BSLASHref] = ACTIONS(6178),
    [anon_sym_BSLASHeqref] = ACTIONS(6178),
    [anon_sym_BSLASHvref] = ACTIONS(6178),
    [anon_sym_BSLASHVref] = ACTIONS(6178),
    [anon_sym_BSLASHautoref] = ACTIONS(6178),
    [anon_sym_BSLASHpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcref] = ACTIONS(6178),
    [anon_sym_BSLASHCref] = ACTIONS(6178),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnameCref] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHdef] = ACTIONS(6178),
    [anon_sym_BSLASHlet] = ACTIONS(6178),
    [anon_sym_BSLASHleft] = ACTIONS(6178),
    [anon_sym_BSLASHbigl] = ACTIONS(6178),
    [anon_sym_BSLASHBigl] = ACTIONS(6178),
    [anon_sym_BSLASHbiggl] = ACTIONS(6178),
    [anon_sym_BSLASHBiggl] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6178),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6178),
    [anon_sym_BSLASHgls] = ACTIONS(6178),
    [anon_sym_BSLASHGls] = ACTIONS(6178),
    [anon_sym_BSLASHGLS] = ACTIONS(6178),
    [anon_sym_BSLASHglspl] = ACTIONS(6178),
    [anon_sym_BSLASHGlspl] = ACTIONS(6178),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6178),
    [anon_sym_BSLASHglslink] = ACTIONS(6178),
    [anon_sym_BSLASHglstext] = ACTIONS(6178),
    [anon_sym_BSLASHGlstext] = ACTIONS(6178),
    [anon_sym_BSLASHGLStext] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6178),
    [anon_sym_BSLASHglsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsname] = ACTIONS(6178),
    [anon_sym_BSLASHGlsname] = ACTIONS(6178),
    [anon_sym_BSLASHGLSname] = ACTIONS(6178),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6178),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6178),
    [anon_sym_BSLASHacrshort] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6178),
    [anon_sym_BSLASHACRshort] = ACTIONS(6178),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrlong] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6178),
    [anon_sym_BSLASHACRlong] = ACTIONS(6178),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrfull] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6178),
    [anon_sym_BSLASHACRfull] = ACTIONS(6178),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHacs] = ACTIONS(6178),
    [anon_sym_BSLASHAcs] = ACTIONS(6178),
    [anon_sym_BSLASHacsp] = ACTIONS(6178),
    [anon_sym_BSLASHAcsp] = ACTIONS(6178),
    [anon_sym_BSLASHacl] = ACTIONS(6178),
    [anon_sym_BSLASHAcl] = ACTIONS(6178),
    [anon_sym_BSLASHaclp] = ACTIONS(6178),
    [anon_sym_BSLASHAclp] = ACTIONS(6178),
    [anon_sym_BSLASHacf] = ACTIONS(6178),
    [anon_sym_BSLASHAcf] = ACTIONS(6178),
    [anon_sym_BSLASHacfp] = ACTIONS(6178),
    [anon_sym_BSLASHAcfp] = ACTIONS(6178),
    [anon_sym_BSLASHac] = ACTIONS(6178),
    [anon_sym_BSLASHAc] = ACTIONS(6178),
    [anon_sym_BSLASHacp] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6178),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6178),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6178),
    [anon_sym_BSLASHcolor] = ACTIONS(6178),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6178),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6178),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6178),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6178),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6178),
    [anon_sym_BSLASHtext] = ACTIONS(6178),
    [anon_sym_BSLASHintertext] = ACTIONS(6178),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6178),
    [anon_sym_BSLASHurl] = ACTIONS(6178),
    [anon_sym_BSLASHhref] = ACTIONS(6178),
  },
  [996] = {
    [ts_builtin_sym_end] = ACTIONS(6560),
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_LBRACK] = ACTIONS(6560),
    [anon_sym_RBRACK] = ACTIONS(6560),
    [anon_sym_COMMA] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHpart] = ACTIONS(6558),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddpart] = ACTIONS(6558),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHchapter] = ACTIONS(6558),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddchap] = ACTIONS(6558),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsection] = ACTIONS(6558),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddsec] = ACTIONS(6558),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHitem] = ACTIONS(6558),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6560),
    [anon_sym_LBRACE] = ACTIONS(6560),
    [anon_sym_RBRACE] = ACTIONS(6560),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6560),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(6558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHbegin] = ACTIONS(6558),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHleft] = ACTIONS(6558),
    [anon_sym_BSLASHbigl] = ACTIONS(6558),
    [anon_sym_BSLASHBigl] = ACTIONS(6558),
    [anon_sym_BSLASHbiggl] = ACTIONS(6558),
    [anon_sym_BSLASHBiggl] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHtext] = ACTIONS(6558),
    [anon_sym_BSLASHintertext] = ACTIONS(6558),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [997] = {
    [ts_builtin_sym_end] = ACTIONS(6436),
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6436),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_EQ] = ACTIONS(6436),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHpart] = ACTIONS(6434),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddpart] = ACTIONS(6434),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHchapter] = ACTIONS(6434),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddchap] = ACTIONS(6434),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsection] = ACTIONS(6434),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddsec] = ACTIONS(6434),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHitem] = ACTIONS(6434),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6436),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [anon_sym_RBRACE] = ACTIONS(6436),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6436),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6436),
    [anon_sym_DOLLAR] = ACTIONS(6434),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHbegin] = ACTIONS(6434),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHleft] = ACTIONS(6434),
    [anon_sym_BSLASHbigl] = ACTIONS(6434),
    [anon_sym_BSLASHBigl] = ACTIONS(6434),
    [anon_sym_BSLASHbiggl] = ACTIONS(6434),
    [anon_sym_BSLASHBiggl] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHtext] = ACTIONS(6434),
    [anon_sym_BSLASHintertext] = ACTIONS(6434),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [998] = {
    [ts_builtin_sym_end] = ACTIONS(6400),
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6400),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHpart] = ACTIONS(6398),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddpart] = ACTIONS(6398),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHchapter] = ACTIONS(6398),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddchap] = ACTIONS(6398),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsection] = ACTIONS(6398),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddsec] = ACTIONS(6398),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHitem] = ACTIONS(6398),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [anon_sym_RBRACE] = ACTIONS(6400),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6400),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHbegin] = ACTIONS(6398),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHleft] = ACTIONS(6398),
    [anon_sym_BSLASHbigl] = ACTIONS(6398),
    [anon_sym_BSLASHBigl] = ACTIONS(6398),
    [anon_sym_BSLASHbiggl] = ACTIONS(6398),
    [anon_sym_BSLASHBiggl] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHtext] = ACTIONS(6398),
    [anon_sym_BSLASHintertext] = ACTIONS(6398),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [999] = {
    [ts_builtin_sym_end] = ACTIONS(6468),
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_LBRACK] = ACTIONS(6468),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_COMMA] = ACTIONS(6468),
    [anon_sym_EQ] = ACTIONS(6468),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHpart] = ACTIONS(6466),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddpart] = ACTIONS(6466),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHchapter] = ACTIONS(6466),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddchap] = ACTIONS(6466),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsection] = ACTIONS(6466),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddsec] = ACTIONS(6466),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHitem] = ACTIONS(6466),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [anon_sym_RBRACE] = ACTIONS(6468),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6468),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6466),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHbegin] = ACTIONS(6466),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHleft] = ACTIONS(6466),
    [anon_sym_BSLASHbigl] = ACTIONS(6466),
    [anon_sym_BSLASHBigl] = ACTIONS(6466),
    [anon_sym_BSLASHbiggl] = ACTIONS(6466),
    [anon_sym_BSLASHBiggl] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHtext] = ACTIONS(6466),
    [anon_sym_BSLASHintertext] = ACTIONS(6466),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [1000] = {
    [ts_builtin_sym_end] = ACTIONS(6596),
    [sym_command_name] = ACTIONS(6594),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6596),
    [anon_sym_LPAREN] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHpart] = ACTIONS(6594),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddpart] = ACTIONS(6594),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHchapter] = ACTIONS(6594),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddchap] = ACTIONS(6594),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsection] = ACTIONS(6594),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddsec] = ACTIONS(6594),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHitem] = ACTIONS(6594),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6596),
    [anon_sym_LBRACE] = ACTIONS(6596),
    [anon_sym_RBRACE] = ACTIONS(6596),
    [sym_word] = ACTIONS(6594),
    [sym_placeholder] = ACTIONS(6596),
    [anon_sym_PLUS] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6596),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_SLASH] = ACTIONS(6596),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_BANG] = ACTIONS(6594),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SQUOTE] = ACTIONS(6594),
    [anon_sym__] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(6596),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6596),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(6594),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHbegin] = ACTIONS(6594),
    [anon_sym_BSLASHtitle] = ACTIONS(6594),
    [anon_sym_BSLASHauthor] = ACTIONS(6594),
    [anon_sym_BSLASHusepackage] = ACTIONS(6594),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6594),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6594),
    [anon_sym_BSLASHinclude] = ACTIONS(6594),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6594),
    [anon_sym_BSLASHinput] = ACTIONS(6594),
    [anon_sym_BSLASHsubfile] = ACTIONS(6594),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6594),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6594),
    [anon_sym_BSLASHbibliography] = ACTIONS(6594),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6594),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6594),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6594),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6594),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6594),
    [anon_sym_BSLASHimport] = ACTIONS(6594),
    [anon_sym_BSLASHsubimport] = ACTIONS(6594),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6594),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHcaption] = ACTIONS(6594),
    [anon_sym_BSLASHcite] = ACTIONS(6594),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCite] = ACTIONS(6594),
    [anon_sym_BSLASHnocite] = ACTIONS(6594),
    [anon_sym_BSLASHcitet] = ACTIONS(6594),
    [anon_sym_BSLASHcitep] = ACTIONS(6594),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteA] = ACTIONS(6594),
    [anon_sym_BSLASHciteR] = ACTIONS(6594),
    [anon_sym_BSLASHciteS] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6594),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteyear] = ACTIONS(6594),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitedate] = ACTIONS(6594),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteurl] = ACTIONS(6594),
    [anon_sym_BSLASHfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6594),
    [anon_sym_BSLASHcitealt] = ACTIONS(6594),
    [anon_sym_BSLASHcitealp] = ACTIONS(6594),
    [anon_sym_BSLASHcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHparencite] = ACTIONS(6594),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHParencite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHtextcite] = ACTIONS(6594),
    [anon_sym_BSLASHTextcite] = ACTIONS(6594),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHsupercite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite] = ACTIONS(6594),
    [anon_sym_BSLASHAutocite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHVolcite] = ACTIONS(6594),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHavolcite] = ACTIONS(6594),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHNotecite] = ACTIONS(6594),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHlabel] = ACTIONS(6594),
    [anon_sym_BSLASHref] = ACTIONS(6594),
    [anon_sym_BSLASHeqref] = ACTIONS(6594),
    [anon_sym_BSLASHvref] = ACTIONS(6594),
    [anon_sym_BSLASHVref] = ACTIONS(6594),
    [anon_sym_BSLASHautoref] = ACTIONS(6594),
    [anon_sym_BSLASHpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcref] = ACTIONS(6594),
    [anon_sym_BSLASHCref] = ACTIONS(6594),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnameCref] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHdef] = ACTIONS(6594),
    [anon_sym_BSLASHlet] = ACTIONS(6594),
    [anon_sym_BSLASHleft] = ACTIONS(6594),
    [anon_sym_BSLASHbigl] = ACTIONS(6594),
    [anon_sym_BSLASHBigl] = ACTIONS(6594),
    [anon_sym_BSLASHbiggl] = ACTIONS(6594),
    [anon_sym_BSLASHBiggl] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6594),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6594),
    [anon_sym_BSLASHgls] = ACTIONS(6594),
    [anon_sym_BSLASHGls] = ACTIONS(6594),
    [anon_sym_BSLASHGLS] = ACTIONS(6594),
    [anon_sym_BSLASHglspl] = ACTIONS(6594),
    [anon_sym_BSLASHGlspl] = ACTIONS(6594),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6594),
    [anon_sym_BSLASHglslink] = ACTIONS(6594),
    [anon_sym_BSLASHglstext] = ACTIONS(6594),
    [anon_sym_BSLASHGlstext] = ACTIONS(6594),
    [anon_sym_BSLASHGLStext] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6594),
    [anon_sym_BSLASHglsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsname] = ACTIONS(6594),
    [anon_sym_BSLASHGlsname] = ACTIONS(6594),
    [anon_sym_BSLASHGLSname] = ACTIONS(6594),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6594),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6594),
    [anon_sym_BSLASHacrshort] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6594),
    [anon_sym_BSLASHACRshort] = ACTIONS(6594),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrlong] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6594),
    [anon_sym_BSLASHACRlong] = ACTIONS(6594),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrfull] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6594),
    [anon_sym_BSLASHACRfull] = ACTIONS(6594),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHacs] = ACTIONS(6594),
    [anon_sym_BSLASHAcs] = ACTIONS(6594),
    [anon_sym_BSLASHacsp] = ACTIONS(6594),
    [anon_sym_BSLASHAcsp] = ACTIONS(6594),
    [anon_sym_BSLASHacl] = ACTIONS(6594),
    [anon_sym_BSLASHAcl] = ACTIONS(6594),
    [anon_sym_BSLASHaclp] = ACTIONS(6594),
    [anon_sym_BSLASHAclp] = ACTIONS(6594),
    [anon_sym_BSLASHacf] = ACTIONS(6594),
    [anon_sym_BSLASHAcf] = ACTIONS(6594),
    [anon_sym_BSLASHacfp] = ACTIONS(6594),
    [anon_sym_BSLASHAcfp] = ACTIONS(6594),
    [anon_sym_BSLASHac] = ACTIONS(6594),
    [anon_sym_BSLASHAc] = ACTIONS(6594),
    [anon_sym_BSLASHacp] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6594),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6594),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6594),
    [anon_sym_BSLASHcolor] = ACTIONS(6594),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6594),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6594),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6594),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6594),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6594),
    [anon_sym_BSLASHtext] = ACTIONS(6594),
    [anon_sym_BSLASHintertext] = ACTIONS(6594),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6594),
    [anon_sym_BSLASHurl] = ACTIONS(6594),
    [anon_sym_BSLASHhref] = ACTIONS(6594),
  },
  [1001] = {
    [ts_builtin_sym_end] = ACTIONS(6476),
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_LBRACK] = ACTIONS(6476),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_RPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHpart] = ACTIONS(6474),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddpart] = ACTIONS(6474),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHchapter] = ACTIONS(6474),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddchap] = ACTIONS(6474),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsection] = ACTIONS(6474),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddsec] = ACTIONS(6474),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHitem] = ACTIONS(6474),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [anon_sym_RBRACE] = ACTIONS(6476),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6476),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6476),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHbegin] = ACTIONS(6474),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHleft] = ACTIONS(6474),
    [anon_sym_BSLASHbigl] = ACTIONS(6474),
    [anon_sym_BSLASHBigl] = ACTIONS(6474),
    [anon_sym_BSLASHbiggl] = ACTIONS(6474),
    [anon_sym_BSLASHBiggl] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHtext] = ACTIONS(6474),
    [anon_sym_BSLASHintertext] = ACTIONS(6474),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [1002] = {
    [ts_builtin_sym_end] = ACTIONS(6480),
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6480),
    [anon_sym_EQ] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6480),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHpart] = ACTIONS(6478),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddpart] = ACTIONS(6478),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHchapter] = ACTIONS(6478),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddchap] = ACTIONS(6478),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsection] = ACTIONS(6478),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddsec] = ACTIONS(6478),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHitem] = ACTIONS(6478),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [anon_sym_RBRACE] = ACTIONS(6480),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6480),
    [anon_sym_DOLLAR] = ACTIONS(6478),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHbegin] = ACTIONS(6478),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHleft] = ACTIONS(6478),
    [anon_sym_BSLASHbigl] = ACTIONS(6478),
    [anon_sym_BSLASHBigl] = ACTIONS(6478),
    [anon_sym_BSLASHbiggl] = ACTIONS(6478),
    [anon_sym_BSLASHBiggl] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHtext] = ACTIONS(6478),
    [anon_sym_BSLASHintertext] = ACTIONS(6478),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [1003] = {
    [ts_builtin_sym_end] = ACTIONS(6484),
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6484),
    [anon_sym_RBRACK] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6484),
    [anon_sym_EQ] = ACTIONS(6484),
    [anon_sym_LPAREN] = ACTIONS(6484),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHpart] = ACTIONS(6482),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddpart] = ACTIONS(6482),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHchapter] = ACTIONS(6482),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddchap] = ACTIONS(6482),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsection] = ACTIONS(6482),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddsec] = ACTIONS(6482),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHitem] = ACTIONS(6482),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6484),
    [anon_sym_LBRACE] = ACTIONS(6484),
    [anon_sym_RBRACE] = ACTIONS(6484),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6484),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6484),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHbegin] = ACTIONS(6482),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHleft] = ACTIONS(6482),
    [anon_sym_BSLASHbigl] = ACTIONS(6482),
    [anon_sym_BSLASHBigl] = ACTIONS(6482),
    [anon_sym_BSLASHbiggl] = ACTIONS(6482),
    [anon_sym_BSLASHBiggl] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHtext] = ACTIONS(6482),
    [anon_sym_BSLASHintertext] = ACTIONS(6482),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [1004] = {
    [ts_builtin_sym_end] = ACTIONS(6488),
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_LBRACK] = ACTIONS(6488),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_COMMA] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6488),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHpart] = ACTIONS(6486),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddpart] = ACTIONS(6486),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHchapter] = ACTIONS(6486),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddchap] = ACTIONS(6486),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsection] = ACTIONS(6486),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddsec] = ACTIONS(6486),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHitem] = ACTIONS(6486),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [anon_sym_RBRACE] = ACTIONS(6488),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6488),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(6486),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHbegin] = ACTIONS(6486),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHleft] = ACTIONS(6486),
    [anon_sym_BSLASHbigl] = ACTIONS(6486),
    [anon_sym_BSLASHBigl] = ACTIONS(6486),
    [anon_sym_BSLASHbiggl] = ACTIONS(6486),
    [anon_sym_BSLASHBiggl] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHtext] = ACTIONS(6486),
    [anon_sym_BSLASHintertext] = ACTIONS(6486),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [1005] = {
    [ts_builtin_sym_end] = ACTIONS(6224),
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6224),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_LPAREN] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHpart] = ACTIONS(6222),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddpart] = ACTIONS(6222),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHchapter] = ACTIONS(6222),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddchap] = ACTIONS(6222),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsection] = ACTIONS(6222),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddsec] = ACTIONS(6222),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHitem] = ACTIONS(6222),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [anon_sym_RBRACE] = ACTIONS(6224),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6224),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6224),
    [anon_sym_DOLLAR] = ACTIONS(6222),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHbegin] = ACTIONS(6222),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHleft] = ACTIONS(6222),
    [anon_sym_BSLASHbigl] = ACTIONS(6222),
    [anon_sym_BSLASHBigl] = ACTIONS(6222),
    [anon_sym_BSLASHbiggl] = ACTIONS(6222),
    [anon_sym_BSLASHBiggl] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHtext] = ACTIONS(6222),
    [anon_sym_BSLASHintertext] = ACTIONS(6222),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [1006] = {
    [ts_builtin_sym_end] = ACTIONS(6672),
    [sym_command_name] = ACTIONS(6670),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6670),
    [anon_sym_LBRACK] = ACTIONS(6672),
    [anon_sym_RBRACK] = ACTIONS(6672),
    [anon_sym_COMMA] = ACTIONS(6672),
    [anon_sym_EQ] = ACTIONS(6672),
    [anon_sym_LPAREN] = ACTIONS(6672),
    [anon_sym_RPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHpart] = ACTIONS(6670),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddpart] = ACTIONS(6670),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHchapter] = ACTIONS(6670),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddchap] = ACTIONS(6670),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsection] = ACTIONS(6670),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddsec] = ACTIONS(6670),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHitem] = ACTIONS(6670),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6672),
    [anon_sym_LBRACE] = ACTIONS(6672),
    [anon_sym_RBRACE] = ACTIONS(6672),
    [sym_word] = ACTIONS(6670),
    [sym_placeholder] = ACTIONS(6672),
    [anon_sym_PLUS] = ACTIONS(6672),
    [anon_sym_DASH] = ACTIONS(6672),
    [anon_sym_STAR] = ACTIONS(6672),
    [anon_sym_SLASH] = ACTIONS(6672),
    [anon_sym_LT] = ACTIONS(6670),
    [anon_sym_GT] = ACTIONS(6670),
    [anon_sym_BANG] = ACTIONS(6670),
    [anon_sym_PIPE] = ACTIONS(6670),
    [anon_sym_COLON] = ACTIONS(6670),
    [anon_sym_SQUOTE] = ACTIONS(6670),
    [anon_sym__] = ACTIONS(6672),
    [anon_sym_CARET] = ACTIONS(6672),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6672),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6672),
    [anon_sym_DOLLAR] = ACTIONS(6670),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHbegin] = ACTIONS(6670),
    [anon_sym_BSLASHtitle] = ACTIONS(6670),
    [anon_sym_BSLASHauthor] = ACTIONS(6670),
    [anon_sym_BSLASHusepackage] = ACTIONS(6670),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6670),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6670),
    [anon_sym_BSLASHinclude] = ACTIONS(6670),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6670),
    [anon_sym_BSLASHinput] = ACTIONS(6670),
    [anon_sym_BSLASHsubfile] = ACTIONS(6670),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6670),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6670),
    [anon_sym_BSLASHbibliography] = ACTIONS(6670),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6670),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6670),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6670),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6670),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6670),
    [anon_sym_BSLASHimport] = ACTIONS(6670),
    [anon_sym_BSLASHsubimport] = ACTIONS(6670),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6670),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHcaption] = ACTIONS(6670),
    [anon_sym_BSLASHcite] = ACTIONS(6670),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCite] = ACTIONS(6670),
    [anon_sym_BSLASHnocite] = ACTIONS(6670),
    [anon_sym_BSLASHcitet] = ACTIONS(6670),
    [anon_sym_BSLASHcitep] = ACTIONS(6670),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteA] = ACTIONS(6670),
    [anon_sym_BSLASHciteR] = ACTIONS(6670),
    [anon_sym_BSLASHciteS] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6670),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteyear] = ACTIONS(6670),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitedate] = ACTIONS(6670),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteurl] = ACTIONS(6670),
    [anon_sym_BSLASHfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6670),
    [anon_sym_BSLASHcitealt] = ACTIONS(6670),
    [anon_sym_BSLASHcitealp] = ACTIONS(6670),
    [anon_sym_BSLASHcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHparencite] = ACTIONS(6670),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHParencite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHtextcite] = ACTIONS(6670),
    [anon_sym_BSLASHTextcite] = ACTIONS(6670),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHsupercite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite] = ACTIONS(6670),
    [anon_sym_BSLASHAutocite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHVolcite] = ACTIONS(6670),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHavolcite] = ACTIONS(6670),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHNotecite] = ACTIONS(6670),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHlabel] = ACTIONS(6670),
    [anon_sym_BSLASHref] = ACTIONS(6670),
    [anon_sym_BSLASHeqref] = ACTIONS(6670),
    [anon_sym_BSLASHvref] = ACTIONS(6670),
    [anon_sym_BSLASHVref] = ACTIONS(6670),
    [anon_sym_BSLASHautoref] = ACTIONS(6670),
    [anon_sym_BSLASHpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcref] = ACTIONS(6670),
    [anon_sym_BSLASHCref] = ACTIONS(6670),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnameCref] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHdef] = ACTIONS(6670),
    [anon_sym_BSLASHlet] = ACTIONS(6670),
    [anon_sym_BSLASHleft] = ACTIONS(6670),
    [anon_sym_BSLASHbigl] = ACTIONS(6670),
    [anon_sym_BSLASHBigl] = ACTIONS(6670),
    [anon_sym_BSLASHbiggl] = ACTIONS(6670),
    [anon_sym_BSLASHBiggl] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6670),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6670),
    [anon_sym_BSLASHgls] = ACTIONS(6670),
    [anon_sym_BSLASHGls] = ACTIONS(6670),
    [anon_sym_BSLASHGLS] = ACTIONS(6670),
    [anon_sym_BSLASHglspl] = ACTIONS(6670),
    [anon_sym_BSLASHGlspl] = ACTIONS(6670),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6670),
    [anon_sym_BSLASHglslink] = ACTIONS(6670),
    [anon_sym_BSLASHglstext] = ACTIONS(6670),
    [anon_sym_BSLASHGlstext] = ACTIONS(6670),
    [anon_sym_BSLASHGLStext] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6670),
    [anon_sym_BSLASHglsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsname] = ACTIONS(6670),
    [anon_sym_BSLASHGlsname] = ACTIONS(6670),
    [anon_sym_BSLASHGLSname] = ACTIONS(6670),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6670),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6670),
    [anon_sym_BSLASHacrshort] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6670),
    [anon_sym_BSLASHACRshort] = ACTIONS(6670),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrlong] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6670),
    [anon_sym_BSLASHACRlong] = ACTIONS(6670),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrfull] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6670),
    [anon_sym_BSLASHACRfull] = ACTIONS(6670),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHacs] = ACTIONS(6670),
    [anon_sym_BSLASHAcs] = ACTIONS(6670),
    [anon_sym_BSLASHacsp] = ACTIONS(6670),
    [anon_sym_BSLASHAcsp] = ACTIONS(6670),
    [anon_sym_BSLASHacl] = ACTIONS(6670),
    [anon_sym_BSLASHAcl] = ACTIONS(6670),
    [anon_sym_BSLASHaclp] = ACTIONS(6670),
    [anon_sym_BSLASHAclp] = ACTIONS(6670),
    [anon_sym_BSLASHacf] = ACTIONS(6670),
    [anon_sym_BSLASHAcf] = ACTIONS(6670),
    [anon_sym_BSLASHacfp] = ACTIONS(6670),
    [anon_sym_BSLASHAcfp] = ACTIONS(6670),
    [anon_sym_BSLASHac] = ACTIONS(6670),
    [anon_sym_BSLASHAc] = ACTIONS(6670),
    [anon_sym_BSLASHacp] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6670),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6670),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6670),
    [anon_sym_BSLASHcolor] = ACTIONS(6670),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6670),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6670),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6670),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6670),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6670),
    [anon_sym_BSLASHtext] = ACTIONS(6670),
    [anon_sym_BSLASHintertext] = ACTIONS(6670),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6670),
    [anon_sym_BSLASHurl] = ACTIONS(6670),
    [anon_sym_BSLASHhref] = ACTIONS(6670),
  },
  [1007] = {
    [ts_builtin_sym_end] = ACTIONS(6564),
    [sym_command_name] = ACTIONS(6562),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6562),
    [anon_sym_LBRACK] = ACTIONS(6564),
    [anon_sym_RBRACK] = ACTIONS(6564),
    [anon_sym_COMMA] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6564),
    [anon_sym_RPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHpart] = ACTIONS(6562),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddpart] = ACTIONS(6562),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHchapter] = ACTIONS(6562),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddchap] = ACTIONS(6562),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsection] = ACTIONS(6562),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddsec] = ACTIONS(6562),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHitem] = ACTIONS(6562),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6564),
    [anon_sym_LBRACE] = ACTIONS(6564),
    [anon_sym_RBRACE] = ACTIONS(6564),
    [sym_word] = ACTIONS(6562),
    [sym_placeholder] = ACTIONS(6564),
    [anon_sym_PLUS] = ACTIONS(6564),
    [anon_sym_DASH] = ACTIONS(6564),
    [anon_sym_STAR] = ACTIONS(6564),
    [anon_sym_SLASH] = ACTIONS(6564),
    [anon_sym_LT] = ACTIONS(6562),
    [anon_sym_GT] = ACTIONS(6562),
    [anon_sym_BANG] = ACTIONS(6562),
    [anon_sym_PIPE] = ACTIONS(6562),
    [anon_sym_COLON] = ACTIONS(6562),
    [anon_sym_SQUOTE] = ACTIONS(6562),
    [anon_sym__] = ACTIONS(6564),
    [anon_sym_CARET] = ACTIONS(6564),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6564),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6564),
    [anon_sym_DOLLAR] = ACTIONS(6562),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHbegin] = ACTIONS(6562),
    [anon_sym_BSLASHtitle] = ACTIONS(6562),
    [anon_sym_BSLASHauthor] = ACTIONS(6562),
    [anon_sym_BSLASHusepackage] = ACTIONS(6562),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6562),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6562),
    [anon_sym_BSLASHinclude] = ACTIONS(6562),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6562),
    [anon_sym_BSLASHinput] = ACTIONS(6562),
    [anon_sym_BSLASHsubfile] = ACTIONS(6562),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6562),
    [anon_sym_BSLASHbibliography] = ACTIONS(6562),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6562),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6562),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6562),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6562),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6562),
    [anon_sym_BSLASHimport] = ACTIONS(6562),
    [anon_sym_BSLASHsubimport] = ACTIONS(6562),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6562),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHcaption] = ACTIONS(6562),
    [anon_sym_BSLASHcite] = ACTIONS(6562),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCite] = ACTIONS(6562),
    [anon_sym_BSLASHnocite] = ACTIONS(6562),
    [anon_sym_BSLASHcitet] = ACTIONS(6562),
    [anon_sym_BSLASHcitep] = ACTIONS(6562),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteA] = ACTIONS(6562),
    [anon_sym_BSLASHciteR] = ACTIONS(6562),
    [anon_sym_BSLASHciteS] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6562),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteyear] = ACTIONS(6562),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitedate] = ACTIONS(6562),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteurl] = ACTIONS(6562),
    [anon_sym_BSLASHfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6562),
    [anon_sym_BSLASHcitealt] = ACTIONS(6562),
    [anon_sym_BSLASHcitealp] = ACTIONS(6562),
    [anon_sym_BSLASHcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHparencite] = ACTIONS(6562),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHParencite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHtextcite] = ACTIONS(6562),
    [anon_sym_BSLASHTextcite] = ACTIONS(6562),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHsupercite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite] = ACTIONS(6562),
    [anon_sym_BSLASHAutocite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHVolcite] = ACTIONS(6562),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHavolcite] = ACTIONS(6562),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHNotecite] = ACTIONS(6562),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHlabel] = ACTIONS(6562),
    [anon_sym_BSLASHref] = ACTIONS(6562),
    [anon_sym_BSLASHeqref] = ACTIONS(6562),
    [anon_sym_BSLASHvref] = ACTIONS(6562),
    [anon_sym_BSLASHVref] = ACTIONS(6562),
    [anon_sym_BSLASHautoref] = ACTIONS(6562),
    [anon_sym_BSLASHpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcref] = ACTIONS(6562),
    [anon_sym_BSLASHCref] = ACTIONS(6562),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnameCref] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHdef] = ACTIONS(6562),
    [anon_sym_BSLASHlet] = ACTIONS(6562),
    [anon_sym_BSLASHleft] = ACTIONS(6562),
    [anon_sym_BSLASHbigl] = ACTIONS(6562),
    [anon_sym_BSLASHBigl] = ACTIONS(6562),
    [anon_sym_BSLASHbiggl] = ACTIONS(6562),
    [anon_sym_BSLASHBiggl] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6562),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6562),
    [anon_sym_BSLASHgls] = ACTIONS(6562),
    [anon_sym_BSLASHGls] = ACTIONS(6562),
    [anon_sym_BSLASHGLS] = ACTIONS(6562),
    [anon_sym_BSLASHglspl] = ACTIONS(6562),
    [anon_sym_BSLASHGlspl] = ACTIONS(6562),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6562),
    [anon_sym_BSLASHglslink] = ACTIONS(6562),
    [anon_sym_BSLASHglstext] = ACTIONS(6562),
    [anon_sym_BSLASHGlstext] = ACTIONS(6562),
    [anon_sym_BSLASHGLStext] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6562),
    [anon_sym_BSLASHglsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsname] = ACTIONS(6562),
    [anon_sym_BSLASHGlsname] = ACTIONS(6562),
    [anon_sym_BSLASHGLSname] = ACTIONS(6562),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6562),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6562),
    [anon_sym_BSLASHacrshort] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6562),
    [anon_sym_BSLASHACRshort] = ACTIONS(6562),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrlong] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6562),
    [anon_sym_BSLASHACRlong] = ACTIONS(6562),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrfull] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6562),
    [anon_sym_BSLASHACRfull] = ACTIONS(6562),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHacs] = ACTIONS(6562),
    [anon_sym_BSLASHAcs] = ACTIONS(6562),
    [anon_sym_BSLASHacsp] = ACTIONS(6562),
    [anon_sym_BSLASHAcsp] = ACTIONS(6562),
    [anon_sym_BSLASHacl] = ACTIONS(6562),
    [anon_sym_BSLASHAcl] = ACTIONS(6562),
    [anon_sym_BSLASHaclp] = ACTIONS(6562),
    [anon_sym_BSLASHAclp] = ACTIONS(6562),
    [anon_sym_BSLASHacf] = ACTIONS(6562),
    [anon_sym_BSLASHAcf] = ACTIONS(6562),
    [anon_sym_BSLASHacfp] = ACTIONS(6562),
    [anon_sym_BSLASHAcfp] = ACTIONS(6562),
    [anon_sym_BSLASHac] = ACTIONS(6562),
    [anon_sym_BSLASHAc] = ACTIONS(6562),
    [anon_sym_BSLASHacp] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6562),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6562),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6562),
    [anon_sym_BSLASHcolor] = ACTIONS(6562),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6562),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6562),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6562),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6562),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6562),
    [anon_sym_BSLASHtext] = ACTIONS(6562),
    [anon_sym_BSLASHintertext] = ACTIONS(6562),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6562),
    [anon_sym_BSLASHurl] = ACTIONS(6562),
    [anon_sym_BSLASHhref] = ACTIONS(6562),
  },
  [1008] = {
    [ts_builtin_sym_end] = ACTIONS(6592),
    [sym_command_name] = ACTIONS(6590),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6590),
    [anon_sym_LBRACK] = ACTIONS(6592),
    [anon_sym_RBRACK] = ACTIONS(6592),
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(6592),
    [anon_sym_LPAREN] = ACTIONS(6592),
    [anon_sym_RPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHpart] = ACTIONS(6590),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddpart] = ACTIONS(6590),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHchapter] = ACTIONS(6590),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddchap] = ACTIONS(6590),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsection] = ACTIONS(6590),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddsec] = ACTIONS(6590),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHitem] = ACTIONS(6590),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6592),
    [anon_sym_LBRACE] = ACTIONS(6592),
    [anon_sym_RBRACE] = ACTIONS(6592),
    [sym_word] = ACTIONS(6590),
    [sym_placeholder] = ACTIONS(6592),
    [anon_sym_PLUS] = ACTIONS(6592),
    [anon_sym_DASH] = ACTIONS(6592),
    [anon_sym_STAR] = ACTIONS(6592),
    [anon_sym_SLASH] = ACTIONS(6592),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6592),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6592),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6592),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHbegin] = ACTIONS(6590),
    [anon_sym_BSLASHtitle] = ACTIONS(6590),
    [anon_sym_BSLASHauthor] = ACTIONS(6590),
    [anon_sym_BSLASHusepackage] = ACTIONS(6590),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6590),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6590),
    [anon_sym_BSLASHinclude] = ACTIONS(6590),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6590),
    [anon_sym_BSLASHinput] = ACTIONS(6590),
    [anon_sym_BSLASHsubfile] = ACTIONS(6590),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6590),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6590),
    [anon_sym_BSLASHbibliography] = ACTIONS(6590),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6590),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6590),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6590),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6590),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6590),
    [anon_sym_BSLASHimport] = ACTIONS(6590),
    [anon_sym_BSLASHsubimport] = ACTIONS(6590),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6590),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHcaption] = ACTIONS(6590),
    [anon_sym_BSLASHcite] = ACTIONS(6590),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCite] = ACTIONS(6590),
    [anon_sym_BSLASHnocite] = ACTIONS(6590),
    [anon_sym_BSLASHcitet] = ACTIONS(6590),
    [anon_sym_BSLASHcitep] = ACTIONS(6590),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteA] = ACTIONS(6590),
    [anon_sym_BSLASHciteR] = ACTIONS(6590),
    [anon_sym_BSLASHciteS] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6590),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteyear] = ACTIONS(6590),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitedate] = ACTIONS(6590),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteurl] = ACTIONS(6590),
    [anon_sym_BSLASHfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6590),
    [anon_sym_BSLASHcitealt] = ACTIONS(6590),
    [anon_sym_BSLASHcitealp] = ACTIONS(6590),
    [anon_sym_BSLASHcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHparencite] = ACTIONS(6590),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHParencite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHtextcite] = ACTIONS(6590),
    [anon_sym_BSLASHTextcite] = ACTIONS(6590),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHsupercite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite] = ACTIONS(6590),
    [anon_sym_BSLASHAutocite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHVolcite] = ACTIONS(6590),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHavolcite] = ACTIONS(6590),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHNotecite] = ACTIONS(6590),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHlabel] = ACTIONS(6590),
    [anon_sym_BSLASHref] = ACTIONS(6590),
    [anon_sym_BSLASHeqref] = ACTIONS(6590),
    [anon_sym_BSLASHvref] = ACTIONS(6590),
    [anon_sym_BSLASHVref] = ACTIONS(6590),
    [anon_sym_BSLASHautoref] = ACTIONS(6590),
    [anon_sym_BSLASHpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcref] = ACTIONS(6590),
    [anon_sym_BSLASHCref] = ACTIONS(6590),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnameCref] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHdef] = ACTIONS(6590),
    [anon_sym_BSLASHlet] = ACTIONS(6590),
    [anon_sym_BSLASHleft] = ACTIONS(6590),
    [anon_sym_BSLASHbigl] = ACTIONS(6590),
    [anon_sym_BSLASHBigl] = ACTIONS(6590),
    [anon_sym_BSLASHbiggl] = ACTIONS(6590),
    [anon_sym_BSLASHBiggl] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6590),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6590),
    [anon_sym_BSLASHgls] = ACTIONS(6590),
    [anon_sym_BSLASHGls] = ACTIONS(6590),
    [anon_sym_BSLASHGLS] = ACTIONS(6590),
    [anon_sym_BSLASHglspl] = ACTIONS(6590),
    [anon_sym_BSLASHGlspl] = ACTIONS(6590),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6590),
    [anon_sym_BSLASHglslink] = ACTIONS(6590),
    [anon_sym_BSLASHglstext] = ACTIONS(6590),
    [anon_sym_BSLASHGlstext] = ACTIONS(6590),
    [anon_sym_BSLASHGLStext] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6590),
    [anon_sym_BSLASHglsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsname] = ACTIONS(6590),
    [anon_sym_BSLASHGlsname] = ACTIONS(6590),
    [anon_sym_BSLASHGLSname] = ACTIONS(6590),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6590),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6590),
    [anon_sym_BSLASHacrshort] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6590),
    [anon_sym_BSLASHACRshort] = ACTIONS(6590),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrlong] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6590),
    [anon_sym_BSLASHACRlong] = ACTIONS(6590),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrfull] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6590),
    [anon_sym_BSLASHACRfull] = ACTIONS(6590),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHacs] = ACTIONS(6590),
    [anon_sym_BSLASHAcs] = ACTIONS(6590),
    [anon_sym_BSLASHacsp] = ACTIONS(6590),
    [anon_sym_BSLASHAcsp] = ACTIONS(6590),
    [anon_sym_BSLASHacl] = ACTIONS(6590),
    [anon_sym_BSLASHAcl] = ACTIONS(6590),
    [anon_sym_BSLASHaclp] = ACTIONS(6590),
    [anon_sym_BSLASHAclp] = ACTIONS(6590),
    [anon_sym_BSLASHacf] = ACTIONS(6590),
    [anon_sym_BSLASHAcf] = ACTIONS(6590),
    [anon_sym_BSLASHacfp] = ACTIONS(6590),
    [anon_sym_BSLASHAcfp] = ACTIONS(6590),
    [anon_sym_BSLASHac] = ACTIONS(6590),
    [anon_sym_BSLASHAc] = ACTIONS(6590),
    [anon_sym_BSLASHacp] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6590),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6590),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6590),
    [anon_sym_BSLASHcolor] = ACTIONS(6590),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6590),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6590),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6590),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6590),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6590),
    [anon_sym_BSLASHtext] = ACTIONS(6590),
    [anon_sym_BSLASHintertext] = ACTIONS(6590),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6590),
    [anon_sym_BSLASHurl] = ACTIONS(6590),
    [anon_sym_BSLASHhref] = ACTIONS(6590),
  },
  [1009] = {
    [ts_builtin_sym_end] = ACTIONS(6600),
    [sym_command_name] = ACTIONS(6598),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6598),
    [anon_sym_LBRACK] = ACTIONS(6600),
    [anon_sym_RBRACK] = ACTIONS(6600),
    [anon_sym_COMMA] = ACTIONS(6600),
    [anon_sym_EQ] = ACTIONS(6600),
    [anon_sym_LPAREN] = ACTIONS(6600),
    [anon_sym_RPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHpart] = ACTIONS(6598),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddpart] = ACTIONS(6598),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHchapter] = ACTIONS(6598),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddchap] = ACTIONS(6598),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsection] = ACTIONS(6598),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddsec] = ACTIONS(6598),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHitem] = ACTIONS(6598),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6600),
    [anon_sym_LBRACE] = ACTIONS(6600),
    [anon_sym_RBRACE] = ACTIONS(6600),
    [sym_word] = ACTIONS(6598),
    [sym_placeholder] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6600),
    [anon_sym_DASH] = ACTIONS(6600),
    [anon_sym_STAR] = ACTIONS(6600),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_BANG] = ACTIONS(6598),
    [anon_sym_PIPE] = ACTIONS(6598),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_SQUOTE] = ACTIONS(6598),
    [anon_sym__] = ACTIONS(6600),
    [anon_sym_CARET] = ACTIONS(6600),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6600),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6600),
    [anon_sym_DOLLAR] = ACTIONS(6598),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHbegin] = ACTIONS(6598),
    [anon_sym_BSLASHtitle] = ACTIONS(6598),
    [anon_sym_BSLASHauthor] = ACTIONS(6598),
    [anon_sym_BSLASHusepackage] = ACTIONS(6598),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6598),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6598),
    [anon_sym_BSLASHinclude] = ACTIONS(6598),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6598),
    [anon_sym_BSLASHinput] = ACTIONS(6598),
    [anon_sym_BSLASHsubfile] = ACTIONS(6598),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6598),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6598),
    [anon_sym_BSLASHbibliography] = ACTIONS(6598),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6598),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6598),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6598),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6598),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6598),
    [anon_sym_BSLASHimport] = ACTIONS(6598),
    [anon_sym_BSLASHsubimport] = ACTIONS(6598),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6598),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHcaption] = ACTIONS(6598),
    [anon_sym_BSLASHcite] = ACTIONS(6598),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCite] = ACTIONS(6598),
    [anon_sym_BSLASHnocite] = ACTIONS(6598),
    [anon_sym_BSLASHcitet] = ACTIONS(6598),
    [anon_sym_BSLASHcitep] = ACTIONS(6598),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteA] = ACTIONS(6598),
    [anon_sym_BSLASHciteR] = ACTIONS(6598),
    [anon_sym_BSLASHciteS] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6598),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteyear] = ACTIONS(6598),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitedate] = ACTIONS(6598),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteurl] = ACTIONS(6598),
    [anon_sym_BSLASHfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6598),
    [anon_sym_BSLASHcitealt] = ACTIONS(6598),
    [anon_sym_BSLASHcitealp] = ACTIONS(6598),
    [anon_sym_BSLASHcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHparencite] = ACTIONS(6598),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHParencite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHtextcite] = ACTIONS(6598),
    [anon_sym_BSLASHTextcite] = ACTIONS(6598),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHsupercite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite] = ACTIONS(6598),
    [anon_sym_BSLASHAutocite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHVolcite] = ACTIONS(6598),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHavolcite] = ACTIONS(6598),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHNotecite] = ACTIONS(6598),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHlabel] = ACTIONS(6598),
    [anon_sym_BSLASHref] = ACTIONS(6598),
    [anon_sym_BSLASHeqref] = ACTIONS(6598),
    [anon_sym_BSLASHvref] = ACTIONS(6598),
    [anon_sym_BSLASHVref] = ACTIONS(6598),
    [anon_sym_BSLASHautoref] = ACTIONS(6598),
    [anon_sym_BSLASHpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcref] = ACTIONS(6598),
    [anon_sym_BSLASHCref] = ACTIONS(6598),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnameCref] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHdef] = ACTIONS(6598),
    [anon_sym_BSLASHlet] = ACTIONS(6598),
    [anon_sym_BSLASHleft] = ACTIONS(6598),
    [anon_sym_BSLASHbigl] = ACTIONS(6598),
    [anon_sym_BSLASHBigl] = ACTIONS(6598),
    [anon_sym_BSLASHbiggl] = ACTIONS(6598),
    [anon_sym_BSLASHBiggl] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6598),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6598),
    [anon_sym_BSLASHgls] = ACTIONS(6598),
    [anon_sym_BSLASHGls] = ACTIONS(6598),
    [anon_sym_BSLASHGLS] = ACTIONS(6598),
    [anon_sym_BSLASHglspl] = ACTIONS(6598),
    [anon_sym_BSLASHGlspl] = ACTIONS(6598),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6598),
    [anon_sym_BSLASHglslink] = ACTIONS(6598),
    [anon_sym_BSLASHglstext] = ACTIONS(6598),
    [anon_sym_BSLASHGlstext] = ACTIONS(6598),
    [anon_sym_BSLASHGLStext] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6598),
    [anon_sym_BSLASHglsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsname] = ACTIONS(6598),
    [anon_sym_BSLASHGlsname] = ACTIONS(6598),
    [anon_sym_BSLASHGLSname] = ACTIONS(6598),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6598),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6598),
    [anon_sym_BSLASHacrshort] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6598),
    [anon_sym_BSLASHACRshort] = ACTIONS(6598),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrlong] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6598),
    [anon_sym_BSLASHACRlong] = ACTIONS(6598),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrfull] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6598),
    [anon_sym_BSLASHACRfull] = ACTIONS(6598),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHacs] = ACTIONS(6598),
    [anon_sym_BSLASHAcs] = ACTIONS(6598),
    [anon_sym_BSLASHacsp] = ACTIONS(6598),
    [anon_sym_BSLASHAcsp] = ACTIONS(6598),
    [anon_sym_BSLASHacl] = ACTIONS(6598),
    [anon_sym_BSLASHAcl] = ACTIONS(6598),
    [anon_sym_BSLASHaclp] = ACTIONS(6598),
    [anon_sym_BSLASHAclp] = ACTIONS(6598),
    [anon_sym_BSLASHacf] = ACTIONS(6598),
    [anon_sym_BSLASHAcf] = ACTIONS(6598),
    [anon_sym_BSLASHacfp] = ACTIONS(6598),
    [anon_sym_BSLASHAcfp] = ACTIONS(6598),
    [anon_sym_BSLASHac] = ACTIONS(6598),
    [anon_sym_BSLASHAc] = ACTIONS(6598),
    [anon_sym_BSLASHacp] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6598),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6598),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6598),
    [anon_sym_BSLASHcolor] = ACTIONS(6598),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6598),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6598),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6598),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6598),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6598),
    [anon_sym_BSLASHtext] = ACTIONS(6598),
    [anon_sym_BSLASHintertext] = ACTIONS(6598),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6598),
    [anon_sym_BSLASHurl] = ACTIONS(6598),
    [anon_sym_BSLASHhref] = ACTIONS(6598),
  },
  [1010] = {
    [ts_builtin_sym_end] = ACTIONS(6628),
    [sym_command_name] = ACTIONS(6626),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6628),
    [anon_sym_RBRACK] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LPAREN] = ACTIONS(6628),
    [anon_sym_RPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHpart] = ACTIONS(6626),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddpart] = ACTIONS(6626),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHchapter] = ACTIONS(6626),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddchap] = ACTIONS(6626),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsection] = ACTIONS(6626),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddsec] = ACTIONS(6626),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHitem] = ACTIONS(6626),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6628),
    [anon_sym_LBRACE] = ACTIONS(6628),
    [anon_sym_RBRACE] = ACTIONS(6628),
    [sym_word] = ACTIONS(6626),
    [sym_placeholder] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_DASH] = ACTIONS(6628),
    [anon_sym_STAR] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6626),
    [anon_sym_GT] = ACTIONS(6626),
    [anon_sym_BANG] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6626),
    [anon_sym_COLON] = ACTIONS(6626),
    [anon_sym_SQUOTE] = ACTIONS(6626),
    [anon_sym__] = ACTIONS(6628),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6628),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6628),
    [anon_sym_DOLLAR] = ACTIONS(6626),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHbegin] = ACTIONS(6626),
    [anon_sym_BSLASHtitle] = ACTIONS(6626),
    [anon_sym_BSLASHauthor] = ACTIONS(6626),
    [anon_sym_BSLASHusepackage] = ACTIONS(6626),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6626),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6626),
    [anon_sym_BSLASHinclude] = ACTIONS(6626),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6626),
    [anon_sym_BSLASHinput] = ACTIONS(6626),
    [anon_sym_BSLASHsubfile] = ACTIONS(6626),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6626),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6626),
    [anon_sym_BSLASHbibliography] = ACTIONS(6626),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6626),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6626),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6626),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6626),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6626),
    [anon_sym_BSLASHimport] = ACTIONS(6626),
    [anon_sym_BSLASHsubimport] = ACTIONS(6626),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6626),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHcaption] = ACTIONS(6626),
    [anon_sym_BSLASHcite] = ACTIONS(6626),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCite] = ACTIONS(6626),
    [anon_sym_BSLASHnocite] = ACTIONS(6626),
    [anon_sym_BSLASHcitet] = ACTIONS(6626),
    [anon_sym_BSLASHcitep] = ACTIONS(6626),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteA] = ACTIONS(6626),
    [anon_sym_BSLASHciteR] = ACTIONS(6626),
    [anon_sym_BSLASHciteS] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6626),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteyear] = ACTIONS(6626),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitedate] = ACTIONS(6626),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteurl] = ACTIONS(6626),
    [anon_sym_BSLASHfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6626),
    [anon_sym_BSLASHcitealt] = ACTIONS(6626),
    [anon_sym_BSLASHcitealp] = ACTIONS(6626),
    [anon_sym_BSLASHcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHparencite] = ACTIONS(6626),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHParencite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHtextcite] = ACTIONS(6626),
    [anon_sym_BSLASHTextcite] = ACTIONS(6626),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHsupercite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite] = ACTIONS(6626),
    [anon_sym_BSLASHAutocite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHVolcite] = ACTIONS(6626),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHavolcite] = ACTIONS(6626),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHNotecite] = ACTIONS(6626),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHlabel] = ACTIONS(6626),
    [anon_sym_BSLASHref] = ACTIONS(6626),
    [anon_sym_BSLASHeqref] = ACTIONS(6626),
    [anon_sym_BSLASHvref] = ACTIONS(6626),
    [anon_sym_BSLASHVref] = ACTIONS(6626),
    [anon_sym_BSLASHautoref] = ACTIONS(6626),
    [anon_sym_BSLASHpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcref] = ACTIONS(6626),
    [anon_sym_BSLASHCref] = ACTIONS(6626),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnameCref] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHdef] = ACTIONS(6626),
    [anon_sym_BSLASHlet] = ACTIONS(6626),
    [anon_sym_BSLASHleft] = ACTIONS(6626),
    [anon_sym_BSLASHbigl] = ACTIONS(6626),
    [anon_sym_BSLASHBigl] = ACTIONS(6626),
    [anon_sym_BSLASHbiggl] = ACTIONS(6626),
    [anon_sym_BSLASHBiggl] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6626),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6626),
    [anon_sym_BSLASHgls] = ACTIONS(6626),
    [anon_sym_BSLASHGls] = ACTIONS(6626),
    [anon_sym_BSLASHGLS] = ACTIONS(6626),
    [anon_sym_BSLASHglspl] = ACTIONS(6626),
    [anon_sym_BSLASHGlspl] = ACTIONS(6626),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6626),
    [anon_sym_BSLASHglslink] = ACTIONS(6626),
    [anon_sym_BSLASHglstext] = ACTIONS(6626),
    [anon_sym_BSLASHGlstext] = ACTIONS(6626),
    [anon_sym_BSLASHGLStext] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6626),
    [anon_sym_BSLASHglsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsname] = ACTIONS(6626),
    [anon_sym_BSLASHGlsname] = ACTIONS(6626),
    [anon_sym_BSLASHGLSname] = ACTIONS(6626),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6626),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6626),
    [anon_sym_BSLASHacrshort] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6626),
    [anon_sym_BSLASHACRshort] = ACTIONS(6626),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrlong] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6626),
    [anon_sym_BSLASHACRlong] = ACTIONS(6626),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrfull] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6626),
    [anon_sym_BSLASHACRfull] = ACTIONS(6626),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHacs] = ACTIONS(6626),
    [anon_sym_BSLASHAcs] = ACTIONS(6626),
    [anon_sym_BSLASHacsp] = ACTIONS(6626),
    [anon_sym_BSLASHAcsp] = ACTIONS(6626),
    [anon_sym_BSLASHacl] = ACTIONS(6626),
    [anon_sym_BSLASHAcl] = ACTIONS(6626),
    [anon_sym_BSLASHaclp] = ACTIONS(6626),
    [anon_sym_BSLASHAclp] = ACTIONS(6626),
    [anon_sym_BSLASHacf] = ACTIONS(6626),
    [anon_sym_BSLASHAcf] = ACTIONS(6626),
    [anon_sym_BSLASHacfp] = ACTIONS(6626),
    [anon_sym_BSLASHAcfp] = ACTIONS(6626),
    [anon_sym_BSLASHac] = ACTIONS(6626),
    [anon_sym_BSLASHAc] = ACTIONS(6626),
    [anon_sym_BSLASHacp] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6626),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6626),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6626),
    [anon_sym_BSLASHcolor] = ACTIONS(6626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6626),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6626),
    [anon_sym_BSLASHtext] = ACTIONS(6626),
    [anon_sym_BSLASHintertext] = ACTIONS(6626),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6626),
    [anon_sym_BSLASHurl] = ACTIONS(6626),
    [anon_sym_BSLASHhref] = ACTIONS(6626),
  },
  [1011] = {
    [ts_builtin_sym_end] = ACTIONS(6632),
    [sym_command_name] = ACTIONS(6630),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LPAREN] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHpart] = ACTIONS(6630),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddpart] = ACTIONS(6630),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHchapter] = ACTIONS(6630),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddchap] = ACTIONS(6630),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsection] = ACTIONS(6630),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddsec] = ACTIONS(6630),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHitem] = ACTIONS(6630),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [sym_word] = ACTIONS(6630),
    [sym_placeholder] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [anon_sym_STAR] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_BANG] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_COLON] = ACTIONS(6630),
    [anon_sym_SQUOTE] = ACTIONS(6630),
    [anon_sym__] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6632),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6632),
    [anon_sym_DOLLAR] = ACTIONS(6630),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHbegin] = ACTIONS(6630),
    [anon_sym_BSLASHtitle] = ACTIONS(6630),
    [anon_sym_BSLASHauthor] = ACTIONS(6630),
    [anon_sym_BSLASHusepackage] = ACTIONS(6630),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6630),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6630),
    [anon_sym_BSLASHinclude] = ACTIONS(6630),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6630),
    [anon_sym_BSLASHinput] = ACTIONS(6630),
    [anon_sym_BSLASHsubfile] = ACTIONS(6630),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6630),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6630),
    [anon_sym_BSLASHbibliography] = ACTIONS(6630),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6630),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6630),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6630),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6630),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6630),
    [anon_sym_BSLASHimport] = ACTIONS(6630),
    [anon_sym_BSLASHsubimport] = ACTIONS(6630),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6630),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHcaption] = ACTIONS(6630),
    [anon_sym_BSLASHcite] = ACTIONS(6630),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCite] = ACTIONS(6630),
    [anon_sym_BSLASHnocite] = ACTIONS(6630),
    [anon_sym_BSLASHcitet] = ACTIONS(6630),
    [anon_sym_BSLASHcitep] = ACTIONS(6630),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteA] = ACTIONS(6630),
    [anon_sym_BSLASHciteR] = ACTIONS(6630),
    [anon_sym_BSLASHciteS] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6630),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteyear] = ACTIONS(6630),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitedate] = ACTIONS(6630),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteurl] = ACTIONS(6630),
    [anon_sym_BSLASHfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6630),
    [anon_sym_BSLASHcitealt] = ACTIONS(6630),
    [anon_sym_BSLASHcitealp] = ACTIONS(6630),
    [anon_sym_BSLASHcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHparencite] = ACTIONS(6630),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHParencite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHtextcite] = ACTIONS(6630),
    [anon_sym_BSLASHTextcite] = ACTIONS(6630),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHsupercite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite] = ACTIONS(6630),
    [anon_sym_BSLASHAutocite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHVolcite] = ACTIONS(6630),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHavolcite] = ACTIONS(6630),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHNotecite] = ACTIONS(6630),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHlabel] = ACTIONS(6630),
    [anon_sym_BSLASHref] = ACTIONS(6630),
    [anon_sym_BSLASHeqref] = ACTIONS(6630),
    [anon_sym_BSLASHvref] = ACTIONS(6630),
    [anon_sym_BSLASHVref] = ACTIONS(6630),
    [anon_sym_BSLASHautoref] = ACTIONS(6630),
    [anon_sym_BSLASHpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcref] = ACTIONS(6630),
    [anon_sym_BSLASHCref] = ACTIONS(6630),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnameCref] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHdef] = ACTIONS(6630),
    [anon_sym_BSLASHlet] = ACTIONS(6630),
    [anon_sym_BSLASHleft] = ACTIONS(6630),
    [anon_sym_BSLASHbigl] = ACTIONS(6630),
    [anon_sym_BSLASHBigl] = ACTIONS(6630),
    [anon_sym_BSLASHbiggl] = ACTIONS(6630),
    [anon_sym_BSLASHBiggl] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6630),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6630),
    [anon_sym_BSLASHgls] = ACTIONS(6630),
    [anon_sym_BSLASHGls] = ACTIONS(6630),
    [anon_sym_BSLASHGLS] = ACTIONS(6630),
    [anon_sym_BSLASHglspl] = ACTIONS(6630),
    [anon_sym_BSLASHGlspl] = ACTIONS(6630),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6630),
    [anon_sym_BSLASHglslink] = ACTIONS(6630),
    [anon_sym_BSLASHglstext] = ACTIONS(6630),
    [anon_sym_BSLASHGlstext] = ACTIONS(6630),
    [anon_sym_BSLASHGLStext] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6630),
    [anon_sym_BSLASHglsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsname] = ACTIONS(6630),
    [anon_sym_BSLASHGlsname] = ACTIONS(6630),
    [anon_sym_BSLASHGLSname] = ACTIONS(6630),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6630),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6630),
    [anon_sym_BSLASHacrshort] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6630),
    [anon_sym_BSLASHACRshort] = ACTIONS(6630),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrlong] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6630),
    [anon_sym_BSLASHACRlong] = ACTIONS(6630),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrfull] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6630),
    [anon_sym_BSLASHACRfull] = ACTIONS(6630),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHacs] = ACTIONS(6630),
    [anon_sym_BSLASHAcs] = ACTIONS(6630),
    [anon_sym_BSLASHacsp] = ACTIONS(6630),
    [anon_sym_BSLASHAcsp] = ACTIONS(6630),
    [anon_sym_BSLASHacl] = ACTIONS(6630),
    [anon_sym_BSLASHAcl] = ACTIONS(6630),
    [anon_sym_BSLASHaclp] = ACTIONS(6630),
    [anon_sym_BSLASHAclp] = ACTIONS(6630),
    [anon_sym_BSLASHacf] = ACTIONS(6630),
    [anon_sym_BSLASHAcf] = ACTIONS(6630),
    [anon_sym_BSLASHacfp] = ACTIONS(6630),
    [anon_sym_BSLASHAcfp] = ACTIONS(6630),
    [anon_sym_BSLASHac] = ACTIONS(6630),
    [anon_sym_BSLASHAc] = ACTIONS(6630),
    [anon_sym_BSLASHacp] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6630),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6630),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6630),
    [anon_sym_BSLASHcolor] = ACTIONS(6630),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6630),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6630),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6630),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6630),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6630),
    [anon_sym_BSLASHtext] = ACTIONS(6630),
    [anon_sym_BSLASHintertext] = ACTIONS(6630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6630),
    [anon_sym_BSLASHurl] = ACTIONS(6630),
    [anon_sym_BSLASHhref] = ACTIONS(6630),
  },
  [1012] = {
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(7075),
    [anon_sym_LBRACK] = ACTIONS(6160),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHpart] = ACTIONS(6156),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddpart] = ACTIONS(6156),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHchapter] = ACTIONS(6156),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddchap] = ACTIONS(6156),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsection] = ACTIONS(6156),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHaddsec] = ACTIONS(6156),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6156),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6156),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHitem] = ACTIONS(6156),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6160),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(6156),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHbegin] = ACTIONS(6156),
    [anon_sym_BSLASHend] = ACTIONS(6156),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHleft] = ACTIONS(6156),
    [anon_sym_BSLASHbigl] = ACTIONS(6156),
    [anon_sym_BSLASHBigl] = ACTIONS(6156),
    [anon_sym_BSLASHbiggl] = ACTIONS(6156),
    [anon_sym_BSLASHBiggl] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHtext] = ACTIONS(6156),
    [anon_sym_BSLASHintertext] = ACTIONS(6156),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [1013] = {
    [sym_brack_group_text] = STATE(1190),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(7059),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHpart] = ACTIONS(6166),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddpart] = ACTIONS(6166),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHchapter] = ACTIONS(6166),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddchap] = ACTIONS(6166),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsection] = ACTIONS(6166),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHaddsec] = ACTIONS(6166),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6166),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6166),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHitem] = ACTIONS(6166),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6168),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6166),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHbegin] = ACTIONS(6166),
    [anon_sym_BSLASHend] = ACTIONS(6166),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHleft] = ACTIONS(6166),
    [anon_sym_BSLASHbigl] = ACTIONS(6166),
    [anon_sym_BSLASHBigl] = ACTIONS(6166),
    [anon_sym_BSLASHbiggl] = ACTIONS(6166),
    [anon_sym_BSLASHBiggl] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHtext] = ACTIONS(6166),
    [anon_sym_BSLASHintertext] = ACTIONS(6166),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [1014] = {
    [ts_builtin_sym_end] = ACTIONS(6420),
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_RBRACK] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHpart] = ACTIONS(6418),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddpart] = ACTIONS(6418),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHchapter] = ACTIONS(6418),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddchap] = ACTIONS(6418),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsection] = ACTIONS(6418),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddsec] = ACTIONS(6418),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHitem] = ACTIONS(6418),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6420),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [anon_sym_RBRACE] = ACTIONS(6420),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6420),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(6418),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHbegin] = ACTIONS(6418),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHleft] = ACTIONS(6418),
    [anon_sym_BSLASHbigl] = ACTIONS(6418),
    [anon_sym_BSLASHBigl] = ACTIONS(6418),
    [anon_sym_BSLASHbiggl] = ACTIONS(6418),
    [anon_sym_BSLASHBiggl] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHtext] = ACTIONS(6418),
    [anon_sym_BSLASHintertext] = ACTIONS(6418),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [1015] = {
    [ts_builtin_sym_end] = ACTIONS(6640),
    [sym_command_name] = ACTIONS(6638),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6640),
    [anon_sym_RBRACK] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LPAREN] = ACTIONS(6640),
    [anon_sym_RPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHpart] = ACTIONS(6638),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddpart] = ACTIONS(6638),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHchapter] = ACTIONS(6638),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddchap] = ACTIONS(6638),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsection] = ACTIONS(6638),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddsec] = ACTIONS(6638),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHitem] = ACTIONS(6638),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(6640),
    [anon_sym_RBRACE] = ACTIONS(6640),
    [sym_word] = ACTIONS(6638),
    [sym_placeholder] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_DASH] = ACTIONS(6640),
    [anon_sym_STAR] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6638),
    [anon_sym_GT] = ACTIONS(6638),
    [anon_sym_BANG] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6638),
    [anon_sym_COLON] = ACTIONS(6638),
    [anon_sym_SQUOTE] = ACTIONS(6638),
    [anon_sym__] = ACTIONS(6640),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6640),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6640),
    [anon_sym_DOLLAR] = ACTIONS(6638),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHbegin] = ACTIONS(6638),
    [anon_sym_BSLASHtitle] = ACTIONS(6638),
    [anon_sym_BSLASHauthor] = ACTIONS(6638),
    [anon_sym_BSLASHusepackage] = ACTIONS(6638),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6638),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6638),
    [anon_sym_BSLASHinclude] = ACTIONS(6638),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6638),
    [anon_sym_BSLASHinput] = ACTIONS(6638),
    [anon_sym_BSLASHsubfile] = ACTIONS(6638),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6638),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6638),
    [anon_sym_BSLASHbibliography] = ACTIONS(6638),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6638),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6638),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6638),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6638),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6638),
    [anon_sym_BSLASHimport] = ACTIONS(6638),
    [anon_sym_BSLASHsubimport] = ACTIONS(6638),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6638),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHcaption] = ACTIONS(6638),
    [anon_sym_BSLASHcite] = ACTIONS(6638),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCite] = ACTIONS(6638),
    [anon_sym_BSLASHnocite] = ACTIONS(6638),
    [anon_sym_BSLASHcitet] = ACTIONS(6638),
    [anon_sym_BSLASHcitep] = ACTIONS(6638),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteA] = ACTIONS(6638),
    [anon_sym_BSLASHciteR] = ACTIONS(6638),
    [anon_sym_BSLASHciteS] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6638),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteyear] = ACTIONS(6638),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitedate] = ACTIONS(6638),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteurl] = ACTIONS(6638),
    [anon_sym_BSLASHfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6638),
    [anon_sym_BSLASHcitealt] = ACTIONS(6638),
    [anon_sym_BSLASHcitealp] = ACTIONS(6638),
    [anon_sym_BSLASHcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHparencite] = ACTIONS(6638),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHParencite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHtextcite] = ACTIONS(6638),
    [anon_sym_BSLASHTextcite] = ACTIONS(6638),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHsupercite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite] = ACTIONS(6638),
    [anon_sym_BSLASHAutocite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHVolcite] = ACTIONS(6638),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHavolcite] = ACTIONS(6638),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHNotecite] = ACTIONS(6638),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHlabel] = ACTIONS(6638),
    [anon_sym_BSLASHref] = ACTIONS(6638),
    [anon_sym_BSLASHeqref] = ACTIONS(6638),
    [anon_sym_BSLASHvref] = ACTIONS(6638),
    [anon_sym_BSLASHVref] = ACTIONS(6638),
    [anon_sym_BSLASHautoref] = ACTIONS(6638),
    [anon_sym_BSLASHpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcref] = ACTIONS(6638),
    [anon_sym_BSLASHCref] = ACTIONS(6638),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnameCref] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHdef] = ACTIONS(6638),
    [anon_sym_BSLASHlet] = ACTIONS(6638),
    [anon_sym_BSLASHleft] = ACTIONS(6638),
    [anon_sym_BSLASHbigl] = ACTIONS(6638),
    [anon_sym_BSLASHBigl] = ACTIONS(6638),
    [anon_sym_BSLASHbiggl] = ACTIONS(6638),
    [anon_sym_BSLASHBiggl] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6638),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6638),
    [anon_sym_BSLASHgls] = ACTIONS(6638),
    [anon_sym_BSLASHGls] = ACTIONS(6638),
    [anon_sym_BSLASHGLS] = ACTIONS(6638),
    [anon_sym_BSLASHglspl] = ACTIONS(6638),
    [anon_sym_BSLASHGlspl] = ACTIONS(6638),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6638),
    [anon_sym_BSLASHglslink] = ACTIONS(6638),
    [anon_sym_BSLASHglstext] = ACTIONS(6638),
    [anon_sym_BSLASHGlstext] = ACTIONS(6638),
    [anon_sym_BSLASHGLStext] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6638),
    [anon_sym_BSLASHglsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsname] = ACTIONS(6638),
    [anon_sym_BSLASHGlsname] = ACTIONS(6638),
    [anon_sym_BSLASHGLSname] = ACTIONS(6638),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6638),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6638),
    [anon_sym_BSLASHacrshort] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6638),
    [anon_sym_BSLASHACRshort] = ACTIONS(6638),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrlong] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6638),
    [anon_sym_BSLASHACRlong] = ACTIONS(6638),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrfull] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6638),
    [anon_sym_BSLASHACRfull] = ACTIONS(6638),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHacs] = ACTIONS(6638),
    [anon_sym_BSLASHAcs] = ACTIONS(6638),
    [anon_sym_BSLASHacsp] = ACTIONS(6638),
    [anon_sym_BSLASHAcsp] = ACTIONS(6638),
    [anon_sym_BSLASHacl] = ACTIONS(6638),
    [anon_sym_BSLASHAcl] = ACTIONS(6638),
    [anon_sym_BSLASHaclp] = ACTIONS(6638),
    [anon_sym_BSLASHAclp] = ACTIONS(6638),
    [anon_sym_BSLASHacf] = ACTIONS(6638),
    [anon_sym_BSLASHAcf] = ACTIONS(6638),
    [anon_sym_BSLASHacfp] = ACTIONS(6638),
    [anon_sym_BSLASHAcfp] = ACTIONS(6638),
    [anon_sym_BSLASHac] = ACTIONS(6638),
    [anon_sym_BSLASHAc] = ACTIONS(6638),
    [anon_sym_BSLASHacp] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6638),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6638),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6638),
    [anon_sym_BSLASHcolor] = ACTIONS(6638),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6638),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6638),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6638),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6638),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6638),
    [anon_sym_BSLASHtext] = ACTIONS(6638),
    [anon_sym_BSLASHintertext] = ACTIONS(6638),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6638),
    [anon_sym_BSLASHurl] = ACTIONS(6638),
    [anon_sym_BSLASHhref] = ACTIONS(6638),
  },
  [1016] = {
    [ts_builtin_sym_end] = ACTIONS(6496),
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_LBRACK] = ACTIONS(6496),
    [anon_sym_RBRACK] = ACTIONS(6496),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6496),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_RPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHpart] = ACTIONS(6494),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddpart] = ACTIONS(6494),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHchapter] = ACTIONS(6494),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddchap] = ACTIONS(6494),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsection] = ACTIONS(6494),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddsec] = ACTIONS(6494),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHitem] = ACTIONS(6494),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [anon_sym_RBRACE] = ACTIONS(6496),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6496),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6496),
    [anon_sym_DOLLAR] = ACTIONS(6494),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHbegin] = ACTIONS(6494),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHleft] = ACTIONS(6494),
    [anon_sym_BSLASHbigl] = ACTIONS(6494),
    [anon_sym_BSLASHBigl] = ACTIONS(6494),
    [anon_sym_BSLASHbiggl] = ACTIONS(6494),
    [anon_sym_BSLASHBiggl] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHtext] = ACTIONS(6494),
    [anon_sym_BSLASHintertext] = ACTIONS(6494),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [1017] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2382),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7077),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1018] = {
    [ts_builtin_sym_end] = ACTIONS(6500),
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_LBRACK] = ACTIONS(6500),
    [anon_sym_RBRACK] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [anon_sym_EQ] = ACTIONS(6500),
    [anon_sym_LPAREN] = ACTIONS(6500),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHpart] = ACTIONS(6498),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddpart] = ACTIONS(6498),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHchapter] = ACTIONS(6498),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddchap] = ACTIONS(6498),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsection] = ACTIONS(6498),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddsec] = ACTIONS(6498),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHitem] = ACTIONS(6498),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6500),
    [anon_sym_LBRACE] = ACTIONS(6500),
    [anon_sym_RBRACE] = ACTIONS(6500),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6500),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6500),
    [anon_sym_DOLLAR] = ACTIONS(6498),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHbegin] = ACTIONS(6498),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHleft] = ACTIONS(6498),
    [anon_sym_BSLASHbigl] = ACTIONS(6498),
    [anon_sym_BSLASHBigl] = ACTIONS(6498),
    [anon_sym_BSLASHbiggl] = ACTIONS(6498),
    [anon_sym_BSLASHBiggl] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHtext] = ACTIONS(6498),
    [anon_sym_BSLASHintertext] = ACTIONS(6498),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [1019] = {
    [ts_builtin_sym_end] = ACTIONS(6416),
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6416),
    [anon_sym_EQ] = ACTIONS(6416),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_RPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHpart] = ACTIONS(6414),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddpart] = ACTIONS(6414),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHchapter] = ACTIONS(6414),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddchap] = ACTIONS(6414),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsection] = ACTIONS(6414),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddsec] = ACTIONS(6414),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHitem] = ACTIONS(6414),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [anon_sym_RBRACE] = ACTIONS(6416),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6416),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(6414),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHbegin] = ACTIONS(6414),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHleft] = ACTIONS(6414),
    [anon_sym_BSLASHbigl] = ACTIONS(6414),
    [anon_sym_BSLASHBigl] = ACTIONS(6414),
    [anon_sym_BSLASHbiggl] = ACTIONS(6414),
    [anon_sym_BSLASHBiggl] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHtext] = ACTIONS(6414),
    [anon_sym_BSLASHintertext] = ACTIONS(6414),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [1020] = {
    [ts_builtin_sym_end] = ACTIONS(6508),
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_LBRACK] = ACTIONS(6508),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [anon_sym_COMMA] = ACTIONS(6508),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_RPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHpart] = ACTIONS(6506),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddpart] = ACTIONS(6506),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHchapter] = ACTIONS(6506),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddchap] = ACTIONS(6506),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsection] = ACTIONS(6506),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddsec] = ACTIONS(6506),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHitem] = ACTIONS(6506),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [anon_sym_RBRACE] = ACTIONS(6508),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6508),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(6506),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHbegin] = ACTIONS(6506),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHleft] = ACTIONS(6506),
    [anon_sym_BSLASHbigl] = ACTIONS(6506),
    [anon_sym_BSLASHBigl] = ACTIONS(6506),
    [anon_sym_BSLASHbiggl] = ACTIONS(6506),
    [anon_sym_BSLASHBiggl] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHtext] = ACTIONS(6506),
    [anon_sym_BSLASHintertext] = ACTIONS(6506),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [1021] = {
    [ts_builtin_sym_end] = ACTIONS(6512),
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_LBRACK] = ACTIONS(6512),
    [anon_sym_RBRACK] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHpart] = ACTIONS(6510),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddpart] = ACTIONS(6510),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHchapter] = ACTIONS(6510),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddchap] = ACTIONS(6510),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsection] = ACTIONS(6510),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddsec] = ACTIONS(6510),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHitem] = ACTIONS(6510),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [anon_sym_RBRACE] = ACTIONS(6512),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6512),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6512),
    [anon_sym_DOLLAR] = ACTIONS(6510),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHbegin] = ACTIONS(6510),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHleft] = ACTIONS(6510),
    [anon_sym_BSLASHbigl] = ACTIONS(6510),
    [anon_sym_BSLASHBigl] = ACTIONS(6510),
    [anon_sym_BSLASHbiggl] = ACTIONS(6510),
    [anon_sym_BSLASHBiggl] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHtext] = ACTIONS(6510),
    [anon_sym_BSLASHintertext] = ACTIONS(6510),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [1022] = {
    [ts_builtin_sym_end] = ACTIONS(6516),
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_LBRACK] = ACTIONS(6516),
    [anon_sym_RBRACK] = ACTIONS(6516),
    [anon_sym_COMMA] = ACTIONS(6516),
    [anon_sym_EQ] = ACTIONS(6516),
    [anon_sym_LPAREN] = ACTIONS(6516),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHpart] = ACTIONS(6514),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddpart] = ACTIONS(6514),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHchapter] = ACTIONS(6514),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddchap] = ACTIONS(6514),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsection] = ACTIONS(6514),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddsec] = ACTIONS(6514),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHitem] = ACTIONS(6514),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6516),
    [anon_sym_LBRACE] = ACTIONS(6516),
    [anon_sym_RBRACE] = ACTIONS(6516),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6516),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(6514),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHbegin] = ACTIONS(6514),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHleft] = ACTIONS(6514),
    [anon_sym_BSLASHbigl] = ACTIONS(6514),
    [anon_sym_BSLASHBigl] = ACTIONS(6514),
    [anon_sym_BSLASHbiggl] = ACTIONS(6514),
    [anon_sym_BSLASHBiggl] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHtext] = ACTIONS(6514),
    [anon_sym_BSLASHintertext] = ACTIONS(6514),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [1023] = {
    [ts_builtin_sym_end] = ACTIONS(6520),
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_LBRACK] = ACTIONS(6520),
    [anon_sym_RBRACK] = ACTIONS(6520),
    [anon_sym_COMMA] = ACTIONS(6520),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_LPAREN] = ACTIONS(6520),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHpart] = ACTIONS(6518),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddpart] = ACTIONS(6518),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHchapter] = ACTIONS(6518),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddchap] = ACTIONS(6518),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsection] = ACTIONS(6518),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddsec] = ACTIONS(6518),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHitem] = ACTIONS(6518),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6520),
    [anon_sym_LBRACE] = ACTIONS(6520),
    [anon_sym_RBRACE] = ACTIONS(6520),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6520),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6520),
    [anon_sym_DOLLAR] = ACTIONS(6518),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHbegin] = ACTIONS(6518),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHleft] = ACTIONS(6518),
    [anon_sym_BSLASHbigl] = ACTIONS(6518),
    [anon_sym_BSLASHBigl] = ACTIONS(6518),
    [anon_sym_BSLASHbiggl] = ACTIONS(6518),
    [anon_sym_BSLASHBiggl] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHtext] = ACTIONS(6518),
    [anon_sym_BSLASHintertext] = ACTIONS(6518),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [1024] = {
    [ts_builtin_sym_end] = ACTIONS(6574),
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_LBRACK] = ACTIONS(6574),
    [anon_sym_RBRACK] = ACTIONS(6574),
    [anon_sym_COMMA] = ACTIONS(6574),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_RPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHpart] = ACTIONS(6572),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddpart] = ACTIONS(6572),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHchapter] = ACTIONS(6572),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddchap] = ACTIONS(6572),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsection] = ACTIONS(6572),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddsec] = ACTIONS(6572),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHitem] = ACTIONS(6572),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6574),
    [anon_sym_LBRACE] = ACTIONS(6574),
    [anon_sym_RBRACE] = ACTIONS(6574),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6574),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6574),
    [anon_sym_DOLLAR] = ACTIONS(6572),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHbegin] = ACTIONS(6572),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHleft] = ACTIONS(6572),
    [anon_sym_BSLASHbigl] = ACTIONS(6572),
    [anon_sym_BSLASHBigl] = ACTIONS(6572),
    [anon_sym_BSLASHbiggl] = ACTIONS(6572),
    [anon_sym_BSLASHBiggl] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHtext] = ACTIONS(6572),
    [anon_sym_BSLASHintertext] = ACTIONS(6572),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [1025] = {
    [ts_builtin_sym_end] = ACTIONS(6384),
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_LBRACK] = ACTIONS(6384),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_EQ] = ACTIONS(6384),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_RPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHpart] = ACTIONS(6382),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddpart] = ACTIONS(6382),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHchapter] = ACTIONS(6382),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddchap] = ACTIONS(6382),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsection] = ACTIONS(6382),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddsec] = ACTIONS(6382),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHitem] = ACTIONS(6382),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6384),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [anon_sym_RBRACE] = ACTIONS(6384),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6384),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(6382),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHbegin] = ACTIONS(6382),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHleft] = ACTIONS(6382),
    [anon_sym_BSLASHbigl] = ACTIONS(6382),
    [anon_sym_BSLASHBigl] = ACTIONS(6382),
    [anon_sym_BSLASHbiggl] = ACTIONS(6382),
    [anon_sym_BSLASHBiggl] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHtext] = ACTIONS(6382),
    [anon_sym_BSLASHintertext] = ACTIONS(6382),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [1026] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2405),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7079),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1027] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2439),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7081),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1028] = {
    [ts_builtin_sym_end] = ACTIONS(6172),
    [sym_command_name] = ACTIONS(6170),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6172),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6172),
    [anon_sym_LPAREN] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHpart] = ACTIONS(6170),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddpart] = ACTIONS(6170),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHchapter] = ACTIONS(6170),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddchap] = ACTIONS(6170),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsection] = ACTIONS(6170),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddsec] = ACTIONS(6170),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHitem] = ACTIONS(6170),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [anon_sym_RBRACE] = ACTIONS(6172),
    [sym_word] = ACTIONS(6170),
    [sym_placeholder] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_BANG] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_SQUOTE] = ACTIONS(6170),
    [anon_sym__] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6172),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6172),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHbegin] = ACTIONS(6170),
    [anon_sym_BSLASHtitle] = ACTIONS(6170),
    [anon_sym_BSLASHauthor] = ACTIONS(6170),
    [anon_sym_BSLASHusepackage] = ACTIONS(6170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6170),
    [anon_sym_BSLASHinclude] = ACTIONS(6170),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6170),
    [anon_sym_BSLASHinput] = ACTIONS(6170),
    [anon_sym_BSLASHsubfile] = ACTIONS(6170),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6170),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6170),
    [anon_sym_BSLASHbibliography] = ACTIONS(6170),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6170),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6170),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6170),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6170),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6170),
    [anon_sym_BSLASHimport] = ACTIONS(6170),
    [anon_sym_BSLASHsubimport] = ACTIONS(6170),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6170),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHcaption] = ACTIONS(6170),
    [anon_sym_BSLASHcite] = ACTIONS(6170),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCite] = ACTIONS(6170),
    [anon_sym_BSLASHnocite] = ACTIONS(6170),
    [anon_sym_BSLASHcitet] = ACTIONS(6170),
    [anon_sym_BSLASHcitep] = ACTIONS(6170),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteA] = ACTIONS(6170),
    [anon_sym_BSLASHciteR] = ACTIONS(6170),
    [anon_sym_BSLASHciteS] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6170),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteyear] = ACTIONS(6170),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitedate] = ACTIONS(6170),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteurl] = ACTIONS(6170),
    [anon_sym_BSLASHfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6170),
    [anon_sym_BSLASHcitealt] = ACTIONS(6170),
    [anon_sym_BSLASHcitealp] = ACTIONS(6170),
    [anon_sym_BSLASHcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHparencite] = ACTIONS(6170),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHParencite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHtextcite] = ACTIONS(6170),
    [anon_sym_BSLASHTextcite] = ACTIONS(6170),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHsupercite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite] = ACTIONS(6170),
    [anon_sym_BSLASHAutocite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHVolcite] = ACTIONS(6170),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHavolcite] = ACTIONS(6170),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHNotecite] = ACTIONS(6170),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHlabel] = ACTIONS(6170),
    [anon_sym_BSLASHref] = ACTIONS(6170),
    [anon_sym_BSLASHeqref] = ACTIONS(6170),
    [anon_sym_BSLASHvref] = ACTIONS(6170),
    [anon_sym_BSLASHVref] = ACTIONS(6170),
    [anon_sym_BSLASHautoref] = ACTIONS(6170),
    [anon_sym_BSLASHpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcref] = ACTIONS(6170),
    [anon_sym_BSLASHCref] = ACTIONS(6170),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnameCref] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHdef] = ACTIONS(6170),
    [anon_sym_BSLASHlet] = ACTIONS(6170),
    [anon_sym_BSLASHleft] = ACTIONS(6170),
    [anon_sym_BSLASHbigl] = ACTIONS(6170),
    [anon_sym_BSLASHBigl] = ACTIONS(6170),
    [anon_sym_BSLASHbiggl] = ACTIONS(6170),
    [anon_sym_BSLASHBiggl] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6170),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6170),
    [anon_sym_BSLASHgls] = ACTIONS(6170),
    [anon_sym_BSLASHGls] = ACTIONS(6170),
    [anon_sym_BSLASHGLS] = ACTIONS(6170),
    [anon_sym_BSLASHglspl] = ACTIONS(6170),
    [anon_sym_BSLASHGlspl] = ACTIONS(6170),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6170),
    [anon_sym_BSLASHglslink] = ACTIONS(6170),
    [anon_sym_BSLASHglstext] = ACTIONS(6170),
    [anon_sym_BSLASHGlstext] = ACTIONS(6170),
    [anon_sym_BSLASHGLStext] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6170),
    [anon_sym_BSLASHglsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsname] = ACTIONS(6170),
    [anon_sym_BSLASHGlsname] = ACTIONS(6170),
    [anon_sym_BSLASHGLSname] = ACTIONS(6170),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6170),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6170),
    [anon_sym_BSLASHacrshort] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6170),
    [anon_sym_BSLASHACRshort] = ACTIONS(6170),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrlong] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6170),
    [anon_sym_BSLASHACRlong] = ACTIONS(6170),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrfull] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6170),
    [anon_sym_BSLASHACRfull] = ACTIONS(6170),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHacs] = ACTIONS(6170),
    [anon_sym_BSLASHAcs] = ACTIONS(6170),
    [anon_sym_BSLASHacsp] = ACTIONS(6170),
    [anon_sym_BSLASHAcsp] = ACTIONS(6170),
    [anon_sym_BSLASHacl] = ACTIONS(6170),
    [anon_sym_BSLASHAcl] = ACTIONS(6170),
    [anon_sym_BSLASHaclp] = ACTIONS(6170),
    [anon_sym_BSLASHAclp] = ACTIONS(6170),
    [anon_sym_BSLASHacf] = ACTIONS(6170),
    [anon_sym_BSLASHAcf] = ACTIONS(6170),
    [anon_sym_BSLASHacfp] = ACTIONS(6170),
    [anon_sym_BSLASHAcfp] = ACTIONS(6170),
    [anon_sym_BSLASHac] = ACTIONS(6170),
    [anon_sym_BSLASHAc] = ACTIONS(6170),
    [anon_sym_BSLASHacp] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6170),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6170),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6170),
    [anon_sym_BSLASHcolor] = ACTIONS(6170),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6170),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6170),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6170),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6170),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6170),
    [anon_sym_BSLASHtext] = ACTIONS(6170),
    [anon_sym_BSLASHintertext] = ACTIONS(6170),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6170),
    [anon_sym_BSLASHurl] = ACTIONS(6170),
    [anon_sym_BSLASHhref] = ACTIONS(6170),
  },
  [1029] = {
    [ts_builtin_sym_end] = ACTIONS(6578),
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(6578),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6578),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_LPAREN] = ACTIONS(6578),
    [anon_sym_RPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHpart] = ACTIONS(6576),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddpart] = ACTIONS(6576),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHchapter] = ACTIONS(6576),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddchap] = ACTIONS(6576),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsection] = ACTIONS(6576),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddsec] = ACTIONS(6576),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHitem] = ACTIONS(6576),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_RBRACE] = ACTIONS(6578),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6578),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHbegin] = ACTIONS(6576),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHleft] = ACTIONS(6576),
    [anon_sym_BSLASHbigl] = ACTIONS(6576),
    [anon_sym_BSLASHBigl] = ACTIONS(6576),
    [anon_sym_BSLASHbiggl] = ACTIONS(6576),
    [anon_sym_BSLASHBiggl] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHtext] = ACTIONS(6576),
    [anon_sym_BSLASHintertext] = ACTIONS(6576),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [1030] = {
    [ts_builtin_sym_end] = ACTIONS(6588),
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHpart] = ACTIONS(6586),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddpart] = ACTIONS(6586),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHchapter] = ACTIONS(6586),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddchap] = ACTIONS(6586),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsection] = ACTIONS(6586),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddsec] = ACTIONS(6586),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHitem] = ACTIONS(6586),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6588),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6588),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHbegin] = ACTIONS(6586),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHleft] = ACTIONS(6586),
    [anon_sym_BSLASHbigl] = ACTIONS(6586),
    [anon_sym_BSLASHBigl] = ACTIONS(6586),
    [anon_sym_BSLASHbiggl] = ACTIONS(6586),
    [anon_sym_BSLASHBiggl] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHtext] = ACTIONS(6586),
    [anon_sym_BSLASHintertext] = ACTIONS(6586),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [1031] = {
    [sym_curly_group] = STATE(1261),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(6164),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHpart] = ACTIONS(6162),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddpart] = ACTIONS(6162),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHchapter] = ACTIONS(6162),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddchap] = ACTIONS(6162),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsection] = ACTIONS(6162),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddsec] = ACTIONS(6162),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHitem] = ACTIONS(6162),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6164),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6164),
    [anon_sym_DOLLAR] = ACTIONS(6162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6164),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHbegin] = ACTIONS(6162),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHleft] = ACTIONS(6162),
    [anon_sym_BSLASHbigl] = ACTIONS(6162),
    [anon_sym_BSLASHBigl] = ACTIONS(6162),
    [anon_sym_BSLASHbiggl] = ACTIONS(6162),
    [anon_sym_BSLASHBiggl] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHtext] = ACTIONS(6162),
    [anon_sym_BSLASHintertext] = ACTIONS(6162),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [1032] = {
    [ts_builtin_sym_end] = ACTIONS(6556),
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6556),
    [anon_sym_RBRACK] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6556),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHpart] = ACTIONS(6554),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddpart] = ACTIONS(6554),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHchapter] = ACTIONS(6554),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddchap] = ACTIONS(6554),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsection] = ACTIONS(6554),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddsec] = ACTIONS(6554),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHitem] = ACTIONS(6554),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6556),
    [anon_sym_LBRACE] = ACTIONS(6556),
    [anon_sym_RBRACE] = ACTIONS(6556),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6556),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6556),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHbegin] = ACTIONS(6554),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHleft] = ACTIONS(6554),
    [anon_sym_BSLASHbigl] = ACTIONS(6554),
    [anon_sym_BSLASHBigl] = ACTIONS(6554),
    [anon_sym_BSLASHbiggl] = ACTIONS(6554),
    [anon_sym_BSLASHBiggl] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHtext] = ACTIONS(6554),
    [anon_sym_BSLASHintertext] = ACTIONS(6554),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [1033] = {
    [ts_builtin_sym_end] = ACTIONS(6396),
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6396),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6396),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHpart] = ACTIONS(6394),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddpart] = ACTIONS(6394),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHchapter] = ACTIONS(6394),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddchap] = ACTIONS(6394),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsection] = ACTIONS(6394),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddsec] = ACTIONS(6394),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHitem] = ACTIONS(6394),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_RBRACE] = ACTIONS(6396),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6396),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6396),
    [anon_sym_DOLLAR] = ACTIONS(6394),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHbegin] = ACTIONS(6394),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHleft] = ACTIONS(6394),
    [anon_sym_BSLASHbigl] = ACTIONS(6394),
    [anon_sym_BSLASHBigl] = ACTIONS(6394),
    [anon_sym_BSLASHbiggl] = ACTIONS(6394),
    [anon_sym_BSLASHBiggl] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHtext] = ACTIONS(6394),
    [anon_sym_BSLASHintertext] = ACTIONS(6394),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [1034] = {
    [ts_builtin_sym_end] = ACTIONS(6552),
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6552),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHpart] = ACTIONS(6550),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddpart] = ACTIONS(6550),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHchapter] = ACTIONS(6550),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddchap] = ACTIONS(6550),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsection] = ACTIONS(6550),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddsec] = ACTIONS(6550),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHitem] = ACTIONS(6550),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [anon_sym_RBRACE] = ACTIONS(6552),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6552),
    [anon_sym_DOLLAR] = ACTIONS(6550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHbegin] = ACTIONS(6550),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHleft] = ACTIONS(6550),
    [anon_sym_BSLASHbigl] = ACTIONS(6550),
    [anon_sym_BSLASHBigl] = ACTIONS(6550),
    [anon_sym_BSLASHbiggl] = ACTIONS(6550),
    [anon_sym_BSLASHBiggl] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHtext] = ACTIONS(6550),
    [anon_sym_BSLASHintertext] = ACTIONS(6550),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [1035] = {
    [ts_builtin_sym_end] = ACTIONS(6472),
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_LBRACK] = ACTIONS(6472),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_EQ] = ACTIONS(6472),
    [anon_sym_LPAREN] = ACTIONS(6472),
    [anon_sym_RPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHpart] = ACTIONS(6470),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddpart] = ACTIONS(6470),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHchapter] = ACTIONS(6470),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddchap] = ACTIONS(6470),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsection] = ACTIONS(6470),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddsec] = ACTIONS(6470),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHitem] = ACTIONS(6470),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [anon_sym_RBRACE] = ACTIONS(6472),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6472),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6472),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHbegin] = ACTIONS(6470),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHleft] = ACTIONS(6470),
    [anon_sym_BSLASHbigl] = ACTIONS(6470),
    [anon_sym_BSLASHBigl] = ACTIONS(6470),
    [anon_sym_BSLASHbiggl] = ACTIONS(6470),
    [anon_sym_BSLASHBiggl] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHtext] = ACTIONS(6470),
    [anon_sym_BSLASHintertext] = ACTIONS(6470),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [1036] = {
    [ts_builtin_sym_end] = ACTIONS(6452),
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_RBRACK] = ACTIONS(6452),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6452),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHpart] = ACTIONS(6450),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddpart] = ACTIONS(6450),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHchapter] = ACTIONS(6450),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddchap] = ACTIONS(6450),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsection] = ACTIONS(6450),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddsec] = ACTIONS(6450),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHitem] = ACTIONS(6450),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [anon_sym_RBRACE] = ACTIONS(6452),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6452),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(6450),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHbegin] = ACTIONS(6450),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHleft] = ACTIONS(6450),
    [anon_sym_BSLASHbigl] = ACTIONS(6450),
    [anon_sym_BSLASHBigl] = ACTIONS(6450),
    [anon_sym_BSLASHbiggl] = ACTIONS(6450),
    [anon_sym_BSLASHBiggl] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHtext] = ACTIONS(6450),
    [anon_sym_BSLASHintertext] = ACTIONS(6450),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [1037] = {
    [ts_builtin_sym_end] = ACTIONS(6352),
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_RBRACK] = ACTIONS(6352),
    [anon_sym_COMMA] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_LPAREN] = ACTIONS(6352),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHpart] = ACTIONS(6350),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddpart] = ACTIONS(6350),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHchapter] = ACTIONS(6350),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddchap] = ACTIONS(6350),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsection] = ACTIONS(6350),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddsec] = ACTIONS(6350),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHitem] = ACTIONS(6350),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6352),
    [anon_sym_LBRACE] = ACTIONS(6352),
    [anon_sym_RBRACE] = ACTIONS(6352),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6352),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6352),
    [anon_sym_DOLLAR] = ACTIONS(6350),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHbegin] = ACTIONS(6350),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHleft] = ACTIONS(6350),
    [anon_sym_BSLASHbigl] = ACTIONS(6350),
    [anon_sym_BSLASHBigl] = ACTIONS(6350),
    [anon_sym_BSLASHbiggl] = ACTIONS(6350),
    [anon_sym_BSLASHBiggl] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHtext] = ACTIONS(6350),
    [anon_sym_BSLASHintertext] = ACTIONS(6350),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [1038] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2391),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7083),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1039] = {
    [sym_curly_group] = STATE(1125),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(6164),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHpart] = ACTIONS(6162),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddpart] = ACTIONS(6162),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHchapter] = ACTIONS(6162),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddchap] = ACTIONS(6162),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsection] = ACTIONS(6162),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHaddsec] = ACTIONS(6162),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6162),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6162),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHitem] = ACTIONS(6162),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(684),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6164),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6164),
    [anon_sym_DOLLAR] = ACTIONS(6162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHbegin] = ACTIONS(6162),
    [anon_sym_BSLASHend] = ACTIONS(6162),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHleft] = ACTIONS(6162),
    [anon_sym_BSLASHbigl] = ACTIONS(6162),
    [anon_sym_BSLASHBigl] = ACTIONS(6162),
    [anon_sym_BSLASHbiggl] = ACTIONS(6162),
    [anon_sym_BSLASHBiggl] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHtext] = ACTIONS(6162),
    [anon_sym_BSLASHintertext] = ACTIONS(6162),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [1040] = {
    [ts_builtin_sym_end] = ACTIONS(6176),
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_LPAREN] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHpart] = ACTIONS(6174),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddpart] = ACTIONS(6174),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHchapter] = ACTIONS(6174),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddchap] = ACTIONS(6174),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsection] = ACTIONS(6174),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddsec] = ACTIONS(6174),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHitem] = ACTIONS(6174),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [anon_sym_RBRACE] = ACTIONS(6176),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6176),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6176),
    [anon_sym_DOLLAR] = ACTIONS(6174),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHbegin] = ACTIONS(6174),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHleft] = ACTIONS(6174),
    [anon_sym_BSLASHbigl] = ACTIONS(6174),
    [anon_sym_BSLASHBigl] = ACTIONS(6174),
    [anon_sym_BSLASHbiggl] = ACTIONS(6174),
    [anon_sym_BSLASHBiggl] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHtext] = ACTIONS(6174),
    [anon_sym_BSLASHintertext] = ACTIONS(6174),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [1041] = {
    [ts_builtin_sym_end] = ACTIONS(6184),
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_RBRACK] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6184),
    [anon_sym_EQ] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_RPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHpart] = ACTIONS(6182),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddpart] = ACTIONS(6182),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHchapter] = ACTIONS(6182),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddchap] = ACTIONS(6182),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsection] = ACTIONS(6182),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddsec] = ACTIONS(6182),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHitem] = ACTIONS(6182),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [anon_sym_RBRACE] = ACTIONS(6184),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6184),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6184),
    [anon_sym_DOLLAR] = ACTIONS(6182),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHbegin] = ACTIONS(6182),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHleft] = ACTIONS(6182),
    [anon_sym_BSLASHbigl] = ACTIONS(6182),
    [anon_sym_BSLASHBigl] = ACTIONS(6182),
    [anon_sym_BSLASHbiggl] = ACTIONS(6182),
    [anon_sym_BSLASHBiggl] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHtext] = ACTIONS(6182),
    [anon_sym_BSLASHintertext] = ACTIONS(6182),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [1042] = {
    [ts_builtin_sym_end] = ACTIONS(6192),
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_RBRACK] = ACTIONS(6192),
    [anon_sym_COMMA] = ACTIONS(6192),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_RPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHpart] = ACTIONS(6190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddpart] = ACTIONS(6190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHchapter] = ACTIONS(6190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddchap] = ACTIONS(6190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsection] = ACTIONS(6190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddsec] = ACTIONS(6190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHitem] = ACTIONS(6190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [anon_sym_RBRACE] = ACTIONS(6192),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6192),
    [anon_sym_DOLLAR] = ACTIONS(6190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHbegin] = ACTIONS(6190),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHleft] = ACTIONS(6190),
    [anon_sym_BSLASHbigl] = ACTIONS(6190),
    [anon_sym_BSLASHBigl] = ACTIONS(6190),
    [anon_sym_BSLASHbiggl] = ACTIONS(6190),
    [anon_sym_BSLASHBiggl] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHtext] = ACTIONS(6190),
    [anon_sym_BSLASHintertext] = ACTIONS(6190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [1043] = {
    [ts_builtin_sym_end] = ACTIONS(6652),
    [sym_command_name] = ACTIONS(6650),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6650),
    [anon_sym_LBRACK] = ACTIONS(6652),
    [anon_sym_RBRACK] = ACTIONS(6652),
    [anon_sym_COMMA] = ACTIONS(6652),
    [anon_sym_EQ] = ACTIONS(6652),
    [anon_sym_LPAREN] = ACTIONS(6652),
    [anon_sym_RPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHpart] = ACTIONS(6650),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddpart] = ACTIONS(6650),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHchapter] = ACTIONS(6650),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddchap] = ACTIONS(6650),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsection] = ACTIONS(6650),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddsec] = ACTIONS(6650),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHitem] = ACTIONS(6650),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6652),
    [anon_sym_LBRACE] = ACTIONS(6652),
    [anon_sym_RBRACE] = ACTIONS(6652),
    [sym_word] = ACTIONS(6650),
    [sym_placeholder] = ACTIONS(6652),
    [anon_sym_PLUS] = ACTIONS(6652),
    [anon_sym_DASH] = ACTIONS(6652),
    [anon_sym_STAR] = ACTIONS(6652),
    [anon_sym_SLASH] = ACTIONS(6652),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_BANG] = ACTIONS(6650),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_COLON] = ACTIONS(6650),
    [anon_sym_SQUOTE] = ACTIONS(6650),
    [anon_sym__] = ACTIONS(6652),
    [anon_sym_CARET] = ACTIONS(6652),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6652),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6652),
    [anon_sym_DOLLAR] = ACTIONS(6650),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHbegin] = ACTIONS(6650),
    [anon_sym_BSLASHtitle] = ACTIONS(6650),
    [anon_sym_BSLASHauthor] = ACTIONS(6650),
    [anon_sym_BSLASHusepackage] = ACTIONS(6650),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6650),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6650),
    [anon_sym_BSLASHinclude] = ACTIONS(6650),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6650),
    [anon_sym_BSLASHinput] = ACTIONS(6650),
    [anon_sym_BSLASHsubfile] = ACTIONS(6650),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6650),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6650),
    [anon_sym_BSLASHbibliography] = ACTIONS(6650),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6650),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6650),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6650),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6650),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6650),
    [anon_sym_BSLASHimport] = ACTIONS(6650),
    [anon_sym_BSLASHsubimport] = ACTIONS(6650),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6650),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHcaption] = ACTIONS(6650),
    [anon_sym_BSLASHcite] = ACTIONS(6650),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCite] = ACTIONS(6650),
    [anon_sym_BSLASHnocite] = ACTIONS(6650),
    [anon_sym_BSLASHcitet] = ACTIONS(6650),
    [anon_sym_BSLASHcitep] = ACTIONS(6650),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteA] = ACTIONS(6650),
    [anon_sym_BSLASHciteR] = ACTIONS(6650),
    [anon_sym_BSLASHciteS] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6650),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteyear] = ACTIONS(6650),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitedate] = ACTIONS(6650),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteurl] = ACTIONS(6650),
    [anon_sym_BSLASHfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6650),
    [anon_sym_BSLASHcitealt] = ACTIONS(6650),
    [anon_sym_BSLASHcitealp] = ACTIONS(6650),
    [anon_sym_BSLASHcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHparencite] = ACTIONS(6650),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHParencite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHtextcite] = ACTIONS(6650),
    [anon_sym_BSLASHTextcite] = ACTIONS(6650),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHsupercite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite] = ACTIONS(6650),
    [anon_sym_BSLASHAutocite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHVolcite] = ACTIONS(6650),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHavolcite] = ACTIONS(6650),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHNotecite] = ACTIONS(6650),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHlabel] = ACTIONS(6650),
    [anon_sym_BSLASHref] = ACTIONS(6650),
    [anon_sym_BSLASHeqref] = ACTIONS(6650),
    [anon_sym_BSLASHvref] = ACTIONS(6650),
    [anon_sym_BSLASHVref] = ACTIONS(6650),
    [anon_sym_BSLASHautoref] = ACTIONS(6650),
    [anon_sym_BSLASHpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcref] = ACTIONS(6650),
    [anon_sym_BSLASHCref] = ACTIONS(6650),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnameCref] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHdef] = ACTIONS(6650),
    [anon_sym_BSLASHlet] = ACTIONS(6650),
    [anon_sym_BSLASHleft] = ACTIONS(6650),
    [anon_sym_BSLASHbigl] = ACTIONS(6650),
    [anon_sym_BSLASHBigl] = ACTIONS(6650),
    [anon_sym_BSLASHbiggl] = ACTIONS(6650),
    [anon_sym_BSLASHBiggl] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6650),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6650),
    [anon_sym_BSLASHgls] = ACTIONS(6650),
    [anon_sym_BSLASHGls] = ACTIONS(6650),
    [anon_sym_BSLASHGLS] = ACTIONS(6650),
    [anon_sym_BSLASHglspl] = ACTIONS(6650),
    [anon_sym_BSLASHGlspl] = ACTIONS(6650),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6650),
    [anon_sym_BSLASHglslink] = ACTIONS(6650),
    [anon_sym_BSLASHglstext] = ACTIONS(6650),
    [anon_sym_BSLASHGlstext] = ACTIONS(6650),
    [anon_sym_BSLASHGLStext] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6650),
    [anon_sym_BSLASHglsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsname] = ACTIONS(6650),
    [anon_sym_BSLASHGlsname] = ACTIONS(6650),
    [anon_sym_BSLASHGLSname] = ACTIONS(6650),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6650),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6650),
    [anon_sym_BSLASHacrshort] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6650),
    [anon_sym_BSLASHACRshort] = ACTIONS(6650),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrlong] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6650),
    [anon_sym_BSLASHACRlong] = ACTIONS(6650),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrfull] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6650),
    [anon_sym_BSLASHACRfull] = ACTIONS(6650),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHacs] = ACTIONS(6650),
    [anon_sym_BSLASHAcs] = ACTIONS(6650),
    [anon_sym_BSLASHacsp] = ACTIONS(6650),
    [anon_sym_BSLASHAcsp] = ACTIONS(6650),
    [anon_sym_BSLASHacl] = ACTIONS(6650),
    [anon_sym_BSLASHAcl] = ACTIONS(6650),
    [anon_sym_BSLASHaclp] = ACTIONS(6650),
    [anon_sym_BSLASHAclp] = ACTIONS(6650),
    [anon_sym_BSLASHacf] = ACTIONS(6650),
    [anon_sym_BSLASHAcf] = ACTIONS(6650),
    [anon_sym_BSLASHacfp] = ACTIONS(6650),
    [anon_sym_BSLASHAcfp] = ACTIONS(6650),
    [anon_sym_BSLASHac] = ACTIONS(6650),
    [anon_sym_BSLASHAc] = ACTIONS(6650),
    [anon_sym_BSLASHacp] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6650),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6650),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6650),
    [anon_sym_BSLASHcolor] = ACTIONS(6650),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6650),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6650),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6650),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6650),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6650),
    [anon_sym_BSLASHtext] = ACTIONS(6650),
    [anon_sym_BSLASHintertext] = ACTIONS(6650),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6650),
    [anon_sym_BSLASHurl] = ACTIONS(6650),
    [anon_sym_BSLASHhref] = ACTIONS(6650),
  },
  [1044] = {
    [ts_builtin_sym_end] = ACTIONS(6504),
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHpart] = ACTIONS(6502),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddpart] = ACTIONS(6502),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHchapter] = ACTIONS(6502),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddchap] = ACTIONS(6502),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsection] = ACTIONS(6502),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddsec] = ACTIONS(6502),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHitem] = ACTIONS(6502),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [anon_sym_RBRACE] = ACTIONS(6504),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6504),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6504),
    [anon_sym_DOLLAR] = ACTIONS(6502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHbegin] = ACTIONS(6502),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHleft] = ACTIONS(6502),
    [anon_sym_BSLASHbigl] = ACTIONS(6502),
    [anon_sym_BSLASHBigl] = ACTIONS(6502),
    [anon_sym_BSLASHbiggl] = ACTIONS(6502),
    [anon_sym_BSLASHBiggl] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHtext] = ACTIONS(6502),
    [anon_sym_BSLASHintertext] = ACTIONS(6502),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [1045] = {
    [ts_builtin_sym_end] = ACTIONS(6660),
    [sym_command_name] = ACTIONS(6658),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6658),
    [anon_sym_LBRACK] = ACTIONS(6660),
    [anon_sym_RBRACK] = ACTIONS(6660),
    [anon_sym_COMMA] = ACTIONS(6660),
    [anon_sym_EQ] = ACTIONS(6660),
    [anon_sym_LPAREN] = ACTIONS(6660),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHpart] = ACTIONS(6658),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddpart] = ACTIONS(6658),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHchapter] = ACTIONS(6658),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddchap] = ACTIONS(6658),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsection] = ACTIONS(6658),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddsec] = ACTIONS(6658),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHitem] = ACTIONS(6658),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6660),
    [anon_sym_LBRACE] = ACTIONS(6660),
    [anon_sym_RBRACE] = ACTIONS(6660),
    [sym_word] = ACTIONS(6658),
    [sym_placeholder] = ACTIONS(6660),
    [anon_sym_PLUS] = ACTIONS(6660),
    [anon_sym_DASH] = ACTIONS(6660),
    [anon_sym_STAR] = ACTIONS(6660),
    [anon_sym_SLASH] = ACTIONS(6660),
    [anon_sym_LT] = ACTIONS(6658),
    [anon_sym_GT] = ACTIONS(6658),
    [anon_sym_BANG] = ACTIONS(6658),
    [anon_sym_PIPE] = ACTIONS(6658),
    [anon_sym_COLON] = ACTIONS(6658),
    [anon_sym_SQUOTE] = ACTIONS(6658),
    [anon_sym__] = ACTIONS(6660),
    [anon_sym_CARET] = ACTIONS(6660),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6660),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6660),
    [anon_sym_DOLLAR] = ACTIONS(6658),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHbegin] = ACTIONS(6658),
    [anon_sym_BSLASHtitle] = ACTIONS(6658),
    [anon_sym_BSLASHauthor] = ACTIONS(6658),
    [anon_sym_BSLASHusepackage] = ACTIONS(6658),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6658),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6658),
    [anon_sym_BSLASHinclude] = ACTIONS(6658),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6658),
    [anon_sym_BSLASHinput] = ACTIONS(6658),
    [anon_sym_BSLASHsubfile] = ACTIONS(6658),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6658),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6658),
    [anon_sym_BSLASHbibliography] = ACTIONS(6658),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6658),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6658),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6658),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6658),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6658),
    [anon_sym_BSLASHimport] = ACTIONS(6658),
    [anon_sym_BSLASHsubimport] = ACTIONS(6658),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6658),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHcaption] = ACTIONS(6658),
    [anon_sym_BSLASHcite] = ACTIONS(6658),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCite] = ACTIONS(6658),
    [anon_sym_BSLASHnocite] = ACTIONS(6658),
    [anon_sym_BSLASHcitet] = ACTIONS(6658),
    [anon_sym_BSLASHcitep] = ACTIONS(6658),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteA] = ACTIONS(6658),
    [anon_sym_BSLASHciteR] = ACTIONS(6658),
    [anon_sym_BSLASHciteS] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6658),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteyear] = ACTIONS(6658),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitedate] = ACTIONS(6658),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteurl] = ACTIONS(6658),
    [anon_sym_BSLASHfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6658),
    [anon_sym_BSLASHcitealt] = ACTIONS(6658),
    [anon_sym_BSLASHcitealp] = ACTIONS(6658),
    [anon_sym_BSLASHcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHparencite] = ACTIONS(6658),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHParencite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHtextcite] = ACTIONS(6658),
    [anon_sym_BSLASHTextcite] = ACTIONS(6658),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHsupercite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite] = ACTIONS(6658),
    [anon_sym_BSLASHAutocite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHVolcite] = ACTIONS(6658),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHavolcite] = ACTIONS(6658),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHNotecite] = ACTIONS(6658),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHlabel] = ACTIONS(6658),
    [anon_sym_BSLASHref] = ACTIONS(6658),
    [anon_sym_BSLASHeqref] = ACTIONS(6658),
    [anon_sym_BSLASHvref] = ACTIONS(6658),
    [anon_sym_BSLASHVref] = ACTIONS(6658),
    [anon_sym_BSLASHautoref] = ACTIONS(6658),
    [anon_sym_BSLASHpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcref] = ACTIONS(6658),
    [anon_sym_BSLASHCref] = ACTIONS(6658),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnameCref] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHdef] = ACTIONS(6658),
    [anon_sym_BSLASHlet] = ACTIONS(6658),
    [anon_sym_BSLASHleft] = ACTIONS(6658),
    [anon_sym_BSLASHbigl] = ACTIONS(6658),
    [anon_sym_BSLASHBigl] = ACTIONS(6658),
    [anon_sym_BSLASHbiggl] = ACTIONS(6658),
    [anon_sym_BSLASHBiggl] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6658),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6658),
    [anon_sym_BSLASHgls] = ACTIONS(6658),
    [anon_sym_BSLASHGls] = ACTIONS(6658),
    [anon_sym_BSLASHGLS] = ACTIONS(6658),
    [anon_sym_BSLASHglspl] = ACTIONS(6658),
    [anon_sym_BSLASHGlspl] = ACTIONS(6658),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6658),
    [anon_sym_BSLASHglslink] = ACTIONS(6658),
    [anon_sym_BSLASHglstext] = ACTIONS(6658),
    [anon_sym_BSLASHGlstext] = ACTIONS(6658),
    [anon_sym_BSLASHGLStext] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6658),
    [anon_sym_BSLASHglsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsname] = ACTIONS(6658),
    [anon_sym_BSLASHGlsname] = ACTIONS(6658),
    [anon_sym_BSLASHGLSname] = ACTIONS(6658),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6658),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6658),
    [anon_sym_BSLASHacrshort] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6658),
    [anon_sym_BSLASHACRshort] = ACTIONS(6658),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrlong] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6658),
    [anon_sym_BSLASHACRlong] = ACTIONS(6658),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrfull] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6658),
    [anon_sym_BSLASHACRfull] = ACTIONS(6658),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHacs] = ACTIONS(6658),
    [anon_sym_BSLASHAcs] = ACTIONS(6658),
    [anon_sym_BSLASHacsp] = ACTIONS(6658),
    [anon_sym_BSLASHAcsp] = ACTIONS(6658),
    [anon_sym_BSLASHacl] = ACTIONS(6658),
    [anon_sym_BSLASHAcl] = ACTIONS(6658),
    [anon_sym_BSLASHaclp] = ACTIONS(6658),
    [anon_sym_BSLASHAclp] = ACTIONS(6658),
    [anon_sym_BSLASHacf] = ACTIONS(6658),
    [anon_sym_BSLASHAcf] = ACTIONS(6658),
    [anon_sym_BSLASHacfp] = ACTIONS(6658),
    [anon_sym_BSLASHAcfp] = ACTIONS(6658),
    [anon_sym_BSLASHac] = ACTIONS(6658),
    [anon_sym_BSLASHAc] = ACTIONS(6658),
    [anon_sym_BSLASHacp] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6658),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6658),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6658),
    [anon_sym_BSLASHcolor] = ACTIONS(6658),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6658),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6658),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6658),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6658),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6658),
    [anon_sym_BSLASHtext] = ACTIONS(6658),
    [anon_sym_BSLASHintertext] = ACTIONS(6658),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6658),
    [anon_sym_BSLASHurl] = ACTIONS(6658),
    [anon_sym_BSLASHhref] = ACTIONS(6658),
  },
  [1046] = {
    [ts_builtin_sym_end] = ACTIONS(6664),
    [sym_command_name] = ACTIONS(6662),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6662),
    [anon_sym_LBRACK] = ACTIONS(6664),
    [anon_sym_RBRACK] = ACTIONS(6664),
    [anon_sym_COMMA] = ACTIONS(6664),
    [anon_sym_EQ] = ACTIONS(6664),
    [anon_sym_LPAREN] = ACTIONS(6664),
    [anon_sym_RPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHpart] = ACTIONS(6662),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddpart] = ACTIONS(6662),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHchapter] = ACTIONS(6662),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddchap] = ACTIONS(6662),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsection] = ACTIONS(6662),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddsec] = ACTIONS(6662),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHitem] = ACTIONS(6662),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6664),
    [anon_sym_LBRACE] = ACTIONS(6664),
    [anon_sym_RBRACE] = ACTIONS(6664),
    [sym_word] = ACTIONS(6662),
    [sym_placeholder] = ACTIONS(6664),
    [anon_sym_PLUS] = ACTIONS(6664),
    [anon_sym_DASH] = ACTIONS(6664),
    [anon_sym_STAR] = ACTIONS(6664),
    [anon_sym_SLASH] = ACTIONS(6664),
    [anon_sym_LT] = ACTIONS(6662),
    [anon_sym_GT] = ACTIONS(6662),
    [anon_sym_BANG] = ACTIONS(6662),
    [anon_sym_PIPE] = ACTIONS(6662),
    [anon_sym_COLON] = ACTIONS(6662),
    [anon_sym_SQUOTE] = ACTIONS(6662),
    [anon_sym__] = ACTIONS(6664),
    [anon_sym_CARET] = ACTIONS(6664),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6664),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6664),
    [anon_sym_DOLLAR] = ACTIONS(6662),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHbegin] = ACTIONS(6662),
    [anon_sym_BSLASHtitle] = ACTIONS(6662),
    [anon_sym_BSLASHauthor] = ACTIONS(6662),
    [anon_sym_BSLASHusepackage] = ACTIONS(6662),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6662),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6662),
    [anon_sym_BSLASHinclude] = ACTIONS(6662),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6662),
    [anon_sym_BSLASHinput] = ACTIONS(6662),
    [anon_sym_BSLASHsubfile] = ACTIONS(6662),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6662),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6662),
    [anon_sym_BSLASHbibliography] = ACTIONS(6662),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6662),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6662),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6662),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6662),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6662),
    [anon_sym_BSLASHimport] = ACTIONS(6662),
    [anon_sym_BSLASHsubimport] = ACTIONS(6662),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6662),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHcaption] = ACTIONS(6662),
    [anon_sym_BSLASHcite] = ACTIONS(6662),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCite] = ACTIONS(6662),
    [anon_sym_BSLASHnocite] = ACTIONS(6662),
    [anon_sym_BSLASHcitet] = ACTIONS(6662),
    [anon_sym_BSLASHcitep] = ACTIONS(6662),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteA] = ACTIONS(6662),
    [anon_sym_BSLASHciteR] = ACTIONS(6662),
    [anon_sym_BSLASHciteS] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6662),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteyear] = ACTIONS(6662),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitedate] = ACTIONS(6662),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteurl] = ACTIONS(6662),
    [anon_sym_BSLASHfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6662),
    [anon_sym_BSLASHcitealt] = ACTIONS(6662),
    [anon_sym_BSLASHcitealp] = ACTIONS(6662),
    [anon_sym_BSLASHcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHparencite] = ACTIONS(6662),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHParencite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHtextcite] = ACTIONS(6662),
    [anon_sym_BSLASHTextcite] = ACTIONS(6662),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHsupercite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite] = ACTIONS(6662),
    [anon_sym_BSLASHAutocite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHVolcite] = ACTIONS(6662),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHavolcite] = ACTIONS(6662),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHNotecite] = ACTIONS(6662),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHlabel] = ACTIONS(6662),
    [anon_sym_BSLASHref] = ACTIONS(6662),
    [anon_sym_BSLASHeqref] = ACTIONS(6662),
    [anon_sym_BSLASHvref] = ACTIONS(6662),
    [anon_sym_BSLASHVref] = ACTIONS(6662),
    [anon_sym_BSLASHautoref] = ACTIONS(6662),
    [anon_sym_BSLASHpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcref] = ACTIONS(6662),
    [anon_sym_BSLASHCref] = ACTIONS(6662),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnameCref] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHdef] = ACTIONS(6662),
    [anon_sym_BSLASHlet] = ACTIONS(6662),
    [anon_sym_BSLASHleft] = ACTIONS(6662),
    [anon_sym_BSLASHbigl] = ACTIONS(6662),
    [anon_sym_BSLASHBigl] = ACTIONS(6662),
    [anon_sym_BSLASHbiggl] = ACTIONS(6662),
    [anon_sym_BSLASHBiggl] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6662),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6662),
    [anon_sym_BSLASHgls] = ACTIONS(6662),
    [anon_sym_BSLASHGls] = ACTIONS(6662),
    [anon_sym_BSLASHGLS] = ACTIONS(6662),
    [anon_sym_BSLASHglspl] = ACTIONS(6662),
    [anon_sym_BSLASHGlspl] = ACTIONS(6662),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6662),
    [anon_sym_BSLASHglslink] = ACTIONS(6662),
    [anon_sym_BSLASHglstext] = ACTIONS(6662),
    [anon_sym_BSLASHGlstext] = ACTIONS(6662),
    [anon_sym_BSLASHGLStext] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6662),
    [anon_sym_BSLASHglsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsname] = ACTIONS(6662),
    [anon_sym_BSLASHGlsname] = ACTIONS(6662),
    [anon_sym_BSLASHGLSname] = ACTIONS(6662),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6662),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6662),
    [anon_sym_BSLASHacrshort] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6662),
    [anon_sym_BSLASHACRshort] = ACTIONS(6662),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrlong] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6662),
    [anon_sym_BSLASHACRlong] = ACTIONS(6662),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrfull] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6662),
    [anon_sym_BSLASHACRfull] = ACTIONS(6662),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHacs] = ACTIONS(6662),
    [anon_sym_BSLASHAcs] = ACTIONS(6662),
    [anon_sym_BSLASHacsp] = ACTIONS(6662),
    [anon_sym_BSLASHAcsp] = ACTIONS(6662),
    [anon_sym_BSLASHacl] = ACTIONS(6662),
    [anon_sym_BSLASHAcl] = ACTIONS(6662),
    [anon_sym_BSLASHaclp] = ACTIONS(6662),
    [anon_sym_BSLASHAclp] = ACTIONS(6662),
    [anon_sym_BSLASHacf] = ACTIONS(6662),
    [anon_sym_BSLASHAcf] = ACTIONS(6662),
    [anon_sym_BSLASHacfp] = ACTIONS(6662),
    [anon_sym_BSLASHAcfp] = ACTIONS(6662),
    [anon_sym_BSLASHac] = ACTIONS(6662),
    [anon_sym_BSLASHAc] = ACTIONS(6662),
    [anon_sym_BSLASHacp] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6662),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6662),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6662),
    [anon_sym_BSLASHcolor] = ACTIONS(6662),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6662),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6662),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6662),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6662),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6662),
    [anon_sym_BSLASHtext] = ACTIONS(6662),
    [anon_sym_BSLASHintertext] = ACTIONS(6662),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6662),
    [anon_sym_BSLASHurl] = ACTIONS(6662),
    [anon_sym_BSLASHhref] = ACTIONS(6662),
  },
  [1047] = {
    [ts_builtin_sym_end] = ACTIONS(6668),
    [sym_command_name] = ACTIONS(6666),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6666),
    [anon_sym_LBRACK] = ACTIONS(6668),
    [anon_sym_RBRACK] = ACTIONS(6668),
    [anon_sym_COMMA] = ACTIONS(6668),
    [anon_sym_EQ] = ACTIONS(6668),
    [anon_sym_LPAREN] = ACTIONS(6668),
    [anon_sym_RPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHpart] = ACTIONS(6666),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddpart] = ACTIONS(6666),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHchapter] = ACTIONS(6666),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddchap] = ACTIONS(6666),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsection] = ACTIONS(6666),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddsec] = ACTIONS(6666),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHitem] = ACTIONS(6666),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6668),
    [anon_sym_LBRACE] = ACTIONS(6668),
    [anon_sym_RBRACE] = ACTIONS(6668),
    [sym_word] = ACTIONS(6666),
    [sym_placeholder] = ACTIONS(6668),
    [anon_sym_PLUS] = ACTIONS(6668),
    [anon_sym_DASH] = ACTIONS(6668),
    [anon_sym_STAR] = ACTIONS(6668),
    [anon_sym_SLASH] = ACTIONS(6668),
    [anon_sym_LT] = ACTIONS(6666),
    [anon_sym_GT] = ACTIONS(6666),
    [anon_sym_BANG] = ACTIONS(6666),
    [anon_sym_PIPE] = ACTIONS(6666),
    [anon_sym_COLON] = ACTIONS(6666),
    [anon_sym_SQUOTE] = ACTIONS(6666),
    [anon_sym__] = ACTIONS(6668),
    [anon_sym_CARET] = ACTIONS(6668),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6668),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6668),
    [anon_sym_DOLLAR] = ACTIONS(6666),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHbegin] = ACTIONS(6666),
    [anon_sym_BSLASHtitle] = ACTIONS(6666),
    [anon_sym_BSLASHauthor] = ACTIONS(6666),
    [anon_sym_BSLASHusepackage] = ACTIONS(6666),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6666),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6666),
    [anon_sym_BSLASHinclude] = ACTIONS(6666),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6666),
    [anon_sym_BSLASHinput] = ACTIONS(6666),
    [anon_sym_BSLASHsubfile] = ACTIONS(6666),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6666),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6666),
    [anon_sym_BSLASHbibliography] = ACTIONS(6666),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6666),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6666),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6666),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6666),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6666),
    [anon_sym_BSLASHimport] = ACTIONS(6666),
    [anon_sym_BSLASHsubimport] = ACTIONS(6666),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6666),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHcaption] = ACTIONS(6666),
    [anon_sym_BSLASHcite] = ACTIONS(6666),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCite] = ACTIONS(6666),
    [anon_sym_BSLASHnocite] = ACTIONS(6666),
    [anon_sym_BSLASHcitet] = ACTIONS(6666),
    [anon_sym_BSLASHcitep] = ACTIONS(6666),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteA] = ACTIONS(6666),
    [anon_sym_BSLASHciteR] = ACTIONS(6666),
    [anon_sym_BSLASHciteS] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6666),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteyear] = ACTIONS(6666),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitedate] = ACTIONS(6666),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteurl] = ACTIONS(6666),
    [anon_sym_BSLASHfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6666),
    [anon_sym_BSLASHcitealt] = ACTIONS(6666),
    [anon_sym_BSLASHcitealp] = ACTIONS(6666),
    [anon_sym_BSLASHcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHparencite] = ACTIONS(6666),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHParencite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHtextcite] = ACTIONS(6666),
    [anon_sym_BSLASHTextcite] = ACTIONS(6666),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHsupercite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite] = ACTIONS(6666),
    [anon_sym_BSLASHAutocite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHVolcite] = ACTIONS(6666),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHavolcite] = ACTIONS(6666),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHNotecite] = ACTIONS(6666),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHlabel] = ACTIONS(6666),
    [anon_sym_BSLASHref] = ACTIONS(6666),
    [anon_sym_BSLASHeqref] = ACTIONS(6666),
    [anon_sym_BSLASHvref] = ACTIONS(6666),
    [anon_sym_BSLASHVref] = ACTIONS(6666),
    [anon_sym_BSLASHautoref] = ACTIONS(6666),
    [anon_sym_BSLASHpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcref] = ACTIONS(6666),
    [anon_sym_BSLASHCref] = ACTIONS(6666),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnameCref] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHdef] = ACTIONS(6666),
    [anon_sym_BSLASHlet] = ACTIONS(6666),
    [anon_sym_BSLASHleft] = ACTIONS(6666),
    [anon_sym_BSLASHbigl] = ACTIONS(6666),
    [anon_sym_BSLASHBigl] = ACTIONS(6666),
    [anon_sym_BSLASHbiggl] = ACTIONS(6666),
    [anon_sym_BSLASHBiggl] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6666),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6666),
    [anon_sym_BSLASHgls] = ACTIONS(6666),
    [anon_sym_BSLASHGls] = ACTIONS(6666),
    [anon_sym_BSLASHGLS] = ACTIONS(6666),
    [anon_sym_BSLASHglspl] = ACTIONS(6666),
    [anon_sym_BSLASHGlspl] = ACTIONS(6666),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6666),
    [anon_sym_BSLASHglslink] = ACTIONS(6666),
    [anon_sym_BSLASHglstext] = ACTIONS(6666),
    [anon_sym_BSLASHGlstext] = ACTIONS(6666),
    [anon_sym_BSLASHGLStext] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6666),
    [anon_sym_BSLASHglsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsname] = ACTIONS(6666),
    [anon_sym_BSLASHGlsname] = ACTIONS(6666),
    [anon_sym_BSLASHGLSname] = ACTIONS(6666),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6666),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6666),
    [anon_sym_BSLASHacrshort] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6666),
    [anon_sym_BSLASHACRshort] = ACTIONS(6666),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrlong] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6666),
    [anon_sym_BSLASHACRlong] = ACTIONS(6666),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrfull] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6666),
    [anon_sym_BSLASHACRfull] = ACTIONS(6666),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHacs] = ACTIONS(6666),
    [anon_sym_BSLASHAcs] = ACTIONS(6666),
    [anon_sym_BSLASHacsp] = ACTIONS(6666),
    [anon_sym_BSLASHAcsp] = ACTIONS(6666),
    [anon_sym_BSLASHacl] = ACTIONS(6666),
    [anon_sym_BSLASHAcl] = ACTIONS(6666),
    [anon_sym_BSLASHaclp] = ACTIONS(6666),
    [anon_sym_BSLASHAclp] = ACTIONS(6666),
    [anon_sym_BSLASHacf] = ACTIONS(6666),
    [anon_sym_BSLASHAcf] = ACTIONS(6666),
    [anon_sym_BSLASHacfp] = ACTIONS(6666),
    [anon_sym_BSLASHAcfp] = ACTIONS(6666),
    [anon_sym_BSLASHac] = ACTIONS(6666),
    [anon_sym_BSLASHAc] = ACTIONS(6666),
    [anon_sym_BSLASHacp] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6666),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6666),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6666),
    [anon_sym_BSLASHcolor] = ACTIONS(6666),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6666),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6666),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6666),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6666),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6666),
    [anon_sym_BSLASHtext] = ACTIONS(6666),
    [anon_sym_BSLASHintertext] = ACTIONS(6666),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6666),
    [anon_sym_BSLASHurl] = ACTIONS(6666),
    [anon_sym_BSLASHhref] = ACTIONS(6666),
  },
  [1048] = {
    [ts_builtin_sym_end] = ACTIONS(6676),
    [sym_command_name] = ACTIONS(6674),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6674),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_RBRACK] = ACTIONS(6676),
    [anon_sym_COMMA] = ACTIONS(6676),
    [anon_sym_EQ] = ACTIONS(6676),
    [anon_sym_LPAREN] = ACTIONS(6676),
    [anon_sym_RPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHpart] = ACTIONS(6674),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddpart] = ACTIONS(6674),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHchapter] = ACTIONS(6674),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddchap] = ACTIONS(6674),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsection] = ACTIONS(6674),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddsec] = ACTIONS(6674),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHitem] = ACTIONS(6674),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(6676),
    [anon_sym_RBRACE] = ACTIONS(6676),
    [sym_word] = ACTIONS(6674),
    [sym_placeholder] = ACTIONS(6676),
    [anon_sym_PLUS] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6676),
    [anon_sym_STAR] = ACTIONS(6676),
    [anon_sym_SLASH] = ACTIONS(6676),
    [anon_sym_LT] = ACTIONS(6674),
    [anon_sym_GT] = ACTIONS(6674),
    [anon_sym_BANG] = ACTIONS(6674),
    [anon_sym_PIPE] = ACTIONS(6674),
    [anon_sym_COLON] = ACTIONS(6674),
    [anon_sym_SQUOTE] = ACTIONS(6674),
    [anon_sym__] = ACTIONS(6676),
    [anon_sym_CARET] = ACTIONS(6676),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6676),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6676),
    [anon_sym_DOLLAR] = ACTIONS(6674),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHbegin] = ACTIONS(6674),
    [anon_sym_BSLASHtitle] = ACTIONS(6674),
    [anon_sym_BSLASHauthor] = ACTIONS(6674),
    [anon_sym_BSLASHusepackage] = ACTIONS(6674),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6674),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6674),
    [anon_sym_BSLASHinclude] = ACTIONS(6674),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6674),
    [anon_sym_BSLASHinput] = ACTIONS(6674),
    [anon_sym_BSLASHsubfile] = ACTIONS(6674),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6674),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6674),
    [anon_sym_BSLASHbibliography] = ACTIONS(6674),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6674),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6674),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6674),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6674),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6674),
    [anon_sym_BSLASHimport] = ACTIONS(6674),
    [anon_sym_BSLASHsubimport] = ACTIONS(6674),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6674),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHcaption] = ACTIONS(6674),
    [anon_sym_BSLASHcite] = ACTIONS(6674),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCite] = ACTIONS(6674),
    [anon_sym_BSLASHnocite] = ACTIONS(6674),
    [anon_sym_BSLASHcitet] = ACTIONS(6674),
    [anon_sym_BSLASHcitep] = ACTIONS(6674),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteA] = ACTIONS(6674),
    [anon_sym_BSLASHciteR] = ACTIONS(6674),
    [anon_sym_BSLASHciteS] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6674),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteyear] = ACTIONS(6674),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitedate] = ACTIONS(6674),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteurl] = ACTIONS(6674),
    [anon_sym_BSLASHfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6674),
    [anon_sym_BSLASHcitealt] = ACTIONS(6674),
    [anon_sym_BSLASHcitealp] = ACTIONS(6674),
    [anon_sym_BSLASHcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHparencite] = ACTIONS(6674),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHParencite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHtextcite] = ACTIONS(6674),
    [anon_sym_BSLASHTextcite] = ACTIONS(6674),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHsupercite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite] = ACTIONS(6674),
    [anon_sym_BSLASHAutocite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHVolcite] = ACTIONS(6674),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHavolcite] = ACTIONS(6674),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHNotecite] = ACTIONS(6674),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHlabel] = ACTIONS(6674),
    [anon_sym_BSLASHref] = ACTIONS(6674),
    [anon_sym_BSLASHeqref] = ACTIONS(6674),
    [anon_sym_BSLASHvref] = ACTIONS(6674),
    [anon_sym_BSLASHVref] = ACTIONS(6674),
    [anon_sym_BSLASHautoref] = ACTIONS(6674),
    [anon_sym_BSLASHpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcref] = ACTIONS(6674),
    [anon_sym_BSLASHCref] = ACTIONS(6674),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnameCref] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHdef] = ACTIONS(6674),
    [anon_sym_BSLASHlet] = ACTIONS(6674),
    [anon_sym_BSLASHleft] = ACTIONS(6674),
    [anon_sym_BSLASHbigl] = ACTIONS(6674),
    [anon_sym_BSLASHBigl] = ACTIONS(6674),
    [anon_sym_BSLASHbiggl] = ACTIONS(6674),
    [anon_sym_BSLASHBiggl] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6674),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6674),
    [anon_sym_BSLASHgls] = ACTIONS(6674),
    [anon_sym_BSLASHGls] = ACTIONS(6674),
    [anon_sym_BSLASHGLS] = ACTIONS(6674),
    [anon_sym_BSLASHglspl] = ACTIONS(6674),
    [anon_sym_BSLASHGlspl] = ACTIONS(6674),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6674),
    [anon_sym_BSLASHglslink] = ACTIONS(6674),
    [anon_sym_BSLASHglstext] = ACTIONS(6674),
    [anon_sym_BSLASHGlstext] = ACTIONS(6674),
    [anon_sym_BSLASHGLStext] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6674),
    [anon_sym_BSLASHglsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsname] = ACTIONS(6674),
    [anon_sym_BSLASHGlsname] = ACTIONS(6674),
    [anon_sym_BSLASHGLSname] = ACTIONS(6674),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6674),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6674),
    [anon_sym_BSLASHacrshort] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6674),
    [anon_sym_BSLASHACRshort] = ACTIONS(6674),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrlong] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6674),
    [anon_sym_BSLASHACRlong] = ACTIONS(6674),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrfull] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6674),
    [anon_sym_BSLASHACRfull] = ACTIONS(6674),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHacs] = ACTIONS(6674),
    [anon_sym_BSLASHAcs] = ACTIONS(6674),
    [anon_sym_BSLASHacsp] = ACTIONS(6674),
    [anon_sym_BSLASHAcsp] = ACTIONS(6674),
    [anon_sym_BSLASHacl] = ACTIONS(6674),
    [anon_sym_BSLASHAcl] = ACTIONS(6674),
    [anon_sym_BSLASHaclp] = ACTIONS(6674),
    [anon_sym_BSLASHAclp] = ACTIONS(6674),
    [anon_sym_BSLASHacf] = ACTIONS(6674),
    [anon_sym_BSLASHAcf] = ACTIONS(6674),
    [anon_sym_BSLASHacfp] = ACTIONS(6674),
    [anon_sym_BSLASHAcfp] = ACTIONS(6674),
    [anon_sym_BSLASHac] = ACTIONS(6674),
    [anon_sym_BSLASHAc] = ACTIONS(6674),
    [anon_sym_BSLASHacp] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6674),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6674),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6674),
    [anon_sym_BSLASHcolor] = ACTIONS(6674),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6674),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6674),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6674),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6674),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6674),
    [anon_sym_BSLASHtext] = ACTIONS(6674),
    [anon_sym_BSLASHintertext] = ACTIONS(6674),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6674),
    [anon_sym_BSLASHurl] = ACTIONS(6674),
    [anon_sym_BSLASHhref] = ACTIONS(6674),
  },
  [1049] = {
    [ts_builtin_sym_end] = ACTIONS(6680),
    [sym_command_name] = ACTIONS(6678),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6678),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6680),
    [anon_sym_COMMA] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LPAREN] = ACTIONS(6680),
    [anon_sym_RPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHpart] = ACTIONS(6678),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddpart] = ACTIONS(6678),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHchapter] = ACTIONS(6678),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddchap] = ACTIONS(6678),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsection] = ACTIONS(6678),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddsec] = ACTIONS(6678),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHitem] = ACTIONS(6678),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6680),
    [anon_sym_LBRACE] = ACTIONS(6680),
    [anon_sym_RBRACE] = ACTIONS(6680),
    [sym_word] = ACTIONS(6678),
    [sym_placeholder] = ACTIONS(6680),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_DASH] = ACTIONS(6680),
    [anon_sym_STAR] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6678),
    [anon_sym_GT] = ACTIONS(6678),
    [anon_sym_BANG] = ACTIONS(6678),
    [anon_sym_PIPE] = ACTIONS(6678),
    [anon_sym_COLON] = ACTIONS(6678),
    [anon_sym_SQUOTE] = ACTIONS(6678),
    [anon_sym__] = ACTIONS(6680),
    [anon_sym_CARET] = ACTIONS(6680),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6680),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6680),
    [anon_sym_DOLLAR] = ACTIONS(6678),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHbegin] = ACTIONS(6678),
    [anon_sym_BSLASHtitle] = ACTIONS(6678),
    [anon_sym_BSLASHauthor] = ACTIONS(6678),
    [anon_sym_BSLASHusepackage] = ACTIONS(6678),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6678),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6678),
    [anon_sym_BSLASHinclude] = ACTIONS(6678),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6678),
    [anon_sym_BSLASHinput] = ACTIONS(6678),
    [anon_sym_BSLASHsubfile] = ACTIONS(6678),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6678),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6678),
    [anon_sym_BSLASHbibliography] = ACTIONS(6678),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6678),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6678),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6678),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6678),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6678),
    [anon_sym_BSLASHimport] = ACTIONS(6678),
    [anon_sym_BSLASHsubimport] = ACTIONS(6678),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6678),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHcaption] = ACTIONS(6678),
    [anon_sym_BSLASHcite] = ACTIONS(6678),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCite] = ACTIONS(6678),
    [anon_sym_BSLASHnocite] = ACTIONS(6678),
    [anon_sym_BSLASHcitet] = ACTIONS(6678),
    [anon_sym_BSLASHcitep] = ACTIONS(6678),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteA] = ACTIONS(6678),
    [anon_sym_BSLASHciteR] = ACTIONS(6678),
    [anon_sym_BSLASHciteS] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6678),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteyear] = ACTIONS(6678),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitedate] = ACTIONS(6678),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteurl] = ACTIONS(6678),
    [anon_sym_BSLASHfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6678),
    [anon_sym_BSLASHcitealt] = ACTIONS(6678),
    [anon_sym_BSLASHcitealp] = ACTIONS(6678),
    [anon_sym_BSLASHcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHparencite] = ACTIONS(6678),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHParencite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHtextcite] = ACTIONS(6678),
    [anon_sym_BSLASHTextcite] = ACTIONS(6678),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHsupercite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite] = ACTIONS(6678),
    [anon_sym_BSLASHAutocite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHVolcite] = ACTIONS(6678),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHavolcite] = ACTIONS(6678),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHNotecite] = ACTIONS(6678),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHlabel] = ACTIONS(6678),
    [anon_sym_BSLASHref] = ACTIONS(6678),
    [anon_sym_BSLASHeqref] = ACTIONS(6678),
    [anon_sym_BSLASHvref] = ACTIONS(6678),
    [anon_sym_BSLASHVref] = ACTIONS(6678),
    [anon_sym_BSLASHautoref] = ACTIONS(6678),
    [anon_sym_BSLASHpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcref] = ACTIONS(6678),
    [anon_sym_BSLASHCref] = ACTIONS(6678),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnameCref] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHdef] = ACTIONS(6678),
    [anon_sym_BSLASHlet] = ACTIONS(6678),
    [anon_sym_BSLASHleft] = ACTIONS(6678),
    [anon_sym_BSLASHbigl] = ACTIONS(6678),
    [anon_sym_BSLASHBigl] = ACTIONS(6678),
    [anon_sym_BSLASHbiggl] = ACTIONS(6678),
    [anon_sym_BSLASHBiggl] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6678),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6678),
    [anon_sym_BSLASHgls] = ACTIONS(6678),
    [anon_sym_BSLASHGls] = ACTIONS(6678),
    [anon_sym_BSLASHGLS] = ACTIONS(6678),
    [anon_sym_BSLASHglspl] = ACTIONS(6678),
    [anon_sym_BSLASHGlspl] = ACTIONS(6678),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6678),
    [anon_sym_BSLASHglslink] = ACTIONS(6678),
    [anon_sym_BSLASHglstext] = ACTIONS(6678),
    [anon_sym_BSLASHGlstext] = ACTIONS(6678),
    [anon_sym_BSLASHGLStext] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6678),
    [anon_sym_BSLASHglsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsname] = ACTIONS(6678),
    [anon_sym_BSLASHGlsname] = ACTIONS(6678),
    [anon_sym_BSLASHGLSname] = ACTIONS(6678),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6678),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6678),
    [anon_sym_BSLASHacrshort] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6678),
    [anon_sym_BSLASHACRshort] = ACTIONS(6678),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrlong] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6678),
    [anon_sym_BSLASHACRlong] = ACTIONS(6678),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrfull] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6678),
    [anon_sym_BSLASHACRfull] = ACTIONS(6678),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHacs] = ACTIONS(6678),
    [anon_sym_BSLASHAcs] = ACTIONS(6678),
    [anon_sym_BSLASHacsp] = ACTIONS(6678),
    [anon_sym_BSLASHAcsp] = ACTIONS(6678),
    [anon_sym_BSLASHacl] = ACTIONS(6678),
    [anon_sym_BSLASHAcl] = ACTIONS(6678),
    [anon_sym_BSLASHaclp] = ACTIONS(6678),
    [anon_sym_BSLASHAclp] = ACTIONS(6678),
    [anon_sym_BSLASHacf] = ACTIONS(6678),
    [anon_sym_BSLASHAcf] = ACTIONS(6678),
    [anon_sym_BSLASHacfp] = ACTIONS(6678),
    [anon_sym_BSLASHAcfp] = ACTIONS(6678),
    [anon_sym_BSLASHac] = ACTIONS(6678),
    [anon_sym_BSLASHAc] = ACTIONS(6678),
    [anon_sym_BSLASHacp] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6678),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6678),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6678),
    [anon_sym_BSLASHcolor] = ACTIONS(6678),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6678),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6678),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6678),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6678),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6678),
    [anon_sym_BSLASHtext] = ACTIONS(6678),
    [anon_sym_BSLASHintertext] = ACTIONS(6678),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6678),
    [anon_sym_BSLASHurl] = ACTIONS(6678),
    [anon_sym_BSLASHhref] = ACTIONS(6678),
  },
  [1050] = {
    [ts_builtin_sym_end] = ACTIONS(6684),
    [sym_command_name] = ACTIONS(6682),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6684),
    [anon_sym_RBRACK] = ACTIONS(6684),
    [anon_sym_COMMA] = ACTIONS(6684),
    [anon_sym_EQ] = ACTIONS(6684),
    [anon_sym_LPAREN] = ACTIONS(6684),
    [anon_sym_RPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHpart] = ACTIONS(6682),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddpart] = ACTIONS(6682),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHchapter] = ACTIONS(6682),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddchap] = ACTIONS(6682),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsection] = ACTIONS(6682),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddsec] = ACTIONS(6682),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHitem] = ACTIONS(6682),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6684),
    [anon_sym_LBRACE] = ACTIONS(6684),
    [anon_sym_RBRACE] = ACTIONS(6684),
    [sym_word] = ACTIONS(6682),
    [sym_placeholder] = ACTIONS(6684),
    [anon_sym_PLUS] = ACTIONS(6684),
    [anon_sym_DASH] = ACTIONS(6684),
    [anon_sym_STAR] = ACTIONS(6684),
    [anon_sym_SLASH] = ACTIONS(6684),
    [anon_sym_LT] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6682),
    [anon_sym_BANG] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6682),
    [anon_sym_COLON] = ACTIONS(6682),
    [anon_sym_SQUOTE] = ACTIONS(6682),
    [anon_sym__] = ACTIONS(6684),
    [anon_sym_CARET] = ACTIONS(6684),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6684),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6684),
    [anon_sym_DOLLAR] = ACTIONS(6682),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHbegin] = ACTIONS(6682),
    [anon_sym_BSLASHtitle] = ACTIONS(6682),
    [anon_sym_BSLASHauthor] = ACTIONS(6682),
    [anon_sym_BSLASHusepackage] = ACTIONS(6682),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6682),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6682),
    [anon_sym_BSLASHinclude] = ACTIONS(6682),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6682),
    [anon_sym_BSLASHinput] = ACTIONS(6682),
    [anon_sym_BSLASHsubfile] = ACTIONS(6682),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6682),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6682),
    [anon_sym_BSLASHbibliography] = ACTIONS(6682),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6682),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6682),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6682),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6682),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6682),
    [anon_sym_BSLASHimport] = ACTIONS(6682),
    [anon_sym_BSLASHsubimport] = ACTIONS(6682),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6682),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHcaption] = ACTIONS(6682),
    [anon_sym_BSLASHcite] = ACTIONS(6682),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCite] = ACTIONS(6682),
    [anon_sym_BSLASHnocite] = ACTIONS(6682),
    [anon_sym_BSLASHcitet] = ACTIONS(6682),
    [anon_sym_BSLASHcitep] = ACTIONS(6682),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteA] = ACTIONS(6682),
    [anon_sym_BSLASHciteR] = ACTIONS(6682),
    [anon_sym_BSLASHciteS] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6682),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteyear] = ACTIONS(6682),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitedate] = ACTIONS(6682),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteurl] = ACTIONS(6682),
    [anon_sym_BSLASHfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6682),
    [anon_sym_BSLASHcitealt] = ACTIONS(6682),
    [anon_sym_BSLASHcitealp] = ACTIONS(6682),
    [anon_sym_BSLASHcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHparencite] = ACTIONS(6682),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHParencite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHtextcite] = ACTIONS(6682),
    [anon_sym_BSLASHTextcite] = ACTIONS(6682),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHsupercite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite] = ACTIONS(6682),
    [anon_sym_BSLASHAutocite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHVolcite] = ACTIONS(6682),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHavolcite] = ACTIONS(6682),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHNotecite] = ACTIONS(6682),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHlabel] = ACTIONS(6682),
    [anon_sym_BSLASHref] = ACTIONS(6682),
    [anon_sym_BSLASHeqref] = ACTIONS(6682),
    [anon_sym_BSLASHvref] = ACTIONS(6682),
    [anon_sym_BSLASHVref] = ACTIONS(6682),
    [anon_sym_BSLASHautoref] = ACTIONS(6682),
    [anon_sym_BSLASHpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcref] = ACTIONS(6682),
    [anon_sym_BSLASHCref] = ACTIONS(6682),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnameCref] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHdef] = ACTIONS(6682),
    [anon_sym_BSLASHlet] = ACTIONS(6682),
    [anon_sym_BSLASHleft] = ACTIONS(6682),
    [anon_sym_BSLASHbigl] = ACTIONS(6682),
    [anon_sym_BSLASHBigl] = ACTIONS(6682),
    [anon_sym_BSLASHbiggl] = ACTIONS(6682),
    [anon_sym_BSLASHBiggl] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6682),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6682),
    [anon_sym_BSLASHgls] = ACTIONS(6682),
    [anon_sym_BSLASHGls] = ACTIONS(6682),
    [anon_sym_BSLASHGLS] = ACTIONS(6682),
    [anon_sym_BSLASHglspl] = ACTIONS(6682),
    [anon_sym_BSLASHGlspl] = ACTIONS(6682),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6682),
    [anon_sym_BSLASHglslink] = ACTIONS(6682),
    [anon_sym_BSLASHglstext] = ACTIONS(6682),
    [anon_sym_BSLASHGlstext] = ACTIONS(6682),
    [anon_sym_BSLASHGLStext] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6682),
    [anon_sym_BSLASHglsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsname] = ACTIONS(6682),
    [anon_sym_BSLASHGlsname] = ACTIONS(6682),
    [anon_sym_BSLASHGLSname] = ACTIONS(6682),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6682),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6682),
    [anon_sym_BSLASHacrshort] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6682),
    [anon_sym_BSLASHACRshort] = ACTIONS(6682),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrlong] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6682),
    [anon_sym_BSLASHACRlong] = ACTIONS(6682),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrfull] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6682),
    [anon_sym_BSLASHACRfull] = ACTIONS(6682),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHacs] = ACTIONS(6682),
    [anon_sym_BSLASHAcs] = ACTIONS(6682),
    [anon_sym_BSLASHacsp] = ACTIONS(6682),
    [anon_sym_BSLASHAcsp] = ACTIONS(6682),
    [anon_sym_BSLASHacl] = ACTIONS(6682),
    [anon_sym_BSLASHAcl] = ACTIONS(6682),
    [anon_sym_BSLASHaclp] = ACTIONS(6682),
    [anon_sym_BSLASHAclp] = ACTIONS(6682),
    [anon_sym_BSLASHacf] = ACTIONS(6682),
    [anon_sym_BSLASHAcf] = ACTIONS(6682),
    [anon_sym_BSLASHacfp] = ACTIONS(6682),
    [anon_sym_BSLASHAcfp] = ACTIONS(6682),
    [anon_sym_BSLASHac] = ACTIONS(6682),
    [anon_sym_BSLASHAc] = ACTIONS(6682),
    [anon_sym_BSLASHacp] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6682),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6682),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6682),
    [anon_sym_BSLASHcolor] = ACTIONS(6682),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6682),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6682),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6682),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6682),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6682),
    [anon_sym_BSLASHtext] = ACTIONS(6682),
    [anon_sym_BSLASHintertext] = ACTIONS(6682),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6682),
    [anon_sym_BSLASHurl] = ACTIONS(6682),
    [anon_sym_BSLASHhref] = ACTIONS(6682),
  },
  [1051] = {
    [ts_builtin_sym_end] = ACTIONS(6712),
    [sym_command_name] = ACTIONS(6710),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(6712),
    [anon_sym_RBRACK] = ACTIONS(6712),
    [anon_sym_COMMA] = ACTIONS(6712),
    [anon_sym_EQ] = ACTIONS(6712),
    [anon_sym_LPAREN] = ACTIONS(6712),
    [anon_sym_RPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHpart] = ACTIONS(6710),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddpart] = ACTIONS(6710),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHchapter] = ACTIONS(6710),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddchap] = ACTIONS(6710),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsection] = ACTIONS(6710),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddsec] = ACTIONS(6710),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHitem] = ACTIONS(6710),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6712),
    [anon_sym_LBRACE] = ACTIONS(6712),
    [anon_sym_RBRACE] = ACTIONS(6712),
    [sym_word] = ACTIONS(6710),
    [sym_placeholder] = ACTIONS(6712),
    [anon_sym_PLUS] = ACTIONS(6712),
    [anon_sym_DASH] = ACTIONS(6712),
    [anon_sym_STAR] = ACTIONS(6712),
    [anon_sym_SLASH] = ACTIONS(6712),
    [anon_sym_LT] = ACTIONS(6710),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_PIPE] = ACTIONS(6710),
    [anon_sym_COLON] = ACTIONS(6710),
    [anon_sym_SQUOTE] = ACTIONS(6710),
    [anon_sym__] = ACTIONS(6712),
    [anon_sym_CARET] = ACTIONS(6712),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6712),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6712),
    [anon_sym_DOLLAR] = ACTIONS(6710),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHbegin] = ACTIONS(6710),
    [anon_sym_BSLASHtitle] = ACTIONS(6710),
    [anon_sym_BSLASHauthor] = ACTIONS(6710),
    [anon_sym_BSLASHusepackage] = ACTIONS(6710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6710),
    [anon_sym_BSLASHinclude] = ACTIONS(6710),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6710),
    [anon_sym_BSLASHinput] = ACTIONS(6710),
    [anon_sym_BSLASHsubfile] = ACTIONS(6710),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6710),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6710),
    [anon_sym_BSLASHbibliography] = ACTIONS(6710),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6710),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6710),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6710),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6710),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6710),
    [anon_sym_BSLASHimport] = ACTIONS(6710),
    [anon_sym_BSLASHsubimport] = ACTIONS(6710),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6710),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHcaption] = ACTIONS(6710),
    [anon_sym_BSLASHcite] = ACTIONS(6710),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCite] = ACTIONS(6710),
    [anon_sym_BSLASHnocite] = ACTIONS(6710),
    [anon_sym_BSLASHcitet] = ACTIONS(6710),
    [anon_sym_BSLASHcitep] = ACTIONS(6710),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteA] = ACTIONS(6710),
    [anon_sym_BSLASHciteR] = ACTIONS(6710),
    [anon_sym_BSLASHciteS] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6710),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteyear] = ACTIONS(6710),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitedate] = ACTIONS(6710),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteurl] = ACTIONS(6710),
    [anon_sym_BSLASHfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6710),
    [anon_sym_BSLASHcitealt] = ACTIONS(6710),
    [anon_sym_BSLASHcitealp] = ACTIONS(6710),
    [anon_sym_BSLASHcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHparencite] = ACTIONS(6710),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHParencite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHtextcite] = ACTIONS(6710),
    [anon_sym_BSLASHTextcite] = ACTIONS(6710),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHsupercite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite] = ACTIONS(6710),
    [anon_sym_BSLASHAutocite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHVolcite] = ACTIONS(6710),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHavolcite] = ACTIONS(6710),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHNotecite] = ACTIONS(6710),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHlabel] = ACTIONS(6710),
    [anon_sym_BSLASHref] = ACTIONS(6710),
    [anon_sym_BSLASHeqref] = ACTIONS(6710),
    [anon_sym_BSLASHvref] = ACTIONS(6710),
    [anon_sym_BSLASHVref] = ACTIONS(6710),
    [anon_sym_BSLASHautoref] = ACTIONS(6710),
    [anon_sym_BSLASHpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcref] = ACTIONS(6710),
    [anon_sym_BSLASHCref] = ACTIONS(6710),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnameCref] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHdef] = ACTIONS(6710),
    [anon_sym_BSLASHlet] = ACTIONS(6710),
    [anon_sym_BSLASHleft] = ACTIONS(6710),
    [anon_sym_BSLASHbigl] = ACTIONS(6710),
    [anon_sym_BSLASHBigl] = ACTIONS(6710),
    [anon_sym_BSLASHbiggl] = ACTIONS(6710),
    [anon_sym_BSLASHBiggl] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6710),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6710),
    [anon_sym_BSLASHgls] = ACTIONS(6710),
    [anon_sym_BSLASHGls] = ACTIONS(6710),
    [anon_sym_BSLASHGLS] = ACTIONS(6710),
    [anon_sym_BSLASHglspl] = ACTIONS(6710),
    [anon_sym_BSLASHGlspl] = ACTIONS(6710),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6710),
    [anon_sym_BSLASHglslink] = ACTIONS(6710),
    [anon_sym_BSLASHglstext] = ACTIONS(6710),
    [anon_sym_BSLASHGlstext] = ACTIONS(6710),
    [anon_sym_BSLASHGLStext] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6710),
    [anon_sym_BSLASHglsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsname] = ACTIONS(6710),
    [anon_sym_BSLASHGlsname] = ACTIONS(6710),
    [anon_sym_BSLASHGLSname] = ACTIONS(6710),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6710),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6710),
    [anon_sym_BSLASHacrshort] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6710),
    [anon_sym_BSLASHACRshort] = ACTIONS(6710),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrlong] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6710),
    [anon_sym_BSLASHACRlong] = ACTIONS(6710),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrfull] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6710),
    [anon_sym_BSLASHACRfull] = ACTIONS(6710),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHacs] = ACTIONS(6710),
    [anon_sym_BSLASHAcs] = ACTIONS(6710),
    [anon_sym_BSLASHacsp] = ACTIONS(6710),
    [anon_sym_BSLASHAcsp] = ACTIONS(6710),
    [anon_sym_BSLASHacl] = ACTIONS(6710),
    [anon_sym_BSLASHAcl] = ACTIONS(6710),
    [anon_sym_BSLASHaclp] = ACTIONS(6710),
    [anon_sym_BSLASHAclp] = ACTIONS(6710),
    [anon_sym_BSLASHacf] = ACTIONS(6710),
    [anon_sym_BSLASHAcf] = ACTIONS(6710),
    [anon_sym_BSLASHacfp] = ACTIONS(6710),
    [anon_sym_BSLASHAcfp] = ACTIONS(6710),
    [anon_sym_BSLASHac] = ACTIONS(6710),
    [anon_sym_BSLASHAc] = ACTIONS(6710),
    [anon_sym_BSLASHacp] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6710),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6710),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6710),
    [anon_sym_BSLASHcolor] = ACTIONS(6710),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6710),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6710),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6710),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6710),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6710),
    [anon_sym_BSLASHtext] = ACTIONS(6710),
    [anon_sym_BSLASHintertext] = ACTIONS(6710),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6710),
    [anon_sym_BSLASHurl] = ACTIONS(6710),
    [anon_sym_BSLASHhref] = ACTIONS(6710),
  },
  [1052] = {
    [ts_builtin_sym_end] = ACTIONS(6716),
    [sym_command_name] = ACTIONS(6714),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6714),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_RBRACK] = ACTIONS(6716),
    [anon_sym_COMMA] = ACTIONS(6716),
    [anon_sym_EQ] = ACTIONS(6716),
    [anon_sym_LPAREN] = ACTIONS(6716),
    [anon_sym_RPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHpart] = ACTIONS(6714),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddpart] = ACTIONS(6714),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHchapter] = ACTIONS(6714),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddchap] = ACTIONS(6714),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsection] = ACTIONS(6714),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddsec] = ACTIONS(6714),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHitem] = ACTIONS(6714),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(6716),
    [anon_sym_RBRACE] = ACTIONS(6716),
    [sym_word] = ACTIONS(6714),
    [sym_placeholder] = ACTIONS(6716),
    [anon_sym_PLUS] = ACTIONS(6716),
    [anon_sym_DASH] = ACTIONS(6716),
    [anon_sym_STAR] = ACTIONS(6716),
    [anon_sym_SLASH] = ACTIONS(6716),
    [anon_sym_LT] = ACTIONS(6714),
    [anon_sym_GT] = ACTIONS(6714),
    [anon_sym_BANG] = ACTIONS(6714),
    [anon_sym_PIPE] = ACTIONS(6714),
    [anon_sym_COLON] = ACTIONS(6714),
    [anon_sym_SQUOTE] = ACTIONS(6714),
    [anon_sym__] = ACTIONS(6716),
    [anon_sym_CARET] = ACTIONS(6716),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6716),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6716),
    [anon_sym_DOLLAR] = ACTIONS(6714),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHbegin] = ACTIONS(6714),
    [anon_sym_BSLASHtitle] = ACTIONS(6714),
    [anon_sym_BSLASHauthor] = ACTIONS(6714),
    [anon_sym_BSLASHusepackage] = ACTIONS(6714),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6714),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6714),
    [anon_sym_BSLASHinclude] = ACTIONS(6714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6714),
    [anon_sym_BSLASHinput] = ACTIONS(6714),
    [anon_sym_BSLASHsubfile] = ACTIONS(6714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6714),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6714),
    [anon_sym_BSLASHbibliography] = ACTIONS(6714),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6714),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6714),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6714),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6714),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6714),
    [anon_sym_BSLASHimport] = ACTIONS(6714),
    [anon_sym_BSLASHsubimport] = ACTIONS(6714),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6714),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHcaption] = ACTIONS(6714),
    [anon_sym_BSLASHcite] = ACTIONS(6714),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCite] = ACTIONS(6714),
    [anon_sym_BSLASHnocite] = ACTIONS(6714),
    [anon_sym_BSLASHcitet] = ACTIONS(6714),
    [anon_sym_BSLASHcitep] = ACTIONS(6714),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteA] = ACTIONS(6714),
    [anon_sym_BSLASHciteR] = ACTIONS(6714),
    [anon_sym_BSLASHciteS] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6714),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteyear] = ACTIONS(6714),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitedate] = ACTIONS(6714),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteurl] = ACTIONS(6714),
    [anon_sym_BSLASHfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6714),
    [anon_sym_BSLASHcitealt] = ACTIONS(6714),
    [anon_sym_BSLASHcitealp] = ACTIONS(6714),
    [anon_sym_BSLASHcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHparencite] = ACTIONS(6714),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHParencite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHtextcite] = ACTIONS(6714),
    [anon_sym_BSLASHTextcite] = ACTIONS(6714),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHsupercite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite] = ACTIONS(6714),
    [anon_sym_BSLASHAutocite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHVolcite] = ACTIONS(6714),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHavolcite] = ACTIONS(6714),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHNotecite] = ACTIONS(6714),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHlabel] = ACTIONS(6714),
    [anon_sym_BSLASHref] = ACTIONS(6714),
    [anon_sym_BSLASHeqref] = ACTIONS(6714),
    [anon_sym_BSLASHvref] = ACTIONS(6714),
    [anon_sym_BSLASHVref] = ACTIONS(6714),
    [anon_sym_BSLASHautoref] = ACTIONS(6714),
    [anon_sym_BSLASHpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcref] = ACTIONS(6714),
    [anon_sym_BSLASHCref] = ACTIONS(6714),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnameCref] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHdef] = ACTIONS(6714),
    [anon_sym_BSLASHlet] = ACTIONS(6714),
    [anon_sym_BSLASHleft] = ACTIONS(6714),
    [anon_sym_BSLASHbigl] = ACTIONS(6714),
    [anon_sym_BSLASHBigl] = ACTIONS(6714),
    [anon_sym_BSLASHbiggl] = ACTIONS(6714),
    [anon_sym_BSLASHBiggl] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6714),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6714),
    [anon_sym_BSLASHgls] = ACTIONS(6714),
    [anon_sym_BSLASHGls] = ACTIONS(6714),
    [anon_sym_BSLASHGLS] = ACTIONS(6714),
    [anon_sym_BSLASHglspl] = ACTIONS(6714),
    [anon_sym_BSLASHGlspl] = ACTIONS(6714),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6714),
    [anon_sym_BSLASHglslink] = ACTIONS(6714),
    [anon_sym_BSLASHglstext] = ACTIONS(6714),
    [anon_sym_BSLASHGlstext] = ACTIONS(6714),
    [anon_sym_BSLASHGLStext] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6714),
    [anon_sym_BSLASHglsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsname] = ACTIONS(6714),
    [anon_sym_BSLASHGlsname] = ACTIONS(6714),
    [anon_sym_BSLASHGLSname] = ACTIONS(6714),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6714),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6714),
    [anon_sym_BSLASHacrshort] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6714),
    [anon_sym_BSLASHACRshort] = ACTIONS(6714),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrlong] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6714),
    [anon_sym_BSLASHACRlong] = ACTIONS(6714),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrfull] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6714),
    [anon_sym_BSLASHACRfull] = ACTIONS(6714),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHacs] = ACTIONS(6714),
    [anon_sym_BSLASHAcs] = ACTIONS(6714),
    [anon_sym_BSLASHacsp] = ACTIONS(6714),
    [anon_sym_BSLASHAcsp] = ACTIONS(6714),
    [anon_sym_BSLASHacl] = ACTIONS(6714),
    [anon_sym_BSLASHAcl] = ACTIONS(6714),
    [anon_sym_BSLASHaclp] = ACTIONS(6714),
    [anon_sym_BSLASHAclp] = ACTIONS(6714),
    [anon_sym_BSLASHacf] = ACTIONS(6714),
    [anon_sym_BSLASHAcf] = ACTIONS(6714),
    [anon_sym_BSLASHacfp] = ACTIONS(6714),
    [anon_sym_BSLASHAcfp] = ACTIONS(6714),
    [anon_sym_BSLASHac] = ACTIONS(6714),
    [anon_sym_BSLASHAc] = ACTIONS(6714),
    [anon_sym_BSLASHacp] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6714),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6714),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6714),
    [anon_sym_BSLASHcolor] = ACTIONS(6714),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6714),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6714),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6714),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6714),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6714),
    [anon_sym_BSLASHtext] = ACTIONS(6714),
    [anon_sym_BSLASHintertext] = ACTIONS(6714),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6714),
    [anon_sym_BSLASHurl] = ACTIONS(6714),
    [anon_sym_BSLASHhref] = ACTIONS(6714),
  },
  [1053] = {
    [ts_builtin_sym_end] = ACTIONS(6720),
    [sym_command_name] = ACTIONS(6718),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6718),
    [anon_sym_LBRACK] = ACTIONS(6720),
    [anon_sym_RBRACK] = ACTIONS(6720),
    [anon_sym_COMMA] = ACTIONS(6720),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_LPAREN] = ACTIONS(6720),
    [anon_sym_RPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHpart] = ACTIONS(6718),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddpart] = ACTIONS(6718),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHchapter] = ACTIONS(6718),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddchap] = ACTIONS(6718),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsection] = ACTIONS(6718),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddsec] = ACTIONS(6718),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHitem] = ACTIONS(6718),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6720),
    [anon_sym_LBRACE] = ACTIONS(6720),
    [anon_sym_RBRACE] = ACTIONS(6720),
    [sym_word] = ACTIONS(6718),
    [sym_placeholder] = ACTIONS(6720),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_LT] = ACTIONS(6718),
    [anon_sym_GT] = ACTIONS(6718),
    [anon_sym_BANG] = ACTIONS(6718),
    [anon_sym_PIPE] = ACTIONS(6718),
    [anon_sym_COLON] = ACTIONS(6718),
    [anon_sym_SQUOTE] = ACTIONS(6718),
    [anon_sym__] = ACTIONS(6720),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6720),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6720),
    [anon_sym_DOLLAR] = ACTIONS(6718),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHbegin] = ACTIONS(6718),
    [anon_sym_BSLASHtitle] = ACTIONS(6718),
    [anon_sym_BSLASHauthor] = ACTIONS(6718),
    [anon_sym_BSLASHusepackage] = ACTIONS(6718),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6718),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6718),
    [anon_sym_BSLASHinclude] = ACTIONS(6718),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6718),
    [anon_sym_BSLASHinput] = ACTIONS(6718),
    [anon_sym_BSLASHsubfile] = ACTIONS(6718),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6718),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6718),
    [anon_sym_BSLASHbibliography] = ACTIONS(6718),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6718),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6718),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6718),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6718),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6718),
    [anon_sym_BSLASHimport] = ACTIONS(6718),
    [anon_sym_BSLASHsubimport] = ACTIONS(6718),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6718),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHcaption] = ACTIONS(6718),
    [anon_sym_BSLASHcite] = ACTIONS(6718),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCite] = ACTIONS(6718),
    [anon_sym_BSLASHnocite] = ACTIONS(6718),
    [anon_sym_BSLASHcitet] = ACTIONS(6718),
    [anon_sym_BSLASHcitep] = ACTIONS(6718),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteA] = ACTIONS(6718),
    [anon_sym_BSLASHciteR] = ACTIONS(6718),
    [anon_sym_BSLASHciteS] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6718),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteyear] = ACTIONS(6718),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitedate] = ACTIONS(6718),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteurl] = ACTIONS(6718),
    [anon_sym_BSLASHfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6718),
    [anon_sym_BSLASHcitealt] = ACTIONS(6718),
    [anon_sym_BSLASHcitealp] = ACTIONS(6718),
    [anon_sym_BSLASHcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHparencite] = ACTIONS(6718),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHParencite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHtextcite] = ACTIONS(6718),
    [anon_sym_BSLASHTextcite] = ACTIONS(6718),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHsupercite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite] = ACTIONS(6718),
    [anon_sym_BSLASHAutocite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHVolcite] = ACTIONS(6718),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHavolcite] = ACTIONS(6718),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHNotecite] = ACTIONS(6718),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHlabel] = ACTIONS(6718),
    [anon_sym_BSLASHref] = ACTIONS(6718),
    [anon_sym_BSLASHeqref] = ACTIONS(6718),
    [anon_sym_BSLASHvref] = ACTIONS(6718),
    [anon_sym_BSLASHVref] = ACTIONS(6718),
    [anon_sym_BSLASHautoref] = ACTIONS(6718),
    [anon_sym_BSLASHpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcref] = ACTIONS(6718),
    [anon_sym_BSLASHCref] = ACTIONS(6718),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnameCref] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHdef] = ACTIONS(6718),
    [anon_sym_BSLASHlet] = ACTIONS(6718),
    [anon_sym_BSLASHleft] = ACTIONS(6718),
    [anon_sym_BSLASHbigl] = ACTIONS(6718),
    [anon_sym_BSLASHBigl] = ACTIONS(6718),
    [anon_sym_BSLASHbiggl] = ACTIONS(6718),
    [anon_sym_BSLASHBiggl] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6718),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6718),
    [anon_sym_BSLASHgls] = ACTIONS(6718),
    [anon_sym_BSLASHGls] = ACTIONS(6718),
    [anon_sym_BSLASHGLS] = ACTIONS(6718),
    [anon_sym_BSLASHglspl] = ACTIONS(6718),
    [anon_sym_BSLASHGlspl] = ACTIONS(6718),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6718),
    [anon_sym_BSLASHglslink] = ACTIONS(6718),
    [anon_sym_BSLASHglstext] = ACTIONS(6718),
    [anon_sym_BSLASHGlstext] = ACTIONS(6718),
    [anon_sym_BSLASHGLStext] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6718),
    [anon_sym_BSLASHglsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsname] = ACTIONS(6718),
    [anon_sym_BSLASHGlsname] = ACTIONS(6718),
    [anon_sym_BSLASHGLSname] = ACTIONS(6718),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6718),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6718),
    [anon_sym_BSLASHacrshort] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6718),
    [anon_sym_BSLASHACRshort] = ACTIONS(6718),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrlong] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6718),
    [anon_sym_BSLASHACRlong] = ACTIONS(6718),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrfull] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6718),
    [anon_sym_BSLASHACRfull] = ACTIONS(6718),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHacs] = ACTIONS(6718),
    [anon_sym_BSLASHAcs] = ACTIONS(6718),
    [anon_sym_BSLASHacsp] = ACTIONS(6718),
    [anon_sym_BSLASHAcsp] = ACTIONS(6718),
    [anon_sym_BSLASHacl] = ACTIONS(6718),
    [anon_sym_BSLASHAcl] = ACTIONS(6718),
    [anon_sym_BSLASHaclp] = ACTIONS(6718),
    [anon_sym_BSLASHAclp] = ACTIONS(6718),
    [anon_sym_BSLASHacf] = ACTIONS(6718),
    [anon_sym_BSLASHAcf] = ACTIONS(6718),
    [anon_sym_BSLASHacfp] = ACTIONS(6718),
    [anon_sym_BSLASHAcfp] = ACTIONS(6718),
    [anon_sym_BSLASHac] = ACTIONS(6718),
    [anon_sym_BSLASHAc] = ACTIONS(6718),
    [anon_sym_BSLASHacp] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6718),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6718),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6718),
    [anon_sym_BSLASHcolor] = ACTIONS(6718),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6718),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6718),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6718),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6718),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6718),
    [anon_sym_BSLASHtext] = ACTIONS(6718),
    [anon_sym_BSLASHintertext] = ACTIONS(6718),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6718),
    [anon_sym_BSLASHurl] = ACTIONS(6718),
    [anon_sym_BSLASHhref] = ACTIONS(6718),
  },
  [1054] = {
    [ts_builtin_sym_end] = ACTIONS(6724),
    [sym_command_name] = ACTIONS(6722),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6722),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_RBRACK] = ACTIONS(6724),
    [anon_sym_COMMA] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6724),
    [anon_sym_LPAREN] = ACTIONS(6724),
    [anon_sym_RPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHpart] = ACTIONS(6722),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddpart] = ACTIONS(6722),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHchapter] = ACTIONS(6722),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddchap] = ACTIONS(6722),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsection] = ACTIONS(6722),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddsec] = ACTIONS(6722),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHitem] = ACTIONS(6722),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(6724),
    [anon_sym_RBRACE] = ACTIONS(6724),
    [sym_word] = ACTIONS(6722),
    [sym_placeholder] = ACTIONS(6724),
    [anon_sym_PLUS] = ACTIONS(6724),
    [anon_sym_DASH] = ACTIONS(6724),
    [anon_sym_STAR] = ACTIONS(6724),
    [anon_sym_SLASH] = ACTIONS(6724),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_BANG] = ACTIONS(6722),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_COLON] = ACTIONS(6722),
    [anon_sym_SQUOTE] = ACTIONS(6722),
    [anon_sym__] = ACTIONS(6724),
    [anon_sym_CARET] = ACTIONS(6724),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6724),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6724),
    [anon_sym_DOLLAR] = ACTIONS(6722),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHbegin] = ACTIONS(6722),
    [anon_sym_BSLASHtitle] = ACTIONS(6722),
    [anon_sym_BSLASHauthor] = ACTIONS(6722),
    [anon_sym_BSLASHusepackage] = ACTIONS(6722),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6722),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6722),
    [anon_sym_BSLASHinclude] = ACTIONS(6722),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6722),
    [anon_sym_BSLASHinput] = ACTIONS(6722),
    [anon_sym_BSLASHsubfile] = ACTIONS(6722),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6722),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6722),
    [anon_sym_BSLASHbibliography] = ACTIONS(6722),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6722),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6722),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6722),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6722),
    [anon_sym_BSLASHimport] = ACTIONS(6722),
    [anon_sym_BSLASHsubimport] = ACTIONS(6722),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6722),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHcaption] = ACTIONS(6722),
    [anon_sym_BSLASHcite] = ACTIONS(6722),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCite] = ACTIONS(6722),
    [anon_sym_BSLASHnocite] = ACTIONS(6722),
    [anon_sym_BSLASHcitet] = ACTIONS(6722),
    [anon_sym_BSLASHcitep] = ACTIONS(6722),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteA] = ACTIONS(6722),
    [anon_sym_BSLASHciteR] = ACTIONS(6722),
    [anon_sym_BSLASHciteS] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6722),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteyear] = ACTIONS(6722),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitedate] = ACTIONS(6722),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteurl] = ACTIONS(6722),
    [anon_sym_BSLASHfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6722),
    [anon_sym_BSLASHcitealt] = ACTIONS(6722),
    [anon_sym_BSLASHcitealp] = ACTIONS(6722),
    [anon_sym_BSLASHcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHparencite] = ACTIONS(6722),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHParencite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHtextcite] = ACTIONS(6722),
    [anon_sym_BSLASHTextcite] = ACTIONS(6722),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHsupercite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite] = ACTIONS(6722),
    [anon_sym_BSLASHAutocite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHVolcite] = ACTIONS(6722),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHavolcite] = ACTIONS(6722),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHNotecite] = ACTIONS(6722),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHlabel] = ACTIONS(6722),
    [anon_sym_BSLASHref] = ACTIONS(6722),
    [anon_sym_BSLASHeqref] = ACTIONS(6722),
    [anon_sym_BSLASHvref] = ACTIONS(6722),
    [anon_sym_BSLASHVref] = ACTIONS(6722),
    [anon_sym_BSLASHautoref] = ACTIONS(6722),
    [anon_sym_BSLASHpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcref] = ACTIONS(6722),
    [anon_sym_BSLASHCref] = ACTIONS(6722),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnameCref] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHdef] = ACTIONS(6722),
    [anon_sym_BSLASHlet] = ACTIONS(6722),
    [anon_sym_BSLASHleft] = ACTIONS(6722),
    [anon_sym_BSLASHbigl] = ACTIONS(6722),
    [anon_sym_BSLASHBigl] = ACTIONS(6722),
    [anon_sym_BSLASHbiggl] = ACTIONS(6722),
    [anon_sym_BSLASHBiggl] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6722),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6722),
    [anon_sym_BSLASHgls] = ACTIONS(6722),
    [anon_sym_BSLASHGls] = ACTIONS(6722),
    [anon_sym_BSLASHGLS] = ACTIONS(6722),
    [anon_sym_BSLASHglspl] = ACTIONS(6722),
    [anon_sym_BSLASHGlspl] = ACTIONS(6722),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6722),
    [anon_sym_BSLASHglslink] = ACTIONS(6722),
    [anon_sym_BSLASHglstext] = ACTIONS(6722),
    [anon_sym_BSLASHGlstext] = ACTIONS(6722),
    [anon_sym_BSLASHGLStext] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6722),
    [anon_sym_BSLASHglsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsname] = ACTIONS(6722),
    [anon_sym_BSLASHGlsname] = ACTIONS(6722),
    [anon_sym_BSLASHGLSname] = ACTIONS(6722),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6722),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6722),
    [anon_sym_BSLASHacrshort] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6722),
    [anon_sym_BSLASHACRshort] = ACTIONS(6722),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrlong] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6722),
    [anon_sym_BSLASHACRlong] = ACTIONS(6722),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrfull] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6722),
    [anon_sym_BSLASHACRfull] = ACTIONS(6722),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHacs] = ACTIONS(6722),
    [anon_sym_BSLASHAcs] = ACTIONS(6722),
    [anon_sym_BSLASHacsp] = ACTIONS(6722),
    [anon_sym_BSLASHAcsp] = ACTIONS(6722),
    [anon_sym_BSLASHacl] = ACTIONS(6722),
    [anon_sym_BSLASHAcl] = ACTIONS(6722),
    [anon_sym_BSLASHaclp] = ACTIONS(6722),
    [anon_sym_BSLASHAclp] = ACTIONS(6722),
    [anon_sym_BSLASHacf] = ACTIONS(6722),
    [anon_sym_BSLASHAcf] = ACTIONS(6722),
    [anon_sym_BSLASHacfp] = ACTIONS(6722),
    [anon_sym_BSLASHAcfp] = ACTIONS(6722),
    [anon_sym_BSLASHac] = ACTIONS(6722),
    [anon_sym_BSLASHAc] = ACTIONS(6722),
    [anon_sym_BSLASHacp] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6722),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6722),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6722),
    [anon_sym_BSLASHcolor] = ACTIONS(6722),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6722),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6722),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6722),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6722),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6722),
    [anon_sym_BSLASHtext] = ACTIONS(6722),
    [anon_sym_BSLASHintertext] = ACTIONS(6722),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6722),
    [anon_sym_BSLASHurl] = ACTIONS(6722),
    [anon_sym_BSLASHhref] = ACTIONS(6722),
  },
  [1055] = {
    [ts_builtin_sym_end] = ACTIONS(6728),
    [sym_command_name] = ACTIONS(6726),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6726),
    [anon_sym_LBRACK] = ACTIONS(6728),
    [anon_sym_RBRACK] = ACTIONS(6728),
    [anon_sym_COMMA] = ACTIONS(6728),
    [anon_sym_EQ] = ACTIONS(6728),
    [anon_sym_LPAREN] = ACTIONS(6728),
    [anon_sym_RPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHpart] = ACTIONS(6726),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddpart] = ACTIONS(6726),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHchapter] = ACTIONS(6726),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddchap] = ACTIONS(6726),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsection] = ACTIONS(6726),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddsec] = ACTIONS(6726),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHitem] = ACTIONS(6726),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6728),
    [anon_sym_LBRACE] = ACTIONS(6728),
    [anon_sym_RBRACE] = ACTIONS(6728),
    [sym_word] = ACTIONS(6726),
    [sym_placeholder] = ACTIONS(6728),
    [anon_sym_PLUS] = ACTIONS(6728),
    [anon_sym_DASH] = ACTIONS(6728),
    [anon_sym_STAR] = ACTIONS(6728),
    [anon_sym_SLASH] = ACTIONS(6728),
    [anon_sym_LT] = ACTIONS(6726),
    [anon_sym_GT] = ACTIONS(6726),
    [anon_sym_BANG] = ACTIONS(6726),
    [anon_sym_PIPE] = ACTIONS(6726),
    [anon_sym_COLON] = ACTIONS(6726),
    [anon_sym_SQUOTE] = ACTIONS(6726),
    [anon_sym__] = ACTIONS(6728),
    [anon_sym_CARET] = ACTIONS(6728),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6728),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6728),
    [anon_sym_DOLLAR] = ACTIONS(6726),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHbegin] = ACTIONS(6726),
    [anon_sym_BSLASHtitle] = ACTIONS(6726),
    [anon_sym_BSLASHauthor] = ACTIONS(6726),
    [anon_sym_BSLASHusepackage] = ACTIONS(6726),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6726),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6726),
    [anon_sym_BSLASHinclude] = ACTIONS(6726),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6726),
    [anon_sym_BSLASHinput] = ACTIONS(6726),
    [anon_sym_BSLASHsubfile] = ACTIONS(6726),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6726),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6726),
    [anon_sym_BSLASHbibliography] = ACTIONS(6726),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6726),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6726),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6726),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6726),
    [anon_sym_BSLASHimport] = ACTIONS(6726),
    [anon_sym_BSLASHsubimport] = ACTIONS(6726),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6726),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHcaption] = ACTIONS(6726),
    [anon_sym_BSLASHcite] = ACTIONS(6726),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCite] = ACTIONS(6726),
    [anon_sym_BSLASHnocite] = ACTIONS(6726),
    [anon_sym_BSLASHcitet] = ACTIONS(6726),
    [anon_sym_BSLASHcitep] = ACTIONS(6726),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteA] = ACTIONS(6726),
    [anon_sym_BSLASHciteR] = ACTIONS(6726),
    [anon_sym_BSLASHciteS] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6726),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteyear] = ACTIONS(6726),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitedate] = ACTIONS(6726),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteurl] = ACTIONS(6726),
    [anon_sym_BSLASHfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6726),
    [anon_sym_BSLASHcitealt] = ACTIONS(6726),
    [anon_sym_BSLASHcitealp] = ACTIONS(6726),
    [anon_sym_BSLASHcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHparencite] = ACTIONS(6726),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHParencite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHtextcite] = ACTIONS(6726),
    [anon_sym_BSLASHTextcite] = ACTIONS(6726),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHsupercite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite] = ACTIONS(6726),
    [anon_sym_BSLASHAutocite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHVolcite] = ACTIONS(6726),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHavolcite] = ACTIONS(6726),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHNotecite] = ACTIONS(6726),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHlabel] = ACTIONS(6726),
    [anon_sym_BSLASHref] = ACTIONS(6726),
    [anon_sym_BSLASHeqref] = ACTIONS(6726),
    [anon_sym_BSLASHvref] = ACTIONS(6726),
    [anon_sym_BSLASHVref] = ACTIONS(6726),
    [anon_sym_BSLASHautoref] = ACTIONS(6726),
    [anon_sym_BSLASHpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcref] = ACTIONS(6726),
    [anon_sym_BSLASHCref] = ACTIONS(6726),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnameCref] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHdef] = ACTIONS(6726),
    [anon_sym_BSLASHlet] = ACTIONS(6726),
    [anon_sym_BSLASHleft] = ACTIONS(6726),
    [anon_sym_BSLASHbigl] = ACTIONS(6726),
    [anon_sym_BSLASHBigl] = ACTIONS(6726),
    [anon_sym_BSLASHbiggl] = ACTIONS(6726),
    [anon_sym_BSLASHBiggl] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6726),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6726),
    [anon_sym_BSLASHgls] = ACTIONS(6726),
    [anon_sym_BSLASHGls] = ACTIONS(6726),
    [anon_sym_BSLASHGLS] = ACTIONS(6726),
    [anon_sym_BSLASHglspl] = ACTIONS(6726),
    [anon_sym_BSLASHGlspl] = ACTIONS(6726),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6726),
    [anon_sym_BSLASHglslink] = ACTIONS(6726),
    [anon_sym_BSLASHglstext] = ACTIONS(6726),
    [anon_sym_BSLASHGlstext] = ACTIONS(6726),
    [anon_sym_BSLASHGLStext] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6726),
    [anon_sym_BSLASHglsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsname] = ACTIONS(6726),
    [anon_sym_BSLASHGlsname] = ACTIONS(6726),
    [anon_sym_BSLASHGLSname] = ACTIONS(6726),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6726),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6726),
    [anon_sym_BSLASHacrshort] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6726),
    [anon_sym_BSLASHACRshort] = ACTIONS(6726),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrlong] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6726),
    [anon_sym_BSLASHACRlong] = ACTIONS(6726),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrfull] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6726),
    [anon_sym_BSLASHACRfull] = ACTIONS(6726),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHacs] = ACTIONS(6726),
    [anon_sym_BSLASHAcs] = ACTIONS(6726),
    [anon_sym_BSLASHacsp] = ACTIONS(6726),
    [anon_sym_BSLASHAcsp] = ACTIONS(6726),
    [anon_sym_BSLASHacl] = ACTIONS(6726),
    [anon_sym_BSLASHAcl] = ACTIONS(6726),
    [anon_sym_BSLASHaclp] = ACTIONS(6726),
    [anon_sym_BSLASHAclp] = ACTIONS(6726),
    [anon_sym_BSLASHacf] = ACTIONS(6726),
    [anon_sym_BSLASHAcf] = ACTIONS(6726),
    [anon_sym_BSLASHacfp] = ACTIONS(6726),
    [anon_sym_BSLASHAcfp] = ACTIONS(6726),
    [anon_sym_BSLASHac] = ACTIONS(6726),
    [anon_sym_BSLASHAc] = ACTIONS(6726),
    [anon_sym_BSLASHacp] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6726),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6726),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6726),
    [anon_sym_BSLASHcolor] = ACTIONS(6726),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6726),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6726),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6726),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6726),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6726),
    [anon_sym_BSLASHtext] = ACTIONS(6726),
    [anon_sym_BSLASHintertext] = ACTIONS(6726),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6726),
    [anon_sym_BSLASHurl] = ACTIONS(6726),
    [anon_sym_BSLASHhref] = ACTIONS(6726),
  },
  [1056] = {
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6244),
    [anon_sym_RBRACK] = ACTIONS(6244),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_LPAREN] = ACTIONS(6244),
    [anon_sym_RPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHpart] = ACTIONS(6242),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddpart] = ACTIONS(6242),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHchapter] = ACTIONS(6242),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddchap] = ACTIONS(6242),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsection] = ACTIONS(6242),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddsec] = ACTIONS(6242),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHitem] = ACTIONS(6242),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6244),
    [anon_sym_LBRACE] = ACTIONS(6244),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6244),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6244),
    [anon_sym_DOLLAR] = ACTIONS(6242),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6244),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHbegin] = ACTIONS(6242),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHleft] = ACTIONS(6242),
    [anon_sym_BSLASHbigl] = ACTIONS(6242),
    [anon_sym_BSLASHBigl] = ACTIONS(6242),
    [anon_sym_BSLASHbiggl] = ACTIONS(6242),
    [anon_sym_BSLASHBiggl] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHtext] = ACTIONS(6242),
    [anon_sym_BSLASHintertext] = ACTIONS(6242),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [1057] = {
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_LBRACK] = ACTIONS(6524),
    [anon_sym_RBRACK] = ACTIONS(6524),
    [anon_sym_COMMA] = ACTIONS(6524),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6524),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHpart] = ACTIONS(6522),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddpart] = ACTIONS(6522),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHchapter] = ACTIONS(6522),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddchap] = ACTIONS(6522),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsection] = ACTIONS(6522),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddsec] = ACTIONS(6522),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHitem] = ACTIONS(6522),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6524),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6524),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6524),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6524),
    [anon_sym_DOLLAR] = ACTIONS(6522),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHbegin] = ACTIONS(6522),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHleft] = ACTIONS(6522),
    [anon_sym_BSLASHbigl] = ACTIONS(6522),
    [anon_sym_BSLASHBigl] = ACTIONS(6522),
    [anon_sym_BSLASHbiggl] = ACTIONS(6522),
    [anon_sym_BSLASHBiggl] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHtext] = ACTIONS(6522),
    [anon_sym_BSLASHintertext] = ACTIONS(6522),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [1058] = {
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHpart] = ACTIONS(6406),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddpart] = ACTIONS(6406),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHchapter] = ACTIONS(6406),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddchap] = ACTIONS(6406),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsection] = ACTIONS(6406),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddsec] = ACTIONS(6406),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHitem] = ACTIONS(6406),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6408),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6408),
    [anon_sym_DOLLAR] = ACTIONS(6406),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHbegin] = ACTIONS(6406),
    [anon_sym_BSLASHend] = ACTIONS(6406),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHleft] = ACTIONS(6406),
    [anon_sym_BSLASHbigl] = ACTIONS(6406),
    [anon_sym_BSLASHBigl] = ACTIONS(6406),
    [anon_sym_BSLASHbiggl] = ACTIONS(6406),
    [anon_sym_BSLASHBiggl] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHtext] = ACTIONS(6406),
    [anon_sym_BSLASHintertext] = ACTIONS(6406),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [1059] = {
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6404),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6404),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHpart] = ACTIONS(6402),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddpart] = ACTIONS(6402),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHchapter] = ACTIONS(6402),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddchap] = ACTIONS(6402),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsection] = ACTIONS(6402),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddsec] = ACTIONS(6402),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHitem] = ACTIONS(6402),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6404),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6404),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6404),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHbegin] = ACTIONS(6402),
    [anon_sym_BSLASHend] = ACTIONS(6402),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHleft] = ACTIONS(6402),
    [anon_sym_BSLASHbigl] = ACTIONS(6402),
    [anon_sym_BSLASHBigl] = ACTIONS(6402),
    [anon_sym_BSLASHbiggl] = ACTIONS(6402),
    [anon_sym_BSLASHBiggl] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHtext] = ACTIONS(6402),
    [anon_sym_BSLASHintertext] = ACTIONS(6402),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [1060] = {
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6400),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHpart] = ACTIONS(6398),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddpart] = ACTIONS(6398),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHchapter] = ACTIONS(6398),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddchap] = ACTIONS(6398),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsection] = ACTIONS(6398),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddsec] = ACTIONS(6398),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHitem] = ACTIONS(6398),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6400),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHbegin] = ACTIONS(6398),
    [anon_sym_BSLASHend] = ACTIONS(6398),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHleft] = ACTIONS(6398),
    [anon_sym_BSLASHbigl] = ACTIONS(6398),
    [anon_sym_BSLASHBigl] = ACTIONS(6398),
    [anon_sym_BSLASHbiggl] = ACTIONS(6398),
    [anon_sym_BSLASHBiggl] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHtext] = ACTIONS(6398),
    [anon_sym_BSLASHintertext] = ACTIONS(6398),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [1061] = {
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6396),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6396),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHpart] = ACTIONS(6394),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddpart] = ACTIONS(6394),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHchapter] = ACTIONS(6394),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddchap] = ACTIONS(6394),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsection] = ACTIONS(6394),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddsec] = ACTIONS(6394),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHitem] = ACTIONS(6394),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6396),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6396),
    [anon_sym_DOLLAR] = ACTIONS(6394),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHbegin] = ACTIONS(6394),
    [anon_sym_BSLASHend] = ACTIONS(6394),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHleft] = ACTIONS(6394),
    [anon_sym_BSLASHbigl] = ACTIONS(6394),
    [anon_sym_BSLASHBigl] = ACTIONS(6394),
    [anon_sym_BSLASHbiggl] = ACTIONS(6394),
    [anon_sym_BSLASHBiggl] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHtext] = ACTIONS(6394),
    [anon_sym_BSLASHintertext] = ACTIONS(6394),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [1062] = {
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_COMMA] = ACTIONS(6392),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHpart] = ACTIONS(6390),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddpart] = ACTIONS(6390),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHchapter] = ACTIONS(6390),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddchap] = ACTIONS(6390),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsection] = ACTIONS(6390),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddsec] = ACTIONS(6390),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHitem] = ACTIONS(6390),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6392),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(6390),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHbegin] = ACTIONS(6390),
    [anon_sym_BSLASHend] = ACTIONS(6390),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHleft] = ACTIONS(6390),
    [anon_sym_BSLASHbigl] = ACTIONS(6390),
    [anon_sym_BSLASHBigl] = ACTIONS(6390),
    [anon_sym_BSLASHbiggl] = ACTIONS(6390),
    [anon_sym_BSLASHBiggl] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHtext] = ACTIONS(6390),
    [anon_sym_BSLASHintertext] = ACTIONS(6390),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [1063] = {
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_COMMA] = ACTIONS(6388),
    [anon_sym_EQ] = ACTIONS(6388),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHpart] = ACTIONS(6386),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddpart] = ACTIONS(6386),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHchapter] = ACTIONS(6386),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddchap] = ACTIONS(6386),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsection] = ACTIONS(6386),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddsec] = ACTIONS(6386),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHitem] = ACTIONS(6386),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6388),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(6386),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHbegin] = ACTIONS(6386),
    [anon_sym_BSLASHend] = ACTIONS(6386),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHleft] = ACTIONS(6386),
    [anon_sym_BSLASHbigl] = ACTIONS(6386),
    [anon_sym_BSLASHBigl] = ACTIONS(6386),
    [anon_sym_BSLASHbiggl] = ACTIONS(6386),
    [anon_sym_BSLASHBiggl] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHtext] = ACTIONS(6386),
    [anon_sym_BSLASHintertext] = ACTIONS(6386),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [1064] = {
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_LBRACK] = ACTIONS(6384),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_EQ] = ACTIONS(6384),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_RPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHpart] = ACTIONS(6382),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddpart] = ACTIONS(6382),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHchapter] = ACTIONS(6382),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddchap] = ACTIONS(6382),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsection] = ACTIONS(6382),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddsec] = ACTIONS(6382),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHitem] = ACTIONS(6382),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6384),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6384),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(6382),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHbegin] = ACTIONS(6382),
    [anon_sym_BSLASHend] = ACTIONS(6382),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHleft] = ACTIONS(6382),
    [anon_sym_BSLASHbigl] = ACTIONS(6382),
    [anon_sym_BSLASHBigl] = ACTIONS(6382),
    [anon_sym_BSLASHbiggl] = ACTIONS(6382),
    [anon_sym_BSLASHBiggl] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHtext] = ACTIONS(6382),
    [anon_sym_BSLASHintertext] = ACTIONS(6382),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [1065] = {
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_LBRACK] = ACTIONS(6380),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_EQ] = ACTIONS(6380),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHpart] = ACTIONS(6378),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddpart] = ACTIONS(6378),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHchapter] = ACTIONS(6378),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddchap] = ACTIONS(6378),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsection] = ACTIONS(6378),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddsec] = ACTIONS(6378),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHitem] = ACTIONS(6378),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6380),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6380),
    [anon_sym_DOLLAR] = ACTIONS(6378),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHbegin] = ACTIONS(6378),
    [anon_sym_BSLASHend] = ACTIONS(6378),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHleft] = ACTIONS(6378),
    [anon_sym_BSLASHbigl] = ACTIONS(6378),
    [anon_sym_BSLASHBigl] = ACTIONS(6378),
    [anon_sym_BSLASHbiggl] = ACTIONS(6378),
    [anon_sym_BSLASHBiggl] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHtext] = ACTIONS(6378),
    [anon_sym_BSLASHintertext] = ACTIONS(6378),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [1066] = {
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_LBRACK] = ACTIONS(6376),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_EQ] = ACTIONS(6376),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHpart] = ACTIONS(6374),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddpart] = ACTIONS(6374),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHchapter] = ACTIONS(6374),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddchap] = ACTIONS(6374),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsection] = ACTIONS(6374),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddsec] = ACTIONS(6374),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHitem] = ACTIONS(6374),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6376),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6376),
    [anon_sym_DOLLAR] = ACTIONS(6374),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHbegin] = ACTIONS(6374),
    [anon_sym_BSLASHend] = ACTIONS(6374),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHleft] = ACTIONS(6374),
    [anon_sym_BSLASHbigl] = ACTIONS(6374),
    [anon_sym_BSLASHBigl] = ACTIONS(6374),
    [anon_sym_BSLASHbiggl] = ACTIONS(6374),
    [anon_sym_BSLASHBiggl] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHtext] = ACTIONS(6374),
    [anon_sym_BSLASHintertext] = ACTIONS(6374),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [1067] = {
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_LBRACK] = ACTIONS(6424),
    [anon_sym_RBRACK] = ACTIONS(6424),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_EQ] = ACTIONS(6424),
    [anon_sym_LPAREN] = ACTIONS(6424),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHpart] = ACTIONS(6422),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddpart] = ACTIONS(6422),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHchapter] = ACTIONS(6422),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddchap] = ACTIONS(6422),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsection] = ACTIONS(6422),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddsec] = ACTIONS(6422),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHitem] = ACTIONS(6422),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6424),
    [anon_sym_LBRACE] = ACTIONS(6424),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6424),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6424),
    [anon_sym_DOLLAR] = ACTIONS(6422),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHbegin] = ACTIONS(6422),
    [anon_sym_BSLASHend] = ACTIONS(6422),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHleft] = ACTIONS(6422),
    [anon_sym_BSLASHbigl] = ACTIONS(6422),
    [anon_sym_BSLASHBigl] = ACTIONS(6422),
    [anon_sym_BSLASHbiggl] = ACTIONS(6422),
    [anon_sym_BSLASHBiggl] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHtext] = ACTIONS(6422),
    [anon_sym_BSLASHintertext] = ACTIONS(6422),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [1068] = {
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LPAREN] = ACTIONS(6364),
    [anon_sym_RPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHpart] = ACTIONS(6362),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddpart] = ACTIONS(6362),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHchapter] = ACTIONS(6362),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddchap] = ACTIONS(6362),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsection] = ACTIONS(6362),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddsec] = ACTIONS(6362),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHitem] = ACTIONS(6362),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6364),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6364),
    [anon_sym_DOLLAR] = ACTIONS(6362),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHbegin] = ACTIONS(6362),
    [anon_sym_BSLASHend] = ACTIONS(6362),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHleft] = ACTIONS(6362),
    [anon_sym_BSLASHbigl] = ACTIONS(6362),
    [anon_sym_BSLASHBigl] = ACTIONS(6362),
    [anon_sym_BSLASHbiggl] = ACTIONS(6362),
    [anon_sym_BSLASHBiggl] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHtext] = ACTIONS(6362),
    [anon_sym_BSLASHintertext] = ACTIONS(6362),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [1069] = {
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_RBRACK] = ACTIONS(6356),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_EQ] = ACTIONS(6356),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_RPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHpart] = ACTIONS(6354),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddpart] = ACTIONS(6354),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHchapter] = ACTIONS(6354),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddchap] = ACTIONS(6354),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsection] = ACTIONS(6354),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddsec] = ACTIONS(6354),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHitem] = ACTIONS(6354),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6356),
    [anon_sym_LBRACE] = ACTIONS(6356),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6356),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6356),
    [anon_sym_DOLLAR] = ACTIONS(6354),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHbegin] = ACTIONS(6354),
    [anon_sym_BSLASHend] = ACTIONS(6354),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHleft] = ACTIONS(6354),
    [anon_sym_BSLASHbigl] = ACTIONS(6354),
    [anon_sym_BSLASHBigl] = ACTIONS(6354),
    [anon_sym_BSLASHbiggl] = ACTIONS(6354),
    [anon_sym_BSLASHBiggl] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHtext] = ACTIONS(6354),
    [anon_sym_BSLASHintertext] = ACTIONS(6354),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [1070] = {
    [sym_command_name] = ACTIONS(6642),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6642),
    [anon_sym_LBRACK] = ACTIONS(6644),
    [anon_sym_RBRACK] = ACTIONS(6644),
    [anon_sym_COMMA] = ACTIONS(6644),
    [anon_sym_EQ] = ACTIONS(6644),
    [anon_sym_LPAREN] = ACTIONS(6644),
    [anon_sym_RPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHpart] = ACTIONS(6642),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddpart] = ACTIONS(6642),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHchapter] = ACTIONS(6642),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddchap] = ACTIONS(6642),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsection] = ACTIONS(6642),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddsec] = ACTIONS(6642),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHitem] = ACTIONS(6642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6644),
    [anon_sym_LBRACE] = ACTIONS(6644),
    [sym_word] = ACTIONS(6642),
    [sym_placeholder] = ACTIONS(6644),
    [anon_sym_PLUS] = ACTIONS(6644),
    [anon_sym_DASH] = ACTIONS(6644),
    [anon_sym_STAR] = ACTIONS(6644),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_LT] = ACTIONS(6642),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_BANG] = ACTIONS(6642),
    [anon_sym_PIPE] = ACTIONS(6642),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_SQUOTE] = ACTIONS(6642),
    [anon_sym__] = ACTIONS(6644),
    [anon_sym_CARET] = ACTIONS(6644),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6644),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6644),
    [anon_sym_DOLLAR] = ACTIONS(6642),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHbegin] = ACTIONS(6642),
    [anon_sym_BSLASHend] = ACTIONS(6642),
    [anon_sym_BSLASHtitle] = ACTIONS(6642),
    [anon_sym_BSLASHauthor] = ACTIONS(6642),
    [anon_sym_BSLASHusepackage] = ACTIONS(6642),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6642),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6642),
    [anon_sym_BSLASHinclude] = ACTIONS(6642),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6642),
    [anon_sym_BSLASHinput] = ACTIONS(6642),
    [anon_sym_BSLASHsubfile] = ACTIONS(6642),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6642),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6642),
    [anon_sym_BSLASHbibliography] = ACTIONS(6642),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6642),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6642),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6642),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6642),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6642),
    [anon_sym_BSLASHimport] = ACTIONS(6642),
    [anon_sym_BSLASHsubimport] = ACTIONS(6642),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6642),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHcaption] = ACTIONS(6642),
    [anon_sym_BSLASHcite] = ACTIONS(6642),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCite] = ACTIONS(6642),
    [anon_sym_BSLASHnocite] = ACTIONS(6642),
    [anon_sym_BSLASHcitet] = ACTIONS(6642),
    [anon_sym_BSLASHcitep] = ACTIONS(6642),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteA] = ACTIONS(6642),
    [anon_sym_BSLASHciteR] = ACTIONS(6642),
    [anon_sym_BSLASHciteS] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6642),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteyear] = ACTIONS(6642),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitedate] = ACTIONS(6642),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteurl] = ACTIONS(6642),
    [anon_sym_BSLASHfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6642),
    [anon_sym_BSLASHcitealt] = ACTIONS(6642),
    [anon_sym_BSLASHcitealp] = ACTIONS(6642),
    [anon_sym_BSLASHcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHparencite] = ACTIONS(6642),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHParencite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHtextcite] = ACTIONS(6642),
    [anon_sym_BSLASHTextcite] = ACTIONS(6642),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHsupercite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite] = ACTIONS(6642),
    [anon_sym_BSLASHAutocite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHVolcite] = ACTIONS(6642),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHavolcite] = ACTIONS(6642),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHNotecite] = ACTIONS(6642),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHlabel] = ACTIONS(6642),
    [anon_sym_BSLASHref] = ACTIONS(6642),
    [anon_sym_BSLASHeqref] = ACTIONS(6642),
    [anon_sym_BSLASHvref] = ACTIONS(6642),
    [anon_sym_BSLASHVref] = ACTIONS(6642),
    [anon_sym_BSLASHautoref] = ACTIONS(6642),
    [anon_sym_BSLASHpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcref] = ACTIONS(6642),
    [anon_sym_BSLASHCref] = ACTIONS(6642),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnameCref] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHdef] = ACTIONS(6642),
    [anon_sym_BSLASHlet] = ACTIONS(6642),
    [anon_sym_BSLASHleft] = ACTIONS(6642),
    [anon_sym_BSLASHbigl] = ACTIONS(6642),
    [anon_sym_BSLASHBigl] = ACTIONS(6642),
    [anon_sym_BSLASHbiggl] = ACTIONS(6642),
    [anon_sym_BSLASHBiggl] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6642),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6642),
    [anon_sym_BSLASHgls] = ACTIONS(6642),
    [anon_sym_BSLASHGls] = ACTIONS(6642),
    [anon_sym_BSLASHGLS] = ACTIONS(6642),
    [anon_sym_BSLASHglspl] = ACTIONS(6642),
    [anon_sym_BSLASHGlspl] = ACTIONS(6642),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6642),
    [anon_sym_BSLASHglslink] = ACTIONS(6642),
    [anon_sym_BSLASHglstext] = ACTIONS(6642),
    [anon_sym_BSLASHGlstext] = ACTIONS(6642),
    [anon_sym_BSLASHGLStext] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6642),
    [anon_sym_BSLASHglsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsname] = ACTIONS(6642),
    [anon_sym_BSLASHGlsname] = ACTIONS(6642),
    [anon_sym_BSLASHGLSname] = ACTIONS(6642),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6642),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6642),
    [anon_sym_BSLASHacrshort] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6642),
    [anon_sym_BSLASHACRshort] = ACTIONS(6642),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrlong] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6642),
    [anon_sym_BSLASHACRlong] = ACTIONS(6642),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrfull] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6642),
    [anon_sym_BSLASHACRfull] = ACTIONS(6642),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHacs] = ACTIONS(6642),
    [anon_sym_BSLASHAcs] = ACTIONS(6642),
    [anon_sym_BSLASHacsp] = ACTIONS(6642),
    [anon_sym_BSLASHAcsp] = ACTIONS(6642),
    [anon_sym_BSLASHacl] = ACTIONS(6642),
    [anon_sym_BSLASHAcl] = ACTIONS(6642),
    [anon_sym_BSLASHaclp] = ACTIONS(6642),
    [anon_sym_BSLASHAclp] = ACTIONS(6642),
    [anon_sym_BSLASHacf] = ACTIONS(6642),
    [anon_sym_BSLASHAcf] = ACTIONS(6642),
    [anon_sym_BSLASHacfp] = ACTIONS(6642),
    [anon_sym_BSLASHAcfp] = ACTIONS(6642),
    [anon_sym_BSLASHac] = ACTIONS(6642),
    [anon_sym_BSLASHAc] = ACTIONS(6642),
    [anon_sym_BSLASHacp] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6642),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6642),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6642),
    [anon_sym_BSLASHcolor] = ACTIONS(6642),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6642),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6642),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6642),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6642),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6642),
    [anon_sym_BSLASHtext] = ACTIONS(6642),
    [anon_sym_BSLASHintertext] = ACTIONS(6642),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6642),
    [anon_sym_BSLASHurl] = ACTIONS(6642),
    [anon_sym_BSLASHhref] = ACTIONS(6642),
  },
  [1071] = {
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_RBRACK] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHpart] = ACTIONS(6418),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddpart] = ACTIONS(6418),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHchapter] = ACTIONS(6418),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddchap] = ACTIONS(6418),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsection] = ACTIONS(6418),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddsec] = ACTIONS(6418),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHitem] = ACTIONS(6418),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6420),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6420),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(6418),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHbegin] = ACTIONS(6418),
    [anon_sym_BSLASHend] = ACTIONS(6418),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHleft] = ACTIONS(6418),
    [anon_sym_BSLASHbigl] = ACTIONS(6418),
    [anon_sym_BSLASHBigl] = ACTIONS(6418),
    [anon_sym_BSLASHbiggl] = ACTIONS(6418),
    [anon_sym_BSLASHBiggl] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHtext] = ACTIONS(6418),
    [anon_sym_BSLASHintertext] = ACTIONS(6418),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [1072] = {
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6416),
    [anon_sym_EQ] = ACTIONS(6416),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_RPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHpart] = ACTIONS(6414),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddpart] = ACTIONS(6414),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHchapter] = ACTIONS(6414),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddchap] = ACTIONS(6414),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsection] = ACTIONS(6414),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddsec] = ACTIONS(6414),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHitem] = ACTIONS(6414),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6416),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(6414),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHbegin] = ACTIONS(6414),
    [anon_sym_BSLASHend] = ACTIONS(6414),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHleft] = ACTIONS(6414),
    [anon_sym_BSLASHbigl] = ACTIONS(6414),
    [anon_sym_BSLASHBigl] = ACTIONS(6414),
    [anon_sym_BSLASHbiggl] = ACTIONS(6414),
    [anon_sym_BSLASHBiggl] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHtext] = ACTIONS(6414),
    [anon_sym_BSLASHintertext] = ACTIONS(6414),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [1073] = {
    [sym_command_name] = ACTIONS(6562),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6562),
    [anon_sym_LBRACK] = ACTIONS(6564),
    [anon_sym_RBRACK] = ACTIONS(6564),
    [anon_sym_COMMA] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6564),
    [anon_sym_RPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHpart] = ACTIONS(6562),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddpart] = ACTIONS(6562),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHchapter] = ACTIONS(6562),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddchap] = ACTIONS(6562),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsection] = ACTIONS(6562),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddsec] = ACTIONS(6562),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHitem] = ACTIONS(6562),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6564),
    [anon_sym_LBRACE] = ACTIONS(6564),
    [sym_word] = ACTIONS(6562),
    [sym_placeholder] = ACTIONS(6564),
    [anon_sym_PLUS] = ACTIONS(6564),
    [anon_sym_DASH] = ACTIONS(6564),
    [anon_sym_STAR] = ACTIONS(6564),
    [anon_sym_SLASH] = ACTIONS(6564),
    [anon_sym_LT] = ACTIONS(6562),
    [anon_sym_GT] = ACTIONS(6562),
    [anon_sym_BANG] = ACTIONS(6562),
    [anon_sym_PIPE] = ACTIONS(6562),
    [anon_sym_COLON] = ACTIONS(6562),
    [anon_sym_SQUOTE] = ACTIONS(6562),
    [anon_sym__] = ACTIONS(6564),
    [anon_sym_CARET] = ACTIONS(6564),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6564),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6564),
    [anon_sym_DOLLAR] = ACTIONS(6562),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6564),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHbegin] = ACTIONS(6562),
    [anon_sym_BSLASHtitle] = ACTIONS(6562),
    [anon_sym_BSLASHauthor] = ACTIONS(6562),
    [anon_sym_BSLASHusepackage] = ACTIONS(6562),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6562),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6562),
    [anon_sym_BSLASHinclude] = ACTIONS(6562),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6562),
    [anon_sym_BSLASHinput] = ACTIONS(6562),
    [anon_sym_BSLASHsubfile] = ACTIONS(6562),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6562),
    [anon_sym_BSLASHbibliography] = ACTIONS(6562),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6562),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6562),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6562),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6562),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6562),
    [anon_sym_BSLASHimport] = ACTIONS(6562),
    [anon_sym_BSLASHsubimport] = ACTIONS(6562),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6562),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHcaption] = ACTIONS(6562),
    [anon_sym_BSLASHcite] = ACTIONS(6562),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCite] = ACTIONS(6562),
    [anon_sym_BSLASHnocite] = ACTIONS(6562),
    [anon_sym_BSLASHcitet] = ACTIONS(6562),
    [anon_sym_BSLASHcitep] = ACTIONS(6562),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteA] = ACTIONS(6562),
    [anon_sym_BSLASHciteR] = ACTIONS(6562),
    [anon_sym_BSLASHciteS] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6562),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteyear] = ACTIONS(6562),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitedate] = ACTIONS(6562),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteurl] = ACTIONS(6562),
    [anon_sym_BSLASHfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6562),
    [anon_sym_BSLASHcitealt] = ACTIONS(6562),
    [anon_sym_BSLASHcitealp] = ACTIONS(6562),
    [anon_sym_BSLASHcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHparencite] = ACTIONS(6562),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHParencite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHtextcite] = ACTIONS(6562),
    [anon_sym_BSLASHTextcite] = ACTIONS(6562),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHsupercite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite] = ACTIONS(6562),
    [anon_sym_BSLASHAutocite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHVolcite] = ACTIONS(6562),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHavolcite] = ACTIONS(6562),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHNotecite] = ACTIONS(6562),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHlabel] = ACTIONS(6562),
    [anon_sym_BSLASHref] = ACTIONS(6562),
    [anon_sym_BSLASHeqref] = ACTIONS(6562),
    [anon_sym_BSLASHvref] = ACTIONS(6562),
    [anon_sym_BSLASHVref] = ACTIONS(6562),
    [anon_sym_BSLASHautoref] = ACTIONS(6562),
    [anon_sym_BSLASHpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcref] = ACTIONS(6562),
    [anon_sym_BSLASHCref] = ACTIONS(6562),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnameCref] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHdef] = ACTIONS(6562),
    [anon_sym_BSLASHlet] = ACTIONS(6562),
    [anon_sym_BSLASHleft] = ACTIONS(6562),
    [anon_sym_BSLASHbigl] = ACTIONS(6562),
    [anon_sym_BSLASHBigl] = ACTIONS(6562),
    [anon_sym_BSLASHbiggl] = ACTIONS(6562),
    [anon_sym_BSLASHBiggl] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6562),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6562),
    [anon_sym_BSLASHgls] = ACTIONS(6562),
    [anon_sym_BSLASHGls] = ACTIONS(6562),
    [anon_sym_BSLASHGLS] = ACTIONS(6562),
    [anon_sym_BSLASHglspl] = ACTIONS(6562),
    [anon_sym_BSLASHGlspl] = ACTIONS(6562),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6562),
    [anon_sym_BSLASHglslink] = ACTIONS(6562),
    [anon_sym_BSLASHglstext] = ACTIONS(6562),
    [anon_sym_BSLASHGlstext] = ACTIONS(6562),
    [anon_sym_BSLASHGLStext] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6562),
    [anon_sym_BSLASHglsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsname] = ACTIONS(6562),
    [anon_sym_BSLASHGlsname] = ACTIONS(6562),
    [anon_sym_BSLASHGLSname] = ACTIONS(6562),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6562),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6562),
    [anon_sym_BSLASHacrshort] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6562),
    [anon_sym_BSLASHACRshort] = ACTIONS(6562),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrlong] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6562),
    [anon_sym_BSLASHACRlong] = ACTIONS(6562),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrfull] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6562),
    [anon_sym_BSLASHACRfull] = ACTIONS(6562),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHacs] = ACTIONS(6562),
    [anon_sym_BSLASHAcs] = ACTIONS(6562),
    [anon_sym_BSLASHacsp] = ACTIONS(6562),
    [anon_sym_BSLASHAcsp] = ACTIONS(6562),
    [anon_sym_BSLASHacl] = ACTIONS(6562),
    [anon_sym_BSLASHAcl] = ACTIONS(6562),
    [anon_sym_BSLASHaclp] = ACTIONS(6562),
    [anon_sym_BSLASHAclp] = ACTIONS(6562),
    [anon_sym_BSLASHacf] = ACTIONS(6562),
    [anon_sym_BSLASHAcf] = ACTIONS(6562),
    [anon_sym_BSLASHacfp] = ACTIONS(6562),
    [anon_sym_BSLASHAcfp] = ACTIONS(6562),
    [anon_sym_BSLASHac] = ACTIONS(6562),
    [anon_sym_BSLASHAc] = ACTIONS(6562),
    [anon_sym_BSLASHacp] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6562),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6562),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6562),
    [anon_sym_BSLASHcolor] = ACTIONS(6562),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6562),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6562),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6562),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6562),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6562),
    [anon_sym_BSLASHtext] = ACTIONS(6562),
    [anon_sym_BSLASHintertext] = ACTIONS(6562),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6562),
    [anon_sym_BSLASHurl] = ACTIONS(6562),
    [anon_sym_BSLASHhref] = ACTIONS(6562),
  },
  [1074] = {
    [sym_command_name] = ACTIONS(2214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_RBRACK] = ACTIONS(2216),
    [anon_sym_COMMA] = ACTIONS(2216),
    [anon_sym_EQ] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2216),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHitem] = ACTIONS(2214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [sym_word] = ACTIONS(2214),
    [sym_placeholder] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_COLON] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [anon_sym__] = ACTIONS(2216),
    [anon_sym_CARET] = ACTIONS(2216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2216),
    [anon_sym_DOLLAR] = ACTIONS(2214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHbegin] = ACTIONS(2214),
    [anon_sym_BSLASHend] = ACTIONS(2214),
    [anon_sym_BSLASHtitle] = ACTIONS(2214),
    [anon_sym_BSLASHauthor] = ACTIONS(2214),
    [anon_sym_BSLASHusepackage] = ACTIONS(2214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2214),
    [anon_sym_BSLASHinclude] = ACTIONS(2214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2214),
    [anon_sym_BSLASHinput] = ACTIONS(2214),
    [anon_sym_BSLASHsubfile] = ACTIONS(2214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2214),
    [anon_sym_BSLASHbibliography] = ACTIONS(2214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2214),
    [anon_sym_BSLASHimport] = ACTIONS(2214),
    [anon_sym_BSLASHsubimport] = ACTIONS(2214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHcaption] = ACTIONS(2214),
    [anon_sym_BSLASHcite] = ACTIONS(2214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCite] = ACTIONS(2214),
    [anon_sym_BSLASHnocite] = ACTIONS(2214),
    [anon_sym_BSLASHcitet] = ACTIONS(2214),
    [anon_sym_BSLASHcitep] = ACTIONS(2214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteA] = ACTIONS(2214),
    [anon_sym_BSLASHciteR] = ACTIONS(2214),
    [anon_sym_BSLASHciteS] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteyear] = ACTIONS(2214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitedate] = ACTIONS(2214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteurl] = ACTIONS(2214),
    [anon_sym_BSLASHfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2214),
    [anon_sym_BSLASHcitealt] = ACTIONS(2214),
    [anon_sym_BSLASHcitealp] = ACTIONS(2214),
    [anon_sym_BSLASHcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHparencite] = ACTIONS(2214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHParencite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHtextcite] = ACTIONS(2214),
    [anon_sym_BSLASHTextcite] = ACTIONS(2214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHsupercite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite] = ACTIONS(2214),
    [anon_sym_BSLASHAutocite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHVolcite] = ACTIONS(2214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHavolcite] = ACTIONS(2214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHNotecite] = ACTIONS(2214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHlabel] = ACTIONS(2214),
    [anon_sym_BSLASHref] = ACTIONS(2214),
    [anon_sym_BSLASHeqref] = ACTIONS(2214),
    [anon_sym_BSLASHvref] = ACTIONS(2214),
    [anon_sym_BSLASHVref] = ACTIONS(2214),
    [anon_sym_BSLASHautoref] = ACTIONS(2214),
    [anon_sym_BSLASHpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcref] = ACTIONS(2214),
    [anon_sym_BSLASHCref] = ACTIONS(2214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnameCref] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHdef] = ACTIONS(2214),
    [anon_sym_BSLASHlet] = ACTIONS(2214),
    [anon_sym_BSLASHleft] = ACTIONS(2214),
    [anon_sym_BSLASHbigl] = ACTIONS(2214),
    [anon_sym_BSLASHBigl] = ACTIONS(2214),
    [anon_sym_BSLASHbiggl] = ACTIONS(2214),
    [anon_sym_BSLASHBiggl] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2214),
    [anon_sym_BSLASHgls] = ACTIONS(2214),
    [anon_sym_BSLASHGls] = ACTIONS(2214),
    [anon_sym_BSLASHGLS] = ACTIONS(2214),
    [anon_sym_BSLASHglspl] = ACTIONS(2214),
    [anon_sym_BSLASHGlspl] = ACTIONS(2214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2214),
    [anon_sym_BSLASHglslink] = ACTIONS(2214),
    [anon_sym_BSLASHglstext] = ACTIONS(2214),
    [anon_sym_BSLASHGlstext] = ACTIONS(2214),
    [anon_sym_BSLASHGLStext] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2214),
    [anon_sym_BSLASHglsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsname] = ACTIONS(2214),
    [anon_sym_BSLASHGlsname] = ACTIONS(2214),
    [anon_sym_BSLASHGLSname] = ACTIONS(2214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2214),
    [anon_sym_BSLASHacrshort] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2214),
    [anon_sym_BSLASHACRshort] = ACTIONS(2214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrlong] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2214),
    [anon_sym_BSLASHACRlong] = ACTIONS(2214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrfull] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2214),
    [anon_sym_BSLASHACRfull] = ACTIONS(2214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHacs] = ACTIONS(2214),
    [anon_sym_BSLASHAcs] = ACTIONS(2214),
    [anon_sym_BSLASHacsp] = ACTIONS(2214),
    [anon_sym_BSLASHAcsp] = ACTIONS(2214),
    [anon_sym_BSLASHacl] = ACTIONS(2214),
    [anon_sym_BSLASHAcl] = ACTIONS(2214),
    [anon_sym_BSLASHaclp] = ACTIONS(2214),
    [anon_sym_BSLASHAclp] = ACTIONS(2214),
    [anon_sym_BSLASHacf] = ACTIONS(2214),
    [anon_sym_BSLASHAcf] = ACTIONS(2214),
    [anon_sym_BSLASHacfp] = ACTIONS(2214),
    [anon_sym_BSLASHAcfp] = ACTIONS(2214),
    [anon_sym_BSLASHac] = ACTIONS(2214),
    [anon_sym_BSLASHAc] = ACTIONS(2214),
    [anon_sym_BSLASHacp] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2214),
    [anon_sym_BSLASHcolor] = ACTIONS(2214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2214),
    [anon_sym_BSLASHtext] = ACTIONS(2214),
    [anon_sym_BSLASHintertext] = ACTIONS(2214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2214),
    [anon_sym_BSLASHurl] = ACTIONS(2214),
    [anon_sym_BSLASHhref] = ACTIONS(2214),
  },
  [1075] = {
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_RBRACK] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6428),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_RPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHpart] = ACTIONS(6426),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddpart] = ACTIONS(6426),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHchapter] = ACTIONS(6426),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddchap] = ACTIONS(6426),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsection] = ACTIONS(6426),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddsec] = ACTIONS(6426),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHitem] = ACTIONS(6426),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6428),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6428),
    [anon_sym_DOLLAR] = ACTIONS(6426),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHbegin] = ACTIONS(6426),
    [anon_sym_BSLASHend] = ACTIONS(6426),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHleft] = ACTIONS(6426),
    [anon_sym_BSLASHbigl] = ACTIONS(6426),
    [anon_sym_BSLASHBigl] = ACTIONS(6426),
    [anon_sym_BSLASHbiggl] = ACTIONS(6426),
    [anon_sym_BSLASHBiggl] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHtext] = ACTIONS(6426),
    [anon_sym_BSLASHintertext] = ACTIONS(6426),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [1076] = {
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHpart] = ACTIONS(6430),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddpart] = ACTIONS(6430),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHchapter] = ACTIONS(6430),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddchap] = ACTIONS(6430),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsection] = ACTIONS(6430),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddsec] = ACTIONS(6430),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHitem] = ACTIONS(6430),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6432),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6432),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6432),
    [anon_sym_DOLLAR] = ACTIONS(6430),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHbegin] = ACTIONS(6430),
    [anon_sym_BSLASHend] = ACTIONS(6430),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHleft] = ACTIONS(6430),
    [anon_sym_BSLASHbigl] = ACTIONS(6430),
    [anon_sym_BSLASHBigl] = ACTIONS(6430),
    [anon_sym_BSLASHbiggl] = ACTIONS(6430),
    [anon_sym_BSLASHBiggl] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHtext] = ACTIONS(6430),
    [anon_sym_BSLASHintertext] = ACTIONS(6430),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [1077] = {
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6436),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_EQ] = ACTIONS(6436),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHpart] = ACTIONS(6434),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddpart] = ACTIONS(6434),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHchapter] = ACTIONS(6434),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddchap] = ACTIONS(6434),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsection] = ACTIONS(6434),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddsec] = ACTIONS(6434),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHitem] = ACTIONS(6434),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6436),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6436),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6436),
    [anon_sym_DOLLAR] = ACTIONS(6434),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHbegin] = ACTIONS(6434),
    [anon_sym_BSLASHend] = ACTIONS(6434),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHleft] = ACTIONS(6434),
    [anon_sym_BSLASHbigl] = ACTIONS(6434),
    [anon_sym_BSLASHBigl] = ACTIONS(6434),
    [anon_sym_BSLASHbiggl] = ACTIONS(6434),
    [anon_sym_BSLASHBiggl] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHtext] = ACTIONS(6434),
    [anon_sym_BSLASHintertext] = ACTIONS(6434),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [1078] = {
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_LBRACK] = ACTIONS(6440),
    [anon_sym_RBRACK] = ACTIONS(6440),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6440),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_RPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHpart] = ACTIONS(6438),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddpart] = ACTIONS(6438),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHchapter] = ACTIONS(6438),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddchap] = ACTIONS(6438),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsection] = ACTIONS(6438),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddsec] = ACTIONS(6438),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHitem] = ACTIONS(6438),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6440),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6440),
    [anon_sym_DOLLAR] = ACTIONS(6438),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHbegin] = ACTIONS(6438),
    [anon_sym_BSLASHend] = ACTIONS(6438),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHleft] = ACTIONS(6438),
    [anon_sym_BSLASHbigl] = ACTIONS(6438),
    [anon_sym_BSLASHBigl] = ACTIONS(6438),
    [anon_sym_BSLASHbiggl] = ACTIONS(6438),
    [anon_sym_BSLASHBiggl] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHtext] = ACTIONS(6438),
    [anon_sym_BSLASHintertext] = ACTIONS(6438),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [1079] = {
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6444),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHpart] = ACTIONS(6442),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddpart] = ACTIONS(6442),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHchapter] = ACTIONS(6442),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddchap] = ACTIONS(6442),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsection] = ACTIONS(6442),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddsec] = ACTIONS(6442),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHitem] = ACTIONS(6442),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6444),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6444),
    [anon_sym_DOLLAR] = ACTIONS(6442),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHbegin] = ACTIONS(6442),
    [anon_sym_BSLASHend] = ACTIONS(6442),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHleft] = ACTIONS(6442),
    [anon_sym_BSLASHbigl] = ACTIONS(6442),
    [anon_sym_BSLASHBigl] = ACTIONS(6442),
    [anon_sym_BSLASHbiggl] = ACTIONS(6442),
    [anon_sym_BSLASHBiggl] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHtext] = ACTIONS(6442),
    [anon_sym_BSLASHintertext] = ACTIONS(6442),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [1080] = {
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6448),
    [anon_sym_RBRACK] = ACTIONS(6448),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(6448),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHpart] = ACTIONS(6446),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddpart] = ACTIONS(6446),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHchapter] = ACTIONS(6446),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddchap] = ACTIONS(6446),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsection] = ACTIONS(6446),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddsec] = ACTIONS(6446),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHitem] = ACTIONS(6446),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6448),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6448),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6448),
    [anon_sym_DOLLAR] = ACTIONS(6446),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHbegin] = ACTIONS(6446),
    [anon_sym_BSLASHend] = ACTIONS(6446),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHleft] = ACTIONS(6446),
    [anon_sym_BSLASHbigl] = ACTIONS(6446),
    [anon_sym_BSLASHBigl] = ACTIONS(6446),
    [anon_sym_BSLASHbiggl] = ACTIONS(6446),
    [anon_sym_BSLASHBiggl] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHtext] = ACTIONS(6446),
    [anon_sym_BSLASHintertext] = ACTIONS(6446),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [1081] = {
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHpart] = ACTIONS(6454),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddpart] = ACTIONS(6454),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHchapter] = ACTIONS(6454),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddchap] = ACTIONS(6454),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsection] = ACTIONS(6454),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddsec] = ACTIONS(6454),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHitem] = ACTIONS(6454),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6456),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(6454),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHbegin] = ACTIONS(6454),
    [anon_sym_BSLASHend] = ACTIONS(6454),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHleft] = ACTIONS(6454),
    [anon_sym_BSLASHbigl] = ACTIONS(6454),
    [anon_sym_BSLASHBigl] = ACTIONS(6454),
    [anon_sym_BSLASHbiggl] = ACTIONS(6454),
    [anon_sym_BSLASHBiggl] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHtext] = ACTIONS(6454),
    [anon_sym_BSLASHintertext] = ACTIONS(6454),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [1082] = {
    [sym_command_name] = ACTIONS(6546),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6548),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LPAREN] = ACTIONS(6548),
    [anon_sym_RPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHpart] = ACTIONS(6546),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddpart] = ACTIONS(6546),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHchapter] = ACTIONS(6546),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddchap] = ACTIONS(6546),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsection] = ACTIONS(6546),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddsec] = ACTIONS(6546),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHitem] = ACTIONS(6546),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6548),
    [anon_sym_LBRACE] = ACTIONS(6548),
    [sym_word] = ACTIONS(6546),
    [sym_placeholder] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_DASH] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6546),
    [anon_sym_GT] = ACTIONS(6546),
    [anon_sym_BANG] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6546),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_SQUOTE] = ACTIONS(6546),
    [anon_sym__] = ACTIONS(6548),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6548),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6548),
    [anon_sym_DOLLAR] = ACTIONS(6546),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHbegin] = ACTIONS(6546),
    [anon_sym_BSLASHend] = ACTIONS(6546),
    [anon_sym_BSLASHtitle] = ACTIONS(6546),
    [anon_sym_BSLASHauthor] = ACTIONS(6546),
    [anon_sym_BSLASHusepackage] = ACTIONS(6546),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6546),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6546),
    [anon_sym_BSLASHinclude] = ACTIONS(6546),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6546),
    [anon_sym_BSLASHinput] = ACTIONS(6546),
    [anon_sym_BSLASHsubfile] = ACTIONS(6546),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6546),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6546),
    [anon_sym_BSLASHbibliography] = ACTIONS(6546),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6546),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6546),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6546),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6546),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6546),
    [anon_sym_BSLASHimport] = ACTIONS(6546),
    [anon_sym_BSLASHsubimport] = ACTIONS(6546),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6546),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHcaption] = ACTIONS(6546),
    [anon_sym_BSLASHcite] = ACTIONS(6546),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCite] = ACTIONS(6546),
    [anon_sym_BSLASHnocite] = ACTIONS(6546),
    [anon_sym_BSLASHcitet] = ACTIONS(6546),
    [anon_sym_BSLASHcitep] = ACTIONS(6546),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteA] = ACTIONS(6546),
    [anon_sym_BSLASHciteR] = ACTIONS(6546),
    [anon_sym_BSLASHciteS] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6546),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteyear] = ACTIONS(6546),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitedate] = ACTIONS(6546),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteurl] = ACTIONS(6546),
    [anon_sym_BSLASHfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6546),
    [anon_sym_BSLASHcitealt] = ACTIONS(6546),
    [anon_sym_BSLASHcitealp] = ACTIONS(6546),
    [anon_sym_BSLASHcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHparencite] = ACTIONS(6546),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHParencite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHtextcite] = ACTIONS(6546),
    [anon_sym_BSLASHTextcite] = ACTIONS(6546),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHsupercite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite] = ACTIONS(6546),
    [anon_sym_BSLASHAutocite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHVolcite] = ACTIONS(6546),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHavolcite] = ACTIONS(6546),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHNotecite] = ACTIONS(6546),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHlabel] = ACTIONS(6546),
    [anon_sym_BSLASHref] = ACTIONS(6546),
    [anon_sym_BSLASHeqref] = ACTIONS(6546),
    [anon_sym_BSLASHvref] = ACTIONS(6546),
    [anon_sym_BSLASHVref] = ACTIONS(6546),
    [anon_sym_BSLASHautoref] = ACTIONS(6546),
    [anon_sym_BSLASHpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcref] = ACTIONS(6546),
    [anon_sym_BSLASHCref] = ACTIONS(6546),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnameCref] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHdef] = ACTIONS(6546),
    [anon_sym_BSLASHlet] = ACTIONS(6546),
    [anon_sym_BSLASHleft] = ACTIONS(6546),
    [anon_sym_BSLASHbigl] = ACTIONS(6546),
    [anon_sym_BSLASHBigl] = ACTIONS(6546),
    [anon_sym_BSLASHbiggl] = ACTIONS(6546),
    [anon_sym_BSLASHBiggl] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6546),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6546),
    [anon_sym_BSLASHgls] = ACTIONS(6546),
    [anon_sym_BSLASHGls] = ACTIONS(6546),
    [anon_sym_BSLASHGLS] = ACTIONS(6546),
    [anon_sym_BSLASHglspl] = ACTIONS(6546),
    [anon_sym_BSLASHGlspl] = ACTIONS(6546),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6546),
    [anon_sym_BSLASHglslink] = ACTIONS(6546),
    [anon_sym_BSLASHglstext] = ACTIONS(6546),
    [anon_sym_BSLASHGlstext] = ACTIONS(6546),
    [anon_sym_BSLASHGLStext] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6546),
    [anon_sym_BSLASHglsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsname] = ACTIONS(6546),
    [anon_sym_BSLASHGlsname] = ACTIONS(6546),
    [anon_sym_BSLASHGLSname] = ACTIONS(6546),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6546),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6546),
    [anon_sym_BSLASHacrshort] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6546),
    [anon_sym_BSLASHACRshort] = ACTIONS(6546),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrlong] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6546),
    [anon_sym_BSLASHACRlong] = ACTIONS(6546),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrfull] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6546),
    [anon_sym_BSLASHACRfull] = ACTIONS(6546),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHacs] = ACTIONS(6546),
    [anon_sym_BSLASHAcs] = ACTIONS(6546),
    [anon_sym_BSLASHacsp] = ACTIONS(6546),
    [anon_sym_BSLASHAcsp] = ACTIONS(6546),
    [anon_sym_BSLASHacl] = ACTIONS(6546),
    [anon_sym_BSLASHAcl] = ACTIONS(6546),
    [anon_sym_BSLASHaclp] = ACTIONS(6546),
    [anon_sym_BSLASHAclp] = ACTIONS(6546),
    [anon_sym_BSLASHacf] = ACTIONS(6546),
    [anon_sym_BSLASHAcf] = ACTIONS(6546),
    [anon_sym_BSLASHacfp] = ACTIONS(6546),
    [anon_sym_BSLASHAcfp] = ACTIONS(6546),
    [anon_sym_BSLASHac] = ACTIONS(6546),
    [anon_sym_BSLASHAc] = ACTIONS(6546),
    [anon_sym_BSLASHacp] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6546),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6546),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6546),
    [anon_sym_BSLASHcolor] = ACTIONS(6546),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6546),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6546),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6546),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6546),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6546),
    [anon_sym_BSLASHtext] = ACTIONS(6546),
    [anon_sym_BSLASHintertext] = ACTIONS(6546),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6546),
    [anon_sym_BSLASHurl] = ACTIONS(6546),
    [anon_sym_BSLASHhref] = ACTIONS(6546),
  },
  [1083] = {
    [sym_command_name] = ACTIONS(6542),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6544),
    [anon_sym_RBRACK] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LPAREN] = ACTIONS(6544),
    [anon_sym_RPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHpart] = ACTIONS(6542),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddpart] = ACTIONS(6542),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHchapter] = ACTIONS(6542),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddchap] = ACTIONS(6542),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsection] = ACTIONS(6542),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddsec] = ACTIONS(6542),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHitem] = ACTIONS(6542),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6544),
    [anon_sym_LBRACE] = ACTIONS(6544),
    [sym_word] = ACTIONS(6542),
    [sym_placeholder] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_DASH] = ACTIONS(6544),
    [anon_sym_STAR] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6542),
    [anon_sym_GT] = ACTIONS(6542),
    [anon_sym_BANG] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6542),
    [anon_sym_COLON] = ACTIONS(6542),
    [anon_sym_SQUOTE] = ACTIONS(6542),
    [anon_sym__] = ACTIONS(6544),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6544),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6544),
    [anon_sym_DOLLAR] = ACTIONS(6542),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHbegin] = ACTIONS(6542),
    [anon_sym_BSLASHend] = ACTIONS(6542),
    [anon_sym_BSLASHtitle] = ACTIONS(6542),
    [anon_sym_BSLASHauthor] = ACTIONS(6542),
    [anon_sym_BSLASHusepackage] = ACTIONS(6542),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6542),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6542),
    [anon_sym_BSLASHinclude] = ACTIONS(6542),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6542),
    [anon_sym_BSLASHinput] = ACTIONS(6542),
    [anon_sym_BSLASHsubfile] = ACTIONS(6542),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6542),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6542),
    [anon_sym_BSLASHbibliography] = ACTIONS(6542),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6542),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6542),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6542),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6542),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6542),
    [anon_sym_BSLASHimport] = ACTIONS(6542),
    [anon_sym_BSLASHsubimport] = ACTIONS(6542),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6542),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHcaption] = ACTIONS(6542),
    [anon_sym_BSLASHcite] = ACTIONS(6542),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCite] = ACTIONS(6542),
    [anon_sym_BSLASHnocite] = ACTIONS(6542),
    [anon_sym_BSLASHcitet] = ACTIONS(6542),
    [anon_sym_BSLASHcitep] = ACTIONS(6542),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteA] = ACTIONS(6542),
    [anon_sym_BSLASHciteR] = ACTIONS(6542),
    [anon_sym_BSLASHciteS] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6542),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteyear] = ACTIONS(6542),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitedate] = ACTIONS(6542),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteurl] = ACTIONS(6542),
    [anon_sym_BSLASHfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6542),
    [anon_sym_BSLASHcitealt] = ACTIONS(6542),
    [anon_sym_BSLASHcitealp] = ACTIONS(6542),
    [anon_sym_BSLASHcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHparencite] = ACTIONS(6542),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHParencite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHtextcite] = ACTIONS(6542),
    [anon_sym_BSLASHTextcite] = ACTIONS(6542),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHsupercite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite] = ACTIONS(6542),
    [anon_sym_BSLASHAutocite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHVolcite] = ACTIONS(6542),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHavolcite] = ACTIONS(6542),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHNotecite] = ACTIONS(6542),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHlabel] = ACTIONS(6542),
    [anon_sym_BSLASHref] = ACTIONS(6542),
    [anon_sym_BSLASHeqref] = ACTIONS(6542),
    [anon_sym_BSLASHvref] = ACTIONS(6542),
    [anon_sym_BSLASHVref] = ACTIONS(6542),
    [anon_sym_BSLASHautoref] = ACTIONS(6542),
    [anon_sym_BSLASHpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcref] = ACTIONS(6542),
    [anon_sym_BSLASHCref] = ACTIONS(6542),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnameCref] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHdef] = ACTIONS(6542),
    [anon_sym_BSLASHlet] = ACTIONS(6542),
    [anon_sym_BSLASHleft] = ACTIONS(6542),
    [anon_sym_BSLASHbigl] = ACTIONS(6542),
    [anon_sym_BSLASHBigl] = ACTIONS(6542),
    [anon_sym_BSLASHbiggl] = ACTIONS(6542),
    [anon_sym_BSLASHBiggl] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6542),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6542),
    [anon_sym_BSLASHgls] = ACTIONS(6542),
    [anon_sym_BSLASHGls] = ACTIONS(6542),
    [anon_sym_BSLASHGLS] = ACTIONS(6542),
    [anon_sym_BSLASHglspl] = ACTIONS(6542),
    [anon_sym_BSLASHGlspl] = ACTIONS(6542),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6542),
    [anon_sym_BSLASHglslink] = ACTIONS(6542),
    [anon_sym_BSLASHglstext] = ACTIONS(6542),
    [anon_sym_BSLASHGlstext] = ACTIONS(6542),
    [anon_sym_BSLASHGLStext] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6542),
    [anon_sym_BSLASHglsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsname] = ACTIONS(6542),
    [anon_sym_BSLASHGlsname] = ACTIONS(6542),
    [anon_sym_BSLASHGLSname] = ACTIONS(6542),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6542),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6542),
    [anon_sym_BSLASHacrshort] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6542),
    [anon_sym_BSLASHACRshort] = ACTIONS(6542),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrlong] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6542),
    [anon_sym_BSLASHACRlong] = ACTIONS(6542),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrfull] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6542),
    [anon_sym_BSLASHACRfull] = ACTIONS(6542),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHacs] = ACTIONS(6542),
    [anon_sym_BSLASHAcs] = ACTIONS(6542),
    [anon_sym_BSLASHacsp] = ACTIONS(6542),
    [anon_sym_BSLASHAcsp] = ACTIONS(6542),
    [anon_sym_BSLASHacl] = ACTIONS(6542),
    [anon_sym_BSLASHAcl] = ACTIONS(6542),
    [anon_sym_BSLASHaclp] = ACTIONS(6542),
    [anon_sym_BSLASHAclp] = ACTIONS(6542),
    [anon_sym_BSLASHacf] = ACTIONS(6542),
    [anon_sym_BSLASHAcf] = ACTIONS(6542),
    [anon_sym_BSLASHacfp] = ACTIONS(6542),
    [anon_sym_BSLASHAcfp] = ACTIONS(6542),
    [anon_sym_BSLASHac] = ACTIONS(6542),
    [anon_sym_BSLASHAc] = ACTIONS(6542),
    [anon_sym_BSLASHacp] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6542),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6542),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6542),
    [anon_sym_BSLASHcolor] = ACTIONS(6542),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6542),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6542),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6542),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6542),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6542),
    [anon_sym_BSLASHtext] = ACTIONS(6542),
    [anon_sym_BSLASHintertext] = ACTIONS(6542),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6542),
    [anon_sym_BSLASHurl] = ACTIONS(6542),
    [anon_sym_BSLASHhref] = ACTIONS(6542),
  },
  [1084] = {
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHend] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [1085] = {
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHend] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [1086] = {
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_LBRACK] = ACTIONS(6524),
    [anon_sym_RBRACK] = ACTIONS(6524),
    [anon_sym_COMMA] = ACTIONS(6524),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6524),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHpart] = ACTIONS(6522),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddpart] = ACTIONS(6522),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHchapter] = ACTIONS(6522),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddchap] = ACTIONS(6522),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsection] = ACTIONS(6522),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddsec] = ACTIONS(6522),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHitem] = ACTIONS(6522),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6524),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6524),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6524),
    [anon_sym_DOLLAR] = ACTIONS(6522),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHbegin] = ACTIONS(6522),
    [anon_sym_BSLASHend] = ACTIONS(6522),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHleft] = ACTIONS(6522),
    [anon_sym_BSLASHbigl] = ACTIONS(6522),
    [anon_sym_BSLASHBigl] = ACTIONS(6522),
    [anon_sym_BSLASHbiggl] = ACTIONS(6522),
    [anon_sym_BSLASHBiggl] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHtext] = ACTIONS(6522),
    [anon_sym_BSLASHintertext] = ACTIONS(6522),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [1087] = {
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6528),
    [anon_sym_RBRACK] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6528),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [anon_sym_RPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHpart] = ACTIONS(6526),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddpart] = ACTIONS(6526),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHchapter] = ACTIONS(6526),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddchap] = ACTIONS(6526),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsection] = ACTIONS(6526),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddsec] = ACTIONS(6526),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHitem] = ACTIONS(6526),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6528),
    [anon_sym_LBRACE] = ACTIONS(6528),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6528),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(6526),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHbegin] = ACTIONS(6526),
    [anon_sym_BSLASHend] = ACTIONS(6526),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHleft] = ACTIONS(6526),
    [anon_sym_BSLASHbigl] = ACTIONS(6526),
    [anon_sym_BSLASHBigl] = ACTIONS(6526),
    [anon_sym_BSLASHbiggl] = ACTIONS(6526),
    [anon_sym_BSLASHBiggl] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHtext] = ACTIONS(6526),
    [anon_sym_BSLASHintertext] = ACTIONS(6526),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [1088] = {
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_RBRACK] = ACTIONS(6656),
    [anon_sym_COMMA] = ACTIONS(6656),
    [anon_sym_EQ] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(6656),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHpart] = ACTIONS(6654),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddpart] = ACTIONS(6654),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHchapter] = ACTIONS(6654),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddchap] = ACTIONS(6654),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsection] = ACTIONS(6654),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddsec] = ACTIONS(6654),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHitem] = ACTIONS(6654),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6656),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6656),
    [anon_sym_DOLLAR] = ACTIONS(6654),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHbegin] = ACTIONS(6654),
    [anon_sym_BSLASHend] = ACTIONS(6654),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHleft] = ACTIONS(6654),
    [anon_sym_BSLASHbigl] = ACTIONS(6654),
    [anon_sym_BSLASHBigl] = ACTIONS(6654),
    [anon_sym_BSLASHbiggl] = ACTIONS(6654),
    [anon_sym_BSLASHBiggl] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHtext] = ACTIONS(6654),
    [anon_sym_BSLASHintertext] = ACTIONS(6654),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [1089] = {
    [sym_command_name] = ACTIONS(6262),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6262),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_RBRACK] = ACTIONS(6264),
    [anon_sym_COMMA] = ACTIONS(6264),
    [anon_sym_EQ] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(6264),
    [anon_sym_RPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHpart] = ACTIONS(6262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddpart] = ACTIONS(6262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHchapter] = ACTIONS(6262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddchap] = ACTIONS(6262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsection] = ACTIONS(6262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddsec] = ACTIONS(6262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHitem] = ACTIONS(6262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6264),
    [anon_sym_LBRACE] = ACTIONS(6264),
    [sym_word] = ACTIONS(6262),
    [sym_placeholder] = ACTIONS(6264),
    [anon_sym_PLUS] = ACTIONS(6264),
    [anon_sym_DASH] = ACTIONS(6264),
    [anon_sym_STAR] = ACTIONS(6264),
    [anon_sym_SLASH] = ACTIONS(6264),
    [anon_sym_LT] = ACTIONS(6262),
    [anon_sym_GT] = ACTIONS(6262),
    [anon_sym_BANG] = ACTIONS(6262),
    [anon_sym_PIPE] = ACTIONS(6262),
    [anon_sym_COLON] = ACTIONS(6262),
    [anon_sym_SQUOTE] = ACTIONS(6262),
    [anon_sym__] = ACTIONS(6264),
    [anon_sym_CARET] = ACTIONS(6264),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6264),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6264),
    [anon_sym_DOLLAR] = ACTIONS(6262),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHbegin] = ACTIONS(6262),
    [anon_sym_BSLASHend] = ACTIONS(6262),
    [anon_sym_BSLASHtitle] = ACTIONS(6262),
    [anon_sym_BSLASHauthor] = ACTIONS(6262),
    [anon_sym_BSLASHusepackage] = ACTIONS(6262),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6262),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6262),
    [anon_sym_BSLASHinclude] = ACTIONS(6262),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6262),
    [anon_sym_BSLASHinput] = ACTIONS(6262),
    [anon_sym_BSLASHsubfile] = ACTIONS(6262),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6262),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6262),
    [anon_sym_BSLASHbibliography] = ACTIONS(6262),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6262),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6262),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6262),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6262),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6262),
    [anon_sym_BSLASHimport] = ACTIONS(6262),
    [anon_sym_BSLASHsubimport] = ACTIONS(6262),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6262),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHcaption] = ACTIONS(6262),
    [anon_sym_BSLASHcite] = ACTIONS(6262),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCite] = ACTIONS(6262),
    [anon_sym_BSLASHnocite] = ACTIONS(6262),
    [anon_sym_BSLASHcitet] = ACTIONS(6262),
    [anon_sym_BSLASHcitep] = ACTIONS(6262),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteA] = ACTIONS(6262),
    [anon_sym_BSLASHciteR] = ACTIONS(6262),
    [anon_sym_BSLASHciteS] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6262),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteyear] = ACTIONS(6262),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitedate] = ACTIONS(6262),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteurl] = ACTIONS(6262),
    [anon_sym_BSLASHfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6262),
    [anon_sym_BSLASHcitealt] = ACTIONS(6262),
    [anon_sym_BSLASHcitealp] = ACTIONS(6262),
    [anon_sym_BSLASHcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHparencite] = ACTIONS(6262),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHParencite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHtextcite] = ACTIONS(6262),
    [anon_sym_BSLASHTextcite] = ACTIONS(6262),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHsupercite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite] = ACTIONS(6262),
    [anon_sym_BSLASHAutocite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHVolcite] = ACTIONS(6262),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHavolcite] = ACTIONS(6262),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHNotecite] = ACTIONS(6262),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHlabel] = ACTIONS(6262),
    [anon_sym_BSLASHref] = ACTIONS(6262),
    [anon_sym_BSLASHeqref] = ACTIONS(6262),
    [anon_sym_BSLASHvref] = ACTIONS(6262),
    [anon_sym_BSLASHVref] = ACTIONS(6262),
    [anon_sym_BSLASHautoref] = ACTIONS(6262),
    [anon_sym_BSLASHpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcref] = ACTIONS(6262),
    [anon_sym_BSLASHCref] = ACTIONS(6262),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnameCref] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHdef] = ACTIONS(6262),
    [anon_sym_BSLASHlet] = ACTIONS(6262),
    [anon_sym_BSLASHleft] = ACTIONS(6262),
    [anon_sym_BSLASHbigl] = ACTIONS(6262),
    [anon_sym_BSLASHBigl] = ACTIONS(6262),
    [anon_sym_BSLASHbiggl] = ACTIONS(6262),
    [anon_sym_BSLASHBiggl] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6262),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6262),
    [anon_sym_BSLASHgls] = ACTIONS(6262),
    [anon_sym_BSLASHGls] = ACTIONS(6262),
    [anon_sym_BSLASHGLS] = ACTIONS(6262),
    [anon_sym_BSLASHglspl] = ACTIONS(6262),
    [anon_sym_BSLASHGlspl] = ACTIONS(6262),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6262),
    [anon_sym_BSLASHglslink] = ACTIONS(6262),
    [anon_sym_BSLASHglstext] = ACTIONS(6262),
    [anon_sym_BSLASHGlstext] = ACTIONS(6262),
    [anon_sym_BSLASHGLStext] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6262),
    [anon_sym_BSLASHglsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsname] = ACTIONS(6262),
    [anon_sym_BSLASHGlsname] = ACTIONS(6262),
    [anon_sym_BSLASHGLSname] = ACTIONS(6262),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6262),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6262),
    [anon_sym_BSLASHacrshort] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6262),
    [anon_sym_BSLASHACRshort] = ACTIONS(6262),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrlong] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6262),
    [anon_sym_BSLASHACRlong] = ACTIONS(6262),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrfull] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6262),
    [anon_sym_BSLASHACRfull] = ACTIONS(6262),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHacs] = ACTIONS(6262),
    [anon_sym_BSLASHAcs] = ACTIONS(6262),
    [anon_sym_BSLASHacsp] = ACTIONS(6262),
    [anon_sym_BSLASHAcsp] = ACTIONS(6262),
    [anon_sym_BSLASHacl] = ACTIONS(6262),
    [anon_sym_BSLASHAcl] = ACTIONS(6262),
    [anon_sym_BSLASHaclp] = ACTIONS(6262),
    [anon_sym_BSLASHAclp] = ACTIONS(6262),
    [anon_sym_BSLASHacf] = ACTIONS(6262),
    [anon_sym_BSLASHAcf] = ACTIONS(6262),
    [anon_sym_BSLASHacfp] = ACTIONS(6262),
    [anon_sym_BSLASHAcfp] = ACTIONS(6262),
    [anon_sym_BSLASHac] = ACTIONS(6262),
    [anon_sym_BSLASHAc] = ACTIONS(6262),
    [anon_sym_BSLASHacp] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6262),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6262),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6262),
    [anon_sym_BSLASHcolor] = ACTIONS(6262),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6262),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6262),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6262),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6262),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6262),
    [anon_sym_BSLASHtext] = ACTIONS(6262),
    [anon_sym_BSLASHintertext] = ACTIONS(6262),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6262),
    [anon_sym_BSLASHurl] = ACTIONS(6262),
    [anon_sym_BSLASHhref] = ACTIONS(6262),
  },
  [1090] = {
    [sym_command_name] = ACTIONS(6258),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6258),
    [anon_sym_LBRACK] = ACTIONS(6260),
    [anon_sym_RBRACK] = ACTIONS(6260),
    [anon_sym_COMMA] = ACTIONS(6260),
    [anon_sym_EQ] = ACTIONS(6260),
    [anon_sym_LPAREN] = ACTIONS(6260),
    [anon_sym_RPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHpart] = ACTIONS(6258),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddpart] = ACTIONS(6258),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHchapter] = ACTIONS(6258),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddchap] = ACTIONS(6258),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsection] = ACTIONS(6258),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddsec] = ACTIONS(6258),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHitem] = ACTIONS(6258),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6260),
    [anon_sym_LBRACE] = ACTIONS(6260),
    [sym_word] = ACTIONS(6258),
    [sym_placeholder] = ACTIONS(6260),
    [anon_sym_PLUS] = ACTIONS(6260),
    [anon_sym_DASH] = ACTIONS(6260),
    [anon_sym_STAR] = ACTIONS(6260),
    [anon_sym_SLASH] = ACTIONS(6260),
    [anon_sym_LT] = ACTIONS(6258),
    [anon_sym_GT] = ACTIONS(6258),
    [anon_sym_BANG] = ACTIONS(6258),
    [anon_sym_PIPE] = ACTIONS(6258),
    [anon_sym_COLON] = ACTIONS(6258),
    [anon_sym_SQUOTE] = ACTIONS(6258),
    [anon_sym__] = ACTIONS(6260),
    [anon_sym_CARET] = ACTIONS(6260),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6260),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6260),
    [anon_sym_DOLLAR] = ACTIONS(6258),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHbegin] = ACTIONS(6258),
    [anon_sym_BSLASHend] = ACTIONS(6258),
    [anon_sym_BSLASHtitle] = ACTIONS(6258),
    [anon_sym_BSLASHauthor] = ACTIONS(6258),
    [anon_sym_BSLASHusepackage] = ACTIONS(6258),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6258),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6258),
    [anon_sym_BSLASHinclude] = ACTIONS(6258),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6258),
    [anon_sym_BSLASHinput] = ACTIONS(6258),
    [anon_sym_BSLASHsubfile] = ACTIONS(6258),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6258),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6258),
    [anon_sym_BSLASHbibliography] = ACTIONS(6258),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6258),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6258),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6258),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6258),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6258),
    [anon_sym_BSLASHimport] = ACTIONS(6258),
    [anon_sym_BSLASHsubimport] = ACTIONS(6258),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6258),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHcaption] = ACTIONS(6258),
    [anon_sym_BSLASHcite] = ACTIONS(6258),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCite] = ACTIONS(6258),
    [anon_sym_BSLASHnocite] = ACTIONS(6258),
    [anon_sym_BSLASHcitet] = ACTIONS(6258),
    [anon_sym_BSLASHcitep] = ACTIONS(6258),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteA] = ACTIONS(6258),
    [anon_sym_BSLASHciteR] = ACTIONS(6258),
    [anon_sym_BSLASHciteS] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6258),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteyear] = ACTIONS(6258),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitedate] = ACTIONS(6258),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteurl] = ACTIONS(6258),
    [anon_sym_BSLASHfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6258),
    [anon_sym_BSLASHcitealt] = ACTIONS(6258),
    [anon_sym_BSLASHcitealp] = ACTIONS(6258),
    [anon_sym_BSLASHcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHparencite] = ACTIONS(6258),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHParencite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHtextcite] = ACTIONS(6258),
    [anon_sym_BSLASHTextcite] = ACTIONS(6258),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHsupercite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite] = ACTIONS(6258),
    [anon_sym_BSLASHAutocite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHVolcite] = ACTIONS(6258),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHavolcite] = ACTIONS(6258),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHNotecite] = ACTIONS(6258),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHlabel] = ACTIONS(6258),
    [anon_sym_BSLASHref] = ACTIONS(6258),
    [anon_sym_BSLASHeqref] = ACTIONS(6258),
    [anon_sym_BSLASHvref] = ACTIONS(6258),
    [anon_sym_BSLASHVref] = ACTIONS(6258),
    [anon_sym_BSLASHautoref] = ACTIONS(6258),
    [anon_sym_BSLASHpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcref] = ACTIONS(6258),
    [anon_sym_BSLASHCref] = ACTIONS(6258),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnameCref] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHdef] = ACTIONS(6258),
    [anon_sym_BSLASHlet] = ACTIONS(6258),
    [anon_sym_BSLASHleft] = ACTIONS(6258),
    [anon_sym_BSLASHbigl] = ACTIONS(6258),
    [anon_sym_BSLASHBigl] = ACTIONS(6258),
    [anon_sym_BSLASHbiggl] = ACTIONS(6258),
    [anon_sym_BSLASHBiggl] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6258),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6258),
    [anon_sym_BSLASHgls] = ACTIONS(6258),
    [anon_sym_BSLASHGls] = ACTIONS(6258),
    [anon_sym_BSLASHGLS] = ACTIONS(6258),
    [anon_sym_BSLASHglspl] = ACTIONS(6258),
    [anon_sym_BSLASHGlspl] = ACTIONS(6258),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6258),
    [anon_sym_BSLASHglslink] = ACTIONS(6258),
    [anon_sym_BSLASHglstext] = ACTIONS(6258),
    [anon_sym_BSLASHGlstext] = ACTIONS(6258),
    [anon_sym_BSLASHGLStext] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6258),
    [anon_sym_BSLASHglsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsname] = ACTIONS(6258),
    [anon_sym_BSLASHGlsname] = ACTIONS(6258),
    [anon_sym_BSLASHGLSname] = ACTIONS(6258),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6258),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6258),
    [anon_sym_BSLASHacrshort] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6258),
    [anon_sym_BSLASHACRshort] = ACTIONS(6258),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrlong] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6258),
    [anon_sym_BSLASHACRlong] = ACTIONS(6258),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrfull] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6258),
    [anon_sym_BSLASHACRfull] = ACTIONS(6258),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHacs] = ACTIONS(6258),
    [anon_sym_BSLASHAcs] = ACTIONS(6258),
    [anon_sym_BSLASHacsp] = ACTIONS(6258),
    [anon_sym_BSLASHAcsp] = ACTIONS(6258),
    [anon_sym_BSLASHacl] = ACTIONS(6258),
    [anon_sym_BSLASHAcl] = ACTIONS(6258),
    [anon_sym_BSLASHaclp] = ACTIONS(6258),
    [anon_sym_BSLASHAclp] = ACTIONS(6258),
    [anon_sym_BSLASHacf] = ACTIONS(6258),
    [anon_sym_BSLASHAcf] = ACTIONS(6258),
    [anon_sym_BSLASHacfp] = ACTIONS(6258),
    [anon_sym_BSLASHAcfp] = ACTIONS(6258),
    [anon_sym_BSLASHac] = ACTIONS(6258),
    [anon_sym_BSLASHAc] = ACTIONS(6258),
    [anon_sym_BSLASHacp] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6258),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6258),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6258),
    [anon_sym_BSLASHcolor] = ACTIONS(6258),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6258),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6258),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6258),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6258),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6258),
    [anon_sym_BSLASHtext] = ACTIONS(6258),
    [anon_sym_BSLASHintertext] = ACTIONS(6258),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6258),
    [anon_sym_BSLASHurl] = ACTIONS(6258),
    [anon_sym_BSLASHhref] = ACTIONS(6258),
  },
  [1091] = {
    [sym_command_name] = ACTIONS(6254),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6254),
    [anon_sym_LBRACK] = ACTIONS(6256),
    [anon_sym_RBRACK] = ACTIONS(6256),
    [anon_sym_COMMA] = ACTIONS(6256),
    [anon_sym_EQ] = ACTIONS(6256),
    [anon_sym_LPAREN] = ACTIONS(6256),
    [anon_sym_RPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHpart] = ACTIONS(6254),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddpart] = ACTIONS(6254),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHchapter] = ACTIONS(6254),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddchap] = ACTIONS(6254),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsection] = ACTIONS(6254),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddsec] = ACTIONS(6254),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHitem] = ACTIONS(6254),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6256),
    [anon_sym_LBRACE] = ACTIONS(6256),
    [sym_word] = ACTIONS(6254),
    [sym_placeholder] = ACTIONS(6256),
    [anon_sym_PLUS] = ACTIONS(6256),
    [anon_sym_DASH] = ACTIONS(6256),
    [anon_sym_STAR] = ACTIONS(6256),
    [anon_sym_SLASH] = ACTIONS(6256),
    [anon_sym_LT] = ACTIONS(6254),
    [anon_sym_GT] = ACTIONS(6254),
    [anon_sym_BANG] = ACTIONS(6254),
    [anon_sym_PIPE] = ACTIONS(6254),
    [anon_sym_COLON] = ACTIONS(6254),
    [anon_sym_SQUOTE] = ACTIONS(6254),
    [anon_sym__] = ACTIONS(6256),
    [anon_sym_CARET] = ACTIONS(6256),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6256),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6256),
    [anon_sym_DOLLAR] = ACTIONS(6254),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHbegin] = ACTIONS(6254),
    [anon_sym_BSLASHend] = ACTIONS(6254),
    [anon_sym_BSLASHtitle] = ACTIONS(6254),
    [anon_sym_BSLASHauthor] = ACTIONS(6254),
    [anon_sym_BSLASHusepackage] = ACTIONS(6254),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6254),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6254),
    [anon_sym_BSLASHinclude] = ACTIONS(6254),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6254),
    [anon_sym_BSLASHinput] = ACTIONS(6254),
    [anon_sym_BSLASHsubfile] = ACTIONS(6254),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6254),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6254),
    [anon_sym_BSLASHbibliography] = ACTIONS(6254),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6254),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6254),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6254),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6254),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6254),
    [anon_sym_BSLASHimport] = ACTIONS(6254),
    [anon_sym_BSLASHsubimport] = ACTIONS(6254),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6254),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHcaption] = ACTIONS(6254),
    [anon_sym_BSLASHcite] = ACTIONS(6254),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCite] = ACTIONS(6254),
    [anon_sym_BSLASHnocite] = ACTIONS(6254),
    [anon_sym_BSLASHcitet] = ACTIONS(6254),
    [anon_sym_BSLASHcitep] = ACTIONS(6254),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteA] = ACTIONS(6254),
    [anon_sym_BSLASHciteR] = ACTIONS(6254),
    [anon_sym_BSLASHciteS] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6254),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteyear] = ACTIONS(6254),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitedate] = ACTIONS(6254),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteurl] = ACTIONS(6254),
    [anon_sym_BSLASHfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6254),
    [anon_sym_BSLASHcitealt] = ACTIONS(6254),
    [anon_sym_BSLASHcitealp] = ACTIONS(6254),
    [anon_sym_BSLASHcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHparencite] = ACTIONS(6254),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHParencite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHtextcite] = ACTIONS(6254),
    [anon_sym_BSLASHTextcite] = ACTIONS(6254),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHsupercite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite] = ACTIONS(6254),
    [anon_sym_BSLASHAutocite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHVolcite] = ACTIONS(6254),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHavolcite] = ACTIONS(6254),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHNotecite] = ACTIONS(6254),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHlabel] = ACTIONS(6254),
    [anon_sym_BSLASHref] = ACTIONS(6254),
    [anon_sym_BSLASHeqref] = ACTIONS(6254),
    [anon_sym_BSLASHvref] = ACTIONS(6254),
    [anon_sym_BSLASHVref] = ACTIONS(6254),
    [anon_sym_BSLASHautoref] = ACTIONS(6254),
    [anon_sym_BSLASHpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcref] = ACTIONS(6254),
    [anon_sym_BSLASHCref] = ACTIONS(6254),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnameCref] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHdef] = ACTIONS(6254),
    [anon_sym_BSLASHlet] = ACTIONS(6254),
    [anon_sym_BSLASHleft] = ACTIONS(6254),
    [anon_sym_BSLASHbigl] = ACTIONS(6254),
    [anon_sym_BSLASHBigl] = ACTIONS(6254),
    [anon_sym_BSLASHbiggl] = ACTIONS(6254),
    [anon_sym_BSLASHBiggl] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6254),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6254),
    [anon_sym_BSLASHgls] = ACTIONS(6254),
    [anon_sym_BSLASHGls] = ACTIONS(6254),
    [anon_sym_BSLASHGLS] = ACTIONS(6254),
    [anon_sym_BSLASHglspl] = ACTIONS(6254),
    [anon_sym_BSLASHGlspl] = ACTIONS(6254),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6254),
    [anon_sym_BSLASHglslink] = ACTIONS(6254),
    [anon_sym_BSLASHglstext] = ACTIONS(6254),
    [anon_sym_BSLASHGlstext] = ACTIONS(6254),
    [anon_sym_BSLASHGLStext] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6254),
    [anon_sym_BSLASHglsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsname] = ACTIONS(6254),
    [anon_sym_BSLASHGlsname] = ACTIONS(6254),
    [anon_sym_BSLASHGLSname] = ACTIONS(6254),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6254),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6254),
    [anon_sym_BSLASHacrshort] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6254),
    [anon_sym_BSLASHACRshort] = ACTIONS(6254),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrlong] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6254),
    [anon_sym_BSLASHACRlong] = ACTIONS(6254),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrfull] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6254),
    [anon_sym_BSLASHACRfull] = ACTIONS(6254),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHacs] = ACTIONS(6254),
    [anon_sym_BSLASHAcs] = ACTIONS(6254),
    [anon_sym_BSLASHacsp] = ACTIONS(6254),
    [anon_sym_BSLASHAcsp] = ACTIONS(6254),
    [anon_sym_BSLASHacl] = ACTIONS(6254),
    [anon_sym_BSLASHAcl] = ACTIONS(6254),
    [anon_sym_BSLASHaclp] = ACTIONS(6254),
    [anon_sym_BSLASHAclp] = ACTIONS(6254),
    [anon_sym_BSLASHacf] = ACTIONS(6254),
    [anon_sym_BSLASHAcf] = ACTIONS(6254),
    [anon_sym_BSLASHacfp] = ACTIONS(6254),
    [anon_sym_BSLASHAcfp] = ACTIONS(6254),
    [anon_sym_BSLASHac] = ACTIONS(6254),
    [anon_sym_BSLASHAc] = ACTIONS(6254),
    [anon_sym_BSLASHacp] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6254),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6254),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6254),
    [anon_sym_BSLASHcolor] = ACTIONS(6254),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6254),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6254),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6254),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6254),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6254),
    [anon_sym_BSLASHtext] = ACTIONS(6254),
    [anon_sym_BSLASHintertext] = ACTIONS(6254),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6254),
    [anon_sym_BSLASHurl] = ACTIONS(6254),
    [anon_sym_BSLASHhref] = ACTIONS(6254),
  },
  [1092] = {
    [sym_command_name] = ACTIONS(6210),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_EQ] = ACTIONS(6212),
    [anon_sym_LPAREN] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHpart] = ACTIONS(6210),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddpart] = ACTIONS(6210),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHchapter] = ACTIONS(6210),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddchap] = ACTIONS(6210),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsection] = ACTIONS(6210),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddsec] = ACTIONS(6210),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHitem] = ACTIONS(6210),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [sym_word] = ACTIONS(6210),
    [sym_placeholder] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_DASH] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_LT] = ACTIONS(6210),
    [anon_sym_GT] = ACTIONS(6210),
    [anon_sym_BANG] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_COLON] = ACTIONS(6210),
    [anon_sym_SQUOTE] = ACTIONS(6210),
    [anon_sym__] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6212),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6212),
    [anon_sym_DOLLAR] = ACTIONS(6210),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHbegin] = ACTIONS(6210),
    [anon_sym_BSLASHend] = ACTIONS(6210),
    [anon_sym_BSLASHtitle] = ACTIONS(6210),
    [anon_sym_BSLASHauthor] = ACTIONS(6210),
    [anon_sym_BSLASHusepackage] = ACTIONS(6210),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6210),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6210),
    [anon_sym_BSLASHinclude] = ACTIONS(6210),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6210),
    [anon_sym_BSLASHinput] = ACTIONS(6210),
    [anon_sym_BSLASHsubfile] = ACTIONS(6210),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6210),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6210),
    [anon_sym_BSLASHbibliography] = ACTIONS(6210),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6210),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6210),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6210),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6210),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6210),
    [anon_sym_BSLASHimport] = ACTIONS(6210),
    [anon_sym_BSLASHsubimport] = ACTIONS(6210),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6210),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHcaption] = ACTIONS(6210),
    [anon_sym_BSLASHcite] = ACTIONS(6210),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCite] = ACTIONS(6210),
    [anon_sym_BSLASHnocite] = ACTIONS(6210),
    [anon_sym_BSLASHcitet] = ACTIONS(6210),
    [anon_sym_BSLASHcitep] = ACTIONS(6210),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteA] = ACTIONS(6210),
    [anon_sym_BSLASHciteR] = ACTIONS(6210),
    [anon_sym_BSLASHciteS] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6210),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteyear] = ACTIONS(6210),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitedate] = ACTIONS(6210),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteurl] = ACTIONS(6210),
    [anon_sym_BSLASHfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6210),
    [anon_sym_BSLASHcitealt] = ACTIONS(6210),
    [anon_sym_BSLASHcitealp] = ACTIONS(6210),
    [anon_sym_BSLASHcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHparencite] = ACTIONS(6210),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHParencite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHtextcite] = ACTIONS(6210),
    [anon_sym_BSLASHTextcite] = ACTIONS(6210),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHsupercite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite] = ACTIONS(6210),
    [anon_sym_BSLASHAutocite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHVolcite] = ACTIONS(6210),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHavolcite] = ACTIONS(6210),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHNotecite] = ACTIONS(6210),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHlabel] = ACTIONS(6210),
    [anon_sym_BSLASHref] = ACTIONS(6210),
    [anon_sym_BSLASHeqref] = ACTIONS(6210),
    [anon_sym_BSLASHvref] = ACTIONS(6210),
    [anon_sym_BSLASHVref] = ACTIONS(6210),
    [anon_sym_BSLASHautoref] = ACTIONS(6210),
    [anon_sym_BSLASHpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcref] = ACTIONS(6210),
    [anon_sym_BSLASHCref] = ACTIONS(6210),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnameCref] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHdef] = ACTIONS(6210),
    [anon_sym_BSLASHlet] = ACTIONS(6210),
    [anon_sym_BSLASHleft] = ACTIONS(6210),
    [anon_sym_BSLASHbigl] = ACTIONS(6210),
    [anon_sym_BSLASHBigl] = ACTIONS(6210),
    [anon_sym_BSLASHbiggl] = ACTIONS(6210),
    [anon_sym_BSLASHBiggl] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6210),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6210),
    [anon_sym_BSLASHgls] = ACTIONS(6210),
    [anon_sym_BSLASHGls] = ACTIONS(6210),
    [anon_sym_BSLASHGLS] = ACTIONS(6210),
    [anon_sym_BSLASHglspl] = ACTIONS(6210),
    [anon_sym_BSLASHGlspl] = ACTIONS(6210),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6210),
    [anon_sym_BSLASHglslink] = ACTIONS(6210),
    [anon_sym_BSLASHglstext] = ACTIONS(6210),
    [anon_sym_BSLASHGlstext] = ACTIONS(6210),
    [anon_sym_BSLASHGLStext] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6210),
    [anon_sym_BSLASHglsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsname] = ACTIONS(6210),
    [anon_sym_BSLASHGlsname] = ACTIONS(6210),
    [anon_sym_BSLASHGLSname] = ACTIONS(6210),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6210),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6210),
    [anon_sym_BSLASHacrshort] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6210),
    [anon_sym_BSLASHACRshort] = ACTIONS(6210),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrlong] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6210),
    [anon_sym_BSLASHACRlong] = ACTIONS(6210),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrfull] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6210),
    [anon_sym_BSLASHACRfull] = ACTIONS(6210),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHacs] = ACTIONS(6210),
    [anon_sym_BSLASHAcs] = ACTIONS(6210),
    [anon_sym_BSLASHacsp] = ACTIONS(6210),
    [anon_sym_BSLASHAcsp] = ACTIONS(6210),
    [anon_sym_BSLASHacl] = ACTIONS(6210),
    [anon_sym_BSLASHAcl] = ACTIONS(6210),
    [anon_sym_BSLASHaclp] = ACTIONS(6210),
    [anon_sym_BSLASHAclp] = ACTIONS(6210),
    [anon_sym_BSLASHacf] = ACTIONS(6210),
    [anon_sym_BSLASHAcf] = ACTIONS(6210),
    [anon_sym_BSLASHacfp] = ACTIONS(6210),
    [anon_sym_BSLASHAcfp] = ACTIONS(6210),
    [anon_sym_BSLASHac] = ACTIONS(6210),
    [anon_sym_BSLASHAc] = ACTIONS(6210),
    [anon_sym_BSLASHacp] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6210),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6210),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6210),
    [anon_sym_BSLASHcolor] = ACTIONS(6210),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6210),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6210),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6210),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6210),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6210),
    [anon_sym_BSLASHtext] = ACTIONS(6210),
    [anon_sym_BSLASHintertext] = ACTIONS(6210),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6210),
    [anon_sym_BSLASHurl] = ACTIONS(6210),
    [anon_sym_BSLASHhref] = ACTIONS(6210),
  },
  [1093] = {
    [sym_command_name] = ACTIONS(6206),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [anon_sym_RBRACK] = ACTIONS(6208),
    [anon_sym_COMMA] = ACTIONS(6208),
    [anon_sym_EQ] = ACTIONS(6208),
    [anon_sym_LPAREN] = ACTIONS(6208),
    [anon_sym_RPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHpart] = ACTIONS(6206),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddpart] = ACTIONS(6206),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHchapter] = ACTIONS(6206),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddchap] = ACTIONS(6206),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsection] = ACTIONS(6206),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddsec] = ACTIONS(6206),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHitem] = ACTIONS(6206),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6208),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [sym_word] = ACTIONS(6206),
    [sym_placeholder] = ACTIONS(6208),
    [anon_sym_PLUS] = ACTIONS(6208),
    [anon_sym_DASH] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_SLASH] = ACTIONS(6208),
    [anon_sym_LT] = ACTIONS(6206),
    [anon_sym_GT] = ACTIONS(6206),
    [anon_sym_BANG] = ACTIONS(6206),
    [anon_sym_PIPE] = ACTIONS(6206),
    [anon_sym_COLON] = ACTIONS(6206),
    [anon_sym_SQUOTE] = ACTIONS(6206),
    [anon_sym__] = ACTIONS(6208),
    [anon_sym_CARET] = ACTIONS(6208),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6208),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6208),
    [anon_sym_DOLLAR] = ACTIONS(6206),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHbegin] = ACTIONS(6206),
    [anon_sym_BSLASHend] = ACTIONS(6206),
    [anon_sym_BSLASHtitle] = ACTIONS(6206),
    [anon_sym_BSLASHauthor] = ACTIONS(6206),
    [anon_sym_BSLASHusepackage] = ACTIONS(6206),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6206),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6206),
    [anon_sym_BSLASHinclude] = ACTIONS(6206),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6206),
    [anon_sym_BSLASHinput] = ACTIONS(6206),
    [anon_sym_BSLASHsubfile] = ACTIONS(6206),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6206),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6206),
    [anon_sym_BSLASHbibliography] = ACTIONS(6206),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6206),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6206),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6206),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6206),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6206),
    [anon_sym_BSLASHimport] = ACTIONS(6206),
    [anon_sym_BSLASHsubimport] = ACTIONS(6206),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6206),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHcaption] = ACTIONS(6206),
    [anon_sym_BSLASHcite] = ACTIONS(6206),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCite] = ACTIONS(6206),
    [anon_sym_BSLASHnocite] = ACTIONS(6206),
    [anon_sym_BSLASHcitet] = ACTIONS(6206),
    [anon_sym_BSLASHcitep] = ACTIONS(6206),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteA] = ACTIONS(6206),
    [anon_sym_BSLASHciteR] = ACTIONS(6206),
    [anon_sym_BSLASHciteS] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6206),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteyear] = ACTIONS(6206),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitedate] = ACTIONS(6206),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteurl] = ACTIONS(6206),
    [anon_sym_BSLASHfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6206),
    [anon_sym_BSLASHcitealt] = ACTIONS(6206),
    [anon_sym_BSLASHcitealp] = ACTIONS(6206),
    [anon_sym_BSLASHcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHparencite] = ACTIONS(6206),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHParencite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHtextcite] = ACTIONS(6206),
    [anon_sym_BSLASHTextcite] = ACTIONS(6206),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHsupercite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite] = ACTIONS(6206),
    [anon_sym_BSLASHAutocite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHVolcite] = ACTIONS(6206),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHavolcite] = ACTIONS(6206),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHNotecite] = ACTIONS(6206),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHlabel] = ACTIONS(6206),
    [anon_sym_BSLASHref] = ACTIONS(6206),
    [anon_sym_BSLASHeqref] = ACTIONS(6206),
    [anon_sym_BSLASHvref] = ACTIONS(6206),
    [anon_sym_BSLASHVref] = ACTIONS(6206),
    [anon_sym_BSLASHautoref] = ACTIONS(6206),
    [anon_sym_BSLASHpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcref] = ACTIONS(6206),
    [anon_sym_BSLASHCref] = ACTIONS(6206),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnameCref] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHdef] = ACTIONS(6206),
    [anon_sym_BSLASHlet] = ACTIONS(6206),
    [anon_sym_BSLASHleft] = ACTIONS(6206),
    [anon_sym_BSLASHbigl] = ACTIONS(6206),
    [anon_sym_BSLASHBigl] = ACTIONS(6206),
    [anon_sym_BSLASHbiggl] = ACTIONS(6206),
    [anon_sym_BSLASHBiggl] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6206),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6206),
    [anon_sym_BSLASHgls] = ACTIONS(6206),
    [anon_sym_BSLASHGls] = ACTIONS(6206),
    [anon_sym_BSLASHGLS] = ACTIONS(6206),
    [anon_sym_BSLASHglspl] = ACTIONS(6206),
    [anon_sym_BSLASHGlspl] = ACTIONS(6206),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6206),
    [anon_sym_BSLASHglslink] = ACTIONS(6206),
    [anon_sym_BSLASHglstext] = ACTIONS(6206),
    [anon_sym_BSLASHGlstext] = ACTIONS(6206),
    [anon_sym_BSLASHGLStext] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6206),
    [anon_sym_BSLASHglsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsname] = ACTIONS(6206),
    [anon_sym_BSLASHGlsname] = ACTIONS(6206),
    [anon_sym_BSLASHGLSname] = ACTIONS(6206),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6206),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6206),
    [anon_sym_BSLASHacrshort] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6206),
    [anon_sym_BSLASHACRshort] = ACTIONS(6206),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrlong] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6206),
    [anon_sym_BSLASHACRlong] = ACTIONS(6206),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrfull] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6206),
    [anon_sym_BSLASHACRfull] = ACTIONS(6206),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHacs] = ACTIONS(6206),
    [anon_sym_BSLASHAcs] = ACTIONS(6206),
    [anon_sym_BSLASHacsp] = ACTIONS(6206),
    [anon_sym_BSLASHAcsp] = ACTIONS(6206),
    [anon_sym_BSLASHacl] = ACTIONS(6206),
    [anon_sym_BSLASHAcl] = ACTIONS(6206),
    [anon_sym_BSLASHaclp] = ACTIONS(6206),
    [anon_sym_BSLASHAclp] = ACTIONS(6206),
    [anon_sym_BSLASHacf] = ACTIONS(6206),
    [anon_sym_BSLASHAcf] = ACTIONS(6206),
    [anon_sym_BSLASHacfp] = ACTIONS(6206),
    [anon_sym_BSLASHAcfp] = ACTIONS(6206),
    [anon_sym_BSLASHac] = ACTIONS(6206),
    [anon_sym_BSLASHAc] = ACTIONS(6206),
    [anon_sym_BSLASHacp] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6206),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6206),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6206),
    [anon_sym_BSLASHcolor] = ACTIONS(6206),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6206),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6206),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6206),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6206),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6206),
    [anon_sym_BSLASHtext] = ACTIONS(6206),
    [anon_sym_BSLASHintertext] = ACTIONS(6206),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6206),
    [anon_sym_BSLASHurl] = ACTIONS(6206),
    [anon_sym_BSLASHhref] = ACTIONS(6206),
  },
  [1094] = {
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [anon_sym_RPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHpart] = ACTIONS(6346),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddpart] = ACTIONS(6346),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHchapter] = ACTIONS(6346),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddchap] = ACTIONS(6346),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsection] = ACTIONS(6346),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddsec] = ACTIONS(6346),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHitem] = ACTIONS(6346),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6348),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6348),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6348),
    [anon_sym_DOLLAR] = ACTIONS(6346),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHbegin] = ACTIONS(6346),
    [anon_sym_BSLASHend] = ACTIONS(6346),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHleft] = ACTIONS(6346),
    [anon_sym_BSLASHbigl] = ACTIONS(6346),
    [anon_sym_BSLASHBigl] = ACTIONS(6346),
    [anon_sym_BSLASHbiggl] = ACTIONS(6346),
    [anon_sym_BSLASHBiggl] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHtext] = ACTIONS(6346),
    [anon_sym_BSLASHintertext] = ACTIONS(6346),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [1095] = {
    [sym_command_name] = ACTIONS(6294),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6294),
    [anon_sym_LBRACK] = ACTIONS(6296),
    [anon_sym_RBRACK] = ACTIONS(6296),
    [anon_sym_COMMA] = ACTIONS(6296),
    [anon_sym_EQ] = ACTIONS(6296),
    [anon_sym_LPAREN] = ACTIONS(6296),
    [anon_sym_RPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHpart] = ACTIONS(6294),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddpart] = ACTIONS(6294),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHchapter] = ACTIONS(6294),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddchap] = ACTIONS(6294),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsection] = ACTIONS(6294),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddsec] = ACTIONS(6294),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHitem] = ACTIONS(6294),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6296),
    [anon_sym_LBRACE] = ACTIONS(6296),
    [sym_word] = ACTIONS(6294),
    [sym_placeholder] = ACTIONS(6296),
    [anon_sym_PLUS] = ACTIONS(6296),
    [anon_sym_DASH] = ACTIONS(6296),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_SLASH] = ACTIONS(6296),
    [anon_sym_LT] = ACTIONS(6294),
    [anon_sym_GT] = ACTIONS(6294),
    [anon_sym_BANG] = ACTIONS(6294),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COLON] = ACTIONS(6294),
    [anon_sym_SQUOTE] = ACTIONS(6294),
    [anon_sym__] = ACTIONS(6296),
    [anon_sym_CARET] = ACTIONS(6296),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6296),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6296),
    [anon_sym_DOLLAR] = ACTIONS(6294),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHbegin] = ACTIONS(6294),
    [anon_sym_BSLASHend] = ACTIONS(6294),
    [anon_sym_BSLASHtitle] = ACTIONS(6294),
    [anon_sym_BSLASHauthor] = ACTIONS(6294),
    [anon_sym_BSLASHusepackage] = ACTIONS(6294),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6294),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6294),
    [anon_sym_BSLASHinclude] = ACTIONS(6294),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6294),
    [anon_sym_BSLASHinput] = ACTIONS(6294),
    [anon_sym_BSLASHsubfile] = ACTIONS(6294),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6294),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6294),
    [anon_sym_BSLASHbibliography] = ACTIONS(6294),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6294),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6294),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6294),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6294),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6294),
    [anon_sym_BSLASHimport] = ACTIONS(6294),
    [anon_sym_BSLASHsubimport] = ACTIONS(6294),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6294),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHcaption] = ACTIONS(6294),
    [anon_sym_BSLASHcite] = ACTIONS(6294),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCite] = ACTIONS(6294),
    [anon_sym_BSLASHnocite] = ACTIONS(6294),
    [anon_sym_BSLASHcitet] = ACTIONS(6294),
    [anon_sym_BSLASHcitep] = ACTIONS(6294),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteA] = ACTIONS(6294),
    [anon_sym_BSLASHciteR] = ACTIONS(6294),
    [anon_sym_BSLASHciteS] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6294),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteyear] = ACTIONS(6294),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitedate] = ACTIONS(6294),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteurl] = ACTIONS(6294),
    [anon_sym_BSLASHfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6294),
    [anon_sym_BSLASHcitealt] = ACTIONS(6294),
    [anon_sym_BSLASHcitealp] = ACTIONS(6294),
    [anon_sym_BSLASHcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHparencite] = ACTIONS(6294),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHParencite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHtextcite] = ACTIONS(6294),
    [anon_sym_BSLASHTextcite] = ACTIONS(6294),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHsupercite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite] = ACTIONS(6294),
    [anon_sym_BSLASHAutocite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHVolcite] = ACTIONS(6294),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHavolcite] = ACTIONS(6294),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHNotecite] = ACTIONS(6294),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHlabel] = ACTIONS(6294),
    [anon_sym_BSLASHref] = ACTIONS(6294),
    [anon_sym_BSLASHeqref] = ACTIONS(6294),
    [anon_sym_BSLASHvref] = ACTIONS(6294),
    [anon_sym_BSLASHVref] = ACTIONS(6294),
    [anon_sym_BSLASHautoref] = ACTIONS(6294),
    [anon_sym_BSLASHpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcref] = ACTIONS(6294),
    [anon_sym_BSLASHCref] = ACTIONS(6294),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnameCref] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHdef] = ACTIONS(6294),
    [anon_sym_BSLASHlet] = ACTIONS(6294),
    [anon_sym_BSLASHleft] = ACTIONS(6294),
    [anon_sym_BSLASHbigl] = ACTIONS(6294),
    [anon_sym_BSLASHBigl] = ACTIONS(6294),
    [anon_sym_BSLASHbiggl] = ACTIONS(6294),
    [anon_sym_BSLASHBiggl] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6294),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6294),
    [anon_sym_BSLASHgls] = ACTIONS(6294),
    [anon_sym_BSLASHGls] = ACTIONS(6294),
    [anon_sym_BSLASHGLS] = ACTIONS(6294),
    [anon_sym_BSLASHglspl] = ACTIONS(6294),
    [anon_sym_BSLASHGlspl] = ACTIONS(6294),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6294),
    [anon_sym_BSLASHglslink] = ACTIONS(6294),
    [anon_sym_BSLASHglstext] = ACTIONS(6294),
    [anon_sym_BSLASHGlstext] = ACTIONS(6294),
    [anon_sym_BSLASHGLStext] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6294),
    [anon_sym_BSLASHglsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsname] = ACTIONS(6294),
    [anon_sym_BSLASHGlsname] = ACTIONS(6294),
    [anon_sym_BSLASHGLSname] = ACTIONS(6294),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6294),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6294),
    [anon_sym_BSLASHacrshort] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6294),
    [anon_sym_BSLASHACRshort] = ACTIONS(6294),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrlong] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6294),
    [anon_sym_BSLASHACRlong] = ACTIONS(6294),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrfull] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6294),
    [anon_sym_BSLASHACRfull] = ACTIONS(6294),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHacs] = ACTIONS(6294),
    [anon_sym_BSLASHAcs] = ACTIONS(6294),
    [anon_sym_BSLASHacsp] = ACTIONS(6294),
    [anon_sym_BSLASHAcsp] = ACTIONS(6294),
    [anon_sym_BSLASHacl] = ACTIONS(6294),
    [anon_sym_BSLASHAcl] = ACTIONS(6294),
    [anon_sym_BSLASHaclp] = ACTIONS(6294),
    [anon_sym_BSLASHAclp] = ACTIONS(6294),
    [anon_sym_BSLASHacf] = ACTIONS(6294),
    [anon_sym_BSLASHAcf] = ACTIONS(6294),
    [anon_sym_BSLASHacfp] = ACTIONS(6294),
    [anon_sym_BSLASHAcfp] = ACTIONS(6294),
    [anon_sym_BSLASHac] = ACTIONS(6294),
    [anon_sym_BSLASHAc] = ACTIONS(6294),
    [anon_sym_BSLASHacp] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6294),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6294),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6294),
    [anon_sym_BSLASHcolor] = ACTIONS(6294),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6294),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6294),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6294),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6294),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6294),
    [anon_sym_BSLASHtext] = ACTIONS(6294),
    [anon_sym_BSLASHintertext] = ACTIONS(6294),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6294),
    [anon_sym_BSLASHurl] = ACTIONS(6294),
    [anon_sym_BSLASHhref] = ACTIONS(6294),
  },
  [1096] = {
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_RBRACK] = ACTIONS(6636),
    [anon_sym_COMMA] = ACTIONS(6636),
    [anon_sym_EQ] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(6636),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHpart] = ACTIONS(6634),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddpart] = ACTIONS(6634),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHchapter] = ACTIONS(6634),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddchap] = ACTIONS(6634),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsection] = ACTIONS(6634),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddsec] = ACTIONS(6634),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHitem] = ACTIONS(6634),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6636),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(6634),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHbegin] = ACTIONS(6634),
    [anon_sym_BSLASHend] = ACTIONS(6634),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHleft] = ACTIONS(6634),
    [anon_sym_BSLASHbigl] = ACTIONS(6634),
    [anon_sym_BSLASHBigl] = ACTIONS(6634),
    [anon_sym_BSLASHbiggl] = ACTIONS(6634),
    [anon_sym_BSLASHBiggl] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHtext] = ACTIONS(6634),
    [anon_sym_BSLASHintertext] = ACTIONS(6634),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [1097] = {
    [sym_command_name] = ACTIONS(6202),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6202),
    [anon_sym_LBRACK] = ACTIONS(6204),
    [anon_sym_RBRACK] = ACTIONS(6204),
    [anon_sym_COMMA] = ACTIONS(6204),
    [anon_sym_EQ] = ACTIONS(6204),
    [anon_sym_LPAREN] = ACTIONS(6204),
    [anon_sym_RPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHpart] = ACTIONS(6202),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddpart] = ACTIONS(6202),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHchapter] = ACTIONS(6202),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddchap] = ACTIONS(6202),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsection] = ACTIONS(6202),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddsec] = ACTIONS(6202),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHitem] = ACTIONS(6202),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6204),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [sym_word] = ACTIONS(6202),
    [sym_placeholder] = ACTIONS(6204),
    [anon_sym_PLUS] = ACTIONS(6204),
    [anon_sym_DASH] = ACTIONS(6204),
    [anon_sym_STAR] = ACTIONS(6204),
    [anon_sym_SLASH] = ACTIONS(6204),
    [anon_sym_LT] = ACTIONS(6202),
    [anon_sym_GT] = ACTIONS(6202),
    [anon_sym_BANG] = ACTIONS(6202),
    [anon_sym_PIPE] = ACTIONS(6202),
    [anon_sym_COLON] = ACTIONS(6202),
    [anon_sym_SQUOTE] = ACTIONS(6202),
    [anon_sym__] = ACTIONS(6204),
    [anon_sym_CARET] = ACTIONS(6204),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6204),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6204),
    [anon_sym_DOLLAR] = ACTIONS(6202),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHbegin] = ACTIONS(6202),
    [anon_sym_BSLASHend] = ACTIONS(6202),
    [anon_sym_BSLASHtitle] = ACTIONS(6202),
    [anon_sym_BSLASHauthor] = ACTIONS(6202),
    [anon_sym_BSLASHusepackage] = ACTIONS(6202),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6202),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6202),
    [anon_sym_BSLASHinclude] = ACTIONS(6202),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6202),
    [anon_sym_BSLASHinput] = ACTIONS(6202),
    [anon_sym_BSLASHsubfile] = ACTIONS(6202),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6202),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6202),
    [anon_sym_BSLASHbibliography] = ACTIONS(6202),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6202),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6202),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6202),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6202),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6202),
    [anon_sym_BSLASHimport] = ACTIONS(6202),
    [anon_sym_BSLASHsubimport] = ACTIONS(6202),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6202),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHcaption] = ACTIONS(6202),
    [anon_sym_BSLASHcite] = ACTIONS(6202),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCite] = ACTIONS(6202),
    [anon_sym_BSLASHnocite] = ACTIONS(6202),
    [anon_sym_BSLASHcitet] = ACTIONS(6202),
    [anon_sym_BSLASHcitep] = ACTIONS(6202),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteA] = ACTIONS(6202),
    [anon_sym_BSLASHciteR] = ACTIONS(6202),
    [anon_sym_BSLASHciteS] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6202),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteyear] = ACTIONS(6202),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitedate] = ACTIONS(6202),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteurl] = ACTIONS(6202),
    [anon_sym_BSLASHfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6202),
    [anon_sym_BSLASHcitealt] = ACTIONS(6202),
    [anon_sym_BSLASHcitealp] = ACTIONS(6202),
    [anon_sym_BSLASHcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHparencite] = ACTIONS(6202),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHParencite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHtextcite] = ACTIONS(6202),
    [anon_sym_BSLASHTextcite] = ACTIONS(6202),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHsupercite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite] = ACTIONS(6202),
    [anon_sym_BSLASHAutocite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHVolcite] = ACTIONS(6202),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHavolcite] = ACTIONS(6202),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHNotecite] = ACTIONS(6202),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHlabel] = ACTIONS(6202),
    [anon_sym_BSLASHref] = ACTIONS(6202),
    [anon_sym_BSLASHeqref] = ACTIONS(6202),
    [anon_sym_BSLASHvref] = ACTIONS(6202),
    [anon_sym_BSLASHVref] = ACTIONS(6202),
    [anon_sym_BSLASHautoref] = ACTIONS(6202),
    [anon_sym_BSLASHpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcref] = ACTIONS(6202),
    [anon_sym_BSLASHCref] = ACTIONS(6202),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnameCref] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHdef] = ACTIONS(6202),
    [anon_sym_BSLASHlet] = ACTIONS(6202),
    [anon_sym_BSLASHleft] = ACTIONS(6202),
    [anon_sym_BSLASHbigl] = ACTIONS(6202),
    [anon_sym_BSLASHBigl] = ACTIONS(6202),
    [anon_sym_BSLASHbiggl] = ACTIONS(6202),
    [anon_sym_BSLASHBiggl] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6202),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6202),
    [anon_sym_BSLASHgls] = ACTIONS(6202),
    [anon_sym_BSLASHGls] = ACTIONS(6202),
    [anon_sym_BSLASHGLS] = ACTIONS(6202),
    [anon_sym_BSLASHglspl] = ACTIONS(6202),
    [anon_sym_BSLASHGlspl] = ACTIONS(6202),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6202),
    [anon_sym_BSLASHglslink] = ACTIONS(6202),
    [anon_sym_BSLASHglstext] = ACTIONS(6202),
    [anon_sym_BSLASHGlstext] = ACTIONS(6202),
    [anon_sym_BSLASHGLStext] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6202),
    [anon_sym_BSLASHglsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsname] = ACTIONS(6202),
    [anon_sym_BSLASHGlsname] = ACTIONS(6202),
    [anon_sym_BSLASHGLSname] = ACTIONS(6202),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6202),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6202),
    [anon_sym_BSLASHacrshort] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6202),
    [anon_sym_BSLASHACRshort] = ACTIONS(6202),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrlong] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6202),
    [anon_sym_BSLASHACRlong] = ACTIONS(6202),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrfull] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6202),
    [anon_sym_BSLASHACRfull] = ACTIONS(6202),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHacs] = ACTIONS(6202),
    [anon_sym_BSLASHAcs] = ACTIONS(6202),
    [anon_sym_BSLASHacsp] = ACTIONS(6202),
    [anon_sym_BSLASHAcsp] = ACTIONS(6202),
    [anon_sym_BSLASHacl] = ACTIONS(6202),
    [anon_sym_BSLASHAcl] = ACTIONS(6202),
    [anon_sym_BSLASHaclp] = ACTIONS(6202),
    [anon_sym_BSLASHAclp] = ACTIONS(6202),
    [anon_sym_BSLASHacf] = ACTIONS(6202),
    [anon_sym_BSLASHAcf] = ACTIONS(6202),
    [anon_sym_BSLASHacfp] = ACTIONS(6202),
    [anon_sym_BSLASHAcfp] = ACTIONS(6202),
    [anon_sym_BSLASHac] = ACTIONS(6202),
    [anon_sym_BSLASHAc] = ACTIONS(6202),
    [anon_sym_BSLASHacp] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6202),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6202),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6202),
    [anon_sym_BSLASHcolor] = ACTIONS(6202),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6202),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6202),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6202),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6202),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6202),
    [anon_sym_BSLASHtext] = ACTIONS(6202),
    [anon_sym_BSLASHintertext] = ACTIONS(6202),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6202),
    [anon_sym_BSLASHurl] = ACTIONS(6202),
    [anon_sym_BSLASHhref] = ACTIONS(6202),
  },
  [1098] = {
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHend] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [1099] = {
    [sym_command_name] = ACTIONS(6194),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_RBRACK] = ACTIONS(6196),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_EQ] = ACTIONS(6196),
    [anon_sym_LPAREN] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHpart] = ACTIONS(6194),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddpart] = ACTIONS(6194),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHchapter] = ACTIONS(6194),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddchap] = ACTIONS(6194),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsection] = ACTIONS(6194),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddsec] = ACTIONS(6194),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHitem] = ACTIONS(6194),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [sym_word] = ACTIONS(6194),
    [sym_placeholder] = ACTIONS(6196),
    [anon_sym_PLUS] = ACTIONS(6196),
    [anon_sym_DASH] = ACTIONS(6196),
    [anon_sym_STAR] = ACTIONS(6196),
    [anon_sym_SLASH] = ACTIONS(6196),
    [anon_sym_LT] = ACTIONS(6194),
    [anon_sym_GT] = ACTIONS(6194),
    [anon_sym_BANG] = ACTIONS(6194),
    [anon_sym_PIPE] = ACTIONS(6194),
    [anon_sym_COLON] = ACTIONS(6194),
    [anon_sym_SQUOTE] = ACTIONS(6194),
    [anon_sym__] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6196),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6196),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6196),
    [anon_sym_DOLLAR] = ACTIONS(6194),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHbegin] = ACTIONS(6194),
    [anon_sym_BSLASHend] = ACTIONS(6194),
    [anon_sym_BSLASHtitle] = ACTIONS(6194),
    [anon_sym_BSLASHauthor] = ACTIONS(6194),
    [anon_sym_BSLASHusepackage] = ACTIONS(6194),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6194),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6194),
    [anon_sym_BSLASHinclude] = ACTIONS(6194),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6194),
    [anon_sym_BSLASHinput] = ACTIONS(6194),
    [anon_sym_BSLASHsubfile] = ACTIONS(6194),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6194),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6194),
    [anon_sym_BSLASHbibliography] = ACTIONS(6194),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6194),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6194),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6194),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6194),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6194),
    [anon_sym_BSLASHimport] = ACTIONS(6194),
    [anon_sym_BSLASHsubimport] = ACTIONS(6194),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6194),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHcaption] = ACTIONS(6194),
    [anon_sym_BSLASHcite] = ACTIONS(6194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCite] = ACTIONS(6194),
    [anon_sym_BSLASHnocite] = ACTIONS(6194),
    [anon_sym_BSLASHcitet] = ACTIONS(6194),
    [anon_sym_BSLASHcitep] = ACTIONS(6194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteA] = ACTIONS(6194),
    [anon_sym_BSLASHciteR] = ACTIONS(6194),
    [anon_sym_BSLASHciteS] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteyear] = ACTIONS(6194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitedate] = ACTIONS(6194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteurl] = ACTIONS(6194),
    [anon_sym_BSLASHfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6194),
    [anon_sym_BSLASHcitealt] = ACTIONS(6194),
    [anon_sym_BSLASHcitealp] = ACTIONS(6194),
    [anon_sym_BSLASHcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHparencite] = ACTIONS(6194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHParencite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHtextcite] = ACTIONS(6194),
    [anon_sym_BSLASHTextcite] = ACTIONS(6194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHsupercite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite] = ACTIONS(6194),
    [anon_sym_BSLASHAutocite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHVolcite] = ACTIONS(6194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHavolcite] = ACTIONS(6194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHNotecite] = ACTIONS(6194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHlabel] = ACTIONS(6194),
    [anon_sym_BSLASHref] = ACTIONS(6194),
    [anon_sym_BSLASHeqref] = ACTIONS(6194),
    [anon_sym_BSLASHvref] = ACTIONS(6194),
    [anon_sym_BSLASHVref] = ACTIONS(6194),
    [anon_sym_BSLASHautoref] = ACTIONS(6194),
    [anon_sym_BSLASHpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcref] = ACTIONS(6194),
    [anon_sym_BSLASHCref] = ACTIONS(6194),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnameCref] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHdef] = ACTIONS(6194),
    [anon_sym_BSLASHlet] = ACTIONS(6194),
    [anon_sym_BSLASHleft] = ACTIONS(6194),
    [anon_sym_BSLASHbigl] = ACTIONS(6194),
    [anon_sym_BSLASHBigl] = ACTIONS(6194),
    [anon_sym_BSLASHbiggl] = ACTIONS(6194),
    [anon_sym_BSLASHBiggl] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6194),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6194),
    [anon_sym_BSLASHgls] = ACTIONS(6194),
    [anon_sym_BSLASHGls] = ACTIONS(6194),
    [anon_sym_BSLASHGLS] = ACTIONS(6194),
    [anon_sym_BSLASHglspl] = ACTIONS(6194),
    [anon_sym_BSLASHGlspl] = ACTIONS(6194),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6194),
    [anon_sym_BSLASHglslink] = ACTIONS(6194),
    [anon_sym_BSLASHglstext] = ACTIONS(6194),
    [anon_sym_BSLASHGlstext] = ACTIONS(6194),
    [anon_sym_BSLASHGLStext] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6194),
    [anon_sym_BSLASHglsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsname] = ACTIONS(6194),
    [anon_sym_BSLASHGlsname] = ACTIONS(6194),
    [anon_sym_BSLASHGLSname] = ACTIONS(6194),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6194),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6194),
    [anon_sym_BSLASHacrshort] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6194),
    [anon_sym_BSLASHACRshort] = ACTIONS(6194),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrlong] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6194),
    [anon_sym_BSLASHACRlong] = ACTIONS(6194),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrfull] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6194),
    [anon_sym_BSLASHACRfull] = ACTIONS(6194),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHacs] = ACTIONS(6194),
    [anon_sym_BSLASHAcs] = ACTIONS(6194),
    [anon_sym_BSLASHacsp] = ACTIONS(6194),
    [anon_sym_BSLASHAcsp] = ACTIONS(6194),
    [anon_sym_BSLASHacl] = ACTIONS(6194),
    [anon_sym_BSLASHAcl] = ACTIONS(6194),
    [anon_sym_BSLASHaclp] = ACTIONS(6194),
    [anon_sym_BSLASHAclp] = ACTIONS(6194),
    [anon_sym_BSLASHacf] = ACTIONS(6194),
    [anon_sym_BSLASHAcf] = ACTIONS(6194),
    [anon_sym_BSLASHacfp] = ACTIONS(6194),
    [anon_sym_BSLASHAcfp] = ACTIONS(6194),
    [anon_sym_BSLASHac] = ACTIONS(6194),
    [anon_sym_BSLASHAc] = ACTIONS(6194),
    [anon_sym_BSLASHacp] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6194),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6194),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6194),
    [anon_sym_BSLASHcolor] = ACTIONS(6194),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6194),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6194),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6194),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6194),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6194),
    [anon_sym_BSLASHtext] = ACTIONS(6194),
    [anon_sym_BSLASHintertext] = ACTIONS(6194),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6194),
    [anon_sym_BSLASHurl] = ACTIONS(6194),
    [anon_sym_BSLASHhref] = ACTIONS(6194),
  },
  [1100] = {
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHend] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [1101] = {
    [sym_command_name] = ACTIONS(6186),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(6188),
    [anon_sym_RBRACK] = ACTIONS(6188),
    [anon_sym_COMMA] = ACTIONS(6188),
    [anon_sym_EQ] = ACTIONS(6188),
    [anon_sym_LPAREN] = ACTIONS(6188),
    [anon_sym_RPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHpart] = ACTIONS(6186),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddpart] = ACTIONS(6186),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHchapter] = ACTIONS(6186),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddchap] = ACTIONS(6186),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsection] = ACTIONS(6186),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddsec] = ACTIONS(6186),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHitem] = ACTIONS(6186),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6188),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [sym_word] = ACTIONS(6186),
    [sym_placeholder] = ACTIONS(6188),
    [anon_sym_PLUS] = ACTIONS(6188),
    [anon_sym_DASH] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_SLASH] = ACTIONS(6188),
    [anon_sym_LT] = ACTIONS(6186),
    [anon_sym_GT] = ACTIONS(6186),
    [anon_sym_BANG] = ACTIONS(6186),
    [anon_sym_PIPE] = ACTIONS(6186),
    [anon_sym_COLON] = ACTIONS(6186),
    [anon_sym_SQUOTE] = ACTIONS(6186),
    [anon_sym__] = ACTIONS(6188),
    [anon_sym_CARET] = ACTIONS(6188),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6188),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6188),
    [anon_sym_DOLLAR] = ACTIONS(6186),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHbegin] = ACTIONS(6186),
    [anon_sym_BSLASHend] = ACTIONS(6186),
    [anon_sym_BSLASHtitle] = ACTIONS(6186),
    [anon_sym_BSLASHauthor] = ACTIONS(6186),
    [anon_sym_BSLASHusepackage] = ACTIONS(6186),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6186),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6186),
    [anon_sym_BSLASHinclude] = ACTIONS(6186),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6186),
    [anon_sym_BSLASHinput] = ACTIONS(6186),
    [anon_sym_BSLASHsubfile] = ACTIONS(6186),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6186),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6186),
    [anon_sym_BSLASHbibliography] = ACTIONS(6186),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6186),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6186),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6186),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6186),
    [anon_sym_BSLASHimport] = ACTIONS(6186),
    [anon_sym_BSLASHsubimport] = ACTIONS(6186),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6186),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHcaption] = ACTIONS(6186),
    [anon_sym_BSLASHcite] = ACTIONS(6186),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCite] = ACTIONS(6186),
    [anon_sym_BSLASHnocite] = ACTIONS(6186),
    [anon_sym_BSLASHcitet] = ACTIONS(6186),
    [anon_sym_BSLASHcitep] = ACTIONS(6186),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteA] = ACTIONS(6186),
    [anon_sym_BSLASHciteR] = ACTIONS(6186),
    [anon_sym_BSLASHciteS] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6186),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteyear] = ACTIONS(6186),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitedate] = ACTIONS(6186),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteurl] = ACTIONS(6186),
    [anon_sym_BSLASHfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6186),
    [anon_sym_BSLASHcitealt] = ACTIONS(6186),
    [anon_sym_BSLASHcitealp] = ACTIONS(6186),
    [anon_sym_BSLASHcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHparencite] = ACTIONS(6186),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHParencite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHtextcite] = ACTIONS(6186),
    [anon_sym_BSLASHTextcite] = ACTIONS(6186),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHsupercite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite] = ACTIONS(6186),
    [anon_sym_BSLASHAutocite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHVolcite] = ACTIONS(6186),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHavolcite] = ACTIONS(6186),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHNotecite] = ACTIONS(6186),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHlabel] = ACTIONS(6186),
    [anon_sym_BSLASHref] = ACTIONS(6186),
    [anon_sym_BSLASHeqref] = ACTIONS(6186),
    [anon_sym_BSLASHvref] = ACTIONS(6186),
    [anon_sym_BSLASHVref] = ACTIONS(6186),
    [anon_sym_BSLASHautoref] = ACTIONS(6186),
    [anon_sym_BSLASHpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcref] = ACTIONS(6186),
    [anon_sym_BSLASHCref] = ACTIONS(6186),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnameCref] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHdef] = ACTIONS(6186),
    [anon_sym_BSLASHlet] = ACTIONS(6186),
    [anon_sym_BSLASHleft] = ACTIONS(6186),
    [anon_sym_BSLASHbigl] = ACTIONS(6186),
    [anon_sym_BSLASHBigl] = ACTIONS(6186),
    [anon_sym_BSLASHbiggl] = ACTIONS(6186),
    [anon_sym_BSLASHBiggl] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6186),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6186),
    [anon_sym_BSLASHgls] = ACTIONS(6186),
    [anon_sym_BSLASHGls] = ACTIONS(6186),
    [anon_sym_BSLASHGLS] = ACTIONS(6186),
    [anon_sym_BSLASHglspl] = ACTIONS(6186),
    [anon_sym_BSLASHGlspl] = ACTIONS(6186),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6186),
    [anon_sym_BSLASHglslink] = ACTIONS(6186),
    [anon_sym_BSLASHglstext] = ACTIONS(6186),
    [anon_sym_BSLASHGlstext] = ACTIONS(6186),
    [anon_sym_BSLASHGLStext] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6186),
    [anon_sym_BSLASHglsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsname] = ACTIONS(6186),
    [anon_sym_BSLASHGlsname] = ACTIONS(6186),
    [anon_sym_BSLASHGLSname] = ACTIONS(6186),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6186),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6186),
    [anon_sym_BSLASHacrshort] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6186),
    [anon_sym_BSLASHACRshort] = ACTIONS(6186),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrlong] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6186),
    [anon_sym_BSLASHACRlong] = ACTIONS(6186),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrfull] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6186),
    [anon_sym_BSLASHACRfull] = ACTIONS(6186),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHacs] = ACTIONS(6186),
    [anon_sym_BSLASHAcs] = ACTIONS(6186),
    [anon_sym_BSLASHacsp] = ACTIONS(6186),
    [anon_sym_BSLASHAcsp] = ACTIONS(6186),
    [anon_sym_BSLASHacl] = ACTIONS(6186),
    [anon_sym_BSLASHAcl] = ACTIONS(6186),
    [anon_sym_BSLASHaclp] = ACTIONS(6186),
    [anon_sym_BSLASHAclp] = ACTIONS(6186),
    [anon_sym_BSLASHacf] = ACTIONS(6186),
    [anon_sym_BSLASHAcf] = ACTIONS(6186),
    [anon_sym_BSLASHacfp] = ACTIONS(6186),
    [anon_sym_BSLASHAcfp] = ACTIONS(6186),
    [anon_sym_BSLASHac] = ACTIONS(6186),
    [anon_sym_BSLASHAc] = ACTIONS(6186),
    [anon_sym_BSLASHacp] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6186),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6186),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6186),
    [anon_sym_BSLASHcolor] = ACTIONS(6186),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6186),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6186),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6186),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6186),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6186),
    [anon_sym_BSLASHtext] = ACTIONS(6186),
    [anon_sym_BSLASHintertext] = ACTIONS(6186),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6186),
    [anon_sym_BSLASHurl] = ACTIONS(6186),
    [anon_sym_BSLASHhref] = ACTIONS(6186),
  },
  [1102] = {
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6336),
    [anon_sym_RBRACK] = ACTIONS(6336),
    [anon_sym_COMMA] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_RPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHpart] = ACTIONS(6334),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddpart] = ACTIONS(6334),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHchapter] = ACTIONS(6334),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddchap] = ACTIONS(6334),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsection] = ACTIONS(6334),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddsec] = ACTIONS(6334),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHitem] = ACTIONS(6334),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6336),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHbegin] = ACTIONS(6334),
    [anon_sym_BSLASHend] = ACTIONS(6334),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHleft] = ACTIONS(6334),
    [anon_sym_BSLASHbigl] = ACTIONS(6334),
    [anon_sym_BSLASHBigl] = ACTIONS(6334),
    [anon_sym_BSLASHbiggl] = ACTIONS(6334),
    [anon_sym_BSLASHBiggl] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHtext] = ACTIONS(6334),
    [anon_sym_BSLASHintertext] = ACTIONS(6334),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [1103] = {
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6332),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_EQ] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6332),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHpart] = ACTIONS(6330),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddpart] = ACTIONS(6330),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHchapter] = ACTIONS(6330),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddchap] = ACTIONS(6330),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsection] = ACTIONS(6330),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddsec] = ACTIONS(6330),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHitem] = ACTIONS(6330),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6332),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6330),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHbegin] = ACTIONS(6330),
    [anon_sym_BSLASHend] = ACTIONS(6330),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHleft] = ACTIONS(6330),
    [anon_sym_BSLASHbigl] = ACTIONS(6330),
    [anon_sym_BSLASHBigl] = ACTIONS(6330),
    [anon_sym_BSLASHbiggl] = ACTIONS(6330),
    [anon_sym_BSLASHBiggl] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHtext] = ACTIONS(6330),
    [anon_sym_BSLASHintertext] = ACTIONS(6330),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [1104] = {
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6328),
    [anon_sym_RBRACK] = ACTIONS(6328),
    [anon_sym_COMMA] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6328),
    [anon_sym_RPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHpart] = ACTIONS(6326),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddpart] = ACTIONS(6326),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHchapter] = ACTIONS(6326),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddchap] = ACTIONS(6326),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsection] = ACTIONS(6326),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddsec] = ACTIONS(6326),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHitem] = ACTIONS(6326),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6328),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6328),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6328),
    [anon_sym_DOLLAR] = ACTIONS(6326),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHbegin] = ACTIONS(6326),
    [anon_sym_BSLASHend] = ACTIONS(6326),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHleft] = ACTIONS(6326),
    [anon_sym_BSLASHbigl] = ACTIONS(6326),
    [anon_sym_BSLASHBigl] = ACTIONS(6326),
    [anon_sym_BSLASHbiggl] = ACTIONS(6326),
    [anon_sym_BSLASHBiggl] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHtext] = ACTIONS(6326),
    [anon_sym_BSLASHintertext] = ACTIONS(6326),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [1105] = {
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHpart] = ACTIONS(6322),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddpart] = ACTIONS(6322),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHchapter] = ACTIONS(6322),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddchap] = ACTIONS(6322),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsection] = ACTIONS(6322),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddsec] = ACTIONS(6322),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHitem] = ACTIONS(6322),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6324),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6324),
    [anon_sym_DOLLAR] = ACTIONS(6322),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHbegin] = ACTIONS(6322),
    [anon_sym_BSLASHend] = ACTIONS(6322),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHleft] = ACTIONS(6322),
    [anon_sym_BSLASHbigl] = ACTIONS(6322),
    [anon_sym_BSLASHBigl] = ACTIONS(6322),
    [anon_sym_BSLASHbiggl] = ACTIONS(6322),
    [anon_sym_BSLASHBiggl] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHtext] = ACTIONS(6322),
    [anon_sym_BSLASHintertext] = ACTIONS(6322),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [1106] = {
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_RBRACK] = ACTIONS(6320),
    [anon_sym_COMMA] = ACTIONS(6320),
    [anon_sym_EQ] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(6320),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHpart] = ACTIONS(6318),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddpart] = ACTIONS(6318),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHchapter] = ACTIONS(6318),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddchap] = ACTIONS(6318),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsection] = ACTIONS(6318),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddsec] = ACTIONS(6318),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHitem] = ACTIONS(6318),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6320),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6320),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHbegin] = ACTIONS(6318),
    [anon_sym_BSLASHend] = ACTIONS(6318),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHleft] = ACTIONS(6318),
    [anon_sym_BSLASHbigl] = ACTIONS(6318),
    [anon_sym_BSLASHBigl] = ACTIONS(6318),
    [anon_sym_BSLASHbiggl] = ACTIONS(6318),
    [anon_sym_BSLASHBiggl] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHtext] = ACTIONS(6318),
    [anon_sym_BSLASHintertext] = ACTIONS(6318),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [1107] = {
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_COMMA] = ACTIONS(6316),
    [anon_sym_EQ] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6316),
    [anon_sym_RPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHpart] = ACTIONS(6314),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddpart] = ACTIONS(6314),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHchapter] = ACTIONS(6314),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddchap] = ACTIONS(6314),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsection] = ACTIONS(6314),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddsec] = ACTIONS(6314),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHitem] = ACTIONS(6314),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6316),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6316),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6316),
    [anon_sym_DOLLAR] = ACTIONS(6314),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHbegin] = ACTIONS(6314),
    [anon_sym_BSLASHend] = ACTIONS(6314),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHleft] = ACTIONS(6314),
    [anon_sym_BSLASHbigl] = ACTIONS(6314),
    [anon_sym_BSLASHBigl] = ACTIONS(6314),
    [anon_sym_BSLASHbiggl] = ACTIONS(6314),
    [anon_sym_BSLASHBiggl] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHtext] = ACTIONS(6314),
    [anon_sym_BSLASHintertext] = ACTIONS(6314),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [1108] = {
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6312),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6312),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHpart] = ACTIONS(6310),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddpart] = ACTIONS(6310),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHchapter] = ACTIONS(6310),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddchap] = ACTIONS(6310),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsection] = ACTIONS(6310),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddsec] = ACTIONS(6310),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHitem] = ACTIONS(6310),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6312),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6312),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6312),
    [anon_sym_DOLLAR] = ACTIONS(6310),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHbegin] = ACTIONS(6310),
    [anon_sym_BSLASHend] = ACTIONS(6310),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHleft] = ACTIONS(6310),
    [anon_sym_BSLASHbigl] = ACTIONS(6310),
    [anon_sym_BSLASHBigl] = ACTIONS(6310),
    [anon_sym_BSLASHbiggl] = ACTIONS(6310),
    [anon_sym_BSLASHBiggl] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHtext] = ACTIONS(6310),
    [anon_sym_BSLASHintertext] = ACTIONS(6310),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [1109] = {
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6292),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_COMMA] = ACTIONS(6292),
    [anon_sym_EQ] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_RPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHpart] = ACTIONS(6290),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddpart] = ACTIONS(6290),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHchapter] = ACTIONS(6290),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddchap] = ACTIONS(6290),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsection] = ACTIONS(6290),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddsec] = ACTIONS(6290),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHitem] = ACTIONS(6290),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6292),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6292),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6292),
    [anon_sym_DOLLAR] = ACTIONS(6290),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHbegin] = ACTIONS(6290),
    [anon_sym_BSLASHend] = ACTIONS(6290),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHleft] = ACTIONS(6290),
    [anon_sym_BSLASHbigl] = ACTIONS(6290),
    [anon_sym_BSLASHBigl] = ACTIONS(6290),
    [anon_sym_BSLASHbiggl] = ACTIONS(6290),
    [anon_sym_BSLASHBiggl] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHtext] = ACTIONS(6290),
    [anon_sym_BSLASHintertext] = ACTIONS(6290),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [1110] = {
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6288),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHpart] = ACTIONS(6286),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddpart] = ACTIONS(6286),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHchapter] = ACTIONS(6286),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddchap] = ACTIONS(6286),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsection] = ACTIONS(6286),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddsec] = ACTIONS(6286),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHitem] = ACTIONS(6286),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6288),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6288),
    [anon_sym_DOLLAR] = ACTIONS(6286),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHbegin] = ACTIONS(6286),
    [anon_sym_BSLASHend] = ACTIONS(6286),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHleft] = ACTIONS(6286),
    [anon_sym_BSLASHbigl] = ACTIONS(6286),
    [anon_sym_BSLASHBigl] = ACTIONS(6286),
    [anon_sym_BSLASHbiggl] = ACTIONS(6286),
    [anon_sym_BSLASHBiggl] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHtext] = ACTIONS(6286),
    [anon_sym_BSLASHintertext] = ACTIONS(6286),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [1111] = {
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_LBRACK] = ACTIONS(6272),
    [anon_sym_RBRACK] = ACTIONS(6272),
    [anon_sym_COMMA] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_LPAREN] = ACTIONS(6272),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHpart] = ACTIONS(6270),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddpart] = ACTIONS(6270),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHchapter] = ACTIONS(6270),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddchap] = ACTIONS(6270),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsection] = ACTIONS(6270),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddsec] = ACTIONS(6270),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHitem] = ACTIONS(6270),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6272),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6272),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6272),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHbegin] = ACTIONS(6270),
    [anon_sym_BSLASHend] = ACTIONS(6270),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHleft] = ACTIONS(6270),
    [anon_sym_BSLASHbigl] = ACTIONS(6270),
    [anon_sym_BSLASHBigl] = ACTIONS(6270),
    [anon_sym_BSLASHbiggl] = ACTIONS(6270),
    [anon_sym_BSLASHBiggl] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHtext] = ACTIONS(6270),
    [anon_sym_BSLASHintertext] = ACTIONS(6270),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [1112] = {
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_COMMA] = ACTIONS(6268),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_LPAREN] = ACTIONS(6268),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHpart] = ACTIONS(6266),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddpart] = ACTIONS(6266),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHchapter] = ACTIONS(6266),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddchap] = ACTIONS(6266),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsection] = ACTIONS(6266),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddsec] = ACTIONS(6266),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHitem] = ACTIONS(6266),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6268),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(6266),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHbegin] = ACTIONS(6266),
    [anon_sym_BSLASHend] = ACTIONS(6266),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHleft] = ACTIONS(6266),
    [anon_sym_BSLASHbigl] = ACTIONS(6266),
    [anon_sym_BSLASHBigl] = ACTIONS(6266),
    [anon_sym_BSLASHbiggl] = ACTIONS(6266),
    [anon_sym_BSLASHBiggl] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHtext] = ACTIONS(6266),
    [anon_sym_BSLASHintertext] = ACTIONS(6266),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [1113] = {
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6252),
    [anon_sym_LPAREN] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHpart] = ACTIONS(6250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddpart] = ACTIONS(6250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHchapter] = ACTIONS(6250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddchap] = ACTIONS(6250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsection] = ACTIONS(6250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddsec] = ACTIONS(6250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHitem] = ACTIONS(6250),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHbegin] = ACTIONS(6250),
    [anon_sym_BSLASHend] = ACTIONS(6250),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHleft] = ACTIONS(6250),
    [anon_sym_BSLASHbigl] = ACTIONS(6250),
    [anon_sym_BSLASHBigl] = ACTIONS(6250),
    [anon_sym_BSLASHbiggl] = ACTIONS(6250),
    [anon_sym_BSLASHBiggl] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHtext] = ACTIONS(6250),
    [anon_sym_BSLASHintertext] = ACTIONS(6250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
  [1114] = {
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_COMMA] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_LPAREN] = ACTIONS(6248),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHpart] = ACTIONS(6246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddpart] = ACTIONS(6246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHchapter] = ACTIONS(6246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddchap] = ACTIONS(6246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsection] = ACTIONS(6246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddsec] = ACTIONS(6246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHitem] = ACTIONS(6246),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6248),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6248),
    [anon_sym_DOLLAR] = ACTIONS(6246),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHbegin] = ACTIONS(6246),
    [anon_sym_BSLASHend] = ACTIONS(6246),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHleft] = ACTIONS(6246),
    [anon_sym_BSLASHbigl] = ACTIONS(6246),
    [anon_sym_BSLASHBigl] = ACTIONS(6246),
    [anon_sym_BSLASHbiggl] = ACTIONS(6246),
    [anon_sym_BSLASHBiggl] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHtext] = ACTIONS(6246),
    [anon_sym_BSLASHintertext] = ACTIONS(6246),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [1115] = {
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6244),
    [anon_sym_RBRACK] = ACTIONS(6244),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_LPAREN] = ACTIONS(6244),
    [anon_sym_RPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHpart] = ACTIONS(6242),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddpart] = ACTIONS(6242),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHchapter] = ACTIONS(6242),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddchap] = ACTIONS(6242),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsection] = ACTIONS(6242),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddsec] = ACTIONS(6242),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHitem] = ACTIONS(6242),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6244),
    [anon_sym_LBRACE] = ACTIONS(6244),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6244),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6244),
    [anon_sym_DOLLAR] = ACTIONS(6242),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHbegin] = ACTIONS(6242),
    [anon_sym_BSLASHend] = ACTIONS(6242),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHleft] = ACTIONS(6242),
    [anon_sym_BSLASHbigl] = ACTIONS(6242),
    [anon_sym_BSLASHBigl] = ACTIONS(6242),
    [anon_sym_BSLASHbiggl] = ACTIONS(6242),
    [anon_sym_BSLASHBiggl] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHtext] = ACTIONS(6242),
    [anon_sym_BSLASHintertext] = ACTIONS(6242),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [1116] = {
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6240),
    [anon_sym_RBRACK] = ACTIONS(6240),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_LPAREN] = ACTIONS(6240),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHpart] = ACTIONS(6238),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddpart] = ACTIONS(6238),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHchapter] = ACTIONS(6238),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddchap] = ACTIONS(6238),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsection] = ACTIONS(6238),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddsec] = ACTIONS(6238),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHitem] = ACTIONS(6238),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(6240),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6240),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6240),
    [anon_sym_DOLLAR] = ACTIONS(6238),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHbegin] = ACTIONS(6238),
    [anon_sym_BSLASHend] = ACTIONS(6238),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHleft] = ACTIONS(6238),
    [anon_sym_BSLASHbigl] = ACTIONS(6238),
    [anon_sym_BSLASHBigl] = ACTIONS(6238),
    [anon_sym_BSLASHbiggl] = ACTIONS(6238),
    [anon_sym_BSLASHBiggl] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHtext] = ACTIONS(6238),
    [anon_sym_BSLASHintertext] = ACTIONS(6238),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [1117] = {
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_LPAREN] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHpart] = ACTIONS(6234),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddpart] = ACTIONS(6234),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHchapter] = ACTIONS(6234),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddchap] = ACTIONS(6234),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsection] = ACTIONS(6234),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddsec] = ACTIONS(6234),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHitem] = ACTIONS(6234),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6236),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(6234),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHbegin] = ACTIONS(6234),
    [anon_sym_BSLASHend] = ACTIONS(6234),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHleft] = ACTIONS(6234),
    [anon_sym_BSLASHbigl] = ACTIONS(6234),
    [anon_sym_BSLASHBigl] = ACTIONS(6234),
    [anon_sym_BSLASHbiggl] = ACTIONS(6234),
    [anon_sym_BSLASHBiggl] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHtext] = ACTIONS(6234),
    [anon_sym_BSLASHintertext] = ACTIONS(6234),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [1118] = {
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6232),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6232),
    [anon_sym_LPAREN] = ACTIONS(6232),
    [anon_sym_RPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHpart] = ACTIONS(6230),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddpart] = ACTIONS(6230),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHchapter] = ACTIONS(6230),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddchap] = ACTIONS(6230),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsection] = ACTIONS(6230),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddsec] = ACTIONS(6230),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHitem] = ACTIONS(6230),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6232),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6232),
    [anon_sym_DOLLAR] = ACTIONS(6230),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHbegin] = ACTIONS(6230),
    [anon_sym_BSLASHend] = ACTIONS(6230),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHleft] = ACTIONS(6230),
    [anon_sym_BSLASHbigl] = ACTIONS(6230),
    [anon_sym_BSLASHBigl] = ACTIONS(6230),
    [anon_sym_BSLASHbiggl] = ACTIONS(6230),
    [anon_sym_BSLASHBiggl] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHtext] = ACTIONS(6230),
    [anon_sym_BSLASHintertext] = ACTIONS(6230),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [1119] = {
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6228),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_LPAREN] = ACTIONS(6228),
    [anon_sym_RPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHpart] = ACTIONS(6226),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddpart] = ACTIONS(6226),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHchapter] = ACTIONS(6226),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddchap] = ACTIONS(6226),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsection] = ACTIONS(6226),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddsec] = ACTIONS(6226),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHitem] = ACTIONS(6226),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(6228),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6228),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(6226),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHbegin] = ACTIONS(6226),
    [anon_sym_BSLASHend] = ACTIONS(6226),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHleft] = ACTIONS(6226),
    [anon_sym_BSLASHbigl] = ACTIONS(6226),
    [anon_sym_BSLASHBigl] = ACTIONS(6226),
    [anon_sym_BSLASHbiggl] = ACTIONS(6226),
    [anon_sym_BSLASHBiggl] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHtext] = ACTIONS(6226),
    [anon_sym_BSLASHintertext] = ACTIONS(6226),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [1120] = {
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6224),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_LPAREN] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHpart] = ACTIONS(6222),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddpart] = ACTIONS(6222),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHchapter] = ACTIONS(6222),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddchap] = ACTIONS(6222),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsection] = ACTIONS(6222),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddsec] = ACTIONS(6222),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHitem] = ACTIONS(6222),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6224),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6224),
    [anon_sym_DOLLAR] = ACTIONS(6222),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHbegin] = ACTIONS(6222),
    [anon_sym_BSLASHend] = ACTIONS(6222),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHleft] = ACTIONS(6222),
    [anon_sym_BSLASHbigl] = ACTIONS(6222),
    [anon_sym_BSLASHBigl] = ACTIONS(6222),
    [anon_sym_BSLASHbiggl] = ACTIONS(6222),
    [anon_sym_BSLASHBiggl] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHtext] = ACTIONS(6222),
    [anon_sym_BSLASHintertext] = ACTIONS(6222),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [1121] = {
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6220),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHpart] = ACTIONS(6218),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddpart] = ACTIONS(6218),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHchapter] = ACTIONS(6218),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddchap] = ACTIONS(6218),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsection] = ACTIONS(6218),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddsec] = ACTIONS(6218),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHitem] = ACTIONS(6218),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6220),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6220),
    [anon_sym_DOLLAR] = ACTIONS(6218),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHbegin] = ACTIONS(6218),
    [anon_sym_BSLASHend] = ACTIONS(6218),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHleft] = ACTIONS(6218),
    [anon_sym_BSLASHbigl] = ACTIONS(6218),
    [anon_sym_BSLASHBigl] = ACTIONS(6218),
    [anon_sym_BSLASHbiggl] = ACTIONS(6218),
    [anon_sym_BSLASHBiggl] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHtext] = ACTIONS(6218),
    [anon_sym_BSLASHintertext] = ACTIONS(6218),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [1122] = {
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_EQ] = ACTIONS(6216),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [anon_sym_RPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHpart] = ACTIONS(6214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddpart] = ACTIONS(6214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHchapter] = ACTIONS(6214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddchap] = ACTIONS(6214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsection] = ACTIONS(6214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddsec] = ACTIONS(6214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHitem] = ACTIONS(6214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6216),
    [anon_sym_DOLLAR] = ACTIONS(6214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHbegin] = ACTIONS(6214),
    [anon_sym_BSLASHend] = ACTIONS(6214),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHleft] = ACTIONS(6214),
    [anon_sym_BSLASHbigl] = ACTIONS(6214),
    [anon_sym_BSLASHBigl] = ACTIONS(6214),
    [anon_sym_BSLASHbiggl] = ACTIONS(6214),
    [anon_sym_BSLASHBiggl] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHtext] = ACTIONS(6214),
    [anon_sym_BSLASHintertext] = ACTIONS(6214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [1123] = {
    [sym_command_name] = ACTIONS(6178),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6178),
    [anon_sym_LBRACK] = ACTIONS(6180),
    [anon_sym_RBRACK] = ACTIONS(6180),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_EQ] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6180),
    [anon_sym_RPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHpart] = ACTIONS(6178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddpart] = ACTIONS(6178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHchapter] = ACTIONS(6178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddchap] = ACTIONS(6178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsection] = ACTIONS(6178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddsec] = ACTIONS(6178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHitem] = ACTIONS(6178),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6180),
    [anon_sym_LBRACE] = ACTIONS(6180),
    [sym_word] = ACTIONS(6178),
    [sym_placeholder] = ACTIONS(6180),
    [anon_sym_PLUS] = ACTIONS(6180),
    [anon_sym_DASH] = ACTIONS(6180),
    [anon_sym_STAR] = ACTIONS(6180),
    [anon_sym_SLASH] = ACTIONS(6180),
    [anon_sym_LT] = ACTIONS(6178),
    [anon_sym_GT] = ACTIONS(6178),
    [anon_sym_BANG] = ACTIONS(6178),
    [anon_sym_PIPE] = ACTIONS(6178),
    [anon_sym_COLON] = ACTIONS(6178),
    [anon_sym_SQUOTE] = ACTIONS(6178),
    [anon_sym__] = ACTIONS(6180),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6180),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6180),
    [anon_sym_DOLLAR] = ACTIONS(6178),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHbegin] = ACTIONS(6178),
    [anon_sym_BSLASHend] = ACTIONS(6178),
    [anon_sym_BSLASHtitle] = ACTIONS(6178),
    [anon_sym_BSLASHauthor] = ACTIONS(6178),
    [anon_sym_BSLASHusepackage] = ACTIONS(6178),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6178),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6178),
    [anon_sym_BSLASHinclude] = ACTIONS(6178),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6178),
    [anon_sym_BSLASHinput] = ACTIONS(6178),
    [anon_sym_BSLASHsubfile] = ACTIONS(6178),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6178),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6178),
    [anon_sym_BSLASHbibliography] = ACTIONS(6178),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6178),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6178),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6178),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6178),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6178),
    [anon_sym_BSLASHimport] = ACTIONS(6178),
    [anon_sym_BSLASHsubimport] = ACTIONS(6178),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6178),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHcaption] = ACTIONS(6178),
    [anon_sym_BSLASHcite] = ACTIONS(6178),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCite] = ACTIONS(6178),
    [anon_sym_BSLASHnocite] = ACTIONS(6178),
    [anon_sym_BSLASHcitet] = ACTIONS(6178),
    [anon_sym_BSLASHcitep] = ACTIONS(6178),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteA] = ACTIONS(6178),
    [anon_sym_BSLASHciteR] = ACTIONS(6178),
    [anon_sym_BSLASHciteS] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6178),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteyear] = ACTIONS(6178),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitedate] = ACTIONS(6178),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteurl] = ACTIONS(6178),
    [anon_sym_BSLASHfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6178),
    [anon_sym_BSLASHcitealt] = ACTIONS(6178),
    [anon_sym_BSLASHcitealp] = ACTIONS(6178),
    [anon_sym_BSLASHcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHparencite] = ACTIONS(6178),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHParencite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHtextcite] = ACTIONS(6178),
    [anon_sym_BSLASHTextcite] = ACTIONS(6178),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHsupercite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite] = ACTIONS(6178),
    [anon_sym_BSLASHAutocite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHVolcite] = ACTIONS(6178),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHavolcite] = ACTIONS(6178),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHNotecite] = ACTIONS(6178),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHlabel] = ACTIONS(6178),
    [anon_sym_BSLASHref] = ACTIONS(6178),
    [anon_sym_BSLASHeqref] = ACTIONS(6178),
    [anon_sym_BSLASHvref] = ACTIONS(6178),
    [anon_sym_BSLASHVref] = ACTIONS(6178),
    [anon_sym_BSLASHautoref] = ACTIONS(6178),
    [anon_sym_BSLASHpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcref] = ACTIONS(6178),
    [anon_sym_BSLASHCref] = ACTIONS(6178),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnameCref] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHdef] = ACTIONS(6178),
    [anon_sym_BSLASHlet] = ACTIONS(6178),
    [anon_sym_BSLASHleft] = ACTIONS(6178),
    [anon_sym_BSLASHbigl] = ACTIONS(6178),
    [anon_sym_BSLASHBigl] = ACTIONS(6178),
    [anon_sym_BSLASHbiggl] = ACTIONS(6178),
    [anon_sym_BSLASHBiggl] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6178),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6178),
    [anon_sym_BSLASHgls] = ACTIONS(6178),
    [anon_sym_BSLASHGls] = ACTIONS(6178),
    [anon_sym_BSLASHGLS] = ACTIONS(6178),
    [anon_sym_BSLASHglspl] = ACTIONS(6178),
    [anon_sym_BSLASHGlspl] = ACTIONS(6178),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6178),
    [anon_sym_BSLASHglslink] = ACTIONS(6178),
    [anon_sym_BSLASHglstext] = ACTIONS(6178),
    [anon_sym_BSLASHGlstext] = ACTIONS(6178),
    [anon_sym_BSLASHGLStext] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6178),
    [anon_sym_BSLASHglsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsname] = ACTIONS(6178),
    [anon_sym_BSLASHGlsname] = ACTIONS(6178),
    [anon_sym_BSLASHGLSname] = ACTIONS(6178),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6178),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6178),
    [anon_sym_BSLASHacrshort] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6178),
    [anon_sym_BSLASHACRshort] = ACTIONS(6178),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrlong] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6178),
    [anon_sym_BSLASHACRlong] = ACTIONS(6178),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrfull] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6178),
    [anon_sym_BSLASHACRfull] = ACTIONS(6178),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHacs] = ACTIONS(6178),
    [anon_sym_BSLASHAcs] = ACTIONS(6178),
    [anon_sym_BSLASHacsp] = ACTIONS(6178),
    [anon_sym_BSLASHAcsp] = ACTIONS(6178),
    [anon_sym_BSLASHacl] = ACTIONS(6178),
    [anon_sym_BSLASHAcl] = ACTIONS(6178),
    [anon_sym_BSLASHaclp] = ACTIONS(6178),
    [anon_sym_BSLASHAclp] = ACTIONS(6178),
    [anon_sym_BSLASHacf] = ACTIONS(6178),
    [anon_sym_BSLASHAcf] = ACTIONS(6178),
    [anon_sym_BSLASHacfp] = ACTIONS(6178),
    [anon_sym_BSLASHAcfp] = ACTIONS(6178),
    [anon_sym_BSLASHac] = ACTIONS(6178),
    [anon_sym_BSLASHAc] = ACTIONS(6178),
    [anon_sym_BSLASHacp] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6178),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6178),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6178),
    [anon_sym_BSLASHcolor] = ACTIONS(6178),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6178),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6178),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6178),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6178),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6178),
    [anon_sym_BSLASHtext] = ACTIONS(6178),
    [anon_sym_BSLASHintertext] = ACTIONS(6178),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6178),
    [anon_sym_BSLASHurl] = ACTIONS(6178),
    [anon_sym_BSLASHhref] = ACTIONS(6178),
  },
  [1124] = {
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_LBRACK] = ACTIONS(6560),
    [anon_sym_RBRACK] = ACTIONS(6560),
    [anon_sym_COMMA] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHpart] = ACTIONS(6558),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddpart] = ACTIONS(6558),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHchapter] = ACTIONS(6558),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddchap] = ACTIONS(6558),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsection] = ACTIONS(6558),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddsec] = ACTIONS(6558),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHitem] = ACTIONS(6558),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6560),
    [anon_sym_LBRACE] = ACTIONS(6560),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6560),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(6558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHbegin] = ACTIONS(6558),
    [anon_sym_BSLASHend] = ACTIONS(6558),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHleft] = ACTIONS(6558),
    [anon_sym_BSLASHbigl] = ACTIONS(6558),
    [anon_sym_BSLASHBigl] = ACTIONS(6558),
    [anon_sym_BSLASHbiggl] = ACTIONS(6558),
    [anon_sym_BSLASHBiggl] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHtext] = ACTIONS(6558),
    [anon_sym_BSLASHintertext] = ACTIONS(6558),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [1125] = {
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [anon_sym_RPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHpart] = ACTIONS(6198),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddpart] = ACTIONS(6198),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHchapter] = ACTIONS(6198),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddchap] = ACTIONS(6198),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsection] = ACTIONS(6198),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddsec] = ACTIONS(6198),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHitem] = ACTIONS(6198),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6200),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6200),
    [anon_sym_DOLLAR] = ACTIONS(6198),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHbegin] = ACTIONS(6198),
    [anon_sym_BSLASHend] = ACTIONS(6198),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHleft] = ACTIONS(6198),
    [anon_sym_BSLASHbigl] = ACTIONS(6198),
    [anon_sym_BSLASHBigl] = ACTIONS(6198),
    [anon_sym_BSLASHbiggl] = ACTIONS(6198),
    [anon_sym_BSLASHBiggl] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHtext] = ACTIONS(6198),
    [anon_sym_BSLASHintertext] = ACTIONS(6198),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [1126] = {
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(6578),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6578),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_LPAREN] = ACTIONS(6578),
    [anon_sym_RPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHpart] = ACTIONS(6576),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddpart] = ACTIONS(6576),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHchapter] = ACTIONS(6576),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddchap] = ACTIONS(6576),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsection] = ACTIONS(6576),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddsec] = ACTIONS(6576),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHitem] = ACTIONS(6576),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6578),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHbegin] = ACTIONS(6576),
    [anon_sym_BSLASHend] = ACTIONS(6576),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHleft] = ACTIONS(6576),
    [anon_sym_BSLASHbigl] = ACTIONS(6576),
    [anon_sym_BSLASHBigl] = ACTIONS(6576),
    [anon_sym_BSLASHbiggl] = ACTIONS(6576),
    [anon_sym_BSLASHBiggl] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHtext] = ACTIONS(6576),
    [anon_sym_BSLASHintertext] = ACTIONS(6576),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [1127] = {
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHpart] = ACTIONS(6586),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddpart] = ACTIONS(6586),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHchapter] = ACTIONS(6586),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddchap] = ACTIONS(6586),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsection] = ACTIONS(6586),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddsec] = ACTIONS(6586),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHitem] = ACTIONS(6586),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6588),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6588),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHbegin] = ACTIONS(6586),
    [anon_sym_BSLASHend] = ACTIONS(6586),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHleft] = ACTIONS(6586),
    [anon_sym_BSLASHbigl] = ACTIONS(6586),
    [anon_sym_BSLASHBigl] = ACTIONS(6586),
    [anon_sym_BSLASHbiggl] = ACTIONS(6586),
    [anon_sym_BSLASHBiggl] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHtext] = ACTIONS(6586),
    [anon_sym_BSLASHintertext] = ACTIONS(6586),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [1128] = {
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHpart] = ACTIONS(6298),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddpart] = ACTIONS(6298),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHchapter] = ACTIONS(6298),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddchap] = ACTIONS(6298),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsection] = ACTIONS(6298),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddsec] = ACTIONS(6298),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHitem] = ACTIONS(6298),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6300),
    [anon_sym_DOLLAR] = ACTIONS(6298),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6300),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHbegin] = ACTIONS(6298),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHleft] = ACTIONS(6298),
    [anon_sym_BSLASHbigl] = ACTIONS(6298),
    [anon_sym_BSLASHBigl] = ACTIONS(6298),
    [anon_sym_BSLASHbiggl] = ACTIONS(6298),
    [anon_sym_BSLASHBiggl] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHtext] = ACTIONS(6298),
    [anon_sym_BSLASHintertext] = ACTIONS(6298),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [1129] = {
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_LPAREN] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHpart] = ACTIONS(6302),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddpart] = ACTIONS(6302),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHchapter] = ACTIONS(6302),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddchap] = ACTIONS(6302),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsection] = ACTIONS(6302),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddsec] = ACTIONS(6302),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHitem] = ACTIONS(6302),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6304),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6304),
    [anon_sym_DOLLAR] = ACTIONS(6302),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6304),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHbegin] = ACTIONS(6302),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHleft] = ACTIONS(6302),
    [anon_sym_BSLASHbigl] = ACTIONS(6302),
    [anon_sym_BSLASHBigl] = ACTIONS(6302),
    [anon_sym_BSLASHbiggl] = ACTIONS(6302),
    [anon_sym_BSLASHBiggl] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHtext] = ACTIONS(6302),
    [anon_sym_BSLASHintertext] = ACTIONS(6302),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [1130] = {
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6308),
    [anon_sym_RBRACK] = ACTIONS(6308),
    [anon_sym_COMMA] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(6308),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_RPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHpart] = ACTIONS(6306),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddpart] = ACTIONS(6306),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHchapter] = ACTIONS(6306),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddchap] = ACTIONS(6306),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsection] = ACTIONS(6306),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddsec] = ACTIONS(6306),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHitem] = ACTIONS(6306),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6308),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6308),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6308),
    [anon_sym_DOLLAR] = ACTIONS(6306),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6308),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHbegin] = ACTIONS(6306),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHleft] = ACTIONS(6306),
    [anon_sym_BSLASHbigl] = ACTIONS(6306),
    [anon_sym_BSLASHBigl] = ACTIONS(6306),
    [anon_sym_BSLASHbiggl] = ACTIONS(6306),
    [anon_sym_BSLASHBiggl] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHtext] = ACTIONS(6306),
    [anon_sym_BSLASHintertext] = ACTIONS(6306),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [1131] = {
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_RBRACK] = ACTIONS(6340),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_EQ] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHpart] = ACTIONS(6338),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddpart] = ACTIONS(6338),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHchapter] = ACTIONS(6338),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddchap] = ACTIONS(6338),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsection] = ACTIONS(6338),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddsec] = ACTIONS(6338),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHitem] = ACTIONS(6338),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6340),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6340),
    [anon_sym_DOLLAR] = ACTIONS(6338),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6340),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHbegin] = ACTIONS(6338),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHleft] = ACTIONS(6338),
    [anon_sym_BSLASHbigl] = ACTIONS(6338),
    [anon_sym_BSLASHBigl] = ACTIONS(6338),
    [anon_sym_BSLASHbiggl] = ACTIONS(6338),
    [anon_sym_BSLASHBiggl] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHtext] = ACTIONS(6338),
    [anon_sym_BSLASHintertext] = ACTIONS(6338),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [1132] = {
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_RPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHpart] = ACTIONS(6342),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddpart] = ACTIONS(6342),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHchapter] = ACTIONS(6342),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddchap] = ACTIONS(6342),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsection] = ACTIONS(6342),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddsec] = ACTIONS(6342),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHitem] = ACTIONS(6342),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6344),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6344),
    [anon_sym_DOLLAR] = ACTIONS(6342),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6344),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHbegin] = ACTIONS(6342),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHleft] = ACTIONS(6342),
    [anon_sym_BSLASHbigl] = ACTIONS(6342),
    [anon_sym_BSLASHBigl] = ACTIONS(6342),
    [anon_sym_BSLASHbiggl] = ACTIONS(6342),
    [anon_sym_BSLASHBiggl] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHtext] = ACTIONS(6342),
    [anon_sym_BSLASHintertext] = ACTIONS(6342),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [1133] = {
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_RBRACK] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LPAREN] = ACTIONS(6360),
    [anon_sym_RPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHpart] = ACTIONS(6358),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddpart] = ACTIONS(6358),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHchapter] = ACTIONS(6358),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddchap] = ACTIONS(6358),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsection] = ACTIONS(6358),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddsec] = ACTIONS(6358),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHitem] = ACTIONS(6358),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(6360),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6360),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6358),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6360),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHbegin] = ACTIONS(6358),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHleft] = ACTIONS(6358),
    [anon_sym_BSLASHbigl] = ACTIONS(6358),
    [anon_sym_BSLASHBigl] = ACTIONS(6358),
    [anon_sym_BSLASHbiggl] = ACTIONS(6358),
    [anon_sym_BSLASHBiggl] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHtext] = ACTIONS(6358),
    [anon_sym_BSLASHintertext] = ACTIONS(6358),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [1134] = {
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_RBRACK] = ACTIONS(6368),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_LPAREN] = ACTIONS(6368),
    [anon_sym_RPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHpart] = ACTIONS(6366),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddpart] = ACTIONS(6366),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHchapter] = ACTIONS(6366),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddchap] = ACTIONS(6366),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsection] = ACTIONS(6366),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddsec] = ACTIONS(6366),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHitem] = ACTIONS(6366),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6368),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6368),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6366),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6368),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHbegin] = ACTIONS(6366),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHleft] = ACTIONS(6366),
    [anon_sym_BSLASHbigl] = ACTIONS(6366),
    [anon_sym_BSLASHBigl] = ACTIONS(6366),
    [anon_sym_BSLASHbiggl] = ACTIONS(6366),
    [anon_sym_BSLASHBiggl] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHtext] = ACTIONS(6366),
    [anon_sym_BSLASHintertext] = ACTIONS(6366),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [1135] = {
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_RBRACK] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LPAREN] = ACTIONS(6372),
    [anon_sym_RPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHpart] = ACTIONS(6370),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddpart] = ACTIONS(6370),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHchapter] = ACTIONS(6370),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddchap] = ACTIONS(6370),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsection] = ACTIONS(6370),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddsec] = ACTIONS(6370),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHitem] = ACTIONS(6370),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6372),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6370),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6372),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHbegin] = ACTIONS(6370),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHleft] = ACTIONS(6370),
    [anon_sym_BSLASHbigl] = ACTIONS(6370),
    [anon_sym_BSLASHBigl] = ACTIONS(6370),
    [anon_sym_BSLASHbiggl] = ACTIONS(6370),
    [anon_sym_BSLASHBiggl] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHtext] = ACTIONS(6370),
    [anon_sym_BSLASHintertext] = ACTIONS(6370),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [1136] = {
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6460),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_COMMA] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_LPAREN] = ACTIONS(6460),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHpart] = ACTIONS(6458),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddpart] = ACTIONS(6458),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHchapter] = ACTIONS(6458),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddchap] = ACTIONS(6458),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsection] = ACTIONS(6458),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddsec] = ACTIONS(6458),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHitem] = ACTIONS(6458),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6460),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6460),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6460),
    [anon_sym_DOLLAR] = ACTIONS(6458),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6460),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHbegin] = ACTIONS(6458),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHleft] = ACTIONS(6458),
    [anon_sym_BSLASHbigl] = ACTIONS(6458),
    [anon_sym_BSLASHBigl] = ACTIONS(6458),
    [anon_sym_BSLASHbiggl] = ACTIONS(6458),
    [anon_sym_BSLASHBiggl] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHtext] = ACTIONS(6458),
    [anon_sym_BSLASHintertext] = ACTIONS(6458),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [1137] = {
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6464),
    [anon_sym_RBRACK] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_EQ] = ACTIONS(6464),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHpart] = ACTIONS(6462),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddpart] = ACTIONS(6462),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHchapter] = ACTIONS(6462),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddchap] = ACTIONS(6462),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsection] = ACTIONS(6462),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddsec] = ACTIONS(6462),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHitem] = ACTIONS(6462),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6464),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(6462),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6464),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHbegin] = ACTIONS(6462),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHleft] = ACTIONS(6462),
    [anon_sym_BSLASHbigl] = ACTIONS(6462),
    [anon_sym_BSLASHBigl] = ACTIONS(6462),
    [anon_sym_BSLASHbiggl] = ACTIONS(6462),
    [anon_sym_BSLASHBiggl] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHtext] = ACTIONS(6462),
    [anon_sym_BSLASHintertext] = ACTIONS(6462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [1138] = {
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_LBRACK] = ACTIONS(6468),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_COMMA] = ACTIONS(6468),
    [anon_sym_EQ] = ACTIONS(6468),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHpart] = ACTIONS(6466),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddpart] = ACTIONS(6466),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHchapter] = ACTIONS(6466),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddchap] = ACTIONS(6466),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsection] = ACTIONS(6466),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddsec] = ACTIONS(6466),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHitem] = ACTIONS(6466),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6468),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6466),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6468),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHbegin] = ACTIONS(6466),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHleft] = ACTIONS(6466),
    [anon_sym_BSLASHbigl] = ACTIONS(6466),
    [anon_sym_BSLASHBigl] = ACTIONS(6466),
    [anon_sym_BSLASHbiggl] = ACTIONS(6466),
    [anon_sym_BSLASHBiggl] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHtext] = ACTIONS(6466),
    [anon_sym_BSLASHintertext] = ACTIONS(6466),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [1139] = {
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6276),
    [anon_sym_RBRACK] = ACTIONS(6276),
    [anon_sym_COMMA] = ACTIONS(6276),
    [anon_sym_EQ] = ACTIONS(6276),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHpart] = ACTIONS(6274),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddpart] = ACTIONS(6274),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHchapter] = ACTIONS(6274),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddchap] = ACTIONS(6274),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsection] = ACTIONS(6274),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddsec] = ACTIONS(6274),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHitem] = ACTIONS(6274),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6276),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6276),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6276),
    [anon_sym_DOLLAR] = ACTIONS(6274),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHbegin] = ACTIONS(6274),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHleft] = ACTIONS(6274),
    [anon_sym_BSLASHbigl] = ACTIONS(6274),
    [anon_sym_BSLASHBigl] = ACTIONS(6274),
    [anon_sym_BSLASHbiggl] = ACTIONS(6274),
    [anon_sym_BSLASHBiggl] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHtext] = ACTIONS(6274),
    [anon_sym_BSLASHintertext] = ACTIONS(6274),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [1140] = {
    [sym_command_name] = ACTIONS(6594),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6596),
    [anon_sym_LPAREN] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHpart] = ACTIONS(6594),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddpart] = ACTIONS(6594),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHchapter] = ACTIONS(6594),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddchap] = ACTIONS(6594),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsection] = ACTIONS(6594),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddsec] = ACTIONS(6594),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHitem] = ACTIONS(6594),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6596),
    [anon_sym_LBRACE] = ACTIONS(6596),
    [sym_word] = ACTIONS(6594),
    [sym_placeholder] = ACTIONS(6596),
    [anon_sym_PLUS] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6596),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_SLASH] = ACTIONS(6596),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_BANG] = ACTIONS(6594),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SQUOTE] = ACTIONS(6594),
    [anon_sym__] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(6596),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6596),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(6594),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6596),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHbegin] = ACTIONS(6594),
    [anon_sym_BSLASHtitle] = ACTIONS(6594),
    [anon_sym_BSLASHauthor] = ACTIONS(6594),
    [anon_sym_BSLASHusepackage] = ACTIONS(6594),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6594),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6594),
    [anon_sym_BSLASHinclude] = ACTIONS(6594),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6594),
    [anon_sym_BSLASHinput] = ACTIONS(6594),
    [anon_sym_BSLASHsubfile] = ACTIONS(6594),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6594),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6594),
    [anon_sym_BSLASHbibliography] = ACTIONS(6594),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6594),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6594),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6594),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6594),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6594),
    [anon_sym_BSLASHimport] = ACTIONS(6594),
    [anon_sym_BSLASHsubimport] = ACTIONS(6594),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6594),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHcaption] = ACTIONS(6594),
    [anon_sym_BSLASHcite] = ACTIONS(6594),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCite] = ACTIONS(6594),
    [anon_sym_BSLASHnocite] = ACTIONS(6594),
    [anon_sym_BSLASHcitet] = ACTIONS(6594),
    [anon_sym_BSLASHcitep] = ACTIONS(6594),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteA] = ACTIONS(6594),
    [anon_sym_BSLASHciteR] = ACTIONS(6594),
    [anon_sym_BSLASHciteS] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6594),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteyear] = ACTIONS(6594),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitedate] = ACTIONS(6594),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteurl] = ACTIONS(6594),
    [anon_sym_BSLASHfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6594),
    [anon_sym_BSLASHcitealt] = ACTIONS(6594),
    [anon_sym_BSLASHcitealp] = ACTIONS(6594),
    [anon_sym_BSLASHcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHparencite] = ACTIONS(6594),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHParencite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHtextcite] = ACTIONS(6594),
    [anon_sym_BSLASHTextcite] = ACTIONS(6594),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHsupercite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite] = ACTIONS(6594),
    [anon_sym_BSLASHAutocite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHVolcite] = ACTIONS(6594),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHavolcite] = ACTIONS(6594),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHNotecite] = ACTIONS(6594),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHlabel] = ACTIONS(6594),
    [anon_sym_BSLASHref] = ACTIONS(6594),
    [anon_sym_BSLASHeqref] = ACTIONS(6594),
    [anon_sym_BSLASHvref] = ACTIONS(6594),
    [anon_sym_BSLASHVref] = ACTIONS(6594),
    [anon_sym_BSLASHautoref] = ACTIONS(6594),
    [anon_sym_BSLASHpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcref] = ACTIONS(6594),
    [anon_sym_BSLASHCref] = ACTIONS(6594),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnameCref] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHdef] = ACTIONS(6594),
    [anon_sym_BSLASHlet] = ACTIONS(6594),
    [anon_sym_BSLASHleft] = ACTIONS(6594),
    [anon_sym_BSLASHbigl] = ACTIONS(6594),
    [anon_sym_BSLASHBigl] = ACTIONS(6594),
    [anon_sym_BSLASHbiggl] = ACTIONS(6594),
    [anon_sym_BSLASHBiggl] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6594),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6594),
    [anon_sym_BSLASHgls] = ACTIONS(6594),
    [anon_sym_BSLASHGls] = ACTIONS(6594),
    [anon_sym_BSLASHGLS] = ACTIONS(6594),
    [anon_sym_BSLASHglspl] = ACTIONS(6594),
    [anon_sym_BSLASHGlspl] = ACTIONS(6594),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6594),
    [anon_sym_BSLASHglslink] = ACTIONS(6594),
    [anon_sym_BSLASHglstext] = ACTIONS(6594),
    [anon_sym_BSLASHGlstext] = ACTIONS(6594),
    [anon_sym_BSLASHGLStext] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6594),
    [anon_sym_BSLASHglsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsname] = ACTIONS(6594),
    [anon_sym_BSLASHGlsname] = ACTIONS(6594),
    [anon_sym_BSLASHGLSname] = ACTIONS(6594),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6594),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6594),
    [anon_sym_BSLASHacrshort] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6594),
    [anon_sym_BSLASHACRshort] = ACTIONS(6594),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrlong] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6594),
    [anon_sym_BSLASHACRlong] = ACTIONS(6594),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrfull] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6594),
    [anon_sym_BSLASHACRfull] = ACTIONS(6594),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHacs] = ACTIONS(6594),
    [anon_sym_BSLASHAcs] = ACTIONS(6594),
    [anon_sym_BSLASHacsp] = ACTIONS(6594),
    [anon_sym_BSLASHAcsp] = ACTIONS(6594),
    [anon_sym_BSLASHacl] = ACTIONS(6594),
    [anon_sym_BSLASHAcl] = ACTIONS(6594),
    [anon_sym_BSLASHaclp] = ACTIONS(6594),
    [anon_sym_BSLASHAclp] = ACTIONS(6594),
    [anon_sym_BSLASHacf] = ACTIONS(6594),
    [anon_sym_BSLASHAcf] = ACTIONS(6594),
    [anon_sym_BSLASHacfp] = ACTIONS(6594),
    [anon_sym_BSLASHAcfp] = ACTIONS(6594),
    [anon_sym_BSLASHac] = ACTIONS(6594),
    [anon_sym_BSLASHAc] = ACTIONS(6594),
    [anon_sym_BSLASHacp] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6594),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6594),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6594),
    [anon_sym_BSLASHcolor] = ACTIONS(6594),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6594),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6594),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6594),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6594),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6594),
    [anon_sym_BSLASHtext] = ACTIONS(6594),
    [anon_sym_BSLASHintertext] = ACTIONS(6594),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6594),
    [anon_sym_BSLASHurl] = ACTIONS(6594),
    [anon_sym_BSLASHhref] = ACTIONS(6594),
  },
  [1141] = {
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_LBRACK] = ACTIONS(6476),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_RPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHpart] = ACTIONS(6474),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddpart] = ACTIONS(6474),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHchapter] = ACTIONS(6474),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddchap] = ACTIONS(6474),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsection] = ACTIONS(6474),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddsec] = ACTIONS(6474),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHitem] = ACTIONS(6474),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6476),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6476),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6476),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHbegin] = ACTIONS(6474),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHleft] = ACTIONS(6474),
    [anon_sym_BSLASHbigl] = ACTIONS(6474),
    [anon_sym_BSLASHBigl] = ACTIONS(6474),
    [anon_sym_BSLASHbiggl] = ACTIONS(6474),
    [anon_sym_BSLASHBiggl] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHtext] = ACTIONS(6474),
    [anon_sym_BSLASHintertext] = ACTIONS(6474),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [1142] = {
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6480),
    [anon_sym_EQ] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6480),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHpart] = ACTIONS(6478),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddpart] = ACTIONS(6478),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHchapter] = ACTIONS(6478),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddchap] = ACTIONS(6478),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsection] = ACTIONS(6478),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddsec] = ACTIONS(6478),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHitem] = ACTIONS(6478),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6480),
    [anon_sym_DOLLAR] = ACTIONS(6478),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6480),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHbegin] = ACTIONS(6478),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHleft] = ACTIONS(6478),
    [anon_sym_BSLASHbigl] = ACTIONS(6478),
    [anon_sym_BSLASHBigl] = ACTIONS(6478),
    [anon_sym_BSLASHbiggl] = ACTIONS(6478),
    [anon_sym_BSLASHBiggl] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHtext] = ACTIONS(6478),
    [anon_sym_BSLASHintertext] = ACTIONS(6478),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [1143] = {
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6484),
    [anon_sym_RBRACK] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6484),
    [anon_sym_EQ] = ACTIONS(6484),
    [anon_sym_LPAREN] = ACTIONS(6484),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHpart] = ACTIONS(6482),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddpart] = ACTIONS(6482),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHchapter] = ACTIONS(6482),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddchap] = ACTIONS(6482),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsection] = ACTIONS(6482),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddsec] = ACTIONS(6482),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHitem] = ACTIONS(6482),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6484),
    [anon_sym_LBRACE] = ACTIONS(6484),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6484),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6484),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6484),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHbegin] = ACTIONS(6482),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHleft] = ACTIONS(6482),
    [anon_sym_BSLASHbigl] = ACTIONS(6482),
    [anon_sym_BSLASHBigl] = ACTIONS(6482),
    [anon_sym_BSLASHbiggl] = ACTIONS(6482),
    [anon_sym_BSLASHBiggl] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHtext] = ACTIONS(6482),
    [anon_sym_BSLASHintertext] = ACTIONS(6482),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [1144] = {
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_LBRACK] = ACTIONS(6488),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_COMMA] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6488),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHpart] = ACTIONS(6486),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddpart] = ACTIONS(6486),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHchapter] = ACTIONS(6486),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddchap] = ACTIONS(6486),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsection] = ACTIONS(6486),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddsec] = ACTIONS(6486),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHitem] = ACTIONS(6486),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6488),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(6486),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6488),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHbegin] = ACTIONS(6486),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHleft] = ACTIONS(6486),
    [anon_sym_BSLASHbigl] = ACTIONS(6486),
    [anon_sym_BSLASHBigl] = ACTIONS(6486),
    [anon_sym_BSLASHbiggl] = ACTIONS(6486),
    [anon_sym_BSLASHBiggl] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHtext] = ACTIONS(6486),
    [anon_sym_BSLASHintertext] = ACTIONS(6486),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [1145] = {
    [sym_command_name] = ACTIONS(6670),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6670),
    [anon_sym_LBRACK] = ACTIONS(6672),
    [anon_sym_RBRACK] = ACTIONS(6672),
    [anon_sym_COMMA] = ACTIONS(6672),
    [anon_sym_EQ] = ACTIONS(6672),
    [anon_sym_LPAREN] = ACTIONS(6672),
    [anon_sym_RPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHpart] = ACTIONS(6670),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddpart] = ACTIONS(6670),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHchapter] = ACTIONS(6670),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddchap] = ACTIONS(6670),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsection] = ACTIONS(6670),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddsec] = ACTIONS(6670),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHitem] = ACTIONS(6670),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6672),
    [anon_sym_LBRACE] = ACTIONS(6672),
    [sym_word] = ACTIONS(6670),
    [sym_placeholder] = ACTIONS(6672),
    [anon_sym_PLUS] = ACTIONS(6672),
    [anon_sym_DASH] = ACTIONS(6672),
    [anon_sym_STAR] = ACTIONS(6672),
    [anon_sym_SLASH] = ACTIONS(6672),
    [anon_sym_LT] = ACTIONS(6670),
    [anon_sym_GT] = ACTIONS(6670),
    [anon_sym_BANG] = ACTIONS(6670),
    [anon_sym_PIPE] = ACTIONS(6670),
    [anon_sym_COLON] = ACTIONS(6670),
    [anon_sym_SQUOTE] = ACTIONS(6670),
    [anon_sym__] = ACTIONS(6672),
    [anon_sym_CARET] = ACTIONS(6672),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6672),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6672),
    [anon_sym_DOLLAR] = ACTIONS(6670),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6672),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHbegin] = ACTIONS(6670),
    [anon_sym_BSLASHtitle] = ACTIONS(6670),
    [anon_sym_BSLASHauthor] = ACTIONS(6670),
    [anon_sym_BSLASHusepackage] = ACTIONS(6670),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6670),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6670),
    [anon_sym_BSLASHinclude] = ACTIONS(6670),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6670),
    [anon_sym_BSLASHinput] = ACTIONS(6670),
    [anon_sym_BSLASHsubfile] = ACTIONS(6670),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6670),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6670),
    [anon_sym_BSLASHbibliography] = ACTIONS(6670),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6670),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6670),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6670),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6670),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6670),
    [anon_sym_BSLASHimport] = ACTIONS(6670),
    [anon_sym_BSLASHsubimport] = ACTIONS(6670),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6670),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHcaption] = ACTIONS(6670),
    [anon_sym_BSLASHcite] = ACTIONS(6670),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCite] = ACTIONS(6670),
    [anon_sym_BSLASHnocite] = ACTIONS(6670),
    [anon_sym_BSLASHcitet] = ACTIONS(6670),
    [anon_sym_BSLASHcitep] = ACTIONS(6670),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteA] = ACTIONS(6670),
    [anon_sym_BSLASHciteR] = ACTIONS(6670),
    [anon_sym_BSLASHciteS] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6670),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteyear] = ACTIONS(6670),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitedate] = ACTIONS(6670),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteurl] = ACTIONS(6670),
    [anon_sym_BSLASHfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6670),
    [anon_sym_BSLASHcitealt] = ACTIONS(6670),
    [anon_sym_BSLASHcitealp] = ACTIONS(6670),
    [anon_sym_BSLASHcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHparencite] = ACTIONS(6670),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHParencite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHtextcite] = ACTIONS(6670),
    [anon_sym_BSLASHTextcite] = ACTIONS(6670),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHsupercite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite] = ACTIONS(6670),
    [anon_sym_BSLASHAutocite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHVolcite] = ACTIONS(6670),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHavolcite] = ACTIONS(6670),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHNotecite] = ACTIONS(6670),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHlabel] = ACTIONS(6670),
    [anon_sym_BSLASHref] = ACTIONS(6670),
    [anon_sym_BSLASHeqref] = ACTIONS(6670),
    [anon_sym_BSLASHvref] = ACTIONS(6670),
    [anon_sym_BSLASHVref] = ACTIONS(6670),
    [anon_sym_BSLASHautoref] = ACTIONS(6670),
    [anon_sym_BSLASHpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcref] = ACTIONS(6670),
    [anon_sym_BSLASHCref] = ACTIONS(6670),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnameCref] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHdef] = ACTIONS(6670),
    [anon_sym_BSLASHlet] = ACTIONS(6670),
    [anon_sym_BSLASHleft] = ACTIONS(6670),
    [anon_sym_BSLASHbigl] = ACTIONS(6670),
    [anon_sym_BSLASHBigl] = ACTIONS(6670),
    [anon_sym_BSLASHbiggl] = ACTIONS(6670),
    [anon_sym_BSLASHBiggl] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6670),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6670),
    [anon_sym_BSLASHgls] = ACTIONS(6670),
    [anon_sym_BSLASHGls] = ACTIONS(6670),
    [anon_sym_BSLASHGLS] = ACTIONS(6670),
    [anon_sym_BSLASHglspl] = ACTIONS(6670),
    [anon_sym_BSLASHGlspl] = ACTIONS(6670),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6670),
    [anon_sym_BSLASHglslink] = ACTIONS(6670),
    [anon_sym_BSLASHglstext] = ACTIONS(6670),
    [anon_sym_BSLASHGlstext] = ACTIONS(6670),
    [anon_sym_BSLASHGLStext] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6670),
    [anon_sym_BSLASHglsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsname] = ACTIONS(6670),
    [anon_sym_BSLASHGlsname] = ACTIONS(6670),
    [anon_sym_BSLASHGLSname] = ACTIONS(6670),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6670),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6670),
    [anon_sym_BSLASHacrshort] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6670),
    [anon_sym_BSLASHACRshort] = ACTIONS(6670),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrlong] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6670),
    [anon_sym_BSLASHACRlong] = ACTIONS(6670),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrfull] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6670),
    [anon_sym_BSLASHACRfull] = ACTIONS(6670),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHacs] = ACTIONS(6670),
    [anon_sym_BSLASHAcs] = ACTIONS(6670),
    [anon_sym_BSLASHacsp] = ACTIONS(6670),
    [anon_sym_BSLASHAcsp] = ACTIONS(6670),
    [anon_sym_BSLASHacl] = ACTIONS(6670),
    [anon_sym_BSLASHAcl] = ACTIONS(6670),
    [anon_sym_BSLASHaclp] = ACTIONS(6670),
    [anon_sym_BSLASHAclp] = ACTIONS(6670),
    [anon_sym_BSLASHacf] = ACTIONS(6670),
    [anon_sym_BSLASHAcf] = ACTIONS(6670),
    [anon_sym_BSLASHacfp] = ACTIONS(6670),
    [anon_sym_BSLASHAcfp] = ACTIONS(6670),
    [anon_sym_BSLASHac] = ACTIONS(6670),
    [anon_sym_BSLASHAc] = ACTIONS(6670),
    [anon_sym_BSLASHacp] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6670),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6670),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6670),
    [anon_sym_BSLASHcolor] = ACTIONS(6670),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6670),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6670),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6670),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6670),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6670),
    [anon_sym_BSLASHtext] = ACTIONS(6670),
    [anon_sym_BSLASHintertext] = ACTIONS(6670),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6670),
    [anon_sym_BSLASHurl] = ACTIONS(6670),
    [anon_sym_BSLASHhref] = ACTIONS(6670),
  },
  [1146] = {
    [sym_command_name] = ACTIONS(6714),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6714),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_RBRACK] = ACTIONS(6716),
    [anon_sym_COMMA] = ACTIONS(6716),
    [anon_sym_EQ] = ACTIONS(6716),
    [anon_sym_LPAREN] = ACTIONS(6716),
    [anon_sym_RPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHpart] = ACTIONS(6714),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddpart] = ACTIONS(6714),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHchapter] = ACTIONS(6714),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddchap] = ACTIONS(6714),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsection] = ACTIONS(6714),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddsec] = ACTIONS(6714),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHitem] = ACTIONS(6714),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(6716),
    [sym_word] = ACTIONS(6714),
    [sym_placeholder] = ACTIONS(6716),
    [anon_sym_PLUS] = ACTIONS(6716),
    [anon_sym_DASH] = ACTIONS(6716),
    [anon_sym_STAR] = ACTIONS(6716),
    [anon_sym_SLASH] = ACTIONS(6716),
    [anon_sym_LT] = ACTIONS(6714),
    [anon_sym_GT] = ACTIONS(6714),
    [anon_sym_BANG] = ACTIONS(6714),
    [anon_sym_PIPE] = ACTIONS(6714),
    [anon_sym_COLON] = ACTIONS(6714),
    [anon_sym_SQUOTE] = ACTIONS(6714),
    [anon_sym__] = ACTIONS(6716),
    [anon_sym_CARET] = ACTIONS(6716),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6716),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6716),
    [anon_sym_DOLLAR] = ACTIONS(6714),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6716),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHbegin] = ACTIONS(6714),
    [anon_sym_BSLASHtitle] = ACTIONS(6714),
    [anon_sym_BSLASHauthor] = ACTIONS(6714),
    [anon_sym_BSLASHusepackage] = ACTIONS(6714),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6714),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6714),
    [anon_sym_BSLASHinclude] = ACTIONS(6714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6714),
    [anon_sym_BSLASHinput] = ACTIONS(6714),
    [anon_sym_BSLASHsubfile] = ACTIONS(6714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6714),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6714),
    [anon_sym_BSLASHbibliography] = ACTIONS(6714),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6714),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6714),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6714),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6714),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6714),
    [anon_sym_BSLASHimport] = ACTIONS(6714),
    [anon_sym_BSLASHsubimport] = ACTIONS(6714),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6714),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHcaption] = ACTIONS(6714),
    [anon_sym_BSLASHcite] = ACTIONS(6714),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCite] = ACTIONS(6714),
    [anon_sym_BSLASHnocite] = ACTIONS(6714),
    [anon_sym_BSLASHcitet] = ACTIONS(6714),
    [anon_sym_BSLASHcitep] = ACTIONS(6714),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteA] = ACTIONS(6714),
    [anon_sym_BSLASHciteR] = ACTIONS(6714),
    [anon_sym_BSLASHciteS] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6714),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteyear] = ACTIONS(6714),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitedate] = ACTIONS(6714),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteurl] = ACTIONS(6714),
    [anon_sym_BSLASHfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6714),
    [anon_sym_BSLASHcitealt] = ACTIONS(6714),
    [anon_sym_BSLASHcitealp] = ACTIONS(6714),
    [anon_sym_BSLASHcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHparencite] = ACTIONS(6714),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHParencite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHtextcite] = ACTIONS(6714),
    [anon_sym_BSLASHTextcite] = ACTIONS(6714),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHsupercite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite] = ACTIONS(6714),
    [anon_sym_BSLASHAutocite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHVolcite] = ACTIONS(6714),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHavolcite] = ACTIONS(6714),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHNotecite] = ACTIONS(6714),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHlabel] = ACTIONS(6714),
    [anon_sym_BSLASHref] = ACTIONS(6714),
    [anon_sym_BSLASHeqref] = ACTIONS(6714),
    [anon_sym_BSLASHvref] = ACTIONS(6714),
    [anon_sym_BSLASHVref] = ACTIONS(6714),
    [anon_sym_BSLASHautoref] = ACTIONS(6714),
    [anon_sym_BSLASHpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcref] = ACTIONS(6714),
    [anon_sym_BSLASHCref] = ACTIONS(6714),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnameCref] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHdef] = ACTIONS(6714),
    [anon_sym_BSLASHlet] = ACTIONS(6714),
    [anon_sym_BSLASHleft] = ACTIONS(6714),
    [anon_sym_BSLASHbigl] = ACTIONS(6714),
    [anon_sym_BSLASHBigl] = ACTIONS(6714),
    [anon_sym_BSLASHbiggl] = ACTIONS(6714),
    [anon_sym_BSLASHBiggl] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6714),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6714),
    [anon_sym_BSLASHgls] = ACTIONS(6714),
    [anon_sym_BSLASHGls] = ACTIONS(6714),
    [anon_sym_BSLASHGLS] = ACTIONS(6714),
    [anon_sym_BSLASHglspl] = ACTIONS(6714),
    [anon_sym_BSLASHGlspl] = ACTIONS(6714),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6714),
    [anon_sym_BSLASHglslink] = ACTIONS(6714),
    [anon_sym_BSLASHglstext] = ACTIONS(6714),
    [anon_sym_BSLASHGlstext] = ACTIONS(6714),
    [anon_sym_BSLASHGLStext] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6714),
    [anon_sym_BSLASHglsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsname] = ACTIONS(6714),
    [anon_sym_BSLASHGlsname] = ACTIONS(6714),
    [anon_sym_BSLASHGLSname] = ACTIONS(6714),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6714),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6714),
    [anon_sym_BSLASHacrshort] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6714),
    [anon_sym_BSLASHACRshort] = ACTIONS(6714),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrlong] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6714),
    [anon_sym_BSLASHACRlong] = ACTIONS(6714),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrfull] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6714),
    [anon_sym_BSLASHACRfull] = ACTIONS(6714),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHacs] = ACTIONS(6714),
    [anon_sym_BSLASHAcs] = ACTIONS(6714),
    [anon_sym_BSLASHacsp] = ACTIONS(6714),
    [anon_sym_BSLASHAcsp] = ACTIONS(6714),
    [anon_sym_BSLASHacl] = ACTIONS(6714),
    [anon_sym_BSLASHAcl] = ACTIONS(6714),
    [anon_sym_BSLASHaclp] = ACTIONS(6714),
    [anon_sym_BSLASHAclp] = ACTIONS(6714),
    [anon_sym_BSLASHacf] = ACTIONS(6714),
    [anon_sym_BSLASHAcf] = ACTIONS(6714),
    [anon_sym_BSLASHacfp] = ACTIONS(6714),
    [anon_sym_BSLASHAcfp] = ACTIONS(6714),
    [anon_sym_BSLASHac] = ACTIONS(6714),
    [anon_sym_BSLASHAc] = ACTIONS(6714),
    [anon_sym_BSLASHacp] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6714),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6714),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6714),
    [anon_sym_BSLASHcolor] = ACTIONS(6714),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6714),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6714),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6714),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6714),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6714),
    [anon_sym_BSLASHtext] = ACTIONS(6714),
    [anon_sym_BSLASHintertext] = ACTIONS(6714),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6714),
    [anon_sym_BSLASHurl] = ACTIONS(6714),
    [anon_sym_BSLASHhref] = ACTIONS(6714),
  },
  [1147] = {
    [sym_command_name] = ACTIONS(6590),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6590),
    [anon_sym_LBRACK] = ACTIONS(6592),
    [anon_sym_RBRACK] = ACTIONS(6592),
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(6592),
    [anon_sym_LPAREN] = ACTIONS(6592),
    [anon_sym_RPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHpart] = ACTIONS(6590),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddpart] = ACTIONS(6590),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHchapter] = ACTIONS(6590),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddchap] = ACTIONS(6590),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsection] = ACTIONS(6590),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddsec] = ACTIONS(6590),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHitem] = ACTIONS(6590),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6592),
    [anon_sym_LBRACE] = ACTIONS(6592),
    [sym_word] = ACTIONS(6590),
    [sym_placeholder] = ACTIONS(6592),
    [anon_sym_PLUS] = ACTIONS(6592),
    [anon_sym_DASH] = ACTIONS(6592),
    [anon_sym_STAR] = ACTIONS(6592),
    [anon_sym_SLASH] = ACTIONS(6592),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6592),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6592),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6592),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6592),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHbegin] = ACTIONS(6590),
    [anon_sym_BSLASHtitle] = ACTIONS(6590),
    [anon_sym_BSLASHauthor] = ACTIONS(6590),
    [anon_sym_BSLASHusepackage] = ACTIONS(6590),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6590),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6590),
    [anon_sym_BSLASHinclude] = ACTIONS(6590),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6590),
    [anon_sym_BSLASHinput] = ACTIONS(6590),
    [anon_sym_BSLASHsubfile] = ACTIONS(6590),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6590),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6590),
    [anon_sym_BSLASHbibliography] = ACTIONS(6590),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6590),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6590),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6590),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6590),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6590),
    [anon_sym_BSLASHimport] = ACTIONS(6590),
    [anon_sym_BSLASHsubimport] = ACTIONS(6590),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6590),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHcaption] = ACTIONS(6590),
    [anon_sym_BSLASHcite] = ACTIONS(6590),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCite] = ACTIONS(6590),
    [anon_sym_BSLASHnocite] = ACTIONS(6590),
    [anon_sym_BSLASHcitet] = ACTIONS(6590),
    [anon_sym_BSLASHcitep] = ACTIONS(6590),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteA] = ACTIONS(6590),
    [anon_sym_BSLASHciteR] = ACTIONS(6590),
    [anon_sym_BSLASHciteS] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6590),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteyear] = ACTIONS(6590),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitedate] = ACTIONS(6590),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteurl] = ACTIONS(6590),
    [anon_sym_BSLASHfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6590),
    [anon_sym_BSLASHcitealt] = ACTIONS(6590),
    [anon_sym_BSLASHcitealp] = ACTIONS(6590),
    [anon_sym_BSLASHcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHparencite] = ACTIONS(6590),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHParencite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHtextcite] = ACTIONS(6590),
    [anon_sym_BSLASHTextcite] = ACTIONS(6590),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHsupercite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite] = ACTIONS(6590),
    [anon_sym_BSLASHAutocite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHVolcite] = ACTIONS(6590),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHavolcite] = ACTIONS(6590),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHNotecite] = ACTIONS(6590),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHlabel] = ACTIONS(6590),
    [anon_sym_BSLASHref] = ACTIONS(6590),
    [anon_sym_BSLASHeqref] = ACTIONS(6590),
    [anon_sym_BSLASHvref] = ACTIONS(6590),
    [anon_sym_BSLASHVref] = ACTIONS(6590),
    [anon_sym_BSLASHautoref] = ACTIONS(6590),
    [anon_sym_BSLASHpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcref] = ACTIONS(6590),
    [anon_sym_BSLASHCref] = ACTIONS(6590),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnameCref] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHdef] = ACTIONS(6590),
    [anon_sym_BSLASHlet] = ACTIONS(6590),
    [anon_sym_BSLASHleft] = ACTIONS(6590),
    [anon_sym_BSLASHbigl] = ACTIONS(6590),
    [anon_sym_BSLASHBigl] = ACTIONS(6590),
    [anon_sym_BSLASHbiggl] = ACTIONS(6590),
    [anon_sym_BSLASHBiggl] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6590),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6590),
    [anon_sym_BSLASHgls] = ACTIONS(6590),
    [anon_sym_BSLASHGls] = ACTIONS(6590),
    [anon_sym_BSLASHGLS] = ACTIONS(6590),
    [anon_sym_BSLASHglspl] = ACTIONS(6590),
    [anon_sym_BSLASHGlspl] = ACTIONS(6590),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6590),
    [anon_sym_BSLASHglslink] = ACTIONS(6590),
    [anon_sym_BSLASHglstext] = ACTIONS(6590),
    [anon_sym_BSLASHGlstext] = ACTIONS(6590),
    [anon_sym_BSLASHGLStext] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6590),
    [anon_sym_BSLASHglsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsname] = ACTIONS(6590),
    [anon_sym_BSLASHGlsname] = ACTIONS(6590),
    [anon_sym_BSLASHGLSname] = ACTIONS(6590),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6590),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6590),
    [anon_sym_BSLASHacrshort] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6590),
    [anon_sym_BSLASHACRshort] = ACTIONS(6590),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrlong] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6590),
    [anon_sym_BSLASHACRlong] = ACTIONS(6590),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrfull] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6590),
    [anon_sym_BSLASHACRfull] = ACTIONS(6590),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHacs] = ACTIONS(6590),
    [anon_sym_BSLASHAcs] = ACTIONS(6590),
    [anon_sym_BSLASHacsp] = ACTIONS(6590),
    [anon_sym_BSLASHAcsp] = ACTIONS(6590),
    [anon_sym_BSLASHacl] = ACTIONS(6590),
    [anon_sym_BSLASHAcl] = ACTIONS(6590),
    [anon_sym_BSLASHaclp] = ACTIONS(6590),
    [anon_sym_BSLASHAclp] = ACTIONS(6590),
    [anon_sym_BSLASHacf] = ACTIONS(6590),
    [anon_sym_BSLASHAcf] = ACTIONS(6590),
    [anon_sym_BSLASHacfp] = ACTIONS(6590),
    [anon_sym_BSLASHAcfp] = ACTIONS(6590),
    [anon_sym_BSLASHac] = ACTIONS(6590),
    [anon_sym_BSLASHAc] = ACTIONS(6590),
    [anon_sym_BSLASHacp] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6590),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6590),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6590),
    [anon_sym_BSLASHcolor] = ACTIONS(6590),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6590),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6590),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6590),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6590),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6590),
    [anon_sym_BSLASHtext] = ACTIONS(6590),
    [anon_sym_BSLASHintertext] = ACTIONS(6590),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6590),
    [anon_sym_BSLASHurl] = ACTIONS(6590),
    [anon_sym_BSLASHhref] = ACTIONS(6590),
  },
  [1148] = {
    [sym_command_name] = ACTIONS(6598),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6598),
    [anon_sym_LBRACK] = ACTIONS(6600),
    [anon_sym_RBRACK] = ACTIONS(6600),
    [anon_sym_COMMA] = ACTIONS(6600),
    [anon_sym_EQ] = ACTIONS(6600),
    [anon_sym_LPAREN] = ACTIONS(6600),
    [anon_sym_RPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHpart] = ACTIONS(6598),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddpart] = ACTIONS(6598),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHchapter] = ACTIONS(6598),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddchap] = ACTIONS(6598),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsection] = ACTIONS(6598),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddsec] = ACTIONS(6598),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHitem] = ACTIONS(6598),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6600),
    [anon_sym_LBRACE] = ACTIONS(6600),
    [sym_word] = ACTIONS(6598),
    [sym_placeholder] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6600),
    [anon_sym_DASH] = ACTIONS(6600),
    [anon_sym_STAR] = ACTIONS(6600),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_BANG] = ACTIONS(6598),
    [anon_sym_PIPE] = ACTIONS(6598),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_SQUOTE] = ACTIONS(6598),
    [anon_sym__] = ACTIONS(6600),
    [anon_sym_CARET] = ACTIONS(6600),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6600),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6600),
    [anon_sym_DOLLAR] = ACTIONS(6598),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6600),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHbegin] = ACTIONS(6598),
    [anon_sym_BSLASHtitle] = ACTIONS(6598),
    [anon_sym_BSLASHauthor] = ACTIONS(6598),
    [anon_sym_BSLASHusepackage] = ACTIONS(6598),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6598),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6598),
    [anon_sym_BSLASHinclude] = ACTIONS(6598),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6598),
    [anon_sym_BSLASHinput] = ACTIONS(6598),
    [anon_sym_BSLASHsubfile] = ACTIONS(6598),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6598),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6598),
    [anon_sym_BSLASHbibliography] = ACTIONS(6598),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6598),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6598),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6598),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6598),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6598),
    [anon_sym_BSLASHimport] = ACTIONS(6598),
    [anon_sym_BSLASHsubimport] = ACTIONS(6598),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6598),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHcaption] = ACTIONS(6598),
    [anon_sym_BSLASHcite] = ACTIONS(6598),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCite] = ACTIONS(6598),
    [anon_sym_BSLASHnocite] = ACTIONS(6598),
    [anon_sym_BSLASHcitet] = ACTIONS(6598),
    [anon_sym_BSLASHcitep] = ACTIONS(6598),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteA] = ACTIONS(6598),
    [anon_sym_BSLASHciteR] = ACTIONS(6598),
    [anon_sym_BSLASHciteS] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6598),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteyear] = ACTIONS(6598),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitedate] = ACTIONS(6598),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteurl] = ACTIONS(6598),
    [anon_sym_BSLASHfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6598),
    [anon_sym_BSLASHcitealt] = ACTIONS(6598),
    [anon_sym_BSLASHcitealp] = ACTIONS(6598),
    [anon_sym_BSLASHcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHparencite] = ACTIONS(6598),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHParencite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHtextcite] = ACTIONS(6598),
    [anon_sym_BSLASHTextcite] = ACTIONS(6598),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHsupercite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite] = ACTIONS(6598),
    [anon_sym_BSLASHAutocite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHVolcite] = ACTIONS(6598),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHavolcite] = ACTIONS(6598),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHNotecite] = ACTIONS(6598),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHlabel] = ACTIONS(6598),
    [anon_sym_BSLASHref] = ACTIONS(6598),
    [anon_sym_BSLASHeqref] = ACTIONS(6598),
    [anon_sym_BSLASHvref] = ACTIONS(6598),
    [anon_sym_BSLASHVref] = ACTIONS(6598),
    [anon_sym_BSLASHautoref] = ACTIONS(6598),
    [anon_sym_BSLASHpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcref] = ACTIONS(6598),
    [anon_sym_BSLASHCref] = ACTIONS(6598),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnameCref] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHdef] = ACTIONS(6598),
    [anon_sym_BSLASHlet] = ACTIONS(6598),
    [anon_sym_BSLASHleft] = ACTIONS(6598),
    [anon_sym_BSLASHbigl] = ACTIONS(6598),
    [anon_sym_BSLASHBigl] = ACTIONS(6598),
    [anon_sym_BSLASHbiggl] = ACTIONS(6598),
    [anon_sym_BSLASHBiggl] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6598),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6598),
    [anon_sym_BSLASHgls] = ACTIONS(6598),
    [anon_sym_BSLASHGls] = ACTIONS(6598),
    [anon_sym_BSLASHGLS] = ACTIONS(6598),
    [anon_sym_BSLASHglspl] = ACTIONS(6598),
    [anon_sym_BSLASHGlspl] = ACTIONS(6598),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6598),
    [anon_sym_BSLASHglslink] = ACTIONS(6598),
    [anon_sym_BSLASHglstext] = ACTIONS(6598),
    [anon_sym_BSLASHGlstext] = ACTIONS(6598),
    [anon_sym_BSLASHGLStext] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6598),
    [anon_sym_BSLASHglsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsname] = ACTIONS(6598),
    [anon_sym_BSLASHGlsname] = ACTIONS(6598),
    [anon_sym_BSLASHGLSname] = ACTIONS(6598),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6598),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6598),
    [anon_sym_BSLASHacrshort] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6598),
    [anon_sym_BSLASHACRshort] = ACTIONS(6598),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrlong] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6598),
    [anon_sym_BSLASHACRlong] = ACTIONS(6598),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrfull] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6598),
    [anon_sym_BSLASHACRfull] = ACTIONS(6598),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHacs] = ACTIONS(6598),
    [anon_sym_BSLASHAcs] = ACTIONS(6598),
    [anon_sym_BSLASHacsp] = ACTIONS(6598),
    [anon_sym_BSLASHAcsp] = ACTIONS(6598),
    [anon_sym_BSLASHacl] = ACTIONS(6598),
    [anon_sym_BSLASHAcl] = ACTIONS(6598),
    [anon_sym_BSLASHaclp] = ACTIONS(6598),
    [anon_sym_BSLASHAclp] = ACTIONS(6598),
    [anon_sym_BSLASHacf] = ACTIONS(6598),
    [anon_sym_BSLASHAcf] = ACTIONS(6598),
    [anon_sym_BSLASHacfp] = ACTIONS(6598),
    [anon_sym_BSLASHAcfp] = ACTIONS(6598),
    [anon_sym_BSLASHac] = ACTIONS(6598),
    [anon_sym_BSLASHAc] = ACTIONS(6598),
    [anon_sym_BSLASHacp] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6598),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6598),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6598),
    [anon_sym_BSLASHcolor] = ACTIONS(6598),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6598),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6598),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6598),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6598),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6598),
    [anon_sym_BSLASHtext] = ACTIONS(6598),
    [anon_sym_BSLASHintertext] = ACTIONS(6598),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6598),
    [anon_sym_BSLASHurl] = ACTIONS(6598),
    [anon_sym_BSLASHhref] = ACTIONS(6598),
  },
  [1149] = {
    [sym_command_name] = ACTIONS(6626),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6628),
    [anon_sym_RBRACK] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LPAREN] = ACTIONS(6628),
    [anon_sym_RPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHpart] = ACTIONS(6626),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddpart] = ACTIONS(6626),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHchapter] = ACTIONS(6626),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddchap] = ACTIONS(6626),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsection] = ACTIONS(6626),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddsec] = ACTIONS(6626),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHitem] = ACTIONS(6626),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6628),
    [anon_sym_LBRACE] = ACTIONS(6628),
    [sym_word] = ACTIONS(6626),
    [sym_placeholder] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_DASH] = ACTIONS(6628),
    [anon_sym_STAR] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6626),
    [anon_sym_GT] = ACTIONS(6626),
    [anon_sym_BANG] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6626),
    [anon_sym_COLON] = ACTIONS(6626),
    [anon_sym_SQUOTE] = ACTIONS(6626),
    [anon_sym__] = ACTIONS(6628),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6628),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6628),
    [anon_sym_DOLLAR] = ACTIONS(6626),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6628),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHbegin] = ACTIONS(6626),
    [anon_sym_BSLASHtitle] = ACTIONS(6626),
    [anon_sym_BSLASHauthor] = ACTIONS(6626),
    [anon_sym_BSLASHusepackage] = ACTIONS(6626),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6626),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6626),
    [anon_sym_BSLASHinclude] = ACTIONS(6626),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6626),
    [anon_sym_BSLASHinput] = ACTIONS(6626),
    [anon_sym_BSLASHsubfile] = ACTIONS(6626),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6626),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6626),
    [anon_sym_BSLASHbibliography] = ACTIONS(6626),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6626),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6626),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6626),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6626),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6626),
    [anon_sym_BSLASHimport] = ACTIONS(6626),
    [anon_sym_BSLASHsubimport] = ACTIONS(6626),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6626),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHcaption] = ACTIONS(6626),
    [anon_sym_BSLASHcite] = ACTIONS(6626),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCite] = ACTIONS(6626),
    [anon_sym_BSLASHnocite] = ACTIONS(6626),
    [anon_sym_BSLASHcitet] = ACTIONS(6626),
    [anon_sym_BSLASHcitep] = ACTIONS(6626),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteA] = ACTIONS(6626),
    [anon_sym_BSLASHciteR] = ACTIONS(6626),
    [anon_sym_BSLASHciteS] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6626),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteyear] = ACTIONS(6626),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitedate] = ACTIONS(6626),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteurl] = ACTIONS(6626),
    [anon_sym_BSLASHfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6626),
    [anon_sym_BSLASHcitealt] = ACTIONS(6626),
    [anon_sym_BSLASHcitealp] = ACTIONS(6626),
    [anon_sym_BSLASHcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHparencite] = ACTIONS(6626),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHParencite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHtextcite] = ACTIONS(6626),
    [anon_sym_BSLASHTextcite] = ACTIONS(6626),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHsupercite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite] = ACTIONS(6626),
    [anon_sym_BSLASHAutocite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHVolcite] = ACTIONS(6626),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHavolcite] = ACTIONS(6626),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHNotecite] = ACTIONS(6626),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHlabel] = ACTIONS(6626),
    [anon_sym_BSLASHref] = ACTIONS(6626),
    [anon_sym_BSLASHeqref] = ACTIONS(6626),
    [anon_sym_BSLASHvref] = ACTIONS(6626),
    [anon_sym_BSLASHVref] = ACTIONS(6626),
    [anon_sym_BSLASHautoref] = ACTIONS(6626),
    [anon_sym_BSLASHpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcref] = ACTIONS(6626),
    [anon_sym_BSLASHCref] = ACTIONS(6626),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnameCref] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHdef] = ACTIONS(6626),
    [anon_sym_BSLASHlet] = ACTIONS(6626),
    [anon_sym_BSLASHleft] = ACTIONS(6626),
    [anon_sym_BSLASHbigl] = ACTIONS(6626),
    [anon_sym_BSLASHBigl] = ACTIONS(6626),
    [anon_sym_BSLASHbiggl] = ACTIONS(6626),
    [anon_sym_BSLASHBiggl] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6626),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6626),
    [anon_sym_BSLASHgls] = ACTIONS(6626),
    [anon_sym_BSLASHGls] = ACTIONS(6626),
    [anon_sym_BSLASHGLS] = ACTIONS(6626),
    [anon_sym_BSLASHglspl] = ACTIONS(6626),
    [anon_sym_BSLASHGlspl] = ACTIONS(6626),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6626),
    [anon_sym_BSLASHglslink] = ACTIONS(6626),
    [anon_sym_BSLASHglstext] = ACTIONS(6626),
    [anon_sym_BSLASHGlstext] = ACTIONS(6626),
    [anon_sym_BSLASHGLStext] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6626),
    [anon_sym_BSLASHglsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsname] = ACTIONS(6626),
    [anon_sym_BSLASHGlsname] = ACTIONS(6626),
    [anon_sym_BSLASHGLSname] = ACTIONS(6626),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6626),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6626),
    [anon_sym_BSLASHacrshort] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6626),
    [anon_sym_BSLASHACRshort] = ACTIONS(6626),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrlong] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6626),
    [anon_sym_BSLASHACRlong] = ACTIONS(6626),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrfull] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6626),
    [anon_sym_BSLASHACRfull] = ACTIONS(6626),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHacs] = ACTIONS(6626),
    [anon_sym_BSLASHAcs] = ACTIONS(6626),
    [anon_sym_BSLASHacsp] = ACTIONS(6626),
    [anon_sym_BSLASHAcsp] = ACTIONS(6626),
    [anon_sym_BSLASHacl] = ACTIONS(6626),
    [anon_sym_BSLASHAcl] = ACTIONS(6626),
    [anon_sym_BSLASHaclp] = ACTIONS(6626),
    [anon_sym_BSLASHAclp] = ACTIONS(6626),
    [anon_sym_BSLASHacf] = ACTIONS(6626),
    [anon_sym_BSLASHAcf] = ACTIONS(6626),
    [anon_sym_BSLASHacfp] = ACTIONS(6626),
    [anon_sym_BSLASHAcfp] = ACTIONS(6626),
    [anon_sym_BSLASHac] = ACTIONS(6626),
    [anon_sym_BSLASHAc] = ACTIONS(6626),
    [anon_sym_BSLASHacp] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6626),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6626),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6626),
    [anon_sym_BSLASHcolor] = ACTIONS(6626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6626),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6626),
    [anon_sym_BSLASHtext] = ACTIONS(6626),
    [anon_sym_BSLASHintertext] = ACTIONS(6626),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6626),
    [anon_sym_BSLASHurl] = ACTIONS(6626),
    [anon_sym_BSLASHhref] = ACTIONS(6626),
  },
  [1150] = {
    [sym_command_name] = ACTIONS(6630),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LPAREN] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHpart] = ACTIONS(6630),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddpart] = ACTIONS(6630),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHchapter] = ACTIONS(6630),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddchap] = ACTIONS(6630),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsection] = ACTIONS(6630),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddsec] = ACTIONS(6630),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHitem] = ACTIONS(6630),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [sym_word] = ACTIONS(6630),
    [sym_placeholder] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [anon_sym_STAR] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_BANG] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_COLON] = ACTIONS(6630),
    [anon_sym_SQUOTE] = ACTIONS(6630),
    [anon_sym__] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6632),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6632),
    [anon_sym_DOLLAR] = ACTIONS(6630),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6632),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHbegin] = ACTIONS(6630),
    [anon_sym_BSLASHtitle] = ACTIONS(6630),
    [anon_sym_BSLASHauthor] = ACTIONS(6630),
    [anon_sym_BSLASHusepackage] = ACTIONS(6630),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6630),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6630),
    [anon_sym_BSLASHinclude] = ACTIONS(6630),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6630),
    [anon_sym_BSLASHinput] = ACTIONS(6630),
    [anon_sym_BSLASHsubfile] = ACTIONS(6630),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6630),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6630),
    [anon_sym_BSLASHbibliography] = ACTIONS(6630),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6630),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6630),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6630),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6630),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6630),
    [anon_sym_BSLASHimport] = ACTIONS(6630),
    [anon_sym_BSLASHsubimport] = ACTIONS(6630),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6630),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHcaption] = ACTIONS(6630),
    [anon_sym_BSLASHcite] = ACTIONS(6630),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCite] = ACTIONS(6630),
    [anon_sym_BSLASHnocite] = ACTIONS(6630),
    [anon_sym_BSLASHcitet] = ACTIONS(6630),
    [anon_sym_BSLASHcitep] = ACTIONS(6630),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteA] = ACTIONS(6630),
    [anon_sym_BSLASHciteR] = ACTIONS(6630),
    [anon_sym_BSLASHciteS] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6630),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteyear] = ACTIONS(6630),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitedate] = ACTIONS(6630),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteurl] = ACTIONS(6630),
    [anon_sym_BSLASHfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6630),
    [anon_sym_BSLASHcitealt] = ACTIONS(6630),
    [anon_sym_BSLASHcitealp] = ACTIONS(6630),
    [anon_sym_BSLASHcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHparencite] = ACTIONS(6630),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHParencite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHtextcite] = ACTIONS(6630),
    [anon_sym_BSLASHTextcite] = ACTIONS(6630),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHsupercite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite] = ACTIONS(6630),
    [anon_sym_BSLASHAutocite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHVolcite] = ACTIONS(6630),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHavolcite] = ACTIONS(6630),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHNotecite] = ACTIONS(6630),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHlabel] = ACTIONS(6630),
    [anon_sym_BSLASHref] = ACTIONS(6630),
    [anon_sym_BSLASHeqref] = ACTIONS(6630),
    [anon_sym_BSLASHvref] = ACTIONS(6630),
    [anon_sym_BSLASHVref] = ACTIONS(6630),
    [anon_sym_BSLASHautoref] = ACTIONS(6630),
    [anon_sym_BSLASHpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcref] = ACTIONS(6630),
    [anon_sym_BSLASHCref] = ACTIONS(6630),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnameCref] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHdef] = ACTIONS(6630),
    [anon_sym_BSLASHlet] = ACTIONS(6630),
    [anon_sym_BSLASHleft] = ACTIONS(6630),
    [anon_sym_BSLASHbigl] = ACTIONS(6630),
    [anon_sym_BSLASHBigl] = ACTIONS(6630),
    [anon_sym_BSLASHbiggl] = ACTIONS(6630),
    [anon_sym_BSLASHBiggl] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6630),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6630),
    [anon_sym_BSLASHgls] = ACTIONS(6630),
    [anon_sym_BSLASHGls] = ACTIONS(6630),
    [anon_sym_BSLASHGLS] = ACTIONS(6630),
    [anon_sym_BSLASHglspl] = ACTIONS(6630),
    [anon_sym_BSLASHGlspl] = ACTIONS(6630),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6630),
    [anon_sym_BSLASHglslink] = ACTIONS(6630),
    [anon_sym_BSLASHglstext] = ACTIONS(6630),
    [anon_sym_BSLASHGlstext] = ACTIONS(6630),
    [anon_sym_BSLASHGLStext] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6630),
    [anon_sym_BSLASHglsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsname] = ACTIONS(6630),
    [anon_sym_BSLASHGlsname] = ACTIONS(6630),
    [anon_sym_BSLASHGLSname] = ACTIONS(6630),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6630),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6630),
    [anon_sym_BSLASHacrshort] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6630),
    [anon_sym_BSLASHACRshort] = ACTIONS(6630),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrlong] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6630),
    [anon_sym_BSLASHACRlong] = ACTIONS(6630),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrfull] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6630),
    [anon_sym_BSLASHACRfull] = ACTIONS(6630),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHacs] = ACTIONS(6630),
    [anon_sym_BSLASHAcs] = ACTIONS(6630),
    [anon_sym_BSLASHacsp] = ACTIONS(6630),
    [anon_sym_BSLASHAcsp] = ACTIONS(6630),
    [anon_sym_BSLASHacl] = ACTIONS(6630),
    [anon_sym_BSLASHAcl] = ACTIONS(6630),
    [anon_sym_BSLASHaclp] = ACTIONS(6630),
    [anon_sym_BSLASHAclp] = ACTIONS(6630),
    [anon_sym_BSLASHacf] = ACTIONS(6630),
    [anon_sym_BSLASHAcf] = ACTIONS(6630),
    [anon_sym_BSLASHacfp] = ACTIONS(6630),
    [anon_sym_BSLASHAcfp] = ACTIONS(6630),
    [anon_sym_BSLASHac] = ACTIONS(6630),
    [anon_sym_BSLASHAc] = ACTIONS(6630),
    [anon_sym_BSLASHacp] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6630),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6630),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6630),
    [anon_sym_BSLASHcolor] = ACTIONS(6630),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6630),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6630),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6630),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6630),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6630),
    [anon_sym_BSLASHtext] = ACTIONS(6630),
    [anon_sym_BSLASHintertext] = ACTIONS(6630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6630),
    [anon_sym_BSLASHurl] = ACTIONS(6630),
    [anon_sym_BSLASHhref] = ACTIONS(6630),
  },
  [1151] = {
    [sym_command_name] = ACTIONS(6490),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6490),
    [anon_sym_LBRACK] = ACTIONS(6492),
    [anon_sym_RBRACK] = ACTIONS(6492),
    [anon_sym_COMMA] = ACTIONS(6492),
    [anon_sym_EQ] = ACTIONS(6492),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [anon_sym_RPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHpart] = ACTIONS(6490),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddpart] = ACTIONS(6490),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHchapter] = ACTIONS(6490),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddchap] = ACTIONS(6490),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsection] = ACTIONS(6490),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddsec] = ACTIONS(6490),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHitem] = ACTIONS(6490),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6492),
    [anon_sym_LBRACE] = ACTIONS(6492),
    [sym_word] = ACTIONS(6490),
    [sym_placeholder] = ACTIONS(6492),
    [anon_sym_PLUS] = ACTIONS(6492),
    [anon_sym_DASH] = ACTIONS(6492),
    [anon_sym_STAR] = ACTIONS(6492),
    [anon_sym_SLASH] = ACTIONS(6492),
    [anon_sym_LT] = ACTIONS(6490),
    [anon_sym_GT] = ACTIONS(6490),
    [anon_sym_BANG] = ACTIONS(6490),
    [anon_sym_PIPE] = ACTIONS(6490),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_SQUOTE] = ACTIONS(6490),
    [anon_sym__] = ACTIONS(6492),
    [anon_sym_CARET] = ACTIONS(6492),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6492),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6492),
    [anon_sym_DOLLAR] = ACTIONS(6490),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHbegin] = ACTIONS(6490),
    [anon_sym_BSLASHend] = ACTIONS(6490),
    [anon_sym_BSLASHtitle] = ACTIONS(6490),
    [anon_sym_BSLASHauthor] = ACTIONS(6490),
    [anon_sym_BSLASHusepackage] = ACTIONS(6490),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6490),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6490),
    [anon_sym_BSLASHinclude] = ACTIONS(6490),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6490),
    [anon_sym_BSLASHinput] = ACTIONS(6490),
    [anon_sym_BSLASHsubfile] = ACTIONS(6490),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6490),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6490),
    [anon_sym_BSLASHbibliography] = ACTIONS(6490),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6490),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6490),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6490),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6490),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6490),
    [anon_sym_BSLASHimport] = ACTIONS(6490),
    [anon_sym_BSLASHsubimport] = ACTIONS(6490),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6490),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHcaption] = ACTIONS(6490),
    [anon_sym_BSLASHcite] = ACTIONS(6490),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCite] = ACTIONS(6490),
    [anon_sym_BSLASHnocite] = ACTIONS(6490),
    [anon_sym_BSLASHcitet] = ACTIONS(6490),
    [anon_sym_BSLASHcitep] = ACTIONS(6490),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteA] = ACTIONS(6490),
    [anon_sym_BSLASHciteR] = ACTIONS(6490),
    [anon_sym_BSLASHciteS] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6490),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteyear] = ACTIONS(6490),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitedate] = ACTIONS(6490),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteurl] = ACTIONS(6490),
    [anon_sym_BSLASHfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6490),
    [anon_sym_BSLASHcitealt] = ACTIONS(6490),
    [anon_sym_BSLASHcitealp] = ACTIONS(6490),
    [anon_sym_BSLASHcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHparencite] = ACTIONS(6490),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHParencite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHtextcite] = ACTIONS(6490),
    [anon_sym_BSLASHTextcite] = ACTIONS(6490),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHsupercite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite] = ACTIONS(6490),
    [anon_sym_BSLASHAutocite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHVolcite] = ACTIONS(6490),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHavolcite] = ACTIONS(6490),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHNotecite] = ACTIONS(6490),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHlabel] = ACTIONS(6490),
    [anon_sym_BSLASHref] = ACTIONS(6490),
    [anon_sym_BSLASHeqref] = ACTIONS(6490),
    [anon_sym_BSLASHvref] = ACTIONS(6490),
    [anon_sym_BSLASHVref] = ACTIONS(6490),
    [anon_sym_BSLASHautoref] = ACTIONS(6490),
    [anon_sym_BSLASHpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcref] = ACTIONS(6490),
    [anon_sym_BSLASHCref] = ACTIONS(6490),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnameCref] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHdef] = ACTIONS(6490),
    [anon_sym_BSLASHlet] = ACTIONS(6490),
    [anon_sym_BSLASHleft] = ACTIONS(6490),
    [anon_sym_BSLASHbigl] = ACTIONS(6490),
    [anon_sym_BSLASHBigl] = ACTIONS(6490),
    [anon_sym_BSLASHbiggl] = ACTIONS(6490),
    [anon_sym_BSLASHBiggl] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6490),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6490),
    [anon_sym_BSLASHgls] = ACTIONS(6490),
    [anon_sym_BSLASHGls] = ACTIONS(6490),
    [anon_sym_BSLASHGLS] = ACTIONS(6490),
    [anon_sym_BSLASHglspl] = ACTIONS(6490),
    [anon_sym_BSLASHGlspl] = ACTIONS(6490),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6490),
    [anon_sym_BSLASHglslink] = ACTIONS(6490),
    [anon_sym_BSLASHglstext] = ACTIONS(6490),
    [anon_sym_BSLASHGlstext] = ACTIONS(6490),
    [anon_sym_BSLASHGLStext] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6490),
    [anon_sym_BSLASHglsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsname] = ACTIONS(6490),
    [anon_sym_BSLASHGlsname] = ACTIONS(6490),
    [anon_sym_BSLASHGLSname] = ACTIONS(6490),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6490),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6490),
    [anon_sym_BSLASHacrshort] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6490),
    [anon_sym_BSLASHACRshort] = ACTIONS(6490),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrlong] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6490),
    [anon_sym_BSLASHACRlong] = ACTIONS(6490),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrfull] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6490),
    [anon_sym_BSLASHACRfull] = ACTIONS(6490),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHacs] = ACTIONS(6490),
    [anon_sym_BSLASHAcs] = ACTIONS(6490),
    [anon_sym_BSLASHacsp] = ACTIONS(6490),
    [anon_sym_BSLASHAcsp] = ACTIONS(6490),
    [anon_sym_BSLASHacl] = ACTIONS(6490),
    [anon_sym_BSLASHAcl] = ACTIONS(6490),
    [anon_sym_BSLASHaclp] = ACTIONS(6490),
    [anon_sym_BSLASHAclp] = ACTIONS(6490),
    [anon_sym_BSLASHacf] = ACTIONS(6490),
    [anon_sym_BSLASHAcf] = ACTIONS(6490),
    [anon_sym_BSLASHacfp] = ACTIONS(6490),
    [anon_sym_BSLASHAcfp] = ACTIONS(6490),
    [anon_sym_BSLASHac] = ACTIONS(6490),
    [anon_sym_BSLASHAc] = ACTIONS(6490),
    [anon_sym_BSLASHacp] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6490),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6490),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6490),
    [anon_sym_BSLASHcolor] = ACTIONS(6490),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6490),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6490),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6490),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6490),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6490),
    [anon_sym_BSLASHtext] = ACTIONS(6490),
    [anon_sym_BSLASHintertext] = ACTIONS(6490),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6490),
    [anon_sym_BSLASHurl] = ACTIONS(6490),
    [anon_sym_BSLASHhref] = ACTIONS(6490),
  },
  [1152] = {
    [sym_command_name] = ACTIONS(6638),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6640),
    [anon_sym_RBRACK] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LPAREN] = ACTIONS(6640),
    [anon_sym_RPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHpart] = ACTIONS(6638),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddpart] = ACTIONS(6638),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHchapter] = ACTIONS(6638),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddchap] = ACTIONS(6638),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsection] = ACTIONS(6638),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddsec] = ACTIONS(6638),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHitem] = ACTIONS(6638),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(6640),
    [sym_word] = ACTIONS(6638),
    [sym_placeholder] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_DASH] = ACTIONS(6640),
    [anon_sym_STAR] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6638),
    [anon_sym_GT] = ACTIONS(6638),
    [anon_sym_BANG] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6638),
    [anon_sym_COLON] = ACTIONS(6638),
    [anon_sym_SQUOTE] = ACTIONS(6638),
    [anon_sym__] = ACTIONS(6640),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6640),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6640),
    [anon_sym_DOLLAR] = ACTIONS(6638),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6640),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHbegin] = ACTIONS(6638),
    [anon_sym_BSLASHtitle] = ACTIONS(6638),
    [anon_sym_BSLASHauthor] = ACTIONS(6638),
    [anon_sym_BSLASHusepackage] = ACTIONS(6638),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6638),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6638),
    [anon_sym_BSLASHinclude] = ACTIONS(6638),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6638),
    [anon_sym_BSLASHinput] = ACTIONS(6638),
    [anon_sym_BSLASHsubfile] = ACTIONS(6638),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6638),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6638),
    [anon_sym_BSLASHbibliography] = ACTIONS(6638),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6638),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6638),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6638),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6638),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6638),
    [anon_sym_BSLASHimport] = ACTIONS(6638),
    [anon_sym_BSLASHsubimport] = ACTIONS(6638),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6638),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHcaption] = ACTIONS(6638),
    [anon_sym_BSLASHcite] = ACTIONS(6638),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCite] = ACTIONS(6638),
    [anon_sym_BSLASHnocite] = ACTIONS(6638),
    [anon_sym_BSLASHcitet] = ACTIONS(6638),
    [anon_sym_BSLASHcitep] = ACTIONS(6638),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteA] = ACTIONS(6638),
    [anon_sym_BSLASHciteR] = ACTIONS(6638),
    [anon_sym_BSLASHciteS] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6638),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteyear] = ACTIONS(6638),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitedate] = ACTIONS(6638),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteurl] = ACTIONS(6638),
    [anon_sym_BSLASHfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6638),
    [anon_sym_BSLASHcitealt] = ACTIONS(6638),
    [anon_sym_BSLASHcitealp] = ACTIONS(6638),
    [anon_sym_BSLASHcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHparencite] = ACTIONS(6638),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHParencite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHtextcite] = ACTIONS(6638),
    [anon_sym_BSLASHTextcite] = ACTIONS(6638),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHsupercite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite] = ACTIONS(6638),
    [anon_sym_BSLASHAutocite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHVolcite] = ACTIONS(6638),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHavolcite] = ACTIONS(6638),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHNotecite] = ACTIONS(6638),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHlabel] = ACTIONS(6638),
    [anon_sym_BSLASHref] = ACTIONS(6638),
    [anon_sym_BSLASHeqref] = ACTIONS(6638),
    [anon_sym_BSLASHvref] = ACTIONS(6638),
    [anon_sym_BSLASHVref] = ACTIONS(6638),
    [anon_sym_BSLASHautoref] = ACTIONS(6638),
    [anon_sym_BSLASHpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcref] = ACTIONS(6638),
    [anon_sym_BSLASHCref] = ACTIONS(6638),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnameCref] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHdef] = ACTIONS(6638),
    [anon_sym_BSLASHlet] = ACTIONS(6638),
    [anon_sym_BSLASHleft] = ACTIONS(6638),
    [anon_sym_BSLASHbigl] = ACTIONS(6638),
    [anon_sym_BSLASHBigl] = ACTIONS(6638),
    [anon_sym_BSLASHbiggl] = ACTIONS(6638),
    [anon_sym_BSLASHBiggl] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6638),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6638),
    [anon_sym_BSLASHgls] = ACTIONS(6638),
    [anon_sym_BSLASHGls] = ACTIONS(6638),
    [anon_sym_BSLASHGLS] = ACTIONS(6638),
    [anon_sym_BSLASHglspl] = ACTIONS(6638),
    [anon_sym_BSLASHGlspl] = ACTIONS(6638),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6638),
    [anon_sym_BSLASHglslink] = ACTIONS(6638),
    [anon_sym_BSLASHglstext] = ACTIONS(6638),
    [anon_sym_BSLASHGlstext] = ACTIONS(6638),
    [anon_sym_BSLASHGLStext] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6638),
    [anon_sym_BSLASHglsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsname] = ACTIONS(6638),
    [anon_sym_BSLASHGlsname] = ACTIONS(6638),
    [anon_sym_BSLASHGLSname] = ACTIONS(6638),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6638),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6638),
    [anon_sym_BSLASHacrshort] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6638),
    [anon_sym_BSLASHACRshort] = ACTIONS(6638),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrlong] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6638),
    [anon_sym_BSLASHACRlong] = ACTIONS(6638),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrfull] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6638),
    [anon_sym_BSLASHACRfull] = ACTIONS(6638),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHacs] = ACTIONS(6638),
    [anon_sym_BSLASHAcs] = ACTIONS(6638),
    [anon_sym_BSLASHacsp] = ACTIONS(6638),
    [anon_sym_BSLASHAcsp] = ACTIONS(6638),
    [anon_sym_BSLASHacl] = ACTIONS(6638),
    [anon_sym_BSLASHAcl] = ACTIONS(6638),
    [anon_sym_BSLASHaclp] = ACTIONS(6638),
    [anon_sym_BSLASHAclp] = ACTIONS(6638),
    [anon_sym_BSLASHacf] = ACTIONS(6638),
    [anon_sym_BSLASHAcf] = ACTIONS(6638),
    [anon_sym_BSLASHacfp] = ACTIONS(6638),
    [anon_sym_BSLASHAcfp] = ACTIONS(6638),
    [anon_sym_BSLASHac] = ACTIONS(6638),
    [anon_sym_BSLASHAc] = ACTIONS(6638),
    [anon_sym_BSLASHacp] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6638),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6638),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6638),
    [anon_sym_BSLASHcolor] = ACTIONS(6638),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6638),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6638),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6638),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6638),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6638),
    [anon_sym_BSLASHtext] = ACTIONS(6638),
    [anon_sym_BSLASHintertext] = ACTIONS(6638),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6638),
    [anon_sym_BSLASHurl] = ACTIONS(6638),
    [anon_sym_BSLASHhref] = ACTIONS(6638),
  },
  [1153] = {
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_LBRACK] = ACTIONS(6496),
    [anon_sym_RBRACK] = ACTIONS(6496),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6496),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_RPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHpart] = ACTIONS(6494),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddpart] = ACTIONS(6494),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHchapter] = ACTIONS(6494),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddchap] = ACTIONS(6494),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsection] = ACTIONS(6494),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddsec] = ACTIONS(6494),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHitem] = ACTIONS(6494),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6496),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6496),
    [anon_sym_DOLLAR] = ACTIONS(6494),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6496),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHbegin] = ACTIONS(6494),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHleft] = ACTIONS(6494),
    [anon_sym_BSLASHbigl] = ACTIONS(6494),
    [anon_sym_BSLASHBigl] = ACTIONS(6494),
    [anon_sym_BSLASHbiggl] = ACTIONS(6494),
    [anon_sym_BSLASHBiggl] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHtext] = ACTIONS(6494),
    [anon_sym_BSLASHintertext] = ACTIONS(6494),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [1154] = {
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_LBRACK] = ACTIONS(6500),
    [anon_sym_RBRACK] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [anon_sym_EQ] = ACTIONS(6500),
    [anon_sym_LPAREN] = ACTIONS(6500),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHpart] = ACTIONS(6498),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddpart] = ACTIONS(6498),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHchapter] = ACTIONS(6498),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddchap] = ACTIONS(6498),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsection] = ACTIONS(6498),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddsec] = ACTIONS(6498),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHitem] = ACTIONS(6498),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6500),
    [anon_sym_LBRACE] = ACTIONS(6500),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6500),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6500),
    [anon_sym_DOLLAR] = ACTIONS(6498),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6500),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHbegin] = ACTIONS(6498),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHleft] = ACTIONS(6498),
    [anon_sym_BSLASHbigl] = ACTIONS(6498),
    [anon_sym_BSLASHBigl] = ACTIONS(6498),
    [anon_sym_BSLASHbiggl] = ACTIONS(6498),
    [anon_sym_BSLASHBiggl] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHtext] = ACTIONS(6498),
    [anon_sym_BSLASHintertext] = ACTIONS(6498),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [1155] = {
    [sym_command_name] = ACTIONS(6726),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6726),
    [anon_sym_LBRACK] = ACTIONS(6728),
    [anon_sym_RBRACK] = ACTIONS(6728),
    [anon_sym_COMMA] = ACTIONS(6728),
    [anon_sym_EQ] = ACTIONS(6728),
    [anon_sym_LPAREN] = ACTIONS(6728),
    [anon_sym_RPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHpart] = ACTIONS(6726),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddpart] = ACTIONS(6726),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHchapter] = ACTIONS(6726),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddchap] = ACTIONS(6726),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsection] = ACTIONS(6726),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddsec] = ACTIONS(6726),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHitem] = ACTIONS(6726),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6728),
    [anon_sym_LBRACE] = ACTIONS(6728),
    [sym_word] = ACTIONS(6726),
    [sym_placeholder] = ACTIONS(6728),
    [anon_sym_PLUS] = ACTIONS(6728),
    [anon_sym_DASH] = ACTIONS(6728),
    [anon_sym_STAR] = ACTIONS(6728),
    [anon_sym_SLASH] = ACTIONS(6728),
    [anon_sym_LT] = ACTIONS(6726),
    [anon_sym_GT] = ACTIONS(6726),
    [anon_sym_BANG] = ACTIONS(6726),
    [anon_sym_PIPE] = ACTIONS(6726),
    [anon_sym_COLON] = ACTIONS(6726),
    [anon_sym_SQUOTE] = ACTIONS(6726),
    [anon_sym__] = ACTIONS(6728),
    [anon_sym_CARET] = ACTIONS(6728),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6728),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6728),
    [anon_sym_DOLLAR] = ACTIONS(6726),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHbegin] = ACTIONS(6726),
    [anon_sym_BSLASHend] = ACTIONS(6726),
    [anon_sym_BSLASHtitle] = ACTIONS(6726),
    [anon_sym_BSLASHauthor] = ACTIONS(6726),
    [anon_sym_BSLASHusepackage] = ACTIONS(6726),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6726),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6726),
    [anon_sym_BSLASHinclude] = ACTIONS(6726),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6726),
    [anon_sym_BSLASHinput] = ACTIONS(6726),
    [anon_sym_BSLASHsubfile] = ACTIONS(6726),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6726),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6726),
    [anon_sym_BSLASHbibliography] = ACTIONS(6726),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6726),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6726),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6726),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6726),
    [anon_sym_BSLASHimport] = ACTIONS(6726),
    [anon_sym_BSLASHsubimport] = ACTIONS(6726),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6726),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHcaption] = ACTIONS(6726),
    [anon_sym_BSLASHcite] = ACTIONS(6726),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCite] = ACTIONS(6726),
    [anon_sym_BSLASHnocite] = ACTIONS(6726),
    [anon_sym_BSLASHcitet] = ACTIONS(6726),
    [anon_sym_BSLASHcitep] = ACTIONS(6726),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteA] = ACTIONS(6726),
    [anon_sym_BSLASHciteR] = ACTIONS(6726),
    [anon_sym_BSLASHciteS] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6726),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteyear] = ACTIONS(6726),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitedate] = ACTIONS(6726),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteurl] = ACTIONS(6726),
    [anon_sym_BSLASHfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6726),
    [anon_sym_BSLASHcitealt] = ACTIONS(6726),
    [anon_sym_BSLASHcitealp] = ACTIONS(6726),
    [anon_sym_BSLASHcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHparencite] = ACTIONS(6726),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHParencite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHtextcite] = ACTIONS(6726),
    [anon_sym_BSLASHTextcite] = ACTIONS(6726),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHsupercite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite] = ACTIONS(6726),
    [anon_sym_BSLASHAutocite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHVolcite] = ACTIONS(6726),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHavolcite] = ACTIONS(6726),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHNotecite] = ACTIONS(6726),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHlabel] = ACTIONS(6726),
    [anon_sym_BSLASHref] = ACTIONS(6726),
    [anon_sym_BSLASHeqref] = ACTIONS(6726),
    [anon_sym_BSLASHvref] = ACTIONS(6726),
    [anon_sym_BSLASHVref] = ACTIONS(6726),
    [anon_sym_BSLASHautoref] = ACTIONS(6726),
    [anon_sym_BSLASHpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcref] = ACTIONS(6726),
    [anon_sym_BSLASHCref] = ACTIONS(6726),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnameCref] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHdef] = ACTIONS(6726),
    [anon_sym_BSLASHlet] = ACTIONS(6726),
    [anon_sym_BSLASHleft] = ACTIONS(6726),
    [anon_sym_BSLASHbigl] = ACTIONS(6726),
    [anon_sym_BSLASHBigl] = ACTIONS(6726),
    [anon_sym_BSLASHbiggl] = ACTIONS(6726),
    [anon_sym_BSLASHBiggl] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6726),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6726),
    [anon_sym_BSLASHgls] = ACTIONS(6726),
    [anon_sym_BSLASHGls] = ACTIONS(6726),
    [anon_sym_BSLASHGLS] = ACTIONS(6726),
    [anon_sym_BSLASHglspl] = ACTIONS(6726),
    [anon_sym_BSLASHGlspl] = ACTIONS(6726),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6726),
    [anon_sym_BSLASHglslink] = ACTIONS(6726),
    [anon_sym_BSLASHglstext] = ACTIONS(6726),
    [anon_sym_BSLASHGlstext] = ACTIONS(6726),
    [anon_sym_BSLASHGLStext] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6726),
    [anon_sym_BSLASHglsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsname] = ACTIONS(6726),
    [anon_sym_BSLASHGlsname] = ACTIONS(6726),
    [anon_sym_BSLASHGLSname] = ACTIONS(6726),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6726),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6726),
    [anon_sym_BSLASHacrshort] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6726),
    [anon_sym_BSLASHACRshort] = ACTIONS(6726),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrlong] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6726),
    [anon_sym_BSLASHACRlong] = ACTIONS(6726),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrfull] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6726),
    [anon_sym_BSLASHACRfull] = ACTIONS(6726),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHacs] = ACTIONS(6726),
    [anon_sym_BSLASHAcs] = ACTIONS(6726),
    [anon_sym_BSLASHacsp] = ACTIONS(6726),
    [anon_sym_BSLASHAcsp] = ACTIONS(6726),
    [anon_sym_BSLASHacl] = ACTIONS(6726),
    [anon_sym_BSLASHAcl] = ACTIONS(6726),
    [anon_sym_BSLASHaclp] = ACTIONS(6726),
    [anon_sym_BSLASHAclp] = ACTIONS(6726),
    [anon_sym_BSLASHacf] = ACTIONS(6726),
    [anon_sym_BSLASHAcf] = ACTIONS(6726),
    [anon_sym_BSLASHacfp] = ACTIONS(6726),
    [anon_sym_BSLASHAcfp] = ACTIONS(6726),
    [anon_sym_BSLASHac] = ACTIONS(6726),
    [anon_sym_BSLASHAc] = ACTIONS(6726),
    [anon_sym_BSLASHacp] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6726),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6726),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6726),
    [anon_sym_BSLASHcolor] = ACTIONS(6726),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6726),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6726),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6726),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6726),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6726),
    [anon_sym_BSLASHtext] = ACTIONS(6726),
    [anon_sym_BSLASHintertext] = ACTIONS(6726),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6726),
    [anon_sym_BSLASHurl] = ACTIONS(6726),
    [anon_sym_BSLASHhref] = ACTIONS(6726),
  },
  [1156] = {
    [sym_command_name] = ACTIONS(6722),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6722),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_RBRACK] = ACTIONS(6724),
    [anon_sym_COMMA] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6724),
    [anon_sym_LPAREN] = ACTIONS(6724),
    [anon_sym_RPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHpart] = ACTIONS(6722),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddpart] = ACTIONS(6722),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHchapter] = ACTIONS(6722),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddchap] = ACTIONS(6722),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsection] = ACTIONS(6722),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddsec] = ACTIONS(6722),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHitem] = ACTIONS(6722),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(6724),
    [sym_word] = ACTIONS(6722),
    [sym_placeholder] = ACTIONS(6724),
    [anon_sym_PLUS] = ACTIONS(6724),
    [anon_sym_DASH] = ACTIONS(6724),
    [anon_sym_STAR] = ACTIONS(6724),
    [anon_sym_SLASH] = ACTIONS(6724),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_BANG] = ACTIONS(6722),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_COLON] = ACTIONS(6722),
    [anon_sym_SQUOTE] = ACTIONS(6722),
    [anon_sym__] = ACTIONS(6724),
    [anon_sym_CARET] = ACTIONS(6724),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6724),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6724),
    [anon_sym_DOLLAR] = ACTIONS(6722),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHbegin] = ACTIONS(6722),
    [anon_sym_BSLASHend] = ACTIONS(6722),
    [anon_sym_BSLASHtitle] = ACTIONS(6722),
    [anon_sym_BSLASHauthor] = ACTIONS(6722),
    [anon_sym_BSLASHusepackage] = ACTIONS(6722),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6722),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6722),
    [anon_sym_BSLASHinclude] = ACTIONS(6722),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6722),
    [anon_sym_BSLASHinput] = ACTIONS(6722),
    [anon_sym_BSLASHsubfile] = ACTIONS(6722),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6722),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6722),
    [anon_sym_BSLASHbibliography] = ACTIONS(6722),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6722),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6722),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6722),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6722),
    [anon_sym_BSLASHimport] = ACTIONS(6722),
    [anon_sym_BSLASHsubimport] = ACTIONS(6722),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6722),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHcaption] = ACTIONS(6722),
    [anon_sym_BSLASHcite] = ACTIONS(6722),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCite] = ACTIONS(6722),
    [anon_sym_BSLASHnocite] = ACTIONS(6722),
    [anon_sym_BSLASHcitet] = ACTIONS(6722),
    [anon_sym_BSLASHcitep] = ACTIONS(6722),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteA] = ACTIONS(6722),
    [anon_sym_BSLASHciteR] = ACTIONS(6722),
    [anon_sym_BSLASHciteS] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6722),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteyear] = ACTIONS(6722),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitedate] = ACTIONS(6722),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteurl] = ACTIONS(6722),
    [anon_sym_BSLASHfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6722),
    [anon_sym_BSLASHcitealt] = ACTIONS(6722),
    [anon_sym_BSLASHcitealp] = ACTIONS(6722),
    [anon_sym_BSLASHcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHparencite] = ACTIONS(6722),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHParencite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHtextcite] = ACTIONS(6722),
    [anon_sym_BSLASHTextcite] = ACTIONS(6722),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHsupercite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite] = ACTIONS(6722),
    [anon_sym_BSLASHAutocite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHVolcite] = ACTIONS(6722),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHavolcite] = ACTIONS(6722),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHNotecite] = ACTIONS(6722),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHlabel] = ACTIONS(6722),
    [anon_sym_BSLASHref] = ACTIONS(6722),
    [anon_sym_BSLASHeqref] = ACTIONS(6722),
    [anon_sym_BSLASHvref] = ACTIONS(6722),
    [anon_sym_BSLASHVref] = ACTIONS(6722),
    [anon_sym_BSLASHautoref] = ACTIONS(6722),
    [anon_sym_BSLASHpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcref] = ACTIONS(6722),
    [anon_sym_BSLASHCref] = ACTIONS(6722),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnameCref] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHdef] = ACTIONS(6722),
    [anon_sym_BSLASHlet] = ACTIONS(6722),
    [anon_sym_BSLASHleft] = ACTIONS(6722),
    [anon_sym_BSLASHbigl] = ACTIONS(6722),
    [anon_sym_BSLASHBigl] = ACTIONS(6722),
    [anon_sym_BSLASHbiggl] = ACTIONS(6722),
    [anon_sym_BSLASHBiggl] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6722),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6722),
    [anon_sym_BSLASHgls] = ACTIONS(6722),
    [anon_sym_BSLASHGls] = ACTIONS(6722),
    [anon_sym_BSLASHGLS] = ACTIONS(6722),
    [anon_sym_BSLASHglspl] = ACTIONS(6722),
    [anon_sym_BSLASHGlspl] = ACTIONS(6722),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6722),
    [anon_sym_BSLASHglslink] = ACTIONS(6722),
    [anon_sym_BSLASHglstext] = ACTIONS(6722),
    [anon_sym_BSLASHGlstext] = ACTIONS(6722),
    [anon_sym_BSLASHGLStext] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6722),
    [anon_sym_BSLASHglsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsname] = ACTIONS(6722),
    [anon_sym_BSLASHGlsname] = ACTIONS(6722),
    [anon_sym_BSLASHGLSname] = ACTIONS(6722),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6722),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6722),
    [anon_sym_BSLASHacrshort] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6722),
    [anon_sym_BSLASHACRshort] = ACTIONS(6722),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrlong] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6722),
    [anon_sym_BSLASHACRlong] = ACTIONS(6722),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrfull] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6722),
    [anon_sym_BSLASHACRfull] = ACTIONS(6722),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHacs] = ACTIONS(6722),
    [anon_sym_BSLASHAcs] = ACTIONS(6722),
    [anon_sym_BSLASHacsp] = ACTIONS(6722),
    [anon_sym_BSLASHAcsp] = ACTIONS(6722),
    [anon_sym_BSLASHacl] = ACTIONS(6722),
    [anon_sym_BSLASHAcl] = ACTIONS(6722),
    [anon_sym_BSLASHaclp] = ACTIONS(6722),
    [anon_sym_BSLASHAclp] = ACTIONS(6722),
    [anon_sym_BSLASHacf] = ACTIONS(6722),
    [anon_sym_BSLASHAcf] = ACTIONS(6722),
    [anon_sym_BSLASHacfp] = ACTIONS(6722),
    [anon_sym_BSLASHAcfp] = ACTIONS(6722),
    [anon_sym_BSLASHac] = ACTIONS(6722),
    [anon_sym_BSLASHAc] = ACTIONS(6722),
    [anon_sym_BSLASHacp] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6722),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6722),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6722),
    [anon_sym_BSLASHcolor] = ACTIONS(6722),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6722),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6722),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6722),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6722),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6722),
    [anon_sym_BSLASHtext] = ACTIONS(6722),
    [anon_sym_BSLASHintertext] = ACTIONS(6722),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6722),
    [anon_sym_BSLASHurl] = ACTIONS(6722),
    [anon_sym_BSLASHhref] = ACTIONS(6722),
  },
  [1157] = {
    [sym_command_name] = ACTIONS(6718),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6718),
    [anon_sym_LBRACK] = ACTIONS(6720),
    [anon_sym_RBRACK] = ACTIONS(6720),
    [anon_sym_COMMA] = ACTIONS(6720),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_LPAREN] = ACTIONS(6720),
    [anon_sym_RPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHpart] = ACTIONS(6718),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddpart] = ACTIONS(6718),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHchapter] = ACTIONS(6718),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddchap] = ACTIONS(6718),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsection] = ACTIONS(6718),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddsec] = ACTIONS(6718),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHitem] = ACTIONS(6718),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6720),
    [anon_sym_LBRACE] = ACTIONS(6720),
    [sym_word] = ACTIONS(6718),
    [sym_placeholder] = ACTIONS(6720),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_LT] = ACTIONS(6718),
    [anon_sym_GT] = ACTIONS(6718),
    [anon_sym_BANG] = ACTIONS(6718),
    [anon_sym_PIPE] = ACTIONS(6718),
    [anon_sym_COLON] = ACTIONS(6718),
    [anon_sym_SQUOTE] = ACTIONS(6718),
    [anon_sym__] = ACTIONS(6720),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6720),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6720),
    [anon_sym_DOLLAR] = ACTIONS(6718),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHbegin] = ACTIONS(6718),
    [anon_sym_BSLASHend] = ACTIONS(6718),
    [anon_sym_BSLASHtitle] = ACTIONS(6718),
    [anon_sym_BSLASHauthor] = ACTIONS(6718),
    [anon_sym_BSLASHusepackage] = ACTIONS(6718),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6718),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6718),
    [anon_sym_BSLASHinclude] = ACTIONS(6718),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6718),
    [anon_sym_BSLASHinput] = ACTIONS(6718),
    [anon_sym_BSLASHsubfile] = ACTIONS(6718),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6718),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6718),
    [anon_sym_BSLASHbibliography] = ACTIONS(6718),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6718),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6718),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6718),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6718),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6718),
    [anon_sym_BSLASHimport] = ACTIONS(6718),
    [anon_sym_BSLASHsubimport] = ACTIONS(6718),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6718),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHcaption] = ACTIONS(6718),
    [anon_sym_BSLASHcite] = ACTIONS(6718),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCite] = ACTIONS(6718),
    [anon_sym_BSLASHnocite] = ACTIONS(6718),
    [anon_sym_BSLASHcitet] = ACTIONS(6718),
    [anon_sym_BSLASHcitep] = ACTIONS(6718),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteA] = ACTIONS(6718),
    [anon_sym_BSLASHciteR] = ACTIONS(6718),
    [anon_sym_BSLASHciteS] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6718),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteyear] = ACTIONS(6718),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitedate] = ACTIONS(6718),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteurl] = ACTIONS(6718),
    [anon_sym_BSLASHfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6718),
    [anon_sym_BSLASHcitealt] = ACTIONS(6718),
    [anon_sym_BSLASHcitealp] = ACTIONS(6718),
    [anon_sym_BSLASHcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHparencite] = ACTIONS(6718),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHParencite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHtextcite] = ACTIONS(6718),
    [anon_sym_BSLASHTextcite] = ACTIONS(6718),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHsupercite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite] = ACTIONS(6718),
    [anon_sym_BSLASHAutocite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHVolcite] = ACTIONS(6718),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHavolcite] = ACTIONS(6718),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHNotecite] = ACTIONS(6718),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHlabel] = ACTIONS(6718),
    [anon_sym_BSLASHref] = ACTIONS(6718),
    [anon_sym_BSLASHeqref] = ACTIONS(6718),
    [anon_sym_BSLASHvref] = ACTIONS(6718),
    [anon_sym_BSLASHVref] = ACTIONS(6718),
    [anon_sym_BSLASHautoref] = ACTIONS(6718),
    [anon_sym_BSLASHpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcref] = ACTIONS(6718),
    [anon_sym_BSLASHCref] = ACTIONS(6718),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnameCref] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHdef] = ACTIONS(6718),
    [anon_sym_BSLASHlet] = ACTIONS(6718),
    [anon_sym_BSLASHleft] = ACTIONS(6718),
    [anon_sym_BSLASHbigl] = ACTIONS(6718),
    [anon_sym_BSLASHBigl] = ACTIONS(6718),
    [anon_sym_BSLASHbiggl] = ACTIONS(6718),
    [anon_sym_BSLASHBiggl] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6718),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6718),
    [anon_sym_BSLASHgls] = ACTIONS(6718),
    [anon_sym_BSLASHGls] = ACTIONS(6718),
    [anon_sym_BSLASHGLS] = ACTIONS(6718),
    [anon_sym_BSLASHglspl] = ACTIONS(6718),
    [anon_sym_BSLASHGlspl] = ACTIONS(6718),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6718),
    [anon_sym_BSLASHglslink] = ACTIONS(6718),
    [anon_sym_BSLASHglstext] = ACTIONS(6718),
    [anon_sym_BSLASHGlstext] = ACTIONS(6718),
    [anon_sym_BSLASHGLStext] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6718),
    [anon_sym_BSLASHglsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsname] = ACTIONS(6718),
    [anon_sym_BSLASHGlsname] = ACTIONS(6718),
    [anon_sym_BSLASHGLSname] = ACTIONS(6718),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6718),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6718),
    [anon_sym_BSLASHacrshort] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6718),
    [anon_sym_BSLASHACRshort] = ACTIONS(6718),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrlong] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6718),
    [anon_sym_BSLASHACRlong] = ACTIONS(6718),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrfull] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6718),
    [anon_sym_BSLASHACRfull] = ACTIONS(6718),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHacs] = ACTIONS(6718),
    [anon_sym_BSLASHAcs] = ACTIONS(6718),
    [anon_sym_BSLASHacsp] = ACTIONS(6718),
    [anon_sym_BSLASHAcsp] = ACTIONS(6718),
    [anon_sym_BSLASHacl] = ACTIONS(6718),
    [anon_sym_BSLASHAcl] = ACTIONS(6718),
    [anon_sym_BSLASHaclp] = ACTIONS(6718),
    [anon_sym_BSLASHAclp] = ACTIONS(6718),
    [anon_sym_BSLASHacf] = ACTIONS(6718),
    [anon_sym_BSLASHAcf] = ACTIONS(6718),
    [anon_sym_BSLASHacfp] = ACTIONS(6718),
    [anon_sym_BSLASHAcfp] = ACTIONS(6718),
    [anon_sym_BSLASHac] = ACTIONS(6718),
    [anon_sym_BSLASHAc] = ACTIONS(6718),
    [anon_sym_BSLASHacp] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6718),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6718),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6718),
    [anon_sym_BSLASHcolor] = ACTIONS(6718),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6718),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6718),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6718),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6718),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6718),
    [anon_sym_BSLASHtext] = ACTIONS(6718),
    [anon_sym_BSLASHintertext] = ACTIONS(6718),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6718),
    [anon_sym_BSLASHurl] = ACTIONS(6718),
    [anon_sym_BSLASHhref] = ACTIONS(6718),
  },
  [1158] = {
    [sym_command_name] = ACTIONS(6714),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6714),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_RBRACK] = ACTIONS(6716),
    [anon_sym_COMMA] = ACTIONS(6716),
    [anon_sym_EQ] = ACTIONS(6716),
    [anon_sym_LPAREN] = ACTIONS(6716),
    [anon_sym_RPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHpart] = ACTIONS(6714),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddpart] = ACTIONS(6714),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHchapter] = ACTIONS(6714),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddchap] = ACTIONS(6714),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsection] = ACTIONS(6714),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddsec] = ACTIONS(6714),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHitem] = ACTIONS(6714),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(6716),
    [sym_word] = ACTIONS(6714),
    [sym_placeholder] = ACTIONS(6716),
    [anon_sym_PLUS] = ACTIONS(6716),
    [anon_sym_DASH] = ACTIONS(6716),
    [anon_sym_STAR] = ACTIONS(6716),
    [anon_sym_SLASH] = ACTIONS(6716),
    [anon_sym_LT] = ACTIONS(6714),
    [anon_sym_GT] = ACTIONS(6714),
    [anon_sym_BANG] = ACTIONS(6714),
    [anon_sym_PIPE] = ACTIONS(6714),
    [anon_sym_COLON] = ACTIONS(6714),
    [anon_sym_SQUOTE] = ACTIONS(6714),
    [anon_sym__] = ACTIONS(6716),
    [anon_sym_CARET] = ACTIONS(6716),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6716),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6716),
    [anon_sym_DOLLAR] = ACTIONS(6714),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHbegin] = ACTIONS(6714),
    [anon_sym_BSLASHend] = ACTIONS(6714),
    [anon_sym_BSLASHtitle] = ACTIONS(6714),
    [anon_sym_BSLASHauthor] = ACTIONS(6714),
    [anon_sym_BSLASHusepackage] = ACTIONS(6714),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6714),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6714),
    [anon_sym_BSLASHinclude] = ACTIONS(6714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6714),
    [anon_sym_BSLASHinput] = ACTIONS(6714),
    [anon_sym_BSLASHsubfile] = ACTIONS(6714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6714),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6714),
    [anon_sym_BSLASHbibliography] = ACTIONS(6714),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6714),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6714),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6714),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6714),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6714),
    [anon_sym_BSLASHimport] = ACTIONS(6714),
    [anon_sym_BSLASHsubimport] = ACTIONS(6714),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6714),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHcaption] = ACTIONS(6714),
    [anon_sym_BSLASHcite] = ACTIONS(6714),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCite] = ACTIONS(6714),
    [anon_sym_BSLASHnocite] = ACTIONS(6714),
    [anon_sym_BSLASHcitet] = ACTIONS(6714),
    [anon_sym_BSLASHcitep] = ACTIONS(6714),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteA] = ACTIONS(6714),
    [anon_sym_BSLASHciteR] = ACTIONS(6714),
    [anon_sym_BSLASHciteS] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6714),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteyear] = ACTIONS(6714),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitedate] = ACTIONS(6714),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteurl] = ACTIONS(6714),
    [anon_sym_BSLASHfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6714),
    [anon_sym_BSLASHcitealt] = ACTIONS(6714),
    [anon_sym_BSLASHcitealp] = ACTIONS(6714),
    [anon_sym_BSLASHcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHparencite] = ACTIONS(6714),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHParencite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHtextcite] = ACTIONS(6714),
    [anon_sym_BSLASHTextcite] = ACTIONS(6714),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHsupercite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite] = ACTIONS(6714),
    [anon_sym_BSLASHAutocite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHVolcite] = ACTIONS(6714),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHavolcite] = ACTIONS(6714),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHNotecite] = ACTIONS(6714),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHlabel] = ACTIONS(6714),
    [anon_sym_BSLASHref] = ACTIONS(6714),
    [anon_sym_BSLASHeqref] = ACTIONS(6714),
    [anon_sym_BSLASHvref] = ACTIONS(6714),
    [anon_sym_BSLASHVref] = ACTIONS(6714),
    [anon_sym_BSLASHautoref] = ACTIONS(6714),
    [anon_sym_BSLASHpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcref] = ACTIONS(6714),
    [anon_sym_BSLASHCref] = ACTIONS(6714),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnameCref] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHdef] = ACTIONS(6714),
    [anon_sym_BSLASHlet] = ACTIONS(6714),
    [anon_sym_BSLASHleft] = ACTIONS(6714),
    [anon_sym_BSLASHbigl] = ACTIONS(6714),
    [anon_sym_BSLASHBigl] = ACTIONS(6714),
    [anon_sym_BSLASHbiggl] = ACTIONS(6714),
    [anon_sym_BSLASHBiggl] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6714),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6714),
    [anon_sym_BSLASHgls] = ACTIONS(6714),
    [anon_sym_BSLASHGls] = ACTIONS(6714),
    [anon_sym_BSLASHGLS] = ACTIONS(6714),
    [anon_sym_BSLASHglspl] = ACTIONS(6714),
    [anon_sym_BSLASHGlspl] = ACTIONS(6714),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6714),
    [anon_sym_BSLASHglslink] = ACTIONS(6714),
    [anon_sym_BSLASHglstext] = ACTIONS(6714),
    [anon_sym_BSLASHGlstext] = ACTIONS(6714),
    [anon_sym_BSLASHGLStext] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6714),
    [anon_sym_BSLASHglsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsname] = ACTIONS(6714),
    [anon_sym_BSLASHGlsname] = ACTIONS(6714),
    [anon_sym_BSLASHGLSname] = ACTIONS(6714),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6714),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6714),
    [anon_sym_BSLASHacrshort] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6714),
    [anon_sym_BSLASHACRshort] = ACTIONS(6714),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrlong] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6714),
    [anon_sym_BSLASHACRlong] = ACTIONS(6714),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrfull] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6714),
    [anon_sym_BSLASHACRfull] = ACTIONS(6714),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHacs] = ACTIONS(6714),
    [anon_sym_BSLASHAcs] = ACTIONS(6714),
    [anon_sym_BSLASHacsp] = ACTIONS(6714),
    [anon_sym_BSLASHAcsp] = ACTIONS(6714),
    [anon_sym_BSLASHacl] = ACTIONS(6714),
    [anon_sym_BSLASHAcl] = ACTIONS(6714),
    [anon_sym_BSLASHaclp] = ACTIONS(6714),
    [anon_sym_BSLASHAclp] = ACTIONS(6714),
    [anon_sym_BSLASHacf] = ACTIONS(6714),
    [anon_sym_BSLASHAcf] = ACTIONS(6714),
    [anon_sym_BSLASHacfp] = ACTIONS(6714),
    [anon_sym_BSLASHAcfp] = ACTIONS(6714),
    [anon_sym_BSLASHac] = ACTIONS(6714),
    [anon_sym_BSLASHAc] = ACTIONS(6714),
    [anon_sym_BSLASHacp] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6714),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6714),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6714),
    [anon_sym_BSLASHcolor] = ACTIONS(6714),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6714),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6714),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6714),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6714),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6714),
    [anon_sym_BSLASHtext] = ACTIONS(6714),
    [anon_sym_BSLASHintertext] = ACTIONS(6714),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6714),
    [anon_sym_BSLASHurl] = ACTIONS(6714),
    [anon_sym_BSLASHhref] = ACTIONS(6714),
  },
  [1159] = {
    [sym_command_name] = ACTIONS(6710),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(6712),
    [anon_sym_RBRACK] = ACTIONS(6712),
    [anon_sym_COMMA] = ACTIONS(6712),
    [anon_sym_EQ] = ACTIONS(6712),
    [anon_sym_LPAREN] = ACTIONS(6712),
    [anon_sym_RPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHpart] = ACTIONS(6710),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddpart] = ACTIONS(6710),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHchapter] = ACTIONS(6710),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddchap] = ACTIONS(6710),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsection] = ACTIONS(6710),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddsec] = ACTIONS(6710),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHitem] = ACTIONS(6710),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6712),
    [anon_sym_LBRACE] = ACTIONS(6712),
    [sym_word] = ACTIONS(6710),
    [sym_placeholder] = ACTIONS(6712),
    [anon_sym_PLUS] = ACTIONS(6712),
    [anon_sym_DASH] = ACTIONS(6712),
    [anon_sym_STAR] = ACTIONS(6712),
    [anon_sym_SLASH] = ACTIONS(6712),
    [anon_sym_LT] = ACTIONS(6710),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_PIPE] = ACTIONS(6710),
    [anon_sym_COLON] = ACTIONS(6710),
    [anon_sym_SQUOTE] = ACTIONS(6710),
    [anon_sym__] = ACTIONS(6712),
    [anon_sym_CARET] = ACTIONS(6712),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6712),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6712),
    [anon_sym_DOLLAR] = ACTIONS(6710),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHbegin] = ACTIONS(6710),
    [anon_sym_BSLASHend] = ACTIONS(6710),
    [anon_sym_BSLASHtitle] = ACTIONS(6710),
    [anon_sym_BSLASHauthor] = ACTIONS(6710),
    [anon_sym_BSLASHusepackage] = ACTIONS(6710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6710),
    [anon_sym_BSLASHinclude] = ACTIONS(6710),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6710),
    [anon_sym_BSLASHinput] = ACTIONS(6710),
    [anon_sym_BSLASHsubfile] = ACTIONS(6710),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6710),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6710),
    [anon_sym_BSLASHbibliography] = ACTIONS(6710),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6710),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6710),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6710),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6710),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6710),
    [anon_sym_BSLASHimport] = ACTIONS(6710),
    [anon_sym_BSLASHsubimport] = ACTIONS(6710),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6710),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHcaption] = ACTIONS(6710),
    [anon_sym_BSLASHcite] = ACTIONS(6710),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCite] = ACTIONS(6710),
    [anon_sym_BSLASHnocite] = ACTIONS(6710),
    [anon_sym_BSLASHcitet] = ACTIONS(6710),
    [anon_sym_BSLASHcitep] = ACTIONS(6710),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteA] = ACTIONS(6710),
    [anon_sym_BSLASHciteR] = ACTIONS(6710),
    [anon_sym_BSLASHciteS] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6710),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteyear] = ACTIONS(6710),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitedate] = ACTIONS(6710),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteurl] = ACTIONS(6710),
    [anon_sym_BSLASHfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6710),
    [anon_sym_BSLASHcitealt] = ACTIONS(6710),
    [anon_sym_BSLASHcitealp] = ACTIONS(6710),
    [anon_sym_BSLASHcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHparencite] = ACTIONS(6710),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHParencite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHtextcite] = ACTIONS(6710),
    [anon_sym_BSLASHTextcite] = ACTIONS(6710),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHsupercite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite] = ACTIONS(6710),
    [anon_sym_BSLASHAutocite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHVolcite] = ACTIONS(6710),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHavolcite] = ACTIONS(6710),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHNotecite] = ACTIONS(6710),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHlabel] = ACTIONS(6710),
    [anon_sym_BSLASHref] = ACTIONS(6710),
    [anon_sym_BSLASHeqref] = ACTIONS(6710),
    [anon_sym_BSLASHvref] = ACTIONS(6710),
    [anon_sym_BSLASHVref] = ACTIONS(6710),
    [anon_sym_BSLASHautoref] = ACTIONS(6710),
    [anon_sym_BSLASHpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcref] = ACTIONS(6710),
    [anon_sym_BSLASHCref] = ACTIONS(6710),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnameCref] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHdef] = ACTIONS(6710),
    [anon_sym_BSLASHlet] = ACTIONS(6710),
    [anon_sym_BSLASHleft] = ACTIONS(6710),
    [anon_sym_BSLASHbigl] = ACTIONS(6710),
    [anon_sym_BSLASHBigl] = ACTIONS(6710),
    [anon_sym_BSLASHbiggl] = ACTIONS(6710),
    [anon_sym_BSLASHBiggl] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6710),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6710),
    [anon_sym_BSLASHgls] = ACTIONS(6710),
    [anon_sym_BSLASHGls] = ACTIONS(6710),
    [anon_sym_BSLASHGLS] = ACTIONS(6710),
    [anon_sym_BSLASHglspl] = ACTIONS(6710),
    [anon_sym_BSLASHGlspl] = ACTIONS(6710),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6710),
    [anon_sym_BSLASHglslink] = ACTIONS(6710),
    [anon_sym_BSLASHglstext] = ACTIONS(6710),
    [anon_sym_BSLASHGlstext] = ACTIONS(6710),
    [anon_sym_BSLASHGLStext] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6710),
    [anon_sym_BSLASHglsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsname] = ACTIONS(6710),
    [anon_sym_BSLASHGlsname] = ACTIONS(6710),
    [anon_sym_BSLASHGLSname] = ACTIONS(6710),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6710),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6710),
    [anon_sym_BSLASHacrshort] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6710),
    [anon_sym_BSLASHACRshort] = ACTIONS(6710),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrlong] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6710),
    [anon_sym_BSLASHACRlong] = ACTIONS(6710),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrfull] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6710),
    [anon_sym_BSLASHACRfull] = ACTIONS(6710),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHacs] = ACTIONS(6710),
    [anon_sym_BSLASHAcs] = ACTIONS(6710),
    [anon_sym_BSLASHacsp] = ACTIONS(6710),
    [anon_sym_BSLASHAcsp] = ACTIONS(6710),
    [anon_sym_BSLASHacl] = ACTIONS(6710),
    [anon_sym_BSLASHAcl] = ACTIONS(6710),
    [anon_sym_BSLASHaclp] = ACTIONS(6710),
    [anon_sym_BSLASHAclp] = ACTIONS(6710),
    [anon_sym_BSLASHacf] = ACTIONS(6710),
    [anon_sym_BSLASHAcf] = ACTIONS(6710),
    [anon_sym_BSLASHacfp] = ACTIONS(6710),
    [anon_sym_BSLASHAcfp] = ACTIONS(6710),
    [anon_sym_BSLASHac] = ACTIONS(6710),
    [anon_sym_BSLASHAc] = ACTIONS(6710),
    [anon_sym_BSLASHacp] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6710),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6710),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6710),
    [anon_sym_BSLASHcolor] = ACTIONS(6710),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6710),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6710),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6710),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6710),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6710),
    [anon_sym_BSLASHtext] = ACTIONS(6710),
    [anon_sym_BSLASHintertext] = ACTIONS(6710),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6710),
    [anon_sym_BSLASHurl] = ACTIONS(6710),
    [anon_sym_BSLASHhref] = ACTIONS(6710),
  },
  [1160] = {
    [sym_command_name] = ACTIONS(6682),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6684),
    [anon_sym_RBRACK] = ACTIONS(6684),
    [anon_sym_COMMA] = ACTIONS(6684),
    [anon_sym_EQ] = ACTIONS(6684),
    [anon_sym_LPAREN] = ACTIONS(6684),
    [anon_sym_RPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHpart] = ACTIONS(6682),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddpart] = ACTIONS(6682),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHchapter] = ACTIONS(6682),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddchap] = ACTIONS(6682),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsection] = ACTIONS(6682),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddsec] = ACTIONS(6682),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHitem] = ACTIONS(6682),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6684),
    [anon_sym_LBRACE] = ACTIONS(6684),
    [sym_word] = ACTIONS(6682),
    [sym_placeholder] = ACTIONS(6684),
    [anon_sym_PLUS] = ACTIONS(6684),
    [anon_sym_DASH] = ACTIONS(6684),
    [anon_sym_STAR] = ACTIONS(6684),
    [anon_sym_SLASH] = ACTIONS(6684),
    [anon_sym_LT] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6682),
    [anon_sym_BANG] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6682),
    [anon_sym_COLON] = ACTIONS(6682),
    [anon_sym_SQUOTE] = ACTIONS(6682),
    [anon_sym__] = ACTIONS(6684),
    [anon_sym_CARET] = ACTIONS(6684),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6684),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6684),
    [anon_sym_DOLLAR] = ACTIONS(6682),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHbegin] = ACTIONS(6682),
    [anon_sym_BSLASHend] = ACTIONS(6682),
    [anon_sym_BSLASHtitle] = ACTIONS(6682),
    [anon_sym_BSLASHauthor] = ACTIONS(6682),
    [anon_sym_BSLASHusepackage] = ACTIONS(6682),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6682),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6682),
    [anon_sym_BSLASHinclude] = ACTIONS(6682),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6682),
    [anon_sym_BSLASHinput] = ACTIONS(6682),
    [anon_sym_BSLASHsubfile] = ACTIONS(6682),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6682),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6682),
    [anon_sym_BSLASHbibliography] = ACTIONS(6682),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6682),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6682),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6682),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6682),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6682),
    [anon_sym_BSLASHimport] = ACTIONS(6682),
    [anon_sym_BSLASHsubimport] = ACTIONS(6682),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6682),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHcaption] = ACTIONS(6682),
    [anon_sym_BSLASHcite] = ACTIONS(6682),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCite] = ACTIONS(6682),
    [anon_sym_BSLASHnocite] = ACTIONS(6682),
    [anon_sym_BSLASHcitet] = ACTIONS(6682),
    [anon_sym_BSLASHcitep] = ACTIONS(6682),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteA] = ACTIONS(6682),
    [anon_sym_BSLASHciteR] = ACTIONS(6682),
    [anon_sym_BSLASHciteS] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6682),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteyear] = ACTIONS(6682),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitedate] = ACTIONS(6682),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteurl] = ACTIONS(6682),
    [anon_sym_BSLASHfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6682),
    [anon_sym_BSLASHcitealt] = ACTIONS(6682),
    [anon_sym_BSLASHcitealp] = ACTIONS(6682),
    [anon_sym_BSLASHcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHparencite] = ACTIONS(6682),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHParencite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHtextcite] = ACTIONS(6682),
    [anon_sym_BSLASHTextcite] = ACTIONS(6682),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHsupercite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite] = ACTIONS(6682),
    [anon_sym_BSLASHAutocite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHVolcite] = ACTIONS(6682),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHavolcite] = ACTIONS(6682),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHNotecite] = ACTIONS(6682),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHlabel] = ACTIONS(6682),
    [anon_sym_BSLASHref] = ACTIONS(6682),
    [anon_sym_BSLASHeqref] = ACTIONS(6682),
    [anon_sym_BSLASHvref] = ACTIONS(6682),
    [anon_sym_BSLASHVref] = ACTIONS(6682),
    [anon_sym_BSLASHautoref] = ACTIONS(6682),
    [anon_sym_BSLASHpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcref] = ACTIONS(6682),
    [anon_sym_BSLASHCref] = ACTIONS(6682),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnameCref] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHdef] = ACTIONS(6682),
    [anon_sym_BSLASHlet] = ACTIONS(6682),
    [anon_sym_BSLASHleft] = ACTIONS(6682),
    [anon_sym_BSLASHbigl] = ACTIONS(6682),
    [anon_sym_BSLASHBigl] = ACTIONS(6682),
    [anon_sym_BSLASHbiggl] = ACTIONS(6682),
    [anon_sym_BSLASHBiggl] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6682),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6682),
    [anon_sym_BSLASHgls] = ACTIONS(6682),
    [anon_sym_BSLASHGls] = ACTIONS(6682),
    [anon_sym_BSLASHGLS] = ACTIONS(6682),
    [anon_sym_BSLASHglspl] = ACTIONS(6682),
    [anon_sym_BSLASHGlspl] = ACTIONS(6682),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6682),
    [anon_sym_BSLASHglslink] = ACTIONS(6682),
    [anon_sym_BSLASHglstext] = ACTIONS(6682),
    [anon_sym_BSLASHGlstext] = ACTIONS(6682),
    [anon_sym_BSLASHGLStext] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6682),
    [anon_sym_BSLASHglsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsname] = ACTIONS(6682),
    [anon_sym_BSLASHGlsname] = ACTIONS(6682),
    [anon_sym_BSLASHGLSname] = ACTIONS(6682),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6682),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6682),
    [anon_sym_BSLASHacrshort] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6682),
    [anon_sym_BSLASHACRshort] = ACTIONS(6682),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrlong] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6682),
    [anon_sym_BSLASHACRlong] = ACTIONS(6682),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrfull] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6682),
    [anon_sym_BSLASHACRfull] = ACTIONS(6682),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHacs] = ACTIONS(6682),
    [anon_sym_BSLASHAcs] = ACTIONS(6682),
    [anon_sym_BSLASHacsp] = ACTIONS(6682),
    [anon_sym_BSLASHAcsp] = ACTIONS(6682),
    [anon_sym_BSLASHacl] = ACTIONS(6682),
    [anon_sym_BSLASHAcl] = ACTIONS(6682),
    [anon_sym_BSLASHaclp] = ACTIONS(6682),
    [anon_sym_BSLASHAclp] = ACTIONS(6682),
    [anon_sym_BSLASHacf] = ACTIONS(6682),
    [anon_sym_BSLASHAcf] = ACTIONS(6682),
    [anon_sym_BSLASHacfp] = ACTIONS(6682),
    [anon_sym_BSLASHAcfp] = ACTIONS(6682),
    [anon_sym_BSLASHac] = ACTIONS(6682),
    [anon_sym_BSLASHAc] = ACTIONS(6682),
    [anon_sym_BSLASHacp] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6682),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6682),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6682),
    [anon_sym_BSLASHcolor] = ACTIONS(6682),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6682),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6682),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6682),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6682),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6682),
    [anon_sym_BSLASHtext] = ACTIONS(6682),
    [anon_sym_BSLASHintertext] = ACTIONS(6682),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6682),
    [anon_sym_BSLASHurl] = ACTIONS(6682),
    [anon_sym_BSLASHhref] = ACTIONS(6682),
  },
  [1161] = {
    [sym_command_name] = ACTIONS(6678),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6678),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6680),
    [anon_sym_COMMA] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LPAREN] = ACTIONS(6680),
    [anon_sym_RPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHpart] = ACTIONS(6678),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddpart] = ACTIONS(6678),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHchapter] = ACTIONS(6678),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddchap] = ACTIONS(6678),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsection] = ACTIONS(6678),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddsec] = ACTIONS(6678),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHitem] = ACTIONS(6678),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6680),
    [anon_sym_LBRACE] = ACTIONS(6680),
    [sym_word] = ACTIONS(6678),
    [sym_placeholder] = ACTIONS(6680),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_DASH] = ACTIONS(6680),
    [anon_sym_STAR] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6678),
    [anon_sym_GT] = ACTIONS(6678),
    [anon_sym_BANG] = ACTIONS(6678),
    [anon_sym_PIPE] = ACTIONS(6678),
    [anon_sym_COLON] = ACTIONS(6678),
    [anon_sym_SQUOTE] = ACTIONS(6678),
    [anon_sym__] = ACTIONS(6680),
    [anon_sym_CARET] = ACTIONS(6680),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6680),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6680),
    [anon_sym_DOLLAR] = ACTIONS(6678),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHbegin] = ACTIONS(6678),
    [anon_sym_BSLASHend] = ACTIONS(6678),
    [anon_sym_BSLASHtitle] = ACTIONS(6678),
    [anon_sym_BSLASHauthor] = ACTIONS(6678),
    [anon_sym_BSLASHusepackage] = ACTIONS(6678),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6678),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6678),
    [anon_sym_BSLASHinclude] = ACTIONS(6678),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6678),
    [anon_sym_BSLASHinput] = ACTIONS(6678),
    [anon_sym_BSLASHsubfile] = ACTIONS(6678),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6678),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6678),
    [anon_sym_BSLASHbibliography] = ACTIONS(6678),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6678),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6678),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6678),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6678),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6678),
    [anon_sym_BSLASHimport] = ACTIONS(6678),
    [anon_sym_BSLASHsubimport] = ACTIONS(6678),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6678),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHcaption] = ACTIONS(6678),
    [anon_sym_BSLASHcite] = ACTIONS(6678),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCite] = ACTIONS(6678),
    [anon_sym_BSLASHnocite] = ACTIONS(6678),
    [anon_sym_BSLASHcitet] = ACTIONS(6678),
    [anon_sym_BSLASHcitep] = ACTIONS(6678),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteA] = ACTIONS(6678),
    [anon_sym_BSLASHciteR] = ACTIONS(6678),
    [anon_sym_BSLASHciteS] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6678),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteyear] = ACTIONS(6678),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitedate] = ACTIONS(6678),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteurl] = ACTIONS(6678),
    [anon_sym_BSLASHfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6678),
    [anon_sym_BSLASHcitealt] = ACTIONS(6678),
    [anon_sym_BSLASHcitealp] = ACTIONS(6678),
    [anon_sym_BSLASHcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHparencite] = ACTIONS(6678),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHParencite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHtextcite] = ACTIONS(6678),
    [anon_sym_BSLASHTextcite] = ACTIONS(6678),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHsupercite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite] = ACTIONS(6678),
    [anon_sym_BSLASHAutocite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHVolcite] = ACTIONS(6678),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHavolcite] = ACTIONS(6678),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHNotecite] = ACTIONS(6678),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHlabel] = ACTIONS(6678),
    [anon_sym_BSLASHref] = ACTIONS(6678),
    [anon_sym_BSLASHeqref] = ACTIONS(6678),
    [anon_sym_BSLASHvref] = ACTIONS(6678),
    [anon_sym_BSLASHVref] = ACTIONS(6678),
    [anon_sym_BSLASHautoref] = ACTIONS(6678),
    [anon_sym_BSLASHpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcref] = ACTIONS(6678),
    [anon_sym_BSLASHCref] = ACTIONS(6678),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnameCref] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHdef] = ACTIONS(6678),
    [anon_sym_BSLASHlet] = ACTIONS(6678),
    [anon_sym_BSLASHleft] = ACTIONS(6678),
    [anon_sym_BSLASHbigl] = ACTIONS(6678),
    [anon_sym_BSLASHBigl] = ACTIONS(6678),
    [anon_sym_BSLASHbiggl] = ACTIONS(6678),
    [anon_sym_BSLASHBiggl] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6678),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6678),
    [anon_sym_BSLASHgls] = ACTIONS(6678),
    [anon_sym_BSLASHGls] = ACTIONS(6678),
    [anon_sym_BSLASHGLS] = ACTIONS(6678),
    [anon_sym_BSLASHglspl] = ACTIONS(6678),
    [anon_sym_BSLASHGlspl] = ACTIONS(6678),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6678),
    [anon_sym_BSLASHglslink] = ACTIONS(6678),
    [anon_sym_BSLASHglstext] = ACTIONS(6678),
    [anon_sym_BSLASHGlstext] = ACTIONS(6678),
    [anon_sym_BSLASHGLStext] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6678),
    [anon_sym_BSLASHglsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsname] = ACTIONS(6678),
    [anon_sym_BSLASHGlsname] = ACTIONS(6678),
    [anon_sym_BSLASHGLSname] = ACTIONS(6678),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6678),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6678),
    [anon_sym_BSLASHacrshort] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6678),
    [anon_sym_BSLASHACRshort] = ACTIONS(6678),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrlong] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6678),
    [anon_sym_BSLASHACRlong] = ACTIONS(6678),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrfull] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6678),
    [anon_sym_BSLASHACRfull] = ACTIONS(6678),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHacs] = ACTIONS(6678),
    [anon_sym_BSLASHAcs] = ACTIONS(6678),
    [anon_sym_BSLASHacsp] = ACTIONS(6678),
    [anon_sym_BSLASHAcsp] = ACTIONS(6678),
    [anon_sym_BSLASHacl] = ACTIONS(6678),
    [anon_sym_BSLASHAcl] = ACTIONS(6678),
    [anon_sym_BSLASHaclp] = ACTIONS(6678),
    [anon_sym_BSLASHAclp] = ACTIONS(6678),
    [anon_sym_BSLASHacf] = ACTIONS(6678),
    [anon_sym_BSLASHAcf] = ACTIONS(6678),
    [anon_sym_BSLASHacfp] = ACTIONS(6678),
    [anon_sym_BSLASHAcfp] = ACTIONS(6678),
    [anon_sym_BSLASHac] = ACTIONS(6678),
    [anon_sym_BSLASHAc] = ACTIONS(6678),
    [anon_sym_BSLASHacp] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6678),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6678),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6678),
    [anon_sym_BSLASHcolor] = ACTIONS(6678),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6678),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6678),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6678),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6678),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6678),
    [anon_sym_BSLASHtext] = ACTIONS(6678),
    [anon_sym_BSLASHintertext] = ACTIONS(6678),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6678),
    [anon_sym_BSLASHurl] = ACTIONS(6678),
    [anon_sym_BSLASHhref] = ACTIONS(6678),
  },
  [1162] = {
    [sym_command_name] = ACTIONS(6674),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6674),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_RBRACK] = ACTIONS(6676),
    [anon_sym_COMMA] = ACTIONS(6676),
    [anon_sym_EQ] = ACTIONS(6676),
    [anon_sym_LPAREN] = ACTIONS(6676),
    [anon_sym_RPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHpart] = ACTIONS(6674),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddpart] = ACTIONS(6674),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHchapter] = ACTIONS(6674),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddchap] = ACTIONS(6674),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsection] = ACTIONS(6674),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddsec] = ACTIONS(6674),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHitem] = ACTIONS(6674),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(6676),
    [sym_word] = ACTIONS(6674),
    [sym_placeholder] = ACTIONS(6676),
    [anon_sym_PLUS] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6676),
    [anon_sym_STAR] = ACTIONS(6676),
    [anon_sym_SLASH] = ACTIONS(6676),
    [anon_sym_LT] = ACTIONS(6674),
    [anon_sym_GT] = ACTIONS(6674),
    [anon_sym_BANG] = ACTIONS(6674),
    [anon_sym_PIPE] = ACTIONS(6674),
    [anon_sym_COLON] = ACTIONS(6674),
    [anon_sym_SQUOTE] = ACTIONS(6674),
    [anon_sym__] = ACTIONS(6676),
    [anon_sym_CARET] = ACTIONS(6676),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6676),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6676),
    [anon_sym_DOLLAR] = ACTIONS(6674),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHbegin] = ACTIONS(6674),
    [anon_sym_BSLASHend] = ACTIONS(6674),
    [anon_sym_BSLASHtitle] = ACTIONS(6674),
    [anon_sym_BSLASHauthor] = ACTIONS(6674),
    [anon_sym_BSLASHusepackage] = ACTIONS(6674),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6674),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6674),
    [anon_sym_BSLASHinclude] = ACTIONS(6674),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6674),
    [anon_sym_BSLASHinput] = ACTIONS(6674),
    [anon_sym_BSLASHsubfile] = ACTIONS(6674),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6674),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6674),
    [anon_sym_BSLASHbibliography] = ACTIONS(6674),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6674),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6674),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6674),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6674),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6674),
    [anon_sym_BSLASHimport] = ACTIONS(6674),
    [anon_sym_BSLASHsubimport] = ACTIONS(6674),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6674),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHcaption] = ACTIONS(6674),
    [anon_sym_BSLASHcite] = ACTIONS(6674),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCite] = ACTIONS(6674),
    [anon_sym_BSLASHnocite] = ACTIONS(6674),
    [anon_sym_BSLASHcitet] = ACTIONS(6674),
    [anon_sym_BSLASHcitep] = ACTIONS(6674),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteA] = ACTIONS(6674),
    [anon_sym_BSLASHciteR] = ACTIONS(6674),
    [anon_sym_BSLASHciteS] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6674),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteyear] = ACTIONS(6674),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitedate] = ACTIONS(6674),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteurl] = ACTIONS(6674),
    [anon_sym_BSLASHfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6674),
    [anon_sym_BSLASHcitealt] = ACTIONS(6674),
    [anon_sym_BSLASHcitealp] = ACTIONS(6674),
    [anon_sym_BSLASHcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHparencite] = ACTIONS(6674),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHParencite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHtextcite] = ACTIONS(6674),
    [anon_sym_BSLASHTextcite] = ACTIONS(6674),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHsupercite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite] = ACTIONS(6674),
    [anon_sym_BSLASHAutocite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHVolcite] = ACTIONS(6674),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHavolcite] = ACTIONS(6674),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHNotecite] = ACTIONS(6674),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHlabel] = ACTIONS(6674),
    [anon_sym_BSLASHref] = ACTIONS(6674),
    [anon_sym_BSLASHeqref] = ACTIONS(6674),
    [anon_sym_BSLASHvref] = ACTIONS(6674),
    [anon_sym_BSLASHVref] = ACTIONS(6674),
    [anon_sym_BSLASHautoref] = ACTIONS(6674),
    [anon_sym_BSLASHpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcref] = ACTIONS(6674),
    [anon_sym_BSLASHCref] = ACTIONS(6674),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnameCref] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHdef] = ACTIONS(6674),
    [anon_sym_BSLASHlet] = ACTIONS(6674),
    [anon_sym_BSLASHleft] = ACTIONS(6674),
    [anon_sym_BSLASHbigl] = ACTIONS(6674),
    [anon_sym_BSLASHBigl] = ACTIONS(6674),
    [anon_sym_BSLASHbiggl] = ACTIONS(6674),
    [anon_sym_BSLASHBiggl] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6674),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6674),
    [anon_sym_BSLASHgls] = ACTIONS(6674),
    [anon_sym_BSLASHGls] = ACTIONS(6674),
    [anon_sym_BSLASHGLS] = ACTIONS(6674),
    [anon_sym_BSLASHglspl] = ACTIONS(6674),
    [anon_sym_BSLASHGlspl] = ACTIONS(6674),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6674),
    [anon_sym_BSLASHglslink] = ACTIONS(6674),
    [anon_sym_BSLASHglstext] = ACTIONS(6674),
    [anon_sym_BSLASHGlstext] = ACTIONS(6674),
    [anon_sym_BSLASHGLStext] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6674),
    [anon_sym_BSLASHglsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsname] = ACTIONS(6674),
    [anon_sym_BSLASHGlsname] = ACTIONS(6674),
    [anon_sym_BSLASHGLSname] = ACTIONS(6674),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6674),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6674),
    [anon_sym_BSLASHacrshort] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6674),
    [anon_sym_BSLASHACRshort] = ACTIONS(6674),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrlong] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6674),
    [anon_sym_BSLASHACRlong] = ACTIONS(6674),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrfull] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6674),
    [anon_sym_BSLASHACRfull] = ACTIONS(6674),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHacs] = ACTIONS(6674),
    [anon_sym_BSLASHAcs] = ACTIONS(6674),
    [anon_sym_BSLASHacsp] = ACTIONS(6674),
    [anon_sym_BSLASHAcsp] = ACTIONS(6674),
    [anon_sym_BSLASHacl] = ACTIONS(6674),
    [anon_sym_BSLASHAcl] = ACTIONS(6674),
    [anon_sym_BSLASHaclp] = ACTIONS(6674),
    [anon_sym_BSLASHAclp] = ACTIONS(6674),
    [anon_sym_BSLASHacf] = ACTIONS(6674),
    [anon_sym_BSLASHAcf] = ACTIONS(6674),
    [anon_sym_BSLASHacfp] = ACTIONS(6674),
    [anon_sym_BSLASHAcfp] = ACTIONS(6674),
    [anon_sym_BSLASHac] = ACTIONS(6674),
    [anon_sym_BSLASHAc] = ACTIONS(6674),
    [anon_sym_BSLASHacp] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6674),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6674),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6674),
    [anon_sym_BSLASHcolor] = ACTIONS(6674),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6674),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6674),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6674),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6674),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6674),
    [anon_sym_BSLASHtext] = ACTIONS(6674),
    [anon_sym_BSLASHintertext] = ACTIONS(6674),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6674),
    [anon_sym_BSLASHurl] = ACTIONS(6674),
    [anon_sym_BSLASHhref] = ACTIONS(6674),
  },
  [1163] = {
    [sym_command_name] = ACTIONS(6666),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6666),
    [anon_sym_LBRACK] = ACTIONS(6668),
    [anon_sym_RBRACK] = ACTIONS(6668),
    [anon_sym_COMMA] = ACTIONS(6668),
    [anon_sym_EQ] = ACTIONS(6668),
    [anon_sym_LPAREN] = ACTIONS(6668),
    [anon_sym_RPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHpart] = ACTIONS(6666),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddpart] = ACTIONS(6666),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHchapter] = ACTIONS(6666),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddchap] = ACTIONS(6666),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsection] = ACTIONS(6666),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddsec] = ACTIONS(6666),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHitem] = ACTIONS(6666),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6668),
    [anon_sym_LBRACE] = ACTIONS(6668),
    [sym_word] = ACTIONS(6666),
    [sym_placeholder] = ACTIONS(6668),
    [anon_sym_PLUS] = ACTIONS(6668),
    [anon_sym_DASH] = ACTIONS(6668),
    [anon_sym_STAR] = ACTIONS(6668),
    [anon_sym_SLASH] = ACTIONS(6668),
    [anon_sym_LT] = ACTIONS(6666),
    [anon_sym_GT] = ACTIONS(6666),
    [anon_sym_BANG] = ACTIONS(6666),
    [anon_sym_PIPE] = ACTIONS(6666),
    [anon_sym_COLON] = ACTIONS(6666),
    [anon_sym_SQUOTE] = ACTIONS(6666),
    [anon_sym__] = ACTIONS(6668),
    [anon_sym_CARET] = ACTIONS(6668),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6668),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6668),
    [anon_sym_DOLLAR] = ACTIONS(6666),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHbegin] = ACTIONS(6666),
    [anon_sym_BSLASHend] = ACTIONS(6666),
    [anon_sym_BSLASHtitle] = ACTIONS(6666),
    [anon_sym_BSLASHauthor] = ACTIONS(6666),
    [anon_sym_BSLASHusepackage] = ACTIONS(6666),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6666),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6666),
    [anon_sym_BSLASHinclude] = ACTIONS(6666),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6666),
    [anon_sym_BSLASHinput] = ACTIONS(6666),
    [anon_sym_BSLASHsubfile] = ACTIONS(6666),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6666),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6666),
    [anon_sym_BSLASHbibliography] = ACTIONS(6666),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6666),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6666),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6666),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6666),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6666),
    [anon_sym_BSLASHimport] = ACTIONS(6666),
    [anon_sym_BSLASHsubimport] = ACTIONS(6666),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6666),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHcaption] = ACTIONS(6666),
    [anon_sym_BSLASHcite] = ACTIONS(6666),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCite] = ACTIONS(6666),
    [anon_sym_BSLASHnocite] = ACTIONS(6666),
    [anon_sym_BSLASHcitet] = ACTIONS(6666),
    [anon_sym_BSLASHcitep] = ACTIONS(6666),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteA] = ACTIONS(6666),
    [anon_sym_BSLASHciteR] = ACTIONS(6666),
    [anon_sym_BSLASHciteS] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6666),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteyear] = ACTIONS(6666),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitedate] = ACTIONS(6666),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteurl] = ACTIONS(6666),
    [anon_sym_BSLASHfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6666),
    [anon_sym_BSLASHcitealt] = ACTIONS(6666),
    [anon_sym_BSLASHcitealp] = ACTIONS(6666),
    [anon_sym_BSLASHcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHparencite] = ACTIONS(6666),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHParencite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHtextcite] = ACTIONS(6666),
    [anon_sym_BSLASHTextcite] = ACTIONS(6666),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHsupercite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite] = ACTIONS(6666),
    [anon_sym_BSLASHAutocite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHVolcite] = ACTIONS(6666),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHavolcite] = ACTIONS(6666),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHNotecite] = ACTIONS(6666),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHlabel] = ACTIONS(6666),
    [anon_sym_BSLASHref] = ACTIONS(6666),
    [anon_sym_BSLASHeqref] = ACTIONS(6666),
    [anon_sym_BSLASHvref] = ACTIONS(6666),
    [anon_sym_BSLASHVref] = ACTIONS(6666),
    [anon_sym_BSLASHautoref] = ACTIONS(6666),
    [anon_sym_BSLASHpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcref] = ACTIONS(6666),
    [anon_sym_BSLASHCref] = ACTIONS(6666),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnameCref] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHdef] = ACTIONS(6666),
    [anon_sym_BSLASHlet] = ACTIONS(6666),
    [anon_sym_BSLASHleft] = ACTIONS(6666),
    [anon_sym_BSLASHbigl] = ACTIONS(6666),
    [anon_sym_BSLASHBigl] = ACTIONS(6666),
    [anon_sym_BSLASHbiggl] = ACTIONS(6666),
    [anon_sym_BSLASHBiggl] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6666),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6666),
    [anon_sym_BSLASHgls] = ACTIONS(6666),
    [anon_sym_BSLASHGls] = ACTIONS(6666),
    [anon_sym_BSLASHGLS] = ACTIONS(6666),
    [anon_sym_BSLASHglspl] = ACTIONS(6666),
    [anon_sym_BSLASHGlspl] = ACTIONS(6666),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6666),
    [anon_sym_BSLASHglslink] = ACTIONS(6666),
    [anon_sym_BSLASHglstext] = ACTIONS(6666),
    [anon_sym_BSLASHGlstext] = ACTIONS(6666),
    [anon_sym_BSLASHGLStext] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6666),
    [anon_sym_BSLASHglsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsname] = ACTIONS(6666),
    [anon_sym_BSLASHGlsname] = ACTIONS(6666),
    [anon_sym_BSLASHGLSname] = ACTIONS(6666),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6666),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6666),
    [anon_sym_BSLASHacrshort] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6666),
    [anon_sym_BSLASHACRshort] = ACTIONS(6666),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrlong] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6666),
    [anon_sym_BSLASHACRlong] = ACTIONS(6666),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrfull] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6666),
    [anon_sym_BSLASHACRfull] = ACTIONS(6666),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHacs] = ACTIONS(6666),
    [anon_sym_BSLASHAcs] = ACTIONS(6666),
    [anon_sym_BSLASHacsp] = ACTIONS(6666),
    [anon_sym_BSLASHAcsp] = ACTIONS(6666),
    [anon_sym_BSLASHacl] = ACTIONS(6666),
    [anon_sym_BSLASHAcl] = ACTIONS(6666),
    [anon_sym_BSLASHaclp] = ACTIONS(6666),
    [anon_sym_BSLASHAclp] = ACTIONS(6666),
    [anon_sym_BSLASHacf] = ACTIONS(6666),
    [anon_sym_BSLASHAcf] = ACTIONS(6666),
    [anon_sym_BSLASHacfp] = ACTIONS(6666),
    [anon_sym_BSLASHAcfp] = ACTIONS(6666),
    [anon_sym_BSLASHac] = ACTIONS(6666),
    [anon_sym_BSLASHAc] = ACTIONS(6666),
    [anon_sym_BSLASHacp] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6666),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6666),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6666),
    [anon_sym_BSLASHcolor] = ACTIONS(6666),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6666),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6666),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6666),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6666),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6666),
    [anon_sym_BSLASHtext] = ACTIONS(6666),
    [anon_sym_BSLASHintertext] = ACTIONS(6666),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6666),
    [anon_sym_BSLASHurl] = ACTIONS(6666),
    [anon_sym_BSLASHhref] = ACTIONS(6666),
  },
  [1164] = {
    [sym_command_name] = ACTIONS(6662),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6662),
    [anon_sym_LBRACK] = ACTIONS(6664),
    [anon_sym_RBRACK] = ACTIONS(6664),
    [anon_sym_COMMA] = ACTIONS(6664),
    [anon_sym_EQ] = ACTIONS(6664),
    [anon_sym_LPAREN] = ACTIONS(6664),
    [anon_sym_RPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHpart] = ACTIONS(6662),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddpart] = ACTIONS(6662),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHchapter] = ACTIONS(6662),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddchap] = ACTIONS(6662),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsection] = ACTIONS(6662),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddsec] = ACTIONS(6662),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHitem] = ACTIONS(6662),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6664),
    [anon_sym_LBRACE] = ACTIONS(6664),
    [sym_word] = ACTIONS(6662),
    [sym_placeholder] = ACTIONS(6664),
    [anon_sym_PLUS] = ACTIONS(6664),
    [anon_sym_DASH] = ACTIONS(6664),
    [anon_sym_STAR] = ACTIONS(6664),
    [anon_sym_SLASH] = ACTIONS(6664),
    [anon_sym_LT] = ACTIONS(6662),
    [anon_sym_GT] = ACTIONS(6662),
    [anon_sym_BANG] = ACTIONS(6662),
    [anon_sym_PIPE] = ACTIONS(6662),
    [anon_sym_COLON] = ACTIONS(6662),
    [anon_sym_SQUOTE] = ACTIONS(6662),
    [anon_sym__] = ACTIONS(6664),
    [anon_sym_CARET] = ACTIONS(6664),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6664),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6664),
    [anon_sym_DOLLAR] = ACTIONS(6662),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHbegin] = ACTIONS(6662),
    [anon_sym_BSLASHend] = ACTIONS(6662),
    [anon_sym_BSLASHtitle] = ACTIONS(6662),
    [anon_sym_BSLASHauthor] = ACTIONS(6662),
    [anon_sym_BSLASHusepackage] = ACTIONS(6662),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6662),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6662),
    [anon_sym_BSLASHinclude] = ACTIONS(6662),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6662),
    [anon_sym_BSLASHinput] = ACTIONS(6662),
    [anon_sym_BSLASHsubfile] = ACTIONS(6662),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6662),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6662),
    [anon_sym_BSLASHbibliography] = ACTIONS(6662),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6662),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6662),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6662),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6662),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6662),
    [anon_sym_BSLASHimport] = ACTIONS(6662),
    [anon_sym_BSLASHsubimport] = ACTIONS(6662),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6662),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHcaption] = ACTIONS(6662),
    [anon_sym_BSLASHcite] = ACTIONS(6662),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCite] = ACTIONS(6662),
    [anon_sym_BSLASHnocite] = ACTIONS(6662),
    [anon_sym_BSLASHcitet] = ACTIONS(6662),
    [anon_sym_BSLASHcitep] = ACTIONS(6662),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteA] = ACTIONS(6662),
    [anon_sym_BSLASHciteR] = ACTIONS(6662),
    [anon_sym_BSLASHciteS] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6662),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteyear] = ACTIONS(6662),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitedate] = ACTIONS(6662),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteurl] = ACTIONS(6662),
    [anon_sym_BSLASHfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6662),
    [anon_sym_BSLASHcitealt] = ACTIONS(6662),
    [anon_sym_BSLASHcitealp] = ACTIONS(6662),
    [anon_sym_BSLASHcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHparencite] = ACTIONS(6662),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHParencite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHtextcite] = ACTIONS(6662),
    [anon_sym_BSLASHTextcite] = ACTIONS(6662),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHsupercite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite] = ACTIONS(6662),
    [anon_sym_BSLASHAutocite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHVolcite] = ACTIONS(6662),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHavolcite] = ACTIONS(6662),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHNotecite] = ACTIONS(6662),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHlabel] = ACTIONS(6662),
    [anon_sym_BSLASHref] = ACTIONS(6662),
    [anon_sym_BSLASHeqref] = ACTIONS(6662),
    [anon_sym_BSLASHvref] = ACTIONS(6662),
    [anon_sym_BSLASHVref] = ACTIONS(6662),
    [anon_sym_BSLASHautoref] = ACTIONS(6662),
    [anon_sym_BSLASHpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcref] = ACTIONS(6662),
    [anon_sym_BSLASHCref] = ACTIONS(6662),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnameCref] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHdef] = ACTIONS(6662),
    [anon_sym_BSLASHlet] = ACTIONS(6662),
    [anon_sym_BSLASHleft] = ACTIONS(6662),
    [anon_sym_BSLASHbigl] = ACTIONS(6662),
    [anon_sym_BSLASHBigl] = ACTIONS(6662),
    [anon_sym_BSLASHbiggl] = ACTIONS(6662),
    [anon_sym_BSLASHBiggl] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6662),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6662),
    [anon_sym_BSLASHgls] = ACTIONS(6662),
    [anon_sym_BSLASHGls] = ACTIONS(6662),
    [anon_sym_BSLASHGLS] = ACTIONS(6662),
    [anon_sym_BSLASHglspl] = ACTIONS(6662),
    [anon_sym_BSLASHGlspl] = ACTIONS(6662),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6662),
    [anon_sym_BSLASHglslink] = ACTIONS(6662),
    [anon_sym_BSLASHglstext] = ACTIONS(6662),
    [anon_sym_BSLASHGlstext] = ACTIONS(6662),
    [anon_sym_BSLASHGLStext] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6662),
    [anon_sym_BSLASHglsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsname] = ACTIONS(6662),
    [anon_sym_BSLASHGlsname] = ACTIONS(6662),
    [anon_sym_BSLASHGLSname] = ACTIONS(6662),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6662),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6662),
    [anon_sym_BSLASHacrshort] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6662),
    [anon_sym_BSLASHACRshort] = ACTIONS(6662),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrlong] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6662),
    [anon_sym_BSLASHACRlong] = ACTIONS(6662),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrfull] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6662),
    [anon_sym_BSLASHACRfull] = ACTIONS(6662),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHacs] = ACTIONS(6662),
    [anon_sym_BSLASHAcs] = ACTIONS(6662),
    [anon_sym_BSLASHacsp] = ACTIONS(6662),
    [anon_sym_BSLASHAcsp] = ACTIONS(6662),
    [anon_sym_BSLASHacl] = ACTIONS(6662),
    [anon_sym_BSLASHAcl] = ACTIONS(6662),
    [anon_sym_BSLASHaclp] = ACTIONS(6662),
    [anon_sym_BSLASHAclp] = ACTIONS(6662),
    [anon_sym_BSLASHacf] = ACTIONS(6662),
    [anon_sym_BSLASHAcf] = ACTIONS(6662),
    [anon_sym_BSLASHacfp] = ACTIONS(6662),
    [anon_sym_BSLASHAcfp] = ACTIONS(6662),
    [anon_sym_BSLASHac] = ACTIONS(6662),
    [anon_sym_BSLASHAc] = ACTIONS(6662),
    [anon_sym_BSLASHacp] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6662),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6662),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6662),
    [anon_sym_BSLASHcolor] = ACTIONS(6662),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6662),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6662),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6662),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6662),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6662),
    [anon_sym_BSLASHtext] = ACTIONS(6662),
    [anon_sym_BSLASHintertext] = ACTIONS(6662),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6662),
    [anon_sym_BSLASHurl] = ACTIONS(6662),
    [anon_sym_BSLASHhref] = ACTIONS(6662),
  },
  [1165] = {
    [sym_command_name] = ACTIONS(6658),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6658),
    [anon_sym_LBRACK] = ACTIONS(6660),
    [anon_sym_RBRACK] = ACTIONS(6660),
    [anon_sym_COMMA] = ACTIONS(6660),
    [anon_sym_EQ] = ACTIONS(6660),
    [anon_sym_LPAREN] = ACTIONS(6660),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHpart] = ACTIONS(6658),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddpart] = ACTIONS(6658),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHchapter] = ACTIONS(6658),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddchap] = ACTIONS(6658),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsection] = ACTIONS(6658),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddsec] = ACTIONS(6658),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHitem] = ACTIONS(6658),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6660),
    [anon_sym_LBRACE] = ACTIONS(6660),
    [sym_word] = ACTIONS(6658),
    [sym_placeholder] = ACTIONS(6660),
    [anon_sym_PLUS] = ACTIONS(6660),
    [anon_sym_DASH] = ACTIONS(6660),
    [anon_sym_STAR] = ACTIONS(6660),
    [anon_sym_SLASH] = ACTIONS(6660),
    [anon_sym_LT] = ACTIONS(6658),
    [anon_sym_GT] = ACTIONS(6658),
    [anon_sym_BANG] = ACTIONS(6658),
    [anon_sym_PIPE] = ACTIONS(6658),
    [anon_sym_COLON] = ACTIONS(6658),
    [anon_sym_SQUOTE] = ACTIONS(6658),
    [anon_sym__] = ACTIONS(6660),
    [anon_sym_CARET] = ACTIONS(6660),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6660),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6660),
    [anon_sym_DOLLAR] = ACTIONS(6658),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHbegin] = ACTIONS(6658),
    [anon_sym_BSLASHend] = ACTIONS(6658),
    [anon_sym_BSLASHtitle] = ACTIONS(6658),
    [anon_sym_BSLASHauthor] = ACTIONS(6658),
    [anon_sym_BSLASHusepackage] = ACTIONS(6658),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6658),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6658),
    [anon_sym_BSLASHinclude] = ACTIONS(6658),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6658),
    [anon_sym_BSLASHinput] = ACTIONS(6658),
    [anon_sym_BSLASHsubfile] = ACTIONS(6658),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6658),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6658),
    [anon_sym_BSLASHbibliography] = ACTIONS(6658),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6658),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6658),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6658),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6658),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6658),
    [anon_sym_BSLASHimport] = ACTIONS(6658),
    [anon_sym_BSLASHsubimport] = ACTIONS(6658),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6658),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHcaption] = ACTIONS(6658),
    [anon_sym_BSLASHcite] = ACTIONS(6658),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCite] = ACTIONS(6658),
    [anon_sym_BSLASHnocite] = ACTIONS(6658),
    [anon_sym_BSLASHcitet] = ACTIONS(6658),
    [anon_sym_BSLASHcitep] = ACTIONS(6658),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteA] = ACTIONS(6658),
    [anon_sym_BSLASHciteR] = ACTIONS(6658),
    [anon_sym_BSLASHciteS] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6658),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteyear] = ACTIONS(6658),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitedate] = ACTIONS(6658),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteurl] = ACTIONS(6658),
    [anon_sym_BSLASHfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6658),
    [anon_sym_BSLASHcitealt] = ACTIONS(6658),
    [anon_sym_BSLASHcitealp] = ACTIONS(6658),
    [anon_sym_BSLASHcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHparencite] = ACTIONS(6658),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHParencite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHtextcite] = ACTIONS(6658),
    [anon_sym_BSLASHTextcite] = ACTIONS(6658),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHsupercite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite] = ACTIONS(6658),
    [anon_sym_BSLASHAutocite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHVolcite] = ACTIONS(6658),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHavolcite] = ACTIONS(6658),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHNotecite] = ACTIONS(6658),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHlabel] = ACTIONS(6658),
    [anon_sym_BSLASHref] = ACTIONS(6658),
    [anon_sym_BSLASHeqref] = ACTIONS(6658),
    [anon_sym_BSLASHvref] = ACTIONS(6658),
    [anon_sym_BSLASHVref] = ACTIONS(6658),
    [anon_sym_BSLASHautoref] = ACTIONS(6658),
    [anon_sym_BSLASHpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcref] = ACTIONS(6658),
    [anon_sym_BSLASHCref] = ACTIONS(6658),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnameCref] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHdef] = ACTIONS(6658),
    [anon_sym_BSLASHlet] = ACTIONS(6658),
    [anon_sym_BSLASHleft] = ACTIONS(6658),
    [anon_sym_BSLASHbigl] = ACTIONS(6658),
    [anon_sym_BSLASHBigl] = ACTIONS(6658),
    [anon_sym_BSLASHbiggl] = ACTIONS(6658),
    [anon_sym_BSLASHBiggl] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6658),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6658),
    [anon_sym_BSLASHgls] = ACTIONS(6658),
    [anon_sym_BSLASHGls] = ACTIONS(6658),
    [anon_sym_BSLASHGLS] = ACTIONS(6658),
    [anon_sym_BSLASHglspl] = ACTIONS(6658),
    [anon_sym_BSLASHGlspl] = ACTIONS(6658),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6658),
    [anon_sym_BSLASHglslink] = ACTIONS(6658),
    [anon_sym_BSLASHglstext] = ACTIONS(6658),
    [anon_sym_BSLASHGlstext] = ACTIONS(6658),
    [anon_sym_BSLASHGLStext] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6658),
    [anon_sym_BSLASHglsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsname] = ACTIONS(6658),
    [anon_sym_BSLASHGlsname] = ACTIONS(6658),
    [anon_sym_BSLASHGLSname] = ACTIONS(6658),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6658),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6658),
    [anon_sym_BSLASHacrshort] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6658),
    [anon_sym_BSLASHACRshort] = ACTIONS(6658),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrlong] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6658),
    [anon_sym_BSLASHACRlong] = ACTIONS(6658),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrfull] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6658),
    [anon_sym_BSLASHACRfull] = ACTIONS(6658),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHacs] = ACTIONS(6658),
    [anon_sym_BSLASHAcs] = ACTIONS(6658),
    [anon_sym_BSLASHacsp] = ACTIONS(6658),
    [anon_sym_BSLASHAcsp] = ACTIONS(6658),
    [anon_sym_BSLASHacl] = ACTIONS(6658),
    [anon_sym_BSLASHAcl] = ACTIONS(6658),
    [anon_sym_BSLASHaclp] = ACTIONS(6658),
    [anon_sym_BSLASHAclp] = ACTIONS(6658),
    [anon_sym_BSLASHacf] = ACTIONS(6658),
    [anon_sym_BSLASHAcf] = ACTIONS(6658),
    [anon_sym_BSLASHacfp] = ACTIONS(6658),
    [anon_sym_BSLASHAcfp] = ACTIONS(6658),
    [anon_sym_BSLASHac] = ACTIONS(6658),
    [anon_sym_BSLASHAc] = ACTIONS(6658),
    [anon_sym_BSLASHacp] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6658),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6658),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6658),
    [anon_sym_BSLASHcolor] = ACTIONS(6658),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6658),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6658),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6658),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6658),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6658),
    [anon_sym_BSLASHtext] = ACTIONS(6658),
    [anon_sym_BSLASHintertext] = ACTIONS(6658),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6658),
    [anon_sym_BSLASHurl] = ACTIONS(6658),
    [anon_sym_BSLASHhref] = ACTIONS(6658),
  },
  [1166] = {
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHpart] = ACTIONS(6502),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddpart] = ACTIONS(6502),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHchapter] = ACTIONS(6502),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddchap] = ACTIONS(6502),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsection] = ACTIONS(6502),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddsec] = ACTIONS(6502),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHitem] = ACTIONS(6502),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6504),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6504),
    [anon_sym_DOLLAR] = ACTIONS(6502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHbegin] = ACTIONS(6502),
    [anon_sym_BSLASHend] = ACTIONS(6502),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHleft] = ACTIONS(6502),
    [anon_sym_BSLASHbigl] = ACTIONS(6502),
    [anon_sym_BSLASHBigl] = ACTIONS(6502),
    [anon_sym_BSLASHbiggl] = ACTIONS(6502),
    [anon_sym_BSLASHBiggl] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHtext] = ACTIONS(6502),
    [anon_sym_BSLASHintertext] = ACTIONS(6502),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [1167] = {
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHpart] = ACTIONS(6282),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddpart] = ACTIONS(6282),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHchapter] = ACTIONS(6282),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddchap] = ACTIONS(6282),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsection] = ACTIONS(6282),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddsec] = ACTIONS(6282),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHitem] = ACTIONS(6282),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6284),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6284),
    [anon_sym_DOLLAR] = ACTIONS(6282),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6284),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHbegin] = ACTIONS(6282),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHleft] = ACTIONS(6282),
    [anon_sym_BSLASHbigl] = ACTIONS(6282),
    [anon_sym_BSLASHBigl] = ACTIONS(6282),
    [anon_sym_BSLASHbiggl] = ACTIONS(6282),
    [anon_sym_BSLASHBiggl] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHtext] = ACTIONS(6282),
    [anon_sym_BSLASHintertext] = ACTIONS(6282),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [1168] = {
    [sym_command_name] = ACTIONS(6622),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6622),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_RBRACK] = ACTIONS(6624),
    [anon_sym_COMMA] = ACTIONS(6624),
    [anon_sym_EQ] = ACTIONS(6624),
    [anon_sym_LPAREN] = ACTIONS(6624),
    [anon_sym_RPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHpart] = ACTIONS(6622),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddpart] = ACTIONS(6622),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHchapter] = ACTIONS(6622),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddchap] = ACTIONS(6622),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsection] = ACTIONS(6622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddsec] = ACTIONS(6622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHitem] = ACTIONS(6622),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(6624),
    [sym_word] = ACTIONS(6622),
    [sym_placeholder] = ACTIONS(6624),
    [anon_sym_PLUS] = ACTIONS(6624),
    [anon_sym_DASH] = ACTIONS(6624),
    [anon_sym_STAR] = ACTIONS(6624),
    [anon_sym_SLASH] = ACTIONS(6624),
    [anon_sym_LT] = ACTIONS(6622),
    [anon_sym_GT] = ACTIONS(6622),
    [anon_sym_BANG] = ACTIONS(6622),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_COLON] = ACTIONS(6622),
    [anon_sym_SQUOTE] = ACTIONS(6622),
    [anon_sym__] = ACTIONS(6624),
    [anon_sym_CARET] = ACTIONS(6624),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6624),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6624),
    [anon_sym_DOLLAR] = ACTIONS(6622),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6624),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHbegin] = ACTIONS(6622),
    [anon_sym_BSLASHtitle] = ACTIONS(6622),
    [anon_sym_BSLASHauthor] = ACTIONS(6622),
    [anon_sym_BSLASHusepackage] = ACTIONS(6622),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6622),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6622),
    [anon_sym_BSLASHinclude] = ACTIONS(6622),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6622),
    [anon_sym_BSLASHinput] = ACTIONS(6622),
    [anon_sym_BSLASHsubfile] = ACTIONS(6622),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6622),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6622),
    [anon_sym_BSLASHbibliography] = ACTIONS(6622),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6622),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6622),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6622),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6622),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6622),
    [anon_sym_BSLASHimport] = ACTIONS(6622),
    [anon_sym_BSLASHsubimport] = ACTIONS(6622),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6622),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHcaption] = ACTIONS(6622),
    [anon_sym_BSLASHcite] = ACTIONS(6622),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCite] = ACTIONS(6622),
    [anon_sym_BSLASHnocite] = ACTIONS(6622),
    [anon_sym_BSLASHcitet] = ACTIONS(6622),
    [anon_sym_BSLASHcitep] = ACTIONS(6622),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteA] = ACTIONS(6622),
    [anon_sym_BSLASHciteR] = ACTIONS(6622),
    [anon_sym_BSLASHciteS] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6622),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteyear] = ACTIONS(6622),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitedate] = ACTIONS(6622),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteurl] = ACTIONS(6622),
    [anon_sym_BSLASHfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6622),
    [anon_sym_BSLASHcitealt] = ACTIONS(6622),
    [anon_sym_BSLASHcitealp] = ACTIONS(6622),
    [anon_sym_BSLASHcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHparencite] = ACTIONS(6622),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHParencite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHtextcite] = ACTIONS(6622),
    [anon_sym_BSLASHTextcite] = ACTIONS(6622),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHsupercite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite] = ACTIONS(6622),
    [anon_sym_BSLASHAutocite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHVolcite] = ACTIONS(6622),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHavolcite] = ACTIONS(6622),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHNotecite] = ACTIONS(6622),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHlabel] = ACTIONS(6622),
    [anon_sym_BSLASHref] = ACTIONS(6622),
    [anon_sym_BSLASHeqref] = ACTIONS(6622),
    [anon_sym_BSLASHvref] = ACTIONS(6622),
    [anon_sym_BSLASHVref] = ACTIONS(6622),
    [anon_sym_BSLASHautoref] = ACTIONS(6622),
    [anon_sym_BSLASHpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcref] = ACTIONS(6622),
    [anon_sym_BSLASHCref] = ACTIONS(6622),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnameCref] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHdef] = ACTIONS(6622),
    [anon_sym_BSLASHlet] = ACTIONS(6622),
    [anon_sym_BSLASHleft] = ACTIONS(6622),
    [anon_sym_BSLASHbigl] = ACTIONS(6622),
    [anon_sym_BSLASHBigl] = ACTIONS(6622),
    [anon_sym_BSLASHbiggl] = ACTIONS(6622),
    [anon_sym_BSLASHBiggl] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6622),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6622),
    [anon_sym_BSLASHgls] = ACTIONS(6622),
    [anon_sym_BSLASHGls] = ACTIONS(6622),
    [anon_sym_BSLASHGLS] = ACTIONS(6622),
    [anon_sym_BSLASHglspl] = ACTIONS(6622),
    [anon_sym_BSLASHGlspl] = ACTIONS(6622),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6622),
    [anon_sym_BSLASHglslink] = ACTIONS(6622),
    [anon_sym_BSLASHglstext] = ACTIONS(6622),
    [anon_sym_BSLASHGlstext] = ACTIONS(6622),
    [anon_sym_BSLASHGLStext] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6622),
    [anon_sym_BSLASHglsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsname] = ACTIONS(6622),
    [anon_sym_BSLASHGlsname] = ACTIONS(6622),
    [anon_sym_BSLASHGLSname] = ACTIONS(6622),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6622),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6622),
    [anon_sym_BSLASHacrshort] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6622),
    [anon_sym_BSLASHACRshort] = ACTIONS(6622),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrlong] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6622),
    [anon_sym_BSLASHACRlong] = ACTIONS(6622),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrfull] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6622),
    [anon_sym_BSLASHACRfull] = ACTIONS(6622),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHacs] = ACTIONS(6622),
    [anon_sym_BSLASHAcs] = ACTIONS(6622),
    [anon_sym_BSLASHacsp] = ACTIONS(6622),
    [anon_sym_BSLASHAcsp] = ACTIONS(6622),
    [anon_sym_BSLASHacl] = ACTIONS(6622),
    [anon_sym_BSLASHAcl] = ACTIONS(6622),
    [anon_sym_BSLASHaclp] = ACTIONS(6622),
    [anon_sym_BSLASHAclp] = ACTIONS(6622),
    [anon_sym_BSLASHacf] = ACTIONS(6622),
    [anon_sym_BSLASHAcf] = ACTIONS(6622),
    [anon_sym_BSLASHacfp] = ACTIONS(6622),
    [anon_sym_BSLASHAcfp] = ACTIONS(6622),
    [anon_sym_BSLASHac] = ACTIONS(6622),
    [anon_sym_BSLASHAc] = ACTIONS(6622),
    [anon_sym_BSLASHacp] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6622),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6622),
    [anon_sym_BSLASHcolor] = ACTIONS(6622),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6622),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6622),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6622),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6622),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6622),
    [anon_sym_BSLASHtext] = ACTIONS(6622),
    [anon_sym_BSLASHintertext] = ACTIONS(6622),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6622),
    [anon_sym_BSLASHurl] = ACTIONS(6622),
    [anon_sym_BSLASHhref] = ACTIONS(6622),
  },
  [1169] = {
    [sym_command_name] = ACTIONS(6618),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(6620),
    [anon_sym_RBRACK] = ACTIONS(6620),
    [anon_sym_COMMA] = ACTIONS(6620),
    [anon_sym_EQ] = ACTIONS(6620),
    [anon_sym_LPAREN] = ACTIONS(6620),
    [anon_sym_RPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHpart] = ACTIONS(6618),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddpart] = ACTIONS(6618),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHchapter] = ACTIONS(6618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddchap] = ACTIONS(6618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsection] = ACTIONS(6618),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddsec] = ACTIONS(6618),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHitem] = ACTIONS(6618),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6620),
    [anon_sym_LBRACE] = ACTIONS(6620),
    [sym_word] = ACTIONS(6618),
    [sym_placeholder] = ACTIONS(6620),
    [anon_sym_PLUS] = ACTIONS(6620),
    [anon_sym_DASH] = ACTIONS(6620),
    [anon_sym_STAR] = ACTIONS(6620),
    [anon_sym_SLASH] = ACTIONS(6620),
    [anon_sym_LT] = ACTIONS(6618),
    [anon_sym_GT] = ACTIONS(6618),
    [anon_sym_BANG] = ACTIONS(6618),
    [anon_sym_PIPE] = ACTIONS(6618),
    [anon_sym_COLON] = ACTIONS(6618),
    [anon_sym_SQUOTE] = ACTIONS(6618),
    [anon_sym__] = ACTIONS(6620),
    [anon_sym_CARET] = ACTIONS(6620),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6620),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6620),
    [anon_sym_DOLLAR] = ACTIONS(6618),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6620),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHbegin] = ACTIONS(6618),
    [anon_sym_BSLASHtitle] = ACTIONS(6618),
    [anon_sym_BSLASHauthor] = ACTIONS(6618),
    [anon_sym_BSLASHusepackage] = ACTIONS(6618),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6618),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6618),
    [anon_sym_BSLASHinclude] = ACTIONS(6618),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6618),
    [anon_sym_BSLASHinput] = ACTIONS(6618),
    [anon_sym_BSLASHsubfile] = ACTIONS(6618),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6618),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6618),
    [anon_sym_BSLASHbibliography] = ACTIONS(6618),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6618),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6618),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6618),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6618),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6618),
    [anon_sym_BSLASHimport] = ACTIONS(6618),
    [anon_sym_BSLASHsubimport] = ACTIONS(6618),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6618),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHcaption] = ACTIONS(6618),
    [anon_sym_BSLASHcite] = ACTIONS(6618),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCite] = ACTIONS(6618),
    [anon_sym_BSLASHnocite] = ACTIONS(6618),
    [anon_sym_BSLASHcitet] = ACTIONS(6618),
    [anon_sym_BSLASHcitep] = ACTIONS(6618),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteA] = ACTIONS(6618),
    [anon_sym_BSLASHciteR] = ACTIONS(6618),
    [anon_sym_BSLASHciteS] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6618),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteyear] = ACTIONS(6618),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitedate] = ACTIONS(6618),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteurl] = ACTIONS(6618),
    [anon_sym_BSLASHfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6618),
    [anon_sym_BSLASHcitealt] = ACTIONS(6618),
    [anon_sym_BSLASHcitealp] = ACTIONS(6618),
    [anon_sym_BSLASHcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHparencite] = ACTIONS(6618),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHParencite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHtextcite] = ACTIONS(6618),
    [anon_sym_BSLASHTextcite] = ACTIONS(6618),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHsupercite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite] = ACTIONS(6618),
    [anon_sym_BSLASHAutocite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHVolcite] = ACTIONS(6618),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHavolcite] = ACTIONS(6618),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHNotecite] = ACTIONS(6618),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHlabel] = ACTIONS(6618),
    [anon_sym_BSLASHref] = ACTIONS(6618),
    [anon_sym_BSLASHeqref] = ACTIONS(6618),
    [anon_sym_BSLASHvref] = ACTIONS(6618),
    [anon_sym_BSLASHVref] = ACTIONS(6618),
    [anon_sym_BSLASHautoref] = ACTIONS(6618),
    [anon_sym_BSLASHpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcref] = ACTIONS(6618),
    [anon_sym_BSLASHCref] = ACTIONS(6618),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnameCref] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHdef] = ACTIONS(6618),
    [anon_sym_BSLASHlet] = ACTIONS(6618),
    [anon_sym_BSLASHleft] = ACTIONS(6618),
    [anon_sym_BSLASHbigl] = ACTIONS(6618),
    [anon_sym_BSLASHBigl] = ACTIONS(6618),
    [anon_sym_BSLASHbiggl] = ACTIONS(6618),
    [anon_sym_BSLASHBiggl] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6618),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6618),
    [anon_sym_BSLASHgls] = ACTIONS(6618),
    [anon_sym_BSLASHGls] = ACTIONS(6618),
    [anon_sym_BSLASHGLS] = ACTIONS(6618),
    [anon_sym_BSLASHglspl] = ACTIONS(6618),
    [anon_sym_BSLASHGlspl] = ACTIONS(6618),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6618),
    [anon_sym_BSLASHglslink] = ACTIONS(6618),
    [anon_sym_BSLASHglstext] = ACTIONS(6618),
    [anon_sym_BSLASHGlstext] = ACTIONS(6618),
    [anon_sym_BSLASHGLStext] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6618),
    [anon_sym_BSLASHglsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsname] = ACTIONS(6618),
    [anon_sym_BSLASHGlsname] = ACTIONS(6618),
    [anon_sym_BSLASHGLSname] = ACTIONS(6618),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6618),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6618),
    [anon_sym_BSLASHacrshort] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6618),
    [anon_sym_BSLASHACRshort] = ACTIONS(6618),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrlong] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6618),
    [anon_sym_BSLASHACRlong] = ACTIONS(6618),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrfull] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6618),
    [anon_sym_BSLASHACRfull] = ACTIONS(6618),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHacs] = ACTIONS(6618),
    [anon_sym_BSLASHAcs] = ACTIONS(6618),
    [anon_sym_BSLASHacsp] = ACTIONS(6618),
    [anon_sym_BSLASHAcsp] = ACTIONS(6618),
    [anon_sym_BSLASHacl] = ACTIONS(6618),
    [anon_sym_BSLASHAcl] = ACTIONS(6618),
    [anon_sym_BSLASHaclp] = ACTIONS(6618),
    [anon_sym_BSLASHAclp] = ACTIONS(6618),
    [anon_sym_BSLASHacf] = ACTIONS(6618),
    [anon_sym_BSLASHAcf] = ACTIONS(6618),
    [anon_sym_BSLASHacfp] = ACTIONS(6618),
    [anon_sym_BSLASHAcfp] = ACTIONS(6618),
    [anon_sym_BSLASHac] = ACTIONS(6618),
    [anon_sym_BSLASHAc] = ACTIONS(6618),
    [anon_sym_BSLASHacp] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6618),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6618),
    [anon_sym_BSLASHcolor] = ACTIONS(6618),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6618),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6618),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6618),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6618),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6618),
    [anon_sym_BSLASHtext] = ACTIONS(6618),
    [anon_sym_BSLASHintertext] = ACTIONS(6618),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6618),
    [anon_sym_BSLASHurl] = ACTIONS(6618),
    [anon_sym_BSLASHhref] = ACTIONS(6618),
  },
  [1170] = {
    [sym_command_name] = ACTIONS(6614),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6614),
    [anon_sym_LBRACK] = ACTIONS(6616),
    [anon_sym_RBRACK] = ACTIONS(6616),
    [anon_sym_COMMA] = ACTIONS(6616),
    [anon_sym_EQ] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6616),
    [anon_sym_RPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHpart] = ACTIONS(6614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddpart] = ACTIONS(6614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHchapter] = ACTIONS(6614),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddchap] = ACTIONS(6614),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsection] = ACTIONS(6614),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddsec] = ACTIONS(6614),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHitem] = ACTIONS(6614),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(6616),
    [sym_word] = ACTIONS(6614),
    [sym_placeholder] = ACTIONS(6616),
    [anon_sym_PLUS] = ACTIONS(6616),
    [anon_sym_DASH] = ACTIONS(6616),
    [anon_sym_STAR] = ACTIONS(6616),
    [anon_sym_SLASH] = ACTIONS(6616),
    [anon_sym_LT] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6614),
    [anon_sym_BANG] = ACTIONS(6614),
    [anon_sym_PIPE] = ACTIONS(6614),
    [anon_sym_COLON] = ACTIONS(6614),
    [anon_sym_SQUOTE] = ACTIONS(6614),
    [anon_sym__] = ACTIONS(6616),
    [anon_sym_CARET] = ACTIONS(6616),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6616),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6616),
    [anon_sym_DOLLAR] = ACTIONS(6614),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6616),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHbegin] = ACTIONS(6614),
    [anon_sym_BSLASHtitle] = ACTIONS(6614),
    [anon_sym_BSLASHauthor] = ACTIONS(6614),
    [anon_sym_BSLASHusepackage] = ACTIONS(6614),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6614),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6614),
    [anon_sym_BSLASHinclude] = ACTIONS(6614),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6614),
    [anon_sym_BSLASHinput] = ACTIONS(6614),
    [anon_sym_BSLASHsubfile] = ACTIONS(6614),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6614),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6614),
    [anon_sym_BSLASHbibliography] = ACTIONS(6614),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6614),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6614),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6614),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6614),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6614),
    [anon_sym_BSLASHimport] = ACTIONS(6614),
    [anon_sym_BSLASHsubimport] = ACTIONS(6614),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6614),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHcaption] = ACTIONS(6614),
    [anon_sym_BSLASHcite] = ACTIONS(6614),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCite] = ACTIONS(6614),
    [anon_sym_BSLASHnocite] = ACTIONS(6614),
    [anon_sym_BSLASHcitet] = ACTIONS(6614),
    [anon_sym_BSLASHcitep] = ACTIONS(6614),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteA] = ACTIONS(6614),
    [anon_sym_BSLASHciteR] = ACTIONS(6614),
    [anon_sym_BSLASHciteS] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6614),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteyear] = ACTIONS(6614),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitedate] = ACTIONS(6614),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteurl] = ACTIONS(6614),
    [anon_sym_BSLASHfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6614),
    [anon_sym_BSLASHcitealt] = ACTIONS(6614),
    [anon_sym_BSLASHcitealp] = ACTIONS(6614),
    [anon_sym_BSLASHcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHparencite] = ACTIONS(6614),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHParencite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHtextcite] = ACTIONS(6614),
    [anon_sym_BSLASHTextcite] = ACTIONS(6614),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHsupercite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite] = ACTIONS(6614),
    [anon_sym_BSLASHAutocite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHVolcite] = ACTIONS(6614),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHavolcite] = ACTIONS(6614),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHNotecite] = ACTIONS(6614),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHlabel] = ACTIONS(6614),
    [anon_sym_BSLASHref] = ACTIONS(6614),
    [anon_sym_BSLASHeqref] = ACTIONS(6614),
    [anon_sym_BSLASHvref] = ACTIONS(6614),
    [anon_sym_BSLASHVref] = ACTIONS(6614),
    [anon_sym_BSLASHautoref] = ACTIONS(6614),
    [anon_sym_BSLASHpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcref] = ACTIONS(6614),
    [anon_sym_BSLASHCref] = ACTIONS(6614),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnameCref] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHdef] = ACTIONS(6614),
    [anon_sym_BSLASHlet] = ACTIONS(6614),
    [anon_sym_BSLASHleft] = ACTIONS(6614),
    [anon_sym_BSLASHbigl] = ACTIONS(6614),
    [anon_sym_BSLASHBigl] = ACTIONS(6614),
    [anon_sym_BSLASHbiggl] = ACTIONS(6614),
    [anon_sym_BSLASHBiggl] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6614),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6614),
    [anon_sym_BSLASHgls] = ACTIONS(6614),
    [anon_sym_BSLASHGls] = ACTIONS(6614),
    [anon_sym_BSLASHGLS] = ACTIONS(6614),
    [anon_sym_BSLASHglspl] = ACTIONS(6614),
    [anon_sym_BSLASHGlspl] = ACTIONS(6614),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6614),
    [anon_sym_BSLASHglslink] = ACTIONS(6614),
    [anon_sym_BSLASHglstext] = ACTIONS(6614),
    [anon_sym_BSLASHGlstext] = ACTIONS(6614),
    [anon_sym_BSLASHGLStext] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6614),
    [anon_sym_BSLASHglsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsname] = ACTIONS(6614),
    [anon_sym_BSLASHGlsname] = ACTIONS(6614),
    [anon_sym_BSLASHGLSname] = ACTIONS(6614),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6614),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6614),
    [anon_sym_BSLASHacrshort] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6614),
    [anon_sym_BSLASHACRshort] = ACTIONS(6614),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrlong] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6614),
    [anon_sym_BSLASHACRlong] = ACTIONS(6614),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrfull] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6614),
    [anon_sym_BSLASHACRfull] = ACTIONS(6614),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHacs] = ACTIONS(6614),
    [anon_sym_BSLASHAcs] = ACTIONS(6614),
    [anon_sym_BSLASHacsp] = ACTIONS(6614),
    [anon_sym_BSLASHAcsp] = ACTIONS(6614),
    [anon_sym_BSLASHacl] = ACTIONS(6614),
    [anon_sym_BSLASHAcl] = ACTIONS(6614),
    [anon_sym_BSLASHaclp] = ACTIONS(6614),
    [anon_sym_BSLASHAclp] = ACTIONS(6614),
    [anon_sym_BSLASHacf] = ACTIONS(6614),
    [anon_sym_BSLASHAcf] = ACTIONS(6614),
    [anon_sym_BSLASHacfp] = ACTIONS(6614),
    [anon_sym_BSLASHAcfp] = ACTIONS(6614),
    [anon_sym_BSLASHac] = ACTIONS(6614),
    [anon_sym_BSLASHAc] = ACTIONS(6614),
    [anon_sym_BSLASHacp] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6614),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6614),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6614),
    [anon_sym_BSLASHcolor] = ACTIONS(6614),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6614),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6614),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6614),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6614),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6614),
    [anon_sym_BSLASHtext] = ACTIONS(6614),
    [anon_sym_BSLASHintertext] = ACTIONS(6614),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6614),
    [anon_sym_BSLASHurl] = ACTIONS(6614),
    [anon_sym_BSLASHhref] = ACTIONS(6614),
  },
  [1171] = {
    [sym_command_name] = ACTIONS(6650),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6650),
    [anon_sym_LBRACK] = ACTIONS(6652),
    [anon_sym_RBRACK] = ACTIONS(6652),
    [anon_sym_COMMA] = ACTIONS(6652),
    [anon_sym_EQ] = ACTIONS(6652),
    [anon_sym_LPAREN] = ACTIONS(6652),
    [anon_sym_RPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHpart] = ACTIONS(6650),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddpart] = ACTIONS(6650),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHchapter] = ACTIONS(6650),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddchap] = ACTIONS(6650),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsection] = ACTIONS(6650),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddsec] = ACTIONS(6650),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHitem] = ACTIONS(6650),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6652),
    [anon_sym_LBRACE] = ACTIONS(6652),
    [sym_word] = ACTIONS(6650),
    [sym_placeholder] = ACTIONS(6652),
    [anon_sym_PLUS] = ACTIONS(6652),
    [anon_sym_DASH] = ACTIONS(6652),
    [anon_sym_STAR] = ACTIONS(6652),
    [anon_sym_SLASH] = ACTIONS(6652),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_BANG] = ACTIONS(6650),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_COLON] = ACTIONS(6650),
    [anon_sym_SQUOTE] = ACTIONS(6650),
    [anon_sym__] = ACTIONS(6652),
    [anon_sym_CARET] = ACTIONS(6652),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6652),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6652),
    [anon_sym_DOLLAR] = ACTIONS(6650),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHbegin] = ACTIONS(6650),
    [anon_sym_BSLASHend] = ACTIONS(6650),
    [anon_sym_BSLASHtitle] = ACTIONS(6650),
    [anon_sym_BSLASHauthor] = ACTIONS(6650),
    [anon_sym_BSLASHusepackage] = ACTIONS(6650),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6650),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6650),
    [anon_sym_BSLASHinclude] = ACTIONS(6650),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6650),
    [anon_sym_BSLASHinput] = ACTIONS(6650),
    [anon_sym_BSLASHsubfile] = ACTIONS(6650),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6650),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6650),
    [anon_sym_BSLASHbibliography] = ACTIONS(6650),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6650),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6650),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6650),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6650),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6650),
    [anon_sym_BSLASHimport] = ACTIONS(6650),
    [anon_sym_BSLASHsubimport] = ACTIONS(6650),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6650),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHcaption] = ACTIONS(6650),
    [anon_sym_BSLASHcite] = ACTIONS(6650),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCite] = ACTIONS(6650),
    [anon_sym_BSLASHnocite] = ACTIONS(6650),
    [anon_sym_BSLASHcitet] = ACTIONS(6650),
    [anon_sym_BSLASHcitep] = ACTIONS(6650),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteA] = ACTIONS(6650),
    [anon_sym_BSLASHciteR] = ACTIONS(6650),
    [anon_sym_BSLASHciteS] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6650),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteyear] = ACTIONS(6650),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitedate] = ACTIONS(6650),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteurl] = ACTIONS(6650),
    [anon_sym_BSLASHfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6650),
    [anon_sym_BSLASHcitealt] = ACTIONS(6650),
    [anon_sym_BSLASHcitealp] = ACTIONS(6650),
    [anon_sym_BSLASHcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHparencite] = ACTIONS(6650),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHParencite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHtextcite] = ACTIONS(6650),
    [anon_sym_BSLASHTextcite] = ACTIONS(6650),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHsupercite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite] = ACTIONS(6650),
    [anon_sym_BSLASHAutocite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHVolcite] = ACTIONS(6650),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHavolcite] = ACTIONS(6650),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHNotecite] = ACTIONS(6650),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHlabel] = ACTIONS(6650),
    [anon_sym_BSLASHref] = ACTIONS(6650),
    [anon_sym_BSLASHeqref] = ACTIONS(6650),
    [anon_sym_BSLASHvref] = ACTIONS(6650),
    [anon_sym_BSLASHVref] = ACTIONS(6650),
    [anon_sym_BSLASHautoref] = ACTIONS(6650),
    [anon_sym_BSLASHpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcref] = ACTIONS(6650),
    [anon_sym_BSLASHCref] = ACTIONS(6650),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnameCref] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHdef] = ACTIONS(6650),
    [anon_sym_BSLASHlet] = ACTIONS(6650),
    [anon_sym_BSLASHleft] = ACTIONS(6650),
    [anon_sym_BSLASHbigl] = ACTIONS(6650),
    [anon_sym_BSLASHBigl] = ACTIONS(6650),
    [anon_sym_BSLASHbiggl] = ACTIONS(6650),
    [anon_sym_BSLASHBiggl] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6650),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6650),
    [anon_sym_BSLASHgls] = ACTIONS(6650),
    [anon_sym_BSLASHGls] = ACTIONS(6650),
    [anon_sym_BSLASHGLS] = ACTIONS(6650),
    [anon_sym_BSLASHglspl] = ACTIONS(6650),
    [anon_sym_BSLASHGlspl] = ACTIONS(6650),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6650),
    [anon_sym_BSLASHglslink] = ACTIONS(6650),
    [anon_sym_BSLASHglstext] = ACTIONS(6650),
    [anon_sym_BSLASHGlstext] = ACTIONS(6650),
    [anon_sym_BSLASHGLStext] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6650),
    [anon_sym_BSLASHglsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsname] = ACTIONS(6650),
    [anon_sym_BSLASHGlsname] = ACTIONS(6650),
    [anon_sym_BSLASHGLSname] = ACTIONS(6650),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6650),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6650),
    [anon_sym_BSLASHacrshort] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6650),
    [anon_sym_BSLASHACRshort] = ACTIONS(6650),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrlong] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6650),
    [anon_sym_BSLASHACRlong] = ACTIONS(6650),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrfull] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6650),
    [anon_sym_BSLASHACRfull] = ACTIONS(6650),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHacs] = ACTIONS(6650),
    [anon_sym_BSLASHAcs] = ACTIONS(6650),
    [anon_sym_BSLASHacsp] = ACTIONS(6650),
    [anon_sym_BSLASHAcsp] = ACTIONS(6650),
    [anon_sym_BSLASHacl] = ACTIONS(6650),
    [anon_sym_BSLASHAcl] = ACTIONS(6650),
    [anon_sym_BSLASHaclp] = ACTIONS(6650),
    [anon_sym_BSLASHAclp] = ACTIONS(6650),
    [anon_sym_BSLASHacf] = ACTIONS(6650),
    [anon_sym_BSLASHAcf] = ACTIONS(6650),
    [anon_sym_BSLASHacfp] = ACTIONS(6650),
    [anon_sym_BSLASHAcfp] = ACTIONS(6650),
    [anon_sym_BSLASHac] = ACTIONS(6650),
    [anon_sym_BSLASHAc] = ACTIONS(6650),
    [anon_sym_BSLASHacp] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6650),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6650),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6650),
    [anon_sym_BSLASHcolor] = ACTIONS(6650),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6650),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6650),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6650),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6650),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6650),
    [anon_sym_BSLASHtext] = ACTIONS(6650),
    [anon_sym_BSLASHintertext] = ACTIONS(6650),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6650),
    [anon_sym_BSLASHurl] = ACTIONS(6650),
    [anon_sym_BSLASHhref] = ACTIONS(6650),
  },
  [1172] = {
    [sym_command_name] = ACTIONS(6610),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6610),
    [anon_sym_LBRACK] = ACTIONS(6612),
    [anon_sym_RBRACK] = ACTIONS(6612),
    [anon_sym_COMMA] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6612),
    [anon_sym_RPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHpart] = ACTIONS(6610),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddpart] = ACTIONS(6610),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHchapter] = ACTIONS(6610),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddchap] = ACTIONS(6610),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsection] = ACTIONS(6610),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddsec] = ACTIONS(6610),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHitem] = ACTIONS(6610),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6612),
    [anon_sym_LBRACE] = ACTIONS(6612),
    [sym_word] = ACTIONS(6610),
    [sym_placeholder] = ACTIONS(6612),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_DASH] = ACTIONS(6612),
    [anon_sym_STAR] = ACTIONS(6612),
    [anon_sym_SLASH] = ACTIONS(6612),
    [anon_sym_LT] = ACTIONS(6610),
    [anon_sym_GT] = ACTIONS(6610),
    [anon_sym_BANG] = ACTIONS(6610),
    [anon_sym_PIPE] = ACTIONS(6610),
    [anon_sym_COLON] = ACTIONS(6610),
    [anon_sym_SQUOTE] = ACTIONS(6610),
    [anon_sym__] = ACTIONS(6612),
    [anon_sym_CARET] = ACTIONS(6612),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6612),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6612),
    [anon_sym_DOLLAR] = ACTIONS(6610),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6612),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHbegin] = ACTIONS(6610),
    [anon_sym_BSLASHtitle] = ACTIONS(6610),
    [anon_sym_BSLASHauthor] = ACTIONS(6610),
    [anon_sym_BSLASHusepackage] = ACTIONS(6610),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6610),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6610),
    [anon_sym_BSLASHinclude] = ACTIONS(6610),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6610),
    [anon_sym_BSLASHinput] = ACTIONS(6610),
    [anon_sym_BSLASHsubfile] = ACTIONS(6610),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6610),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6610),
    [anon_sym_BSLASHbibliography] = ACTIONS(6610),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6610),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6610),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6610),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6610),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6610),
    [anon_sym_BSLASHimport] = ACTIONS(6610),
    [anon_sym_BSLASHsubimport] = ACTIONS(6610),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6610),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHcaption] = ACTIONS(6610),
    [anon_sym_BSLASHcite] = ACTIONS(6610),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCite] = ACTIONS(6610),
    [anon_sym_BSLASHnocite] = ACTIONS(6610),
    [anon_sym_BSLASHcitet] = ACTIONS(6610),
    [anon_sym_BSLASHcitep] = ACTIONS(6610),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteA] = ACTIONS(6610),
    [anon_sym_BSLASHciteR] = ACTIONS(6610),
    [anon_sym_BSLASHciteS] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6610),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteyear] = ACTIONS(6610),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitedate] = ACTIONS(6610),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteurl] = ACTIONS(6610),
    [anon_sym_BSLASHfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6610),
    [anon_sym_BSLASHcitealt] = ACTIONS(6610),
    [anon_sym_BSLASHcitealp] = ACTIONS(6610),
    [anon_sym_BSLASHcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHparencite] = ACTIONS(6610),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHParencite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHtextcite] = ACTIONS(6610),
    [anon_sym_BSLASHTextcite] = ACTIONS(6610),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHsupercite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite] = ACTIONS(6610),
    [anon_sym_BSLASHAutocite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHVolcite] = ACTIONS(6610),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHavolcite] = ACTIONS(6610),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHNotecite] = ACTIONS(6610),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHlabel] = ACTIONS(6610),
    [anon_sym_BSLASHref] = ACTIONS(6610),
    [anon_sym_BSLASHeqref] = ACTIONS(6610),
    [anon_sym_BSLASHvref] = ACTIONS(6610),
    [anon_sym_BSLASHVref] = ACTIONS(6610),
    [anon_sym_BSLASHautoref] = ACTIONS(6610),
    [anon_sym_BSLASHpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcref] = ACTIONS(6610),
    [anon_sym_BSLASHCref] = ACTIONS(6610),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnameCref] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHdef] = ACTIONS(6610),
    [anon_sym_BSLASHlet] = ACTIONS(6610),
    [anon_sym_BSLASHleft] = ACTIONS(6610),
    [anon_sym_BSLASHbigl] = ACTIONS(6610),
    [anon_sym_BSLASHBigl] = ACTIONS(6610),
    [anon_sym_BSLASHbiggl] = ACTIONS(6610),
    [anon_sym_BSLASHBiggl] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6610),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6610),
    [anon_sym_BSLASHgls] = ACTIONS(6610),
    [anon_sym_BSLASHGls] = ACTIONS(6610),
    [anon_sym_BSLASHGLS] = ACTIONS(6610),
    [anon_sym_BSLASHglspl] = ACTIONS(6610),
    [anon_sym_BSLASHGlspl] = ACTIONS(6610),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6610),
    [anon_sym_BSLASHglslink] = ACTIONS(6610),
    [anon_sym_BSLASHglstext] = ACTIONS(6610),
    [anon_sym_BSLASHGlstext] = ACTIONS(6610),
    [anon_sym_BSLASHGLStext] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6610),
    [anon_sym_BSLASHglsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsname] = ACTIONS(6610),
    [anon_sym_BSLASHGlsname] = ACTIONS(6610),
    [anon_sym_BSLASHGLSname] = ACTIONS(6610),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6610),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6610),
    [anon_sym_BSLASHacrshort] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6610),
    [anon_sym_BSLASHACRshort] = ACTIONS(6610),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrlong] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6610),
    [anon_sym_BSLASHACRlong] = ACTIONS(6610),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrfull] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6610),
    [anon_sym_BSLASHACRfull] = ACTIONS(6610),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHacs] = ACTIONS(6610),
    [anon_sym_BSLASHAcs] = ACTIONS(6610),
    [anon_sym_BSLASHacsp] = ACTIONS(6610),
    [anon_sym_BSLASHAcsp] = ACTIONS(6610),
    [anon_sym_BSLASHacl] = ACTIONS(6610),
    [anon_sym_BSLASHAcl] = ACTIONS(6610),
    [anon_sym_BSLASHaclp] = ACTIONS(6610),
    [anon_sym_BSLASHAclp] = ACTIONS(6610),
    [anon_sym_BSLASHacf] = ACTIONS(6610),
    [anon_sym_BSLASHAcf] = ACTIONS(6610),
    [anon_sym_BSLASHacfp] = ACTIONS(6610),
    [anon_sym_BSLASHAcfp] = ACTIONS(6610),
    [anon_sym_BSLASHac] = ACTIONS(6610),
    [anon_sym_BSLASHAc] = ACTIONS(6610),
    [anon_sym_BSLASHacp] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6610),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6610),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6610),
    [anon_sym_BSLASHcolor] = ACTIONS(6610),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6610),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6610),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6610),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6610),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6610),
    [anon_sym_BSLASHtext] = ACTIONS(6610),
    [anon_sym_BSLASHintertext] = ACTIONS(6610),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6610),
    [anon_sym_BSLASHurl] = ACTIONS(6610),
    [anon_sym_BSLASHhref] = ACTIONS(6610),
  },
  [1173] = {
    [sym_command_name] = ACTIONS(6606),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6606),
    [anon_sym_LBRACK] = ACTIONS(6608),
    [anon_sym_RBRACK] = ACTIONS(6608),
    [anon_sym_COMMA] = ACTIONS(6608),
    [anon_sym_EQ] = ACTIONS(6608),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_RPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHpart] = ACTIONS(6606),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddpart] = ACTIONS(6606),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHchapter] = ACTIONS(6606),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddchap] = ACTIONS(6606),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsection] = ACTIONS(6606),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddsec] = ACTIONS(6606),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHitem] = ACTIONS(6606),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6608),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [sym_word] = ACTIONS(6606),
    [sym_placeholder] = ACTIONS(6608),
    [anon_sym_PLUS] = ACTIONS(6608),
    [anon_sym_DASH] = ACTIONS(6608),
    [anon_sym_STAR] = ACTIONS(6608),
    [anon_sym_SLASH] = ACTIONS(6608),
    [anon_sym_LT] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6606),
    [anon_sym_BANG] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6606),
    [anon_sym_COLON] = ACTIONS(6606),
    [anon_sym_SQUOTE] = ACTIONS(6606),
    [anon_sym__] = ACTIONS(6608),
    [anon_sym_CARET] = ACTIONS(6608),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6608),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(6606),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6608),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHbegin] = ACTIONS(6606),
    [anon_sym_BSLASHtitle] = ACTIONS(6606),
    [anon_sym_BSLASHauthor] = ACTIONS(6606),
    [anon_sym_BSLASHusepackage] = ACTIONS(6606),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6606),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6606),
    [anon_sym_BSLASHinclude] = ACTIONS(6606),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6606),
    [anon_sym_BSLASHinput] = ACTIONS(6606),
    [anon_sym_BSLASHsubfile] = ACTIONS(6606),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6606),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6606),
    [anon_sym_BSLASHbibliography] = ACTIONS(6606),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6606),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6606),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6606),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6606),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6606),
    [anon_sym_BSLASHimport] = ACTIONS(6606),
    [anon_sym_BSLASHsubimport] = ACTIONS(6606),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6606),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHcaption] = ACTIONS(6606),
    [anon_sym_BSLASHcite] = ACTIONS(6606),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCite] = ACTIONS(6606),
    [anon_sym_BSLASHnocite] = ACTIONS(6606),
    [anon_sym_BSLASHcitet] = ACTIONS(6606),
    [anon_sym_BSLASHcitep] = ACTIONS(6606),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteA] = ACTIONS(6606),
    [anon_sym_BSLASHciteR] = ACTIONS(6606),
    [anon_sym_BSLASHciteS] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6606),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteyear] = ACTIONS(6606),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitedate] = ACTIONS(6606),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteurl] = ACTIONS(6606),
    [anon_sym_BSLASHfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6606),
    [anon_sym_BSLASHcitealt] = ACTIONS(6606),
    [anon_sym_BSLASHcitealp] = ACTIONS(6606),
    [anon_sym_BSLASHcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHparencite] = ACTIONS(6606),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHParencite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHtextcite] = ACTIONS(6606),
    [anon_sym_BSLASHTextcite] = ACTIONS(6606),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHsupercite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite] = ACTIONS(6606),
    [anon_sym_BSLASHAutocite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHVolcite] = ACTIONS(6606),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHavolcite] = ACTIONS(6606),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHNotecite] = ACTIONS(6606),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHlabel] = ACTIONS(6606),
    [anon_sym_BSLASHref] = ACTIONS(6606),
    [anon_sym_BSLASHeqref] = ACTIONS(6606),
    [anon_sym_BSLASHvref] = ACTIONS(6606),
    [anon_sym_BSLASHVref] = ACTIONS(6606),
    [anon_sym_BSLASHautoref] = ACTIONS(6606),
    [anon_sym_BSLASHpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcref] = ACTIONS(6606),
    [anon_sym_BSLASHCref] = ACTIONS(6606),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnameCref] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHdef] = ACTIONS(6606),
    [anon_sym_BSLASHlet] = ACTIONS(6606),
    [anon_sym_BSLASHleft] = ACTIONS(6606),
    [anon_sym_BSLASHbigl] = ACTIONS(6606),
    [anon_sym_BSLASHBigl] = ACTIONS(6606),
    [anon_sym_BSLASHbiggl] = ACTIONS(6606),
    [anon_sym_BSLASHBiggl] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6606),
    [anon_sym_BSLASHgls] = ACTIONS(6606),
    [anon_sym_BSLASHGls] = ACTIONS(6606),
    [anon_sym_BSLASHGLS] = ACTIONS(6606),
    [anon_sym_BSLASHglspl] = ACTIONS(6606),
    [anon_sym_BSLASHGlspl] = ACTIONS(6606),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6606),
    [anon_sym_BSLASHglslink] = ACTIONS(6606),
    [anon_sym_BSLASHglstext] = ACTIONS(6606),
    [anon_sym_BSLASHGlstext] = ACTIONS(6606),
    [anon_sym_BSLASHGLStext] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6606),
    [anon_sym_BSLASHglsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsname] = ACTIONS(6606),
    [anon_sym_BSLASHGlsname] = ACTIONS(6606),
    [anon_sym_BSLASHGLSname] = ACTIONS(6606),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6606),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6606),
    [anon_sym_BSLASHacrshort] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6606),
    [anon_sym_BSLASHACRshort] = ACTIONS(6606),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrlong] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6606),
    [anon_sym_BSLASHACRlong] = ACTIONS(6606),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrfull] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6606),
    [anon_sym_BSLASHACRfull] = ACTIONS(6606),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHacs] = ACTIONS(6606),
    [anon_sym_BSLASHAcs] = ACTIONS(6606),
    [anon_sym_BSLASHacsp] = ACTIONS(6606),
    [anon_sym_BSLASHAcsp] = ACTIONS(6606),
    [anon_sym_BSLASHacl] = ACTIONS(6606),
    [anon_sym_BSLASHAcl] = ACTIONS(6606),
    [anon_sym_BSLASHaclp] = ACTIONS(6606),
    [anon_sym_BSLASHAclp] = ACTIONS(6606),
    [anon_sym_BSLASHacf] = ACTIONS(6606),
    [anon_sym_BSLASHAcf] = ACTIONS(6606),
    [anon_sym_BSLASHacfp] = ACTIONS(6606),
    [anon_sym_BSLASHAcfp] = ACTIONS(6606),
    [anon_sym_BSLASHac] = ACTIONS(6606),
    [anon_sym_BSLASHAc] = ACTIONS(6606),
    [anon_sym_BSLASHacp] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6606),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6606),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6606),
    [anon_sym_BSLASHcolor] = ACTIONS(6606),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6606),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6606),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6606),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6606),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6606),
    [anon_sym_BSLASHtext] = ACTIONS(6606),
    [anon_sym_BSLASHintertext] = ACTIONS(6606),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6606),
    [anon_sym_BSLASHurl] = ACTIONS(6606),
    [anon_sym_BSLASHhref] = ACTIONS(6606),
  },
  [1174] = {
    [sym_command_name] = ACTIONS(6602),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6602),
    [anon_sym_LBRACK] = ACTIONS(6604),
    [anon_sym_RBRACK] = ACTIONS(6604),
    [anon_sym_COMMA] = ACTIONS(6604),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(6604),
    [anon_sym_RPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHpart] = ACTIONS(6602),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddpart] = ACTIONS(6602),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHchapter] = ACTIONS(6602),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddchap] = ACTIONS(6602),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsection] = ACTIONS(6602),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddsec] = ACTIONS(6602),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHitem] = ACTIONS(6602),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6604),
    [anon_sym_LBRACE] = ACTIONS(6604),
    [sym_word] = ACTIONS(6602),
    [sym_placeholder] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6602),
    [anon_sym_GT] = ACTIONS(6602),
    [anon_sym_BANG] = ACTIONS(6602),
    [anon_sym_PIPE] = ACTIONS(6602),
    [anon_sym_COLON] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(6602),
    [anon_sym__] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6604),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6604),
    [anon_sym_DOLLAR] = ACTIONS(6602),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6604),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHbegin] = ACTIONS(6602),
    [anon_sym_BSLASHtitle] = ACTIONS(6602),
    [anon_sym_BSLASHauthor] = ACTIONS(6602),
    [anon_sym_BSLASHusepackage] = ACTIONS(6602),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6602),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6602),
    [anon_sym_BSLASHinclude] = ACTIONS(6602),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6602),
    [anon_sym_BSLASHinput] = ACTIONS(6602),
    [anon_sym_BSLASHsubfile] = ACTIONS(6602),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6602),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6602),
    [anon_sym_BSLASHbibliography] = ACTIONS(6602),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6602),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6602),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6602),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6602),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6602),
    [anon_sym_BSLASHimport] = ACTIONS(6602),
    [anon_sym_BSLASHsubimport] = ACTIONS(6602),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6602),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHcaption] = ACTIONS(6602),
    [anon_sym_BSLASHcite] = ACTIONS(6602),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCite] = ACTIONS(6602),
    [anon_sym_BSLASHnocite] = ACTIONS(6602),
    [anon_sym_BSLASHcitet] = ACTIONS(6602),
    [anon_sym_BSLASHcitep] = ACTIONS(6602),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteA] = ACTIONS(6602),
    [anon_sym_BSLASHciteR] = ACTIONS(6602),
    [anon_sym_BSLASHciteS] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6602),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteyear] = ACTIONS(6602),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitedate] = ACTIONS(6602),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteurl] = ACTIONS(6602),
    [anon_sym_BSLASHfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6602),
    [anon_sym_BSLASHcitealt] = ACTIONS(6602),
    [anon_sym_BSLASHcitealp] = ACTIONS(6602),
    [anon_sym_BSLASHcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHparencite] = ACTIONS(6602),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHParencite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHtextcite] = ACTIONS(6602),
    [anon_sym_BSLASHTextcite] = ACTIONS(6602),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHsupercite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite] = ACTIONS(6602),
    [anon_sym_BSLASHAutocite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHVolcite] = ACTIONS(6602),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHavolcite] = ACTIONS(6602),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHNotecite] = ACTIONS(6602),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHlabel] = ACTIONS(6602),
    [anon_sym_BSLASHref] = ACTIONS(6602),
    [anon_sym_BSLASHeqref] = ACTIONS(6602),
    [anon_sym_BSLASHvref] = ACTIONS(6602),
    [anon_sym_BSLASHVref] = ACTIONS(6602),
    [anon_sym_BSLASHautoref] = ACTIONS(6602),
    [anon_sym_BSLASHpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcref] = ACTIONS(6602),
    [anon_sym_BSLASHCref] = ACTIONS(6602),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnameCref] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHdef] = ACTIONS(6602),
    [anon_sym_BSLASHlet] = ACTIONS(6602),
    [anon_sym_BSLASHleft] = ACTIONS(6602),
    [anon_sym_BSLASHbigl] = ACTIONS(6602),
    [anon_sym_BSLASHBigl] = ACTIONS(6602),
    [anon_sym_BSLASHbiggl] = ACTIONS(6602),
    [anon_sym_BSLASHBiggl] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6602),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6602),
    [anon_sym_BSLASHgls] = ACTIONS(6602),
    [anon_sym_BSLASHGls] = ACTIONS(6602),
    [anon_sym_BSLASHGLS] = ACTIONS(6602),
    [anon_sym_BSLASHglspl] = ACTIONS(6602),
    [anon_sym_BSLASHGlspl] = ACTIONS(6602),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6602),
    [anon_sym_BSLASHglslink] = ACTIONS(6602),
    [anon_sym_BSLASHglstext] = ACTIONS(6602),
    [anon_sym_BSLASHGlstext] = ACTIONS(6602),
    [anon_sym_BSLASHGLStext] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6602),
    [anon_sym_BSLASHglsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsname] = ACTIONS(6602),
    [anon_sym_BSLASHGlsname] = ACTIONS(6602),
    [anon_sym_BSLASHGLSname] = ACTIONS(6602),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6602),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6602),
    [anon_sym_BSLASHacrshort] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6602),
    [anon_sym_BSLASHACRshort] = ACTIONS(6602),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrlong] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6602),
    [anon_sym_BSLASHACRlong] = ACTIONS(6602),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrfull] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6602),
    [anon_sym_BSLASHACRfull] = ACTIONS(6602),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHacs] = ACTIONS(6602),
    [anon_sym_BSLASHAcs] = ACTIONS(6602),
    [anon_sym_BSLASHacsp] = ACTIONS(6602),
    [anon_sym_BSLASHAcsp] = ACTIONS(6602),
    [anon_sym_BSLASHacl] = ACTIONS(6602),
    [anon_sym_BSLASHAcl] = ACTIONS(6602),
    [anon_sym_BSLASHaclp] = ACTIONS(6602),
    [anon_sym_BSLASHAclp] = ACTIONS(6602),
    [anon_sym_BSLASHacf] = ACTIONS(6602),
    [anon_sym_BSLASHAcf] = ACTIONS(6602),
    [anon_sym_BSLASHacfp] = ACTIONS(6602),
    [anon_sym_BSLASHAcfp] = ACTIONS(6602),
    [anon_sym_BSLASHac] = ACTIONS(6602),
    [anon_sym_BSLASHAc] = ACTIONS(6602),
    [anon_sym_BSLASHacp] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6602),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6602),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6602),
    [anon_sym_BSLASHcolor] = ACTIONS(6602),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6602),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6602),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6602),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6602),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6602),
    [anon_sym_BSLASHtext] = ACTIONS(6602),
    [anon_sym_BSLASHintertext] = ACTIONS(6602),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6602),
    [anon_sym_BSLASHurl] = ACTIONS(6602),
    [anon_sym_BSLASHhref] = ACTIONS(6602),
  },
  [1175] = {
    [sym_command_name] = ACTIONS(6646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6646),
    [anon_sym_LBRACK] = ACTIONS(6648),
    [anon_sym_RBRACK] = ACTIONS(6648),
    [anon_sym_COMMA] = ACTIONS(6648),
    [anon_sym_EQ] = ACTIONS(6648),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [anon_sym_RPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHpart] = ACTIONS(6646),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddpart] = ACTIONS(6646),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHchapter] = ACTIONS(6646),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddchap] = ACTIONS(6646),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsection] = ACTIONS(6646),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddsec] = ACTIONS(6646),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHitem] = ACTIONS(6646),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6648),
    [anon_sym_LBRACE] = ACTIONS(6648),
    [sym_word] = ACTIONS(6646),
    [sym_placeholder] = ACTIONS(6648),
    [anon_sym_PLUS] = ACTIONS(6648),
    [anon_sym_DASH] = ACTIONS(6648),
    [anon_sym_STAR] = ACTIONS(6648),
    [anon_sym_SLASH] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6646),
    [anon_sym_GT] = ACTIONS(6646),
    [anon_sym_BANG] = ACTIONS(6646),
    [anon_sym_PIPE] = ACTIONS(6646),
    [anon_sym_COLON] = ACTIONS(6646),
    [anon_sym_SQUOTE] = ACTIONS(6646),
    [anon_sym__] = ACTIONS(6648),
    [anon_sym_CARET] = ACTIONS(6648),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6648),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6648),
    [anon_sym_DOLLAR] = ACTIONS(6646),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6648),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHbegin] = ACTIONS(6646),
    [anon_sym_BSLASHtitle] = ACTIONS(6646),
    [anon_sym_BSLASHauthor] = ACTIONS(6646),
    [anon_sym_BSLASHusepackage] = ACTIONS(6646),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6646),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6646),
    [anon_sym_BSLASHinclude] = ACTIONS(6646),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6646),
    [anon_sym_BSLASHinput] = ACTIONS(6646),
    [anon_sym_BSLASHsubfile] = ACTIONS(6646),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6646),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6646),
    [anon_sym_BSLASHbibliography] = ACTIONS(6646),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6646),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6646),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6646),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6646),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6646),
    [anon_sym_BSLASHimport] = ACTIONS(6646),
    [anon_sym_BSLASHsubimport] = ACTIONS(6646),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6646),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHcaption] = ACTIONS(6646),
    [anon_sym_BSLASHcite] = ACTIONS(6646),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCite] = ACTIONS(6646),
    [anon_sym_BSLASHnocite] = ACTIONS(6646),
    [anon_sym_BSLASHcitet] = ACTIONS(6646),
    [anon_sym_BSLASHcitep] = ACTIONS(6646),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteA] = ACTIONS(6646),
    [anon_sym_BSLASHciteR] = ACTIONS(6646),
    [anon_sym_BSLASHciteS] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6646),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteyear] = ACTIONS(6646),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitedate] = ACTIONS(6646),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteurl] = ACTIONS(6646),
    [anon_sym_BSLASHfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6646),
    [anon_sym_BSLASHcitealt] = ACTIONS(6646),
    [anon_sym_BSLASHcitealp] = ACTIONS(6646),
    [anon_sym_BSLASHcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHparencite] = ACTIONS(6646),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHParencite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHtextcite] = ACTIONS(6646),
    [anon_sym_BSLASHTextcite] = ACTIONS(6646),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHsupercite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite] = ACTIONS(6646),
    [anon_sym_BSLASHAutocite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHVolcite] = ACTIONS(6646),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHavolcite] = ACTIONS(6646),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHNotecite] = ACTIONS(6646),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHlabel] = ACTIONS(6646),
    [anon_sym_BSLASHref] = ACTIONS(6646),
    [anon_sym_BSLASHeqref] = ACTIONS(6646),
    [anon_sym_BSLASHvref] = ACTIONS(6646),
    [anon_sym_BSLASHVref] = ACTIONS(6646),
    [anon_sym_BSLASHautoref] = ACTIONS(6646),
    [anon_sym_BSLASHpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcref] = ACTIONS(6646),
    [anon_sym_BSLASHCref] = ACTIONS(6646),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnameCref] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHdef] = ACTIONS(6646),
    [anon_sym_BSLASHlet] = ACTIONS(6646),
    [anon_sym_BSLASHleft] = ACTIONS(6646),
    [anon_sym_BSLASHbigl] = ACTIONS(6646),
    [anon_sym_BSLASHBigl] = ACTIONS(6646),
    [anon_sym_BSLASHbiggl] = ACTIONS(6646),
    [anon_sym_BSLASHBiggl] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6646),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6646),
    [anon_sym_BSLASHgls] = ACTIONS(6646),
    [anon_sym_BSLASHGls] = ACTIONS(6646),
    [anon_sym_BSLASHGLS] = ACTIONS(6646),
    [anon_sym_BSLASHglspl] = ACTIONS(6646),
    [anon_sym_BSLASHGlspl] = ACTIONS(6646),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6646),
    [anon_sym_BSLASHglslink] = ACTIONS(6646),
    [anon_sym_BSLASHglstext] = ACTIONS(6646),
    [anon_sym_BSLASHGlstext] = ACTIONS(6646),
    [anon_sym_BSLASHGLStext] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6646),
    [anon_sym_BSLASHglsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsname] = ACTIONS(6646),
    [anon_sym_BSLASHGlsname] = ACTIONS(6646),
    [anon_sym_BSLASHGLSname] = ACTIONS(6646),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6646),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6646),
    [anon_sym_BSLASHacrshort] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6646),
    [anon_sym_BSLASHACRshort] = ACTIONS(6646),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrlong] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6646),
    [anon_sym_BSLASHACRlong] = ACTIONS(6646),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrfull] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6646),
    [anon_sym_BSLASHACRfull] = ACTIONS(6646),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHacs] = ACTIONS(6646),
    [anon_sym_BSLASHAcs] = ACTIONS(6646),
    [anon_sym_BSLASHacsp] = ACTIONS(6646),
    [anon_sym_BSLASHAcsp] = ACTIONS(6646),
    [anon_sym_BSLASHacl] = ACTIONS(6646),
    [anon_sym_BSLASHAcl] = ACTIONS(6646),
    [anon_sym_BSLASHaclp] = ACTIONS(6646),
    [anon_sym_BSLASHAclp] = ACTIONS(6646),
    [anon_sym_BSLASHacf] = ACTIONS(6646),
    [anon_sym_BSLASHAcf] = ACTIONS(6646),
    [anon_sym_BSLASHacfp] = ACTIONS(6646),
    [anon_sym_BSLASHAcfp] = ACTIONS(6646),
    [anon_sym_BSLASHac] = ACTIONS(6646),
    [anon_sym_BSLASHAc] = ACTIONS(6646),
    [anon_sym_BSLASHacp] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6646),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6646),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6646),
    [anon_sym_BSLASHcolor] = ACTIONS(6646),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6646),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6646),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6646),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6646),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6646),
    [anon_sym_BSLASHtext] = ACTIONS(6646),
    [anon_sym_BSLASHintertext] = ACTIONS(6646),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6646),
    [anon_sym_BSLASHurl] = ACTIONS(6646),
    [anon_sym_BSLASHhref] = ACTIONS(6646),
  },
  [1176] = {
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_RBRACK] = ACTIONS(6192),
    [anon_sym_COMMA] = ACTIONS(6192),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_RPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHpart] = ACTIONS(6190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddpart] = ACTIONS(6190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHchapter] = ACTIONS(6190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddchap] = ACTIONS(6190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsection] = ACTIONS(6190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddsec] = ACTIONS(6190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHitem] = ACTIONS(6190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6192),
    [anon_sym_DOLLAR] = ACTIONS(6190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHbegin] = ACTIONS(6190),
    [anon_sym_BSLASHend] = ACTIONS(6190),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHleft] = ACTIONS(6190),
    [anon_sym_BSLASHbigl] = ACTIONS(6190),
    [anon_sym_BSLASHBigl] = ACTIONS(6190),
    [anon_sym_BSLASHbiggl] = ACTIONS(6190),
    [anon_sym_BSLASHBiggl] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHtext] = ACTIONS(6190),
    [anon_sym_BSLASHintertext] = ACTIONS(6190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [1177] = {
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_RBRACK] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6184),
    [anon_sym_EQ] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_RPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHpart] = ACTIONS(6182),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddpart] = ACTIONS(6182),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHchapter] = ACTIONS(6182),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddchap] = ACTIONS(6182),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsection] = ACTIONS(6182),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddsec] = ACTIONS(6182),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHitem] = ACTIONS(6182),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6184),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6184),
    [anon_sym_DOLLAR] = ACTIONS(6182),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHbegin] = ACTIONS(6182),
    [anon_sym_BSLASHend] = ACTIONS(6182),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHleft] = ACTIONS(6182),
    [anon_sym_BSLASHbigl] = ACTIONS(6182),
    [anon_sym_BSLASHBigl] = ACTIONS(6182),
    [anon_sym_BSLASHbiggl] = ACTIONS(6182),
    [anon_sym_BSLASHBiggl] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHtext] = ACTIONS(6182),
    [anon_sym_BSLASHintertext] = ACTIONS(6182),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [1178] = {
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_LPAREN] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHpart] = ACTIONS(6174),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddpart] = ACTIONS(6174),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHchapter] = ACTIONS(6174),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddchap] = ACTIONS(6174),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsection] = ACTIONS(6174),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddsec] = ACTIONS(6174),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHitem] = ACTIONS(6174),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6176),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6176),
    [anon_sym_DOLLAR] = ACTIONS(6174),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHbegin] = ACTIONS(6174),
    [anon_sym_BSLASHend] = ACTIONS(6174),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHleft] = ACTIONS(6174),
    [anon_sym_BSLASHbigl] = ACTIONS(6174),
    [anon_sym_BSLASHBigl] = ACTIONS(6174),
    [anon_sym_BSLASHbiggl] = ACTIONS(6174),
    [anon_sym_BSLASHBiggl] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHtext] = ACTIONS(6174),
    [anon_sym_BSLASHintertext] = ACTIONS(6174),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [1179] = {
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_RBRACK] = ACTIONS(6352),
    [anon_sym_COMMA] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_LPAREN] = ACTIONS(6352),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHpart] = ACTIONS(6350),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddpart] = ACTIONS(6350),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHchapter] = ACTIONS(6350),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddchap] = ACTIONS(6350),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsection] = ACTIONS(6350),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddsec] = ACTIONS(6350),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHitem] = ACTIONS(6350),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6352),
    [anon_sym_LBRACE] = ACTIONS(6352),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6352),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6352),
    [anon_sym_DOLLAR] = ACTIONS(6350),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHbegin] = ACTIONS(6350),
    [anon_sym_BSLASHend] = ACTIONS(6350),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHleft] = ACTIONS(6350),
    [anon_sym_BSLASHbigl] = ACTIONS(6350),
    [anon_sym_BSLASHBigl] = ACTIONS(6350),
    [anon_sym_BSLASHbiggl] = ACTIONS(6350),
    [anon_sym_BSLASHBiggl] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHtext] = ACTIONS(6350),
    [anon_sym_BSLASHintertext] = ACTIONS(6350),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [1180] = {
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_RBRACK] = ACTIONS(6452),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6452),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHpart] = ACTIONS(6450),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddpart] = ACTIONS(6450),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHchapter] = ACTIONS(6450),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddchap] = ACTIONS(6450),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsection] = ACTIONS(6450),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddsec] = ACTIONS(6450),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHitem] = ACTIONS(6450),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6452),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(6450),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHbegin] = ACTIONS(6450),
    [anon_sym_BSLASHend] = ACTIONS(6450),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHleft] = ACTIONS(6450),
    [anon_sym_BSLASHbigl] = ACTIONS(6450),
    [anon_sym_BSLASHBigl] = ACTIONS(6450),
    [anon_sym_BSLASHbiggl] = ACTIONS(6450),
    [anon_sym_BSLASHBiggl] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHtext] = ACTIONS(6450),
    [anon_sym_BSLASHintertext] = ACTIONS(6450),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [1181] = {
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_LBRACK] = ACTIONS(6472),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_EQ] = ACTIONS(6472),
    [anon_sym_LPAREN] = ACTIONS(6472),
    [anon_sym_RPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHpart] = ACTIONS(6470),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddpart] = ACTIONS(6470),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHchapter] = ACTIONS(6470),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddchap] = ACTIONS(6470),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsection] = ACTIONS(6470),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddsec] = ACTIONS(6470),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHitem] = ACTIONS(6470),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6472),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6472),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHbegin] = ACTIONS(6470),
    [anon_sym_BSLASHend] = ACTIONS(6470),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHleft] = ACTIONS(6470),
    [anon_sym_BSLASHbigl] = ACTIONS(6470),
    [anon_sym_BSLASHBigl] = ACTIONS(6470),
    [anon_sym_BSLASHbiggl] = ACTIONS(6470),
    [anon_sym_BSLASHBiggl] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHtext] = ACTIONS(6470),
    [anon_sym_BSLASHintertext] = ACTIONS(6470),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [1182] = {
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6552),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHpart] = ACTIONS(6550),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddpart] = ACTIONS(6550),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHchapter] = ACTIONS(6550),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddchap] = ACTIONS(6550),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsection] = ACTIONS(6550),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddsec] = ACTIONS(6550),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHitem] = ACTIONS(6550),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6552),
    [anon_sym_DOLLAR] = ACTIONS(6550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHbegin] = ACTIONS(6550),
    [anon_sym_BSLASHend] = ACTIONS(6550),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHleft] = ACTIONS(6550),
    [anon_sym_BSLASHbigl] = ACTIONS(6550),
    [anon_sym_BSLASHBigl] = ACTIONS(6550),
    [anon_sym_BSLASHbiggl] = ACTIONS(6550),
    [anon_sym_BSLASHBiggl] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHtext] = ACTIONS(6550),
    [anon_sym_BSLASHintertext] = ACTIONS(6550),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [1183] = {
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6556),
    [anon_sym_RBRACK] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6556),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHpart] = ACTIONS(6554),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddpart] = ACTIONS(6554),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHchapter] = ACTIONS(6554),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddchap] = ACTIONS(6554),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsection] = ACTIONS(6554),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddsec] = ACTIONS(6554),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHitem] = ACTIONS(6554),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6556),
    [anon_sym_LBRACE] = ACTIONS(6556),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6556),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6556),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHbegin] = ACTIONS(6554),
    [anon_sym_BSLASHend] = ACTIONS(6554),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHleft] = ACTIONS(6554),
    [anon_sym_BSLASHbigl] = ACTIONS(6554),
    [anon_sym_BSLASHBigl] = ACTIONS(6554),
    [anon_sym_BSLASHbiggl] = ACTIONS(6554),
    [anon_sym_BSLASHBiggl] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHtext] = ACTIONS(6554),
    [anon_sym_BSLASHintertext] = ACTIONS(6554),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [1184] = {
    [sym_command_name] = ACTIONS(6170),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6172),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6172),
    [anon_sym_LPAREN] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHpart] = ACTIONS(6170),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddpart] = ACTIONS(6170),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHchapter] = ACTIONS(6170),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddchap] = ACTIONS(6170),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsection] = ACTIONS(6170),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddsec] = ACTIONS(6170),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHitem] = ACTIONS(6170),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [sym_word] = ACTIONS(6170),
    [sym_placeholder] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_BANG] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_SQUOTE] = ACTIONS(6170),
    [anon_sym__] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6172),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6172),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHbegin] = ACTIONS(6170),
    [anon_sym_BSLASHend] = ACTIONS(6170),
    [anon_sym_BSLASHtitle] = ACTIONS(6170),
    [anon_sym_BSLASHauthor] = ACTIONS(6170),
    [anon_sym_BSLASHusepackage] = ACTIONS(6170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6170),
    [anon_sym_BSLASHinclude] = ACTIONS(6170),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6170),
    [anon_sym_BSLASHinput] = ACTIONS(6170),
    [anon_sym_BSLASHsubfile] = ACTIONS(6170),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6170),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6170),
    [anon_sym_BSLASHbibliography] = ACTIONS(6170),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6170),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6170),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6170),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6170),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6170),
    [anon_sym_BSLASHimport] = ACTIONS(6170),
    [anon_sym_BSLASHsubimport] = ACTIONS(6170),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6170),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHcaption] = ACTIONS(6170),
    [anon_sym_BSLASHcite] = ACTIONS(6170),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCite] = ACTIONS(6170),
    [anon_sym_BSLASHnocite] = ACTIONS(6170),
    [anon_sym_BSLASHcitet] = ACTIONS(6170),
    [anon_sym_BSLASHcitep] = ACTIONS(6170),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteA] = ACTIONS(6170),
    [anon_sym_BSLASHciteR] = ACTIONS(6170),
    [anon_sym_BSLASHciteS] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6170),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteyear] = ACTIONS(6170),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitedate] = ACTIONS(6170),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteurl] = ACTIONS(6170),
    [anon_sym_BSLASHfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6170),
    [anon_sym_BSLASHcitealt] = ACTIONS(6170),
    [anon_sym_BSLASHcitealp] = ACTIONS(6170),
    [anon_sym_BSLASHcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHparencite] = ACTIONS(6170),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHParencite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHtextcite] = ACTIONS(6170),
    [anon_sym_BSLASHTextcite] = ACTIONS(6170),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHsupercite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite] = ACTIONS(6170),
    [anon_sym_BSLASHAutocite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHVolcite] = ACTIONS(6170),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHavolcite] = ACTIONS(6170),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHNotecite] = ACTIONS(6170),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHlabel] = ACTIONS(6170),
    [anon_sym_BSLASHref] = ACTIONS(6170),
    [anon_sym_BSLASHeqref] = ACTIONS(6170),
    [anon_sym_BSLASHvref] = ACTIONS(6170),
    [anon_sym_BSLASHVref] = ACTIONS(6170),
    [anon_sym_BSLASHautoref] = ACTIONS(6170),
    [anon_sym_BSLASHpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcref] = ACTIONS(6170),
    [anon_sym_BSLASHCref] = ACTIONS(6170),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnameCref] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHdef] = ACTIONS(6170),
    [anon_sym_BSLASHlet] = ACTIONS(6170),
    [anon_sym_BSLASHleft] = ACTIONS(6170),
    [anon_sym_BSLASHbigl] = ACTIONS(6170),
    [anon_sym_BSLASHBigl] = ACTIONS(6170),
    [anon_sym_BSLASHbiggl] = ACTIONS(6170),
    [anon_sym_BSLASHBiggl] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6170),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6170),
    [anon_sym_BSLASHgls] = ACTIONS(6170),
    [anon_sym_BSLASHGls] = ACTIONS(6170),
    [anon_sym_BSLASHGLS] = ACTIONS(6170),
    [anon_sym_BSLASHglspl] = ACTIONS(6170),
    [anon_sym_BSLASHGlspl] = ACTIONS(6170),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6170),
    [anon_sym_BSLASHglslink] = ACTIONS(6170),
    [anon_sym_BSLASHglstext] = ACTIONS(6170),
    [anon_sym_BSLASHGlstext] = ACTIONS(6170),
    [anon_sym_BSLASHGLStext] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6170),
    [anon_sym_BSLASHglsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsname] = ACTIONS(6170),
    [anon_sym_BSLASHGlsname] = ACTIONS(6170),
    [anon_sym_BSLASHGLSname] = ACTIONS(6170),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6170),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6170),
    [anon_sym_BSLASHacrshort] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6170),
    [anon_sym_BSLASHACRshort] = ACTIONS(6170),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrlong] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6170),
    [anon_sym_BSLASHACRlong] = ACTIONS(6170),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrfull] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6170),
    [anon_sym_BSLASHACRfull] = ACTIONS(6170),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHacs] = ACTIONS(6170),
    [anon_sym_BSLASHAcs] = ACTIONS(6170),
    [anon_sym_BSLASHacsp] = ACTIONS(6170),
    [anon_sym_BSLASHAcsp] = ACTIONS(6170),
    [anon_sym_BSLASHacl] = ACTIONS(6170),
    [anon_sym_BSLASHAcl] = ACTIONS(6170),
    [anon_sym_BSLASHaclp] = ACTIONS(6170),
    [anon_sym_BSLASHAclp] = ACTIONS(6170),
    [anon_sym_BSLASHacf] = ACTIONS(6170),
    [anon_sym_BSLASHAcf] = ACTIONS(6170),
    [anon_sym_BSLASHacfp] = ACTIONS(6170),
    [anon_sym_BSLASHAcfp] = ACTIONS(6170),
    [anon_sym_BSLASHac] = ACTIONS(6170),
    [anon_sym_BSLASHAc] = ACTIONS(6170),
    [anon_sym_BSLASHacp] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6170),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6170),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6170),
    [anon_sym_BSLASHcolor] = ACTIONS(6170),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6170),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6170),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6170),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6170),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6170),
    [anon_sym_BSLASHtext] = ACTIONS(6170),
    [anon_sym_BSLASHintertext] = ACTIONS(6170),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6170),
    [anon_sym_BSLASHurl] = ACTIONS(6170),
    [anon_sym_BSLASHhref] = ACTIONS(6170),
  },
  [1185] = {
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6280),
    [anon_sym_RBRACK] = ACTIONS(6280),
    [anon_sym_COMMA] = ACTIONS(6280),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_RPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHpart] = ACTIONS(6278),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddpart] = ACTIONS(6278),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHchapter] = ACTIONS(6278),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddchap] = ACTIONS(6278),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsection] = ACTIONS(6278),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddsec] = ACTIONS(6278),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHitem] = ACTIONS(6278),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6280),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6280),
    [anon_sym_DOLLAR] = ACTIONS(6278),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6280),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHbegin] = ACTIONS(6278),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHleft] = ACTIONS(6278),
    [anon_sym_BSLASHbigl] = ACTIONS(6278),
    [anon_sym_BSLASHBigl] = ACTIONS(6278),
    [anon_sym_BSLASHbiggl] = ACTIONS(6278),
    [anon_sym_BSLASHBiggl] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHtext] = ACTIONS(6278),
    [anon_sym_BSLASHintertext] = ACTIONS(6278),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [1186] = {
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_LBRACK] = ACTIONS(6508),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [anon_sym_COMMA] = ACTIONS(6508),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_RPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHpart] = ACTIONS(6506),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddpart] = ACTIONS(6506),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHchapter] = ACTIONS(6506),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddchap] = ACTIONS(6506),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsection] = ACTIONS(6506),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddsec] = ACTIONS(6506),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHitem] = ACTIONS(6506),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6508),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(6506),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6508),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHbegin] = ACTIONS(6506),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHleft] = ACTIONS(6506),
    [anon_sym_BSLASHbigl] = ACTIONS(6506),
    [anon_sym_BSLASHBigl] = ACTIONS(6506),
    [anon_sym_BSLASHbiggl] = ACTIONS(6506),
    [anon_sym_BSLASHBiggl] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHtext] = ACTIONS(6506),
    [anon_sym_BSLASHintertext] = ACTIONS(6506),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [1187] = {
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_LBRACK] = ACTIONS(6574),
    [anon_sym_RBRACK] = ACTIONS(6574),
    [anon_sym_COMMA] = ACTIONS(6574),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_RPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHpart] = ACTIONS(6572),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddpart] = ACTIONS(6572),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHchapter] = ACTIONS(6572),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddchap] = ACTIONS(6572),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsection] = ACTIONS(6572),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddsec] = ACTIONS(6572),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHitem] = ACTIONS(6572),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6574),
    [anon_sym_LBRACE] = ACTIONS(6574),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6574),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6574),
    [anon_sym_DOLLAR] = ACTIONS(6572),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHbegin] = ACTIONS(6572),
    [anon_sym_BSLASHend] = ACTIONS(6572),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHleft] = ACTIONS(6572),
    [anon_sym_BSLASHbigl] = ACTIONS(6572),
    [anon_sym_BSLASHBigl] = ACTIONS(6572),
    [anon_sym_BSLASHbiggl] = ACTIONS(6572),
    [anon_sym_BSLASHBiggl] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHtext] = ACTIONS(6572),
    [anon_sym_BSLASHintertext] = ACTIONS(6572),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [1188] = {
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_LBRACK] = ACTIONS(6520),
    [anon_sym_RBRACK] = ACTIONS(6520),
    [anon_sym_COMMA] = ACTIONS(6520),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_LPAREN] = ACTIONS(6520),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHpart] = ACTIONS(6518),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddpart] = ACTIONS(6518),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHchapter] = ACTIONS(6518),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddchap] = ACTIONS(6518),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsection] = ACTIONS(6518),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddsec] = ACTIONS(6518),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHitem] = ACTIONS(6518),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6520),
    [anon_sym_LBRACE] = ACTIONS(6520),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6520),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6520),
    [anon_sym_DOLLAR] = ACTIONS(6518),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHbegin] = ACTIONS(6518),
    [anon_sym_BSLASHend] = ACTIONS(6518),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHleft] = ACTIONS(6518),
    [anon_sym_BSLASHbigl] = ACTIONS(6518),
    [anon_sym_BSLASHBigl] = ACTIONS(6518),
    [anon_sym_BSLASHbiggl] = ACTIONS(6518),
    [anon_sym_BSLASHBiggl] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHtext] = ACTIONS(6518),
    [anon_sym_BSLASHintertext] = ACTIONS(6518),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [1189] = {
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_LBRACK] = ACTIONS(6516),
    [anon_sym_RBRACK] = ACTIONS(6516),
    [anon_sym_COMMA] = ACTIONS(6516),
    [anon_sym_EQ] = ACTIONS(6516),
    [anon_sym_LPAREN] = ACTIONS(6516),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHpart] = ACTIONS(6514),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddpart] = ACTIONS(6514),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHchapter] = ACTIONS(6514),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddchap] = ACTIONS(6514),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsection] = ACTIONS(6514),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddsec] = ACTIONS(6514),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHitem] = ACTIONS(6514),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6516),
    [anon_sym_LBRACE] = ACTIONS(6516),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6516),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(6514),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHbegin] = ACTIONS(6514),
    [anon_sym_BSLASHend] = ACTIONS(6514),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHleft] = ACTIONS(6514),
    [anon_sym_BSLASHbigl] = ACTIONS(6514),
    [anon_sym_BSLASHBigl] = ACTIONS(6514),
    [anon_sym_BSLASHbiggl] = ACTIONS(6514),
    [anon_sym_BSLASHBiggl] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHtext] = ACTIONS(6514),
    [anon_sym_BSLASHintertext] = ACTIONS(6514),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [1190] = {
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_LBRACK] = ACTIONS(6512),
    [anon_sym_RBRACK] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHpart] = ACTIONS(6510),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddpart] = ACTIONS(6510),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHchapter] = ACTIONS(6510),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddchap] = ACTIONS(6510),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsection] = ACTIONS(6510),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddsec] = ACTIONS(6510),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHitem] = ACTIONS(6510),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6512),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6512),
    [anon_sym_DOLLAR] = ACTIONS(6510),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHbegin] = ACTIONS(6510),
    [anon_sym_BSLASHend] = ACTIONS(6510),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHleft] = ACTIONS(6510),
    [anon_sym_BSLASHbigl] = ACTIONS(6510),
    [anon_sym_BSLASHBigl] = ACTIONS(6510),
    [anon_sym_BSLASHbiggl] = ACTIONS(6510),
    [anon_sym_BSLASHBiggl] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHtext] = ACTIONS(6510),
    [anon_sym_BSLASHintertext] = ACTIONS(6510),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [1191] = {
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_LBRACK] = ACTIONS(6508),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [anon_sym_COMMA] = ACTIONS(6508),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_RPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHpart] = ACTIONS(6506),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddpart] = ACTIONS(6506),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHchapter] = ACTIONS(6506),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddchap] = ACTIONS(6506),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsection] = ACTIONS(6506),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddsec] = ACTIONS(6506),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHitem] = ACTIONS(6506),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6508),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(6506),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHbegin] = ACTIONS(6506),
    [anon_sym_BSLASHend] = ACTIONS(6506),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHleft] = ACTIONS(6506),
    [anon_sym_BSLASHbigl] = ACTIONS(6506),
    [anon_sym_BSLASHBigl] = ACTIONS(6506),
    [anon_sym_BSLASHbiggl] = ACTIONS(6506),
    [anon_sym_BSLASHBiggl] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHtext] = ACTIONS(6506),
    [anon_sym_BSLASHintertext] = ACTIONS(6506),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [1192] = {
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_LBRACK] = ACTIONS(6512),
    [anon_sym_RBRACK] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHpart] = ACTIONS(6510),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddpart] = ACTIONS(6510),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHchapter] = ACTIONS(6510),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddchap] = ACTIONS(6510),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsection] = ACTIONS(6510),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddsec] = ACTIONS(6510),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHitem] = ACTIONS(6510),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6512),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6512),
    [anon_sym_DOLLAR] = ACTIONS(6510),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6512),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHbegin] = ACTIONS(6510),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHleft] = ACTIONS(6510),
    [anon_sym_BSLASHbigl] = ACTIONS(6510),
    [anon_sym_BSLASHBigl] = ACTIONS(6510),
    [anon_sym_BSLASHbiggl] = ACTIONS(6510),
    [anon_sym_BSLASHBiggl] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHtext] = ACTIONS(6510),
    [anon_sym_BSLASHintertext] = ACTIONS(6510),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [1193] = {
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_LBRACK] = ACTIONS(6500),
    [anon_sym_RBRACK] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [anon_sym_EQ] = ACTIONS(6500),
    [anon_sym_LPAREN] = ACTIONS(6500),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHpart] = ACTIONS(6498),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddpart] = ACTIONS(6498),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHchapter] = ACTIONS(6498),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddchap] = ACTIONS(6498),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsection] = ACTIONS(6498),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddsec] = ACTIONS(6498),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHitem] = ACTIONS(6498),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6500),
    [anon_sym_LBRACE] = ACTIONS(6500),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6500),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6500),
    [anon_sym_DOLLAR] = ACTIONS(6498),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHbegin] = ACTIONS(6498),
    [anon_sym_BSLASHend] = ACTIONS(6498),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHleft] = ACTIONS(6498),
    [anon_sym_BSLASHbigl] = ACTIONS(6498),
    [anon_sym_BSLASHBigl] = ACTIONS(6498),
    [anon_sym_BSLASHbiggl] = ACTIONS(6498),
    [anon_sym_BSLASHBiggl] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHtext] = ACTIONS(6498),
    [anon_sym_BSLASHintertext] = ACTIONS(6498),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [1194] = {
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_LBRACK] = ACTIONS(6496),
    [anon_sym_RBRACK] = ACTIONS(6496),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6496),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_RPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHpart] = ACTIONS(6494),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddpart] = ACTIONS(6494),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHchapter] = ACTIONS(6494),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddchap] = ACTIONS(6494),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsection] = ACTIONS(6494),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddsec] = ACTIONS(6494),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHitem] = ACTIONS(6494),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6496),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6496),
    [anon_sym_DOLLAR] = ACTIONS(6494),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHbegin] = ACTIONS(6494),
    [anon_sym_BSLASHend] = ACTIONS(6494),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHleft] = ACTIONS(6494),
    [anon_sym_BSLASHbigl] = ACTIONS(6494),
    [anon_sym_BSLASHBigl] = ACTIONS(6494),
    [anon_sym_BSLASHbiggl] = ACTIONS(6494),
    [anon_sym_BSLASHBiggl] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHtext] = ACTIONS(6494),
    [anon_sym_BSLASHintertext] = ACTIONS(6494),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [1195] = {
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_LBRACK] = ACTIONS(6516),
    [anon_sym_RBRACK] = ACTIONS(6516),
    [anon_sym_COMMA] = ACTIONS(6516),
    [anon_sym_EQ] = ACTIONS(6516),
    [anon_sym_LPAREN] = ACTIONS(6516),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHpart] = ACTIONS(6514),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddpart] = ACTIONS(6514),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHchapter] = ACTIONS(6514),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddchap] = ACTIONS(6514),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsection] = ACTIONS(6514),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddsec] = ACTIONS(6514),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHitem] = ACTIONS(6514),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6516),
    [anon_sym_LBRACE] = ACTIONS(6516),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6516),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(6514),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6516),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHbegin] = ACTIONS(6514),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHleft] = ACTIONS(6514),
    [anon_sym_BSLASHbigl] = ACTIONS(6514),
    [anon_sym_BSLASHBigl] = ACTIONS(6514),
    [anon_sym_BSLASHbiggl] = ACTIONS(6514),
    [anon_sym_BSLASHBiggl] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHtext] = ACTIONS(6514),
    [anon_sym_BSLASHintertext] = ACTIONS(6514),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [1196] = {
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_LBRACK] = ACTIONS(6520),
    [anon_sym_RBRACK] = ACTIONS(6520),
    [anon_sym_COMMA] = ACTIONS(6520),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_LPAREN] = ACTIONS(6520),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHpart] = ACTIONS(6518),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddpart] = ACTIONS(6518),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHchapter] = ACTIONS(6518),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddchap] = ACTIONS(6518),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsection] = ACTIONS(6518),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddsec] = ACTIONS(6518),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHitem] = ACTIONS(6518),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6520),
    [anon_sym_LBRACE] = ACTIONS(6520),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6520),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6520),
    [anon_sym_DOLLAR] = ACTIONS(6518),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6520),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHbegin] = ACTIONS(6518),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHleft] = ACTIONS(6518),
    [anon_sym_BSLASHbigl] = ACTIONS(6518),
    [anon_sym_BSLASHBigl] = ACTIONS(6518),
    [anon_sym_BSLASHbiggl] = ACTIONS(6518),
    [anon_sym_BSLASHBiggl] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHtext] = ACTIONS(6518),
    [anon_sym_BSLASHintertext] = ACTIONS(6518),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [1197] = {
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_LBRACK] = ACTIONS(6574),
    [anon_sym_RBRACK] = ACTIONS(6574),
    [anon_sym_COMMA] = ACTIONS(6574),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_RPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHpart] = ACTIONS(6572),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddpart] = ACTIONS(6572),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHchapter] = ACTIONS(6572),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddchap] = ACTIONS(6572),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsection] = ACTIONS(6572),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddsec] = ACTIONS(6572),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHitem] = ACTIONS(6572),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6574),
    [anon_sym_LBRACE] = ACTIONS(6574),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6574),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6574),
    [anon_sym_DOLLAR] = ACTIONS(6572),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6574),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHbegin] = ACTIONS(6572),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHleft] = ACTIONS(6572),
    [anon_sym_BSLASHbigl] = ACTIONS(6572),
    [anon_sym_BSLASHBigl] = ACTIONS(6572),
    [anon_sym_BSLASHbiggl] = ACTIONS(6572),
    [anon_sym_BSLASHBiggl] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHtext] = ACTIONS(6572),
    [anon_sym_BSLASHintertext] = ACTIONS(6572),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [1198] = {
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6280),
    [anon_sym_RBRACK] = ACTIONS(6280),
    [anon_sym_COMMA] = ACTIONS(6280),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_RPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHpart] = ACTIONS(6278),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddpart] = ACTIONS(6278),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHchapter] = ACTIONS(6278),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddchap] = ACTIONS(6278),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsection] = ACTIONS(6278),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddsec] = ACTIONS(6278),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHitem] = ACTIONS(6278),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6280),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6280),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6280),
    [anon_sym_DOLLAR] = ACTIONS(6278),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHbegin] = ACTIONS(6278),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHleft] = ACTIONS(6278),
    [anon_sym_BSLASHbigl] = ACTIONS(6278),
    [anon_sym_BSLASHBigl] = ACTIONS(6278),
    [anon_sym_BSLASHbiggl] = ACTIONS(6278),
    [anon_sym_BSLASHBiggl] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHtext] = ACTIONS(6278),
    [anon_sym_BSLASHintertext] = ACTIONS(6278),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [1199] = {
    [sym_command_name] = ACTIONS(6170),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6172),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6172),
    [anon_sym_LPAREN] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHpart] = ACTIONS(6170),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddpart] = ACTIONS(6170),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHchapter] = ACTIONS(6170),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddchap] = ACTIONS(6170),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsection] = ACTIONS(6170),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddsec] = ACTIONS(6170),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHitem] = ACTIONS(6170),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [sym_word] = ACTIONS(6170),
    [sym_placeholder] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_BANG] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_SQUOTE] = ACTIONS(6170),
    [anon_sym__] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6172),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6172),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6172),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHbegin] = ACTIONS(6170),
    [anon_sym_BSLASHtitle] = ACTIONS(6170),
    [anon_sym_BSLASHauthor] = ACTIONS(6170),
    [anon_sym_BSLASHusepackage] = ACTIONS(6170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6170),
    [anon_sym_BSLASHinclude] = ACTIONS(6170),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6170),
    [anon_sym_BSLASHinput] = ACTIONS(6170),
    [anon_sym_BSLASHsubfile] = ACTIONS(6170),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6170),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6170),
    [anon_sym_BSLASHbibliography] = ACTIONS(6170),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6170),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6170),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6170),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6170),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6170),
    [anon_sym_BSLASHimport] = ACTIONS(6170),
    [anon_sym_BSLASHsubimport] = ACTIONS(6170),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6170),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHcaption] = ACTIONS(6170),
    [anon_sym_BSLASHcite] = ACTIONS(6170),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCite] = ACTIONS(6170),
    [anon_sym_BSLASHnocite] = ACTIONS(6170),
    [anon_sym_BSLASHcitet] = ACTIONS(6170),
    [anon_sym_BSLASHcitep] = ACTIONS(6170),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteA] = ACTIONS(6170),
    [anon_sym_BSLASHciteR] = ACTIONS(6170),
    [anon_sym_BSLASHciteS] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6170),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteyear] = ACTIONS(6170),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitedate] = ACTIONS(6170),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteurl] = ACTIONS(6170),
    [anon_sym_BSLASHfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6170),
    [anon_sym_BSLASHcitealt] = ACTIONS(6170),
    [anon_sym_BSLASHcitealp] = ACTIONS(6170),
    [anon_sym_BSLASHcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHparencite] = ACTIONS(6170),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHParencite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHtextcite] = ACTIONS(6170),
    [anon_sym_BSLASHTextcite] = ACTIONS(6170),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHsupercite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite] = ACTIONS(6170),
    [anon_sym_BSLASHAutocite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHVolcite] = ACTIONS(6170),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHavolcite] = ACTIONS(6170),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHNotecite] = ACTIONS(6170),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHlabel] = ACTIONS(6170),
    [anon_sym_BSLASHref] = ACTIONS(6170),
    [anon_sym_BSLASHeqref] = ACTIONS(6170),
    [anon_sym_BSLASHvref] = ACTIONS(6170),
    [anon_sym_BSLASHVref] = ACTIONS(6170),
    [anon_sym_BSLASHautoref] = ACTIONS(6170),
    [anon_sym_BSLASHpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcref] = ACTIONS(6170),
    [anon_sym_BSLASHCref] = ACTIONS(6170),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnameCref] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHdef] = ACTIONS(6170),
    [anon_sym_BSLASHlet] = ACTIONS(6170),
    [anon_sym_BSLASHleft] = ACTIONS(6170),
    [anon_sym_BSLASHbigl] = ACTIONS(6170),
    [anon_sym_BSLASHBigl] = ACTIONS(6170),
    [anon_sym_BSLASHbiggl] = ACTIONS(6170),
    [anon_sym_BSLASHBiggl] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6170),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6170),
    [anon_sym_BSLASHgls] = ACTIONS(6170),
    [anon_sym_BSLASHGls] = ACTIONS(6170),
    [anon_sym_BSLASHGLS] = ACTIONS(6170),
    [anon_sym_BSLASHglspl] = ACTIONS(6170),
    [anon_sym_BSLASHGlspl] = ACTIONS(6170),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6170),
    [anon_sym_BSLASHglslink] = ACTIONS(6170),
    [anon_sym_BSLASHglstext] = ACTIONS(6170),
    [anon_sym_BSLASHGlstext] = ACTIONS(6170),
    [anon_sym_BSLASHGLStext] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6170),
    [anon_sym_BSLASHglsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsname] = ACTIONS(6170),
    [anon_sym_BSLASHGlsname] = ACTIONS(6170),
    [anon_sym_BSLASHGLSname] = ACTIONS(6170),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6170),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6170),
    [anon_sym_BSLASHacrshort] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6170),
    [anon_sym_BSLASHACRshort] = ACTIONS(6170),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrlong] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6170),
    [anon_sym_BSLASHACRlong] = ACTIONS(6170),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrfull] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6170),
    [anon_sym_BSLASHACRfull] = ACTIONS(6170),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHacs] = ACTIONS(6170),
    [anon_sym_BSLASHAcs] = ACTIONS(6170),
    [anon_sym_BSLASHacsp] = ACTIONS(6170),
    [anon_sym_BSLASHAcsp] = ACTIONS(6170),
    [anon_sym_BSLASHacl] = ACTIONS(6170),
    [anon_sym_BSLASHAcl] = ACTIONS(6170),
    [anon_sym_BSLASHaclp] = ACTIONS(6170),
    [anon_sym_BSLASHAclp] = ACTIONS(6170),
    [anon_sym_BSLASHacf] = ACTIONS(6170),
    [anon_sym_BSLASHAcf] = ACTIONS(6170),
    [anon_sym_BSLASHacfp] = ACTIONS(6170),
    [anon_sym_BSLASHAcfp] = ACTIONS(6170),
    [anon_sym_BSLASHac] = ACTIONS(6170),
    [anon_sym_BSLASHAc] = ACTIONS(6170),
    [anon_sym_BSLASHacp] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6170),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6170),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6170),
    [anon_sym_BSLASHcolor] = ACTIONS(6170),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6170),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6170),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6170),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6170),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6170),
    [anon_sym_BSLASHtext] = ACTIONS(6170),
    [anon_sym_BSLASHintertext] = ACTIONS(6170),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6170),
    [anon_sym_BSLASHurl] = ACTIONS(6170),
    [anon_sym_BSLASHhref] = ACTIONS(6170),
  },
  [1200] = {
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6556),
    [anon_sym_RBRACK] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6556),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHpart] = ACTIONS(6554),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddpart] = ACTIONS(6554),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHchapter] = ACTIONS(6554),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddchap] = ACTIONS(6554),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsection] = ACTIONS(6554),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddsec] = ACTIONS(6554),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHitem] = ACTIONS(6554),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6556),
    [anon_sym_LBRACE] = ACTIONS(6556),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6556),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6556),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6556),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHbegin] = ACTIONS(6554),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHleft] = ACTIONS(6554),
    [anon_sym_BSLASHbigl] = ACTIONS(6554),
    [anon_sym_BSLASHBigl] = ACTIONS(6554),
    [anon_sym_BSLASHbiggl] = ACTIONS(6554),
    [anon_sym_BSLASHBiggl] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHtext] = ACTIONS(6554),
    [anon_sym_BSLASHintertext] = ACTIONS(6554),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [1201] = {
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6552),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHpart] = ACTIONS(6550),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddpart] = ACTIONS(6550),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHchapter] = ACTIONS(6550),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddchap] = ACTIONS(6550),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsection] = ACTIONS(6550),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddsec] = ACTIONS(6550),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHitem] = ACTIONS(6550),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6552),
    [anon_sym_DOLLAR] = ACTIONS(6550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6552),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHbegin] = ACTIONS(6550),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHleft] = ACTIONS(6550),
    [anon_sym_BSLASHbigl] = ACTIONS(6550),
    [anon_sym_BSLASHBigl] = ACTIONS(6550),
    [anon_sym_BSLASHbiggl] = ACTIONS(6550),
    [anon_sym_BSLASHBiggl] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHtext] = ACTIONS(6550),
    [anon_sym_BSLASHintertext] = ACTIONS(6550),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [1202] = {
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_LBRACK] = ACTIONS(6472),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_EQ] = ACTIONS(6472),
    [anon_sym_LPAREN] = ACTIONS(6472),
    [anon_sym_RPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHpart] = ACTIONS(6470),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddpart] = ACTIONS(6470),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHchapter] = ACTIONS(6470),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddchap] = ACTIONS(6470),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsection] = ACTIONS(6470),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddsec] = ACTIONS(6470),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHitem] = ACTIONS(6470),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6472),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6472),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6472),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHbegin] = ACTIONS(6470),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHleft] = ACTIONS(6470),
    [anon_sym_BSLASHbigl] = ACTIONS(6470),
    [anon_sym_BSLASHBigl] = ACTIONS(6470),
    [anon_sym_BSLASHbiggl] = ACTIONS(6470),
    [anon_sym_BSLASHBiggl] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHtext] = ACTIONS(6470),
    [anon_sym_BSLASHintertext] = ACTIONS(6470),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [1203] = {
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_RBRACK] = ACTIONS(6452),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6452),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHpart] = ACTIONS(6450),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddpart] = ACTIONS(6450),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHchapter] = ACTIONS(6450),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddchap] = ACTIONS(6450),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsection] = ACTIONS(6450),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddsec] = ACTIONS(6450),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHitem] = ACTIONS(6450),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6452),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(6450),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6452),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHbegin] = ACTIONS(6450),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHleft] = ACTIONS(6450),
    [anon_sym_BSLASHbigl] = ACTIONS(6450),
    [anon_sym_BSLASHBigl] = ACTIONS(6450),
    [anon_sym_BSLASHbiggl] = ACTIONS(6450),
    [anon_sym_BSLASHBiggl] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHtext] = ACTIONS(6450),
    [anon_sym_BSLASHintertext] = ACTIONS(6450),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [1204] = {
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_RBRACK] = ACTIONS(6352),
    [anon_sym_COMMA] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_LPAREN] = ACTIONS(6352),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHpart] = ACTIONS(6350),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddpart] = ACTIONS(6350),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHchapter] = ACTIONS(6350),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddchap] = ACTIONS(6350),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsection] = ACTIONS(6350),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddsec] = ACTIONS(6350),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHitem] = ACTIONS(6350),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6352),
    [anon_sym_LBRACE] = ACTIONS(6352),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6352),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6352),
    [anon_sym_DOLLAR] = ACTIONS(6350),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6352),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHbegin] = ACTIONS(6350),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHleft] = ACTIONS(6350),
    [anon_sym_BSLASHbigl] = ACTIONS(6350),
    [anon_sym_BSLASHBigl] = ACTIONS(6350),
    [anon_sym_BSLASHbiggl] = ACTIONS(6350),
    [anon_sym_BSLASHBiggl] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHtext] = ACTIONS(6350),
    [anon_sym_BSLASHintertext] = ACTIONS(6350),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [1205] = {
    [sym_command_name] = ACTIONS(6638),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6640),
    [anon_sym_RBRACK] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LPAREN] = ACTIONS(6640),
    [anon_sym_RPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHpart] = ACTIONS(6638),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddpart] = ACTIONS(6638),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHchapter] = ACTIONS(6638),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddchap] = ACTIONS(6638),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsection] = ACTIONS(6638),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddsec] = ACTIONS(6638),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHitem] = ACTIONS(6638),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(6640),
    [sym_word] = ACTIONS(6638),
    [sym_placeholder] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_DASH] = ACTIONS(6640),
    [anon_sym_STAR] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6638),
    [anon_sym_GT] = ACTIONS(6638),
    [anon_sym_BANG] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6638),
    [anon_sym_COLON] = ACTIONS(6638),
    [anon_sym_SQUOTE] = ACTIONS(6638),
    [anon_sym__] = ACTIONS(6640),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6640),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6640),
    [anon_sym_DOLLAR] = ACTIONS(6638),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHbegin] = ACTIONS(6638),
    [anon_sym_BSLASHend] = ACTIONS(6638),
    [anon_sym_BSLASHtitle] = ACTIONS(6638),
    [anon_sym_BSLASHauthor] = ACTIONS(6638),
    [anon_sym_BSLASHusepackage] = ACTIONS(6638),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6638),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6638),
    [anon_sym_BSLASHinclude] = ACTIONS(6638),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6638),
    [anon_sym_BSLASHinput] = ACTIONS(6638),
    [anon_sym_BSLASHsubfile] = ACTIONS(6638),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6638),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6638),
    [anon_sym_BSLASHbibliography] = ACTIONS(6638),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6638),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6638),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6638),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6638),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6638),
    [anon_sym_BSLASHimport] = ACTIONS(6638),
    [anon_sym_BSLASHsubimport] = ACTIONS(6638),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6638),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHcaption] = ACTIONS(6638),
    [anon_sym_BSLASHcite] = ACTIONS(6638),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCite] = ACTIONS(6638),
    [anon_sym_BSLASHnocite] = ACTIONS(6638),
    [anon_sym_BSLASHcitet] = ACTIONS(6638),
    [anon_sym_BSLASHcitep] = ACTIONS(6638),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteA] = ACTIONS(6638),
    [anon_sym_BSLASHciteR] = ACTIONS(6638),
    [anon_sym_BSLASHciteS] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6638),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteyear] = ACTIONS(6638),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitedate] = ACTIONS(6638),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteurl] = ACTIONS(6638),
    [anon_sym_BSLASHfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6638),
    [anon_sym_BSLASHcitealt] = ACTIONS(6638),
    [anon_sym_BSLASHcitealp] = ACTIONS(6638),
    [anon_sym_BSLASHcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHparencite] = ACTIONS(6638),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHParencite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHtextcite] = ACTIONS(6638),
    [anon_sym_BSLASHTextcite] = ACTIONS(6638),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHsupercite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite] = ACTIONS(6638),
    [anon_sym_BSLASHAutocite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHVolcite] = ACTIONS(6638),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHavolcite] = ACTIONS(6638),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHNotecite] = ACTIONS(6638),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHlabel] = ACTIONS(6638),
    [anon_sym_BSLASHref] = ACTIONS(6638),
    [anon_sym_BSLASHeqref] = ACTIONS(6638),
    [anon_sym_BSLASHvref] = ACTIONS(6638),
    [anon_sym_BSLASHVref] = ACTIONS(6638),
    [anon_sym_BSLASHautoref] = ACTIONS(6638),
    [anon_sym_BSLASHpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcref] = ACTIONS(6638),
    [anon_sym_BSLASHCref] = ACTIONS(6638),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnameCref] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHdef] = ACTIONS(6638),
    [anon_sym_BSLASHlet] = ACTIONS(6638),
    [anon_sym_BSLASHleft] = ACTIONS(6638),
    [anon_sym_BSLASHbigl] = ACTIONS(6638),
    [anon_sym_BSLASHBigl] = ACTIONS(6638),
    [anon_sym_BSLASHbiggl] = ACTIONS(6638),
    [anon_sym_BSLASHBiggl] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6638),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6638),
    [anon_sym_BSLASHgls] = ACTIONS(6638),
    [anon_sym_BSLASHGls] = ACTIONS(6638),
    [anon_sym_BSLASHGLS] = ACTIONS(6638),
    [anon_sym_BSLASHglspl] = ACTIONS(6638),
    [anon_sym_BSLASHGlspl] = ACTIONS(6638),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6638),
    [anon_sym_BSLASHglslink] = ACTIONS(6638),
    [anon_sym_BSLASHglstext] = ACTIONS(6638),
    [anon_sym_BSLASHGlstext] = ACTIONS(6638),
    [anon_sym_BSLASHGLStext] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6638),
    [anon_sym_BSLASHglsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsname] = ACTIONS(6638),
    [anon_sym_BSLASHGlsname] = ACTIONS(6638),
    [anon_sym_BSLASHGLSname] = ACTIONS(6638),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6638),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6638),
    [anon_sym_BSLASHacrshort] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6638),
    [anon_sym_BSLASHACRshort] = ACTIONS(6638),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrlong] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6638),
    [anon_sym_BSLASHACRlong] = ACTIONS(6638),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrfull] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6638),
    [anon_sym_BSLASHACRfull] = ACTIONS(6638),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHacs] = ACTIONS(6638),
    [anon_sym_BSLASHAcs] = ACTIONS(6638),
    [anon_sym_BSLASHacsp] = ACTIONS(6638),
    [anon_sym_BSLASHAcsp] = ACTIONS(6638),
    [anon_sym_BSLASHacl] = ACTIONS(6638),
    [anon_sym_BSLASHAcl] = ACTIONS(6638),
    [anon_sym_BSLASHaclp] = ACTIONS(6638),
    [anon_sym_BSLASHAclp] = ACTIONS(6638),
    [anon_sym_BSLASHacf] = ACTIONS(6638),
    [anon_sym_BSLASHAcf] = ACTIONS(6638),
    [anon_sym_BSLASHacfp] = ACTIONS(6638),
    [anon_sym_BSLASHAcfp] = ACTIONS(6638),
    [anon_sym_BSLASHac] = ACTIONS(6638),
    [anon_sym_BSLASHAc] = ACTIONS(6638),
    [anon_sym_BSLASHacp] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6638),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6638),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6638),
    [anon_sym_BSLASHcolor] = ACTIONS(6638),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6638),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6638),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6638),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6638),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6638),
    [anon_sym_BSLASHtext] = ACTIONS(6638),
    [anon_sym_BSLASHintertext] = ACTIONS(6638),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6638),
    [anon_sym_BSLASHurl] = ACTIONS(6638),
    [anon_sym_BSLASHhref] = ACTIONS(6638),
  },
  [1206] = {
    [sym_command_name] = ACTIONS(6630),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LPAREN] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHpart] = ACTIONS(6630),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddpart] = ACTIONS(6630),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHchapter] = ACTIONS(6630),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddchap] = ACTIONS(6630),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsection] = ACTIONS(6630),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddsec] = ACTIONS(6630),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHitem] = ACTIONS(6630),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [sym_word] = ACTIONS(6630),
    [sym_placeholder] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [anon_sym_STAR] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_BANG] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_COLON] = ACTIONS(6630),
    [anon_sym_SQUOTE] = ACTIONS(6630),
    [anon_sym__] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6632),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6632),
    [anon_sym_DOLLAR] = ACTIONS(6630),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHbegin] = ACTIONS(6630),
    [anon_sym_BSLASHend] = ACTIONS(6630),
    [anon_sym_BSLASHtitle] = ACTIONS(6630),
    [anon_sym_BSLASHauthor] = ACTIONS(6630),
    [anon_sym_BSLASHusepackage] = ACTIONS(6630),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6630),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6630),
    [anon_sym_BSLASHinclude] = ACTIONS(6630),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6630),
    [anon_sym_BSLASHinput] = ACTIONS(6630),
    [anon_sym_BSLASHsubfile] = ACTIONS(6630),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6630),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6630),
    [anon_sym_BSLASHbibliography] = ACTIONS(6630),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6630),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6630),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6630),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6630),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6630),
    [anon_sym_BSLASHimport] = ACTIONS(6630),
    [anon_sym_BSLASHsubimport] = ACTIONS(6630),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6630),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHcaption] = ACTIONS(6630),
    [anon_sym_BSLASHcite] = ACTIONS(6630),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCite] = ACTIONS(6630),
    [anon_sym_BSLASHnocite] = ACTIONS(6630),
    [anon_sym_BSLASHcitet] = ACTIONS(6630),
    [anon_sym_BSLASHcitep] = ACTIONS(6630),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteA] = ACTIONS(6630),
    [anon_sym_BSLASHciteR] = ACTIONS(6630),
    [anon_sym_BSLASHciteS] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6630),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteyear] = ACTIONS(6630),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitedate] = ACTIONS(6630),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteurl] = ACTIONS(6630),
    [anon_sym_BSLASHfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6630),
    [anon_sym_BSLASHcitealt] = ACTIONS(6630),
    [anon_sym_BSLASHcitealp] = ACTIONS(6630),
    [anon_sym_BSLASHcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHparencite] = ACTIONS(6630),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHParencite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHtextcite] = ACTIONS(6630),
    [anon_sym_BSLASHTextcite] = ACTIONS(6630),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHsupercite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite] = ACTIONS(6630),
    [anon_sym_BSLASHAutocite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHVolcite] = ACTIONS(6630),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHavolcite] = ACTIONS(6630),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHNotecite] = ACTIONS(6630),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHlabel] = ACTIONS(6630),
    [anon_sym_BSLASHref] = ACTIONS(6630),
    [anon_sym_BSLASHeqref] = ACTIONS(6630),
    [anon_sym_BSLASHvref] = ACTIONS(6630),
    [anon_sym_BSLASHVref] = ACTIONS(6630),
    [anon_sym_BSLASHautoref] = ACTIONS(6630),
    [anon_sym_BSLASHpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcref] = ACTIONS(6630),
    [anon_sym_BSLASHCref] = ACTIONS(6630),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnameCref] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHdef] = ACTIONS(6630),
    [anon_sym_BSLASHlet] = ACTIONS(6630),
    [anon_sym_BSLASHleft] = ACTIONS(6630),
    [anon_sym_BSLASHbigl] = ACTIONS(6630),
    [anon_sym_BSLASHBigl] = ACTIONS(6630),
    [anon_sym_BSLASHbiggl] = ACTIONS(6630),
    [anon_sym_BSLASHBiggl] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6630),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6630),
    [anon_sym_BSLASHgls] = ACTIONS(6630),
    [anon_sym_BSLASHGls] = ACTIONS(6630),
    [anon_sym_BSLASHGLS] = ACTIONS(6630),
    [anon_sym_BSLASHglspl] = ACTIONS(6630),
    [anon_sym_BSLASHGlspl] = ACTIONS(6630),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6630),
    [anon_sym_BSLASHglslink] = ACTIONS(6630),
    [anon_sym_BSLASHglstext] = ACTIONS(6630),
    [anon_sym_BSLASHGlstext] = ACTIONS(6630),
    [anon_sym_BSLASHGLStext] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6630),
    [anon_sym_BSLASHglsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsname] = ACTIONS(6630),
    [anon_sym_BSLASHGlsname] = ACTIONS(6630),
    [anon_sym_BSLASHGLSname] = ACTIONS(6630),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6630),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6630),
    [anon_sym_BSLASHacrshort] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6630),
    [anon_sym_BSLASHACRshort] = ACTIONS(6630),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrlong] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6630),
    [anon_sym_BSLASHACRlong] = ACTIONS(6630),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrfull] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6630),
    [anon_sym_BSLASHACRfull] = ACTIONS(6630),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHacs] = ACTIONS(6630),
    [anon_sym_BSLASHAcs] = ACTIONS(6630),
    [anon_sym_BSLASHacsp] = ACTIONS(6630),
    [anon_sym_BSLASHAcsp] = ACTIONS(6630),
    [anon_sym_BSLASHacl] = ACTIONS(6630),
    [anon_sym_BSLASHAcl] = ACTIONS(6630),
    [anon_sym_BSLASHaclp] = ACTIONS(6630),
    [anon_sym_BSLASHAclp] = ACTIONS(6630),
    [anon_sym_BSLASHacf] = ACTIONS(6630),
    [anon_sym_BSLASHAcf] = ACTIONS(6630),
    [anon_sym_BSLASHacfp] = ACTIONS(6630),
    [anon_sym_BSLASHAcfp] = ACTIONS(6630),
    [anon_sym_BSLASHac] = ACTIONS(6630),
    [anon_sym_BSLASHAc] = ACTIONS(6630),
    [anon_sym_BSLASHacp] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6630),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6630),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6630),
    [anon_sym_BSLASHcolor] = ACTIONS(6630),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6630),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6630),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6630),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6630),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6630),
    [anon_sym_BSLASHtext] = ACTIONS(6630),
    [anon_sym_BSLASHintertext] = ACTIONS(6630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6630),
    [anon_sym_BSLASHurl] = ACTIONS(6630),
    [anon_sym_BSLASHhref] = ACTIONS(6630),
  },
  [1207] = {
    [sym_command_name] = ACTIONS(6626),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6628),
    [anon_sym_RBRACK] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LPAREN] = ACTIONS(6628),
    [anon_sym_RPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHpart] = ACTIONS(6626),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddpart] = ACTIONS(6626),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHchapter] = ACTIONS(6626),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddchap] = ACTIONS(6626),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsection] = ACTIONS(6626),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddsec] = ACTIONS(6626),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHitem] = ACTIONS(6626),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6628),
    [anon_sym_LBRACE] = ACTIONS(6628),
    [sym_word] = ACTIONS(6626),
    [sym_placeholder] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_DASH] = ACTIONS(6628),
    [anon_sym_STAR] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6626),
    [anon_sym_GT] = ACTIONS(6626),
    [anon_sym_BANG] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6626),
    [anon_sym_COLON] = ACTIONS(6626),
    [anon_sym_SQUOTE] = ACTIONS(6626),
    [anon_sym__] = ACTIONS(6628),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6628),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6628),
    [anon_sym_DOLLAR] = ACTIONS(6626),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHbegin] = ACTIONS(6626),
    [anon_sym_BSLASHend] = ACTIONS(6626),
    [anon_sym_BSLASHtitle] = ACTIONS(6626),
    [anon_sym_BSLASHauthor] = ACTIONS(6626),
    [anon_sym_BSLASHusepackage] = ACTIONS(6626),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6626),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6626),
    [anon_sym_BSLASHinclude] = ACTIONS(6626),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6626),
    [anon_sym_BSLASHinput] = ACTIONS(6626),
    [anon_sym_BSLASHsubfile] = ACTIONS(6626),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6626),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6626),
    [anon_sym_BSLASHbibliography] = ACTIONS(6626),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6626),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6626),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6626),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6626),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6626),
    [anon_sym_BSLASHimport] = ACTIONS(6626),
    [anon_sym_BSLASHsubimport] = ACTIONS(6626),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6626),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHcaption] = ACTIONS(6626),
    [anon_sym_BSLASHcite] = ACTIONS(6626),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCite] = ACTIONS(6626),
    [anon_sym_BSLASHnocite] = ACTIONS(6626),
    [anon_sym_BSLASHcitet] = ACTIONS(6626),
    [anon_sym_BSLASHcitep] = ACTIONS(6626),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteA] = ACTIONS(6626),
    [anon_sym_BSLASHciteR] = ACTIONS(6626),
    [anon_sym_BSLASHciteS] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6626),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteyear] = ACTIONS(6626),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitedate] = ACTIONS(6626),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteurl] = ACTIONS(6626),
    [anon_sym_BSLASHfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6626),
    [anon_sym_BSLASHcitealt] = ACTIONS(6626),
    [anon_sym_BSLASHcitealp] = ACTIONS(6626),
    [anon_sym_BSLASHcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHparencite] = ACTIONS(6626),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHParencite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHtextcite] = ACTIONS(6626),
    [anon_sym_BSLASHTextcite] = ACTIONS(6626),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHsupercite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite] = ACTIONS(6626),
    [anon_sym_BSLASHAutocite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHVolcite] = ACTIONS(6626),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHavolcite] = ACTIONS(6626),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHNotecite] = ACTIONS(6626),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHlabel] = ACTIONS(6626),
    [anon_sym_BSLASHref] = ACTIONS(6626),
    [anon_sym_BSLASHeqref] = ACTIONS(6626),
    [anon_sym_BSLASHvref] = ACTIONS(6626),
    [anon_sym_BSLASHVref] = ACTIONS(6626),
    [anon_sym_BSLASHautoref] = ACTIONS(6626),
    [anon_sym_BSLASHpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcref] = ACTIONS(6626),
    [anon_sym_BSLASHCref] = ACTIONS(6626),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnameCref] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHdef] = ACTIONS(6626),
    [anon_sym_BSLASHlet] = ACTIONS(6626),
    [anon_sym_BSLASHleft] = ACTIONS(6626),
    [anon_sym_BSLASHbigl] = ACTIONS(6626),
    [anon_sym_BSLASHBigl] = ACTIONS(6626),
    [anon_sym_BSLASHbiggl] = ACTIONS(6626),
    [anon_sym_BSLASHBiggl] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6626),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6626),
    [anon_sym_BSLASHgls] = ACTIONS(6626),
    [anon_sym_BSLASHGls] = ACTIONS(6626),
    [anon_sym_BSLASHGLS] = ACTIONS(6626),
    [anon_sym_BSLASHglspl] = ACTIONS(6626),
    [anon_sym_BSLASHGlspl] = ACTIONS(6626),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6626),
    [anon_sym_BSLASHglslink] = ACTIONS(6626),
    [anon_sym_BSLASHglstext] = ACTIONS(6626),
    [anon_sym_BSLASHGlstext] = ACTIONS(6626),
    [anon_sym_BSLASHGLStext] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6626),
    [anon_sym_BSLASHglsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsname] = ACTIONS(6626),
    [anon_sym_BSLASHGlsname] = ACTIONS(6626),
    [anon_sym_BSLASHGLSname] = ACTIONS(6626),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6626),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6626),
    [anon_sym_BSLASHacrshort] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6626),
    [anon_sym_BSLASHACRshort] = ACTIONS(6626),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrlong] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6626),
    [anon_sym_BSLASHACRlong] = ACTIONS(6626),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrfull] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6626),
    [anon_sym_BSLASHACRfull] = ACTIONS(6626),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHacs] = ACTIONS(6626),
    [anon_sym_BSLASHAcs] = ACTIONS(6626),
    [anon_sym_BSLASHacsp] = ACTIONS(6626),
    [anon_sym_BSLASHAcsp] = ACTIONS(6626),
    [anon_sym_BSLASHacl] = ACTIONS(6626),
    [anon_sym_BSLASHAcl] = ACTIONS(6626),
    [anon_sym_BSLASHaclp] = ACTIONS(6626),
    [anon_sym_BSLASHAclp] = ACTIONS(6626),
    [anon_sym_BSLASHacf] = ACTIONS(6626),
    [anon_sym_BSLASHAcf] = ACTIONS(6626),
    [anon_sym_BSLASHacfp] = ACTIONS(6626),
    [anon_sym_BSLASHAcfp] = ACTIONS(6626),
    [anon_sym_BSLASHac] = ACTIONS(6626),
    [anon_sym_BSLASHAc] = ACTIONS(6626),
    [anon_sym_BSLASHacp] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6626),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6626),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6626),
    [anon_sym_BSLASHcolor] = ACTIONS(6626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6626),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6626),
    [anon_sym_BSLASHtext] = ACTIONS(6626),
    [anon_sym_BSLASHintertext] = ACTIONS(6626),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6626),
    [anon_sym_BSLASHurl] = ACTIONS(6626),
    [anon_sym_BSLASHhref] = ACTIONS(6626),
  },
  [1208] = {
    [sym_command_name] = ACTIONS(6598),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6598),
    [anon_sym_LBRACK] = ACTIONS(6600),
    [anon_sym_RBRACK] = ACTIONS(6600),
    [anon_sym_COMMA] = ACTIONS(6600),
    [anon_sym_EQ] = ACTIONS(6600),
    [anon_sym_LPAREN] = ACTIONS(6600),
    [anon_sym_RPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHpart] = ACTIONS(6598),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddpart] = ACTIONS(6598),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHchapter] = ACTIONS(6598),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddchap] = ACTIONS(6598),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsection] = ACTIONS(6598),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddsec] = ACTIONS(6598),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHitem] = ACTIONS(6598),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6600),
    [anon_sym_LBRACE] = ACTIONS(6600),
    [sym_word] = ACTIONS(6598),
    [sym_placeholder] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6600),
    [anon_sym_DASH] = ACTIONS(6600),
    [anon_sym_STAR] = ACTIONS(6600),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_BANG] = ACTIONS(6598),
    [anon_sym_PIPE] = ACTIONS(6598),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_SQUOTE] = ACTIONS(6598),
    [anon_sym__] = ACTIONS(6600),
    [anon_sym_CARET] = ACTIONS(6600),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6600),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6600),
    [anon_sym_DOLLAR] = ACTIONS(6598),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHbegin] = ACTIONS(6598),
    [anon_sym_BSLASHend] = ACTIONS(6598),
    [anon_sym_BSLASHtitle] = ACTIONS(6598),
    [anon_sym_BSLASHauthor] = ACTIONS(6598),
    [anon_sym_BSLASHusepackage] = ACTIONS(6598),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6598),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6598),
    [anon_sym_BSLASHinclude] = ACTIONS(6598),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6598),
    [anon_sym_BSLASHinput] = ACTIONS(6598),
    [anon_sym_BSLASHsubfile] = ACTIONS(6598),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6598),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6598),
    [anon_sym_BSLASHbibliography] = ACTIONS(6598),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6598),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6598),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6598),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6598),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6598),
    [anon_sym_BSLASHimport] = ACTIONS(6598),
    [anon_sym_BSLASHsubimport] = ACTIONS(6598),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6598),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHcaption] = ACTIONS(6598),
    [anon_sym_BSLASHcite] = ACTIONS(6598),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCite] = ACTIONS(6598),
    [anon_sym_BSLASHnocite] = ACTIONS(6598),
    [anon_sym_BSLASHcitet] = ACTIONS(6598),
    [anon_sym_BSLASHcitep] = ACTIONS(6598),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteA] = ACTIONS(6598),
    [anon_sym_BSLASHciteR] = ACTIONS(6598),
    [anon_sym_BSLASHciteS] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6598),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteyear] = ACTIONS(6598),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitedate] = ACTIONS(6598),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteurl] = ACTIONS(6598),
    [anon_sym_BSLASHfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6598),
    [anon_sym_BSLASHcitealt] = ACTIONS(6598),
    [anon_sym_BSLASHcitealp] = ACTIONS(6598),
    [anon_sym_BSLASHcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHparencite] = ACTIONS(6598),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHParencite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHtextcite] = ACTIONS(6598),
    [anon_sym_BSLASHTextcite] = ACTIONS(6598),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHsupercite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite] = ACTIONS(6598),
    [anon_sym_BSLASHAutocite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHVolcite] = ACTIONS(6598),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHavolcite] = ACTIONS(6598),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHNotecite] = ACTIONS(6598),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHlabel] = ACTIONS(6598),
    [anon_sym_BSLASHref] = ACTIONS(6598),
    [anon_sym_BSLASHeqref] = ACTIONS(6598),
    [anon_sym_BSLASHvref] = ACTIONS(6598),
    [anon_sym_BSLASHVref] = ACTIONS(6598),
    [anon_sym_BSLASHautoref] = ACTIONS(6598),
    [anon_sym_BSLASHpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcref] = ACTIONS(6598),
    [anon_sym_BSLASHCref] = ACTIONS(6598),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnameCref] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHdef] = ACTIONS(6598),
    [anon_sym_BSLASHlet] = ACTIONS(6598),
    [anon_sym_BSLASHleft] = ACTIONS(6598),
    [anon_sym_BSLASHbigl] = ACTIONS(6598),
    [anon_sym_BSLASHBigl] = ACTIONS(6598),
    [anon_sym_BSLASHbiggl] = ACTIONS(6598),
    [anon_sym_BSLASHBiggl] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6598),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6598),
    [anon_sym_BSLASHgls] = ACTIONS(6598),
    [anon_sym_BSLASHGls] = ACTIONS(6598),
    [anon_sym_BSLASHGLS] = ACTIONS(6598),
    [anon_sym_BSLASHglspl] = ACTIONS(6598),
    [anon_sym_BSLASHGlspl] = ACTIONS(6598),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6598),
    [anon_sym_BSLASHglslink] = ACTIONS(6598),
    [anon_sym_BSLASHglstext] = ACTIONS(6598),
    [anon_sym_BSLASHGlstext] = ACTIONS(6598),
    [anon_sym_BSLASHGLStext] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6598),
    [anon_sym_BSLASHglsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsname] = ACTIONS(6598),
    [anon_sym_BSLASHGlsname] = ACTIONS(6598),
    [anon_sym_BSLASHGLSname] = ACTIONS(6598),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6598),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6598),
    [anon_sym_BSLASHacrshort] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6598),
    [anon_sym_BSLASHACRshort] = ACTIONS(6598),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrlong] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6598),
    [anon_sym_BSLASHACRlong] = ACTIONS(6598),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrfull] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6598),
    [anon_sym_BSLASHACRfull] = ACTIONS(6598),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHacs] = ACTIONS(6598),
    [anon_sym_BSLASHAcs] = ACTIONS(6598),
    [anon_sym_BSLASHacsp] = ACTIONS(6598),
    [anon_sym_BSLASHAcsp] = ACTIONS(6598),
    [anon_sym_BSLASHacl] = ACTIONS(6598),
    [anon_sym_BSLASHAcl] = ACTIONS(6598),
    [anon_sym_BSLASHaclp] = ACTIONS(6598),
    [anon_sym_BSLASHAclp] = ACTIONS(6598),
    [anon_sym_BSLASHacf] = ACTIONS(6598),
    [anon_sym_BSLASHAcf] = ACTIONS(6598),
    [anon_sym_BSLASHacfp] = ACTIONS(6598),
    [anon_sym_BSLASHAcfp] = ACTIONS(6598),
    [anon_sym_BSLASHac] = ACTIONS(6598),
    [anon_sym_BSLASHAc] = ACTIONS(6598),
    [anon_sym_BSLASHacp] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6598),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6598),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6598),
    [anon_sym_BSLASHcolor] = ACTIONS(6598),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6598),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6598),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6598),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6598),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6598),
    [anon_sym_BSLASHtext] = ACTIONS(6598),
    [anon_sym_BSLASHintertext] = ACTIONS(6598),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6598),
    [anon_sym_BSLASHurl] = ACTIONS(6598),
    [anon_sym_BSLASHhref] = ACTIONS(6598),
  },
  [1209] = {
    [sym_command_name] = ACTIONS(6590),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6590),
    [anon_sym_LBRACK] = ACTIONS(6592),
    [anon_sym_RBRACK] = ACTIONS(6592),
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(6592),
    [anon_sym_LPAREN] = ACTIONS(6592),
    [anon_sym_RPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHpart] = ACTIONS(6590),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddpart] = ACTIONS(6590),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHchapter] = ACTIONS(6590),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddchap] = ACTIONS(6590),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsection] = ACTIONS(6590),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddsec] = ACTIONS(6590),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHitem] = ACTIONS(6590),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6592),
    [anon_sym_LBRACE] = ACTIONS(6592),
    [sym_word] = ACTIONS(6590),
    [sym_placeholder] = ACTIONS(6592),
    [anon_sym_PLUS] = ACTIONS(6592),
    [anon_sym_DASH] = ACTIONS(6592),
    [anon_sym_STAR] = ACTIONS(6592),
    [anon_sym_SLASH] = ACTIONS(6592),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6592),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6592),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6592),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHbegin] = ACTIONS(6590),
    [anon_sym_BSLASHend] = ACTIONS(6590),
    [anon_sym_BSLASHtitle] = ACTIONS(6590),
    [anon_sym_BSLASHauthor] = ACTIONS(6590),
    [anon_sym_BSLASHusepackage] = ACTIONS(6590),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6590),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6590),
    [anon_sym_BSLASHinclude] = ACTIONS(6590),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6590),
    [anon_sym_BSLASHinput] = ACTIONS(6590),
    [anon_sym_BSLASHsubfile] = ACTIONS(6590),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6590),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6590),
    [anon_sym_BSLASHbibliography] = ACTIONS(6590),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6590),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6590),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6590),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6590),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6590),
    [anon_sym_BSLASHimport] = ACTIONS(6590),
    [anon_sym_BSLASHsubimport] = ACTIONS(6590),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6590),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHcaption] = ACTIONS(6590),
    [anon_sym_BSLASHcite] = ACTIONS(6590),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCite] = ACTIONS(6590),
    [anon_sym_BSLASHnocite] = ACTIONS(6590),
    [anon_sym_BSLASHcitet] = ACTIONS(6590),
    [anon_sym_BSLASHcitep] = ACTIONS(6590),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteA] = ACTIONS(6590),
    [anon_sym_BSLASHciteR] = ACTIONS(6590),
    [anon_sym_BSLASHciteS] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6590),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteyear] = ACTIONS(6590),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitedate] = ACTIONS(6590),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteurl] = ACTIONS(6590),
    [anon_sym_BSLASHfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6590),
    [anon_sym_BSLASHcitealt] = ACTIONS(6590),
    [anon_sym_BSLASHcitealp] = ACTIONS(6590),
    [anon_sym_BSLASHcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHparencite] = ACTIONS(6590),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHParencite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHtextcite] = ACTIONS(6590),
    [anon_sym_BSLASHTextcite] = ACTIONS(6590),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHsupercite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite] = ACTIONS(6590),
    [anon_sym_BSLASHAutocite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHVolcite] = ACTIONS(6590),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHavolcite] = ACTIONS(6590),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHNotecite] = ACTIONS(6590),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHlabel] = ACTIONS(6590),
    [anon_sym_BSLASHref] = ACTIONS(6590),
    [anon_sym_BSLASHeqref] = ACTIONS(6590),
    [anon_sym_BSLASHvref] = ACTIONS(6590),
    [anon_sym_BSLASHVref] = ACTIONS(6590),
    [anon_sym_BSLASHautoref] = ACTIONS(6590),
    [anon_sym_BSLASHpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcref] = ACTIONS(6590),
    [anon_sym_BSLASHCref] = ACTIONS(6590),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnameCref] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHdef] = ACTIONS(6590),
    [anon_sym_BSLASHlet] = ACTIONS(6590),
    [anon_sym_BSLASHleft] = ACTIONS(6590),
    [anon_sym_BSLASHbigl] = ACTIONS(6590),
    [anon_sym_BSLASHBigl] = ACTIONS(6590),
    [anon_sym_BSLASHbiggl] = ACTIONS(6590),
    [anon_sym_BSLASHBiggl] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6590),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6590),
    [anon_sym_BSLASHgls] = ACTIONS(6590),
    [anon_sym_BSLASHGls] = ACTIONS(6590),
    [anon_sym_BSLASHGLS] = ACTIONS(6590),
    [anon_sym_BSLASHglspl] = ACTIONS(6590),
    [anon_sym_BSLASHGlspl] = ACTIONS(6590),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6590),
    [anon_sym_BSLASHglslink] = ACTIONS(6590),
    [anon_sym_BSLASHglstext] = ACTIONS(6590),
    [anon_sym_BSLASHGlstext] = ACTIONS(6590),
    [anon_sym_BSLASHGLStext] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6590),
    [anon_sym_BSLASHglsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsname] = ACTIONS(6590),
    [anon_sym_BSLASHGlsname] = ACTIONS(6590),
    [anon_sym_BSLASHGLSname] = ACTIONS(6590),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6590),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6590),
    [anon_sym_BSLASHacrshort] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6590),
    [anon_sym_BSLASHACRshort] = ACTIONS(6590),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrlong] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6590),
    [anon_sym_BSLASHACRlong] = ACTIONS(6590),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrfull] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6590),
    [anon_sym_BSLASHACRfull] = ACTIONS(6590),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHacs] = ACTIONS(6590),
    [anon_sym_BSLASHAcs] = ACTIONS(6590),
    [anon_sym_BSLASHacsp] = ACTIONS(6590),
    [anon_sym_BSLASHAcsp] = ACTIONS(6590),
    [anon_sym_BSLASHacl] = ACTIONS(6590),
    [anon_sym_BSLASHAcl] = ACTIONS(6590),
    [anon_sym_BSLASHaclp] = ACTIONS(6590),
    [anon_sym_BSLASHAclp] = ACTIONS(6590),
    [anon_sym_BSLASHacf] = ACTIONS(6590),
    [anon_sym_BSLASHAcf] = ACTIONS(6590),
    [anon_sym_BSLASHacfp] = ACTIONS(6590),
    [anon_sym_BSLASHAcfp] = ACTIONS(6590),
    [anon_sym_BSLASHac] = ACTIONS(6590),
    [anon_sym_BSLASHAc] = ACTIONS(6590),
    [anon_sym_BSLASHacp] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6590),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6590),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6590),
    [anon_sym_BSLASHcolor] = ACTIONS(6590),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6590),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6590),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6590),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6590),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6590),
    [anon_sym_BSLASHtext] = ACTIONS(6590),
    [anon_sym_BSLASHintertext] = ACTIONS(6590),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6590),
    [anon_sym_BSLASHurl] = ACTIONS(6590),
    [anon_sym_BSLASHhref] = ACTIONS(6590),
  },
  [1210] = {
    [sym_command_name] = ACTIONS(6562),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6562),
    [anon_sym_LBRACK] = ACTIONS(6564),
    [anon_sym_RBRACK] = ACTIONS(6564),
    [anon_sym_COMMA] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6564),
    [anon_sym_RPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHpart] = ACTIONS(6562),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddpart] = ACTIONS(6562),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHchapter] = ACTIONS(6562),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddchap] = ACTIONS(6562),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsection] = ACTIONS(6562),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddsec] = ACTIONS(6562),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHitem] = ACTIONS(6562),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6564),
    [anon_sym_LBRACE] = ACTIONS(6564),
    [sym_word] = ACTIONS(6562),
    [sym_placeholder] = ACTIONS(6564),
    [anon_sym_PLUS] = ACTIONS(6564),
    [anon_sym_DASH] = ACTIONS(6564),
    [anon_sym_STAR] = ACTIONS(6564),
    [anon_sym_SLASH] = ACTIONS(6564),
    [anon_sym_LT] = ACTIONS(6562),
    [anon_sym_GT] = ACTIONS(6562),
    [anon_sym_BANG] = ACTIONS(6562),
    [anon_sym_PIPE] = ACTIONS(6562),
    [anon_sym_COLON] = ACTIONS(6562),
    [anon_sym_SQUOTE] = ACTIONS(6562),
    [anon_sym__] = ACTIONS(6564),
    [anon_sym_CARET] = ACTIONS(6564),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6564),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6564),
    [anon_sym_DOLLAR] = ACTIONS(6562),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHbegin] = ACTIONS(6562),
    [anon_sym_BSLASHend] = ACTIONS(6562),
    [anon_sym_BSLASHtitle] = ACTIONS(6562),
    [anon_sym_BSLASHauthor] = ACTIONS(6562),
    [anon_sym_BSLASHusepackage] = ACTIONS(6562),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6562),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6562),
    [anon_sym_BSLASHinclude] = ACTIONS(6562),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6562),
    [anon_sym_BSLASHinput] = ACTIONS(6562),
    [anon_sym_BSLASHsubfile] = ACTIONS(6562),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6562),
    [anon_sym_BSLASHbibliography] = ACTIONS(6562),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6562),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6562),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6562),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6562),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6562),
    [anon_sym_BSLASHimport] = ACTIONS(6562),
    [anon_sym_BSLASHsubimport] = ACTIONS(6562),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6562),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHcaption] = ACTIONS(6562),
    [anon_sym_BSLASHcite] = ACTIONS(6562),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCite] = ACTIONS(6562),
    [anon_sym_BSLASHnocite] = ACTIONS(6562),
    [anon_sym_BSLASHcitet] = ACTIONS(6562),
    [anon_sym_BSLASHcitep] = ACTIONS(6562),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteA] = ACTIONS(6562),
    [anon_sym_BSLASHciteR] = ACTIONS(6562),
    [anon_sym_BSLASHciteS] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6562),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteyear] = ACTIONS(6562),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitedate] = ACTIONS(6562),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteurl] = ACTIONS(6562),
    [anon_sym_BSLASHfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6562),
    [anon_sym_BSLASHcitealt] = ACTIONS(6562),
    [anon_sym_BSLASHcitealp] = ACTIONS(6562),
    [anon_sym_BSLASHcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHparencite] = ACTIONS(6562),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHParencite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHtextcite] = ACTIONS(6562),
    [anon_sym_BSLASHTextcite] = ACTIONS(6562),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHsupercite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite] = ACTIONS(6562),
    [anon_sym_BSLASHAutocite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHVolcite] = ACTIONS(6562),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHavolcite] = ACTIONS(6562),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHNotecite] = ACTIONS(6562),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHlabel] = ACTIONS(6562),
    [anon_sym_BSLASHref] = ACTIONS(6562),
    [anon_sym_BSLASHeqref] = ACTIONS(6562),
    [anon_sym_BSLASHvref] = ACTIONS(6562),
    [anon_sym_BSLASHVref] = ACTIONS(6562),
    [anon_sym_BSLASHautoref] = ACTIONS(6562),
    [anon_sym_BSLASHpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcref] = ACTIONS(6562),
    [anon_sym_BSLASHCref] = ACTIONS(6562),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnameCref] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHdef] = ACTIONS(6562),
    [anon_sym_BSLASHlet] = ACTIONS(6562),
    [anon_sym_BSLASHleft] = ACTIONS(6562),
    [anon_sym_BSLASHbigl] = ACTIONS(6562),
    [anon_sym_BSLASHBigl] = ACTIONS(6562),
    [anon_sym_BSLASHbiggl] = ACTIONS(6562),
    [anon_sym_BSLASHBiggl] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6562),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6562),
    [anon_sym_BSLASHgls] = ACTIONS(6562),
    [anon_sym_BSLASHGls] = ACTIONS(6562),
    [anon_sym_BSLASHGLS] = ACTIONS(6562),
    [anon_sym_BSLASHglspl] = ACTIONS(6562),
    [anon_sym_BSLASHGlspl] = ACTIONS(6562),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6562),
    [anon_sym_BSLASHglslink] = ACTIONS(6562),
    [anon_sym_BSLASHglstext] = ACTIONS(6562),
    [anon_sym_BSLASHGlstext] = ACTIONS(6562),
    [anon_sym_BSLASHGLStext] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6562),
    [anon_sym_BSLASHglsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsname] = ACTIONS(6562),
    [anon_sym_BSLASHGlsname] = ACTIONS(6562),
    [anon_sym_BSLASHGLSname] = ACTIONS(6562),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6562),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6562),
    [anon_sym_BSLASHacrshort] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6562),
    [anon_sym_BSLASHACRshort] = ACTIONS(6562),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrlong] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6562),
    [anon_sym_BSLASHACRlong] = ACTIONS(6562),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrfull] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6562),
    [anon_sym_BSLASHACRfull] = ACTIONS(6562),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHacs] = ACTIONS(6562),
    [anon_sym_BSLASHAcs] = ACTIONS(6562),
    [anon_sym_BSLASHacsp] = ACTIONS(6562),
    [anon_sym_BSLASHAcsp] = ACTIONS(6562),
    [anon_sym_BSLASHacl] = ACTIONS(6562),
    [anon_sym_BSLASHAcl] = ACTIONS(6562),
    [anon_sym_BSLASHaclp] = ACTIONS(6562),
    [anon_sym_BSLASHAclp] = ACTIONS(6562),
    [anon_sym_BSLASHacf] = ACTIONS(6562),
    [anon_sym_BSLASHAcf] = ACTIONS(6562),
    [anon_sym_BSLASHacfp] = ACTIONS(6562),
    [anon_sym_BSLASHAcfp] = ACTIONS(6562),
    [anon_sym_BSLASHac] = ACTIONS(6562),
    [anon_sym_BSLASHAc] = ACTIONS(6562),
    [anon_sym_BSLASHacp] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6562),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6562),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6562),
    [anon_sym_BSLASHcolor] = ACTIONS(6562),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6562),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6562),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6562),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6562),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6562),
    [anon_sym_BSLASHtext] = ACTIONS(6562),
    [anon_sym_BSLASHintertext] = ACTIONS(6562),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6562),
    [anon_sym_BSLASHurl] = ACTIONS(6562),
    [anon_sym_BSLASHhref] = ACTIONS(6562),
  },
  [1211] = {
    [sym_command_name] = ACTIONS(6670),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6670),
    [anon_sym_LBRACK] = ACTIONS(6672),
    [anon_sym_RBRACK] = ACTIONS(6672),
    [anon_sym_COMMA] = ACTIONS(6672),
    [anon_sym_EQ] = ACTIONS(6672),
    [anon_sym_LPAREN] = ACTIONS(6672),
    [anon_sym_RPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHpart] = ACTIONS(6670),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddpart] = ACTIONS(6670),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHchapter] = ACTIONS(6670),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddchap] = ACTIONS(6670),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsection] = ACTIONS(6670),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddsec] = ACTIONS(6670),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHitem] = ACTIONS(6670),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6672),
    [anon_sym_LBRACE] = ACTIONS(6672),
    [sym_word] = ACTIONS(6670),
    [sym_placeholder] = ACTIONS(6672),
    [anon_sym_PLUS] = ACTIONS(6672),
    [anon_sym_DASH] = ACTIONS(6672),
    [anon_sym_STAR] = ACTIONS(6672),
    [anon_sym_SLASH] = ACTIONS(6672),
    [anon_sym_LT] = ACTIONS(6670),
    [anon_sym_GT] = ACTIONS(6670),
    [anon_sym_BANG] = ACTIONS(6670),
    [anon_sym_PIPE] = ACTIONS(6670),
    [anon_sym_COLON] = ACTIONS(6670),
    [anon_sym_SQUOTE] = ACTIONS(6670),
    [anon_sym__] = ACTIONS(6672),
    [anon_sym_CARET] = ACTIONS(6672),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6672),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6672),
    [anon_sym_DOLLAR] = ACTIONS(6670),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHbegin] = ACTIONS(6670),
    [anon_sym_BSLASHend] = ACTIONS(6670),
    [anon_sym_BSLASHtitle] = ACTIONS(6670),
    [anon_sym_BSLASHauthor] = ACTIONS(6670),
    [anon_sym_BSLASHusepackage] = ACTIONS(6670),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6670),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6670),
    [anon_sym_BSLASHinclude] = ACTIONS(6670),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6670),
    [anon_sym_BSLASHinput] = ACTIONS(6670),
    [anon_sym_BSLASHsubfile] = ACTIONS(6670),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6670),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6670),
    [anon_sym_BSLASHbibliography] = ACTIONS(6670),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6670),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6670),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6670),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6670),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6670),
    [anon_sym_BSLASHimport] = ACTIONS(6670),
    [anon_sym_BSLASHsubimport] = ACTIONS(6670),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6670),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHcaption] = ACTIONS(6670),
    [anon_sym_BSLASHcite] = ACTIONS(6670),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCite] = ACTIONS(6670),
    [anon_sym_BSLASHnocite] = ACTIONS(6670),
    [anon_sym_BSLASHcitet] = ACTIONS(6670),
    [anon_sym_BSLASHcitep] = ACTIONS(6670),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteA] = ACTIONS(6670),
    [anon_sym_BSLASHciteR] = ACTIONS(6670),
    [anon_sym_BSLASHciteS] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6670),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteyear] = ACTIONS(6670),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitedate] = ACTIONS(6670),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteurl] = ACTIONS(6670),
    [anon_sym_BSLASHfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6670),
    [anon_sym_BSLASHcitealt] = ACTIONS(6670),
    [anon_sym_BSLASHcitealp] = ACTIONS(6670),
    [anon_sym_BSLASHcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHparencite] = ACTIONS(6670),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHParencite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHtextcite] = ACTIONS(6670),
    [anon_sym_BSLASHTextcite] = ACTIONS(6670),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHsupercite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite] = ACTIONS(6670),
    [anon_sym_BSLASHAutocite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHVolcite] = ACTIONS(6670),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHavolcite] = ACTIONS(6670),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHNotecite] = ACTIONS(6670),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHlabel] = ACTIONS(6670),
    [anon_sym_BSLASHref] = ACTIONS(6670),
    [anon_sym_BSLASHeqref] = ACTIONS(6670),
    [anon_sym_BSLASHvref] = ACTIONS(6670),
    [anon_sym_BSLASHVref] = ACTIONS(6670),
    [anon_sym_BSLASHautoref] = ACTIONS(6670),
    [anon_sym_BSLASHpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcref] = ACTIONS(6670),
    [anon_sym_BSLASHCref] = ACTIONS(6670),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnameCref] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHdef] = ACTIONS(6670),
    [anon_sym_BSLASHlet] = ACTIONS(6670),
    [anon_sym_BSLASHleft] = ACTIONS(6670),
    [anon_sym_BSLASHbigl] = ACTIONS(6670),
    [anon_sym_BSLASHBigl] = ACTIONS(6670),
    [anon_sym_BSLASHbiggl] = ACTIONS(6670),
    [anon_sym_BSLASHBiggl] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6670),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6670),
    [anon_sym_BSLASHgls] = ACTIONS(6670),
    [anon_sym_BSLASHGls] = ACTIONS(6670),
    [anon_sym_BSLASHGLS] = ACTIONS(6670),
    [anon_sym_BSLASHglspl] = ACTIONS(6670),
    [anon_sym_BSLASHGlspl] = ACTIONS(6670),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6670),
    [anon_sym_BSLASHglslink] = ACTIONS(6670),
    [anon_sym_BSLASHglstext] = ACTIONS(6670),
    [anon_sym_BSLASHGlstext] = ACTIONS(6670),
    [anon_sym_BSLASHGLStext] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6670),
    [anon_sym_BSLASHglsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsname] = ACTIONS(6670),
    [anon_sym_BSLASHGlsname] = ACTIONS(6670),
    [anon_sym_BSLASHGLSname] = ACTIONS(6670),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6670),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6670),
    [anon_sym_BSLASHacrshort] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6670),
    [anon_sym_BSLASHACRshort] = ACTIONS(6670),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrlong] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6670),
    [anon_sym_BSLASHACRlong] = ACTIONS(6670),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrfull] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6670),
    [anon_sym_BSLASHACRfull] = ACTIONS(6670),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHacs] = ACTIONS(6670),
    [anon_sym_BSLASHAcs] = ACTIONS(6670),
    [anon_sym_BSLASHacsp] = ACTIONS(6670),
    [anon_sym_BSLASHAcsp] = ACTIONS(6670),
    [anon_sym_BSLASHacl] = ACTIONS(6670),
    [anon_sym_BSLASHAcl] = ACTIONS(6670),
    [anon_sym_BSLASHaclp] = ACTIONS(6670),
    [anon_sym_BSLASHAclp] = ACTIONS(6670),
    [anon_sym_BSLASHacf] = ACTIONS(6670),
    [anon_sym_BSLASHAcf] = ACTIONS(6670),
    [anon_sym_BSLASHacfp] = ACTIONS(6670),
    [anon_sym_BSLASHAcfp] = ACTIONS(6670),
    [anon_sym_BSLASHac] = ACTIONS(6670),
    [anon_sym_BSLASHAc] = ACTIONS(6670),
    [anon_sym_BSLASHacp] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6670),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6670),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6670),
    [anon_sym_BSLASHcolor] = ACTIONS(6670),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6670),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6670),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6670),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6670),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6670),
    [anon_sym_BSLASHtext] = ACTIONS(6670),
    [anon_sym_BSLASHintertext] = ACTIONS(6670),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6670),
    [anon_sym_BSLASHurl] = ACTIONS(6670),
    [anon_sym_BSLASHhref] = ACTIONS(6670),
  },
  [1212] = {
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_LBRACK] = ACTIONS(6488),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_COMMA] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6488),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHpart] = ACTIONS(6486),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddpart] = ACTIONS(6486),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHchapter] = ACTIONS(6486),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddchap] = ACTIONS(6486),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsection] = ACTIONS(6486),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddsec] = ACTIONS(6486),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHitem] = ACTIONS(6486),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6488),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(6486),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHbegin] = ACTIONS(6486),
    [anon_sym_BSLASHend] = ACTIONS(6486),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHleft] = ACTIONS(6486),
    [anon_sym_BSLASHbigl] = ACTIONS(6486),
    [anon_sym_BSLASHBigl] = ACTIONS(6486),
    [anon_sym_BSLASHbiggl] = ACTIONS(6486),
    [anon_sym_BSLASHBiggl] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHtext] = ACTIONS(6486),
    [anon_sym_BSLASHintertext] = ACTIONS(6486),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [1213] = {
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6484),
    [anon_sym_RBRACK] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6484),
    [anon_sym_EQ] = ACTIONS(6484),
    [anon_sym_LPAREN] = ACTIONS(6484),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHpart] = ACTIONS(6482),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddpart] = ACTIONS(6482),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHchapter] = ACTIONS(6482),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddchap] = ACTIONS(6482),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsection] = ACTIONS(6482),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddsec] = ACTIONS(6482),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHitem] = ACTIONS(6482),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6484),
    [anon_sym_LBRACE] = ACTIONS(6484),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6484),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6484),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHbegin] = ACTIONS(6482),
    [anon_sym_BSLASHend] = ACTIONS(6482),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHleft] = ACTIONS(6482),
    [anon_sym_BSLASHbigl] = ACTIONS(6482),
    [anon_sym_BSLASHBigl] = ACTIONS(6482),
    [anon_sym_BSLASHbiggl] = ACTIONS(6482),
    [anon_sym_BSLASHBiggl] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHtext] = ACTIONS(6482),
    [anon_sym_BSLASHintertext] = ACTIONS(6482),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [1214] = {
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6480),
    [anon_sym_EQ] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6480),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHpart] = ACTIONS(6478),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddpart] = ACTIONS(6478),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHchapter] = ACTIONS(6478),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddchap] = ACTIONS(6478),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsection] = ACTIONS(6478),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddsec] = ACTIONS(6478),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHitem] = ACTIONS(6478),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6480),
    [anon_sym_DOLLAR] = ACTIONS(6478),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHbegin] = ACTIONS(6478),
    [anon_sym_BSLASHend] = ACTIONS(6478),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHleft] = ACTIONS(6478),
    [anon_sym_BSLASHbigl] = ACTIONS(6478),
    [anon_sym_BSLASHBigl] = ACTIONS(6478),
    [anon_sym_BSLASHbiggl] = ACTIONS(6478),
    [anon_sym_BSLASHBiggl] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHtext] = ACTIONS(6478),
    [anon_sym_BSLASHintertext] = ACTIONS(6478),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [1215] = {
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_LBRACK] = ACTIONS(6476),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_RPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHpart] = ACTIONS(6474),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddpart] = ACTIONS(6474),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHchapter] = ACTIONS(6474),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddchap] = ACTIONS(6474),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsection] = ACTIONS(6474),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddsec] = ACTIONS(6474),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHitem] = ACTIONS(6474),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6476),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6476),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHbegin] = ACTIONS(6474),
    [anon_sym_BSLASHend] = ACTIONS(6474),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHleft] = ACTIONS(6474),
    [anon_sym_BSLASHbigl] = ACTIONS(6474),
    [anon_sym_BSLASHBigl] = ACTIONS(6474),
    [anon_sym_BSLASHbiggl] = ACTIONS(6474),
    [anon_sym_BSLASHBiggl] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHtext] = ACTIONS(6474),
    [anon_sym_BSLASHintertext] = ACTIONS(6474),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [1216] = {
    [sym_command_name] = ACTIONS(6594),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6596),
    [anon_sym_LPAREN] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHpart] = ACTIONS(6594),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddpart] = ACTIONS(6594),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHchapter] = ACTIONS(6594),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddchap] = ACTIONS(6594),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsection] = ACTIONS(6594),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddsec] = ACTIONS(6594),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHitem] = ACTIONS(6594),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6596),
    [anon_sym_LBRACE] = ACTIONS(6596),
    [sym_word] = ACTIONS(6594),
    [sym_placeholder] = ACTIONS(6596),
    [anon_sym_PLUS] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6596),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_SLASH] = ACTIONS(6596),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_BANG] = ACTIONS(6594),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SQUOTE] = ACTIONS(6594),
    [anon_sym__] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(6596),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6596),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(6594),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHbegin] = ACTIONS(6594),
    [anon_sym_BSLASHend] = ACTIONS(6594),
    [anon_sym_BSLASHtitle] = ACTIONS(6594),
    [anon_sym_BSLASHauthor] = ACTIONS(6594),
    [anon_sym_BSLASHusepackage] = ACTIONS(6594),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6594),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6594),
    [anon_sym_BSLASHinclude] = ACTIONS(6594),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6594),
    [anon_sym_BSLASHinput] = ACTIONS(6594),
    [anon_sym_BSLASHsubfile] = ACTIONS(6594),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6594),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6594),
    [anon_sym_BSLASHbibliography] = ACTIONS(6594),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6594),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6594),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6594),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6594),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6594),
    [anon_sym_BSLASHimport] = ACTIONS(6594),
    [anon_sym_BSLASHsubimport] = ACTIONS(6594),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6594),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHcaption] = ACTIONS(6594),
    [anon_sym_BSLASHcite] = ACTIONS(6594),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCite] = ACTIONS(6594),
    [anon_sym_BSLASHnocite] = ACTIONS(6594),
    [anon_sym_BSLASHcitet] = ACTIONS(6594),
    [anon_sym_BSLASHcitep] = ACTIONS(6594),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteA] = ACTIONS(6594),
    [anon_sym_BSLASHciteR] = ACTIONS(6594),
    [anon_sym_BSLASHciteS] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6594),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteyear] = ACTIONS(6594),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitedate] = ACTIONS(6594),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteurl] = ACTIONS(6594),
    [anon_sym_BSLASHfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6594),
    [anon_sym_BSLASHcitealt] = ACTIONS(6594),
    [anon_sym_BSLASHcitealp] = ACTIONS(6594),
    [anon_sym_BSLASHcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHparencite] = ACTIONS(6594),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHParencite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHtextcite] = ACTIONS(6594),
    [anon_sym_BSLASHTextcite] = ACTIONS(6594),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHsupercite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite] = ACTIONS(6594),
    [anon_sym_BSLASHAutocite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHVolcite] = ACTIONS(6594),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHavolcite] = ACTIONS(6594),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHNotecite] = ACTIONS(6594),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHlabel] = ACTIONS(6594),
    [anon_sym_BSLASHref] = ACTIONS(6594),
    [anon_sym_BSLASHeqref] = ACTIONS(6594),
    [anon_sym_BSLASHvref] = ACTIONS(6594),
    [anon_sym_BSLASHVref] = ACTIONS(6594),
    [anon_sym_BSLASHautoref] = ACTIONS(6594),
    [anon_sym_BSLASHpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcref] = ACTIONS(6594),
    [anon_sym_BSLASHCref] = ACTIONS(6594),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnameCref] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHdef] = ACTIONS(6594),
    [anon_sym_BSLASHlet] = ACTIONS(6594),
    [anon_sym_BSLASHleft] = ACTIONS(6594),
    [anon_sym_BSLASHbigl] = ACTIONS(6594),
    [anon_sym_BSLASHBigl] = ACTIONS(6594),
    [anon_sym_BSLASHbiggl] = ACTIONS(6594),
    [anon_sym_BSLASHBiggl] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6594),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6594),
    [anon_sym_BSLASHgls] = ACTIONS(6594),
    [anon_sym_BSLASHGls] = ACTIONS(6594),
    [anon_sym_BSLASHGLS] = ACTIONS(6594),
    [anon_sym_BSLASHglspl] = ACTIONS(6594),
    [anon_sym_BSLASHGlspl] = ACTIONS(6594),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6594),
    [anon_sym_BSLASHglslink] = ACTIONS(6594),
    [anon_sym_BSLASHglstext] = ACTIONS(6594),
    [anon_sym_BSLASHGlstext] = ACTIONS(6594),
    [anon_sym_BSLASHGLStext] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6594),
    [anon_sym_BSLASHglsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsname] = ACTIONS(6594),
    [anon_sym_BSLASHGlsname] = ACTIONS(6594),
    [anon_sym_BSLASHGLSname] = ACTIONS(6594),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6594),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6594),
    [anon_sym_BSLASHacrshort] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6594),
    [anon_sym_BSLASHACRshort] = ACTIONS(6594),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrlong] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6594),
    [anon_sym_BSLASHACRlong] = ACTIONS(6594),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrfull] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6594),
    [anon_sym_BSLASHACRfull] = ACTIONS(6594),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHacs] = ACTIONS(6594),
    [anon_sym_BSLASHAcs] = ACTIONS(6594),
    [anon_sym_BSLASHacsp] = ACTIONS(6594),
    [anon_sym_BSLASHAcsp] = ACTIONS(6594),
    [anon_sym_BSLASHacl] = ACTIONS(6594),
    [anon_sym_BSLASHAcl] = ACTIONS(6594),
    [anon_sym_BSLASHaclp] = ACTIONS(6594),
    [anon_sym_BSLASHAclp] = ACTIONS(6594),
    [anon_sym_BSLASHacf] = ACTIONS(6594),
    [anon_sym_BSLASHAcf] = ACTIONS(6594),
    [anon_sym_BSLASHacfp] = ACTIONS(6594),
    [anon_sym_BSLASHAcfp] = ACTIONS(6594),
    [anon_sym_BSLASHac] = ACTIONS(6594),
    [anon_sym_BSLASHAc] = ACTIONS(6594),
    [anon_sym_BSLASHacp] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6594),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6594),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6594),
    [anon_sym_BSLASHcolor] = ACTIONS(6594),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6594),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6594),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6594),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6594),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6594),
    [anon_sym_BSLASHtext] = ACTIONS(6594),
    [anon_sym_BSLASHintertext] = ACTIONS(6594),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6594),
    [anon_sym_BSLASHurl] = ACTIONS(6594),
    [anon_sym_BSLASHhref] = ACTIONS(6594),
  },
  [1217] = {
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6276),
    [anon_sym_RBRACK] = ACTIONS(6276),
    [anon_sym_COMMA] = ACTIONS(6276),
    [anon_sym_EQ] = ACTIONS(6276),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHpart] = ACTIONS(6274),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddpart] = ACTIONS(6274),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHchapter] = ACTIONS(6274),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddchap] = ACTIONS(6274),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsection] = ACTIONS(6274),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddsec] = ACTIONS(6274),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHitem] = ACTIONS(6274),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6276),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6276),
    [anon_sym_DOLLAR] = ACTIONS(6274),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6276),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHbegin] = ACTIONS(6274),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHleft] = ACTIONS(6274),
    [anon_sym_BSLASHbigl] = ACTIONS(6274),
    [anon_sym_BSLASHBigl] = ACTIONS(6274),
    [anon_sym_BSLASHbiggl] = ACTIONS(6274),
    [anon_sym_BSLASHBiggl] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHtext] = ACTIONS(6274),
    [anon_sym_BSLASHintertext] = ACTIONS(6274),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [1218] = {
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_LBRACK] = ACTIONS(6468),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_COMMA] = ACTIONS(6468),
    [anon_sym_EQ] = ACTIONS(6468),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHpart] = ACTIONS(6466),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddpart] = ACTIONS(6466),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHchapter] = ACTIONS(6466),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddchap] = ACTIONS(6466),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsection] = ACTIONS(6466),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddsec] = ACTIONS(6466),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHitem] = ACTIONS(6466),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6468),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6466),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHbegin] = ACTIONS(6466),
    [anon_sym_BSLASHend] = ACTIONS(6466),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHleft] = ACTIONS(6466),
    [anon_sym_BSLASHbigl] = ACTIONS(6466),
    [anon_sym_BSLASHBigl] = ACTIONS(6466),
    [anon_sym_BSLASHbiggl] = ACTIONS(6466),
    [anon_sym_BSLASHBiggl] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHtext] = ACTIONS(6466),
    [anon_sym_BSLASHintertext] = ACTIONS(6466),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [1219] = {
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_LPAREN] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHpart] = ACTIONS(6174),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddpart] = ACTIONS(6174),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHchapter] = ACTIONS(6174),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddchap] = ACTIONS(6174),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsection] = ACTIONS(6174),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddsec] = ACTIONS(6174),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHitem] = ACTIONS(6174),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6176),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6176),
    [anon_sym_DOLLAR] = ACTIONS(6174),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6176),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHbegin] = ACTIONS(6174),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHleft] = ACTIONS(6174),
    [anon_sym_BSLASHbigl] = ACTIONS(6174),
    [anon_sym_BSLASHBigl] = ACTIONS(6174),
    [anon_sym_BSLASHbiggl] = ACTIONS(6174),
    [anon_sym_BSLASHBiggl] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHtext] = ACTIONS(6174),
    [anon_sym_BSLASHintertext] = ACTIONS(6174),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [1220] = {
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6464),
    [anon_sym_RBRACK] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_EQ] = ACTIONS(6464),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHpart] = ACTIONS(6462),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddpart] = ACTIONS(6462),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHchapter] = ACTIONS(6462),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddchap] = ACTIONS(6462),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsection] = ACTIONS(6462),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddsec] = ACTIONS(6462),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHitem] = ACTIONS(6462),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6464),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(6462),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHbegin] = ACTIONS(6462),
    [anon_sym_BSLASHend] = ACTIONS(6462),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHleft] = ACTIONS(6462),
    [anon_sym_BSLASHbigl] = ACTIONS(6462),
    [anon_sym_BSLASHBigl] = ACTIONS(6462),
    [anon_sym_BSLASHbiggl] = ACTIONS(6462),
    [anon_sym_BSLASHBiggl] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHtext] = ACTIONS(6462),
    [anon_sym_BSLASHintertext] = ACTIONS(6462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [1221] = {
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6460),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_COMMA] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_LPAREN] = ACTIONS(6460),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHpart] = ACTIONS(6458),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddpart] = ACTIONS(6458),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHchapter] = ACTIONS(6458),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddchap] = ACTIONS(6458),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsection] = ACTIONS(6458),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddsec] = ACTIONS(6458),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHitem] = ACTIONS(6458),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6460),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6460),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6460),
    [anon_sym_DOLLAR] = ACTIONS(6458),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHbegin] = ACTIONS(6458),
    [anon_sym_BSLASHend] = ACTIONS(6458),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHleft] = ACTIONS(6458),
    [anon_sym_BSLASHbigl] = ACTIONS(6458),
    [anon_sym_BSLASHBigl] = ACTIONS(6458),
    [anon_sym_BSLASHbiggl] = ACTIONS(6458),
    [anon_sym_BSLASHBiggl] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHtext] = ACTIONS(6458),
    [anon_sym_BSLASHintertext] = ACTIONS(6458),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [1222] = {
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_RBRACK] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LPAREN] = ACTIONS(6372),
    [anon_sym_RPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHpart] = ACTIONS(6370),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddpart] = ACTIONS(6370),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHchapter] = ACTIONS(6370),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddchap] = ACTIONS(6370),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsection] = ACTIONS(6370),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddsec] = ACTIONS(6370),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHitem] = ACTIONS(6370),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6372),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6370),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHbegin] = ACTIONS(6370),
    [anon_sym_BSLASHend] = ACTIONS(6370),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHleft] = ACTIONS(6370),
    [anon_sym_BSLASHbigl] = ACTIONS(6370),
    [anon_sym_BSLASHBigl] = ACTIONS(6370),
    [anon_sym_BSLASHbiggl] = ACTIONS(6370),
    [anon_sym_BSLASHBiggl] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHtext] = ACTIONS(6370),
    [anon_sym_BSLASHintertext] = ACTIONS(6370),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [1223] = {
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_RBRACK] = ACTIONS(6368),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_LPAREN] = ACTIONS(6368),
    [anon_sym_RPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHpart] = ACTIONS(6366),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddpart] = ACTIONS(6366),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHchapter] = ACTIONS(6366),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddchap] = ACTIONS(6366),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsection] = ACTIONS(6366),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddsec] = ACTIONS(6366),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHitem] = ACTIONS(6366),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6368),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6368),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6366),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHbegin] = ACTIONS(6366),
    [anon_sym_BSLASHend] = ACTIONS(6366),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHleft] = ACTIONS(6366),
    [anon_sym_BSLASHbigl] = ACTIONS(6366),
    [anon_sym_BSLASHBigl] = ACTIONS(6366),
    [anon_sym_BSLASHbiggl] = ACTIONS(6366),
    [anon_sym_BSLASHBiggl] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHtext] = ACTIONS(6366),
    [anon_sym_BSLASHintertext] = ACTIONS(6366),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [1224] = {
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_RBRACK] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LPAREN] = ACTIONS(6360),
    [anon_sym_RPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHpart] = ACTIONS(6358),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddpart] = ACTIONS(6358),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHchapter] = ACTIONS(6358),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddchap] = ACTIONS(6358),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsection] = ACTIONS(6358),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddsec] = ACTIONS(6358),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHitem] = ACTIONS(6358),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(6360),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6360),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6358),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHbegin] = ACTIONS(6358),
    [anon_sym_BSLASHend] = ACTIONS(6358),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHleft] = ACTIONS(6358),
    [anon_sym_BSLASHbigl] = ACTIONS(6358),
    [anon_sym_BSLASHBigl] = ACTIONS(6358),
    [anon_sym_BSLASHbiggl] = ACTIONS(6358),
    [anon_sym_BSLASHBiggl] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHtext] = ACTIONS(6358),
    [anon_sym_BSLASHintertext] = ACTIONS(6358),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [1225] = {
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_RPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHpart] = ACTIONS(6342),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddpart] = ACTIONS(6342),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHchapter] = ACTIONS(6342),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddchap] = ACTIONS(6342),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsection] = ACTIONS(6342),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddsec] = ACTIONS(6342),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHitem] = ACTIONS(6342),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6344),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6344),
    [anon_sym_DOLLAR] = ACTIONS(6342),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHbegin] = ACTIONS(6342),
    [anon_sym_BSLASHend] = ACTIONS(6342),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHleft] = ACTIONS(6342),
    [anon_sym_BSLASHbigl] = ACTIONS(6342),
    [anon_sym_BSLASHBigl] = ACTIONS(6342),
    [anon_sym_BSLASHbiggl] = ACTIONS(6342),
    [anon_sym_BSLASHBiggl] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHtext] = ACTIONS(6342),
    [anon_sym_BSLASHintertext] = ACTIONS(6342),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [1226] = {
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_RBRACK] = ACTIONS(6340),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_EQ] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHpart] = ACTIONS(6338),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddpart] = ACTIONS(6338),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHchapter] = ACTIONS(6338),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddchap] = ACTIONS(6338),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsection] = ACTIONS(6338),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddsec] = ACTIONS(6338),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHitem] = ACTIONS(6338),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6340),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6340),
    [anon_sym_DOLLAR] = ACTIONS(6338),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHbegin] = ACTIONS(6338),
    [anon_sym_BSLASHend] = ACTIONS(6338),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHleft] = ACTIONS(6338),
    [anon_sym_BSLASHbigl] = ACTIONS(6338),
    [anon_sym_BSLASHBigl] = ACTIONS(6338),
    [anon_sym_BSLASHbiggl] = ACTIONS(6338),
    [anon_sym_BSLASHBiggl] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHtext] = ACTIONS(6338),
    [anon_sym_BSLASHintertext] = ACTIONS(6338),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [1227] = {
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6308),
    [anon_sym_RBRACK] = ACTIONS(6308),
    [anon_sym_COMMA] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(6308),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_RPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHpart] = ACTIONS(6306),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddpart] = ACTIONS(6306),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHchapter] = ACTIONS(6306),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddchap] = ACTIONS(6306),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsection] = ACTIONS(6306),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddsec] = ACTIONS(6306),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHitem] = ACTIONS(6306),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6308),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6308),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6308),
    [anon_sym_DOLLAR] = ACTIONS(6306),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHbegin] = ACTIONS(6306),
    [anon_sym_BSLASHend] = ACTIONS(6306),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHleft] = ACTIONS(6306),
    [anon_sym_BSLASHbigl] = ACTIONS(6306),
    [anon_sym_BSLASHBigl] = ACTIONS(6306),
    [anon_sym_BSLASHbiggl] = ACTIONS(6306),
    [anon_sym_BSLASHBiggl] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHtext] = ACTIONS(6306),
    [anon_sym_BSLASHintertext] = ACTIONS(6306),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [1228] = {
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_LPAREN] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHpart] = ACTIONS(6302),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddpart] = ACTIONS(6302),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHchapter] = ACTIONS(6302),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddchap] = ACTIONS(6302),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsection] = ACTIONS(6302),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddsec] = ACTIONS(6302),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHitem] = ACTIONS(6302),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6304),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6304),
    [anon_sym_DOLLAR] = ACTIONS(6302),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHbegin] = ACTIONS(6302),
    [anon_sym_BSLASHend] = ACTIONS(6302),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHleft] = ACTIONS(6302),
    [anon_sym_BSLASHbigl] = ACTIONS(6302),
    [anon_sym_BSLASHBigl] = ACTIONS(6302),
    [anon_sym_BSLASHbiggl] = ACTIONS(6302),
    [anon_sym_BSLASHBiggl] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHtext] = ACTIONS(6302),
    [anon_sym_BSLASHintertext] = ACTIONS(6302),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [1229] = {
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHpart] = ACTIONS(6298),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddpart] = ACTIONS(6298),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHchapter] = ACTIONS(6298),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddchap] = ACTIONS(6298),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsection] = ACTIONS(6298),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddsec] = ACTIONS(6298),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHitem] = ACTIONS(6298),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6300),
    [anon_sym_DOLLAR] = ACTIONS(6298),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHbegin] = ACTIONS(6298),
    [anon_sym_BSLASHend] = ACTIONS(6298),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHleft] = ACTIONS(6298),
    [anon_sym_BSLASHbigl] = ACTIONS(6298),
    [anon_sym_BSLASHBigl] = ACTIONS(6298),
    [anon_sym_BSLASHbiggl] = ACTIONS(6298),
    [anon_sym_BSLASHBiggl] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHtext] = ACTIONS(6298),
    [anon_sym_BSLASHintertext] = ACTIONS(6298),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [1230] = {
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_LBRACK] = ACTIONS(6508),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [anon_sym_COMMA] = ACTIONS(6508),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_RPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHpart] = ACTIONS(6506),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddpart] = ACTIONS(6506),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHchapter] = ACTIONS(6506),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddchap] = ACTIONS(6506),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsection] = ACTIONS(6506),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHaddsec] = ACTIONS(6506),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6506),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6506),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHitem] = ACTIONS(6506),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6508),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6508),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(6506),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHbegin] = ACTIONS(6506),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHleft] = ACTIONS(6506),
    [anon_sym_BSLASHbigl] = ACTIONS(6506),
    [anon_sym_BSLASHBigl] = ACTIONS(6506),
    [anon_sym_BSLASHbiggl] = ACTIONS(6506),
    [anon_sym_BSLASHBiggl] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHtext] = ACTIONS(6506),
    [anon_sym_BSLASHintertext] = ACTIONS(6506),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [1231] = {
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_RBRACK] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6184),
    [anon_sym_EQ] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_RPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHpart] = ACTIONS(6182),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddpart] = ACTIONS(6182),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHchapter] = ACTIONS(6182),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddchap] = ACTIONS(6182),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsection] = ACTIONS(6182),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddsec] = ACTIONS(6182),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHitem] = ACTIONS(6182),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6184),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6184),
    [anon_sym_DOLLAR] = ACTIONS(6182),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6184),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHbegin] = ACTIONS(6182),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHleft] = ACTIONS(6182),
    [anon_sym_BSLASHbigl] = ACTIONS(6182),
    [anon_sym_BSLASHBigl] = ACTIONS(6182),
    [anon_sym_BSLASHbiggl] = ACTIONS(6182),
    [anon_sym_BSLASHBiggl] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHtext] = ACTIONS(6182),
    [anon_sym_BSLASHintertext] = ACTIONS(6182),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [1232] = {
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_RBRACK] = ACTIONS(6192),
    [anon_sym_COMMA] = ACTIONS(6192),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_RPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHpart] = ACTIONS(6190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddpart] = ACTIONS(6190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHchapter] = ACTIONS(6190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddchap] = ACTIONS(6190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsection] = ACTIONS(6190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddsec] = ACTIONS(6190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHitem] = ACTIONS(6190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6192),
    [anon_sym_DOLLAR] = ACTIONS(6190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6192),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHbegin] = ACTIONS(6190),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHleft] = ACTIONS(6190),
    [anon_sym_BSLASHbigl] = ACTIONS(6190),
    [anon_sym_BSLASHBigl] = ACTIONS(6190),
    [anon_sym_BSLASHbiggl] = ACTIONS(6190),
    [anon_sym_BSLASHBiggl] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHtext] = ACTIONS(6190),
    [anon_sym_BSLASHintertext] = ACTIONS(6190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [1233] = {
    [sym_command_name] = ACTIONS(6646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6646),
    [anon_sym_LBRACK] = ACTIONS(6648),
    [anon_sym_RBRACK] = ACTIONS(6648),
    [anon_sym_COMMA] = ACTIONS(6648),
    [anon_sym_EQ] = ACTIONS(6648),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [anon_sym_RPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHpart] = ACTIONS(6646),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddpart] = ACTIONS(6646),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHchapter] = ACTIONS(6646),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddchap] = ACTIONS(6646),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsection] = ACTIONS(6646),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddsec] = ACTIONS(6646),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHitem] = ACTIONS(6646),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6648),
    [anon_sym_LBRACE] = ACTIONS(6648),
    [sym_word] = ACTIONS(6646),
    [sym_placeholder] = ACTIONS(6648),
    [anon_sym_PLUS] = ACTIONS(6648),
    [anon_sym_DASH] = ACTIONS(6648),
    [anon_sym_STAR] = ACTIONS(6648),
    [anon_sym_SLASH] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6646),
    [anon_sym_GT] = ACTIONS(6646),
    [anon_sym_BANG] = ACTIONS(6646),
    [anon_sym_PIPE] = ACTIONS(6646),
    [anon_sym_COLON] = ACTIONS(6646),
    [anon_sym_SQUOTE] = ACTIONS(6646),
    [anon_sym__] = ACTIONS(6648),
    [anon_sym_CARET] = ACTIONS(6648),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6648),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6648),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6648),
    [anon_sym_DOLLAR] = ACTIONS(6646),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHbegin] = ACTIONS(6646),
    [anon_sym_BSLASHtitle] = ACTIONS(6646),
    [anon_sym_BSLASHauthor] = ACTIONS(6646),
    [anon_sym_BSLASHusepackage] = ACTIONS(6646),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6646),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6646),
    [anon_sym_BSLASHinclude] = ACTIONS(6646),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6646),
    [anon_sym_BSLASHinput] = ACTIONS(6646),
    [anon_sym_BSLASHsubfile] = ACTIONS(6646),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6646),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6646),
    [anon_sym_BSLASHbibliography] = ACTIONS(6646),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6646),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6646),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6646),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6646),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6646),
    [anon_sym_BSLASHimport] = ACTIONS(6646),
    [anon_sym_BSLASHsubimport] = ACTIONS(6646),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6646),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHcaption] = ACTIONS(6646),
    [anon_sym_BSLASHcite] = ACTIONS(6646),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCite] = ACTIONS(6646),
    [anon_sym_BSLASHnocite] = ACTIONS(6646),
    [anon_sym_BSLASHcitet] = ACTIONS(6646),
    [anon_sym_BSLASHcitep] = ACTIONS(6646),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteA] = ACTIONS(6646),
    [anon_sym_BSLASHciteR] = ACTIONS(6646),
    [anon_sym_BSLASHciteS] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6646),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteyear] = ACTIONS(6646),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitedate] = ACTIONS(6646),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteurl] = ACTIONS(6646),
    [anon_sym_BSLASHfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6646),
    [anon_sym_BSLASHcitealt] = ACTIONS(6646),
    [anon_sym_BSLASHcitealp] = ACTIONS(6646),
    [anon_sym_BSLASHcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHparencite] = ACTIONS(6646),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHParencite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHtextcite] = ACTIONS(6646),
    [anon_sym_BSLASHTextcite] = ACTIONS(6646),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHsupercite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite] = ACTIONS(6646),
    [anon_sym_BSLASHAutocite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHVolcite] = ACTIONS(6646),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHavolcite] = ACTIONS(6646),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHNotecite] = ACTIONS(6646),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHlabel] = ACTIONS(6646),
    [anon_sym_BSLASHref] = ACTIONS(6646),
    [anon_sym_BSLASHeqref] = ACTIONS(6646),
    [anon_sym_BSLASHvref] = ACTIONS(6646),
    [anon_sym_BSLASHVref] = ACTIONS(6646),
    [anon_sym_BSLASHautoref] = ACTIONS(6646),
    [anon_sym_BSLASHpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcref] = ACTIONS(6646),
    [anon_sym_BSLASHCref] = ACTIONS(6646),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnameCref] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHdef] = ACTIONS(6646),
    [anon_sym_BSLASHlet] = ACTIONS(6646),
    [anon_sym_BSLASHleft] = ACTIONS(6646),
    [anon_sym_BSLASHbigl] = ACTIONS(6646),
    [anon_sym_BSLASHBigl] = ACTIONS(6646),
    [anon_sym_BSLASHbiggl] = ACTIONS(6646),
    [anon_sym_BSLASHBiggl] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6646),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6646),
    [anon_sym_BSLASHgls] = ACTIONS(6646),
    [anon_sym_BSLASHGls] = ACTIONS(6646),
    [anon_sym_BSLASHGLS] = ACTIONS(6646),
    [anon_sym_BSLASHglspl] = ACTIONS(6646),
    [anon_sym_BSLASHGlspl] = ACTIONS(6646),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6646),
    [anon_sym_BSLASHglslink] = ACTIONS(6646),
    [anon_sym_BSLASHglstext] = ACTIONS(6646),
    [anon_sym_BSLASHGlstext] = ACTIONS(6646),
    [anon_sym_BSLASHGLStext] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6646),
    [anon_sym_BSLASHglsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsname] = ACTIONS(6646),
    [anon_sym_BSLASHGlsname] = ACTIONS(6646),
    [anon_sym_BSLASHGLSname] = ACTIONS(6646),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6646),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6646),
    [anon_sym_BSLASHacrshort] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6646),
    [anon_sym_BSLASHACRshort] = ACTIONS(6646),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrlong] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6646),
    [anon_sym_BSLASHACRlong] = ACTIONS(6646),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrfull] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6646),
    [anon_sym_BSLASHACRfull] = ACTIONS(6646),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHacs] = ACTIONS(6646),
    [anon_sym_BSLASHAcs] = ACTIONS(6646),
    [anon_sym_BSLASHacsp] = ACTIONS(6646),
    [anon_sym_BSLASHAcsp] = ACTIONS(6646),
    [anon_sym_BSLASHacl] = ACTIONS(6646),
    [anon_sym_BSLASHAcl] = ACTIONS(6646),
    [anon_sym_BSLASHaclp] = ACTIONS(6646),
    [anon_sym_BSLASHAclp] = ACTIONS(6646),
    [anon_sym_BSLASHacf] = ACTIONS(6646),
    [anon_sym_BSLASHAcf] = ACTIONS(6646),
    [anon_sym_BSLASHacfp] = ACTIONS(6646),
    [anon_sym_BSLASHAcfp] = ACTIONS(6646),
    [anon_sym_BSLASHac] = ACTIONS(6646),
    [anon_sym_BSLASHAc] = ACTIONS(6646),
    [anon_sym_BSLASHacp] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6646),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6646),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6646),
    [anon_sym_BSLASHcolor] = ACTIONS(6646),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6646),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6646),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6646),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6646),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6646),
    [anon_sym_BSLASHtext] = ACTIONS(6646),
    [anon_sym_BSLASHintertext] = ACTIONS(6646),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6646),
    [anon_sym_BSLASHurl] = ACTIONS(6646),
    [anon_sym_BSLASHhref] = ACTIONS(6646),
  },
  [1234] = {
    [sym_command_name] = ACTIONS(6602),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6602),
    [anon_sym_LBRACK] = ACTIONS(6604),
    [anon_sym_RBRACK] = ACTIONS(6604),
    [anon_sym_COMMA] = ACTIONS(6604),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(6604),
    [anon_sym_RPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHpart] = ACTIONS(6602),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddpart] = ACTIONS(6602),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHchapter] = ACTIONS(6602),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddchap] = ACTIONS(6602),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsection] = ACTIONS(6602),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddsec] = ACTIONS(6602),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHitem] = ACTIONS(6602),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6604),
    [anon_sym_LBRACE] = ACTIONS(6604),
    [sym_word] = ACTIONS(6602),
    [sym_placeholder] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6602),
    [anon_sym_GT] = ACTIONS(6602),
    [anon_sym_BANG] = ACTIONS(6602),
    [anon_sym_PIPE] = ACTIONS(6602),
    [anon_sym_COLON] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(6602),
    [anon_sym__] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6604),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6604),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6604),
    [anon_sym_DOLLAR] = ACTIONS(6602),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHbegin] = ACTIONS(6602),
    [anon_sym_BSLASHtitle] = ACTIONS(6602),
    [anon_sym_BSLASHauthor] = ACTIONS(6602),
    [anon_sym_BSLASHusepackage] = ACTIONS(6602),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6602),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6602),
    [anon_sym_BSLASHinclude] = ACTIONS(6602),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6602),
    [anon_sym_BSLASHinput] = ACTIONS(6602),
    [anon_sym_BSLASHsubfile] = ACTIONS(6602),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6602),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6602),
    [anon_sym_BSLASHbibliography] = ACTIONS(6602),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6602),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6602),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6602),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6602),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6602),
    [anon_sym_BSLASHimport] = ACTIONS(6602),
    [anon_sym_BSLASHsubimport] = ACTIONS(6602),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6602),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHcaption] = ACTIONS(6602),
    [anon_sym_BSLASHcite] = ACTIONS(6602),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCite] = ACTIONS(6602),
    [anon_sym_BSLASHnocite] = ACTIONS(6602),
    [anon_sym_BSLASHcitet] = ACTIONS(6602),
    [anon_sym_BSLASHcitep] = ACTIONS(6602),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteA] = ACTIONS(6602),
    [anon_sym_BSLASHciteR] = ACTIONS(6602),
    [anon_sym_BSLASHciteS] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6602),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteyear] = ACTIONS(6602),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitedate] = ACTIONS(6602),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteurl] = ACTIONS(6602),
    [anon_sym_BSLASHfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6602),
    [anon_sym_BSLASHcitealt] = ACTIONS(6602),
    [anon_sym_BSLASHcitealp] = ACTIONS(6602),
    [anon_sym_BSLASHcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHparencite] = ACTIONS(6602),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHParencite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHtextcite] = ACTIONS(6602),
    [anon_sym_BSLASHTextcite] = ACTIONS(6602),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHsupercite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite] = ACTIONS(6602),
    [anon_sym_BSLASHAutocite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHVolcite] = ACTIONS(6602),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHavolcite] = ACTIONS(6602),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHNotecite] = ACTIONS(6602),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHlabel] = ACTIONS(6602),
    [anon_sym_BSLASHref] = ACTIONS(6602),
    [anon_sym_BSLASHeqref] = ACTIONS(6602),
    [anon_sym_BSLASHvref] = ACTIONS(6602),
    [anon_sym_BSLASHVref] = ACTIONS(6602),
    [anon_sym_BSLASHautoref] = ACTIONS(6602),
    [anon_sym_BSLASHpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcref] = ACTIONS(6602),
    [anon_sym_BSLASHCref] = ACTIONS(6602),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnameCref] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHdef] = ACTIONS(6602),
    [anon_sym_BSLASHlet] = ACTIONS(6602),
    [anon_sym_BSLASHleft] = ACTIONS(6602),
    [anon_sym_BSLASHbigl] = ACTIONS(6602),
    [anon_sym_BSLASHBigl] = ACTIONS(6602),
    [anon_sym_BSLASHbiggl] = ACTIONS(6602),
    [anon_sym_BSLASHBiggl] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6602),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6602),
    [anon_sym_BSLASHgls] = ACTIONS(6602),
    [anon_sym_BSLASHGls] = ACTIONS(6602),
    [anon_sym_BSLASHGLS] = ACTIONS(6602),
    [anon_sym_BSLASHglspl] = ACTIONS(6602),
    [anon_sym_BSLASHGlspl] = ACTIONS(6602),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6602),
    [anon_sym_BSLASHglslink] = ACTIONS(6602),
    [anon_sym_BSLASHglstext] = ACTIONS(6602),
    [anon_sym_BSLASHGlstext] = ACTIONS(6602),
    [anon_sym_BSLASHGLStext] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6602),
    [anon_sym_BSLASHglsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsname] = ACTIONS(6602),
    [anon_sym_BSLASHGlsname] = ACTIONS(6602),
    [anon_sym_BSLASHGLSname] = ACTIONS(6602),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6602),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6602),
    [anon_sym_BSLASHacrshort] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6602),
    [anon_sym_BSLASHACRshort] = ACTIONS(6602),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrlong] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6602),
    [anon_sym_BSLASHACRlong] = ACTIONS(6602),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrfull] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6602),
    [anon_sym_BSLASHACRfull] = ACTIONS(6602),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHacs] = ACTIONS(6602),
    [anon_sym_BSLASHAcs] = ACTIONS(6602),
    [anon_sym_BSLASHacsp] = ACTIONS(6602),
    [anon_sym_BSLASHAcsp] = ACTIONS(6602),
    [anon_sym_BSLASHacl] = ACTIONS(6602),
    [anon_sym_BSLASHAcl] = ACTIONS(6602),
    [anon_sym_BSLASHaclp] = ACTIONS(6602),
    [anon_sym_BSLASHAclp] = ACTIONS(6602),
    [anon_sym_BSLASHacf] = ACTIONS(6602),
    [anon_sym_BSLASHAcf] = ACTIONS(6602),
    [anon_sym_BSLASHacfp] = ACTIONS(6602),
    [anon_sym_BSLASHAcfp] = ACTIONS(6602),
    [anon_sym_BSLASHac] = ACTIONS(6602),
    [anon_sym_BSLASHAc] = ACTIONS(6602),
    [anon_sym_BSLASHacp] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6602),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6602),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6602),
    [anon_sym_BSLASHcolor] = ACTIONS(6602),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6602),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6602),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6602),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6602),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6602),
    [anon_sym_BSLASHtext] = ACTIONS(6602),
    [anon_sym_BSLASHintertext] = ACTIONS(6602),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6602),
    [anon_sym_BSLASHurl] = ACTIONS(6602),
    [anon_sym_BSLASHhref] = ACTIONS(6602),
  },
  [1235] = {
    [sym_command_name] = ACTIONS(6606),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6606),
    [anon_sym_LBRACK] = ACTIONS(6608),
    [anon_sym_RBRACK] = ACTIONS(6608),
    [anon_sym_COMMA] = ACTIONS(6608),
    [anon_sym_EQ] = ACTIONS(6608),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_RPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHpart] = ACTIONS(6606),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddpart] = ACTIONS(6606),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHchapter] = ACTIONS(6606),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddchap] = ACTIONS(6606),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsection] = ACTIONS(6606),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddsec] = ACTIONS(6606),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHitem] = ACTIONS(6606),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6608),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [sym_word] = ACTIONS(6606),
    [sym_placeholder] = ACTIONS(6608),
    [anon_sym_PLUS] = ACTIONS(6608),
    [anon_sym_DASH] = ACTIONS(6608),
    [anon_sym_STAR] = ACTIONS(6608),
    [anon_sym_SLASH] = ACTIONS(6608),
    [anon_sym_LT] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6606),
    [anon_sym_BANG] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6606),
    [anon_sym_COLON] = ACTIONS(6606),
    [anon_sym_SQUOTE] = ACTIONS(6606),
    [anon_sym__] = ACTIONS(6608),
    [anon_sym_CARET] = ACTIONS(6608),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6608),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6608),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(6606),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHbegin] = ACTIONS(6606),
    [anon_sym_BSLASHtitle] = ACTIONS(6606),
    [anon_sym_BSLASHauthor] = ACTIONS(6606),
    [anon_sym_BSLASHusepackage] = ACTIONS(6606),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6606),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6606),
    [anon_sym_BSLASHinclude] = ACTIONS(6606),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6606),
    [anon_sym_BSLASHinput] = ACTIONS(6606),
    [anon_sym_BSLASHsubfile] = ACTIONS(6606),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6606),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6606),
    [anon_sym_BSLASHbibliography] = ACTIONS(6606),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6606),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6606),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6606),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6606),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6606),
    [anon_sym_BSLASHimport] = ACTIONS(6606),
    [anon_sym_BSLASHsubimport] = ACTIONS(6606),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6606),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHcaption] = ACTIONS(6606),
    [anon_sym_BSLASHcite] = ACTIONS(6606),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCite] = ACTIONS(6606),
    [anon_sym_BSLASHnocite] = ACTIONS(6606),
    [anon_sym_BSLASHcitet] = ACTIONS(6606),
    [anon_sym_BSLASHcitep] = ACTIONS(6606),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteA] = ACTIONS(6606),
    [anon_sym_BSLASHciteR] = ACTIONS(6606),
    [anon_sym_BSLASHciteS] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6606),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteyear] = ACTIONS(6606),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitedate] = ACTIONS(6606),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteurl] = ACTIONS(6606),
    [anon_sym_BSLASHfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6606),
    [anon_sym_BSLASHcitealt] = ACTIONS(6606),
    [anon_sym_BSLASHcitealp] = ACTIONS(6606),
    [anon_sym_BSLASHcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHparencite] = ACTIONS(6606),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHParencite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHtextcite] = ACTIONS(6606),
    [anon_sym_BSLASHTextcite] = ACTIONS(6606),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHsupercite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite] = ACTIONS(6606),
    [anon_sym_BSLASHAutocite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHVolcite] = ACTIONS(6606),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHavolcite] = ACTIONS(6606),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHNotecite] = ACTIONS(6606),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHlabel] = ACTIONS(6606),
    [anon_sym_BSLASHref] = ACTIONS(6606),
    [anon_sym_BSLASHeqref] = ACTIONS(6606),
    [anon_sym_BSLASHvref] = ACTIONS(6606),
    [anon_sym_BSLASHVref] = ACTIONS(6606),
    [anon_sym_BSLASHautoref] = ACTIONS(6606),
    [anon_sym_BSLASHpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcref] = ACTIONS(6606),
    [anon_sym_BSLASHCref] = ACTIONS(6606),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnameCref] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHdef] = ACTIONS(6606),
    [anon_sym_BSLASHlet] = ACTIONS(6606),
    [anon_sym_BSLASHleft] = ACTIONS(6606),
    [anon_sym_BSLASHbigl] = ACTIONS(6606),
    [anon_sym_BSLASHBigl] = ACTIONS(6606),
    [anon_sym_BSLASHbiggl] = ACTIONS(6606),
    [anon_sym_BSLASHBiggl] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6606),
    [anon_sym_BSLASHgls] = ACTIONS(6606),
    [anon_sym_BSLASHGls] = ACTIONS(6606),
    [anon_sym_BSLASHGLS] = ACTIONS(6606),
    [anon_sym_BSLASHglspl] = ACTIONS(6606),
    [anon_sym_BSLASHGlspl] = ACTIONS(6606),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6606),
    [anon_sym_BSLASHglslink] = ACTIONS(6606),
    [anon_sym_BSLASHglstext] = ACTIONS(6606),
    [anon_sym_BSLASHGlstext] = ACTIONS(6606),
    [anon_sym_BSLASHGLStext] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6606),
    [anon_sym_BSLASHglsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsname] = ACTIONS(6606),
    [anon_sym_BSLASHGlsname] = ACTIONS(6606),
    [anon_sym_BSLASHGLSname] = ACTIONS(6606),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6606),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6606),
    [anon_sym_BSLASHacrshort] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6606),
    [anon_sym_BSLASHACRshort] = ACTIONS(6606),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrlong] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6606),
    [anon_sym_BSLASHACRlong] = ACTIONS(6606),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrfull] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6606),
    [anon_sym_BSLASHACRfull] = ACTIONS(6606),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHacs] = ACTIONS(6606),
    [anon_sym_BSLASHAcs] = ACTIONS(6606),
    [anon_sym_BSLASHacsp] = ACTIONS(6606),
    [anon_sym_BSLASHAcsp] = ACTIONS(6606),
    [anon_sym_BSLASHacl] = ACTIONS(6606),
    [anon_sym_BSLASHAcl] = ACTIONS(6606),
    [anon_sym_BSLASHaclp] = ACTIONS(6606),
    [anon_sym_BSLASHAclp] = ACTIONS(6606),
    [anon_sym_BSLASHacf] = ACTIONS(6606),
    [anon_sym_BSLASHAcf] = ACTIONS(6606),
    [anon_sym_BSLASHacfp] = ACTIONS(6606),
    [anon_sym_BSLASHAcfp] = ACTIONS(6606),
    [anon_sym_BSLASHac] = ACTIONS(6606),
    [anon_sym_BSLASHAc] = ACTIONS(6606),
    [anon_sym_BSLASHacp] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6606),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6606),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6606),
    [anon_sym_BSLASHcolor] = ACTIONS(6606),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6606),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6606),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6606),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6606),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6606),
    [anon_sym_BSLASHtext] = ACTIONS(6606),
    [anon_sym_BSLASHintertext] = ACTIONS(6606),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6606),
    [anon_sym_BSLASHurl] = ACTIONS(6606),
    [anon_sym_BSLASHhref] = ACTIONS(6606),
  },
  [1236] = {
    [sym_command_name] = ACTIONS(6610),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6610),
    [anon_sym_LBRACK] = ACTIONS(6612),
    [anon_sym_RBRACK] = ACTIONS(6612),
    [anon_sym_COMMA] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6612),
    [anon_sym_RPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHpart] = ACTIONS(6610),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddpart] = ACTIONS(6610),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHchapter] = ACTIONS(6610),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddchap] = ACTIONS(6610),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsection] = ACTIONS(6610),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddsec] = ACTIONS(6610),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHitem] = ACTIONS(6610),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6612),
    [anon_sym_LBRACE] = ACTIONS(6612),
    [sym_word] = ACTIONS(6610),
    [sym_placeholder] = ACTIONS(6612),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_DASH] = ACTIONS(6612),
    [anon_sym_STAR] = ACTIONS(6612),
    [anon_sym_SLASH] = ACTIONS(6612),
    [anon_sym_LT] = ACTIONS(6610),
    [anon_sym_GT] = ACTIONS(6610),
    [anon_sym_BANG] = ACTIONS(6610),
    [anon_sym_PIPE] = ACTIONS(6610),
    [anon_sym_COLON] = ACTIONS(6610),
    [anon_sym_SQUOTE] = ACTIONS(6610),
    [anon_sym__] = ACTIONS(6612),
    [anon_sym_CARET] = ACTIONS(6612),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6612),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6612),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6612),
    [anon_sym_DOLLAR] = ACTIONS(6610),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHbegin] = ACTIONS(6610),
    [anon_sym_BSLASHtitle] = ACTIONS(6610),
    [anon_sym_BSLASHauthor] = ACTIONS(6610),
    [anon_sym_BSLASHusepackage] = ACTIONS(6610),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6610),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6610),
    [anon_sym_BSLASHinclude] = ACTIONS(6610),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6610),
    [anon_sym_BSLASHinput] = ACTIONS(6610),
    [anon_sym_BSLASHsubfile] = ACTIONS(6610),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6610),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6610),
    [anon_sym_BSLASHbibliography] = ACTIONS(6610),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6610),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6610),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6610),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6610),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6610),
    [anon_sym_BSLASHimport] = ACTIONS(6610),
    [anon_sym_BSLASHsubimport] = ACTIONS(6610),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6610),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHcaption] = ACTIONS(6610),
    [anon_sym_BSLASHcite] = ACTIONS(6610),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCite] = ACTIONS(6610),
    [anon_sym_BSLASHnocite] = ACTIONS(6610),
    [anon_sym_BSLASHcitet] = ACTIONS(6610),
    [anon_sym_BSLASHcitep] = ACTIONS(6610),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteA] = ACTIONS(6610),
    [anon_sym_BSLASHciteR] = ACTIONS(6610),
    [anon_sym_BSLASHciteS] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6610),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteyear] = ACTIONS(6610),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitedate] = ACTIONS(6610),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteurl] = ACTIONS(6610),
    [anon_sym_BSLASHfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6610),
    [anon_sym_BSLASHcitealt] = ACTIONS(6610),
    [anon_sym_BSLASHcitealp] = ACTIONS(6610),
    [anon_sym_BSLASHcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHparencite] = ACTIONS(6610),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHParencite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHtextcite] = ACTIONS(6610),
    [anon_sym_BSLASHTextcite] = ACTIONS(6610),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHsupercite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite] = ACTIONS(6610),
    [anon_sym_BSLASHAutocite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHVolcite] = ACTIONS(6610),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHavolcite] = ACTIONS(6610),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHNotecite] = ACTIONS(6610),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHlabel] = ACTIONS(6610),
    [anon_sym_BSLASHref] = ACTIONS(6610),
    [anon_sym_BSLASHeqref] = ACTIONS(6610),
    [anon_sym_BSLASHvref] = ACTIONS(6610),
    [anon_sym_BSLASHVref] = ACTIONS(6610),
    [anon_sym_BSLASHautoref] = ACTIONS(6610),
    [anon_sym_BSLASHpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcref] = ACTIONS(6610),
    [anon_sym_BSLASHCref] = ACTIONS(6610),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnameCref] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHdef] = ACTIONS(6610),
    [anon_sym_BSLASHlet] = ACTIONS(6610),
    [anon_sym_BSLASHleft] = ACTIONS(6610),
    [anon_sym_BSLASHbigl] = ACTIONS(6610),
    [anon_sym_BSLASHBigl] = ACTIONS(6610),
    [anon_sym_BSLASHbiggl] = ACTIONS(6610),
    [anon_sym_BSLASHBiggl] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6610),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6610),
    [anon_sym_BSLASHgls] = ACTIONS(6610),
    [anon_sym_BSLASHGls] = ACTIONS(6610),
    [anon_sym_BSLASHGLS] = ACTIONS(6610),
    [anon_sym_BSLASHglspl] = ACTIONS(6610),
    [anon_sym_BSLASHGlspl] = ACTIONS(6610),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6610),
    [anon_sym_BSLASHglslink] = ACTIONS(6610),
    [anon_sym_BSLASHglstext] = ACTIONS(6610),
    [anon_sym_BSLASHGlstext] = ACTIONS(6610),
    [anon_sym_BSLASHGLStext] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6610),
    [anon_sym_BSLASHglsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsname] = ACTIONS(6610),
    [anon_sym_BSLASHGlsname] = ACTIONS(6610),
    [anon_sym_BSLASHGLSname] = ACTIONS(6610),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6610),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6610),
    [anon_sym_BSLASHacrshort] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6610),
    [anon_sym_BSLASHACRshort] = ACTIONS(6610),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrlong] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6610),
    [anon_sym_BSLASHACRlong] = ACTIONS(6610),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrfull] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6610),
    [anon_sym_BSLASHACRfull] = ACTIONS(6610),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHacs] = ACTIONS(6610),
    [anon_sym_BSLASHAcs] = ACTIONS(6610),
    [anon_sym_BSLASHacsp] = ACTIONS(6610),
    [anon_sym_BSLASHAcsp] = ACTIONS(6610),
    [anon_sym_BSLASHacl] = ACTIONS(6610),
    [anon_sym_BSLASHAcl] = ACTIONS(6610),
    [anon_sym_BSLASHaclp] = ACTIONS(6610),
    [anon_sym_BSLASHAclp] = ACTIONS(6610),
    [anon_sym_BSLASHacf] = ACTIONS(6610),
    [anon_sym_BSLASHAcf] = ACTIONS(6610),
    [anon_sym_BSLASHacfp] = ACTIONS(6610),
    [anon_sym_BSLASHAcfp] = ACTIONS(6610),
    [anon_sym_BSLASHac] = ACTIONS(6610),
    [anon_sym_BSLASHAc] = ACTIONS(6610),
    [anon_sym_BSLASHacp] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6610),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6610),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6610),
    [anon_sym_BSLASHcolor] = ACTIONS(6610),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6610),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6610),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6610),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6610),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6610),
    [anon_sym_BSLASHtext] = ACTIONS(6610),
    [anon_sym_BSLASHintertext] = ACTIONS(6610),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6610),
    [anon_sym_BSLASHurl] = ACTIONS(6610),
    [anon_sym_BSLASHhref] = ACTIONS(6610),
  },
  [1237] = {
    [sym_command_name] = ACTIONS(6650),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6650),
    [anon_sym_LBRACK] = ACTIONS(6652),
    [anon_sym_RBRACK] = ACTIONS(6652),
    [anon_sym_COMMA] = ACTIONS(6652),
    [anon_sym_EQ] = ACTIONS(6652),
    [anon_sym_LPAREN] = ACTIONS(6652),
    [anon_sym_RPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHpart] = ACTIONS(6650),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddpart] = ACTIONS(6650),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHchapter] = ACTIONS(6650),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddchap] = ACTIONS(6650),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsection] = ACTIONS(6650),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddsec] = ACTIONS(6650),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHitem] = ACTIONS(6650),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6652),
    [anon_sym_LBRACE] = ACTIONS(6652),
    [sym_word] = ACTIONS(6650),
    [sym_placeholder] = ACTIONS(6652),
    [anon_sym_PLUS] = ACTIONS(6652),
    [anon_sym_DASH] = ACTIONS(6652),
    [anon_sym_STAR] = ACTIONS(6652),
    [anon_sym_SLASH] = ACTIONS(6652),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_BANG] = ACTIONS(6650),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_COLON] = ACTIONS(6650),
    [anon_sym_SQUOTE] = ACTIONS(6650),
    [anon_sym__] = ACTIONS(6652),
    [anon_sym_CARET] = ACTIONS(6652),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6652),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6652),
    [anon_sym_DOLLAR] = ACTIONS(6650),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6652),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHbegin] = ACTIONS(6650),
    [anon_sym_BSLASHtitle] = ACTIONS(6650),
    [anon_sym_BSLASHauthor] = ACTIONS(6650),
    [anon_sym_BSLASHusepackage] = ACTIONS(6650),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6650),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6650),
    [anon_sym_BSLASHinclude] = ACTIONS(6650),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6650),
    [anon_sym_BSLASHinput] = ACTIONS(6650),
    [anon_sym_BSLASHsubfile] = ACTIONS(6650),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6650),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6650),
    [anon_sym_BSLASHbibliography] = ACTIONS(6650),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6650),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6650),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6650),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6650),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6650),
    [anon_sym_BSLASHimport] = ACTIONS(6650),
    [anon_sym_BSLASHsubimport] = ACTIONS(6650),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6650),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHcaption] = ACTIONS(6650),
    [anon_sym_BSLASHcite] = ACTIONS(6650),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCite] = ACTIONS(6650),
    [anon_sym_BSLASHnocite] = ACTIONS(6650),
    [anon_sym_BSLASHcitet] = ACTIONS(6650),
    [anon_sym_BSLASHcitep] = ACTIONS(6650),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteA] = ACTIONS(6650),
    [anon_sym_BSLASHciteR] = ACTIONS(6650),
    [anon_sym_BSLASHciteS] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6650),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteyear] = ACTIONS(6650),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitedate] = ACTIONS(6650),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteurl] = ACTIONS(6650),
    [anon_sym_BSLASHfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6650),
    [anon_sym_BSLASHcitealt] = ACTIONS(6650),
    [anon_sym_BSLASHcitealp] = ACTIONS(6650),
    [anon_sym_BSLASHcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHparencite] = ACTIONS(6650),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHParencite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHtextcite] = ACTIONS(6650),
    [anon_sym_BSLASHTextcite] = ACTIONS(6650),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHsupercite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite] = ACTIONS(6650),
    [anon_sym_BSLASHAutocite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHVolcite] = ACTIONS(6650),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHavolcite] = ACTIONS(6650),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHNotecite] = ACTIONS(6650),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHlabel] = ACTIONS(6650),
    [anon_sym_BSLASHref] = ACTIONS(6650),
    [anon_sym_BSLASHeqref] = ACTIONS(6650),
    [anon_sym_BSLASHvref] = ACTIONS(6650),
    [anon_sym_BSLASHVref] = ACTIONS(6650),
    [anon_sym_BSLASHautoref] = ACTIONS(6650),
    [anon_sym_BSLASHpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcref] = ACTIONS(6650),
    [anon_sym_BSLASHCref] = ACTIONS(6650),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnameCref] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHdef] = ACTIONS(6650),
    [anon_sym_BSLASHlet] = ACTIONS(6650),
    [anon_sym_BSLASHleft] = ACTIONS(6650),
    [anon_sym_BSLASHbigl] = ACTIONS(6650),
    [anon_sym_BSLASHBigl] = ACTIONS(6650),
    [anon_sym_BSLASHbiggl] = ACTIONS(6650),
    [anon_sym_BSLASHBiggl] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6650),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6650),
    [anon_sym_BSLASHgls] = ACTIONS(6650),
    [anon_sym_BSLASHGls] = ACTIONS(6650),
    [anon_sym_BSLASHGLS] = ACTIONS(6650),
    [anon_sym_BSLASHglspl] = ACTIONS(6650),
    [anon_sym_BSLASHGlspl] = ACTIONS(6650),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6650),
    [anon_sym_BSLASHglslink] = ACTIONS(6650),
    [anon_sym_BSLASHglstext] = ACTIONS(6650),
    [anon_sym_BSLASHGlstext] = ACTIONS(6650),
    [anon_sym_BSLASHGLStext] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6650),
    [anon_sym_BSLASHglsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsname] = ACTIONS(6650),
    [anon_sym_BSLASHGlsname] = ACTIONS(6650),
    [anon_sym_BSLASHGLSname] = ACTIONS(6650),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6650),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6650),
    [anon_sym_BSLASHacrshort] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6650),
    [anon_sym_BSLASHACRshort] = ACTIONS(6650),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrlong] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6650),
    [anon_sym_BSLASHACRlong] = ACTIONS(6650),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrfull] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6650),
    [anon_sym_BSLASHACRfull] = ACTIONS(6650),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHacs] = ACTIONS(6650),
    [anon_sym_BSLASHAcs] = ACTIONS(6650),
    [anon_sym_BSLASHacsp] = ACTIONS(6650),
    [anon_sym_BSLASHAcsp] = ACTIONS(6650),
    [anon_sym_BSLASHacl] = ACTIONS(6650),
    [anon_sym_BSLASHAcl] = ACTIONS(6650),
    [anon_sym_BSLASHaclp] = ACTIONS(6650),
    [anon_sym_BSLASHAclp] = ACTIONS(6650),
    [anon_sym_BSLASHacf] = ACTIONS(6650),
    [anon_sym_BSLASHAcf] = ACTIONS(6650),
    [anon_sym_BSLASHacfp] = ACTIONS(6650),
    [anon_sym_BSLASHAcfp] = ACTIONS(6650),
    [anon_sym_BSLASHac] = ACTIONS(6650),
    [anon_sym_BSLASHAc] = ACTIONS(6650),
    [anon_sym_BSLASHacp] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6650),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6650),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6650),
    [anon_sym_BSLASHcolor] = ACTIONS(6650),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6650),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6650),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6650),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6650),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6650),
    [anon_sym_BSLASHtext] = ACTIONS(6650),
    [anon_sym_BSLASHintertext] = ACTIONS(6650),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6650),
    [anon_sym_BSLASHurl] = ACTIONS(6650),
    [anon_sym_BSLASHhref] = ACTIONS(6650),
  },
  [1238] = {
    [sym_command_name] = ACTIONS(6614),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6614),
    [anon_sym_LBRACK] = ACTIONS(6616),
    [anon_sym_RBRACK] = ACTIONS(6616),
    [anon_sym_COMMA] = ACTIONS(6616),
    [anon_sym_EQ] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6616),
    [anon_sym_RPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHpart] = ACTIONS(6614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddpart] = ACTIONS(6614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHchapter] = ACTIONS(6614),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddchap] = ACTIONS(6614),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsection] = ACTIONS(6614),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddsec] = ACTIONS(6614),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHitem] = ACTIONS(6614),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(6616),
    [sym_word] = ACTIONS(6614),
    [sym_placeholder] = ACTIONS(6616),
    [anon_sym_PLUS] = ACTIONS(6616),
    [anon_sym_DASH] = ACTIONS(6616),
    [anon_sym_STAR] = ACTIONS(6616),
    [anon_sym_SLASH] = ACTIONS(6616),
    [anon_sym_LT] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6614),
    [anon_sym_BANG] = ACTIONS(6614),
    [anon_sym_PIPE] = ACTIONS(6614),
    [anon_sym_COLON] = ACTIONS(6614),
    [anon_sym_SQUOTE] = ACTIONS(6614),
    [anon_sym__] = ACTIONS(6616),
    [anon_sym_CARET] = ACTIONS(6616),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6616),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6616),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6616),
    [anon_sym_DOLLAR] = ACTIONS(6614),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHbegin] = ACTIONS(6614),
    [anon_sym_BSLASHtitle] = ACTIONS(6614),
    [anon_sym_BSLASHauthor] = ACTIONS(6614),
    [anon_sym_BSLASHusepackage] = ACTIONS(6614),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6614),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6614),
    [anon_sym_BSLASHinclude] = ACTIONS(6614),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6614),
    [anon_sym_BSLASHinput] = ACTIONS(6614),
    [anon_sym_BSLASHsubfile] = ACTIONS(6614),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6614),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6614),
    [anon_sym_BSLASHbibliography] = ACTIONS(6614),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6614),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6614),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6614),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6614),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6614),
    [anon_sym_BSLASHimport] = ACTIONS(6614),
    [anon_sym_BSLASHsubimport] = ACTIONS(6614),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6614),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHcaption] = ACTIONS(6614),
    [anon_sym_BSLASHcite] = ACTIONS(6614),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCite] = ACTIONS(6614),
    [anon_sym_BSLASHnocite] = ACTIONS(6614),
    [anon_sym_BSLASHcitet] = ACTIONS(6614),
    [anon_sym_BSLASHcitep] = ACTIONS(6614),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteA] = ACTIONS(6614),
    [anon_sym_BSLASHciteR] = ACTIONS(6614),
    [anon_sym_BSLASHciteS] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6614),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteyear] = ACTIONS(6614),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitedate] = ACTIONS(6614),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteurl] = ACTIONS(6614),
    [anon_sym_BSLASHfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6614),
    [anon_sym_BSLASHcitealt] = ACTIONS(6614),
    [anon_sym_BSLASHcitealp] = ACTIONS(6614),
    [anon_sym_BSLASHcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHparencite] = ACTIONS(6614),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHParencite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHtextcite] = ACTIONS(6614),
    [anon_sym_BSLASHTextcite] = ACTIONS(6614),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHsupercite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite] = ACTIONS(6614),
    [anon_sym_BSLASHAutocite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHVolcite] = ACTIONS(6614),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHavolcite] = ACTIONS(6614),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHNotecite] = ACTIONS(6614),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHlabel] = ACTIONS(6614),
    [anon_sym_BSLASHref] = ACTIONS(6614),
    [anon_sym_BSLASHeqref] = ACTIONS(6614),
    [anon_sym_BSLASHvref] = ACTIONS(6614),
    [anon_sym_BSLASHVref] = ACTIONS(6614),
    [anon_sym_BSLASHautoref] = ACTIONS(6614),
    [anon_sym_BSLASHpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcref] = ACTIONS(6614),
    [anon_sym_BSLASHCref] = ACTIONS(6614),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnameCref] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHdef] = ACTIONS(6614),
    [anon_sym_BSLASHlet] = ACTIONS(6614),
    [anon_sym_BSLASHleft] = ACTIONS(6614),
    [anon_sym_BSLASHbigl] = ACTIONS(6614),
    [anon_sym_BSLASHBigl] = ACTIONS(6614),
    [anon_sym_BSLASHbiggl] = ACTIONS(6614),
    [anon_sym_BSLASHBiggl] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6614),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6614),
    [anon_sym_BSLASHgls] = ACTIONS(6614),
    [anon_sym_BSLASHGls] = ACTIONS(6614),
    [anon_sym_BSLASHGLS] = ACTIONS(6614),
    [anon_sym_BSLASHglspl] = ACTIONS(6614),
    [anon_sym_BSLASHGlspl] = ACTIONS(6614),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6614),
    [anon_sym_BSLASHglslink] = ACTIONS(6614),
    [anon_sym_BSLASHglstext] = ACTIONS(6614),
    [anon_sym_BSLASHGlstext] = ACTIONS(6614),
    [anon_sym_BSLASHGLStext] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6614),
    [anon_sym_BSLASHglsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsname] = ACTIONS(6614),
    [anon_sym_BSLASHGlsname] = ACTIONS(6614),
    [anon_sym_BSLASHGLSname] = ACTIONS(6614),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6614),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6614),
    [anon_sym_BSLASHacrshort] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6614),
    [anon_sym_BSLASHACRshort] = ACTIONS(6614),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrlong] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6614),
    [anon_sym_BSLASHACRlong] = ACTIONS(6614),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrfull] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6614),
    [anon_sym_BSLASHACRfull] = ACTIONS(6614),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHacs] = ACTIONS(6614),
    [anon_sym_BSLASHAcs] = ACTIONS(6614),
    [anon_sym_BSLASHacsp] = ACTIONS(6614),
    [anon_sym_BSLASHAcsp] = ACTIONS(6614),
    [anon_sym_BSLASHacl] = ACTIONS(6614),
    [anon_sym_BSLASHAcl] = ACTIONS(6614),
    [anon_sym_BSLASHaclp] = ACTIONS(6614),
    [anon_sym_BSLASHAclp] = ACTIONS(6614),
    [anon_sym_BSLASHacf] = ACTIONS(6614),
    [anon_sym_BSLASHAcf] = ACTIONS(6614),
    [anon_sym_BSLASHacfp] = ACTIONS(6614),
    [anon_sym_BSLASHAcfp] = ACTIONS(6614),
    [anon_sym_BSLASHac] = ACTIONS(6614),
    [anon_sym_BSLASHAc] = ACTIONS(6614),
    [anon_sym_BSLASHacp] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6614),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6614),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6614),
    [anon_sym_BSLASHcolor] = ACTIONS(6614),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6614),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6614),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6614),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6614),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6614),
    [anon_sym_BSLASHtext] = ACTIONS(6614),
    [anon_sym_BSLASHintertext] = ACTIONS(6614),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6614),
    [anon_sym_BSLASHurl] = ACTIONS(6614),
    [anon_sym_BSLASHhref] = ACTIONS(6614),
  },
  [1239] = {
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [1240] = {
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6336),
    [anon_sym_RBRACK] = ACTIONS(6336),
    [anon_sym_COMMA] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_RPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHpart] = ACTIONS(6334),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddpart] = ACTIONS(6334),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHchapter] = ACTIONS(6334),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddchap] = ACTIONS(6334),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsection] = ACTIONS(6334),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddsec] = ACTIONS(6334),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHitem] = ACTIONS(6334),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6336),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6336),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHbegin] = ACTIONS(6334),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHleft] = ACTIONS(6334),
    [anon_sym_BSLASHbigl] = ACTIONS(6334),
    [anon_sym_BSLASHBigl] = ACTIONS(6334),
    [anon_sym_BSLASHbiggl] = ACTIONS(6334),
    [anon_sym_BSLASHBiggl] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHtext] = ACTIONS(6334),
    [anon_sym_BSLASHintertext] = ACTIONS(6334),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [1241] = {
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_LBRACK] = ACTIONS(6500),
    [anon_sym_RBRACK] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [anon_sym_EQ] = ACTIONS(6500),
    [anon_sym_LPAREN] = ACTIONS(6500),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHpart] = ACTIONS(6498),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddpart] = ACTIONS(6498),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHchapter] = ACTIONS(6498),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddchap] = ACTIONS(6498),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsection] = ACTIONS(6498),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHaddsec] = ACTIONS(6498),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6498),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6498),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHitem] = ACTIONS(6498),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6500),
    [anon_sym_LBRACE] = ACTIONS(6500),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6500),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6500),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6500),
    [anon_sym_DOLLAR] = ACTIONS(6498),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHbegin] = ACTIONS(6498),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHleft] = ACTIONS(6498),
    [anon_sym_BSLASHbigl] = ACTIONS(6498),
    [anon_sym_BSLASHBigl] = ACTIONS(6498),
    [anon_sym_BSLASHbiggl] = ACTIONS(6498),
    [anon_sym_BSLASHBiggl] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHtext] = ACTIONS(6498),
    [anon_sym_BSLASHintertext] = ACTIONS(6498),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [1242] = {
    [sym_command_name] = ACTIONS(6618),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(6620),
    [anon_sym_RBRACK] = ACTIONS(6620),
    [anon_sym_COMMA] = ACTIONS(6620),
    [anon_sym_EQ] = ACTIONS(6620),
    [anon_sym_LPAREN] = ACTIONS(6620),
    [anon_sym_RPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHpart] = ACTIONS(6618),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddpart] = ACTIONS(6618),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHchapter] = ACTIONS(6618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddchap] = ACTIONS(6618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsection] = ACTIONS(6618),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddsec] = ACTIONS(6618),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHitem] = ACTIONS(6618),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6620),
    [anon_sym_LBRACE] = ACTIONS(6620),
    [sym_word] = ACTIONS(6618),
    [sym_placeholder] = ACTIONS(6620),
    [anon_sym_PLUS] = ACTIONS(6620),
    [anon_sym_DASH] = ACTIONS(6620),
    [anon_sym_STAR] = ACTIONS(6620),
    [anon_sym_SLASH] = ACTIONS(6620),
    [anon_sym_LT] = ACTIONS(6618),
    [anon_sym_GT] = ACTIONS(6618),
    [anon_sym_BANG] = ACTIONS(6618),
    [anon_sym_PIPE] = ACTIONS(6618),
    [anon_sym_COLON] = ACTIONS(6618),
    [anon_sym_SQUOTE] = ACTIONS(6618),
    [anon_sym__] = ACTIONS(6620),
    [anon_sym_CARET] = ACTIONS(6620),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6620),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6620),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6620),
    [anon_sym_DOLLAR] = ACTIONS(6618),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHbegin] = ACTIONS(6618),
    [anon_sym_BSLASHtitle] = ACTIONS(6618),
    [anon_sym_BSLASHauthor] = ACTIONS(6618),
    [anon_sym_BSLASHusepackage] = ACTIONS(6618),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6618),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6618),
    [anon_sym_BSLASHinclude] = ACTIONS(6618),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6618),
    [anon_sym_BSLASHinput] = ACTIONS(6618),
    [anon_sym_BSLASHsubfile] = ACTIONS(6618),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6618),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6618),
    [anon_sym_BSLASHbibliography] = ACTIONS(6618),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6618),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6618),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6618),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6618),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6618),
    [anon_sym_BSLASHimport] = ACTIONS(6618),
    [anon_sym_BSLASHsubimport] = ACTIONS(6618),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6618),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHcaption] = ACTIONS(6618),
    [anon_sym_BSLASHcite] = ACTIONS(6618),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCite] = ACTIONS(6618),
    [anon_sym_BSLASHnocite] = ACTIONS(6618),
    [anon_sym_BSLASHcitet] = ACTIONS(6618),
    [anon_sym_BSLASHcitep] = ACTIONS(6618),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteA] = ACTIONS(6618),
    [anon_sym_BSLASHciteR] = ACTIONS(6618),
    [anon_sym_BSLASHciteS] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6618),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteyear] = ACTIONS(6618),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitedate] = ACTIONS(6618),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteurl] = ACTIONS(6618),
    [anon_sym_BSLASHfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6618),
    [anon_sym_BSLASHcitealt] = ACTIONS(6618),
    [anon_sym_BSLASHcitealp] = ACTIONS(6618),
    [anon_sym_BSLASHcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHparencite] = ACTIONS(6618),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHParencite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHtextcite] = ACTIONS(6618),
    [anon_sym_BSLASHTextcite] = ACTIONS(6618),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHsupercite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite] = ACTIONS(6618),
    [anon_sym_BSLASHAutocite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHVolcite] = ACTIONS(6618),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHavolcite] = ACTIONS(6618),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHNotecite] = ACTIONS(6618),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHlabel] = ACTIONS(6618),
    [anon_sym_BSLASHref] = ACTIONS(6618),
    [anon_sym_BSLASHeqref] = ACTIONS(6618),
    [anon_sym_BSLASHvref] = ACTIONS(6618),
    [anon_sym_BSLASHVref] = ACTIONS(6618),
    [anon_sym_BSLASHautoref] = ACTIONS(6618),
    [anon_sym_BSLASHpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcref] = ACTIONS(6618),
    [anon_sym_BSLASHCref] = ACTIONS(6618),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnameCref] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHdef] = ACTIONS(6618),
    [anon_sym_BSLASHlet] = ACTIONS(6618),
    [anon_sym_BSLASHleft] = ACTIONS(6618),
    [anon_sym_BSLASHbigl] = ACTIONS(6618),
    [anon_sym_BSLASHBigl] = ACTIONS(6618),
    [anon_sym_BSLASHbiggl] = ACTIONS(6618),
    [anon_sym_BSLASHBiggl] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6618),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6618),
    [anon_sym_BSLASHgls] = ACTIONS(6618),
    [anon_sym_BSLASHGls] = ACTIONS(6618),
    [anon_sym_BSLASHGLS] = ACTIONS(6618),
    [anon_sym_BSLASHglspl] = ACTIONS(6618),
    [anon_sym_BSLASHGlspl] = ACTIONS(6618),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6618),
    [anon_sym_BSLASHglslink] = ACTIONS(6618),
    [anon_sym_BSLASHglstext] = ACTIONS(6618),
    [anon_sym_BSLASHGlstext] = ACTIONS(6618),
    [anon_sym_BSLASHGLStext] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6618),
    [anon_sym_BSLASHglsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsname] = ACTIONS(6618),
    [anon_sym_BSLASHGlsname] = ACTIONS(6618),
    [anon_sym_BSLASHGLSname] = ACTIONS(6618),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6618),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6618),
    [anon_sym_BSLASHacrshort] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6618),
    [anon_sym_BSLASHACRshort] = ACTIONS(6618),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrlong] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6618),
    [anon_sym_BSLASHACRlong] = ACTIONS(6618),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrfull] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6618),
    [anon_sym_BSLASHACRfull] = ACTIONS(6618),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHacs] = ACTIONS(6618),
    [anon_sym_BSLASHAcs] = ACTIONS(6618),
    [anon_sym_BSLASHacsp] = ACTIONS(6618),
    [anon_sym_BSLASHAcsp] = ACTIONS(6618),
    [anon_sym_BSLASHacl] = ACTIONS(6618),
    [anon_sym_BSLASHAcl] = ACTIONS(6618),
    [anon_sym_BSLASHaclp] = ACTIONS(6618),
    [anon_sym_BSLASHAclp] = ACTIONS(6618),
    [anon_sym_BSLASHacf] = ACTIONS(6618),
    [anon_sym_BSLASHAcf] = ACTIONS(6618),
    [anon_sym_BSLASHacfp] = ACTIONS(6618),
    [anon_sym_BSLASHAcfp] = ACTIONS(6618),
    [anon_sym_BSLASHac] = ACTIONS(6618),
    [anon_sym_BSLASHAc] = ACTIONS(6618),
    [anon_sym_BSLASHacp] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6618),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6618),
    [anon_sym_BSLASHcolor] = ACTIONS(6618),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6618),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6618),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6618),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6618),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6618),
    [anon_sym_BSLASHtext] = ACTIONS(6618),
    [anon_sym_BSLASHintertext] = ACTIONS(6618),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6618),
    [anon_sym_BSLASHurl] = ACTIONS(6618),
    [anon_sym_BSLASHhref] = ACTIONS(6618),
  },
  [1243] = {
    [sym_command_name] = ACTIONS(6622),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6622),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_RBRACK] = ACTIONS(6624),
    [anon_sym_COMMA] = ACTIONS(6624),
    [anon_sym_EQ] = ACTIONS(6624),
    [anon_sym_LPAREN] = ACTIONS(6624),
    [anon_sym_RPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHpart] = ACTIONS(6622),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddpart] = ACTIONS(6622),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHchapter] = ACTIONS(6622),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddchap] = ACTIONS(6622),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsection] = ACTIONS(6622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddsec] = ACTIONS(6622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHitem] = ACTIONS(6622),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(6624),
    [sym_word] = ACTIONS(6622),
    [sym_placeholder] = ACTIONS(6624),
    [anon_sym_PLUS] = ACTIONS(6624),
    [anon_sym_DASH] = ACTIONS(6624),
    [anon_sym_STAR] = ACTIONS(6624),
    [anon_sym_SLASH] = ACTIONS(6624),
    [anon_sym_LT] = ACTIONS(6622),
    [anon_sym_GT] = ACTIONS(6622),
    [anon_sym_BANG] = ACTIONS(6622),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_COLON] = ACTIONS(6622),
    [anon_sym_SQUOTE] = ACTIONS(6622),
    [anon_sym__] = ACTIONS(6624),
    [anon_sym_CARET] = ACTIONS(6624),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6624),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6624),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6624),
    [anon_sym_DOLLAR] = ACTIONS(6622),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHbegin] = ACTIONS(6622),
    [anon_sym_BSLASHtitle] = ACTIONS(6622),
    [anon_sym_BSLASHauthor] = ACTIONS(6622),
    [anon_sym_BSLASHusepackage] = ACTIONS(6622),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6622),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6622),
    [anon_sym_BSLASHinclude] = ACTIONS(6622),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6622),
    [anon_sym_BSLASHinput] = ACTIONS(6622),
    [anon_sym_BSLASHsubfile] = ACTIONS(6622),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6622),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6622),
    [anon_sym_BSLASHbibliography] = ACTIONS(6622),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6622),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6622),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6622),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6622),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6622),
    [anon_sym_BSLASHimport] = ACTIONS(6622),
    [anon_sym_BSLASHsubimport] = ACTIONS(6622),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6622),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHcaption] = ACTIONS(6622),
    [anon_sym_BSLASHcite] = ACTIONS(6622),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCite] = ACTIONS(6622),
    [anon_sym_BSLASHnocite] = ACTIONS(6622),
    [anon_sym_BSLASHcitet] = ACTIONS(6622),
    [anon_sym_BSLASHcitep] = ACTIONS(6622),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteA] = ACTIONS(6622),
    [anon_sym_BSLASHciteR] = ACTIONS(6622),
    [anon_sym_BSLASHciteS] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6622),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteyear] = ACTIONS(6622),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitedate] = ACTIONS(6622),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteurl] = ACTIONS(6622),
    [anon_sym_BSLASHfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6622),
    [anon_sym_BSLASHcitealt] = ACTIONS(6622),
    [anon_sym_BSLASHcitealp] = ACTIONS(6622),
    [anon_sym_BSLASHcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHparencite] = ACTIONS(6622),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHParencite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHtextcite] = ACTIONS(6622),
    [anon_sym_BSLASHTextcite] = ACTIONS(6622),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHsupercite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite] = ACTIONS(6622),
    [anon_sym_BSLASHAutocite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHVolcite] = ACTIONS(6622),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHavolcite] = ACTIONS(6622),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHNotecite] = ACTIONS(6622),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHlabel] = ACTIONS(6622),
    [anon_sym_BSLASHref] = ACTIONS(6622),
    [anon_sym_BSLASHeqref] = ACTIONS(6622),
    [anon_sym_BSLASHvref] = ACTIONS(6622),
    [anon_sym_BSLASHVref] = ACTIONS(6622),
    [anon_sym_BSLASHautoref] = ACTIONS(6622),
    [anon_sym_BSLASHpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcref] = ACTIONS(6622),
    [anon_sym_BSLASHCref] = ACTIONS(6622),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnameCref] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHdef] = ACTIONS(6622),
    [anon_sym_BSLASHlet] = ACTIONS(6622),
    [anon_sym_BSLASHleft] = ACTIONS(6622),
    [anon_sym_BSLASHbigl] = ACTIONS(6622),
    [anon_sym_BSLASHBigl] = ACTIONS(6622),
    [anon_sym_BSLASHbiggl] = ACTIONS(6622),
    [anon_sym_BSLASHBiggl] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6622),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6622),
    [anon_sym_BSLASHgls] = ACTIONS(6622),
    [anon_sym_BSLASHGls] = ACTIONS(6622),
    [anon_sym_BSLASHGLS] = ACTIONS(6622),
    [anon_sym_BSLASHglspl] = ACTIONS(6622),
    [anon_sym_BSLASHGlspl] = ACTIONS(6622),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6622),
    [anon_sym_BSLASHglslink] = ACTIONS(6622),
    [anon_sym_BSLASHglstext] = ACTIONS(6622),
    [anon_sym_BSLASHGlstext] = ACTIONS(6622),
    [anon_sym_BSLASHGLStext] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6622),
    [anon_sym_BSLASHglsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsname] = ACTIONS(6622),
    [anon_sym_BSLASHGlsname] = ACTIONS(6622),
    [anon_sym_BSLASHGLSname] = ACTIONS(6622),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6622),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6622),
    [anon_sym_BSLASHacrshort] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6622),
    [anon_sym_BSLASHACRshort] = ACTIONS(6622),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrlong] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6622),
    [anon_sym_BSLASHACRlong] = ACTIONS(6622),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrfull] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6622),
    [anon_sym_BSLASHACRfull] = ACTIONS(6622),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHacs] = ACTIONS(6622),
    [anon_sym_BSLASHAcs] = ACTIONS(6622),
    [anon_sym_BSLASHacsp] = ACTIONS(6622),
    [anon_sym_BSLASHAcsp] = ACTIONS(6622),
    [anon_sym_BSLASHacl] = ACTIONS(6622),
    [anon_sym_BSLASHAcl] = ACTIONS(6622),
    [anon_sym_BSLASHaclp] = ACTIONS(6622),
    [anon_sym_BSLASHAclp] = ACTIONS(6622),
    [anon_sym_BSLASHacf] = ACTIONS(6622),
    [anon_sym_BSLASHAcf] = ACTIONS(6622),
    [anon_sym_BSLASHacfp] = ACTIONS(6622),
    [anon_sym_BSLASHAcfp] = ACTIONS(6622),
    [anon_sym_BSLASHac] = ACTIONS(6622),
    [anon_sym_BSLASHAc] = ACTIONS(6622),
    [anon_sym_BSLASHacp] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6622),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6622),
    [anon_sym_BSLASHcolor] = ACTIONS(6622),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6622),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6622),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6622),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6622),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6622),
    [anon_sym_BSLASHtext] = ACTIONS(6622),
    [anon_sym_BSLASHintertext] = ACTIONS(6622),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6622),
    [anon_sym_BSLASHurl] = ACTIONS(6622),
    [anon_sym_BSLASHhref] = ACTIONS(6622),
  },
  [1244] = {
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHpart] = ACTIONS(6282),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddpart] = ACTIONS(6282),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHchapter] = ACTIONS(6282),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddchap] = ACTIONS(6282),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsection] = ACTIONS(6282),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddsec] = ACTIONS(6282),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHitem] = ACTIONS(6282),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6284),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6284),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6284),
    [anon_sym_DOLLAR] = ACTIONS(6282),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHbegin] = ACTIONS(6282),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHleft] = ACTIONS(6282),
    [anon_sym_BSLASHbigl] = ACTIONS(6282),
    [anon_sym_BSLASHBigl] = ACTIONS(6282),
    [anon_sym_BSLASHbiggl] = ACTIONS(6282),
    [anon_sym_BSLASHBiggl] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHtext] = ACTIONS(6282),
    [anon_sym_BSLASHintertext] = ACTIONS(6282),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [1245] = {
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHpart] = ACTIONS(6502),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddpart] = ACTIONS(6502),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHchapter] = ACTIONS(6502),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddchap] = ACTIONS(6502),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsection] = ACTIONS(6502),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddsec] = ACTIONS(6502),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHitem] = ACTIONS(6502),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6504),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6504),
    [anon_sym_DOLLAR] = ACTIONS(6502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6504),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHbegin] = ACTIONS(6502),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHleft] = ACTIONS(6502),
    [anon_sym_BSLASHbigl] = ACTIONS(6502),
    [anon_sym_BSLASHBigl] = ACTIONS(6502),
    [anon_sym_BSLASHbiggl] = ACTIONS(6502),
    [anon_sym_BSLASHBiggl] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHtext] = ACTIONS(6502),
    [anon_sym_BSLASHintertext] = ACTIONS(6502),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [1246] = {
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6332),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_EQ] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6332),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHpart] = ACTIONS(6330),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddpart] = ACTIONS(6330),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHchapter] = ACTIONS(6330),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddchap] = ACTIONS(6330),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsection] = ACTIONS(6330),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddsec] = ACTIONS(6330),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHitem] = ACTIONS(6330),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6332),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6332),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6330),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHbegin] = ACTIONS(6330),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHleft] = ACTIONS(6330),
    [anon_sym_BSLASHbigl] = ACTIONS(6330),
    [anon_sym_BSLASHBigl] = ACTIONS(6330),
    [anon_sym_BSLASHbiggl] = ACTIONS(6330),
    [anon_sym_BSLASHBiggl] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHtext] = ACTIONS(6330),
    [anon_sym_BSLASHintertext] = ACTIONS(6330),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [1247] = {
    [sym_command_name] = ACTIONS(6658),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6658),
    [anon_sym_LBRACK] = ACTIONS(6660),
    [anon_sym_RBRACK] = ACTIONS(6660),
    [anon_sym_COMMA] = ACTIONS(6660),
    [anon_sym_EQ] = ACTIONS(6660),
    [anon_sym_LPAREN] = ACTIONS(6660),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHpart] = ACTIONS(6658),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddpart] = ACTIONS(6658),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHchapter] = ACTIONS(6658),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddchap] = ACTIONS(6658),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsection] = ACTIONS(6658),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddsec] = ACTIONS(6658),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHitem] = ACTIONS(6658),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6660),
    [anon_sym_LBRACE] = ACTIONS(6660),
    [sym_word] = ACTIONS(6658),
    [sym_placeholder] = ACTIONS(6660),
    [anon_sym_PLUS] = ACTIONS(6660),
    [anon_sym_DASH] = ACTIONS(6660),
    [anon_sym_STAR] = ACTIONS(6660),
    [anon_sym_SLASH] = ACTIONS(6660),
    [anon_sym_LT] = ACTIONS(6658),
    [anon_sym_GT] = ACTIONS(6658),
    [anon_sym_BANG] = ACTIONS(6658),
    [anon_sym_PIPE] = ACTIONS(6658),
    [anon_sym_COLON] = ACTIONS(6658),
    [anon_sym_SQUOTE] = ACTIONS(6658),
    [anon_sym__] = ACTIONS(6660),
    [anon_sym_CARET] = ACTIONS(6660),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6660),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6660),
    [anon_sym_DOLLAR] = ACTIONS(6658),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6660),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHbegin] = ACTIONS(6658),
    [anon_sym_BSLASHtitle] = ACTIONS(6658),
    [anon_sym_BSLASHauthor] = ACTIONS(6658),
    [anon_sym_BSLASHusepackage] = ACTIONS(6658),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6658),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6658),
    [anon_sym_BSLASHinclude] = ACTIONS(6658),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6658),
    [anon_sym_BSLASHinput] = ACTIONS(6658),
    [anon_sym_BSLASHsubfile] = ACTIONS(6658),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6658),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6658),
    [anon_sym_BSLASHbibliography] = ACTIONS(6658),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6658),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6658),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6658),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6658),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6658),
    [anon_sym_BSLASHimport] = ACTIONS(6658),
    [anon_sym_BSLASHsubimport] = ACTIONS(6658),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6658),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHcaption] = ACTIONS(6658),
    [anon_sym_BSLASHcite] = ACTIONS(6658),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCite] = ACTIONS(6658),
    [anon_sym_BSLASHnocite] = ACTIONS(6658),
    [anon_sym_BSLASHcitet] = ACTIONS(6658),
    [anon_sym_BSLASHcitep] = ACTIONS(6658),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteA] = ACTIONS(6658),
    [anon_sym_BSLASHciteR] = ACTIONS(6658),
    [anon_sym_BSLASHciteS] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6658),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteyear] = ACTIONS(6658),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitedate] = ACTIONS(6658),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteurl] = ACTIONS(6658),
    [anon_sym_BSLASHfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6658),
    [anon_sym_BSLASHcitealt] = ACTIONS(6658),
    [anon_sym_BSLASHcitealp] = ACTIONS(6658),
    [anon_sym_BSLASHcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHparencite] = ACTIONS(6658),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHParencite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHtextcite] = ACTIONS(6658),
    [anon_sym_BSLASHTextcite] = ACTIONS(6658),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHsupercite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite] = ACTIONS(6658),
    [anon_sym_BSLASHAutocite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHVolcite] = ACTIONS(6658),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHavolcite] = ACTIONS(6658),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHNotecite] = ACTIONS(6658),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHlabel] = ACTIONS(6658),
    [anon_sym_BSLASHref] = ACTIONS(6658),
    [anon_sym_BSLASHeqref] = ACTIONS(6658),
    [anon_sym_BSLASHvref] = ACTIONS(6658),
    [anon_sym_BSLASHVref] = ACTIONS(6658),
    [anon_sym_BSLASHautoref] = ACTIONS(6658),
    [anon_sym_BSLASHpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcref] = ACTIONS(6658),
    [anon_sym_BSLASHCref] = ACTIONS(6658),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnameCref] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHdef] = ACTIONS(6658),
    [anon_sym_BSLASHlet] = ACTIONS(6658),
    [anon_sym_BSLASHleft] = ACTIONS(6658),
    [anon_sym_BSLASHbigl] = ACTIONS(6658),
    [anon_sym_BSLASHBigl] = ACTIONS(6658),
    [anon_sym_BSLASHbiggl] = ACTIONS(6658),
    [anon_sym_BSLASHBiggl] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6658),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6658),
    [anon_sym_BSLASHgls] = ACTIONS(6658),
    [anon_sym_BSLASHGls] = ACTIONS(6658),
    [anon_sym_BSLASHGLS] = ACTIONS(6658),
    [anon_sym_BSLASHglspl] = ACTIONS(6658),
    [anon_sym_BSLASHGlspl] = ACTIONS(6658),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6658),
    [anon_sym_BSLASHglslink] = ACTIONS(6658),
    [anon_sym_BSLASHglstext] = ACTIONS(6658),
    [anon_sym_BSLASHGlstext] = ACTIONS(6658),
    [anon_sym_BSLASHGLStext] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6658),
    [anon_sym_BSLASHglsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsname] = ACTIONS(6658),
    [anon_sym_BSLASHGlsname] = ACTIONS(6658),
    [anon_sym_BSLASHGLSname] = ACTIONS(6658),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6658),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6658),
    [anon_sym_BSLASHacrshort] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6658),
    [anon_sym_BSLASHACRshort] = ACTIONS(6658),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrlong] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6658),
    [anon_sym_BSLASHACRlong] = ACTIONS(6658),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrfull] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6658),
    [anon_sym_BSLASHACRfull] = ACTIONS(6658),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHacs] = ACTIONS(6658),
    [anon_sym_BSLASHAcs] = ACTIONS(6658),
    [anon_sym_BSLASHacsp] = ACTIONS(6658),
    [anon_sym_BSLASHAcsp] = ACTIONS(6658),
    [anon_sym_BSLASHacl] = ACTIONS(6658),
    [anon_sym_BSLASHAcl] = ACTIONS(6658),
    [anon_sym_BSLASHaclp] = ACTIONS(6658),
    [anon_sym_BSLASHAclp] = ACTIONS(6658),
    [anon_sym_BSLASHacf] = ACTIONS(6658),
    [anon_sym_BSLASHAcf] = ACTIONS(6658),
    [anon_sym_BSLASHacfp] = ACTIONS(6658),
    [anon_sym_BSLASHAcfp] = ACTIONS(6658),
    [anon_sym_BSLASHac] = ACTIONS(6658),
    [anon_sym_BSLASHAc] = ACTIONS(6658),
    [anon_sym_BSLASHacp] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6658),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6658),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6658),
    [anon_sym_BSLASHcolor] = ACTIONS(6658),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6658),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6658),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6658),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6658),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6658),
    [anon_sym_BSLASHtext] = ACTIONS(6658),
    [anon_sym_BSLASHintertext] = ACTIONS(6658),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6658),
    [anon_sym_BSLASHurl] = ACTIONS(6658),
    [anon_sym_BSLASHhref] = ACTIONS(6658),
  },
  [1248] = {
    [sym_command_name] = ACTIONS(6662),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6662),
    [anon_sym_LBRACK] = ACTIONS(6664),
    [anon_sym_RBRACK] = ACTIONS(6664),
    [anon_sym_COMMA] = ACTIONS(6664),
    [anon_sym_EQ] = ACTIONS(6664),
    [anon_sym_LPAREN] = ACTIONS(6664),
    [anon_sym_RPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHpart] = ACTIONS(6662),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddpart] = ACTIONS(6662),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHchapter] = ACTIONS(6662),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddchap] = ACTIONS(6662),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsection] = ACTIONS(6662),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddsec] = ACTIONS(6662),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHitem] = ACTIONS(6662),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6664),
    [anon_sym_LBRACE] = ACTIONS(6664),
    [sym_word] = ACTIONS(6662),
    [sym_placeholder] = ACTIONS(6664),
    [anon_sym_PLUS] = ACTIONS(6664),
    [anon_sym_DASH] = ACTIONS(6664),
    [anon_sym_STAR] = ACTIONS(6664),
    [anon_sym_SLASH] = ACTIONS(6664),
    [anon_sym_LT] = ACTIONS(6662),
    [anon_sym_GT] = ACTIONS(6662),
    [anon_sym_BANG] = ACTIONS(6662),
    [anon_sym_PIPE] = ACTIONS(6662),
    [anon_sym_COLON] = ACTIONS(6662),
    [anon_sym_SQUOTE] = ACTIONS(6662),
    [anon_sym__] = ACTIONS(6664),
    [anon_sym_CARET] = ACTIONS(6664),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6664),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6664),
    [anon_sym_DOLLAR] = ACTIONS(6662),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6664),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHbegin] = ACTIONS(6662),
    [anon_sym_BSLASHtitle] = ACTIONS(6662),
    [anon_sym_BSLASHauthor] = ACTIONS(6662),
    [anon_sym_BSLASHusepackage] = ACTIONS(6662),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6662),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6662),
    [anon_sym_BSLASHinclude] = ACTIONS(6662),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6662),
    [anon_sym_BSLASHinput] = ACTIONS(6662),
    [anon_sym_BSLASHsubfile] = ACTIONS(6662),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6662),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6662),
    [anon_sym_BSLASHbibliography] = ACTIONS(6662),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6662),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6662),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6662),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6662),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6662),
    [anon_sym_BSLASHimport] = ACTIONS(6662),
    [anon_sym_BSLASHsubimport] = ACTIONS(6662),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6662),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHcaption] = ACTIONS(6662),
    [anon_sym_BSLASHcite] = ACTIONS(6662),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCite] = ACTIONS(6662),
    [anon_sym_BSLASHnocite] = ACTIONS(6662),
    [anon_sym_BSLASHcitet] = ACTIONS(6662),
    [anon_sym_BSLASHcitep] = ACTIONS(6662),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteA] = ACTIONS(6662),
    [anon_sym_BSLASHciteR] = ACTIONS(6662),
    [anon_sym_BSLASHciteS] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6662),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteyear] = ACTIONS(6662),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitedate] = ACTIONS(6662),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteurl] = ACTIONS(6662),
    [anon_sym_BSLASHfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6662),
    [anon_sym_BSLASHcitealt] = ACTIONS(6662),
    [anon_sym_BSLASHcitealp] = ACTIONS(6662),
    [anon_sym_BSLASHcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHparencite] = ACTIONS(6662),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHParencite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHtextcite] = ACTIONS(6662),
    [anon_sym_BSLASHTextcite] = ACTIONS(6662),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHsupercite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite] = ACTIONS(6662),
    [anon_sym_BSLASHAutocite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHVolcite] = ACTIONS(6662),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHavolcite] = ACTIONS(6662),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHNotecite] = ACTIONS(6662),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHlabel] = ACTIONS(6662),
    [anon_sym_BSLASHref] = ACTIONS(6662),
    [anon_sym_BSLASHeqref] = ACTIONS(6662),
    [anon_sym_BSLASHvref] = ACTIONS(6662),
    [anon_sym_BSLASHVref] = ACTIONS(6662),
    [anon_sym_BSLASHautoref] = ACTIONS(6662),
    [anon_sym_BSLASHpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcref] = ACTIONS(6662),
    [anon_sym_BSLASHCref] = ACTIONS(6662),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnameCref] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHdef] = ACTIONS(6662),
    [anon_sym_BSLASHlet] = ACTIONS(6662),
    [anon_sym_BSLASHleft] = ACTIONS(6662),
    [anon_sym_BSLASHbigl] = ACTIONS(6662),
    [anon_sym_BSLASHBigl] = ACTIONS(6662),
    [anon_sym_BSLASHbiggl] = ACTIONS(6662),
    [anon_sym_BSLASHBiggl] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6662),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6662),
    [anon_sym_BSLASHgls] = ACTIONS(6662),
    [anon_sym_BSLASHGls] = ACTIONS(6662),
    [anon_sym_BSLASHGLS] = ACTIONS(6662),
    [anon_sym_BSLASHglspl] = ACTIONS(6662),
    [anon_sym_BSLASHGlspl] = ACTIONS(6662),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6662),
    [anon_sym_BSLASHglslink] = ACTIONS(6662),
    [anon_sym_BSLASHglstext] = ACTIONS(6662),
    [anon_sym_BSLASHGlstext] = ACTIONS(6662),
    [anon_sym_BSLASHGLStext] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6662),
    [anon_sym_BSLASHglsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsname] = ACTIONS(6662),
    [anon_sym_BSLASHGlsname] = ACTIONS(6662),
    [anon_sym_BSLASHGLSname] = ACTIONS(6662),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6662),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6662),
    [anon_sym_BSLASHacrshort] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6662),
    [anon_sym_BSLASHACRshort] = ACTIONS(6662),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrlong] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6662),
    [anon_sym_BSLASHACRlong] = ACTIONS(6662),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrfull] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6662),
    [anon_sym_BSLASHACRfull] = ACTIONS(6662),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHacs] = ACTIONS(6662),
    [anon_sym_BSLASHAcs] = ACTIONS(6662),
    [anon_sym_BSLASHacsp] = ACTIONS(6662),
    [anon_sym_BSLASHAcsp] = ACTIONS(6662),
    [anon_sym_BSLASHacl] = ACTIONS(6662),
    [anon_sym_BSLASHAcl] = ACTIONS(6662),
    [anon_sym_BSLASHaclp] = ACTIONS(6662),
    [anon_sym_BSLASHAclp] = ACTIONS(6662),
    [anon_sym_BSLASHacf] = ACTIONS(6662),
    [anon_sym_BSLASHAcf] = ACTIONS(6662),
    [anon_sym_BSLASHacfp] = ACTIONS(6662),
    [anon_sym_BSLASHAcfp] = ACTIONS(6662),
    [anon_sym_BSLASHac] = ACTIONS(6662),
    [anon_sym_BSLASHAc] = ACTIONS(6662),
    [anon_sym_BSLASHacp] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6662),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6662),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6662),
    [anon_sym_BSLASHcolor] = ACTIONS(6662),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6662),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6662),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6662),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6662),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6662),
    [anon_sym_BSLASHtext] = ACTIONS(6662),
    [anon_sym_BSLASHintertext] = ACTIONS(6662),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6662),
    [anon_sym_BSLASHurl] = ACTIONS(6662),
    [anon_sym_BSLASHhref] = ACTIONS(6662),
  },
  [1249] = {
    [sym_command_name] = ACTIONS(6666),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6666),
    [anon_sym_LBRACK] = ACTIONS(6668),
    [anon_sym_RBRACK] = ACTIONS(6668),
    [anon_sym_COMMA] = ACTIONS(6668),
    [anon_sym_EQ] = ACTIONS(6668),
    [anon_sym_LPAREN] = ACTIONS(6668),
    [anon_sym_RPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHpart] = ACTIONS(6666),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddpart] = ACTIONS(6666),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHchapter] = ACTIONS(6666),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddchap] = ACTIONS(6666),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsection] = ACTIONS(6666),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddsec] = ACTIONS(6666),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHitem] = ACTIONS(6666),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6668),
    [anon_sym_LBRACE] = ACTIONS(6668),
    [sym_word] = ACTIONS(6666),
    [sym_placeholder] = ACTIONS(6668),
    [anon_sym_PLUS] = ACTIONS(6668),
    [anon_sym_DASH] = ACTIONS(6668),
    [anon_sym_STAR] = ACTIONS(6668),
    [anon_sym_SLASH] = ACTIONS(6668),
    [anon_sym_LT] = ACTIONS(6666),
    [anon_sym_GT] = ACTIONS(6666),
    [anon_sym_BANG] = ACTIONS(6666),
    [anon_sym_PIPE] = ACTIONS(6666),
    [anon_sym_COLON] = ACTIONS(6666),
    [anon_sym_SQUOTE] = ACTIONS(6666),
    [anon_sym__] = ACTIONS(6668),
    [anon_sym_CARET] = ACTIONS(6668),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6668),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6668),
    [anon_sym_DOLLAR] = ACTIONS(6666),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6668),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHbegin] = ACTIONS(6666),
    [anon_sym_BSLASHtitle] = ACTIONS(6666),
    [anon_sym_BSLASHauthor] = ACTIONS(6666),
    [anon_sym_BSLASHusepackage] = ACTIONS(6666),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6666),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6666),
    [anon_sym_BSLASHinclude] = ACTIONS(6666),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6666),
    [anon_sym_BSLASHinput] = ACTIONS(6666),
    [anon_sym_BSLASHsubfile] = ACTIONS(6666),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6666),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6666),
    [anon_sym_BSLASHbibliography] = ACTIONS(6666),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6666),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6666),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6666),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6666),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6666),
    [anon_sym_BSLASHimport] = ACTIONS(6666),
    [anon_sym_BSLASHsubimport] = ACTIONS(6666),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6666),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHcaption] = ACTIONS(6666),
    [anon_sym_BSLASHcite] = ACTIONS(6666),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCite] = ACTIONS(6666),
    [anon_sym_BSLASHnocite] = ACTIONS(6666),
    [anon_sym_BSLASHcitet] = ACTIONS(6666),
    [anon_sym_BSLASHcitep] = ACTIONS(6666),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteA] = ACTIONS(6666),
    [anon_sym_BSLASHciteR] = ACTIONS(6666),
    [anon_sym_BSLASHciteS] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6666),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteyear] = ACTIONS(6666),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitedate] = ACTIONS(6666),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteurl] = ACTIONS(6666),
    [anon_sym_BSLASHfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6666),
    [anon_sym_BSLASHcitealt] = ACTIONS(6666),
    [anon_sym_BSLASHcitealp] = ACTIONS(6666),
    [anon_sym_BSLASHcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHparencite] = ACTIONS(6666),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHParencite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHtextcite] = ACTIONS(6666),
    [anon_sym_BSLASHTextcite] = ACTIONS(6666),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHsupercite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite] = ACTIONS(6666),
    [anon_sym_BSLASHAutocite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHVolcite] = ACTIONS(6666),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHavolcite] = ACTIONS(6666),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHNotecite] = ACTIONS(6666),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHlabel] = ACTIONS(6666),
    [anon_sym_BSLASHref] = ACTIONS(6666),
    [anon_sym_BSLASHeqref] = ACTIONS(6666),
    [anon_sym_BSLASHvref] = ACTIONS(6666),
    [anon_sym_BSLASHVref] = ACTIONS(6666),
    [anon_sym_BSLASHautoref] = ACTIONS(6666),
    [anon_sym_BSLASHpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcref] = ACTIONS(6666),
    [anon_sym_BSLASHCref] = ACTIONS(6666),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnameCref] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHdef] = ACTIONS(6666),
    [anon_sym_BSLASHlet] = ACTIONS(6666),
    [anon_sym_BSLASHleft] = ACTIONS(6666),
    [anon_sym_BSLASHbigl] = ACTIONS(6666),
    [anon_sym_BSLASHBigl] = ACTIONS(6666),
    [anon_sym_BSLASHbiggl] = ACTIONS(6666),
    [anon_sym_BSLASHBiggl] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6666),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6666),
    [anon_sym_BSLASHgls] = ACTIONS(6666),
    [anon_sym_BSLASHGls] = ACTIONS(6666),
    [anon_sym_BSLASHGLS] = ACTIONS(6666),
    [anon_sym_BSLASHglspl] = ACTIONS(6666),
    [anon_sym_BSLASHGlspl] = ACTIONS(6666),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6666),
    [anon_sym_BSLASHglslink] = ACTIONS(6666),
    [anon_sym_BSLASHglstext] = ACTIONS(6666),
    [anon_sym_BSLASHGlstext] = ACTIONS(6666),
    [anon_sym_BSLASHGLStext] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6666),
    [anon_sym_BSLASHglsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsname] = ACTIONS(6666),
    [anon_sym_BSLASHGlsname] = ACTIONS(6666),
    [anon_sym_BSLASHGLSname] = ACTIONS(6666),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6666),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6666),
    [anon_sym_BSLASHacrshort] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6666),
    [anon_sym_BSLASHACRshort] = ACTIONS(6666),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrlong] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6666),
    [anon_sym_BSLASHACRlong] = ACTIONS(6666),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrfull] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6666),
    [anon_sym_BSLASHACRfull] = ACTIONS(6666),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHacs] = ACTIONS(6666),
    [anon_sym_BSLASHAcs] = ACTIONS(6666),
    [anon_sym_BSLASHacsp] = ACTIONS(6666),
    [anon_sym_BSLASHAcsp] = ACTIONS(6666),
    [anon_sym_BSLASHacl] = ACTIONS(6666),
    [anon_sym_BSLASHAcl] = ACTIONS(6666),
    [anon_sym_BSLASHaclp] = ACTIONS(6666),
    [anon_sym_BSLASHAclp] = ACTIONS(6666),
    [anon_sym_BSLASHacf] = ACTIONS(6666),
    [anon_sym_BSLASHAcf] = ACTIONS(6666),
    [anon_sym_BSLASHacfp] = ACTIONS(6666),
    [anon_sym_BSLASHAcfp] = ACTIONS(6666),
    [anon_sym_BSLASHac] = ACTIONS(6666),
    [anon_sym_BSLASHAc] = ACTIONS(6666),
    [anon_sym_BSLASHacp] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6666),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6666),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6666),
    [anon_sym_BSLASHcolor] = ACTIONS(6666),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6666),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6666),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6666),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6666),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6666),
    [anon_sym_BSLASHtext] = ACTIONS(6666),
    [anon_sym_BSLASHintertext] = ACTIONS(6666),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6666),
    [anon_sym_BSLASHurl] = ACTIONS(6666),
    [anon_sym_BSLASHhref] = ACTIONS(6666),
  },
  [1250] = {
    [sym_command_name] = ACTIONS(6674),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6674),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_RBRACK] = ACTIONS(6676),
    [anon_sym_COMMA] = ACTIONS(6676),
    [anon_sym_EQ] = ACTIONS(6676),
    [anon_sym_LPAREN] = ACTIONS(6676),
    [anon_sym_RPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHpart] = ACTIONS(6674),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddpart] = ACTIONS(6674),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHchapter] = ACTIONS(6674),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddchap] = ACTIONS(6674),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsection] = ACTIONS(6674),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddsec] = ACTIONS(6674),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHitem] = ACTIONS(6674),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(6676),
    [sym_word] = ACTIONS(6674),
    [sym_placeholder] = ACTIONS(6676),
    [anon_sym_PLUS] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6676),
    [anon_sym_STAR] = ACTIONS(6676),
    [anon_sym_SLASH] = ACTIONS(6676),
    [anon_sym_LT] = ACTIONS(6674),
    [anon_sym_GT] = ACTIONS(6674),
    [anon_sym_BANG] = ACTIONS(6674),
    [anon_sym_PIPE] = ACTIONS(6674),
    [anon_sym_COLON] = ACTIONS(6674),
    [anon_sym_SQUOTE] = ACTIONS(6674),
    [anon_sym__] = ACTIONS(6676),
    [anon_sym_CARET] = ACTIONS(6676),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6676),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6676),
    [anon_sym_DOLLAR] = ACTIONS(6674),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6676),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHbegin] = ACTIONS(6674),
    [anon_sym_BSLASHtitle] = ACTIONS(6674),
    [anon_sym_BSLASHauthor] = ACTIONS(6674),
    [anon_sym_BSLASHusepackage] = ACTIONS(6674),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6674),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6674),
    [anon_sym_BSLASHinclude] = ACTIONS(6674),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6674),
    [anon_sym_BSLASHinput] = ACTIONS(6674),
    [anon_sym_BSLASHsubfile] = ACTIONS(6674),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6674),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6674),
    [anon_sym_BSLASHbibliography] = ACTIONS(6674),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6674),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6674),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6674),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6674),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6674),
    [anon_sym_BSLASHimport] = ACTIONS(6674),
    [anon_sym_BSLASHsubimport] = ACTIONS(6674),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6674),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHcaption] = ACTIONS(6674),
    [anon_sym_BSLASHcite] = ACTIONS(6674),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCite] = ACTIONS(6674),
    [anon_sym_BSLASHnocite] = ACTIONS(6674),
    [anon_sym_BSLASHcitet] = ACTIONS(6674),
    [anon_sym_BSLASHcitep] = ACTIONS(6674),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteA] = ACTIONS(6674),
    [anon_sym_BSLASHciteR] = ACTIONS(6674),
    [anon_sym_BSLASHciteS] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6674),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteyear] = ACTIONS(6674),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitedate] = ACTIONS(6674),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteurl] = ACTIONS(6674),
    [anon_sym_BSLASHfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6674),
    [anon_sym_BSLASHcitealt] = ACTIONS(6674),
    [anon_sym_BSLASHcitealp] = ACTIONS(6674),
    [anon_sym_BSLASHcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHparencite] = ACTIONS(6674),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHParencite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHtextcite] = ACTIONS(6674),
    [anon_sym_BSLASHTextcite] = ACTIONS(6674),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHsupercite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite] = ACTIONS(6674),
    [anon_sym_BSLASHAutocite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHVolcite] = ACTIONS(6674),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHavolcite] = ACTIONS(6674),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHNotecite] = ACTIONS(6674),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHlabel] = ACTIONS(6674),
    [anon_sym_BSLASHref] = ACTIONS(6674),
    [anon_sym_BSLASHeqref] = ACTIONS(6674),
    [anon_sym_BSLASHvref] = ACTIONS(6674),
    [anon_sym_BSLASHVref] = ACTIONS(6674),
    [anon_sym_BSLASHautoref] = ACTIONS(6674),
    [anon_sym_BSLASHpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcref] = ACTIONS(6674),
    [anon_sym_BSLASHCref] = ACTIONS(6674),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnameCref] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHdef] = ACTIONS(6674),
    [anon_sym_BSLASHlet] = ACTIONS(6674),
    [anon_sym_BSLASHleft] = ACTIONS(6674),
    [anon_sym_BSLASHbigl] = ACTIONS(6674),
    [anon_sym_BSLASHBigl] = ACTIONS(6674),
    [anon_sym_BSLASHbiggl] = ACTIONS(6674),
    [anon_sym_BSLASHBiggl] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6674),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6674),
    [anon_sym_BSLASHgls] = ACTIONS(6674),
    [anon_sym_BSLASHGls] = ACTIONS(6674),
    [anon_sym_BSLASHGLS] = ACTIONS(6674),
    [anon_sym_BSLASHglspl] = ACTIONS(6674),
    [anon_sym_BSLASHGlspl] = ACTIONS(6674),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6674),
    [anon_sym_BSLASHglslink] = ACTIONS(6674),
    [anon_sym_BSLASHglstext] = ACTIONS(6674),
    [anon_sym_BSLASHGlstext] = ACTIONS(6674),
    [anon_sym_BSLASHGLStext] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6674),
    [anon_sym_BSLASHglsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsname] = ACTIONS(6674),
    [anon_sym_BSLASHGlsname] = ACTIONS(6674),
    [anon_sym_BSLASHGLSname] = ACTIONS(6674),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6674),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6674),
    [anon_sym_BSLASHacrshort] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6674),
    [anon_sym_BSLASHACRshort] = ACTIONS(6674),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrlong] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6674),
    [anon_sym_BSLASHACRlong] = ACTIONS(6674),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrfull] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6674),
    [anon_sym_BSLASHACRfull] = ACTIONS(6674),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHacs] = ACTIONS(6674),
    [anon_sym_BSLASHAcs] = ACTIONS(6674),
    [anon_sym_BSLASHacsp] = ACTIONS(6674),
    [anon_sym_BSLASHAcsp] = ACTIONS(6674),
    [anon_sym_BSLASHacl] = ACTIONS(6674),
    [anon_sym_BSLASHAcl] = ACTIONS(6674),
    [anon_sym_BSLASHaclp] = ACTIONS(6674),
    [anon_sym_BSLASHAclp] = ACTIONS(6674),
    [anon_sym_BSLASHacf] = ACTIONS(6674),
    [anon_sym_BSLASHAcf] = ACTIONS(6674),
    [anon_sym_BSLASHacfp] = ACTIONS(6674),
    [anon_sym_BSLASHAcfp] = ACTIONS(6674),
    [anon_sym_BSLASHac] = ACTIONS(6674),
    [anon_sym_BSLASHAc] = ACTIONS(6674),
    [anon_sym_BSLASHacp] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6674),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6674),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6674),
    [anon_sym_BSLASHcolor] = ACTIONS(6674),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6674),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6674),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6674),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6674),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6674),
    [anon_sym_BSLASHtext] = ACTIONS(6674),
    [anon_sym_BSLASHintertext] = ACTIONS(6674),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6674),
    [anon_sym_BSLASHurl] = ACTIONS(6674),
    [anon_sym_BSLASHhref] = ACTIONS(6674),
  },
  [1251] = {
    [sym_command_name] = ACTIONS(6678),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6678),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6680),
    [anon_sym_COMMA] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LPAREN] = ACTIONS(6680),
    [anon_sym_RPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHpart] = ACTIONS(6678),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddpart] = ACTIONS(6678),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHchapter] = ACTIONS(6678),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddchap] = ACTIONS(6678),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsection] = ACTIONS(6678),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddsec] = ACTIONS(6678),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHitem] = ACTIONS(6678),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6680),
    [anon_sym_LBRACE] = ACTIONS(6680),
    [sym_word] = ACTIONS(6678),
    [sym_placeholder] = ACTIONS(6680),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_DASH] = ACTIONS(6680),
    [anon_sym_STAR] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6678),
    [anon_sym_GT] = ACTIONS(6678),
    [anon_sym_BANG] = ACTIONS(6678),
    [anon_sym_PIPE] = ACTIONS(6678),
    [anon_sym_COLON] = ACTIONS(6678),
    [anon_sym_SQUOTE] = ACTIONS(6678),
    [anon_sym__] = ACTIONS(6680),
    [anon_sym_CARET] = ACTIONS(6680),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6680),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6680),
    [anon_sym_DOLLAR] = ACTIONS(6678),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6680),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHbegin] = ACTIONS(6678),
    [anon_sym_BSLASHtitle] = ACTIONS(6678),
    [anon_sym_BSLASHauthor] = ACTIONS(6678),
    [anon_sym_BSLASHusepackage] = ACTIONS(6678),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6678),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6678),
    [anon_sym_BSLASHinclude] = ACTIONS(6678),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6678),
    [anon_sym_BSLASHinput] = ACTIONS(6678),
    [anon_sym_BSLASHsubfile] = ACTIONS(6678),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6678),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6678),
    [anon_sym_BSLASHbibliography] = ACTIONS(6678),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6678),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6678),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6678),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6678),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6678),
    [anon_sym_BSLASHimport] = ACTIONS(6678),
    [anon_sym_BSLASHsubimport] = ACTIONS(6678),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6678),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHcaption] = ACTIONS(6678),
    [anon_sym_BSLASHcite] = ACTIONS(6678),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCite] = ACTIONS(6678),
    [anon_sym_BSLASHnocite] = ACTIONS(6678),
    [anon_sym_BSLASHcitet] = ACTIONS(6678),
    [anon_sym_BSLASHcitep] = ACTIONS(6678),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteA] = ACTIONS(6678),
    [anon_sym_BSLASHciteR] = ACTIONS(6678),
    [anon_sym_BSLASHciteS] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6678),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteyear] = ACTIONS(6678),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitedate] = ACTIONS(6678),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteurl] = ACTIONS(6678),
    [anon_sym_BSLASHfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6678),
    [anon_sym_BSLASHcitealt] = ACTIONS(6678),
    [anon_sym_BSLASHcitealp] = ACTIONS(6678),
    [anon_sym_BSLASHcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHparencite] = ACTIONS(6678),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHParencite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHtextcite] = ACTIONS(6678),
    [anon_sym_BSLASHTextcite] = ACTIONS(6678),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHsupercite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite] = ACTIONS(6678),
    [anon_sym_BSLASHAutocite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHVolcite] = ACTIONS(6678),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHavolcite] = ACTIONS(6678),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHNotecite] = ACTIONS(6678),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHlabel] = ACTIONS(6678),
    [anon_sym_BSLASHref] = ACTIONS(6678),
    [anon_sym_BSLASHeqref] = ACTIONS(6678),
    [anon_sym_BSLASHvref] = ACTIONS(6678),
    [anon_sym_BSLASHVref] = ACTIONS(6678),
    [anon_sym_BSLASHautoref] = ACTIONS(6678),
    [anon_sym_BSLASHpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcref] = ACTIONS(6678),
    [anon_sym_BSLASHCref] = ACTIONS(6678),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnameCref] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHdef] = ACTIONS(6678),
    [anon_sym_BSLASHlet] = ACTIONS(6678),
    [anon_sym_BSLASHleft] = ACTIONS(6678),
    [anon_sym_BSLASHbigl] = ACTIONS(6678),
    [anon_sym_BSLASHBigl] = ACTIONS(6678),
    [anon_sym_BSLASHbiggl] = ACTIONS(6678),
    [anon_sym_BSLASHBiggl] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6678),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6678),
    [anon_sym_BSLASHgls] = ACTIONS(6678),
    [anon_sym_BSLASHGls] = ACTIONS(6678),
    [anon_sym_BSLASHGLS] = ACTIONS(6678),
    [anon_sym_BSLASHglspl] = ACTIONS(6678),
    [anon_sym_BSLASHGlspl] = ACTIONS(6678),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6678),
    [anon_sym_BSLASHglslink] = ACTIONS(6678),
    [anon_sym_BSLASHglstext] = ACTIONS(6678),
    [anon_sym_BSLASHGlstext] = ACTIONS(6678),
    [anon_sym_BSLASHGLStext] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6678),
    [anon_sym_BSLASHglsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsname] = ACTIONS(6678),
    [anon_sym_BSLASHGlsname] = ACTIONS(6678),
    [anon_sym_BSLASHGLSname] = ACTIONS(6678),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6678),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6678),
    [anon_sym_BSLASHacrshort] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6678),
    [anon_sym_BSLASHACRshort] = ACTIONS(6678),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrlong] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6678),
    [anon_sym_BSLASHACRlong] = ACTIONS(6678),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrfull] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6678),
    [anon_sym_BSLASHACRfull] = ACTIONS(6678),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHacs] = ACTIONS(6678),
    [anon_sym_BSLASHAcs] = ACTIONS(6678),
    [anon_sym_BSLASHacsp] = ACTIONS(6678),
    [anon_sym_BSLASHAcsp] = ACTIONS(6678),
    [anon_sym_BSLASHacl] = ACTIONS(6678),
    [anon_sym_BSLASHAcl] = ACTIONS(6678),
    [anon_sym_BSLASHaclp] = ACTIONS(6678),
    [anon_sym_BSLASHAclp] = ACTIONS(6678),
    [anon_sym_BSLASHacf] = ACTIONS(6678),
    [anon_sym_BSLASHAcf] = ACTIONS(6678),
    [anon_sym_BSLASHacfp] = ACTIONS(6678),
    [anon_sym_BSLASHAcfp] = ACTIONS(6678),
    [anon_sym_BSLASHac] = ACTIONS(6678),
    [anon_sym_BSLASHAc] = ACTIONS(6678),
    [anon_sym_BSLASHacp] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6678),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6678),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6678),
    [anon_sym_BSLASHcolor] = ACTIONS(6678),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6678),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6678),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6678),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6678),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6678),
    [anon_sym_BSLASHtext] = ACTIONS(6678),
    [anon_sym_BSLASHintertext] = ACTIONS(6678),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6678),
    [anon_sym_BSLASHurl] = ACTIONS(6678),
    [anon_sym_BSLASHhref] = ACTIONS(6678),
  },
  [1252] = {
    [sym_command_name] = ACTIONS(6682),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6684),
    [anon_sym_RBRACK] = ACTIONS(6684),
    [anon_sym_COMMA] = ACTIONS(6684),
    [anon_sym_EQ] = ACTIONS(6684),
    [anon_sym_LPAREN] = ACTIONS(6684),
    [anon_sym_RPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHpart] = ACTIONS(6682),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddpart] = ACTIONS(6682),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHchapter] = ACTIONS(6682),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddchap] = ACTIONS(6682),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsection] = ACTIONS(6682),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddsec] = ACTIONS(6682),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHitem] = ACTIONS(6682),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6684),
    [anon_sym_LBRACE] = ACTIONS(6684),
    [sym_word] = ACTIONS(6682),
    [sym_placeholder] = ACTIONS(6684),
    [anon_sym_PLUS] = ACTIONS(6684),
    [anon_sym_DASH] = ACTIONS(6684),
    [anon_sym_STAR] = ACTIONS(6684),
    [anon_sym_SLASH] = ACTIONS(6684),
    [anon_sym_LT] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6682),
    [anon_sym_BANG] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6682),
    [anon_sym_COLON] = ACTIONS(6682),
    [anon_sym_SQUOTE] = ACTIONS(6682),
    [anon_sym__] = ACTIONS(6684),
    [anon_sym_CARET] = ACTIONS(6684),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6684),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6684),
    [anon_sym_DOLLAR] = ACTIONS(6682),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6684),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHbegin] = ACTIONS(6682),
    [anon_sym_BSLASHtitle] = ACTIONS(6682),
    [anon_sym_BSLASHauthor] = ACTIONS(6682),
    [anon_sym_BSLASHusepackage] = ACTIONS(6682),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6682),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6682),
    [anon_sym_BSLASHinclude] = ACTIONS(6682),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6682),
    [anon_sym_BSLASHinput] = ACTIONS(6682),
    [anon_sym_BSLASHsubfile] = ACTIONS(6682),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6682),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6682),
    [anon_sym_BSLASHbibliography] = ACTIONS(6682),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6682),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6682),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6682),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6682),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6682),
    [anon_sym_BSLASHimport] = ACTIONS(6682),
    [anon_sym_BSLASHsubimport] = ACTIONS(6682),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6682),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHcaption] = ACTIONS(6682),
    [anon_sym_BSLASHcite] = ACTIONS(6682),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCite] = ACTIONS(6682),
    [anon_sym_BSLASHnocite] = ACTIONS(6682),
    [anon_sym_BSLASHcitet] = ACTIONS(6682),
    [anon_sym_BSLASHcitep] = ACTIONS(6682),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteA] = ACTIONS(6682),
    [anon_sym_BSLASHciteR] = ACTIONS(6682),
    [anon_sym_BSLASHciteS] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6682),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteyear] = ACTIONS(6682),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitedate] = ACTIONS(6682),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteurl] = ACTIONS(6682),
    [anon_sym_BSLASHfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6682),
    [anon_sym_BSLASHcitealt] = ACTIONS(6682),
    [anon_sym_BSLASHcitealp] = ACTIONS(6682),
    [anon_sym_BSLASHcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHparencite] = ACTIONS(6682),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHParencite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHtextcite] = ACTIONS(6682),
    [anon_sym_BSLASHTextcite] = ACTIONS(6682),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHsupercite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite] = ACTIONS(6682),
    [anon_sym_BSLASHAutocite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHVolcite] = ACTIONS(6682),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHavolcite] = ACTIONS(6682),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHNotecite] = ACTIONS(6682),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHlabel] = ACTIONS(6682),
    [anon_sym_BSLASHref] = ACTIONS(6682),
    [anon_sym_BSLASHeqref] = ACTIONS(6682),
    [anon_sym_BSLASHvref] = ACTIONS(6682),
    [anon_sym_BSLASHVref] = ACTIONS(6682),
    [anon_sym_BSLASHautoref] = ACTIONS(6682),
    [anon_sym_BSLASHpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcref] = ACTIONS(6682),
    [anon_sym_BSLASHCref] = ACTIONS(6682),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnameCref] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHdef] = ACTIONS(6682),
    [anon_sym_BSLASHlet] = ACTIONS(6682),
    [anon_sym_BSLASHleft] = ACTIONS(6682),
    [anon_sym_BSLASHbigl] = ACTIONS(6682),
    [anon_sym_BSLASHBigl] = ACTIONS(6682),
    [anon_sym_BSLASHbiggl] = ACTIONS(6682),
    [anon_sym_BSLASHBiggl] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6682),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6682),
    [anon_sym_BSLASHgls] = ACTIONS(6682),
    [anon_sym_BSLASHGls] = ACTIONS(6682),
    [anon_sym_BSLASHGLS] = ACTIONS(6682),
    [anon_sym_BSLASHglspl] = ACTIONS(6682),
    [anon_sym_BSLASHGlspl] = ACTIONS(6682),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6682),
    [anon_sym_BSLASHglslink] = ACTIONS(6682),
    [anon_sym_BSLASHglstext] = ACTIONS(6682),
    [anon_sym_BSLASHGlstext] = ACTIONS(6682),
    [anon_sym_BSLASHGLStext] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6682),
    [anon_sym_BSLASHglsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsname] = ACTIONS(6682),
    [anon_sym_BSLASHGlsname] = ACTIONS(6682),
    [anon_sym_BSLASHGLSname] = ACTIONS(6682),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6682),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6682),
    [anon_sym_BSLASHacrshort] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6682),
    [anon_sym_BSLASHACRshort] = ACTIONS(6682),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrlong] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6682),
    [anon_sym_BSLASHACRlong] = ACTIONS(6682),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrfull] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6682),
    [anon_sym_BSLASHACRfull] = ACTIONS(6682),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHacs] = ACTIONS(6682),
    [anon_sym_BSLASHAcs] = ACTIONS(6682),
    [anon_sym_BSLASHacsp] = ACTIONS(6682),
    [anon_sym_BSLASHAcsp] = ACTIONS(6682),
    [anon_sym_BSLASHacl] = ACTIONS(6682),
    [anon_sym_BSLASHAcl] = ACTIONS(6682),
    [anon_sym_BSLASHaclp] = ACTIONS(6682),
    [anon_sym_BSLASHAclp] = ACTIONS(6682),
    [anon_sym_BSLASHacf] = ACTIONS(6682),
    [anon_sym_BSLASHAcf] = ACTIONS(6682),
    [anon_sym_BSLASHacfp] = ACTIONS(6682),
    [anon_sym_BSLASHAcfp] = ACTIONS(6682),
    [anon_sym_BSLASHac] = ACTIONS(6682),
    [anon_sym_BSLASHAc] = ACTIONS(6682),
    [anon_sym_BSLASHacp] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6682),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6682),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6682),
    [anon_sym_BSLASHcolor] = ACTIONS(6682),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6682),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6682),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6682),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6682),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6682),
    [anon_sym_BSLASHtext] = ACTIONS(6682),
    [anon_sym_BSLASHintertext] = ACTIONS(6682),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6682),
    [anon_sym_BSLASHurl] = ACTIONS(6682),
    [anon_sym_BSLASHhref] = ACTIONS(6682),
  },
  [1253] = {
    [sym_command_name] = ACTIONS(6710),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(6712),
    [anon_sym_RBRACK] = ACTIONS(6712),
    [anon_sym_COMMA] = ACTIONS(6712),
    [anon_sym_EQ] = ACTIONS(6712),
    [anon_sym_LPAREN] = ACTIONS(6712),
    [anon_sym_RPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHpart] = ACTIONS(6710),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddpart] = ACTIONS(6710),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHchapter] = ACTIONS(6710),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddchap] = ACTIONS(6710),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsection] = ACTIONS(6710),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddsec] = ACTIONS(6710),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHitem] = ACTIONS(6710),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6712),
    [anon_sym_LBRACE] = ACTIONS(6712),
    [sym_word] = ACTIONS(6710),
    [sym_placeholder] = ACTIONS(6712),
    [anon_sym_PLUS] = ACTIONS(6712),
    [anon_sym_DASH] = ACTIONS(6712),
    [anon_sym_STAR] = ACTIONS(6712),
    [anon_sym_SLASH] = ACTIONS(6712),
    [anon_sym_LT] = ACTIONS(6710),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_PIPE] = ACTIONS(6710),
    [anon_sym_COLON] = ACTIONS(6710),
    [anon_sym_SQUOTE] = ACTIONS(6710),
    [anon_sym__] = ACTIONS(6712),
    [anon_sym_CARET] = ACTIONS(6712),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6712),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6712),
    [anon_sym_DOLLAR] = ACTIONS(6710),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6712),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHbegin] = ACTIONS(6710),
    [anon_sym_BSLASHtitle] = ACTIONS(6710),
    [anon_sym_BSLASHauthor] = ACTIONS(6710),
    [anon_sym_BSLASHusepackage] = ACTIONS(6710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6710),
    [anon_sym_BSLASHinclude] = ACTIONS(6710),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6710),
    [anon_sym_BSLASHinput] = ACTIONS(6710),
    [anon_sym_BSLASHsubfile] = ACTIONS(6710),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6710),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6710),
    [anon_sym_BSLASHbibliography] = ACTIONS(6710),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6710),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6710),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6710),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6710),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6710),
    [anon_sym_BSLASHimport] = ACTIONS(6710),
    [anon_sym_BSLASHsubimport] = ACTIONS(6710),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6710),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHcaption] = ACTIONS(6710),
    [anon_sym_BSLASHcite] = ACTIONS(6710),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCite] = ACTIONS(6710),
    [anon_sym_BSLASHnocite] = ACTIONS(6710),
    [anon_sym_BSLASHcitet] = ACTIONS(6710),
    [anon_sym_BSLASHcitep] = ACTIONS(6710),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteA] = ACTIONS(6710),
    [anon_sym_BSLASHciteR] = ACTIONS(6710),
    [anon_sym_BSLASHciteS] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6710),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteyear] = ACTIONS(6710),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitedate] = ACTIONS(6710),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteurl] = ACTIONS(6710),
    [anon_sym_BSLASHfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6710),
    [anon_sym_BSLASHcitealt] = ACTIONS(6710),
    [anon_sym_BSLASHcitealp] = ACTIONS(6710),
    [anon_sym_BSLASHcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHparencite] = ACTIONS(6710),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHParencite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHtextcite] = ACTIONS(6710),
    [anon_sym_BSLASHTextcite] = ACTIONS(6710),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHsupercite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite] = ACTIONS(6710),
    [anon_sym_BSLASHAutocite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHVolcite] = ACTIONS(6710),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHavolcite] = ACTIONS(6710),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHNotecite] = ACTIONS(6710),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHlabel] = ACTIONS(6710),
    [anon_sym_BSLASHref] = ACTIONS(6710),
    [anon_sym_BSLASHeqref] = ACTIONS(6710),
    [anon_sym_BSLASHvref] = ACTIONS(6710),
    [anon_sym_BSLASHVref] = ACTIONS(6710),
    [anon_sym_BSLASHautoref] = ACTIONS(6710),
    [anon_sym_BSLASHpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcref] = ACTIONS(6710),
    [anon_sym_BSLASHCref] = ACTIONS(6710),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnameCref] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHdef] = ACTIONS(6710),
    [anon_sym_BSLASHlet] = ACTIONS(6710),
    [anon_sym_BSLASHleft] = ACTIONS(6710),
    [anon_sym_BSLASHbigl] = ACTIONS(6710),
    [anon_sym_BSLASHBigl] = ACTIONS(6710),
    [anon_sym_BSLASHbiggl] = ACTIONS(6710),
    [anon_sym_BSLASHBiggl] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6710),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6710),
    [anon_sym_BSLASHgls] = ACTIONS(6710),
    [anon_sym_BSLASHGls] = ACTIONS(6710),
    [anon_sym_BSLASHGLS] = ACTIONS(6710),
    [anon_sym_BSLASHglspl] = ACTIONS(6710),
    [anon_sym_BSLASHGlspl] = ACTIONS(6710),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6710),
    [anon_sym_BSLASHglslink] = ACTIONS(6710),
    [anon_sym_BSLASHglstext] = ACTIONS(6710),
    [anon_sym_BSLASHGlstext] = ACTIONS(6710),
    [anon_sym_BSLASHGLStext] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6710),
    [anon_sym_BSLASHglsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsname] = ACTIONS(6710),
    [anon_sym_BSLASHGlsname] = ACTIONS(6710),
    [anon_sym_BSLASHGLSname] = ACTIONS(6710),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6710),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6710),
    [anon_sym_BSLASHacrshort] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6710),
    [anon_sym_BSLASHACRshort] = ACTIONS(6710),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrlong] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6710),
    [anon_sym_BSLASHACRlong] = ACTIONS(6710),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrfull] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6710),
    [anon_sym_BSLASHACRfull] = ACTIONS(6710),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHacs] = ACTIONS(6710),
    [anon_sym_BSLASHAcs] = ACTIONS(6710),
    [anon_sym_BSLASHacsp] = ACTIONS(6710),
    [anon_sym_BSLASHAcsp] = ACTIONS(6710),
    [anon_sym_BSLASHacl] = ACTIONS(6710),
    [anon_sym_BSLASHAcl] = ACTIONS(6710),
    [anon_sym_BSLASHaclp] = ACTIONS(6710),
    [anon_sym_BSLASHAclp] = ACTIONS(6710),
    [anon_sym_BSLASHacf] = ACTIONS(6710),
    [anon_sym_BSLASHAcf] = ACTIONS(6710),
    [anon_sym_BSLASHacfp] = ACTIONS(6710),
    [anon_sym_BSLASHAcfp] = ACTIONS(6710),
    [anon_sym_BSLASHac] = ACTIONS(6710),
    [anon_sym_BSLASHAc] = ACTIONS(6710),
    [anon_sym_BSLASHacp] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6710),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6710),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6710),
    [anon_sym_BSLASHcolor] = ACTIONS(6710),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6710),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6710),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6710),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6710),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6710),
    [anon_sym_BSLASHtext] = ACTIONS(6710),
    [anon_sym_BSLASHintertext] = ACTIONS(6710),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6710),
    [anon_sym_BSLASHurl] = ACTIONS(6710),
    [anon_sym_BSLASHhref] = ACTIONS(6710),
  },
  [1254] = {
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_COMMA] = ACTIONS(6268),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_LPAREN] = ACTIONS(6268),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHpart] = ACTIONS(6266),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddpart] = ACTIONS(6266),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHchapter] = ACTIONS(6266),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddchap] = ACTIONS(6266),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsection] = ACTIONS(6266),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddsec] = ACTIONS(6266),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHitem] = ACTIONS(6266),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6268),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(6266),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6268),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHbegin] = ACTIONS(6266),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHleft] = ACTIONS(6266),
    [anon_sym_BSLASHbigl] = ACTIONS(6266),
    [anon_sym_BSLASHBigl] = ACTIONS(6266),
    [anon_sym_BSLASHbiggl] = ACTIONS(6266),
    [anon_sym_BSLASHBiggl] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHtext] = ACTIONS(6266),
    [anon_sym_BSLASHintertext] = ACTIONS(6266),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [1255] = {
    [sym_command_name] = ACTIONS(6718),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6718),
    [anon_sym_LBRACK] = ACTIONS(6720),
    [anon_sym_RBRACK] = ACTIONS(6720),
    [anon_sym_COMMA] = ACTIONS(6720),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_LPAREN] = ACTIONS(6720),
    [anon_sym_RPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHpart] = ACTIONS(6718),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddpart] = ACTIONS(6718),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHchapter] = ACTIONS(6718),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddchap] = ACTIONS(6718),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsection] = ACTIONS(6718),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddsec] = ACTIONS(6718),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHitem] = ACTIONS(6718),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6720),
    [anon_sym_LBRACE] = ACTIONS(6720),
    [sym_word] = ACTIONS(6718),
    [sym_placeholder] = ACTIONS(6720),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_LT] = ACTIONS(6718),
    [anon_sym_GT] = ACTIONS(6718),
    [anon_sym_BANG] = ACTIONS(6718),
    [anon_sym_PIPE] = ACTIONS(6718),
    [anon_sym_COLON] = ACTIONS(6718),
    [anon_sym_SQUOTE] = ACTIONS(6718),
    [anon_sym__] = ACTIONS(6720),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6720),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6720),
    [anon_sym_DOLLAR] = ACTIONS(6718),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6720),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHbegin] = ACTIONS(6718),
    [anon_sym_BSLASHtitle] = ACTIONS(6718),
    [anon_sym_BSLASHauthor] = ACTIONS(6718),
    [anon_sym_BSLASHusepackage] = ACTIONS(6718),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6718),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6718),
    [anon_sym_BSLASHinclude] = ACTIONS(6718),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6718),
    [anon_sym_BSLASHinput] = ACTIONS(6718),
    [anon_sym_BSLASHsubfile] = ACTIONS(6718),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6718),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6718),
    [anon_sym_BSLASHbibliography] = ACTIONS(6718),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6718),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6718),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6718),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6718),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6718),
    [anon_sym_BSLASHimport] = ACTIONS(6718),
    [anon_sym_BSLASHsubimport] = ACTIONS(6718),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6718),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHcaption] = ACTIONS(6718),
    [anon_sym_BSLASHcite] = ACTIONS(6718),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCite] = ACTIONS(6718),
    [anon_sym_BSLASHnocite] = ACTIONS(6718),
    [anon_sym_BSLASHcitet] = ACTIONS(6718),
    [anon_sym_BSLASHcitep] = ACTIONS(6718),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteA] = ACTIONS(6718),
    [anon_sym_BSLASHciteR] = ACTIONS(6718),
    [anon_sym_BSLASHciteS] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6718),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteyear] = ACTIONS(6718),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitedate] = ACTIONS(6718),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteurl] = ACTIONS(6718),
    [anon_sym_BSLASHfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6718),
    [anon_sym_BSLASHcitealt] = ACTIONS(6718),
    [anon_sym_BSLASHcitealp] = ACTIONS(6718),
    [anon_sym_BSLASHcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHparencite] = ACTIONS(6718),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHParencite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHtextcite] = ACTIONS(6718),
    [anon_sym_BSLASHTextcite] = ACTIONS(6718),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHsupercite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite] = ACTIONS(6718),
    [anon_sym_BSLASHAutocite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHVolcite] = ACTIONS(6718),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHavolcite] = ACTIONS(6718),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHNotecite] = ACTIONS(6718),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHlabel] = ACTIONS(6718),
    [anon_sym_BSLASHref] = ACTIONS(6718),
    [anon_sym_BSLASHeqref] = ACTIONS(6718),
    [anon_sym_BSLASHvref] = ACTIONS(6718),
    [anon_sym_BSLASHVref] = ACTIONS(6718),
    [anon_sym_BSLASHautoref] = ACTIONS(6718),
    [anon_sym_BSLASHpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcref] = ACTIONS(6718),
    [anon_sym_BSLASHCref] = ACTIONS(6718),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnameCref] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHdef] = ACTIONS(6718),
    [anon_sym_BSLASHlet] = ACTIONS(6718),
    [anon_sym_BSLASHleft] = ACTIONS(6718),
    [anon_sym_BSLASHbigl] = ACTIONS(6718),
    [anon_sym_BSLASHBigl] = ACTIONS(6718),
    [anon_sym_BSLASHbiggl] = ACTIONS(6718),
    [anon_sym_BSLASHBiggl] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6718),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6718),
    [anon_sym_BSLASHgls] = ACTIONS(6718),
    [anon_sym_BSLASHGls] = ACTIONS(6718),
    [anon_sym_BSLASHGLS] = ACTIONS(6718),
    [anon_sym_BSLASHglspl] = ACTIONS(6718),
    [anon_sym_BSLASHGlspl] = ACTIONS(6718),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6718),
    [anon_sym_BSLASHglslink] = ACTIONS(6718),
    [anon_sym_BSLASHglstext] = ACTIONS(6718),
    [anon_sym_BSLASHGlstext] = ACTIONS(6718),
    [anon_sym_BSLASHGLStext] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6718),
    [anon_sym_BSLASHglsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsname] = ACTIONS(6718),
    [anon_sym_BSLASHGlsname] = ACTIONS(6718),
    [anon_sym_BSLASHGLSname] = ACTIONS(6718),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6718),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6718),
    [anon_sym_BSLASHacrshort] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6718),
    [anon_sym_BSLASHACRshort] = ACTIONS(6718),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrlong] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6718),
    [anon_sym_BSLASHACRlong] = ACTIONS(6718),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrfull] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6718),
    [anon_sym_BSLASHACRfull] = ACTIONS(6718),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHacs] = ACTIONS(6718),
    [anon_sym_BSLASHAcs] = ACTIONS(6718),
    [anon_sym_BSLASHacsp] = ACTIONS(6718),
    [anon_sym_BSLASHAcsp] = ACTIONS(6718),
    [anon_sym_BSLASHacl] = ACTIONS(6718),
    [anon_sym_BSLASHAcl] = ACTIONS(6718),
    [anon_sym_BSLASHaclp] = ACTIONS(6718),
    [anon_sym_BSLASHAclp] = ACTIONS(6718),
    [anon_sym_BSLASHacf] = ACTIONS(6718),
    [anon_sym_BSLASHAcf] = ACTIONS(6718),
    [anon_sym_BSLASHacfp] = ACTIONS(6718),
    [anon_sym_BSLASHAcfp] = ACTIONS(6718),
    [anon_sym_BSLASHac] = ACTIONS(6718),
    [anon_sym_BSLASHAc] = ACTIONS(6718),
    [anon_sym_BSLASHacp] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6718),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6718),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6718),
    [anon_sym_BSLASHcolor] = ACTIONS(6718),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6718),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6718),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6718),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6718),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6718),
    [anon_sym_BSLASHtext] = ACTIONS(6718),
    [anon_sym_BSLASHintertext] = ACTIONS(6718),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6718),
    [anon_sym_BSLASHurl] = ACTIONS(6718),
    [anon_sym_BSLASHhref] = ACTIONS(6718),
  },
  [1256] = {
    [sym_command_name] = ACTIONS(6722),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6722),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_RBRACK] = ACTIONS(6724),
    [anon_sym_COMMA] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6724),
    [anon_sym_LPAREN] = ACTIONS(6724),
    [anon_sym_RPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHpart] = ACTIONS(6722),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddpart] = ACTIONS(6722),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHchapter] = ACTIONS(6722),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddchap] = ACTIONS(6722),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsection] = ACTIONS(6722),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddsec] = ACTIONS(6722),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHitem] = ACTIONS(6722),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(6724),
    [sym_word] = ACTIONS(6722),
    [sym_placeholder] = ACTIONS(6724),
    [anon_sym_PLUS] = ACTIONS(6724),
    [anon_sym_DASH] = ACTIONS(6724),
    [anon_sym_STAR] = ACTIONS(6724),
    [anon_sym_SLASH] = ACTIONS(6724),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_BANG] = ACTIONS(6722),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_COLON] = ACTIONS(6722),
    [anon_sym_SQUOTE] = ACTIONS(6722),
    [anon_sym__] = ACTIONS(6724),
    [anon_sym_CARET] = ACTIONS(6724),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6724),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6724),
    [anon_sym_DOLLAR] = ACTIONS(6722),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6724),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHbegin] = ACTIONS(6722),
    [anon_sym_BSLASHtitle] = ACTIONS(6722),
    [anon_sym_BSLASHauthor] = ACTIONS(6722),
    [anon_sym_BSLASHusepackage] = ACTIONS(6722),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6722),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6722),
    [anon_sym_BSLASHinclude] = ACTIONS(6722),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6722),
    [anon_sym_BSLASHinput] = ACTIONS(6722),
    [anon_sym_BSLASHsubfile] = ACTIONS(6722),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6722),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6722),
    [anon_sym_BSLASHbibliography] = ACTIONS(6722),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6722),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6722),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6722),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6722),
    [anon_sym_BSLASHimport] = ACTIONS(6722),
    [anon_sym_BSLASHsubimport] = ACTIONS(6722),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6722),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHcaption] = ACTIONS(6722),
    [anon_sym_BSLASHcite] = ACTIONS(6722),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCite] = ACTIONS(6722),
    [anon_sym_BSLASHnocite] = ACTIONS(6722),
    [anon_sym_BSLASHcitet] = ACTIONS(6722),
    [anon_sym_BSLASHcitep] = ACTIONS(6722),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteA] = ACTIONS(6722),
    [anon_sym_BSLASHciteR] = ACTIONS(6722),
    [anon_sym_BSLASHciteS] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6722),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteyear] = ACTIONS(6722),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitedate] = ACTIONS(6722),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteurl] = ACTIONS(6722),
    [anon_sym_BSLASHfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6722),
    [anon_sym_BSLASHcitealt] = ACTIONS(6722),
    [anon_sym_BSLASHcitealp] = ACTIONS(6722),
    [anon_sym_BSLASHcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHparencite] = ACTIONS(6722),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHParencite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHtextcite] = ACTIONS(6722),
    [anon_sym_BSLASHTextcite] = ACTIONS(6722),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHsupercite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite] = ACTIONS(6722),
    [anon_sym_BSLASHAutocite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHVolcite] = ACTIONS(6722),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHavolcite] = ACTIONS(6722),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHNotecite] = ACTIONS(6722),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHlabel] = ACTIONS(6722),
    [anon_sym_BSLASHref] = ACTIONS(6722),
    [anon_sym_BSLASHeqref] = ACTIONS(6722),
    [anon_sym_BSLASHvref] = ACTIONS(6722),
    [anon_sym_BSLASHVref] = ACTIONS(6722),
    [anon_sym_BSLASHautoref] = ACTIONS(6722),
    [anon_sym_BSLASHpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcref] = ACTIONS(6722),
    [anon_sym_BSLASHCref] = ACTIONS(6722),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnameCref] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHdef] = ACTIONS(6722),
    [anon_sym_BSLASHlet] = ACTIONS(6722),
    [anon_sym_BSLASHleft] = ACTIONS(6722),
    [anon_sym_BSLASHbigl] = ACTIONS(6722),
    [anon_sym_BSLASHBigl] = ACTIONS(6722),
    [anon_sym_BSLASHbiggl] = ACTIONS(6722),
    [anon_sym_BSLASHBiggl] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6722),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6722),
    [anon_sym_BSLASHgls] = ACTIONS(6722),
    [anon_sym_BSLASHGls] = ACTIONS(6722),
    [anon_sym_BSLASHGLS] = ACTIONS(6722),
    [anon_sym_BSLASHglspl] = ACTIONS(6722),
    [anon_sym_BSLASHGlspl] = ACTIONS(6722),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6722),
    [anon_sym_BSLASHglslink] = ACTIONS(6722),
    [anon_sym_BSLASHglstext] = ACTIONS(6722),
    [anon_sym_BSLASHGlstext] = ACTIONS(6722),
    [anon_sym_BSLASHGLStext] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6722),
    [anon_sym_BSLASHglsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsname] = ACTIONS(6722),
    [anon_sym_BSLASHGlsname] = ACTIONS(6722),
    [anon_sym_BSLASHGLSname] = ACTIONS(6722),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6722),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6722),
    [anon_sym_BSLASHacrshort] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6722),
    [anon_sym_BSLASHACRshort] = ACTIONS(6722),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrlong] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6722),
    [anon_sym_BSLASHACRlong] = ACTIONS(6722),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrfull] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6722),
    [anon_sym_BSLASHACRfull] = ACTIONS(6722),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHacs] = ACTIONS(6722),
    [anon_sym_BSLASHAcs] = ACTIONS(6722),
    [anon_sym_BSLASHacsp] = ACTIONS(6722),
    [anon_sym_BSLASHAcsp] = ACTIONS(6722),
    [anon_sym_BSLASHacl] = ACTIONS(6722),
    [anon_sym_BSLASHAcl] = ACTIONS(6722),
    [anon_sym_BSLASHaclp] = ACTIONS(6722),
    [anon_sym_BSLASHAclp] = ACTIONS(6722),
    [anon_sym_BSLASHacf] = ACTIONS(6722),
    [anon_sym_BSLASHAcf] = ACTIONS(6722),
    [anon_sym_BSLASHacfp] = ACTIONS(6722),
    [anon_sym_BSLASHAcfp] = ACTIONS(6722),
    [anon_sym_BSLASHac] = ACTIONS(6722),
    [anon_sym_BSLASHAc] = ACTIONS(6722),
    [anon_sym_BSLASHacp] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6722),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6722),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6722),
    [anon_sym_BSLASHcolor] = ACTIONS(6722),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6722),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6722),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6722),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6722),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6722),
    [anon_sym_BSLASHtext] = ACTIONS(6722),
    [anon_sym_BSLASHintertext] = ACTIONS(6722),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6722),
    [anon_sym_BSLASHurl] = ACTIONS(6722),
    [anon_sym_BSLASHhref] = ACTIONS(6722),
  },
  [1257] = {
    [sym_command_name] = ACTIONS(6726),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6726),
    [anon_sym_LBRACK] = ACTIONS(6728),
    [anon_sym_RBRACK] = ACTIONS(6728),
    [anon_sym_COMMA] = ACTIONS(6728),
    [anon_sym_EQ] = ACTIONS(6728),
    [anon_sym_LPAREN] = ACTIONS(6728),
    [anon_sym_RPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHpart] = ACTIONS(6726),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddpart] = ACTIONS(6726),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHchapter] = ACTIONS(6726),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddchap] = ACTIONS(6726),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsection] = ACTIONS(6726),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddsec] = ACTIONS(6726),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHitem] = ACTIONS(6726),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6728),
    [anon_sym_LBRACE] = ACTIONS(6728),
    [sym_word] = ACTIONS(6726),
    [sym_placeholder] = ACTIONS(6728),
    [anon_sym_PLUS] = ACTIONS(6728),
    [anon_sym_DASH] = ACTIONS(6728),
    [anon_sym_STAR] = ACTIONS(6728),
    [anon_sym_SLASH] = ACTIONS(6728),
    [anon_sym_LT] = ACTIONS(6726),
    [anon_sym_GT] = ACTIONS(6726),
    [anon_sym_BANG] = ACTIONS(6726),
    [anon_sym_PIPE] = ACTIONS(6726),
    [anon_sym_COLON] = ACTIONS(6726),
    [anon_sym_SQUOTE] = ACTIONS(6726),
    [anon_sym__] = ACTIONS(6728),
    [anon_sym_CARET] = ACTIONS(6728),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6728),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6728),
    [anon_sym_DOLLAR] = ACTIONS(6726),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6728),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHbegin] = ACTIONS(6726),
    [anon_sym_BSLASHtitle] = ACTIONS(6726),
    [anon_sym_BSLASHauthor] = ACTIONS(6726),
    [anon_sym_BSLASHusepackage] = ACTIONS(6726),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6726),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6726),
    [anon_sym_BSLASHinclude] = ACTIONS(6726),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6726),
    [anon_sym_BSLASHinput] = ACTIONS(6726),
    [anon_sym_BSLASHsubfile] = ACTIONS(6726),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6726),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6726),
    [anon_sym_BSLASHbibliography] = ACTIONS(6726),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6726),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6726),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6726),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6726),
    [anon_sym_BSLASHimport] = ACTIONS(6726),
    [anon_sym_BSLASHsubimport] = ACTIONS(6726),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6726),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHcaption] = ACTIONS(6726),
    [anon_sym_BSLASHcite] = ACTIONS(6726),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCite] = ACTIONS(6726),
    [anon_sym_BSLASHnocite] = ACTIONS(6726),
    [anon_sym_BSLASHcitet] = ACTIONS(6726),
    [anon_sym_BSLASHcitep] = ACTIONS(6726),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteA] = ACTIONS(6726),
    [anon_sym_BSLASHciteR] = ACTIONS(6726),
    [anon_sym_BSLASHciteS] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6726),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteyear] = ACTIONS(6726),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitedate] = ACTIONS(6726),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteurl] = ACTIONS(6726),
    [anon_sym_BSLASHfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6726),
    [anon_sym_BSLASHcitealt] = ACTIONS(6726),
    [anon_sym_BSLASHcitealp] = ACTIONS(6726),
    [anon_sym_BSLASHcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHparencite] = ACTIONS(6726),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHParencite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHtextcite] = ACTIONS(6726),
    [anon_sym_BSLASHTextcite] = ACTIONS(6726),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHsupercite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite] = ACTIONS(6726),
    [anon_sym_BSLASHAutocite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHVolcite] = ACTIONS(6726),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHavolcite] = ACTIONS(6726),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHNotecite] = ACTIONS(6726),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHlabel] = ACTIONS(6726),
    [anon_sym_BSLASHref] = ACTIONS(6726),
    [anon_sym_BSLASHeqref] = ACTIONS(6726),
    [anon_sym_BSLASHvref] = ACTIONS(6726),
    [anon_sym_BSLASHVref] = ACTIONS(6726),
    [anon_sym_BSLASHautoref] = ACTIONS(6726),
    [anon_sym_BSLASHpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcref] = ACTIONS(6726),
    [anon_sym_BSLASHCref] = ACTIONS(6726),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnameCref] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHdef] = ACTIONS(6726),
    [anon_sym_BSLASHlet] = ACTIONS(6726),
    [anon_sym_BSLASHleft] = ACTIONS(6726),
    [anon_sym_BSLASHbigl] = ACTIONS(6726),
    [anon_sym_BSLASHBigl] = ACTIONS(6726),
    [anon_sym_BSLASHbiggl] = ACTIONS(6726),
    [anon_sym_BSLASHBiggl] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6726),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6726),
    [anon_sym_BSLASHgls] = ACTIONS(6726),
    [anon_sym_BSLASHGls] = ACTIONS(6726),
    [anon_sym_BSLASHGLS] = ACTIONS(6726),
    [anon_sym_BSLASHglspl] = ACTIONS(6726),
    [anon_sym_BSLASHGlspl] = ACTIONS(6726),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6726),
    [anon_sym_BSLASHglslink] = ACTIONS(6726),
    [anon_sym_BSLASHglstext] = ACTIONS(6726),
    [anon_sym_BSLASHGlstext] = ACTIONS(6726),
    [anon_sym_BSLASHGLStext] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6726),
    [anon_sym_BSLASHglsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsname] = ACTIONS(6726),
    [anon_sym_BSLASHGlsname] = ACTIONS(6726),
    [anon_sym_BSLASHGLSname] = ACTIONS(6726),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6726),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6726),
    [anon_sym_BSLASHacrshort] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6726),
    [anon_sym_BSLASHACRshort] = ACTIONS(6726),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrlong] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6726),
    [anon_sym_BSLASHACRlong] = ACTIONS(6726),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrfull] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6726),
    [anon_sym_BSLASHACRfull] = ACTIONS(6726),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHacs] = ACTIONS(6726),
    [anon_sym_BSLASHAcs] = ACTIONS(6726),
    [anon_sym_BSLASHacsp] = ACTIONS(6726),
    [anon_sym_BSLASHAcsp] = ACTIONS(6726),
    [anon_sym_BSLASHacl] = ACTIONS(6726),
    [anon_sym_BSLASHAcl] = ACTIONS(6726),
    [anon_sym_BSLASHaclp] = ACTIONS(6726),
    [anon_sym_BSLASHAclp] = ACTIONS(6726),
    [anon_sym_BSLASHacf] = ACTIONS(6726),
    [anon_sym_BSLASHAcf] = ACTIONS(6726),
    [anon_sym_BSLASHacfp] = ACTIONS(6726),
    [anon_sym_BSLASHAcfp] = ACTIONS(6726),
    [anon_sym_BSLASHac] = ACTIONS(6726),
    [anon_sym_BSLASHAc] = ACTIONS(6726),
    [anon_sym_BSLASHacp] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6726),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6726),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6726),
    [anon_sym_BSLASHcolor] = ACTIONS(6726),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6726),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6726),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6726),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6726),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6726),
    [anon_sym_BSLASHtext] = ACTIONS(6726),
    [anon_sym_BSLASHintertext] = ACTIONS(6726),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6726),
    [anon_sym_BSLASHurl] = ACTIONS(6726),
    [anon_sym_BSLASHhref] = ACTIONS(6726),
  },
  [1258] = {
    [sym_command_name] = ACTIONS(6490),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6490),
    [anon_sym_LBRACK] = ACTIONS(6492),
    [anon_sym_RBRACK] = ACTIONS(6492),
    [anon_sym_COMMA] = ACTIONS(6492),
    [anon_sym_EQ] = ACTIONS(6492),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [anon_sym_RPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHpart] = ACTIONS(6490),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddpart] = ACTIONS(6490),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHchapter] = ACTIONS(6490),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddchap] = ACTIONS(6490),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsection] = ACTIONS(6490),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddsec] = ACTIONS(6490),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHitem] = ACTIONS(6490),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6492),
    [anon_sym_LBRACE] = ACTIONS(6492),
    [sym_word] = ACTIONS(6490),
    [sym_placeholder] = ACTIONS(6492),
    [anon_sym_PLUS] = ACTIONS(6492),
    [anon_sym_DASH] = ACTIONS(6492),
    [anon_sym_STAR] = ACTIONS(6492),
    [anon_sym_SLASH] = ACTIONS(6492),
    [anon_sym_LT] = ACTIONS(6490),
    [anon_sym_GT] = ACTIONS(6490),
    [anon_sym_BANG] = ACTIONS(6490),
    [anon_sym_PIPE] = ACTIONS(6490),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_SQUOTE] = ACTIONS(6490),
    [anon_sym__] = ACTIONS(6492),
    [anon_sym_CARET] = ACTIONS(6492),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6492),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6492),
    [anon_sym_DOLLAR] = ACTIONS(6490),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6492),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHbegin] = ACTIONS(6490),
    [anon_sym_BSLASHtitle] = ACTIONS(6490),
    [anon_sym_BSLASHauthor] = ACTIONS(6490),
    [anon_sym_BSLASHusepackage] = ACTIONS(6490),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6490),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6490),
    [anon_sym_BSLASHinclude] = ACTIONS(6490),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6490),
    [anon_sym_BSLASHinput] = ACTIONS(6490),
    [anon_sym_BSLASHsubfile] = ACTIONS(6490),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6490),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6490),
    [anon_sym_BSLASHbibliography] = ACTIONS(6490),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6490),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6490),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6490),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6490),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6490),
    [anon_sym_BSLASHimport] = ACTIONS(6490),
    [anon_sym_BSLASHsubimport] = ACTIONS(6490),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6490),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHcaption] = ACTIONS(6490),
    [anon_sym_BSLASHcite] = ACTIONS(6490),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCite] = ACTIONS(6490),
    [anon_sym_BSLASHnocite] = ACTIONS(6490),
    [anon_sym_BSLASHcitet] = ACTIONS(6490),
    [anon_sym_BSLASHcitep] = ACTIONS(6490),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteA] = ACTIONS(6490),
    [anon_sym_BSLASHciteR] = ACTIONS(6490),
    [anon_sym_BSLASHciteS] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6490),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteyear] = ACTIONS(6490),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitedate] = ACTIONS(6490),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteurl] = ACTIONS(6490),
    [anon_sym_BSLASHfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6490),
    [anon_sym_BSLASHcitealt] = ACTIONS(6490),
    [anon_sym_BSLASHcitealp] = ACTIONS(6490),
    [anon_sym_BSLASHcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHparencite] = ACTIONS(6490),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHParencite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHtextcite] = ACTIONS(6490),
    [anon_sym_BSLASHTextcite] = ACTIONS(6490),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHsupercite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite] = ACTIONS(6490),
    [anon_sym_BSLASHAutocite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHVolcite] = ACTIONS(6490),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHavolcite] = ACTIONS(6490),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHNotecite] = ACTIONS(6490),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHlabel] = ACTIONS(6490),
    [anon_sym_BSLASHref] = ACTIONS(6490),
    [anon_sym_BSLASHeqref] = ACTIONS(6490),
    [anon_sym_BSLASHvref] = ACTIONS(6490),
    [anon_sym_BSLASHVref] = ACTIONS(6490),
    [anon_sym_BSLASHautoref] = ACTIONS(6490),
    [anon_sym_BSLASHpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcref] = ACTIONS(6490),
    [anon_sym_BSLASHCref] = ACTIONS(6490),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnameCref] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHdef] = ACTIONS(6490),
    [anon_sym_BSLASHlet] = ACTIONS(6490),
    [anon_sym_BSLASHleft] = ACTIONS(6490),
    [anon_sym_BSLASHbigl] = ACTIONS(6490),
    [anon_sym_BSLASHBigl] = ACTIONS(6490),
    [anon_sym_BSLASHbiggl] = ACTIONS(6490),
    [anon_sym_BSLASHBiggl] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6490),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6490),
    [anon_sym_BSLASHgls] = ACTIONS(6490),
    [anon_sym_BSLASHGls] = ACTIONS(6490),
    [anon_sym_BSLASHGLS] = ACTIONS(6490),
    [anon_sym_BSLASHglspl] = ACTIONS(6490),
    [anon_sym_BSLASHGlspl] = ACTIONS(6490),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6490),
    [anon_sym_BSLASHglslink] = ACTIONS(6490),
    [anon_sym_BSLASHglstext] = ACTIONS(6490),
    [anon_sym_BSLASHGlstext] = ACTIONS(6490),
    [anon_sym_BSLASHGLStext] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6490),
    [anon_sym_BSLASHglsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsname] = ACTIONS(6490),
    [anon_sym_BSLASHGlsname] = ACTIONS(6490),
    [anon_sym_BSLASHGLSname] = ACTIONS(6490),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6490),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6490),
    [anon_sym_BSLASHacrshort] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6490),
    [anon_sym_BSLASHACRshort] = ACTIONS(6490),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrlong] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6490),
    [anon_sym_BSLASHACRlong] = ACTIONS(6490),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrfull] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6490),
    [anon_sym_BSLASHACRfull] = ACTIONS(6490),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHacs] = ACTIONS(6490),
    [anon_sym_BSLASHAcs] = ACTIONS(6490),
    [anon_sym_BSLASHacsp] = ACTIONS(6490),
    [anon_sym_BSLASHAcsp] = ACTIONS(6490),
    [anon_sym_BSLASHacl] = ACTIONS(6490),
    [anon_sym_BSLASHAcl] = ACTIONS(6490),
    [anon_sym_BSLASHaclp] = ACTIONS(6490),
    [anon_sym_BSLASHAclp] = ACTIONS(6490),
    [anon_sym_BSLASHacf] = ACTIONS(6490),
    [anon_sym_BSLASHAcf] = ACTIONS(6490),
    [anon_sym_BSLASHacfp] = ACTIONS(6490),
    [anon_sym_BSLASHAcfp] = ACTIONS(6490),
    [anon_sym_BSLASHac] = ACTIONS(6490),
    [anon_sym_BSLASHAc] = ACTIONS(6490),
    [anon_sym_BSLASHacp] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6490),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6490),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6490),
    [anon_sym_BSLASHcolor] = ACTIONS(6490),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6490),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6490),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6490),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6490),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6490),
    [anon_sym_BSLASHtext] = ACTIONS(6490),
    [anon_sym_BSLASHintertext] = ACTIONS(6490),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6490),
    [anon_sym_BSLASHurl] = ACTIONS(6490),
    [anon_sym_BSLASHhref] = ACTIONS(6490),
  },
  [1259] = {
    [sym_command_name] = ACTIONS(6210),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_EQ] = ACTIONS(6212),
    [anon_sym_LPAREN] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHpart] = ACTIONS(6210),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddpart] = ACTIONS(6210),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHchapter] = ACTIONS(6210),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddchap] = ACTIONS(6210),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsection] = ACTIONS(6210),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddsec] = ACTIONS(6210),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHitem] = ACTIONS(6210),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [sym_word] = ACTIONS(6210),
    [sym_placeholder] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_DASH] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_LT] = ACTIONS(6210),
    [anon_sym_GT] = ACTIONS(6210),
    [anon_sym_BANG] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_COLON] = ACTIONS(6210),
    [anon_sym_SQUOTE] = ACTIONS(6210),
    [anon_sym__] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6212),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6212),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6212),
    [anon_sym_DOLLAR] = ACTIONS(6210),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHbegin] = ACTIONS(6210),
    [anon_sym_BSLASHtitle] = ACTIONS(6210),
    [anon_sym_BSLASHauthor] = ACTIONS(6210),
    [anon_sym_BSLASHusepackage] = ACTIONS(6210),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6210),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6210),
    [anon_sym_BSLASHinclude] = ACTIONS(6210),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6210),
    [anon_sym_BSLASHinput] = ACTIONS(6210),
    [anon_sym_BSLASHsubfile] = ACTIONS(6210),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6210),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6210),
    [anon_sym_BSLASHbibliography] = ACTIONS(6210),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6210),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6210),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6210),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6210),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6210),
    [anon_sym_BSLASHimport] = ACTIONS(6210),
    [anon_sym_BSLASHsubimport] = ACTIONS(6210),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6210),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHcaption] = ACTIONS(6210),
    [anon_sym_BSLASHcite] = ACTIONS(6210),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCite] = ACTIONS(6210),
    [anon_sym_BSLASHnocite] = ACTIONS(6210),
    [anon_sym_BSLASHcitet] = ACTIONS(6210),
    [anon_sym_BSLASHcitep] = ACTIONS(6210),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteA] = ACTIONS(6210),
    [anon_sym_BSLASHciteR] = ACTIONS(6210),
    [anon_sym_BSLASHciteS] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6210),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteyear] = ACTIONS(6210),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitedate] = ACTIONS(6210),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteurl] = ACTIONS(6210),
    [anon_sym_BSLASHfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6210),
    [anon_sym_BSLASHcitealt] = ACTIONS(6210),
    [anon_sym_BSLASHcitealp] = ACTIONS(6210),
    [anon_sym_BSLASHcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHparencite] = ACTIONS(6210),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHParencite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHtextcite] = ACTIONS(6210),
    [anon_sym_BSLASHTextcite] = ACTIONS(6210),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHsupercite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite] = ACTIONS(6210),
    [anon_sym_BSLASHAutocite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHVolcite] = ACTIONS(6210),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHavolcite] = ACTIONS(6210),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHNotecite] = ACTIONS(6210),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHlabel] = ACTIONS(6210),
    [anon_sym_BSLASHref] = ACTIONS(6210),
    [anon_sym_BSLASHeqref] = ACTIONS(6210),
    [anon_sym_BSLASHvref] = ACTIONS(6210),
    [anon_sym_BSLASHVref] = ACTIONS(6210),
    [anon_sym_BSLASHautoref] = ACTIONS(6210),
    [anon_sym_BSLASHpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcref] = ACTIONS(6210),
    [anon_sym_BSLASHCref] = ACTIONS(6210),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnameCref] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHdef] = ACTIONS(6210),
    [anon_sym_BSLASHlet] = ACTIONS(6210),
    [anon_sym_BSLASHleft] = ACTIONS(6210),
    [anon_sym_BSLASHbigl] = ACTIONS(6210),
    [anon_sym_BSLASHBigl] = ACTIONS(6210),
    [anon_sym_BSLASHbiggl] = ACTIONS(6210),
    [anon_sym_BSLASHBiggl] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6210),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6210),
    [anon_sym_BSLASHgls] = ACTIONS(6210),
    [anon_sym_BSLASHGls] = ACTIONS(6210),
    [anon_sym_BSLASHGLS] = ACTIONS(6210),
    [anon_sym_BSLASHglspl] = ACTIONS(6210),
    [anon_sym_BSLASHGlspl] = ACTIONS(6210),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6210),
    [anon_sym_BSLASHglslink] = ACTIONS(6210),
    [anon_sym_BSLASHglstext] = ACTIONS(6210),
    [anon_sym_BSLASHGlstext] = ACTIONS(6210),
    [anon_sym_BSLASHGLStext] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6210),
    [anon_sym_BSLASHglsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsname] = ACTIONS(6210),
    [anon_sym_BSLASHGlsname] = ACTIONS(6210),
    [anon_sym_BSLASHGLSname] = ACTIONS(6210),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6210),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6210),
    [anon_sym_BSLASHacrshort] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6210),
    [anon_sym_BSLASHACRshort] = ACTIONS(6210),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrlong] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6210),
    [anon_sym_BSLASHACRlong] = ACTIONS(6210),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrfull] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6210),
    [anon_sym_BSLASHACRfull] = ACTIONS(6210),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHacs] = ACTIONS(6210),
    [anon_sym_BSLASHAcs] = ACTIONS(6210),
    [anon_sym_BSLASHacsp] = ACTIONS(6210),
    [anon_sym_BSLASHAcsp] = ACTIONS(6210),
    [anon_sym_BSLASHacl] = ACTIONS(6210),
    [anon_sym_BSLASHAcl] = ACTIONS(6210),
    [anon_sym_BSLASHaclp] = ACTIONS(6210),
    [anon_sym_BSLASHAclp] = ACTIONS(6210),
    [anon_sym_BSLASHacf] = ACTIONS(6210),
    [anon_sym_BSLASHAcf] = ACTIONS(6210),
    [anon_sym_BSLASHacfp] = ACTIONS(6210),
    [anon_sym_BSLASHAcfp] = ACTIONS(6210),
    [anon_sym_BSLASHac] = ACTIONS(6210),
    [anon_sym_BSLASHAc] = ACTIONS(6210),
    [anon_sym_BSLASHacp] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6210),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6210),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6210),
    [anon_sym_BSLASHcolor] = ACTIONS(6210),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6210),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6210),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6210),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6210),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6210),
    [anon_sym_BSLASHtext] = ACTIONS(6210),
    [anon_sym_BSLASHintertext] = ACTIONS(6210),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6210),
    [anon_sym_BSLASHurl] = ACTIONS(6210),
    [anon_sym_BSLASHhref] = ACTIONS(6210),
  },
  [1260] = {
    [sym_command_name] = ACTIONS(6254),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6254),
    [anon_sym_LBRACK] = ACTIONS(6256),
    [anon_sym_RBRACK] = ACTIONS(6256),
    [anon_sym_COMMA] = ACTIONS(6256),
    [anon_sym_EQ] = ACTIONS(6256),
    [anon_sym_LPAREN] = ACTIONS(6256),
    [anon_sym_RPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHpart] = ACTIONS(6254),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddpart] = ACTIONS(6254),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHchapter] = ACTIONS(6254),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddchap] = ACTIONS(6254),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsection] = ACTIONS(6254),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddsec] = ACTIONS(6254),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHitem] = ACTIONS(6254),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6256),
    [anon_sym_LBRACE] = ACTIONS(6256),
    [sym_word] = ACTIONS(6254),
    [sym_placeholder] = ACTIONS(6256),
    [anon_sym_PLUS] = ACTIONS(6256),
    [anon_sym_DASH] = ACTIONS(6256),
    [anon_sym_STAR] = ACTIONS(6256),
    [anon_sym_SLASH] = ACTIONS(6256),
    [anon_sym_LT] = ACTIONS(6254),
    [anon_sym_GT] = ACTIONS(6254),
    [anon_sym_BANG] = ACTIONS(6254),
    [anon_sym_PIPE] = ACTIONS(6254),
    [anon_sym_COLON] = ACTIONS(6254),
    [anon_sym_SQUOTE] = ACTIONS(6254),
    [anon_sym__] = ACTIONS(6256),
    [anon_sym_CARET] = ACTIONS(6256),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6256),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6256),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6256),
    [anon_sym_DOLLAR] = ACTIONS(6254),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHbegin] = ACTIONS(6254),
    [anon_sym_BSLASHtitle] = ACTIONS(6254),
    [anon_sym_BSLASHauthor] = ACTIONS(6254),
    [anon_sym_BSLASHusepackage] = ACTIONS(6254),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6254),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6254),
    [anon_sym_BSLASHinclude] = ACTIONS(6254),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6254),
    [anon_sym_BSLASHinput] = ACTIONS(6254),
    [anon_sym_BSLASHsubfile] = ACTIONS(6254),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6254),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6254),
    [anon_sym_BSLASHbibliography] = ACTIONS(6254),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6254),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6254),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6254),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6254),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6254),
    [anon_sym_BSLASHimport] = ACTIONS(6254),
    [anon_sym_BSLASHsubimport] = ACTIONS(6254),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6254),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHcaption] = ACTIONS(6254),
    [anon_sym_BSLASHcite] = ACTIONS(6254),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCite] = ACTIONS(6254),
    [anon_sym_BSLASHnocite] = ACTIONS(6254),
    [anon_sym_BSLASHcitet] = ACTIONS(6254),
    [anon_sym_BSLASHcitep] = ACTIONS(6254),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteA] = ACTIONS(6254),
    [anon_sym_BSLASHciteR] = ACTIONS(6254),
    [anon_sym_BSLASHciteS] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6254),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteyear] = ACTIONS(6254),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitedate] = ACTIONS(6254),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteurl] = ACTIONS(6254),
    [anon_sym_BSLASHfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6254),
    [anon_sym_BSLASHcitealt] = ACTIONS(6254),
    [anon_sym_BSLASHcitealp] = ACTIONS(6254),
    [anon_sym_BSLASHcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHparencite] = ACTIONS(6254),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHParencite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHtextcite] = ACTIONS(6254),
    [anon_sym_BSLASHTextcite] = ACTIONS(6254),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHsupercite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite] = ACTIONS(6254),
    [anon_sym_BSLASHAutocite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHVolcite] = ACTIONS(6254),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHavolcite] = ACTIONS(6254),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHNotecite] = ACTIONS(6254),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHlabel] = ACTIONS(6254),
    [anon_sym_BSLASHref] = ACTIONS(6254),
    [anon_sym_BSLASHeqref] = ACTIONS(6254),
    [anon_sym_BSLASHvref] = ACTIONS(6254),
    [anon_sym_BSLASHVref] = ACTIONS(6254),
    [anon_sym_BSLASHautoref] = ACTIONS(6254),
    [anon_sym_BSLASHpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcref] = ACTIONS(6254),
    [anon_sym_BSLASHCref] = ACTIONS(6254),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnameCref] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHdef] = ACTIONS(6254),
    [anon_sym_BSLASHlet] = ACTIONS(6254),
    [anon_sym_BSLASHleft] = ACTIONS(6254),
    [anon_sym_BSLASHbigl] = ACTIONS(6254),
    [anon_sym_BSLASHBigl] = ACTIONS(6254),
    [anon_sym_BSLASHbiggl] = ACTIONS(6254),
    [anon_sym_BSLASHBiggl] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6254),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6254),
    [anon_sym_BSLASHgls] = ACTIONS(6254),
    [anon_sym_BSLASHGls] = ACTIONS(6254),
    [anon_sym_BSLASHGLS] = ACTIONS(6254),
    [anon_sym_BSLASHglspl] = ACTIONS(6254),
    [anon_sym_BSLASHGlspl] = ACTIONS(6254),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6254),
    [anon_sym_BSLASHglslink] = ACTIONS(6254),
    [anon_sym_BSLASHglstext] = ACTIONS(6254),
    [anon_sym_BSLASHGlstext] = ACTIONS(6254),
    [anon_sym_BSLASHGLStext] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6254),
    [anon_sym_BSLASHglsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsname] = ACTIONS(6254),
    [anon_sym_BSLASHGlsname] = ACTIONS(6254),
    [anon_sym_BSLASHGLSname] = ACTIONS(6254),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6254),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6254),
    [anon_sym_BSLASHacrshort] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6254),
    [anon_sym_BSLASHACRshort] = ACTIONS(6254),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrlong] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6254),
    [anon_sym_BSLASHACRlong] = ACTIONS(6254),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrfull] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6254),
    [anon_sym_BSLASHACRfull] = ACTIONS(6254),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHacs] = ACTIONS(6254),
    [anon_sym_BSLASHAcs] = ACTIONS(6254),
    [anon_sym_BSLASHacsp] = ACTIONS(6254),
    [anon_sym_BSLASHAcsp] = ACTIONS(6254),
    [anon_sym_BSLASHacl] = ACTIONS(6254),
    [anon_sym_BSLASHAcl] = ACTIONS(6254),
    [anon_sym_BSLASHaclp] = ACTIONS(6254),
    [anon_sym_BSLASHAclp] = ACTIONS(6254),
    [anon_sym_BSLASHacf] = ACTIONS(6254),
    [anon_sym_BSLASHAcf] = ACTIONS(6254),
    [anon_sym_BSLASHacfp] = ACTIONS(6254),
    [anon_sym_BSLASHAcfp] = ACTIONS(6254),
    [anon_sym_BSLASHac] = ACTIONS(6254),
    [anon_sym_BSLASHAc] = ACTIONS(6254),
    [anon_sym_BSLASHacp] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6254),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6254),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6254),
    [anon_sym_BSLASHcolor] = ACTIONS(6254),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6254),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6254),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6254),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6254),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6254),
    [anon_sym_BSLASHtext] = ACTIONS(6254),
    [anon_sym_BSLASHintertext] = ACTIONS(6254),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6254),
    [anon_sym_BSLASHurl] = ACTIONS(6254),
    [anon_sym_BSLASHhref] = ACTIONS(6254),
  },
  [1261] = {
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [anon_sym_RPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHpart] = ACTIONS(6198),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddpart] = ACTIONS(6198),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHchapter] = ACTIONS(6198),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddchap] = ACTIONS(6198),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsection] = ACTIONS(6198),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddsec] = ACTIONS(6198),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHitem] = ACTIONS(6198),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6200),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6200),
    [anon_sym_DOLLAR] = ACTIONS(6198),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6200),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHbegin] = ACTIONS(6198),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHleft] = ACTIONS(6198),
    [anon_sym_BSLASHbigl] = ACTIONS(6198),
    [anon_sym_BSLASHBigl] = ACTIONS(6198),
    [anon_sym_BSLASHbiggl] = ACTIONS(6198),
    [anon_sym_BSLASHBiggl] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHtext] = ACTIONS(6198),
    [anon_sym_BSLASHintertext] = ACTIONS(6198),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [1262] = {
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_EQ] = ACTIONS(6216),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [anon_sym_RPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHpart] = ACTIONS(6214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddpart] = ACTIONS(6214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHchapter] = ACTIONS(6214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddchap] = ACTIONS(6214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsection] = ACTIONS(6214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddsec] = ACTIONS(6214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHitem] = ACTIONS(6214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6216),
    [anon_sym_DOLLAR] = ACTIONS(6214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6216),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHbegin] = ACTIONS(6214),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHleft] = ACTIONS(6214),
    [anon_sym_BSLASHbigl] = ACTIONS(6214),
    [anon_sym_BSLASHBigl] = ACTIONS(6214),
    [anon_sym_BSLASHbiggl] = ACTIONS(6214),
    [anon_sym_BSLASHBiggl] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHtext] = ACTIONS(6214),
    [anon_sym_BSLASHintertext] = ACTIONS(6214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [1263] = {
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6220),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHpart] = ACTIONS(6218),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddpart] = ACTIONS(6218),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHchapter] = ACTIONS(6218),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddchap] = ACTIONS(6218),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsection] = ACTIONS(6218),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddsec] = ACTIONS(6218),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHitem] = ACTIONS(6218),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6220),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6220),
    [anon_sym_DOLLAR] = ACTIONS(6218),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6220),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHbegin] = ACTIONS(6218),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHleft] = ACTIONS(6218),
    [anon_sym_BSLASHbigl] = ACTIONS(6218),
    [anon_sym_BSLASHBigl] = ACTIONS(6218),
    [anon_sym_BSLASHbiggl] = ACTIONS(6218),
    [anon_sym_BSLASHBiggl] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHtext] = ACTIONS(6218),
    [anon_sym_BSLASHintertext] = ACTIONS(6218),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [1264] = {
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6224),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_LPAREN] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHpart] = ACTIONS(6222),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddpart] = ACTIONS(6222),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHchapter] = ACTIONS(6222),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddchap] = ACTIONS(6222),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsection] = ACTIONS(6222),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddsec] = ACTIONS(6222),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHitem] = ACTIONS(6222),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6224),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6224),
    [anon_sym_DOLLAR] = ACTIONS(6222),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6224),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHbegin] = ACTIONS(6222),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHleft] = ACTIONS(6222),
    [anon_sym_BSLASHbigl] = ACTIONS(6222),
    [anon_sym_BSLASHBigl] = ACTIONS(6222),
    [anon_sym_BSLASHbiggl] = ACTIONS(6222),
    [anon_sym_BSLASHBiggl] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHtext] = ACTIONS(6222),
    [anon_sym_BSLASHintertext] = ACTIONS(6222),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [1265] = {
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6228),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_LPAREN] = ACTIONS(6228),
    [anon_sym_RPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHpart] = ACTIONS(6226),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddpart] = ACTIONS(6226),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHchapter] = ACTIONS(6226),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddchap] = ACTIONS(6226),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsection] = ACTIONS(6226),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddsec] = ACTIONS(6226),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHitem] = ACTIONS(6226),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(6228),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6228),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(6226),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6228),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHbegin] = ACTIONS(6226),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHleft] = ACTIONS(6226),
    [anon_sym_BSLASHbigl] = ACTIONS(6226),
    [anon_sym_BSLASHBigl] = ACTIONS(6226),
    [anon_sym_BSLASHbiggl] = ACTIONS(6226),
    [anon_sym_BSLASHBiggl] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHtext] = ACTIONS(6226),
    [anon_sym_BSLASHintertext] = ACTIONS(6226),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [1266] = {
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6232),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6232),
    [anon_sym_LPAREN] = ACTIONS(6232),
    [anon_sym_RPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHpart] = ACTIONS(6230),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddpart] = ACTIONS(6230),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHchapter] = ACTIONS(6230),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddchap] = ACTIONS(6230),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsection] = ACTIONS(6230),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddsec] = ACTIONS(6230),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHitem] = ACTIONS(6230),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6232),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6232),
    [anon_sym_DOLLAR] = ACTIONS(6230),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6232),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHbegin] = ACTIONS(6230),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHleft] = ACTIONS(6230),
    [anon_sym_BSLASHbigl] = ACTIONS(6230),
    [anon_sym_BSLASHBigl] = ACTIONS(6230),
    [anon_sym_BSLASHbiggl] = ACTIONS(6230),
    [anon_sym_BSLASHBiggl] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHtext] = ACTIONS(6230),
    [anon_sym_BSLASHintertext] = ACTIONS(6230),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [1267] = {
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_LPAREN] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHpart] = ACTIONS(6234),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddpart] = ACTIONS(6234),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHchapter] = ACTIONS(6234),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddchap] = ACTIONS(6234),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsection] = ACTIONS(6234),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddsec] = ACTIONS(6234),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHitem] = ACTIONS(6234),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6236),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(6234),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6236),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHbegin] = ACTIONS(6234),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHleft] = ACTIONS(6234),
    [anon_sym_BSLASHbigl] = ACTIONS(6234),
    [anon_sym_BSLASHBigl] = ACTIONS(6234),
    [anon_sym_BSLASHbiggl] = ACTIONS(6234),
    [anon_sym_BSLASHBiggl] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHtext] = ACTIONS(6234),
    [anon_sym_BSLASHintertext] = ACTIONS(6234),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [1268] = {
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6240),
    [anon_sym_RBRACK] = ACTIONS(6240),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_LPAREN] = ACTIONS(6240),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHpart] = ACTIONS(6238),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddpart] = ACTIONS(6238),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHchapter] = ACTIONS(6238),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddchap] = ACTIONS(6238),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsection] = ACTIONS(6238),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddsec] = ACTIONS(6238),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHitem] = ACTIONS(6238),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(6240),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6240),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6240),
    [anon_sym_DOLLAR] = ACTIONS(6238),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6240),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHbegin] = ACTIONS(6238),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHleft] = ACTIONS(6238),
    [anon_sym_BSLASHbigl] = ACTIONS(6238),
    [anon_sym_BSLASHBigl] = ACTIONS(6238),
    [anon_sym_BSLASHbiggl] = ACTIONS(6238),
    [anon_sym_BSLASHBiggl] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHtext] = ACTIONS(6238),
    [anon_sym_BSLASHintertext] = ACTIONS(6238),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [1269] = {
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_COMMA] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_LPAREN] = ACTIONS(6248),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHpart] = ACTIONS(6246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddpart] = ACTIONS(6246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHchapter] = ACTIONS(6246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddchap] = ACTIONS(6246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsection] = ACTIONS(6246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddsec] = ACTIONS(6246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHitem] = ACTIONS(6246),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6248),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6248),
    [anon_sym_DOLLAR] = ACTIONS(6246),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6248),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHbegin] = ACTIONS(6246),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHleft] = ACTIONS(6246),
    [anon_sym_BSLASHbigl] = ACTIONS(6246),
    [anon_sym_BSLASHBigl] = ACTIONS(6246),
    [anon_sym_BSLASHbiggl] = ACTIONS(6246),
    [anon_sym_BSLASHBiggl] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHtext] = ACTIONS(6246),
    [anon_sym_BSLASHintertext] = ACTIONS(6246),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [1270] = {
    [sym_command_name] = ACTIONS(6258),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6258),
    [anon_sym_LBRACK] = ACTIONS(6260),
    [anon_sym_RBRACK] = ACTIONS(6260),
    [anon_sym_COMMA] = ACTIONS(6260),
    [anon_sym_EQ] = ACTIONS(6260),
    [anon_sym_LPAREN] = ACTIONS(6260),
    [anon_sym_RPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHpart] = ACTIONS(6258),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddpart] = ACTIONS(6258),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHchapter] = ACTIONS(6258),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddchap] = ACTIONS(6258),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsection] = ACTIONS(6258),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddsec] = ACTIONS(6258),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHitem] = ACTIONS(6258),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6260),
    [anon_sym_LBRACE] = ACTIONS(6260),
    [sym_word] = ACTIONS(6258),
    [sym_placeholder] = ACTIONS(6260),
    [anon_sym_PLUS] = ACTIONS(6260),
    [anon_sym_DASH] = ACTIONS(6260),
    [anon_sym_STAR] = ACTIONS(6260),
    [anon_sym_SLASH] = ACTIONS(6260),
    [anon_sym_LT] = ACTIONS(6258),
    [anon_sym_GT] = ACTIONS(6258),
    [anon_sym_BANG] = ACTIONS(6258),
    [anon_sym_PIPE] = ACTIONS(6258),
    [anon_sym_COLON] = ACTIONS(6258),
    [anon_sym_SQUOTE] = ACTIONS(6258),
    [anon_sym__] = ACTIONS(6260),
    [anon_sym_CARET] = ACTIONS(6260),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6260),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6260),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6260),
    [anon_sym_DOLLAR] = ACTIONS(6258),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHbegin] = ACTIONS(6258),
    [anon_sym_BSLASHtitle] = ACTIONS(6258),
    [anon_sym_BSLASHauthor] = ACTIONS(6258),
    [anon_sym_BSLASHusepackage] = ACTIONS(6258),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6258),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6258),
    [anon_sym_BSLASHinclude] = ACTIONS(6258),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6258),
    [anon_sym_BSLASHinput] = ACTIONS(6258),
    [anon_sym_BSLASHsubfile] = ACTIONS(6258),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6258),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6258),
    [anon_sym_BSLASHbibliography] = ACTIONS(6258),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6258),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6258),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6258),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6258),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6258),
    [anon_sym_BSLASHimport] = ACTIONS(6258),
    [anon_sym_BSLASHsubimport] = ACTIONS(6258),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6258),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHcaption] = ACTIONS(6258),
    [anon_sym_BSLASHcite] = ACTIONS(6258),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCite] = ACTIONS(6258),
    [anon_sym_BSLASHnocite] = ACTIONS(6258),
    [anon_sym_BSLASHcitet] = ACTIONS(6258),
    [anon_sym_BSLASHcitep] = ACTIONS(6258),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteA] = ACTIONS(6258),
    [anon_sym_BSLASHciteR] = ACTIONS(6258),
    [anon_sym_BSLASHciteS] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6258),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteyear] = ACTIONS(6258),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitedate] = ACTIONS(6258),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteurl] = ACTIONS(6258),
    [anon_sym_BSLASHfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6258),
    [anon_sym_BSLASHcitealt] = ACTIONS(6258),
    [anon_sym_BSLASHcitealp] = ACTIONS(6258),
    [anon_sym_BSLASHcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHparencite] = ACTIONS(6258),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHParencite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHtextcite] = ACTIONS(6258),
    [anon_sym_BSLASHTextcite] = ACTIONS(6258),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHsupercite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite] = ACTIONS(6258),
    [anon_sym_BSLASHAutocite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHVolcite] = ACTIONS(6258),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHavolcite] = ACTIONS(6258),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHNotecite] = ACTIONS(6258),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHlabel] = ACTIONS(6258),
    [anon_sym_BSLASHref] = ACTIONS(6258),
    [anon_sym_BSLASHeqref] = ACTIONS(6258),
    [anon_sym_BSLASHvref] = ACTIONS(6258),
    [anon_sym_BSLASHVref] = ACTIONS(6258),
    [anon_sym_BSLASHautoref] = ACTIONS(6258),
    [anon_sym_BSLASHpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcref] = ACTIONS(6258),
    [anon_sym_BSLASHCref] = ACTIONS(6258),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnameCref] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHdef] = ACTIONS(6258),
    [anon_sym_BSLASHlet] = ACTIONS(6258),
    [anon_sym_BSLASHleft] = ACTIONS(6258),
    [anon_sym_BSLASHbigl] = ACTIONS(6258),
    [anon_sym_BSLASHBigl] = ACTIONS(6258),
    [anon_sym_BSLASHbiggl] = ACTIONS(6258),
    [anon_sym_BSLASHBiggl] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6258),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6258),
    [anon_sym_BSLASHgls] = ACTIONS(6258),
    [anon_sym_BSLASHGls] = ACTIONS(6258),
    [anon_sym_BSLASHGLS] = ACTIONS(6258),
    [anon_sym_BSLASHglspl] = ACTIONS(6258),
    [anon_sym_BSLASHGlspl] = ACTIONS(6258),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6258),
    [anon_sym_BSLASHglslink] = ACTIONS(6258),
    [anon_sym_BSLASHglstext] = ACTIONS(6258),
    [anon_sym_BSLASHGlstext] = ACTIONS(6258),
    [anon_sym_BSLASHGLStext] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6258),
    [anon_sym_BSLASHglsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsname] = ACTIONS(6258),
    [anon_sym_BSLASHGlsname] = ACTIONS(6258),
    [anon_sym_BSLASHGLSname] = ACTIONS(6258),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6258),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6258),
    [anon_sym_BSLASHacrshort] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6258),
    [anon_sym_BSLASHACRshort] = ACTIONS(6258),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrlong] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6258),
    [anon_sym_BSLASHACRlong] = ACTIONS(6258),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrfull] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6258),
    [anon_sym_BSLASHACRfull] = ACTIONS(6258),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHacs] = ACTIONS(6258),
    [anon_sym_BSLASHAcs] = ACTIONS(6258),
    [anon_sym_BSLASHacsp] = ACTIONS(6258),
    [anon_sym_BSLASHAcsp] = ACTIONS(6258),
    [anon_sym_BSLASHacl] = ACTIONS(6258),
    [anon_sym_BSLASHAcl] = ACTIONS(6258),
    [anon_sym_BSLASHaclp] = ACTIONS(6258),
    [anon_sym_BSLASHAclp] = ACTIONS(6258),
    [anon_sym_BSLASHacf] = ACTIONS(6258),
    [anon_sym_BSLASHAcf] = ACTIONS(6258),
    [anon_sym_BSLASHacfp] = ACTIONS(6258),
    [anon_sym_BSLASHAcfp] = ACTIONS(6258),
    [anon_sym_BSLASHac] = ACTIONS(6258),
    [anon_sym_BSLASHAc] = ACTIONS(6258),
    [anon_sym_BSLASHacp] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6258),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6258),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6258),
    [anon_sym_BSLASHcolor] = ACTIONS(6258),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6258),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6258),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6258),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6258),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6258),
    [anon_sym_BSLASHtext] = ACTIONS(6258),
    [anon_sym_BSLASHintertext] = ACTIONS(6258),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6258),
    [anon_sym_BSLASHurl] = ACTIONS(6258),
    [anon_sym_BSLASHhref] = ACTIONS(6258),
  },
  [1271] = {
    [sym_command_name] = ACTIONS(6262),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6262),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_RBRACK] = ACTIONS(6264),
    [anon_sym_COMMA] = ACTIONS(6264),
    [anon_sym_EQ] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(6264),
    [anon_sym_RPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHpart] = ACTIONS(6262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddpart] = ACTIONS(6262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHchapter] = ACTIONS(6262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddchap] = ACTIONS(6262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsection] = ACTIONS(6262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddsec] = ACTIONS(6262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHitem] = ACTIONS(6262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6264),
    [anon_sym_LBRACE] = ACTIONS(6264),
    [sym_word] = ACTIONS(6262),
    [sym_placeholder] = ACTIONS(6264),
    [anon_sym_PLUS] = ACTIONS(6264),
    [anon_sym_DASH] = ACTIONS(6264),
    [anon_sym_STAR] = ACTIONS(6264),
    [anon_sym_SLASH] = ACTIONS(6264),
    [anon_sym_LT] = ACTIONS(6262),
    [anon_sym_GT] = ACTIONS(6262),
    [anon_sym_BANG] = ACTIONS(6262),
    [anon_sym_PIPE] = ACTIONS(6262),
    [anon_sym_COLON] = ACTIONS(6262),
    [anon_sym_SQUOTE] = ACTIONS(6262),
    [anon_sym__] = ACTIONS(6264),
    [anon_sym_CARET] = ACTIONS(6264),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6264),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6264),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6264),
    [anon_sym_DOLLAR] = ACTIONS(6262),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHbegin] = ACTIONS(6262),
    [anon_sym_BSLASHtitle] = ACTIONS(6262),
    [anon_sym_BSLASHauthor] = ACTIONS(6262),
    [anon_sym_BSLASHusepackage] = ACTIONS(6262),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6262),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6262),
    [anon_sym_BSLASHinclude] = ACTIONS(6262),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6262),
    [anon_sym_BSLASHinput] = ACTIONS(6262),
    [anon_sym_BSLASHsubfile] = ACTIONS(6262),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6262),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6262),
    [anon_sym_BSLASHbibliography] = ACTIONS(6262),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6262),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6262),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6262),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6262),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6262),
    [anon_sym_BSLASHimport] = ACTIONS(6262),
    [anon_sym_BSLASHsubimport] = ACTIONS(6262),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6262),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHcaption] = ACTIONS(6262),
    [anon_sym_BSLASHcite] = ACTIONS(6262),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCite] = ACTIONS(6262),
    [anon_sym_BSLASHnocite] = ACTIONS(6262),
    [anon_sym_BSLASHcitet] = ACTIONS(6262),
    [anon_sym_BSLASHcitep] = ACTIONS(6262),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteA] = ACTIONS(6262),
    [anon_sym_BSLASHciteR] = ACTIONS(6262),
    [anon_sym_BSLASHciteS] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6262),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteyear] = ACTIONS(6262),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitedate] = ACTIONS(6262),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteurl] = ACTIONS(6262),
    [anon_sym_BSLASHfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6262),
    [anon_sym_BSLASHcitealt] = ACTIONS(6262),
    [anon_sym_BSLASHcitealp] = ACTIONS(6262),
    [anon_sym_BSLASHcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHparencite] = ACTIONS(6262),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHParencite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHtextcite] = ACTIONS(6262),
    [anon_sym_BSLASHTextcite] = ACTIONS(6262),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHsupercite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite] = ACTIONS(6262),
    [anon_sym_BSLASHAutocite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHVolcite] = ACTIONS(6262),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHavolcite] = ACTIONS(6262),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHNotecite] = ACTIONS(6262),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHlabel] = ACTIONS(6262),
    [anon_sym_BSLASHref] = ACTIONS(6262),
    [anon_sym_BSLASHeqref] = ACTIONS(6262),
    [anon_sym_BSLASHvref] = ACTIONS(6262),
    [anon_sym_BSLASHVref] = ACTIONS(6262),
    [anon_sym_BSLASHautoref] = ACTIONS(6262),
    [anon_sym_BSLASHpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcref] = ACTIONS(6262),
    [anon_sym_BSLASHCref] = ACTIONS(6262),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnameCref] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHdef] = ACTIONS(6262),
    [anon_sym_BSLASHlet] = ACTIONS(6262),
    [anon_sym_BSLASHleft] = ACTIONS(6262),
    [anon_sym_BSLASHbigl] = ACTIONS(6262),
    [anon_sym_BSLASHBigl] = ACTIONS(6262),
    [anon_sym_BSLASHbiggl] = ACTIONS(6262),
    [anon_sym_BSLASHBiggl] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6262),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6262),
    [anon_sym_BSLASHgls] = ACTIONS(6262),
    [anon_sym_BSLASHGls] = ACTIONS(6262),
    [anon_sym_BSLASHGLS] = ACTIONS(6262),
    [anon_sym_BSLASHglspl] = ACTIONS(6262),
    [anon_sym_BSLASHGlspl] = ACTIONS(6262),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6262),
    [anon_sym_BSLASHglslink] = ACTIONS(6262),
    [anon_sym_BSLASHglstext] = ACTIONS(6262),
    [anon_sym_BSLASHGlstext] = ACTIONS(6262),
    [anon_sym_BSLASHGLStext] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6262),
    [anon_sym_BSLASHglsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsname] = ACTIONS(6262),
    [anon_sym_BSLASHGlsname] = ACTIONS(6262),
    [anon_sym_BSLASHGLSname] = ACTIONS(6262),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6262),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6262),
    [anon_sym_BSLASHacrshort] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6262),
    [anon_sym_BSLASHACRshort] = ACTIONS(6262),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrlong] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6262),
    [anon_sym_BSLASHACRlong] = ACTIONS(6262),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrfull] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6262),
    [anon_sym_BSLASHACRfull] = ACTIONS(6262),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHacs] = ACTIONS(6262),
    [anon_sym_BSLASHAcs] = ACTIONS(6262),
    [anon_sym_BSLASHacsp] = ACTIONS(6262),
    [anon_sym_BSLASHAcsp] = ACTIONS(6262),
    [anon_sym_BSLASHacl] = ACTIONS(6262),
    [anon_sym_BSLASHAcl] = ACTIONS(6262),
    [anon_sym_BSLASHaclp] = ACTIONS(6262),
    [anon_sym_BSLASHAclp] = ACTIONS(6262),
    [anon_sym_BSLASHacf] = ACTIONS(6262),
    [anon_sym_BSLASHAcf] = ACTIONS(6262),
    [anon_sym_BSLASHacfp] = ACTIONS(6262),
    [anon_sym_BSLASHAcfp] = ACTIONS(6262),
    [anon_sym_BSLASHac] = ACTIONS(6262),
    [anon_sym_BSLASHAc] = ACTIONS(6262),
    [anon_sym_BSLASHacp] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6262),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6262),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6262),
    [anon_sym_BSLASHcolor] = ACTIONS(6262),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6262),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6262),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6262),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6262),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6262),
    [anon_sym_BSLASHtext] = ACTIONS(6262),
    [anon_sym_BSLASHintertext] = ACTIONS(6262),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6262),
    [anon_sym_BSLASHurl] = ACTIONS(6262),
    [anon_sym_BSLASHhref] = ACTIONS(6262),
  },
  [1272] = {
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_RBRACK] = ACTIONS(6656),
    [anon_sym_COMMA] = ACTIONS(6656),
    [anon_sym_EQ] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(6656),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHpart] = ACTIONS(6654),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddpart] = ACTIONS(6654),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHchapter] = ACTIONS(6654),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddchap] = ACTIONS(6654),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsection] = ACTIONS(6654),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddsec] = ACTIONS(6654),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHitem] = ACTIONS(6654),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6656),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6656),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6656),
    [anon_sym_DOLLAR] = ACTIONS(6654),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHbegin] = ACTIONS(6654),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHleft] = ACTIONS(6654),
    [anon_sym_BSLASHbigl] = ACTIONS(6654),
    [anon_sym_BSLASHBigl] = ACTIONS(6654),
    [anon_sym_BSLASHbiggl] = ACTIONS(6654),
    [anon_sym_BSLASHBiggl] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHtext] = ACTIONS(6654),
    [anon_sym_BSLASHintertext] = ACTIONS(6654),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [1273] = {
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6252),
    [anon_sym_LPAREN] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHpart] = ACTIONS(6250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddpart] = ACTIONS(6250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHchapter] = ACTIONS(6250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddchap] = ACTIONS(6250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsection] = ACTIONS(6250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddsec] = ACTIONS(6250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHitem] = ACTIONS(6250),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6252),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHbegin] = ACTIONS(6250),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHleft] = ACTIONS(6250),
    [anon_sym_BSLASHbigl] = ACTIONS(6250),
    [anon_sym_BSLASHBigl] = ACTIONS(6250),
    [anon_sym_BSLASHbiggl] = ACTIONS(6250),
    [anon_sym_BSLASHBiggl] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHtext] = ACTIONS(6250),
    [anon_sym_BSLASHintertext] = ACTIONS(6250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
  [1274] = {
    [sym_command_name] = ACTIONS(6194),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_RBRACK] = ACTIONS(6196),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_EQ] = ACTIONS(6196),
    [anon_sym_LPAREN] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHpart] = ACTIONS(6194),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddpart] = ACTIONS(6194),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHchapter] = ACTIONS(6194),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddchap] = ACTIONS(6194),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsection] = ACTIONS(6194),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddsec] = ACTIONS(6194),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHitem] = ACTIONS(6194),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [sym_word] = ACTIONS(6194),
    [sym_placeholder] = ACTIONS(6196),
    [anon_sym_PLUS] = ACTIONS(6196),
    [anon_sym_DASH] = ACTIONS(6196),
    [anon_sym_STAR] = ACTIONS(6196),
    [anon_sym_SLASH] = ACTIONS(6196),
    [anon_sym_LT] = ACTIONS(6194),
    [anon_sym_GT] = ACTIONS(6194),
    [anon_sym_BANG] = ACTIONS(6194),
    [anon_sym_PIPE] = ACTIONS(6194),
    [anon_sym_COLON] = ACTIONS(6194),
    [anon_sym_SQUOTE] = ACTIONS(6194),
    [anon_sym__] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6196),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6196),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6196),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6196),
    [anon_sym_DOLLAR] = ACTIONS(6194),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHbegin] = ACTIONS(6194),
    [anon_sym_BSLASHtitle] = ACTIONS(6194),
    [anon_sym_BSLASHauthor] = ACTIONS(6194),
    [anon_sym_BSLASHusepackage] = ACTIONS(6194),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6194),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6194),
    [anon_sym_BSLASHinclude] = ACTIONS(6194),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6194),
    [anon_sym_BSLASHinput] = ACTIONS(6194),
    [anon_sym_BSLASHsubfile] = ACTIONS(6194),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6194),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6194),
    [anon_sym_BSLASHbibliography] = ACTIONS(6194),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6194),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6194),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6194),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6194),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6194),
    [anon_sym_BSLASHimport] = ACTIONS(6194),
    [anon_sym_BSLASHsubimport] = ACTIONS(6194),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6194),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHcaption] = ACTIONS(6194),
    [anon_sym_BSLASHcite] = ACTIONS(6194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCite] = ACTIONS(6194),
    [anon_sym_BSLASHnocite] = ACTIONS(6194),
    [anon_sym_BSLASHcitet] = ACTIONS(6194),
    [anon_sym_BSLASHcitep] = ACTIONS(6194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteA] = ACTIONS(6194),
    [anon_sym_BSLASHciteR] = ACTIONS(6194),
    [anon_sym_BSLASHciteS] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteyear] = ACTIONS(6194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitedate] = ACTIONS(6194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteurl] = ACTIONS(6194),
    [anon_sym_BSLASHfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6194),
    [anon_sym_BSLASHcitealt] = ACTIONS(6194),
    [anon_sym_BSLASHcitealp] = ACTIONS(6194),
    [anon_sym_BSLASHcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHparencite] = ACTIONS(6194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHParencite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHtextcite] = ACTIONS(6194),
    [anon_sym_BSLASHTextcite] = ACTIONS(6194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHsupercite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite] = ACTIONS(6194),
    [anon_sym_BSLASHAutocite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHVolcite] = ACTIONS(6194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHavolcite] = ACTIONS(6194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHNotecite] = ACTIONS(6194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHlabel] = ACTIONS(6194),
    [anon_sym_BSLASHref] = ACTIONS(6194),
    [anon_sym_BSLASHeqref] = ACTIONS(6194),
    [anon_sym_BSLASHvref] = ACTIONS(6194),
    [anon_sym_BSLASHVref] = ACTIONS(6194),
    [anon_sym_BSLASHautoref] = ACTIONS(6194),
    [anon_sym_BSLASHpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcref] = ACTIONS(6194),
    [anon_sym_BSLASHCref] = ACTIONS(6194),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnameCref] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHdef] = ACTIONS(6194),
    [anon_sym_BSLASHlet] = ACTIONS(6194),
    [anon_sym_BSLASHleft] = ACTIONS(6194),
    [anon_sym_BSLASHbigl] = ACTIONS(6194),
    [anon_sym_BSLASHBigl] = ACTIONS(6194),
    [anon_sym_BSLASHbiggl] = ACTIONS(6194),
    [anon_sym_BSLASHBiggl] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6194),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6194),
    [anon_sym_BSLASHgls] = ACTIONS(6194),
    [anon_sym_BSLASHGls] = ACTIONS(6194),
    [anon_sym_BSLASHGLS] = ACTIONS(6194),
    [anon_sym_BSLASHglspl] = ACTIONS(6194),
    [anon_sym_BSLASHGlspl] = ACTIONS(6194),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6194),
    [anon_sym_BSLASHglslink] = ACTIONS(6194),
    [anon_sym_BSLASHglstext] = ACTIONS(6194),
    [anon_sym_BSLASHGlstext] = ACTIONS(6194),
    [anon_sym_BSLASHGLStext] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6194),
    [anon_sym_BSLASHglsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsname] = ACTIONS(6194),
    [anon_sym_BSLASHGlsname] = ACTIONS(6194),
    [anon_sym_BSLASHGLSname] = ACTIONS(6194),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6194),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6194),
    [anon_sym_BSLASHacrshort] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6194),
    [anon_sym_BSLASHACRshort] = ACTIONS(6194),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrlong] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6194),
    [anon_sym_BSLASHACRlong] = ACTIONS(6194),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrfull] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6194),
    [anon_sym_BSLASHACRfull] = ACTIONS(6194),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHacs] = ACTIONS(6194),
    [anon_sym_BSLASHAcs] = ACTIONS(6194),
    [anon_sym_BSLASHacsp] = ACTIONS(6194),
    [anon_sym_BSLASHAcsp] = ACTIONS(6194),
    [anon_sym_BSLASHacl] = ACTIONS(6194),
    [anon_sym_BSLASHAcl] = ACTIONS(6194),
    [anon_sym_BSLASHaclp] = ACTIONS(6194),
    [anon_sym_BSLASHAclp] = ACTIONS(6194),
    [anon_sym_BSLASHacf] = ACTIONS(6194),
    [anon_sym_BSLASHAcf] = ACTIONS(6194),
    [anon_sym_BSLASHacfp] = ACTIONS(6194),
    [anon_sym_BSLASHAcfp] = ACTIONS(6194),
    [anon_sym_BSLASHac] = ACTIONS(6194),
    [anon_sym_BSLASHAc] = ACTIONS(6194),
    [anon_sym_BSLASHacp] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6194),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6194),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6194),
    [anon_sym_BSLASHcolor] = ACTIONS(6194),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6194),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6194),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6194),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6194),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6194),
    [anon_sym_BSLASHtext] = ACTIONS(6194),
    [anon_sym_BSLASHintertext] = ACTIONS(6194),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6194),
    [anon_sym_BSLASHurl] = ACTIONS(6194),
    [anon_sym_BSLASHhref] = ACTIONS(6194),
  },
  [1275] = {
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6448),
    [anon_sym_RBRACK] = ACTIONS(6448),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(6448),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHpart] = ACTIONS(6446),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddpart] = ACTIONS(6446),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHchapter] = ACTIONS(6446),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddchap] = ACTIONS(6446),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsection] = ACTIONS(6446),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddsec] = ACTIONS(6446),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHitem] = ACTIONS(6446),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6448),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6448),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6448),
    [anon_sym_DOLLAR] = ACTIONS(6446),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6448),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHbegin] = ACTIONS(6446),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHleft] = ACTIONS(6446),
    [anon_sym_BSLASHbigl] = ACTIONS(6446),
    [anon_sym_BSLASHBigl] = ACTIONS(6446),
    [anon_sym_BSLASHbiggl] = ACTIONS(6446),
    [anon_sym_BSLASHBiggl] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHtext] = ACTIONS(6446),
    [anon_sym_BSLASHintertext] = ACTIONS(6446),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [1276] = {
    [sym_command_name] = ACTIONS(6202),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6202),
    [anon_sym_LBRACK] = ACTIONS(6204),
    [anon_sym_RBRACK] = ACTIONS(6204),
    [anon_sym_COMMA] = ACTIONS(6204),
    [anon_sym_EQ] = ACTIONS(6204),
    [anon_sym_LPAREN] = ACTIONS(6204),
    [anon_sym_RPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHpart] = ACTIONS(6202),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddpart] = ACTIONS(6202),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHchapter] = ACTIONS(6202),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddchap] = ACTIONS(6202),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsection] = ACTIONS(6202),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddsec] = ACTIONS(6202),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHitem] = ACTIONS(6202),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6204),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [sym_word] = ACTIONS(6202),
    [sym_placeholder] = ACTIONS(6204),
    [anon_sym_PLUS] = ACTIONS(6204),
    [anon_sym_DASH] = ACTIONS(6204),
    [anon_sym_STAR] = ACTIONS(6204),
    [anon_sym_SLASH] = ACTIONS(6204),
    [anon_sym_LT] = ACTIONS(6202),
    [anon_sym_GT] = ACTIONS(6202),
    [anon_sym_BANG] = ACTIONS(6202),
    [anon_sym_PIPE] = ACTIONS(6202),
    [anon_sym_COLON] = ACTIONS(6202),
    [anon_sym_SQUOTE] = ACTIONS(6202),
    [anon_sym__] = ACTIONS(6204),
    [anon_sym_CARET] = ACTIONS(6204),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6204),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6204),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6204),
    [anon_sym_DOLLAR] = ACTIONS(6202),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHbegin] = ACTIONS(6202),
    [anon_sym_BSLASHtitle] = ACTIONS(6202),
    [anon_sym_BSLASHauthor] = ACTIONS(6202),
    [anon_sym_BSLASHusepackage] = ACTIONS(6202),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6202),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6202),
    [anon_sym_BSLASHinclude] = ACTIONS(6202),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6202),
    [anon_sym_BSLASHinput] = ACTIONS(6202),
    [anon_sym_BSLASHsubfile] = ACTIONS(6202),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6202),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6202),
    [anon_sym_BSLASHbibliography] = ACTIONS(6202),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6202),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6202),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6202),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6202),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6202),
    [anon_sym_BSLASHimport] = ACTIONS(6202),
    [anon_sym_BSLASHsubimport] = ACTIONS(6202),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6202),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHcaption] = ACTIONS(6202),
    [anon_sym_BSLASHcite] = ACTIONS(6202),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCite] = ACTIONS(6202),
    [anon_sym_BSLASHnocite] = ACTIONS(6202),
    [anon_sym_BSLASHcitet] = ACTIONS(6202),
    [anon_sym_BSLASHcitep] = ACTIONS(6202),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteA] = ACTIONS(6202),
    [anon_sym_BSLASHciteR] = ACTIONS(6202),
    [anon_sym_BSLASHciteS] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6202),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteyear] = ACTIONS(6202),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitedate] = ACTIONS(6202),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteurl] = ACTIONS(6202),
    [anon_sym_BSLASHfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6202),
    [anon_sym_BSLASHcitealt] = ACTIONS(6202),
    [anon_sym_BSLASHcitealp] = ACTIONS(6202),
    [anon_sym_BSLASHcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHparencite] = ACTIONS(6202),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHParencite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHtextcite] = ACTIONS(6202),
    [anon_sym_BSLASHTextcite] = ACTIONS(6202),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHsupercite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite] = ACTIONS(6202),
    [anon_sym_BSLASHAutocite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHVolcite] = ACTIONS(6202),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHavolcite] = ACTIONS(6202),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHNotecite] = ACTIONS(6202),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHlabel] = ACTIONS(6202),
    [anon_sym_BSLASHref] = ACTIONS(6202),
    [anon_sym_BSLASHeqref] = ACTIONS(6202),
    [anon_sym_BSLASHvref] = ACTIONS(6202),
    [anon_sym_BSLASHVref] = ACTIONS(6202),
    [anon_sym_BSLASHautoref] = ACTIONS(6202),
    [anon_sym_BSLASHpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcref] = ACTIONS(6202),
    [anon_sym_BSLASHCref] = ACTIONS(6202),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnameCref] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHdef] = ACTIONS(6202),
    [anon_sym_BSLASHlet] = ACTIONS(6202),
    [anon_sym_BSLASHleft] = ACTIONS(6202),
    [anon_sym_BSLASHbigl] = ACTIONS(6202),
    [anon_sym_BSLASHBigl] = ACTIONS(6202),
    [anon_sym_BSLASHbiggl] = ACTIONS(6202),
    [anon_sym_BSLASHBiggl] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6202),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6202),
    [anon_sym_BSLASHgls] = ACTIONS(6202),
    [anon_sym_BSLASHGls] = ACTIONS(6202),
    [anon_sym_BSLASHGLS] = ACTIONS(6202),
    [anon_sym_BSLASHglspl] = ACTIONS(6202),
    [anon_sym_BSLASHGlspl] = ACTIONS(6202),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6202),
    [anon_sym_BSLASHglslink] = ACTIONS(6202),
    [anon_sym_BSLASHglstext] = ACTIONS(6202),
    [anon_sym_BSLASHGlstext] = ACTIONS(6202),
    [anon_sym_BSLASHGLStext] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6202),
    [anon_sym_BSLASHglsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsname] = ACTIONS(6202),
    [anon_sym_BSLASHGlsname] = ACTIONS(6202),
    [anon_sym_BSLASHGLSname] = ACTIONS(6202),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6202),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6202),
    [anon_sym_BSLASHacrshort] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6202),
    [anon_sym_BSLASHACRshort] = ACTIONS(6202),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrlong] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6202),
    [anon_sym_BSLASHACRlong] = ACTIONS(6202),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrfull] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6202),
    [anon_sym_BSLASHACRfull] = ACTIONS(6202),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHacs] = ACTIONS(6202),
    [anon_sym_BSLASHAcs] = ACTIONS(6202),
    [anon_sym_BSLASHacsp] = ACTIONS(6202),
    [anon_sym_BSLASHAcsp] = ACTIONS(6202),
    [anon_sym_BSLASHacl] = ACTIONS(6202),
    [anon_sym_BSLASHAcl] = ACTIONS(6202),
    [anon_sym_BSLASHaclp] = ACTIONS(6202),
    [anon_sym_BSLASHAclp] = ACTIONS(6202),
    [anon_sym_BSLASHacf] = ACTIONS(6202),
    [anon_sym_BSLASHAcf] = ACTIONS(6202),
    [anon_sym_BSLASHacfp] = ACTIONS(6202),
    [anon_sym_BSLASHAcfp] = ACTIONS(6202),
    [anon_sym_BSLASHac] = ACTIONS(6202),
    [anon_sym_BSLASHAc] = ACTIONS(6202),
    [anon_sym_BSLASHacp] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6202),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6202),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6202),
    [anon_sym_BSLASHcolor] = ACTIONS(6202),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6202),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6202),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6202),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6202),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6202),
    [anon_sym_BSLASHtext] = ACTIONS(6202),
    [anon_sym_BSLASHintertext] = ACTIONS(6202),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6202),
    [anon_sym_BSLASHurl] = ACTIONS(6202),
    [anon_sym_BSLASHhref] = ACTIONS(6202),
  },
  [1277] = {
    [sym_command_name] = ACTIONS(6170),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6172),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6172),
    [anon_sym_LPAREN] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHpart] = ACTIONS(6170),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddpart] = ACTIONS(6170),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHchapter] = ACTIONS(6170),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddchap] = ACTIONS(6170),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsection] = ACTIONS(6170),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHaddsec] = ACTIONS(6170),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6170),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6170),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHitem] = ACTIONS(6170),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [sym_word] = ACTIONS(6170),
    [sym_placeholder] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_BANG] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_SQUOTE] = ACTIONS(6170),
    [anon_sym__] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6172),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6172),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6172),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHbegin] = ACTIONS(6170),
    [anon_sym_BSLASHtitle] = ACTIONS(6170),
    [anon_sym_BSLASHauthor] = ACTIONS(6170),
    [anon_sym_BSLASHusepackage] = ACTIONS(6170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6170),
    [anon_sym_BSLASHinclude] = ACTIONS(6170),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6170),
    [anon_sym_BSLASHinput] = ACTIONS(6170),
    [anon_sym_BSLASHsubfile] = ACTIONS(6170),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6170),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6170),
    [anon_sym_BSLASHbibliography] = ACTIONS(6170),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6170),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6170),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6170),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6170),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6170),
    [anon_sym_BSLASHimport] = ACTIONS(6170),
    [anon_sym_BSLASHsubimport] = ACTIONS(6170),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6170),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHcaption] = ACTIONS(6170),
    [anon_sym_BSLASHcite] = ACTIONS(6170),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCite] = ACTIONS(6170),
    [anon_sym_BSLASHnocite] = ACTIONS(6170),
    [anon_sym_BSLASHcitet] = ACTIONS(6170),
    [anon_sym_BSLASHcitep] = ACTIONS(6170),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteA] = ACTIONS(6170),
    [anon_sym_BSLASHciteR] = ACTIONS(6170),
    [anon_sym_BSLASHciteS] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6170),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteyear] = ACTIONS(6170),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitedate] = ACTIONS(6170),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteurl] = ACTIONS(6170),
    [anon_sym_BSLASHfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6170),
    [anon_sym_BSLASHcitealt] = ACTIONS(6170),
    [anon_sym_BSLASHcitealp] = ACTIONS(6170),
    [anon_sym_BSLASHcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHparencite] = ACTIONS(6170),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHParencite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHtextcite] = ACTIONS(6170),
    [anon_sym_BSLASHTextcite] = ACTIONS(6170),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHsupercite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite] = ACTIONS(6170),
    [anon_sym_BSLASHAutocite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHVolcite] = ACTIONS(6170),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHavolcite] = ACTIONS(6170),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHNotecite] = ACTIONS(6170),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHlabel] = ACTIONS(6170),
    [anon_sym_BSLASHref] = ACTIONS(6170),
    [anon_sym_BSLASHeqref] = ACTIONS(6170),
    [anon_sym_BSLASHvref] = ACTIONS(6170),
    [anon_sym_BSLASHVref] = ACTIONS(6170),
    [anon_sym_BSLASHautoref] = ACTIONS(6170),
    [anon_sym_BSLASHpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcref] = ACTIONS(6170),
    [anon_sym_BSLASHCref] = ACTIONS(6170),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnameCref] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHdef] = ACTIONS(6170),
    [anon_sym_BSLASHlet] = ACTIONS(6170),
    [anon_sym_BSLASHleft] = ACTIONS(6170),
    [anon_sym_BSLASHbigl] = ACTIONS(6170),
    [anon_sym_BSLASHBigl] = ACTIONS(6170),
    [anon_sym_BSLASHbiggl] = ACTIONS(6170),
    [anon_sym_BSLASHBiggl] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6170),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6170),
    [anon_sym_BSLASHgls] = ACTIONS(6170),
    [anon_sym_BSLASHGls] = ACTIONS(6170),
    [anon_sym_BSLASHGLS] = ACTIONS(6170),
    [anon_sym_BSLASHglspl] = ACTIONS(6170),
    [anon_sym_BSLASHGlspl] = ACTIONS(6170),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6170),
    [anon_sym_BSLASHglslink] = ACTIONS(6170),
    [anon_sym_BSLASHglstext] = ACTIONS(6170),
    [anon_sym_BSLASHGlstext] = ACTIONS(6170),
    [anon_sym_BSLASHGLStext] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6170),
    [anon_sym_BSLASHglsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsname] = ACTIONS(6170),
    [anon_sym_BSLASHGlsname] = ACTIONS(6170),
    [anon_sym_BSLASHGLSname] = ACTIONS(6170),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6170),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6170),
    [anon_sym_BSLASHacrshort] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6170),
    [anon_sym_BSLASHACRshort] = ACTIONS(6170),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrlong] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6170),
    [anon_sym_BSLASHACRlong] = ACTIONS(6170),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrfull] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6170),
    [anon_sym_BSLASHACRfull] = ACTIONS(6170),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHacs] = ACTIONS(6170),
    [anon_sym_BSLASHAcs] = ACTIONS(6170),
    [anon_sym_BSLASHacsp] = ACTIONS(6170),
    [anon_sym_BSLASHAcsp] = ACTIONS(6170),
    [anon_sym_BSLASHacl] = ACTIONS(6170),
    [anon_sym_BSLASHAcl] = ACTIONS(6170),
    [anon_sym_BSLASHaclp] = ACTIONS(6170),
    [anon_sym_BSLASHAclp] = ACTIONS(6170),
    [anon_sym_BSLASHacf] = ACTIONS(6170),
    [anon_sym_BSLASHAcf] = ACTIONS(6170),
    [anon_sym_BSLASHacfp] = ACTIONS(6170),
    [anon_sym_BSLASHAcfp] = ACTIONS(6170),
    [anon_sym_BSLASHac] = ACTIONS(6170),
    [anon_sym_BSLASHAc] = ACTIONS(6170),
    [anon_sym_BSLASHacp] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6170),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6170),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6170),
    [anon_sym_BSLASHcolor] = ACTIONS(6170),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6170),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6170),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6170),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6170),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6170),
    [anon_sym_BSLASHtext] = ACTIONS(6170),
    [anon_sym_BSLASHintertext] = ACTIONS(6170),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6170),
    [anon_sym_BSLASHurl] = ACTIONS(6170),
    [anon_sym_BSLASHhref] = ACTIONS(6170),
  },
  [1278] = {
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_LBRACK] = ACTIONS(6496),
    [anon_sym_RBRACK] = ACTIONS(6496),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6496),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_RPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHpart] = ACTIONS(6494),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddpart] = ACTIONS(6494),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHchapter] = ACTIONS(6494),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddchap] = ACTIONS(6494),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsection] = ACTIONS(6494),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHaddsec] = ACTIONS(6494),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6494),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6494),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHitem] = ACTIONS(6494),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6496),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6496),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6496),
    [anon_sym_DOLLAR] = ACTIONS(6494),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHbegin] = ACTIONS(6494),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHleft] = ACTIONS(6494),
    [anon_sym_BSLASHbigl] = ACTIONS(6494),
    [anon_sym_BSLASHBigl] = ACTIONS(6494),
    [anon_sym_BSLASHbiggl] = ACTIONS(6494),
    [anon_sym_BSLASHBiggl] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHtext] = ACTIONS(6494),
    [anon_sym_BSLASHintertext] = ACTIONS(6494),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [1279] = {
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6528),
    [anon_sym_RBRACK] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6528),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [anon_sym_RPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHpart] = ACTIONS(6526),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddpart] = ACTIONS(6526),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHchapter] = ACTIONS(6526),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddchap] = ACTIONS(6526),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsection] = ACTIONS(6526),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddsec] = ACTIONS(6526),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHitem] = ACTIONS(6526),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6528),
    [anon_sym_LBRACE] = ACTIONS(6528),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6528),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6528),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(6526),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHbegin] = ACTIONS(6526),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHleft] = ACTIONS(6526),
    [anon_sym_BSLASHbigl] = ACTIONS(6526),
    [anon_sym_BSLASHBigl] = ACTIONS(6526),
    [anon_sym_BSLASHbiggl] = ACTIONS(6526),
    [anon_sym_BSLASHBiggl] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHtext] = ACTIONS(6526),
    [anon_sym_BSLASHintertext] = ACTIONS(6526),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [1280] = {
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [1281] = {
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6328),
    [anon_sym_RBRACK] = ACTIONS(6328),
    [anon_sym_COMMA] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6328),
    [anon_sym_RPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHpart] = ACTIONS(6326),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddpart] = ACTIONS(6326),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHchapter] = ACTIONS(6326),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddchap] = ACTIONS(6326),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsection] = ACTIONS(6326),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddsec] = ACTIONS(6326),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHitem] = ACTIONS(6326),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6328),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6328),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6328),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6328),
    [anon_sym_DOLLAR] = ACTIONS(6326),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHbegin] = ACTIONS(6326),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHleft] = ACTIONS(6326),
    [anon_sym_BSLASHbigl] = ACTIONS(6326),
    [anon_sym_BSLASHBigl] = ACTIONS(6326),
    [anon_sym_BSLASHbiggl] = ACTIONS(6326),
    [anon_sym_BSLASHBiggl] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHtext] = ACTIONS(6326),
    [anon_sym_BSLASHintertext] = ACTIONS(6326),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [1282] = {
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHpart] = ACTIONS(6454),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddpart] = ACTIONS(6454),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHchapter] = ACTIONS(6454),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddchap] = ACTIONS(6454),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsection] = ACTIONS(6454),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddsec] = ACTIONS(6454),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHitem] = ACTIONS(6454),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6456),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6456),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(6454),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHbegin] = ACTIONS(6454),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHleft] = ACTIONS(6454),
    [anon_sym_BSLASHbigl] = ACTIONS(6454),
    [anon_sym_BSLASHBigl] = ACTIONS(6454),
    [anon_sym_BSLASHbiggl] = ACTIONS(6454),
    [anon_sym_BSLASHBiggl] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHtext] = ACTIONS(6454),
    [anon_sym_BSLASHintertext] = ACTIONS(6454),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [1283] = {
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6448),
    [anon_sym_RBRACK] = ACTIONS(6448),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(6448),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHpart] = ACTIONS(6446),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddpart] = ACTIONS(6446),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHchapter] = ACTIONS(6446),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddchap] = ACTIONS(6446),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsection] = ACTIONS(6446),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHaddsec] = ACTIONS(6446),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6446),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6446),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHitem] = ACTIONS(6446),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6448),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6448),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6448),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6448),
    [anon_sym_DOLLAR] = ACTIONS(6446),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHbegin] = ACTIONS(6446),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHleft] = ACTIONS(6446),
    [anon_sym_BSLASHbigl] = ACTIONS(6446),
    [anon_sym_BSLASHBigl] = ACTIONS(6446),
    [anon_sym_BSLASHbiggl] = ACTIONS(6446),
    [anon_sym_BSLASHBiggl] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHtext] = ACTIONS(6446),
    [anon_sym_BSLASHintertext] = ACTIONS(6446),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [1284] = {
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6444),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHpart] = ACTIONS(6442),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddpart] = ACTIONS(6442),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHchapter] = ACTIONS(6442),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddchap] = ACTIONS(6442),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsection] = ACTIONS(6442),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddsec] = ACTIONS(6442),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHitem] = ACTIONS(6442),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6444),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6444),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6444),
    [anon_sym_DOLLAR] = ACTIONS(6442),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHbegin] = ACTIONS(6442),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHleft] = ACTIONS(6442),
    [anon_sym_BSLASHbigl] = ACTIONS(6442),
    [anon_sym_BSLASHBigl] = ACTIONS(6442),
    [anon_sym_BSLASHbiggl] = ACTIONS(6442),
    [anon_sym_BSLASHBiggl] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHtext] = ACTIONS(6442),
    [anon_sym_BSLASHintertext] = ACTIONS(6442),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [1285] = {
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_LBRACK] = ACTIONS(6440),
    [anon_sym_RBRACK] = ACTIONS(6440),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6440),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_RPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHpart] = ACTIONS(6438),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddpart] = ACTIONS(6438),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHchapter] = ACTIONS(6438),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddchap] = ACTIONS(6438),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsection] = ACTIONS(6438),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddsec] = ACTIONS(6438),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHitem] = ACTIONS(6438),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6440),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6440),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6440),
    [anon_sym_DOLLAR] = ACTIONS(6438),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHbegin] = ACTIONS(6438),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHleft] = ACTIONS(6438),
    [anon_sym_BSLASHbigl] = ACTIONS(6438),
    [anon_sym_BSLASHBigl] = ACTIONS(6438),
    [anon_sym_BSLASHbiggl] = ACTIONS(6438),
    [anon_sym_BSLASHBiggl] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHtext] = ACTIONS(6438),
    [anon_sym_BSLASHintertext] = ACTIONS(6438),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [1286] = {
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6436),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_EQ] = ACTIONS(6436),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHpart] = ACTIONS(6434),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddpart] = ACTIONS(6434),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHchapter] = ACTIONS(6434),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddchap] = ACTIONS(6434),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsection] = ACTIONS(6434),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddsec] = ACTIONS(6434),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHitem] = ACTIONS(6434),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6436),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6436),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6436),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6436),
    [anon_sym_DOLLAR] = ACTIONS(6434),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHbegin] = ACTIONS(6434),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHleft] = ACTIONS(6434),
    [anon_sym_BSLASHbigl] = ACTIONS(6434),
    [anon_sym_BSLASHBigl] = ACTIONS(6434),
    [anon_sym_BSLASHbiggl] = ACTIONS(6434),
    [anon_sym_BSLASHBiggl] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHtext] = ACTIONS(6434),
    [anon_sym_BSLASHintertext] = ACTIONS(6434),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [1287] = {
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHpart] = ACTIONS(6430),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddpart] = ACTIONS(6430),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHchapter] = ACTIONS(6430),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddchap] = ACTIONS(6430),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsection] = ACTIONS(6430),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddsec] = ACTIONS(6430),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHitem] = ACTIONS(6430),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6432),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6432),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6432),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6432),
    [anon_sym_DOLLAR] = ACTIONS(6430),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHbegin] = ACTIONS(6430),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHleft] = ACTIONS(6430),
    [anon_sym_BSLASHbigl] = ACTIONS(6430),
    [anon_sym_BSLASHBigl] = ACTIONS(6430),
    [anon_sym_BSLASHbiggl] = ACTIONS(6430),
    [anon_sym_BSLASHBiggl] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHtext] = ACTIONS(6430),
    [anon_sym_BSLASHintertext] = ACTIONS(6430),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [1288] = {
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_RBRACK] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6428),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_RPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHpart] = ACTIONS(6426),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddpart] = ACTIONS(6426),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHchapter] = ACTIONS(6426),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddchap] = ACTIONS(6426),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsection] = ACTIONS(6426),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddsec] = ACTIONS(6426),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHitem] = ACTIONS(6426),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6428),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6428),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6428),
    [anon_sym_DOLLAR] = ACTIONS(6426),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHbegin] = ACTIONS(6426),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHleft] = ACTIONS(6426),
    [anon_sym_BSLASHbigl] = ACTIONS(6426),
    [anon_sym_BSLASHBigl] = ACTIONS(6426),
    [anon_sym_BSLASHbiggl] = ACTIONS(6426),
    [anon_sym_BSLASHBiggl] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHtext] = ACTIONS(6426),
    [anon_sym_BSLASHintertext] = ACTIONS(6426),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [1289] = {
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_LBRACK] = ACTIONS(6424),
    [anon_sym_RBRACK] = ACTIONS(6424),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_EQ] = ACTIONS(6424),
    [anon_sym_LPAREN] = ACTIONS(6424),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHpart] = ACTIONS(6422),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddpart] = ACTIONS(6422),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHchapter] = ACTIONS(6422),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddchap] = ACTIONS(6422),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsection] = ACTIONS(6422),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddsec] = ACTIONS(6422),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHitem] = ACTIONS(6422),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6424),
    [anon_sym_LBRACE] = ACTIONS(6424),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6424),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6424),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6424),
    [anon_sym_DOLLAR] = ACTIONS(6422),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHbegin] = ACTIONS(6422),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHleft] = ACTIONS(6422),
    [anon_sym_BSLASHbigl] = ACTIONS(6422),
    [anon_sym_BSLASHBigl] = ACTIONS(6422),
    [anon_sym_BSLASHbiggl] = ACTIONS(6422),
    [anon_sym_BSLASHBiggl] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHtext] = ACTIONS(6422),
    [anon_sym_BSLASHintertext] = ACTIONS(6422),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [1290] = {
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_RBRACK] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHpart] = ACTIONS(6418),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddpart] = ACTIONS(6418),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHchapter] = ACTIONS(6418),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddchap] = ACTIONS(6418),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsection] = ACTIONS(6418),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddsec] = ACTIONS(6418),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHitem] = ACTIONS(6418),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6420),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6420),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6420),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(6418),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHbegin] = ACTIONS(6418),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHleft] = ACTIONS(6418),
    [anon_sym_BSLASHbigl] = ACTIONS(6418),
    [anon_sym_BSLASHBigl] = ACTIONS(6418),
    [anon_sym_BSLASHbiggl] = ACTIONS(6418),
    [anon_sym_BSLASHBiggl] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHtext] = ACTIONS(6418),
    [anon_sym_BSLASHintertext] = ACTIONS(6418),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [1291] = {
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6416),
    [anon_sym_EQ] = ACTIONS(6416),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_RPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHpart] = ACTIONS(6414),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddpart] = ACTIONS(6414),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHchapter] = ACTIONS(6414),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddchap] = ACTIONS(6414),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsection] = ACTIONS(6414),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddsec] = ACTIONS(6414),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHitem] = ACTIONS(6414),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6416),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6416),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(6414),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHbegin] = ACTIONS(6414),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHleft] = ACTIONS(6414),
    [anon_sym_BSLASHbigl] = ACTIONS(6414),
    [anon_sym_BSLASHBigl] = ACTIONS(6414),
    [anon_sym_BSLASHbiggl] = ACTIONS(6414),
    [anon_sym_BSLASHBiggl] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHtext] = ACTIONS(6414),
    [anon_sym_BSLASHintertext] = ACTIONS(6414),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [1292] = {
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6412),
    [anon_sym_RBRACK] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHpart] = ACTIONS(6410),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddpart] = ACTIONS(6410),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHchapter] = ACTIONS(6410),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddchap] = ACTIONS(6410),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsection] = ACTIONS(6410),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddsec] = ACTIONS(6410),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHitem] = ACTIONS(6410),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6412),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6412),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6412),
    [anon_sym_DOLLAR] = ACTIONS(6410),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHbegin] = ACTIONS(6410),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHleft] = ACTIONS(6410),
    [anon_sym_BSLASHbigl] = ACTIONS(6410),
    [anon_sym_BSLASHBigl] = ACTIONS(6410),
    [anon_sym_BSLASHbiggl] = ACTIONS(6410),
    [anon_sym_BSLASHBiggl] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHtext] = ACTIONS(6410),
    [anon_sym_BSLASHintertext] = ACTIONS(6410),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [1293] = {
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHpart] = ACTIONS(6406),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddpart] = ACTIONS(6406),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHchapter] = ACTIONS(6406),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddchap] = ACTIONS(6406),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsection] = ACTIONS(6406),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddsec] = ACTIONS(6406),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHitem] = ACTIONS(6406),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6408),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6408),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6408),
    [anon_sym_DOLLAR] = ACTIONS(6406),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHbegin] = ACTIONS(6406),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHleft] = ACTIONS(6406),
    [anon_sym_BSLASHbigl] = ACTIONS(6406),
    [anon_sym_BSLASHBigl] = ACTIONS(6406),
    [anon_sym_BSLASHbiggl] = ACTIONS(6406),
    [anon_sym_BSLASHBiggl] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHtext] = ACTIONS(6406),
    [anon_sym_BSLASHintertext] = ACTIONS(6406),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [1294] = {
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6404),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6404),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHpart] = ACTIONS(6402),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddpart] = ACTIONS(6402),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHchapter] = ACTIONS(6402),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddchap] = ACTIONS(6402),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsection] = ACTIONS(6402),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddsec] = ACTIONS(6402),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHitem] = ACTIONS(6402),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6404),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6404),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6404),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6404),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHbegin] = ACTIONS(6402),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHleft] = ACTIONS(6402),
    [anon_sym_BSLASHbigl] = ACTIONS(6402),
    [anon_sym_BSLASHBigl] = ACTIONS(6402),
    [anon_sym_BSLASHbiggl] = ACTIONS(6402),
    [anon_sym_BSLASHBiggl] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHtext] = ACTIONS(6402),
    [anon_sym_BSLASHintertext] = ACTIONS(6402),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [1295] = {
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHpart] = ACTIONS(6322),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddpart] = ACTIONS(6322),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHchapter] = ACTIONS(6322),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddchap] = ACTIONS(6322),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsection] = ACTIONS(6322),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddsec] = ACTIONS(6322),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHitem] = ACTIONS(6322),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6324),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6324),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6324),
    [anon_sym_DOLLAR] = ACTIONS(6322),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHbegin] = ACTIONS(6322),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHleft] = ACTIONS(6322),
    [anon_sym_BSLASHbigl] = ACTIONS(6322),
    [anon_sym_BSLASHBigl] = ACTIONS(6322),
    [anon_sym_BSLASHbiggl] = ACTIONS(6322),
    [anon_sym_BSLASHBiggl] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHtext] = ACTIONS(6322),
    [anon_sym_BSLASHintertext] = ACTIONS(6322),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [1296] = {
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6400),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHpart] = ACTIONS(6398),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddpart] = ACTIONS(6398),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHchapter] = ACTIONS(6398),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddchap] = ACTIONS(6398),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsection] = ACTIONS(6398),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddsec] = ACTIONS(6398),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHitem] = ACTIONS(6398),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6400),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6400),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHbegin] = ACTIONS(6398),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHleft] = ACTIONS(6398),
    [anon_sym_BSLASHbigl] = ACTIONS(6398),
    [anon_sym_BSLASHBigl] = ACTIONS(6398),
    [anon_sym_BSLASHbiggl] = ACTIONS(6398),
    [anon_sym_BSLASHBiggl] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHtext] = ACTIONS(6398),
    [anon_sym_BSLASHintertext] = ACTIONS(6398),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [1297] = {
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6396),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6396),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHpart] = ACTIONS(6394),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddpart] = ACTIONS(6394),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHchapter] = ACTIONS(6394),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddchap] = ACTIONS(6394),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsection] = ACTIONS(6394),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddsec] = ACTIONS(6394),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHitem] = ACTIONS(6394),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6396),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6396),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6396),
    [anon_sym_DOLLAR] = ACTIONS(6394),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHbegin] = ACTIONS(6394),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHleft] = ACTIONS(6394),
    [anon_sym_BSLASHbigl] = ACTIONS(6394),
    [anon_sym_BSLASHBigl] = ACTIONS(6394),
    [anon_sym_BSLASHbiggl] = ACTIONS(6394),
    [anon_sym_BSLASHBiggl] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHtext] = ACTIONS(6394),
    [anon_sym_BSLASHintertext] = ACTIONS(6394),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [1298] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2401),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7085),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1299] = {
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_COMMA] = ACTIONS(6392),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHpart] = ACTIONS(6390),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddpart] = ACTIONS(6390),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHchapter] = ACTIONS(6390),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddchap] = ACTIONS(6390),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsection] = ACTIONS(6390),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddsec] = ACTIONS(6390),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHitem] = ACTIONS(6390),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6392),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6392),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(6390),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHbegin] = ACTIONS(6390),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHleft] = ACTIONS(6390),
    [anon_sym_BSLASHbigl] = ACTIONS(6390),
    [anon_sym_BSLASHBigl] = ACTIONS(6390),
    [anon_sym_BSLASHbiggl] = ACTIONS(6390),
    [anon_sym_BSLASHBiggl] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHtext] = ACTIONS(6390),
    [anon_sym_BSLASHintertext] = ACTIONS(6390),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [1300] = {
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_COMMA] = ACTIONS(6388),
    [anon_sym_EQ] = ACTIONS(6388),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHpart] = ACTIONS(6386),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddpart] = ACTIONS(6386),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHchapter] = ACTIONS(6386),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddchap] = ACTIONS(6386),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsection] = ACTIONS(6386),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddsec] = ACTIONS(6386),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHitem] = ACTIONS(6386),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6388),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6388),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(6386),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHbegin] = ACTIONS(6386),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHleft] = ACTIONS(6386),
    [anon_sym_BSLASHbigl] = ACTIONS(6386),
    [anon_sym_BSLASHBigl] = ACTIONS(6386),
    [anon_sym_BSLASHbiggl] = ACTIONS(6386),
    [anon_sym_BSLASHBiggl] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHtext] = ACTIONS(6386),
    [anon_sym_BSLASHintertext] = ACTIONS(6386),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [1301] = {
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_LBRACK] = ACTIONS(6384),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_EQ] = ACTIONS(6384),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_RPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHpart] = ACTIONS(6382),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddpart] = ACTIONS(6382),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHchapter] = ACTIONS(6382),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddchap] = ACTIONS(6382),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsection] = ACTIONS(6382),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddsec] = ACTIONS(6382),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHitem] = ACTIONS(6382),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6384),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6384),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6384),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(6382),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHbegin] = ACTIONS(6382),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHleft] = ACTIONS(6382),
    [anon_sym_BSLASHbigl] = ACTIONS(6382),
    [anon_sym_BSLASHBigl] = ACTIONS(6382),
    [anon_sym_BSLASHbiggl] = ACTIONS(6382),
    [anon_sym_BSLASHBiggl] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHtext] = ACTIONS(6382),
    [anon_sym_BSLASHintertext] = ACTIONS(6382),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [1302] = {
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_LBRACK] = ACTIONS(6380),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_EQ] = ACTIONS(6380),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHpart] = ACTIONS(6378),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddpart] = ACTIONS(6378),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHchapter] = ACTIONS(6378),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddchap] = ACTIONS(6378),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsection] = ACTIONS(6378),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddsec] = ACTIONS(6378),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHitem] = ACTIONS(6378),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6380),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6380),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6380),
    [anon_sym_DOLLAR] = ACTIONS(6378),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHbegin] = ACTIONS(6378),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHleft] = ACTIONS(6378),
    [anon_sym_BSLASHbigl] = ACTIONS(6378),
    [anon_sym_BSLASHBigl] = ACTIONS(6378),
    [anon_sym_BSLASHbiggl] = ACTIONS(6378),
    [anon_sym_BSLASHBiggl] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHtext] = ACTIONS(6378),
    [anon_sym_BSLASHintertext] = ACTIONS(6378),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [1303] = {
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_LBRACK] = ACTIONS(6272),
    [anon_sym_RBRACK] = ACTIONS(6272),
    [anon_sym_COMMA] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_LPAREN] = ACTIONS(6272),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHpart] = ACTIONS(6270),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddpart] = ACTIONS(6270),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHchapter] = ACTIONS(6270),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddchap] = ACTIONS(6270),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsection] = ACTIONS(6270),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddsec] = ACTIONS(6270),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHitem] = ACTIONS(6270),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6272),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6272),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6272),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6272),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHbegin] = ACTIONS(6270),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHleft] = ACTIONS(6270),
    [anon_sym_BSLASHbigl] = ACTIONS(6270),
    [anon_sym_BSLASHBigl] = ACTIONS(6270),
    [anon_sym_BSLASHbiggl] = ACTIONS(6270),
    [anon_sym_BSLASHBiggl] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHtext] = ACTIONS(6270),
    [anon_sym_BSLASHintertext] = ACTIONS(6270),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [1304] = {
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6288),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHpart] = ACTIONS(6286),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddpart] = ACTIONS(6286),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHchapter] = ACTIONS(6286),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddchap] = ACTIONS(6286),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsection] = ACTIONS(6286),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddsec] = ACTIONS(6286),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHitem] = ACTIONS(6286),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6288),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6288),
    [anon_sym_DOLLAR] = ACTIONS(6286),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6288),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHbegin] = ACTIONS(6286),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHleft] = ACTIONS(6286),
    [anon_sym_BSLASHbigl] = ACTIONS(6286),
    [anon_sym_BSLASHBigl] = ACTIONS(6286),
    [anon_sym_BSLASHbiggl] = ACTIONS(6286),
    [anon_sym_BSLASHBiggl] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHtext] = ACTIONS(6286),
    [anon_sym_BSLASHintertext] = ACTIONS(6286),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [1305] = {
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6292),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_COMMA] = ACTIONS(6292),
    [anon_sym_EQ] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_RPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHpart] = ACTIONS(6290),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddpart] = ACTIONS(6290),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHchapter] = ACTIONS(6290),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddchap] = ACTIONS(6290),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsection] = ACTIONS(6290),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddsec] = ACTIONS(6290),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHitem] = ACTIONS(6290),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6292),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6292),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6292),
    [anon_sym_DOLLAR] = ACTIONS(6290),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6292),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHbegin] = ACTIONS(6290),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHleft] = ACTIONS(6290),
    [anon_sym_BSLASHbigl] = ACTIONS(6290),
    [anon_sym_BSLASHBigl] = ACTIONS(6290),
    [anon_sym_BSLASHbiggl] = ACTIONS(6290),
    [anon_sym_BSLASHBiggl] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHtext] = ACTIONS(6290),
    [anon_sym_BSLASHintertext] = ACTIONS(6290),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [1306] = {
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6312),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6312),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHpart] = ACTIONS(6310),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddpart] = ACTIONS(6310),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHchapter] = ACTIONS(6310),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddchap] = ACTIONS(6310),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsection] = ACTIONS(6310),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddsec] = ACTIONS(6310),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHitem] = ACTIONS(6310),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6312),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6312),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6312),
    [anon_sym_DOLLAR] = ACTIONS(6310),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6312),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHbegin] = ACTIONS(6310),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHleft] = ACTIONS(6310),
    [anon_sym_BSLASHbigl] = ACTIONS(6310),
    [anon_sym_BSLASHBigl] = ACTIONS(6310),
    [anon_sym_BSLASHbiggl] = ACTIONS(6310),
    [anon_sym_BSLASHBiggl] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHtext] = ACTIONS(6310),
    [anon_sym_BSLASHintertext] = ACTIONS(6310),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [1307] = {
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_COMMA] = ACTIONS(6316),
    [anon_sym_EQ] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6316),
    [anon_sym_RPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHpart] = ACTIONS(6314),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddpart] = ACTIONS(6314),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHchapter] = ACTIONS(6314),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddchap] = ACTIONS(6314),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsection] = ACTIONS(6314),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddsec] = ACTIONS(6314),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHitem] = ACTIONS(6314),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6316),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6316),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6316),
    [anon_sym_DOLLAR] = ACTIONS(6314),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6316),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHbegin] = ACTIONS(6314),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHleft] = ACTIONS(6314),
    [anon_sym_BSLASHbigl] = ACTIONS(6314),
    [anon_sym_BSLASHBigl] = ACTIONS(6314),
    [anon_sym_BSLASHbiggl] = ACTIONS(6314),
    [anon_sym_BSLASHBiggl] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHtext] = ACTIONS(6314),
    [anon_sym_BSLASHintertext] = ACTIONS(6314),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [1308] = {
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_RBRACK] = ACTIONS(6320),
    [anon_sym_COMMA] = ACTIONS(6320),
    [anon_sym_EQ] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(6320),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHpart] = ACTIONS(6318),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddpart] = ACTIONS(6318),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHchapter] = ACTIONS(6318),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddchap] = ACTIONS(6318),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsection] = ACTIONS(6318),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddsec] = ACTIONS(6318),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHitem] = ACTIONS(6318),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6320),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6320),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6320),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHbegin] = ACTIONS(6318),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHleft] = ACTIONS(6318),
    [anon_sym_BSLASHbigl] = ACTIONS(6318),
    [anon_sym_BSLASHBigl] = ACTIONS(6318),
    [anon_sym_BSLASHbiggl] = ACTIONS(6318),
    [anon_sym_BSLASHBiggl] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHtext] = ACTIONS(6318),
    [anon_sym_BSLASHintertext] = ACTIONS(6318),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [1309] = {
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHpart] = ACTIONS(6322),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddpart] = ACTIONS(6322),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHchapter] = ACTIONS(6322),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddchap] = ACTIONS(6322),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsection] = ACTIONS(6322),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHaddsec] = ACTIONS(6322),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6322),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6322),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHitem] = ACTIONS(6322),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6324),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6324),
    [anon_sym_DOLLAR] = ACTIONS(6322),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6324),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHbegin] = ACTIONS(6322),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHleft] = ACTIONS(6322),
    [anon_sym_BSLASHbigl] = ACTIONS(6322),
    [anon_sym_BSLASHBigl] = ACTIONS(6322),
    [anon_sym_BSLASHbiggl] = ACTIONS(6322),
    [anon_sym_BSLASHBiggl] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHtext] = ACTIONS(6322),
    [anon_sym_BSLASHintertext] = ACTIONS(6322),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [1310] = {
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6328),
    [anon_sym_RBRACK] = ACTIONS(6328),
    [anon_sym_COMMA] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6328),
    [anon_sym_RPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHpart] = ACTIONS(6326),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddpart] = ACTIONS(6326),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHchapter] = ACTIONS(6326),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddchap] = ACTIONS(6326),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsection] = ACTIONS(6326),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHaddsec] = ACTIONS(6326),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6326),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6326),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHitem] = ACTIONS(6326),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6328),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6328),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6328),
    [anon_sym_DOLLAR] = ACTIONS(6326),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6328),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHbegin] = ACTIONS(6326),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHleft] = ACTIONS(6326),
    [anon_sym_BSLASHbigl] = ACTIONS(6326),
    [anon_sym_BSLASHBigl] = ACTIONS(6326),
    [anon_sym_BSLASHbiggl] = ACTIONS(6326),
    [anon_sym_BSLASHBiggl] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHtext] = ACTIONS(6326),
    [anon_sym_BSLASHintertext] = ACTIONS(6326),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [1311] = {
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6332),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_EQ] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6332),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHpart] = ACTIONS(6330),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddpart] = ACTIONS(6330),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHchapter] = ACTIONS(6330),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddchap] = ACTIONS(6330),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsection] = ACTIONS(6330),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHaddsec] = ACTIONS(6330),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6330),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6330),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHitem] = ACTIONS(6330),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6332),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6330),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6332),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHbegin] = ACTIONS(6330),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHleft] = ACTIONS(6330),
    [anon_sym_BSLASHbigl] = ACTIONS(6330),
    [anon_sym_BSLASHBigl] = ACTIONS(6330),
    [anon_sym_BSLASHbiggl] = ACTIONS(6330),
    [anon_sym_BSLASHBiggl] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHtext] = ACTIONS(6330),
    [anon_sym_BSLASHintertext] = ACTIONS(6330),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [1312] = {
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6336),
    [anon_sym_RBRACK] = ACTIONS(6336),
    [anon_sym_COMMA] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_RPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHpart] = ACTIONS(6334),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddpart] = ACTIONS(6334),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHchapter] = ACTIONS(6334),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddchap] = ACTIONS(6334),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsection] = ACTIONS(6334),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHaddsec] = ACTIONS(6334),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6334),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6334),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHitem] = ACTIONS(6334),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6336),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6336),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHbegin] = ACTIONS(6334),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHleft] = ACTIONS(6334),
    [anon_sym_BSLASHbigl] = ACTIONS(6334),
    [anon_sym_BSLASHBigl] = ACTIONS(6334),
    [anon_sym_BSLASHbiggl] = ACTIONS(6334),
    [anon_sym_BSLASHBiggl] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHtext] = ACTIONS(6334),
    [anon_sym_BSLASHintertext] = ACTIONS(6334),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [1313] = {
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHpart] = ACTIONS(161),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddpart] = ACTIONS(161),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(163),
    [anon_sym_BSLASHchapter] = ACTIONS(161),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddchap] = ACTIONS(161),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsection] = ACTIONS(161),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHaddsec] = ACTIONS(161),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(161),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(163),
    [anon_sym_BSLASHparagraph] = ACTIONS(161),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(161),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(163),
    [anon_sym_BSLASHitem] = ACTIONS(161),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(163),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [1314] = {
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [1315] = {
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_RBRACK] = ACTIONS(6636),
    [anon_sym_COMMA] = ACTIONS(6636),
    [anon_sym_EQ] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(6636),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHpart] = ACTIONS(6634),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddpart] = ACTIONS(6634),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHchapter] = ACTIONS(6634),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddchap] = ACTIONS(6634),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsection] = ACTIONS(6634),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddsec] = ACTIONS(6634),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHitem] = ACTIONS(6634),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6636),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(6634),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6636),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHbegin] = ACTIONS(6634),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHleft] = ACTIONS(6634),
    [anon_sym_BSLASHbigl] = ACTIONS(6634),
    [anon_sym_BSLASHBigl] = ACTIONS(6634),
    [anon_sym_BSLASHbiggl] = ACTIONS(6634),
    [anon_sym_BSLASHBiggl] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHtext] = ACTIONS(6634),
    [anon_sym_BSLASHintertext] = ACTIONS(6634),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [1316] = {
    [sym_command_name] = ACTIONS(6294),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6294),
    [anon_sym_LBRACK] = ACTIONS(6296),
    [anon_sym_RBRACK] = ACTIONS(6296),
    [anon_sym_COMMA] = ACTIONS(6296),
    [anon_sym_EQ] = ACTIONS(6296),
    [anon_sym_LPAREN] = ACTIONS(6296),
    [anon_sym_RPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHpart] = ACTIONS(6294),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddpart] = ACTIONS(6294),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHchapter] = ACTIONS(6294),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddchap] = ACTIONS(6294),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsection] = ACTIONS(6294),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddsec] = ACTIONS(6294),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHitem] = ACTIONS(6294),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6296),
    [anon_sym_LBRACE] = ACTIONS(6296),
    [sym_word] = ACTIONS(6294),
    [sym_placeholder] = ACTIONS(6296),
    [anon_sym_PLUS] = ACTIONS(6296),
    [anon_sym_DASH] = ACTIONS(6296),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_SLASH] = ACTIONS(6296),
    [anon_sym_LT] = ACTIONS(6294),
    [anon_sym_GT] = ACTIONS(6294),
    [anon_sym_BANG] = ACTIONS(6294),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COLON] = ACTIONS(6294),
    [anon_sym_SQUOTE] = ACTIONS(6294),
    [anon_sym__] = ACTIONS(6296),
    [anon_sym_CARET] = ACTIONS(6296),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6296),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6296),
    [anon_sym_DOLLAR] = ACTIONS(6294),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6296),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHbegin] = ACTIONS(6294),
    [anon_sym_BSLASHtitle] = ACTIONS(6294),
    [anon_sym_BSLASHauthor] = ACTIONS(6294),
    [anon_sym_BSLASHusepackage] = ACTIONS(6294),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6294),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6294),
    [anon_sym_BSLASHinclude] = ACTIONS(6294),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6294),
    [anon_sym_BSLASHinput] = ACTIONS(6294),
    [anon_sym_BSLASHsubfile] = ACTIONS(6294),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6294),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6294),
    [anon_sym_BSLASHbibliography] = ACTIONS(6294),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6294),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6294),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6294),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6294),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6294),
    [anon_sym_BSLASHimport] = ACTIONS(6294),
    [anon_sym_BSLASHsubimport] = ACTIONS(6294),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6294),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHcaption] = ACTIONS(6294),
    [anon_sym_BSLASHcite] = ACTIONS(6294),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCite] = ACTIONS(6294),
    [anon_sym_BSLASHnocite] = ACTIONS(6294),
    [anon_sym_BSLASHcitet] = ACTIONS(6294),
    [anon_sym_BSLASHcitep] = ACTIONS(6294),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteA] = ACTIONS(6294),
    [anon_sym_BSLASHciteR] = ACTIONS(6294),
    [anon_sym_BSLASHciteS] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6294),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteyear] = ACTIONS(6294),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitedate] = ACTIONS(6294),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteurl] = ACTIONS(6294),
    [anon_sym_BSLASHfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6294),
    [anon_sym_BSLASHcitealt] = ACTIONS(6294),
    [anon_sym_BSLASHcitealp] = ACTIONS(6294),
    [anon_sym_BSLASHcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHparencite] = ACTIONS(6294),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHParencite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHtextcite] = ACTIONS(6294),
    [anon_sym_BSLASHTextcite] = ACTIONS(6294),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHsupercite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite] = ACTIONS(6294),
    [anon_sym_BSLASHAutocite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHVolcite] = ACTIONS(6294),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHavolcite] = ACTIONS(6294),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHNotecite] = ACTIONS(6294),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHlabel] = ACTIONS(6294),
    [anon_sym_BSLASHref] = ACTIONS(6294),
    [anon_sym_BSLASHeqref] = ACTIONS(6294),
    [anon_sym_BSLASHvref] = ACTIONS(6294),
    [anon_sym_BSLASHVref] = ACTIONS(6294),
    [anon_sym_BSLASHautoref] = ACTIONS(6294),
    [anon_sym_BSLASHpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcref] = ACTIONS(6294),
    [anon_sym_BSLASHCref] = ACTIONS(6294),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnameCref] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHdef] = ACTIONS(6294),
    [anon_sym_BSLASHlet] = ACTIONS(6294),
    [anon_sym_BSLASHleft] = ACTIONS(6294),
    [anon_sym_BSLASHbigl] = ACTIONS(6294),
    [anon_sym_BSLASHBigl] = ACTIONS(6294),
    [anon_sym_BSLASHbiggl] = ACTIONS(6294),
    [anon_sym_BSLASHBiggl] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6294),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6294),
    [anon_sym_BSLASHgls] = ACTIONS(6294),
    [anon_sym_BSLASHGls] = ACTIONS(6294),
    [anon_sym_BSLASHGLS] = ACTIONS(6294),
    [anon_sym_BSLASHglspl] = ACTIONS(6294),
    [anon_sym_BSLASHGlspl] = ACTIONS(6294),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6294),
    [anon_sym_BSLASHglslink] = ACTIONS(6294),
    [anon_sym_BSLASHglstext] = ACTIONS(6294),
    [anon_sym_BSLASHGlstext] = ACTIONS(6294),
    [anon_sym_BSLASHGLStext] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6294),
    [anon_sym_BSLASHglsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsname] = ACTIONS(6294),
    [anon_sym_BSLASHGlsname] = ACTIONS(6294),
    [anon_sym_BSLASHGLSname] = ACTIONS(6294),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6294),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6294),
    [anon_sym_BSLASHacrshort] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6294),
    [anon_sym_BSLASHACRshort] = ACTIONS(6294),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrlong] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6294),
    [anon_sym_BSLASHACRlong] = ACTIONS(6294),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrfull] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6294),
    [anon_sym_BSLASHACRfull] = ACTIONS(6294),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHacs] = ACTIONS(6294),
    [anon_sym_BSLASHAcs] = ACTIONS(6294),
    [anon_sym_BSLASHacsp] = ACTIONS(6294),
    [anon_sym_BSLASHAcsp] = ACTIONS(6294),
    [anon_sym_BSLASHacl] = ACTIONS(6294),
    [anon_sym_BSLASHAcl] = ACTIONS(6294),
    [anon_sym_BSLASHaclp] = ACTIONS(6294),
    [anon_sym_BSLASHAclp] = ACTIONS(6294),
    [anon_sym_BSLASHacf] = ACTIONS(6294),
    [anon_sym_BSLASHAcf] = ACTIONS(6294),
    [anon_sym_BSLASHacfp] = ACTIONS(6294),
    [anon_sym_BSLASHAcfp] = ACTIONS(6294),
    [anon_sym_BSLASHac] = ACTIONS(6294),
    [anon_sym_BSLASHAc] = ACTIONS(6294),
    [anon_sym_BSLASHacp] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6294),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6294),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6294),
    [anon_sym_BSLASHcolor] = ACTIONS(6294),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6294),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6294),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6294),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6294),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6294),
    [anon_sym_BSLASHtext] = ACTIONS(6294),
    [anon_sym_BSLASHintertext] = ACTIONS(6294),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6294),
    [anon_sym_BSLASHurl] = ACTIONS(6294),
    [anon_sym_BSLASHhref] = ACTIONS(6294),
  },
  [1317] = {
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_LBRACK] = ACTIONS(6376),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_EQ] = ACTIONS(6376),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHpart] = ACTIONS(6374),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddpart] = ACTIONS(6374),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHchapter] = ACTIONS(6374),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddchap] = ACTIONS(6374),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsection] = ACTIONS(6374),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddsec] = ACTIONS(6374),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHitem] = ACTIONS(6374),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6376),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6376),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6376),
    [anon_sym_DOLLAR] = ACTIONS(6374),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHbegin] = ACTIONS(6374),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHleft] = ACTIONS(6374),
    [anon_sym_BSLASHbigl] = ACTIONS(6374),
    [anon_sym_BSLASHBigl] = ACTIONS(6374),
    [anon_sym_BSLASHbiggl] = ACTIONS(6374),
    [anon_sym_BSLASHBiggl] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHtext] = ACTIONS(6374),
    [anon_sym_BSLASHintertext] = ACTIONS(6374),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [1318] = {
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [anon_sym_RPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHpart] = ACTIONS(6346),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddpart] = ACTIONS(6346),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHchapter] = ACTIONS(6346),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddchap] = ACTIONS(6346),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsection] = ACTIONS(6346),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddsec] = ACTIONS(6346),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHitem] = ACTIONS(6346),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6348),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6348),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6348),
    [anon_sym_DOLLAR] = ACTIONS(6346),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6348),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHbegin] = ACTIONS(6346),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHleft] = ACTIONS(6346),
    [anon_sym_BSLASHbigl] = ACTIONS(6346),
    [anon_sym_BSLASHBigl] = ACTIONS(6346),
    [anon_sym_BSLASHbiggl] = ACTIONS(6346),
    [anon_sym_BSLASHBiggl] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHtext] = ACTIONS(6346),
    [anon_sym_BSLASHintertext] = ACTIONS(6346),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [1319] = {
    [sym_command_name] = ACTIONS(6542),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6544),
    [anon_sym_RBRACK] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LPAREN] = ACTIONS(6544),
    [anon_sym_RPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHpart] = ACTIONS(6542),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddpart] = ACTIONS(6542),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHchapter] = ACTIONS(6542),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddchap] = ACTIONS(6542),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsection] = ACTIONS(6542),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddsec] = ACTIONS(6542),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHitem] = ACTIONS(6542),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6544),
    [anon_sym_LBRACE] = ACTIONS(6544),
    [sym_word] = ACTIONS(6542),
    [sym_placeholder] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_DASH] = ACTIONS(6544),
    [anon_sym_STAR] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6542),
    [anon_sym_GT] = ACTIONS(6542),
    [anon_sym_BANG] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6542),
    [anon_sym_COLON] = ACTIONS(6542),
    [anon_sym_SQUOTE] = ACTIONS(6542),
    [anon_sym__] = ACTIONS(6544),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6544),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6544),
    [anon_sym_DOLLAR] = ACTIONS(6542),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6544),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHbegin] = ACTIONS(6542),
    [anon_sym_BSLASHtitle] = ACTIONS(6542),
    [anon_sym_BSLASHauthor] = ACTIONS(6542),
    [anon_sym_BSLASHusepackage] = ACTIONS(6542),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6542),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6542),
    [anon_sym_BSLASHinclude] = ACTIONS(6542),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6542),
    [anon_sym_BSLASHinput] = ACTIONS(6542),
    [anon_sym_BSLASHsubfile] = ACTIONS(6542),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6542),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6542),
    [anon_sym_BSLASHbibliography] = ACTIONS(6542),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6542),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6542),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6542),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6542),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6542),
    [anon_sym_BSLASHimport] = ACTIONS(6542),
    [anon_sym_BSLASHsubimport] = ACTIONS(6542),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6542),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHcaption] = ACTIONS(6542),
    [anon_sym_BSLASHcite] = ACTIONS(6542),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCite] = ACTIONS(6542),
    [anon_sym_BSLASHnocite] = ACTIONS(6542),
    [anon_sym_BSLASHcitet] = ACTIONS(6542),
    [anon_sym_BSLASHcitep] = ACTIONS(6542),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteA] = ACTIONS(6542),
    [anon_sym_BSLASHciteR] = ACTIONS(6542),
    [anon_sym_BSLASHciteS] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6542),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteyear] = ACTIONS(6542),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitedate] = ACTIONS(6542),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteurl] = ACTIONS(6542),
    [anon_sym_BSLASHfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6542),
    [anon_sym_BSLASHcitealt] = ACTIONS(6542),
    [anon_sym_BSLASHcitealp] = ACTIONS(6542),
    [anon_sym_BSLASHcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHparencite] = ACTIONS(6542),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHParencite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHtextcite] = ACTIONS(6542),
    [anon_sym_BSLASHTextcite] = ACTIONS(6542),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHsupercite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite] = ACTIONS(6542),
    [anon_sym_BSLASHAutocite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHVolcite] = ACTIONS(6542),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHavolcite] = ACTIONS(6542),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHNotecite] = ACTIONS(6542),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHlabel] = ACTIONS(6542),
    [anon_sym_BSLASHref] = ACTIONS(6542),
    [anon_sym_BSLASHeqref] = ACTIONS(6542),
    [anon_sym_BSLASHvref] = ACTIONS(6542),
    [anon_sym_BSLASHVref] = ACTIONS(6542),
    [anon_sym_BSLASHautoref] = ACTIONS(6542),
    [anon_sym_BSLASHpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcref] = ACTIONS(6542),
    [anon_sym_BSLASHCref] = ACTIONS(6542),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnameCref] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHdef] = ACTIONS(6542),
    [anon_sym_BSLASHlet] = ACTIONS(6542),
    [anon_sym_BSLASHleft] = ACTIONS(6542),
    [anon_sym_BSLASHbigl] = ACTIONS(6542),
    [anon_sym_BSLASHBigl] = ACTIONS(6542),
    [anon_sym_BSLASHbiggl] = ACTIONS(6542),
    [anon_sym_BSLASHBiggl] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6542),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6542),
    [anon_sym_BSLASHgls] = ACTIONS(6542),
    [anon_sym_BSLASHGls] = ACTIONS(6542),
    [anon_sym_BSLASHGLS] = ACTIONS(6542),
    [anon_sym_BSLASHglspl] = ACTIONS(6542),
    [anon_sym_BSLASHGlspl] = ACTIONS(6542),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6542),
    [anon_sym_BSLASHglslink] = ACTIONS(6542),
    [anon_sym_BSLASHglstext] = ACTIONS(6542),
    [anon_sym_BSLASHGlstext] = ACTIONS(6542),
    [anon_sym_BSLASHGLStext] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6542),
    [anon_sym_BSLASHglsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsname] = ACTIONS(6542),
    [anon_sym_BSLASHGlsname] = ACTIONS(6542),
    [anon_sym_BSLASHGLSname] = ACTIONS(6542),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6542),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6542),
    [anon_sym_BSLASHacrshort] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6542),
    [anon_sym_BSLASHACRshort] = ACTIONS(6542),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrlong] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6542),
    [anon_sym_BSLASHACRlong] = ACTIONS(6542),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrfull] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6542),
    [anon_sym_BSLASHACRfull] = ACTIONS(6542),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHacs] = ACTIONS(6542),
    [anon_sym_BSLASHAcs] = ACTIONS(6542),
    [anon_sym_BSLASHacsp] = ACTIONS(6542),
    [anon_sym_BSLASHAcsp] = ACTIONS(6542),
    [anon_sym_BSLASHacl] = ACTIONS(6542),
    [anon_sym_BSLASHAcl] = ACTIONS(6542),
    [anon_sym_BSLASHaclp] = ACTIONS(6542),
    [anon_sym_BSLASHAclp] = ACTIONS(6542),
    [anon_sym_BSLASHacf] = ACTIONS(6542),
    [anon_sym_BSLASHAcf] = ACTIONS(6542),
    [anon_sym_BSLASHacfp] = ACTIONS(6542),
    [anon_sym_BSLASHAcfp] = ACTIONS(6542),
    [anon_sym_BSLASHac] = ACTIONS(6542),
    [anon_sym_BSLASHAc] = ACTIONS(6542),
    [anon_sym_BSLASHacp] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6542),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6542),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6542),
    [anon_sym_BSLASHcolor] = ACTIONS(6542),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6542),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6542),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6542),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6542),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6542),
    [anon_sym_BSLASHtext] = ACTIONS(6542),
    [anon_sym_BSLASHintertext] = ACTIONS(6542),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6542),
    [anon_sym_BSLASHurl] = ACTIONS(6542),
    [anon_sym_BSLASHhref] = ACTIONS(6542),
  },
  [1320] = {
    [sym_command_name] = ACTIONS(6546),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6548),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LPAREN] = ACTIONS(6548),
    [anon_sym_RPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHpart] = ACTIONS(6546),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddpart] = ACTIONS(6546),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHchapter] = ACTIONS(6546),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddchap] = ACTIONS(6546),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsection] = ACTIONS(6546),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddsec] = ACTIONS(6546),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHitem] = ACTIONS(6546),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6548),
    [anon_sym_LBRACE] = ACTIONS(6548),
    [sym_word] = ACTIONS(6546),
    [sym_placeholder] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_DASH] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6546),
    [anon_sym_GT] = ACTIONS(6546),
    [anon_sym_BANG] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6546),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_SQUOTE] = ACTIONS(6546),
    [anon_sym__] = ACTIONS(6548),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6548),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6548),
    [anon_sym_DOLLAR] = ACTIONS(6546),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6548),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHbegin] = ACTIONS(6546),
    [anon_sym_BSLASHtitle] = ACTIONS(6546),
    [anon_sym_BSLASHauthor] = ACTIONS(6546),
    [anon_sym_BSLASHusepackage] = ACTIONS(6546),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6546),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6546),
    [anon_sym_BSLASHinclude] = ACTIONS(6546),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6546),
    [anon_sym_BSLASHinput] = ACTIONS(6546),
    [anon_sym_BSLASHsubfile] = ACTIONS(6546),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6546),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6546),
    [anon_sym_BSLASHbibliography] = ACTIONS(6546),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6546),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6546),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6546),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6546),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6546),
    [anon_sym_BSLASHimport] = ACTIONS(6546),
    [anon_sym_BSLASHsubimport] = ACTIONS(6546),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6546),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHcaption] = ACTIONS(6546),
    [anon_sym_BSLASHcite] = ACTIONS(6546),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCite] = ACTIONS(6546),
    [anon_sym_BSLASHnocite] = ACTIONS(6546),
    [anon_sym_BSLASHcitet] = ACTIONS(6546),
    [anon_sym_BSLASHcitep] = ACTIONS(6546),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteA] = ACTIONS(6546),
    [anon_sym_BSLASHciteR] = ACTIONS(6546),
    [anon_sym_BSLASHciteS] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6546),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteyear] = ACTIONS(6546),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitedate] = ACTIONS(6546),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteurl] = ACTIONS(6546),
    [anon_sym_BSLASHfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6546),
    [anon_sym_BSLASHcitealt] = ACTIONS(6546),
    [anon_sym_BSLASHcitealp] = ACTIONS(6546),
    [anon_sym_BSLASHcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHparencite] = ACTIONS(6546),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHParencite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHtextcite] = ACTIONS(6546),
    [anon_sym_BSLASHTextcite] = ACTIONS(6546),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHsupercite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite] = ACTIONS(6546),
    [anon_sym_BSLASHAutocite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHVolcite] = ACTIONS(6546),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHavolcite] = ACTIONS(6546),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHNotecite] = ACTIONS(6546),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHlabel] = ACTIONS(6546),
    [anon_sym_BSLASHref] = ACTIONS(6546),
    [anon_sym_BSLASHeqref] = ACTIONS(6546),
    [anon_sym_BSLASHvref] = ACTIONS(6546),
    [anon_sym_BSLASHVref] = ACTIONS(6546),
    [anon_sym_BSLASHautoref] = ACTIONS(6546),
    [anon_sym_BSLASHpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcref] = ACTIONS(6546),
    [anon_sym_BSLASHCref] = ACTIONS(6546),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnameCref] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHdef] = ACTIONS(6546),
    [anon_sym_BSLASHlet] = ACTIONS(6546),
    [anon_sym_BSLASHleft] = ACTIONS(6546),
    [anon_sym_BSLASHbigl] = ACTIONS(6546),
    [anon_sym_BSLASHBigl] = ACTIONS(6546),
    [anon_sym_BSLASHbiggl] = ACTIONS(6546),
    [anon_sym_BSLASHBiggl] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6546),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6546),
    [anon_sym_BSLASHgls] = ACTIONS(6546),
    [anon_sym_BSLASHGls] = ACTIONS(6546),
    [anon_sym_BSLASHGLS] = ACTIONS(6546),
    [anon_sym_BSLASHglspl] = ACTIONS(6546),
    [anon_sym_BSLASHGlspl] = ACTIONS(6546),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6546),
    [anon_sym_BSLASHglslink] = ACTIONS(6546),
    [anon_sym_BSLASHglstext] = ACTIONS(6546),
    [anon_sym_BSLASHGlstext] = ACTIONS(6546),
    [anon_sym_BSLASHGLStext] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6546),
    [anon_sym_BSLASHglsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsname] = ACTIONS(6546),
    [anon_sym_BSLASHGlsname] = ACTIONS(6546),
    [anon_sym_BSLASHGLSname] = ACTIONS(6546),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6546),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6546),
    [anon_sym_BSLASHacrshort] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6546),
    [anon_sym_BSLASHACRshort] = ACTIONS(6546),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrlong] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6546),
    [anon_sym_BSLASHACRlong] = ACTIONS(6546),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrfull] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6546),
    [anon_sym_BSLASHACRfull] = ACTIONS(6546),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHacs] = ACTIONS(6546),
    [anon_sym_BSLASHAcs] = ACTIONS(6546),
    [anon_sym_BSLASHacsp] = ACTIONS(6546),
    [anon_sym_BSLASHAcsp] = ACTIONS(6546),
    [anon_sym_BSLASHacl] = ACTIONS(6546),
    [anon_sym_BSLASHAcl] = ACTIONS(6546),
    [anon_sym_BSLASHaclp] = ACTIONS(6546),
    [anon_sym_BSLASHAclp] = ACTIONS(6546),
    [anon_sym_BSLASHacf] = ACTIONS(6546),
    [anon_sym_BSLASHAcf] = ACTIONS(6546),
    [anon_sym_BSLASHacfp] = ACTIONS(6546),
    [anon_sym_BSLASHAcfp] = ACTIONS(6546),
    [anon_sym_BSLASHac] = ACTIONS(6546),
    [anon_sym_BSLASHAc] = ACTIONS(6546),
    [anon_sym_BSLASHacp] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6546),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6546),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6546),
    [anon_sym_BSLASHcolor] = ACTIONS(6546),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6546),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6546),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6546),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6546),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6546),
    [anon_sym_BSLASHtext] = ACTIONS(6546),
    [anon_sym_BSLASHintertext] = ACTIONS(6546),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6546),
    [anon_sym_BSLASHurl] = ACTIONS(6546),
    [anon_sym_BSLASHhref] = ACTIONS(6546),
  },
  [1321] = {
    [sym_command_name] = ACTIONS(2214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_RBRACK] = ACTIONS(2216),
    [anon_sym_COMMA] = ACTIONS(2216),
    [anon_sym_EQ] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2216),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHitem] = ACTIONS(2214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [sym_word] = ACTIONS(2214),
    [sym_placeholder] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_COLON] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [anon_sym__] = ACTIONS(2216),
    [anon_sym_CARET] = ACTIONS(2216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2216),
    [anon_sym_DOLLAR] = ACTIONS(2214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2216),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHbegin] = ACTIONS(2214),
    [anon_sym_BSLASHtitle] = ACTIONS(2214),
    [anon_sym_BSLASHauthor] = ACTIONS(2214),
    [anon_sym_BSLASHusepackage] = ACTIONS(2214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2214),
    [anon_sym_BSLASHinclude] = ACTIONS(2214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2214),
    [anon_sym_BSLASHinput] = ACTIONS(2214),
    [anon_sym_BSLASHsubfile] = ACTIONS(2214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2214),
    [anon_sym_BSLASHbibliography] = ACTIONS(2214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2214),
    [anon_sym_BSLASHimport] = ACTIONS(2214),
    [anon_sym_BSLASHsubimport] = ACTIONS(2214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHcaption] = ACTIONS(2214),
    [anon_sym_BSLASHcite] = ACTIONS(2214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCite] = ACTIONS(2214),
    [anon_sym_BSLASHnocite] = ACTIONS(2214),
    [anon_sym_BSLASHcitet] = ACTIONS(2214),
    [anon_sym_BSLASHcitep] = ACTIONS(2214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteA] = ACTIONS(2214),
    [anon_sym_BSLASHciteR] = ACTIONS(2214),
    [anon_sym_BSLASHciteS] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteyear] = ACTIONS(2214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitedate] = ACTIONS(2214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteurl] = ACTIONS(2214),
    [anon_sym_BSLASHfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2214),
    [anon_sym_BSLASHcitealt] = ACTIONS(2214),
    [anon_sym_BSLASHcitealp] = ACTIONS(2214),
    [anon_sym_BSLASHcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHparencite] = ACTIONS(2214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHParencite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHtextcite] = ACTIONS(2214),
    [anon_sym_BSLASHTextcite] = ACTIONS(2214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHsupercite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite] = ACTIONS(2214),
    [anon_sym_BSLASHAutocite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHVolcite] = ACTIONS(2214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHavolcite] = ACTIONS(2214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHNotecite] = ACTIONS(2214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHlabel] = ACTIONS(2214),
    [anon_sym_BSLASHref] = ACTIONS(2214),
    [anon_sym_BSLASHeqref] = ACTIONS(2214),
    [anon_sym_BSLASHvref] = ACTIONS(2214),
    [anon_sym_BSLASHVref] = ACTIONS(2214),
    [anon_sym_BSLASHautoref] = ACTIONS(2214),
    [anon_sym_BSLASHpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcref] = ACTIONS(2214),
    [anon_sym_BSLASHCref] = ACTIONS(2214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnameCref] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHdef] = ACTIONS(2214),
    [anon_sym_BSLASHlet] = ACTIONS(2214),
    [anon_sym_BSLASHleft] = ACTIONS(2214),
    [anon_sym_BSLASHbigl] = ACTIONS(2214),
    [anon_sym_BSLASHBigl] = ACTIONS(2214),
    [anon_sym_BSLASHbiggl] = ACTIONS(2214),
    [anon_sym_BSLASHBiggl] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2214),
    [anon_sym_BSLASHgls] = ACTIONS(2214),
    [anon_sym_BSLASHGls] = ACTIONS(2214),
    [anon_sym_BSLASHGLS] = ACTIONS(2214),
    [anon_sym_BSLASHglspl] = ACTIONS(2214),
    [anon_sym_BSLASHGlspl] = ACTIONS(2214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2214),
    [anon_sym_BSLASHglslink] = ACTIONS(2214),
    [anon_sym_BSLASHglstext] = ACTIONS(2214),
    [anon_sym_BSLASHGlstext] = ACTIONS(2214),
    [anon_sym_BSLASHGLStext] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2214),
    [anon_sym_BSLASHglsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsname] = ACTIONS(2214),
    [anon_sym_BSLASHGlsname] = ACTIONS(2214),
    [anon_sym_BSLASHGLSname] = ACTIONS(2214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2214),
    [anon_sym_BSLASHacrshort] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2214),
    [anon_sym_BSLASHACRshort] = ACTIONS(2214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrlong] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2214),
    [anon_sym_BSLASHACRlong] = ACTIONS(2214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrfull] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2214),
    [anon_sym_BSLASHACRfull] = ACTIONS(2214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHacs] = ACTIONS(2214),
    [anon_sym_BSLASHAcs] = ACTIONS(2214),
    [anon_sym_BSLASHacsp] = ACTIONS(2214),
    [anon_sym_BSLASHAcsp] = ACTIONS(2214),
    [anon_sym_BSLASHacl] = ACTIONS(2214),
    [anon_sym_BSLASHAcl] = ACTIONS(2214),
    [anon_sym_BSLASHaclp] = ACTIONS(2214),
    [anon_sym_BSLASHAclp] = ACTIONS(2214),
    [anon_sym_BSLASHacf] = ACTIONS(2214),
    [anon_sym_BSLASHAcf] = ACTIONS(2214),
    [anon_sym_BSLASHacfp] = ACTIONS(2214),
    [anon_sym_BSLASHAcfp] = ACTIONS(2214),
    [anon_sym_BSLASHac] = ACTIONS(2214),
    [anon_sym_BSLASHAc] = ACTIONS(2214),
    [anon_sym_BSLASHacp] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2214),
    [anon_sym_BSLASHcolor] = ACTIONS(2214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2214),
    [anon_sym_BSLASHtext] = ACTIONS(2214),
    [anon_sym_BSLASHintertext] = ACTIONS(2214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2214),
    [anon_sym_BSLASHurl] = ACTIONS(2214),
    [anon_sym_BSLASHhref] = ACTIONS(2214),
  },
  [1322] = {
    [sym_command_name] = ACTIONS(6642),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6642),
    [anon_sym_LBRACK] = ACTIONS(6644),
    [anon_sym_RBRACK] = ACTIONS(6644),
    [anon_sym_COMMA] = ACTIONS(6644),
    [anon_sym_EQ] = ACTIONS(6644),
    [anon_sym_LPAREN] = ACTIONS(6644),
    [anon_sym_RPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHpart] = ACTIONS(6642),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddpart] = ACTIONS(6642),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHchapter] = ACTIONS(6642),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddchap] = ACTIONS(6642),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsection] = ACTIONS(6642),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddsec] = ACTIONS(6642),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHitem] = ACTIONS(6642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6644),
    [anon_sym_LBRACE] = ACTIONS(6644),
    [sym_word] = ACTIONS(6642),
    [sym_placeholder] = ACTIONS(6644),
    [anon_sym_PLUS] = ACTIONS(6644),
    [anon_sym_DASH] = ACTIONS(6644),
    [anon_sym_STAR] = ACTIONS(6644),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_LT] = ACTIONS(6642),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_BANG] = ACTIONS(6642),
    [anon_sym_PIPE] = ACTIONS(6642),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_SQUOTE] = ACTIONS(6642),
    [anon_sym__] = ACTIONS(6644),
    [anon_sym_CARET] = ACTIONS(6644),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6644),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6644),
    [anon_sym_DOLLAR] = ACTIONS(6642),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6644),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHbegin] = ACTIONS(6642),
    [anon_sym_BSLASHtitle] = ACTIONS(6642),
    [anon_sym_BSLASHauthor] = ACTIONS(6642),
    [anon_sym_BSLASHusepackage] = ACTIONS(6642),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6642),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6642),
    [anon_sym_BSLASHinclude] = ACTIONS(6642),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6642),
    [anon_sym_BSLASHinput] = ACTIONS(6642),
    [anon_sym_BSLASHsubfile] = ACTIONS(6642),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6642),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6642),
    [anon_sym_BSLASHbibliography] = ACTIONS(6642),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6642),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6642),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6642),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6642),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6642),
    [anon_sym_BSLASHimport] = ACTIONS(6642),
    [anon_sym_BSLASHsubimport] = ACTIONS(6642),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6642),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHcaption] = ACTIONS(6642),
    [anon_sym_BSLASHcite] = ACTIONS(6642),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCite] = ACTIONS(6642),
    [anon_sym_BSLASHnocite] = ACTIONS(6642),
    [anon_sym_BSLASHcitet] = ACTIONS(6642),
    [anon_sym_BSLASHcitep] = ACTIONS(6642),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteA] = ACTIONS(6642),
    [anon_sym_BSLASHciteR] = ACTIONS(6642),
    [anon_sym_BSLASHciteS] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6642),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteyear] = ACTIONS(6642),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitedate] = ACTIONS(6642),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteurl] = ACTIONS(6642),
    [anon_sym_BSLASHfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6642),
    [anon_sym_BSLASHcitealt] = ACTIONS(6642),
    [anon_sym_BSLASHcitealp] = ACTIONS(6642),
    [anon_sym_BSLASHcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHparencite] = ACTIONS(6642),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHParencite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHtextcite] = ACTIONS(6642),
    [anon_sym_BSLASHTextcite] = ACTIONS(6642),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHsupercite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite] = ACTIONS(6642),
    [anon_sym_BSLASHAutocite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHVolcite] = ACTIONS(6642),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHavolcite] = ACTIONS(6642),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHNotecite] = ACTIONS(6642),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHlabel] = ACTIONS(6642),
    [anon_sym_BSLASHref] = ACTIONS(6642),
    [anon_sym_BSLASHeqref] = ACTIONS(6642),
    [anon_sym_BSLASHvref] = ACTIONS(6642),
    [anon_sym_BSLASHVref] = ACTIONS(6642),
    [anon_sym_BSLASHautoref] = ACTIONS(6642),
    [anon_sym_BSLASHpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcref] = ACTIONS(6642),
    [anon_sym_BSLASHCref] = ACTIONS(6642),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnameCref] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHdef] = ACTIONS(6642),
    [anon_sym_BSLASHlet] = ACTIONS(6642),
    [anon_sym_BSLASHleft] = ACTIONS(6642),
    [anon_sym_BSLASHbigl] = ACTIONS(6642),
    [anon_sym_BSLASHBigl] = ACTIONS(6642),
    [anon_sym_BSLASHbiggl] = ACTIONS(6642),
    [anon_sym_BSLASHBiggl] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6642),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6642),
    [anon_sym_BSLASHgls] = ACTIONS(6642),
    [anon_sym_BSLASHGls] = ACTIONS(6642),
    [anon_sym_BSLASHGLS] = ACTIONS(6642),
    [anon_sym_BSLASHglspl] = ACTIONS(6642),
    [anon_sym_BSLASHGlspl] = ACTIONS(6642),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6642),
    [anon_sym_BSLASHglslink] = ACTIONS(6642),
    [anon_sym_BSLASHglstext] = ACTIONS(6642),
    [anon_sym_BSLASHGlstext] = ACTIONS(6642),
    [anon_sym_BSLASHGLStext] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6642),
    [anon_sym_BSLASHglsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsname] = ACTIONS(6642),
    [anon_sym_BSLASHGlsname] = ACTIONS(6642),
    [anon_sym_BSLASHGLSname] = ACTIONS(6642),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6642),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6642),
    [anon_sym_BSLASHacrshort] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6642),
    [anon_sym_BSLASHACRshort] = ACTIONS(6642),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrlong] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6642),
    [anon_sym_BSLASHACRlong] = ACTIONS(6642),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrfull] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6642),
    [anon_sym_BSLASHACRfull] = ACTIONS(6642),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHacs] = ACTIONS(6642),
    [anon_sym_BSLASHAcs] = ACTIONS(6642),
    [anon_sym_BSLASHacsp] = ACTIONS(6642),
    [anon_sym_BSLASHAcsp] = ACTIONS(6642),
    [anon_sym_BSLASHacl] = ACTIONS(6642),
    [anon_sym_BSLASHAcl] = ACTIONS(6642),
    [anon_sym_BSLASHaclp] = ACTIONS(6642),
    [anon_sym_BSLASHAclp] = ACTIONS(6642),
    [anon_sym_BSLASHacf] = ACTIONS(6642),
    [anon_sym_BSLASHAcf] = ACTIONS(6642),
    [anon_sym_BSLASHacfp] = ACTIONS(6642),
    [anon_sym_BSLASHAcfp] = ACTIONS(6642),
    [anon_sym_BSLASHac] = ACTIONS(6642),
    [anon_sym_BSLASHAc] = ACTIONS(6642),
    [anon_sym_BSLASHacp] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6642),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6642),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6642),
    [anon_sym_BSLASHcolor] = ACTIONS(6642),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6642),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6642),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6642),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6642),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6642),
    [anon_sym_BSLASHtext] = ACTIONS(6642),
    [anon_sym_BSLASHintertext] = ACTIONS(6642),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6642),
    [anon_sym_BSLASHurl] = ACTIONS(6642),
    [anon_sym_BSLASHhref] = ACTIONS(6642),
  },
  [1323] = {
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_RBRACK] = ACTIONS(6356),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_EQ] = ACTIONS(6356),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_RPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHpart] = ACTIONS(6354),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddpart] = ACTIONS(6354),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHchapter] = ACTIONS(6354),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddchap] = ACTIONS(6354),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsection] = ACTIONS(6354),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddsec] = ACTIONS(6354),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHitem] = ACTIONS(6354),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6356),
    [anon_sym_LBRACE] = ACTIONS(6356),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6356),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6356),
    [anon_sym_DOLLAR] = ACTIONS(6354),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6356),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHbegin] = ACTIONS(6354),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHleft] = ACTIONS(6354),
    [anon_sym_BSLASHbigl] = ACTIONS(6354),
    [anon_sym_BSLASHBigl] = ACTIONS(6354),
    [anon_sym_BSLASHbiggl] = ACTIONS(6354),
    [anon_sym_BSLASHBiggl] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHtext] = ACTIONS(6354),
    [anon_sym_BSLASHintertext] = ACTIONS(6354),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [1324] = {
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LPAREN] = ACTIONS(6364),
    [anon_sym_RPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHpart] = ACTIONS(6362),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddpart] = ACTIONS(6362),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHchapter] = ACTIONS(6362),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddchap] = ACTIONS(6362),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsection] = ACTIONS(6362),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddsec] = ACTIONS(6362),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHitem] = ACTIONS(6362),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6364),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6364),
    [anon_sym_DOLLAR] = ACTIONS(6362),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6364),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHbegin] = ACTIONS(6362),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHleft] = ACTIONS(6362),
    [anon_sym_BSLASHbigl] = ACTIONS(6362),
    [anon_sym_BSLASHBigl] = ACTIONS(6362),
    [anon_sym_BSLASHbiggl] = ACTIONS(6362),
    [anon_sym_BSLASHBiggl] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHtext] = ACTIONS(6362),
    [anon_sym_BSLASHintertext] = ACTIONS(6362),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [1325] = {
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_LBRACK] = ACTIONS(6376),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_EQ] = ACTIONS(6376),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHpart] = ACTIONS(6374),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddpart] = ACTIONS(6374),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHchapter] = ACTIONS(6374),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddchap] = ACTIONS(6374),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsection] = ACTIONS(6374),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHaddsec] = ACTIONS(6374),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6374),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6374),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHitem] = ACTIONS(6374),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6376),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6376),
    [anon_sym_DOLLAR] = ACTIONS(6374),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6376),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHbegin] = ACTIONS(6374),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHleft] = ACTIONS(6374),
    [anon_sym_BSLASHbigl] = ACTIONS(6374),
    [anon_sym_BSLASHBigl] = ACTIONS(6374),
    [anon_sym_BSLASHbiggl] = ACTIONS(6374),
    [anon_sym_BSLASHBiggl] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHtext] = ACTIONS(6374),
    [anon_sym_BSLASHintertext] = ACTIONS(6374),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [1326] = {
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_LBRACK] = ACTIONS(6380),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_EQ] = ACTIONS(6380),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHpart] = ACTIONS(6378),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddpart] = ACTIONS(6378),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHchapter] = ACTIONS(6378),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddchap] = ACTIONS(6378),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsection] = ACTIONS(6378),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHaddsec] = ACTIONS(6378),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6378),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6378),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHitem] = ACTIONS(6378),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6380),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6380),
    [anon_sym_DOLLAR] = ACTIONS(6378),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6380),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHbegin] = ACTIONS(6378),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHleft] = ACTIONS(6378),
    [anon_sym_BSLASHbigl] = ACTIONS(6378),
    [anon_sym_BSLASHBigl] = ACTIONS(6378),
    [anon_sym_BSLASHbiggl] = ACTIONS(6378),
    [anon_sym_BSLASHBiggl] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHtext] = ACTIONS(6378),
    [anon_sym_BSLASHintertext] = ACTIONS(6378),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [1327] = {
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_LBRACK] = ACTIONS(6384),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_EQ] = ACTIONS(6384),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_RPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHpart] = ACTIONS(6382),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddpart] = ACTIONS(6382),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHchapter] = ACTIONS(6382),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddchap] = ACTIONS(6382),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsection] = ACTIONS(6382),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHaddsec] = ACTIONS(6382),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6382),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6382),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHitem] = ACTIONS(6382),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6384),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6384),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(6382),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6384),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHbegin] = ACTIONS(6382),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHleft] = ACTIONS(6382),
    [anon_sym_BSLASHbigl] = ACTIONS(6382),
    [anon_sym_BSLASHBigl] = ACTIONS(6382),
    [anon_sym_BSLASHbiggl] = ACTIONS(6382),
    [anon_sym_BSLASHBiggl] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHtext] = ACTIONS(6382),
    [anon_sym_BSLASHintertext] = ACTIONS(6382),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [1328] = {
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_COMMA] = ACTIONS(6388),
    [anon_sym_EQ] = ACTIONS(6388),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHpart] = ACTIONS(6386),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddpart] = ACTIONS(6386),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHchapter] = ACTIONS(6386),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddchap] = ACTIONS(6386),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsection] = ACTIONS(6386),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHaddsec] = ACTIONS(6386),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6386),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6386),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHitem] = ACTIONS(6386),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6388),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(6386),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6388),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHbegin] = ACTIONS(6386),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHleft] = ACTIONS(6386),
    [anon_sym_BSLASHbigl] = ACTIONS(6386),
    [anon_sym_BSLASHBigl] = ACTIONS(6386),
    [anon_sym_BSLASHbiggl] = ACTIONS(6386),
    [anon_sym_BSLASHBiggl] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHtext] = ACTIONS(6386),
    [anon_sym_BSLASHintertext] = ACTIONS(6386),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [1329] = {
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LPAREN] = ACTIONS(6364),
    [anon_sym_RPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHpart] = ACTIONS(6362),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddpart] = ACTIONS(6362),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHchapter] = ACTIONS(6362),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddchap] = ACTIONS(6362),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsection] = ACTIONS(6362),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHaddsec] = ACTIONS(6362),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6362),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6362),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHitem] = ACTIONS(6362),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6364),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6364),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6364),
    [anon_sym_DOLLAR] = ACTIONS(6362),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHbegin] = ACTIONS(6362),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHleft] = ACTIONS(6362),
    [anon_sym_BSLASHbigl] = ACTIONS(6362),
    [anon_sym_BSLASHBigl] = ACTIONS(6362),
    [anon_sym_BSLASHbiggl] = ACTIONS(6362),
    [anon_sym_BSLASHBiggl] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHtext] = ACTIONS(6362),
    [anon_sym_BSLASHintertext] = ACTIONS(6362),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [1330] = {
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_RBRACK] = ACTIONS(6320),
    [anon_sym_COMMA] = ACTIONS(6320),
    [anon_sym_EQ] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(6320),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHpart] = ACTIONS(6318),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddpart] = ACTIONS(6318),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHchapter] = ACTIONS(6318),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddchap] = ACTIONS(6318),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsection] = ACTIONS(6318),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHaddsec] = ACTIONS(6318),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6318),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6318),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHitem] = ACTIONS(6318),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6320),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6320),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6320),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHbegin] = ACTIONS(6318),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHleft] = ACTIONS(6318),
    [anon_sym_BSLASHbigl] = ACTIONS(6318),
    [anon_sym_BSLASHBigl] = ACTIONS(6318),
    [anon_sym_BSLASHbiggl] = ACTIONS(6318),
    [anon_sym_BSLASHBiggl] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHtext] = ACTIONS(6318),
    [anon_sym_BSLASHintertext] = ACTIONS(6318),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [1331] = {
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_COMMA] = ACTIONS(6392),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHpart] = ACTIONS(6390),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddpart] = ACTIONS(6390),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHchapter] = ACTIONS(6390),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddchap] = ACTIONS(6390),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsection] = ACTIONS(6390),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHaddsec] = ACTIONS(6390),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6390),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6390),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHitem] = ACTIONS(6390),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6392),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(6390),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6392),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHbegin] = ACTIONS(6390),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHleft] = ACTIONS(6390),
    [anon_sym_BSLASHbigl] = ACTIONS(6390),
    [anon_sym_BSLASHBigl] = ACTIONS(6390),
    [anon_sym_BSLASHbiggl] = ACTIONS(6390),
    [anon_sym_BSLASHBiggl] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHtext] = ACTIONS(6390),
    [anon_sym_BSLASHintertext] = ACTIONS(6390),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [1332] = {
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6396),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6396),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHpart] = ACTIONS(6394),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddpart] = ACTIONS(6394),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHchapter] = ACTIONS(6394),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddchap] = ACTIONS(6394),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsection] = ACTIONS(6394),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHaddsec] = ACTIONS(6394),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6394),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6394),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHitem] = ACTIONS(6394),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6396),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6396),
    [anon_sym_DOLLAR] = ACTIONS(6394),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6396),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHbegin] = ACTIONS(6394),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHleft] = ACTIONS(6394),
    [anon_sym_BSLASHbigl] = ACTIONS(6394),
    [anon_sym_BSLASHBigl] = ACTIONS(6394),
    [anon_sym_BSLASHbiggl] = ACTIONS(6394),
    [anon_sym_BSLASHBiggl] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHtext] = ACTIONS(6394),
    [anon_sym_BSLASHintertext] = ACTIONS(6394),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [1333] = {
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6400),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHpart] = ACTIONS(6398),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddpart] = ACTIONS(6398),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHchapter] = ACTIONS(6398),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddchap] = ACTIONS(6398),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsection] = ACTIONS(6398),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHaddsec] = ACTIONS(6398),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6398),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6398),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHitem] = ACTIONS(6398),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6400),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6400),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHbegin] = ACTIONS(6398),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHleft] = ACTIONS(6398),
    [anon_sym_BSLASHbigl] = ACTIONS(6398),
    [anon_sym_BSLASHBigl] = ACTIONS(6398),
    [anon_sym_BSLASHbiggl] = ACTIONS(6398),
    [anon_sym_BSLASHBiggl] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHtext] = ACTIONS(6398),
    [anon_sym_BSLASHintertext] = ACTIONS(6398),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [1334] = {
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6404),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6404),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHpart] = ACTIONS(6402),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddpart] = ACTIONS(6402),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHchapter] = ACTIONS(6402),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddchap] = ACTIONS(6402),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsection] = ACTIONS(6402),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHaddsec] = ACTIONS(6402),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6402),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6402),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHitem] = ACTIONS(6402),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6404),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6404),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6404),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6404),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHbegin] = ACTIONS(6402),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHleft] = ACTIONS(6402),
    [anon_sym_BSLASHbigl] = ACTIONS(6402),
    [anon_sym_BSLASHBigl] = ACTIONS(6402),
    [anon_sym_BSLASHbiggl] = ACTIONS(6402),
    [anon_sym_BSLASHBiggl] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHtext] = ACTIONS(6402),
    [anon_sym_BSLASHintertext] = ACTIONS(6402),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [1335] = {
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHpart] = ACTIONS(6406),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddpart] = ACTIONS(6406),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHchapter] = ACTIONS(6406),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddchap] = ACTIONS(6406),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsection] = ACTIONS(6406),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHaddsec] = ACTIONS(6406),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6406),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6406),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHitem] = ACTIONS(6406),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6408),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6408),
    [anon_sym_DOLLAR] = ACTIONS(6406),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6408),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHbegin] = ACTIONS(6406),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHleft] = ACTIONS(6406),
    [anon_sym_BSLASHbigl] = ACTIONS(6406),
    [anon_sym_BSLASHBigl] = ACTIONS(6406),
    [anon_sym_BSLASHbiggl] = ACTIONS(6406),
    [anon_sym_BSLASHBiggl] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHtext] = ACTIONS(6406),
    [anon_sym_BSLASHintertext] = ACTIONS(6406),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [1336] = {
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6412),
    [anon_sym_RBRACK] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHpart] = ACTIONS(6410),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddpart] = ACTIONS(6410),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHchapter] = ACTIONS(6410),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddchap] = ACTIONS(6410),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsection] = ACTIONS(6410),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddsec] = ACTIONS(6410),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHitem] = ACTIONS(6410),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6412),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6412),
    [anon_sym_DOLLAR] = ACTIONS(6410),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6412),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHbegin] = ACTIONS(6410),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHleft] = ACTIONS(6410),
    [anon_sym_BSLASHbigl] = ACTIONS(6410),
    [anon_sym_BSLASHBigl] = ACTIONS(6410),
    [anon_sym_BSLASHbiggl] = ACTIONS(6410),
    [anon_sym_BSLASHBiggl] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHtext] = ACTIONS(6410),
    [anon_sym_BSLASHintertext] = ACTIONS(6410),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [1337] = {
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6416),
    [anon_sym_EQ] = ACTIONS(6416),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_RPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHpart] = ACTIONS(6414),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddpart] = ACTIONS(6414),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHchapter] = ACTIONS(6414),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddchap] = ACTIONS(6414),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsection] = ACTIONS(6414),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHaddsec] = ACTIONS(6414),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6414),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6414),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHitem] = ACTIONS(6414),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6416),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(6414),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6416),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHbegin] = ACTIONS(6414),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHleft] = ACTIONS(6414),
    [anon_sym_BSLASHbigl] = ACTIONS(6414),
    [anon_sym_BSLASHBigl] = ACTIONS(6414),
    [anon_sym_BSLASHbiggl] = ACTIONS(6414),
    [anon_sym_BSLASHBiggl] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHtext] = ACTIONS(6414),
    [anon_sym_BSLASHintertext] = ACTIONS(6414),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [1338] = {
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_RBRACK] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHpart] = ACTIONS(6418),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddpart] = ACTIONS(6418),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHchapter] = ACTIONS(6418),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddchap] = ACTIONS(6418),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsection] = ACTIONS(6418),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHaddsec] = ACTIONS(6418),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6418),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6418),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHitem] = ACTIONS(6418),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6420),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6420),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(6418),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6420),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHbegin] = ACTIONS(6418),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHleft] = ACTIONS(6418),
    [anon_sym_BSLASHbigl] = ACTIONS(6418),
    [anon_sym_BSLASHBigl] = ACTIONS(6418),
    [anon_sym_BSLASHbiggl] = ACTIONS(6418),
    [anon_sym_BSLASHBiggl] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHtext] = ACTIONS(6418),
    [anon_sym_BSLASHintertext] = ACTIONS(6418),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [1339] = {
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_LBRACK] = ACTIONS(6424),
    [anon_sym_RBRACK] = ACTIONS(6424),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_EQ] = ACTIONS(6424),
    [anon_sym_LPAREN] = ACTIONS(6424),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHpart] = ACTIONS(6422),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddpart] = ACTIONS(6422),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHchapter] = ACTIONS(6422),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddchap] = ACTIONS(6422),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsection] = ACTIONS(6422),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHaddsec] = ACTIONS(6422),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6422),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6422),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHitem] = ACTIONS(6422),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6424),
    [anon_sym_LBRACE] = ACTIONS(6424),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6424),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6424),
    [anon_sym_DOLLAR] = ACTIONS(6422),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6424),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHbegin] = ACTIONS(6422),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHleft] = ACTIONS(6422),
    [anon_sym_BSLASHbigl] = ACTIONS(6422),
    [anon_sym_BSLASHBigl] = ACTIONS(6422),
    [anon_sym_BSLASHbiggl] = ACTIONS(6422),
    [anon_sym_BSLASHBiggl] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHtext] = ACTIONS(6422),
    [anon_sym_BSLASHintertext] = ACTIONS(6422),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [1340] = {
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_RBRACK] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6428),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_RPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHpart] = ACTIONS(6426),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddpart] = ACTIONS(6426),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHchapter] = ACTIONS(6426),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddchap] = ACTIONS(6426),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsection] = ACTIONS(6426),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHaddsec] = ACTIONS(6426),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6426),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6426),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHitem] = ACTIONS(6426),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6428),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6428),
    [anon_sym_DOLLAR] = ACTIONS(6426),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6428),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHbegin] = ACTIONS(6426),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHleft] = ACTIONS(6426),
    [anon_sym_BSLASHbigl] = ACTIONS(6426),
    [anon_sym_BSLASHBigl] = ACTIONS(6426),
    [anon_sym_BSLASHbiggl] = ACTIONS(6426),
    [anon_sym_BSLASHBiggl] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHtext] = ACTIONS(6426),
    [anon_sym_BSLASHintertext] = ACTIONS(6426),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [1341] = {
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_COMMA] = ACTIONS(6316),
    [anon_sym_EQ] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6316),
    [anon_sym_RPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHpart] = ACTIONS(6314),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddpart] = ACTIONS(6314),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHchapter] = ACTIONS(6314),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddchap] = ACTIONS(6314),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsection] = ACTIONS(6314),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHaddsec] = ACTIONS(6314),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6314),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6314),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHitem] = ACTIONS(6314),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6316),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6316),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6316),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6316),
    [anon_sym_DOLLAR] = ACTIONS(6314),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHbegin] = ACTIONS(6314),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHleft] = ACTIONS(6314),
    [anon_sym_BSLASHbigl] = ACTIONS(6314),
    [anon_sym_BSLASHBigl] = ACTIONS(6314),
    [anon_sym_BSLASHbiggl] = ACTIONS(6314),
    [anon_sym_BSLASHBiggl] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHtext] = ACTIONS(6314),
    [anon_sym_BSLASHintertext] = ACTIONS(6314),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [1342] = {
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHpart] = ACTIONS(6430),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddpart] = ACTIONS(6430),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHchapter] = ACTIONS(6430),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddchap] = ACTIONS(6430),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsection] = ACTIONS(6430),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHaddsec] = ACTIONS(6430),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6430),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6430),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHitem] = ACTIONS(6430),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6432),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6432),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6432),
    [anon_sym_DOLLAR] = ACTIONS(6430),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6432),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHbegin] = ACTIONS(6430),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHleft] = ACTIONS(6430),
    [anon_sym_BSLASHbigl] = ACTIONS(6430),
    [anon_sym_BSLASHBigl] = ACTIONS(6430),
    [anon_sym_BSLASHbiggl] = ACTIONS(6430),
    [anon_sym_BSLASHBiggl] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHtext] = ACTIONS(6430),
    [anon_sym_BSLASHintertext] = ACTIONS(6430),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [1343] = {
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6312),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6312),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHpart] = ACTIONS(6310),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddpart] = ACTIONS(6310),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHchapter] = ACTIONS(6310),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddchap] = ACTIONS(6310),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsection] = ACTIONS(6310),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHaddsec] = ACTIONS(6310),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6310),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6310),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHitem] = ACTIONS(6310),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6312),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6312),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6312),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6312),
    [anon_sym_DOLLAR] = ACTIONS(6310),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHbegin] = ACTIONS(6310),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHleft] = ACTIONS(6310),
    [anon_sym_BSLASHbigl] = ACTIONS(6310),
    [anon_sym_BSLASHBigl] = ACTIONS(6310),
    [anon_sym_BSLASHbiggl] = ACTIONS(6310),
    [anon_sym_BSLASHBiggl] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHtext] = ACTIONS(6310),
    [anon_sym_BSLASHintertext] = ACTIONS(6310),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [1344] = {
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6436),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_EQ] = ACTIONS(6436),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHpart] = ACTIONS(6434),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddpart] = ACTIONS(6434),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHchapter] = ACTIONS(6434),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddchap] = ACTIONS(6434),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsection] = ACTIONS(6434),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHaddsec] = ACTIONS(6434),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6434),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6434),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHitem] = ACTIONS(6434),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6436),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6436),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6436),
    [anon_sym_DOLLAR] = ACTIONS(6434),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6436),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHbegin] = ACTIONS(6434),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHleft] = ACTIONS(6434),
    [anon_sym_BSLASHbigl] = ACTIONS(6434),
    [anon_sym_BSLASHBigl] = ACTIONS(6434),
    [anon_sym_BSLASHbiggl] = ACTIONS(6434),
    [anon_sym_BSLASHBiggl] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHtext] = ACTIONS(6434),
    [anon_sym_BSLASHintertext] = ACTIONS(6434),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [1345] = {
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6292),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_COMMA] = ACTIONS(6292),
    [anon_sym_EQ] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_RPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHpart] = ACTIONS(6290),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddpart] = ACTIONS(6290),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHchapter] = ACTIONS(6290),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddchap] = ACTIONS(6290),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsection] = ACTIONS(6290),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHaddsec] = ACTIONS(6290),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6290),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6290),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHitem] = ACTIONS(6290),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6292),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6292),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6292),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6292),
    [anon_sym_DOLLAR] = ACTIONS(6290),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHbegin] = ACTIONS(6290),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHleft] = ACTIONS(6290),
    [anon_sym_BSLASHbigl] = ACTIONS(6290),
    [anon_sym_BSLASHBigl] = ACTIONS(6290),
    [anon_sym_BSLASHbiggl] = ACTIONS(6290),
    [anon_sym_BSLASHBiggl] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHtext] = ACTIONS(6290),
    [anon_sym_BSLASHintertext] = ACTIONS(6290),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [1346] = {
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_LBRACK] = ACTIONS(6440),
    [anon_sym_RBRACK] = ACTIONS(6440),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6440),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_RPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHpart] = ACTIONS(6438),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddpart] = ACTIONS(6438),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHchapter] = ACTIONS(6438),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddchap] = ACTIONS(6438),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsection] = ACTIONS(6438),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHaddsec] = ACTIONS(6438),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6438),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6438),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHitem] = ACTIONS(6438),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6440),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6440),
    [anon_sym_DOLLAR] = ACTIONS(6438),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6440),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHbegin] = ACTIONS(6438),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHleft] = ACTIONS(6438),
    [anon_sym_BSLASHbigl] = ACTIONS(6438),
    [anon_sym_BSLASHBigl] = ACTIONS(6438),
    [anon_sym_BSLASHbiggl] = ACTIONS(6438),
    [anon_sym_BSLASHBiggl] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHtext] = ACTIONS(6438),
    [anon_sym_BSLASHintertext] = ACTIONS(6438),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [1347] = {
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6288),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHpart] = ACTIONS(6286),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddpart] = ACTIONS(6286),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHchapter] = ACTIONS(6286),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddchap] = ACTIONS(6286),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsection] = ACTIONS(6286),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHaddsec] = ACTIONS(6286),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6286),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6286),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHitem] = ACTIONS(6286),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6288),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6288),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6288),
    [anon_sym_DOLLAR] = ACTIONS(6286),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHbegin] = ACTIONS(6286),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHleft] = ACTIONS(6286),
    [anon_sym_BSLASHbigl] = ACTIONS(6286),
    [anon_sym_BSLASHBigl] = ACTIONS(6286),
    [anon_sym_BSLASHbiggl] = ACTIONS(6286),
    [anon_sym_BSLASHBiggl] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHtext] = ACTIONS(6286),
    [anon_sym_BSLASHintertext] = ACTIONS(6286),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [1348] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2420),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7087),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1349] = {
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_LBRACK] = ACTIONS(6272),
    [anon_sym_RBRACK] = ACTIONS(6272),
    [anon_sym_COMMA] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_LPAREN] = ACTIONS(6272),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHpart] = ACTIONS(6270),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddpart] = ACTIONS(6270),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHchapter] = ACTIONS(6270),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddchap] = ACTIONS(6270),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsection] = ACTIONS(6270),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHaddsec] = ACTIONS(6270),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6270),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6270),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHitem] = ACTIONS(6270),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6272),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6272),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6272),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6272),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHbegin] = ACTIONS(6270),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHleft] = ACTIONS(6270),
    [anon_sym_BSLASHbigl] = ACTIONS(6270),
    [anon_sym_BSLASHBigl] = ACTIONS(6270),
    [anon_sym_BSLASHbiggl] = ACTIONS(6270),
    [anon_sym_BSLASHBiggl] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHtext] = ACTIONS(6270),
    [anon_sym_BSLASHintertext] = ACTIONS(6270),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [1350] = {
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_RBRACK] = ACTIONS(6356),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_EQ] = ACTIONS(6356),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_RPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHpart] = ACTIONS(6354),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddpart] = ACTIONS(6354),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHchapter] = ACTIONS(6354),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddchap] = ACTIONS(6354),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsection] = ACTIONS(6354),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHaddsec] = ACTIONS(6354),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6354),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6354),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHitem] = ACTIONS(6354),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6356),
    [anon_sym_LBRACE] = ACTIONS(6356),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6356),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6356),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6356),
    [anon_sym_DOLLAR] = ACTIONS(6354),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHbegin] = ACTIONS(6354),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHleft] = ACTIONS(6354),
    [anon_sym_BSLASHbigl] = ACTIONS(6354),
    [anon_sym_BSLASHBigl] = ACTIONS(6354),
    [anon_sym_BSLASHbiggl] = ACTIONS(6354),
    [anon_sym_BSLASHBiggl] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHtext] = ACTIONS(6354),
    [anon_sym_BSLASHintertext] = ACTIONS(6354),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [1351] = {
    [sym_command_name] = ACTIONS(6642),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6642),
    [anon_sym_LBRACK] = ACTIONS(6644),
    [anon_sym_RBRACK] = ACTIONS(6644),
    [anon_sym_COMMA] = ACTIONS(6644),
    [anon_sym_EQ] = ACTIONS(6644),
    [anon_sym_LPAREN] = ACTIONS(6644),
    [anon_sym_RPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHpart] = ACTIONS(6642),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddpart] = ACTIONS(6642),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHchapter] = ACTIONS(6642),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddchap] = ACTIONS(6642),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsection] = ACTIONS(6642),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHaddsec] = ACTIONS(6642),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6642),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6642),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHitem] = ACTIONS(6642),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6644),
    [anon_sym_LBRACE] = ACTIONS(6644),
    [sym_word] = ACTIONS(6642),
    [sym_placeholder] = ACTIONS(6644),
    [anon_sym_PLUS] = ACTIONS(6644),
    [anon_sym_DASH] = ACTIONS(6644),
    [anon_sym_STAR] = ACTIONS(6644),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_LT] = ACTIONS(6642),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_BANG] = ACTIONS(6642),
    [anon_sym_PIPE] = ACTIONS(6642),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_SQUOTE] = ACTIONS(6642),
    [anon_sym__] = ACTIONS(6644),
    [anon_sym_CARET] = ACTIONS(6644),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6644),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6644),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6644),
    [anon_sym_DOLLAR] = ACTIONS(6642),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHbegin] = ACTIONS(6642),
    [anon_sym_BSLASHtitle] = ACTIONS(6642),
    [anon_sym_BSLASHauthor] = ACTIONS(6642),
    [anon_sym_BSLASHusepackage] = ACTIONS(6642),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6642),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6642),
    [anon_sym_BSLASHinclude] = ACTIONS(6642),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6642),
    [anon_sym_BSLASHinput] = ACTIONS(6642),
    [anon_sym_BSLASHsubfile] = ACTIONS(6642),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6642),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6642),
    [anon_sym_BSLASHbibliography] = ACTIONS(6642),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6642),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6642),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6642),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6642),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6642),
    [anon_sym_BSLASHimport] = ACTIONS(6642),
    [anon_sym_BSLASHsubimport] = ACTIONS(6642),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6642),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHcaption] = ACTIONS(6642),
    [anon_sym_BSLASHcite] = ACTIONS(6642),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCite] = ACTIONS(6642),
    [anon_sym_BSLASHnocite] = ACTIONS(6642),
    [anon_sym_BSLASHcitet] = ACTIONS(6642),
    [anon_sym_BSLASHcitep] = ACTIONS(6642),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteA] = ACTIONS(6642),
    [anon_sym_BSLASHciteR] = ACTIONS(6642),
    [anon_sym_BSLASHciteS] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6642),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteyear] = ACTIONS(6642),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitedate] = ACTIONS(6642),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteurl] = ACTIONS(6642),
    [anon_sym_BSLASHfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6642),
    [anon_sym_BSLASHcitealt] = ACTIONS(6642),
    [anon_sym_BSLASHcitealp] = ACTIONS(6642),
    [anon_sym_BSLASHcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHparencite] = ACTIONS(6642),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHParencite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHtextcite] = ACTIONS(6642),
    [anon_sym_BSLASHTextcite] = ACTIONS(6642),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHsupercite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite] = ACTIONS(6642),
    [anon_sym_BSLASHAutocite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHVolcite] = ACTIONS(6642),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHavolcite] = ACTIONS(6642),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHNotecite] = ACTIONS(6642),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHlabel] = ACTIONS(6642),
    [anon_sym_BSLASHref] = ACTIONS(6642),
    [anon_sym_BSLASHeqref] = ACTIONS(6642),
    [anon_sym_BSLASHvref] = ACTIONS(6642),
    [anon_sym_BSLASHVref] = ACTIONS(6642),
    [anon_sym_BSLASHautoref] = ACTIONS(6642),
    [anon_sym_BSLASHpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcref] = ACTIONS(6642),
    [anon_sym_BSLASHCref] = ACTIONS(6642),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnameCref] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHdef] = ACTIONS(6642),
    [anon_sym_BSLASHlet] = ACTIONS(6642),
    [anon_sym_BSLASHleft] = ACTIONS(6642),
    [anon_sym_BSLASHbigl] = ACTIONS(6642),
    [anon_sym_BSLASHBigl] = ACTIONS(6642),
    [anon_sym_BSLASHbiggl] = ACTIONS(6642),
    [anon_sym_BSLASHBiggl] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6642),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6642),
    [anon_sym_BSLASHgls] = ACTIONS(6642),
    [anon_sym_BSLASHGls] = ACTIONS(6642),
    [anon_sym_BSLASHGLS] = ACTIONS(6642),
    [anon_sym_BSLASHglspl] = ACTIONS(6642),
    [anon_sym_BSLASHGlspl] = ACTIONS(6642),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6642),
    [anon_sym_BSLASHglslink] = ACTIONS(6642),
    [anon_sym_BSLASHglstext] = ACTIONS(6642),
    [anon_sym_BSLASHGlstext] = ACTIONS(6642),
    [anon_sym_BSLASHGLStext] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6642),
    [anon_sym_BSLASHglsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsname] = ACTIONS(6642),
    [anon_sym_BSLASHGlsname] = ACTIONS(6642),
    [anon_sym_BSLASHGLSname] = ACTIONS(6642),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6642),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6642),
    [anon_sym_BSLASHacrshort] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6642),
    [anon_sym_BSLASHACRshort] = ACTIONS(6642),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrlong] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6642),
    [anon_sym_BSLASHACRlong] = ACTIONS(6642),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrfull] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6642),
    [anon_sym_BSLASHACRfull] = ACTIONS(6642),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHacs] = ACTIONS(6642),
    [anon_sym_BSLASHAcs] = ACTIONS(6642),
    [anon_sym_BSLASHacsp] = ACTIONS(6642),
    [anon_sym_BSLASHAcsp] = ACTIONS(6642),
    [anon_sym_BSLASHacl] = ACTIONS(6642),
    [anon_sym_BSLASHAcl] = ACTIONS(6642),
    [anon_sym_BSLASHaclp] = ACTIONS(6642),
    [anon_sym_BSLASHAclp] = ACTIONS(6642),
    [anon_sym_BSLASHacf] = ACTIONS(6642),
    [anon_sym_BSLASHAcf] = ACTIONS(6642),
    [anon_sym_BSLASHacfp] = ACTIONS(6642),
    [anon_sym_BSLASHAcfp] = ACTIONS(6642),
    [anon_sym_BSLASHac] = ACTIONS(6642),
    [anon_sym_BSLASHAc] = ACTIONS(6642),
    [anon_sym_BSLASHacp] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6642),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6642),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6642),
    [anon_sym_BSLASHcolor] = ACTIONS(6642),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6642),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6642),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6642),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6642),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6642),
    [anon_sym_BSLASHtext] = ACTIONS(6642),
    [anon_sym_BSLASHintertext] = ACTIONS(6642),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6642),
    [anon_sym_BSLASHurl] = ACTIONS(6642),
    [anon_sym_BSLASHhref] = ACTIONS(6642),
  },
  [1352] = {
    [sym_command_name] = ACTIONS(2214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(2214),
    [anon_sym_LBRACK] = ACTIONS(2216),
    [anon_sym_RBRACK] = ACTIONS(2216),
    [anon_sym_COMMA] = ACTIONS(2216),
    [anon_sym_EQ] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2216),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHpart] = ACTIONS(2214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddpart] = ACTIONS(2214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHchapter] = ACTIONS(2214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddchap] = ACTIONS(2214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsection] = ACTIONS(2214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHaddsec] = ACTIONS(2214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(2214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(2214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHitem] = ACTIONS(2214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2216),
    [sym_word] = ACTIONS(2214),
    [sym_placeholder] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2214),
    [anon_sym_COLON] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [anon_sym__] = ACTIONS(2216),
    [anon_sym_CARET] = ACTIONS(2216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(2216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(2216),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(2216),
    [anon_sym_DOLLAR] = ACTIONS(2214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(2216),
    [anon_sym_BSLASHbegin] = ACTIONS(2214),
    [anon_sym_BSLASHtitle] = ACTIONS(2214),
    [anon_sym_BSLASHauthor] = ACTIONS(2214),
    [anon_sym_BSLASHusepackage] = ACTIONS(2214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(2214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(2214),
    [anon_sym_BSLASHinclude] = ACTIONS(2214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(2214),
    [anon_sym_BSLASHinput] = ACTIONS(2214),
    [anon_sym_BSLASHsubfile] = ACTIONS(2214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(2214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(2214),
    [anon_sym_BSLASHbibliography] = ACTIONS(2214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(2214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(2214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(2214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(2214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(2214),
    [anon_sym_BSLASHimport] = ACTIONS(2214),
    [anon_sym_BSLASHsubimport] = ACTIONS(2214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(2214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(2214),
    [anon_sym_BSLASHcaption] = ACTIONS(2214),
    [anon_sym_BSLASHcite] = ACTIONS(2214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCite] = ACTIONS(2214),
    [anon_sym_BSLASHnocite] = ACTIONS(2214),
    [anon_sym_BSLASHcitet] = ACTIONS(2214),
    [anon_sym_BSLASHcitep] = ACTIONS(2214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteA] = ACTIONS(2214),
    [anon_sym_BSLASHciteR] = ACTIONS(2214),
    [anon_sym_BSLASHciteS] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(2214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(2214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteyear] = ACTIONS(2214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHcitedate] = ACTIONS(2214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHciteurl] = ACTIONS(2214),
    [anon_sym_BSLASHfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(2214),
    [anon_sym_BSLASHcitealt] = ACTIONS(2214),
    [anon_sym_BSLASHcitealp] = ACTIONS(2214),
    [anon_sym_BSLASHcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHparencite] = ACTIONS(2214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHParencite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(2214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(2214),
    [anon_sym_BSLASHtextcite] = ACTIONS(2214),
    [anon_sym_BSLASHTextcite] = ACTIONS(2214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(2214),
    [anon_sym_BSLASHsupercite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite] = ACTIONS(2214),
    [anon_sym_BSLASHAutocite] = ACTIONS(2214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHVolcite] = ACTIONS(2214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHavolcite] = ACTIONS(2214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(2214),
    [anon_sym_BSLASHnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHNotecite] = ACTIONS(2214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(2214),
    [anon_sym_BSLASHlabel] = ACTIONS(2214),
    [anon_sym_BSLASHref] = ACTIONS(2214),
    [anon_sym_BSLASHeqref] = ACTIONS(2214),
    [anon_sym_BSLASHvref] = ACTIONS(2214),
    [anon_sym_BSLASHVref] = ACTIONS(2214),
    [anon_sym_BSLASHautoref] = ACTIONS(2214),
    [anon_sym_BSLASHpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcref] = ACTIONS(2214),
    [anon_sym_BSLASHCref] = ACTIONS(2214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnameCref] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(2214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(2214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(2214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(2214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(2214),
    [anon_sym_BSLASHdef] = ACTIONS(2214),
    [anon_sym_BSLASHlet] = ACTIONS(2214),
    [anon_sym_BSLASHleft] = ACTIONS(2214),
    [anon_sym_BSLASHbigl] = ACTIONS(2214),
    [anon_sym_BSLASHBigl] = ACTIONS(2214),
    [anon_sym_BSLASHbiggl] = ACTIONS(2214),
    [anon_sym_BSLASHBiggl] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(2214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(2214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(2214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(2214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(2214),
    [anon_sym_BSLASHgls] = ACTIONS(2214),
    [anon_sym_BSLASHGls] = ACTIONS(2214),
    [anon_sym_BSLASHGLS] = ACTIONS(2214),
    [anon_sym_BSLASHglspl] = ACTIONS(2214),
    [anon_sym_BSLASHGlspl] = ACTIONS(2214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(2214),
    [anon_sym_BSLASHglslink] = ACTIONS(2214),
    [anon_sym_BSLASHglstext] = ACTIONS(2214),
    [anon_sym_BSLASHGlstext] = ACTIONS(2214),
    [anon_sym_BSLASHGLStext] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(2214),
    [anon_sym_BSLASHglsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(2214),
    [anon_sym_BSLASHglsname] = ACTIONS(2214),
    [anon_sym_BSLASHGlsname] = ACTIONS(2214),
    [anon_sym_BSLASHGLSname] = ACTIONS(2214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(2214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(2214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(2214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(2214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(2214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(2214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(2214),
    [anon_sym_BSLASHacrshort] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(2214),
    [anon_sym_BSLASHACRshort] = ACTIONS(2214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrlong] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(2214),
    [anon_sym_BSLASHACRlong] = ACTIONS(2214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(2214),
    [anon_sym_BSLASHacrfull] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(2214),
    [anon_sym_BSLASHACRfull] = ACTIONS(2214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHacs] = ACTIONS(2214),
    [anon_sym_BSLASHAcs] = ACTIONS(2214),
    [anon_sym_BSLASHacsp] = ACTIONS(2214),
    [anon_sym_BSLASHAcsp] = ACTIONS(2214),
    [anon_sym_BSLASHacl] = ACTIONS(2214),
    [anon_sym_BSLASHAcl] = ACTIONS(2214),
    [anon_sym_BSLASHaclp] = ACTIONS(2214),
    [anon_sym_BSLASHAclp] = ACTIONS(2214),
    [anon_sym_BSLASHacf] = ACTIONS(2214),
    [anon_sym_BSLASHAcf] = ACTIONS(2214),
    [anon_sym_BSLASHacfp] = ACTIONS(2214),
    [anon_sym_BSLASHAcfp] = ACTIONS(2214),
    [anon_sym_BSLASHac] = ACTIONS(2214),
    [anon_sym_BSLASHAc] = ACTIONS(2214),
    [anon_sym_BSLASHacp] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(2214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(2214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(2214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(2214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(2216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(2214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(2214),
    [anon_sym_BSLASHcolor] = ACTIONS(2214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(2214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(2214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(2214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(2214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(2214),
    [anon_sym_BSLASHtext] = ACTIONS(2214),
    [anon_sym_BSLASHintertext] = ACTIONS(2214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(2214),
    [anon_sym_BSLASHurl] = ACTIONS(2214),
    [anon_sym_BSLASHhref] = ACTIONS(2214),
  },
  [1353] = {
    [sym_command_name] = ACTIONS(6546),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6548),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LPAREN] = ACTIONS(6548),
    [anon_sym_RPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHpart] = ACTIONS(6546),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddpart] = ACTIONS(6546),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHchapter] = ACTIONS(6546),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddchap] = ACTIONS(6546),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsection] = ACTIONS(6546),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHaddsec] = ACTIONS(6546),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6546),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6546),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHitem] = ACTIONS(6546),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6548),
    [anon_sym_LBRACE] = ACTIONS(6548),
    [sym_word] = ACTIONS(6546),
    [sym_placeholder] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_DASH] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6546),
    [anon_sym_GT] = ACTIONS(6546),
    [anon_sym_BANG] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6546),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_SQUOTE] = ACTIONS(6546),
    [anon_sym__] = ACTIONS(6548),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6548),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6548),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6548),
    [anon_sym_DOLLAR] = ACTIONS(6546),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHbegin] = ACTIONS(6546),
    [anon_sym_BSLASHtitle] = ACTIONS(6546),
    [anon_sym_BSLASHauthor] = ACTIONS(6546),
    [anon_sym_BSLASHusepackage] = ACTIONS(6546),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6546),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6546),
    [anon_sym_BSLASHinclude] = ACTIONS(6546),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6546),
    [anon_sym_BSLASHinput] = ACTIONS(6546),
    [anon_sym_BSLASHsubfile] = ACTIONS(6546),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6546),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6546),
    [anon_sym_BSLASHbibliography] = ACTIONS(6546),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6546),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6546),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6546),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6546),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6546),
    [anon_sym_BSLASHimport] = ACTIONS(6546),
    [anon_sym_BSLASHsubimport] = ACTIONS(6546),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6546),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHcaption] = ACTIONS(6546),
    [anon_sym_BSLASHcite] = ACTIONS(6546),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCite] = ACTIONS(6546),
    [anon_sym_BSLASHnocite] = ACTIONS(6546),
    [anon_sym_BSLASHcitet] = ACTIONS(6546),
    [anon_sym_BSLASHcitep] = ACTIONS(6546),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteA] = ACTIONS(6546),
    [anon_sym_BSLASHciteR] = ACTIONS(6546),
    [anon_sym_BSLASHciteS] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6546),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteyear] = ACTIONS(6546),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitedate] = ACTIONS(6546),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteurl] = ACTIONS(6546),
    [anon_sym_BSLASHfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6546),
    [anon_sym_BSLASHcitealt] = ACTIONS(6546),
    [anon_sym_BSLASHcitealp] = ACTIONS(6546),
    [anon_sym_BSLASHcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHparencite] = ACTIONS(6546),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHParencite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHtextcite] = ACTIONS(6546),
    [anon_sym_BSLASHTextcite] = ACTIONS(6546),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHsupercite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite] = ACTIONS(6546),
    [anon_sym_BSLASHAutocite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHVolcite] = ACTIONS(6546),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHavolcite] = ACTIONS(6546),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHNotecite] = ACTIONS(6546),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHlabel] = ACTIONS(6546),
    [anon_sym_BSLASHref] = ACTIONS(6546),
    [anon_sym_BSLASHeqref] = ACTIONS(6546),
    [anon_sym_BSLASHvref] = ACTIONS(6546),
    [anon_sym_BSLASHVref] = ACTIONS(6546),
    [anon_sym_BSLASHautoref] = ACTIONS(6546),
    [anon_sym_BSLASHpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcref] = ACTIONS(6546),
    [anon_sym_BSLASHCref] = ACTIONS(6546),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnameCref] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHdef] = ACTIONS(6546),
    [anon_sym_BSLASHlet] = ACTIONS(6546),
    [anon_sym_BSLASHleft] = ACTIONS(6546),
    [anon_sym_BSLASHbigl] = ACTIONS(6546),
    [anon_sym_BSLASHBigl] = ACTIONS(6546),
    [anon_sym_BSLASHbiggl] = ACTIONS(6546),
    [anon_sym_BSLASHBiggl] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6546),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6546),
    [anon_sym_BSLASHgls] = ACTIONS(6546),
    [anon_sym_BSLASHGls] = ACTIONS(6546),
    [anon_sym_BSLASHGLS] = ACTIONS(6546),
    [anon_sym_BSLASHglspl] = ACTIONS(6546),
    [anon_sym_BSLASHGlspl] = ACTIONS(6546),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6546),
    [anon_sym_BSLASHglslink] = ACTIONS(6546),
    [anon_sym_BSLASHglstext] = ACTIONS(6546),
    [anon_sym_BSLASHGlstext] = ACTIONS(6546),
    [anon_sym_BSLASHGLStext] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6546),
    [anon_sym_BSLASHglsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsname] = ACTIONS(6546),
    [anon_sym_BSLASHGlsname] = ACTIONS(6546),
    [anon_sym_BSLASHGLSname] = ACTIONS(6546),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6546),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6546),
    [anon_sym_BSLASHacrshort] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6546),
    [anon_sym_BSLASHACRshort] = ACTIONS(6546),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrlong] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6546),
    [anon_sym_BSLASHACRlong] = ACTIONS(6546),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrfull] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6546),
    [anon_sym_BSLASHACRfull] = ACTIONS(6546),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHacs] = ACTIONS(6546),
    [anon_sym_BSLASHAcs] = ACTIONS(6546),
    [anon_sym_BSLASHacsp] = ACTIONS(6546),
    [anon_sym_BSLASHAcsp] = ACTIONS(6546),
    [anon_sym_BSLASHacl] = ACTIONS(6546),
    [anon_sym_BSLASHAcl] = ACTIONS(6546),
    [anon_sym_BSLASHaclp] = ACTIONS(6546),
    [anon_sym_BSLASHAclp] = ACTIONS(6546),
    [anon_sym_BSLASHacf] = ACTIONS(6546),
    [anon_sym_BSLASHAcf] = ACTIONS(6546),
    [anon_sym_BSLASHacfp] = ACTIONS(6546),
    [anon_sym_BSLASHAcfp] = ACTIONS(6546),
    [anon_sym_BSLASHac] = ACTIONS(6546),
    [anon_sym_BSLASHAc] = ACTIONS(6546),
    [anon_sym_BSLASHacp] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6546),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6546),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6546),
    [anon_sym_BSLASHcolor] = ACTIONS(6546),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6546),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6546),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6546),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6546),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6546),
    [anon_sym_BSLASHtext] = ACTIONS(6546),
    [anon_sym_BSLASHintertext] = ACTIONS(6546),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6546),
    [anon_sym_BSLASHurl] = ACTIONS(6546),
    [anon_sym_BSLASHhref] = ACTIONS(6546),
  },
  [1354] = {
    [sym_command_name] = ACTIONS(6542),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6544),
    [anon_sym_RBRACK] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LPAREN] = ACTIONS(6544),
    [anon_sym_RPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHpart] = ACTIONS(6542),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddpart] = ACTIONS(6542),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHchapter] = ACTIONS(6542),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddchap] = ACTIONS(6542),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsection] = ACTIONS(6542),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHaddsec] = ACTIONS(6542),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6542),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6542),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHitem] = ACTIONS(6542),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6544),
    [anon_sym_LBRACE] = ACTIONS(6544),
    [sym_word] = ACTIONS(6542),
    [sym_placeholder] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_DASH] = ACTIONS(6544),
    [anon_sym_STAR] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6542),
    [anon_sym_GT] = ACTIONS(6542),
    [anon_sym_BANG] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6542),
    [anon_sym_COLON] = ACTIONS(6542),
    [anon_sym_SQUOTE] = ACTIONS(6542),
    [anon_sym__] = ACTIONS(6544),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6544),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6544),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6544),
    [anon_sym_DOLLAR] = ACTIONS(6542),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHbegin] = ACTIONS(6542),
    [anon_sym_BSLASHtitle] = ACTIONS(6542),
    [anon_sym_BSLASHauthor] = ACTIONS(6542),
    [anon_sym_BSLASHusepackage] = ACTIONS(6542),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6542),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6542),
    [anon_sym_BSLASHinclude] = ACTIONS(6542),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6542),
    [anon_sym_BSLASHinput] = ACTIONS(6542),
    [anon_sym_BSLASHsubfile] = ACTIONS(6542),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6542),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6542),
    [anon_sym_BSLASHbibliography] = ACTIONS(6542),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6542),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6542),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6542),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6542),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6542),
    [anon_sym_BSLASHimport] = ACTIONS(6542),
    [anon_sym_BSLASHsubimport] = ACTIONS(6542),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6542),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHcaption] = ACTIONS(6542),
    [anon_sym_BSLASHcite] = ACTIONS(6542),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCite] = ACTIONS(6542),
    [anon_sym_BSLASHnocite] = ACTIONS(6542),
    [anon_sym_BSLASHcitet] = ACTIONS(6542),
    [anon_sym_BSLASHcitep] = ACTIONS(6542),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteA] = ACTIONS(6542),
    [anon_sym_BSLASHciteR] = ACTIONS(6542),
    [anon_sym_BSLASHciteS] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6542),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteyear] = ACTIONS(6542),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitedate] = ACTIONS(6542),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteurl] = ACTIONS(6542),
    [anon_sym_BSLASHfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6542),
    [anon_sym_BSLASHcitealt] = ACTIONS(6542),
    [anon_sym_BSLASHcitealp] = ACTIONS(6542),
    [anon_sym_BSLASHcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHparencite] = ACTIONS(6542),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHParencite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHtextcite] = ACTIONS(6542),
    [anon_sym_BSLASHTextcite] = ACTIONS(6542),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHsupercite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite] = ACTIONS(6542),
    [anon_sym_BSLASHAutocite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHVolcite] = ACTIONS(6542),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHavolcite] = ACTIONS(6542),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHNotecite] = ACTIONS(6542),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHlabel] = ACTIONS(6542),
    [anon_sym_BSLASHref] = ACTIONS(6542),
    [anon_sym_BSLASHeqref] = ACTIONS(6542),
    [anon_sym_BSLASHvref] = ACTIONS(6542),
    [anon_sym_BSLASHVref] = ACTIONS(6542),
    [anon_sym_BSLASHautoref] = ACTIONS(6542),
    [anon_sym_BSLASHpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcref] = ACTIONS(6542),
    [anon_sym_BSLASHCref] = ACTIONS(6542),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnameCref] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHdef] = ACTIONS(6542),
    [anon_sym_BSLASHlet] = ACTIONS(6542),
    [anon_sym_BSLASHleft] = ACTIONS(6542),
    [anon_sym_BSLASHbigl] = ACTIONS(6542),
    [anon_sym_BSLASHBigl] = ACTIONS(6542),
    [anon_sym_BSLASHbiggl] = ACTIONS(6542),
    [anon_sym_BSLASHBiggl] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6542),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6542),
    [anon_sym_BSLASHgls] = ACTIONS(6542),
    [anon_sym_BSLASHGls] = ACTIONS(6542),
    [anon_sym_BSLASHGLS] = ACTIONS(6542),
    [anon_sym_BSLASHglspl] = ACTIONS(6542),
    [anon_sym_BSLASHGlspl] = ACTIONS(6542),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6542),
    [anon_sym_BSLASHglslink] = ACTIONS(6542),
    [anon_sym_BSLASHglstext] = ACTIONS(6542),
    [anon_sym_BSLASHGlstext] = ACTIONS(6542),
    [anon_sym_BSLASHGLStext] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6542),
    [anon_sym_BSLASHglsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsname] = ACTIONS(6542),
    [anon_sym_BSLASHGlsname] = ACTIONS(6542),
    [anon_sym_BSLASHGLSname] = ACTIONS(6542),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6542),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6542),
    [anon_sym_BSLASHacrshort] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6542),
    [anon_sym_BSLASHACRshort] = ACTIONS(6542),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrlong] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6542),
    [anon_sym_BSLASHACRlong] = ACTIONS(6542),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrfull] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6542),
    [anon_sym_BSLASHACRfull] = ACTIONS(6542),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHacs] = ACTIONS(6542),
    [anon_sym_BSLASHAcs] = ACTIONS(6542),
    [anon_sym_BSLASHacsp] = ACTIONS(6542),
    [anon_sym_BSLASHAcsp] = ACTIONS(6542),
    [anon_sym_BSLASHacl] = ACTIONS(6542),
    [anon_sym_BSLASHAcl] = ACTIONS(6542),
    [anon_sym_BSLASHaclp] = ACTIONS(6542),
    [anon_sym_BSLASHAclp] = ACTIONS(6542),
    [anon_sym_BSLASHacf] = ACTIONS(6542),
    [anon_sym_BSLASHAcf] = ACTIONS(6542),
    [anon_sym_BSLASHacfp] = ACTIONS(6542),
    [anon_sym_BSLASHAcfp] = ACTIONS(6542),
    [anon_sym_BSLASHac] = ACTIONS(6542),
    [anon_sym_BSLASHAc] = ACTIONS(6542),
    [anon_sym_BSLASHacp] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6542),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6542),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6542),
    [anon_sym_BSLASHcolor] = ACTIONS(6542),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6542),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6542),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6542),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6542),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6542),
    [anon_sym_BSLASHtext] = ACTIONS(6542),
    [anon_sym_BSLASHintertext] = ACTIONS(6542),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6542),
    [anon_sym_BSLASHurl] = ACTIONS(6542),
    [anon_sym_BSLASHhref] = ACTIONS(6542),
  },
  [1355] = {
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [anon_sym_RPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHpart] = ACTIONS(6346),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddpart] = ACTIONS(6346),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHchapter] = ACTIONS(6346),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddchap] = ACTIONS(6346),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsection] = ACTIONS(6346),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHaddsec] = ACTIONS(6346),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6346),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6346),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHitem] = ACTIONS(6346),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6348),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6348),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6348),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6348),
    [anon_sym_DOLLAR] = ACTIONS(6346),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHbegin] = ACTIONS(6346),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHleft] = ACTIONS(6346),
    [anon_sym_BSLASHbigl] = ACTIONS(6346),
    [anon_sym_BSLASHBigl] = ACTIONS(6346),
    [anon_sym_BSLASHbiggl] = ACTIONS(6346),
    [anon_sym_BSLASHBiggl] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHtext] = ACTIONS(6346),
    [anon_sym_BSLASHintertext] = ACTIONS(6346),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [1356] = {
    [sym_command_name] = ACTIONS(6206),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [anon_sym_RBRACK] = ACTIONS(6208),
    [anon_sym_COMMA] = ACTIONS(6208),
    [anon_sym_EQ] = ACTIONS(6208),
    [anon_sym_LPAREN] = ACTIONS(6208),
    [anon_sym_RPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHpart] = ACTIONS(6206),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddpart] = ACTIONS(6206),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHchapter] = ACTIONS(6206),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddchap] = ACTIONS(6206),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsection] = ACTIONS(6206),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddsec] = ACTIONS(6206),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHitem] = ACTIONS(6206),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6208),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [sym_word] = ACTIONS(6206),
    [sym_placeholder] = ACTIONS(6208),
    [anon_sym_PLUS] = ACTIONS(6208),
    [anon_sym_DASH] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_SLASH] = ACTIONS(6208),
    [anon_sym_LT] = ACTIONS(6206),
    [anon_sym_GT] = ACTIONS(6206),
    [anon_sym_BANG] = ACTIONS(6206),
    [anon_sym_PIPE] = ACTIONS(6206),
    [anon_sym_COLON] = ACTIONS(6206),
    [anon_sym_SQUOTE] = ACTIONS(6206),
    [anon_sym__] = ACTIONS(6208),
    [anon_sym_CARET] = ACTIONS(6208),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6208),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6208),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6208),
    [anon_sym_DOLLAR] = ACTIONS(6206),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHbegin] = ACTIONS(6206),
    [anon_sym_BSLASHtitle] = ACTIONS(6206),
    [anon_sym_BSLASHauthor] = ACTIONS(6206),
    [anon_sym_BSLASHusepackage] = ACTIONS(6206),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6206),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6206),
    [anon_sym_BSLASHinclude] = ACTIONS(6206),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6206),
    [anon_sym_BSLASHinput] = ACTIONS(6206),
    [anon_sym_BSLASHsubfile] = ACTIONS(6206),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6206),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6206),
    [anon_sym_BSLASHbibliography] = ACTIONS(6206),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6206),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6206),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6206),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6206),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6206),
    [anon_sym_BSLASHimport] = ACTIONS(6206),
    [anon_sym_BSLASHsubimport] = ACTIONS(6206),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6206),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHcaption] = ACTIONS(6206),
    [anon_sym_BSLASHcite] = ACTIONS(6206),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCite] = ACTIONS(6206),
    [anon_sym_BSLASHnocite] = ACTIONS(6206),
    [anon_sym_BSLASHcitet] = ACTIONS(6206),
    [anon_sym_BSLASHcitep] = ACTIONS(6206),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteA] = ACTIONS(6206),
    [anon_sym_BSLASHciteR] = ACTIONS(6206),
    [anon_sym_BSLASHciteS] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6206),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteyear] = ACTIONS(6206),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitedate] = ACTIONS(6206),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteurl] = ACTIONS(6206),
    [anon_sym_BSLASHfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6206),
    [anon_sym_BSLASHcitealt] = ACTIONS(6206),
    [anon_sym_BSLASHcitealp] = ACTIONS(6206),
    [anon_sym_BSLASHcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHparencite] = ACTIONS(6206),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHParencite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHtextcite] = ACTIONS(6206),
    [anon_sym_BSLASHTextcite] = ACTIONS(6206),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHsupercite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite] = ACTIONS(6206),
    [anon_sym_BSLASHAutocite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHVolcite] = ACTIONS(6206),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHavolcite] = ACTIONS(6206),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHNotecite] = ACTIONS(6206),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHlabel] = ACTIONS(6206),
    [anon_sym_BSLASHref] = ACTIONS(6206),
    [anon_sym_BSLASHeqref] = ACTIONS(6206),
    [anon_sym_BSLASHvref] = ACTIONS(6206),
    [anon_sym_BSLASHVref] = ACTIONS(6206),
    [anon_sym_BSLASHautoref] = ACTIONS(6206),
    [anon_sym_BSLASHpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcref] = ACTIONS(6206),
    [anon_sym_BSLASHCref] = ACTIONS(6206),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnameCref] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHdef] = ACTIONS(6206),
    [anon_sym_BSLASHlet] = ACTIONS(6206),
    [anon_sym_BSLASHleft] = ACTIONS(6206),
    [anon_sym_BSLASHbigl] = ACTIONS(6206),
    [anon_sym_BSLASHBigl] = ACTIONS(6206),
    [anon_sym_BSLASHbiggl] = ACTIONS(6206),
    [anon_sym_BSLASHBiggl] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6206),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6206),
    [anon_sym_BSLASHgls] = ACTIONS(6206),
    [anon_sym_BSLASHGls] = ACTIONS(6206),
    [anon_sym_BSLASHGLS] = ACTIONS(6206),
    [anon_sym_BSLASHglspl] = ACTIONS(6206),
    [anon_sym_BSLASHGlspl] = ACTIONS(6206),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6206),
    [anon_sym_BSLASHglslink] = ACTIONS(6206),
    [anon_sym_BSLASHglstext] = ACTIONS(6206),
    [anon_sym_BSLASHGlstext] = ACTIONS(6206),
    [anon_sym_BSLASHGLStext] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6206),
    [anon_sym_BSLASHglsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsname] = ACTIONS(6206),
    [anon_sym_BSLASHGlsname] = ACTIONS(6206),
    [anon_sym_BSLASHGLSname] = ACTIONS(6206),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6206),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6206),
    [anon_sym_BSLASHacrshort] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6206),
    [anon_sym_BSLASHACRshort] = ACTIONS(6206),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrlong] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6206),
    [anon_sym_BSLASHACRlong] = ACTIONS(6206),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrfull] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6206),
    [anon_sym_BSLASHACRfull] = ACTIONS(6206),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHacs] = ACTIONS(6206),
    [anon_sym_BSLASHAcs] = ACTIONS(6206),
    [anon_sym_BSLASHacsp] = ACTIONS(6206),
    [anon_sym_BSLASHAcsp] = ACTIONS(6206),
    [anon_sym_BSLASHacl] = ACTIONS(6206),
    [anon_sym_BSLASHAcl] = ACTIONS(6206),
    [anon_sym_BSLASHaclp] = ACTIONS(6206),
    [anon_sym_BSLASHAclp] = ACTIONS(6206),
    [anon_sym_BSLASHacf] = ACTIONS(6206),
    [anon_sym_BSLASHAcf] = ACTIONS(6206),
    [anon_sym_BSLASHacfp] = ACTIONS(6206),
    [anon_sym_BSLASHAcfp] = ACTIONS(6206),
    [anon_sym_BSLASHac] = ACTIONS(6206),
    [anon_sym_BSLASHAc] = ACTIONS(6206),
    [anon_sym_BSLASHacp] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6206),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6206),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6206),
    [anon_sym_BSLASHcolor] = ACTIONS(6206),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6206),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6206),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6206),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6206),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6206),
    [anon_sym_BSLASHtext] = ACTIONS(6206),
    [anon_sym_BSLASHintertext] = ACTIONS(6206),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6206),
    [anon_sym_BSLASHurl] = ACTIONS(6206),
    [anon_sym_BSLASHhref] = ACTIONS(6206),
  },
  [1357] = {
    [sym_command_name] = ACTIONS(7089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7089),
    [anon_sym_LBRACK] = ACTIONS(7091),
    [anon_sym_RBRACK] = ACTIONS(7091),
    [anon_sym_COMMA] = ACTIONS(7091),
    [anon_sym_EQ] = ACTIONS(7091),
    [anon_sym_LPAREN] = ACTIONS(7091),
    [anon_sym_RPAREN] = ACTIONS(7091),
    [anon_sym_BSLASHpart] = ACTIONS(7089),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHaddpart] = ACTIONS(7089),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHchapter] = ACTIONS(7089),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHaddchap] = ACTIONS(7089),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHsection] = ACTIONS(7089),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHaddsec] = ACTIONS(7089),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHsubsection] = ACTIONS(7089),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(7089),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHparagraph] = ACTIONS(7089),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(7089),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHitem] = ACTIONS(7089),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(7091),
    [anon_sym_LBRACE] = ACTIONS(7091),
    [sym_word] = ACTIONS(7089),
    [sym_placeholder] = ACTIONS(7091),
    [anon_sym_PLUS] = ACTIONS(7091),
    [anon_sym_DASH] = ACTIONS(7091),
    [anon_sym_STAR] = ACTIONS(7091),
    [anon_sym_SLASH] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_BANG] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_COLON] = ACTIONS(7089),
    [anon_sym_SQUOTE] = ACTIONS(7089),
    [anon_sym__] = ACTIONS(7091),
    [anon_sym_CARET] = ACTIONS(7091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7091),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7091),
    [anon_sym_BSLASHbegin] = ACTIONS(7089),
    [anon_sym_BSLASHend] = ACTIONS(7089),
    [anon_sym_BSLASHtitle] = ACTIONS(7089),
    [anon_sym_BSLASHauthor] = ACTIONS(7089),
    [anon_sym_BSLASHusepackage] = ACTIONS(7089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7089),
    [anon_sym_BSLASHinclude] = ACTIONS(7089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7089),
    [anon_sym_BSLASHinput] = ACTIONS(7089),
    [anon_sym_BSLASHsubfile] = ACTIONS(7089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7089),
    [anon_sym_BSLASHbibliography] = ACTIONS(7089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7089),
    [anon_sym_BSLASHimport] = ACTIONS(7089),
    [anon_sym_BSLASHsubimport] = ACTIONS(7089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7089),
    [anon_sym_BSLASHcaption] = ACTIONS(7089),
    [anon_sym_BSLASHcite] = ACTIONS(7089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCite] = ACTIONS(7089),
    [anon_sym_BSLASHnocite] = ACTIONS(7089),
    [anon_sym_BSLASHcitet] = ACTIONS(7089),
    [anon_sym_BSLASHcitep] = ACTIONS(7089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHciteA] = ACTIONS(7089),
    [anon_sym_BSLASHciteR] = ACTIONS(7089),
    [anon_sym_BSLASHciteS] = ACTIONS(7089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHciteyear] = ACTIONS(7089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHcitedate] = ACTIONS(7089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHciteurl] = ACTIONS(7089),
    [anon_sym_BSLASHfullcite] = ACTIONS(7089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7089),
    [anon_sym_BSLASHcitealt] = ACTIONS(7089),
    [anon_sym_BSLASHcitealp] = ACTIONS(7089),
    [anon_sym_BSLASHcitetext] = ACTIONS(7089),
    [anon_sym_BSLASHparencite] = ACTIONS(7089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHParencite] = ACTIONS(7089),
    [anon_sym_BSLASHfootcite] = ACTIONS(7089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7089),
    [anon_sym_BSLASHtextcite] = ACTIONS(7089),
    [anon_sym_BSLASHTextcite] = ACTIONS(7089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7089),
    [anon_sym_BSLASHsupercite] = ACTIONS(7089),
    [anon_sym_BSLASHautocite] = ACTIONS(7089),
    [anon_sym_BSLASHAutocite] = ACTIONS(7089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHVolcite] = ACTIONS(7089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHavolcite] = ACTIONS(7089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHNotecite] = ACTIONS(7089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHlabel] = ACTIONS(7089),
    [anon_sym_BSLASHref] = ACTIONS(7089),
    [anon_sym_BSLASHeqref] = ACTIONS(7089),
    [anon_sym_BSLASHvref] = ACTIONS(7089),
    [anon_sym_BSLASHVref] = ACTIONS(7089),
    [anon_sym_BSLASHautoref] = ACTIONS(7089),
    [anon_sym_BSLASHpageref] = ACTIONS(7089),
    [anon_sym_BSLASHcref] = ACTIONS(7089),
    [anon_sym_BSLASHCref] = ACTIONS(7089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHnamecref] = ACTIONS(7089),
    [anon_sym_BSLASHnameCref] = ACTIONS(7089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHdef] = ACTIONS(7089),
    [anon_sym_BSLASHlet] = ACTIONS(7089),
    [anon_sym_BSLASHleft] = ACTIONS(7089),
    [anon_sym_BSLASHbigl] = ACTIONS(7089),
    [anon_sym_BSLASHBigl] = ACTIONS(7089),
    [anon_sym_BSLASHbiggl] = ACTIONS(7089),
    [anon_sym_BSLASHBiggl] = ACTIONS(7089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7089),
    [anon_sym_BSLASHgls] = ACTIONS(7089),
    [anon_sym_BSLASHGls] = ACTIONS(7089),
    [anon_sym_BSLASHGLS] = ACTIONS(7089),
    [anon_sym_BSLASHglspl] = ACTIONS(7089),
    [anon_sym_BSLASHGlspl] = ACTIONS(7089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7089),
    [anon_sym_BSLASHglslink] = ACTIONS(7089),
    [anon_sym_BSLASHglstext] = ACTIONS(7089),
    [anon_sym_BSLASHGlstext] = ACTIONS(7089),
    [anon_sym_BSLASHGLStext] = ACTIONS(7089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7089),
    [anon_sym_BSLASHglsplural] = ACTIONS(7089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7089),
    [anon_sym_BSLASHglsname] = ACTIONS(7089),
    [anon_sym_BSLASHGlsname] = ACTIONS(7089),
    [anon_sym_BSLASHGLSname] = ACTIONS(7089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7089),
    [anon_sym_BSLASHacrshort] = ACTIONS(7089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7089),
    [anon_sym_BSLASHACRshort] = ACTIONS(7089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHacrlong] = ACTIONS(7089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7089),
    [anon_sym_BSLASHACRlong] = ACTIONS(7089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7089),
    [anon_sym_BSLASHacrfull] = ACTIONS(7089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7089),
    [anon_sym_BSLASHACRfull] = ACTIONS(7089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHacs] = ACTIONS(7089),
    [anon_sym_BSLASHAcs] = ACTIONS(7089),
    [anon_sym_BSLASHacsp] = ACTIONS(7089),
    [anon_sym_BSLASHAcsp] = ACTIONS(7089),
    [anon_sym_BSLASHacl] = ACTIONS(7089),
    [anon_sym_BSLASHAcl] = ACTIONS(7089),
    [anon_sym_BSLASHaclp] = ACTIONS(7089),
    [anon_sym_BSLASHAclp] = ACTIONS(7089),
    [anon_sym_BSLASHacf] = ACTIONS(7089),
    [anon_sym_BSLASHAcf] = ACTIONS(7089),
    [anon_sym_BSLASHacfp] = ACTIONS(7089),
    [anon_sym_BSLASHAcfp] = ACTIONS(7089),
    [anon_sym_BSLASHac] = ACTIONS(7089),
    [anon_sym_BSLASHAc] = ACTIONS(7089),
    [anon_sym_BSLASHacp] = ACTIONS(7089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7089),
    [anon_sym_BSLASHcolor] = ACTIONS(7089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7089),
    [anon_sym_BSLASHtext] = ACTIONS(7089),
    [anon_sym_BSLASHintertext] = ACTIONS(7089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7089),
    [anon_sym_BSLASHurl] = ACTIONS(7089),
    [anon_sym_BSLASHhref] = ACTIONS(7089),
  },
  [1358] = {
    [sym_command_name] = ACTIONS(6294),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6294),
    [anon_sym_LBRACK] = ACTIONS(6296),
    [anon_sym_RBRACK] = ACTIONS(6296),
    [anon_sym_COMMA] = ACTIONS(6296),
    [anon_sym_EQ] = ACTIONS(6296),
    [anon_sym_LPAREN] = ACTIONS(6296),
    [anon_sym_RPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHpart] = ACTIONS(6294),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddpart] = ACTIONS(6294),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHchapter] = ACTIONS(6294),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddchap] = ACTIONS(6294),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsection] = ACTIONS(6294),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHaddsec] = ACTIONS(6294),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6294),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6294),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHitem] = ACTIONS(6294),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6296),
    [anon_sym_LBRACE] = ACTIONS(6296),
    [sym_word] = ACTIONS(6294),
    [sym_placeholder] = ACTIONS(6296),
    [anon_sym_PLUS] = ACTIONS(6296),
    [anon_sym_DASH] = ACTIONS(6296),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_SLASH] = ACTIONS(6296),
    [anon_sym_LT] = ACTIONS(6294),
    [anon_sym_GT] = ACTIONS(6294),
    [anon_sym_BANG] = ACTIONS(6294),
    [anon_sym_PIPE] = ACTIONS(6294),
    [anon_sym_COLON] = ACTIONS(6294),
    [anon_sym_SQUOTE] = ACTIONS(6294),
    [anon_sym__] = ACTIONS(6296),
    [anon_sym_CARET] = ACTIONS(6296),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6296),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6296),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6296),
    [anon_sym_DOLLAR] = ACTIONS(6294),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6296),
    [anon_sym_BSLASHbegin] = ACTIONS(6294),
    [anon_sym_BSLASHtitle] = ACTIONS(6294),
    [anon_sym_BSLASHauthor] = ACTIONS(6294),
    [anon_sym_BSLASHusepackage] = ACTIONS(6294),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6294),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6294),
    [anon_sym_BSLASHinclude] = ACTIONS(6294),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6294),
    [anon_sym_BSLASHinput] = ACTIONS(6294),
    [anon_sym_BSLASHsubfile] = ACTIONS(6294),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6294),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6294),
    [anon_sym_BSLASHbibliography] = ACTIONS(6294),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6294),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6294),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6294),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6294),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6294),
    [anon_sym_BSLASHimport] = ACTIONS(6294),
    [anon_sym_BSLASHsubimport] = ACTIONS(6294),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6294),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6294),
    [anon_sym_BSLASHcaption] = ACTIONS(6294),
    [anon_sym_BSLASHcite] = ACTIONS(6294),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCite] = ACTIONS(6294),
    [anon_sym_BSLASHnocite] = ACTIONS(6294),
    [anon_sym_BSLASHcitet] = ACTIONS(6294),
    [anon_sym_BSLASHcitep] = ACTIONS(6294),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteA] = ACTIONS(6294),
    [anon_sym_BSLASHciteR] = ACTIONS(6294),
    [anon_sym_BSLASHciteS] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6294),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6294),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteyear] = ACTIONS(6294),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHcitedate] = ACTIONS(6294),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHciteurl] = ACTIONS(6294),
    [anon_sym_BSLASHfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6294),
    [anon_sym_BSLASHcitealt] = ACTIONS(6294),
    [anon_sym_BSLASHcitealp] = ACTIONS(6294),
    [anon_sym_BSLASHcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHparencite] = ACTIONS(6294),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHParencite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6294),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6294),
    [anon_sym_BSLASHtextcite] = ACTIONS(6294),
    [anon_sym_BSLASHTextcite] = ACTIONS(6294),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6294),
    [anon_sym_BSLASHsupercite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite] = ACTIONS(6294),
    [anon_sym_BSLASHAutocite] = ACTIONS(6294),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHVolcite] = ACTIONS(6294),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHavolcite] = ACTIONS(6294),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6294),
    [anon_sym_BSLASHnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHNotecite] = ACTIONS(6294),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6294),
    [anon_sym_BSLASHlabel] = ACTIONS(6294),
    [anon_sym_BSLASHref] = ACTIONS(6294),
    [anon_sym_BSLASHeqref] = ACTIONS(6294),
    [anon_sym_BSLASHvref] = ACTIONS(6294),
    [anon_sym_BSLASHVref] = ACTIONS(6294),
    [anon_sym_BSLASHautoref] = ACTIONS(6294),
    [anon_sym_BSLASHpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcref] = ACTIONS(6294),
    [anon_sym_BSLASHCref] = ACTIONS(6294),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnameCref] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6294),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6294),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6294),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6294),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6294),
    [anon_sym_BSLASHdef] = ACTIONS(6294),
    [anon_sym_BSLASHlet] = ACTIONS(6294),
    [anon_sym_BSLASHleft] = ACTIONS(6294),
    [anon_sym_BSLASHbigl] = ACTIONS(6294),
    [anon_sym_BSLASHBigl] = ACTIONS(6294),
    [anon_sym_BSLASHbiggl] = ACTIONS(6294),
    [anon_sym_BSLASHBiggl] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6294),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6294),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6294),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6294),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6294),
    [anon_sym_BSLASHgls] = ACTIONS(6294),
    [anon_sym_BSLASHGls] = ACTIONS(6294),
    [anon_sym_BSLASHGLS] = ACTIONS(6294),
    [anon_sym_BSLASHglspl] = ACTIONS(6294),
    [anon_sym_BSLASHGlspl] = ACTIONS(6294),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6294),
    [anon_sym_BSLASHglslink] = ACTIONS(6294),
    [anon_sym_BSLASHglstext] = ACTIONS(6294),
    [anon_sym_BSLASHGlstext] = ACTIONS(6294),
    [anon_sym_BSLASHGLStext] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6294),
    [anon_sym_BSLASHglsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6294),
    [anon_sym_BSLASHglsname] = ACTIONS(6294),
    [anon_sym_BSLASHGlsname] = ACTIONS(6294),
    [anon_sym_BSLASHGLSname] = ACTIONS(6294),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6294),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6294),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6294),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6294),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6294),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6294),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6294),
    [anon_sym_BSLASHacrshort] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6294),
    [anon_sym_BSLASHACRshort] = ACTIONS(6294),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrlong] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6294),
    [anon_sym_BSLASHACRlong] = ACTIONS(6294),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6294),
    [anon_sym_BSLASHacrfull] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6294),
    [anon_sym_BSLASHACRfull] = ACTIONS(6294),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHacs] = ACTIONS(6294),
    [anon_sym_BSLASHAcs] = ACTIONS(6294),
    [anon_sym_BSLASHacsp] = ACTIONS(6294),
    [anon_sym_BSLASHAcsp] = ACTIONS(6294),
    [anon_sym_BSLASHacl] = ACTIONS(6294),
    [anon_sym_BSLASHAcl] = ACTIONS(6294),
    [anon_sym_BSLASHaclp] = ACTIONS(6294),
    [anon_sym_BSLASHAclp] = ACTIONS(6294),
    [anon_sym_BSLASHacf] = ACTIONS(6294),
    [anon_sym_BSLASHAcf] = ACTIONS(6294),
    [anon_sym_BSLASHacfp] = ACTIONS(6294),
    [anon_sym_BSLASHAcfp] = ACTIONS(6294),
    [anon_sym_BSLASHac] = ACTIONS(6294),
    [anon_sym_BSLASHAc] = ACTIONS(6294),
    [anon_sym_BSLASHacp] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6294),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6294),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6294),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6294),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6296),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6294),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6294),
    [anon_sym_BSLASHcolor] = ACTIONS(6294),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6294),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6294),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6294),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6294),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6294),
    [anon_sym_BSLASHtext] = ACTIONS(6294),
    [anon_sym_BSLASHintertext] = ACTIONS(6294),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6294),
    [anon_sym_BSLASHurl] = ACTIONS(6294),
    [anon_sym_BSLASHhref] = ACTIONS(6294),
  },
  [1359] = {
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_RBRACK] = ACTIONS(6636),
    [anon_sym_COMMA] = ACTIONS(6636),
    [anon_sym_EQ] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(6636),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHpart] = ACTIONS(6634),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddpart] = ACTIONS(6634),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHchapter] = ACTIONS(6634),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddchap] = ACTIONS(6634),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsection] = ACTIONS(6634),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHaddsec] = ACTIONS(6634),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6634),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6634),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHitem] = ACTIONS(6634),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6636),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6636),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(6634),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHbegin] = ACTIONS(6634),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHleft] = ACTIONS(6634),
    [anon_sym_BSLASHbigl] = ACTIONS(6634),
    [anon_sym_BSLASHBigl] = ACTIONS(6634),
    [anon_sym_BSLASHbiggl] = ACTIONS(6634),
    [anon_sym_BSLASHBiggl] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHtext] = ACTIONS(6634),
    [anon_sym_BSLASHintertext] = ACTIONS(6634),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [1360] = {
    [sym_command_name] = ACTIONS(6186),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(6188),
    [anon_sym_RBRACK] = ACTIONS(6188),
    [anon_sym_COMMA] = ACTIONS(6188),
    [anon_sym_EQ] = ACTIONS(6188),
    [anon_sym_LPAREN] = ACTIONS(6188),
    [anon_sym_RPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHpart] = ACTIONS(6186),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddpart] = ACTIONS(6186),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHchapter] = ACTIONS(6186),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddchap] = ACTIONS(6186),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsection] = ACTIONS(6186),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddsec] = ACTIONS(6186),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHitem] = ACTIONS(6186),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6188),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [sym_word] = ACTIONS(6186),
    [sym_placeholder] = ACTIONS(6188),
    [anon_sym_PLUS] = ACTIONS(6188),
    [anon_sym_DASH] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_SLASH] = ACTIONS(6188),
    [anon_sym_LT] = ACTIONS(6186),
    [anon_sym_GT] = ACTIONS(6186),
    [anon_sym_BANG] = ACTIONS(6186),
    [anon_sym_PIPE] = ACTIONS(6186),
    [anon_sym_COLON] = ACTIONS(6186),
    [anon_sym_SQUOTE] = ACTIONS(6186),
    [anon_sym__] = ACTIONS(6188),
    [anon_sym_CARET] = ACTIONS(6188),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6188),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6188),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6188),
    [anon_sym_DOLLAR] = ACTIONS(6186),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHbegin] = ACTIONS(6186),
    [anon_sym_BSLASHtitle] = ACTIONS(6186),
    [anon_sym_BSLASHauthor] = ACTIONS(6186),
    [anon_sym_BSLASHusepackage] = ACTIONS(6186),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6186),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6186),
    [anon_sym_BSLASHinclude] = ACTIONS(6186),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6186),
    [anon_sym_BSLASHinput] = ACTIONS(6186),
    [anon_sym_BSLASHsubfile] = ACTIONS(6186),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6186),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6186),
    [anon_sym_BSLASHbibliography] = ACTIONS(6186),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6186),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6186),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6186),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6186),
    [anon_sym_BSLASHimport] = ACTIONS(6186),
    [anon_sym_BSLASHsubimport] = ACTIONS(6186),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6186),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHcaption] = ACTIONS(6186),
    [anon_sym_BSLASHcite] = ACTIONS(6186),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCite] = ACTIONS(6186),
    [anon_sym_BSLASHnocite] = ACTIONS(6186),
    [anon_sym_BSLASHcitet] = ACTIONS(6186),
    [anon_sym_BSLASHcitep] = ACTIONS(6186),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteA] = ACTIONS(6186),
    [anon_sym_BSLASHciteR] = ACTIONS(6186),
    [anon_sym_BSLASHciteS] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6186),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteyear] = ACTIONS(6186),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitedate] = ACTIONS(6186),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteurl] = ACTIONS(6186),
    [anon_sym_BSLASHfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6186),
    [anon_sym_BSLASHcitealt] = ACTIONS(6186),
    [anon_sym_BSLASHcitealp] = ACTIONS(6186),
    [anon_sym_BSLASHcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHparencite] = ACTIONS(6186),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHParencite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHtextcite] = ACTIONS(6186),
    [anon_sym_BSLASHTextcite] = ACTIONS(6186),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHsupercite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite] = ACTIONS(6186),
    [anon_sym_BSLASHAutocite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHVolcite] = ACTIONS(6186),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHavolcite] = ACTIONS(6186),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHNotecite] = ACTIONS(6186),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHlabel] = ACTIONS(6186),
    [anon_sym_BSLASHref] = ACTIONS(6186),
    [anon_sym_BSLASHeqref] = ACTIONS(6186),
    [anon_sym_BSLASHvref] = ACTIONS(6186),
    [anon_sym_BSLASHVref] = ACTIONS(6186),
    [anon_sym_BSLASHautoref] = ACTIONS(6186),
    [anon_sym_BSLASHpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcref] = ACTIONS(6186),
    [anon_sym_BSLASHCref] = ACTIONS(6186),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnameCref] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHdef] = ACTIONS(6186),
    [anon_sym_BSLASHlet] = ACTIONS(6186),
    [anon_sym_BSLASHleft] = ACTIONS(6186),
    [anon_sym_BSLASHbigl] = ACTIONS(6186),
    [anon_sym_BSLASHBigl] = ACTIONS(6186),
    [anon_sym_BSLASHbiggl] = ACTIONS(6186),
    [anon_sym_BSLASHBiggl] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6186),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6186),
    [anon_sym_BSLASHgls] = ACTIONS(6186),
    [anon_sym_BSLASHGls] = ACTIONS(6186),
    [anon_sym_BSLASHGLS] = ACTIONS(6186),
    [anon_sym_BSLASHglspl] = ACTIONS(6186),
    [anon_sym_BSLASHGlspl] = ACTIONS(6186),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6186),
    [anon_sym_BSLASHglslink] = ACTIONS(6186),
    [anon_sym_BSLASHglstext] = ACTIONS(6186),
    [anon_sym_BSLASHGlstext] = ACTIONS(6186),
    [anon_sym_BSLASHGLStext] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6186),
    [anon_sym_BSLASHglsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsname] = ACTIONS(6186),
    [anon_sym_BSLASHGlsname] = ACTIONS(6186),
    [anon_sym_BSLASHGLSname] = ACTIONS(6186),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6186),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6186),
    [anon_sym_BSLASHacrshort] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6186),
    [anon_sym_BSLASHACRshort] = ACTIONS(6186),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrlong] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6186),
    [anon_sym_BSLASHACRlong] = ACTIONS(6186),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrfull] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6186),
    [anon_sym_BSLASHACRfull] = ACTIONS(6186),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHacs] = ACTIONS(6186),
    [anon_sym_BSLASHAcs] = ACTIONS(6186),
    [anon_sym_BSLASHacsp] = ACTIONS(6186),
    [anon_sym_BSLASHAcsp] = ACTIONS(6186),
    [anon_sym_BSLASHacl] = ACTIONS(6186),
    [anon_sym_BSLASHAcl] = ACTIONS(6186),
    [anon_sym_BSLASHaclp] = ACTIONS(6186),
    [anon_sym_BSLASHAclp] = ACTIONS(6186),
    [anon_sym_BSLASHacf] = ACTIONS(6186),
    [anon_sym_BSLASHAcf] = ACTIONS(6186),
    [anon_sym_BSLASHacfp] = ACTIONS(6186),
    [anon_sym_BSLASHAcfp] = ACTIONS(6186),
    [anon_sym_BSLASHac] = ACTIONS(6186),
    [anon_sym_BSLASHAc] = ACTIONS(6186),
    [anon_sym_BSLASHacp] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6186),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6186),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6186),
    [anon_sym_BSLASHcolor] = ACTIONS(6186),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6186),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6186),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6186),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6186),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6186),
    [anon_sym_BSLASHtext] = ACTIONS(6186),
    [anon_sym_BSLASHintertext] = ACTIONS(6186),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6186),
    [anon_sym_BSLASHurl] = ACTIONS(6186),
    [anon_sym_BSLASHhref] = ACTIONS(6186),
  },
  [1361] = {
    [sym_command_name] = ACTIONS(6178),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6178),
    [anon_sym_LBRACK] = ACTIONS(6180),
    [anon_sym_RBRACK] = ACTIONS(6180),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_EQ] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6180),
    [anon_sym_RPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHpart] = ACTIONS(6178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddpart] = ACTIONS(6178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHchapter] = ACTIONS(6178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddchap] = ACTIONS(6178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsection] = ACTIONS(6178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddsec] = ACTIONS(6178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHitem] = ACTIONS(6178),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6180),
    [anon_sym_LBRACE] = ACTIONS(6180),
    [sym_word] = ACTIONS(6178),
    [sym_placeholder] = ACTIONS(6180),
    [anon_sym_PLUS] = ACTIONS(6180),
    [anon_sym_DASH] = ACTIONS(6180),
    [anon_sym_STAR] = ACTIONS(6180),
    [anon_sym_SLASH] = ACTIONS(6180),
    [anon_sym_LT] = ACTIONS(6178),
    [anon_sym_GT] = ACTIONS(6178),
    [anon_sym_BANG] = ACTIONS(6178),
    [anon_sym_PIPE] = ACTIONS(6178),
    [anon_sym_COLON] = ACTIONS(6178),
    [anon_sym_SQUOTE] = ACTIONS(6178),
    [anon_sym__] = ACTIONS(6180),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6180),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6180),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6180),
    [anon_sym_DOLLAR] = ACTIONS(6178),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHbegin] = ACTIONS(6178),
    [anon_sym_BSLASHtitle] = ACTIONS(6178),
    [anon_sym_BSLASHauthor] = ACTIONS(6178),
    [anon_sym_BSLASHusepackage] = ACTIONS(6178),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6178),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6178),
    [anon_sym_BSLASHinclude] = ACTIONS(6178),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6178),
    [anon_sym_BSLASHinput] = ACTIONS(6178),
    [anon_sym_BSLASHsubfile] = ACTIONS(6178),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6178),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6178),
    [anon_sym_BSLASHbibliography] = ACTIONS(6178),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6178),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6178),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6178),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6178),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6178),
    [anon_sym_BSLASHimport] = ACTIONS(6178),
    [anon_sym_BSLASHsubimport] = ACTIONS(6178),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6178),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHcaption] = ACTIONS(6178),
    [anon_sym_BSLASHcite] = ACTIONS(6178),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCite] = ACTIONS(6178),
    [anon_sym_BSLASHnocite] = ACTIONS(6178),
    [anon_sym_BSLASHcitet] = ACTIONS(6178),
    [anon_sym_BSLASHcitep] = ACTIONS(6178),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteA] = ACTIONS(6178),
    [anon_sym_BSLASHciteR] = ACTIONS(6178),
    [anon_sym_BSLASHciteS] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6178),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteyear] = ACTIONS(6178),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitedate] = ACTIONS(6178),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteurl] = ACTIONS(6178),
    [anon_sym_BSLASHfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6178),
    [anon_sym_BSLASHcitealt] = ACTIONS(6178),
    [anon_sym_BSLASHcitealp] = ACTIONS(6178),
    [anon_sym_BSLASHcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHparencite] = ACTIONS(6178),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHParencite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHtextcite] = ACTIONS(6178),
    [anon_sym_BSLASHTextcite] = ACTIONS(6178),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHsupercite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite] = ACTIONS(6178),
    [anon_sym_BSLASHAutocite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHVolcite] = ACTIONS(6178),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHavolcite] = ACTIONS(6178),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHNotecite] = ACTIONS(6178),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHlabel] = ACTIONS(6178),
    [anon_sym_BSLASHref] = ACTIONS(6178),
    [anon_sym_BSLASHeqref] = ACTIONS(6178),
    [anon_sym_BSLASHvref] = ACTIONS(6178),
    [anon_sym_BSLASHVref] = ACTIONS(6178),
    [anon_sym_BSLASHautoref] = ACTIONS(6178),
    [anon_sym_BSLASHpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcref] = ACTIONS(6178),
    [anon_sym_BSLASHCref] = ACTIONS(6178),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnameCref] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHdef] = ACTIONS(6178),
    [anon_sym_BSLASHlet] = ACTIONS(6178),
    [anon_sym_BSLASHleft] = ACTIONS(6178),
    [anon_sym_BSLASHbigl] = ACTIONS(6178),
    [anon_sym_BSLASHBigl] = ACTIONS(6178),
    [anon_sym_BSLASHbiggl] = ACTIONS(6178),
    [anon_sym_BSLASHBiggl] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6178),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6178),
    [anon_sym_BSLASHgls] = ACTIONS(6178),
    [anon_sym_BSLASHGls] = ACTIONS(6178),
    [anon_sym_BSLASHGLS] = ACTIONS(6178),
    [anon_sym_BSLASHglspl] = ACTIONS(6178),
    [anon_sym_BSLASHGlspl] = ACTIONS(6178),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6178),
    [anon_sym_BSLASHglslink] = ACTIONS(6178),
    [anon_sym_BSLASHglstext] = ACTIONS(6178),
    [anon_sym_BSLASHGlstext] = ACTIONS(6178),
    [anon_sym_BSLASHGLStext] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6178),
    [anon_sym_BSLASHglsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsname] = ACTIONS(6178),
    [anon_sym_BSLASHGlsname] = ACTIONS(6178),
    [anon_sym_BSLASHGLSname] = ACTIONS(6178),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6178),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6178),
    [anon_sym_BSLASHacrshort] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6178),
    [anon_sym_BSLASHACRshort] = ACTIONS(6178),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrlong] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6178),
    [anon_sym_BSLASHACRlong] = ACTIONS(6178),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrfull] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6178),
    [anon_sym_BSLASHACRfull] = ACTIONS(6178),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHacs] = ACTIONS(6178),
    [anon_sym_BSLASHAcs] = ACTIONS(6178),
    [anon_sym_BSLASHacsp] = ACTIONS(6178),
    [anon_sym_BSLASHAcsp] = ACTIONS(6178),
    [anon_sym_BSLASHacl] = ACTIONS(6178),
    [anon_sym_BSLASHAcl] = ACTIONS(6178),
    [anon_sym_BSLASHaclp] = ACTIONS(6178),
    [anon_sym_BSLASHAclp] = ACTIONS(6178),
    [anon_sym_BSLASHacf] = ACTIONS(6178),
    [anon_sym_BSLASHAcf] = ACTIONS(6178),
    [anon_sym_BSLASHacfp] = ACTIONS(6178),
    [anon_sym_BSLASHAcfp] = ACTIONS(6178),
    [anon_sym_BSLASHac] = ACTIONS(6178),
    [anon_sym_BSLASHAc] = ACTIONS(6178),
    [anon_sym_BSLASHacp] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6178),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6178),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6178),
    [anon_sym_BSLASHcolor] = ACTIONS(6178),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6178),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6178),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6178),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6178),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6178),
    [anon_sym_BSLASHtext] = ACTIONS(6178),
    [anon_sym_BSLASHintertext] = ACTIONS(6178),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6178),
    [anon_sym_BSLASHurl] = ACTIONS(6178),
    [anon_sym_BSLASHhref] = ACTIONS(6178),
  },
  [1362] = {
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_LBRACK] = ACTIONS(6560),
    [anon_sym_RBRACK] = ACTIONS(6560),
    [anon_sym_COMMA] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHpart] = ACTIONS(6558),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddpart] = ACTIONS(6558),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHchapter] = ACTIONS(6558),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddchap] = ACTIONS(6558),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsection] = ACTIONS(6558),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddsec] = ACTIONS(6558),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHitem] = ACTIONS(6558),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6560),
    [anon_sym_LBRACE] = ACTIONS(6560),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6560),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6560),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(6558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHbegin] = ACTIONS(6558),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHleft] = ACTIONS(6558),
    [anon_sym_BSLASHbigl] = ACTIONS(6558),
    [anon_sym_BSLASHBigl] = ACTIONS(6558),
    [anon_sym_BSLASHbiggl] = ACTIONS(6558),
    [anon_sym_BSLASHBiggl] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHtext] = ACTIONS(6558),
    [anon_sym_BSLASHintertext] = ACTIONS(6558),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [1363] = {
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(6578),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6578),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_LPAREN] = ACTIONS(6578),
    [anon_sym_RPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHpart] = ACTIONS(6576),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddpart] = ACTIONS(6576),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHchapter] = ACTIONS(6576),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddchap] = ACTIONS(6576),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsection] = ACTIONS(6576),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddsec] = ACTIONS(6576),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHitem] = ACTIONS(6576),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6578),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6578),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHbegin] = ACTIONS(6576),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHleft] = ACTIONS(6576),
    [anon_sym_BSLASHbigl] = ACTIONS(6576),
    [anon_sym_BSLASHBigl] = ACTIONS(6576),
    [anon_sym_BSLASHbiggl] = ACTIONS(6576),
    [anon_sym_BSLASHBiggl] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHtext] = ACTIONS(6576),
    [anon_sym_BSLASHintertext] = ACTIONS(6576),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [1364] = {
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHpart] = ACTIONS(6586),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddpart] = ACTIONS(6586),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHchapter] = ACTIONS(6586),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddchap] = ACTIONS(6586),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsection] = ACTIONS(6586),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddsec] = ACTIONS(6586),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHitem] = ACTIONS(6586),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6588),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6588),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6588),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHbegin] = ACTIONS(6586),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHleft] = ACTIONS(6586),
    [anon_sym_BSLASHbigl] = ACTIONS(6586),
    [anon_sym_BSLASHBigl] = ACTIONS(6586),
    [anon_sym_BSLASHbiggl] = ACTIONS(6586),
    [anon_sym_BSLASHBiggl] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHtext] = ACTIONS(6586),
    [anon_sym_BSLASHintertext] = ACTIONS(6586),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [1365] = {
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHpart] = ACTIONS(6282),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddpart] = ACTIONS(6282),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHchapter] = ACTIONS(6282),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddchap] = ACTIONS(6282),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsection] = ACTIONS(6282),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHaddsec] = ACTIONS(6282),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6282),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6282),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHitem] = ACTIONS(6282),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6284),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6284),
    [anon_sym_DOLLAR] = ACTIONS(6282),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHbegin] = ACTIONS(6282),
    [anon_sym_BSLASHend] = ACTIONS(6282),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHleft] = ACTIONS(6282),
    [anon_sym_BSLASHbigl] = ACTIONS(6282),
    [anon_sym_BSLASHBigl] = ACTIONS(6282),
    [anon_sym_BSLASHbiggl] = ACTIONS(6282),
    [anon_sym_BSLASHBiggl] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHtext] = ACTIONS(6282),
    [anon_sym_BSLASHintertext] = ACTIONS(6282),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [1366] = {
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_LBRACK] = ACTIONS(6516),
    [anon_sym_RBRACK] = ACTIONS(6516),
    [anon_sym_COMMA] = ACTIONS(6516),
    [anon_sym_EQ] = ACTIONS(6516),
    [anon_sym_LPAREN] = ACTIONS(6516),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHpart] = ACTIONS(6514),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddpart] = ACTIONS(6514),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHchapter] = ACTIONS(6514),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddchap] = ACTIONS(6514),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsection] = ACTIONS(6514),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHaddsec] = ACTIONS(6514),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6514),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6514),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHitem] = ACTIONS(6514),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6516),
    [anon_sym_LBRACE] = ACTIONS(6516),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6516),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6516),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(6514),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHbegin] = ACTIONS(6514),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHleft] = ACTIONS(6514),
    [anon_sym_BSLASHbigl] = ACTIONS(6514),
    [anon_sym_BSLASHBigl] = ACTIONS(6514),
    [anon_sym_BSLASHbiggl] = ACTIONS(6514),
    [anon_sym_BSLASHBiggl] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHtext] = ACTIONS(6514),
    [anon_sym_BSLASHintertext] = ACTIONS(6514),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [1367] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2408),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2384),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1368] = {
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_COMMA] = ACTIONS(6268),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_LPAREN] = ACTIONS(6268),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHpart] = ACTIONS(6266),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddpart] = ACTIONS(6266),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHchapter] = ACTIONS(6266),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddchap] = ACTIONS(6266),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsection] = ACTIONS(6266),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHaddsec] = ACTIONS(6266),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6266),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6266),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHitem] = ACTIONS(6266),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6268),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6268),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(6266),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHbegin] = ACTIONS(6266),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHleft] = ACTIONS(6266),
    [anon_sym_BSLASHbigl] = ACTIONS(6266),
    [anon_sym_BSLASHBigl] = ACTIONS(6266),
    [anon_sym_BSLASHbiggl] = ACTIONS(6266),
    [anon_sym_BSLASHBiggl] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHtext] = ACTIONS(6266),
    [anon_sym_BSLASHintertext] = ACTIONS(6266),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [1369] = {
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6252),
    [anon_sym_LPAREN] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHpart] = ACTIONS(6250),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddpart] = ACTIONS(6250),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHchapter] = ACTIONS(6250),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddchap] = ACTIONS(6250),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsection] = ACTIONS(6250),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHaddsec] = ACTIONS(6250),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6250),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6250),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHitem] = ACTIONS(6250),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6252),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHbegin] = ACTIONS(6250),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHleft] = ACTIONS(6250),
    [anon_sym_BSLASHbigl] = ACTIONS(6250),
    [anon_sym_BSLASHBigl] = ACTIONS(6250),
    [anon_sym_BSLASHbiggl] = ACTIONS(6250),
    [anon_sym_BSLASHBiggl] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHtext] = ACTIONS(6250),
    [anon_sym_BSLASHintertext] = ACTIONS(6250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
  [1370] = {
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_COMMA] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_LPAREN] = ACTIONS(6248),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHpart] = ACTIONS(6246),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddpart] = ACTIONS(6246),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHchapter] = ACTIONS(6246),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddchap] = ACTIONS(6246),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsection] = ACTIONS(6246),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHaddsec] = ACTIONS(6246),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6246),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6246),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHitem] = ACTIONS(6246),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6248),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6248),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6248),
    [anon_sym_DOLLAR] = ACTIONS(6246),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHbegin] = ACTIONS(6246),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHleft] = ACTIONS(6246),
    [anon_sym_BSLASHbigl] = ACTIONS(6246),
    [anon_sym_BSLASHBigl] = ACTIONS(6246),
    [anon_sym_BSLASHbiggl] = ACTIONS(6246),
    [anon_sym_BSLASHBiggl] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHtext] = ACTIONS(6246),
    [anon_sym_BSLASHintertext] = ACTIONS(6246),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [1371] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2411),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7093),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1372] = {
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6244),
    [anon_sym_RBRACK] = ACTIONS(6244),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_LPAREN] = ACTIONS(6244),
    [anon_sym_RPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHpart] = ACTIONS(6242),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddpart] = ACTIONS(6242),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHchapter] = ACTIONS(6242),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddchap] = ACTIONS(6242),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsection] = ACTIONS(6242),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHaddsec] = ACTIONS(6242),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6242),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6242),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHitem] = ACTIONS(6242),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6244),
    [anon_sym_LBRACE] = ACTIONS(6244),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6244),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6244),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6244),
    [anon_sym_DOLLAR] = ACTIONS(6242),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHbegin] = ACTIONS(6242),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHleft] = ACTIONS(6242),
    [anon_sym_BSLASHbigl] = ACTIONS(6242),
    [anon_sym_BSLASHBigl] = ACTIONS(6242),
    [anon_sym_BSLASHbiggl] = ACTIONS(6242),
    [anon_sym_BSLASHBiggl] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHtext] = ACTIONS(6242),
    [anon_sym_BSLASHintertext] = ACTIONS(6242),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [1373] = {
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6444),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHpart] = ACTIONS(6442),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddpart] = ACTIONS(6442),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHchapter] = ACTIONS(6442),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddchap] = ACTIONS(6442),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsection] = ACTIONS(6442),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHaddsec] = ACTIONS(6442),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6442),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6442),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHitem] = ACTIONS(6442),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6444),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6444),
    [anon_sym_DOLLAR] = ACTIONS(6442),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6444),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHbegin] = ACTIONS(6442),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHleft] = ACTIONS(6442),
    [anon_sym_BSLASHbigl] = ACTIONS(6442),
    [anon_sym_BSLASHBigl] = ACTIONS(6442),
    [anon_sym_BSLASHbiggl] = ACTIONS(6442),
    [anon_sym_BSLASHBiggl] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHtext] = ACTIONS(6442),
    [anon_sym_BSLASHintertext] = ACTIONS(6442),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [1374] = {
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6464),
    [anon_sym_RBRACK] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_EQ] = ACTIONS(6464),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHpart] = ACTIONS(6462),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddpart] = ACTIONS(6462),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHchapter] = ACTIONS(6462),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddchap] = ACTIONS(6462),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsection] = ACTIONS(6462),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHaddsec] = ACTIONS(6462),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6462),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6462),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHitem] = ACTIONS(6462),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6464),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6464),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(6462),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHbegin] = ACTIONS(6462),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHleft] = ACTIONS(6462),
    [anon_sym_BSLASHbigl] = ACTIONS(6462),
    [anon_sym_BSLASHBigl] = ACTIONS(6462),
    [anon_sym_BSLASHbiggl] = ACTIONS(6462),
    [anon_sym_BSLASHBiggl] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHtext] = ACTIONS(6462),
    [anon_sym_BSLASHintertext] = ACTIONS(6462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [1375] = {
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHpart] = ACTIONS(6454),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddpart] = ACTIONS(6454),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHchapter] = ACTIONS(6454),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddchap] = ACTIONS(6454),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsection] = ACTIONS(6454),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHaddsec] = ACTIONS(6454),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6454),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6454),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHitem] = ACTIONS(6454),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6456),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(6454),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6456),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHbegin] = ACTIONS(6454),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHleft] = ACTIONS(6454),
    [anon_sym_BSLASHbigl] = ACTIONS(6454),
    [anon_sym_BSLASHBigl] = ACTIONS(6454),
    [anon_sym_BSLASHbiggl] = ACTIONS(6454),
    [anon_sym_BSLASHBiggl] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHtext] = ACTIONS(6454),
    [anon_sym_BSLASHintertext] = ACTIONS(6454),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [1376] = {
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHpart] = ACTIONS(155),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddpart] = ACTIONS(155),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(157),
    [anon_sym_BSLASHchapter] = ACTIONS(155),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddchap] = ACTIONS(155),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsection] = ACTIONS(155),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHaddsec] = ACTIONS(155),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(155),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(157),
    [anon_sym_BSLASHparagraph] = ACTIONS(155),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(155),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(157),
    [anon_sym_BSLASHitem] = ACTIONS(155),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(157),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [1377] = {
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [1378] = {
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_LBRACK] = ACTIONS(6524),
    [anon_sym_RBRACK] = ACTIONS(6524),
    [anon_sym_COMMA] = ACTIONS(6524),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6524),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHpart] = ACTIONS(6522),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddpart] = ACTIONS(6522),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHchapter] = ACTIONS(6522),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddchap] = ACTIONS(6522),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsection] = ACTIONS(6522),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHaddsec] = ACTIONS(6522),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6522),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6522),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHitem] = ACTIONS(6522),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6524),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6524),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6524),
    [anon_sym_DOLLAR] = ACTIONS(6522),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6524),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHbegin] = ACTIONS(6522),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHleft] = ACTIONS(6522),
    [anon_sym_BSLASHbigl] = ACTIONS(6522),
    [anon_sym_BSLASHBigl] = ACTIONS(6522),
    [anon_sym_BSLASHbiggl] = ACTIONS(6522),
    [anon_sym_BSLASHBiggl] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHtext] = ACTIONS(6522),
    [anon_sym_BSLASHintertext] = ACTIONS(6522),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [1379] = {
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6528),
    [anon_sym_RBRACK] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6528),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [anon_sym_RPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHpart] = ACTIONS(6526),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddpart] = ACTIONS(6526),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHchapter] = ACTIONS(6526),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddchap] = ACTIONS(6526),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsection] = ACTIONS(6526),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHaddsec] = ACTIONS(6526),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6526),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6526),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHitem] = ACTIONS(6526),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6528),
    [anon_sym_LBRACE] = ACTIONS(6528),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6528),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(6526),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6528),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHbegin] = ACTIONS(6526),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHleft] = ACTIONS(6526),
    [anon_sym_BSLASHbigl] = ACTIONS(6526),
    [anon_sym_BSLASHBigl] = ACTIONS(6526),
    [anon_sym_BSLASHbiggl] = ACTIONS(6526),
    [anon_sym_BSLASHBiggl] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHtext] = ACTIONS(6526),
    [anon_sym_BSLASHintertext] = ACTIONS(6526),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [1380] = {
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_RBRACK] = ACTIONS(6656),
    [anon_sym_COMMA] = ACTIONS(6656),
    [anon_sym_EQ] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(6656),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHpart] = ACTIONS(6654),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddpart] = ACTIONS(6654),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHchapter] = ACTIONS(6654),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddchap] = ACTIONS(6654),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsection] = ACTIONS(6654),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHaddsec] = ACTIONS(6654),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6654),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6654),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHitem] = ACTIONS(6654),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6656),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6656),
    [anon_sym_DOLLAR] = ACTIONS(6654),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6656),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHbegin] = ACTIONS(6654),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHleft] = ACTIONS(6654),
    [anon_sym_BSLASHbigl] = ACTIONS(6654),
    [anon_sym_BSLASHBigl] = ACTIONS(6654),
    [anon_sym_BSLASHbiggl] = ACTIONS(6654),
    [anon_sym_BSLASHBiggl] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHtext] = ACTIONS(6654),
    [anon_sym_BSLASHintertext] = ACTIONS(6654),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [1381] = {
    [sym_command_name] = ACTIONS(6262),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6262),
    [anon_sym_LBRACK] = ACTIONS(6264),
    [anon_sym_RBRACK] = ACTIONS(6264),
    [anon_sym_COMMA] = ACTIONS(6264),
    [anon_sym_EQ] = ACTIONS(6264),
    [anon_sym_LPAREN] = ACTIONS(6264),
    [anon_sym_RPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHpart] = ACTIONS(6262),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddpart] = ACTIONS(6262),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHchapter] = ACTIONS(6262),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddchap] = ACTIONS(6262),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsection] = ACTIONS(6262),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHaddsec] = ACTIONS(6262),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6262),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6262),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHitem] = ACTIONS(6262),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6264),
    [anon_sym_LBRACE] = ACTIONS(6264),
    [sym_word] = ACTIONS(6262),
    [sym_placeholder] = ACTIONS(6264),
    [anon_sym_PLUS] = ACTIONS(6264),
    [anon_sym_DASH] = ACTIONS(6264),
    [anon_sym_STAR] = ACTIONS(6264),
    [anon_sym_SLASH] = ACTIONS(6264),
    [anon_sym_LT] = ACTIONS(6262),
    [anon_sym_GT] = ACTIONS(6262),
    [anon_sym_BANG] = ACTIONS(6262),
    [anon_sym_PIPE] = ACTIONS(6262),
    [anon_sym_COLON] = ACTIONS(6262),
    [anon_sym_SQUOTE] = ACTIONS(6262),
    [anon_sym__] = ACTIONS(6264),
    [anon_sym_CARET] = ACTIONS(6264),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6264),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6264),
    [anon_sym_DOLLAR] = ACTIONS(6262),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6264),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6264),
    [anon_sym_BSLASHbegin] = ACTIONS(6262),
    [anon_sym_BSLASHtitle] = ACTIONS(6262),
    [anon_sym_BSLASHauthor] = ACTIONS(6262),
    [anon_sym_BSLASHusepackage] = ACTIONS(6262),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6262),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6262),
    [anon_sym_BSLASHinclude] = ACTIONS(6262),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6262),
    [anon_sym_BSLASHinput] = ACTIONS(6262),
    [anon_sym_BSLASHsubfile] = ACTIONS(6262),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6262),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6262),
    [anon_sym_BSLASHbibliography] = ACTIONS(6262),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6262),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6262),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6262),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6262),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6262),
    [anon_sym_BSLASHimport] = ACTIONS(6262),
    [anon_sym_BSLASHsubimport] = ACTIONS(6262),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6262),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6262),
    [anon_sym_BSLASHcaption] = ACTIONS(6262),
    [anon_sym_BSLASHcite] = ACTIONS(6262),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCite] = ACTIONS(6262),
    [anon_sym_BSLASHnocite] = ACTIONS(6262),
    [anon_sym_BSLASHcitet] = ACTIONS(6262),
    [anon_sym_BSLASHcitep] = ACTIONS(6262),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteA] = ACTIONS(6262),
    [anon_sym_BSLASHciteR] = ACTIONS(6262),
    [anon_sym_BSLASHciteS] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6262),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6262),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteyear] = ACTIONS(6262),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHcitedate] = ACTIONS(6262),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHciteurl] = ACTIONS(6262),
    [anon_sym_BSLASHfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6262),
    [anon_sym_BSLASHcitealt] = ACTIONS(6262),
    [anon_sym_BSLASHcitealp] = ACTIONS(6262),
    [anon_sym_BSLASHcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHparencite] = ACTIONS(6262),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHParencite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6262),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6262),
    [anon_sym_BSLASHtextcite] = ACTIONS(6262),
    [anon_sym_BSLASHTextcite] = ACTIONS(6262),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6262),
    [anon_sym_BSLASHsupercite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite] = ACTIONS(6262),
    [anon_sym_BSLASHAutocite] = ACTIONS(6262),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHVolcite] = ACTIONS(6262),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHavolcite] = ACTIONS(6262),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6262),
    [anon_sym_BSLASHnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHNotecite] = ACTIONS(6262),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6262),
    [anon_sym_BSLASHlabel] = ACTIONS(6262),
    [anon_sym_BSLASHref] = ACTIONS(6262),
    [anon_sym_BSLASHeqref] = ACTIONS(6262),
    [anon_sym_BSLASHvref] = ACTIONS(6262),
    [anon_sym_BSLASHVref] = ACTIONS(6262),
    [anon_sym_BSLASHautoref] = ACTIONS(6262),
    [anon_sym_BSLASHpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcref] = ACTIONS(6262),
    [anon_sym_BSLASHCref] = ACTIONS(6262),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnameCref] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6262),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6262),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6262),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6262),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6262),
    [anon_sym_BSLASHdef] = ACTIONS(6262),
    [anon_sym_BSLASHlet] = ACTIONS(6262),
    [anon_sym_BSLASHleft] = ACTIONS(6262),
    [anon_sym_BSLASHbigl] = ACTIONS(6262),
    [anon_sym_BSLASHBigl] = ACTIONS(6262),
    [anon_sym_BSLASHbiggl] = ACTIONS(6262),
    [anon_sym_BSLASHBiggl] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6262),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6262),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6262),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6262),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6262),
    [anon_sym_BSLASHgls] = ACTIONS(6262),
    [anon_sym_BSLASHGls] = ACTIONS(6262),
    [anon_sym_BSLASHGLS] = ACTIONS(6262),
    [anon_sym_BSLASHglspl] = ACTIONS(6262),
    [anon_sym_BSLASHGlspl] = ACTIONS(6262),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6262),
    [anon_sym_BSLASHglslink] = ACTIONS(6262),
    [anon_sym_BSLASHglstext] = ACTIONS(6262),
    [anon_sym_BSLASHGlstext] = ACTIONS(6262),
    [anon_sym_BSLASHGLStext] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6262),
    [anon_sym_BSLASHglsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6262),
    [anon_sym_BSLASHglsname] = ACTIONS(6262),
    [anon_sym_BSLASHGlsname] = ACTIONS(6262),
    [anon_sym_BSLASHGLSname] = ACTIONS(6262),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6262),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6262),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6262),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6262),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6262),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6262),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6262),
    [anon_sym_BSLASHacrshort] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6262),
    [anon_sym_BSLASHACRshort] = ACTIONS(6262),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrlong] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6262),
    [anon_sym_BSLASHACRlong] = ACTIONS(6262),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6262),
    [anon_sym_BSLASHacrfull] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6262),
    [anon_sym_BSLASHACRfull] = ACTIONS(6262),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHacs] = ACTIONS(6262),
    [anon_sym_BSLASHAcs] = ACTIONS(6262),
    [anon_sym_BSLASHacsp] = ACTIONS(6262),
    [anon_sym_BSLASHAcsp] = ACTIONS(6262),
    [anon_sym_BSLASHacl] = ACTIONS(6262),
    [anon_sym_BSLASHAcl] = ACTIONS(6262),
    [anon_sym_BSLASHaclp] = ACTIONS(6262),
    [anon_sym_BSLASHAclp] = ACTIONS(6262),
    [anon_sym_BSLASHacf] = ACTIONS(6262),
    [anon_sym_BSLASHAcf] = ACTIONS(6262),
    [anon_sym_BSLASHacfp] = ACTIONS(6262),
    [anon_sym_BSLASHAcfp] = ACTIONS(6262),
    [anon_sym_BSLASHac] = ACTIONS(6262),
    [anon_sym_BSLASHAc] = ACTIONS(6262),
    [anon_sym_BSLASHacp] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6262),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6262),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6262),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6262),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6264),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6262),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6262),
    [anon_sym_BSLASHcolor] = ACTIONS(6262),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6262),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6262),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6262),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6262),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6262),
    [anon_sym_BSLASHtext] = ACTIONS(6262),
    [anon_sym_BSLASHintertext] = ACTIONS(6262),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6262),
    [anon_sym_BSLASHurl] = ACTIONS(6262),
    [anon_sym_BSLASHhref] = ACTIONS(6262),
  },
  [1382] = {
    [sym_command_name] = ACTIONS(6258),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6258),
    [anon_sym_LBRACK] = ACTIONS(6260),
    [anon_sym_RBRACK] = ACTIONS(6260),
    [anon_sym_COMMA] = ACTIONS(6260),
    [anon_sym_EQ] = ACTIONS(6260),
    [anon_sym_LPAREN] = ACTIONS(6260),
    [anon_sym_RPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHpart] = ACTIONS(6258),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddpart] = ACTIONS(6258),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHchapter] = ACTIONS(6258),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddchap] = ACTIONS(6258),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsection] = ACTIONS(6258),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHaddsec] = ACTIONS(6258),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6258),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6258),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHitem] = ACTIONS(6258),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6260),
    [anon_sym_LBRACE] = ACTIONS(6260),
    [sym_word] = ACTIONS(6258),
    [sym_placeholder] = ACTIONS(6260),
    [anon_sym_PLUS] = ACTIONS(6260),
    [anon_sym_DASH] = ACTIONS(6260),
    [anon_sym_STAR] = ACTIONS(6260),
    [anon_sym_SLASH] = ACTIONS(6260),
    [anon_sym_LT] = ACTIONS(6258),
    [anon_sym_GT] = ACTIONS(6258),
    [anon_sym_BANG] = ACTIONS(6258),
    [anon_sym_PIPE] = ACTIONS(6258),
    [anon_sym_COLON] = ACTIONS(6258),
    [anon_sym_SQUOTE] = ACTIONS(6258),
    [anon_sym__] = ACTIONS(6260),
    [anon_sym_CARET] = ACTIONS(6260),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6260),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6260),
    [anon_sym_DOLLAR] = ACTIONS(6258),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6260),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6260),
    [anon_sym_BSLASHbegin] = ACTIONS(6258),
    [anon_sym_BSLASHtitle] = ACTIONS(6258),
    [anon_sym_BSLASHauthor] = ACTIONS(6258),
    [anon_sym_BSLASHusepackage] = ACTIONS(6258),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6258),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6258),
    [anon_sym_BSLASHinclude] = ACTIONS(6258),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6258),
    [anon_sym_BSLASHinput] = ACTIONS(6258),
    [anon_sym_BSLASHsubfile] = ACTIONS(6258),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6258),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6258),
    [anon_sym_BSLASHbibliography] = ACTIONS(6258),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6258),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6258),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6258),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6258),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6258),
    [anon_sym_BSLASHimport] = ACTIONS(6258),
    [anon_sym_BSLASHsubimport] = ACTIONS(6258),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6258),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6258),
    [anon_sym_BSLASHcaption] = ACTIONS(6258),
    [anon_sym_BSLASHcite] = ACTIONS(6258),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCite] = ACTIONS(6258),
    [anon_sym_BSLASHnocite] = ACTIONS(6258),
    [anon_sym_BSLASHcitet] = ACTIONS(6258),
    [anon_sym_BSLASHcitep] = ACTIONS(6258),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteA] = ACTIONS(6258),
    [anon_sym_BSLASHciteR] = ACTIONS(6258),
    [anon_sym_BSLASHciteS] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6258),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6258),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteyear] = ACTIONS(6258),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHcitedate] = ACTIONS(6258),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHciteurl] = ACTIONS(6258),
    [anon_sym_BSLASHfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6258),
    [anon_sym_BSLASHcitealt] = ACTIONS(6258),
    [anon_sym_BSLASHcitealp] = ACTIONS(6258),
    [anon_sym_BSLASHcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHparencite] = ACTIONS(6258),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHParencite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6258),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6258),
    [anon_sym_BSLASHtextcite] = ACTIONS(6258),
    [anon_sym_BSLASHTextcite] = ACTIONS(6258),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6258),
    [anon_sym_BSLASHsupercite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite] = ACTIONS(6258),
    [anon_sym_BSLASHAutocite] = ACTIONS(6258),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHVolcite] = ACTIONS(6258),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHavolcite] = ACTIONS(6258),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6258),
    [anon_sym_BSLASHnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHNotecite] = ACTIONS(6258),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6258),
    [anon_sym_BSLASHlabel] = ACTIONS(6258),
    [anon_sym_BSLASHref] = ACTIONS(6258),
    [anon_sym_BSLASHeqref] = ACTIONS(6258),
    [anon_sym_BSLASHvref] = ACTIONS(6258),
    [anon_sym_BSLASHVref] = ACTIONS(6258),
    [anon_sym_BSLASHautoref] = ACTIONS(6258),
    [anon_sym_BSLASHpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcref] = ACTIONS(6258),
    [anon_sym_BSLASHCref] = ACTIONS(6258),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnameCref] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6258),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6258),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6258),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6258),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6258),
    [anon_sym_BSLASHdef] = ACTIONS(6258),
    [anon_sym_BSLASHlet] = ACTIONS(6258),
    [anon_sym_BSLASHleft] = ACTIONS(6258),
    [anon_sym_BSLASHbigl] = ACTIONS(6258),
    [anon_sym_BSLASHBigl] = ACTIONS(6258),
    [anon_sym_BSLASHbiggl] = ACTIONS(6258),
    [anon_sym_BSLASHBiggl] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6258),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6258),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6258),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6258),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6258),
    [anon_sym_BSLASHgls] = ACTIONS(6258),
    [anon_sym_BSLASHGls] = ACTIONS(6258),
    [anon_sym_BSLASHGLS] = ACTIONS(6258),
    [anon_sym_BSLASHglspl] = ACTIONS(6258),
    [anon_sym_BSLASHGlspl] = ACTIONS(6258),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6258),
    [anon_sym_BSLASHglslink] = ACTIONS(6258),
    [anon_sym_BSLASHglstext] = ACTIONS(6258),
    [anon_sym_BSLASHGlstext] = ACTIONS(6258),
    [anon_sym_BSLASHGLStext] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6258),
    [anon_sym_BSLASHglsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6258),
    [anon_sym_BSLASHglsname] = ACTIONS(6258),
    [anon_sym_BSLASHGlsname] = ACTIONS(6258),
    [anon_sym_BSLASHGLSname] = ACTIONS(6258),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6258),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6258),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6258),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6258),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6258),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6258),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6258),
    [anon_sym_BSLASHacrshort] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6258),
    [anon_sym_BSLASHACRshort] = ACTIONS(6258),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrlong] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6258),
    [anon_sym_BSLASHACRlong] = ACTIONS(6258),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6258),
    [anon_sym_BSLASHacrfull] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6258),
    [anon_sym_BSLASHACRfull] = ACTIONS(6258),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHacs] = ACTIONS(6258),
    [anon_sym_BSLASHAcs] = ACTIONS(6258),
    [anon_sym_BSLASHacsp] = ACTIONS(6258),
    [anon_sym_BSLASHAcsp] = ACTIONS(6258),
    [anon_sym_BSLASHacl] = ACTIONS(6258),
    [anon_sym_BSLASHAcl] = ACTIONS(6258),
    [anon_sym_BSLASHaclp] = ACTIONS(6258),
    [anon_sym_BSLASHAclp] = ACTIONS(6258),
    [anon_sym_BSLASHacf] = ACTIONS(6258),
    [anon_sym_BSLASHAcf] = ACTIONS(6258),
    [anon_sym_BSLASHacfp] = ACTIONS(6258),
    [anon_sym_BSLASHAcfp] = ACTIONS(6258),
    [anon_sym_BSLASHac] = ACTIONS(6258),
    [anon_sym_BSLASHAc] = ACTIONS(6258),
    [anon_sym_BSLASHacp] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6258),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6258),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6258),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6258),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6260),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6258),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6258),
    [anon_sym_BSLASHcolor] = ACTIONS(6258),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6258),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6258),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6258),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6258),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6258),
    [anon_sym_BSLASHtext] = ACTIONS(6258),
    [anon_sym_BSLASHintertext] = ACTIONS(6258),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6258),
    [anon_sym_BSLASHurl] = ACTIONS(6258),
    [anon_sym_BSLASHhref] = ACTIONS(6258),
  },
  [1383] = {
    [sym_command_name] = ACTIONS(6254),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6254),
    [anon_sym_LBRACK] = ACTIONS(6256),
    [anon_sym_RBRACK] = ACTIONS(6256),
    [anon_sym_COMMA] = ACTIONS(6256),
    [anon_sym_EQ] = ACTIONS(6256),
    [anon_sym_LPAREN] = ACTIONS(6256),
    [anon_sym_RPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHpart] = ACTIONS(6254),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddpart] = ACTIONS(6254),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHchapter] = ACTIONS(6254),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddchap] = ACTIONS(6254),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsection] = ACTIONS(6254),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHaddsec] = ACTIONS(6254),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6254),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6254),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHitem] = ACTIONS(6254),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6256),
    [anon_sym_LBRACE] = ACTIONS(6256),
    [sym_word] = ACTIONS(6254),
    [sym_placeholder] = ACTIONS(6256),
    [anon_sym_PLUS] = ACTIONS(6256),
    [anon_sym_DASH] = ACTIONS(6256),
    [anon_sym_STAR] = ACTIONS(6256),
    [anon_sym_SLASH] = ACTIONS(6256),
    [anon_sym_LT] = ACTIONS(6254),
    [anon_sym_GT] = ACTIONS(6254),
    [anon_sym_BANG] = ACTIONS(6254),
    [anon_sym_PIPE] = ACTIONS(6254),
    [anon_sym_COLON] = ACTIONS(6254),
    [anon_sym_SQUOTE] = ACTIONS(6254),
    [anon_sym__] = ACTIONS(6256),
    [anon_sym_CARET] = ACTIONS(6256),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6256),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6256),
    [anon_sym_DOLLAR] = ACTIONS(6254),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6256),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6256),
    [anon_sym_BSLASHbegin] = ACTIONS(6254),
    [anon_sym_BSLASHtitle] = ACTIONS(6254),
    [anon_sym_BSLASHauthor] = ACTIONS(6254),
    [anon_sym_BSLASHusepackage] = ACTIONS(6254),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6254),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6254),
    [anon_sym_BSLASHinclude] = ACTIONS(6254),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6254),
    [anon_sym_BSLASHinput] = ACTIONS(6254),
    [anon_sym_BSLASHsubfile] = ACTIONS(6254),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6254),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6254),
    [anon_sym_BSLASHbibliography] = ACTIONS(6254),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6254),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6254),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6254),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6254),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6254),
    [anon_sym_BSLASHimport] = ACTIONS(6254),
    [anon_sym_BSLASHsubimport] = ACTIONS(6254),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6254),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6254),
    [anon_sym_BSLASHcaption] = ACTIONS(6254),
    [anon_sym_BSLASHcite] = ACTIONS(6254),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCite] = ACTIONS(6254),
    [anon_sym_BSLASHnocite] = ACTIONS(6254),
    [anon_sym_BSLASHcitet] = ACTIONS(6254),
    [anon_sym_BSLASHcitep] = ACTIONS(6254),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteA] = ACTIONS(6254),
    [anon_sym_BSLASHciteR] = ACTIONS(6254),
    [anon_sym_BSLASHciteS] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6254),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6254),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteyear] = ACTIONS(6254),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHcitedate] = ACTIONS(6254),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHciteurl] = ACTIONS(6254),
    [anon_sym_BSLASHfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6254),
    [anon_sym_BSLASHcitealt] = ACTIONS(6254),
    [anon_sym_BSLASHcitealp] = ACTIONS(6254),
    [anon_sym_BSLASHcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHparencite] = ACTIONS(6254),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHParencite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6254),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6254),
    [anon_sym_BSLASHtextcite] = ACTIONS(6254),
    [anon_sym_BSLASHTextcite] = ACTIONS(6254),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6254),
    [anon_sym_BSLASHsupercite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite] = ACTIONS(6254),
    [anon_sym_BSLASHAutocite] = ACTIONS(6254),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHVolcite] = ACTIONS(6254),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHavolcite] = ACTIONS(6254),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6254),
    [anon_sym_BSLASHnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHNotecite] = ACTIONS(6254),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6254),
    [anon_sym_BSLASHlabel] = ACTIONS(6254),
    [anon_sym_BSLASHref] = ACTIONS(6254),
    [anon_sym_BSLASHeqref] = ACTIONS(6254),
    [anon_sym_BSLASHvref] = ACTIONS(6254),
    [anon_sym_BSLASHVref] = ACTIONS(6254),
    [anon_sym_BSLASHautoref] = ACTIONS(6254),
    [anon_sym_BSLASHpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcref] = ACTIONS(6254),
    [anon_sym_BSLASHCref] = ACTIONS(6254),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnameCref] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6254),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6254),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6254),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6254),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6254),
    [anon_sym_BSLASHdef] = ACTIONS(6254),
    [anon_sym_BSLASHlet] = ACTIONS(6254),
    [anon_sym_BSLASHleft] = ACTIONS(6254),
    [anon_sym_BSLASHbigl] = ACTIONS(6254),
    [anon_sym_BSLASHBigl] = ACTIONS(6254),
    [anon_sym_BSLASHbiggl] = ACTIONS(6254),
    [anon_sym_BSLASHBiggl] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6254),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6254),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6254),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6254),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6254),
    [anon_sym_BSLASHgls] = ACTIONS(6254),
    [anon_sym_BSLASHGls] = ACTIONS(6254),
    [anon_sym_BSLASHGLS] = ACTIONS(6254),
    [anon_sym_BSLASHglspl] = ACTIONS(6254),
    [anon_sym_BSLASHGlspl] = ACTIONS(6254),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6254),
    [anon_sym_BSLASHglslink] = ACTIONS(6254),
    [anon_sym_BSLASHglstext] = ACTIONS(6254),
    [anon_sym_BSLASHGlstext] = ACTIONS(6254),
    [anon_sym_BSLASHGLStext] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6254),
    [anon_sym_BSLASHglsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6254),
    [anon_sym_BSLASHglsname] = ACTIONS(6254),
    [anon_sym_BSLASHGlsname] = ACTIONS(6254),
    [anon_sym_BSLASHGLSname] = ACTIONS(6254),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6254),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6254),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6254),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6254),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6254),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6254),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6254),
    [anon_sym_BSLASHacrshort] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6254),
    [anon_sym_BSLASHACRshort] = ACTIONS(6254),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrlong] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6254),
    [anon_sym_BSLASHACRlong] = ACTIONS(6254),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6254),
    [anon_sym_BSLASHacrfull] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6254),
    [anon_sym_BSLASHACRfull] = ACTIONS(6254),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHacs] = ACTIONS(6254),
    [anon_sym_BSLASHAcs] = ACTIONS(6254),
    [anon_sym_BSLASHacsp] = ACTIONS(6254),
    [anon_sym_BSLASHAcsp] = ACTIONS(6254),
    [anon_sym_BSLASHacl] = ACTIONS(6254),
    [anon_sym_BSLASHAcl] = ACTIONS(6254),
    [anon_sym_BSLASHaclp] = ACTIONS(6254),
    [anon_sym_BSLASHAclp] = ACTIONS(6254),
    [anon_sym_BSLASHacf] = ACTIONS(6254),
    [anon_sym_BSLASHAcf] = ACTIONS(6254),
    [anon_sym_BSLASHacfp] = ACTIONS(6254),
    [anon_sym_BSLASHAcfp] = ACTIONS(6254),
    [anon_sym_BSLASHac] = ACTIONS(6254),
    [anon_sym_BSLASHAc] = ACTIONS(6254),
    [anon_sym_BSLASHacp] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6254),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6254),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6254),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6254),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6256),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6254),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6254),
    [anon_sym_BSLASHcolor] = ACTIONS(6254),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6254),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6254),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6254),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6254),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6254),
    [anon_sym_BSLASHtext] = ACTIONS(6254),
    [anon_sym_BSLASHintertext] = ACTIONS(6254),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6254),
    [anon_sym_BSLASHurl] = ACTIONS(6254),
    [anon_sym_BSLASHhref] = ACTIONS(6254),
  },
  [1384] = {
    [sym_command_name] = ACTIONS(6210),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6210),
    [anon_sym_LBRACK] = ACTIONS(6212),
    [anon_sym_RBRACK] = ACTIONS(6212),
    [anon_sym_COMMA] = ACTIONS(6212),
    [anon_sym_EQ] = ACTIONS(6212),
    [anon_sym_LPAREN] = ACTIONS(6212),
    [anon_sym_RPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHpart] = ACTIONS(6210),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddpart] = ACTIONS(6210),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHchapter] = ACTIONS(6210),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddchap] = ACTIONS(6210),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsection] = ACTIONS(6210),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHaddsec] = ACTIONS(6210),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6210),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6210),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHitem] = ACTIONS(6210),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6212),
    [anon_sym_LBRACE] = ACTIONS(6212),
    [sym_word] = ACTIONS(6210),
    [sym_placeholder] = ACTIONS(6212),
    [anon_sym_PLUS] = ACTIONS(6212),
    [anon_sym_DASH] = ACTIONS(6212),
    [anon_sym_STAR] = ACTIONS(6212),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_LT] = ACTIONS(6210),
    [anon_sym_GT] = ACTIONS(6210),
    [anon_sym_BANG] = ACTIONS(6210),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_COLON] = ACTIONS(6210),
    [anon_sym_SQUOTE] = ACTIONS(6210),
    [anon_sym__] = ACTIONS(6212),
    [anon_sym_CARET] = ACTIONS(6212),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6212),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6212),
    [anon_sym_DOLLAR] = ACTIONS(6210),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6212),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6212),
    [anon_sym_BSLASHbegin] = ACTIONS(6210),
    [anon_sym_BSLASHtitle] = ACTIONS(6210),
    [anon_sym_BSLASHauthor] = ACTIONS(6210),
    [anon_sym_BSLASHusepackage] = ACTIONS(6210),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6210),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6210),
    [anon_sym_BSLASHinclude] = ACTIONS(6210),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6210),
    [anon_sym_BSLASHinput] = ACTIONS(6210),
    [anon_sym_BSLASHsubfile] = ACTIONS(6210),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6210),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6210),
    [anon_sym_BSLASHbibliography] = ACTIONS(6210),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6210),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6210),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6210),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6210),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6210),
    [anon_sym_BSLASHimport] = ACTIONS(6210),
    [anon_sym_BSLASHsubimport] = ACTIONS(6210),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6210),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6210),
    [anon_sym_BSLASHcaption] = ACTIONS(6210),
    [anon_sym_BSLASHcite] = ACTIONS(6210),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCite] = ACTIONS(6210),
    [anon_sym_BSLASHnocite] = ACTIONS(6210),
    [anon_sym_BSLASHcitet] = ACTIONS(6210),
    [anon_sym_BSLASHcitep] = ACTIONS(6210),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteA] = ACTIONS(6210),
    [anon_sym_BSLASHciteR] = ACTIONS(6210),
    [anon_sym_BSLASHciteS] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6210),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6210),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteyear] = ACTIONS(6210),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHcitedate] = ACTIONS(6210),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHciteurl] = ACTIONS(6210),
    [anon_sym_BSLASHfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6210),
    [anon_sym_BSLASHcitealt] = ACTIONS(6210),
    [anon_sym_BSLASHcitealp] = ACTIONS(6210),
    [anon_sym_BSLASHcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHparencite] = ACTIONS(6210),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHParencite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6210),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6210),
    [anon_sym_BSLASHtextcite] = ACTIONS(6210),
    [anon_sym_BSLASHTextcite] = ACTIONS(6210),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6210),
    [anon_sym_BSLASHsupercite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite] = ACTIONS(6210),
    [anon_sym_BSLASHAutocite] = ACTIONS(6210),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHVolcite] = ACTIONS(6210),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHavolcite] = ACTIONS(6210),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6210),
    [anon_sym_BSLASHnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHNotecite] = ACTIONS(6210),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6210),
    [anon_sym_BSLASHlabel] = ACTIONS(6210),
    [anon_sym_BSLASHref] = ACTIONS(6210),
    [anon_sym_BSLASHeqref] = ACTIONS(6210),
    [anon_sym_BSLASHvref] = ACTIONS(6210),
    [anon_sym_BSLASHVref] = ACTIONS(6210),
    [anon_sym_BSLASHautoref] = ACTIONS(6210),
    [anon_sym_BSLASHpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcref] = ACTIONS(6210),
    [anon_sym_BSLASHCref] = ACTIONS(6210),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnameCref] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6210),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6210),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6210),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6210),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6210),
    [anon_sym_BSLASHdef] = ACTIONS(6210),
    [anon_sym_BSLASHlet] = ACTIONS(6210),
    [anon_sym_BSLASHleft] = ACTIONS(6210),
    [anon_sym_BSLASHbigl] = ACTIONS(6210),
    [anon_sym_BSLASHBigl] = ACTIONS(6210),
    [anon_sym_BSLASHbiggl] = ACTIONS(6210),
    [anon_sym_BSLASHBiggl] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6210),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6210),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6210),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6210),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6210),
    [anon_sym_BSLASHgls] = ACTIONS(6210),
    [anon_sym_BSLASHGls] = ACTIONS(6210),
    [anon_sym_BSLASHGLS] = ACTIONS(6210),
    [anon_sym_BSLASHglspl] = ACTIONS(6210),
    [anon_sym_BSLASHGlspl] = ACTIONS(6210),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6210),
    [anon_sym_BSLASHglslink] = ACTIONS(6210),
    [anon_sym_BSLASHglstext] = ACTIONS(6210),
    [anon_sym_BSLASHGlstext] = ACTIONS(6210),
    [anon_sym_BSLASHGLStext] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6210),
    [anon_sym_BSLASHglsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6210),
    [anon_sym_BSLASHglsname] = ACTIONS(6210),
    [anon_sym_BSLASHGlsname] = ACTIONS(6210),
    [anon_sym_BSLASHGLSname] = ACTIONS(6210),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6210),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6210),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6210),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6210),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6210),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6210),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6210),
    [anon_sym_BSLASHacrshort] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6210),
    [anon_sym_BSLASHACRshort] = ACTIONS(6210),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrlong] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6210),
    [anon_sym_BSLASHACRlong] = ACTIONS(6210),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6210),
    [anon_sym_BSLASHacrfull] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6210),
    [anon_sym_BSLASHACRfull] = ACTIONS(6210),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHacs] = ACTIONS(6210),
    [anon_sym_BSLASHAcs] = ACTIONS(6210),
    [anon_sym_BSLASHacsp] = ACTIONS(6210),
    [anon_sym_BSLASHAcsp] = ACTIONS(6210),
    [anon_sym_BSLASHacl] = ACTIONS(6210),
    [anon_sym_BSLASHAcl] = ACTIONS(6210),
    [anon_sym_BSLASHaclp] = ACTIONS(6210),
    [anon_sym_BSLASHAclp] = ACTIONS(6210),
    [anon_sym_BSLASHacf] = ACTIONS(6210),
    [anon_sym_BSLASHAcf] = ACTIONS(6210),
    [anon_sym_BSLASHacfp] = ACTIONS(6210),
    [anon_sym_BSLASHAcfp] = ACTIONS(6210),
    [anon_sym_BSLASHac] = ACTIONS(6210),
    [anon_sym_BSLASHAc] = ACTIONS(6210),
    [anon_sym_BSLASHacp] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6210),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6210),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6210),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6210),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6212),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6210),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6210),
    [anon_sym_BSLASHcolor] = ACTIONS(6210),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6210),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6210),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6210),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6210),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6210),
    [anon_sym_BSLASHtext] = ACTIONS(6210),
    [anon_sym_BSLASHintertext] = ACTIONS(6210),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6210),
    [anon_sym_BSLASHurl] = ACTIONS(6210),
    [anon_sym_BSLASHhref] = ACTIONS(6210),
  },
  [1385] = {
    [sym_command_name] = ACTIONS(6206),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6206),
    [anon_sym_LBRACK] = ACTIONS(6208),
    [anon_sym_RBRACK] = ACTIONS(6208),
    [anon_sym_COMMA] = ACTIONS(6208),
    [anon_sym_EQ] = ACTIONS(6208),
    [anon_sym_LPAREN] = ACTIONS(6208),
    [anon_sym_RPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHpart] = ACTIONS(6206),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddpart] = ACTIONS(6206),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHchapter] = ACTIONS(6206),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddchap] = ACTIONS(6206),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsection] = ACTIONS(6206),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHaddsec] = ACTIONS(6206),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6206),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6206),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHitem] = ACTIONS(6206),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6208),
    [anon_sym_LBRACE] = ACTIONS(6208),
    [sym_word] = ACTIONS(6206),
    [sym_placeholder] = ACTIONS(6208),
    [anon_sym_PLUS] = ACTIONS(6208),
    [anon_sym_DASH] = ACTIONS(6208),
    [anon_sym_STAR] = ACTIONS(6208),
    [anon_sym_SLASH] = ACTIONS(6208),
    [anon_sym_LT] = ACTIONS(6206),
    [anon_sym_GT] = ACTIONS(6206),
    [anon_sym_BANG] = ACTIONS(6206),
    [anon_sym_PIPE] = ACTIONS(6206),
    [anon_sym_COLON] = ACTIONS(6206),
    [anon_sym_SQUOTE] = ACTIONS(6206),
    [anon_sym__] = ACTIONS(6208),
    [anon_sym_CARET] = ACTIONS(6208),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6208),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6208),
    [anon_sym_DOLLAR] = ACTIONS(6206),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6208),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6208),
    [anon_sym_BSLASHbegin] = ACTIONS(6206),
    [anon_sym_BSLASHtitle] = ACTIONS(6206),
    [anon_sym_BSLASHauthor] = ACTIONS(6206),
    [anon_sym_BSLASHusepackage] = ACTIONS(6206),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6206),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6206),
    [anon_sym_BSLASHinclude] = ACTIONS(6206),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6206),
    [anon_sym_BSLASHinput] = ACTIONS(6206),
    [anon_sym_BSLASHsubfile] = ACTIONS(6206),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6206),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6206),
    [anon_sym_BSLASHbibliography] = ACTIONS(6206),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6206),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6206),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6206),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6206),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6206),
    [anon_sym_BSLASHimport] = ACTIONS(6206),
    [anon_sym_BSLASHsubimport] = ACTIONS(6206),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6206),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6206),
    [anon_sym_BSLASHcaption] = ACTIONS(6206),
    [anon_sym_BSLASHcite] = ACTIONS(6206),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCite] = ACTIONS(6206),
    [anon_sym_BSLASHnocite] = ACTIONS(6206),
    [anon_sym_BSLASHcitet] = ACTIONS(6206),
    [anon_sym_BSLASHcitep] = ACTIONS(6206),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteA] = ACTIONS(6206),
    [anon_sym_BSLASHciteR] = ACTIONS(6206),
    [anon_sym_BSLASHciteS] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6206),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6206),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteyear] = ACTIONS(6206),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHcitedate] = ACTIONS(6206),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHciteurl] = ACTIONS(6206),
    [anon_sym_BSLASHfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6206),
    [anon_sym_BSLASHcitealt] = ACTIONS(6206),
    [anon_sym_BSLASHcitealp] = ACTIONS(6206),
    [anon_sym_BSLASHcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHparencite] = ACTIONS(6206),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHParencite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6206),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6206),
    [anon_sym_BSLASHtextcite] = ACTIONS(6206),
    [anon_sym_BSLASHTextcite] = ACTIONS(6206),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6206),
    [anon_sym_BSLASHsupercite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite] = ACTIONS(6206),
    [anon_sym_BSLASHAutocite] = ACTIONS(6206),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHVolcite] = ACTIONS(6206),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHavolcite] = ACTIONS(6206),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6206),
    [anon_sym_BSLASHnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHNotecite] = ACTIONS(6206),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6206),
    [anon_sym_BSLASHlabel] = ACTIONS(6206),
    [anon_sym_BSLASHref] = ACTIONS(6206),
    [anon_sym_BSLASHeqref] = ACTIONS(6206),
    [anon_sym_BSLASHvref] = ACTIONS(6206),
    [anon_sym_BSLASHVref] = ACTIONS(6206),
    [anon_sym_BSLASHautoref] = ACTIONS(6206),
    [anon_sym_BSLASHpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcref] = ACTIONS(6206),
    [anon_sym_BSLASHCref] = ACTIONS(6206),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnameCref] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6206),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6206),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6206),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6206),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6206),
    [anon_sym_BSLASHdef] = ACTIONS(6206),
    [anon_sym_BSLASHlet] = ACTIONS(6206),
    [anon_sym_BSLASHleft] = ACTIONS(6206),
    [anon_sym_BSLASHbigl] = ACTIONS(6206),
    [anon_sym_BSLASHBigl] = ACTIONS(6206),
    [anon_sym_BSLASHbiggl] = ACTIONS(6206),
    [anon_sym_BSLASHBiggl] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6206),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6206),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6206),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6206),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6206),
    [anon_sym_BSLASHgls] = ACTIONS(6206),
    [anon_sym_BSLASHGls] = ACTIONS(6206),
    [anon_sym_BSLASHGLS] = ACTIONS(6206),
    [anon_sym_BSLASHglspl] = ACTIONS(6206),
    [anon_sym_BSLASHGlspl] = ACTIONS(6206),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6206),
    [anon_sym_BSLASHglslink] = ACTIONS(6206),
    [anon_sym_BSLASHglstext] = ACTIONS(6206),
    [anon_sym_BSLASHGlstext] = ACTIONS(6206),
    [anon_sym_BSLASHGLStext] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6206),
    [anon_sym_BSLASHglsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6206),
    [anon_sym_BSLASHglsname] = ACTIONS(6206),
    [anon_sym_BSLASHGlsname] = ACTIONS(6206),
    [anon_sym_BSLASHGLSname] = ACTIONS(6206),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6206),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6206),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6206),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6206),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6206),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6206),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6206),
    [anon_sym_BSLASHacrshort] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6206),
    [anon_sym_BSLASHACRshort] = ACTIONS(6206),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrlong] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6206),
    [anon_sym_BSLASHACRlong] = ACTIONS(6206),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6206),
    [anon_sym_BSLASHacrfull] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6206),
    [anon_sym_BSLASHACRfull] = ACTIONS(6206),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHacs] = ACTIONS(6206),
    [anon_sym_BSLASHAcs] = ACTIONS(6206),
    [anon_sym_BSLASHacsp] = ACTIONS(6206),
    [anon_sym_BSLASHAcsp] = ACTIONS(6206),
    [anon_sym_BSLASHacl] = ACTIONS(6206),
    [anon_sym_BSLASHAcl] = ACTIONS(6206),
    [anon_sym_BSLASHaclp] = ACTIONS(6206),
    [anon_sym_BSLASHAclp] = ACTIONS(6206),
    [anon_sym_BSLASHacf] = ACTIONS(6206),
    [anon_sym_BSLASHAcf] = ACTIONS(6206),
    [anon_sym_BSLASHacfp] = ACTIONS(6206),
    [anon_sym_BSLASHAcfp] = ACTIONS(6206),
    [anon_sym_BSLASHac] = ACTIONS(6206),
    [anon_sym_BSLASHAc] = ACTIONS(6206),
    [anon_sym_BSLASHacp] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6206),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6206),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6206),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6206),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6208),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6206),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6206),
    [anon_sym_BSLASHcolor] = ACTIONS(6206),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6206),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6206),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6206),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6206),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6206),
    [anon_sym_BSLASHtext] = ACTIONS(6206),
    [anon_sym_BSLASHintertext] = ACTIONS(6206),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6206),
    [anon_sym_BSLASHurl] = ACTIONS(6206),
    [anon_sym_BSLASHhref] = ACTIONS(6206),
  },
  [1386] = {
    [sym_command_name] = ACTIONS(6202),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6202),
    [anon_sym_LBRACK] = ACTIONS(6204),
    [anon_sym_RBRACK] = ACTIONS(6204),
    [anon_sym_COMMA] = ACTIONS(6204),
    [anon_sym_EQ] = ACTIONS(6204),
    [anon_sym_LPAREN] = ACTIONS(6204),
    [anon_sym_RPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHpart] = ACTIONS(6202),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddpart] = ACTIONS(6202),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHchapter] = ACTIONS(6202),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddchap] = ACTIONS(6202),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsection] = ACTIONS(6202),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHaddsec] = ACTIONS(6202),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6202),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6202),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHitem] = ACTIONS(6202),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6204),
    [anon_sym_LBRACE] = ACTIONS(6204),
    [sym_word] = ACTIONS(6202),
    [sym_placeholder] = ACTIONS(6204),
    [anon_sym_PLUS] = ACTIONS(6204),
    [anon_sym_DASH] = ACTIONS(6204),
    [anon_sym_STAR] = ACTIONS(6204),
    [anon_sym_SLASH] = ACTIONS(6204),
    [anon_sym_LT] = ACTIONS(6202),
    [anon_sym_GT] = ACTIONS(6202),
    [anon_sym_BANG] = ACTIONS(6202),
    [anon_sym_PIPE] = ACTIONS(6202),
    [anon_sym_COLON] = ACTIONS(6202),
    [anon_sym_SQUOTE] = ACTIONS(6202),
    [anon_sym__] = ACTIONS(6204),
    [anon_sym_CARET] = ACTIONS(6204),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6204),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6204),
    [anon_sym_DOLLAR] = ACTIONS(6202),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6204),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6204),
    [anon_sym_BSLASHbegin] = ACTIONS(6202),
    [anon_sym_BSLASHtitle] = ACTIONS(6202),
    [anon_sym_BSLASHauthor] = ACTIONS(6202),
    [anon_sym_BSLASHusepackage] = ACTIONS(6202),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6202),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6202),
    [anon_sym_BSLASHinclude] = ACTIONS(6202),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6202),
    [anon_sym_BSLASHinput] = ACTIONS(6202),
    [anon_sym_BSLASHsubfile] = ACTIONS(6202),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6202),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6202),
    [anon_sym_BSLASHbibliography] = ACTIONS(6202),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6202),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6202),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6202),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6202),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6202),
    [anon_sym_BSLASHimport] = ACTIONS(6202),
    [anon_sym_BSLASHsubimport] = ACTIONS(6202),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6202),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6202),
    [anon_sym_BSLASHcaption] = ACTIONS(6202),
    [anon_sym_BSLASHcite] = ACTIONS(6202),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCite] = ACTIONS(6202),
    [anon_sym_BSLASHnocite] = ACTIONS(6202),
    [anon_sym_BSLASHcitet] = ACTIONS(6202),
    [anon_sym_BSLASHcitep] = ACTIONS(6202),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteA] = ACTIONS(6202),
    [anon_sym_BSLASHciteR] = ACTIONS(6202),
    [anon_sym_BSLASHciteS] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6202),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6202),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteyear] = ACTIONS(6202),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHcitedate] = ACTIONS(6202),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHciteurl] = ACTIONS(6202),
    [anon_sym_BSLASHfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6202),
    [anon_sym_BSLASHcitealt] = ACTIONS(6202),
    [anon_sym_BSLASHcitealp] = ACTIONS(6202),
    [anon_sym_BSLASHcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHparencite] = ACTIONS(6202),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHParencite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6202),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6202),
    [anon_sym_BSLASHtextcite] = ACTIONS(6202),
    [anon_sym_BSLASHTextcite] = ACTIONS(6202),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6202),
    [anon_sym_BSLASHsupercite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite] = ACTIONS(6202),
    [anon_sym_BSLASHAutocite] = ACTIONS(6202),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHVolcite] = ACTIONS(6202),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHavolcite] = ACTIONS(6202),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6202),
    [anon_sym_BSLASHnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHNotecite] = ACTIONS(6202),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6202),
    [anon_sym_BSLASHlabel] = ACTIONS(6202),
    [anon_sym_BSLASHref] = ACTIONS(6202),
    [anon_sym_BSLASHeqref] = ACTIONS(6202),
    [anon_sym_BSLASHvref] = ACTIONS(6202),
    [anon_sym_BSLASHVref] = ACTIONS(6202),
    [anon_sym_BSLASHautoref] = ACTIONS(6202),
    [anon_sym_BSLASHpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcref] = ACTIONS(6202),
    [anon_sym_BSLASHCref] = ACTIONS(6202),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnameCref] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6202),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6202),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6202),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6202),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6202),
    [anon_sym_BSLASHdef] = ACTIONS(6202),
    [anon_sym_BSLASHlet] = ACTIONS(6202),
    [anon_sym_BSLASHleft] = ACTIONS(6202),
    [anon_sym_BSLASHbigl] = ACTIONS(6202),
    [anon_sym_BSLASHBigl] = ACTIONS(6202),
    [anon_sym_BSLASHbiggl] = ACTIONS(6202),
    [anon_sym_BSLASHBiggl] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6202),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6202),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6202),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6202),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6202),
    [anon_sym_BSLASHgls] = ACTIONS(6202),
    [anon_sym_BSLASHGls] = ACTIONS(6202),
    [anon_sym_BSLASHGLS] = ACTIONS(6202),
    [anon_sym_BSLASHglspl] = ACTIONS(6202),
    [anon_sym_BSLASHGlspl] = ACTIONS(6202),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6202),
    [anon_sym_BSLASHglslink] = ACTIONS(6202),
    [anon_sym_BSLASHglstext] = ACTIONS(6202),
    [anon_sym_BSLASHGlstext] = ACTIONS(6202),
    [anon_sym_BSLASHGLStext] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6202),
    [anon_sym_BSLASHglsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6202),
    [anon_sym_BSLASHglsname] = ACTIONS(6202),
    [anon_sym_BSLASHGlsname] = ACTIONS(6202),
    [anon_sym_BSLASHGLSname] = ACTIONS(6202),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6202),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6202),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6202),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6202),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6202),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6202),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6202),
    [anon_sym_BSLASHacrshort] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6202),
    [anon_sym_BSLASHACRshort] = ACTIONS(6202),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrlong] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6202),
    [anon_sym_BSLASHACRlong] = ACTIONS(6202),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6202),
    [anon_sym_BSLASHacrfull] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6202),
    [anon_sym_BSLASHACRfull] = ACTIONS(6202),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHacs] = ACTIONS(6202),
    [anon_sym_BSLASHAcs] = ACTIONS(6202),
    [anon_sym_BSLASHacsp] = ACTIONS(6202),
    [anon_sym_BSLASHAcsp] = ACTIONS(6202),
    [anon_sym_BSLASHacl] = ACTIONS(6202),
    [anon_sym_BSLASHAcl] = ACTIONS(6202),
    [anon_sym_BSLASHaclp] = ACTIONS(6202),
    [anon_sym_BSLASHAclp] = ACTIONS(6202),
    [anon_sym_BSLASHacf] = ACTIONS(6202),
    [anon_sym_BSLASHAcf] = ACTIONS(6202),
    [anon_sym_BSLASHacfp] = ACTIONS(6202),
    [anon_sym_BSLASHAcfp] = ACTIONS(6202),
    [anon_sym_BSLASHac] = ACTIONS(6202),
    [anon_sym_BSLASHAc] = ACTIONS(6202),
    [anon_sym_BSLASHacp] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6202),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6202),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6202),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6202),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6204),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6202),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6202),
    [anon_sym_BSLASHcolor] = ACTIONS(6202),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6202),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6202),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6202),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6202),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6202),
    [anon_sym_BSLASHtext] = ACTIONS(6202),
    [anon_sym_BSLASHintertext] = ACTIONS(6202),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6202),
    [anon_sym_BSLASHurl] = ACTIONS(6202),
    [anon_sym_BSLASHhref] = ACTIONS(6202),
  },
  [1387] = {
    [sym_command_name] = ACTIONS(6194),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_RBRACK] = ACTIONS(6196),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_EQ] = ACTIONS(6196),
    [anon_sym_LPAREN] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHpart] = ACTIONS(6194),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddpart] = ACTIONS(6194),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHchapter] = ACTIONS(6194),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddchap] = ACTIONS(6194),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsection] = ACTIONS(6194),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHaddsec] = ACTIONS(6194),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6194),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6194),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHitem] = ACTIONS(6194),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [sym_word] = ACTIONS(6194),
    [sym_placeholder] = ACTIONS(6196),
    [anon_sym_PLUS] = ACTIONS(6196),
    [anon_sym_DASH] = ACTIONS(6196),
    [anon_sym_STAR] = ACTIONS(6196),
    [anon_sym_SLASH] = ACTIONS(6196),
    [anon_sym_LT] = ACTIONS(6194),
    [anon_sym_GT] = ACTIONS(6194),
    [anon_sym_BANG] = ACTIONS(6194),
    [anon_sym_PIPE] = ACTIONS(6194),
    [anon_sym_COLON] = ACTIONS(6194),
    [anon_sym_SQUOTE] = ACTIONS(6194),
    [anon_sym__] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6196),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6196),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6196),
    [anon_sym_DOLLAR] = ACTIONS(6194),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6196),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6196),
    [anon_sym_BSLASHbegin] = ACTIONS(6194),
    [anon_sym_BSLASHtitle] = ACTIONS(6194),
    [anon_sym_BSLASHauthor] = ACTIONS(6194),
    [anon_sym_BSLASHusepackage] = ACTIONS(6194),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6194),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6194),
    [anon_sym_BSLASHinclude] = ACTIONS(6194),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6194),
    [anon_sym_BSLASHinput] = ACTIONS(6194),
    [anon_sym_BSLASHsubfile] = ACTIONS(6194),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6194),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6194),
    [anon_sym_BSLASHbibliography] = ACTIONS(6194),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6194),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6194),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6194),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6194),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6194),
    [anon_sym_BSLASHimport] = ACTIONS(6194),
    [anon_sym_BSLASHsubimport] = ACTIONS(6194),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6194),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6194),
    [anon_sym_BSLASHcaption] = ACTIONS(6194),
    [anon_sym_BSLASHcite] = ACTIONS(6194),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCite] = ACTIONS(6194),
    [anon_sym_BSLASHnocite] = ACTIONS(6194),
    [anon_sym_BSLASHcitet] = ACTIONS(6194),
    [anon_sym_BSLASHcitep] = ACTIONS(6194),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteA] = ACTIONS(6194),
    [anon_sym_BSLASHciteR] = ACTIONS(6194),
    [anon_sym_BSLASHciteS] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6194),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6194),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteyear] = ACTIONS(6194),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHcitedate] = ACTIONS(6194),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHciteurl] = ACTIONS(6194),
    [anon_sym_BSLASHfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6194),
    [anon_sym_BSLASHcitealt] = ACTIONS(6194),
    [anon_sym_BSLASHcitealp] = ACTIONS(6194),
    [anon_sym_BSLASHcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHparencite] = ACTIONS(6194),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHParencite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6194),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6194),
    [anon_sym_BSLASHtextcite] = ACTIONS(6194),
    [anon_sym_BSLASHTextcite] = ACTIONS(6194),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6194),
    [anon_sym_BSLASHsupercite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite] = ACTIONS(6194),
    [anon_sym_BSLASHAutocite] = ACTIONS(6194),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHVolcite] = ACTIONS(6194),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHavolcite] = ACTIONS(6194),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6194),
    [anon_sym_BSLASHnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHNotecite] = ACTIONS(6194),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6194),
    [anon_sym_BSLASHlabel] = ACTIONS(6194),
    [anon_sym_BSLASHref] = ACTIONS(6194),
    [anon_sym_BSLASHeqref] = ACTIONS(6194),
    [anon_sym_BSLASHvref] = ACTIONS(6194),
    [anon_sym_BSLASHVref] = ACTIONS(6194),
    [anon_sym_BSLASHautoref] = ACTIONS(6194),
    [anon_sym_BSLASHpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcref] = ACTIONS(6194),
    [anon_sym_BSLASHCref] = ACTIONS(6194),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnameCref] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6194),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6194),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6194),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6194),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6194),
    [anon_sym_BSLASHdef] = ACTIONS(6194),
    [anon_sym_BSLASHlet] = ACTIONS(6194),
    [anon_sym_BSLASHleft] = ACTIONS(6194),
    [anon_sym_BSLASHbigl] = ACTIONS(6194),
    [anon_sym_BSLASHBigl] = ACTIONS(6194),
    [anon_sym_BSLASHbiggl] = ACTIONS(6194),
    [anon_sym_BSLASHBiggl] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6194),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6194),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6194),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6194),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6194),
    [anon_sym_BSLASHgls] = ACTIONS(6194),
    [anon_sym_BSLASHGls] = ACTIONS(6194),
    [anon_sym_BSLASHGLS] = ACTIONS(6194),
    [anon_sym_BSLASHglspl] = ACTIONS(6194),
    [anon_sym_BSLASHGlspl] = ACTIONS(6194),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6194),
    [anon_sym_BSLASHglslink] = ACTIONS(6194),
    [anon_sym_BSLASHglstext] = ACTIONS(6194),
    [anon_sym_BSLASHGlstext] = ACTIONS(6194),
    [anon_sym_BSLASHGLStext] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6194),
    [anon_sym_BSLASHglsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6194),
    [anon_sym_BSLASHglsname] = ACTIONS(6194),
    [anon_sym_BSLASHGlsname] = ACTIONS(6194),
    [anon_sym_BSLASHGLSname] = ACTIONS(6194),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6194),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6194),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6194),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6194),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6194),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6194),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6194),
    [anon_sym_BSLASHacrshort] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6194),
    [anon_sym_BSLASHACRshort] = ACTIONS(6194),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrlong] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6194),
    [anon_sym_BSLASHACRlong] = ACTIONS(6194),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6194),
    [anon_sym_BSLASHacrfull] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6194),
    [anon_sym_BSLASHACRfull] = ACTIONS(6194),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHacs] = ACTIONS(6194),
    [anon_sym_BSLASHAcs] = ACTIONS(6194),
    [anon_sym_BSLASHacsp] = ACTIONS(6194),
    [anon_sym_BSLASHAcsp] = ACTIONS(6194),
    [anon_sym_BSLASHacl] = ACTIONS(6194),
    [anon_sym_BSLASHAcl] = ACTIONS(6194),
    [anon_sym_BSLASHaclp] = ACTIONS(6194),
    [anon_sym_BSLASHAclp] = ACTIONS(6194),
    [anon_sym_BSLASHacf] = ACTIONS(6194),
    [anon_sym_BSLASHAcf] = ACTIONS(6194),
    [anon_sym_BSLASHacfp] = ACTIONS(6194),
    [anon_sym_BSLASHAcfp] = ACTIONS(6194),
    [anon_sym_BSLASHac] = ACTIONS(6194),
    [anon_sym_BSLASHAc] = ACTIONS(6194),
    [anon_sym_BSLASHacp] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6194),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6194),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6194),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6194),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6196),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6194),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6194),
    [anon_sym_BSLASHcolor] = ACTIONS(6194),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6194),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6194),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6194),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6194),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6194),
    [anon_sym_BSLASHtext] = ACTIONS(6194),
    [anon_sym_BSLASHintertext] = ACTIONS(6194),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6194),
    [anon_sym_BSLASHurl] = ACTIONS(6194),
    [anon_sym_BSLASHhref] = ACTIONS(6194),
  },
  [1388] = {
    [sym_command_name] = ACTIONS(6186),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(6188),
    [anon_sym_RBRACK] = ACTIONS(6188),
    [anon_sym_COMMA] = ACTIONS(6188),
    [anon_sym_EQ] = ACTIONS(6188),
    [anon_sym_LPAREN] = ACTIONS(6188),
    [anon_sym_RPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHpart] = ACTIONS(6186),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddpart] = ACTIONS(6186),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHchapter] = ACTIONS(6186),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddchap] = ACTIONS(6186),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsection] = ACTIONS(6186),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHaddsec] = ACTIONS(6186),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6186),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6186),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHitem] = ACTIONS(6186),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6188),
    [anon_sym_LBRACE] = ACTIONS(6188),
    [sym_word] = ACTIONS(6186),
    [sym_placeholder] = ACTIONS(6188),
    [anon_sym_PLUS] = ACTIONS(6188),
    [anon_sym_DASH] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_SLASH] = ACTIONS(6188),
    [anon_sym_LT] = ACTIONS(6186),
    [anon_sym_GT] = ACTIONS(6186),
    [anon_sym_BANG] = ACTIONS(6186),
    [anon_sym_PIPE] = ACTIONS(6186),
    [anon_sym_COLON] = ACTIONS(6186),
    [anon_sym_SQUOTE] = ACTIONS(6186),
    [anon_sym__] = ACTIONS(6188),
    [anon_sym_CARET] = ACTIONS(6188),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6188),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6188),
    [anon_sym_DOLLAR] = ACTIONS(6186),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6188),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6188),
    [anon_sym_BSLASHbegin] = ACTIONS(6186),
    [anon_sym_BSLASHtitle] = ACTIONS(6186),
    [anon_sym_BSLASHauthor] = ACTIONS(6186),
    [anon_sym_BSLASHusepackage] = ACTIONS(6186),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6186),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6186),
    [anon_sym_BSLASHinclude] = ACTIONS(6186),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6186),
    [anon_sym_BSLASHinput] = ACTIONS(6186),
    [anon_sym_BSLASHsubfile] = ACTIONS(6186),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6186),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6186),
    [anon_sym_BSLASHbibliography] = ACTIONS(6186),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6186),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6186),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6186),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6186),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6186),
    [anon_sym_BSLASHimport] = ACTIONS(6186),
    [anon_sym_BSLASHsubimport] = ACTIONS(6186),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6186),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6186),
    [anon_sym_BSLASHcaption] = ACTIONS(6186),
    [anon_sym_BSLASHcite] = ACTIONS(6186),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCite] = ACTIONS(6186),
    [anon_sym_BSLASHnocite] = ACTIONS(6186),
    [anon_sym_BSLASHcitet] = ACTIONS(6186),
    [anon_sym_BSLASHcitep] = ACTIONS(6186),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteA] = ACTIONS(6186),
    [anon_sym_BSLASHciteR] = ACTIONS(6186),
    [anon_sym_BSLASHciteS] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6186),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6186),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteyear] = ACTIONS(6186),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHcitedate] = ACTIONS(6186),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHciteurl] = ACTIONS(6186),
    [anon_sym_BSLASHfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6186),
    [anon_sym_BSLASHcitealt] = ACTIONS(6186),
    [anon_sym_BSLASHcitealp] = ACTIONS(6186),
    [anon_sym_BSLASHcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHparencite] = ACTIONS(6186),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHParencite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6186),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6186),
    [anon_sym_BSLASHtextcite] = ACTIONS(6186),
    [anon_sym_BSLASHTextcite] = ACTIONS(6186),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6186),
    [anon_sym_BSLASHsupercite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite] = ACTIONS(6186),
    [anon_sym_BSLASHAutocite] = ACTIONS(6186),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHVolcite] = ACTIONS(6186),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHavolcite] = ACTIONS(6186),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6186),
    [anon_sym_BSLASHnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHNotecite] = ACTIONS(6186),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6186),
    [anon_sym_BSLASHlabel] = ACTIONS(6186),
    [anon_sym_BSLASHref] = ACTIONS(6186),
    [anon_sym_BSLASHeqref] = ACTIONS(6186),
    [anon_sym_BSLASHvref] = ACTIONS(6186),
    [anon_sym_BSLASHVref] = ACTIONS(6186),
    [anon_sym_BSLASHautoref] = ACTIONS(6186),
    [anon_sym_BSLASHpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcref] = ACTIONS(6186),
    [anon_sym_BSLASHCref] = ACTIONS(6186),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnameCref] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6186),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6186),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6186),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6186),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6186),
    [anon_sym_BSLASHdef] = ACTIONS(6186),
    [anon_sym_BSLASHlet] = ACTIONS(6186),
    [anon_sym_BSLASHleft] = ACTIONS(6186),
    [anon_sym_BSLASHbigl] = ACTIONS(6186),
    [anon_sym_BSLASHBigl] = ACTIONS(6186),
    [anon_sym_BSLASHbiggl] = ACTIONS(6186),
    [anon_sym_BSLASHBiggl] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6186),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6186),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6186),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6186),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6186),
    [anon_sym_BSLASHgls] = ACTIONS(6186),
    [anon_sym_BSLASHGls] = ACTIONS(6186),
    [anon_sym_BSLASHGLS] = ACTIONS(6186),
    [anon_sym_BSLASHglspl] = ACTIONS(6186),
    [anon_sym_BSLASHGlspl] = ACTIONS(6186),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6186),
    [anon_sym_BSLASHglslink] = ACTIONS(6186),
    [anon_sym_BSLASHglstext] = ACTIONS(6186),
    [anon_sym_BSLASHGlstext] = ACTIONS(6186),
    [anon_sym_BSLASHGLStext] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6186),
    [anon_sym_BSLASHglsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6186),
    [anon_sym_BSLASHglsname] = ACTIONS(6186),
    [anon_sym_BSLASHGlsname] = ACTIONS(6186),
    [anon_sym_BSLASHGLSname] = ACTIONS(6186),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6186),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6186),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6186),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6186),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6186),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6186),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6186),
    [anon_sym_BSLASHacrshort] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6186),
    [anon_sym_BSLASHACRshort] = ACTIONS(6186),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrlong] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6186),
    [anon_sym_BSLASHACRlong] = ACTIONS(6186),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6186),
    [anon_sym_BSLASHacrfull] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6186),
    [anon_sym_BSLASHACRfull] = ACTIONS(6186),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHacs] = ACTIONS(6186),
    [anon_sym_BSLASHAcs] = ACTIONS(6186),
    [anon_sym_BSLASHacsp] = ACTIONS(6186),
    [anon_sym_BSLASHAcsp] = ACTIONS(6186),
    [anon_sym_BSLASHacl] = ACTIONS(6186),
    [anon_sym_BSLASHAcl] = ACTIONS(6186),
    [anon_sym_BSLASHaclp] = ACTIONS(6186),
    [anon_sym_BSLASHAclp] = ACTIONS(6186),
    [anon_sym_BSLASHacf] = ACTIONS(6186),
    [anon_sym_BSLASHAcf] = ACTIONS(6186),
    [anon_sym_BSLASHacfp] = ACTIONS(6186),
    [anon_sym_BSLASHAcfp] = ACTIONS(6186),
    [anon_sym_BSLASHac] = ACTIONS(6186),
    [anon_sym_BSLASHAc] = ACTIONS(6186),
    [anon_sym_BSLASHacp] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6186),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6186),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6186),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6186),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6188),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6186),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6186),
    [anon_sym_BSLASHcolor] = ACTIONS(6186),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6186),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6186),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6186),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6186),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6186),
    [anon_sym_BSLASHtext] = ACTIONS(6186),
    [anon_sym_BSLASHintertext] = ACTIONS(6186),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6186),
    [anon_sym_BSLASHurl] = ACTIONS(6186),
    [anon_sym_BSLASHhref] = ACTIONS(6186),
  },
  [1389] = {
    [sym_command_name] = ACTIONS(6178),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6178),
    [anon_sym_LBRACK] = ACTIONS(6180),
    [anon_sym_RBRACK] = ACTIONS(6180),
    [anon_sym_COMMA] = ACTIONS(6180),
    [anon_sym_EQ] = ACTIONS(6180),
    [anon_sym_LPAREN] = ACTIONS(6180),
    [anon_sym_RPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHpart] = ACTIONS(6178),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddpart] = ACTIONS(6178),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHchapter] = ACTIONS(6178),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddchap] = ACTIONS(6178),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsection] = ACTIONS(6178),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHaddsec] = ACTIONS(6178),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6178),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6178),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHitem] = ACTIONS(6178),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6180),
    [anon_sym_LBRACE] = ACTIONS(6180),
    [sym_word] = ACTIONS(6178),
    [sym_placeholder] = ACTIONS(6180),
    [anon_sym_PLUS] = ACTIONS(6180),
    [anon_sym_DASH] = ACTIONS(6180),
    [anon_sym_STAR] = ACTIONS(6180),
    [anon_sym_SLASH] = ACTIONS(6180),
    [anon_sym_LT] = ACTIONS(6178),
    [anon_sym_GT] = ACTIONS(6178),
    [anon_sym_BANG] = ACTIONS(6178),
    [anon_sym_PIPE] = ACTIONS(6178),
    [anon_sym_COLON] = ACTIONS(6178),
    [anon_sym_SQUOTE] = ACTIONS(6178),
    [anon_sym__] = ACTIONS(6180),
    [anon_sym_CARET] = ACTIONS(6180),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6180),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6180),
    [anon_sym_DOLLAR] = ACTIONS(6178),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6180),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6180),
    [anon_sym_BSLASHbegin] = ACTIONS(6178),
    [anon_sym_BSLASHtitle] = ACTIONS(6178),
    [anon_sym_BSLASHauthor] = ACTIONS(6178),
    [anon_sym_BSLASHusepackage] = ACTIONS(6178),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6178),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6178),
    [anon_sym_BSLASHinclude] = ACTIONS(6178),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6178),
    [anon_sym_BSLASHinput] = ACTIONS(6178),
    [anon_sym_BSLASHsubfile] = ACTIONS(6178),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6178),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6178),
    [anon_sym_BSLASHbibliography] = ACTIONS(6178),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6178),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6178),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6178),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6178),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6178),
    [anon_sym_BSLASHimport] = ACTIONS(6178),
    [anon_sym_BSLASHsubimport] = ACTIONS(6178),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6178),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6178),
    [anon_sym_BSLASHcaption] = ACTIONS(6178),
    [anon_sym_BSLASHcite] = ACTIONS(6178),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCite] = ACTIONS(6178),
    [anon_sym_BSLASHnocite] = ACTIONS(6178),
    [anon_sym_BSLASHcitet] = ACTIONS(6178),
    [anon_sym_BSLASHcitep] = ACTIONS(6178),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteA] = ACTIONS(6178),
    [anon_sym_BSLASHciteR] = ACTIONS(6178),
    [anon_sym_BSLASHciteS] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6178),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6178),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteyear] = ACTIONS(6178),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHcitedate] = ACTIONS(6178),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHciteurl] = ACTIONS(6178),
    [anon_sym_BSLASHfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6178),
    [anon_sym_BSLASHcitealt] = ACTIONS(6178),
    [anon_sym_BSLASHcitealp] = ACTIONS(6178),
    [anon_sym_BSLASHcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHparencite] = ACTIONS(6178),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHParencite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6178),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6178),
    [anon_sym_BSLASHtextcite] = ACTIONS(6178),
    [anon_sym_BSLASHTextcite] = ACTIONS(6178),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6178),
    [anon_sym_BSLASHsupercite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite] = ACTIONS(6178),
    [anon_sym_BSLASHAutocite] = ACTIONS(6178),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHVolcite] = ACTIONS(6178),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHavolcite] = ACTIONS(6178),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6178),
    [anon_sym_BSLASHnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHNotecite] = ACTIONS(6178),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6178),
    [anon_sym_BSLASHlabel] = ACTIONS(6178),
    [anon_sym_BSLASHref] = ACTIONS(6178),
    [anon_sym_BSLASHeqref] = ACTIONS(6178),
    [anon_sym_BSLASHvref] = ACTIONS(6178),
    [anon_sym_BSLASHVref] = ACTIONS(6178),
    [anon_sym_BSLASHautoref] = ACTIONS(6178),
    [anon_sym_BSLASHpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcref] = ACTIONS(6178),
    [anon_sym_BSLASHCref] = ACTIONS(6178),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnameCref] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6178),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6178),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6178),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6178),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6178),
    [anon_sym_BSLASHdef] = ACTIONS(6178),
    [anon_sym_BSLASHlet] = ACTIONS(6178),
    [anon_sym_BSLASHleft] = ACTIONS(6178),
    [anon_sym_BSLASHbigl] = ACTIONS(6178),
    [anon_sym_BSLASHBigl] = ACTIONS(6178),
    [anon_sym_BSLASHbiggl] = ACTIONS(6178),
    [anon_sym_BSLASHBiggl] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6178),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6178),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6178),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6178),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6178),
    [anon_sym_BSLASHgls] = ACTIONS(6178),
    [anon_sym_BSLASHGls] = ACTIONS(6178),
    [anon_sym_BSLASHGLS] = ACTIONS(6178),
    [anon_sym_BSLASHglspl] = ACTIONS(6178),
    [anon_sym_BSLASHGlspl] = ACTIONS(6178),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6178),
    [anon_sym_BSLASHglslink] = ACTIONS(6178),
    [anon_sym_BSLASHglstext] = ACTIONS(6178),
    [anon_sym_BSLASHGlstext] = ACTIONS(6178),
    [anon_sym_BSLASHGLStext] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6178),
    [anon_sym_BSLASHglsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6178),
    [anon_sym_BSLASHglsname] = ACTIONS(6178),
    [anon_sym_BSLASHGlsname] = ACTIONS(6178),
    [anon_sym_BSLASHGLSname] = ACTIONS(6178),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6178),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6178),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6178),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6178),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6178),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6178),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6178),
    [anon_sym_BSLASHacrshort] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6178),
    [anon_sym_BSLASHACRshort] = ACTIONS(6178),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrlong] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6178),
    [anon_sym_BSLASHACRlong] = ACTIONS(6178),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6178),
    [anon_sym_BSLASHacrfull] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6178),
    [anon_sym_BSLASHACRfull] = ACTIONS(6178),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHacs] = ACTIONS(6178),
    [anon_sym_BSLASHAcs] = ACTIONS(6178),
    [anon_sym_BSLASHacsp] = ACTIONS(6178),
    [anon_sym_BSLASHAcsp] = ACTIONS(6178),
    [anon_sym_BSLASHacl] = ACTIONS(6178),
    [anon_sym_BSLASHAcl] = ACTIONS(6178),
    [anon_sym_BSLASHaclp] = ACTIONS(6178),
    [anon_sym_BSLASHAclp] = ACTIONS(6178),
    [anon_sym_BSLASHacf] = ACTIONS(6178),
    [anon_sym_BSLASHAcf] = ACTIONS(6178),
    [anon_sym_BSLASHacfp] = ACTIONS(6178),
    [anon_sym_BSLASHAcfp] = ACTIONS(6178),
    [anon_sym_BSLASHac] = ACTIONS(6178),
    [anon_sym_BSLASHAc] = ACTIONS(6178),
    [anon_sym_BSLASHacp] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6178),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6178),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6178),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6178),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6180),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6178),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6178),
    [anon_sym_BSLASHcolor] = ACTIONS(6178),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6178),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6178),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6178),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6178),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6178),
    [anon_sym_BSLASHtext] = ACTIONS(6178),
    [anon_sym_BSLASHintertext] = ACTIONS(6178),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6178),
    [anon_sym_BSLASHurl] = ACTIONS(6178),
    [anon_sym_BSLASHhref] = ACTIONS(6178),
  },
  [1390] = {
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_LBRACK] = ACTIONS(6560),
    [anon_sym_RBRACK] = ACTIONS(6560),
    [anon_sym_COMMA] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHpart] = ACTIONS(6558),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddpart] = ACTIONS(6558),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHchapter] = ACTIONS(6558),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddchap] = ACTIONS(6558),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsection] = ACTIONS(6558),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHaddsec] = ACTIONS(6558),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6558),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6558),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHitem] = ACTIONS(6558),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6560),
    [anon_sym_LBRACE] = ACTIONS(6560),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6560),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(6558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6560),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHbegin] = ACTIONS(6558),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHleft] = ACTIONS(6558),
    [anon_sym_BSLASHbigl] = ACTIONS(6558),
    [anon_sym_BSLASHBigl] = ACTIONS(6558),
    [anon_sym_BSLASHbiggl] = ACTIONS(6558),
    [anon_sym_BSLASHBiggl] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHtext] = ACTIONS(6558),
    [anon_sym_BSLASHintertext] = ACTIONS(6558),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [1391] = {
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(6578),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6578),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_LPAREN] = ACTIONS(6578),
    [anon_sym_RPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHpart] = ACTIONS(6576),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddpart] = ACTIONS(6576),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHchapter] = ACTIONS(6576),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddchap] = ACTIONS(6576),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsection] = ACTIONS(6576),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHaddsec] = ACTIONS(6576),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6576),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6576),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHitem] = ACTIONS(6576),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6578),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6578),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHbegin] = ACTIONS(6576),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHleft] = ACTIONS(6576),
    [anon_sym_BSLASHbigl] = ACTIONS(6576),
    [anon_sym_BSLASHBigl] = ACTIONS(6576),
    [anon_sym_BSLASHbiggl] = ACTIONS(6576),
    [anon_sym_BSLASHBiggl] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHtext] = ACTIONS(6576),
    [anon_sym_BSLASHintertext] = ACTIONS(6576),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [1392] = {
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHpart] = ACTIONS(6586),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddpart] = ACTIONS(6586),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHchapter] = ACTIONS(6586),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddchap] = ACTIONS(6586),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsection] = ACTIONS(6586),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHaddsec] = ACTIONS(6586),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6586),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6586),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHitem] = ACTIONS(6586),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6588),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6588),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6588),
    [anon_sym_BSLASH_RPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHbegin] = ACTIONS(6586),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHleft] = ACTIONS(6586),
    [anon_sym_BSLASHbigl] = ACTIONS(6586),
    [anon_sym_BSLASHBigl] = ACTIONS(6586),
    [anon_sym_BSLASHbiggl] = ACTIONS(6586),
    [anon_sym_BSLASHBiggl] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHtext] = ACTIONS(6586),
    [anon_sym_BSLASHintertext] = ACTIONS(6586),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [1393] = {
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHpart] = ACTIONS(6298),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddpart] = ACTIONS(6298),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHchapter] = ACTIONS(6298),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddchap] = ACTIONS(6298),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsection] = ACTIONS(6298),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHaddsec] = ACTIONS(6298),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6298),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6298),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHitem] = ACTIONS(6298),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6300),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6300),
    [anon_sym_DOLLAR] = ACTIONS(6298),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHbegin] = ACTIONS(6298),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHleft] = ACTIONS(6298),
    [anon_sym_BSLASHbigl] = ACTIONS(6298),
    [anon_sym_BSLASHBigl] = ACTIONS(6298),
    [anon_sym_BSLASHbiggl] = ACTIONS(6298),
    [anon_sym_BSLASHBiggl] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHtext] = ACTIONS(6298),
    [anon_sym_BSLASHintertext] = ACTIONS(6298),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [1394] = {
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_LPAREN] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHpart] = ACTIONS(6302),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddpart] = ACTIONS(6302),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHchapter] = ACTIONS(6302),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddchap] = ACTIONS(6302),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsection] = ACTIONS(6302),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHaddsec] = ACTIONS(6302),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6302),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6302),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHitem] = ACTIONS(6302),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6304),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6304),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6304),
    [anon_sym_DOLLAR] = ACTIONS(6302),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHbegin] = ACTIONS(6302),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHleft] = ACTIONS(6302),
    [anon_sym_BSLASHbigl] = ACTIONS(6302),
    [anon_sym_BSLASHBigl] = ACTIONS(6302),
    [anon_sym_BSLASHbiggl] = ACTIONS(6302),
    [anon_sym_BSLASHBiggl] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHtext] = ACTIONS(6302),
    [anon_sym_BSLASHintertext] = ACTIONS(6302),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [1395] = {
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6308),
    [anon_sym_RBRACK] = ACTIONS(6308),
    [anon_sym_COMMA] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(6308),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_RPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHpart] = ACTIONS(6306),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddpart] = ACTIONS(6306),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHchapter] = ACTIONS(6306),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddchap] = ACTIONS(6306),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsection] = ACTIONS(6306),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHaddsec] = ACTIONS(6306),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6306),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6306),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHitem] = ACTIONS(6306),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6308),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6308),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6308),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6308),
    [anon_sym_DOLLAR] = ACTIONS(6306),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHbegin] = ACTIONS(6306),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHleft] = ACTIONS(6306),
    [anon_sym_BSLASHbigl] = ACTIONS(6306),
    [anon_sym_BSLASHBigl] = ACTIONS(6306),
    [anon_sym_BSLASHbiggl] = ACTIONS(6306),
    [anon_sym_BSLASHBiggl] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHtext] = ACTIONS(6306),
    [anon_sym_BSLASHintertext] = ACTIONS(6306),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [1396] = {
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_RBRACK] = ACTIONS(6340),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_EQ] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHpart] = ACTIONS(6338),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddpart] = ACTIONS(6338),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHchapter] = ACTIONS(6338),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddchap] = ACTIONS(6338),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsection] = ACTIONS(6338),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHaddsec] = ACTIONS(6338),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6338),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6338),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHitem] = ACTIONS(6338),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6340),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6340),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6340),
    [anon_sym_DOLLAR] = ACTIONS(6338),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHbegin] = ACTIONS(6338),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHleft] = ACTIONS(6338),
    [anon_sym_BSLASHbigl] = ACTIONS(6338),
    [anon_sym_BSLASHBigl] = ACTIONS(6338),
    [anon_sym_BSLASHbiggl] = ACTIONS(6338),
    [anon_sym_BSLASHBiggl] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHtext] = ACTIONS(6338),
    [anon_sym_BSLASHintertext] = ACTIONS(6338),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [1397] = {
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_RPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHpart] = ACTIONS(6342),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddpart] = ACTIONS(6342),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHchapter] = ACTIONS(6342),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddchap] = ACTIONS(6342),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsection] = ACTIONS(6342),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHaddsec] = ACTIONS(6342),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6342),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6342),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHitem] = ACTIONS(6342),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6344),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6344),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6344),
    [anon_sym_DOLLAR] = ACTIONS(6342),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHbegin] = ACTIONS(6342),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHleft] = ACTIONS(6342),
    [anon_sym_BSLASHbigl] = ACTIONS(6342),
    [anon_sym_BSLASHBigl] = ACTIONS(6342),
    [anon_sym_BSLASHbiggl] = ACTIONS(6342),
    [anon_sym_BSLASHBiggl] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHtext] = ACTIONS(6342),
    [anon_sym_BSLASHintertext] = ACTIONS(6342),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [1398] = {
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_RBRACK] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LPAREN] = ACTIONS(6360),
    [anon_sym_RPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHpart] = ACTIONS(6358),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddpart] = ACTIONS(6358),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHchapter] = ACTIONS(6358),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddchap] = ACTIONS(6358),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsection] = ACTIONS(6358),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHaddsec] = ACTIONS(6358),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6358),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6358),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHitem] = ACTIONS(6358),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(6360),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6360),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6360),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6358),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHbegin] = ACTIONS(6358),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHleft] = ACTIONS(6358),
    [anon_sym_BSLASHbigl] = ACTIONS(6358),
    [anon_sym_BSLASHBigl] = ACTIONS(6358),
    [anon_sym_BSLASHbiggl] = ACTIONS(6358),
    [anon_sym_BSLASHBiggl] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHtext] = ACTIONS(6358),
    [anon_sym_BSLASHintertext] = ACTIONS(6358),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [1399] = {
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_RBRACK] = ACTIONS(6368),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_LPAREN] = ACTIONS(6368),
    [anon_sym_RPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHpart] = ACTIONS(6366),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddpart] = ACTIONS(6366),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHchapter] = ACTIONS(6366),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddchap] = ACTIONS(6366),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsection] = ACTIONS(6366),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHaddsec] = ACTIONS(6366),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6366),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6366),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHitem] = ACTIONS(6366),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6368),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6368),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6368),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6366),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHbegin] = ACTIONS(6366),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHleft] = ACTIONS(6366),
    [anon_sym_BSLASHbigl] = ACTIONS(6366),
    [anon_sym_BSLASHBigl] = ACTIONS(6366),
    [anon_sym_BSLASHbiggl] = ACTIONS(6366),
    [anon_sym_BSLASHBiggl] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHtext] = ACTIONS(6366),
    [anon_sym_BSLASHintertext] = ACTIONS(6366),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [1400] = {
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_RBRACK] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LPAREN] = ACTIONS(6372),
    [anon_sym_RPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHpart] = ACTIONS(6370),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddpart] = ACTIONS(6370),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHchapter] = ACTIONS(6370),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddchap] = ACTIONS(6370),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsection] = ACTIONS(6370),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHaddsec] = ACTIONS(6370),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6370),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6370),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHitem] = ACTIONS(6370),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6372),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6372),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6370),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHbegin] = ACTIONS(6370),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHleft] = ACTIONS(6370),
    [anon_sym_BSLASHbigl] = ACTIONS(6370),
    [anon_sym_BSLASHBigl] = ACTIONS(6370),
    [anon_sym_BSLASHbiggl] = ACTIONS(6370),
    [anon_sym_BSLASHBiggl] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHtext] = ACTIONS(6370),
    [anon_sym_BSLASHintertext] = ACTIONS(6370),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [1401] = {
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6460),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_COMMA] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_LPAREN] = ACTIONS(6460),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHpart] = ACTIONS(6458),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddpart] = ACTIONS(6458),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHchapter] = ACTIONS(6458),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddchap] = ACTIONS(6458),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsection] = ACTIONS(6458),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHaddsec] = ACTIONS(6458),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6458),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6458),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHitem] = ACTIONS(6458),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6460),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6460),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6460),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6460),
    [anon_sym_DOLLAR] = ACTIONS(6458),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHbegin] = ACTIONS(6458),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHleft] = ACTIONS(6458),
    [anon_sym_BSLASHbigl] = ACTIONS(6458),
    [anon_sym_BSLASHBigl] = ACTIONS(6458),
    [anon_sym_BSLASHbiggl] = ACTIONS(6458),
    [anon_sym_BSLASHBiggl] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHtext] = ACTIONS(6458),
    [anon_sym_BSLASHintertext] = ACTIONS(6458),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [1402] = {
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6240),
    [anon_sym_RBRACK] = ACTIONS(6240),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_LPAREN] = ACTIONS(6240),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHpart] = ACTIONS(6238),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddpart] = ACTIONS(6238),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHchapter] = ACTIONS(6238),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddchap] = ACTIONS(6238),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsection] = ACTIONS(6238),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHaddsec] = ACTIONS(6238),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6238),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6238),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHitem] = ACTIONS(6238),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(6240),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6240),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6240),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6240),
    [anon_sym_DOLLAR] = ACTIONS(6238),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHbegin] = ACTIONS(6238),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHleft] = ACTIONS(6238),
    [anon_sym_BSLASHbigl] = ACTIONS(6238),
    [anon_sym_BSLASHBigl] = ACTIONS(6238),
    [anon_sym_BSLASHbiggl] = ACTIONS(6238),
    [anon_sym_BSLASHBiggl] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHtext] = ACTIONS(6238),
    [anon_sym_BSLASHintertext] = ACTIONS(6238),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [1403] = {
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_LPAREN] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHpart] = ACTIONS(6234),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddpart] = ACTIONS(6234),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHchapter] = ACTIONS(6234),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddchap] = ACTIONS(6234),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsection] = ACTIONS(6234),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHaddsec] = ACTIONS(6234),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6234),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6234),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHitem] = ACTIONS(6234),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6236),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6236),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(6234),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHbegin] = ACTIONS(6234),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHleft] = ACTIONS(6234),
    [anon_sym_BSLASHbigl] = ACTIONS(6234),
    [anon_sym_BSLASHBigl] = ACTIONS(6234),
    [anon_sym_BSLASHbiggl] = ACTIONS(6234),
    [anon_sym_BSLASHBiggl] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHtext] = ACTIONS(6234),
    [anon_sym_BSLASHintertext] = ACTIONS(6234),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [1404] = {
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_BSLASHpart] = ACTIONS(165),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddpart] = ACTIONS(165),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(167),
    [anon_sym_BSLASHchapter] = ACTIONS(165),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddchap] = ACTIONS(165),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsection] = ACTIONS(165),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHaddsec] = ACTIONS(165),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(165),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(167),
    [anon_sym_BSLASHparagraph] = ACTIONS(165),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(165),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(167),
    [anon_sym_BSLASHitem] = ACTIONS(165),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [1405] = {
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6228),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_LPAREN] = ACTIONS(6228),
    [anon_sym_RPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHpart] = ACTIONS(6226),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddpart] = ACTIONS(6226),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHchapter] = ACTIONS(6226),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddchap] = ACTIONS(6226),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsection] = ACTIONS(6226),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHaddsec] = ACTIONS(6226),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6226),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6226),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHitem] = ACTIONS(6226),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(6228),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6228),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6228),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(6226),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHbegin] = ACTIONS(6226),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHleft] = ACTIONS(6226),
    [anon_sym_BSLASHbigl] = ACTIONS(6226),
    [anon_sym_BSLASHBigl] = ACTIONS(6226),
    [anon_sym_BSLASHbiggl] = ACTIONS(6226),
    [anon_sym_BSLASHBiggl] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHtext] = ACTIONS(6226),
    [anon_sym_BSLASHintertext] = ACTIONS(6226),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [1406] = {
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6224),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_LPAREN] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHpart] = ACTIONS(6222),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddpart] = ACTIONS(6222),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHchapter] = ACTIONS(6222),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddchap] = ACTIONS(6222),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsection] = ACTIONS(6222),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHaddsec] = ACTIONS(6222),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6222),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6222),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHitem] = ACTIONS(6222),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6224),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6224),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6224),
    [anon_sym_DOLLAR] = ACTIONS(6222),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHbegin] = ACTIONS(6222),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHleft] = ACTIONS(6222),
    [anon_sym_BSLASHbigl] = ACTIONS(6222),
    [anon_sym_BSLASHBigl] = ACTIONS(6222),
    [anon_sym_BSLASHbiggl] = ACTIONS(6222),
    [anon_sym_BSLASHBiggl] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHtext] = ACTIONS(6222),
    [anon_sym_BSLASHintertext] = ACTIONS(6222),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [1407] = {
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6220),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHpart] = ACTIONS(6218),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddpart] = ACTIONS(6218),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHchapter] = ACTIONS(6218),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddchap] = ACTIONS(6218),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsection] = ACTIONS(6218),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHaddsec] = ACTIONS(6218),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6218),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6218),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHitem] = ACTIONS(6218),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6220),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6220),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6220),
    [anon_sym_DOLLAR] = ACTIONS(6218),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHbegin] = ACTIONS(6218),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHleft] = ACTIONS(6218),
    [anon_sym_BSLASHbigl] = ACTIONS(6218),
    [anon_sym_BSLASHBigl] = ACTIONS(6218),
    [anon_sym_BSLASHbiggl] = ACTIONS(6218),
    [anon_sym_BSLASHBiggl] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHtext] = ACTIONS(6218),
    [anon_sym_BSLASHintertext] = ACTIONS(6218),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [1408] = {
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_EQ] = ACTIONS(6216),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [anon_sym_RPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHpart] = ACTIONS(6214),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddpart] = ACTIONS(6214),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHchapter] = ACTIONS(6214),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddchap] = ACTIONS(6214),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsection] = ACTIONS(6214),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHaddsec] = ACTIONS(6214),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6214),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6214),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHitem] = ACTIONS(6214),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6216),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6216),
    [anon_sym_DOLLAR] = ACTIONS(6214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHbegin] = ACTIONS(6214),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHleft] = ACTIONS(6214),
    [anon_sym_BSLASHbigl] = ACTIONS(6214),
    [anon_sym_BSLASHBigl] = ACTIONS(6214),
    [anon_sym_BSLASHbiggl] = ACTIONS(6214),
    [anon_sym_BSLASHBiggl] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHtext] = ACTIONS(6214),
    [anon_sym_BSLASHintertext] = ACTIONS(6214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [1409] = {
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [anon_sym_RPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHpart] = ACTIONS(6198),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddpart] = ACTIONS(6198),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHchapter] = ACTIONS(6198),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddchap] = ACTIONS(6198),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsection] = ACTIONS(6198),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHaddsec] = ACTIONS(6198),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6198),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6198),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHitem] = ACTIONS(6198),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6200),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6200),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6200),
    [anon_sym_DOLLAR] = ACTIONS(6198),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHbegin] = ACTIONS(6198),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHleft] = ACTIONS(6198),
    [anon_sym_BSLASHbigl] = ACTIONS(6198),
    [anon_sym_BSLASHBigl] = ACTIONS(6198),
    [anon_sym_BSLASHbiggl] = ACTIONS(6198),
    [anon_sym_BSLASHBiggl] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHtext] = ACTIONS(6198),
    [anon_sym_BSLASHintertext] = ACTIONS(6198),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [1410] = {
    [sym_command_name] = ACTIONS(6490),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6490),
    [anon_sym_LBRACK] = ACTIONS(6492),
    [anon_sym_RBRACK] = ACTIONS(6492),
    [anon_sym_COMMA] = ACTIONS(6492),
    [anon_sym_EQ] = ACTIONS(6492),
    [anon_sym_LPAREN] = ACTIONS(6492),
    [anon_sym_RPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHpart] = ACTIONS(6490),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddpart] = ACTIONS(6490),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHchapter] = ACTIONS(6490),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddchap] = ACTIONS(6490),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsection] = ACTIONS(6490),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHaddsec] = ACTIONS(6490),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6490),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6490),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHitem] = ACTIONS(6490),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6492),
    [anon_sym_LBRACE] = ACTIONS(6492),
    [sym_word] = ACTIONS(6490),
    [sym_placeholder] = ACTIONS(6492),
    [anon_sym_PLUS] = ACTIONS(6492),
    [anon_sym_DASH] = ACTIONS(6492),
    [anon_sym_STAR] = ACTIONS(6492),
    [anon_sym_SLASH] = ACTIONS(6492),
    [anon_sym_LT] = ACTIONS(6490),
    [anon_sym_GT] = ACTIONS(6490),
    [anon_sym_BANG] = ACTIONS(6490),
    [anon_sym_PIPE] = ACTIONS(6490),
    [anon_sym_COLON] = ACTIONS(6490),
    [anon_sym_SQUOTE] = ACTIONS(6490),
    [anon_sym__] = ACTIONS(6492),
    [anon_sym_CARET] = ACTIONS(6492),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6492),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6492),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6492),
    [anon_sym_DOLLAR] = ACTIONS(6490),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6492),
    [anon_sym_BSLASHbegin] = ACTIONS(6490),
    [anon_sym_BSLASHtitle] = ACTIONS(6490),
    [anon_sym_BSLASHauthor] = ACTIONS(6490),
    [anon_sym_BSLASHusepackage] = ACTIONS(6490),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6490),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6490),
    [anon_sym_BSLASHinclude] = ACTIONS(6490),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6490),
    [anon_sym_BSLASHinput] = ACTIONS(6490),
    [anon_sym_BSLASHsubfile] = ACTIONS(6490),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6490),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6490),
    [anon_sym_BSLASHbibliography] = ACTIONS(6490),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6490),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6490),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6490),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6490),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6490),
    [anon_sym_BSLASHimport] = ACTIONS(6490),
    [anon_sym_BSLASHsubimport] = ACTIONS(6490),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6490),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6490),
    [anon_sym_BSLASHcaption] = ACTIONS(6490),
    [anon_sym_BSLASHcite] = ACTIONS(6490),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCite] = ACTIONS(6490),
    [anon_sym_BSLASHnocite] = ACTIONS(6490),
    [anon_sym_BSLASHcitet] = ACTIONS(6490),
    [anon_sym_BSLASHcitep] = ACTIONS(6490),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteA] = ACTIONS(6490),
    [anon_sym_BSLASHciteR] = ACTIONS(6490),
    [anon_sym_BSLASHciteS] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6490),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6490),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteyear] = ACTIONS(6490),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHcitedate] = ACTIONS(6490),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHciteurl] = ACTIONS(6490),
    [anon_sym_BSLASHfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6490),
    [anon_sym_BSLASHcitealt] = ACTIONS(6490),
    [anon_sym_BSLASHcitealp] = ACTIONS(6490),
    [anon_sym_BSLASHcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHparencite] = ACTIONS(6490),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHParencite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6490),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6490),
    [anon_sym_BSLASHtextcite] = ACTIONS(6490),
    [anon_sym_BSLASHTextcite] = ACTIONS(6490),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6490),
    [anon_sym_BSLASHsupercite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite] = ACTIONS(6490),
    [anon_sym_BSLASHAutocite] = ACTIONS(6490),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHVolcite] = ACTIONS(6490),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHavolcite] = ACTIONS(6490),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6490),
    [anon_sym_BSLASHnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHNotecite] = ACTIONS(6490),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6490),
    [anon_sym_BSLASHlabel] = ACTIONS(6490),
    [anon_sym_BSLASHref] = ACTIONS(6490),
    [anon_sym_BSLASHeqref] = ACTIONS(6490),
    [anon_sym_BSLASHvref] = ACTIONS(6490),
    [anon_sym_BSLASHVref] = ACTIONS(6490),
    [anon_sym_BSLASHautoref] = ACTIONS(6490),
    [anon_sym_BSLASHpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcref] = ACTIONS(6490),
    [anon_sym_BSLASHCref] = ACTIONS(6490),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnameCref] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6490),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6490),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6490),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6490),
    [anon_sym_BSLASHdef] = ACTIONS(6490),
    [anon_sym_BSLASHlet] = ACTIONS(6490),
    [anon_sym_BSLASHleft] = ACTIONS(6490),
    [anon_sym_BSLASHbigl] = ACTIONS(6490),
    [anon_sym_BSLASHBigl] = ACTIONS(6490),
    [anon_sym_BSLASHbiggl] = ACTIONS(6490),
    [anon_sym_BSLASHBiggl] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6490),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6490),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6490),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6490),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6490),
    [anon_sym_BSLASHgls] = ACTIONS(6490),
    [anon_sym_BSLASHGls] = ACTIONS(6490),
    [anon_sym_BSLASHGLS] = ACTIONS(6490),
    [anon_sym_BSLASHglspl] = ACTIONS(6490),
    [anon_sym_BSLASHGlspl] = ACTIONS(6490),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6490),
    [anon_sym_BSLASHglslink] = ACTIONS(6490),
    [anon_sym_BSLASHglstext] = ACTIONS(6490),
    [anon_sym_BSLASHGlstext] = ACTIONS(6490),
    [anon_sym_BSLASHGLStext] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6490),
    [anon_sym_BSLASHglsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6490),
    [anon_sym_BSLASHglsname] = ACTIONS(6490),
    [anon_sym_BSLASHGlsname] = ACTIONS(6490),
    [anon_sym_BSLASHGLSname] = ACTIONS(6490),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6490),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6490),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6490),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6490),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6490),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6490),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6490),
    [anon_sym_BSLASHacrshort] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6490),
    [anon_sym_BSLASHACRshort] = ACTIONS(6490),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrlong] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6490),
    [anon_sym_BSLASHACRlong] = ACTIONS(6490),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6490),
    [anon_sym_BSLASHacrfull] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6490),
    [anon_sym_BSLASHACRfull] = ACTIONS(6490),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHacs] = ACTIONS(6490),
    [anon_sym_BSLASHAcs] = ACTIONS(6490),
    [anon_sym_BSLASHacsp] = ACTIONS(6490),
    [anon_sym_BSLASHAcsp] = ACTIONS(6490),
    [anon_sym_BSLASHacl] = ACTIONS(6490),
    [anon_sym_BSLASHAcl] = ACTIONS(6490),
    [anon_sym_BSLASHaclp] = ACTIONS(6490),
    [anon_sym_BSLASHAclp] = ACTIONS(6490),
    [anon_sym_BSLASHacf] = ACTIONS(6490),
    [anon_sym_BSLASHAcf] = ACTIONS(6490),
    [anon_sym_BSLASHacfp] = ACTIONS(6490),
    [anon_sym_BSLASHAcfp] = ACTIONS(6490),
    [anon_sym_BSLASHac] = ACTIONS(6490),
    [anon_sym_BSLASHAc] = ACTIONS(6490),
    [anon_sym_BSLASHacp] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6490),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6490),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6490),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6490),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6492),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6490),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6490),
    [anon_sym_BSLASHcolor] = ACTIONS(6490),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6490),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6490),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6490),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6490),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6490),
    [anon_sym_BSLASHtext] = ACTIONS(6490),
    [anon_sym_BSLASHintertext] = ACTIONS(6490),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6490),
    [anon_sym_BSLASHurl] = ACTIONS(6490),
    [anon_sym_BSLASHhref] = ACTIONS(6490),
  },
  [1411] = {
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6232),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6232),
    [anon_sym_LPAREN] = ACTIONS(6232),
    [anon_sym_RPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHpart] = ACTIONS(6230),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddpart] = ACTIONS(6230),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHchapter] = ACTIONS(6230),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddchap] = ACTIONS(6230),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsection] = ACTIONS(6230),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHaddsec] = ACTIONS(6230),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6230),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6230),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHitem] = ACTIONS(6230),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6232),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6232),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6232),
    [anon_sym_DOLLAR] = ACTIONS(6230),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHbegin] = ACTIONS(6230),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHleft] = ACTIONS(6230),
    [anon_sym_BSLASHbigl] = ACTIONS(6230),
    [anon_sym_BSLASHBigl] = ACTIONS(6230),
    [anon_sym_BSLASHbiggl] = ACTIONS(6230),
    [anon_sym_BSLASHBiggl] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHtext] = ACTIONS(6230),
    [anon_sym_BSLASHintertext] = ACTIONS(6230),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [1412] = {
    [sym_command_name] = ACTIONS(6722),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6722),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_RBRACK] = ACTIONS(6724),
    [anon_sym_COMMA] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6724),
    [anon_sym_LPAREN] = ACTIONS(6724),
    [anon_sym_RPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHpart] = ACTIONS(6722),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddpart] = ACTIONS(6722),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHchapter] = ACTIONS(6722),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddchap] = ACTIONS(6722),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsection] = ACTIONS(6722),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHaddsec] = ACTIONS(6722),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6722),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6722),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHitem] = ACTIONS(6722),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(6724),
    [sym_word] = ACTIONS(6722),
    [sym_placeholder] = ACTIONS(6724),
    [anon_sym_PLUS] = ACTIONS(6724),
    [anon_sym_DASH] = ACTIONS(6724),
    [anon_sym_STAR] = ACTIONS(6724),
    [anon_sym_SLASH] = ACTIONS(6724),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_BANG] = ACTIONS(6722),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_COLON] = ACTIONS(6722),
    [anon_sym_SQUOTE] = ACTIONS(6722),
    [anon_sym__] = ACTIONS(6724),
    [anon_sym_CARET] = ACTIONS(6724),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6724),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6724),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6724),
    [anon_sym_DOLLAR] = ACTIONS(6722),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHbegin] = ACTIONS(6722),
    [anon_sym_BSLASHtitle] = ACTIONS(6722),
    [anon_sym_BSLASHauthor] = ACTIONS(6722),
    [anon_sym_BSLASHusepackage] = ACTIONS(6722),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6722),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6722),
    [anon_sym_BSLASHinclude] = ACTIONS(6722),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6722),
    [anon_sym_BSLASHinput] = ACTIONS(6722),
    [anon_sym_BSLASHsubfile] = ACTIONS(6722),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6722),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6722),
    [anon_sym_BSLASHbibliography] = ACTIONS(6722),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6722),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6722),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6722),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6722),
    [anon_sym_BSLASHimport] = ACTIONS(6722),
    [anon_sym_BSLASHsubimport] = ACTIONS(6722),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6722),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHcaption] = ACTIONS(6722),
    [anon_sym_BSLASHcite] = ACTIONS(6722),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCite] = ACTIONS(6722),
    [anon_sym_BSLASHnocite] = ACTIONS(6722),
    [anon_sym_BSLASHcitet] = ACTIONS(6722),
    [anon_sym_BSLASHcitep] = ACTIONS(6722),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteA] = ACTIONS(6722),
    [anon_sym_BSLASHciteR] = ACTIONS(6722),
    [anon_sym_BSLASHciteS] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6722),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteyear] = ACTIONS(6722),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitedate] = ACTIONS(6722),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteurl] = ACTIONS(6722),
    [anon_sym_BSLASHfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6722),
    [anon_sym_BSLASHcitealt] = ACTIONS(6722),
    [anon_sym_BSLASHcitealp] = ACTIONS(6722),
    [anon_sym_BSLASHcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHparencite] = ACTIONS(6722),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHParencite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHtextcite] = ACTIONS(6722),
    [anon_sym_BSLASHTextcite] = ACTIONS(6722),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHsupercite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite] = ACTIONS(6722),
    [anon_sym_BSLASHAutocite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHVolcite] = ACTIONS(6722),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHavolcite] = ACTIONS(6722),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHNotecite] = ACTIONS(6722),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHlabel] = ACTIONS(6722),
    [anon_sym_BSLASHref] = ACTIONS(6722),
    [anon_sym_BSLASHeqref] = ACTIONS(6722),
    [anon_sym_BSLASHvref] = ACTIONS(6722),
    [anon_sym_BSLASHVref] = ACTIONS(6722),
    [anon_sym_BSLASHautoref] = ACTIONS(6722),
    [anon_sym_BSLASHpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcref] = ACTIONS(6722),
    [anon_sym_BSLASHCref] = ACTIONS(6722),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnameCref] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHdef] = ACTIONS(6722),
    [anon_sym_BSLASHlet] = ACTIONS(6722),
    [anon_sym_BSLASHleft] = ACTIONS(6722),
    [anon_sym_BSLASHbigl] = ACTIONS(6722),
    [anon_sym_BSLASHBigl] = ACTIONS(6722),
    [anon_sym_BSLASHbiggl] = ACTIONS(6722),
    [anon_sym_BSLASHBiggl] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6722),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6722),
    [anon_sym_BSLASHgls] = ACTIONS(6722),
    [anon_sym_BSLASHGls] = ACTIONS(6722),
    [anon_sym_BSLASHGLS] = ACTIONS(6722),
    [anon_sym_BSLASHglspl] = ACTIONS(6722),
    [anon_sym_BSLASHGlspl] = ACTIONS(6722),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6722),
    [anon_sym_BSLASHglslink] = ACTIONS(6722),
    [anon_sym_BSLASHglstext] = ACTIONS(6722),
    [anon_sym_BSLASHGlstext] = ACTIONS(6722),
    [anon_sym_BSLASHGLStext] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6722),
    [anon_sym_BSLASHglsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsname] = ACTIONS(6722),
    [anon_sym_BSLASHGlsname] = ACTIONS(6722),
    [anon_sym_BSLASHGLSname] = ACTIONS(6722),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6722),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6722),
    [anon_sym_BSLASHacrshort] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6722),
    [anon_sym_BSLASHACRshort] = ACTIONS(6722),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrlong] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6722),
    [anon_sym_BSLASHACRlong] = ACTIONS(6722),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrfull] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6722),
    [anon_sym_BSLASHACRfull] = ACTIONS(6722),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHacs] = ACTIONS(6722),
    [anon_sym_BSLASHAcs] = ACTIONS(6722),
    [anon_sym_BSLASHacsp] = ACTIONS(6722),
    [anon_sym_BSLASHAcsp] = ACTIONS(6722),
    [anon_sym_BSLASHacl] = ACTIONS(6722),
    [anon_sym_BSLASHAcl] = ACTIONS(6722),
    [anon_sym_BSLASHaclp] = ACTIONS(6722),
    [anon_sym_BSLASHAclp] = ACTIONS(6722),
    [anon_sym_BSLASHacf] = ACTIONS(6722),
    [anon_sym_BSLASHAcf] = ACTIONS(6722),
    [anon_sym_BSLASHacfp] = ACTIONS(6722),
    [anon_sym_BSLASHAcfp] = ACTIONS(6722),
    [anon_sym_BSLASHac] = ACTIONS(6722),
    [anon_sym_BSLASHAc] = ACTIONS(6722),
    [anon_sym_BSLASHacp] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6722),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6722),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6722),
    [anon_sym_BSLASHcolor] = ACTIONS(6722),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6722),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6722),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6722),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6722),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6722),
    [anon_sym_BSLASHtext] = ACTIONS(6722),
    [anon_sym_BSLASHintertext] = ACTIONS(6722),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6722),
    [anon_sym_BSLASHurl] = ACTIONS(6722),
    [anon_sym_BSLASHhref] = ACTIONS(6722),
  },
  [1413] = {
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_LBRACK] = ACTIONS(6512),
    [anon_sym_RBRACK] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHpart] = ACTIONS(6510),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddpart] = ACTIONS(6510),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHchapter] = ACTIONS(6510),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddchap] = ACTIONS(6510),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsection] = ACTIONS(6510),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHaddsec] = ACTIONS(6510),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6510),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6510),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHitem] = ACTIONS(6510),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6512),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6512),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6512),
    [anon_sym_DOLLAR] = ACTIONS(6510),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHbegin] = ACTIONS(6510),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHleft] = ACTIONS(6510),
    [anon_sym_BSLASHbigl] = ACTIONS(6510),
    [anon_sym_BSLASHBigl] = ACTIONS(6510),
    [anon_sym_BSLASHbiggl] = ACTIONS(6510),
    [anon_sym_BSLASHBiggl] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHtext] = ACTIONS(6510),
    [anon_sym_BSLASHintertext] = ACTIONS(6510),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [1414] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2443),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7095),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1415] = {
    [sym_command_name] = ACTIONS(6622),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6622),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_RBRACK] = ACTIONS(6624),
    [anon_sym_COMMA] = ACTIONS(6624),
    [anon_sym_EQ] = ACTIONS(6624),
    [anon_sym_LPAREN] = ACTIONS(6624),
    [anon_sym_RPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHpart] = ACTIONS(6622),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddpart] = ACTIONS(6622),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHchapter] = ACTIONS(6622),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddchap] = ACTIONS(6622),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsection] = ACTIONS(6622),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHaddsec] = ACTIONS(6622),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6622),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6622),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHitem] = ACTIONS(6622),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(6624),
    [sym_word] = ACTIONS(6622),
    [sym_placeholder] = ACTIONS(6624),
    [anon_sym_PLUS] = ACTIONS(6624),
    [anon_sym_DASH] = ACTIONS(6624),
    [anon_sym_STAR] = ACTIONS(6624),
    [anon_sym_SLASH] = ACTIONS(6624),
    [anon_sym_LT] = ACTIONS(6622),
    [anon_sym_GT] = ACTIONS(6622),
    [anon_sym_BANG] = ACTIONS(6622),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_COLON] = ACTIONS(6622),
    [anon_sym_SQUOTE] = ACTIONS(6622),
    [anon_sym__] = ACTIONS(6624),
    [anon_sym_CARET] = ACTIONS(6624),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6624),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6624),
    [anon_sym_DOLLAR] = ACTIONS(6622),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHbegin] = ACTIONS(6622),
    [anon_sym_BSLASHend] = ACTIONS(6622),
    [anon_sym_BSLASHtitle] = ACTIONS(6622),
    [anon_sym_BSLASHauthor] = ACTIONS(6622),
    [anon_sym_BSLASHusepackage] = ACTIONS(6622),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6622),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6622),
    [anon_sym_BSLASHinclude] = ACTIONS(6622),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6622),
    [anon_sym_BSLASHinput] = ACTIONS(6622),
    [anon_sym_BSLASHsubfile] = ACTIONS(6622),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6622),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6622),
    [anon_sym_BSLASHbibliography] = ACTIONS(6622),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6622),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6622),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6622),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6622),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6622),
    [anon_sym_BSLASHimport] = ACTIONS(6622),
    [anon_sym_BSLASHsubimport] = ACTIONS(6622),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6622),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHcaption] = ACTIONS(6622),
    [anon_sym_BSLASHcite] = ACTIONS(6622),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCite] = ACTIONS(6622),
    [anon_sym_BSLASHnocite] = ACTIONS(6622),
    [anon_sym_BSLASHcitet] = ACTIONS(6622),
    [anon_sym_BSLASHcitep] = ACTIONS(6622),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteA] = ACTIONS(6622),
    [anon_sym_BSLASHciteR] = ACTIONS(6622),
    [anon_sym_BSLASHciteS] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6622),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteyear] = ACTIONS(6622),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitedate] = ACTIONS(6622),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteurl] = ACTIONS(6622),
    [anon_sym_BSLASHfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6622),
    [anon_sym_BSLASHcitealt] = ACTIONS(6622),
    [anon_sym_BSLASHcitealp] = ACTIONS(6622),
    [anon_sym_BSLASHcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHparencite] = ACTIONS(6622),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHParencite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHtextcite] = ACTIONS(6622),
    [anon_sym_BSLASHTextcite] = ACTIONS(6622),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHsupercite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite] = ACTIONS(6622),
    [anon_sym_BSLASHAutocite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHVolcite] = ACTIONS(6622),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHavolcite] = ACTIONS(6622),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHNotecite] = ACTIONS(6622),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHlabel] = ACTIONS(6622),
    [anon_sym_BSLASHref] = ACTIONS(6622),
    [anon_sym_BSLASHeqref] = ACTIONS(6622),
    [anon_sym_BSLASHvref] = ACTIONS(6622),
    [anon_sym_BSLASHVref] = ACTIONS(6622),
    [anon_sym_BSLASHautoref] = ACTIONS(6622),
    [anon_sym_BSLASHpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcref] = ACTIONS(6622),
    [anon_sym_BSLASHCref] = ACTIONS(6622),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnameCref] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHdef] = ACTIONS(6622),
    [anon_sym_BSLASHlet] = ACTIONS(6622),
    [anon_sym_BSLASHleft] = ACTIONS(6622),
    [anon_sym_BSLASHbigl] = ACTIONS(6622),
    [anon_sym_BSLASHBigl] = ACTIONS(6622),
    [anon_sym_BSLASHbiggl] = ACTIONS(6622),
    [anon_sym_BSLASHBiggl] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6622),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6622),
    [anon_sym_BSLASHgls] = ACTIONS(6622),
    [anon_sym_BSLASHGls] = ACTIONS(6622),
    [anon_sym_BSLASHGLS] = ACTIONS(6622),
    [anon_sym_BSLASHglspl] = ACTIONS(6622),
    [anon_sym_BSLASHGlspl] = ACTIONS(6622),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6622),
    [anon_sym_BSLASHglslink] = ACTIONS(6622),
    [anon_sym_BSLASHglstext] = ACTIONS(6622),
    [anon_sym_BSLASHGlstext] = ACTIONS(6622),
    [anon_sym_BSLASHGLStext] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6622),
    [anon_sym_BSLASHglsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsname] = ACTIONS(6622),
    [anon_sym_BSLASHGlsname] = ACTIONS(6622),
    [anon_sym_BSLASHGLSname] = ACTIONS(6622),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6622),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6622),
    [anon_sym_BSLASHacrshort] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6622),
    [anon_sym_BSLASHACRshort] = ACTIONS(6622),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrlong] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6622),
    [anon_sym_BSLASHACRlong] = ACTIONS(6622),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrfull] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6622),
    [anon_sym_BSLASHACRfull] = ACTIONS(6622),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHacs] = ACTIONS(6622),
    [anon_sym_BSLASHAcs] = ACTIONS(6622),
    [anon_sym_BSLASHacsp] = ACTIONS(6622),
    [anon_sym_BSLASHAcsp] = ACTIONS(6622),
    [anon_sym_BSLASHacl] = ACTIONS(6622),
    [anon_sym_BSLASHAcl] = ACTIONS(6622),
    [anon_sym_BSLASHaclp] = ACTIONS(6622),
    [anon_sym_BSLASHAclp] = ACTIONS(6622),
    [anon_sym_BSLASHacf] = ACTIONS(6622),
    [anon_sym_BSLASHAcf] = ACTIONS(6622),
    [anon_sym_BSLASHacfp] = ACTIONS(6622),
    [anon_sym_BSLASHAcfp] = ACTIONS(6622),
    [anon_sym_BSLASHac] = ACTIONS(6622),
    [anon_sym_BSLASHAc] = ACTIONS(6622),
    [anon_sym_BSLASHacp] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6622),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6622),
    [anon_sym_BSLASHcolor] = ACTIONS(6622),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6622),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6622),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6622),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6622),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6622),
    [anon_sym_BSLASHtext] = ACTIONS(6622),
    [anon_sym_BSLASHintertext] = ACTIONS(6622),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6622),
    [anon_sym_BSLASHurl] = ACTIONS(6622),
    [anon_sym_BSLASHhref] = ACTIONS(6622),
  },
  [1416] = {
    [sym_command_name] = ACTIONS(6618),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(6620),
    [anon_sym_RBRACK] = ACTIONS(6620),
    [anon_sym_COMMA] = ACTIONS(6620),
    [anon_sym_EQ] = ACTIONS(6620),
    [anon_sym_LPAREN] = ACTIONS(6620),
    [anon_sym_RPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHpart] = ACTIONS(6618),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddpart] = ACTIONS(6618),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHchapter] = ACTIONS(6618),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddchap] = ACTIONS(6618),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsection] = ACTIONS(6618),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHaddsec] = ACTIONS(6618),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6618),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6618),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHitem] = ACTIONS(6618),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6620),
    [anon_sym_LBRACE] = ACTIONS(6620),
    [sym_word] = ACTIONS(6618),
    [sym_placeholder] = ACTIONS(6620),
    [anon_sym_PLUS] = ACTIONS(6620),
    [anon_sym_DASH] = ACTIONS(6620),
    [anon_sym_STAR] = ACTIONS(6620),
    [anon_sym_SLASH] = ACTIONS(6620),
    [anon_sym_LT] = ACTIONS(6618),
    [anon_sym_GT] = ACTIONS(6618),
    [anon_sym_BANG] = ACTIONS(6618),
    [anon_sym_PIPE] = ACTIONS(6618),
    [anon_sym_COLON] = ACTIONS(6618),
    [anon_sym_SQUOTE] = ACTIONS(6618),
    [anon_sym__] = ACTIONS(6620),
    [anon_sym_CARET] = ACTIONS(6620),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6620),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6620),
    [anon_sym_DOLLAR] = ACTIONS(6618),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHbegin] = ACTIONS(6618),
    [anon_sym_BSLASHend] = ACTIONS(6618),
    [anon_sym_BSLASHtitle] = ACTIONS(6618),
    [anon_sym_BSLASHauthor] = ACTIONS(6618),
    [anon_sym_BSLASHusepackage] = ACTIONS(6618),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6618),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6618),
    [anon_sym_BSLASHinclude] = ACTIONS(6618),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6618),
    [anon_sym_BSLASHinput] = ACTIONS(6618),
    [anon_sym_BSLASHsubfile] = ACTIONS(6618),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6618),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6618),
    [anon_sym_BSLASHbibliography] = ACTIONS(6618),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6618),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6618),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6618),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6618),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6618),
    [anon_sym_BSLASHimport] = ACTIONS(6618),
    [anon_sym_BSLASHsubimport] = ACTIONS(6618),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6618),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHcaption] = ACTIONS(6618),
    [anon_sym_BSLASHcite] = ACTIONS(6618),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCite] = ACTIONS(6618),
    [anon_sym_BSLASHnocite] = ACTIONS(6618),
    [anon_sym_BSLASHcitet] = ACTIONS(6618),
    [anon_sym_BSLASHcitep] = ACTIONS(6618),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteA] = ACTIONS(6618),
    [anon_sym_BSLASHciteR] = ACTIONS(6618),
    [anon_sym_BSLASHciteS] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6618),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteyear] = ACTIONS(6618),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitedate] = ACTIONS(6618),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteurl] = ACTIONS(6618),
    [anon_sym_BSLASHfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6618),
    [anon_sym_BSLASHcitealt] = ACTIONS(6618),
    [anon_sym_BSLASHcitealp] = ACTIONS(6618),
    [anon_sym_BSLASHcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHparencite] = ACTIONS(6618),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHParencite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHtextcite] = ACTIONS(6618),
    [anon_sym_BSLASHTextcite] = ACTIONS(6618),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHsupercite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite] = ACTIONS(6618),
    [anon_sym_BSLASHAutocite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHVolcite] = ACTIONS(6618),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHavolcite] = ACTIONS(6618),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHNotecite] = ACTIONS(6618),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHlabel] = ACTIONS(6618),
    [anon_sym_BSLASHref] = ACTIONS(6618),
    [anon_sym_BSLASHeqref] = ACTIONS(6618),
    [anon_sym_BSLASHvref] = ACTIONS(6618),
    [anon_sym_BSLASHVref] = ACTIONS(6618),
    [anon_sym_BSLASHautoref] = ACTIONS(6618),
    [anon_sym_BSLASHpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcref] = ACTIONS(6618),
    [anon_sym_BSLASHCref] = ACTIONS(6618),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnameCref] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHdef] = ACTIONS(6618),
    [anon_sym_BSLASHlet] = ACTIONS(6618),
    [anon_sym_BSLASHleft] = ACTIONS(6618),
    [anon_sym_BSLASHbigl] = ACTIONS(6618),
    [anon_sym_BSLASHBigl] = ACTIONS(6618),
    [anon_sym_BSLASHbiggl] = ACTIONS(6618),
    [anon_sym_BSLASHBiggl] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6618),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6618),
    [anon_sym_BSLASHgls] = ACTIONS(6618),
    [anon_sym_BSLASHGls] = ACTIONS(6618),
    [anon_sym_BSLASHGLS] = ACTIONS(6618),
    [anon_sym_BSLASHglspl] = ACTIONS(6618),
    [anon_sym_BSLASHGlspl] = ACTIONS(6618),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6618),
    [anon_sym_BSLASHglslink] = ACTIONS(6618),
    [anon_sym_BSLASHglstext] = ACTIONS(6618),
    [anon_sym_BSLASHGlstext] = ACTIONS(6618),
    [anon_sym_BSLASHGLStext] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6618),
    [anon_sym_BSLASHglsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsname] = ACTIONS(6618),
    [anon_sym_BSLASHGlsname] = ACTIONS(6618),
    [anon_sym_BSLASHGLSname] = ACTIONS(6618),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6618),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6618),
    [anon_sym_BSLASHacrshort] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6618),
    [anon_sym_BSLASHACRshort] = ACTIONS(6618),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrlong] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6618),
    [anon_sym_BSLASHACRlong] = ACTIONS(6618),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrfull] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6618),
    [anon_sym_BSLASHACRfull] = ACTIONS(6618),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHacs] = ACTIONS(6618),
    [anon_sym_BSLASHAcs] = ACTIONS(6618),
    [anon_sym_BSLASHacsp] = ACTIONS(6618),
    [anon_sym_BSLASHAcsp] = ACTIONS(6618),
    [anon_sym_BSLASHacl] = ACTIONS(6618),
    [anon_sym_BSLASHAcl] = ACTIONS(6618),
    [anon_sym_BSLASHaclp] = ACTIONS(6618),
    [anon_sym_BSLASHAclp] = ACTIONS(6618),
    [anon_sym_BSLASHacf] = ACTIONS(6618),
    [anon_sym_BSLASHAcf] = ACTIONS(6618),
    [anon_sym_BSLASHacfp] = ACTIONS(6618),
    [anon_sym_BSLASHAcfp] = ACTIONS(6618),
    [anon_sym_BSLASHac] = ACTIONS(6618),
    [anon_sym_BSLASHAc] = ACTIONS(6618),
    [anon_sym_BSLASHacp] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6618),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6618),
    [anon_sym_BSLASHcolor] = ACTIONS(6618),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6618),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6618),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6618),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6618),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6618),
    [anon_sym_BSLASHtext] = ACTIONS(6618),
    [anon_sym_BSLASHintertext] = ACTIONS(6618),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6618),
    [anon_sym_BSLASHurl] = ACTIONS(6618),
    [anon_sym_BSLASHhref] = ACTIONS(6618),
  },
  [1417] = {
    [sym_command_name] = ACTIONS(6614),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6614),
    [anon_sym_LBRACK] = ACTIONS(6616),
    [anon_sym_RBRACK] = ACTIONS(6616),
    [anon_sym_COMMA] = ACTIONS(6616),
    [anon_sym_EQ] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6616),
    [anon_sym_RPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHpart] = ACTIONS(6614),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddpart] = ACTIONS(6614),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHchapter] = ACTIONS(6614),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddchap] = ACTIONS(6614),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsection] = ACTIONS(6614),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHaddsec] = ACTIONS(6614),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6614),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6614),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHitem] = ACTIONS(6614),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(6616),
    [sym_word] = ACTIONS(6614),
    [sym_placeholder] = ACTIONS(6616),
    [anon_sym_PLUS] = ACTIONS(6616),
    [anon_sym_DASH] = ACTIONS(6616),
    [anon_sym_STAR] = ACTIONS(6616),
    [anon_sym_SLASH] = ACTIONS(6616),
    [anon_sym_LT] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6614),
    [anon_sym_BANG] = ACTIONS(6614),
    [anon_sym_PIPE] = ACTIONS(6614),
    [anon_sym_COLON] = ACTIONS(6614),
    [anon_sym_SQUOTE] = ACTIONS(6614),
    [anon_sym__] = ACTIONS(6616),
    [anon_sym_CARET] = ACTIONS(6616),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6616),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6616),
    [anon_sym_DOLLAR] = ACTIONS(6614),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHbegin] = ACTIONS(6614),
    [anon_sym_BSLASHend] = ACTIONS(6614),
    [anon_sym_BSLASHtitle] = ACTIONS(6614),
    [anon_sym_BSLASHauthor] = ACTIONS(6614),
    [anon_sym_BSLASHusepackage] = ACTIONS(6614),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6614),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6614),
    [anon_sym_BSLASHinclude] = ACTIONS(6614),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6614),
    [anon_sym_BSLASHinput] = ACTIONS(6614),
    [anon_sym_BSLASHsubfile] = ACTIONS(6614),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6614),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6614),
    [anon_sym_BSLASHbibliography] = ACTIONS(6614),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6614),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6614),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6614),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6614),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6614),
    [anon_sym_BSLASHimport] = ACTIONS(6614),
    [anon_sym_BSLASHsubimport] = ACTIONS(6614),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6614),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHcaption] = ACTIONS(6614),
    [anon_sym_BSLASHcite] = ACTIONS(6614),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCite] = ACTIONS(6614),
    [anon_sym_BSLASHnocite] = ACTIONS(6614),
    [anon_sym_BSLASHcitet] = ACTIONS(6614),
    [anon_sym_BSLASHcitep] = ACTIONS(6614),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteA] = ACTIONS(6614),
    [anon_sym_BSLASHciteR] = ACTIONS(6614),
    [anon_sym_BSLASHciteS] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6614),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteyear] = ACTIONS(6614),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitedate] = ACTIONS(6614),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteurl] = ACTIONS(6614),
    [anon_sym_BSLASHfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6614),
    [anon_sym_BSLASHcitealt] = ACTIONS(6614),
    [anon_sym_BSLASHcitealp] = ACTIONS(6614),
    [anon_sym_BSLASHcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHparencite] = ACTIONS(6614),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHParencite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHtextcite] = ACTIONS(6614),
    [anon_sym_BSLASHTextcite] = ACTIONS(6614),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHsupercite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite] = ACTIONS(6614),
    [anon_sym_BSLASHAutocite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHVolcite] = ACTIONS(6614),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHavolcite] = ACTIONS(6614),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHNotecite] = ACTIONS(6614),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHlabel] = ACTIONS(6614),
    [anon_sym_BSLASHref] = ACTIONS(6614),
    [anon_sym_BSLASHeqref] = ACTIONS(6614),
    [anon_sym_BSLASHvref] = ACTIONS(6614),
    [anon_sym_BSLASHVref] = ACTIONS(6614),
    [anon_sym_BSLASHautoref] = ACTIONS(6614),
    [anon_sym_BSLASHpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcref] = ACTIONS(6614),
    [anon_sym_BSLASHCref] = ACTIONS(6614),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnameCref] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHdef] = ACTIONS(6614),
    [anon_sym_BSLASHlet] = ACTIONS(6614),
    [anon_sym_BSLASHleft] = ACTIONS(6614),
    [anon_sym_BSLASHbigl] = ACTIONS(6614),
    [anon_sym_BSLASHBigl] = ACTIONS(6614),
    [anon_sym_BSLASHbiggl] = ACTIONS(6614),
    [anon_sym_BSLASHBiggl] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6614),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6614),
    [anon_sym_BSLASHgls] = ACTIONS(6614),
    [anon_sym_BSLASHGls] = ACTIONS(6614),
    [anon_sym_BSLASHGLS] = ACTIONS(6614),
    [anon_sym_BSLASHglspl] = ACTIONS(6614),
    [anon_sym_BSLASHGlspl] = ACTIONS(6614),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6614),
    [anon_sym_BSLASHglslink] = ACTIONS(6614),
    [anon_sym_BSLASHglstext] = ACTIONS(6614),
    [anon_sym_BSLASHGlstext] = ACTIONS(6614),
    [anon_sym_BSLASHGLStext] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6614),
    [anon_sym_BSLASHglsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsname] = ACTIONS(6614),
    [anon_sym_BSLASHGlsname] = ACTIONS(6614),
    [anon_sym_BSLASHGLSname] = ACTIONS(6614),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6614),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6614),
    [anon_sym_BSLASHacrshort] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6614),
    [anon_sym_BSLASHACRshort] = ACTIONS(6614),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrlong] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6614),
    [anon_sym_BSLASHACRlong] = ACTIONS(6614),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrfull] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6614),
    [anon_sym_BSLASHACRfull] = ACTIONS(6614),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHacs] = ACTIONS(6614),
    [anon_sym_BSLASHAcs] = ACTIONS(6614),
    [anon_sym_BSLASHacsp] = ACTIONS(6614),
    [anon_sym_BSLASHAcsp] = ACTIONS(6614),
    [anon_sym_BSLASHacl] = ACTIONS(6614),
    [anon_sym_BSLASHAcl] = ACTIONS(6614),
    [anon_sym_BSLASHaclp] = ACTIONS(6614),
    [anon_sym_BSLASHAclp] = ACTIONS(6614),
    [anon_sym_BSLASHacf] = ACTIONS(6614),
    [anon_sym_BSLASHAcf] = ACTIONS(6614),
    [anon_sym_BSLASHacfp] = ACTIONS(6614),
    [anon_sym_BSLASHAcfp] = ACTIONS(6614),
    [anon_sym_BSLASHac] = ACTIONS(6614),
    [anon_sym_BSLASHAc] = ACTIONS(6614),
    [anon_sym_BSLASHacp] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6614),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6614),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6614),
    [anon_sym_BSLASHcolor] = ACTIONS(6614),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6614),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6614),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6614),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6614),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6614),
    [anon_sym_BSLASHtext] = ACTIONS(6614),
    [anon_sym_BSLASHintertext] = ACTIONS(6614),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6614),
    [anon_sym_BSLASHurl] = ACTIONS(6614),
    [anon_sym_BSLASHhref] = ACTIONS(6614),
  },
  [1418] = {
    [sym_command_name] = ACTIONS(6718),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6718),
    [anon_sym_LBRACK] = ACTIONS(6720),
    [anon_sym_RBRACK] = ACTIONS(6720),
    [anon_sym_COMMA] = ACTIONS(6720),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_LPAREN] = ACTIONS(6720),
    [anon_sym_RPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHpart] = ACTIONS(6718),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddpart] = ACTIONS(6718),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHchapter] = ACTIONS(6718),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddchap] = ACTIONS(6718),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsection] = ACTIONS(6718),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHaddsec] = ACTIONS(6718),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6718),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6718),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHitem] = ACTIONS(6718),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6720),
    [anon_sym_LBRACE] = ACTIONS(6720),
    [sym_word] = ACTIONS(6718),
    [sym_placeholder] = ACTIONS(6720),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_LT] = ACTIONS(6718),
    [anon_sym_GT] = ACTIONS(6718),
    [anon_sym_BANG] = ACTIONS(6718),
    [anon_sym_PIPE] = ACTIONS(6718),
    [anon_sym_COLON] = ACTIONS(6718),
    [anon_sym_SQUOTE] = ACTIONS(6718),
    [anon_sym__] = ACTIONS(6720),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6720),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6720),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6720),
    [anon_sym_DOLLAR] = ACTIONS(6718),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHbegin] = ACTIONS(6718),
    [anon_sym_BSLASHtitle] = ACTIONS(6718),
    [anon_sym_BSLASHauthor] = ACTIONS(6718),
    [anon_sym_BSLASHusepackage] = ACTIONS(6718),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6718),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6718),
    [anon_sym_BSLASHinclude] = ACTIONS(6718),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6718),
    [anon_sym_BSLASHinput] = ACTIONS(6718),
    [anon_sym_BSLASHsubfile] = ACTIONS(6718),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6718),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6718),
    [anon_sym_BSLASHbibliography] = ACTIONS(6718),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6718),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6718),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6718),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6718),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6718),
    [anon_sym_BSLASHimport] = ACTIONS(6718),
    [anon_sym_BSLASHsubimport] = ACTIONS(6718),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6718),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHcaption] = ACTIONS(6718),
    [anon_sym_BSLASHcite] = ACTIONS(6718),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCite] = ACTIONS(6718),
    [anon_sym_BSLASHnocite] = ACTIONS(6718),
    [anon_sym_BSLASHcitet] = ACTIONS(6718),
    [anon_sym_BSLASHcitep] = ACTIONS(6718),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteA] = ACTIONS(6718),
    [anon_sym_BSLASHciteR] = ACTIONS(6718),
    [anon_sym_BSLASHciteS] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6718),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteyear] = ACTIONS(6718),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitedate] = ACTIONS(6718),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteurl] = ACTIONS(6718),
    [anon_sym_BSLASHfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6718),
    [anon_sym_BSLASHcitealt] = ACTIONS(6718),
    [anon_sym_BSLASHcitealp] = ACTIONS(6718),
    [anon_sym_BSLASHcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHparencite] = ACTIONS(6718),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHParencite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHtextcite] = ACTIONS(6718),
    [anon_sym_BSLASHTextcite] = ACTIONS(6718),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHsupercite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite] = ACTIONS(6718),
    [anon_sym_BSLASHAutocite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHVolcite] = ACTIONS(6718),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHavolcite] = ACTIONS(6718),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHNotecite] = ACTIONS(6718),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHlabel] = ACTIONS(6718),
    [anon_sym_BSLASHref] = ACTIONS(6718),
    [anon_sym_BSLASHeqref] = ACTIONS(6718),
    [anon_sym_BSLASHvref] = ACTIONS(6718),
    [anon_sym_BSLASHVref] = ACTIONS(6718),
    [anon_sym_BSLASHautoref] = ACTIONS(6718),
    [anon_sym_BSLASHpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcref] = ACTIONS(6718),
    [anon_sym_BSLASHCref] = ACTIONS(6718),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnameCref] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHdef] = ACTIONS(6718),
    [anon_sym_BSLASHlet] = ACTIONS(6718),
    [anon_sym_BSLASHleft] = ACTIONS(6718),
    [anon_sym_BSLASHbigl] = ACTIONS(6718),
    [anon_sym_BSLASHBigl] = ACTIONS(6718),
    [anon_sym_BSLASHbiggl] = ACTIONS(6718),
    [anon_sym_BSLASHBiggl] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6718),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6718),
    [anon_sym_BSLASHgls] = ACTIONS(6718),
    [anon_sym_BSLASHGls] = ACTIONS(6718),
    [anon_sym_BSLASHGLS] = ACTIONS(6718),
    [anon_sym_BSLASHglspl] = ACTIONS(6718),
    [anon_sym_BSLASHGlspl] = ACTIONS(6718),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6718),
    [anon_sym_BSLASHglslink] = ACTIONS(6718),
    [anon_sym_BSLASHglstext] = ACTIONS(6718),
    [anon_sym_BSLASHGlstext] = ACTIONS(6718),
    [anon_sym_BSLASHGLStext] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6718),
    [anon_sym_BSLASHglsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsname] = ACTIONS(6718),
    [anon_sym_BSLASHGlsname] = ACTIONS(6718),
    [anon_sym_BSLASHGLSname] = ACTIONS(6718),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6718),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6718),
    [anon_sym_BSLASHacrshort] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6718),
    [anon_sym_BSLASHACRshort] = ACTIONS(6718),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrlong] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6718),
    [anon_sym_BSLASHACRlong] = ACTIONS(6718),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrfull] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6718),
    [anon_sym_BSLASHACRfull] = ACTIONS(6718),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHacs] = ACTIONS(6718),
    [anon_sym_BSLASHAcs] = ACTIONS(6718),
    [anon_sym_BSLASHacsp] = ACTIONS(6718),
    [anon_sym_BSLASHAcsp] = ACTIONS(6718),
    [anon_sym_BSLASHacl] = ACTIONS(6718),
    [anon_sym_BSLASHAcl] = ACTIONS(6718),
    [anon_sym_BSLASHaclp] = ACTIONS(6718),
    [anon_sym_BSLASHAclp] = ACTIONS(6718),
    [anon_sym_BSLASHacf] = ACTIONS(6718),
    [anon_sym_BSLASHAcf] = ACTIONS(6718),
    [anon_sym_BSLASHacfp] = ACTIONS(6718),
    [anon_sym_BSLASHAcfp] = ACTIONS(6718),
    [anon_sym_BSLASHac] = ACTIONS(6718),
    [anon_sym_BSLASHAc] = ACTIONS(6718),
    [anon_sym_BSLASHacp] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6718),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6718),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6718),
    [anon_sym_BSLASHcolor] = ACTIONS(6718),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6718),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6718),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6718),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6718),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6718),
    [anon_sym_BSLASHtext] = ACTIONS(6718),
    [anon_sym_BSLASHintertext] = ACTIONS(6718),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6718),
    [anon_sym_BSLASHurl] = ACTIONS(6718),
    [anon_sym_BSLASHhref] = ACTIONS(6718),
  },
  [1419] = {
    [sym_command_name] = ACTIONS(6610),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6610),
    [anon_sym_LBRACK] = ACTIONS(6612),
    [anon_sym_RBRACK] = ACTIONS(6612),
    [anon_sym_COMMA] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6612),
    [anon_sym_RPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHpart] = ACTIONS(6610),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddpart] = ACTIONS(6610),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHchapter] = ACTIONS(6610),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddchap] = ACTIONS(6610),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsection] = ACTIONS(6610),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHaddsec] = ACTIONS(6610),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6610),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6610),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHitem] = ACTIONS(6610),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6612),
    [anon_sym_LBRACE] = ACTIONS(6612),
    [sym_word] = ACTIONS(6610),
    [sym_placeholder] = ACTIONS(6612),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_DASH] = ACTIONS(6612),
    [anon_sym_STAR] = ACTIONS(6612),
    [anon_sym_SLASH] = ACTIONS(6612),
    [anon_sym_LT] = ACTIONS(6610),
    [anon_sym_GT] = ACTIONS(6610),
    [anon_sym_BANG] = ACTIONS(6610),
    [anon_sym_PIPE] = ACTIONS(6610),
    [anon_sym_COLON] = ACTIONS(6610),
    [anon_sym_SQUOTE] = ACTIONS(6610),
    [anon_sym__] = ACTIONS(6612),
    [anon_sym_CARET] = ACTIONS(6612),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6612),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6612),
    [anon_sym_DOLLAR] = ACTIONS(6610),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHbegin] = ACTIONS(6610),
    [anon_sym_BSLASHend] = ACTIONS(6610),
    [anon_sym_BSLASHtitle] = ACTIONS(6610),
    [anon_sym_BSLASHauthor] = ACTIONS(6610),
    [anon_sym_BSLASHusepackage] = ACTIONS(6610),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6610),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6610),
    [anon_sym_BSLASHinclude] = ACTIONS(6610),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6610),
    [anon_sym_BSLASHinput] = ACTIONS(6610),
    [anon_sym_BSLASHsubfile] = ACTIONS(6610),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6610),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6610),
    [anon_sym_BSLASHbibliography] = ACTIONS(6610),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6610),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6610),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6610),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6610),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6610),
    [anon_sym_BSLASHimport] = ACTIONS(6610),
    [anon_sym_BSLASHsubimport] = ACTIONS(6610),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6610),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHcaption] = ACTIONS(6610),
    [anon_sym_BSLASHcite] = ACTIONS(6610),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCite] = ACTIONS(6610),
    [anon_sym_BSLASHnocite] = ACTIONS(6610),
    [anon_sym_BSLASHcitet] = ACTIONS(6610),
    [anon_sym_BSLASHcitep] = ACTIONS(6610),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteA] = ACTIONS(6610),
    [anon_sym_BSLASHciteR] = ACTIONS(6610),
    [anon_sym_BSLASHciteS] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6610),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteyear] = ACTIONS(6610),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitedate] = ACTIONS(6610),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteurl] = ACTIONS(6610),
    [anon_sym_BSLASHfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6610),
    [anon_sym_BSLASHcitealt] = ACTIONS(6610),
    [anon_sym_BSLASHcitealp] = ACTIONS(6610),
    [anon_sym_BSLASHcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHparencite] = ACTIONS(6610),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHParencite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHtextcite] = ACTIONS(6610),
    [anon_sym_BSLASHTextcite] = ACTIONS(6610),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHsupercite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite] = ACTIONS(6610),
    [anon_sym_BSLASHAutocite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHVolcite] = ACTIONS(6610),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHavolcite] = ACTIONS(6610),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHNotecite] = ACTIONS(6610),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHlabel] = ACTIONS(6610),
    [anon_sym_BSLASHref] = ACTIONS(6610),
    [anon_sym_BSLASHeqref] = ACTIONS(6610),
    [anon_sym_BSLASHvref] = ACTIONS(6610),
    [anon_sym_BSLASHVref] = ACTIONS(6610),
    [anon_sym_BSLASHautoref] = ACTIONS(6610),
    [anon_sym_BSLASHpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcref] = ACTIONS(6610),
    [anon_sym_BSLASHCref] = ACTIONS(6610),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnameCref] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHdef] = ACTIONS(6610),
    [anon_sym_BSLASHlet] = ACTIONS(6610),
    [anon_sym_BSLASHleft] = ACTIONS(6610),
    [anon_sym_BSLASHbigl] = ACTIONS(6610),
    [anon_sym_BSLASHBigl] = ACTIONS(6610),
    [anon_sym_BSLASHbiggl] = ACTIONS(6610),
    [anon_sym_BSLASHBiggl] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6610),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6610),
    [anon_sym_BSLASHgls] = ACTIONS(6610),
    [anon_sym_BSLASHGls] = ACTIONS(6610),
    [anon_sym_BSLASHGLS] = ACTIONS(6610),
    [anon_sym_BSLASHglspl] = ACTIONS(6610),
    [anon_sym_BSLASHGlspl] = ACTIONS(6610),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6610),
    [anon_sym_BSLASHglslink] = ACTIONS(6610),
    [anon_sym_BSLASHglstext] = ACTIONS(6610),
    [anon_sym_BSLASHGlstext] = ACTIONS(6610),
    [anon_sym_BSLASHGLStext] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6610),
    [anon_sym_BSLASHglsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsname] = ACTIONS(6610),
    [anon_sym_BSLASHGlsname] = ACTIONS(6610),
    [anon_sym_BSLASHGLSname] = ACTIONS(6610),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6610),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6610),
    [anon_sym_BSLASHacrshort] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6610),
    [anon_sym_BSLASHACRshort] = ACTIONS(6610),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrlong] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6610),
    [anon_sym_BSLASHACRlong] = ACTIONS(6610),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrfull] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6610),
    [anon_sym_BSLASHACRfull] = ACTIONS(6610),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHacs] = ACTIONS(6610),
    [anon_sym_BSLASHAcs] = ACTIONS(6610),
    [anon_sym_BSLASHacsp] = ACTIONS(6610),
    [anon_sym_BSLASHAcsp] = ACTIONS(6610),
    [anon_sym_BSLASHacl] = ACTIONS(6610),
    [anon_sym_BSLASHAcl] = ACTIONS(6610),
    [anon_sym_BSLASHaclp] = ACTIONS(6610),
    [anon_sym_BSLASHAclp] = ACTIONS(6610),
    [anon_sym_BSLASHacf] = ACTIONS(6610),
    [anon_sym_BSLASHAcf] = ACTIONS(6610),
    [anon_sym_BSLASHacfp] = ACTIONS(6610),
    [anon_sym_BSLASHAcfp] = ACTIONS(6610),
    [anon_sym_BSLASHac] = ACTIONS(6610),
    [anon_sym_BSLASHAc] = ACTIONS(6610),
    [anon_sym_BSLASHacp] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6610),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6610),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6610),
    [anon_sym_BSLASHcolor] = ACTIONS(6610),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6610),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6610),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6610),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6610),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6610),
    [anon_sym_BSLASHtext] = ACTIONS(6610),
    [anon_sym_BSLASHintertext] = ACTIONS(6610),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6610),
    [anon_sym_BSLASHurl] = ACTIONS(6610),
    [anon_sym_BSLASHhref] = ACTIONS(6610),
  },
  [1420] = {
    [sym_command_name] = ACTIONS(6606),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6606),
    [anon_sym_LBRACK] = ACTIONS(6608),
    [anon_sym_RBRACK] = ACTIONS(6608),
    [anon_sym_COMMA] = ACTIONS(6608),
    [anon_sym_EQ] = ACTIONS(6608),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_RPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHpart] = ACTIONS(6606),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddpart] = ACTIONS(6606),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHchapter] = ACTIONS(6606),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddchap] = ACTIONS(6606),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsection] = ACTIONS(6606),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHaddsec] = ACTIONS(6606),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6606),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6606),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHitem] = ACTIONS(6606),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6608),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [sym_word] = ACTIONS(6606),
    [sym_placeholder] = ACTIONS(6608),
    [anon_sym_PLUS] = ACTIONS(6608),
    [anon_sym_DASH] = ACTIONS(6608),
    [anon_sym_STAR] = ACTIONS(6608),
    [anon_sym_SLASH] = ACTIONS(6608),
    [anon_sym_LT] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6606),
    [anon_sym_BANG] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6606),
    [anon_sym_COLON] = ACTIONS(6606),
    [anon_sym_SQUOTE] = ACTIONS(6606),
    [anon_sym__] = ACTIONS(6608),
    [anon_sym_CARET] = ACTIONS(6608),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6608),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(6606),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHbegin] = ACTIONS(6606),
    [anon_sym_BSLASHend] = ACTIONS(6606),
    [anon_sym_BSLASHtitle] = ACTIONS(6606),
    [anon_sym_BSLASHauthor] = ACTIONS(6606),
    [anon_sym_BSLASHusepackage] = ACTIONS(6606),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6606),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6606),
    [anon_sym_BSLASHinclude] = ACTIONS(6606),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6606),
    [anon_sym_BSLASHinput] = ACTIONS(6606),
    [anon_sym_BSLASHsubfile] = ACTIONS(6606),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6606),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6606),
    [anon_sym_BSLASHbibliography] = ACTIONS(6606),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6606),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6606),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6606),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6606),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6606),
    [anon_sym_BSLASHimport] = ACTIONS(6606),
    [anon_sym_BSLASHsubimport] = ACTIONS(6606),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6606),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHcaption] = ACTIONS(6606),
    [anon_sym_BSLASHcite] = ACTIONS(6606),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCite] = ACTIONS(6606),
    [anon_sym_BSLASHnocite] = ACTIONS(6606),
    [anon_sym_BSLASHcitet] = ACTIONS(6606),
    [anon_sym_BSLASHcitep] = ACTIONS(6606),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteA] = ACTIONS(6606),
    [anon_sym_BSLASHciteR] = ACTIONS(6606),
    [anon_sym_BSLASHciteS] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6606),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteyear] = ACTIONS(6606),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitedate] = ACTIONS(6606),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteurl] = ACTIONS(6606),
    [anon_sym_BSLASHfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6606),
    [anon_sym_BSLASHcitealt] = ACTIONS(6606),
    [anon_sym_BSLASHcitealp] = ACTIONS(6606),
    [anon_sym_BSLASHcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHparencite] = ACTIONS(6606),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHParencite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHtextcite] = ACTIONS(6606),
    [anon_sym_BSLASHTextcite] = ACTIONS(6606),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHsupercite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite] = ACTIONS(6606),
    [anon_sym_BSLASHAutocite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHVolcite] = ACTIONS(6606),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHavolcite] = ACTIONS(6606),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHNotecite] = ACTIONS(6606),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHlabel] = ACTIONS(6606),
    [anon_sym_BSLASHref] = ACTIONS(6606),
    [anon_sym_BSLASHeqref] = ACTIONS(6606),
    [anon_sym_BSLASHvref] = ACTIONS(6606),
    [anon_sym_BSLASHVref] = ACTIONS(6606),
    [anon_sym_BSLASHautoref] = ACTIONS(6606),
    [anon_sym_BSLASHpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcref] = ACTIONS(6606),
    [anon_sym_BSLASHCref] = ACTIONS(6606),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnameCref] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHdef] = ACTIONS(6606),
    [anon_sym_BSLASHlet] = ACTIONS(6606),
    [anon_sym_BSLASHleft] = ACTIONS(6606),
    [anon_sym_BSLASHbigl] = ACTIONS(6606),
    [anon_sym_BSLASHBigl] = ACTIONS(6606),
    [anon_sym_BSLASHbiggl] = ACTIONS(6606),
    [anon_sym_BSLASHBiggl] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6606),
    [anon_sym_BSLASHgls] = ACTIONS(6606),
    [anon_sym_BSLASHGls] = ACTIONS(6606),
    [anon_sym_BSLASHGLS] = ACTIONS(6606),
    [anon_sym_BSLASHglspl] = ACTIONS(6606),
    [anon_sym_BSLASHGlspl] = ACTIONS(6606),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6606),
    [anon_sym_BSLASHglslink] = ACTIONS(6606),
    [anon_sym_BSLASHglstext] = ACTIONS(6606),
    [anon_sym_BSLASHGlstext] = ACTIONS(6606),
    [anon_sym_BSLASHGLStext] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6606),
    [anon_sym_BSLASHglsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsname] = ACTIONS(6606),
    [anon_sym_BSLASHGlsname] = ACTIONS(6606),
    [anon_sym_BSLASHGLSname] = ACTIONS(6606),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6606),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6606),
    [anon_sym_BSLASHacrshort] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6606),
    [anon_sym_BSLASHACRshort] = ACTIONS(6606),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrlong] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6606),
    [anon_sym_BSLASHACRlong] = ACTIONS(6606),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrfull] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6606),
    [anon_sym_BSLASHACRfull] = ACTIONS(6606),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHacs] = ACTIONS(6606),
    [anon_sym_BSLASHAcs] = ACTIONS(6606),
    [anon_sym_BSLASHacsp] = ACTIONS(6606),
    [anon_sym_BSLASHAcsp] = ACTIONS(6606),
    [anon_sym_BSLASHacl] = ACTIONS(6606),
    [anon_sym_BSLASHAcl] = ACTIONS(6606),
    [anon_sym_BSLASHaclp] = ACTIONS(6606),
    [anon_sym_BSLASHAclp] = ACTIONS(6606),
    [anon_sym_BSLASHacf] = ACTIONS(6606),
    [anon_sym_BSLASHAcf] = ACTIONS(6606),
    [anon_sym_BSLASHacfp] = ACTIONS(6606),
    [anon_sym_BSLASHAcfp] = ACTIONS(6606),
    [anon_sym_BSLASHac] = ACTIONS(6606),
    [anon_sym_BSLASHAc] = ACTIONS(6606),
    [anon_sym_BSLASHacp] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6606),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6606),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6606),
    [anon_sym_BSLASHcolor] = ACTIONS(6606),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6606),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6606),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6606),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6606),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6606),
    [anon_sym_BSLASHtext] = ACTIONS(6606),
    [anon_sym_BSLASHintertext] = ACTIONS(6606),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6606),
    [anon_sym_BSLASHurl] = ACTIONS(6606),
    [anon_sym_BSLASHhref] = ACTIONS(6606),
  },
  [1421] = {
    [sym_command_name] = ACTIONS(6602),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6602),
    [anon_sym_LBRACK] = ACTIONS(6604),
    [anon_sym_RBRACK] = ACTIONS(6604),
    [anon_sym_COMMA] = ACTIONS(6604),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(6604),
    [anon_sym_RPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHpart] = ACTIONS(6602),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddpart] = ACTIONS(6602),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHchapter] = ACTIONS(6602),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddchap] = ACTIONS(6602),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsection] = ACTIONS(6602),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHaddsec] = ACTIONS(6602),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6602),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6602),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHitem] = ACTIONS(6602),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6604),
    [anon_sym_LBRACE] = ACTIONS(6604),
    [sym_word] = ACTIONS(6602),
    [sym_placeholder] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6602),
    [anon_sym_GT] = ACTIONS(6602),
    [anon_sym_BANG] = ACTIONS(6602),
    [anon_sym_PIPE] = ACTIONS(6602),
    [anon_sym_COLON] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(6602),
    [anon_sym__] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6604),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6604),
    [anon_sym_DOLLAR] = ACTIONS(6602),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHbegin] = ACTIONS(6602),
    [anon_sym_BSLASHend] = ACTIONS(6602),
    [anon_sym_BSLASHtitle] = ACTIONS(6602),
    [anon_sym_BSLASHauthor] = ACTIONS(6602),
    [anon_sym_BSLASHusepackage] = ACTIONS(6602),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6602),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6602),
    [anon_sym_BSLASHinclude] = ACTIONS(6602),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6602),
    [anon_sym_BSLASHinput] = ACTIONS(6602),
    [anon_sym_BSLASHsubfile] = ACTIONS(6602),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6602),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6602),
    [anon_sym_BSLASHbibliography] = ACTIONS(6602),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6602),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6602),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6602),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6602),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6602),
    [anon_sym_BSLASHimport] = ACTIONS(6602),
    [anon_sym_BSLASHsubimport] = ACTIONS(6602),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6602),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHcaption] = ACTIONS(6602),
    [anon_sym_BSLASHcite] = ACTIONS(6602),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCite] = ACTIONS(6602),
    [anon_sym_BSLASHnocite] = ACTIONS(6602),
    [anon_sym_BSLASHcitet] = ACTIONS(6602),
    [anon_sym_BSLASHcitep] = ACTIONS(6602),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteA] = ACTIONS(6602),
    [anon_sym_BSLASHciteR] = ACTIONS(6602),
    [anon_sym_BSLASHciteS] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6602),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteyear] = ACTIONS(6602),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitedate] = ACTIONS(6602),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteurl] = ACTIONS(6602),
    [anon_sym_BSLASHfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6602),
    [anon_sym_BSLASHcitealt] = ACTIONS(6602),
    [anon_sym_BSLASHcitealp] = ACTIONS(6602),
    [anon_sym_BSLASHcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHparencite] = ACTIONS(6602),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHParencite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHtextcite] = ACTIONS(6602),
    [anon_sym_BSLASHTextcite] = ACTIONS(6602),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHsupercite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite] = ACTIONS(6602),
    [anon_sym_BSLASHAutocite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHVolcite] = ACTIONS(6602),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHavolcite] = ACTIONS(6602),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHNotecite] = ACTIONS(6602),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHlabel] = ACTIONS(6602),
    [anon_sym_BSLASHref] = ACTIONS(6602),
    [anon_sym_BSLASHeqref] = ACTIONS(6602),
    [anon_sym_BSLASHvref] = ACTIONS(6602),
    [anon_sym_BSLASHVref] = ACTIONS(6602),
    [anon_sym_BSLASHautoref] = ACTIONS(6602),
    [anon_sym_BSLASHpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcref] = ACTIONS(6602),
    [anon_sym_BSLASHCref] = ACTIONS(6602),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnameCref] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHdef] = ACTIONS(6602),
    [anon_sym_BSLASHlet] = ACTIONS(6602),
    [anon_sym_BSLASHleft] = ACTIONS(6602),
    [anon_sym_BSLASHbigl] = ACTIONS(6602),
    [anon_sym_BSLASHBigl] = ACTIONS(6602),
    [anon_sym_BSLASHbiggl] = ACTIONS(6602),
    [anon_sym_BSLASHBiggl] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6602),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6602),
    [anon_sym_BSLASHgls] = ACTIONS(6602),
    [anon_sym_BSLASHGls] = ACTIONS(6602),
    [anon_sym_BSLASHGLS] = ACTIONS(6602),
    [anon_sym_BSLASHglspl] = ACTIONS(6602),
    [anon_sym_BSLASHGlspl] = ACTIONS(6602),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6602),
    [anon_sym_BSLASHglslink] = ACTIONS(6602),
    [anon_sym_BSLASHglstext] = ACTIONS(6602),
    [anon_sym_BSLASHGlstext] = ACTIONS(6602),
    [anon_sym_BSLASHGLStext] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6602),
    [anon_sym_BSLASHglsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsname] = ACTIONS(6602),
    [anon_sym_BSLASHGlsname] = ACTIONS(6602),
    [anon_sym_BSLASHGLSname] = ACTIONS(6602),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6602),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6602),
    [anon_sym_BSLASHacrshort] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6602),
    [anon_sym_BSLASHACRshort] = ACTIONS(6602),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrlong] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6602),
    [anon_sym_BSLASHACRlong] = ACTIONS(6602),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrfull] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6602),
    [anon_sym_BSLASHACRfull] = ACTIONS(6602),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHacs] = ACTIONS(6602),
    [anon_sym_BSLASHAcs] = ACTIONS(6602),
    [anon_sym_BSLASHacsp] = ACTIONS(6602),
    [anon_sym_BSLASHAcsp] = ACTIONS(6602),
    [anon_sym_BSLASHacl] = ACTIONS(6602),
    [anon_sym_BSLASHAcl] = ACTIONS(6602),
    [anon_sym_BSLASHaclp] = ACTIONS(6602),
    [anon_sym_BSLASHAclp] = ACTIONS(6602),
    [anon_sym_BSLASHacf] = ACTIONS(6602),
    [anon_sym_BSLASHAcf] = ACTIONS(6602),
    [anon_sym_BSLASHacfp] = ACTIONS(6602),
    [anon_sym_BSLASHAcfp] = ACTIONS(6602),
    [anon_sym_BSLASHac] = ACTIONS(6602),
    [anon_sym_BSLASHAc] = ACTIONS(6602),
    [anon_sym_BSLASHacp] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6602),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6602),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6602),
    [anon_sym_BSLASHcolor] = ACTIONS(6602),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6602),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6602),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6602),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6602),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6602),
    [anon_sym_BSLASHtext] = ACTIONS(6602),
    [anon_sym_BSLASHintertext] = ACTIONS(6602),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6602),
    [anon_sym_BSLASHurl] = ACTIONS(6602),
    [anon_sym_BSLASHhref] = ACTIONS(6602),
  },
  [1422] = {
    [sym_command_name] = ACTIONS(6646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6646),
    [anon_sym_LBRACK] = ACTIONS(6648),
    [anon_sym_RBRACK] = ACTIONS(6648),
    [anon_sym_COMMA] = ACTIONS(6648),
    [anon_sym_EQ] = ACTIONS(6648),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [anon_sym_RPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHpart] = ACTIONS(6646),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddpart] = ACTIONS(6646),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHchapter] = ACTIONS(6646),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddchap] = ACTIONS(6646),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsection] = ACTIONS(6646),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHaddsec] = ACTIONS(6646),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6646),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6646),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHitem] = ACTIONS(6646),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6648),
    [anon_sym_LBRACE] = ACTIONS(6648),
    [sym_word] = ACTIONS(6646),
    [sym_placeholder] = ACTIONS(6648),
    [anon_sym_PLUS] = ACTIONS(6648),
    [anon_sym_DASH] = ACTIONS(6648),
    [anon_sym_STAR] = ACTIONS(6648),
    [anon_sym_SLASH] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6646),
    [anon_sym_GT] = ACTIONS(6646),
    [anon_sym_BANG] = ACTIONS(6646),
    [anon_sym_PIPE] = ACTIONS(6646),
    [anon_sym_COLON] = ACTIONS(6646),
    [anon_sym_SQUOTE] = ACTIONS(6646),
    [anon_sym__] = ACTIONS(6648),
    [anon_sym_CARET] = ACTIONS(6648),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6648),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6648),
    [anon_sym_DOLLAR] = ACTIONS(6646),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHbegin] = ACTIONS(6646),
    [anon_sym_BSLASHend] = ACTIONS(6646),
    [anon_sym_BSLASHtitle] = ACTIONS(6646),
    [anon_sym_BSLASHauthor] = ACTIONS(6646),
    [anon_sym_BSLASHusepackage] = ACTIONS(6646),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6646),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6646),
    [anon_sym_BSLASHinclude] = ACTIONS(6646),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6646),
    [anon_sym_BSLASHinput] = ACTIONS(6646),
    [anon_sym_BSLASHsubfile] = ACTIONS(6646),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6646),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6646),
    [anon_sym_BSLASHbibliography] = ACTIONS(6646),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6646),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6646),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6646),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6646),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6646),
    [anon_sym_BSLASHimport] = ACTIONS(6646),
    [anon_sym_BSLASHsubimport] = ACTIONS(6646),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6646),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHcaption] = ACTIONS(6646),
    [anon_sym_BSLASHcite] = ACTIONS(6646),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCite] = ACTIONS(6646),
    [anon_sym_BSLASHnocite] = ACTIONS(6646),
    [anon_sym_BSLASHcitet] = ACTIONS(6646),
    [anon_sym_BSLASHcitep] = ACTIONS(6646),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteA] = ACTIONS(6646),
    [anon_sym_BSLASHciteR] = ACTIONS(6646),
    [anon_sym_BSLASHciteS] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6646),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteyear] = ACTIONS(6646),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitedate] = ACTIONS(6646),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteurl] = ACTIONS(6646),
    [anon_sym_BSLASHfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6646),
    [anon_sym_BSLASHcitealt] = ACTIONS(6646),
    [anon_sym_BSLASHcitealp] = ACTIONS(6646),
    [anon_sym_BSLASHcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHparencite] = ACTIONS(6646),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHParencite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHtextcite] = ACTIONS(6646),
    [anon_sym_BSLASHTextcite] = ACTIONS(6646),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHsupercite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite] = ACTIONS(6646),
    [anon_sym_BSLASHAutocite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHVolcite] = ACTIONS(6646),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHavolcite] = ACTIONS(6646),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHNotecite] = ACTIONS(6646),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHlabel] = ACTIONS(6646),
    [anon_sym_BSLASHref] = ACTIONS(6646),
    [anon_sym_BSLASHeqref] = ACTIONS(6646),
    [anon_sym_BSLASHvref] = ACTIONS(6646),
    [anon_sym_BSLASHVref] = ACTIONS(6646),
    [anon_sym_BSLASHautoref] = ACTIONS(6646),
    [anon_sym_BSLASHpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcref] = ACTIONS(6646),
    [anon_sym_BSLASHCref] = ACTIONS(6646),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnameCref] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHdef] = ACTIONS(6646),
    [anon_sym_BSLASHlet] = ACTIONS(6646),
    [anon_sym_BSLASHleft] = ACTIONS(6646),
    [anon_sym_BSLASHbigl] = ACTIONS(6646),
    [anon_sym_BSLASHBigl] = ACTIONS(6646),
    [anon_sym_BSLASHbiggl] = ACTIONS(6646),
    [anon_sym_BSLASHBiggl] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6646),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6646),
    [anon_sym_BSLASHgls] = ACTIONS(6646),
    [anon_sym_BSLASHGls] = ACTIONS(6646),
    [anon_sym_BSLASHGLS] = ACTIONS(6646),
    [anon_sym_BSLASHglspl] = ACTIONS(6646),
    [anon_sym_BSLASHGlspl] = ACTIONS(6646),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6646),
    [anon_sym_BSLASHglslink] = ACTIONS(6646),
    [anon_sym_BSLASHglstext] = ACTIONS(6646),
    [anon_sym_BSLASHGlstext] = ACTIONS(6646),
    [anon_sym_BSLASHGLStext] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6646),
    [anon_sym_BSLASHglsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsname] = ACTIONS(6646),
    [anon_sym_BSLASHGlsname] = ACTIONS(6646),
    [anon_sym_BSLASHGLSname] = ACTIONS(6646),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6646),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6646),
    [anon_sym_BSLASHacrshort] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6646),
    [anon_sym_BSLASHACRshort] = ACTIONS(6646),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrlong] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6646),
    [anon_sym_BSLASHACRlong] = ACTIONS(6646),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrfull] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6646),
    [anon_sym_BSLASHACRfull] = ACTIONS(6646),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHacs] = ACTIONS(6646),
    [anon_sym_BSLASHAcs] = ACTIONS(6646),
    [anon_sym_BSLASHacsp] = ACTIONS(6646),
    [anon_sym_BSLASHAcsp] = ACTIONS(6646),
    [anon_sym_BSLASHacl] = ACTIONS(6646),
    [anon_sym_BSLASHAcl] = ACTIONS(6646),
    [anon_sym_BSLASHaclp] = ACTIONS(6646),
    [anon_sym_BSLASHAclp] = ACTIONS(6646),
    [anon_sym_BSLASHacf] = ACTIONS(6646),
    [anon_sym_BSLASHAcf] = ACTIONS(6646),
    [anon_sym_BSLASHacfp] = ACTIONS(6646),
    [anon_sym_BSLASHAcfp] = ACTIONS(6646),
    [anon_sym_BSLASHac] = ACTIONS(6646),
    [anon_sym_BSLASHAc] = ACTIONS(6646),
    [anon_sym_BSLASHacp] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6646),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6646),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6646),
    [anon_sym_BSLASHcolor] = ACTIONS(6646),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6646),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6646),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6646),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6646),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6646),
    [anon_sym_BSLASHtext] = ACTIONS(6646),
    [anon_sym_BSLASHintertext] = ACTIONS(6646),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6646),
    [anon_sym_BSLASHurl] = ACTIONS(6646),
    [anon_sym_BSLASHhref] = ACTIONS(6646),
  },
  [1423] = {
    [sym_command_name] = ACTIONS(6714),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6714),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_RBRACK] = ACTIONS(6716),
    [anon_sym_COMMA] = ACTIONS(6716),
    [anon_sym_EQ] = ACTIONS(6716),
    [anon_sym_LPAREN] = ACTIONS(6716),
    [anon_sym_RPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHpart] = ACTIONS(6714),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddpart] = ACTIONS(6714),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHchapter] = ACTIONS(6714),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddchap] = ACTIONS(6714),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsection] = ACTIONS(6714),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHaddsec] = ACTIONS(6714),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6714),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6714),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHitem] = ACTIONS(6714),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(6716),
    [sym_word] = ACTIONS(6714),
    [sym_placeholder] = ACTIONS(6716),
    [anon_sym_PLUS] = ACTIONS(6716),
    [anon_sym_DASH] = ACTIONS(6716),
    [anon_sym_STAR] = ACTIONS(6716),
    [anon_sym_SLASH] = ACTIONS(6716),
    [anon_sym_LT] = ACTIONS(6714),
    [anon_sym_GT] = ACTIONS(6714),
    [anon_sym_BANG] = ACTIONS(6714),
    [anon_sym_PIPE] = ACTIONS(6714),
    [anon_sym_COLON] = ACTIONS(6714),
    [anon_sym_SQUOTE] = ACTIONS(6714),
    [anon_sym__] = ACTIONS(6716),
    [anon_sym_CARET] = ACTIONS(6716),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6716),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6716),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6716),
    [anon_sym_DOLLAR] = ACTIONS(6714),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHbegin] = ACTIONS(6714),
    [anon_sym_BSLASHtitle] = ACTIONS(6714),
    [anon_sym_BSLASHauthor] = ACTIONS(6714),
    [anon_sym_BSLASHusepackage] = ACTIONS(6714),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6714),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6714),
    [anon_sym_BSLASHinclude] = ACTIONS(6714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6714),
    [anon_sym_BSLASHinput] = ACTIONS(6714),
    [anon_sym_BSLASHsubfile] = ACTIONS(6714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6714),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6714),
    [anon_sym_BSLASHbibliography] = ACTIONS(6714),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6714),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6714),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6714),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6714),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6714),
    [anon_sym_BSLASHimport] = ACTIONS(6714),
    [anon_sym_BSLASHsubimport] = ACTIONS(6714),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6714),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHcaption] = ACTIONS(6714),
    [anon_sym_BSLASHcite] = ACTIONS(6714),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCite] = ACTIONS(6714),
    [anon_sym_BSLASHnocite] = ACTIONS(6714),
    [anon_sym_BSLASHcitet] = ACTIONS(6714),
    [anon_sym_BSLASHcitep] = ACTIONS(6714),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteA] = ACTIONS(6714),
    [anon_sym_BSLASHciteR] = ACTIONS(6714),
    [anon_sym_BSLASHciteS] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6714),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteyear] = ACTIONS(6714),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitedate] = ACTIONS(6714),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteurl] = ACTIONS(6714),
    [anon_sym_BSLASHfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6714),
    [anon_sym_BSLASHcitealt] = ACTIONS(6714),
    [anon_sym_BSLASHcitealp] = ACTIONS(6714),
    [anon_sym_BSLASHcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHparencite] = ACTIONS(6714),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHParencite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHtextcite] = ACTIONS(6714),
    [anon_sym_BSLASHTextcite] = ACTIONS(6714),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHsupercite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite] = ACTIONS(6714),
    [anon_sym_BSLASHAutocite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHVolcite] = ACTIONS(6714),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHavolcite] = ACTIONS(6714),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHNotecite] = ACTIONS(6714),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHlabel] = ACTIONS(6714),
    [anon_sym_BSLASHref] = ACTIONS(6714),
    [anon_sym_BSLASHeqref] = ACTIONS(6714),
    [anon_sym_BSLASHvref] = ACTIONS(6714),
    [anon_sym_BSLASHVref] = ACTIONS(6714),
    [anon_sym_BSLASHautoref] = ACTIONS(6714),
    [anon_sym_BSLASHpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcref] = ACTIONS(6714),
    [anon_sym_BSLASHCref] = ACTIONS(6714),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnameCref] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHdef] = ACTIONS(6714),
    [anon_sym_BSLASHlet] = ACTIONS(6714),
    [anon_sym_BSLASHleft] = ACTIONS(6714),
    [anon_sym_BSLASHbigl] = ACTIONS(6714),
    [anon_sym_BSLASHBigl] = ACTIONS(6714),
    [anon_sym_BSLASHbiggl] = ACTIONS(6714),
    [anon_sym_BSLASHBiggl] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6714),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6714),
    [anon_sym_BSLASHgls] = ACTIONS(6714),
    [anon_sym_BSLASHGls] = ACTIONS(6714),
    [anon_sym_BSLASHGLS] = ACTIONS(6714),
    [anon_sym_BSLASHglspl] = ACTIONS(6714),
    [anon_sym_BSLASHGlspl] = ACTIONS(6714),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6714),
    [anon_sym_BSLASHglslink] = ACTIONS(6714),
    [anon_sym_BSLASHglstext] = ACTIONS(6714),
    [anon_sym_BSLASHGlstext] = ACTIONS(6714),
    [anon_sym_BSLASHGLStext] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6714),
    [anon_sym_BSLASHglsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsname] = ACTIONS(6714),
    [anon_sym_BSLASHGlsname] = ACTIONS(6714),
    [anon_sym_BSLASHGLSname] = ACTIONS(6714),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6714),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6714),
    [anon_sym_BSLASHacrshort] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6714),
    [anon_sym_BSLASHACRshort] = ACTIONS(6714),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrlong] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6714),
    [anon_sym_BSLASHACRlong] = ACTIONS(6714),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrfull] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6714),
    [anon_sym_BSLASHACRfull] = ACTIONS(6714),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHacs] = ACTIONS(6714),
    [anon_sym_BSLASHAcs] = ACTIONS(6714),
    [anon_sym_BSLASHacsp] = ACTIONS(6714),
    [anon_sym_BSLASHAcsp] = ACTIONS(6714),
    [anon_sym_BSLASHacl] = ACTIONS(6714),
    [anon_sym_BSLASHAcl] = ACTIONS(6714),
    [anon_sym_BSLASHaclp] = ACTIONS(6714),
    [anon_sym_BSLASHAclp] = ACTIONS(6714),
    [anon_sym_BSLASHacf] = ACTIONS(6714),
    [anon_sym_BSLASHAcf] = ACTIONS(6714),
    [anon_sym_BSLASHacfp] = ACTIONS(6714),
    [anon_sym_BSLASHAcfp] = ACTIONS(6714),
    [anon_sym_BSLASHac] = ACTIONS(6714),
    [anon_sym_BSLASHAc] = ACTIONS(6714),
    [anon_sym_BSLASHacp] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6714),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6714),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6714),
    [anon_sym_BSLASHcolor] = ACTIONS(6714),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6714),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6714),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6714),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6714),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6714),
    [anon_sym_BSLASHtext] = ACTIONS(6714),
    [anon_sym_BSLASHintertext] = ACTIONS(6714),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6714),
    [anon_sym_BSLASHurl] = ACTIONS(6714),
    [anon_sym_BSLASHhref] = ACTIONS(6714),
  },
  [1424] = {
    [sym_command_name] = ACTIONS(6710),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(6712),
    [anon_sym_RBRACK] = ACTIONS(6712),
    [anon_sym_COMMA] = ACTIONS(6712),
    [anon_sym_EQ] = ACTIONS(6712),
    [anon_sym_LPAREN] = ACTIONS(6712),
    [anon_sym_RPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHpart] = ACTIONS(6710),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddpart] = ACTIONS(6710),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHchapter] = ACTIONS(6710),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddchap] = ACTIONS(6710),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsection] = ACTIONS(6710),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHaddsec] = ACTIONS(6710),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6710),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6710),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHitem] = ACTIONS(6710),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6712),
    [anon_sym_LBRACE] = ACTIONS(6712),
    [sym_word] = ACTIONS(6710),
    [sym_placeholder] = ACTIONS(6712),
    [anon_sym_PLUS] = ACTIONS(6712),
    [anon_sym_DASH] = ACTIONS(6712),
    [anon_sym_STAR] = ACTIONS(6712),
    [anon_sym_SLASH] = ACTIONS(6712),
    [anon_sym_LT] = ACTIONS(6710),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_PIPE] = ACTIONS(6710),
    [anon_sym_COLON] = ACTIONS(6710),
    [anon_sym_SQUOTE] = ACTIONS(6710),
    [anon_sym__] = ACTIONS(6712),
    [anon_sym_CARET] = ACTIONS(6712),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6712),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6712),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6712),
    [anon_sym_DOLLAR] = ACTIONS(6710),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHbegin] = ACTIONS(6710),
    [anon_sym_BSLASHtitle] = ACTIONS(6710),
    [anon_sym_BSLASHauthor] = ACTIONS(6710),
    [anon_sym_BSLASHusepackage] = ACTIONS(6710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6710),
    [anon_sym_BSLASHinclude] = ACTIONS(6710),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6710),
    [anon_sym_BSLASHinput] = ACTIONS(6710),
    [anon_sym_BSLASHsubfile] = ACTIONS(6710),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6710),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6710),
    [anon_sym_BSLASHbibliography] = ACTIONS(6710),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6710),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6710),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6710),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6710),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6710),
    [anon_sym_BSLASHimport] = ACTIONS(6710),
    [anon_sym_BSLASHsubimport] = ACTIONS(6710),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6710),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHcaption] = ACTIONS(6710),
    [anon_sym_BSLASHcite] = ACTIONS(6710),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCite] = ACTIONS(6710),
    [anon_sym_BSLASHnocite] = ACTIONS(6710),
    [anon_sym_BSLASHcitet] = ACTIONS(6710),
    [anon_sym_BSLASHcitep] = ACTIONS(6710),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteA] = ACTIONS(6710),
    [anon_sym_BSLASHciteR] = ACTIONS(6710),
    [anon_sym_BSLASHciteS] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6710),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteyear] = ACTIONS(6710),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitedate] = ACTIONS(6710),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteurl] = ACTIONS(6710),
    [anon_sym_BSLASHfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6710),
    [anon_sym_BSLASHcitealt] = ACTIONS(6710),
    [anon_sym_BSLASHcitealp] = ACTIONS(6710),
    [anon_sym_BSLASHcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHparencite] = ACTIONS(6710),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHParencite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHtextcite] = ACTIONS(6710),
    [anon_sym_BSLASHTextcite] = ACTIONS(6710),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHsupercite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite] = ACTIONS(6710),
    [anon_sym_BSLASHAutocite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHVolcite] = ACTIONS(6710),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHavolcite] = ACTIONS(6710),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHNotecite] = ACTIONS(6710),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHlabel] = ACTIONS(6710),
    [anon_sym_BSLASHref] = ACTIONS(6710),
    [anon_sym_BSLASHeqref] = ACTIONS(6710),
    [anon_sym_BSLASHvref] = ACTIONS(6710),
    [anon_sym_BSLASHVref] = ACTIONS(6710),
    [anon_sym_BSLASHautoref] = ACTIONS(6710),
    [anon_sym_BSLASHpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcref] = ACTIONS(6710),
    [anon_sym_BSLASHCref] = ACTIONS(6710),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnameCref] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHdef] = ACTIONS(6710),
    [anon_sym_BSLASHlet] = ACTIONS(6710),
    [anon_sym_BSLASHleft] = ACTIONS(6710),
    [anon_sym_BSLASHbigl] = ACTIONS(6710),
    [anon_sym_BSLASHBigl] = ACTIONS(6710),
    [anon_sym_BSLASHbiggl] = ACTIONS(6710),
    [anon_sym_BSLASHBiggl] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6710),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6710),
    [anon_sym_BSLASHgls] = ACTIONS(6710),
    [anon_sym_BSLASHGls] = ACTIONS(6710),
    [anon_sym_BSLASHGLS] = ACTIONS(6710),
    [anon_sym_BSLASHglspl] = ACTIONS(6710),
    [anon_sym_BSLASHGlspl] = ACTIONS(6710),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6710),
    [anon_sym_BSLASHglslink] = ACTIONS(6710),
    [anon_sym_BSLASHglstext] = ACTIONS(6710),
    [anon_sym_BSLASHGlstext] = ACTIONS(6710),
    [anon_sym_BSLASHGLStext] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6710),
    [anon_sym_BSLASHglsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsname] = ACTIONS(6710),
    [anon_sym_BSLASHGlsname] = ACTIONS(6710),
    [anon_sym_BSLASHGLSname] = ACTIONS(6710),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6710),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6710),
    [anon_sym_BSLASHacrshort] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6710),
    [anon_sym_BSLASHACRshort] = ACTIONS(6710),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrlong] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6710),
    [anon_sym_BSLASHACRlong] = ACTIONS(6710),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrfull] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6710),
    [anon_sym_BSLASHACRfull] = ACTIONS(6710),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHacs] = ACTIONS(6710),
    [anon_sym_BSLASHAcs] = ACTIONS(6710),
    [anon_sym_BSLASHacsp] = ACTIONS(6710),
    [anon_sym_BSLASHAcsp] = ACTIONS(6710),
    [anon_sym_BSLASHacl] = ACTIONS(6710),
    [anon_sym_BSLASHAcl] = ACTIONS(6710),
    [anon_sym_BSLASHaclp] = ACTIONS(6710),
    [anon_sym_BSLASHAclp] = ACTIONS(6710),
    [anon_sym_BSLASHacf] = ACTIONS(6710),
    [anon_sym_BSLASHAcf] = ACTIONS(6710),
    [anon_sym_BSLASHacfp] = ACTIONS(6710),
    [anon_sym_BSLASHAcfp] = ACTIONS(6710),
    [anon_sym_BSLASHac] = ACTIONS(6710),
    [anon_sym_BSLASHAc] = ACTIONS(6710),
    [anon_sym_BSLASHacp] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6710),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6710),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6710),
    [anon_sym_BSLASHcolor] = ACTIONS(6710),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6710),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6710),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6710),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6710),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6710),
    [anon_sym_BSLASHtext] = ACTIONS(6710),
    [anon_sym_BSLASHintertext] = ACTIONS(6710),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6710),
    [anon_sym_BSLASHurl] = ACTIONS(6710),
    [anon_sym_BSLASHhref] = ACTIONS(6710),
  },
  [1425] = {
    [sym_command_name] = ACTIONS(6682),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6684),
    [anon_sym_RBRACK] = ACTIONS(6684),
    [anon_sym_COMMA] = ACTIONS(6684),
    [anon_sym_EQ] = ACTIONS(6684),
    [anon_sym_LPAREN] = ACTIONS(6684),
    [anon_sym_RPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHpart] = ACTIONS(6682),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddpart] = ACTIONS(6682),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHchapter] = ACTIONS(6682),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddchap] = ACTIONS(6682),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsection] = ACTIONS(6682),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHaddsec] = ACTIONS(6682),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6682),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6682),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHitem] = ACTIONS(6682),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6684),
    [anon_sym_LBRACE] = ACTIONS(6684),
    [sym_word] = ACTIONS(6682),
    [sym_placeholder] = ACTIONS(6684),
    [anon_sym_PLUS] = ACTIONS(6684),
    [anon_sym_DASH] = ACTIONS(6684),
    [anon_sym_STAR] = ACTIONS(6684),
    [anon_sym_SLASH] = ACTIONS(6684),
    [anon_sym_LT] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6682),
    [anon_sym_BANG] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6682),
    [anon_sym_COLON] = ACTIONS(6682),
    [anon_sym_SQUOTE] = ACTIONS(6682),
    [anon_sym__] = ACTIONS(6684),
    [anon_sym_CARET] = ACTIONS(6684),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6684),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6684),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6684),
    [anon_sym_DOLLAR] = ACTIONS(6682),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHbegin] = ACTIONS(6682),
    [anon_sym_BSLASHtitle] = ACTIONS(6682),
    [anon_sym_BSLASHauthor] = ACTIONS(6682),
    [anon_sym_BSLASHusepackage] = ACTIONS(6682),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6682),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6682),
    [anon_sym_BSLASHinclude] = ACTIONS(6682),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6682),
    [anon_sym_BSLASHinput] = ACTIONS(6682),
    [anon_sym_BSLASHsubfile] = ACTIONS(6682),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6682),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6682),
    [anon_sym_BSLASHbibliography] = ACTIONS(6682),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6682),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6682),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6682),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6682),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6682),
    [anon_sym_BSLASHimport] = ACTIONS(6682),
    [anon_sym_BSLASHsubimport] = ACTIONS(6682),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6682),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHcaption] = ACTIONS(6682),
    [anon_sym_BSLASHcite] = ACTIONS(6682),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCite] = ACTIONS(6682),
    [anon_sym_BSLASHnocite] = ACTIONS(6682),
    [anon_sym_BSLASHcitet] = ACTIONS(6682),
    [anon_sym_BSLASHcitep] = ACTIONS(6682),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteA] = ACTIONS(6682),
    [anon_sym_BSLASHciteR] = ACTIONS(6682),
    [anon_sym_BSLASHciteS] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6682),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteyear] = ACTIONS(6682),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitedate] = ACTIONS(6682),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteurl] = ACTIONS(6682),
    [anon_sym_BSLASHfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6682),
    [anon_sym_BSLASHcitealt] = ACTIONS(6682),
    [anon_sym_BSLASHcitealp] = ACTIONS(6682),
    [anon_sym_BSLASHcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHparencite] = ACTIONS(6682),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHParencite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHtextcite] = ACTIONS(6682),
    [anon_sym_BSLASHTextcite] = ACTIONS(6682),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHsupercite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite] = ACTIONS(6682),
    [anon_sym_BSLASHAutocite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHVolcite] = ACTIONS(6682),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHavolcite] = ACTIONS(6682),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHNotecite] = ACTIONS(6682),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHlabel] = ACTIONS(6682),
    [anon_sym_BSLASHref] = ACTIONS(6682),
    [anon_sym_BSLASHeqref] = ACTIONS(6682),
    [anon_sym_BSLASHvref] = ACTIONS(6682),
    [anon_sym_BSLASHVref] = ACTIONS(6682),
    [anon_sym_BSLASHautoref] = ACTIONS(6682),
    [anon_sym_BSLASHpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcref] = ACTIONS(6682),
    [anon_sym_BSLASHCref] = ACTIONS(6682),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnameCref] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHdef] = ACTIONS(6682),
    [anon_sym_BSLASHlet] = ACTIONS(6682),
    [anon_sym_BSLASHleft] = ACTIONS(6682),
    [anon_sym_BSLASHbigl] = ACTIONS(6682),
    [anon_sym_BSLASHBigl] = ACTIONS(6682),
    [anon_sym_BSLASHbiggl] = ACTIONS(6682),
    [anon_sym_BSLASHBiggl] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6682),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6682),
    [anon_sym_BSLASHgls] = ACTIONS(6682),
    [anon_sym_BSLASHGls] = ACTIONS(6682),
    [anon_sym_BSLASHGLS] = ACTIONS(6682),
    [anon_sym_BSLASHglspl] = ACTIONS(6682),
    [anon_sym_BSLASHGlspl] = ACTIONS(6682),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6682),
    [anon_sym_BSLASHglslink] = ACTIONS(6682),
    [anon_sym_BSLASHglstext] = ACTIONS(6682),
    [anon_sym_BSLASHGlstext] = ACTIONS(6682),
    [anon_sym_BSLASHGLStext] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6682),
    [anon_sym_BSLASHglsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsname] = ACTIONS(6682),
    [anon_sym_BSLASHGlsname] = ACTIONS(6682),
    [anon_sym_BSLASHGLSname] = ACTIONS(6682),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6682),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6682),
    [anon_sym_BSLASHacrshort] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6682),
    [anon_sym_BSLASHACRshort] = ACTIONS(6682),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrlong] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6682),
    [anon_sym_BSLASHACRlong] = ACTIONS(6682),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrfull] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6682),
    [anon_sym_BSLASHACRfull] = ACTIONS(6682),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHacs] = ACTIONS(6682),
    [anon_sym_BSLASHAcs] = ACTIONS(6682),
    [anon_sym_BSLASHacsp] = ACTIONS(6682),
    [anon_sym_BSLASHAcsp] = ACTIONS(6682),
    [anon_sym_BSLASHacl] = ACTIONS(6682),
    [anon_sym_BSLASHAcl] = ACTIONS(6682),
    [anon_sym_BSLASHaclp] = ACTIONS(6682),
    [anon_sym_BSLASHAclp] = ACTIONS(6682),
    [anon_sym_BSLASHacf] = ACTIONS(6682),
    [anon_sym_BSLASHAcf] = ACTIONS(6682),
    [anon_sym_BSLASHacfp] = ACTIONS(6682),
    [anon_sym_BSLASHAcfp] = ACTIONS(6682),
    [anon_sym_BSLASHac] = ACTIONS(6682),
    [anon_sym_BSLASHAc] = ACTIONS(6682),
    [anon_sym_BSLASHacp] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6682),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6682),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6682),
    [anon_sym_BSLASHcolor] = ACTIONS(6682),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6682),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6682),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6682),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6682),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6682),
    [anon_sym_BSLASHtext] = ACTIONS(6682),
    [anon_sym_BSLASHintertext] = ACTIONS(6682),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6682),
    [anon_sym_BSLASHurl] = ACTIONS(6682),
    [anon_sym_BSLASHhref] = ACTIONS(6682),
  },
  [1426] = {
    [sym_command_name] = ACTIONS(6678),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6678),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6680),
    [anon_sym_COMMA] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LPAREN] = ACTIONS(6680),
    [anon_sym_RPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHpart] = ACTIONS(6678),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddpart] = ACTIONS(6678),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHchapter] = ACTIONS(6678),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddchap] = ACTIONS(6678),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsection] = ACTIONS(6678),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHaddsec] = ACTIONS(6678),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6678),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6678),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHitem] = ACTIONS(6678),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6680),
    [anon_sym_LBRACE] = ACTIONS(6680),
    [sym_word] = ACTIONS(6678),
    [sym_placeholder] = ACTIONS(6680),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_DASH] = ACTIONS(6680),
    [anon_sym_STAR] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6678),
    [anon_sym_GT] = ACTIONS(6678),
    [anon_sym_BANG] = ACTIONS(6678),
    [anon_sym_PIPE] = ACTIONS(6678),
    [anon_sym_COLON] = ACTIONS(6678),
    [anon_sym_SQUOTE] = ACTIONS(6678),
    [anon_sym__] = ACTIONS(6680),
    [anon_sym_CARET] = ACTIONS(6680),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6680),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6680),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6680),
    [anon_sym_DOLLAR] = ACTIONS(6678),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHbegin] = ACTIONS(6678),
    [anon_sym_BSLASHtitle] = ACTIONS(6678),
    [anon_sym_BSLASHauthor] = ACTIONS(6678),
    [anon_sym_BSLASHusepackage] = ACTIONS(6678),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6678),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6678),
    [anon_sym_BSLASHinclude] = ACTIONS(6678),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6678),
    [anon_sym_BSLASHinput] = ACTIONS(6678),
    [anon_sym_BSLASHsubfile] = ACTIONS(6678),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6678),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6678),
    [anon_sym_BSLASHbibliography] = ACTIONS(6678),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6678),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6678),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6678),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6678),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6678),
    [anon_sym_BSLASHimport] = ACTIONS(6678),
    [anon_sym_BSLASHsubimport] = ACTIONS(6678),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6678),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHcaption] = ACTIONS(6678),
    [anon_sym_BSLASHcite] = ACTIONS(6678),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCite] = ACTIONS(6678),
    [anon_sym_BSLASHnocite] = ACTIONS(6678),
    [anon_sym_BSLASHcitet] = ACTIONS(6678),
    [anon_sym_BSLASHcitep] = ACTIONS(6678),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteA] = ACTIONS(6678),
    [anon_sym_BSLASHciteR] = ACTIONS(6678),
    [anon_sym_BSLASHciteS] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6678),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteyear] = ACTIONS(6678),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitedate] = ACTIONS(6678),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteurl] = ACTIONS(6678),
    [anon_sym_BSLASHfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6678),
    [anon_sym_BSLASHcitealt] = ACTIONS(6678),
    [anon_sym_BSLASHcitealp] = ACTIONS(6678),
    [anon_sym_BSLASHcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHparencite] = ACTIONS(6678),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHParencite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHtextcite] = ACTIONS(6678),
    [anon_sym_BSLASHTextcite] = ACTIONS(6678),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHsupercite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite] = ACTIONS(6678),
    [anon_sym_BSLASHAutocite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHVolcite] = ACTIONS(6678),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHavolcite] = ACTIONS(6678),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHNotecite] = ACTIONS(6678),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHlabel] = ACTIONS(6678),
    [anon_sym_BSLASHref] = ACTIONS(6678),
    [anon_sym_BSLASHeqref] = ACTIONS(6678),
    [anon_sym_BSLASHvref] = ACTIONS(6678),
    [anon_sym_BSLASHVref] = ACTIONS(6678),
    [anon_sym_BSLASHautoref] = ACTIONS(6678),
    [anon_sym_BSLASHpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcref] = ACTIONS(6678),
    [anon_sym_BSLASHCref] = ACTIONS(6678),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnameCref] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHdef] = ACTIONS(6678),
    [anon_sym_BSLASHlet] = ACTIONS(6678),
    [anon_sym_BSLASHleft] = ACTIONS(6678),
    [anon_sym_BSLASHbigl] = ACTIONS(6678),
    [anon_sym_BSLASHBigl] = ACTIONS(6678),
    [anon_sym_BSLASHbiggl] = ACTIONS(6678),
    [anon_sym_BSLASHBiggl] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6678),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6678),
    [anon_sym_BSLASHgls] = ACTIONS(6678),
    [anon_sym_BSLASHGls] = ACTIONS(6678),
    [anon_sym_BSLASHGLS] = ACTIONS(6678),
    [anon_sym_BSLASHglspl] = ACTIONS(6678),
    [anon_sym_BSLASHGlspl] = ACTIONS(6678),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6678),
    [anon_sym_BSLASHglslink] = ACTIONS(6678),
    [anon_sym_BSLASHglstext] = ACTIONS(6678),
    [anon_sym_BSLASHGlstext] = ACTIONS(6678),
    [anon_sym_BSLASHGLStext] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6678),
    [anon_sym_BSLASHglsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsname] = ACTIONS(6678),
    [anon_sym_BSLASHGlsname] = ACTIONS(6678),
    [anon_sym_BSLASHGLSname] = ACTIONS(6678),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6678),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6678),
    [anon_sym_BSLASHacrshort] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6678),
    [anon_sym_BSLASHACRshort] = ACTIONS(6678),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrlong] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6678),
    [anon_sym_BSLASHACRlong] = ACTIONS(6678),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrfull] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6678),
    [anon_sym_BSLASHACRfull] = ACTIONS(6678),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHacs] = ACTIONS(6678),
    [anon_sym_BSLASHAcs] = ACTIONS(6678),
    [anon_sym_BSLASHacsp] = ACTIONS(6678),
    [anon_sym_BSLASHAcsp] = ACTIONS(6678),
    [anon_sym_BSLASHacl] = ACTIONS(6678),
    [anon_sym_BSLASHAcl] = ACTIONS(6678),
    [anon_sym_BSLASHaclp] = ACTIONS(6678),
    [anon_sym_BSLASHAclp] = ACTIONS(6678),
    [anon_sym_BSLASHacf] = ACTIONS(6678),
    [anon_sym_BSLASHAcf] = ACTIONS(6678),
    [anon_sym_BSLASHacfp] = ACTIONS(6678),
    [anon_sym_BSLASHAcfp] = ACTIONS(6678),
    [anon_sym_BSLASHac] = ACTIONS(6678),
    [anon_sym_BSLASHAc] = ACTIONS(6678),
    [anon_sym_BSLASHacp] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6678),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6678),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6678),
    [anon_sym_BSLASHcolor] = ACTIONS(6678),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6678),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6678),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6678),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6678),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6678),
    [anon_sym_BSLASHtext] = ACTIONS(6678),
    [anon_sym_BSLASHintertext] = ACTIONS(6678),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6678),
    [anon_sym_BSLASHurl] = ACTIONS(6678),
    [anon_sym_BSLASHhref] = ACTIONS(6678),
  },
  [1427] = {
    [sym_command_name] = ACTIONS(6674),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6674),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_RBRACK] = ACTIONS(6676),
    [anon_sym_COMMA] = ACTIONS(6676),
    [anon_sym_EQ] = ACTIONS(6676),
    [anon_sym_LPAREN] = ACTIONS(6676),
    [anon_sym_RPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHpart] = ACTIONS(6674),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddpart] = ACTIONS(6674),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHchapter] = ACTIONS(6674),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddchap] = ACTIONS(6674),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsection] = ACTIONS(6674),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHaddsec] = ACTIONS(6674),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6674),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6674),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHitem] = ACTIONS(6674),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(6676),
    [sym_word] = ACTIONS(6674),
    [sym_placeholder] = ACTIONS(6676),
    [anon_sym_PLUS] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6676),
    [anon_sym_STAR] = ACTIONS(6676),
    [anon_sym_SLASH] = ACTIONS(6676),
    [anon_sym_LT] = ACTIONS(6674),
    [anon_sym_GT] = ACTIONS(6674),
    [anon_sym_BANG] = ACTIONS(6674),
    [anon_sym_PIPE] = ACTIONS(6674),
    [anon_sym_COLON] = ACTIONS(6674),
    [anon_sym_SQUOTE] = ACTIONS(6674),
    [anon_sym__] = ACTIONS(6676),
    [anon_sym_CARET] = ACTIONS(6676),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6676),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6676),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6676),
    [anon_sym_DOLLAR] = ACTIONS(6674),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHbegin] = ACTIONS(6674),
    [anon_sym_BSLASHtitle] = ACTIONS(6674),
    [anon_sym_BSLASHauthor] = ACTIONS(6674),
    [anon_sym_BSLASHusepackage] = ACTIONS(6674),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6674),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6674),
    [anon_sym_BSLASHinclude] = ACTIONS(6674),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6674),
    [anon_sym_BSLASHinput] = ACTIONS(6674),
    [anon_sym_BSLASHsubfile] = ACTIONS(6674),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6674),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6674),
    [anon_sym_BSLASHbibliography] = ACTIONS(6674),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6674),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6674),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6674),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6674),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6674),
    [anon_sym_BSLASHimport] = ACTIONS(6674),
    [anon_sym_BSLASHsubimport] = ACTIONS(6674),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6674),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHcaption] = ACTIONS(6674),
    [anon_sym_BSLASHcite] = ACTIONS(6674),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCite] = ACTIONS(6674),
    [anon_sym_BSLASHnocite] = ACTIONS(6674),
    [anon_sym_BSLASHcitet] = ACTIONS(6674),
    [anon_sym_BSLASHcitep] = ACTIONS(6674),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteA] = ACTIONS(6674),
    [anon_sym_BSLASHciteR] = ACTIONS(6674),
    [anon_sym_BSLASHciteS] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6674),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteyear] = ACTIONS(6674),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitedate] = ACTIONS(6674),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteurl] = ACTIONS(6674),
    [anon_sym_BSLASHfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6674),
    [anon_sym_BSLASHcitealt] = ACTIONS(6674),
    [anon_sym_BSLASHcitealp] = ACTIONS(6674),
    [anon_sym_BSLASHcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHparencite] = ACTIONS(6674),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHParencite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHtextcite] = ACTIONS(6674),
    [anon_sym_BSLASHTextcite] = ACTIONS(6674),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHsupercite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite] = ACTIONS(6674),
    [anon_sym_BSLASHAutocite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHVolcite] = ACTIONS(6674),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHavolcite] = ACTIONS(6674),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHNotecite] = ACTIONS(6674),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHlabel] = ACTIONS(6674),
    [anon_sym_BSLASHref] = ACTIONS(6674),
    [anon_sym_BSLASHeqref] = ACTIONS(6674),
    [anon_sym_BSLASHvref] = ACTIONS(6674),
    [anon_sym_BSLASHVref] = ACTIONS(6674),
    [anon_sym_BSLASHautoref] = ACTIONS(6674),
    [anon_sym_BSLASHpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcref] = ACTIONS(6674),
    [anon_sym_BSLASHCref] = ACTIONS(6674),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnameCref] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHdef] = ACTIONS(6674),
    [anon_sym_BSLASHlet] = ACTIONS(6674),
    [anon_sym_BSLASHleft] = ACTIONS(6674),
    [anon_sym_BSLASHbigl] = ACTIONS(6674),
    [anon_sym_BSLASHBigl] = ACTIONS(6674),
    [anon_sym_BSLASHbiggl] = ACTIONS(6674),
    [anon_sym_BSLASHBiggl] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6674),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6674),
    [anon_sym_BSLASHgls] = ACTIONS(6674),
    [anon_sym_BSLASHGls] = ACTIONS(6674),
    [anon_sym_BSLASHGLS] = ACTIONS(6674),
    [anon_sym_BSLASHglspl] = ACTIONS(6674),
    [anon_sym_BSLASHGlspl] = ACTIONS(6674),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6674),
    [anon_sym_BSLASHglslink] = ACTIONS(6674),
    [anon_sym_BSLASHglstext] = ACTIONS(6674),
    [anon_sym_BSLASHGlstext] = ACTIONS(6674),
    [anon_sym_BSLASHGLStext] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6674),
    [anon_sym_BSLASHglsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsname] = ACTIONS(6674),
    [anon_sym_BSLASHGlsname] = ACTIONS(6674),
    [anon_sym_BSLASHGLSname] = ACTIONS(6674),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6674),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6674),
    [anon_sym_BSLASHacrshort] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6674),
    [anon_sym_BSLASHACRshort] = ACTIONS(6674),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrlong] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6674),
    [anon_sym_BSLASHACRlong] = ACTIONS(6674),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrfull] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6674),
    [anon_sym_BSLASHACRfull] = ACTIONS(6674),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHacs] = ACTIONS(6674),
    [anon_sym_BSLASHAcs] = ACTIONS(6674),
    [anon_sym_BSLASHacsp] = ACTIONS(6674),
    [anon_sym_BSLASHAcsp] = ACTIONS(6674),
    [anon_sym_BSLASHacl] = ACTIONS(6674),
    [anon_sym_BSLASHAcl] = ACTIONS(6674),
    [anon_sym_BSLASHaclp] = ACTIONS(6674),
    [anon_sym_BSLASHAclp] = ACTIONS(6674),
    [anon_sym_BSLASHacf] = ACTIONS(6674),
    [anon_sym_BSLASHAcf] = ACTIONS(6674),
    [anon_sym_BSLASHacfp] = ACTIONS(6674),
    [anon_sym_BSLASHAcfp] = ACTIONS(6674),
    [anon_sym_BSLASHac] = ACTIONS(6674),
    [anon_sym_BSLASHAc] = ACTIONS(6674),
    [anon_sym_BSLASHacp] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6674),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6674),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6674),
    [anon_sym_BSLASHcolor] = ACTIONS(6674),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6674),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6674),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6674),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6674),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6674),
    [anon_sym_BSLASHtext] = ACTIONS(6674),
    [anon_sym_BSLASHintertext] = ACTIONS(6674),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6674),
    [anon_sym_BSLASHurl] = ACTIONS(6674),
    [anon_sym_BSLASHhref] = ACTIONS(6674),
  },
  [1428] = {
    [sym_command_name] = ACTIONS(6666),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6666),
    [anon_sym_LBRACK] = ACTIONS(6668),
    [anon_sym_RBRACK] = ACTIONS(6668),
    [anon_sym_COMMA] = ACTIONS(6668),
    [anon_sym_EQ] = ACTIONS(6668),
    [anon_sym_LPAREN] = ACTIONS(6668),
    [anon_sym_RPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHpart] = ACTIONS(6666),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddpart] = ACTIONS(6666),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHchapter] = ACTIONS(6666),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddchap] = ACTIONS(6666),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsection] = ACTIONS(6666),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHaddsec] = ACTIONS(6666),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6666),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6666),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHitem] = ACTIONS(6666),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6668),
    [anon_sym_LBRACE] = ACTIONS(6668),
    [sym_word] = ACTIONS(6666),
    [sym_placeholder] = ACTIONS(6668),
    [anon_sym_PLUS] = ACTIONS(6668),
    [anon_sym_DASH] = ACTIONS(6668),
    [anon_sym_STAR] = ACTIONS(6668),
    [anon_sym_SLASH] = ACTIONS(6668),
    [anon_sym_LT] = ACTIONS(6666),
    [anon_sym_GT] = ACTIONS(6666),
    [anon_sym_BANG] = ACTIONS(6666),
    [anon_sym_PIPE] = ACTIONS(6666),
    [anon_sym_COLON] = ACTIONS(6666),
    [anon_sym_SQUOTE] = ACTIONS(6666),
    [anon_sym__] = ACTIONS(6668),
    [anon_sym_CARET] = ACTIONS(6668),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6668),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6668),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6668),
    [anon_sym_DOLLAR] = ACTIONS(6666),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHbegin] = ACTIONS(6666),
    [anon_sym_BSLASHtitle] = ACTIONS(6666),
    [anon_sym_BSLASHauthor] = ACTIONS(6666),
    [anon_sym_BSLASHusepackage] = ACTIONS(6666),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6666),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6666),
    [anon_sym_BSLASHinclude] = ACTIONS(6666),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6666),
    [anon_sym_BSLASHinput] = ACTIONS(6666),
    [anon_sym_BSLASHsubfile] = ACTIONS(6666),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6666),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6666),
    [anon_sym_BSLASHbibliography] = ACTIONS(6666),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6666),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6666),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6666),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6666),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6666),
    [anon_sym_BSLASHimport] = ACTIONS(6666),
    [anon_sym_BSLASHsubimport] = ACTIONS(6666),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6666),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHcaption] = ACTIONS(6666),
    [anon_sym_BSLASHcite] = ACTIONS(6666),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCite] = ACTIONS(6666),
    [anon_sym_BSLASHnocite] = ACTIONS(6666),
    [anon_sym_BSLASHcitet] = ACTIONS(6666),
    [anon_sym_BSLASHcitep] = ACTIONS(6666),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteA] = ACTIONS(6666),
    [anon_sym_BSLASHciteR] = ACTIONS(6666),
    [anon_sym_BSLASHciteS] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6666),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteyear] = ACTIONS(6666),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitedate] = ACTIONS(6666),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteurl] = ACTIONS(6666),
    [anon_sym_BSLASHfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6666),
    [anon_sym_BSLASHcitealt] = ACTIONS(6666),
    [anon_sym_BSLASHcitealp] = ACTIONS(6666),
    [anon_sym_BSLASHcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHparencite] = ACTIONS(6666),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHParencite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHtextcite] = ACTIONS(6666),
    [anon_sym_BSLASHTextcite] = ACTIONS(6666),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHsupercite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite] = ACTIONS(6666),
    [anon_sym_BSLASHAutocite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHVolcite] = ACTIONS(6666),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHavolcite] = ACTIONS(6666),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHNotecite] = ACTIONS(6666),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHlabel] = ACTIONS(6666),
    [anon_sym_BSLASHref] = ACTIONS(6666),
    [anon_sym_BSLASHeqref] = ACTIONS(6666),
    [anon_sym_BSLASHvref] = ACTIONS(6666),
    [anon_sym_BSLASHVref] = ACTIONS(6666),
    [anon_sym_BSLASHautoref] = ACTIONS(6666),
    [anon_sym_BSLASHpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcref] = ACTIONS(6666),
    [anon_sym_BSLASHCref] = ACTIONS(6666),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnameCref] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHdef] = ACTIONS(6666),
    [anon_sym_BSLASHlet] = ACTIONS(6666),
    [anon_sym_BSLASHleft] = ACTIONS(6666),
    [anon_sym_BSLASHbigl] = ACTIONS(6666),
    [anon_sym_BSLASHBigl] = ACTIONS(6666),
    [anon_sym_BSLASHbiggl] = ACTIONS(6666),
    [anon_sym_BSLASHBiggl] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6666),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6666),
    [anon_sym_BSLASHgls] = ACTIONS(6666),
    [anon_sym_BSLASHGls] = ACTIONS(6666),
    [anon_sym_BSLASHGLS] = ACTIONS(6666),
    [anon_sym_BSLASHglspl] = ACTIONS(6666),
    [anon_sym_BSLASHGlspl] = ACTIONS(6666),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6666),
    [anon_sym_BSLASHglslink] = ACTIONS(6666),
    [anon_sym_BSLASHglstext] = ACTIONS(6666),
    [anon_sym_BSLASHGlstext] = ACTIONS(6666),
    [anon_sym_BSLASHGLStext] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6666),
    [anon_sym_BSLASHglsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsname] = ACTIONS(6666),
    [anon_sym_BSLASHGlsname] = ACTIONS(6666),
    [anon_sym_BSLASHGLSname] = ACTIONS(6666),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6666),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6666),
    [anon_sym_BSLASHacrshort] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6666),
    [anon_sym_BSLASHACRshort] = ACTIONS(6666),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrlong] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6666),
    [anon_sym_BSLASHACRlong] = ACTIONS(6666),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrfull] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6666),
    [anon_sym_BSLASHACRfull] = ACTIONS(6666),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHacs] = ACTIONS(6666),
    [anon_sym_BSLASHAcs] = ACTIONS(6666),
    [anon_sym_BSLASHacsp] = ACTIONS(6666),
    [anon_sym_BSLASHAcsp] = ACTIONS(6666),
    [anon_sym_BSLASHacl] = ACTIONS(6666),
    [anon_sym_BSLASHAcl] = ACTIONS(6666),
    [anon_sym_BSLASHaclp] = ACTIONS(6666),
    [anon_sym_BSLASHAclp] = ACTIONS(6666),
    [anon_sym_BSLASHacf] = ACTIONS(6666),
    [anon_sym_BSLASHAcf] = ACTIONS(6666),
    [anon_sym_BSLASHacfp] = ACTIONS(6666),
    [anon_sym_BSLASHAcfp] = ACTIONS(6666),
    [anon_sym_BSLASHac] = ACTIONS(6666),
    [anon_sym_BSLASHAc] = ACTIONS(6666),
    [anon_sym_BSLASHacp] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6666),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6666),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6666),
    [anon_sym_BSLASHcolor] = ACTIONS(6666),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6666),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6666),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6666),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6666),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6666),
    [anon_sym_BSLASHtext] = ACTIONS(6666),
    [anon_sym_BSLASHintertext] = ACTIONS(6666),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6666),
    [anon_sym_BSLASHurl] = ACTIONS(6666),
    [anon_sym_BSLASHhref] = ACTIONS(6666),
  },
  [1429] = {
    [sym_command_name] = ACTIONS(6662),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6662),
    [anon_sym_LBRACK] = ACTIONS(6664),
    [anon_sym_RBRACK] = ACTIONS(6664),
    [anon_sym_COMMA] = ACTIONS(6664),
    [anon_sym_EQ] = ACTIONS(6664),
    [anon_sym_LPAREN] = ACTIONS(6664),
    [anon_sym_RPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHpart] = ACTIONS(6662),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddpart] = ACTIONS(6662),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHchapter] = ACTIONS(6662),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddchap] = ACTIONS(6662),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsection] = ACTIONS(6662),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHaddsec] = ACTIONS(6662),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6662),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6662),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHitem] = ACTIONS(6662),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6664),
    [anon_sym_LBRACE] = ACTIONS(6664),
    [sym_word] = ACTIONS(6662),
    [sym_placeholder] = ACTIONS(6664),
    [anon_sym_PLUS] = ACTIONS(6664),
    [anon_sym_DASH] = ACTIONS(6664),
    [anon_sym_STAR] = ACTIONS(6664),
    [anon_sym_SLASH] = ACTIONS(6664),
    [anon_sym_LT] = ACTIONS(6662),
    [anon_sym_GT] = ACTIONS(6662),
    [anon_sym_BANG] = ACTIONS(6662),
    [anon_sym_PIPE] = ACTIONS(6662),
    [anon_sym_COLON] = ACTIONS(6662),
    [anon_sym_SQUOTE] = ACTIONS(6662),
    [anon_sym__] = ACTIONS(6664),
    [anon_sym_CARET] = ACTIONS(6664),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6664),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6664),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6664),
    [anon_sym_DOLLAR] = ACTIONS(6662),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHbegin] = ACTIONS(6662),
    [anon_sym_BSLASHtitle] = ACTIONS(6662),
    [anon_sym_BSLASHauthor] = ACTIONS(6662),
    [anon_sym_BSLASHusepackage] = ACTIONS(6662),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6662),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6662),
    [anon_sym_BSLASHinclude] = ACTIONS(6662),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6662),
    [anon_sym_BSLASHinput] = ACTIONS(6662),
    [anon_sym_BSLASHsubfile] = ACTIONS(6662),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6662),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6662),
    [anon_sym_BSLASHbibliography] = ACTIONS(6662),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6662),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6662),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6662),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6662),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6662),
    [anon_sym_BSLASHimport] = ACTIONS(6662),
    [anon_sym_BSLASHsubimport] = ACTIONS(6662),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6662),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHcaption] = ACTIONS(6662),
    [anon_sym_BSLASHcite] = ACTIONS(6662),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCite] = ACTIONS(6662),
    [anon_sym_BSLASHnocite] = ACTIONS(6662),
    [anon_sym_BSLASHcitet] = ACTIONS(6662),
    [anon_sym_BSLASHcitep] = ACTIONS(6662),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteA] = ACTIONS(6662),
    [anon_sym_BSLASHciteR] = ACTIONS(6662),
    [anon_sym_BSLASHciteS] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6662),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteyear] = ACTIONS(6662),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitedate] = ACTIONS(6662),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteurl] = ACTIONS(6662),
    [anon_sym_BSLASHfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6662),
    [anon_sym_BSLASHcitealt] = ACTIONS(6662),
    [anon_sym_BSLASHcitealp] = ACTIONS(6662),
    [anon_sym_BSLASHcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHparencite] = ACTIONS(6662),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHParencite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHtextcite] = ACTIONS(6662),
    [anon_sym_BSLASHTextcite] = ACTIONS(6662),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHsupercite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite] = ACTIONS(6662),
    [anon_sym_BSLASHAutocite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHVolcite] = ACTIONS(6662),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHavolcite] = ACTIONS(6662),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHNotecite] = ACTIONS(6662),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHlabel] = ACTIONS(6662),
    [anon_sym_BSLASHref] = ACTIONS(6662),
    [anon_sym_BSLASHeqref] = ACTIONS(6662),
    [anon_sym_BSLASHvref] = ACTIONS(6662),
    [anon_sym_BSLASHVref] = ACTIONS(6662),
    [anon_sym_BSLASHautoref] = ACTIONS(6662),
    [anon_sym_BSLASHpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcref] = ACTIONS(6662),
    [anon_sym_BSLASHCref] = ACTIONS(6662),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnameCref] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHdef] = ACTIONS(6662),
    [anon_sym_BSLASHlet] = ACTIONS(6662),
    [anon_sym_BSLASHleft] = ACTIONS(6662),
    [anon_sym_BSLASHbigl] = ACTIONS(6662),
    [anon_sym_BSLASHBigl] = ACTIONS(6662),
    [anon_sym_BSLASHbiggl] = ACTIONS(6662),
    [anon_sym_BSLASHBiggl] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6662),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6662),
    [anon_sym_BSLASHgls] = ACTIONS(6662),
    [anon_sym_BSLASHGls] = ACTIONS(6662),
    [anon_sym_BSLASHGLS] = ACTIONS(6662),
    [anon_sym_BSLASHglspl] = ACTIONS(6662),
    [anon_sym_BSLASHGlspl] = ACTIONS(6662),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6662),
    [anon_sym_BSLASHglslink] = ACTIONS(6662),
    [anon_sym_BSLASHglstext] = ACTIONS(6662),
    [anon_sym_BSLASHGlstext] = ACTIONS(6662),
    [anon_sym_BSLASHGLStext] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6662),
    [anon_sym_BSLASHglsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsname] = ACTIONS(6662),
    [anon_sym_BSLASHGlsname] = ACTIONS(6662),
    [anon_sym_BSLASHGLSname] = ACTIONS(6662),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6662),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6662),
    [anon_sym_BSLASHacrshort] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6662),
    [anon_sym_BSLASHACRshort] = ACTIONS(6662),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrlong] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6662),
    [anon_sym_BSLASHACRlong] = ACTIONS(6662),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrfull] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6662),
    [anon_sym_BSLASHACRfull] = ACTIONS(6662),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHacs] = ACTIONS(6662),
    [anon_sym_BSLASHAcs] = ACTIONS(6662),
    [anon_sym_BSLASHacsp] = ACTIONS(6662),
    [anon_sym_BSLASHAcsp] = ACTIONS(6662),
    [anon_sym_BSLASHacl] = ACTIONS(6662),
    [anon_sym_BSLASHAcl] = ACTIONS(6662),
    [anon_sym_BSLASHaclp] = ACTIONS(6662),
    [anon_sym_BSLASHAclp] = ACTIONS(6662),
    [anon_sym_BSLASHacf] = ACTIONS(6662),
    [anon_sym_BSLASHAcf] = ACTIONS(6662),
    [anon_sym_BSLASHacfp] = ACTIONS(6662),
    [anon_sym_BSLASHAcfp] = ACTIONS(6662),
    [anon_sym_BSLASHac] = ACTIONS(6662),
    [anon_sym_BSLASHAc] = ACTIONS(6662),
    [anon_sym_BSLASHacp] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6662),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6662),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6662),
    [anon_sym_BSLASHcolor] = ACTIONS(6662),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6662),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6662),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6662),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6662),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6662),
    [anon_sym_BSLASHtext] = ACTIONS(6662),
    [anon_sym_BSLASHintertext] = ACTIONS(6662),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6662),
    [anon_sym_BSLASHurl] = ACTIONS(6662),
    [anon_sym_BSLASHhref] = ACTIONS(6662),
  },
  [1430] = {
    [sym_command_name] = ACTIONS(6658),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6658),
    [anon_sym_LBRACK] = ACTIONS(6660),
    [anon_sym_RBRACK] = ACTIONS(6660),
    [anon_sym_COMMA] = ACTIONS(6660),
    [anon_sym_EQ] = ACTIONS(6660),
    [anon_sym_LPAREN] = ACTIONS(6660),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHpart] = ACTIONS(6658),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddpart] = ACTIONS(6658),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHchapter] = ACTIONS(6658),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddchap] = ACTIONS(6658),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsection] = ACTIONS(6658),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHaddsec] = ACTIONS(6658),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6658),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6658),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHitem] = ACTIONS(6658),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6660),
    [anon_sym_LBRACE] = ACTIONS(6660),
    [sym_word] = ACTIONS(6658),
    [sym_placeholder] = ACTIONS(6660),
    [anon_sym_PLUS] = ACTIONS(6660),
    [anon_sym_DASH] = ACTIONS(6660),
    [anon_sym_STAR] = ACTIONS(6660),
    [anon_sym_SLASH] = ACTIONS(6660),
    [anon_sym_LT] = ACTIONS(6658),
    [anon_sym_GT] = ACTIONS(6658),
    [anon_sym_BANG] = ACTIONS(6658),
    [anon_sym_PIPE] = ACTIONS(6658),
    [anon_sym_COLON] = ACTIONS(6658),
    [anon_sym_SQUOTE] = ACTIONS(6658),
    [anon_sym__] = ACTIONS(6660),
    [anon_sym_CARET] = ACTIONS(6660),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6660),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6660),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6660),
    [anon_sym_DOLLAR] = ACTIONS(6658),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHbegin] = ACTIONS(6658),
    [anon_sym_BSLASHtitle] = ACTIONS(6658),
    [anon_sym_BSLASHauthor] = ACTIONS(6658),
    [anon_sym_BSLASHusepackage] = ACTIONS(6658),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6658),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6658),
    [anon_sym_BSLASHinclude] = ACTIONS(6658),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6658),
    [anon_sym_BSLASHinput] = ACTIONS(6658),
    [anon_sym_BSLASHsubfile] = ACTIONS(6658),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6658),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6658),
    [anon_sym_BSLASHbibliography] = ACTIONS(6658),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6658),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6658),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6658),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6658),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6658),
    [anon_sym_BSLASHimport] = ACTIONS(6658),
    [anon_sym_BSLASHsubimport] = ACTIONS(6658),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6658),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHcaption] = ACTIONS(6658),
    [anon_sym_BSLASHcite] = ACTIONS(6658),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCite] = ACTIONS(6658),
    [anon_sym_BSLASHnocite] = ACTIONS(6658),
    [anon_sym_BSLASHcitet] = ACTIONS(6658),
    [anon_sym_BSLASHcitep] = ACTIONS(6658),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteA] = ACTIONS(6658),
    [anon_sym_BSLASHciteR] = ACTIONS(6658),
    [anon_sym_BSLASHciteS] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6658),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteyear] = ACTIONS(6658),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitedate] = ACTIONS(6658),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteurl] = ACTIONS(6658),
    [anon_sym_BSLASHfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6658),
    [anon_sym_BSLASHcitealt] = ACTIONS(6658),
    [anon_sym_BSLASHcitealp] = ACTIONS(6658),
    [anon_sym_BSLASHcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHparencite] = ACTIONS(6658),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHParencite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHtextcite] = ACTIONS(6658),
    [anon_sym_BSLASHTextcite] = ACTIONS(6658),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHsupercite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite] = ACTIONS(6658),
    [anon_sym_BSLASHAutocite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHVolcite] = ACTIONS(6658),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHavolcite] = ACTIONS(6658),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHNotecite] = ACTIONS(6658),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHlabel] = ACTIONS(6658),
    [anon_sym_BSLASHref] = ACTIONS(6658),
    [anon_sym_BSLASHeqref] = ACTIONS(6658),
    [anon_sym_BSLASHvref] = ACTIONS(6658),
    [anon_sym_BSLASHVref] = ACTIONS(6658),
    [anon_sym_BSLASHautoref] = ACTIONS(6658),
    [anon_sym_BSLASHpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcref] = ACTIONS(6658),
    [anon_sym_BSLASHCref] = ACTIONS(6658),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnameCref] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHdef] = ACTIONS(6658),
    [anon_sym_BSLASHlet] = ACTIONS(6658),
    [anon_sym_BSLASHleft] = ACTIONS(6658),
    [anon_sym_BSLASHbigl] = ACTIONS(6658),
    [anon_sym_BSLASHBigl] = ACTIONS(6658),
    [anon_sym_BSLASHbiggl] = ACTIONS(6658),
    [anon_sym_BSLASHBiggl] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6658),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6658),
    [anon_sym_BSLASHgls] = ACTIONS(6658),
    [anon_sym_BSLASHGls] = ACTIONS(6658),
    [anon_sym_BSLASHGLS] = ACTIONS(6658),
    [anon_sym_BSLASHglspl] = ACTIONS(6658),
    [anon_sym_BSLASHGlspl] = ACTIONS(6658),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6658),
    [anon_sym_BSLASHglslink] = ACTIONS(6658),
    [anon_sym_BSLASHglstext] = ACTIONS(6658),
    [anon_sym_BSLASHGlstext] = ACTIONS(6658),
    [anon_sym_BSLASHGLStext] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6658),
    [anon_sym_BSLASHglsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsname] = ACTIONS(6658),
    [anon_sym_BSLASHGlsname] = ACTIONS(6658),
    [anon_sym_BSLASHGLSname] = ACTIONS(6658),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6658),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6658),
    [anon_sym_BSLASHacrshort] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6658),
    [anon_sym_BSLASHACRshort] = ACTIONS(6658),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrlong] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6658),
    [anon_sym_BSLASHACRlong] = ACTIONS(6658),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrfull] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6658),
    [anon_sym_BSLASHACRfull] = ACTIONS(6658),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHacs] = ACTIONS(6658),
    [anon_sym_BSLASHAcs] = ACTIONS(6658),
    [anon_sym_BSLASHacsp] = ACTIONS(6658),
    [anon_sym_BSLASHAcsp] = ACTIONS(6658),
    [anon_sym_BSLASHacl] = ACTIONS(6658),
    [anon_sym_BSLASHAcl] = ACTIONS(6658),
    [anon_sym_BSLASHaclp] = ACTIONS(6658),
    [anon_sym_BSLASHAclp] = ACTIONS(6658),
    [anon_sym_BSLASHacf] = ACTIONS(6658),
    [anon_sym_BSLASHAcf] = ACTIONS(6658),
    [anon_sym_BSLASHacfp] = ACTIONS(6658),
    [anon_sym_BSLASHAcfp] = ACTIONS(6658),
    [anon_sym_BSLASHac] = ACTIONS(6658),
    [anon_sym_BSLASHAc] = ACTIONS(6658),
    [anon_sym_BSLASHacp] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6658),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6658),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6658),
    [anon_sym_BSLASHcolor] = ACTIONS(6658),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6658),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6658),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6658),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6658),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6658),
    [anon_sym_BSLASHtext] = ACTIONS(6658),
    [anon_sym_BSLASHintertext] = ACTIONS(6658),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6658),
    [anon_sym_BSLASHurl] = ACTIONS(6658),
    [anon_sym_BSLASHhref] = ACTIONS(6658),
  },
  [1431] = {
    [sym_command_name] = ACTIONS(7097),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7097),
    [anon_sym_LBRACK] = ACTIONS(7099),
    [anon_sym_RBRACK] = ACTIONS(7099),
    [anon_sym_COMMA] = ACTIONS(7099),
    [anon_sym_EQ] = ACTIONS(7099),
    [anon_sym_LPAREN] = ACTIONS(7099),
    [anon_sym_RPAREN] = ACTIONS(7099),
    [anon_sym_BSLASHpart] = ACTIONS(7097),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHaddpart] = ACTIONS(7097),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHchapter] = ACTIONS(7097),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHaddchap] = ACTIONS(7097),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHsection] = ACTIONS(7097),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHaddsec] = ACTIONS(7097),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHsubsection] = ACTIONS(7097),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(7097),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHparagraph] = ACTIONS(7097),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(7097),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHitem] = ACTIONS(7097),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(7099),
    [anon_sym_LBRACE] = ACTIONS(7099),
    [sym_word] = ACTIONS(7097),
    [sym_placeholder] = ACTIONS(7099),
    [anon_sym_PLUS] = ACTIONS(7099),
    [anon_sym_DASH] = ACTIONS(7099),
    [anon_sym_STAR] = ACTIONS(7099),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_LT] = ACTIONS(7097),
    [anon_sym_GT] = ACTIONS(7097),
    [anon_sym_BANG] = ACTIONS(7097),
    [anon_sym_PIPE] = ACTIONS(7097),
    [anon_sym_COLON] = ACTIONS(7097),
    [anon_sym_SQUOTE] = ACTIONS(7097),
    [anon_sym__] = ACTIONS(7099),
    [anon_sym_CARET] = ACTIONS(7099),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7099),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7099),
    [anon_sym_DOLLAR] = ACTIONS(7097),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7099),
    [anon_sym_BSLASHbegin] = ACTIONS(7097),
    [anon_sym_BSLASHend] = ACTIONS(7097),
    [anon_sym_BSLASHtitle] = ACTIONS(7097),
    [anon_sym_BSLASHauthor] = ACTIONS(7097),
    [anon_sym_BSLASHusepackage] = ACTIONS(7097),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7097),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7097),
    [anon_sym_BSLASHinclude] = ACTIONS(7097),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7097),
    [anon_sym_BSLASHinput] = ACTIONS(7097),
    [anon_sym_BSLASHsubfile] = ACTIONS(7097),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7097),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7097),
    [anon_sym_BSLASHbibliography] = ACTIONS(7097),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7097),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7097),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7097),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7097),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7097),
    [anon_sym_BSLASHimport] = ACTIONS(7097),
    [anon_sym_BSLASHsubimport] = ACTIONS(7097),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7097),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7097),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7097),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7097),
    [anon_sym_BSLASHcaption] = ACTIONS(7097),
    [anon_sym_BSLASHcite] = ACTIONS(7097),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCite] = ACTIONS(7097),
    [anon_sym_BSLASHnocite] = ACTIONS(7097),
    [anon_sym_BSLASHcitet] = ACTIONS(7097),
    [anon_sym_BSLASHcitep] = ACTIONS(7097),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHciteA] = ACTIONS(7097),
    [anon_sym_BSLASHciteR] = ACTIONS(7097),
    [anon_sym_BSLASHciteS] = ACTIONS(7097),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7097),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7097),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7097),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7097),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHciteyear] = ACTIONS(7097),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHcitedate] = ACTIONS(7097),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHciteurl] = ACTIONS(7097),
    [anon_sym_BSLASHfullcite] = ACTIONS(7097),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7097),
    [anon_sym_BSLASHcitealt] = ACTIONS(7097),
    [anon_sym_BSLASHcitealp] = ACTIONS(7097),
    [anon_sym_BSLASHcitetext] = ACTIONS(7097),
    [anon_sym_BSLASHparencite] = ACTIONS(7097),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHParencite] = ACTIONS(7097),
    [anon_sym_BSLASHfootcite] = ACTIONS(7097),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7097),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7097),
    [anon_sym_BSLASHtextcite] = ACTIONS(7097),
    [anon_sym_BSLASHTextcite] = ACTIONS(7097),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7097),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7097),
    [anon_sym_BSLASHsupercite] = ACTIONS(7097),
    [anon_sym_BSLASHautocite] = ACTIONS(7097),
    [anon_sym_BSLASHAutocite] = ACTIONS(7097),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHVolcite] = ACTIONS(7097),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHavolcite] = ACTIONS(7097),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHNotecite] = ACTIONS(7097),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHlabel] = ACTIONS(7097),
    [anon_sym_BSLASHref] = ACTIONS(7097),
    [anon_sym_BSLASHeqref] = ACTIONS(7097),
    [anon_sym_BSLASHvref] = ACTIONS(7097),
    [anon_sym_BSLASHVref] = ACTIONS(7097),
    [anon_sym_BSLASHautoref] = ACTIONS(7097),
    [anon_sym_BSLASHpageref] = ACTIONS(7097),
    [anon_sym_BSLASHcref] = ACTIONS(7097),
    [anon_sym_BSLASHCref] = ACTIONS(7097),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHnamecref] = ACTIONS(7097),
    [anon_sym_BSLASHnameCref] = ACTIONS(7097),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7097),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7097),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7097),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7097),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7097),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7097),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7097),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7097),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7097),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7097),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7097),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHdef] = ACTIONS(7097),
    [anon_sym_BSLASHlet] = ACTIONS(7097),
    [anon_sym_BSLASHleft] = ACTIONS(7097),
    [anon_sym_BSLASHbigl] = ACTIONS(7097),
    [anon_sym_BSLASHBigl] = ACTIONS(7097),
    [anon_sym_BSLASHbiggl] = ACTIONS(7097),
    [anon_sym_BSLASHBiggl] = ACTIONS(7097),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7097),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7097),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7097),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7097),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7097),
    [anon_sym_BSLASHgls] = ACTIONS(7097),
    [anon_sym_BSLASHGls] = ACTIONS(7097),
    [anon_sym_BSLASHGLS] = ACTIONS(7097),
    [anon_sym_BSLASHglspl] = ACTIONS(7097),
    [anon_sym_BSLASHGlspl] = ACTIONS(7097),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7097),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7097),
    [anon_sym_BSLASHglslink] = ACTIONS(7097),
    [anon_sym_BSLASHglstext] = ACTIONS(7097),
    [anon_sym_BSLASHGlstext] = ACTIONS(7097),
    [anon_sym_BSLASHGLStext] = ACTIONS(7097),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7097),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7097),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7097),
    [anon_sym_BSLASHglsplural] = ACTIONS(7097),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7097),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7097),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7097),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7097),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7097),
    [anon_sym_BSLASHglsname] = ACTIONS(7097),
    [anon_sym_BSLASHGlsname] = ACTIONS(7097),
    [anon_sym_BSLASHGLSname] = ACTIONS(7097),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7097),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7097),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7097),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7097),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7097),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7097),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7097),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7097),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7097),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7097),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7097),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7097),
    [anon_sym_BSLASHacrshort] = ACTIONS(7097),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7097),
    [anon_sym_BSLASHACRshort] = ACTIONS(7097),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHacrlong] = ACTIONS(7097),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7097),
    [anon_sym_BSLASHACRlong] = ACTIONS(7097),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7097),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7097),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7097),
    [anon_sym_BSLASHacrfull] = ACTIONS(7097),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7097),
    [anon_sym_BSLASHACRfull] = ACTIONS(7097),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHacs] = ACTIONS(7097),
    [anon_sym_BSLASHAcs] = ACTIONS(7097),
    [anon_sym_BSLASHacsp] = ACTIONS(7097),
    [anon_sym_BSLASHAcsp] = ACTIONS(7097),
    [anon_sym_BSLASHacl] = ACTIONS(7097),
    [anon_sym_BSLASHAcl] = ACTIONS(7097),
    [anon_sym_BSLASHaclp] = ACTIONS(7097),
    [anon_sym_BSLASHAclp] = ACTIONS(7097),
    [anon_sym_BSLASHacf] = ACTIONS(7097),
    [anon_sym_BSLASHAcf] = ACTIONS(7097),
    [anon_sym_BSLASHacfp] = ACTIONS(7097),
    [anon_sym_BSLASHAcfp] = ACTIONS(7097),
    [anon_sym_BSLASHac] = ACTIONS(7097),
    [anon_sym_BSLASHAc] = ACTIONS(7097),
    [anon_sym_BSLASHacp] = ACTIONS(7097),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7097),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7097),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7097),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7097),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7097),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7097),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7097),
    [anon_sym_BSLASHcolor] = ACTIONS(7097),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7097),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7097),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7097),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7097),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7097),
    [anon_sym_BSLASHtext] = ACTIONS(7097),
    [anon_sym_BSLASHintertext] = ACTIONS(7097),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7097),
    [anon_sym_BSLASHurl] = ACTIONS(7097),
    [anon_sym_BSLASHhref] = ACTIONS(7097),
  },
  [1432] = {
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6280),
    [anon_sym_RBRACK] = ACTIONS(6280),
    [anon_sym_COMMA] = ACTIONS(6280),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_RPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHpart] = ACTIONS(6278),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddpart] = ACTIONS(6278),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHchapter] = ACTIONS(6278),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddchap] = ACTIONS(6278),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsection] = ACTIONS(6278),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHaddsec] = ACTIONS(6278),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6278),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6278),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHitem] = ACTIONS(6278),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6280),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6280),
    [anon_sym_DOLLAR] = ACTIONS(6278),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHbegin] = ACTIONS(6278),
    [anon_sym_BSLASHend] = ACTIONS(6278),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHleft] = ACTIONS(6278),
    [anon_sym_BSLASHbigl] = ACTIONS(6278),
    [anon_sym_BSLASHBigl] = ACTIONS(6278),
    [anon_sym_BSLASHbiggl] = ACTIONS(6278),
    [anon_sym_BSLASHBiggl] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHtext] = ACTIONS(6278),
    [anon_sym_BSLASHintertext] = ACTIONS(6278),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [1433] = {
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHpart] = ACTIONS(6502),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddpart] = ACTIONS(6502),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHchapter] = ACTIONS(6502),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddchap] = ACTIONS(6502),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsection] = ACTIONS(6502),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHaddsec] = ACTIONS(6502),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6502),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6502),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHitem] = ACTIONS(6502),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6504),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6504),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6504),
    [anon_sym_DOLLAR] = ACTIONS(6502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHbegin] = ACTIONS(6502),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHleft] = ACTIONS(6502),
    [anon_sym_BSLASHbigl] = ACTIONS(6502),
    [anon_sym_BSLASHBigl] = ACTIONS(6502),
    [anon_sym_BSLASHbiggl] = ACTIONS(6502),
    [anon_sym_BSLASHBiggl] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHtext] = ACTIONS(6502),
    [anon_sym_BSLASHintertext] = ACTIONS(6502),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [1434] = {
    [sym_command_name] = ACTIONS(6650),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6650),
    [anon_sym_LBRACK] = ACTIONS(6652),
    [anon_sym_RBRACK] = ACTIONS(6652),
    [anon_sym_COMMA] = ACTIONS(6652),
    [anon_sym_EQ] = ACTIONS(6652),
    [anon_sym_LPAREN] = ACTIONS(6652),
    [anon_sym_RPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHpart] = ACTIONS(6650),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddpart] = ACTIONS(6650),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHchapter] = ACTIONS(6650),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddchap] = ACTIONS(6650),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsection] = ACTIONS(6650),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHaddsec] = ACTIONS(6650),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6650),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6650),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHitem] = ACTIONS(6650),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6652),
    [anon_sym_LBRACE] = ACTIONS(6652),
    [sym_word] = ACTIONS(6650),
    [sym_placeholder] = ACTIONS(6652),
    [anon_sym_PLUS] = ACTIONS(6652),
    [anon_sym_DASH] = ACTIONS(6652),
    [anon_sym_STAR] = ACTIONS(6652),
    [anon_sym_SLASH] = ACTIONS(6652),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_BANG] = ACTIONS(6650),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_COLON] = ACTIONS(6650),
    [anon_sym_SQUOTE] = ACTIONS(6650),
    [anon_sym__] = ACTIONS(6652),
    [anon_sym_CARET] = ACTIONS(6652),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6652),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6652),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6652),
    [anon_sym_DOLLAR] = ACTIONS(6650),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHbegin] = ACTIONS(6650),
    [anon_sym_BSLASHtitle] = ACTIONS(6650),
    [anon_sym_BSLASHauthor] = ACTIONS(6650),
    [anon_sym_BSLASHusepackage] = ACTIONS(6650),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6650),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6650),
    [anon_sym_BSLASHinclude] = ACTIONS(6650),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6650),
    [anon_sym_BSLASHinput] = ACTIONS(6650),
    [anon_sym_BSLASHsubfile] = ACTIONS(6650),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6650),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6650),
    [anon_sym_BSLASHbibliography] = ACTIONS(6650),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6650),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6650),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6650),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6650),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6650),
    [anon_sym_BSLASHimport] = ACTIONS(6650),
    [anon_sym_BSLASHsubimport] = ACTIONS(6650),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6650),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHcaption] = ACTIONS(6650),
    [anon_sym_BSLASHcite] = ACTIONS(6650),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCite] = ACTIONS(6650),
    [anon_sym_BSLASHnocite] = ACTIONS(6650),
    [anon_sym_BSLASHcitet] = ACTIONS(6650),
    [anon_sym_BSLASHcitep] = ACTIONS(6650),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteA] = ACTIONS(6650),
    [anon_sym_BSLASHciteR] = ACTIONS(6650),
    [anon_sym_BSLASHciteS] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6650),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteyear] = ACTIONS(6650),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitedate] = ACTIONS(6650),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteurl] = ACTIONS(6650),
    [anon_sym_BSLASHfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6650),
    [anon_sym_BSLASHcitealt] = ACTIONS(6650),
    [anon_sym_BSLASHcitealp] = ACTIONS(6650),
    [anon_sym_BSLASHcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHparencite] = ACTIONS(6650),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHParencite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHtextcite] = ACTIONS(6650),
    [anon_sym_BSLASHTextcite] = ACTIONS(6650),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHsupercite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite] = ACTIONS(6650),
    [anon_sym_BSLASHAutocite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHVolcite] = ACTIONS(6650),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHavolcite] = ACTIONS(6650),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHNotecite] = ACTIONS(6650),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHlabel] = ACTIONS(6650),
    [anon_sym_BSLASHref] = ACTIONS(6650),
    [anon_sym_BSLASHeqref] = ACTIONS(6650),
    [anon_sym_BSLASHvref] = ACTIONS(6650),
    [anon_sym_BSLASHVref] = ACTIONS(6650),
    [anon_sym_BSLASHautoref] = ACTIONS(6650),
    [anon_sym_BSLASHpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcref] = ACTIONS(6650),
    [anon_sym_BSLASHCref] = ACTIONS(6650),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnameCref] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHdef] = ACTIONS(6650),
    [anon_sym_BSLASHlet] = ACTIONS(6650),
    [anon_sym_BSLASHleft] = ACTIONS(6650),
    [anon_sym_BSLASHbigl] = ACTIONS(6650),
    [anon_sym_BSLASHBigl] = ACTIONS(6650),
    [anon_sym_BSLASHbiggl] = ACTIONS(6650),
    [anon_sym_BSLASHBiggl] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6650),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6650),
    [anon_sym_BSLASHgls] = ACTIONS(6650),
    [anon_sym_BSLASHGls] = ACTIONS(6650),
    [anon_sym_BSLASHGLS] = ACTIONS(6650),
    [anon_sym_BSLASHglspl] = ACTIONS(6650),
    [anon_sym_BSLASHGlspl] = ACTIONS(6650),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6650),
    [anon_sym_BSLASHglslink] = ACTIONS(6650),
    [anon_sym_BSLASHglstext] = ACTIONS(6650),
    [anon_sym_BSLASHGlstext] = ACTIONS(6650),
    [anon_sym_BSLASHGLStext] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6650),
    [anon_sym_BSLASHglsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsname] = ACTIONS(6650),
    [anon_sym_BSLASHGlsname] = ACTIONS(6650),
    [anon_sym_BSLASHGLSname] = ACTIONS(6650),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6650),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6650),
    [anon_sym_BSLASHacrshort] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6650),
    [anon_sym_BSLASHACRshort] = ACTIONS(6650),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrlong] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6650),
    [anon_sym_BSLASHACRlong] = ACTIONS(6650),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrfull] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6650),
    [anon_sym_BSLASHACRfull] = ACTIONS(6650),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHacs] = ACTIONS(6650),
    [anon_sym_BSLASHAcs] = ACTIONS(6650),
    [anon_sym_BSLASHacsp] = ACTIONS(6650),
    [anon_sym_BSLASHAcsp] = ACTIONS(6650),
    [anon_sym_BSLASHacl] = ACTIONS(6650),
    [anon_sym_BSLASHAcl] = ACTIONS(6650),
    [anon_sym_BSLASHaclp] = ACTIONS(6650),
    [anon_sym_BSLASHAclp] = ACTIONS(6650),
    [anon_sym_BSLASHacf] = ACTIONS(6650),
    [anon_sym_BSLASHAcf] = ACTIONS(6650),
    [anon_sym_BSLASHacfp] = ACTIONS(6650),
    [anon_sym_BSLASHAcfp] = ACTIONS(6650),
    [anon_sym_BSLASHac] = ACTIONS(6650),
    [anon_sym_BSLASHAc] = ACTIONS(6650),
    [anon_sym_BSLASHacp] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6650),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6650),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6650),
    [anon_sym_BSLASHcolor] = ACTIONS(6650),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6650),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6650),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6650),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6650),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6650),
    [anon_sym_BSLASHtext] = ACTIONS(6650),
    [anon_sym_BSLASHintertext] = ACTIONS(6650),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6650),
    [anon_sym_BSLASHurl] = ACTIONS(6650),
    [anon_sym_BSLASHhref] = ACTIONS(6650),
  },
  [1435] = {
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_RBRACK] = ACTIONS(6192),
    [anon_sym_COMMA] = ACTIONS(6192),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_RPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHpart] = ACTIONS(6190),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddpart] = ACTIONS(6190),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHchapter] = ACTIONS(6190),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddchap] = ACTIONS(6190),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsection] = ACTIONS(6190),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHaddsec] = ACTIONS(6190),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6190),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6190),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHitem] = ACTIONS(6190),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6192),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6192),
    [anon_sym_DOLLAR] = ACTIONS(6190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHbegin] = ACTIONS(6190),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHleft] = ACTIONS(6190),
    [anon_sym_BSLASHbigl] = ACTIONS(6190),
    [anon_sym_BSLASHBigl] = ACTIONS(6190),
    [anon_sym_BSLASHbiggl] = ACTIONS(6190),
    [anon_sym_BSLASHBiggl] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHtext] = ACTIONS(6190),
    [anon_sym_BSLASHintertext] = ACTIONS(6190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [1436] = {
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_RBRACK] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6184),
    [anon_sym_EQ] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_RPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHpart] = ACTIONS(6182),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddpart] = ACTIONS(6182),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHchapter] = ACTIONS(6182),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddchap] = ACTIONS(6182),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsection] = ACTIONS(6182),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHaddsec] = ACTIONS(6182),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6182),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6182),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHitem] = ACTIONS(6182),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6184),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6184),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6184),
    [anon_sym_DOLLAR] = ACTIONS(6182),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHbegin] = ACTIONS(6182),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHleft] = ACTIONS(6182),
    [anon_sym_BSLASHbigl] = ACTIONS(6182),
    [anon_sym_BSLASHBigl] = ACTIONS(6182),
    [anon_sym_BSLASHbiggl] = ACTIONS(6182),
    [anon_sym_BSLASHBiggl] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHtext] = ACTIONS(6182),
    [anon_sym_BSLASHintertext] = ACTIONS(6182),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [1437] = {
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_LPAREN] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHpart] = ACTIONS(6174),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddpart] = ACTIONS(6174),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHchapter] = ACTIONS(6174),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddchap] = ACTIONS(6174),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsection] = ACTIONS(6174),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHaddsec] = ACTIONS(6174),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6174),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6174),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHitem] = ACTIONS(6174),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6176),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6176),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6176),
    [anon_sym_DOLLAR] = ACTIONS(6174),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHbegin] = ACTIONS(6174),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHleft] = ACTIONS(6174),
    [anon_sym_BSLASHbigl] = ACTIONS(6174),
    [anon_sym_BSLASHBigl] = ACTIONS(6174),
    [anon_sym_BSLASHbiggl] = ACTIONS(6174),
    [anon_sym_BSLASHBiggl] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHtext] = ACTIONS(6174),
    [anon_sym_BSLASHintertext] = ACTIONS(6174),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [1438] = {
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_RBRACK] = ACTIONS(6352),
    [anon_sym_COMMA] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_LPAREN] = ACTIONS(6352),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHpart] = ACTIONS(6350),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddpart] = ACTIONS(6350),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHchapter] = ACTIONS(6350),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddchap] = ACTIONS(6350),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsection] = ACTIONS(6350),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHaddsec] = ACTIONS(6350),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6350),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6350),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHitem] = ACTIONS(6350),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6352),
    [anon_sym_LBRACE] = ACTIONS(6352),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6352),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6352),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6352),
    [anon_sym_DOLLAR] = ACTIONS(6350),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHbegin] = ACTIONS(6350),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHleft] = ACTIONS(6350),
    [anon_sym_BSLASHbigl] = ACTIONS(6350),
    [anon_sym_BSLASHBigl] = ACTIONS(6350),
    [anon_sym_BSLASHbiggl] = ACTIONS(6350),
    [anon_sym_BSLASHBiggl] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHtext] = ACTIONS(6350),
    [anon_sym_BSLASHintertext] = ACTIONS(6350),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [1439] = {
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_RBRACK] = ACTIONS(6452),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6452),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHpart] = ACTIONS(6450),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddpart] = ACTIONS(6450),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHchapter] = ACTIONS(6450),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddchap] = ACTIONS(6450),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsection] = ACTIONS(6450),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHaddsec] = ACTIONS(6450),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6450),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6450),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHitem] = ACTIONS(6450),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6452),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6452),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(6450),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHbegin] = ACTIONS(6450),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHleft] = ACTIONS(6450),
    [anon_sym_BSLASHbigl] = ACTIONS(6450),
    [anon_sym_BSLASHBigl] = ACTIONS(6450),
    [anon_sym_BSLASHbiggl] = ACTIONS(6450),
    [anon_sym_BSLASHBiggl] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHtext] = ACTIONS(6450),
    [anon_sym_BSLASHintertext] = ACTIONS(6450),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [1440] = {
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_LBRACK] = ACTIONS(6472),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_EQ] = ACTIONS(6472),
    [anon_sym_LPAREN] = ACTIONS(6472),
    [anon_sym_RPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHpart] = ACTIONS(6470),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddpart] = ACTIONS(6470),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHchapter] = ACTIONS(6470),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddchap] = ACTIONS(6470),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsection] = ACTIONS(6470),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHaddsec] = ACTIONS(6470),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6470),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6470),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHitem] = ACTIONS(6470),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6472),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6472),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6472),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHbegin] = ACTIONS(6470),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHleft] = ACTIONS(6470),
    [anon_sym_BSLASHbigl] = ACTIONS(6470),
    [anon_sym_BSLASHBigl] = ACTIONS(6470),
    [anon_sym_BSLASHbiggl] = ACTIONS(6470),
    [anon_sym_BSLASHBiggl] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHtext] = ACTIONS(6470),
    [anon_sym_BSLASHintertext] = ACTIONS(6470),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [1441] = {
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6552),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHpart] = ACTIONS(6550),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddpart] = ACTIONS(6550),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHchapter] = ACTIONS(6550),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddchap] = ACTIONS(6550),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsection] = ACTIONS(6550),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHaddsec] = ACTIONS(6550),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6550),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6550),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHitem] = ACTIONS(6550),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6552),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6552),
    [anon_sym_DOLLAR] = ACTIONS(6550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHbegin] = ACTIONS(6550),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHleft] = ACTIONS(6550),
    [anon_sym_BSLASHbigl] = ACTIONS(6550),
    [anon_sym_BSLASHBigl] = ACTIONS(6550),
    [anon_sym_BSLASHbiggl] = ACTIONS(6550),
    [anon_sym_BSLASHBiggl] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHtext] = ACTIONS(6550),
    [anon_sym_BSLASHintertext] = ACTIONS(6550),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [1442] = {
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_LBRACK] = ACTIONS(6468),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_COMMA] = ACTIONS(6468),
    [anon_sym_EQ] = ACTIONS(6468),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHpart] = ACTIONS(6466),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddpart] = ACTIONS(6466),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHchapter] = ACTIONS(6466),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddchap] = ACTIONS(6466),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsection] = ACTIONS(6466),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHaddsec] = ACTIONS(6466),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6466),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6466),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHitem] = ACTIONS(6466),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6468),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6468),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6466),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHbegin] = ACTIONS(6466),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHleft] = ACTIONS(6466),
    [anon_sym_BSLASHbigl] = ACTIONS(6466),
    [anon_sym_BSLASHBigl] = ACTIONS(6466),
    [anon_sym_BSLASHbiggl] = ACTIONS(6466),
    [anon_sym_BSLASHBiggl] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHtext] = ACTIONS(6466),
    [anon_sym_BSLASHintertext] = ACTIONS(6466),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [1443] = {
    [sym_command_name] = ACTIONS(6594),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6596),
    [anon_sym_LPAREN] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHpart] = ACTIONS(6594),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddpart] = ACTIONS(6594),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHchapter] = ACTIONS(6594),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddchap] = ACTIONS(6594),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsection] = ACTIONS(6594),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHaddsec] = ACTIONS(6594),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6594),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6594),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHitem] = ACTIONS(6594),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6596),
    [anon_sym_LBRACE] = ACTIONS(6596),
    [sym_word] = ACTIONS(6594),
    [sym_placeholder] = ACTIONS(6596),
    [anon_sym_PLUS] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6596),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_SLASH] = ACTIONS(6596),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_BANG] = ACTIONS(6594),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SQUOTE] = ACTIONS(6594),
    [anon_sym__] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(6596),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6596),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6596),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(6594),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHbegin] = ACTIONS(6594),
    [anon_sym_BSLASHtitle] = ACTIONS(6594),
    [anon_sym_BSLASHauthor] = ACTIONS(6594),
    [anon_sym_BSLASHusepackage] = ACTIONS(6594),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6594),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6594),
    [anon_sym_BSLASHinclude] = ACTIONS(6594),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6594),
    [anon_sym_BSLASHinput] = ACTIONS(6594),
    [anon_sym_BSLASHsubfile] = ACTIONS(6594),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6594),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6594),
    [anon_sym_BSLASHbibliography] = ACTIONS(6594),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6594),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6594),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6594),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6594),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6594),
    [anon_sym_BSLASHimport] = ACTIONS(6594),
    [anon_sym_BSLASHsubimport] = ACTIONS(6594),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6594),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHcaption] = ACTIONS(6594),
    [anon_sym_BSLASHcite] = ACTIONS(6594),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCite] = ACTIONS(6594),
    [anon_sym_BSLASHnocite] = ACTIONS(6594),
    [anon_sym_BSLASHcitet] = ACTIONS(6594),
    [anon_sym_BSLASHcitep] = ACTIONS(6594),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteA] = ACTIONS(6594),
    [anon_sym_BSLASHciteR] = ACTIONS(6594),
    [anon_sym_BSLASHciteS] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6594),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteyear] = ACTIONS(6594),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitedate] = ACTIONS(6594),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteurl] = ACTIONS(6594),
    [anon_sym_BSLASHfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6594),
    [anon_sym_BSLASHcitealt] = ACTIONS(6594),
    [anon_sym_BSLASHcitealp] = ACTIONS(6594),
    [anon_sym_BSLASHcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHparencite] = ACTIONS(6594),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHParencite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHtextcite] = ACTIONS(6594),
    [anon_sym_BSLASHTextcite] = ACTIONS(6594),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHsupercite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite] = ACTIONS(6594),
    [anon_sym_BSLASHAutocite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHVolcite] = ACTIONS(6594),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHavolcite] = ACTIONS(6594),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHNotecite] = ACTIONS(6594),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHlabel] = ACTIONS(6594),
    [anon_sym_BSLASHref] = ACTIONS(6594),
    [anon_sym_BSLASHeqref] = ACTIONS(6594),
    [anon_sym_BSLASHvref] = ACTIONS(6594),
    [anon_sym_BSLASHVref] = ACTIONS(6594),
    [anon_sym_BSLASHautoref] = ACTIONS(6594),
    [anon_sym_BSLASHpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcref] = ACTIONS(6594),
    [anon_sym_BSLASHCref] = ACTIONS(6594),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnameCref] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHdef] = ACTIONS(6594),
    [anon_sym_BSLASHlet] = ACTIONS(6594),
    [anon_sym_BSLASHleft] = ACTIONS(6594),
    [anon_sym_BSLASHbigl] = ACTIONS(6594),
    [anon_sym_BSLASHBigl] = ACTIONS(6594),
    [anon_sym_BSLASHbiggl] = ACTIONS(6594),
    [anon_sym_BSLASHBiggl] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6594),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6594),
    [anon_sym_BSLASHgls] = ACTIONS(6594),
    [anon_sym_BSLASHGls] = ACTIONS(6594),
    [anon_sym_BSLASHGLS] = ACTIONS(6594),
    [anon_sym_BSLASHglspl] = ACTIONS(6594),
    [anon_sym_BSLASHGlspl] = ACTIONS(6594),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6594),
    [anon_sym_BSLASHglslink] = ACTIONS(6594),
    [anon_sym_BSLASHglstext] = ACTIONS(6594),
    [anon_sym_BSLASHGlstext] = ACTIONS(6594),
    [anon_sym_BSLASHGLStext] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6594),
    [anon_sym_BSLASHglsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsname] = ACTIONS(6594),
    [anon_sym_BSLASHGlsname] = ACTIONS(6594),
    [anon_sym_BSLASHGLSname] = ACTIONS(6594),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6594),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6594),
    [anon_sym_BSLASHacrshort] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6594),
    [anon_sym_BSLASHACRshort] = ACTIONS(6594),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrlong] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6594),
    [anon_sym_BSLASHACRlong] = ACTIONS(6594),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrfull] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6594),
    [anon_sym_BSLASHACRfull] = ACTIONS(6594),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHacs] = ACTIONS(6594),
    [anon_sym_BSLASHAcs] = ACTIONS(6594),
    [anon_sym_BSLASHacsp] = ACTIONS(6594),
    [anon_sym_BSLASHAcsp] = ACTIONS(6594),
    [anon_sym_BSLASHacl] = ACTIONS(6594),
    [anon_sym_BSLASHAcl] = ACTIONS(6594),
    [anon_sym_BSLASHaclp] = ACTIONS(6594),
    [anon_sym_BSLASHAclp] = ACTIONS(6594),
    [anon_sym_BSLASHacf] = ACTIONS(6594),
    [anon_sym_BSLASHAcf] = ACTIONS(6594),
    [anon_sym_BSLASHacfp] = ACTIONS(6594),
    [anon_sym_BSLASHAcfp] = ACTIONS(6594),
    [anon_sym_BSLASHac] = ACTIONS(6594),
    [anon_sym_BSLASHAc] = ACTIONS(6594),
    [anon_sym_BSLASHacp] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6594),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6594),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6594),
    [anon_sym_BSLASHcolor] = ACTIONS(6594),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6594),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6594),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6594),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6594),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6594),
    [anon_sym_BSLASHtext] = ACTIONS(6594),
    [anon_sym_BSLASHintertext] = ACTIONS(6594),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6594),
    [anon_sym_BSLASHurl] = ACTIONS(6594),
    [anon_sym_BSLASHhref] = ACTIONS(6594),
  },
  [1444] = {
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_LBRACK] = ACTIONS(6476),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_RPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHpart] = ACTIONS(6474),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddpart] = ACTIONS(6474),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHchapter] = ACTIONS(6474),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddchap] = ACTIONS(6474),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsection] = ACTIONS(6474),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHaddsec] = ACTIONS(6474),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6474),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6474),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHitem] = ACTIONS(6474),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6476),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6476),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6476),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHbegin] = ACTIONS(6474),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHleft] = ACTIONS(6474),
    [anon_sym_BSLASHbigl] = ACTIONS(6474),
    [anon_sym_BSLASHBigl] = ACTIONS(6474),
    [anon_sym_BSLASHbiggl] = ACTIONS(6474),
    [anon_sym_BSLASHBiggl] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHtext] = ACTIONS(6474),
    [anon_sym_BSLASHintertext] = ACTIONS(6474),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [1445] = {
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6480),
    [anon_sym_EQ] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6480),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHpart] = ACTIONS(6478),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddpart] = ACTIONS(6478),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHchapter] = ACTIONS(6478),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddchap] = ACTIONS(6478),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsection] = ACTIONS(6478),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHaddsec] = ACTIONS(6478),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6478),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6478),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHitem] = ACTIONS(6478),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6480),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6480),
    [anon_sym_DOLLAR] = ACTIONS(6478),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHbegin] = ACTIONS(6478),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHleft] = ACTIONS(6478),
    [anon_sym_BSLASHbigl] = ACTIONS(6478),
    [anon_sym_BSLASHBigl] = ACTIONS(6478),
    [anon_sym_BSLASHbiggl] = ACTIONS(6478),
    [anon_sym_BSLASHBiggl] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHtext] = ACTIONS(6478),
    [anon_sym_BSLASHintertext] = ACTIONS(6478),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [1446] = {
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6484),
    [anon_sym_RBRACK] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6484),
    [anon_sym_EQ] = ACTIONS(6484),
    [anon_sym_LPAREN] = ACTIONS(6484),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHpart] = ACTIONS(6482),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddpart] = ACTIONS(6482),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHchapter] = ACTIONS(6482),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddchap] = ACTIONS(6482),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsection] = ACTIONS(6482),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHaddsec] = ACTIONS(6482),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6482),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6482),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHitem] = ACTIONS(6482),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6484),
    [anon_sym_LBRACE] = ACTIONS(6484),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6484),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6484),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6484),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHbegin] = ACTIONS(6482),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHleft] = ACTIONS(6482),
    [anon_sym_BSLASHbigl] = ACTIONS(6482),
    [anon_sym_BSLASHBigl] = ACTIONS(6482),
    [anon_sym_BSLASHbiggl] = ACTIONS(6482),
    [anon_sym_BSLASHBiggl] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHtext] = ACTIONS(6482),
    [anon_sym_BSLASHintertext] = ACTIONS(6482),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [1447] = {
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_LBRACK] = ACTIONS(6488),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_COMMA] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6488),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHpart] = ACTIONS(6486),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddpart] = ACTIONS(6486),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHchapter] = ACTIONS(6486),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddchap] = ACTIONS(6486),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsection] = ACTIONS(6486),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHaddsec] = ACTIONS(6486),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6486),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6486),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHitem] = ACTIONS(6486),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6488),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6488),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(6486),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHbegin] = ACTIONS(6486),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHleft] = ACTIONS(6486),
    [anon_sym_BSLASHbigl] = ACTIONS(6486),
    [anon_sym_BSLASHBigl] = ACTIONS(6486),
    [anon_sym_BSLASHbiggl] = ACTIONS(6486),
    [anon_sym_BSLASHBiggl] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHtext] = ACTIONS(6486),
    [anon_sym_BSLASHintertext] = ACTIONS(6486),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [1448] = {
    [sym_command_name] = ACTIONS(6670),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6670),
    [anon_sym_LBRACK] = ACTIONS(6672),
    [anon_sym_RBRACK] = ACTIONS(6672),
    [anon_sym_COMMA] = ACTIONS(6672),
    [anon_sym_EQ] = ACTIONS(6672),
    [anon_sym_LPAREN] = ACTIONS(6672),
    [anon_sym_RPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHpart] = ACTIONS(6670),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddpart] = ACTIONS(6670),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHchapter] = ACTIONS(6670),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddchap] = ACTIONS(6670),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsection] = ACTIONS(6670),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHaddsec] = ACTIONS(6670),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6670),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6670),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHitem] = ACTIONS(6670),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6672),
    [anon_sym_LBRACE] = ACTIONS(6672),
    [sym_word] = ACTIONS(6670),
    [sym_placeholder] = ACTIONS(6672),
    [anon_sym_PLUS] = ACTIONS(6672),
    [anon_sym_DASH] = ACTIONS(6672),
    [anon_sym_STAR] = ACTIONS(6672),
    [anon_sym_SLASH] = ACTIONS(6672),
    [anon_sym_LT] = ACTIONS(6670),
    [anon_sym_GT] = ACTIONS(6670),
    [anon_sym_BANG] = ACTIONS(6670),
    [anon_sym_PIPE] = ACTIONS(6670),
    [anon_sym_COLON] = ACTIONS(6670),
    [anon_sym_SQUOTE] = ACTIONS(6670),
    [anon_sym__] = ACTIONS(6672),
    [anon_sym_CARET] = ACTIONS(6672),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6672),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6672),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6672),
    [anon_sym_DOLLAR] = ACTIONS(6670),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHbegin] = ACTIONS(6670),
    [anon_sym_BSLASHtitle] = ACTIONS(6670),
    [anon_sym_BSLASHauthor] = ACTIONS(6670),
    [anon_sym_BSLASHusepackage] = ACTIONS(6670),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6670),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6670),
    [anon_sym_BSLASHinclude] = ACTIONS(6670),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6670),
    [anon_sym_BSLASHinput] = ACTIONS(6670),
    [anon_sym_BSLASHsubfile] = ACTIONS(6670),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6670),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6670),
    [anon_sym_BSLASHbibliography] = ACTIONS(6670),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6670),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6670),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6670),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6670),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6670),
    [anon_sym_BSLASHimport] = ACTIONS(6670),
    [anon_sym_BSLASHsubimport] = ACTIONS(6670),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6670),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHcaption] = ACTIONS(6670),
    [anon_sym_BSLASHcite] = ACTIONS(6670),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCite] = ACTIONS(6670),
    [anon_sym_BSLASHnocite] = ACTIONS(6670),
    [anon_sym_BSLASHcitet] = ACTIONS(6670),
    [anon_sym_BSLASHcitep] = ACTIONS(6670),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteA] = ACTIONS(6670),
    [anon_sym_BSLASHciteR] = ACTIONS(6670),
    [anon_sym_BSLASHciteS] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6670),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteyear] = ACTIONS(6670),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitedate] = ACTIONS(6670),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteurl] = ACTIONS(6670),
    [anon_sym_BSLASHfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6670),
    [anon_sym_BSLASHcitealt] = ACTIONS(6670),
    [anon_sym_BSLASHcitealp] = ACTIONS(6670),
    [anon_sym_BSLASHcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHparencite] = ACTIONS(6670),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHParencite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHtextcite] = ACTIONS(6670),
    [anon_sym_BSLASHTextcite] = ACTIONS(6670),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHsupercite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite] = ACTIONS(6670),
    [anon_sym_BSLASHAutocite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHVolcite] = ACTIONS(6670),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHavolcite] = ACTIONS(6670),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHNotecite] = ACTIONS(6670),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHlabel] = ACTIONS(6670),
    [anon_sym_BSLASHref] = ACTIONS(6670),
    [anon_sym_BSLASHeqref] = ACTIONS(6670),
    [anon_sym_BSLASHvref] = ACTIONS(6670),
    [anon_sym_BSLASHVref] = ACTIONS(6670),
    [anon_sym_BSLASHautoref] = ACTIONS(6670),
    [anon_sym_BSLASHpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcref] = ACTIONS(6670),
    [anon_sym_BSLASHCref] = ACTIONS(6670),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnameCref] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHdef] = ACTIONS(6670),
    [anon_sym_BSLASHlet] = ACTIONS(6670),
    [anon_sym_BSLASHleft] = ACTIONS(6670),
    [anon_sym_BSLASHbigl] = ACTIONS(6670),
    [anon_sym_BSLASHBigl] = ACTIONS(6670),
    [anon_sym_BSLASHbiggl] = ACTIONS(6670),
    [anon_sym_BSLASHBiggl] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6670),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6670),
    [anon_sym_BSLASHgls] = ACTIONS(6670),
    [anon_sym_BSLASHGls] = ACTIONS(6670),
    [anon_sym_BSLASHGLS] = ACTIONS(6670),
    [anon_sym_BSLASHglspl] = ACTIONS(6670),
    [anon_sym_BSLASHGlspl] = ACTIONS(6670),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6670),
    [anon_sym_BSLASHglslink] = ACTIONS(6670),
    [anon_sym_BSLASHglstext] = ACTIONS(6670),
    [anon_sym_BSLASHGlstext] = ACTIONS(6670),
    [anon_sym_BSLASHGLStext] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6670),
    [anon_sym_BSLASHglsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsname] = ACTIONS(6670),
    [anon_sym_BSLASHGlsname] = ACTIONS(6670),
    [anon_sym_BSLASHGLSname] = ACTIONS(6670),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6670),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6670),
    [anon_sym_BSLASHacrshort] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6670),
    [anon_sym_BSLASHACRshort] = ACTIONS(6670),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrlong] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6670),
    [anon_sym_BSLASHACRlong] = ACTIONS(6670),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrfull] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6670),
    [anon_sym_BSLASHACRfull] = ACTIONS(6670),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHacs] = ACTIONS(6670),
    [anon_sym_BSLASHAcs] = ACTIONS(6670),
    [anon_sym_BSLASHacsp] = ACTIONS(6670),
    [anon_sym_BSLASHAcsp] = ACTIONS(6670),
    [anon_sym_BSLASHacl] = ACTIONS(6670),
    [anon_sym_BSLASHAcl] = ACTIONS(6670),
    [anon_sym_BSLASHaclp] = ACTIONS(6670),
    [anon_sym_BSLASHAclp] = ACTIONS(6670),
    [anon_sym_BSLASHacf] = ACTIONS(6670),
    [anon_sym_BSLASHAcf] = ACTIONS(6670),
    [anon_sym_BSLASHacfp] = ACTIONS(6670),
    [anon_sym_BSLASHAcfp] = ACTIONS(6670),
    [anon_sym_BSLASHac] = ACTIONS(6670),
    [anon_sym_BSLASHAc] = ACTIONS(6670),
    [anon_sym_BSLASHacp] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6670),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6670),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6670),
    [anon_sym_BSLASHcolor] = ACTIONS(6670),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6670),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6670),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6670),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6670),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6670),
    [anon_sym_BSLASHtext] = ACTIONS(6670),
    [anon_sym_BSLASHintertext] = ACTIONS(6670),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6670),
    [anon_sym_BSLASHurl] = ACTIONS(6670),
    [anon_sym_BSLASHhref] = ACTIONS(6670),
  },
  [1449] = {
    [sym_command_name] = ACTIONS(6562),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6562),
    [anon_sym_LBRACK] = ACTIONS(6564),
    [anon_sym_RBRACK] = ACTIONS(6564),
    [anon_sym_COMMA] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6564),
    [anon_sym_RPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHpart] = ACTIONS(6562),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddpart] = ACTIONS(6562),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHchapter] = ACTIONS(6562),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddchap] = ACTIONS(6562),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsection] = ACTIONS(6562),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHaddsec] = ACTIONS(6562),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6562),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6562),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHitem] = ACTIONS(6562),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6564),
    [anon_sym_LBRACE] = ACTIONS(6564),
    [sym_word] = ACTIONS(6562),
    [sym_placeholder] = ACTIONS(6564),
    [anon_sym_PLUS] = ACTIONS(6564),
    [anon_sym_DASH] = ACTIONS(6564),
    [anon_sym_STAR] = ACTIONS(6564),
    [anon_sym_SLASH] = ACTIONS(6564),
    [anon_sym_LT] = ACTIONS(6562),
    [anon_sym_GT] = ACTIONS(6562),
    [anon_sym_BANG] = ACTIONS(6562),
    [anon_sym_PIPE] = ACTIONS(6562),
    [anon_sym_COLON] = ACTIONS(6562),
    [anon_sym_SQUOTE] = ACTIONS(6562),
    [anon_sym__] = ACTIONS(6564),
    [anon_sym_CARET] = ACTIONS(6564),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6564),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6564),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6564),
    [anon_sym_DOLLAR] = ACTIONS(6562),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHbegin] = ACTIONS(6562),
    [anon_sym_BSLASHtitle] = ACTIONS(6562),
    [anon_sym_BSLASHauthor] = ACTIONS(6562),
    [anon_sym_BSLASHusepackage] = ACTIONS(6562),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6562),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6562),
    [anon_sym_BSLASHinclude] = ACTIONS(6562),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6562),
    [anon_sym_BSLASHinput] = ACTIONS(6562),
    [anon_sym_BSLASHsubfile] = ACTIONS(6562),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6562),
    [anon_sym_BSLASHbibliography] = ACTIONS(6562),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6562),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6562),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6562),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6562),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6562),
    [anon_sym_BSLASHimport] = ACTIONS(6562),
    [anon_sym_BSLASHsubimport] = ACTIONS(6562),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6562),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHcaption] = ACTIONS(6562),
    [anon_sym_BSLASHcite] = ACTIONS(6562),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCite] = ACTIONS(6562),
    [anon_sym_BSLASHnocite] = ACTIONS(6562),
    [anon_sym_BSLASHcitet] = ACTIONS(6562),
    [anon_sym_BSLASHcitep] = ACTIONS(6562),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteA] = ACTIONS(6562),
    [anon_sym_BSLASHciteR] = ACTIONS(6562),
    [anon_sym_BSLASHciteS] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6562),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteyear] = ACTIONS(6562),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitedate] = ACTIONS(6562),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteurl] = ACTIONS(6562),
    [anon_sym_BSLASHfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6562),
    [anon_sym_BSLASHcitealt] = ACTIONS(6562),
    [anon_sym_BSLASHcitealp] = ACTIONS(6562),
    [anon_sym_BSLASHcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHparencite] = ACTIONS(6562),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHParencite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHtextcite] = ACTIONS(6562),
    [anon_sym_BSLASHTextcite] = ACTIONS(6562),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHsupercite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite] = ACTIONS(6562),
    [anon_sym_BSLASHAutocite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHVolcite] = ACTIONS(6562),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHavolcite] = ACTIONS(6562),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHNotecite] = ACTIONS(6562),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHlabel] = ACTIONS(6562),
    [anon_sym_BSLASHref] = ACTIONS(6562),
    [anon_sym_BSLASHeqref] = ACTIONS(6562),
    [anon_sym_BSLASHvref] = ACTIONS(6562),
    [anon_sym_BSLASHVref] = ACTIONS(6562),
    [anon_sym_BSLASHautoref] = ACTIONS(6562),
    [anon_sym_BSLASHpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcref] = ACTIONS(6562),
    [anon_sym_BSLASHCref] = ACTIONS(6562),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnameCref] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHdef] = ACTIONS(6562),
    [anon_sym_BSLASHlet] = ACTIONS(6562),
    [anon_sym_BSLASHleft] = ACTIONS(6562),
    [anon_sym_BSLASHbigl] = ACTIONS(6562),
    [anon_sym_BSLASHBigl] = ACTIONS(6562),
    [anon_sym_BSLASHbiggl] = ACTIONS(6562),
    [anon_sym_BSLASHBiggl] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6562),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6562),
    [anon_sym_BSLASHgls] = ACTIONS(6562),
    [anon_sym_BSLASHGls] = ACTIONS(6562),
    [anon_sym_BSLASHGLS] = ACTIONS(6562),
    [anon_sym_BSLASHglspl] = ACTIONS(6562),
    [anon_sym_BSLASHGlspl] = ACTIONS(6562),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6562),
    [anon_sym_BSLASHglslink] = ACTIONS(6562),
    [anon_sym_BSLASHglstext] = ACTIONS(6562),
    [anon_sym_BSLASHGlstext] = ACTIONS(6562),
    [anon_sym_BSLASHGLStext] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6562),
    [anon_sym_BSLASHglsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsname] = ACTIONS(6562),
    [anon_sym_BSLASHGlsname] = ACTIONS(6562),
    [anon_sym_BSLASHGLSname] = ACTIONS(6562),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6562),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6562),
    [anon_sym_BSLASHacrshort] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6562),
    [anon_sym_BSLASHACRshort] = ACTIONS(6562),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrlong] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6562),
    [anon_sym_BSLASHACRlong] = ACTIONS(6562),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrfull] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6562),
    [anon_sym_BSLASHACRfull] = ACTIONS(6562),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHacs] = ACTIONS(6562),
    [anon_sym_BSLASHAcs] = ACTIONS(6562),
    [anon_sym_BSLASHacsp] = ACTIONS(6562),
    [anon_sym_BSLASHAcsp] = ACTIONS(6562),
    [anon_sym_BSLASHacl] = ACTIONS(6562),
    [anon_sym_BSLASHAcl] = ACTIONS(6562),
    [anon_sym_BSLASHaclp] = ACTIONS(6562),
    [anon_sym_BSLASHAclp] = ACTIONS(6562),
    [anon_sym_BSLASHacf] = ACTIONS(6562),
    [anon_sym_BSLASHAcf] = ACTIONS(6562),
    [anon_sym_BSLASHacfp] = ACTIONS(6562),
    [anon_sym_BSLASHAcfp] = ACTIONS(6562),
    [anon_sym_BSLASHac] = ACTIONS(6562),
    [anon_sym_BSLASHAc] = ACTIONS(6562),
    [anon_sym_BSLASHacp] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6562),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6562),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6562),
    [anon_sym_BSLASHcolor] = ACTIONS(6562),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6562),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6562),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6562),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6562),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6562),
    [anon_sym_BSLASHtext] = ACTIONS(6562),
    [anon_sym_BSLASHintertext] = ACTIONS(6562),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6562),
    [anon_sym_BSLASHurl] = ACTIONS(6562),
    [anon_sym_BSLASHhref] = ACTIONS(6562),
  },
  [1450] = {
    [sym_command_name] = ACTIONS(6590),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6590),
    [anon_sym_LBRACK] = ACTIONS(6592),
    [anon_sym_RBRACK] = ACTIONS(6592),
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(6592),
    [anon_sym_LPAREN] = ACTIONS(6592),
    [anon_sym_RPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHpart] = ACTIONS(6590),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddpart] = ACTIONS(6590),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHchapter] = ACTIONS(6590),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddchap] = ACTIONS(6590),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsection] = ACTIONS(6590),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHaddsec] = ACTIONS(6590),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6590),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6590),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHitem] = ACTIONS(6590),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6592),
    [anon_sym_LBRACE] = ACTIONS(6592),
    [sym_word] = ACTIONS(6590),
    [sym_placeholder] = ACTIONS(6592),
    [anon_sym_PLUS] = ACTIONS(6592),
    [anon_sym_DASH] = ACTIONS(6592),
    [anon_sym_STAR] = ACTIONS(6592),
    [anon_sym_SLASH] = ACTIONS(6592),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6592),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6592),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6592),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6592),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHbegin] = ACTIONS(6590),
    [anon_sym_BSLASHtitle] = ACTIONS(6590),
    [anon_sym_BSLASHauthor] = ACTIONS(6590),
    [anon_sym_BSLASHusepackage] = ACTIONS(6590),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6590),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6590),
    [anon_sym_BSLASHinclude] = ACTIONS(6590),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6590),
    [anon_sym_BSLASHinput] = ACTIONS(6590),
    [anon_sym_BSLASHsubfile] = ACTIONS(6590),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6590),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6590),
    [anon_sym_BSLASHbibliography] = ACTIONS(6590),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6590),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6590),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6590),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6590),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6590),
    [anon_sym_BSLASHimport] = ACTIONS(6590),
    [anon_sym_BSLASHsubimport] = ACTIONS(6590),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6590),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHcaption] = ACTIONS(6590),
    [anon_sym_BSLASHcite] = ACTIONS(6590),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCite] = ACTIONS(6590),
    [anon_sym_BSLASHnocite] = ACTIONS(6590),
    [anon_sym_BSLASHcitet] = ACTIONS(6590),
    [anon_sym_BSLASHcitep] = ACTIONS(6590),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteA] = ACTIONS(6590),
    [anon_sym_BSLASHciteR] = ACTIONS(6590),
    [anon_sym_BSLASHciteS] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6590),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteyear] = ACTIONS(6590),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitedate] = ACTIONS(6590),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteurl] = ACTIONS(6590),
    [anon_sym_BSLASHfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6590),
    [anon_sym_BSLASHcitealt] = ACTIONS(6590),
    [anon_sym_BSLASHcitealp] = ACTIONS(6590),
    [anon_sym_BSLASHcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHparencite] = ACTIONS(6590),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHParencite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHtextcite] = ACTIONS(6590),
    [anon_sym_BSLASHTextcite] = ACTIONS(6590),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHsupercite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite] = ACTIONS(6590),
    [anon_sym_BSLASHAutocite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHVolcite] = ACTIONS(6590),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHavolcite] = ACTIONS(6590),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHNotecite] = ACTIONS(6590),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHlabel] = ACTIONS(6590),
    [anon_sym_BSLASHref] = ACTIONS(6590),
    [anon_sym_BSLASHeqref] = ACTIONS(6590),
    [anon_sym_BSLASHvref] = ACTIONS(6590),
    [anon_sym_BSLASHVref] = ACTIONS(6590),
    [anon_sym_BSLASHautoref] = ACTIONS(6590),
    [anon_sym_BSLASHpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcref] = ACTIONS(6590),
    [anon_sym_BSLASHCref] = ACTIONS(6590),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnameCref] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHdef] = ACTIONS(6590),
    [anon_sym_BSLASHlet] = ACTIONS(6590),
    [anon_sym_BSLASHleft] = ACTIONS(6590),
    [anon_sym_BSLASHbigl] = ACTIONS(6590),
    [anon_sym_BSLASHBigl] = ACTIONS(6590),
    [anon_sym_BSLASHbiggl] = ACTIONS(6590),
    [anon_sym_BSLASHBiggl] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6590),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6590),
    [anon_sym_BSLASHgls] = ACTIONS(6590),
    [anon_sym_BSLASHGls] = ACTIONS(6590),
    [anon_sym_BSLASHGLS] = ACTIONS(6590),
    [anon_sym_BSLASHglspl] = ACTIONS(6590),
    [anon_sym_BSLASHGlspl] = ACTIONS(6590),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6590),
    [anon_sym_BSLASHglslink] = ACTIONS(6590),
    [anon_sym_BSLASHglstext] = ACTIONS(6590),
    [anon_sym_BSLASHGlstext] = ACTIONS(6590),
    [anon_sym_BSLASHGLStext] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6590),
    [anon_sym_BSLASHglsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsname] = ACTIONS(6590),
    [anon_sym_BSLASHGlsname] = ACTIONS(6590),
    [anon_sym_BSLASHGLSname] = ACTIONS(6590),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6590),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6590),
    [anon_sym_BSLASHacrshort] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6590),
    [anon_sym_BSLASHACRshort] = ACTIONS(6590),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrlong] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6590),
    [anon_sym_BSLASHACRlong] = ACTIONS(6590),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrfull] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6590),
    [anon_sym_BSLASHACRfull] = ACTIONS(6590),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHacs] = ACTIONS(6590),
    [anon_sym_BSLASHAcs] = ACTIONS(6590),
    [anon_sym_BSLASHacsp] = ACTIONS(6590),
    [anon_sym_BSLASHAcsp] = ACTIONS(6590),
    [anon_sym_BSLASHacl] = ACTIONS(6590),
    [anon_sym_BSLASHAcl] = ACTIONS(6590),
    [anon_sym_BSLASHaclp] = ACTIONS(6590),
    [anon_sym_BSLASHAclp] = ACTIONS(6590),
    [anon_sym_BSLASHacf] = ACTIONS(6590),
    [anon_sym_BSLASHAcf] = ACTIONS(6590),
    [anon_sym_BSLASHacfp] = ACTIONS(6590),
    [anon_sym_BSLASHAcfp] = ACTIONS(6590),
    [anon_sym_BSLASHac] = ACTIONS(6590),
    [anon_sym_BSLASHAc] = ACTIONS(6590),
    [anon_sym_BSLASHacp] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6590),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6590),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6590),
    [anon_sym_BSLASHcolor] = ACTIONS(6590),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6590),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6590),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6590),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6590),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6590),
    [anon_sym_BSLASHtext] = ACTIONS(6590),
    [anon_sym_BSLASHintertext] = ACTIONS(6590),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6590),
    [anon_sym_BSLASHurl] = ACTIONS(6590),
    [anon_sym_BSLASHhref] = ACTIONS(6590),
  },
  [1451] = {
    [sym_command_name] = ACTIONS(6598),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6598),
    [anon_sym_LBRACK] = ACTIONS(6600),
    [anon_sym_RBRACK] = ACTIONS(6600),
    [anon_sym_COMMA] = ACTIONS(6600),
    [anon_sym_EQ] = ACTIONS(6600),
    [anon_sym_LPAREN] = ACTIONS(6600),
    [anon_sym_RPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHpart] = ACTIONS(6598),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddpart] = ACTIONS(6598),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHchapter] = ACTIONS(6598),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddchap] = ACTIONS(6598),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsection] = ACTIONS(6598),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHaddsec] = ACTIONS(6598),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6598),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6598),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHitem] = ACTIONS(6598),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6600),
    [anon_sym_LBRACE] = ACTIONS(6600),
    [sym_word] = ACTIONS(6598),
    [sym_placeholder] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6600),
    [anon_sym_DASH] = ACTIONS(6600),
    [anon_sym_STAR] = ACTIONS(6600),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_BANG] = ACTIONS(6598),
    [anon_sym_PIPE] = ACTIONS(6598),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_SQUOTE] = ACTIONS(6598),
    [anon_sym__] = ACTIONS(6600),
    [anon_sym_CARET] = ACTIONS(6600),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6600),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6600),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6600),
    [anon_sym_DOLLAR] = ACTIONS(6598),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHbegin] = ACTIONS(6598),
    [anon_sym_BSLASHtitle] = ACTIONS(6598),
    [anon_sym_BSLASHauthor] = ACTIONS(6598),
    [anon_sym_BSLASHusepackage] = ACTIONS(6598),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6598),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6598),
    [anon_sym_BSLASHinclude] = ACTIONS(6598),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6598),
    [anon_sym_BSLASHinput] = ACTIONS(6598),
    [anon_sym_BSLASHsubfile] = ACTIONS(6598),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6598),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6598),
    [anon_sym_BSLASHbibliography] = ACTIONS(6598),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6598),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6598),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6598),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6598),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6598),
    [anon_sym_BSLASHimport] = ACTIONS(6598),
    [anon_sym_BSLASHsubimport] = ACTIONS(6598),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6598),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHcaption] = ACTIONS(6598),
    [anon_sym_BSLASHcite] = ACTIONS(6598),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCite] = ACTIONS(6598),
    [anon_sym_BSLASHnocite] = ACTIONS(6598),
    [anon_sym_BSLASHcitet] = ACTIONS(6598),
    [anon_sym_BSLASHcitep] = ACTIONS(6598),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteA] = ACTIONS(6598),
    [anon_sym_BSLASHciteR] = ACTIONS(6598),
    [anon_sym_BSLASHciteS] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6598),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteyear] = ACTIONS(6598),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitedate] = ACTIONS(6598),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteurl] = ACTIONS(6598),
    [anon_sym_BSLASHfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6598),
    [anon_sym_BSLASHcitealt] = ACTIONS(6598),
    [anon_sym_BSLASHcitealp] = ACTIONS(6598),
    [anon_sym_BSLASHcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHparencite] = ACTIONS(6598),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHParencite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHtextcite] = ACTIONS(6598),
    [anon_sym_BSLASHTextcite] = ACTIONS(6598),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHsupercite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite] = ACTIONS(6598),
    [anon_sym_BSLASHAutocite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHVolcite] = ACTIONS(6598),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHavolcite] = ACTIONS(6598),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHNotecite] = ACTIONS(6598),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHlabel] = ACTIONS(6598),
    [anon_sym_BSLASHref] = ACTIONS(6598),
    [anon_sym_BSLASHeqref] = ACTIONS(6598),
    [anon_sym_BSLASHvref] = ACTIONS(6598),
    [anon_sym_BSLASHVref] = ACTIONS(6598),
    [anon_sym_BSLASHautoref] = ACTIONS(6598),
    [anon_sym_BSLASHpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcref] = ACTIONS(6598),
    [anon_sym_BSLASHCref] = ACTIONS(6598),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnameCref] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHdef] = ACTIONS(6598),
    [anon_sym_BSLASHlet] = ACTIONS(6598),
    [anon_sym_BSLASHleft] = ACTIONS(6598),
    [anon_sym_BSLASHbigl] = ACTIONS(6598),
    [anon_sym_BSLASHBigl] = ACTIONS(6598),
    [anon_sym_BSLASHbiggl] = ACTIONS(6598),
    [anon_sym_BSLASHBiggl] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6598),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6598),
    [anon_sym_BSLASHgls] = ACTIONS(6598),
    [anon_sym_BSLASHGls] = ACTIONS(6598),
    [anon_sym_BSLASHGLS] = ACTIONS(6598),
    [anon_sym_BSLASHglspl] = ACTIONS(6598),
    [anon_sym_BSLASHGlspl] = ACTIONS(6598),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6598),
    [anon_sym_BSLASHglslink] = ACTIONS(6598),
    [anon_sym_BSLASHglstext] = ACTIONS(6598),
    [anon_sym_BSLASHGlstext] = ACTIONS(6598),
    [anon_sym_BSLASHGLStext] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6598),
    [anon_sym_BSLASHglsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsname] = ACTIONS(6598),
    [anon_sym_BSLASHGlsname] = ACTIONS(6598),
    [anon_sym_BSLASHGLSname] = ACTIONS(6598),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6598),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6598),
    [anon_sym_BSLASHacrshort] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6598),
    [anon_sym_BSLASHACRshort] = ACTIONS(6598),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrlong] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6598),
    [anon_sym_BSLASHACRlong] = ACTIONS(6598),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrfull] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6598),
    [anon_sym_BSLASHACRfull] = ACTIONS(6598),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHacs] = ACTIONS(6598),
    [anon_sym_BSLASHAcs] = ACTIONS(6598),
    [anon_sym_BSLASHacsp] = ACTIONS(6598),
    [anon_sym_BSLASHAcsp] = ACTIONS(6598),
    [anon_sym_BSLASHacl] = ACTIONS(6598),
    [anon_sym_BSLASHAcl] = ACTIONS(6598),
    [anon_sym_BSLASHaclp] = ACTIONS(6598),
    [anon_sym_BSLASHAclp] = ACTIONS(6598),
    [anon_sym_BSLASHacf] = ACTIONS(6598),
    [anon_sym_BSLASHAcf] = ACTIONS(6598),
    [anon_sym_BSLASHacfp] = ACTIONS(6598),
    [anon_sym_BSLASHAcfp] = ACTIONS(6598),
    [anon_sym_BSLASHac] = ACTIONS(6598),
    [anon_sym_BSLASHAc] = ACTIONS(6598),
    [anon_sym_BSLASHacp] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6598),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6598),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6598),
    [anon_sym_BSLASHcolor] = ACTIONS(6598),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6598),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6598),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6598),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6598),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6598),
    [anon_sym_BSLASHtext] = ACTIONS(6598),
    [anon_sym_BSLASHintertext] = ACTIONS(6598),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6598),
    [anon_sym_BSLASHurl] = ACTIONS(6598),
    [anon_sym_BSLASHhref] = ACTIONS(6598),
  },
  [1452] = {
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6556),
    [anon_sym_RBRACK] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6556),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHpart] = ACTIONS(6554),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddpart] = ACTIONS(6554),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHchapter] = ACTIONS(6554),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddchap] = ACTIONS(6554),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsection] = ACTIONS(6554),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHaddsec] = ACTIONS(6554),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6554),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6554),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHitem] = ACTIONS(6554),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6556),
    [anon_sym_LBRACE] = ACTIONS(6556),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6556),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6556),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6556),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHbegin] = ACTIONS(6554),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHleft] = ACTIONS(6554),
    [anon_sym_BSLASHbigl] = ACTIONS(6554),
    [anon_sym_BSLASHBigl] = ACTIONS(6554),
    [anon_sym_BSLASHbiggl] = ACTIONS(6554),
    [anon_sym_BSLASHBiggl] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHtext] = ACTIONS(6554),
    [anon_sym_BSLASHintertext] = ACTIONS(6554),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [1453] = {
    [sym_command_name] = ACTIONS(6726),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6726),
    [anon_sym_LBRACK] = ACTIONS(6728),
    [anon_sym_RBRACK] = ACTIONS(6728),
    [anon_sym_COMMA] = ACTIONS(6728),
    [anon_sym_EQ] = ACTIONS(6728),
    [anon_sym_LPAREN] = ACTIONS(6728),
    [anon_sym_RPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHpart] = ACTIONS(6726),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddpart] = ACTIONS(6726),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHchapter] = ACTIONS(6726),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddchap] = ACTIONS(6726),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsection] = ACTIONS(6726),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHaddsec] = ACTIONS(6726),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6726),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6726),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHitem] = ACTIONS(6726),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6728),
    [anon_sym_LBRACE] = ACTIONS(6728),
    [sym_word] = ACTIONS(6726),
    [sym_placeholder] = ACTIONS(6728),
    [anon_sym_PLUS] = ACTIONS(6728),
    [anon_sym_DASH] = ACTIONS(6728),
    [anon_sym_STAR] = ACTIONS(6728),
    [anon_sym_SLASH] = ACTIONS(6728),
    [anon_sym_LT] = ACTIONS(6726),
    [anon_sym_GT] = ACTIONS(6726),
    [anon_sym_BANG] = ACTIONS(6726),
    [anon_sym_PIPE] = ACTIONS(6726),
    [anon_sym_COLON] = ACTIONS(6726),
    [anon_sym_SQUOTE] = ACTIONS(6726),
    [anon_sym__] = ACTIONS(6728),
    [anon_sym_CARET] = ACTIONS(6728),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6728),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6728),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6728),
    [anon_sym_DOLLAR] = ACTIONS(6726),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHbegin] = ACTIONS(6726),
    [anon_sym_BSLASHtitle] = ACTIONS(6726),
    [anon_sym_BSLASHauthor] = ACTIONS(6726),
    [anon_sym_BSLASHusepackage] = ACTIONS(6726),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6726),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6726),
    [anon_sym_BSLASHinclude] = ACTIONS(6726),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6726),
    [anon_sym_BSLASHinput] = ACTIONS(6726),
    [anon_sym_BSLASHsubfile] = ACTIONS(6726),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6726),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6726),
    [anon_sym_BSLASHbibliography] = ACTIONS(6726),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6726),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6726),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6726),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6726),
    [anon_sym_BSLASHimport] = ACTIONS(6726),
    [anon_sym_BSLASHsubimport] = ACTIONS(6726),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6726),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHcaption] = ACTIONS(6726),
    [anon_sym_BSLASHcite] = ACTIONS(6726),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCite] = ACTIONS(6726),
    [anon_sym_BSLASHnocite] = ACTIONS(6726),
    [anon_sym_BSLASHcitet] = ACTIONS(6726),
    [anon_sym_BSLASHcitep] = ACTIONS(6726),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteA] = ACTIONS(6726),
    [anon_sym_BSLASHciteR] = ACTIONS(6726),
    [anon_sym_BSLASHciteS] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6726),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteyear] = ACTIONS(6726),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitedate] = ACTIONS(6726),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteurl] = ACTIONS(6726),
    [anon_sym_BSLASHfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6726),
    [anon_sym_BSLASHcitealt] = ACTIONS(6726),
    [anon_sym_BSLASHcitealp] = ACTIONS(6726),
    [anon_sym_BSLASHcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHparencite] = ACTIONS(6726),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHParencite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHtextcite] = ACTIONS(6726),
    [anon_sym_BSLASHTextcite] = ACTIONS(6726),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHsupercite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite] = ACTIONS(6726),
    [anon_sym_BSLASHAutocite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHVolcite] = ACTIONS(6726),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHavolcite] = ACTIONS(6726),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHNotecite] = ACTIONS(6726),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHlabel] = ACTIONS(6726),
    [anon_sym_BSLASHref] = ACTIONS(6726),
    [anon_sym_BSLASHeqref] = ACTIONS(6726),
    [anon_sym_BSLASHvref] = ACTIONS(6726),
    [anon_sym_BSLASHVref] = ACTIONS(6726),
    [anon_sym_BSLASHautoref] = ACTIONS(6726),
    [anon_sym_BSLASHpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcref] = ACTIONS(6726),
    [anon_sym_BSLASHCref] = ACTIONS(6726),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnameCref] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHdef] = ACTIONS(6726),
    [anon_sym_BSLASHlet] = ACTIONS(6726),
    [anon_sym_BSLASHleft] = ACTIONS(6726),
    [anon_sym_BSLASHbigl] = ACTIONS(6726),
    [anon_sym_BSLASHBigl] = ACTIONS(6726),
    [anon_sym_BSLASHbiggl] = ACTIONS(6726),
    [anon_sym_BSLASHBiggl] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6726),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6726),
    [anon_sym_BSLASHgls] = ACTIONS(6726),
    [anon_sym_BSLASHGls] = ACTIONS(6726),
    [anon_sym_BSLASHGLS] = ACTIONS(6726),
    [anon_sym_BSLASHglspl] = ACTIONS(6726),
    [anon_sym_BSLASHGlspl] = ACTIONS(6726),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6726),
    [anon_sym_BSLASHglslink] = ACTIONS(6726),
    [anon_sym_BSLASHglstext] = ACTIONS(6726),
    [anon_sym_BSLASHGlstext] = ACTIONS(6726),
    [anon_sym_BSLASHGLStext] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6726),
    [anon_sym_BSLASHglsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsname] = ACTIONS(6726),
    [anon_sym_BSLASHGlsname] = ACTIONS(6726),
    [anon_sym_BSLASHGLSname] = ACTIONS(6726),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6726),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6726),
    [anon_sym_BSLASHacrshort] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6726),
    [anon_sym_BSLASHACRshort] = ACTIONS(6726),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrlong] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6726),
    [anon_sym_BSLASHACRlong] = ACTIONS(6726),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrfull] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6726),
    [anon_sym_BSLASHACRfull] = ACTIONS(6726),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHacs] = ACTIONS(6726),
    [anon_sym_BSLASHAcs] = ACTIONS(6726),
    [anon_sym_BSLASHacsp] = ACTIONS(6726),
    [anon_sym_BSLASHAcsp] = ACTIONS(6726),
    [anon_sym_BSLASHacl] = ACTIONS(6726),
    [anon_sym_BSLASHAcl] = ACTIONS(6726),
    [anon_sym_BSLASHaclp] = ACTIONS(6726),
    [anon_sym_BSLASHAclp] = ACTIONS(6726),
    [anon_sym_BSLASHacf] = ACTIONS(6726),
    [anon_sym_BSLASHAcf] = ACTIONS(6726),
    [anon_sym_BSLASHacfp] = ACTIONS(6726),
    [anon_sym_BSLASHAcfp] = ACTIONS(6726),
    [anon_sym_BSLASHac] = ACTIONS(6726),
    [anon_sym_BSLASHAc] = ACTIONS(6726),
    [anon_sym_BSLASHacp] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6726),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6726),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6726),
    [anon_sym_BSLASHcolor] = ACTIONS(6726),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6726),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6726),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6726),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6726),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6726),
    [anon_sym_BSLASHtext] = ACTIONS(6726),
    [anon_sym_BSLASHintertext] = ACTIONS(6726),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6726),
    [anon_sym_BSLASHurl] = ACTIONS(6726),
    [anon_sym_BSLASHhref] = ACTIONS(6726),
  },
  [1454] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2462),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym_key_value_pair] = STATE(2384),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1455] = {
    [sym_command_name] = ACTIONS(6638),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6640),
    [anon_sym_RBRACK] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LPAREN] = ACTIONS(6640),
    [anon_sym_RPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHpart] = ACTIONS(6638),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddpart] = ACTIONS(6638),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHchapter] = ACTIONS(6638),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddchap] = ACTIONS(6638),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsection] = ACTIONS(6638),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHaddsec] = ACTIONS(6638),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6638),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6638),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHitem] = ACTIONS(6638),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(6640),
    [sym_word] = ACTIONS(6638),
    [sym_placeholder] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_DASH] = ACTIONS(6640),
    [anon_sym_STAR] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6638),
    [anon_sym_GT] = ACTIONS(6638),
    [anon_sym_BANG] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6638),
    [anon_sym_COLON] = ACTIONS(6638),
    [anon_sym_SQUOTE] = ACTIONS(6638),
    [anon_sym__] = ACTIONS(6640),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6640),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6640),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6640),
    [anon_sym_DOLLAR] = ACTIONS(6638),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHbegin] = ACTIONS(6638),
    [anon_sym_BSLASHtitle] = ACTIONS(6638),
    [anon_sym_BSLASHauthor] = ACTIONS(6638),
    [anon_sym_BSLASHusepackage] = ACTIONS(6638),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6638),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6638),
    [anon_sym_BSLASHinclude] = ACTIONS(6638),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6638),
    [anon_sym_BSLASHinput] = ACTIONS(6638),
    [anon_sym_BSLASHsubfile] = ACTIONS(6638),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6638),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6638),
    [anon_sym_BSLASHbibliography] = ACTIONS(6638),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6638),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6638),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6638),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6638),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6638),
    [anon_sym_BSLASHimport] = ACTIONS(6638),
    [anon_sym_BSLASHsubimport] = ACTIONS(6638),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6638),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHcaption] = ACTIONS(6638),
    [anon_sym_BSLASHcite] = ACTIONS(6638),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCite] = ACTIONS(6638),
    [anon_sym_BSLASHnocite] = ACTIONS(6638),
    [anon_sym_BSLASHcitet] = ACTIONS(6638),
    [anon_sym_BSLASHcitep] = ACTIONS(6638),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteA] = ACTIONS(6638),
    [anon_sym_BSLASHciteR] = ACTIONS(6638),
    [anon_sym_BSLASHciteS] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6638),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteyear] = ACTIONS(6638),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitedate] = ACTIONS(6638),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteurl] = ACTIONS(6638),
    [anon_sym_BSLASHfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6638),
    [anon_sym_BSLASHcitealt] = ACTIONS(6638),
    [anon_sym_BSLASHcitealp] = ACTIONS(6638),
    [anon_sym_BSLASHcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHparencite] = ACTIONS(6638),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHParencite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHtextcite] = ACTIONS(6638),
    [anon_sym_BSLASHTextcite] = ACTIONS(6638),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHsupercite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite] = ACTIONS(6638),
    [anon_sym_BSLASHAutocite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHVolcite] = ACTIONS(6638),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHavolcite] = ACTIONS(6638),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHNotecite] = ACTIONS(6638),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHlabel] = ACTIONS(6638),
    [anon_sym_BSLASHref] = ACTIONS(6638),
    [anon_sym_BSLASHeqref] = ACTIONS(6638),
    [anon_sym_BSLASHvref] = ACTIONS(6638),
    [anon_sym_BSLASHVref] = ACTIONS(6638),
    [anon_sym_BSLASHautoref] = ACTIONS(6638),
    [anon_sym_BSLASHpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcref] = ACTIONS(6638),
    [anon_sym_BSLASHCref] = ACTIONS(6638),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnameCref] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHdef] = ACTIONS(6638),
    [anon_sym_BSLASHlet] = ACTIONS(6638),
    [anon_sym_BSLASHleft] = ACTIONS(6638),
    [anon_sym_BSLASHbigl] = ACTIONS(6638),
    [anon_sym_BSLASHBigl] = ACTIONS(6638),
    [anon_sym_BSLASHbiggl] = ACTIONS(6638),
    [anon_sym_BSLASHBiggl] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6638),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6638),
    [anon_sym_BSLASHgls] = ACTIONS(6638),
    [anon_sym_BSLASHGls] = ACTIONS(6638),
    [anon_sym_BSLASHGLS] = ACTIONS(6638),
    [anon_sym_BSLASHglspl] = ACTIONS(6638),
    [anon_sym_BSLASHGlspl] = ACTIONS(6638),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6638),
    [anon_sym_BSLASHglslink] = ACTIONS(6638),
    [anon_sym_BSLASHglstext] = ACTIONS(6638),
    [anon_sym_BSLASHGlstext] = ACTIONS(6638),
    [anon_sym_BSLASHGLStext] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6638),
    [anon_sym_BSLASHglsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsname] = ACTIONS(6638),
    [anon_sym_BSLASHGlsname] = ACTIONS(6638),
    [anon_sym_BSLASHGLSname] = ACTIONS(6638),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6638),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6638),
    [anon_sym_BSLASHacrshort] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6638),
    [anon_sym_BSLASHACRshort] = ACTIONS(6638),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrlong] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6638),
    [anon_sym_BSLASHACRlong] = ACTIONS(6638),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrfull] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6638),
    [anon_sym_BSLASHACRfull] = ACTIONS(6638),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHacs] = ACTIONS(6638),
    [anon_sym_BSLASHAcs] = ACTIONS(6638),
    [anon_sym_BSLASHacsp] = ACTIONS(6638),
    [anon_sym_BSLASHAcsp] = ACTIONS(6638),
    [anon_sym_BSLASHacl] = ACTIONS(6638),
    [anon_sym_BSLASHAcl] = ACTIONS(6638),
    [anon_sym_BSLASHaclp] = ACTIONS(6638),
    [anon_sym_BSLASHAclp] = ACTIONS(6638),
    [anon_sym_BSLASHacf] = ACTIONS(6638),
    [anon_sym_BSLASHAcf] = ACTIONS(6638),
    [anon_sym_BSLASHacfp] = ACTIONS(6638),
    [anon_sym_BSLASHAcfp] = ACTIONS(6638),
    [anon_sym_BSLASHac] = ACTIONS(6638),
    [anon_sym_BSLASHAc] = ACTIONS(6638),
    [anon_sym_BSLASHacp] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6638),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6638),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6638),
    [anon_sym_BSLASHcolor] = ACTIONS(6638),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6638),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6638),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6638),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6638),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6638),
    [anon_sym_BSLASHtext] = ACTIONS(6638),
    [anon_sym_BSLASHintertext] = ACTIONS(6638),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6638),
    [anon_sym_BSLASHurl] = ACTIONS(6638),
    [anon_sym_BSLASHhref] = ACTIONS(6638),
  },
  [1456] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2365),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7101),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1457] = {
    [sym_command_name] = ACTIONS(6630),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LPAREN] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHpart] = ACTIONS(6630),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddpart] = ACTIONS(6630),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHchapter] = ACTIONS(6630),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddchap] = ACTIONS(6630),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsection] = ACTIONS(6630),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHaddsec] = ACTIONS(6630),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6630),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6630),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHitem] = ACTIONS(6630),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [sym_word] = ACTIONS(6630),
    [sym_placeholder] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [anon_sym_STAR] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_BANG] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_COLON] = ACTIONS(6630),
    [anon_sym_SQUOTE] = ACTIONS(6630),
    [anon_sym__] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6632),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6632),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6632),
    [anon_sym_DOLLAR] = ACTIONS(6630),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHbegin] = ACTIONS(6630),
    [anon_sym_BSLASHtitle] = ACTIONS(6630),
    [anon_sym_BSLASHauthor] = ACTIONS(6630),
    [anon_sym_BSLASHusepackage] = ACTIONS(6630),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6630),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6630),
    [anon_sym_BSLASHinclude] = ACTIONS(6630),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6630),
    [anon_sym_BSLASHinput] = ACTIONS(6630),
    [anon_sym_BSLASHsubfile] = ACTIONS(6630),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6630),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6630),
    [anon_sym_BSLASHbibliography] = ACTIONS(6630),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6630),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6630),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6630),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6630),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6630),
    [anon_sym_BSLASHimport] = ACTIONS(6630),
    [anon_sym_BSLASHsubimport] = ACTIONS(6630),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6630),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHcaption] = ACTIONS(6630),
    [anon_sym_BSLASHcite] = ACTIONS(6630),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCite] = ACTIONS(6630),
    [anon_sym_BSLASHnocite] = ACTIONS(6630),
    [anon_sym_BSLASHcitet] = ACTIONS(6630),
    [anon_sym_BSLASHcitep] = ACTIONS(6630),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteA] = ACTIONS(6630),
    [anon_sym_BSLASHciteR] = ACTIONS(6630),
    [anon_sym_BSLASHciteS] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6630),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteyear] = ACTIONS(6630),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitedate] = ACTIONS(6630),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteurl] = ACTIONS(6630),
    [anon_sym_BSLASHfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6630),
    [anon_sym_BSLASHcitealt] = ACTIONS(6630),
    [anon_sym_BSLASHcitealp] = ACTIONS(6630),
    [anon_sym_BSLASHcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHparencite] = ACTIONS(6630),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHParencite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHtextcite] = ACTIONS(6630),
    [anon_sym_BSLASHTextcite] = ACTIONS(6630),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHsupercite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite] = ACTIONS(6630),
    [anon_sym_BSLASHAutocite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHVolcite] = ACTIONS(6630),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHavolcite] = ACTIONS(6630),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHNotecite] = ACTIONS(6630),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHlabel] = ACTIONS(6630),
    [anon_sym_BSLASHref] = ACTIONS(6630),
    [anon_sym_BSLASHeqref] = ACTIONS(6630),
    [anon_sym_BSLASHvref] = ACTIONS(6630),
    [anon_sym_BSLASHVref] = ACTIONS(6630),
    [anon_sym_BSLASHautoref] = ACTIONS(6630),
    [anon_sym_BSLASHpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcref] = ACTIONS(6630),
    [anon_sym_BSLASHCref] = ACTIONS(6630),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnameCref] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHdef] = ACTIONS(6630),
    [anon_sym_BSLASHlet] = ACTIONS(6630),
    [anon_sym_BSLASHleft] = ACTIONS(6630),
    [anon_sym_BSLASHbigl] = ACTIONS(6630),
    [anon_sym_BSLASHBigl] = ACTIONS(6630),
    [anon_sym_BSLASHbiggl] = ACTIONS(6630),
    [anon_sym_BSLASHBiggl] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6630),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6630),
    [anon_sym_BSLASHgls] = ACTIONS(6630),
    [anon_sym_BSLASHGls] = ACTIONS(6630),
    [anon_sym_BSLASHGLS] = ACTIONS(6630),
    [anon_sym_BSLASHglspl] = ACTIONS(6630),
    [anon_sym_BSLASHGlspl] = ACTIONS(6630),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6630),
    [anon_sym_BSLASHglslink] = ACTIONS(6630),
    [anon_sym_BSLASHglstext] = ACTIONS(6630),
    [anon_sym_BSLASHGlstext] = ACTIONS(6630),
    [anon_sym_BSLASHGLStext] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6630),
    [anon_sym_BSLASHglsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsname] = ACTIONS(6630),
    [anon_sym_BSLASHGlsname] = ACTIONS(6630),
    [anon_sym_BSLASHGLSname] = ACTIONS(6630),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6630),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6630),
    [anon_sym_BSLASHacrshort] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6630),
    [anon_sym_BSLASHACRshort] = ACTIONS(6630),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrlong] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6630),
    [anon_sym_BSLASHACRlong] = ACTIONS(6630),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrfull] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6630),
    [anon_sym_BSLASHACRfull] = ACTIONS(6630),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHacs] = ACTIONS(6630),
    [anon_sym_BSLASHAcs] = ACTIONS(6630),
    [anon_sym_BSLASHacsp] = ACTIONS(6630),
    [anon_sym_BSLASHAcsp] = ACTIONS(6630),
    [anon_sym_BSLASHacl] = ACTIONS(6630),
    [anon_sym_BSLASHAcl] = ACTIONS(6630),
    [anon_sym_BSLASHaclp] = ACTIONS(6630),
    [anon_sym_BSLASHAclp] = ACTIONS(6630),
    [anon_sym_BSLASHacf] = ACTIONS(6630),
    [anon_sym_BSLASHAcf] = ACTIONS(6630),
    [anon_sym_BSLASHacfp] = ACTIONS(6630),
    [anon_sym_BSLASHAcfp] = ACTIONS(6630),
    [anon_sym_BSLASHac] = ACTIONS(6630),
    [anon_sym_BSLASHAc] = ACTIONS(6630),
    [anon_sym_BSLASHacp] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6630),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6630),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6630),
    [anon_sym_BSLASHcolor] = ACTIONS(6630),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6630),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6630),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6630),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6630),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6630),
    [anon_sym_BSLASHtext] = ACTIONS(6630),
    [anon_sym_BSLASHintertext] = ACTIONS(6630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6630),
    [anon_sym_BSLASHurl] = ACTIONS(6630),
    [anon_sym_BSLASHhref] = ACTIONS(6630),
  },
  [1458] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2373),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7103),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1459] = {
    [sym_command_name] = ACTIONS(7105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7105),
    [anon_sym_LBRACK] = ACTIONS(7107),
    [anon_sym_RBRACK] = ACTIONS(7107),
    [anon_sym_COMMA] = ACTIONS(7107),
    [anon_sym_EQ] = ACTIONS(7107),
    [anon_sym_LPAREN] = ACTIONS(7107),
    [anon_sym_RPAREN] = ACTIONS(7107),
    [anon_sym_BSLASHpart] = ACTIONS(7105),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHaddpart] = ACTIONS(7105),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHchapter] = ACTIONS(7105),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHaddchap] = ACTIONS(7105),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHsection] = ACTIONS(7105),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHaddsec] = ACTIONS(7105),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHsubsection] = ACTIONS(7105),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(7105),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHparagraph] = ACTIONS(7105),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(7105),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHitem] = ACTIONS(7105),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(7107),
    [anon_sym_LBRACE] = ACTIONS(7107),
    [sym_word] = ACTIONS(7105),
    [sym_placeholder] = ACTIONS(7107),
    [anon_sym_PLUS] = ACTIONS(7107),
    [anon_sym_DASH] = ACTIONS(7107),
    [anon_sym_STAR] = ACTIONS(7107),
    [anon_sym_SLASH] = ACTIONS(7107),
    [anon_sym_LT] = ACTIONS(7105),
    [anon_sym_GT] = ACTIONS(7105),
    [anon_sym_BANG] = ACTIONS(7105),
    [anon_sym_PIPE] = ACTIONS(7105),
    [anon_sym_COLON] = ACTIONS(7105),
    [anon_sym_SQUOTE] = ACTIONS(7105),
    [anon_sym__] = ACTIONS(7107),
    [anon_sym_CARET] = ACTIONS(7107),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7107),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7107),
    [anon_sym_DOLLAR] = ACTIONS(7105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7107),
    [anon_sym_BSLASHbegin] = ACTIONS(7105),
    [anon_sym_BSLASHend] = ACTIONS(7105),
    [anon_sym_BSLASHtitle] = ACTIONS(7105),
    [anon_sym_BSLASHauthor] = ACTIONS(7105),
    [anon_sym_BSLASHusepackage] = ACTIONS(7105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7105),
    [anon_sym_BSLASHinclude] = ACTIONS(7105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7105),
    [anon_sym_BSLASHinput] = ACTIONS(7105),
    [anon_sym_BSLASHsubfile] = ACTIONS(7105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7105),
    [anon_sym_BSLASHbibliography] = ACTIONS(7105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7105),
    [anon_sym_BSLASHimport] = ACTIONS(7105),
    [anon_sym_BSLASHsubimport] = ACTIONS(7105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7105),
    [anon_sym_BSLASHcaption] = ACTIONS(7105),
    [anon_sym_BSLASHcite] = ACTIONS(7105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHCite] = ACTIONS(7105),
    [anon_sym_BSLASHnocite] = ACTIONS(7105),
    [anon_sym_BSLASHcitet] = ACTIONS(7105),
    [anon_sym_BSLASHcitep] = ACTIONS(7105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHciteA] = ACTIONS(7105),
    [anon_sym_BSLASHciteR] = ACTIONS(7105),
    [anon_sym_BSLASHciteS] = ACTIONS(7105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHciteyear] = ACTIONS(7105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHcitedate] = ACTIONS(7105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHciteurl] = ACTIONS(7105),
    [anon_sym_BSLASHfullcite] = ACTIONS(7105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7105),
    [anon_sym_BSLASHcitealt] = ACTIONS(7105),
    [anon_sym_BSLASHcitealp] = ACTIONS(7105),
    [anon_sym_BSLASHcitetext] = ACTIONS(7105),
    [anon_sym_BSLASHparencite] = ACTIONS(7105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHParencite] = ACTIONS(7105),
    [anon_sym_BSLASHfootcite] = ACTIONS(7105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7105),
    [anon_sym_BSLASHtextcite] = ACTIONS(7105),
    [anon_sym_BSLASHTextcite] = ACTIONS(7105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7105),
    [anon_sym_BSLASHsupercite] = ACTIONS(7105),
    [anon_sym_BSLASHautocite] = ACTIONS(7105),
    [anon_sym_BSLASHAutocite] = ACTIONS(7105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHVolcite] = ACTIONS(7105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHavolcite] = ACTIONS(7105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7105),
    [anon_sym_BSLASHnotecite] = ACTIONS(7105),
    [anon_sym_BSLASHNotecite] = ACTIONS(7105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7105),
    [anon_sym_BSLASHlabel] = ACTIONS(7105),
    [anon_sym_BSLASHref] = ACTIONS(7105),
    [anon_sym_BSLASHeqref] = ACTIONS(7105),
    [anon_sym_BSLASHvref] = ACTIONS(7105),
    [anon_sym_BSLASHVref] = ACTIONS(7105),
    [anon_sym_BSLASHautoref] = ACTIONS(7105),
    [anon_sym_BSLASHpageref] = ACTIONS(7105),
    [anon_sym_BSLASHcref] = ACTIONS(7105),
    [anon_sym_BSLASHCref] = ACTIONS(7105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHnamecref] = ACTIONS(7105),
    [anon_sym_BSLASHnameCref] = ACTIONS(7105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7105),
    [anon_sym_BSLASHdef] = ACTIONS(7105),
    [anon_sym_BSLASHlet] = ACTIONS(7105),
    [anon_sym_BSLASHleft] = ACTIONS(7105),
    [anon_sym_BSLASHbigl] = ACTIONS(7105),
    [anon_sym_BSLASHBigl] = ACTIONS(7105),
    [anon_sym_BSLASHbiggl] = ACTIONS(7105),
    [anon_sym_BSLASHBiggl] = ACTIONS(7105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7105),
    [anon_sym_BSLASHgls] = ACTIONS(7105),
    [anon_sym_BSLASHGls] = ACTIONS(7105),
    [anon_sym_BSLASHGLS] = ACTIONS(7105),
    [anon_sym_BSLASHglspl] = ACTIONS(7105),
    [anon_sym_BSLASHGlspl] = ACTIONS(7105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7105),
    [anon_sym_BSLASHglslink] = ACTIONS(7105),
    [anon_sym_BSLASHglstext] = ACTIONS(7105),
    [anon_sym_BSLASHGlstext] = ACTIONS(7105),
    [anon_sym_BSLASHGLStext] = ACTIONS(7105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7105),
    [anon_sym_BSLASHglsplural] = ACTIONS(7105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7105),
    [anon_sym_BSLASHglsname] = ACTIONS(7105),
    [anon_sym_BSLASHGlsname] = ACTIONS(7105),
    [anon_sym_BSLASHGLSname] = ACTIONS(7105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7105),
    [anon_sym_BSLASHacrshort] = ACTIONS(7105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7105),
    [anon_sym_BSLASHACRshort] = ACTIONS(7105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7105),
    [anon_sym_BSLASHacrlong] = ACTIONS(7105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7105),
    [anon_sym_BSLASHACRlong] = ACTIONS(7105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7105),
    [anon_sym_BSLASHacrfull] = ACTIONS(7105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7105),
    [anon_sym_BSLASHACRfull] = ACTIONS(7105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7105),
    [anon_sym_BSLASHacs] = ACTIONS(7105),
    [anon_sym_BSLASHAcs] = ACTIONS(7105),
    [anon_sym_BSLASHacsp] = ACTIONS(7105),
    [anon_sym_BSLASHAcsp] = ACTIONS(7105),
    [anon_sym_BSLASHacl] = ACTIONS(7105),
    [anon_sym_BSLASHAcl] = ACTIONS(7105),
    [anon_sym_BSLASHaclp] = ACTIONS(7105),
    [anon_sym_BSLASHAclp] = ACTIONS(7105),
    [anon_sym_BSLASHacf] = ACTIONS(7105),
    [anon_sym_BSLASHAcf] = ACTIONS(7105),
    [anon_sym_BSLASHacfp] = ACTIONS(7105),
    [anon_sym_BSLASHAcfp] = ACTIONS(7105),
    [anon_sym_BSLASHac] = ACTIONS(7105),
    [anon_sym_BSLASHAc] = ACTIONS(7105),
    [anon_sym_BSLASHacp] = ACTIONS(7105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7107),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7105),
    [anon_sym_BSLASHcolor] = ACTIONS(7105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7105),
    [anon_sym_BSLASHtext] = ACTIONS(7105),
    [anon_sym_BSLASHintertext] = ACTIONS(7105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7105),
    [anon_sym_BSLASHurl] = ACTIONS(7105),
    [anon_sym_BSLASHhref] = ACTIONS(7105),
  },
  [1460] = {
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_LBRACK] = ACTIONS(6520),
    [anon_sym_RBRACK] = ACTIONS(6520),
    [anon_sym_COMMA] = ACTIONS(6520),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_LPAREN] = ACTIONS(6520),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHpart] = ACTIONS(6518),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddpart] = ACTIONS(6518),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHchapter] = ACTIONS(6518),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddchap] = ACTIONS(6518),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsection] = ACTIONS(6518),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHaddsec] = ACTIONS(6518),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6518),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6518),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHitem] = ACTIONS(6518),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6520),
    [anon_sym_LBRACE] = ACTIONS(6520),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6520),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6520),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6520),
    [anon_sym_DOLLAR] = ACTIONS(6518),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHbegin] = ACTIONS(6518),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHleft] = ACTIONS(6518),
    [anon_sym_BSLASHbigl] = ACTIONS(6518),
    [anon_sym_BSLASHBigl] = ACTIONS(6518),
    [anon_sym_BSLASHbiggl] = ACTIONS(6518),
    [anon_sym_BSLASHBiggl] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHtext] = ACTIONS(6518),
    [anon_sym_BSLASHintertext] = ACTIONS(6518),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [1461] = {
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_LBRACK] = ACTIONS(6574),
    [anon_sym_RBRACK] = ACTIONS(6574),
    [anon_sym_COMMA] = ACTIONS(6574),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_RPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHpart] = ACTIONS(6572),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddpart] = ACTIONS(6572),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHchapter] = ACTIONS(6572),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddchap] = ACTIONS(6572),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsection] = ACTIONS(6572),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHaddsec] = ACTIONS(6572),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6572),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6572),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHitem] = ACTIONS(6572),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6574),
    [anon_sym_LBRACE] = ACTIONS(6574),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6574),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6574),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6574),
    [anon_sym_DOLLAR] = ACTIONS(6572),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHbegin] = ACTIONS(6572),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHleft] = ACTIONS(6572),
    [anon_sym_BSLASHbigl] = ACTIONS(6572),
    [anon_sym_BSLASHBigl] = ACTIONS(6572),
    [anon_sym_BSLASHbiggl] = ACTIONS(6572),
    [anon_sym_BSLASHBiggl] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHtext] = ACTIONS(6572),
    [anon_sym_BSLASHintertext] = ACTIONS(6572),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [1462] = {
    [sym_command_name] = ACTIONS(6626),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6628),
    [anon_sym_RBRACK] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LPAREN] = ACTIONS(6628),
    [anon_sym_RPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHpart] = ACTIONS(6626),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddpart] = ACTIONS(6626),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHchapter] = ACTIONS(6626),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddchap] = ACTIONS(6626),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsection] = ACTIONS(6626),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHaddsec] = ACTIONS(6626),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6626),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6626),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHitem] = ACTIONS(6626),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6628),
    [anon_sym_LBRACE] = ACTIONS(6628),
    [sym_word] = ACTIONS(6626),
    [sym_placeholder] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_DASH] = ACTIONS(6628),
    [anon_sym_STAR] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6626),
    [anon_sym_GT] = ACTIONS(6626),
    [anon_sym_BANG] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6626),
    [anon_sym_COLON] = ACTIONS(6626),
    [anon_sym_SQUOTE] = ACTIONS(6626),
    [anon_sym__] = ACTIONS(6628),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6628),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6628),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(6628),
    [anon_sym_DOLLAR] = ACTIONS(6626),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHbegin] = ACTIONS(6626),
    [anon_sym_BSLASHtitle] = ACTIONS(6626),
    [anon_sym_BSLASHauthor] = ACTIONS(6626),
    [anon_sym_BSLASHusepackage] = ACTIONS(6626),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6626),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6626),
    [anon_sym_BSLASHinclude] = ACTIONS(6626),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6626),
    [anon_sym_BSLASHinput] = ACTIONS(6626),
    [anon_sym_BSLASHsubfile] = ACTIONS(6626),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6626),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6626),
    [anon_sym_BSLASHbibliography] = ACTIONS(6626),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6626),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6626),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6626),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6626),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6626),
    [anon_sym_BSLASHimport] = ACTIONS(6626),
    [anon_sym_BSLASHsubimport] = ACTIONS(6626),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6626),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHcaption] = ACTIONS(6626),
    [anon_sym_BSLASHcite] = ACTIONS(6626),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCite] = ACTIONS(6626),
    [anon_sym_BSLASHnocite] = ACTIONS(6626),
    [anon_sym_BSLASHcitet] = ACTIONS(6626),
    [anon_sym_BSLASHcitep] = ACTIONS(6626),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteA] = ACTIONS(6626),
    [anon_sym_BSLASHciteR] = ACTIONS(6626),
    [anon_sym_BSLASHciteS] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6626),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteyear] = ACTIONS(6626),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitedate] = ACTIONS(6626),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteurl] = ACTIONS(6626),
    [anon_sym_BSLASHfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6626),
    [anon_sym_BSLASHcitealt] = ACTIONS(6626),
    [anon_sym_BSLASHcitealp] = ACTIONS(6626),
    [anon_sym_BSLASHcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHparencite] = ACTIONS(6626),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHParencite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHtextcite] = ACTIONS(6626),
    [anon_sym_BSLASHTextcite] = ACTIONS(6626),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHsupercite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite] = ACTIONS(6626),
    [anon_sym_BSLASHAutocite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHVolcite] = ACTIONS(6626),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHavolcite] = ACTIONS(6626),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHNotecite] = ACTIONS(6626),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHlabel] = ACTIONS(6626),
    [anon_sym_BSLASHref] = ACTIONS(6626),
    [anon_sym_BSLASHeqref] = ACTIONS(6626),
    [anon_sym_BSLASHvref] = ACTIONS(6626),
    [anon_sym_BSLASHVref] = ACTIONS(6626),
    [anon_sym_BSLASHautoref] = ACTIONS(6626),
    [anon_sym_BSLASHpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcref] = ACTIONS(6626),
    [anon_sym_BSLASHCref] = ACTIONS(6626),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnameCref] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHdef] = ACTIONS(6626),
    [anon_sym_BSLASHlet] = ACTIONS(6626),
    [anon_sym_BSLASHleft] = ACTIONS(6626),
    [anon_sym_BSLASHbigl] = ACTIONS(6626),
    [anon_sym_BSLASHBigl] = ACTIONS(6626),
    [anon_sym_BSLASHbiggl] = ACTIONS(6626),
    [anon_sym_BSLASHBiggl] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6626),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6626),
    [anon_sym_BSLASHgls] = ACTIONS(6626),
    [anon_sym_BSLASHGls] = ACTIONS(6626),
    [anon_sym_BSLASHGLS] = ACTIONS(6626),
    [anon_sym_BSLASHglspl] = ACTIONS(6626),
    [anon_sym_BSLASHGlspl] = ACTIONS(6626),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6626),
    [anon_sym_BSLASHglslink] = ACTIONS(6626),
    [anon_sym_BSLASHglstext] = ACTIONS(6626),
    [anon_sym_BSLASHGlstext] = ACTIONS(6626),
    [anon_sym_BSLASHGLStext] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6626),
    [anon_sym_BSLASHglsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsname] = ACTIONS(6626),
    [anon_sym_BSLASHGlsname] = ACTIONS(6626),
    [anon_sym_BSLASHGLSname] = ACTIONS(6626),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6626),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6626),
    [anon_sym_BSLASHacrshort] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6626),
    [anon_sym_BSLASHACRshort] = ACTIONS(6626),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrlong] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6626),
    [anon_sym_BSLASHACRlong] = ACTIONS(6626),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrfull] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6626),
    [anon_sym_BSLASHACRfull] = ACTIONS(6626),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHacs] = ACTIONS(6626),
    [anon_sym_BSLASHAcs] = ACTIONS(6626),
    [anon_sym_BSLASHacsp] = ACTIONS(6626),
    [anon_sym_BSLASHAcsp] = ACTIONS(6626),
    [anon_sym_BSLASHacl] = ACTIONS(6626),
    [anon_sym_BSLASHAcl] = ACTIONS(6626),
    [anon_sym_BSLASHaclp] = ACTIONS(6626),
    [anon_sym_BSLASHAclp] = ACTIONS(6626),
    [anon_sym_BSLASHacf] = ACTIONS(6626),
    [anon_sym_BSLASHAcf] = ACTIONS(6626),
    [anon_sym_BSLASHacfp] = ACTIONS(6626),
    [anon_sym_BSLASHAcfp] = ACTIONS(6626),
    [anon_sym_BSLASHac] = ACTIONS(6626),
    [anon_sym_BSLASHAc] = ACTIONS(6626),
    [anon_sym_BSLASHacp] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6626),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6626),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6626),
    [anon_sym_BSLASHcolor] = ACTIONS(6626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6626),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6626),
    [anon_sym_BSLASHtext] = ACTIONS(6626),
    [anon_sym_BSLASHintertext] = ACTIONS(6626),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6626),
    [anon_sym_BSLASHurl] = ACTIONS(6626),
    [anon_sym_BSLASHhref] = ACTIONS(6626),
  },
  [1463] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2387),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7109),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1464] = {
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6276),
    [anon_sym_RBRACK] = ACTIONS(6276),
    [anon_sym_COMMA] = ACTIONS(6276),
    [anon_sym_EQ] = ACTIONS(6276),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHpart] = ACTIONS(6274),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddpart] = ACTIONS(6274),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHchapter] = ACTIONS(6274),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddchap] = ACTIONS(6274),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsection] = ACTIONS(6274),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHaddsec] = ACTIONS(6274),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6274),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6274),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHitem] = ACTIONS(6274),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6276),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6276),
    [anon_sym_DOLLAR] = ACTIONS(6274),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHbegin] = ACTIONS(6274),
    [anon_sym_BSLASHend] = ACTIONS(6274),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHleft] = ACTIONS(6274),
    [anon_sym_BSLASHbigl] = ACTIONS(6274),
    [anon_sym_BSLASHBigl] = ACTIONS(6274),
    [anon_sym_BSLASHbiggl] = ACTIONS(6274),
    [anon_sym_BSLASHBiggl] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHtext] = ACTIONS(6274),
    [anon_sym_BSLASHintertext] = ACTIONS(6274),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [1465] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2453),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7111),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1466] = {
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_BSLASHpart] = ACTIONS(149),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddpart] = ACTIONS(149),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(151),
    [anon_sym_BSLASHchapter] = ACTIONS(149),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddchap] = ACTIONS(149),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsection] = ACTIONS(149),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHaddsec] = ACTIONS(149),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(149),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(151),
    [anon_sym_BSLASHparagraph] = ACTIONS(149),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(149),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(151),
    [anon_sym_BSLASHitem] = ACTIONS(149),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_BSLASH_RBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [1467] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2376),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7113),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1468] = {
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6412),
    [anon_sym_RBRACK] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHpart] = ACTIONS(6410),
    [anon_sym_BSLASHpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddpart] = ACTIONS(6410),
    [anon_sym_BSLASHaddpart_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHchapter] = ACTIONS(6410),
    [anon_sym_BSLASHchapter_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddchap] = ACTIONS(6410),
    [anon_sym_BSLASHaddchap_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsection] = ACTIONS(6410),
    [anon_sym_BSLASHsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHaddsec] = ACTIONS(6410),
    [anon_sym_BSLASHaddsec_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubsubsection] = ACTIONS(6410),
    [anon_sym_BSLASHsubsubsection_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHsubparagraph] = ACTIONS(6410),
    [anon_sym_BSLASHsubparagraph_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHitem] = ACTIONS(6410),
    [anon_sym_BSLASHitem_STAR] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6412),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6412),
    [anon_sym_DOLLAR] = ACTIONS(6410),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHbegin] = ACTIONS(6410),
    [anon_sym_BSLASHend] = ACTIONS(6410),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHleft] = ACTIONS(6410),
    [anon_sym_BSLASHbigl] = ACTIONS(6410),
    [anon_sym_BSLASHBigl] = ACTIONS(6410),
    [anon_sym_BSLASHbiggl] = ACTIONS(6410),
    [anon_sym_BSLASHBiggl] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHtext] = ACTIONS(6410),
    [anon_sym_BSLASHintertext] = ACTIONS(6410),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [1469] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2414),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(7115),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1470] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3370),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1471] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3248),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1472] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3434),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1473] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3337),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1474] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3467),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1475] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3411),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1476] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3247),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1477] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3466),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1478] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3432),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1479] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3431),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1480] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3406),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1481] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3403),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1482] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3435),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1483] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3371),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1484] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3334),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1485] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3326),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1486] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3325),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1487] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3311),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1488] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3310),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1489] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3302),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1490] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(3468),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1491] = {
    [sym_block_comment] = STATE(2022),
    [sym_text] = STATE(2526),
    [sym_operator] = STATE(2022),
    [sym_subscript] = STATE(2022),
    [sym_superscript] = STATE(2022),
    [sym__command] = STATE(2022),
    [sym_generic_command] = STATE(2022),
    [sym_title_declaration] = STATE(2022),
    [sym_author_declaration] = STATE(2022),
    [sym_package_include] = STATE(2022),
    [sym_class_include] = STATE(2022),
    [sym_latex_include] = STATE(2022),
    [sym_biblatex_include] = STATE(2022),
    [sym_bibstyle_include] = STATE(2022),
    [sym_bibtex_include] = STATE(2022),
    [sym_graphics_include] = STATE(2022),
    [sym_svg_include] = STATE(2022),
    [sym_inkscape_include] = STATE(2022),
    [sym_verbatim_include] = STATE(2022),
    [sym_import_include] = STATE(2022),
    [sym_caption] = STATE(2022),
    [sym_citation] = STATE(2022),
    [sym_label_definition] = STATE(2022),
    [sym_label_reference] = STATE(2022),
    [sym_label_reference_range] = STATE(2022),
    [sym_label_number] = STATE(2022),
    [sym_new_command_definition] = STATE(2022),
    [sym_old_command_definition] = STATE(2022),
    [sym_let_command_definition] = STATE(2022),
    [sym_paired_delimiter_definition] = STATE(2022),
    [sym_environment_definition] = STATE(2022),
    [sym_glossary_entry_definition] = STATE(2022),
    [sym_glossary_entry_reference] = STATE(2022),
    [sym_acronym_definition] = STATE(2022),
    [sym_acronym_reference] = STATE(2022),
    [sym_theorem_definition] = STATE(2022),
    [sym_color_definition] = STATE(2022),
    [sym_color_set_definition] = STATE(2022),
    [sym_color_reference] = STATE(2022),
    [sym_tikz_library_import] = STATE(2022),
    [sym_hyperlink] = STATE(2022),
    [aux_sym_text_repeat1] = STATE(886),
    [sym_command_name] = ACTIONS(4412),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(4414),
    [sym_word] = ACTIONS(4416),
    [sym_placeholder] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_STAR] = ACTIONS(4420),
    [anon_sym_SLASH] = ACTIONS(4420),
    [anon_sym_LT] = ACTIONS(4422),
    [anon_sym_GT] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_PIPE] = ACTIONS(4422),
    [anon_sym_COLON] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4422),
    [anon_sym__] = ACTIONS(4424),
    [anon_sym_CARET] = ACTIONS(4426),
    [anon_sym_BSLASHtitle] = ACTIONS(4446),
    [anon_sym_BSLASHauthor] = ACTIONS(4448),
    [anon_sym_BSLASHusepackage] = ACTIONS(4450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(4450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(4452),
    [anon_sym_BSLASHinclude] = ACTIONS(4454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(4454),
    [anon_sym_BSLASHinput] = ACTIONS(4454),
    [anon_sym_BSLASHsubfile] = ACTIONS(4454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(4456),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(4458),
    [anon_sym_BSLASHbibliography] = ACTIONS(4460),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(4462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(4464),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(4466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(4468),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(4468),
    [anon_sym_BSLASHimport] = ACTIONS(4470),
    [anon_sym_BSLASHsubimport] = ACTIONS(4470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(4470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(4470),
    [anon_sym_BSLASHcaption] = ACTIONS(4472),
    [anon_sym_BSLASHcite] = ACTIONS(4474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCite] = ACTIONS(4474),
    [anon_sym_BSLASHnocite] = ACTIONS(4474),
    [anon_sym_BSLASHcitet] = ACTIONS(4474),
    [anon_sym_BSLASHcitep] = ACTIONS(4474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteA] = ACTIONS(4474),
    [anon_sym_BSLASHciteR] = ACTIONS(4474),
    [anon_sym_BSLASHciteS] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(4474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(4474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteyear] = ACTIONS(4474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHcitedate] = ACTIONS(4474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHciteurl] = ACTIONS(4474),
    [anon_sym_BSLASHfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(4474),
    [anon_sym_BSLASHcitealt] = ACTIONS(4474),
    [anon_sym_BSLASHcitealp] = ACTIONS(4474),
    [anon_sym_BSLASHcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHparencite] = ACTIONS(4474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHParencite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(4474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(4474),
    [anon_sym_BSLASHtextcite] = ACTIONS(4474),
    [anon_sym_BSLASHTextcite] = ACTIONS(4474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(4474),
    [anon_sym_BSLASHsupercite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite] = ACTIONS(4474),
    [anon_sym_BSLASHAutocite] = ACTIONS(4474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(4476),
    [anon_sym_BSLASHvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHVolcite] = ACTIONS(4474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHavolcite] = ACTIONS(4474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(4474),
    [anon_sym_BSLASHnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHNotecite] = ACTIONS(4474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(4474),
    [anon_sym_BSLASHlabel] = ACTIONS(4478),
    [anon_sym_BSLASHref] = ACTIONS(4480),
    [anon_sym_BSLASHeqref] = ACTIONS(4480),
    [anon_sym_BSLASHvref] = ACTIONS(4480),
    [anon_sym_BSLASHVref] = ACTIONS(4480),
    [anon_sym_BSLASHautoref] = ACTIONS(4480),
    [anon_sym_BSLASHpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcref] = ACTIONS(4480),
    [anon_sym_BSLASHCref] = ACTIONS(4480),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(4482),
    [anon_sym_BSLASHnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnameCref] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(4480),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcref] = ACTIONS(4480),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(4480),
    [anon_sym_BSLASHcrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHCrefrange] = ACTIONS(4484),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(4486),
    [anon_sym_BSLASHnewlabel] = ACTIONS(4488),
    [anon_sym_BSLASHnewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(4490),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(4492),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(4490),
    [anon_sym_BSLASHdef] = ACTIONS(4494),
    [anon_sym_BSLASHlet] = ACTIONS(4496),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(4498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(4498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(4500),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(4500),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(4502),
    [anon_sym_BSLASHgls] = ACTIONS(4504),
    [anon_sym_BSLASHGls] = ACTIONS(4504),
    [anon_sym_BSLASHGLS] = ACTIONS(4504),
    [anon_sym_BSLASHglspl] = ACTIONS(4504),
    [anon_sym_BSLASHGlspl] = ACTIONS(4504),
    [anon_sym_BSLASHGLSpl] = ACTIONS(4504),
    [anon_sym_BSLASHglsdisp] = ACTIONS(4504),
    [anon_sym_BSLASHglslink] = ACTIONS(4504),
    [anon_sym_BSLASHglstext] = ACTIONS(4504),
    [anon_sym_BSLASHGlstext] = ACTIONS(4504),
    [anon_sym_BSLASHGLStext] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(4504),
    [anon_sym_BSLASHglsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(4504),
    [anon_sym_BSLASHglsname] = ACTIONS(4504),
    [anon_sym_BSLASHGlsname] = ACTIONS(4504),
    [anon_sym_BSLASHGLSname] = ACTIONS(4504),
    [anon_sym_BSLASHglssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(4504),
    [anon_sym_BSLASHglsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(4504),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(4504),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(4504),
    [anon_sym_BSLASHglsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(4504),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(4504),
    [anon_sym_BSLASHnewacronym] = ACTIONS(4506),
    [anon_sym_BSLASHacrshort] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshort] = ACTIONS(4508),
    [anon_sym_BSLASHACRshort] = ACTIONS(4508),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrlong] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlong] = ACTIONS(4508),
    [anon_sym_BSLASHACRlong] = ACTIONS(4508),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(4508),
    [anon_sym_BSLASHacrfull] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfull] = ACTIONS(4508),
    [anon_sym_BSLASHACRfull] = ACTIONS(4508),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHacs] = ACTIONS(4508),
    [anon_sym_BSLASHAcs] = ACTIONS(4508),
    [anon_sym_BSLASHacsp] = ACTIONS(4508),
    [anon_sym_BSLASHAcsp] = ACTIONS(4508),
    [anon_sym_BSLASHacl] = ACTIONS(4508),
    [anon_sym_BSLASHAcl] = ACTIONS(4508),
    [anon_sym_BSLASHaclp] = ACTIONS(4508),
    [anon_sym_BSLASHAclp] = ACTIONS(4508),
    [anon_sym_BSLASHacf] = ACTIONS(4508),
    [anon_sym_BSLASHAcf] = ACTIONS(4508),
    [anon_sym_BSLASHacfp] = ACTIONS(4508),
    [anon_sym_BSLASHAcfp] = ACTIONS(4508),
    [anon_sym_BSLASHac] = ACTIONS(4508),
    [anon_sym_BSLASHAc] = ACTIONS(4508),
    [anon_sym_BSLASHacp] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(4508),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(4508),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(4508),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(4510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(4510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(4512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(4514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(4516),
    [anon_sym_BSLASHcolor] = ACTIONS(4518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(4518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(4518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(4518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(4520),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(4520),
    [anon_sym_BSLASHurl] = ACTIONS(4522),
    [anon_sym_BSLASHhref] = ACTIONS(4522),
  },
  [1492] = {
    [sym_curly_group] = STATE(1590),
    [aux_sym_generic_command_repeat1] = STATE(1492),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(6133),
    [anon_sym_COMMA] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(7117),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6133),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6133),
    [anon_sym_DOLLAR] = ACTIONS(6131),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHbegin] = ACTIONS(6131),
    [anon_sym_BSLASHend] = ACTIONS(6131),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHleft] = ACTIONS(6131),
    [anon_sym_BSLASHbigl] = ACTIONS(6131),
    [anon_sym_BSLASHBigl] = ACTIONS(6131),
    [anon_sym_BSLASHbiggl] = ACTIONS(6131),
    [anon_sym_BSLASHBiggl] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHtext] = ACTIONS(6131),
    [anon_sym_BSLASHintertext] = ACTIONS(6131),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [1493] = {
    [sym_curly_group] = STATE(1507),
    [sym_brack_group_text] = STATE(2568),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_LPAREN] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6109),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(6105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHbegin] = ACTIONS(6105),
    [anon_sym_BSLASHend] = ACTIONS(6105),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHleft] = ACTIONS(6105),
    [anon_sym_BSLASHbigl] = ACTIONS(6105),
    [anon_sym_BSLASHBigl] = ACTIONS(6105),
    [anon_sym_BSLASHbiggl] = ACTIONS(6105),
    [anon_sym_BSLASHBiggl] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHtext] = ACTIONS(6105),
    [anon_sym_BSLASHintertext] = ACTIONS(6105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [1494] = {
    [sym_curly_group] = STATE(1514),
    [sym_brack_group_text] = STATE(2548),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6129),
    [anon_sym_COMMA] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_LPAREN] = ACTIONS(6129),
    [anon_sym_RPAREN] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6129),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHbegin] = ACTIONS(6127),
    [anon_sym_BSLASHend] = ACTIONS(6127),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHleft] = ACTIONS(6127),
    [anon_sym_BSLASHbigl] = ACTIONS(6127),
    [anon_sym_BSLASHBigl] = ACTIONS(6127),
    [anon_sym_BSLASHbiggl] = ACTIONS(6127),
    [anon_sym_BSLASHBiggl] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHtext] = ACTIONS(6127),
    [anon_sym_BSLASHintertext] = ACTIONS(6127),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [1495] = {
    [sym_curly_group] = STATE(1590),
    [aux_sym_generic_command_repeat1] = STATE(1492),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6125),
    [anon_sym_RBRACK] = ACTIONS(6125),
    [anon_sym_COMMA] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_LPAREN] = ACTIONS(6125),
    [anon_sym_RPAREN] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6125),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6125),
    [anon_sym_DOLLAR] = ACTIONS(6123),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHbegin] = ACTIONS(6123),
    [anon_sym_BSLASHend] = ACTIONS(6123),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHleft] = ACTIONS(6123),
    [anon_sym_BSLASHbigl] = ACTIONS(6123),
    [anon_sym_BSLASHBigl] = ACTIONS(6123),
    [anon_sym_BSLASHbiggl] = ACTIONS(6123),
    [anon_sym_BSLASHBiggl] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHtext] = ACTIONS(6123),
    [anon_sym_BSLASHintertext] = ACTIONS(6123),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [1496] = {
    [sym_curly_group] = STATE(1590),
    [aux_sym_generic_command_repeat1] = STATE(1495),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6121),
    [anon_sym_RBRACK] = ACTIONS(6121),
    [anon_sym_COMMA] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6121),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(6119),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHbegin] = ACTIONS(6119),
    [anon_sym_BSLASHend] = ACTIONS(6119),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHleft] = ACTIONS(6119),
    [anon_sym_BSLASHbigl] = ACTIONS(6119),
    [anon_sym_BSLASHBigl] = ACTIONS(6119),
    [anon_sym_BSLASHbiggl] = ACTIONS(6119),
    [anon_sym_BSLASHBiggl] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHtext] = ACTIONS(6119),
    [anon_sym_BSLASHintertext] = ACTIONS(6119),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [1497] = {
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(7120),
    [anon_sym_LBRACK] = ACTIONS(6115),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6115),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6111),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHbegin] = ACTIONS(6111),
    [anon_sym_BSLASHend] = ACTIONS(6111),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHleft] = ACTIONS(6111),
    [anon_sym_BSLASHbigl] = ACTIONS(6111),
    [anon_sym_BSLASHBigl] = ACTIONS(6111),
    [anon_sym_BSLASHbiggl] = ACTIONS(6111),
    [anon_sym_BSLASHBiggl] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHtext] = ACTIONS(6111),
    [anon_sym_BSLASHintertext] = ACTIONS(6111),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(7122),
  },
  [1498] = {
    [sym_curly_group] = STATE(1635),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6154),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHbegin] = ACTIONS(6152),
    [anon_sym_BSLASHend] = ACTIONS(6152),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHleft] = ACTIONS(6152),
    [anon_sym_BSLASHbigl] = ACTIONS(6152),
    [anon_sym_BSLASHBigl] = ACTIONS(6152),
    [anon_sym_BSLASHbiggl] = ACTIONS(6152),
    [anon_sym_BSLASHBiggl] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHtext] = ACTIONS(6152),
    [anon_sym_BSLASHintertext] = ACTIONS(6152),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [1499] = {
    [sym_curly_group] = STATE(1574),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(6164),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6164),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6164),
    [anon_sym_DOLLAR] = ACTIONS(6162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHbegin] = ACTIONS(6162),
    [anon_sym_BSLASHend] = ACTIONS(6162),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHleft] = ACTIONS(6162),
    [anon_sym_BSLASHbigl] = ACTIONS(6162),
    [anon_sym_BSLASHBigl] = ACTIONS(6162),
    [anon_sym_BSLASHbiggl] = ACTIONS(6162),
    [anon_sym_BSLASHBiggl] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHtext] = ACTIONS(6162),
    [anon_sym_BSLASHintertext] = ACTIONS(6162),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [1500] = {
    [sym_curly_group] = STATE(1680),
    [aux_sym_generic_command_repeat1] = STATE(1500),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(6133),
    [anon_sym_COMMA] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(7124),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6133),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6133),
    [anon_sym_DOLLAR] = ACTIONS(6131),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHbegin] = ACTIONS(6131),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHleft] = ACTIONS(6131),
    [anon_sym_BSLASHbigl] = ACTIONS(6131),
    [anon_sym_BSLASHBigl] = ACTIONS(6131),
    [anon_sym_BSLASHbiggl] = ACTIONS(6131),
    [anon_sym_BSLASHBiggl] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHtext] = ACTIONS(6131),
    [anon_sym_BSLASHintertext] = ACTIONS(6131),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [1501] = {
    [sym_curly_group] = STATE(1589),
    [sym_brack_group_text] = STATE(2685),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_LPAREN] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6109),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(6105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHbegin] = ACTIONS(6105),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHleft] = ACTIONS(6105),
    [anon_sym_BSLASHbigl] = ACTIONS(6105),
    [anon_sym_BSLASHBigl] = ACTIONS(6105),
    [anon_sym_BSLASHbiggl] = ACTIONS(6105),
    [anon_sym_BSLASHBiggl] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHtext] = ACTIONS(6105),
    [anon_sym_BSLASHintertext] = ACTIONS(6105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [1502] = {
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(7127),
    [anon_sym_LBRACK] = ACTIONS(6115),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6115),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6111),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHbegin] = ACTIONS(6111),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHleft] = ACTIONS(6111),
    [anon_sym_BSLASHbigl] = ACTIONS(6111),
    [anon_sym_BSLASHBigl] = ACTIONS(6111),
    [anon_sym_BSLASHbiggl] = ACTIONS(6111),
    [anon_sym_BSLASHBiggl] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHtext] = ACTIONS(6111),
    [anon_sym_BSLASHintertext] = ACTIONS(6111),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(7129),
  },
  [1503] = {
    [sym_curly_group] = STATE(1680),
    [aux_sym_generic_command_repeat1] = STATE(1504),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6121),
    [anon_sym_RBRACK] = ACTIONS(6121),
    [anon_sym_COMMA] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6121),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(6119),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHbegin] = ACTIONS(6119),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHleft] = ACTIONS(6119),
    [anon_sym_BSLASHbigl] = ACTIONS(6119),
    [anon_sym_BSLASHBigl] = ACTIONS(6119),
    [anon_sym_BSLASHbiggl] = ACTIONS(6119),
    [anon_sym_BSLASHBiggl] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHtext] = ACTIONS(6119),
    [anon_sym_BSLASHintertext] = ACTIONS(6119),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [1504] = {
    [sym_curly_group] = STATE(1680),
    [aux_sym_generic_command_repeat1] = STATE(1500),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6125),
    [anon_sym_RBRACK] = ACTIONS(6125),
    [anon_sym_COMMA] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_LPAREN] = ACTIONS(6125),
    [anon_sym_RPAREN] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6125),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6125),
    [anon_sym_DOLLAR] = ACTIONS(6123),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHbegin] = ACTIONS(6123),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHleft] = ACTIONS(6123),
    [anon_sym_BSLASHbigl] = ACTIONS(6123),
    [anon_sym_BSLASHBigl] = ACTIONS(6123),
    [anon_sym_BSLASHbiggl] = ACTIONS(6123),
    [anon_sym_BSLASHBiggl] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHtext] = ACTIONS(6123),
    [anon_sym_BSLASHintertext] = ACTIONS(6123),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [1505] = {
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(7131),
    [anon_sym_LBRACK] = ACTIONS(6160),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6160),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(6156),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHbegin] = ACTIONS(6156),
    [anon_sym_BSLASHend] = ACTIONS(6156),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHleft] = ACTIONS(6156),
    [anon_sym_BSLASHbigl] = ACTIONS(6156),
    [anon_sym_BSLASHBigl] = ACTIONS(6156),
    [anon_sym_BSLASHbiggl] = ACTIONS(6156),
    [anon_sym_BSLASHBiggl] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHtext] = ACTIONS(6156),
    [anon_sym_BSLASHintertext] = ACTIONS(6156),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [1506] = {
    [sym_curly_group] = STATE(1632),
    [sym_brack_group_text] = STATE(2665),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6129),
    [anon_sym_COMMA] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_LPAREN] = ACTIONS(6129),
    [anon_sym_RPAREN] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6129),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHbegin] = ACTIONS(6127),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHleft] = ACTIONS(6127),
    [anon_sym_BSLASHbigl] = ACTIONS(6127),
    [anon_sym_BSLASHBigl] = ACTIONS(6127),
    [anon_sym_BSLASHbiggl] = ACTIONS(6127),
    [anon_sym_BSLASHBiggl] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHtext] = ACTIONS(6127),
    [anon_sym_BSLASHintertext] = ACTIONS(6127),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [1507] = {
    [sym_brack_group_text] = STATE(1639),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(7133),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [anon_sym_LBRACE] = ACTIONS(6150),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6150),
    [anon_sym_DOLLAR] = ACTIONS(6148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHbegin] = ACTIONS(6148),
    [anon_sym_BSLASHend] = ACTIONS(6148),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHleft] = ACTIONS(6148),
    [anon_sym_BSLASHbigl] = ACTIONS(6148),
    [anon_sym_BSLASHBigl] = ACTIONS(6148),
    [anon_sym_BSLASHbiggl] = ACTIONS(6148),
    [anon_sym_BSLASHBiggl] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHtext] = ACTIONS(6148),
    [anon_sym_BSLASHintertext] = ACTIONS(6148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [1508] = {
    [sym_curly_group] = STATE(1643),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6146),
    [anon_sym_LPAREN] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(3109),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6146),
    [anon_sym_DOLLAR] = ACTIONS(6144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHbegin] = ACTIONS(6144),
    [anon_sym_BSLASHend] = ACTIONS(6144),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHleft] = ACTIONS(6144),
    [anon_sym_BSLASHbigl] = ACTIONS(6144),
    [anon_sym_BSLASHBigl] = ACTIONS(6144),
    [anon_sym_BSLASHbiggl] = ACTIONS(6144),
    [anon_sym_BSLASHBiggl] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHtext] = ACTIONS(6144),
    [anon_sym_BSLASHintertext] = ACTIONS(6144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [1509] = {
    [sym_curly_group] = STATE(1619),
    [sym_brack_group_text] = STATE(3068),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_LPAREN] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(6109),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6109),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(6105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHleft] = ACTIONS(6105),
    [anon_sym_BSLASHbigl] = ACTIONS(6105),
    [anon_sym_BSLASHBigl] = ACTIONS(6105),
    [anon_sym_BSLASHbiggl] = ACTIONS(6105),
    [anon_sym_BSLASHBiggl] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHtext] = ACTIONS(6105),
    [anon_sym_BSLASHintertext] = ACTIONS(6105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [1510] = {
    [sym_curly_group] = STATE(1786),
    [aux_sym_generic_command_repeat1] = STATE(1510),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_LBRACK] = ACTIONS(6133),
    [anon_sym_RBRACK] = ACTIONS(6133),
    [anon_sym_COMMA] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(7135),
    [anon_sym_RBRACE] = ACTIONS(6133),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6133),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6133),
    [anon_sym_DOLLAR] = ACTIONS(6131),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHleft] = ACTIONS(6131),
    [anon_sym_BSLASHbigl] = ACTIONS(6131),
    [anon_sym_BSLASHBigl] = ACTIONS(6131),
    [anon_sym_BSLASHbiggl] = ACTIONS(6131),
    [anon_sym_BSLASHBiggl] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHtext] = ACTIONS(6131),
    [anon_sym_BSLASHintertext] = ACTIONS(6131),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [1511] = {
    [sym_curly_group] = STATE(1600),
    [sym_brack_group_text] = STATE(3056),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6129),
    [anon_sym_COMMA] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_LPAREN] = ACTIONS(6129),
    [anon_sym_RPAREN] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(6129),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6129),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHleft] = ACTIONS(6127),
    [anon_sym_BSLASHbigl] = ACTIONS(6127),
    [anon_sym_BSLASHBigl] = ACTIONS(6127),
    [anon_sym_BSLASHbiggl] = ACTIONS(6127),
    [anon_sym_BSLASHBiggl] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHtext] = ACTIONS(6127),
    [anon_sym_BSLASHintertext] = ACTIONS(6127),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [1512] = {
    [sym_curly_group] = STATE(1786),
    [aux_sym_generic_command_repeat1] = STATE(1510),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_LBRACK] = ACTIONS(6125),
    [anon_sym_RBRACK] = ACTIONS(6125),
    [anon_sym_COMMA] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_LPAREN] = ACTIONS(6125),
    [anon_sym_RPAREN] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(6125),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6125),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6125),
    [anon_sym_DOLLAR] = ACTIONS(6123),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHleft] = ACTIONS(6123),
    [anon_sym_BSLASHbigl] = ACTIONS(6123),
    [anon_sym_BSLASHBigl] = ACTIONS(6123),
    [anon_sym_BSLASHbiggl] = ACTIONS(6123),
    [anon_sym_BSLASHBiggl] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHtext] = ACTIONS(6123),
    [anon_sym_BSLASHintertext] = ACTIONS(6123),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [1513] = {
    [sym_curly_group] = STATE(1786),
    [aux_sym_generic_command_repeat1] = STATE(1512),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_LBRACK] = ACTIONS(6121),
    [anon_sym_RBRACK] = ACTIONS(6121),
    [anon_sym_COMMA] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(6121),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6121),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(6119),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHleft] = ACTIONS(6119),
    [anon_sym_BSLASHbigl] = ACTIONS(6119),
    [anon_sym_BSLASHBigl] = ACTIONS(6119),
    [anon_sym_BSLASHbiggl] = ACTIONS(6119),
    [anon_sym_BSLASHBiggl] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHtext] = ACTIONS(6119),
    [anon_sym_BSLASHintertext] = ACTIONS(6119),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [1514] = {
    [sym_brack_group_text] = STATE(1613),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(7133),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6168),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6166),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHbegin] = ACTIONS(6166),
    [anon_sym_BSLASHend] = ACTIONS(6166),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHleft] = ACTIONS(6166),
    [anon_sym_BSLASHbigl] = ACTIONS(6166),
    [anon_sym_BSLASHBigl] = ACTIONS(6166),
    [anon_sym_BSLASHbiggl] = ACTIONS(6166),
    [anon_sym_BSLASHBiggl] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHtext] = ACTIONS(6166),
    [anon_sym_BSLASHintertext] = ACTIONS(6166),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [1515] = {
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(7138),
    [anon_sym_LBRACK] = ACTIONS(6115),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_LPAREN] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [anon_sym_RBRACE] = ACTIONS(6115),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6115),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6111),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHleft] = ACTIONS(6111),
    [anon_sym_BSLASHbigl] = ACTIONS(6111),
    [anon_sym_BSLASHBigl] = ACTIONS(6111),
    [anon_sym_BSLASHbiggl] = ACTIONS(6111),
    [anon_sym_BSLASHBiggl] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHtext] = ACTIONS(6111),
    [anon_sym_BSLASHintertext] = ACTIONS(6111),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(7140),
  },
  [1516] = {
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_EQ] = ACTIONS(6216),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [anon_sym_RPAREN] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6216),
    [anon_sym_DOLLAR] = ACTIONS(6214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHbegin] = ACTIONS(6214),
    [anon_sym_BSLASHend] = ACTIONS(6214),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHleft] = ACTIONS(6214),
    [anon_sym_BSLASHbigl] = ACTIONS(6214),
    [anon_sym_BSLASHBigl] = ACTIONS(6214),
    [anon_sym_BSLASHbiggl] = ACTIONS(6214),
    [anon_sym_BSLASHBiggl] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHtext] = ACTIONS(6214),
    [anon_sym_BSLASHintertext] = ACTIONS(6214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [1517] = {
    [sym_curly_group] = STATE(1707),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6146),
    [anon_sym_LPAREN] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6146),
    [anon_sym_DOLLAR] = ACTIONS(6144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHbegin] = ACTIONS(6144),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHleft] = ACTIONS(6144),
    [anon_sym_BSLASHbigl] = ACTIONS(6144),
    [anon_sym_BSLASHBigl] = ACTIONS(6144),
    [anon_sym_BSLASHbiggl] = ACTIONS(6144),
    [anon_sym_BSLASHBiggl] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHtext] = ACTIONS(6144),
    [anon_sym_BSLASHintertext] = ACTIONS(6144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [1518] = {
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6432),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6432),
    [anon_sym_DOLLAR] = ACTIONS(6430),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHbegin] = ACTIONS(6430),
    [anon_sym_BSLASHend] = ACTIONS(6430),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHleft] = ACTIONS(6430),
    [anon_sym_BSLASHbigl] = ACTIONS(6430),
    [anon_sym_BSLASHBigl] = ACTIONS(6430),
    [anon_sym_BSLASHbiggl] = ACTIONS(6430),
    [anon_sym_BSLASHBiggl] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHtext] = ACTIONS(6430),
    [anon_sym_BSLASHintertext] = ACTIONS(6430),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [1519] = {
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_RBRACK] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6428),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_RPAREN] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6428),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6428),
    [anon_sym_DOLLAR] = ACTIONS(6426),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHbegin] = ACTIONS(6426),
    [anon_sym_BSLASHend] = ACTIONS(6426),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHleft] = ACTIONS(6426),
    [anon_sym_BSLASHbigl] = ACTIONS(6426),
    [anon_sym_BSLASHBigl] = ACTIONS(6426),
    [anon_sym_BSLASHbiggl] = ACTIONS(6426),
    [anon_sym_BSLASHBiggl] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHtext] = ACTIONS(6426),
    [anon_sym_BSLASHintertext] = ACTIONS(6426),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [1520] = {
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_LBRACK] = ACTIONS(6424),
    [anon_sym_RBRACK] = ACTIONS(6424),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_EQ] = ACTIONS(6424),
    [anon_sym_LPAREN] = ACTIONS(6424),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_LBRACE] = ACTIONS(6424),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6424),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6424),
    [anon_sym_DOLLAR] = ACTIONS(6422),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHbegin] = ACTIONS(6422),
    [anon_sym_BSLASHend] = ACTIONS(6422),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHleft] = ACTIONS(6422),
    [anon_sym_BSLASHbigl] = ACTIONS(6422),
    [anon_sym_BSLASHBigl] = ACTIONS(6422),
    [anon_sym_BSLASHbiggl] = ACTIONS(6422),
    [anon_sym_BSLASHBiggl] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHtext] = ACTIONS(6422),
    [anon_sym_BSLASHintertext] = ACTIONS(6422),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [1521] = {
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_RBRACK] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6420),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(6418),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHbegin] = ACTIONS(6418),
    [anon_sym_BSLASHend] = ACTIONS(6418),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHleft] = ACTIONS(6418),
    [anon_sym_BSLASHbigl] = ACTIONS(6418),
    [anon_sym_BSLASHBigl] = ACTIONS(6418),
    [anon_sym_BSLASHbiggl] = ACTIONS(6418),
    [anon_sym_BSLASHBiggl] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHtext] = ACTIONS(6418),
    [anon_sym_BSLASHintertext] = ACTIONS(6418),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [1522] = {
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6416),
    [anon_sym_EQ] = ACTIONS(6416),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_RPAREN] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6416),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(6414),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHbegin] = ACTIONS(6414),
    [anon_sym_BSLASHend] = ACTIONS(6414),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHleft] = ACTIONS(6414),
    [anon_sym_BSLASHbigl] = ACTIONS(6414),
    [anon_sym_BSLASHBigl] = ACTIONS(6414),
    [anon_sym_BSLASHbiggl] = ACTIONS(6414),
    [anon_sym_BSLASHBiggl] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHtext] = ACTIONS(6414),
    [anon_sym_BSLASHintertext] = ACTIONS(6414),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [1523] = {
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6412),
    [anon_sym_RBRACK] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6412),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6412),
    [anon_sym_DOLLAR] = ACTIONS(6410),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHbegin] = ACTIONS(6410),
    [anon_sym_BSLASHend] = ACTIONS(6410),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHleft] = ACTIONS(6410),
    [anon_sym_BSLASHbigl] = ACTIONS(6410),
    [anon_sym_BSLASHBigl] = ACTIONS(6410),
    [anon_sym_BSLASHbiggl] = ACTIONS(6410),
    [anon_sym_BSLASHBiggl] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHtext] = ACTIONS(6410),
    [anon_sym_BSLASHintertext] = ACTIONS(6410),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [1524] = {
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6408),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6408),
    [anon_sym_DOLLAR] = ACTIONS(6406),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHbegin] = ACTIONS(6406),
    [anon_sym_BSLASHend] = ACTIONS(6406),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHleft] = ACTIONS(6406),
    [anon_sym_BSLASHbigl] = ACTIONS(6406),
    [anon_sym_BSLASHBigl] = ACTIONS(6406),
    [anon_sym_BSLASHbiggl] = ACTIONS(6406),
    [anon_sym_BSLASHBiggl] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHtext] = ACTIONS(6406),
    [anon_sym_BSLASHintertext] = ACTIONS(6406),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [1525] = {
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6404),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6404),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6404),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6404),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHbegin] = ACTIONS(6402),
    [anon_sym_BSLASHend] = ACTIONS(6402),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHleft] = ACTIONS(6402),
    [anon_sym_BSLASHbigl] = ACTIONS(6402),
    [anon_sym_BSLASHBigl] = ACTIONS(6402),
    [anon_sym_BSLASHbiggl] = ACTIONS(6402),
    [anon_sym_BSLASHBiggl] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHtext] = ACTIONS(6402),
    [anon_sym_BSLASHintertext] = ACTIONS(6402),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [1526] = {
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6400),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6400),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHbegin] = ACTIONS(6398),
    [anon_sym_BSLASHend] = ACTIONS(6398),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHleft] = ACTIONS(6398),
    [anon_sym_BSLASHbigl] = ACTIONS(6398),
    [anon_sym_BSLASHBigl] = ACTIONS(6398),
    [anon_sym_BSLASHbiggl] = ACTIONS(6398),
    [anon_sym_BSLASHBiggl] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHtext] = ACTIONS(6398),
    [anon_sym_BSLASHintertext] = ACTIONS(6398),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [1527] = {
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6396),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6396),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6396),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6396),
    [anon_sym_DOLLAR] = ACTIONS(6394),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHbegin] = ACTIONS(6394),
    [anon_sym_BSLASHend] = ACTIONS(6394),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHleft] = ACTIONS(6394),
    [anon_sym_BSLASHbigl] = ACTIONS(6394),
    [anon_sym_BSLASHBigl] = ACTIONS(6394),
    [anon_sym_BSLASHbiggl] = ACTIONS(6394),
    [anon_sym_BSLASHBiggl] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHtext] = ACTIONS(6394),
    [anon_sym_BSLASHintertext] = ACTIONS(6394),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [1528] = {
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_COMMA] = ACTIONS(6392),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6392),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(6390),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHbegin] = ACTIONS(6390),
    [anon_sym_BSLASHend] = ACTIONS(6390),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHleft] = ACTIONS(6390),
    [anon_sym_BSLASHbigl] = ACTIONS(6390),
    [anon_sym_BSLASHBigl] = ACTIONS(6390),
    [anon_sym_BSLASHbiggl] = ACTIONS(6390),
    [anon_sym_BSLASHBiggl] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHtext] = ACTIONS(6390),
    [anon_sym_BSLASHintertext] = ACTIONS(6390),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [1529] = {
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_COMMA] = ACTIONS(6388),
    [anon_sym_EQ] = ACTIONS(6388),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6388),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(6386),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHbegin] = ACTIONS(6386),
    [anon_sym_BSLASHend] = ACTIONS(6386),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHleft] = ACTIONS(6386),
    [anon_sym_BSLASHbigl] = ACTIONS(6386),
    [anon_sym_BSLASHBigl] = ACTIONS(6386),
    [anon_sym_BSLASHbiggl] = ACTIONS(6386),
    [anon_sym_BSLASHBiggl] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHtext] = ACTIONS(6386),
    [anon_sym_BSLASHintertext] = ACTIONS(6386),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [1530] = {
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_LBRACK] = ACTIONS(6384),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_EQ] = ACTIONS(6384),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_RPAREN] = ACTIONS(6384),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6384),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(6382),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHbegin] = ACTIONS(6382),
    [anon_sym_BSLASHend] = ACTIONS(6382),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHleft] = ACTIONS(6382),
    [anon_sym_BSLASHbigl] = ACTIONS(6382),
    [anon_sym_BSLASHBigl] = ACTIONS(6382),
    [anon_sym_BSLASHbiggl] = ACTIONS(6382),
    [anon_sym_BSLASHBiggl] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHtext] = ACTIONS(6382),
    [anon_sym_BSLASHintertext] = ACTIONS(6382),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [1531] = {
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_LBRACK] = ACTIONS(6380),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_EQ] = ACTIONS(6380),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6380),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6380),
    [anon_sym_DOLLAR] = ACTIONS(6378),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHbegin] = ACTIONS(6378),
    [anon_sym_BSLASHend] = ACTIONS(6378),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHleft] = ACTIONS(6378),
    [anon_sym_BSLASHbigl] = ACTIONS(6378),
    [anon_sym_BSLASHBigl] = ACTIONS(6378),
    [anon_sym_BSLASHbiggl] = ACTIONS(6378),
    [anon_sym_BSLASHBiggl] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHtext] = ACTIONS(6378),
    [anon_sym_BSLASHintertext] = ACTIONS(6378),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [1532] = {
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_LBRACK] = ACTIONS(6376),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_EQ] = ACTIONS(6376),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6376),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6376),
    [anon_sym_DOLLAR] = ACTIONS(6374),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHbegin] = ACTIONS(6374),
    [anon_sym_BSLASHend] = ACTIONS(6374),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHleft] = ACTIONS(6374),
    [anon_sym_BSLASHbigl] = ACTIONS(6374),
    [anon_sym_BSLASHBigl] = ACTIONS(6374),
    [anon_sym_BSLASHbiggl] = ACTIONS(6374),
    [anon_sym_BSLASHBiggl] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHtext] = ACTIONS(6374),
    [anon_sym_BSLASHintertext] = ACTIONS(6374),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [1533] = {
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LPAREN] = ACTIONS(6364),
    [anon_sym_RPAREN] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6364),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6364),
    [anon_sym_DOLLAR] = ACTIONS(6362),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHbegin] = ACTIONS(6362),
    [anon_sym_BSLASHend] = ACTIONS(6362),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHleft] = ACTIONS(6362),
    [anon_sym_BSLASHbigl] = ACTIONS(6362),
    [anon_sym_BSLASHBigl] = ACTIONS(6362),
    [anon_sym_BSLASHbiggl] = ACTIONS(6362),
    [anon_sym_BSLASHBiggl] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHtext] = ACTIONS(6362),
    [anon_sym_BSLASHintertext] = ACTIONS(6362),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [1534] = {
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_RBRACK] = ACTIONS(6356),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_EQ] = ACTIONS(6356),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_RPAREN] = ACTIONS(6356),
    [anon_sym_LBRACE] = ACTIONS(6356),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6356),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6356),
    [anon_sym_DOLLAR] = ACTIONS(6354),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHbegin] = ACTIONS(6354),
    [anon_sym_BSLASHend] = ACTIONS(6354),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHleft] = ACTIONS(6354),
    [anon_sym_BSLASHbigl] = ACTIONS(6354),
    [anon_sym_BSLASHBigl] = ACTIONS(6354),
    [anon_sym_BSLASHbiggl] = ACTIONS(6354),
    [anon_sym_BSLASHBiggl] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHtext] = ACTIONS(6354),
    [anon_sym_BSLASHintertext] = ACTIONS(6354),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [1535] = {
    [sym_command_name] = ACTIONS(6642),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6642),
    [anon_sym_LBRACK] = ACTIONS(6644),
    [anon_sym_RBRACK] = ACTIONS(6644),
    [anon_sym_COMMA] = ACTIONS(6644),
    [anon_sym_EQ] = ACTIONS(6644),
    [anon_sym_LPAREN] = ACTIONS(6644),
    [anon_sym_RPAREN] = ACTIONS(6644),
    [anon_sym_LBRACE] = ACTIONS(6644),
    [sym_word] = ACTIONS(6642),
    [sym_placeholder] = ACTIONS(6644),
    [anon_sym_PLUS] = ACTIONS(6644),
    [anon_sym_DASH] = ACTIONS(6644),
    [anon_sym_STAR] = ACTIONS(6644),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_LT] = ACTIONS(6642),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_BANG] = ACTIONS(6642),
    [anon_sym_PIPE] = ACTIONS(6642),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_SQUOTE] = ACTIONS(6642),
    [anon_sym__] = ACTIONS(6644),
    [anon_sym_CARET] = ACTIONS(6644),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6644),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6644),
    [anon_sym_DOLLAR] = ACTIONS(6642),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHbegin] = ACTIONS(6642),
    [anon_sym_BSLASHend] = ACTIONS(6642),
    [anon_sym_BSLASHtitle] = ACTIONS(6642),
    [anon_sym_BSLASHauthor] = ACTIONS(6642),
    [anon_sym_BSLASHusepackage] = ACTIONS(6642),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6642),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6642),
    [anon_sym_BSLASHinclude] = ACTIONS(6642),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6642),
    [anon_sym_BSLASHinput] = ACTIONS(6642),
    [anon_sym_BSLASHsubfile] = ACTIONS(6642),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6642),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6642),
    [anon_sym_BSLASHbibliography] = ACTIONS(6642),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6642),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6642),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6642),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6642),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6642),
    [anon_sym_BSLASHimport] = ACTIONS(6642),
    [anon_sym_BSLASHsubimport] = ACTIONS(6642),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6642),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHcaption] = ACTIONS(6642),
    [anon_sym_BSLASHcite] = ACTIONS(6642),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCite] = ACTIONS(6642),
    [anon_sym_BSLASHnocite] = ACTIONS(6642),
    [anon_sym_BSLASHcitet] = ACTIONS(6642),
    [anon_sym_BSLASHcitep] = ACTIONS(6642),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteA] = ACTIONS(6642),
    [anon_sym_BSLASHciteR] = ACTIONS(6642),
    [anon_sym_BSLASHciteS] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6642),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteyear] = ACTIONS(6642),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitedate] = ACTIONS(6642),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteurl] = ACTIONS(6642),
    [anon_sym_BSLASHfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6642),
    [anon_sym_BSLASHcitealt] = ACTIONS(6642),
    [anon_sym_BSLASHcitealp] = ACTIONS(6642),
    [anon_sym_BSLASHcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHparencite] = ACTIONS(6642),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHParencite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHtextcite] = ACTIONS(6642),
    [anon_sym_BSLASHTextcite] = ACTIONS(6642),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHsupercite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite] = ACTIONS(6642),
    [anon_sym_BSLASHAutocite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHVolcite] = ACTIONS(6642),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHavolcite] = ACTIONS(6642),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHNotecite] = ACTIONS(6642),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHlabel] = ACTIONS(6642),
    [anon_sym_BSLASHref] = ACTIONS(6642),
    [anon_sym_BSLASHeqref] = ACTIONS(6642),
    [anon_sym_BSLASHvref] = ACTIONS(6642),
    [anon_sym_BSLASHVref] = ACTIONS(6642),
    [anon_sym_BSLASHautoref] = ACTIONS(6642),
    [anon_sym_BSLASHpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcref] = ACTIONS(6642),
    [anon_sym_BSLASHCref] = ACTIONS(6642),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnameCref] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHdef] = ACTIONS(6642),
    [anon_sym_BSLASHlet] = ACTIONS(6642),
    [anon_sym_BSLASHleft] = ACTIONS(6642),
    [anon_sym_BSLASHbigl] = ACTIONS(6642),
    [anon_sym_BSLASHBigl] = ACTIONS(6642),
    [anon_sym_BSLASHbiggl] = ACTIONS(6642),
    [anon_sym_BSLASHBiggl] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6642),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6642),
    [anon_sym_BSLASHgls] = ACTIONS(6642),
    [anon_sym_BSLASHGls] = ACTIONS(6642),
    [anon_sym_BSLASHGLS] = ACTIONS(6642),
    [anon_sym_BSLASHglspl] = ACTIONS(6642),
    [anon_sym_BSLASHGlspl] = ACTIONS(6642),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6642),
    [anon_sym_BSLASHglslink] = ACTIONS(6642),
    [anon_sym_BSLASHglstext] = ACTIONS(6642),
    [anon_sym_BSLASHGlstext] = ACTIONS(6642),
    [anon_sym_BSLASHGLStext] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6642),
    [anon_sym_BSLASHglsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsname] = ACTIONS(6642),
    [anon_sym_BSLASHGlsname] = ACTIONS(6642),
    [anon_sym_BSLASHGLSname] = ACTIONS(6642),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6642),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6642),
    [anon_sym_BSLASHacrshort] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6642),
    [anon_sym_BSLASHACRshort] = ACTIONS(6642),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrlong] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6642),
    [anon_sym_BSLASHACRlong] = ACTIONS(6642),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrfull] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6642),
    [anon_sym_BSLASHACRfull] = ACTIONS(6642),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHacs] = ACTIONS(6642),
    [anon_sym_BSLASHAcs] = ACTIONS(6642),
    [anon_sym_BSLASHacsp] = ACTIONS(6642),
    [anon_sym_BSLASHAcsp] = ACTIONS(6642),
    [anon_sym_BSLASHacl] = ACTIONS(6642),
    [anon_sym_BSLASHAcl] = ACTIONS(6642),
    [anon_sym_BSLASHaclp] = ACTIONS(6642),
    [anon_sym_BSLASHAclp] = ACTIONS(6642),
    [anon_sym_BSLASHacf] = ACTIONS(6642),
    [anon_sym_BSLASHAcf] = ACTIONS(6642),
    [anon_sym_BSLASHacfp] = ACTIONS(6642),
    [anon_sym_BSLASHAcfp] = ACTIONS(6642),
    [anon_sym_BSLASHac] = ACTIONS(6642),
    [anon_sym_BSLASHAc] = ACTIONS(6642),
    [anon_sym_BSLASHacp] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6642),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6642),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6642),
    [anon_sym_BSLASHcolor] = ACTIONS(6642),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6642),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6642),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6642),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6642),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6642),
    [anon_sym_BSLASHtext] = ACTIONS(6642),
    [anon_sym_BSLASHintertext] = ACTIONS(6642),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6642),
    [anon_sym_BSLASHurl] = ACTIONS(6642),
    [anon_sym_BSLASHhref] = ACTIONS(6642),
  },
  [1536] = {
    [sym_command_name] = ACTIONS(6546),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6548),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LPAREN] = ACTIONS(6548),
    [anon_sym_RPAREN] = ACTIONS(6548),
    [anon_sym_LBRACE] = ACTIONS(6548),
    [sym_word] = ACTIONS(6546),
    [sym_placeholder] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_DASH] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6546),
    [anon_sym_GT] = ACTIONS(6546),
    [anon_sym_BANG] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6546),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_SQUOTE] = ACTIONS(6546),
    [anon_sym__] = ACTIONS(6548),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6548),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6548),
    [anon_sym_DOLLAR] = ACTIONS(6546),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHbegin] = ACTIONS(6546),
    [anon_sym_BSLASHend] = ACTIONS(6546),
    [anon_sym_BSLASHtitle] = ACTIONS(6546),
    [anon_sym_BSLASHauthor] = ACTIONS(6546),
    [anon_sym_BSLASHusepackage] = ACTIONS(6546),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6546),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6546),
    [anon_sym_BSLASHinclude] = ACTIONS(6546),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6546),
    [anon_sym_BSLASHinput] = ACTIONS(6546),
    [anon_sym_BSLASHsubfile] = ACTIONS(6546),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6546),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6546),
    [anon_sym_BSLASHbibliography] = ACTIONS(6546),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6546),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6546),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6546),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6546),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6546),
    [anon_sym_BSLASHimport] = ACTIONS(6546),
    [anon_sym_BSLASHsubimport] = ACTIONS(6546),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6546),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHcaption] = ACTIONS(6546),
    [anon_sym_BSLASHcite] = ACTIONS(6546),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCite] = ACTIONS(6546),
    [anon_sym_BSLASHnocite] = ACTIONS(6546),
    [anon_sym_BSLASHcitet] = ACTIONS(6546),
    [anon_sym_BSLASHcitep] = ACTIONS(6546),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteA] = ACTIONS(6546),
    [anon_sym_BSLASHciteR] = ACTIONS(6546),
    [anon_sym_BSLASHciteS] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6546),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteyear] = ACTIONS(6546),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitedate] = ACTIONS(6546),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteurl] = ACTIONS(6546),
    [anon_sym_BSLASHfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6546),
    [anon_sym_BSLASHcitealt] = ACTIONS(6546),
    [anon_sym_BSLASHcitealp] = ACTIONS(6546),
    [anon_sym_BSLASHcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHparencite] = ACTIONS(6546),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHParencite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHtextcite] = ACTIONS(6546),
    [anon_sym_BSLASHTextcite] = ACTIONS(6546),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHsupercite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite] = ACTIONS(6546),
    [anon_sym_BSLASHAutocite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHVolcite] = ACTIONS(6546),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHavolcite] = ACTIONS(6546),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHNotecite] = ACTIONS(6546),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHlabel] = ACTIONS(6546),
    [anon_sym_BSLASHref] = ACTIONS(6546),
    [anon_sym_BSLASHeqref] = ACTIONS(6546),
    [anon_sym_BSLASHvref] = ACTIONS(6546),
    [anon_sym_BSLASHVref] = ACTIONS(6546),
    [anon_sym_BSLASHautoref] = ACTIONS(6546),
    [anon_sym_BSLASHpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcref] = ACTIONS(6546),
    [anon_sym_BSLASHCref] = ACTIONS(6546),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnameCref] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHdef] = ACTIONS(6546),
    [anon_sym_BSLASHlet] = ACTIONS(6546),
    [anon_sym_BSLASHleft] = ACTIONS(6546),
    [anon_sym_BSLASHbigl] = ACTIONS(6546),
    [anon_sym_BSLASHBigl] = ACTIONS(6546),
    [anon_sym_BSLASHbiggl] = ACTIONS(6546),
    [anon_sym_BSLASHBiggl] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6546),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6546),
    [anon_sym_BSLASHgls] = ACTIONS(6546),
    [anon_sym_BSLASHGls] = ACTIONS(6546),
    [anon_sym_BSLASHGLS] = ACTIONS(6546),
    [anon_sym_BSLASHglspl] = ACTIONS(6546),
    [anon_sym_BSLASHGlspl] = ACTIONS(6546),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6546),
    [anon_sym_BSLASHglslink] = ACTIONS(6546),
    [anon_sym_BSLASHglstext] = ACTIONS(6546),
    [anon_sym_BSLASHGlstext] = ACTIONS(6546),
    [anon_sym_BSLASHGLStext] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6546),
    [anon_sym_BSLASHglsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsname] = ACTIONS(6546),
    [anon_sym_BSLASHGlsname] = ACTIONS(6546),
    [anon_sym_BSLASHGLSname] = ACTIONS(6546),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6546),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6546),
    [anon_sym_BSLASHacrshort] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6546),
    [anon_sym_BSLASHACRshort] = ACTIONS(6546),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrlong] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6546),
    [anon_sym_BSLASHACRlong] = ACTIONS(6546),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrfull] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6546),
    [anon_sym_BSLASHACRfull] = ACTIONS(6546),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHacs] = ACTIONS(6546),
    [anon_sym_BSLASHAcs] = ACTIONS(6546),
    [anon_sym_BSLASHacsp] = ACTIONS(6546),
    [anon_sym_BSLASHAcsp] = ACTIONS(6546),
    [anon_sym_BSLASHacl] = ACTIONS(6546),
    [anon_sym_BSLASHAcl] = ACTIONS(6546),
    [anon_sym_BSLASHaclp] = ACTIONS(6546),
    [anon_sym_BSLASHAclp] = ACTIONS(6546),
    [anon_sym_BSLASHacf] = ACTIONS(6546),
    [anon_sym_BSLASHAcf] = ACTIONS(6546),
    [anon_sym_BSLASHacfp] = ACTIONS(6546),
    [anon_sym_BSLASHAcfp] = ACTIONS(6546),
    [anon_sym_BSLASHac] = ACTIONS(6546),
    [anon_sym_BSLASHAc] = ACTIONS(6546),
    [anon_sym_BSLASHacp] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6546),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6546),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6546),
    [anon_sym_BSLASHcolor] = ACTIONS(6546),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6546),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6546),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6546),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6546),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6546),
    [anon_sym_BSLASHtext] = ACTIONS(6546),
    [anon_sym_BSLASHintertext] = ACTIONS(6546),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6546),
    [anon_sym_BSLASHurl] = ACTIONS(6546),
    [anon_sym_BSLASHhref] = ACTIONS(6546),
  },
  [1537] = {
    [sym_command_name] = ACTIONS(6542),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6544),
    [anon_sym_RBRACK] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LPAREN] = ACTIONS(6544),
    [anon_sym_RPAREN] = ACTIONS(6544),
    [anon_sym_LBRACE] = ACTIONS(6544),
    [sym_word] = ACTIONS(6542),
    [sym_placeholder] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_DASH] = ACTIONS(6544),
    [anon_sym_STAR] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6542),
    [anon_sym_GT] = ACTIONS(6542),
    [anon_sym_BANG] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6542),
    [anon_sym_COLON] = ACTIONS(6542),
    [anon_sym_SQUOTE] = ACTIONS(6542),
    [anon_sym__] = ACTIONS(6544),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6544),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6544),
    [anon_sym_DOLLAR] = ACTIONS(6542),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHbegin] = ACTIONS(6542),
    [anon_sym_BSLASHend] = ACTIONS(6542),
    [anon_sym_BSLASHtitle] = ACTIONS(6542),
    [anon_sym_BSLASHauthor] = ACTIONS(6542),
    [anon_sym_BSLASHusepackage] = ACTIONS(6542),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6542),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6542),
    [anon_sym_BSLASHinclude] = ACTIONS(6542),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6542),
    [anon_sym_BSLASHinput] = ACTIONS(6542),
    [anon_sym_BSLASHsubfile] = ACTIONS(6542),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6542),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6542),
    [anon_sym_BSLASHbibliography] = ACTIONS(6542),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6542),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6542),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6542),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6542),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6542),
    [anon_sym_BSLASHimport] = ACTIONS(6542),
    [anon_sym_BSLASHsubimport] = ACTIONS(6542),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6542),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHcaption] = ACTIONS(6542),
    [anon_sym_BSLASHcite] = ACTIONS(6542),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCite] = ACTIONS(6542),
    [anon_sym_BSLASHnocite] = ACTIONS(6542),
    [anon_sym_BSLASHcitet] = ACTIONS(6542),
    [anon_sym_BSLASHcitep] = ACTIONS(6542),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteA] = ACTIONS(6542),
    [anon_sym_BSLASHciteR] = ACTIONS(6542),
    [anon_sym_BSLASHciteS] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6542),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteyear] = ACTIONS(6542),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitedate] = ACTIONS(6542),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteurl] = ACTIONS(6542),
    [anon_sym_BSLASHfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6542),
    [anon_sym_BSLASHcitealt] = ACTIONS(6542),
    [anon_sym_BSLASHcitealp] = ACTIONS(6542),
    [anon_sym_BSLASHcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHparencite] = ACTIONS(6542),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHParencite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHtextcite] = ACTIONS(6542),
    [anon_sym_BSLASHTextcite] = ACTIONS(6542),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHsupercite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite] = ACTIONS(6542),
    [anon_sym_BSLASHAutocite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHVolcite] = ACTIONS(6542),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHavolcite] = ACTIONS(6542),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHNotecite] = ACTIONS(6542),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHlabel] = ACTIONS(6542),
    [anon_sym_BSLASHref] = ACTIONS(6542),
    [anon_sym_BSLASHeqref] = ACTIONS(6542),
    [anon_sym_BSLASHvref] = ACTIONS(6542),
    [anon_sym_BSLASHVref] = ACTIONS(6542),
    [anon_sym_BSLASHautoref] = ACTIONS(6542),
    [anon_sym_BSLASHpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcref] = ACTIONS(6542),
    [anon_sym_BSLASHCref] = ACTIONS(6542),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnameCref] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHdef] = ACTIONS(6542),
    [anon_sym_BSLASHlet] = ACTIONS(6542),
    [anon_sym_BSLASHleft] = ACTIONS(6542),
    [anon_sym_BSLASHbigl] = ACTIONS(6542),
    [anon_sym_BSLASHBigl] = ACTIONS(6542),
    [anon_sym_BSLASHbiggl] = ACTIONS(6542),
    [anon_sym_BSLASHBiggl] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6542),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6542),
    [anon_sym_BSLASHgls] = ACTIONS(6542),
    [anon_sym_BSLASHGls] = ACTIONS(6542),
    [anon_sym_BSLASHGLS] = ACTIONS(6542),
    [anon_sym_BSLASHglspl] = ACTIONS(6542),
    [anon_sym_BSLASHGlspl] = ACTIONS(6542),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6542),
    [anon_sym_BSLASHglslink] = ACTIONS(6542),
    [anon_sym_BSLASHglstext] = ACTIONS(6542),
    [anon_sym_BSLASHGlstext] = ACTIONS(6542),
    [anon_sym_BSLASHGLStext] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6542),
    [anon_sym_BSLASHglsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsname] = ACTIONS(6542),
    [anon_sym_BSLASHGlsname] = ACTIONS(6542),
    [anon_sym_BSLASHGLSname] = ACTIONS(6542),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6542),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6542),
    [anon_sym_BSLASHacrshort] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6542),
    [anon_sym_BSLASHACRshort] = ACTIONS(6542),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrlong] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6542),
    [anon_sym_BSLASHACRlong] = ACTIONS(6542),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrfull] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6542),
    [anon_sym_BSLASHACRfull] = ACTIONS(6542),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHacs] = ACTIONS(6542),
    [anon_sym_BSLASHAcs] = ACTIONS(6542),
    [anon_sym_BSLASHacsp] = ACTIONS(6542),
    [anon_sym_BSLASHAcsp] = ACTIONS(6542),
    [anon_sym_BSLASHacl] = ACTIONS(6542),
    [anon_sym_BSLASHAcl] = ACTIONS(6542),
    [anon_sym_BSLASHaclp] = ACTIONS(6542),
    [anon_sym_BSLASHAclp] = ACTIONS(6542),
    [anon_sym_BSLASHacf] = ACTIONS(6542),
    [anon_sym_BSLASHAcf] = ACTIONS(6542),
    [anon_sym_BSLASHacfp] = ACTIONS(6542),
    [anon_sym_BSLASHAcfp] = ACTIONS(6542),
    [anon_sym_BSLASHac] = ACTIONS(6542),
    [anon_sym_BSLASHAc] = ACTIONS(6542),
    [anon_sym_BSLASHacp] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6542),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6542),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6542),
    [anon_sym_BSLASHcolor] = ACTIONS(6542),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6542),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6542),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6542),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6542),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6542),
    [anon_sym_BSLASHtext] = ACTIONS(6542),
    [anon_sym_BSLASHintertext] = ACTIONS(6542),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6542),
    [anon_sym_BSLASHurl] = ACTIONS(6542),
    [anon_sym_BSLASHhref] = ACTIONS(6542),
  },
  [1538] = {
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [anon_sym_RPAREN] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6348),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6348),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6348),
    [anon_sym_DOLLAR] = ACTIONS(6346),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHbegin] = ACTIONS(6346),
    [anon_sym_BSLASHend] = ACTIONS(6346),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHleft] = ACTIONS(6346),
    [anon_sym_BSLASHbigl] = ACTIONS(6346),
    [anon_sym_BSLASHBigl] = ACTIONS(6346),
    [anon_sym_BSLASHbiggl] = ACTIONS(6346),
    [anon_sym_BSLASHBiggl] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHtext] = ACTIONS(6346),
    [anon_sym_BSLASHintertext] = ACTIONS(6346),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [1539] = {
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_RBRACK] = ACTIONS(6636),
    [anon_sym_COMMA] = ACTIONS(6636),
    [anon_sym_EQ] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(6636),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6636),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(6634),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHbegin] = ACTIONS(6634),
    [anon_sym_BSLASHend] = ACTIONS(6634),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHleft] = ACTIONS(6634),
    [anon_sym_BSLASHbigl] = ACTIONS(6634),
    [anon_sym_BSLASHBigl] = ACTIONS(6634),
    [anon_sym_BSLASHbiggl] = ACTIONS(6634),
    [anon_sym_BSLASHBiggl] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHtext] = ACTIONS(6634),
    [anon_sym_BSLASHintertext] = ACTIONS(6634),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [1540] = {
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHend] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [1541] = {
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHend] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [1542] = {
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6336),
    [anon_sym_RBRACK] = ACTIONS(6336),
    [anon_sym_COMMA] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_RPAREN] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6336),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHbegin] = ACTIONS(6334),
    [anon_sym_BSLASHend] = ACTIONS(6334),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHleft] = ACTIONS(6334),
    [anon_sym_BSLASHbigl] = ACTIONS(6334),
    [anon_sym_BSLASHBigl] = ACTIONS(6334),
    [anon_sym_BSLASHbiggl] = ACTIONS(6334),
    [anon_sym_BSLASHBiggl] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHtext] = ACTIONS(6334),
    [anon_sym_BSLASHintertext] = ACTIONS(6334),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [1543] = {
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6332),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_EQ] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6332),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6332),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6330),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHbegin] = ACTIONS(6330),
    [anon_sym_BSLASHend] = ACTIONS(6330),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHleft] = ACTIONS(6330),
    [anon_sym_BSLASHbigl] = ACTIONS(6330),
    [anon_sym_BSLASHBigl] = ACTIONS(6330),
    [anon_sym_BSLASHbiggl] = ACTIONS(6330),
    [anon_sym_BSLASHBiggl] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHtext] = ACTIONS(6330),
    [anon_sym_BSLASHintertext] = ACTIONS(6330),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [1544] = {
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6328),
    [anon_sym_RBRACK] = ACTIONS(6328),
    [anon_sym_COMMA] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6328),
    [anon_sym_RPAREN] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6328),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6328),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6328),
    [anon_sym_DOLLAR] = ACTIONS(6326),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHbegin] = ACTIONS(6326),
    [anon_sym_BSLASHend] = ACTIONS(6326),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHleft] = ACTIONS(6326),
    [anon_sym_BSLASHbigl] = ACTIONS(6326),
    [anon_sym_BSLASHBigl] = ACTIONS(6326),
    [anon_sym_BSLASHbiggl] = ACTIONS(6326),
    [anon_sym_BSLASHBiggl] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHtext] = ACTIONS(6326),
    [anon_sym_BSLASHintertext] = ACTIONS(6326),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [1545] = {
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6324),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6324),
    [anon_sym_DOLLAR] = ACTIONS(6322),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHbegin] = ACTIONS(6322),
    [anon_sym_BSLASHend] = ACTIONS(6322),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHleft] = ACTIONS(6322),
    [anon_sym_BSLASHbigl] = ACTIONS(6322),
    [anon_sym_BSLASHBigl] = ACTIONS(6322),
    [anon_sym_BSLASHbiggl] = ACTIONS(6322),
    [anon_sym_BSLASHBiggl] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHtext] = ACTIONS(6322),
    [anon_sym_BSLASHintertext] = ACTIONS(6322),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [1546] = {
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_RBRACK] = ACTIONS(6320),
    [anon_sym_COMMA] = ACTIONS(6320),
    [anon_sym_EQ] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(6320),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6320),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6320),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHbegin] = ACTIONS(6318),
    [anon_sym_BSLASHend] = ACTIONS(6318),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHleft] = ACTIONS(6318),
    [anon_sym_BSLASHbigl] = ACTIONS(6318),
    [anon_sym_BSLASHBigl] = ACTIONS(6318),
    [anon_sym_BSLASHbiggl] = ACTIONS(6318),
    [anon_sym_BSLASHBiggl] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHtext] = ACTIONS(6318),
    [anon_sym_BSLASHintertext] = ACTIONS(6318),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [1547] = {
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_COMMA] = ACTIONS(6316),
    [anon_sym_EQ] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6316),
    [anon_sym_RPAREN] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6316),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6316),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6316),
    [anon_sym_DOLLAR] = ACTIONS(6314),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHbegin] = ACTIONS(6314),
    [anon_sym_BSLASHend] = ACTIONS(6314),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHleft] = ACTIONS(6314),
    [anon_sym_BSLASHbigl] = ACTIONS(6314),
    [anon_sym_BSLASHBigl] = ACTIONS(6314),
    [anon_sym_BSLASHbiggl] = ACTIONS(6314),
    [anon_sym_BSLASHBiggl] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHtext] = ACTIONS(6314),
    [anon_sym_BSLASHintertext] = ACTIONS(6314),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [1548] = {
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6312),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6312),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6312),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6312),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6312),
    [anon_sym_DOLLAR] = ACTIONS(6310),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHbegin] = ACTIONS(6310),
    [anon_sym_BSLASHend] = ACTIONS(6310),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHleft] = ACTIONS(6310),
    [anon_sym_BSLASHbigl] = ACTIONS(6310),
    [anon_sym_BSLASHBigl] = ACTIONS(6310),
    [anon_sym_BSLASHbiggl] = ACTIONS(6310),
    [anon_sym_BSLASHBiggl] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHtext] = ACTIONS(6310),
    [anon_sym_BSLASHintertext] = ACTIONS(6310),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [1549] = {
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6292),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_COMMA] = ACTIONS(6292),
    [anon_sym_EQ] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_RPAREN] = ACTIONS(6292),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6292),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6292),
    [anon_sym_DOLLAR] = ACTIONS(6290),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHbegin] = ACTIONS(6290),
    [anon_sym_BSLASHend] = ACTIONS(6290),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHleft] = ACTIONS(6290),
    [anon_sym_BSLASHbigl] = ACTIONS(6290),
    [anon_sym_BSLASHBigl] = ACTIONS(6290),
    [anon_sym_BSLASHbiggl] = ACTIONS(6290),
    [anon_sym_BSLASHBiggl] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHtext] = ACTIONS(6290),
    [anon_sym_BSLASHintertext] = ACTIONS(6290),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [1550] = {
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6288),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6288),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6288),
    [anon_sym_DOLLAR] = ACTIONS(6286),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHbegin] = ACTIONS(6286),
    [anon_sym_BSLASHend] = ACTIONS(6286),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHleft] = ACTIONS(6286),
    [anon_sym_BSLASHbigl] = ACTIONS(6286),
    [anon_sym_BSLASHBigl] = ACTIONS(6286),
    [anon_sym_BSLASHbiggl] = ACTIONS(6286),
    [anon_sym_BSLASHBiggl] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHtext] = ACTIONS(6286),
    [anon_sym_BSLASHintertext] = ACTIONS(6286),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [1551] = {
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_LBRACK] = ACTIONS(6272),
    [anon_sym_RBRACK] = ACTIONS(6272),
    [anon_sym_COMMA] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_LPAREN] = ACTIONS(6272),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6272),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6272),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6272),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHbegin] = ACTIONS(6270),
    [anon_sym_BSLASHend] = ACTIONS(6270),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHleft] = ACTIONS(6270),
    [anon_sym_BSLASHbigl] = ACTIONS(6270),
    [anon_sym_BSLASHBigl] = ACTIONS(6270),
    [anon_sym_BSLASHbiggl] = ACTIONS(6270),
    [anon_sym_BSLASHBiggl] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHtext] = ACTIONS(6270),
    [anon_sym_BSLASHintertext] = ACTIONS(6270),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [1552] = {
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_COMMA] = ACTIONS(6268),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_LPAREN] = ACTIONS(6268),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6268),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(6266),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHbegin] = ACTIONS(6266),
    [anon_sym_BSLASHend] = ACTIONS(6266),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHleft] = ACTIONS(6266),
    [anon_sym_BSLASHbigl] = ACTIONS(6266),
    [anon_sym_BSLASHBigl] = ACTIONS(6266),
    [anon_sym_BSLASHbiggl] = ACTIONS(6266),
    [anon_sym_BSLASHBiggl] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHtext] = ACTIONS(6266),
    [anon_sym_BSLASHintertext] = ACTIONS(6266),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [1553] = {
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6252),
    [anon_sym_LPAREN] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHbegin] = ACTIONS(6250),
    [anon_sym_BSLASHend] = ACTIONS(6250),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHleft] = ACTIONS(6250),
    [anon_sym_BSLASHbigl] = ACTIONS(6250),
    [anon_sym_BSLASHBigl] = ACTIONS(6250),
    [anon_sym_BSLASHbiggl] = ACTIONS(6250),
    [anon_sym_BSLASHBiggl] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHtext] = ACTIONS(6250),
    [anon_sym_BSLASHintertext] = ACTIONS(6250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
  [1554] = {
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_COMMA] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_LPAREN] = ACTIONS(6248),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6248),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6248),
    [anon_sym_DOLLAR] = ACTIONS(6246),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHbegin] = ACTIONS(6246),
    [anon_sym_BSLASHend] = ACTIONS(6246),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHleft] = ACTIONS(6246),
    [anon_sym_BSLASHbigl] = ACTIONS(6246),
    [anon_sym_BSLASHBigl] = ACTIONS(6246),
    [anon_sym_BSLASHbiggl] = ACTIONS(6246),
    [anon_sym_BSLASHBiggl] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHtext] = ACTIONS(6246),
    [anon_sym_BSLASHintertext] = ACTIONS(6246),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [1555] = {
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6244),
    [anon_sym_RBRACK] = ACTIONS(6244),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_LPAREN] = ACTIONS(6244),
    [anon_sym_RPAREN] = ACTIONS(6244),
    [anon_sym_LBRACE] = ACTIONS(6244),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6244),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6244),
    [anon_sym_DOLLAR] = ACTIONS(6242),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHbegin] = ACTIONS(6242),
    [anon_sym_BSLASHend] = ACTIONS(6242),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHleft] = ACTIONS(6242),
    [anon_sym_BSLASHbigl] = ACTIONS(6242),
    [anon_sym_BSLASHBigl] = ACTIONS(6242),
    [anon_sym_BSLASHbiggl] = ACTIONS(6242),
    [anon_sym_BSLASHBiggl] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHtext] = ACTIONS(6242),
    [anon_sym_BSLASHintertext] = ACTIONS(6242),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [1556] = {
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6240),
    [anon_sym_RBRACK] = ACTIONS(6240),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_LPAREN] = ACTIONS(6240),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(6240),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6240),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6240),
    [anon_sym_DOLLAR] = ACTIONS(6238),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHbegin] = ACTIONS(6238),
    [anon_sym_BSLASHend] = ACTIONS(6238),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHleft] = ACTIONS(6238),
    [anon_sym_BSLASHbigl] = ACTIONS(6238),
    [anon_sym_BSLASHBigl] = ACTIONS(6238),
    [anon_sym_BSLASHbiggl] = ACTIONS(6238),
    [anon_sym_BSLASHBiggl] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHtext] = ACTIONS(6238),
    [anon_sym_BSLASHintertext] = ACTIONS(6238),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [1557] = {
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_LPAREN] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6236),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(6234),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHbegin] = ACTIONS(6234),
    [anon_sym_BSLASHend] = ACTIONS(6234),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHleft] = ACTIONS(6234),
    [anon_sym_BSLASHbigl] = ACTIONS(6234),
    [anon_sym_BSLASHBigl] = ACTIONS(6234),
    [anon_sym_BSLASHbiggl] = ACTIONS(6234),
    [anon_sym_BSLASHBiggl] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHtext] = ACTIONS(6234),
    [anon_sym_BSLASHintertext] = ACTIONS(6234),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [1558] = {
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6232),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6232),
    [anon_sym_LPAREN] = ACTIONS(6232),
    [anon_sym_RPAREN] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6232),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6232),
    [anon_sym_DOLLAR] = ACTIONS(6230),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHbegin] = ACTIONS(6230),
    [anon_sym_BSLASHend] = ACTIONS(6230),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHleft] = ACTIONS(6230),
    [anon_sym_BSLASHbigl] = ACTIONS(6230),
    [anon_sym_BSLASHBigl] = ACTIONS(6230),
    [anon_sym_BSLASHbiggl] = ACTIONS(6230),
    [anon_sym_BSLASHBiggl] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHtext] = ACTIONS(6230),
    [anon_sym_BSLASHintertext] = ACTIONS(6230),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [1559] = {
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6228),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_LPAREN] = ACTIONS(6228),
    [anon_sym_RPAREN] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(6228),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6228),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(6226),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHbegin] = ACTIONS(6226),
    [anon_sym_BSLASHend] = ACTIONS(6226),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHleft] = ACTIONS(6226),
    [anon_sym_BSLASHbigl] = ACTIONS(6226),
    [anon_sym_BSLASHBigl] = ACTIONS(6226),
    [anon_sym_BSLASHbiggl] = ACTIONS(6226),
    [anon_sym_BSLASHBiggl] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHtext] = ACTIONS(6226),
    [anon_sym_BSLASHintertext] = ACTIONS(6226),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [1560] = {
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6588),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6588),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHbegin] = ACTIONS(6586),
    [anon_sym_BSLASHend] = ACTIONS(6586),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHleft] = ACTIONS(6586),
    [anon_sym_BSLASHbigl] = ACTIONS(6586),
    [anon_sym_BSLASHBigl] = ACTIONS(6586),
    [anon_sym_BSLASHbiggl] = ACTIONS(6586),
    [anon_sym_BSLASHBiggl] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHtext] = ACTIONS(6586),
    [anon_sym_BSLASHintertext] = ACTIONS(6586),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [1561] = {
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6220),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6220),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6220),
    [anon_sym_DOLLAR] = ACTIONS(6218),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHbegin] = ACTIONS(6218),
    [anon_sym_BSLASHend] = ACTIONS(6218),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHleft] = ACTIONS(6218),
    [anon_sym_BSLASHbigl] = ACTIONS(6218),
    [anon_sym_BSLASHBigl] = ACTIONS(6218),
    [anon_sym_BSLASHbiggl] = ACTIONS(6218),
    [anon_sym_BSLASHBiggl] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHtext] = ACTIONS(6218),
    [anon_sym_BSLASHintertext] = ACTIONS(6218),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [1562] = {
    [sym_command_name] = ACTIONS(6646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6646),
    [anon_sym_LBRACK] = ACTIONS(6648),
    [anon_sym_RBRACK] = ACTIONS(6648),
    [anon_sym_COMMA] = ACTIONS(6648),
    [anon_sym_EQ] = ACTIONS(6648),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [anon_sym_RPAREN] = ACTIONS(6648),
    [anon_sym_LBRACE] = ACTIONS(6648),
    [sym_word] = ACTIONS(6646),
    [sym_placeholder] = ACTIONS(6648),
    [anon_sym_PLUS] = ACTIONS(6648),
    [anon_sym_DASH] = ACTIONS(6648),
    [anon_sym_STAR] = ACTIONS(6648),
    [anon_sym_SLASH] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6646),
    [anon_sym_GT] = ACTIONS(6646),
    [anon_sym_BANG] = ACTIONS(6646),
    [anon_sym_PIPE] = ACTIONS(6646),
    [anon_sym_COLON] = ACTIONS(6646),
    [anon_sym_SQUOTE] = ACTIONS(6646),
    [anon_sym__] = ACTIONS(6648),
    [anon_sym_CARET] = ACTIONS(6648),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6648),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6648),
    [anon_sym_DOLLAR] = ACTIONS(6646),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHbegin] = ACTIONS(6646),
    [anon_sym_BSLASHend] = ACTIONS(6646),
    [anon_sym_BSLASHtitle] = ACTIONS(6646),
    [anon_sym_BSLASHauthor] = ACTIONS(6646),
    [anon_sym_BSLASHusepackage] = ACTIONS(6646),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6646),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6646),
    [anon_sym_BSLASHinclude] = ACTIONS(6646),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6646),
    [anon_sym_BSLASHinput] = ACTIONS(6646),
    [anon_sym_BSLASHsubfile] = ACTIONS(6646),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6646),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6646),
    [anon_sym_BSLASHbibliography] = ACTIONS(6646),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6646),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6646),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6646),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6646),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6646),
    [anon_sym_BSLASHimport] = ACTIONS(6646),
    [anon_sym_BSLASHsubimport] = ACTIONS(6646),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6646),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHcaption] = ACTIONS(6646),
    [anon_sym_BSLASHcite] = ACTIONS(6646),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCite] = ACTIONS(6646),
    [anon_sym_BSLASHnocite] = ACTIONS(6646),
    [anon_sym_BSLASHcitet] = ACTIONS(6646),
    [anon_sym_BSLASHcitep] = ACTIONS(6646),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteA] = ACTIONS(6646),
    [anon_sym_BSLASHciteR] = ACTIONS(6646),
    [anon_sym_BSLASHciteS] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6646),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteyear] = ACTIONS(6646),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitedate] = ACTIONS(6646),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteurl] = ACTIONS(6646),
    [anon_sym_BSLASHfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6646),
    [anon_sym_BSLASHcitealt] = ACTIONS(6646),
    [anon_sym_BSLASHcitealp] = ACTIONS(6646),
    [anon_sym_BSLASHcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHparencite] = ACTIONS(6646),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHParencite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHtextcite] = ACTIONS(6646),
    [anon_sym_BSLASHTextcite] = ACTIONS(6646),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHsupercite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite] = ACTIONS(6646),
    [anon_sym_BSLASHAutocite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHVolcite] = ACTIONS(6646),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHavolcite] = ACTIONS(6646),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHNotecite] = ACTIONS(6646),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHlabel] = ACTIONS(6646),
    [anon_sym_BSLASHref] = ACTIONS(6646),
    [anon_sym_BSLASHeqref] = ACTIONS(6646),
    [anon_sym_BSLASHvref] = ACTIONS(6646),
    [anon_sym_BSLASHVref] = ACTIONS(6646),
    [anon_sym_BSLASHautoref] = ACTIONS(6646),
    [anon_sym_BSLASHpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcref] = ACTIONS(6646),
    [anon_sym_BSLASHCref] = ACTIONS(6646),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnameCref] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHdef] = ACTIONS(6646),
    [anon_sym_BSLASHlet] = ACTIONS(6646),
    [anon_sym_BSLASHleft] = ACTIONS(6646),
    [anon_sym_BSLASHbigl] = ACTIONS(6646),
    [anon_sym_BSLASHBigl] = ACTIONS(6646),
    [anon_sym_BSLASHbiggl] = ACTIONS(6646),
    [anon_sym_BSLASHBiggl] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6646),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6646),
    [anon_sym_BSLASHgls] = ACTIONS(6646),
    [anon_sym_BSLASHGls] = ACTIONS(6646),
    [anon_sym_BSLASHGLS] = ACTIONS(6646),
    [anon_sym_BSLASHglspl] = ACTIONS(6646),
    [anon_sym_BSLASHGlspl] = ACTIONS(6646),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6646),
    [anon_sym_BSLASHglslink] = ACTIONS(6646),
    [anon_sym_BSLASHglstext] = ACTIONS(6646),
    [anon_sym_BSLASHGlstext] = ACTIONS(6646),
    [anon_sym_BSLASHGLStext] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6646),
    [anon_sym_BSLASHglsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsname] = ACTIONS(6646),
    [anon_sym_BSLASHGlsname] = ACTIONS(6646),
    [anon_sym_BSLASHGLSname] = ACTIONS(6646),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6646),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6646),
    [anon_sym_BSLASHacrshort] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6646),
    [anon_sym_BSLASHACRshort] = ACTIONS(6646),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrlong] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6646),
    [anon_sym_BSLASHACRlong] = ACTIONS(6646),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrfull] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6646),
    [anon_sym_BSLASHACRfull] = ACTIONS(6646),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHacs] = ACTIONS(6646),
    [anon_sym_BSLASHAcs] = ACTIONS(6646),
    [anon_sym_BSLASHacsp] = ACTIONS(6646),
    [anon_sym_BSLASHAcsp] = ACTIONS(6646),
    [anon_sym_BSLASHacl] = ACTIONS(6646),
    [anon_sym_BSLASHAcl] = ACTIONS(6646),
    [anon_sym_BSLASHaclp] = ACTIONS(6646),
    [anon_sym_BSLASHAclp] = ACTIONS(6646),
    [anon_sym_BSLASHacf] = ACTIONS(6646),
    [anon_sym_BSLASHAcf] = ACTIONS(6646),
    [anon_sym_BSLASHacfp] = ACTIONS(6646),
    [anon_sym_BSLASHAcfp] = ACTIONS(6646),
    [anon_sym_BSLASHac] = ACTIONS(6646),
    [anon_sym_BSLASHAc] = ACTIONS(6646),
    [anon_sym_BSLASHacp] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6646),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6646),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6646),
    [anon_sym_BSLASHcolor] = ACTIONS(6646),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6646),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6646),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6646),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6646),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6646),
    [anon_sym_BSLASHtext] = ACTIONS(6646),
    [anon_sym_BSLASHintertext] = ACTIONS(6646),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6646),
    [anon_sym_BSLASHurl] = ACTIONS(6646),
    [anon_sym_BSLASHhref] = ACTIONS(6646),
  },
  [1563] = {
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6504),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6504),
    [anon_sym_DOLLAR] = ACTIONS(6502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHbegin] = ACTIONS(6502),
    [anon_sym_BSLASHend] = ACTIONS(6502),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHleft] = ACTIONS(6502),
    [anon_sym_BSLASHbigl] = ACTIONS(6502),
    [anon_sym_BSLASHBigl] = ACTIONS(6502),
    [anon_sym_BSLASHbiggl] = ACTIONS(6502),
    [anon_sym_BSLASHBiggl] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHtext] = ACTIONS(6502),
    [anon_sym_BSLASHintertext] = ACTIONS(6502),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [1564] = {
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6284),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6284),
    [anon_sym_DOLLAR] = ACTIONS(6282),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHbegin] = ACTIONS(6282),
    [anon_sym_BSLASHend] = ACTIONS(6282),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHleft] = ACTIONS(6282),
    [anon_sym_BSLASHbigl] = ACTIONS(6282),
    [anon_sym_BSLASHBigl] = ACTIONS(6282),
    [anon_sym_BSLASHbiggl] = ACTIONS(6282),
    [anon_sym_BSLASHBiggl] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHtext] = ACTIONS(6282),
    [anon_sym_BSLASHintertext] = ACTIONS(6282),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [1565] = {
    [sym_command_name] = ACTIONS(6622),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6622),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_RBRACK] = ACTIONS(6624),
    [anon_sym_COMMA] = ACTIONS(6624),
    [anon_sym_EQ] = ACTIONS(6624),
    [anon_sym_LPAREN] = ACTIONS(6624),
    [anon_sym_RPAREN] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(6624),
    [sym_word] = ACTIONS(6622),
    [sym_placeholder] = ACTIONS(6624),
    [anon_sym_PLUS] = ACTIONS(6624),
    [anon_sym_DASH] = ACTIONS(6624),
    [anon_sym_STAR] = ACTIONS(6624),
    [anon_sym_SLASH] = ACTIONS(6624),
    [anon_sym_LT] = ACTIONS(6622),
    [anon_sym_GT] = ACTIONS(6622),
    [anon_sym_BANG] = ACTIONS(6622),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_COLON] = ACTIONS(6622),
    [anon_sym_SQUOTE] = ACTIONS(6622),
    [anon_sym__] = ACTIONS(6624),
    [anon_sym_CARET] = ACTIONS(6624),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6624),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6624),
    [anon_sym_DOLLAR] = ACTIONS(6622),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHbegin] = ACTIONS(6622),
    [anon_sym_BSLASHend] = ACTIONS(6622),
    [anon_sym_BSLASHtitle] = ACTIONS(6622),
    [anon_sym_BSLASHauthor] = ACTIONS(6622),
    [anon_sym_BSLASHusepackage] = ACTIONS(6622),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6622),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6622),
    [anon_sym_BSLASHinclude] = ACTIONS(6622),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6622),
    [anon_sym_BSLASHinput] = ACTIONS(6622),
    [anon_sym_BSLASHsubfile] = ACTIONS(6622),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6622),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6622),
    [anon_sym_BSLASHbibliography] = ACTIONS(6622),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6622),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6622),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6622),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6622),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6622),
    [anon_sym_BSLASHimport] = ACTIONS(6622),
    [anon_sym_BSLASHsubimport] = ACTIONS(6622),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6622),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHcaption] = ACTIONS(6622),
    [anon_sym_BSLASHcite] = ACTIONS(6622),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCite] = ACTIONS(6622),
    [anon_sym_BSLASHnocite] = ACTIONS(6622),
    [anon_sym_BSLASHcitet] = ACTIONS(6622),
    [anon_sym_BSLASHcitep] = ACTIONS(6622),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteA] = ACTIONS(6622),
    [anon_sym_BSLASHciteR] = ACTIONS(6622),
    [anon_sym_BSLASHciteS] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6622),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteyear] = ACTIONS(6622),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitedate] = ACTIONS(6622),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteurl] = ACTIONS(6622),
    [anon_sym_BSLASHfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6622),
    [anon_sym_BSLASHcitealt] = ACTIONS(6622),
    [anon_sym_BSLASHcitealp] = ACTIONS(6622),
    [anon_sym_BSLASHcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHparencite] = ACTIONS(6622),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHParencite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHtextcite] = ACTIONS(6622),
    [anon_sym_BSLASHTextcite] = ACTIONS(6622),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHsupercite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite] = ACTIONS(6622),
    [anon_sym_BSLASHAutocite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHVolcite] = ACTIONS(6622),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHavolcite] = ACTIONS(6622),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHNotecite] = ACTIONS(6622),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHlabel] = ACTIONS(6622),
    [anon_sym_BSLASHref] = ACTIONS(6622),
    [anon_sym_BSLASHeqref] = ACTIONS(6622),
    [anon_sym_BSLASHvref] = ACTIONS(6622),
    [anon_sym_BSLASHVref] = ACTIONS(6622),
    [anon_sym_BSLASHautoref] = ACTIONS(6622),
    [anon_sym_BSLASHpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcref] = ACTIONS(6622),
    [anon_sym_BSLASHCref] = ACTIONS(6622),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnameCref] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHdef] = ACTIONS(6622),
    [anon_sym_BSLASHlet] = ACTIONS(6622),
    [anon_sym_BSLASHleft] = ACTIONS(6622),
    [anon_sym_BSLASHbigl] = ACTIONS(6622),
    [anon_sym_BSLASHBigl] = ACTIONS(6622),
    [anon_sym_BSLASHbiggl] = ACTIONS(6622),
    [anon_sym_BSLASHBiggl] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6622),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6622),
    [anon_sym_BSLASHgls] = ACTIONS(6622),
    [anon_sym_BSLASHGls] = ACTIONS(6622),
    [anon_sym_BSLASHGLS] = ACTIONS(6622),
    [anon_sym_BSLASHglspl] = ACTIONS(6622),
    [anon_sym_BSLASHGlspl] = ACTIONS(6622),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6622),
    [anon_sym_BSLASHglslink] = ACTIONS(6622),
    [anon_sym_BSLASHglstext] = ACTIONS(6622),
    [anon_sym_BSLASHGlstext] = ACTIONS(6622),
    [anon_sym_BSLASHGLStext] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6622),
    [anon_sym_BSLASHglsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsname] = ACTIONS(6622),
    [anon_sym_BSLASHGlsname] = ACTIONS(6622),
    [anon_sym_BSLASHGLSname] = ACTIONS(6622),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6622),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6622),
    [anon_sym_BSLASHacrshort] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6622),
    [anon_sym_BSLASHACRshort] = ACTIONS(6622),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrlong] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6622),
    [anon_sym_BSLASHACRlong] = ACTIONS(6622),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrfull] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6622),
    [anon_sym_BSLASHACRfull] = ACTIONS(6622),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHacs] = ACTIONS(6622),
    [anon_sym_BSLASHAcs] = ACTIONS(6622),
    [anon_sym_BSLASHacsp] = ACTIONS(6622),
    [anon_sym_BSLASHAcsp] = ACTIONS(6622),
    [anon_sym_BSLASHacl] = ACTIONS(6622),
    [anon_sym_BSLASHAcl] = ACTIONS(6622),
    [anon_sym_BSLASHaclp] = ACTIONS(6622),
    [anon_sym_BSLASHAclp] = ACTIONS(6622),
    [anon_sym_BSLASHacf] = ACTIONS(6622),
    [anon_sym_BSLASHAcf] = ACTIONS(6622),
    [anon_sym_BSLASHacfp] = ACTIONS(6622),
    [anon_sym_BSLASHAcfp] = ACTIONS(6622),
    [anon_sym_BSLASHac] = ACTIONS(6622),
    [anon_sym_BSLASHAc] = ACTIONS(6622),
    [anon_sym_BSLASHacp] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6622),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6622),
    [anon_sym_BSLASHcolor] = ACTIONS(6622),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6622),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6622),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6622),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6622),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6622),
    [anon_sym_BSLASHtext] = ACTIONS(6622),
    [anon_sym_BSLASHintertext] = ACTIONS(6622),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6622),
    [anon_sym_BSLASHurl] = ACTIONS(6622),
    [anon_sym_BSLASHhref] = ACTIONS(6622),
  },
  [1566] = {
    [sym_command_name] = ACTIONS(6618),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(6620),
    [anon_sym_RBRACK] = ACTIONS(6620),
    [anon_sym_COMMA] = ACTIONS(6620),
    [anon_sym_EQ] = ACTIONS(6620),
    [anon_sym_LPAREN] = ACTIONS(6620),
    [anon_sym_RPAREN] = ACTIONS(6620),
    [anon_sym_LBRACE] = ACTIONS(6620),
    [sym_word] = ACTIONS(6618),
    [sym_placeholder] = ACTIONS(6620),
    [anon_sym_PLUS] = ACTIONS(6620),
    [anon_sym_DASH] = ACTIONS(6620),
    [anon_sym_STAR] = ACTIONS(6620),
    [anon_sym_SLASH] = ACTIONS(6620),
    [anon_sym_LT] = ACTIONS(6618),
    [anon_sym_GT] = ACTIONS(6618),
    [anon_sym_BANG] = ACTIONS(6618),
    [anon_sym_PIPE] = ACTIONS(6618),
    [anon_sym_COLON] = ACTIONS(6618),
    [anon_sym_SQUOTE] = ACTIONS(6618),
    [anon_sym__] = ACTIONS(6620),
    [anon_sym_CARET] = ACTIONS(6620),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6620),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6620),
    [anon_sym_DOLLAR] = ACTIONS(6618),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHbegin] = ACTIONS(6618),
    [anon_sym_BSLASHend] = ACTIONS(6618),
    [anon_sym_BSLASHtitle] = ACTIONS(6618),
    [anon_sym_BSLASHauthor] = ACTIONS(6618),
    [anon_sym_BSLASHusepackage] = ACTIONS(6618),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6618),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6618),
    [anon_sym_BSLASHinclude] = ACTIONS(6618),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6618),
    [anon_sym_BSLASHinput] = ACTIONS(6618),
    [anon_sym_BSLASHsubfile] = ACTIONS(6618),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6618),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6618),
    [anon_sym_BSLASHbibliography] = ACTIONS(6618),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6618),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6618),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6618),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6618),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6618),
    [anon_sym_BSLASHimport] = ACTIONS(6618),
    [anon_sym_BSLASHsubimport] = ACTIONS(6618),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6618),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHcaption] = ACTIONS(6618),
    [anon_sym_BSLASHcite] = ACTIONS(6618),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCite] = ACTIONS(6618),
    [anon_sym_BSLASHnocite] = ACTIONS(6618),
    [anon_sym_BSLASHcitet] = ACTIONS(6618),
    [anon_sym_BSLASHcitep] = ACTIONS(6618),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteA] = ACTIONS(6618),
    [anon_sym_BSLASHciteR] = ACTIONS(6618),
    [anon_sym_BSLASHciteS] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6618),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteyear] = ACTIONS(6618),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitedate] = ACTIONS(6618),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteurl] = ACTIONS(6618),
    [anon_sym_BSLASHfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6618),
    [anon_sym_BSLASHcitealt] = ACTIONS(6618),
    [anon_sym_BSLASHcitealp] = ACTIONS(6618),
    [anon_sym_BSLASHcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHparencite] = ACTIONS(6618),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHParencite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHtextcite] = ACTIONS(6618),
    [anon_sym_BSLASHTextcite] = ACTIONS(6618),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHsupercite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite] = ACTIONS(6618),
    [anon_sym_BSLASHAutocite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHVolcite] = ACTIONS(6618),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHavolcite] = ACTIONS(6618),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHNotecite] = ACTIONS(6618),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHlabel] = ACTIONS(6618),
    [anon_sym_BSLASHref] = ACTIONS(6618),
    [anon_sym_BSLASHeqref] = ACTIONS(6618),
    [anon_sym_BSLASHvref] = ACTIONS(6618),
    [anon_sym_BSLASHVref] = ACTIONS(6618),
    [anon_sym_BSLASHautoref] = ACTIONS(6618),
    [anon_sym_BSLASHpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcref] = ACTIONS(6618),
    [anon_sym_BSLASHCref] = ACTIONS(6618),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnameCref] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHdef] = ACTIONS(6618),
    [anon_sym_BSLASHlet] = ACTIONS(6618),
    [anon_sym_BSLASHleft] = ACTIONS(6618),
    [anon_sym_BSLASHbigl] = ACTIONS(6618),
    [anon_sym_BSLASHBigl] = ACTIONS(6618),
    [anon_sym_BSLASHbiggl] = ACTIONS(6618),
    [anon_sym_BSLASHBiggl] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6618),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6618),
    [anon_sym_BSLASHgls] = ACTIONS(6618),
    [anon_sym_BSLASHGls] = ACTIONS(6618),
    [anon_sym_BSLASHGLS] = ACTIONS(6618),
    [anon_sym_BSLASHglspl] = ACTIONS(6618),
    [anon_sym_BSLASHGlspl] = ACTIONS(6618),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6618),
    [anon_sym_BSLASHglslink] = ACTIONS(6618),
    [anon_sym_BSLASHglstext] = ACTIONS(6618),
    [anon_sym_BSLASHGlstext] = ACTIONS(6618),
    [anon_sym_BSLASHGLStext] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6618),
    [anon_sym_BSLASHglsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsname] = ACTIONS(6618),
    [anon_sym_BSLASHGlsname] = ACTIONS(6618),
    [anon_sym_BSLASHGLSname] = ACTIONS(6618),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6618),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6618),
    [anon_sym_BSLASHacrshort] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6618),
    [anon_sym_BSLASHACRshort] = ACTIONS(6618),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrlong] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6618),
    [anon_sym_BSLASHACRlong] = ACTIONS(6618),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrfull] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6618),
    [anon_sym_BSLASHACRfull] = ACTIONS(6618),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHacs] = ACTIONS(6618),
    [anon_sym_BSLASHAcs] = ACTIONS(6618),
    [anon_sym_BSLASHacsp] = ACTIONS(6618),
    [anon_sym_BSLASHAcsp] = ACTIONS(6618),
    [anon_sym_BSLASHacl] = ACTIONS(6618),
    [anon_sym_BSLASHAcl] = ACTIONS(6618),
    [anon_sym_BSLASHaclp] = ACTIONS(6618),
    [anon_sym_BSLASHAclp] = ACTIONS(6618),
    [anon_sym_BSLASHacf] = ACTIONS(6618),
    [anon_sym_BSLASHAcf] = ACTIONS(6618),
    [anon_sym_BSLASHacfp] = ACTIONS(6618),
    [anon_sym_BSLASHAcfp] = ACTIONS(6618),
    [anon_sym_BSLASHac] = ACTIONS(6618),
    [anon_sym_BSLASHAc] = ACTIONS(6618),
    [anon_sym_BSLASHacp] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6618),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6618),
    [anon_sym_BSLASHcolor] = ACTIONS(6618),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6618),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6618),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6618),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6618),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6618),
    [anon_sym_BSLASHtext] = ACTIONS(6618),
    [anon_sym_BSLASHintertext] = ACTIONS(6618),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6618),
    [anon_sym_BSLASHurl] = ACTIONS(6618),
    [anon_sym_BSLASHhref] = ACTIONS(6618),
  },
  [1567] = {
    [sym_command_name] = ACTIONS(6614),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6614),
    [anon_sym_LBRACK] = ACTIONS(6616),
    [anon_sym_RBRACK] = ACTIONS(6616),
    [anon_sym_COMMA] = ACTIONS(6616),
    [anon_sym_EQ] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6616),
    [anon_sym_RPAREN] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(6616),
    [sym_word] = ACTIONS(6614),
    [sym_placeholder] = ACTIONS(6616),
    [anon_sym_PLUS] = ACTIONS(6616),
    [anon_sym_DASH] = ACTIONS(6616),
    [anon_sym_STAR] = ACTIONS(6616),
    [anon_sym_SLASH] = ACTIONS(6616),
    [anon_sym_LT] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6614),
    [anon_sym_BANG] = ACTIONS(6614),
    [anon_sym_PIPE] = ACTIONS(6614),
    [anon_sym_COLON] = ACTIONS(6614),
    [anon_sym_SQUOTE] = ACTIONS(6614),
    [anon_sym__] = ACTIONS(6616),
    [anon_sym_CARET] = ACTIONS(6616),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6616),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6616),
    [anon_sym_DOLLAR] = ACTIONS(6614),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHbegin] = ACTIONS(6614),
    [anon_sym_BSLASHend] = ACTIONS(6614),
    [anon_sym_BSLASHtitle] = ACTIONS(6614),
    [anon_sym_BSLASHauthor] = ACTIONS(6614),
    [anon_sym_BSLASHusepackage] = ACTIONS(6614),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6614),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6614),
    [anon_sym_BSLASHinclude] = ACTIONS(6614),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6614),
    [anon_sym_BSLASHinput] = ACTIONS(6614),
    [anon_sym_BSLASHsubfile] = ACTIONS(6614),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6614),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6614),
    [anon_sym_BSLASHbibliography] = ACTIONS(6614),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6614),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6614),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6614),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6614),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6614),
    [anon_sym_BSLASHimport] = ACTIONS(6614),
    [anon_sym_BSLASHsubimport] = ACTIONS(6614),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6614),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHcaption] = ACTIONS(6614),
    [anon_sym_BSLASHcite] = ACTIONS(6614),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCite] = ACTIONS(6614),
    [anon_sym_BSLASHnocite] = ACTIONS(6614),
    [anon_sym_BSLASHcitet] = ACTIONS(6614),
    [anon_sym_BSLASHcitep] = ACTIONS(6614),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteA] = ACTIONS(6614),
    [anon_sym_BSLASHciteR] = ACTIONS(6614),
    [anon_sym_BSLASHciteS] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6614),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteyear] = ACTIONS(6614),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitedate] = ACTIONS(6614),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteurl] = ACTIONS(6614),
    [anon_sym_BSLASHfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6614),
    [anon_sym_BSLASHcitealt] = ACTIONS(6614),
    [anon_sym_BSLASHcitealp] = ACTIONS(6614),
    [anon_sym_BSLASHcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHparencite] = ACTIONS(6614),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHParencite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHtextcite] = ACTIONS(6614),
    [anon_sym_BSLASHTextcite] = ACTIONS(6614),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHsupercite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite] = ACTIONS(6614),
    [anon_sym_BSLASHAutocite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHVolcite] = ACTIONS(6614),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHavolcite] = ACTIONS(6614),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHNotecite] = ACTIONS(6614),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHlabel] = ACTIONS(6614),
    [anon_sym_BSLASHref] = ACTIONS(6614),
    [anon_sym_BSLASHeqref] = ACTIONS(6614),
    [anon_sym_BSLASHvref] = ACTIONS(6614),
    [anon_sym_BSLASHVref] = ACTIONS(6614),
    [anon_sym_BSLASHautoref] = ACTIONS(6614),
    [anon_sym_BSLASHpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcref] = ACTIONS(6614),
    [anon_sym_BSLASHCref] = ACTIONS(6614),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnameCref] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHdef] = ACTIONS(6614),
    [anon_sym_BSLASHlet] = ACTIONS(6614),
    [anon_sym_BSLASHleft] = ACTIONS(6614),
    [anon_sym_BSLASHbigl] = ACTIONS(6614),
    [anon_sym_BSLASHBigl] = ACTIONS(6614),
    [anon_sym_BSLASHbiggl] = ACTIONS(6614),
    [anon_sym_BSLASHBiggl] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6614),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6614),
    [anon_sym_BSLASHgls] = ACTIONS(6614),
    [anon_sym_BSLASHGls] = ACTIONS(6614),
    [anon_sym_BSLASHGLS] = ACTIONS(6614),
    [anon_sym_BSLASHglspl] = ACTIONS(6614),
    [anon_sym_BSLASHGlspl] = ACTIONS(6614),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6614),
    [anon_sym_BSLASHglslink] = ACTIONS(6614),
    [anon_sym_BSLASHglstext] = ACTIONS(6614),
    [anon_sym_BSLASHGlstext] = ACTIONS(6614),
    [anon_sym_BSLASHGLStext] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6614),
    [anon_sym_BSLASHglsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsname] = ACTIONS(6614),
    [anon_sym_BSLASHGlsname] = ACTIONS(6614),
    [anon_sym_BSLASHGLSname] = ACTIONS(6614),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6614),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6614),
    [anon_sym_BSLASHacrshort] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6614),
    [anon_sym_BSLASHACRshort] = ACTIONS(6614),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrlong] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6614),
    [anon_sym_BSLASHACRlong] = ACTIONS(6614),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrfull] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6614),
    [anon_sym_BSLASHACRfull] = ACTIONS(6614),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHacs] = ACTIONS(6614),
    [anon_sym_BSLASHAcs] = ACTIONS(6614),
    [anon_sym_BSLASHacsp] = ACTIONS(6614),
    [anon_sym_BSLASHAcsp] = ACTIONS(6614),
    [anon_sym_BSLASHacl] = ACTIONS(6614),
    [anon_sym_BSLASHAcl] = ACTIONS(6614),
    [anon_sym_BSLASHaclp] = ACTIONS(6614),
    [anon_sym_BSLASHAclp] = ACTIONS(6614),
    [anon_sym_BSLASHacf] = ACTIONS(6614),
    [anon_sym_BSLASHAcf] = ACTIONS(6614),
    [anon_sym_BSLASHacfp] = ACTIONS(6614),
    [anon_sym_BSLASHAcfp] = ACTIONS(6614),
    [anon_sym_BSLASHac] = ACTIONS(6614),
    [anon_sym_BSLASHAc] = ACTIONS(6614),
    [anon_sym_BSLASHacp] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6614),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6614),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6614),
    [anon_sym_BSLASHcolor] = ACTIONS(6614),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6614),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6614),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6614),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6614),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6614),
    [anon_sym_BSLASHtext] = ACTIONS(6614),
    [anon_sym_BSLASHintertext] = ACTIONS(6614),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6614),
    [anon_sym_BSLASHurl] = ACTIONS(6614),
    [anon_sym_BSLASHhref] = ACTIONS(6614),
  },
  [1568] = {
    [sym_curly_group] = STATE(1820),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(6164),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6164),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6164),
    [anon_sym_DOLLAR] = ACTIONS(6162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHbegin] = ACTIONS(6162),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHleft] = ACTIONS(6162),
    [anon_sym_BSLASHbigl] = ACTIONS(6162),
    [anon_sym_BSLASHBigl] = ACTIONS(6162),
    [anon_sym_BSLASHbiggl] = ACTIONS(6162),
    [anon_sym_BSLASHBiggl] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHtext] = ACTIONS(6162),
    [anon_sym_BSLASHintertext] = ACTIONS(6162),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [1569] = {
    [sym_command_name] = ACTIONS(6610),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6610),
    [anon_sym_LBRACK] = ACTIONS(6612),
    [anon_sym_RBRACK] = ACTIONS(6612),
    [anon_sym_COMMA] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6612),
    [anon_sym_RPAREN] = ACTIONS(6612),
    [anon_sym_LBRACE] = ACTIONS(6612),
    [sym_word] = ACTIONS(6610),
    [sym_placeholder] = ACTIONS(6612),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_DASH] = ACTIONS(6612),
    [anon_sym_STAR] = ACTIONS(6612),
    [anon_sym_SLASH] = ACTIONS(6612),
    [anon_sym_LT] = ACTIONS(6610),
    [anon_sym_GT] = ACTIONS(6610),
    [anon_sym_BANG] = ACTIONS(6610),
    [anon_sym_PIPE] = ACTIONS(6610),
    [anon_sym_COLON] = ACTIONS(6610),
    [anon_sym_SQUOTE] = ACTIONS(6610),
    [anon_sym__] = ACTIONS(6612),
    [anon_sym_CARET] = ACTIONS(6612),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6612),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6612),
    [anon_sym_DOLLAR] = ACTIONS(6610),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHbegin] = ACTIONS(6610),
    [anon_sym_BSLASHend] = ACTIONS(6610),
    [anon_sym_BSLASHtitle] = ACTIONS(6610),
    [anon_sym_BSLASHauthor] = ACTIONS(6610),
    [anon_sym_BSLASHusepackage] = ACTIONS(6610),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6610),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6610),
    [anon_sym_BSLASHinclude] = ACTIONS(6610),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6610),
    [anon_sym_BSLASHinput] = ACTIONS(6610),
    [anon_sym_BSLASHsubfile] = ACTIONS(6610),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6610),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6610),
    [anon_sym_BSLASHbibliography] = ACTIONS(6610),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6610),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6610),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6610),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6610),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6610),
    [anon_sym_BSLASHimport] = ACTIONS(6610),
    [anon_sym_BSLASHsubimport] = ACTIONS(6610),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6610),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHcaption] = ACTIONS(6610),
    [anon_sym_BSLASHcite] = ACTIONS(6610),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCite] = ACTIONS(6610),
    [anon_sym_BSLASHnocite] = ACTIONS(6610),
    [anon_sym_BSLASHcitet] = ACTIONS(6610),
    [anon_sym_BSLASHcitep] = ACTIONS(6610),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteA] = ACTIONS(6610),
    [anon_sym_BSLASHciteR] = ACTIONS(6610),
    [anon_sym_BSLASHciteS] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6610),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteyear] = ACTIONS(6610),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitedate] = ACTIONS(6610),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteurl] = ACTIONS(6610),
    [anon_sym_BSLASHfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6610),
    [anon_sym_BSLASHcitealt] = ACTIONS(6610),
    [anon_sym_BSLASHcitealp] = ACTIONS(6610),
    [anon_sym_BSLASHcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHparencite] = ACTIONS(6610),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHParencite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHtextcite] = ACTIONS(6610),
    [anon_sym_BSLASHTextcite] = ACTIONS(6610),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHsupercite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite] = ACTIONS(6610),
    [anon_sym_BSLASHAutocite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHVolcite] = ACTIONS(6610),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHavolcite] = ACTIONS(6610),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHNotecite] = ACTIONS(6610),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHlabel] = ACTIONS(6610),
    [anon_sym_BSLASHref] = ACTIONS(6610),
    [anon_sym_BSLASHeqref] = ACTIONS(6610),
    [anon_sym_BSLASHvref] = ACTIONS(6610),
    [anon_sym_BSLASHVref] = ACTIONS(6610),
    [anon_sym_BSLASHautoref] = ACTIONS(6610),
    [anon_sym_BSLASHpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcref] = ACTIONS(6610),
    [anon_sym_BSLASHCref] = ACTIONS(6610),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnameCref] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHdef] = ACTIONS(6610),
    [anon_sym_BSLASHlet] = ACTIONS(6610),
    [anon_sym_BSLASHleft] = ACTIONS(6610),
    [anon_sym_BSLASHbigl] = ACTIONS(6610),
    [anon_sym_BSLASHBigl] = ACTIONS(6610),
    [anon_sym_BSLASHbiggl] = ACTIONS(6610),
    [anon_sym_BSLASHBiggl] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6610),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6610),
    [anon_sym_BSLASHgls] = ACTIONS(6610),
    [anon_sym_BSLASHGls] = ACTIONS(6610),
    [anon_sym_BSLASHGLS] = ACTIONS(6610),
    [anon_sym_BSLASHglspl] = ACTIONS(6610),
    [anon_sym_BSLASHGlspl] = ACTIONS(6610),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6610),
    [anon_sym_BSLASHglslink] = ACTIONS(6610),
    [anon_sym_BSLASHglstext] = ACTIONS(6610),
    [anon_sym_BSLASHGlstext] = ACTIONS(6610),
    [anon_sym_BSLASHGLStext] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6610),
    [anon_sym_BSLASHglsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsname] = ACTIONS(6610),
    [anon_sym_BSLASHGlsname] = ACTIONS(6610),
    [anon_sym_BSLASHGLSname] = ACTIONS(6610),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6610),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6610),
    [anon_sym_BSLASHacrshort] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6610),
    [anon_sym_BSLASHACRshort] = ACTIONS(6610),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrlong] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6610),
    [anon_sym_BSLASHACRlong] = ACTIONS(6610),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrfull] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6610),
    [anon_sym_BSLASHACRfull] = ACTIONS(6610),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHacs] = ACTIONS(6610),
    [anon_sym_BSLASHAcs] = ACTIONS(6610),
    [anon_sym_BSLASHacsp] = ACTIONS(6610),
    [anon_sym_BSLASHAcsp] = ACTIONS(6610),
    [anon_sym_BSLASHacl] = ACTIONS(6610),
    [anon_sym_BSLASHAcl] = ACTIONS(6610),
    [anon_sym_BSLASHaclp] = ACTIONS(6610),
    [anon_sym_BSLASHAclp] = ACTIONS(6610),
    [anon_sym_BSLASHacf] = ACTIONS(6610),
    [anon_sym_BSLASHAcf] = ACTIONS(6610),
    [anon_sym_BSLASHacfp] = ACTIONS(6610),
    [anon_sym_BSLASHAcfp] = ACTIONS(6610),
    [anon_sym_BSLASHac] = ACTIONS(6610),
    [anon_sym_BSLASHAc] = ACTIONS(6610),
    [anon_sym_BSLASHacp] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6610),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6610),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6610),
    [anon_sym_BSLASHcolor] = ACTIONS(6610),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6610),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6610),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6610),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6610),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6610),
    [anon_sym_BSLASHtext] = ACTIONS(6610),
    [anon_sym_BSLASHintertext] = ACTIONS(6610),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6610),
    [anon_sym_BSLASHurl] = ACTIONS(6610),
    [anon_sym_BSLASHhref] = ACTIONS(6610),
  },
  [1570] = {
    [sym_command_name] = ACTIONS(6606),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6606),
    [anon_sym_LBRACK] = ACTIONS(6608),
    [anon_sym_RBRACK] = ACTIONS(6608),
    [anon_sym_COMMA] = ACTIONS(6608),
    [anon_sym_EQ] = ACTIONS(6608),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_RPAREN] = ACTIONS(6608),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [sym_word] = ACTIONS(6606),
    [sym_placeholder] = ACTIONS(6608),
    [anon_sym_PLUS] = ACTIONS(6608),
    [anon_sym_DASH] = ACTIONS(6608),
    [anon_sym_STAR] = ACTIONS(6608),
    [anon_sym_SLASH] = ACTIONS(6608),
    [anon_sym_LT] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6606),
    [anon_sym_BANG] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6606),
    [anon_sym_COLON] = ACTIONS(6606),
    [anon_sym_SQUOTE] = ACTIONS(6606),
    [anon_sym__] = ACTIONS(6608),
    [anon_sym_CARET] = ACTIONS(6608),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6608),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(6606),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHbegin] = ACTIONS(6606),
    [anon_sym_BSLASHend] = ACTIONS(6606),
    [anon_sym_BSLASHtitle] = ACTIONS(6606),
    [anon_sym_BSLASHauthor] = ACTIONS(6606),
    [anon_sym_BSLASHusepackage] = ACTIONS(6606),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6606),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6606),
    [anon_sym_BSLASHinclude] = ACTIONS(6606),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6606),
    [anon_sym_BSLASHinput] = ACTIONS(6606),
    [anon_sym_BSLASHsubfile] = ACTIONS(6606),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6606),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6606),
    [anon_sym_BSLASHbibliography] = ACTIONS(6606),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6606),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6606),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6606),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6606),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6606),
    [anon_sym_BSLASHimport] = ACTIONS(6606),
    [anon_sym_BSLASHsubimport] = ACTIONS(6606),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6606),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHcaption] = ACTIONS(6606),
    [anon_sym_BSLASHcite] = ACTIONS(6606),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCite] = ACTIONS(6606),
    [anon_sym_BSLASHnocite] = ACTIONS(6606),
    [anon_sym_BSLASHcitet] = ACTIONS(6606),
    [anon_sym_BSLASHcitep] = ACTIONS(6606),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteA] = ACTIONS(6606),
    [anon_sym_BSLASHciteR] = ACTIONS(6606),
    [anon_sym_BSLASHciteS] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6606),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteyear] = ACTIONS(6606),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitedate] = ACTIONS(6606),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteurl] = ACTIONS(6606),
    [anon_sym_BSLASHfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6606),
    [anon_sym_BSLASHcitealt] = ACTIONS(6606),
    [anon_sym_BSLASHcitealp] = ACTIONS(6606),
    [anon_sym_BSLASHcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHparencite] = ACTIONS(6606),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHParencite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHtextcite] = ACTIONS(6606),
    [anon_sym_BSLASHTextcite] = ACTIONS(6606),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHsupercite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite] = ACTIONS(6606),
    [anon_sym_BSLASHAutocite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHVolcite] = ACTIONS(6606),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHavolcite] = ACTIONS(6606),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHNotecite] = ACTIONS(6606),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHlabel] = ACTIONS(6606),
    [anon_sym_BSLASHref] = ACTIONS(6606),
    [anon_sym_BSLASHeqref] = ACTIONS(6606),
    [anon_sym_BSLASHvref] = ACTIONS(6606),
    [anon_sym_BSLASHVref] = ACTIONS(6606),
    [anon_sym_BSLASHautoref] = ACTIONS(6606),
    [anon_sym_BSLASHpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcref] = ACTIONS(6606),
    [anon_sym_BSLASHCref] = ACTIONS(6606),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnameCref] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHdef] = ACTIONS(6606),
    [anon_sym_BSLASHlet] = ACTIONS(6606),
    [anon_sym_BSLASHleft] = ACTIONS(6606),
    [anon_sym_BSLASHbigl] = ACTIONS(6606),
    [anon_sym_BSLASHBigl] = ACTIONS(6606),
    [anon_sym_BSLASHbiggl] = ACTIONS(6606),
    [anon_sym_BSLASHBiggl] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6606),
    [anon_sym_BSLASHgls] = ACTIONS(6606),
    [anon_sym_BSLASHGls] = ACTIONS(6606),
    [anon_sym_BSLASHGLS] = ACTIONS(6606),
    [anon_sym_BSLASHglspl] = ACTIONS(6606),
    [anon_sym_BSLASHGlspl] = ACTIONS(6606),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6606),
    [anon_sym_BSLASHglslink] = ACTIONS(6606),
    [anon_sym_BSLASHglstext] = ACTIONS(6606),
    [anon_sym_BSLASHGlstext] = ACTIONS(6606),
    [anon_sym_BSLASHGLStext] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6606),
    [anon_sym_BSLASHglsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsname] = ACTIONS(6606),
    [anon_sym_BSLASHGlsname] = ACTIONS(6606),
    [anon_sym_BSLASHGLSname] = ACTIONS(6606),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6606),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6606),
    [anon_sym_BSLASHacrshort] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6606),
    [anon_sym_BSLASHACRshort] = ACTIONS(6606),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrlong] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6606),
    [anon_sym_BSLASHACRlong] = ACTIONS(6606),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrfull] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6606),
    [anon_sym_BSLASHACRfull] = ACTIONS(6606),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHacs] = ACTIONS(6606),
    [anon_sym_BSLASHAcs] = ACTIONS(6606),
    [anon_sym_BSLASHacsp] = ACTIONS(6606),
    [anon_sym_BSLASHAcsp] = ACTIONS(6606),
    [anon_sym_BSLASHacl] = ACTIONS(6606),
    [anon_sym_BSLASHAcl] = ACTIONS(6606),
    [anon_sym_BSLASHaclp] = ACTIONS(6606),
    [anon_sym_BSLASHAclp] = ACTIONS(6606),
    [anon_sym_BSLASHacf] = ACTIONS(6606),
    [anon_sym_BSLASHAcf] = ACTIONS(6606),
    [anon_sym_BSLASHacfp] = ACTIONS(6606),
    [anon_sym_BSLASHAcfp] = ACTIONS(6606),
    [anon_sym_BSLASHac] = ACTIONS(6606),
    [anon_sym_BSLASHAc] = ACTIONS(6606),
    [anon_sym_BSLASHacp] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6606),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6606),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6606),
    [anon_sym_BSLASHcolor] = ACTIONS(6606),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6606),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6606),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6606),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6606),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6606),
    [anon_sym_BSLASHtext] = ACTIONS(6606),
    [anon_sym_BSLASHintertext] = ACTIONS(6606),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6606),
    [anon_sym_BSLASHurl] = ACTIONS(6606),
    [anon_sym_BSLASHhref] = ACTIONS(6606),
  },
  [1571] = {
    [sym_command_name] = ACTIONS(6602),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6602),
    [anon_sym_LBRACK] = ACTIONS(6604),
    [anon_sym_RBRACK] = ACTIONS(6604),
    [anon_sym_COMMA] = ACTIONS(6604),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(6604),
    [anon_sym_RPAREN] = ACTIONS(6604),
    [anon_sym_LBRACE] = ACTIONS(6604),
    [sym_word] = ACTIONS(6602),
    [sym_placeholder] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6602),
    [anon_sym_GT] = ACTIONS(6602),
    [anon_sym_BANG] = ACTIONS(6602),
    [anon_sym_PIPE] = ACTIONS(6602),
    [anon_sym_COLON] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(6602),
    [anon_sym__] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6604),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6604),
    [anon_sym_DOLLAR] = ACTIONS(6602),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHbegin] = ACTIONS(6602),
    [anon_sym_BSLASHend] = ACTIONS(6602),
    [anon_sym_BSLASHtitle] = ACTIONS(6602),
    [anon_sym_BSLASHauthor] = ACTIONS(6602),
    [anon_sym_BSLASHusepackage] = ACTIONS(6602),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6602),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6602),
    [anon_sym_BSLASHinclude] = ACTIONS(6602),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6602),
    [anon_sym_BSLASHinput] = ACTIONS(6602),
    [anon_sym_BSLASHsubfile] = ACTIONS(6602),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6602),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6602),
    [anon_sym_BSLASHbibliography] = ACTIONS(6602),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6602),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6602),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6602),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6602),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6602),
    [anon_sym_BSLASHimport] = ACTIONS(6602),
    [anon_sym_BSLASHsubimport] = ACTIONS(6602),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6602),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHcaption] = ACTIONS(6602),
    [anon_sym_BSLASHcite] = ACTIONS(6602),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCite] = ACTIONS(6602),
    [anon_sym_BSLASHnocite] = ACTIONS(6602),
    [anon_sym_BSLASHcitet] = ACTIONS(6602),
    [anon_sym_BSLASHcitep] = ACTIONS(6602),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteA] = ACTIONS(6602),
    [anon_sym_BSLASHciteR] = ACTIONS(6602),
    [anon_sym_BSLASHciteS] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6602),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteyear] = ACTIONS(6602),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitedate] = ACTIONS(6602),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteurl] = ACTIONS(6602),
    [anon_sym_BSLASHfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6602),
    [anon_sym_BSLASHcitealt] = ACTIONS(6602),
    [anon_sym_BSLASHcitealp] = ACTIONS(6602),
    [anon_sym_BSLASHcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHparencite] = ACTIONS(6602),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHParencite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHtextcite] = ACTIONS(6602),
    [anon_sym_BSLASHTextcite] = ACTIONS(6602),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHsupercite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite] = ACTIONS(6602),
    [anon_sym_BSLASHAutocite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHVolcite] = ACTIONS(6602),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHavolcite] = ACTIONS(6602),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHNotecite] = ACTIONS(6602),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHlabel] = ACTIONS(6602),
    [anon_sym_BSLASHref] = ACTIONS(6602),
    [anon_sym_BSLASHeqref] = ACTIONS(6602),
    [anon_sym_BSLASHvref] = ACTIONS(6602),
    [anon_sym_BSLASHVref] = ACTIONS(6602),
    [anon_sym_BSLASHautoref] = ACTIONS(6602),
    [anon_sym_BSLASHpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcref] = ACTIONS(6602),
    [anon_sym_BSLASHCref] = ACTIONS(6602),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnameCref] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHdef] = ACTIONS(6602),
    [anon_sym_BSLASHlet] = ACTIONS(6602),
    [anon_sym_BSLASHleft] = ACTIONS(6602),
    [anon_sym_BSLASHbigl] = ACTIONS(6602),
    [anon_sym_BSLASHBigl] = ACTIONS(6602),
    [anon_sym_BSLASHbiggl] = ACTIONS(6602),
    [anon_sym_BSLASHBiggl] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6602),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6602),
    [anon_sym_BSLASHgls] = ACTIONS(6602),
    [anon_sym_BSLASHGls] = ACTIONS(6602),
    [anon_sym_BSLASHGLS] = ACTIONS(6602),
    [anon_sym_BSLASHglspl] = ACTIONS(6602),
    [anon_sym_BSLASHGlspl] = ACTIONS(6602),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6602),
    [anon_sym_BSLASHglslink] = ACTIONS(6602),
    [anon_sym_BSLASHglstext] = ACTIONS(6602),
    [anon_sym_BSLASHGlstext] = ACTIONS(6602),
    [anon_sym_BSLASHGLStext] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6602),
    [anon_sym_BSLASHglsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsname] = ACTIONS(6602),
    [anon_sym_BSLASHGlsname] = ACTIONS(6602),
    [anon_sym_BSLASHGLSname] = ACTIONS(6602),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6602),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6602),
    [anon_sym_BSLASHacrshort] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6602),
    [anon_sym_BSLASHACRshort] = ACTIONS(6602),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrlong] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6602),
    [anon_sym_BSLASHACRlong] = ACTIONS(6602),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrfull] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6602),
    [anon_sym_BSLASHACRfull] = ACTIONS(6602),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHacs] = ACTIONS(6602),
    [anon_sym_BSLASHAcs] = ACTIONS(6602),
    [anon_sym_BSLASHacsp] = ACTIONS(6602),
    [anon_sym_BSLASHAcsp] = ACTIONS(6602),
    [anon_sym_BSLASHacl] = ACTIONS(6602),
    [anon_sym_BSLASHAcl] = ACTIONS(6602),
    [anon_sym_BSLASHaclp] = ACTIONS(6602),
    [anon_sym_BSLASHAclp] = ACTIONS(6602),
    [anon_sym_BSLASHacf] = ACTIONS(6602),
    [anon_sym_BSLASHAcf] = ACTIONS(6602),
    [anon_sym_BSLASHacfp] = ACTIONS(6602),
    [anon_sym_BSLASHAcfp] = ACTIONS(6602),
    [anon_sym_BSLASHac] = ACTIONS(6602),
    [anon_sym_BSLASHAc] = ACTIONS(6602),
    [anon_sym_BSLASHacp] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6602),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6602),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6602),
    [anon_sym_BSLASHcolor] = ACTIONS(6602),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6602),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6602),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6602),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6602),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6602),
    [anon_sym_BSLASHtext] = ACTIONS(6602),
    [anon_sym_BSLASHintertext] = ACTIONS(6602),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6602),
    [anon_sym_BSLASHurl] = ACTIONS(6602),
    [anon_sym_BSLASHhref] = ACTIONS(6602),
  },
  [1572] = {
    [sym_command_name] = ACTIONS(6562),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6562),
    [anon_sym_LBRACK] = ACTIONS(6564),
    [anon_sym_RBRACK] = ACTIONS(6564),
    [anon_sym_COMMA] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6564),
    [anon_sym_RPAREN] = ACTIONS(6564),
    [anon_sym_LBRACE] = ACTIONS(6564),
    [sym_word] = ACTIONS(6562),
    [sym_placeholder] = ACTIONS(6564),
    [anon_sym_PLUS] = ACTIONS(6564),
    [anon_sym_DASH] = ACTIONS(6564),
    [anon_sym_STAR] = ACTIONS(6564),
    [anon_sym_SLASH] = ACTIONS(6564),
    [anon_sym_LT] = ACTIONS(6562),
    [anon_sym_GT] = ACTIONS(6562),
    [anon_sym_BANG] = ACTIONS(6562),
    [anon_sym_PIPE] = ACTIONS(6562),
    [anon_sym_COLON] = ACTIONS(6562),
    [anon_sym_SQUOTE] = ACTIONS(6562),
    [anon_sym__] = ACTIONS(6564),
    [anon_sym_CARET] = ACTIONS(6564),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6564),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6564),
    [anon_sym_DOLLAR] = ACTIONS(6562),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHbegin] = ACTIONS(6562),
    [anon_sym_BSLASHend] = ACTIONS(6562),
    [anon_sym_BSLASHtitle] = ACTIONS(6562),
    [anon_sym_BSLASHauthor] = ACTIONS(6562),
    [anon_sym_BSLASHusepackage] = ACTIONS(6562),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6562),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6562),
    [anon_sym_BSLASHinclude] = ACTIONS(6562),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6562),
    [anon_sym_BSLASHinput] = ACTIONS(6562),
    [anon_sym_BSLASHsubfile] = ACTIONS(6562),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6562),
    [anon_sym_BSLASHbibliography] = ACTIONS(6562),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6562),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6562),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6562),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6562),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6562),
    [anon_sym_BSLASHimport] = ACTIONS(6562),
    [anon_sym_BSLASHsubimport] = ACTIONS(6562),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6562),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHcaption] = ACTIONS(6562),
    [anon_sym_BSLASHcite] = ACTIONS(6562),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCite] = ACTIONS(6562),
    [anon_sym_BSLASHnocite] = ACTIONS(6562),
    [anon_sym_BSLASHcitet] = ACTIONS(6562),
    [anon_sym_BSLASHcitep] = ACTIONS(6562),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteA] = ACTIONS(6562),
    [anon_sym_BSLASHciteR] = ACTIONS(6562),
    [anon_sym_BSLASHciteS] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6562),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteyear] = ACTIONS(6562),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitedate] = ACTIONS(6562),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteurl] = ACTIONS(6562),
    [anon_sym_BSLASHfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6562),
    [anon_sym_BSLASHcitealt] = ACTIONS(6562),
    [anon_sym_BSLASHcitealp] = ACTIONS(6562),
    [anon_sym_BSLASHcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHparencite] = ACTIONS(6562),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHParencite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHtextcite] = ACTIONS(6562),
    [anon_sym_BSLASHTextcite] = ACTIONS(6562),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHsupercite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite] = ACTIONS(6562),
    [anon_sym_BSLASHAutocite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHVolcite] = ACTIONS(6562),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHavolcite] = ACTIONS(6562),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHNotecite] = ACTIONS(6562),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHlabel] = ACTIONS(6562),
    [anon_sym_BSLASHref] = ACTIONS(6562),
    [anon_sym_BSLASHeqref] = ACTIONS(6562),
    [anon_sym_BSLASHvref] = ACTIONS(6562),
    [anon_sym_BSLASHVref] = ACTIONS(6562),
    [anon_sym_BSLASHautoref] = ACTIONS(6562),
    [anon_sym_BSLASHpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcref] = ACTIONS(6562),
    [anon_sym_BSLASHCref] = ACTIONS(6562),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnameCref] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHdef] = ACTIONS(6562),
    [anon_sym_BSLASHlet] = ACTIONS(6562),
    [anon_sym_BSLASHleft] = ACTIONS(6562),
    [anon_sym_BSLASHbigl] = ACTIONS(6562),
    [anon_sym_BSLASHBigl] = ACTIONS(6562),
    [anon_sym_BSLASHbiggl] = ACTIONS(6562),
    [anon_sym_BSLASHBiggl] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6562),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6562),
    [anon_sym_BSLASHgls] = ACTIONS(6562),
    [anon_sym_BSLASHGls] = ACTIONS(6562),
    [anon_sym_BSLASHGLS] = ACTIONS(6562),
    [anon_sym_BSLASHglspl] = ACTIONS(6562),
    [anon_sym_BSLASHGlspl] = ACTIONS(6562),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6562),
    [anon_sym_BSLASHglslink] = ACTIONS(6562),
    [anon_sym_BSLASHglstext] = ACTIONS(6562),
    [anon_sym_BSLASHGlstext] = ACTIONS(6562),
    [anon_sym_BSLASHGLStext] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6562),
    [anon_sym_BSLASHglsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsname] = ACTIONS(6562),
    [anon_sym_BSLASHGlsname] = ACTIONS(6562),
    [anon_sym_BSLASHGLSname] = ACTIONS(6562),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6562),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6562),
    [anon_sym_BSLASHacrshort] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6562),
    [anon_sym_BSLASHACRshort] = ACTIONS(6562),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrlong] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6562),
    [anon_sym_BSLASHACRlong] = ACTIONS(6562),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrfull] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6562),
    [anon_sym_BSLASHACRfull] = ACTIONS(6562),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHacs] = ACTIONS(6562),
    [anon_sym_BSLASHAcs] = ACTIONS(6562),
    [anon_sym_BSLASHacsp] = ACTIONS(6562),
    [anon_sym_BSLASHAcsp] = ACTIONS(6562),
    [anon_sym_BSLASHacl] = ACTIONS(6562),
    [anon_sym_BSLASHAcl] = ACTIONS(6562),
    [anon_sym_BSLASHaclp] = ACTIONS(6562),
    [anon_sym_BSLASHAclp] = ACTIONS(6562),
    [anon_sym_BSLASHacf] = ACTIONS(6562),
    [anon_sym_BSLASHAcf] = ACTIONS(6562),
    [anon_sym_BSLASHacfp] = ACTIONS(6562),
    [anon_sym_BSLASHAcfp] = ACTIONS(6562),
    [anon_sym_BSLASHac] = ACTIONS(6562),
    [anon_sym_BSLASHAc] = ACTIONS(6562),
    [anon_sym_BSLASHacp] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6562),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6562),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6562),
    [anon_sym_BSLASHcolor] = ACTIONS(6562),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6562),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6562),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6562),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6562),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6562),
    [anon_sym_BSLASHtext] = ACTIONS(6562),
    [anon_sym_BSLASHintertext] = ACTIONS(6562),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6562),
    [anon_sym_BSLASHurl] = ACTIONS(6562),
    [anon_sym_BSLASHhref] = ACTIONS(6562),
  },
  [1573] = {
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_LBRACK] = ACTIONS(6440),
    [anon_sym_RBRACK] = ACTIONS(6440),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6440),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_RPAREN] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6440),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6440),
    [anon_sym_DOLLAR] = ACTIONS(6438),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHbegin] = ACTIONS(6438),
    [anon_sym_BSLASHend] = ACTIONS(6438),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHleft] = ACTIONS(6438),
    [anon_sym_BSLASHbigl] = ACTIONS(6438),
    [anon_sym_BSLASHBigl] = ACTIONS(6438),
    [anon_sym_BSLASHbiggl] = ACTIONS(6438),
    [anon_sym_BSLASHBiggl] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHtext] = ACTIONS(6438),
    [anon_sym_BSLASHintertext] = ACTIONS(6438),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [1574] = {
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [anon_sym_RPAREN] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6200),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6200),
    [anon_sym_DOLLAR] = ACTIONS(6198),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHbegin] = ACTIONS(6198),
    [anon_sym_BSLASHend] = ACTIONS(6198),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHleft] = ACTIONS(6198),
    [anon_sym_BSLASHbigl] = ACTIONS(6198),
    [anon_sym_BSLASHBigl] = ACTIONS(6198),
    [anon_sym_BSLASHbiggl] = ACTIONS(6198),
    [anon_sym_BSLASHBiggl] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHtext] = ACTIONS(6198),
    [anon_sym_BSLASHintertext] = ACTIONS(6198),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [1575] = {
    [sym_command_name] = ACTIONS(6726),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6726),
    [anon_sym_LBRACK] = ACTIONS(6728),
    [anon_sym_RBRACK] = ACTIONS(6728),
    [anon_sym_COMMA] = ACTIONS(6728),
    [anon_sym_EQ] = ACTIONS(6728),
    [anon_sym_LPAREN] = ACTIONS(6728),
    [anon_sym_RPAREN] = ACTIONS(6728),
    [anon_sym_LBRACE] = ACTIONS(6728),
    [sym_word] = ACTIONS(6726),
    [sym_placeholder] = ACTIONS(6728),
    [anon_sym_PLUS] = ACTIONS(6728),
    [anon_sym_DASH] = ACTIONS(6728),
    [anon_sym_STAR] = ACTIONS(6728),
    [anon_sym_SLASH] = ACTIONS(6728),
    [anon_sym_LT] = ACTIONS(6726),
    [anon_sym_GT] = ACTIONS(6726),
    [anon_sym_BANG] = ACTIONS(6726),
    [anon_sym_PIPE] = ACTIONS(6726),
    [anon_sym_COLON] = ACTIONS(6726),
    [anon_sym_SQUOTE] = ACTIONS(6726),
    [anon_sym__] = ACTIONS(6728),
    [anon_sym_CARET] = ACTIONS(6728),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6728),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6728),
    [anon_sym_DOLLAR] = ACTIONS(6726),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHbegin] = ACTIONS(6726),
    [anon_sym_BSLASHend] = ACTIONS(6726),
    [anon_sym_BSLASHtitle] = ACTIONS(6726),
    [anon_sym_BSLASHauthor] = ACTIONS(6726),
    [anon_sym_BSLASHusepackage] = ACTIONS(6726),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6726),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6726),
    [anon_sym_BSLASHinclude] = ACTIONS(6726),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6726),
    [anon_sym_BSLASHinput] = ACTIONS(6726),
    [anon_sym_BSLASHsubfile] = ACTIONS(6726),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6726),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6726),
    [anon_sym_BSLASHbibliography] = ACTIONS(6726),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6726),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6726),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6726),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6726),
    [anon_sym_BSLASHimport] = ACTIONS(6726),
    [anon_sym_BSLASHsubimport] = ACTIONS(6726),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6726),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHcaption] = ACTIONS(6726),
    [anon_sym_BSLASHcite] = ACTIONS(6726),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCite] = ACTIONS(6726),
    [anon_sym_BSLASHnocite] = ACTIONS(6726),
    [anon_sym_BSLASHcitet] = ACTIONS(6726),
    [anon_sym_BSLASHcitep] = ACTIONS(6726),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteA] = ACTIONS(6726),
    [anon_sym_BSLASHciteR] = ACTIONS(6726),
    [anon_sym_BSLASHciteS] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6726),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteyear] = ACTIONS(6726),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitedate] = ACTIONS(6726),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteurl] = ACTIONS(6726),
    [anon_sym_BSLASHfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6726),
    [anon_sym_BSLASHcitealt] = ACTIONS(6726),
    [anon_sym_BSLASHcitealp] = ACTIONS(6726),
    [anon_sym_BSLASHcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHparencite] = ACTIONS(6726),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHParencite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHtextcite] = ACTIONS(6726),
    [anon_sym_BSLASHTextcite] = ACTIONS(6726),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHsupercite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite] = ACTIONS(6726),
    [anon_sym_BSLASHAutocite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHVolcite] = ACTIONS(6726),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHavolcite] = ACTIONS(6726),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHNotecite] = ACTIONS(6726),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHlabel] = ACTIONS(6726),
    [anon_sym_BSLASHref] = ACTIONS(6726),
    [anon_sym_BSLASHeqref] = ACTIONS(6726),
    [anon_sym_BSLASHvref] = ACTIONS(6726),
    [anon_sym_BSLASHVref] = ACTIONS(6726),
    [anon_sym_BSLASHautoref] = ACTIONS(6726),
    [anon_sym_BSLASHpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcref] = ACTIONS(6726),
    [anon_sym_BSLASHCref] = ACTIONS(6726),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnameCref] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHdef] = ACTIONS(6726),
    [anon_sym_BSLASHlet] = ACTIONS(6726),
    [anon_sym_BSLASHleft] = ACTIONS(6726),
    [anon_sym_BSLASHbigl] = ACTIONS(6726),
    [anon_sym_BSLASHBigl] = ACTIONS(6726),
    [anon_sym_BSLASHbiggl] = ACTIONS(6726),
    [anon_sym_BSLASHBiggl] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6726),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6726),
    [anon_sym_BSLASHgls] = ACTIONS(6726),
    [anon_sym_BSLASHGls] = ACTIONS(6726),
    [anon_sym_BSLASHGLS] = ACTIONS(6726),
    [anon_sym_BSLASHglspl] = ACTIONS(6726),
    [anon_sym_BSLASHGlspl] = ACTIONS(6726),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6726),
    [anon_sym_BSLASHglslink] = ACTIONS(6726),
    [anon_sym_BSLASHglstext] = ACTIONS(6726),
    [anon_sym_BSLASHGlstext] = ACTIONS(6726),
    [anon_sym_BSLASHGLStext] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6726),
    [anon_sym_BSLASHglsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsname] = ACTIONS(6726),
    [anon_sym_BSLASHGlsname] = ACTIONS(6726),
    [anon_sym_BSLASHGLSname] = ACTIONS(6726),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6726),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6726),
    [anon_sym_BSLASHacrshort] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6726),
    [anon_sym_BSLASHACRshort] = ACTIONS(6726),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrlong] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6726),
    [anon_sym_BSLASHACRlong] = ACTIONS(6726),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrfull] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6726),
    [anon_sym_BSLASHACRfull] = ACTIONS(6726),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHacs] = ACTIONS(6726),
    [anon_sym_BSLASHAcs] = ACTIONS(6726),
    [anon_sym_BSLASHacsp] = ACTIONS(6726),
    [anon_sym_BSLASHAcsp] = ACTIONS(6726),
    [anon_sym_BSLASHacl] = ACTIONS(6726),
    [anon_sym_BSLASHAcl] = ACTIONS(6726),
    [anon_sym_BSLASHaclp] = ACTIONS(6726),
    [anon_sym_BSLASHAclp] = ACTIONS(6726),
    [anon_sym_BSLASHacf] = ACTIONS(6726),
    [anon_sym_BSLASHAcf] = ACTIONS(6726),
    [anon_sym_BSLASHacfp] = ACTIONS(6726),
    [anon_sym_BSLASHAcfp] = ACTIONS(6726),
    [anon_sym_BSLASHac] = ACTIONS(6726),
    [anon_sym_BSLASHAc] = ACTIONS(6726),
    [anon_sym_BSLASHacp] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6726),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6726),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6726),
    [anon_sym_BSLASHcolor] = ACTIONS(6726),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6726),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6726),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6726),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6726),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6726),
    [anon_sym_BSLASHtext] = ACTIONS(6726),
    [anon_sym_BSLASHintertext] = ACTIONS(6726),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6726),
    [anon_sym_BSLASHurl] = ACTIONS(6726),
    [anon_sym_BSLASHhref] = ACTIONS(6726),
  },
  [1576] = {
    [sym_command_name] = ACTIONS(6722),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6722),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_RBRACK] = ACTIONS(6724),
    [anon_sym_COMMA] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6724),
    [anon_sym_LPAREN] = ACTIONS(6724),
    [anon_sym_RPAREN] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(6724),
    [sym_word] = ACTIONS(6722),
    [sym_placeholder] = ACTIONS(6724),
    [anon_sym_PLUS] = ACTIONS(6724),
    [anon_sym_DASH] = ACTIONS(6724),
    [anon_sym_STAR] = ACTIONS(6724),
    [anon_sym_SLASH] = ACTIONS(6724),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_BANG] = ACTIONS(6722),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_COLON] = ACTIONS(6722),
    [anon_sym_SQUOTE] = ACTIONS(6722),
    [anon_sym__] = ACTIONS(6724),
    [anon_sym_CARET] = ACTIONS(6724),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6724),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6724),
    [anon_sym_DOLLAR] = ACTIONS(6722),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHbegin] = ACTIONS(6722),
    [anon_sym_BSLASHend] = ACTIONS(6722),
    [anon_sym_BSLASHtitle] = ACTIONS(6722),
    [anon_sym_BSLASHauthor] = ACTIONS(6722),
    [anon_sym_BSLASHusepackage] = ACTIONS(6722),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6722),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6722),
    [anon_sym_BSLASHinclude] = ACTIONS(6722),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6722),
    [anon_sym_BSLASHinput] = ACTIONS(6722),
    [anon_sym_BSLASHsubfile] = ACTIONS(6722),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6722),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6722),
    [anon_sym_BSLASHbibliography] = ACTIONS(6722),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6722),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6722),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6722),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6722),
    [anon_sym_BSLASHimport] = ACTIONS(6722),
    [anon_sym_BSLASHsubimport] = ACTIONS(6722),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6722),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHcaption] = ACTIONS(6722),
    [anon_sym_BSLASHcite] = ACTIONS(6722),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCite] = ACTIONS(6722),
    [anon_sym_BSLASHnocite] = ACTIONS(6722),
    [anon_sym_BSLASHcitet] = ACTIONS(6722),
    [anon_sym_BSLASHcitep] = ACTIONS(6722),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteA] = ACTIONS(6722),
    [anon_sym_BSLASHciteR] = ACTIONS(6722),
    [anon_sym_BSLASHciteS] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6722),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteyear] = ACTIONS(6722),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitedate] = ACTIONS(6722),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteurl] = ACTIONS(6722),
    [anon_sym_BSLASHfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6722),
    [anon_sym_BSLASHcitealt] = ACTIONS(6722),
    [anon_sym_BSLASHcitealp] = ACTIONS(6722),
    [anon_sym_BSLASHcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHparencite] = ACTIONS(6722),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHParencite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHtextcite] = ACTIONS(6722),
    [anon_sym_BSLASHTextcite] = ACTIONS(6722),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHsupercite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite] = ACTIONS(6722),
    [anon_sym_BSLASHAutocite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHVolcite] = ACTIONS(6722),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHavolcite] = ACTIONS(6722),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHNotecite] = ACTIONS(6722),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHlabel] = ACTIONS(6722),
    [anon_sym_BSLASHref] = ACTIONS(6722),
    [anon_sym_BSLASHeqref] = ACTIONS(6722),
    [anon_sym_BSLASHvref] = ACTIONS(6722),
    [anon_sym_BSLASHVref] = ACTIONS(6722),
    [anon_sym_BSLASHautoref] = ACTIONS(6722),
    [anon_sym_BSLASHpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcref] = ACTIONS(6722),
    [anon_sym_BSLASHCref] = ACTIONS(6722),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnameCref] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHdef] = ACTIONS(6722),
    [anon_sym_BSLASHlet] = ACTIONS(6722),
    [anon_sym_BSLASHleft] = ACTIONS(6722),
    [anon_sym_BSLASHbigl] = ACTIONS(6722),
    [anon_sym_BSLASHBigl] = ACTIONS(6722),
    [anon_sym_BSLASHbiggl] = ACTIONS(6722),
    [anon_sym_BSLASHBiggl] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6722),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6722),
    [anon_sym_BSLASHgls] = ACTIONS(6722),
    [anon_sym_BSLASHGls] = ACTIONS(6722),
    [anon_sym_BSLASHGLS] = ACTIONS(6722),
    [anon_sym_BSLASHglspl] = ACTIONS(6722),
    [anon_sym_BSLASHGlspl] = ACTIONS(6722),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6722),
    [anon_sym_BSLASHglslink] = ACTIONS(6722),
    [anon_sym_BSLASHglstext] = ACTIONS(6722),
    [anon_sym_BSLASHGlstext] = ACTIONS(6722),
    [anon_sym_BSLASHGLStext] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6722),
    [anon_sym_BSLASHglsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsname] = ACTIONS(6722),
    [anon_sym_BSLASHGlsname] = ACTIONS(6722),
    [anon_sym_BSLASHGLSname] = ACTIONS(6722),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6722),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6722),
    [anon_sym_BSLASHacrshort] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6722),
    [anon_sym_BSLASHACRshort] = ACTIONS(6722),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrlong] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6722),
    [anon_sym_BSLASHACRlong] = ACTIONS(6722),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrfull] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6722),
    [anon_sym_BSLASHACRfull] = ACTIONS(6722),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHacs] = ACTIONS(6722),
    [anon_sym_BSLASHAcs] = ACTIONS(6722),
    [anon_sym_BSLASHacsp] = ACTIONS(6722),
    [anon_sym_BSLASHAcsp] = ACTIONS(6722),
    [anon_sym_BSLASHacl] = ACTIONS(6722),
    [anon_sym_BSLASHAcl] = ACTIONS(6722),
    [anon_sym_BSLASHaclp] = ACTIONS(6722),
    [anon_sym_BSLASHAclp] = ACTIONS(6722),
    [anon_sym_BSLASHacf] = ACTIONS(6722),
    [anon_sym_BSLASHAcf] = ACTIONS(6722),
    [anon_sym_BSLASHacfp] = ACTIONS(6722),
    [anon_sym_BSLASHAcfp] = ACTIONS(6722),
    [anon_sym_BSLASHac] = ACTIONS(6722),
    [anon_sym_BSLASHAc] = ACTIONS(6722),
    [anon_sym_BSLASHacp] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6722),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6722),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6722),
    [anon_sym_BSLASHcolor] = ACTIONS(6722),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6722),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6722),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6722),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6722),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6722),
    [anon_sym_BSLASHtext] = ACTIONS(6722),
    [anon_sym_BSLASHintertext] = ACTIONS(6722),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6722),
    [anon_sym_BSLASHurl] = ACTIONS(6722),
    [anon_sym_BSLASHhref] = ACTIONS(6722),
  },
  [1577] = {
    [sym_command_name] = ACTIONS(6718),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6718),
    [anon_sym_LBRACK] = ACTIONS(6720),
    [anon_sym_RBRACK] = ACTIONS(6720),
    [anon_sym_COMMA] = ACTIONS(6720),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_LPAREN] = ACTIONS(6720),
    [anon_sym_RPAREN] = ACTIONS(6720),
    [anon_sym_LBRACE] = ACTIONS(6720),
    [sym_word] = ACTIONS(6718),
    [sym_placeholder] = ACTIONS(6720),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_LT] = ACTIONS(6718),
    [anon_sym_GT] = ACTIONS(6718),
    [anon_sym_BANG] = ACTIONS(6718),
    [anon_sym_PIPE] = ACTIONS(6718),
    [anon_sym_COLON] = ACTIONS(6718),
    [anon_sym_SQUOTE] = ACTIONS(6718),
    [anon_sym__] = ACTIONS(6720),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6720),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6720),
    [anon_sym_DOLLAR] = ACTIONS(6718),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHbegin] = ACTIONS(6718),
    [anon_sym_BSLASHend] = ACTIONS(6718),
    [anon_sym_BSLASHtitle] = ACTIONS(6718),
    [anon_sym_BSLASHauthor] = ACTIONS(6718),
    [anon_sym_BSLASHusepackage] = ACTIONS(6718),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6718),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6718),
    [anon_sym_BSLASHinclude] = ACTIONS(6718),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6718),
    [anon_sym_BSLASHinput] = ACTIONS(6718),
    [anon_sym_BSLASHsubfile] = ACTIONS(6718),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6718),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6718),
    [anon_sym_BSLASHbibliography] = ACTIONS(6718),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6718),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6718),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6718),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6718),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6718),
    [anon_sym_BSLASHimport] = ACTIONS(6718),
    [anon_sym_BSLASHsubimport] = ACTIONS(6718),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6718),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHcaption] = ACTIONS(6718),
    [anon_sym_BSLASHcite] = ACTIONS(6718),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCite] = ACTIONS(6718),
    [anon_sym_BSLASHnocite] = ACTIONS(6718),
    [anon_sym_BSLASHcitet] = ACTIONS(6718),
    [anon_sym_BSLASHcitep] = ACTIONS(6718),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteA] = ACTIONS(6718),
    [anon_sym_BSLASHciteR] = ACTIONS(6718),
    [anon_sym_BSLASHciteS] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6718),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteyear] = ACTIONS(6718),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitedate] = ACTIONS(6718),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteurl] = ACTIONS(6718),
    [anon_sym_BSLASHfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6718),
    [anon_sym_BSLASHcitealt] = ACTIONS(6718),
    [anon_sym_BSLASHcitealp] = ACTIONS(6718),
    [anon_sym_BSLASHcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHparencite] = ACTIONS(6718),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHParencite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHtextcite] = ACTIONS(6718),
    [anon_sym_BSLASHTextcite] = ACTIONS(6718),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHsupercite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite] = ACTIONS(6718),
    [anon_sym_BSLASHAutocite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHVolcite] = ACTIONS(6718),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHavolcite] = ACTIONS(6718),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHNotecite] = ACTIONS(6718),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHlabel] = ACTIONS(6718),
    [anon_sym_BSLASHref] = ACTIONS(6718),
    [anon_sym_BSLASHeqref] = ACTIONS(6718),
    [anon_sym_BSLASHvref] = ACTIONS(6718),
    [anon_sym_BSLASHVref] = ACTIONS(6718),
    [anon_sym_BSLASHautoref] = ACTIONS(6718),
    [anon_sym_BSLASHpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcref] = ACTIONS(6718),
    [anon_sym_BSLASHCref] = ACTIONS(6718),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnameCref] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHdef] = ACTIONS(6718),
    [anon_sym_BSLASHlet] = ACTIONS(6718),
    [anon_sym_BSLASHleft] = ACTIONS(6718),
    [anon_sym_BSLASHbigl] = ACTIONS(6718),
    [anon_sym_BSLASHBigl] = ACTIONS(6718),
    [anon_sym_BSLASHbiggl] = ACTIONS(6718),
    [anon_sym_BSLASHBiggl] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6718),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6718),
    [anon_sym_BSLASHgls] = ACTIONS(6718),
    [anon_sym_BSLASHGls] = ACTIONS(6718),
    [anon_sym_BSLASHGLS] = ACTIONS(6718),
    [anon_sym_BSLASHglspl] = ACTIONS(6718),
    [anon_sym_BSLASHGlspl] = ACTIONS(6718),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6718),
    [anon_sym_BSLASHglslink] = ACTIONS(6718),
    [anon_sym_BSLASHglstext] = ACTIONS(6718),
    [anon_sym_BSLASHGlstext] = ACTIONS(6718),
    [anon_sym_BSLASHGLStext] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6718),
    [anon_sym_BSLASHglsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsname] = ACTIONS(6718),
    [anon_sym_BSLASHGlsname] = ACTIONS(6718),
    [anon_sym_BSLASHGLSname] = ACTIONS(6718),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6718),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6718),
    [anon_sym_BSLASHacrshort] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6718),
    [anon_sym_BSLASHACRshort] = ACTIONS(6718),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrlong] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6718),
    [anon_sym_BSLASHACRlong] = ACTIONS(6718),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrfull] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6718),
    [anon_sym_BSLASHACRfull] = ACTIONS(6718),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHacs] = ACTIONS(6718),
    [anon_sym_BSLASHAcs] = ACTIONS(6718),
    [anon_sym_BSLASHacsp] = ACTIONS(6718),
    [anon_sym_BSLASHAcsp] = ACTIONS(6718),
    [anon_sym_BSLASHacl] = ACTIONS(6718),
    [anon_sym_BSLASHAcl] = ACTIONS(6718),
    [anon_sym_BSLASHaclp] = ACTIONS(6718),
    [anon_sym_BSLASHAclp] = ACTIONS(6718),
    [anon_sym_BSLASHacf] = ACTIONS(6718),
    [anon_sym_BSLASHAcf] = ACTIONS(6718),
    [anon_sym_BSLASHacfp] = ACTIONS(6718),
    [anon_sym_BSLASHAcfp] = ACTIONS(6718),
    [anon_sym_BSLASHac] = ACTIONS(6718),
    [anon_sym_BSLASHAc] = ACTIONS(6718),
    [anon_sym_BSLASHacp] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6718),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6718),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6718),
    [anon_sym_BSLASHcolor] = ACTIONS(6718),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6718),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6718),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6718),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6718),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6718),
    [anon_sym_BSLASHtext] = ACTIONS(6718),
    [anon_sym_BSLASHintertext] = ACTIONS(6718),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6718),
    [anon_sym_BSLASHurl] = ACTIONS(6718),
    [anon_sym_BSLASHhref] = ACTIONS(6718),
  },
  [1578] = {
    [sym_command_name] = ACTIONS(6714),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6714),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_RBRACK] = ACTIONS(6716),
    [anon_sym_COMMA] = ACTIONS(6716),
    [anon_sym_EQ] = ACTIONS(6716),
    [anon_sym_LPAREN] = ACTIONS(6716),
    [anon_sym_RPAREN] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(6716),
    [sym_word] = ACTIONS(6714),
    [sym_placeholder] = ACTIONS(6716),
    [anon_sym_PLUS] = ACTIONS(6716),
    [anon_sym_DASH] = ACTIONS(6716),
    [anon_sym_STAR] = ACTIONS(6716),
    [anon_sym_SLASH] = ACTIONS(6716),
    [anon_sym_LT] = ACTIONS(6714),
    [anon_sym_GT] = ACTIONS(6714),
    [anon_sym_BANG] = ACTIONS(6714),
    [anon_sym_PIPE] = ACTIONS(6714),
    [anon_sym_COLON] = ACTIONS(6714),
    [anon_sym_SQUOTE] = ACTIONS(6714),
    [anon_sym__] = ACTIONS(6716),
    [anon_sym_CARET] = ACTIONS(6716),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6716),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6716),
    [anon_sym_DOLLAR] = ACTIONS(6714),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHbegin] = ACTIONS(6714),
    [anon_sym_BSLASHend] = ACTIONS(6714),
    [anon_sym_BSLASHtitle] = ACTIONS(6714),
    [anon_sym_BSLASHauthor] = ACTIONS(6714),
    [anon_sym_BSLASHusepackage] = ACTIONS(6714),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6714),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6714),
    [anon_sym_BSLASHinclude] = ACTIONS(6714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6714),
    [anon_sym_BSLASHinput] = ACTIONS(6714),
    [anon_sym_BSLASHsubfile] = ACTIONS(6714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6714),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6714),
    [anon_sym_BSLASHbibliography] = ACTIONS(6714),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6714),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6714),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6714),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6714),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6714),
    [anon_sym_BSLASHimport] = ACTIONS(6714),
    [anon_sym_BSLASHsubimport] = ACTIONS(6714),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6714),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHcaption] = ACTIONS(6714),
    [anon_sym_BSLASHcite] = ACTIONS(6714),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCite] = ACTIONS(6714),
    [anon_sym_BSLASHnocite] = ACTIONS(6714),
    [anon_sym_BSLASHcitet] = ACTIONS(6714),
    [anon_sym_BSLASHcitep] = ACTIONS(6714),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteA] = ACTIONS(6714),
    [anon_sym_BSLASHciteR] = ACTIONS(6714),
    [anon_sym_BSLASHciteS] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6714),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteyear] = ACTIONS(6714),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitedate] = ACTIONS(6714),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteurl] = ACTIONS(6714),
    [anon_sym_BSLASHfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6714),
    [anon_sym_BSLASHcitealt] = ACTIONS(6714),
    [anon_sym_BSLASHcitealp] = ACTIONS(6714),
    [anon_sym_BSLASHcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHparencite] = ACTIONS(6714),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHParencite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHtextcite] = ACTIONS(6714),
    [anon_sym_BSLASHTextcite] = ACTIONS(6714),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHsupercite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite] = ACTIONS(6714),
    [anon_sym_BSLASHAutocite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHVolcite] = ACTIONS(6714),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHavolcite] = ACTIONS(6714),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHNotecite] = ACTIONS(6714),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHlabel] = ACTIONS(6714),
    [anon_sym_BSLASHref] = ACTIONS(6714),
    [anon_sym_BSLASHeqref] = ACTIONS(6714),
    [anon_sym_BSLASHvref] = ACTIONS(6714),
    [anon_sym_BSLASHVref] = ACTIONS(6714),
    [anon_sym_BSLASHautoref] = ACTIONS(6714),
    [anon_sym_BSLASHpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcref] = ACTIONS(6714),
    [anon_sym_BSLASHCref] = ACTIONS(6714),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnameCref] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHdef] = ACTIONS(6714),
    [anon_sym_BSLASHlet] = ACTIONS(6714),
    [anon_sym_BSLASHleft] = ACTIONS(6714),
    [anon_sym_BSLASHbigl] = ACTIONS(6714),
    [anon_sym_BSLASHBigl] = ACTIONS(6714),
    [anon_sym_BSLASHbiggl] = ACTIONS(6714),
    [anon_sym_BSLASHBiggl] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6714),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6714),
    [anon_sym_BSLASHgls] = ACTIONS(6714),
    [anon_sym_BSLASHGls] = ACTIONS(6714),
    [anon_sym_BSLASHGLS] = ACTIONS(6714),
    [anon_sym_BSLASHglspl] = ACTIONS(6714),
    [anon_sym_BSLASHGlspl] = ACTIONS(6714),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6714),
    [anon_sym_BSLASHglslink] = ACTIONS(6714),
    [anon_sym_BSLASHglstext] = ACTIONS(6714),
    [anon_sym_BSLASHGlstext] = ACTIONS(6714),
    [anon_sym_BSLASHGLStext] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6714),
    [anon_sym_BSLASHglsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsname] = ACTIONS(6714),
    [anon_sym_BSLASHGlsname] = ACTIONS(6714),
    [anon_sym_BSLASHGLSname] = ACTIONS(6714),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6714),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6714),
    [anon_sym_BSLASHacrshort] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6714),
    [anon_sym_BSLASHACRshort] = ACTIONS(6714),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrlong] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6714),
    [anon_sym_BSLASHACRlong] = ACTIONS(6714),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrfull] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6714),
    [anon_sym_BSLASHACRfull] = ACTIONS(6714),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHacs] = ACTIONS(6714),
    [anon_sym_BSLASHAcs] = ACTIONS(6714),
    [anon_sym_BSLASHacsp] = ACTIONS(6714),
    [anon_sym_BSLASHAcsp] = ACTIONS(6714),
    [anon_sym_BSLASHacl] = ACTIONS(6714),
    [anon_sym_BSLASHAcl] = ACTIONS(6714),
    [anon_sym_BSLASHaclp] = ACTIONS(6714),
    [anon_sym_BSLASHAclp] = ACTIONS(6714),
    [anon_sym_BSLASHacf] = ACTIONS(6714),
    [anon_sym_BSLASHAcf] = ACTIONS(6714),
    [anon_sym_BSLASHacfp] = ACTIONS(6714),
    [anon_sym_BSLASHAcfp] = ACTIONS(6714),
    [anon_sym_BSLASHac] = ACTIONS(6714),
    [anon_sym_BSLASHAc] = ACTIONS(6714),
    [anon_sym_BSLASHacp] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6714),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6714),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6714),
    [anon_sym_BSLASHcolor] = ACTIONS(6714),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6714),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6714),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6714),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6714),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6714),
    [anon_sym_BSLASHtext] = ACTIONS(6714),
    [anon_sym_BSLASHintertext] = ACTIONS(6714),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6714),
    [anon_sym_BSLASHurl] = ACTIONS(6714),
    [anon_sym_BSLASHhref] = ACTIONS(6714),
  },
  [1579] = {
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6444),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6444),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6444),
    [anon_sym_DOLLAR] = ACTIONS(6442),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHbegin] = ACTIONS(6442),
    [anon_sym_BSLASHend] = ACTIONS(6442),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHleft] = ACTIONS(6442),
    [anon_sym_BSLASHbigl] = ACTIONS(6442),
    [anon_sym_BSLASHBigl] = ACTIONS(6442),
    [anon_sym_BSLASHbiggl] = ACTIONS(6442),
    [anon_sym_BSLASHBiggl] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHtext] = ACTIONS(6442),
    [anon_sym_BSLASHintertext] = ACTIONS(6442),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [1580] = {
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6280),
    [anon_sym_RBRACK] = ACTIONS(6280),
    [anon_sym_COMMA] = ACTIONS(6280),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_RPAREN] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6280),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6280),
    [anon_sym_DOLLAR] = ACTIONS(6278),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHbegin] = ACTIONS(6278),
    [anon_sym_BSLASHend] = ACTIONS(6278),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHleft] = ACTIONS(6278),
    [anon_sym_BSLASHbigl] = ACTIONS(6278),
    [anon_sym_BSLASHBigl] = ACTIONS(6278),
    [anon_sym_BSLASHbiggl] = ACTIONS(6278),
    [anon_sym_BSLASHBiggl] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHtext] = ACTIONS(6278),
    [anon_sym_BSLASHintertext] = ACTIONS(6278),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [1581] = {
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6448),
    [anon_sym_RBRACK] = ACTIONS(6448),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(6448),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6448),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6448),
    [anon_sym_DOLLAR] = ACTIONS(6446),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHbegin] = ACTIONS(6446),
    [anon_sym_BSLASHend] = ACTIONS(6446),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHleft] = ACTIONS(6446),
    [anon_sym_BSLASHbigl] = ACTIONS(6446),
    [anon_sym_BSLASHBigl] = ACTIONS(6446),
    [anon_sym_BSLASHbiggl] = ACTIONS(6446),
    [anon_sym_BSLASHBiggl] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHtext] = ACTIONS(6446),
    [anon_sym_BSLASHintertext] = ACTIONS(6446),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [1582] = {
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(7142),
    [anon_sym_LBRACK] = ACTIONS(6160),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [anon_sym_RBRACE] = ACTIONS(6160),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6160),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(6156),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHleft] = ACTIONS(6156),
    [anon_sym_BSLASHbigl] = ACTIONS(6156),
    [anon_sym_BSLASHBigl] = ACTIONS(6156),
    [anon_sym_BSLASHbiggl] = ACTIONS(6156),
    [anon_sym_BSLASHBiggl] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHtext] = ACTIONS(6156),
    [anon_sym_BSLASHintertext] = ACTIONS(6156),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [1583] = {
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6436),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_EQ] = ACTIONS(6436),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6436),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6436),
    [anon_sym_DOLLAR] = ACTIONS(6434),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHbegin] = ACTIONS(6434),
    [anon_sym_BSLASHend] = ACTIONS(6434),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHleft] = ACTIONS(6434),
    [anon_sym_BSLASHbigl] = ACTIONS(6434),
    [anon_sym_BSLASHBigl] = ACTIONS(6434),
    [anon_sym_BSLASHbiggl] = ACTIONS(6434),
    [anon_sym_BSLASHBiggl] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHtext] = ACTIONS(6434),
    [anon_sym_BSLASHintertext] = ACTIONS(6434),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [1584] = {
    [sym_command_name] = ACTIONS(6670),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6670),
    [anon_sym_LBRACK] = ACTIONS(6672),
    [anon_sym_RBRACK] = ACTIONS(6672),
    [anon_sym_COMMA] = ACTIONS(6672),
    [anon_sym_EQ] = ACTIONS(6672),
    [anon_sym_LPAREN] = ACTIONS(6672),
    [anon_sym_RPAREN] = ACTIONS(6672),
    [anon_sym_LBRACE] = ACTIONS(6672),
    [sym_word] = ACTIONS(6670),
    [sym_placeholder] = ACTIONS(6672),
    [anon_sym_PLUS] = ACTIONS(6672),
    [anon_sym_DASH] = ACTIONS(6672),
    [anon_sym_STAR] = ACTIONS(6672),
    [anon_sym_SLASH] = ACTIONS(6672),
    [anon_sym_LT] = ACTIONS(6670),
    [anon_sym_GT] = ACTIONS(6670),
    [anon_sym_BANG] = ACTIONS(6670),
    [anon_sym_PIPE] = ACTIONS(6670),
    [anon_sym_COLON] = ACTIONS(6670),
    [anon_sym_SQUOTE] = ACTIONS(6670),
    [anon_sym__] = ACTIONS(6672),
    [anon_sym_CARET] = ACTIONS(6672),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6672),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6672),
    [anon_sym_DOLLAR] = ACTIONS(6670),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHbegin] = ACTIONS(6670),
    [anon_sym_BSLASHend] = ACTIONS(6670),
    [anon_sym_BSLASHtitle] = ACTIONS(6670),
    [anon_sym_BSLASHauthor] = ACTIONS(6670),
    [anon_sym_BSLASHusepackage] = ACTIONS(6670),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6670),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6670),
    [anon_sym_BSLASHinclude] = ACTIONS(6670),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6670),
    [anon_sym_BSLASHinput] = ACTIONS(6670),
    [anon_sym_BSLASHsubfile] = ACTIONS(6670),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6670),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6670),
    [anon_sym_BSLASHbibliography] = ACTIONS(6670),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6670),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6670),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6670),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6670),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6670),
    [anon_sym_BSLASHimport] = ACTIONS(6670),
    [anon_sym_BSLASHsubimport] = ACTIONS(6670),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6670),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHcaption] = ACTIONS(6670),
    [anon_sym_BSLASHcite] = ACTIONS(6670),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCite] = ACTIONS(6670),
    [anon_sym_BSLASHnocite] = ACTIONS(6670),
    [anon_sym_BSLASHcitet] = ACTIONS(6670),
    [anon_sym_BSLASHcitep] = ACTIONS(6670),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteA] = ACTIONS(6670),
    [anon_sym_BSLASHciteR] = ACTIONS(6670),
    [anon_sym_BSLASHciteS] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6670),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteyear] = ACTIONS(6670),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitedate] = ACTIONS(6670),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteurl] = ACTIONS(6670),
    [anon_sym_BSLASHfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6670),
    [anon_sym_BSLASHcitealt] = ACTIONS(6670),
    [anon_sym_BSLASHcitealp] = ACTIONS(6670),
    [anon_sym_BSLASHcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHparencite] = ACTIONS(6670),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHParencite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHtextcite] = ACTIONS(6670),
    [anon_sym_BSLASHTextcite] = ACTIONS(6670),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHsupercite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite] = ACTIONS(6670),
    [anon_sym_BSLASHAutocite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHVolcite] = ACTIONS(6670),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHavolcite] = ACTIONS(6670),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHNotecite] = ACTIONS(6670),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHlabel] = ACTIONS(6670),
    [anon_sym_BSLASHref] = ACTIONS(6670),
    [anon_sym_BSLASHeqref] = ACTIONS(6670),
    [anon_sym_BSLASHvref] = ACTIONS(6670),
    [anon_sym_BSLASHVref] = ACTIONS(6670),
    [anon_sym_BSLASHautoref] = ACTIONS(6670),
    [anon_sym_BSLASHpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcref] = ACTIONS(6670),
    [anon_sym_BSLASHCref] = ACTIONS(6670),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnameCref] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHdef] = ACTIONS(6670),
    [anon_sym_BSLASHlet] = ACTIONS(6670),
    [anon_sym_BSLASHleft] = ACTIONS(6670),
    [anon_sym_BSLASHbigl] = ACTIONS(6670),
    [anon_sym_BSLASHBigl] = ACTIONS(6670),
    [anon_sym_BSLASHbiggl] = ACTIONS(6670),
    [anon_sym_BSLASHBiggl] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6670),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6670),
    [anon_sym_BSLASHgls] = ACTIONS(6670),
    [anon_sym_BSLASHGls] = ACTIONS(6670),
    [anon_sym_BSLASHGLS] = ACTIONS(6670),
    [anon_sym_BSLASHglspl] = ACTIONS(6670),
    [anon_sym_BSLASHGlspl] = ACTIONS(6670),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6670),
    [anon_sym_BSLASHglslink] = ACTIONS(6670),
    [anon_sym_BSLASHglstext] = ACTIONS(6670),
    [anon_sym_BSLASHGlstext] = ACTIONS(6670),
    [anon_sym_BSLASHGLStext] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6670),
    [anon_sym_BSLASHglsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsname] = ACTIONS(6670),
    [anon_sym_BSLASHGlsname] = ACTIONS(6670),
    [anon_sym_BSLASHGLSname] = ACTIONS(6670),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6670),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6670),
    [anon_sym_BSLASHacrshort] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6670),
    [anon_sym_BSLASHACRshort] = ACTIONS(6670),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrlong] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6670),
    [anon_sym_BSLASHACRlong] = ACTIONS(6670),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrfull] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6670),
    [anon_sym_BSLASHACRfull] = ACTIONS(6670),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHacs] = ACTIONS(6670),
    [anon_sym_BSLASHAcs] = ACTIONS(6670),
    [anon_sym_BSLASHacsp] = ACTIONS(6670),
    [anon_sym_BSLASHAcsp] = ACTIONS(6670),
    [anon_sym_BSLASHacl] = ACTIONS(6670),
    [anon_sym_BSLASHAcl] = ACTIONS(6670),
    [anon_sym_BSLASHaclp] = ACTIONS(6670),
    [anon_sym_BSLASHAclp] = ACTIONS(6670),
    [anon_sym_BSLASHacf] = ACTIONS(6670),
    [anon_sym_BSLASHAcf] = ACTIONS(6670),
    [anon_sym_BSLASHacfp] = ACTIONS(6670),
    [anon_sym_BSLASHAcfp] = ACTIONS(6670),
    [anon_sym_BSLASHac] = ACTIONS(6670),
    [anon_sym_BSLASHAc] = ACTIONS(6670),
    [anon_sym_BSLASHacp] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6670),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6670),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6670),
    [anon_sym_BSLASHcolor] = ACTIONS(6670),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6670),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6670),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6670),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6670),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6670),
    [anon_sym_BSLASHtext] = ACTIONS(6670),
    [anon_sym_BSLASHintertext] = ACTIONS(6670),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6670),
    [anon_sym_BSLASHurl] = ACTIONS(6670),
    [anon_sym_BSLASHhref] = ACTIONS(6670),
  },
  [1585] = {
    [sym_command_name] = ACTIONS(6682),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6684),
    [anon_sym_RBRACK] = ACTIONS(6684),
    [anon_sym_COMMA] = ACTIONS(6684),
    [anon_sym_EQ] = ACTIONS(6684),
    [anon_sym_LPAREN] = ACTIONS(6684),
    [anon_sym_RPAREN] = ACTIONS(6684),
    [anon_sym_LBRACE] = ACTIONS(6684),
    [sym_word] = ACTIONS(6682),
    [sym_placeholder] = ACTIONS(6684),
    [anon_sym_PLUS] = ACTIONS(6684),
    [anon_sym_DASH] = ACTIONS(6684),
    [anon_sym_STAR] = ACTIONS(6684),
    [anon_sym_SLASH] = ACTIONS(6684),
    [anon_sym_LT] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6682),
    [anon_sym_BANG] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6682),
    [anon_sym_COLON] = ACTIONS(6682),
    [anon_sym_SQUOTE] = ACTIONS(6682),
    [anon_sym__] = ACTIONS(6684),
    [anon_sym_CARET] = ACTIONS(6684),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6684),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6684),
    [anon_sym_DOLLAR] = ACTIONS(6682),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHbegin] = ACTIONS(6682),
    [anon_sym_BSLASHend] = ACTIONS(6682),
    [anon_sym_BSLASHtitle] = ACTIONS(6682),
    [anon_sym_BSLASHauthor] = ACTIONS(6682),
    [anon_sym_BSLASHusepackage] = ACTIONS(6682),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6682),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6682),
    [anon_sym_BSLASHinclude] = ACTIONS(6682),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6682),
    [anon_sym_BSLASHinput] = ACTIONS(6682),
    [anon_sym_BSLASHsubfile] = ACTIONS(6682),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6682),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6682),
    [anon_sym_BSLASHbibliography] = ACTIONS(6682),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6682),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6682),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6682),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6682),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6682),
    [anon_sym_BSLASHimport] = ACTIONS(6682),
    [anon_sym_BSLASHsubimport] = ACTIONS(6682),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6682),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHcaption] = ACTIONS(6682),
    [anon_sym_BSLASHcite] = ACTIONS(6682),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCite] = ACTIONS(6682),
    [anon_sym_BSLASHnocite] = ACTIONS(6682),
    [anon_sym_BSLASHcitet] = ACTIONS(6682),
    [anon_sym_BSLASHcitep] = ACTIONS(6682),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteA] = ACTIONS(6682),
    [anon_sym_BSLASHciteR] = ACTIONS(6682),
    [anon_sym_BSLASHciteS] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6682),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteyear] = ACTIONS(6682),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitedate] = ACTIONS(6682),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteurl] = ACTIONS(6682),
    [anon_sym_BSLASHfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6682),
    [anon_sym_BSLASHcitealt] = ACTIONS(6682),
    [anon_sym_BSLASHcitealp] = ACTIONS(6682),
    [anon_sym_BSLASHcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHparencite] = ACTIONS(6682),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHParencite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHtextcite] = ACTIONS(6682),
    [anon_sym_BSLASHTextcite] = ACTIONS(6682),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHsupercite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite] = ACTIONS(6682),
    [anon_sym_BSLASHAutocite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHVolcite] = ACTIONS(6682),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHavolcite] = ACTIONS(6682),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHNotecite] = ACTIONS(6682),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHlabel] = ACTIONS(6682),
    [anon_sym_BSLASHref] = ACTIONS(6682),
    [anon_sym_BSLASHeqref] = ACTIONS(6682),
    [anon_sym_BSLASHvref] = ACTIONS(6682),
    [anon_sym_BSLASHVref] = ACTIONS(6682),
    [anon_sym_BSLASHautoref] = ACTIONS(6682),
    [anon_sym_BSLASHpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcref] = ACTIONS(6682),
    [anon_sym_BSLASHCref] = ACTIONS(6682),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnameCref] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHdef] = ACTIONS(6682),
    [anon_sym_BSLASHlet] = ACTIONS(6682),
    [anon_sym_BSLASHleft] = ACTIONS(6682),
    [anon_sym_BSLASHbigl] = ACTIONS(6682),
    [anon_sym_BSLASHBigl] = ACTIONS(6682),
    [anon_sym_BSLASHbiggl] = ACTIONS(6682),
    [anon_sym_BSLASHBiggl] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6682),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6682),
    [anon_sym_BSLASHgls] = ACTIONS(6682),
    [anon_sym_BSLASHGls] = ACTIONS(6682),
    [anon_sym_BSLASHGLS] = ACTIONS(6682),
    [anon_sym_BSLASHglspl] = ACTIONS(6682),
    [anon_sym_BSLASHGlspl] = ACTIONS(6682),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6682),
    [anon_sym_BSLASHglslink] = ACTIONS(6682),
    [anon_sym_BSLASHglstext] = ACTIONS(6682),
    [anon_sym_BSLASHGlstext] = ACTIONS(6682),
    [anon_sym_BSLASHGLStext] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6682),
    [anon_sym_BSLASHglsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsname] = ACTIONS(6682),
    [anon_sym_BSLASHGlsname] = ACTIONS(6682),
    [anon_sym_BSLASHGLSname] = ACTIONS(6682),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6682),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6682),
    [anon_sym_BSLASHacrshort] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6682),
    [anon_sym_BSLASHACRshort] = ACTIONS(6682),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrlong] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6682),
    [anon_sym_BSLASHACRlong] = ACTIONS(6682),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrfull] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6682),
    [anon_sym_BSLASHACRfull] = ACTIONS(6682),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHacs] = ACTIONS(6682),
    [anon_sym_BSLASHAcs] = ACTIONS(6682),
    [anon_sym_BSLASHacsp] = ACTIONS(6682),
    [anon_sym_BSLASHAcsp] = ACTIONS(6682),
    [anon_sym_BSLASHacl] = ACTIONS(6682),
    [anon_sym_BSLASHAcl] = ACTIONS(6682),
    [anon_sym_BSLASHaclp] = ACTIONS(6682),
    [anon_sym_BSLASHAclp] = ACTIONS(6682),
    [anon_sym_BSLASHacf] = ACTIONS(6682),
    [anon_sym_BSLASHAcf] = ACTIONS(6682),
    [anon_sym_BSLASHacfp] = ACTIONS(6682),
    [anon_sym_BSLASHAcfp] = ACTIONS(6682),
    [anon_sym_BSLASHac] = ACTIONS(6682),
    [anon_sym_BSLASHAc] = ACTIONS(6682),
    [anon_sym_BSLASHacp] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6682),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6682),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6682),
    [anon_sym_BSLASHcolor] = ACTIONS(6682),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6682),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6682),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6682),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6682),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6682),
    [anon_sym_BSLASHtext] = ACTIONS(6682),
    [anon_sym_BSLASHintertext] = ACTIONS(6682),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6682),
    [anon_sym_BSLASHurl] = ACTIONS(6682),
    [anon_sym_BSLASHhref] = ACTIONS(6682),
  },
  [1586] = {
    [sym_command_name] = ACTIONS(6678),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6678),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6680),
    [anon_sym_COMMA] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LPAREN] = ACTIONS(6680),
    [anon_sym_RPAREN] = ACTIONS(6680),
    [anon_sym_LBRACE] = ACTIONS(6680),
    [sym_word] = ACTIONS(6678),
    [sym_placeholder] = ACTIONS(6680),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_DASH] = ACTIONS(6680),
    [anon_sym_STAR] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6678),
    [anon_sym_GT] = ACTIONS(6678),
    [anon_sym_BANG] = ACTIONS(6678),
    [anon_sym_PIPE] = ACTIONS(6678),
    [anon_sym_COLON] = ACTIONS(6678),
    [anon_sym_SQUOTE] = ACTIONS(6678),
    [anon_sym__] = ACTIONS(6680),
    [anon_sym_CARET] = ACTIONS(6680),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6680),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6680),
    [anon_sym_DOLLAR] = ACTIONS(6678),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHbegin] = ACTIONS(6678),
    [anon_sym_BSLASHend] = ACTIONS(6678),
    [anon_sym_BSLASHtitle] = ACTIONS(6678),
    [anon_sym_BSLASHauthor] = ACTIONS(6678),
    [anon_sym_BSLASHusepackage] = ACTIONS(6678),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6678),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6678),
    [anon_sym_BSLASHinclude] = ACTIONS(6678),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6678),
    [anon_sym_BSLASHinput] = ACTIONS(6678),
    [anon_sym_BSLASHsubfile] = ACTIONS(6678),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6678),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6678),
    [anon_sym_BSLASHbibliography] = ACTIONS(6678),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6678),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6678),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6678),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6678),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6678),
    [anon_sym_BSLASHimport] = ACTIONS(6678),
    [anon_sym_BSLASHsubimport] = ACTIONS(6678),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6678),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHcaption] = ACTIONS(6678),
    [anon_sym_BSLASHcite] = ACTIONS(6678),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCite] = ACTIONS(6678),
    [anon_sym_BSLASHnocite] = ACTIONS(6678),
    [anon_sym_BSLASHcitet] = ACTIONS(6678),
    [anon_sym_BSLASHcitep] = ACTIONS(6678),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteA] = ACTIONS(6678),
    [anon_sym_BSLASHciteR] = ACTIONS(6678),
    [anon_sym_BSLASHciteS] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6678),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteyear] = ACTIONS(6678),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitedate] = ACTIONS(6678),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteurl] = ACTIONS(6678),
    [anon_sym_BSLASHfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6678),
    [anon_sym_BSLASHcitealt] = ACTIONS(6678),
    [anon_sym_BSLASHcitealp] = ACTIONS(6678),
    [anon_sym_BSLASHcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHparencite] = ACTIONS(6678),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHParencite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHtextcite] = ACTIONS(6678),
    [anon_sym_BSLASHTextcite] = ACTIONS(6678),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHsupercite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite] = ACTIONS(6678),
    [anon_sym_BSLASHAutocite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHVolcite] = ACTIONS(6678),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHavolcite] = ACTIONS(6678),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHNotecite] = ACTIONS(6678),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHlabel] = ACTIONS(6678),
    [anon_sym_BSLASHref] = ACTIONS(6678),
    [anon_sym_BSLASHeqref] = ACTIONS(6678),
    [anon_sym_BSLASHvref] = ACTIONS(6678),
    [anon_sym_BSLASHVref] = ACTIONS(6678),
    [anon_sym_BSLASHautoref] = ACTIONS(6678),
    [anon_sym_BSLASHpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcref] = ACTIONS(6678),
    [anon_sym_BSLASHCref] = ACTIONS(6678),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnameCref] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHdef] = ACTIONS(6678),
    [anon_sym_BSLASHlet] = ACTIONS(6678),
    [anon_sym_BSLASHleft] = ACTIONS(6678),
    [anon_sym_BSLASHbigl] = ACTIONS(6678),
    [anon_sym_BSLASHBigl] = ACTIONS(6678),
    [anon_sym_BSLASHbiggl] = ACTIONS(6678),
    [anon_sym_BSLASHBiggl] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6678),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6678),
    [anon_sym_BSLASHgls] = ACTIONS(6678),
    [anon_sym_BSLASHGls] = ACTIONS(6678),
    [anon_sym_BSLASHGLS] = ACTIONS(6678),
    [anon_sym_BSLASHglspl] = ACTIONS(6678),
    [anon_sym_BSLASHGlspl] = ACTIONS(6678),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6678),
    [anon_sym_BSLASHglslink] = ACTIONS(6678),
    [anon_sym_BSLASHglstext] = ACTIONS(6678),
    [anon_sym_BSLASHGlstext] = ACTIONS(6678),
    [anon_sym_BSLASHGLStext] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6678),
    [anon_sym_BSLASHglsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsname] = ACTIONS(6678),
    [anon_sym_BSLASHGlsname] = ACTIONS(6678),
    [anon_sym_BSLASHGLSname] = ACTIONS(6678),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6678),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6678),
    [anon_sym_BSLASHacrshort] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6678),
    [anon_sym_BSLASHACRshort] = ACTIONS(6678),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrlong] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6678),
    [anon_sym_BSLASHACRlong] = ACTIONS(6678),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrfull] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6678),
    [anon_sym_BSLASHACRfull] = ACTIONS(6678),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHacs] = ACTIONS(6678),
    [anon_sym_BSLASHAcs] = ACTIONS(6678),
    [anon_sym_BSLASHacsp] = ACTIONS(6678),
    [anon_sym_BSLASHAcsp] = ACTIONS(6678),
    [anon_sym_BSLASHacl] = ACTIONS(6678),
    [anon_sym_BSLASHAcl] = ACTIONS(6678),
    [anon_sym_BSLASHaclp] = ACTIONS(6678),
    [anon_sym_BSLASHAclp] = ACTIONS(6678),
    [anon_sym_BSLASHacf] = ACTIONS(6678),
    [anon_sym_BSLASHAcf] = ACTIONS(6678),
    [anon_sym_BSLASHacfp] = ACTIONS(6678),
    [anon_sym_BSLASHAcfp] = ACTIONS(6678),
    [anon_sym_BSLASHac] = ACTIONS(6678),
    [anon_sym_BSLASHAc] = ACTIONS(6678),
    [anon_sym_BSLASHacp] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6678),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6678),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6678),
    [anon_sym_BSLASHcolor] = ACTIONS(6678),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6678),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6678),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6678),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6678),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6678),
    [anon_sym_BSLASHtext] = ACTIONS(6678),
    [anon_sym_BSLASHintertext] = ACTIONS(6678),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6678),
    [anon_sym_BSLASHurl] = ACTIONS(6678),
    [anon_sym_BSLASHhref] = ACTIONS(6678),
  },
  [1587] = {
    [sym_command_name] = ACTIONS(6674),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6674),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_RBRACK] = ACTIONS(6676),
    [anon_sym_COMMA] = ACTIONS(6676),
    [anon_sym_EQ] = ACTIONS(6676),
    [anon_sym_LPAREN] = ACTIONS(6676),
    [anon_sym_RPAREN] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(6676),
    [sym_word] = ACTIONS(6674),
    [sym_placeholder] = ACTIONS(6676),
    [anon_sym_PLUS] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6676),
    [anon_sym_STAR] = ACTIONS(6676),
    [anon_sym_SLASH] = ACTIONS(6676),
    [anon_sym_LT] = ACTIONS(6674),
    [anon_sym_GT] = ACTIONS(6674),
    [anon_sym_BANG] = ACTIONS(6674),
    [anon_sym_PIPE] = ACTIONS(6674),
    [anon_sym_COLON] = ACTIONS(6674),
    [anon_sym_SQUOTE] = ACTIONS(6674),
    [anon_sym__] = ACTIONS(6676),
    [anon_sym_CARET] = ACTIONS(6676),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6676),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6676),
    [anon_sym_DOLLAR] = ACTIONS(6674),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHbegin] = ACTIONS(6674),
    [anon_sym_BSLASHend] = ACTIONS(6674),
    [anon_sym_BSLASHtitle] = ACTIONS(6674),
    [anon_sym_BSLASHauthor] = ACTIONS(6674),
    [anon_sym_BSLASHusepackage] = ACTIONS(6674),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6674),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6674),
    [anon_sym_BSLASHinclude] = ACTIONS(6674),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6674),
    [anon_sym_BSLASHinput] = ACTIONS(6674),
    [anon_sym_BSLASHsubfile] = ACTIONS(6674),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6674),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6674),
    [anon_sym_BSLASHbibliography] = ACTIONS(6674),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6674),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6674),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6674),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6674),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6674),
    [anon_sym_BSLASHimport] = ACTIONS(6674),
    [anon_sym_BSLASHsubimport] = ACTIONS(6674),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6674),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHcaption] = ACTIONS(6674),
    [anon_sym_BSLASHcite] = ACTIONS(6674),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCite] = ACTIONS(6674),
    [anon_sym_BSLASHnocite] = ACTIONS(6674),
    [anon_sym_BSLASHcitet] = ACTIONS(6674),
    [anon_sym_BSLASHcitep] = ACTIONS(6674),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteA] = ACTIONS(6674),
    [anon_sym_BSLASHciteR] = ACTIONS(6674),
    [anon_sym_BSLASHciteS] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6674),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteyear] = ACTIONS(6674),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitedate] = ACTIONS(6674),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteurl] = ACTIONS(6674),
    [anon_sym_BSLASHfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6674),
    [anon_sym_BSLASHcitealt] = ACTIONS(6674),
    [anon_sym_BSLASHcitealp] = ACTIONS(6674),
    [anon_sym_BSLASHcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHparencite] = ACTIONS(6674),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHParencite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHtextcite] = ACTIONS(6674),
    [anon_sym_BSLASHTextcite] = ACTIONS(6674),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHsupercite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite] = ACTIONS(6674),
    [anon_sym_BSLASHAutocite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHVolcite] = ACTIONS(6674),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHavolcite] = ACTIONS(6674),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHNotecite] = ACTIONS(6674),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHlabel] = ACTIONS(6674),
    [anon_sym_BSLASHref] = ACTIONS(6674),
    [anon_sym_BSLASHeqref] = ACTIONS(6674),
    [anon_sym_BSLASHvref] = ACTIONS(6674),
    [anon_sym_BSLASHVref] = ACTIONS(6674),
    [anon_sym_BSLASHautoref] = ACTIONS(6674),
    [anon_sym_BSLASHpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcref] = ACTIONS(6674),
    [anon_sym_BSLASHCref] = ACTIONS(6674),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnameCref] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHdef] = ACTIONS(6674),
    [anon_sym_BSLASHlet] = ACTIONS(6674),
    [anon_sym_BSLASHleft] = ACTIONS(6674),
    [anon_sym_BSLASHbigl] = ACTIONS(6674),
    [anon_sym_BSLASHBigl] = ACTIONS(6674),
    [anon_sym_BSLASHbiggl] = ACTIONS(6674),
    [anon_sym_BSLASHBiggl] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6674),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6674),
    [anon_sym_BSLASHgls] = ACTIONS(6674),
    [anon_sym_BSLASHGls] = ACTIONS(6674),
    [anon_sym_BSLASHGLS] = ACTIONS(6674),
    [anon_sym_BSLASHglspl] = ACTIONS(6674),
    [anon_sym_BSLASHGlspl] = ACTIONS(6674),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6674),
    [anon_sym_BSLASHglslink] = ACTIONS(6674),
    [anon_sym_BSLASHglstext] = ACTIONS(6674),
    [anon_sym_BSLASHGlstext] = ACTIONS(6674),
    [anon_sym_BSLASHGLStext] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6674),
    [anon_sym_BSLASHglsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsname] = ACTIONS(6674),
    [anon_sym_BSLASHGlsname] = ACTIONS(6674),
    [anon_sym_BSLASHGLSname] = ACTIONS(6674),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6674),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6674),
    [anon_sym_BSLASHacrshort] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6674),
    [anon_sym_BSLASHACRshort] = ACTIONS(6674),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrlong] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6674),
    [anon_sym_BSLASHACRlong] = ACTIONS(6674),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrfull] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6674),
    [anon_sym_BSLASHACRfull] = ACTIONS(6674),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHacs] = ACTIONS(6674),
    [anon_sym_BSLASHAcs] = ACTIONS(6674),
    [anon_sym_BSLASHacsp] = ACTIONS(6674),
    [anon_sym_BSLASHAcsp] = ACTIONS(6674),
    [anon_sym_BSLASHacl] = ACTIONS(6674),
    [anon_sym_BSLASHAcl] = ACTIONS(6674),
    [anon_sym_BSLASHaclp] = ACTIONS(6674),
    [anon_sym_BSLASHAclp] = ACTIONS(6674),
    [anon_sym_BSLASHacf] = ACTIONS(6674),
    [anon_sym_BSLASHAcf] = ACTIONS(6674),
    [anon_sym_BSLASHacfp] = ACTIONS(6674),
    [anon_sym_BSLASHAcfp] = ACTIONS(6674),
    [anon_sym_BSLASHac] = ACTIONS(6674),
    [anon_sym_BSLASHAc] = ACTIONS(6674),
    [anon_sym_BSLASHacp] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6674),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6674),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6674),
    [anon_sym_BSLASHcolor] = ACTIONS(6674),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6674),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6674),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6674),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6674),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6674),
    [anon_sym_BSLASHtext] = ACTIONS(6674),
    [anon_sym_BSLASHintertext] = ACTIONS(6674),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6674),
    [anon_sym_BSLASHurl] = ACTIONS(6674),
    [anon_sym_BSLASHhref] = ACTIONS(6674),
  },
  [1588] = {
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6224),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_LPAREN] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6224),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6224),
    [anon_sym_DOLLAR] = ACTIONS(6222),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHbegin] = ACTIONS(6222),
    [anon_sym_BSLASHend] = ACTIONS(6222),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHleft] = ACTIONS(6222),
    [anon_sym_BSLASHbigl] = ACTIONS(6222),
    [anon_sym_BSLASHBigl] = ACTIONS(6222),
    [anon_sym_BSLASHbiggl] = ACTIONS(6222),
    [anon_sym_BSLASHBiggl] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHtext] = ACTIONS(6222),
    [anon_sym_BSLASHintertext] = ACTIONS(6222),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [1589] = {
    [sym_brack_group_text] = STATE(1698),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(7144),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [anon_sym_LBRACE] = ACTIONS(6150),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6150),
    [anon_sym_DOLLAR] = ACTIONS(6148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHbegin] = ACTIONS(6148),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHleft] = ACTIONS(6148),
    [anon_sym_BSLASHbigl] = ACTIONS(6148),
    [anon_sym_BSLASHBigl] = ACTIONS(6148),
    [anon_sym_BSLASHbiggl] = ACTIONS(6148),
    [anon_sym_BSLASHBiggl] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHtext] = ACTIONS(6148),
    [anon_sym_BSLASHintertext] = ACTIONS(6148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [1590] = {
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6456),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(6454),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHbegin] = ACTIONS(6454),
    [anon_sym_BSLASHend] = ACTIONS(6454),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHleft] = ACTIONS(6454),
    [anon_sym_BSLASHbigl] = ACTIONS(6454),
    [anon_sym_BSLASHBigl] = ACTIONS(6454),
    [anon_sym_BSLASHbiggl] = ACTIONS(6454),
    [anon_sym_BSLASHBiggl] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHtext] = ACTIONS(6454),
    [anon_sym_BSLASHintertext] = ACTIONS(6454),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [1591] = {
    [sym_curly_group] = STATE(1718),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_LBRACK] = ACTIONS(6164),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(6164),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6164),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6164),
    [anon_sym_DOLLAR] = ACTIONS(6162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHleft] = ACTIONS(6162),
    [anon_sym_BSLASHbigl] = ACTIONS(6162),
    [anon_sym_BSLASHBigl] = ACTIONS(6162),
    [anon_sym_BSLASHbiggl] = ACTIONS(6162),
    [anon_sym_BSLASHBiggl] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHtext] = ACTIONS(6162),
    [anon_sym_BSLASHintertext] = ACTIONS(6162),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [1592] = {
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHend] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [1593] = {
    [sym_command_name] = ACTIONS(6662),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6662),
    [anon_sym_LBRACK] = ACTIONS(6664),
    [anon_sym_RBRACK] = ACTIONS(6664),
    [anon_sym_COMMA] = ACTIONS(6664),
    [anon_sym_EQ] = ACTIONS(6664),
    [anon_sym_LPAREN] = ACTIONS(6664),
    [anon_sym_RPAREN] = ACTIONS(6664),
    [anon_sym_LBRACE] = ACTIONS(6664),
    [sym_word] = ACTIONS(6662),
    [sym_placeholder] = ACTIONS(6664),
    [anon_sym_PLUS] = ACTIONS(6664),
    [anon_sym_DASH] = ACTIONS(6664),
    [anon_sym_STAR] = ACTIONS(6664),
    [anon_sym_SLASH] = ACTIONS(6664),
    [anon_sym_LT] = ACTIONS(6662),
    [anon_sym_GT] = ACTIONS(6662),
    [anon_sym_BANG] = ACTIONS(6662),
    [anon_sym_PIPE] = ACTIONS(6662),
    [anon_sym_COLON] = ACTIONS(6662),
    [anon_sym_SQUOTE] = ACTIONS(6662),
    [anon_sym__] = ACTIONS(6664),
    [anon_sym_CARET] = ACTIONS(6664),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6664),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6664),
    [anon_sym_DOLLAR] = ACTIONS(6662),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHbegin] = ACTIONS(6662),
    [anon_sym_BSLASHend] = ACTIONS(6662),
    [anon_sym_BSLASHtitle] = ACTIONS(6662),
    [anon_sym_BSLASHauthor] = ACTIONS(6662),
    [anon_sym_BSLASHusepackage] = ACTIONS(6662),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6662),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6662),
    [anon_sym_BSLASHinclude] = ACTIONS(6662),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6662),
    [anon_sym_BSLASHinput] = ACTIONS(6662),
    [anon_sym_BSLASHsubfile] = ACTIONS(6662),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6662),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6662),
    [anon_sym_BSLASHbibliography] = ACTIONS(6662),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6662),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6662),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6662),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6662),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6662),
    [anon_sym_BSLASHimport] = ACTIONS(6662),
    [anon_sym_BSLASHsubimport] = ACTIONS(6662),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6662),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHcaption] = ACTIONS(6662),
    [anon_sym_BSLASHcite] = ACTIONS(6662),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCite] = ACTIONS(6662),
    [anon_sym_BSLASHnocite] = ACTIONS(6662),
    [anon_sym_BSLASHcitet] = ACTIONS(6662),
    [anon_sym_BSLASHcitep] = ACTIONS(6662),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteA] = ACTIONS(6662),
    [anon_sym_BSLASHciteR] = ACTIONS(6662),
    [anon_sym_BSLASHciteS] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6662),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteyear] = ACTIONS(6662),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitedate] = ACTIONS(6662),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteurl] = ACTIONS(6662),
    [anon_sym_BSLASHfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6662),
    [anon_sym_BSLASHcitealt] = ACTIONS(6662),
    [anon_sym_BSLASHcitealp] = ACTIONS(6662),
    [anon_sym_BSLASHcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHparencite] = ACTIONS(6662),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHParencite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHtextcite] = ACTIONS(6662),
    [anon_sym_BSLASHTextcite] = ACTIONS(6662),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHsupercite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite] = ACTIONS(6662),
    [anon_sym_BSLASHAutocite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHVolcite] = ACTIONS(6662),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHavolcite] = ACTIONS(6662),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHNotecite] = ACTIONS(6662),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHlabel] = ACTIONS(6662),
    [anon_sym_BSLASHref] = ACTIONS(6662),
    [anon_sym_BSLASHeqref] = ACTIONS(6662),
    [anon_sym_BSLASHvref] = ACTIONS(6662),
    [anon_sym_BSLASHVref] = ACTIONS(6662),
    [anon_sym_BSLASHautoref] = ACTIONS(6662),
    [anon_sym_BSLASHpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcref] = ACTIONS(6662),
    [anon_sym_BSLASHCref] = ACTIONS(6662),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnameCref] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHdef] = ACTIONS(6662),
    [anon_sym_BSLASHlet] = ACTIONS(6662),
    [anon_sym_BSLASHleft] = ACTIONS(6662),
    [anon_sym_BSLASHbigl] = ACTIONS(6662),
    [anon_sym_BSLASHBigl] = ACTIONS(6662),
    [anon_sym_BSLASHbiggl] = ACTIONS(6662),
    [anon_sym_BSLASHBiggl] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6662),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6662),
    [anon_sym_BSLASHgls] = ACTIONS(6662),
    [anon_sym_BSLASHGls] = ACTIONS(6662),
    [anon_sym_BSLASHGLS] = ACTIONS(6662),
    [anon_sym_BSLASHglspl] = ACTIONS(6662),
    [anon_sym_BSLASHGlspl] = ACTIONS(6662),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6662),
    [anon_sym_BSLASHglslink] = ACTIONS(6662),
    [anon_sym_BSLASHglstext] = ACTIONS(6662),
    [anon_sym_BSLASHGlstext] = ACTIONS(6662),
    [anon_sym_BSLASHGLStext] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6662),
    [anon_sym_BSLASHglsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsname] = ACTIONS(6662),
    [anon_sym_BSLASHGlsname] = ACTIONS(6662),
    [anon_sym_BSLASHGLSname] = ACTIONS(6662),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6662),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6662),
    [anon_sym_BSLASHacrshort] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6662),
    [anon_sym_BSLASHACRshort] = ACTIONS(6662),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrlong] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6662),
    [anon_sym_BSLASHACRlong] = ACTIONS(6662),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrfull] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6662),
    [anon_sym_BSLASHACRfull] = ACTIONS(6662),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHacs] = ACTIONS(6662),
    [anon_sym_BSLASHAcs] = ACTIONS(6662),
    [anon_sym_BSLASHacsp] = ACTIONS(6662),
    [anon_sym_BSLASHAcsp] = ACTIONS(6662),
    [anon_sym_BSLASHacl] = ACTIONS(6662),
    [anon_sym_BSLASHAcl] = ACTIONS(6662),
    [anon_sym_BSLASHaclp] = ACTIONS(6662),
    [anon_sym_BSLASHAclp] = ACTIONS(6662),
    [anon_sym_BSLASHacf] = ACTIONS(6662),
    [anon_sym_BSLASHAcf] = ACTIONS(6662),
    [anon_sym_BSLASHacfp] = ACTIONS(6662),
    [anon_sym_BSLASHAcfp] = ACTIONS(6662),
    [anon_sym_BSLASHac] = ACTIONS(6662),
    [anon_sym_BSLASHAc] = ACTIONS(6662),
    [anon_sym_BSLASHacp] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6662),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6662),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6662),
    [anon_sym_BSLASHcolor] = ACTIONS(6662),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6662),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6662),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6662),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6662),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6662),
    [anon_sym_BSLASHtext] = ACTIONS(6662),
    [anon_sym_BSLASHintertext] = ACTIONS(6662),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6662),
    [anon_sym_BSLASHurl] = ACTIONS(6662),
    [anon_sym_BSLASHhref] = ACTIONS(6662),
  },
  [1594] = {
    [sym_command_name] = ACTIONS(6658),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6658),
    [anon_sym_LBRACK] = ACTIONS(6660),
    [anon_sym_RBRACK] = ACTIONS(6660),
    [anon_sym_COMMA] = ACTIONS(6660),
    [anon_sym_EQ] = ACTIONS(6660),
    [anon_sym_LPAREN] = ACTIONS(6660),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_LBRACE] = ACTIONS(6660),
    [sym_word] = ACTIONS(6658),
    [sym_placeholder] = ACTIONS(6660),
    [anon_sym_PLUS] = ACTIONS(6660),
    [anon_sym_DASH] = ACTIONS(6660),
    [anon_sym_STAR] = ACTIONS(6660),
    [anon_sym_SLASH] = ACTIONS(6660),
    [anon_sym_LT] = ACTIONS(6658),
    [anon_sym_GT] = ACTIONS(6658),
    [anon_sym_BANG] = ACTIONS(6658),
    [anon_sym_PIPE] = ACTIONS(6658),
    [anon_sym_COLON] = ACTIONS(6658),
    [anon_sym_SQUOTE] = ACTIONS(6658),
    [anon_sym__] = ACTIONS(6660),
    [anon_sym_CARET] = ACTIONS(6660),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6660),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6660),
    [anon_sym_DOLLAR] = ACTIONS(6658),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHbegin] = ACTIONS(6658),
    [anon_sym_BSLASHend] = ACTIONS(6658),
    [anon_sym_BSLASHtitle] = ACTIONS(6658),
    [anon_sym_BSLASHauthor] = ACTIONS(6658),
    [anon_sym_BSLASHusepackage] = ACTIONS(6658),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6658),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6658),
    [anon_sym_BSLASHinclude] = ACTIONS(6658),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6658),
    [anon_sym_BSLASHinput] = ACTIONS(6658),
    [anon_sym_BSLASHsubfile] = ACTIONS(6658),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6658),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6658),
    [anon_sym_BSLASHbibliography] = ACTIONS(6658),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6658),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6658),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6658),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6658),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6658),
    [anon_sym_BSLASHimport] = ACTIONS(6658),
    [anon_sym_BSLASHsubimport] = ACTIONS(6658),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6658),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHcaption] = ACTIONS(6658),
    [anon_sym_BSLASHcite] = ACTIONS(6658),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCite] = ACTIONS(6658),
    [anon_sym_BSLASHnocite] = ACTIONS(6658),
    [anon_sym_BSLASHcitet] = ACTIONS(6658),
    [anon_sym_BSLASHcitep] = ACTIONS(6658),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteA] = ACTIONS(6658),
    [anon_sym_BSLASHciteR] = ACTIONS(6658),
    [anon_sym_BSLASHciteS] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6658),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteyear] = ACTIONS(6658),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitedate] = ACTIONS(6658),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteurl] = ACTIONS(6658),
    [anon_sym_BSLASHfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6658),
    [anon_sym_BSLASHcitealt] = ACTIONS(6658),
    [anon_sym_BSLASHcitealp] = ACTIONS(6658),
    [anon_sym_BSLASHcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHparencite] = ACTIONS(6658),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHParencite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHtextcite] = ACTIONS(6658),
    [anon_sym_BSLASHTextcite] = ACTIONS(6658),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHsupercite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite] = ACTIONS(6658),
    [anon_sym_BSLASHAutocite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHVolcite] = ACTIONS(6658),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHavolcite] = ACTIONS(6658),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHNotecite] = ACTIONS(6658),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHlabel] = ACTIONS(6658),
    [anon_sym_BSLASHref] = ACTIONS(6658),
    [anon_sym_BSLASHeqref] = ACTIONS(6658),
    [anon_sym_BSLASHvref] = ACTIONS(6658),
    [anon_sym_BSLASHVref] = ACTIONS(6658),
    [anon_sym_BSLASHautoref] = ACTIONS(6658),
    [anon_sym_BSLASHpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcref] = ACTIONS(6658),
    [anon_sym_BSLASHCref] = ACTIONS(6658),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnameCref] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHdef] = ACTIONS(6658),
    [anon_sym_BSLASHlet] = ACTIONS(6658),
    [anon_sym_BSLASHleft] = ACTIONS(6658),
    [anon_sym_BSLASHbigl] = ACTIONS(6658),
    [anon_sym_BSLASHBigl] = ACTIONS(6658),
    [anon_sym_BSLASHbiggl] = ACTIONS(6658),
    [anon_sym_BSLASHBiggl] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6658),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6658),
    [anon_sym_BSLASHgls] = ACTIONS(6658),
    [anon_sym_BSLASHGls] = ACTIONS(6658),
    [anon_sym_BSLASHGLS] = ACTIONS(6658),
    [anon_sym_BSLASHglspl] = ACTIONS(6658),
    [anon_sym_BSLASHGlspl] = ACTIONS(6658),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6658),
    [anon_sym_BSLASHglslink] = ACTIONS(6658),
    [anon_sym_BSLASHglstext] = ACTIONS(6658),
    [anon_sym_BSLASHGlstext] = ACTIONS(6658),
    [anon_sym_BSLASHGLStext] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6658),
    [anon_sym_BSLASHglsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsname] = ACTIONS(6658),
    [anon_sym_BSLASHGlsname] = ACTIONS(6658),
    [anon_sym_BSLASHGLSname] = ACTIONS(6658),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6658),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6658),
    [anon_sym_BSLASHacrshort] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6658),
    [anon_sym_BSLASHACRshort] = ACTIONS(6658),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrlong] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6658),
    [anon_sym_BSLASHACRlong] = ACTIONS(6658),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrfull] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6658),
    [anon_sym_BSLASHACRfull] = ACTIONS(6658),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHacs] = ACTIONS(6658),
    [anon_sym_BSLASHAcs] = ACTIONS(6658),
    [anon_sym_BSLASHacsp] = ACTIONS(6658),
    [anon_sym_BSLASHAcsp] = ACTIONS(6658),
    [anon_sym_BSLASHacl] = ACTIONS(6658),
    [anon_sym_BSLASHAcl] = ACTIONS(6658),
    [anon_sym_BSLASHaclp] = ACTIONS(6658),
    [anon_sym_BSLASHAclp] = ACTIONS(6658),
    [anon_sym_BSLASHacf] = ACTIONS(6658),
    [anon_sym_BSLASHAcf] = ACTIONS(6658),
    [anon_sym_BSLASHacfp] = ACTIONS(6658),
    [anon_sym_BSLASHAcfp] = ACTIONS(6658),
    [anon_sym_BSLASHac] = ACTIONS(6658),
    [anon_sym_BSLASHAc] = ACTIONS(6658),
    [anon_sym_BSLASHacp] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6658),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6658),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6658),
    [anon_sym_BSLASHcolor] = ACTIONS(6658),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6658),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6658),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6658),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6658),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6658),
    [anon_sym_BSLASHtext] = ACTIONS(6658),
    [anon_sym_BSLASHintertext] = ACTIONS(6658),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6658),
    [anon_sym_BSLASHurl] = ACTIONS(6658),
    [anon_sym_BSLASHhref] = ACTIONS(6658),
  },
  [1595] = {
    [sym_command_name] = ACTIONS(6650),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6650),
    [anon_sym_LBRACK] = ACTIONS(6652),
    [anon_sym_RBRACK] = ACTIONS(6652),
    [anon_sym_COMMA] = ACTIONS(6652),
    [anon_sym_EQ] = ACTIONS(6652),
    [anon_sym_LPAREN] = ACTIONS(6652),
    [anon_sym_RPAREN] = ACTIONS(6652),
    [anon_sym_LBRACE] = ACTIONS(6652),
    [sym_word] = ACTIONS(6650),
    [sym_placeholder] = ACTIONS(6652),
    [anon_sym_PLUS] = ACTIONS(6652),
    [anon_sym_DASH] = ACTIONS(6652),
    [anon_sym_STAR] = ACTIONS(6652),
    [anon_sym_SLASH] = ACTIONS(6652),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_BANG] = ACTIONS(6650),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_COLON] = ACTIONS(6650),
    [anon_sym_SQUOTE] = ACTIONS(6650),
    [anon_sym__] = ACTIONS(6652),
    [anon_sym_CARET] = ACTIONS(6652),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6652),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6652),
    [anon_sym_DOLLAR] = ACTIONS(6650),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHbegin] = ACTIONS(6650),
    [anon_sym_BSLASHend] = ACTIONS(6650),
    [anon_sym_BSLASHtitle] = ACTIONS(6650),
    [anon_sym_BSLASHauthor] = ACTIONS(6650),
    [anon_sym_BSLASHusepackage] = ACTIONS(6650),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6650),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6650),
    [anon_sym_BSLASHinclude] = ACTIONS(6650),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6650),
    [anon_sym_BSLASHinput] = ACTIONS(6650),
    [anon_sym_BSLASHsubfile] = ACTIONS(6650),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6650),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6650),
    [anon_sym_BSLASHbibliography] = ACTIONS(6650),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6650),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6650),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6650),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6650),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6650),
    [anon_sym_BSLASHimport] = ACTIONS(6650),
    [anon_sym_BSLASHsubimport] = ACTIONS(6650),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6650),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHcaption] = ACTIONS(6650),
    [anon_sym_BSLASHcite] = ACTIONS(6650),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCite] = ACTIONS(6650),
    [anon_sym_BSLASHnocite] = ACTIONS(6650),
    [anon_sym_BSLASHcitet] = ACTIONS(6650),
    [anon_sym_BSLASHcitep] = ACTIONS(6650),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteA] = ACTIONS(6650),
    [anon_sym_BSLASHciteR] = ACTIONS(6650),
    [anon_sym_BSLASHciteS] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6650),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteyear] = ACTIONS(6650),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitedate] = ACTIONS(6650),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteurl] = ACTIONS(6650),
    [anon_sym_BSLASHfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6650),
    [anon_sym_BSLASHcitealt] = ACTIONS(6650),
    [anon_sym_BSLASHcitealp] = ACTIONS(6650),
    [anon_sym_BSLASHcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHparencite] = ACTIONS(6650),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHParencite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHtextcite] = ACTIONS(6650),
    [anon_sym_BSLASHTextcite] = ACTIONS(6650),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHsupercite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite] = ACTIONS(6650),
    [anon_sym_BSLASHAutocite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHVolcite] = ACTIONS(6650),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHavolcite] = ACTIONS(6650),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHNotecite] = ACTIONS(6650),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHlabel] = ACTIONS(6650),
    [anon_sym_BSLASHref] = ACTIONS(6650),
    [anon_sym_BSLASHeqref] = ACTIONS(6650),
    [anon_sym_BSLASHvref] = ACTIONS(6650),
    [anon_sym_BSLASHVref] = ACTIONS(6650),
    [anon_sym_BSLASHautoref] = ACTIONS(6650),
    [anon_sym_BSLASHpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcref] = ACTIONS(6650),
    [anon_sym_BSLASHCref] = ACTIONS(6650),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnameCref] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHdef] = ACTIONS(6650),
    [anon_sym_BSLASHlet] = ACTIONS(6650),
    [anon_sym_BSLASHleft] = ACTIONS(6650),
    [anon_sym_BSLASHbigl] = ACTIONS(6650),
    [anon_sym_BSLASHBigl] = ACTIONS(6650),
    [anon_sym_BSLASHbiggl] = ACTIONS(6650),
    [anon_sym_BSLASHBiggl] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6650),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6650),
    [anon_sym_BSLASHgls] = ACTIONS(6650),
    [anon_sym_BSLASHGls] = ACTIONS(6650),
    [anon_sym_BSLASHGLS] = ACTIONS(6650),
    [anon_sym_BSLASHglspl] = ACTIONS(6650),
    [anon_sym_BSLASHGlspl] = ACTIONS(6650),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6650),
    [anon_sym_BSLASHglslink] = ACTIONS(6650),
    [anon_sym_BSLASHglstext] = ACTIONS(6650),
    [anon_sym_BSLASHGlstext] = ACTIONS(6650),
    [anon_sym_BSLASHGLStext] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6650),
    [anon_sym_BSLASHglsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsname] = ACTIONS(6650),
    [anon_sym_BSLASHGlsname] = ACTIONS(6650),
    [anon_sym_BSLASHGLSname] = ACTIONS(6650),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6650),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6650),
    [anon_sym_BSLASHacrshort] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6650),
    [anon_sym_BSLASHACRshort] = ACTIONS(6650),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrlong] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6650),
    [anon_sym_BSLASHACRlong] = ACTIONS(6650),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrfull] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6650),
    [anon_sym_BSLASHACRfull] = ACTIONS(6650),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHacs] = ACTIONS(6650),
    [anon_sym_BSLASHAcs] = ACTIONS(6650),
    [anon_sym_BSLASHacsp] = ACTIONS(6650),
    [anon_sym_BSLASHAcsp] = ACTIONS(6650),
    [anon_sym_BSLASHacl] = ACTIONS(6650),
    [anon_sym_BSLASHAcl] = ACTIONS(6650),
    [anon_sym_BSLASHaclp] = ACTIONS(6650),
    [anon_sym_BSLASHAclp] = ACTIONS(6650),
    [anon_sym_BSLASHacf] = ACTIONS(6650),
    [anon_sym_BSLASHAcf] = ACTIONS(6650),
    [anon_sym_BSLASHacfp] = ACTIONS(6650),
    [anon_sym_BSLASHAcfp] = ACTIONS(6650),
    [anon_sym_BSLASHac] = ACTIONS(6650),
    [anon_sym_BSLASHAc] = ACTIONS(6650),
    [anon_sym_BSLASHacp] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6650),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6650),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6650),
    [anon_sym_BSLASHcolor] = ACTIONS(6650),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6650),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6650),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6650),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6650),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6650),
    [anon_sym_BSLASHtext] = ACTIONS(6650),
    [anon_sym_BSLASHintertext] = ACTIONS(6650),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6650),
    [anon_sym_BSLASHurl] = ACTIONS(6650),
    [anon_sym_BSLASHhref] = ACTIONS(6650),
  },
  [1596] = {
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_RBRACK] = ACTIONS(6192),
    [anon_sym_COMMA] = ACTIONS(6192),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_RPAREN] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6192),
    [anon_sym_DOLLAR] = ACTIONS(6190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHbegin] = ACTIONS(6190),
    [anon_sym_BSLASHend] = ACTIONS(6190),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHleft] = ACTIONS(6190),
    [anon_sym_BSLASHbigl] = ACTIONS(6190),
    [anon_sym_BSLASHBigl] = ACTIONS(6190),
    [anon_sym_BSLASHbiggl] = ACTIONS(6190),
    [anon_sym_BSLASHBiggl] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHtext] = ACTIONS(6190),
    [anon_sym_BSLASHintertext] = ACTIONS(6190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [1597] = {
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_RBRACK] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6184),
    [anon_sym_EQ] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_RPAREN] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6184),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6184),
    [anon_sym_DOLLAR] = ACTIONS(6182),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHbegin] = ACTIONS(6182),
    [anon_sym_BSLASHend] = ACTIONS(6182),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHleft] = ACTIONS(6182),
    [anon_sym_BSLASHbigl] = ACTIONS(6182),
    [anon_sym_BSLASHBigl] = ACTIONS(6182),
    [anon_sym_BSLASHbiggl] = ACTIONS(6182),
    [anon_sym_BSLASHBiggl] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHtext] = ACTIONS(6182),
    [anon_sym_BSLASHintertext] = ACTIONS(6182),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [1598] = {
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_LPAREN] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6176),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6176),
    [anon_sym_DOLLAR] = ACTIONS(6174),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHbegin] = ACTIONS(6174),
    [anon_sym_BSLASHend] = ACTIONS(6174),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHleft] = ACTIONS(6174),
    [anon_sym_BSLASHbigl] = ACTIONS(6174),
    [anon_sym_BSLASHBigl] = ACTIONS(6174),
    [anon_sym_BSLASHbiggl] = ACTIONS(6174),
    [anon_sym_BSLASHBiggl] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHtext] = ACTIONS(6174),
    [anon_sym_BSLASHintertext] = ACTIONS(6174),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [1599] = {
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_RBRACK] = ACTIONS(6352),
    [anon_sym_COMMA] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_LPAREN] = ACTIONS(6352),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_LBRACE] = ACTIONS(6352),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6352),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6352),
    [anon_sym_DOLLAR] = ACTIONS(6350),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHbegin] = ACTIONS(6350),
    [anon_sym_BSLASHend] = ACTIONS(6350),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHleft] = ACTIONS(6350),
    [anon_sym_BSLASHbigl] = ACTIONS(6350),
    [anon_sym_BSLASHBigl] = ACTIONS(6350),
    [anon_sym_BSLASHbiggl] = ACTIONS(6350),
    [anon_sym_BSLASHBiggl] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHtext] = ACTIONS(6350),
    [anon_sym_BSLASHintertext] = ACTIONS(6350),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [1600] = {
    [sym_brack_group_text] = STATE(1682),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(7146),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [anon_sym_RBRACE] = ACTIONS(6168),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6168),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6166),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHleft] = ACTIONS(6166),
    [anon_sym_BSLASHbigl] = ACTIONS(6166),
    [anon_sym_BSLASHBigl] = ACTIONS(6166),
    [anon_sym_BSLASHbiggl] = ACTIONS(6166),
    [anon_sym_BSLASHBiggl] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHtext] = ACTIONS(6166),
    [anon_sym_BSLASHintertext] = ACTIONS(6166),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [1601] = {
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHend] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [1602] = {
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_RBRACK] = ACTIONS(6452),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6452),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6452),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(6450),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHbegin] = ACTIONS(6450),
    [anon_sym_BSLASHend] = ACTIONS(6450),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHleft] = ACTIONS(6450),
    [anon_sym_BSLASHbigl] = ACTIONS(6450),
    [anon_sym_BSLASHBigl] = ACTIONS(6450),
    [anon_sym_BSLASHbiggl] = ACTIONS(6450),
    [anon_sym_BSLASHBiggl] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHtext] = ACTIONS(6450),
    [anon_sym_BSLASHintertext] = ACTIONS(6450),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [1603] = {
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_LBRACK] = ACTIONS(6472),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_EQ] = ACTIONS(6472),
    [anon_sym_LPAREN] = ACTIONS(6472),
    [anon_sym_RPAREN] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6472),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6472),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHbegin] = ACTIONS(6470),
    [anon_sym_BSLASHend] = ACTIONS(6470),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHleft] = ACTIONS(6470),
    [anon_sym_BSLASHbigl] = ACTIONS(6470),
    [anon_sym_BSLASHBigl] = ACTIONS(6470),
    [anon_sym_BSLASHbiggl] = ACTIONS(6470),
    [anon_sym_BSLASHBiggl] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHtext] = ACTIONS(6470),
    [anon_sym_BSLASHintertext] = ACTIONS(6470),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [1604] = {
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6276),
    [anon_sym_RBRACK] = ACTIONS(6276),
    [anon_sym_COMMA] = ACTIONS(6276),
    [anon_sym_EQ] = ACTIONS(6276),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6276),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6276),
    [anon_sym_DOLLAR] = ACTIONS(6274),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHbegin] = ACTIONS(6274),
    [anon_sym_BSLASHend] = ACTIONS(6274),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHleft] = ACTIONS(6274),
    [anon_sym_BSLASHbigl] = ACTIONS(6274),
    [anon_sym_BSLASHBigl] = ACTIONS(6274),
    [anon_sym_BSLASHbiggl] = ACTIONS(6274),
    [anon_sym_BSLASHBiggl] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHtext] = ACTIONS(6274),
    [anon_sym_BSLASHintertext] = ACTIONS(6274),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [1605] = {
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6552),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6552),
    [anon_sym_DOLLAR] = ACTIONS(6550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHbegin] = ACTIONS(6550),
    [anon_sym_BSLASHend] = ACTIONS(6550),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHleft] = ACTIONS(6550),
    [anon_sym_BSLASHbigl] = ACTIONS(6550),
    [anon_sym_BSLASHBigl] = ACTIONS(6550),
    [anon_sym_BSLASHbiggl] = ACTIONS(6550),
    [anon_sym_BSLASHBiggl] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHtext] = ACTIONS(6550),
    [anon_sym_BSLASHintertext] = ACTIONS(6550),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [1606] = {
    [sym_curly_group] = STATE(1694),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(3411),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6154),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHbegin] = ACTIONS(6152),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHleft] = ACTIONS(6152),
    [anon_sym_BSLASHbigl] = ACTIONS(6152),
    [anon_sym_BSLASHBigl] = ACTIONS(6152),
    [anon_sym_BSLASHbiggl] = ACTIONS(6152),
    [anon_sym_BSLASHBiggl] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHtext] = ACTIONS(6152),
    [anon_sym_BSLASHintertext] = ACTIONS(6152),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [1607] = {
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6556),
    [anon_sym_RBRACK] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6556),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_LBRACE] = ACTIONS(6556),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6556),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6556),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHbegin] = ACTIONS(6554),
    [anon_sym_BSLASHend] = ACTIONS(6554),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHleft] = ACTIONS(6554),
    [anon_sym_BSLASHbigl] = ACTIONS(6554),
    [anon_sym_BSLASHBigl] = ACTIONS(6554),
    [anon_sym_BSLASHbiggl] = ACTIONS(6554),
    [anon_sym_BSLASHBiggl] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHtext] = ACTIONS(6554),
    [anon_sym_BSLASHintertext] = ACTIONS(6554),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [1608] = {
    [sym_command_name] = ACTIONS(6170),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6172),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6172),
    [anon_sym_LPAREN] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [sym_word] = ACTIONS(6170),
    [sym_placeholder] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_BANG] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_SQUOTE] = ACTIONS(6170),
    [anon_sym__] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6172),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6172),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHbegin] = ACTIONS(6170),
    [anon_sym_BSLASHend] = ACTIONS(6170),
    [anon_sym_BSLASHtitle] = ACTIONS(6170),
    [anon_sym_BSLASHauthor] = ACTIONS(6170),
    [anon_sym_BSLASHusepackage] = ACTIONS(6170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6170),
    [anon_sym_BSLASHinclude] = ACTIONS(6170),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6170),
    [anon_sym_BSLASHinput] = ACTIONS(6170),
    [anon_sym_BSLASHsubfile] = ACTIONS(6170),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6170),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6170),
    [anon_sym_BSLASHbibliography] = ACTIONS(6170),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6170),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6170),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6170),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6170),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6170),
    [anon_sym_BSLASHimport] = ACTIONS(6170),
    [anon_sym_BSLASHsubimport] = ACTIONS(6170),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6170),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHcaption] = ACTIONS(6170),
    [anon_sym_BSLASHcite] = ACTIONS(6170),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCite] = ACTIONS(6170),
    [anon_sym_BSLASHnocite] = ACTIONS(6170),
    [anon_sym_BSLASHcitet] = ACTIONS(6170),
    [anon_sym_BSLASHcitep] = ACTIONS(6170),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteA] = ACTIONS(6170),
    [anon_sym_BSLASHciteR] = ACTIONS(6170),
    [anon_sym_BSLASHciteS] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6170),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteyear] = ACTIONS(6170),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitedate] = ACTIONS(6170),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteurl] = ACTIONS(6170),
    [anon_sym_BSLASHfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6170),
    [anon_sym_BSLASHcitealt] = ACTIONS(6170),
    [anon_sym_BSLASHcitealp] = ACTIONS(6170),
    [anon_sym_BSLASHcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHparencite] = ACTIONS(6170),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHParencite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHtextcite] = ACTIONS(6170),
    [anon_sym_BSLASHTextcite] = ACTIONS(6170),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHsupercite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite] = ACTIONS(6170),
    [anon_sym_BSLASHAutocite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHVolcite] = ACTIONS(6170),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHavolcite] = ACTIONS(6170),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHNotecite] = ACTIONS(6170),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHlabel] = ACTIONS(6170),
    [anon_sym_BSLASHref] = ACTIONS(6170),
    [anon_sym_BSLASHeqref] = ACTIONS(6170),
    [anon_sym_BSLASHvref] = ACTIONS(6170),
    [anon_sym_BSLASHVref] = ACTIONS(6170),
    [anon_sym_BSLASHautoref] = ACTIONS(6170),
    [anon_sym_BSLASHpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcref] = ACTIONS(6170),
    [anon_sym_BSLASHCref] = ACTIONS(6170),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnameCref] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHdef] = ACTIONS(6170),
    [anon_sym_BSLASHlet] = ACTIONS(6170),
    [anon_sym_BSLASHleft] = ACTIONS(6170),
    [anon_sym_BSLASHbigl] = ACTIONS(6170),
    [anon_sym_BSLASHBigl] = ACTIONS(6170),
    [anon_sym_BSLASHbiggl] = ACTIONS(6170),
    [anon_sym_BSLASHBiggl] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6170),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6170),
    [anon_sym_BSLASHgls] = ACTIONS(6170),
    [anon_sym_BSLASHGls] = ACTIONS(6170),
    [anon_sym_BSLASHGLS] = ACTIONS(6170),
    [anon_sym_BSLASHglspl] = ACTIONS(6170),
    [anon_sym_BSLASHGlspl] = ACTIONS(6170),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6170),
    [anon_sym_BSLASHglslink] = ACTIONS(6170),
    [anon_sym_BSLASHglstext] = ACTIONS(6170),
    [anon_sym_BSLASHGlstext] = ACTIONS(6170),
    [anon_sym_BSLASHGLStext] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6170),
    [anon_sym_BSLASHglsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsname] = ACTIONS(6170),
    [anon_sym_BSLASHGlsname] = ACTIONS(6170),
    [anon_sym_BSLASHGLSname] = ACTIONS(6170),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6170),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6170),
    [anon_sym_BSLASHacrshort] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6170),
    [anon_sym_BSLASHACRshort] = ACTIONS(6170),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrlong] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6170),
    [anon_sym_BSLASHACRlong] = ACTIONS(6170),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrfull] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6170),
    [anon_sym_BSLASHACRfull] = ACTIONS(6170),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHacs] = ACTIONS(6170),
    [anon_sym_BSLASHAcs] = ACTIONS(6170),
    [anon_sym_BSLASHacsp] = ACTIONS(6170),
    [anon_sym_BSLASHAcsp] = ACTIONS(6170),
    [anon_sym_BSLASHacl] = ACTIONS(6170),
    [anon_sym_BSLASHAcl] = ACTIONS(6170),
    [anon_sym_BSLASHaclp] = ACTIONS(6170),
    [anon_sym_BSLASHAclp] = ACTIONS(6170),
    [anon_sym_BSLASHacf] = ACTIONS(6170),
    [anon_sym_BSLASHAcf] = ACTIONS(6170),
    [anon_sym_BSLASHacfp] = ACTIONS(6170),
    [anon_sym_BSLASHAcfp] = ACTIONS(6170),
    [anon_sym_BSLASHac] = ACTIONS(6170),
    [anon_sym_BSLASHAc] = ACTIONS(6170),
    [anon_sym_BSLASHacp] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6170),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6170),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6170),
    [anon_sym_BSLASHcolor] = ACTIONS(6170),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6170),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6170),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6170),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6170),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6170),
    [anon_sym_BSLASHtext] = ACTIONS(6170),
    [anon_sym_BSLASHintertext] = ACTIONS(6170),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6170),
    [anon_sym_BSLASHurl] = ACTIONS(6170),
    [anon_sym_BSLASHhref] = ACTIONS(6170),
  },
  [1609] = {
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_LBRACK] = ACTIONS(6524),
    [anon_sym_RBRACK] = ACTIONS(6524),
    [anon_sym_COMMA] = ACTIONS(6524),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6524),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6524),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6524),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6524),
    [anon_sym_DOLLAR] = ACTIONS(6522),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHbegin] = ACTIONS(6522),
    [anon_sym_BSLASHend] = ACTIONS(6522),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHleft] = ACTIONS(6522),
    [anon_sym_BSLASHbigl] = ACTIONS(6522),
    [anon_sym_BSLASHBigl] = ACTIONS(6522),
    [anon_sym_BSLASHbiggl] = ACTIONS(6522),
    [anon_sym_BSLASHBiggl] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHtext] = ACTIONS(6522),
    [anon_sym_BSLASHintertext] = ACTIONS(6522),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [1610] = {
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_LBRACK] = ACTIONS(6574),
    [anon_sym_RBRACK] = ACTIONS(6574),
    [anon_sym_COMMA] = ACTIONS(6574),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_RPAREN] = ACTIONS(6574),
    [anon_sym_LBRACE] = ACTIONS(6574),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6574),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6574),
    [anon_sym_DOLLAR] = ACTIONS(6572),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHbegin] = ACTIONS(6572),
    [anon_sym_BSLASHend] = ACTIONS(6572),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHleft] = ACTIONS(6572),
    [anon_sym_BSLASHbigl] = ACTIONS(6572),
    [anon_sym_BSLASHBigl] = ACTIONS(6572),
    [anon_sym_BSLASHbiggl] = ACTIONS(6572),
    [anon_sym_BSLASHBiggl] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHtext] = ACTIONS(6572),
    [anon_sym_BSLASHintertext] = ACTIONS(6572),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [1611] = {
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_LBRACK] = ACTIONS(6520),
    [anon_sym_RBRACK] = ACTIONS(6520),
    [anon_sym_COMMA] = ACTIONS(6520),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_LPAREN] = ACTIONS(6520),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_LBRACE] = ACTIONS(6520),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6520),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6520),
    [anon_sym_DOLLAR] = ACTIONS(6518),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHbegin] = ACTIONS(6518),
    [anon_sym_BSLASHend] = ACTIONS(6518),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHleft] = ACTIONS(6518),
    [anon_sym_BSLASHbigl] = ACTIONS(6518),
    [anon_sym_BSLASHBigl] = ACTIONS(6518),
    [anon_sym_BSLASHbiggl] = ACTIONS(6518),
    [anon_sym_BSLASHBiggl] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHtext] = ACTIONS(6518),
    [anon_sym_BSLASHintertext] = ACTIONS(6518),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [1612] = {
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_LBRACK] = ACTIONS(6516),
    [anon_sym_RBRACK] = ACTIONS(6516),
    [anon_sym_COMMA] = ACTIONS(6516),
    [anon_sym_EQ] = ACTIONS(6516),
    [anon_sym_LPAREN] = ACTIONS(6516),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_LBRACE] = ACTIONS(6516),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6516),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(6514),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHbegin] = ACTIONS(6514),
    [anon_sym_BSLASHend] = ACTIONS(6514),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHleft] = ACTIONS(6514),
    [anon_sym_BSLASHbigl] = ACTIONS(6514),
    [anon_sym_BSLASHBigl] = ACTIONS(6514),
    [anon_sym_BSLASHbiggl] = ACTIONS(6514),
    [anon_sym_BSLASHBiggl] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHtext] = ACTIONS(6514),
    [anon_sym_BSLASHintertext] = ACTIONS(6514),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [1613] = {
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_LBRACK] = ACTIONS(6512),
    [anon_sym_RBRACK] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6512),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6512),
    [anon_sym_DOLLAR] = ACTIONS(6510),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHbegin] = ACTIONS(6510),
    [anon_sym_BSLASHend] = ACTIONS(6510),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHleft] = ACTIONS(6510),
    [anon_sym_BSLASHbigl] = ACTIONS(6510),
    [anon_sym_BSLASHBigl] = ACTIONS(6510),
    [anon_sym_BSLASHbiggl] = ACTIONS(6510),
    [anon_sym_BSLASHBiggl] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHtext] = ACTIONS(6510),
    [anon_sym_BSLASHintertext] = ACTIONS(6510),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [1614] = {
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_LBRACK] = ACTIONS(6508),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [anon_sym_COMMA] = ACTIONS(6508),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_RPAREN] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6508),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(6506),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHbegin] = ACTIONS(6506),
    [anon_sym_BSLASHend] = ACTIONS(6506),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHleft] = ACTIONS(6506),
    [anon_sym_BSLASHbigl] = ACTIONS(6506),
    [anon_sym_BSLASHBigl] = ACTIONS(6506),
    [anon_sym_BSLASHbiggl] = ACTIONS(6506),
    [anon_sym_BSLASHBiggl] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHtext] = ACTIONS(6506),
    [anon_sym_BSLASHintertext] = ACTIONS(6506),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [1615] = {
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6528),
    [anon_sym_RBRACK] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6528),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [anon_sym_RPAREN] = ACTIONS(6528),
    [anon_sym_LBRACE] = ACTIONS(6528),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6528),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(6526),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHbegin] = ACTIONS(6526),
    [anon_sym_BSLASHend] = ACTIONS(6526),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHleft] = ACTIONS(6526),
    [anon_sym_BSLASHbigl] = ACTIONS(6526),
    [anon_sym_BSLASHBigl] = ACTIONS(6526),
    [anon_sym_BSLASHbiggl] = ACTIONS(6526),
    [anon_sym_BSLASHBiggl] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHtext] = ACTIONS(6526),
    [anon_sym_BSLASHintertext] = ACTIONS(6526),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [1616] = {
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_LBRACK] = ACTIONS(6500),
    [anon_sym_RBRACK] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [anon_sym_EQ] = ACTIONS(6500),
    [anon_sym_LPAREN] = ACTIONS(6500),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_LBRACE] = ACTIONS(6500),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6500),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6500),
    [anon_sym_DOLLAR] = ACTIONS(6498),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHbegin] = ACTIONS(6498),
    [anon_sym_BSLASHend] = ACTIONS(6498),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHleft] = ACTIONS(6498),
    [anon_sym_BSLASHbigl] = ACTIONS(6498),
    [anon_sym_BSLASHBigl] = ACTIONS(6498),
    [anon_sym_BSLASHbiggl] = ACTIONS(6498),
    [anon_sym_BSLASHBiggl] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHtext] = ACTIONS(6498),
    [anon_sym_BSLASHintertext] = ACTIONS(6498),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [1617] = {
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_RBRACK] = ACTIONS(6656),
    [anon_sym_COMMA] = ACTIONS(6656),
    [anon_sym_EQ] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(6656),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6656),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6656),
    [anon_sym_DOLLAR] = ACTIONS(6654),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHbegin] = ACTIONS(6654),
    [anon_sym_BSLASHend] = ACTIONS(6654),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHleft] = ACTIONS(6654),
    [anon_sym_BSLASHbigl] = ACTIONS(6654),
    [anon_sym_BSLASHBigl] = ACTIONS(6654),
    [anon_sym_BSLASHbiggl] = ACTIONS(6654),
    [anon_sym_BSLASHBiggl] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHtext] = ACTIONS(6654),
    [anon_sym_BSLASHintertext] = ACTIONS(6654),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [1618] = {
    [sym_curly_group] = STATE(1673),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_LBRACK] = ACTIONS(6146),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6146),
    [anon_sym_LPAREN] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(6146),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6146),
    [anon_sym_DOLLAR] = ACTIONS(6144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHleft] = ACTIONS(6144),
    [anon_sym_BSLASHbigl] = ACTIONS(6144),
    [anon_sym_BSLASHBigl] = ACTIONS(6144),
    [anon_sym_BSLASHbiggl] = ACTIONS(6144),
    [anon_sym_BSLASHBiggl] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHtext] = ACTIONS(6144),
    [anon_sym_BSLASHintertext] = ACTIONS(6144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [1619] = {
    [sym_brack_group_text] = STATE(1668),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(7146),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [anon_sym_LBRACE] = ACTIONS(6150),
    [anon_sym_RBRACE] = ACTIONS(6150),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6150),
    [anon_sym_DOLLAR] = ACTIONS(6148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHleft] = ACTIONS(6148),
    [anon_sym_BSLASHbigl] = ACTIONS(6148),
    [anon_sym_BSLASHBigl] = ACTIONS(6148),
    [anon_sym_BSLASHbiggl] = ACTIONS(6148),
    [anon_sym_BSLASHBiggl] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHtext] = ACTIONS(6148),
    [anon_sym_BSLASHintertext] = ACTIONS(6148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [1620] = {
    [sym_command_name] = ACTIONS(6666),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6666),
    [anon_sym_LBRACK] = ACTIONS(6668),
    [anon_sym_RBRACK] = ACTIONS(6668),
    [anon_sym_COMMA] = ACTIONS(6668),
    [anon_sym_EQ] = ACTIONS(6668),
    [anon_sym_LPAREN] = ACTIONS(6668),
    [anon_sym_RPAREN] = ACTIONS(6668),
    [anon_sym_LBRACE] = ACTIONS(6668),
    [sym_word] = ACTIONS(6666),
    [sym_placeholder] = ACTIONS(6668),
    [anon_sym_PLUS] = ACTIONS(6668),
    [anon_sym_DASH] = ACTIONS(6668),
    [anon_sym_STAR] = ACTIONS(6668),
    [anon_sym_SLASH] = ACTIONS(6668),
    [anon_sym_LT] = ACTIONS(6666),
    [anon_sym_GT] = ACTIONS(6666),
    [anon_sym_BANG] = ACTIONS(6666),
    [anon_sym_PIPE] = ACTIONS(6666),
    [anon_sym_COLON] = ACTIONS(6666),
    [anon_sym_SQUOTE] = ACTIONS(6666),
    [anon_sym__] = ACTIONS(6668),
    [anon_sym_CARET] = ACTIONS(6668),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6668),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6668),
    [anon_sym_DOLLAR] = ACTIONS(6666),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHbegin] = ACTIONS(6666),
    [anon_sym_BSLASHend] = ACTIONS(6666),
    [anon_sym_BSLASHtitle] = ACTIONS(6666),
    [anon_sym_BSLASHauthor] = ACTIONS(6666),
    [anon_sym_BSLASHusepackage] = ACTIONS(6666),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6666),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6666),
    [anon_sym_BSLASHinclude] = ACTIONS(6666),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6666),
    [anon_sym_BSLASHinput] = ACTIONS(6666),
    [anon_sym_BSLASHsubfile] = ACTIONS(6666),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6666),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6666),
    [anon_sym_BSLASHbibliography] = ACTIONS(6666),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6666),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6666),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6666),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6666),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6666),
    [anon_sym_BSLASHimport] = ACTIONS(6666),
    [anon_sym_BSLASHsubimport] = ACTIONS(6666),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6666),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHcaption] = ACTIONS(6666),
    [anon_sym_BSLASHcite] = ACTIONS(6666),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCite] = ACTIONS(6666),
    [anon_sym_BSLASHnocite] = ACTIONS(6666),
    [anon_sym_BSLASHcitet] = ACTIONS(6666),
    [anon_sym_BSLASHcitep] = ACTIONS(6666),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteA] = ACTIONS(6666),
    [anon_sym_BSLASHciteR] = ACTIONS(6666),
    [anon_sym_BSLASHciteS] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6666),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteyear] = ACTIONS(6666),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitedate] = ACTIONS(6666),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteurl] = ACTIONS(6666),
    [anon_sym_BSLASHfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6666),
    [anon_sym_BSLASHcitealt] = ACTIONS(6666),
    [anon_sym_BSLASHcitealp] = ACTIONS(6666),
    [anon_sym_BSLASHcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHparencite] = ACTIONS(6666),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHParencite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHtextcite] = ACTIONS(6666),
    [anon_sym_BSLASHTextcite] = ACTIONS(6666),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHsupercite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite] = ACTIONS(6666),
    [anon_sym_BSLASHAutocite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHVolcite] = ACTIONS(6666),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHavolcite] = ACTIONS(6666),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHNotecite] = ACTIONS(6666),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHlabel] = ACTIONS(6666),
    [anon_sym_BSLASHref] = ACTIONS(6666),
    [anon_sym_BSLASHeqref] = ACTIONS(6666),
    [anon_sym_BSLASHvref] = ACTIONS(6666),
    [anon_sym_BSLASHVref] = ACTIONS(6666),
    [anon_sym_BSLASHautoref] = ACTIONS(6666),
    [anon_sym_BSLASHpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcref] = ACTIONS(6666),
    [anon_sym_BSLASHCref] = ACTIONS(6666),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnameCref] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHdef] = ACTIONS(6666),
    [anon_sym_BSLASHlet] = ACTIONS(6666),
    [anon_sym_BSLASHleft] = ACTIONS(6666),
    [anon_sym_BSLASHbigl] = ACTIONS(6666),
    [anon_sym_BSLASHBigl] = ACTIONS(6666),
    [anon_sym_BSLASHbiggl] = ACTIONS(6666),
    [anon_sym_BSLASHBiggl] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6666),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6666),
    [anon_sym_BSLASHgls] = ACTIONS(6666),
    [anon_sym_BSLASHGls] = ACTIONS(6666),
    [anon_sym_BSLASHGLS] = ACTIONS(6666),
    [anon_sym_BSLASHglspl] = ACTIONS(6666),
    [anon_sym_BSLASHGlspl] = ACTIONS(6666),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6666),
    [anon_sym_BSLASHglslink] = ACTIONS(6666),
    [anon_sym_BSLASHglstext] = ACTIONS(6666),
    [anon_sym_BSLASHGlstext] = ACTIONS(6666),
    [anon_sym_BSLASHGLStext] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6666),
    [anon_sym_BSLASHglsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsname] = ACTIONS(6666),
    [anon_sym_BSLASHGlsname] = ACTIONS(6666),
    [anon_sym_BSLASHGLSname] = ACTIONS(6666),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6666),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6666),
    [anon_sym_BSLASHacrshort] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6666),
    [anon_sym_BSLASHACRshort] = ACTIONS(6666),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrlong] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6666),
    [anon_sym_BSLASHACRlong] = ACTIONS(6666),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrfull] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6666),
    [anon_sym_BSLASHACRfull] = ACTIONS(6666),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHacs] = ACTIONS(6666),
    [anon_sym_BSLASHAcs] = ACTIONS(6666),
    [anon_sym_BSLASHacsp] = ACTIONS(6666),
    [anon_sym_BSLASHAcsp] = ACTIONS(6666),
    [anon_sym_BSLASHacl] = ACTIONS(6666),
    [anon_sym_BSLASHAcl] = ACTIONS(6666),
    [anon_sym_BSLASHaclp] = ACTIONS(6666),
    [anon_sym_BSLASHAclp] = ACTIONS(6666),
    [anon_sym_BSLASHacf] = ACTIONS(6666),
    [anon_sym_BSLASHAcf] = ACTIONS(6666),
    [anon_sym_BSLASHacfp] = ACTIONS(6666),
    [anon_sym_BSLASHAcfp] = ACTIONS(6666),
    [anon_sym_BSLASHac] = ACTIONS(6666),
    [anon_sym_BSLASHAc] = ACTIONS(6666),
    [anon_sym_BSLASHacp] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6666),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6666),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6666),
    [anon_sym_BSLASHcolor] = ACTIONS(6666),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6666),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6666),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6666),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6666),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6666),
    [anon_sym_BSLASHtext] = ACTIONS(6666),
    [anon_sym_BSLASHintertext] = ACTIONS(6666),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6666),
    [anon_sym_BSLASHurl] = ACTIONS(6666),
    [anon_sym_BSLASHhref] = ACTIONS(6666),
  },
  [1621] = {
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_LBRACK] = ACTIONS(6560),
    [anon_sym_RBRACK] = ACTIONS(6560),
    [anon_sym_COMMA] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_LBRACE] = ACTIONS(6560),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6560),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(6558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHbegin] = ACTIONS(6558),
    [anon_sym_BSLASHend] = ACTIONS(6558),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHleft] = ACTIONS(6558),
    [anon_sym_BSLASHbigl] = ACTIONS(6558),
    [anon_sym_BSLASHBigl] = ACTIONS(6558),
    [anon_sym_BSLASHbiggl] = ACTIONS(6558),
    [anon_sym_BSLASHBiggl] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHtext] = ACTIONS(6558),
    [anon_sym_BSLASHintertext] = ACTIONS(6558),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [1622] = {
    [sym_curly_group] = STATE(1663),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_LBRACK] = ACTIONS(6154),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(6154),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6154),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHleft] = ACTIONS(6152),
    [anon_sym_BSLASHbigl] = ACTIONS(6152),
    [anon_sym_BSLASHBigl] = ACTIONS(6152),
    [anon_sym_BSLASHbiggl] = ACTIONS(6152),
    [anon_sym_BSLASHBiggl] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHtext] = ACTIONS(6152),
    [anon_sym_BSLASHintertext] = ACTIONS(6152),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [1623] = {
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_LBRACK] = ACTIONS(6496),
    [anon_sym_RBRACK] = ACTIONS(6496),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6496),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_RPAREN] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6496),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6496),
    [anon_sym_DOLLAR] = ACTIONS(6494),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHbegin] = ACTIONS(6494),
    [anon_sym_BSLASHend] = ACTIONS(6494),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHleft] = ACTIONS(6494),
    [anon_sym_BSLASHbigl] = ACTIONS(6494),
    [anon_sym_BSLASHBigl] = ACTIONS(6494),
    [anon_sym_BSLASHbiggl] = ACTIONS(6494),
    [anon_sym_BSLASHBiggl] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHtext] = ACTIONS(6494),
    [anon_sym_BSLASHintertext] = ACTIONS(6494),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [1624] = {
    [sym_command_name] = ACTIONS(7148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7148),
    [anon_sym_LBRACK] = ACTIONS(7150),
    [anon_sym_RBRACK] = ACTIONS(7150),
    [anon_sym_COMMA] = ACTIONS(7150),
    [anon_sym_EQ] = ACTIONS(7150),
    [anon_sym_LPAREN] = ACTIONS(7150),
    [anon_sym_RPAREN] = ACTIONS(7150),
    [anon_sym_LBRACE] = ACTIONS(7150),
    [sym_word] = ACTIONS(7148),
    [sym_placeholder] = ACTIONS(7150),
    [anon_sym_PLUS] = ACTIONS(7150),
    [anon_sym_DASH] = ACTIONS(7150),
    [anon_sym_STAR] = ACTIONS(7150),
    [anon_sym_SLASH] = ACTIONS(7150),
    [anon_sym_LT] = ACTIONS(7148),
    [anon_sym_GT] = ACTIONS(7148),
    [anon_sym_BANG] = ACTIONS(7148),
    [anon_sym_PIPE] = ACTIONS(7148),
    [anon_sym_COLON] = ACTIONS(7148),
    [anon_sym_SQUOTE] = ACTIONS(7148),
    [anon_sym__] = ACTIONS(7150),
    [anon_sym_CARET] = ACTIONS(7150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7150),
    [anon_sym_DOLLAR] = ACTIONS(7148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7150),
    [anon_sym_BSLASHbegin] = ACTIONS(7148),
    [anon_sym_BSLASHend] = ACTIONS(7148),
    [anon_sym_BSLASHtitle] = ACTIONS(7148),
    [anon_sym_BSLASHauthor] = ACTIONS(7148),
    [anon_sym_BSLASHusepackage] = ACTIONS(7148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7148),
    [anon_sym_BSLASHinclude] = ACTIONS(7148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7148),
    [anon_sym_BSLASHinput] = ACTIONS(7148),
    [anon_sym_BSLASHsubfile] = ACTIONS(7148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7148),
    [anon_sym_BSLASHbibliography] = ACTIONS(7148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7148),
    [anon_sym_BSLASHimport] = ACTIONS(7148),
    [anon_sym_BSLASHsubimport] = ACTIONS(7148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7148),
    [anon_sym_BSLASHcaption] = ACTIONS(7148),
    [anon_sym_BSLASHcite] = ACTIONS(7148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHCite] = ACTIONS(7148),
    [anon_sym_BSLASHnocite] = ACTIONS(7148),
    [anon_sym_BSLASHcitet] = ACTIONS(7148),
    [anon_sym_BSLASHcitep] = ACTIONS(7148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHciteA] = ACTIONS(7148),
    [anon_sym_BSLASHciteR] = ACTIONS(7148),
    [anon_sym_BSLASHciteS] = ACTIONS(7148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHciteyear] = ACTIONS(7148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHcitedate] = ACTIONS(7148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHciteurl] = ACTIONS(7148),
    [anon_sym_BSLASHfullcite] = ACTIONS(7148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7148),
    [anon_sym_BSLASHcitealt] = ACTIONS(7148),
    [anon_sym_BSLASHcitealp] = ACTIONS(7148),
    [anon_sym_BSLASHcitetext] = ACTIONS(7148),
    [anon_sym_BSLASHparencite] = ACTIONS(7148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHParencite] = ACTIONS(7148),
    [anon_sym_BSLASHfootcite] = ACTIONS(7148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7148),
    [anon_sym_BSLASHtextcite] = ACTIONS(7148),
    [anon_sym_BSLASHTextcite] = ACTIONS(7148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7148),
    [anon_sym_BSLASHsupercite] = ACTIONS(7148),
    [anon_sym_BSLASHautocite] = ACTIONS(7148),
    [anon_sym_BSLASHAutocite] = ACTIONS(7148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHVolcite] = ACTIONS(7148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHavolcite] = ACTIONS(7148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7148),
    [anon_sym_BSLASHnotecite] = ACTIONS(7148),
    [anon_sym_BSLASHNotecite] = ACTIONS(7148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7148),
    [anon_sym_BSLASHlabel] = ACTIONS(7148),
    [anon_sym_BSLASHref] = ACTIONS(7148),
    [anon_sym_BSLASHeqref] = ACTIONS(7148),
    [anon_sym_BSLASHvref] = ACTIONS(7148),
    [anon_sym_BSLASHVref] = ACTIONS(7148),
    [anon_sym_BSLASHautoref] = ACTIONS(7148),
    [anon_sym_BSLASHpageref] = ACTIONS(7148),
    [anon_sym_BSLASHcref] = ACTIONS(7148),
    [anon_sym_BSLASHCref] = ACTIONS(7148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHnamecref] = ACTIONS(7148),
    [anon_sym_BSLASHnameCref] = ACTIONS(7148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7148),
    [anon_sym_BSLASHdef] = ACTIONS(7148),
    [anon_sym_BSLASHlet] = ACTIONS(7148),
    [anon_sym_BSLASHleft] = ACTIONS(7148),
    [anon_sym_BSLASHbigl] = ACTIONS(7148),
    [anon_sym_BSLASHBigl] = ACTIONS(7148),
    [anon_sym_BSLASHbiggl] = ACTIONS(7148),
    [anon_sym_BSLASHBiggl] = ACTIONS(7148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7148),
    [anon_sym_BSLASHgls] = ACTIONS(7148),
    [anon_sym_BSLASHGls] = ACTIONS(7148),
    [anon_sym_BSLASHGLS] = ACTIONS(7148),
    [anon_sym_BSLASHglspl] = ACTIONS(7148),
    [anon_sym_BSLASHGlspl] = ACTIONS(7148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7148),
    [anon_sym_BSLASHglslink] = ACTIONS(7148),
    [anon_sym_BSLASHglstext] = ACTIONS(7148),
    [anon_sym_BSLASHGlstext] = ACTIONS(7148),
    [anon_sym_BSLASHGLStext] = ACTIONS(7148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7148),
    [anon_sym_BSLASHglsplural] = ACTIONS(7148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7148),
    [anon_sym_BSLASHglsname] = ACTIONS(7148),
    [anon_sym_BSLASHGlsname] = ACTIONS(7148),
    [anon_sym_BSLASHGLSname] = ACTIONS(7148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7148),
    [anon_sym_BSLASHacrshort] = ACTIONS(7148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7148),
    [anon_sym_BSLASHACRshort] = ACTIONS(7148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7148),
    [anon_sym_BSLASHacrlong] = ACTIONS(7148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7148),
    [anon_sym_BSLASHACRlong] = ACTIONS(7148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7148),
    [anon_sym_BSLASHacrfull] = ACTIONS(7148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7148),
    [anon_sym_BSLASHACRfull] = ACTIONS(7148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7148),
    [anon_sym_BSLASHacs] = ACTIONS(7148),
    [anon_sym_BSLASHAcs] = ACTIONS(7148),
    [anon_sym_BSLASHacsp] = ACTIONS(7148),
    [anon_sym_BSLASHAcsp] = ACTIONS(7148),
    [anon_sym_BSLASHacl] = ACTIONS(7148),
    [anon_sym_BSLASHAcl] = ACTIONS(7148),
    [anon_sym_BSLASHaclp] = ACTIONS(7148),
    [anon_sym_BSLASHAclp] = ACTIONS(7148),
    [anon_sym_BSLASHacf] = ACTIONS(7148),
    [anon_sym_BSLASHAcf] = ACTIONS(7148),
    [anon_sym_BSLASHacfp] = ACTIONS(7148),
    [anon_sym_BSLASHAcfp] = ACTIONS(7148),
    [anon_sym_BSLASHac] = ACTIONS(7148),
    [anon_sym_BSLASHAc] = ACTIONS(7148),
    [anon_sym_BSLASHacp] = ACTIONS(7148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7148),
    [anon_sym_BSLASHcolor] = ACTIONS(7148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7148),
    [anon_sym_BSLASHtext] = ACTIONS(7148),
    [anon_sym_BSLASHintertext] = ACTIONS(7148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7148),
    [anon_sym_BSLASHurl] = ACTIONS(7148),
    [anon_sym_BSLASHhref] = ACTIONS(7148),
  },
  [1625] = {
    [sym_command_name] = ACTIONS(6638),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6640),
    [anon_sym_RBRACK] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LPAREN] = ACTIONS(6640),
    [anon_sym_RPAREN] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(6640),
    [sym_word] = ACTIONS(6638),
    [sym_placeholder] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_DASH] = ACTIONS(6640),
    [anon_sym_STAR] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6638),
    [anon_sym_GT] = ACTIONS(6638),
    [anon_sym_BANG] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6638),
    [anon_sym_COLON] = ACTIONS(6638),
    [anon_sym_SQUOTE] = ACTIONS(6638),
    [anon_sym__] = ACTIONS(6640),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6640),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6640),
    [anon_sym_DOLLAR] = ACTIONS(6638),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHbegin] = ACTIONS(6638),
    [anon_sym_BSLASHend] = ACTIONS(6638),
    [anon_sym_BSLASHtitle] = ACTIONS(6638),
    [anon_sym_BSLASHauthor] = ACTIONS(6638),
    [anon_sym_BSLASHusepackage] = ACTIONS(6638),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6638),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6638),
    [anon_sym_BSLASHinclude] = ACTIONS(6638),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6638),
    [anon_sym_BSLASHinput] = ACTIONS(6638),
    [anon_sym_BSLASHsubfile] = ACTIONS(6638),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6638),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6638),
    [anon_sym_BSLASHbibliography] = ACTIONS(6638),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6638),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6638),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6638),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6638),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6638),
    [anon_sym_BSLASHimport] = ACTIONS(6638),
    [anon_sym_BSLASHsubimport] = ACTIONS(6638),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6638),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHcaption] = ACTIONS(6638),
    [anon_sym_BSLASHcite] = ACTIONS(6638),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCite] = ACTIONS(6638),
    [anon_sym_BSLASHnocite] = ACTIONS(6638),
    [anon_sym_BSLASHcitet] = ACTIONS(6638),
    [anon_sym_BSLASHcitep] = ACTIONS(6638),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteA] = ACTIONS(6638),
    [anon_sym_BSLASHciteR] = ACTIONS(6638),
    [anon_sym_BSLASHciteS] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6638),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteyear] = ACTIONS(6638),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitedate] = ACTIONS(6638),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteurl] = ACTIONS(6638),
    [anon_sym_BSLASHfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6638),
    [anon_sym_BSLASHcitealt] = ACTIONS(6638),
    [anon_sym_BSLASHcitealp] = ACTIONS(6638),
    [anon_sym_BSLASHcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHparencite] = ACTIONS(6638),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHParencite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHtextcite] = ACTIONS(6638),
    [anon_sym_BSLASHTextcite] = ACTIONS(6638),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHsupercite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite] = ACTIONS(6638),
    [anon_sym_BSLASHAutocite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHVolcite] = ACTIONS(6638),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHavolcite] = ACTIONS(6638),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHNotecite] = ACTIONS(6638),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHlabel] = ACTIONS(6638),
    [anon_sym_BSLASHref] = ACTIONS(6638),
    [anon_sym_BSLASHeqref] = ACTIONS(6638),
    [anon_sym_BSLASHvref] = ACTIONS(6638),
    [anon_sym_BSLASHVref] = ACTIONS(6638),
    [anon_sym_BSLASHautoref] = ACTIONS(6638),
    [anon_sym_BSLASHpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcref] = ACTIONS(6638),
    [anon_sym_BSLASHCref] = ACTIONS(6638),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnameCref] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHdef] = ACTIONS(6638),
    [anon_sym_BSLASHlet] = ACTIONS(6638),
    [anon_sym_BSLASHleft] = ACTIONS(6638),
    [anon_sym_BSLASHbigl] = ACTIONS(6638),
    [anon_sym_BSLASHBigl] = ACTIONS(6638),
    [anon_sym_BSLASHbiggl] = ACTIONS(6638),
    [anon_sym_BSLASHBiggl] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6638),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6638),
    [anon_sym_BSLASHgls] = ACTIONS(6638),
    [anon_sym_BSLASHGls] = ACTIONS(6638),
    [anon_sym_BSLASHGLS] = ACTIONS(6638),
    [anon_sym_BSLASHglspl] = ACTIONS(6638),
    [anon_sym_BSLASHGlspl] = ACTIONS(6638),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6638),
    [anon_sym_BSLASHglslink] = ACTIONS(6638),
    [anon_sym_BSLASHglstext] = ACTIONS(6638),
    [anon_sym_BSLASHGlstext] = ACTIONS(6638),
    [anon_sym_BSLASHGLStext] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6638),
    [anon_sym_BSLASHglsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsname] = ACTIONS(6638),
    [anon_sym_BSLASHGlsname] = ACTIONS(6638),
    [anon_sym_BSLASHGLSname] = ACTIONS(6638),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6638),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6638),
    [anon_sym_BSLASHacrshort] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6638),
    [anon_sym_BSLASHACRshort] = ACTIONS(6638),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrlong] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6638),
    [anon_sym_BSLASHACRlong] = ACTIONS(6638),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrfull] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6638),
    [anon_sym_BSLASHACRfull] = ACTIONS(6638),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHacs] = ACTIONS(6638),
    [anon_sym_BSLASHAcs] = ACTIONS(6638),
    [anon_sym_BSLASHacsp] = ACTIONS(6638),
    [anon_sym_BSLASHAcsp] = ACTIONS(6638),
    [anon_sym_BSLASHacl] = ACTIONS(6638),
    [anon_sym_BSLASHAcl] = ACTIONS(6638),
    [anon_sym_BSLASHaclp] = ACTIONS(6638),
    [anon_sym_BSLASHAclp] = ACTIONS(6638),
    [anon_sym_BSLASHacf] = ACTIONS(6638),
    [anon_sym_BSLASHAcf] = ACTIONS(6638),
    [anon_sym_BSLASHacfp] = ACTIONS(6638),
    [anon_sym_BSLASHAcfp] = ACTIONS(6638),
    [anon_sym_BSLASHac] = ACTIONS(6638),
    [anon_sym_BSLASHAc] = ACTIONS(6638),
    [anon_sym_BSLASHacp] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6638),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6638),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6638),
    [anon_sym_BSLASHcolor] = ACTIONS(6638),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6638),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6638),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6638),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6638),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6638),
    [anon_sym_BSLASHtext] = ACTIONS(6638),
    [anon_sym_BSLASHintertext] = ACTIONS(6638),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6638),
    [anon_sym_BSLASHurl] = ACTIONS(6638),
    [anon_sym_BSLASHhref] = ACTIONS(6638),
  },
  [1626] = {
    [sym_command_name] = ACTIONS(6630),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LPAREN] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [sym_word] = ACTIONS(6630),
    [sym_placeholder] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [anon_sym_STAR] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_BANG] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_COLON] = ACTIONS(6630),
    [anon_sym_SQUOTE] = ACTIONS(6630),
    [anon_sym__] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6632),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6632),
    [anon_sym_DOLLAR] = ACTIONS(6630),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHbegin] = ACTIONS(6630),
    [anon_sym_BSLASHend] = ACTIONS(6630),
    [anon_sym_BSLASHtitle] = ACTIONS(6630),
    [anon_sym_BSLASHauthor] = ACTIONS(6630),
    [anon_sym_BSLASHusepackage] = ACTIONS(6630),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6630),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6630),
    [anon_sym_BSLASHinclude] = ACTIONS(6630),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6630),
    [anon_sym_BSLASHinput] = ACTIONS(6630),
    [anon_sym_BSLASHsubfile] = ACTIONS(6630),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6630),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6630),
    [anon_sym_BSLASHbibliography] = ACTIONS(6630),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6630),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6630),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6630),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6630),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6630),
    [anon_sym_BSLASHimport] = ACTIONS(6630),
    [anon_sym_BSLASHsubimport] = ACTIONS(6630),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6630),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHcaption] = ACTIONS(6630),
    [anon_sym_BSLASHcite] = ACTIONS(6630),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCite] = ACTIONS(6630),
    [anon_sym_BSLASHnocite] = ACTIONS(6630),
    [anon_sym_BSLASHcitet] = ACTIONS(6630),
    [anon_sym_BSLASHcitep] = ACTIONS(6630),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteA] = ACTIONS(6630),
    [anon_sym_BSLASHciteR] = ACTIONS(6630),
    [anon_sym_BSLASHciteS] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6630),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteyear] = ACTIONS(6630),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitedate] = ACTIONS(6630),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteurl] = ACTIONS(6630),
    [anon_sym_BSLASHfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6630),
    [anon_sym_BSLASHcitealt] = ACTIONS(6630),
    [anon_sym_BSLASHcitealp] = ACTIONS(6630),
    [anon_sym_BSLASHcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHparencite] = ACTIONS(6630),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHParencite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHtextcite] = ACTIONS(6630),
    [anon_sym_BSLASHTextcite] = ACTIONS(6630),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHsupercite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite] = ACTIONS(6630),
    [anon_sym_BSLASHAutocite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHVolcite] = ACTIONS(6630),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHavolcite] = ACTIONS(6630),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHNotecite] = ACTIONS(6630),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHlabel] = ACTIONS(6630),
    [anon_sym_BSLASHref] = ACTIONS(6630),
    [anon_sym_BSLASHeqref] = ACTIONS(6630),
    [anon_sym_BSLASHvref] = ACTIONS(6630),
    [anon_sym_BSLASHVref] = ACTIONS(6630),
    [anon_sym_BSLASHautoref] = ACTIONS(6630),
    [anon_sym_BSLASHpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcref] = ACTIONS(6630),
    [anon_sym_BSLASHCref] = ACTIONS(6630),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnameCref] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHdef] = ACTIONS(6630),
    [anon_sym_BSLASHlet] = ACTIONS(6630),
    [anon_sym_BSLASHleft] = ACTIONS(6630),
    [anon_sym_BSLASHbigl] = ACTIONS(6630),
    [anon_sym_BSLASHBigl] = ACTIONS(6630),
    [anon_sym_BSLASHbiggl] = ACTIONS(6630),
    [anon_sym_BSLASHBiggl] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6630),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6630),
    [anon_sym_BSLASHgls] = ACTIONS(6630),
    [anon_sym_BSLASHGls] = ACTIONS(6630),
    [anon_sym_BSLASHGLS] = ACTIONS(6630),
    [anon_sym_BSLASHglspl] = ACTIONS(6630),
    [anon_sym_BSLASHGlspl] = ACTIONS(6630),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6630),
    [anon_sym_BSLASHglslink] = ACTIONS(6630),
    [anon_sym_BSLASHglstext] = ACTIONS(6630),
    [anon_sym_BSLASHGlstext] = ACTIONS(6630),
    [anon_sym_BSLASHGLStext] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6630),
    [anon_sym_BSLASHglsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsname] = ACTIONS(6630),
    [anon_sym_BSLASHGlsname] = ACTIONS(6630),
    [anon_sym_BSLASHGLSname] = ACTIONS(6630),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6630),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6630),
    [anon_sym_BSLASHacrshort] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6630),
    [anon_sym_BSLASHACRshort] = ACTIONS(6630),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrlong] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6630),
    [anon_sym_BSLASHACRlong] = ACTIONS(6630),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrfull] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6630),
    [anon_sym_BSLASHACRfull] = ACTIONS(6630),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHacs] = ACTIONS(6630),
    [anon_sym_BSLASHAcs] = ACTIONS(6630),
    [anon_sym_BSLASHacsp] = ACTIONS(6630),
    [anon_sym_BSLASHAcsp] = ACTIONS(6630),
    [anon_sym_BSLASHacl] = ACTIONS(6630),
    [anon_sym_BSLASHAcl] = ACTIONS(6630),
    [anon_sym_BSLASHaclp] = ACTIONS(6630),
    [anon_sym_BSLASHAclp] = ACTIONS(6630),
    [anon_sym_BSLASHacf] = ACTIONS(6630),
    [anon_sym_BSLASHAcf] = ACTIONS(6630),
    [anon_sym_BSLASHacfp] = ACTIONS(6630),
    [anon_sym_BSLASHAcfp] = ACTIONS(6630),
    [anon_sym_BSLASHac] = ACTIONS(6630),
    [anon_sym_BSLASHAc] = ACTIONS(6630),
    [anon_sym_BSLASHacp] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6630),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6630),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6630),
    [anon_sym_BSLASHcolor] = ACTIONS(6630),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6630),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6630),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6630),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6630),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6630),
    [anon_sym_BSLASHtext] = ACTIONS(6630),
    [anon_sym_BSLASHintertext] = ACTIONS(6630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6630),
    [anon_sym_BSLASHurl] = ACTIONS(6630),
    [anon_sym_BSLASHhref] = ACTIONS(6630),
  },
  [1627] = {
    [sym_command_name] = ACTIONS(6626),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6628),
    [anon_sym_RBRACK] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LPAREN] = ACTIONS(6628),
    [anon_sym_RPAREN] = ACTIONS(6628),
    [anon_sym_LBRACE] = ACTIONS(6628),
    [sym_word] = ACTIONS(6626),
    [sym_placeholder] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_DASH] = ACTIONS(6628),
    [anon_sym_STAR] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6626),
    [anon_sym_GT] = ACTIONS(6626),
    [anon_sym_BANG] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6626),
    [anon_sym_COLON] = ACTIONS(6626),
    [anon_sym_SQUOTE] = ACTIONS(6626),
    [anon_sym__] = ACTIONS(6628),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6628),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6628),
    [anon_sym_DOLLAR] = ACTIONS(6626),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHbegin] = ACTIONS(6626),
    [anon_sym_BSLASHend] = ACTIONS(6626),
    [anon_sym_BSLASHtitle] = ACTIONS(6626),
    [anon_sym_BSLASHauthor] = ACTIONS(6626),
    [anon_sym_BSLASHusepackage] = ACTIONS(6626),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6626),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6626),
    [anon_sym_BSLASHinclude] = ACTIONS(6626),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6626),
    [anon_sym_BSLASHinput] = ACTIONS(6626),
    [anon_sym_BSLASHsubfile] = ACTIONS(6626),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6626),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6626),
    [anon_sym_BSLASHbibliography] = ACTIONS(6626),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6626),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6626),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6626),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6626),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6626),
    [anon_sym_BSLASHimport] = ACTIONS(6626),
    [anon_sym_BSLASHsubimport] = ACTIONS(6626),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6626),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHcaption] = ACTIONS(6626),
    [anon_sym_BSLASHcite] = ACTIONS(6626),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCite] = ACTIONS(6626),
    [anon_sym_BSLASHnocite] = ACTIONS(6626),
    [anon_sym_BSLASHcitet] = ACTIONS(6626),
    [anon_sym_BSLASHcitep] = ACTIONS(6626),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteA] = ACTIONS(6626),
    [anon_sym_BSLASHciteR] = ACTIONS(6626),
    [anon_sym_BSLASHciteS] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6626),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteyear] = ACTIONS(6626),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitedate] = ACTIONS(6626),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteurl] = ACTIONS(6626),
    [anon_sym_BSLASHfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6626),
    [anon_sym_BSLASHcitealt] = ACTIONS(6626),
    [anon_sym_BSLASHcitealp] = ACTIONS(6626),
    [anon_sym_BSLASHcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHparencite] = ACTIONS(6626),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHParencite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHtextcite] = ACTIONS(6626),
    [anon_sym_BSLASHTextcite] = ACTIONS(6626),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHsupercite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite] = ACTIONS(6626),
    [anon_sym_BSLASHAutocite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHVolcite] = ACTIONS(6626),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHavolcite] = ACTIONS(6626),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHNotecite] = ACTIONS(6626),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHlabel] = ACTIONS(6626),
    [anon_sym_BSLASHref] = ACTIONS(6626),
    [anon_sym_BSLASHeqref] = ACTIONS(6626),
    [anon_sym_BSLASHvref] = ACTIONS(6626),
    [anon_sym_BSLASHVref] = ACTIONS(6626),
    [anon_sym_BSLASHautoref] = ACTIONS(6626),
    [anon_sym_BSLASHpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcref] = ACTIONS(6626),
    [anon_sym_BSLASHCref] = ACTIONS(6626),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnameCref] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHdef] = ACTIONS(6626),
    [anon_sym_BSLASHlet] = ACTIONS(6626),
    [anon_sym_BSLASHleft] = ACTIONS(6626),
    [anon_sym_BSLASHbigl] = ACTIONS(6626),
    [anon_sym_BSLASHBigl] = ACTIONS(6626),
    [anon_sym_BSLASHbiggl] = ACTIONS(6626),
    [anon_sym_BSLASHBiggl] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6626),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6626),
    [anon_sym_BSLASHgls] = ACTIONS(6626),
    [anon_sym_BSLASHGls] = ACTIONS(6626),
    [anon_sym_BSLASHGLS] = ACTIONS(6626),
    [anon_sym_BSLASHglspl] = ACTIONS(6626),
    [anon_sym_BSLASHGlspl] = ACTIONS(6626),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6626),
    [anon_sym_BSLASHglslink] = ACTIONS(6626),
    [anon_sym_BSLASHglstext] = ACTIONS(6626),
    [anon_sym_BSLASHGlstext] = ACTIONS(6626),
    [anon_sym_BSLASHGLStext] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6626),
    [anon_sym_BSLASHglsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsname] = ACTIONS(6626),
    [anon_sym_BSLASHGlsname] = ACTIONS(6626),
    [anon_sym_BSLASHGLSname] = ACTIONS(6626),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6626),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6626),
    [anon_sym_BSLASHacrshort] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6626),
    [anon_sym_BSLASHACRshort] = ACTIONS(6626),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrlong] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6626),
    [anon_sym_BSLASHACRlong] = ACTIONS(6626),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrfull] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6626),
    [anon_sym_BSLASHACRfull] = ACTIONS(6626),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHacs] = ACTIONS(6626),
    [anon_sym_BSLASHAcs] = ACTIONS(6626),
    [anon_sym_BSLASHacsp] = ACTIONS(6626),
    [anon_sym_BSLASHAcsp] = ACTIONS(6626),
    [anon_sym_BSLASHacl] = ACTIONS(6626),
    [anon_sym_BSLASHAcl] = ACTIONS(6626),
    [anon_sym_BSLASHaclp] = ACTIONS(6626),
    [anon_sym_BSLASHAclp] = ACTIONS(6626),
    [anon_sym_BSLASHacf] = ACTIONS(6626),
    [anon_sym_BSLASHAcf] = ACTIONS(6626),
    [anon_sym_BSLASHacfp] = ACTIONS(6626),
    [anon_sym_BSLASHAcfp] = ACTIONS(6626),
    [anon_sym_BSLASHac] = ACTIONS(6626),
    [anon_sym_BSLASHAc] = ACTIONS(6626),
    [anon_sym_BSLASHacp] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6626),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6626),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6626),
    [anon_sym_BSLASHcolor] = ACTIONS(6626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6626),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6626),
    [anon_sym_BSLASHtext] = ACTIONS(6626),
    [anon_sym_BSLASHintertext] = ACTIONS(6626),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6626),
    [anon_sym_BSLASHurl] = ACTIONS(6626),
    [anon_sym_BSLASHhref] = ACTIONS(6626),
  },
  [1628] = {
    [sym_command_name] = ACTIONS(6598),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6598),
    [anon_sym_LBRACK] = ACTIONS(6600),
    [anon_sym_RBRACK] = ACTIONS(6600),
    [anon_sym_COMMA] = ACTIONS(6600),
    [anon_sym_EQ] = ACTIONS(6600),
    [anon_sym_LPAREN] = ACTIONS(6600),
    [anon_sym_RPAREN] = ACTIONS(6600),
    [anon_sym_LBRACE] = ACTIONS(6600),
    [sym_word] = ACTIONS(6598),
    [sym_placeholder] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6600),
    [anon_sym_DASH] = ACTIONS(6600),
    [anon_sym_STAR] = ACTIONS(6600),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_BANG] = ACTIONS(6598),
    [anon_sym_PIPE] = ACTIONS(6598),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_SQUOTE] = ACTIONS(6598),
    [anon_sym__] = ACTIONS(6600),
    [anon_sym_CARET] = ACTIONS(6600),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6600),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6600),
    [anon_sym_DOLLAR] = ACTIONS(6598),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHbegin] = ACTIONS(6598),
    [anon_sym_BSLASHend] = ACTIONS(6598),
    [anon_sym_BSLASHtitle] = ACTIONS(6598),
    [anon_sym_BSLASHauthor] = ACTIONS(6598),
    [anon_sym_BSLASHusepackage] = ACTIONS(6598),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6598),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6598),
    [anon_sym_BSLASHinclude] = ACTIONS(6598),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6598),
    [anon_sym_BSLASHinput] = ACTIONS(6598),
    [anon_sym_BSLASHsubfile] = ACTIONS(6598),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6598),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6598),
    [anon_sym_BSLASHbibliography] = ACTIONS(6598),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6598),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6598),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6598),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6598),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6598),
    [anon_sym_BSLASHimport] = ACTIONS(6598),
    [anon_sym_BSLASHsubimport] = ACTIONS(6598),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6598),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHcaption] = ACTIONS(6598),
    [anon_sym_BSLASHcite] = ACTIONS(6598),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCite] = ACTIONS(6598),
    [anon_sym_BSLASHnocite] = ACTIONS(6598),
    [anon_sym_BSLASHcitet] = ACTIONS(6598),
    [anon_sym_BSLASHcitep] = ACTIONS(6598),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteA] = ACTIONS(6598),
    [anon_sym_BSLASHciteR] = ACTIONS(6598),
    [anon_sym_BSLASHciteS] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6598),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteyear] = ACTIONS(6598),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitedate] = ACTIONS(6598),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteurl] = ACTIONS(6598),
    [anon_sym_BSLASHfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6598),
    [anon_sym_BSLASHcitealt] = ACTIONS(6598),
    [anon_sym_BSLASHcitealp] = ACTIONS(6598),
    [anon_sym_BSLASHcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHparencite] = ACTIONS(6598),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHParencite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHtextcite] = ACTIONS(6598),
    [anon_sym_BSLASHTextcite] = ACTIONS(6598),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHsupercite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite] = ACTIONS(6598),
    [anon_sym_BSLASHAutocite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHVolcite] = ACTIONS(6598),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHavolcite] = ACTIONS(6598),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHNotecite] = ACTIONS(6598),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHlabel] = ACTIONS(6598),
    [anon_sym_BSLASHref] = ACTIONS(6598),
    [anon_sym_BSLASHeqref] = ACTIONS(6598),
    [anon_sym_BSLASHvref] = ACTIONS(6598),
    [anon_sym_BSLASHVref] = ACTIONS(6598),
    [anon_sym_BSLASHautoref] = ACTIONS(6598),
    [anon_sym_BSLASHpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcref] = ACTIONS(6598),
    [anon_sym_BSLASHCref] = ACTIONS(6598),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnameCref] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHdef] = ACTIONS(6598),
    [anon_sym_BSLASHlet] = ACTIONS(6598),
    [anon_sym_BSLASHleft] = ACTIONS(6598),
    [anon_sym_BSLASHbigl] = ACTIONS(6598),
    [anon_sym_BSLASHBigl] = ACTIONS(6598),
    [anon_sym_BSLASHbiggl] = ACTIONS(6598),
    [anon_sym_BSLASHBiggl] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6598),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6598),
    [anon_sym_BSLASHgls] = ACTIONS(6598),
    [anon_sym_BSLASHGls] = ACTIONS(6598),
    [anon_sym_BSLASHGLS] = ACTIONS(6598),
    [anon_sym_BSLASHglspl] = ACTIONS(6598),
    [anon_sym_BSLASHGlspl] = ACTIONS(6598),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6598),
    [anon_sym_BSLASHglslink] = ACTIONS(6598),
    [anon_sym_BSLASHglstext] = ACTIONS(6598),
    [anon_sym_BSLASHGlstext] = ACTIONS(6598),
    [anon_sym_BSLASHGLStext] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6598),
    [anon_sym_BSLASHglsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsname] = ACTIONS(6598),
    [anon_sym_BSLASHGlsname] = ACTIONS(6598),
    [anon_sym_BSLASHGLSname] = ACTIONS(6598),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6598),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6598),
    [anon_sym_BSLASHacrshort] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6598),
    [anon_sym_BSLASHACRshort] = ACTIONS(6598),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrlong] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6598),
    [anon_sym_BSLASHACRlong] = ACTIONS(6598),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrfull] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6598),
    [anon_sym_BSLASHACRfull] = ACTIONS(6598),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHacs] = ACTIONS(6598),
    [anon_sym_BSLASHAcs] = ACTIONS(6598),
    [anon_sym_BSLASHacsp] = ACTIONS(6598),
    [anon_sym_BSLASHAcsp] = ACTIONS(6598),
    [anon_sym_BSLASHacl] = ACTIONS(6598),
    [anon_sym_BSLASHAcl] = ACTIONS(6598),
    [anon_sym_BSLASHaclp] = ACTIONS(6598),
    [anon_sym_BSLASHAclp] = ACTIONS(6598),
    [anon_sym_BSLASHacf] = ACTIONS(6598),
    [anon_sym_BSLASHAcf] = ACTIONS(6598),
    [anon_sym_BSLASHacfp] = ACTIONS(6598),
    [anon_sym_BSLASHAcfp] = ACTIONS(6598),
    [anon_sym_BSLASHac] = ACTIONS(6598),
    [anon_sym_BSLASHAc] = ACTIONS(6598),
    [anon_sym_BSLASHacp] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6598),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6598),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6598),
    [anon_sym_BSLASHcolor] = ACTIONS(6598),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6598),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6598),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6598),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6598),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6598),
    [anon_sym_BSLASHtext] = ACTIONS(6598),
    [anon_sym_BSLASHintertext] = ACTIONS(6598),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6598),
    [anon_sym_BSLASHurl] = ACTIONS(6598),
    [anon_sym_BSLASHhref] = ACTIONS(6598),
  },
  [1629] = {
    [sym_command_name] = ACTIONS(6590),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6590),
    [anon_sym_LBRACK] = ACTIONS(6592),
    [anon_sym_RBRACK] = ACTIONS(6592),
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(6592),
    [anon_sym_LPAREN] = ACTIONS(6592),
    [anon_sym_RPAREN] = ACTIONS(6592),
    [anon_sym_LBRACE] = ACTIONS(6592),
    [sym_word] = ACTIONS(6590),
    [sym_placeholder] = ACTIONS(6592),
    [anon_sym_PLUS] = ACTIONS(6592),
    [anon_sym_DASH] = ACTIONS(6592),
    [anon_sym_STAR] = ACTIONS(6592),
    [anon_sym_SLASH] = ACTIONS(6592),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6592),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6592),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6592),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHbegin] = ACTIONS(6590),
    [anon_sym_BSLASHend] = ACTIONS(6590),
    [anon_sym_BSLASHtitle] = ACTIONS(6590),
    [anon_sym_BSLASHauthor] = ACTIONS(6590),
    [anon_sym_BSLASHusepackage] = ACTIONS(6590),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6590),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6590),
    [anon_sym_BSLASHinclude] = ACTIONS(6590),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6590),
    [anon_sym_BSLASHinput] = ACTIONS(6590),
    [anon_sym_BSLASHsubfile] = ACTIONS(6590),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6590),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6590),
    [anon_sym_BSLASHbibliography] = ACTIONS(6590),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6590),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6590),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6590),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6590),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6590),
    [anon_sym_BSLASHimport] = ACTIONS(6590),
    [anon_sym_BSLASHsubimport] = ACTIONS(6590),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6590),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHcaption] = ACTIONS(6590),
    [anon_sym_BSLASHcite] = ACTIONS(6590),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCite] = ACTIONS(6590),
    [anon_sym_BSLASHnocite] = ACTIONS(6590),
    [anon_sym_BSLASHcitet] = ACTIONS(6590),
    [anon_sym_BSLASHcitep] = ACTIONS(6590),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteA] = ACTIONS(6590),
    [anon_sym_BSLASHciteR] = ACTIONS(6590),
    [anon_sym_BSLASHciteS] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6590),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteyear] = ACTIONS(6590),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitedate] = ACTIONS(6590),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteurl] = ACTIONS(6590),
    [anon_sym_BSLASHfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6590),
    [anon_sym_BSLASHcitealt] = ACTIONS(6590),
    [anon_sym_BSLASHcitealp] = ACTIONS(6590),
    [anon_sym_BSLASHcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHparencite] = ACTIONS(6590),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHParencite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHtextcite] = ACTIONS(6590),
    [anon_sym_BSLASHTextcite] = ACTIONS(6590),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHsupercite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite] = ACTIONS(6590),
    [anon_sym_BSLASHAutocite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHVolcite] = ACTIONS(6590),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHavolcite] = ACTIONS(6590),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHNotecite] = ACTIONS(6590),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHlabel] = ACTIONS(6590),
    [anon_sym_BSLASHref] = ACTIONS(6590),
    [anon_sym_BSLASHeqref] = ACTIONS(6590),
    [anon_sym_BSLASHvref] = ACTIONS(6590),
    [anon_sym_BSLASHVref] = ACTIONS(6590),
    [anon_sym_BSLASHautoref] = ACTIONS(6590),
    [anon_sym_BSLASHpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcref] = ACTIONS(6590),
    [anon_sym_BSLASHCref] = ACTIONS(6590),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnameCref] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHdef] = ACTIONS(6590),
    [anon_sym_BSLASHlet] = ACTIONS(6590),
    [anon_sym_BSLASHleft] = ACTIONS(6590),
    [anon_sym_BSLASHbigl] = ACTIONS(6590),
    [anon_sym_BSLASHBigl] = ACTIONS(6590),
    [anon_sym_BSLASHbiggl] = ACTIONS(6590),
    [anon_sym_BSLASHBiggl] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6590),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6590),
    [anon_sym_BSLASHgls] = ACTIONS(6590),
    [anon_sym_BSLASHGls] = ACTIONS(6590),
    [anon_sym_BSLASHGLS] = ACTIONS(6590),
    [anon_sym_BSLASHglspl] = ACTIONS(6590),
    [anon_sym_BSLASHGlspl] = ACTIONS(6590),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6590),
    [anon_sym_BSLASHglslink] = ACTIONS(6590),
    [anon_sym_BSLASHglstext] = ACTIONS(6590),
    [anon_sym_BSLASHGlstext] = ACTIONS(6590),
    [anon_sym_BSLASHGLStext] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6590),
    [anon_sym_BSLASHglsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsname] = ACTIONS(6590),
    [anon_sym_BSLASHGlsname] = ACTIONS(6590),
    [anon_sym_BSLASHGLSname] = ACTIONS(6590),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6590),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6590),
    [anon_sym_BSLASHacrshort] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6590),
    [anon_sym_BSLASHACRshort] = ACTIONS(6590),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrlong] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6590),
    [anon_sym_BSLASHACRlong] = ACTIONS(6590),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrfull] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6590),
    [anon_sym_BSLASHACRfull] = ACTIONS(6590),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHacs] = ACTIONS(6590),
    [anon_sym_BSLASHAcs] = ACTIONS(6590),
    [anon_sym_BSLASHacsp] = ACTIONS(6590),
    [anon_sym_BSLASHAcsp] = ACTIONS(6590),
    [anon_sym_BSLASHacl] = ACTIONS(6590),
    [anon_sym_BSLASHAcl] = ACTIONS(6590),
    [anon_sym_BSLASHaclp] = ACTIONS(6590),
    [anon_sym_BSLASHAclp] = ACTIONS(6590),
    [anon_sym_BSLASHacf] = ACTIONS(6590),
    [anon_sym_BSLASHAcf] = ACTIONS(6590),
    [anon_sym_BSLASHacfp] = ACTIONS(6590),
    [anon_sym_BSLASHAcfp] = ACTIONS(6590),
    [anon_sym_BSLASHac] = ACTIONS(6590),
    [anon_sym_BSLASHAc] = ACTIONS(6590),
    [anon_sym_BSLASHacp] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6590),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6590),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6590),
    [anon_sym_BSLASHcolor] = ACTIONS(6590),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6590),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6590),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6590),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6590),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6590),
    [anon_sym_BSLASHtext] = ACTIONS(6590),
    [anon_sym_BSLASHintertext] = ACTIONS(6590),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6590),
    [anon_sym_BSLASHurl] = ACTIONS(6590),
    [anon_sym_BSLASHhref] = ACTIONS(6590),
  },
  [1630] = {
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(7152),
    [anon_sym_LBRACK] = ACTIONS(6160),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6160),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(6156),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHbegin] = ACTIONS(6156),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHleft] = ACTIONS(6156),
    [anon_sym_BSLASHbigl] = ACTIONS(6156),
    [anon_sym_BSLASHBigl] = ACTIONS(6156),
    [anon_sym_BSLASHbiggl] = ACTIONS(6156),
    [anon_sym_BSLASHBiggl] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHtext] = ACTIONS(6156),
    [anon_sym_BSLASHintertext] = ACTIONS(6156),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [1631] = {
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(6578),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6578),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_LPAREN] = ACTIONS(6578),
    [anon_sym_RPAREN] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6578),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHbegin] = ACTIONS(6576),
    [anon_sym_BSLASHend] = ACTIONS(6576),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHleft] = ACTIONS(6576),
    [anon_sym_BSLASHbigl] = ACTIONS(6576),
    [anon_sym_BSLASHBigl] = ACTIONS(6576),
    [anon_sym_BSLASHbiggl] = ACTIONS(6576),
    [anon_sym_BSLASHBiggl] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHtext] = ACTIONS(6576),
    [anon_sym_BSLASHintertext] = ACTIONS(6576),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [1632] = {
    [sym_brack_group_text] = STATE(1766),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(7144),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6168),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6166),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHbegin] = ACTIONS(6166),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHleft] = ACTIONS(6166),
    [anon_sym_BSLASHbigl] = ACTIONS(6166),
    [anon_sym_BSLASHBigl] = ACTIONS(6166),
    [anon_sym_BSLASHbiggl] = ACTIONS(6166),
    [anon_sym_BSLASHBiggl] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHtext] = ACTIONS(6166),
    [anon_sym_BSLASHintertext] = ACTIONS(6166),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [1633] = {
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6300),
    [anon_sym_DOLLAR] = ACTIONS(6298),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHbegin] = ACTIONS(6298),
    [anon_sym_BSLASHend] = ACTIONS(6298),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHleft] = ACTIONS(6298),
    [anon_sym_BSLASHbigl] = ACTIONS(6298),
    [anon_sym_BSLASHBigl] = ACTIONS(6298),
    [anon_sym_BSLASHbiggl] = ACTIONS(6298),
    [anon_sym_BSLASHBiggl] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHtext] = ACTIONS(6298),
    [anon_sym_BSLASHintertext] = ACTIONS(6298),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [1634] = {
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_LPAREN] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6304),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6304),
    [anon_sym_DOLLAR] = ACTIONS(6302),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHbegin] = ACTIONS(6302),
    [anon_sym_BSLASHend] = ACTIONS(6302),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHleft] = ACTIONS(6302),
    [anon_sym_BSLASHbigl] = ACTIONS(6302),
    [anon_sym_BSLASHBigl] = ACTIONS(6302),
    [anon_sym_BSLASHbiggl] = ACTIONS(6302),
    [anon_sym_BSLASHBiggl] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHtext] = ACTIONS(6302),
    [anon_sym_BSLASHintertext] = ACTIONS(6302),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [1635] = {
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6308),
    [anon_sym_RBRACK] = ACTIONS(6308),
    [anon_sym_COMMA] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(6308),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_RPAREN] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6308),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6308),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6308),
    [anon_sym_DOLLAR] = ACTIONS(6306),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHbegin] = ACTIONS(6306),
    [anon_sym_BSLASHend] = ACTIONS(6306),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHleft] = ACTIONS(6306),
    [anon_sym_BSLASHbigl] = ACTIONS(6306),
    [anon_sym_BSLASHBigl] = ACTIONS(6306),
    [anon_sym_BSLASHbiggl] = ACTIONS(6306),
    [anon_sym_BSLASHBiggl] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHtext] = ACTIONS(6306),
    [anon_sym_BSLASHintertext] = ACTIONS(6306),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [1636] = {
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_RBRACK] = ACTIONS(6340),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_EQ] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6340),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6340),
    [anon_sym_DOLLAR] = ACTIONS(6338),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHbegin] = ACTIONS(6338),
    [anon_sym_BSLASHend] = ACTIONS(6338),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHleft] = ACTIONS(6338),
    [anon_sym_BSLASHbigl] = ACTIONS(6338),
    [anon_sym_BSLASHBigl] = ACTIONS(6338),
    [anon_sym_BSLASHbiggl] = ACTIONS(6338),
    [anon_sym_BSLASHBiggl] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHtext] = ACTIONS(6338),
    [anon_sym_BSLASHintertext] = ACTIONS(6338),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [1637] = {
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_RPAREN] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6344),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6344),
    [anon_sym_DOLLAR] = ACTIONS(6342),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHbegin] = ACTIONS(6342),
    [anon_sym_BSLASHend] = ACTIONS(6342),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHleft] = ACTIONS(6342),
    [anon_sym_BSLASHbigl] = ACTIONS(6342),
    [anon_sym_BSLASHBigl] = ACTIONS(6342),
    [anon_sym_BSLASHbiggl] = ACTIONS(6342),
    [anon_sym_BSLASHBiggl] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHtext] = ACTIONS(6342),
    [anon_sym_BSLASHintertext] = ACTIONS(6342),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [1638] = {
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_RBRACK] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LPAREN] = ACTIONS(6360),
    [anon_sym_RPAREN] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(6360),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6360),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6358),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHbegin] = ACTIONS(6358),
    [anon_sym_BSLASHend] = ACTIONS(6358),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHleft] = ACTIONS(6358),
    [anon_sym_BSLASHbigl] = ACTIONS(6358),
    [anon_sym_BSLASHBigl] = ACTIONS(6358),
    [anon_sym_BSLASHbiggl] = ACTIONS(6358),
    [anon_sym_BSLASHBiggl] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHtext] = ACTIONS(6358),
    [anon_sym_BSLASHintertext] = ACTIONS(6358),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [1639] = {
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_RBRACK] = ACTIONS(6368),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_LPAREN] = ACTIONS(6368),
    [anon_sym_RPAREN] = ACTIONS(6368),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6368),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6366),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHbegin] = ACTIONS(6366),
    [anon_sym_BSLASHend] = ACTIONS(6366),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHleft] = ACTIONS(6366),
    [anon_sym_BSLASHbigl] = ACTIONS(6366),
    [anon_sym_BSLASHBigl] = ACTIONS(6366),
    [anon_sym_BSLASHbiggl] = ACTIONS(6366),
    [anon_sym_BSLASHBiggl] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHtext] = ACTIONS(6366),
    [anon_sym_BSLASHintertext] = ACTIONS(6366),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [1640] = {
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_RBRACK] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LPAREN] = ACTIONS(6372),
    [anon_sym_RPAREN] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6372),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6370),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHbegin] = ACTIONS(6370),
    [anon_sym_BSLASHend] = ACTIONS(6370),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHleft] = ACTIONS(6370),
    [anon_sym_BSLASHbigl] = ACTIONS(6370),
    [anon_sym_BSLASHBigl] = ACTIONS(6370),
    [anon_sym_BSLASHbiggl] = ACTIONS(6370),
    [anon_sym_BSLASHBiggl] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHtext] = ACTIONS(6370),
    [anon_sym_BSLASHintertext] = ACTIONS(6370),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [1641] = {
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6460),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_COMMA] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_LPAREN] = ACTIONS(6460),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6460),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6460),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6460),
    [anon_sym_DOLLAR] = ACTIONS(6458),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHbegin] = ACTIONS(6458),
    [anon_sym_BSLASHend] = ACTIONS(6458),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHleft] = ACTIONS(6458),
    [anon_sym_BSLASHbigl] = ACTIONS(6458),
    [anon_sym_BSLASHBigl] = ACTIONS(6458),
    [anon_sym_BSLASHbiggl] = ACTIONS(6458),
    [anon_sym_BSLASHBiggl] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHtext] = ACTIONS(6458),
    [anon_sym_BSLASHintertext] = ACTIONS(6458),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [1642] = {
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6464),
    [anon_sym_RBRACK] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_EQ] = ACTIONS(6464),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6464),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(6462),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHbegin] = ACTIONS(6462),
    [anon_sym_BSLASHend] = ACTIONS(6462),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHleft] = ACTIONS(6462),
    [anon_sym_BSLASHbigl] = ACTIONS(6462),
    [anon_sym_BSLASHBigl] = ACTIONS(6462),
    [anon_sym_BSLASHbiggl] = ACTIONS(6462),
    [anon_sym_BSLASHBiggl] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHtext] = ACTIONS(6462),
    [anon_sym_BSLASHintertext] = ACTIONS(6462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [1643] = {
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_LBRACK] = ACTIONS(6468),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_COMMA] = ACTIONS(6468),
    [anon_sym_EQ] = ACTIONS(6468),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6468),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6466),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHbegin] = ACTIONS(6466),
    [anon_sym_BSLASHend] = ACTIONS(6466),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHleft] = ACTIONS(6466),
    [anon_sym_BSLASHbigl] = ACTIONS(6466),
    [anon_sym_BSLASHBigl] = ACTIONS(6466),
    [anon_sym_BSLASHbiggl] = ACTIONS(6466),
    [anon_sym_BSLASHBiggl] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHtext] = ACTIONS(6466),
    [anon_sym_BSLASHintertext] = ACTIONS(6466),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [1644] = {
    [sym_command_name] = ACTIONS(6594),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6596),
    [anon_sym_LPAREN] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_LBRACE] = ACTIONS(6596),
    [sym_word] = ACTIONS(6594),
    [sym_placeholder] = ACTIONS(6596),
    [anon_sym_PLUS] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6596),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_SLASH] = ACTIONS(6596),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_BANG] = ACTIONS(6594),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SQUOTE] = ACTIONS(6594),
    [anon_sym__] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(6596),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6596),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(6594),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHbegin] = ACTIONS(6594),
    [anon_sym_BSLASHend] = ACTIONS(6594),
    [anon_sym_BSLASHtitle] = ACTIONS(6594),
    [anon_sym_BSLASHauthor] = ACTIONS(6594),
    [anon_sym_BSLASHusepackage] = ACTIONS(6594),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6594),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6594),
    [anon_sym_BSLASHinclude] = ACTIONS(6594),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6594),
    [anon_sym_BSLASHinput] = ACTIONS(6594),
    [anon_sym_BSLASHsubfile] = ACTIONS(6594),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6594),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6594),
    [anon_sym_BSLASHbibliography] = ACTIONS(6594),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6594),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6594),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6594),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6594),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6594),
    [anon_sym_BSLASHimport] = ACTIONS(6594),
    [anon_sym_BSLASHsubimport] = ACTIONS(6594),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6594),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHcaption] = ACTIONS(6594),
    [anon_sym_BSLASHcite] = ACTIONS(6594),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCite] = ACTIONS(6594),
    [anon_sym_BSLASHnocite] = ACTIONS(6594),
    [anon_sym_BSLASHcitet] = ACTIONS(6594),
    [anon_sym_BSLASHcitep] = ACTIONS(6594),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteA] = ACTIONS(6594),
    [anon_sym_BSLASHciteR] = ACTIONS(6594),
    [anon_sym_BSLASHciteS] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6594),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteyear] = ACTIONS(6594),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitedate] = ACTIONS(6594),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteurl] = ACTIONS(6594),
    [anon_sym_BSLASHfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6594),
    [anon_sym_BSLASHcitealt] = ACTIONS(6594),
    [anon_sym_BSLASHcitealp] = ACTIONS(6594),
    [anon_sym_BSLASHcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHparencite] = ACTIONS(6594),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHParencite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHtextcite] = ACTIONS(6594),
    [anon_sym_BSLASHTextcite] = ACTIONS(6594),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHsupercite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite] = ACTIONS(6594),
    [anon_sym_BSLASHAutocite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHVolcite] = ACTIONS(6594),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHavolcite] = ACTIONS(6594),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHNotecite] = ACTIONS(6594),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHlabel] = ACTIONS(6594),
    [anon_sym_BSLASHref] = ACTIONS(6594),
    [anon_sym_BSLASHeqref] = ACTIONS(6594),
    [anon_sym_BSLASHvref] = ACTIONS(6594),
    [anon_sym_BSLASHVref] = ACTIONS(6594),
    [anon_sym_BSLASHautoref] = ACTIONS(6594),
    [anon_sym_BSLASHpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcref] = ACTIONS(6594),
    [anon_sym_BSLASHCref] = ACTIONS(6594),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnameCref] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHdef] = ACTIONS(6594),
    [anon_sym_BSLASHlet] = ACTIONS(6594),
    [anon_sym_BSLASHleft] = ACTIONS(6594),
    [anon_sym_BSLASHbigl] = ACTIONS(6594),
    [anon_sym_BSLASHBigl] = ACTIONS(6594),
    [anon_sym_BSLASHbiggl] = ACTIONS(6594),
    [anon_sym_BSLASHBiggl] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6594),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6594),
    [anon_sym_BSLASHgls] = ACTIONS(6594),
    [anon_sym_BSLASHGls] = ACTIONS(6594),
    [anon_sym_BSLASHGLS] = ACTIONS(6594),
    [anon_sym_BSLASHglspl] = ACTIONS(6594),
    [anon_sym_BSLASHGlspl] = ACTIONS(6594),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6594),
    [anon_sym_BSLASHglslink] = ACTIONS(6594),
    [anon_sym_BSLASHglstext] = ACTIONS(6594),
    [anon_sym_BSLASHGlstext] = ACTIONS(6594),
    [anon_sym_BSLASHGLStext] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6594),
    [anon_sym_BSLASHglsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsname] = ACTIONS(6594),
    [anon_sym_BSLASHGlsname] = ACTIONS(6594),
    [anon_sym_BSLASHGLSname] = ACTIONS(6594),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6594),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6594),
    [anon_sym_BSLASHacrshort] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6594),
    [anon_sym_BSLASHACRshort] = ACTIONS(6594),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrlong] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6594),
    [anon_sym_BSLASHACRlong] = ACTIONS(6594),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrfull] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6594),
    [anon_sym_BSLASHACRfull] = ACTIONS(6594),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHacs] = ACTIONS(6594),
    [anon_sym_BSLASHAcs] = ACTIONS(6594),
    [anon_sym_BSLASHacsp] = ACTIONS(6594),
    [anon_sym_BSLASHAcsp] = ACTIONS(6594),
    [anon_sym_BSLASHacl] = ACTIONS(6594),
    [anon_sym_BSLASHAcl] = ACTIONS(6594),
    [anon_sym_BSLASHaclp] = ACTIONS(6594),
    [anon_sym_BSLASHAclp] = ACTIONS(6594),
    [anon_sym_BSLASHacf] = ACTIONS(6594),
    [anon_sym_BSLASHAcf] = ACTIONS(6594),
    [anon_sym_BSLASHacfp] = ACTIONS(6594),
    [anon_sym_BSLASHAcfp] = ACTIONS(6594),
    [anon_sym_BSLASHac] = ACTIONS(6594),
    [anon_sym_BSLASHAc] = ACTIONS(6594),
    [anon_sym_BSLASHacp] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6594),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6594),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6594),
    [anon_sym_BSLASHcolor] = ACTIONS(6594),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6594),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6594),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6594),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6594),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6594),
    [anon_sym_BSLASHtext] = ACTIONS(6594),
    [anon_sym_BSLASHintertext] = ACTIONS(6594),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6594),
    [anon_sym_BSLASHurl] = ACTIONS(6594),
    [anon_sym_BSLASHhref] = ACTIONS(6594),
  },
  [1645] = {
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_LBRACK] = ACTIONS(6476),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_RPAREN] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6476),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6476),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHbegin] = ACTIONS(6474),
    [anon_sym_BSLASHend] = ACTIONS(6474),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHleft] = ACTIONS(6474),
    [anon_sym_BSLASHbigl] = ACTIONS(6474),
    [anon_sym_BSLASHBigl] = ACTIONS(6474),
    [anon_sym_BSLASHbiggl] = ACTIONS(6474),
    [anon_sym_BSLASHBiggl] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHtext] = ACTIONS(6474),
    [anon_sym_BSLASHintertext] = ACTIONS(6474),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [1646] = {
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6480),
    [anon_sym_EQ] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6480),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6480),
    [anon_sym_DOLLAR] = ACTIONS(6478),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHbegin] = ACTIONS(6478),
    [anon_sym_BSLASHend] = ACTIONS(6478),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHleft] = ACTIONS(6478),
    [anon_sym_BSLASHbigl] = ACTIONS(6478),
    [anon_sym_BSLASHBigl] = ACTIONS(6478),
    [anon_sym_BSLASHbiggl] = ACTIONS(6478),
    [anon_sym_BSLASHBiggl] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHtext] = ACTIONS(6478),
    [anon_sym_BSLASHintertext] = ACTIONS(6478),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [1647] = {
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6484),
    [anon_sym_RBRACK] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6484),
    [anon_sym_EQ] = ACTIONS(6484),
    [anon_sym_LPAREN] = ACTIONS(6484),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_LBRACE] = ACTIONS(6484),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6484),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6484),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHbegin] = ACTIONS(6482),
    [anon_sym_BSLASHend] = ACTIONS(6482),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHleft] = ACTIONS(6482),
    [anon_sym_BSLASHbigl] = ACTIONS(6482),
    [anon_sym_BSLASHBigl] = ACTIONS(6482),
    [anon_sym_BSLASHbiggl] = ACTIONS(6482),
    [anon_sym_BSLASHBiggl] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHtext] = ACTIONS(6482),
    [anon_sym_BSLASHintertext] = ACTIONS(6482),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [1648] = {
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_LBRACK] = ACTIONS(6488),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_COMMA] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6488),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6488),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(6486),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHbegin] = ACTIONS(6486),
    [anon_sym_BSLASHend] = ACTIONS(6486),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHleft] = ACTIONS(6486),
    [anon_sym_BSLASHbigl] = ACTIONS(6486),
    [anon_sym_BSLASHBigl] = ACTIONS(6486),
    [anon_sym_BSLASHbiggl] = ACTIONS(6486),
    [anon_sym_BSLASHBiggl] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHtext] = ACTIONS(6486),
    [anon_sym_BSLASHintertext] = ACTIONS(6486),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [1649] = {
    [sym_command_name] = ACTIONS(6710),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(6712),
    [anon_sym_RBRACK] = ACTIONS(6712),
    [anon_sym_COMMA] = ACTIONS(6712),
    [anon_sym_EQ] = ACTIONS(6712),
    [anon_sym_LPAREN] = ACTIONS(6712),
    [anon_sym_RPAREN] = ACTIONS(6712),
    [anon_sym_LBRACE] = ACTIONS(6712),
    [sym_word] = ACTIONS(6710),
    [sym_placeholder] = ACTIONS(6712),
    [anon_sym_PLUS] = ACTIONS(6712),
    [anon_sym_DASH] = ACTIONS(6712),
    [anon_sym_STAR] = ACTIONS(6712),
    [anon_sym_SLASH] = ACTIONS(6712),
    [anon_sym_LT] = ACTIONS(6710),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_PIPE] = ACTIONS(6710),
    [anon_sym_COLON] = ACTIONS(6710),
    [anon_sym_SQUOTE] = ACTIONS(6710),
    [anon_sym__] = ACTIONS(6712),
    [anon_sym_CARET] = ACTIONS(6712),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6712),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6712),
    [anon_sym_DOLLAR] = ACTIONS(6710),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHbegin] = ACTIONS(6710),
    [anon_sym_BSLASHend] = ACTIONS(6710),
    [anon_sym_BSLASHtitle] = ACTIONS(6710),
    [anon_sym_BSLASHauthor] = ACTIONS(6710),
    [anon_sym_BSLASHusepackage] = ACTIONS(6710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6710),
    [anon_sym_BSLASHinclude] = ACTIONS(6710),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6710),
    [anon_sym_BSLASHinput] = ACTIONS(6710),
    [anon_sym_BSLASHsubfile] = ACTIONS(6710),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6710),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6710),
    [anon_sym_BSLASHbibliography] = ACTIONS(6710),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6710),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6710),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6710),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6710),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6710),
    [anon_sym_BSLASHimport] = ACTIONS(6710),
    [anon_sym_BSLASHsubimport] = ACTIONS(6710),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6710),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHcaption] = ACTIONS(6710),
    [anon_sym_BSLASHcite] = ACTIONS(6710),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCite] = ACTIONS(6710),
    [anon_sym_BSLASHnocite] = ACTIONS(6710),
    [anon_sym_BSLASHcitet] = ACTIONS(6710),
    [anon_sym_BSLASHcitep] = ACTIONS(6710),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteA] = ACTIONS(6710),
    [anon_sym_BSLASHciteR] = ACTIONS(6710),
    [anon_sym_BSLASHciteS] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6710),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteyear] = ACTIONS(6710),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitedate] = ACTIONS(6710),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteurl] = ACTIONS(6710),
    [anon_sym_BSLASHfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6710),
    [anon_sym_BSLASHcitealt] = ACTIONS(6710),
    [anon_sym_BSLASHcitealp] = ACTIONS(6710),
    [anon_sym_BSLASHcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHparencite] = ACTIONS(6710),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHParencite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHtextcite] = ACTIONS(6710),
    [anon_sym_BSLASHTextcite] = ACTIONS(6710),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHsupercite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite] = ACTIONS(6710),
    [anon_sym_BSLASHAutocite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHVolcite] = ACTIONS(6710),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHavolcite] = ACTIONS(6710),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHNotecite] = ACTIONS(6710),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHlabel] = ACTIONS(6710),
    [anon_sym_BSLASHref] = ACTIONS(6710),
    [anon_sym_BSLASHeqref] = ACTIONS(6710),
    [anon_sym_BSLASHvref] = ACTIONS(6710),
    [anon_sym_BSLASHVref] = ACTIONS(6710),
    [anon_sym_BSLASHautoref] = ACTIONS(6710),
    [anon_sym_BSLASHpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcref] = ACTIONS(6710),
    [anon_sym_BSLASHCref] = ACTIONS(6710),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnameCref] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHdef] = ACTIONS(6710),
    [anon_sym_BSLASHlet] = ACTIONS(6710),
    [anon_sym_BSLASHleft] = ACTIONS(6710),
    [anon_sym_BSLASHbigl] = ACTIONS(6710),
    [anon_sym_BSLASHBigl] = ACTIONS(6710),
    [anon_sym_BSLASHbiggl] = ACTIONS(6710),
    [anon_sym_BSLASHBiggl] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6710),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6710),
    [anon_sym_BSLASHgls] = ACTIONS(6710),
    [anon_sym_BSLASHGls] = ACTIONS(6710),
    [anon_sym_BSLASHGLS] = ACTIONS(6710),
    [anon_sym_BSLASHglspl] = ACTIONS(6710),
    [anon_sym_BSLASHGlspl] = ACTIONS(6710),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6710),
    [anon_sym_BSLASHglslink] = ACTIONS(6710),
    [anon_sym_BSLASHglstext] = ACTIONS(6710),
    [anon_sym_BSLASHGlstext] = ACTIONS(6710),
    [anon_sym_BSLASHGLStext] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6710),
    [anon_sym_BSLASHglsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsname] = ACTIONS(6710),
    [anon_sym_BSLASHGlsname] = ACTIONS(6710),
    [anon_sym_BSLASHGLSname] = ACTIONS(6710),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6710),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6710),
    [anon_sym_BSLASHacrshort] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6710),
    [anon_sym_BSLASHACRshort] = ACTIONS(6710),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrlong] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6710),
    [anon_sym_BSLASHACRlong] = ACTIONS(6710),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrfull] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6710),
    [anon_sym_BSLASHACRfull] = ACTIONS(6710),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHacs] = ACTIONS(6710),
    [anon_sym_BSLASHAcs] = ACTIONS(6710),
    [anon_sym_BSLASHacsp] = ACTIONS(6710),
    [anon_sym_BSLASHAcsp] = ACTIONS(6710),
    [anon_sym_BSLASHacl] = ACTIONS(6710),
    [anon_sym_BSLASHAcl] = ACTIONS(6710),
    [anon_sym_BSLASHaclp] = ACTIONS(6710),
    [anon_sym_BSLASHAclp] = ACTIONS(6710),
    [anon_sym_BSLASHacf] = ACTIONS(6710),
    [anon_sym_BSLASHAcf] = ACTIONS(6710),
    [anon_sym_BSLASHacfp] = ACTIONS(6710),
    [anon_sym_BSLASHAcfp] = ACTIONS(6710),
    [anon_sym_BSLASHac] = ACTIONS(6710),
    [anon_sym_BSLASHAc] = ACTIONS(6710),
    [anon_sym_BSLASHacp] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6710),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6710),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6710),
    [anon_sym_BSLASHcolor] = ACTIONS(6710),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6710),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6710),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6710),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6710),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6710),
    [anon_sym_BSLASHtext] = ACTIONS(6710),
    [anon_sym_BSLASHintertext] = ACTIONS(6710),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6710),
    [anon_sym_BSLASHurl] = ACTIONS(6710),
    [anon_sym_BSLASHhref] = ACTIONS(6710),
  },
  [1650] = {
    [sym_command_name] = ACTIONS(7097),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7097),
    [anon_sym_LBRACK] = ACTIONS(7099),
    [anon_sym_RBRACK] = ACTIONS(7099),
    [anon_sym_COMMA] = ACTIONS(7099),
    [anon_sym_EQ] = ACTIONS(7099),
    [anon_sym_LPAREN] = ACTIONS(7099),
    [anon_sym_RPAREN] = ACTIONS(7099),
    [anon_sym_LBRACE] = ACTIONS(7099),
    [sym_word] = ACTIONS(7097),
    [sym_placeholder] = ACTIONS(7099),
    [anon_sym_PLUS] = ACTIONS(7099),
    [anon_sym_DASH] = ACTIONS(7099),
    [anon_sym_STAR] = ACTIONS(7099),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_LT] = ACTIONS(7097),
    [anon_sym_GT] = ACTIONS(7097),
    [anon_sym_BANG] = ACTIONS(7097),
    [anon_sym_PIPE] = ACTIONS(7097),
    [anon_sym_COLON] = ACTIONS(7097),
    [anon_sym_SQUOTE] = ACTIONS(7097),
    [anon_sym__] = ACTIONS(7099),
    [anon_sym_CARET] = ACTIONS(7099),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7099),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7099),
    [anon_sym_DOLLAR] = ACTIONS(7097),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7099),
    [anon_sym_BSLASHbegin] = ACTIONS(7097),
    [anon_sym_BSLASHtitle] = ACTIONS(7097),
    [anon_sym_BSLASHauthor] = ACTIONS(7097),
    [anon_sym_BSLASHusepackage] = ACTIONS(7097),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7097),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7097),
    [anon_sym_BSLASHinclude] = ACTIONS(7097),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7097),
    [anon_sym_BSLASHinput] = ACTIONS(7097),
    [anon_sym_BSLASHsubfile] = ACTIONS(7097),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7097),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7097),
    [anon_sym_BSLASHbibliography] = ACTIONS(7097),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7097),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7097),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7097),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7097),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7097),
    [anon_sym_BSLASHimport] = ACTIONS(7097),
    [anon_sym_BSLASHsubimport] = ACTIONS(7097),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7097),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7097),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7097),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7097),
    [anon_sym_BSLASHcaption] = ACTIONS(7097),
    [anon_sym_BSLASHcite] = ACTIONS(7097),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCite] = ACTIONS(7097),
    [anon_sym_BSLASHnocite] = ACTIONS(7097),
    [anon_sym_BSLASHcitet] = ACTIONS(7097),
    [anon_sym_BSLASHcitep] = ACTIONS(7097),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHciteA] = ACTIONS(7097),
    [anon_sym_BSLASHciteR] = ACTIONS(7097),
    [anon_sym_BSLASHciteS] = ACTIONS(7097),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7097),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7097),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7097),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7097),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHciteyear] = ACTIONS(7097),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHcitedate] = ACTIONS(7097),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHciteurl] = ACTIONS(7097),
    [anon_sym_BSLASHfullcite] = ACTIONS(7097),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7097),
    [anon_sym_BSLASHcitealt] = ACTIONS(7097),
    [anon_sym_BSLASHcitealp] = ACTIONS(7097),
    [anon_sym_BSLASHcitetext] = ACTIONS(7097),
    [anon_sym_BSLASHparencite] = ACTIONS(7097),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHParencite] = ACTIONS(7097),
    [anon_sym_BSLASHfootcite] = ACTIONS(7097),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7097),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7097),
    [anon_sym_BSLASHtextcite] = ACTIONS(7097),
    [anon_sym_BSLASHTextcite] = ACTIONS(7097),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7097),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7097),
    [anon_sym_BSLASHsupercite] = ACTIONS(7097),
    [anon_sym_BSLASHautocite] = ACTIONS(7097),
    [anon_sym_BSLASHAutocite] = ACTIONS(7097),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHVolcite] = ACTIONS(7097),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHavolcite] = ACTIONS(7097),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHNotecite] = ACTIONS(7097),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHlabel] = ACTIONS(7097),
    [anon_sym_BSLASHref] = ACTIONS(7097),
    [anon_sym_BSLASHeqref] = ACTIONS(7097),
    [anon_sym_BSLASHvref] = ACTIONS(7097),
    [anon_sym_BSLASHVref] = ACTIONS(7097),
    [anon_sym_BSLASHautoref] = ACTIONS(7097),
    [anon_sym_BSLASHpageref] = ACTIONS(7097),
    [anon_sym_BSLASHcref] = ACTIONS(7097),
    [anon_sym_BSLASHCref] = ACTIONS(7097),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHnamecref] = ACTIONS(7097),
    [anon_sym_BSLASHnameCref] = ACTIONS(7097),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7097),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7097),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7097),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7097),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7097),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7097),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7097),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7097),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7097),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7097),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7097),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHdef] = ACTIONS(7097),
    [anon_sym_BSLASHlet] = ACTIONS(7097),
    [anon_sym_BSLASHleft] = ACTIONS(7097),
    [anon_sym_BSLASHbigl] = ACTIONS(7097),
    [anon_sym_BSLASHBigl] = ACTIONS(7097),
    [anon_sym_BSLASHbiggl] = ACTIONS(7097),
    [anon_sym_BSLASHBiggl] = ACTIONS(7097),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7097),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7097),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7097),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7097),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7097),
    [anon_sym_BSLASHgls] = ACTIONS(7097),
    [anon_sym_BSLASHGls] = ACTIONS(7097),
    [anon_sym_BSLASHGLS] = ACTIONS(7097),
    [anon_sym_BSLASHglspl] = ACTIONS(7097),
    [anon_sym_BSLASHGlspl] = ACTIONS(7097),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7097),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7097),
    [anon_sym_BSLASHglslink] = ACTIONS(7097),
    [anon_sym_BSLASHglstext] = ACTIONS(7097),
    [anon_sym_BSLASHGlstext] = ACTIONS(7097),
    [anon_sym_BSLASHGLStext] = ACTIONS(7097),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7097),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7097),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7097),
    [anon_sym_BSLASHglsplural] = ACTIONS(7097),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7097),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7097),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7097),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7097),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7097),
    [anon_sym_BSLASHglsname] = ACTIONS(7097),
    [anon_sym_BSLASHGlsname] = ACTIONS(7097),
    [anon_sym_BSLASHGLSname] = ACTIONS(7097),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7097),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7097),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7097),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7097),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7097),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7097),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7097),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7097),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7097),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7097),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7097),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7097),
    [anon_sym_BSLASHacrshort] = ACTIONS(7097),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7097),
    [anon_sym_BSLASHACRshort] = ACTIONS(7097),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHacrlong] = ACTIONS(7097),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7097),
    [anon_sym_BSLASHACRlong] = ACTIONS(7097),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7097),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7097),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7097),
    [anon_sym_BSLASHacrfull] = ACTIONS(7097),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7097),
    [anon_sym_BSLASHACRfull] = ACTIONS(7097),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHacs] = ACTIONS(7097),
    [anon_sym_BSLASHAcs] = ACTIONS(7097),
    [anon_sym_BSLASHacsp] = ACTIONS(7097),
    [anon_sym_BSLASHAcsp] = ACTIONS(7097),
    [anon_sym_BSLASHacl] = ACTIONS(7097),
    [anon_sym_BSLASHAcl] = ACTIONS(7097),
    [anon_sym_BSLASHaclp] = ACTIONS(7097),
    [anon_sym_BSLASHAclp] = ACTIONS(7097),
    [anon_sym_BSLASHacf] = ACTIONS(7097),
    [anon_sym_BSLASHAcf] = ACTIONS(7097),
    [anon_sym_BSLASHacfp] = ACTIONS(7097),
    [anon_sym_BSLASHAcfp] = ACTIONS(7097),
    [anon_sym_BSLASHac] = ACTIONS(7097),
    [anon_sym_BSLASHAc] = ACTIONS(7097),
    [anon_sym_BSLASHacp] = ACTIONS(7097),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7097),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7097),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7097),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7097),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7097),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7097),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7097),
    [anon_sym_BSLASHcolor] = ACTIONS(7097),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7097),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7097),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7097),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7097),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7097),
    [anon_sym_BSLASHtext] = ACTIONS(7097),
    [anon_sym_BSLASHintertext] = ACTIONS(7097),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7097),
    [anon_sym_BSLASHurl] = ACTIONS(7097),
    [anon_sym_BSLASHhref] = ACTIONS(7097),
  },
  [1651] = {
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_LBRACK] = ACTIONS(6508),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [anon_sym_COMMA] = ACTIONS(6508),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_RPAREN] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6508),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(6506),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHbegin] = ACTIONS(6506),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHleft] = ACTIONS(6506),
    [anon_sym_BSLASHbigl] = ACTIONS(6506),
    [anon_sym_BSLASHBigl] = ACTIONS(6506),
    [anon_sym_BSLASHbiggl] = ACTIONS(6506),
    [anon_sym_BSLASHBiggl] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHtext] = ACTIONS(6506),
    [anon_sym_BSLASHintertext] = ACTIONS(6506),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [1652] = {
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(6578),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6578),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_LPAREN] = ACTIONS(6578),
    [anon_sym_RPAREN] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6578),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHbegin] = ACTIONS(6576),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHleft] = ACTIONS(6576),
    [anon_sym_BSLASHbigl] = ACTIONS(6576),
    [anon_sym_BSLASHBigl] = ACTIONS(6576),
    [anon_sym_BSLASHbiggl] = ACTIONS(6576),
    [anon_sym_BSLASHBiggl] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHtext] = ACTIONS(6576),
    [anon_sym_BSLASHintertext] = ACTIONS(6576),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [1653] = {
    [sym_command_name] = ACTIONS(6630),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6630),
    [anon_sym_LBRACK] = ACTIONS(6632),
    [anon_sym_RBRACK] = ACTIONS(6632),
    [anon_sym_COMMA] = ACTIONS(6632),
    [anon_sym_EQ] = ACTIONS(6632),
    [anon_sym_LPAREN] = ACTIONS(6632),
    [anon_sym_RPAREN] = ACTIONS(6632),
    [anon_sym_LBRACE] = ACTIONS(6632),
    [sym_word] = ACTIONS(6630),
    [sym_placeholder] = ACTIONS(6632),
    [anon_sym_PLUS] = ACTIONS(6632),
    [anon_sym_DASH] = ACTIONS(6632),
    [anon_sym_STAR] = ACTIONS(6632),
    [anon_sym_SLASH] = ACTIONS(6632),
    [anon_sym_LT] = ACTIONS(6630),
    [anon_sym_GT] = ACTIONS(6630),
    [anon_sym_BANG] = ACTIONS(6630),
    [anon_sym_PIPE] = ACTIONS(6630),
    [anon_sym_COLON] = ACTIONS(6630),
    [anon_sym_SQUOTE] = ACTIONS(6630),
    [anon_sym__] = ACTIONS(6632),
    [anon_sym_CARET] = ACTIONS(6632),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6632),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6632),
    [anon_sym_DOLLAR] = ACTIONS(6630),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6632),
    [anon_sym_BSLASHbegin] = ACTIONS(6630),
    [anon_sym_BSLASHtitle] = ACTIONS(6630),
    [anon_sym_BSLASHauthor] = ACTIONS(6630),
    [anon_sym_BSLASHusepackage] = ACTIONS(6630),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6630),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6630),
    [anon_sym_BSLASHinclude] = ACTIONS(6630),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6630),
    [anon_sym_BSLASHinput] = ACTIONS(6630),
    [anon_sym_BSLASHsubfile] = ACTIONS(6630),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6630),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6630),
    [anon_sym_BSLASHbibliography] = ACTIONS(6630),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6630),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6630),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6630),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6630),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6630),
    [anon_sym_BSLASHimport] = ACTIONS(6630),
    [anon_sym_BSLASHsubimport] = ACTIONS(6630),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6630),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6630),
    [anon_sym_BSLASHcaption] = ACTIONS(6630),
    [anon_sym_BSLASHcite] = ACTIONS(6630),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCite] = ACTIONS(6630),
    [anon_sym_BSLASHnocite] = ACTIONS(6630),
    [anon_sym_BSLASHcitet] = ACTIONS(6630),
    [anon_sym_BSLASHcitep] = ACTIONS(6630),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteA] = ACTIONS(6630),
    [anon_sym_BSLASHciteR] = ACTIONS(6630),
    [anon_sym_BSLASHciteS] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6630),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6630),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteyear] = ACTIONS(6630),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHcitedate] = ACTIONS(6630),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHciteurl] = ACTIONS(6630),
    [anon_sym_BSLASHfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6630),
    [anon_sym_BSLASHcitealt] = ACTIONS(6630),
    [anon_sym_BSLASHcitealp] = ACTIONS(6630),
    [anon_sym_BSLASHcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHparencite] = ACTIONS(6630),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHParencite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6630),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6630),
    [anon_sym_BSLASHtextcite] = ACTIONS(6630),
    [anon_sym_BSLASHTextcite] = ACTIONS(6630),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6630),
    [anon_sym_BSLASHsupercite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite] = ACTIONS(6630),
    [anon_sym_BSLASHAutocite] = ACTIONS(6630),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHVolcite] = ACTIONS(6630),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHavolcite] = ACTIONS(6630),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6630),
    [anon_sym_BSLASHnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHNotecite] = ACTIONS(6630),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6630),
    [anon_sym_BSLASHlabel] = ACTIONS(6630),
    [anon_sym_BSLASHref] = ACTIONS(6630),
    [anon_sym_BSLASHeqref] = ACTIONS(6630),
    [anon_sym_BSLASHvref] = ACTIONS(6630),
    [anon_sym_BSLASHVref] = ACTIONS(6630),
    [anon_sym_BSLASHautoref] = ACTIONS(6630),
    [anon_sym_BSLASHpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcref] = ACTIONS(6630),
    [anon_sym_BSLASHCref] = ACTIONS(6630),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnameCref] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6630),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6630),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6630),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6630),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6630),
    [anon_sym_BSLASHdef] = ACTIONS(6630),
    [anon_sym_BSLASHlet] = ACTIONS(6630),
    [anon_sym_BSLASHleft] = ACTIONS(6630),
    [anon_sym_BSLASHbigl] = ACTIONS(6630),
    [anon_sym_BSLASHBigl] = ACTIONS(6630),
    [anon_sym_BSLASHbiggl] = ACTIONS(6630),
    [anon_sym_BSLASHBiggl] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6630),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6630),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6630),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6630),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6630),
    [anon_sym_BSLASHgls] = ACTIONS(6630),
    [anon_sym_BSLASHGls] = ACTIONS(6630),
    [anon_sym_BSLASHGLS] = ACTIONS(6630),
    [anon_sym_BSLASHglspl] = ACTIONS(6630),
    [anon_sym_BSLASHGlspl] = ACTIONS(6630),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6630),
    [anon_sym_BSLASHglslink] = ACTIONS(6630),
    [anon_sym_BSLASHglstext] = ACTIONS(6630),
    [anon_sym_BSLASHGlstext] = ACTIONS(6630),
    [anon_sym_BSLASHGLStext] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6630),
    [anon_sym_BSLASHglsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6630),
    [anon_sym_BSLASHglsname] = ACTIONS(6630),
    [anon_sym_BSLASHGlsname] = ACTIONS(6630),
    [anon_sym_BSLASHGLSname] = ACTIONS(6630),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6630),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6630),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6630),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6630),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6630),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6630),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6630),
    [anon_sym_BSLASHacrshort] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6630),
    [anon_sym_BSLASHACRshort] = ACTIONS(6630),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrlong] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6630),
    [anon_sym_BSLASHACRlong] = ACTIONS(6630),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6630),
    [anon_sym_BSLASHacrfull] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6630),
    [anon_sym_BSLASHACRfull] = ACTIONS(6630),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHacs] = ACTIONS(6630),
    [anon_sym_BSLASHAcs] = ACTIONS(6630),
    [anon_sym_BSLASHacsp] = ACTIONS(6630),
    [anon_sym_BSLASHAcsp] = ACTIONS(6630),
    [anon_sym_BSLASHacl] = ACTIONS(6630),
    [anon_sym_BSLASHAcl] = ACTIONS(6630),
    [anon_sym_BSLASHaclp] = ACTIONS(6630),
    [anon_sym_BSLASHAclp] = ACTIONS(6630),
    [anon_sym_BSLASHacf] = ACTIONS(6630),
    [anon_sym_BSLASHAcf] = ACTIONS(6630),
    [anon_sym_BSLASHacfp] = ACTIONS(6630),
    [anon_sym_BSLASHAcfp] = ACTIONS(6630),
    [anon_sym_BSLASHac] = ACTIONS(6630),
    [anon_sym_BSLASHAc] = ACTIONS(6630),
    [anon_sym_BSLASHacp] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6630),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6630),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6630),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6630),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6632),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6630),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6630),
    [anon_sym_BSLASHcolor] = ACTIONS(6630),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6630),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6630),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6630),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6630),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6630),
    [anon_sym_BSLASHtext] = ACTIONS(6630),
    [anon_sym_BSLASHintertext] = ACTIONS(6630),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6630),
    [anon_sym_BSLASHurl] = ACTIONS(6630),
    [anon_sym_BSLASHhref] = ACTIONS(6630),
  },
  [1654] = {
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6276),
    [anon_sym_RBRACK] = ACTIONS(6276),
    [anon_sym_COMMA] = ACTIONS(6276),
    [anon_sym_EQ] = ACTIONS(6276),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [anon_sym_RBRACE] = ACTIONS(6276),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6276),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6276),
    [anon_sym_DOLLAR] = ACTIONS(6274),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHleft] = ACTIONS(6274),
    [anon_sym_BSLASHbigl] = ACTIONS(6274),
    [anon_sym_BSLASHBigl] = ACTIONS(6274),
    [anon_sym_BSLASHbiggl] = ACTIONS(6274),
    [anon_sym_BSLASHBiggl] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHtext] = ACTIONS(6274),
    [anon_sym_BSLASHintertext] = ACTIONS(6274),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [1655] = {
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6280),
    [anon_sym_RBRACK] = ACTIONS(6280),
    [anon_sym_COMMA] = ACTIONS(6280),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_RPAREN] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [anon_sym_RBRACE] = ACTIONS(6280),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6280),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6280),
    [anon_sym_DOLLAR] = ACTIONS(6278),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHleft] = ACTIONS(6278),
    [anon_sym_BSLASHbigl] = ACTIONS(6278),
    [anon_sym_BSLASHBigl] = ACTIONS(6278),
    [anon_sym_BSLASHbiggl] = ACTIONS(6278),
    [anon_sym_BSLASHBiggl] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHtext] = ACTIONS(6278),
    [anon_sym_BSLASHintertext] = ACTIONS(6278),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [1656] = {
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [anon_sym_RBRACE] = ACTIONS(6284),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6284),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6284),
    [anon_sym_DOLLAR] = ACTIONS(6282),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHleft] = ACTIONS(6282),
    [anon_sym_BSLASHbigl] = ACTIONS(6282),
    [anon_sym_BSLASHBigl] = ACTIONS(6282),
    [anon_sym_BSLASHbiggl] = ACTIONS(6282),
    [anon_sym_BSLASHBiggl] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHtext] = ACTIONS(6282),
    [anon_sym_BSLASHintertext] = ACTIONS(6282),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [1657] = {
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_LBRACK] = ACTIONS(6560),
    [anon_sym_RBRACK] = ACTIONS(6560),
    [anon_sym_COMMA] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_LBRACE] = ACTIONS(6560),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6560),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(6558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHbegin] = ACTIONS(6558),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHleft] = ACTIONS(6558),
    [anon_sym_BSLASHbigl] = ACTIONS(6558),
    [anon_sym_BSLASHBigl] = ACTIONS(6558),
    [anon_sym_BSLASHbiggl] = ACTIONS(6558),
    [anon_sym_BSLASHBiggl] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHtext] = ACTIONS(6558),
    [anon_sym_BSLASHintertext] = ACTIONS(6558),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [1658] = {
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_RBRACK] = ACTIONS(6656),
    [anon_sym_COMMA] = ACTIONS(6656),
    [anon_sym_EQ] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(6656),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6656),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6656),
    [anon_sym_DOLLAR] = ACTIONS(6654),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHbegin] = ACTIONS(6654),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHleft] = ACTIONS(6654),
    [anon_sym_BSLASHbigl] = ACTIONS(6654),
    [anon_sym_BSLASHBigl] = ACTIONS(6654),
    [anon_sym_BSLASHbiggl] = ACTIONS(6654),
    [anon_sym_BSLASHBiggl] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHtext] = ACTIONS(6654),
    [anon_sym_BSLASHintertext] = ACTIONS(6654),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [1659] = {
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6528),
    [anon_sym_RBRACK] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6528),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [anon_sym_RPAREN] = ACTIONS(6528),
    [anon_sym_LBRACE] = ACTIONS(6528),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6528),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(6526),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHbegin] = ACTIONS(6526),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHleft] = ACTIONS(6526),
    [anon_sym_BSLASHbigl] = ACTIONS(6526),
    [anon_sym_BSLASHBigl] = ACTIONS(6526),
    [anon_sym_BSLASHbiggl] = ACTIONS(6526),
    [anon_sym_BSLASHBiggl] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHtext] = ACTIONS(6526),
    [anon_sym_BSLASHintertext] = ACTIONS(6526),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [1660] = {
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_RBRACE] = ACTIONS(6300),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6300),
    [anon_sym_DOLLAR] = ACTIONS(6298),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHleft] = ACTIONS(6298),
    [anon_sym_BSLASHbigl] = ACTIONS(6298),
    [anon_sym_BSLASHBigl] = ACTIONS(6298),
    [anon_sym_BSLASHbiggl] = ACTIONS(6298),
    [anon_sym_BSLASHBiggl] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHtext] = ACTIONS(6298),
    [anon_sym_BSLASHintertext] = ACTIONS(6298),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [1661] = {
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_LPAREN] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [anon_sym_RBRACE] = ACTIONS(6304),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6304),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6304),
    [anon_sym_DOLLAR] = ACTIONS(6302),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHleft] = ACTIONS(6302),
    [anon_sym_BSLASHbigl] = ACTIONS(6302),
    [anon_sym_BSLASHBigl] = ACTIONS(6302),
    [anon_sym_BSLASHbiggl] = ACTIONS(6302),
    [anon_sym_BSLASHBiggl] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHtext] = ACTIONS(6302),
    [anon_sym_BSLASHintertext] = ACTIONS(6302),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [1662] = {
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_LBRACK] = ACTIONS(6524),
    [anon_sym_RBRACK] = ACTIONS(6524),
    [anon_sym_COMMA] = ACTIONS(6524),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6524),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6524),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6524),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6524),
    [anon_sym_DOLLAR] = ACTIONS(6522),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHbegin] = ACTIONS(6522),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHleft] = ACTIONS(6522),
    [anon_sym_BSLASHbigl] = ACTIONS(6522),
    [anon_sym_BSLASHBigl] = ACTIONS(6522),
    [anon_sym_BSLASHbiggl] = ACTIONS(6522),
    [anon_sym_BSLASHBiggl] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHtext] = ACTIONS(6522),
    [anon_sym_BSLASHintertext] = ACTIONS(6522),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [1663] = {
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6308),
    [anon_sym_RBRACK] = ACTIONS(6308),
    [anon_sym_COMMA] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(6308),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_RPAREN] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6308),
    [anon_sym_RBRACE] = ACTIONS(6308),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6308),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6308),
    [anon_sym_DOLLAR] = ACTIONS(6306),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHleft] = ACTIONS(6306),
    [anon_sym_BSLASHbigl] = ACTIONS(6306),
    [anon_sym_BSLASHBigl] = ACTIONS(6306),
    [anon_sym_BSLASHbiggl] = ACTIONS(6306),
    [anon_sym_BSLASHBiggl] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHtext] = ACTIONS(6306),
    [anon_sym_BSLASHintertext] = ACTIONS(6306),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [1664] = {
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHbegin] = ACTIONS(165),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [1665] = {
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_RBRACK] = ACTIONS(6340),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_EQ] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [anon_sym_RBRACE] = ACTIONS(6340),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6340),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6340),
    [anon_sym_DOLLAR] = ACTIONS(6338),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHleft] = ACTIONS(6338),
    [anon_sym_BSLASHbigl] = ACTIONS(6338),
    [anon_sym_BSLASHBigl] = ACTIONS(6338),
    [anon_sym_BSLASHbiggl] = ACTIONS(6338),
    [anon_sym_BSLASHBiggl] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHtext] = ACTIONS(6338),
    [anon_sym_BSLASHintertext] = ACTIONS(6338),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [1666] = {
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_RPAREN] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [anon_sym_RBRACE] = ACTIONS(6344),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6344),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6344),
    [anon_sym_DOLLAR] = ACTIONS(6342),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHleft] = ACTIONS(6342),
    [anon_sym_BSLASHbigl] = ACTIONS(6342),
    [anon_sym_BSLASHBigl] = ACTIONS(6342),
    [anon_sym_BSLASHbiggl] = ACTIONS(6342),
    [anon_sym_BSLASHBiggl] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHtext] = ACTIONS(6342),
    [anon_sym_BSLASHintertext] = ACTIONS(6342),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [1667] = {
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_RBRACK] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LPAREN] = ACTIONS(6360),
    [anon_sym_RPAREN] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(6360),
    [anon_sym_RBRACE] = ACTIONS(6360),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6360),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6358),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHleft] = ACTIONS(6358),
    [anon_sym_BSLASHbigl] = ACTIONS(6358),
    [anon_sym_BSLASHBigl] = ACTIONS(6358),
    [anon_sym_BSLASHbiggl] = ACTIONS(6358),
    [anon_sym_BSLASHBiggl] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHtext] = ACTIONS(6358),
    [anon_sym_BSLASHintertext] = ACTIONS(6358),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [1668] = {
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_RBRACK] = ACTIONS(6368),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_LPAREN] = ACTIONS(6368),
    [anon_sym_RPAREN] = ACTIONS(6368),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [anon_sym_RBRACE] = ACTIONS(6368),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6368),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6366),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHleft] = ACTIONS(6366),
    [anon_sym_BSLASHbigl] = ACTIONS(6366),
    [anon_sym_BSLASHBigl] = ACTIONS(6366),
    [anon_sym_BSLASHbiggl] = ACTIONS(6366),
    [anon_sym_BSLASHBiggl] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHtext] = ACTIONS(6366),
    [anon_sym_BSLASHintertext] = ACTIONS(6366),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [1669] = {
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_RBRACK] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LPAREN] = ACTIONS(6372),
    [anon_sym_RPAREN] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [anon_sym_RBRACE] = ACTIONS(6372),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6372),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6370),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHleft] = ACTIONS(6370),
    [anon_sym_BSLASHbigl] = ACTIONS(6370),
    [anon_sym_BSLASHBigl] = ACTIONS(6370),
    [anon_sym_BSLASHbiggl] = ACTIONS(6370),
    [anon_sym_BSLASHBiggl] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHtext] = ACTIONS(6370),
    [anon_sym_BSLASHintertext] = ACTIONS(6370),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [1670] = {
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6460),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_COMMA] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_LPAREN] = ACTIONS(6460),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6460),
    [anon_sym_RBRACE] = ACTIONS(6460),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6460),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6460),
    [anon_sym_DOLLAR] = ACTIONS(6458),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHleft] = ACTIONS(6458),
    [anon_sym_BSLASHbigl] = ACTIONS(6458),
    [anon_sym_BSLASHBigl] = ACTIONS(6458),
    [anon_sym_BSLASHbiggl] = ACTIONS(6458),
    [anon_sym_BSLASHBiggl] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHtext] = ACTIONS(6458),
    [anon_sym_BSLASHintertext] = ACTIONS(6458),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [1671] = {
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6464),
    [anon_sym_RBRACK] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_EQ] = ACTIONS(6464),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [anon_sym_RBRACE] = ACTIONS(6464),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6464),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(6462),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHleft] = ACTIONS(6462),
    [anon_sym_BSLASHbigl] = ACTIONS(6462),
    [anon_sym_BSLASHBigl] = ACTIONS(6462),
    [anon_sym_BSLASHbiggl] = ACTIONS(6462),
    [anon_sym_BSLASHBiggl] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHtext] = ACTIONS(6462),
    [anon_sym_BSLASHintertext] = ACTIONS(6462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [1672] = {
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASHbegin] = ACTIONS(155),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [1673] = {
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_LBRACK] = ACTIONS(6468),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_COMMA] = ACTIONS(6468),
    [anon_sym_EQ] = ACTIONS(6468),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [anon_sym_RBRACE] = ACTIONS(6468),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6468),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6466),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHleft] = ACTIONS(6466),
    [anon_sym_BSLASHbigl] = ACTIONS(6466),
    [anon_sym_BSLASHBigl] = ACTIONS(6466),
    [anon_sym_BSLASHbiggl] = ACTIONS(6466),
    [anon_sym_BSLASHBiggl] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHtext] = ACTIONS(6466),
    [anon_sym_BSLASHintertext] = ACTIONS(6466),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [1674] = {
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_LBRACK] = ACTIONS(6476),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_RPAREN] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [anon_sym_RBRACE] = ACTIONS(6476),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6476),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6476),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHleft] = ACTIONS(6474),
    [anon_sym_BSLASHbigl] = ACTIONS(6474),
    [anon_sym_BSLASHBigl] = ACTIONS(6474),
    [anon_sym_BSLASHbiggl] = ACTIONS(6474),
    [anon_sym_BSLASHBiggl] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHtext] = ACTIONS(6474),
    [anon_sym_BSLASHintertext] = ACTIONS(6474),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [1675] = {
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6480),
    [anon_sym_EQ] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6480),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [anon_sym_RBRACE] = ACTIONS(6480),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6480),
    [anon_sym_DOLLAR] = ACTIONS(6478),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHleft] = ACTIONS(6478),
    [anon_sym_BSLASHbigl] = ACTIONS(6478),
    [anon_sym_BSLASHBigl] = ACTIONS(6478),
    [anon_sym_BSLASHbiggl] = ACTIONS(6478),
    [anon_sym_BSLASHBiggl] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHtext] = ACTIONS(6478),
    [anon_sym_BSLASHintertext] = ACTIONS(6478),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [1676] = {
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6484),
    [anon_sym_RBRACK] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6484),
    [anon_sym_EQ] = ACTIONS(6484),
    [anon_sym_LPAREN] = ACTIONS(6484),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_LBRACE] = ACTIONS(6484),
    [anon_sym_RBRACE] = ACTIONS(6484),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6484),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6484),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHleft] = ACTIONS(6482),
    [anon_sym_BSLASHbigl] = ACTIONS(6482),
    [anon_sym_BSLASHBigl] = ACTIONS(6482),
    [anon_sym_BSLASHbiggl] = ACTIONS(6482),
    [anon_sym_BSLASHBiggl] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHtext] = ACTIONS(6482),
    [anon_sym_BSLASHintertext] = ACTIONS(6482),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [1677] = {
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_LBRACK] = ACTIONS(6488),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_COMMA] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6488),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [anon_sym_RBRACE] = ACTIONS(6488),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6488),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(6486),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHleft] = ACTIONS(6486),
    [anon_sym_BSLASHbigl] = ACTIONS(6486),
    [anon_sym_BSLASHBigl] = ACTIONS(6486),
    [anon_sym_BSLASHbiggl] = ACTIONS(6486),
    [anon_sym_BSLASHBiggl] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHtext] = ACTIONS(6486),
    [anon_sym_BSLASHintertext] = ACTIONS(6486),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [1678] = {
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_LBRACK] = ACTIONS(6496),
    [anon_sym_RBRACK] = ACTIONS(6496),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6496),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_RPAREN] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [anon_sym_RBRACE] = ACTIONS(6496),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6496),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6496),
    [anon_sym_DOLLAR] = ACTIONS(6494),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHleft] = ACTIONS(6494),
    [anon_sym_BSLASHbigl] = ACTIONS(6494),
    [anon_sym_BSLASHBigl] = ACTIONS(6494),
    [anon_sym_BSLASHbiggl] = ACTIONS(6494),
    [anon_sym_BSLASHBiggl] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHtext] = ACTIONS(6494),
    [anon_sym_BSLASHintertext] = ACTIONS(6494),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [1679] = {
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_LBRACK] = ACTIONS(6500),
    [anon_sym_RBRACK] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [anon_sym_EQ] = ACTIONS(6500),
    [anon_sym_LPAREN] = ACTIONS(6500),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_LBRACE] = ACTIONS(6500),
    [anon_sym_RBRACE] = ACTIONS(6500),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6500),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6500),
    [anon_sym_DOLLAR] = ACTIONS(6498),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHleft] = ACTIONS(6498),
    [anon_sym_BSLASHbigl] = ACTIONS(6498),
    [anon_sym_BSLASHBigl] = ACTIONS(6498),
    [anon_sym_BSLASHbiggl] = ACTIONS(6498),
    [anon_sym_BSLASHBiggl] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHtext] = ACTIONS(6498),
    [anon_sym_BSLASHintertext] = ACTIONS(6498),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [1680] = {
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6456),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(6454),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHbegin] = ACTIONS(6454),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHleft] = ACTIONS(6454),
    [anon_sym_BSLASHbigl] = ACTIONS(6454),
    [anon_sym_BSLASHBigl] = ACTIONS(6454),
    [anon_sym_BSLASHbiggl] = ACTIONS(6454),
    [anon_sym_BSLASHBiggl] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHtext] = ACTIONS(6454),
    [anon_sym_BSLASHintertext] = ACTIONS(6454),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [1681] = {
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_LBRACK] = ACTIONS(6508),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [anon_sym_COMMA] = ACTIONS(6508),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_RPAREN] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [anon_sym_RBRACE] = ACTIONS(6508),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6508),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(6506),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHleft] = ACTIONS(6506),
    [anon_sym_BSLASHbigl] = ACTIONS(6506),
    [anon_sym_BSLASHBigl] = ACTIONS(6506),
    [anon_sym_BSLASHbiggl] = ACTIONS(6506),
    [anon_sym_BSLASHBiggl] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHtext] = ACTIONS(6506),
    [anon_sym_BSLASHintertext] = ACTIONS(6506),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [1682] = {
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_LBRACK] = ACTIONS(6512),
    [anon_sym_RBRACK] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [anon_sym_RBRACE] = ACTIONS(6512),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6512),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6512),
    [anon_sym_DOLLAR] = ACTIONS(6510),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHleft] = ACTIONS(6510),
    [anon_sym_BSLASHbigl] = ACTIONS(6510),
    [anon_sym_BSLASHBigl] = ACTIONS(6510),
    [anon_sym_BSLASHbiggl] = ACTIONS(6510),
    [anon_sym_BSLASHBiggl] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHtext] = ACTIONS(6510),
    [anon_sym_BSLASHintertext] = ACTIONS(6510),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [1683] = {
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_LBRACK] = ACTIONS(6516),
    [anon_sym_RBRACK] = ACTIONS(6516),
    [anon_sym_COMMA] = ACTIONS(6516),
    [anon_sym_EQ] = ACTIONS(6516),
    [anon_sym_LPAREN] = ACTIONS(6516),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_LBRACE] = ACTIONS(6516),
    [anon_sym_RBRACE] = ACTIONS(6516),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6516),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(6514),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHleft] = ACTIONS(6514),
    [anon_sym_BSLASHbigl] = ACTIONS(6514),
    [anon_sym_BSLASHBigl] = ACTIONS(6514),
    [anon_sym_BSLASHbiggl] = ACTIONS(6514),
    [anon_sym_BSLASHBiggl] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHtext] = ACTIONS(6514),
    [anon_sym_BSLASHintertext] = ACTIONS(6514),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [1684] = {
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_LBRACK] = ACTIONS(6520),
    [anon_sym_RBRACK] = ACTIONS(6520),
    [anon_sym_COMMA] = ACTIONS(6520),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_LPAREN] = ACTIONS(6520),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_LBRACE] = ACTIONS(6520),
    [anon_sym_RBRACE] = ACTIONS(6520),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6520),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6520),
    [anon_sym_DOLLAR] = ACTIONS(6518),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHleft] = ACTIONS(6518),
    [anon_sym_BSLASHbigl] = ACTIONS(6518),
    [anon_sym_BSLASHBigl] = ACTIONS(6518),
    [anon_sym_BSLASHbiggl] = ACTIONS(6518),
    [anon_sym_BSLASHBiggl] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHtext] = ACTIONS(6518),
    [anon_sym_BSLASHintertext] = ACTIONS(6518),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [1685] = {
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_LBRACK] = ACTIONS(6574),
    [anon_sym_RBRACK] = ACTIONS(6574),
    [anon_sym_COMMA] = ACTIONS(6574),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_RPAREN] = ACTIONS(6574),
    [anon_sym_LBRACE] = ACTIONS(6574),
    [anon_sym_RBRACE] = ACTIONS(6574),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6574),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6574),
    [anon_sym_DOLLAR] = ACTIONS(6572),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHleft] = ACTIONS(6572),
    [anon_sym_BSLASHbigl] = ACTIONS(6572),
    [anon_sym_BSLASHBigl] = ACTIONS(6572),
    [anon_sym_BSLASHbiggl] = ACTIONS(6572),
    [anon_sym_BSLASHBiggl] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHtext] = ACTIONS(6572),
    [anon_sym_BSLASHintertext] = ACTIONS(6572),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [1686] = {
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6444),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6444),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6444),
    [anon_sym_DOLLAR] = ACTIONS(6442),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHbegin] = ACTIONS(6442),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHleft] = ACTIONS(6442),
    [anon_sym_BSLASHbigl] = ACTIONS(6442),
    [anon_sym_BSLASHBigl] = ACTIONS(6442),
    [anon_sym_BSLASHbiggl] = ACTIONS(6442),
    [anon_sym_BSLASHBiggl] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHtext] = ACTIONS(6442),
    [anon_sym_BSLASHintertext] = ACTIONS(6442),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [1687] = {
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6448),
    [anon_sym_RBRACK] = ACTIONS(6448),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(6448),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6448),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6448),
    [anon_sym_DOLLAR] = ACTIONS(6446),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHbegin] = ACTIONS(6446),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHleft] = ACTIONS(6446),
    [anon_sym_BSLASHbigl] = ACTIONS(6446),
    [anon_sym_BSLASHBigl] = ACTIONS(6446),
    [anon_sym_BSLASHbiggl] = ACTIONS(6446),
    [anon_sym_BSLASHBiggl] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHtext] = ACTIONS(6446),
    [anon_sym_BSLASHintertext] = ACTIONS(6446),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [1688] = {
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6556),
    [anon_sym_RBRACK] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6556),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_LBRACE] = ACTIONS(6556),
    [anon_sym_RBRACE] = ACTIONS(6556),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6556),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6556),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHleft] = ACTIONS(6554),
    [anon_sym_BSLASHbigl] = ACTIONS(6554),
    [anon_sym_BSLASHBigl] = ACTIONS(6554),
    [anon_sym_BSLASHbiggl] = ACTIONS(6554),
    [anon_sym_BSLASHBiggl] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHtext] = ACTIONS(6554),
    [anon_sym_BSLASHintertext] = ACTIONS(6554),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [1689] = {
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6552),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [anon_sym_RBRACE] = ACTIONS(6552),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6552),
    [anon_sym_DOLLAR] = ACTIONS(6550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHleft] = ACTIONS(6550),
    [anon_sym_BSLASHbigl] = ACTIONS(6550),
    [anon_sym_BSLASHBigl] = ACTIONS(6550),
    [anon_sym_BSLASHbiggl] = ACTIONS(6550),
    [anon_sym_BSLASHBiggl] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHtext] = ACTIONS(6550),
    [anon_sym_BSLASHintertext] = ACTIONS(6550),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [1690] = {
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_LBRACK] = ACTIONS(6472),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_EQ] = ACTIONS(6472),
    [anon_sym_LPAREN] = ACTIONS(6472),
    [anon_sym_RPAREN] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [anon_sym_RBRACE] = ACTIONS(6472),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6472),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6472),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHleft] = ACTIONS(6470),
    [anon_sym_BSLASHbigl] = ACTIONS(6470),
    [anon_sym_BSLASHBigl] = ACTIONS(6470),
    [anon_sym_BSLASHbiggl] = ACTIONS(6470),
    [anon_sym_BSLASHBiggl] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHtext] = ACTIONS(6470),
    [anon_sym_BSLASHintertext] = ACTIONS(6470),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [1691] = {
    [sym_command_name] = ACTIONS(7089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7089),
    [anon_sym_LBRACK] = ACTIONS(7091),
    [anon_sym_RBRACK] = ACTIONS(7091),
    [anon_sym_COMMA] = ACTIONS(7091),
    [anon_sym_EQ] = ACTIONS(7091),
    [anon_sym_LPAREN] = ACTIONS(7091),
    [anon_sym_RPAREN] = ACTIONS(7091),
    [anon_sym_LBRACE] = ACTIONS(7091),
    [sym_word] = ACTIONS(7089),
    [sym_placeholder] = ACTIONS(7091),
    [anon_sym_PLUS] = ACTIONS(7091),
    [anon_sym_DASH] = ACTIONS(7091),
    [anon_sym_STAR] = ACTIONS(7091),
    [anon_sym_SLASH] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_BANG] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_COLON] = ACTIONS(7089),
    [anon_sym_SQUOTE] = ACTIONS(7089),
    [anon_sym__] = ACTIONS(7091),
    [anon_sym_CARET] = ACTIONS(7091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7091),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7091),
    [anon_sym_BSLASHbegin] = ACTIONS(7089),
    [anon_sym_BSLASHtitle] = ACTIONS(7089),
    [anon_sym_BSLASHauthor] = ACTIONS(7089),
    [anon_sym_BSLASHusepackage] = ACTIONS(7089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7089),
    [anon_sym_BSLASHinclude] = ACTIONS(7089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7089),
    [anon_sym_BSLASHinput] = ACTIONS(7089),
    [anon_sym_BSLASHsubfile] = ACTIONS(7089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7089),
    [anon_sym_BSLASHbibliography] = ACTIONS(7089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7089),
    [anon_sym_BSLASHimport] = ACTIONS(7089),
    [anon_sym_BSLASHsubimport] = ACTIONS(7089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7089),
    [anon_sym_BSLASHcaption] = ACTIONS(7089),
    [anon_sym_BSLASHcite] = ACTIONS(7089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCite] = ACTIONS(7089),
    [anon_sym_BSLASHnocite] = ACTIONS(7089),
    [anon_sym_BSLASHcitet] = ACTIONS(7089),
    [anon_sym_BSLASHcitep] = ACTIONS(7089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHciteA] = ACTIONS(7089),
    [anon_sym_BSLASHciteR] = ACTIONS(7089),
    [anon_sym_BSLASHciteS] = ACTIONS(7089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHciteyear] = ACTIONS(7089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHcitedate] = ACTIONS(7089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHciteurl] = ACTIONS(7089),
    [anon_sym_BSLASHfullcite] = ACTIONS(7089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7089),
    [anon_sym_BSLASHcitealt] = ACTIONS(7089),
    [anon_sym_BSLASHcitealp] = ACTIONS(7089),
    [anon_sym_BSLASHcitetext] = ACTIONS(7089),
    [anon_sym_BSLASHparencite] = ACTIONS(7089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHParencite] = ACTIONS(7089),
    [anon_sym_BSLASHfootcite] = ACTIONS(7089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7089),
    [anon_sym_BSLASHtextcite] = ACTIONS(7089),
    [anon_sym_BSLASHTextcite] = ACTIONS(7089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7089),
    [anon_sym_BSLASHsupercite] = ACTIONS(7089),
    [anon_sym_BSLASHautocite] = ACTIONS(7089),
    [anon_sym_BSLASHAutocite] = ACTIONS(7089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHVolcite] = ACTIONS(7089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHavolcite] = ACTIONS(7089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHNotecite] = ACTIONS(7089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHlabel] = ACTIONS(7089),
    [anon_sym_BSLASHref] = ACTIONS(7089),
    [anon_sym_BSLASHeqref] = ACTIONS(7089),
    [anon_sym_BSLASHvref] = ACTIONS(7089),
    [anon_sym_BSLASHVref] = ACTIONS(7089),
    [anon_sym_BSLASHautoref] = ACTIONS(7089),
    [anon_sym_BSLASHpageref] = ACTIONS(7089),
    [anon_sym_BSLASHcref] = ACTIONS(7089),
    [anon_sym_BSLASHCref] = ACTIONS(7089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHnamecref] = ACTIONS(7089),
    [anon_sym_BSLASHnameCref] = ACTIONS(7089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHdef] = ACTIONS(7089),
    [anon_sym_BSLASHlet] = ACTIONS(7089),
    [anon_sym_BSLASHleft] = ACTIONS(7089),
    [anon_sym_BSLASHbigl] = ACTIONS(7089),
    [anon_sym_BSLASHBigl] = ACTIONS(7089),
    [anon_sym_BSLASHbiggl] = ACTIONS(7089),
    [anon_sym_BSLASHBiggl] = ACTIONS(7089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7089),
    [anon_sym_BSLASHgls] = ACTIONS(7089),
    [anon_sym_BSLASHGls] = ACTIONS(7089),
    [anon_sym_BSLASHGLS] = ACTIONS(7089),
    [anon_sym_BSLASHglspl] = ACTIONS(7089),
    [anon_sym_BSLASHGlspl] = ACTIONS(7089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7089),
    [anon_sym_BSLASHglslink] = ACTIONS(7089),
    [anon_sym_BSLASHglstext] = ACTIONS(7089),
    [anon_sym_BSLASHGlstext] = ACTIONS(7089),
    [anon_sym_BSLASHGLStext] = ACTIONS(7089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7089),
    [anon_sym_BSLASHglsplural] = ACTIONS(7089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7089),
    [anon_sym_BSLASHglsname] = ACTIONS(7089),
    [anon_sym_BSLASHGlsname] = ACTIONS(7089),
    [anon_sym_BSLASHGLSname] = ACTIONS(7089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7089),
    [anon_sym_BSLASHacrshort] = ACTIONS(7089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7089),
    [anon_sym_BSLASHACRshort] = ACTIONS(7089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHacrlong] = ACTIONS(7089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7089),
    [anon_sym_BSLASHACRlong] = ACTIONS(7089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7089),
    [anon_sym_BSLASHacrfull] = ACTIONS(7089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7089),
    [anon_sym_BSLASHACRfull] = ACTIONS(7089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHacs] = ACTIONS(7089),
    [anon_sym_BSLASHAcs] = ACTIONS(7089),
    [anon_sym_BSLASHacsp] = ACTIONS(7089),
    [anon_sym_BSLASHAcsp] = ACTIONS(7089),
    [anon_sym_BSLASHacl] = ACTIONS(7089),
    [anon_sym_BSLASHAcl] = ACTIONS(7089),
    [anon_sym_BSLASHaclp] = ACTIONS(7089),
    [anon_sym_BSLASHAclp] = ACTIONS(7089),
    [anon_sym_BSLASHacf] = ACTIONS(7089),
    [anon_sym_BSLASHAcf] = ACTIONS(7089),
    [anon_sym_BSLASHacfp] = ACTIONS(7089),
    [anon_sym_BSLASHAcfp] = ACTIONS(7089),
    [anon_sym_BSLASHac] = ACTIONS(7089),
    [anon_sym_BSLASHAc] = ACTIONS(7089),
    [anon_sym_BSLASHacp] = ACTIONS(7089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7089),
    [anon_sym_BSLASHcolor] = ACTIONS(7089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7089),
    [anon_sym_BSLASHtext] = ACTIONS(7089),
    [anon_sym_BSLASHintertext] = ACTIONS(7089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7089),
    [anon_sym_BSLASHurl] = ACTIONS(7089),
    [anon_sym_BSLASHhref] = ACTIONS(7089),
  },
  [1692] = {
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_LBRACK] = ACTIONS(6300),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_LPAREN] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6300),
    [anon_sym_DOLLAR] = ACTIONS(6298),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHbegin] = ACTIONS(6298),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHleft] = ACTIONS(6298),
    [anon_sym_BSLASHbigl] = ACTIONS(6298),
    [anon_sym_BSLASHBigl] = ACTIONS(6298),
    [anon_sym_BSLASHbiggl] = ACTIONS(6298),
    [anon_sym_BSLASHBiggl] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHtext] = ACTIONS(6298),
    [anon_sym_BSLASHintertext] = ACTIONS(6298),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [1693] = {
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_LBRACK] = ACTIONS(6304),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_LPAREN] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6304),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6304),
    [anon_sym_DOLLAR] = ACTIONS(6302),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHbegin] = ACTIONS(6302),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHleft] = ACTIONS(6302),
    [anon_sym_BSLASHbigl] = ACTIONS(6302),
    [anon_sym_BSLASHBigl] = ACTIONS(6302),
    [anon_sym_BSLASHbiggl] = ACTIONS(6302),
    [anon_sym_BSLASHBiggl] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHtext] = ACTIONS(6302),
    [anon_sym_BSLASHintertext] = ACTIONS(6302),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [1694] = {
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_LBRACK] = ACTIONS(6308),
    [anon_sym_RBRACK] = ACTIONS(6308),
    [anon_sym_COMMA] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(6308),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_RPAREN] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6308),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6308),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6308),
    [anon_sym_DOLLAR] = ACTIONS(6306),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHbegin] = ACTIONS(6306),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHleft] = ACTIONS(6306),
    [anon_sym_BSLASHbigl] = ACTIONS(6306),
    [anon_sym_BSLASHBigl] = ACTIONS(6306),
    [anon_sym_BSLASHbiggl] = ACTIONS(6306),
    [anon_sym_BSLASHBiggl] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHtext] = ACTIONS(6306),
    [anon_sym_BSLASHintertext] = ACTIONS(6306),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [1695] = {
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_LBRACK] = ACTIONS(6340),
    [anon_sym_RBRACK] = ACTIONS(6340),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_EQ] = ACTIONS(6340),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6340),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6340),
    [anon_sym_DOLLAR] = ACTIONS(6338),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHbegin] = ACTIONS(6338),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHleft] = ACTIONS(6338),
    [anon_sym_BSLASHbigl] = ACTIONS(6338),
    [anon_sym_BSLASHBigl] = ACTIONS(6338),
    [anon_sym_BSLASHbiggl] = ACTIONS(6338),
    [anon_sym_BSLASHBiggl] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHtext] = ACTIONS(6338),
    [anon_sym_BSLASHintertext] = ACTIONS(6338),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [1696] = {
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_LBRACK] = ACTIONS(6344),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6344),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_RPAREN] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6344),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6344),
    [anon_sym_DOLLAR] = ACTIONS(6342),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHbegin] = ACTIONS(6342),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHleft] = ACTIONS(6342),
    [anon_sym_BSLASHbigl] = ACTIONS(6342),
    [anon_sym_BSLASHBigl] = ACTIONS(6342),
    [anon_sym_BSLASHbiggl] = ACTIONS(6342),
    [anon_sym_BSLASHBiggl] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHtext] = ACTIONS(6342),
    [anon_sym_BSLASHintertext] = ACTIONS(6342),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [1697] = {
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_LBRACK] = ACTIONS(6360),
    [anon_sym_RBRACK] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_LPAREN] = ACTIONS(6360),
    [anon_sym_RPAREN] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(6360),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6360),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6358),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHbegin] = ACTIONS(6358),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHleft] = ACTIONS(6358),
    [anon_sym_BSLASHbigl] = ACTIONS(6358),
    [anon_sym_BSLASHBigl] = ACTIONS(6358),
    [anon_sym_BSLASHbiggl] = ACTIONS(6358),
    [anon_sym_BSLASHBiggl] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHtext] = ACTIONS(6358),
    [anon_sym_BSLASHintertext] = ACTIONS(6358),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [1698] = {
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_LBRACK] = ACTIONS(6368),
    [anon_sym_RBRACK] = ACTIONS(6368),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_LPAREN] = ACTIONS(6368),
    [anon_sym_RPAREN] = ACTIONS(6368),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6368),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6366),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHbegin] = ACTIONS(6366),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHleft] = ACTIONS(6366),
    [anon_sym_BSLASHbigl] = ACTIONS(6366),
    [anon_sym_BSLASHBigl] = ACTIONS(6366),
    [anon_sym_BSLASHbiggl] = ACTIONS(6366),
    [anon_sym_BSLASHBiggl] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHtext] = ACTIONS(6366),
    [anon_sym_BSLASHintertext] = ACTIONS(6366),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [1699] = {
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_LBRACK] = ACTIONS(6372),
    [anon_sym_RBRACK] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_LPAREN] = ACTIONS(6372),
    [anon_sym_RPAREN] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6372),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6370),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHbegin] = ACTIONS(6370),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHleft] = ACTIONS(6370),
    [anon_sym_BSLASHbigl] = ACTIONS(6370),
    [anon_sym_BSLASHBigl] = ACTIONS(6370),
    [anon_sym_BSLASHbiggl] = ACTIONS(6370),
    [anon_sym_BSLASHBiggl] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHtext] = ACTIONS(6370),
    [anon_sym_BSLASHintertext] = ACTIONS(6370),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [1700] = {
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_LBRACK] = ACTIONS(6460),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_COMMA] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_LPAREN] = ACTIONS(6460),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6460),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6460),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6460),
    [anon_sym_DOLLAR] = ACTIONS(6458),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHbegin] = ACTIONS(6458),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHleft] = ACTIONS(6458),
    [anon_sym_BSLASHbigl] = ACTIONS(6458),
    [anon_sym_BSLASHBigl] = ACTIONS(6458),
    [anon_sym_BSLASHbiggl] = ACTIONS(6458),
    [anon_sym_BSLASHBiggl] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHtext] = ACTIONS(6458),
    [anon_sym_BSLASHintertext] = ACTIONS(6458),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [1701] = {
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_LBRACK] = ACTIONS(6464),
    [anon_sym_RBRACK] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_EQ] = ACTIONS(6464),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6464),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(6462),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHbegin] = ACTIONS(6462),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHleft] = ACTIONS(6462),
    [anon_sym_BSLASHbigl] = ACTIONS(6462),
    [anon_sym_BSLASHBigl] = ACTIONS(6462),
    [anon_sym_BSLASHbiggl] = ACTIONS(6462),
    [anon_sym_BSLASHBiggl] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHtext] = ACTIONS(6462),
    [anon_sym_BSLASHintertext] = ACTIONS(6462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [1702] = {
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6504),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6504),
    [anon_sym_DOLLAR] = ACTIONS(6502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHbegin] = ACTIONS(6502),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHleft] = ACTIONS(6502),
    [anon_sym_BSLASHbigl] = ACTIONS(6502),
    [anon_sym_BSLASHBigl] = ACTIONS(6502),
    [anon_sym_BSLASHbiggl] = ACTIONS(6502),
    [anon_sym_BSLASHBiggl] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHtext] = ACTIONS(6502),
    [anon_sym_BSLASHintertext] = ACTIONS(6502),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [1703] = {
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_LBRACK] = ACTIONS(6284),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6284),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6284),
    [anon_sym_DOLLAR] = ACTIONS(6282),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHbegin] = ACTIONS(6282),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHleft] = ACTIONS(6282),
    [anon_sym_BSLASHbigl] = ACTIONS(6282),
    [anon_sym_BSLASHBigl] = ACTIONS(6282),
    [anon_sym_BSLASHbiggl] = ACTIONS(6282),
    [anon_sym_BSLASHBiggl] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHtext] = ACTIONS(6282),
    [anon_sym_BSLASHintertext] = ACTIONS(6282),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [1704] = {
    [sym_command_name] = ACTIONS(6622),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6622),
    [anon_sym_LBRACK] = ACTIONS(6624),
    [anon_sym_RBRACK] = ACTIONS(6624),
    [anon_sym_COMMA] = ACTIONS(6624),
    [anon_sym_EQ] = ACTIONS(6624),
    [anon_sym_LPAREN] = ACTIONS(6624),
    [anon_sym_RPAREN] = ACTIONS(6624),
    [anon_sym_LBRACE] = ACTIONS(6624),
    [sym_word] = ACTIONS(6622),
    [sym_placeholder] = ACTIONS(6624),
    [anon_sym_PLUS] = ACTIONS(6624),
    [anon_sym_DASH] = ACTIONS(6624),
    [anon_sym_STAR] = ACTIONS(6624),
    [anon_sym_SLASH] = ACTIONS(6624),
    [anon_sym_LT] = ACTIONS(6622),
    [anon_sym_GT] = ACTIONS(6622),
    [anon_sym_BANG] = ACTIONS(6622),
    [anon_sym_PIPE] = ACTIONS(6622),
    [anon_sym_COLON] = ACTIONS(6622),
    [anon_sym_SQUOTE] = ACTIONS(6622),
    [anon_sym__] = ACTIONS(6624),
    [anon_sym_CARET] = ACTIONS(6624),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6624),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6624),
    [anon_sym_DOLLAR] = ACTIONS(6622),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6624),
    [anon_sym_BSLASHbegin] = ACTIONS(6622),
    [anon_sym_BSLASHtitle] = ACTIONS(6622),
    [anon_sym_BSLASHauthor] = ACTIONS(6622),
    [anon_sym_BSLASHusepackage] = ACTIONS(6622),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6622),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6622),
    [anon_sym_BSLASHinclude] = ACTIONS(6622),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6622),
    [anon_sym_BSLASHinput] = ACTIONS(6622),
    [anon_sym_BSLASHsubfile] = ACTIONS(6622),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6622),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6622),
    [anon_sym_BSLASHbibliography] = ACTIONS(6622),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6622),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6622),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6622),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6622),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6622),
    [anon_sym_BSLASHimport] = ACTIONS(6622),
    [anon_sym_BSLASHsubimport] = ACTIONS(6622),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6622),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6622),
    [anon_sym_BSLASHcaption] = ACTIONS(6622),
    [anon_sym_BSLASHcite] = ACTIONS(6622),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCite] = ACTIONS(6622),
    [anon_sym_BSLASHnocite] = ACTIONS(6622),
    [anon_sym_BSLASHcitet] = ACTIONS(6622),
    [anon_sym_BSLASHcitep] = ACTIONS(6622),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteA] = ACTIONS(6622),
    [anon_sym_BSLASHciteR] = ACTIONS(6622),
    [anon_sym_BSLASHciteS] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6622),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6622),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteyear] = ACTIONS(6622),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHcitedate] = ACTIONS(6622),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHciteurl] = ACTIONS(6622),
    [anon_sym_BSLASHfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6622),
    [anon_sym_BSLASHcitealt] = ACTIONS(6622),
    [anon_sym_BSLASHcitealp] = ACTIONS(6622),
    [anon_sym_BSLASHcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHparencite] = ACTIONS(6622),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHParencite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6622),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6622),
    [anon_sym_BSLASHtextcite] = ACTIONS(6622),
    [anon_sym_BSLASHTextcite] = ACTIONS(6622),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6622),
    [anon_sym_BSLASHsupercite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite] = ACTIONS(6622),
    [anon_sym_BSLASHAutocite] = ACTIONS(6622),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHVolcite] = ACTIONS(6622),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHavolcite] = ACTIONS(6622),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6622),
    [anon_sym_BSLASHnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHNotecite] = ACTIONS(6622),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6622),
    [anon_sym_BSLASHlabel] = ACTIONS(6622),
    [anon_sym_BSLASHref] = ACTIONS(6622),
    [anon_sym_BSLASHeqref] = ACTIONS(6622),
    [anon_sym_BSLASHvref] = ACTIONS(6622),
    [anon_sym_BSLASHVref] = ACTIONS(6622),
    [anon_sym_BSLASHautoref] = ACTIONS(6622),
    [anon_sym_BSLASHpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcref] = ACTIONS(6622),
    [anon_sym_BSLASHCref] = ACTIONS(6622),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnameCref] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6622),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6622),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6622),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6622),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6622),
    [anon_sym_BSLASHdef] = ACTIONS(6622),
    [anon_sym_BSLASHlet] = ACTIONS(6622),
    [anon_sym_BSLASHleft] = ACTIONS(6622),
    [anon_sym_BSLASHbigl] = ACTIONS(6622),
    [anon_sym_BSLASHBigl] = ACTIONS(6622),
    [anon_sym_BSLASHbiggl] = ACTIONS(6622),
    [anon_sym_BSLASHBiggl] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6622),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6622),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6622),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6622),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6622),
    [anon_sym_BSLASHgls] = ACTIONS(6622),
    [anon_sym_BSLASHGls] = ACTIONS(6622),
    [anon_sym_BSLASHGLS] = ACTIONS(6622),
    [anon_sym_BSLASHglspl] = ACTIONS(6622),
    [anon_sym_BSLASHGlspl] = ACTIONS(6622),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6622),
    [anon_sym_BSLASHglslink] = ACTIONS(6622),
    [anon_sym_BSLASHglstext] = ACTIONS(6622),
    [anon_sym_BSLASHGlstext] = ACTIONS(6622),
    [anon_sym_BSLASHGLStext] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6622),
    [anon_sym_BSLASHglsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6622),
    [anon_sym_BSLASHglsname] = ACTIONS(6622),
    [anon_sym_BSLASHGlsname] = ACTIONS(6622),
    [anon_sym_BSLASHGLSname] = ACTIONS(6622),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6622),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6622),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6622),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6622),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6622),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6622),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6622),
    [anon_sym_BSLASHacrshort] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6622),
    [anon_sym_BSLASHACRshort] = ACTIONS(6622),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrlong] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6622),
    [anon_sym_BSLASHACRlong] = ACTIONS(6622),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6622),
    [anon_sym_BSLASHacrfull] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6622),
    [anon_sym_BSLASHACRfull] = ACTIONS(6622),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHacs] = ACTIONS(6622),
    [anon_sym_BSLASHAcs] = ACTIONS(6622),
    [anon_sym_BSLASHacsp] = ACTIONS(6622),
    [anon_sym_BSLASHAcsp] = ACTIONS(6622),
    [anon_sym_BSLASHacl] = ACTIONS(6622),
    [anon_sym_BSLASHAcl] = ACTIONS(6622),
    [anon_sym_BSLASHaclp] = ACTIONS(6622),
    [anon_sym_BSLASHAclp] = ACTIONS(6622),
    [anon_sym_BSLASHacf] = ACTIONS(6622),
    [anon_sym_BSLASHAcf] = ACTIONS(6622),
    [anon_sym_BSLASHacfp] = ACTIONS(6622),
    [anon_sym_BSLASHAcfp] = ACTIONS(6622),
    [anon_sym_BSLASHac] = ACTIONS(6622),
    [anon_sym_BSLASHAc] = ACTIONS(6622),
    [anon_sym_BSLASHacp] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6622),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6622),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6622),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6622),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6624),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6622),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6622),
    [anon_sym_BSLASHcolor] = ACTIONS(6622),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6622),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6622),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6622),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6622),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6622),
    [anon_sym_BSLASHtext] = ACTIONS(6622),
    [anon_sym_BSLASHintertext] = ACTIONS(6622),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6622),
    [anon_sym_BSLASHurl] = ACTIONS(6622),
    [anon_sym_BSLASHhref] = ACTIONS(6622),
  },
  [1705] = {
    [sym_command_name] = ACTIONS(6618),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6618),
    [anon_sym_LBRACK] = ACTIONS(6620),
    [anon_sym_RBRACK] = ACTIONS(6620),
    [anon_sym_COMMA] = ACTIONS(6620),
    [anon_sym_EQ] = ACTIONS(6620),
    [anon_sym_LPAREN] = ACTIONS(6620),
    [anon_sym_RPAREN] = ACTIONS(6620),
    [anon_sym_LBRACE] = ACTIONS(6620),
    [sym_word] = ACTIONS(6618),
    [sym_placeholder] = ACTIONS(6620),
    [anon_sym_PLUS] = ACTIONS(6620),
    [anon_sym_DASH] = ACTIONS(6620),
    [anon_sym_STAR] = ACTIONS(6620),
    [anon_sym_SLASH] = ACTIONS(6620),
    [anon_sym_LT] = ACTIONS(6618),
    [anon_sym_GT] = ACTIONS(6618),
    [anon_sym_BANG] = ACTIONS(6618),
    [anon_sym_PIPE] = ACTIONS(6618),
    [anon_sym_COLON] = ACTIONS(6618),
    [anon_sym_SQUOTE] = ACTIONS(6618),
    [anon_sym__] = ACTIONS(6620),
    [anon_sym_CARET] = ACTIONS(6620),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6620),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6620),
    [anon_sym_DOLLAR] = ACTIONS(6618),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6620),
    [anon_sym_BSLASHbegin] = ACTIONS(6618),
    [anon_sym_BSLASHtitle] = ACTIONS(6618),
    [anon_sym_BSLASHauthor] = ACTIONS(6618),
    [anon_sym_BSLASHusepackage] = ACTIONS(6618),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6618),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6618),
    [anon_sym_BSLASHinclude] = ACTIONS(6618),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6618),
    [anon_sym_BSLASHinput] = ACTIONS(6618),
    [anon_sym_BSLASHsubfile] = ACTIONS(6618),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6618),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6618),
    [anon_sym_BSLASHbibliography] = ACTIONS(6618),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6618),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6618),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6618),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6618),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6618),
    [anon_sym_BSLASHimport] = ACTIONS(6618),
    [anon_sym_BSLASHsubimport] = ACTIONS(6618),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6618),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6618),
    [anon_sym_BSLASHcaption] = ACTIONS(6618),
    [anon_sym_BSLASHcite] = ACTIONS(6618),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCite] = ACTIONS(6618),
    [anon_sym_BSLASHnocite] = ACTIONS(6618),
    [anon_sym_BSLASHcitet] = ACTIONS(6618),
    [anon_sym_BSLASHcitep] = ACTIONS(6618),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteA] = ACTIONS(6618),
    [anon_sym_BSLASHciteR] = ACTIONS(6618),
    [anon_sym_BSLASHciteS] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6618),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6618),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteyear] = ACTIONS(6618),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHcitedate] = ACTIONS(6618),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHciteurl] = ACTIONS(6618),
    [anon_sym_BSLASHfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6618),
    [anon_sym_BSLASHcitealt] = ACTIONS(6618),
    [anon_sym_BSLASHcitealp] = ACTIONS(6618),
    [anon_sym_BSLASHcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHparencite] = ACTIONS(6618),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHParencite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6618),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6618),
    [anon_sym_BSLASHtextcite] = ACTIONS(6618),
    [anon_sym_BSLASHTextcite] = ACTIONS(6618),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6618),
    [anon_sym_BSLASHsupercite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite] = ACTIONS(6618),
    [anon_sym_BSLASHAutocite] = ACTIONS(6618),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHVolcite] = ACTIONS(6618),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHavolcite] = ACTIONS(6618),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6618),
    [anon_sym_BSLASHnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHNotecite] = ACTIONS(6618),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6618),
    [anon_sym_BSLASHlabel] = ACTIONS(6618),
    [anon_sym_BSLASHref] = ACTIONS(6618),
    [anon_sym_BSLASHeqref] = ACTIONS(6618),
    [anon_sym_BSLASHvref] = ACTIONS(6618),
    [anon_sym_BSLASHVref] = ACTIONS(6618),
    [anon_sym_BSLASHautoref] = ACTIONS(6618),
    [anon_sym_BSLASHpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcref] = ACTIONS(6618),
    [anon_sym_BSLASHCref] = ACTIONS(6618),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnameCref] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6618),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6618),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6618),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6618),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6618),
    [anon_sym_BSLASHdef] = ACTIONS(6618),
    [anon_sym_BSLASHlet] = ACTIONS(6618),
    [anon_sym_BSLASHleft] = ACTIONS(6618),
    [anon_sym_BSLASHbigl] = ACTIONS(6618),
    [anon_sym_BSLASHBigl] = ACTIONS(6618),
    [anon_sym_BSLASHbiggl] = ACTIONS(6618),
    [anon_sym_BSLASHBiggl] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6618),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6618),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6618),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6618),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6618),
    [anon_sym_BSLASHgls] = ACTIONS(6618),
    [anon_sym_BSLASHGls] = ACTIONS(6618),
    [anon_sym_BSLASHGLS] = ACTIONS(6618),
    [anon_sym_BSLASHglspl] = ACTIONS(6618),
    [anon_sym_BSLASHGlspl] = ACTIONS(6618),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6618),
    [anon_sym_BSLASHglslink] = ACTIONS(6618),
    [anon_sym_BSLASHglstext] = ACTIONS(6618),
    [anon_sym_BSLASHGlstext] = ACTIONS(6618),
    [anon_sym_BSLASHGLStext] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6618),
    [anon_sym_BSLASHglsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6618),
    [anon_sym_BSLASHglsname] = ACTIONS(6618),
    [anon_sym_BSLASHGlsname] = ACTIONS(6618),
    [anon_sym_BSLASHGLSname] = ACTIONS(6618),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6618),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6618),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6618),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6618),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6618),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6618),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6618),
    [anon_sym_BSLASHacrshort] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6618),
    [anon_sym_BSLASHACRshort] = ACTIONS(6618),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrlong] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6618),
    [anon_sym_BSLASHACRlong] = ACTIONS(6618),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6618),
    [anon_sym_BSLASHacrfull] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6618),
    [anon_sym_BSLASHACRfull] = ACTIONS(6618),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHacs] = ACTIONS(6618),
    [anon_sym_BSLASHAcs] = ACTIONS(6618),
    [anon_sym_BSLASHacsp] = ACTIONS(6618),
    [anon_sym_BSLASHAcsp] = ACTIONS(6618),
    [anon_sym_BSLASHacl] = ACTIONS(6618),
    [anon_sym_BSLASHAcl] = ACTIONS(6618),
    [anon_sym_BSLASHaclp] = ACTIONS(6618),
    [anon_sym_BSLASHAclp] = ACTIONS(6618),
    [anon_sym_BSLASHacf] = ACTIONS(6618),
    [anon_sym_BSLASHAcf] = ACTIONS(6618),
    [anon_sym_BSLASHacfp] = ACTIONS(6618),
    [anon_sym_BSLASHAcfp] = ACTIONS(6618),
    [anon_sym_BSLASHac] = ACTIONS(6618),
    [anon_sym_BSLASHAc] = ACTIONS(6618),
    [anon_sym_BSLASHacp] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6618),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6618),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6618),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6618),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6620),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6618),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6618),
    [anon_sym_BSLASHcolor] = ACTIONS(6618),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6618),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6618),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6618),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6618),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6618),
    [anon_sym_BSLASHtext] = ACTIONS(6618),
    [anon_sym_BSLASHintertext] = ACTIONS(6618),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6618),
    [anon_sym_BSLASHurl] = ACTIONS(6618),
    [anon_sym_BSLASHhref] = ACTIONS(6618),
  },
  [1706] = {
    [sym_command_name] = ACTIONS(6614),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6614),
    [anon_sym_LBRACK] = ACTIONS(6616),
    [anon_sym_RBRACK] = ACTIONS(6616),
    [anon_sym_COMMA] = ACTIONS(6616),
    [anon_sym_EQ] = ACTIONS(6616),
    [anon_sym_LPAREN] = ACTIONS(6616),
    [anon_sym_RPAREN] = ACTIONS(6616),
    [anon_sym_LBRACE] = ACTIONS(6616),
    [sym_word] = ACTIONS(6614),
    [sym_placeholder] = ACTIONS(6616),
    [anon_sym_PLUS] = ACTIONS(6616),
    [anon_sym_DASH] = ACTIONS(6616),
    [anon_sym_STAR] = ACTIONS(6616),
    [anon_sym_SLASH] = ACTIONS(6616),
    [anon_sym_LT] = ACTIONS(6614),
    [anon_sym_GT] = ACTIONS(6614),
    [anon_sym_BANG] = ACTIONS(6614),
    [anon_sym_PIPE] = ACTIONS(6614),
    [anon_sym_COLON] = ACTIONS(6614),
    [anon_sym_SQUOTE] = ACTIONS(6614),
    [anon_sym__] = ACTIONS(6616),
    [anon_sym_CARET] = ACTIONS(6616),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6616),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6616),
    [anon_sym_DOLLAR] = ACTIONS(6614),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6616),
    [anon_sym_BSLASHbegin] = ACTIONS(6614),
    [anon_sym_BSLASHtitle] = ACTIONS(6614),
    [anon_sym_BSLASHauthor] = ACTIONS(6614),
    [anon_sym_BSLASHusepackage] = ACTIONS(6614),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6614),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6614),
    [anon_sym_BSLASHinclude] = ACTIONS(6614),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6614),
    [anon_sym_BSLASHinput] = ACTIONS(6614),
    [anon_sym_BSLASHsubfile] = ACTIONS(6614),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6614),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6614),
    [anon_sym_BSLASHbibliography] = ACTIONS(6614),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6614),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6614),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6614),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6614),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6614),
    [anon_sym_BSLASHimport] = ACTIONS(6614),
    [anon_sym_BSLASHsubimport] = ACTIONS(6614),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6614),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6614),
    [anon_sym_BSLASHcaption] = ACTIONS(6614),
    [anon_sym_BSLASHcite] = ACTIONS(6614),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCite] = ACTIONS(6614),
    [anon_sym_BSLASHnocite] = ACTIONS(6614),
    [anon_sym_BSLASHcitet] = ACTIONS(6614),
    [anon_sym_BSLASHcitep] = ACTIONS(6614),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteA] = ACTIONS(6614),
    [anon_sym_BSLASHciteR] = ACTIONS(6614),
    [anon_sym_BSLASHciteS] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6614),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6614),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteyear] = ACTIONS(6614),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHcitedate] = ACTIONS(6614),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHciteurl] = ACTIONS(6614),
    [anon_sym_BSLASHfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6614),
    [anon_sym_BSLASHcitealt] = ACTIONS(6614),
    [anon_sym_BSLASHcitealp] = ACTIONS(6614),
    [anon_sym_BSLASHcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHparencite] = ACTIONS(6614),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHParencite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6614),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6614),
    [anon_sym_BSLASHtextcite] = ACTIONS(6614),
    [anon_sym_BSLASHTextcite] = ACTIONS(6614),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6614),
    [anon_sym_BSLASHsupercite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite] = ACTIONS(6614),
    [anon_sym_BSLASHAutocite] = ACTIONS(6614),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHVolcite] = ACTIONS(6614),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHavolcite] = ACTIONS(6614),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6614),
    [anon_sym_BSLASHnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHNotecite] = ACTIONS(6614),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6614),
    [anon_sym_BSLASHlabel] = ACTIONS(6614),
    [anon_sym_BSLASHref] = ACTIONS(6614),
    [anon_sym_BSLASHeqref] = ACTIONS(6614),
    [anon_sym_BSLASHvref] = ACTIONS(6614),
    [anon_sym_BSLASHVref] = ACTIONS(6614),
    [anon_sym_BSLASHautoref] = ACTIONS(6614),
    [anon_sym_BSLASHpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcref] = ACTIONS(6614),
    [anon_sym_BSLASHCref] = ACTIONS(6614),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnameCref] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6614),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6614),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6614),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6614),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6614),
    [anon_sym_BSLASHdef] = ACTIONS(6614),
    [anon_sym_BSLASHlet] = ACTIONS(6614),
    [anon_sym_BSLASHleft] = ACTIONS(6614),
    [anon_sym_BSLASHbigl] = ACTIONS(6614),
    [anon_sym_BSLASHBigl] = ACTIONS(6614),
    [anon_sym_BSLASHbiggl] = ACTIONS(6614),
    [anon_sym_BSLASHBiggl] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6614),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6614),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6614),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6614),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6614),
    [anon_sym_BSLASHgls] = ACTIONS(6614),
    [anon_sym_BSLASHGls] = ACTIONS(6614),
    [anon_sym_BSLASHGLS] = ACTIONS(6614),
    [anon_sym_BSLASHglspl] = ACTIONS(6614),
    [anon_sym_BSLASHGlspl] = ACTIONS(6614),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6614),
    [anon_sym_BSLASHglslink] = ACTIONS(6614),
    [anon_sym_BSLASHglstext] = ACTIONS(6614),
    [anon_sym_BSLASHGlstext] = ACTIONS(6614),
    [anon_sym_BSLASHGLStext] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6614),
    [anon_sym_BSLASHglsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6614),
    [anon_sym_BSLASHglsname] = ACTIONS(6614),
    [anon_sym_BSLASHGlsname] = ACTIONS(6614),
    [anon_sym_BSLASHGLSname] = ACTIONS(6614),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6614),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6614),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6614),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6614),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6614),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6614),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6614),
    [anon_sym_BSLASHacrshort] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6614),
    [anon_sym_BSLASHACRshort] = ACTIONS(6614),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrlong] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6614),
    [anon_sym_BSLASHACRlong] = ACTIONS(6614),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6614),
    [anon_sym_BSLASHacrfull] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6614),
    [anon_sym_BSLASHACRfull] = ACTIONS(6614),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHacs] = ACTIONS(6614),
    [anon_sym_BSLASHAcs] = ACTIONS(6614),
    [anon_sym_BSLASHacsp] = ACTIONS(6614),
    [anon_sym_BSLASHAcsp] = ACTIONS(6614),
    [anon_sym_BSLASHacl] = ACTIONS(6614),
    [anon_sym_BSLASHAcl] = ACTIONS(6614),
    [anon_sym_BSLASHaclp] = ACTIONS(6614),
    [anon_sym_BSLASHAclp] = ACTIONS(6614),
    [anon_sym_BSLASHacf] = ACTIONS(6614),
    [anon_sym_BSLASHAcf] = ACTIONS(6614),
    [anon_sym_BSLASHacfp] = ACTIONS(6614),
    [anon_sym_BSLASHAcfp] = ACTIONS(6614),
    [anon_sym_BSLASHac] = ACTIONS(6614),
    [anon_sym_BSLASHAc] = ACTIONS(6614),
    [anon_sym_BSLASHacp] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6614),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6614),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6614),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6614),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6616),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6614),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6614),
    [anon_sym_BSLASHcolor] = ACTIONS(6614),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6614),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6614),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6614),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6614),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6614),
    [anon_sym_BSLASHtext] = ACTIONS(6614),
    [anon_sym_BSLASHintertext] = ACTIONS(6614),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6614),
    [anon_sym_BSLASHurl] = ACTIONS(6614),
    [anon_sym_BSLASHhref] = ACTIONS(6614),
  },
  [1707] = {
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_LBRACK] = ACTIONS(6468),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_COMMA] = ACTIONS(6468),
    [anon_sym_EQ] = ACTIONS(6468),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6468),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6466),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHbegin] = ACTIONS(6466),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHleft] = ACTIONS(6466),
    [anon_sym_BSLASHbigl] = ACTIONS(6466),
    [anon_sym_BSLASHBigl] = ACTIONS(6466),
    [anon_sym_BSLASHbiggl] = ACTIONS(6466),
    [anon_sym_BSLASHBiggl] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHtext] = ACTIONS(6466),
    [anon_sym_BSLASHintertext] = ACTIONS(6466),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [1708] = {
    [sym_command_name] = ACTIONS(6610),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6610),
    [anon_sym_LBRACK] = ACTIONS(6612),
    [anon_sym_RBRACK] = ACTIONS(6612),
    [anon_sym_COMMA] = ACTIONS(6612),
    [anon_sym_EQ] = ACTIONS(6612),
    [anon_sym_LPAREN] = ACTIONS(6612),
    [anon_sym_RPAREN] = ACTIONS(6612),
    [anon_sym_LBRACE] = ACTIONS(6612),
    [sym_word] = ACTIONS(6610),
    [sym_placeholder] = ACTIONS(6612),
    [anon_sym_PLUS] = ACTIONS(6612),
    [anon_sym_DASH] = ACTIONS(6612),
    [anon_sym_STAR] = ACTIONS(6612),
    [anon_sym_SLASH] = ACTIONS(6612),
    [anon_sym_LT] = ACTIONS(6610),
    [anon_sym_GT] = ACTIONS(6610),
    [anon_sym_BANG] = ACTIONS(6610),
    [anon_sym_PIPE] = ACTIONS(6610),
    [anon_sym_COLON] = ACTIONS(6610),
    [anon_sym_SQUOTE] = ACTIONS(6610),
    [anon_sym__] = ACTIONS(6612),
    [anon_sym_CARET] = ACTIONS(6612),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6612),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6612),
    [anon_sym_DOLLAR] = ACTIONS(6610),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6612),
    [anon_sym_BSLASHbegin] = ACTIONS(6610),
    [anon_sym_BSLASHtitle] = ACTIONS(6610),
    [anon_sym_BSLASHauthor] = ACTIONS(6610),
    [anon_sym_BSLASHusepackage] = ACTIONS(6610),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6610),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6610),
    [anon_sym_BSLASHinclude] = ACTIONS(6610),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6610),
    [anon_sym_BSLASHinput] = ACTIONS(6610),
    [anon_sym_BSLASHsubfile] = ACTIONS(6610),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6610),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6610),
    [anon_sym_BSLASHbibliography] = ACTIONS(6610),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6610),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6610),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6610),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6610),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6610),
    [anon_sym_BSLASHimport] = ACTIONS(6610),
    [anon_sym_BSLASHsubimport] = ACTIONS(6610),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6610),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6610),
    [anon_sym_BSLASHcaption] = ACTIONS(6610),
    [anon_sym_BSLASHcite] = ACTIONS(6610),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCite] = ACTIONS(6610),
    [anon_sym_BSLASHnocite] = ACTIONS(6610),
    [anon_sym_BSLASHcitet] = ACTIONS(6610),
    [anon_sym_BSLASHcitep] = ACTIONS(6610),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteA] = ACTIONS(6610),
    [anon_sym_BSLASHciteR] = ACTIONS(6610),
    [anon_sym_BSLASHciteS] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6610),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6610),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteyear] = ACTIONS(6610),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHcitedate] = ACTIONS(6610),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHciteurl] = ACTIONS(6610),
    [anon_sym_BSLASHfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6610),
    [anon_sym_BSLASHcitealt] = ACTIONS(6610),
    [anon_sym_BSLASHcitealp] = ACTIONS(6610),
    [anon_sym_BSLASHcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHparencite] = ACTIONS(6610),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHParencite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6610),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6610),
    [anon_sym_BSLASHtextcite] = ACTIONS(6610),
    [anon_sym_BSLASHTextcite] = ACTIONS(6610),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6610),
    [anon_sym_BSLASHsupercite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite] = ACTIONS(6610),
    [anon_sym_BSLASHAutocite] = ACTIONS(6610),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHVolcite] = ACTIONS(6610),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHavolcite] = ACTIONS(6610),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6610),
    [anon_sym_BSLASHnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHNotecite] = ACTIONS(6610),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6610),
    [anon_sym_BSLASHlabel] = ACTIONS(6610),
    [anon_sym_BSLASHref] = ACTIONS(6610),
    [anon_sym_BSLASHeqref] = ACTIONS(6610),
    [anon_sym_BSLASHvref] = ACTIONS(6610),
    [anon_sym_BSLASHVref] = ACTIONS(6610),
    [anon_sym_BSLASHautoref] = ACTIONS(6610),
    [anon_sym_BSLASHpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcref] = ACTIONS(6610),
    [anon_sym_BSLASHCref] = ACTIONS(6610),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnameCref] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6610),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6610),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6610),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6610),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6610),
    [anon_sym_BSLASHdef] = ACTIONS(6610),
    [anon_sym_BSLASHlet] = ACTIONS(6610),
    [anon_sym_BSLASHleft] = ACTIONS(6610),
    [anon_sym_BSLASHbigl] = ACTIONS(6610),
    [anon_sym_BSLASHBigl] = ACTIONS(6610),
    [anon_sym_BSLASHbiggl] = ACTIONS(6610),
    [anon_sym_BSLASHBiggl] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6610),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6610),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6610),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6610),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6610),
    [anon_sym_BSLASHgls] = ACTIONS(6610),
    [anon_sym_BSLASHGls] = ACTIONS(6610),
    [anon_sym_BSLASHGLS] = ACTIONS(6610),
    [anon_sym_BSLASHglspl] = ACTIONS(6610),
    [anon_sym_BSLASHGlspl] = ACTIONS(6610),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6610),
    [anon_sym_BSLASHglslink] = ACTIONS(6610),
    [anon_sym_BSLASHglstext] = ACTIONS(6610),
    [anon_sym_BSLASHGlstext] = ACTIONS(6610),
    [anon_sym_BSLASHGLStext] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6610),
    [anon_sym_BSLASHglsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6610),
    [anon_sym_BSLASHglsname] = ACTIONS(6610),
    [anon_sym_BSLASHGlsname] = ACTIONS(6610),
    [anon_sym_BSLASHGLSname] = ACTIONS(6610),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6610),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6610),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6610),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6610),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6610),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6610),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6610),
    [anon_sym_BSLASHacrshort] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6610),
    [anon_sym_BSLASHACRshort] = ACTIONS(6610),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrlong] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6610),
    [anon_sym_BSLASHACRlong] = ACTIONS(6610),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6610),
    [anon_sym_BSLASHacrfull] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6610),
    [anon_sym_BSLASHACRfull] = ACTIONS(6610),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHacs] = ACTIONS(6610),
    [anon_sym_BSLASHAcs] = ACTIONS(6610),
    [anon_sym_BSLASHacsp] = ACTIONS(6610),
    [anon_sym_BSLASHAcsp] = ACTIONS(6610),
    [anon_sym_BSLASHacl] = ACTIONS(6610),
    [anon_sym_BSLASHAcl] = ACTIONS(6610),
    [anon_sym_BSLASHaclp] = ACTIONS(6610),
    [anon_sym_BSLASHAclp] = ACTIONS(6610),
    [anon_sym_BSLASHacf] = ACTIONS(6610),
    [anon_sym_BSLASHAcf] = ACTIONS(6610),
    [anon_sym_BSLASHacfp] = ACTIONS(6610),
    [anon_sym_BSLASHAcfp] = ACTIONS(6610),
    [anon_sym_BSLASHac] = ACTIONS(6610),
    [anon_sym_BSLASHAc] = ACTIONS(6610),
    [anon_sym_BSLASHacp] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6610),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6610),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6610),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6610),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6612),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6610),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6610),
    [anon_sym_BSLASHcolor] = ACTIONS(6610),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6610),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6610),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6610),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6610),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6610),
    [anon_sym_BSLASHtext] = ACTIONS(6610),
    [anon_sym_BSLASHintertext] = ACTIONS(6610),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6610),
    [anon_sym_BSLASHurl] = ACTIONS(6610),
    [anon_sym_BSLASHhref] = ACTIONS(6610),
  },
  [1709] = {
    [sym_command_name] = ACTIONS(6606),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6606),
    [anon_sym_LBRACK] = ACTIONS(6608),
    [anon_sym_RBRACK] = ACTIONS(6608),
    [anon_sym_COMMA] = ACTIONS(6608),
    [anon_sym_EQ] = ACTIONS(6608),
    [anon_sym_LPAREN] = ACTIONS(6608),
    [anon_sym_RPAREN] = ACTIONS(6608),
    [anon_sym_LBRACE] = ACTIONS(6608),
    [sym_word] = ACTIONS(6606),
    [sym_placeholder] = ACTIONS(6608),
    [anon_sym_PLUS] = ACTIONS(6608),
    [anon_sym_DASH] = ACTIONS(6608),
    [anon_sym_STAR] = ACTIONS(6608),
    [anon_sym_SLASH] = ACTIONS(6608),
    [anon_sym_LT] = ACTIONS(6606),
    [anon_sym_GT] = ACTIONS(6606),
    [anon_sym_BANG] = ACTIONS(6606),
    [anon_sym_PIPE] = ACTIONS(6606),
    [anon_sym_COLON] = ACTIONS(6606),
    [anon_sym_SQUOTE] = ACTIONS(6606),
    [anon_sym__] = ACTIONS(6608),
    [anon_sym_CARET] = ACTIONS(6608),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6608),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6608),
    [anon_sym_DOLLAR] = ACTIONS(6606),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6608),
    [anon_sym_BSLASHbegin] = ACTIONS(6606),
    [anon_sym_BSLASHtitle] = ACTIONS(6606),
    [anon_sym_BSLASHauthor] = ACTIONS(6606),
    [anon_sym_BSLASHusepackage] = ACTIONS(6606),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6606),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6606),
    [anon_sym_BSLASHinclude] = ACTIONS(6606),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6606),
    [anon_sym_BSLASHinput] = ACTIONS(6606),
    [anon_sym_BSLASHsubfile] = ACTIONS(6606),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6606),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6606),
    [anon_sym_BSLASHbibliography] = ACTIONS(6606),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6606),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6606),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6606),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6606),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6606),
    [anon_sym_BSLASHimport] = ACTIONS(6606),
    [anon_sym_BSLASHsubimport] = ACTIONS(6606),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6606),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6606),
    [anon_sym_BSLASHcaption] = ACTIONS(6606),
    [anon_sym_BSLASHcite] = ACTIONS(6606),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCite] = ACTIONS(6606),
    [anon_sym_BSLASHnocite] = ACTIONS(6606),
    [anon_sym_BSLASHcitet] = ACTIONS(6606),
    [anon_sym_BSLASHcitep] = ACTIONS(6606),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteA] = ACTIONS(6606),
    [anon_sym_BSLASHciteR] = ACTIONS(6606),
    [anon_sym_BSLASHciteS] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6606),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6606),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteyear] = ACTIONS(6606),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHcitedate] = ACTIONS(6606),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHciteurl] = ACTIONS(6606),
    [anon_sym_BSLASHfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6606),
    [anon_sym_BSLASHcitealt] = ACTIONS(6606),
    [anon_sym_BSLASHcitealp] = ACTIONS(6606),
    [anon_sym_BSLASHcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHparencite] = ACTIONS(6606),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHParencite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6606),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6606),
    [anon_sym_BSLASHtextcite] = ACTIONS(6606),
    [anon_sym_BSLASHTextcite] = ACTIONS(6606),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6606),
    [anon_sym_BSLASHsupercite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite] = ACTIONS(6606),
    [anon_sym_BSLASHAutocite] = ACTIONS(6606),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHVolcite] = ACTIONS(6606),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHavolcite] = ACTIONS(6606),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6606),
    [anon_sym_BSLASHnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHNotecite] = ACTIONS(6606),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6606),
    [anon_sym_BSLASHlabel] = ACTIONS(6606),
    [anon_sym_BSLASHref] = ACTIONS(6606),
    [anon_sym_BSLASHeqref] = ACTIONS(6606),
    [anon_sym_BSLASHvref] = ACTIONS(6606),
    [anon_sym_BSLASHVref] = ACTIONS(6606),
    [anon_sym_BSLASHautoref] = ACTIONS(6606),
    [anon_sym_BSLASHpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcref] = ACTIONS(6606),
    [anon_sym_BSLASHCref] = ACTIONS(6606),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnameCref] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6606),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6606),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6606),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6606),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6606),
    [anon_sym_BSLASHdef] = ACTIONS(6606),
    [anon_sym_BSLASHlet] = ACTIONS(6606),
    [anon_sym_BSLASHleft] = ACTIONS(6606),
    [anon_sym_BSLASHbigl] = ACTIONS(6606),
    [anon_sym_BSLASHBigl] = ACTIONS(6606),
    [anon_sym_BSLASHbiggl] = ACTIONS(6606),
    [anon_sym_BSLASHBiggl] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6606),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6606),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6606),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6606),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6606),
    [anon_sym_BSLASHgls] = ACTIONS(6606),
    [anon_sym_BSLASHGls] = ACTIONS(6606),
    [anon_sym_BSLASHGLS] = ACTIONS(6606),
    [anon_sym_BSLASHglspl] = ACTIONS(6606),
    [anon_sym_BSLASHGlspl] = ACTIONS(6606),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6606),
    [anon_sym_BSLASHglslink] = ACTIONS(6606),
    [anon_sym_BSLASHglstext] = ACTIONS(6606),
    [anon_sym_BSLASHGlstext] = ACTIONS(6606),
    [anon_sym_BSLASHGLStext] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6606),
    [anon_sym_BSLASHglsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6606),
    [anon_sym_BSLASHglsname] = ACTIONS(6606),
    [anon_sym_BSLASHGlsname] = ACTIONS(6606),
    [anon_sym_BSLASHGLSname] = ACTIONS(6606),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6606),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6606),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6606),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6606),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6606),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6606),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6606),
    [anon_sym_BSLASHacrshort] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6606),
    [anon_sym_BSLASHACRshort] = ACTIONS(6606),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrlong] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6606),
    [anon_sym_BSLASHACRlong] = ACTIONS(6606),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6606),
    [anon_sym_BSLASHacrfull] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6606),
    [anon_sym_BSLASHACRfull] = ACTIONS(6606),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHacs] = ACTIONS(6606),
    [anon_sym_BSLASHAcs] = ACTIONS(6606),
    [anon_sym_BSLASHacsp] = ACTIONS(6606),
    [anon_sym_BSLASHAcsp] = ACTIONS(6606),
    [anon_sym_BSLASHacl] = ACTIONS(6606),
    [anon_sym_BSLASHAcl] = ACTIONS(6606),
    [anon_sym_BSLASHaclp] = ACTIONS(6606),
    [anon_sym_BSLASHAclp] = ACTIONS(6606),
    [anon_sym_BSLASHacf] = ACTIONS(6606),
    [anon_sym_BSLASHAcf] = ACTIONS(6606),
    [anon_sym_BSLASHacfp] = ACTIONS(6606),
    [anon_sym_BSLASHAcfp] = ACTIONS(6606),
    [anon_sym_BSLASHac] = ACTIONS(6606),
    [anon_sym_BSLASHAc] = ACTIONS(6606),
    [anon_sym_BSLASHacp] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6606),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6606),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6606),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6606),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6608),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6606),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6606),
    [anon_sym_BSLASHcolor] = ACTIONS(6606),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6606),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6606),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6606),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6606),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6606),
    [anon_sym_BSLASHtext] = ACTIONS(6606),
    [anon_sym_BSLASHintertext] = ACTIONS(6606),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6606),
    [anon_sym_BSLASHurl] = ACTIONS(6606),
    [anon_sym_BSLASHhref] = ACTIONS(6606),
  },
  [1710] = {
    [sym_command_name] = ACTIONS(6602),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6602),
    [anon_sym_LBRACK] = ACTIONS(6604),
    [anon_sym_RBRACK] = ACTIONS(6604),
    [anon_sym_COMMA] = ACTIONS(6604),
    [anon_sym_EQ] = ACTIONS(6604),
    [anon_sym_LPAREN] = ACTIONS(6604),
    [anon_sym_RPAREN] = ACTIONS(6604),
    [anon_sym_LBRACE] = ACTIONS(6604),
    [sym_word] = ACTIONS(6602),
    [sym_placeholder] = ACTIONS(6604),
    [anon_sym_PLUS] = ACTIONS(6604),
    [anon_sym_DASH] = ACTIONS(6604),
    [anon_sym_STAR] = ACTIONS(6604),
    [anon_sym_SLASH] = ACTIONS(6604),
    [anon_sym_LT] = ACTIONS(6602),
    [anon_sym_GT] = ACTIONS(6602),
    [anon_sym_BANG] = ACTIONS(6602),
    [anon_sym_PIPE] = ACTIONS(6602),
    [anon_sym_COLON] = ACTIONS(6602),
    [anon_sym_SQUOTE] = ACTIONS(6602),
    [anon_sym__] = ACTIONS(6604),
    [anon_sym_CARET] = ACTIONS(6604),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6604),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6604),
    [anon_sym_DOLLAR] = ACTIONS(6602),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6604),
    [anon_sym_BSLASHbegin] = ACTIONS(6602),
    [anon_sym_BSLASHtitle] = ACTIONS(6602),
    [anon_sym_BSLASHauthor] = ACTIONS(6602),
    [anon_sym_BSLASHusepackage] = ACTIONS(6602),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6602),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6602),
    [anon_sym_BSLASHinclude] = ACTIONS(6602),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6602),
    [anon_sym_BSLASHinput] = ACTIONS(6602),
    [anon_sym_BSLASHsubfile] = ACTIONS(6602),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6602),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6602),
    [anon_sym_BSLASHbibliography] = ACTIONS(6602),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6602),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6602),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6602),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6602),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6602),
    [anon_sym_BSLASHimport] = ACTIONS(6602),
    [anon_sym_BSLASHsubimport] = ACTIONS(6602),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6602),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6602),
    [anon_sym_BSLASHcaption] = ACTIONS(6602),
    [anon_sym_BSLASHcite] = ACTIONS(6602),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCite] = ACTIONS(6602),
    [anon_sym_BSLASHnocite] = ACTIONS(6602),
    [anon_sym_BSLASHcitet] = ACTIONS(6602),
    [anon_sym_BSLASHcitep] = ACTIONS(6602),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteA] = ACTIONS(6602),
    [anon_sym_BSLASHciteR] = ACTIONS(6602),
    [anon_sym_BSLASHciteS] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6602),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6602),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteyear] = ACTIONS(6602),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHcitedate] = ACTIONS(6602),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHciteurl] = ACTIONS(6602),
    [anon_sym_BSLASHfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6602),
    [anon_sym_BSLASHcitealt] = ACTIONS(6602),
    [anon_sym_BSLASHcitealp] = ACTIONS(6602),
    [anon_sym_BSLASHcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHparencite] = ACTIONS(6602),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHParencite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6602),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6602),
    [anon_sym_BSLASHtextcite] = ACTIONS(6602),
    [anon_sym_BSLASHTextcite] = ACTIONS(6602),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6602),
    [anon_sym_BSLASHsupercite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite] = ACTIONS(6602),
    [anon_sym_BSLASHAutocite] = ACTIONS(6602),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHVolcite] = ACTIONS(6602),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHavolcite] = ACTIONS(6602),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6602),
    [anon_sym_BSLASHnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHNotecite] = ACTIONS(6602),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6602),
    [anon_sym_BSLASHlabel] = ACTIONS(6602),
    [anon_sym_BSLASHref] = ACTIONS(6602),
    [anon_sym_BSLASHeqref] = ACTIONS(6602),
    [anon_sym_BSLASHvref] = ACTIONS(6602),
    [anon_sym_BSLASHVref] = ACTIONS(6602),
    [anon_sym_BSLASHautoref] = ACTIONS(6602),
    [anon_sym_BSLASHpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcref] = ACTIONS(6602),
    [anon_sym_BSLASHCref] = ACTIONS(6602),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnameCref] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6602),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6602),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6602),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6602),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6602),
    [anon_sym_BSLASHdef] = ACTIONS(6602),
    [anon_sym_BSLASHlet] = ACTIONS(6602),
    [anon_sym_BSLASHleft] = ACTIONS(6602),
    [anon_sym_BSLASHbigl] = ACTIONS(6602),
    [anon_sym_BSLASHBigl] = ACTIONS(6602),
    [anon_sym_BSLASHbiggl] = ACTIONS(6602),
    [anon_sym_BSLASHBiggl] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6602),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6602),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6602),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6602),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6602),
    [anon_sym_BSLASHgls] = ACTIONS(6602),
    [anon_sym_BSLASHGls] = ACTIONS(6602),
    [anon_sym_BSLASHGLS] = ACTIONS(6602),
    [anon_sym_BSLASHglspl] = ACTIONS(6602),
    [anon_sym_BSLASHGlspl] = ACTIONS(6602),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6602),
    [anon_sym_BSLASHglslink] = ACTIONS(6602),
    [anon_sym_BSLASHglstext] = ACTIONS(6602),
    [anon_sym_BSLASHGlstext] = ACTIONS(6602),
    [anon_sym_BSLASHGLStext] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6602),
    [anon_sym_BSLASHglsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6602),
    [anon_sym_BSLASHglsname] = ACTIONS(6602),
    [anon_sym_BSLASHGlsname] = ACTIONS(6602),
    [anon_sym_BSLASHGLSname] = ACTIONS(6602),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6602),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6602),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6602),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6602),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6602),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6602),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6602),
    [anon_sym_BSLASHacrshort] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6602),
    [anon_sym_BSLASHACRshort] = ACTIONS(6602),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrlong] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6602),
    [anon_sym_BSLASHACRlong] = ACTIONS(6602),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6602),
    [anon_sym_BSLASHacrfull] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6602),
    [anon_sym_BSLASHACRfull] = ACTIONS(6602),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHacs] = ACTIONS(6602),
    [anon_sym_BSLASHAcs] = ACTIONS(6602),
    [anon_sym_BSLASHacsp] = ACTIONS(6602),
    [anon_sym_BSLASHAcsp] = ACTIONS(6602),
    [anon_sym_BSLASHacl] = ACTIONS(6602),
    [anon_sym_BSLASHAcl] = ACTIONS(6602),
    [anon_sym_BSLASHaclp] = ACTIONS(6602),
    [anon_sym_BSLASHAclp] = ACTIONS(6602),
    [anon_sym_BSLASHacf] = ACTIONS(6602),
    [anon_sym_BSLASHAcf] = ACTIONS(6602),
    [anon_sym_BSLASHacfp] = ACTIONS(6602),
    [anon_sym_BSLASHAcfp] = ACTIONS(6602),
    [anon_sym_BSLASHac] = ACTIONS(6602),
    [anon_sym_BSLASHAc] = ACTIONS(6602),
    [anon_sym_BSLASHacp] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6602),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6602),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6602),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6602),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6604),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6602),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6602),
    [anon_sym_BSLASHcolor] = ACTIONS(6602),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6602),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6602),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6602),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6602),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6602),
    [anon_sym_BSLASHtext] = ACTIONS(6602),
    [anon_sym_BSLASHintertext] = ACTIONS(6602),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6602),
    [anon_sym_BSLASHurl] = ACTIONS(6602),
    [anon_sym_BSLASHhref] = ACTIONS(6602),
  },
  [1711] = {
    [sym_command_name] = ACTIONS(6594),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6596),
    [anon_sym_LPAREN] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_LBRACE] = ACTIONS(6596),
    [sym_word] = ACTIONS(6594),
    [sym_placeholder] = ACTIONS(6596),
    [anon_sym_PLUS] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6596),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_SLASH] = ACTIONS(6596),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_BANG] = ACTIONS(6594),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SQUOTE] = ACTIONS(6594),
    [anon_sym__] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(6596),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6596),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(6594),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHbegin] = ACTIONS(6594),
    [anon_sym_BSLASHtitle] = ACTIONS(6594),
    [anon_sym_BSLASHauthor] = ACTIONS(6594),
    [anon_sym_BSLASHusepackage] = ACTIONS(6594),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6594),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6594),
    [anon_sym_BSLASHinclude] = ACTIONS(6594),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6594),
    [anon_sym_BSLASHinput] = ACTIONS(6594),
    [anon_sym_BSLASHsubfile] = ACTIONS(6594),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6594),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6594),
    [anon_sym_BSLASHbibliography] = ACTIONS(6594),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6594),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6594),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6594),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6594),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6594),
    [anon_sym_BSLASHimport] = ACTIONS(6594),
    [anon_sym_BSLASHsubimport] = ACTIONS(6594),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6594),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHcaption] = ACTIONS(6594),
    [anon_sym_BSLASHcite] = ACTIONS(6594),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCite] = ACTIONS(6594),
    [anon_sym_BSLASHnocite] = ACTIONS(6594),
    [anon_sym_BSLASHcitet] = ACTIONS(6594),
    [anon_sym_BSLASHcitep] = ACTIONS(6594),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteA] = ACTIONS(6594),
    [anon_sym_BSLASHciteR] = ACTIONS(6594),
    [anon_sym_BSLASHciteS] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6594),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteyear] = ACTIONS(6594),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitedate] = ACTIONS(6594),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteurl] = ACTIONS(6594),
    [anon_sym_BSLASHfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6594),
    [anon_sym_BSLASHcitealt] = ACTIONS(6594),
    [anon_sym_BSLASHcitealp] = ACTIONS(6594),
    [anon_sym_BSLASHcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHparencite] = ACTIONS(6594),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHParencite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHtextcite] = ACTIONS(6594),
    [anon_sym_BSLASHTextcite] = ACTIONS(6594),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHsupercite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite] = ACTIONS(6594),
    [anon_sym_BSLASHAutocite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHVolcite] = ACTIONS(6594),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHavolcite] = ACTIONS(6594),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHNotecite] = ACTIONS(6594),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHlabel] = ACTIONS(6594),
    [anon_sym_BSLASHref] = ACTIONS(6594),
    [anon_sym_BSLASHeqref] = ACTIONS(6594),
    [anon_sym_BSLASHvref] = ACTIONS(6594),
    [anon_sym_BSLASHVref] = ACTIONS(6594),
    [anon_sym_BSLASHautoref] = ACTIONS(6594),
    [anon_sym_BSLASHpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcref] = ACTIONS(6594),
    [anon_sym_BSLASHCref] = ACTIONS(6594),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnameCref] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHdef] = ACTIONS(6594),
    [anon_sym_BSLASHlet] = ACTIONS(6594),
    [anon_sym_BSLASHleft] = ACTIONS(6594),
    [anon_sym_BSLASHbigl] = ACTIONS(6594),
    [anon_sym_BSLASHBigl] = ACTIONS(6594),
    [anon_sym_BSLASHbiggl] = ACTIONS(6594),
    [anon_sym_BSLASHBiggl] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6594),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6594),
    [anon_sym_BSLASHgls] = ACTIONS(6594),
    [anon_sym_BSLASHGls] = ACTIONS(6594),
    [anon_sym_BSLASHGLS] = ACTIONS(6594),
    [anon_sym_BSLASHglspl] = ACTIONS(6594),
    [anon_sym_BSLASHGlspl] = ACTIONS(6594),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6594),
    [anon_sym_BSLASHglslink] = ACTIONS(6594),
    [anon_sym_BSLASHglstext] = ACTIONS(6594),
    [anon_sym_BSLASHGlstext] = ACTIONS(6594),
    [anon_sym_BSLASHGLStext] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6594),
    [anon_sym_BSLASHglsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsname] = ACTIONS(6594),
    [anon_sym_BSLASHGlsname] = ACTIONS(6594),
    [anon_sym_BSLASHGLSname] = ACTIONS(6594),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6594),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6594),
    [anon_sym_BSLASHacrshort] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6594),
    [anon_sym_BSLASHACRshort] = ACTIONS(6594),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrlong] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6594),
    [anon_sym_BSLASHACRlong] = ACTIONS(6594),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrfull] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6594),
    [anon_sym_BSLASHACRfull] = ACTIONS(6594),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHacs] = ACTIONS(6594),
    [anon_sym_BSLASHAcs] = ACTIONS(6594),
    [anon_sym_BSLASHacsp] = ACTIONS(6594),
    [anon_sym_BSLASHAcsp] = ACTIONS(6594),
    [anon_sym_BSLASHacl] = ACTIONS(6594),
    [anon_sym_BSLASHAcl] = ACTIONS(6594),
    [anon_sym_BSLASHaclp] = ACTIONS(6594),
    [anon_sym_BSLASHAclp] = ACTIONS(6594),
    [anon_sym_BSLASHacf] = ACTIONS(6594),
    [anon_sym_BSLASHAcf] = ACTIONS(6594),
    [anon_sym_BSLASHacfp] = ACTIONS(6594),
    [anon_sym_BSLASHAcfp] = ACTIONS(6594),
    [anon_sym_BSLASHac] = ACTIONS(6594),
    [anon_sym_BSLASHAc] = ACTIONS(6594),
    [anon_sym_BSLASHacp] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6594),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6594),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6594),
    [anon_sym_BSLASHcolor] = ACTIONS(6594),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6594),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6594),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6594),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6594),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6594),
    [anon_sym_BSLASHtext] = ACTIONS(6594),
    [anon_sym_BSLASHintertext] = ACTIONS(6594),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6594),
    [anon_sym_BSLASHurl] = ACTIONS(6594),
    [anon_sym_BSLASHhref] = ACTIONS(6594),
  },
  [1712] = {
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_RBRACK] = ACTIONS(6452),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6452),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [anon_sym_RBRACE] = ACTIONS(6452),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6452),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(6450),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHleft] = ACTIONS(6450),
    [anon_sym_BSLASHbigl] = ACTIONS(6450),
    [anon_sym_BSLASHBigl] = ACTIONS(6450),
    [anon_sym_BSLASHbiggl] = ACTIONS(6450),
    [anon_sym_BSLASHBiggl] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHtext] = ACTIONS(6450),
    [anon_sym_BSLASHintertext] = ACTIONS(6450),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [1713] = {
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_RBRACK] = ACTIONS(6352),
    [anon_sym_COMMA] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_LPAREN] = ACTIONS(6352),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_LBRACE] = ACTIONS(6352),
    [anon_sym_RBRACE] = ACTIONS(6352),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6352),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6352),
    [anon_sym_DOLLAR] = ACTIONS(6350),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHleft] = ACTIONS(6350),
    [anon_sym_BSLASHbigl] = ACTIONS(6350),
    [anon_sym_BSLASHBigl] = ACTIONS(6350),
    [anon_sym_BSLASHbiggl] = ACTIONS(6350),
    [anon_sym_BSLASHBiggl] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHtext] = ACTIONS(6350),
    [anon_sym_BSLASHintertext] = ACTIONS(6350),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [1714] = {
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_LPAREN] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [anon_sym_RBRACE] = ACTIONS(6176),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6176),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6176),
    [anon_sym_DOLLAR] = ACTIONS(6174),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHleft] = ACTIONS(6174),
    [anon_sym_BSLASHbigl] = ACTIONS(6174),
    [anon_sym_BSLASHBigl] = ACTIONS(6174),
    [anon_sym_BSLASHbiggl] = ACTIONS(6174),
    [anon_sym_BSLASHBiggl] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHtext] = ACTIONS(6174),
    [anon_sym_BSLASHintertext] = ACTIONS(6174),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [1715] = {
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_RBRACK] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6184),
    [anon_sym_EQ] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_RPAREN] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [anon_sym_RBRACE] = ACTIONS(6184),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6184),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6184),
    [anon_sym_DOLLAR] = ACTIONS(6182),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHleft] = ACTIONS(6182),
    [anon_sym_BSLASHbigl] = ACTIONS(6182),
    [anon_sym_BSLASHBigl] = ACTIONS(6182),
    [anon_sym_BSLASHbiggl] = ACTIONS(6182),
    [anon_sym_BSLASHBiggl] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHtext] = ACTIONS(6182),
    [anon_sym_BSLASHintertext] = ACTIONS(6182),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [1716] = {
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_RBRACK] = ACTIONS(6192),
    [anon_sym_COMMA] = ACTIONS(6192),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_RPAREN] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [anon_sym_RBRACE] = ACTIONS(6192),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6192),
    [anon_sym_DOLLAR] = ACTIONS(6190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHleft] = ACTIONS(6190),
    [anon_sym_BSLASHbigl] = ACTIONS(6190),
    [anon_sym_BSLASHBigl] = ACTIONS(6190),
    [anon_sym_BSLASHbiggl] = ACTIONS(6190),
    [anon_sym_BSLASHBiggl] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHtext] = ACTIONS(6190),
    [anon_sym_BSLASHintertext] = ACTIONS(6190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [1717] = {
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_LBRACK] = ACTIONS(6504),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6504),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [anon_sym_RBRACE] = ACTIONS(6504),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6504),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6504),
    [anon_sym_DOLLAR] = ACTIONS(6502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHleft] = ACTIONS(6502),
    [anon_sym_BSLASHbigl] = ACTIONS(6502),
    [anon_sym_BSLASHBigl] = ACTIONS(6502),
    [anon_sym_BSLASHbiggl] = ACTIONS(6502),
    [anon_sym_BSLASHBiggl] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHtext] = ACTIONS(6502),
    [anon_sym_BSLASHintertext] = ACTIONS(6502),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [1718] = {
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [anon_sym_RPAREN] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [anon_sym_RBRACE] = ACTIONS(6200),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6200),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6200),
    [anon_sym_DOLLAR] = ACTIONS(6198),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHleft] = ACTIONS(6198),
    [anon_sym_BSLASHbigl] = ACTIONS(6198),
    [anon_sym_BSLASHBigl] = ACTIONS(6198),
    [anon_sym_BSLASHbiggl] = ACTIONS(6198),
    [anon_sym_BSLASHBiggl] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHtext] = ACTIONS(6198),
    [anon_sym_BSLASHintertext] = ACTIONS(6198),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [1719] = {
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_LBRACK] = ACTIONS(6476),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_RPAREN] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6476),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6476),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHbegin] = ACTIONS(6474),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHleft] = ACTIONS(6474),
    [anon_sym_BSLASHbigl] = ACTIONS(6474),
    [anon_sym_BSLASHBigl] = ACTIONS(6474),
    [anon_sym_BSLASHbiggl] = ACTIONS(6474),
    [anon_sym_BSLASHBiggl] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHtext] = ACTIONS(6474),
    [anon_sym_BSLASHintertext] = ACTIONS(6474),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [1720] = {
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6480),
    [anon_sym_EQ] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6480),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6480),
    [anon_sym_DOLLAR] = ACTIONS(6478),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHbegin] = ACTIONS(6478),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHleft] = ACTIONS(6478),
    [anon_sym_BSLASHbigl] = ACTIONS(6478),
    [anon_sym_BSLASHBigl] = ACTIONS(6478),
    [anon_sym_BSLASHbiggl] = ACTIONS(6478),
    [anon_sym_BSLASHBiggl] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHtext] = ACTIONS(6478),
    [anon_sym_BSLASHintertext] = ACTIONS(6478),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [1721] = {
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_LBRACK] = ACTIONS(6280),
    [anon_sym_RBRACK] = ACTIONS(6280),
    [anon_sym_COMMA] = ACTIONS(6280),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_RPAREN] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6280),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6280),
    [anon_sym_DOLLAR] = ACTIONS(6278),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHbegin] = ACTIONS(6278),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHleft] = ACTIONS(6278),
    [anon_sym_BSLASHbigl] = ACTIONS(6278),
    [anon_sym_BSLASHBigl] = ACTIONS(6278),
    [anon_sym_BSLASHbiggl] = ACTIONS(6278),
    [anon_sym_BSLASHBiggl] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHtext] = ACTIONS(6278),
    [anon_sym_BSLASHintertext] = ACTIONS(6278),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [1722] = {
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_EQ] = ACTIONS(6216),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [anon_sym_RPAREN] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6216),
    [anon_sym_DOLLAR] = ACTIONS(6214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHleft] = ACTIONS(6214),
    [anon_sym_BSLASHbigl] = ACTIONS(6214),
    [anon_sym_BSLASHBigl] = ACTIONS(6214),
    [anon_sym_BSLASHbiggl] = ACTIONS(6214),
    [anon_sym_BSLASHBiggl] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHtext] = ACTIONS(6214),
    [anon_sym_BSLASHintertext] = ACTIONS(6214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [1723] = {
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6220),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [anon_sym_RBRACE] = ACTIONS(6220),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6220),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6220),
    [anon_sym_DOLLAR] = ACTIONS(6218),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHleft] = ACTIONS(6218),
    [anon_sym_BSLASHbigl] = ACTIONS(6218),
    [anon_sym_BSLASHBigl] = ACTIONS(6218),
    [anon_sym_BSLASHbiggl] = ACTIONS(6218),
    [anon_sym_BSLASHBiggl] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHtext] = ACTIONS(6218),
    [anon_sym_BSLASHintertext] = ACTIONS(6218),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [1724] = {
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6224),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_LPAREN] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [anon_sym_RBRACE] = ACTIONS(6224),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6224),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6224),
    [anon_sym_DOLLAR] = ACTIONS(6222),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHleft] = ACTIONS(6222),
    [anon_sym_BSLASHbigl] = ACTIONS(6222),
    [anon_sym_BSLASHBigl] = ACTIONS(6222),
    [anon_sym_BSLASHbiggl] = ACTIONS(6222),
    [anon_sym_BSLASHBiggl] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHtext] = ACTIONS(6222),
    [anon_sym_BSLASHintertext] = ACTIONS(6222),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [1725] = {
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6228),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_LPAREN] = ACTIONS(6228),
    [anon_sym_RPAREN] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(6228),
    [anon_sym_RBRACE] = ACTIONS(6228),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6228),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(6226),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHleft] = ACTIONS(6226),
    [anon_sym_BSLASHbigl] = ACTIONS(6226),
    [anon_sym_BSLASHBigl] = ACTIONS(6226),
    [anon_sym_BSLASHbiggl] = ACTIONS(6226),
    [anon_sym_BSLASHBiggl] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHtext] = ACTIONS(6226),
    [anon_sym_BSLASHintertext] = ACTIONS(6226),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [1726] = {
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6232),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6232),
    [anon_sym_LPAREN] = ACTIONS(6232),
    [anon_sym_RPAREN] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [anon_sym_RBRACE] = ACTIONS(6232),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6232),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6232),
    [anon_sym_DOLLAR] = ACTIONS(6230),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHleft] = ACTIONS(6230),
    [anon_sym_BSLASHbigl] = ACTIONS(6230),
    [anon_sym_BSLASHBigl] = ACTIONS(6230),
    [anon_sym_BSLASHbiggl] = ACTIONS(6230),
    [anon_sym_BSLASHBiggl] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHtext] = ACTIONS(6230),
    [anon_sym_BSLASHintertext] = ACTIONS(6230),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [1727] = {
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_LPAREN] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6236),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(6234),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHleft] = ACTIONS(6234),
    [anon_sym_BSLASHbigl] = ACTIONS(6234),
    [anon_sym_BSLASHBigl] = ACTIONS(6234),
    [anon_sym_BSLASHbiggl] = ACTIONS(6234),
    [anon_sym_BSLASHBiggl] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHtext] = ACTIONS(6234),
    [anon_sym_BSLASHintertext] = ACTIONS(6234),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [1728] = {
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6240),
    [anon_sym_RBRACK] = ACTIONS(6240),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_LPAREN] = ACTIONS(6240),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(6240),
    [anon_sym_RBRACE] = ACTIONS(6240),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6240),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6240),
    [anon_sym_DOLLAR] = ACTIONS(6238),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHleft] = ACTIONS(6238),
    [anon_sym_BSLASHbigl] = ACTIONS(6238),
    [anon_sym_BSLASHBigl] = ACTIONS(6238),
    [anon_sym_BSLASHbiggl] = ACTIONS(6238),
    [anon_sym_BSLASHBiggl] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHtext] = ACTIONS(6238),
    [anon_sym_BSLASHintertext] = ACTIONS(6238),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [1729] = {
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6244),
    [anon_sym_RBRACK] = ACTIONS(6244),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_LPAREN] = ACTIONS(6244),
    [anon_sym_RPAREN] = ACTIONS(6244),
    [anon_sym_LBRACE] = ACTIONS(6244),
    [anon_sym_RBRACE] = ACTIONS(6244),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6244),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6244),
    [anon_sym_DOLLAR] = ACTIONS(6242),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHleft] = ACTIONS(6242),
    [anon_sym_BSLASHbigl] = ACTIONS(6242),
    [anon_sym_BSLASHBigl] = ACTIONS(6242),
    [anon_sym_BSLASHbiggl] = ACTIONS(6242),
    [anon_sym_BSLASHBiggl] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHtext] = ACTIONS(6242),
    [anon_sym_BSLASHintertext] = ACTIONS(6242),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [1730] = {
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_COMMA] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_LPAREN] = ACTIONS(6248),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [anon_sym_RBRACE] = ACTIONS(6248),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6248),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6248),
    [anon_sym_DOLLAR] = ACTIONS(6246),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHleft] = ACTIONS(6246),
    [anon_sym_BSLASHbigl] = ACTIONS(6246),
    [anon_sym_BSLASHBigl] = ACTIONS(6246),
    [anon_sym_BSLASHbiggl] = ACTIONS(6246),
    [anon_sym_BSLASHBiggl] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHtext] = ACTIONS(6246),
    [anon_sym_BSLASHintertext] = ACTIONS(6246),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [1731] = {
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6484),
    [anon_sym_RBRACK] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6484),
    [anon_sym_EQ] = ACTIONS(6484),
    [anon_sym_LPAREN] = ACTIONS(6484),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_LBRACE] = ACTIONS(6484),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6484),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6484),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHbegin] = ACTIONS(6482),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHleft] = ACTIONS(6482),
    [anon_sym_BSLASHbigl] = ACTIONS(6482),
    [anon_sym_BSLASHBigl] = ACTIONS(6482),
    [anon_sym_BSLASHbiggl] = ACTIONS(6482),
    [anon_sym_BSLASHBiggl] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHtext] = ACTIONS(6482),
    [anon_sym_BSLASHintertext] = ACTIONS(6482),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [1732] = {
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_LBRACK] = ACTIONS(6488),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_COMMA] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6488),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6488),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(6486),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHbegin] = ACTIONS(6486),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHleft] = ACTIONS(6486),
    [anon_sym_BSLASHbigl] = ACTIONS(6486),
    [anon_sym_BSLASHBigl] = ACTIONS(6486),
    [anon_sym_BSLASHbiggl] = ACTIONS(6486),
    [anon_sym_BSLASHBiggl] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHtext] = ACTIONS(6486),
    [anon_sym_BSLASHintertext] = ACTIONS(6486),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [1733] = {
    [sym_command_name] = ACTIONS(6670),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6670),
    [anon_sym_LBRACK] = ACTIONS(6672),
    [anon_sym_RBRACK] = ACTIONS(6672),
    [anon_sym_COMMA] = ACTIONS(6672),
    [anon_sym_EQ] = ACTIONS(6672),
    [anon_sym_LPAREN] = ACTIONS(6672),
    [anon_sym_RPAREN] = ACTIONS(6672),
    [anon_sym_LBRACE] = ACTIONS(6672),
    [sym_word] = ACTIONS(6670),
    [sym_placeholder] = ACTIONS(6672),
    [anon_sym_PLUS] = ACTIONS(6672),
    [anon_sym_DASH] = ACTIONS(6672),
    [anon_sym_STAR] = ACTIONS(6672),
    [anon_sym_SLASH] = ACTIONS(6672),
    [anon_sym_LT] = ACTIONS(6670),
    [anon_sym_GT] = ACTIONS(6670),
    [anon_sym_BANG] = ACTIONS(6670),
    [anon_sym_PIPE] = ACTIONS(6670),
    [anon_sym_COLON] = ACTIONS(6670),
    [anon_sym_SQUOTE] = ACTIONS(6670),
    [anon_sym__] = ACTIONS(6672),
    [anon_sym_CARET] = ACTIONS(6672),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6672),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6672),
    [anon_sym_DOLLAR] = ACTIONS(6670),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6672),
    [anon_sym_BSLASHbegin] = ACTIONS(6670),
    [anon_sym_BSLASHtitle] = ACTIONS(6670),
    [anon_sym_BSLASHauthor] = ACTIONS(6670),
    [anon_sym_BSLASHusepackage] = ACTIONS(6670),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6670),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6670),
    [anon_sym_BSLASHinclude] = ACTIONS(6670),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6670),
    [anon_sym_BSLASHinput] = ACTIONS(6670),
    [anon_sym_BSLASHsubfile] = ACTIONS(6670),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6670),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6670),
    [anon_sym_BSLASHbibliography] = ACTIONS(6670),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6670),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6670),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6670),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6670),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6670),
    [anon_sym_BSLASHimport] = ACTIONS(6670),
    [anon_sym_BSLASHsubimport] = ACTIONS(6670),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6670),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6670),
    [anon_sym_BSLASHcaption] = ACTIONS(6670),
    [anon_sym_BSLASHcite] = ACTIONS(6670),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCite] = ACTIONS(6670),
    [anon_sym_BSLASHnocite] = ACTIONS(6670),
    [anon_sym_BSLASHcitet] = ACTIONS(6670),
    [anon_sym_BSLASHcitep] = ACTIONS(6670),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteA] = ACTIONS(6670),
    [anon_sym_BSLASHciteR] = ACTIONS(6670),
    [anon_sym_BSLASHciteS] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6670),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6670),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteyear] = ACTIONS(6670),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHcitedate] = ACTIONS(6670),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHciteurl] = ACTIONS(6670),
    [anon_sym_BSLASHfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6670),
    [anon_sym_BSLASHcitealt] = ACTIONS(6670),
    [anon_sym_BSLASHcitealp] = ACTIONS(6670),
    [anon_sym_BSLASHcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHparencite] = ACTIONS(6670),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHParencite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6670),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6670),
    [anon_sym_BSLASHtextcite] = ACTIONS(6670),
    [anon_sym_BSLASHTextcite] = ACTIONS(6670),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6670),
    [anon_sym_BSLASHsupercite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite] = ACTIONS(6670),
    [anon_sym_BSLASHAutocite] = ACTIONS(6670),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHVolcite] = ACTIONS(6670),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHavolcite] = ACTIONS(6670),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6670),
    [anon_sym_BSLASHnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHNotecite] = ACTIONS(6670),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6670),
    [anon_sym_BSLASHlabel] = ACTIONS(6670),
    [anon_sym_BSLASHref] = ACTIONS(6670),
    [anon_sym_BSLASHeqref] = ACTIONS(6670),
    [anon_sym_BSLASHvref] = ACTIONS(6670),
    [anon_sym_BSLASHVref] = ACTIONS(6670),
    [anon_sym_BSLASHautoref] = ACTIONS(6670),
    [anon_sym_BSLASHpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcref] = ACTIONS(6670),
    [anon_sym_BSLASHCref] = ACTIONS(6670),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnameCref] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6670),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6670),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6670),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6670),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6670),
    [anon_sym_BSLASHdef] = ACTIONS(6670),
    [anon_sym_BSLASHlet] = ACTIONS(6670),
    [anon_sym_BSLASHleft] = ACTIONS(6670),
    [anon_sym_BSLASHbigl] = ACTIONS(6670),
    [anon_sym_BSLASHBigl] = ACTIONS(6670),
    [anon_sym_BSLASHbiggl] = ACTIONS(6670),
    [anon_sym_BSLASHBiggl] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6670),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6670),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6670),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6670),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6670),
    [anon_sym_BSLASHgls] = ACTIONS(6670),
    [anon_sym_BSLASHGls] = ACTIONS(6670),
    [anon_sym_BSLASHGLS] = ACTIONS(6670),
    [anon_sym_BSLASHglspl] = ACTIONS(6670),
    [anon_sym_BSLASHGlspl] = ACTIONS(6670),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6670),
    [anon_sym_BSLASHglslink] = ACTIONS(6670),
    [anon_sym_BSLASHglstext] = ACTIONS(6670),
    [anon_sym_BSLASHGlstext] = ACTIONS(6670),
    [anon_sym_BSLASHGLStext] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6670),
    [anon_sym_BSLASHglsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6670),
    [anon_sym_BSLASHglsname] = ACTIONS(6670),
    [anon_sym_BSLASHGlsname] = ACTIONS(6670),
    [anon_sym_BSLASHGLSname] = ACTIONS(6670),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6670),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6670),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6670),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6670),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6670),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6670),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6670),
    [anon_sym_BSLASHacrshort] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6670),
    [anon_sym_BSLASHACRshort] = ACTIONS(6670),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrlong] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6670),
    [anon_sym_BSLASHACRlong] = ACTIONS(6670),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6670),
    [anon_sym_BSLASHacrfull] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6670),
    [anon_sym_BSLASHACRfull] = ACTIONS(6670),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHacs] = ACTIONS(6670),
    [anon_sym_BSLASHAcs] = ACTIONS(6670),
    [anon_sym_BSLASHacsp] = ACTIONS(6670),
    [anon_sym_BSLASHAcsp] = ACTIONS(6670),
    [anon_sym_BSLASHacl] = ACTIONS(6670),
    [anon_sym_BSLASHAcl] = ACTIONS(6670),
    [anon_sym_BSLASHaclp] = ACTIONS(6670),
    [anon_sym_BSLASHAclp] = ACTIONS(6670),
    [anon_sym_BSLASHacf] = ACTIONS(6670),
    [anon_sym_BSLASHAcf] = ACTIONS(6670),
    [anon_sym_BSLASHacfp] = ACTIONS(6670),
    [anon_sym_BSLASHAcfp] = ACTIONS(6670),
    [anon_sym_BSLASHac] = ACTIONS(6670),
    [anon_sym_BSLASHAc] = ACTIONS(6670),
    [anon_sym_BSLASHacp] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6670),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6670),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6670),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6670),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6672),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6670),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6670),
    [anon_sym_BSLASHcolor] = ACTIONS(6670),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6670),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6670),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6670),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6670),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6670),
    [anon_sym_BSLASHtext] = ACTIONS(6670),
    [anon_sym_BSLASHintertext] = ACTIONS(6670),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6670),
    [anon_sym_BSLASHurl] = ACTIONS(6670),
    [anon_sym_BSLASHhref] = ACTIONS(6670),
  },
  [1734] = {
    [sym_command_name] = ACTIONS(6562),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6562),
    [anon_sym_LBRACK] = ACTIONS(6564),
    [anon_sym_RBRACK] = ACTIONS(6564),
    [anon_sym_COMMA] = ACTIONS(6564),
    [anon_sym_EQ] = ACTIONS(6564),
    [anon_sym_LPAREN] = ACTIONS(6564),
    [anon_sym_RPAREN] = ACTIONS(6564),
    [anon_sym_LBRACE] = ACTIONS(6564),
    [sym_word] = ACTIONS(6562),
    [sym_placeholder] = ACTIONS(6564),
    [anon_sym_PLUS] = ACTIONS(6564),
    [anon_sym_DASH] = ACTIONS(6564),
    [anon_sym_STAR] = ACTIONS(6564),
    [anon_sym_SLASH] = ACTIONS(6564),
    [anon_sym_LT] = ACTIONS(6562),
    [anon_sym_GT] = ACTIONS(6562),
    [anon_sym_BANG] = ACTIONS(6562),
    [anon_sym_PIPE] = ACTIONS(6562),
    [anon_sym_COLON] = ACTIONS(6562),
    [anon_sym_SQUOTE] = ACTIONS(6562),
    [anon_sym__] = ACTIONS(6564),
    [anon_sym_CARET] = ACTIONS(6564),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6564),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6564),
    [anon_sym_DOLLAR] = ACTIONS(6562),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6564),
    [anon_sym_BSLASHbegin] = ACTIONS(6562),
    [anon_sym_BSLASHtitle] = ACTIONS(6562),
    [anon_sym_BSLASHauthor] = ACTIONS(6562),
    [anon_sym_BSLASHusepackage] = ACTIONS(6562),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6562),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6562),
    [anon_sym_BSLASHinclude] = ACTIONS(6562),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6562),
    [anon_sym_BSLASHinput] = ACTIONS(6562),
    [anon_sym_BSLASHsubfile] = ACTIONS(6562),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6562),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6562),
    [anon_sym_BSLASHbibliography] = ACTIONS(6562),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6562),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6562),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6562),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6562),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6562),
    [anon_sym_BSLASHimport] = ACTIONS(6562),
    [anon_sym_BSLASHsubimport] = ACTIONS(6562),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6562),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6562),
    [anon_sym_BSLASHcaption] = ACTIONS(6562),
    [anon_sym_BSLASHcite] = ACTIONS(6562),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCite] = ACTIONS(6562),
    [anon_sym_BSLASHnocite] = ACTIONS(6562),
    [anon_sym_BSLASHcitet] = ACTIONS(6562),
    [anon_sym_BSLASHcitep] = ACTIONS(6562),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteA] = ACTIONS(6562),
    [anon_sym_BSLASHciteR] = ACTIONS(6562),
    [anon_sym_BSLASHciteS] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6562),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6562),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteyear] = ACTIONS(6562),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHcitedate] = ACTIONS(6562),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHciteurl] = ACTIONS(6562),
    [anon_sym_BSLASHfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6562),
    [anon_sym_BSLASHcitealt] = ACTIONS(6562),
    [anon_sym_BSLASHcitealp] = ACTIONS(6562),
    [anon_sym_BSLASHcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHparencite] = ACTIONS(6562),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHParencite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6562),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6562),
    [anon_sym_BSLASHtextcite] = ACTIONS(6562),
    [anon_sym_BSLASHTextcite] = ACTIONS(6562),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6562),
    [anon_sym_BSLASHsupercite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite] = ACTIONS(6562),
    [anon_sym_BSLASHAutocite] = ACTIONS(6562),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHVolcite] = ACTIONS(6562),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHavolcite] = ACTIONS(6562),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6562),
    [anon_sym_BSLASHnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHNotecite] = ACTIONS(6562),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6562),
    [anon_sym_BSLASHlabel] = ACTIONS(6562),
    [anon_sym_BSLASHref] = ACTIONS(6562),
    [anon_sym_BSLASHeqref] = ACTIONS(6562),
    [anon_sym_BSLASHvref] = ACTIONS(6562),
    [anon_sym_BSLASHVref] = ACTIONS(6562),
    [anon_sym_BSLASHautoref] = ACTIONS(6562),
    [anon_sym_BSLASHpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcref] = ACTIONS(6562),
    [anon_sym_BSLASHCref] = ACTIONS(6562),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnameCref] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6562),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6562),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6562),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6562),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6562),
    [anon_sym_BSLASHdef] = ACTIONS(6562),
    [anon_sym_BSLASHlet] = ACTIONS(6562),
    [anon_sym_BSLASHleft] = ACTIONS(6562),
    [anon_sym_BSLASHbigl] = ACTIONS(6562),
    [anon_sym_BSLASHBigl] = ACTIONS(6562),
    [anon_sym_BSLASHbiggl] = ACTIONS(6562),
    [anon_sym_BSLASHBiggl] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6562),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6562),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6562),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6562),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6562),
    [anon_sym_BSLASHgls] = ACTIONS(6562),
    [anon_sym_BSLASHGls] = ACTIONS(6562),
    [anon_sym_BSLASHGLS] = ACTIONS(6562),
    [anon_sym_BSLASHglspl] = ACTIONS(6562),
    [anon_sym_BSLASHGlspl] = ACTIONS(6562),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6562),
    [anon_sym_BSLASHglslink] = ACTIONS(6562),
    [anon_sym_BSLASHglstext] = ACTIONS(6562),
    [anon_sym_BSLASHGlstext] = ACTIONS(6562),
    [anon_sym_BSLASHGLStext] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6562),
    [anon_sym_BSLASHglsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6562),
    [anon_sym_BSLASHglsname] = ACTIONS(6562),
    [anon_sym_BSLASHGlsname] = ACTIONS(6562),
    [anon_sym_BSLASHGLSname] = ACTIONS(6562),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6562),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6562),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6562),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6562),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6562),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6562),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6562),
    [anon_sym_BSLASHacrshort] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6562),
    [anon_sym_BSLASHACRshort] = ACTIONS(6562),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrlong] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6562),
    [anon_sym_BSLASHACRlong] = ACTIONS(6562),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6562),
    [anon_sym_BSLASHacrfull] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6562),
    [anon_sym_BSLASHACRfull] = ACTIONS(6562),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHacs] = ACTIONS(6562),
    [anon_sym_BSLASHAcs] = ACTIONS(6562),
    [anon_sym_BSLASHacsp] = ACTIONS(6562),
    [anon_sym_BSLASHAcsp] = ACTIONS(6562),
    [anon_sym_BSLASHacl] = ACTIONS(6562),
    [anon_sym_BSLASHAcl] = ACTIONS(6562),
    [anon_sym_BSLASHaclp] = ACTIONS(6562),
    [anon_sym_BSLASHAclp] = ACTIONS(6562),
    [anon_sym_BSLASHacf] = ACTIONS(6562),
    [anon_sym_BSLASHAcf] = ACTIONS(6562),
    [anon_sym_BSLASHacfp] = ACTIONS(6562),
    [anon_sym_BSLASHAcfp] = ACTIONS(6562),
    [anon_sym_BSLASHac] = ACTIONS(6562),
    [anon_sym_BSLASHAc] = ACTIONS(6562),
    [anon_sym_BSLASHacp] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6562),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6562),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6562),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6562),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6564),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6562),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6562),
    [anon_sym_BSLASHcolor] = ACTIONS(6562),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6562),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6562),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6562),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6562),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6562),
    [anon_sym_BSLASHtext] = ACTIONS(6562),
    [anon_sym_BSLASHintertext] = ACTIONS(6562),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6562),
    [anon_sym_BSLASHurl] = ACTIONS(6562),
    [anon_sym_BSLASHhref] = ACTIONS(6562),
  },
  [1735] = {
    [sym_command_name] = ACTIONS(6590),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6590),
    [anon_sym_LBRACK] = ACTIONS(6592),
    [anon_sym_RBRACK] = ACTIONS(6592),
    [anon_sym_COMMA] = ACTIONS(6592),
    [anon_sym_EQ] = ACTIONS(6592),
    [anon_sym_LPAREN] = ACTIONS(6592),
    [anon_sym_RPAREN] = ACTIONS(6592),
    [anon_sym_LBRACE] = ACTIONS(6592),
    [sym_word] = ACTIONS(6590),
    [sym_placeholder] = ACTIONS(6592),
    [anon_sym_PLUS] = ACTIONS(6592),
    [anon_sym_DASH] = ACTIONS(6592),
    [anon_sym_STAR] = ACTIONS(6592),
    [anon_sym_SLASH] = ACTIONS(6592),
    [anon_sym_LT] = ACTIONS(6590),
    [anon_sym_GT] = ACTIONS(6590),
    [anon_sym_BANG] = ACTIONS(6590),
    [anon_sym_PIPE] = ACTIONS(6590),
    [anon_sym_COLON] = ACTIONS(6590),
    [anon_sym_SQUOTE] = ACTIONS(6590),
    [anon_sym__] = ACTIONS(6592),
    [anon_sym_CARET] = ACTIONS(6592),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6592),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6592),
    [anon_sym_DOLLAR] = ACTIONS(6590),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6592),
    [anon_sym_BSLASHbegin] = ACTIONS(6590),
    [anon_sym_BSLASHtitle] = ACTIONS(6590),
    [anon_sym_BSLASHauthor] = ACTIONS(6590),
    [anon_sym_BSLASHusepackage] = ACTIONS(6590),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6590),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6590),
    [anon_sym_BSLASHinclude] = ACTIONS(6590),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6590),
    [anon_sym_BSLASHinput] = ACTIONS(6590),
    [anon_sym_BSLASHsubfile] = ACTIONS(6590),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6590),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6590),
    [anon_sym_BSLASHbibliography] = ACTIONS(6590),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6590),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6590),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6590),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6590),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6590),
    [anon_sym_BSLASHimport] = ACTIONS(6590),
    [anon_sym_BSLASHsubimport] = ACTIONS(6590),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6590),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6590),
    [anon_sym_BSLASHcaption] = ACTIONS(6590),
    [anon_sym_BSLASHcite] = ACTIONS(6590),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCite] = ACTIONS(6590),
    [anon_sym_BSLASHnocite] = ACTIONS(6590),
    [anon_sym_BSLASHcitet] = ACTIONS(6590),
    [anon_sym_BSLASHcitep] = ACTIONS(6590),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteA] = ACTIONS(6590),
    [anon_sym_BSLASHciteR] = ACTIONS(6590),
    [anon_sym_BSLASHciteS] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6590),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6590),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteyear] = ACTIONS(6590),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHcitedate] = ACTIONS(6590),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHciteurl] = ACTIONS(6590),
    [anon_sym_BSLASHfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6590),
    [anon_sym_BSLASHcitealt] = ACTIONS(6590),
    [anon_sym_BSLASHcitealp] = ACTIONS(6590),
    [anon_sym_BSLASHcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHparencite] = ACTIONS(6590),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHParencite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6590),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6590),
    [anon_sym_BSLASHtextcite] = ACTIONS(6590),
    [anon_sym_BSLASHTextcite] = ACTIONS(6590),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6590),
    [anon_sym_BSLASHsupercite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite] = ACTIONS(6590),
    [anon_sym_BSLASHAutocite] = ACTIONS(6590),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHVolcite] = ACTIONS(6590),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHavolcite] = ACTIONS(6590),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6590),
    [anon_sym_BSLASHnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHNotecite] = ACTIONS(6590),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6590),
    [anon_sym_BSLASHlabel] = ACTIONS(6590),
    [anon_sym_BSLASHref] = ACTIONS(6590),
    [anon_sym_BSLASHeqref] = ACTIONS(6590),
    [anon_sym_BSLASHvref] = ACTIONS(6590),
    [anon_sym_BSLASHVref] = ACTIONS(6590),
    [anon_sym_BSLASHautoref] = ACTIONS(6590),
    [anon_sym_BSLASHpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcref] = ACTIONS(6590),
    [anon_sym_BSLASHCref] = ACTIONS(6590),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnameCref] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6590),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6590),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6590),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6590),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6590),
    [anon_sym_BSLASHdef] = ACTIONS(6590),
    [anon_sym_BSLASHlet] = ACTIONS(6590),
    [anon_sym_BSLASHleft] = ACTIONS(6590),
    [anon_sym_BSLASHbigl] = ACTIONS(6590),
    [anon_sym_BSLASHBigl] = ACTIONS(6590),
    [anon_sym_BSLASHbiggl] = ACTIONS(6590),
    [anon_sym_BSLASHBiggl] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6590),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6590),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6590),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6590),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6590),
    [anon_sym_BSLASHgls] = ACTIONS(6590),
    [anon_sym_BSLASHGls] = ACTIONS(6590),
    [anon_sym_BSLASHGLS] = ACTIONS(6590),
    [anon_sym_BSLASHglspl] = ACTIONS(6590),
    [anon_sym_BSLASHGlspl] = ACTIONS(6590),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6590),
    [anon_sym_BSLASHglslink] = ACTIONS(6590),
    [anon_sym_BSLASHglstext] = ACTIONS(6590),
    [anon_sym_BSLASHGlstext] = ACTIONS(6590),
    [anon_sym_BSLASHGLStext] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6590),
    [anon_sym_BSLASHglsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6590),
    [anon_sym_BSLASHglsname] = ACTIONS(6590),
    [anon_sym_BSLASHGlsname] = ACTIONS(6590),
    [anon_sym_BSLASHGLSname] = ACTIONS(6590),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6590),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6590),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6590),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6590),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6590),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6590),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6590),
    [anon_sym_BSLASHacrshort] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6590),
    [anon_sym_BSLASHACRshort] = ACTIONS(6590),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrlong] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6590),
    [anon_sym_BSLASHACRlong] = ACTIONS(6590),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6590),
    [anon_sym_BSLASHacrfull] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6590),
    [anon_sym_BSLASHACRfull] = ACTIONS(6590),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHacs] = ACTIONS(6590),
    [anon_sym_BSLASHAcs] = ACTIONS(6590),
    [anon_sym_BSLASHacsp] = ACTIONS(6590),
    [anon_sym_BSLASHAcsp] = ACTIONS(6590),
    [anon_sym_BSLASHacl] = ACTIONS(6590),
    [anon_sym_BSLASHAcl] = ACTIONS(6590),
    [anon_sym_BSLASHaclp] = ACTIONS(6590),
    [anon_sym_BSLASHAclp] = ACTIONS(6590),
    [anon_sym_BSLASHacf] = ACTIONS(6590),
    [anon_sym_BSLASHAcf] = ACTIONS(6590),
    [anon_sym_BSLASHacfp] = ACTIONS(6590),
    [anon_sym_BSLASHAcfp] = ACTIONS(6590),
    [anon_sym_BSLASHac] = ACTIONS(6590),
    [anon_sym_BSLASHAc] = ACTIONS(6590),
    [anon_sym_BSLASHacp] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6590),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6590),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6590),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6590),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6592),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6590),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6590),
    [anon_sym_BSLASHcolor] = ACTIONS(6590),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6590),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6590),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6590),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6590),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6590),
    [anon_sym_BSLASHtext] = ACTIONS(6590),
    [anon_sym_BSLASHintertext] = ACTIONS(6590),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6590),
    [anon_sym_BSLASHurl] = ACTIONS(6590),
    [anon_sym_BSLASHhref] = ACTIONS(6590),
  },
  [1736] = {
    [sym_command_name] = ACTIONS(6598),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6598),
    [anon_sym_LBRACK] = ACTIONS(6600),
    [anon_sym_RBRACK] = ACTIONS(6600),
    [anon_sym_COMMA] = ACTIONS(6600),
    [anon_sym_EQ] = ACTIONS(6600),
    [anon_sym_LPAREN] = ACTIONS(6600),
    [anon_sym_RPAREN] = ACTIONS(6600),
    [anon_sym_LBRACE] = ACTIONS(6600),
    [sym_word] = ACTIONS(6598),
    [sym_placeholder] = ACTIONS(6600),
    [anon_sym_PLUS] = ACTIONS(6600),
    [anon_sym_DASH] = ACTIONS(6600),
    [anon_sym_STAR] = ACTIONS(6600),
    [anon_sym_SLASH] = ACTIONS(6600),
    [anon_sym_LT] = ACTIONS(6598),
    [anon_sym_GT] = ACTIONS(6598),
    [anon_sym_BANG] = ACTIONS(6598),
    [anon_sym_PIPE] = ACTIONS(6598),
    [anon_sym_COLON] = ACTIONS(6598),
    [anon_sym_SQUOTE] = ACTIONS(6598),
    [anon_sym__] = ACTIONS(6600),
    [anon_sym_CARET] = ACTIONS(6600),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6600),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6600),
    [anon_sym_DOLLAR] = ACTIONS(6598),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6600),
    [anon_sym_BSLASHbegin] = ACTIONS(6598),
    [anon_sym_BSLASHtitle] = ACTIONS(6598),
    [anon_sym_BSLASHauthor] = ACTIONS(6598),
    [anon_sym_BSLASHusepackage] = ACTIONS(6598),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6598),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6598),
    [anon_sym_BSLASHinclude] = ACTIONS(6598),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6598),
    [anon_sym_BSLASHinput] = ACTIONS(6598),
    [anon_sym_BSLASHsubfile] = ACTIONS(6598),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6598),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6598),
    [anon_sym_BSLASHbibliography] = ACTIONS(6598),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6598),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6598),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6598),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6598),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6598),
    [anon_sym_BSLASHimport] = ACTIONS(6598),
    [anon_sym_BSLASHsubimport] = ACTIONS(6598),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6598),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6598),
    [anon_sym_BSLASHcaption] = ACTIONS(6598),
    [anon_sym_BSLASHcite] = ACTIONS(6598),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCite] = ACTIONS(6598),
    [anon_sym_BSLASHnocite] = ACTIONS(6598),
    [anon_sym_BSLASHcitet] = ACTIONS(6598),
    [anon_sym_BSLASHcitep] = ACTIONS(6598),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteA] = ACTIONS(6598),
    [anon_sym_BSLASHciteR] = ACTIONS(6598),
    [anon_sym_BSLASHciteS] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6598),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6598),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteyear] = ACTIONS(6598),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHcitedate] = ACTIONS(6598),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHciteurl] = ACTIONS(6598),
    [anon_sym_BSLASHfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6598),
    [anon_sym_BSLASHcitealt] = ACTIONS(6598),
    [anon_sym_BSLASHcitealp] = ACTIONS(6598),
    [anon_sym_BSLASHcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHparencite] = ACTIONS(6598),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHParencite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6598),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6598),
    [anon_sym_BSLASHtextcite] = ACTIONS(6598),
    [anon_sym_BSLASHTextcite] = ACTIONS(6598),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6598),
    [anon_sym_BSLASHsupercite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite] = ACTIONS(6598),
    [anon_sym_BSLASHAutocite] = ACTIONS(6598),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHVolcite] = ACTIONS(6598),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHavolcite] = ACTIONS(6598),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6598),
    [anon_sym_BSLASHnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHNotecite] = ACTIONS(6598),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6598),
    [anon_sym_BSLASHlabel] = ACTIONS(6598),
    [anon_sym_BSLASHref] = ACTIONS(6598),
    [anon_sym_BSLASHeqref] = ACTIONS(6598),
    [anon_sym_BSLASHvref] = ACTIONS(6598),
    [anon_sym_BSLASHVref] = ACTIONS(6598),
    [anon_sym_BSLASHautoref] = ACTIONS(6598),
    [anon_sym_BSLASHpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcref] = ACTIONS(6598),
    [anon_sym_BSLASHCref] = ACTIONS(6598),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnameCref] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6598),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6598),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6598),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6598),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6598),
    [anon_sym_BSLASHdef] = ACTIONS(6598),
    [anon_sym_BSLASHlet] = ACTIONS(6598),
    [anon_sym_BSLASHleft] = ACTIONS(6598),
    [anon_sym_BSLASHbigl] = ACTIONS(6598),
    [anon_sym_BSLASHBigl] = ACTIONS(6598),
    [anon_sym_BSLASHbiggl] = ACTIONS(6598),
    [anon_sym_BSLASHBiggl] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6598),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6598),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6598),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6598),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6598),
    [anon_sym_BSLASHgls] = ACTIONS(6598),
    [anon_sym_BSLASHGls] = ACTIONS(6598),
    [anon_sym_BSLASHGLS] = ACTIONS(6598),
    [anon_sym_BSLASHglspl] = ACTIONS(6598),
    [anon_sym_BSLASHGlspl] = ACTIONS(6598),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6598),
    [anon_sym_BSLASHglslink] = ACTIONS(6598),
    [anon_sym_BSLASHglstext] = ACTIONS(6598),
    [anon_sym_BSLASHGlstext] = ACTIONS(6598),
    [anon_sym_BSLASHGLStext] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6598),
    [anon_sym_BSLASHglsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6598),
    [anon_sym_BSLASHglsname] = ACTIONS(6598),
    [anon_sym_BSLASHGlsname] = ACTIONS(6598),
    [anon_sym_BSLASHGLSname] = ACTIONS(6598),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6598),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6598),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6598),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6598),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6598),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6598),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6598),
    [anon_sym_BSLASHacrshort] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6598),
    [anon_sym_BSLASHACRshort] = ACTIONS(6598),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrlong] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6598),
    [anon_sym_BSLASHACRlong] = ACTIONS(6598),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6598),
    [anon_sym_BSLASHacrfull] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6598),
    [anon_sym_BSLASHACRfull] = ACTIONS(6598),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHacs] = ACTIONS(6598),
    [anon_sym_BSLASHAcs] = ACTIONS(6598),
    [anon_sym_BSLASHacsp] = ACTIONS(6598),
    [anon_sym_BSLASHAcsp] = ACTIONS(6598),
    [anon_sym_BSLASHacl] = ACTIONS(6598),
    [anon_sym_BSLASHAcl] = ACTIONS(6598),
    [anon_sym_BSLASHaclp] = ACTIONS(6598),
    [anon_sym_BSLASHAclp] = ACTIONS(6598),
    [anon_sym_BSLASHacf] = ACTIONS(6598),
    [anon_sym_BSLASHAcf] = ACTIONS(6598),
    [anon_sym_BSLASHacfp] = ACTIONS(6598),
    [anon_sym_BSLASHAcfp] = ACTIONS(6598),
    [anon_sym_BSLASHac] = ACTIONS(6598),
    [anon_sym_BSLASHAc] = ACTIONS(6598),
    [anon_sym_BSLASHacp] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6598),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6598),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6598),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6598),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6600),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6598),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6598),
    [anon_sym_BSLASHcolor] = ACTIONS(6598),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6598),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6598),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6598),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6598),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6598),
    [anon_sym_BSLASHtext] = ACTIONS(6598),
    [anon_sym_BSLASHintertext] = ACTIONS(6598),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6598),
    [anon_sym_BSLASHurl] = ACTIONS(6598),
    [anon_sym_BSLASHhref] = ACTIONS(6598),
  },
  [1737] = {
    [sym_command_name] = ACTIONS(6626),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6626),
    [anon_sym_LBRACK] = ACTIONS(6628),
    [anon_sym_RBRACK] = ACTIONS(6628),
    [anon_sym_COMMA] = ACTIONS(6628),
    [anon_sym_EQ] = ACTIONS(6628),
    [anon_sym_LPAREN] = ACTIONS(6628),
    [anon_sym_RPAREN] = ACTIONS(6628),
    [anon_sym_LBRACE] = ACTIONS(6628),
    [sym_word] = ACTIONS(6626),
    [sym_placeholder] = ACTIONS(6628),
    [anon_sym_PLUS] = ACTIONS(6628),
    [anon_sym_DASH] = ACTIONS(6628),
    [anon_sym_STAR] = ACTIONS(6628),
    [anon_sym_SLASH] = ACTIONS(6628),
    [anon_sym_LT] = ACTIONS(6626),
    [anon_sym_GT] = ACTIONS(6626),
    [anon_sym_BANG] = ACTIONS(6626),
    [anon_sym_PIPE] = ACTIONS(6626),
    [anon_sym_COLON] = ACTIONS(6626),
    [anon_sym_SQUOTE] = ACTIONS(6626),
    [anon_sym__] = ACTIONS(6628),
    [anon_sym_CARET] = ACTIONS(6628),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6628),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6628),
    [anon_sym_DOLLAR] = ACTIONS(6626),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6628),
    [anon_sym_BSLASHbegin] = ACTIONS(6626),
    [anon_sym_BSLASHtitle] = ACTIONS(6626),
    [anon_sym_BSLASHauthor] = ACTIONS(6626),
    [anon_sym_BSLASHusepackage] = ACTIONS(6626),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6626),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6626),
    [anon_sym_BSLASHinclude] = ACTIONS(6626),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6626),
    [anon_sym_BSLASHinput] = ACTIONS(6626),
    [anon_sym_BSLASHsubfile] = ACTIONS(6626),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6626),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6626),
    [anon_sym_BSLASHbibliography] = ACTIONS(6626),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6626),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6626),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6626),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6626),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6626),
    [anon_sym_BSLASHimport] = ACTIONS(6626),
    [anon_sym_BSLASHsubimport] = ACTIONS(6626),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6626),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6626),
    [anon_sym_BSLASHcaption] = ACTIONS(6626),
    [anon_sym_BSLASHcite] = ACTIONS(6626),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCite] = ACTIONS(6626),
    [anon_sym_BSLASHnocite] = ACTIONS(6626),
    [anon_sym_BSLASHcitet] = ACTIONS(6626),
    [anon_sym_BSLASHcitep] = ACTIONS(6626),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteA] = ACTIONS(6626),
    [anon_sym_BSLASHciteR] = ACTIONS(6626),
    [anon_sym_BSLASHciteS] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6626),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6626),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteyear] = ACTIONS(6626),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHcitedate] = ACTIONS(6626),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHciteurl] = ACTIONS(6626),
    [anon_sym_BSLASHfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6626),
    [anon_sym_BSLASHcitealt] = ACTIONS(6626),
    [anon_sym_BSLASHcitealp] = ACTIONS(6626),
    [anon_sym_BSLASHcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHparencite] = ACTIONS(6626),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHParencite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6626),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6626),
    [anon_sym_BSLASHtextcite] = ACTIONS(6626),
    [anon_sym_BSLASHTextcite] = ACTIONS(6626),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6626),
    [anon_sym_BSLASHsupercite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite] = ACTIONS(6626),
    [anon_sym_BSLASHAutocite] = ACTIONS(6626),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHVolcite] = ACTIONS(6626),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHavolcite] = ACTIONS(6626),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6626),
    [anon_sym_BSLASHnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHNotecite] = ACTIONS(6626),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6626),
    [anon_sym_BSLASHlabel] = ACTIONS(6626),
    [anon_sym_BSLASHref] = ACTIONS(6626),
    [anon_sym_BSLASHeqref] = ACTIONS(6626),
    [anon_sym_BSLASHvref] = ACTIONS(6626),
    [anon_sym_BSLASHVref] = ACTIONS(6626),
    [anon_sym_BSLASHautoref] = ACTIONS(6626),
    [anon_sym_BSLASHpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcref] = ACTIONS(6626),
    [anon_sym_BSLASHCref] = ACTIONS(6626),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnameCref] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6626),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6626),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6626),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6626),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6626),
    [anon_sym_BSLASHdef] = ACTIONS(6626),
    [anon_sym_BSLASHlet] = ACTIONS(6626),
    [anon_sym_BSLASHleft] = ACTIONS(6626),
    [anon_sym_BSLASHbigl] = ACTIONS(6626),
    [anon_sym_BSLASHBigl] = ACTIONS(6626),
    [anon_sym_BSLASHbiggl] = ACTIONS(6626),
    [anon_sym_BSLASHBiggl] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6626),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6626),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6626),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6626),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6626),
    [anon_sym_BSLASHgls] = ACTIONS(6626),
    [anon_sym_BSLASHGls] = ACTIONS(6626),
    [anon_sym_BSLASHGLS] = ACTIONS(6626),
    [anon_sym_BSLASHglspl] = ACTIONS(6626),
    [anon_sym_BSLASHGlspl] = ACTIONS(6626),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6626),
    [anon_sym_BSLASHglslink] = ACTIONS(6626),
    [anon_sym_BSLASHglstext] = ACTIONS(6626),
    [anon_sym_BSLASHGlstext] = ACTIONS(6626),
    [anon_sym_BSLASHGLStext] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6626),
    [anon_sym_BSLASHglsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6626),
    [anon_sym_BSLASHglsname] = ACTIONS(6626),
    [anon_sym_BSLASHGlsname] = ACTIONS(6626),
    [anon_sym_BSLASHGLSname] = ACTIONS(6626),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6626),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6626),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6626),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6626),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6626),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6626),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6626),
    [anon_sym_BSLASHacrshort] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6626),
    [anon_sym_BSLASHACRshort] = ACTIONS(6626),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrlong] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6626),
    [anon_sym_BSLASHACRlong] = ACTIONS(6626),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6626),
    [anon_sym_BSLASHacrfull] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6626),
    [anon_sym_BSLASHACRfull] = ACTIONS(6626),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHacs] = ACTIONS(6626),
    [anon_sym_BSLASHAcs] = ACTIONS(6626),
    [anon_sym_BSLASHacsp] = ACTIONS(6626),
    [anon_sym_BSLASHAcsp] = ACTIONS(6626),
    [anon_sym_BSLASHacl] = ACTIONS(6626),
    [anon_sym_BSLASHAcl] = ACTIONS(6626),
    [anon_sym_BSLASHaclp] = ACTIONS(6626),
    [anon_sym_BSLASHAclp] = ACTIONS(6626),
    [anon_sym_BSLASHacf] = ACTIONS(6626),
    [anon_sym_BSLASHAcf] = ACTIONS(6626),
    [anon_sym_BSLASHacfp] = ACTIONS(6626),
    [anon_sym_BSLASHAcfp] = ACTIONS(6626),
    [anon_sym_BSLASHac] = ACTIONS(6626),
    [anon_sym_BSLASHAc] = ACTIONS(6626),
    [anon_sym_BSLASHacp] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6626),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6626),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6626),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6626),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6628),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6626),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6626),
    [anon_sym_BSLASHcolor] = ACTIONS(6626),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6626),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6626),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6626),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6626),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6626),
    [anon_sym_BSLASHtext] = ACTIONS(6626),
    [anon_sym_BSLASHintertext] = ACTIONS(6626),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6626),
    [anon_sym_BSLASHurl] = ACTIONS(6626),
    [anon_sym_BSLASHhref] = ACTIONS(6626),
  },
  [1738] = {
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6252),
    [anon_sym_LPAREN] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHleft] = ACTIONS(6250),
    [anon_sym_BSLASHbigl] = ACTIONS(6250),
    [anon_sym_BSLASHBigl] = ACTIONS(6250),
    [anon_sym_BSLASHbiggl] = ACTIONS(6250),
    [anon_sym_BSLASHBiggl] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHtext] = ACTIONS(6250),
    [anon_sym_BSLASHintertext] = ACTIONS(6250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
  [1739] = {
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_COMMA] = ACTIONS(6268),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_LPAREN] = ACTIONS(6268),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [anon_sym_RBRACE] = ACTIONS(6268),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6268),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(6266),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHleft] = ACTIONS(6266),
    [anon_sym_BSLASHbigl] = ACTIONS(6266),
    [anon_sym_BSLASHBigl] = ACTIONS(6266),
    [anon_sym_BSLASHbiggl] = ACTIONS(6266),
    [anon_sym_BSLASHBiggl] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHtext] = ACTIONS(6266),
    [anon_sym_BSLASHintertext] = ACTIONS(6266),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [1740] = {
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_LBRACK] = ACTIONS(6272),
    [anon_sym_RBRACK] = ACTIONS(6272),
    [anon_sym_COMMA] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_LPAREN] = ACTIONS(6272),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6272),
    [anon_sym_RBRACE] = ACTIONS(6272),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6272),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6272),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHleft] = ACTIONS(6270),
    [anon_sym_BSLASHbigl] = ACTIONS(6270),
    [anon_sym_BSLASHBigl] = ACTIONS(6270),
    [anon_sym_BSLASHbiggl] = ACTIONS(6270),
    [anon_sym_BSLASHBiggl] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHtext] = ACTIONS(6270),
    [anon_sym_BSLASHintertext] = ACTIONS(6270),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [1741] = {
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6288),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_RBRACE] = ACTIONS(6288),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6288),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6288),
    [anon_sym_DOLLAR] = ACTIONS(6286),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHleft] = ACTIONS(6286),
    [anon_sym_BSLASHbigl] = ACTIONS(6286),
    [anon_sym_BSLASHBigl] = ACTIONS(6286),
    [anon_sym_BSLASHbiggl] = ACTIONS(6286),
    [anon_sym_BSLASHBiggl] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHtext] = ACTIONS(6286),
    [anon_sym_BSLASHintertext] = ACTIONS(6286),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [1742] = {
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6292),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_COMMA] = ACTIONS(6292),
    [anon_sym_EQ] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_RPAREN] = ACTIONS(6292),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [anon_sym_RBRACE] = ACTIONS(6292),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6292),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6292),
    [anon_sym_DOLLAR] = ACTIONS(6290),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHleft] = ACTIONS(6290),
    [anon_sym_BSLASHbigl] = ACTIONS(6290),
    [anon_sym_BSLASHBigl] = ACTIONS(6290),
    [anon_sym_BSLASHbiggl] = ACTIONS(6290),
    [anon_sym_BSLASHBiggl] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHtext] = ACTIONS(6290),
    [anon_sym_BSLASHintertext] = ACTIONS(6290),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [1743] = {
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_LBRACK] = ACTIONS(6276),
    [anon_sym_RBRACK] = ACTIONS(6276),
    [anon_sym_COMMA] = ACTIONS(6276),
    [anon_sym_EQ] = ACTIONS(6276),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6276),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6276),
    [anon_sym_DOLLAR] = ACTIONS(6274),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHbegin] = ACTIONS(6274),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHleft] = ACTIONS(6274),
    [anon_sym_BSLASHbigl] = ACTIONS(6274),
    [anon_sym_BSLASHBigl] = ACTIONS(6274),
    [anon_sym_BSLASHbiggl] = ACTIONS(6274),
    [anon_sym_BSLASHBiggl] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHtext] = ACTIONS(6274),
    [anon_sym_BSLASHintertext] = ACTIONS(6274),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [1744] = {
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6312),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6312),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6312),
    [anon_sym_RBRACE] = ACTIONS(6312),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6312),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6312),
    [anon_sym_DOLLAR] = ACTIONS(6310),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHleft] = ACTIONS(6310),
    [anon_sym_BSLASHbigl] = ACTIONS(6310),
    [anon_sym_BSLASHBigl] = ACTIONS(6310),
    [anon_sym_BSLASHbiggl] = ACTIONS(6310),
    [anon_sym_BSLASHBiggl] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHtext] = ACTIONS(6310),
    [anon_sym_BSLASHintertext] = ACTIONS(6310),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [1745] = {
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_COMMA] = ACTIONS(6316),
    [anon_sym_EQ] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6316),
    [anon_sym_RPAREN] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6316),
    [anon_sym_RBRACE] = ACTIONS(6316),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6316),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6316),
    [anon_sym_DOLLAR] = ACTIONS(6314),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHleft] = ACTIONS(6314),
    [anon_sym_BSLASHbigl] = ACTIONS(6314),
    [anon_sym_BSLASHBigl] = ACTIONS(6314),
    [anon_sym_BSLASHbiggl] = ACTIONS(6314),
    [anon_sym_BSLASHBiggl] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHtext] = ACTIONS(6314),
    [anon_sym_BSLASHintertext] = ACTIONS(6314),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [1746] = {
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_RBRACK] = ACTIONS(6320),
    [anon_sym_COMMA] = ACTIONS(6320),
    [anon_sym_EQ] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(6320),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [anon_sym_RBRACE] = ACTIONS(6320),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6320),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6320),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHleft] = ACTIONS(6318),
    [anon_sym_BSLASHbigl] = ACTIONS(6318),
    [anon_sym_BSLASHBigl] = ACTIONS(6318),
    [anon_sym_BSLASHbiggl] = ACTIONS(6318),
    [anon_sym_BSLASHBiggl] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHtext] = ACTIONS(6318),
    [anon_sym_BSLASHintertext] = ACTIONS(6318),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [1747] = {
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [anon_sym_RBRACE] = ACTIONS(6324),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6324),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6324),
    [anon_sym_DOLLAR] = ACTIONS(6322),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHleft] = ACTIONS(6322),
    [anon_sym_BSLASHbigl] = ACTIONS(6322),
    [anon_sym_BSLASHBigl] = ACTIONS(6322),
    [anon_sym_BSLASHbiggl] = ACTIONS(6322),
    [anon_sym_BSLASHBiggl] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHtext] = ACTIONS(6322),
    [anon_sym_BSLASHintertext] = ACTIONS(6322),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [1748] = {
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6328),
    [anon_sym_RBRACK] = ACTIONS(6328),
    [anon_sym_COMMA] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6328),
    [anon_sym_RPAREN] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6328),
    [anon_sym_RBRACE] = ACTIONS(6328),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6328),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6328),
    [anon_sym_DOLLAR] = ACTIONS(6326),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHleft] = ACTIONS(6326),
    [anon_sym_BSLASHbigl] = ACTIONS(6326),
    [anon_sym_BSLASHBigl] = ACTIONS(6326),
    [anon_sym_BSLASHbiggl] = ACTIONS(6326),
    [anon_sym_BSLASHBiggl] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHtext] = ACTIONS(6326),
    [anon_sym_BSLASHintertext] = ACTIONS(6326),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [1749] = {
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6332),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_EQ] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6332),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [anon_sym_RBRACE] = ACTIONS(6332),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6332),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6330),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHleft] = ACTIONS(6330),
    [anon_sym_BSLASHbigl] = ACTIONS(6330),
    [anon_sym_BSLASHBigl] = ACTIONS(6330),
    [anon_sym_BSLASHbiggl] = ACTIONS(6330),
    [anon_sym_BSLASHBiggl] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHtext] = ACTIONS(6330),
    [anon_sym_BSLASHintertext] = ACTIONS(6330),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [1750] = {
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6336),
    [anon_sym_RBRACK] = ACTIONS(6336),
    [anon_sym_COMMA] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_RPAREN] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [anon_sym_RBRACE] = ACTIONS(6336),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6336),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHleft] = ACTIONS(6334),
    [anon_sym_BSLASHbigl] = ACTIONS(6334),
    [anon_sym_BSLASHBigl] = ACTIONS(6334),
    [anon_sym_BSLASHbiggl] = ACTIONS(6334),
    [anon_sym_BSLASHBiggl] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHtext] = ACTIONS(6334),
    [anon_sym_BSLASHintertext] = ACTIONS(6334),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [1751] = {
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_LBRACK] = ACTIONS(6424),
    [anon_sym_RBRACK] = ACTIONS(6424),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_EQ] = ACTIONS(6424),
    [anon_sym_LPAREN] = ACTIONS(6424),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_LBRACE] = ACTIONS(6424),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6424),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6424),
    [anon_sym_DOLLAR] = ACTIONS(6422),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHbegin] = ACTIONS(6422),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHleft] = ACTIONS(6422),
    [anon_sym_BSLASHbigl] = ACTIONS(6422),
    [anon_sym_BSLASHBigl] = ACTIONS(6422),
    [anon_sym_BSLASHbiggl] = ACTIONS(6422),
    [anon_sym_BSLASHBiggl] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHtext] = ACTIONS(6422),
    [anon_sym_BSLASHintertext] = ACTIONS(6422),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [1752] = {
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_RBRACK] = ACTIONS(6636),
    [anon_sym_COMMA] = ACTIONS(6636),
    [anon_sym_EQ] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(6636),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [anon_sym_RBRACE] = ACTIONS(6636),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6636),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(6634),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHleft] = ACTIONS(6634),
    [anon_sym_BSLASHbigl] = ACTIONS(6634),
    [anon_sym_BSLASHBigl] = ACTIONS(6634),
    [anon_sym_BSLASHbiggl] = ACTIONS(6634),
    [anon_sym_BSLASHBiggl] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHtext] = ACTIONS(6634),
    [anon_sym_BSLASHintertext] = ACTIONS(6634),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [1753] = {
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [anon_sym_RPAREN] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6348),
    [anon_sym_RBRACE] = ACTIONS(6348),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6348),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6348),
    [anon_sym_DOLLAR] = ACTIONS(6346),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHleft] = ACTIONS(6346),
    [anon_sym_BSLASHbigl] = ACTIONS(6346),
    [anon_sym_BSLASHBigl] = ACTIONS(6346),
    [anon_sym_BSLASHbiggl] = ACTIONS(6346),
    [anon_sym_BSLASHBiggl] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHtext] = ACTIONS(6346),
    [anon_sym_BSLASHintertext] = ACTIONS(6346),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [1754] = {
    [sym_command_name] = ACTIONS(6638),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6638),
    [anon_sym_LBRACK] = ACTIONS(6640),
    [anon_sym_RBRACK] = ACTIONS(6640),
    [anon_sym_COMMA] = ACTIONS(6640),
    [anon_sym_EQ] = ACTIONS(6640),
    [anon_sym_LPAREN] = ACTIONS(6640),
    [anon_sym_RPAREN] = ACTIONS(6640),
    [anon_sym_LBRACE] = ACTIONS(6640),
    [sym_word] = ACTIONS(6638),
    [sym_placeholder] = ACTIONS(6640),
    [anon_sym_PLUS] = ACTIONS(6640),
    [anon_sym_DASH] = ACTIONS(6640),
    [anon_sym_STAR] = ACTIONS(6640),
    [anon_sym_SLASH] = ACTIONS(6640),
    [anon_sym_LT] = ACTIONS(6638),
    [anon_sym_GT] = ACTIONS(6638),
    [anon_sym_BANG] = ACTIONS(6638),
    [anon_sym_PIPE] = ACTIONS(6638),
    [anon_sym_COLON] = ACTIONS(6638),
    [anon_sym_SQUOTE] = ACTIONS(6638),
    [anon_sym__] = ACTIONS(6640),
    [anon_sym_CARET] = ACTIONS(6640),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6640),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6640),
    [anon_sym_DOLLAR] = ACTIONS(6638),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6640),
    [anon_sym_BSLASHbegin] = ACTIONS(6638),
    [anon_sym_BSLASHtitle] = ACTIONS(6638),
    [anon_sym_BSLASHauthor] = ACTIONS(6638),
    [anon_sym_BSLASHusepackage] = ACTIONS(6638),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6638),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6638),
    [anon_sym_BSLASHinclude] = ACTIONS(6638),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6638),
    [anon_sym_BSLASHinput] = ACTIONS(6638),
    [anon_sym_BSLASHsubfile] = ACTIONS(6638),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6638),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6638),
    [anon_sym_BSLASHbibliography] = ACTIONS(6638),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6638),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6638),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6638),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6638),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6638),
    [anon_sym_BSLASHimport] = ACTIONS(6638),
    [anon_sym_BSLASHsubimport] = ACTIONS(6638),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6638),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6638),
    [anon_sym_BSLASHcaption] = ACTIONS(6638),
    [anon_sym_BSLASHcite] = ACTIONS(6638),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCite] = ACTIONS(6638),
    [anon_sym_BSLASHnocite] = ACTIONS(6638),
    [anon_sym_BSLASHcitet] = ACTIONS(6638),
    [anon_sym_BSLASHcitep] = ACTIONS(6638),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteA] = ACTIONS(6638),
    [anon_sym_BSLASHciteR] = ACTIONS(6638),
    [anon_sym_BSLASHciteS] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6638),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6638),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteyear] = ACTIONS(6638),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHcitedate] = ACTIONS(6638),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHciteurl] = ACTIONS(6638),
    [anon_sym_BSLASHfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6638),
    [anon_sym_BSLASHcitealt] = ACTIONS(6638),
    [anon_sym_BSLASHcitealp] = ACTIONS(6638),
    [anon_sym_BSLASHcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHparencite] = ACTIONS(6638),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHParencite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6638),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6638),
    [anon_sym_BSLASHtextcite] = ACTIONS(6638),
    [anon_sym_BSLASHTextcite] = ACTIONS(6638),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6638),
    [anon_sym_BSLASHsupercite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite] = ACTIONS(6638),
    [anon_sym_BSLASHAutocite] = ACTIONS(6638),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHVolcite] = ACTIONS(6638),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHavolcite] = ACTIONS(6638),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6638),
    [anon_sym_BSLASHnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHNotecite] = ACTIONS(6638),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6638),
    [anon_sym_BSLASHlabel] = ACTIONS(6638),
    [anon_sym_BSLASHref] = ACTIONS(6638),
    [anon_sym_BSLASHeqref] = ACTIONS(6638),
    [anon_sym_BSLASHvref] = ACTIONS(6638),
    [anon_sym_BSLASHVref] = ACTIONS(6638),
    [anon_sym_BSLASHautoref] = ACTIONS(6638),
    [anon_sym_BSLASHpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcref] = ACTIONS(6638),
    [anon_sym_BSLASHCref] = ACTIONS(6638),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnameCref] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6638),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6638),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6638),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6638),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6638),
    [anon_sym_BSLASHdef] = ACTIONS(6638),
    [anon_sym_BSLASHlet] = ACTIONS(6638),
    [anon_sym_BSLASHleft] = ACTIONS(6638),
    [anon_sym_BSLASHbigl] = ACTIONS(6638),
    [anon_sym_BSLASHBigl] = ACTIONS(6638),
    [anon_sym_BSLASHbiggl] = ACTIONS(6638),
    [anon_sym_BSLASHBiggl] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6638),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6638),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6638),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6638),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6638),
    [anon_sym_BSLASHgls] = ACTIONS(6638),
    [anon_sym_BSLASHGls] = ACTIONS(6638),
    [anon_sym_BSLASHGLS] = ACTIONS(6638),
    [anon_sym_BSLASHglspl] = ACTIONS(6638),
    [anon_sym_BSLASHGlspl] = ACTIONS(6638),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6638),
    [anon_sym_BSLASHglslink] = ACTIONS(6638),
    [anon_sym_BSLASHglstext] = ACTIONS(6638),
    [anon_sym_BSLASHGlstext] = ACTIONS(6638),
    [anon_sym_BSLASHGLStext] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6638),
    [anon_sym_BSLASHglsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6638),
    [anon_sym_BSLASHglsname] = ACTIONS(6638),
    [anon_sym_BSLASHGlsname] = ACTIONS(6638),
    [anon_sym_BSLASHGLSname] = ACTIONS(6638),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6638),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6638),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6638),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6638),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6638),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6638),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6638),
    [anon_sym_BSLASHacrshort] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6638),
    [anon_sym_BSLASHACRshort] = ACTIONS(6638),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrlong] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6638),
    [anon_sym_BSLASHACRlong] = ACTIONS(6638),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6638),
    [anon_sym_BSLASHacrfull] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6638),
    [anon_sym_BSLASHACRfull] = ACTIONS(6638),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHacs] = ACTIONS(6638),
    [anon_sym_BSLASHAcs] = ACTIONS(6638),
    [anon_sym_BSLASHacsp] = ACTIONS(6638),
    [anon_sym_BSLASHAcsp] = ACTIONS(6638),
    [anon_sym_BSLASHacl] = ACTIONS(6638),
    [anon_sym_BSLASHAcl] = ACTIONS(6638),
    [anon_sym_BSLASHaclp] = ACTIONS(6638),
    [anon_sym_BSLASHAclp] = ACTIONS(6638),
    [anon_sym_BSLASHacf] = ACTIONS(6638),
    [anon_sym_BSLASHAcf] = ACTIONS(6638),
    [anon_sym_BSLASHacfp] = ACTIONS(6638),
    [anon_sym_BSLASHAcfp] = ACTIONS(6638),
    [anon_sym_BSLASHac] = ACTIONS(6638),
    [anon_sym_BSLASHAc] = ACTIONS(6638),
    [anon_sym_BSLASHacp] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6638),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6638),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6638),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6638),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6640),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6638),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6638),
    [anon_sym_BSLASHcolor] = ACTIONS(6638),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6638),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6638),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6638),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6638),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6638),
    [anon_sym_BSLASHtext] = ACTIONS(6638),
    [anon_sym_BSLASHintertext] = ACTIONS(6638),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6638),
    [anon_sym_BSLASHurl] = ACTIONS(6638),
    [anon_sym_BSLASHhref] = ACTIONS(6638),
  },
  [1755] = {
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_RBRACK] = ACTIONS(6356),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_EQ] = ACTIONS(6356),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_RPAREN] = ACTIONS(6356),
    [anon_sym_LBRACE] = ACTIONS(6356),
    [anon_sym_RBRACE] = ACTIONS(6356),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6356),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6356),
    [anon_sym_DOLLAR] = ACTIONS(6354),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHleft] = ACTIONS(6354),
    [anon_sym_BSLASHbigl] = ACTIONS(6354),
    [anon_sym_BSLASHBigl] = ACTIONS(6354),
    [anon_sym_BSLASHbiggl] = ACTIONS(6354),
    [anon_sym_BSLASHBiggl] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHtext] = ACTIONS(6354),
    [anon_sym_BSLASHintertext] = ACTIONS(6354),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [1756] = {
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_RBRACK] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6420),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(6418),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHbegin] = ACTIONS(6418),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHleft] = ACTIONS(6418),
    [anon_sym_BSLASHbigl] = ACTIONS(6418),
    [anon_sym_BSLASHBigl] = ACTIONS(6418),
    [anon_sym_BSLASHbiggl] = ACTIONS(6418),
    [anon_sym_BSLASHBiggl] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHtext] = ACTIONS(6418),
    [anon_sym_BSLASHintertext] = ACTIONS(6418),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [1757] = {
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LPAREN] = ACTIONS(6364),
    [anon_sym_RPAREN] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [anon_sym_RBRACE] = ACTIONS(6364),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6364),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6364),
    [anon_sym_DOLLAR] = ACTIONS(6362),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHleft] = ACTIONS(6362),
    [anon_sym_BSLASHbigl] = ACTIONS(6362),
    [anon_sym_BSLASHBigl] = ACTIONS(6362),
    [anon_sym_BSLASHbiggl] = ACTIONS(6362),
    [anon_sym_BSLASHBiggl] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHtext] = ACTIONS(6362),
    [anon_sym_BSLASHintertext] = ACTIONS(6362),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [1758] = {
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_LBRACK] = ACTIONS(6496),
    [anon_sym_RBRACK] = ACTIONS(6496),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6496),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_RPAREN] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6496),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6496),
    [anon_sym_DOLLAR] = ACTIONS(6494),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHbegin] = ACTIONS(6494),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHleft] = ACTIONS(6494),
    [anon_sym_BSLASHbigl] = ACTIONS(6494),
    [anon_sym_BSLASHBigl] = ACTIONS(6494),
    [anon_sym_BSLASHbiggl] = ACTIONS(6494),
    [anon_sym_BSLASHBiggl] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHtext] = ACTIONS(6494),
    [anon_sym_BSLASHintertext] = ACTIONS(6494),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [1759] = {
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6416),
    [anon_sym_EQ] = ACTIONS(6416),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_RPAREN] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6416),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(6414),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHbegin] = ACTIONS(6414),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHleft] = ACTIONS(6414),
    [anon_sym_BSLASHbigl] = ACTIONS(6414),
    [anon_sym_BSLASHBigl] = ACTIONS(6414),
    [anon_sym_BSLASHbiggl] = ACTIONS(6414),
    [anon_sym_BSLASHBiggl] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHtext] = ACTIONS(6414),
    [anon_sym_BSLASHintertext] = ACTIONS(6414),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [1760] = {
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_LBRACK] = ACTIONS(6500),
    [anon_sym_RBRACK] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [anon_sym_EQ] = ACTIONS(6500),
    [anon_sym_LPAREN] = ACTIONS(6500),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_LBRACE] = ACTIONS(6500),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6500),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6500),
    [anon_sym_DOLLAR] = ACTIONS(6498),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHbegin] = ACTIONS(6498),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHleft] = ACTIONS(6498),
    [anon_sym_BSLASHbigl] = ACTIONS(6498),
    [anon_sym_BSLASHBigl] = ACTIONS(6498),
    [anon_sym_BSLASHbiggl] = ACTIONS(6498),
    [anon_sym_BSLASHBiggl] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHtext] = ACTIONS(6498),
    [anon_sym_BSLASHintertext] = ACTIONS(6498),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [1761] = {
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_LBRACK] = ACTIONS(6376),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_EQ] = ACTIONS(6376),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [anon_sym_RBRACE] = ACTIONS(6376),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6376),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6376),
    [anon_sym_DOLLAR] = ACTIONS(6374),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHleft] = ACTIONS(6374),
    [anon_sym_BSLASHbigl] = ACTIONS(6374),
    [anon_sym_BSLASHBigl] = ACTIONS(6374),
    [anon_sym_BSLASHbiggl] = ACTIONS(6374),
    [anon_sym_BSLASHBiggl] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHtext] = ACTIONS(6374),
    [anon_sym_BSLASHintertext] = ACTIONS(6374),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [1762] = {
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_LBRACK] = ACTIONS(6380),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_EQ] = ACTIONS(6380),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [anon_sym_RBRACE] = ACTIONS(6380),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6380),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6380),
    [anon_sym_DOLLAR] = ACTIONS(6378),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHleft] = ACTIONS(6378),
    [anon_sym_BSLASHbigl] = ACTIONS(6378),
    [anon_sym_BSLASHBigl] = ACTIONS(6378),
    [anon_sym_BSLASHbiggl] = ACTIONS(6378),
    [anon_sym_BSLASHBiggl] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHtext] = ACTIONS(6378),
    [anon_sym_BSLASHintertext] = ACTIONS(6378),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [1763] = {
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6588),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6588),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHbegin] = ACTIONS(6586),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHleft] = ACTIONS(6586),
    [anon_sym_BSLASHbigl] = ACTIONS(6586),
    [anon_sym_BSLASHBigl] = ACTIONS(6586),
    [anon_sym_BSLASHbiggl] = ACTIONS(6586),
    [anon_sym_BSLASHBiggl] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHtext] = ACTIONS(6586),
    [anon_sym_BSLASHintertext] = ACTIONS(6586),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [1764] = {
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_LBRACK] = ACTIONS(6384),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_EQ] = ACTIONS(6384),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_RPAREN] = ACTIONS(6384),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [anon_sym_RBRACE] = ACTIONS(6384),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6384),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(6382),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHleft] = ACTIONS(6382),
    [anon_sym_BSLASHbigl] = ACTIONS(6382),
    [anon_sym_BSLASHBigl] = ACTIONS(6382),
    [anon_sym_BSLASHbiggl] = ACTIONS(6382),
    [anon_sym_BSLASHBiggl] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHtext] = ACTIONS(6382),
    [anon_sym_BSLASHintertext] = ACTIONS(6382),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [1765] = {
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_COMMA] = ACTIONS(6388),
    [anon_sym_EQ] = ACTIONS(6388),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [anon_sym_RBRACE] = ACTIONS(6388),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6388),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(6386),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHleft] = ACTIONS(6386),
    [anon_sym_BSLASHbigl] = ACTIONS(6386),
    [anon_sym_BSLASHBigl] = ACTIONS(6386),
    [anon_sym_BSLASHbiggl] = ACTIONS(6386),
    [anon_sym_BSLASHBiggl] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHtext] = ACTIONS(6386),
    [anon_sym_BSLASHintertext] = ACTIONS(6386),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [1766] = {
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_LBRACK] = ACTIONS(6512),
    [anon_sym_RBRACK] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6512),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6512),
    [anon_sym_DOLLAR] = ACTIONS(6510),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHbegin] = ACTIONS(6510),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHleft] = ACTIONS(6510),
    [anon_sym_BSLASHbigl] = ACTIONS(6510),
    [anon_sym_BSLASHBigl] = ACTIONS(6510),
    [anon_sym_BSLASHbiggl] = ACTIONS(6510),
    [anon_sym_BSLASHBiggl] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHtext] = ACTIONS(6510),
    [anon_sym_BSLASHintertext] = ACTIONS(6510),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [1767] = {
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_LBRACK] = ACTIONS(6516),
    [anon_sym_RBRACK] = ACTIONS(6516),
    [anon_sym_COMMA] = ACTIONS(6516),
    [anon_sym_EQ] = ACTIONS(6516),
    [anon_sym_LPAREN] = ACTIONS(6516),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_LBRACE] = ACTIONS(6516),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6516),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(6514),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHbegin] = ACTIONS(6514),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHleft] = ACTIONS(6514),
    [anon_sym_BSLASHbigl] = ACTIONS(6514),
    [anon_sym_BSLASHBigl] = ACTIONS(6514),
    [anon_sym_BSLASHbiggl] = ACTIONS(6514),
    [anon_sym_BSLASHBiggl] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHtext] = ACTIONS(6514),
    [anon_sym_BSLASHintertext] = ACTIONS(6514),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [1768] = {
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_COMMA] = ACTIONS(6392),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [anon_sym_RBRACE] = ACTIONS(6392),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6392),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(6390),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHleft] = ACTIONS(6390),
    [anon_sym_BSLASHbigl] = ACTIONS(6390),
    [anon_sym_BSLASHBigl] = ACTIONS(6390),
    [anon_sym_BSLASHbiggl] = ACTIONS(6390),
    [anon_sym_BSLASHBiggl] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHtext] = ACTIONS(6390),
    [anon_sym_BSLASHintertext] = ACTIONS(6390),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [1769] = {
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_LBRACK] = ACTIONS(6520),
    [anon_sym_RBRACK] = ACTIONS(6520),
    [anon_sym_COMMA] = ACTIONS(6520),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_LPAREN] = ACTIONS(6520),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_LBRACE] = ACTIONS(6520),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6520),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6520),
    [anon_sym_DOLLAR] = ACTIONS(6518),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHbegin] = ACTIONS(6518),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHleft] = ACTIONS(6518),
    [anon_sym_BSLASHbigl] = ACTIONS(6518),
    [anon_sym_BSLASHBigl] = ACTIONS(6518),
    [anon_sym_BSLASHbiggl] = ACTIONS(6518),
    [anon_sym_BSLASHBiggl] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHtext] = ACTIONS(6518),
    [anon_sym_BSLASHintertext] = ACTIONS(6518),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [1770] = {
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6396),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6396),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_RBRACE] = ACTIONS(6396),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6396),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6396),
    [anon_sym_DOLLAR] = ACTIONS(6394),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHleft] = ACTIONS(6394),
    [anon_sym_BSLASHbigl] = ACTIONS(6394),
    [anon_sym_BSLASHBigl] = ACTIONS(6394),
    [anon_sym_BSLASHbiggl] = ACTIONS(6394),
    [anon_sym_BSLASHBiggl] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHtext] = ACTIONS(6394),
    [anon_sym_BSLASHintertext] = ACTIONS(6394),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [1771] = {
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6412),
    [anon_sym_RBRACK] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6412),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6412),
    [anon_sym_DOLLAR] = ACTIONS(6410),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHbegin] = ACTIONS(6410),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHleft] = ACTIONS(6410),
    [anon_sym_BSLASHbigl] = ACTIONS(6410),
    [anon_sym_BSLASHBigl] = ACTIONS(6410),
    [anon_sym_BSLASHbiggl] = ACTIONS(6410),
    [anon_sym_BSLASHBiggl] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHtext] = ACTIONS(6410),
    [anon_sym_BSLASHintertext] = ACTIONS(6410),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [1772] = {
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6400),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [anon_sym_RBRACE] = ACTIONS(6400),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6400),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHleft] = ACTIONS(6398),
    [anon_sym_BSLASHbigl] = ACTIONS(6398),
    [anon_sym_BSLASHBigl] = ACTIONS(6398),
    [anon_sym_BSLASHbiggl] = ACTIONS(6398),
    [anon_sym_BSLASHBiggl] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHtext] = ACTIONS(6398),
    [anon_sym_BSLASHintertext] = ACTIONS(6398),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [1773] = {
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6404),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6404),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [anon_sym_RBRACE] = ACTIONS(6404),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6404),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6404),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHleft] = ACTIONS(6402),
    [anon_sym_BSLASHbigl] = ACTIONS(6402),
    [anon_sym_BSLASHBigl] = ACTIONS(6402),
    [anon_sym_BSLASHbiggl] = ACTIONS(6402),
    [anon_sym_BSLASHBiggl] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHtext] = ACTIONS(6402),
    [anon_sym_BSLASHintertext] = ACTIONS(6402),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [1774] = {
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [anon_sym_RBRACE] = ACTIONS(6408),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6408),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6408),
    [anon_sym_DOLLAR] = ACTIONS(6406),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHleft] = ACTIONS(6406),
    [anon_sym_BSLASHbigl] = ACTIONS(6406),
    [anon_sym_BSLASHBigl] = ACTIONS(6406),
    [anon_sym_BSLASHbiggl] = ACTIONS(6406),
    [anon_sym_BSLASHBiggl] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHtext] = ACTIONS(6406),
    [anon_sym_BSLASHintertext] = ACTIONS(6406),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [1775] = {
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_LBRACK] = ACTIONS(6412),
    [anon_sym_RBRACK] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6412),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [anon_sym_RBRACE] = ACTIONS(6412),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6412),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6412),
    [anon_sym_DOLLAR] = ACTIONS(6410),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHleft] = ACTIONS(6410),
    [anon_sym_BSLASHbigl] = ACTIONS(6410),
    [anon_sym_BSLASHBigl] = ACTIONS(6410),
    [anon_sym_BSLASHbiggl] = ACTIONS(6410),
    [anon_sym_BSLASHBiggl] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHtext] = ACTIONS(6410),
    [anon_sym_BSLASHintertext] = ACTIONS(6410),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [1776] = {
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_LBRACK] = ACTIONS(6416),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6416),
    [anon_sym_EQ] = ACTIONS(6416),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_RPAREN] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [anon_sym_RBRACE] = ACTIONS(6416),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6416),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(6414),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHleft] = ACTIONS(6414),
    [anon_sym_BSLASHbigl] = ACTIONS(6414),
    [anon_sym_BSLASHBigl] = ACTIONS(6414),
    [anon_sym_BSLASHbiggl] = ACTIONS(6414),
    [anon_sym_BSLASHBiggl] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHtext] = ACTIONS(6414),
    [anon_sym_BSLASHintertext] = ACTIONS(6414),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [1777] = {
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_LBRACK] = ACTIONS(6420),
    [anon_sym_RBRACK] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [anon_sym_RBRACE] = ACTIONS(6420),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6420),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(6418),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHleft] = ACTIONS(6418),
    [anon_sym_BSLASHbigl] = ACTIONS(6418),
    [anon_sym_BSLASHBigl] = ACTIONS(6418),
    [anon_sym_BSLASHbiggl] = ACTIONS(6418),
    [anon_sym_BSLASHBiggl] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHtext] = ACTIONS(6418),
    [anon_sym_BSLASHintertext] = ACTIONS(6418),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [1778] = {
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_LBRACK] = ACTIONS(6424),
    [anon_sym_RBRACK] = ACTIONS(6424),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_EQ] = ACTIONS(6424),
    [anon_sym_LPAREN] = ACTIONS(6424),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_LBRACE] = ACTIONS(6424),
    [anon_sym_RBRACE] = ACTIONS(6424),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6424),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6424),
    [anon_sym_DOLLAR] = ACTIONS(6422),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHleft] = ACTIONS(6422),
    [anon_sym_BSLASHbigl] = ACTIONS(6422),
    [anon_sym_BSLASHBigl] = ACTIONS(6422),
    [anon_sym_BSLASHbiggl] = ACTIONS(6422),
    [anon_sym_BSLASHBiggl] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHtext] = ACTIONS(6422),
    [anon_sym_BSLASHintertext] = ACTIONS(6422),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [1779] = {
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_RBRACK] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6428),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_RPAREN] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [anon_sym_RBRACE] = ACTIONS(6428),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6428),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6428),
    [anon_sym_DOLLAR] = ACTIONS(6426),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHleft] = ACTIONS(6426),
    [anon_sym_BSLASHbigl] = ACTIONS(6426),
    [anon_sym_BSLASHBigl] = ACTIONS(6426),
    [anon_sym_BSLASHbiggl] = ACTIONS(6426),
    [anon_sym_BSLASHBiggl] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHtext] = ACTIONS(6426),
    [anon_sym_BSLASHintertext] = ACTIONS(6426),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [1780] = {
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [anon_sym_RBRACE] = ACTIONS(6432),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6432),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6432),
    [anon_sym_DOLLAR] = ACTIONS(6430),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHleft] = ACTIONS(6430),
    [anon_sym_BSLASHbigl] = ACTIONS(6430),
    [anon_sym_BSLASHBigl] = ACTIONS(6430),
    [anon_sym_BSLASHbiggl] = ACTIONS(6430),
    [anon_sym_BSLASHBiggl] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHtext] = ACTIONS(6430),
    [anon_sym_BSLASHintertext] = ACTIONS(6430),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [1781] = {
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6436),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_EQ] = ACTIONS(6436),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [anon_sym_RBRACE] = ACTIONS(6436),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6436),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6436),
    [anon_sym_DOLLAR] = ACTIONS(6434),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHleft] = ACTIONS(6434),
    [anon_sym_BSLASHbigl] = ACTIONS(6434),
    [anon_sym_BSLASHBigl] = ACTIONS(6434),
    [anon_sym_BSLASHbiggl] = ACTIONS(6434),
    [anon_sym_BSLASHBiggl] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHtext] = ACTIONS(6434),
    [anon_sym_BSLASHintertext] = ACTIONS(6434),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [1782] = {
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_LBRACK] = ACTIONS(6440),
    [anon_sym_RBRACK] = ACTIONS(6440),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6440),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_RPAREN] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [anon_sym_RBRACE] = ACTIONS(6440),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6440),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6440),
    [anon_sym_DOLLAR] = ACTIONS(6438),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHleft] = ACTIONS(6438),
    [anon_sym_BSLASHbigl] = ACTIONS(6438),
    [anon_sym_BSLASHBigl] = ACTIONS(6438),
    [anon_sym_BSLASHbiggl] = ACTIONS(6438),
    [anon_sym_BSLASHBiggl] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHtext] = ACTIONS(6438),
    [anon_sym_BSLASHintertext] = ACTIONS(6438),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [1783] = {
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_LBRACK] = ACTIONS(6444),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6444),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [anon_sym_RBRACE] = ACTIONS(6444),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6444),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6444),
    [anon_sym_DOLLAR] = ACTIONS(6442),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHleft] = ACTIONS(6442),
    [anon_sym_BSLASHbigl] = ACTIONS(6442),
    [anon_sym_BSLASHBigl] = ACTIONS(6442),
    [anon_sym_BSLASHbiggl] = ACTIONS(6442),
    [anon_sym_BSLASHBiggl] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHtext] = ACTIONS(6442),
    [anon_sym_BSLASHintertext] = ACTIONS(6442),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [1784] = {
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_LBRACK] = ACTIONS(6448),
    [anon_sym_RBRACK] = ACTIONS(6448),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(6448),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [anon_sym_RBRACE] = ACTIONS(6448),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6448),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6448),
    [anon_sym_DOLLAR] = ACTIONS(6446),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHleft] = ACTIONS(6446),
    [anon_sym_BSLASHbigl] = ACTIONS(6446),
    [anon_sym_BSLASHBigl] = ACTIONS(6446),
    [anon_sym_BSLASHbiggl] = ACTIONS(6446),
    [anon_sym_BSLASHBiggl] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHtext] = ACTIONS(6446),
    [anon_sym_BSLASHintertext] = ACTIONS(6446),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [1785] = {
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_LBRACK] = ACTIONS(6574),
    [anon_sym_RBRACK] = ACTIONS(6574),
    [anon_sym_COMMA] = ACTIONS(6574),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_RPAREN] = ACTIONS(6574),
    [anon_sym_LBRACE] = ACTIONS(6574),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6574),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6574),
    [anon_sym_DOLLAR] = ACTIONS(6572),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHbegin] = ACTIONS(6572),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHleft] = ACTIONS(6572),
    [anon_sym_BSLASHbigl] = ACTIONS(6572),
    [anon_sym_BSLASHBigl] = ACTIONS(6572),
    [anon_sym_BSLASHbiggl] = ACTIONS(6572),
    [anon_sym_BSLASHBiggl] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHtext] = ACTIONS(6572),
    [anon_sym_BSLASHintertext] = ACTIONS(6572),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [1786] = {
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_LBRACK] = ACTIONS(6456),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6456),
    [anon_sym_LPAREN] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [anon_sym_RBRACE] = ACTIONS(6456),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6456),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(6454),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHleft] = ACTIONS(6454),
    [anon_sym_BSLASHbigl] = ACTIONS(6454),
    [anon_sym_BSLASHBigl] = ACTIONS(6454),
    [anon_sym_BSLASHbiggl] = ACTIONS(6454),
    [anon_sym_BSLASHBiggl] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHtext] = ACTIONS(6454),
    [anon_sym_BSLASHintertext] = ACTIONS(6454),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [1787] = {
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_LBRACK] = ACTIONS(6524),
    [anon_sym_RBRACK] = ACTIONS(6524),
    [anon_sym_COMMA] = ACTIONS(6524),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_LPAREN] = ACTIONS(6524),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6524),
    [anon_sym_RBRACE] = ACTIONS(6524),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6524),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6524),
    [anon_sym_DOLLAR] = ACTIONS(6522),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHleft] = ACTIONS(6522),
    [anon_sym_BSLASHbigl] = ACTIONS(6522),
    [anon_sym_BSLASHBigl] = ACTIONS(6522),
    [anon_sym_BSLASHbiggl] = ACTIONS(6522),
    [anon_sym_BSLASHBiggl] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHtext] = ACTIONS(6522),
    [anon_sym_BSLASHintertext] = ACTIONS(6522),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [1788] = {
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_LBRACK] = ACTIONS(6528),
    [anon_sym_RBRACK] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6528),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [anon_sym_RPAREN] = ACTIONS(6528),
    [anon_sym_LBRACE] = ACTIONS(6528),
    [anon_sym_RBRACE] = ACTIONS(6528),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6528),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(6526),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHleft] = ACTIONS(6526),
    [anon_sym_BSLASHbigl] = ACTIONS(6526),
    [anon_sym_BSLASHBigl] = ACTIONS(6526),
    [anon_sym_BSLASHbiggl] = ACTIONS(6526),
    [anon_sym_BSLASHBiggl] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHtext] = ACTIONS(6526),
    [anon_sym_BSLASHintertext] = ACTIONS(6526),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [1789] = {
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_RBRACK] = ACTIONS(6656),
    [anon_sym_COMMA] = ACTIONS(6656),
    [anon_sym_EQ] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(6656),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [anon_sym_RBRACE] = ACTIONS(6656),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6656),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6656),
    [anon_sym_DOLLAR] = ACTIONS(6654),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHleft] = ACTIONS(6654),
    [anon_sym_BSLASHbigl] = ACTIONS(6654),
    [anon_sym_BSLASHBigl] = ACTIONS(6654),
    [anon_sym_BSLASHbiggl] = ACTIONS(6654),
    [anon_sym_BSLASHBiggl] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHtext] = ACTIONS(6654),
    [anon_sym_BSLASHintertext] = ACTIONS(6654),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [1790] = {
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_LBRACK] = ACTIONS(6560),
    [anon_sym_RBRACK] = ACTIONS(6560),
    [anon_sym_COMMA] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6560),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_LBRACE] = ACTIONS(6560),
    [anon_sym_RBRACE] = ACTIONS(6560),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6560),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(6558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHleft] = ACTIONS(6558),
    [anon_sym_BSLASHbigl] = ACTIONS(6558),
    [anon_sym_BSLASHBigl] = ACTIONS(6558),
    [anon_sym_BSLASHbiggl] = ACTIONS(6558),
    [anon_sym_BSLASHBiggl] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHtext] = ACTIONS(6558),
    [anon_sym_BSLASHintertext] = ACTIONS(6558),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [1791] = {
    [sym_curly_group] = STATE(1870),
    [sym_brack_group_text] = STATE(2884),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_LPAREN] = ACTIONS(6129),
    [anon_sym_RPAREN] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(6129),
    [anon_sym_BSLASHand] = ACTIONS(6127),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6129),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6129),
    [anon_sym_DOLLAR] = ACTIONS(6127),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6129),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHleft] = ACTIONS(6127),
    [anon_sym_BSLASHbigl] = ACTIONS(6127),
    [anon_sym_BSLASHBigl] = ACTIONS(6127),
    [anon_sym_BSLASHbiggl] = ACTIONS(6127),
    [anon_sym_BSLASHBiggl] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHtext] = ACTIONS(6127),
    [anon_sym_BSLASHintertext] = ACTIONS(6127),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [1792] = {
    [sym_command_name] = ACTIONS(6170),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6172),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6172),
    [anon_sym_LPAREN] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [sym_word] = ACTIONS(6170),
    [sym_placeholder] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_BANG] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_SQUOTE] = ACTIONS(6170),
    [anon_sym__] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6172),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6172),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHbegin] = ACTIONS(6170),
    [anon_sym_BSLASHtitle] = ACTIONS(6170),
    [anon_sym_BSLASHauthor] = ACTIONS(6170),
    [anon_sym_BSLASHusepackage] = ACTIONS(6170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6170),
    [anon_sym_BSLASHinclude] = ACTIONS(6170),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6170),
    [anon_sym_BSLASHinput] = ACTIONS(6170),
    [anon_sym_BSLASHsubfile] = ACTIONS(6170),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6170),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6170),
    [anon_sym_BSLASHbibliography] = ACTIONS(6170),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6170),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6170),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6170),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6170),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6170),
    [anon_sym_BSLASHimport] = ACTIONS(6170),
    [anon_sym_BSLASHsubimport] = ACTIONS(6170),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6170),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHcaption] = ACTIONS(6170),
    [anon_sym_BSLASHcite] = ACTIONS(6170),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCite] = ACTIONS(6170),
    [anon_sym_BSLASHnocite] = ACTIONS(6170),
    [anon_sym_BSLASHcitet] = ACTIONS(6170),
    [anon_sym_BSLASHcitep] = ACTIONS(6170),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteA] = ACTIONS(6170),
    [anon_sym_BSLASHciteR] = ACTIONS(6170),
    [anon_sym_BSLASHciteS] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6170),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteyear] = ACTIONS(6170),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitedate] = ACTIONS(6170),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteurl] = ACTIONS(6170),
    [anon_sym_BSLASHfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6170),
    [anon_sym_BSLASHcitealt] = ACTIONS(6170),
    [anon_sym_BSLASHcitealp] = ACTIONS(6170),
    [anon_sym_BSLASHcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHparencite] = ACTIONS(6170),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHParencite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHtextcite] = ACTIONS(6170),
    [anon_sym_BSLASHTextcite] = ACTIONS(6170),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHsupercite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite] = ACTIONS(6170),
    [anon_sym_BSLASHAutocite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHVolcite] = ACTIONS(6170),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHavolcite] = ACTIONS(6170),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHNotecite] = ACTIONS(6170),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHlabel] = ACTIONS(6170),
    [anon_sym_BSLASHref] = ACTIONS(6170),
    [anon_sym_BSLASHeqref] = ACTIONS(6170),
    [anon_sym_BSLASHvref] = ACTIONS(6170),
    [anon_sym_BSLASHVref] = ACTIONS(6170),
    [anon_sym_BSLASHautoref] = ACTIONS(6170),
    [anon_sym_BSLASHpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcref] = ACTIONS(6170),
    [anon_sym_BSLASHCref] = ACTIONS(6170),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnameCref] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHdef] = ACTIONS(6170),
    [anon_sym_BSLASHlet] = ACTIONS(6170),
    [anon_sym_BSLASHleft] = ACTIONS(6170),
    [anon_sym_BSLASHbigl] = ACTIONS(6170),
    [anon_sym_BSLASHBigl] = ACTIONS(6170),
    [anon_sym_BSLASHbiggl] = ACTIONS(6170),
    [anon_sym_BSLASHBiggl] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6170),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6170),
    [anon_sym_BSLASHgls] = ACTIONS(6170),
    [anon_sym_BSLASHGls] = ACTIONS(6170),
    [anon_sym_BSLASHGLS] = ACTIONS(6170),
    [anon_sym_BSLASHglspl] = ACTIONS(6170),
    [anon_sym_BSLASHGlspl] = ACTIONS(6170),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6170),
    [anon_sym_BSLASHglslink] = ACTIONS(6170),
    [anon_sym_BSLASHglstext] = ACTIONS(6170),
    [anon_sym_BSLASHGlstext] = ACTIONS(6170),
    [anon_sym_BSLASHGLStext] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6170),
    [anon_sym_BSLASHglsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsname] = ACTIONS(6170),
    [anon_sym_BSLASHGlsname] = ACTIONS(6170),
    [anon_sym_BSLASHGLSname] = ACTIONS(6170),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6170),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6170),
    [anon_sym_BSLASHacrshort] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6170),
    [anon_sym_BSLASHACRshort] = ACTIONS(6170),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrlong] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6170),
    [anon_sym_BSLASHACRlong] = ACTIONS(6170),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrfull] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6170),
    [anon_sym_BSLASHACRfull] = ACTIONS(6170),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHacs] = ACTIONS(6170),
    [anon_sym_BSLASHAcs] = ACTIONS(6170),
    [anon_sym_BSLASHacsp] = ACTIONS(6170),
    [anon_sym_BSLASHAcsp] = ACTIONS(6170),
    [anon_sym_BSLASHacl] = ACTIONS(6170),
    [anon_sym_BSLASHAcl] = ACTIONS(6170),
    [anon_sym_BSLASHaclp] = ACTIONS(6170),
    [anon_sym_BSLASHAclp] = ACTIONS(6170),
    [anon_sym_BSLASHacf] = ACTIONS(6170),
    [anon_sym_BSLASHAcf] = ACTIONS(6170),
    [anon_sym_BSLASHacfp] = ACTIONS(6170),
    [anon_sym_BSLASHAcfp] = ACTIONS(6170),
    [anon_sym_BSLASHac] = ACTIONS(6170),
    [anon_sym_BSLASHAc] = ACTIONS(6170),
    [anon_sym_BSLASHacp] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6170),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6170),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6170),
    [anon_sym_BSLASHcolor] = ACTIONS(6170),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6170),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6170),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6170),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6170),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6170),
    [anon_sym_BSLASHtext] = ACTIONS(6170),
    [anon_sym_BSLASHintertext] = ACTIONS(6170),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6170),
    [anon_sym_BSLASHurl] = ACTIONS(6170),
    [anon_sym_BSLASHhref] = ACTIONS(6170),
  },
  [1793] = {
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6556),
    [anon_sym_RBRACK] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LPAREN] = ACTIONS(6556),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_LBRACE] = ACTIONS(6556),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6556),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6556),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHbegin] = ACTIONS(6554),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHleft] = ACTIONS(6554),
    [anon_sym_BSLASHbigl] = ACTIONS(6554),
    [anon_sym_BSLASHBigl] = ACTIONS(6554),
    [anon_sym_BSLASHbiggl] = ACTIONS(6554),
    [anon_sym_BSLASHBiggl] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHtext] = ACTIONS(6554),
    [anon_sym_BSLASHintertext] = ACTIONS(6554),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [1794] = {
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_LBRACK] = ACTIONS(6552),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6552),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6552),
    [anon_sym_DOLLAR] = ACTIONS(6550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHbegin] = ACTIONS(6550),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHleft] = ACTIONS(6550),
    [anon_sym_BSLASHbigl] = ACTIONS(6550),
    [anon_sym_BSLASHBigl] = ACTIONS(6550),
    [anon_sym_BSLASHbiggl] = ACTIONS(6550),
    [anon_sym_BSLASHBiggl] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHtext] = ACTIONS(6550),
    [anon_sym_BSLASHintertext] = ACTIONS(6550),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [1795] = {
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_LBRACK] = ACTIONS(6578),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6578),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_LPAREN] = ACTIONS(6578),
    [anon_sym_RPAREN] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_RBRACE] = ACTIONS(6578),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6578),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHleft] = ACTIONS(6576),
    [anon_sym_BSLASHbigl] = ACTIONS(6576),
    [anon_sym_BSLASHBigl] = ACTIONS(6576),
    [anon_sym_BSLASHbiggl] = ACTIONS(6576),
    [anon_sym_BSLASHBiggl] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHtext] = ACTIONS(6576),
    [anon_sym_BSLASHintertext] = ACTIONS(6576),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [1796] = {
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_LBRACK] = ACTIONS(6472),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_EQ] = ACTIONS(6472),
    [anon_sym_LPAREN] = ACTIONS(6472),
    [anon_sym_RPAREN] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6472),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6472),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHbegin] = ACTIONS(6470),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHleft] = ACTIONS(6470),
    [anon_sym_BSLASHbigl] = ACTIONS(6470),
    [anon_sym_BSLASHBigl] = ACTIONS(6470),
    [anon_sym_BSLASHbiggl] = ACTIONS(6470),
    [anon_sym_BSLASHBiggl] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHtext] = ACTIONS(6470),
    [anon_sym_BSLASHintertext] = ACTIONS(6470),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [1797] = {
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_LBRACK] = ACTIONS(6588),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6588),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6588),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHleft] = ACTIONS(6586),
    [anon_sym_BSLASHbigl] = ACTIONS(6586),
    [anon_sym_BSLASHBigl] = ACTIONS(6586),
    [anon_sym_BSLASHbiggl] = ACTIONS(6586),
    [anon_sym_BSLASHBiggl] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHtext] = ACTIONS(6586),
    [anon_sym_BSLASHintertext] = ACTIONS(6586),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [1798] = {
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_RBRACK] = ACTIONS(6452),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6452),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6452),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(6450),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHbegin] = ACTIONS(6450),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHleft] = ACTIONS(6450),
    [anon_sym_BSLASHbigl] = ACTIONS(6450),
    [anon_sym_BSLASHBigl] = ACTIONS(6450),
    [anon_sym_BSLASHbiggl] = ACTIONS(6450),
    [anon_sym_BSLASHBiggl] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHtext] = ACTIONS(6450),
    [anon_sym_BSLASHintertext] = ACTIONS(6450),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [1799] = {
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_LBRACK] = ACTIONS(6352),
    [anon_sym_RBRACK] = ACTIONS(6352),
    [anon_sym_COMMA] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_LPAREN] = ACTIONS(6352),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_LBRACE] = ACTIONS(6352),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6352),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6352),
    [anon_sym_DOLLAR] = ACTIONS(6350),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHbegin] = ACTIONS(6350),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHleft] = ACTIONS(6350),
    [anon_sym_BSLASHbigl] = ACTIONS(6350),
    [anon_sym_BSLASHBigl] = ACTIONS(6350),
    [anon_sym_BSLASHbiggl] = ACTIONS(6350),
    [anon_sym_BSLASHBiggl] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHtext] = ACTIONS(6350),
    [anon_sym_BSLASHintertext] = ACTIONS(6350),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [1800] = {
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_LBRACK] = ACTIONS(6176),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_LPAREN] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6176),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6176),
    [anon_sym_DOLLAR] = ACTIONS(6174),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHbegin] = ACTIONS(6174),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHleft] = ACTIONS(6174),
    [anon_sym_BSLASHbigl] = ACTIONS(6174),
    [anon_sym_BSLASHBigl] = ACTIONS(6174),
    [anon_sym_BSLASHbiggl] = ACTIONS(6174),
    [anon_sym_BSLASHBiggl] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHtext] = ACTIONS(6174),
    [anon_sym_BSLASHintertext] = ACTIONS(6174),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [1801] = {
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(6184),
    [anon_sym_RBRACK] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6184),
    [anon_sym_EQ] = ACTIONS(6184),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_RPAREN] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6184),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6184),
    [anon_sym_DOLLAR] = ACTIONS(6182),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHbegin] = ACTIONS(6182),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHleft] = ACTIONS(6182),
    [anon_sym_BSLASHbigl] = ACTIONS(6182),
    [anon_sym_BSLASHBigl] = ACTIONS(6182),
    [anon_sym_BSLASHbiggl] = ACTIONS(6182),
    [anon_sym_BSLASHBiggl] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHtext] = ACTIONS(6182),
    [anon_sym_BSLASHintertext] = ACTIONS(6182),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [1802] = {
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6192),
    [anon_sym_RBRACK] = ACTIONS(6192),
    [anon_sym_COMMA] = ACTIONS(6192),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_RPAREN] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6192),
    [anon_sym_DOLLAR] = ACTIONS(6190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHbegin] = ACTIONS(6190),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHleft] = ACTIONS(6190),
    [anon_sym_BSLASHbigl] = ACTIONS(6190),
    [anon_sym_BSLASHBigl] = ACTIONS(6190),
    [anon_sym_BSLASHbiggl] = ACTIONS(6190),
    [anon_sym_BSLASHBiggl] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHtext] = ACTIONS(6190),
    [anon_sym_BSLASHintertext] = ACTIONS(6190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [1803] = {
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_LBRACK] = ACTIONS(6408),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6408),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6408),
    [anon_sym_DOLLAR] = ACTIONS(6406),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHbegin] = ACTIONS(6406),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHleft] = ACTIONS(6406),
    [anon_sym_BSLASHbigl] = ACTIONS(6406),
    [anon_sym_BSLASHBigl] = ACTIONS(6406),
    [anon_sym_BSLASHbiggl] = ACTIONS(6406),
    [anon_sym_BSLASHBiggl] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHtext] = ACTIONS(6406),
    [anon_sym_BSLASHintertext] = ACTIONS(6406),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [1804] = {
    [sym_command_name] = ACTIONS(6646),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6646),
    [anon_sym_LBRACK] = ACTIONS(6648),
    [anon_sym_RBRACK] = ACTIONS(6648),
    [anon_sym_COMMA] = ACTIONS(6648),
    [anon_sym_EQ] = ACTIONS(6648),
    [anon_sym_LPAREN] = ACTIONS(6648),
    [anon_sym_RPAREN] = ACTIONS(6648),
    [anon_sym_LBRACE] = ACTIONS(6648),
    [sym_word] = ACTIONS(6646),
    [sym_placeholder] = ACTIONS(6648),
    [anon_sym_PLUS] = ACTIONS(6648),
    [anon_sym_DASH] = ACTIONS(6648),
    [anon_sym_STAR] = ACTIONS(6648),
    [anon_sym_SLASH] = ACTIONS(6648),
    [anon_sym_LT] = ACTIONS(6646),
    [anon_sym_GT] = ACTIONS(6646),
    [anon_sym_BANG] = ACTIONS(6646),
    [anon_sym_PIPE] = ACTIONS(6646),
    [anon_sym_COLON] = ACTIONS(6646),
    [anon_sym_SQUOTE] = ACTIONS(6646),
    [anon_sym__] = ACTIONS(6648),
    [anon_sym_CARET] = ACTIONS(6648),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6648),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6648),
    [anon_sym_DOLLAR] = ACTIONS(6646),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6648),
    [anon_sym_BSLASHbegin] = ACTIONS(6646),
    [anon_sym_BSLASHtitle] = ACTIONS(6646),
    [anon_sym_BSLASHauthor] = ACTIONS(6646),
    [anon_sym_BSLASHusepackage] = ACTIONS(6646),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6646),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6646),
    [anon_sym_BSLASHinclude] = ACTIONS(6646),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6646),
    [anon_sym_BSLASHinput] = ACTIONS(6646),
    [anon_sym_BSLASHsubfile] = ACTIONS(6646),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6646),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6646),
    [anon_sym_BSLASHbibliography] = ACTIONS(6646),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6646),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6646),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6646),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6646),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6646),
    [anon_sym_BSLASHimport] = ACTIONS(6646),
    [anon_sym_BSLASHsubimport] = ACTIONS(6646),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6646),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6646),
    [anon_sym_BSLASHcaption] = ACTIONS(6646),
    [anon_sym_BSLASHcite] = ACTIONS(6646),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCite] = ACTIONS(6646),
    [anon_sym_BSLASHnocite] = ACTIONS(6646),
    [anon_sym_BSLASHcitet] = ACTIONS(6646),
    [anon_sym_BSLASHcitep] = ACTIONS(6646),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteA] = ACTIONS(6646),
    [anon_sym_BSLASHciteR] = ACTIONS(6646),
    [anon_sym_BSLASHciteS] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6646),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6646),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteyear] = ACTIONS(6646),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHcitedate] = ACTIONS(6646),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHciteurl] = ACTIONS(6646),
    [anon_sym_BSLASHfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6646),
    [anon_sym_BSLASHcitealt] = ACTIONS(6646),
    [anon_sym_BSLASHcitealp] = ACTIONS(6646),
    [anon_sym_BSLASHcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHparencite] = ACTIONS(6646),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHParencite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6646),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6646),
    [anon_sym_BSLASHtextcite] = ACTIONS(6646),
    [anon_sym_BSLASHTextcite] = ACTIONS(6646),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6646),
    [anon_sym_BSLASHsupercite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite] = ACTIONS(6646),
    [anon_sym_BSLASHAutocite] = ACTIONS(6646),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHVolcite] = ACTIONS(6646),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHavolcite] = ACTIONS(6646),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6646),
    [anon_sym_BSLASHnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHNotecite] = ACTIONS(6646),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6646),
    [anon_sym_BSLASHlabel] = ACTIONS(6646),
    [anon_sym_BSLASHref] = ACTIONS(6646),
    [anon_sym_BSLASHeqref] = ACTIONS(6646),
    [anon_sym_BSLASHvref] = ACTIONS(6646),
    [anon_sym_BSLASHVref] = ACTIONS(6646),
    [anon_sym_BSLASHautoref] = ACTIONS(6646),
    [anon_sym_BSLASHpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcref] = ACTIONS(6646),
    [anon_sym_BSLASHCref] = ACTIONS(6646),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnameCref] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6646),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6646),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6646),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6646),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6646),
    [anon_sym_BSLASHdef] = ACTIONS(6646),
    [anon_sym_BSLASHlet] = ACTIONS(6646),
    [anon_sym_BSLASHleft] = ACTIONS(6646),
    [anon_sym_BSLASHbigl] = ACTIONS(6646),
    [anon_sym_BSLASHBigl] = ACTIONS(6646),
    [anon_sym_BSLASHbiggl] = ACTIONS(6646),
    [anon_sym_BSLASHBiggl] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6646),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6646),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6646),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6646),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6646),
    [anon_sym_BSLASHgls] = ACTIONS(6646),
    [anon_sym_BSLASHGls] = ACTIONS(6646),
    [anon_sym_BSLASHGLS] = ACTIONS(6646),
    [anon_sym_BSLASHglspl] = ACTIONS(6646),
    [anon_sym_BSLASHGlspl] = ACTIONS(6646),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6646),
    [anon_sym_BSLASHglslink] = ACTIONS(6646),
    [anon_sym_BSLASHglstext] = ACTIONS(6646),
    [anon_sym_BSLASHGlstext] = ACTIONS(6646),
    [anon_sym_BSLASHGLStext] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6646),
    [anon_sym_BSLASHglsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6646),
    [anon_sym_BSLASHglsname] = ACTIONS(6646),
    [anon_sym_BSLASHGlsname] = ACTIONS(6646),
    [anon_sym_BSLASHGLSname] = ACTIONS(6646),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6646),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6646),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6646),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6646),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6646),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6646),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6646),
    [anon_sym_BSLASHacrshort] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6646),
    [anon_sym_BSLASHACRshort] = ACTIONS(6646),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrlong] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6646),
    [anon_sym_BSLASHACRlong] = ACTIONS(6646),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6646),
    [anon_sym_BSLASHacrfull] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6646),
    [anon_sym_BSLASHACRfull] = ACTIONS(6646),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHacs] = ACTIONS(6646),
    [anon_sym_BSLASHAcs] = ACTIONS(6646),
    [anon_sym_BSLASHacsp] = ACTIONS(6646),
    [anon_sym_BSLASHAcsp] = ACTIONS(6646),
    [anon_sym_BSLASHacl] = ACTIONS(6646),
    [anon_sym_BSLASHAcl] = ACTIONS(6646),
    [anon_sym_BSLASHaclp] = ACTIONS(6646),
    [anon_sym_BSLASHAclp] = ACTIONS(6646),
    [anon_sym_BSLASHacf] = ACTIONS(6646),
    [anon_sym_BSLASHAcf] = ACTIONS(6646),
    [anon_sym_BSLASHacfp] = ACTIONS(6646),
    [anon_sym_BSLASHAcfp] = ACTIONS(6646),
    [anon_sym_BSLASHac] = ACTIONS(6646),
    [anon_sym_BSLASHAc] = ACTIONS(6646),
    [anon_sym_BSLASHacp] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6646),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6646),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6646),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6646),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6648),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6646),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6646),
    [anon_sym_BSLASHcolor] = ACTIONS(6646),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6646),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6646),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6646),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6646),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6646),
    [anon_sym_BSLASHtext] = ACTIONS(6646),
    [anon_sym_BSLASHintertext] = ACTIONS(6646),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6646),
    [anon_sym_BSLASHurl] = ACTIONS(6646),
    [anon_sym_BSLASHhref] = ACTIONS(6646),
  },
  [1805] = {
    [sym_command_name] = ACTIONS(6650),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6650),
    [anon_sym_LBRACK] = ACTIONS(6652),
    [anon_sym_RBRACK] = ACTIONS(6652),
    [anon_sym_COMMA] = ACTIONS(6652),
    [anon_sym_EQ] = ACTIONS(6652),
    [anon_sym_LPAREN] = ACTIONS(6652),
    [anon_sym_RPAREN] = ACTIONS(6652),
    [anon_sym_LBRACE] = ACTIONS(6652),
    [sym_word] = ACTIONS(6650),
    [sym_placeholder] = ACTIONS(6652),
    [anon_sym_PLUS] = ACTIONS(6652),
    [anon_sym_DASH] = ACTIONS(6652),
    [anon_sym_STAR] = ACTIONS(6652),
    [anon_sym_SLASH] = ACTIONS(6652),
    [anon_sym_LT] = ACTIONS(6650),
    [anon_sym_GT] = ACTIONS(6650),
    [anon_sym_BANG] = ACTIONS(6650),
    [anon_sym_PIPE] = ACTIONS(6650),
    [anon_sym_COLON] = ACTIONS(6650),
    [anon_sym_SQUOTE] = ACTIONS(6650),
    [anon_sym__] = ACTIONS(6652),
    [anon_sym_CARET] = ACTIONS(6652),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6652),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6652),
    [anon_sym_DOLLAR] = ACTIONS(6650),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6652),
    [anon_sym_BSLASHbegin] = ACTIONS(6650),
    [anon_sym_BSLASHtitle] = ACTIONS(6650),
    [anon_sym_BSLASHauthor] = ACTIONS(6650),
    [anon_sym_BSLASHusepackage] = ACTIONS(6650),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6650),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6650),
    [anon_sym_BSLASHinclude] = ACTIONS(6650),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6650),
    [anon_sym_BSLASHinput] = ACTIONS(6650),
    [anon_sym_BSLASHsubfile] = ACTIONS(6650),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6650),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6650),
    [anon_sym_BSLASHbibliography] = ACTIONS(6650),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6650),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6650),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6650),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6650),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6650),
    [anon_sym_BSLASHimport] = ACTIONS(6650),
    [anon_sym_BSLASHsubimport] = ACTIONS(6650),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6650),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6650),
    [anon_sym_BSLASHcaption] = ACTIONS(6650),
    [anon_sym_BSLASHcite] = ACTIONS(6650),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCite] = ACTIONS(6650),
    [anon_sym_BSLASHnocite] = ACTIONS(6650),
    [anon_sym_BSLASHcitet] = ACTIONS(6650),
    [anon_sym_BSLASHcitep] = ACTIONS(6650),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteA] = ACTIONS(6650),
    [anon_sym_BSLASHciteR] = ACTIONS(6650),
    [anon_sym_BSLASHciteS] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6650),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6650),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteyear] = ACTIONS(6650),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHcitedate] = ACTIONS(6650),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHciteurl] = ACTIONS(6650),
    [anon_sym_BSLASHfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6650),
    [anon_sym_BSLASHcitealt] = ACTIONS(6650),
    [anon_sym_BSLASHcitealp] = ACTIONS(6650),
    [anon_sym_BSLASHcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHparencite] = ACTIONS(6650),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHParencite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6650),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6650),
    [anon_sym_BSLASHtextcite] = ACTIONS(6650),
    [anon_sym_BSLASHTextcite] = ACTIONS(6650),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6650),
    [anon_sym_BSLASHsupercite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite] = ACTIONS(6650),
    [anon_sym_BSLASHAutocite] = ACTIONS(6650),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHVolcite] = ACTIONS(6650),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHavolcite] = ACTIONS(6650),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6650),
    [anon_sym_BSLASHnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHNotecite] = ACTIONS(6650),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6650),
    [anon_sym_BSLASHlabel] = ACTIONS(6650),
    [anon_sym_BSLASHref] = ACTIONS(6650),
    [anon_sym_BSLASHeqref] = ACTIONS(6650),
    [anon_sym_BSLASHvref] = ACTIONS(6650),
    [anon_sym_BSLASHVref] = ACTIONS(6650),
    [anon_sym_BSLASHautoref] = ACTIONS(6650),
    [anon_sym_BSLASHpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcref] = ACTIONS(6650),
    [anon_sym_BSLASHCref] = ACTIONS(6650),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnameCref] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6650),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6650),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6650),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6650),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6650),
    [anon_sym_BSLASHdef] = ACTIONS(6650),
    [anon_sym_BSLASHlet] = ACTIONS(6650),
    [anon_sym_BSLASHleft] = ACTIONS(6650),
    [anon_sym_BSLASHbigl] = ACTIONS(6650),
    [anon_sym_BSLASHBigl] = ACTIONS(6650),
    [anon_sym_BSLASHbiggl] = ACTIONS(6650),
    [anon_sym_BSLASHBiggl] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6650),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6650),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6650),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6650),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6650),
    [anon_sym_BSLASHgls] = ACTIONS(6650),
    [anon_sym_BSLASHGls] = ACTIONS(6650),
    [anon_sym_BSLASHGLS] = ACTIONS(6650),
    [anon_sym_BSLASHglspl] = ACTIONS(6650),
    [anon_sym_BSLASHGlspl] = ACTIONS(6650),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6650),
    [anon_sym_BSLASHglslink] = ACTIONS(6650),
    [anon_sym_BSLASHglstext] = ACTIONS(6650),
    [anon_sym_BSLASHGlstext] = ACTIONS(6650),
    [anon_sym_BSLASHGLStext] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6650),
    [anon_sym_BSLASHglsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6650),
    [anon_sym_BSLASHglsname] = ACTIONS(6650),
    [anon_sym_BSLASHGlsname] = ACTIONS(6650),
    [anon_sym_BSLASHGLSname] = ACTIONS(6650),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6650),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6650),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6650),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6650),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6650),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6650),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6650),
    [anon_sym_BSLASHacrshort] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6650),
    [anon_sym_BSLASHACRshort] = ACTIONS(6650),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrlong] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6650),
    [anon_sym_BSLASHACRlong] = ACTIONS(6650),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6650),
    [anon_sym_BSLASHacrfull] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6650),
    [anon_sym_BSLASHACRfull] = ACTIONS(6650),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHacs] = ACTIONS(6650),
    [anon_sym_BSLASHAcs] = ACTIONS(6650),
    [anon_sym_BSLASHacsp] = ACTIONS(6650),
    [anon_sym_BSLASHAcsp] = ACTIONS(6650),
    [anon_sym_BSLASHacl] = ACTIONS(6650),
    [anon_sym_BSLASHAcl] = ACTIONS(6650),
    [anon_sym_BSLASHaclp] = ACTIONS(6650),
    [anon_sym_BSLASHAclp] = ACTIONS(6650),
    [anon_sym_BSLASHacf] = ACTIONS(6650),
    [anon_sym_BSLASHAcf] = ACTIONS(6650),
    [anon_sym_BSLASHacfp] = ACTIONS(6650),
    [anon_sym_BSLASHAcfp] = ACTIONS(6650),
    [anon_sym_BSLASHac] = ACTIONS(6650),
    [anon_sym_BSLASHAc] = ACTIONS(6650),
    [anon_sym_BSLASHacp] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6650),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6650),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6650),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6650),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6652),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6650),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6650),
    [anon_sym_BSLASHcolor] = ACTIONS(6650),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6650),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6650),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6650),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6650),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6650),
    [anon_sym_BSLASHtext] = ACTIONS(6650),
    [anon_sym_BSLASHintertext] = ACTIONS(6650),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6650),
    [anon_sym_BSLASHurl] = ACTIONS(6650),
    [anon_sym_BSLASHhref] = ACTIONS(6650),
  },
  [1806] = {
    [sym_command_name] = ACTIONS(6658),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6658),
    [anon_sym_LBRACK] = ACTIONS(6660),
    [anon_sym_RBRACK] = ACTIONS(6660),
    [anon_sym_COMMA] = ACTIONS(6660),
    [anon_sym_EQ] = ACTIONS(6660),
    [anon_sym_LPAREN] = ACTIONS(6660),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_LBRACE] = ACTIONS(6660),
    [sym_word] = ACTIONS(6658),
    [sym_placeholder] = ACTIONS(6660),
    [anon_sym_PLUS] = ACTIONS(6660),
    [anon_sym_DASH] = ACTIONS(6660),
    [anon_sym_STAR] = ACTIONS(6660),
    [anon_sym_SLASH] = ACTIONS(6660),
    [anon_sym_LT] = ACTIONS(6658),
    [anon_sym_GT] = ACTIONS(6658),
    [anon_sym_BANG] = ACTIONS(6658),
    [anon_sym_PIPE] = ACTIONS(6658),
    [anon_sym_COLON] = ACTIONS(6658),
    [anon_sym_SQUOTE] = ACTIONS(6658),
    [anon_sym__] = ACTIONS(6660),
    [anon_sym_CARET] = ACTIONS(6660),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6660),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6660),
    [anon_sym_DOLLAR] = ACTIONS(6658),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6660),
    [anon_sym_BSLASHbegin] = ACTIONS(6658),
    [anon_sym_BSLASHtitle] = ACTIONS(6658),
    [anon_sym_BSLASHauthor] = ACTIONS(6658),
    [anon_sym_BSLASHusepackage] = ACTIONS(6658),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6658),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6658),
    [anon_sym_BSLASHinclude] = ACTIONS(6658),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6658),
    [anon_sym_BSLASHinput] = ACTIONS(6658),
    [anon_sym_BSLASHsubfile] = ACTIONS(6658),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6658),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6658),
    [anon_sym_BSLASHbibliography] = ACTIONS(6658),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6658),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6658),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6658),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6658),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6658),
    [anon_sym_BSLASHimport] = ACTIONS(6658),
    [anon_sym_BSLASHsubimport] = ACTIONS(6658),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6658),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6658),
    [anon_sym_BSLASHcaption] = ACTIONS(6658),
    [anon_sym_BSLASHcite] = ACTIONS(6658),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCite] = ACTIONS(6658),
    [anon_sym_BSLASHnocite] = ACTIONS(6658),
    [anon_sym_BSLASHcitet] = ACTIONS(6658),
    [anon_sym_BSLASHcitep] = ACTIONS(6658),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteA] = ACTIONS(6658),
    [anon_sym_BSLASHciteR] = ACTIONS(6658),
    [anon_sym_BSLASHciteS] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6658),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6658),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteyear] = ACTIONS(6658),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHcitedate] = ACTIONS(6658),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHciteurl] = ACTIONS(6658),
    [anon_sym_BSLASHfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6658),
    [anon_sym_BSLASHcitealt] = ACTIONS(6658),
    [anon_sym_BSLASHcitealp] = ACTIONS(6658),
    [anon_sym_BSLASHcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHparencite] = ACTIONS(6658),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHParencite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6658),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6658),
    [anon_sym_BSLASHtextcite] = ACTIONS(6658),
    [anon_sym_BSLASHTextcite] = ACTIONS(6658),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6658),
    [anon_sym_BSLASHsupercite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite] = ACTIONS(6658),
    [anon_sym_BSLASHAutocite] = ACTIONS(6658),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHVolcite] = ACTIONS(6658),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHavolcite] = ACTIONS(6658),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6658),
    [anon_sym_BSLASHnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHNotecite] = ACTIONS(6658),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6658),
    [anon_sym_BSLASHlabel] = ACTIONS(6658),
    [anon_sym_BSLASHref] = ACTIONS(6658),
    [anon_sym_BSLASHeqref] = ACTIONS(6658),
    [anon_sym_BSLASHvref] = ACTIONS(6658),
    [anon_sym_BSLASHVref] = ACTIONS(6658),
    [anon_sym_BSLASHautoref] = ACTIONS(6658),
    [anon_sym_BSLASHpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcref] = ACTIONS(6658),
    [anon_sym_BSLASHCref] = ACTIONS(6658),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnameCref] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6658),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6658),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6658),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6658),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6658),
    [anon_sym_BSLASHdef] = ACTIONS(6658),
    [anon_sym_BSLASHlet] = ACTIONS(6658),
    [anon_sym_BSLASHleft] = ACTIONS(6658),
    [anon_sym_BSLASHbigl] = ACTIONS(6658),
    [anon_sym_BSLASHBigl] = ACTIONS(6658),
    [anon_sym_BSLASHbiggl] = ACTIONS(6658),
    [anon_sym_BSLASHBiggl] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6658),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6658),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6658),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6658),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6658),
    [anon_sym_BSLASHgls] = ACTIONS(6658),
    [anon_sym_BSLASHGls] = ACTIONS(6658),
    [anon_sym_BSLASHGLS] = ACTIONS(6658),
    [anon_sym_BSLASHglspl] = ACTIONS(6658),
    [anon_sym_BSLASHGlspl] = ACTIONS(6658),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6658),
    [anon_sym_BSLASHglslink] = ACTIONS(6658),
    [anon_sym_BSLASHglstext] = ACTIONS(6658),
    [anon_sym_BSLASHGlstext] = ACTIONS(6658),
    [anon_sym_BSLASHGLStext] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6658),
    [anon_sym_BSLASHglsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6658),
    [anon_sym_BSLASHglsname] = ACTIONS(6658),
    [anon_sym_BSLASHGlsname] = ACTIONS(6658),
    [anon_sym_BSLASHGLSname] = ACTIONS(6658),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6658),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6658),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6658),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6658),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6658),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6658),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6658),
    [anon_sym_BSLASHacrshort] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6658),
    [anon_sym_BSLASHACRshort] = ACTIONS(6658),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrlong] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6658),
    [anon_sym_BSLASHACRlong] = ACTIONS(6658),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6658),
    [anon_sym_BSLASHacrfull] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6658),
    [anon_sym_BSLASHACRfull] = ACTIONS(6658),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHacs] = ACTIONS(6658),
    [anon_sym_BSLASHAcs] = ACTIONS(6658),
    [anon_sym_BSLASHacsp] = ACTIONS(6658),
    [anon_sym_BSLASHAcsp] = ACTIONS(6658),
    [anon_sym_BSLASHacl] = ACTIONS(6658),
    [anon_sym_BSLASHAcl] = ACTIONS(6658),
    [anon_sym_BSLASHaclp] = ACTIONS(6658),
    [anon_sym_BSLASHAclp] = ACTIONS(6658),
    [anon_sym_BSLASHacf] = ACTIONS(6658),
    [anon_sym_BSLASHAcf] = ACTIONS(6658),
    [anon_sym_BSLASHacfp] = ACTIONS(6658),
    [anon_sym_BSLASHAcfp] = ACTIONS(6658),
    [anon_sym_BSLASHac] = ACTIONS(6658),
    [anon_sym_BSLASHAc] = ACTIONS(6658),
    [anon_sym_BSLASHacp] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6658),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6658),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6658),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6658),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6660),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6658),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6658),
    [anon_sym_BSLASHcolor] = ACTIONS(6658),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6658),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6658),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6658),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6658),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6658),
    [anon_sym_BSLASHtext] = ACTIONS(6658),
    [anon_sym_BSLASHintertext] = ACTIONS(6658),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6658),
    [anon_sym_BSLASHurl] = ACTIONS(6658),
    [anon_sym_BSLASHhref] = ACTIONS(6658),
  },
  [1807] = {
    [sym_command_name] = ACTIONS(6662),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6662),
    [anon_sym_LBRACK] = ACTIONS(6664),
    [anon_sym_RBRACK] = ACTIONS(6664),
    [anon_sym_COMMA] = ACTIONS(6664),
    [anon_sym_EQ] = ACTIONS(6664),
    [anon_sym_LPAREN] = ACTIONS(6664),
    [anon_sym_RPAREN] = ACTIONS(6664),
    [anon_sym_LBRACE] = ACTIONS(6664),
    [sym_word] = ACTIONS(6662),
    [sym_placeholder] = ACTIONS(6664),
    [anon_sym_PLUS] = ACTIONS(6664),
    [anon_sym_DASH] = ACTIONS(6664),
    [anon_sym_STAR] = ACTIONS(6664),
    [anon_sym_SLASH] = ACTIONS(6664),
    [anon_sym_LT] = ACTIONS(6662),
    [anon_sym_GT] = ACTIONS(6662),
    [anon_sym_BANG] = ACTIONS(6662),
    [anon_sym_PIPE] = ACTIONS(6662),
    [anon_sym_COLON] = ACTIONS(6662),
    [anon_sym_SQUOTE] = ACTIONS(6662),
    [anon_sym__] = ACTIONS(6664),
    [anon_sym_CARET] = ACTIONS(6664),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6664),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6664),
    [anon_sym_DOLLAR] = ACTIONS(6662),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6664),
    [anon_sym_BSLASHbegin] = ACTIONS(6662),
    [anon_sym_BSLASHtitle] = ACTIONS(6662),
    [anon_sym_BSLASHauthor] = ACTIONS(6662),
    [anon_sym_BSLASHusepackage] = ACTIONS(6662),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6662),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6662),
    [anon_sym_BSLASHinclude] = ACTIONS(6662),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6662),
    [anon_sym_BSLASHinput] = ACTIONS(6662),
    [anon_sym_BSLASHsubfile] = ACTIONS(6662),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6662),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6662),
    [anon_sym_BSLASHbibliography] = ACTIONS(6662),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6662),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6662),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6662),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6662),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6662),
    [anon_sym_BSLASHimport] = ACTIONS(6662),
    [anon_sym_BSLASHsubimport] = ACTIONS(6662),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6662),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6662),
    [anon_sym_BSLASHcaption] = ACTIONS(6662),
    [anon_sym_BSLASHcite] = ACTIONS(6662),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCite] = ACTIONS(6662),
    [anon_sym_BSLASHnocite] = ACTIONS(6662),
    [anon_sym_BSLASHcitet] = ACTIONS(6662),
    [anon_sym_BSLASHcitep] = ACTIONS(6662),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteA] = ACTIONS(6662),
    [anon_sym_BSLASHciteR] = ACTIONS(6662),
    [anon_sym_BSLASHciteS] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6662),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6662),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteyear] = ACTIONS(6662),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHcitedate] = ACTIONS(6662),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHciteurl] = ACTIONS(6662),
    [anon_sym_BSLASHfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6662),
    [anon_sym_BSLASHcitealt] = ACTIONS(6662),
    [anon_sym_BSLASHcitealp] = ACTIONS(6662),
    [anon_sym_BSLASHcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHparencite] = ACTIONS(6662),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHParencite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6662),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6662),
    [anon_sym_BSLASHtextcite] = ACTIONS(6662),
    [anon_sym_BSLASHTextcite] = ACTIONS(6662),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6662),
    [anon_sym_BSLASHsupercite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite] = ACTIONS(6662),
    [anon_sym_BSLASHAutocite] = ACTIONS(6662),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHVolcite] = ACTIONS(6662),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHavolcite] = ACTIONS(6662),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6662),
    [anon_sym_BSLASHnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHNotecite] = ACTIONS(6662),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6662),
    [anon_sym_BSLASHlabel] = ACTIONS(6662),
    [anon_sym_BSLASHref] = ACTIONS(6662),
    [anon_sym_BSLASHeqref] = ACTIONS(6662),
    [anon_sym_BSLASHvref] = ACTIONS(6662),
    [anon_sym_BSLASHVref] = ACTIONS(6662),
    [anon_sym_BSLASHautoref] = ACTIONS(6662),
    [anon_sym_BSLASHpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcref] = ACTIONS(6662),
    [anon_sym_BSLASHCref] = ACTIONS(6662),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnameCref] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6662),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6662),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6662),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6662),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6662),
    [anon_sym_BSLASHdef] = ACTIONS(6662),
    [anon_sym_BSLASHlet] = ACTIONS(6662),
    [anon_sym_BSLASHleft] = ACTIONS(6662),
    [anon_sym_BSLASHbigl] = ACTIONS(6662),
    [anon_sym_BSLASHBigl] = ACTIONS(6662),
    [anon_sym_BSLASHbiggl] = ACTIONS(6662),
    [anon_sym_BSLASHBiggl] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6662),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6662),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6662),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6662),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6662),
    [anon_sym_BSLASHgls] = ACTIONS(6662),
    [anon_sym_BSLASHGls] = ACTIONS(6662),
    [anon_sym_BSLASHGLS] = ACTIONS(6662),
    [anon_sym_BSLASHglspl] = ACTIONS(6662),
    [anon_sym_BSLASHGlspl] = ACTIONS(6662),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6662),
    [anon_sym_BSLASHglslink] = ACTIONS(6662),
    [anon_sym_BSLASHglstext] = ACTIONS(6662),
    [anon_sym_BSLASHGlstext] = ACTIONS(6662),
    [anon_sym_BSLASHGLStext] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6662),
    [anon_sym_BSLASHglsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6662),
    [anon_sym_BSLASHglsname] = ACTIONS(6662),
    [anon_sym_BSLASHGlsname] = ACTIONS(6662),
    [anon_sym_BSLASHGLSname] = ACTIONS(6662),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6662),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6662),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6662),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6662),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6662),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6662),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6662),
    [anon_sym_BSLASHacrshort] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6662),
    [anon_sym_BSLASHACRshort] = ACTIONS(6662),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrlong] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6662),
    [anon_sym_BSLASHACRlong] = ACTIONS(6662),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6662),
    [anon_sym_BSLASHacrfull] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6662),
    [anon_sym_BSLASHACRfull] = ACTIONS(6662),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHacs] = ACTIONS(6662),
    [anon_sym_BSLASHAcs] = ACTIONS(6662),
    [anon_sym_BSLASHacsp] = ACTIONS(6662),
    [anon_sym_BSLASHAcsp] = ACTIONS(6662),
    [anon_sym_BSLASHacl] = ACTIONS(6662),
    [anon_sym_BSLASHAcl] = ACTIONS(6662),
    [anon_sym_BSLASHaclp] = ACTIONS(6662),
    [anon_sym_BSLASHAclp] = ACTIONS(6662),
    [anon_sym_BSLASHacf] = ACTIONS(6662),
    [anon_sym_BSLASHAcf] = ACTIONS(6662),
    [anon_sym_BSLASHacfp] = ACTIONS(6662),
    [anon_sym_BSLASHAcfp] = ACTIONS(6662),
    [anon_sym_BSLASHac] = ACTIONS(6662),
    [anon_sym_BSLASHAc] = ACTIONS(6662),
    [anon_sym_BSLASHacp] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6662),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6662),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6662),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6662),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6664),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6662),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6662),
    [anon_sym_BSLASHcolor] = ACTIONS(6662),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6662),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6662),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6662),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6662),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6662),
    [anon_sym_BSLASHtext] = ACTIONS(6662),
    [anon_sym_BSLASHintertext] = ACTIONS(6662),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6662),
    [anon_sym_BSLASHurl] = ACTIONS(6662),
    [anon_sym_BSLASHhref] = ACTIONS(6662),
  },
  [1808] = {
    [sym_command_name] = ACTIONS(6594),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6594),
    [anon_sym_LBRACK] = ACTIONS(6596),
    [anon_sym_RBRACK] = ACTIONS(6596),
    [anon_sym_COMMA] = ACTIONS(6596),
    [anon_sym_EQ] = ACTIONS(6596),
    [anon_sym_LPAREN] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_LBRACE] = ACTIONS(6596),
    [anon_sym_RBRACE] = ACTIONS(6596),
    [sym_word] = ACTIONS(6594),
    [sym_placeholder] = ACTIONS(6596),
    [anon_sym_PLUS] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6596),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_SLASH] = ACTIONS(6596),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_BANG] = ACTIONS(6594),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SQUOTE] = ACTIONS(6594),
    [anon_sym__] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(6596),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6596),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(6594),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHtitle] = ACTIONS(6594),
    [anon_sym_BSLASHauthor] = ACTIONS(6594),
    [anon_sym_BSLASHusepackage] = ACTIONS(6594),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6594),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6594),
    [anon_sym_BSLASHinclude] = ACTIONS(6594),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6594),
    [anon_sym_BSLASHinput] = ACTIONS(6594),
    [anon_sym_BSLASHsubfile] = ACTIONS(6594),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6594),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6594),
    [anon_sym_BSLASHbibliography] = ACTIONS(6594),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6594),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6594),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6594),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6594),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6594),
    [anon_sym_BSLASHimport] = ACTIONS(6594),
    [anon_sym_BSLASHsubimport] = ACTIONS(6594),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6594),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHcaption] = ACTIONS(6594),
    [anon_sym_BSLASHcite] = ACTIONS(6594),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCite] = ACTIONS(6594),
    [anon_sym_BSLASHnocite] = ACTIONS(6594),
    [anon_sym_BSLASHcitet] = ACTIONS(6594),
    [anon_sym_BSLASHcitep] = ACTIONS(6594),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteA] = ACTIONS(6594),
    [anon_sym_BSLASHciteR] = ACTIONS(6594),
    [anon_sym_BSLASHciteS] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6594),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteyear] = ACTIONS(6594),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitedate] = ACTIONS(6594),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteurl] = ACTIONS(6594),
    [anon_sym_BSLASHfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6594),
    [anon_sym_BSLASHcitealt] = ACTIONS(6594),
    [anon_sym_BSLASHcitealp] = ACTIONS(6594),
    [anon_sym_BSLASHcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHparencite] = ACTIONS(6594),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHParencite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHtextcite] = ACTIONS(6594),
    [anon_sym_BSLASHTextcite] = ACTIONS(6594),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHsupercite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite] = ACTIONS(6594),
    [anon_sym_BSLASHAutocite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHVolcite] = ACTIONS(6594),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHavolcite] = ACTIONS(6594),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHNotecite] = ACTIONS(6594),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHlabel] = ACTIONS(6594),
    [anon_sym_BSLASHref] = ACTIONS(6594),
    [anon_sym_BSLASHeqref] = ACTIONS(6594),
    [anon_sym_BSLASHvref] = ACTIONS(6594),
    [anon_sym_BSLASHVref] = ACTIONS(6594),
    [anon_sym_BSLASHautoref] = ACTIONS(6594),
    [anon_sym_BSLASHpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcref] = ACTIONS(6594),
    [anon_sym_BSLASHCref] = ACTIONS(6594),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnameCref] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHdef] = ACTIONS(6594),
    [anon_sym_BSLASHlet] = ACTIONS(6594),
    [anon_sym_BSLASHleft] = ACTIONS(6594),
    [anon_sym_BSLASHbigl] = ACTIONS(6594),
    [anon_sym_BSLASHBigl] = ACTIONS(6594),
    [anon_sym_BSLASHbiggl] = ACTIONS(6594),
    [anon_sym_BSLASHBiggl] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6594),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6594),
    [anon_sym_BSLASHgls] = ACTIONS(6594),
    [anon_sym_BSLASHGls] = ACTIONS(6594),
    [anon_sym_BSLASHGLS] = ACTIONS(6594),
    [anon_sym_BSLASHglspl] = ACTIONS(6594),
    [anon_sym_BSLASHGlspl] = ACTIONS(6594),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6594),
    [anon_sym_BSLASHglslink] = ACTIONS(6594),
    [anon_sym_BSLASHglstext] = ACTIONS(6594),
    [anon_sym_BSLASHGlstext] = ACTIONS(6594),
    [anon_sym_BSLASHGLStext] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6594),
    [anon_sym_BSLASHglsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsname] = ACTIONS(6594),
    [anon_sym_BSLASHGlsname] = ACTIONS(6594),
    [anon_sym_BSLASHGLSname] = ACTIONS(6594),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6594),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6594),
    [anon_sym_BSLASHacrshort] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6594),
    [anon_sym_BSLASHACRshort] = ACTIONS(6594),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrlong] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6594),
    [anon_sym_BSLASHACRlong] = ACTIONS(6594),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrfull] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6594),
    [anon_sym_BSLASHACRfull] = ACTIONS(6594),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHacs] = ACTIONS(6594),
    [anon_sym_BSLASHAcs] = ACTIONS(6594),
    [anon_sym_BSLASHacsp] = ACTIONS(6594),
    [anon_sym_BSLASHAcsp] = ACTIONS(6594),
    [anon_sym_BSLASHacl] = ACTIONS(6594),
    [anon_sym_BSLASHAcl] = ACTIONS(6594),
    [anon_sym_BSLASHaclp] = ACTIONS(6594),
    [anon_sym_BSLASHAclp] = ACTIONS(6594),
    [anon_sym_BSLASHacf] = ACTIONS(6594),
    [anon_sym_BSLASHAcf] = ACTIONS(6594),
    [anon_sym_BSLASHacfp] = ACTIONS(6594),
    [anon_sym_BSLASHAcfp] = ACTIONS(6594),
    [anon_sym_BSLASHac] = ACTIONS(6594),
    [anon_sym_BSLASHAc] = ACTIONS(6594),
    [anon_sym_BSLASHacp] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6594),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6594),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6594),
    [anon_sym_BSLASHcolor] = ACTIONS(6594),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6594),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6594),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6594),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6594),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6594),
    [anon_sym_BSLASHtext] = ACTIONS(6594),
    [anon_sym_BSLASHintertext] = ACTIONS(6594),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6594),
    [anon_sym_BSLASHurl] = ACTIONS(6594),
    [anon_sym_BSLASHhref] = ACTIONS(6594),
  },
  [1809] = {
    [sym_command_name] = ACTIONS(6666),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6666),
    [anon_sym_LBRACK] = ACTIONS(6668),
    [anon_sym_RBRACK] = ACTIONS(6668),
    [anon_sym_COMMA] = ACTIONS(6668),
    [anon_sym_EQ] = ACTIONS(6668),
    [anon_sym_LPAREN] = ACTIONS(6668),
    [anon_sym_RPAREN] = ACTIONS(6668),
    [anon_sym_LBRACE] = ACTIONS(6668),
    [sym_word] = ACTIONS(6666),
    [sym_placeholder] = ACTIONS(6668),
    [anon_sym_PLUS] = ACTIONS(6668),
    [anon_sym_DASH] = ACTIONS(6668),
    [anon_sym_STAR] = ACTIONS(6668),
    [anon_sym_SLASH] = ACTIONS(6668),
    [anon_sym_LT] = ACTIONS(6666),
    [anon_sym_GT] = ACTIONS(6666),
    [anon_sym_BANG] = ACTIONS(6666),
    [anon_sym_PIPE] = ACTIONS(6666),
    [anon_sym_COLON] = ACTIONS(6666),
    [anon_sym_SQUOTE] = ACTIONS(6666),
    [anon_sym__] = ACTIONS(6668),
    [anon_sym_CARET] = ACTIONS(6668),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6668),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6668),
    [anon_sym_DOLLAR] = ACTIONS(6666),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6668),
    [anon_sym_BSLASHbegin] = ACTIONS(6666),
    [anon_sym_BSLASHtitle] = ACTIONS(6666),
    [anon_sym_BSLASHauthor] = ACTIONS(6666),
    [anon_sym_BSLASHusepackage] = ACTIONS(6666),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6666),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6666),
    [anon_sym_BSLASHinclude] = ACTIONS(6666),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6666),
    [anon_sym_BSLASHinput] = ACTIONS(6666),
    [anon_sym_BSLASHsubfile] = ACTIONS(6666),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6666),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6666),
    [anon_sym_BSLASHbibliography] = ACTIONS(6666),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6666),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6666),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6666),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6666),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6666),
    [anon_sym_BSLASHimport] = ACTIONS(6666),
    [anon_sym_BSLASHsubimport] = ACTIONS(6666),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6666),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6666),
    [anon_sym_BSLASHcaption] = ACTIONS(6666),
    [anon_sym_BSLASHcite] = ACTIONS(6666),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCite] = ACTIONS(6666),
    [anon_sym_BSLASHnocite] = ACTIONS(6666),
    [anon_sym_BSLASHcitet] = ACTIONS(6666),
    [anon_sym_BSLASHcitep] = ACTIONS(6666),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteA] = ACTIONS(6666),
    [anon_sym_BSLASHciteR] = ACTIONS(6666),
    [anon_sym_BSLASHciteS] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6666),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6666),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteyear] = ACTIONS(6666),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHcitedate] = ACTIONS(6666),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHciteurl] = ACTIONS(6666),
    [anon_sym_BSLASHfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6666),
    [anon_sym_BSLASHcitealt] = ACTIONS(6666),
    [anon_sym_BSLASHcitealp] = ACTIONS(6666),
    [anon_sym_BSLASHcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHparencite] = ACTIONS(6666),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHParencite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6666),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6666),
    [anon_sym_BSLASHtextcite] = ACTIONS(6666),
    [anon_sym_BSLASHTextcite] = ACTIONS(6666),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6666),
    [anon_sym_BSLASHsupercite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite] = ACTIONS(6666),
    [anon_sym_BSLASHAutocite] = ACTIONS(6666),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHVolcite] = ACTIONS(6666),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHavolcite] = ACTIONS(6666),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6666),
    [anon_sym_BSLASHnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHNotecite] = ACTIONS(6666),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6666),
    [anon_sym_BSLASHlabel] = ACTIONS(6666),
    [anon_sym_BSLASHref] = ACTIONS(6666),
    [anon_sym_BSLASHeqref] = ACTIONS(6666),
    [anon_sym_BSLASHvref] = ACTIONS(6666),
    [anon_sym_BSLASHVref] = ACTIONS(6666),
    [anon_sym_BSLASHautoref] = ACTIONS(6666),
    [anon_sym_BSLASHpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcref] = ACTIONS(6666),
    [anon_sym_BSLASHCref] = ACTIONS(6666),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnameCref] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6666),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6666),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6666),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6666),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6666),
    [anon_sym_BSLASHdef] = ACTIONS(6666),
    [anon_sym_BSLASHlet] = ACTIONS(6666),
    [anon_sym_BSLASHleft] = ACTIONS(6666),
    [anon_sym_BSLASHbigl] = ACTIONS(6666),
    [anon_sym_BSLASHBigl] = ACTIONS(6666),
    [anon_sym_BSLASHbiggl] = ACTIONS(6666),
    [anon_sym_BSLASHBiggl] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6666),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6666),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6666),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6666),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6666),
    [anon_sym_BSLASHgls] = ACTIONS(6666),
    [anon_sym_BSLASHGls] = ACTIONS(6666),
    [anon_sym_BSLASHGLS] = ACTIONS(6666),
    [anon_sym_BSLASHglspl] = ACTIONS(6666),
    [anon_sym_BSLASHGlspl] = ACTIONS(6666),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6666),
    [anon_sym_BSLASHglslink] = ACTIONS(6666),
    [anon_sym_BSLASHglstext] = ACTIONS(6666),
    [anon_sym_BSLASHGlstext] = ACTIONS(6666),
    [anon_sym_BSLASHGLStext] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6666),
    [anon_sym_BSLASHglsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6666),
    [anon_sym_BSLASHglsname] = ACTIONS(6666),
    [anon_sym_BSLASHGlsname] = ACTIONS(6666),
    [anon_sym_BSLASHGLSname] = ACTIONS(6666),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6666),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6666),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6666),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6666),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6666),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6666),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6666),
    [anon_sym_BSLASHacrshort] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6666),
    [anon_sym_BSLASHACRshort] = ACTIONS(6666),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrlong] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6666),
    [anon_sym_BSLASHACRlong] = ACTIONS(6666),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6666),
    [anon_sym_BSLASHacrfull] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6666),
    [anon_sym_BSLASHACRfull] = ACTIONS(6666),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHacs] = ACTIONS(6666),
    [anon_sym_BSLASHAcs] = ACTIONS(6666),
    [anon_sym_BSLASHacsp] = ACTIONS(6666),
    [anon_sym_BSLASHAcsp] = ACTIONS(6666),
    [anon_sym_BSLASHacl] = ACTIONS(6666),
    [anon_sym_BSLASHAcl] = ACTIONS(6666),
    [anon_sym_BSLASHaclp] = ACTIONS(6666),
    [anon_sym_BSLASHAclp] = ACTIONS(6666),
    [anon_sym_BSLASHacf] = ACTIONS(6666),
    [anon_sym_BSLASHAcf] = ACTIONS(6666),
    [anon_sym_BSLASHacfp] = ACTIONS(6666),
    [anon_sym_BSLASHAcfp] = ACTIONS(6666),
    [anon_sym_BSLASHac] = ACTIONS(6666),
    [anon_sym_BSLASHAc] = ACTIONS(6666),
    [anon_sym_BSLASHacp] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6666),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6666),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6666),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6666),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6668),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6666),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6666),
    [anon_sym_BSLASHcolor] = ACTIONS(6666),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6666),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6666),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6666),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6666),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6666),
    [anon_sym_BSLASHtext] = ACTIONS(6666),
    [anon_sym_BSLASHintertext] = ACTIONS(6666),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6666),
    [anon_sym_BSLASHurl] = ACTIONS(6666),
    [anon_sym_BSLASHhref] = ACTIONS(6666),
  },
  [1810] = {
    [sym_command_name] = ACTIONS(6170),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6170),
    [anon_sym_LBRACK] = ACTIONS(6172),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_COMMA] = ACTIONS(6172),
    [anon_sym_EQ] = ACTIONS(6172),
    [anon_sym_LPAREN] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [anon_sym_RBRACE] = ACTIONS(6172),
    [sym_word] = ACTIONS(6170),
    [sym_placeholder] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_BANG] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_SQUOTE] = ACTIONS(6170),
    [anon_sym__] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6172),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6172),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHtitle] = ACTIONS(6170),
    [anon_sym_BSLASHauthor] = ACTIONS(6170),
    [anon_sym_BSLASHusepackage] = ACTIONS(6170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6170),
    [anon_sym_BSLASHinclude] = ACTIONS(6170),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6170),
    [anon_sym_BSLASHinput] = ACTIONS(6170),
    [anon_sym_BSLASHsubfile] = ACTIONS(6170),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6170),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6170),
    [anon_sym_BSLASHbibliography] = ACTIONS(6170),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6170),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6170),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6170),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6170),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6170),
    [anon_sym_BSLASHimport] = ACTIONS(6170),
    [anon_sym_BSLASHsubimport] = ACTIONS(6170),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6170),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHcaption] = ACTIONS(6170),
    [anon_sym_BSLASHcite] = ACTIONS(6170),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCite] = ACTIONS(6170),
    [anon_sym_BSLASHnocite] = ACTIONS(6170),
    [anon_sym_BSLASHcitet] = ACTIONS(6170),
    [anon_sym_BSLASHcitep] = ACTIONS(6170),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteA] = ACTIONS(6170),
    [anon_sym_BSLASHciteR] = ACTIONS(6170),
    [anon_sym_BSLASHciteS] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6170),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteyear] = ACTIONS(6170),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitedate] = ACTIONS(6170),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteurl] = ACTIONS(6170),
    [anon_sym_BSLASHfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6170),
    [anon_sym_BSLASHcitealt] = ACTIONS(6170),
    [anon_sym_BSLASHcitealp] = ACTIONS(6170),
    [anon_sym_BSLASHcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHparencite] = ACTIONS(6170),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHParencite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHtextcite] = ACTIONS(6170),
    [anon_sym_BSLASHTextcite] = ACTIONS(6170),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHsupercite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite] = ACTIONS(6170),
    [anon_sym_BSLASHAutocite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHVolcite] = ACTIONS(6170),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHavolcite] = ACTIONS(6170),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHNotecite] = ACTIONS(6170),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHlabel] = ACTIONS(6170),
    [anon_sym_BSLASHref] = ACTIONS(6170),
    [anon_sym_BSLASHeqref] = ACTIONS(6170),
    [anon_sym_BSLASHvref] = ACTIONS(6170),
    [anon_sym_BSLASHVref] = ACTIONS(6170),
    [anon_sym_BSLASHautoref] = ACTIONS(6170),
    [anon_sym_BSLASHpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcref] = ACTIONS(6170),
    [anon_sym_BSLASHCref] = ACTIONS(6170),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnameCref] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHdef] = ACTIONS(6170),
    [anon_sym_BSLASHlet] = ACTIONS(6170),
    [anon_sym_BSLASHleft] = ACTIONS(6170),
    [anon_sym_BSLASHbigl] = ACTIONS(6170),
    [anon_sym_BSLASHBigl] = ACTIONS(6170),
    [anon_sym_BSLASHbiggl] = ACTIONS(6170),
    [anon_sym_BSLASHBiggl] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6170),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6170),
    [anon_sym_BSLASHgls] = ACTIONS(6170),
    [anon_sym_BSLASHGls] = ACTIONS(6170),
    [anon_sym_BSLASHGLS] = ACTIONS(6170),
    [anon_sym_BSLASHglspl] = ACTIONS(6170),
    [anon_sym_BSLASHGlspl] = ACTIONS(6170),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6170),
    [anon_sym_BSLASHglslink] = ACTIONS(6170),
    [anon_sym_BSLASHglstext] = ACTIONS(6170),
    [anon_sym_BSLASHGlstext] = ACTIONS(6170),
    [anon_sym_BSLASHGLStext] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6170),
    [anon_sym_BSLASHglsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsname] = ACTIONS(6170),
    [anon_sym_BSLASHGlsname] = ACTIONS(6170),
    [anon_sym_BSLASHGLSname] = ACTIONS(6170),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6170),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6170),
    [anon_sym_BSLASHacrshort] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6170),
    [anon_sym_BSLASHACRshort] = ACTIONS(6170),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrlong] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6170),
    [anon_sym_BSLASHACRlong] = ACTIONS(6170),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrfull] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6170),
    [anon_sym_BSLASHACRfull] = ACTIONS(6170),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHacs] = ACTIONS(6170),
    [anon_sym_BSLASHAcs] = ACTIONS(6170),
    [anon_sym_BSLASHacsp] = ACTIONS(6170),
    [anon_sym_BSLASHAcsp] = ACTIONS(6170),
    [anon_sym_BSLASHacl] = ACTIONS(6170),
    [anon_sym_BSLASHAcl] = ACTIONS(6170),
    [anon_sym_BSLASHaclp] = ACTIONS(6170),
    [anon_sym_BSLASHAclp] = ACTIONS(6170),
    [anon_sym_BSLASHacf] = ACTIONS(6170),
    [anon_sym_BSLASHAcf] = ACTIONS(6170),
    [anon_sym_BSLASHacfp] = ACTIONS(6170),
    [anon_sym_BSLASHAcfp] = ACTIONS(6170),
    [anon_sym_BSLASHac] = ACTIONS(6170),
    [anon_sym_BSLASHAc] = ACTIONS(6170),
    [anon_sym_BSLASHacp] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6170),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6170),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6170),
    [anon_sym_BSLASHcolor] = ACTIONS(6170),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6170),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6170),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6170),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6170),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6170),
    [anon_sym_BSLASHtext] = ACTIONS(6170),
    [anon_sym_BSLASHintertext] = ACTIONS(6170),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6170),
    [anon_sym_BSLASHurl] = ACTIONS(6170),
    [anon_sym_BSLASHhref] = ACTIONS(6170),
  },
  [1811] = {
    [sym_command_name] = ACTIONS(6674),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6674),
    [anon_sym_LBRACK] = ACTIONS(6676),
    [anon_sym_RBRACK] = ACTIONS(6676),
    [anon_sym_COMMA] = ACTIONS(6676),
    [anon_sym_EQ] = ACTIONS(6676),
    [anon_sym_LPAREN] = ACTIONS(6676),
    [anon_sym_RPAREN] = ACTIONS(6676),
    [anon_sym_LBRACE] = ACTIONS(6676),
    [sym_word] = ACTIONS(6674),
    [sym_placeholder] = ACTIONS(6676),
    [anon_sym_PLUS] = ACTIONS(6676),
    [anon_sym_DASH] = ACTIONS(6676),
    [anon_sym_STAR] = ACTIONS(6676),
    [anon_sym_SLASH] = ACTIONS(6676),
    [anon_sym_LT] = ACTIONS(6674),
    [anon_sym_GT] = ACTIONS(6674),
    [anon_sym_BANG] = ACTIONS(6674),
    [anon_sym_PIPE] = ACTIONS(6674),
    [anon_sym_COLON] = ACTIONS(6674),
    [anon_sym_SQUOTE] = ACTIONS(6674),
    [anon_sym__] = ACTIONS(6676),
    [anon_sym_CARET] = ACTIONS(6676),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6676),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6676),
    [anon_sym_DOLLAR] = ACTIONS(6674),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6676),
    [anon_sym_BSLASHbegin] = ACTIONS(6674),
    [anon_sym_BSLASHtitle] = ACTIONS(6674),
    [anon_sym_BSLASHauthor] = ACTIONS(6674),
    [anon_sym_BSLASHusepackage] = ACTIONS(6674),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6674),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6674),
    [anon_sym_BSLASHinclude] = ACTIONS(6674),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6674),
    [anon_sym_BSLASHinput] = ACTIONS(6674),
    [anon_sym_BSLASHsubfile] = ACTIONS(6674),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6674),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6674),
    [anon_sym_BSLASHbibliography] = ACTIONS(6674),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6674),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6674),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6674),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6674),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6674),
    [anon_sym_BSLASHimport] = ACTIONS(6674),
    [anon_sym_BSLASHsubimport] = ACTIONS(6674),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6674),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6674),
    [anon_sym_BSLASHcaption] = ACTIONS(6674),
    [anon_sym_BSLASHcite] = ACTIONS(6674),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCite] = ACTIONS(6674),
    [anon_sym_BSLASHnocite] = ACTIONS(6674),
    [anon_sym_BSLASHcitet] = ACTIONS(6674),
    [anon_sym_BSLASHcitep] = ACTIONS(6674),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteA] = ACTIONS(6674),
    [anon_sym_BSLASHciteR] = ACTIONS(6674),
    [anon_sym_BSLASHciteS] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6674),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6674),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteyear] = ACTIONS(6674),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHcitedate] = ACTIONS(6674),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHciteurl] = ACTIONS(6674),
    [anon_sym_BSLASHfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6674),
    [anon_sym_BSLASHcitealt] = ACTIONS(6674),
    [anon_sym_BSLASHcitealp] = ACTIONS(6674),
    [anon_sym_BSLASHcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHparencite] = ACTIONS(6674),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHParencite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6674),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6674),
    [anon_sym_BSLASHtextcite] = ACTIONS(6674),
    [anon_sym_BSLASHTextcite] = ACTIONS(6674),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6674),
    [anon_sym_BSLASHsupercite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite] = ACTIONS(6674),
    [anon_sym_BSLASHAutocite] = ACTIONS(6674),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHVolcite] = ACTIONS(6674),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHavolcite] = ACTIONS(6674),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6674),
    [anon_sym_BSLASHnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHNotecite] = ACTIONS(6674),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6674),
    [anon_sym_BSLASHlabel] = ACTIONS(6674),
    [anon_sym_BSLASHref] = ACTIONS(6674),
    [anon_sym_BSLASHeqref] = ACTIONS(6674),
    [anon_sym_BSLASHvref] = ACTIONS(6674),
    [anon_sym_BSLASHVref] = ACTIONS(6674),
    [anon_sym_BSLASHautoref] = ACTIONS(6674),
    [anon_sym_BSLASHpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcref] = ACTIONS(6674),
    [anon_sym_BSLASHCref] = ACTIONS(6674),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnameCref] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6674),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6674),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6674),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6674),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6674),
    [anon_sym_BSLASHdef] = ACTIONS(6674),
    [anon_sym_BSLASHlet] = ACTIONS(6674),
    [anon_sym_BSLASHleft] = ACTIONS(6674),
    [anon_sym_BSLASHbigl] = ACTIONS(6674),
    [anon_sym_BSLASHBigl] = ACTIONS(6674),
    [anon_sym_BSLASHbiggl] = ACTIONS(6674),
    [anon_sym_BSLASHBiggl] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6674),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6674),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6674),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6674),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6674),
    [anon_sym_BSLASHgls] = ACTIONS(6674),
    [anon_sym_BSLASHGls] = ACTIONS(6674),
    [anon_sym_BSLASHGLS] = ACTIONS(6674),
    [anon_sym_BSLASHglspl] = ACTIONS(6674),
    [anon_sym_BSLASHGlspl] = ACTIONS(6674),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6674),
    [anon_sym_BSLASHglslink] = ACTIONS(6674),
    [anon_sym_BSLASHglstext] = ACTIONS(6674),
    [anon_sym_BSLASHGlstext] = ACTIONS(6674),
    [anon_sym_BSLASHGLStext] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6674),
    [anon_sym_BSLASHglsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6674),
    [anon_sym_BSLASHglsname] = ACTIONS(6674),
    [anon_sym_BSLASHGlsname] = ACTIONS(6674),
    [anon_sym_BSLASHGLSname] = ACTIONS(6674),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6674),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6674),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6674),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6674),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6674),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6674),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6674),
    [anon_sym_BSLASHacrshort] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6674),
    [anon_sym_BSLASHACRshort] = ACTIONS(6674),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrlong] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6674),
    [anon_sym_BSLASHACRlong] = ACTIONS(6674),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6674),
    [anon_sym_BSLASHacrfull] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6674),
    [anon_sym_BSLASHACRfull] = ACTIONS(6674),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHacs] = ACTIONS(6674),
    [anon_sym_BSLASHAcs] = ACTIONS(6674),
    [anon_sym_BSLASHacsp] = ACTIONS(6674),
    [anon_sym_BSLASHAcsp] = ACTIONS(6674),
    [anon_sym_BSLASHacl] = ACTIONS(6674),
    [anon_sym_BSLASHAcl] = ACTIONS(6674),
    [anon_sym_BSLASHaclp] = ACTIONS(6674),
    [anon_sym_BSLASHAclp] = ACTIONS(6674),
    [anon_sym_BSLASHacf] = ACTIONS(6674),
    [anon_sym_BSLASHAcf] = ACTIONS(6674),
    [anon_sym_BSLASHacfp] = ACTIONS(6674),
    [anon_sym_BSLASHAcfp] = ACTIONS(6674),
    [anon_sym_BSLASHac] = ACTIONS(6674),
    [anon_sym_BSLASHAc] = ACTIONS(6674),
    [anon_sym_BSLASHacp] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6674),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6674),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6674),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6674),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6676),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6674),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6674),
    [anon_sym_BSLASHcolor] = ACTIONS(6674),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6674),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6674),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6674),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6674),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6674),
    [anon_sym_BSLASHtext] = ACTIONS(6674),
    [anon_sym_BSLASHintertext] = ACTIONS(6674),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6674),
    [anon_sym_BSLASHurl] = ACTIONS(6674),
    [anon_sym_BSLASHhref] = ACTIONS(6674),
  },
  [1812] = {
    [sym_command_name] = ACTIONS(6678),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6678),
    [anon_sym_LBRACK] = ACTIONS(6680),
    [anon_sym_RBRACK] = ACTIONS(6680),
    [anon_sym_COMMA] = ACTIONS(6680),
    [anon_sym_EQ] = ACTIONS(6680),
    [anon_sym_LPAREN] = ACTIONS(6680),
    [anon_sym_RPAREN] = ACTIONS(6680),
    [anon_sym_LBRACE] = ACTIONS(6680),
    [sym_word] = ACTIONS(6678),
    [sym_placeholder] = ACTIONS(6680),
    [anon_sym_PLUS] = ACTIONS(6680),
    [anon_sym_DASH] = ACTIONS(6680),
    [anon_sym_STAR] = ACTIONS(6680),
    [anon_sym_SLASH] = ACTIONS(6680),
    [anon_sym_LT] = ACTIONS(6678),
    [anon_sym_GT] = ACTIONS(6678),
    [anon_sym_BANG] = ACTIONS(6678),
    [anon_sym_PIPE] = ACTIONS(6678),
    [anon_sym_COLON] = ACTIONS(6678),
    [anon_sym_SQUOTE] = ACTIONS(6678),
    [anon_sym__] = ACTIONS(6680),
    [anon_sym_CARET] = ACTIONS(6680),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6680),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6680),
    [anon_sym_DOLLAR] = ACTIONS(6678),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6680),
    [anon_sym_BSLASHbegin] = ACTIONS(6678),
    [anon_sym_BSLASHtitle] = ACTIONS(6678),
    [anon_sym_BSLASHauthor] = ACTIONS(6678),
    [anon_sym_BSLASHusepackage] = ACTIONS(6678),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6678),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6678),
    [anon_sym_BSLASHinclude] = ACTIONS(6678),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6678),
    [anon_sym_BSLASHinput] = ACTIONS(6678),
    [anon_sym_BSLASHsubfile] = ACTIONS(6678),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6678),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6678),
    [anon_sym_BSLASHbibliography] = ACTIONS(6678),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6678),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6678),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6678),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6678),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6678),
    [anon_sym_BSLASHimport] = ACTIONS(6678),
    [anon_sym_BSLASHsubimport] = ACTIONS(6678),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6678),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6678),
    [anon_sym_BSLASHcaption] = ACTIONS(6678),
    [anon_sym_BSLASHcite] = ACTIONS(6678),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCite] = ACTIONS(6678),
    [anon_sym_BSLASHnocite] = ACTIONS(6678),
    [anon_sym_BSLASHcitet] = ACTIONS(6678),
    [anon_sym_BSLASHcitep] = ACTIONS(6678),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteA] = ACTIONS(6678),
    [anon_sym_BSLASHciteR] = ACTIONS(6678),
    [anon_sym_BSLASHciteS] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6678),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6678),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteyear] = ACTIONS(6678),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHcitedate] = ACTIONS(6678),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHciteurl] = ACTIONS(6678),
    [anon_sym_BSLASHfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6678),
    [anon_sym_BSLASHcitealt] = ACTIONS(6678),
    [anon_sym_BSLASHcitealp] = ACTIONS(6678),
    [anon_sym_BSLASHcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHparencite] = ACTIONS(6678),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHParencite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6678),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6678),
    [anon_sym_BSLASHtextcite] = ACTIONS(6678),
    [anon_sym_BSLASHTextcite] = ACTIONS(6678),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6678),
    [anon_sym_BSLASHsupercite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite] = ACTIONS(6678),
    [anon_sym_BSLASHAutocite] = ACTIONS(6678),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHVolcite] = ACTIONS(6678),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHavolcite] = ACTIONS(6678),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6678),
    [anon_sym_BSLASHnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHNotecite] = ACTIONS(6678),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6678),
    [anon_sym_BSLASHlabel] = ACTIONS(6678),
    [anon_sym_BSLASHref] = ACTIONS(6678),
    [anon_sym_BSLASHeqref] = ACTIONS(6678),
    [anon_sym_BSLASHvref] = ACTIONS(6678),
    [anon_sym_BSLASHVref] = ACTIONS(6678),
    [anon_sym_BSLASHautoref] = ACTIONS(6678),
    [anon_sym_BSLASHpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcref] = ACTIONS(6678),
    [anon_sym_BSLASHCref] = ACTIONS(6678),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnameCref] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6678),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6678),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6678),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6678),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6678),
    [anon_sym_BSLASHdef] = ACTIONS(6678),
    [anon_sym_BSLASHlet] = ACTIONS(6678),
    [anon_sym_BSLASHleft] = ACTIONS(6678),
    [anon_sym_BSLASHbigl] = ACTIONS(6678),
    [anon_sym_BSLASHBigl] = ACTIONS(6678),
    [anon_sym_BSLASHbiggl] = ACTIONS(6678),
    [anon_sym_BSLASHBiggl] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6678),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6678),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6678),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6678),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6678),
    [anon_sym_BSLASHgls] = ACTIONS(6678),
    [anon_sym_BSLASHGls] = ACTIONS(6678),
    [anon_sym_BSLASHGLS] = ACTIONS(6678),
    [anon_sym_BSLASHglspl] = ACTIONS(6678),
    [anon_sym_BSLASHGlspl] = ACTIONS(6678),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6678),
    [anon_sym_BSLASHglslink] = ACTIONS(6678),
    [anon_sym_BSLASHglstext] = ACTIONS(6678),
    [anon_sym_BSLASHGlstext] = ACTIONS(6678),
    [anon_sym_BSLASHGLStext] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6678),
    [anon_sym_BSLASHglsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6678),
    [anon_sym_BSLASHglsname] = ACTIONS(6678),
    [anon_sym_BSLASHGlsname] = ACTIONS(6678),
    [anon_sym_BSLASHGLSname] = ACTIONS(6678),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6678),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6678),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6678),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6678),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6678),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6678),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6678),
    [anon_sym_BSLASHacrshort] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6678),
    [anon_sym_BSLASHACRshort] = ACTIONS(6678),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrlong] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6678),
    [anon_sym_BSLASHACRlong] = ACTIONS(6678),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6678),
    [anon_sym_BSLASHacrfull] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6678),
    [anon_sym_BSLASHACRfull] = ACTIONS(6678),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHacs] = ACTIONS(6678),
    [anon_sym_BSLASHAcs] = ACTIONS(6678),
    [anon_sym_BSLASHacsp] = ACTIONS(6678),
    [anon_sym_BSLASHAcsp] = ACTIONS(6678),
    [anon_sym_BSLASHacl] = ACTIONS(6678),
    [anon_sym_BSLASHAcl] = ACTIONS(6678),
    [anon_sym_BSLASHaclp] = ACTIONS(6678),
    [anon_sym_BSLASHAclp] = ACTIONS(6678),
    [anon_sym_BSLASHacf] = ACTIONS(6678),
    [anon_sym_BSLASHAcf] = ACTIONS(6678),
    [anon_sym_BSLASHacfp] = ACTIONS(6678),
    [anon_sym_BSLASHAcfp] = ACTIONS(6678),
    [anon_sym_BSLASHac] = ACTIONS(6678),
    [anon_sym_BSLASHAc] = ACTIONS(6678),
    [anon_sym_BSLASHacp] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6678),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6678),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6678),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6678),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6680),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6678),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6678),
    [anon_sym_BSLASHcolor] = ACTIONS(6678),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6678),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6678),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6678),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6678),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6678),
    [anon_sym_BSLASHtext] = ACTIONS(6678),
    [anon_sym_BSLASHintertext] = ACTIONS(6678),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6678),
    [anon_sym_BSLASHurl] = ACTIONS(6678),
    [anon_sym_BSLASHhref] = ACTIONS(6678),
  },
  [1813] = {
    [sym_command_name] = ACTIONS(6682),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6682),
    [anon_sym_LBRACK] = ACTIONS(6684),
    [anon_sym_RBRACK] = ACTIONS(6684),
    [anon_sym_COMMA] = ACTIONS(6684),
    [anon_sym_EQ] = ACTIONS(6684),
    [anon_sym_LPAREN] = ACTIONS(6684),
    [anon_sym_RPAREN] = ACTIONS(6684),
    [anon_sym_LBRACE] = ACTIONS(6684),
    [sym_word] = ACTIONS(6682),
    [sym_placeholder] = ACTIONS(6684),
    [anon_sym_PLUS] = ACTIONS(6684),
    [anon_sym_DASH] = ACTIONS(6684),
    [anon_sym_STAR] = ACTIONS(6684),
    [anon_sym_SLASH] = ACTIONS(6684),
    [anon_sym_LT] = ACTIONS(6682),
    [anon_sym_GT] = ACTIONS(6682),
    [anon_sym_BANG] = ACTIONS(6682),
    [anon_sym_PIPE] = ACTIONS(6682),
    [anon_sym_COLON] = ACTIONS(6682),
    [anon_sym_SQUOTE] = ACTIONS(6682),
    [anon_sym__] = ACTIONS(6684),
    [anon_sym_CARET] = ACTIONS(6684),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6684),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6684),
    [anon_sym_DOLLAR] = ACTIONS(6682),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6684),
    [anon_sym_BSLASHbegin] = ACTIONS(6682),
    [anon_sym_BSLASHtitle] = ACTIONS(6682),
    [anon_sym_BSLASHauthor] = ACTIONS(6682),
    [anon_sym_BSLASHusepackage] = ACTIONS(6682),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6682),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6682),
    [anon_sym_BSLASHinclude] = ACTIONS(6682),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6682),
    [anon_sym_BSLASHinput] = ACTIONS(6682),
    [anon_sym_BSLASHsubfile] = ACTIONS(6682),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6682),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6682),
    [anon_sym_BSLASHbibliography] = ACTIONS(6682),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6682),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6682),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6682),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6682),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6682),
    [anon_sym_BSLASHimport] = ACTIONS(6682),
    [anon_sym_BSLASHsubimport] = ACTIONS(6682),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6682),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6682),
    [anon_sym_BSLASHcaption] = ACTIONS(6682),
    [anon_sym_BSLASHcite] = ACTIONS(6682),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCite] = ACTIONS(6682),
    [anon_sym_BSLASHnocite] = ACTIONS(6682),
    [anon_sym_BSLASHcitet] = ACTIONS(6682),
    [anon_sym_BSLASHcitep] = ACTIONS(6682),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteA] = ACTIONS(6682),
    [anon_sym_BSLASHciteR] = ACTIONS(6682),
    [anon_sym_BSLASHciteS] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6682),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6682),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteyear] = ACTIONS(6682),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHcitedate] = ACTIONS(6682),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHciteurl] = ACTIONS(6682),
    [anon_sym_BSLASHfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6682),
    [anon_sym_BSLASHcitealt] = ACTIONS(6682),
    [anon_sym_BSLASHcitealp] = ACTIONS(6682),
    [anon_sym_BSLASHcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHparencite] = ACTIONS(6682),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHParencite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6682),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6682),
    [anon_sym_BSLASHtextcite] = ACTIONS(6682),
    [anon_sym_BSLASHTextcite] = ACTIONS(6682),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6682),
    [anon_sym_BSLASHsupercite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite] = ACTIONS(6682),
    [anon_sym_BSLASHAutocite] = ACTIONS(6682),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHVolcite] = ACTIONS(6682),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHavolcite] = ACTIONS(6682),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6682),
    [anon_sym_BSLASHnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHNotecite] = ACTIONS(6682),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6682),
    [anon_sym_BSLASHlabel] = ACTIONS(6682),
    [anon_sym_BSLASHref] = ACTIONS(6682),
    [anon_sym_BSLASHeqref] = ACTIONS(6682),
    [anon_sym_BSLASHvref] = ACTIONS(6682),
    [anon_sym_BSLASHVref] = ACTIONS(6682),
    [anon_sym_BSLASHautoref] = ACTIONS(6682),
    [anon_sym_BSLASHpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcref] = ACTIONS(6682),
    [anon_sym_BSLASHCref] = ACTIONS(6682),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnameCref] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6682),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6682),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6682),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6682),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6682),
    [anon_sym_BSLASHdef] = ACTIONS(6682),
    [anon_sym_BSLASHlet] = ACTIONS(6682),
    [anon_sym_BSLASHleft] = ACTIONS(6682),
    [anon_sym_BSLASHbigl] = ACTIONS(6682),
    [anon_sym_BSLASHBigl] = ACTIONS(6682),
    [anon_sym_BSLASHbiggl] = ACTIONS(6682),
    [anon_sym_BSLASHBiggl] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6682),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6682),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6682),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6682),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6682),
    [anon_sym_BSLASHgls] = ACTIONS(6682),
    [anon_sym_BSLASHGls] = ACTIONS(6682),
    [anon_sym_BSLASHGLS] = ACTIONS(6682),
    [anon_sym_BSLASHglspl] = ACTIONS(6682),
    [anon_sym_BSLASHGlspl] = ACTIONS(6682),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6682),
    [anon_sym_BSLASHglslink] = ACTIONS(6682),
    [anon_sym_BSLASHglstext] = ACTIONS(6682),
    [anon_sym_BSLASHGlstext] = ACTIONS(6682),
    [anon_sym_BSLASHGLStext] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6682),
    [anon_sym_BSLASHglsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6682),
    [anon_sym_BSLASHglsname] = ACTIONS(6682),
    [anon_sym_BSLASHGlsname] = ACTIONS(6682),
    [anon_sym_BSLASHGLSname] = ACTIONS(6682),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6682),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6682),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6682),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6682),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6682),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6682),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6682),
    [anon_sym_BSLASHacrshort] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6682),
    [anon_sym_BSLASHACRshort] = ACTIONS(6682),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrlong] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6682),
    [anon_sym_BSLASHACRlong] = ACTIONS(6682),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6682),
    [anon_sym_BSLASHacrfull] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6682),
    [anon_sym_BSLASHACRfull] = ACTIONS(6682),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHacs] = ACTIONS(6682),
    [anon_sym_BSLASHAcs] = ACTIONS(6682),
    [anon_sym_BSLASHacsp] = ACTIONS(6682),
    [anon_sym_BSLASHAcsp] = ACTIONS(6682),
    [anon_sym_BSLASHacl] = ACTIONS(6682),
    [anon_sym_BSLASHAcl] = ACTIONS(6682),
    [anon_sym_BSLASHaclp] = ACTIONS(6682),
    [anon_sym_BSLASHAclp] = ACTIONS(6682),
    [anon_sym_BSLASHacf] = ACTIONS(6682),
    [anon_sym_BSLASHAcf] = ACTIONS(6682),
    [anon_sym_BSLASHacfp] = ACTIONS(6682),
    [anon_sym_BSLASHAcfp] = ACTIONS(6682),
    [anon_sym_BSLASHac] = ACTIONS(6682),
    [anon_sym_BSLASHAc] = ACTIONS(6682),
    [anon_sym_BSLASHacp] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6682),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6682),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6682),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6682),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6684),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6682),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6682),
    [anon_sym_BSLASHcolor] = ACTIONS(6682),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6682),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6682),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6682),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6682),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6682),
    [anon_sym_BSLASHtext] = ACTIONS(6682),
    [anon_sym_BSLASHintertext] = ACTIONS(6682),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6682),
    [anon_sym_BSLASHurl] = ACTIONS(6682),
    [anon_sym_BSLASHhref] = ACTIONS(6682),
  },
  [1814] = {
    [sym_command_name] = ACTIONS(6710),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6710),
    [anon_sym_LBRACK] = ACTIONS(6712),
    [anon_sym_RBRACK] = ACTIONS(6712),
    [anon_sym_COMMA] = ACTIONS(6712),
    [anon_sym_EQ] = ACTIONS(6712),
    [anon_sym_LPAREN] = ACTIONS(6712),
    [anon_sym_RPAREN] = ACTIONS(6712),
    [anon_sym_LBRACE] = ACTIONS(6712),
    [sym_word] = ACTIONS(6710),
    [sym_placeholder] = ACTIONS(6712),
    [anon_sym_PLUS] = ACTIONS(6712),
    [anon_sym_DASH] = ACTIONS(6712),
    [anon_sym_STAR] = ACTIONS(6712),
    [anon_sym_SLASH] = ACTIONS(6712),
    [anon_sym_LT] = ACTIONS(6710),
    [anon_sym_GT] = ACTIONS(6710),
    [anon_sym_BANG] = ACTIONS(6710),
    [anon_sym_PIPE] = ACTIONS(6710),
    [anon_sym_COLON] = ACTIONS(6710),
    [anon_sym_SQUOTE] = ACTIONS(6710),
    [anon_sym__] = ACTIONS(6712),
    [anon_sym_CARET] = ACTIONS(6712),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6712),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6712),
    [anon_sym_DOLLAR] = ACTIONS(6710),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6712),
    [anon_sym_BSLASHbegin] = ACTIONS(6710),
    [anon_sym_BSLASHtitle] = ACTIONS(6710),
    [anon_sym_BSLASHauthor] = ACTIONS(6710),
    [anon_sym_BSLASHusepackage] = ACTIONS(6710),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6710),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6710),
    [anon_sym_BSLASHinclude] = ACTIONS(6710),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6710),
    [anon_sym_BSLASHinput] = ACTIONS(6710),
    [anon_sym_BSLASHsubfile] = ACTIONS(6710),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6710),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6710),
    [anon_sym_BSLASHbibliography] = ACTIONS(6710),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6710),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6710),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6710),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6710),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6710),
    [anon_sym_BSLASHimport] = ACTIONS(6710),
    [anon_sym_BSLASHsubimport] = ACTIONS(6710),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6710),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6710),
    [anon_sym_BSLASHcaption] = ACTIONS(6710),
    [anon_sym_BSLASHcite] = ACTIONS(6710),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCite] = ACTIONS(6710),
    [anon_sym_BSLASHnocite] = ACTIONS(6710),
    [anon_sym_BSLASHcitet] = ACTIONS(6710),
    [anon_sym_BSLASHcitep] = ACTIONS(6710),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteA] = ACTIONS(6710),
    [anon_sym_BSLASHciteR] = ACTIONS(6710),
    [anon_sym_BSLASHciteS] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6710),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6710),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteyear] = ACTIONS(6710),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHcitedate] = ACTIONS(6710),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHciteurl] = ACTIONS(6710),
    [anon_sym_BSLASHfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6710),
    [anon_sym_BSLASHcitealt] = ACTIONS(6710),
    [anon_sym_BSLASHcitealp] = ACTIONS(6710),
    [anon_sym_BSLASHcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHparencite] = ACTIONS(6710),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHParencite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6710),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6710),
    [anon_sym_BSLASHtextcite] = ACTIONS(6710),
    [anon_sym_BSLASHTextcite] = ACTIONS(6710),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6710),
    [anon_sym_BSLASHsupercite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite] = ACTIONS(6710),
    [anon_sym_BSLASHAutocite] = ACTIONS(6710),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHVolcite] = ACTIONS(6710),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHavolcite] = ACTIONS(6710),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6710),
    [anon_sym_BSLASHnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHNotecite] = ACTIONS(6710),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6710),
    [anon_sym_BSLASHlabel] = ACTIONS(6710),
    [anon_sym_BSLASHref] = ACTIONS(6710),
    [anon_sym_BSLASHeqref] = ACTIONS(6710),
    [anon_sym_BSLASHvref] = ACTIONS(6710),
    [anon_sym_BSLASHVref] = ACTIONS(6710),
    [anon_sym_BSLASHautoref] = ACTIONS(6710),
    [anon_sym_BSLASHpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcref] = ACTIONS(6710),
    [anon_sym_BSLASHCref] = ACTIONS(6710),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnameCref] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6710),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6710),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6710),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6710),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6710),
    [anon_sym_BSLASHdef] = ACTIONS(6710),
    [anon_sym_BSLASHlet] = ACTIONS(6710),
    [anon_sym_BSLASHleft] = ACTIONS(6710),
    [anon_sym_BSLASHbigl] = ACTIONS(6710),
    [anon_sym_BSLASHBigl] = ACTIONS(6710),
    [anon_sym_BSLASHbiggl] = ACTIONS(6710),
    [anon_sym_BSLASHBiggl] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6710),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6710),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6710),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6710),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6710),
    [anon_sym_BSLASHgls] = ACTIONS(6710),
    [anon_sym_BSLASHGls] = ACTIONS(6710),
    [anon_sym_BSLASHGLS] = ACTIONS(6710),
    [anon_sym_BSLASHglspl] = ACTIONS(6710),
    [anon_sym_BSLASHGlspl] = ACTIONS(6710),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6710),
    [anon_sym_BSLASHglslink] = ACTIONS(6710),
    [anon_sym_BSLASHglstext] = ACTIONS(6710),
    [anon_sym_BSLASHGlstext] = ACTIONS(6710),
    [anon_sym_BSLASHGLStext] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6710),
    [anon_sym_BSLASHglsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6710),
    [anon_sym_BSLASHglsname] = ACTIONS(6710),
    [anon_sym_BSLASHGlsname] = ACTIONS(6710),
    [anon_sym_BSLASHGLSname] = ACTIONS(6710),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6710),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6710),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6710),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6710),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6710),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6710),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6710),
    [anon_sym_BSLASHacrshort] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6710),
    [anon_sym_BSLASHACRshort] = ACTIONS(6710),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrlong] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6710),
    [anon_sym_BSLASHACRlong] = ACTIONS(6710),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6710),
    [anon_sym_BSLASHacrfull] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6710),
    [anon_sym_BSLASHACRfull] = ACTIONS(6710),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHacs] = ACTIONS(6710),
    [anon_sym_BSLASHAcs] = ACTIONS(6710),
    [anon_sym_BSLASHacsp] = ACTIONS(6710),
    [anon_sym_BSLASHAcsp] = ACTIONS(6710),
    [anon_sym_BSLASHacl] = ACTIONS(6710),
    [anon_sym_BSLASHAcl] = ACTIONS(6710),
    [anon_sym_BSLASHaclp] = ACTIONS(6710),
    [anon_sym_BSLASHAclp] = ACTIONS(6710),
    [anon_sym_BSLASHacf] = ACTIONS(6710),
    [anon_sym_BSLASHAcf] = ACTIONS(6710),
    [anon_sym_BSLASHacfp] = ACTIONS(6710),
    [anon_sym_BSLASHAcfp] = ACTIONS(6710),
    [anon_sym_BSLASHac] = ACTIONS(6710),
    [anon_sym_BSLASHAc] = ACTIONS(6710),
    [anon_sym_BSLASHacp] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6710),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6710),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6710),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6710),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6712),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6710),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6710),
    [anon_sym_BSLASHcolor] = ACTIONS(6710),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6710),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6710),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6710),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6710),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6710),
    [anon_sym_BSLASHtext] = ACTIONS(6710),
    [anon_sym_BSLASHintertext] = ACTIONS(6710),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6710),
    [anon_sym_BSLASHurl] = ACTIONS(6710),
    [anon_sym_BSLASHhref] = ACTIONS(6710),
  },
  [1815] = {
    [sym_command_name] = ACTIONS(6714),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6714),
    [anon_sym_LBRACK] = ACTIONS(6716),
    [anon_sym_RBRACK] = ACTIONS(6716),
    [anon_sym_COMMA] = ACTIONS(6716),
    [anon_sym_EQ] = ACTIONS(6716),
    [anon_sym_LPAREN] = ACTIONS(6716),
    [anon_sym_RPAREN] = ACTIONS(6716),
    [anon_sym_LBRACE] = ACTIONS(6716),
    [sym_word] = ACTIONS(6714),
    [sym_placeholder] = ACTIONS(6716),
    [anon_sym_PLUS] = ACTIONS(6716),
    [anon_sym_DASH] = ACTIONS(6716),
    [anon_sym_STAR] = ACTIONS(6716),
    [anon_sym_SLASH] = ACTIONS(6716),
    [anon_sym_LT] = ACTIONS(6714),
    [anon_sym_GT] = ACTIONS(6714),
    [anon_sym_BANG] = ACTIONS(6714),
    [anon_sym_PIPE] = ACTIONS(6714),
    [anon_sym_COLON] = ACTIONS(6714),
    [anon_sym_SQUOTE] = ACTIONS(6714),
    [anon_sym__] = ACTIONS(6716),
    [anon_sym_CARET] = ACTIONS(6716),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6716),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6716),
    [anon_sym_DOLLAR] = ACTIONS(6714),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6716),
    [anon_sym_BSLASHbegin] = ACTIONS(6714),
    [anon_sym_BSLASHtitle] = ACTIONS(6714),
    [anon_sym_BSLASHauthor] = ACTIONS(6714),
    [anon_sym_BSLASHusepackage] = ACTIONS(6714),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6714),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6714),
    [anon_sym_BSLASHinclude] = ACTIONS(6714),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6714),
    [anon_sym_BSLASHinput] = ACTIONS(6714),
    [anon_sym_BSLASHsubfile] = ACTIONS(6714),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6714),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6714),
    [anon_sym_BSLASHbibliography] = ACTIONS(6714),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6714),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6714),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6714),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6714),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6714),
    [anon_sym_BSLASHimport] = ACTIONS(6714),
    [anon_sym_BSLASHsubimport] = ACTIONS(6714),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6714),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6714),
    [anon_sym_BSLASHcaption] = ACTIONS(6714),
    [anon_sym_BSLASHcite] = ACTIONS(6714),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCite] = ACTIONS(6714),
    [anon_sym_BSLASHnocite] = ACTIONS(6714),
    [anon_sym_BSLASHcitet] = ACTIONS(6714),
    [anon_sym_BSLASHcitep] = ACTIONS(6714),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteA] = ACTIONS(6714),
    [anon_sym_BSLASHciteR] = ACTIONS(6714),
    [anon_sym_BSLASHciteS] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6714),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6714),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteyear] = ACTIONS(6714),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHcitedate] = ACTIONS(6714),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHciteurl] = ACTIONS(6714),
    [anon_sym_BSLASHfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6714),
    [anon_sym_BSLASHcitealt] = ACTIONS(6714),
    [anon_sym_BSLASHcitealp] = ACTIONS(6714),
    [anon_sym_BSLASHcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHparencite] = ACTIONS(6714),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHParencite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6714),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6714),
    [anon_sym_BSLASHtextcite] = ACTIONS(6714),
    [anon_sym_BSLASHTextcite] = ACTIONS(6714),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6714),
    [anon_sym_BSLASHsupercite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite] = ACTIONS(6714),
    [anon_sym_BSLASHAutocite] = ACTIONS(6714),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHVolcite] = ACTIONS(6714),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHavolcite] = ACTIONS(6714),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6714),
    [anon_sym_BSLASHnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHNotecite] = ACTIONS(6714),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6714),
    [anon_sym_BSLASHlabel] = ACTIONS(6714),
    [anon_sym_BSLASHref] = ACTIONS(6714),
    [anon_sym_BSLASHeqref] = ACTIONS(6714),
    [anon_sym_BSLASHvref] = ACTIONS(6714),
    [anon_sym_BSLASHVref] = ACTIONS(6714),
    [anon_sym_BSLASHautoref] = ACTIONS(6714),
    [anon_sym_BSLASHpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcref] = ACTIONS(6714),
    [anon_sym_BSLASHCref] = ACTIONS(6714),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnameCref] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6714),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6714),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6714),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6714),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6714),
    [anon_sym_BSLASHdef] = ACTIONS(6714),
    [anon_sym_BSLASHlet] = ACTIONS(6714),
    [anon_sym_BSLASHleft] = ACTIONS(6714),
    [anon_sym_BSLASHbigl] = ACTIONS(6714),
    [anon_sym_BSLASHBigl] = ACTIONS(6714),
    [anon_sym_BSLASHbiggl] = ACTIONS(6714),
    [anon_sym_BSLASHBiggl] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6714),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6714),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6714),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6714),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6714),
    [anon_sym_BSLASHgls] = ACTIONS(6714),
    [anon_sym_BSLASHGls] = ACTIONS(6714),
    [anon_sym_BSLASHGLS] = ACTIONS(6714),
    [anon_sym_BSLASHglspl] = ACTIONS(6714),
    [anon_sym_BSLASHGlspl] = ACTIONS(6714),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6714),
    [anon_sym_BSLASHglslink] = ACTIONS(6714),
    [anon_sym_BSLASHglstext] = ACTIONS(6714),
    [anon_sym_BSLASHGlstext] = ACTIONS(6714),
    [anon_sym_BSLASHGLStext] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6714),
    [anon_sym_BSLASHglsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6714),
    [anon_sym_BSLASHglsname] = ACTIONS(6714),
    [anon_sym_BSLASHGlsname] = ACTIONS(6714),
    [anon_sym_BSLASHGLSname] = ACTIONS(6714),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6714),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6714),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6714),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6714),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6714),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6714),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6714),
    [anon_sym_BSLASHacrshort] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6714),
    [anon_sym_BSLASHACRshort] = ACTIONS(6714),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrlong] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6714),
    [anon_sym_BSLASHACRlong] = ACTIONS(6714),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6714),
    [anon_sym_BSLASHacrfull] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6714),
    [anon_sym_BSLASHACRfull] = ACTIONS(6714),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHacs] = ACTIONS(6714),
    [anon_sym_BSLASHAcs] = ACTIONS(6714),
    [anon_sym_BSLASHacsp] = ACTIONS(6714),
    [anon_sym_BSLASHAcsp] = ACTIONS(6714),
    [anon_sym_BSLASHacl] = ACTIONS(6714),
    [anon_sym_BSLASHAcl] = ACTIONS(6714),
    [anon_sym_BSLASHaclp] = ACTIONS(6714),
    [anon_sym_BSLASHAclp] = ACTIONS(6714),
    [anon_sym_BSLASHacf] = ACTIONS(6714),
    [anon_sym_BSLASHAcf] = ACTIONS(6714),
    [anon_sym_BSLASHacfp] = ACTIONS(6714),
    [anon_sym_BSLASHAcfp] = ACTIONS(6714),
    [anon_sym_BSLASHac] = ACTIONS(6714),
    [anon_sym_BSLASHAc] = ACTIONS(6714),
    [anon_sym_BSLASHacp] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6714),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6714),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6714),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6714),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6716),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6714),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6714),
    [anon_sym_BSLASHcolor] = ACTIONS(6714),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6714),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6714),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6714),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6714),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6714),
    [anon_sym_BSLASHtext] = ACTIONS(6714),
    [anon_sym_BSLASHintertext] = ACTIONS(6714),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6714),
    [anon_sym_BSLASHurl] = ACTIONS(6714),
    [anon_sym_BSLASHhref] = ACTIONS(6714),
  },
  [1816] = {
    [sym_command_name] = ACTIONS(6718),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6718),
    [anon_sym_LBRACK] = ACTIONS(6720),
    [anon_sym_RBRACK] = ACTIONS(6720),
    [anon_sym_COMMA] = ACTIONS(6720),
    [anon_sym_EQ] = ACTIONS(6720),
    [anon_sym_LPAREN] = ACTIONS(6720),
    [anon_sym_RPAREN] = ACTIONS(6720),
    [anon_sym_LBRACE] = ACTIONS(6720),
    [sym_word] = ACTIONS(6718),
    [sym_placeholder] = ACTIONS(6720),
    [anon_sym_PLUS] = ACTIONS(6720),
    [anon_sym_DASH] = ACTIONS(6720),
    [anon_sym_STAR] = ACTIONS(6720),
    [anon_sym_SLASH] = ACTIONS(6720),
    [anon_sym_LT] = ACTIONS(6718),
    [anon_sym_GT] = ACTIONS(6718),
    [anon_sym_BANG] = ACTIONS(6718),
    [anon_sym_PIPE] = ACTIONS(6718),
    [anon_sym_COLON] = ACTIONS(6718),
    [anon_sym_SQUOTE] = ACTIONS(6718),
    [anon_sym__] = ACTIONS(6720),
    [anon_sym_CARET] = ACTIONS(6720),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6720),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6720),
    [anon_sym_DOLLAR] = ACTIONS(6718),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6720),
    [anon_sym_BSLASHbegin] = ACTIONS(6718),
    [anon_sym_BSLASHtitle] = ACTIONS(6718),
    [anon_sym_BSLASHauthor] = ACTIONS(6718),
    [anon_sym_BSLASHusepackage] = ACTIONS(6718),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6718),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6718),
    [anon_sym_BSLASHinclude] = ACTIONS(6718),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6718),
    [anon_sym_BSLASHinput] = ACTIONS(6718),
    [anon_sym_BSLASHsubfile] = ACTIONS(6718),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6718),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6718),
    [anon_sym_BSLASHbibliography] = ACTIONS(6718),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6718),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6718),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6718),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6718),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6718),
    [anon_sym_BSLASHimport] = ACTIONS(6718),
    [anon_sym_BSLASHsubimport] = ACTIONS(6718),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6718),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6718),
    [anon_sym_BSLASHcaption] = ACTIONS(6718),
    [anon_sym_BSLASHcite] = ACTIONS(6718),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCite] = ACTIONS(6718),
    [anon_sym_BSLASHnocite] = ACTIONS(6718),
    [anon_sym_BSLASHcitet] = ACTIONS(6718),
    [anon_sym_BSLASHcitep] = ACTIONS(6718),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteA] = ACTIONS(6718),
    [anon_sym_BSLASHciteR] = ACTIONS(6718),
    [anon_sym_BSLASHciteS] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6718),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6718),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteyear] = ACTIONS(6718),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHcitedate] = ACTIONS(6718),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHciteurl] = ACTIONS(6718),
    [anon_sym_BSLASHfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6718),
    [anon_sym_BSLASHcitealt] = ACTIONS(6718),
    [anon_sym_BSLASHcitealp] = ACTIONS(6718),
    [anon_sym_BSLASHcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHparencite] = ACTIONS(6718),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHParencite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6718),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6718),
    [anon_sym_BSLASHtextcite] = ACTIONS(6718),
    [anon_sym_BSLASHTextcite] = ACTIONS(6718),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6718),
    [anon_sym_BSLASHsupercite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite] = ACTIONS(6718),
    [anon_sym_BSLASHAutocite] = ACTIONS(6718),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHVolcite] = ACTIONS(6718),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHavolcite] = ACTIONS(6718),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6718),
    [anon_sym_BSLASHnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHNotecite] = ACTIONS(6718),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6718),
    [anon_sym_BSLASHlabel] = ACTIONS(6718),
    [anon_sym_BSLASHref] = ACTIONS(6718),
    [anon_sym_BSLASHeqref] = ACTIONS(6718),
    [anon_sym_BSLASHvref] = ACTIONS(6718),
    [anon_sym_BSLASHVref] = ACTIONS(6718),
    [anon_sym_BSLASHautoref] = ACTIONS(6718),
    [anon_sym_BSLASHpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcref] = ACTIONS(6718),
    [anon_sym_BSLASHCref] = ACTIONS(6718),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnameCref] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6718),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6718),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6718),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6718),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6718),
    [anon_sym_BSLASHdef] = ACTIONS(6718),
    [anon_sym_BSLASHlet] = ACTIONS(6718),
    [anon_sym_BSLASHleft] = ACTIONS(6718),
    [anon_sym_BSLASHbigl] = ACTIONS(6718),
    [anon_sym_BSLASHBigl] = ACTIONS(6718),
    [anon_sym_BSLASHbiggl] = ACTIONS(6718),
    [anon_sym_BSLASHBiggl] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6718),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6718),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6718),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6718),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6718),
    [anon_sym_BSLASHgls] = ACTIONS(6718),
    [anon_sym_BSLASHGls] = ACTIONS(6718),
    [anon_sym_BSLASHGLS] = ACTIONS(6718),
    [anon_sym_BSLASHglspl] = ACTIONS(6718),
    [anon_sym_BSLASHGlspl] = ACTIONS(6718),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6718),
    [anon_sym_BSLASHglslink] = ACTIONS(6718),
    [anon_sym_BSLASHglstext] = ACTIONS(6718),
    [anon_sym_BSLASHGlstext] = ACTIONS(6718),
    [anon_sym_BSLASHGLStext] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6718),
    [anon_sym_BSLASHglsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6718),
    [anon_sym_BSLASHglsname] = ACTIONS(6718),
    [anon_sym_BSLASHGlsname] = ACTIONS(6718),
    [anon_sym_BSLASHGLSname] = ACTIONS(6718),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6718),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6718),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6718),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6718),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6718),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6718),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6718),
    [anon_sym_BSLASHacrshort] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6718),
    [anon_sym_BSLASHACRshort] = ACTIONS(6718),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrlong] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6718),
    [anon_sym_BSLASHACRlong] = ACTIONS(6718),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6718),
    [anon_sym_BSLASHacrfull] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6718),
    [anon_sym_BSLASHACRfull] = ACTIONS(6718),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHacs] = ACTIONS(6718),
    [anon_sym_BSLASHAcs] = ACTIONS(6718),
    [anon_sym_BSLASHacsp] = ACTIONS(6718),
    [anon_sym_BSLASHAcsp] = ACTIONS(6718),
    [anon_sym_BSLASHacl] = ACTIONS(6718),
    [anon_sym_BSLASHAcl] = ACTIONS(6718),
    [anon_sym_BSLASHaclp] = ACTIONS(6718),
    [anon_sym_BSLASHAclp] = ACTIONS(6718),
    [anon_sym_BSLASHacf] = ACTIONS(6718),
    [anon_sym_BSLASHAcf] = ACTIONS(6718),
    [anon_sym_BSLASHacfp] = ACTIONS(6718),
    [anon_sym_BSLASHAcfp] = ACTIONS(6718),
    [anon_sym_BSLASHac] = ACTIONS(6718),
    [anon_sym_BSLASHAc] = ACTIONS(6718),
    [anon_sym_BSLASHacp] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6718),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6718),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6718),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6718),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6720),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6718),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6718),
    [anon_sym_BSLASHcolor] = ACTIONS(6718),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6718),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6718),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6718),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6718),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6718),
    [anon_sym_BSLASHtext] = ACTIONS(6718),
    [anon_sym_BSLASHintertext] = ACTIONS(6718),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6718),
    [anon_sym_BSLASHurl] = ACTIONS(6718),
    [anon_sym_BSLASHhref] = ACTIONS(6718),
  },
  [1817] = {
    [sym_command_name] = ACTIONS(6722),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6722),
    [anon_sym_LBRACK] = ACTIONS(6724),
    [anon_sym_RBRACK] = ACTIONS(6724),
    [anon_sym_COMMA] = ACTIONS(6724),
    [anon_sym_EQ] = ACTIONS(6724),
    [anon_sym_LPAREN] = ACTIONS(6724),
    [anon_sym_RPAREN] = ACTIONS(6724),
    [anon_sym_LBRACE] = ACTIONS(6724),
    [sym_word] = ACTIONS(6722),
    [sym_placeholder] = ACTIONS(6724),
    [anon_sym_PLUS] = ACTIONS(6724),
    [anon_sym_DASH] = ACTIONS(6724),
    [anon_sym_STAR] = ACTIONS(6724),
    [anon_sym_SLASH] = ACTIONS(6724),
    [anon_sym_LT] = ACTIONS(6722),
    [anon_sym_GT] = ACTIONS(6722),
    [anon_sym_BANG] = ACTIONS(6722),
    [anon_sym_PIPE] = ACTIONS(6722),
    [anon_sym_COLON] = ACTIONS(6722),
    [anon_sym_SQUOTE] = ACTIONS(6722),
    [anon_sym__] = ACTIONS(6724),
    [anon_sym_CARET] = ACTIONS(6724),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6724),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6724),
    [anon_sym_DOLLAR] = ACTIONS(6722),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6724),
    [anon_sym_BSLASHbegin] = ACTIONS(6722),
    [anon_sym_BSLASHtitle] = ACTIONS(6722),
    [anon_sym_BSLASHauthor] = ACTIONS(6722),
    [anon_sym_BSLASHusepackage] = ACTIONS(6722),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6722),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6722),
    [anon_sym_BSLASHinclude] = ACTIONS(6722),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6722),
    [anon_sym_BSLASHinput] = ACTIONS(6722),
    [anon_sym_BSLASHsubfile] = ACTIONS(6722),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6722),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6722),
    [anon_sym_BSLASHbibliography] = ACTIONS(6722),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6722),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6722),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6722),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6722),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6722),
    [anon_sym_BSLASHimport] = ACTIONS(6722),
    [anon_sym_BSLASHsubimport] = ACTIONS(6722),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6722),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6722),
    [anon_sym_BSLASHcaption] = ACTIONS(6722),
    [anon_sym_BSLASHcite] = ACTIONS(6722),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCite] = ACTIONS(6722),
    [anon_sym_BSLASHnocite] = ACTIONS(6722),
    [anon_sym_BSLASHcitet] = ACTIONS(6722),
    [anon_sym_BSLASHcitep] = ACTIONS(6722),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteA] = ACTIONS(6722),
    [anon_sym_BSLASHciteR] = ACTIONS(6722),
    [anon_sym_BSLASHciteS] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6722),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6722),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteyear] = ACTIONS(6722),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHcitedate] = ACTIONS(6722),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHciteurl] = ACTIONS(6722),
    [anon_sym_BSLASHfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6722),
    [anon_sym_BSLASHcitealt] = ACTIONS(6722),
    [anon_sym_BSLASHcitealp] = ACTIONS(6722),
    [anon_sym_BSLASHcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHparencite] = ACTIONS(6722),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHParencite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6722),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6722),
    [anon_sym_BSLASHtextcite] = ACTIONS(6722),
    [anon_sym_BSLASHTextcite] = ACTIONS(6722),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6722),
    [anon_sym_BSLASHsupercite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite] = ACTIONS(6722),
    [anon_sym_BSLASHAutocite] = ACTIONS(6722),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHVolcite] = ACTIONS(6722),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHavolcite] = ACTIONS(6722),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6722),
    [anon_sym_BSLASHnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHNotecite] = ACTIONS(6722),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6722),
    [anon_sym_BSLASHlabel] = ACTIONS(6722),
    [anon_sym_BSLASHref] = ACTIONS(6722),
    [anon_sym_BSLASHeqref] = ACTIONS(6722),
    [anon_sym_BSLASHvref] = ACTIONS(6722),
    [anon_sym_BSLASHVref] = ACTIONS(6722),
    [anon_sym_BSLASHautoref] = ACTIONS(6722),
    [anon_sym_BSLASHpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcref] = ACTIONS(6722),
    [anon_sym_BSLASHCref] = ACTIONS(6722),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnameCref] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6722),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6722),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6722),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6722),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6722),
    [anon_sym_BSLASHdef] = ACTIONS(6722),
    [anon_sym_BSLASHlet] = ACTIONS(6722),
    [anon_sym_BSLASHleft] = ACTIONS(6722),
    [anon_sym_BSLASHbigl] = ACTIONS(6722),
    [anon_sym_BSLASHBigl] = ACTIONS(6722),
    [anon_sym_BSLASHbiggl] = ACTIONS(6722),
    [anon_sym_BSLASHBiggl] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6722),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6722),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6722),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6722),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6722),
    [anon_sym_BSLASHgls] = ACTIONS(6722),
    [anon_sym_BSLASHGls] = ACTIONS(6722),
    [anon_sym_BSLASHGLS] = ACTIONS(6722),
    [anon_sym_BSLASHglspl] = ACTIONS(6722),
    [anon_sym_BSLASHGlspl] = ACTIONS(6722),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6722),
    [anon_sym_BSLASHglslink] = ACTIONS(6722),
    [anon_sym_BSLASHglstext] = ACTIONS(6722),
    [anon_sym_BSLASHGlstext] = ACTIONS(6722),
    [anon_sym_BSLASHGLStext] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6722),
    [anon_sym_BSLASHglsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6722),
    [anon_sym_BSLASHglsname] = ACTIONS(6722),
    [anon_sym_BSLASHGlsname] = ACTIONS(6722),
    [anon_sym_BSLASHGLSname] = ACTIONS(6722),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6722),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6722),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6722),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6722),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6722),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6722),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6722),
    [anon_sym_BSLASHacrshort] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6722),
    [anon_sym_BSLASHACRshort] = ACTIONS(6722),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrlong] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6722),
    [anon_sym_BSLASHACRlong] = ACTIONS(6722),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6722),
    [anon_sym_BSLASHacrfull] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6722),
    [anon_sym_BSLASHACRfull] = ACTIONS(6722),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHacs] = ACTIONS(6722),
    [anon_sym_BSLASHAcs] = ACTIONS(6722),
    [anon_sym_BSLASHacsp] = ACTIONS(6722),
    [anon_sym_BSLASHAcsp] = ACTIONS(6722),
    [anon_sym_BSLASHacl] = ACTIONS(6722),
    [anon_sym_BSLASHAcl] = ACTIONS(6722),
    [anon_sym_BSLASHaclp] = ACTIONS(6722),
    [anon_sym_BSLASHAclp] = ACTIONS(6722),
    [anon_sym_BSLASHacf] = ACTIONS(6722),
    [anon_sym_BSLASHAcf] = ACTIONS(6722),
    [anon_sym_BSLASHacfp] = ACTIONS(6722),
    [anon_sym_BSLASHAcfp] = ACTIONS(6722),
    [anon_sym_BSLASHac] = ACTIONS(6722),
    [anon_sym_BSLASHAc] = ACTIONS(6722),
    [anon_sym_BSLASHacp] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6722),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6722),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6722),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6722),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6724),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6722),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6722),
    [anon_sym_BSLASHcolor] = ACTIONS(6722),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6722),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6722),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6722),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6722),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6722),
    [anon_sym_BSLASHtext] = ACTIONS(6722),
    [anon_sym_BSLASHintertext] = ACTIONS(6722),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6722),
    [anon_sym_BSLASHurl] = ACTIONS(6722),
    [anon_sym_BSLASHhref] = ACTIONS(6722),
  },
  [1818] = {
    [sym_command_name] = ACTIONS(6726),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6726),
    [anon_sym_LBRACK] = ACTIONS(6728),
    [anon_sym_RBRACK] = ACTIONS(6728),
    [anon_sym_COMMA] = ACTIONS(6728),
    [anon_sym_EQ] = ACTIONS(6728),
    [anon_sym_LPAREN] = ACTIONS(6728),
    [anon_sym_RPAREN] = ACTIONS(6728),
    [anon_sym_LBRACE] = ACTIONS(6728),
    [sym_word] = ACTIONS(6726),
    [sym_placeholder] = ACTIONS(6728),
    [anon_sym_PLUS] = ACTIONS(6728),
    [anon_sym_DASH] = ACTIONS(6728),
    [anon_sym_STAR] = ACTIONS(6728),
    [anon_sym_SLASH] = ACTIONS(6728),
    [anon_sym_LT] = ACTIONS(6726),
    [anon_sym_GT] = ACTIONS(6726),
    [anon_sym_BANG] = ACTIONS(6726),
    [anon_sym_PIPE] = ACTIONS(6726),
    [anon_sym_COLON] = ACTIONS(6726),
    [anon_sym_SQUOTE] = ACTIONS(6726),
    [anon_sym__] = ACTIONS(6728),
    [anon_sym_CARET] = ACTIONS(6728),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6728),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6728),
    [anon_sym_DOLLAR] = ACTIONS(6726),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6728),
    [anon_sym_BSLASHbegin] = ACTIONS(6726),
    [anon_sym_BSLASHtitle] = ACTIONS(6726),
    [anon_sym_BSLASHauthor] = ACTIONS(6726),
    [anon_sym_BSLASHusepackage] = ACTIONS(6726),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6726),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6726),
    [anon_sym_BSLASHinclude] = ACTIONS(6726),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6726),
    [anon_sym_BSLASHinput] = ACTIONS(6726),
    [anon_sym_BSLASHsubfile] = ACTIONS(6726),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6726),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6726),
    [anon_sym_BSLASHbibliography] = ACTIONS(6726),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6726),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6726),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6726),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6726),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6726),
    [anon_sym_BSLASHimport] = ACTIONS(6726),
    [anon_sym_BSLASHsubimport] = ACTIONS(6726),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6726),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6726),
    [anon_sym_BSLASHcaption] = ACTIONS(6726),
    [anon_sym_BSLASHcite] = ACTIONS(6726),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCite] = ACTIONS(6726),
    [anon_sym_BSLASHnocite] = ACTIONS(6726),
    [anon_sym_BSLASHcitet] = ACTIONS(6726),
    [anon_sym_BSLASHcitep] = ACTIONS(6726),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteA] = ACTIONS(6726),
    [anon_sym_BSLASHciteR] = ACTIONS(6726),
    [anon_sym_BSLASHciteS] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6726),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6726),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteyear] = ACTIONS(6726),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHcitedate] = ACTIONS(6726),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHciteurl] = ACTIONS(6726),
    [anon_sym_BSLASHfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6726),
    [anon_sym_BSLASHcitealt] = ACTIONS(6726),
    [anon_sym_BSLASHcitealp] = ACTIONS(6726),
    [anon_sym_BSLASHcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHparencite] = ACTIONS(6726),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHParencite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6726),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6726),
    [anon_sym_BSLASHtextcite] = ACTIONS(6726),
    [anon_sym_BSLASHTextcite] = ACTIONS(6726),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6726),
    [anon_sym_BSLASHsupercite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite] = ACTIONS(6726),
    [anon_sym_BSLASHAutocite] = ACTIONS(6726),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHVolcite] = ACTIONS(6726),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHavolcite] = ACTIONS(6726),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6726),
    [anon_sym_BSLASHnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHNotecite] = ACTIONS(6726),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6726),
    [anon_sym_BSLASHlabel] = ACTIONS(6726),
    [anon_sym_BSLASHref] = ACTIONS(6726),
    [anon_sym_BSLASHeqref] = ACTIONS(6726),
    [anon_sym_BSLASHvref] = ACTIONS(6726),
    [anon_sym_BSLASHVref] = ACTIONS(6726),
    [anon_sym_BSLASHautoref] = ACTIONS(6726),
    [anon_sym_BSLASHpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcref] = ACTIONS(6726),
    [anon_sym_BSLASHCref] = ACTIONS(6726),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnameCref] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6726),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6726),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6726),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6726),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6726),
    [anon_sym_BSLASHdef] = ACTIONS(6726),
    [anon_sym_BSLASHlet] = ACTIONS(6726),
    [anon_sym_BSLASHleft] = ACTIONS(6726),
    [anon_sym_BSLASHbigl] = ACTIONS(6726),
    [anon_sym_BSLASHBigl] = ACTIONS(6726),
    [anon_sym_BSLASHbiggl] = ACTIONS(6726),
    [anon_sym_BSLASHBiggl] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6726),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6726),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6726),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6726),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6726),
    [anon_sym_BSLASHgls] = ACTIONS(6726),
    [anon_sym_BSLASHGls] = ACTIONS(6726),
    [anon_sym_BSLASHGLS] = ACTIONS(6726),
    [anon_sym_BSLASHglspl] = ACTIONS(6726),
    [anon_sym_BSLASHGlspl] = ACTIONS(6726),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6726),
    [anon_sym_BSLASHglslink] = ACTIONS(6726),
    [anon_sym_BSLASHglstext] = ACTIONS(6726),
    [anon_sym_BSLASHGlstext] = ACTIONS(6726),
    [anon_sym_BSLASHGLStext] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6726),
    [anon_sym_BSLASHglsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6726),
    [anon_sym_BSLASHglsname] = ACTIONS(6726),
    [anon_sym_BSLASHGlsname] = ACTIONS(6726),
    [anon_sym_BSLASHGLSname] = ACTIONS(6726),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6726),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6726),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6726),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6726),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6726),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6726),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6726),
    [anon_sym_BSLASHacrshort] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6726),
    [anon_sym_BSLASHACRshort] = ACTIONS(6726),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrlong] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6726),
    [anon_sym_BSLASHACRlong] = ACTIONS(6726),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6726),
    [anon_sym_BSLASHacrfull] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6726),
    [anon_sym_BSLASHACRfull] = ACTIONS(6726),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHacs] = ACTIONS(6726),
    [anon_sym_BSLASHAcs] = ACTIONS(6726),
    [anon_sym_BSLASHacsp] = ACTIONS(6726),
    [anon_sym_BSLASHAcsp] = ACTIONS(6726),
    [anon_sym_BSLASHacl] = ACTIONS(6726),
    [anon_sym_BSLASHAcl] = ACTIONS(6726),
    [anon_sym_BSLASHaclp] = ACTIONS(6726),
    [anon_sym_BSLASHAclp] = ACTIONS(6726),
    [anon_sym_BSLASHacf] = ACTIONS(6726),
    [anon_sym_BSLASHAcf] = ACTIONS(6726),
    [anon_sym_BSLASHacfp] = ACTIONS(6726),
    [anon_sym_BSLASHAcfp] = ACTIONS(6726),
    [anon_sym_BSLASHac] = ACTIONS(6726),
    [anon_sym_BSLASHAc] = ACTIONS(6726),
    [anon_sym_BSLASHacp] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6726),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6726),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6726),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6726),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6728),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6726),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6726),
    [anon_sym_BSLASHcolor] = ACTIONS(6726),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6726),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6726),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6726),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6726),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6726),
    [anon_sym_BSLASHtext] = ACTIONS(6726),
    [anon_sym_BSLASHintertext] = ACTIONS(6726),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6726),
    [anon_sym_BSLASHurl] = ACTIONS(6726),
    [anon_sym_BSLASHhref] = ACTIONS(6726),
  },
  [1819] = {
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_LBRACK] = ACTIONS(6428),
    [anon_sym_RBRACK] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6428),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_RPAREN] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6428),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6428),
    [anon_sym_DOLLAR] = ACTIONS(6426),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHbegin] = ACTIONS(6426),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHleft] = ACTIONS(6426),
    [anon_sym_BSLASHbigl] = ACTIONS(6426),
    [anon_sym_BSLASHBigl] = ACTIONS(6426),
    [anon_sym_BSLASHbiggl] = ACTIONS(6426),
    [anon_sym_BSLASHBiggl] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHtext] = ACTIONS(6426),
    [anon_sym_BSLASHintertext] = ACTIONS(6426),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [1820] = {
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(6200),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [anon_sym_RPAREN] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6200),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6200),
    [anon_sym_DOLLAR] = ACTIONS(6198),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHbegin] = ACTIONS(6198),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHleft] = ACTIONS(6198),
    [anon_sym_BSLASHbigl] = ACTIONS(6198),
    [anon_sym_BSLASHBigl] = ACTIONS(6198),
    [anon_sym_BSLASHbiggl] = ACTIONS(6198),
    [anon_sym_BSLASHBiggl] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHtext] = ACTIONS(6198),
    [anon_sym_BSLASHintertext] = ACTIONS(6198),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [1821] = {
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_LBRACK] = ACTIONS(6216),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_EQ] = ACTIONS(6216),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [anon_sym_RPAREN] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6216),
    [anon_sym_DOLLAR] = ACTIONS(6214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHbegin] = ACTIONS(6214),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHleft] = ACTIONS(6214),
    [anon_sym_BSLASHbigl] = ACTIONS(6214),
    [anon_sym_BSLASHBigl] = ACTIONS(6214),
    [anon_sym_BSLASHbiggl] = ACTIONS(6214),
    [anon_sym_BSLASHBiggl] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHtext] = ACTIONS(6214),
    [anon_sym_BSLASHintertext] = ACTIONS(6214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [1822] = {
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_LBRACK] = ACTIONS(6220),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6220),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6220),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6220),
    [anon_sym_DOLLAR] = ACTIONS(6218),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHbegin] = ACTIONS(6218),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHleft] = ACTIONS(6218),
    [anon_sym_BSLASHbigl] = ACTIONS(6218),
    [anon_sym_BSLASHBigl] = ACTIONS(6218),
    [anon_sym_BSLASHbiggl] = ACTIONS(6218),
    [anon_sym_BSLASHBiggl] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHtext] = ACTIONS(6218),
    [anon_sym_BSLASHintertext] = ACTIONS(6218),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [1823] = {
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LBRACK] = ACTIONS(167),
    [anon_sym_RBRACK] = ACTIONS(167),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_EQ] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [anon_sym_RBRACE] = ACTIONS(167),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [1824] = {
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(6224),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_LPAREN] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6224),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6224),
    [anon_sym_DOLLAR] = ACTIONS(6222),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHbegin] = ACTIONS(6222),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHleft] = ACTIONS(6222),
    [anon_sym_BSLASHbigl] = ACTIONS(6222),
    [anon_sym_BSLASHBigl] = ACTIONS(6222),
    [anon_sym_BSLASHbiggl] = ACTIONS(6222),
    [anon_sym_BSLASHBiggl] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHtext] = ACTIONS(6222),
    [anon_sym_BSLASHintertext] = ACTIONS(6222),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [1825] = {
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_LBRACK] = ACTIONS(6404),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6404),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6404),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6404),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHbegin] = ACTIONS(6402),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHleft] = ACTIONS(6402),
    [anon_sym_BSLASHbigl] = ACTIONS(6402),
    [anon_sym_BSLASHBigl] = ACTIONS(6402),
    [anon_sym_BSLASHbiggl] = ACTIONS(6402),
    [anon_sym_BSLASHBiggl] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHtext] = ACTIONS(6402),
    [anon_sym_BSLASHintertext] = ACTIONS(6402),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [1826] = {
    [sym_curly_group] = STATE(1868),
    [sym_brack_group_text] = STATE(2897),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_LPAREN] = ACTIONS(6109),
    [anon_sym_RPAREN] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(6109),
    [anon_sym_BSLASHand] = ACTIONS(6105),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6109),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6109),
    [anon_sym_DOLLAR] = ACTIONS(6105),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6109),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHleft] = ACTIONS(6105),
    [anon_sym_BSLASHbigl] = ACTIONS(6105),
    [anon_sym_BSLASHBigl] = ACTIONS(6105),
    [anon_sym_BSLASHbiggl] = ACTIONS(6105),
    [anon_sym_BSLASHBiggl] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHtext] = ACTIONS(6105),
    [anon_sym_BSLASHintertext] = ACTIONS(6105),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [1827] = {
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(157),
    [anon_sym_RBRACK] = ACTIONS(157),
    [anon_sym_COMMA] = ACTIONS(157),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_RBRACE] = ACTIONS(157),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [1828] = {
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_LBRACK] = ACTIONS(6228),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_LPAREN] = ACTIONS(6228),
    [anon_sym_RPAREN] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(6228),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6228),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(6226),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHbegin] = ACTIONS(6226),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHleft] = ACTIONS(6226),
    [anon_sym_BSLASHbigl] = ACTIONS(6226),
    [anon_sym_BSLASHBigl] = ACTIONS(6226),
    [anon_sym_BSLASHbiggl] = ACTIONS(6226),
    [anon_sym_BSLASHBiggl] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHtext] = ACTIONS(6226),
    [anon_sym_BSLASHintertext] = ACTIONS(6226),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [1829] = {
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(6232),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6232),
    [anon_sym_LPAREN] = ACTIONS(6232),
    [anon_sym_RPAREN] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6232),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6232),
    [anon_sym_DOLLAR] = ACTIONS(6230),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHbegin] = ACTIONS(6230),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHleft] = ACTIONS(6230),
    [anon_sym_BSLASHbigl] = ACTIONS(6230),
    [anon_sym_BSLASHBigl] = ACTIONS(6230),
    [anon_sym_BSLASHbiggl] = ACTIONS(6230),
    [anon_sym_BSLASHBiggl] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHtext] = ACTIONS(6230),
    [anon_sym_BSLASHintertext] = ACTIONS(6230),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [1830] = {
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_LPAREN] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6236),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(6234),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHbegin] = ACTIONS(6234),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHleft] = ACTIONS(6234),
    [anon_sym_BSLASHbigl] = ACTIONS(6234),
    [anon_sym_BSLASHBigl] = ACTIONS(6234),
    [anon_sym_BSLASHbiggl] = ACTIONS(6234),
    [anon_sym_BSLASHBiggl] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHtext] = ACTIONS(6234),
    [anon_sym_BSLASHintertext] = ACTIONS(6234),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [1831] = {
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6240),
    [anon_sym_RBRACK] = ACTIONS(6240),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_LPAREN] = ACTIONS(6240),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(6240),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6240),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6240),
    [anon_sym_DOLLAR] = ACTIONS(6238),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHbegin] = ACTIONS(6238),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHleft] = ACTIONS(6238),
    [anon_sym_BSLASHbigl] = ACTIONS(6238),
    [anon_sym_BSLASHBigl] = ACTIONS(6238),
    [anon_sym_BSLASHbiggl] = ACTIONS(6238),
    [anon_sym_BSLASHBiggl] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHtext] = ACTIONS(6238),
    [anon_sym_BSLASHintertext] = ACTIONS(6238),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [1832] = {
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_LBRACK] = ACTIONS(6244),
    [anon_sym_RBRACK] = ACTIONS(6244),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_LPAREN] = ACTIONS(6244),
    [anon_sym_RPAREN] = ACTIONS(6244),
    [anon_sym_LBRACE] = ACTIONS(6244),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6244),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6244),
    [anon_sym_DOLLAR] = ACTIONS(6242),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHbegin] = ACTIONS(6242),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHleft] = ACTIONS(6242),
    [anon_sym_BSLASHbigl] = ACTIONS(6242),
    [anon_sym_BSLASHBigl] = ACTIONS(6242),
    [anon_sym_BSLASHbiggl] = ACTIONS(6242),
    [anon_sym_BSLASHBiggl] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHtext] = ACTIONS(6242),
    [anon_sym_BSLASHintertext] = ACTIONS(6242),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [1833] = {
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_COMMA] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_LPAREN] = ACTIONS(6248),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6248),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6248),
    [anon_sym_DOLLAR] = ACTIONS(6246),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHbegin] = ACTIONS(6246),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHleft] = ACTIONS(6246),
    [anon_sym_BSLASHbigl] = ACTIONS(6246),
    [anon_sym_BSLASHBigl] = ACTIONS(6246),
    [anon_sym_BSLASHbiggl] = ACTIONS(6246),
    [anon_sym_BSLASHBiggl] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHtext] = ACTIONS(6246),
    [anon_sym_BSLASHintertext] = ACTIONS(6246),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [1834] = {
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6252),
    [anon_sym_LPAREN] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHbegin] = ACTIONS(6250),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHleft] = ACTIONS(6250),
    [anon_sym_BSLASHbigl] = ACTIONS(6250),
    [anon_sym_BSLASHBigl] = ACTIONS(6250),
    [anon_sym_BSLASHbiggl] = ACTIONS(6250),
    [anon_sym_BSLASHBiggl] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHtext] = ACTIONS(6250),
    [anon_sym_BSLASHintertext] = ACTIONS(6250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
  [1835] = {
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_LBRACK] = ACTIONS(6268),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_COMMA] = ACTIONS(6268),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_LPAREN] = ACTIONS(6268),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6268),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(6266),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHbegin] = ACTIONS(6266),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHleft] = ACTIONS(6266),
    [anon_sym_BSLASHbigl] = ACTIONS(6266),
    [anon_sym_BSLASHBigl] = ACTIONS(6266),
    [anon_sym_BSLASHbiggl] = ACTIONS(6266),
    [anon_sym_BSLASHBiggl] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHtext] = ACTIONS(6266),
    [anon_sym_BSLASHintertext] = ACTIONS(6266),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [1836] = {
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_LBRACK] = ACTIONS(6272),
    [anon_sym_RBRACK] = ACTIONS(6272),
    [anon_sym_COMMA] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_LPAREN] = ACTIONS(6272),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6272),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6272),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6272),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHbegin] = ACTIONS(6270),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHleft] = ACTIONS(6270),
    [anon_sym_BSLASHbigl] = ACTIONS(6270),
    [anon_sym_BSLASHBigl] = ACTIONS(6270),
    [anon_sym_BSLASHbiggl] = ACTIONS(6270),
    [anon_sym_BSLASHBiggl] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHtext] = ACTIONS(6270),
    [anon_sym_BSLASHintertext] = ACTIONS(6270),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [1837] = {
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_LBRACK] = ACTIONS(6288),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6288),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6288),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6288),
    [anon_sym_DOLLAR] = ACTIONS(6286),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHbegin] = ACTIONS(6286),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHleft] = ACTIONS(6286),
    [anon_sym_BSLASHbigl] = ACTIONS(6286),
    [anon_sym_BSLASHBigl] = ACTIONS(6286),
    [anon_sym_BSLASHbiggl] = ACTIONS(6286),
    [anon_sym_BSLASHBiggl] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHtext] = ACTIONS(6286),
    [anon_sym_BSLASHintertext] = ACTIONS(6286),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [1838] = {
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [1839] = {
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_LBRACK] = ACTIONS(6292),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_COMMA] = ACTIONS(6292),
    [anon_sym_EQ] = ACTIONS(6292),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_RPAREN] = ACTIONS(6292),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6292),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6292),
    [anon_sym_DOLLAR] = ACTIONS(6290),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHbegin] = ACTIONS(6290),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHleft] = ACTIONS(6290),
    [anon_sym_BSLASHbigl] = ACTIONS(6290),
    [anon_sym_BSLASHBigl] = ACTIONS(6290),
    [anon_sym_BSLASHbiggl] = ACTIONS(6290),
    [anon_sym_BSLASHBiggl] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHtext] = ACTIONS(6290),
    [anon_sym_BSLASHintertext] = ACTIONS(6290),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [1840] = {
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_LBRACK] = ACTIONS(6312),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6312),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6312),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6312),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6312),
    [anon_sym_DOLLAR] = ACTIONS(6310),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHbegin] = ACTIONS(6310),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHleft] = ACTIONS(6310),
    [anon_sym_BSLASHbigl] = ACTIONS(6310),
    [anon_sym_BSLASHBigl] = ACTIONS(6310),
    [anon_sym_BSLASHbiggl] = ACTIONS(6310),
    [anon_sym_BSLASHBiggl] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHtext] = ACTIONS(6310),
    [anon_sym_BSLASHintertext] = ACTIONS(6310),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [1841] = {
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_LBRACK] = ACTIONS(6316),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_COMMA] = ACTIONS(6316),
    [anon_sym_EQ] = ACTIONS(6316),
    [anon_sym_LPAREN] = ACTIONS(6316),
    [anon_sym_RPAREN] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6316),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6316),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6316),
    [anon_sym_DOLLAR] = ACTIONS(6314),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHbegin] = ACTIONS(6314),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHleft] = ACTIONS(6314),
    [anon_sym_BSLASHbigl] = ACTIONS(6314),
    [anon_sym_BSLASHBigl] = ACTIONS(6314),
    [anon_sym_BSLASHbiggl] = ACTIONS(6314),
    [anon_sym_BSLASHBiggl] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHtext] = ACTIONS(6314),
    [anon_sym_BSLASHintertext] = ACTIONS(6314),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [1842] = {
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_RBRACK] = ACTIONS(6320),
    [anon_sym_COMMA] = ACTIONS(6320),
    [anon_sym_EQ] = ACTIONS(6320),
    [anon_sym_LPAREN] = ACTIONS(6320),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6320),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6320),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHbegin] = ACTIONS(6318),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHleft] = ACTIONS(6318),
    [anon_sym_BSLASHbigl] = ACTIONS(6318),
    [anon_sym_BSLASHBigl] = ACTIONS(6318),
    [anon_sym_BSLASHbiggl] = ACTIONS(6318),
    [anon_sym_BSLASHBiggl] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHtext] = ACTIONS(6318),
    [anon_sym_BSLASHintertext] = ACTIONS(6318),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [1843] = {
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_LBRACK] = ACTIONS(6324),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6324),
    [anon_sym_LPAREN] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6324),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6324),
    [anon_sym_DOLLAR] = ACTIONS(6322),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHbegin] = ACTIONS(6322),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHleft] = ACTIONS(6322),
    [anon_sym_BSLASHbigl] = ACTIONS(6322),
    [anon_sym_BSLASHBigl] = ACTIONS(6322),
    [anon_sym_BSLASHbiggl] = ACTIONS(6322),
    [anon_sym_BSLASHBiggl] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHtext] = ACTIONS(6322),
    [anon_sym_BSLASHintertext] = ACTIONS(6322),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [1844] = {
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_LBRACK] = ACTIONS(6328),
    [anon_sym_RBRACK] = ACTIONS(6328),
    [anon_sym_COMMA] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6328),
    [anon_sym_LPAREN] = ACTIONS(6328),
    [anon_sym_RPAREN] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6328),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6328),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6328),
    [anon_sym_DOLLAR] = ACTIONS(6326),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHbegin] = ACTIONS(6326),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHleft] = ACTIONS(6326),
    [anon_sym_BSLASHbigl] = ACTIONS(6326),
    [anon_sym_BSLASHBigl] = ACTIONS(6326),
    [anon_sym_BSLASHbiggl] = ACTIONS(6326),
    [anon_sym_BSLASHBiggl] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHtext] = ACTIONS(6326),
    [anon_sym_BSLASHintertext] = ACTIONS(6326),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [1845] = {
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_LBRACK] = ACTIONS(6332),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_EQ] = ACTIONS(6332),
    [anon_sym_LPAREN] = ACTIONS(6332),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6332),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6330),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHbegin] = ACTIONS(6330),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHleft] = ACTIONS(6330),
    [anon_sym_BSLASHbigl] = ACTIONS(6330),
    [anon_sym_BSLASHBigl] = ACTIONS(6330),
    [anon_sym_BSLASHbiggl] = ACTIONS(6330),
    [anon_sym_BSLASHBiggl] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHtext] = ACTIONS(6330),
    [anon_sym_BSLASHintertext] = ACTIONS(6330),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [1846] = {
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_LBRACK] = ACTIONS(6336),
    [anon_sym_RBRACK] = ACTIONS(6336),
    [anon_sym_COMMA] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_RPAREN] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6336),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHbegin] = ACTIONS(6334),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHleft] = ACTIONS(6334),
    [anon_sym_BSLASHbigl] = ACTIONS(6334),
    [anon_sym_BSLASHBigl] = ACTIONS(6334),
    [anon_sym_BSLASHbiggl] = ACTIONS(6334),
    [anon_sym_BSLASHBiggl] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHtext] = ACTIONS(6334),
    [anon_sym_BSLASHintertext] = ACTIONS(6334),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [1847] = {
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LBRACK] = ACTIONS(163),
    [anon_sym_RBRACK] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASHbegin] = ACTIONS(161),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [1848] = {
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_LBRACK] = ACTIONS(6432),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6432),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6432),
    [anon_sym_DOLLAR] = ACTIONS(6430),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHbegin] = ACTIONS(6430),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHleft] = ACTIONS(6430),
    [anon_sym_BSLASHbigl] = ACTIONS(6430),
    [anon_sym_BSLASHBigl] = ACTIONS(6430),
    [anon_sym_BSLASHbiggl] = ACTIONS(6430),
    [anon_sym_BSLASHBiggl] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHtext] = ACTIONS(6430),
    [anon_sym_BSLASHintertext] = ACTIONS(6430),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [1849] = {
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHbegin] = ACTIONS(149),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [1850] = {
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_LBRACK] = ACTIONS(6436),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_EQ] = ACTIONS(6436),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6436),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6436),
    [anon_sym_DOLLAR] = ACTIONS(6434),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHbegin] = ACTIONS(6434),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHleft] = ACTIONS(6434),
    [anon_sym_BSLASHbigl] = ACTIONS(6434),
    [anon_sym_BSLASHBigl] = ACTIONS(6434),
    [anon_sym_BSLASHbiggl] = ACTIONS(6434),
    [anon_sym_BSLASHBiggl] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHtext] = ACTIONS(6434),
    [anon_sym_BSLASHintertext] = ACTIONS(6434),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [1851] = {
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_RBRACK] = ACTIONS(6636),
    [anon_sym_COMMA] = ACTIONS(6636),
    [anon_sym_EQ] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(6636),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6636),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(6634),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHbegin] = ACTIONS(6634),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHleft] = ACTIONS(6634),
    [anon_sym_BSLASHbigl] = ACTIONS(6634),
    [anon_sym_BSLASHBigl] = ACTIONS(6634),
    [anon_sym_BSLASHbiggl] = ACTIONS(6634),
    [anon_sym_BSLASHBiggl] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHtext] = ACTIONS(6634),
    [anon_sym_BSLASHintertext] = ACTIONS(6634),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [1852] = {
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_LBRACK] = ACTIONS(6400),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6400),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6400),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHbegin] = ACTIONS(6398),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHleft] = ACTIONS(6398),
    [anon_sym_BSLASHbigl] = ACTIONS(6398),
    [anon_sym_BSLASHBigl] = ACTIONS(6398),
    [anon_sym_BSLASHbiggl] = ACTIONS(6398),
    [anon_sym_BSLASHBiggl] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHtext] = ACTIONS(6398),
    [anon_sym_BSLASHintertext] = ACTIONS(6398),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [1853] = {
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_LBRACK] = ACTIONS(6348),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [anon_sym_RPAREN] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6348),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6348),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6348),
    [anon_sym_DOLLAR] = ACTIONS(6346),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHbegin] = ACTIONS(6346),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHleft] = ACTIONS(6346),
    [anon_sym_BSLASHbigl] = ACTIONS(6346),
    [anon_sym_BSLASHBigl] = ACTIONS(6346),
    [anon_sym_BSLASHbiggl] = ACTIONS(6346),
    [anon_sym_BSLASHBiggl] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHtext] = ACTIONS(6346),
    [anon_sym_BSLASHintertext] = ACTIONS(6346),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [1854] = {
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_LBRACK] = ACTIONS(6440),
    [anon_sym_RBRACK] = ACTIONS(6440),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6440),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_RPAREN] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6440),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6440),
    [anon_sym_DOLLAR] = ACTIONS(6438),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHbegin] = ACTIONS(6438),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHleft] = ACTIONS(6438),
    [anon_sym_BSLASHbigl] = ACTIONS(6438),
    [anon_sym_BSLASHBigl] = ACTIONS(6438),
    [anon_sym_BSLASHbiggl] = ACTIONS(6438),
    [anon_sym_BSLASHBiggl] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHtext] = ACTIONS(6438),
    [anon_sym_BSLASHintertext] = ACTIONS(6438),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [1855] = {
    [sym_command_name] = ACTIONS(6542),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6544),
    [anon_sym_RBRACK] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LPAREN] = ACTIONS(6544),
    [anon_sym_RPAREN] = ACTIONS(6544),
    [anon_sym_LBRACE] = ACTIONS(6544),
    [sym_word] = ACTIONS(6542),
    [sym_placeholder] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_DASH] = ACTIONS(6544),
    [anon_sym_STAR] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6542),
    [anon_sym_GT] = ACTIONS(6542),
    [anon_sym_BANG] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6542),
    [anon_sym_COLON] = ACTIONS(6542),
    [anon_sym_SQUOTE] = ACTIONS(6542),
    [anon_sym__] = ACTIONS(6544),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6544),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6544),
    [anon_sym_DOLLAR] = ACTIONS(6542),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6544),
    [anon_sym_BSLASHbegin] = ACTIONS(6542),
    [anon_sym_BSLASHtitle] = ACTIONS(6542),
    [anon_sym_BSLASHauthor] = ACTIONS(6542),
    [anon_sym_BSLASHusepackage] = ACTIONS(6542),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6542),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6542),
    [anon_sym_BSLASHinclude] = ACTIONS(6542),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6542),
    [anon_sym_BSLASHinput] = ACTIONS(6542),
    [anon_sym_BSLASHsubfile] = ACTIONS(6542),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6542),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6542),
    [anon_sym_BSLASHbibliography] = ACTIONS(6542),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6542),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6542),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6542),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6542),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6542),
    [anon_sym_BSLASHimport] = ACTIONS(6542),
    [anon_sym_BSLASHsubimport] = ACTIONS(6542),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6542),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6542),
    [anon_sym_BSLASHcaption] = ACTIONS(6542),
    [anon_sym_BSLASHcite] = ACTIONS(6542),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCite] = ACTIONS(6542),
    [anon_sym_BSLASHnocite] = ACTIONS(6542),
    [anon_sym_BSLASHcitet] = ACTIONS(6542),
    [anon_sym_BSLASHcitep] = ACTIONS(6542),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteA] = ACTIONS(6542),
    [anon_sym_BSLASHciteR] = ACTIONS(6542),
    [anon_sym_BSLASHciteS] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6542),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6542),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteyear] = ACTIONS(6542),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHcitedate] = ACTIONS(6542),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHciteurl] = ACTIONS(6542),
    [anon_sym_BSLASHfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6542),
    [anon_sym_BSLASHcitealt] = ACTIONS(6542),
    [anon_sym_BSLASHcitealp] = ACTIONS(6542),
    [anon_sym_BSLASHcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHparencite] = ACTIONS(6542),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHParencite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6542),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6542),
    [anon_sym_BSLASHtextcite] = ACTIONS(6542),
    [anon_sym_BSLASHTextcite] = ACTIONS(6542),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6542),
    [anon_sym_BSLASHsupercite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite] = ACTIONS(6542),
    [anon_sym_BSLASHAutocite] = ACTIONS(6542),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHVolcite] = ACTIONS(6542),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHavolcite] = ACTIONS(6542),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6542),
    [anon_sym_BSLASHnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHNotecite] = ACTIONS(6542),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6542),
    [anon_sym_BSLASHlabel] = ACTIONS(6542),
    [anon_sym_BSLASHref] = ACTIONS(6542),
    [anon_sym_BSLASHeqref] = ACTIONS(6542),
    [anon_sym_BSLASHvref] = ACTIONS(6542),
    [anon_sym_BSLASHVref] = ACTIONS(6542),
    [anon_sym_BSLASHautoref] = ACTIONS(6542),
    [anon_sym_BSLASHpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcref] = ACTIONS(6542),
    [anon_sym_BSLASHCref] = ACTIONS(6542),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnameCref] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6542),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6542),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6542),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6542),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6542),
    [anon_sym_BSLASHdef] = ACTIONS(6542),
    [anon_sym_BSLASHlet] = ACTIONS(6542),
    [anon_sym_BSLASHleft] = ACTIONS(6542),
    [anon_sym_BSLASHbigl] = ACTIONS(6542),
    [anon_sym_BSLASHBigl] = ACTIONS(6542),
    [anon_sym_BSLASHbiggl] = ACTIONS(6542),
    [anon_sym_BSLASHBiggl] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6542),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6542),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6542),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6542),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6542),
    [anon_sym_BSLASHgls] = ACTIONS(6542),
    [anon_sym_BSLASHGls] = ACTIONS(6542),
    [anon_sym_BSLASHGLS] = ACTIONS(6542),
    [anon_sym_BSLASHglspl] = ACTIONS(6542),
    [anon_sym_BSLASHGlspl] = ACTIONS(6542),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6542),
    [anon_sym_BSLASHglslink] = ACTIONS(6542),
    [anon_sym_BSLASHglstext] = ACTIONS(6542),
    [anon_sym_BSLASHGlstext] = ACTIONS(6542),
    [anon_sym_BSLASHGLStext] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6542),
    [anon_sym_BSLASHglsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6542),
    [anon_sym_BSLASHglsname] = ACTIONS(6542),
    [anon_sym_BSLASHGlsname] = ACTIONS(6542),
    [anon_sym_BSLASHGLSname] = ACTIONS(6542),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6542),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6542),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6542),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6542),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6542),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6542),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6542),
    [anon_sym_BSLASHacrshort] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6542),
    [anon_sym_BSLASHACRshort] = ACTIONS(6542),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrlong] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6542),
    [anon_sym_BSLASHACRlong] = ACTIONS(6542),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6542),
    [anon_sym_BSLASHacrfull] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6542),
    [anon_sym_BSLASHACRfull] = ACTIONS(6542),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHacs] = ACTIONS(6542),
    [anon_sym_BSLASHAcs] = ACTIONS(6542),
    [anon_sym_BSLASHacsp] = ACTIONS(6542),
    [anon_sym_BSLASHAcsp] = ACTIONS(6542),
    [anon_sym_BSLASHacl] = ACTIONS(6542),
    [anon_sym_BSLASHAcl] = ACTIONS(6542),
    [anon_sym_BSLASHaclp] = ACTIONS(6542),
    [anon_sym_BSLASHAclp] = ACTIONS(6542),
    [anon_sym_BSLASHacf] = ACTIONS(6542),
    [anon_sym_BSLASHAcf] = ACTIONS(6542),
    [anon_sym_BSLASHacfp] = ACTIONS(6542),
    [anon_sym_BSLASHAcfp] = ACTIONS(6542),
    [anon_sym_BSLASHac] = ACTIONS(6542),
    [anon_sym_BSLASHAc] = ACTIONS(6542),
    [anon_sym_BSLASHacp] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6542),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6542),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6542),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6542),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6544),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6542),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6542),
    [anon_sym_BSLASHcolor] = ACTIONS(6542),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6542),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6542),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6542),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6542),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6542),
    [anon_sym_BSLASHtext] = ACTIONS(6542),
    [anon_sym_BSLASHintertext] = ACTIONS(6542),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6542),
    [anon_sym_BSLASHurl] = ACTIONS(6542),
    [anon_sym_BSLASHhref] = ACTIONS(6542),
  },
  [1856] = {
    [sym_command_name] = ACTIONS(6546),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6548),
    [anon_sym_RBRACK] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LPAREN] = ACTIONS(6548),
    [anon_sym_RPAREN] = ACTIONS(6548),
    [anon_sym_LBRACE] = ACTIONS(6548),
    [sym_word] = ACTIONS(6546),
    [sym_placeholder] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_DASH] = ACTIONS(6548),
    [anon_sym_STAR] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6546),
    [anon_sym_GT] = ACTIONS(6546),
    [anon_sym_BANG] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6546),
    [anon_sym_COLON] = ACTIONS(6546),
    [anon_sym_SQUOTE] = ACTIONS(6546),
    [anon_sym__] = ACTIONS(6548),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6548),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6548),
    [anon_sym_DOLLAR] = ACTIONS(6546),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6548),
    [anon_sym_BSLASHbegin] = ACTIONS(6546),
    [anon_sym_BSLASHtitle] = ACTIONS(6546),
    [anon_sym_BSLASHauthor] = ACTIONS(6546),
    [anon_sym_BSLASHusepackage] = ACTIONS(6546),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6546),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6546),
    [anon_sym_BSLASHinclude] = ACTIONS(6546),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6546),
    [anon_sym_BSLASHinput] = ACTIONS(6546),
    [anon_sym_BSLASHsubfile] = ACTIONS(6546),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6546),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6546),
    [anon_sym_BSLASHbibliography] = ACTIONS(6546),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6546),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6546),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6546),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6546),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6546),
    [anon_sym_BSLASHimport] = ACTIONS(6546),
    [anon_sym_BSLASHsubimport] = ACTIONS(6546),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6546),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6546),
    [anon_sym_BSLASHcaption] = ACTIONS(6546),
    [anon_sym_BSLASHcite] = ACTIONS(6546),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCite] = ACTIONS(6546),
    [anon_sym_BSLASHnocite] = ACTIONS(6546),
    [anon_sym_BSLASHcitet] = ACTIONS(6546),
    [anon_sym_BSLASHcitep] = ACTIONS(6546),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteA] = ACTIONS(6546),
    [anon_sym_BSLASHciteR] = ACTIONS(6546),
    [anon_sym_BSLASHciteS] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6546),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6546),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteyear] = ACTIONS(6546),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHcitedate] = ACTIONS(6546),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHciteurl] = ACTIONS(6546),
    [anon_sym_BSLASHfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6546),
    [anon_sym_BSLASHcitealt] = ACTIONS(6546),
    [anon_sym_BSLASHcitealp] = ACTIONS(6546),
    [anon_sym_BSLASHcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHparencite] = ACTIONS(6546),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHParencite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6546),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6546),
    [anon_sym_BSLASHtextcite] = ACTIONS(6546),
    [anon_sym_BSLASHTextcite] = ACTIONS(6546),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6546),
    [anon_sym_BSLASHsupercite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite] = ACTIONS(6546),
    [anon_sym_BSLASHAutocite] = ACTIONS(6546),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHVolcite] = ACTIONS(6546),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHavolcite] = ACTIONS(6546),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6546),
    [anon_sym_BSLASHnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHNotecite] = ACTIONS(6546),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6546),
    [anon_sym_BSLASHlabel] = ACTIONS(6546),
    [anon_sym_BSLASHref] = ACTIONS(6546),
    [anon_sym_BSLASHeqref] = ACTIONS(6546),
    [anon_sym_BSLASHvref] = ACTIONS(6546),
    [anon_sym_BSLASHVref] = ACTIONS(6546),
    [anon_sym_BSLASHautoref] = ACTIONS(6546),
    [anon_sym_BSLASHpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcref] = ACTIONS(6546),
    [anon_sym_BSLASHCref] = ACTIONS(6546),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnameCref] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6546),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6546),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6546),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6546),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6546),
    [anon_sym_BSLASHdef] = ACTIONS(6546),
    [anon_sym_BSLASHlet] = ACTIONS(6546),
    [anon_sym_BSLASHleft] = ACTIONS(6546),
    [anon_sym_BSLASHbigl] = ACTIONS(6546),
    [anon_sym_BSLASHBigl] = ACTIONS(6546),
    [anon_sym_BSLASHbiggl] = ACTIONS(6546),
    [anon_sym_BSLASHBiggl] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6546),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6546),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6546),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6546),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6546),
    [anon_sym_BSLASHgls] = ACTIONS(6546),
    [anon_sym_BSLASHGls] = ACTIONS(6546),
    [anon_sym_BSLASHGLS] = ACTIONS(6546),
    [anon_sym_BSLASHglspl] = ACTIONS(6546),
    [anon_sym_BSLASHGlspl] = ACTIONS(6546),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6546),
    [anon_sym_BSLASHglslink] = ACTIONS(6546),
    [anon_sym_BSLASHglstext] = ACTIONS(6546),
    [anon_sym_BSLASHGlstext] = ACTIONS(6546),
    [anon_sym_BSLASHGLStext] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6546),
    [anon_sym_BSLASHglsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6546),
    [anon_sym_BSLASHglsname] = ACTIONS(6546),
    [anon_sym_BSLASHGlsname] = ACTIONS(6546),
    [anon_sym_BSLASHGLSname] = ACTIONS(6546),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6546),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6546),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6546),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6546),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6546),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6546),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6546),
    [anon_sym_BSLASHacrshort] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6546),
    [anon_sym_BSLASHACRshort] = ACTIONS(6546),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrlong] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6546),
    [anon_sym_BSLASHACRlong] = ACTIONS(6546),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6546),
    [anon_sym_BSLASHacrfull] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6546),
    [anon_sym_BSLASHACRfull] = ACTIONS(6546),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHacs] = ACTIONS(6546),
    [anon_sym_BSLASHAcs] = ACTIONS(6546),
    [anon_sym_BSLASHacsp] = ACTIONS(6546),
    [anon_sym_BSLASHAcsp] = ACTIONS(6546),
    [anon_sym_BSLASHacl] = ACTIONS(6546),
    [anon_sym_BSLASHAcl] = ACTIONS(6546),
    [anon_sym_BSLASHaclp] = ACTIONS(6546),
    [anon_sym_BSLASHAclp] = ACTIONS(6546),
    [anon_sym_BSLASHacf] = ACTIONS(6546),
    [anon_sym_BSLASHAcf] = ACTIONS(6546),
    [anon_sym_BSLASHacfp] = ACTIONS(6546),
    [anon_sym_BSLASHAcfp] = ACTIONS(6546),
    [anon_sym_BSLASHac] = ACTIONS(6546),
    [anon_sym_BSLASHAc] = ACTIONS(6546),
    [anon_sym_BSLASHacp] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6546),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6546),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6546),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6546),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6548),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6546),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6546),
    [anon_sym_BSLASHcolor] = ACTIONS(6546),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6546),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6546),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6546),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6546),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6546),
    [anon_sym_BSLASHtext] = ACTIONS(6546),
    [anon_sym_BSLASHintertext] = ACTIONS(6546),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6546),
    [anon_sym_BSLASHurl] = ACTIONS(6546),
    [anon_sym_BSLASHhref] = ACTIONS(6546),
  },
  [1857] = {
    [sym_command_name] = ACTIONS(6642),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6642),
    [anon_sym_LBRACK] = ACTIONS(6644),
    [anon_sym_RBRACK] = ACTIONS(6644),
    [anon_sym_COMMA] = ACTIONS(6644),
    [anon_sym_EQ] = ACTIONS(6644),
    [anon_sym_LPAREN] = ACTIONS(6644),
    [anon_sym_RPAREN] = ACTIONS(6644),
    [anon_sym_LBRACE] = ACTIONS(6644),
    [sym_word] = ACTIONS(6642),
    [sym_placeholder] = ACTIONS(6644),
    [anon_sym_PLUS] = ACTIONS(6644),
    [anon_sym_DASH] = ACTIONS(6644),
    [anon_sym_STAR] = ACTIONS(6644),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_LT] = ACTIONS(6642),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_BANG] = ACTIONS(6642),
    [anon_sym_PIPE] = ACTIONS(6642),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_SQUOTE] = ACTIONS(6642),
    [anon_sym__] = ACTIONS(6644),
    [anon_sym_CARET] = ACTIONS(6644),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6644),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6644),
    [anon_sym_DOLLAR] = ACTIONS(6642),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHbegin] = ACTIONS(6642),
    [anon_sym_BSLASHtitle] = ACTIONS(6642),
    [anon_sym_BSLASHauthor] = ACTIONS(6642),
    [anon_sym_BSLASHusepackage] = ACTIONS(6642),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6642),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6642),
    [anon_sym_BSLASHinclude] = ACTIONS(6642),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6642),
    [anon_sym_BSLASHinput] = ACTIONS(6642),
    [anon_sym_BSLASHsubfile] = ACTIONS(6642),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6642),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6642),
    [anon_sym_BSLASHbibliography] = ACTIONS(6642),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6642),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6642),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6642),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6642),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6642),
    [anon_sym_BSLASHimport] = ACTIONS(6642),
    [anon_sym_BSLASHsubimport] = ACTIONS(6642),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6642),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHcaption] = ACTIONS(6642),
    [anon_sym_BSLASHcite] = ACTIONS(6642),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCite] = ACTIONS(6642),
    [anon_sym_BSLASHnocite] = ACTIONS(6642),
    [anon_sym_BSLASHcitet] = ACTIONS(6642),
    [anon_sym_BSLASHcitep] = ACTIONS(6642),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteA] = ACTIONS(6642),
    [anon_sym_BSLASHciteR] = ACTIONS(6642),
    [anon_sym_BSLASHciteS] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6642),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteyear] = ACTIONS(6642),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitedate] = ACTIONS(6642),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteurl] = ACTIONS(6642),
    [anon_sym_BSLASHfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6642),
    [anon_sym_BSLASHcitealt] = ACTIONS(6642),
    [anon_sym_BSLASHcitealp] = ACTIONS(6642),
    [anon_sym_BSLASHcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHparencite] = ACTIONS(6642),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHParencite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHtextcite] = ACTIONS(6642),
    [anon_sym_BSLASHTextcite] = ACTIONS(6642),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHsupercite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite] = ACTIONS(6642),
    [anon_sym_BSLASHAutocite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHVolcite] = ACTIONS(6642),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHavolcite] = ACTIONS(6642),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHNotecite] = ACTIONS(6642),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHlabel] = ACTIONS(6642),
    [anon_sym_BSLASHref] = ACTIONS(6642),
    [anon_sym_BSLASHeqref] = ACTIONS(6642),
    [anon_sym_BSLASHvref] = ACTIONS(6642),
    [anon_sym_BSLASHVref] = ACTIONS(6642),
    [anon_sym_BSLASHautoref] = ACTIONS(6642),
    [anon_sym_BSLASHpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcref] = ACTIONS(6642),
    [anon_sym_BSLASHCref] = ACTIONS(6642),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnameCref] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHdef] = ACTIONS(6642),
    [anon_sym_BSLASHlet] = ACTIONS(6642),
    [anon_sym_BSLASHleft] = ACTIONS(6642),
    [anon_sym_BSLASHbigl] = ACTIONS(6642),
    [anon_sym_BSLASHBigl] = ACTIONS(6642),
    [anon_sym_BSLASHbiggl] = ACTIONS(6642),
    [anon_sym_BSLASHBiggl] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6642),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6642),
    [anon_sym_BSLASHgls] = ACTIONS(6642),
    [anon_sym_BSLASHGls] = ACTIONS(6642),
    [anon_sym_BSLASHGLS] = ACTIONS(6642),
    [anon_sym_BSLASHglspl] = ACTIONS(6642),
    [anon_sym_BSLASHGlspl] = ACTIONS(6642),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6642),
    [anon_sym_BSLASHglslink] = ACTIONS(6642),
    [anon_sym_BSLASHglstext] = ACTIONS(6642),
    [anon_sym_BSLASHGlstext] = ACTIONS(6642),
    [anon_sym_BSLASHGLStext] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6642),
    [anon_sym_BSLASHglsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsname] = ACTIONS(6642),
    [anon_sym_BSLASHGlsname] = ACTIONS(6642),
    [anon_sym_BSLASHGLSname] = ACTIONS(6642),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6642),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6642),
    [anon_sym_BSLASHacrshort] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6642),
    [anon_sym_BSLASHACRshort] = ACTIONS(6642),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrlong] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6642),
    [anon_sym_BSLASHACRlong] = ACTIONS(6642),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrfull] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6642),
    [anon_sym_BSLASHACRfull] = ACTIONS(6642),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHacs] = ACTIONS(6642),
    [anon_sym_BSLASHAcs] = ACTIONS(6642),
    [anon_sym_BSLASHacsp] = ACTIONS(6642),
    [anon_sym_BSLASHAcsp] = ACTIONS(6642),
    [anon_sym_BSLASHacl] = ACTIONS(6642),
    [anon_sym_BSLASHAcl] = ACTIONS(6642),
    [anon_sym_BSLASHaclp] = ACTIONS(6642),
    [anon_sym_BSLASHAclp] = ACTIONS(6642),
    [anon_sym_BSLASHacf] = ACTIONS(6642),
    [anon_sym_BSLASHAcf] = ACTIONS(6642),
    [anon_sym_BSLASHacfp] = ACTIONS(6642),
    [anon_sym_BSLASHAcfp] = ACTIONS(6642),
    [anon_sym_BSLASHac] = ACTIONS(6642),
    [anon_sym_BSLASHAc] = ACTIONS(6642),
    [anon_sym_BSLASHacp] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6642),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6642),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6642),
    [anon_sym_BSLASHcolor] = ACTIONS(6642),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6642),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6642),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6642),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6642),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6642),
    [anon_sym_BSLASHtext] = ACTIONS(6642),
    [anon_sym_BSLASHintertext] = ACTIONS(6642),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6642),
    [anon_sym_BSLASHurl] = ACTIONS(6642),
    [anon_sym_BSLASHhref] = ACTIONS(6642),
  },
  [1858] = {
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_LBRACK] = ACTIONS(6356),
    [anon_sym_RBRACK] = ACTIONS(6356),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_EQ] = ACTIONS(6356),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_RPAREN] = ACTIONS(6356),
    [anon_sym_LBRACE] = ACTIONS(6356),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6356),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6356),
    [anon_sym_DOLLAR] = ACTIONS(6354),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHbegin] = ACTIONS(6354),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHleft] = ACTIONS(6354),
    [anon_sym_BSLASHbigl] = ACTIONS(6354),
    [anon_sym_BSLASHBigl] = ACTIONS(6354),
    [anon_sym_BSLASHbiggl] = ACTIONS(6354),
    [anon_sym_BSLASHBiggl] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHtext] = ACTIONS(6354),
    [anon_sym_BSLASHintertext] = ACTIONS(6354),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [1859] = {
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_LBRACK] = ACTIONS(6364),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_LPAREN] = ACTIONS(6364),
    [anon_sym_RPAREN] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6364),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6364),
    [anon_sym_DOLLAR] = ACTIONS(6362),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHbegin] = ACTIONS(6362),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHleft] = ACTIONS(6362),
    [anon_sym_BSLASHbigl] = ACTIONS(6362),
    [anon_sym_BSLASHBigl] = ACTIONS(6362),
    [anon_sym_BSLASHbiggl] = ACTIONS(6362),
    [anon_sym_BSLASHBiggl] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHtext] = ACTIONS(6362),
    [anon_sym_BSLASHintertext] = ACTIONS(6362),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [1860] = {
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_LBRACK] = ACTIONS(6376),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_EQ] = ACTIONS(6376),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6376),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6376),
    [anon_sym_DOLLAR] = ACTIONS(6374),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHbegin] = ACTIONS(6374),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHleft] = ACTIONS(6374),
    [anon_sym_BSLASHbigl] = ACTIONS(6374),
    [anon_sym_BSLASHBigl] = ACTIONS(6374),
    [anon_sym_BSLASHbiggl] = ACTIONS(6374),
    [anon_sym_BSLASHBiggl] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHtext] = ACTIONS(6374),
    [anon_sym_BSLASHintertext] = ACTIONS(6374),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [1861] = {
    [sym_command_name] = ACTIONS(6642),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6642),
    [anon_sym_LBRACK] = ACTIONS(6644),
    [anon_sym_RBRACK] = ACTIONS(6644),
    [anon_sym_COMMA] = ACTIONS(6644),
    [anon_sym_EQ] = ACTIONS(6644),
    [anon_sym_LPAREN] = ACTIONS(6644),
    [anon_sym_RPAREN] = ACTIONS(6644),
    [anon_sym_LBRACE] = ACTIONS(6644),
    [anon_sym_RBRACE] = ACTIONS(6644),
    [sym_word] = ACTIONS(6642),
    [sym_placeholder] = ACTIONS(6644),
    [anon_sym_PLUS] = ACTIONS(6644),
    [anon_sym_DASH] = ACTIONS(6644),
    [anon_sym_STAR] = ACTIONS(6644),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_LT] = ACTIONS(6642),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_BANG] = ACTIONS(6642),
    [anon_sym_PIPE] = ACTIONS(6642),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_SQUOTE] = ACTIONS(6642),
    [anon_sym__] = ACTIONS(6644),
    [anon_sym_CARET] = ACTIONS(6644),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6644),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6644),
    [anon_sym_DOLLAR] = ACTIONS(6642),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHtitle] = ACTIONS(6642),
    [anon_sym_BSLASHauthor] = ACTIONS(6642),
    [anon_sym_BSLASHusepackage] = ACTIONS(6642),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6642),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6642),
    [anon_sym_BSLASHinclude] = ACTIONS(6642),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6642),
    [anon_sym_BSLASHinput] = ACTIONS(6642),
    [anon_sym_BSLASHsubfile] = ACTIONS(6642),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6642),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6642),
    [anon_sym_BSLASHbibliography] = ACTIONS(6642),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6642),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6642),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6642),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6642),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6642),
    [anon_sym_BSLASHimport] = ACTIONS(6642),
    [anon_sym_BSLASHsubimport] = ACTIONS(6642),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6642),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHcaption] = ACTIONS(6642),
    [anon_sym_BSLASHcite] = ACTIONS(6642),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCite] = ACTIONS(6642),
    [anon_sym_BSLASHnocite] = ACTIONS(6642),
    [anon_sym_BSLASHcitet] = ACTIONS(6642),
    [anon_sym_BSLASHcitep] = ACTIONS(6642),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteA] = ACTIONS(6642),
    [anon_sym_BSLASHciteR] = ACTIONS(6642),
    [anon_sym_BSLASHciteS] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6642),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteyear] = ACTIONS(6642),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitedate] = ACTIONS(6642),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteurl] = ACTIONS(6642),
    [anon_sym_BSLASHfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6642),
    [anon_sym_BSLASHcitealt] = ACTIONS(6642),
    [anon_sym_BSLASHcitealp] = ACTIONS(6642),
    [anon_sym_BSLASHcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHparencite] = ACTIONS(6642),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHParencite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHtextcite] = ACTIONS(6642),
    [anon_sym_BSLASHTextcite] = ACTIONS(6642),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHsupercite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite] = ACTIONS(6642),
    [anon_sym_BSLASHAutocite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHVolcite] = ACTIONS(6642),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHavolcite] = ACTIONS(6642),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHNotecite] = ACTIONS(6642),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHlabel] = ACTIONS(6642),
    [anon_sym_BSLASHref] = ACTIONS(6642),
    [anon_sym_BSLASHeqref] = ACTIONS(6642),
    [anon_sym_BSLASHvref] = ACTIONS(6642),
    [anon_sym_BSLASHVref] = ACTIONS(6642),
    [anon_sym_BSLASHautoref] = ACTIONS(6642),
    [anon_sym_BSLASHpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcref] = ACTIONS(6642),
    [anon_sym_BSLASHCref] = ACTIONS(6642),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnameCref] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHdef] = ACTIONS(6642),
    [anon_sym_BSLASHlet] = ACTIONS(6642),
    [anon_sym_BSLASHleft] = ACTIONS(6642),
    [anon_sym_BSLASHbigl] = ACTIONS(6642),
    [anon_sym_BSLASHBigl] = ACTIONS(6642),
    [anon_sym_BSLASHbiggl] = ACTIONS(6642),
    [anon_sym_BSLASHBiggl] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6642),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6642),
    [anon_sym_BSLASHgls] = ACTIONS(6642),
    [anon_sym_BSLASHGls] = ACTIONS(6642),
    [anon_sym_BSLASHGLS] = ACTIONS(6642),
    [anon_sym_BSLASHglspl] = ACTIONS(6642),
    [anon_sym_BSLASHGlspl] = ACTIONS(6642),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6642),
    [anon_sym_BSLASHglslink] = ACTIONS(6642),
    [anon_sym_BSLASHglstext] = ACTIONS(6642),
    [anon_sym_BSLASHGlstext] = ACTIONS(6642),
    [anon_sym_BSLASHGLStext] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6642),
    [anon_sym_BSLASHglsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsname] = ACTIONS(6642),
    [anon_sym_BSLASHGlsname] = ACTIONS(6642),
    [anon_sym_BSLASHGLSname] = ACTIONS(6642),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6642),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6642),
    [anon_sym_BSLASHacrshort] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6642),
    [anon_sym_BSLASHACRshort] = ACTIONS(6642),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrlong] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6642),
    [anon_sym_BSLASHACRlong] = ACTIONS(6642),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrfull] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6642),
    [anon_sym_BSLASHACRfull] = ACTIONS(6642),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHacs] = ACTIONS(6642),
    [anon_sym_BSLASHAcs] = ACTIONS(6642),
    [anon_sym_BSLASHacsp] = ACTIONS(6642),
    [anon_sym_BSLASHAcsp] = ACTIONS(6642),
    [anon_sym_BSLASHacl] = ACTIONS(6642),
    [anon_sym_BSLASHAcl] = ACTIONS(6642),
    [anon_sym_BSLASHaclp] = ACTIONS(6642),
    [anon_sym_BSLASHAclp] = ACTIONS(6642),
    [anon_sym_BSLASHacf] = ACTIONS(6642),
    [anon_sym_BSLASHAcf] = ACTIONS(6642),
    [anon_sym_BSLASHacfp] = ACTIONS(6642),
    [anon_sym_BSLASHAcfp] = ACTIONS(6642),
    [anon_sym_BSLASHac] = ACTIONS(6642),
    [anon_sym_BSLASHAc] = ACTIONS(6642),
    [anon_sym_BSLASHacp] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6642),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6642),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6642),
    [anon_sym_BSLASHcolor] = ACTIONS(6642),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6642),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6642),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6642),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6642),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6642),
    [anon_sym_BSLASHtext] = ACTIONS(6642),
    [anon_sym_BSLASHintertext] = ACTIONS(6642),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6642),
    [anon_sym_BSLASHurl] = ACTIONS(6642),
    [anon_sym_BSLASHhref] = ACTIONS(6642),
  },
  [1862] = {
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_LBRACK] = ACTIONS(6380),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_EQ] = ACTIONS(6380),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6380),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6380),
    [anon_sym_DOLLAR] = ACTIONS(6378),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHbegin] = ACTIONS(6378),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHleft] = ACTIONS(6378),
    [anon_sym_BSLASHbigl] = ACTIONS(6378),
    [anon_sym_BSLASHBigl] = ACTIONS(6378),
    [anon_sym_BSLASHbiggl] = ACTIONS(6378),
    [anon_sym_BSLASHBiggl] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHtext] = ACTIONS(6378),
    [anon_sym_BSLASHintertext] = ACTIONS(6378),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [1863] = {
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_LBRACK] = ACTIONS(6384),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_EQ] = ACTIONS(6384),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_RPAREN] = ACTIONS(6384),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6384),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(6382),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHbegin] = ACTIONS(6382),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHleft] = ACTIONS(6382),
    [anon_sym_BSLASHbigl] = ACTIONS(6382),
    [anon_sym_BSLASHBigl] = ACTIONS(6382),
    [anon_sym_BSLASHbiggl] = ACTIONS(6382),
    [anon_sym_BSLASHBiggl] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHtext] = ACTIONS(6382),
    [anon_sym_BSLASHintertext] = ACTIONS(6382),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [1864] = {
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_LBRACK] = ACTIONS(6388),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_COMMA] = ACTIONS(6388),
    [anon_sym_EQ] = ACTIONS(6388),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6388),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(6386),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHbegin] = ACTIONS(6386),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHleft] = ACTIONS(6386),
    [anon_sym_BSLASHbigl] = ACTIONS(6386),
    [anon_sym_BSLASHBigl] = ACTIONS(6386),
    [anon_sym_BSLASHbiggl] = ACTIONS(6386),
    [anon_sym_BSLASHBiggl] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHtext] = ACTIONS(6386),
    [anon_sym_BSLASHintertext] = ACTIONS(6386),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [1865] = {
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_LBRACK] = ACTIONS(6392),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_COMMA] = ACTIONS(6392),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6392),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(6390),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHbegin] = ACTIONS(6390),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHleft] = ACTIONS(6390),
    [anon_sym_BSLASHbigl] = ACTIONS(6390),
    [anon_sym_BSLASHBigl] = ACTIONS(6390),
    [anon_sym_BSLASHbiggl] = ACTIONS(6390),
    [anon_sym_BSLASHBiggl] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHtext] = ACTIONS(6390),
    [anon_sym_BSLASHintertext] = ACTIONS(6390),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [1866] = {
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_LBRACK] = ACTIONS(6396),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6396),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6396),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6396),
    [anon_sym_DOLLAR] = ACTIONS(6394),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHbegin] = ACTIONS(6394),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHleft] = ACTIONS(6394),
    [anon_sym_BSLASHbigl] = ACTIONS(6394),
    [anon_sym_BSLASHBigl] = ACTIONS(6394),
    [anon_sym_BSLASHbiggl] = ACTIONS(6394),
    [anon_sym_BSLASHBiggl] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHtext] = ACTIONS(6394),
    [anon_sym_BSLASHintertext] = ACTIONS(6394),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [1867] = {
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(151),
    [anon_sym_COMMA] = ACTIONS(151),
    [anon_sym_EQ] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [1868] = {
    [sym_brack_group_text] = STATE(1917),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(7154),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_RPAREN] = ACTIONS(6150),
    [anon_sym_LBRACE] = ACTIONS(6150),
    [anon_sym_RBRACE] = ACTIONS(6150),
    [anon_sym_BSLASHand] = ACTIONS(6148),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6150),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6150),
    [anon_sym_DOLLAR] = ACTIONS(6148),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6150),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHleft] = ACTIONS(6148),
    [anon_sym_BSLASHbigl] = ACTIONS(6148),
    [anon_sym_BSLASHBigl] = ACTIONS(6148),
    [anon_sym_BSLASHbiggl] = ACTIONS(6148),
    [anon_sym_BSLASHBiggl] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHtext] = ACTIONS(6148),
    [anon_sym_BSLASHintertext] = ACTIONS(6148),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [1869] = {
    [sym_command_name] = ACTIONS(7089),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7089),
    [anon_sym_LBRACK] = ACTIONS(7091),
    [anon_sym_RBRACK] = ACTIONS(7091),
    [anon_sym_COMMA] = ACTIONS(7091),
    [anon_sym_LPAREN] = ACTIONS(7091),
    [anon_sym_RPAREN] = ACTIONS(7091),
    [anon_sym_LBRACE] = ACTIONS(7091),
    [anon_sym_RBRACE] = ACTIONS(7091),
    [sym_word] = ACTIONS(7089),
    [sym_placeholder] = ACTIONS(7091),
    [anon_sym_PLUS] = ACTIONS(7091),
    [anon_sym_DASH] = ACTIONS(7091),
    [anon_sym_STAR] = ACTIONS(7091),
    [anon_sym_SLASH] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(7089),
    [anon_sym_GT] = ACTIONS(7089),
    [anon_sym_BANG] = ACTIONS(7089),
    [anon_sym_PIPE] = ACTIONS(7089),
    [anon_sym_COLON] = ACTIONS(7089),
    [anon_sym_SQUOTE] = ACTIONS(7089),
    [anon_sym__] = ACTIONS(7091),
    [anon_sym_CARET] = ACTIONS(7091),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7091),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7091),
    [anon_sym_DOLLAR] = ACTIONS(7089),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7091),
    [anon_sym_BSLASHtitle] = ACTIONS(7089),
    [anon_sym_BSLASHauthor] = ACTIONS(7089),
    [anon_sym_BSLASHusepackage] = ACTIONS(7089),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7089),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7089),
    [anon_sym_BSLASHinclude] = ACTIONS(7089),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7089),
    [anon_sym_BSLASHinput] = ACTIONS(7089),
    [anon_sym_BSLASHsubfile] = ACTIONS(7089),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7089),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7089),
    [anon_sym_BSLASHbibliography] = ACTIONS(7089),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7089),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7089),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7089),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7089),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7089),
    [anon_sym_BSLASHimport] = ACTIONS(7089),
    [anon_sym_BSLASHsubimport] = ACTIONS(7089),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7089),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7089),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7089),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7089),
    [anon_sym_BSLASHcaption] = ACTIONS(7089),
    [anon_sym_BSLASHcite] = ACTIONS(7089),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCite] = ACTIONS(7089),
    [anon_sym_BSLASHnocite] = ACTIONS(7089),
    [anon_sym_BSLASHcitet] = ACTIONS(7089),
    [anon_sym_BSLASHcitep] = ACTIONS(7089),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHciteA] = ACTIONS(7089),
    [anon_sym_BSLASHciteR] = ACTIONS(7089),
    [anon_sym_BSLASHciteS] = ACTIONS(7089),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7089),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7089),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7089),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7089),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHciteyear] = ACTIONS(7089),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHcitedate] = ACTIONS(7089),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHciteurl] = ACTIONS(7089),
    [anon_sym_BSLASHfullcite] = ACTIONS(7089),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7089),
    [anon_sym_BSLASHcitealt] = ACTIONS(7089),
    [anon_sym_BSLASHcitealp] = ACTIONS(7089),
    [anon_sym_BSLASHcitetext] = ACTIONS(7089),
    [anon_sym_BSLASHparencite] = ACTIONS(7089),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHParencite] = ACTIONS(7089),
    [anon_sym_BSLASHfootcite] = ACTIONS(7089),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7089),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7089),
    [anon_sym_BSLASHtextcite] = ACTIONS(7089),
    [anon_sym_BSLASHTextcite] = ACTIONS(7089),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7089),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7089),
    [anon_sym_BSLASHsupercite] = ACTIONS(7089),
    [anon_sym_BSLASHautocite] = ACTIONS(7089),
    [anon_sym_BSLASHAutocite] = ACTIONS(7089),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHVolcite] = ACTIONS(7089),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHavolcite] = ACTIONS(7089),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7089),
    [anon_sym_BSLASHnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHNotecite] = ACTIONS(7089),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7089),
    [anon_sym_BSLASHlabel] = ACTIONS(7089),
    [anon_sym_BSLASHref] = ACTIONS(7089),
    [anon_sym_BSLASHeqref] = ACTIONS(7089),
    [anon_sym_BSLASHvref] = ACTIONS(7089),
    [anon_sym_BSLASHVref] = ACTIONS(7089),
    [anon_sym_BSLASHautoref] = ACTIONS(7089),
    [anon_sym_BSLASHpageref] = ACTIONS(7089),
    [anon_sym_BSLASHcref] = ACTIONS(7089),
    [anon_sym_BSLASHCref] = ACTIONS(7089),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHnamecref] = ACTIONS(7089),
    [anon_sym_BSLASHnameCref] = ACTIONS(7089),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7089),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7089),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7089),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7089),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7089),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7089),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7089),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7089),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7089),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7089),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7089),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7089),
    [anon_sym_BSLASHdef] = ACTIONS(7089),
    [anon_sym_BSLASHlet] = ACTIONS(7089),
    [anon_sym_BSLASHleft] = ACTIONS(7089),
    [anon_sym_BSLASHbigl] = ACTIONS(7089),
    [anon_sym_BSLASHBigl] = ACTIONS(7089),
    [anon_sym_BSLASHbiggl] = ACTIONS(7089),
    [anon_sym_BSLASHBiggl] = ACTIONS(7089),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7089),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7089),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7089),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7089),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7089),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7089),
    [anon_sym_BSLASHgls] = ACTIONS(7089),
    [anon_sym_BSLASHGls] = ACTIONS(7089),
    [anon_sym_BSLASHGLS] = ACTIONS(7089),
    [anon_sym_BSLASHglspl] = ACTIONS(7089),
    [anon_sym_BSLASHGlspl] = ACTIONS(7089),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7089),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7089),
    [anon_sym_BSLASHglslink] = ACTIONS(7089),
    [anon_sym_BSLASHglstext] = ACTIONS(7089),
    [anon_sym_BSLASHGlstext] = ACTIONS(7089),
    [anon_sym_BSLASHGLStext] = ACTIONS(7089),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7089),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7089),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7089),
    [anon_sym_BSLASHglsplural] = ACTIONS(7089),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7089),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7089),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7089),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7089),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7089),
    [anon_sym_BSLASHglsname] = ACTIONS(7089),
    [anon_sym_BSLASHGlsname] = ACTIONS(7089),
    [anon_sym_BSLASHGLSname] = ACTIONS(7089),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7089),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7089),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7089),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7089),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7089),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7089),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7089),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7089),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7089),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7089),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7089),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7089),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7089),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7089),
    [anon_sym_BSLASHacrshort] = ACTIONS(7089),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7089),
    [anon_sym_BSLASHACRshort] = ACTIONS(7089),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHacrlong] = ACTIONS(7089),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7089),
    [anon_sym_BSLASHACRlong] = ACTIONS(7089),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7089),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7089),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7089),
    [anon_sym_BSLASHacrfull] = ACTIONS(7089),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7089),
    [anon_sym_BSLASHACRfull] = ACTIONS(7089),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHacs] = ACTIONS(7089),
    [anon_sym_BSLASHAcs] = ACTIONS(7089),
    [anon_sym_BSLASHacsp] = ACTIONS(7089),
    [anon_sym_BSLASHAcsp] = ACTIONS(7089),
    [anon_sym_BSLASHacl] = ACTIONS(7089),
    [anon_sym_BSLASHAcl] = ACTIONS(7089),
    [anon_sym_BSLASHaclp] = ACTIONS(7089),
    [anon_sym_BSLASHAclp] = ACTIONS(7089),
    [anon_sym_BSLASHacf] = ACTIONS(7089),
    [anon_sym_BSLASHAcf] = ACTIONS(7089),
    [anon_sym_BSLASHacfp] = ACTIONS(7089),
    [anon_sym_BSLASHAcfp] = ACTIONS(7089),
    [anon_sym_BSLASHac] = ACTIONS(7089),
    [anon_sym_BSLASHAc] = ACTIONS(7089),
    [anon_sym_BSLASHacp] = ACTIONS(7089),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7089),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7089),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7089),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7089),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7089),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7089),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7089),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7091),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7089),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7089),
    [anon_sym_BSLASHcolor] = ACTIONS(7089),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7089),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7089),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7089),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7089),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7089),
    [anon_sym_BSLASHtext] = ACTIONS(7089),
    [anon_sym_BSLASHintertext] = ACTIONS(7089),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7089),
    [anon_sym_BSLASHurl] = ACTIONS(7089),
    [anon_sym_BSLASHhref] = ACTIONS(7089),
  },
  [1870] = {
    [sym_brack_group_text] = STATE(1905),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(7154),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_RPAREN] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(6168),
    [anon_sym_RBRACE] = ACTIONS(6168),
    [anon_sym_BSLASHand] = ACTIONS(6166),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6168),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6168),
    [anon_sym_DOLLAR] = ACTIONS(6166),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6168),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHleft] = ACTIONS(6166),
    [anon_sym_BSLASHbigl] = ACTIONS(6166),
    [anon_sym_BSLASHBigl] = ACTIONS(6166),
    [anon_sym_BSLASHbiggl] = ACTIONS(6166),
    [anon_sym_BSLASHBiggl] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHtext] = ACTIONS(6166),
    [anon_sym_BSLASHintertext] = ACTIONS(6166),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [1871] = {
    [sym_curly_group] = STATE(1958),
    [aux_sym_generic_command_repeat1] = STATE(1871),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_LPAREN] = ACTIONS(6133),
    [anon_sym_RPAREN] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(7156),
    [anon_sym_RBRACE] = ACTIONS(6133),
    [anon_sym_BSLASHand] = ACTIONS(6131),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6133),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6133),
    [anon_sym_DOLLAR] = ACTIONS(6131),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6133),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHleft] = ACTIONS(6131),
    [anon_sym_BSLASHbigl] = ACTIONS(6131),
    [anon_sym_BSLASHBigl] = ACTIONS(6131),
    [anon_sym_BSLASHbiggl] = ACTIONS(6131),
    [anon_sym_BSLASHBiggl] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHtext] = ACTIONS(6131),
    [anon_sym_BSLASHintertext] = ACTIONS(6131),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [1872] = {
    [sym_curly_group] = STATE(1958),
    [aux_sym_generic_command_repeat1] = STATE(1871),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_LPAREN] = ACTIONS(6125),
    [anon_sym_RPAREN] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(6125),
    [anon_sym_BSLASHand] = ACTIONS(6123),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6125),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6125),
    [anon_sym_DOLLAR] = ACTIONS(6123),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6125),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHleft] = ACTIONS(6123),
    [anon_sym_BSLASHbigl] = ACTIONS(6123),
    [anon_sym_BSLASHBigl] = ACTIONS(6123),
    [anon_sym_BSLASHbiggl] = ACTIONS(6123),
    [anon_sym_BSLASHBiggl] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHtext] = ACTIONS(6123),
    [anon_sym_BSLASHintertext] = ACTIONS(6123),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [1873] = {
    [sym_curly_group] = STATE(1958),
    [aux_sym_generic_command_repeat1] = STATE(1872),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [anon_sym_RPAREN] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(6121),
    [anon_sym_BSLASHand] = ACTIONS(6119),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6121),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6121),
    [anon_sym_DOLLAR] = ACTIONS(6119),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6121),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHleft] = ACTIONS(6119),
    [anon_sym_BSLASHbigl] = ACTIONS(6119),
    [anon_sym_BSLASHBigl] = ACTIONS(6119),
    [anon_sym_BSLASHbiggl] = ACTIONS(6119),
    [anon_sym_BSLASHBiggl] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHtext] = ACTIONS(6119),
    [anon_sym_BSLASHintertext] = ACTIONS(6119),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [1874] = {
    [sym_command_name] = ACTIONS(7097),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7097),
    [anon_sym_LBRACK] = ACTIONS(7099),
    [anon_sym_RBRACK] = ACTIONS(7099),
    [anon_sym_COMMA] = ACTIONS(7099),
    [anon_sym_LPAREN] = ACTIONS(7099),
    [anon_sym_RPAREN] = ACTIONS(7099),
    [anon_sym_LBRACE] = ACTIONS(7099),
    [anon_sym_RBRACE] = ACTIONS(7099),
    [sym_word] = ACTIONS(7097),
    [sym_placeholder] = ACTIONS(7099),
    [anon_sym_PLUS] = ACTIONS(7099),
    [anon_sym_DASH] = ACTIONS(7099),
    [anon_sym_STAR] = ACTIONS(7099),
    [anon_sym_SLASH] = ACTIONS(7099),
    [anon_sym_LT] = ACTIONS(7097),
    [anon_sym_GT] = ACTIONS(7097),
    [anon_sym_BANG] = ACTIONS(7097),
    [anon_sym_PIPE] = ACTIONS(7097),
    [anon_sym_COLON] = ACTIONS(7097),
    [anon_sym_SQUOTE] = ACTIONS(7097),
    [anon_sym__] = ACTIONS(7099),
    [anon_sym_CARET] = ACTIONS(7099),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7099),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7099),
    [anon_sym_DOLLAR] = ACTIONS(7097),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7099),
    [anon_sym_BSLASHtitle] = ACTIONS(7097),
    [anon_sym_BSLASHauthor] = ACTIONS(7097),
    [anon_sym_BSLASHusepackage] = ACTIONS(7097),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7097),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7097),
    [anon_sym_BSLASHinclude] = ACTIONS(7097),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7097),
    [anon_sym_BSLASHinput] = ACTIONS(7097),
    [anon_sym_BSLASHsubfile] = ACTIONS(7097),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7097),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7097),
    [anon_sym_BSLASHbibliography] = ACTIONS(7097),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7097),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7097),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7097),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7097),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7097),
    [anon_sym_BSLASHimport] = ACTIONS(7097),
    [anon_sym_BSLASHsubimport] = ACTIONS(7097),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7097),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7097),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7097),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7097),
    [anon_sym_BSLASHcaption] = ACTIONS(7097),
    [anon_sym_BSLASHcite] = ACTIONS(7097),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCite] = ACTIONS(7097),
    [anon_sym_BSLASHnocite] = ACTIONS(7097),
    [anon_sym_BSLASHcitet] = ACTIONS(7097),
    [anon_sym_BSLASHcitep] = ACTIONS(7097),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHciteA] = ACTIONS(7097),
    [anon_sym_BSLASHciteR] = ACTIONS(7097),
    [anon_sym_BSLASHciteS] = ACTIONS(7097),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7097),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7097),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7097),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7097),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHciteyear] = ACTIONS(7097),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHcitedate] = ACTIONS(7097),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHciteurl] = ACTIONS(7097),
    [anon_sym_BSLASHfullcite] = ACTIONS(7097),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7097),
    [anon_sym_BSLASHcitealt] = ACTIONS(7097),
    [anon_sym_BSLASHcitealp] = ACTIONS(7097),
    [anon_sym_BSLASHcitetext] = ACTIONS(7097),
    [anon_sym_BSLASHparencite] = ACTIONS(7097),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHParencite] = ACTIONS(7097),
    [anon_sym_BSLASHfootcite] = ACTIONS(7097),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7097),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7097),
    [anon_sym_BSLASHtextcite] = ACTIONS(7097),
    [anon_sym_BSLASHTextcite] = ACTIONS(7097),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7097),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7097),
    [anon_sym_BSLASHsupercite] = ACTIONS(7097),
    [anon_sym_BSLASHautocite] = ACTIONS(7097),
    [anon_sym_BSLASHAutocite] = ACTIONS(7097),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHVolcite] = ACTIONS(7097),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHavolcite] = ACTIONS(7097),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7097),
    [anon_sym_BSLASHnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHNotecite] = ACTIONS(7097),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7097),
    [anon_sym_BSLASHlabel] = ACTIONS(7097),
    [anon_sym_BSLASHref] = ACTIONS(7097),
    [anon_sym_BSLASHeqref] = ACTIONS(7097),
    [anon_sym_BSLASHvref] = ACTIONS(7097),
    [anon_sym_BSLASHVref] = ACTIONS(7097),
    [anon_sym_BSLASHautoref] = ACTIONS(7097),
    [anon_sym_BSLASHpageref] = ACTIONS(7097),
    [anon_sym_BSLASHcref] = ACTIONS(7097),
    [anon_sym_BSLASHCref] = ACTIONS(7097),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHnamecref] = ACTIONS(7097),
    [anon_sym_BSLASHnameCref] = ACTIONS(7097),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7097),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7097),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7097),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7097),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7097),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7097),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7097),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7097),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7097),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7097),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7097),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7097),
    [anon_sym_BSLASHdef] = ACTIONS(7097),
    [anon_sym_BSLASHlet] = ACTIONS(7097),
    [anon_sym_BSLASHleft] = ACTIONS(7097),
    [anon_sym_BSLASHbigl] = ACTIONS(7097),
    [anon_sym_BSLASHBigl] = ACTIONS(7097),
    [anon_sym_BSLASHbiggl] = ACTIONS(7097),
    [anon_sym_BSLASHBiggl] = ACTIONS(7097),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7097),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7097),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7097),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7097),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7097),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7097),
    [anon_sym_BSLASHgls] = ACTIONS(7097),
    [anon_sym_BSLASHGls] = ACTIONS(7097),
    [anon_sym_BSLASHGLS] = ACTIONS(7097),
    [anon_sym_BSLASHglspl] = ACTIONS(7097),
    [anon_sym_BSLASHGlspl] = ACTIONS(7097),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7097),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7097),
    [anon_sym_BSLASHglslink] = ACTIONS(7097),
    [anon_sym_BSLASHglstext] = ACTIONS(7097),
    [anon_sym_BSLASHGlstext] = ACTIONS(7097),
    [anon_sym_BSLASHGLStext] = ACTIONS(7097),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7097),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7097),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7097),
    [anon_sym_BSLASHglsplural] = ACTIONS(7097),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7097),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7097),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7097),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7097),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7097),
    [anon_sym_BSLASHglsname] = ACTIONS(7097),
    [anon_sym_BSLASHGlsname] = ACTIONS(7097),
    [anon_sym_BSLASHGLSname] = ACTIONS(7097),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7097),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7097),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7097),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7097),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7097),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7097),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7097),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7097),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7097),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7097),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7097),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7097),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7097),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7097),
    [anon_sym_BSLASHacrshort] = ACTIONS(7097),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7097),
    [anon_sym_BSLASHACRshort] = ACTIONS(7097),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHacrlong] = ACTIONS(7097),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7097),
    [anon_sym_BSLASHACRlong] = ACTIONS(7097),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7097),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7097),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7097),
    [anon_sym_BSLASHacrfull] = ACTIONS(7097),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7097),
    [anon_sym_BSLASHACRfull] = ACTIONS(7097),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHacs] = ACTIONS(7097),
    [anon_sym_BSLASHAcs] = ACTIONS(7097),
    [anon_sym_BSLASHacsp] = ACTIONS(7097),
    [anon_sym_BSLASHAcsp] = ACTIONS(7097),
    [anon_sym_BSLASHacl] = ACTIONS(7097),
    [anon_sym_BSLASHAcl] = ACTIONS(7097),
    [anon_sym_BSLASHaclp] = ACTIONS(7097),
    [anon_sym_BSLASHAclp] = ACTIONS(7097),
    [anon_sym_BSLASHacf] = ACTIONS(7097),
    [anon_sym_BSLASHAcf] = ACTIONS(7097),
    [anon_sym_BSLASHacfp] = ACTIONS(7097),
    [anon_sym_BSLASHAcfp] = ACTIONS(7097),
    [anon_sym_BSLASHac] = ACTIONS(7097),
    [anon_sym_BSLASHAc] = ACTIONS(7097),
    [anon_sym_BSLASHacp] = ACTIONS(7097),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7097),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7097),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7097),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7097),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7097),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7097),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7097),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7099),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7097),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7097),
    [anon_sym_BSLASHcolor] = ACTIONS(7097),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7097),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7097),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7097),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7097),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7097),
    [anon_sym_BSLASHtext] = ACTIONS(7097),
    [anon_sym_BSLASHintertext] = ACTIONS(7097),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7097),
    [anon_sym_BSLASHurl] = ACTIONS(7097),
    [anon_sym_BSLASHhref] = ACTIONS(7097),
  },
  [1875] = {
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(7159),
    [anon_sym_LPAREN] = ACTIONS(6115),
    [anon_sym_RPAREN] = ACTIONS(6115),
    [anon_sym_LBRACE] = ACTIONS(6115),
    [anon_sym_RBRACE] = ACTIONS(6115),
    [anon_sym_BSLASHand] = ACTIONS(6111),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6115),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6111),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6115),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHleft] = ACTIONS(6111),
    [anon_sym_BSLASHbigl] = ACTIONS(6111),
    [anon_sym_BSLASHBigl] = ACTIONS(6111),
    [anon_sym_BSLASHbiggl] = ACTIONS(6111),
    [anon_sym_BSLASHBiggl] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHtext] = ACTIONS(6111),
    [anon_sym_BSLASHintertext] = ACTIONS(6111),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(7161),
  },
  [1876] = {
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(7163),
    [anon_sym_LPAREN] = ACTIONS(6160),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [anon_sym_RBRACE] = ACTIONS(6160),
    [anon_sym_BSLASHand] = ACTIONS(6156),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6160),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6160),
    [anon_sym_DOLLAR] = ACTIONS(6156),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6160),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHleft] = ACTIONS(6156),
    [anon_sym_BSLASHbigl] = ACTIONS(6156),
    [anon_sym_BSLASHBigl] = ACTIONS(6156),
    [anon_sym_BSLASHbiggl] = ACTIONS(6156),
    [anon_sym_BSLASHBiggl] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHtext] = ACTIONS(6156),
    [anon_sym_BSLASHintertext] = ACTIONS(6156),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [1877] = {
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_LPAREN] = ACTIONS(6636),
    [anon_sym_RPAREN] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [anon_sym_RBRACE] = ACTIONS(6636),
    [anon_sym_BSLASHand] = ACTIONS(6634),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6636),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(6634),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6636),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHleft] = ACTIONS(6634),
    [anon_sym_BSLASHbigl] = ACTIONS(6634),
    [anon_sym_BSLASHBigl] = ACTIONS(6634),
    [anon_sym_BSLASHbiggl] = ACTIONS(6634),
    [anon_sym_BSLASHBiggl] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHtext] = ACTIONS(6634),
    [anon_sym_BSLASHintertext] = ACTIONS(6634),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [1878] = {
    [sym_curly_group] = STATE(1892),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_RPAREN] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(6164),
    [anon_sym_BSLASHand] = ACTIONS(6162),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6164),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6164),
    [anon_sym_DOLLAR] = ACTIONS(6162),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6164),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHleft] = ACTIONS(6162),
    [anon_sym_BSLASHbigl] = ACTIONS(6162),
    [anon_sym_BSLASHBigl] = ACTIONS(6162),
    [anon_sym_BSLASHbiggl] = ACTIONS(6162),
    [anon_sym_BSLASHBiggl] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHtext] = ACTIONS(6162),
    [anon_sym_BSLASHintertext] = ACTIONS(6162),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [1879] = {
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_LPAREN] = ACTIONS(6656),
    [anon_sym_RPAREN] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [anon_sym_RBRACE] = ACTIONS(6656),
    [anon_sym_BSLASHand] = ACTIONS(6654),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6656),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6656),
    [anon_sym_DOLLAR] = ACTIONS(6654),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6656),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHleft] = ACTIONS(6654),
    [anon_sym_BSLASHbigl] = ACTIONS(6654),
    [anon_sym_BSLASHBigl] = ACTIONS(6654),
    [anon_sym_BSLASHbiggl] = ACTIONS(6654),
    [anon_sym_BSLASHBiggl] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHtext] = ACTIONS(6654),
    [anon_sym_BSLASHintertext] = ACTIONS(6654),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [1880] = {
    [sym_curly_group] = STATE(1921),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_RPAREN] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(6154),
    [anon_sym_BSLASHand] = ACTIONS(6152),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6154),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6154),
    [anon_sym_DOLLAR] = ACTIONS(6152),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6154),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHleft] = ACTIONS(6152),
    [anon_sym_BSLASHbigl] = ACTIONS(6152),
    [anon_sym_BSLASHBigl] = ACTIONS(6152),
    [anon_sym_BSLASHbiggl] = ACTIONS(6152),
    [anon_sym_BSLASHBiggl] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHtext] = ACTIONS(6152),
    [anon_sym_BSLASHintertext] = ACTIONS(6152),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [1881] = {
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_LPAREN] = ACTIONS(6248),
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [anon_sym_RBRACE] = ACTIONS(6248),
    [anon_sym_BSLASHand] = ACTIONS(6246),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6248),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6248),
    [anon_sym_DOLLAR] = ACTIONS(6246),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6248),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHleft] = ACTIONS(6246),
    [anon_sym_BSLASHbigl] = ACTIONS(6246),
    [anon_sym_BSLASHBigl] = ACTIONS(6246),
    [anon_sym_BSLASHbiggl] = ACTIONS(6246),
    [anon_sym_BSLASHBiggl] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHtext] = ACTIONS(6246),
    [anon_sym_BSLASHintertext] = ACTIONS(6246),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [1882] = {
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_LPAREN] = ACTIONS(6452),
    [anon_sym_RPAREN] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [anon_sym_RBRACE] = ACTIONS(6452),
    [anon_sym_BSLASHand] = ACTIONS(6450),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6452),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(6450),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6452),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHleft] = ACTIONS(6450),
    [anon_sym_BSLASHbigl] = ACTIONS(6450),
    [anon_sym_BSLASHBigl] = ACTIONS(6450),
    [anon_sym_BSLASHbiggl] = ACTIONS(6450),
    [anon_sym_BSLASHBiggl] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHtext] = ACTIONS(6450),
    [anon_sym_BSLASHintertext] = ACTIONS(6450),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [1883] = {
    [sym_curly_group] = STATE(1913),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_LPAREN] = ACTIONS(6146),
    [anon_sym_RPAREN] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(5067),
    [anon_sym_RBRACE] = ACTIONS(6146),
    [anon_sym_BSLASHand] = ACTIONS(6144),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6146),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6146),
    [anon_sym_DOLLAR] = ACTIONS(6144),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6146),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHleft] = ACTIONS(6144),
    [anon_sym_BSLASHbigl] = ACTIONS(6144),
    [anon_sym_BSLASHBigl] = ACTIONS(6144),
    [anon_sym_BSLASHbiggl] = ACTIONS(6144),
    [anon_sym_BSLASHBiggl] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHtext] = ACTIONS(6144),
    [anon_sym_BSLASHintertext] = ACTIONS(6144),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [1884] = {
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_LPAREN] = ACTIONS(6480),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [anon_sym_RBRACE] = ACTIONS(6480),
    [anon_sym_BSLASHand] = ACTIONS(6478),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6480),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6480),
    [anon_sym_DOLLAR] = ACTIONS(6478),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6480),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHleft] = ACTIONS(6478),
    [anon_sym_BSLASHbigl] = ACTIONS(6478),
    [anon_sym_BSLASHBigl] = ACTIONS(6478),
    [anon_sym_BSLASHbiggl] = ACTIONS(6478),
    [anon_sym_BSLASHBiggl] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHtext] = ACTIONS(6478),
    [anon_sym_BSLASHintertext] = ACTIONS(6478),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [1885] = {
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_LPAREN] = ACTIONS(6444),
    [anon_sym_RPAREN] = ACTIONS(6444),
    [anon_sym_LBRACE] = ACTIONS(6444),
    [anon_sym_RBRACE] = ACTIONS(6444),
    [anon_sym_BSLASHand] = ACTIONS(6442),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6444),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6444),
    [anon_sym_DOLLAR] = ACTIONS(6442),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6444),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHleft] = ACTIONS(6442),
    [anon_sym_BSLASHbigl] = ACTIONS(6442),
    [anon_sym_BSLASHBigl] = ACTIONS(6442),
    [anon_sym_BSLASHbiggl] = ACTIONS(6442),
    [anon_sym_BSLASHBiggl] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHtext] = ACTIONS(6442),
    [anon_sym_BSLASHintertext] = ACTIONS(6442),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [1886] = {
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_LBRACE] = ACTIONS(6404),
    [anon_sym_RBRACE] = ACTIONS(6404),
    [anon_sym_BSLASHand] = ACTIONS(6402),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6404),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6404),
    [anon_sym_DOLLAR] = ACTIONS(6402),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6404),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHleft] = ACTIONS(6402),
    [anon_sym_BSLASHbigl] = ACTIONS(6402),
    [anon_sym_BSLASHBigl] = ACTIONS(6402),
    [anon_sym_BSLASHbiggl] = ACTIONS(6402),
    [anon_sym_BSLASHBiggl] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHtext] = ACTIONS(6402),
    [anon_sym_BSLASHintertext] = ACTIONS(6402),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [1887] = {
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_LPAREN] = ACTIONS(6232),
    [anon_sym_RPAREN] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(6232),
    [anon_sym_RBRACE] = ACTIONS(6232),
    [anon_sym_BSLASHand] = ACTIONS(6230),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6232),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6232),
    [anon_sym_DOLLAR] = ACTIONS(6230),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6232),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHleft] = ACTIONS(6230),
    [anon_sym_BSLASHbigl] = ACTIONS(6230),
    [anon_sym_BSLASHBigl] = ACTIONS(6230),
    [anon_sym_BSLASHbiggl] = ACTIONS(6230),
    [anon_sym_BSLASHBiggl] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHtext] = ACTIONS(6230),
    [anon_sym_BSLASHintertext] = ACTIONS(6230),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [1888] = {
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_LPAREN] = ACTIONS(6228),
    [anon_sym_RPAREN] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(6228),
    [anon_sym_RBRACE] = ACTIONS(6228),
    [anon_sym_BSLASHand] = ACTIONS(6226),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6228),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6228),
    [anon_sym_DOLLAR] = ACTIONS(6226),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6228),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHleft] = ACTIONS(6226),
    [anon_sym_BSLASHbigl] = ACTIONS(6226),
    [anon_sym_BSLASHBigl] = ACTIONS(6226),
    [anon_sym_BSLASHbiggl] = ACTIONS(6226),
    [anon_sym_BSLASHBiggl] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHtext] = ACTIONS(6226),
    [anon_sym_BSLASHintertext] = ACTIONS(6226),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [1889] = {
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_LPAREN] = ACTIONS(6224),
    [anon_sym_RPAREN] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(6224),
    [anon_sym_RBRACE] = ACTIONS(6224),
    [anon_sym_BSLASHand] = ACTIONS(6222),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6224),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6224),
    [anon_sym_DOLLAR] = ACTIONS(6222),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6224),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHleft] = ACTIONS(6222),
    [anon_sym_BSLASHbigl] = ACTIONS(6222),
    [anon_sym_BSLASHBigl] = ACTIONS(6222),
    [anon_sym_BSLASHbiggl] = ACTIONS(6222),
    [anon_sym_BSLASHBiggl] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHtext] = ACTIONS(6222),
    [anon_sym_BSLASHintertext] = ACTIONS(6222),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [1890] = {
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_LPAREN] = ACTIONS(6220),
    [anon_sym_RPAREN] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6220),
    [anon_sym_RBRACE] = ACTIONS(6220),
    [anon_sym_BSLASHand] = ACTIONS(6218),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6220),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6220),
    [anon_sym_DOLLAR] = ACTIONS(6218),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6220),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHleft] = ACTIONS(6218),
    [anon_sym_BSLASHbigl] = ACTIONS(6218),
    [anon_sym_BSLASHBigl] = ACTIONS(6218),
    [anon_sym_BSLASHbiggl] = ACTIONS(6218),
    [anon_sym_BSLASHBiggl] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHtext] = ACTIONS(6218),
    [anon_sym_BSLASHintertext] = ACTIONS(6218),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [1891] = {
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_LPAREN] = ACTIONS(6216),
    [anon_sym_RPAREN] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(6216),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [anon_sym_BSLASHand] = ACTIONS(6214),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6216),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6216),
    [anon_sym_DOLLAR] = ACTIONS(6214),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6216),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHleft] = ACTIONS(6214),
    [anon_sym_BSLASHbigl] = ACTIONS(6214),
    [anon_sym_BSLASHBigl] = ACTIONS(6214),
    [anon_sym_BSLASHbiggl] = ACTIONS(6214),
    [anon_sym_BSLASHBiggl] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHtext] = ACTIONS(6214),
    [anon_sym_BSLASHintertext] = ACTIONS(6214),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [1892] = {
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_LPAREN] = ACTIONS(6200),
    [anon_sym_RPAREN] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(6200),
    [anon_sym_RBRACE] = ACTIONS(6200),
    [anon_sym_BSLASHand] = ACTIONS(6198),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6200),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6200),
    [anon_sym_DOLLAR] = ACTIONS(6198),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6200),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHleft] = ACTIONS(6198),
    [anon_sym_BSLASHbigl] = ACTIONS(6198),
    [anon_sym_BSLASHBigl] = ACTIONS(6198),
    [anon_sym_BSLASHbiggl] = ACTIONS(6198),
    [anon_sym_BSLASHBiggl] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHtext] = ACTIONS(6198),
    [anon_sym_BSLASHintertext] = ACTIONS(6198),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [1893] = {
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_LPAREN] = ACTIONS(6356),
    [anon_sym_RPAREN] = ACTIONS(6356),
    [anon_sym_LBRACE] = ACTIONS(6356),
    [anon_sym_RBRACE] = ACTIONS(6356),
    [anon_sym_BSLASHand] = ACTIONS(6354),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6356),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6356),
    [anon_sym_DOLLAR] = ACTIONS(6354),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6356),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHleft] = ACTIONS(6354),
    [anon_sym_BSLASHbigl] = ACTIONS(6354),
    [anon_sym_BSLASHBigl] = ACTIONS(6354),
    [anon_sym_BSLASHbiggl] = ACTIONS(6354),
    [anon_sym_BSLASHBiggl] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHtext] = ACTIONS(6354),
    [anon_sym_BSLASHintertext] = ACTIONS(6354),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [1894] = {
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_LPAREN] = ACTIONS(6192),
    [anon_sym_RPAREN] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6192),
    [anon_sym_RBRACE] = ACTIONS(6192),
    [anon_sym_BSLASHand] = ACTIONS(6190),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6192),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6192),
    [anon_sym_DOLLAR] = ACTIONS(6190),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6192),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHleft] = ACTIONS(6190),
    [anon_sym_BSLASHbigl] = ACTIONS(6190),
    [anon_sym_BSLASHBigl] = ACTIONS(6190),
    [anon_sym_BSLASHbiggl] = ACTIONS(6190),
    [anon_sym_BSLASHBiggl] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHtext] = ACTIONS(6190),
    [anon_sym_BSLASHintertext] = ACTIONS(6190),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [1895] = {
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_LPAREN] = ACTIONS(6184),
    [anon_sym_RPAREN] = ACTIONS(6184),
    [anon_sym_LBRACE] = ACTIONS(6184),
    [anon_sym_RBRACE] = ACTIONS(6184),
    [anon_sym_BSLASHand] = ACTIONS(6182),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6184),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6184),
    [anon_sym_DOLLAR] = ACTIONS(6182),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6184),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHleft] = ACTIONS(6182),
    [anon_sym_BSLASHbigl] = ACTIONS(6182),
    [anon_sym_BSLASHBigl] = ACTIONS(6182),
    [anon_sym_BSLASHbiggl] = ACTIONS(6182),
    [anon_sym_BSLASHBiggl] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHtext] = ACTIONS(6182),
    [anon_sym_BSLASHintertext] = ACTIONS(6182),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [1896] = {
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_LPAREN] = ACTIONS(6176),
    [anon_sym_RPAREN] = ACTIONS(6176),
    [anon_sym_LBRACE] = ACTIONS(6176),
    [anon_sym_RBRACE] = ACTIONS(6176),
    [anon_sym_BSLASHand] = ACTIONS(6174),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6176),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6176),
    [anon_sym_DOLLAR] = ACTIONS(6174),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6176),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHleft] = ACTIONS(6174),
    [anon_sym_BSLASHbigl] = ACTIONS(6174),
    [anon_sym_BSLASHBigl] = ACTIONS(6174),
    [anon_sym_BSLASHbiggl] = ACTIONS(6174),
    [anon_sym_BSLASHBiggl] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHtext] = ACTIONS(6174),
    [anon_sym_BSLASHintertext] = ACTIONS(6174),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [1897] = {
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_LPAREN] = ACTIONS(6352),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_LBRACE] = ACTIONS(6352),
    [anon_sym_RBRACE] = ACTIONS(6352),
    [anon_sym_BSLASHand] = ACTIONS(6350),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6352),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6352),
    [anon_sym_DOLLAR] = ACTIONS(6350),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6352),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHleft] = ACTIONS(6350),
    [anon_sym_BSLASHbigl] = ACTIONS(6350),
    [anon_sym_BSLASHBigl] = ACTIONS(6350),
    [anon_sym_BSLASHbiggl] = ACTIONS(6350),
    [anon_sym_BSLASHBiggl] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHtext] = ACTIONS(6350),
    [anon_sym_BSLASHintertext] = ACTIONS(6350),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [1898] = {
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_LPAREN] = ACTIONS(6472),
    [anon_sym_RPAREN] = ACTIONS(6472),
    [anon_sym_LBRACE] = ACTIONS(6472),
    [anon_sym_RBRACE] = ACTIONS(6472),
    [anon_sym_BSLASHand] = ACTIONS(6470),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6472),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6472),
    [anon_sym_DOLLAR] = ACTIONS(6470),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6472),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHleft] = ACTIONS(6470),
    [anon_sym_BSLASHbigl] = ACTIONS(6470),
    [anon_sym_BSLASHBigl] = ACTIONS(6470),
    [anon_sym_BSLASHbiggl] = ACTIONS(6470),
    [anon_sym_BSLASHBiggl] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHtext] = ACTIONS(6470),
    [anon_sym_BSLASHintertext] = ACTIONS(6470),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [1899] = {
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_LPAREN] = ACTIONS(6552),
    [anon_sym_RPAREN] = ACTIONS(6552),
    [anon_sym_LBRACE] = ACTIONS(6552),
    [anon_sym_RBRACE] = ACTIONS(6552),
    [anon_sym_BSLASHand] = ACTIONS(6550),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6552),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6552),
    [anon_sym_DOLLAR] = ACTIONS(6550),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6552),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHleft] = ACTIONS(6550),
    [anon_sym_BSLASHbigl] = ACTIONS(6550),
    [anon_sym_BSLASHBigl] = ACTIONS(6550),
    [anon_sym_BSLASHbiggl] = ACTIONS(6550),
    [anon_sym_BSLASHBiggl] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHtext] = ACTIONS(6550),
    [anon_sym_BSLASHintertext] = ACTIONS(6550),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [1900] = {
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_LPAREN] = ACTIONS(6556),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_LBRACE] = ACTIONS(6556),
    [anon_sym_RBRACE] = ACTIONS(6556),
    [anon_sym_BSLASHand] = ACTIONS(6554),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6556),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6556),
    [anon_sym_DOLLAR] = ACTIONS(6554),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6556),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHleft] = ACTIONS(6554),
    [anon_sym_BSLASHbigl] = ACTIONS(6554),
    [anon_sym_BSLASHBigl] = ACTIONS(6554),
    [anon_sym_BSLASHbiggl] = ACTIONS(6554),
    [anon_sym_BSLASHBiggl] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHtext] = ACTIONS(6554),
    [anon_sym_BSLASHintertext] = ACTIONS(6554),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [1901] = {
    [sym_command_name] = ACTIONS(6642),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6642),
    [anon_sym_LPAREN] = ACTIONS(6644),
    [anon_sym_RPAREN] = ACTIONS(6644),
    [anon_sym_LBRACE] = ACTIONS(6644),
    [anon_sym_RBRACE] = ACTIONS(6644),
    [anon_sym_BSLASHand] = ACTIONS(6642),
    [sym_word] = ACTIONS(6642),
    [sym_placeholder] = ACTIONS(6644),
    [anon_sym_PLUS] = ACTIONS(6644),
    [anon_sym_DASH] = ACTIONS(6644),
    [anon_sym_STAR] = ACTIONS(6644),
    [anon_sym_SLASH] = ACTIONS(6644),
    [anon_sym_LT] = ACTIONS(6642),
    [anon_sym_GT] = ACTIONS(6642),
    [anon_sym_BANG] = ACTIONS(6642),
    [anon_sym_PIPE] = ACTIONS(6642),
    [anon_sym_COLON] = ACTIONS(6642),
    [anon_sym_SQUOTE] = ACTIONS(6642),
    [anon_sym__] = ACTIONS(6644),
    [anon_sym_CARET] = ACTIONS(6644),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6644),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6644),
    [anon_sym_DOLLAR] = ACTIONS(6642),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6644),
    [anon_sym_BSLASHtitle] = ACTIONS(6642),
    [anon_sym_BSLASHauthor] = ACTIONS(6642),
    [anon_sym_BSLASHusepackage] = ACTIONS(6642),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6642),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6642),
    [anon_sym_BSLASHinclude] = ACTIONS(6642),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6642),
    [anon_sym_BSLASHinput] = ACTIONS(6642),
    [anon_sym_BSLASHsubfile] = ACTIONS(6642),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6642),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6642),
    [anon_sym_BSLASHbibliography] = ACTIONS(6642),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6642),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6642),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6642),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6642),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6642),
    [anon_sym_BSLASHimport] = ACTIONS(6642),
    [anon_sym_BSLASHsubimport] = ACTIONS(6642),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6642),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6642),
    [anon_sym_BSLASHcaption] = ACTIONS(6642),
    [anon_sym_BSLASHcite] = ACTIONS(6642),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCite] = ACTIONS(6642),
    [anon_sym_BSLASHnocite] = ACTIONS(6642),
    [anon_sym_BSLASHcitet] = ACTIONS(6642),
    [anon_sym_BSLASHcitep] = ACTIONS(6642),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteA] = ACTIONS(6642),
    [anon_sym_BSLASHciteR] = ACTIONS(6642),
    [anon_sym_BSLASHciteS] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6642),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6642),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteyear] = ACTIONS(6642),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHcitedate] = ACTIONS(6642),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHciteurl] = ACTIONS(6642),
    [anon_sym_BSLASHfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6642),
    [anon_sym_BSLASHcitealt] = ACTIONS(6642),
    [anon_sym_BSLASHcitealp] = ACTIONS(6642),
    [anon_sym_BSLASHcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHparencite] = ACTIONS(6642),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHParencite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6642),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6642),
    [anon_sym_BSLASHtextcite] = ACTIONS(6642),
    [anon_sym_BSLASHTextcite] = ACTIONS(6642),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6642),
    [anon_sym_BSLASHsupercite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite] = ACTIONS(6642),
    [anon_sym_BSLASHAutocite] = ACTIONS(6642),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHVolcite] = ACTIONS(6642),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHavolcite] = ACTIONS(6642),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6642),
    [anon_sym_BSLASHnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHNotecite] = ACTIONS(6642),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6642),
    [anon_sym_BSLASHlabel] = ACTIONS(6642),
    [anon_sym_BSLASHref] = ACTIONS(6642),
    [anon_sym_BSLASHeqref] = ACTIONS(6642),
    [anon_sym_BSLASHvref] = ACTIONS(6642),
    [anon_sym_BSLASHVref] = ACTIONS(6642),
    [anon_sym_BSLASHautoref] = ACTIONS(6642),
    [anon_sym_BSLASHpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcref] = ACTIONS(6642),
    [anon_sym_BSLASHCref] = ACTIONS(6642),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnameCref] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6642),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6642),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6642),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6642),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6642),
    [anon_sym_BSLASHdef] = ACTIONS(6642),
    [anon_sym_BSLASHlet] = ACTIONS(6642),
    [anon_sym_BSLASHleft] = ACTIONS(6642),
    [anon_sym_BSLASHbigl] = ACTIONS(6642),
    [anon_sym_BSLASHBigl] = ACTIONS(6642),
    [anon_sym_BSLASHbiggl] = ACTIONS(6642),
    [anon_sym_BSLASHBiggl] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6642),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6642),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6642),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6642),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6642),
    [anon_sym_BSLASHgls] = ACTIONS(6642),
    [anon_sym_BSLASHGls] = ACTIONS(6642),
    [anon_sym_BSLASHGLS] = ACTIONS(6642),
    [anon_sym_BSLASHglspl] = ACTIONS(6642),
    [anon_sym_BSLASHGlspl] = ACTIONS(6642),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6642),
    [anon_sym_BSLASHglslink] = ACTIONS(6642),
    [anon_sym_BSLASHglstext] = ACTIONS(6642),
    [anon_sym_BSLASHGlstext] = ACTIONS(6642),
    [anon_sym_BSLASHGLStext] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6642),
    [anon_sym_BSLASHglsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6642),
    [anon_sym_BSLASHglsname] = ACTIONS(6642),
    [anon_sym_BSLASHGlsname] = ACTIONS(6642),
    [anon_sym_BSLASHGLSname] = ACTIONS(6642),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6642),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6642),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6642),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6642),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6642),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6642),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6642),
    [anon_sym_BSLASHacrshort] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6642),
    [anon_sym_BSLASHACRshort] = ACTIONS(6642),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrlong] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6642),
    [anon_sym_BSLASHACRlong] = ACTIONS(6642),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6642),
    [anon_sym_BSLASHacrfull] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6642),
    [anon_sym_BSLASHACRfull] = ACTIONS(6642),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHacs] = ACTIONS(6642),
    [anon_sym_BSLASHAcs] = ACTIONS(6642),
    [anon_sym_BSLASHacsp] = ACTIONS(6642),
    [anon_sym_BSLASHAcsp] = ACTIONS(6642),
    [anon_sym_BSLASHacl] = ACTIONS(6642),
    [anon_sym_BSLASHAcl] = ACTIONS(6642),
    [anon_sym_BSLASHaclp] = ACTIONS(6642),
    [anon_sym_BSLASHAclp] = ACTIONS(6642),
    [anon_sym_BSLASHacf] = ACTIONS(6642),
    [anon_sym_BSLASHAcf] = ACTIONS(6642),
    [anon_sym_BSLASHacfp] = ACTIONS(6642),
    [anon_sym_BSLASHAcfp] = ACTIONS(6642),
    [anon_sym_BSLASHac] = ACTIONS(6642),
    [anon_sym_BSLASHAc] = ACTIONS(6642),
    [anon_sym_BSLASHacp] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6642),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6642),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6642),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6642),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6644),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6642),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6642),
    [anon_sym_BSLASHcolor] = ACTIONS(6642),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6642),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6642),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6642),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6642),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6642),
    [anon_sym_BSLASHtext] = ACTIONS(6642),
    [anon_sym_BSLASHintertext] = ACTIONS(6642),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6642),
    [anon_sym_BSLASHurl] = ACTIONS(6642),
    [anon_sym_BSLASHhref] = ACTIONS(6642),
  },
  [1902] = {
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_RPAREN] = ACTIONS(6574),
    [anon_sym_LBRACE] = ACTIONS(6574),
    [anon_sym_RBRACE] = ACTIONS(6574),
    [anon_sym_BSLASHand] = ACTIONS(6572),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6574),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6574),
    [anon_sym_DOLLAR] = ACTIONS(6572),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6574),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHleft] = ACTIONS(6572),
    [anon_sym_BSLASHbigl] = ACTIONS(6572),
    [anon_sym_BSLASHBigl] = ACTIONS(6572),
    [anon_sym_BSLASHbiggl] = ACTIONS(6572),
    [anon_sym_BSLASHBiggl] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHtext] = ACTIONS(6572),
    [anon_sym_BSLASHintertext] = ACTIONS(6572),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [1903] = {
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_LPAREN] = ACTIONS(6520),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_LBRACE] = ACTIONS(6520),
    [anon_sym_RBRACE] = ACTIONS(6520),
    [anon_sym_BSLASHand] = ACTIONS(6518),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6520),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6520),
    [anon_sym_DOLLAR] = ACTIONS(6518),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6520),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHleft] = ACTIONS(6518),
    [anon_sym_BSLASHbigl] = ACTIONS(6518),
    [anon_sym_BSLASHBigl] = ACTIONS(6518),
    [anon_sym_BSLASHbiggl] = ACTIONS(6518),
    [anon_sym_BSLASHBiggl] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHtext] = ACTIONS(6518),
    [anon_sym_BSLASHintertext] = ACTIONS(6518),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [1904] = {
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_LPAREN] = ACTIONS(6516),
    [anon_sym_RPAREN] = ACTIONS(6516),
    [anon_sym_LBRACE] = ACTIONS(6516),
    [anon_sym_RBRACE] = ACTIONS(6516),
    [anon_sym_BSLASHand] = ACTIONS(6514),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6516),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(6514),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6516),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHleft] = ACTIONS(6514),
    [anon_sym_BSLASHbigl] = ACTIONS(6514),
    [anon_sym_BSLASHBigl] = ACTIONS(6514),
    [anon_sym_BSLASHbiggl] = ACTIONS(6514),
    [anon_sym_BSLASHBiggl] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHtext] = ACTIONS(6514),
    [anon_sym_BSLASHintertext] = ACTIONS(6514),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [1905] = {
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_LPAREN] = ACTIONS(6512),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_LBRACE] = ACTIONS(6512),
    [anon_sym_RBRACE] = ACTIONS(6512),
    [anon_sym_BSLASHand] = ACTIONS(6510),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6512),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6512),
    [anon_sym_DOLLAR] = ACTIONS(6510),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6512),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHleft] = ACTIONS(6510),
    [anon_sym_BSLASHbigl] = ACTIONS(6510),
    [anon_sym_BSLASHBigl] = ACTIONS(6510),
    [anon_sym_BSLASHbiggl] = ACTIONS(6510),
    [anon_sym_BSLASHBiggl] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHtext] = ACTIONS(6510),
    [anon_sym_BSLASHintertext] = ACTIONS(6510),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [1906] = {
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_LPAREN] = ACTIONS(6508),
    [anon_sym_RPAREN] = ACTIONS(6508),
    [anon_sym_LBRACE] = ACTIONS(6508),
    [anon_sym_RBRACE] = ACTIONS(6508),
    [anon_sym_BSLASHand] = ACTIONS(6506),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6508),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(6506),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6508),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHleft] = ACTIONS(6506),
    [anon_sym_BSLASHbigl] = ACTIONS(6506),
    [anon_sym_BSLASHBigl] = ACTIONS(6506),
    [anon_sym_BSLASHbiggl] = ACTIONS(6506),
    [anon_sym_BSLASHBiggl] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHtext] = ACTIONS(6506),
    [anon_sym_BSLASHintertext] = ACTIONS(6506),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [1907] = {
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_LPAREN] = ACTIONS(6500),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_LBRACE] = ACTIONS(6500),
    [anon_sym_RBRACE] = ACTIONS(6500),
    [anon_sym_BSLASHand] = ACTIONS(6498),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6500),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6500),
    [anon_sym_DOLLAR] = ACTIONS(6498),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6500),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHleft] = ACTIONS(6498),
    [anon_sym_BSLASHbigl] = ACTIONS(6498),
    [anon_sym_BSLASHBigl] = ACTIONS(6498),
    [anon_sym_BSLASHbiggl] = ACTIONS(6498),
    [anon_sym_BSLASHBiggl] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHtext] = ACTIONS(6498),
    [anon_sym_BSLASHintertext] = ACTIONS(6498),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [1908] = {
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_LPAREN] = ACTIONS(6496),
    [anon_sym_RPAREN] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [anon_sym_RBRACE] = ACTIONS(6496),
    [anon_sym_BSLASHand] = ACTIONS(6494),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6496),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6496),
    [anon_sym_DOLLAR] = ACTIONS(6494),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6496),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHleft] = ACTIONS(6494),
    [anon_sym_BSLASHbigl] = ACTIONS(6494),
    [anon_sym_BSLASHBigl] = ACTIONS(6494),
    [anon_sym_BSLASHbiggl] = ACTIONS(6494),
    [anon_sym_BSLASHBiggl] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHtext] = ACTIONS(6494),
    [anon_sym_BSLASHintertext] = ACTIONS(6494),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [1909] = {
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_LPAREN] = ACTIONS(6488),
    [anon_sym_RPAREN] = ACTIONS(6488),
    [anon_sym_LBRACE] = ACTIONS(6488),
    [anon_sym_RBRACE] = ACTIONS(6488),
    [anon_sym_BSLASHand] = ACTIONS(6486),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6488),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(6486),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6488),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHleft] = ACTIONS(6486),
    [anon_sym_BSLASHbigl] = ACTIONS(6486),
    [anon_sym_BSLASHBigl] = ACTIONS(6486),
    [anon_sym_BSLASHbiggl] = ACTIONS(6486),
    [anon_sym_BSLASHBiggl] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHtext] = ACTIONS(6486),
    [anon_sym_BSLASHintertext] = ACTIONS(6486),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [1910] = {
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_LPAREN] = ACTIONS(6484),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_LBRACE] = ACTIONS(6484),
    [anon_sym_RBRACE] = ACTIONS(6484),
    [anon_sym_BSLASHand] = ACTIONS(6482),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6484),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6484),
    [anon_sym_DOLLAR] = ACTIONS(6482),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6484),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHleft] = ACTIONS(6482),
    [anon_sym_BSLASHbigl] = ACTIONS(6482),
    [anon_sym_BSLASHBigl] = ACTIONS(6482),
    [anon_sym_BSLASHbiggl] = ACTIONS(6482),
    [anon_sym_BSLASHBiggl] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHtext] = ACTIONS(6482),
    [anon_sym_BSLASHintertext] = ACTIONS(6482),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [1911] = {
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_LPAREN] = ACTIONS(6476),
    [anon_sym_RPAREN] = ACTIONS(6476),
    [anon_sym_LBRACE] = ACTIONS(6476),
    [anon_sym_RBRACE] = ACTIONS(6476),
    [anon_sym_BSLASHand] = ACTIONS(6474),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6476),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6476),
    [anon_sym_DOLLAR] = ACTIONS(6474),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6476),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHleft] = ACTIONS(6474),
    [anon_sym_BSLASHbigl] = ACTIONS(6474),
    [anon_sym_BSLASHBigl] = ACTIONS(6474),
    [anon_sym_BSLASHbiggl] = ACTIONS(6474),
    [anon_sym_BSLASHBiggl] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHtext] = ACTIONS(6474),
    [anon_sym_BSLASHintertext] = ACTIONS(6474),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [1912] = {
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_LPAREN] = ACTIONS(6424),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_LBRACE] = ACTIONS(6424),
    [anon_sym_RBRACE] = ACTIONS(6424),
    [anon_sym_BSLASHand] = ACTIONS(6422),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6424),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6424),
    [anon_sym_DOLLAR] = ACTIONS(6422),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6424),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHleft] = ACTIONS(6422),
    [anon_sym_BSLASHbigl] = ACTIONS(6422),
    [anon_sym_BSLASHBigl] = ACTIONS(6422),
    [anon_sym_BSLASHbiggl] = ACTIONS(6422),
    [anon_sym_BSLASHBiggl] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHtext] = ACTIONS(6422),
    [anon_sym_BSLASHintertext] = ACTIONS(6422),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [1913] = {
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_LPAREN] = ACTIONS(6468),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_LBRACE] = ACTIONS(6468),
    [anon_sym_RBRACE] = ACTIONS(6468),
    [anon_sym_BSLASHand] = ACTIONS(6466),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6468),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6468),
    [anon_sym_DOLLAR] = ACTIONS(6466),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6468),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHleft] = ACTIONS(6466),
    [anon_sym_BSLASHbigl] = ACTIONS(6466),
    [anon_sym_BSLASHBigl] = ACTIONS(6466),
    [anon_sym_BSLASHbiggl] = ACTIONS(6466),
    [anon_sym_BSLASHBiggl] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHtext] = ACTIONS(6466),
    [anon_sym_BSLASHintertext] = ACTIONS(6466),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [1914] = {
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_LPAREN] = ACTIONS(6464),
    [anon_sym_RPAREN] = ACTIONS(6464),
    [anon_sym_LBRACE] = ACTIONS(6464),
    [anon_sym_RBRACE] = ACTIONS(6464),
    [anon_sym_BSLASHand] = ACTIONS(6462),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6464),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(6462),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6464),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHleft] = ACTIONS(6462),
    [anon_sym_BSLASHbigl] = ACTIONS(6462),
    [anon_sym_BSLASHBigl] = ACTIONS(6462),
    [anon_sym_BSLASHbiggl] = ACTIONS(6462),
    [anon_sym_BSLASHBiggl] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHtext] = ACTIONS(6462),
    [anon_sym_BSLASHintertext] = ACTIONS(6462),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [1915] = {
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_LPAREN] = ACTIONS(6460),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_LBRACE] = ACTIONS(6460),
    [anon_sym_RBRACE] = ACTIONS(6460),
    [anon_sym_BSLASHand] = ACTIONS(6458),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6460),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6460),
    [anon_sym_DOLLAR] = ACTIONS(6458),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6460),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHleft] = ACTIONS(6458),
    [anon_sym_BSLASHbigl] = ACTIONS(6458),
    [anon_sym_BSLASHBigl] = ACTIONS(6458),
    [anon_sym_BSLASHbiggl] = ACTIONS(6458),
    [anon_sym_BSLASHBiggl] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHtext] = ACTIONS(6458),
    [anon_sym_BSLASHintertext] = ACTIONS(6458),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [1916] = {
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_LPAREN] = ACTIONS(6372),
    [anon_sym_RPAREN] = ACTIONS(6372),
    [anon_sym_LBRACE] = ACTIONS(6372),
    [anon_sym_RBRACE] = ACTIONS(6372),
    [anon_sym_BSLASHand] = ACTIONS(6370),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6372),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6372),
    [anon_sym_DOLLAR] = ACTIONS(6370),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6372),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHleft] = ACTIONS(6370),
    [anon_sym_BSLASHbigl] = ACTIONS(6370),
    [anon_sym_BSLASHBigl] = ACTIONS(6370),
    [anon_sym_BSLASHbiggl] = ACTIONS(6370),
    [anon_sym_BSLASHBiggl] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHtext] = ACTIONS(6370),
    [anon_sym_BSLASHintertext] = ACTIONS(6370),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [1917] = {
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_LPAREN] = ACTIONS(6368),
    [anon_sym_RPAREN] = ACTIONS(6368),
    [anon_sym_LBRACE] = ACTIONS(6368),
    [anon_sym_RBRACE] = ACTIONS(6368),
    [anon_sym_BSLASHand] = ACTIONS(6366),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6368),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6368),
    [anon_sym_DOLLAR] = ACTIONS(6366),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6368),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHleft] = ACTIONS(6366),
    [anon_sym_BSLASHbigl] = ACTIONS(6366),
    [anon_sym_BSLASHBigl] = ACTIONS(6366),
    [anon_sym_BSLASHbiggl] = ACTIONS(6366),
    [anon_sym_BSLASHBiggl] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHtext] = ACTIONS(6366),
    [anon_sym_BSLASHintertext] = ACTIONS(6366),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [1918] = {
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_LPAREN] = ACTIONS(6360),
    [anon_sym_RPAREN] = ACTIONS(6360),
    [anon_sym_LBRACE] = ACTIONS(6360),
    [anon_sym_RBRACE] = ACTIONS(6360),
    [anon_sym_BSLASHand] = ACTIONS(6358),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6360),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6360),
    [anon_sym_DOLLAR] = ACTIONS(6358),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6360),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHleft] = ACTIONS(6358),
    [anon_sym_BSLASHbigl] = ACTIONS(6358),
    [anon_sym_BSLASHBigl] = ACTIONS(6358),
    [anon_sym_BSLASHbiggl] = ACTIONS(6358),
    [anon_sym_BSLASHBiggl] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHtext] = ACTIONS(6358),
    [anon_sym_BSLASHintertext] = ACTIONS(6358),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [1919] = {
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_LPAREN] = ACTIONS(6344),
    [anon_sym_RPAREN] = ACTIONS(6344),
    [anon_sym_LBRACE] = ACTIONS(6344),
    [anon_sym_RBRACE] = ACTIONS(6344),
    [anon_sym_BSLASHand] = ACTIONS(6342),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6344),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6344),
    [anon_sym_DOLLAR] = ACTIONS(6342),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6344),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHleft] = ACTIONS(6342),
    [anon_sym_BSLASHbigl] = ACTIONS(6342),
    [anon_sym_BSLASHBigl] = ACTIONS(6342),
    [anon_sym_BSLASHbiggl] = ACTIONS(6342),
    [anon_sym_BSLASHBiggl] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHtext] = ACTIONS(6342),
    [anon_sym_BSLASHintertext] = ACTIONS(6342),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [1920] = {
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_LPAREN] = ACTIONS(6340),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_LBRACE] = ACTIONS(6340),
    [anon_sym_RBRACE] = ACTIONS(6340),
    [anon_sym_BSLASHand] = ACTIONS(6338),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6340),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6340),
    [anon_sym_DOLLAR] = ACTIONS(6338),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6340),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHleft] = ACTIONS(6338),
    [anon_sym_BSLASHbigl] = ACTIONS(6338),
    [anon_sym_BSLASHBigl] = ACTIONS(6338),
    [anon_sym_BSLASHbiggl] = ACTIONS(6338),
    [anon_sym_BSLASHBiggl] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHtext] = ACTIONS(6338),
    [anon_sym_BSLASHintertext] = ACTIONS(6338),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [1921] = {
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_LPAREN] = ACTIONS(6308),
    [anon_sym_RPAREN] = ACTIONS(6308),
    [anon_sym_LBRACE] = ACTIONS(6308),
    [anon_sym_RBRACE] = ACTIONS(6308),
    [anon_sym_BSLASHand] = ACTIONS(6306),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6308),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6308),
    [anon_sym_DOLLAR] = ACTIONS(6306),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6308),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHleft] = ACTIONS(6306),
    [anon_sym_BSLASHbigl] = ACTIONS(6306),
    [anon_sym_BSLASHBigl] = ACTIONS(6306),
    [anon_sym_BSLASHbiggl] = ACTIONS(6306),
    [anon_sym_BSLASHBiggl] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHtext] = ACTIONS(6306),
    [anon_sym_BSLASHintertext] = ACTIONS(6306),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [1922] = {
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_LPAREN] = ACTIONS(6304),
    [anon_sym_RPAREN] = ACTIONS(6304),
    [anon_sym_LBRACE] = ACTIONS(6304),
    [anon_sym_RBRACE] = ACTIONS(6304),
    [anon_sym_BSLASHand] = ACTIONS(6302),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6304),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6304),
    [anon_sym_DOLLAR] = ACTIONS(6302),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6304),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHleft] = ACTIONS(6302),
    [anon_sym_BSLASHbigl] = ACTIONS(6302),
    [anon_sym_BSLASHBigl] = ACTIONS(6302),
    [anon_sym_BSLASHbiggl] = ACTIONS(6302),
    [anon_sym_BSLASHBiggl] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHtext] = ACTIONS(6302),
    [anon_sym_BSLASHintertext] = ACTIONS(6302),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [1923] = {
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_LPAREN] = ACTIONS(6300),
    [anon_sym_RPAREN] = ACTIONS(6300),
    [anon_sym_LBRACE] = ACTIONS(6300),
    [anon_sym_RBRACE] = ACTIONS(6300),
    [anon_sym_BSLASHand] = ACTIONS(6298),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6300),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6300),
    [anon_sym_DOLLAR] = ACTIONS(6298),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6300),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHleft] = ACTIONS(6298),
    [anon_sym_BSLASHbigl] = ACTIONS(6298),
    [anon_sym_BSLASHBigl] = ACTIONS(6298),
    [anon_sym_BSLASHbiggl] = ACTIONS(6298),
    [anon_sym_BSLASHBiggl] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHtext] = ACTIONS(6298),
    [anon_sym_BSLASHintertext] = ACTIONS(6298),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [1924] = {
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_LPAREN] = ACTIONS(6240),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_LBRACE] = ACTIONS(6240),
    [anon_sym_RBRACE] = ACTIONS(6240),
    [anon_sym_BSLASHand] = ACTIONS(6238),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6240),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6240),
    [anon_sym_DOLLAR] = ACTIONS(6238),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6240),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHleft] = ACTIONS(6238),
    [anon_sym_BSLASHbigl] = ACTIONS(6238),
    [anon_sym_BSLASHBigl] = ACTIONS(6238),
    [anon_sym_BSLASHbiggl] = ACTIONS(6238),
    [anon_sym_BSLASHBiggl] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHtext] = ACTIONS(6238),
    [anon_sym_BSLASHintertext] = ACTIONS(6238),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [1925] = {
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [anon_sym_RPAREN] = ACTIONS(6348),
    [anon_sym_LBRACE] = ACTIONS(6348),
    [anon_sym_RBRACE] = ACTIONS(6348),
    [anon_sym_BSLASHand] = ACTIONS(6346),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6348),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6348),
    [anon_sym_DOLLAR] = ACTIONS(6346),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6348),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHleft] = ACTIONS(6346),
    [anon_sym_BSLASHbigl] = ACTIONS(6346),
    [anon_sym_BSLASHBigl] = ACTIONS(6346),
    [anon_sym_BSLASHbiggl] = ACTIONS(6346),
    [anon_sym_BSLASHBiggl] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHtext] = ACTIONS(6346),
    [anon_sym_BSLASHintertext] = ACTIONS(6346),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [1926] = {
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_LPAREN] = ACTIONS(6420),
    [anon_sym_RPAREN] = ACTIONS(6420),
    [anon_sym_LBRACE] = ACTIONS(6420),
    [anon_sym_RBRACE] = ACTIONS(6420),
    [anon_sym_BSLASHand] = ACTIONS(6418),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6420),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(6418),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6420),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHleft] = ACTIONS(6418),
    [anon_sym_BSLASHbigl] = ACTIONS(6418),
    [anon_sym_BSLASHBigl] = ACTIONS(6418),
    [anon_sym_BSLASHbiggl] = ACTIONS(6418),
    [anon_sym_BSLASHBiggl] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHtext] = ACTIONS(6418),
    [anon_sym_BSLASHintertext] = ACTIONS(6418),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [1927] = {
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_LPAREN] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_BSLASHand] = ACTIONS(6250),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6252),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6252),
    [anon_sym_DOLLAR] = ACTIONS(6250),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6252),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHleft] = ACTIONS(6250),
    [anon_sym_BSLASHbigl] = ACTIONS(6250),
    [anon_sym_BSLASHBigl] = ACTIONS(6250),
    [anon_sym_BSLASHbiggl] = ACTIONS(6250),
    [anon_sym_BSLASHBiggl] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHtext] = ACTIONS(6250),
    [anon_sym_BSLASHintertext] = ACTIONS(6250),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
  [1928] = {
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_LPAREN] = ACTIONS(6268),
    [anon_sym_RPAREN] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(6268),
    [anon_sym_RBRACE] = ACTIONS(6268),
    [anon_sym_BSLASHand] = ACTIONS(6266),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6268),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6268),
    [anon_sym_DOLLAR] = ACTIONS(6266),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6268),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHleft] = ACTIONS(6266),
    [anon_sym_BSLASHbigl] = ACTIONS(6266),
    [anon_sym_BSLASHBigl] = ACTIONS(6266),
    [anon_sym_BSLASHbiggl] = ACTIONS(6266),
    [anon_sym_BSLASHBiggl] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHtext] = ACTIONS(6266),
    [anon_sym_BSLASHintertext] = ACTIONS(6266),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [1929] = {
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_LPAREN] = ACTIONS(6272),
    [anon_sym_RPAREN] = ACTIONS(6272),
    [anon_sym_LBRACE] = ACTIONS(6272),
    [anon_sym_RBRACE] = ACTIONS(6272),
    [anon_sym_BSLASHand] = ACTIONS(6270),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6272),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6272),
    [anon_sym_DOLLAR] = ACTIONS(6270),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6272),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHleft] = ACTIONS(6270),
    [anon_sym_BSLASHbigl] = ACTIONS(6270),
    [anon_sym_BSLASHBigl] = ACTIONS(6270),
    [anon_sym_BSLASHbiggl] = ACTIONS(6270),
    [anon_sym_BSLASHBiggl] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHtext] = ACTIONS(6270),
    [anon_sym_BSLASHintertext] = ACTIONS(6270),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [1930] = {
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_LPAREN] = ACTIONS(6288),
    [anon_sym_RPAREN] = ACTIONS(6288),
    [anon_sym_LBRACE] = ACTIONS(6288),
    [anon_sym_RBRACE] = ACTIONS(6288),
    [anon_sym_BSLASHand] = ACTIONS(6286),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6288),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6288),
    [anon_sym_DOLLAR] = ACTIONS(6286),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6288),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHleft] = ACTIONS(6286),
    [anon_sym_BSLASHbigl] = ACTIONS(6286),
    [anon_sym_BSLASHBigl] = ACTIONS(6286),
    [anon_sym_BSLASHbiggl] = ACTIONS(6286),
    [anon_sym_BSLASHBiggl] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHtext] = ACTIONS(6286),
    [anon_sym_BSLASHintertext] = ACTIONS(6286),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [1931] = {
    [sym_command_name] = ACTIONS(149),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(151),
    [anon_sym_LBRACE] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_BSLASHand] = ACTIONS(149),
    [sym_word] = ACTIONS(149),
    [sym_placeholder] = ACTIONS(151),
    [anon_sym_PLUS] = ACTIONS(151),
    [anon_sym_DASH] = ACTIONS(151),
    [anon_sym_STAR] = ACTIONS(151),
    [anon_sym_SLASH] = ACTIONS(151),
    [anon_sym_LT] = ACTIONS(149),
    [anon_sym_GT] = ACTIONS(149),
    [anon_sym_BANG] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(149),
    [anon_sym__] = ACTIONS(151),
    [anon_sym_CARET] = ACTIONS(151),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(151),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(151),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(151),
    [anon_sym_BSLASHtitle] = ACTIONS(149),
    [anon_sym_BSLASHauthor] = ACTIONS(149),
    [anon_sym_BSLASHusepackage] = ACTIONS(149),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(149),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(149),
    [anon_sym_BSLASHinclude] = ACTIONS(149),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(149),
    [anon_sym_BSLASHinput] = ACTIONS(149),
    [anon_sym_BSLASHsubfile] = ACTIONS(149),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(149),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(149),
    [anon_sym_BSLASHbibliography] = ACTIONS(149),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(149),
    [anon_sym_BSLASHincludesvg] = ACTIONS(149),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(149),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(149),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(149),
    [anon_sym_BSLASHimport] = ACTIONS(149),
    [anon_sym_BSLASHsubimport] = ACTIONS(149),
    [anon_sym_BSLASHinputfrom] = ACTIONS(149),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(149),
    [anon_sym_BSLASHincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(149),
    [anon_sym_BSLASHcaption] = ACTIONS(149),
    [anon_sym_BSLASHcite] = ACTIONS(149),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCite] = ACTIONS(149),
    [anon_sym_BSLASHnocite] = ACTIONS(149),
    [anon_sym_BSLASHcitet] = ACTIONS(149),
    [anon_sym_BSLASHcitep] = ACTIONS(149),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteA] = ACTIONS(149),
    [anon_sym_BSLASHciteR] = ACTIONS(149),
    [anon_sym_BSLASHciteS] = ACTIONS(149),
    [anon_sym_BSLASHciteyearR] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor] = ACTIONS(149),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(149),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitetitle] = ACTIONS(149),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteyear] = ACTIONS(149),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(151),
    [anon_sym_BSLASHcitedate] = ACTIONS(149),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(151),
    [anon_sym_BSLASHciteurl] = ACTIONS(149),
    [anon_sym_BSLASHfullcite] = ACTIONS(149),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(149),
    [anon_sym_BSLASHcitealt] = ACTIONS(149),
    [anon_sym_BSLASHcitealp] = ACTIONS(149),
    [anon_sym_BSLASHcitetext] = ACTIONS(149),
    [anon_sym_BSLASHparencite] = ACTIONS(149),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHParencite] = ACTIONS(149),
    [anon_sym_BSLASHfootcite] = ACTIONS(149),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(149),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(149),
    [anon_sym_BSLASHtextcite] = ACTIONS(149),
    [anon_sym_BSLASHTextcite] = ACTIONS(149),
    [anon_sym_BSLASHsmartcite] = ACTIONS(149),
    [anon_sym_BSLASHSmartcite] = ACTIONS(149),
    [anon_sym_BSLASHsupercite] = ACTIONS(149),
    [anon_sym_BSLASHautocite] = ACTIONS(149),
    [anon_sym_BSLASHAutocite] = ACTIONS(149),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(151),
    [anon_sym_BSLASHvolcite] = ACTIONS(149),
    [anon_sym_BSLASHVolcite] = ACTIONS(149),
    [anon_sym_BSLASHpvolcite] = ACTIONS(149),
    [anon_sym_BSLASHPvolcite] = ACTIONS(149),
    [anon_sym_BSLASHfvolcite] = ACTIONS(149),
    [anon_sym_BSLASHftvolcite] = ACTIONS(149),
    [anon_sym_BSLASHsvolcite] = ACTIONS(149),
    [anon_sym_BSLASHSvolcite] = ACTIONS(149),
    [anon_sym_BSLASHtvolcite] = ACTIONS(149),
    [anon_sym_BSLASHTvolcite] = ACTIONS(149),
    [anon_sym_BSLASHavolcite] = ACTIONS(149),
    [anon_sym_BSLASHAvolcite] = ACTIONS(149),
    [anon_sym_BSLASHnotecite] = ACTIONS(149),
    [anon_sym_BSLASHNotecite] = ACTIONS(149),
    [anon_sym_BSLASHpnotecite] = ACTIONS(149),
    [anon_sym_BSLASHPnotecite] = ACTIONS(149),
    [anon_sym_BSLASHfnotecite] = ACTIONS(149),
    [anon_sym_BSLASHlabel] = ACTIONS(149),
    [anon_sym_BSLASHref] = ACTIONS(149),
    [anon_sym_BSLASHeqref] = ACTIONS(149),
    [anon_sym_BSLASHvref] = ACTIONS(149),
    [anon_sym_BSLASHVref] = ACTIONS(149),
    [anon_sym_BSLASHautoref] = ACTIONS(149),
    [anon_sym_BSLASHpageref] = ACTIONS(149),
    [anon_sym_BSLASHcref] = ACTIONS(149),
    [anon_sym_BSLASHCref] = ACTIONS(149),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnameCref] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(149),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(149),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(149),
    [anon_sym_BSLASHlabelcref] = ACTIONS(149),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange] = ACTIONS(149),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHCrefrange] = ACTIONS(149),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(151),
    [anon_sym_BSLASHnewlabel] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand] = ACTIONS(149),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(149),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(151),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(149),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(151),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(149),
    [anon_sym_BSLASHdef] = ACTIONS(149),
    [anon_sym_BSLASHlet] = ACTIONS(149),
    [anon_sym_BSLASHleft] = ACTIONS(149),
    [anon_sym_BSLASHbigl] = ACTIONS(149),
    [anon_sym_BSLASHBigl] = ACTIONS(149),
    [anon_sym_BSLASHbiggl] = ACTIONS(149),
    [anon_sym_BSLASHBiggl] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(149),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(149),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(149),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(149),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(149),
    [anon_sym_BSLASHgls] = ACTIONS(149),
    [anon_sym_BSLASHGls] = ACTIONS(149),
    [anon_sym_BSLASHGLS] = ACTIONS(149),
    [anon_sym_BSLASHglspl] = ACTIONS(149),
    [anon_sym_BSLASHGlspl] = ACTIONS(149),
    [anon_sym_BSLASHGLSpl] = ACTIONS(149),
    [anon_sym_BSLASHglsdisp] = ACTIONS(149),
    [anon_sym_BSLASHglslink] = ACTIONS(149),
    [anon_sym_BSLASHglstext] = ACTIONS(149),
    [anon_sym_BSLASHGlstext] = ACTIONS(149),
    [anon_sym_BSLASHGLStext] = ACTIONS(149),
    [anon_sym_BSLASHglsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(149),
    [anon_sym_BSLASHglsplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSplural] = ACTIONS(149),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(149),
    [anon_sym_BSLASHglsname] = ACTIONS(149),
    [anon_sym_BSLASHGlsname] = ACTIONS(149),
    [anon_sym_BSLASHGLSname] = ACTIONS(149),
    [anon_sym_BSLASHglssymbol] = ACTIONS(149),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(149),
    [anon_sym_BSLASHglsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(149),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(149),
    [anon_sym_BSLASHglsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(149),
    [anon_sym_BSLASHglsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(149),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(149),
    [anon_sym_BSLASHglsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(149),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(149),
    [anon_sym_BSLASHglsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(149),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(149),
    [anon_sym_BSLASHnewacronym] = ACTIONS(149),
    [anon_sym_BSLASHacrshort] = ACTIONS(149),
    [anon_sym_BSLASHAcrshort] = ACTIONS(149),
    [anon_sym_BSLASHACRshort] = ACTIONS(149),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(149),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(149),
    [anon_sym_BSLASHacrlong] = ACTIONS(149),
    [anon_sym_BSLASHAcrlong] = ACTIONS(149),
    [anon_sym_BSLASHACRlong] = ACTIONS(149),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(149),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(149),
    [anon_sym_BSLASHacrfull] = ACTIONS(149),
    [anon_sym_BSLASHAcrfull] = ACTIONS(149),
    [anon_sym_BSLASHACRfull] = ACTIONS(149),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(149),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(149),
    [anon_sym_BSLASHacs] = ACTIONS(149),
    [anon_sym_BSLASHAcs] = ACTIONS(149),
    [anon_sym_BSLASHacsp] = ACTIONS(149),
    [anon_sym_BSLASHAcsp] = ACTIONS(149),
    [anon_sym_BSLASHacl] = ACTIONS(149),
    [anon_sym_BSLASHAcl] = ACTIONS(149),
    [anon_sym_BSLASHaclp] = ACTIONS(149),
    [anon_sym_BSLASHAclp] = ACTIONS(149),
    [anon_sym_BSLASHacf] = ACTIONS(149),
    [anon_sym_BSLASHAcf] = ACTIONS(149),
    [anon_sym_BSLASHacfp] = ACTIONS(149),
    [anon_sym_BSLASHAcfp] = ACTIONS(149),
    [anon_sym_BSLASHac] = ACTIONS(149),
    [anon_sym_BSLASHAc] = ACTIONS(149),
    [anon_sym_BSLASHacp] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(149),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(149),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(149),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(149),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(149),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(151),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(149),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(149),
    [anon_sym_BSLASHcolor] = ACTIONS(149),
    [anon_sym_BSLASHcolorbox] = ACTIONS(149),
    [anon_sym_BSLASHtextcolor] = ACTIONS(149),
    [anon_sym_BSLASHpagecolor] = ACTIONS(149),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(149),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(149),
    [anon_sym_BSLASHtext] = ACTIONS(149),
    [anon_sym_BSLASHintertext] = ACTIONS(149),
    [anon_sym_BSLASHshortintertext] = ACTIONS(149),
    [anon_sym_BSLASHurl] = ACTIONS(149),
    [anon_sym_BSLASHhref] = ACTIONS(149),
  },
  [1932] = {
    [sym_command_name] = ACTIONS(161),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(163),
    [anon_sym_RPAREN] = ACTIONS(163),
    [anon_sym_LBRACE] = ACTIONS(163),
    [anon_sym_RBRACE] = ACTIONS(163),
    [anon_sym_BSLASHand] = ACTIONS(161),
    [sym_word] = ACTIONS(161),
    [sym_placeholder] = ACTIONS(163),
    [anon_sym_PLUS] = ACTIONS(163),
    [anon_sym_DASH] = ACTIONS(163),
    [anon_sym_STAR] = ACTIONS(163),
    [anon_sym_SLASH] = ACTIONS(163),
    [anon_sym_LT] = ACTIONS(161),
    [anon_sym_GT] = ACTIONS(161),
    [anon_sym_BANG] = ACTIONS(161),
    [anon_sym_PIPE] = ACTIONS(161),
    [anon_sym_COLON] = ACTIONS(161),
    [anon_sym_SQUOTE] = ACTIONS(161),
    [anon_sym__] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(163),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(163),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(163),
    [anon_sym_DOLLAR] = ACTIONS(161),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(163),
    [anon_sym_BSLASHtitle] = ACTIONS(161),
    [anon_sym_BSLASHauthor] = ACTIONS(161),
    [anon_sym_BSLASHusepackage] = ACTIONS(161),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(161),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(161),
    [anon_sym_BSLASHinclude] = ACTIONS(161),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(161),
    [anon_sym_BSLASHinput] = ACTIONS(161),
    [anon_sym_BSLASHsubfile] = ACTIONS(161),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(161),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(161),
    [anon_sym_BSLASHbibliography] = ACTIONS(161),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(161),
    [anon_sym_BSLASHincludesvg] = ACTIONS(161),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(161),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(161),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(161),
    [anon_sym_BSLASHimport] = ACTIONS(161),
    [anon_sym_BSLASHsubimport] = ACTIONS(161),
    [anon_sym_BSLASHinputfrom] = ACTIONS(161),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(161),
    [anon_sym_BSLASHincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(161),
    [anon_sym_BSLASHcaption] = ACTIONS(161),
    [anon_sym_BSLASHcite] = ACTIONS(161),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCite] = ACTIONS(161),
    [anon_sym_BSLASHnocite] = ACTIONS(161),
    [anon_sym_BSLASHcitet] = ACTIONS(161),
    [anon_sym_BSLASHcitep] = ACTIONS(161),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteA] = ACTIONS(161),
    [anon_sym_BSLASHciteR] = ACTIONS(161),
    [anon_sym_BSLASHciteS] = ACTIONS(161),
    [anon_sym_BSLASHciteyearR] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor] = ACTIONS(161),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(161),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitetitle] = ACTIONS(161),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteyear] = ACTIONS(161),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(163),
    [anon_sym_BSLASHcitedate] = ACTIONS(161),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(163),
    [anon_sym_BSLASHciteurl] = ACTIONS(161),
    [anon_sym_BSLASHfullcite] = ACTIONS(161),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(161),
    [anon_sym_BSLASHcitealt] = ACTIONS(161),
    [anon_sym_BSLASHcitealp] = ACTIONS(161),
    [anon_sym_BSLASHcitetext] = ACTIONS(161),
    [anon_sym_BSLASHparencite] = ACTIONS(161),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHParencite] = ACTIONS(161),
    [anon_sym_BSLASHfootcite] = ACTIONS(161),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(161),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(161),
    [anon_sym_BSLASHtextcite] = ACTIONS(161),
    [anon_sym_BSLASHTextcite] = ACTIONS(161),
    [anon_sym_BSLASHsmartcite] = ACTIONS(161),
    [anon_sym_BSLASHSmartcite] = ACTIONS(161),
    [anon_sym_BSLASHsupercite] = ACTIONS(161),
    [anon_sym_BSLASHautocite] = ACTIONS(161),
    [anon_sym_BSLASHAutocite] = ACTIONS(161),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(163),
    [anon_sym_BSLASHvolcite] = ACTIONS(161),
    [anon_sym_BSLASHVolcite] = ACTIONS(161),
    [anon_sym_BSLASHpvolcite] = ACTIONS(161),
    [anon_sym_BSLASHPvolcite] = ACTIONS(161),
    [anon_sym_BSLASHfvolcite] = ACTIONS(161),
    [anon_sym_BSLASHftvolcite] = ACTIONS(161),
    [anon_sym_BSLASHsvolcite] = ACTIONS(161),
    [anon_sym_BSLASHSvolcite] = ACTIONS(161),
    [anon_sym_BSLASHtvolcite] = ACTIONS(161),
    [anon_sym_BSLASHTvolcite] = ACTIONS(161),
    [anon_sym_BSLASHavolcite] = ACTIONS(161),
    [anon_sym_BSLASHAvolcite] = ACTIONS(161),
    [anon_sym_BSLASHnotecite] = ACTIONS(161),
    [anon_sym_BSLASHNotecite] = ACTIONS(161),
    [anon_sym_BSLASHpnotecite] = ACTIONS(161),
    [anon_sym_BSLASHPnotecite] = ACTIONS(161),
    [anon_sym_BSLASHfnotecite] = ACTIONS(161),
    [anon_sym_BSLASHlabel] = ACTIONS(161),
    [anon_sym_BSLASHref] = ACTIONS(161),
    [anon_sym_BSLASHeqref] = ACTIONS(161),
    [anon_sym_BSLASHvref] = ACTIONS(161),
    [anon_sym_BSLASHVref] = ACTIONS(161),
    [anon_sym_BSLASHautoref] = ACTIONS(161),
    [anon_sym_BSLASHpageref] = ACTIONS(161),
    [anon_sym_BSLASHcref] = ACTIONS(161),
    [anon_sym_BSLASHCref] = ACTIONS(161),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnameCref] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(161),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(161),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(161),
    [anon_sym_BSLASHlabelcref] = ACTIONS(161),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange] = ACTIONS(161),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHCrefrange] = ACTIONS(161),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(163),
    [anon_sym_BSLASHnewlabel] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand] = ACTIONS(161),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(161),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(163),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(161),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(163),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(161),
    [anon_sym_BSLASHdef] = ACTIONS(161),
    [anon_sym_BSLASHlet] = ACTIONS(161),
    [anon_sym_BSLASHleft] = ACTIONS(161),
    [anon_sym_BSLASHbigl] = ACTIONS(161),
    [anon_sym_BSLASHBigl] = ACTIONS(161),
    [anon_sym_BSLASHbiggl] = ACTIONS(161),
    [anon_sym_BSLASHBiggl] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(161),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(161),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(161),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(161),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(161),
    [anon_sym_BSLASHgls] = ACTIONS(161),
    [anon_sym_BSLASHGls] = ACTIONS(161),
    [anon_sym_BSLASHGLS] = ACTIONS(161),
    [anon_sym_BSLASHglspl] = ACTIONS(161),
    [anon_sym_BSLASHGlspl] = ACTIONS(161),
    [anon_sym_BSLASHGLSpl] = ACTIONS(161),
    [anon_sym_BSLASHglsdisp] = ACTIONS(161),
    [anon_sym_BSLASHglslink] = ACTIONS(161),
    [anon_sym_BSLASHglstext] = ACTIONS(161),
    [anon_sym_BSLASHGlstext] = ACTIONS(161),
    [anon_sym_BSLASHGLStext] = ACTIONS(161),
    [anon_sym_BSLASHglsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(161),
    [anon_sym_BSLASHglsplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSplural] = ACTIONS(161),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(161),
    [anon_sym_BSLASHglsname] = ACTIONS(161),
    [anon_sym_BSLASHGlsname] = ACTIONS(161),
    [anon_sym_BSLASHGLSname] = ACTIONS(161),
    [anon_sym_BSLASHglssymbol] = ACTIONS(161),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(161),
    [anon_sym_BSLASHglsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(161),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(161),
    [anon_sym_BSLASHglsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(161),
    [anon_sym_BSLASHglsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(161),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(161),
    [anon_sym_BSLASHglsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(161),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(161),
    [anon_sym_BSLASHglsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(161),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(161),
    [anon_sym_BSLASHnewacronym] = ACTIONS(161),
    [anon_sym_BSLASHacrshort] = ACTIONS(161),
    [anon_sym_BSLASHAcrshort] = ACTIONS(161),
    [anon_sym_BSLASHACRshort] = ACTIONS(161),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(161),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(161),
    [anon_sym_BSLASHacrlong] = ACTIONS(161),
    [anon_sym_BSLASHAcrlong] = ACTIONS(161),
    [anon_sym_BSLASHACRlong] = ACTIONS(161),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(161),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(161),
    [anon_sym_BSLASHacrfull] = ACTIONS(161),
    [anon_sym_BSLASHAcrfull] = ACTIONS(161),
    [anon_sym_BSLASHACRfull] = ACTIONS(161),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(161),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(161),
    [anon_sym_BSLASHacs] = ACTIONS(161),
    [anon_sym_BSLASHAcs] = ACTIONS(161),
    [anon_sym_BSLASHacsp] = ACTIONS(161),
    [anon_sym_BSLASHAcsp] = ACTIONS(161),
    [anon_sym_BSLASHacl] = ACTIONS(161),
    [anon_sym_BSLASHAcl] = ACTIONS(161),
    [anon_sym_BSLASHaclp] = ACTIONS(161),
    [anon_sym_BSLASHAclp] = ACTIONS(161),
    [anon_sym_BSLASHacf] = ACTIONS(161),
    [anon_sym_BSLASHAcf] = ACTIONS(161),
    [anon_sym_BSLASHacfp] = ACTIONS(161),
    [anon_sym_BSLASHAcfp] = ACTIONS(161),
    [anon_sym_BSLASHac] = ACTIONS(161),
    [anon_sym_BSLASHAc] = ACTIONS(161),
    [anon_sym_BSLASHacp] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(161),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(161),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(161),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(161),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(161),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(163),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(161),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(161),
    [anon_sym_BSLASHcolor] = ACTIONS(161),
    [anon_sym_BSLASHcolorbox] = ACTIONS(161),
    [anon_sym_BSLASHtextcolor] = ACTIONS(161),
    [anon_sym_BSLASHpagecolor] = ACTIONS(161),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(161),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(161),
    [anon_sym_BSLASHtext] = ACTIONS(161),
    [anon_sym_BSLASHintertext] = ACTIONS(161),
    [anon_sym_BSLASHshortintertext] = ACTIONS(161),
    [anon_sym_BSLASHurl] = ACTIONS(161),
    [anon_sym_BSLASHhref] = ACTIONS(161),
  },
  [1933] = {
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_LPAREN] = ACTIONS(6332),
    [anon_sym_RPAREN] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(6332),
    [anon_sym_RBRACE] = ACTIONS(6332),
    [anon_sym_BSLASHand] = ACTIONS(6330),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6332),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6332),
    [anon_sym_DOLLAR] = ACTIONS(6330),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6332),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHleft] = ACTIONS(6330),
    [anon_sym_BSLASHbigl] = ACTIONS(6330),
    [anon_sym_BSLASHBigl] = ACTIONS(6330),
    [anon_sym_BSLASHbiggl] = ACTIONS(6330),
    [anon_sym_BSLASHBiggl] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHtext] = ACTIONS(6330),
    [anon_sym_BSLASHintertext] = ACTIONS(6330),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [1934] = {
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_LPAREN] = ACTIONS(6328),
    [anon_sym_RPAREN] = ACTIONS(6328),
    [anon_sym_LBRACE] = ACTIONS(6328),
    [anon_sym_RBRACE] = ACTIONS(6328),
    [anon_sym_BSLASHand] = ACTIONS(6326),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6328),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6328),
    [anon_sym_DOLLAR] = ACTIONS(6326),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6328),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHleft] = ACTIONS(6326),
    [anon_sym_BSLASHbigl] = ACTIONS(6326),
    [anon_sym_BSLASHBigl] = ACTIONS(6326),
    [anon_sym_BSLASHbiggl] = ACTIONS(6326),
    [anon_sym_BSLASHBiggl] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHtext] = ACTIONS(6326),
    [anon_sym_BSLASHintertext] = ACTIONS(6326),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [1935] = {
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_LPAREN] = ACTIONS(6416),
    [anon_sym_RPAREN] = ACTIONS(6416),
    [anon_sym_LBRACE] = ACTIONS(6416),
    [anon_sym_RBRACE] = ACTIONS(6416),
    [anon_sym_BSLASHand] = ACTIONS(6414),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6416),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(6414),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6416),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHleft] = ACTIONS(6414),
    [anon_sym_BSLASHbigl] = ACTIONS(6414),
    [anon_sym_BSLASHBigl] = ACTIONS(6414),
    [anon_sym_BSLASHbiggl] = ACTIONS(6414),
    [anon_sym_BSLASHBiggl] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHtext] = ACTIONS(6414),
    [anon_sym_BSLASHintertext] = ACTIONS(6414),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [1936] = {
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_LPAREN] = ACTIONS(6412),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_LBRACE] = ACTIONS(6412),
    [anon_sym_RBRACE] = ACTIONS(6412),
    [anon_sym_BSLASHand] = ACTIONS(6410),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6412),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6412),
    [anon_sym_DOLLAR] = ACTIONS(6410),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6412),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHleft] = ACTIONS(6410),
    [anon_sym_BSLASHbigl] = ACTIONS(6410),
    [anon_sym_BSLASHBigl] = ACTIONS(6410),
    [anon_sym_BSLASHbiggl] = ACTIONS(6410),
    [anon_sym_BSLASHBiggl] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHtext] = ACTIONS(6410),
    [anon_sym_BSLASHintertext] = ACTIONS(6410),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [1937] = {
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_LPAREN] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_BSLASHand] = ACTIONS(6234),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6236),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6236),
    [anon_sym_DOLLAR] = ACTIONS(6234),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6236),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHleft] = ACTIONS(6234),
    [anon_sym_BSLASHbigl] = ACTIONS(6234),
    [anon_sym_BSLASHBigl] = ACTIONS(6234),
    [anon_sym_BSLASHbiggl] = ACTIONS(6234),
    [anon_sym_BSLASHBiggl] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHtext] = ACTIONS(6234),
    [anon_sym_BSLASHintertext] = ACTIONS(6234),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [1938] = {
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_LPAREN] = ACTIONS(6408),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_LBRACE] = ACTIONS(6408),
    [anon_sym_RBRACE] = ACTIONS(6408),
    [anon_sym_BSLASHand] = ACTIONS(6406),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6408),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6408),
    [anon_sym_DOLLAR] = ACTIONS(6406),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6408),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHleft] = ACTIONS(6406),
    [anon_sym_BSLASHbigl] = ACTIONS(6406),
    [anon_sym_BSLASHBigl] = ACTIONS(6406),
    [anon_sym_BSLASHbiggl] = ACTIONS(6406),
    [anon_sym_BSLASHBiggl] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHtext] = ACTIONS(6406),
    [anon_sym_BSLASHintertext] = ACTIONS(6406),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [1939] = {
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_LPAREN] = ACTIONS(6292),
    [anon_sym_RPAREN] = ACTIONS(6292),
    [anon_sym_LBRACE] = ACTIONS(6292),
    [anon_sym_RBRACE] = ACTIONS(6292),
    [anon_sym_BSLASHand] = ACTIONS(6290),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6292),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6292),
    [anon_sym_DOLLAR] = ACTIONS(6290),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6292),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHleft] = ACTIONS(6290),
    [anon_sym_BSLASHbigl] = ACTIONS(6290),
    [anon_sym_BSLASHBigl] = ACTIONS(6290),
    [anon_sym_BSLASHbiggl] = ACTIONS(6290),
    [anon_sym_BSLASHBiggl] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHtext] = ACTIONS(6290),
    [anon_sym_BSLASHintertext] = ACTIONS(6290),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [1940] = {
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_LPAREN] = ACTIONS(6324),
    [anon_sym_RPAREN] = ACTIONS(6324),
    [anon_sym_LBRACE] = ACTIONS(6324),
    [anon_sym_RBRACE] = ACTIONS(6324),
    [anon_sym_BSLASHand] = ACTIONS(6322),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6324),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6324),
    [anon_sym_DOLLAR] = ACTIONS(6322),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6324),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHleft] = ACTIONS(6322),
    [anon_sym_BSLASHbigl] = ACTIONS(6322),
    [anon_sym_BSLASHBigl] = ACTIONS(6322),
    [anon_sym_BSLASHbiggl] = ACTIONS(6322),
    [anon_sym_BSLASHBiggl] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHtext] = ACTIONS(6322),
    [anon_sym_BSLASHintertext] = ACTIONS(6322),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [1941] = {
    [sym_command_name] = ACTIONS(6170),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6170),
    [anon_sym_LPAREN] = ACTIONS(6172),
    [anon_sym_RPAREN] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(6172),
    [anon_sym_RBRACE] = ACTIONS(6172),
    [anon_sym_BSLASHand] = ACTIONS(6170),
    [sym_word] = ACTIONS(6170),
    [sym_placeholder] = ACTIONS(6172),
    [anon_sym_PLUS] = ACTIONS(6172),
    [anon_sym_DASH] = ACTIONS(6172),
    [anon_sym_STAR] = ACTIONS(6172),
    [anon_sym_SLASH] = ACTIONS(6172),
    [anon_sym_LT] = ACTIONS(6170),
    [anon_sym_GT] = ACTIONS(6170),
    [anon_sym_BANG] = ACTIONS(6170),
    [anon_sym_PIPE] = ACTIONS(6170),
    [anon_sym_COLON] = ACTIONS(6170),
    [anon_sym_SQUOTE] = ACTIONS(6170),
    [anon_sym__] = ACTIONS(6172),
    [anon_sym_CARET] = ACTIONS(6172),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6172),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6172),
    [anon_sym_DOLLAR] = ACTIONS(6170),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6172),
    [anon_sym_BSLASHtitle] = ACTIONS(6170),
    [anon_sym_BSLASHauthor] = ACTIONS(6170),
    [anon_sym_BSLASHusepackage] = ACTIONS(6170),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6170),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6170),
    [anon_sym_BSLASHinclude] = ACTIONS(6170),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6170),
    [anon_sym_BSLASHinput] = ACTIONS(6170),
    [anon_sym_BSLASHsubfile] = ACTIONS(6170),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6170),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6170),
    [anon_sym_BSLASHbibliography] = ACTIONS(6170),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6170),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6170),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6170),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6170),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6170),
    [anon_sym_BSLASHimport] = ACTIONS(6170),
    [anon_sym_BSLASHsubimport] = ACTIONS(6170),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6170),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6170),
    [anon_sym_BSLASHcaption] = ACTIONS(6170),
    [anon_sym_BSLASHcite] = ACTIONS(6170),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCite] = ACTIONS(6170),
    [anon_sym_BSLASHnocite] = ACTIONS(6170),
    [anon_sym_BSLASHcitet] = ACTIONS(6170),
    [anon_sym_BSLASHcitep] = ACTIONS(6170),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteA] = ACTIONS(6170),
    [anon_sym_BSLASHciteR] = ACTIONS(6170),
    [anon_sym_BSLASHciteS] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6170),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6170),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteyear] = ACTIONS(6170),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHcitedate] = ACTIONS(6170),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHciteurl] = ACTIONS(6170),
    [anon_sym_BSLASHfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6170),
    [anon_sym_BSLASHcitealt] = ACTIONS(6170),
    [anon_sym_BSLASHcitealp] = ACTIONS(6170),
    [anon_sym_BSLASHcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHparencite] = ACTIONS(6170),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHParencite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6170),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6170),
    [anon_sym_BSLASHtextcite] = ACTIONS(6170),
    [anon_sym_BSLASHTextcite] = ACTIONS(6170),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6170),
    [anon_sym_BSLASHsupercite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite] = ACTIONS(6170),
    [anon_sym_BSLASHAutocite] = ACTIONS(6170),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHVolcite] = ACTIONS(6170),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHavolcite] = ACTIONS(6170),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6170),
    [anon_sym_BSLASHnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHNotecite] = ACTIONS(6170),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6170),
    [anon_sym_BSLASHlabel] = ACTIONS(6170),
    [anon_sym_BSLASHref] = ACTIONS(6170),
    [anon_sym_BSLASHeqref] = ACTIONS(6170),
    [anon_sym_BSLASHvref] = ACTIONS(6170),
    [anon_sym_BSLASHVref] = ACTIONS(6170),
    [anon_sym_BSLASHautoref] = ACTIONS(6170),
    [anon_sym_BSLASHpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcref] = ACTIONS(6170),
    [anon_sym_BSLASHCref] = ACTIONS(6170),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnameCref] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6170),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6170),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6170),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6170),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6170),
    [anon_sym_BSLASHdef] = ACTIONS(6170),
    [anon_sym_BSLASHlet] = ACTIONS(6170),
    [anon_sym_BSLASHleft] = ACTIONS(6170),
    [anon_sym_BSLASHbigl] = ACTIONS(6170),
    [anon_sym_BSLASHBigl] = ACTIONS(6170),
    [anon_sym_BSLASHbiggl] = ACTIONS(6170),
    [anon_sym_BSLASHBiggl] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6170),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6170),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6170),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6170),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6170),
    [anon_sym_BSLASHgls] = ACTIONS(6170),
    [anon_sym_BSLASHGls] = ACTIONS(6170),
    [anon_sym_BSLASHGLS] = ACTIONS(6170),
    [anon_sym_BSLASHglspl] = ACTIONS(6170),
    [anon_sym_BSLASHGlspl] = ACTIONS(6170),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6170),
    [anon_sym_BSLASHglslink] = ACTIONS(6170),
    [anon_sym_BSLASHglstext] = ACTIONS(6170),
    [anon_sym_BSLASHGlstext] = ACTIONS(6170),
    [anon_sym_BSLASHGLStext] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6170),
    [anon_sym_BSLASHglsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6170),
    [anon_sym_BSLASHglsname] = ACTIONS(6170),
    [anon_sym_BSLASHGlsname] = ACTIONS(6170),
    [anon_sym_BSLASHGLSname] = ACTIONS(6170),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6170),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6170),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6170),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6170),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6170),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6170),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6170),
    [anon_sym_BSLASHacrshort] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6170),
    [anon_sym_BSLASHACRshort] = ACTIONS(6170),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrlong] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6170),
    [anon_sym_BSLASHACRlong] = ACTIONS(6170),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6170),
    [anon_sym_BSLASHacrfull] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6170),
    [anon_sym_BSLASHACRfull] = ACTIONS(6170),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHacs] = ACTIONS(6170),
    [anon_sym_BSLASHAcs] = ACTIONS(6170),
    [anon_sym_BSLASHacsp] = ACTIONS(6170),
    [anon_sym_BSLASHAcsp] = ACTIONS(6170),
    [anon_sym_BSLASHacl] = ACTIONS(6170),
    [anon_sym_BSLASHAcl] = ACTIONS(6170),
    [anon_sym_BSLASHaclp] = ACTIONS(6170),
    [anon_sym_BSLASHAclp] = ACTIONS(6170),
    [anon_sym_BSLASHacf] = ACTIONS(6170),
    [anon_sym_BSLASHAcf] = ACTIONS(6170),
    [anon_sym_BSLASHacfp] = ACTIONS(6170),
    [anon_sym_BSLASHAcfp] = ACTIONS(6170),
    [anon_sym_BSLASHac] = ACTIONS(6170),
    [anon_sym_BSLASHAc] = ACTIONS(6170),
    [anon_sym_BSLASHacp] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6170),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6170),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6170),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6170),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6172),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6170),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6170),
    [anon_sym_BSLASHcolor] = ACTIONS(6170),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6170),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6170),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6170),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6170),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6170),
    [anon_sym_BSLASHtext] = ACTIONS(6170),
    [anon_sym_BSLASHintertext] = ACTIONS(6170),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6170),
    [anon_sym_BSLASHurl] = ACTIONS(6170),
    [anon_sym_BSLASHhref] = ACTIONS(6170),
  },
  [1942] = {
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_LPAREN] = ACTIONS(6400),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_LBRACE] = ACTIONS(6400),
    [anon_sym_RBRACE] = ACTIONS(6400),
    [anon_sym_BSLASHand] = ACTIONS(6398),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6400),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6400),
    [anon_sym_DOLLAR] = ACTIONS(6398),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6400),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHleft] = ACTIONS(6398),
    [anon_sym_BSLASHbigl] = ACTIONS(6398),
    [anon_sym_BSLASHBigl] = ACTIONS(6398),
    [anon_sym_BSLASHbiggl] = ACTIONS(6398),
    [anon_sym_BSLASHBiggl] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHtext] = ACTIONS(6398),
    [anon_sym_BSLASHintertext] = ACTIONS(6398),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [1943] = {
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_LPAREN] = ACTIONS(6244),
    [anon_sym_RPAREN] = ACTIONS(6244),
    [anon_sym_LBRACE] = ACTIONS(6244),
    [anon_sym_RBRACE] = ACTIONS(6244),
    [anon_sym_BSLASHand] = ACTIONS(6242),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6244),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6244),
    [anon_sym_DOLLAR] = ACTIONS(6242),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6244),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHleft] = ACTIONS(6242),
    [anon_sym_BSLASHbigl] = ACTIONS(6242),
    [anon_sym_BSLASHBigl] = ACTIONS(6242),
    [anon_sym_BSLASHbiggl] = ACTIONS(6242),
    [anon_sym_BSLASHBiggl] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHtext] = ACTIONS(6242),
    [anon_sym_BSLASHintertext] = ACTIONS(6242),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [1944] = {
    [sym_command_name] = ACTIONS(6594),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6594),
    [anon_sym_LPAREN] = ACTIONS(6596),
    [anon_sym_RPAREN] = ACTIONS(6596),
    [anon_sym_LBRACE] = ACTIONS(6596),
    [anon_sym_RBRACE] = ACTIONS(6596),
    [anon_sym_BSLASHand] = ACTIONS(6594),
    [sym_word] = ACTIONS(6594),
    [sym_placeholder] = ACTIONS(6596),
    [anon_sym_PLUS] = ACTIONS(6596),
    [anon_sym_DASH] = ACTIONS(6596),
    [anon_sym_STAR] = ACTIONS(6596),
    [anon_sym_SLASH] = ACTIONS(6596),
    [anon_sym_LT] = ACTIONS(6594),
    [anon_sym_GT] = ACTIONS(6594),
    [anon_sym_BANG] = ACTIONS(6594),
    [anon_sym_PIPE] = ACTIONS(6594),
    [anon_sym_COLON] = ACTIONS(6594),
    [anon_sym_SQUOTE] = ACTIONS(6594),
    [anon_sym__] = ACTIONS(6596),
    [anon_sym_CARET] = ACTIONS(6596),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6596),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(6594),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6596),
    [anon_sym_BSLASHtitle] = ACTIONS(6594),
    [anon_sym_BSLASHauthor] = ACTIONS(6594),
    [anon_sym_BSLASHusepackage] = ACTIONS(6594),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6594),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6594),
    [anon_sym_BSLASHinclude] = ACTIONS(6594),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6594),
    [anon_sym_BSLASHinput] = ACTIONS(6594),
    [anon_sym_BSLASHsubfile] = ACTIONS(6594),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6594),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6594),
    [anon_sym_BSLASHbibliography] = ACTIONS(6594),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6594),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6594),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6594),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6594),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6594),
    [anon_sym_BSLASHimport] = ACTIONS(6594),
    [anon_sym_BSLASHsubimport] = ACTIONS(6594),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6594),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6594),
    [anon_sym_BSLASHcaption] = ACTIONS(6594),
    [anon_sym_BSLASHcite] = ACTIONS(6594),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCite] = ACTIONS(6594),
    [anon_sym_BSLASHnocite] = ACTIONS(6594),
    [anon_sym_BSLASHcitet] = ACTIONS(6594),
    [anon_sym_BSLASHcitep] = ACTIONS(6594),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteA] = ACTIONS(6594),
    [anon_sym_BSLASHciteR] = ACTIONS(6594),
    [anon_sym_BSLASHciteS] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6594),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6594),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteyear] = ACTIONS(6594),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHcitedate] = ACTIONS(6594),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHciteurl] = ACTIONS(6594),
    [anon_sym_BSLASHfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6594),
    [anon_sym_BSLASHcitealt] = ACTIONS(6594),
    [anon_sym_BSLASHcitealp] = ACTIONS(6594),
    [anon_sym_BSLASHcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHparencite] = ACTIONS(6594),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHParencite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6594),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6594),
    [anon_sym_BSLASHtextcite] = ACTIONS(6594),
    [anon_sym_BSLASHTextcite] = ACTIONS(6594),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6594),
    [anon_sym_BSLASHsupercite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite] = ACTIONS(6594),
    [anon_sym_BSLASHAutocite] = ACTIONS(6594),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHVolcite] = ACTIONS(6594),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHavolcite] = ACTIONS(6594),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6594),
    [anon_sym_BSLASHnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHNotecite] = ACTIONS(6594),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6594),
    [anon_sym_BSLASHlabel] = ACTIONS(6594),
    [anon_sym_BSLASHref] = ACTIONS(6594),
    [anon_sym_BSLASHeqref] = ACTIONS(6594),
    [anon_sym_BSLASHvref] = ACTIONS(6594),
    [anon_sym_BSLASHVref] = ACTIONS(6594),
    [anon_sym_BSLASHautoref] = ACTIONS(6594),
    [anon_sym_BSLASHpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcref] = ACTIONS(6594),
    [anon_sym_BSLASHCref] = ACTIONS(6594),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnameCref] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6594),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6594),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6594),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6594),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6594),
    [anon_sym_BSLASHdef] = ACTIONS(6594),
    [anon_sym_BSLASHlet] = ACTIONS(6594),
    [anon_sym_BSLASHleft] = ACTIONS(6594),
    [anon_sym_BSLASHbigl] = ACTIONS(6594),
    [anon_sym_BSLASHBigl] = ACTIONS(6594),
    [anon_sym_BSLASHbiggl] = ACTIONS(6594),
    [anon_sym_BSLASHBiggl] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6594),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6594),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6594),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6594),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6594),
    [anon_sym_BSLASHgls] = ACTIONS(6594),
    [anon_sym_BSLASHGls] = ACTIONS(6594),
    [anon_sym_BSLASHGLS] = ACTIONS(6594),
    [anon_sym_BSLASHglspl] = ACTIONS(6594),
    [anon_sym_BSLASHGlspl] = ACTIONS(6594),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6594),
    [anon_sym_BSLASHglslink] = ACTIONS(6594),
    [anon_sym_BSLASHglstext] = ACTIONS(6594),
    [anon_sym_BSLASHGlstext] = ACTIONS(6594),
    [anon_sym_BSLASHGLStext] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6594),
    [anon_sym_BSLASHglsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6594),
    [anon_sym_BSLASHglsname] = ACTIONS(6594),
    [anon_sym_BSLASHGlsname] = ACTIONS(6594),
    [anon_sym_BSLASHGLSname] = ACTIONS(6594),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6594),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6594),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6594),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6594),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6594),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6594),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6594),
    [anon_sym_BSLASHacrshort] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6594),
    [anon_sym_BSLASHACRshort] = ACTIONS(6594),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrlong] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6594),
    [anon_sym_BSLASHACRlong] = ACTIONS(6594),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6594),
    [anon_sym_BSLASHacrfull] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6594),
    [anon_sym_BSLASHACRfull] = ACTIONS(6594),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHacs] = ACTIONS(6594),
    [anon_sym_BSLASHAcs] = ACTIONS(6594),
    [anon_sym_BSLASHacsp] = ACTIONS(6594),
    [anon_sym_BSLASHAcsp] = ACTIONS(6594),
    [anon_sym_BSLASHacl] = ACTIONS(6594),
    [anon_sym_BSLASHAcl] = ACTIONS(6594),
    [anon_sym_BSLASHaclp] = ACTIONS(6594),
    [anon_sym_BSLASHAclp] = ACTIONS(6594),
    [anon_sym_BSLASHacf] = ACTIONS(6594),
    [anon_sym_BSLASHAcf] = ACTIONS(6594),
    [anon_sym_BSLASHacfp] = ACTIONS(6594),
    [anon_sym_BSLASHAcfp] = ACTIONS(6594),
    [anon_sym_BSLASHac] = ACTIONS(6594),
    [anon_sym_BSLASHAc] = ACTIONS(6594),
    [anon_sym_BSLASHacp] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6594),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6594),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6594),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6594),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6596),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6594),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6594),
    [anon_sym_BSLASHcolor] = ACTIONS(6594),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6594),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6594),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6594),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6594),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6594),
    [anon_sym_BSLASHtext] = ACTIONS(6594),
    [anon_sym_BSLASHintertext] = ACTIONS(6594),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6594),
    [anon_sym_BSLASHurl] = ACTIONS(6594),
    [anon_sym_BSLASHhref] = ACTIONS(6594),
  },
  [1945] = {
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_LPAREN] = ACTIONS(6504),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_LBRACE] = ACTIONS(6504),
    [anon_sym_RBRACE] = ACTIONS(6504),
    [anon_sym_BSLASHand] = ACTIONS(6502),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6504),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6504),
    [anon_sym_DOLLAR] = ACTIONS(6502),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6504),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHleft] = ACTIONS(6502),
    [anon_sym_BSLASHbigl] = ACTIONS(6502),
    [anon_sym_BSLASHBigl] = ACTIONS(6502),
    [anon_sym_BSLASHbiggl] = ACTIONS(6502),
    [anon_sym_BSLASHBiggl] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHtext] = ACTIONS(6502),
    [anon_sym_BSLASHintertext] = ACTIONS(6502),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [1946] = {
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_LPAREN] = ACTIONS(6284),
    [anon_sym_RPAREN] = ACTIONS(6284),
    [anon_sym_LBRACE] = ACTIONS(6284),
    [anon_sym_RBRACE] = ACTIONS(6284),
    [anon_sym_BSLASHand] = ACTIONS(6282),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6284),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6284),
    [anon_sym_DOLLAR] = ACTIONS(6282),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6284),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHleft] = ACTIONS(6282),
    [anon_sym_BSLASHbigl] = ACTIONS(6282),
    [anon_sym_BSLASHBigl] = ACTIONS(6282),
    [anon_sym_BSLASHbiggl] = ACTIONS(6282),
    [anon_sym_BSLASHBiggl] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHtext] = ACTIONS(6282),
    [anon_sym_BSLASHintertext] = ACTIONS(6282),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [1947] = {
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_LPAREN] = ACTIONS(6396),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_LBRACE] = ACTIONS(6396),
    [anon_sym_RBRACE] = ACTIONS(6396),
    [anon_sym_BSLASHand] = ACTIONS(6394),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6396),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6396),
    [anon_sym_DOLLAR] = ACTIONS(6394),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6396),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHleft] = ACTIONS(6394),
    [anon_sym_BSLASHbigl] = ACTIONS(6394),
    [anon_sym_BSLASHBigl] = ACTIONS(6394),
    [anon_sym_BSLASHbiggl] = ACTIONS(6394),
    [anon_sym_BSLASHBiggl] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHtext] = ACTIONS(6394),
    [anon_sym_BSLASHintertext] = ACTIONS(6394),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [1948] = {
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_LPAREN] = ACTIONS(6392),
    [anon_sym_RPAREN] = ACTIONS(6392),
    [anon_sym_LBRACE] = ACTIONS(6392),
    [anon_sym_RBRACE] = ACTIONS(6392),
    [anon_sym_BSLASHand] = ACTIONS(6390),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6392),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(6390),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6392),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHleft] = ACTIONS(6390),
    [anon_sym_BSLASHbigl] = ACTIONS(6390),
    [anon_sym_BSLASHBigl] = ACTIONS(6390),
    [anon_sym_BSLASHbiggl] = ACTIONS(6390),
    [anon_sym_BSLASHBiggl] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHtext] = ACTIONS(6390),
    [anon_sym_BSLASHintertext] = ACTIONS(6390),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [1949] = {
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_LPAREN] = ACTIONS(6588),
    [anon_sym_RPAREN] = ACTIONS(6588),
    [anon_sym_LBRACE] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [anon_sym_BSLASHand] = ACTIONS(6586),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6588),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6588),
    [anon_sym_DOLLAR] = ACTIONS(6586),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6588),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHleft] = ACTIONS(6586),
    [anon_sym_BSLASHbigl] = ACTIONS(6586),
    [anon_sym_BSLASHBigl] = ACTIONS(6586),
    [anon_sym_BSLASHbiggl] = ACTIONS(6586),
    [anon_sym_BSLASHBiggl] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHtext] = ACTIONS(6586),
    [anon_sym_BSLASHintertext] = ACTIONS(6586),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [1950] = {
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_LPAREN] = ACTIONS(6578),
    [anon_sym_RPAREN] = ACTIONS(6578),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_RBRACE] = ACTIONS(6578),
    [anon_sym_BSLASHand] = ACTIONS(6576),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6578),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6576),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6578),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHleft] = ACTIONS(6576),
    [anon_sym_BSLASHbigl] = ACTIONS(6576),
    [anon_sym_BSLASHBigl] = ACTIONS(6576),
    [anon_sym_BSLASHbiggl] = ACTIONS(6576),
    [anon_sym_BSLASHBiggl] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHtext] = ACTIONS(6576),
    [anon_sym_BSLASHintertext] = ACTIONS(6576),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [1951] = {
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_LPAREN] = ACTIONS(6560),
    [anon_sym_RPAREN] = ACTIONS(6560),
    [anon_sym_LBRACE] = ACTIONS(6560),
    [anon_sym_RBRACE] = ACTIONS(6560),
    [anon_sym_BSLASHand] = ACTIONS(6558),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6560),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(6558),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6560),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHleft] = ACTIONS(6558),
    [anon_sym_BSLASHbigl] = ACTIONS(6558),
    [anon_sym_BSLASHBigl] = ACTIONS(6558),
    [anon_sym_BSLASHbiggl] = ACTIONS(6558),
    [anon_sym_BSLASHBiggl] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHtext] = ACTIONS(6558),
    [anon_sym_BSLASHintertext] = ACTIONS(6558),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [1952] = {
    [sym_command_name] = ACTIONS(165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(165),
    [anon_sym_LPAREN] = ACTIONS(167),
    [anon_sym_RPAREN] = ACTIONS(167),
    [anon_sym_LBRACE] = ACTIONS(167),
    [anon_sym_RBRACE] = ACTIONS(167),
    [anon_sym_BSLASHand] = ACTIONS(165),
    [sym_word] = ACTIONS(165),
    [sym_placeholder] = ACTIONS(167),
    [anon_sym_PLUS] = ACTIONS(167),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(167),
    [anon_sym_SLASH] = ACTIONS(167),
    [anon_sym_LT] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(165),
    [anon_sym_BANG] = ACTIONS(165),
    [anon_sym_PIPE] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(165),
    [anon_sym_SQUOTE] = ACTIONS(165),
    [anon_sym__] = ACTIONS(167),
    [anon_sym_CARET] = ACTIONS(167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(167),
    [anon_sym_DOLLAR] = ACTIONS(165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(167),
    [anon_sym_BSLASHtitle] = ACTIONS(165),
    [anon_sym_BSLASHauthor] = ACTIONS(165),
    [anon_sym_BSLASHusepackage] = ACTIONS(165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(165),
    [anon_sym_BSLASHinclude] = ACTIONS(165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(165),
    [anon_sym_BSLASHinput] = ACTIONS(165),
    [anon_sym_BSLASHsubfile] = ACTIONS(165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(165),
    [anon_sym_BSLASHbibliography] = ACTIONS(165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(165),
    [anon_sym_BSLASHimport] = ACTIONS(165),
    [anon_sym_BSLASHsubimport] = ACTIONS(165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(165),
    [anon_sym_BSLASHcaption] = ACTIONS(165),
    [anon_sym_BSLASHcite] = ACTIONS(165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCite] = ACTIONS(165),
    [anon_sym_BSLASHnocite] = ACTIONS(165),
    [anon_sym_BSLASHcitet] = ACTIONS(165),
    [anon_sym_BSLASHcitep] = ACTIONS(165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteA] = ACTIONS(165),
    [anon_sym_BSLASHciteR] = ACTIONS(165),
    [anon_sym_BSLASHciteS] = ACTIONS(165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteyear] = ACTIONS(165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(167),
    [anon_sym_BSLASHcitedate] = ACTIONS(165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(167),
    [anon_sym_BSLASHciteurl] = ACTIONS(165),
    [anon_sym_BSLASHfullcite] = ACTIONS(165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(165),
    [anon_sym_BSLASHcitealt] = ACTIONS(165),
    [anon_sym_BSLASHcitealp] = ACTIONS(165),
    [anon_sym_BSLASHcitetext] = ACTIONS(165),
    [anon_sym_BSLASHparencite] = ACTIONS(165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHParencite] = ACTIONS(165),
    [anon_sym_BSLASHfootcite] = ACTIONS(165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(165),
    [anon_sym_BSLASHtextcite] = ACTIONS(165),
    [anon_sym_BSLASHTextcite] = ACTIONS(165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(165),
    [anon_sym_BSLASHsupercite] = ACTIONS(165),
    [anon_sym_BSLASHautocite] = ACTIONS(165),
    [anon_sym_BSLASHAutocite] = ACTIONS(165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(167),
    [anon_sym_BSLASHvolcite] = ACTIONS(165),
    [anon_sym_BSLASHVolcite] = ACTIONS(165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(165),
    [anon_sym_BSLASHavolcite] = ACTIONS(165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(165),
    [anon_sym_BSLASHnotecite] = ACTIONS(165),
    [anon_sym_BSLASHNotecite] = ACTIONS(165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(165),
    [anon_sym_BSLASHlabel] = ACTIONS(165),
    [anon_sym_BSLASHref] = ACTIONS(165),
    [anon_sym_BSLASHeqref] = ACTIONS(165),
    [anon_sym_BSLASHvref] = ACTIONS(165),
    [anon_sym_BSLASHVref] = ACTIONS(165),
    [anon_sym_BSLASHautoref] = ACTIONS(165),
    [anon_sym_BSLASHpageref] = ACTIONS(165),
    [anon_sym_BSLASHcref] = ACTIONS(165),
    [anon_sym_BSLASHCref] = ACTIONS(165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnameCref] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(165),
    [anon_sym_BSLASHdef] = ACTIONS(165),
    [anon_sym_BSLASHlet] = ACTIONS(165),
    [anon_sym_BSLASHleft] = ACTIONS(165),
    [anon_sym_BSLASHbigl] = ACTIONS(165),
    [anon_sym_BSLASHBigl] = ACTIONS(165),
    [anon_sym_BSLASHbiggl] = ACTIONS(165),
    [anon_sym_BSLASHBiggl] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(165),
    [anon_sym_BSLASHgls] = ACTIONS(165),
    [anon_sym_BSLASHGls] = ACTIONS(165),
    [anon_sym_BSLASHGLS] = ACTIONS(165),
    [anon_sym_BSLASHglspl] = ACTIONS(165),
    [anon_sym_BSLASHGlspl] = ACTIONS(165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(165),
    [anon_sym_BSLASHglslink] = ACTIONS(165),
    [anon_sym_BSLASHglstext] = ACTIONS(165),
    [anon_sym_BSLASHGlstext] = ACTIONS(165),
    [anon_sym_BSLASHGLStext] = ACTIONS(165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(165),
    [anon_sym_BSLASHglsplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(165),
    [anon_sym_BSLASHglsname] = ACTIONS(165),
    [anon_sym_BSLASHGlsname] = ACTIONS(165),
    [anon_sym_BSLASHGLSname] = ACTIONS(165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(165),
    [anon_sym_BSLASHacrshort] = ACTIONS(165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(165),
    [anon_sym_BSLASHACRshort] = ACTIONS(165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(165),
    [anon_sym_BSLASHacrlong] = ACTIONS(165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(165),
    [anon_sym_BSLASHACRlong] = ACTIONS(165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(165),
    [anon_sym_BSLASHacrfull] = ACTIONS(165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(165),
    [anon_sym_BSLASHACRfull] = ACTIONS(165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(165),
    [anon_sym_BSLASHacs] = ACTIONS(165),
    [anon_sym_BSLASHAcs] = ACTIONS(165),
    [anon_sym_BSLASHacsp] = ACTIONS(165),
    [anon_sym_BSLASHAcsp] = ACTIONS(165),
    [anon_sym_BSLASHacl] = ACTIONS(165),
    [anon_sym_BSLASHAcl] = ACTIONS(165),
    [anon_sym_BSLASHaclp] = ACTIONS(165),
    [anon_sym_BSLASHAclp] = ACTIONS(165),
    [anon_sym_BSLASHacf] = ACTIONS(165),
    [anon_sym_BSLASHAcf] = ACTIONS(165),
    [anon_sym_BSLASHacfp] = ACTIONS(165),
    [anon_sym_BSLASHAcfp] = ACTIONS(165),
    [anon_sym_BSLASHac] = ACTIONS(165),
    [anon_sym_BSLASHAc] = ACTIONS(165),
    [anon_sym_BSLASHacp] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(165),
    [anon_sym_BSLASHcolor] = ACTIONS(165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(165),
    [anon_sym_BSLASHtext] = ACTIONS(165),
    [anon_sym_BSLASHintertext] = ACTIONS(165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(165),
    [anon_sym_BSLASHurl] = ACTIONS(165),
    [anon_sym_BSLASHhref] = ACTIONS(165),
  },
  [1953] = {
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_LPAREN] = ACTIONS(6528),
    [anon_sym_RPAREN] = ACTIONS(6528),
    [anon_sym_LBRACE] = ACTIONS(6528),
    [anon_sym_RBRACE] = ACTIONS(6528),
    [anon_sym_BSLASHand] = ACTIONS(6526),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6528),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(6526),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6528),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHleft] = ACTIONS(6526),
    [anon_sym_BSLASHbigl] = ACTIONS(6526),
    [anon_sym_BSLASHBigl] = ACTIONS(6526),
    [anon_sym_BSLASHbiggl] = ACTIONS(6526),
    [anon_sym_BSLASHBiggl] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHtext] = ACTIONS(6526),
    [anon_sym_BSLASHintertext] = ACTIONS(6526),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [1954] = {
    [sym_command_name] = ACTIONS(155),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(155),
    [anon_sym_LPAREN] = ACTIONS(157),
    [anon_sym_RPAREN] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_RBRACE] = ACTIONS(157),
    [anon_sym_BSLASHand] = ACTIONS(155),
    [sym_word] = ACTIONS(155),
    [sym_placeholder] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_LT] = ACTIONS(155),
    [anon_sym_GT] = ACTIONS(155),
    [anon_sym_BANG] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(155),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [anon_sym__] = ACTIONS(157),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(157),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(157),
    [anon_sym_DOLLAR] = ACTIONS(155),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(157),
    [anon_sym_BSLASHtitle] = ACTIONS(155),
    [anon_sym_BSLASHauthor] = ACTIONS(155),
    [anon_sym_BSLASHusepackage] = ACTIONS(155),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(155),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(155),
    [anon_sym_BSLASHinclude] = ACTIONS(155),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(155),
    [anon_sym_BSLASHinput] = ACTIONS(155),
    [anon_sym_BSLASHsubfile] = ACTIONS(155),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(155),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(155),
    [anon_sym_BSLASHbibliography] = ACTIONS(155),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(155),
    [anon_sym_BSLASHincludesvg] = ACTIONS(155),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(155),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(155),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(155),
    [anon_sym_BSLASHimport] = ACTIONS(155),
    [anon_sym_BSLASHsubimport] = ACTIONS(155),
    [anon_sym_BSLASHinputfrom] = ACTIONS(155),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(155),
    [anon_sym_BSLASHincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(155),
    [anon_sym_BSLASHcaption] = ACTIONS(155),
    [anon_sym_BSLASHcite] = ACTIONS(155),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCite] = ACTIONS(155),
    [anon_sym_BSLASHnocite] = ACTIONS(155),
    [anon_sym_BSLASHcitet] = ACTIONS(155),
    [anon_sym_BSLASHcitep] = ACTIONS(155),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteA] = ACTIONS(155),
    [anon_sym_BSLASHciteR] = ACTIONS(155),
    [anon_sym_BSLASHciteS] = ACTIONS(155),
    [anon_sym_BSLASHciteyearR] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor] = ACTIONS(155),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(155),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitetitle] = ACTIONS(155),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteyear] = ACTIONS(155),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(157),
    [anon_sym_BSLASHcitedate] = ACTIONS(155),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(157),
    [anon_sym_BSLASHciteurl] = ACTIONS(155),
    [anon_sym_BSLASHfullcite] = ACTIONS(155),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(155),
    [anon_sym_BSLASHcitealt] = ACTIONS(155),
    [anon_sym_BSLASHcitealp] = ACTIONS(155),
    [anon_sym_BSLASHcitetext] = ACTIONS(155),
    [anon_sym_BSLASHparencite] = ACTIONS(155),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHParencite] = ACTIONS(155),
    [anon_sym_BSLASHfootcite] = ACTIONS(155),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(155),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(155),
    [anon_sym_BSLASHtextcite] = ACTIONS(155),
    [anon_sym_BSLASHTextcite] = ACTIONS(155),
    [anon_sym_BSLASHsmartcite] = ACTIONS(155),
    [anon_sym_BSLASHSmartcite] = ACTIONS(155),
    [anon_sym_BSLASHsupercite] = ACTIONS(155),
    [anon_sym_BSLASHautocite] = ACTIONS(155),
    [anon_sym_BSLASHAutocite] = ACTIONS(155),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(157),
    [anon_sym_BSLASHvolcite] = ACTIONS(155),
    [anon_sym_BSLASHVolcite] = ACTIONS(155),
    [anon_sym_BSLASHpvolcite] = ACTIONS(155),
    [anon_sym_BSLASHPvolcite] = ACTIONS(155),
    [anon_sym_BSLASHfvolcite] = ACTIONS(155),
    [anon_sym_BSLASHftvolcite] = ACTIONS(155),
    [anon_sym_BSLASHsvolcite] = ACTIONS(155),
    [anon_sym_BSLASHSvolcite] = ACTIONS(155),
    [anon_sym_BSLASHtvolcite] = ACTIONS(155),
    [anon_sym_BSLASHTvolcite] = ACTIONS(155),
    [anon_sym_BSLASHavolcite] = ACTIONS(155),
    [anon_sym_BSLASHAvolcite] = ACTIONS(155),
    [anon_sym_BSLASHnotecite] = ACTIONS(155),
    [anon_sym_BSLASHNotecite] = ACTIONS(155),
    [anon_sym_BSLASHpnotecite] = ACTIONS(155),
    [anon_sym_BSLASHPnotecite] = ACTIONS(155),
    [anon_sym_BSLASHfnotecite] = ACTIONS(155),
    [anon_sym_BSLASHlabel] = ACTIONS(155),
    [anon_sym_BSLASHref] = ACTIONS(155),
    [anon_sym_BSLASHeqref] = ACTIONS(155),
    [anon_sym_BSLASHvref] = ACTIONS(155),
    [anon_sym_BSLASHVref] = ACTIONS(155),
    [anon_sym_BSLASHautoref] = ACTIONS(155),
    [anon_sym_BSLASHpageref] = ACTIONS(155),
    [anon_sym_BSLASHcref] = ACTIONS(155),
    [anon_sym_BSLASHCref] = ACTIONS(155),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnameCref] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(155),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(155),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(155),
    [anon_sym_BSLASHlabelcref] = ACTIONS(155),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange] = ACTIONS(155),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHCrefrange] = ACTIONS(155),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(157),
    [anon_sym_BSLASHnewlabel] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand] = ACTIONS(155),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(155),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(157),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(155),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(157),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(155),
    [anon_sym_BSLASHdef] = ACTIONS(155),
    [anon_sym_BSLASHlet] = ACTIONS(155),
    [anon_sym_BSLASHleft] = ACTIONS(155),
    [anon_sym_BSLASHbigl] = ACTIONS(155),
    [anon_sym_BSLASHBigl] = ACTIONS(155),
    [anon_sym_BSLASHbiggl] = ACTIONS(155),
    [anon_sym_BSLASHBiggl] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(155),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(155),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(155),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(155),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(155),
    [anon_sym_BSLASHgls] = ACTIONS(155),
    [anon_sym_BSLASHGls] = ACTIONS(155),
    [anon_sym_BSLASHGLS] = ACTIONS(155),
    [anon_sym_BSLASHglspl] = ACTIONS(155),
    [anon_sym_BSLASHGlspl] = ACTIONS(155),
    [anon_sym_BSLASHGLSpl] = ACTIONS(155),
    [anon_sym_BSLASHglsdisp] = ACTIONS(155),
    [anon_sym_BSLASHglslink] = ACTIONS(155),
    [anon_sym_BSLASHglstext] = ACTIONS(155),
    [anon_sym_BSLASHGlstext] = ACTIONS(155),
    [anon_sym_BSLASHGLStext] = ACTIONS(155),
    [anon_sym_BSLASHglsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(155),
    [anon_sym_BSLASHglsplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSplural] = ACTIONS(155),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(155),
    [anon_sym_BSLASHglsname] = ACTIONS(155),
    [anon_sym_BSLASHGlsname] = ACTIONS(155),
    [anon_sym_BSLASHGLSname] = ACTIONS(155),
    [anon_sym_BSLASHglssymbol] = ACTIONS(155),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(155),
    [anon_sym_BSLASHglsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(155),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(155),
    [anon_sym_BSLASHglsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(155),
    [anon_sym_BSLASHglsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(155),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(155),
    [anon_sym_BSLASHglsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(155),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(155),
    [anon_sym_BSLASHglsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(155),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(155),
    [anon_sym_BSLASHnewacronym] = ACTIONS(155),
    [anon_sym_BSLASHacrshort] = ACTIONS(155),
    [anon_sym_BSLASHAcrshort] = ACTIONS(155),
    [anon_sym_BSLASHACRshort] = ACTIONS(155),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(155),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(155),
    [anon_sym_BSLASHacrlong] = ACTIONS(155),
    [anon_sym_BSLASHAcrlong] = ACTIONS(155),
    [anon_sym_BSLASHACRlong] = ACTIONS(155),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(155),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(155),
    [anon_sym_BSLASHacrfull] = ACTIONS(155),
    [anon_sym_BSLASHAcrfull] = ACTIONS(155),
    [anon_sym_BSLASHACRfull] = ACTIONS(155),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(155),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(155),
    [anon_sym_BSLASHacs] = ACTIONS(155),
    [anon_sym_BSLASHAcs] = ACTIONS(155),
    [anon_sym_BSLASHacsp] = ACTIONS(155),
    [anon_sym_BSLASHAcsp] = ACTIONS(155),
    [anon_sym_BSLASHacl] = ACTIONS(155),
    [anon_sym_BSLASHAcl] = ACTIONS(155),
    [anon_sym_BSLASHaclp] = ACTIONS(155),
    [anon_sym_BSLASHAclp] = ACTIONS(155),
    [anon_sym_BSLASHacf] = ACTIONS(155),
    [anon_sym_BSLASHAcf] = ACTIONS(155),
    [anon_sym_BSLASHacfp] = ACTIONS(155),
    [anon_sym_BSLASHAcfp] = ACTIONS(155),
    [anon_sym_BSLASHac] = ACTIONS(155),
    [anon_sym_BSLASHAc] = ACTIONS(155),
    [anon_sym_BSLASHacp] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(155),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(155),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(155),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(155),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(155),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(157),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(155),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(155),
    [anon_sym_BSLASHcolor] = ACTIONS(155),
    [anon_sym_BSLASHcolorbox] = ACTIONS(155),
    [anon_sym_BSLASHtextcolor] = ACTIONS(155),
    [anon_sym_BSLASHpagecolor] = ACTIONS(155),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(155),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(155),
    [anon_sym_BSLASHtext] = ACTIONS(155),
    [anon_sym_BSLASHintertext] = ACTIONS(155),
    [anon_sym_BSLASHshortintertext] = ACTIONS(155),
    [anon_sym_BSLASHurl] = ACTIONS(155),
    [anon_sym_BSLASHhref] = ACTIONS(155),
  },
  [1955] = {
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_LPAREN] = ACTIONS(6336),
    [anon_sym_RPAREN] = ACTIONS(6336),
    [anon_sym_LBRACE] = ACTIONS(6336),
    [anon_sym_RBRACE] = ACTIONS(6336),
    [anon_sym_BSLASHand] = ACTIONS(6334),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6336),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6336),
    [anon_sym_DOLLAR] = ACTIONS(6334),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6336),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHleft] = ACTIONS(6334),
    [anon_sym_BSLASHbigl] = ACTIONS(6334),
    [anon_sym_BSLASHBigl] = ACTIONS(6334),
    [anon_sym_BSLASHbiggl] = ACTIONS(6334),
    [anon_sym_BSLASHBiggl] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHtext] = ACTIONS(6334),
    [anon_sym_BSLASHintertext] = ACTIONS(6334),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [1956] = {
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_LPAREN] = ACTIONS(6280),
    [anon_sym_RPAREN] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [anon_sym_RBRACE] = ACTIONS(6280),
    [anon_sym_BSLASHand] = ACTIONS(6278),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6280),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6280),
    [anon_sym_DOLLAR] = ACTIONS(6278),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6280),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHleft] = ACTIONS(6278),
    [anon_sym_BSLASHbigl] = ACTIONS(6278),
    [anon_sym_BSLASHBigl] = ACTIONS(6278),
    [anon_sym_BSLASHbiggl] = ACTIONS(6278),
    [anon_sym_BSLASHBiggl] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHtext] = ACTIONS(6278),
    [anon_sym_BSLASHintertext] = ACTIONS(6278),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [1957] = {
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_LPAREN] = ACTIONS(6524),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_LBRACE] = ACTIONS(6524),
    [anon_sym_RBRACE] = ACTIONS(6524),
    [anon_sym_BSLASHand] = ACTIONS(6522),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6524),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6524),
    [anon_sym_DOLLAR] = ACTIONS(6522),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6524),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHleft] = ACTIONS(6522),
    [anon_sym_BSLASHbigl] = ACTIONS(6522),
    [anon_sym_BSLASHBigl] = ACTIONS(6522),
    [anon_sym_BSLASHbiggl] = ACTIONS(6522),
    [anon_sym_BSLASHBiggl] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHtext] = ACTIONS(6522),
    [anon_sym_BSLASHintertext] = ACTIONS(6522),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [1958] = {
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_LPAREN] = ACTIONS(6456),
    [anon_sym_RPAREN] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [anon_sym_RBRACE] = ACTIONS(6456),
    [anon_sym_BSLASHand] = ACTIONS(6454),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6456),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(6454),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6456),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHleft] = ACTIONS(6454),
    [anon_sym_BSLASHbigl] = ACTIONS(6454),
    [anon_sym_BSLASHBigl] = ACTIONS(6454),
    [anon_sym_BSLASHbiggl] = ACTIONS(6454),
    [anon_sym_BSLASHBiggl] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHtext] = ACTIONS(6454),
    [anon_sym_BSLASHintertext] = ACTIONS(6454),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [1959] = {
    [sym_command_name] = ACTIONS(7165),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(7165),
    [anon_sym_LPAREN] = ACTIONS(7167),
    [anon_sym_RPAREN] = ACTIONS(7167),
    [anon_sym_LBRACE] = ACTIONS(7167),
    [anon_sym_RBRACE] = ACTIONS(7167),
    [anon_sym_BSLASHand] = ACTIONS(7165),
    [sym_word] = ACTIONS(7165),
    [sym_placeholder] = ACTIONS(7167),
    [anon_sym_PLUS] = ACTIONS(7167),
    [anon_sym_DASH] = ACTIONS(7167),
    [anon_sym_STAR] = ACTIONS(7167),
    [anon_sym_SLASH] = ACTIONS(7167),
    [anon_sym_LT] = ACTIONS(7165),
    [anon_sym_GT] = ACTIONS(7165),
    [anon_sym_BANG] = ACTIONS(7165),
    [anon_sym_PIPE] = ACTIONS(7165),
    [anon_sym_COLON] = ACTIONS(7165),
    [anon_sym_SQUOTE] = ACTIONS(7165),
    [anon_sym__] = ACTIONS(7167),
    [anon_sym_CARET] = ACTIONS(7167),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(7167),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(7167),
    [anon_sym_DOLLAR] = ACTIONS(7165),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(7167),
    [anon_sym_BSLASHtitle] = ACTIONS(7165),
    [anon_sym_BSLASHauthor] = ACTIONS(7165),
    [anon_sym_BSLASHusepackage] = ACTIONS(7165),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(7165),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(7165),
    [anon_sym_BSLASHinclude] = ACTIONS(7165),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(7165),
    [anon_sym_BSLASHinput] = ACTIONS(7165),
    [anon_sym_BSLASHsubfile] = ACTIONS(7165),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(7165),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(7165),
    [anon_sym_BSLASHbibliography] = ACTIONS(7165),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(7165),
    [anon_sym_BSLASHincludesvg] = ACTIONS(7165),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(7165),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(7165),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(7165),
    [anon_sym_BSLASHimport] = ACTIONS(7165),
    [anon_sym_BSLASHsubimport] = ACTIONS(7165),
    [anon_sym_BSLASHinputfrom] = ACTIONS(7165),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(7165),
    [anon_sym_BSLASHincludefrom] = ACTIONS(7165),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(7165),
    [anon_sym_BSLASHcaption] = ACTIONS(7165),
    [anon_sym_BSLASHcite] = ACTIONS(7165),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHCite] = ACTIONS(7165),
    [anon_sym_BSLASHnocite] = ACTIONS(7165),
    [anon_sym_BSLASHcitet] = ACTIONS(7165),
    [anon_sym_BSLASHcitep] = ACTIONS(7165),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHciteA] = ACTIONS(7165),
    [anon_sym_BSLASHciteR] = ACTIONS(7165),
    [anon_sym_BSLASHciteS] = ACTIONS(7165),
    [anon_sym_BSLASHciteyearR] = ACTIONS(7165),
    [anon_sym_BSLASHciteauthor] = ACTIONS(7165),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(7165),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHcitetitle] = ACTIONS(7165),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHciteyear] = ACTIONS(7165),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHcitedate] = ACTIONS(7165),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHciteurl] = ACTIONS(7165),
    [anon_sym_BSLASHfullcite] = ACTIONS(7165),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(7165),
    [anon_sym_BSLASHcitealt] = ACTIONS(7165),
    [anon_sym_BSLASHcitealp] = ACTIONS(7165),
    [anon_sym_BSLASHcitetext] = ACTIONS(7165),
    [anon_sym_BSLASHparencite] = ACTIONS(7165),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHParencite] = ACTIONS(7165),
    [anon_sym_BSLASHfootcite] = ACTIONS(7165),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(7165),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(7165),
    [anon_sym_BSLASHtextcite] = ACTIONS(7165),
    [anon_sym_BSLASHTextcite] = ACTIONS(7165),
    [anon_sym_BSLASHsmartcite] = ACTIONS(7165),
    [anon_sym_BSLASHSmartcite] = ACTIONS(7165),
    [anon_sym_BSLASHsupercite] = ACTIONS(7165),
    [anon_sym_BSLASHautocite] = ACTIONS(7165),
    [anon_sym_BSLASHAutocite] = ACTIONS(7165),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHVolcite] = ACTIONS(7165),
    [anon_sym_BSLASHpvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHPvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHfvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHftvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHsvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHSvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHtvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHTvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHavolcite] = ACTIONS(7165),
    [anon_sym_BSLASHAvolcite] = ACTIONS(7165),
    [anon_sym_BSLASHnotecite] = ACTIONS(7165),
    [anon_sym_BSLASHNotecite] = ACTIONS(7165),
    [anon_sym_BSLASHpnotecite] = ACTIONS(7165),
    [anon_sym_BSLASHPnotecite] = ACTIONS(7165),
    [anon_sym_BSLASHfnotecite] = ACTIONS(7165),
    [anon_sym_BSLASHlabel] = ACTIONS(7165),
    [anon_sym_BSLASHref] = ACTIONS(7165),
    [anon_sym_BSLASHeqref] = ACTIONS(7165),
    [anon_sym_BSLASHvref] = ACTIONS(7165),
    [anon_sym_BSLASHVref] = ACTIONS(7165),
    [anon_sym_BSLASHautoref] = ACTIONS(7165),
    [anon_sym_BSLASHpageref] = ACTIONS(7165),
    [anon_sym_BSLASHcref] = ACTIONS(7165),
    [anon_sym_BSLASHCref] = ACTIONS(7165),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHnamecref] = ACTIONS(7165),
    [anon_sym_BSLASHnameCref] = ACTIONS(7165),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(7165),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(7165),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(7165),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(7165),
    [anon_sym_BSLASHlabelcref] = ACTIONS(7165),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(7165),
    [anon_sym_BSLASHcrefrange] = ACTIONS(7165),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHCrefrange] = ACTIONS(7165),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHnewlabel] = ACTIONS(7165),
    [anon_sym_BSLASHnewcommand] = ACTIONS(7165),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(7165),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(7165),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(7165),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(7165),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(7165),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(7165),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(7165),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(7165),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(7165),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(7165),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(7165),
    [anon_sym_BSLASHdef] = ACTIONS(7165),
    [anon_sym_BSLASHlet] = ACTIONS(7165),
    [anon_sym_BSLASHleft] = ACTIONS(7165),
    [anon_sym_BSLASHbigl] = ACTIONS(7165),
    [anon_sym_BSLASHBigl] = ACTIONS(7165),
    [anon_sym_BSLASHbiggl] = ACTIONS(7165),
    [anon_sym_BSLASHBiggl] = ACTIONS(7165),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(7165),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(7165),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(7165),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(7165),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(7165),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(7165),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(7165),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(7165),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(7165),
    [anon_sym_BSLASHgls] = ACTIONS(7165),
    [anon_sym_BSLASHGls] = ACTIONS(7165),
    [anon_sym_BSLASHGLS] = ACTIONS(7165),
    [anon_sym_BSLASHglspl] = ACTIONS(7165),
    [anon_sym_BSLASHGlspl] = ACTIONS(7165),
    [anon_sym_BSLASHGLSpl] = ACTIONS(7165),
    [anon_sym_BSLASHglsdisp] = ACTIONS(7165),
    [anon_sym_BSLASHglslink] = ACTIONS(7165),
    [anon_sym_BSLASHglstext] = ACTIONS(7165),
    [anon_sym_BSLASHGlstext] = ACTIONS(7165),
    [anon_sym_BSLASHGLStext] = ACTIONS(7165),
    [anon_sym_BSLASHglsfirst] = ACTIONS(7165),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(7165),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(7165),
    [anon_sym_BSLASHglsplural] = ACTIONS(7165),
    [anon_sym_BSLASHGlsplural] = ACTIONS(7165),
    [anon_sym_BSLASHGLSplural] = ACTIONS(7165),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(7165),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(7165),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(7165),
    [anon_sym_BSLASHglsname] = ACTIONS(7165),
    [anon_sym_BSLASHGlsname] = ACTIONS(7165),
    [anon_sym_BSLASHGLSname] = ACTIONS(7165),
    [anon_sym_BSLASHglssymbol] = ACTIONS(7165),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(7165),
    [anon_sym_BSLASHglsdesc] = ACTIONS(7165),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(7165),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(7165),
    [anon_sym_BSLASHglsuseri] = ACTIONS(7165),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(7165),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(7165),
    [anon_sym_BSLASHglsuserii] = ACTIONS(7165),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(7165),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(7165),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(7165),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(7165),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(7165),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(7165),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(7165),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(7165),
    [anon_sym_BSLASHglsuserv] = ACTIONS(7165),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(7165),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(7165),
    [anon_sym_BSLASHglsuservi] = ACTIONS(7165),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(7165),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(7165),
    [anon_sym_BSLASHnewacronym] = ACTIONS(7165),
    [anon_sym_BSLASHacrshort] = ACTIONS(7165),
    [anon_sym_BSLASHAcrshort] = ACTIONS(7165),
    [anon_sym_BSLASHACRshort] = ACTIONS(7165),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(7165),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(7165),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(7165),
    [anon_sym_BSLASHacrlong] = ACTIONS(7165),
    [anon_sym_BSLASHAcrlong] = ACTIONS(7165),
    [anon_sym_BSLASHACRlong] = ACTIONS(7165),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(7165),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(7165),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(7165),
    [anon_sym_BSLASHacrfull] = ACTIONS(7165),
    [anon_sym_BSLASHAcrfull] = ACTIONS(7165),
    [anon_sym_BSLASHACRfull] = ACTIONS(7165),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(7165),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(7165),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(7165),
    [anon_sym_BSLASHacs] = ACTIONS(7165),
    [anon_sym_BSLASHAcs] = ACTIONS(7165),
    [anon_sym_BSLASHacsp] = ACTIONS(7165),
    [anon_sym_BSLASHAcsp] = ACTIONS(7165),
    [anon_sym_BSLASHacl] = ACTIONS(7165),
    [anon_sym_BSLASHAcl] = ACTIONS(7165),
    [anon_sym_BSLASHaclp] = ACTIONS(7165),
    [anon_sym_BSLASHAclp] = ACTIONS(7165),
    [anon_sym_BSLASHacf] = ACTIONS(7165),
    [anon_sym_BSLASHAcf] = ACTIONS(7165),
    [anon_sym_BSLASHacfp] = ACTIONS(7165),
    [anon_sym_BSLASHAcfp] = ACTIONS(7165),
    [anon_sym_BSLASHac] = ACTIONS(7165),
    [anon_sym_BSLASHAc] = ACTIONS(7165),
    [anon_sym_BSLASHacp] = ACTIONS(7165),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(7165),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(7165),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(7165),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(7165),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(7165),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(7165),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(7165),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(7165),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(7165),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(7165),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(7165),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(7165),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(7167),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(7165),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(7165),
    [anon_sym_BSLASHcolor] = ACTIONS(7165),
    [anon_sym_BSLASHcolorbox] = ACTIONS(7165),
    [anon_sym_BSLASHtextcolor] = ACTIONS(7165),
    [anon_sym_BSLASHpagecolor] = ACTIONS(7165),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(7165),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(7165),
    [anon_sym_BSLASHtext] = ACTIONS(7165),
    [anon_sym_BSLASHintertext] = ACTIONS(7165),
    [anon_sym_BSLASHshortintertext] = ACTIONS(7165),
    [anon_sym_BSLASHurl] = ACTIONS(7165),
    [anon_sym_BSLASHhref] = ACTIONS(7165),
  },
  [1960] = {
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_LPAREN] = ACTIONS(6448),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_LBRACE] = ACTIONS(6448),
    [anon_sym_RBRACE] = ACTIONS(6448),
    [anon_sym_BSLASHand] = ACTIONS(6446),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6448),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6448),
    [anon_sym_DOLLAR] = ACTIONS(6446),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6448),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHleft] = ACTIONS(6446),
    [anon_sym_BSLASHbigl] = ACTIONS(6446),
    [anon_sym_BSLASHBigl] = ACTIONS(6446),
    [anon_sym_BSLASHbiggl] = ACTIONS(6446),
    [anon_sym_BSLASHBiggl] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHtext] = ACTIONS(6446),
    [anon_sym_BSLASHintertext] = ACTIONS(6446),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [1961] = {
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_LPAREN] = ACTIONS(6388),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_LBRACE] = ACTIONS(6388),
    [anon_sym_RBRACE] = ACTIONS(6388),
    [anon_sym_BSLASHand] = ACTIONS(6386),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6388),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(6386),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6388),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHleft] = ACTIONS(6386),
    [anon_sym_BSLASHbigl] = ACTIONS(6386),
    [anon_sym_BSLASHBigl] = ACTIONS(6386),
    [anon_sym_BSLASHbiggl] = ACTIONS(6386),
    [anon_sym_BSLASHBiggl] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHtext] = ACTIONS(6386),
    [anon_sym_BSLASHintertext] = ACTIONS(6386),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [1962] = {
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_LPAREN] = ACTIONS(6364),
    [anon_sym_RPAREN] = ACTIONS(6364),
    [anon_sym_LBRACE] = ACTIONS(6364),
    [anon_sym_RBRACE] = ACTIONS(6364),
    [anon_sym_BSLASHand] = ACTIONS(6362),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6364),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6364),
    [anon_sym_DOLLAR] = ACTIONS(6362),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6364),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHleft] = ACTIONS(6362),
    [anon_sym_BSLASHbigl] = ACTIONS(6362),
    [anon_sym_BSLASHBigl] = ACTIONS(6362),
    [anon_sym_BSLASHbiggl] = ACTIONS(6362),
    [anon_sym_BSLASHBiggl] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHtext] = ACTIONS(6362),
    [anon_sym_BSLASHintertext] = ACTIONS(6362),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [1963] = {
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_LPAREN] = ACTIONS(6440),
    [anon_sym_RPAREN] = ACTIONS(6440),
    [anon_sym_LBRACE] = ACTIONS(6440),
    [anon_sym_RBRACE] = ACTIONS(6440),
    [anon_sym_BSLASHand] = ACTIONS(6438),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6440),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6440),
    [anon_sym_DOLLAR] = ACTIONS(6438),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6440),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHleft] = ACTIONS(6438),
    [anon_sym_BSLASHbigl] = ACTIONS(6438),
    [anon_sym_BSLASHBigl] = ACTIONS(6438),
    [anon_sym_BSLASHbiggl] = ACTIONS(6438),
    [anon_sym_BSLASHBiggl] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHtext] = ACTIONS(6438),
    [anon_sym_BSLASHintertext] = ACTIONS(6438),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [1964] = {
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_LPAREN] = ACTIONS(6436),
    [anon_sym_RPAREN] = ACTIONS(6436),
    [anon_sym_LBRACE] = ACTIONS(6436),
    [anon_sym_RBRACE] = ACTIONS(6436),
    [anon_sym_BSLASHand] = ACTIONS(6434),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6436),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6436),
    [anon_sym_DOLLAR] = ACTIONS(6434),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6436),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHleft] = ACTIONS(6434),
    [anon_sym_BSLASHbigl] = ACTIONS(6434),
    [anon_sym_BSLASHBigl] = ACTIONS(6434),
    [anon_sym_BSLASHbiggl] = ACTIONS(6434),
    [anon_sym_BSLASHBiggl] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHtext] = ACTIONS(6434),
    [anon_sym_BSLASHintertext] = ACTIONS(6434),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [1965] = {
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [anon_sym_RPAREN] = ACTIONS(6376),
    [anon_sym_LBRACE] = ACTIONS(6376),
    [anon_sym_RBRACE] = ACTIONS(6376),
    [anon_sym_BSLASHand] = ACTIONS(6374),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6376),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6376),
    [anon_sym_DOLLAR] = ACTIONS(6374),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6376),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHleft] = ACTIONS(6374),
    [anon_sym_BSLASHbigl] = ACTIONS(6374),
    [anon_sym_BSLASHBigl] = ACTIONS(6374),
    [anon_sym_BSLASHbiggl] = ACTIONS(6374),
    [anon_sym_BSLASHBiggl] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHtext] = ACTIONS(6374),
    [anon_sym_BSLASHintertext] = ACTIONS(6374),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [1966] = {
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_LPAREN] = ACTIONS(6380),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_LBRACE] = ACTIONS(6380),
    [anon_sym_RBRACE] = ACTIONS(6380),
    [anon_sym_BSLASHand] = ACTIONS(6378),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6380),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6380),
    [anon_sym_DOLLAR] = ACTIONS(6378),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6380),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHleft] = ACTIONS(6378),
    [anon_sym_BSLASHbigl] = ACTIONS(6378),
    [anon_sym_BSLASHBigl] = ACTIONS(6378),
    [anon_sym_BSLASHbiggl] = ACTIONS(6378),
    [anon_sym_BSLASHBiggl] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHtext] = ACTIONS(6378),
    [anon_sym_BSLASHintertext] = ACTIONS(6378),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [1967] = {
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_LPAREN] = ACTIONS(6384),
    [anon_sym_RPAREN] = ACTIONS(6384),
    [anon_sym_LBRACE] = ACTIONS(6384),
    [anon_sym_RBRACE] = ACTIONS(6384),
    [anon_sym_BSLASHand] = ACTIONS(6382),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6384),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(6382),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6384),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHleft] = ACTIONS(6382),
    [anon_sym_BSLASHbigl] = ACTIONS(6382),
    [anon_sym_BSLASHBigl] = ACTIONS(6382),
    [anon_sym_BSLASHbiggl] = ACTIONS(6382),
    [anon_sym_BSLASHBiggl] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHtext] = ACTIONS(6382),
    [anon_sym_BSLASHintertext] = ACTIONS(6382),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [1968] = {
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_LPAREN] = ACTIONS(6312),
    [anon_sym_RPAREN] = ACTIONS(6312),
    [anon_sym_LBRACE] = ACTIONS(6312),
    [anon_sym_RBRACE] = ACTIONS(6312),
    [anon_sym_BSLASHand] = ACTIONS(6310),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6312),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6312),
    [anon_sym_DOLLAR] = ACTIONS(6310),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6312),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHleft] = ACTIONS(6310),
    [anon_sym_BSLASHbigl] = ACTIONS(6310),
    [anon_sym_BSLASHBigl] = ACTIONS(6310),
    [anon_sym_BSLASHbiggl] = ACTIONS(6310),
    [anon_sym_BSLASHBiggl] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHtext] = ACTIONS(6310),
    [anon_sym_BSLASHintertext] = ACTIONS(6310),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [1969] = {
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_LPAREN] = ACTIONS(6428),
    [anon_sym_RPAREN] = ACTIONS(6428),
    [anon_sym_LBRACE] = ACTIONS(6428),
    [anon_sym_RBRACE] = ACTIONS(6428),
    [anon_sym_BSLASHand] = ACTIONS(6426),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6428),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6428),
    [anon_sym_DOLLAR] = ACTIONS(6426),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6428),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHleft] = ACTIONS(6426),
    [anon_sym_BSLASHbigl] = ACTIONS(6426),
    [anon_sym_BSLASHBigl] = ACTIONS(6426),
    [anon_sym_BSLASHbiggl] = ACTIONS(6426),
    [anon_sym_BSLASHBiggl] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHtext] = ACTIONS(6426),
    [anon_sym_BSLASHintertext] = ACTIONS(6426),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [1970] = {
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_LPAREN] = ACTIONS(6316),
    [anon_sym_RPAREN] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(6316),
    [anon_sym_RBRACE] = ACTIONS(6316),
    [anon_sym_BSLASHand] = ACTIONS(6314),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6316),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6316),
    [anon_sym_DOLLAR] = ACTIONS(6314),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6316),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHleft] = ACTIONS(6314),
    [anon_sym_BSLASHbigl] = ACTIONS(6314),
    [anon_sym_BSLASHBigl] = ACTIONS(6314),
    [anon_sym_BSLASHbiggl] = ACTIONS(6314),
    [anon_sym_BSLASHBiggl] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHtext] = ACTIONS(6314),
    [anon_sym_BSLASHintertext] = ACTIONS(6314),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [1971] = {
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_LPAREN] = ACTIONS(6276),
    [anon_sym_RPAREN] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [anon_sym_RBRACE] = ACTIONS(6276),
    [anon_sym_BSLASHand] = ACTIONS(6274),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6276),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6276),
    [anon_sym_DOLLAR] = ACTIONS(6274),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6276),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHleft] = ACTIONS(6274),
    [anon_sym_BSLASHbigl] = ACTIONS(6274),
    [anon_sym_BSLASHBigl] = ACTIONS(6274),
    [anon_sym_BSLASHbiggl] = ACTIONS(6274),
    [anon_sym_BSLASHBiggl] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHtext] = ACTIONS(6274),
    [anon_sym_BSLASHintertext] = ACTIONS(6274),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [1972] = {
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_LPAREN] = ACTIONS(6320),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_LBRACE] = ACTIONS(6320),
    [anon_sym_RBRACE] = ACTIONS(6320),
    [anon_sym_BSLASHand] = ACTIONS(6318),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6320),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6320),
    [anon_sym_DOLLAR] = ACTIONS(6318),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6320),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHleft] = ACTIONS(6318),
    [anon_sym_BSLASHbigl] = ACTIONS(6318),
    [anon_sym_BSLASHBigl] = ACTIONS(6318),
    [anon_sym_BSLASHbiggl] = ACTIONS(6318),
    [anon_sym_BSLASHBiggl] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHtext] = ACTIONS(6318),
    [anon_sym_BSLASHintertext] = ACTIONS(6318),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [1973] = {
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_LPAREN] = ACTIONS(6432),
    [anon_sym_RPAREN] = ACTIONS(6432),
    [anon_sym_LBRACE] = ACTIONS(6432),
    [anon_sym_RBRACE] = ACTIONS(6432),
    [anon_sym_BSLASHand] = ACTIONS(6430),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_DOLLAR_DOLLAR] = ACTIONS(6432),
    [anon_sym_BSLASH_LBRACK] = ACTIONS(6432),
    [anon_sym_DOLLAR] = ACTIONS(6430),
    [anon_sym_BSLASH_LPAREN] = ACTIONS(6432),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHleft] = ACTIONS(6430),
    [anon_sym_BSLASHbigl] = ACTIONS(6430),
    [anon_sym_BSLASHBigl] = ACTIONS(6430),
    [anon_sym_BSLASHbiggl] = ACTIONS(6430),
    [anon_sym_BSLASHBiggl] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHtext] = ACTIONS(6430),
    [anon_sym_BSLASHintertext] = ACTIONS(6430),
    [anon_sym_BSLASHshortintertext] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [1974] = {
    [sym_curly_group] = STATE(1982),
    [sym_brack_group_text] = STATE(2802),
    [sym_command_name] = ACTIONS(6105),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6105),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6109),
    [anon_sym_COMMA] = ACTIONS(6109),
    [anon_sym_EQ] = ACTIONS(6109),
    [anon_sym_LBRACE] = ACTIONS(7169),
    [anon_sym_RBRACE] = ACTIONS(6109),
    [sym_word] = ACTIONS(6105),
    [sym_placeholder] = ACTIONS(6109),
    [anon_sym_PLUS] = ACTIONS(6109),
    [anon_sym_DASH] = ACTIONS(6109),
    [anon_sym_STAR] = ACTIONS(6109),
    [anon_sym_SLASH] = ACTIONS(6109),
    [anon_sym_LT] = ACTIONS(6105),
    [anon_sym_GT] = ACTIONS(6105),
    [anon_sym_BANG] = ACTIONS(6105),
    [anon_sym_PIPE] = ACTIONS(6105),
    [anon_sym_COLON] = ACTIONS(6105),
    [anon_sym_SQUOTE] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6109),
    [anon_sym_CARET] = ACTIONS(6109),
    [anon_sym_BSLASHtitle] = ACTIONS(6105),
    [anon_sym_BSLASHauthor] = ACTIONS(6105),
    [anon_sym_BSLASHusepackage] = ACTIONS(6105),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6105),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6105),
    [anon_sym_BSLASHinclude] = ACTIONS(6105),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6105),
    [anon_sym_BSLASHinput] = ACTIONS(6105),
    [anon_sym_BSLASHsubfile] = ACTIONS(6105),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6105),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6105),
    [anon_sym_BSLASHbibliography] = ACTIONS(6105),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6105),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6105),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6105),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6105),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6105),
    [anon_sym_BSLASHimport] = ACTIONS(6105),
    [anon_sym_BSLASHsubimport] = ACTIONS(6105),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6105),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6105),
    [anon_sym_BSLASHcaption] = ACTIONS(6105),
    [anon_sym_BSLASHcite] = ACTIONS(6105),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCite] = ACTIONS(6105),
    [anon_sym_BSLASHnocite] = ACTIONS(6105),
    [anon_sym_BSLASHcitet] = ACTIONS(6105),
    [anon_sym_BSLASHcitep] = ACTIONS(6105),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteA] = ACTIONS(6105),
    [anon_sym_BSLASHciteR] = ACTIONS(6105),
    [anon_sym_BSLASHciteS] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6105),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6105),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteyear] = ACTIONS(6105),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHcitedate] = ACTIONS(6105),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHciteurl] = ACTIONS(6105),
    [anon_sym_BSLASHfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6105),
    [anon_sym_BSLASHcitealt] = ACTIONS(6105),
    [anon_sym_BSLASHcitealp] = ACTIONS(6105),
    [anon_sym_BSLASHcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHparencite] = ACTIONS(6105),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHParencite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6105),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6105),
    [anon_sym_BSLASHtextcite] = ACTIONS(6105),
    [anon_sym_BSLASHTextcite] = ACTIONS(6105),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6105),
    [anon_sym_BSLASHsupercite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite] = ACTIONS(6105),
    [anon_sym_BSLASHAutocite] = ACTIONS(6105),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHVolcite] = ACTIONS(6105),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHavolcite] = ACTIONS(6105),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6105),
    [anon_sym_BSLASHnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHNotecite] = ACTIONS(6105),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6105),
    [anon_sym_BSLASHlabel] = ACTIONS(6105),
    [anon_sym_BSLASHref] = ACTIONS(6105),
    [anon_sym_BSLASHeqref] = ACTIONS(6105),
    [anon_sym_BSLASHvref] = ACTIONS(6105),
    [anon_sym_BSLASHVref] = ACTIONS(6105),
    [anon_sym_BSLASHautoref] = ACTIONS(6105),
    [anon_sym_BSLASHpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcref] = ACTIONS(6105),
    [anon_sym_BSLASHCref] = ACTIONS(6105),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnameCref] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6105),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6105),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6105),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6105),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6105),
    [anon_sym_BSLASHdef] = ACTIONS(6105),
    [anon_sym_BSLASHlet] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6105),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6105),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6105),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6105),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6105),
    [anon_sym_BSLASHgls] = ACTIONS(6105),
    [anon_sym_BSLASHGls] = ACTIONS(6105),
    [anon_sym_BSLASHGLS] = ACTIONS(6105),
    [anon_sym_BSLASHglspl] = ACTIONS(6105),
    [anon_sym_BSLASHGlspl] = ACTIONS(6105),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6105),
    [anon_sym_BSLASHglslink] = ACTIONS(6105),
    [anon_sym_BSLASHglstext] = ACTIONS(6105),
    [anon_sym_BSLASHGlstext] = ACTIONS(6105),
    [anon_sym_BSLASHGLStext] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6105),
    [anon_sym_BSLASHglsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6105),
    [anon_sym_BSLASHglsname] = ACTIONS(6105),
    [anon_sym_BSLASHGlsname] = ACTIONS(6105),
    [anon_sym_BSLASHGLSname] = ACTIONS(6105),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6105),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6105),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6105),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6105),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6105),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6105),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6105),
    [anon_sym_BSLASHacrshort] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6105),
    [anon_sym_BSLASHACRshort] = ACTIONS(6105),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrlong] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6105),
    [anon_sym_BSLASHACRlong] = ACTIONS(6105),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6105),
    [anon_sym_BSLASHacrfull] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6105),
    [anon_sym_BSLASHACRfull] = ACTIONS(6105),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHacs] = ACTIONS(6105),
    [anon_sym_BSLASHAcs] = ACTIONS(6105),
    [anon_sym_BSLASHacsp] = ACTIONS(6105),
    [anon_sym_BSLASHAcsp] = ACTIONS(6105),
    [anon_sym_BSLASHacl] = ACTIONS(6105),
    [anon_sym_BSLASHAcl] = ACTIONS(6105),
    [anon_sym_BSLASHaclp] = ACTIONS(6105),
    [anon_sym_BSLASHAclp] = ACTIONS(6105),
    [anon_sym_BSLASHacf] = ACTIONS(6105),
    [anon_sym_BSLASHAcf] = ACTIONS(6105),
    [anon_sym_BSLASHacfp] = ACTIONS(6105),
    [anon_sym_BSLASHAcfp] = ACTIONS(6105),
    [anon_sym_BSLASHac] = ACTIONS(6105),
    [anon_sym_BSLASHAc] = ACTIONS(6105),
    [anon_sym_BSLASHacp] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6105),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6105),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6105),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6105),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6109),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6105),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6105),
    [anon_sym_BSLASHcolor] = ACTIONS(6105),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6105),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6105),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6105),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6105),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6105),
    [anon_sym_BSLASHurl] = ACTIONS(6105),
    [anon_sym_BSLASHhref] = ACTIONS(6105),
  },
  [1975] = {
    [sym_curly_group] = STATE(1985),
    [sym_brack_group_text] = STATE(2782),
    [sym_command_name] = ACTIONS(6127),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6127),
    [anon_sym_LBRACK] = ACTIONS(6107),
    [anon_sym_RBRACK] = ACTIONS(6129),
    [anon_sym_COMMA] = ACTIONS(6129),
    [anon_sym_EQ] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(7169),
    [anon_sym_RBRACE] = ACTIONS(6129),
    [sym_word] = ACTIONS(6127),
    [sym_placeholder] = ACTIONS(6129),
    [anon_sym_PLUS] = ACTIONS(6129),
    [anon_sym_DASH] = ACTIONS(6129),
    [anon_sym_STAR] = ACTIONS(6129),
    [anon_sym_SLASH] = ACTIONS(6129),
    [anon_sym_LT] = ACTIONS(6127),
    [anon_sym_GT] = ACTIONS(6127),
    [anon_sym_BANG] = ACTIONS(6127),
    [anon_sym_PIPE] = ACTIONS(6127),
    [anon_sym_COLON] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6129),
    [anon_sym_CARET] = ACTIONS(6129),
    [anon_sym_BSLASHtitle] = ACTIONS(6127),
    [anon_sym_BSLASHauthor] = ACTIONS(6127),
    [anon_sym_BSLASHusepackage] = ACTIONS(6127),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6127),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6127),
    [anon_sym_BSLASHinclude] = ACTIONS(6127),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6127),
    [anon_sym_BSLASHinput] = ACTIONS(6127),
    [anon_sym_BSLASHsubfile] = ACTIONS(6127),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6127),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6127),
    [anon_sym_BSLASHbibliography] = ACTIONS(6127),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6127),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6127),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6127),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6127),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6127),
    [anon_sym_BSLASHimport] = ACTIONS(6127),
    [anon_sym_BSLASHsubimport] = ACTIONS(6127),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6127),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6127),
    [anon_sym_BSLASHcaption] = ACTIONS(6127),
    [anon_sym_BSLASHcite] = ACTIONS(6127),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCite] = ACTIONS(6127),
    [anon_sym_BSLASHnocite] = ACTIONS(6127),
    [anon_sym_BSLASHcitet] = ACTIONS(6127),
    [anon_sym_BSLASHcitep] = ACTIONS(6127),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteA] = ACTIONS(6127),
    [anon_sym_BSLASHciteR] = ACTIONS(6127),
    [anon_sym_BSLASHciteS] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6127),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6127),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteyear] = ACTIONS(6127),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHcitedate] = ACTIONS(6127),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHciteurl] = ACTIONS(6127),
    [anon_sym_BSLASHfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6127),
    [anon_sym_BSLASHcitealt] = ACTIONS(6127),
    [anon_sym_BSLASHcitealp] = ACTIONS(6127),
    [anon_sym_BSLASHcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHparencite] = ACTIONS(6127),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHParencite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6127),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6127),
    [anon_sym_BSLASHtextcite] = ACTIONS(6127),
    [anon_sym_BSLASHTextcite] = ACTIONS(6127),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6127),
    [anon_sym_BSLASHsupercite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite] = ACTIONS(6127),
    [anon_sym_BSLASHAutocite] = ACTIONS(6127),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHVolcite] = ACTIONS(6127),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHavolcite] = ACTIONS(6127),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6127),
    [anon_sym_BSLASHnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHNotecite] = ACTIONS(6127),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6127),
    [anon_sym_BSLASHlabel] = ACTIONS(6127),
    [anon_sym_BSLASHref] = ACTIONS(6127),
    [anon_sym_BSLASHeqref] = ACTIONS(6127),
    [anon_sym_BSLASHvref] = ACTIONS(6127),
    [anon_sym_BSLASHVref] = ACTIONS(6127),
    [anon_sym_BSLASHautoref] = ACTIONS(6127),
    [anon_sym_BSLASHpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcref] = ACTIONS(6127),
    [anon_sym_BSLASHCref] = ACTIONS(6127),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnameCref] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6127),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6127),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6127),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6127),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6127),
    [anon_sym_BSLASHdef] = ACTIONS(6127),
    [anon_sym_BSLASHlet] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6127),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6127),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6127),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6127),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6127),
    [anon_sym_BSLASHgls] = ACTIONS(6127),
    [anon_sym_BSLASHGls] = ACTIONS(6127),
    [anon_sym_BSLASHGLS] = ACTIONS(6127),
    [anon_sym_BSLASHglspl] = ACTIONS(6127),
    [anon_sym_BSLASHGlspl] = ACTIONS(6127),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6127),
    [anon_sym_BSLASHglslink] = ACTIONS(6127),
    [anon_sym_BSLASHglstext] = ACTIONS(6127),
    [anon_sym_BSLASHGlstext] = ACTIONS(6127),
    [anon_sym_BSLASHGLStext] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6127),
    [anon_sym_BSLASHglsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6127),
    [anon_sym_BSLASHglsname] = ACTIONS(6127),
    [anon_sym_BSLASHGlsname] = ACTIONS(6127),
    [anon_sym_BSLASHGLSname] = ACTIONS(6127),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6127),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6127),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6127),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6127),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6127),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6127),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6127),
    [anon_sym_BSLASHacrshort] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6127),
    [anon_sym_BSLASHACRshort] = ACTIONS(6127),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrlong] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6127),
    [anon_sym_BSLASHACRlong] = ACTIONS(6127),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6127),
    [anon_sym_BSLASHacrfull] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6127),
    [anon_sym_BSLASHACRfull] = ACTIONS(6127),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHacs] = ACTIONS(6127),
    [anon_sym_BSLASHAcs] = ACTIONS(6127),
    [anon_sym_BSLASHacsp] = ACTIONS(6127),
    [anon_sym_BSLASHAcsp] = ACTIONS(6127),
    [anon_sym_BSLASHacl] = ACTIONS(6127),
    [anon_sym_BSLASHAcl] = ACTIONS(6127),
    [anon_sym_BSLASHaclp] = ACTIONS(6127),
    [anon_sym_BSLASHAclp] = ACTIONS(6127),
    [anon_sym_BSLASHacf] = ACTIONS(6127),
    [anon_sym_BSLASHAcf] = ACTIONS(6127),
    [anon_sym_BSLASHacfp] = ACTIONS(6127),
    [anon_sym_BSLASHAcfp] = ACTIONS(6127),
    [anon_sym_BSLASHac] = ACTIONS(6127),
    [anon_sym_BSLASHAc] = ACTIONS(6127),
    [anon_sym_BSLASHacp] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6127),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6127),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6127),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6127),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6129),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6127),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6127),
    [anon_sym_BSLASHcolor] = ACTIONS(6127),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6127),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6127),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6127),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6127),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6127),
    [anon_sym_BSLASHurl] = ACTIONS(6127),
    [anon_sym_BSLASHhref] = ACTIONS(6127),
  },
  [1976] = {
    [sym_curly_group] = STATE(1994),
    [aux_sym_generic_command_repeat1] = STATE(1977),
    [sym_command_name] = ACTIONS(6123),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6123),
    [anon_sym_RBRACK] = ACTIONS(6125),
    [anon_sym_COMMA] = ACTIONS(6125),
    [anon_sym_EQ] = ACTIONS(6125),
    [anon_sym_LBRACE] = ACTIONS(7169),
    [anon_sym_RBRACE] = ACTIONS(6125),
    [sym_word] = ACTIONS(6123),
    [sym_placeholder] = ACTIONS(6125),
    [anon_sym_PLUS] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_STAR] = ACTIONS(6125),
    [anon_sym_SLASH] = ACTIONS(6125),
    [anon_sym_LT] = ACTIONS(6123),
    [anon_sym_GT] = ACTIONS(6123),
    [anon_sym_BANG] = ACTIONS(6123),
    [anon_sym_PIPE] = ACTIONS(6123),
    [anon_sym_COLON] = ACTIONS(6123),
    [anon_sym_SQUOTE] = ACTIONS(6123),
    [anon_sym__] = ACTIONS(6125),
    [anon_sym_CARET] = ACTIONS(6125),
    [anon_sym_BSLASHtitle] = ACTIONS(6123),
    [anon_sym_BSLASHauthor] = ACTIONS(6123),
    [anon_sym_BSLASHusepackage] = ACTIONS(6123),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6123),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6123),
    [anon_sym_BSLASHinclude] = ACTIONS(6123),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6123),
    [anon_sym_BSLASHinput] = ACTIONS(6123),
    [anon_sym_BSLASHsubfile] = ACTIONS(6123),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6123),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6123),
    [anon_sym_BSLASHbibliography] = ACTIONS(6123),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6123),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6123),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6123),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6123),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6123),
    [anon_sym_BSLASHimport] = ACTIONS(6123),
    [anon_sym_BSLASHsubimport] = ACTIONS(6123),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6123),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6123),
    [anon_sym_BSLASHcaption] = ACTIONS(6123),
    [anon_sym_BSLASHcite] = ACTIONS(6123),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCite] = ACTIONS(6123),
    [anon_sym_BSLASHnocite] = ACTIONS(6123),
    [anon_sym_BSLASHcitet] = ACTIONS(6123),
    [anon_sym_BSLASHcitep] = ACTIONS(6123),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteA] = ACTIONS(6123),
    [anon_sym_BSLASHciteR] = ACTIONS(6123),
    [anon_sym_BSLASHciteS] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6123),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6123),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteyear] = ACTIONS(6123),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHcitedate] = ACTIONS(6123),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHciteurl] = ACTIONS(6123),
    [anon_sym_BSLASHfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6123),
    [anon_sym_BSLASHcitealt] = ACTIONS(6123),
    [anon_sym_BSLASHcitealp] = ACTIONS(6123),
    [anon_sym_BSLASHcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHparencite] = ACTIONS(6123),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHParencite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6123),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6123),
    [anon_sym_BSLASHtextcite] = ACTIONS(6123),
    [anon_sym_BSLASHTextcite] = ACTIONS(6123),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6123),
    [anon_sym_BSLASHsupercite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite] = ACTIONS(6123),
    [anon_sym_BSLASHAutocite] = ACTIONS(6123),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHVolcite] = ACTIONS(6123),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHavolcite] = ACTIONS(6123),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6123),
    [anon_sym_BSLASHnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHNotecite] = ACTIONS(6123),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6123),
    [anon_sym_BSLASHlabel] = ACTIONS(6123),
    [anon_sym_BSLASHref] = ACTIONS(6123),
    [anon_sym_BSLASHeqref] = ACTIONS(6123),
    [anon_sym_BSLASHvref] = ACTIONS(6123),
    [anon_sym_BSLASHVref] = ACTIONS(6123),
    [anon_sym_BSLASHautoref] = ACTIONS(6123),
    [anon_sym_BSLASHpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcref] = ACTIONS(6123),
    [anon_sym_BSLASHCref] = ACTIONS(6123),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnameCref] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6123),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6123),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6123),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6123),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6123),
    [anon_sym_BSLASHdef] = ACTIONS(6123),
    [anon_sym_BSLASHlet] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6123),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6123),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6123),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6123),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6123),
    [anon_sym_BSLASHgls] = ACTIONS(6123),
    [anon_sym_BSLASHGls] = ACTIONS(6123),
    [anon_sym_BSLASHGLS] = ACTIONS(6123),
    [anon_sym_BSLASHglspl] = ACTIONS(6123),
    [anon_sym_BSLASHGlspl] = ACTIONS(6123),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6123),
    [anon_sym_BSLASHglslink] = ACTIONS(6123),
    [anon_sym_BSLASHglstext] = ACTIONS(6123),
    [anon_sym_BSLASHGlstext] = ACTIONS(6123),
    [anon_sym_BSLASHGLStext] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6123),
    [anon_sym_BSLASHglsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6123),
    [anon_sym_BSLASHglsname] = ACTIONS(6123),
    [anon_sym_BSLASHGlsname] = ACTIONS(6123),
    [anon_sym_BSLASHGLSname] = ACTIONS(6123),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6123),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6123),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6123),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6123),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6123),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6123),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6123),
    [anon_sym_BSLASHacrshort] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6123),
    [anon_sym_BSLASHACRshort] = ACTIONS(6123),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrlong] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6123),
    [anon_sym_BSLASHACRlong] = ACTIONS(6123),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6123),
    [anon_sym_BSLASHacrfull] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6123),
    [anon_sym_BSLASHACRfull] = ACTIONS(6123),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHacs] = ACTIONS(6123),
    [anon_sym_BSLASHAcs] = ACTIONS(6123),
    [anon_sym_BSLASHacsp] = ACTIONS(6123),
    [anon_sym_BSLASHAcsp] = ACTIONS(6123),
    [anon_sym_BSLASHacl] = ACTIONS(6123),
    [anon_sym_BSLASHAcl] = ACTIONS(6123),
    [anon_sym_BSLASHaclp] = ACTIONS(6123),
    [anon_sym_BSLASHAclp] = ACTIONS(6123),
    [anon_sym_BSLASHacf] = ACTIONS(6123),
    [anon_sym_BSLASHAcf] = ACTIONS(6123),
    [anon_sym_BSLASHacfp] = ACTIONS(6123),
    [anon_sym_BSLASHAcfp] = ACTIONS(6123),
    [anon_sym_BSLASHac] = ACTIONS(6123),
    [anon_sym_BSLASHAc] = ACTIONS(6123),
    [anon_sym_BSLASHacp] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6123),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6123),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6123),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6123),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6125),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6123),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6123),
    [anon_sym_BSLASHcolor] = ACTIONS(6123),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6123),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6123),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6123),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6123),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6123),
    [anon_sym_BSLASHurl] = ACTIONS(6123),
    [anon_sym_BSLASHhref] = ACTIONS(6123),
  },
  [1977] = {
    [sym_curly_group] = STATE(1994),
    [aux_sym_generic_command_repeat1] = STATE(1977),
    [sym_command_name] = ACTIONS(6131),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6131),
    [anon_sym_RBRACK] = ACTIONS(6133),
    [anon_sym_COMMA] = ACTIONS(6133),
    [anon_sym_EQ] = ACTIONS(6133),
    [anon_sym_LBRACE] = ACTIONS(7171),
    [anon_sym_RBRACE] = ACTIONS(6133),
    [sym_word] = ACTIONS(6131),
    [sym_placeholder] = ACTIONS(6133),
    [anon_sym_PLUS] = ACTIONS(6133),
    [anon_sym_DASH] = ACTIONS(6133),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_SLASH] = ACTIONS(6133),
    [anon_sym_LT] = ACTIONS(6131),
    [anon_sym_GT] = ACTIONS(6131),
    [anon_sym_BANG] = ACTIONS(6131),
    [anon_sym_PIPE] = ACTIONS(6131),
    [anon_sym_COLON] = ACTIONS(6131),
    [anon_sym_SQUOTE] = ACTIONS(6131),
    [anon_sym__] = ACTIONS(6133),
    [anon_sym_CARET] = ACTIONS(6133),
    [anon_sym_BSLASHtitle] = ACTIONS(6131),
    [anon_sym_BSLASHauthor] = ACTIONS(6131),
    [anon_sym_BSLASHusepackage] = ACTIONS(6131),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6131),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6131),
    [anon_sym_BSLASHinclude] = ACTIONS(6131),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6131),
    [anon_sym_BSLASHinput] = ACTIONS(6131),
    [anon_sym_BSLASHsubfile] = ACTIONS(6131),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6131),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6131),
    [anon_sym_BSLASHbibliography] = ACTIONS(6131),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6131),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6131),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6131),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6131),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6131),
    [anon_sym_BSLASHimport] = ACTIONS(6131),
    [anon_sym_BSLASHsubimport] = ACTIONS(6131),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6131),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6131),
    [anon_sym_BSLASHcaption] = ACTIONS(6131),
    [anon_sym_BSLASHcite] = ACTIONS(6131),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCite] = ACTIONS(6131),
    [anon_sym_BSLASHnocite] = ACTIONS(6131),
    [anon_sym_BSLASHcitet] = ACTIONS(6131),
    [anon_sym_BSLASHcitep] = ACTIONS(6131),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteA] = ACTIONS(6131),
    [anon_sym_BSLASHciteR] = ACTIONS(6131),
    [anon_sym_BSLASHciteS] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6131),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6131),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteyear] = ACTIONS(6131),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHcitedate] = ACTIONS(6131),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHciteurl] = ACTIONS(6131),
    [anon_sym_BSLASHfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6131),
    [anon_sym_BSLASHcitealt] = ACTIONS(6131),
    [anon_sym_BSLASHcitealp] = ACTIONS(6131),
    [anon_sym_BSLASHcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHparencite] = ACTIONS(6131),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHParencite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6131),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6131),
    [anon_sym_BSLASHtextcite] = ACTIONS(6131),
    [anon_sym_BSLASHTextcite] = ACTIONS(6131),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6131),
    [anon_sym_BSLASHsupercite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite] = ACTIONS(6131),
    [anon_sym_BSLASHAutocite] = ACTIONS(6131),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHVolcite] = ACTIONS(6131),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHavolcite] = ACTIONS(6131),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6131),
    [anon_sym_BSLASHnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHNotecite] = ACTIONS(6131),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6131),
    [anon_sym_BSLASHlabel] = ACTIONS(6131),
    [anon_sym_BSLASHref] = ACTIONS(6131),
    [anon_sym_BSLASHeqref] = ACTIONS(6131),
    [anon_sym_BSLASHvref] = ACTIONS(6131),
    [anon_sym_BSLASHVref] = ACTIONS(6131),
    [anon_sym_BSLASHautoref] = ACTIONS(6131),
    [anon_sym_BSLASHpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcref] = ACTIONS(6131),
    [anon_sym_BSLASHCref] = ACTIONS(6131),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnameCref] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6131),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6131),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6131),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6131),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6131),
    [anon_sym_BSLASHdef] = ACTIONS(6131),
    [anon_sym_BSLASHlet] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6131),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6131),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6131),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6131),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6131),
    [anon_sym_BSLASHgls] = ACTIONS(6131),
    [anon_sym_BSLASHGls] = ACTIONS(6131),
    [anon_sym_BSLASHGLS] = ACTIONS(6131),
    [anon_sym_BSLASHglspl] = ACTIONS(6131),
    [anon_sym_BSLASHGlspl] = ACTIONS(6131),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6131),
    [anon_sym_BSLASHglslink] = ACTIONS(6131),
    [anon_sym_BSLASHglstext] = ACTIONS(6131),
    [anon_sym_BSLASHGlstext] = ACTIONS(6131),
    [anon_sym_BSLASHGLStext] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6131),
    [anon_sym_BSLASHglsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6131),
    [anon_sym_BSLASHglsname] = ACTIONS(6131),
    [anon_sym_BSLASHGlsname] = ACTIONS(6131),
    [anon_sym_BSLASHGLSname] = ACTIONS(6131),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6131),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6131),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6131),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6131),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6131),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6131),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6131),
    [anon_sym_BSLASHacrshort] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6131),
    [anon_sym_BSLASHACRshort] = ACTIONS(6131),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrlong] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6131),
    [anon_sym_BSLASHACRlong] = ACTIONS(6131),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6131),
    [anon_sym_BSLASHacrfull] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6131),
    [anon_sym_BSLASHACRfull] = ACTIONS(6131),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHacs] = ACTIONS(6131),
    [anon_sym_BSLASHAcs] = ACTIONS(6131),
    [anon_sym_BSLASHacsp] = ACTIONS(6131),
    [anon_sym_BSLASHAcsp] = ACTIONS(6131),
    [anon_sym_BSLASHacl] = ACTIONS(6131),
    [anon_sym_BSLASHAcl] = ACTIONS(6131),
    [anon_sym_BSLASHaclp] = ACTIONS(6131),
    [anon_sym_BSLASHAclp] = ACTIONS(6131),
    [anon_sym_BSLASHacf] = ACTIONS(6131),
    [anon_sym_BSLASHAcf] = ACTIONS(6131),
    [anon_sym_BSLASHacfp] = ACTIONS(6131),
    [anon_sym_BSLASHAcfp] = ACTIONS(6131),
    [anon_sym_BSLASHac] = ACTIONS(6131),
    [anon_sym_BSLASHAc] = ACTIONS(6131),
    [anon_sym_BSLASHacp] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6131),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6131),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6131),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6131),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6133),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6131),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6131),
    [anon_sym_BSLASHcolor] = ACTIONS(6131),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6131),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6131),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6131),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6131),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6131),
    [anon_sym_BSLASHurl] = ACTIONS(6131),
    [anon_sym_BSLASHhref] = ACTIONS(6131),
  },
  [1978] = {
    [sym_curly_group] = STATE(1994),
    [aux_sym_generic_command_repeat1] = STATE(1976),
    [sym_command_name] = ACTIONS(6119),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6119),
    [anon_sym_RBRACK] = ACTIONS(6121),
    [anon_sym_COMMA] = ACTIONS(6121),
    [anon_sym_EQ] = ACTIONS(6121),
    [anon_sym_LBRACE] = ACTIONS(7169),
    [anon_sym_RBRACE] = ACTIONS(6121),
    [sym_word] = ACTIONS(6119),
    [sym_placeholder] = ACTIONS(6121),
    [anon_sym_PLUS] = ACTIONS(6121),
    [anon_sym_DASH] = ACTIONS(6121),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_SLASH] = ACTIONS(6121),
    [anon_sym_LT] = ACTIONS(6119),
    [anon_sym_GT] = ACTIONS(6119),
    [anon_sym_BANG] = ACTIONS(6119),
    [anon_sym_PIPE] = ACTIONS(6119),
    [anon_sym_COLON] = ACTIONS(6119),
    [anon_sym_SQUOTE] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6121),
    [anon_sym_CARET] = ACTIONS(6121),
    [anon_sym_BSLASHtitle] = ACTIONS(6119),
    [anon_sym_BSLASHauthor] = ACTIONS(6119),
    [anon_sym_BSLASHusepackage] = ACTIONS(6119),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6119),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6119),
    [anon_sym_BSLASHinclude] = ACTIONS(6119),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6119),
    [anon_sym_BSLASHinput] = ACTIONS(6119),
    [anon_sym_BSLASHsubfile] = ACTIONS(6119),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6119),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6119),
    [anon_sym_BSLASHbibliography] = ACTIONS(6119),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6119),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6119),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6119),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6119),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6119),
    [anon_sym_BSLASHimport] = ACTIONS(6119),
    [anon_sym_BSLASHsubimport] = ACTIONS(6119),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6119),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6119),
    [anon_sym_BSLASHcaption] = ACTIONS(6119),
    [anon_sym_BSLASHcite] = ACTIONS(6119),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCite] = ACTIONS(6119),
    [anon_sym_BSLASHnocite] = ACTIONS(6119),
    [anon_sym_BSLASHcitet] = ACTIONS(6119),
    [anon_sym_BSLASHcitep] = ACTIONS(6119),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteA] = ACTIONS(6119),
    [anon_sym_BSLASHciteR] = ACTIONS(6119),
    [anon_sym_BSLASHciteS] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6119),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6119),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteyear] = ACTIONS(6119),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHcitedate] = ACTIONS(6119),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHciteurl] = ACTIONS(6119),
    [anon_sym_BSLASHfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6119),
    [anon_sym_BSLASHcitealt] = ACTIONS(6119),
    [anon_sym_BSLASHcitealp] = ACTIONS(6119),
    [anon_sym_BSLASHcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHparencite] = ACTIONS(6119),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHParencite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6119),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6119),
    [anon_sym_BSLASHtextcite] = ACTIONS(6119),
    [anon_sym_BSLASHTextcite] = ACTIONS(6119),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6119),
    [anon_sym_BSLASHsupercite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite] = ACTIONS(6119),
    [anon_sym_BSLASHAutocite] = ACTIONS(6119),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHVolcite] = ACTIONS(6119),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHavolcite] = ACTIONS(6119),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6119),
    [anon_sym_BSLASHnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHNotecite] = ACTIONS(6119),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6119),
    [anon_sym_BSLASHlabel] = ACTIONS(6119),
    [anon_sym_BSLASHref] = ACTIONS(6119),
    [anon_sym_BSLASHeqref] = ACTIONS(6119),
    [anon_sym_BSLASHvref] = ACTIONS(6119),
    [anon_sym_BSLASHVref] = ACTIONS(6119),
    [anon_sym_BSLASHautoref] = ACTIONS(6119),
    [anon_sym_BSLASHpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcref] = ACTIONS(6119),
    [anon_sym_BSLASHCref] = ACTIONS(6119),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnameCref] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6119),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6119),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6119),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6119),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6119),
    [anon_sym_BSLASHdef] = ACTIONS(6119),
    [anon_sym_BSLASHlet] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6119),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6119),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6119),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6119),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6119),
    [anon_sym_BSLASHgls] = ACTIONS(6119),
    [anon_sym_BSLASHGls] = ACTIONS(6119),
    [anon_sym_BSLASHGLS] = ACTIONS(6119),
    [anon_sym_BSLASHglspl] = ACTIONS(6119),
    [anon_sym_BSLASHGlspl] = ACTIONS(6119),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6119),
    [anon_sym_BSLASHglslink] = ACTIONS(6119),
    [anon_sym_BSLASHglstext] = ACTIONS(6119),
    [anon_sym_BSLASHGlstext] = ACTIONS(6119),
    [anon_sym_BSLASHGLStext] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6119),
    [anon_sym_BSLASHglsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6119),
    [anon_sym_BSLASHglsname] = ACTIONS(6119),
    [anon_sym_BSLASHGlsname] = ACTIONS(6119),
    [anon_sym_BSLASHGLSname] = ACTIONS(6119),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6119),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6119),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6119),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6119),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6119),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6119),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6119),
    [anon_sym_BSLASHacrshort] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6119),
    [anon_sym_BSLASHACRshort] = ACTIONS(6119),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrlong] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6119),
    [anon_sym_BSLASHACRlong] = ACTIONS(6119),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6119),
    [anon_sym_BSLASHacrfull] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6119),
    [anon_sym_BSLASHACRfull] = ACTIONS(6119),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHacs] = ACTIONS(6119),
    [anon_sym_BSLASHAcs] = ACTIONS(6119),
    [anon_sym_BSLASHacsp] = ACTIONS(6119),
    [anon_sym_BSLASHAcsp] = ACTIONS(6119),
    [anon_sym_BSLASHacl] = ACTIONS(6119),
    [anon_sym_BSLASHAcl] = ACTIONS(6119),
    [anon_sym_BSLASHaclp] = ACTIONS(6119),
    [anon_sym_BSLASHAclp] = ACTIONS(6119),
    [anon_sym_BSLASHacf] = ACTIONS(6119),
    [anon_sym_BSLASHAcf] = ACTIONS(6119),
    [anon_sym_BSLASHacfp] = ACTIONS(6119),
    [anon_sym_BSLASHAcfp] = ACTIONS(6119),
    [anon_sym_BSLASHac] = ACTIONS(6119),
    [anon_sym_BSLASHAc] = ACTIONS(6119),
    [anon_sym_BSLASHacp] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6119),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6119),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6119),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6119),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6121),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6119),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6119),
    [anon_sym_BSLASHcolor] = ACTIONS(6119),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6119),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6119),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6119),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6119),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6119),
    [anon_sym_BSLASHurl] = ACTIONS(6119),
    [anon_sym_BSLASHhref] = ACTIONS(6119),
  },
  [1979] = {
    [sym_command_name] = ACTIONS(6111),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6111),
    [anon_sym_BSLASHfi] = ACTIONS(7174),
    [anon_sym_RBRACK] = ACTIONS(6115),
    [anon_sym_COMMA] = ACTIONS(6115),
    [anon_sym_EQ] = ACTIONS(6115),
    [anon_sym_RBRACE] = ACTIONS(6115),
    [sym_word] = ACTIONS(6111),
    [sym_placeholder] = ACTIONS(6115),
    [anon_sym_PLUS] = ACTIONS(6115),
    [anon_sym_DASH] = ACTIONS(6115),
    [anon_sym_STAR] = ACTIONS(6115),
    [anon_sym_SLASH] = ACTIONS(6115),
    [anon_sym_LT] = ACTIONS(6111),
    [anon_sym_GT] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6111),
    [anon_sym_PIPE] = ACTIONS(6111),
    [anon_sym_COLON] = ACTIONS(6111),
    [anon_sym_SQUOTE] = ACTIONS(6111),
    [anon_sym__] = ACTIONS(6115),
    [anon_sym_CARET] = ACTIONS(6115),
    [anon_sym_BSLASHtitle] = ACTIONS(6111),
    [anon_sym_BSLASHauthor] = ACTIONS(6111),
    [anon_sym_BSLASHusepackage] = ACTIONS(6111),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6111),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6111),
    [anon_sym_BSLASHinclude] = ACTIONS(6111),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6111),
    [anon_sym_BSLASHinput] = ACTIONS(6111),
    [anon_sym_BSLASHsubfile] = ACTIONS(6111),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6111),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6111),
    [anon_sym_BSLASHbibliography] = ACTIONS(6111),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6111),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6111),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6111),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6111),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6111),
    [anon_sym_BSLASHimport] = ACTIONS(6111),
    [anon_sym_BSLASHsubimport] = ACTIONS(6111),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6111),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6111),
    [anon_sym_BSLASHcaption] = ACTIONS(6111),
    [anon_sym_BSLASHcite] = ACTIONS(6111),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCite] = ACTIONS(6111),
    [anon_sym_BSLASHnocite] = ACTIONS(6111),
    [anon_sym_BSLASHcitet] = ACTIONS(6111),
    [anon_sym_BSLASHcitep] = ACTIONS(6111),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteA] = ACTIONS(6111),
    [anon_sym_BSLASHciteR] = ACTIONS(6111),
    [anon_sym_BSLASHciteS] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6111),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6111),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteyear] = ACTIONS(6111),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHcitedate] = ACTIONS(6111),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHciteurl] = ACTIONS(6111),
    [anon_sym_BSLASHfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6111),
    [anon_sym_BSLASHcitealt] = ACTIONS(6111),
    [anon_sym_BSLASHcitealp] = ACTIONS(6111),
    [anon_sym_BSLASHcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHparencite] = ACTIONS(6111),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHParencite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6111),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6111),
    [anon_sym_BSLASHtextcite] = ACTIONS(6111),
    [anon_sym_BSLASHTextcite] = ACTIONS(6111),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6111),
    [anon_sym_BSLASHsupercite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite] = ACTIONS(6111),
    [anon_sym_BSLASHAutocite] = ACTIONS(6111),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHVolcite] = ACTIONS(6111),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHavolcite] = ACTIONS(6111),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6111),
    [anon_sym_BSLASHnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHNotecite] = ACTIONS(6111),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6111),
    [anon_sym_BSLASHlabel] = ACTIONS(6111),
    [anon_sym_BSLASHref] = ACTIONS(6111),
    [anon_sym_BSLASHeqref] = ACTIONS(6111),
    [anon_sym_BSLASHvref] = ACTIONS(6111),
    [anon_sym_BSLASHVref] = ACTIONS(6111),
    [anon_sym_BSLASHautoref] = ACTIONS(6111),
    [anon_sym_BSLASHpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcref] = ACTIONS(6111),
    [anon_sym_BSLASHCref] = ACTIONS(6111),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnameCref] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6111),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6111),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6111),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6111),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6111),
    [anon_sym_BSLASHdef] = ACTIONS(6111),
    [anon_sym_BSLASHlet] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6111),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6111),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6111),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6111),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6111),
    [anon_sym_BSLASHgls] = ACTIONS(6111),
    [anon_sym_BSLASHGls] = ACTIONS(6111),
    [anon_sym_BSLASHGLS] = ACTIONS(6111),
    [anon_sym_BSLASHglspl] = ACTIONS(6111),
    [anon_sym_BSLASHGlspl] = ACTIONS(6111),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6111),
    [anon_sym_BSLASHglslink] = ACTIONS(6111),
    [anon_sym_BSLASHglstext] = ACTIONS(6111),
    [anon_sym_BSLASHGlstext] = ACTIONS(6111),
    [anon_sym_BSLASHGLStext] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6111),
    [anon_sym_BSLASHglsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6111),
    [anon_sym_BSLASHglsname] = ACTIONS(6111),
    [anon_sym_BSLASHGlsname] = ACTIONS(6111),
    [anon_sym_BSLASHGLSname] = ACTIONS(6111),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6111),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6111),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6111),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6111),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6111),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6111),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6111),
    [anon_sym_BSLASHacrshort] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6111),
    [anon_sym_BSLASHACRshort] = ACTIONS(6111),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrlong] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6111),
    [anon_sym_BSLASHACRlong] = ACTIONS(6111),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6111),
    [anon_sym_BSLASHacrfull] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6111),
    [anon_sym_BSLASHACRfull] = ACTIONS(6111),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHacs] = ACTIONS(6111),
    [anon_sym_BSLASHAcs] = ACTIONS(6111),
    [anon_sym_BSLASHacsp] = ACTIONS(6111),
    [anon_sym_BSLASHAcsp] = ACTIONS(6111),
    [anon_sym_BSLASHacl] = ACTIONS(6111),
    [anon_sym_BSLASHAcl] = ACTIONS(6111),
    [anon_sym_BSLASHaclp] = ACTIONS(6111),
    [anon_sym_BSLASHAclp] = ACTIONS(6111),
    [anon_sym_BSLASHacf] = ACTIONS(6111),
    [anon_sym_BSLASHAcf] = ACTIONS(6111),
    [anon_sym_BSLASHacfp] = ACTIONS(6111),
    [anon_sym_BSLASHAcfp] = ACTIONS(6111),
    [anon_sym_BSLASHac] = ACTIONS(6111),
    [anon_sym_BSLASHAc] = ACTIONS(6111),
    [anon_sym_BSLASHacp] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6111),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6111),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6111),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6111),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6115),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6111),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6111),
    [anon_sym_BSLASHcolor] = ACTIONS(6111),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6111),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6111),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6111),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6111),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6111),
    [anon_sym_BSLASHurl] = ACTIONS(6111),
    [anon_sym_BSLASHhref] = ACTIONS(6111),
    [sym__trivia_raw_fi] = ACTIONS(7176),
  },
  [1980] = {
    [sym_curly_group] = STATE(2024),
    [sym_command_name] = ACTIONS(6152),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6152),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_COMMA] = ACTIONS(6154),
    [anon_sym_EQ] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(7169),
    [anon_sym_RBRACE] = ACTIONS(6154),
    [sym_word] = ACTIONS(6152),
    [sym_placeholder] = ACTIONS(6154),
    [anon_sym_PLUS] = ACTIONS(6154),
    [anon_sym_DASH] = ACTIONS(6154),
    [anon_sym_STAR] = ACTIONS(6154),
    [anon_sym_SLASH] = ACTIONS(6154),
    [anon_sym_LT] = ACTIONS(6152),
    [anon_sym_GT] = ACTIONS(6152),
    [anon_sym_BANG] = ACTIONS(6152),
    [anon_sym_PIPE] = ACTIONS(6152),
    [anon_sym_COLON] = ACTIONS(6152),
    [anon_sym_SQUOTE] = ACTIONS(6152),
    [anon_sym__] = ACTIONS(6154),
    [anon_sym_CARET] = ACTIONS(6154),
    [anon_sym_BSLASHtitle] = ACTIONS(6152),
    [anon_sym_BSLASHauthor] = ACTIONS(6152),
    [anon_sym_BSLASHusepackage] = ACTIONS(6152),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6152),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6152),
    [anon_sym_BSLASHinclude] = ACTIONS(6152),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6152),
    [anon_sym_BSLASHinput] = ACTIONS(6152),
    [anon_sym_BSLASHsubfile] = ACTIONS(6152),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6152),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6152),
    [anon_sym_BSLASHbibliography] = ACTIONS(6152),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6152),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6152),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6152),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6152),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6152),
    [anon_sym_BSLASHimport] = ACTIONS(6152),
    [anon_sym_BSLASHsubimport] = ACTIONS(6152),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6152),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6152),
    [anon_sym_BSLASHcaption] = ACTIONS(6152),
    [anon_sym_BSLASHcite] = ACTIONS(6152),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCite] = ACTIONS(6152),
    [anon_sym_BSLASHnocite] = ACTIONS(6152),
    [anon_sym_BSLASHcitet] = ACTIONS(6152),
    [anon_sym_BSLASHcitep] = ACTIONS(6152),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteA] = ACTIONS(6152),
    [anon_sym_BSLASHciteR] = ACTIONS(6152),
    [anon_sym_BSLASHciteS] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6152),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6152),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteyear] = ACTIONS(6152),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHcitedate] = ACTIONS(6152),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHciteurl] = ACTIONS(6152),
    [anon_sym_BSLASHfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6152),
    [anon_sym_BSLASHcitealt] = ACTIONS(6152),
    [anon_sym_BSLASHcitealp] = ACTIONS(6152),
    [anon_sym_BSLASHcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHparencite] = ACTIONS(6152),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHParencite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6152),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6152),
    [anon_sym_BSLASHtextcite] = ACTIONS(6152),
    [anon_sym_BSLASHTextcite] = ACTIONS(6152),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6152),
    [anon_sym_BSLASHsupercite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite] = ACTIONS(6152),
    [anon_sym_BSLASHAutocite] = ACTIONS(6152),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHVolcite] = ACTIONS(6152),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHavolcite] = ACTIONS(6152),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6152),
    [anon_sym_BSLASHnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHNotecite] = ACTIONS(6152),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6152),
    [anon_sym_BSLASHlabel] = ACTIONS(6152),
    [anon_sym_BSLASHref] = ACTIONS(6152),
    [anon_sym_BSLASHeqref] = ACTIONS(6152),
    [anon_sym_BSLASHvref] = ACTIONS(6152),
    [anon_sym_BSLASHVref] = ACTIONS(6152),
    [anon_sym_BSLASHautoref] = ACTIONS(6152),
    [anon_sym_BSLASHpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcref] = ACTIONS(6152),
    [anon_sym_BSLASHCref] = ACTIONS(6152),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnameCref] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6152),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6152),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6152),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6152),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6152),
    [anon_sym_BSLASHdef] = ACTIONS(6152),
    [anon_sym_BSLASHlet] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6152),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6152),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6152),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6152),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6152),
    [anon_sym_BSLASHgls] = ACTIONS(6152),
    [anon_sym_BSLASHGls] = ACTIONS(6152),
    [anon_sym_BSLASHGLS] = ACTIONS(6152),
    [anon_sym_BSLASHglspl] = ACTIONS(6152),
    [anon_sym_BSLASHGlspl] = ACTIONS(6152),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6152),
    [anon_sym_BSLASHglslink] = ACTIONS(6152),
    [anon_sym_BSLASHglstext] = ACTIONS(6152),
    [anon_sym_BSLASHGlstext] = ACTIONS(6152),
    [anon_sym_BSLASHGLStext] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6152),
    [anon_sym_BSLASHglsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6152),
    [anon_sym_BSLASHglsname] = ACTIONS(6152),
    [anon_sym_BSLASHGlsname] = ACTIONS(6152),
    [anon_sym_BSLASHGLSname] = ACTIONS(6152),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6152),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6152),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6152),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6152),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6152),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6152),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6152),
    [anon_sym_BSLASHacrshort] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6152),
    [anon_sym_BSLASHACRshort] = ACTIONS(6152),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrlong] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6152),
    [anon_sym_BSLASHACRlong] = ACTIONS(6152),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6152),
    [anon_sym_BSLASHacrfull] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6152),
    [anon_sym_BSLASHACRfull] = ACTIONS(6152),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHacs] = ACTIONS(6152),
    [anon_sym_BSLASHAcs] = ACTIONS(6152),
    [anon_sym_BSLASHacsp] = ACTIONS(6152),
    [anon_sym_BSLASHAcsp] = ACTIONS(6152),
    [anon_sym_BSLASHacl] = ACTIONS(6152),
    [anon_sym_BSLASHAcl] = ACTIONS(6152),
    [anon_sym_BSLASHaclp] = ACTIONS(6152),
    [anon_sym_BSLASHAclp] = ACTIONS(6152),
    [anon_sym_BSLASHacf] = ACTIONS(6152),
    [anon_sym_BSLASHAcf] = ACTIONS(6152),
    [anon_sym_BSLASHacfp] = ACTIONS(6152),
    [anon_sym_BSLASHAcfp] = ACTIONS(6152),
    [anon_sym_BSLASHac] = ACTIONS(6152),
    [anon_sym_BSLASHAc] = ACTIONS(6152),
    [anon_sym_BSLASHacp] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6152),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6152),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6152),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6152),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6154),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6152),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6152),
    [anon_sym_BSLASHcolor] = ACTIONS(6152),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6152),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6152),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6152),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6152),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6152),
    [anon_sym_BSLASHurl] = ACTIONS(6152),
    [anon_sym_BSLASHhref] = ACTIONS(6152),
  },
  [1981] = {
    [sym_command_name] = ACTIONS(6478),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6478),
    [anon_sym_LBRACK] = ACTIONS(6480),
    [anon_sym_RBRACK] = ACTIONS(6480),
    [anon_sym_COMMA] = ACTIONS(6480),
    [anon_sym_EQ] = ACTIONS(6480),
    [anon_sym_LBRACE] = ACTIONS(6480),
    [anon_sym_RBRACE] = ACTIONS(6480),
    [sym_word] = ACTIONS(6478),
    [sym_placeholder] = ACTIONS(6480),
    [anon_sym_PLUS] = ACTIONS(6480),
    [anon_sym_DASH] = ACTIONS(6480),
    [anon_sym_STAR] = ACTIONS(6480),
    [anon_sym_SLASH] = ACTIONS(6480),
    [anon_sym_LT] = ACTIONS(6478),
    [anon_sym_GT] = ACTIONS(6478),
    [anon_sym_BANG] = ACTIONS(6478),
    [anon_sym_PIPE] = ACTIONS(6478),
    [anon_sym_COLON] = ACTIONS(6478),
    [anon_sym_SQUOTE] = ACTIONS(6478),
    [anon_sym__] = ACTIONS(6480),
    [anon_sym_CARET] = ACTIONS(6480),
    [anon_sym_BSLASHtitle] = ACTIONS(6478),
    [anon_sym_BSLASHauthor] = ACTIONS(6478),
    [anon_sym_BSLASHusepackage] = ACTIONS(6478),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6478),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6478),
    [anon_sym_BSLASHinclude] = ACTIONS(6478),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6478),
    [anon_sym_BSLASHinput] = ACTIONS(6478),
    [anon_sym_BSLASHsubfile] = ACTIONS(6478),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6478),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6478),
    [anon_sym_BSLASHbibliography] = ACTIONS(6478),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6478),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6478),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6478),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6478),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6478),
    [anon_sym_BSLASHimport] = ACTIONS(6478),
    [anon_sym_BSLASHsubimport] = ACTIONS(6478),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6478),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6478),
    [anon_sym_BSLASHcaption] = ACTIONS(6478),
    [anon_sym_BSLASHcite] = ACTIONS(6478),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCite] = ACTIONS(6478),
    [anon_sym_BSLASHnocite] = ACTIONS(6478),
    [anon_sym_BSLASHcitet] = ACTIONS(6478),
    [anon_sym_BSLASHcitep] = ACTIONS(6478),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteA] = ACTIONS(6478),
    [anon_sym_BSLASHciteR] = ACTIONS(6478),
    [anon_sym_BSLASHciteS] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6478),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6478),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteyear] = ACTIONS(6478),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHcitedate] = ACTIONS(6478),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHciteurl] = ACTIONS(6478),
    [anon_sym_BSLASHfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6478),
    [anon_sym_BSLASHcitealt] = ACTIONS(6478),
    [anon_sym_BSLASHcitealp] = ACTIONS(6478),
    [anon_sym_BSLASHcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHparencite] = ACTIONS(6478),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHParencite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6478),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6478),
    [anon_sym_BSLASHtextcite] = ACTIONS(6478),
    [anon_sym_BSLASHTextcite] = ACTIONS(6478),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6478),
    [anon_sym_BSLASHsupercite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite] = ACTIONS(6478),
    [anon_sym_BSLASHAutocite] = ACTIONS(6478),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHVolcite] = ACTIONS(6478),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHavolcite] = ACTIONS(6478),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6478),
    [anon_sym_BSLASHnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHNotecite] = ACTIONS(6478),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6478),
    [anon_sym_BSLASHlabel] = ACTIONS(6478),
    [anon_sym_BSLASHref] = ACTIONS(6478),
    [anon_sym_BSLASHeqref] = ACTIONS(6478),
    [anon_sym_BSLASHvref] = ACTIONS(6478),
    [anon_sym_BSLASHVref] = ACTIONS(6478),
    [anon_sym_BSLASHautoref] = ACTIONS(6478),
    [anon_sym_BSLASHpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcref] = ACTIONS(6478),
    [anon_sym_BSLASHCref] = ACTIONS(6478),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnameCref] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6478),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6478),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6478),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6478),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6478),
    [anon_sym_BSLASHdef] = ACTIONS(6478),
    [anon_sym_BSLASHlet] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6478),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6478),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6478),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6478),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6478),
    [anon_sym_BSLASHgls] = ACTIONS(6478),
    [anon_sym_BSLASHGls] = ACTIONS(6478),
    [anon_sym_BSLASHGLS] = ACTIONS(6478),
    [anon_sym_BSLASHglspl] = ACTIONS(6478),
    [anon_sym_BSLASHGlspl] = ACTIONS(6478),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6478),
    [anon_sym_BSLASHglslink] = ACTIONS(6478),
    [anon_sym_BSLASHglstext] = ACTIONS(6478),
    [anon_sym_BSLASHGlstext] = ACTIONS(6478),
    [anon_sym_BSLASHGLStext] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6478),
    [anon_sym_BSLASHglsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6478),
    [anon_sym_BSLASHglsname] = ACTIONS(6478),
    [anon_sym_BSLASHGlsname] = ACTIONS(6478),
    [anon_sym_BSLASHGLSname] = ACTIONS(6478),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6478),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6478),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6478),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6478),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6478),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6478),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6478),
    [anon_sym_BSLASHacrshort] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6478),
    [anon_sym_BSLASHACRshort] = ACTIONS(6478),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrlong] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6478),
    [anon_sym_BSLASHACRlong] = ACTIONS(6478),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6478),
    [anon_sym_BSLASHacrfull] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6478),
    [anon_sym_BSLASHACRfull] = ACTIONS(6478),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHacs] = ACTIONS(6478),
    [anon_sym_BSLASHAcs] = ACTIONS(6478),
    [anon_sym_BSLASHacsp] = ACTIONS(6478),
    [anon_sym_BSLASHAcsp] = ACTIONS(6478),
    [anon_sym_BSLASHacl] = ACTIONS(6478),
    [anon_sym_BSLASHAcl] = ACTIONS(6478),
    [anon_sym_BSLASHaclp] = ACTIONS(6478),
    [anon_sym_BSLASHAclp] = ACTIONS(6478),
    [anon_sym_BSLASHacf] = ACTIONS(6478),
    [anon_sym_BSLASHAcf] = ACTIONS(6478),
    [anon_sym_BSLASHacfp] = ACTIONS(6478),
    [anon_sym_BSLASHAcfp] = ACTIONS(6478),
    [anon_sym_BSLASHac] = ACTIONS(6478),
    [anon_sym_BSLASHAc] = ACTIONS(6478),
    [anon_sym_BSLASHacp] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6478),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6478),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6478),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6478),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6480),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6478),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6478),
    [anon_sym_BSLASHcolor] = ACTIONS(6478),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6478),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6478),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6478),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6478),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6478),
    [anon_sym_BSLASHurl] = ACTIONS(6478),
    [anon_sym_BSLASHhref] = ACTIONS(6478),
  },
  [1982] = {
    [sym_brack_group_text] = STATE(2030),
    [sym_command_name] = ACTIONS(6148),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6148),
    [anon_sym_LBRACK] = ACTIONS(7178),
    [anon_sym_RBRACK] = ACTIONS(6150),
    [anon_sym_COMMA] = ACTIONS(6150),
    [anon_sym_EQ] = ACTIONS(6150),
    [anon_sym_RBRACE] = ACTIONS(6150),
    [sym_word] = ACTIONS(6148),
    [sym_placeholder] = ACTIONS(6150),
    [anon_sym_PLUS] = ACTIONS(6150),
    [anon_sym_DASH] = ACTIONS(6150),
    [anon_sym_STAR] = ACTIONS(6150),
    [anon_sym_SLASH] = ACTIONS(6150),
    [anon_sym_LT] = ACTIONS(6148),
    [anon_sym_GT] = ACTIONS(6148),
    [anon_sym_BANG] = ACTIONS(6148),
    [anon_sym_PIPE] = ACTIONS(6148),
    [anon_sym_COLON] = ACTIONS(6148),
    [anon_sym_SQUOTE] = ACTIONS(6148),
    [anon_sym__] = ACTIONS(6150),
    [anon_sym_CARET] = ACTIONS(6150),
    [anon_sym_BSLASHtitle] = ACTIONS(6148),
    [anon_sym_BSLASHauthor] = ACTIONS(6148),
    [anon_sym_BSLASHusepackage] = ACTIONS(6148),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6148),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6148),
    [anon_sym_BSLASHinclude] = ACTIONS(6148),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6148),
    [anon_sym_BSLASHinput] = ACTIONS(6148),
    [anon_sym_BSLASHsubfile] = ACTIONS(6148),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6148),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6148),
    [anon_sym_BSLASHbibliography] = ACTIONS(6148),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6148),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6148),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6148),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6148),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6148),
    [anon_sym_BSLASHimport] = ACTIONS(6148),
    [anon_sym_BSLASHsubimport] = ACTIONS(6148),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6148),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6148),
    [anon_sym_BSLASHcaption] = ACTIONS(6148),
    [anon_sym_BSLASHcite] = ACTIONS(6148),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCite] = ACTIONS(6148),
    [anon_sym_BSLASHnocite] = ACTIONS(6148),
    [anon_sym_BSLASHcitet] = ACTIONS(6148),
    [anon_sym_BSLASHcitep] = ACTIONS(6148),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteA] = ACTIONS(6148),
    [anon_sym_BSLASHciteR] = ACTIONS(6148),
    [anon_sym_BSLASHciteS] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6148),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6148),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteyear] = ACTIONS(6148),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHcitedate] = ACTIONS(6148),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHciteurl] = ACTIONS(6148),
    [anon_sym_BSLASHfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6148),
    [anon_sym_BSLASHcitealt] = ACTIONS(6148),
    [anon_sym_BSLASHcitealp] = ACTIONS(6148),
    [anon_sym_BSLASHcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHparencite] = ACTIONS(6148),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHParencite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6148),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6148),
    [anon_sym_BSLASHtextcite] = ACTIONS(6148),
    [anon_sym_BSLASHTextcite] = ACTIONS(6148),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6148),
    [anon_sym_BSLASHsupercite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite] = ACTIONS(6148),
    [anon_sym_BSLASHAutocite] = ACTIONS(6148),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHVolcite] = ACTIONS(6148),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHavolcite] = ACTIONS(6148),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6148),
    [anon_sym_BSLASHnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHNotecite] = ACTIONS(6148),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6148),
    [anon_sym_BSLASHlabel] = ACTIONS(6148),
    [anon_sym_BSLASHref] = ACTIONS(6148),
    [anon_sym_BSLASHeqref] = ACTIONS(6148),
    [anon_sym_BSLASHvref] = ACTIONS(6148),
    [anon_sym_BSLASHVref] = ACTIONS(6148),
    [anon_sym_BSLASHautoref] = ACTIONS(6148),
    [anon_sym_BSLASHpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcref] = ACTIONS(6148),
    [anon_sym_BSLASHCref] = ACTIONS(6148),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnameCref] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6148),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6148),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6148),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6148),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6148),
    [anon_sym_BSLASHdef] = ACTIONS(6148),
    [anon_sym_BSLASHlet] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6148),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6148),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6148),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6148),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6148),
    [anon_sym_BSLASHgls] = ACTIONS(6148),
    [anon_sym_BSLASHGls] = ACTIONS(6148),
    [anon_sym_BSLASHGLS] = ACTIONS(6148),
    [anon_sym_BSLASHglspl] = ACTIONS(6148),
    [anon_sym_BSLASHGlspl] = ACTIONS(6148),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6148),
    [anon_sym_BSLASHglslink] = ACTIONS(6148),
    [anon_sym_BSLASHglstext] = ACTIONS(6148),
    [anon_sym_BSLASHGlstext] = ACTIONS(6148),
    [anon_sym_BSLASHGLStext] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6148),
    [anon_sym_BSLASHglsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6148),
    [anon_sym_BSLASHglsname] = ACTIONS(6148),
    [anon_sym_BSLASHGlsname] = ACTIONS(6148),
    [anon_sym_BSLASHGLSname] = ACTIONS(6148),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6148),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6148),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6148),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6148),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6148),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6148),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6148),
    [anon_sym_BSLASHacrshort] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6148),
    [anon_sym_BSLASHACRshort] = ACTIONS(6148),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrlong] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6148),
    [anon_sym_BSLASHACRlong] = ACTIONS(6148),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6148),
    [anon_sym_BSLASHacrfull] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6148),
    [anon_sym_BSLASHACRfull] = ACTIONS(6148),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHacs] = ACTIONS(6148),
    [anon_sym_BSLASHAcs] = ACTIONS(6148),
    [anon_sym_BSLASHacsp] = ACTIONS(6148),
    [anon_sym_BSLASHAcsp] = ACTIONS(6148),
    [anon_sym_BSLASHacl] = ACTIONS(6148),
    [anon_sym_BSLASHAcl] = ACTIONS(6148),
    [anon_sym_BSLASHaclp] = ACTIONS(6148),
    [anon_sym_BSLASHAclp] = ACTIONS(6148),
    [anon_sym_BSLASHacf] = ACTIONS(6148),
    [anon_sym_BSLASHAcf] = ACTIONS(6148),
    [anon_sym_BSLASHacfp] = ACTIONS(6148),
    [anon_sym_BSLASHAcfp] = ACTIONS(6148),
    [anon_sym_BSLASHac] = ACTIONS(6148),
    [anon_sym_BSLASHAc] = ACTIONS(6148),
    [anon_sym_BSLASHacp] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6148),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6148),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6148),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6148),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6150),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6148),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6148),
    [anon_sym_BSLASHcolor] = ACTIONS(6148),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6148),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6148),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6148),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6148),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6148),
    [anon_sym_BSLASHurl] = ACTIONS(6148),
    [anon_sym_BSLASHhref] = ACTIONS(6148),
  },
  [1983] = {
    [sym_curly_group] = STATE(2035),
    [sym_command_name] = ACTIONS(6144),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6144),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_COMMA] = ACTIONS(6146),
    [anon_sym_EQ] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(7169),
    [anon_sym_RBRACE] = ACTIONS(6146),
    [sym_word] = ACTIONS(6144),
    [sym_placeholder] = ACTIONS(6146),
    [anon_sym_PLUS] = ACTIONS(6146),
    [anon_sym_DASH] = ACTIONS(6146),
    [anon_sym_STAR] = ACTIONS(6146),
    [anon_sym_SLASH] = ACTIONS(6146),
    [anon_sym_LT] = ACTIONS(6144),
    [anon_sym_GT] = ACTIONS(6144),
    [anon_sym_BANG] = ACTIONS(6144),
    [anon_sym_PIPE] = ACTIONS(6144),
    [anon_sym_COLON] = ACTIONS(6144),
    [anon_sym_SQUOTE] = ACTIONS(6144),
    [anon_sym__] = ACTIONS(6146),
    [anon_sym_CARET] = ACTIONS(6146),
    [anon_sym_BSLASHtitle] = ACTIONS(6144),
    [anon_sym_BSLASHauthor] = ACTIONS(6144),
    [anon_sym_BSLASHusepackage] = ACTIONS(6144),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6144),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6144),
    [anon_sym_BSLASHinclude] = ACTIONS(6144),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6144),
    [anon_sym_BSLASHinput] = ACTIONS(6144),
    [anon_sym_BSLASHsubfile] = ACTIONS(6144),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6144),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6144),
    [anon_sym_BSLASHbibliography] = ACTIONS(6144),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6144),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6144),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6144),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6144),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6144),
    [anon_sym_BSLASHimport] = ACTIONS(6144),
    [anon_sym_BSLASHsubimport] = ACTIONS(6144),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6144),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6144),
    [anon_sym_BSLASHcaption] = ACTIONS(6144),
    [anon_sym_BSLASHcite] = ACTIONS(6144),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCite] = ACTIONS(6144),
    [anon_sym_BSLASHnocite] = ACTIONS(6144),
    [anon_sym_BSLASHcitet] = ACTIONS(6144),
    [anon_sym_BSLASHcitep] = ACTIONS(6144),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteA] = ACTIONS(6144),
    [anon_sym_BSLASHciteR] = ACTIONS(6144),
    [anon_sym_BSLASHciteS] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6144),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6144),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteyear] = ACTIONS(6144),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHcitedate] = ACTIONS(6144),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHciteurl] = ACTIONS(6144),
    [anon_sym_BSLASHfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6144),
    [anon_sym_BSLASHcitealt] = ACTIONS(6144),
    [anon_sym_BSLASHcitealp] = ACTIONS(6144),
    [anon_sym_BSLASHcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHparencite] = ACTIONS(6144),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHParencite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6144),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6144),
    [anon_sym_BSLASHtextcite] = ACTIONS(6144),
    [anon_sym_BSLASHTextcite] = ACTIONS(6144),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6144),
    [anon_sym_BSLASHsupercite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite] = ACTIONS(6144),
    [anon_sym_BSLASHAutocite] = ACTIONS(6144),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHVolcite] = ACTIONS(6144),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHavolcite] = ACTIONS(6144),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6144),
    [anon_sym_BSLASHnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHNotecite] = ACTIONS(6144),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6144),
    [anon_sym_BSLASHlabel] = ACTIONS(6144),
    [anon_sym_BSLASHref] = ACTIONS(6144),
    [anon_sym_BSLASHeqref] = ACTIONS(6144),
    [anon_sym_BSLASHvref] = ACTIONS(6144),
    [anon_sym_BSLASHVref] = ACTIONS(6144),
    [anon_sym_BSLASHautoref] = ACTIONS(6144),
    [anon_sym_BSLASHpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcref] = ACTIONS(6144),
    [anon_sym_BSLASHCref] = ACTIONS(6144),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnameCref] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6144),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6144),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6144),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6144),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6144),
    [anon_sym_BSLASHdef] = ACTIONS(6144),
    [anon_sym_BSLASHlet] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6144),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6144),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6144),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6144),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6144),
    [anon_sym_BSLASHgls] = ACTIONS(6144),
    [anon_sym_BSLASHGls] = ACTIONS(6144),
    [anon_sym_BSLASHGLS] = ACTIONS(6144),
    [anon_sym_BSLASHglspl] = ACTIONS(6144),
    [anon_sym_BSLASHGlspl] = ACTIONS(6144),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6144),
    [anon_sym_BSLASHglslink] = ACTIONS(6144),
    [anon_sym_BSLASHglstext] = ACTIONS(6144),
    [anon_sym_BSLASHGlstext] = ACTIONS(6144),
    [anon_sym_BSLASHGLStext] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6144),
    [anon_sym_BSLASHglsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6144),
    [anon_sym_BSLASHglsname] = ACTIONS(6144),
    [anon_sym_BSLASHGlsname] = ACTIONS(6144),
    [anon_sym_BSLASHGLSname] = ACTIONS(6144),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6144),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6144),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6144),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6144),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6144),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6144),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6144),
    [anon_sym_BSLASHacrshort] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6144),
    [anon_sym_BSLASHACRshort] = ACTIONS(6144),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrlong] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6144),
    [anon_sym_BSLASHACRlong] = ACTIONS(6144),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6144),
    [anon_sym_BSLASHacrfull] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6144),
    [anon_sym_BSLASHACRfull] = ACTIONS(6144),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHacs] = ACTIONS(6144),
    [anon_sym_BSLASHAcs] = ACTIONS(6144),
    [anon_sym_BSLASHacsp] = ACTIONS(6144),
    [anon_sym_BSLASHAcsp] = ACTIONS(6144),
    [anon_sym_BSLASHacl] = ACTIONS(6144),
    [anon_sym_BSLASHAcl] = ACTIONS(6144),
    [anon_sym_BSLASHaclp] = ACTIONS(6144),
    [anon_sym_BSLASHAclp] = ACTIONS(6144),
    [anon_sym_BSLASHacf] = ACTIONS(6144),
    [anon_sym_BSLASHAcf] = ACTIONS(6144),
    [anon_sym_BSLASHacfp] = ACTIONS(6144),
    [anon_sym_BSLASHAcfp] = ACTIONS(6144),
    [anon_sym_BSLASHac] = ACTIONS(6144),
    [anon_sym_BSLASHAc] = ACTIONS(6144),
    [anon_sym_BSLASHacp] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6144),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6144),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6144),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6144),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6146),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6144),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6144),
    [anon_sym_BSLASHcolor] = ACTIONS(6144),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6144),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6144),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6144),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6144),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6144),
    [anon_sym_BSLASHurl] = ACTIONS(6144),
    [anon_sym_BSLASHhref] = ACTIONS(6144),
  },
  [1984] = {
    [sym_command_name] = ACTIONS(6450),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_RBRACK] = ACTIONS(6452),
    [anon_sym_COMMA] = ACTIONS(6452),
    [anon_sym_EQ] = ACTIONS(6452),
    [anon_sym_LBRACE] = ACTIONS(6452),
    [anon_sym_RBRACE] = ACTIONS(6452),
    [sym_word] = ACTIONS(6450),
    [sym_placeholder] = ACTIONS(6452),
    [anon_sym_PLUS] = ACTIONS(6452),
    [anon_sym_DASH] = ACTIONS(6452),
    [anon_sym_STAR] = ACTIONS(6452),
    [anon_sym_SLASH] = ACTIONS(6452),
    [anon_sym_LT] = ACTIONS(6450),
    [anon_sym_GT] = ACTIONS(6450),
    [anon_sym_BANG] = ACTIONS(6450),
    [anon_sym_PIPE] = ACTIONS(6450),
    [anon_sym_COLON] = ACTIONS(6450),
    [anon_sym_SQUOTE] = ACTIONS(6450),
    [anon_sym__] = ACTIONS(6452),
    [anon_sym_CARET] = ACTIONS(6452),
    [anon_sym_BSLASHtitle] = ACTIONS(6450),
    [anon_sym_BSLASHauthor] = ACTIONS(6450),
    [anon_sym_BSLASHusepackage] = ACTIONS(6450),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6450),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6450),
    [anon_sym_BSLASHinclude] = ACTIONS(6450),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6450),
    [anon_sym_BSLASHinput] = ACTIONS(6450),
    [anon_sym_BSLASHsubfile] = ACTIONS(6450),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6450),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6450),
    [anon_sym_BSLASHbibliography] = ACTIONS(6450),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6450),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6450),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6450),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6450),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6450),
    [anon_sym_BSLASHimport] = ACTIONS(6450),
    [anon_sym_BSLASHsubimport] = ACTIONS(6450),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6450),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6450),
    [anon_sym_BSLASHcaption] = ACTIONS(6450),
    [anon_sym_BSLASHcite] = ACTIONS(6450),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCite] = ACTIONS(6450),
    [anon_sym_BSLASHnocite] = ACTIONS(6450),
    [anon_sym_BSLASHcitet] = ACTIONS(6450),
    [anon_sym_BSLASHcitep] = ACTIONS(6450),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteA] = ACTIONS(6450),
    [anon_sym_BSLASHciteR] = ACTIONS(6450),
    [anon_sym_BSLASHciteS] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6450),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6450),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteyear] = ACTIONS(6450),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHcitedate] = ACTIONS(6450),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHciteurl] = ACTIONS(6450),
    [anon_sym_BSLASHfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6450),
    [anon_sym_BSLASHcitealt] = ACTIONS(6450),
    [anon_sym_BSLASHcitealp] = ACTIONS(6450),
    [anon_sym_BSLASHcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHparencite] = ACTIONS(6450),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHParencite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6450),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6450),
    [anon_sym_BSLASHtextcite] = ACTIONS(6450),
    [anon_sym_BSLASHTextcite] = ACTIONS(6450),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6450),
    [anon_sym_BSLASHsupercite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite] = ACTIONS(6450),
    [anon_sym_BSLASHAutocite] = ACTIONS(6450),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHVolcite] = ACTIONS(6450),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHavolcite] = ACTIONS(6450),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6450),
    [anon_sym_BSLASHnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHNotecite] = ACTIONS(6450),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6450),
    [anon_sym_BSLASHlabel] = ACTIONS(6450),
    [anon_sym_BSLASHref] = ACTIONS(6450),
    [anon_sym_BSLASHeqref] = ACTIONS(6450),
    [anon_sym_BSLASHvref] = ACTIONS(6450),
    [anon_sym_BSLASHVref] = ACTIONS(6450),
    [anon_sym_BSLASHautoref] = ACTIONS(6450),
    [anon_sym_BSLASHpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcref] = ACTIONS(6450),
    [anon_sym_BSLASHCref] = ACTIONS(6450),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnameCref] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6450),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6450),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6450),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6450),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6450),
    [anon_sym_BSLASHdef] = ACTIONS(6450),
    [anon_sym_BSLASHlet] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6450),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6450),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6450),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6450),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6450),
    [anon_sym_BSLASHgls] = ACTIONS(6450),
    [anon_sym_BSLASHGls] = ACTIONS(6450),
    [anon_sym_BSLASHGLS] = ACTIONS(6450),
    [anon_sym_BSLASHglspl] = ACTIONS(6450),
    [anon_sym_BSLASHGlspl] = ACTIONS(6450),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6450),
    [anon_sym_BSLASHglslink] = ACTIONS(6450),
    [anon_sym_BSLASHglstext] = ACTIONS(6450),
    [anon_sym_BSLASHGlstext] = ACTIONS(6450),
    [anon_sym_BSLASHGLStext] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6450),
    [anon_sym_BSLASHglsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6450),
    [anon_sym_BSLASHglsname] = ACTIONS(6450),
    [anon_sym_BSLASHGlsname] = ACTIONS(6450),
    [anon_sym_BSLASHGLSname] = ACTIONS(6450),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6450),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6450),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6450),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6450),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6450),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6450),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6450),
    [anon_sym_BSLASHacrshort] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6450),
    [anon_sym_BSLASHACRshort] = ACTIONS(6450),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrlong] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6450),
    [anon_sym_BSLASHACRlong] = ACTIONS(6450),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6450),
    [anon_sym_BSLASHacrfull] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6450),
    [anon_sym_BSLASHACRfull] = ACTIONS(6450),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHacs] = ACTIONS(6450),
    [anon_sym_BSLASHAcs] = ACTIONS(6450),
    [anon_sym_BSLASHacsp] = ACTIONS(6450),
    [anon_sym_BSLASHAcsp] = ACTIONS(6450),
    [anon_sym_BSLASHacl] = ACTIONS(6450),
    [anon_sym_BSLASHAcl] = ACTIONS(6450),
    [anon_sym_BSLASHaclp] = ACTIONS(6450),
    [anon_sym_BSLASHAclp] = ACTIONS(6450),
    [anon_sym_BSLASHacf] = ACTIONS(6450),
    [anon_sym_BSLASHAcf] = ACTIONS(6450),
    [anon_sym_BSLASHacfp] = ACTIONS(6450),
    [anon_sym_BSLASHAcfp] = ACTIONS(6450),
    [anon_sym_BSLASHac] = ACTIONS(6450),
    [anon_sym_BSLASHAc] = ACTIONS(6450),
    [anon_sym_BSLASHacp] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6450),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6450),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6450),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6450),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6452),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6450),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6450),
    [anon_sym_BSLASHcolor] = ACTIONS(6450),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6450),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6450),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6450),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6450),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6450),
    [anon_sym_BSLASHurl] = ACTIONS(6450),
    [anon_sym_BSLASHhref] = ACTIONS(6450),
  },
  [1985] = {
    [sym_brack_group_text] = STATE(2044),
    [sym_command_name] = ACTIONS(6166),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6166),
    [anon_sym_LBRACK] = ACTIONS(7178),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_COMMA] = ACTIONS(6168),
    [anon_sym_EQ] = ACTIONS(6168),
    [anon_sym_RBRACE] = ACTIONS(6168),
    [sym_word] = ACTIONS(6166),
    [sym_placeholder] = ACTIONS(6168),
    [anon_sym_PLUS] = ACTIONS(6168),
    [anon_sym_DASH] = ACTIONS(6168),
    [anon_sym_STAR] = ACTIONS(6168),
    [anon_sym_SLASH] = ACTIONS(6168),
    [anon_sym_LT] = ACTIONS(6166),
    [anon_sym_GT] = ACTIONS(6166),
    [anon_sym_BANG] = ACTIONS(6166),
    [anon_sym_PIPE] = ACTIONS(6166),
    [anon_sym_COLON] = ACTIONS(6166),
    [anon_sym_SQUOTE] = ACTIONS(6166),
    [anon_sym__] = ACTIONS(6168),
    [anon_sym_CARET] = ACTIONS(6168),
    [anon_sym_BSLASHtitle] = ACTIONS(6166),
    [anon_sym_BSLASHauthor] = ACTIONS(6166),
    [anon_sym_BSLASHusepackage] = ACTIONS(6166),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6166),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6166),
    [anon_sym_BSLASHinclude] = ACTIONS(6166),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6166),
    [anon_sym_BSLASHinput] = ACTIONS(6166),
    [anon_sym_BSLASHsubfile] = ACTIONS(6166),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6166),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6166),
    [anon_sym_BSLASHbibliography] = ACTIONS(6166),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6166),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6166),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6166),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6166),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6166),
    [anon_sym_BSLASHimport] = ACTIONS(6166),
    [anon_sym_BSLASHsubimport] = ACTIONS(6166),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6166),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6166),
    [anon_sym_BSLASHcaption] = ACTIONS(6166),
    [anon_sym_BSLASHcite] = ACTIONS(6166),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCite] = ACTIONS(6166),
    [anon_sym_BSLASHnocite] = ACTIONS(6166),
    [anon_sym_BSLASHcitet] = ACTIONS(6166),
    [anon_sym_BSLASHcitep] = ACTIONS(6166),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteA] = ACTIONS(6166),
    [anon_sym_BSLASHciteR] = ACTIONS(6166),
    [anon_sym_BSLASHciteS] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6166),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6166),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteyear] = ACTIONS(6166),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHcitedate] = ACTIONS(6166),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHciteurl] = ACTIONS(6166),
    [anon_sym_BSLASHfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6166),
    [anon_sym_BSLASHcitealt] = ACTIONS(6166),
    [anon_sym_BSLASHcitealp] = ACTIONS(6166),
    [anon_sym_BSLASHcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHparencite] = ACTIONS(6166),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHParencite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6166),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6166),
    [anon_sym_BSLASHtextcite] = ACTIONS(6166),
    [anon_sym_BSLASHTextcite] = ACTIONS(6166),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6166),
    [anon_sym_BSLASHsupercite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite] = ACTIONS(6166),
    [anon_sym_BSLASHAutocite] = ACTIONS(6166),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHVolcite] = ACTIONS(6166),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHavolcite] = ACTIONS(6166),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6166),
    [anon_sym_BSLASHnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHNotecite] = ACTIONS(6166),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6166),
    [anon_sym_BSLASHlabel] = ACTIONS(6166),
    [anon_sym_BSLASHref] = ACTIONS(6166),
    [anon_sym_BSLASHeqref] = ACTIONS(6166),
    [anon_sym_BSLASHvref] = ACTIONS(6166),
    [anon_sym_BSLASHVref] = ACTIONS(6166),
    [anon_sym_BSLASHautoref] = ACTIONS(6166),
    [anon_sym_BSLASHpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcref] = ACTIONS(6166),
    [anon_sym_BSLASHCref] = ACTIONS(6166),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnameCref] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6166),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6166),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6166),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6166),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6166),
    [anon_sym_BSLASHdef] = ACTIONS(6166),
    [anon_sym_BSLASHlet] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6166),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6166),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6166),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6166),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6166),
    [anon_sym_BSLASHgls] = ACTIONS(6166),
    [anon_sym_BSLASHGls] = ACTIONS(6166),
    [anon_sym_BSLASHGLS] = ACTIONS(6166),
    [anon_sym_BSLASHglspl] = ACTIONS(6166),
    [anon_sym_BSLASHGlspl] = ACTIONS(6166),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6166),
    [anon_sym_BSLASHglslink] = ACTIONS(6166),
    [anon_sym_BSLASHglstext] = ACTIONS(6166),
    [anon_sym_BSLASHGlstext] = ACTIONS(6166),
    [anon_sym_BSLASHGLStext] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6166),
    [anon_sym_BSLASHglsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6166),
    [anon_sym_BSLASHglsname] = ACTIONS(6166),
    [anon_sym_BSLASHGlsname] = ACTIONS(6166),
    [anon_sym_BSLASHGLSname] = ACTIONS(6166),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6166),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6166),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6166),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6166),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6166),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6166),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6166),
    [anon_sym_BSLASHacrshort] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6166),
    [anon_sym_BSLASHACRshort] = ACTIONS(6166),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrlong] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6166),
    [anon_sym_BSLASHACRlong] = ACTIONS(6166),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6166),
    [anon_sym_BSLASHacrfull] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6166),
    [anon_sym_BSLASHACRfull] = ACTIONS(6166),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHacs] = ACTIONS(6166),
    [anon_sym_BSLASHAcs] = ACTIONS(6166),
    [anon_sym_BSLASHacsp] = ACTIONS(6166),
    [anon_sym_BSLASHAcsp] = ACTIONS(6166),
    [anon_sym_BSLASHacl] = ACTIONS(6166),
    [anon_sym_BSLASHAcl] = ACTIONS(6166),
    [anon_sym_BSLASHaclp] = ACTIONS(6166),
    [anon_sym_BSLASHAclp] = ACTIONS(6166),
    [anon_sym_BSLASHacf] = ACTIONS(6166),
    [anon_sym_BSLASHAcf] = ACTIONS(6166),
    [anon_sym_BSLASHacfp] = ACTIONS(6166),
    [anon_sym_BSLASHAcfp] = ACTIONS(6166),
    [anon_sym_BSLASHac] = ACTIONS(6166),
    [anon_sym_BSLASHAc] = ACTIONS(6166),
    [anon_sym_BSLASHacp] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6166),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6166),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6166),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6166),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6168),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6166),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6166),
    [anon_sym_BSLASHcolor] = ACTIONS(6166),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6166),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6166),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6166),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6166),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6166),
    [anon_sym_BSLASHurl] = ACTIONS(6166),
    [anon_sym_BSLASHhref] = ACTIONS(6166),
  },
  [1986] = {
    [sym_command_name] = ACTIONS(6246),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6246),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_COMMA] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(6248),
    [anon_sym_RBRACE] = ACTIONS(6248),
    [sym_word] = ACTIONS(6246),
    [sym_placeholder] = ACTIONS(6248),
    [anon_sym_PLUS] = ACTIONS(6248),
    [anon_sym_DASH] = ACTIONS(6248),
    [anon_sym_STAR] = ACTIONS(6248),
    [anon_sym_SLASH] = ACTIONS(6248),
    [anon_sym_LT] = ACTIONS(6246),
    [anon_sym_GT] = ACTIONS(6246),
    [anon_sym_BANG] = ACTIONS(6246),
    [anon_sym_PIPE] = ACTIONS(6246),
    [anon_sym_COLON] = ACTIONS(6246),
    [anon_sym_SQUOTE] = ACTIONS(6246),
    [anon_sym__] = ACTIONS(6248),
    [anon_sym_CARET] = ACTIONS(6248),
    [anon_sym_BSLASHtitle] = ACTIONS(6246),
    [anon_sym_BSLASHauthor] = ACTIONS(6246),
    [anon_sym_BSLASHusepackage] = ACTIONS(6246),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6246),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6246),
    [anon_sym_BSLASHinclude] = ACTIONS(6246),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6246),
    [anon_sym_BSLASHinput] = ACTIONS(6246),
    [anon_sym_BSLASHsubfile] = ACTIONS(6246),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6246),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6246),
    [anon_sym_BSLASHbibliography] = ACTIONS(6246),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6246),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6246),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6246),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6246),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6246),
    [anon_sym_BSLASHimport] = ACTIONS(6246),
    [anon_sym_BSLASHsubimport] = ACTIONS(6246),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6246),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6246),
    [anon_sym_BSLASHcaption] = ACTIONS(6246),
    [anon_sym_BSLASHcite] = ACTIONS(6246),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCite] = ACTIONS(6246),
    [anon_sym_BSLASHnocite] = ACTIONS(6246),
    [anon_sym_BSLASHcitet] = ACTIONS(6246),
    [anon_sym_BSLASHcitep] = ACTIONS(6246),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteA] = ACTIONS(6246),
    [anon_sym_BSLASHciteR] = ACTIONS(6246),
    [anon_sym_BSLASHciteS] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6246),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6246),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteyear] = ACTIONS(6246),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHcitedate] = ACTIONS(6246),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHciteurl] = ACTIONS(6246),
    [anon_sym_BSLASHfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6246),
    [anon_sym_BSLASHcitealt] = ACTIONS(6246),
    [anon_sym_BSLASHcitealp] = ACTIONS(6246),
    [anon_sym_BSLASHcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHparencite] = ACTIONS(6246),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHParencite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6246),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6246),
    [anon_sym_BSLASHtextcite] = ACTIONS(6246),
    [anon_sym_BSLASHTextcite] = ACTIONS(6246),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6246),
    [anon_sym_BSLASHsupercite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite] = ACTIONS(6246),
    [anon_sym_BSLASHAutocite] = ACTIONS(6246),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHVolcite] = ACTIONS(6246),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHavolcite] = ACTIONS(6246),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6246),
    [anon_sym_BSLASHnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHNotecite] = ACTIONS(6246),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6246),
    [anon_sym_BSLASHlabel] = ACTIONS(6246),
    [anon_sym_BSLASHref] = ACTIONS(6246),
    [anon_sym_BSLASHeqref] = ACTIONS(6246),
    [anon_sym_BSLASHvref] = ACTIONS(6246),
    [anon_sym_BSLASHVref] = ACTIONS(6246),
    [anon_sym_BSLASHautoref] = ACTIONS(6246),
    [anon_sym_BSLASHpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcref] = ACTIONS(6246),
    [anon_sym_BSLASHCref] = ACTIONS(6246),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnameCref] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6246),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6246),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6246),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6246),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6246),
    [anon_sym_BSLASHdef] = ACTIONS(6246),
    [anon_sym_BSLASHlet] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6246),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6246),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6246),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6246),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6246),
    [anon_sym_BSLASHgls] = ACTIONS(6246),
    [anon_sym_BSLASHGls] = ACTIONS(6246),
    [anon_sym_BSLASHGLS] = ACTIONS(6246),
    [anon_sym_BSLASHglspl] = ACTIONS(6246),
    [anon_sym_BSLASHGlspl] = ACTIONS(6246),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6246),
    [anon_sym_BSLASHglslink] = ACTIONS(6246),
    [anon_sym_BSLASHglstext] = ACTIONS(6246),
    [anon_sym_BSLASHGlstext] = ACTIONS(6246),
    [anon_sym_BSLASHGLStext] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6246),
    [anon_sym_BSLASHglsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6246),
    [anon_sym_BSLASHglsname] = ACTIONS(6246),
    [anon_sym_BSLASHGlsname] = ACTIONS(6246),
    [anon_sym_BSLASHGLSname] = ACTIONS(6246),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6246),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6246),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6246),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6246),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6246),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6246),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6246),
    [anon_sym_BSLASHacrshort] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6246),
    [anon_sym_BSLASHACRshort] = ACTIONS(6246),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrlong] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6246),
    [anon_sym_BSLASHACRlong] = ACTIONS(6246),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6246),
    [anon_sym_BSLASHacrfull] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6246),
    [anon_sym_BSLASHACRfull] = ACTIONS(6246),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHacs] = ACTIONS(6246),
    [anon_sym_BSLASHAcs] = ACTIONS(6246),
    [anon_sym_BSLASHacsp] = ACTIONS(6246),
    [anon_sym_BSLASHAcsp] = ACTIONS(6246),
    [anon_sym_BSLASHacl] = ACTIONS(6246),
    [anon_sym_BSLASHAcl] = ACTIONS(6246),
    [anon_sym_BSLASHaclp] = ACTIONS(6246),
    [anon_sym_BSLASHAclp] = ACTIONS(6246),
    [anon_sym_BSLASHacf] = ACTIONS(6246),
    [anon_sym_BSLASHAcf] = ACTIONS(6246),
    [anon_sym_BSLASHacfp] = ACTIONS(6246),
    [anon_sym_BSLASHAcfp] = ACTIONS(6246),
    [anon_sym_BSLASHac] = ACTIONS(6246),
    [anon_sym_BSLASHAc] = ACTIONS(6246),
    [anon_sym_BSLASHacp] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6246),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6246),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6246),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6246),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6248),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6246),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6246),
    [anon_sym_BSLASHcolor] = ACTIONS(6246),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6246),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6246),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6246),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6246),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6246),
    [anon_sym_BSLASHurl] = ACTIONS(6246),
    [anon_sym_BSLASHhref] = ACTIONS(6246),
  },
  [1987] = {
    [sym_command_name] = ACTIONS(6634),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6634),
    [anon_sym_LBRACK] = ACTIONS(6636),
    [anon_sym_RBRACK] = ACTIONS(6636),
    [anon_sym_COMMA] = ACTIONS(6636),
    [anon_sym_EQ] = ACTIONS(6636),
    [anon_sym_LBRACE] = ACTIONS(6636),
    [anon_sym_RBRACE] = ACTIONS(6636),
    [sym_word] = ACTIONS(6634),
    [sym_placeholder] = ACTIONS(6636),
    [anon_sym_PLUS] = ACTIONS(6636),
    [anon_sym_DASH] = ACTIONS(6636),
    [anon_sym_STAR] = ACTIONS(6636),
    [anon_sym_SLASH] = ACTIONS(6636),
    [anon_sym_LT] = ACTIONS(6634),
    [anon_sym_GT] = ACTIONS(6634),
    [anon_sym_BANG] = ACTIONS(6634),
    [anon_sym_PIPE] = ACTIONS(6634),
    [anon_sym_COLON] = ACTIONS(6634),
    [anon_sym_SQUOTE] = ACTIONS(6634),
    [anon_sym__] = ACTIONS(6636),
    [anon_sym_CARET] = ACTIONS(6636),
    [anon_sym_BSLASHtitle] = ACTIONS(6634),
    [anon_sym_BSLASHauthor] = ACTIONS(6634),
    [anon_sym_BSLASHusepackage] = ACTIONS(6634),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6634),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6634),
    [anon_sym_BSLASHinclude] = ACTIONS(6634),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6634),
    [anon_sym_BSLASHinput] = ACTIONS(6634),
    [anon_sym_BSLASHsubfile] = ACTIONS(6634),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6634),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6634),
    [anon_sym_BSLASHbibliography] = ACTIONS(6634),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6634),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6634),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6634),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6634),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6634),
    [anon_sym_BSLASHimport] = ACTIONS(6634),
    [anon_sym_BSLASHsubimport] = ACTIONS(6634),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6634),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6634),
    [anon_sym_BSLASHcaption] = ACTIONS(6634),
    [anon_sym_BSLASHcite] = ACTIONS(6634),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCite] = ACTIONS(6634),
    [anon_sym_BSLASHnocite] = ACTIONS(6634),
    [anon_sym_BSLASHcitet] = ACTIONS(6634),
    [anon_sym_BSLASHcitep] = ACTIONS(6634),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteA] = ACTIONS(6634),
    [anon_sym_BSLASHciteR] = ACTIONS(6634),
    [anon_sym_BSLASHciteS] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6634),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6634),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteyear] = ACTIONS(6634),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHcitedate] = ACTIONS(6634),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHciteurl] = ACTIONS(6634),
    [anon_sym_BSLASHfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6634),
    [anon_sym_BSLASHcitealt] = ACTIONS(6634),
    [anon_sym_BSLASHcitealp] = ACTIONS(6634),
    [anon_sym_BSLASHcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHparencite] = ACTIONS(6634),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHParencite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6634),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6634),
    [anon_sym_BSLASHtextcite] = ACTIONS(6634),
    [anon_sym_BSLASHTextcite] = ACTIONS(6634),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6634),
    [anon_sym_BSLASHsupercite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite] = ACTIONS(6634),
    [anon_sym_BSLASHAutocite] = ACTIONS(6634),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHVolcite] = ACTIONS(6634),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHavolcite] = ACTIONS(6634),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6634),
    [anon_sym_BSLASHnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHNotecite] = ACTIONS(6634),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6634),
    [anon_sym_BSLASHlabel] = ACTIONS(6634),
    [anon_sym_BSLASHref] = ACTIONS(6634),
    [anon_sym_BSLASHeqref] = ACTIONS(6634),
    [anon_sym_BSLASHvref] = ACTIONS(6634),
    [anon_sym_BSLASHVref] = ACTIONS(6634),
    [anon_sym_BSLASHautoref] = ACTIONS(6634),
    [anon_sym_BSLASHpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcref] = ACTIONS(6634),
    [anon_sym_BSLASHCref] = ACTIONS(6634),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnameCref] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6634),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6634),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6634),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6634),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6634),
    [anon_sym_BSLASHdef] = ACTIONS(6634),
    [anon_sym_BSLASHlet] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6634),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6634),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6634),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6634),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6634),
    [anon_sym_BSLASHgls] = ACTIONS(6634),
    [anon_sym_BSLASHGls] = ACTIONS(6634),
    [anon_sym_BSLASHGLS] = ACTIONS(6634),
    [anon_sym_BSLASHglspl] = ACTIONS(6634),
    [anon_sym_BSLASHGlspl] = ACTIONS(6634),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6634),
    [anon_sym_BSLASHglslink] = ACTIONS(6634),
    [anon_sym_BSLASHglstext] = ACTIONS(6634),
    [anon_sym_BSLASHGlstext] = ACTIONS(6634),
    [anon_sym_BSLASHGLStext] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6634),
    [anon_sym_BSLASHglsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6634),
    [anon_sym_BSLASHglsname] = ACTIONS(6634),
    [anon_sym_BSLASHGlsname] = ACTIONS(6634),
    [anon_sym_BSLASHGLSname] = ACTIONS(6634),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6634),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6634),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6634),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6634),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6634),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6634),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6634),
    [anon_sym_BSLASHacrshort] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6634),
    [anon_sym_BSLASHACRshort] = ACTIONS(6634),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrlong] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6634),
    [anon_sym_BSLASHACRlong] = ACTIONS(6634),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6634),
    [anon_sym_BSLASHacrfull] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6634),
    [anon_sym_BSLASHACRfull] = ACTIONS(6634),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHacs] = ACTIONS(6634),
    [anon_sym_BSLASHAcs] = ACTIONS(6634),
    [anon_sym_BSLASHacsp] = ACTIONS(6634),
    [anon_sym_BSLASHAcsp] = ACTIONS(6634),
    [anon_sym_BSLASHacl] = ACTIONS(6634),
    [anon_sym_BSLASHAcl] = ACTIONS(6634),
    [anon_sym_BSLASHaclp] = ACTIONS(6634),
    [anon_sym_BSLASHAclp] = ACTIONS(6634),
    [anon_sym_BSLASHacf] = ACTIONS(6634),
    [anon_sym_BSLASHAcf] = ACTIONS(6634),
    [anon_sym_BSLASHacfp] = ACTIONS(6634),
    [anon_sym_BSLASHAcfp] = ACTIONS(6634),
    [anon_sym_BSLASHac] = ACTIONS(6634),
    [anon_sym_BSLASHAc] = ACTIONS(6634),
    [anon_sym_BSLASHacp] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6634),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6634),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6634),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6634),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6636),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6634),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6634),
    [anon_sym_BSLASHcolor] = ACTIONS(6634),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6634),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6634),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6634),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6634),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6634),
    [anon_sym_BSLASHurl] = ACTIONS(6634),
    [anon_sym_BSLASHhref] = ACTIONS(6634),
  },
  [1988] = {
    [sym_command_name] = ACTIONS(6654),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6654),
    [anon_sym_LBRACK] = ACTIONS(6656),
    [anon_sym_RBRACK] = ACTIONS(6656),
    [anon_sym_COMMA] = ACTIONS(6656),
    [anon_sym_EQ] = ACTIONS(6656),
    [anon_sym_LBRACE] = ACTIONS(6656),
    [anon_sym_RBRACE] = ACTIONS(6656),
    [sym_word] = ACTIONS(6654),
    [sym_placeholder] = ACTIONS(6656),
    [anon_sym_PLUS] = ACTIONS(6656),
    [anon_sym_DASH] = ACTIONS(6656),
    [anon_sym_STAR] = ACTIONS(6656),
    [anon_sym_SLASH] = ACTIONS(6656),
    [anon_sym_LT] = ACTIONS(6654),
    [anon_sym_GT] = ACTIONS(6654),
    [anon_sym_BANG] = ACTIONS(6654),
    [anon_sym_PIPE] = ACTIONS(6654),
    [anon_sym_COLON] = ACTIONS(6654),
    [anon_sym_SQUOTE] = ACTIONS(6654),
    [anon_sym__] = ACTIONS(6656),
    [anon_sym_CARET] = ACTIONS(6656),
    [anon_sym_BSLASHtitle] = ACTIONS(6654),
    [anon_sym_BSLASHauthor] = ACTIONS(6654),
    [anon_sym_BSLASHusepackage] = ACTIONS(6654),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6654),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6654),
    [anon_sym_BSLASHinclude] = ACTIONS(6654),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6654),
    [anon_sym_BSLASHinput] = ACTIONS(6654),
    [anon_sym_BSLASHsubfile] = ACTIONS(6654),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6654),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6654),
    [anon_sym_BSLASHbibliography] = ACTIONS(6654),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6654),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6654),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6654),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6654),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6654),
    [anon_sym_BSLASHimport] = ACTIONS(6654),
    [anon_sym_BSLASHsubimport] = ACTIONS(6654),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6654),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6654),
    [anon_sym_BSLASHcaption] = ACTIONS(6654),
    [anon_sym_BSLASHcite] = ACTIONS(6654),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCite] = ACTIONS(6654),
    [anon_sym_BSLASHnocite] = ACTIONS(6654),
    [anon_sym_BSLASHcitet] = ACTIONS(6654),
    [anon_sym_BSLASHcitep] = ACTIONS(6654),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteA] = ACTIONS(6654),
    [anon_sym_BSLASHciteR] = ACTIONS(6654),
    [anon_sym_BSLASHciteS] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6654),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6654),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteyear] = ACTIONS(6654),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHcitedate] = ACTIONS(6654),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHciteurl] = ACTIONS(6654),
    [anon_sym_BSLASHfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6654),
    [anon_sym_BSLASHcitealt] = ACTIONS(6654),
    [anon_sym_BSLASHcitealp] = ACTIONS(6654),
    [anon_sym_BSLASHcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHparencite] = ACTIONS(6654),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHParencite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6654),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6654),
    [anon_sym_BSLASHtextcite] = ACTIONS(6654),
    [anon_sym_BSLASHTextcite] = ACTIONS(6654),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6654),
    [anon_sym_BSLASHsupercite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite] = ACTIONS(6654),
    [anon_sym_BSLASHAutocite] = ACTIONS(6654),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHVolcite] = ACTIONS(6654),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHavolcite] = ACTIONS(6654),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6654),
    [anon_sym_BSLASHnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHNotecite] = ACTIONS(6654),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6654),
    [anon_sym_BSLASHlabel] = ACTIONS(6654),
    [anon_sym_BSLASHref] = ACTIONS(6654),
    [anon_sym_BSLASHeqref] = ACTIONS(6654),
    [anon_sym_BSLASHvref] = ACTIONS(6654),
    [anon_sym_BSLASHVref] = ACTIONS(6654),
    [anon_sym_BSLASHautoref] = ACTIONS(6654),
    [anon_sym_BSLASHpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcref] = ACTIONS(6654),
    [anon_sym_BSLASHCref] = ACTIONS(6654),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnameCref] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6654),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6654),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6654),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6654),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6654),
    [anon_sym_BSLASHdef] = ACTIONS(6654),
    [anon_sym_BSLASHlet] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6654),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6654),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6654),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6654),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6654),
    [anon_sym_BSLASHgls] = ACTIONS(6654),
    [anon_sym_BSLASHGls] = ACTIONS(6654),
    [anon_sym_BSLASHGLS] = ACTIONS(6654),
    [anon_sym_BSLASHglspl] = ACTIONS(6654),
    [anon_sym_BSLASHGlspl] = ACTIONS(6654),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6654),
    [anon_sym_BSLASHglslink] = ACTIONS(6654),
    [anon_sym_BSLASHglstext] = ACTIONS(6654),
    [anon_sym_BSLASHGlstext] = ACTIONS(6654),
    [anon_sym_BSLASHGLStext] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6654),
    [anon_sym_BSLASHglsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6654),
    [anon_sym_BSLASHglsname] = ACTIONS(6654),
    [anon_sym_BSLASHGlsname] = ACTIONS(6654),
    [anon_sym_BSLASHGLSname] = ACTIONS(6654),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6654),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6654),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6654),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6654),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6654),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6654),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6654),
    [anon_sym_BSLASHacrshort] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6654),
    [anon_sym_BSLASHACRshort] = ACTIONS(6654),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrlong] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6654),
    [anon_sym_BSLASHACRlong] = ACTIONS(6654),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6654),
    [anon_sym_BSLASHacrfull] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6654),
    [anon_sym_BSLASHACRfull] = ACTIONS(6654),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHacs] = ACTIONS(6654),
    [anon_sym_BSLASHAcs] = ACTIONS(6654),
    [anon_sym_BSLASHacsp] = ACTIONS(6654),
    [anon_sym_BSLASHAcsp] = ACTIONS(6654),
    [anon_sym_BSLASHacl] = ACTIONS(6654),
    [anon_sym_BSLASHAcl] = ACTIONS(6654),
    [anon_sym_BSLASHaclp] = ACTIONS(6654),
    [anon_sym_BSLASHAclp] = ACTIONS(6654),
    [anon_sym_BSLASHacf] = ACTIONS(6654),
    [anon_sym_BSLASHAcf] = ACTIONS(6654),
    [anon_sym_BSLASHacfp] = ACTIONS(6654),
    [anon_sym_BSLASHAcfp] = ACTIONS(6654),
    [anon_sym_BSLASHac] = ACTIONS(6654),
    [anon_sym_BSLASHAc] = ACTIONS(6654),
    [anon_sym_BSLASHacp] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6654),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6654),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6654),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6654),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6656),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6654),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6654),
    [anon_sym_BSLASHcolor] = ACTIONS(6654),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6654),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6654),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6654),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6654),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6654),
    [anon_sym_BSLASHurl] = ACTIONS(6654),
    [anon_sym_BSLASHhref] = ACTIONS(6654),
  },
  [1989] = {
    [sym_curly_group] = STATE(2059),
    [sym_command_name] = ACTIONS(6162),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6162),
    [anon_sym_RBRACK] = ACTIONS(6164),
    [anon_sym_COMMA] = ACTIONS(6164),
    [anon_sym_EQ] = ACTIONS(6164),
    [anon_sym_LBRACE] = ACTIONS(7169),
    [anon_sym_RBRACE] = ACTIONS(6164),
    [sym_word] = ACTIONS(6162),
    [sym_placeholder] = ACTIONS(6164),
    [anon_sym_PLUS] = ACTIONS(6164),
    [anon_sym_DASH] = ACTIONS(6164),
    [anon_sym_STAR] = ACTIONS(6164),
    [anon_sym_SLASH] = ACTIONS(6164),
    [anon_sym_LT] = ACTIONS(6162),
    [anon_sym_GT] = ACTIONS(6162),
    [anon_sym_BANG] = ACTIONS(6162),
    [anon_sym_PIPE] = ACTIONS(6162),
    [anon_sym_COLON] = ACTIONS(6162),
    [anon_sym_SQUOTE] = ACTIONS(6162),
    [anon_sym__] = ACTIONS(6164),
    [anon_sym_CARET] = ACTIONS(6164),
    [anon_sym_BSLASHtitle] = ACTIONS(6162),
    [anon_sym_BSLASHauthor] = ACTIONS(6162),
    [anon_sym_BSLASHusepackage] = ACTIONS(6162),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6162),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6162),
    [anon_sym_BSLASHinclude] = ACTIONS(6162),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6162),
    [anon_sym_BSLASHinput] = ACTIONS(6162),
    [anon_sym_BSLASHsubfile] = ACTIONS(6162),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6162),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6162),
    [anon_sym_BSLASHbibliography] = ACTIONS(6162),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6162),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6162),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6162),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6162),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6162),
    [anon_sym_BSLASHimport] = ACTIONS(6162),
    [anon_sym_BSLASHsubimport] = ACTIONS(6162),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6162),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6162),
    [anon_sym_BSLASHcaption] = ACTIONS(6162),
    [anon_sym_BSLASHcite] = ACTIONS(6162),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCite] = ACTIONS(6162),
    [anon_sym_BSLASHnocite] = ACTIONS(6162),
    [anon_sym_BSLASHcitet] = ACTIONS(6162),
    [anon_sym_BSLASHcitep] = ACTIONS(6162),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteA] = ACTIONS(6162),
    [anon_sym_BSLASHciteR] = ACTIONS(6162),
    [anon_sym_BSLASHciteS] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6162),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6162),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteyear] = ACTIONS(6162),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHcitedate] = ACTIONS(6162),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHciteurl] = ACTIONS(6162),
    [anon_sym_BSLASHfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6162),
    [anon_sym_BSLASHcitealt] = ACTIONS(6162),
    [anon_sym_BSLASHcitealp] = ACTIONS(6162),
    [anon_sym_BSLASHcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHparencite] = ACTIONS(6162),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHParencite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6162),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6162),
    [anon_sym_BSLASHtextcite] = ACTIONS(6162),
    [anon_sym_BSLASHTextcite] = ACTIONS(6162),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6162),
    [anon_sym_BSLASHsupercite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite] = ACTIONS(6162),
    [anon_sym_BSLASHAutocite] = ACTIONS(6162),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHVolcite] = ACTIONS(6162),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHavolcite] = ACTIONS(6162),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6162),
    [anon_sym_BSLASHnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHNotecite] = ACTIONS(6162),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6162),
    [anon_sym_BSLASHlabel] = ACTIONS(6162),
    [anon_sym_BSLASHref] = ACTIONS(6162),
    [anon_sym_BSLASHeqref] = ACTIONS(6162),
    [anon_sym_BSLASHvref] = ACTIONS(6162),
    [anon_sym_BSLASHVref] = ACTIONS(6162),
    [anon_sym_BSLASHautoref] = ACTIONS(6162),
    [anon_sym_BSLASHpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcref] = ACTIONS(6162),
    [anon_sym_BSLASHCref] = ACTIONS(6162),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnameCref] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6162),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6162),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6162),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6162),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6162),
    [anon_sym_BSLASHdef] = ACTIONS(6162),
    [anon_sym_BSLASHlet] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6162),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6162),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6162),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6162),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6162),
    [anon_sym_BSLASHgls] = ACTIONS(6162),
    [anon_sym_BSLASHGls] = ACTIONS(6162),
    [anon_sym_BSLASHGLS] = ACTIONS(6162),
    [anon_sym_BSLASHglspl] = ACTIONS(6162),
    [anon_sym_BSLASHGlspl] = ACTIONS(6162),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6162),
    [anon_sym_BSLASHglslink] = ACTIONS(6162),
    [anon_sym_BSLASHglstext] = ACTIONS(6162),
    [anon_sym_BSLASHGlstext] = ACTIONS(6162),
    [anon_sym_BSLASHGLStext] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6162),
    [anon_sym_BSLASHglsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6162),
    [anon_sym_BSLASHglsname] = ACTIONS(6162),
    [anon_sym_BSLASHGlsname] = ACTIONS(6162),
    [anon_sym_BSLASHGLSname] = ACTIONS(6162),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6162),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6162),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6162),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6162),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6162),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6162),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6162),
    [anon_sym_BSLASHacrshort] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6162),
    [anon_sym_BSLASHACRshort] = ACTIONS(6162),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrlong] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6162),
    [anon_sym_BSLASHACRlong] = ACTIONS(6162),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6162),
    [anon_sym_BSLASHacrfull] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6162),
    [anon_sym_BSLASHACRfull] = ACTIONS(6162),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHacs] = ACTIONS(6162),
    [anon_sym_BSLASHAcs] = ACTIONS(6162),
    [anon_sym_BSLASHacsp] = ACTIONS(6162),
    [anon_sym_BSLASHAcsp] = ACTIONS(6162),
    [anon_sym_BSLASHacl] = ACTIONS(6162),
    [anon_sym_BSLASHAcl] = ACTIONS(6162),
    [anon_sym_BSLASHaclp] = ACTIONS(6162),
    [anon_sym_BSLASHAclp] = ACTIONS(6162),
    [anon_sym_BSLASHacf] = ACTIONS(6162),
    [anon_sym_BSLASHAcf] = ACTIONS(6162),
    [anon_sym_BSLASHacfp] = ACTIONS(6162),
    [anon_sym_BSLASHAcfp] = ACTIONS(6162),
    [anon_sym_BSLASHac] = ACTIONS(6162),
    [anon_sym_BSLASHAc] = ACTIONS(6162),
    [anon_sym_BSLASHacp] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6162),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6162),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6162),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6162),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6164),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6162),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6162),
    [anon_sym_BSLASHcolor] = ACTIONS(6162),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6162),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6162),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6162),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6162),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6162),
    [anon_sym_BSLASHurl] = ACTIONS(6162),
    [anon_sym_BSLASHhref] = ACTIONS(6162),
  },
  [1990] = {
    [sym_command_name] = ACTIONS(6156),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6156),
    [anon_sym_BSLASHfi] = ACTIONS(7180),
    [anon_sym_RBRACK] = ACTIONS(6160),
    [anon_sym_COMMA] = ACTIONS(6160),
    [anon_sym_EQ] = ACTIONS(6160),
    [anon_sym_RBRACE] = ACTIONS(6160),
    [sym_word] = ACTIONS(6156),
    [sym_placeholder] = ACTIONS(6160),
    [anon_sym_PLUS] = ACTIONS(6160),
    [anon_sym_DASH] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(6160),
    [anon_sym_SLASH] = ACTIONS(6160),
    [anon_sym_LT] = ACTIONS(6156),
    [anon_sym_GT] = ACTIONS(6156),
    [anon_sym_BANG] = ACTIONS(6156),
    [anon_sym_PIPE] = ACTIONS(6156),
    [anon_sym_COLON] = ACTIONS(6156),
    [anon_sym_SQUOTE] = ACTIONS(6156),
    [anon_sym__] = ACTIONS(6160),
    [anon_sym_CARET] = ACTIONS(6160),
    [anon_sym_BSLASHtitle] = ACTIONS(6156),
    [anon_sym_BSLASHauthor] = ACTIONS(6156),
    [anon_sym_BSLASHusepackage] = ACTIONS(6156),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6156),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6156),
    [anon_sym_BSLASHinclude] = ACTIONS(6156),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6156),
    [anon_sym_BSLASHinput] = ACTIONS(6156),
    [anon_sym_BSLASHsubfile] = ACTIONS(6156),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6156),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6156),
    [anon_sym_BSLASHbibliography] = ACTIONS(6156),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6156),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6156),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6156),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6156),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6156),
    [anon_sym_BSLASHimport] = ACTIONS(6156),
    [anon_sym_BSLASHsubimport] = ACTIONS(6156),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6156),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6156),
    [anon_sym_BSLASHcaption] = ACTIONS(6156),
    [anon_sym_BSLASHcite] = ACTIONS(6156),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCite] = ACTIONS(6156),
    [anon_sym_BSLASHnocite] = ACTIONS(6156),
    [anon_sym_BSLASHcitet] = ACTIONS(6156),
    [anon_sym_BSLASHcitep] = ACTIONS(6156),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteA] = ACTIONS(6156),
    [anon_sym_BSLASHciteR] = ACTIONS(6156),
    [anon_sym_BSLASHciteS] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6156),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6156),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteyear] = ACTIONS(6156),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHcitedate] = ACTIONS(6156),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHciteurl] = ACTIONS(6156),
    [anon_sym_BSLASHfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6156),
    [anon_sym_BSLASHcitealt] = ACTIONS(6156),
    [anon_sym_BSLASHcitealp] = ACTIONS(6156),
    [anon_sym_BSLASHcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHparencite] = ACTIONS(6156),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHParencite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6156),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6156),
    [anon_sym_BSLASHtextcite] = ACTIONS(6156),
    [anon_sym_BSLASHTextcite] = ACTIONS(6156),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6156),
    [anon_sym_BSLASHsupercite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite] = ACTIONS(6156),
    [anon_sym_BSLASHAutocite] = ACTIONS(6156),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHVolcite] = ACTIONS(6156),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHavolcite] = ACTIONS(6156),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6156),
    [anon_sym_BSLASHnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHNotecite] = ACTIONS(6156),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6156),
    [anon_sym_BSLASHlabel] = ACTIONS(6156),
    [anon_sym_BSLASHref] = ACTIONS(6156),
    [anon_sym_BSLASHeqref] = ACTIONS(6156),
    [anon_sym_BSLASHvref] = ACTIONS(6156),
    [anon_sym_BSLASHVref] = ACTIONS(6156),
    [anon_sym_BSLASHautoref] = ACTIONS(6156),
    [anon_sym_BSLASHpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcref] = ACTIONS(6156),
    [anon_sym_BSLASHCref] = ACTIONS(6156),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnameCref] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6156),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6156),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6156),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6156),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6156),
    [anon_sym_BSLASHdef] = ACTIONS(6156),
    [anon_sym_BSLASHlet] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6156),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6156),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6156),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6156),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6156),
    [anon_sym_BSLASHgls] = ACTIONS(6156),
    [anon_sym_BSLASHGls] = ACTIONS(6156),
    [anon_sym_BSLASHGLS] = ACTIONS(6156),
    [anon_sym_BSLASHglspl] = ACTIONS(6156),
    [anon_sym_BSLASHGlspl] = ACTIONS(6156),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6156),
    [anon_sym_BSLASHglslink] = ACTIONS(6156),
    [anon_sym_BSLASHglstext] = ACTIONS(6156),
    [anon_sym_BSLASHGlstext] = ACTIONS(6156),
    [anon_sym_BSLASHGLStext] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6156),
    [anon_sym_BSLASHglsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6156),
    [anon_sym_BSLASHglsname] = ACTIONS(6156),
    [anon_sym_BSLASHGlsname] = ACTIONS(6156),
    [anon_sym_BSLASHGLSname] = ACTIONS(6156),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6156),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6156),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6156),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6156),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6156),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6156),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6156),
    [anon_sym_BSLASHacrshort] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6156),
    [anon_sym_BSLASHACRshort] = ACTIONS(6156),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrlong] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6156),
    [anon_sym_BSLASHACRlong] = ACTIONS(6156),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6156),
    [anon_sym_BSLASHacrfull] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6156),
    [anon_sym_BSLASHACRfull] = ACTIONS(6156),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHacs] = ACTIONS(6156),
    [anon_sym_BSLASHAcs] = ACTIONS(6156),
    [anon_sym_BSLASHacsp] = ACTIONS(6156),
    [anon_sym_BSLASHAcsp] = ACTIONS(6156),
    [anon_sym_BSLASHacl] = ACTIONS(6156),
    [anon_sym_BSLASHAcl] = ACTIONS(6156),
    [anon_sym_BSLASHaclp] = ACTIONS(6156),
    [anon_sym_BSLASHAclp] = ACTIONS(6156),
    [anon_sym_BSLASHacf] = ACTIONS(6156),
    [anon_sym_BSLASHAcf] = ACTIONS(6156),
    [anon_sym_BSLASHacfp] = ACTIONS(6156),
    [anon_sym_BSLASHAcfp] = ACTIONS(6156),
    [anon_sym_BSLASHac] = ACTIONS(6156),
    [anon_sym_BSLASHAc] = ACTIONS(6156),
    [anon_sym_BSLASHacp] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6156),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6156),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6156),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6156),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6160),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6156),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6156),
    [anon_sym_BSLASHcolor] = ACTIONS(6156),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6156),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6156),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6156),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6156),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6156),
    [anon_sym_BSLASHurl] = ACTIONS(6156),
    [anon_sym_BSLASHhref] = ACTIONS(6156),
  },
  [1991] = {
    [sym_command_name] = ACTIONS(6494),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6494),
    [anon_sym_RBRACK] = ACTIONS(6496),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_EQ] = ACTIONS(6496),
    [anon_sym_LBRACE] = ACTIONS(6496),
    [anon_sym_RBRACE] = ACTIONS(6496),
    [sym_word] = ACTIONS(6494),
    [sym_placeholder] = ACTIONS(6496),
    [anon_sym_PLUS] = ACTIONS(6496),
    [anon_sym_DASH] = ACTIONS(6496),
    [anon_sym_STAR] = ACTIONS(6496),
    [anon_sym_SLASH] = ACTIONS(6496),
    [anon_sym_LT] = ACTIONS(6494),
    [anon_sym_GT] = ACTIONS(6494),
    [anon_sym_BANG] = ACTIONS(6494),
    [anon_sym_PIPE] = ACTIONS(6494),
    [anon_sym_COLON] = ACTIONS(6494),
    [anon_sym_SQUOTE] = ACTIONS(6494),
    [anon_sym__] = ACTIONS(6496),
    [anon_sym_CARET] = ACTIONS(6496),
    [anon_sym_BSLASHtitle] = ACTIONS(6494),
    [anon_sym_BSLASHauthor] = ACTIONS(6494),
    [anon_sym_BSLASHusepackage] = ACTIONS(6494),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6494),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6494),
    [anon_sym_BSLASHinclude] = ACTIONS(6494),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6494),
    [anon_sym_BSLASHinput] = ACTIONS(6494),
    [anon_sym_BSLASHsubfile] = ACTIONS(6494),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6494),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6494),
    [anon_sym_BSLASHbibliography] = ACTIONS(6494),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6494),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6494),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6494),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6494),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6494),
    [anon_sym_BSLASHimport] = ACTIONS(6494),
    [anon_sym_BSLASHsubimport] = ACTIONS(6494),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6494),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6494),
    [anon_sym_BSLASHcaption] = ACTIONS(6494),
    [anon_sym_BSLASHcite] = ACTIONS(6494),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCite] = ACTIONS(6494),
    [anon_sym_BSLASHnocite] = ACTIONS(6494),
    [anon_sym_BSLASHcitet] = ACTIONS(6494),
    [anon_sym_BSLASHcitep] = ACTIONS(6494),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteA] = ACTIONS(6494),
    [anon_sym_BSLASHciteR] = ACTIONS(6494),
    [anon_sym_BSLASHciteS] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6494),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6494),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteyear] = ACTIONS(6494),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHcitedate] = ACTIONS(6494),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHciteurl] = ACTIONS(6494),
    [anon_sym_BSLASHfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6494),
    [anon_sym_BSLASHcitealt] = ACTIONS(6494),
    [anon_sym_BSLASHcitealp] = ACTIONS(6494),
    [anon_sym_BSLASHcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHparencite] = ACTIONS(6494),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHParencite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6494),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6494),
    [anon_sym_BSLASHtextcite] = ACTIONS(6494),
    [anon_sym_BSLASHTextcite] = ACTIONS(6494),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6494),
    [anon_sym_BSLASHsupercite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite] = ACTIONS(6494),
    [anon_sym_BSLASHAutocite] = ACTIONS(6494),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHVolcite] = ACTIONS(6494),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHavolcite] = ACTIONS(6494),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6494),
    [anon_sym_BSLASHnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHNotecite] = ACTIONS(6494),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6494),
    [anon_sym_BSLASHlabel] = ACTIONS(6494),
    [anon_sym_BSLASHref] = ACTIONS(6494),
    [anon_sym_BSLASHeqref] = ACTIONS(6494),
    [anon_sym_BSLASHvref] = ACTIONS(6494),
    [anon_sym_BSLASHVref] = ACTIONS(6494),
    [anon_sym_BSLASHautoref] = ACTIONS(6494),
    [anon_sym_BSLASHpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcref] = ACTIONS(6494),
    [anon_sym_BSLASHCref] = ACTIONS(6494),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnameCref] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6494),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6494),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6494),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6494),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6494),
    [anon_sym_BSLASHdef] = ACTIONS(6494),
    [anon_sym_BSLASHlet] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6494),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6494),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6494),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6494),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6494),
    [anon_sym_BSLASHgls] = ACTIONS(6494),
    [anon_sym_BSLASHGls] = ACTIONS(6494),
    [anon_sym_BSLASHGLS] = ACTIONS(6494),
    [anon_sym_BSLASHglspl] = ACTIONS(6494),
    [anon_sym_BSLASHGlspl] = ACTIONS(6494),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6494),
    [anon_sym_BSLASHglslink] = ACTIONS(6494),
    [anon_sym_BSLASHglstext] = ACTIONS(6494),
    [anon_sym_BSLASHGlstext] = ACTIONS(6494),
    [anon_sym_BSLASHGLStext] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6494),
    [anon_sym_BSLASHglsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6494),
    [anon_sym_BSLASHglsname] = ACTIONS(6494),
    [anon_sym_BSLASHGlsname] = ACTIONS(6494),
    [anon_sym_BSLASHGLSname] = ACTIONS(6494),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6494),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6494),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6494),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6494),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6494),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6494),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6494),
    [anon_sym_BSLASHacrshort] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6494),
    [anon_sym_BSLASHACRshort] = ACTIONS(6494),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrlong] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6494),
    [anon_sym_BSLASHACRlong] = ACTIONS(6494),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6494),
    [anon_sym_BSLASHacrfull] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6494),
    [anon_sym_BSLASHACRfull] = ACTIONS(6494),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHacs] = ACTIONS(6494),
    [anon_sym_BSLASHAcs] = ACTIONS(6494),
    [anon_sym_BSLASHacsp] = ACTIONS(6494),
    [anon_sym_BSLASHAcsp] = ACTIONS(6494),
    [anon_sym_BSLASHacl] = ACTIONS(6494),
    [anon_sym_BSLASHAcl] = ACTIONS(6494),
    [anon_sym_BSLASHaclp] = ACTIONS(6494),
    [anon_sym_BSLASHAclp] = ACTIONS(6494),
    [anon_sym_BSLASHacf] = ACTIONS(6494),
    [anon_sym_BSLASHAcf] = ACTIONS(6494),
    [anon_sym_BSLASHacfp] = ACTIONS(6494),
    [anon_sym_BSLASHAcfp] = ACTIONS(6494),
    [anon_sym_BSLASHac] = ACTIONS(6494),
    [anon_sym_BSLASHAc] = ACTIONS(6494),
    [anon_sym_BSLASHacp] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6494),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6494),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6494),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6494),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6496),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6494),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6494),
    [anon_sym_BSLASHcolor] = ACTIONS(6494),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6494),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6494),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6494),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6494),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6494),
    [anon_sym_BSLASHurl] = ACTIONS(6494),
    [anon_sym_BSLASHhref] = ACTIONS(6494),
  },
  [1992] = {
    [sym_command_name] = ACTIONS(6278),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6278),
    [anon_sym_RBRACK] = ACTIONS(6280),
    [anon_sym_COMMA] = ACTIONS(6280),
    [anon_sym_EQ] = ACTIONS(6280),
    [anon_sym_LBRACE] = ACTIONS(6280),
    [anon_sym_RBRACE] = ACTIONS(6280),
    [sym_word] = ACTIONS(6278),
    [sym_placeholder] = ACTIONS(6280),
    [anon_sym_PLUS] = ACTIONS(6280),
    [anon_sym_DASH] = ACTIONS(6280),
    [anon_sym_STAR] = ACTIONS(6280),
    [anon_sym_SLASH] = ACTIONS(6280),
    [anon_sym_LT] = ACTIONS(6278),
    [anon_sym_GT] = ACTIONS(6278),
    [anon_sym_BANG] = ACTIONS(6278),
    [anon_sym_PIPE] = ACTIONS(6278),
    [anon_sym_COLON] = ACTIONS(6278),
    [anon_sym_SQUOTE] = ACTIONS(6278),
    [anon_sym__] = ACTIONS(6280),
    [anon_sym_CARET] = ACTIONS(6280),
    [anon_sym_BSLASHtitle] = ACTIONS(6278),
    [anon_sym_BSLASHauthor] = ACTIONS(6278),
    [anon_sym_BSLASHusepackage] = ACTIONS(6278),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6278),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6278),
    [anon_sym_BSLASHinclude] = ACTIONS(6278),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6278),
    [anon_sym_BSLASHinput] = ACTIONS(6278),
    [anon_sym_BSLASHsubfile] = ACTIONS(6278),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6278),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6278),
    [anon_sym_BSLASHbibliography] = ACTIONS(6278),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6278),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6278),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6278),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6278),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6278),
    [anon_sym_BSLASHimport] = ACTIONS(6278),
    [anon_sym_BSLASHsubimport] = ACTIONS(6278),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6278),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6278),
    [anon_sym_BSLASHcaption] = ACTIONS(6278),
    [anon_sym_BSLASHcite] = ACTIONS(6278),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCite] = ACTIONS(6278),
    [anon_sym_BSLASHnocite] = ACTIONS(6278),
    [anon_sym_BSLASHcitet] = ACTIONS(6278),
    [anon_sym_BSLASHcitep] = ACTIONS(6278),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteA] = ACTIONS(6278),
    [anon_sym_BSLASHciteR] = ACTIONS(6278),
    [anon_sym_BSLASHciteS] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6278),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6278),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteyear] = ACTIONS(6278),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHcitedate] = ACTIONS(6278),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHciteurl] = ACTIONS(6278),
    [anon_sym_BSLASHfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6278),
    [anon_sym_BSLASHcitealt] = ACTIONS(6278),
    [anon_sym_BSLASHcitealp] = ACTIONS(6278),
    [anon_sym_BSLASHcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHparencite] = ACTIONS(6278),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHParencite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6278),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6278),
    [anon_sym_BSLASHtextcite] = ACTIONS(6278),
    [anon_sym_BSLASHTextcite] = ACTIONS(6278),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6278),
    [anon_sym_BSLASHsupercite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite] = ACTIONS(6278),
    [anon_sym_BSLASHAutocite] = ACTIONS(6278),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHVolcite] = ACTIONS(6278),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHavolcite] = ACTIONS(6278),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6278),
    [anon_sym_BSLASHnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHNotecite] = ACTIONS(6278),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6278),
    [anon_sym_BSLASHlabel] = ACTIONS(6278),
    [anon_sym_BSLASHref] = ACTIONS(6278),
    [anon_sym_BSLASHeqref] = ACTIONS(6278),
    [anon_sym_BSLASHvref] = ACTIONS(6278),
    [anon_sym_BSLASHVref] = ACTIONS(6278),
    [anon_sym_BSLASHautoref] = ACTIONS(6278),
    [anon_sym_BSLASHpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcref] = ACTIONS(6278),
    [anon_sym_BSLASHCref] = ACTIONS(6278),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnameCref] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6278),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6278),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6278),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6278),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6278),
    [anon_sym_BSLASHdef] = ACTIONS(6278),
    [anon_sym_BSLASHlet] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6278),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6278),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6278),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6278),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6278),
    [anon_sym_BSLASHgls] = ACTIONS(6278),
    [anon_sym_BSLASHGls] = ACTIONS(6278),
    [anon_sym_BSLASHGLS] = ACTIONS(6278),
    [anon_sym_BSLASHglspl] = ACTIONS(6278),
    [anon_sym_BSLASHGlspl] = ACTIONS(6278),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6278),
    [anon_sym_BSLASHglslink] = ACTIONS(6278),
    [anon_sym_BSLASHglstext] = ACTIONS(6278),
    [anon_sym_BSLASHGlstext] = ACTIONS(6278),
    [anon_sym_BSLASHGLStext] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6278),
    [anon_sym_BSLASHglsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6278),
    [anon_sym_BSLASHglsname] = ACTIONS(6278),
    [anon_sym_BSLASHGlsname] = ACTIONS(6278),
    [anon_sym_BSLASHGLSname] = ACTIONS(6278),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6278),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6278),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6278),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6278),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6278),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6278),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6278),
    [anon_sym_BSLASHacrshort] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6278),
    [anon_sym_BSLASHACRshort] = ACTIONS(6278),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrlong] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6278),
    [anon_sym_BSLASHACRlong] = ACTIONS(6278),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6278),
    [anon_sym_BSLASHacrfull] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6278),
    [anon_sym_BSLASHACRfull] = ACTIONS(6278),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHacs] = ACTIONS(6278),
    [anon_sym_BSLASHAcs] = ACTIONS(6278),
    [anon_sym_BSLASHacsp] = ACTIONS(6278),
    [anon_sym_BSLASHAcsp] = ACTIONS(6278),
    [anon_sym_BSLASHacl] = ACTIONS(6278),
    [anon_sym_BSLASHAcl] = ACTIONS(6278),
    [anon_sym_BSLASHaclp] = ACTIONS(6278),
    [anon_sym_BSLASHAclp] = ACTIONS(6278),
    [anon_sym_BSLASHacf] = ACTIONS(6278),
    [anon_sym_BSLASHAcf] = ACTIONS(6278),
    [anon_sym_BSLASHacfp] = ACTIONS(6278),
    [anon_sym_BSLASHAcfp] = ACTIONS(6278),
    [anon_sym_BSLASHac] = ACTIONS(6278),
    [anon_sym_BSLASHAc] = ACTIONS(6278),
    [anon_sym_BSLASHacp] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6278),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6278),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6278),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6278),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6280),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6278),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6278),
    [anon_sym_BSLASHcolor] = ACTIONS(6278),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6278),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6278),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6278),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6278),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6278),
    [anon_sym_BSLASHurl] = ACTIONS(6278),
    [anon_sym_BSLASHhref] = ACTIONS(6278),
  },
  [1993] = {
    [sym_command_name] = ACTIONS(6274),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6274),
    [anon_sym_RBRACK] = ACTIONS(6276),
    [anon_sym_COMMA] = ACTIONS(6276),
    [anon_sym_EQ] = ACTIONS(6276),
    [anon_sym_LBRACE] = ACTIONS(6276),
    [anon_sym_RBRACE] = ACTIONS(6276),
    [sym_word] = ACTIONS(6274),
    [sym_placeholder] = ACTIONS(6276),
    [anon_sym_PLUS] = ACTIONS(6276),
    [anon_sym_DASH] = ACTIONS(6276),
    [anon_sym_STAR] = ACTIONS(6276),
    [anon_sym_SLASH] = ACTIONS(6276),
    [anon_sym_LT] = ACTIONS(6274),
    [anon_sym_GT] = ACTIONS(6274),
    [anon_sym_BANG] = ACTIONS(6274),
    [anon_sym_PIPE] = ACTIONS(6274),
    [anon_sym_COLON] = ACTIONS(6274),
    [anon_sym_SQUOTE] = ACTIONS(6274),
    [anon_sym__] = ACTIONS(6276),
    [anon_sym_CARET] = ACTIONS(6276),
    [anon_sym_BSLASHtitle] = ACTIONS(6274),
    [anon_sym_BSLASHauthor] = ACTIONS(6274),
    [anon_sym_BSLASHusepackage] = ACTIONS(6274),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6274),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6274),
    [anon_sym_BSLASHinclude] = ACTIONS(6274),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6274),
    [anon_sym_BSLASHinput] = ACTIONS(6274),
    [anon_sym_BSLASHsubfile] = ACTIONS(6274),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6274),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6274),
    [anon_sym_BSLASHbibliography] = ACTIONS(6274),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6274),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6274),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6274),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6274),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6274),
    [anon_sym_BSLASHimport] = ACTIONS(6274),
    [anon_sym_BSLASHsubimport] = ACTIONS(6274),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6274),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6274),
    [anon_sym_BSLASHcaption] = ACTIONS(6274),
    [anon_sym_BSLASHcite] = ACTIONS(6274),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCite] = ACTIONS(6274),
    [anon_sym_BSLASHnocite] = ACTIONS(6274),
    [anon_sym_BSLASHcitet] = ACTIONS(6274),
    [anon_sym_BSLASHcitep] = ACTIONS(6274),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteA] = ACTIONS(6274),
    [anon_sym_BSLASHciteR] = ACTIONS(6274),
    [anon_sym_BSLASHciteS] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6274),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6274),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteyear] = ACTIONS(6274),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHcitedate] = ACTIONS(6274),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHciteurl] = ACTIONS(6274),
    [anon_sym_BSLASHfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6274),
    [anon_sym_BSLASHcitealt] = ACTIONS(6274),
    [anon_sym_BSLASHcitealp] = ACTIONS(6274),
    [anon_sym_BSLASHcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHparencite] = ACTIONS(6274),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHParencite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6274),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6274),
    [anon_sym_BSLASHtextcite] = ACTIONS(6274),
    [anon_sym_BSLASHTextcite] = ACTIONS(6274),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6274),
    [anon_sym_BSLASHsupercite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite] = ACTIONS(6274),
    [anon_sym_BSLASHAutocite] = ACTIONS(6274),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHVolcite] = ACTIONS(6274),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHavolcite] = ACTIONS(6274),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6274),
    [anon_sym_BSLASHnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHNotecite] = ACTIONS(6274),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6274),
    [anon_sym_BSLASHlabel] = ACTIONS(6274),
    [anon_sym_BSLASHref] = ACTIONS(6274),
    [anon_sym_BSLASHeqref] = ACTIONS(6274),
    [anon_sym_BSLASHvref] = ACTIONS(6274),
    [anon_sym_BSLASHVref] = ACTIONS(6274),
    [anon_sym_BSLASHautoref] = ACTIONS(6274),
    [anon_sym_BSLASHpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcref] = ACTIONS(6274),
    [anon_sym_BSLASHCref] = ACTIONS(6274),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnameCref] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6274),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6274),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6274),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6274),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6274),
    [anon_sym_BSLASHdef] = ACTIONS(6274),
    [anon_sym_BSLASHlet] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6274),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6274),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6274),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6274),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6274),
    [anon_sym_BSLASHgls] = ACTIONS(6274),
    [anon_sym_BSLASHGls] = ACTIONS(6274),
    [anon_sym_BSLASHGLS] = ACTIONS(6274),
    [anon_sym_BSLASHglspl] = ACTIONS(6274),
    [anon_sym_BSLASHGlspl] = ACTIONS(6274),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6274),
    [anon_sym_BSLASHglslink] = ACTIONS(6274),
    [anon_sym_BSLASHglstext] = ACTIONS(6274),
    [anon_sym_BSLASHGlstext] = ACTIONS(6274),
    [anon_sym_BSLASHGLStext] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6274),
    [anon_sym_BSLASHglsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6274),
    [anon_sym_BSLASHglsname] = ACTIONS(6274),
    [anon_sym_BSLASHGlsname] = ACTIONS(6274),
    [anon_sym_BSLASHGLSname] = ACTIONS(6274),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6274),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6274),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6274),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6274),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6274),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6274),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6274),
    [anon_sym_BSLASHacrshort] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6274),
    [anon_sym_BSLASHACRshort] = ACTIONS(6274),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrlong] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6274),
    [anon_sym_BSLASHACRlong] = ACTIONS(6274),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6274),
    [anon_sym_BSLASHacrfull] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6274),
    [anon_sym_BSLASHACRfull] = ACTIONS(6274),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHacs] = ACTIONS(6274),
    [anon_sym_BSLASHAcs] = ACTIONS(6274),
    [anon_sym_BSLASHacsp] = ACTIONS(6274),
    [anon_sym_BSLASHAcsp] = ACTIONS(6274),
    [anon_sym_BSLASHacl] = ACTIONS(6274),
    [anon_sym_BSLASHAcl] = ACTIONS(6274),
    [anon_sym_BSLASHaclp] = ACTIONS(6274),
    [anon_sym_BSLASHAclp] = ACTIONS(6274),
    [anon_sym_BSLASHacf] = ACTIONS(6274),
    [anon_sym_BSLASHAcf] = ACTIONS(6274),
    [anon_sym_BSLASHacfp] = ACTIONS(6274),
    [anon_sym_BSLASHAcfp] = ACTIONS(6274),
    [anon_sym_BSLASHac] = ACTIONS(6274),
    [anon_sym_BSLASHAc] = ACTIONS(6274),
    [anon_sym_BSLASHacp] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6274),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6274),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6274),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6274),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6276),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6274),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6274),
    [anon_sym_BSLASHcolor] = ACTIONS(6274),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6274),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6274),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6274),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6274),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6274),
    [anon_sym_BSLASHurl] = ACTIONS(6274),
    [anon_sym_BSLASHhref] = ACTIONS(6274),
  },
  [1994] = {
    [sym_command_name] = ACTIONS(6454),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6454),
    [anon_sym_RBRACK] = ACTIONS(6456),
    [anon_sym_COMMA] = ACTIONS(6456),
    [anon_sym_EQ] = ACTIONS(6456),
    [anon_sym_LBRACE] = ACTIONS(6456),
    [anon_sym_RBRACE] = ACTIONS(6456),
    [sym_word] = ACTIONS(6454),
    [sym_placeholder] = ACTIONS(6456),
    [anon_sym_PLUS] = ACTIONS(6456),
    [anon_sym_DASH] = ACTIONS(6456),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_SLASH] = ACTIONS(6456),
    [anon_sym_LT] = ACTIONS(6454),
    [anon_sym_GT] = ACTIONS(6454),
    [anon_sym_BANG] = ACTIONS(6454),
    [anon_sym_PIPE] = ACTIONS(6454),
    [anon_sym_COLON] = ACTIONS(6454),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym__] = ACTIONS(6456),
    [anon_sym_CARET] = ACTIONS(6456),
    [anon_sym_BSLASHtitle] = ACTIONS(6454),
    [anon_sym_BSLASHauthor] = ACTIONS(6454),
    [anon_sym_BSLASHusepackage] = ACTIONS(6454),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6454),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6454),
    [anon_sym_BSLASHinclude] = ACTIONS(6454),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6454),
    [anon_sym_BSLASHinput] = ACTIONS(6454),
    [anon_sym_BSLASHsubfile] = ACTIONS(6454),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6454),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6454),
    [anon_sym_BSLASHbibliography] = ACTIONS(6454),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6454),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6454),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6454),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6454),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6454),
    [anon_sym_BSLASHimport] = ACTIONS(6454),
    [anon_sym_BSLASHsubimport] = ACTIONS(6454),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6454),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6454),
    [anon_sym_BSLASHcaption] = ACTIONS(6454),
    [anon_sym_BSLASHcite] = ACTIONS(6454),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCite] = ACTIONS(6454),
    [anon_sym_BSLASHnocite] = ACTIONS(6454),
    [anon_sym_BSLASHcitet] = ACTIONS(6454),
    [anon_sym_BSLASHcitep] = ACTIONS(6454),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteA] = ACTIONS(6454),
    [anon_sym_BSLASHciteR] = ACTIONS(6454),
    [anon_sym_BSLASHciteS] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6454),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6454),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteyear] = ACTIONS(6454),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHcitedate] = ACTIONS(6454),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHciteurl] = ACTIONS(6454),
    [anon_sym_BSLASHfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6454),
    [anon_sym_BSLASHcitealt] = ACTIONS(6454),
    [anon_sym_BSLASHcitealp] = ACTIONS(6454),
    [anon_sym_BSLASHcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHparencite] = ACTIONS(6454),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHParencite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6454),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6454),
    [anon_sym_BSLASHtextcite] = ACTIONS(6454),
    [anon_sym_BSLASHTextcite] = ACTIONS(6454),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6454),
    [anon_sym_BSLASHsupercite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite] = ACTIONS(6454),
    [anon_sym_BSLASHAutocite] = ACTIONS(6454),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHVolcite] = ACTIONS(6454),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHavolcite] = ACTIONS(6454),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6454),
    [anon_sym_BSLASHnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHNotecite] = ACTIONS(6454),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6454),
    [anon_sym_BSLASHlabel] = ACTIONS(6454),
    [anon_sym_BSLASHref] = ACTIONS(6454),
    [anon_sym_BSLASHeqref] = ACTIONS(6454),
    [anon_sym_BSLASHvref] = ACTIONS(6454),
    [anon_sym_BSLASHVref] = ACTIONS(6454),
    [anon_sym_BSLASHautoref] = ACTIONS(6454),
    [anon_sym_BSLASHpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcref] = ACTIONS(6454),
    [anon_sym_BSLASHCref] = ACTIONS(6454),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnameCref] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6454),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6454),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6454),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6454),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6454),
    [anon_sym_BSLASHdef] = ACTIONS(6454),
    [anon_sym_BSLASHlet] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6454),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6454),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6454),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6454),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6454),
    [anon_sym_BSLASHgls] = ACTIONS(6454),
    [anon_sym_BSLASHGls] = ACTIONS(6454),
    [anon_sym_BSLASHGLS] = ACTIONS(6454),
    [anon_sym_BSLASHglspl] = ACTIONS(6454),
    [anon_sym_BSLASHGlspl] = ACTIONS(6454),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6454),
    [anon_sym_BSLASHglslink] = ACTIONS(6454),
    [anon_sym_BSLASHglstext] = ACTIONS(6454),
    [anon_sym_BSLASHGlstext] = ACTIONS(6454),
    [anon_sym_BSLASHGLStext] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6454),
    [anon_sym_BSLASHglsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6454),
    [anon_sym_BSLASHglsname] = ACTIONS(6454),
    [anon_sym_BSLASHGlsname] = ACTIONS(6454),
    [anon_sym_BSLASHGLSname] = ACTIONS(6454),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6454),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6454),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6454),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6454),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6454),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6454),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6454),
    [anon_sym_BSLASHacrshort] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6454),
    [anon_sym_BSLASHACRshort] = ACTIONS(6454),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrlong] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6454),
    [anon_sym_BSLASHACRlong] = ACTIONS(6454),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6454),
    [anon_sym_BSLASHacrfull] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6454),
    [anon_sym_BSLASHACRfull] = ACTIONS(6454),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHacs] = ACTIONS(6454),
    [anon_sym_BSLASHAcs] = ACTIONS(6454),
    [anon_sym_BSLASHacsp] = ACTIONS(6454),
    [anon_sym_BSLASHAcsp] = ACTIONS(6454),
    [anon_sym_BSLASHacl] = ACTIONS(6454),
    [anon_sym_BSLASHAcl] = ACTIONS(6454),
    [anon_sym_BSLASHaclp] = ACTIONS(6454),
    [anon_sym_BSLASHAclp] = ACTIONS(6454),
    [anon_sym_BSLASHacf] = ACTIONS(6454),
    [anon_sym_BSLASHAcf] = ACTIONS(6454),
    [anon_sym_BSLASHacfp] = ACTIONS(6454),
    [anon_sym_BSLASHAcfp] = ACTIONS(6454),
    [anon_sym_BSLASHac] = ACTIONS(6454),
    [anon_sym_BSLASHAc] = ACTIONS(6454),
    [anon_sym_BSLASHacp] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6454),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6454),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6454),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6454),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6456),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6454),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6454),
    [anon_sym_BSLASHcolor] = ACTIONS(6454),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6454),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6454),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6454),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6454),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6454),
    [anon_sym_BSLASHurl] = ACTIONS(6454),
    [anon_sym_BSLASHhref] = ACTIONS(6454),
  },
  [1995] = {
    [sym_command_name] = ACTIONS(6214),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6214),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_COMMA] = ACTIONS(6216),
    [anon_sym_EQ] = ACTIONS(6216),
    [anon_sym_RBRACE] = ACTIONS(6216),
    [sym_word] = ACTIONS(6214),
    [sym_placeholder] = ACTIONS(6216),
    [anon_sym_PLUS] = ACTIONS(6216),
    [anon_sym_DASH] = ACTIONS(6216),
    [anon_sym_STAR] = ACTIONS(6216),
    [anon_sym_SLASH] = ACTIONS(6216),
    [anon_sym_LT] = ACTIONS(6214),
    [anon_sym_GT] = ACTIONS(6214),
    [anon_sym_BANG] = ACTIONS(6214),
    [anon_sym_PIPE] = ACTIONS(6214),
    [anon_sym_COLON] = ACTIONS(6214),
    [anon_sym_SQUOTE] = ACTIONS(6214),
    [anon_sym__] = ACTIONS(6216),
    [anon_sym_CARET] = ACTIONS(6216),
    [anon_sym_BSLASHtitle] = ACTIONS(6214),
    [anon_sym_BSLASHauthor] = ACTIONS(6214),
    [anon_sym_BSLASHusepackage] = ACTIONS(6214),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6214),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6214),
    [anon_sym_BSLASHinclude] = ACTIONS(6214),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6214),
    [anon_sym_BSLASHinput] = ACTIONS(6214),
    [anon_sym_BSLASHsubfile] = ACTIONS(6214),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6214),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6214),
    [anon_sym_BSLASHbibliography] = ACTIONS(6214),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6214),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6214),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6214),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6214),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6214),
    [anon_sym_BSLASHimport] = ACTIONS(6214),
    [anon_sym_BSLASHsubimport] = ACTIONS(6214),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6214),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6214),
    [anon_sym_BSLASHcaption] = ACTIONS(6214),
    [anon_sym_BSLASHcite] = ACTIONS(6214),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCite] = ACTIONS(6214),
    [anon_sym_BSLASHnocite] = ACTIONS(6214),
    [anon_sym_BSLASHcitet] = ACTIONS(6214),
    [anon_sym_BSLASHcitep] = ACTIONS(6214),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteA] = ACTIONS(6214),
    [anon_sym_BSLASHciteR] = ACTIONS(6214),
    [anon_sym_BSLASHciteS] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6214),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6214),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteyear] = ACTIONS(6214),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHcitedate] = ACTIONS(6214),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHciteurl] = ACTIONS(6214),
    [anon_sym_BSLASHfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6214),
    [anon_sym_BSLASHcitealt] = ACTIONS(6214),
    [anon_sym_BSLASHcitealp] = ACTIONS(6214),
    [anon_sym_BSLASHcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHparencite] = ACTIONS(6214),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHParencite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6214),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6214),
    [anon_sym_BSLASHtextcite] = ACTIONS(6214),
    [anon_sym_BSLASHTextcite] = ACTIONS(6214),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6214),
    [anon_sym_BSLASHsupercite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite] = ACTIONS(6214),
    [anon_sym_BSLASHAutocite] = ACTIONS(6214),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHVolcite] = ACTIONS(6214),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHavolcite] = ACTIONS(6214),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6214),
    [anon_sym_BSLASHnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHNotecite] = ACTIONS(6214),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6214),
    [anon_sym_BSLASHlabel] = ACTIONS(6214),
    [anon_sym_BSLASHref] = ACTIONS(6214),
    [anon_sym_BSLASHeqref] = ACTIONS(6214),
    [anon_sym_BSLASHvref] = ACTIONS(6214),
    [anon_sym_BSLASHVref] = ACTIONS(6214),
    [anon_sym_BSLASHautoref] = ACTIONS(6214),
    [anon_sym_BSLASHpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcref] = ACTIONS(6214),
    [anon_sym_BSLASHCref] = ACTIONS(6214),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnameCref] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6214),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6214),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6214),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6214),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6214),
    [anon_sym_BSLASHdef] = ACTIONS(6214),
    [anon_sym_BSLASHlet] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6214),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6214),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6214),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6214),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6214),
    [anon_sym_BSLASHgls] = ACTIONS(6214),
    [anon_sym_BSLASHGls] = ACTIONS(6214),
    [anon_sym_BSLASHGLS] = ACTIONS(6214),
    [anon_sym_BSLASHglspl] = ACTIONS(6214),
    [anon_sym_BSLASHGlspl] = ACTIONS(6214),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6214),
    [anon_sym_BSLASHglslink] = ACTIONS(6214),
    [anon_sym_BSLASHglstext] = ACTIONS(6214),
    [anon_sym_BSLASHGlstext] = ACTIONS(6214),
    [anon_sym_BSLASHGLStext] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6214),
    [anon_sym_BSLASHglsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6214),
    [anon_sym_BSLASHglsname] = ACTIONS(6214),
    [anon_sym_BSLASHGlsname] = ACTIONS(6214),
    [anon_sym_BSLASHGLSname] = ACTIONS(6214),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6214),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6214),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6214),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6214),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6214),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6214),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6214),
    [anon_sym_BSLASHacrshort] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6214),
    [anon_sym_BSLASHACRshort] = ACTIONS(6214),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrlong] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6214),
    [anon_sym_BSLASHACRlong] = ACTIONS(6214),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6214),
    [anon_sym_BSLASHacrfull] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6214),
    [anon_sym_BSLASHACRfull] = ACTIONS(6214),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHacs] = ACTIONS(6214),
    [anon_sym_BSLASHAcs] = ACTIONS(6214),
    [anon_sym_BSLASHacsp] = ACTIONS(6214),
    [anon_sym_BSLASHAcsp] = ACTIONS(6214),
    [anon_sym_BSLASHacl] = ACTIONS(6214),
    [anon_sym_BSLASHAcl] = ACTIONS(6214),
    [anon_sym_BSLASHaclp] = ACTIONS(6214),
    [anon_sym_BSLASHAclp] = ACTIONS(6214),
    [anon_sym_BSLASHacf] = ACTIONS(6214),
    [anon_sym_BSLASHAcf] = ACTIONS(6214),
    [anon_sym_BSLASHacfp] = ACTIONS(6214),
    [anon_sym_BSLASHAcfp] = ACTIONS(6214),
    [anon_sym_BSLASHac] = ACTIONS(6214),
    [anon_sym_BSLASHAc] = ACTIONS(6214),
    [anon_sym_BSLASHacp] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6214),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6214),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6214),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6214),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6216),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6214),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6214),
    [anon_sym_BSLASHcolor] = ACTIONS(6214),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6214),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6214),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6214),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6214),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6214),
    [anon_sym_BSLASHurl] = ACTIONS(6214),
    [anon_sym_BSLASHhref] = ACTIONS(6214),
  },
  [1996] = {
    [sym_command_name] = ACTIONS(6222),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6222),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_COMMA] = ACTIONS(6224),
    [anon_sym_EQ] = ACTIONS(6224),
    [anon_sym_RBRACE] = ACTIONS(6224),
    [sym_word] = ACTIONS(6222),
    [sym_placeholder] = ACTIONS(6224),
    [anon_sym_PLUS] = ACTIONS(6224),
    [anon_sym_DASH] = ACTIONS(6224),
    [anon_sym_STAR] = ACTIONS(6224),
    [anon_sym_SLASH] = ACTIONS(6224),
    [anon_sym_LT] = ACTIONS(6222),
    [anon_sym_GT] = ACTIONS(6222),
    [anon_sym_BANG] = ACTIONS(6222),
    [anon_sym_PIPE] = ACTIONS(6222),
    [anon_sym_COLON] = ACTIONS(6222),
    [anon_sym_SQUOTE] = ACTIONS(6222),
    [anon_sym__] = ACTIONS(6224),
    [anon_sym_CARET] = ACTIONS(6224),
    [anon_sym_BSLASHtitle] = ACTIONS(6222),
    [anon_sym_BSLASHauthor] = ACTIONS(6222),
    [anon_sym_BSLASHusepackage] = ACTIONS(6222),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6222),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6222),
    [anon_sym_BSLASHinclude] = ACTIONS(6222),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6222),
    [anon_sym_BSLASHinput] = ACTIONS(6222),
    [anon_sym_BSLASHsubfile] = ACTIONS(6222),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6222),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6222),
    [anon_sym_BSLASHbibliography] = ACTIONS(6222),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6222),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6222),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6222),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6222),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6222),
    [anon_sym_BSLASHimport] = ACTIONS(6222),
    [anon_sym_BSLASHsubimport] = ACTIONS(6222),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6222),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6222),
    [anon_sym_BSLASHcaption] = ACTIONS(6222),
    [anon_sym_BSLASHcite] = ACTIONS(6222),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCite] = ACTIONS(6222),
    [anon_sym_BSLASHnocite] = ACTIONS(6222),
    [anon_sym_BSLASHcitet] = ACTIONS(6222),
    [anon_sym_BSLASHcitep] = ACTIONS(6222),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteA] = ACTIONS(6222),
    [anon_sym_BSLASHciteR] = ACTIONS(6222),
    [anon_sym_BSLASHciteS] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6222),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6222),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteyear] = ACTIONS(6222),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHcitedate] = ACTIONS(6222),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHciteurl] = ACTIONS(6222),
    [anon_sym_BSLASHfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6222),
    [anon_sym_BSLASHcitealt] = ACTIONS(6222),
    [anon_sym_BSLASHcitealp] = ACTIONS(6222),
    [anon_sym_BSLASHcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHparencite] = ACTIONS(6222),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHParencite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6222),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6222),
    [anon_sym_BSLASHtextcite] = ACTIONS(6222),
    [anon_sym_BSLASHTextcite] = ACTIONS(6222),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6222),
    [anon_sym_BSLASHsupercite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite] = ACTIONS(6222),
    [anon_sym_BSLASHAutocite] = ACTIONS(6222),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHVolcite] = ACTIONS(6222),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHavolcite] = ACTIONS(6222),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6222),
    [anon_sym_BSLASHnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHNotecite] = ACTIONS(6222),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6222),
    [anon_sym_BSLASHlabel] = ACTIONS(6222),
    [anon_sym_BSLASHref] = ACTIONS(6222),
    [anon_sym_BSLASHeqref] = ACTIONS(6222),
    [anon_sym_BSLASHvref] = ACTIONS(6222),
    [anon_sym_BSLASHVref] = ACTIONS(6222),
    [anon_sym_BSLASHautoref] = ACTIONS(6222),
    [anon_sym_BSLASHpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcref] = ACTIONS(6222),
    [anon_sym_BSLASHCref] = ACTIONS(6222),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnameCref] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6222),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6222),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6222),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6222),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6222),
    [anon_sym_BSLASHdef] = ACTIONS(6222),
    [anon_sym_BSLASHlet] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6222),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6222),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6222),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6222),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6222),
    [anon_sym_BSLASHgls] = ACTIONS(6222),
    [anon_sym_BSLASHGls] = ACTIONS(6222),
    [anon_sym_BSLASHGLS] = ACTIONS(6222),
    [anon_sym_BSLASHglspl] = ACTIONS(6222),
    [anon_sym_BSLASHGlspl] = ACTIONS(6222),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6222),
    [anon_sym_BSLASHglslink] = ACTIONS(6222),
    [anon_sym_BSLASHglstext] = ACTIONS(6222),
    [anon_sym_BSLASHGlstext] = ACTIONS(6222),
    [anon_sym_BSLASHGLStext] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6222),
    [anon_sym_BSLASHglsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6222),
    [anon_sym_BSLASHglsname] = ACTIONS(6222),
    [anon_sym_BSLASHGlsname] = ACTIONS(6222),
    [anon_sym_BSLASHGLSname] = ACTIONS(6222),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6222),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6222),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6222),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6222),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6222),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6222),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6222),
    [anon_sym_BSLASHacrshort] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6222),
    [anon_sym_BSLASHACRshort] = ACTIONS(6222),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrlong] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6222),
    [anon_sym_BSLASHACRlong] = ACTIONS(6222),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6222),
    [anon_sym_BSLASHacrfull] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6222),
    [anon_sym_BSLASHACRfull] = ACTIONS(6222),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHacs] = ACTIONS(6222),
    [anon_sym_BSLASHAcs] = ACTIONS(6222),
    [anon_sym_BSLASHacsp] = ACTIONS(6222),
    [anon_sym_BSLASHAcsp] = ACTIONS(6222),
    [anon_sym_BSLASHacl] = ACTIONS(6222),
    [anon_sym_BSLASHAcl] = ACTIONS(6222),
    [anon_sym_BSLASHaclp] = ACTIONS(6222),
    [anon_sym_BSLASHAclp] = ACTIONS(6222),
    [anon_sym_BSLASHacf] = ACTIONS(6222),
    [anon_sym_BSLASHAcf] = ACTIONS(6222),
    [anon_sym_BSLASHacfp] = ACTIONS(6222),
    [anon_sym_BSLASHAcfp] = ACTIONS(6222),
    [anon_sym_BSLASHac] = ACTIONS(6222),
    [anon_sym_BSLASHAc] = ACTIONS(6222),
    [anon_sym_BSLASHacp] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6222),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6222),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6222),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6222),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6224),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6222),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6222),
    [anon_sym_BSLASHcolor] = ACTIONS(6222),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6222),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6222),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6222),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6222),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6222),
    [anon_sym_BSLASHurl] = ACTIONS(6222),
    [anon_sym_BSLASHhref] = ACTIONS(6222),
  },
  [1997] = {
    [sym_command_name] = ACTIONS(6426),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6426),
    [anon_sym_RBRACK] = ACTIONS(6428),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_EQ] = ACTIONS(6428),
    [anon_sym_RBRACE] = ACTIONS(6428),
    [sym_word] = ACTIONS(6426),
    [sym_placeholder] = ACTIONS(6428),
    [anon_sym_PLUS] = ACTIONS(6428),
    [anon_sym_DASH] = ACTIONS(6428),
    [anon_sym_STAR] = ACTIONS(6428),
    [anon_sym_SLASH] = ACTIONS(6428),
    [anon_sym_LT] = ACTIONS(6426),
    [anon_sym_GT] = ACTIONS(6426),
    [anon_sym_BANG] = ACTIONS(6426),
    [anon_sym_PIPE] = ACTIONS(6426),
    [anon_sym_COLON] = ACTIONS(6426),
    [anon_sym_SQUOTE] = ACTIONS(6426),
    [anon_sym__] = ACTIONS(6428),
    [anon_sym_CARET] = ACTIONS(6428),
    [anon_sym_BSLASHtitle] = ACTIONS(6426),
    [anon_sym_BSLASHauthor] = ACTIONS(6426),
    [anon_sym_BSLASHusepackage] = ACTIONS(6426),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6426),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6426),
    [anon_sym_BSLASHinclude] = ACTIONS(6426),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6426),
    [anon_sym_BSLASHinput] = ACTIONS(6426),
    [anon_sym_BSLASHsubfile] = ACTIONS(6426),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6426),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6426),
    [anon_sym_BSLASHbibliography] = ACTIONS(6426),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6426),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6426),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6426),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6426),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6426),
    [anon_sym_BSLASHimport] = ACTIONS(6426),
    [anon_sym_BSLASHsubimport] = ACTIONS(6426),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6426),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6426),
    [anon_sym_BSLASHcaption] = ACTIONS(6426),
    [anon_sym_BSLASHcite] = ACTIONS(6426),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCite] = ACTIONS(6426),
    [anon_sym_BSLASHnocite] = ACTIONS(6426),
    [anon_sym_BSLASHcitet] = ACTIONS(6426),
    [anon_sym_BSLASHcitep] = ACTIONS(6426),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteA] = ACTIONS(6426),
    [anon_sym_BSLASHciteR] = ACTIONS(6426),
    [anon_sym_BSLASHciteS] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6426),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6426),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteyear] = ACTIONS(6426),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHcitedate] = ACTIONS(6426),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHciteurl] = ACTIONS(6426),
    [anon_sym_BSLASHfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6426),
    [anon_sym_BSLASHcitealt] = ACTIONS(6426),
    [anon_sym_BSLASHcitealp] = ACTIONS(6426),
    [anon_sym_BSLASHcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHparencite] = ACTIONS(6426),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHParencite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6426),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6426),
    [anon_sym_BSLASHtextcite] = ACTIONS(6426),
    [anon_sym_BSLASHTextcite] = ACTIONS(6426),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6426),
    [anon_sym_BSLASHsupercite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite] = ACTIONS(6426),
    [anon_sym_BSLASHAutocite] = ACTIONS(6426),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHVolcite] = ACTIONS(6426),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHavolcite] = ACTIONS(6426),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6426),
    [anon_sym_BSLASHnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHNotecite] = ACTIONS(6426),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6426),
    [anon_sym_BSLASHlabel] = ACTIONS(6426),
    [anon_sym_BSLASHref] = ACTIONS(6426),
    [anon_sym_BSLASHeqref] = ACTIONS(6426),
    [anon_sym_BSLASHvref] = ACTIONS(6426),
    [anon_sym_BSLASHVref] = ACTIONS(6426),
    [anon_sym_BSLASHautoref] = ACTIONS(6426),
    [anon_sym_BSLASHpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcref] = ACTIONS(6426),
    [anon_sym_BSLASHCref] = ACTIONS(6426),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnameCref] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6426),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6426),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6426),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6426),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6426),
    [anon_sym_BSLASHdef] = ACTIONS(6426),
    [anon_sym_BSLASHlet] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6426),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6426),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6426),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6426),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6426),
    [anon_sym_BSLASHgls] = ACTIONS(6426),
    [anon_sym_BSLASHGls] = ACTIONS(6426),
    [anon_sym_BSLASHGLS] = ACTIONS(6426),
    [anon_sym_BSLASHglspl] = ACTIONS(6426),
    [anon_sym_BSLASHGlspl] = ACTIONS(6426),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6426),
    [anon_sym_BSLASHglslink] = ACTIONS(6426),
    [anon_sym_BSLASHglstext] = ACTIONS(6426),
    [anon_sym_BSLASHGlstext] = ACTIONS(6426),
    [anon_sym_BSLASHGLStext] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6426),
    [anon_sym_BSLASHglsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6426),
    [anon_sym_BSLASHglsname] = ACTIONS(6426),
    [anon_sym_BSLASHGlsname] = ACTIONS(6426),
    [anon_sym_BSLASHGLSname] = ACTIONS(6426),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6426),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6426),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6426),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6426),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6426),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6426),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6426),
    [anon_sym_BSLASHacrshort] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6426),
    [anon_sym_BSLASHACRshort] = ACTIONS(6426),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrlong] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6426),
    [anon_sym_BSLASHACRlong] = ACTIONS(6426),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6426),
    [anon_sym_BSLASHacrfull] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6426),
    [anon_sym_BSLASHACRfull] = ACTIONS(6426),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHacs] = ACTIONS(6426),
    [anon_sym_BSLASHAcs] = ACTIONS(6426),
    [anon_sym_BSLASHacsp] = ACTIONS(6426),
    [anon_sym_BSLASHAcsp] = ACTIONS(6426),
    [anon_sym_BSLASHacl] = ACTIONS(6426),
    [anon_sym_BSLASHAcl] = ACTIONS(6426),
    [anon_sym_BSLASHaclp] = ACTIONS(6426),
    [anon_sym_BSLASHAclp] = ACTIONS(6426),
    [anon_sym_BSLASHacf] = ACTIONS(6426),
    [anon_sym_BSLASHAcf] = ACTIONS(6426),
    [anon_sym_BSLASHacfp] = ACTIONS(6426),
    [anon_sym_BSLASHAcfp] = ACTIONS(6426),
    [anon_sym_BSLASHac] = ACTIONS(6426),
    [anon_sym_BSLASHAc] = ACTIONS(6426),
    [anon_sym_BSLASHacp] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6426),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6426),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6426),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6426),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6428),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6426),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6426),
    [anon_sym_BSLASHcolor] = ACTIONS(6426),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6426),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6426),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6426),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6426),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6426),
    [anon_sym_BSLASHurl] = ACTIONS(6426),
    [anon_sym_BSLASHhref] = ACTIONS(6426),
  },
  [1998] = {
    [sym_command_name] = ACTIONS(6282),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6282),
    [anon_sym_RBRACK] = ACTIONS(6284),
    [anon_sym_COMMA] = ACTIONS(6284),
    [anon_sym_EQ] = ACTIONS(6284),
    [anon_sym_RBRACE] = ACTIONS(6284),
    [sym_word] = ACTIONS(6282),
    [sym_placeholder] = ACTIONS(6284),
    [anon_sym_PLUS] = ACTIONS(6284),
    [anon_sym_DASH] = ACTIONS(6284),
    [anon_sym_STAR] = ACTIONS(6284),
    [anon_sym_SLASH] = ACTIONS(6284),
    [anon_sym_LT] = ACTIONS(6282),
    [anon_sym_GT] = ACTIONS(6282),
    [anon_sym_BANG] = ACTIONS(6282),
    [anon_sym_PIPE] = ACTIONS(6282),
    [anon_sym_COLON] = ACTIONS(6282),
    [anon_sym_SQUOTE] = ACTIONS(6282),
    [anon_sym__] = ACTIONS(6284),
    [anon_sym_CARET] = ACTIONS(6284),
    [anon_sym_BSLASHtitle] = ACTIONS(6282),
    [anon_sym_BSLASHauthor] = ACTIONS(6282),
    [anon_sym_BSLASHusepackage] = ACTIONS(6282),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6282),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6282),
    [anon_sym_BSLASHinclude] = ACTIONS(6282),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6282),
    [anon_sym_BSLASHinput] = ACTIONS(6282),
    [anon_sym_BSLASHsubfile] = ACTIONS(6282),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6282),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6282),
    [anon_sym_BSLASHbibliography] = ACTIONS(6282),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6282),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6282),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6282),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6282),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6282),
    [anon_sym_BSLASHimport] = ACTIONS(6282),
    [anon_sym_BSLASHsubimport] = ACTIONS(6282),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6282),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6282),
    [anon_sym_BSLASHcaption] = ACTIONS(6282),
    [anon_sym_BSLASHcite] = ACTIONS(6282),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCite] = ACTIONS(6282),
    [anon_sym_BSLASHnocite] = ACTIONS(6282),
    [anon_sym_BSLASHcitet] = ACTIONS(6282),
    [anon_sym_BSLASHcitep] = ACTIONS(6282),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteA] = ACTIONS(6282),
    [anon_sym_BSLASHciteR] = ACTIONS(6282),
    [anon_sym_BSLASHciteS] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6282),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6282),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteyear] = ACTIONS(6282),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHcitedate] = ACTIONS(6282),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHciteurl] = ACTIONS(6282),
    [anon_sym_BSLASHfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6282),
    [anon_sym_BSLASHcitealt] = ACTIONS(6282),
    [anon_sym_BSLASHcitealp] = ACTIONS(6282),
    [anon_sym_BSLASHcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHparencite] = ACTIONS(6282),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHParencite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6282),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6282),
    [anon_sym_BSLASHtextcite] = ACTIONS(6282),
    [anon_sym_BSLASHTextcite] = ACTIONS(6282),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6282),
    [anon_sym_BSLASHsupercite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite] = ACTIONS(6282),
    [anon_sym_BSLASHAutocite] = ACTIONS(6282),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHVolcite] = ACTIONS(6282),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHavolcite] = ACTIONS(6282),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6282),
    [anon_sym_BSLASHnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHNotecite] = ACTIONS(6282),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6282),
    [anon_sym_BSLASHlabel] = ACTIONS(6282),
    [anon_sym_BSLASHref] = ACTIONS(6282),
    [anon_sym_BSLASHeqref] = ACTIONS(6282),
    [anon_sym_BSLASHvref] = ACTIONS(6282),
    [anon_sym_BSLASHVref] = ACTIONS(6282),
    [anon_sym_BSLASHautoref] = ACTIONS(6282),
    [anon_sym_BSLASHpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcref] = ACTIONS(6282),
    [anon_sym_BSLASHCref] = ACTIONS(6282),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnameCref] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6282),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6282),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6282),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6282),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6282),
    [anon_sym_BSLASHdef] = ACTIONS(6282),
    [anon_sym_BSLASHlet] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6282),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6282),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6282),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6282),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6282),
    [anon_sym_BSLASHgls] = ACTIONS(6282),
    [anon_sym_BSLASHGls] = ACTIONS(6282),
    [anon_sym_BSLASHGLS] = ACTIONS(6282),
    [anon_sym_BSLASHglspl] = ACTIONS(6282),
    [anon_sym_BSLASHGlspl] = ACTIONS(6282),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6282),
    [anon_sym_BSLASHglslink] = ACTIONS(6282),
    [anon_sym_BSLASHglstext] = ACTIONS(6282),
    [anon_sym_BSLASHGlstext] = ACTIONS(6282),
    [anon_sym_BSLASHGLStext] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6282),
    [anon_sym_BSLASHglsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6282),
    [anon_sym_BSLASHglsname] = ACTIONS(6282),
    [anon_sym_BSLASHGlsname] = ACTIONS(6282),
    [anon_sym_BSLASHGLSname] = ACTIONS(6282),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6282),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6282),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6282),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6282),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6282),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6282),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6282),
    [anon_sym_BSLASHacrshort] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6282),
    [anon_sym_BSLASHACRshort] = ACTIONS(6282),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrlong] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6282),
    [anon_sym_BSLASHACRlong] = ACTIONS(6282),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6282),
    [anon_sym_BSLASHacrfull] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6282),
    [anon_sym_BSLASHACRfull] = ACTIONS(6282),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHacs] = ACTIONS(6282),
    [anon_sym_BSLASHAcs] = ACTIONS(6282),
    [anon_sym_BSLASHacsp] = ACTIONS(6282),
    [anon_sym_BSLASHAcsp] = ACTIONS(6282),
    [anon_sym_BSLASHacl] = ACTIONS(6282),
    [anon_sym_BSLASHAcl] = ACTIONS(6282),
    [anon_sym_BSLASHaclp] = ACTIONS(6282),
    [anon_sym_BSLASHAclp] = ACTIONS(6282),
    [anon_sym_BSLASHacf] = ACTIONS(6282),
    [anon_sym_BSLASHAcf] = ACTIONS(6282),
    [anon_sym_BSLASHacfp] = ACTIONS(6282),
    [anon_sym_BSLASHAcfp] = ACTIONS(6282),
    [anon_sym_BSLASHac] = ACTIONS(6282),
    [anon_sym_BSLASHAc] = ACTIONS(6282),
    [anon_sym_BSLASHacp] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6282),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6282),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6282),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6282),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6284),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6282),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6282),
    [anon_sym_BSLASHcolor] = ACTIONS(6282),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6282),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6282),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6282),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6282),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6282),
    [anon_sym_BSLASHurl] = ACTIONS(6282),
    [anon_sym_BSLASHhref] = ACTIONS(6282),
  },
  [1999] = {
    [sym_command_name] = ACTIONS(6422),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6422),
    [anon_sym_RBRACK] = ACTIONS(6424),
    [anon_sym_COMMA] = ACTIONS(6424),
    [anon_sym_EQ] = ACTIONS(6424),
    [anon_sym_RBRACE] = ACTIONS(6424),
    [sym_word] = ACTIONS(6422),
    [sym_placeholder] = ACTIONS(6424),
    [anon_sym_PLUS] = ACTIONS(6424),
    [anon_sym_DASH] = ACTIONS(6424),
    [anon_sym_STAR] = ACTIONS(6424),
    [anon_sym_SLASH] = ACTIONS(6424),
    [anon_sym_LT] = ACTIONS(6422),
    [anon_sym_GT] = ACTIONS(6422),
    [anon_sym_BANG] = ACTIONS(6422),
    [anon_sym_PIPE] = ACTIONS(6422),
    [anon_sym_COLON] = ACTIONS(6422),
    [anon_sym_SQUOTE] = ACTIONS(6422),
    [anon_sym__] = ACTIONS(6424),
    [anon_sym_CARET] = ACTIONS(6424),
    [anon_sym_BSLASHtitle] = ACTIONS(6422),
    [anon_sym_BSLASHauthor] = ACTIONS(6422),
    [anon_sym_BSLASHusepackage] = ACTIONS(6422),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6422),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6422),
    [anon_sym_BSLASHinclude] = ACTIONS(6422),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6422),
    [anon_sym_BSLASHinput] = ACTIONS(6422),
    [anon_sym_BSLASHsubfile] = ACTIONS(6422),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6422),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6422),
    [anon_sym_BSLASHbibliography] = ACTIONS(6422),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6422),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6422),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6422),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6422),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6422),
    [anon_sym_BSLASHimport] = ACTIONS(6422),
    [anon_sym_BSLASHsubimport] = ACTIONS(6422),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6422),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6422),
    [anon_sym_BSLASHcaption] = ACTIONS(6422),
    [anon_sym_BSLASHcite] = ACTIONS(6422),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCite] = ACTIONS(6422),
    [anon_sym_BSLASHnocite] = ACTIONS(6422),
    [anon_sym_BSLASHcitet] = ACTIONS(6422),
    [anon_sym_BSLASHcitep] = ACTIONS(6422),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteA] = ACTIONS(6422),
    [anon_sym_BSLASHciteR] = ACTIONS(6422),
    [anon_sym_BSLASHciteS] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6422),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6422),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteyear] = ACTIONS(6422),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHcitedate] = ACTIONS(6422),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHciteurl] = ACTIONS(6422),
    [anon_sym_BSLASHfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6422),
    [anon_sym_BSLASHcitealt] = ACTIONS(6422),
    [anon_sym_BSLASHcitealp] = ACTIONS(6422),
    [anon_sym_BSLASHcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHparencite] = ACTIONS(6422),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHParencite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6422),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6422),
    [anon_sym_BSLASHtextcite] = ACTIONS(6422),
    [anon_sym_BSLASHTextcite] = ACTIONS(6422),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6422),
    [anon_sym_BSLASHsupercite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite] = ACTIONS(6422),
    [anon_sym_BSLASHAutocite] = ACTIONS(6422),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHVolcite] = ACTIONS(6422),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHavolcite] = ACTIONS(6422),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6422),
    [anon_sym_BSLASHnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHNotecite] = ACTIONS(6422),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6422),
    [anon_sym_BSLASHlabel] = ACTIONS(6422),
    [anon_sym_BSLASHref] = ACTIONS(6422),
    [anon_sym_BSLASHeqref] = ACTIONS(6422),
    [anon_sym_BSLASHvref] = ACTIONS(6422),
    [anon_sym_BSLASHVref] = ACTIONS(6422),
    [anon_sym_BSLASHautoref] = ACTIONS(6422),
    [anon_sym_BSLASHpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcref] = ACTIONS(6422),
    [anon_sym_BSLASHCref] = ACTIONS(6422),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnameCref] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6422),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6422),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6422),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6422),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6422),
    [anon_sym_BSLASHdef] = ACTIONS(6422),
    [anon_sym_BSLASHlet] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6422),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6422),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6422),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6422),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6422),
    [anon_sym_BSLASHgls] = ACTIONS(6422),
    [anon_sym_BSLASHGls] = ACTIONS(6422),
    [anon_sym_BSLASHGLS] = ACTIONS(6422),
    [anon_sym_BSLASHglspl] = ACTIONS(6422),
    [anon_sym_BSLASHGlspl] = ACTIONS(6422),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6422),
    [anon_sym_BSLASHglslink] = ACTIONS(6422),
    [anon_sym_BSLASHglstext] = ACTIONS(6422),
    [anon_sym_BSLASHGlstext] = ACTIONS(6422),
    [anon_sym_BSLASHGLStext] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6422),
    [anon_sym_BSLASHglsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6422),
    [anon_sym_BSLASHglsname] = ACTIONS(6422),
    [anon_sym_BSLASHGlsname] = ACTIONS(6422),
    [anon_sym_BSLASHGLSname] = ACTIONS(6422),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6422),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6422),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6422),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6422),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6422),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6422),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6422),
    [anon_sym_BSLASHacrshort] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6422),
    [anon_sym_BSLASHACRshort] = ACTIONS(6422),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrlong] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6422),
    [anon_sym_BSLASHACRlong] = ACTIONS(6422),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6422),
    [anon_sym_BSLASHacrfull] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6422),
    [anon_sym_BSLASHACRfull] = ACTIONS(6422),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHacs] = ACTIONS(6422),
    [anon_sym_BSLASHAcs] = ACTIONS(6422),
    [anon_sym_BSLASHacsp] = ACTIONS(6422),
    [anon_sym_BSLASHAcsp] = ACTIONS(6422),
    [anon_sym_BSLASHacl] = ACTIONS(6422),
    [anon_sym_BSLASHAcl] = ACTIONS(6422),
    [anon_sym_BSLASHaclp] = ACTIONS(6422),
    [anon_sym_BSLASHAclp] = ACTIONS(6422),
    [anon_sym_BSLASHacf] = ACTIONS(6422),
    [anon_sym_BSLASHAcf] = ACTIONS(6422),
    [anon_sym_BSLASHacfp] = ACTIONS(6422),
    [anon_sym_BSLASHAcfp] = ACTIONS(6422),
    [anon_sym_BSLASHac] = ACTIONS(6422),
    [anon_sym_BSLASHAc] = ACTIONS(6422),
    [anon_sym_BSLASHacp] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6422),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6422),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6422),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6422),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6424),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6422),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6422),
    [anon_sym_BSLASHcolor] = ACTIONS(6422),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6422),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6422),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6422),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6422),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6422),
    [anon_sym_BSLASHurl] = ACTIONS(6422),
    [anon_sym_BSLASHhref] = ACTIONS(6422),
  },
  [2000] = {
    [sym_command_name] = ACTIONS(6418),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6418),
    [anon_sym_RBRACK] = ACTIONS(6420),
    [anon_sym_COMMA] = ACTIONS(6420),
    [anon_sym_EQ] = ACTIONS(6420),
    [anon_sym_RBRACE] = ACTIONS(6420),
    [sym_word] = ACTIONS(6418),
    [sym_placeholder] = ACTIONS(6420),
    [anon_sym_PLUS] = ACTIONS(6420),
    [anon_sym_DASH] = ACTIONS(6420),
    [anon_sym_STAR] = ACTIONS(6420),
    [anon_sym_SLASH] = ACTIONS(6420),
    [anon_sym_LT] = ACTIONS(6418),
    [anon_sym_GT] = ACTIONS(6418),
    [anon_sym_BANG] = ACTIONS(6418),
    [anon_sym_PIPE] = ACTIONS(6418),
    [anon_sym_COLON] = ACTIONS(6418),
    [anon_sym_SQUOTE] = ACTIONS(6418),
    [anon_sym__] = ACTIONS(6420),
    [anon_sym_CARET] = ACTIONS(6420),
    [anon_sym_BSLASHtitle] = ACTIONS(6418),
    [anon_sym_BSLASHauthor] = ACTIONS(6418),
    [anon_sym_BSLASHusepackage] = ACTIONS(6418),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6418),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6418),
    [anon_sym_BSLASHinclude] = ACTIONS(6418),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6418),
    [anon_sym_BSLASHinput] = ACTIONS(6418),
    [anon_sym_BSLASHsubfile] = ACTIONS(6418),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6418),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6418),
    [anon_sym_BSLASHbibliography] = ACTIONS(6418),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6418),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6418),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6418),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6418),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6418),
    [anon_sym_BSLASHimport] = ACTIONS(6418),
    [anon_sym_BSLASHsubimport] = ACTIONS(6418),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6418),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6418),
    [anon_sym_BSLASHcaption] = ACTIONS(6418),
    [anon_sym_BSLASHcite] = ACTIONS(6418),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCite] = ACTIONS(6418),
    [anon_sym_BSLASHnocite] = ACTIONS(6418),
    [anon_sym_BSLASHcitet] = ACTIONS(6418),
    [anon_sym_BSLASHcitep] = ACTIONS(6418),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteA] = ACTIONS(6418),
    [anon_sym_BSLASHciteR] = ACTIONS(6418),
    [anon_sym_BSLASHciteS] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6418),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6418),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteyear] = ACTIONS(6418),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHcitedate] = ACTIONS(6418),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHciteurl] = ACTIONS(6418),
    [anon_sym_BSLASHfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6418),
    [anon_sym_BSLASHcitealt] = ACTIONS(6418),
    [anon_sym_BSLASHcitealp] = ACTIONS(6418),
    [anon_sym_BSLASHcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHparencite] = ACTIONS(6418),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHParencite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6418),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6418),
    [anon_sym_BSLASHtextcite] = ACTIONS(6418),
    [anon_sym_BSLASHTextcite] = ACTIONS(6418),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6418),
    [anon_sym_BSLASHsupercite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite] = ACTIONS(6418),
    [anon_sym_BSLASHAutocite] = ACTIONS(6418),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHVolcite] = ACTIONS(6418),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHavolcite] = ACTIONS(6418),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6418),
    [anon_sym_BSLASHnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHNotecite] = ACTIONS(6418),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6418),
    [anon_sym_BSLASHlabel] = ACTIONS(6418),
    [anon_sym_BSLASHref] = ACTIONS(6418),
    [anon_sym_BSLASHeqref] = ACTIONS(6418),
    [anon_sym_BSLASHvref] = ACTIONS(6418),
    [anon_sym_BSLASHVref] = ACTIONS(6418),
    [anon_sym_BSLASHautoref] = ACTIONS(6418),
    [anon_sym_BSLASHpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcref] = ACTIONS(6418),
    [anon_sym_BSLASHCref] = ACTIONS(6418),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnameCref] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6418),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6418),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6418),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6418),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6418),
    [anon_sym_BSLASHdef] = ACTIONS(6418),
    [anon_sym_BSLASHlet] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6418),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6418),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6418),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6418),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6418),
    [anon_sym_BSLASHgls] = ACTIONS(6418),
    [anon_sym_BSLASHGls] = ACTIONS(6418),
    [anon_sym_BSLASHGLS] = ACTIONS(6418),
    [anon_sym_BSLASHglspl] = ACTIONS(6418),
    [anon_sym_BSLASHGlspl] = ACTIONS(6418),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6418),
    [anon_sym_BSLASHglslink] = ACTIONS(6418),
    [anon_sym_BSLASHglstext] = ACTIONS(6418),
    [anon_sym_BSLASHGlstext] = ACTIONS(6418),
    [anon_sym_BSLASHGLStext] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6418),
    [anon_sym_BSLASHglsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6418),
    [anon_sym_BSLASHglsname] = ACTIONS(6418),
    [anon_sym_BSLASHGlsname] = ACTIONS(6418),
    [anon_sym_BSLASHGLSname] = ACTIONS(6418),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6418),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6418),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6418),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6418),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6418),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6418),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6418),
    [anon_sym_BSLASHacrshort] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6418),
    [anon_sym_BSLASHACRshort] = ACTIONS(6418),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrlong] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6418),
    [anon_sym_BSLASHACRlong] = ACTIONS(6418),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6418),
    [anon_sym_BSLASHacrfull] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6418),
    [anon_sym_BSLASHACRfull] = ACTIONS(6418),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHacs] = ACTIONS(6418),
    [anon_sym_BSLASHAcs] = ACTIONS(6418),
    [anon_sym_BSLASHacsp] = ACTIONS(6418),
    [anon_sym_BSLASHAcsp] = ACTIONS(6418),
    [anon_sym_BSLASHacl] = ACTIONS(6418),
    [anon_sym_BSLASHAcl] = ACTIONS(6418),
    [anon_sym_BSLASHaclp] = ACTIONS(6418),
    [anon_sym_BSLASHAclp] = ACTIONS(6418),
    [anon_sym_BSLASHacf] = ACTIONS(6418),
    [anon_sym_BSLASHAcf] = ACTIONS(6418),
    [anon_sym_BSLASHacfp] = ACTIONS(6418),
    [anon_sym_BSLASHAcfp] = ACTIONS(6418),
    [anon_sym_BSLASHac] = ACTIONS(6418),
    [anon_sym_BSLASHAc] = ACTIONS(6418),
    [anon_sym_BSLASHacp] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6418),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6418),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6418),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6418),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6420),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6418),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6418),
    [anon_sym_BSLASHcolor] = ACTIONS(6418),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6418),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6418),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6418),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6418),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6418),
    [anon_sym_BSLASHurl] = ACTIONS(6418),
    [anon_sym_BSLASHhref] = ACTIONS(6418),
  },
  [2001] = {
    [sym_command_name] = ACTIONS(6414),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6414),
    [anon_sym_RBRACK] = ACTIONS(6416),
    [anon_sym_COMMA] = ACTIONS(6416),
    [anon_sym_EQ] = ACTIONS(6416),
    [anon_sym_RBRACE] = ACTIONS(6416),
    [sym_word] = ACTIONS(6414),
    [sym_placeholder] = ACTIONS(6416),
    [anon_sym_PLUS] = ACTIONS(6416),
    [anon_sym_DASH] = ACTIONS(6416),
    [anon_sym_STAR] = ACTIONS(6416),
    [anon_sym_SLASH] = ACTIONS(6416),
    [anon_sym_LT] = ACTIONS(6414),
    [anon_sym_GT] = ACTIONS(6414),
    [anon_sym_BANG] = ACTIONS(6414),
    [anon_sym_PIPE] = ACTIONS(6414),
    [anon_sym_COLON] = ACTIONS(6414),
    [anon_sym_SQUOTE] = ACTIONS(6414),
    [anon_sym__] = ACTIONS(6416),
    [anon_sym_CARET] = ACTIONS(6416),
    [anon_sym_BSLASHtitle] = ACTIONS(6414),
    [anon_sym_BSLASHauthor] = ACTIONS(6414),
    [anon_sym_BSLASHusepackage] = ACTIONS(6414),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6414),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6414),
    [anon_sym_BSLASHinclude] = ACTIONS(6414),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6414),
    [anon_sym_BSLASHinput] = ACTIONS(6414),
    [anon_sym_BSLASHsubfile] = ACTIONS(6414),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6414),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6414),
    [anon_sym_BSLASHbibliography] = ACTIONS(6414),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6414),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6414),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6414),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6414),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6414),
    [anon_sym_BSLASHimport] = ACTIONS(6414),
    [anon_sym_BSLASHsubimport] = ACTIONS(6414),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6414),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6414),
    [anon_sym_BSLASHcaption] = ACTIONS(6414),
    [anon_sym_BSLASHcite] = ACTIONS(6414),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCite] = ACTIONS(6414),
    [anon_sym_BSLASHnocite] = ACTIONS(6414),
    [anon_sym_BSLASHcitet] = ACTIONS(6414),
    [anon_sym_BSLASHcitep] = ACTIONS(6414),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteA] = ACTIONS(6414),
    [anon_sym_BSLASHciteR] = ACTIONS(6414),
    [anon_sym_BSLASHciteS] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6414),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6414),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteyear] = ACTIONS(6414),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHcitedate] = ACTIONS(6414),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHciteurl] = ACTIONS(6414),
    [anon_sym_BSLASHfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6414),
    [anon_sym_BSLASHcitealt] = ACTIONS(6414),
    [anon_sym_BSLASHcitealp] = ACTIONS(6414),
    [anon_sym_BSLASHcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHparencite] = ACTIONS(6414),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHParencite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6414),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6414),
    [anon_sym_BSLASHtextcite] = ACTIONS(6414),
    [anon_sym_BSLASHTextcite] = ACTIONS(6414),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6414),
    [anon_sym_BSLASHsupercite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite] = ACTIONS(6414),
    [anon_sym_BSLASHAutocite] = ACTIONS(6414),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHVolcite] = ACTIONS(6414),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHavolcite] = ACTIONS(6414),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6414),
    [anon_sym_BSLASHnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHNotecite] = ACTIONS(6414),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6414),
    [anon_sym_BSLASHlabel] = ACTIONS(6414),
    [anon_sym_BSLASHref] = ACTIONS(6414),
    [anon_sym_BSLASHeqref] = ACTIONS(6414),
    [anon_sym_BSLASHvref] = ACTIONS(6414),
    [anon_sym_BSLASHVref] = ACTIONS(6414),
    [anon_sym_BSLASHautoref] = ACTIONS(6414),
    [anon_sym_BSLASHpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcref] = ACTIONS(6414),
    [anon_sym_BSLASHCref] = ACTIONS(6414),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnameCref] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6414),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6414),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6414),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6414),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6414),
    [anon_sym_BSLASHdef] = ACTIONS(6414),
    [anon_sym_BSLASHlet] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6414),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6414),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6414),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6414),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6414),
    [anon_sym_BSLASHgls] = ACTIONS(6414),
    [anon_sym_BSLASHGls] = ACTIONS(6414),
    [anon_sym_BSLASHGLS] = ACTIONS(6414),
    [anon_sym_BSLASHglspl] = ACTIONS(6414),
    [anon_sym_BSLASHGlspl] = ACTIONS(6414),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6414),
    [anon_sym_BSLASHglslink] = ACTIONS(6414),
    [anon_sym_BSLASHglstext] = ACTIONS(6414),
    [anon_sym_BSLASHGlstext] = ACTIONS(6414),
    [anon_sym_BSLASHGLStext] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6414),
    [anon_sym_BSLASHglsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6414),
    [anon_sym_BSLASHglsname] = ACTIONS(6414),
    [anon_sym_BSLASHGlsname] = ACTIONS(6414),
    [anon_sym_BSLASHGLSname] = ACTIONS(6414),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6414),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6414),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6414),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6414),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6414),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6414),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6414),
    [anon_sym_BSLASHacrshort] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6414),
    [anon_sym_BSLASHACRshort] = ACTIONS(6414),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrlong] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6414),
    [anon_sym_BSLASHACRlong] = ACTIONS(6414),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6414),
    [anon_sym_BSLASHacrfull] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6414),
    [anon_sym_BSLASHACRfull] = ACTIONS(6414),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHacs] = ACTIONS(6414),
    [anon_sym_BSLASHAcs] = ACTIONS(6414),
    [anon_sym_BSLASHacsp] = ACTIONS(6414),
    [anon_sym_BSLASHAcsp] = ACTIONS(6414),
    [anon_sym_BSLASHacl] = ACTIONS(6414),
    [anon_sym_BSLASHAcl] = ACTIONS(6414),
    [anon_sym_BSLASHaclp] = ACTIONS(6414),
    [anon_sym_BSLASHAclp] = ACTIONS(6414),
    [anon_sym_BSLASHacf] = ACTIONS(6414),
    [anon_sym_BSLASHAcf] = ACTIONS(6414),
    [anon_sym_BSLASHacfp] = ACTIONS(6414),
    [anon_sym_BSLASHAcfp] = ACTIONS(6414),
    [anon_sym_BSLASHac] = ACTIONS(6414),
    [anon_sym_BSLASHAc] = ACTIONS(6414),
    [anon_sym_BSLASHacp] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6414),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6414),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6414),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6414),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6416),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6414),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6414),
    [anon_sym_BSLASHcolor] = ACTIONS(6414),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6414),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6414),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6414),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6414),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6414),
    [anon_sym_BSLASHurl] = ACTIONS(6414),
    [anon_sym_BSLASHhref] = ACTIONS(6414),
  },
  [2002] = {
    [sym_command_name] = ACTIONS(6410),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6410),
    [anon_sym_RBRACK] = ACTIONS(6412),
    [anon_sym_COMMA] = ACTIONS(6412),
    [anon_sym_EQ] = ACTIONS(6412),
    [anon_sym_RBRACE] = ACTIONS(6412),
    [sym_word] = ACTIONS(6410),
    [sym_placeholder] = ACTIONS(6412),
    [anon_sym_PLUS] = ACTIONS(6412),
    [anon_sym_DASH] = ACTIONS(6412),
    [anon_sym_STAR] = ACTIONS(6412),
    [anon_sym_SLASH] = ACTIONS(6412),
    [anon_sym_LT] = ACTIONS(6410),
    [anon_sym_GT] = ACTIONS(6410),
    [anon_sym_BANG] = ACTIONS(6410),
    [anon_sym_PIPE] = ACTIONS(6410),
    [anon_sym_COLON] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6410),
    [anon_sym__] = ACTIONS(6412),
    [anon_sym_CARET] = ACTIONS(6412),
    [anon_sym_BSLASHtitle] = ACTIONS(6410),
    [anon_sym_BSLASHauthor] = ACTIONS(6410),
    [anon_sym_BSLASHusepackage] = ACTIONS(6410),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6410),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6410),
    [anon_sym_BSLASHinclude] = ACTIONS(6410),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6410),
    [anon_sym_BSLASHinput] = ACTIONS(6410),
    [anon_sym_BSLASHsubfile] = ACTIONS(6410),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6410),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6410),
    [anon_sym_BSLASHbibliography] = ACTIONS(6410),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6410),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6410),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6410),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6410),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6410),
    [anon_sym_BSLASHimport] = ACTIONS(6410),
    [anon_sym_BSLASHsubimport] = ACTIONS(6410),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6410),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6410),
    [anon_sym_BSLASHcaption] = ACTIONS(6410),
    [anon_sym_BSLASHcite] = ACTIONS(6410),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCite] = ACTIONS(6410),
    [anon_sym_BSLASHnocite] = ACTIONS(6410),
    [anon_sym_BSLASHcitet] = ACTIONS(6410),
    [anon_sym_BSLASHcitep] = ACTIONS(6410),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteA] = ACTIONS(6410),
    [anon_sym_BSLASHciteR] = ACTIONS(6410),
    [anon_sym_BSLASHciteS] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6410),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6410),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteyear] = ACTIONS(6410),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHcitedate] = ACTIONS(6410),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHciteurl] = ACTIONS(6410),
    [anon_sym_BSLASHfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6410),
    [anon_sym_BSLASHcitealt] = ACTIONS(6410),
    [anon_sym_BSLASHcitealp] = ACTIONS(6410),
    [anon_sym_BSLASHcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHparencite] = ACTIONS(6410),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHParencite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6410),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6410),
    [anon_sym_BSLASHtextcite] = ACTIONS(6410),
    [anon_sym_BSLASHTextcite] = ACTIONS(6410),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6410),
    [anon_sym_BSLASHsupercite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite] = ACTIONS(6410),
    [anon_sym_BSLASHAutocite] = ACTIONS(6410),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHVolcite] = ACTIONS(6410),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHavolcite] = ACTIONS(6410),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6410),
    [anon_sym_BSLASHnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHNotecite] = ACTIONS(6410),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6410),
    [anon_sym_BSLASHlabel] = ACTIONS(6410),
    [anon_sym_BSLASHref] = ACTIONS(6410),
    [anon_sym_BSLASHeqref] = ACTIONS(6410),
    [anon_sym_BSLASHvref] = ACTIONS(6410),
    [anon_sym_BSLASHVref] = ACTIONS(6410),
    [anon_sym_BSLASHautoref] = ACTIONS(6410),
    [anon_sym_BSLASHpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcref] = ACTIONS(6410),
    [anon_sym_BSLASHCref] = ACTIONS(6410),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnameCref] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6410),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6410),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6410),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6410),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6410),
    [anon_sym_BSLASHdef] = ACTIONS(6410),
    [anon_sym_BSLASHlet] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6410),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6410),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6410),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6410),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6410),
    [anon_sym_BSLASHgls] = ACTIONS(6410),
    [anon_sym_BSLASHGls] = ACTIONS(6410),
    [anon_sym_BSLASHGLS] = ACTIONS(6410),
    [anon_sym_BSLASHglspl] = ACTIONS(6410),
    [anon_sym_BSLASHGlspl] = ACTIONS(6410),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6410),
    [anon_sym_BSLASHglslink] = ACTIONS(6410),
    [anon_sym_BSLASHglstext] = ACTIONS(6410),
    [anon_sym_BSLASHGlstext] = ACTIONS(6410),
    [anon_sym_BSLASHGLStext] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6410),
    [anon_sym_BSLASHglsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6410),
    [anon_sym_BSLASHglsname] = ACTIONS(6410),
    [anon_sym_BSLASHGlsname] = ACTIONS(6410),
    [anon_sym_BSLASHGLSname] = ACTIONS(6410),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6410),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6410),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6410),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6410),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6410),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6410),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6410),
    [anon_sym_BSLASHacrshort] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6410),
    [anon_sym_BSLASHACRshort] = ACTIONS(6410),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrlong] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6410),
    [anon_sym_BSLASHACRlong] = ACTIONS(6410),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6410),
    [anon_sym_BSLASHacrfull] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6410),
    [anon_sym_BSLASHACRfull] = ACTIONS(6410),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHacs] = ACTIONS(6410),
    [anon_sym_BSLASHAcs] = ACTIONS(6410),
    [anon_sym_BSLASHacsp] = ACTIONS(6410),
    [anon_sym_BSLASHAcsp] = ACTIONS(6410),
    [anon_sym_BSLASHacl] = ACTIONS(6410),
    [anon_sym_BSLASHAcl] = ACTIONS(6410),
    [anon_sym_BSLASHaclp] = ACTIONS(6410),
    [anon_sym_BSLASHAclp] = ACTIONS(6410),
    [anon_sym_BSLASHacf] = ACTIONS(6410),
    [anon_sym_BSLASHAcf] = ACTIONS(6410),
    [anon_sym_BSLASHacfp] = ACTIONS(6410),
    [anon_sym_BSLASHAcfp] = ACTIONS(6410),
    [anon_sym_BSLASHac] = ACTIONS(6410),
    [anon_sym_BSLASHAc] = ACTIONS(6410),
    [anon_sym_BSLASHacp] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6410),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6410),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6410),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6410),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6412),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6410),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6410),
    [anon_sym_BSLASHcolor] = ACTIONS(6410),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6410),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6410),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6410),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6410),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6410),
    [anon_sym_BSLASHurl] = ACTIONS(6410),
    [anon_sym_BSLASHhref] = ACTIONS(6410),
  },
  [2003] = {
    [sym_command_name] = ACTIONS(6438),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6438),
    [anon_sym_RBRACK] = ACTIONS(6440),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_EQ] = ACTIONS(6440),
    [anon_sym_RBRACE] = ACTIONS(6440),
    [sym_word] = ACTIONS(6438),
    [sym_placeholder] = ACTIONS(6440),
    [anon_sym_PLUS] = ACTIONS(6440),
    [anon_sym_DASH] = ACTIONS(6440),
    [anon_sym_STAR] = ACTIONS(6440),
    [anon_sym_SLASH] = ACTIONS(6440),
    [anon_sym_LT] = ACTIONS(6438),
    [anon_sym_GT] = ACTIONS(6438),
    [anon_sym_BANG] = ACTIONS(6438),
    [anon_sym_PIPE] = ACTIONS(6438),
    [anon_sym_COLON] = ACTIONS(6438),
    [anon_sym_SQUOTE] = ACTIONS(6438),
    [anon_sym__] = ACTIONS(6440),
    [anon_sym_CARET] = ACTIONS(6440),
    [anon_sym_BSLASHtitle] = ACTIONS(6438),
    [anon_sym_BSLASHauthor] = ACTIONS(6438),
    [anon_sym_BSLASHusepackage] = ACTIONS(6438),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6438),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6438),
    [anon_sym_BSLASHinclude] = ACTIONS(6438),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6438),
    [anon_sym_BSLASHinput] = ACTIONS(6438),
    [anon_sym_BSLASHsubfile] = ACTIONS(6438),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6438),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6438),
    [anon_sym_BSLASHbibliography] = ACTIONS(6438),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6438),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6438),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6438),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6438),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6438),
    [anon_sym_BSLASHimport] = ACTIONS(6438),
    [anon_sym_BSLASHsubimport] = ACTIONS(6438),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6438),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6438),
    [anon_sym_BSLASHcaption] = ACTIONS(6438),
    [anon_sym_BSLASHcite] = ACTIONS(6438),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCite] = ACTIONS(6438),
    [anon_sym_BSLASHnocite] = ACTIONS(6438),
    [anon_sym_BSLASHcitet] = ACTIONS(6438),
    [anon_sym_BSLASHcitep] = ACTIONS(6438),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteA] = ACTIONS(6438),
    [anon_sym_BSLASHciteR] = ACTIONS(6438),
    [anon_sym_BSLASHciteS] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6438),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6438),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteyear] = ACTIONS(6438),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHcitedate] = ACTIONS(6438),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHciteurl] = ACTIONS(6438),
    [anon_sym_BSLASHfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6438),
    [anon_sym_BSLASHcitealt] = ACTIONS(6438),
    [anon_sym_BSLASHcitealp] = ACTIONS(6438),
    [anon_sym_BSLASHcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHparencite] = ACTIONS(6438),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHParencite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6438),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6438),
    [anon_sym_BSLASHtextcite] = ACTIONS(6438),
    [anon_sym_BSLASHTextcite] = ACTIONS(6438),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6438),
    [anon_sym_BSLASHsupercite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite] = ACTIONS(6438),
    [anon_sym_BSLASHAutocite] = ACTIONS(6438),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHVolcite] = ACTIONS(6438),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHavolcite] = ACTIONS(6438),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6438),
    [anon_sym_BSLASHnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHNotecite] = ACTIONS(6438),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6438),
    [anon_sym_BSLASHlabel] = ACTIONS(6438),
    [anon_sym_BSLASHref] = ACTIONS(6438),
    [anon_sym_BSLASHeqref] = ACTIONS(6438),
    [anon_sym_BSLASHvref] = ACTIONS(6438),
    [anon_sym_BSLASHVref] = ACTIONS(6438),
    [anon_sym_BSLASHautoref] = ACTIONS(6438),
    [anon_sym_BSLASHpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcref] = ACTIONS(6438),
    [anon_sym_BSLASHCref] = ACTIONS(6438),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnameCref] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6438),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6438),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6438),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6438),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6438),
    [anon_sym_BSLASHdef] = ACTIONS(6438),
    [anon_sym_BSLASHlet] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6438),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6438),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6438),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6438),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6438),
    [anon_sym_BSLASHgls] = ACTIONS(6438),
    [anon_sym_BSLASHGls] = ACTIONS(6438),
    [anon_sym_BSLASHGLS] = ACTIONS(6438),
    [anon_sym_BSLASHglspl] = ACTIONS(6438),
    [anon_sym_BSLASHGlspl] = ACTIONS(6438),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6438),
    [anon_sym_BSLASHglslink] = ACTIONS(6438),
    [anon_sym_BSLASHglstext] = ACTIONS(6438),
    [anon_sym_BSLASHGlstext] = ACTIONS(6438),
    [anon_sym_BSLASHGLStext] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6438),
    [anon_sym_BSLASHglsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6438),
    [anon_sym_BSLASHglsname] = ACTIONS(6438),
    [anon_sym_BSLASHGlsname] = ACTIONS(6438),
    [anon_sym_BSLASHGLSname] = ACTIONS(6438),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6438),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6438),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6438),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6438),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6438),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6438),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6438),
    [anon_sym_BSLASHacrshort] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6438),
    [anon_sym_BSLASHACRshort] = ACTIONS(6438),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrlong] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6438),
    [anon_sym_BSLASHACRlong] = ACTIONS(6438),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6438),
    [anon_sym_BSLASHacrfull] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6438),
    [anon_sym_BSLASHACRfull] = ACTIONS(6438),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHacs] = ACTIONS(6438),
    [anon_sym_BSLASHAcs] = ACTIONS(6438),
    [anon_sym_BSLASHacsp] = ACTIONS(6438),
    [anon_sym_BSLASHAcsp] = ACTIONS(6438),
    [anon_sym_BSLASHacl] = ACTIONS(6438),
    [anon_sym_BSLASHAcl] = ACTIONS(6438),
    [anon_sym_BSLASHaclp] = ACTIONS(6438),
    [anon_sym_BSLASHAclp] = ACTIONS(6438),
    [anon_sym_BSLASHacf] = ACTIONS(6438),
    [anon_sym_BSLASHAcf] = ACTIONS(6438),
    [anon_sym_BSLASHacfp] = ACTIONS(6438),
    [anon_sym_BSLASHAcfp] = ACTIONS(6438),
    [anon_sym_BSLASHac] = ACTIONS(6438),
    [anon_sym_BSLASHAc] = ACTIONS(6438),
    [anon_sym_BSLASHacp] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6438),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6438),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6438),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6438),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6440),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6438),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6438),
    [anon_sym_BSLASHcolor] = ACTIONS(6438),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6438),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6438),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6438),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6438),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6438),
    [anon_sym_BSLASHurl] = ACTIONS(6438),
    [anon_sym_BSLASHhref] = ACTIONS(6438),
  },
  [2004] = {
    [sym_command_name] = ACTIONS(6406),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6406),
    [anon_sym_RBRACK] = ACTIONS(6408),
    [anon_sym_COMMA] = ACTIONS(6408),
    [anon_sym_EQ] = ACTIONS(6408),
    [anon_sym_RBRACE] = ACTIONS(6408),
    [sym_word] = ACTIONS(6406),
    [sym_placeholder] = ACTIONS(6408),
    [anon_sym_PLUS] = ACTIONS(6408),
    [anon_sym_DASH] = ACTIONS(6408),
    [anon_sym_STAR] = ACTIONS(6408),
    [anon_sym_SLASH] = ACTIONS(6408),
    [anon_sym_LT] = ACTIONS(6406),
    [anon_sym_GT] = ACTIONS(6406),
    [anon_sym_BANG] = ACTIONS(6406),
    [anon_sym_PIPE] = ACTIONS(6406),
    [anon_sym_COLON] = ACTIONS(6406),
    [anon_sym_SQUOTE] = ACTIONS(6406),
    [anon_sym__] = ACTIONS(6408),
    [anon_sym_CARET] = ACTIONS(6408),
    [anon_sym_BSLASHtitle] = ACTIONS(6406),
    [anon_sym_BSLASHauthor] = ACTIONS(6406),
    [anon_sym_BSLASHusepackage] = ACTIONS(6406),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6406),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6406),
    [anon_sym_BSLASHinclude] = ACTIONS(6406),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6406),
    [anon_sym_BSLASHinput] = ACTIONS(6406),
    [anon_sym_BSLASHsubfile] = ACTIONS(6406),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6406),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6406),
    [anon_sym_BSLASHbibliography] = ACTIONS(6406),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6406),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6406),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6406),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6406),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6406),
    [anon_sym_BSLASHimport] = ACTIONS(6406),
    [anon_sym_BSLASHsubimport] = ACTIONS(6406),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6406),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6406),
    [anon_sym_BSLASHcaption] = ACTIONS(6406),
    [anon_sym_BSLASHcite] = ACTIONS(6406),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCite] = ACTIONS(6406),
    [anon_sym_BSLASHnocite] = ACTIONS(6406),
    [anon_sym_BSLASHcitet] = ACTIONS(6406),
    [anon_sym_BSLASHcitep] = ACTIONS(6406),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteA] = ACTIONS(6406),
    [anon_sym_BSLASHciteR] = ACTIONS(6406),
    [anon_sym_BSLASHciteS] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6406),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6406),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteyear] = ACTIONS(6406),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHcitedate] = ACTIONS(6406),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHciteurl] = ACTIONS(6406),
    [anon_sym_BSLASHfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6406),
    [anon_sym_BSLASHcitealt] = ACTIONS(6406),
    [anon_sym_BSLASHcitealp] = ACTIONS(6406),
    [anon_sym_BSLASHcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHparencite] = ACTIONS(6406),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHParencite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6406),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6406),
    [anon_sym_BSLASHtextcite] = ACTIONS(6406),
    [anon_sym_BSLASHTextcite] = ACTIONS(6406),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6406),
    [anon_sym_BSLASHsupercite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite] = ACTIONS(6406),
    [anon_sym_BSLASHAutocite] = ACTIONS(6406),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHVolcite] = ACTIONS(6406),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHavolcite] = ACTIONS(6406),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6406),
    [anon_sym_BSLASHnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHNotecite] = ACTIONS(6406),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6406),
    [anon_sym_BSLASHlabel] = ACTIONS(6406),
    [anon_sym_BSLASHref] = ACTIONS(6406),
    [anon_sym_BSLASHeqref] = ACTIONS(6406),
    [anon_sym_BSLASHvref] = ACTIONS(6406),
    [anon_sym_BSLASHVref] = ACTIONS(6406),
    [anon_sym_BSLASHautoref] = ACTIONS(6406),
    [anon_sym_BSLASHpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcref] = ACTIONS(6406),
    [anon_sym_BSLASHCref] = ACTIONS(6406),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnameCref] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6406),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6406),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6406),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6406),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6406),
    [anon_sym_BSLASHdef] = ACTIONS(6406),
    [anon_sym_BSLASHlet] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6406),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6406),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6406),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6406),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6406),
    [anon_sym_BSLASHgls] = ACTIONS(6406),
    [anon_sym_BSLASHGls] = ACTIONS(6406),
    [anon_sym_BSLASHGLS] = ACTIONS(6406),
    [anon_sym_BSLASHglspl] = ACTIONS(6406),
    [anon_sym_BSLASHGlspl] = ACTIONS(6406),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6406),
    [anon_sym_BSLASHglslink] = ACTIONS(6406),
    [anon_sym_BSLASHglstext] = ACTIONS(6406),
    [anon_sym_BSLASHGlstext] = ACTIONS(6406),
    [anon_sym_BSLASHGLStext] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6406),
    [anon_sym_BSLASHglsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6406),
    [anon_sym_BSLASHglsname] = ACTIONS(6406),
    [anon_sym_BSLASHGlsname] = ACTIONS(6406),
    [anon_sym_BSLASHGLSname] = ACTIONS(6406),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6406),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6406),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6406),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6406),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6406),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6406),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6406),
    [anon_sym_BSLASHacrshort] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6406),
    [anon_sym_BSLASHACRshort] = ACTIONS(6406),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrlong] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6406),
    [anon_sym_BSLASHACRlong] = ACTIONS(6406),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6406),
    [anon_sym_BSLASHacrfull] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6406),
    [anon_sym_BSLASHACRfull] = ACTIONS(6406),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHacs] = ACTIONS(6406),
    [anon_sym_BSLASHAcs] = ACTIONS(6406),
    [anon_sym_BSLASHacsp] = ACTIONS(6406),
    [anon_sym_BSLASHAcsp] = ACTIONS(6406),
    [anon_sym_BSLASHacl] = ACTIONS(6406),
    [anon_sym_BSLASHAcl] = ACTIONS(6406),
    [anon_sym_BSLASHaclp] = ACTIONS(6406),
    [anon_sym_BSLASHAclp] = ACTIONS(6406),
    [anon_sym_BSLASHacf] = ACTIONS(6406),
    [anon_sym_BSLASHAcf] = ACTIONS(6406),
    [anon_sym_BSLASHacfp] = ACTIONS(6406),
    [anon_sym_BSLASHAcfp] = ACTIONS(6406),
    [anon_sym_BSLASHac] = ACTIONS(6406),
    [anon_sym_BSLASHAc] = ACTIONS(6406),
    [anon_sym_BSLASHacp] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6406),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6406),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6406),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6406),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6408),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6406),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6406),
    [anon_sym_BSLASHcolor] = ACTIONS(6406),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6406),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6406),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6406),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6406),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6406),
    [anon_sym_BSLASHurl] = ACTIONS(6406),
    [anon_sym_BSLASHhref] = ACTIONS(6406),
  },
  [2005] = {
    [sym_command_name] = ACTIONS(6402),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6402),
    [anon_sym_RBRACK] = ACTIONS(6404),
    [anon_sym_COMMA] = ACTIONS(6404),
    [anon_sym_EQ] = ACTIONS(6404),
    [anon_sym_RBRACE] = ACTIONS(6404),
    [sym_word] = ACTIONS(6402),
    [sym_placeholder] = ACTIONS(6404),
    [anon_sym_PLUS] = ACTIONS(6404),
    [anon_sym_DASH] = ACTIONS(6404),
    [anon_sym_STAR] = ACTIONS(6404),
    [anon_sym_SLASH] = ACTIONS(6404),
    [anon_sym_LT] = ACTIONS(6402),
    [anon_sym_GT] = ACTIONS(6402),
    [anon_sym_BANG] = ACTIONS(6402),
    [anon_sym_PIPE] = ACTIONS(6402),
    [anon_sym_COLON] = ACTIONS(6402),
    [anon_sym_SQUOTE] = ACTIONS(6402),
    [anon_sym__] = ACTIONS(6404),
    [anon_sym_CARET] = ACTIONS(6404),
    [anon_sym_BSLASHtitle] = ACTIONS(6402),
    [anon_sym_BSLASHauthor] = ACTIONS(6402),
    [anon_sym_BSLASHusepackage] = ACTIONS(6402),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6402),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6402),
    [anon_sym_BSLASHinclude] = ACTIONS(6402),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6402),
    [anon_sym_BSLASHinput] = ACTIONS(6402),
    [anon_sym_BSLASHsubfile] = ACTIONS(6402),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6402),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6402),
    [anon_sym_BSLASHbibliography] = ACTIONS(6402),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6402),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6402),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6402),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6402),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6402),
    [anon_sym_BSLASHimport] = ACTIONS(6402),
    [anon_sym_BSLASHsubimport] = ACTIONS(6402),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6402),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6402),
    [anon_sym_BSLASHcaption] = ACTIONS(6402),
    [anon_sym_BSLASHcite] = ACTIONS(6402),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCite] = ACTIONS(6402),
    [anon_sym_BSLASHnocite] = ACTIONS(6402),
    [anon_sym_BSLASHcitet] = ACTIONS(6402),
    [anon_sym_BSLASHcitep] = ACTIONS(6402),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteA] = ACTIONS(6402),
    [anon_sym_BSLASHciteR] = ACTIONS(6402),
    [anon_sym_BSLASHciteS] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6402),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6402),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteyear] = ACTIONS(6402),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHcitedate] = ACTIONS(6402),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHciteurl] = ACTIONS(6402),
    [anon_sym_BSLASHfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6402),
    [anon_sym_BSLASHcitealt] = ACTIONS(6402),
    [anon_sym_BSLASHcitealp] = ACTIONS(6402),
    [anon_sym_BSLASHcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHparencite] = ACTIONS(6402),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHParencite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6402),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6402),
    [anon_sym_BSLASHtextcite] = ACTIONS(6402),
    [anon_sym_BSLASHTextcite] = ACTIONS(6402),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6402),
    [anon_sym_BSLASHsupercite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite] = ACTIONS(6402),
    [anon_sym_BSLASHAutocite] = ACTIONS(6402),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHVolcite] = ACTIONS(6402),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHavolcite] = ACTIONS(6402),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6402),
    [anon_sym_BSLASHnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHNotecite] = ACTIONS(6402),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6402),
    [anon_sym_BSLASHlabel] = ACTIONS(6402),
    [anon_sym_BSLASHref] = ACTIONS(6402),
    [anon_sym_BSLASHeqref] = ACTIONS(6402),
    [anon_sym_BSLASHvref] = ACTIONS(6402),
    [anon_sym_BSLASHVref] = ACTIONS(6402),
    [anon_sym_BSLASHautoref] = ACTIONS(6402),
    [anon_sym_BSLASHpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcref] = ACTIONS(6402),
    [anon_sym_BSLASHCref] = ACTIONS(6402),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnameCref] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6402),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6402),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6402),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6402),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6402),
    [anon_sym_BSLASHdef] = ACTIONS(6402),
    [anon_sym_BSLASHlet] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6402),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6402),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6402),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6402),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6402),
    [anon_sym_BSLASHgls] = ACTIONS(6402),
    [anon_sym_BSLASHGls] = ACTIONS(6402),
    [anon_sym_BSLASHGLS] = ACTIONS(6402),
    [anon_sym_BSLASHglspl] = ACTIONS(6402),
    [anon_sym_BSLASHGlspl] = ACTIONS(6402),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6402),
    [anon_sym_BSLASHglslink] = ACTIONS(6402),
    [anon_sym_BSLASHglstext] = ACTIONS(6402),
    [anon_sym_BSLASHGlstext] = ACTIONS(6402),
    [anon_sym_BSLASHGLStext] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6402),
    [anon_sym_BSLASHglsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6402),
    [anon_sym_BSLASHglsname] = ACTIONS(6402),
    [anon_sym_BSLASHGlsname] = ACTIONS(6402),
    [anon_sym_BSLASHGLSname] = ACTIONS(6402),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6402),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6402),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6402),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6402),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6402),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6402),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6402),
    [anon_sym_BSLASHacrshort] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6402),
    [anon_sym_BSLASHACRshort] = ACTIONS(6402),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrlong] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6402),
    [anon_sym_BSLASHACRlong] = ACTIONS(6402),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6402),
    [anon_sym_BSLASHacrfull] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6402),
    [anon_sym_BSLASHACRfull] = ACTIONS(6402),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHacs] = ACTIONS(6402),
    [anon_sym_BSLASHAcs] = ACTIONS(6402),
    [anon_sym_BSLASHacsp] = ACTIONS(6402),
    [anon_sym_BSLASHAcsp] = ACTIONS(6402),
    [anon_sym_BSLASHacl] = ACTIONS(6402),
    [anon_sym_BSLASHAcl] = ACTIONS(6402),
    [anon_sym_BSLASHaclp] = ACTIONS(6402),
    [anon_sym_BSLASHAclp] = ACTIONS(6402),
    [anon_sym_BSLASHacf] = ACTIONS(6402),
    [anon_sym_BSLASHAcf] = ACTIONS(6402),
    [anon_sym_BSLASHacfp] = ACTIONS(6402),
    [anon_sym_BSLASHAcfp] = ACTIONS(6402),
    [anon_sym_BSLASHac] = ACTIONS(6402),
    [anon_sym_BSLASHAc] = ACTIONS(6402),
    [anon_sym_BSLASHacp] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6402),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6402),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6402),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6402),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6404),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6402),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6402),
    [anon_sym_BSLASHcolor] = ACTIONS(6402),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6402),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6402),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6402),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6402),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6402),
    [anon_sym_BSLASHurl] = ACTIONS(6402),
    [anon_sym_BSLASHhref] = ACTIONS(6402),
  },
  [2006] = {
    [sym_command_name] = ACTIONS(6322),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6322),
    [anon_sym_RBRACK] = ACTIONS(6324),
    [anon_sym_COMMA] = ACTIONS(6324),
    [anon_sym_EQ] = ACTIONS(6324),
    [anon_sym_RBRACE] = ACTIONS(6324),
    [sym_word] = ACTIONS(6322),
    [sym_placeholder] = ACTIONS(6324),
    [anon_sym_PLUS] = ACTIONS(6324),
    [anon_sym_DASH] = ACTIONS(6324),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_SLASH] = ACTIONS(6324),
    [anon_sym_LT] = ACTIONS(6322),
    [anon_sym_GT] = ACTIONS(6322),
    [anon_sym_BANG] = ACTIONS(6322),
    [anon_sym_PIPE] = ACTIONS(6322),
    [anon_sym_COLON] = ACTIONS(6322),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym__] = ACTIONS(6324),
    [anon_sym_CARET] = ACTIONS(6324),
    [anon_sym_BSLASHtitle] = ACTIONS(6322),
    [anon_sym_BSLASHauthor] = ACTIONS(6322),
    [anon_sym_BSLASHusepackage] = ACTIONS(6322),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6322),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6322),
    [anon_sym_BSLASHinclude] = ACTIONS(6322),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6322),
    [anon_sym_BSLASHinput] = ACTIONS(6322),
    [anon_sym_BSLASHsubfile] = ACTIONS(6322),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6322),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6322),
    [anon_sym_BSLASHbibliography] = ACTIONS(6322),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6322),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6322),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6322),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6322),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6322),
    [anon_sym_BSLASHimport] = ACTIONS(6322),
    [anon_sym_BSLASHsubimport] = ACTIONS(6322),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6322),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6322),
    [anon_sym_BSLASHcaption] = ACTIONS(6322),
    [anon_sym_BSLASHcite] = ACTIONS(6322),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCite] = ACTIONS(6322),
    [anon_sym_BSLASHnocite] = ACTIONS(6322),
    [anon_sym_BSLASHcitet] = ACTIONS(6322),
    [anon_sym_BSLASHcitep] = ACTIONS(6322),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteA] = ACTIONS(6322),
    [anon_sym_BSLASHciteR] = ACTIONS(6322),
    [anon_sym_BSLASHciteS] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6322),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6322),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteyear] = ACTIONS(6322),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHcitedate] = ACTIONS(6322),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHciteurl] = ACTIONS(6322),
    [anon_sym_BSLASHfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6322),
    [anon_sym_BSLASHcitealt] = ACTIONS(6322),
    [anon_sym_BSLASHcitealp] = ACTIONS(6322),
    [anon_sym_BSLASHcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHparencite] = ACTIONS(6322),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHParencite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6322),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6322),
    [anon_sym_BSLASHtextcite] = ACTIONS(6322),
    [anon_sym_BSLASHTextcite] = ACTIONS(6322),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6322),
    [anon_sym_BSLASHsupercite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite] = ACTIONS(6322),
    [anon_sym_BSLASHAutocite] = ACTIONS(6322),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHVolcite] = ACTIONS(6322),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHavolcite] = ACTIONS(6322),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6322),
    [anon_sym_BSLASHnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHNotecite] = ACTIONS(6322),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6322),
    [anon_sym_BSLASHlabel] = ACTIONS(6322),
    [anon_sym_BSLASHref] = ACTIONS(6322),
    [anon_sym_BSLASHeqref] = ACTIONS(6322),
    [anon_sym_BSLASHvref] = ACTIONS(6322),
    [anon_sym_BSLASHVref] = ACTIONS(6322),
    [anon_sym_BSLASHautoref] = ACTIONS(6322),
    [anon_sym_BSLASHpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcref] = ACTIONS(6322),
    [anon_sym_BSLASHCref] = ACTIONS(6322),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnameCref] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6322),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6322),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6322),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6322),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6322),
    [anon_sym_BSLASHdef] = ACTIONS(6322),
    [anon_sym_BSLASHlet] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6322),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6322),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6322),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6322),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6322),
    [anon_sym_BSLASHgls] = ACTIONS(6322),
    [anon_sym_BSLASHGls] = ACTIONS(6322),
    [anon_sym_BSLASHGLS] = ACTIONS(6322),
    [anon_sym_BSLASHglspl] = ACTIONS(6322),
    [anon_sym_BSLASHGlspl] = ACTIONS(6322),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6322),
    [anon_sym_BSLASHglslink] = ACTIONS(6322),
    [anon_sym_BSLASHglstext] = ACTIONS(6322),
    [anon_sym_BSLASHGlstext] = ACTIONS(6322),
    [anon_sym_BSLASHGLStext] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6322),
    [anon_sym_BSLASHglsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6322),
    [anon_sym_BSLASHglsname] = ACTIONS(6322),
    [anon_sym_BSLASHGlsname] = ACTIONS(6322),
    [anon_sym_BSLASHGLSname] = ACTIONS(6322),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6322),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6322),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6322),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6322),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6322),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6322),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6322),
    [anon_sym_BSLASHacrshort] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6322),
    [anon_sym_BSLASHACRshort] = ACTIONS(6322),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrlong] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6322),
    [anon_sym_BSLASHACRlong] = ACTIONS(6322),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6322),
    [anon_sym_BSLASHacrfull] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6322),
    [anon_sym_BSLASHACRfull] = ACTIONS(6322),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHacs] = ACTIONS(6322),
    [anon_sym_BSLASHAcs] = ACTIONS(6322),
    [anon_sym_BSLASHacsp] = ACTIONS(6322),
    [anon_sym_BSLASHAcsp] = ACTIONS(6322),
    [anon_sym_BSLASHacl] = ACTIONS(6322),
    [anon_sym_BSLASHAcl] = ACTIONS(6322),
    [anon_sym_BSLASHaclp] = ACTIONS(6322),
    [anon_sym_BSLASHAclp] = ACTIONS(6322),
    [anon_sym_BSLASHacf] = ACTIONS(6322),
    [anon_sym_BSLASHAcf] = ACTIONS(6322),
    [anon_sym_BSLASHacfp] = ACTIONS(6322),
    [anon_sym_BSLASHAcfp] = ACTIONS(6322),
    [anon_sym_BSLASHac] = ACTIONS(6322),
    [anon_sym_BSLASHAc] = ACTIONS(6322),
    [anon_sym_BSLASHacp] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6322),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6322),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6322),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6322),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6324),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6322),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6322),
    [anon_sym_BSLASHcolor] = ACTIONS(6322),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6322),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6322),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6322),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6322),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6322),
    [anon_sym_BSLASHurl] = ACTIONS(6322),
    [anon_sym_BSLASHhref] = ACTIONS(6322),
  },
  [2007] = {
    [sym_command_name] = ACTIONS(6434),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6434),
    [anon_sym_RBRACK] = ACTIONS(6436),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_EQ] = ACTIONS(6436),
    [anon_sym_RBRACE] = ACTIONS(6436),
    [sym_word] = ACTIONS(6434),
    [sym_placeholder] = ACTIONS(6436),
    [anon_sym_PLUS] = ACTIONS(6436),
    [anon_sym_DASH] = ACTIONS(6436),
    [anon_sym_STAR] = ACTIONS(6436),
    [anon_sym_SLASH] = ACTIONS(6436),
    [anon_sym_LT] = ACTIONS(6434),
    [anon_sym_GT] = ACTIONS(6434),
    [anon_sym_BANG] = ACTIONS(6434),
    [anon_sym_PIPE] = ACTIONS(6434),
    [anon_sym_COLON] = ACTIONS(6434),
    [anon_sym_SQUOTE] = ACTIONS(6434),
    [anon_sym__] = ACTIONS(6436),
    [anon_sym_CARET] = ACTIONS(6436),
    [anon_sym_BSLASHtitle] = ACTIONS(6434),
    [anon_sym_BSLASHauthor] = ACTIONS(6434),
    [anon_sym_BSLASHusepackage] = ACTIONS(6434),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6434),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6434),
    [anon_sym_BSLASHinclude] = ACTIONS(6434),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6434),
    [anon_sym_BSLASHinput] = ACTIONS(6434),
    [anon_sym_BSLASHsubfile] = ACTIONS(6434),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6434),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6434),
    [anon_sym_BSLASHbibliography] = ACTIONS(6434),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6434),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6434),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6434),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6434),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6434),
    [anon_sym_BSLASHimport] = ACTIONS(6434),
    [anon_sym_BSLASHsubimport] = ACTIONS(6434),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6434),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6434),
    [anon_sym_BSLASHcaption] = ACTIONS(6434),
    [anon_sym_BSLASHcite] = ACTIONS(6434),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCite] = ACTIONS(6434),
    [anon_sym_BSLASHnocite] = ACTIONS(6434),
    [anon_sym_BSLASHcitet] = ACTIONS(6434),
    [anon_sym_BSLASHcitep] = ACTIONS(6434),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteA] = ACTIONS(6434),
    [anon_sym_BSLASHciteR] = ACTIONS(6434),
    [anon_sym_BSLASHciteS] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6434),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6434),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteyear] = ACTIONS(6434),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHcitedate] = ACTIONS(6434),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHciteurl] = ACTIONS(6434),
    [anon_sym_BSLASHfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6434),
    [anon_sym_BSLASHcitealt] = ACTIONS(6434),
    [anon_sym_BSLASHcitealp] = ACTIONS(6434),
    [anon_sym_BSLASHcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHparencite] = ACTIONS(6434),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHParencite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6434),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6434),
    [anon_sym_BSLASHtextcite] = ACTIONS(6434),
    [anon_sym_BSLASHTextcite] = ACTIONS(6434),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6434),
    [anon_sym_BSLASHsupercite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite] = ACTIONS(6434),
    [anon_sym_BSLASHAutocite] = ACTIONS(6434),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHVolcite] = ACTIONS(6434),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHavolcite] = ACTIONS(6434),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6434),
    [anon_sym_BSLASHnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHNotecite] = ACTIONS(6434),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6434),
    [anon_sym_BSLASHlabel] = ACTIONS(6434),
    [anon_sym_BSLASHref] = ACTIONS(6434),
    [anon_sym_BSLASHeqref] = ACTIONS(6434),
    [anon_sym_BSLASHvref] = ACTIONS(6434),
    [anon_sym_BSLASHVref] = ACTIONS(6434),
    [anon_sym_BSLASHautoref] = ACTIONS(6434),
    [anon_sym_BSLASHpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcref] = ACTIONS(6434),
    [anon_sym_BSLASHCref] = ACTIONS(6434),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnameCref] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6434),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6434),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6434),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6434),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6434),
    [anon_sym_BSLASHdef] = ACTIONS(6434),
    [anon_sym_BSLASHlet] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6434),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6434),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6434),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6434),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6434),
    [anon_sym_BSLASHgls] = ACTIONS(6434),
    [anon_sym_BSLASHGls] = ACTIONS(6434),
    [anon_sym_BSLASHGLS] = ACTIONS(6434),
    [anon_sym_BSLASHglspl] = ACTIONS(6434),
    [anon_sym_BSLASHGlspl] = ACTIONS(6434),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6434),
    [anon_sym_BSLASHglslink] = ACTIONS(6434),
    [anon_sym_BSLASHglstext] = ACTIONS(6434),
    [anon_sym_BSLASHGlstext] = ACTIONS(6434),
    [anon_sym_BSLASHGLStext] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6434),
    [anon_sym_BSLASHglsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6434),
    [anon_sym_BSLASHglsname] = ACTIONS(6434),
    [anon_sym_BSLASHGlsname] = ACTIONS(6434),
    [anon_sym_BSLASHGLSname] = ACTIONS(6434),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6434),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6434),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6434),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6434),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6434),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6434),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6434),
    [anon_sym_BSLASHacrshort] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6434),
    [anon_sym_BSLASHACRshort] = ACTIONS(6434),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrlong] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6434),
    [anon_sym_BSLASHACRlong] = ACTIONS(6434),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6434),
    [anon_sym_BSLASHacrfull] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6434),
    [anon_sym_BSLASHACRfull] = ACTIONS(6434),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHacs] = ACTIONS(6434),
    [anon_sym_BSLASHAcs] = ACTIONS(6434),
    [anon_sym_BSLASHacsp] = ACTIONS(6434),
    [anon_sym_BSLASHAcsp] = ACTIONS(6434),
    [anon_sym_BSLASHacl] = ACTIONS(6434),
    [anon_sym_BSLASHAcl] = ACTIONS(6434),
    [anon_sym_BSLASHaclp] = ACTIONS(6434),
    [anon_sym_BSLASHAclp] = ACTIONS(6434),
    [anon_sym_BSLASHacf] = ACTIONS(6434),
    [anon_sym_BSLASHAcf] = ACTIONS(6434),
    [anon_sym_BSLASHacfp] = ACTIONS(6434),
    [anon_sym_BSLASHAcfp] = ACTIONS(6434),
    [anon_sym_BSLASHac] = ACTIONS(6434),
    [anon_sym_BSLASHAc] = ACTIONS(6434),
    [anon_sym_BSLASHacp] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6434),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6434),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6434),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6434),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6436),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6434),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6434),
    [anon_sym_BSLASHcolor] = ACTIONS(6434),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6434),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6434),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6434),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6434),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6434),
    [anon_sym_BSLASHurl] = ACTIONS(6434),
    [anon_sym_BSLASHhref] = ACTIONS(6434),
  },
  [2008] = {
    [sym_command_name] = ACTIONS(6398),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6398),
    [anon_sym_RBRACK] = ACTIONS(6400),
    [anon_sym_COMMA] = ACTIONS(6400),
    [anon_sym_EQ] = ACTIONS(6400),
    [anon_sym_RBRACE] = ACTIONS(6400),
    [sym_word] = ACTIONS(6398),
    [sym_placeholder] = ACTIONS(6400),
    [anon_sym_PLUS] = ACTIONS(6400),
    [anon_sym_DASH] = ACTIONS(6400),
    [anon_sym_STAR] = ACTIONS(6400),
    [anon_sym_SLASH] = ACTIONS(6400),
    [anon_sym_LT] = ACTIONS(6398),
    [anon_sym_GT] = ACTIONS(6398),
    [anon_sym_BANG] = ACTIONS(6398),
    [anon_sym_PIPE] = ACTIONS(6398),
    [anon_sym_COLON] = ACTIONS(6398),
    [anon_sym_SQUOTE] = ACTIONS(6398),
    [anon_sym__] = ACTIONS(6400),
    [anon_sym_CARET] = ACTIONS(6400),
    [anon_sym_BSLASHtitle] = ACTIONS(6398),
    [anon_sym_BSLASHauthor] = ACTIONS(6398),
    [anon_sym_BSLASHusepackage] = ACTIONS(6398),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6398),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6398),
    [anon_sym_BSLASHinclude] = ACTIONS(6398),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6398),
    [anon_sym_BSLASHinput] = ACTIONS(6398),
    [anon_sym_BSLASHsubfile] = ACTIONS(6398),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6398),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6398),
    [anon_sym_BSLASHbibliography] = ACTIONS(6398),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6398),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6398),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6398),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6398),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6398),
    [anon_sym_BSLASHimport] = ACTIONS(6398),
    [anon_sym_BSLASHsubimport] = ACTIONS(6398),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6398),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6398),
    [anon_sym_BSLASHcaption] = ACTIONS(6398),
    [anon_sym_BSLASHcite] = ACTIONS(6398),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCite] = ACTIONS(6398),
    [anon_sym_BSLASHnocite] = ACTIONS(6398),
    [anon_sym_BSLASHcitet] = ACTIONS(6398),
    [anon_sym_BSLASHcitep] = ACTIONS(6398),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteA] = ACTIONS(6398),
    [anon_sym_BSLASHciteR] = ACTIONS(6398),
    [anon_sym_BSLASHciteS] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6398),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6398),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteyear] = ACTIONS(6398),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHcitedate] = ACTIONS(6398),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHciteurl] = ACTIONS(6398),
    [anon_sym_BSLASHfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6398),
    [anon_sym_BSLASHcitealt] = ACTIONS(6398),
    [anon_sym_BSLASHcitealp] = ACTIONS(6398),
    [anon_sym_BSLASHcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHparencite] = ACTIONS(6398),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHParencite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6398),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6398),
    [anon_sym_BSLASHtextcite] = ACTIONS(6398),
    [anon_sym_BSLASHTextcite] = ACTIONS(6398),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6398),
    [anon_sym_BSLASHsupercite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite] = ACTIONS(6398),
    [anon_sym_BSLASHAutocite] = ACTIONS(6398),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHVolcite] = ACTIONS(6398),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHavolcite] = ACTIONS(6398),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6398),
    [anon_sym_BSLASHnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHNotecite] = ACTIONS(6398),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6398),
    [anon_sym_BSLASHlabel] = ACTIONS(6398),
    [anon_sym_BSLASHref] = ACTIONS(6398),
    [anon_sym_BSLASHeqref] = ACTIONS(6398),
    [anon_sym_BSLASHvref] = ACTIONS(6398),
    [anon_sym_BSLASHVref] = ACTIONS(6398),
    [anon_sym_BSLASHautoref] = ACTIONS(6398),
    [anon_sym_BSLASHpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcref] = ACTIONS(6398),
    [anon_sym_BSLASHCref] = ACTIONS(6398),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnameCref] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6398),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6398),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6398),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6398),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6398),
    [anon_sym_BSLASHdef] = ACTIONS(6398),
    [anon_sym_BSLASHlet] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6398),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6398),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6398),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6398),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6398),
    [anon_sym_BSLASHgls] = ACTIONS(6398),
    [anon_sym_BSLASHGls] = ACTIONS(6398),
    [anon_sym_BSLASHGLS] = ACTIONS(6398),
    [anon_sym_BSLASHglspl] = ACTIONS(6398),
    [anon_sym_BSLASHGlspl] = ACTIONS(6398),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6398),
    [anon_sym_BSLASHglslink] = ACTIONS(6398),
    [anon_sym_BSLASHglstext] = ACTIONS(6398),
    [anon_sym_BSLASHGlstext] = ACTIONS(6398),
    [anon_sym_BSLASHGLStext] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6398),
    [anon_sym_BSLASHglsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6398),
    [anon_sym_BSLASHglsname] = ACTIONS(6398),
    [anon_sym_BSLASHGlsname] = ACTIONS(6398),
    [anon_sym_BSLASHGLSname] = ACTIONS(6398),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6398),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6398),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6398),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6398),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6398),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6398),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6398),
    [anon_sym_BSLASHacrshort] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6398),
    [anon_sym_BSLASHACRshort] = ACTIONS(6398),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrlong] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6398),
    [anon_sym_BSLASHACRlong] = ACTIONS(6398),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6398),
    [anon_sym_BSLASHacrfull] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6398),
    [anon_sym_BSLASHACRfull] = ACTIONS(6398),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHacs] = ACTIONS(6398),
    [anon_sym_BSLASHAcs] = ACTIONS(6398),
    [anon_sym_BSLASHacsp] = ACTIONS(6398),
    [anon_sym_BSLASHAcsp] = ACTIONS(6398),
    [anon_sym_BSLASHacl] = ACTIONS(6398),
    [anon_sym_BSLASHAcl] = ACTIONS(6398),
    [anon_sym_BSLASHaclp] = ACTIONS(6398),
    [anon_sym_BSLASHAclp] = ACTIONS(6398),
    [anon_sym_BSLASHacf] = ACTIONS(6398),
    [anon_sym_BSLASHAcf] = ACTIONS(6398),
    [anon_sym_BSLASHacfp] = ACTIONS(6398),
    [anon_sym_BSLASHAcfp] = ACTIONS(6398),
    [anon_sym_BSLASHac] = ACTIONS(6398),
    [anon_sym_BSLASHAc] = ACTIONS(6398),
    [anon_sym_BSLASHacp] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6398),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6398),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6398),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6398),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6400),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6398),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6398),
    [anon_sym_BSLASHcolor] = ACTIONS(6398),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6398),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6398),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6398),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6398),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6398),
    [anon_sym_BSLASHurl] = ACTIONS(6398),
    [anon_sym_BSLASHhref] = ACTIONS(6398),
  },
  [2009] = {
    [sym_command_name] = ACTIONS(6394),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6394),
    [anon_sym_RBRACK] = ACTIONS(6396),
    [anon_sym_COMMA] = ACTIONS(6396),
    [anon_sym_EQ] = ACTIONS(6396),
    [anon_sym_RBRACE] = ACTIONS(6396),
    [sym_word] = ACTIONS(6394),
    [sym_placeholder] = ACTIONS(6396),
    [anon_sym_PLUS] = ACTIONS(6396),
    [anon_sym_DASH] = ACTIONS(6396),
    [anon_sym_STAR] = ACTIONS(6396),
    [anon_sym_SLASH] = ACTIONS(6396),
    [anon_sym_LT] = ACTIONS(6394),
    [anon_sym_GT] = ACTIONS(6394),
    [anon_sym_BANG] = ACTIONS(6394),
    [anon_sym_PIPE] = ACTIONS(6394),
    [anon_sym_COLON] = ACTIONS(6394),
    [anon_sym_SQUOTE] = ACTIONS(6394),
    [anon_sym__] = ACTIONS(6396),
    [anon_sym_CARET] = ACTIONS(6396),
    [anon_sym_BSLASHtitle] = ACTIONS(6394),
    [anon_sym_BSLASHauthor] = ACTIONS(6394),
    [anon_sym_BSLASHusepackage] = ACTIONS(6394),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6394),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6394),
    [anon_sym_BSLASHinclude] = ACTIONS(6394),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6394),
    [anon_sym_BSLASHinput] = ACTIONS(6394),
    [anon_sym_BSLASHsubfile] = ACTIONS(6394),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6394),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6394),
    [anon_sym_BSLASHbibliography] = ACTIONS(6394),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6394),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6394),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6394),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6394),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6394),
    [anon_sym_BSLASHimport] = ACTIONS(6394),
    [anon_sym_BSLASHsubimport] = ACTIONS(6394),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6394),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6394),
    [anon_sym_BSLASHcaption] = ACTIONS(6394),
    [anon_sym_BSLASHcite] = ACTIONS(6394),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCite] = ACTIONS(6394),
    [anon_sym_BSLASHnocite] = ACTIONS(6394),
    [anon_sym_BSLASHcitet] = ACTIONS(6394),
    [anon_sym_BSLASHcitep] = ACTIONS(6394),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteA] = ACTIONS(6394),
    [anon_sym_BSLASHciteR] = ACTIONS(6394),
    [anon_sym_BSLASHciteS] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6394),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6394),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteyear] = ACTIONS(6394),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHcitedate] = ACTIONS(6394),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHciteurl] = ACTIONS(6394),
    [anon_sym_BSLASHfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6394),
    [anon_sym_BSLASHcitealt] = ACTIONS(6394),
    [anon_sym_BSLASHcitealp] = ACTIONS(6394),
    [anon_sym_BSLASHcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHparencite] = ACTIONS(6394),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHParencite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6394),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6394),
    [anon_sym_BSLASHtextcite] = ACTIONS(6394),
    [anon_sym_BSLASHTextcite] = ACTIONS(6394),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6394),
    [anon_sym_BSLASHsupercite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite] = ACTIONS(6394),
    [anon_sym_BSLASHAutocite] = ACTIONS(6394),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHVolcite] = ACTIONS(6394),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHavolcite] = ACTIONS(6394),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6394),
    [anon_sym_BSLASHnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHNotecite] = ACTIONS(6394),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6394),
    [anon_sym_BSLASHlabel] = ACTIONS(6394),
    [anon_sym_BSLASHref] = ACTIONS(6394),
    [anon_sym_BSLASHeqref] = ACTIONS(6394),
    [anon_sym_BSLASHvref] = ACTIONS(6394),
    [anon_sym_BSLASHVref] = ACTIONS(6394),
    [anon_sym_BSLASHautoref] = ACTIONS(6394),
    [anon_sym_BSLASHpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcref] = ACTIONS(6394),
    [anon_sym_BSLASHCref] = ACTIONS(6394),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnameCref] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6394),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6394),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6394),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6394),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6394),
    [anon_sym_BSLASHdef] = ACTIONS(6394),
    [anon_sym_BSLASHlet] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6394),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6394),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6394),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6394),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6394),
    [anon_sym_BSLASHgls] = ACTIONS(6394),
    [anon_sym_BSLASHGls] = ACTIONS(6394),
    [anon_sym_BSLASHGLS] = ACTIONS(6394),
    [anon_sym_BSLASHglspl] = ACTIONS(6394),
    [anon_sym_BSLASHGlspl] = ACTIONS(6394),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6394),
    [anon_sym_BSLASHglslink] = ACTIONS(6394),
    [anon_sym_BSLASHglstext] = ACTIONS(6394),
    [anon_sym_BSLASHGlstext] = ACTIONS(6394),
    [anon_sym_BSLASHGLStext] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6394),
    [anon_sym_BSLASHglsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6394),
    [anon_sym_BSLASHglsname] = ACTIONS(6394),
    [anon_sym_BSLASHGlsname] = ACTIONS(6394),
    [anon_sym_BSLASHGLSname] = ACTIONS(6394),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6394),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6394),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6394),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6394),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6394),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6394),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6394),
    [anon_sym_BSLASHacrshort] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6394),
    [anon_sym_BSLASHACRshort] = ACTIONS(6394),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrlong] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6394),
    [anon_sym_BSLASHACRlong] = ACTIONS(6394),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6394),
    [anon_sym_BSLASHacrfull] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6394),
    [anon_sym_BSLASHACRfull] = ACTIONS(6394),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHacs] = ACTIONS(6394),
    [anon_sym_BSLASHAcs] = ACTIONS(6394),
    [anon_sym_BSLASHacsp] = ACTIONS(6394),
    [anon_sym_BSLASHAcsp] = ACTIONS(6394),
    [anon_sym_BSLASHacl] = ACTIONS(6394),
    [anon_sym_BSLASHAcl] = ACTIONS(6394),
    [anon_sym_BSLASHaclp] = ACTIONS(6394),
    [anon_sym_BSLASHAclp] = ACTIONS(6394),
    [anon_sym_BSLASHacf] = ACTIONS(6394),
    [anon_sym_BSLASHAcf] = ACTIONS(6394),
    [anon_sym_BSLASHacfp] = ACTIONS(6394),
    [anon_sym_BSLASHAcfp] = ACTIONS(6394),
    [anon_sym_BSLASHac] = ACTIONS(6394),
    [anon_sym_BSLASHAc] = ACTIONS(6394),
    [anon_sym_BSLASHacp] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6394),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6394),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6394),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6394),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6396),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6394),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6394),
    [anon_sym_BSLASHcolor] = ACTIONS(6394),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6394),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6394),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6394),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6394),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6394),
    [anon_sym_BSLASHurl] = ACTIONS(6394),
    [anon_sym_BSLASHhref] = ACTIONS(6394),
  },
  [2010] = {
    [sym_command_name] = ACTIONS(6502),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6502),
    [anon_sym_RBRACK] = ACTIONS(6504),
    [anon_sym_COMMA] = ACTIONS(6504),
    [anon_sym_EQ] = ACTIONS(6504),
    [anon_sym_RBRACE] = ACTIONS(6504),
    [sym_word] = ACTIONS(6502),
    [sym_placeholder] = ACTIONS(6504),
    [anon_sym_PLUS] = ACTIONS(6504),
    [anon_sym_DASH] = ACTIONS(6504),
    [anon_sym_STAR] = ACTIONS(6504),
    [anon_sym_SLASH] = ACTIONS(6504),
    [anon_sym_LT] = ACTIONS(6502),
    [anon_sym_GT] = ACTIONS(6502),
    [anon_sym_BANG] = ACTIONS(6502),
    [anon_sym_PIPE] = ACTIONS(6502),
    [anon_sym_COLON] = ACTIONS(6502),
    [anon_sym_SQUOTE] = ACTIONS(6502),
    [anon_sym__] = ACTIONS(6504),
    [anon_sym_CARET] = ACTIONS(6504),
    [anon_sym_BSLASHtitle] = ACTIONS(6502),
    [anon_sym_BSLASHauthor] = ACTIONS(6502),
    [anon_sym_BSLASHusepackage] = ACTIONS(6502),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6502),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6502),
    [anon_sym_BSLASHinclude] = ACTIONS(6502),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6502),
    [anon_sym_BSLASHinput] = ACTIONS(6502),
    [anon_sym_BSLASHsubfile] = ACTIONS(6502),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6502),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6502),
    [anon_sym_BSLASHbibliography] = ACTIONS(6502),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6502),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6502),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6502),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6502),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6502),
    [anon_sym_BSLASHimport] = ACTIONS(6502),
    [anon_sym_BSLASHsubimport] = ACTIONS(6502),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6502),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6502),
    [anon_sym_BSLASHcaption] = ACTIONS(6502),
    [anon_sym_BSLASHcite] = ACTIONS(6502),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCite] = ACTIONS(6502),
    [anon_sym_BSLASHnocite] = ACTIONS(6502),
    [anon_sym_BSLASHcitet] = ACTIONS(6502),
    [anon_sym_BSLASHcitep] = ACTIONS(6502),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteA] = ACTIONS(6502),
    [anon_sym_BSLASHciteR] = ACTIONS(6502),
    [anon_sym_BSLASHciteS] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6502),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6502),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteyear] = ACTIONS(6502),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHcitedate] = ACTIONS(6502),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHciteurl] = ACTIONS(6502),
    [anon_sym_BSLASHfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6502),
    [anon_sym_BSLASHcitealt] = ACTIONS(6502),
    [anon_sym_BSLASHcitealp] = ACTIONS(6502),
    [anon_sym_BSLASHcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHparencite] = ACTIONS(6502),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHParencite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6502),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6502),
    [anon_sym_BSLASHtextcite] = ACTIONS(6502),
    [anon_sym_BSLASHTextcite] = ACTIONS(6502),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6502),
    [anon_sym_BSLASHsupercite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite] = ACTIONS(6502),
    [anon_sym_BSLASHAutocite] = ACTIONS(6502),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHVolcite] = ACTIONS(6502),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHavolcite] = ACTIONS(6502),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6502),
    [anon_sym_BSLASHnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHNotecite] = ACTIONS(6502),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6502),
    [anon_sym_BSLASHlabel] = ACTIONS(6502),
    [anon_sym_BSLASHref] = ACTIONS(6502),
    [anon_sym_BSLASHeqref] = ACTIONS(6502),
    [anon_sym_BSLASHvref] = ACTIONS(6502),
    [anon_sym_BSLASHVref] = ACTIONS(6502),
    [anon_sym_BSLASHautoref] = ACTIONS(6502),
    [anon_sym_BSLASHpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcref] = ACTIONS(6502),
    [anon_sym_BSLASHCref] = ACTIONS(6502),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnameCref] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6502),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6502),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6502),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6502),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6502),
    [anon_sym_BSLASHdef] = ACTIONS(6502),
    [anon_sym_BSLASHlet] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6502),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6502),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6502),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6502),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6502),
    [anon_sym_BSLASHgls] = ACTIONS(6502),
    [anon_sym_BSLASHGls] = ACTIONS(6502),
    [anon_sym_BSLASHGLS] = ACTIONS(6502),
    [anon_sym_BSLASHglspl] = ACTIONS(6502),
    [anon_sym_BSLASHGlspl] = ACTIONS(6502),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6502),
    [anon_sym_BSLASHglslink] = ACTIONS(6502),
    [anon_sym_BSLASHglstext] = ACTIONS(6502),
    [anon_sym_BSLASHGlstext] = ACTIONS(6502),
    [anon_sym_BSLASHGLStext] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6502),
    [anon_sym_BSLASHglsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6502),
    [anon_sym_BSLASHglsname] = ACTIONS(6502),
    [anon_sym_BSLASHGlsname] = ACTIONS(6502),
    [anon_sym_BSLASHGLSname] = ACTIONS(6502),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6502),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6502),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6502),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6502),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6502),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6502),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6502),
    [anon_sym_BSLASHacrshort] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6502),
    [anon_sym_BSLASHACRshort] = ACTIONS(6502),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrlong] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6502),
    [anon_sym_BSLASHACRlong] = ACTIONS(6502),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6502),
    [anon_sym_BSLASHacrfull] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6502),
    [anon_sym_BSLASHACRfull] = ACTIONS(6502),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHacs] = ACTIONS(6502),
    [anon_sym_BSLASHAcs] = ACTIONS(6502),
    [anon_sym_BSLASHacsp] = ACTIONS(6502),
    [anon_sym_BSLASHAcsp] = ACTIONS(6502),
    [anon_sym_BSLASHacl] = ACTIONS(6502),
    [anon_sym_BSLASHAcl] = ACTIONS(6502),
    [anon_sym_BSLASHaclp] = ACTIONS(6502),
    [anon_sym_BSLASHAclp] = ACTIONS(6502),
    [anon_sym_BSLASHacf] = ACTIONS(6502),
    [anon_sym_BSLASHAcf] = ACTIONS(6502),
    [anon_sym_BSLASHacfp] = ACTIONS(6502),
    [anon_sym_BSLASHAcfp] = ACTIONS(6502),
    [anon_sym_BSLASHac] = ACTIONS(6502),
    [anon_sym_BSLASHAc] = ACTIONS(6502),
    [anon_sym_BSLASHacp] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6502),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6502),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6502),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6502),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6504),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6502),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6502),
    [anon_sym_BSLASHcolor] = ACTIONS(6502),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6502),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6502),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6502),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6502),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6502),
    [anon_sym_BSLASHurl] = ACTIONS(6502),
    [anon_sym_BSLASHhref] = ACTIONS(6502),
  },
  [2011] = {
    [sym_command_name] = ACTIONS(6218),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6218),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_COMMA] = ACTIONS(6220),
    [anon_sym_EQ] = ACTIONS(6220),
    [anon_sym_RBRACE] = ACTIONS(6220),
    [sym_word] = ACTIONS(6218),
    [sym_placeholder] = ACTIONS(6220),
    [anon_sym_PLUS] = ACTIONS(6220),
    [anon_sym_DASH] = ACTIONS(6220),
    [anon_sym_STAR] = ACTIONS(6220),
    [anon_sym_SLASH] = ACTIONS(6220),
    [anon_sym_LT] = ACTIONS(6218),
    [anon_sym_GT] = ACTIONS(6218),
    [anon_sym_BANG] = ACTIONS(6218),
    [anon_sym_PIPE] = ACTIONS(6218),
    [anon_sym_COLON] = ACTIONS(6218),
    [anon_sym_SQUOTE] = ACTIONS(6218),
    [anon_sym__] = ACTIONS(6220),
    [anon_sym_CARET] = ACTIONS(6220),
    [anon_sym_BSLASHtitle] = ACTIONS(6218),
    [anon_sym_BSLASHauthor] = ACTIONS(6218),
    [anon_sym_BSLASHusepackage] = ACTIONS(6218),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6218),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6218),
    [anon_sym_BSLASHinclude] = ACTIONS(6218),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6218),
    [anon_sym_BSLASHinput] = ACTIONS(6218),
    [anon_sym_BSLASHsubfile] = ACTIONS(6218),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6218),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6218),
    [anon_sym_BSLASHbibliography] = ACTIONS(6218),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6218),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6218),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6218),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6218),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6218),
    [anon_sym_BSLASHimport] = ACTIONS(6218),
    [anon_sym_BSLASHsubimport] = ACTIONS(6218),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6218),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6218),
    [anon_sym_BSLASHcaption] = ACTIONS(6218),
    [anon_sym_BSLASHcite] = ACTIONS(6218),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCite] = ACTIONS(6218),
    [anon_sym_BSLASHnocite] = ACTIONS(6218),
    [anon_sym_BSLASHcitet] = ACTIONS(6218),
    [anon_sym_BSLASHcitep] = ACTIONS(6218),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteA] = ACTIONS(6218),
    [anon_sym_BSLASHciteR] = ACTIONS(6218),
    [anon_sym_BSLASHciteS] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6218),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6218),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteyear] = ACTIONS(6218),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHcitedate] = ACTIONS(6218),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHciteurl] = ACTIONS(6218),
    [anon_sym_BSLASHfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6218),
    [anon_sym_BSLASHcitealt] = ACTIONS(6218),
    [anon_sym_BSLASHcitealp] = ACTIONS(6218),
    [anon_sym_BSLASHcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHparencite] = ACTIONS(6218),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHParencite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6218),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6218),
    [anon_sym_BSLASHtextcite] = ACTIONS(6218),
    [anon_sym_BSLASHTextcite] = ACTIONS(6218),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6218),
    [anon_sym_BSLASHsupercite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite] = ACTIONS(6218),
    [anon_sym_BSLASHAutocite] = ACTIONS(6218),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHVolcite] = ACTIONS(6218),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHavolcite] = ACTIONS(6218),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6218),
    [anon_sym_BSLASHnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHNotecite] = ACTIONS(6218),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6218),
    [anon_sym_BSLASHlabel] = ACTIONS(6218),
    [anon_sym_BSLASHref] = ACTIONS(6218),
    [anon_sym_BSLASHeqref] = ACTIONS(6218),
    [anon_sym_BSLASHvref] = ACTIONS(6218),
    [anon_sym_BSLASHVref] = ACTIONS(6218),
    [anon_sym_BSLASHautoref] = ACTIONS(6218),
    [anon_sym_BSLASHpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcref] = ACTIONS(6218),
    [anon_sym_BSLASHCref] = ACTIONS(6218),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnameCref] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6218),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6218),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6218),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6218),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6218),
    [anon_sym_BSLASHdef] = ACTIONS(6218),
    [anon_sym_BSLASHlet] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6218),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6218),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6218),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6218),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6218),
    [anon_sym_BSLASHgls] = ACTIONS(6218),
    [anon_sym_BSLASHGls] = ACTIONS(6218),
    [anon_sym_BSLASHGLS] = ACTIONS(6218),
    [anon_sym_BSLASHglspl] = ACTIONS(6218),
    [anon_sym_BSLASHGlspl] = ACTIONS(6218),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6218),
    [anon_sym_BSLASHglslink] = ACTIONS(6218),
    [anon_sym_BSLASHglstext] = ACTIONS(6218),
    [anon_sym_BSLASHGlstext] = ACTIONS(6218),
    [anon_sym_BSLASHGLStext] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6218),
    [anon_sym_BSLASHglsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6218),
    [anon_sym_BSLASHglsname] = ACTIONS(6218),
    [anon_sym_BSLASHGlsname] = ACTIONS(6218),
    [anon_sym_BSLASHGLSname] = ACTIONS(6218),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6218),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6218),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6218),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6218),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6218),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6218),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6218),
    [anon_sym_BSLASHacrshort] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6218),
    [anon_sym_BSLASHACRshort] = ACTIONS(6218),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrlong] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6218),
    [anon_sym_BSLASHACRlong] = ACTIONS(6218),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6218),
    [anon_sym_BSLASHacrfull] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6218),
    [anon_sym_BSLASHACRfull] = ACTIONS(6218),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHacs] = ACTIONS(6218),
    [anon_sym_BSLASHAcs] = ACTIONS(6218),
    [anon_sym_BSLASHacsp] = ACTIONS(6218),
    [anon_sym_BSLASHAcsp] = ACTIONS(6218),
    [anon_sym_BSLASHacl] = ACTIONS(6218),
    [anon_sym_BSLASHAcl] = ACTIONS(6218),
    [anon_sym_BSLASHaclp] = ACTIONS(6218),
    [anon_sym_BSLASHAclp] = ACTIONS(6218),
    [anon_sym_BSLASHacf] = ACTIONS(6218),
    [anon_sym_BSLASHAcf] = ACTIONS(6218),
    [anon_sym_BSLASHacfp] = ACTIONS(6218),
    [anon_sym_BSLASHAcfp] = ACTIONS(6218),
    [anon_sym_BSLASHac] = ACTIONS(6218),
    [anon_sym_BSLASHAc] = ACTIONS(6218),
    [anon_sym_BSLASHacp] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6218),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6218),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6218),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6218),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6220),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6218),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6218),
    [anon_sym_BSLASHcolor] = ACTIONS(6218),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6218),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6218),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6218),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6218),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6218),
    [anon_sym_BSLASHurl] = ACTIONS(6218),
    [anon_sym_BSLASHhref] = ACTIONS(6218),
  },
  [2012] = {
    [sym_command_name] = ACTIONS(6446),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6446),
    [anon_sym_RBRACK] = ACTIONS(6448),
    [anon_sym_COMMA] = ACTIONS(6448),
    [anon_sym_EQ] = ACTIONS(6448),
    [anon_sym_RBRACE] = ACTIONS(6448),
    [sym_word] = ACTIONS(6446),
    [sym_placeholder] = ACTIONS(6448),
    [anon_sym_PLUS] = ACTIONS(6448),
    [anon_sym_DASH] = ACTIONS(6448),
    [anon_sym_STAR] = ACTIONS(6448),
    [anon_sym_SLASH] = ACTIONS(6448),
    [anon_sym_LT] = ACTIONS(6446),
    [anon_sym_GT] = ACTIONS(6446),
    [anon_sym_BANG] = ACTIONS(6446),
    [anon_sym_PIPE] = ACTIONS(6446),
    [anon_sym_COLON] = ACTIONS(6446),
    [anon_sym_SQUOTE] = ACTIONS(6446),
    [anon_sym__] = ACTIONS(6448),
    [anon_sym_CARET] = ACTIONS(6448),
    [anon_sym_BSLASHtitle] = ACTIONS(6446),
    [anon_sym_BSLASHauthor] = ACTIONS(6446),
    [anon_sym_BSLASHusepackage] = ACTIONS(6446),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6446),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6446),
    [anon_sym_BSLASHinclude] = ACTIONS(6446),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6446),
    [anon_sym_BSLASHinput] = ACTIONS(6446),
    [anon_sym_BSLASHsubfile] = ACTIONS(6446),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6446),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6446),
    [anon_sym_BSLASHbibliography] = ACTIONS(6446),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6446),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6446),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6446),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6446),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6446),
    [anon_sym_BSLASHimport] = ACTIONS(6446),
    [anon_sym_BSLASHsubimport] = ACTIONS(6446),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6446),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6446),
    [anon_sym_BSLASHcaption] = ACTIONS(6446),
    [anon_sym_BSLASHcite] = ACTIONS(6446),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCite] = ACTIONS(6446),
    [anon_sym_BSLASHnocite] = ACTIONS(6446),
    [anon_sym_BSLASHcitet] = ACTIONS(6446),
    [anon_sym_BSLASHcitep] = ACTIONS(6446),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteA] = ACTIONS(6446),
    [anon_sym_BSLASHciteR] = ACTIONS(6446),
    [anon_sym_BSLASHciteS] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6446),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6446),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteyear] = ACTIONS(6446),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHcitedate] = ACTIONS(6446),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHciteurl] = ACTIONS(6446),
    [anon_sym_BSLASHfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6446),
    [anon_sym_BSLASHcitealt] = ACTIONS(6446),
    [anon_sym_BSLASHcitealp] = ACTIONS(6446),
    [anon_sym_BSLASHcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHparencite] = ACTIONS(6446),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHParencite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6446),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6446),
    [anon_sym_BSLASHtextcite] = ACTIONS(6446),
    [anon_sym_BSLASHTextcite] = ACTIONS(6446),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6446),
    [anon_sym_BSLASHsupercite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite] = ACTIONS(6446),
    [anon_sym_BSLASHAutocite] = ACTIONS(6446),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHVolcite] = ACTIONS(6446),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHavolcite] = ACTIONS(6446),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6446),
    [anon_sym_BSLASHnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHNotecite] = ACTIONS(6446),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6446),
    [anon_sym_BSLASHlabel] = ACTIONS(6446),
    [anon_sym_BSLASHref] = ACTIONS(6446),
    [anon_sym_BSLASHeqref] = ACTIONS(6446),
    [anon_sym_BSLASHvref] = ACTIONS(6446),
    [anon_sym_BSLASHVref] = ACTIONS(6446),
    [anon_sym_BSLASHautoref] = ACTIONS(6446),
    [anon_sym_BSLASHpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcref] = ACTIONS(6446),
    [anon_sym_BSLASHCref] = ACTIONS(6446),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnameCref] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6446),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6446),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6446),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6446),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6446),
    [anon_sym_BSLASHdef] = ACTIONS(6446),
    [anon_sym_BSLASHlet] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6446),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6446),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6446),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6446),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6446),
    [anon_sym_BSLASHgls] = ACTIONS(6446),
    [anon_sym_BSLASHGls] = ACTIONS(6446),
    [anon_sym_BSLASHGLS] = ACTIONS(6446),
    [anon_sym_BSLASHglspl] = ACTIONS(6446),
    [anon_sym_BSLASHGlspl] = ACTIONS(6446),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6446),
    [anon_sym_BSLASHglslink] = ACTIONS(6446),
    [anon_sym_BSLASHglstext] = ACTIONS(6446),
    [anon_sym_BSLASHGlstext] = ACTIONS(6446),
    [anon_sym_BSLASHGLStext] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6446),
    [anon_sym_BSLASHglsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6446),
    [anon_sym_BSLASHglsname] = ACTIONS(6446),
    [anon_sym_BSLASHGlsname] = ACTIONS(6446),
    [anon_sym_BSLASHGLSname] = ACTIONS(6446),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6446),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6446),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6446),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6446),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6446),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6446),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6446),
    [anon_sym_BSLASHacrshort] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6446),
    [anon_sym_BSLASHACRshort] = ACTIONS(6446),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrlong] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6446),
    [anon_sym_BSLASHACRlong] = ACTIONS(6446),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6446),
    [anon_sym_BSLASHacrfull] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6446),
    [anon_sym_BSLASHACRfull] = ACTIONS(6446),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHacs] = ACTIONS(6446),
    [anon_sym_BSLASHAcs] = ACTIONS(6446),
    [anon_sym_BSLASHacsp] = ACTIONS(6446),
    [anon_sym_BSLASHAcsp] = ACTIONS(6446),
    [anon_sym_BSLASHacl] = ACTIONS(6446),
    [anon_sym_BSLASHAcl] = ACTIONS(6446),
    [anon_sym_BSLASHaclp] = ACTIONS(6446),
    [anon_sym_BSLASHAclp] = ACTIONS(6446),
    [anon_sym_BSLASHacf] = ACTIONS(6446),
    [anon_sym_BSLASHAcf] = ACTIONS(6446),
    [anon_sym_BSLASHacfp] = ACTIONS(6446),
    [anon_sym_BSLASHAcfp] = ACTIONS(6446),
    [anon_sym_BSLASHac] = ACTIONS(6446),
    [anon_sym_BSLASHAc] = ACTIONS(6446),
    [anon_sym_BSLASHacp] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6446),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6446),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6446),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6446),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6448),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6446),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6446),
    [anon_sym_BSLASHcolor] = ACTIONS(6446),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6446),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6446),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6446),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6446),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6446),
    [anon_sym_BSLASHurl] = ACTIONS(6446),
    [anon_sym_BSLASHhref] = ACTIONS(6446),
  },
  [2013] = {
    [sym_command_name] = ACTIONS(6390),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6390),
    [anon_sym_RBRACK] = ACTIONS(6392),
    [anon_sym_COMMA] = ACTIONS(6392),
    [anon_sym_EQ] = ACTIONS(6392),
    [anon_sym_RBRACE] = ACTIONS(6392),
    [sym_word] = ACTIONS(6390),
    [sym_placeholder] = ACTIONS(6392),
    [anon_sym_PLUS] = ACTIONS(6392),
    [anon_sym_DASH] = ACTIONS(6392),
    [anon_sym_STAR] = ACTIONS(6392),
    [anon_sym_SLASH] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(6390),
    [anon_sym_GT] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(6390),
    [anon_sym_PIPE] = ACTIONS(6390),
    [anon_sym_COLON] = ACTIONS(6390),
    [anon_sym_SQUOTE] = ACTIONS(6390),
    [anon_sym__] = ACTIONS(6392),
    [anon_sym_CARET] = ACTIONS(6392),
    [anon_sym_BSLASHtitle] = ACTIONS(6390),
    [anon_sym_BSLASHauthor] = ACTIONS(6390),
    [anon_sym_BSLASHusepackage] = ACTIONS(6390),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6390),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6390),
    [anon_sym_BSLASHinclude] = ACTIONS(6390),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6390),
    [anon_sym_BSLASHinput] = ACTIONS(6390),
    [anon_sym_BSLASHsubfile] = ACTIONS(6390),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6390),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6390),
    [anon_sym_BSLASHbibliography] = ACTIONS(6390),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6390),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6390),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6390),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6390),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6390),
    [anon_sym_BSLASHimport] = ACTIONS(6390),
    [anon_sym_BSLASHsubimport] = ACTIONS(6390),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6390),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6390),
    [anon_sym_BSLASHcaption] = ACTIONS(6390),
    [anon_sym_BSLASHcite] = ACTIONS(6390),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCite] = ACTIONS(6390),
    [anon_sym_BSLASHnocite] = ACTIONS(6390),
    [anon_sym_BSLASHcitet] = ACTIONS(6390),
    [anon_sym_BSLASHcitep] = ACTIONS(6390),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteA] = ACTIONS(6390),
    [anon_sym_BSLASHciteR] = ACTIONS(6390),
    [anon_sym_BSLASHciteS] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6390),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6390),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteyear] = ACTIONS(6390),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHcitedate] = ACTIONS(6390),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHciteurl] = ACTIONS(6390),
    [anon_sym_BSLASHfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6390),
    [anon_sym_BSLASHcitealt] = ACTIONS(6390),
    [anon_sym_BSLASHcitealp] = ACTIONS(6390),
    [anon_sym_BSLASHcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHparencite] = ACTIONS(6390),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHParencite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6390),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6390),
    [anon_sym_BSLASHtextcite] = ACTIONS(6390),
    [anon_sym_BSLASHTextcite] = ACTIONS(6390),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6390),
    [anon_sym_BSLASHsupercite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite] = ACTIONS(6390),
    [anon_sym_BSLASHAutocite] = ACTIONS(6390),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHVolcite] = ACTIONS(6390),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHavolcite] = ACTIONS(6390),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6390),
    [anon_sym_BSLASHnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHNotecite] = ACTIONS(6390),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6390),
    [anon_sym_BSLASHlabel] = ACTIONS(6390),
    [anon_sym_BSLASHref] = ACTIONS(6390),
    [anon_sym_BSLASHeqref] = ACTIONS(6390),
    [anon_sym_BSLASHvref] = ACTIONS(6390),
    [anon_sym_BSLASHVref] = ACTIONS(6390),
    [anon_sym_BSLASHautoref] = ACTIONS(6390),
    [anon_sym_BSLASHpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcref] = ACTIONS(6390),
    [anon_sym_BSLASHCref] = ACTIONS(6390),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnameCref] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6390),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6390),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6390),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6390),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6390),
    [anon_sym_BSLASHdef] = ACTIONS(6390),
    [anon_sym_BSLASHlet] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6390),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6390),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6390),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6390),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6390),
    [anon_sym_BSLASHgls] = ACTIONS(6390),
    [anon_sym_BSLASHGls] = ACTIONS(6390),
    [anon_sym_BSLASHGLS] = ACTIONS(6390),
    [anon_sym_BSLASHglspl] = ACTIONS(6390),
    [anon_sym_BSLASHGlspl] = ACTIONS(6390),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6390),
    [anon_sym_BSLASHglslink] = ACTIONS(6390),
    [anon_sym_BSLASHglstext] = ACTIONS(6390),
    [anon_sym_BSLASHGlstext] = ACTIONS(6390),
    [anon_sym_BSLASHGLStext] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6390),
    [anon_sym_BSLASHglsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6390),
    [anon_sym_BSLASHglsname] = ACTIONS(6390),
    [anon_sym_BSLASHGlsname] = ACTIONS(6390),
    [anon_sym_BSLASHGLSname] = ACTIONS(6390),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6390),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6390),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6390),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6390),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6390),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6390),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6390),
    [anon_sym_BSLASHacrshort] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6390),
    [anon_sym_BSLASHACRshort] = ACTIONS(6390),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrlong] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6390),
    [anon_sym_BSLASHACRlong] = ACTIONS(6390),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6390),
    [anon_sym_BSLASHacrfull] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6390),
    [anon_sym_BSLASHACRfull] = ACTIONS(6390),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHacs] = ACTIONS(6390),
    [anon_sym_BSLASHAcs] = ACTIONS(6390),
    [anon_sym_BSLASHacsp] = ACTIONS(6390),
    [anon_sym_BSLASHAcsp] = ACTIONS(6390),
    [anon_sym_BSLASHacl] = ACTIONS(6390),
    [anon_sym_BSLASHAcl] = ACTIONS(6390),
    [anon_sym_BSLASHaclp] = ACTIONS(6390),
    [anon_sym_BSLASHAclp] = ACTIONS(6390),
    [anon_sym_BSLASHacf] = ACTIONS(6390),
    [anon_sym_BSLASHAcf] = ACTIONS(6390),
    [anon_sym_BSLASHacfp] = ACTIONS(6390),
    [anon_sym_BSLASHAcfp] = ACTIONS(6390),
    [anon_sym_BSLASHac] = ACTIONS(6390),
    [anon_sym_BSLASHAc] = ACTIONS(6390),
    [anon_sym_BSLASHacp] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6390),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6390),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6390),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6390),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6392),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6390),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6390),
    [anon_sym_BSLASHcolor] = ACTIONS(6390),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6390),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6390),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6390),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6390),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6390),
    [anon_sym_BSLASHurl] = ACTIONS(6390),
    [anon_sym_BSLASHhref] = ACTIONS(6390),
  },
  [2014] = {
    [sym_command_name] = ACTIONS(6386),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6386),
    [anon_sym_RBRACK] = ACTIONS(6388),
    [anon_sym_COMMA] = ACTIONS(6388),
    [anon_sym_EQ] = ACTIONS(6388),
    [anon_sym_RBRACE] = ACTIONS(6388),
    [sym_word] = ACTIONS(6386),
    [sym_placeholder] = ACTIONS(6388),
    [anon_sym_PLUS] = ACTIONS(6388),
    [anon_sym_DASH] = ACTIONS(6388),
    [anon_sym_STAR] = ACTIONS(6388),
    [anon_sym_SLASH] = ACTIONS(6388),
    [anon_sym_LT] = ACTIONS(6386),
    [anon_sym_GT] = ACTIONS(6386),
    [anon_sym_BANG] = ACTIONS(6386),
    [anon_sym_PIPE] = ACTIONS(6386),
    [anon_sym_COLON] = ACTIONS(6386),
    [anon_sym_SQUOTE] = ACTIONS(6386),
    [anon_sym__] = ACTIONS(6388),
    [anon_sym_CARET] = ACTIONS(6388),
    [anon_sym_BSLASHtitle] = ACTIONS(6386),
    [anon_sym_BSLASHauthor] = ACTIONS(6386),
    [anon_sym_BSLASHusepackage] = ACTIONS(6386),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6386),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6386),
    [anon_sym_BSLASHinclude] = ACTIONS(6386),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6386),
    [anon_sym_BSLASHinput] = ACTIONS(6386),
    [anon_sym_BSLASHsubfile] = ACTIONS(6386),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6386),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6386),
    [anon_sym_BSLASHbibliography] = ACTIONS(6386),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6386),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6386),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6386),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6386),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6386),
    [anon_sym_BSLASHimport] = ACTIONS(6386),
    [anon_sym_BSLASHsubimport] = ACTIONS(6386),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6386),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6386),
    [anon_sym_BSLASHcaption] = ACTIONS(6386),
    [anon_sym_BSLASHcite] = ACTIONS(6386),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCite] = ACTIONS(6386),
    [anon_sym_BSLASHnocite] = ACTIONS(6386),
    [anon_sym_BSLASHcitet] = ACTIONS(6386),
    [anon_sym_BSLASHcitep] = ACTIONS(6386),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteA] = ACTIONS(6386),
    [anon_sym_BSLASHciteR] = ACTIONS(6386),
    [anon_sym_BSLASHciteS] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6386),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6386),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteyear] = ACTIONS(6386),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHcitedate] = ACTIONS(6386),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHciteurl] = ACTIONS(6386),
    [anon_sym_BSLASHfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6386),
    [anon_sym_BSLASHcitealt] = ACTIONS(6386),
    [anon_sym_BSLASHcitealp] = ACTIONS(6386),
    [anon_sym_BSLASHcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHparencite] = ACTIONS(6386),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHParencite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6386),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6386),
    [anon_sym_BSLASHtextcite] = ACTIONS(6386),
    [anon_sym_BSLASHTextcite] = ACTIONS(6386),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6386),
    [anon_sym_BSLASHsupercite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite] = ACTIONS(6386),
    [anon_sym_BSLASHAutocite] = ACTIONS(6386),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHVolcite] = ACTIONS(6386),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHavolcite] = ACTIONS(6386),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6386),
    [anon_sym_BSLASHnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHNotecite] = ACTIONS(6386),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6386),
    [anon_sym_BSLASHlabel] = ACTIONS(6386),
    [anon_sym_BSLASHref] = ACTIONS(6386),
    [anon_sym_BSLASHeqref] = ACTIONS(6386),
    [anon_sym_BSLASHvref] = ACTIONS(6386),
    [anon_sym_BSLASHVref] = ACTIONS(6386),
    [anon_sym_BSLASHautoref] = ACTIONS(6386),
    [anon_sym_BSLASHpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcref] = ACTIONS(6386),
    [anon_sym_BSLASHCref] = ACTIONS(6386),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnameCref] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6386),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6386),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6386),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6386),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6386),
    [anon_sym_BSLASHdef] = ACTIONS(6386),
    [anon_sym_BSLASHlet] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6386),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6386),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6386),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6386),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6386),
    [anon_sym_BSLASHgls] = ACTIONS(6386),
    [anon_sym_BSLASHGls] = ACTIONS(6386),
    [anon_sym_BSLASHGLS] = ACTIONS(6386),
    [anon_sym_BSLASHglspl] = ACTIONS(6386),
    [anon_sym_BSLASHGlspl] = ACTIONS(6386),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6386),
    [anon_sym_BSLASHglslink] = ACTIONS(6386),
    [anon_sym_BSLASHglstext] = ACTIONS(6386),
    [anon_sym_BSLASHGlstext] = ACTIONS(6386),
    [anon_sym_BSLASHGLStext] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6386),
    [anon_sym_BSLASHglsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6386),
    [anon_sym_BSLASHglsname] = ACTIONS(6386),
    [anon_sym_BSLASHGlsname] = ACTIONS(6386),
    [anon_sym_BSLASHGLSname] = ACTIONS(6386),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6386),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6386),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6386),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6386),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6386),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6386),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6386),
    [anon_sym_BSLASHacrshort] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6386),
    [anon_sym_BSLASHACRshort] = ACTIONS(6386),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrlong] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6386),
    [anon_sym_BSLASHACRlong] = ACTIONS(6386),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6386),
    [anon_sym_BSLASHacrfull] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6386),
    [anon_sym_BSLASHACRfull] = ACTIONS(6386),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHacs] = ACTIONS(6386),
    [anon_sym_BSLASHAcs] = ACTIONS(6386),
    [anon_sym_BSLASHacsp] = ACTIONS(6386),
    [anon_sym_BSLASHAcsp] = ACTIONS(6386),
    [anon_sym_BSLASHacl] = ACTIONS(6386),
    [anon_sym_BSLASHAcl] = ACTIONS(6386),
    [anon_sym_BSLASHaclp] = ACTIONS(6386),
    [anon_sym_BSLASHAclp] = ACTIONS(6386),
    [anon_sym_BSLASHacf] = ACTIONS(6386),
    [anon_sym_BSLASHAcf] = ACTIONS(6386),
    [anon_sym_BSLASHacfp] = ACTIONS(6386),
    [anon_sym_BSLASHAcfp] = ACTIONS(6386),
    [anon_sym_BSLASHac] = ACTIONS(6386),
    [anon_sym_BSLASHAc] = ACTIONS(6386),
    [anon_sym_BSLASHacp] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6386),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6386),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6386),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6386),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6388),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6386),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6386),
    [anon_sym_BSLASHcolor] = ACTIONS(6386),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6386),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6386),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6386),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6386),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6386),
    [anon_sym_BSLASHurl] = ACTIONS(6386),
    [anon_sym_BSLASHhref] = ACTIONS(6386),
  },
  [2015] = {
    [sym_command_name] = ACTIONS(6382),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6382),
    [anon_sym_RBRACK] = ACTIONS(6384),
    [anon_sym_COMMA] = ACTIONS(6384),
    [anon_sym_EQ] = ACTIONS(6384),
    [anon_sym_RBRACE] = ACTIONS(6384),
    [sym_word] = ACTIONS(6382),
    [sym_placeholder] = ACTIONS(6384),
    [anon_sym_PLUS] = ACTIONS(6384),
    [anon_sym_DASH] = ACTIONS(6384),
    [anon_sym_STAR] = ACTIONS(6384),
    [anon_sym_SLASH] = ACTIONS(6384),
    [anon_sym_LT] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6382),
    [anon_sym_BANG] = ACTIONS(6382),
    [anon_sym_PIPE] = ACTIONS(6382),
    [anon_sym_COLON] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6382),
    [anon_sym__] = ACTIONS(6384),
    [anon_sym_CARET] = ACTIONS(6384),
    [anon_sym_BSLASHtitle] = ACTIONS(6382),
    [anon_sym_BSLASHauthor] = ACTIONS(6382),
    [anon_sym_BSLASHusepackage] = ACTIONS(6382),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6382),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6382),
    [anon_sym_BSLASHinclude] = ACTIONS(6382),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6382),
    [anon_sym_BSLASHinput] = ACTIONS(6382),
    [anon_sym_BSLASHsubfile] = ACTIONS(6382),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6382),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6382),
    [anon_sym_BSLASHbibliography] = ACTIONS(6382),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6382),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6382),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6382),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6382),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6382),
    [anon_sym_BSLASHimport] = ACTIONS(6382),
    [anon_sym_BSLASHsubimport] = ACTIONS(6382),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6382),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6382),
    [anon_sym_BSLASHcaption] = ACTIONS(6382),
    [anon_sym_BSLASHcite] = ACTIONS(6382),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCite] = ACTIONS(6382),
    [anon_sym_BSLASHnocite] = ACTIONS(6382),
    [anon_sym_BSLASHcitet] = ACTIONS(6382),
    [anon_sym_BSLASHcitep] = ACTIONS(6382),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteA] = ACTIONS(6382),
    [anon_sym_BSLASHciteR] = ACTIONS(6382),
    [anon_sym_BSLASHciteS] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6382),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6382),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteyear] = ACTIONS(6382),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHcitedate] = ACTIONS(6382),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHciteurl] = ACTIONS(6382),
    [anon_sym_BSLASHfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6382),
    [anon_sym_BSLASHcitealt] = ACTIONS(6382),
    [anon_sym_BSLASHcitealp] = ACTIONS(6382),
    [anon_sym_BSLASHcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHparencite] = ACTIONS(6382),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHParencite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6382),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6382),
    [anon_sym_BSLASHtextcite] = ACTIONS(6382),
    [anon_sym_BSLASHTextcite] = ACTIONS(6382),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6382),
    [anon_sym_BSLASHsupercite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite] = ACTIONS(6382),
    [anon_sym_BSLASHAutocite] = ACTIONS(6382),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHVolcite] = ACTIONS(6382),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHavolcite] = ACTIONS(6382),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6382),
    [anon_sym_BSLASHnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHNotecite] = ACTIONS(6382),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6382),
    [anon_sym_BSLASHlabel] = ACTIONS(6382),
    [anon_sym_BSLASHref] = ACTIONS(6382),
    [anon_sym_BSLASHeqref] = ACTIONS(6382),
    [anon_sym_BSLASHvref] = ACTIONS(6382),
    [anon_sym_BSLASHVref] = ACTIONS(6382),
    [anon_sym_BSLASHautoref] = ACTIONS(6382),
    [anon_sym_BSLASHpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcref] = ACTIONS(6382),
    [anon_sym_BSLASHCref] = ACTIONS(6382),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnameCref] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6382),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6382),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6382),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6382),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6382),
    [anon_sym_BSLASHdef] = ACTIONS(6382),
    [anon_sym_BSLASHlet] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6382),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6382),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6382),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6382),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6382),
    [anon_sym_BSLASHgls] = ACTIONS(6382),
    [anon_sym_BSLASHGls] = ACTIONS(6382),
    [anon_sym_BSLASHGLS] = ACTIONS(6382),
    [anon_sym_BSLASHglspl] = ACTIONS(6382),
    [anon_sym_BSLASHGlspl] = ACTIONS(6382),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6382),
    [anon_sym_BSLASHglslink] = ACTIONS(6382),
    [anon_sym_BSLASHglstext] = ACTIONS(6382),
    [anon_sym_BSLASHGlstext] = ACTIONS(6382),
    [anon_sym_BSLASHGLStext] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6382),
    [anon_sym_BSLASHglsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6382),
    [anon_sym_BSLASHglsname] = ACTIONS(6382),
    [anon_sym_BSLASHGlsname] = ACTIONS(6382),
    [anon_sym_BSLASHGLSname] = ACTIONS(6382),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6382),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6382),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6382),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6382),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6382),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6382),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6382),
    [anon_sym_BSLASHacrshort] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6382),
    [anon_sym_BSLASHACRshort] = ACTIONS(6382),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrlong] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6382),
    [anon_sym_BSLASHACRlong] = ACTIONS(6382),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6382),
    [anon_sym_BSLASHacrfull] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6382),
    [anon_sym_BSLASHACRfull] = ACTIONS(6382),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHacs] = ACTIONS(6382),
    [anon_sym_BSLASHAcs] = ACTIONS(6382),
    [anon_sym_BSLASHacsp] = ACTIONS(6382),
    [anon_sym_BSLASHAcsp] = ACTIONS(6382),
    [anon_sym_BSLASHacl] = ACTIONS(6382),
    [anon_sym_BSLASHAcl] = ACTIONS(6382),
    [anon_sym_BSLASHaclp] = ACTIONS(6382),
    [anon_sym_BSLASHAclp] = ACTIONS(6382),
    [anon_sym_BSLASHacf] = ACTIONS(6382),
    [anon_sym_BSLASHAcf] = ACTIONS(6382),
    [anon_sym_BSLASHacfp] = ACTIONS(6382),
    [anon_sym_BSLASHAcfp] = ACTIONS(6382),
    [anon_sym_BSLASHac] = ACTIONS(6382),
    [anon_sym_BSLASHAc] = ACTIONS(6382),
    [anon_sym_BSLASHacp] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6382),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6382),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6382),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6382),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6384),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6382),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6382),
    [anon_sym_BSLASHcolor] = ACTIONS(6382),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6382),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6382),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6382),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6382),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6382),
    [anon_sym_BSLASHurl] = ACTIONS(6382),
    [anon_sym_BSLASHhref] = ACTIONS(6382),
  },
  [2016] = {
    [sym_command_name] = ACTIONS(6378),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6378),
    [anon_sym_RBRACK] = ACTIONS(6380),
    [anon_sym_COMMA] = ACTIONS(6380),
    [anon_sym_EQ] = ACTIONS(6380),
    [anon_sym_RBRACE] = ACTIONS(6380),
    [sym_word] = ACTIONS(6378),
    [sym_placeholder] = ACTIONS(6380),
    [anon_sym_PLUS] = ACTIONS(6380),
    [anon_sym_DASH] = ACTIONS(6380),
    [anon_sym_STAR] = ACTIONS(6380),
    [anon_sym_SLASH] = ACTIONS(6380),
    [anon_sym_LT] = ACTIONS(6378),
    [anon_sym_GT] = ACTIONS(6378),
    [anon_sym_BANG] = ACTIONS(6378),
    [anon_sym_PIPE] = ACTIONS(6378),
    [anon_sym_COLON] = ACTIONS(6378),
    [anon_sym_SQUOTE] = ACTIONS(6378),
    [anon_sym__] = ACTIONS(6380),
    [anon_sym_CARET] = ACTIONS(6380),
    [anon_sym_BSLASHtitle] = ACTIONS(6378),
    [anon_sym_BSLASHauthor] = ACTIONS(6378),
    [anon_sym_BSLASHusepackage] = ACTIONS(6378),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6378),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6378),
    [anon_sym_BSLASHinclude] = ACTIONS(6378),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6378),
    [anon_sym_BSLASHinput] = ACTIONS(6378),
    [anon_sym_BSLASHsubfile] = ACTIONS(6378),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6378),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6378),
    [anon_sym_BSLASHbibliography] = ACTIONS(6378),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6378),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6378),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6378),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6378),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6378),
    [anon_sym_BSLASHimport] = ACTIONS(6378),
    [anon_sym_BSLASHsubimport] = ACTIONS(6378),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6378),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6378),
    [anon_sym_BSLASHcaption] = ACTIONS(6378),
    [anon_sym_BSLASHcite] = ACTIONS(6378),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCite] = ACTIONS(6378),
    [anon_sym_BSLASHnocite] = ACTIONS(6378),
    [anon_sym_BSLASHcitet] = ACTIONS(6378),
    [anon_sym_BSLASHcitep] = ACTIONS(6378),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteA] = ACTIONS(6378),
    [anon_sym_BSLASHciteR] = ACTIONS(6378),
    [anon_sym_BSLASHciteS] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6378),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6378),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteyear] = ACTIONS(6378),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHcitedate] = ACTIONS(6378),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHciteurl] = ACTIONS(6378),
    [anon_sym_BSLASHfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6378),
    [anon_sym_BSLASHcitealt] = ACTIONS(6378),
    [anon_sym_BSLASHcitealp] = ACTIONS(6378),
    [anon_sym_BSLASHcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHparencite] = ACTIONS(6378),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHParencite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6378),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6378),
    [anon_sym_BSLASHtextcite] = ACTIONS(6378),
    [anon_sym_BSLASHTextcite] = ACTIONS(6378),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6378),
    [anon_sym_BSLASHsupercite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite] = ACTIONS(6378),
    [anon_sym_BSLASHAutocite] = ACTIONS(6378),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHVolcite] = ACTIONS(6378),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHavolcite] = ACTIONS(6378),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6378),
    [anon_sym_BSLASHnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHNotecite] = ACTIONS(6378),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6378),
    [anon_sym_BSLASHlabel] = ACTIONS(6378),
    [anon_sym_BSLASHref] = ACTIONS(6378),
    [anon_sym_BSLASHeqref] = ACTIONS(6378),
    [anon_sym_BSLASHvref] = ACTIONS(6378),
    [anon_sym_BSLASHVref] = ACTIONS(6378),
    [anon_sym_BSLASHautoref] = ACTIONS(6378),
    [anon_sym_BSLASHpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcref] = ACTIONS(6378),
    [anon_sym_BSLASHCref] = ACTIONS(6378),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnameCref] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6378),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6378),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6378),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6378),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6378),
    [anon_sym_BSLASHdef] = ACTIONS(6378),
    [anon_sym_BSLASHlet] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6378),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6378),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6378),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6378),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6378),
    [anon_sym_BSLASHgls] = ACTIONS(6378),
    [anon_sym_BSLASHGls] = ACTIONS(6378),
    [anon_sym_BSLASHGLS] = ACTIONS(6378),
    [anon_sym_BSLASHglspl] = ACTIONS(6378),
    [anon_sym_BSLASHGlspl] = ACTIONS(6378),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6378),
    [anon_sym_BSLASHglslink] = ACTIONS(6378),
    [anon_sym_BSLASHglstext] = ACTIONS(6378),
    [anon_sym_BSLASHGlstext] = ACTIONS(6378),
    [anon_sym_BSLASHGLStext] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6378),
    [anon_sym_BSLASHglsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6378),
    [anon_sym_BSLASHglsname] = ACTIONS(6378),
    [anon_sym_BSLASHGlsname] = ACTIONS(6378),
    [anon_sym_BSLASHGLSname] = ACTIONS(6378),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6378),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6378),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6378),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6378),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6378),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6378),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6378),
    [anon_sym_BSLASHacrshort] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6378),
    [anon_sym_BSLASHACRshort] = ACTIONS(6378),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrlong] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6378),
    [anon_sym_BSLASHACRlong] = ACTIONS(6378),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6378),
    [anon_sym_BSLASHacrfull] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6378),
    [anon_sym_BSLASHACRfull] = ACTIONS(6378),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHacs] = ACTIONS(6378),
    [anon_sym_BSLASHAcs] = ACTIONS(6378),
    [anon_sym_BSLASHacsp] = ACTIONS(6378),
    [anon_sym_BSLASHAcsp] = ACTIONS(6378),
    [anon_sym_BSLASHacl] = ACTIONS(6378),
    [anon_sym_BSLASHAcl] = ACTIONS(6378),
    [anon_sym_BSLASHaclp] = ACTIONS(6378),
    [anon_sym_BSLASHAclp] = ACTIONS(6378),
    [anon_sym_BSLASHacf] = ACTIONS(6378),
    [anon_sym_BSLASHAcf] = ACTIONS(6378),
    [anon_sym_BSLASHacfp] = ACTIONS(6378),
    [anon_sym_BSLASHAcfp] = ACTIONS(6378),
    [anon_sym_BSLASHac] = ACTIONS(6378),
    [anon_sym_BSLASHAc] = ACTIONS(6378),
    [anon_sym_BSLASHacp] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6378),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6378),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6378),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6378),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6380),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6378),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6378),
    [anon_sym_BSLASHcolor] = ACTIONS(6378),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6378),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6378),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6378),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6378),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6378),
    [anon_sym_BSLASHurl] = ACTIONS(6378),
    [anon_sym_BSLASHhref] = ACTIONS(6378),
  },
  [2017] = {
    [sym_command_name] = ACTIONS(6374),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6374),
    [anon_sym_RBRACK] = ACTIONS(6376),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_EQ] = ACTIONS(6376),
    [anon_sym_RBRACE] = ACTIONS(6376),
    [sym_word] = ACTIONS(6374),
    [sym_placeholder] = ACTIONS(6376),
    [anon_sym_PLUS] = ACTIONS(6376),
    [anon_sym_DASH] = ACTIONS(6376),
    [anon_sym_STAR] = ACTIONS(6376),
    [anon_sym_SLASH] = ACTIONS(6376),
    [anon_sym_LT] = ACTIONS(6374),
    [anon_sym_GT] = ACTIONS(6374),
    [anon_sym_BANG] = ACTIONS(6374),
    [anon_sym_PIPE] = ACTIONS(6374),
    [anon_sym_COLON] = ACTIONS(6374),
    [anon_sym_SQUOTE] = ACTIONS(6374),
    [anon_sym__] = ACTIONS(6376),
    [anon_sym_CARET] = ACTIONS(6376),
    [anon_sym_BSLASHtitle] = ACTIONS(6374),
    [anon_sym_BSLASHauthor] = ACTIONS(6374),
    [anon_sym_BSLASHusepackage] = ACTIONS(6374),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6374),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6374),
    [anon_sym_BSLASHinclude] = ACTIONS(6374),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6374),
    [anon_sym_BSLASHinput] = ACTIONS(6374),
    [anon_sym_BSLASHsubfile] = ACTIONS(6374),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6374),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6374),
    [anon_sym_BSLASHbibliography] = ACTIONS(6374),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6374),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6374),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6374),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6374),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6374),
    [anon_sym_BSLASHimport] = ACTIONS(6374),
    [anon_sym_BSLASHsubimport] = ACTIONS(6374),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6374),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6374),
    [anon_sym_BSLASHcaption] = ACTIONS(6374),
    [anon_sym_BSLASHcite] = ACTIONS(6374),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCite] = ACTIONS(6374),
    [anon_sym_BSLASHnocite] = ACTIONS(6374),
    [anon_sym_BSLASHcitet] = ACTIONS(6374),
    [anon_sym_BSLASHcitep] = ACTIONS(6374),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteA] = ACTIONS(6374),
    [anon_sym_BSLASHciteR] = ACTIONS(6374),
    [anon_sym_BSLASHciteS] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6374),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6374),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteyear] = ACTIONS(6374),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHcitedate] = ACTIONS(6374),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHciteurl] = ACTIONS(6374),
    [anon_sym_BSLASHfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6374),
    [anon_sym_BSLASHcitealt] = ACTIONS(6374),
    [anon_sym_BSLASHcitealp] = ACTIONS(6374),
    [anon_sym_BSLASHcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHparencite] = ACTIONS(6374),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHParencite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6374),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6374),
    [anon_sym_BSLASHtextcite] = ACTIONS(6374),
    [anon_sym_BSLASHTextcite] = ACTIONS(6374),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6374),
    [anon_sym_BSLASHsupercite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite] = ACTIONS(6374),
    [anon_sym_BSLASHAutocite] = ACTIONS(6374),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHVolcite] = ACTIONS(6374),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHavolcite] = ACTIONS(6374),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6374),
    [anon_sym_BSLASHnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHNotecite] = ACTIONS(6374),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6374),
    [anon_sym_BSLASHlabel] = ACTIONS(6374),
    [anon_sym_BSLASHref] = ACTIONS(6374),
    [anon_sym_BSLASHeqref] = ACTIONS(6374),
    [anon_sym_BSLASHvref] = ACTIONS(6374),
    [anon_sym_BSLASHVref] = ACTIONS(6374),
    [anon_sym_BSLASHautoref] = ACTIONS(6374),
    [anon_sym_BSLASHpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcref] = ACTIONS(6374),
    [anon_sym_BSLASHCref] = ACTIONS(6374),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnameCref] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6374),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6374),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6374),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6374),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6374),
    [anon_sym_BSLASHdef] = ACTIONS(6374),
    [anon_sym_BSLASHlet] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6374),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6374),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6374),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6374),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6374),
    [anon_sym_BSLASHgls] = ACTIONS(6374),
    [anon_sym_BSLASHGls] = ACTIONS(6374),
    [anon_sym_BSLASHGLS] = ACTIONS(6374),
    [anon_sym_BSLASHglspl] = ACTIONS(6374),
    [anon_sym_BSLASHGlspl] = ACTIONS(6374),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6374),
    [anon_sym_BSLASHglslink] = ACTIONS(6374),
    [anon_sym_BSLASHglstext] = ACTIONS(6374),
    [anon_sym_BSLASHGlstext] = ACTIONS(6374),
    [anon_sym_BSLASHGLStext] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6374),
    [anon_sym_BSLASHglsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6374),
    [anon_sym_BSLASHglsname] = ACTIONS(6374),
    [anon_sym_BSLASHGlsname] = ACTIONS(6374),
    [anon_sym_BSLASHGLSname] = ACTIONS(6374),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6374),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6374),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6374),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6374),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6374),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6374),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6374),
    [anon_sym_BSLASHacrshort] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6374),
    [anon_sym_BSLASHACRshort] = ACTIONS(6374),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrlong] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6374),
    [anon_sym_BSLASHACRlong] = ACTIONS(6374),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6374),
    [anon_sym_BSLASHacrfull] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6374),
    [anon_sym_BSLASHACRfull] = ACTIONS(6374),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHacs] = ACTIONS(6374),
    [anon_sym_BSLASHAcs] = ACTIONS(6374),
    [anon_sym_BSLASHacsp] = ACTIONS(6374),
    [anon_sym_BSLASHAcsp] = ACTIONS(6374),
    [anon_sym_BSLASHacl] = ACTIONS(6374),
    [anon_sym_BSLASHAcl] = ACTIONS(6374),
    [anon_sym_BSLASHaclp] = ACTIONS(6374),
    [anon_sym_BSLASHAclp] = ACTIONS(6374),
    [anon_sym_BSLASHacf] = ACTIONS(6374),
    [anon_sym_BSLASHAcf] = ACTIONS(6374),
    [anon_sym_BSLASHacfp] = ACTIONS(6374),
    [anon_sym_BSLASHAcfp] = ACTIONS(6374),
    [anon_sym_BSLASHac] = ACTIONS(6374),
    [anon_sym_BSLASHAc] = ACTIONS(6374),
    [anon_sym_BSLASHacp] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6374),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6374),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6374),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6374),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6376),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6374),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6374),
    [anon_sym_BSLASHcolor] = ACTIONS(6374),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6374),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6374),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6374),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6374),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6374),
    [anon_sym_BSLASHurl] = ACTIONS(6374),
    [anon_sym_BSLASHhref] = ACTIONS(6374),
  },
  [2018] = {
    [sym_command_name] = ACTIONS(6362),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6362),
    [anon_sym_RBRACK] = ACTIONS(6364),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_EQ] = ACTIONS(6364),
    [anon_sym_RBRACE] = ACTIONS(6364),
    [sym_word] = ACTIONS(6362),
    [sym_placeholder] = ACTIONS(6364),
    [anon_sym_PLUS] = ACTIONS(6364),
    [anon_sym_DASH] = ACTIONS(6364),
    [anon_sym_STAR] = ACTIONS(6364),
    [anon_sym_SLASH] = ACTIONS(6364),
    [anon_sym_LT] = ACTIONS(6362),
    [anon_sym_GT] = ACTIONS(6362),
    [anon_sym_BANG] = ACTIONS(6362),
    [anon_sym_PIPE] = ACTIONS(6362),
    [anon_sym_COLON] = ACTIONS(6362),
    [anon_sym_SQUOTE] = ACTIONS(6362),
    [anon_sym__] = ACTIONS(6364),
    [anon_sym_CARET] = ACTIONS(6364),
    [anon_sym_BSLASHtitle] = ACTIONS(6362),
    [anon_sym_BSLASHauthor] = ACTIONS(6362),
    [anon_sym_BSLASHusepackage] = ACTIONS(6362),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6362),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6362),
    [anon_sym_BSLASHinclude] = ACTIONS(6362),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6362),
    [anon_sym_BSLASHinput] = ACTIONS(6362),
    [anon_sym_BSLASHsubfile] = ACTIONS(6362),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6362),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6362),
    [anon_sym_BSLASHbibliography] = ACTIONS(6362),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6362),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6362),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6362),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6362),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6362),
    [anon_sym_BSLASHimport] = ACTIONS(6362),
    [anon_sym_BSLASHsubimport] = ACTIONS(6362),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6362),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6362),
    [anon_sym_BSLASHcaption] = ACTIONS(6362),
    [anon_sym_BSLASHcite] = ACTIONS(6362),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCite] = ACTIONS(6362),
    [anon_sym_BSLASHnocite] = ACTIONS(6362),
    [anon_sym_BSLASHcitet] = ACTIONS(6362),
    [anon_sym_BSLASHcitep] = ACTIONS(6362),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteA] = ACTIONS(6362),
    [anon_sym_BSLASHciteR] = ACTIONS(6362),
    [anon_sym_BSLASHciteS] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6362),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6362),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteyear] = ACTIONS(6362),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHcitedate] = ACTIONS(6362),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHciteurl] = ACTIONS(6362),
    [anon_sym_BSLASHfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6362),
    [anon_sym_BSLASHcitealt] = ACTIONS(6362),
    [anon_sym_BSLASHcitealp] = ACTIONS(6362),
    [anon_sym_BSLASHcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHparencite] = ACTIONS(6362),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHParencite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6362),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6362),
    [anon_sym_BSLASHtextcite] = ACTIONS(6362),
    [anon_sym_BSLASHTextcite] = ACTIONS(6362),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6362),
    [anon_sym_BSLASHsupercite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite] = ACTIONS(6362),
    [anon_sym_BSLASHAutocite] = ACTIONS(6362),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHVolcite] = ACTIONS(6362),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHavolcite] = ACTIONS(6362),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6362),
    [anon_sym_BSLASHnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHNotecite] = ACTIONS(6362),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6362),
    [anon_sym_BSLASHlabel] = ACTIONS(6362),
    [anon_sym_BSLASHref] = ACTIONS(6362),
    [anon_sym_BSLASHeqref] = ACTIONS(6362),
    [anon_sym_BSLASHvref] = ACTIONS(6362),
    [anon_sym_BSLASHVref] = ACTIONS(6362),
    [anon_sym_BSLASHautoref] = ACTIONS(6362),
    [anon_sym_BSLASHpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcref] = ACTIONS(6362),
    [anon_sym_BSLASHCref] = ACTIONS(6362),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnameCref] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6362),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6362),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6362),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6362),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6362),
    [anon_sym_BSLASHdef] = ACTIONS(6362),
    [anon_sym_BSLASHlet] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6362),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6362),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6362),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6362),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6362),
    [anon_sym_BSLASHgls] = ACTIONS(6362),
    [anon_sym_BSLASHGls] = ACTIONS(6362),
    [anon_sym_BSLASHGLS] = ACTIONS(6362),
    [anon_sym_BSLASHglspl] = ACTIONS(6362),
    [anon_sym_BSLASHGlspl] = ACTIONS(6362),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6362),
    [anon_sym_BSLASHglslink] = ACTIONS(6362),
    [anon_sym_BSLASHglstext] = ACTIONS(6362),
    [anon_sym_BSLASHGlstext] = ACTIONS(6362),
    [anon_sym_BSLASHGLStext] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6362),
    [anon_sym_BSLASHglsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6362),
    [anon_sym_BSLASHglsname] = ACTIONS(6362),
    [anon_sym_BSLASHGlsname] = ACTIONS(6362),
    [anon_sym_BSLASHGLSname] = ACTIONS(6362),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6362),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6362),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6362),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6362),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6362),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6362),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6362),
    [anon_sym_BSLASHacrshort] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6362),
    [anon_sym_BSLASHACRshort] = ACTIONS(6362),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrlong] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6362),
    [anon_sym_BSLASHACRlong] = ACTIONS(6362),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6362),
    [anon_sym_BSLASHacrfull] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6362),
    [anon_sym_BSLASHACRfull] = ACTIONS(6362),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHacs] = ACTIONS(6362),
    [anon_sym_BSLASHAcs] = ACTIONS(6362),
    [anon_sym_BSLASHacsp] = ACTIONS(6362),
    [anon_sym_BSLASHAcsp] = ACTIONS(6362),
    [anon_sym_BSLASHacl] = ACTIONS(6362),
    [anon_sym_BSLASHAcl] = ACTIONS(6362),
    [anon_sym_BSLASHaclp] = ACTIONS(6362),
    [anon_sym_BSLASHAclp] = ACTIONS(6362),
    [anon_sym_BSLASHacf] = ACTIONS(6362),
    [anon_sym_BSLASHAcf] = ACTIONS(6362),
    [anon_sym_BSLASHacfp] = ACTIONS(6362),
    [anon_sym_BSLASHAcfp] = ACTIONS(6362),
    [anon_sym_BSLASHac] = ACTIONS(6362),
    [anon_sym_BSLASHAc] = ACTIONS(6362),
    [anon_sym_BSLASHacp] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6362),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6362),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6362),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6362),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6364),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6362),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6362),
    [anon_sym_BSLASHcolor] = ACTIONS(6362),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6362),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6362),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6362),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6362),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6362),
    [anon_sym_BSLASHurl] = ACTIONS(6362),
    [anon_sym_BSLASHhref] = ACTIONS(6362),
  },
  [2019] = {
    [sym_command_name] = ACTIONS(6354),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6354),
    [anon_sym_RBRACK] = ACTIONS(6356),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_EQ] = ACTIONS(6356),
    [anon_sym_RBRACE] = ACTIONS(6356),
    [sym_word] = ACTIONS(6354),
    [sym_placeholder] = ACTIONS(6356),
    [anon_sym_PLUS] = ACTIONS(6356),
    [anon_sym_DASH] = ACTIONS(6356),
    [anon_sym_STAR] = ACTIONS(6356),
    [anon_sym_SLASH] = ACTIONS(6356),
    [anon_sym_LT] = ACTIONS(6354),
    [anon_sym_GT] = ACTIONS(6354),
    [anon_sym_BANG] = ACTIONS(6354),
    [anon_sym_PIPE] = ACTIONS(6354),
    [anon_sym_COLON] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6354),
    [anon_sym__] = ACTIONS(6356),
    [anon_sym_CARET] = ACTIONS(6356),
    [anon_sym_BSLASHtitle] = ACTIONS(6354),
    [anon_sym_BSLASHauthor] = ACTIONS(6354),
    [anon_sym_BSLASHusepackage] = ACTIONS(6354),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6354),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6354),
    [anon_sym_BSLASHinclude] = ACTIONS(6354),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6354),
    [anon_sym_BSLASHinput] = ACTIONS(6354),
    [anon_sym_BSLASHsubfile] = ACTIONS(6354),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6354),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6354),
    [anon_sym_BSLASHbibliography] = ACTIONS(6354),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6354),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6354),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6354),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6354),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6354),
    [anon_sym_BSLASHimport] = ACTIONS(6354),
    [anon_sym_BSLASHsubimport] = ACTIONS(6354),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6354),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6354),
    [anon_sym_BSLASHcaption] = ACTIONS(6354),
    [anon_sym_BSLASHcite] = ACTIONS(6354),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCite] = ACTIONS(6354),
    [anon_sym_BSLASHnocite] = ACTIONS(6354),
    [anon_sym_BSLASHcitet] = ACTIONS(6354),
    [anon_sym_BSLASHcitep] = ACTIONS(6354),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteA] = ACTIONS(6354),
    [anon_sym_BSLASHciteR] = ACTIONS(6354),
    [anon_sym_BSLASHciteS] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6354),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6354),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteyear] = ACTIONS(6354),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHcitedate] = ACTIONS(6354),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHciteurl] = ACTIONS(6354),
    [anon_sym_BSLASHfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6354),
    [anon_sym_BSLASHcitealt] = ACTIONS(6354),
    [anon_sym_BSLASHcitealp] = ACTIONS(6354),
    [anon_sym_BSLASHcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHparencite] = ACTIONS(6354),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHParencite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6354),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6354),
    [anon_sym_BSLASHtextcite] = ACTIONS(6354),
    [anon_sym_BSLASHTextcite] = ACTIONS(6354),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6354),
    [anon_sym_BSLASHsupercite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite] = ACTIONS(6354),
    [anon_sym_BSLASHAutocite] = ACTIONS(6354),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHVolcite] = ACTIONS(6354),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHavolcite] = ACTIONS(6354),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6354),
    [anon_sym_BSLASHnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHNotecite] = ACTIONS(6354),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6354),
    [anon_sym_BSLASHlabel] = ACTIONS(6354),
    [anon_sym_BSLASHref] = ACTIONS(6354),
    [anon_sym_BSLASHeqref] = ACTIONS(6354),
    [anon_sym_BSLASHvref] = ACTIONS(6354),
    [anon_sym_BSLASHVref] = ACTIONS(6354),
    [anon_sym_BSLASHautoref] = ACTIONS(6354),
    [anon_sym_BSLASHpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcref] = ACTIONS(6354),
    [anon_sym_BSLASHCref] = ACTIONS(6354),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnameCref] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6354),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6354),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6354),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6354),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6354),
    [anon_sym_BSLASHdef] = ACTIONS(6354),
    [anon_sym_BSLASHlet] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6354),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6354),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6354),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6354),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6354),
    [anon_sym_BSLASHgls] = ACTIONS(6354),
    [anon_sym_BSLASHGls] = ACTIONS(6354),
    [anon_sym_BSLASHGLS] = ACTIONS(6354),
    [anon_sym_BSLASHglspl] = ACTIONS(6354),
    [anon_sym_BSLASHGlspl] = ACTIONS(6354),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6354),
    [anon_sym_BSLASHglslink] = ACTIONS(6354),
    [anon_sym_BSLASHglstext] = ACTIONS(6354),
    [anon_sym_BSLASHGlstext] = ACTIONS(6354),
    [anon_sym_BSLASHGLStext] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6354),
    [anon_sym_BSLASHglsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6354),
    [anon_sym_BSLASHglsname] = ACTIONS(6354),
    [anon_sym_BSLASHGlsname] = ACTIONS(6354),
    [anon_sym_BSLASHGLSname] = ACTIONS(6354),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6354),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6354),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6354),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6354),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6354),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6354),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6354),
    [anon_sym_BSLASHacrshort] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6354),
    [anon_sym_BSLASHACRshort] = ACTIONS(6354),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrlong] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6354),
    [anon_sym_BSLASHACRlong] = ACTIONS(6354),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6354),
    [anon_sym_BSLASHacrfull] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6354),
    [anon_sym_BSLASHACRfull] = ACTIONS(6354),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHacs] = ACTIONS(6354),
    [anon_sym_BSLASHAcs] = ACTIONS(6354),
    [anon_sym_BSLASHacsp] = ACTIONS(6354),
    [anon_sym_BSLASHAcsp] = ACTIONS(6354),
    [anon_sym_BSLASHacl] = ACTIONS(6354),
    [anon_sym_BSLASHAcl] = ACTIONS(6354),
    [anon_sym_BSLASHaclp] = ACTIONS(6354),
    [anon_sym_BSLASHAclp] = ACTIONS(6354),
    [anon_sym_BSLASHacf] = ACTIONS(6354),
    [anon_sym_BSLASHAcf] = ACTIONS(6354),
    [anon_sym_BSLASHacfp] = ACTIONS(6354),
    [anon_sym_BSLASHAcfp] = ACTIONS(6354),
    [anon_sym_BSLASHac] = ACTIONS(6354),
    [anon_sym_BSLASHAc] = ACTIONS(6354),
    [anon_sym_BSLASHacp] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6354),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6354),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6354),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6354),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6356),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6354),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6354),
    [anon_sym_BSLASHcolor] = ACTIONS(6354),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6354),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6354),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6354),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6354),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6354),
    [anon_sym_BSLASHurl] = ACTIONS(6354),
    [anon_sym_BSLASHhref] = ACTIONS(6354),
  },
  [2020] = {
    [sym_command_name] = ACTIONS(6522),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6522),
    [anon_sym_RBRACK] = ACTIONS(6524),
    [anon_sym_COMMA] = ACTIONS(6524),
    [anon_sym_EQ] = ACTIONS(6524),
    [anon_sym_RBRACE] = ACTIONS(6524),
    [sym_word] = ACTIONS(6522),
    [sym_placeholder] = ACTIONS(6524),
    [anon_sym_PLUS] = ACTIONS(6524),
    [anon_sym_DASH] = ACTIONS(6524),
    [anon_sym_STAR] = ACTIONS(6524),
    [anon_sym_SLASH] = ACTIONS(6524),
    [anon_sym_LT] = ACTIONS(6522),
    [anon_sym_GT] = ACTIONS(6522),
    [anon_sym_BANG] = ACTIONS(6522),
    [anon_sym_PIPE] = ACTIONS(6522),
    [anon_sym_COLON] = ACTIONS(6522),
    [anon_sym_SQUOTE] = ACTIONS(6522),
    [anon_sym__] = ACTIONS(6524),
    [anon_sym_CARET] = ACTIONS(6524),
    [anon_sym_BSLASHtitle] = ACTIONS(6522),
    [anon_sym_BSLASHauthor] = ACTIONS(6522),
    [anon_sym_BSLASHusepackage] = ACTIONS(6522),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6522),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6522),
    [anon_sym_BSLASHinclude] = ACTIONS(6522),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6522),
    [anon_sym_BSLASHinput] = ACTIONS(6522),
    [anon_sym_BSLASHsubfile] = ACTIONS(6522),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6522),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6522),
    [anon_sym_BSLASHbibliography] = ACTIONS(6522),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6522),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6522),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6522),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6522),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6522),
    [anon_sym_BSLASHimport] = ACTIONS(6522),
    [anon_sym_BSLASHsubimport] = ACTIONS(6522),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6522),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6522),
    [anon_sym_BSLASHcaption] = ACTIONS(6522),
    [anon_sym_BSLASHcite] = ACTIONS(6522),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCite] = ACTIONS(6522),
    [anon_sym_BSLASHnocite] = ACTIONS(6522),
    [anon_sym_BSLASHcitet] = ACTIONS(6522),
    [anon_sym_BSLASHcitep] = ACTIONS(6522),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteA] = ACTIONS(6522),
    [anon_sym_BSLASHciteR] = ACTIONS(6522),
    [anon_sym_BSLASHciteS] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6522),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6522),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteyear] = ACTIONS(6522),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHcitedate] = ACTIONS(6522),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHciteurl] = ACTIONS(6522),
    [anon_sym_BSLASHfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6522),
    [anon_sym_BSLASHcitealt] = ACTIONS(6522),
    [anon_sym_BSLASHcitealp] = ACTIONS(6522),
    [anon_sym_BSLASHcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHparencite] = ACTIONS(6522),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHParencite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6522),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6522),
    [anon_sym_BSLASHtextcite] = ACTIONS(6522),
    [anon_sym_BSLASHTextcite] = ACTIONS(6522),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6522),
    [anon_sym_BSLASHsupercite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite] = ACTIONS(6522),
    [anon_sym_BSLASHAutocite] = ACTIONS(6522),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHVolcite] = ACTIONS(6522),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHavolcite] = ACTIONS(6522),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6522),
    [anon_sym_BSLASHnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHNotecite] = ACTIONS(6522),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6522),
    [anon_sym_BSLASHlabel] = ACTIONS(6522),
    [anon_sym_BSLASHref] = ACTIONS(6522),
    [anon_sym_BSLASHeqref] = ACTIONS(6522),
    [anon_sym_BSLASHvref] = ACTIONS(6522),
    [anon_sym_BSLASHVref] = ACTIONS(6522),
    [anon_sym_BSLASHautoref] = ACTIONS(6522),
    [anon_sym_BSLASHpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcref] = ACTIONS(6522),
    [anon_sym_BSLASHCref] = ACTIONS(6522),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnameCref] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6522),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6522),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6522),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6522),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6522),
    [anon_sym_BSLASHdef] = ACTIONS(6522),
    [anon_sym_BSLASHlet] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6522),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6522),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6522),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6522),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6522),
    [anon_sym_BSLASHgls] = ACTIONS(6522),
    [anon_sym_BSLASHGls] = ACTIONS(6522),
    [anon_sym_BSLASHGLS] = ACTIONS(6522),
    [anon_sym_BSLASHglspl] = ACTIONS(6522),
    [anon_sym_BSLASHGlspl] = ACTIONS(6522),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6522),
    [anon_sym_BSLASHglslink] = ACTIONS(6522),
    [anon_sym_BSLASHglstext] = ACTIONS(6522),
    [anon_sym_BSLASHGlstext] = ACTIONS(6522),
    [anon_sym_BSLASHGLStext] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6522),
    [anon_sym_BSLASHglsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6522),
    [anon_sym_BSLASHglsname] = ACTIONS(6522),
    [anon_sym_BSLASHGlsname] = ACTIONS(6522),
    [anon_sym_BSLASHGLSname] = ACTIONS(6522),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6522),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6522),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6522),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6522),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6522),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6522),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6522),
    [anon_sym_BSLASHacrshort] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6522),
    [anon_sym_BSLASHACRshort] = ACTIONS(6522),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrlong] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6522),
    [anon_sym_BSLASHACRlong] = ACTIONS(6522),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6522),
    [anon_sym_BSLASHacrfull] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6522),
    [anon_sym_BSLASHACRfull] = ACTIONS(6522),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHacs] = ACTIONS(6522),
    [anon_sym_BSLASHAcs] = ACTIONS(6522),
    [anon_sym_BSLASHacsp] = ACTIONS(6522),
    [anon_sym_BSLASHAcsp] = ACTIONS(6522),
    [anon_sym_BSLASHacl] = ACTIONS(6522),
    [anon_sym_BSLASHAcl] = ACTIONS(6522),
    [anon_sym_BSLASHaclp] = ACTIONS(6522),
    [anon_sym_BSLASHAclp] = ACTIONS(6522),
    [anon_sym_BSLASHacf] = ACTIONS(6522),
    [anon_sym_BSLASHAcf] = ACTIONS(6522),
    [anon_sym_BSLASHacfp] = ACTIONS(6522),
    [anon_sym_BSLASHAcfp] = ACTIONS(6522),
    [anon_sym_BSLASHac] = ACTIONS(6522),
    [anon_sym_BSLASHAc] = ACTIONS(6522),
    [anon_sym_BSLASHacp] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6522),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6522),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6522),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6522),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6524),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6522),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6522),
    [anon_sym_BSLASHcolor] = ACTIONS(6522),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6522),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6522),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6522),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6522),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6522),
    [anon_sym_BSLASHurl] = ACTIONS(6522),
    [anon_sym_BSLASHhref] = ACTIONS(6522),
  },
  [2021] = {
    [sym_command_name] = ACTIONS(6298),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6298),
    [anon_sym_RBRACK] = ACTIONS(6300),
    [anon_sym_COMMA] = ACTIONS(6300),
    [anon_sym_EQ] = ACTIONS(6300),
    [anon_sym_RBRACE] = ACTIONS(6300),
    [sym_word] = ACTIONS(6298),
    [sym_placeholder] = ACTIONS(6300),
    [anon_sym_PLUS] = ACTIONS(6300),
    [anon_sym_DASH] = ACTIONS(6300),
    [anon_sym_STAR] = ACTIONS(6300),
    [anon_sym_SLASH] = ACTIONS(6300),
    [anon_sym_LT] = ACTIONS(6298),
    [anon_sym_GT] = ACTIONS(6298),
    [anon_sym_BANG] = ACTIONS(6298),
    [anon_sym_PIPE] = ACTIONS(6298),
    [anon_sym_COLON] = ACTIONS(6298),
    [anon_sym_SQUOTE] = ACTIONS(6298),
    [anon_sym__] = ACTIONS(6300),
    [anon_sym_CARET] = ACTIONS(6300),
    [anon_sym_BSLASHtitle] = ACTIONS(6298),
    [anon_sym_BSLASHauthor] = ACTIONS(6298),
    [anon_sym_BSLASHusepackage] = ACTIONS(6298),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6298),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6298),
    [anon_sym_BSLASHinclude] = ACTIONS(6298),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6298),
    [anon_sym_BSLASHinput] = ACTIONS(6298),
    [anon_sym_BSLASHsubfile] = ACTIONS(6298),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6298),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6298),
    [anon_sym_BSLASHbibliography] = ACTIONS(6298),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6298),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6298),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6298),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6298),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6298),
    [anon_sym_BSLASHimport] = ACTIONS(6298),
    [anon_sym_BSLASHsubimport] = ACTIONS(6298),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6298),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6298),
    [anon_sym_BSLASHcaption] = ACTIONS(6298),
    [anon_sym_BSLASHcite] = ACTIONS(6298),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCite] = ACTIONS(6298),
    [anon_sym_BSLASHnocite] = ACTIONS(6298),
    [anon_sym_BSLASHcitet] = ACTIONS(6298),
    [anon_sym_BSLASHcitep] = ACTIONS(6298),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteA] = ACTIONS(6298),
    [anon_sym_BSLASHciteR] = ACTIONS(6298),
    [anon_sym_BSLASHciteS] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6298),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6298),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteyear] = ACTIONS(6298),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHcitedate] = ACTIONS(6298),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHciteurl] = ACTIONS(6298),
    [anon_sym_BSLASHfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6298),
    [anon_sym_BSLASHcitealt] = ACTIONS(6298),
    [anon_sym_BSLASHcitealp] = ACTIONS(6298),
    [anon_sym_BSLASHcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHparencite] = ACTIONS(6298),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHParencite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6298),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6298),
    [anon_sym_BSLASHtextcite] = ACTIONS(6298),
    [anon_sym_BSLASHTextcite] = ACTIONS(6298),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6298),
    [anon_sym_BSLASHsupercite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite] = ACTIONS(6298),
    [anon_sym_BSLASHAutocite] = ACTIONS(6298),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHVolcite] = ACTIONS(6298),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHavolcite] = ACTIONS(6298),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6298),
    [anon_sym_BSLASHnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHNotecite] = ACTIONS(6298),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6298),
    [anon_sym_BSLASHlabel] = ACTIONS(6298),
    [anon_sym_BSLASHref] = ACTIONS(6298),
    [anon_sym_BSLASHeqref] = ACTIONS(6298),
    [anon_sym_BSLASHvref] = ACTIONS(6298),
    [anon_sym_BSLASHVref] = ACTIONS(6298),
    [anon_sym_BSLASHautoref] = ACTIONS(6298),
    [anon_sym_BSLASHpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcref] = ACTIONS(6298),
    [anon_sym_BSLASHCref] = ACTIONS(6298),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnameCref] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6298),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6298),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6298),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6298),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6298),
    [anon_sym_BSLASHdef] = ACTIONS(6298),
    [anon_sym_BSLASHlet] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6298),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6298),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6298),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6298),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6298),
    [anon_sym_BSLASHgls] = ACTIONS(6298),
    [anon_sym_BSLASHGls] = ACTIONS(6298),
    [anon_sym_BSLASHGLS] = ACTIONS(6298),
    [anon_sym_BSLASHglspl] = ACTIONS(6298),
    [anon_sym_BSLASHGlspl] = ACTIONS(6298),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6298),
    [anon_sym_BSLASHglslink] = ACTIONS(6298),
    [anon_sym_BSLASHglstext] = ACTIONS(6298),
    [anon_sym_BSLASHGlstext] = ACTIONS(6298),
    [anon_sym_BSLASHGLStext] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6298),
    [anon_sym_BSLASHglsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6298),
    [anon_sym_BSLASHglsname] = ACTIONS(6298),
    [anon_sym_BSLASHGlsname] = ACTIONS(6298),
    [anon_sym_BSLASHGLSname] = ACTIONS(6298),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6298),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6298),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6298),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6298),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6298),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6298),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6298),
    [anon_sym_BSLASHacrshort] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6298),
    [anon_sym_BSLASHACRshort] = ACTIONS(6298),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrlong] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6298),
    [anon_sym_BSLASHACRlong] = ACTIONS(6298),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6298),
    [anon_sym_BSLASHacrfull] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6298),
    [anon_sym_BSLASHACRfull] = ACTIONS(6298),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHacs] = ACTIONS(6298),
    [anon_sym_BSLASHAcs] = ACTIONS(6298),
    [anon_sym_BSLASHacsp] = ACTIONS(6298),
    [anon_sym_BSLASHAcsp] = ACTIONS(6298),
    [anon_sym_BSLASHacl] = ACTIONS(6298),
    [anon_sym_BSLASHAcl] = ACTIONS(6298),
    [anon_sym_BSLASHaclp] = ACTIONS(6298),
    [anon_sym_BSLASHAclp] = ACTIONS(6298),
    [anon_sym_BSLASHacf] = ACTIONS(6298),
    [anon_sym_BSLASHAcf] = ACTIONS(6298),
    [anon_sym_BSLASHacfp] = ACTIONS(6298),
    [anon_sym_BSLASHAcfp] = ACTIONS(6298),
    [anon_sym_BSLASHac] = ACTIONS(6298),
    [anon_sym_BSLASHAc] = ACTIONS(6298),
    [anon_sym_BSLASHacp] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6298),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6298),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6298),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6298),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6300),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6298),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6298),
    [anon_sym_BSLASHcolor] = ACTIONS(6298),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6298),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6298),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6298),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6298),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6298),
    [anon_sym_BSLASHurl] = ACTIONS(6298),
    [anon_sym_BSLASHhref] = ACTIONS(6298),
  },
  [2022] = {
    [sym_command_name] = ACTIONS(6586),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6586),
    [anon_sym_RBRACK] = ACTIONS(6588),
    [anon_sym_COMMA] = ACTIONS(6588),
    [anon_sym_EQ] = ACTIONS(6588),
    [anon_sym_RBRACE] = ACTIONS(6588),
    [sym_word] = ACTIONS(6586),
    [sym_placeholder] = ACTIONS(6588),
    [anon_sym_PLUS] = ACTIONS(6588),
    [anon_sym_DASH] = ACTIONS(6588),
    [anon_sym_STAR] = ACTIONS(6588),
    [anon_sym_SLASH] = ACTIONS(6588),
    [anon_sym_LT] = ACTIONS(6586),
    [anon_sym_GT] = ACTIONS(6586),
    [anon_sym_BANG] = ACTIONS(6586),
    [anon_sym_PIPE] = ACTIONS(6586),
    [anon_sym_COLON] = ACTIONS(6586),
    [anon_sym_SQUOTE] = ACTIONS(6586),
    [anon_sym__] = ACTIONS(6588),
    [anon_sym_CARET] = ACTIONS(6588),
    [anon_sym_BSLASHtitle] = ACTIONS(6586),
    [anon_sym_BSLASHauthor] = ACTIONS(6586),
    [anon_sym_BSLASHusepackage] = ACTIONS(6586),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6586),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6586),
    [anon_sym_BSLASHinclude] = ACTIONS(6586),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6586),
    [anon_sym_BSLASHinput] = ACTIONS(6586),
    [anon_sym_BSLASHsubfile] = ACTIONS(6586),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6586),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6586),
    [anon_sym_BSLASHbibliography] = ACTIONS(6586),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6586),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6586),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6586),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6586),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6586),
    [anon_sym_BSLASHimport] = ACTIONS(6586),
    [anon_sym_BSLASHsubimport] = ACTIONS(6586),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6586),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6586),
    [anon_sym_BSLASHcaption] = ACTIONS(6586),
    [anon_sym_BSLASHcite] = ACTIONS(6586),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCite] = ACTIONS(6586),
    [anon_sym_BSLASHnocite] = ACTIONS(6586),
    [anon_sym_BSLASHcitet] = ACTIONS(6586),
    [anon_sym_BSLASHcitep] = ACTIONS(6586),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteA] = ACTIONS(6586),
    [anon_sym_BSLASHciteR] = ACTIONS(6586),
    [anon_sym_BSLASHciteS] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6586),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6586),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteyear] = ACTIONS(6586),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHcitedate] = ACTIONS(6586),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHciteurl] = ACTIONS(6586),
    [anon_sym_BSLASHfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6586),
    [anon_sym_BSLASHcitealt] = ACTIONS(6586),
    [anon_sym_BSLASHcitealp] = ACTIONS(6586),
    [anon_sym_BSLASHcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHparencite] = ACTIONS(6586),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHParencite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6586),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6586),
    [anon_sym_BSLASHtextcite] = ACTIONS(6586),
    [anon_sym_BSLASHTextcite] = ACTIONS(6586),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6586),
    [anon_sym_BSLASHsupercite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite] = ACTIONS(6586),
    [anon_sym_BSLASHAutocite] = ACTIONS(6586),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHVolcite] = ACTIONS(6586),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHavolcite] = ACTIONS(6586),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6586),
    [anon_sym_BSLASHnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHNotecite] = ACTIONS(6586),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6586),
    [anon_sym_BSLASHlabel] = ACTIONS(6586),
    [anon_sym_BSLASHref] = ACTIONS(6586),
    [anon_sym_BSLASHeqref] = ACTIONS(6586),
    [anon_sym_BSLASHvref] = ACTIONS(6586),
    [anon_sym_BSLASHVref] = ACTIONS(6586),
    [anon_sym_BSLASHautoref] = ACTIONS(6586),
    [anon_sym_BSLASHpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcref] = ACTIONS(6586),
    [anon_sym_BSLASHCref] = ACTIONS(6586),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnameCref] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6586),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6586),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6586),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6586),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6586),
    [anon_sym_BSLASHdef] = ACTIONS(6586),
    [anon_sym_BSLASHlet] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6586),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6586),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6586),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6586),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6586),
    [anon_sym_BSLASHgls] = ACTIONS(6586),
    [anon_sym_BSLASHGls] = ACTIONS(6586),
    [anon_sym_BSLASHGLS] = ACTIONS(6586),
    [anon_sym_BSLASHglspl] = ACTIONS(6586),
    [anon_sym_BSLASHGlspl] = ACTIONS(6586),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6586),
    [anon_sym_BSLASHglslink] = ACTIONS(6586),
    [anon_sym_BSLASHglstext] = ACTIONS(6586),
    [anon_sym_BSLASHGlstext] = ACTIONS(6586),
    [anon_sym_BSLASHGLStext] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6586),
    [anon_sym_BSLASHglsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6586),
    [anon_sym_BSLASHglsname] = ACTIONS(6586),
    [anon_sym_BSLASHGlsname] = ACTIONS(6586),
    [anon_sym_BSLASHGLSname] = ACTIONS(6586),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6586),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6586),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6586),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6586),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6586),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6586),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6586),
    [anon_sym_BSLASHacrshort] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6586),
    [anon_sym_BSLASHACRshort] = ACTIONS(6586),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrlong] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6586),
    [anon_sym_BSLASHACRlong] = ACTIONS(6586),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6586),
    [anon_sym_BSLASHacrfull] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6586),
    [anon_sym_BSLASHACRfull] = ACTIONS(6586),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHacs] = ACTIONS(6586),
    [anon_sym_BSLASHAcs] = ACTIONS(6586),
    [anon_sym_BSLASHacsp] = ACTIONS(6586),
    [anon_sym_BSLASHAcsp] = ACTIONS(6586),
    [anon_sym_BSLASHacl] = ACTIONS(6586),
    [anon_sym_BSLASHAcl] = ACTIONS(6586),
    [anon_sym_BSLASHaclp] = ACTIONS(6586),
    [anon_sym_BSLASHAclp] = ACTIONS(6586),
    [anon_sym_BSLASHacf] = ACTIONS(6586),
    [anon_sym_BSLASHAcf] = ACTIONS(6586),
    [anon_sym_BSLASHacfp] = ACTIONS(6586),
    [anon_sym_BSLASHAcfp] = ACTIONS(6586),
    [anon_sym_BSLASHac] = ACTIONS(6586),
    [anon_sym_BSLASHAc] = ACTIONS(6586),
    [anon_sym_BSLASHacp] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6586),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6586),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6586),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6586),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6588),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6586),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6586),
    [anon_sym_BSLASHcolor] = ACTIONS(6586),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6586),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6586),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6586),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6586),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6586),
    [anon_sym_BSLASHurl] = ACTIONS(6586),
    [anon_sym_BSLASHhref] = ACTIONS(6586),
  },
  [2023] = {
    [sym_command_name] = ACTIONS(6302),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6302),
    [anon_sym_RBRACK] = ACTIONS(6304),
    [anon_sym_COMMA] = ACTIONS(6304),
    [anon_sym_EQ] = ACTIONS(6304),
    [anon_sym_RBRACE] = ACTIONS(6304),
    [sym_word] = ACTIONS(6302),
    [sym_placeholder] = ACTIONS(6304),
    [anon_sym_PLUS] = ACTIONS(6304),
    [anon_sym_DASH] = ACTIONS(6304),
    [anon_sym_STAR] = ACTIONS(6304),
    [anon_sym_SLASH] = ACTIONS(6304),
    [anon_sym_LT] = ACTIONS(6302),
    [anon_sym_GT] = ACTIONS(6302),
    [anon_sym_BANG] = ACTIONS(6302),
    [anon_sym_PIPE] = ACTIONS(6302),
    [anon_sym_COLON] = ACTIONS(6302),
    [anon_sym_SQUOTE] = ACTIONS(6302),
    [anon_sym__] = ACTIONS(6304),
    [anon_sym_CARET] = ACTIONS(6304),
    [anon_sym_BSLASHtitle] = ACTIONS(6302),
    [anon_sym_BSLASHauthor] = ACTIONS(6302),
    [anon_sym_BSLASHusepackage] = ACTIONS(6302),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6302),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6302),
    [anon_sym_BSLASHinclude] = ACTIONS(6302),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6302),
    [anon_sym_BSLASHinput] = ACTIONS(6302),
    [anon_sym_BSLASHsubfile] = ACTIONS(6302),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6302),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6302),
    [anon_sym_BSLASHbibliography] = ACTIONS(6302),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6302),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6302),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6302),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6302),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6302),
    [anon_sym_BSLASHimport] = ACTIONS(6302),
    [anon_sym_BSLASHsubimport] = ACTIONS(6302),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6302),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6302),
    [anon_sym_BSLASHcaption] = ACTIONS(6302),
    [anon_sym_BSLASHcite] = ACTIONS(6302),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCite] = ACTIONS(6302),
    [anon_sym_BSLASHnocite] = ACTIONS(6302),
    [anon_sym_BSLASHcitet] = ACTIONS(6302),
    [anon_sym_BSLASHcitep] = ACTIONS(6302),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteA] = ACTIONS(6302),
    [anon_sym_BSLASHciteR] = ACTIONS(6302),
    [anon_sym_BSLASHciteS] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6302),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6302),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteyear] = ACTIONS(6302),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHcitedate] = ACTIONS(6302),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHciteurl] = ACTIONS(6302),
    [anon_sym_BSLASHfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6302),
    [anon_sym_BSLASHcitealt] = ACTIONS(6302),
    [anon_sym_BSLASHcitealp] = ACTIONS(6302),
    [anon_sym_BSLASHcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHparencite] = ACTIONS(6302),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHParencite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6302),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6302),
    [anon_sym_BSLASHtextcite] = ACTIONS(6302),
    [anon_sym_BSLASHTextcite] = ACTIONS(6302),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6302),
    [anon_sym_BSLASHsupercite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite] = ACTIONS(6302),
    [anon_sym_BSLASHAutocite] = ACTIONS(6302),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHVolcite] = ACTIONS(6302),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHavolcite] = ACTIONS(6302),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6302),
    [anon_sym_BSLASHnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHNotecite] = ACTIONS(6302),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6302),
    [anon_sym_BSLASHlabel] = ACTIONS(6302),
    [anon_sym_BSLASHref] = ACTIONS(6302),
    [anon_sym_BSLASHeqref] = ACTIONS(6302),
    [anon_sym_BSLASHvref] = ACTIONS(6302),
    [anon_sym_BSLASHVref] = ACTIONS(6302),
    [anon_sym_BSLASHautoref] = ACTIONS(6302),
    [anon_sym_BSLASHpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcref] = ACTIONS(6302),
    [anon_sym_BSLASHCref] = ACTIONS(6302),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnameCref] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6302),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6302),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6302),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6302),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6302),
    [anon_sym_BSLASHdef] = ACTIONS(6302),
    [anon_sym_BSLASHlet] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6302),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6302),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6302),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6302),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6302),
    [anon_sym_BSLASHgls] = ACTIONS(6302),
    [anon_sym_BSLASHGls] = ACTIONS(6302),
    [anon_sym_BSLASHGLS] = ACTIONS(6302),
    [anon_sym_BSLASHglspl] = ACTIONS(6302),
    [anon_sym_BSLASHGlspl] = ACTIONS(6302),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6302),
    [anon_sym_BSLASHglslink] = ACTIONS(6302),
    [anon_sym_BSLASHglstext] = ACTIONS(6302),
    [anon_sym_BSLASHGlstext] = ACTIONS(6302),
    [anon_sym_BSLASHGLStext] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6302),
    [anon_sym_BSLASHglsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6302),
    [anon_sym_BSLASHglsname] = ACTIONS(6302),
    [anon_sym_BSLASHGlsname] = ACTIONS(6302),
    [anon_sym_BSLASHGLSname] = ACTIONS(6302),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6302),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6302),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6302),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6302),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6302),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6302),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6302),
    [anon_sym_BSLASHacrshort] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6302),
    [anon_sym_BSLASHACRshort] = ACTIONS(6302),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrlong] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6302),
    [anon_sym_BSLASHACRlong] = ACTIONS(6302),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6302),
    [anon_sym_BSLASHacrfull] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6302),
    [anon_sym_BSLASHACRfull] = ACTIONS(6302),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHacs] = ACTIONS(6302),
    [anon_sym_BSLASHAcs] = ACTIONS(6302),
    [anon_sym_BSLASHacsp] = ACTIONS(6302),
    [anon_sym_BSLASHAcsp] = ACTIONS(6302),
    [anon_sym_BSLASHacl] = ACTIONS(6302),
    [anon_sym_BSLASHAcl] = ACTIONS(6302),
    [anon_sym_BSLASHaclp] = ACTIONS(6302),
    [anon_sym_BSLASHAclp] = ACTIONS(6302),
    [anon_sym_BSLASHacf] = ACTIONS(6302),
    [anon_sym_BSLASHAcf] = ACTIONS(6302),
    [anon_sym_BSLASHacfp] = ACTIONS(6302),
    [anon_sym_BSLASHAcfp] = ACTIONS(6302),
    [anon_sym_BSLASHac] = ACTIONS(6302),
    [anon_sym_BSLASHAc] = ACTIONS(6302),
    [anon_sym_BSLASHacp] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6302),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6302),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6302),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6302),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6304),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6302),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6302),
    [anon_sym_BSLASHcolor] = ACTIONS(6302),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6302),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6302),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6302),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6302),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6302),
    [anon_sym_BSLASHurl] = ACTIONS(6302),
    [anon_sym_BSLASHhref] = ACTIONS(6302),
  },
  [2024] = {
    [sym_command_name] = ACTIONS(6306),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6306),
    [anon_sym_RBRACK] = ACTIONS(6308),
    [anon_sym_COMMA] = ACTIONS(6308),
    [anon_sym_EQ] = ACTIONS(6308),
    [anon_sym_RBRACE] = ACTIONS(6308),
    [sym_word] = ACTIONS(6306),
    [sym_placeholder] = ACTIONS(6308),
    [anon_sym_PLUS] = ACTIONS(6308),
    [anon_sym_DASH] = ACTIONS(6308),
    [anon_sym_STAR] = ACTIONS(6308),
    [anon_sym_SLASH] = ACTIONS(6308),
    [anon_sym_LT] = ACTIONS(6306),
    [anon_sym_GT] = ACTIONS(6306),
    [anon_sym_BANG] = ACTIONS(6306),
    [anon_sym_PIPE] = ACTIONS(6306),
    [anon_sym_COLON] = ACTIONS(6306),
    [anon_sym_SQUOTE] = ACTIONS(6306),
    [anon_sym__] = ACTIONS(6308),
    [anon_sym_CARET] = ACTIONS(6308),
    [anon_sym_BSLASHtitle] = ACTIONS(6306),
    [anon_sym_BSLASHauthor] = ACTIONS(6306),
    [anon_sym_BSLASHusepackage] = ACTIONS(6306),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6306),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6306),
    [anon_sym_BSLASHinclude] = ACTIONS(6306),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6306),
    [anon_sym_BSLASHinput] = ACTIONS(6306),
    [anon_sym_BSLASHsubfile] = ACTIONS(6306),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6306),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6306),
    [anon_sym_BSLASHbibliography] = ACTIONS(6306),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6306),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6306),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6306),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6306),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6306),
    [anon_sym_BSLASHimport] = ACTIONS(6306),
    [anon_sym_BSLASHsubimport] = ACTIONS(6306),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6306),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6306),
    [anon_sym_BSLASHcaption] = ACTIONS(6306),
    [anon_sym_BSLASHcite] = ACTIONS(6306),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCite] = ACTIONS(6306),
    [anon_sym_BSLASHnocite] = ACTIONS(6306),
    [anon_sym_BSLASHcitet] = ACTIONS(6306),
    [anon_sym_BSLASHcitep] = ACTIONS(6306),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteA] = ACTIONS(6306),
    [anon_sym_BSLASHciteR] = ACTIONS(6306),
    [anon_sym_BSLASHciteS] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6306),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6306),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteyear] = ACTIONS(6306),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHcitedate] = ACTIONS(6306),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHciteurl] = ACTIONS(6306),
    [anon_sym_BSLASHfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6306),
    [anon_sym_BSLASHcitealt] = ACTIONS(6306),
    [anon_sym_BSLASHcitealp] = ACTIONS(6306),
    [anon_sym_BSLASHcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHparencite] = ACTIONS(6306),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHParencite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6306),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6306),
    [anon_sym_BSLASHtextcite] = ACTIONS(6306),
    [anon_sym_BSLASHTextcite] = ACTIONS(6306),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6306),
    [anon_sym_BSLASHsupercite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite] = ACTIONS(6306),
    [anon_sym_BSLASHAutocite] = ACTIONS(6306),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHVolcite] = ACTIONS(6306),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHavolcite] = ACTIONS(6306),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6306),
    [anon_sym_BSLASHnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHNotecite] = ACTIONS(6306),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6306),
    [anon_sym_BSLASHlabel] = ACTIONS(6306),
    [anon_sym_BSLASHref] = ACTIONS(6306),
    [anon_sym_BSLASHeqref] = ACTIONS(6306),
    [anon_sym_BSLASHvref] = ACTIONS(6306),
    [anon_sym_BSLASHVref] = ACTIONS(6306),
    [anon_sym_BSLASHautoref] = ACTIONS(6306),
    [anon_sym_BSLASHpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcref] = ACTIONS(6306),
    [anon_sym_BSLASHCref] = ACTIONS(6306),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnameCref] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6306),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6306),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6306),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6306),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6306),
    [anon_sym_BSLASHdef] = ACTIONS(6306),
    [anon_sym_BSLASHlet] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6306),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6306),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6306),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6306),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6306),
    [anon_sym_BSLASHgls] = ACTIONS(6306),
    [anon_sym_BSLASHGls] = ACTIONS(6306),
    [anon_sym_BSLASHGLS] = ACTIONS(6306),
    [anon_sym_BSLASHglspl] = ACTIONS(6306),
    [anon_sym_BSLASHGlspl] = ACTIONS(6306),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6306),
    [anon_sym_BSLASHglslink] = ACTIONS(6306),
    [anon_sym_BSLASHglstext] = ACTIONS(6306),
    [anon_sym_BSLASHGlstext] = ACTIONS(6306),
    [anon_sym_BSLASHGLStext] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6306),
    [anon_sym_BSLASHglsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6306),
    [anon_sym_BSLASHglsname] = ACTIONS(6306),
    [anon_sym_BSLASHGlsname] = ACTIONS(6306),
    [anon_sym_BSLASHGLSname] = ACTIONS(6306),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6306),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6306),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6306),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6306),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6306),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6306),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6306),
    [anon_sym_BSLASHacrshort] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6306),
    [anon_sym_BSLASHACRshort] = ACTIONS(6306),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrlong] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6306),
    [anon_sym_BSLASHACRlong] = ACTIONS(6306),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6306),
    [anon_sym_BSLASHacrfull] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6306),
    [anon_sym_BSLASHACRfull] = ACTIONS(6306),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHacs] = ACTIONS(6306),
    [anon_sym_BSLASHAcs] = ACTIONS(6306),
    [anon_sym_BSLASHacsp] = ACTIONS(6306),
    [anon_sym_BSLASHAcsp] = ACTIONS(6306),
    [anon_sym_BSLASHacl] = ACTIONS(6306),
    [anon_sym_BSLASHAcl] = ACTIONS(6306),
    [anon_sym_BSLASHaclp] = ACTIONS(6306),
    [anon_sym_BSLASHAclp] = ACTIONS(6306),
    [anon_sym_BSLASHacf] = ACTIONS(6306),
    [anon_sym_BSLASHAcf] = ACTIONS(6306),
    [anon_sym_BSLASHacfp] = ACTIONS(6306),
    [anon_sym_BSLASHAcfp] = ACTIONS(6306),
    [anon_sym_BSLASHac] = ACTIONS(6306),
    [anon_sym_BSLASHAc] = ACTIONS(6306),
    [anon_sym_BSLASHacp] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6306),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6306),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6306),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6306),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6308),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6306),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6306),
    [anon_sym_BSLASHcolor] = ACTIONS(6306),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6306),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6306),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6306),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6306),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6306),
    [anon_sym_BSLASHurl] = ACTIONS(6306),
    [anon_sym_BSLASHhref] = ACTIONS(6306),
  },
  [2025] = {
    [sym_command_name] = ACTIONS(6346),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6346),
    [anon_sym_RBRACK] = ACTIONS(6348),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_EQ] = ACTIONS(6348),
    [anon_sym_RBRACE] = ACTIONS(6348),
    [sym_word] = ACTIONS(6346),
    [sym_placeholder] = ACTIONS(6348),
    [anon_sym_PLUS] = ACTIONS(6348),
    [anon_sym_DASH] = ACTIONS(6348),
    [anon_sym_STAR] = ACTIONS(6348),
    [anon_sym_SLASH] = ACTIONS(6348),
    [anon_sym_LT] = ACTIONS(6346),
    [anon_sym_GT] = ACTIONS(6346),
    [anon_sym_BANG] = ACTIONS(6346),
    [anon_sym_PIPE] = ACTIONS(6346),
    [anon_sym_COLON] = ACTIONS(6346),
    [anon_sym_SQUOTE] = ACTIONS(6346),
    [anon_sym__] = ACTIONS(6348),
    [anon_sym_CARET] = ACTIONS(6348),
    [anon_sym_BSLASHtitle] = ACTIONS(6346),
    [anon_sym_BSLASHauthor] = ACTIONS(6346),
    [anon_sym_BSLASHusepackage] = ACTIONS(6346),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6346),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6346),
    [anon_sym_BSLASHinclude] = ACTIONS(6346),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6346),
    [anon_sym_BSLASHinput] = ACTIONS(6346),
    [anon_sym_BSLASHsubfile] = ACTIONS(6346),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6346),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6346),
    [anon_sym_BSLASHbibliography] = ACTIONS(6346),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6346),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6346),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6346),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6346),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6346),
    [anon_sym_BSLASHimport] = ACTIONS(6346),
    [anon_sym_BSLASHsubimport] = ACTIONS(6346),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6346),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6346),
    [anon_sym_BSLASHcaption] = ACTIONS(6346),
    [anon_sym_BSLASHcite] = ACTIONS(6346),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCite] = ACTIONS(6346),
    [anon_sym_BSLASHnocite] = ACTIONS(6346),
    [anon_sym_BSLASHcitet] = ACTIONS(6346),
    [anon_sym_BSLASHcitep] = ACTIONS(6346),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteA] = ACTIONS(6346),
    [anon_sym_BSLASHciteR] = ACTIONS(6346),
    [anon_sym_BSLASHciteS] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6346),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6346),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteyear] = ACTIONS(6346),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHcitedate] = ACTIONS(6346),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHciteurl] = ACTIONS(6346),
    [anon_sym_BSLASHfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6346),
    [anon_sym_BSLASHcitealt] = ACTIONS(6346),
    [anon_sym_BSLASHcitealp] = ACTIONS(6346),
    [anon_sym_BSLASHcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHparencite] = ACTIONS(6346),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHParencite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6346),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6346),
    [anon_sym_BSLASHtextcite] = ACTIONS(6346),
    [anon_sym_BSLASHTextcite] = ACTIONS(6346),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6346),
    [anon_sym_BSLASHsupercite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite] = ACTIONS(6346),
    [anon_sym_BSLASHAutocite] = ACTIONS(6346),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHVolcite] = ACTIONS(6346),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHavolcite] = ACTIONS(6346),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6346),
    [anon_sym_BSLASHnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHNotecite] = ACTIONS(6346),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6346),
    [anon_sym_BSLASHlabel] = ACTIONS(6346),
    [anon_sym_BSLASHref] = ACTIONS(6346),
    [anon_sym_BSLASHeqref] = ACTIONS(6346),
    [anon_sym_BSLASHvref] = ACTIONS(6346),
    [anon_sym_BSLASHVref] = ACTIONS(6346),
    [anon_sym_BSLASHautoref] = ACTIONS(6346),
    [anon_sym_BSLASHpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcref] = ACTIONS(6346),
    [anon_sym_BSLASHCref] = ACTIONS(6346),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnameCref] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6346),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6346),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6346),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6346),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6346),
    [anon_sym_BSLASHdef] = ACTIONS(6346),
    [anon_sym_BSLASHlet] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6346),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6346),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6346),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6346),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6346),
    [anon_sym_BSLASHgls] = ACTIONS(6346),
    [anon_sym_BSLASHGls] = ACTIONS(6346),
    [anon_sym_BSLASHGLS] = ACTIONS(6346),
    [anon_sym_BSLASHglspl] = ACTIONS(6346),
    [anon_sym_BSLASHGlspl] = ACTIONS(6346),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6346),
    [anon_sym_BSLASHglslink] = ACTIONS(6346),
    [anon_sym_BSLASHglstext] = ACTIONS(6346),
    [anon_sym_BSLASHGlstext] = ACTIONS(6346),
    [anon_sym_BSLASHGLStext] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6346),
    [anon_sym_BSLASHglsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6346),
    [anon_sym_BSLASHglsname] = ACTIONS(6346),
    [anon_sym_BSLASHGlsname] = ACTIONS(6346),
    [anon_sym_BSLASHGLSname] = ACTIONS(6346),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6346),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6346),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6346),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6346),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6346),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6346),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6346),
    [anon_sym_BSLASHacrshort] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6346),
    [anon_sym_BSLASHACRshort] = ACTIONS(6346),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrlong] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6346),
    [anon_sym_BSLASHACRlong] = ACTIONS(6346),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6346),
    [anon_sym_BSLASHacrfull] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6346),
    [anon_sym_BSLASHACRfull] = ACTIONS(6346),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHacs] = ACTIONS(6346),
    [anon_sym_BSLASHAcs] = ACTIONS(6346),
    [anon_sym_BSLASHacsp] = ACTIONS(6346),
    [anon_sym_BSLASHAcsp] = ACTIONS(6346),
    [anon_sym_BSLASHacl] = ACTIONS(6346),
    [anon_sym_BSLASHAcl] = ACTIONS(6346),
    [anon_sym_BSLASHaclp] = ACTIONS(6346),
    [anon_sym_BSLASHAclp] = ACTIONS(6346),
    [anon_sym_BSLASHacf] = ACTIONS(6346),
    [anon_sym_BSLASHAcf] = ACTIONS(6346),
    [anon_sym_BSLASHacfp] = ACTIONS(6346),
    [anon_sym_BSLASHAcfp] = ACTIONS(6346),
    [anon_sym_BSLASHac] = ACTIONS(6346),
    [anon_sym_BSLASHAc] = ACTIONS(6346),
    [anon_sym_BSLASHacp] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6346),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6346),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6346),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6346),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6348),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6346),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6346),
    [anon_sym_BSLASHcolor] = ACTIONS(6346),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6346),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6346),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6346),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6346),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6346),
    [anon_sym_BSLASHurl] = ACTIONS(6346),
    [anon_sym_BSLASHhref] = ACTIONS(6346),
  },
  [2026] = {
    [sym_command_name] = ACTIONS(6334),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6334),
    [anon_sym_RBRACK] = ACTIONS(6336),
    [anon_sym_COMMA] = ACTIONS(6336),
    [anon_sym_EQ] = ACTIONS(6336),
    [anon_sym_RBRACE] = ACTIONS(6336),
    [sym_word] = ACTIONS(6334),
    [sym_placeholder] = ACTIONS(6336),
    [anon_sym_PLUS] = ACTIONS(6336),
    [anon_sym_DASH] = ACTIONS(6336),
    [anon_sym_STAR] = ACTIONS(6336),
    [anon_sym_SLASH] = ACTIONS(6336),
    [anon_sym_LT] = ACTIONS(6334),
    [anon_sym_GT] = ACTIONS(6334),
    [anon_sym_BANG] = ACTIONS(6334),
    [anon_sym_PIPE] = ACTIONS(6334),
    [anon_sym_COLON] = ACTIONS(6334),
    [anon_sym_SQUOTE] = ACTIONS(6334),
    [anon_sym__] = ACTIONS(6336),
    [anon_sym_CARET] = ACTIONS(6336),
    [anon_sym_BSLASHtitle] = ACTIONS(6334),
    [anon_sym_BSLASHauthor] = ACTIONS(6334),
    [anon_sym_BSLASHusepackage] = ACTIONS(6334),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6334),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6334),
    [anon_sym_BSLASHinclude] = ACTIONS(6334),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6334),
    [anon_sym_BSLASHinput] = ACTIONS(6334),
    [anon_sym_BSLASHsubfile] = ACTIONS(6334),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6334),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6334),
    [anon_sym_BSLASHbibliography] = ACTIONS(6334),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6334),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6334),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6334),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6334),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6334),
    [anon_sym_BSLASHimport] = ACTIONS(6334),
    [anon_sym_BSLASHsubimport] = ACTIONS(6334),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6334),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6334),
    [anon_sym_BSLASHcaption] = ACTIONS(6334),
    [anon_sym_BSLASHcite] = ACTIONS(6334),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCite] = ACTIONS(6334),
    [anon_sym_BSLASHnocite] = ACTIONS(6334),
    [anon_sym_BSLASHcitet] = ACTIONS(6334),
    [anon_sym_BSLASHcitep] = ACTIONS(6334),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteA] = ACTIONS(6334),
    [anon_sym_BSLASHciteR] = ACTIONS(6334),
    [anon_sym_BSLASHciteS] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6334),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6334),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteyear] = ACTIONS(6334),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHcitedate] = ACTIONS(6334),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHciteurl] = ACTIONS(6334),
    [anon_sym_BSLASHfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6334),
    [anon_sym_BSLASHcitealt] = ACTIONS(6334),
    [anon_sym_BSLASHcitealp] = ACTIONS(6334),
    [anon_sym_BSLASHcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHparencite] = ACTIONS(6334),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHParencite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6334),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6334),
    [anon_sym_BSLASHtextcite] = ACTIONS(6334),
    [anon_sym_BSLASHTextcite] = ACTIONS(6334),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6334),
    [anon_sym_BSLASHsupercite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite] = ACTIONS(6334),
    [anon_sym_BSLASHAutocite] = ACTIONS(6334),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHVolcite] = ACTIONS(6334),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHavolcite] = ACTIONS(6334),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6334),
    [anon_sym_BSLASHnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHNotecite] = ACTIONS(6334),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6334),
    [anon_sym_BSLASHlabel] = ACTIONS(6334),
    [anon_sym_BSLASHref] = ACTIONS(6334),
    [anon_sym_BSLASHeqref] = ACTIONS(6334),
    [anon_sym_BSLASHvref] = ACTIONS(6334),
    [anon_sym_BSLASHVref] = ACTIONS(6334),
    [anon_sym_BSLASHautoref] = ACTIONS(6334),
    [anon_sym_BSLASHpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcref] = ACTIONS(6334),
    [anon_sym_BSLASHCref] = ACTIONS(6334),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnameCref] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6334),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6334),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6334),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6334),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6334),
    [anon_sym_BSLASHdef] = ACTIONS(6334),
    [anon_sym_BSLASHlet] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6334),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6334),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6334),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6334),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6334),
    [anon_sym_BSLASHgls] = ACTIONS(6334),
    [anon_sym_BSLASHGls] = ACTIONS(6334),
    [anon_sym_BSLASHGLS] = ACTIONS(6334),
    [anon_sym_BSLASHglspl] = ACTIONS(6334),
    [anon_sym_BSLASHGlspl] = ACTIONS(6334),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6334),
    [anon_sym_BSLASHglslink] = ACTIONS(6334),
    [anon_sym_BSLASHglstext] = ACTIONS(6334),
    [anon_sym_BSLASHGlstext] = ACTIONS(6334),
    [anon_sym_BSLASHGLStext] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6334),
    [anon_sym_BSLASHglsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6334),
    [anon_sym_BSLASHglsname] = ACTIONS(6334),
    [anon_sym_BSLASHGlsname] = ACTIONS(6334),
    [anon_sym_BSLASHGLSname] = ACTIONS(6334),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6334),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6334),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6334),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6334),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6334),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6334),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6334),
    [anon_sym_BSLASHacrshort] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6334),
    [anon_sym_BSLASHACRshort] = ACTIONS(6334),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrlong] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6334),
    [anon_sym_BSLASHACRlong] = ACTIONS(6334),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6334),
    [anon_sym_BSLASHacrfull] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6334),
    [anon_sym_BSLASHACRfull] = ACTIONS(6334),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHacs] = ACTIONS(6334),
    [anon_sym_BSLASHAcs] = ACTIONS(6334),
    [anon_sym_BSLASHacsp] = ACTIONS(6334),
    [anon_sym_BSLASHAcsp] = ACTIONS(6334),
    [anon_sym_BSLASHacl] = ACTIONS(6334),
    [anon_sym_BSLASHAcl] = ACTIONS(6334),
    [anon_sym_BSLASHaclp] = ACTIONS(6334),
    [anon_sym_BSLASHAclp] = ACTIONS(6334),
    [anon_sym_BSLASHacf] = ACTIONS(6334),
    [anon_sym_BSLASHAcf] = ACTIONS(6334),
    [anon_sym_BSLASHacfp] = ACTIONS(6334),
    [anon_sym_BSLASHAcfp] = ACTIONS(6334),
    [anon_sym_BSLASHac] = ACTIONS(6334),
    [anon_sym_BSLASHAc] = ACTIONS(6334),
    [anon_sym_BSLASHacp] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6334),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6334),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6334),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6334),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6336),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6334),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6334),
    [anon_sym_BSLASHcolor] = ACTIONS(6334),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6334),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6334),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6334),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6334),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6334),
    [anon_sym_BSLASHurl] = ACTIONS(6334),
    [anon_sym_BSLASHhref] = ACTIONS(6334),
  },
  [2027] = {
    [sym_command_name] = ACTIONS(6338),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6338),
    [anon_sym_RBRACK] = ACTIONS(6340),
    [anon_sym_COMMA] = ACTIONS(6340),
    [anon_sym_EQ] = ACTIONS(6340),
    [anon_sym_RBRACE] = ACTIONS(6340),
    [sym_word] = ACTIONS(6338),
    [sym_placeholder] = ACTIONS(6340),
    [anon_sym_PLUS] = ACTIONS(6340),
    [anon_sym_DASH] = ACTIONS(6340),
    [anon_sym_STAR] = ACTIONS(6340),
    [anon_sym_SLASH] = ACTIONS(6340),
    [anon_sym_LT] = ACTIONS(6338),
    [anon_sym_GT] = ACTIONS(6338),
    [anon_sym_BANG] = ACTIONS(6338),
    [anon_sym_PIPE] = ACTIONS(6338),
    [anon_sym_COLON] = ACTIONS(6338),
    [anon_sym_SQUOTE] = ACTIONS(6338),
    [anon_sym__] = ACTIONS(6340),
    [anon_sym_CARET] = ACTIONS(6340),
    [anon_sym_BSLASHtitle] = ACTIONS(6338),
    [anon_sym_BSLASHauthor] = ACTIONS(6338),
    [anon_sym_BSLASHusepackage] = ACTIONS(6338),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6338),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6338),
    [anon_sym_BSLASHinclude] = ACTIONS(6338),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6338),
    [anon_sym_BSLASHinput] = ACTIONS(6338),
    [anon_sym_BSLASHsubfile] = ACTIONS(6338),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6338),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6338),
    [anon_sym_BSLASHbibliography] = ACTIONS(6338),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6338),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6338),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6338),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6338),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6338),
    [anon_sym_BSLASHimport] = ACTIONS(6338),
    [anon_sym_BSLASHsubimport] = ACTIONS(6338),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6338),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6338),
    [anon_sym_BSLASHcaption] = ACTIONS(6338),
    [anon_sym_BSLASHcite] = ACTIONS(6338),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCite] = ACTIONS(6338),
    [anon_sym_BSLASHnocite] = ACTIONS(6338),
    [anon_sym_BSLASHcitet] = ACTIONS(6338),
    [anon_sym_BSLASHcitep] = ACTIONS(6338),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteA] = ACTIONS(6338),
    [anon_sym_BSLASHciteR] = ACTIONS(6338),
    [anon_sym_BSLASHciteS] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6338),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6338),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteyear] = ACTIONS(6338),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHcitedate] = ACTIONS(6338),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHciteurl] = ACTIONS(6338),
    [anon_sym_BSLASHfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6338),
    [anon_sym_BSLASHcitealt] = ACTIONS(6338),
    [anon_sym_BSLASHcitealp] = ACTIONS(6338),
    [anon_sym_BSLASHcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHparencite] = ACTIONS(6338),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHParencite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6338),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6338),
    [anon_sym_BSLASHtextcite] = ACTIONS(6338),
    [anon_sym_BSLASHTextcite] = ACTIONS(6338),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6338),
    [anon_sym_BSLASHsupercite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite] = ACTIONS(6338),
    [anon_sym_BSLASHAutocite] = ACTIONS(6338),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHVolcite] = ACTIONS(6338),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHavolcite] = ACTIONS(6338),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6338),
    [anon_sym_BSLASHnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHNotecite] = ACTIONS(6338),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6338),
    [anon_sym_BSLASHlabel] = ACTIONS(6338),
    [anon_sym_BSLASHref] = ACTIONS(6338),
    [anon_sym_BSLASHeqref] = ACTIONS(6338),
    [anon_sym_BSLASHvref] = ACTIONS(6338),
    [anon_sym_BSLASHVref] = ACTIONS(6338),
    [anon_sym_BSLASHautoref] = ACTIONS(6338),
    [anon_sym_BSLASHpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcref] = ACTIONS(6338),
    [anon_sym_BSLASHCref] = ACTIONS(6338),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnameCref] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6338),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6338),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6338),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6338),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6338),
    [anon_sym_BSLASHdef] = ACTIONS(6338),
    [anon_sym_BSLASHlet] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6338),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6338),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6338),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6338),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6338),
    [anon_sym_BSLASHgls] = ACTIONS(6338),
    [anon_sym_BSLASHGls] = ACTIONS(6338),
    [anon_sym_BSLASHGLS] = ACTIONS(6338),
    [anon_sym_BSLASHglspl] = ACTIONS(6338),
    [anon_sym_BSLASHGlspl] = ACTIONS(6338),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6338),
    [anon_sym_BSLASHglslink] = ACTIONS(6338),
    [anon_sym_BSLASHglstext] = ACTIONS(6338),
    [anon_sym_BSLASHGlstext] = ACTIONS(6338),
    [anon_sym_BSLASHGLStext] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6338),
    [anon_sym_BSLASHglsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6338),
    [anon_sym_BSLASHglsname] = ACTIONS(6338),
    [anon_sym_BSLASHGlsname] = ACTIONS(6338),
    [anon_sym_BSLASHGLSname] = ACTIONS(6338),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6338),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6338),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6338),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6338),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6338),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6338),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6338),
    [anon_sym_BSLASHacrshort] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6338),
    [anon_sym_BSLASHACRshort] = ACTIONS(6338),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrlong] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6338),
    [anon_sym_BSLASHACRlong] = ACTIONS(6338),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6338),
    [anon_sym_BSLASHacrfull] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6338),
    [anon_sym_BSLASHACRfull] = ACTIONS(6338),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHacs] = ACTIONS(6338),
    [anon_sym_BSLASHAcs] = ACTIONS(6338),
    [anon_sym_BSLASHacsp] = ACTIONS(6338),
    [anon_sym_BSLASHAcsp] = ACTIONS(6338),
    [anon_sym_BSLASHacl] = ACTIONS(6338),
    [anon_sym_BSLASHAcl] = ACTIONS(6338),
    [anon_sym_BSLASHaclp] = ACTIONS(6338),
    [anon_sym_BSLASHAclp] = ACTIONS(6338),
    [anon_sym_BSLASHacf] = ACTIONS(6338),
    [anon_sym_BSLASHAcf] = ACTIONS(6338),
    [anon_sym_BSLASHacfp] = ACTIONS(6338),
    [anon_sym_BSLASHAcfp] = ACTIONS(6338),
    [anon_sym_BSLASHac] = ACTIONS(6338),
    [anon_sym_BSLASHAc] = ACTIONS(6338),
    [anon_sym_BSLASHacp] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6338),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6338),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6338),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6338),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6340),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6338),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6338),
    [anon_sym_BSLASHcolor] = ACTIONS(6338),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6338),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6338),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6338),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6338),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6338),
    [anon_sym_BSLASHurl] = ACTIONS(6338),
    [anon_sym_BSLASHhref] = ACTIONS(6338),
  },
  [2028] = {
    [sym_command_name] = ACTIONS(6342),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6342),
    [anon_sym_RBRACK] = ACTIONS(6344),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_EQ] = ACTIONS(6344),
    [anon_sym_RBRACE] = ACTIONS(6344),
    [sym_word] = ACTIONS(6342),
    [sym_placeholder] = ACTIONS(6344),
    [anon_sym_PLUS] = ACTIONS(6344),
    [anon_sym_DASH] = ACTIONS(6344),
    [anon_sym_STAR] = ACTIONS(6344),
    [anon_sym_SLASH] = ACTIONS(6344),
    [anon_sym_LT] = ACTIONS(6342),
    [anon_sym_GT] = ACTIONS(6342),
    [anon_sym_BANG] = ACTIONS(6342),
    [anon_sym_PIPE] = ACTIONS(6342),
    [anon_sym_COLON] = ACTIONS(6342),
    [anon_sym_SQUOTE] = ACTIONS(6342),
    [anon_sym__] = ACTIONS(6344),
    [anon_sym_CARET] = ACTIONS(6344),
    [anon_sym_BSLASHtitle] = ACTIONS(6342),
    [anon_sym_BSLASHauthor] = ACTIONS(6342),
    [anon_sym_BSLASHusepackage] = ACTIONS(6342),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6342),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6342),
    [anon_sym_BSLASHinclude] = ACTIONS(6342),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6342),
    [anon_sym_BSLASHinput] = ACTIONS(6342),
    [anon_sym_BSLASHsubfile] = ACTIONS(6342),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6342),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6342),
    [anon_sym_BSLASHbibliography] = ACTIONS(6342),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6342),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6342),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6342),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6342),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6342),
    [anon_sym_BSLASHimport] = ACTIONS(6342),
    [anon_sym_BSLASHsubimport] = ACTIONS(6342),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6342),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6342),
    [anon_sym_BSLASHcaption] = ACTIONS(6342),
    [anon_sym_BSLASHcite] = ACTIONS(6342),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCite] = ACTIONS(6342),
    [anon_sym_BSLASHnocite] = ACTIONS(6342),
    [anon_sym_BSLASHcitet] = ACTIONS(6342),
    [anon_sym_BSLASHcitep] = ACTIONS(6342),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteA] = ACTIONS(6342),
    [anon_sym_BSLASHciteR] = ACTIONS(6342),
    [anon_sym_BSLASHciteS] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6342),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6342),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteyear] = ACTIONS(6342),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHcitedate] = ACTIONS(6342),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHciteurl] = ACTIONS(6342),
    [anon_sym_BSLASHfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6342),
    [anon_sym_BSLASHcitealt] = ACTIONS(6342),
    [anon_sym_BSLASHcitealp] = ACTIONS(6342),
    [anon_sym_BSLASHcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHparencite] = ACTIONS(6342),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHParencite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6342),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6342),
    [anon_sym_BSLASHtextcite] = ACTIONS(6342),
    [anon_sym_BSLASHTextcite] = ACTIONS(6342),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6342),
    [anon_sym_BSLASHsupercite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite] = ACTIONS(6342),
    [anon_sym_BSLASHAutocite] = ACTIONS(6342),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHVolcite] = ACTIONS(6342),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHavolcite] = ACTIONS(6342),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6342),
    [anon_sym_BSLASHnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHNotecite] = ACTIONS(6342),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6342),
    [anon_sym_BSLASHlabel] = ACTIONS(6342),
    [anon_sym_BSLASHref] = ACTIONS(6342),
    [anon_sym_BSLASHeqref] = ACTIONS(6342),
    [anon_sym_BSLASHvref] = ACTIONS(6342),
    [anon_sym_BSLASHVref] = ACTIONS(6342),
    [anon_sym_BSLASHautoref] = ACTIONS(6342),
    [anon_sym_BSLASHpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcref] = ACTIONS(6342),
    [anon_sym_BSLASHCref] = ACTIONS(6342),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnameCref] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6342),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6342),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6342),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6342),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6342),
    [anon_sym_BSLASHdef] = ACTIONS(6342),
    [anon_sym_BSLASHlet] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6342),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6342),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6342),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6342),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6342),
    [anon_sym_BSLASHgls] = ACTIONS(6342),
    [anon_sym_BSLASHGls] = ACTIONS(6342),
    [anon_sym_BSLASHGLS] = ACTIONS(6342),
    [anon_sym_BSLASHglspl] = ACTIONS(6342),
    [anon_sym_BSLASHGlspl] = ACTIONS(6342),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6342),
    [anon_sym_BSLASHglslink] = ACTIONS(6342),
    [anon_sym_BSLASHglstext] = ACTIONS(6342),
    [anon_sym_BSLASHGlstext] = ACTIONS(6342),
    [anon_sym_BSLASHGLStext] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6342),
    [anon_sym_BSLASHglsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6342),
    [anon_sym_BSLASHglsname] = ACTIONS(6342),
    [anon_sym_BSLASHGlsname] = ACTIONS(6342),
    [anon_sym_BSLASHGLSname] = ACTIONS(6342),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6342),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6342),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6342),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6342),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6342),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6342),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6342),
    [anon_sym_BSLASHacrshort] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6342),
    [anon_sym_BSLASHACRshort] = ACTIONS(6342),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrlong] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6342),
    [anon_sym_BSLASHACRlong] = ACTIONS(6342),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6342),
    [anon_sym_BSLASHacrfull] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6342),
    [anon_sym_BSLASHACRfull] = ACTIONS(6342),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHacs] = ACTIONS(6342),
    [anon_sym_BSLASHAcs] = ACTIONS(6342),
    [anon_sym_BSLASHacsp] = ACTIONS(6342),
    [anon_sym_BSLASHAcsp] = ACTIONS(6342),
    [anon_sym_BSLASHacl] = ACTIONS(6342),
    [anon_sym_BSLASHAcl] = ACTIONS(6342),
    [anon_sym_BSLASHaclp] = ACTIONS(6342),
    [anon_sym_BSLASHAclp] = ACTIONS(6342),
    [anon_sym_BSLASHacf] = ACTIONS(6342),
    [anon_sym_BSLASHAcf] = ACTIONS(6342),
    [anon_sym_BSLASHacfp] = ACTIONS(6342),
    [anon_sym_BSLASHAcfp] = ACTIONS(6342),
    [anon_sym_BSLASHac] = ACTIONS(6342),
    [anon_sym_BSLASHAc] = ACTIONS(6342),
    [anon_sym_BSLASHacp] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6342),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6342),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6342),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6342),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6344),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6342),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6342),
    [anon_sym_BSLASHcolor] = ACTIONS(6342),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6342),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6342),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6342),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6342),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6342),
    [anon_sym_BSLASHurl] = ACTIONS(6342),
    [anon_sym_BSLASHhref] = ACTIONS(6342),
  },
  [2029] = {
    [sym_command_name] = ACTIONS(6358),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6358),
    [anon_sym_RBRACK] = ACTIONS(6360),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_EQ] = ACTIONS(6360),
    [anon_sym_RBRACE] = ACTIONS(6360),
    [sym_word] = ACTIONS(6358),
    [sym_placeholder] = ACTIONS(6360),
    [anon_sym_PLUS] = ACTIONS(6360),
    [anon_sym_DASH] = ACTIONS(6360),
    [anon_sym_STAR] = ACTIONS(6360),
    [anon_sym_SLASH] = ACTIONS(6360),
    [anon_sym_LT] = ACTIONS(6358),
    [anon_sym_GT] = ACTIONS(6358),
    [anon_sym_BANG] = ACTIONS(6358),
    [anon_sym_PIPE] = ACTIONS(6358),
    [anon_sym_COLON] = ACTIONS(6358),
    [anon_sym_SQUOTE] = ACTIONS(6358),
    [anon_sym__] = ACTIONS(6360),
    [anon_sym_CARET] = ACTIONS(6360),
    [anon_sym_BSLASHtitle] = ACTIONS(6358),
    [anon_sym_BSLASHauthor] = ACTIONS(6358),
    [anon_sym_BSLASHusepackage] = ACTIONS(6358),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6358),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6358),
    [anon_sym_BSLASHinclude] = ACTIONS(6358),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6358),
    [anon_sym_BSLASHinput] = ACTIONS(6358),
    [anon_sym_BSLASHsubfile] = ACTIONS(6358),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6358),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6358),
    [anon_sym_BSLASHbibliography] = ACTIONS(6358),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6358),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6358),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6358),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6358),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6358),
    [anon_sym_BSLASHimport] = ACTIONS(6358),
    [anon_sym_BSLASHsubimport] = ACTIONS(6358),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6358),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6358),
    [anon_sym_BSLASHcaption] = ACTIONS(6358),
    [anon_sym_BSLASHcite] = ACTIONS(6358),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCite] = ACTIONS(6358),
    [anon_sym_BSLASHnocite] = ACTIONS(6358),
    [anon_sym_BSLASHcitet] = ACTIONS(6358),
    [anon_sym_BSLASHcitep] = ACTIONS(6358),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteA] = ACTIONS(6358),
    [anon_sym_BSLASHciteR] = ACTIONS(6358),
    [anon_sym_BSLASHciteS] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6358),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6358),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteyear] = ACTIONS(6358),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHcitedate] = ACTIONS(6358),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHciteurl] = ACTIONS(6358),
    [anon_sym_BSLASHfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6358),
    [anon_sym_BSLASHcitealt] = ACTIONS(6358),
    [anon_sym_BSLASHcitealp] = ACTIONS(6358),
    [anon_sym_BSLASHcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHparencite] = ACTIONS(6358),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHParencite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6358),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6358),
    [anon_sym_BSLASHtextcite] = ACTIONS(6358),
    [anon_sym_BSLASHTextcite] = ACTIONS(6358),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6358),
    [anon_sym_BSLASHsupercite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite] = ACTIONS(6358),
    [anon_sym_BSLASHAutocite] = ACTIONS(6358),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHVolcite] = ACTIONS(6358),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHavolcite] = ACTIONS(6358),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6358),
    [anon_sym_BSLASHnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHNotecite] = ACTIONS(6358),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6358),
    [anon_sym_BSLASHlabel] = ACTIONS(6358),
    [anon_sym_BSLASHref] = ACTIONS(6358),
    [anon_sym_BSLASHeqref] = ACTIONS(6358),
    [anon_sym_BSLASHvref] = ACTIONS(6358),
    [anon_sym_BSLASHVref] = ACTIONS(6358),
    [anon_sym_BSLASHautoref] = ACTIONS(6358),
    [anon_sym_BSLASHpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcref] = ACTIONS(6358),
    [anon_sym_BSLASHCref] = ACTIONS(6358),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnameCref] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6358),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6358),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6358),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6358),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6358),
    [anon_sym_BSLASHdef] = ACTIONS(6358),
    [anon_sym_BSLASHlet] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6358),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6358),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6358),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6358),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6358),
    [anon_sym_BSLASHgls] = ACTIONS(6358),
    [anon_sym_BSLASHGls] = ACTIONS(6358),
    [anon_sym_BSLASHGLS] = ACTIONS(6358),
    [anon_sym_BSLASHglspl] = ACTIONS(6358),
    [anon_sym_BSLASHGlspl] = ACTIONS(6358),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6358),
    [anon_sym_BSLASHglslink] = ACTIONS(6358),
    [anon_sym_BSLASHglstext] = ACTIONS(6358),
    [anon_sym_BSLASHGlstext] = ACTIONS(6358),
    [anon_sym_BSLASHGLStext] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6358),
    [anon_sym_BSLASHglsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6358),
    [anon_sym_BSLASHglsname] = ACTIONS(6358),
    [anon_sym_BSLASHGlsname] = ACTIONS(6358),
    [anon_sym_BSLASHGLSname] = ACTIONS(6358),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6358),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6358),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6358),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6358),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6358),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6358),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6358),
    [anon_sym_BSLASHacrshort] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6358),
    [anon_sym_BSLASHACRshort] = ACTIONS(6358),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrlong] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6358),
    [anon_sym_BSLASHACRlong] = ACTIONS(6358),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6358),
    [anon_sym_BSLASHacrfull] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6358),
    [anon_sym_BSLASHACRfull] = ACTIONS(6358),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHacs] = ACTIONS(6358),
    [anon_sym_BSLASHAcs] = ACTIONS(6358),
    [anon_sym_BSLASHacsp] = ACTIONS(6358),
    [anon_sym_BSLASHAcsp] = ACTIONS(6358),
    [anon_sym_BSLASHacl] = ACTIONS(6358),
    [anon_sym_BSLASHAcl] = ACTIONS(6358),
    [anon_sym_BSLASHaclp] = ACTIONS(6358),
    [anon_sym_BSLASHAclp] = ACTIONS(6358),
    [anon_sym_BSLASHacf] = ACTIONS(6358),
    [anon_sym_BSLASHAcf] = ACTIONS(6358),
    [anon_sym_BSLASHacfp] = ACTIONS(6358),
    [anon_sym_BSLASHAcfp] = ACTIONS(6358),
    [anon_sym_BSLASHac] = ACTIONS(6358),
    [anon_sym_BSLASHAc] = ACTIONS(6358),
    [anon_sym_BSLASHacp] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6358),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6358),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6358),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6358),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6360),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6358),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6358),
    [anon_sym_BSLASHcolor] = ACTIONS(6358),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6358),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6358),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6358),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6358),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6358),
    [anon_sym_BSLASHurl] = ACTIONS(6358),
    [anon_sym_BSLASHhref] = ACTIONS(6358),
  },
  [2030] = {
    [sym_command_name] = ACTIONS(6366),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6366),
    [anon_sym_RBRACK] = ACTIONS(6368),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_EQ] = ACTIONS(6368),
    [anon_sym_RBRACE] = ACTIONS(6368),
    [sym_word] = ACTIONS(6366),
    [sym_placeholder] = ACTIONS(6368),
    [anon_sym_PLUS] = ACTIONS(6368),
    [anon_sym_DASH] = ACTIONS(6368),
    [anon_sym_STAR] = ACTIONS(6368),
    [anon_sym_SLASH] = ACTIONS(6368),
    [anon_sym_LT] = ACTIONS(6366),
    [anon_sym_GT] = ACTIONS(6366),
    [anon_sym_BANG] = ACTIONS(6366),
    [anon_sym_PIPE] = ACTIONS(6366),
    [anon_sym_COLON] = ACTIONS(6366),
    [anon_sym_SQUOTE] = ACTIONS(6366),
    [anon_sym__] = ACTIONS(6368),
    [anon_sym_CARET] = ACTIONS(6368),
    [anon_sym_BSLASHtitle] = ACTIONS(6366),
    [anon_sym_BSLASHauthor] = ACTIONS(6366),
    [anon_sym_BSLASHusepackage] = ACTIONS(6366),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6366),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6366),
    [anon_sym_BSLASHinclude] = ACTIONS(6366),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6366),
    [anon_sym_BSLASHinput] = ACTIONS(6366),
    [anon_sym_BSLASHsubfile] = ACTIONS(6366),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6366),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6366),
    [anon_sym_BSLASHbibliography] = ACTIONS(6366),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6366),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6366),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6366),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6366),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6366),
    [anon_sym_BSLASHimport] = ACTIONS(6366),
    [anon_sym_BSLASHsubimport] = ACTIONS(6366),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6366),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6366),
    [anon_sym_BSLASHcaption] = ACTIONS(6366),
    [anon_sym_BSLASHcite] = ACTIONS(6366),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCite] = ACTIONS(6366),
    [anon_sym_BSLASHnocite] = ACTIONS(6366),
    [anon_sym_BSLASHcitet] = ACTIONS(6366),
    [anon_sym_BSLASHcitep] = ACTIONS(6366),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteA] = ACTIONS(6366),
    [anon_sym_BSLASHciteR] = ACTIONS(6366),
    [anon_sym_BSLASHciteS] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6366),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6366),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteyear] = ACTIONS(6366),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHcitedate] = ACTIONS(6366),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHciteurl] = ACTIONS(6366),
    [anon_sym_BSLASHfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6366),
    [anon_sym_BSLASHcitealt] = ACTIONS(6366),
    [anon_sym_BSLASHcitealp] = ACTIONS(6366),
    [anon_sym_BSLASHcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHparencite] = ACTIONS(6366),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHParencite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6366),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6366),
    [anon_sym_BSLASHtextcite] = ACTIONS(6366),
    [anon_sym_BSLASHTextcite] = ACTIONS(6366),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6366),
    [anon_sym_BSLASHsupercite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite] = ACTIONS(6366),
    [anon_sym_BSLASHAutocite] = ACTIONS(6366),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHVolcite] = ACTIONS(6366),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHavolcite] = ACTIONS(6366),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6366),
    [anon_sym_BSLASHnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHNotecite] = ACTIONS(6366),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6366),
    [anon_sym_BSLASHlabel] = ACTIONS(6366),
    [anon_sym_BSLASHref] = ACTIONS(6366),
    [anon_sym_BSLASHeqref] = ACTIONS(6366),
    [anon_sym_BSLASHvref] = ACTIONS(6366),
    [anon_sym_BSLASHVref] = ACTIONS(6366),
    [anon_sym_BSLASHautoref] = ACTIONS(6366),
    [anon_sym_BSLASHpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcref] = ACTIONS(6366),
    [anon_sym_BSLASHCref] = ACTIONS(6366),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnameCref] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6366),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6366),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6366),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6366),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6366),
    [anon_sym_BSLASHdef] = ACTIONS(6366),
    [anon_sym_BSLASHlet] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6366),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6366),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6366),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6366),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6366),
    [anon_sym_BSLASHgls] = ACTIONS(6366),
    [anon_sym_BSLASHGls] = ACTIONS(6366),
    [anon_sym_BSLASHGLS] = ACTIONS(6366),
    [anon_sym_BSLASHglspl] = ACTIONS(6366),
    [anon_sym_BSLASHGlspl] = ACTIONS(6366),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6366),
    [anon_sym_BSLASHglslink] = ACTIONS(6366),
    [anon_sym_BSLASHglstext] = ACTIONS(6366),
    [anon_sym_BSLASHGlstext] = ACTIONS(6366),
    [anon_sym_BSLASHGLStext] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6366),
    [anon_sym_BSLASHglsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6366),
    [anon_sym_BSLASHglsname] = ACTIONS(6366),
    [anon_sym_BSLASHGlsname] = ACTIONS(6366),
    [anon_sym_BSLASHGLSname] = ACTIONS(6366),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6366),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6366),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6366),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6366),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6366),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6366),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6366),
    [anon_sym_BSLASHacrshort] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6366),
    [anon_sym_BSLASHACRshort] = ACTIONS(6366),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrlong] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6366),
    [anon_sym_BSLASHACRlong] = ACTIONS(6366),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6366),
    [anon_sym_BSLASHacrfull] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6366),
    [anon_sym_BSLASHACRfull] = ACTIONS(6366),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHacs] = ACTIONS(6366),
    [anon_sym_BSLASHAcs] = ACTIONS(6366),
    [anon_sym_BSLASHacsp] = ACTIONS(6366),
    [anon_sym_BSLASHAcsp] = ACTIONS(6366),
    [anon_sym_BSLASHacl] = ACTIONS(6366),
    [anon_sym_BSLASHAcl] = ACTIONS(6366),
    [anon_sym_BSLASHaclp] = ACTIONS(6366),
    [anon_sym_BSLASHAclp] = ACTIONS(6366),
    [anon_sym_BSLASHacf] = ACTIONS(6366),
    [anon_sym_BSLASHAcf] = ACTIONS(6366),
    [anon_sym_BSLASHacfp] = ACTIONS(6366),
    [anon_sym_BSLASHAcfp] = ACTIONS(6366),
    [anon_sym_BSLASHac] = ACTIONS(6366),
    [anon_sym_BSLASHAc] = ACTIONS(6366),
    [anon_sym_BSLASHacp] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6366),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6366),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6366),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6366),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6368),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6366),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6366),
    [anon_sym_BSLASHcolor] = ACTIONS(6366),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6366),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6366),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6366),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6366),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6366),
    [anon_sym_BSLASHurl] = ACTIONS(6366),
    [anon_sym_BSLASHhref] = ACTIONS(6366),
  },
  [2031] = {
    [sym_command_name] = ACTIONS(6370),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6370),
    [anon_sym_RBRACK] = ACTIONS(6372),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_EQ] = ACTIONS(6372),
    [anon_sym_RBRACE] = ACTIONS(6372),
    [sym_word] = ACTIONS(6370),
    [sym_placeholder] = ACTIONS(6372),
    [anon_sym_PLUS] = ACTIONS(6372),
    [anon_sym_DASH] = ACTIONS(6372),
    [anon_sym_STAR] = ACTIONS(6372),
    [anon_sym_SLASH] = ACTIONS(6372),
    [anon_sym_LT] = ACTIONS(6370),
    [anon_sym_GT] = ACTIONS(6370),
    [anon_sym_BANG] = ACTIONS(6370),
    [anon_sym_PIPE] = ACTIONS(6370),
    [anon_sym_COLON] = ACTIONS(6370),
    [anon_sym_SQUOTE] = ACTIONS(6370),
    [anon_sym__] = ACTIONS(6372),
    [anon_sym_CARET] = ACTIONS(6372),
    [anon_sym_BSLASHtitle] = ACTIONS(6370),
    [anon_sym_BSLASHauthor] = ACTIONS(6370),
    [anon_sym_BSLASHusepackage] = ACTIONS(6370),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6370),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6370),
    [anon_sym_BSLASHinclude] = ACTIONS(6370),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6370),
    [anon_sym_BSLASHinput] = ACTIONS(6370),
    [anon_sym_BSLASHsubfile] = ACTIONS(6370),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6370),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6370),
    [anon_sym_BSLASHbibliography] = ACTIONS(6370),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6370),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6370),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6370),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6370),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6370),
    [anon_sym_BSLASHimport] = ACTIONS(6370),
    [anon_sym_BSLASHsubimport] = ACTIONS(6370),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6370),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6370),
    [anon_sym_BSLASHcaption] = ACTIONS(6370),
    [anon_sym_BSLASHcite] = ACTIONS(6370),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCite] = ACTIONS(6370),
    [anon_sym_BSLASHnocite] = ACTIONS(6370),
    [anon_sym_BSLASHcitet] = ACTIONS(6370),
    [anon_sym_BSLASHcitep] = ACTIONS(6370),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteA] = ACTIONS(6370),
    [anon_sym_BSLASHciteR] = ACTIONS(6370),
    [anon_sym_BSLASHciteS] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6370),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6370),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteyear] = ACTIONS(6370),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHcitedate] = ACTIONS(6370),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHciteurl] = ACTIONS(6370),
    [anon_sym_BSLASHfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6370),
    [anon_sym_BSLASHcitealt] = ACTIONS(6370),
    [anon_sym_BSLASHcitealp] = ACTIONS(6370),
    [anon_sym_BSLASHcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHparencite] = ACTIONS(6370),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHParencite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6370),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6370),
    [anon_sym_BSLASHtextcite] = ACTIONS(6370),
    [anon_sym_BSLASHTextcite] = ACTIONS(6370),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6370),
    [anon_sym_BSLASHsupercite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite] = ACTIONS(6370),
    [anon_sym_BSLASHAutocite] = ACTIONS(6370),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHVolcite] = ACTIONS(6370),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHavolcite] = ACTIONS(6370),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6370),
    [anon_sym_BSLASHnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHNotecite] = ACTIONS(6370),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6370),
    [anon_sym_BSLASHlabel] = ACTIONS(6370),
    [anon_sym_BSLASHref] = ACTIONS(6370),
    [anon_sym_BSLASHeqref] = ACTIONS(6370),
    [anon_sym_BSLASHvref] = ACTIONS(6370),
    [anon_sym_BSLASHVref] = ACTIONS(6370),
    [anon_sym_BSLASHautoref] = ACTIONS(6370),
    [anon_sym_BSLASHpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcref] = ACTIONS(6370),
    [anon_sym_BSLASHCref] = ACTIONS(6370),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnameCref] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6370),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6370),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6370),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6370),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6370),
    [anon_sym_BSLASHdef] = ACTIONS(6370),
    [anon_sym_BSLASHlet] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6370),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6370),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6370),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6370),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6370),
    [anon_sym_BSLASHgls] = ACTIONS(6370),
    [anon_sym_BSLASHGls] = ACTIONS(6370),
    [anon_sym_BSLASHGLS] = ACTIONS(6370),
    [anon_sym_BSLASHglspl] = ACTIONS(6370),
    [anon_sym_BSLASHGlspl] = ACTIONS(6370),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6370),
    [anon_sym_BSLASHglslink] = ACTIONS(6370),
    [anon_sym_BSLASHglstext] = ACTIONS(6370),
    [anon_sym_BSLASHGlstext] = ACTIONS(6370),
    [anon_sym_BSLASHGLStext] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6370),
    [anon_sym_BSLASHglsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6370),
    [anon_sym_BSLASHglsname] = ACTIONS(6370),
    [anon_sym_BSLASHGlsname] = ACTIONS(6370),
    [anon_sym_BSLASHGLSname] = ACTIONS(6370),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6370),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6370),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6370),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6370),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6370),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6370),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6370),
    [anon_sym_BSLASHacrshort] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6370),
    [anon_sym_BSLASHACRshort] = ACTIONS(6370),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrlong] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6370),
    [anon_sym_BSLASHACRlong] = ACTIONS(6370),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6370),
    [anon_sym_BSLASHacrfull] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6370),
    [anon_sym_BSLASHACRfull] = ACTIONS(6370),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHacs] = ACTIONS(6370),
    [anon_sym_BSLASHAcs] = ACTIONS(6370),
    [anon_sym_BSLASHacsp] = ACTIONS(6370),
    [anon_sym_BSLASHAcsp] = ACTIONS(6370),
    [anon_sym_BSLASHacl] = ACTIONS(6370),
    [anon_sym_BSLASHAcl] = ACTIONS(6370),
    [anon_sym_BSLASHaclp] = ACTIONS(6370),
    [anon_sym_BSLASHAclp] = ACTIONS(6370),
    [anon_sym_BSLASHacf] = ACTIONS(6370),
    [anon_sym_BSLASHAcf] = ACTIONS(6370),
    [anon_sym_BSLASHacfp] = ACTIONS(6370),
    [anon_sym_BSLASHAcfp] = ACTIONS(6370),
    [anon_sym_BSLASHac] = ACTIONS(6370),
    [anon_sym_BSLASHAc] = ACTIONS(6370),
    [anon_sym_BSLASHacp] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6370),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6370),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6370),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6370),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6372),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6370),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6370),
    [anon_sym_BSLASHcolor] = ACTIONS(6370),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6370),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6370),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6370),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6370),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6370),
    [anon_sym_BSLASHurl] = ACTIONS(6370),
    [anon_sym_BSLASHhref] = ACTIONS(6370),
  },
  [2032] = {
    [sym_command_name] = ACTIONS(6458),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6458),
    [anon_sym_RBRACK] = ACTIONS(6460),
    [anon_sym_COMMA] = ACTIONS(6460),
    [anon_sym_EQ] = ACTIONS(6460),
    [anon_sym_RBRACE] = ACTIONS(6460),
    [sym_word] = ACTIONS(6458),
    [sym_placeholder] = ACTIONS(6460),
    [anon_sym_PLUS] = ACTIONS(6460),
    [anon_sym_DASH] = ACTIONS(6460),
    [anon_sym_STAR] = ACTIONS(6460),
    [anon_sym_SLASH] = ACTIONS(6460),
    [anon_sym_LT] = ACTIONS(6458),
    [anon_sym_GT] = ACTIONS(6458),
    [anon_sym_BANG] = ACTIONS(6458),
    [anon_sym_PIPE] = ACTIONS(6458),
    [anon_sym_COLON] = ACTIONS(6458),
    [anon_sym_SQUOTE] = ACTIONS(6458),
    [anon_sym__] = ACTIONS(6460),
    [anon_sym_CARET] = ACTIONS(6460),
    [anon_sym_BSLASHtitle] = ACTIONS(6458),
    [anon_sym_BSLASHauthor] = ACTIONS(6458),
    [anon_sym_BSLASHusepackage] = ACTIONS(6458),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6458),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6458),
    [anon_sym_BSLASHinclude] = ACTIONS(6458),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6458),
    [anon_sym_BSLASHinput] = ACTIONS(6458),
    [anon_sym_BSLASHsubfile] = ACTIONS(6458),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6458),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6458),
    [anon_sym_BSLASHbibliography] = ACTIONS(6458),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6458),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6458),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6458),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6458),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6458),
    [anon_sym_BSLASHimport] = ACTIONS(6458),
    [anon_sym_BSLASHsubimport] = ACTIONS(6458),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6458),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6458),
    [anon_sym_BSLASHcaption] = ACTIONS(6458),
    [anon_sym_BSLASHcite] = ACTIONS(6458),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCite] = ACTIONS(6458),
    [anon_sym_BSLASHnocite] = ACTIONS(6458),
    [anon_sym_BSLASHcitet] = ACTIONS(6458),
    [anon_sym_BSLASHcitep] = ACTIONS(6458),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteA] = ACTIONS(6458),
    [anon_sym_BSLASHciteR] = ACTIONS(6458),
    [anon_sym_BSLASHciteS] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6458),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6458),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteyear] = ACTIONS(6458),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHcitedate] = ACTIONS(6458),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHciteurl] = ACTIONS(6458),
    [anon_sym_BSLASHfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6458),
    [anon_sym_BSLASHcitealt] = ACTIONS(6458),
    [anon_sym_BSLASHcitealp] = ACTIONS(6458),
    [anon_sym_BSLASHcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHparencite] = ACTIONS(6458),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHParencite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6458),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6458),
    [anon_sym_BSLASHtextcite] = ACTIONS(6458),
    [anon_sym_BSLASHTextcite] = ACTIONS(6458),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6458),
    [anon_sym_BSLASHsupercite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite] = ACTIONS(6458),
    [anon_sym_BSLASHAutocite] = ACTIONS(6458),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHVolcite] = ACTIONS(6458),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHavolcite] = ACTIONS(6458),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6458),
    [anon_sym_BSLASHnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHNotecite] = ACTIONS(6458),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6458),
    [anon_sym_BSLASHlabel] = ACTIONS(6458),
    [anon_sym_BSLASHref] = ACTIONS(6458),
    [anon_sym_BSLASHeqref] = ACTIONS(6458),
    [anon_sym_BSLASHvref] = ACTIONS(6458),
    [anon_sym_BSLASHVref] = ACTIONS(6458),
    [anon_sym_BSLASHautoref] = ACTIONS(6458),
    [anon_sym_BSLASHpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcref] = ACTIONS(6458),
    [anon_sym_BSLASHCref] = ACTIONS(6458),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnameCref] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6458),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6458),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6458),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6458),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6458),
    [anon_sym_BSLASHdef] = ACTIONS(6458),
    [anon_sym_BSLASHlet] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6458),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6458),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6458),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6458),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6458),
    [anon_sym_BSLASHgls] = ACTIONS(6458),
    [anon_sym_BSLASHGls] = ACTIONS(6458),
    [anon_sym_BSLASHGLS] = ACTIONS(6458),
    [anon_sym_BSLASHglspl] = ACTIONS(6458),
    [anon_sym_BSLASHGlspl] = ACTIONS(6458),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6458),
    [anon_sym_BSLASHglslink] = ACTIONS(6458),
    [anon_sym_BSLASHglstext] = ACTIONS(6458),
    [anon_sym_BSLASHGlstext] = ACTIONS(6458),
    [anon_sym_BSLASHGLStext] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6458),
    [anon_sym_BSLASHglsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6458),
    [anon_sym_BSLASHglsname] = ACTIONS(6458),
    [anon_sym_BSLASHGlsname] = ACTIONS(6458),
    [anon_sym_BSLASHGLSname] = ACTIONS(6458),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6458),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6458),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6458),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6458),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6458),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6458),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6458),
    [anon_sym_BSLASHacrshort] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6458),
    [anon_sym_BSLASHACRshort] = ACTIONS(6458),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrlong] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6458),
    [anon_sym_BSLASHACRlong] = ACTIONS(6458),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6458),
    [anon_sym_BSLASHacrfull] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6458),
    [anon_sym_BSLASHACRfull] = ACTIONS(6458),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHacs] = ACTIONS(6458),
    [anon_sym_BSLASHAcs] = ACTIONS(6458),
    [anon_sym_BSLASHacsp] = ACTIONS(6458),
    [anon_sym_BSLASHAcsp] = ACTIONS(6458),
    [anon_sym_BSLASHacl] = ACTIONS(6458),
    [anon_sym_BSLASHAcl] = ACTIONS(6458),
    [anon_sym_BSLASHaclp] = ACTIONS(6458),
    [anon_sym_BSLASHAclp] = ACTIONS(6458),
    [anon_sym_BSLASHacf] = ACTIONS(6458),
    [anon_sym_BSLASHAcf] = ACTIONS(6458),
    [anon_sym_BSLASHacfp] = ACTIONS(6458),
    [anon_sym_BSLASHAcfp] = ACTIONS(6458),
    [anon_sym_BSLASHac] = ACTIONS(6458),
    [anon_sym_BSLASHAc] = ACTIONS(6458),
    [anon_sym_BSLASHacp] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6458),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6458),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6458),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6458),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6460),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6458),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6458),
    [anon_sym_BSLASHcolor] = ACTIONS(6458),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6458),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6458),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6458),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6458),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6458),
    [anon_sym_BSLASHurl] = ACTIONS(6458),
    [anon_sym_BSLASHhref] = ACTIONS(6458),
  },
  [2033] = {
    [sym_command_name] = ACTIONS(6462),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6462),
    [anon_sym_RBRACK] = ACTIONS(6464),
    [anon_sym_COMMA] = ACTIONS(6464),
    [anon_sym_EQ] = ACTIONS(6464),
    [anon_sym_RBRACE] = ACTIONS(6464),
    [sym_word] = ACTIONS(6462),
    [sym_placeholder] = ACTIONS(6464),
    [anon_sym_PLUS] = ACTIONS(6464),
    [anon_sym_DASH] = ACTIONS(6464),
    [anon_sym_STAR] = ACTIONS(6464),
    [anon_sym_SLASH] = ACTIONS(6464),
    [anon_sym_LT] = ACTIONS(6462),
    [anon_sym_GT] = ACTIONS(6462),
    [anon_sym_BANG] = ACTIONS(6462),
    [anon_sym_PIPE] = ACTIONS(6462),
    [anon_sym_COLON] = ACTIONS(6462),
    [anon_sym_SQUOTE] = ACTIONS(6462),
    [anon_sym__] = ACTIONS(6464),
    [anon_sym_CARET] = ACTIONS(6464),
    [anon_sym_BSLASHtitle] = ACTIONS(6462),
    [anon_sym_BSLASHauthor] = ACTIONS(6462),
    [anon_sym_BSLASHusepackage] = ACTIONS(6462),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6462),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6462),
    [anon_sym_BSLASHinclude] = ACTIONS(6462),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6462),
    [anon_sym_BSLASHinput] = ACTIONS(6462),
    [anon_sym_BSLASHsubfile] = ACTIONS(6462),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6462),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6462),
    [anon_sym_BSLASHbibliography] = ACTIONS(6462),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6462),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6462),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6462),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6462),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6462),
    [anon_sym_BSLASHimport] = ACTIONS(6462),
    [anon_sym_BSLASHsubimport] = ACTIONS(6462),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6462),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6462),
    [anon_sym_BSLASHcaption] = ACTIONS(6462),
    [anon_sym_BSLASHcite] = ACTIONS(6462),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCite] = ACTIONS(6462),
    [anon_sym_BSLASHnocite] = ACTIONS(6462),
    [anon_sym_BSLASHcitet] = ACTIONS(6462),
    [anon_sym_BSLASHcitep] = ACTIONS(6462),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteA] = ACTIONS(6462),
    [anon_sym_BSLASHciteR] = ACTIONS(6462),
    [anon_sym_BSLASHciteS] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6462),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6462),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteyear] = ACTIONS(6462),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHcitedate] = ACTIONS(6462),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHciteurl] = ACTIONS(6462),
    [anon_sym_BSLASHfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6462),
    [anon_sym_BSLASHcitealt] = ACTIONS(6462),
    [anon_sym_BSLASHcitealp] = ACTIONS(6462),
    [anon_sym_BSLASHcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHparencite] = ACTIONS(6462),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHParencite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6462),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6462),
    [anon_sym_BSLASHtextcite] = ACTIONS(6462),
    [anon_sym_BSLASHTextcite] = ACTIONS(6462),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6462),
    [anon_sym_BSLASHsupercite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite] = ACTIONS(6462),
    [anon_sym_BSLASHAutocite] = ACTIONS(6462),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHVolcite] = ACTIONS(6462),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHavolcite] = ACTIONS(6462),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6462),
    [anon_sym_BSLASHnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHNotecite] = ACTIONS(6462),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6462),
    [anon_sym_BSLASHlabel] = ACTIONS(6462),
    [anon_sym_BSLASHref] = ACTIONS(6462),
    [anon_sym_BSLASHeqref] = ACTIONS(6462),
    [anon_sym_BSLASHvref] = ACTIONS(6462),
    [anon_sym_BSLASHVref] = ACTIONS(6462),
    [anon_sym_BSLASHautoref] = ACTIONS(6462),
    [anon_sym_BSLASHpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcref] = ACTIONS(6462),
    [anon_sym_BSLASHCref] = ACTIONS(6462),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnameCref] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6462),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6462),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6462),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6462),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6462),
    [anon_sym_BSLASHdef] = ACTIONS(6462),
    [anon_sym_BSLASHlet] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6462),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6462),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6462),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6462),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6462),
    [anon_sym_BSLASHgls] = ACTIONS(6462),
    [anon_sym_BSLASHGls] = ACTIONS(6462),
    [anon_sym_BSLASHGLS] = ACTIONS(6462),
    [anon_sym_BSLASHglspl] = ACTIONS(6462),
    [anon_sym_BSLASHGlspl] = ACTIONS(6462),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6462),
    [anon_sym_BSLASHglslink] = ACTIONS(6462),
    [anon_sym_BSLASHglstext] = ACTIONS(6462),
    [anon_sym_BSLASHGlstext] = ACTIONS(6462),
    [anon_sym_BSLASHGLStext] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6462),
    [anon_sym_BSLASHglsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6462),
    [anon_sym_BSLASHglsname] = ACTIONS(6462),
    [anon_sym_BSLASHGlsname] = ACTIONS(6462),
    [anon_sym_BSLASHGLSname] = ACTIONS(6462),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6462),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6462),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6462),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6462),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6462),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6462),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6462),
    [anon_sym_BSLASHacrshort] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6462),
    [anon_sym_BSLASHACRshort] = ACTIONS(6462),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrlong] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6462),
    [anon_sym_BSLASHACRlong] = ACTIONS(6462),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6462),
    [anon_sym_BSLASHacrfull] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6462),
    [anon_sym_BSLASHACRfull] = ACTIONS(6462),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHacs] = ACTIONS(6462),
    [anon_sym_BSLASHAcs] = ACTIONS(6462),
    [anon_sym_BSLASHacsp] = ACTIONS(6462),
    [anon_sym_BSLASHAcsp] = ACTIONS(6462),
    [anon_sym_BSLASHacl] = ACTIONS(6462),
    [anon_sym_BSLASHAcl] = ACTIONS(6462),
    [anon_sym_BSLASHaclp] = ACTIONS(6462),
    [anon_sym_BSLASHAclp] = ACTIONS(6462),
    [anon_sym_BSLASHacf] = ACTIONS(6462),
    [anon_sym_BSLASHAcf] = ACTIONS(6462),
    [anon_sym_BSLASHacfp] = ACTIONS(6462),
    [anon_sym_BSLASHAcfp] = ACTIONS(6462),
    [anon_sym_BSLASHac] = ACTIONS(6462),
    [anon_sym_BSLASHAc] = ACTIONS(6462),
    [anon_sym_BSLASHacp] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6462),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6462),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6462),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6462),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6464),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6462),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6462),
    [anon_sym_BSLASHcolor] = ACTIONS(6462),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6462),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6462),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6462),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6462),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6462),
    [anon_sym_BSLASHurl] = ACTIONS(6462),
    [anon_sym_BSLASHhref] = ACTIONS(6462),
  },
  [2034] = {
    [sym_command_name] = ACTIONS(6442),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6442),
    [anon_sym_RBRACK] = ACTIONS(6444),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_EQ] = ACTIONS(6444),
    [anon_sym_RBRACE] = ACTIONS(6444),
    [sym_word] = ACTIONS(6442),
    [sym_placeholder] = ACTIONS(6444),
    [anon_sym_PLUS] = ACTIONS(6444),
    [anon_sym_DASH] = ACTIONS(6444),
    [anon_sym_STAR] = ACTIONS(6444),
    [anon_sym_SLASH] = ACTIONS(6444),
    [anon_sym_LT] = ACTIONS(6442),
    [anon_sym_GT] = ACTIONS(6442),
    [anon_sym_BANG] = ACTIONS(6442),
    [anon_sym_PIPE] = ACTIONS(6442),
    [anon_sym_COLON] = ACTIONS(6442),
    [anon_sym_SQUOTE] = ACTIONS(6442),
    [anon_sym__] = ACTIONS(6444),
    [anon_sym_CARET] = ACTIONS(6444),
    [anon_sym_BSLASHtitle] = ACTIONS(6442),
    [anon_sym_BSLASHauthor] = ACTIONS(6442),
    [anon_sym_BSLASHusepackage] = ACTIONS(6442),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6442),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6442),
    [anon_sym_BSLASHinclude] = ACTIONS(6442),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6442),
    [anon_sym_BSLASHinput] = ACTIONS(6442),
    [anon_sym_BSLASHsubfile] = ACTIONS(6442),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6442),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6442),
    [anon_sym_BSLASHbibliography] = ACTIONS(6442),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6442),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6442),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6442),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6442),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6442),
    [anon_sym_BSLASHimport] = ACTIONS(6442),
    [anon_sym_BSLASHsubimport] = ACTIONS(6442),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6442),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6442),
    [anon_sym_BSLASHcaption] = ACTIONS(6442),
    [anon_sym_BSLASHcite] = ACTIONS(6442),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCite] = ACTIONS(6442),
    [anon_sym_BSLASHnocite] = ACTIONS(6442),
    [anon_sym_BSLASHcitet] = ACTIONS(6442),
    [anon_sym_BSLASHcitep] = ACTIONS(6442),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteA] = ACTIONS(6442),
    [anon_sym_BSLASHciteR] = ACTIONS(6442),
    [anon_sym_BSLASHciteS] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6442),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6442),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteyear] = ACTIONS(6442),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHcitedate] = ACTIONS(6442),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHciteurl] = ACTIONS(6442),
    [anon_sym_BSLASHfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6442),
    [anon_sym_BSLASHcitealt] = ACTIONS(6442),
    [anon_sym_BSLASHcitealp] = ACTIONS(6442),
    [anon_sym_BSLASHcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHparencite] = ACTIONS(6442),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHParencite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6442),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6442),
    [anon_sym_BSLASHtextcite] = ACTIONS(6442),
    [anon_sym_BSLASHTextcite] = ACTIONS(6442),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6442),
    [anon_sym_BSLASHsupercite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite] = ACTIONS(6442),
    [anon_sym_BSLASHAutocite] = ACTIONS(6442),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHVolcite] = ACTIONS(6442),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHavolcite] = ACTIONS(6442),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6442),
    [anon_sym_BSLASHnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHNotecite] = ACTIONS(6442),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6442),
    [anon_sym_BSLASHlabel] = ACTIONS(6442),
    [anon_sym_BSLASHref] = ACTIONS(6442),
    [anon_sym_BSLASHeqref] = ACTIONS(6442),
    [anon_sym_BSLASHvref] = ACTIONS(6442),
    [anon_sym_BSLASHVref] = ACTIONS(6442),
    [anon_sym_BSLASHautoref] = ACTIONS(6442),
    [anon_sym_BSLASHpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcref] = ACTIONS(6442),
    [anon_sym_BSLASHCref] = ACTIONS(6442),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnameCref] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6442),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6442),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6442),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6442),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6442),
    [anon_sym_BSLASHdef] = ACTIONS(6442),
    [anon_sym_BSLASHlet] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6442),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6442),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6442),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6442),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6442),
    [anon_sym_BSLASHgls] = ACTIONS(6442),
    [anon_sym_BSLASHGls] = ACTIONS(6442),
    [anon_sym_BSLASHGLS] = ACTIONS(6442),
    [anon_sym_BSLASHglspl] = ACTIONS(6442),
    [anon_sym_BSLASHGlspl] = ACTIONS(6442),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6442),
    [anon_sym_BSLASHglslink] = ACTIONS(6442),
    [anon_sym_BSLASHglstext] = ACTIONS(6442),
    [anon_sym_BSLASHGlstext] = ACTIONS(6442),
    [anon_sym_BSLASHGLStext] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6442),
    [anon_sym_BSLASHglsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6442),
    [anon_sym_BSLASHglsname] = ACTIONS(6442),
    [anon_sym_BSLASHGlsname] = ACTIONS(6442),
    [anon_sym_BSLASHGLSname] = ACTIONS(6442),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6442),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6442),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6442),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6442),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6442),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6442),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6442),
    [anon_sym_BSLASHacrshort] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6442),
    [anon_sym_BSLASHACRshort] = ACTIONS(6442),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrlong] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6442),
    [anon_sym_BSLASHACRlong] = ACTIONS(6442),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6442),
    [anon_sym_BSLASHacrfull] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6442),
    [anon_sym_BSLASHACRfull] = ACTIONS(6442),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHacs] = ACTIONS(6442),
    [anon_sym_BSLASHAcs] = ACTIONS(6442),
    [anon_sym_BSLASHacsp] = ACTIONS(6442),
    [anon_sym_BSLASHAcsp] = ACTIONS(6442),
    [anon_sym_BSLASHacl] = ACTIONS(6442),
    [anon_sym_BSLASHAcl] = ACTIONS(6442),
    [anon_sym_BSLASHaclp] = ACTIONS(6442),
    [anon_sym_BSLASHAclp] = ACTIONS(6442),
    [anon_sym_BSLASHacf] = ACTIONS(6442),
    [anon_sym_BSLASHAcf] = ACTIONS(6442),
    [anon_sym_BSLASHacfp] = ACTIONS(6442),
    [anon_sym_BSLASHAcfp] = ACTIONS(6442),
    [anon_sym_BSLASHac] = ACTIONS(6442),
    [anon_sym_BSLASHAc] = ACTIONS(6442),
    [anon_sym_BSLASHacp] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6442),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6442),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6442),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6442),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6444),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6442),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6442),
    [anon_sym_BSLASHcolor] = ACTIONS(6442),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6442),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6442),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6442),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6442),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6442),
    [anon_sym_BSLASHurl] = ACTIONS(6442),
    [anon_sym_BSLASHhref] = ACTIONS(6442),
  },
  [2035] = {
    [sym_command_name] = ACTIONS(6466),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6466),
    [anon_sym_RBRACK] = ACTIONS(6468),
    [anon_sym_COMMA] = ACTIONS(6468),
    [anon_sym_EQ] = ACTIONS(6468),
    [anon_sym_RBRACE] = ACTIONS(6468),
    [sym_word] = ACTIONS(6466),
    [sym_placeholder] = ACTIONS(6468),
    [anon_sym_PLUS] = ACTIONS(6468),
    [anon_sym_DASH] = ACTIONS(6468),
    [anon_sym_STAR] = ACTIONS(6468),
    [anon_sym_SLASH] = ACTIONS(6468),
    [anon_sym_LT] = ACTIONS(6466),
    [anon_sym_GT] = ACTIONS(6466),
    [anon_sym_BANG] = ACTIONS(6466),
    [anon_sym_PIPE] = ACTIONS(6466),
    [anon_sym_COLON] = ACTIONS(6466),
    [anon_sym_SQUOTE] = ACTIONS(6466),
    [anon_sym__] = ACTIONS(6468),
    [anon_sym_CARET] = ACTIONS(6468),
    [anon_sym_BSLASHtitle] = ACTIONS(6466),
    [anon_sym_BSLASHauthor] = ACTIONS(6466),
    [anon_sym_BSLASHusepackage] = ACTIONS(6466),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6466),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6466),
    [anon_sym_BSLASHinclude] = ACTIONS(6466),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6466),
    [anon_sym_BSLASHinput] = ACTIONS(6466),
    [anon_sym_BSLASHsubfile] = ACTIONS(6466),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6466),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6466),
    [anon_sym_BSLASHbibliography] = ACTIONS(6466),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6466),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6466),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6466),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6466),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6466),
    [anon_sym_BSLASHimport] = ACTIONS(6466),
    [anon_sym_BSLASHsubimport] = ACTIONS(6466),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6466),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6466),
    [anon_sym_BSLASHcaption] = ACTIONS(6466),
    [anon_sym_BSLASHcite] = ACTIONS(6466),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCite] = ACTIONS(6466),
    [anon_sym_BSLASHnocite] = ACTIONS(6466),
    [anon_sym_BSLASHcitet] = ACTIONS(6466),
    [anon_sym_BSLASHcitep] = ACTIONS(6466),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteA] = ACTIONS(6466),
    [anon_sym_BSLASHciteR] = ACTIONS(6466),
    [anon_sym_BSLASHciteS] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6466),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6466),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteyear] = ACTIONS(6466),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHcitedate] = ACTIONS(6466),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHciteurl] = ACTIONS(6466),
    [anon_sym_BSLASHfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6466),
    [anon_sym_BSLASHcitealt] = ACTIONS(6466),
    [anon_sym_BSLASHcitealp] = ACTIONS(6466),
    [anon_sym_BSLASHcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHparencite] = ACTIONS(6466),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHParencite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6466),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6466),
    [anon_sym_BSLASHtextcite] = ACTIONS(6466),
    [anon_sym_BSLASHTextcite] = ACTIONS(6466),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6466),
    [anon_sym_BSLASHsupercite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite] = ACTIONS(6466),
    [anon_sym_BSLASHAutocite] = ACTIONS(6466),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHVolcite] = ACTIONS(6466),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHavolcite] = ACTIONS(6466),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6466),
    [anon_sym_BSLASHnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHNotecite] = ACTIONS(6466),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6466),
    [anon_sym_BSLASHlabel] = ACTIONS(6466),
    [anon_sym_BSLASHref] = ACTIONS(6466),
    [anon_sym_BSLASHeqref] = ACTIONS(6466),
    [anon_sym_BSLASHvref] = ACTIONS(6466),
    [anon_sym_BSLASHVref] = ACTIONS(6466),
    [anon_sym_BSLASHautoref] = ACTIONS(6466),
    [anon_sym_BSLASHpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcref] = ACTIONS(6466),
    [anon_sym_BSLASHCref] = ACTIONS(6466),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnameCref] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6466),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6466),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6466),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6466),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6466),
    [anon_sym_BSLASHdef] = ACTIONS(6466),
    [anon_sym_BSLASHlet] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6466),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6466),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6466),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6466),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6466),
    [anon_sym_BSLASHgls] = ACTIONS(6466),
    [anon_sym_BSLASHGls] = ACTIONS(6466),
    [anon_sym_BSLASHGLS] = ACTIONS(6466),
    [anon_sym_BSLASHglspl] = ACTIONS(6466),
    [anon_sym_BSLASHGlspl] = ACTIONS(6466),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6466),
    [anon_sym_BSLASHglslink] = ACTIONS(6466),
    [anon_sym_BSLASHglstext] = ACTIONS(6466),
    [anon_sym_BSLASHGlstext] = ACTIONS(6466),
    [anon_sym_BSLASHGLStext] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6466),
    [anon_sym_BSLASHglsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6466),
    [anon_sym_BSLASHglsname] = ACTIONS(6466),
    [anon_sym_BSLASHGlsname] = ACTIONS(6466),
    [anon_sym_BSLASHGLSname] = ACTIONS(6466),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6466),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6466),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6466),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6466),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6466),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6466),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6466),
    [anon_sym_BSLASHacrshort] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6466),
    [anon_sym_BSLASHACRshort] = ACTIONS(6466),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrlong] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6466),
    [anon_sym_BSLASHACRlong] = ACTIONS(6466),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6466),
    [anon_sym_BSLASHacrfull] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6466),
    [anon_sym_BSLASHACRfull] = ACTIONS(6466),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHacs] = ACTIONS(6466),
    [anon_sym_BSLASHAcs] = ACTIONS(6466),
    [anon_sym_BSLASHacsp] = ACTIONS(6466),
    [anon_sym_BSLASHAcsp] = ACTIONS(6466),
    [anon_sym_BSLASHacl] = ACTIONS(6466),
    [anon_sym_BSLASHAcl] = ACTIONS(6466),
    [anon_sym_BSLASHaclp] = ACTIONS(6466),
    [anon_sym_BSLASHAclp] = ACTIONS(6466),
    [anon_sym_BSLASHacf] = ACTIONS(6466),
    [anon_sym_BSLASHAcf] = ACTIONS(6466),
    [anon_sym_BSLASHacfp] = ACTIONS(6466),
    [anon_sym_BSLASHAcfp] = ACTIONS(6466),
    [anon_sym_BSLASHac] = ACTIONS(6466),
    [anon_sym_BSLASHAc] = ACTIONS(6466),
    [anon_sym_BSLASHacp] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6466),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6466),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6466),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6466),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6468),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6466),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6466),
    [anon_sym_BSLASHcolor] = ACTIONS(6466),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6466),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6466),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6466),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6466),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6466),
    [anon_sym_BSLASHurl] = ACTIONS(6466),
    [anon_sym_BSLASHhref] = ACTIONS(6466),
  },
  [2036] = {
    [sym_command_name] = ACTIONS(6326),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6326),
    [anon_sym_RBRACK] = ACTIONS(6328),
    [anon_sym_COMMA] = ACTIONS(6328),
    [anon_sym_EQ] = ACTIONS(6328),
    [anon_sym_RBRACE] = ACTIONS(6328),
    [sym_word] = ACTIONS(6326),
    [sym_placeholder] = ACTIONS(6328),
    [anon_sym_PLUS] = ACTIONS(6328),
    [anon_sym_DASH] = ACTIONS(6328),
    [anon_sym_STAR] = ACTIONS(6328),
    [anon_sym_SLASH] = ACTIONS(6328),
    [anon_sym_LT] = ACTIONS(6326),
    [anon_sym_GT] = ACTIONS(6326),
    [anon_sym_BANG] = ACTIONS(6326),
    [anon_sym_PIPE] = ACTIONS(6326),
    [anon_sym_COLON] = ACTIONS(6326),
    [anon_sym_SQUOTE] = ACTIONS(6326),
    [anon_sym__] = ACTIONS(6328),
    [anon_sym_CARET] = ACTIONS(6328),
    [anon_sym_BSLASHtitle] = ACTIONS(6326),
    [anon_sym_BSLASHauthor] = ACTIONS(6326),
    [anon_sym_BSLASHusepackage] = ACTIONS(6326),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6326),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6326),
    [anon_sym_BSLASHinclude] = ACTIONS(6326),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6326),
    [anon_sym_BSLASHinput] = ACTIONS(6326),
    [anon_sym_BSLASHsubfile] = ACTIONS(6326),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6326),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6326),
    [anon_sym_BSLASHbibliography] = ACTIONS(6326),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6326),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6326),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6326),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6326),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6326),
    [anon_sym_BSLASHimport] = ACTIONS(6326),
    [anon_sym_BSLASHsubimport] = ACTIONS(6326),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6326),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6326),
    [anon_sym_BSLASHcaption] = ACTIONS(6326),
    [anon_sym_BSLASHcite] = ACTIONS(6326),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCite] = ACTIONS(6326),
    [anon_sym_BSLASHnocite] = ACTIONS(6326),
    [anon_sym_BSLASHcitet] = ACTIONS(6326),
    [anon_sym_BSLASHcitep] = ACTIONS(6326),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteA] = ACTIONS(6326),
    [anon_sym_BSLASHciteR] = ACTIONS(6326),
    [anon_sym_BSLASHciteS] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6326),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6326),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteyear] = ACTIONS(6326),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHcitedate] = ACTIONS(6326),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHciteurl] = ACTIONS(6326),
    [anon_sym_BSLASHfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6326),
    [anon_sym_BSLASHcitealt] = ACTIONS(6326),
    [anon_sym_BSLASHcitealp] = ACTIONS(6326),
    [anon_sym_BSLASHcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHparencite] = ACTIONS(6326),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHParencite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6326),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6326),
    [anon_sym_BSLASHtextcite] = ACTIONS(6326),
    [anon_sym_BSLASHTextcite] = ACTIONS(6326),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6326),
    [anon_sym_BSLASHsupercite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite] = ACTIONS(6326),
    [anon_sym_BSLASHAutocite] = ACTIONS(6326),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHVolcite] = ACTIONS(6326),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHavolcite] = ACTIONS(6326),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6326),
    [anon_sym_BSLASHnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHNotecite] = ACTIONS(6326),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6326),
    [anon_sym_BSLASHlabel] = ACTIONS(6326),
    [anon_sym_BSLASHref] = ACTIONS(6326),
    [anon_sym_BSLASHeqref] = ACTIONS(6326),
    [anon_sym_BSLASHvref] = ACTIONS(6326),
    [anon_sym_BSLASHVref] = ACTIONS(6326),
    [anon_sym_BSLASHautoref] = ACTIONS(6326),
    [anon_sym_BSLASHpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcref] = ACTIONS(6326),
    [anon_sym_BSLASHCref] = ACTIONS(6326),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnameCref] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6326),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6326),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6326),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6326),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6326),
    [anon_sym_BSLASHdef] = ACTIONS(6326),
    [anon_sym_BSLASHlet] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6326),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6326),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6326),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6326),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6326),
    [anon_sym_BSLASHgls] = ACTIONS(6326),
    [anon_sym_BSLASHGls] = ACTIONS(6326),
    [anon_sym_BSLASHGLS] = ACTIONS(6326),
    [anon_sym_BSLASHglspl] = ACTIONS(6326),
    [anon_sym_BSLASHGlspl] = ACTIONS(6326),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6326),
    [anon_sym_BSLASHglslink] = ACTIONS(6326),
    [anon_sym_BSLASHglstext] = ACTIONS(6326),
    [anon_sym_BSLASHGlstext] = ACTIONS(6326),
    [anon_sym_BSLASHGLStext] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6326),
    [anon_sym_BSLASHglsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6326),
    [anon_sym_BSLASHglsname] = ACTIONS(6326),
    [anon_sym_BSLASHGlsname] = ACTIONS(6326),
    [anon_sym_BSLASHGLSname] = ACTIONS(6326),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6326),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6326),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6326),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6326),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6326),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6326),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6326),
    [anon_sym_BSLASHacrshort] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6326),
    [anon_sym_BSLASHACRshort] = ACTIONS(6326),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrlong] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6326),
    [anon_sym_BSLASHACRlong] = ACTIONS(6326),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6326),
    [anon_sym_BSLASHacrfull] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6326),
    [anon_sym_BSLASHACRfull] = ACTIONS(6326),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHacs] = ACTIONS(6326),
    [anon_sym_BSLASHAcs] = ACTIONS(6326),
    [anon_sym_BSLASHacsp] = ACTIONS(6326),
    [anon_sym_BSLASHAcsp] = ACTIONS(6326),
    [anon_sym_BSLASHacl] = ACTIONS(6326),
    [anon_sym_BSLASHAcl] = ACTIONS(6326),
    [anon_sym_BSLASHaclp] = ACTIONS(6326),
    [anon_sym_BSLASHAclp] = ACTIONS(6326),
    [anon_sym_BSLASHacf] = ACTIONS(6326),
    [anon_sym_BSLASHAcf] = ACTIONS(6326),
    [anon_sym_BSLASHacfp] = ACTIONS(6326),
    [anon_sym_BSLASHAcfp] = ACTIONS(6326),
    [anon_sym_BSLASHac] = ACTIONS(6326),
    [anon_sym_BSLASHAc] = ACTIONS(6326),
    [anon_sym_BSLASHacp] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6326),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6326),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6326),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6326),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6328),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6326),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6326),
    [anon_sym_BSLASHcolor] = ACTIONS(6326),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6326),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6326),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6326),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6326),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6326),
    [anon_sym_BSLASHurl] = ACTIONS(6326),
    [anon_sym_BSLASHhref] = ACTIONS(6326),
  },
  [2037] = {
    [sym_command_name] = ACTIONS(6474),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6474),
    [anon_sym_RBRACK] = ACTIONS(6476),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_EQ] = ACTIONS(6476),
    [anon_sym_RBRACE] = ACTIONS(6476),
    [sym_word] = ACTIONS(6474),
    [sym_placeholder] = ACTIONS(6476),
    [anon_sym_PLUS] = ACTIONS(6476),
    [anon_sym_DASH] = ACTIONS(6476),
    [anon_sym_STAR] = ACTIONS(6476),
    [anon_sym_SLASH] = ACTIONS(6476),
    [anon_sym_LT] = ACTIONS(6474),
    [anon_sym_GT] = ACTIONS(6474),
    [anon_sym_BANG] = ACTIONS(6474),
    [anon_sym_PIPE] = ACTIONS(6474),
    [anon_sym_COLON] = ACTIONS(6474),
    [anon_sym_SQUOTE] = ACTIONS(6474),
    [anon_sym__] = ACTIONS(6476),
    [anon_sym_CARET] = ACTIONS(6476),
    [anon_sym_BSLASHtitle] = ACTIONS(6474),
    [anon_sym_BSLASHauthor] = ACTIONS(6474),
    [anon_sym_BSLASHusepackage] = ACTIONS(6474),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6474),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6474),
    [anon_sym_BSLASHinclude] = ACTIONS(6474),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6474),
    [anon_sym_BSLASHinput] = ACTIONS(6474),
    [anon_sym_BSLASHsubfile] = ACTIONS(6474),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6474),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6474),
    [anon_sym_BSLASHbibliography] = ACTIONS(6474),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6474),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6474),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6474),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6474),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6474),
    [anon_sym_BSLASHimport] = ACTIONS(6474),
    [anon_sym_BSLASHsubimport] = ACTIONS(6474),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6474),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6474),
    [anon_sym_BSLASHcaption] = ACTIONS(6474),
    [anon_sym_BSLASHcite] = ACTIONS(6474),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCite] = ACTIONS(6474),
    [anon_sym_BSLASHnocite] = ACTIONS(6474),
    [anon_sym_BSLASHcitet] = ACTIONS(6474),
    [anon_sym_BSLASHcitep] = ACTIONS(6474),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteA] = ACTIONS(6474),
    [anon_sym_BSLASHciteR] = ACTIONS(6474),
    [anon_sym_BSLASHciteS] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6474),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6474),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteyear] = ACTIONS(6474),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHcitedate] = ACTIONS(6474),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHciteurl] = ACTIONS(6474),
    [anon_sym_BSLASHfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6474),
    [anon_sym_BSLASHcitealt] = ACTIONS(6474),
    [anon_sym_BSLASHcitealp] = ACTIONS(6474),
    [anon_sym_BSLASHcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHparencite] = ACTIONS(6474),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHParencite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6474),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6474),
    [anon_sym_BSLASHtextcite] = ACTIONS(6474),
    [anon_sym_BSLASHTextcite] = ACTIONS(6474),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6474),
    [anon_sym_BSLASHsupercite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite] = ACTIONS(6474),
    [anon_sym_BSLASHAutocite] = ACTIONS(6474),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHVolcite] = ACTIONS(6474),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHavolcite] = ACTIONS(6474),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6474),
    [anon_sym_BSLASHnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHNotecite] = ACTIONS(6474),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6474),
    [anon_sym_BSLASHlabel] = ACTIONS(6474),
    [anon_sym_BSLASHref] = ACTIONS(6474),
    [anon_sym_BSLASHeqref] = ACTIONS(6474),
    [anon_sym_BSLASHvref] = ACTIONS(6474),
    [anon_sym_BSLASHVref] = ACTIONS(6474),
    [anon_sym_BSLASHautoref] = ACTIONS(6474),
    [anon_sym_BSLASHpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcref] = ACTIONS(6474),
    [anon_sym_BSLASHCref] = ACTIONS(6474),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnameCref] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6474),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6474),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6474),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6474),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6474),
    [anon_sym_BSLASHdef] = ACTIONS(6474),
    [anon_sym_BSLASHlet] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6474),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6474),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6474),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6474),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6474),
    [anon_sym_BSLASHgls] = ACTIONS(6474),
    [anon_sym_BSLASHGls] = ACTIONS(6474),
    [anon_sym_BSLASHGLS] = ACTIONS(6474),
    [anon_sym_BSLASHglspl] = ACTIONS(6474),
    [anon_sym_BSLASHGlspl] = ACTIONS(6474),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6474),
    [anon_sym_BSLASHglslink] = ACTIONS(6474),
    [anon_sym_BSLASHglstext] = ACTIONS(6474),
    [anon_sym_BSLASHGlstext] = ACTIONS(6474),
    [anon_sym_BSLASHGLStext] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6474),
    [anon_sym_BSLASHglsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6474),
    [anon_sym_BSLASHglsname] = ACTIONS(6474),
    [anon_sym_BSLASHGlsname] = ACTIONS(6474),
    [anon_sym_BSLASHGLSname] = ACTIONS(6474),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6474),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6474),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6474),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6474),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6474),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6474),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6474),
    [anon_sym_BSLASHacrshort] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6474),
    [anon_sym_BSLASHACRshort] = ACTIONS(6474),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrlong] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6474),
    [anon_sym_BSLASHACRlong] = ACTIONS(6474),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6474),
    [anon_sym_BSLASHacrfull] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6474),
    [anon_sym_BSLASHACRfull] = ACTIONS(6474),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHacs] = ACTIONS(6474),
    [anon_sym_BSLASHAcs] = ACTIONS(6474),
    [anon_sym_BSLASHacsp] = ACTIONS(6474),
    [anon_sym_BSLASHAcsp] = ACTIONS(6474),
    [anon_sym_BSLASHacl] = ACTIONS(6474),
    [anon_sym_BSLASHAcl] = ACTIONS(6474),
    [anon_sym_BSLASHaclp] = ACTIONS(6474),
    [anon_sym_BSLASHAclp] = ACTIONS(6474),
    [anon_sym_BSLASHacf] = ACTIONS(6474),
    [anon_sym_BSLASHAcf] = ACTIONS(6474),
    [anon_sym_BSLASHacfp] = ACTIONS(6474),
    [anon_sym_BSLASHAcfp] = ACTIONS(6474),
    [anon_sym_BSLASHac] = ACTIONS(6474),
    [anon_sym_BSLASHAc] = ACTIONS(6474),
    [anon_sym_BSLASHacp] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6474),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6474),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6474),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6474),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6476),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6474),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6474),
    [anon_sym_BSLASHcolor] = ACTIONS(6474),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6474),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6474),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6474),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6474),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6474),
    [anon_sym_BSLASHurl] = ACTIONS(6474),
    [anon_sym_BSLASHhref] = ACTIONS(6474),
  },
  [2038] = {
    [sym_command_name] = ACTIONS(6330),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6330),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_COMMA] = ACTIONS(6332),
    [anon_sym_EQ] = ACTIONS(6332),
    [anon_sym_RBRACE] = ACTIONS(6332),
    [sym_word] = ACTIONS(6330),
    [sym_placeholder] = ACTIONS(6332),
    [anon_sym_PLUS] = ACTIONS(6332),
    [anon_sym_DASH] = ACTIONS(6332),
    [anon_sym_STAR] = ACTIONS(6332),
    [anon_sym_SLASH] = ACTIONS(6332),
    [anon_sym_LT] = ACTIONS(6330),
    [anon_sym_GT] = ACTIONS(6330),
    [anon_sym_BANG] = ACTIONS(6330),
    [anon_sym_PIPE] = ACTIONS(6330),
    [anon_sym_COLON] = ACTIONS(6330),
    [anon_sym_SQUOTE] = ACTIONS(6330),
    [anon_sym__] = ACTIONS(6332),
    [anon_sym_CARET] = ACTIONS(6332),
    [anon_sym_BSLASHtitle] = ACTIONS(6330),
    [anon_sym_BSLASHauthor] = ACTIONS(6330),
    [anon_sym_BSLASHusepackage] = ACTIONS(6330),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6330),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6330),
    [anon_sym_BSLASHinclude] = ACTIONS(6330),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6330),
    [anon_sym_BSLASHinput] = ACTIONS(6330),
    [anon_sym_BSLASHsubfile] = ACTIONS(6330),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6330),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6330),
    [anon_sym_BSLASHbibliography] = ACTIONS(6330),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6330),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6330),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6330),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6330),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6330),
    [anon_sym_BSLASHimport] = ACTIONS(6330),
    [anon_sym_BSLASHsubimport] = ACTIONS(6330),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6330),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6330),
    [anon_sym_BSLASHcaption] = ACTIONS(6330),
    [anon_sym_BSLASHcite] = ACTIONS(6330),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCite] = ACTIONS(6330),
    [anon_sym_BSLASHnocite] = ACTIONS(6330),
    [anon_sym_BSLASHcitet] = ACTIONS(6330),
    [anon_sym_BSLASHcitep] = ACTIONS(6330),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteA] = ACTIONS(6330),
    [anon_sym_BSLASHciteR] = ACTIONS(6330),
    [anon_sym_BSLASHciteS] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6330),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6330),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteyear] = ACTIONS(6330),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHcitedate] = ACTIONS(6330),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHciteurl] = ACTIONS(6330),
    [anon_sym_BSLASHfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6330),
    [anon_sym_BSLASHcitealt] = ACTIONS(6330),
    [anon_sym_BSLASHcitealp] = ACTIONS(6330),
    [anon_sym_BSLASHcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHparencite] = ACTIONS(6330),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHParencite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6330),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6330),
    [anon_sym_BSLASHtextcite] = ACTIONS(6330),
    [anon_sym_BSLASHTextcite] = ACTIONS(6330),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6330),
    [anon_sym_BSLASHsupercite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite] = ACTIONS(6330),
    [anon_sym_BSLASHAutocite] = ACTIONS(6330),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHVolcite] = ACTIONS(6330),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHavolcite] = ACTIONS(6330),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6330),
    [anon_sym_BSLASHnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHNotecite] = ACTIONS(6330),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6330),
    [anon_sym_BSLASHlabel] = ACTIONS(6330),
    [anon_sym_BSLASHref] = ACTIONS(6330),
    [anon_sym_BSLASHeqref] = ACTIONS(6330),
    [anon_sym_BSLASHvref] = ACTIONS(6330),
    [anon_sym_BSLASHVref] = ACTIONS(6330),
    [anon_sym_BSLASHautoref] = ACTIONS(6330),
    [anon_sym_BSLASHpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcref] = ACTIONS(6330),
    [anon_sym_BSLASHCref] = ACTIONS(6330),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnameCref] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6330),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6330),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6330),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6330),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6330),
    [anon_sym_BSLASHdef] = ACTIONS(6330),
    [anon_sym_BSLASHlet] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6330),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6330),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6330),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6330),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6330),
    [anon_sym_BSLASHgls] = ACTIONS(6330),
    [anon_sym_BSLASHGls] = ACTIONS(6330),
    [anon_sym_BSLASHGLS] = ACTIONS(6330),
    [anon_sym_BSLASHglspl] = ACTIONS(6330),
    [anon_sym_BSLASHGlspl] = ACTIONS(6330),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6330),
    [anon_sym_BSLASHglslink] = ACTIONS(6330),
    [anon_sym_BSLASHglstext] = ACTIONS(6330),
    [anon_sym_BSLASHGlstext] = ACTIONS(6330),
    [anon_sym_BSLASHGLStext] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6330),
    [anon_sym_BSLASHglsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6330),
    [anon_sym_BSLASHglsname] = ACTIONS(6330),
    [anon_sym_BSLASHGlsname] = ACTIONS(6330),
    [anon_sym_BSLASHGLSname] = ACTIONS(6330),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6330),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6330),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6330),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6330),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6330),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6330),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6330),
    [anon_sym_BSLASHacrshort] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6330),
    [anon_sym_BSLASHACRshort] = ACTIONS(6330),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrlong] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6330),
    [anon_sym_BSLASHACRlong] = ACTIONS(6330),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6330),
    [anon_sym_BSLASHacrfull] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6330),
    [anon_sym_BSLASHACRfull] = ACTIONS(6330),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHacs] = ACTIONS(6330),
    [anon_sym_BSLASHAcs] = ACTIONS(6330),
    [anon_sym_BSLASHacsp] = ACTIONS(6330),
    [anon_sym_BSLASHAcsp] = ACTIONS(6330),
    [anon_sym_BSLASHacl] = ACTIONS(6330),
    [anon_sym_BSLASHAcl] = ACTIONS(6330),
    [anon_sym_BSLASHaclp] = ACTIONS(6330),
    [anon_sym_BSLASHAclp] = ACTIONS(6330),
    [anon_sym_BSLASHacf] = ACTIONS(6330),
    [anon_sym_BSLASHAcf] = ACTIONS(6330),
    [anon_sym_BSLASHacfp] = ACTIONS(6330),
    [anon_sym_BSLASHAcfp] = ACTIONS(6330),
    [anon_sym_BSLASHac] = ACTIONS(6330),
    [anon_sym_BSLASHAc] = ACTIONS(6330),
    [anon_sym_BSLASHacp] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6330),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6330),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6330),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6330),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6332),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6330),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6330),
    [anon_sym_BSLASHcolor] = ACTIONS(6330),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6330),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6330),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6330),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6330),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6330),
    [anon_sym_BSLASHurl] = ACTIONS(6330),
    [anon_sym_BSLASHhref] = ACTIONS(6330),
  },
  [2039] = {
    [sym_command_name] = ACTIONS(6482),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6482),
    [anon_sym_RBRACK] = ACTIONS(6484),
    [anon_sym_COMMA] = ACTIONS(6484),
    [anon_sym_EQ] = ACTIONS(6484),
    [anon_sym_RBRACE] = ACTIONS(6484),
    [sym_word] = ACTIONS(6482),
    [sym_placeholder] = ACTIONS(6484),
    [anon_sym_PLUS] = ACTIONS(6484),
    [anon_sym_DASH] = ACTIONS(6484),
    [anon_sym_STAR] = ACTIONS(6484),
    [anon_sym_SLASH] = ACTIONS(6484),
    [anon_sym_LT] = ACTIONS(6482),
    [anon_sym_GT] = ACTIONS(6482),
    [anon_sym_BANG] = ACTIONS(6482),
    [anon_sym_PIPE] = ACTIONS(6482),
    [anon_sym_COLON] = ACTIONS(6482),
    [anon_sym_SQUOTE] = ACTIONS(6482),
    [anon_sym__] = ACTIONS(6484),
    [anon_sym_CARET] = ACTIONS(6484),
    [anon_sym_BSLASHtitle] = ACTIONS(6482),
    [anon_sym_BSLASHauthor] = ACTIONS(6482),
    [anon_sym_BSLASHusepackage] = ACTIONS(6482),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6482),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6482),
    [anon_sym_BSLASHinclude] = ACTIONS(6482),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6482),
    [anon_sym_BSLASHinput] = ACTIONS(6482),
    [anon_sym_BSLASHsubfile] = ACTIONS(6482),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6482),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6482),
    [anon_sym_BSLASHbibliography] = ACTIONS(6482),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6482),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6482),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6482),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6482),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6482),
    [anon_sym_BSLASHimport] = ACTIONS(6482),
    [anon_sym_BSLASHsubimport] = ACTIONS(6482),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6482),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6482),
    [anon_sym_BSLASHcaption] = ACTIONS(6482),
    [anon_sym_BSLASHcite] = ACTIONS(6482),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCite] = ACTIONS(6482),
    [anon_sym_BSLASHnocite] = ACTIONS(6482),
    [anon_sym_BSLASHcitet] = ACTIONS(6482),
    [anon_sym_BSLASHcitep] = ACTIONS(6482),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteA] = ACTIONS(6482),
    [anon_sym_BSLASHciteR] = ACTIONS(6482),
    [anon_sym_BSLASHciteS] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6482),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6482),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteyear] = ACTIONS(6482),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHcitedate] = ACTIONS(6482),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHciteurl] = ACTIONS(6482),
    [anon_sym_BSLASHfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6482),
    [anon_sym_BSLASHcitealt] = ACTIONS(6482),
    [anon_sym_BSLASHcitealp] = ACTIONS(6482),
    [anon_sym_BSLASHcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHparencite] = ACTIONS(6482),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHParencite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6482),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6482),
    [anon_sym_BSLASHtextcite] = ACTIONS(6482),
    [anon_sym_BSLASHTextcite] = ACTIONS(6482),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6482),
    [anon_sym_BSLASHsupercite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite] = ACTIONS(6482),
    [anon_sym_BSLASHAutocite] = ACTIONS(6482),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHVolcite] = ACTIONS(6482),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHavolcite] = ACTIONS(6482),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6482),
    [anon_sym_BSLASHnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHNotecite] = ACTIONS(6482),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6482),
    [anon_sym_BSLASHlabel] = ACTIONS(6482),
    [anon_sym_BSLASHref] = ACTIONS(6482),
    [anon_sym_BSLASHeqref] = ACTIONS(6482),
    [anon_sym_BSLASHvref] = ACTIONS(6482),
    [anon_sym_BSLASHVref] = ACTIONS(6482),
    [anon_sym_BSLASHautoref] = ACTIONS(6482),
    [anon_sym_BSLASHpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcref] = ACTIONS(6482),
    [anon_sym_BSLASHCref] = ACTIONS(6482),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnameCref] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6482),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6482),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6482),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6482),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6482),
    [anon_sym_BSLASHdef] = ACTIONS(6482),
    [anon_sym_BSLASHlet] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6482),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6482),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6482),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6482),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6482),
    [anon_sym_BSLASHgls] = ACTIONS(6482),
    [anon_sym_BSLASHGls] = ACTIONS(6482),
    [anon_sym_BSLASHGLS] = ACTIONS(6482),
    [anon_sym_BSLASHglspl] = ACTIONS(6482),
    [anon_sym_BSLASHGlspl] = ACTIONS(6482),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6482),
    [anon_sym_BSLASHglslink] = ACTIONS(6482),
    [anon_sym_BSLASHglstext] = ACTIONS(6482),
    [anon_sym_BSLASHGlstext] = ACTIONS(6482),
    [anon_sym_BSLASHGLStext] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6482),
    [anon_sym_BSLASHglsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6482),
    [anon_sym_BSLASHglsname] = ACTIONS(6482),
    [anon_sym_BSLASHGlsname] = ACTIONS(6482),
    [anon_sym_BSLASHGLSname] = ACTIONS(6482),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6482),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6482),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6482),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6482),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6482),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6482),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6482),
    [anon_sym_BSLASHacrshort] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6482),
    [anon_sym_BSLASHACRshort] = ACTIONS(6482),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrlong] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6482),
    [anon_sym_BSLASHACRlong] = ACTIONS(6482),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6482),
    [anon_sym_BSLASHacrfull] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6482),
    [anon_sym_BSLASHACRfull] = ACTIONS(6482),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHacs] = ACTIONS(6482),
    [anon_sym_BSLASHAcs] = ACTIONS(6482),
    [anon_sym_BSLASHacsp] = ACTIONS(6482),
    [anon_sym_BSLASHAcsp] = ACTIONS(6482),
    [anon_sym_BSLASHacl] = ACTIONS(6482),
    [anon_sym_BSLASHAcl] = ACTIONS(6482),
    [anon_sym_BSLASHaclp] = ACTIONS(6482),
    [anon_sym_BSLASHAclp] = ACTIONS(6482),
    [anon_sym_BSLASHacf] = ACTIONS(6482),
    [anon_sym_BSLASHAcf] = ACTIONS(6482),
    [anon_sym_BSLASHacfp] = ACTIONS(6482),
    [anon_sym_BSLASHAcfp] = ACTIONS(6482),
    [anon_sym_BSLASHac] = ACTIONS(6482),
    [anon_sym_BSLASHAc] = ACTIONS(6482),
    [anon_sym_BSLASHacp] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6482),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6482),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6482),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6482),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6484),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6482),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6482),
    [anon_sym_BSLASHcolor] = ACTIONS(6482),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6482),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6482),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6482),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6482),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6482),
    [anon_sym_BSLASHurl] = ACTIONS(6482),
    [anon_sym_BSLASHhref] = ACTIONS(6482),
  },
  [2040] = {
    [sym_command_name] = ACTIONS(6486),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6486),
    [anon_sym_RBRACK] = ACTIONS(6488),
    [anon_sym_COMMA] = ACTIONS(6488),
    [anon_sym_EQ] = ACTIONS(6488),
    [anon_sym_RBRACE] = ACTIONS(6488),
    [sym_word] = ACTIONS(6486),
    [sym_placeholder] = ACTIONS(6488),
    [anon_sym_PLUS] = ACTIONS(6488),
    [anon_sym_DASH] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6488),
    [anon_sym_SLASH] = ACTIONS(6488),
    [anon_sym_LT] = ACTIONS(6486),
    [anon_sym_GT] = ACTIONS(6486),
    [anon_sym_BANG] = ACTIONS(6486),
    [anon_sym_PIPE] = ACTIONS(6486),
    [anon_sym_COLON] = ACTIONS(6486),
    [anon_sym_SQUOTE] = ACTIONS(6486),
    [anon_sym__] = ACTIONS(6488),
    [anon_sym_CARET] = ACTIONS(6488),
    [anon_sym_BSLASHtitle] = ACTIONS(6486),
    [anon_sym_BSLASHauthor] = ACTIONS(6486),
    [anon_sym_BSLASHusepackage] = ACTIONS(6486),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6486),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6486),
    [anon_sym_BSLASHinclude] = ACTIONS(6486),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6486),
    [anon_sym_BSLASHinput] = ACTIONS(6486),
    [anon_sym_BSLASHsubfile] = ACTIONS(6486),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6486),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6486),
    [anon_sym_BSLASHbibliography] = ACTIONS(6486),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6486),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6486),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6486),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6486),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6486),
    [anon_sym_BSLASHimport] = ACTIONS(6486),
    [anon_sym_BSLASHsubimport] = ACTIONS(6486),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6486),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6486),
    [anon_sym_BSLASHcaption] = ACTIONS(6486),
    [anon_sym_BSLASHcite] = ACTIONS(6486),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCite] = ACTIONS(6486),
    [anon_sym_BSLASHnocite] = ACTIONS(6486),
    [anon_sym_BSLASHcitet] = ACTIONS(6486),
    [anon_sym_BSLASHcitep] = ACTIONS(6486),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteA] = ACTIONS(6486),
    [anon_sym_BSLASHciteR] = ACTIONS(6486),
    [anon_sym_BSLASHciteS] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6486),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6486),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteyear] = ACTIONS(6486),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHcitedate] = ACTIONS(6486),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHciteurl] = ACTIONS(6486),
    [anon_sym_BSLASHfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6486),
    [anon_sym_BSLASHcitealt] = ACTIONS(6486),
    [anon_sym_BSLASHcitealp] = ACTIONS(6486),
    [anon_sym_BSLASHcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHparencite] = ACTIONS(6486),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHParencite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6486),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6486),
    [anon_sym_BSLASHtextcite] = ACTIONS(6486),
    [anon_sym_BSLASHTextcite] = ACTIONS(6486),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6486),
    [anon_sym_BSLASHsupercite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite] = ACTIONS(6486),
    [anon_sym_BSLASHAutocite] = ACTIONS(6486),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHVolcite] = ACTIONS(6486),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHavolcite] = ACTIONS(6486),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6486),
    [anon_sym_BSLASHnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHNotecite] = ACTIONS(6486),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6486),
    [anon_sym_BSLASHlabel] = ACTIONS(6486),
    [anon_sym_BSLASHref] = ACTIONS(6486),
    [anon_sym_BSLASHeqref] = ACTIONS(6486),
    [anon_sym_BSLASHvref] = ACTIONS(6486),
    [anon_sym_BSLASHVref] = ACTIONS(6486),
    [anon_sym_BSLASHautoref] = ACTIONS(6486),
    [anon_sym_BSLASHpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcref] = ACTIONS(6486),
    [anon_sym_BSLASHCref] = ACTIONS(6486),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnameCref] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6486),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6486),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6486),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6486),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6486),
    [anon_sym_BSLASHdef] = ACTIONS(6486),
    [anon_sym_BSLASHlet] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6486),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6486),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6486),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6486),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6486),
    [anon_sym_BSLASHgls] = ACTIONS(6486),
    [anon_sym_BSLASHGls] = ACTIONS(6486),
    [anon_sym_BSLASHGLS] = ACTIONS(6486),
    [anon_sym_BSLASHglspl] = ACTIONS(6486),
    [anon_sym_BSLASHGlspl] = ACTIONS(6486),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6486),
    [anon_sym_BSLASHglslink] = ACTIONS(6486),
    [anon_sym_BSLASHglstext] = ACTIONS(6486),
    [anon_sym_BSLASHGlstext] = ACTIONS(6486),
    [anon_sym_BSLASHGLStext] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6486),
    [anon_sym_BSLASHglsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6486),
    [anon_sym_BSLASHglsname] = ACTIONS(6486),
    [anon_sym_BSLASHGlsname] = ACTIONS(6486),
    [anon_sym_BSLASHGLSname] = ACTIONS(6486),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6486),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6486),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6486),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6486),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6486),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6486),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6486),
    [anon_sym_BSLASHacrshort] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6486),
    [anon_sym_BSLASHACRshort] = ACTIONS(6486),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrlong] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6486),
    [anon_sym_BSLASHACRlong] = ACTIONS(6486),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6486),
    [anon_sym_BSLASHacrfull] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6486),
    [anon_sym_BSLASHACRfull] = ACTIONS(6486),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHacs] = ACTIONS(6486),
    [anon_sym_BSLASHAcs] = ACTIONS(6486),
    [anon_sym_BSLASHacsp] = ACTIONS(6486),
    [anon_sym_BSLASHAcsp] = ACTIONS(6486),
    [anon_sym_BSLASHacl] = ACTIONS(6486),
    [anon_sym_BSLASHAcl] = ACTIONS(6486),
    [anon_sym_BSLASHaclp] = ACTIONS(6486),
    [anon_sym_BSLASHAclp] = ACTIONS(6486),
    [anon_sym_BSLASHacf] = ACTIONS(6486),
    [anon_sym_BSLASHAcf] = ACTIONS(6486),
    [anon_sym_BSLASHacfp] = ACTIONS(6486),
    [anon_sym_BSLASHAcfp] = ACTIONS(6486),
    [anon_sym_BSLASHac] = ACTIONS(6486),
    [anon_sym_BSLASHAc] = ACTIONS(6486),
    [anon_sym_BSLASHacp] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6486),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6486),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6486),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6486),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6488),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6486),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6486),
    [anon_sym_BSLASHcolor] = ACTIONS(6486),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6486),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6486),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6486),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6486),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6486),
    [anon_sym_BSLASHurl] = ACTIONS(6486),
    [anon_sym_BSLASHhref] = ACTIONS(6486),
  },
  [2041] = {
    [sym_command_name] = ACTIONS(6498),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6498),
    [anon_sym_RBRACK] = ACTIONS(6500),
    [anon_sym_COMMA] = ACTIONS(6500),
    [anon_sym_EQ] = ACTIONS(6500),
    [anon_sym_RBRACE] = ACTIONS(6500),
    [sym_word] = ACTIONS(6498),
    [sym_placeholder] = ACTIONS(6500),
    [anon_sym_PLUS] = ACTIONS(6500),
    [anon_sym_DASH] = ACTIONS(6500),
    [anon_sym_STAR] = ACTIONS(6500),
    [anon_sym_SLASH] = ACTIONS(6500),
    [anon_sym_LT] = ACTIONS(6498),
    [anon_sym_GT] = ACTIONS(6498),
    [anon_sym_BANG] = ACTIONS(6498),
    [anon_sym_PIPE] = ACTIONS(6498),
    [anon_sym_COLON] = ACTIONS(6498),
    [anon_sym_SQUOTE] = ACTIONS(6498),
    [anon_sym__] = ACTIONS(6500),
    [anon_sym_CARET] = ACTIONS(6500),
    [anon_sym_BSLASHtitle] = ACTIONS(6498),
    [anon_sym_BSLASHauthor] = ACTIONS(6498),
    [anon_sym_BSLASHusepackage] = ACTIONS(6498),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6498),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6498),
    [anon_sym_BSLASHinclude] = ACTIONS(6498),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6498),
    [anon_sym_BSLASHinput] = ACTIONS(6498),
    [anon_sym_BSLASHsubfile] = ACTIONS(6498),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6498),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6498),
    [anon_sym_BSLASHbibliography] = ACTIONS(6498),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6498),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6498),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6498),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6498),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6498),
    [anon_sym_BSLASHimport] = ACTIONS(6498),
    [anon_sym_BSLASHsubimport] = ACTIONS(6498),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6498),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6498),
    [anon_sym_BSLASHcaption] = ACTIONS(6498),
    [anon_sym_BSLASHcite] = ACTIONS(6498),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCite] = ACTIONS(6498),
    [anon_sym_BSLASHnocite] = ACTIONS(6498),
    [anon_sym_BSLASHcitet] = ACTIONS(6498),
    [anon_sym_BSLASHcitep] = ACTIONS(6498),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteA] = ACTIONS(6498),
    [anon_sym_BSLASHciteR] = ACTIONS(6498),
    [anon_sym_BSLASHciteS] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6498),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6498),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteyear] = ACTIONS(6498),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHcitedate] = ACTIONS(6498),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHciteurl] = ACTIONS(6498),
    [anon_sym_BSLASHfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6498),
    [anon_sym_BSLASHcitealt] = ACTIONS(6498),
    [anon_sym_BSLASHcitealp] = ACTIONS(6498),
    [anon_sym_BSLASHcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHparencite] = ACTIONS(6498),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHParencite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6498),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6498),
    [anon_sym_BSLASHtextcite] = ACTIONS(6498),
    [anon_sym_BSLASHTextcite] = ACTIONS(6498),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6498),
    [anon_sym_BSLASHsupercite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite] = ACTIONS(6498),
    [anon_sym_BSLASHAutocite] = ACTIONS(6498),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHVolcite] = ACTIONS(6498),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHavolcite] = ACTIONS(6498),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6498),
    [anon_sym_BSLASHnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHNotecite] = ACTIONS(6498),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6498),
    [anon_sym_BSLASHlabel] = ACTIONS(6498),
    [anon_sym_BSLASHref] = ACTIONS(6498),
    [anon_sym_BSLASHeqref] = ACTIONS(6498),
    [anon_sym_BSLASHvref] = ACTIONS(6498),
    [anon_sym_BSLASHVref] = ACTIONS(6498),
    [anon_sym_BSLASHautoref] = ACTIONS(6498),
    [anon_sym_BSLASHpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcref] = ACTIONS(6498),
    [anon_sym_BSLASHCref] = ACTIONS(6498),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnameCref] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6498),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6498),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6498),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6498),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6498),
    [anon_sym_BSLASHdef] = ACTIONS(6498),
    [anon_sym_BSLASHlet] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6498),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6498),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6498),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6498),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6498),
    [anon_sym_BSLASHgls] = ACTIONS(6498),
    [anon_sym_BSLASHGls] = ACTIONS(6498),
    [anon_sym_BSLASHGLS] = ACTIONS(6498),
    [anon_sym_BSLASHglspl] = ACTIONS(6498),
    [anon_sym_BSLASHGlspl] = ACTIONS(6498),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6498),
    [anon_sym_BSLASHglslink] = ACTIONS(6498),
    [anon_sym_BSLASHglstext] = ACTIONS(6498),
    [anon_sym_BSLASHGlstext] = ACTIONS(6498),
    [anon_sym_BSLASHGLStext] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6498),
    [anon_sym_BSLASHglsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6498),
    [anon_sym_BSLASHglsname] = ACTIONS(6498),
    [anon_sym_BSLASHGlsname] = ACTIONS(6498),
    [anon_sym_BSLASHGLSname] = ACTIONS(6498),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6498),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6498),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6498),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6498),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6498),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6498),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6498),
    [anon_sym_BSLASHacrshort] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6498),
    [anon_sym_BSLASHACRshort] = ACTIONS(6498),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrlong] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6498),
    [anon_sym_BSLASHACRlong] = ACTIONS(6498),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6498),
    [anon_sym_BSLASHacrfull] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6498),
    [anon_sym_BSLASHACRfull] = ACTIONS(6498),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHacs] = ACTIONS(6498),
    [anon_sym_BSLASHAcs] = ACTIONS(6498),
    [anon_sym_BSLASHacsp] = ACTIONS(6498),
    [anon_sym_BSLASHAcsp] = ACTIONS(6498),
    [anon_sym_BSLASHacl] = ACTIONS(6498),
    [anon_sym_BSLASHAcl] = ACTIONS(6498),
    [anon_sym_BSLASHaclp] = ACTIONS(6498),
    [anon_sym_BSLASHAclp] = ACTIONS(6498),
    [anon_sym_BSLASHacf] = ACTIONS(6498),
    [anon_sym_BSLASHAcf] = ACTIONS(6498),
    [anon_sym_BSLASHacfp] = ACTIONS(6498),
    [anon_sym_BSLASHAcfp] = ACTIONS(6498),
    [anon_sym_BSLASHac] = ACTIONS(6498),
    [anon_sym_BSLASHAc] = ACTIONS(6498),
    [anon_sym_BSLASHacp] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6498),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6498),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6498),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6498),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6500),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6498),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6498),
    [anon_sym_BSLASHcolor] = ACTIONS(6498),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6498),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6498),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6498),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6498),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6498),
    [anon_sym_BSLASHurl] = ACTIONS(6498),
    [anon_sym_BSLASHhref] = ACTIONS(6498),
  },
  [2042] = {
    [sym_command_name] = ACTIONS(6318),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6318),
    [anon_sym_RBRACK] = ACTIONS(6320),
    [anon_sym_COMMA] = ACTIONS(6320),
    [anon_sym_EQ] = ACTIONS(6320),
    [anon_sym_RBRACE] = ACTIONS(6320),
    [sym_word] = ACTIONS(6318),
    [sym_placeholder] = ACTIONS(6320),
    [anon_sym_PLUS] = ACTIONS(6320),
    [anon_sym_DASH] = ACTIONS(6320),
    [anon_sym_STAR] = ACTIONS(6320),
    [anon_sym_SLASH] = ACTIONS(6320),
    [anon_sym_LT] = ACTIONS(6318),
    [anon_sym_GT] = ACTIONS(6318),
    [anon_sym_BANG] = ACTIONS(6318),
    [anon_sym_PIPE] = ACTIONS(6318),
    [anon_sym_COLON] = ACTIONS(6318),
    [anon_sym_SQUOTE] = ACTIONS(6318),
    [anon_sym__] = ACTIONS(6320),
    [anon_sym_CARET] = ACTIONS(6320),
    [anon_sym_BSLASHtitle] = ACTIONS(6318),
    [anon_sym_BSLASHauthor] = ACTIONS(6318),
    [anon_sym_BSLASHusepackage] = ACTIONS(6318),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6318),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6318),
    [anon_sym_BSLASHinclude] = ACTIONS(6318),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6318),
    [anon_sym_BSLASHinput] = ACTIONS(6318),
    [anon_sym_BSLASHsubfile] = ACTIONS(6318),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6318),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6318),
    [anon_sym_BSLASHbibliography] = ACTIONS(6318),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6318),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6318),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6318),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6318),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6318),
    [anon_sym_BSLASHimport] = ACTIONS(6318),
    [anon_sym_BSLASHsubimport] = ACTIONS(6318),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6318),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6318),
    [anon_sym_BSLASHcaption] = ACTIONS(6318),
    [anon_sym_BSLASHcite] = ACTIONS(6318),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCite] = ACTIONS(6318),
    [anon_sym_BSLASHnocite] = ACTIONS(6318),
    [anon_sym_BSLASHcitet] = ACTIONS(6318),
    [anon_sym_BSLASHcitep] = ACTIONS(6318),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteA] = ACTIONS(6318),
    [anon_sym_BSLASHciteR] = ACTIONS(6318),
    [anon_sym_BSLASHciteS] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6318),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6318),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteyear] = ACTIONS(6318),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHcitedate] = ACTIONS(6318),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHciteurl] = ACTIONS(6318),
    [anon_sym_BSLASHfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6318),
    [anon_sym_BSLASHcitealt] = ACTIONS(6318),
    [anon_sym_BSLASHcitealp] = ACTIONS(6318),
    [anon_sym_BSLASHcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHparencite] = ACTIONS(6318),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHParencite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6318),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6318),
    [anon_sym_BSLASHtextcite] = ACTIONS(6318),
    [anon_sym_BSLASHTextcite] = ACTIONS(6318),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6318),
    [anon_sym_BSLASHsupercite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite] = ACTIONS(6318),
    [anon_sym_BSLASHAutocite] = ACTIONS(6318),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHVolcite] = ACTIONS(6318),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHavolcite] = ACTIONS(6318),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6318),
    [anon_sym_BSLASHnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHNotecite] = ACTIONS(6318),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6318),
    [anon_sym_BSLASHlabel] = ACTIONS(6318),
    [anon_sym_BSLASHref] = ACTIONS(6318),
    [anon_sym_BSLASHeqref] = ACTIONS(6318),
    [anon_sym_BSLASHvref] = ACTIONS(6318),
    [anon_sym_BSLASHVref] = ACTIONS(6318),
    [anon_sym_BSLASHautoref] = ACTIONS(6318),
    [anon_sym_BSLASHpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcref] = ACTIONS(6318),
    [anon_sym_BSLASHCref] = ACTIONS(6318),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnameCref] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6318),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6318),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6318),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6318),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6318),
    [anon_sym_BSLASHdef] = ACTIONS(6318),
    [anon_sym_BSLASHlet] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6318),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6318),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6318),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6318),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6318),
    [anon_sym_BSLASHgls] = ACTIONS(6318),
    [anon_sym_BSLASHGls] = ACTIONS(6318),
    [anon_sym_BSLASHGLS] = ACTIONS(6318),
    [anon_sym_BSLASHglspl] = ACTIONS(6318),
    [anon_sym_BSLASHGlspl] = ACTIONS(6318),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6318),
    [anon_sym_BSLASHglslink] = ACTIONS(6318),
    [anon_sym_BSLASHglstext] = ACTIONS(6318),
    [anon_sym_BSLASHGlstext] = ACTIONS(6318),
    [anon_sym_BSLASHGLStext] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6318),
    [anon_sym_BSLASHglsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6318),
    [anon_sym_BSLASHglsname] = ACTIONS(6318),
    [anon_sym_BSLASHGlsname] = ACTIONS(6318),
    [anon_sym_BSLASHGLSname] = ACTIONS(6318),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6318),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6318),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6318),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6318),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6318),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6318),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6318),
    [anon_sym_BSLASHacrshort] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6318),
    [anon_sym_BSLASHACRshort] = ACTIONS(6318),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrlong] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6318),
    [anon_sym_BSLASHACRlong] = ACTIONS(6318),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6318),
    [anon_sym_BSLASHacrfull] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6318),
    [anon_sym_BSLASHACRfull] = ACTIONS(6318),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHacs] = ACTIONS(6318),
    [anon_sym_BSLASHAcs] = ACTIONS(6318),
    [anon_sym_BSLASHacsp] = ACTIONS(6318),
    [anon_sym_BSLASHAcsp] = ACTIONS(6318),
    [anon_sym_BSLASHacl] = ACTIONS(6318),
    [anon_sym_BSLASHAcl] = ACTIONS(6318),
    [anon_sym_BSLASHaclp] = ACTIONS(6318),
    [anon_sym_BSLASHAclp] = ACTIONS(6318),
    [anon_sym_BSLASHacf] = ACTIONS(6318),
    [anon_sym_BSLASHAcf] = ACTIONS(6318),
    [anon_sym_BSLASHacfp] = ACTIONS(6318),
    [anon_sym_BSLASHAcfp] = ACTIONS(6318),
    [anon_sym_BSLASHac] = ACTIONS(6318),
    [anon_sym_BSLASHAc] = ACTIONS(6318),
    [anon_sym_BSLASHacp] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6318),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6318),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6318),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6318),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6320),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6318),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6318),
    [anon_sym_BSLASHcolor] = ACTIONS(6318),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6318),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6318),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6318),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6318),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6318),
    [anon_sym_BSLASHurl] = ACTIONS(6318),
    [anon_sym_BSLASHhref] = ACTIONS(6318),
  },
  [2043] = {
    [sym_command_name] = ACTIONS(6506),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6506),
    [anon_sym_RBRACK] = ACTIONS(6508),
    [anon_sym_COMMA] = ACTIONS(6508),
    [anon_sym_EQ] = ACTIONS(6508),
    [anon_sym_RBRACE] = ACTIONS(6508),
    [sym_word] = ACTIONS(6506),
    [sym_placeholder] = ACTIONS(6508),
    [anon_sym_PLUS] = ACTIONS(6508),
    [anon_sym_DASH] = ACTIONS(6508),
    [anon_sym_STAR] = ACTIONS(6508),
    [anon_sym_SLASH] = ACTIONS(6508),
    [anon_sym_LT] = ACTIONS(6506),
    [anon_sym_GT] = ACTIONS(6506),
    [anon_sym_BANG] = ACTIONS(6506),
    [anon_sym_PIPE] = ACTIONS(6506),
    [anon_sym_COLON] = ACTIONS(6506),
    [anon_sym_SQUOTE] = ACTIONS(6506),
    [anon_sym__] = ACTIONS(6508),
    [anon_sym_CARET] = ACTIONS(6508),
    [anon_sym_BSLASHtitle] = ACTIONS(6506),
    [anon_sym_BSLASHauthor] = ACTIONS(6506),
    [anon_sym_BSLASHusepackage] = ACTIONS(6506),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6506),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6506),
    [anon_sym_BSLASHinclude] = ACTIONS(6506),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6506),
    [anon_sym_BSLASHinput] = ACTIONS(6506),
    [anon_sym_BSLASHsubfile] = ACTIONS(6506),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6506),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6506),
    [anon_sym_BSLASHbibliography] = ACTIONS(6506),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6506),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6506),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6506),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6506),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6506),
    [anon_sym_BSLASHimport] = ACTIONS(6506),
    [anon_sym_BSLASHsubimport] = ACTIONS(6506),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6506),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6506),
    [anon_sym_BSLASHcaption] = ACTIONS(6506),
    [anon_sym_BSLASHcite] = ACTIONS(6506),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCite] = ACTIONS(6506),
    [anon_sym_BSLASHnocite] = ACTIONS(6506),
    [anon_sym_BSLASHcitet] = ACTIONS(6506),
    [anon_sym_BSLASHcitep] = ACTIONS(6506),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteA] = ACTIONS(6506),
    [anon_sym_BSLASHciteR] = ACTIONS(6506),
    [anon_sym_BSLASHciteS] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6506),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6506),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteyear] = ACTIONS(6506),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHcitedate] = ACTIONS(6506),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHciteurl] = ACTIONS(6506),
    [anon_sym_BSLASHfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6506),
    [anon_sym_BSLASHcitealt] = ACTIONS(6506),
    [anon_sym_BSLASHcitealp] = ACTIONS(6506),
    [anon_sym_BSLASHcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHparencite] = ACTIONS(6506),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHParencite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6506),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6506),
    [anon_sym_BSLASHtextcite] = ACTIONS(6506),
    [anon_sym_BSLASHTextcite] = ACTIONS(6506),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6506),
    [anon_sym_BSLASHsupercite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite] = ACTIONS(6506),
    [anon_sym_BSLASHAutocite] = ACTIONS(6506),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHVolcite] = ACTIONS(6506),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHavolcite] = ACTIONS(6506),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6506),
    [anon_sym_BSLASHnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHNotecite] = ACTIONS(6506),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6506),
    [anon_sym_BSLASHlabel] = ACTIONS(6506),
    [anon_sym_BSLASHref] = ACTIONS(6506),
    [anon_sym_BSLASHeqref] = ACTIONS(6506),
    [anon_sym_BSLASHvref] = ACTIONS(6506),
    [anon_sym_BSLASHVref] = ACTIONS(6506),
    [anon_sym_BSLASHautoref] = ACTIONS(6506),
    [anon_sym_BSLASHpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcref] = ACTIONS(6506),
    [anon_sym_BSLASHCref] = ACTIONS(6506),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnameCref] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6506),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6506),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6506),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6506),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6506),
    [anon_sym_BSLASHdef] = ACTIONS(6506),
    [anon_sym_BSLASHlet] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6506),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6506),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6506),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6506),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6506),
    [anon_sym_BSLASHgls] = ACTIONS(6506),
    [anon_sym_BSLASHGls] = ACTIONS(6506),
    [anon_sym_BSLASHGLS] = ACTIONS(6506),
    [anon_sym_BSLASHglspl] = ACTIONS(6506),
    [anon_sym_BSLASHGlspl] = ACTIONS(6506),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6506),
    [anon_sym_BSLASHglslink] = ACTIONS(6506),
    [anon_sym_BSLASHglstext] = ACTIONS(6506),
    [anon_sym_BSLASHGlstext] = ACTIONS(6506),
    [anon_sym_BSLASHGLStext] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6506),
    [anon_sym_BSLASHglsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6506),
    [anon_sym_BSLASHglsname] = ACTIONS(6506),
    [anon_sym_BSLASHGlsname] = ACTIONS(6506),
    [anon_sym_BSLASHGLSname] = ACTIONS(6506),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6506),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6506),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6506),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6506),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6506),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6506),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6506),
    [anon_sym_BSLASHacrshort] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6506),
    [anon_sym_BSLASHACRshort] = ACTIONS(6506),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrlong] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6506),
    [anon_sym_BSLASHACRlong] = ACTIONS(6506),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6506),
    [anon_sym_BSLASHacrfull] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6506),
    [anon_sym_BSLASHACRfull] = ACTIONS(6506),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHacs] = ACTIONS(6506),
    [anon_sym_BSLASHAcs] = ACTIONS(6506),
    [anon_sym_BSLASHacsp] = ACTIONS(6506),
    [anon_sym_BSLASHAcsp] = ACTIONS(6506),
    [anon_sym_BSLASHacl] = ACTIONS(6506),
    [anon_sym_BSLASHAcl] = ACTIONS(6506),
    [anon_sym_BSLASHaclp] = ACTIONS(6506),
    [anon_sym_BSLASHAclp] = ACTIONS(6506),
    [anon_sym_BSLASHacf] = ACTIONS(6506),
    [anon_sym_BSLASHAcf] = ACTIONS(6506),
    [anon_sym_BSLASHacfp] = ACTIONS(6506),
    [anon_sym_BSLASHAcfp] = ACTIONS(6506),
    [anon_sym_BSLASHac] = ACTIONS(6506),
    [anon_sym_BSLASHAc] = ACTIONS(6506),
    [anon_sym_BSLASHacp] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6506),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6506),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6506),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6506),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6508),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6506),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6506),
    [anon_sym_BSLASHcolor] = ACTIONS(6506),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6506),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6506),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6506),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6506),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6506),
    [anon_sym_BSLASHurl] = ACTIONS(6506),
    [anon_sym_BSLASHhref] = ACTIONS(6506),
  },
  [2044] = {
    [sym_command_name] = ACTIONS(6510),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6510),
    [anon_sym_RBRACK] = ACTIONS(6512),
    [anon_sym_COMMA] = ACTIONS(6512),
    [anon_sym_EQ] = ACTIONS(6512),
    [anon_sym_RBRACE] = ACTIONS(6512),
    [sym_word] = ACTIONS(6510),
    [sym_placeholder] = ACTIONS(6512),
    [anon_sym_PLUS] = ACTIONS(6512),
    [anon_sym_DASH] = ACTIONS(6512),
    [anon_sym_STAR] = ACTIONS(6512),
    [anon_sym_SLASH] = ACTIONS(6512),
    [anon_sym_LT] = ACTIONS(6510),
    [anon_sym_GT] = ACTIONS(6510),
    [anon_sym_BANG] = ACTIONS(6510),
    [anon_sym_PIPE] = ACTIONS(6510),
    [anon_sym_COLON] = ACTIONS(6510),
    [anon_sym_SQUOTE] = ACTIONS(6510),
    [anon_sym__] = ACTIONS(6512),
    [anon_sym_CARET] = ACTIONS(6512),
    [anon_sym_BSLASHtitle] = ACTIONS(6510),
    [anon_sym_BSLASHauthor] = ACTIONS(6510),
    [anon_sym_BSLASHusepackage] = ACTIONS(6510),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6510),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6510),
    [anon_sym_BSLASHinclude] = ACTIONS(6510),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6510),
    [anon_sym_BSLASHinput] = ACTIONS(6510),
    [anon_sym_BSLASHsubfile] = ACTIONS(6510),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6510),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6510),
    [anon_sym_BSLASHbibliography] = ACTIONS(6510),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6510),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6510),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6510),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6510),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6510),
    [anon_sym_BSLASHimport] = ACTIONS(6510),
    [anon_sym_BSLASHsubimport] = ACTIONS(6510),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6510),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6510),
    [anon_sym_BSLASHcaption] = ACTIONS(6510),
    [anon_sym_BSLASHcite] = ACTIONS(6510),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCite] = ACTIONS(6510),
    [anon_sym_BSLASHnocite] = ACTIONS(6510),
    [anon_sym_BSLASHcitet] = ACTIONS(6510),
    [anon_sym_BSLASHcitep] = ACTIONS(6510),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteA] = ACTIONS(6510),
    [anon_sym_BSLASHciteR] = ACTIONS(6510),
    [anon_sym_BSLASHciteS] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6510),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6510),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteyear] = ACTIONS(6510),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHcitedate] = ACTIONS(6510),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHciteurl] = ACTIONS(6510),
    [anon_sym_BSLASHfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6510),
    [anon_sym_BSLASHcitealt] = ACTIONS(6510),
    [anon_sym_BSLASHcitealp] = ACTIONS(6510),
    [anon_sym_BSLASHcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHparencite] = ACTIONS(6510),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHParencite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6510),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6510),
    [anon_sym_BSLASHtextcite] = ACTIONS(6510),
    [anon_sym_BSLASHTextcite] = ACTIONS(6510),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6510),
    [anon_sym_BSLASHsupercite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite] = ACTIONS(6510),
    [anon_sym_BSLASHAutocite] = ACTIONS(6510),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHVolcite] = ACTIONS(6510),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHavolcite] = ACTIONS(6510),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6510),
    [anon_sym_BSLASHnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHNotecite] = ACTIONS(6510),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6510),
    [anon_sym_BSLASHlabel] = ACTIONS(6510),
    [anon_sym_BSLASHref] = ACTIONS(6510),
    [anon_sym_BSLASHeqref] = ACTIONS(6510),
    [anon_sym_BSLASHvref] = ACTIONS(6510),
    [anon_sym_BSLASHVref] = ACTIONS(6510),
    [anon_sym_BSLASHautoref] = ACTIONS(6510),
    [anon_sym_BSLASHpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcref] = ACTIONS(6510),
    [anon_sym_BSLASHCref] = ACTIONS(6510),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnameCref] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6510),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6510),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6510),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6510),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6510),
    [anon_sym_BSLASHdef] = ACTIONS(6510),
    [anon_sym_BSLASHlet] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6510),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6510),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6510),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6510),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6510),
    [anon_sym_BSLASHgls] = ACTIONS(6510),
    [anon_sym_BSLASHGls] = ACTIONS(6510),
    [anon_sym_BSLASHGLS] = ACTIONS(6510),
    [anon_sym_BSLASHglspl] = ACTIONS(6510),
    [anon_sym_BSLASHGlspl] = ACTIONS(6510),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6510),
    [anon_sym_BSLASHglslink] = ACTIONS(6510),
    [anon_sym_BSLASHglstext] = ACTIONS(6510),
    [anon_sym_BSLASHGlstext] = ACTIONS(6510),
    [anon_sym_BSLASHGLStext] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6510),
    [anon_sym_BSLASHglsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6510),
    [anon_sym_BSLASHglsname] = ACTIONS(6510),
    [anon_sym_BSLASHGlsname] = ACTIONS(6510),
    [anon_sym_BSLASHGLSname] = ACTIONS(6510),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6510),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6510),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6510),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6510),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6510),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6510),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6510),
    [anon_sym_BSLASHacrshort] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6510),
    [anon_sym_BSLASHACRshort] = ACTIONS(6510),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrlong] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6510),
    [anon_sym_BSLASHACRlong] = ACTIONS(6510),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6510),
    [anon_sym_BSLASHacrfull] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6510),
    [anon_sym_BSLASHACRfull] = ACTIONS(6510),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHacs] = ACTIONS(6510),
    [anon_sym_BSLASHAcs] = ACTIONS(6510),
    [anon_sym_BSLASHacsp] = ACTIONS(6510),
    [anon_sym_BSLASHAcsp] = ACTIONS(6510),
    [anon_sym_BSLASHacl] = ACTIONS(6510),
    [anon_sym_BSLASHAcl] = ACTIONS(6510),
    [anon_sym_BSLASHaclp] = ACTIONS(6510),
    [anon_sym_BSLASHAclp] = ACTIONS(6510),
    [anon_sym_BSLASHacf] = ACTIONS(6510),
    [anon_sym_BSLASHAcf] = ACTIONS(6510),
    [anon_sym_BSLASHacfp] = ACTIONS(6510),
    [anon_sym_BSLASHAcfp] = ACTIONS(6510),
    [anon_sym_BSLASHac] = ACTIONS(6510),
    [anon_sym_BSLASHAc] = ACTIONS(6510),
    [anon_sym_BSLASHacp] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6510),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6510),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6510),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6510),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6512),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6510),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6510),
    [anon_sym_BSLASHcolor] = ACTIONS(6510),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6510),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6510),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6510),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6510),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6510),
    [anon_sym_BSLASHurl] = ACTIONS(6510),
    [anon_sym_BSLASHhref] = ACTIONS(6510),
  },
  [2045] = {
    [sym_command_name] = ACTIONS(6514),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6514),
    [anon_sym_RBRACK] = ACTIONS(6516),
    [anon_sym_COMMA] = ACTIONS(6516),
    [anon_sym_EQ] = ACTIONS(6516),
    [anon_sym_RBRACE] = ACTIONS(6516),
    [sym_word] = ACTIONS(6514),
    [sym_placeholder] = ACTIONS(6516),
    [anon_sym_PLUS] = ACTIONS(6516),
    [anon_sym_DASH] = ACTIONS(6516),
    [anon_sym_STAR] = ACTIONS(6516),
    [anon_sym_SLASH] = ACTIONS(6516),
    [anon_sym_LT] = ACTIONS(6514),
    [anon_sym_GT] = ACTIONS(6514),
    [anon_sym_BANG] = ACTIONS(6514),
    [anon_sym_PIPE] = ACTIONS(6514),
    [anon_sym_COLON] = ACTIONS(6514),
    [anon_sym_SQUOTE] = ACTIONS(6514),
    [anon_sym__] = ACTIONS(6516),
    [anon_sym_CARET] = ACTIONS(6516),
    [anon_sym_BSLASHtitle] = ACTIONS(6514),
    [anon_sym_BSLASHauthor] = ACTIONS(6514),
    [anon_sym_BSLASHusepackage] = ACTIONS(6514),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6514),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6514),
    [anon_sym_BSLASHinclude] = ACTIONS(6514),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6514),
    [anon_sym_BSLASHinput] = ACTIONS(6514),
    [anon_sym_BSLASHsubfile] = ACTIONS(6514),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6514),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6514),
    [anon_sym_BSLASHbibliography] = ACTIONS(6514),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6514),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6514),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6514),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6514),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6514),
    [anon_sym_BSLASHimport] = ACTIONS(6514),
    [anon_sym_BSLASHsubimport] = ACTIONS(6514),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6514),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6514),
    [anon_sym_BSLASHcaption] = ACTIONS(6514),
    [anon_sym_BSLASHcite] = ACTIONS(6514),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCite] = ACTIONS(6514),
    [anon_sym_BSLASHnocite] = ACTIONS(6514),
    [anon_sym_BSLASHcitet] = ACTIONS(6514),
    [anon_sym_BSLASHcitep] = ACTIONS(6514),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteA] = ACTIONS(6514),
    [anon_sym_BSLASHciteR] = ACTIONS(6514),
    [anon_sym_BSLASHciteS] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6514),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6514),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteyear] = ACTIONS(6514),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHcitedate] = ACTIONS(6514),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHciteurl] = ACTIONS(6514),
    [anon_sym_BSLASHfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6514),
    [anon_sym_BSLASHcitealt] = ACTIONS(6514),
    [anon_sym_BSLASHcitealp] = ACTIONS(6514),
    [anon_sym_BSLASHcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHparencite] = ACTIONS(6514),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHParencite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6514),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6514),
    [anon_sym_BSLASHtextcite] = ACTIONS(6514),
    [anon_sym_BSLASHTextcite] = ACTIONS(6514),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6514),
    [anon_sym_BSLASHsupercite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite] = ACTIONS(6514),
    [anon_sym_BSLASHAutocite] = ACTIONS(6514),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHVolcite] = ACTIONS(6514),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHavolcite] = ACTIONS(6514),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6514),
    [anon_sym_BSLASHnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHNotecite] = ACTIONS(6514),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6514),
    [anon_sym_BSLASHlabel] = ACTIONS(6514),
    [anon_sym_BSLASHref] = ACTIONS(6514),
    [anon_sym_BSLASHeqref] = ACTIONS(6514),
    [anon_sym_BSLASHvref] = ACTIONS(6514),
    [anon_sym_BSLASHVref] = ACTIONS(6514),
    [anon_sym_BSLASHautoref] = ACTIONS(6514),
    [anon_sym_BSLASHpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcref] = ACTIONS(6514),
    [anon_sym_BSLASHCref] = ACTIONS(6514),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnameCref] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6514),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6514),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6514),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6514),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6514),
    [anon_sym_BSLASHdef] = ACTIONS(6514),
    [anon_sym_BSLASHlet] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6514),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6514),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6514),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6514),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6514),
    [anon_sym_BSLASHgls] = ACTIONS(6514),
    [anon_sym_BSLASHGls] = ACTIONS(6514),
    [anon_sym_BSLASHGLS] = ACTIONS(6514),
    [anon_sym_BSLASHglspl] = ACTIONS(6514),
    [anon_sym_BSLASHGlspl] = ACTIONS(6514),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6514),
    [anon_sym_BSLASHglslink] = ACTIONS(6514),
    [anon_sym_BSLASHglstext] = ACTIONS(6514),
    [anon_sym_BSLASHGlstext] = ACTIONS(6514),
    [anon_sym_BSLASHGLStext] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6514),
    [anon_sym_BSLASHglsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6514),
    [anon_sym_BSLASHglsname] = ACTIONS(6514),
    [anon_sym_BSLASHGlsname] = ACTIONS(6514),
    [anon_sym_BSLASHGLSname] = ACTIONS(6514),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6514),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6514),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6514),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6514),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6514),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6514),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6514),
    [anon_sym_BSLASHacrshort] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6514),
    [anon_sym_BSLASHACRshort] = ACTIONS(6514),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrlong] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6514),
    [anon_sym_BSLASHACRlong] = ACTIONS(6514),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6514),
    [anon_sym_BSLASHacrfull] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6514),
    [anon_sym_BSLASHACRfull] = ACTIONS(6514),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHacs] = ACTIONS(6514),
    [anon_sym_BSLASHAcs] = ACTIONS(6514),
    [anon_sym_BSLASHacsp] = ACTIONS(6514),
    [anon_sym_BSLASHAcsp] = ACTIONS(6514),
    [anon_sym_BSLASHacl] = ACTIONS(6514),
    [anon_sym_BSLASHAcl] = ACTIONS(6514),
    [anon_sym_BSLASHaclp] = ACTIONS(6514),
    [anon_sym_BSLASHAclp] = ACTIONS(6514),
    [anon_sym_BSLASHacf] = ACTIONS(6514),
    [anon_sym_BSLASHAcf] = ACTIONS(6514),
    [anon_sym_BSLASHacfp] = ACTIONS(6514),
    [anon_sym_BSLASHAcfp] = ACTIONS(6514),
    [anon_sym_BSLASHac] = ACTIONS(6514),
    [anon_sym_BSLASHAc] = ACTIONS(6514),
    [anon_sym_BSLASHacp] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6514),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6514),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6514),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6514),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6516),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6514),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6514),
    [anon_sym_BSLASHcolor] = ACTIONS(6514),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6514),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6514),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6514),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6514),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6514),
    [anon_sym_BSLASHurl] = ACTIONS(6514),
    [anon_sym_BSLASHhref] = ACTIONS(6514),
  },
  [2046] = {
    [sym_command_name] = ACTIONS(6518),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6518),
    [anon_sym_RBRACK] = ACTIONS(6520),
    [anon_sym_COMMA] = ACTIONS(6520),
    [anon_sym_EQ] = ACTIONS(6520),
    [anon_sym_RBRACE] = ACTIONS(6520),
    [sym_word] = ACTIONS(6518),
    [sym_placeholder] = ACTIONS(6520),
    [anon_sym_PLUS] = ACTIONS(6520),
    [anon_sym_DASH] = ACTIONS(6520),
    [anon_sym_STAR] = ACTIONS(6520),
    [anon_sym_SLASH] = ACTIONS(6520),
    [anon_sym_LT] = ACTIONS(6518),
    [anon_sym_GT] = ACTIONS(6518),
    [anon_sym_BANG] = ACTIONS(6518),
    [anon_sym_PIPE] = ACTIONS(6518),
    [anon_sym_COLON] = ACTIONS(6518),
    [anon_sym_SQUOTE] = ACTIONS(6518),
    [anon_sym__] = ACTIONS(6520),
    [anon_sym_CARET] = ACTIONS(6520),
    [anon_sym_BSLASHtitle] = ACTIONS(6518),
    [anon_sym_BSLASHauthor] = ACTIONS(6518),
    [anon_sym_BSLASHusepackage] = ACTIONS(6518),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6518),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6518),
    [anon_sym_BSLASHinclude] = ACTIONS(6518),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6518),
    [anon_sym_BSLASHinput] = ACTIONS(6518),
    [anon_sym_BSLASHsubfile] = ACTIONS(6518),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6518),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6518),
    [anon_sym_BSLASHbibliography] = ACTIONS(6518),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6518),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6518),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6518),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6518),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6518),
    [anon_sym_BSLASHimport] = ACTIONS(6518),
    [anon_sym_BSLASHsubimport] = ACTIONS(6518),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6518),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6518),
    [anon_sym_BSLASHcaption] = ACTIONS(6518),
    [anon_sym_BSLASHcite] = ACTIONS(6518),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCite] = ACTIONS(6518),
    [anon_sym_BSLASHnocite] = ACTIONS(6518),
    [anon_sym_BSLASHcitet] = ACTIONS(6518),
    [anon_sym_BSLASHcitep] = ACTIONS(6518),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteA] = ACTIONS(6518),
    [anon_sym_BSLASHciteR] = ACTIONS(6518),
    [anon_sym_BSLASHciteS] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6518),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6518),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteyear] = ACTIONS(6518),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHcitedate] = ACTIONS(6518),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHciteurl] = ACTIONS(6518),
    [anon_sym_BSLASHfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6518),
    [anon_sym_BSLASHcitealt] = ACTIONS(6518),
    [anon_sym_BSLASHcitealp] = ACTIONS(6518),
    [anon_sym_BSLASHcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHparencite] = ACTIONS(6518),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHParencite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6518),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6518),
    [anon_sym_BSLASHtextcite] = ACTIONS(6518),
    [anon_sym_BSLASHTextcite] = ACTIONS(6518),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6518),
    [anon_sym_BSLASHsupercite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite] = ACTIONS(6518),
    [anon_sym_BSLASHAutocite] = ACTIONS(6518),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHVolcite] = ACTIONS(6518),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHavolcite] = ACTIONS(6518),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6518),
    [anon_sym_BSLASHnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHNotecite] = ACTIONS(6518),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6518),
    [anon_sym_BSLASHlabel] = ACTIONS(6518),
    [anon_sym_BSLASHref] = ACTIONS(6518),
    [anon_sym_BSLASHeqref] = ACTIONS(6518),
    [anon_sym_BSLASHvref] = ACTIONS(6518),
    [anon_sym_BSLASHVref] = ACTIONS(6518),
    [anon_sym_BSLASHautoref] = ACTIONS(6518),
    [anon_sym_BSLASHpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcref] = ACTIONS(6518),
    [anon_sym_BSLASHCref] = ACTIONS(6518),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnameCref] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6518),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6518),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6518),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6518),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6518),
    [anon_sym_BSLASHdef] = ACTIONS(6518),
    [anon_sym_BSLASHlet] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6518),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6518),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6518),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6518),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6518),
    [anon_sym_BSLASHgls] = ACTIONS(6518),
    [anon_sym_BSLASHGls] = ACTIONS(6518),
    [anon_sym_BSLASHGLS] = ACTIONS(6518),
    [anon_sym_BSLASHglspl] = ACTIONS(6518),
    [anon_sym_BSLASHGlspl] = ACTIONS(6518),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6518),
    [anon_sym_BSLASHglslink] = ACTIONS(6518),
    [anon_sym_BSLASHglstext] = ACTIONS(6518),
    [anon_sym_BSLASHGlstext] = ACTIONS(6518),
    [anon_sym_BSLASHGLStext] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6518),
    [anon_sym_BSLASHglsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6518),
    [anon_sym_BSLASHglsname] = ACTIONS(6518),
    [anon_sym_BSLASHGlsname] = ACTIONS(6518),
    [anon_sym_BSLASHGLSname] = ACTIONS(6518),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6518),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6518),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6518),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6518),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6518),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6518),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6518),
    [anon_sym_BSLASHacrshort] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6518),
    [anon_sym_BSLASHACRshort] = ACTIONS(6518),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrlong] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6518),
    [anon_sym_BSLASHACRlong] = ACTIONS(6518),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6518),
    [anon_sym_BSLASHacrfull] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6518),
    [anon_sym_BSLASHACRfull] = ACTIONS(6518),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHacs] = ACTIONS(6518),
    [anon_sym_BSLASHAcs] = ACTIONS(6518),
    [anon_sym_BSLASHacsp] = ACTIONS(6518),
    [anon_sym_BSLASHAcsp] = ACTIONS(6518),
    [anon_sym_BSLASHacl] = ACTIONS(6518),
    [anon_sym_BSLASHAcl] = ACTIONS(6518),
    [anon_sym_BSLASHaclp] = ACTIONS(6518),
    [anon_sym_BSLASHAclp] = ACTIONS(6518),
    [anon_sym_BSLASHacf] = ACTIONS(6518),
    [anon_sym_BSLASHAcf] = ACTIONS(6518),
    [anon_sym_BSLASHacfp] = ACTIONS(6518),
    [anon_sym_BSLASHAcfp] = ACTIONS(6518),
    [anon_sym_BSLASHac] = ACTIONS(6518),
    [anon_sym_BSLASHAc] = ACTIONS(6518),
    [anon_sym_BSLASHacp] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6518),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6518),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6518),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6518),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6520),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6518),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6518),
    [anon_sym_BSLASHcolor] = ACTIONS(6518),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6518),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6518),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6518),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6518),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6518),
    [anon_sym_BSLASHurl] = ACTIONS(6518),
    [anon_sym_BSLASHhref] = ACTIONS(6518),
  },
  [2047] = {
    [sym_command_name] = ACTIONS(6572),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6572),
    [anon_sym_RBRACK] = ACTIONS(6574),
    [anon_sym_COMMA] = ACTIONS(6574),
    [anon_sym_EQ] = ACTIONS(6574),
    [anon_sym_RBRACE] = ACTIONS(6574),
    [sym_word] = ACTIONS(6572),
    [sym_placeholder] = ACTIONS(6574),
    [anon_sym_PLUS] = ACTIONS(6574),
    [anon_sym_DASH] = ACTIONS(6574),
    [anon_sym_STAR] = ACTIONS(6574),
    [anon_sym_SLASH] = ACTIONS(6574),
    [anon_sym_LT] = ACTIONS(6572),
    [anon_sym_GT] = ACTIONS(6572),
    [anon_sym_BANG] = ACTIONS(6572),
    [anon_sym_PIPE] = ACTIONS(6572),
    [anon_sym_COLON] = ACTIONS(6572),
    [anon_sym_SQUOTE] = ACTIONS(6572),
    [anon_sym__] = ACTIONS(6574),
    [anon_sym_CARET] = ACTIONS(6574),
    [anon_sym_BSLASHtitle] = ACTIONS(6572),
    [anon_sym_BSLASHauthor] = ACTIONS(6572),
    [anon_sym_BSLASHusepackage] = ACTIONS(6572),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6572),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6572),
    [anon_sym_BSLASHinclude] = ACTIONS(6572),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6572),
    [anon_sym_BSLASHinput] = ACTIONS(6572),
    [anon_sym_BSLASHsubfile] = ACTIONS(6572),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6572),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6572),
    [anon_sym_BSLASHbibliography] = ACTIONS(6572),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6572),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6572),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6572),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6572),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6572),
    [anon_sym_BSLASHimport] = ACTIONS(6572),
    [anon_sym_BSLASHsubimport] = ACTIONS(6572),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6572),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6572),
    [anon_sym_BSLASHcaption] = ACTIONS(6572),
    [anon_sym_BSLASHcite] = ACTIONS(6572),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCite] = ACTIONS(6572),
    [anon_sym_BSLASHnocite] = ACTIONS(6572),
    [anon_sym_BSLASHcitet] = ACTIONS(6572),
    [anon_sym_BSLASHcitep] = ACTIONS(6572),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteA] = ACTIONS(6572),
    [anon_sym_BSLASHciteR] = ACTIONS(6572),
    [anon_sym_BSLASHciteS] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6572),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6572),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteyear] = ACTIONS(6572),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHcitedate] = ACTIONS(6572),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHciteurl] = ACTIONS(6572),
    [anon_sym_BSLASHfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6572),
    [anon_sym_BSLASHcitealt] = ACTIONS(6572),
    [anon_sym_BSLASHcitealp] = ACTIONS(6572),
    [anon_sym_BSLASHcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHparencite] = ACTIONS(6572),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHParencite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6572),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6572),
    [anon_sym_BSLASHtextcite] = ACTIONS(6572),
    [anon_sym_BSLASHTextcite] = ACTIONS(6572),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6572),
    [anon_sym_BSLASHsupercite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite] = ACTIONS(6572),
    [anon_sym_BSLASHAutocite] = ACTIONS(6572),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHVolcite] = ACTIONS(6572),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHavolcite] = ACTIONS(6572),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6572),
    [anon_sym_BSLASHnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHNotecite] = ACTIONS(6572),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6572),
    [anon_sym_BSLASHlabel] = ACTIONS(6572),
    [anon_sym_BSLASHref] = ACTIONS(6572),
    [anon_sym_BSLASHeqref] = ACTIONS(6572),
    [anon_sym_BSLASHvref] = ACTIONS(6572),
    [anon_sym_BSLASHVref] = ACTIONS(6572),
    [anon_sym_BSLASHautoref] = ACTIONS(6572),
    [anon_sym_BSLASHpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcref] = ACTIONS(6572),
    [anon_sym_BSLASHCref] = ACTIONS(6572),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnameCref] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6572),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6572),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6572),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6572),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6572),
    [anon_sym_BSLASHdef] = ACTIONS(6572),
    [anon_sym_BSLASHlet] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6572),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6572),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6572),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6572),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6572),
    [anon_sym_BSLASHgls] = ACTIONS(6572),
    [anon_sym_BSLASHGls] = ACTIONS(6572),
    [anon_sym_BSLASHGLS] = ACTIONS(6572),
    [anon_sym_BSLASHglspl] = ACTIONS(6572),
    [anon_sym_BSLASHGlspl] = ACTIONS(6572),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6572),
    [anon_sym_BSLASHglslink] = ACTIONS(6572),
    [anon_sym_BSLASHglstext] = ACTIONS(6572),
    [anon_sym_BSLASHGlstext] = ACTIONS(6572),
    [anon_sym_BSLASHGLStext] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6572),
    [anon_sym_BSLASHglsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6572),
    [anon_sym_BSLASHglsname] = ACTIONS(6572),
    [anon_sym_BSLASHGlsname] = ACTIONS(6572),
    [anon_sym_BSLASHGLSname] = ACTIONS(6572),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6572),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6572),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6572),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6572),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6572),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6572),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6572),
    [anon_sym_BSLASHacrshort] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6572),
    [anon_sym_BSLASHACRshort] = ACTIONS(6572),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrlong] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6572),
    [anon_sym_BSLASHACRlong] = ACTIONS(6572),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6572),
    [anon_sym_BSLASHacrfull] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6572),
    [anon_sym_BSLASHACRfull] = ACTIONS(6572),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHacs] = ACTIONS(6572),
    [anon_sym_BSLASHAcs] = ACTIONS(6572),
    [anon_sym_BSLASHacsp] = ACTIONS(6572),
    [anon_sym_BSLASHAcsp] = ACTIONS(6572),
    [anon_sym_BSLASHacl] = ACTIONS(6572),
    [anon_sym_BSLASHAcl] = ACTIONS(6572),
    [anon_sym_BSLASHaclp] = ACTIONS(6572),
    [anon_sym_BSLASHAclp] = ACTIONS(6572),
    [anon_sym_BSLASHacf] = ACTIONS(6572),
    [anon_sym_BSLASHAcf] = ACTIONS(6572),
    [anon_sym_BSLASHacfp] = ACTIONS(6572),
    [anon_sym_BSLASHAcfp] = ACTIONS(6572),
    [anon_sym_BSLASHac] = ACTIONS(6572),
    [anon_sym_BSLASHAc] = ACTIONS(6572),
    [anon_sym_BSLASHacp] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6572),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6572),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6572),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6572),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6574),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6572),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6572),
    [anon_sym_BSLASHcolor] = ACTIONS(6572),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6572),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6572),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6572),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6572),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6572),
    [anon_sym_BSLASHurl] = ACTIONS(6572),
    [anon_sym_BSLASHhref] = ACTIONS(6572),
  },
  [2048] = {
    [sym_command_name] = ACTIONS(6558),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6558),
    [anon_sym_RBRACK] = ACTIONS(6560),
    [anon_sym_COMMA] = ACTIONS(6560),
    [anon_sym_EQ] = ACTIONS(6560),
    [anon_sym_RBRACE] = ACTIONS(6560),
    [sym_word] = ACTIONS(6558),
    [sym_placeholder] = ACTIONS(6560),
    [anon_sym_PLUS] = ACTIONS(6560),
    [anon_sym_DASH] = ACTIONS(6560),
    [anon_sym_STAR] = ACTIONS(6560),
    [anon_sym_SLASH] = ACTIONS(6560),
    [anon_sym_LT] = ACTIONS(6558),
    [anon_sym_GT] = ACTIONS(6558),
    [anon_sym_BANG] = ACTIONS(6558),
    [anon_sym_PIPE] = ACTIONS(6558),
    [anon_sym_COLON] = ACTIONS(6558),
    [anon_sym_SQUOTE] = ACTIONS(6558),
    [anon_sym__] = ACTIONS(6560),
    [anon_sym_CARET] = ACTIONS(6560),
    [anon_sym_BSLASHtitle] = ACTIONS(6558),
    [anon_sym_BSLASHauthor] = ACTIONS(6558),
    [anon_sym_BSLASHusepackage] = ACTIONS(6558),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6558),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6558),
    [anon_sym_BSLASHinclude] = ACTIONS(6558),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6558),
    [anon_sym_BSLASHinput] = ACTIONS(6558),
    [anon_sym_BSLASHsubfile] = ACTIONS(6558),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6558),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6558),
    [anon_sym_BSLASHbibliography] = ACTIONS(6558),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6558),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6558),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6558),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6558),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6558),
    [anon_sym_BSLASHimport] = ACTIONS(6558),
    [anon_sym_BSLASHsubimport] = ACTIONS(6558),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6558),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6558),
    [anon_sym_BSLASHcaption] = ACTIONS(6558),
    [anon_sym_BSLASHcite] = ACTIONS(6558),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCite] = ACTIONS(6558),
    [anon_sym_BSLASHnocite] = ACTIONS(6558),
    [anon_sym_BSLASHcitet] = ACTIONS(6558),
    [anon_sym_BSLASHcitep] = ACTIONS(6558),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteA] = ACTIONS(6558),
    [anon_sym_BSLASHciteR] = ACTIONS(6558),
    [anon_sym_BSLASHciteS] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6558),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6558),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteyear] = ACTIONS(6558),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHcitedate] = ACTIONS(6558),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHciteurl] = ACTIONS(6558),
    [anon_sym_BSLASHfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6558),
    [anon_sym_BSLASHcitealt] = ACTIONS(6558),
    [anon_sym_BSLASHcitealp] = ACTIONS(6558),
    [anon_sym_BSLASHcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHparencite] = ACTIONS(6558),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHParencite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6558),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6558),
    [anon_sym_BSLASHtextcite] = ACTIONS(6558),
    [anon_sym_BSLASHTextcite] = ACTIONS(6558),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6558),
    [anon_sym_BSLASHsupercite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite] = ACTIONS(6558),
    [anon_sym_BSLASHAutocite] = ACTIONS(6558),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHVolcite] = ACTIONS(6558),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHavolcite] = ACTIONS(6558),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6558),
    [anon_sym_BSLASHnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHNotecite] = ACTIONS(6558),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6558),
    [anon_sym_BSLASHlabel] = ACTIONS(6558),
    [anon_sym_BSLASHref] = ACTIONS(6558),
    [anon_sym_BSLASHeqref] = ACTIONS(6558),
    [anon_sym_BSLASHvref] = ACTIONS(6558),
    [anon_sym_BSLASHVref] = ACTIONS(6558),
    [anon_sym_BSLASHautoref] = ACTIONS(6558),
    [anon_sym_BSLASHpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcref] = ACTIONS(6558),
    [anon_sym_BSLASHCref] = ACTIONS(6558),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnameCref] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6558),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6558),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6558),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6558),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6558),
    [anon_sym_BSLASHdef] = ACTIONS(6558),
    [anon_sym_BSLASHlet] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6558),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6558),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6558),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6558),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6558),
    [anon_sym_BSLASHgls] = ACTIONS(6558),
    [anon_sym_BSLASHGls] = ACTIONS(6558),
    [anon_sym_BSLASHGLS] = ACTIONS(6558),
    [anon_sym_BSLASHglspl] = ACTIONS(6558),
    [anon_sym_BSLASHGlspl] = ACTIONS(6558),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6558),
    [anon_sym_BSLASHglslink] = ACTIONS(6558),
    [anon_sym_BSLASHglstext] = ACTIONS(6558),
    [anon_sym_BSLASHGlstext] = ACTIONS(6558),
    [anon_sym_BSLASHGLStext] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6558),
    [anon_sym_BSLASHglsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6558),
    [anon_sym_BSLASHglsname] = ACTIONS(6558),
    [anon_sym_BSLASHGlsname] = ACTIONS(6558),
    [anon_sym_BSLASHGLSname] = ACTIONS(6558),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6558),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6558),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6558),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6558),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6558),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6558),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6558),
    [anon_sym_BSLASHacrshort] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6558),
    [anon_sym_BSLASHACRshort] = ACTIONS(6558),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrlong] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6558),
    [anon_sym_BSLASHACRlong] = ACTIONS(6558),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6558),
    [anon_sym_BSLASHacrfull] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6558),
    [anon_sym_BSLASHACRfull] = ACTIONS(6558),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHacs] = ACTIONS(6558),
    [anon_sym_BSLASHAcs] = ACTIONS(6558),
    [anon_sym_BSLASHacsp] = ACTIONS(6558),
    [anon_sym_BSLASHAcsp] = ACTIONS(6558),
    [anon_sym_BSLASHacl] = ACTIONS(6558),
    [anon_sym_BSLASHAcl] = ACTIONS(6558),
    [anon_sym_BSLASHaclp] = ACTIONS(6558),
    [anon_sym_BSLASHAclp] = ACTIONS(6558),
    [anon_sym_BSLASHacf] = ACTIONS(6558),
    [anon_sym_BSLASHAcf] = ACTIONS(6558),
    [anon_sym_BSLASHacfp] = ACTIONS(6558),
    [anon_sym_BSLASHAcfp] = ACTIONS(6558),
    [anon_sym_BSLASHac] = ACTIONS(6558),
    [anon_sym_BSLASHAc] = ACTIONS(6558),
    [anon_sym_BSLASHacp] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6558),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6558),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6558),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6558),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6560),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6558),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6558),
    [anon_sym_BSLASHcolor] = ACTIONS(6558),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6558),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6558),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6558),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6558),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6558),
    [anon_sym_BSLASHurl] = ACTIONS(6558),
    [anon_sym_BSLASHhref] = ACTIONS(6558),
  },
  [2049] = {
    [sym_command_name] = ACTIONS(6314),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6314),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_COMMA] = ACTIONS(6316),
    [anon_sym_EQ] = ACTIONS(6316),
    [anon_sym_RBRACE] = ACTIONS(6316),
    [sym_word] = ACTIONS(6314),
    [sym_placeholder] = ACTIONS(6316),
    [anon_sym_PLUS] = ACTIONS(6316),
    [anon_sym_DASH] = ACTIONS(6316),
    [anon_sym_STAR] = ACTIONS(6316),
    [anon_sym_SLASH] = ACTIONS(6316),
    [anon_sym_LT] = ACTIONS(6314),
    [anon_sym_GT] = ACTIONS(6314),
    [anon_sym_BANG] = ACTIONS(6314),
    [anon_sym_PIPE] = ACTIONS(6314),
    [anon_sym_COLON] = ACTIONS(6314),
    [anon_sym_SQUOTE] = ACTIONS(6314),
    [anon_sym__] = ACTIONS(6316),
    [anon_sym_CARET] = ACTIONS(6316),
    [anon_sym_BSLASHtitle] = ACTIONS(6314),
    [anon_sym_BSLASHauthor] = ACTIONS(6314),
    [anon_sym_BSLASHusepackage] = ACTIONS(6314),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6314),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6314),
    [anon_sym_BSLASHinclude] = ACTIONS(6314),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6314),
    [anon_sym_BSLASHinput] = ACTIONS(6314),
    [anon_sym_BSLASHsubfile] = ACTIONS(6314),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6314),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6314),
    [anon_sym_BSLASHbibliography] = ACTIONS(6314),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6314),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6314),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6314),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6314),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6314),
    [anon_sym_BSLASHimport] = ACTIONS(6314),
    [anon_sym_BSLASHsubimport] = ACTIONS(6314),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6314),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6314),
    [anon_sym_BSLASHcaption] = ACTIONS(6314),
    [anon_sym_BSLASHcite] = ACTIONS(6314),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCite] = ACTIONS(6314),
    [anon_sym_BSLASHnocite] = ACTIONS(6314),
    [anon_sym_BSLASHcitet] = ACTIONS(6314),
    [anon_sym_BSLASHcitep] = ACTIONS(6314),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteA] = ACTIONS(6314),
    [anon_sym_BSLASHciteR] = ACTIONS(6314),
    [anon_sym_BSLASHciteS] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6314),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6314),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteyear] = ACTIONS(6314),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHcitedate] = ACTIONS(6314),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHciteurl] = ACTIONS(6314),
    [anon_sym_BSLASHfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6314),
    [anon_sym_BSLASHcitealt] = ACTIONS(6314),
    [anon_sym_BSLASHcitealp] = ACTIONS(6314),
    [anon_sym_BSLASHcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHparencite] = ACTIONS(6314),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHParencite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6314),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6314),
    [anon_sym_BSLASHtextcite] = ACTIONS(6314),
    [anon_sym_BSLASHTextcite] = ACTIONS(6314),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6314),
    [anon_sym_BSLASHsupercite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite] = ACTIONS(6314),
    [anon_sym_BSLASHAutocite] = ACTIONS(6314),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHVolcite] = ACTIONS(6314),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHavolcite] = ACTIONS(6314),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6314),
    [anon_sym_BSLASHnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHNotecite] = ACTIONS(6314),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6314),
    [anon_sym_BSLASHlabel] = ACTIONS(6314),
    [anon_sym_BSLASHref] = ACTIONS(6314),
    [anon_sym_BSLASHeqref] = ACTIONS(6314),
    [anon_sym_BSLASHvref] = ACTIONS(6314),
    [anon_sym_BSLASHVref] = ACTIONS(6314),
    [anon_sym_BSLASHautoref] = ACTIONS(6314),
    [anon_sym_BSLASHpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcref] = ACTIONS(6314),
    [anon_sym_BSLASHCref] = ACTIONS(6314),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnameCref] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6314),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6314),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6314),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6314),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6314),
    [anon_sym_BSLASHdef] = ACTIONS(6314),
    [anon_sym_BSLASHlet] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6314),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6314),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6314),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6314),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6314),
    [anon_sym_BSLASHgls] = ACTIONS(6314),
    [anon_sym_BSLASHGls] = ACTIONS(6314),
    [anon_sym_BSLASHGLS] = ACTIONS(6314),
    [anon_sym_BSLASHglspl] = ACTIONS(6314),
    [anon_sym_BSLASHGlspl] = ACTIONS(6314),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6314),
    [anon_sym_BSLASHglslink] = ACTIONS(6314),
    [anon_sym_BSLASHglstext] = ACTIONS(6314),
    [anon_sym_BSLASHGlstext] = ACTIONS(6314),
    [anon_sym_BSLASHGLStext] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6314),
    [anon_sym_BSLASHglsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6314),
    [anon_sym_BSLASHglsname] = ACTIONS(6314),
    [anon_sym_BSLASHGlsname] = ACTIONS(6314),
    [anon_sym_BSLASHGLSname] = ACTIONS(6314),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6314),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6314),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6314),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6314),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6314),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6314),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6314),
    [anon_sym_BSLASHacrshort] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6314),
    [anon_sym_BSLASHACRshort] = ACTIONS(6314),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrlong] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6314),
    [anon_sym_BSLASHACRlong] = ACTIONS(6314),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6314),
    [anon_sym_BSLASHacrfull] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6314),
    [anon_sym_BSLASHACRfull] = ACTIONS(6314),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHacs] = ACTIONS(6314),
    [anon_sym_BSLASHAcs] = ACTIONS(6314),
    [anon_sym_BSLASHacsp] = ACTIONS(6314),
    [anon_sym_BSLASHAcsp] = ACTIONS(6314),
    [anon_sym_BSLASHacl] = ACTIONS(6314),
    [anon_sym_BSLASHAcl] = ACTIONS(6314),
    [anon_sym_BSLASHaclp] = ACTIONS(6314),
    [anon_sym_BSLASHAclp] = ACTIONS(6314),
    [anon_sym_BSLASHacf] = ACTIONS(6314),
    [anon_sym_BSLASHAcf] = ACTIONS(6314),
    [anon_sym_BSLASHacfp] = ACTIONS(6314),
    [anon_sym_BSLASHAcfp] = ACTIONS(6314),
    [anon_sym_BSLASHac] = ACTIONS(6314),
    [anon_sym_BSLASHAc] = ACTIONS(6314),
    [anon_sym_BSLASHacp] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6314),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6314),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6314),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6314),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6316),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6314),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6314),
    [anon_sym_BSLASHcolor] = ACTIONS(6314),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6314),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6314),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6314),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6314),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6314),
    [anon_sym_BSLASHurl] = ACTIONS(6314),
    [anon_sym_BSLASHhref] = ACTIONS(6314),
  },
  [2050] = {
    [sym_command_name] = ACTIONS(6554),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6554),
    [anon_sym_RBRACK] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_RBRACE] = ACTIONS(6556),
    [sym_word] = ACTIONS(6554),
    [sym_placeholder] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_DASH] = ACTIONS(6556),
    [anon_sym_STAR] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6554),
    [anon_sym_GT] = ACTIONS(6554),
    [anon_sym_BANG] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6554),
    [anon_sym_COLON] = ACTIONS(6554),
    [anon_sym_SQUOTE] = ACTIONS(6554),
    [anon_sym__] = ACTIONS(6556),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_BSLASHtitle] = ACTIONS(6554),
    [anon_sym_BSLASHauthor] = ACTIONS(6554),
    [anon_sym_BSLASHusepackage] = ACTIONS(6554),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6554),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6554),
    [anon_sym_BSLASHinclude] = ACTIONS(6554),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6554),
    [anon_sym_BSLASHinput] = ACTIONS(6554),
    [anon_sym_BSLASHsubfile] = ACTIONS(6554),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6554),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6554),
    [anon_sym_BSLASHbibliography] = ACTIONS(6554),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6554),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6554),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6554),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6554),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6554),
    [anon_sym_BSLASHimport] = ACTIONS(6554),
    [anon_sym_BSLASHsubimport] = ACTIONS(6554),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6554),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6554),
    [anon_sym_BSLASHcaption] = ACTIONS(6554),
    [anon_sym_BSLASHcite] = ACTIONS(6554),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCite] = ACTIONS(6554),
    [anon_sym_BSLASHnocite] = ACTIONS(6554),
    [anon_sym_BSLASHcitet] = ACTIONS(6554),
    [anon_sym_BSLASHcitep] = ACTIONS(6554),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteA] = ACTIONS(6554),
    [anon_sym_BSLASHciteR] = ACTIONS(6554),
    [anon_sym_BSLASHciteS] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6554),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6554),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteyear] = ACTIONS(6554),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHcitedate] = ACTIONS(6554),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHciteurl] = ACTIONS(6554),
    [anon_sym_BSLASHfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6554),
    [anon_sym_BSLASHcitealt] = ACTIONS(6554),
    [anon_sym_BSLASHcitealp] = ACTIONS(6554),
    [anon_sym_BSLASHcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHparencite] = ACTIONS(6554),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHParencite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6554),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6554),
    [anon_sym_BSLASHtextcite] = ACTIONS(6554),
    [anon_sym_BSLASHTextcite] = ACTIONS(6554),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6554),
    [anon_sym_BSLASHsupercite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite] = ACTIONS(6554),
    [anon_sym_BSLASHAutocite] = ACTIONS(6554),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHVolcite] = ACTIONS(6554),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHavolcite] = ACTIONS(6554),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6554),
    [anon_sym_BSLASHnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHNotecite] = ACTIONS(6554),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6554),
    [anon_sym_BSLASHlabel] = ACTIONS(6554),
    [anon_sym_BSLASHref] = ACTIONS(6554),
    [anon_sym_BSLASHeqref] = ACTIONS(6554),
    [anon_sym_BSLASHvref] = ACTIONS(6554),
    [anon_sym_BSLASHVref] = ACTIONS(6554),
    [anon_sym_BSLASHautoref] = ACTIONS(6554),
    [anon_sym_BSLASHpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcref] = ACTIONS(6554),
    [anon_sym_BSLASHCref] = ACTIONS(6554),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnameCref] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6554),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6554),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6554),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6554),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6554),
    [anon_sym_BSLASHdef] = ACTIONS(6554),
    [anon_sym_BSLASHlet] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6554),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6554),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6554),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6554),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6554),
    [anon_sym_BSLASHgls] = ACTIONS(6554),
    [anon_sym_BSLASHGls] = ACTIONS(6554),
    [anon_sym_BSLASHGLS] = ACTIONS(6554),
    [anon_sym_BSLASHglspl] = ACTIONS(6554),
    [anon_sym_BSLASHGlspl] = ACTIONS(6554),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6554),
    [anon_sym_BSLASHglslink] = ACTIONS(6554),
    [anon_sym_BSLASHglstext] = ACTIONS(6554),
    [anon_sym_BSLASHGlstext] = ACTIONS(6554),
    [anon_sym_BSLASHGLStext] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6554),
    [anon_sym_BSLASHglsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6554),
    [anon_sym_BSLASHglsname] = ACTIONS(6554),
    [anon_sym_BSLASHGlsname] = ACTIONS(6554),
    [anon_sym_BSLASHGLSname] = ACTIONS(6554),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6554),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6554),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6554),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6554),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6554),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6554),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6554),
    [anon_sym_BSLASHacrshort] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6554),
    [anon_sym_BSLASHACRshort] = ACTIONS(6554),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrlong] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6554),
    [anon_sym_BSLASHACRlong] = ACTIONS(6554),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6554),
    [anon_sym_BSLASHacrfull] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6554),
    [anon_sym_BSLASHACRfull] = ACTIONS(6554),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHacs] = ACTIONS(6554),
    [anon_sym_BSLASHAcs] = ACTIONS(6554),
    [anon_sym_BSLASHacsp] = ACTIONS(6554),
    [anon_sym_BSLASHAcsp] = ACTIONS(6554),
    [anon_sym_BSLASHacl] = ACTIONS(6554),
    [anon_sym_BSLASHAcl] = ACTIONS(6554),
    [anon_sym_BSLASHaclp] = ACTIONS(6554),
    [anon_sym_BSLASHAclp] = ACTIONS(6554),
    [anon_sym_BSLASHacf] = ACTIONS(6554),
    [anon_sym_BSLASHAcf] = ACTIONS(6554),
    [anon_sym_BSLASHacfp] = ACTIONS(6554),
    [anon_sym_BSLASHAcfp] = ACTIONS(6554),
    [anon_sym_BSLASHac] = ACTIONS(6554),
    [anon_sym_BSLASHAc] = ACTIONS(6554),
    [anon_sym_BSLASHacp] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6554),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6554),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6554),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6554),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6556),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6554),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6554),
    [anon_sym_BSLASHcolor] = ACTIONS(6554),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6554),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6554),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6554),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6554),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6554),
    [anon_sym_BSLASHurl] = ACTIONS(6554),
    [anon_sym_BSLASHhref] = ACTIONS(6554),
  },
  [2051] = {
    [sym_command_name] = ACTIONS(6550),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6550),
    [anon_sym_RBRACK] = ACTIONS(6552),
    [anon_sym_COMMA] = ACTIONS(6552),
    [anon_sym_EQ] = ACTIONS(6552),
    [anon_sym_RBRACE] = ACTIONS(6552),
    [sym_word] = ACTIONS(6550),
    [sym_placeholder] = ACTIONS(6552),
    [anon_sym_PLUS] = ACTIONS(6552),
    [anon_sym_DASH] = ACTIONS(6552),
    [anon_sym_STAR] = ACTIONS(6552),
    [anon_sym_SLASH] = ACTIONS(6552),
    [anon_sym_LT] = ACTIONS(6550),
    [anon_sym_GT] = ACTIONS(6550),
    [anon_sym_BANG] = ACTIONS(6550),
    [anon_sym_PIPE] = ACTIONS(6550),
    [anon_sym_COLON] = ACTIONS(6550),
    [anon_sym_SQUOTE] = ACTIONS(6550),
    [anon_sym__] = ACTIONS(6552),
    [anon_sym_CARET] = ACTIONS(6552),
    [anon_sym_BSLASHtitle] = ACTIONS(6550),
    [anon_sym_BSLASHauthor] = ACTIONS(6550),
    [anon_sym_BSLASHusepackage] = ACTIONS(6550),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6550),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6550),
    [anon_sym_BSLASHinclude] = ACTIONS(6550),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6550),
    [anon_sym_BSLASHinput] = ACTIONS(6550),
    [anon_sym_BSLASHsubfile] = ACTIONS(6550),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6550),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6550),
    [anon_sym_BSLASHbibliography] = ACTIONS(6550),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6550),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6550),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6550),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6550),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6550),
    [anon_sym_BSLASHimport] = ACTIONS(6550),
    [anon_sym_BSLASHsubimport] = ACTIONS(6550),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6550),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6550),
    [anon_sym_BSLASHcaption] = ACTIONS(6550),
    [anon_sym_BSLASHcite] = ACTIONS(6550),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCite] = ACTIONS(6550),
    [anon_sym_BSLASHnocite] = ACTIONS(6550),
    [anon_sym_BSLASHcitet] = ACTIONS(6550),
    [anon_sym_BSLASHcitep] = ACTIONS(6550),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteA] = ACTIONS(6550),
    [anon_sym_BSLASHciteR] = ACTIONS(6550),
    [anon_sym_BSLASHciteS] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6550),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6550),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteyear] = ACTIONS(6550),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHcitedate] = ACTIONS(6550),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHciteurl] = ACTIONS(6550),
    [anon_sym_BSLASHfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6550),
    [anon_sym_BSLASHcitealt] = ACTIONS(6550),
    [anon_sym_BSLASHcitealp] = ACTIONS(6550),
    [anon_sym_BSLASHcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHparencite] = ACTIONS(6550),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHParencite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6550),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6550),
    [anon_sym_BSLASHtextcite] = ACTIONS(6550),
    [anon_sym_BSLASHTextcite] = ACTIONS(6550),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6550),
    [anon_sym_BSLASHsupercite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite] = ACTIONS(6550),
    [anon_sym_BSLASHAutocite] = ACTIONS(6550),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHVolcite] = ACTIONS(6550),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHavolcite] = ACTIONS(6550),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6550),
    [anon_sym_BSLASHnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHNotecite] = ACTIONS(6550),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6550),
    [anon_sym_BSLASHlabel] = ACTIONS(6550),
    [anon_sym_BSLASHref] = ACTIONS(6550),
    [anon_sym_BSLASHeqref] = ACTIONS(6550),
    [anon_sym_BSLASHvref] = ACTIONS(6550),
    [anon_sym_BSLASHVref] = ACTIONS(6550),
    [anon_sym_BSLASHautoref] = ACTIONS(6550),
    [anon_sym_BSLASHpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcref] = ACTIONS(6550),
    [anon_sym_BSLASHCref] = ACTIONS(6550),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnameCref] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6550),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6550),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6550),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6550),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6550),
    [anon_sym_BSLASHdef] = ACTIONS(6550),
    [anon_sym_BSLASHlet] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6550),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6550),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6550),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6550),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6550),
    [anon_sym_BSLASHgls] = ACTIONS(6550),
    [anon_sym_BSLASHGls] = ACTIONS(6550),
    [anon_sym_BSLASHGLS] = ACTIONS(6550),
    [anon_sym_BSLASHglspl] = ACTIONS(6550),
    [anon_sym_BSLASHGlspl] = ACTIONS(6550),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6550),
    [anon_sym_BSLASHglslink] = ACTIONS(6550),
    [anon_sym_BSLASHglstext] = ACTIONS(6550),
    [anon_sym_BSLASHGlstext] = ACTIONS(6550),
    [anon_sym_BSLASHGLStext] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6550),
    [anon_sym_BSLASHglsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6550),
    [anon_sym_BSLASHglsname] = ACTIONS(6550),
    [anon_sym_BSLASHGlsname] = ACTIONS(6550),
    [anon_sym_BSLASHGLSname] = ACTIONS(6550),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6550),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6550),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6550),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6550),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6550),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6550),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6550),
    [anon_sym_BSLASHacrshort] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6550),
    [anon_sym_BSLASHACRshort] = ACTIONS(6550),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrlong] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6550),
    [anon_sym_BSLASHACRlong] = ACTIONS(6550),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6550),
    [anon_sym_BSLASHacrfull] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6550),
    [anon_sym_BSLASHACRfull] = ACTIONS(6550),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHacs] = ACTIONS(6550),
    [anon_sym_BSLASHAcs] = ACTIONS(6550),
    [anon_sym_BSLASHacsp] = ACTIONS(6550),
    [anon_sym_BSLASHAcsp] = ACTIONS(6550),
    [anon_sym_BSLASHacl] = ACTIONS(6550),
    [anon_sym_BSLASHAcl] = ACTIONS(6550),
    [anon_sym_BSLASHaclp] = ACTIONS(6550),
    [anon_sym_BSLASHAclp] = ACTIONS(6550),
    [anon_sym_BSLASHacf] = ACTIONS(6550),
    [anon_sym_BSLASHAcf] = ACTIONS(6550),
    [anon_sym_BSLASHacfp] = ACTIONS(6550),
    [anon_sym_BSLASHAcfp] = ACTIONS(6550),
    [anon_sym_BSLASHac] = ACTIONS(6550),
    [anon_sym_BSLASHAc] = ACTIONS(6550),
    [anon_sym_BSLASHacp] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6550),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6550),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6550),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6550),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6552),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6550),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6550),
    [anon_sym_BSLASHcolor] = ACTIONS(6550),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6550),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6550),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6550),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6550),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6550),
    [anon_sym_BSLASHurl] = ACTIONS(6550),
    [anon_sym_BSLASHhref] = ACTIONS(6550),
  },
  [2052] = {
    [sym_command_name] = ACTIONS(6430),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6430),
    [anon_sym_RBRACK] = ACTIONS(6432),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_EQ] = ACTIONS(6432),
    [anon_sym_RBRACE] = ACTIONS(6432),
    [sym_word] = ACTIONS(6430),
    [sym_placeholder] = ACTIONS(6432),
    [anon_sym_PLUS] = ACTIONS(6432),
    [anon_sym_DASH] = ACTIONS(6432),
    [anon_sym_STAR] = ACTIONS(6432),
    [anon_sym_SLASH] = ACTIONS(6432),
    [anon_sym_LT] = ACTIONS(6430),
    [anon_sym_GT] = ACTIONS(6430),
    [anon_sym_BANG] = ACTIONS(6430),
    [anon_sym_PIPE] = ACTIONS(6430),
    [anon_sym_COLON] = ACTIONS(6430),
    [anon_sym_SQUOTE] = ACTIONS(6430),
    [anon_sym__] = ACTIONS(6432),
    [anon_sym_CARET] = ACTIONS(6432),
    [anon_sym_BSLASHtitle] = ACTIONS(6430),
    [anon_sym_BSLASHauthor] = ACTIONS(6430),
    [anon_sym_BSLASHusepackage] = ACTIONS(6430),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6430),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6430),
    [anon_sym_BSLASHinclude] = ACTIONS(6430),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6430),
    [anon_sym_BSLASHinput] = ACTIONS(6430),
    [anon_sym_BSLASHsubfile] = ACTIONS(6430),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6430),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6430),
    [anon_sym_BSLASHbibliography] = ACTIONS(6430),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6430),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6430),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6430),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6430),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6430),
    [anon_sym_BSLASHimport] = ACTIONS(6430),
    [anon_sym_BSLASHsubimport] = ACTIONS(6430),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6430),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6430),
    [anon_sym_BSLASHcaption] = ACTIONS(6430),
    [anon_sym_BSLASHcite] = ACTIONS(6430),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCite] = ACTIONS(6430),
    [anon_sym_BSLASHnocite] = ACTIONS(6430),
    [anon_sym_BSLASHcitet] = ACTIONS(6430),
    [anon_sym_BSLASHcitep] = ACTIONS(6430),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteA] = ACTIONS(6430),
    [anon_sym_BSLASHciteR] = ACTIONS(6430),
    [anon_sym_BSLASHciteS] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6430),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6430),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteyear] = ACTIONS(6430),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHcitedate] = ACTIONS(6430),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHciteurl] = ACTIONS(6430),
    [anon_sym_BSLASHfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6430),
    [anon_sym_BSLASHcitealt] = ACTIONS(6430),
    [anon_sym_BSLASHcitealp] = ACTIONS(6430),
    [anon_sym_BSLASHcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHparencite] = ACTIONS(6430),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHParencite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6430),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6430),
    [anon_sym_BSLASHtextcite] = ACTIONS(6430),
    [anon_sym_BSLASHTextcite] = ACTIONS(6430),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6430),
    [anon_sym_BSLASHsupercite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite] = ACTIONS(6430),
    [anon_sym_BSLASHAutocite] = ACTIONS(6430),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHVolcite] = ACTIONS(6430),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHavolcite] = ACTIONS(6430),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6430),
    [anon_sym_BSLASHnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHNotecite] = ACTIONS(6430),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6430),
    [anon_sym_BSLASHlabel] = ACTIONS(6430),
    [anon_sym_BSLASHref] = ACTIONS(6430),
    [anon_sym_BSLASHeqref] = ACTIONS(6430),
    [anon_sym_BSLASHvref] = ACTIONS(6430),
    [anon_sym_BSLASHVref] = ACTIONS(6430),
    [anon_sym_BSLASHautoref] = ACTIONS(6430),
    [anon_sym_BSLASHpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcref] = ACTIONS(6430),
    [anon_sym_BSLASHCref] = ACTIONS(6430),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnameCref] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6430),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6430),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6430),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6430),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6430),
    [anon_sym_BSLASHdef] = ACTIONS(6430),
    [anon_sym_BSLASHlet] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6430),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6430),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6430),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6430),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6430),
    [anon_sym_BSLASHgls] = ACTIONS(6430),
    [anon_sym_BSLASHGls] = ACTIONS(6430),
    [anon_sym_BSLASHGLS] = ACTIONS(6430),
    [anon_sym_BSLASHglspl] = ACTIONS(6430),
    [anon_sym_BSLASHGlspl] = ACTIONS(6430),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6430),
    [anon_sym_BSLASHglslink] = ACTIONS(6430),
    [anon_sym_BSLASHglstext] = ACTIONS(6430),
    [anon_sym_BSLASHGlstext] = ACTIONS(6430),
    [anon_sym_BSLASHGLStext] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6430),
    [anon_sym_BSLASHglsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6430),
    [anon_sym_BSLASHglsname] = ACTIONS(6430),
    [anon_sym_BSLASHGlsname] = ACTIONS(6430),
    [anon_sym_BSLASHGLSname] = ACTIONS(6430),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6430),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6430),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6430),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6430),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6430),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6430),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6430),
    [anon_sym_BSLASHacrshort] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6430),
    [anon_sym_BSLASHACRshort] = ACTIONS(6430),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrlong] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6430),
    [anon_sym_BSLASHACRlong] = ACTIONS(6430),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6430),
    [anon_sym_BSLASHacrfull] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6430),
    [anon_sym_BSLASHACRfull] = ACTIONS(6430),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHacs] = ACTIONS(6430),
    [anon_sym_BSLASHAcs] = ACTIONS(6430),
    [anon_sym_BSLASHacsp] = ACTIONS(6430),
    [anon_sym_BSLASHAcsp] = ACTIONS(6430),
    [anon_sym_BSLASHacl] = ACTIONS(6430),
    [anon_sym_BSLASHAcl] = ACTIONS(6430),
    [anon_sym_BSLASHaclp] = ACTIONS(6430),
    [anon_sym_BSLASHAclp] = ACTIONS(6430),
    [anon_sym_BSLASHacf] = ACTIONS(6430),
    [anon_sym_BSLASHAcf] = ACTIONS(6430),
    [anon_sym_BSLASHacfp] = ACTIONS(6430),
    [anon_sym_BSLASHAcfp] = ACTIONS(6430),
    [anon_sym_BSLASHac] = ACTIONS(6430),
    [anon_sym_BSLASHAc] = ACTIONS(6430),
    [anon_sym_BSLASHacp] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6430),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6430),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6430),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6430),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6432),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6430),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6430),
    [anon_sym_BSLASHcolor] = ACTIONS(6430),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6430),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6430),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6430),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6430),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6430),
    [anon_sym_BSLASHurl] = ACTIONS(6430),
    [anon_sym_BSLASHhref] = ACTIONS(6430),
  },
  [2053] = {
    [sym_command_name] = ACTIONS(6470),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6470),
    [anon_sym_RBRACK] = ACTIONS(6472),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_EQ] = ACTIONS(6472),
    [anon_sym_RBRACE] = ACTIONS(6472),
    [sym_word] = ACTIONS(6470),
    [sym_placeholder] = ACTIONS(6472),
    [anon_sym_PLUS] = ACTIONS(6472),
    [anon_sym_DASH] = ACTIONS(6472),
    [anon_sym_STAR] = ACTIONS(6472),
    [anon_sym_SLASH] = ACTIONS(6472),
    [anon_sym_LT] = ACTIONS(6470),
    [anon_sym_GT] = ACTIONS(6470),
    [anon_sym_BANG] = ACTIONS(6470),
    [anon_sym_PIPE] = ACTIONS(6470),
    [anon_sym_COLON] = ACTIONS(6470),
    [anon_sym_SQUOTE] = ACTIONS(6470),
    [anon_sym__] = ACTIONS(6472),
    [anon_sym_CARET] = ACTIONS(6472),
    [anon_sym_BSLASHtitle] = ACTIONS(6470),
    [anon_sym_BSLASHauthor] = ACTIONS(6470),
    [anon_sym_BSLASHusepackage] = ACTIONS(6470),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6470),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6470),
    [anon_sym_BSLASHinclude] = ACTIONS(6470),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6470),
    [anon_sym_BSLASHinput] = ACTIONS(6470),
    [anon_sym_BSLASHsubfile] = ACTIONS(6470),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6470),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6470),
    [anon_sym_BSLASHbibliography] = ACTIONS(6470),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6470),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6470),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6470),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6470),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6470),
    [anon_sym_BSLASHimport] = ACTIONS(6470),
    [anon_sym_BSLASHsubimport] = ACTIONS(6470),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6470),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6470),
    [anon_sym_BSLASHcaption] = ACTIONS(6470),
    [anon_sym_BSLASHcite] = ACTIONS(6470),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCite] = ACTIONS(6470),
    [anon_sym_BSLASHnocite] = ACTIONS(6470),
    [anon_sym_BSLASHcitet] = ACTIONS(6470),
    [anon_sym_BSLASHcitep] = ACTIONS(6470),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteA] = ACTIONS(6470),
    [anon_sym_BSLASHciteR] = ACTIONS(6470),
    [anon_sym_BSLASHciteS] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6470),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6470),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteyear] = ACTIONS(6470),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHcitedate] = ACTIONS(6470),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHciteurl] = ACTIONS(6470),
    [anon_sym_BSLASHfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6470),
    [anon_sym_BSLASHcitealt] = ACTIONS(6470),
    [anon_sym_BSLASHcitealp] = ACTIONS(6470),
    [anon_sym_BSLASHcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHparencite] = ACTIONS(6470),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHParencite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6470),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6470),
    [anon_sym_BSLASHtextcite] = ACTIONS(6470),
    [anon_sym_BSLASHTextcite] = ACTIONS(6470),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6470),
    [anon_sym_BSLASHsupercite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite] = ACTIONS(6470),
    [anon_sym_BSLASHAutocite] = ACTIONS(6470),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHVolcite] = ACTIONS(6470),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHavolcite] = ACTIONS(6470),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6470),
    [anon_sym_BSLASHnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHNotecite] = ACTIONS(6470),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6470),
    [anon_sym_BSLASHlabel] = ACTIONS(6470),
    [anon_sym_BSLASHref] = ACTIONS(6470),
    [anon_sym_BSLASHeqref] = ACTIONS(6470),
    [anon_sym_BSLASHvref] = ACTIONS(6470),
    [anon_sym_BSLASHVref] = ACTIONS(6470),
    [anon_sym_BSLASHautoref] = ACTIONS(6470),
    [anon_sym_BSLASHpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcref] = ACTIONS(6470),
    [anon_sym_BSLASHCref] = ACTIONS(6470),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnameCref] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6470),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6470),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6470),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6470),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6470),
    [anon_sym_BSLASHdef] = ACTIONS(6470),
    [anon_sym_BSLASHlet] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6470),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6470),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6470),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6470),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6470),
    [anon_sym_BSLASHgls] = ACTIONS(6470),
    [anon_sym_BSLASHGls] = ACTIONS(6470),
    [anon_sym_BSLASHGLS] = ACTIONS(6470),
    [anon_sym_BSLASHglspl] = ACTIONS(6470),
    [anon_sym_BSLASHGlspl] = ACTIONS(6470),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6470),
    [anon_sym_BSLASHglslink] = ACTIONS(6470),
    [anon_sym_BSLASHglstext] = ACTIONS(6470),
    [anon_sym_BSLASHGlstext] = ACTIONS(6470),
    [anon_sym_BSLASHGLStext] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6470),
    [anon_sym_BSLASHglsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6470),
    [anon_sym_BSLASHglsname] = ACTIONS(6470),
    [anon_sym_BSLASHGlsname] = ACTIONS(6470),
    [anon_sym_BSLASHGLSname] = ACTIONS(6470),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6470),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6470),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6470),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6470),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6470),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6470),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6470),
    [anon_sym_BSLASHacrshort] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6470),
    [anon_sym_BSLASHACRshort] = ACTIONS(6470),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrlong] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6470),
    [anon_sym_BSLASHACRlong] = ACTIONS(6470),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6470),
    [anon_sym_BSLASHacrfull] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6470),
    [anon_sym_BSLASHACRfull] = ACTIONS(6470),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHacs] = ACTIONS(6470),
    [anon_sym_BSLASHAcs] = ACTIONS(6470),
    [anon_sym_BSLASHacsp] = ACTIONS(6470),
    [anon_sym_BSLASHAcsp] = ACTIONS(6470),
    [anon_sym_BSLASHacl] = ACTIONS(6470),
    [anon_sym_BSLASHAcl] = ACTIONS(6470),
    [anon_sym_BSLASHaclp] = ACTIONS(6470),
    [anon_sym_BSLASHAclp] = ACTIONS(6470),
    [anon_sym_BSLASHacf] = ACTIONS(6470),
    [anon_sym_BSLASHAcf] = ACTIONS(6470),
    [anon_sym_BSLASHacfp] = ACTIONS(6470),
    [anon_sym_BSLASHAcfp] = ACTIONS(6470),
    [anon_sym_BSLASHac] = ACTIONS(6470),
    [anon_sym_BSLASHAc] = ACTIONS(6470),
    [anon_sym_BSLASHacp] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6470),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6470),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6470),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6470),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6472),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6470),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6470),
    [anon_sym_BSLASHcolor] = ACTIONS(6470),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6470),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6470),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6470),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6470),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6470),
    [anon_sym_BSLASHurl] = ACTIONS(6470),
    [anon_sym_BSLASHhref] = ACTIONS(6470),
  },
  [2054] = {
    [sym_command_name] = ACTIONS(6310),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6310),
    [anon_sym_RBRACK] = ACTIONS(6312),
    [anon_sym_COMMA] = ACTIONS(6312),
    [anon_sym_EQ] = ACTIONS(6312),
    [anon_sym_RBRACE] = ACTIONS(6312),
    [sym_word] = ACTIONS(6310),
    [sym_placeholder] = ACTIONS(6312),
    [anon_sym_PLUS] = ACTIONS(6312),
    [anon_sym_DASH] = ACTIONS(6312),
    [anon_sym_STAR] = ACTIONS(6312),
    [anon_sym_SLASH] = ACTIONS(6312),
    [anon_sym_LT] = ACTIONS(6310),
    [anon_sym_GT] = ACTIONS(6310),
    [anon_sym_BANG] = ACTIONS(6310),
    [anon_sym_PIPE] = ACTIONS(6310),
    [anon_sym_COLON] = ACTIONS(6310),
    [anon_sym_SQUOTE] = ACTIONS(6310),
    [anon_sym__] = ACTIONS(6312),
    [anon_sym_CARET] = ACTIONS(6312),
    [anon_sym_BSLASHtitle] = ACTIONS(6310),
    [anon_sym_BSLASHauthor] = ACTIONS(6310),
    [anon_sym_BSLASHusepackage] = ACTIONS(6310),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6310),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6310),
    [anon_sym_BSLASHinclude] = ACTIONS(6310),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6310),
    [anon_sym_BSLASHinput] = ACTIONS(6310),
    [anon_sym_BSLASHsubfile] = ACTIONS(6310),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6310),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6310),
    [anon_sym_BSLASHbibliography] = ACTIONS(6310),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6310),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6310),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6310),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6310),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6310),
    [anon_sym_BSLASHimport] = ACTIONS(6310),
    [anon_sym_BSLASHsubimport] = ACTIONS(6310),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6310),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6310),
    [anon_sym_BSLASHcaption] = ACTIONS(6310),
    [anon_sym_BSLASHcite] = ACTIONS(6310),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCite] = ACTIONS(6310),
    [anon_sym_BSLASHnocite] = ACTIONS(6310),
    [anon_sym_BSLASHcitet] = ACTIONS(6310),
    [anon_sym_BSLASHcitep] = ACTIONS(6310),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteA] = ACTIONS(6310),
    [anon_sym_BSLASHciteR] = ACTIONS(6310),
    [anon_sym_BSLASHciteS] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6310),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6310),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteyear] = ACTIONS(6310),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHcitedate] = ACTIONS(6310),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHciteurl] = ACTIONS(6310),
    [anon_sym_BSLASHfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6310),
    [anon_sym_BSLASHcitealt] = ACTIONS(6310),
    [anon_sym_BSLASHcitealp] = ACTIONS(6310),
    [anon_sym_BSLASHcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHparencite] = ACTIONS(6310),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHParencite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6310),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6310),
    [anon_sym_BSLASHtextcite] = ACTIONS(6310),
    [anon_sym_BSLASHTextcite] = ACTIONS(6310),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6310),
    [anon_sym_BSLASHsupercite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite] = ACTIONS(6310),
    [anon_sym_BSLASHAutocite] = ACTIONS(6310),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHVolcite] = ACTIONS(6310),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHavolcite] = ACTIONS(6310),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6310),
    [anon_sym_BSLASHnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHNotecite] = ACTIONS(6310),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6310),
    [anon_sym_BSLASHlabel] = ACTIONS(6310),
    [anon_sym_BSLASHref] = ACTIONS(6310),
    [anon_sym_BSLASHeqref] = ACTIONS(6310),
    [anon_sym_BSLASHvref] = ACTIONS(6310),
    [anon_sym_BSLASHVref] = ACTIONS(6310),
    [anon_sym_BSLASHautoref] = ACTIONS(6310),
    [anon_sym_BSLASHpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcref] = ACTIONS(6310),
    [anon_sym_BSLASHCref] = ACTIONS(6310),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnameCref] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6310),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6310),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6310),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6310),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6310),
    [anon_sym_BSLASHdef] = ACTIONS(6310),
    [anon_sym_BSLASHlet] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6310),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6310),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6310),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6310),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6310),
    [anon_sym_BSLASHgls] = ACTIONS(6310),
    [anon_sym_BSLASHGls] = ACTIONS(6310),
    [anon_sym_BSLASHGLS] = ACTIONS(6310),
    [anon_sym_BSLASHglspl] = ACTIONS(6310),
    [anon_sym_BSLASHGlspl] = ACTIONS(6310),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6310),
    [anon_sym_BSLASHglslink] = ACTIONS(6310),
    [anon_sym_BSLASHglstext] = ACTIONS(6310),
    [anon_sym_BSLASHGlstext] = ACTIONS(6310),
    [anon_sym_BSLASHGLStext] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6310),
    [anon_sym_BSLASHglsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6310),
    [anon_sym_BSLASHglsname] = ACTIONS(6310),
    [anon_sym_BSLASHGlsname] = ACTIONS(6310),
    [anon_sym_BSLASHGLSname] = ACTIONS(6310),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6310),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6310),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6310),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6310),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6310),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6310),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6310),
    [anon_sym_BSLASHacrshort] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6310),
    [anon_sym_BSLASHACRshort] = ACTIONS(6310),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrlong] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6310),
    [anon_sym_BSLASHACRlong] = ACTIONS(6310),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6310),
    [anon_sym_BSLASHacrfull] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6310),
    [anon_sym_BSLASHACRfull] = ACTIONS(6310),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHacs] = ACTIONS(6310),
    [anon_sym_BSLASHAcs] = ACTIONS(6310),
    [anon_sym_BSLASHacsp] = ACTIONS(6310),
    [anon_sym_BSLASHAcsp] = ACTIONS(6310),
    [anon_sym_BSLASHacl] = ACTIONS(6310),
    [anon_sym_BSLASHAcl] = ACTIONS(6310),
    [anon_sym_BSLASHaclp] = ACTIONS(6310),
    [anon_sym_BSLASHAclp] = ACTIONS(6310),
    [anon_sym_BSLASHacf] = ACTIONS(6310),
    [anon_sym_BSLASHAcf] = ACTIONS(6310),
    [anon_sym_BSLASHacfp] = ACTIONS(6310),
    [anon_sym_BSLASHAcfp] = ACTIONS(6310),
    [anon_sym_BSLASHac] = ACTIONS(6310),
    [anon_sym_BSLASHAc] = ACTIONS(6310),
    [anon_sym_BSLASHacp] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6310),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6310),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6310),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6310),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6312),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6310),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6310),
    [anon_sym_BSLASHcolor] = ACTIONS(6310),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6310),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6310),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6310),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6310),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6310),
    [anon_sym_BSLASHurl] = ACTIONS(6310),
    [anon_sym_BSLASHhref] = ACTIONS(6310),
  },
  [2055] = {
    [sym_command_name] = ACTIONS(6350),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6350),
    [anon_sym_RBRACK] = ACTIONS(6352),
    [anon_sym_COMMA] = ACTIONS(6352),
    [anon_sym_EQ] = ACTIONS(6352),
    [anon_sym_RBRACE] = ACTIONS(6352),
    [sym_word] = ACTIONS(6350),
    [sym_placeholder] = ACTIONS(6352),
    [anon_sym_PLUS] = ACTIONS(6352),
    [anon_sym_DASH] = ACTIONS(6352),
    [anon_sym_STAR] = ACTIONS(6352),
    [anon_sym_SLASH] = ACTIONS(6352),
    [anon_sym_LT] = ACTIONS(6350),
    [anon_sym_GT] = ACTIONS(6350),
    [anon_sym_BANG] = ACTIONS(6350),
    [anon_sym_PIPE] = ACTIONS(6350),
    [anon_sym_COLON] = ACTIONS(6350),
    [anon_sym_SQUOTE] = ACTIONS(6350),
    [anon_sym__] = ACTIONS(6352),
    [anon_sym_CARET] = ACTIONS(6352),
    [anon_sym_BSLASHtitle] = ACTIONS(6350),
    [anon_sym_BSLASHauthor] = ACTIONS(6350),
    [anon_sym_BSLASHusepackage] = ACTIONS(6350),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6350),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6350),
    [anon_sym_BSLASHinclude] = ACTIONS(6350),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6350),
    [anon_sym_BSLASHinput] = ACTIONS(6350),
    [anon_sym_BSLASHsubfile] = ACTIONS(6350),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6350),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6350),
    [anon_sym_BSLASHbibliography] = ACTIONS(6350),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6350),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6350),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6350),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6350),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6350),
    [anon_sym_BSLASHimport] = ACTIONS(6350),
    [anon_sym_BSLASHsubimport] = ACTIONS(6350),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6350),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6350),
    [anon_sym_BSLASHcaption] = ACTIONS(6350),
    [anon_sym_BSLASHcite] = ACTIONS(6350),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCite] = ACTIONS(6350),
    [anon_sym_BSLASHnocite] = ACTIONS(6350),
    [anon_sym_BSLASHcitet] = ACTIONS(6350),
    [anon_sym_BSLASHcitep] = ACTIONS(6350),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteA] = ACTIONS(6350),
    [anon_sym_BSLASHciteR] = ACTIONS(6350),
    [anon_sym_BSLASHciteS] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6350),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6350),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteyear] = ACTIONS(6350),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHcitedate] = ACTIONS(6350),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHciteurl] = ACTIONS(6350),
    [anon_sym_BSLASHfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6350),
    [anon_sym_BSLASHcitealt] = ACTIONS(6350),
    [anon_sym_BSLASHcitealp] = ACTIONS(6350),
    [anon_sym_BSLASHcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHparencite] = ACTIONS(6350),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHParencite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6350),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6350),
    [anon_sym_BSLASHtextcite] = ACTIONS(6350),
    [anon_sym_BSLASHTextcite] = ACTIONS(6350),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6350),
    [anon_sym_BSLASHsupercite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite] = ACTIONS(6350),
    [anon_sym_BSLASHAutocite] = ACTIONS(6350),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHVolcite] = ACTIONS(6350),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHavolcite] = ACTIONS(6350),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6350),
    [anon_sym_BSLASHnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHNotecite] = ACTIONS(6350),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6350),
    [anon_sym_BSLASHlabel] = ACTIONS(6350),
    [anon_sym_BSLASHref] = ACTIONS(6350),
    [anon_sym_BSLASHeqref] = ACTIONS(6350),
    [anon_sym_BSLASHvref] = ACTIONS(6350),
    [anon_sym_BSLASHVref] = ACTIONS(6350),
    [anon_sym_BSLASHautoref] = ACTIONS(6350),
    [anon_sym_BSLASHpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcref] = ACTIONS(6350),
    [anon_sym_BSLASHCref] = ACTIONS(6350),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnameCref] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6350),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6350),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6350),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6350),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6350),
    [anon_sym_BSLASHdef] = ACTIONS(6350),
    [anon_sym_BSLASHlet] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6350),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6350),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6350),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6350),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6350),
    [anon_sym_BSLASHgls] = ACTIONS(6350),
    [anon_sym_BSLASHGls] = ACTIONS(6350),
    [anon_sym_BSLASHGLS] = ACTIONS(6350),
    [anon_sym_BSLASHglspl] = ACTIONS(6350),
    [anon_sym_BSLASHGlspl] = ACTIONS(6350),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6350),
    [anon_sym_BSLASHglslink] = ACTIONS(6350),
    [anon_sym_BSLASHglstext] = ACTIONS(6350),
    [anon_sym_BSLASHGlstext] = ACTIONS(6350),
    [anon_sym_BSLASHGLStext] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6350),
    [anon_sym_BSLASHglsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6350),
    [anon_sym_BSLASHglsname] = ACTIONS(6350),
    [anon_sym_BSLASHGlsname] = ACTIONS(6350),
    [anon_sym_BSLASHGLSname] = ACTIONS(6350),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6350),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6350),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6350),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6350),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6350),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6350),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6350),
    [anon_sym_BSLASHacrshort] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6350),
    [anon_sym_BSLASHACRshort] = ACTIONS(6350),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrlong] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6350),
    [anon_sym_BSLASHACRlong] = ACTIONS(6350),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6350),
    [anon_sym_BSLASHacrfull] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6350),
    [anon_sym_BSLASHACRfull] = ACTIONS(6350),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHacs] = ACTIONS(6350),
    [anon_sym_BSLASHAcs] = ACTIONS(6350),
    [anon_sym_BSLASHacsp] = ACTIONS(6350),
    [anon_sym_BSLASHAcsp] = ACTIONS(6350),
    [anon_sym_BSLASHacl] = ACTIONS(6350),
    [anon_sym_BSLASHAcl] = ACTIONS(6350),
    [anon_sym_BSLASHaclp] = ACTIONS(6350),
    [anon_sym_BSLASHAclp] = ACTIONS(6350),
    [anon_sym_BSLASHacf] = ACTIONS(6350),
    [anon_sym_BSLASHAcf] = ACTIONS(6350),
    [anon_sym_BSLASHacfp] = ACTIONS(6350),
    [anon_sym_BSLASHAcfp] = ACTIONS(6350),
    [anon_sym_BSLASHac] = ACTIONS(6350),
    [anon_sym_BSLASHAc] = ACTIONS(6350),
    [anon_sym_BSLASHacp] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6350),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6350),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6350),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6350),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6352),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6350),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6350),
    [anon_sym_BSLASHcolor] = ACTIONS(6350),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6350),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6350),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6350),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6350),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6350),
    [anon_sym_BSLASHurl] = ACTIONS(6350),
    [anon_sym_BSLASHhref] = ACTIONS(6350),
  },
  [2056] = {
    [sym_command_name] = ACTIONS(6174),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6174),
    [anon_sym_RBRACK] = ACTIONS(6176),
    [anon_sym_COMMA] = ACTIONS(6176),
    [anon_sym_EQ] = ACTIONS(6176),
    [anon_sym_RBRACE] = ACTIONS(6176),
    [sym_word] = ACTIONS(6174),
    [sym_placeholder] = ACTIONS(6176),
    [anon_sym_PLUS] = ACTIONS(6176),
    [anon_sym_DASH] = ACTIONS(6176),
    [anon_sym_STAR] = ACTIONS(6176),
    [anon_sym_SLASH] = ACTIONS(6176),
    [anon_sym_LT] = ACTIONS(6174),
    [anon_sym_GT] = ACTIONS(6174),
    [anon_sym_BANG] = ACTIONS(6174),
    [anon_sym_PIPE] = ACTIONS(6174),
    [anon_sym_COLON] = ACTIONS(6174),
    [anon_sym_SQUOTE] = ACTIONS(6174),
    [anon_sym__] = ACTIONS(6176),
    [anon_sym_CARET] = ACTIONS(6176),
    [anon_sym_BSLASHtitle] = ACTIONS(6174),
    [anon_sym_BSLASHauthor] = ACTIONS(6174),
    [anon_sym_BSLASHusepackage] = ACTIONS(6174),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6174),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6174),
    [anon_sym_BSLASHinclude] = ACTIONS(6174),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6174),
    [anon_sym_BSLASHinput] = ACTIONS(6174),
    [anon_sym_BSLASHsubfile] = ACTIONS(6174),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6174),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6174),
    [anon_sym_BSLASHbibliography] = ACTIONS(6174),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6174),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6174),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6174),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6174),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6174),
    [anon_sym_BSLASHimport] = ACTIONS(6174),
    [anon_sym_BSLASHsubimport] = ACTIONS(6174),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6174),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6174),
    [anon_sym_BSLASHcaption] = ACTIONS(6174),
    [anon_sym_BSLASHcite] = ACTIONS(6174),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCite] = ACTIONS(6174),
    [anon_sym_BSLASHnocite] = ACTIONS(6174),
    [anon_sym_BSLASHcitet] = ACTIONS(6174),
    [anon_sym_BSLASHcitep] = ACTIONS(6174),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteA] = ACTIONS(6174),
    [anon_sym_BSLASHciteR] = ACTIONS(6174),
    [anon_sym_BSLASHciteS] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6174),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6174),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteyear] = ACTIONS(6174),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHcitedate] = ACTIONS(6174),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHciteurl] = ACTIONS(6174),
    [anon_sym_BSLASHfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6174),
    [anon_sym_BSLASHcitealt] = ACTIONS(6174),
    [anon_sym_BSLASHcitealp] = ACTIONS(6174),
    [anon_sym_BSLASHcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHparencite] = ACTIONS(6174),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHParencite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6174),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6174),
    [anon_sym_BSLASHtextcite] = ACTIONS(6174),
    [anon_sym_BSLASHTextcite] = ACTIONS(6174),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6174),
    [anon_sym_BSLASHsupercite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite] = ACTIONS(6174),
    [anon_sym_BSLASHAutocite] = ACTIONS(6174),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHVolcite] = ACTIONS(6174),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHavolcite] = ACTIONS(6174),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6174),
    [anon_sym_BSLASHnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHNotecite] = ACTIONS(6174),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6174),
    [anon_sym_BSLASHlabel] = ACTIONS(6174),
    [anon_sym_BSLASHref] = ACTIONS(6174),
    [anon_sym_BSLASHeqref] = ACTIONS(6174),
    [anon_sym_BSLASHvref] = ACTIONS(6174),
    [anon_sym_BSLASHVref] = ACTIONS(6174),
    [anon_sym_BSLASHautoref] = ACTIONS(6174),
    [anon_sym_BSLASHpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcref] = ACTIONS(6174),
    [anon_sym_BSLASHCref] = ACTIONS(6174),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnameCref] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6174),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6174),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6174),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6174),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6174),
    [anon_sym_BSLASHdef] = ACTIONS(6174),
    [anon_sym_BSLASHlet] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6174),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6174),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6174),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6174),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6174),
    [anon_sym_BSLASHgls] = ACTIONS(6174),
    [anon_sym_BSLASHGls] = ACTIONS(6174),
    [anon_sym_BSLASHGLS] = ACTIONS(6174),
    [anon_sym_BSLASHglspl] = ACTIONS(6174),
    [anon_sym_BSLASHGlspl] = ACTIONS(6174),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6174),
    [anon_sym_BSLASHglslink] = ACTIONS(6174),
    [anon_sym_BSLASHglstext] = ACTIONS(6174),
    [anon_sym_BSLASHGlstext] = ACTIONS(6174),
    [anon_sym_BSLASHGLStext] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6174),
    [anon_sym_BSLASHglsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6174),
    [anon_sym_BSLASHglsname] = ACTIONS(6174),
    [anon_sym_BSLASHGlsname] = ACTIONS(6174),
    [anon_sym_BSLASHGLSname] = ACTIONS(6174),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6174),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6174),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6174),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6174),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6174),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6174),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6174),
    [anon_sym_BSLASHacrshort] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6174),
    [anon_sym_BSLASHACRshort] = ACTIONS(6174),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrlong] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6174),
    [anon_sym_BSLASHACRlong] = ACTIONS(6174),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6174),
    [anon_sym_BSLASHacrfull] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6174),
    [anon_sym_BSLASHACRfull] = ACTIONS(6174),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHacs] = ACTIONS(6174),
    [anon_sym_BSLASHAcs] = ACTIONS(6174),
    [anon_sym_BSLASHacsp] = ACTIONS(6174),
    [anon_sym_BSLASHAcsp] = ACTIONS(6174),
    [anon_sym_BSLASHacl] = ACTIONS(6174),
    [anon_sym_BSLASHAcl] = ACTIONS(6174),
    [anon_sym_BSLASHaclp] = ACTIONS(6174),
    [anon_sym_BSLASHAclp] = ACTIONS(6174),
    [anon_sym_BSLASHacf] = ACTIONS(6174),
    [anon_sym_BSLASHAcf] = ACTIONS(6174),
    [anon_sym_BSLASHacfp] = ACTIONS(6174),
    [anon_sym_BSLASHAcfp] = ACTIONS(6174),
    [anon_sym_BSLASHac] = ACTIONS(6174),
    [anon_sym_BSLASHAc] = ACTIONS(6174),
    [anon_sym_BSLASHacp] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6174),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6174),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6174),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6174),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6176),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6174),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6174),
    [anon_sym_BSLASHcolor] = ACTIONS(6174),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6174),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6174),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6174),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6174),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6174),
    [anon_sym_BSLASHurl] = ACTIONS(6174),
    [anon_sym_BSLASHhref] = ACTIONS(6174),
  },
  [2057] = {
    [sym_command_name] = ACTIONS(6182),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6182),
    [anon_sym_RBRACK] = ACTIONS(6184),
    [anon_sym_COMMA] = ACTIONS(6184),
    [anon_sym_EQ] = ACTIONS(6184),
    [anon_sym_RBRACE] = ACTIONS(6184),
    [sym_word] = ACTIONS(6182),
    [sym_placeholder] = ACTIONS(6184),
    [anon_sym_PLUS] = ACTIONS(6184),
    [anon_sym_DASH] = ACTIONS(6184),
    [anon_sym_STAR] = ACTIONS(6184),
    [anon_sym_SLASH] = ACTIONS(6184),
    [anon_sym_LT] = ACTIONS(6182),
    [anon_sym_GT] = ACTIONS(6182),
    [anon_sym_BANG] = ACTIONS(6182),
    [anon_sym_PIPE] = ACTIONS(6182),
    [anon_sym_COLON] = ACTIONS(6182),
    [anon_sym_SQUOTE] = ACTIONS(6182),
    [anon_sym__] = ACTIONS(6184),
    [anon_sym_CARET] = ACTIONS(6184),
    [anon_sym_BSLASHtitle] = ACTIONS(6182),
    [anon_sym_BSLASHauthor] = ACTIONS(6182),
    [anon_sym_BSLASHusepackage] = ACTIONS(6182),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6182),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6182),
    [anon_sym_BSLASHinclude] = ACTIONS(6182),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6182),
    [anon_sym_BSLASHinput] = ACTIONS(6182),
    [anon_sym_BSLASHsubfile] = ACTIONS(6182),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6182),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6182),
    [anon_sym_BSLASHbibliography] = ACTIONS(6182),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6182),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6182),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6182),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6182),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6182),
    [anon_sym_BSLASHimport] = ACTIONS(6182),
    [anon_sym_BSLASHsubimport] = ACTIONS(6182),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6182),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6182),
    [anon_sym_BSLASHcaption] = ACTIONS(6182),
    [anon_sym_BSLASHcite] = ACTIONS(6182),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCite] = ACTIONS(6182),
    [anon_sym_BSLASHnocite] = ACTIONS(6182),
    [anon_sym_BSLASHcitet] = ACTIONS(6182),
    [anon_sym_BSLASHcitep] = ACTIONS(6182),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteA] = ACTIONS(6182),
    [anon_sym_BSLASHciteR] = ACTIONS(6182),
    [anon_sym_BSLASHciteS] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6182),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6182),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteyear] = ACTIONS(6182),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHcitedate] = ACTIONS(6182),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHciteurl] = ACTIONS(6182),
    [anon_sym_BSLASHfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6182),
    [anon_sym_BSLASHcitealt] = ACTIONS(6182),
    [anon_sym_BSLASHcitealp] = ACTIONS(6182),
    [anon_sym_BSLASHcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHparencite] = ACTIONS(6182),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHParencite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6182),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6182),
    [anon_sym_BSLASHtextcite] = ACTIONS(6182),
    [anon_sym_BSLASHTextcite] = ACTIONS(6182),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6182),
    [anon_sym_BSLASHsupercite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite] = ACTIONS(6182),
    [anon_sym_BSLASHAutocite] = ACTIONS(6182),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHVolcite] = ACTIONS(6182),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHavolcite] = ACTIONS(6182),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6182),
    [anon_sym_BSLASHnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHNotecite] = ACTIONS(6182),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6182),
    [anon_sym_BSLASHlabel] = ACTIONS(6182),
    [anon_sym_BSLASHref] = ACTIONS(6182),
    [anon_sym_BSLASHeqref] = ACTIONS(6182),
    [anon_sym_BSLASHvref] = ACTIONS(6182),
    [anon_sym_BSLASHVref] = ACTIONS(6182),
    [anon_sym_BSLASHautoref] = ACTIONS(6182),
    [anon_sym_BSLASHpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcref] = ACTIONS(6182),
    [anon_sym_BSLASHCref] = ACTIONS(6182),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnameCref] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6182),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6182),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6182),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6182),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6182),
    [anon_sym_BSLASHdef] = ACTIONS(6182),
    [anon_sym_BSLASHlet] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6182),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6182),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6182),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6182),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6182),
    [anon_sym_BSLASHgls] = ACTIONS(6182),
    [anon_sym_BSLASHGls] = ACTIONS(6182),
    [anon_sym_BSLASHGLS] = ACTIONS(6182),
    [anon_sym_BSLASHglspl] = ACTIONS(6182),
    [anon_sym_BSLASHGlspl] = ACTIONS(6182),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6182),
    [anon_sym_BSLASHglslink] = ACTIONS(6182),
    [anon_sym_BSLASHglstext] = ACTIONS(6182),
    [anon_sym_BSLASHGlstext] = ACTIONS(6182),
    [anon_sym_BSLASHGLStext] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6182),
    [anon_sym_BSLASHglsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6182),
    [anon_sym_BSLASHglsname] = ACTIONS(6182),
    [anon_sym_BSLASHGlsname] = ACTIONS(6182),
    [anon_sym_BSLASHGLSname] = ACTIONS(6182),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6182),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6182),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6182),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6182),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6182),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6182),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6182),
    [anon_sym_BSLASHacrshort] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6182),
    [anon_sym_BSLASHACRshort] = ACTIONS(6182),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrlong] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6182),
    [anon_sym_BSLASHACRlong] = ACTIONS(6182),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6182),
    [anon_sym_BSLASHacrfull] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6182),
    [anon_sym_BSLASHACRfull] = ACTIONS(6182),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHacs] = ACTIONS(6182),
    [anon_sym_BSLASHAcs] = ACTIONS(6182),
    [anon_sym_BSLASHacsp] = ACTIONS(6182),
    [anon_sym_BSLASHAcsp] = ACTIONS(6182),
    [anon_sym_BSLASHacl] = ACTIONS(6182),
    [anon_sym_BSLASHAcl] = ACTIONS(6182),
    [anon_sym_BSLASHaclp] = ACTIONS(6182),
    [anon_sym_BSLASHAclp] = ACTIONS(6182),
    [anon_sym_BSLASHacf] = ACTIONS(6182),
    [anon_sym_BSLASHAcf] = ACTIONS(6182),
    [anon_sym_BSLASHacfp] = ACTIONS(6182),
    [anon_sym_BSLASHAcfp] = ACTIONS(6182),
    [anon_sym_BSLASHac] = ACTIONS(6182),
    [anon_sym_BSLASHAc] = ACTIONS(6182),
    [anon_sym_BSLASHacp] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6182),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6182),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6182),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6182),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6184),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6182),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6182),
    [anon_sym_BSLASHcolor] = ACTIONS(6182),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6182),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6182),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6182),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6182),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6182),
    [anon_sym_BSLASHurl] = ACTIONS(6182),
    [anon_sym_BSLASHhref] = ACTIONS(6182),
  },
  [2058] = {
    [sym_command_name] = ACTIONS(6190),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6190),
    [anon_sym_RBRACK] = ACTIONS(6192),
    [anon_sym_COMMA] = ACTIONS(6192),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_RBRACE] = ACTIONS(6192),
    [sym_word] = ACTIONS(6190),
    [sym_placeholder] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6190),
    [anon_sym_BANG] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6190),
    [anon_sym_COLON] = ACTIONS(6190),
    [anon_sym_SQUOTE] = ACTIONS(6190),
    [anon_sym__] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_BSLASHtitle] = ACTIONS(6190),
    [anon_sym_BSLASHauthor] = ACTIONS(6190),
    [anon_sym_BSLASHusepackage] = ACTIONS(6190),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6190),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6190),
    [anon_sym_BSLASHinclude] = ACTIONS(6190),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6190),
    [anon_sym_BSLASHinput] = ACTIONS(6190),
    [anon_sym_BSLASHsubfile] = ACTIONS(6190),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6190),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6190),
    [anon_sym_BSLASHbibliography] = ACTIONS(6190),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6190),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6190),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6190),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6190),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6190),
    [anon_sym_BSLASHimport] = ACTIONS(6190),
    [anon_sym_BSLASHsubimport] = ACTIONS(6190),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6190),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6190),
    [anon_sym_BSLASHcaption] = ACTIONS(6190),
    [anon_sym_BSLASHcite] = ACTIONS(6190),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCite] = ACTIONS(6190),
    [anon_sym_BSLASHnocite] = ACTIONS(6190),
    [anon_sym_BSLASHcitet] = ACTIONS(6190),
    [anon_sym_BSLASHcitep] = ACTIONS(6190),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteA] = ACTIONS(6190),
    [anon_sym_BSLASHciteR] = ACTIONS(6190),
    [anon_sym_BSLASHciteS] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6190),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6190),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteyear] = ACTIONS(6190),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHcitedate] = ACTIONS(6190),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHciteurl] = ACTIONS(6190),
    [anon_sym_BSLASHfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6190),
    [anon_sym_BSLASHcitealt] = ACTIONS(6190),
    [anon_sym_BSLASHcitealp] = ACTIONS(6190),
    [anon_sym_BSLASHcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHparencite] = ACTIONS(6190),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHParencite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6190),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6190),
    [anon_sym_BSLASHtextcite] = ACTIONS(6190),
    [anon_sym_BSLASHTextcite] = ACTIONS(6190),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6190),
    [anon_sym_BSLASHsupercite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite] = ACTIONS(6190),
    [anon_sym_BSLASHAutocite] = ACTIONS(6190),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHVolcite] = ACTIONS(6190),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHavolcite] = ACTIONS(6190),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6190),
    [anon_sym_BSLASHnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHNotecite] = ACTIONS(6190),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6190),
    [anon_sym_BSLASHlabel] = ACTIONS(6190),
    [anon_sym_BSLASHref] = ACTIONS(6190),
    [anon_sym_BSLASHeqref] = ACTIONS(6190),
    [anon_sym_BSLASHvref] = ACTIONS(6190),
    [anon_sym_BSLASHVref] = ACTIONS(6190),
    [anon_sym_BSLASHautoref] = ACTIONS(6190),
    [anon_sym_BSLASHpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcref] = ACTIONS(6190),
    [anon_sym_BSLASHCref] = ACTIONS(6190),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnameCref] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6190),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6190),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6190),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6190),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6190),
    [anon_sym_BSLASHdef] = ACTIONS(6190),
    [anon_sym_BSLASHlet] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6190),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6190),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6190),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6190),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6190),
    [anon_sym_BSLASHgls] = ACTIONS(6190),
    [anon_sym_BSLASHGls] = ACTIONS(6190),
    [anon_sym_BSLASHGLS] = ACTIONS(6190),
    [anon_sym_BSLASHglspl] = ACTIONS(6190),
    [anon_sym_BSLASHGlspl] = ACTIONS(6190),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6190),
    [anon_sym_BSLASHglslink] = ACTIONS(6190),
    [anon_sym_BSLASHglstext] = ACTIONS(6190),
    [anon_sym_BSLASHGlstext] = ACTIONS(6190),
    [anon_sym_BSLASHGLStext] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6190),
    [anon_sym_BSLASHglsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6190),
    [anon_sym_BSLASHglsname] = ACTIONS(6190),
    [anon_sym_BSLASHGlsname] = ACTIONS(6190),
    [anon_sym_BSLASHGLSname] = ACTIONS(6190),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6190),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6190),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6190),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6190),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6190),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6190),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6190),
    [anon_sym_BSLASHacrshort] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6190),
    [anon_sym_BSLASHACRshort] = ACTIONS(6190),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrlong] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6190),
    [anon_sym_BSLASHACRlong] = ACTIONS(6190),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6190),
    [anon_sym_BSLASHacrfull] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6190),
    [anon_sym_BSLASHACRfull] = ACTIONS(6190),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHacs] = ACTIONS(6190),
    [anon_sym_BSLASHAcs] = ACTIONS(6190),
    [anon_sym_BSLASHacsp] = ACTIONS(6190),
    [anon_sym_BSLASHAcsp] = ACTIONS(6190),
    [anon_sym_BSLASHacl] = ACTIONS(6190),
    [anon_sym_BSLASHAcl] = ACTIONS(6190),
    [anon_sym_BSLASHaclp] = ACTIONS(6190),
    [anon_sym_BSLASHAclp] = ACTIONS(6190),
    [anon_sym_BSLASHacf] = ACTIONS(6190),
    [anon_sym_BSLASHAcf] = ACTIONS(6190),
    [anon_sym_BSLASHacfp] = ACTIONS(6190),
    [anon_sym_BSLASHAcfp] = ACTIONS(6190),
    [anon_sym_BSLASHac] = ACTIONS(6190),
    [anon_sym_BSLASHAc] = ACTIONS(6190),
    [anon_sym_BSLASHacp] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6190),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6190),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6190),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6190),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6192),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6190),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6190),
    [anon_sym_BSLASHcolor] = ACTIONS(6190),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6190),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6190),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6190),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6190),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6190),
    [anon_sym_BSLASHurl] = ACTIONS(6190),
    [anon_sym_BSLASHhref] = ACTIONS(6190),
  },
  [2059] = {
    [sym_command_name] = ACTIONS(6198),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6198),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_COMMA] = ACTIONS(6200),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_RBRACE] = ACTIONS(6200),
    [sym_word] = ACTIONS(6198),
    [sym_placeholder] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_BANG] = ACTIONS(6198),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_COLON] = ACTIONS(6198),
    [anon_sym_SQUOTE] = ACTIONS(6198),
    [anon_sym__] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_BSLASHtitle] = ACTIONS(6198),
    [anon_sym_BSLASHauthor] = ACTIONS(6198),
    [anon_sym_BSLASHusepackage] = ACTIONS(6198),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6198),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6198),
    [anon_sym_BSLASHinclude] = ACTIONS(6198),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6198),
    [anon_sym_BSLASHinput] = ACTIONS(6198),
    [anon_sym_BSLASHsubfile] = ACTIONS(6198),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6198),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6198),
    [anon_sym_BSLASHbibliography] = ACTIONS(6198),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6198),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6198),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6198),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6198),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6198),
    [anon_sym_BSLASHimport] = ACTIONS(6198),
    [anon_sym_BSLASHsubimport] = ACTIONS(6198),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6198),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6198),
    [anon_sym_BSLASHcaption] = ACTIONS(6198),
    [anon_sym_BSLASHcite] = ACTIONS(6198),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCite] = ACTIONS(6198),
    [anon_sym_BSLASHnocite] = ACTIONS(6198),
    [anon_sym_BSLASHcitet] = ACTIONS(6198),
    [anon_sym_BSLASHcitep] = ACTIONS(6198),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteA] = ACTIONS(6198),
    [anon_sym_BSLASHciteR] = ACTIONS(6198),
    [anon_sym_BSLASHciteS] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6198),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6198),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteyear] = ACTIONS(6198),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHcitedate] = ACTIONS(6198),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHciteurl] = ACTIONS(6198),
    [anon_sym_BSLASHfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6198),
    [anon_sym_BSLASHcitealt] = ACTIONS(6198),
    [anon_sym_BSLASHcitealp] = ACTIONS(6198),
    [anon_sym_BSLASHcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHparencite] = ACTIONS(6198),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHParencite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6198),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6198),
    [anon_sym_BSLASHtextcite] = ACTIONS(6198),
    [anon_sym_BSLASHTextcite] = ACTIONS(6198),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6198),
    [anon_sym_BSLASHsupercite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite] = ACTIONS(6198),
    [anon_sym_BSLASHAutocite] = ACTIONS(6198),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHVolcite] = ACTIONS(6198),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHavolcite] = ACTIONS(6198),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6198),
    [anon_sym_BSLASHnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHNotecite] = ACTIONS(6198),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6198),
    [anon_sym_BSLASHlabel] = ACTIONS(6198),
    [anon_sym_BSLASHref] = ACTIONS(6198),
    [anon_sym_BSLASHeqref] = ACTIONS(6198),
    [anon_sym_BSLASHvref] = ACTIONS(6198),
    [anon_sym_BSLASHVref] = ACTIONS(6198),
    [anon_sym_BSLASHautoref] = ACTIONS(6198),
    [anon_sym_BSLASHpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcref] = ACTIONS(6198),
    [anon_sym_BSLASHCref] = ACTIONS(6198),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnameCref] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6198),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6198),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6198),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6198),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6198),
    [anon_sym_BSLASHdef] = ACTIONS(6198),
    [anon_sym_BSLASHlet] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6198),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6198),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6198),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6198),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6198),
    [anon_sym_BSLASHgls] = ACTIONS(6198),
    [anon_sym_BSLASHGls] = ACTIONS(6198),
    [anon_sym_BSLASHGLS] = ACTIONS(6198),
    [anon_sym_BSLASHglspl] = ACTIONS(6198),
    [anon_sym_BSLASHGlspl] = ACTIONS(6198),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6198),
    [anon_sym_BSLASHglslink] = ACTIONS(6198),
    [anon_sym_BSLASHglstext] = ACTIONS(6198),
    [anon_sym_BSLASHGlstext] = ACTIONS(6198),
    [anon_sym_BSLASHGLStext] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6198),
    [anon_sym_BSLASHglsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6198),
    [anon_sym_BSLASHglsname] = ACTIONS(6198),
    [anon_sym_BSLASHGlsname] = ACTIONS(6198),
    [anon_sym_BSLASHGLSname] = ACTIONS(6198),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6198),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6198),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6198),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6198),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6198),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6198),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6198),
    [anon_sym_BSLASHacrshort] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6198),
    [anon_sym_BSLASHACRshort] = ACTIONS(6198),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrlong] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6198),
    [anon_sym_BSLASHACRlong] = ACTIONS(6198),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6198),
    [anon_sym_BSLASHacrfull] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6198),
    [anon_sym_BSLASHACRfull] = ACTIONS(6198),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHacs] = ACTIONS(6198),
    [anon_sym_BSLASHAcs] = ACTIONS(6198),
    [anon_sym_BSLASHacsp] = ACTIONS(6198),
    [anon_sym_BSLASHAcsp] = ACTIONS(6198),
    [anon_sym_BSLASHacl] = ACTIONS(6198),
    [anon_sym_BSLASHAcl] = ACTIONS(6198),
    [anon_sym_BSLASHaclp] = ACTIONS(6198),
    [anon_sym_BSLASHAclp] = ACTIONS(6198),
    [anon_sym_BSLASHacf] = ACTIONS(6198),
    [anon_sym_BSLASHAcf] = ACTIONS(6198),
    [anon_sym_BSLASHacfp] = ACTIONS(6198),
    [anon_sym_BSLASHAcfp] = ACTIONS(6198),
    [anon_sym_BSLASHac] = ACTIONS(6198),
    [anon_sym_BSLASHAc] = ACTIONS(6198),
    [anon_sym_BSLASHacp] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6198),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6198),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6198),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6198),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6200),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6198),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6198),
    [anon_sym_BSLASHcolor] = ACTIONS(6198),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6198),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6198),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6198),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6198),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6198),
    [anon_sym_BSLASHurl] = ACTIONS(6198),
    [anon_sym_BSLASHhref] = ACTIONS(6198),
  },
  [2060] = {
    [sym_command_name] = ACTIONS(6290),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6290),
    [anon_sym_RBRACK] = ACTIONS(6292),
    [anon_sym_COMMA] = ACTIONS(6292),
    [anon_sym_EQ] = ACTIONS(6292),
    [anon_sym_RBRACE] = ACTIONS(6292),
    [sym_word] = ACTIONS(6290),
    [sym_placeholder] = ACTIONS(6292),
    [anon_sym_PLUS] = ACTIONS(6292),
    [anon_sym_DASH] = ACTIONS(6292),
    [anon_sym_STAR] = ACTIONS(6292),
    [anon_sym_SLASH] = ACTIONS(6292),
    [anon_sym_LT] = ACTIONS(6290),
    [anon_sym_GT] = ACTIONS(6290),
    [anon_sym_BANG] = ACTIONS(6290),
    [anon_sym_PIPE] = ACTIONS(6290),
    [anon_sym_COLON] = ACTIONS(6290),
    [anon_sym_SQUOTE] = ACTIONS(6290),
    [anon_sym__] = ACTIONS(6292),
    [anon_sym_CARET] = ACTIONS(6292),
    [anon_sym_BSLASHtitle] = ACTIONS(6290),
    [anon_sym_BSLASHauthor] = ACTIONS(6290),
    [anon_sym_BSLASHusepackage] = ACTIONS(6290),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6290),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6290),
    [anon_sym_BSLASHinclude] = ACTIONS(6290),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6290),
    [anon_sym_BSLASHinput] = ACTIONS(6290),
    [anon_sym_BSLASHsubfile] = ACTIONS(6290),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6290),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6290),
    [anon_sym_BSLASHbibliography] = ACTIONS(6290),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6290),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6290),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6290),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6290),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6290),
    [anon_sym_BSLASHimport] = ACTIONS(6290),
    [anon_sym_BSLASHsubimport] = ACTIONS(6290),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6290),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6290),
    [anon_sym_BSLASHcaption] = ACTIONS(6290),
    [anon_sym_BSLASHcite] = ACTIONS(6290),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCite] = ACTIONS(6290),
    [anon_sym_BSLASHnocite] = ACTIONS(6290),
    [anon_sym_BSLASHcitet] = ACTIONS(6290),
    [anon_sym_BSLASHcitep] = ACTIONS(6290),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteA] = ACTIONS(6290),
    [anon_sym_BSLASHciteR] = ACTIONS(6290),
    [anon_sym_BSLASHciteS] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6290),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6290),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteyear] = ACTIONS(6290),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHcitedate] = ACTIONS(6290),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHciteurl] = ACTIONS(6290),
    [anon_sym_BSLASHfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6290),
    [anon_sym_BSLASHcitealt] = ACTIONS(6290),
    [anon_sym_BSLASHcitealp] = ACTIONS(6290),
    [anon_sym_BSLASHcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHparencite] = ACTIONS(6290),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHParencite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6290),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6290),
    [anon_sym_BSLASHtextcite] = ACTIONS(6290),
    [anon_sym_BSLASHTextcite] = ACTIONS(6290),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6290),
    [anon_sym_BSLASHsupercite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite] = ACTIONS(6290),
    [anon_sym_BSLASHAutocite] = ACTIONS(6290),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHVolcite] = ACTIONS(6290),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHavolcite] = ACTIONS(6290),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6290),
    [anon_sym_BSLASHnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHNotecite] = ACTIONS(6290),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6290),
    [anon_sym_BSLASHlabel] = ACTIONS(6290),
    [anon_sym_BSLASHref] = ACTIONS(6290),
    [anon_sym_BSLASHeqref] = ACTIONS(6290),
    [anon_sym_BSLASHvref] = ACTIONS(6290),
    [anon_sym_BSLASHVref] = ACTIONS(6290),
    [anon_sym_BSLASHautoref] = ACTIONS(6290),
    [anon_sym_BSLASHpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcref] = ACTIONS(6290),
    [anon_sym_BSLASHCref] = ACTIONS(6290),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnameCref] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6290),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6290),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6290),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6290),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6290),
    [anon_sym_BSLASHdef] = ACTIONS(6290),
    [anon_sym_BSLASHlet] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6290),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6290),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6290),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6290),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6290),
    [anon_sym_BSLASHgls] = ACTIONS(6290),
    [anon_sym_BSLASHGls] = ACTIONS(6290),
    [anon_sym_BSLASHGLS] = ACTIONS(6290),
    [anon_sym_BSLASHglspl] = ACTIONS(6290),
    [anon_sym_BSLASHGlspl] = ACTIONS(6290),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6290),
    [anon_sym_BSLASHglslink] = ACTIONS(6290),
    [anon_sym_BSLASHglstext] = ACTIONS(6290),
    [anon_sym_BSLASHGlstext] = ACTIONS(6290),
    [anon_sym_BSLASHGLStext] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6290),
    [anon_sym_BSLASHglsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6290),
    [anon_sym_BSLASHglsname] = ACTIONS(6290),
    [anon_sym_BSLASHGlsname] = ACTIONS(6290),
    [anon_sym_BSLASHGLSname] = ACTIONS(6290),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6290),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6290),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6290),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6290),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6290),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6290),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6290),
    [anon_sym_BSLASHacrshort] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6290),
    [anon_sym_BSLASHACRshort] = ACTIONS(6290),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrlong] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6290),
    [anon_sym_BSLASHACRlong] = ACTIONS(6290),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6290),
    [anon_sym_BSLASHacrfull] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6290),
    [anon_sym_BSLASHACRfull] = ACTIONS(6290),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHacs] = ACTIONS(6290),
    [anon_sym_BSLASHAcs] = ACTIONS(6290),
    [anon_sym_BSLASHacsp] = ACTIONS(6290),
    [anon_sym_BSLASHAcsp] = ACTIONS(6290),
    [anon_sym_BSLASHacl] = ACTIONS(6290),
    [anon_sym_BSLASHAcl] = ACTIONS(6290),
    [anon_sym_BSLASHaclp] = ACTIONS(6290),
    [anon_sym_BSLASHAclp] = ACTIONS(6290),
    [anon_sym_BSLASHacf] = ACTIONS(6290),
    [anon_sym_BSLASHAcf] = ACTIONS(6290),
    [anon_sym_BSLASHacfp] = ACTIONS(6290),
    [anon_sym_BSLASHAcfp] = ACTIONS(6290),
    [anon_sym_BSLASHac] = ACTIONS(6290),
    [anon_sym_BSLASHAc] = ACTIONS(6290),
    [anon_sym_BSLASHacp] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6290),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6290),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6290),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6290),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6292),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6290),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6290),
    [anon_sym_BSLASHcolor] = ACTIONS(6290),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6290),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6290),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6290),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6290),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6290),
    [anon_sym_BSLASHurl] = ACTIONS(6290),
    [anon_sym_BSLASHhref] = ACTIONS(6290),
  },
  [2061] = {
    [sym_command_name] = ACTIONS(6230),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6230),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_COMMA] = ACTIONS(6232),
    [anon_sym_EQ] = ACTIONS(6232),
    [anon_sym_RBRACE] = ACTIONS(6232),
    [sym_word] = ACTIONS(6230),
    [sym_placeholder] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6232),
    [anon_sym_DASH] = ACTIONS(6232),
    [anon_sym_STAR] = ACTIONS(6232),
    [anon_sym_SLASH] = ACTIONS(6232),
    [anon_sym_LT] = ACTIONS(6230),
    [anon_sym_GT] = ACTIONS(6230),
    [anon_sym_BANG] = ACTIONS(6230),
    [anon_sym_PIPE] = ACTIONS(6230),
    [anon_sym_COLON] = ACTIONS(6230),
    [anon_sym_SQUOTE] = ACTIONS(6230),
    [anon_sym__] = ACTIONS(6232),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_BSLASHtitle] = ACTIONS(6230),
    [anon_sym_BSLASHauthor] = ACTIONS(6230),
    [anon_sym_BSLASHusepackage] = ACTIONS(6230),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6230),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6230),
    [anon_sym_BSLASHinclude] = ACTIONS(6230),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6230),
    [anon_sym_BSLASHinput] = ACTIONS(6230),
    [anon_sym_BSLASHsubfile] = ACTIONS(6230),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6230),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6230),
    [anon_sym_BSLASHbibliography] = ACTIONS(6230),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6230),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6230),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6230),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6230),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6230),
    [anon_sym_BSLASHimport] = ACTIONS(6230),
    [anon_sym_BSLASHsubimport] = ACTIONS(6230),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6230),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6230),
    [anon_sym_BSLASHcaption] = ACTIONS(6230),
    [anon_sym_BSLASHcite] = ACTIONS(6230),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCite] = ACTIONS(6230),
    [anon_sym_BSLASHnocite] = ACTIONS(6230),
    [anon_sym_BSLASHcitet] = ACTIONS(6230),
    [anon_sym_BSLASHcitep] = ACTIONS(6230),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteA] = ACTIONS(6230),
    [anon_sym_BSLASHciteR] = ACTIONS(6230),
    [anon_sym_BSLASHciteS] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6230),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6230),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteyear] = ACTIONS(6230),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHcitedate] = ACTIONS(6230),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHciteurl] = ACTIONS(6230),
    [anon_sym_BSLASHfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6230),
    [anon_sym_BSLASHcitealt] = ACTIONS(6230),
    [anon_sym_BSLASHcitealp] = ACTIONS(6230),
    [anon_sym_BSLASHcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHparencite] = ACTIONS(6230),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHParencite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6230),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6230),
    [anon_sym_BSLASHtextcite] = ACTIONS(6230),
    [anon_sym_BSLASHTextcite] = ACTIONS(6230),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6230),
    [anon_sym_BSLASHsupercite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite] = ACTIONS(6230),
    [anon_sym_BSLASHAutocite] = ACTIONS(6230),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHVolcite] = ACTIONS(6230),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHavolcite] = ACTIONS(6230),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6230),
    [anon_sym_BSLASHnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHNotecite] = ACTIONS(6230),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6230),
    [anon_sym_BSLASHlabel] = ACTIONS(6230),
    [anon_sym_BSLASHref] = ACTIONS(6230),
    [anon_sym_BSLASHeqref] = ACTIONS(6230),
    [anon_sym_BSLASHvref] = ACTIONS(6230),
    [anon_sym_BSLASHVref] = ACTIONS(6230),
    [anon_sym_BSLASHautoref] = ACTIONS(6230),
    [anon_sym_BSLASHpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcref] = ACTIONS(6230),
    [anon_sym_BSLASHCref] = ACTIONS(6230),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnameCref] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6230),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6230),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6230),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6230),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6230),
    [anon_sym_BSLASHdef] = ACTIONS(6230),
    [anon_sym_BSLASHlet] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6230),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6230),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6230),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6230),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6230),
    [anon_sym_BSLASHgls] = ACTIONS(6230),
    [anon_sym_BSLASHGls] = ACTIONS(6230),
    [anon_sym_BSLASHGLS] = ACTIONS(6230),
    [anon_sym_BSLASHglspl] = ACTIONS(6230),
    [anon_sym_BSLASHGlspl] = ACTIONS(6230),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6230),
    [anon_sym_BSLASHglslink] = ACTIONS(6230),
    [anon_sym_BSLASHglstext] = ACTIONS(6230),
    [anon_sym_BSLASHGlstext] = ACTIONS(6230),
    [anon_sym_BSLASHGLStext] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6230),
    [anon_sym_BSLASHglsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6230),
    [anon_sym_BSLASHglsname] = ACTIONS(6230),
    [anon_sym_BSLASHGlsname] = ACTIONS(6230),
    [anon_sym_BSLASHGLSname] = ACTIONS(6230),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6230),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6230),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6230),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6230),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6230),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6230),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6230),
    [anon_sym_BSLASHacrshort] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6230),
    [anon_sym_BSLASHACRshort] = ACTIONS(6230),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrlong] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6230),
    [anon_sym_BSLASHACRlong] = ACTIONS(6230),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6230),
    [anon_sym_BSLASHacrfull] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6230),
    [anon_sym_BSLASHACRfull] = ACTIONS(6230),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHacs] = ACTIONS(6230),
    [anon_sym_BSLASHAcs] = ACTIONS(6230),
    [anon_sym_BSLASHacsp] = ACTIONS(6230),
    [anon_sym_BSLASHAcsp] = ACTIONS(6230),
    [anon_sym_BSLASHacl] = ACTIONS(6230),
    [anon_sym_BSLASHAcl] = ACTIONS(6230),
    [anon_sym_BSLASHaclp] = ACTIONS(6230),
    [anon_sym_BSLASHAclp] = ACTIONS(6230),
    [anon_sym_BSLASHacf] = ACTIONS(6230),
    [anon_sym_BSLASHAcf] = ACTIONS(6230),
    [anon_sym_BSLASHacfp] = ACTIONS(6230),
    [anon_sym_BSLASHAcfp] = ACTIONS(6230),
    [anon_sym_BSLASHac] = ACTIONS(6230),
    [anon_sym_BSLASHAc] = ACTIONS(6230),
    [anon_sym_BSLASHacp] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6230),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6230),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6230),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6230),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6232),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6230),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6230),
    [anon_sym_BSLASHcolor] = ACTIONS(6230),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6230),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6230),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6230),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6230),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6230),
    [anon_sym_BSLASHurl] = ACTIONS(6230),
    [anon_sym_BSLASHhref] = ACTIONS(6230),
  },
  [2062] = {
    [sym_command_name] = ACTIONS(6526),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6526),
    [anon_sym_RBRACK] = ACTIONS(6528),
    [anon_sym_COMMA] = ACTIONS(6528),
    [anon_sym_EQ] = ACTIONS(6528),
    [anon_sym_RBRACE] = ACTIONS(6528),
    [sym_word] = ACTIONS(6526),
    [sym_placeholder] = ACTIONS(6528),
    [anon_sym_PLUS] = ACTIONS(6528),
    [anon_sym_DASH] = ACTIONS(6528),
    [anon_sym_STAR] = ACTIONS(6528),
    [anon_sym_SLASH] = ACTIONS(6528),
    [anon_sym_LT] = ACTIONS(6526),
    [anon_sym_GT] = ACTIONS(6526),
    [anon_sym_BANG] = ACTIONS(6526),
    [anon_sym_PIPE] = ACTIONS(6526),
    [anon_sym_COLON] = ACTIONS(6526),
    [anon_sym_SQUOTE] = ACTIONS(6526),
    [anon_sym__] = ACTIONS(6528),
    [anon_sym_CARET] = ACTIONS(6528),
    [anon_sym_BSLASHtitle] = ACTIONS(6526),
    [anon_sym_BSLASHauthor] = ACTIONS(6526),
    [anon_sym_BSLASHusepackage] = ACTIONS(6526),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6526),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6526),
    [anon_sym_BSLASHinclude] = ACTIONS(6526),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6526),
    [anon_sym_BSLASHinput] = ACTIONS(6526),
    [anon_sym_BSLASHsubfile] = ACTIONS(6526),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6526),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6526),
    [anon_sym_BSLASHbibliography] = ACTIONS(6526),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6526),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6526),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6526),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6526),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6526),
    [anon_sym_BSLASHimport] = ACTIONS(6526),
    [anon_sym_BSLASHsubimport] = ACTIONS(6526),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6526),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6526),
    [anon_sym_BSLASHcaption] = ACTIONS(6526),
    [anon_sym_BSLASHcite] = ACTIONS(6526),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCite] = ACTIONS(6526),
    [anon_sym_BSLASHnocite] = ACTIONS(6526),
    [anon_sym_BSLASHcitet] = ACTIONS(6526),
    [anon_sym_BSLASHcitep] = ACTIONS(6526),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteA] = ACTIONS(6526),
    [anon_sym_BSLASHciteR] = ACTIONS(6526),
    [anon_sym_BSLASHciteS] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6526),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6526),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteyear] = ACTIONS(6526),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHcitedate] = ACTIONS(6526),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHciteurl] = ACTIONS(6526),
    [anon_sym_BSLASHfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6526),
    [anon_sym_BSLASHcitealt] = ACTIONS(6526),
    [anon_sym_BSLASHcitealp] = ACTIONS(6526),
    [anon_sym_BSLASHcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHparencite] = ACTIONS(6526),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHParencite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6526),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6526),
    [anon_sym_BSLASHtextcite] = ACTIONS(6526),
    [anon_sym_BSLASHTextcite] = ACTIONS(6526),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6526),
    [anon_sym_BSLASHsupercite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite] = ACTIONS(6526),
    [anon_sym_BSLASHAutocite] = ACTIONS(6526),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHVolcite] = ACTIONS(6526),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHavolcite] = ACTIONS(6526),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6526),
    [anon_sym_BSLASHnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHNotecite] = ACTIONS(6526),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6526),
    [anon_sym_BSLASHlabel] = ACTIONS(6526),
    [anon_sym_BSLASHref] = ACTIONS(6526),
    [anon_sym_BSLASHeqref] = ACTIONS(6526),
    [anon_sym_BSLASHvref] = ACTIONS(6526),
    [anon_sym_BSLASHVref] = ACTIONS(6526),
    [anon_sym_BSLASHautoref] = ACTIONS(6526),
    [anon_sym_BSLASHpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcref] = ACTIONS(6526),
    [anon_sym_BSLASHCref] = ACTIONS(6526),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnameCref] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6526),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6526),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6526),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6526),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6526),
    [anon_sym_BSLASHdef] = ACTIONS(6526),
    [anon_sym_BSLASHlet] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6526),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6526),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6526),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6526),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6526),
    [anon_sym_BSLASHgls] = ACTIONS(6526),
    [anon_sym_BSLASHGls] = ACTIONS(6526),
    [anon_sym_BSLASHGLS] = ACTIONS(6526),
    [anon_sym_BSLASHglspl] = ACTIONS(6526),
    [anon_sym_BSLASHGlspl] = ACTIONS(6526),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6526),
    [anon_sym_BSLASHglslink] = ACTIONS(6526),
    [anon_sym_BSLASHglstext] = ACTIONS(6526),
    [anon_sym_BSLASHGlstext] = ACTIONS(6526),
    [anon_sym_BSLASHGLStext] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6526),
    [anon_sym_BSLASHglsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6526),
    [anon_sym_BSLASHglsname] = ACTIONS(6526),
    [anon_sym_BSLASHGlsname] = ACTIONS(6526),
    [anon_sym_BSLASHGLSname] = ACTIONS(6526),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6526),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6526),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6526),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6526),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6526),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6526),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6526),
    [anon_sym_BSLASHacrshort] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6526),
    [anon_sym_BSLASHACRshort] = ACTIONS(6526),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrlong] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6526),
    [anon_sym_BSLASHACRlong] = ACTIONS(6526),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6526),
    [anon_sym_BSLASHacrfull] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6526),
    [anon_sym_BSLASHACRfull] = ACTIONS(6526),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHacs] = ACTIONS(6526),
    [anon_sym_BSLASHAcs] = ACTIONS(6526),
    [anon_sym_BSLASHacsp] = ACTIONS(6526),
    [anon_sym_BSLASHAcsp] = ACTIONS(6526),
    [anon_sym_BSLASHacl] = ACTIONS(6526),
    [anon_sym_BSLASHAcl] = ACTIONS(6526),
    [anon_sym_BSLASHaclp] = ACTIONS(6526),
    [anon_sym_BSLASHAclp] = ACTIONS(6526),
    [anon_sym_BSLASHacf] = ACTIONS(6526),
    [anon_sym_BSLASHAcf] = ACTIONS(6526),
    [anon_sym_BSLASHacfp] = ACTIONS(6526),
    [anon_sym_BSLASHAcfp] = ACTIONS(6526),
    [anon_sym_BSLASHac] = ACTIONS(6526),
    [anon_sym_BSLASHAc] = ACTIONS(6526),
    [anon_sym_BSLASHacp] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6526),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6526),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6526),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6526),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6528),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6526),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6526),
    [anon_sym_BSLASHcolor] = ACTIONS(6526),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6526),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6526),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6526),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6526),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6526),
    [anon_sym_BSLASHurl] = ACTIONS(6526),
    [anon_sym_BSLASHhref] = ACTIONS(6526),
  },
  [2063] = {
    [sym_command_name] = ACTIONS(6286),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6286),
    [anon_sym_RBRACK] = ACTIONS(6288),
    [anon_sym_COMMA] = ACTIONS(6288),
    [anon_sym_EQ] = ACTIONS(6288),
    [anon_sym_RBRACE] = ACTIONS(6288),
    [sym_word] = ACTIONS(6286),
    [sym_placeholder] = ACTIONS(6288),
    [anon_sym_PLUS] = ACTIONS(6288),
    [anon_sym_DASH] = ACTIONS(6288),
    [anon_sym_STAR] = ACTIONS(6288),
    [anon_sym_SLASH] = ACTIONS(6288),
    [anon_sym_LT] = ACTIONS(6286),
    [anon_sym_GT] = ACTIONS(6286),
    [anon_sym_BANG] = ACTIONS(6286),
    [anon_sym_PIPE] = ACTIONS(6286),
    [anon_sym_COLON] = ACTIONS(6286),
    [anon_sym_SQUOTE] = ACTIONS(6286),
    [anon_sym__] = ACTIONS(6288),
    [anon_sym_CARET] = ACTIONS(6288),
    [anon_sym_BSLASHtitle] = ACTIONS(6286),
    [anon_sym_BSLASHauthor] = ACTIONS(6286),
    [anon_sym_BSLASHusepackage] = ACTIONS(6286),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6286),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6286),
    [anon_sym_BSLASHinclude] = ACTIONS(6286),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6286),
    [anon_sym_BSLASHinput] = ACTIONS(6286),
    [anon_sym_BSLASHsubfile] = ACTIONS(6286),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6286),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6286),
    [anon_sym_BSLASHbibliography] = ACTIONS(6286),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6286),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6286),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6286),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6286),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6286),
    [anon_sym_BSLASHimport] = ACTIONS(6286),
    [anon_sym_BSLASHsubimport] = ACTIONS(6286),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6286),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6286),
    [anon_sym_BSLASHcaption] = ACTIONS(6286),
    [anon_sym_BSLASHcite] = ACTIONS(6286),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCite] = ACTIONS(6286),
    [anon_sym_BSLASHnocite] = ACTIONS(6286),
    [anon_sym_BSLASHcitet] = ACTIONS(6286),
    [anon_sym_BSLASHcitep] = ACTIONS(6286),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteA] = ACTIONS(6286),
    [anon_sym_BSLASHciteR] = ACTIONS(6286),
    [anon_sym_BSLASHciteS] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6286),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6286),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteyear] = ACTIONS(6286),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHcitedate] = ACTIONS(6286),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHciteurl] = ACTIONS(6286),
    [anon_sym_BSLASHfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6286),
    [anon_sym_BSLASHcitealt] = ACTIONS(6286),
    [anon_sym_BSLASHcitealp] = ACTIONS(6286),
    [anon_sym_BSLASHcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHparencite] = ACTIONS(6286),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHParencite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6286),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6286),
    [anon_sym_BSLASHtextcite] = ACTIONS(6286),
    [anon_sym_BSLASHTextcite] = ACTIONS(6286),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6286),
    [anon_sym_BSLASHsupercite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite] = ACTIONS(6286),
    [anon_sym_BSLASHAutocite] = ACTIONS(6286),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHVolcite] = ACTIONS(6286),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHavolcite] = ACTIONS(6286),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6286),
    [anon_sym_BSLASHnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHNotecite] = ACTIONS(6286),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6286),
    [anon_sym_BSLASHlabel] = ACTIONS(6286),
    [anon_sym_BSLASHref] = ACTIONS(6286),
    [anon_sym_BSLASHeqref] = ACTIONS(6286),
    [anon_sym_BSLASHvref] = ACTIONS(6286),
    [anon_sym_BSLASHVref] = ACTIONS(6286),
    [anon_sym_BSLASHautoref] = ACTIONS(6286),
    [anon_sym_BSLASHpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcref] = ACTIONS(6286),
    [anon_sym_BSLASHCref] = ACTIONS(6286),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnameCref] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6286),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6286),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6286),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6286),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6286),
    [anon_sym_BSLASHdef] = ACTIONS(6286),
    [anon_sym_BSLASHlet] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6286),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6286),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6286),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6286),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6286),
    [anon_sym_BSLASHgls] = ACTIONS(6286),
    [anon_sym_BSLASHGls] = ACTIONS(6286),
    [anon_sym_BSLASHGLS] = ACTIONS(6286),
    [anon_sym_BSLASHglspl] = ACTIONS(6286),
    [anon_sym_BSLASHGlspl] = ACTIONS(6286),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6286),
    [anon_sym_BSLASHglslink] = ACTIONS(6286),
    [anon_sym_BSLASHglstext] = ACTIONS(6286),
    [anon_sym_BSLASHGlstext] = ACTIONS(6286),
    [anon_sym_BSLASHGLStext] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6286),
    [anon_sym_BSLASHglsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6286),
    [anon_sym_BSLASHglsname] = ACTIONS(6286),
    [anon_sym_BSLASHGlsname] = ACTIONS(6286),
    [anon_sym_BSLASHGLSname] = ACTIONS(6286),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6286),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6286),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6286),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6286),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6286),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6286),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6286),
    [anon_sym_BSLASHacrshort] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6286),
    [anon_sym_BSLASHACRshort] = ACTIONS(6286),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrlong] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6286),
    [anon_sym_BSLASHACRlong] = ACTIONS(6286),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6286),
    [anon_sym_BSLASHacrfull] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6286),
    [anon_sym_BSLASHACRfull] = ACTIONS(6286),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHacs] = ACTIONS(6286),
    [anon_sym_BSLASHAcs] = ACTIONS(6286),
    [anon_sym_BSLASHacsp] = ACTIONS(6286),
    [anon_sym_BSLASHAcsp] = ACTIONS(6286),
    [anon_sym_BSLASHacl] = ACTIONS(6286),
    [anon_sym_BSLASHAcl] = ACTIONS(6286),
    [anon_sym_BSLASHaclp] = ACTIONS(6286),
    [anon_sym_BSLASHAclp] = ACTIONS(6286),
    [anon_sym_BSLASHacf] = ACTIONS(6286),
    [anon_sym_BSLASHAcf] = ACTIONS(6286),
    [anon_sym_BSLASHacfp] = ACTIONS(6286),
    [anon_sym_BSLASHAcfp] = ACTIONS(6286),
    [anon_sym_BSLASHac] = ACTIONS(6286),
    [anon_sym_BSLASHAc] = ACTIONS(6286),
    [anon_sym_BSLASHacp] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6286),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6286),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6286),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6286),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6288),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6286),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6286),
    [anon_sym_BSLASHcolor] = ACTIONS(6286),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6286),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6286),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6286),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6286),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6286),
    [anon_sym_BSLASHurl] = ACTIONS(6286),
    [anon_sym_BSLASHhref] = ACTIONS(6286),
  },
  [2064] = {
    [sym_command_name] = ACTIONS(6270),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6270),
    [anon_sym_RBRACK] = ACTIONS(6272),
    [anon_sym_COMMA] = ACTIONS(6272),
    [anon_sym_EQ] = ACTIONS(6272),
    [anon_sym_RBRACE] = ACTIONS(6272),
    [sym_word] = ACTIONS(6270),
    [sym_placeholder] = ACTIONS(6272),
    [anon_sym_PLUS] = ACTIONS(6272),
    [anon_sym_DASH] = ACTIONS(6272),
    [anon_sym_STAR] = ACTIONS(6272),
    [anon_sym_SLASH] = ACTIONS(6272),
    [anon_sym_LT] = ACTIONS(6270),
    [anon_sym_GT] = ACTIONS(6270),
    [anon_sym_BANG] = ACTIONS(6270),
    [anon_sym_PIPE] = ACTIONS(6270),
    [anon_sym_COLON] = ACTIONS(6270),
    [anon_sym_SQUOTE] = ACTIONS(6270),
    [anon_sym__] = ACTIONS(6272),
    [anon_sym_CARET] = ACTIONS(6272),
    [anon_sym_BSLASHtitle] = ACTIONS(6270),
    [anon_sym_BSLASHauthor] = ACTIONS(6270),
    [anon_sym_BSLASHusepackage] = ACTIONS(6270),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6270),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6270),
    [anon_sym_BSLASHinclude] = ACTIONS(6270),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6270),
    [anon_sym_BSLASHinput] = ACTIONS(6270),
    [anon_sym_BSLASHsubfile] = ACTIONS(6270),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6270),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6270),
    [anon_sym_BSLASHbibliography] = ACTIONS(6270),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6270),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6270),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6270),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6270),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6270),
    [anon_sym_BSLASHimport] = ACTIONS(6270),
    [anon_sym_BSLASHsubimport] = ACTIONS(6270),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6270),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6270),
    [anon_sym_BSLASHcaption] = ACTIONS(6270),
    [anon_sym_BSLASHcite] = ACTIONS(6270),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCite] = ACTIONS(6270),
    [anon_sym_BSLASHnocite] = ACTIONS(6270),
    [anon_sym_BSLASHcitet] = ACTIONS(6270),
    [anon_sym_BSLASHcitep] = ACTIONS(6270),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteA] = ACTIONS(6270),
    [anon_sym_BSLASHciteR] = ACTIONS(6270),
    [anon_sym_BSLASHciteS] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6270),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6270),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteyear] = ACTIONS(6270),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHcitedate] = ACTIONS(6270),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHciteurl] = ACTIONS(6270),
    [anon_sym_BSLASHfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6270),
    [anon_sym_BSLASHcitealt] = ACTIONS(6270),
    [anon_sym_BSLASHcitealp] = ACTIONS(6270),
    [anon_sym_BSLASHcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHparencite] = ACTIONS(6270),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHParencite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6270),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6270),
    [anon_sym_BSLASHtextcite] = ACTIONS(6270),
    [anon_sym_BSLASHTextcite] = ACTIONS(6270),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6270),
    [anon_sym_BSLASHsupercite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite] = ACTIONS(6270),
    [anon_sym_BSLASHAutocite] = ACTIONS(6270),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHVolcite] = ACTIONS(6270),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHavolcite] = ACTIONS(6270),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6270),
    [anon_sym_BSLASHnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHNotecite] = ACTIONS(6270),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6270),
    [anon_sym_BSLASHlabel] = ACTIONS(6270),
    [anon_sym_BSLASHref] = ACTIONS(6270),
    [anon_sym_BSLASHeqref] = ACTIONS(6270),
    [anon_sym_BSLASHvref] = ACTIONS(6270),
    [anon_sym_BSLASHVref] = ACTIONS(6270),
    [anon_sym_BSLASHautoref] = ACTIONS(6270),
    [anon_sym_BSLASHpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcref] = ACTIONS(6270),
    [anon_sym_BSLASHCref] = ACTIONS(6270),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnameCref] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6270),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6270),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6270),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6270),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6270),
    [anon_sym_BSLASHdef] = ACTIONS(6270),
    [anon_sym_BSLASHlet] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6270),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6270),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6270),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6270),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6270),
    [anon_sym_BSLASHgls] = ACTIONS(6270),
    [anon_sym_BSLASHGls] = ACTIONS(6270),
    [anon_sym_BSLASHGLS] = ACTIONS(6270),
    [anon_sym_BSLASHglspl] = ACTIONS(6270),
    [anon_sym_BSLASHGlspl] = ACTIONS(6270),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6270),
    [anon_sym_BSLASHglslink] = ACTIONS(6270),
    [anon_sym_BSLASHglstext] = ACTIONS(6270),
    [anon_sym_BSLASHGlstext] = ACTIONS(6270),
    [anon_sym_BSLASHGLStext] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6270),
    [anon_sym_BSLASHglsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6270),
    [anon_sym_BSLASHglsname] = ACTIONS(6270),
    [anon_sym_BSLASHGlsname] = ACTIONS(6270),
    [anon_sym_BSLASHGLSname] = ACTIONS(6270),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6270),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6270),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6270),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6270),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6270),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6270),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6270),
    [anon_sym_BSLASHacrshort] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6270),
    [anon_sym_BSLASHACRshort] = ACTIONS(6270),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrlong] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6270),
    [anon_sym_BSLASHACRlong] = ACTIONS(6270),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6270),
    [anon_sym_BSLASHacrfull] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6270),
    [anon_sym_BSLASHACRfull] = ACTIONS(6270),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHacs] = ACTIONS(6270),
    [anon_sym_BSLASHAcs] = ACTIONS(6270),
    [anon_sym_BSLASHacsp] = ACTIONS(6270),
    [anon_sym_BSLASHAcsp] = ACTIONS(6270),
    [anon_sym_BSLASHacl] = ACTIONS(6270),
    [anon_sym_BSLASHAcl] = ACTIONS(6270),
    [anon_sym_BSLASHaclp] = ACTIONS(6270),
    [anon_sym_BSLASHAclp] = ACTIONS(6270),
    [anon_sym_BSLASHacf] = ACTIONS(6270),
    [anon_sym_BSLASHAcf] = ACTIONS(6270),
    [anon_sym_BSLASHacfp] = ACTIONS(6270),
    [anon_sym_BSLASHAcfp] = ACTIONS(6270),
    [anon_sym_BSLASHac] = ACTIONS(6270),
    [anon_sym_BSLASHAc] = ACTIONS(6270),
    [anon_sym_BSLASHacp] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6270),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6270),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6270),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6270),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6272),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6270),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6270),
    [anon_sym_BSLASHcolor] = ACTIONS(6270),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6270),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6270),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6270),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6270),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6270),
    [anon_sym_BSLASHurl] = ACTIONS(6270),
    [anon_sym_BSLASHhref] = ACTIONS(6270),
  },
  [2065] = {
    [sym_command_name] = ACTIONS(6226),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6226),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_COMMA] = ACTIONS(6228),
    [anon_sym_EQ] = ACTIONS(6228),
    [anon_sym_RBRACE] = ACTIONS(6228),
    [sym_word] = ACTIONS(6226),
    [sym_placeholder] = ACTIONS(6228),
    [anon_sym_PLUS] = ACTIONS(6228),
    [anon_sym_DASH] = ACTIONS(6228),
    [anon_sym_STAR] = ACTIONS(6228),
    [anon_sym_SLASH] = ACTIONS(6228),
    [anon_sym_LT] = ACTIONS(6226),
    [anon_sym_GT] = ACTIONS(6226),
    [anon_sym_BANG] = ACTIONS(6226),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_COLON] = ACTIONS(6226),
    [anon_sym_SQUOTE] = ACTIONS(6226),
    [anon_sym__] = ACTIONS(6228),
    [anon_sym_CARET] = ACTIONS(6228),
    [anon_sym_BSLASHtitle] = ACTIONS(6226),
    [anon_sym_BSLASHauthor] = ACTIONS(6226),
    [anon_sym_BSLASHusepackage] = ACTIONS(6226),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6226),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6226),
    [anon_sym_BSLASHinclude] = ACTIONS(6226),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6226),
    [anon_sym_BSLASHinput] = ACTIONS(6226),
    [anon_sym_BSLASHsubfile] = ACTIONS(6226),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6226),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6226),
    [anon_sym_BSLASHbibliography] = ACTIONS(6226),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6226),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6226),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6226),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6226),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6226),
    [anon_sym_BSLASHimport] = ACTIONS(6226),
    [anon_sym_BSLASHsubimport] = ACTIONS(6226),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6226),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6226),
    [anon_sym_BSLASHcaption] = ACTIONS(6226),
    [anon_sym_BSLASHcite] = ACTIONS(6226),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCite] = ACTIONS(6226),
    [anon_sym_BSLASHnocite] = ACTIONS(6226),
    [anon_sym_BSLASHcitet] = ACTIONS(6226),
    [anon_sym_BSLASHcitep] = ACTIONS(6226),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteA] = ACTIONS(6226),
    [anon_sym_BSLASHciteR] = ACTIONS(6226),
    [anon_sym_BSLASHciteS] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6226),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6226),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteyear] = ACTIONS(6226),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHcitedate] = ACTIONS(6226),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHciteurl] = ACTIONS(6226),
    [anon_sym_BSLASHfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6226),
    [anon_sym_BSLASHcitealt] = ACTIONS(6226),
    [anon_sym_BSLASHcitealp] = ACTIONS(6226),
    [anon_sym_BSLASHcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHparencite] = ACTIONS(6226),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHParencite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6226),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6226),
    [anon_sym_BSLASHtextcite] = ACTIONS(6226),
    [anon_sym_BSLASHTextcite] = ACTIONS(6226),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6226),
    [anon_sym_BSLASHsupercite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite] = ACTIONS(6226),
    [anon_sym_BSLASHAutocite] = ACTIONS(6226),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHVolcite] = ACTIONS(6226),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHavolcite] = ACTIONS(6226),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6226),
    [anon_sym_BSLASHnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHNotecite] = ACTIONS(6226),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6226),
    [anon_sym_BSLASHlabel] = ACTIONS(6226),
    [anon_sym_BSLASHref] = ACTIONS(6226),
    [anon_sym_BSLASHeqref] = ACTIONS(6226),
    [anon_sym_BSLASHvref] = ACTIONS(6226),
    [anon_sym_BSLASHVref] = ACTIONS(6226),
    [anon_sym_BSLASHautoref] = ACTIONS(6226),
    [anon_sym_BSLASHpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcref] = ACTIONS(6226),
    [anon_sym_BSLASHCref] = ACTIONS(6226),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnameCref] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6226),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6226),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6226),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6226),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6226),
    [anon_sym_BSLASHdef] = ACTIONS(6226),
    [anon_sym_BSLASHlet] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6226),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6226),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6226),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6226),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6226),
    [anon_sym_BSLASHgls] = ACTIONS(6226),
    [anon_sym_BSLASHGls] = ACTIONS(6226),
    [anon_sym_BSLASHGLS] = ACTIONS(6226),
    [anon_sym_BSLASHglspl] = ACTIONS(6226),
    [anon_sym_BSLASHGlspl] = ACTIONS(6226),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6226),
    [anon_sym_BSLASHglslink] = ACTIONS(6226),
    [anon_sym_BSLASHglstext] = ACTIONS(6226),
    [anon_sym_BSLASHGlstext] = ACTIONS(6226),
    [anon_sym_BSLASHGLStext] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6226),
    [anon_sym_BSLASHglsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6226),
    [anon_sym_BSLASHglsname] = ACTIONS(6226),
    [anon_sym_BSLASHGlsname] = ACTIONS(6226),
    [anon_sym_BSLASHGLSname] = ACTIONS(6226),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6226),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6226),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6226),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6226),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6226),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6226),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6226),
    [anon_sym_BSLASHacrshort] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6226),
    [anon_sym_BSLASHACRshort] = ACTIONS(6226),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrlong] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6226),
    [anon_sym_BSLASHACRlong] = ACTIONS(6226),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6226),
    [anon_sym_BSLASHacrfull] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6226),
    [anon_sym_BSLASHACRfull] = ACTIONS(6226),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHacs] = ACTIONS(6226),
    [anon_sym_BSLASHAcs] = ACTIONS(6226),
    [anon_sym_BSLASHacsp] = ACTIONS(6226),
    [anon_sym_BSLASHAcsp] = ACTIONS(6226),
    [anon_sym_BSLASHacl] = ACTIONS(6226),
    [anon_sym_BSLASHAcl] = ACTIONS(6226),
    [anon_sym_BSLASHaclp] = ACTIONS(6226),
    [anon_sym_BSLASHAclp] = ACTIONS(6226),
    [anon_sym_BSLASHacf] = ACTIONS(6226),
    [anon_sym_BSLASHAcf] = ACTIONS(6226),
    [anon_sym_BSLASHacfp] = ACTIONS(6226),
    [anon_sym_BSLASHAcfp] = ACTIONS(6226),
    [anon_sym_BSLASHac] = ACTIONS(6226),
    [anon_sym_BSLASHAc] = ACTIONS(6226),
    [anon_sym_BSLASHacp] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6226),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6226),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6226),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6226),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6228),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6226),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6226),
    [anon_sym_BSLASHcolor] = ACTIONS(6226),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6226),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6226),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6226),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6226),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6226),
    [anon_sym_BSLASHurl] = ACTIONS(6226),
    [anon_sym_BSLASHhref] = ACTIONS(6226),
  },
  [2066] = {
    [sym_command_name] = ACTIONS(6576),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6576),
    [anon_sym_RBRACK] = ACTIONS(6578),
    [anon_sym_COMMA] = ACTIONS(6578),
    [anon_sym_EQ] = ACTIONS(6578),
    [anon_sym_RBRACE] = ACTIONS(6578),
    [sym_word] = ACTIONS(6576),
    [sym_placeholder] = ACTIONS(6578),
    [anon_sym_PLUS] = ACTIONS(6578),
    [anon_sym_DASH] = ACTIONS(6578),
    [anon_sym_STAR] = ACTIONS(6578),
    [anon_sym_SLASH] = ACTIONS(6578),
    [anon_sym_LT] = ACTIONS(6576),
    [anon_sym_GT] = ACTIONS(6576),
    [anon_sym_BANG] = ACTIONS(6576),
    [anon_sym_PIPE] = ACTIONS(6576),
    [anon_sym_COLON] = ACTIONS(6576),
    [anon_sym_SQUOTE] = ACTIONS(6576),
    [anon_sym__] = ACTIONS(6578),
    [anon_sym_CARET] = ACTIONS(6578),
    [anon_sym_BSLASHtitle] = ACTIONS(6576),
    [anon_sym_BSLASHauthor] = ACTIONS(6576),
    [anon_sym_BSLASHusepackage] = ACTIONS(6576),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6576),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6576),
    [anon_sym_BSLASHinclude] = ACTIONS(6576),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6576),
    [anon_sym_BSLASHinput] = ACTIONS(6576),
    [anon_sym_BSLASHsubfile] = ACTIONS(6576),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6576),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6576),
    [anon_sym_BSLASHbibliography] = ACTIONS(6576),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6576),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6576),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6576),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6576),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6576),
    [anon_sym_BSLASHimport] = ACTIONS(6576),
    [anon_sym_BSLASHsubimport] = ACTIONS(6576),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6576),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6576),
    [anon_sym_BSLASHcaption] = ACTIONS(6576),
    [anon_sym_BSLASHcite] = ACTIONS(6576),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCite] = ACTIONS(6576),
    [anon_sym_BSLASHnocite] = ACTIONS(6576),
    [anon_sym_BSLASHcitet] = ACTIONS(6576),
    [anon_sym_BSLASHcitep] = ACTIONS(6576),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteA] = ACTIONS(6576),
    [anon_sym_BSLASHciteR] = ACTIONS(6576),
    [anon_sym_BSLASHciteS] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6576),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6576),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteyear] = ACTIONS(6576),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHcitedate] = ACTIONS(6576),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHciteurl] = ACTIONS(6576),
    [anon_sym_BSLASHfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6576),
    [anon_sym_BSLASHcitealt] = ACTIONS(6576),
    [anon_sym_BSLASHcitealp] = ACTIONS(6576),
    [anon_sym_BSLASHcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHparencite] = ACTIONS(6576),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHParencite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6576),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6576),
    [anon_sym_BSLASHtextcite] = ACTIONS(6576),
    [anon_sym_BSLASHTextcite] = ACTIONS(6576),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6576),
    [anon_sym_BSLASHsupercite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite] = ACTIONS(6576),
    [anon_sym_BSLASHAutocite] = ACTIONS(6576),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHVolcite] = ACTIONS(6576),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHavolcite] = ACTIONS(6576),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6576),
    [anon_sym_BSLASHnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHNotecite] = ACTIONS(6576),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6576),
    [anon_sym_BSLASHlabel] = ACTIONS(6576),
    [anon_sym_BSLASHref] = ACTIONS(6576),
    [anon_sym_BSLASHeqref] = ACTIONS(6576),
    [anon_sym_BSLASHvref] = ACTIONS(6576),
    [anon_sym_BSLASHVref] = ACTIONS(6576),
    [anon_sym_BSLASHautoref] = ACTIONS(6576),
    [anon_sym_BSLASHpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcref] = ACTIONS(6576),
    [anon_sym_BSLASHCref] = ACTIONS(6576),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnameCref] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6576),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6576),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6576),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6576),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6576),
    [anon_sym_BSLASHdef] = ACTIONS(6576),
    [anon_sym_BSLASHlet] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6576),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6576),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6576),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6576),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6576),
    [anon_sym_BSLASHgls] = ACTIONS(6576),
    [anon_sym_BSLASHGls] = ACTIONS(6576),
    [anon_sym_BSLASHGLS] = ACTIONS(6576),
    [anon_sym_BSLASHglspl] = ACTIONS(6576),
    [anon_sym_BSLASHGlspl] = ACTIONS(6576),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6576),
    [anon_sym_BSLASHglslink] = ACTIONS(6576),
    [anon_sym_BSLASHglstext] = ACTIONS(6576),
    [anon_sym_BSLASHGlstext] = ACTIONS(6576),
    [anon_sym_BSLASHGLStext] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6576),
    [anon_sym_BSLASHglsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6576),
    [anon_sym_BSLASHglsname] = ACTIONS(6576),
    [anon_sym_BSLASHGlsname] = ACTIONS(6576),
    [anon_sym_BSLASHGLSname] = ACTIONS(6576),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6576),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6576),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6576),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6576),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6576),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6576),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6576),
    [anon_sym_BSLASHacrshort] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6576),
    [anon_sym_BSLASHACRshort] = ACTIONS(6576),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrlong] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6576),
    [anon_sym_BSLASHACRlong] = ACTIONS(6576),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6576),
    [anon_sym_BSLASHacrfull] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6576),
    [anon_sym_BSLASHACRfull] = ACTIONS(6576),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHacs] = ACTIONS(6576),
    [anon_sym_BSLASHAcs] = ACTIONS(6576),
    [anon_sym_BSLASHacsp] = ACTIONS(6576),
    [anon_sym_BSLASHAcsp] = ACTIONS(6576),
    [anon_sym_BSLASHacl] = ACTIONS(6576),
    [anon_sym_BSLASHAcl] = ACTIONS(6576),
    [anon_sym_BSLASHaclp] = ACTIONS(6576),
    [anon_sym_BSLASHAclp] = ACTIONS(6576),
    [anon_sym_BSLASHacf] = ACTIONS(6576),
    [anon_sym_BSLASHAcf] = ACTIONS(6576),
    [anon_sym_BSLASHacfp] = ACTIONS(6576),
    [anon_sym_BSLASHAcfp] = ACTIONS(6576),
    [anon_sym_BSLASHac] = ACTIONS(6576),
    [anon_sym_BSLASHAc] = ACTIONS(6576),
    [anon_sym_BSLASHacp] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6576),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6576),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6576),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6576),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6578),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6576),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6576),
    [anon_sym_BSLASHcolor] = ACTIONS(6576),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6576),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6576),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6576),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6576),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6576),
    [anon_sym_BSLASHurl] = ACTIONS(6576),
    [anon_sym_BSLASHhref] = ACTIONS(6576),
  },
  [2067] = {
    [sym_command_name] = ACTIONS(6234),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6234),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_EQ] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [sym_word] = ACTIONS(6234),
    [sym_placeholder] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_DASH] = ACTIONS(6236),
    [anon_sym_STAR] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_LT] = ACTIONS(6234),
    [anon_sym_GT] = ACTIONS(6234),
    [anon_sym_BANG] = ACTIONS(6234),
    [anon_sym_PIPE] = ACTIONS(6234),
    [anon_sym_COLON] = ACTIONS(6234),
    [anon_sym_SQUOTE] = ACTIONS(6234),
    [anon_sym__] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_BSLASHtitle] = ACTIONS(6234),
    [anon_sym_BSLASHauthor] = ACTIONS(6234),
    [anon_sym_BSLASHusepackage] = ACTIONS(6234),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6234),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6234),
    [anon_sym_BSLASHinclude] = ACTIONS(6234),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6234),
    [anon_sym_BSLASHinput] = ACTIONS(6234),
    [anon_sym_BSLASHsubfile] = ACTIONS(6234),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6234),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6234),
    [anon_sym_BSLASHbibliography] = ACTIONS(6234),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6234),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6234),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6234),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6234),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6234),
    [anon_sym_BSLASHimport] = ACTIONS(6234),
    [anon_sym_BSLASHsubimport] = ACTIONS(6234),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6234),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6234),
    [anon_sym_BSLASHcaption] = ACTIONS(6234),
    [anon_sym_BSLASHcite] = ACTIONS(6234),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCite] = ACTIONS(6234),
    [anon_sym_BSLASHnocite] = ACTIONS(6234),
    [anon_sym_BSLASHcitet] = ACTIONS(6234),
    [anon_sym_BSLASHcitep] = ACTIONS(6234),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteA] = ACTIONS(6234),
    [anon_sym_BSLASHciteR] = ACTIONS(6234),
    [anon_sym_BSLASHciteS] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6234),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6234),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteyear] = ACTIONS(6234),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHcitedate] = ACTIONS(6234),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHciteurl] = ACTIONS(6234),
    [anon_sym_BSLASHfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6234),
    [anon_sym_BSLASHcitealt] = ACTIONS(6234),
    [anon_sym_BSLASHcitealp] = ACTIONS(6234),
    [anon_sym_BSLASHcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHparencite] = ACTIONS(6234),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHParencite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6234),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6234),
    [anon_sym_BSLASHtextcite] = ACTIONS(6234),
    [anon_sym_BSLASHTextcite] = ACTIONS(6234),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6234),
    [anon_sym_BSLASHsupercite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite] = ACTIONS(6234),
    [anon_sym_BSLASHAutocite] = ACTIONS(6234),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHVolcite] = ACTIONS(6234),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHavolcite] = ACTIONS(6234),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6234),
    [anon_sym_BSLASHnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHNotecite] = ACTIONS(6234),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6234),
    [anon_sym_BSLASHlabel] = ACTIONS(6234),
    [anon_sym_BSLASHref] = ACTIONS(6234),
    [anon_sym_BSLASHeqref] = ACTIONS(6234),
    [anon_sym_BSLASHvref] = ACTIONS(6234),
    [anon_sym_BSLASHVref] = ACTIONS(6234),
    [anon_sym_BSLASHautoref] = ACTIONS(6234),
    [anon_sym_BSLASHpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcref] = ACTIONS(6234),
    [anon_sym_BSLASHCref] = ACTIONS(6234),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnameCref] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6234),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6234),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6234),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6234),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6234),
    [anon_sym_BSLASHdef] = ACTIONS(6234),
    [anon_sym_BSLASHlet] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6234),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6234),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6234),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6234),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6234),
    [anon_sym_BSLASHgls] = ACTIONS(6234),
    [anon_sym_BSLASHGls] = ACTIONS(6234),
    [anon_sym_BSLASHGLS] = ACTIONS(6234),
    [anon_sym_BSLASHglspl] = ACTIONS(6234),
    [anon_sym_BSLASHGlspl] = ACTIONS(6234),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6234),
    [anon_sym_BSLASHglslink] = ACTIONS(6234),
    [anon_sym_BSLASHglstext] = ACTIONS(6234),
    [anon_sym_BSLASHGlstext] = ACTIONS(6234),
    [anon_sym_BSLASHGLStext] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6234),
    [anon_sym_BSLASHglsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6234),
    [anon_sym_BSLASHglsname] = ACTIONS(6234),
    [anon_sym_BSLASHGlsname] = ACTIONS(6234),
    [anon_sym_BSLASHGLSname] = ACTIONS(6234),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6234),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6234),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6234),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6234),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6234),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6234),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6234),
    [anon_sym_BSLASHacrshort] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6234),
    [anon_sym_BSLASHACRshort] = ACTIONS(6234),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrlong] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6234),
    [anon_sym_BSLASHACRlong] = ACTIONS(6234),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6234),
    [anon_sym_BSLASHacrfull] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6234),
    [anon_sym_BSLASHACRfull] = ACTIONS(6234),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHacs] = ACTIONS(6234),
    [anon_sym_BSLASHAcs] = ACTIONS(6234),
    [anon_sym_BSLASHacsp] = ACTIONS(6234),
    [anon_sym_BSLASHAcsp] = ACTIONS(6234),
    [anon_sym_BSLASHacl] = ACTIONS(6234),
    [anon_sym_BSLASHAcl] = ACTIONS(6234),
    [anon_sym_BSLASHaclp] = ACTIONS(6234),
    [anon_sym_BSLASHAclp] = ACTIONS(6234),
    [anon_sym_BSLASHacf] = ACTIONS(6234),
    [anon_sym_BSLASHAcf] = ACTIONS(6234),
    [anon_sym_BSLASHacfp] = ACTIONS(6234),
    [anon_sym_BSLASHAcfp] = ACTIONS(6234),
    [anon_sym_BSLASHac] = ACTIONS(6234),
    [anon_sym_BSLASHAc] = ACTIONS(6234),
    [anon_sym_BSLASHacp] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6234),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6234),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6234),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6234),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6236),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6234),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6234),
    [anon_sym_BSLASHcolor] = ACTIONS(6234),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6234),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6234),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6234),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6234),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6234),
    [anon_sym_BSLASHurl] = ACTIONS(6234),
    [anon_sym_BSLASHhref] = ACTIONS(6234),
  },
  [2068] = {
    [sym_command_name] = ACTIONS(6238),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6238),
    [anon_sym_RBRACK] = ACTIONS(6240),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_EQ] = ACTIONS(6240),
    [anon_sym_RBRACE] = ACTIONS(6240),
    [sym_word] = ACTIONS(6238),
    [sym_placeholder] = ACTIONS(6240),
    [anon_sym_PLUS] = ACTIONS(6240),
    [anon_sym_DASH] = ACTIONS(6240),
    [anon_sym_STAR] = ACTIONS(6240),
    [anon_sym_SLASH] = ACTIONS(6240),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_BANG] = ACTIONS(6238),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_COLON] = ACTIONS(6238),
    [anon_sym_SQUOTE] = ACTIONS(6238),
    [anon_sym__] = ACTIONS(6240),
    [anon_sym_CARET] = ACTIONS(6240),
    [anon_sym_BSLASHtitle] = ACTIONS(6238),
    [anon_sym_BSLASHauthor] = ACTIONS(6238),
    [anon_sym_BSLASHusepackage] = ACTIONS(6238),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6238),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6238),
    [anon_sym_BSLASHinclude] = ACTIONS(6238),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6238),
    [anon_sym_BSLASHinput] = ACTIONS(6238),
    [anon_sym_BSLASHsubfile] = ACTIONS(6238),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6238),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6238),
    [anon_sym_BSLASHbibliography] = ACTIONS(6238),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6238),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6238),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6238),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6238),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6238),
    [anon_sym_BSLASHimport] = ACTIONS(6238),
    [anon_sym_BSLASHsubimport] = ACTIONS(6238),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6238),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6238),
    [anon_sym_BSLASHcaption] = ACTIONS(6238),
    [anon_sym_BSLASHcite] = ACTIONS(6238),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCite] = ACTIONS(6238),
    [anon_sym_BSLASHnocite] = ACTIONS(6238),
    [anon_sym_BSLASHcitet] = ACTIONS(6238),
    [anon_sym_BSLASHcitep] = ACTIONS(6238),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteA] = ACTIONS(6238),
    [anon_sym_BSLASHciteR] = ACTIONS(6238),
    [anon_sym_BSLASHciteS] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6238),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6238),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteyear] = ACTIONS(6238),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHcitedate] = ACTIONS(6238),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHciteurl] = ACTIONS(6238),
    [anon_sym_BSLASHfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6238),
    [anon_sym_BSLASHcitealt] = ACTIONS(6238),
    [anon_sym_BSLASHcitealp] = ACTIONS(6238),
    [anon_sym_BSLASHcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHparencite] = ACTIONS(6238),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHParencite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6238),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6238),
    [anon_sym_BSLASHtextcite] = ACTIONS(6238),
    [anon_sym_BSLASHTextcite] = ACTIONS(6238),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6238),
    [anon_sym_BSLASHsupercite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite] = ACTIONS(6238),
    [anon_sym_BSLASHAutocite] = ACTIONS(6238),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHVolcite] = ACTIONS(6238),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHavolcite] = ACTIONS(6238),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6238),
    [anon_sym_BSLASHnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHNotecite] = ACTIONS(6238),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6238),
    [anon_sym_BSLASHlabel] = ACTIONS(6238),
    [anon_sym_BSLASHref] = ACTIONS(6238),
    [anon_sym_BSLASHeqref] = ACTIONS(6238),
    [anon_sym_BSLASHvref] = ACTIONS(6238),
    [anon_sym_BSLASHVref] = ACTIONS(6238),
    [anon_sym_BSLASHautoref] = ACTIONS(6238),
    [anon_sym_BSLASHpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcref] = ACTIONS(6238),
    [anon_sym_BSLASHCref] = ACTIONS(6238),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnameCref] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6238),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6238),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6238),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6238),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6238),
    [anon_sym_BSLASHdef] = ACTIONS(6238),
    [anon_sym_BSLASHlet] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6238),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6238),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6238),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6238),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6238),
    [anon_sym_BSLASHgls] = ACTIONS(6238),
    [anon_sym_BSLASHGls] = ACTIONS(6238),
    [anon_sym_BSLASHGLS] = ACTIONS(6238),
    [anon_sym_BSLASHglspl] = ACTIONS(6238),
    [anon_sym_BSLASHGlspl] = ACTIONS(6238),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6238),
    [anon_sym_BSLASHglslink] = ACTIONS(6238),
    [anon_sym_BSLASHglstext] = ACTIONS(6238),
    [anon_sym_BSLASHGlstext] = ACTIONS(6238),
    [anon_sym_BSLASHGLStext] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6238),
    [anon_sym_BSLASHglsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6238),
    [anon_sym_BSLASHglsname] = ACTIONS(6238),
    [anon_sym_BSLASHGlsname] = ACTIONS(6238),
    [anon_sym_BSLASHGLSname] = ACTIONS(6238),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6238),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6238),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6238),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6238),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6238),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6238),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6238),
    [anon_sym_BSLASHacrshort] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6238),
    [anon_sym_BSLASHACRshort] = ACTIONS(6238),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrlong] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6238),
    [anon_sym_BSLASHACRlong] = ACTIONS(6238),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6238),
    [anon_sym_BSLASHacrfull] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6238),
    [anon_sym_BSLASHACRfull] = ACTIONS(6238),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHacs] = ACTIONS(6238),
    [anon_sym_BSLASHAcs] = ACTIONS(6238),
    [anon_sym_BSLASHacsp] = ACTIONS(6238),
    [anon_sym_BSLASHAcsp] = ACTIONS(6238),
    [anon_sym_BSLASHacl] = ACTIONS(6238),
    [anon_sym_BSLASHAcl] = ACTIONS(6238),
    [anon_sym_BSLASHaclp] = ACTIONS(6238),
    [anon_sym_BSLASHAclp] = ACTIONS(6238),
    [anon_sym_BSLASHacf] = ACTIONS(6238),
    [anon_sym_BSLASHAcf] = ACTIONS(6238),
    [anon_sym_BSLASHacfp] = ACTIONS(6238),
    [anon_sym_BSLASHAcfp] = ACTIONS(6238),
    [anon_sym_BSLASHac] = ACTIONS(6238),
    [anon_sym_BSLASHAc] = ACTIONS(6238),
    [anon_sym_BSLASHacp] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6238),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6238),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6238),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6238),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6240),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6238),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6238),
    [anon_sym_BSLASHcolor] = ACTIONS(6238),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6238),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6238),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6238),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6238),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6238),
    [anon_sym_BSLASHurl] = ACTIONS(6238),
    [anon_sym_BSLASHhref] = ACTIONS(6238),
  },
  [2069] = {
    [sym_command_name] = ACTIONS(6242),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6242),
    [anon_sym_RBRACK] = ACTIONS(6244),
    [anon_sym_COMMA] = ACTIONS(6244),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_RBRACE] = ACTIONS(6244),
    [sym_word] = ACTIONS(6242),
    [sym_placeholder] = ACTIONS(6244),
    [anon_sym_PLUS] = ACTIONS(6244),
    [anon_sym_DASH] = ACTIONS(6244),
    [anon_sym_STAR] = ACTIONS(6244),
    [anon_sym_SLASH] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(6242),
    [anon_sym_GT] = ACTIONS(6242),
    [anon_sym_BANG] = ACTIONS(6242),
    [anon_sym_PIPE] = ACTIONS(6242),
    [anon_sym_COLON] = ACTIONS(6242),
    [anon_sym_SQUOTE] = ACTIONS(6242),
    [anon_sym__] = ACTIONS(6244),
    [anon_sym_CARET] = ACTIONS(6244),
    [anon_sym_BSLASHtitle] = ACTIONS(6242),
    [anon_sym_BSLASHauthor] = ACTIONS(6242),
    [anon_sym_BSLASHusepackage] = ACTIONS(6242),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6242),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6242),
    [anon_sym_BSLASHinclude] = ACTIONS(6242),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6242),
    [anon_sym_BSLASHinput] = ACTIONS(6242),
    [anon_sym_BSLASHsubfile] = ACTIONS(6242),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6242),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6242),
    [anon_sym_BSLASHbibliography] = ACTIONS(6242),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6242),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6242),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6242),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6242),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6242),
    [anon_sym_BSLASHimport] = ACTIONS(6242),
    [anon_sym_BSLASHsubimport] = ACTIONS(6242),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6242),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6242),
    [anon_sym_BSLASHcaption] = ACTIONS(6242),
    [anon_sym_BSLASHcite] = ACTIONS(6242),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCite] = ACTIONS(6242),
    [anon_sym_BSLASHnocite] = ACTIONS(6242),
    [anon_sym_BSLASHcitet] = ACTIONS(6242),
    [anon_sym_BSLASHcitep] = ACTIONS(6242),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteA] = ACTIONS(6242),
    [anon_sym_BSLASHciteR] = ACTIONS(6242),
    [anon_sym_BSLASHciteS] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6242),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6242),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteyear] = ACTIONS(6242),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHcitedate] = ACTIONS(6242),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHciteurl] = ACTIONS(6242),
    [anon_sym_BSLASHfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6242),
    [anon_sym_BSLASHcitealt] = ACTIONS(6242),
    [anon_sym_BSLASHcitealp] = ACTIONS(6242),
    [anon_sym_BSLASHcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHparencite] = ACTIONS(6242),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHParencite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6242),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6242),
    [anon_sym_BSLASHtextcite] = ACTIONS(6242),
    [anon_sym_BSLASHTextcite] = ACTIONS(6242),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6242),
    [anon_sym_BSLASHsupercite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite] = ACTIONS(6242),
    [anon_sym_BSLASHAutocite] = ACTIONS(6242),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHVolcite] = ACTIONS(6242),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHavolcite] = ACTIONS(6242),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6242),
    [anon_sym_BSLASHnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHNotecite] = ACTIONS(6242),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6242),
    [anon_sym_BSLASHlabel] = ACTIONS(6242),
    [anon_sym_BSLASHref] = ACTIONS(6242),
    [anon_sym_BSLASHeqref] = ACTIONS(6242),
    [anon_sym_BSLASHvref] = ACTIONS(6242),
    [anon_sym_BSLASHVref] = ACTIONS(6242),
    [anon_sym_BSLASHautoref] = ACTIONS(6242),
    [anon_sym_BSLASHpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcref] = ACTIONS(6242),
    [anon_sym_BSLASHCref] = ACTIONS(6242),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnameCref] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6242),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6242),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6242),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6242),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6242),
    [anon_sym_BSLASHdef] = ACTIONS(6242),
    [anon_sym_BSLASHlet] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6242),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6242),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6242),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6242),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6242),
    [anon_sym_BSLASHgls] = ACTIONS(6242),
    [anon_sym_BSLASHGls] = ACTIONS(6242),
    [anon_sym_BSLASHGLS] = ACTIONS(6242),
    [anon_sym_BSLASHglspl] = ACTIONS(6242),
    [anon_sym_BSLASHGlspl] = ACTIONS(6242),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6242),
    [anon_sym_BSLASHglslink] = ACTIONS(6242),
    [anon_sym_BSLASHglstext] = ACTIONS(6242),
    [anon_sym_BSLASHGlstext] = ACTIONS(6242),
    [anon_sym_BSLASHGLStext] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6242),
    [anon_sym_BSLASHglsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6242),
    [anon_sym_BSLASHglsname] = ACTIONS(6242),
    [anon_sym_BSLASHGlsname] = ACTIONS(6242),
    [anon_sym_BSLASHGLSname] = ACTIONS(6242),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6242),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6242),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6242),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6242),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6242),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6242),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6242),
    [anon_sym_BSLASHacrshort] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6242),
    [anon_sym_BSLASHACRshort] = ACTIONS(6242),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrlong] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6242),
    [anon_sym_BSLASHACRlong] = ACTIONS(6242),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6242),
    [anon_sym_BSLASHacrfull] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6242),
    [anon_sym_BSLASHACRfull] = ACTIONS(6242),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHacs] = ACTIONS(6242),
    [anon_sym_BSLASHAcs] = ACTIONS(6242),
    [anon_sym_BSLASHacsp] = ACTIONS(6242),
    [anon_sym_BSLASHAcsp] = ACTIONS(6242),
    [anon_sym_BSLASHacl] = ACTIONS(6242),
    [anon_sym_BSLASHAcl] = ACTIONS(6242),
    [anon_sym_BSLASHaclp] = ACTIONS(6242),
    [anon_sym_BSLASHAclp] = ACTIONS(6242),
    [anon_sym_BSLASHacf] = ACTIONS(6242),
    [anon_sym_BSLASHAcf] = ACTIONS(6242),
    [anon_sym_BSLASHacfp] = ACTIONS(6242),
    [anon_sym_BSLASHAcfp] = ACTIONS(6242),
    [anon_sym_BSLASHac] = ACTIONS(6242),
    [anon_sym_BSLASHAc] = ACTIONS(6242),
    [anon_sym_BSLASHacp] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6242),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6242),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6242),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6242),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6244),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6242),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6242),
    [anon_sym_BSLASHcolor] = ACTIONS(6242),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6242),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6242),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6242),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6242),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6242),
    [anon_sym_BSLASHurl] = ACTIONS(6242),
    [anon_sym_BSLASHhref] = ACTIONS(6242),
  },
  [2070] = {
    [sym_command_name] = ACTIONS(6266),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6266),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_COMMA] = ACTIONS(6268),
    [anon_sym_EQ] = ACTIONS(6268),
    [anon_sym_RBRACE] = ACTIONS(6268),
    [sym_word] = ACTIONS(6266),
    [sym_placeholder] = ACTIONS(6268),
    [anon_sym_PLUS] = ACTIONS(6268),
    [anon_sym_DASH] = ACTIONS(6268),
    [anon_sym_STAR] = ACTIONS(6268),
    [anon_sym_SLASH] = ACTIONS(6268),
    [anon_sym_LT] = ACTIONS(6266),
    [anon_sym_GT] = ACTIONS(6266),
    [anon_sym_BANG] = ACTIONS(6266),
    [anon_sym_PIPE] = ACTIONS(6266),
    [anon_sym_COLON] = ACTIONS(6266),
    [anon_sym_SQUOTE] = ACTIONS(6266),
    [anon_sym__] = ACTIONS(6268),
    [anon_sym_CARET] = ACTIONS(6268),
    [anon_sym_BSLASHtitle] = ACTIONS(6266),
    [anon_sym_BSLASHauthor] = ACTIONS(6266),
    [anon_sym_BSLASHusepackage] = ACTIONS(6266),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6266),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6266),
    [anon_sym_BSLASHinclude] = ACTIONS(6266),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6266),
    [anon_sym_BSLASHinput] = ACTIONS(6266),
    [anon_sym_BSLASHsubfile] = ACTIONS(6266),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6266),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6266),
    [anon_sym_BSLASHbibliography] = ACTIONS(6266),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6266),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6266),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6266),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6266),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6266),
    [anon_sym_BSLASHimport] = ACTIONS(6266),
    [anon_sym_BSLASHsubimport] = ACTIONS(6266),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6266),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6266),
    [anon_sym_BSLASHcaption] = ACTIONS(6266),
    [anon_sym_BSLASHcite] = ACTIONS(6266),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCite] = ACTIONS(6266),
    [anon_sym_BSLASHnocite] = ACTIONS(6266),
    [anon_sym_BSLASHcitet] = ACTIONS(6266),
    [anon_sym_BSLASHcitep] = ACTIONS(6266),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteA] = ACTIONS(6266),
    [anon_sym_BSLASHciteR] = ACTIONS(6266),
    [anon_sym_BSLASHciteS] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6266),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6266),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteyear] = ACTIONS(6266),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHcitedate] = ACTIONS(6266),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHciteurl] = ACTIONS(6266),
    [anon_sym_BSLASHfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6266),
    [anon_sym_BSLASHcitealt] = ACTIONS(6266),
    [anon_sym_BSLASHcitealp] = ACTIONS(6266),
    [anon_sym_BSLASHcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHparencite] = ACTIONS(6266),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHParencite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6266),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6266),
    [anon_sym_BSLASHtextcite] = ACTIONS(6266),
    [anon_sym_BSLASHTextcite] = ACTIONS(6266),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6266),
    [anon_sym_BSLASHsupercite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite] = ACTIONS(6266),
    [anon_sym_BSLASHAutocite] = ACTIONS(6266),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHVolcite] = ACTIONS(6266),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHavolcite] = ACTIONS(6266),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6266),
    [anon_sym_BSLASHnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHNotecite] = ACTIONS(6266),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6266),
    [anon_sym_BSLASHlabel] = ACTIONS(6266),
    [anon_sym_BSLASHref] = ACTIONS(6266),
    [anon_sym_BSLASHeqref] = ACTIONS(6266),
    [anon_sym_BSLASHvref] = ACTIONS(6266),
    [anon_sym_BSLASHVref] = ACTIONS(6266),
    [anon_sym_BSLASHautoref] = ACTIONS(6266),
    [anon_sym_BSLASHpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcref] = ACTIONS(6266),
    [anon_sym_BSLASHCref] = ACTIONS(6266),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnameCref] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6266),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6266),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6266),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6266),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6266),
    [anon_sym_BSLASHdef] = ACTIONS(6266),
    [anon_sym_BSLASHlet] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6266),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6266),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6266),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6266),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6266),
    [anon_sym_BSLASHgls] = ACTIONS(6266),
    [anon_sym_BSLASHGls] = ACTIONS(6266),
    [anon_sym_BSLASHGLS] = ACTIONS(6266),
    [anon_sym_BSLASHglspl] = ACTIONS(6266),
    [anon_sym_BSLASHGlspl] = ACTIONS(6266),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6266),
    [anon_sym_BSLASHglslink] = ACTIONS(6266),
    [anon_sym_BSLASHglstext] = ACTIONS(6266),
    [anon_sym_BSLASHGlstext] = ACTIONS(6266),
    [anon_sym_BSLASHGLStext] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6266),
    [anon_sym_BSLASHglsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6266),
    [anon_sym_BSLASHglsname] = ACTIONS(6266),
    [anon_sym_BSLASHGlsname] = ACTIONS(6266),
    [anon_sym_BSLASHGLSname] = ACTIONS(6266),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6266),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6266),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6266),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6266),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6266),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6266),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6266),
    [anon_sym_BSLASHacrshort] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6266),
    [anon_sym_BSLASHACRshort] = ACTIONS(6266),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrlong] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6266),
    [anon_sym_BSLASHACRlong] = ACTIONS(6266),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6266),
    [anon_sym_BSLASHacrfull] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6266),
    [anon_sym_BSLASHACRfull] = ACTIONS(6266),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHacs] = ACTIONS(6266),
    [anon_sym_BSLASHAcs] = ACTIONS(6266),
    [anon_sym_BSLASHacsp] = ACTIONS(6266),
    [anon_sym_BSLASHAcsp] = ACTIONS(6266),
    [anon_sym_BSLASHacl] = ACTIONS(6266),
    [anon_sym_BSLASHAcl] = ACTIONS(6266),
    [anon_sym_BSLASHaclp] = ACTIONS(6266),
    [anon_sym_BSLASHAclp] = ACTIONS(6266),
    [anon_sym_BSLASHacf] = ACTIONS(6266),
    [anon_sym_BSLASHAcf] = ACTIONS(6266),
    [anon_sym_BSLASHacfp] = ACTIONS(6266),
    [anon_sym_BSLASHAcfp] = ACTIONS(6266),
    [anon_sym_BSLASHac] = ACTIONS(6266),
    [anon_sym_BSLASHAc] = ACTIONS(6266),
    [anon_sym_BSLASHacp] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6266),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6266),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6266),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6266),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6268),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6266),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6266),
    [anon_sym_BSLASHcolor] = ACTIONS(6266),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6266),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6266),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6266),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6266),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6266),
    [anon_sym_BSLASHurl] = ACTIONS(6266),
    [anon_sym_BSLASHhref] = ACTIONS(6266),
  },
  [2071] = {
    [sym_command_name] = ACTIONS(6250),
    [sym__whitespace] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_BSLASHiffalse] = ACTIONS(6250),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_EQ] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [sym_word] = ACTIONS(6250),
    [sym_placeholder] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_DASH] = ACTIONS(6252),
    [anon_sym_STAR] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_LT] = ACTIONS(6250),
    [anon_sym_GT] = ACTIONS(6250),
    [anon_sym_BANG] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6250),
    [anon_sym_COLON] = ACTIONS(6250),
    [anon_sym_SQUOTE] = ACTIONS(6250),
    [anon_sym__] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_BSLASHtitle] = ACTIONS(6250),
    [anon_sym_BSLASHauthor] = ACTIONS(6250),
    [anon_sym_BSLASHusepackage] = ACTIONS(6250),
    [anon_sym_BSLASHRequirePackage] = ACTIONS(6250),
    [anon_sym_BSLASHdocumentclass] = ACTIONS(6250),
    [anon_sym_BSLASHinclude] = ACTIONS(6250),
    [anon_sym_BSLASHsubfileinclude] = ACTIONS(6250),
    [anon_sym_BSLASHinput] = ACTIONS(6250),
    [anon_sym_BSLASHsubfile] = ACTIONS(6250),
    [anon_sym_BSLASHaddbibresource] = ACTIONS(6250),
    [anon_sym_BSLASHbibliographystyle] = ACTIONS(6250),
    [anon_sym_BSLASHbibliography] = ACTIONS(6250),
    [anon_sym_BSLASHincludegraphics] = ACTIONS(6250),
    [anon_sym_BSLASHincludesvg] = ACTIONS(6250),
    [anon_sym_BSLASHincludeinkscape] = ACTIONS(6250),
    [anon_sym_BSLASHverbatiminput] = ACTIONS(6250),
    [anon_sym_BSLASHVerbatimInput] = ACTIONS(6250),
    [anon_sym_BSLASHimport] = ACTIONS(6250),
    [anon_sym_BSLASHsubimport] = ACTIONS(6250),
    [anon_sym_BSLASHinputfrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubimportfrom] = ACTIONS(6250),
    [anon_sym_BSLASHincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHsubincludefrom] = ACTIONS(6250),
    [anon_sym_BSLASHcaption] = ACTIONS(6250),
    [anon_sym_BSLASHcite] = ACTIONS(6250),
    [anon_sym_BSLASHcite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCite] = ACTIONS(6250),
    [anon_sym_BSLASHnocite] = ACTIONS(6250),
    [anon_sym_BSLASHcitet] = ACTIONS(6250),
    [anon_sym_BSLASHcitep] = ACTIONS(6250),
    [anon_sym_BSLASHcitet_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitep_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteA] = ACTIONS(6250),
    [anon_sym_BSLASHciteR] = ACTIONS(6250),
    [anon_sym_BSLASHciteS] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearR] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHciteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCiteauthor] = ACTIONS(6250),
    [anon_sym_BSLASHCiteauthor_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitetitle] = ACTIONS(6250),
    [anon_sym_BSLASHcitetitle_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteyear] = ACTIONS(6250),
    [anon_sym_BSLASHciteyear_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHcitedate] = ACTIONS(6250),
    [anon_sym_BSLASHcitedate_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHciteurl] = ACTIONS(6250),
    [anon_sym_BSLASHfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHciteyearpar] = ACTIONS(6250),
    [anon_sym_BSLASHcitealt] = ACTIONS(6250),
    [anon_sym_BSLASHcitealp] = ACTIONS(6250),
    [anon_sym_BSLASHcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHparencite] = ACTIONS(6250),
    [anon_sym_BSLASHparencite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHParencite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootfullcite] = ACTIONS(6250),
    [anon_sym_BSLASHfootcitetext] = ACTIONS(6250),
    [anon_sym_BSLASHtextcite] = ACTIONS(6250),
    [anon_sym_BSLASHTextcite] = ACTIONS(6250),
    [anon_sym_BSLASHsmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHSmartcite] = ACTIONS(6250),
    [anon_sym_BSLASHsupercite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite] = ACTIONS(6250),
    [anon_sym_BSLASHAutocite] = ACTIONS(6250),
    [anon_sym_BSLASHautocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHAutocite_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHVolcite] = ACTIONS(6250),
    [anon_sym_BSLASHpvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHPvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHfvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHftvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHsvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHSvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHtvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHTvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHavolcite] = ACTIONS(6250),
    [anon_sym_BSLASHAvolcite] = ACTIONS(6250),
    [anon_sym_BSLASHnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHNotecite] = ACTIONS(6250),
    [anon_sym_BSLASHpnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHPnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHfnotecite] = ACTIONS(6250),
    [anon_sym_BSLASHlabel] = ACTIONS(6250),
    [anon_sym_BSLASHref] = ACTIONS(6250),
    [anon_sym_BSLASHeqref] = ACTIONS(6250),
    [anon_sym_BSLASHvref] = ACTIONS(6250),
    [anon_sym_BSLASHVref] = ACTIONS(6250),
    [anon_sym_BSLASHautoref] = ACTIONS(6250),
    [anon_sym_BSLASHpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcref] = ACTIONS(6250),
    [anon_sym_BSLASHCref] = ACTIONS(6250),
    [anon_sym_BSLASHcref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCref_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnameCref] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecref] = ACTIONS(6250),
    [anon_sym_BSLASHnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHnameCrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlcnamecrefs] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcref] = ACTIONS(6250),
    [anon_sym_BSLASHlabelcpageref] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHcrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHCrefrange] = ACTIONS(6250),
    [anon_sym_BSLASHCrefrange_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHnewlabel] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHnewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHrenewcommand] = ACTIONS(6250),
    [anon_sym_BSLASHrenewcommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareRobustCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareRobustCommand_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHDeclareMathOperator] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareMathOperator_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHNewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHNewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHRenewExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHProvideExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareExpandableDocumentCommand] = ACTIONS(6250),
    [anon_sym_BSLASHdef] = ACTIONS(6250),
    [anon_sym_BSLASHlet] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiter] = ACTIONS(6250),
    [anon_sym_BSLASHDeclarePairedDelimiterX] = ACTIONS(6250),
    [anon_sym_BSLASHnewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHrenewenvironment] = ACTIONS(6250),
    [anon_sym_BSLASHNewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHRenewDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHProvideDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHDeclareDocumentEnvironment] = ACTIONS(6250),
    [anon_sym_BSLASHnewglossaryentry] = ACTIONS(6250),
    [anon_sym_BSLASHgls] = ACTIONS(6250),
    [anon_sym_BSLASHGls] = ACTIONS(6250),
    [anon_sym_BSLASHGLS] = ACTIONS(6250),
    [anon_sym_BSLASHglspl] = ACTIONS(6250),
    [anon_sym_BSLASHGlspl] = ACTIONS(6250),
    [anon_sym_BSLASHGLSpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsdisp] = ACTIONS(6250),
    [anon_sym_BSLASHglslink] = ACTIONS(6250),
    [anon_sym_BSLASHglstext] = ACTIONS(6250),
    [anon_sym_BSLASHGlstext] = ACTIONS(6250),
    [anon_sym_BSLASHGLStext] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirst] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirst] = ACTIONS(6250),
    [anon_sym_BSLASHglsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGlsfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHGLSfirstplural] = ACTIONS(6250),
    [anon_sym_BSLASHglsname] = ACTIONS(6250),
    [anon_sym_BSLASHGlsname] = ACTIONS(6250),
    [anon_sym_BSLASHGLSname] = ACTIONS(6250),
    [anon_sym_BSLASHglssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHGlssymbol] = ACTIONS(6250),
    [anon_sym_BSLASHglsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGlsdesc] = ACTIONS(6250),
    [anon_sym_BSLASHGLSdesc] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseri] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseri] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriii] = ACTIONS(6250),
    [anon_sym_BSLASHglsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuseriv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuserv] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuserv] = ACTIONS(6250),
    [anon_sym_BSLASHglsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGlsuservi] = ACTIONS(6250),
    [anon_sym_BSLASHGLSuservi] = ACTIONS(6250),
    [anon_sym_BSLASHnewacronym] = ACTIONS(6250),
    [anon_sym_BSLASHacrshort] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshort] = ACTIONS(6250),
    [anon_sym_BSLASHACRshort] = ACTIONS(6250),
    [anon_sym_BSLASHacrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrlong] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlong] = ACTIONS(6250),
    [anon_sym_BSLASHACRlong] = ACTIONS(6250),
    [anon_sym_BSLASHacrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRlongpl] = ACTIONS(6250),
    [anon_sym_BSLASHacrfull] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfull] = ACTIONS(6250),
    [anon_sym_BSLASHACRfull] = ACTIONS(6250),
    [anon_sym_BSLASHacrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHAcrfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHACRfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHacs] = ACTIONS(6250),
    [anon_sym_BSLASHAcs] = ACTIONS(6250),
    [anon_sym_BSLASHacsp] = ACTIONS(6250),
    [anon_sym_BSLASHAcsp] = ACTIONS(6250),
    [anon_sym_BSLASHacl] = ACTIONS(6250),
    [anon_sym_BSLASHAcl] = ACTIONS(6250),
    [anon_sym_BSLASHaclp] = ACTIONS(6250),
    [anon_sym_BSLASHAclp] = ACTIONS(6250),
    [anon_sym_BSLASHacf] = ACTIONS(6250),
    [anon_sym_BSLASHAcf] = ACTIONS(6250),
    [anon_sym_BSLASHacfp] = ACTIONS(6250),
    [anon_sym_BSLASHAcfp] = ACTIONS(6250),
    [anon_sym_BSLASHac] = ACTIONS(6250),
    [anon_sym_BSLASHAc] = ACTIONS(6250),
    [anon_sym_BSLASHacp] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylong] = ACTIONS(6250),
    [anon_sym_BSLASHglsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentrylongpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshort] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryshortpl] = ACTIONS(6250),
    [anon_sym_BSLASHglsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHGlsentryfullpl] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem] = ACTIONS(6250),
    [anon_sym_BSLASHnewtheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdeclaretheorem] = ACTIONS(6250),
    [anon_sym_BSLASHdeclaretheorem_STAR] = ACTIONS(6252),
    [anon_sym_BSLASHdefinecolor] = ACTIONS(6250),
    [anon_sym_BSLASHdefinecolorset] = ACTIONS(6250),
    [anon_sym_BSLASHcolor] = ACTIONS(6250),
    [anon_sym_BSLASHcolorbox] = ACTIONS(6250),
    [anon_sym_BSLASHtextcolor] = ACTIONS(6250),
    [anon_sym_BSLASHpagecolor] = ACTIONS(6250),
    [anon_sym_BSLASHusepgflibrary] = ACTIONS(6250),
    [anon_sym_BSLASHusetikzlibrary] = ACTIONS(6250),
    [anon_sym_BSLASHurl] = ACTIONS(6250),
    [anon_sym_BSLASHhref] = ACTIONS(6250),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 4,
    STATE(3349), 1,
      sym__math_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(4442), 10,
      anon_sym_displaymath,
      anon_sym_equation,
      anon_sym_multline,
      anon_sym_eqnarray,
      anon_sym_align,
      anon_sym_array,
      anon_sym_split,
      anon_sym_alignat,
      anon_sym_gather,
      anon_sym_flalign,
    ACTIONS(4444), 11,
      anon_sym_math,
      anon_sym_displaymath_STAR,
      anon_sym_equation_STAR,
      anon_sym_multline_STAR,
      anon_sym_eqnarray_STAR,
      anon_sym_align_STAR,
      anon_sym_array_STAR,
      anon_sym_split_STAR,
      anon_sym_alignat_STAR,
      anon_sym_gather_STAR,
      anon_sym_flalign_STAR,
  [33] = 4,
    STATE(3444), 1,
      sym__math_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(4442), 10,
      anon_sym_displaymath,
      anon_sym_equation,
      anon_sym_multline,
      anon_sym_eqnarray,
      anon_sym_align,
      anon_sym_array,
      anon_sym_split,
      anon_sym_alignat,
      anon_sym_gather,
      anon_sym_flalign,
    ACTIONS(4444), 11,
      anon_sym_math,
      anon_sym_displaymath_STAR,
      anon_sym_equation_STAR,
      anon_sym_multline_STAR,
      anon_sym_eqnarray_STAR,
      anon_sym_align_STAR,
      anon_sym_array_STAR,
      anon_sym_split_STAR,
      anon_sym_alignat_STAR,
      anon_sym_gather_STAR,
      anon_sym_flalign_STAR,
  [66] = 4,
    STATE(3457), 1,
      sym__math_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(4442), 10,
      anon_sym_displaymath,
      anon_sym_equation,
      anon_sym_multline,
      anon_sym_eqnarray,
      anon_sym_align,
      anon_sym_array,
      anon_sym_split,
      anon_sym_alignat,
      anon_sym_gather,
      anon_sym_flalign,
    ACTIONS(4444), 11,
      anon_sym_math,
      anon_sym_displaymath_STAR,
      anon_sym_equation_STAR,
      anon_sym_multline_STAR,
      anon_sym_eqnarray_STAR,
      anon_sym_align_STAR,
      anon_sym_array_STAR,
      anon_sym_split_STAR,
      anon_sym_alignat_STAR,
      anon_sym_gather_STAR,
      anon_sym_flalign_STAR,
  [99] = 4,
    STATE(3376), 1,
      sym__math_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(4442), 10,
      anon_sym_displaymath,
      anon_sym_equation,
      anon_sym_multline,
      anon_sym_eqnarray,
      anon_sym_align,
      anon_sym_array,
      anon_sym_split,
      anon_sym_alignat,
      anon_sym_gather,
      anon_sym_flalign,
    ACTIONS(4444), 11,
      anon_sym_math,
      anon_sym_displaymath_STAR,
      anon_sym_equation_STAR,
      anon_sym_multline_STAR,
      anon_sym_eqnarray_STAR,
      anon_sym_align_STAR,
      anon_sym_array_STAR,
      anon_sym_split_STAR,
      anon_sym_alignat_STAR,
      anon_sym_gather_STAR,
      anon_sym_flalign_STAR,
  [132] = 4,
    STATE(3423), 1,
      sym__math_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(4442), 10,
      anon_sym_displaymath,
      anon_sym_equation,
      anon_sym_multline,
      anon_sym_eqnarray,
      anon_sym_align,
      anon_sym_array,
      anon_sym_split,
      anon_sym_alignat,
      anon_sym_gather,
      anon_sym_flalign,
    ACTIONS(4444), 11,
      anon_sym_math,
      anon_sym_displaymath_STAR,
      anon_sym_equation_STAR,
      anon_sym_multline_STAR,
      anon_sym_eqnarray_STAR,
      anon_sym_align_STAR,
      anon_sym_array_STAR,
      anon_sym_split_STAR,
      anon_sym_alignat_STAR,
      anon_sym_gather_STAR,
      anon_sym_flalign_STAR,
  [165] = 4,
    STATE(3391), 1,
      sym__math_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(4442), 10,
      anon_sym_displaymath,
      anon_sym_equation,
      anon_sym_multline,
      anon_sym_eqnarray,
      anon_sym_align,
      anon_sym_array,
      anon_sym_split,
      anon_sym_alignat,
      anon_sym_gather,
      anon_sym_flalign,
    ACTIONS(4444), 11,
      anon_sym_math,
      anon_sym_displaymath_STAR,
      anon_sym_equation_STAR,
      anon_sym_multline_STAR,
      anon_sym_eqnarray_STAR,
      anon_sym_align_STAR,
      anon_sym_array_STAR,
      anon_sym_split_STAR,
      anon_sym_alignat_STAR,
      anon_sym_gather_STAR,
      anon_sym_flalign_STAR,
  [198] = 4,
    STATE(3267), 1,
      sym__math_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(4442), 10,
      anon_sym_displaymath,
      anon_sym_equation,
      anon_sym_multline,
      anon_sym_eqnarray,
      anon_sym_align,
      anon_sym_array,
      anon_sym_split,
      anon_sym_alignat,
      anon_sym_gather,
      anon_sym_flalign,
    ACTIONS(4444), 11,
      anon_sym_math,
      anon_sym_displaymath_STAR,
      anon_sym_equation_STAR,
      anon_sym_multline_STAR,
      anon_sym_eqnarray_STAR,
      anon_sym_align_STAR,
      anon_sym_array_STAR,
      anon_sym_split_STAR,
      anon_sym_alignat_STAR,
      anon_sym_gather_STAR,
      anon_sym_flalign_STAR,
  [231] = 11,
    ACTIONS(7182), 1,
      anon_sym_LBRACE,
    STATE(973), 1,
      sym_curly_group_text,
    STATE(1624), 1,
      sym__math_environment_group,
    STATE(2316), 1,
      sym__minted_environment_group,
    STATE(3362), 1,
      sym__comment_environment_group,
    STATE(3373), 1,
      sym__verbatim_environment_group,
    STATE(3374), 1,
      sym__listing_environment_group,
    STATE(3375), 1,
      sym__pycode_environment_group,
    STATE(3379), 1,
      sym__sagesilent_environment_group,
    STATE(3412), 1,
      sym__sageblock_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [266] = 4,
    STATE(13), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7186), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7184), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [285] = 4,
    STATE(440), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7190), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7188), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [304] = 4,
    STATE(1944), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7194), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7192), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [323] = 4,
    STATE(1140), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7198), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7196), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [342] = 4,
    STATE(11), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7202), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7200), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [361] = 4,
    STATE(1184), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7206), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7204), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [380] = 4,
    STATE(1644), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7210), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7208), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [399] = 4,
    STATE(1608), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7214), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7212), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [418] = 4,
    STATE(1216), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7218), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7216), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [437] = 4,
    STATE(604), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7222), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7220), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [456] = 4,
    STATE(1277), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7226), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7224), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [475] = 4,
    STATE(10), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7230), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7228), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [494] = 4,
    STATE(24), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7234), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7232), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [513] = 4,
    STATE(1810), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7238), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7236), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [532] = 4,
    STATE(1443), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7242), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7240), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [551] = 4,
    STATE(1028), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7246), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7244), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [570] = 4,
    STATE(1808), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7250), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7248), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [589] = 4,
    STATE(22), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7254), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7252), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [608] = 4,
    STATE(1792), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7258), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7256), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [627] = 4,
    STATE(9), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7262), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7260), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [646] = 4,
    STATE(1199), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7266), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7264), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [665] = 4,
    STATE(1000), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7270), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7268), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [684] = 4,
    STATE(1711), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7274), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7272), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [703] = 4,
    STATE(6), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7278), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7276), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [722] = 4,
    STATE(15), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7282), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7280), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [741] = 4,
    STATE(20), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7286), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7284), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [760] = 4,
    STATE(1941), 1,
      sym__math_delimiter_part,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7290), 2,
      sym_word,
      anon_sym_PIPE,
    ACTIONS(7288), 5,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_command_name,
  [779] = 6,
    ACTIONS(7292), 1,
      sym_command_name,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2454), 1,
      sym_curly_group_impl,
    STATE(2460), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [799] = 6,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7298), 1,
      sym_command_name,
    STATE(2398), 1,
      sym_curly_group_impl,
    STATE(2466), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [819] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3388), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [837] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3322), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [855] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3354), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [873] = 6,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7306), 1,
      sym_command_name,
    STATE(2451), 1,
      sym_curly_group_impl,
    STATE(2452), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [893] = 6,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7308), 1,
      sym_command_name,
    STATE(2437), 1,
      sym_curly_group_impl,
    STATE(2464), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [913] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3316), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [931] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3420), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [949] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3269), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [967] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3360), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [985] = 6,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7310), 1,
      sym_command_name,
    STATE(2375), 1,
      sym_curly_group_impl,
    STATE(2459), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1005] = 6,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7312), 1,
      sym_command_name,
    STATE(2426), 1,
      sym_curly_group_impl,
    STATE(2461), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1025] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3454), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [1043] = 6,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7314), 1,
      sym_command_name,
    STATE(2388), 1,
      sym_curly_group_impl,
    STATE(2465), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1063] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3307), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [1081] = 6,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7316), 1,
      sym_command_name,
    STATE(2359), 1,
      sym_curly_group_impl,
    STATE(2407), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1101] = 6,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7318), 1,
      sym_command_name,
    STATE(2415), 1,
      sym_curly_group_impl,
    STATE(2457), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1121] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7304), 1,
      aux_sym__glob_pattern_fragment_token1,
    STATE(3447), 1,
      sym_glob_pattern,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2126), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [1139] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7320), 1,
      anon_sym_RBRACE,
    ACTIONS(7322), 1,
      aux_sym__glob_pattern_fragment_token1,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2130), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [1157] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7324), 1,
      anon_sym_RBRACE,
    ACTIONS(7326), 1,
      aux_sym__glob_pattern_fragment_token1,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2128), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [1175] = 5,
    ACTIONS(7302), 1,
      anon_sym_LBRACE,
    ACTIONS(7322), 1,
      aux_sym__glob_pattern_fragment_token1,
    ACTIONS(7328), 1,
      anon_sym_RBRACE,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2130), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [1193] = 6,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7330), 1,
      sym_command_name,
    STATE(2374), 1,
      sym_curly_group_impl,
    STATE(2458), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1213] = 5,
    ACTIONS(7332), 1,
      anon_sym_LBRACE,
    ACTIONS(7335), 1,
      anon_sym_RBRACE,
    ACTIONS(7337), 1,
      aux_sym__glob_pattern_fragment_token1,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    STATE(2130), 2,
      sym__glob_pattern_fragment,
      aux_sym_glob_pattern_repeat1,
  [1231] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2879), 1,
      sym_curly_group_impl,
    STATE(3146), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1248] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_LBRACE,
    STATE(865), 1,
      sym_curly_group_text_list,
    STATE(2878), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1265] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7344), 1,
      anon_sym_LBRACE,
    STATE(1555), 1,
      sym_curly_group_text_list,
    STATE(2539), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1282] = 5,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(960), 1,
      sym_curly_group,
    STATE(2797), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1299] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2779), 1,
      sym_curly_group_impl,
    STATE(3093), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1316] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2829), 1,
      sym_brack_group_text,
    STATE(3102), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1333] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7348), 1,
      anon_sym_LBRACE,
    STATE(903), 1,
      sym_curly_group_author_list,
    STATE(2780), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1350] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1291), 1,
      sym_curly_group_path,
    STATE(3127), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1367] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1292), 1,
      sym_curly_group_path,
    STATE(3128), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1384] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1293), 1,
      sym_curly_group_path,
    STATE(3129), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1401] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2830), 1,
      sym_brack_group_key_value,
    STATE(3101), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1418] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2477), 1,
      sym_brack_group_text,
    STATE(2550), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1435] = 5,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1296), 1,
      sym_curly_group,
    STATE(3150), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1452] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_LBRACE,
    STATE(1372), 1,
      sym_curly_group_text_list,
    STATE(3134), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1469] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7356), 1,
      anon_sym_LBRACE,
    STATE(896), 1,
      sym_curly_group_path_list,
    STATE(2768), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1486] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2662), 1,
      sym_curly_group_impl,
    STATE(3166), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1503] = 5,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(1411), 1,
      sym_curly_group,
    STATE(2182), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1520] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_LBRACE,
    STATE(1297), 1,
      sym_curly_group_text_list,
    STATE(2144), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1537] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(997), 1,
      sym_curly_group_path,
    STATE(2748), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1554] = 5,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    ACTIONS(7360), 1,
      sym_command_name,
    ACTIONS(7362), 1,
      sym_letter,
    STATE(1279), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1571] = 5,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    ACTIONS(7364), 1,
      sym_command_name,
    ACTIONS(7366), 1,
      sym_letter,
    STATE(1057), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1588] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7344), 1,
      anon_sym_LBRACE,
    STATE(1494), 1,
      sym_curly_group_text_list,
    STATE(2512), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1605] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7368), 1,
      anon_sym_LBRACE,
    STATE(1302), 1,
      sym_curly_group_text,
    STATE(3174), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1622] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(1532), 1,
      sym_curly_group_text,
    STATE(2511), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1639] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2545), 1,
      sym_curly_group_impl,
    STATE(3220), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1656] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7368), 1,
      anon_sym_LBRACE,
    STATE(1317), 1,
      sym_curly_group_text,
    STATE(3176), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1673] = 5,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(7372), 1,
      sym_command_name,
    ACTIONS(7374), 1,
      sym_letter,
    STATE(918), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1690] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7354), 1,
      anon_sym_LBRACE,
    STATE(881), 1,
      sym_curly_group_text_list,
    STATE(3180), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1707] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2468), 1,
      sym_curly_group_impl,
    STATE(2904), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1724] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(1531), 1,
      sym_curly_group_text,
    STATE(2510), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1741] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7344), 1,
      anon_sym_LBRACE,
    STATE(1527), 1,
      sym_curly_group_text_list,
    STATE(2133), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1758] = 5,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1526), 1,
      sym_curly_group,
    STATE(2502), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1775] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2579), 1,
      sym_curly_group_impl,
    STATE(3183), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1792] = 5,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1283), 1,
      sym_curly_group,
    STATE(3010), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1809] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1524), 1,
      sym_curly_group_path,
    STATE(2500), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1826] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7378), 1,
      anon_sym_LBRACE,
    STATE(1284), 1,
      sym_curly_group_author_list,
    STATE(3041), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1843] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1523), 1,
      sym_curly_group_path,
    STATE(2499), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1860] = 5,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(7380), 1,
      sym_command_name,
    ACTIONS(7382), 1,
      sym_letter,
    STATE(917), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1877] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2881), 1,
      sym_curly_group_impl,
    STATE(2960), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1894] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1522), 1,
      sym_curly_group_path,
    STATE(2498), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1911] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(1019), 1,
      sym_curly_group_path,
    STATE(2723), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1928] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7384), 1,
      anon_sym_LBRACE,
    STATE(1285), 1,
      sym_curly_group_path_list,
    STATE(3095), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1945] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1286), 1,
      sym_curly_group_path,
    STATE(3110), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1962] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(900), 1,
      sym_curly_group_path,
    STATE(2722), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1979] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7386), 1,
      anon_sym_LBRACE,
    STATE(1519), 1,
      sym_curly_group_glob_pattern,
    STATE(2497), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [1996] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1583), 1,
      sym_curly_group_path,
    STATE(2496), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2013] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7388), 1,
      anon_sym_LBRACE,
    STATE(1573), 1,
      sym_curly_group_path_list,
    STATE(2495), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2030] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7390), 1,
      anon_sym_LBRACE,
    STATE(1288), 1,
      sym_curly_group_glob_pattern,
    STATE(3125), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2047] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7392), 1,
      anon_sym_LBRACE,
    STATE(1579), 1,
      sym_curly_group_author_list,
    STATE(2493), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2064] = 5,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1581), 1,
      sym_curly_group,
    STATE(2491), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2081] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(893), 1,
      sym_curly_group_path,
    STATE(2691), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2098] = 5,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1441), 1,
      sym_curly_group,
    STATE(3064), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2115] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2758), 1,
      sym_brack_group_key_value,
    STATE(3215), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2132] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2771), 1,
      sym_brack_group_key_value,
    STATE(3141), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2149] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2770), 1,
      sym_brack_group_text,
    STATE(3142), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2166] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2504), 1,
      sym_brack_group_text,
    STATE(2591), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2183] = 5,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    ACTIONS(7394), 1,
      sym_command_name,
    ACTIONS(7396), 1,
      sym_letter,
    STATE(1609), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2200] = 5,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(998), 1,
      sym_curly_group,
    STATE(2695), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2217] = 5,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1034), 1,
      sym_curly_group,
    STATE(2715), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2234] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(3105), 1,
      sym_curly_group_impl,
    STATE(3106), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2251] = 5,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(1558), 1,
      sym_curly_group,
    STATE(2198), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2268] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(1033), 1,
      sym_curly_group_text_list,
    STATE(2200), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2285] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2764), 1,
      sym_brack_group_key_value,
    STATE(3178), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2302] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2763), 1,
      sym_brack_group_text,
    STATE(3179), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2319] = 5,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    ACTIONS(7398), 1,
      sym_command_name,
    ACTIONS(7400), 1,
      sym_letter,
    STATE(1615), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2336] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2564), 1,
      sym_brack_group_text,
    STATE(2870), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2353] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7402), 1,
      anon_sym_LBRACE,
    STATE(980), 1,
      sym_curly_group_glob_pattern,
    STATE(2724), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2370] = 5,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1605), 1,
      sym_curly_group,
    STATE(2561), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2387] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2525), 1,
      sym_brack_group_text,
    STATE(2620), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2404] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(961), 1,
      sym_curly_group_text_list,
    STATE(3032), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2421] = 5,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    ACTIONS(7404), 1,
      sym_command_name,
    ACTIONS(7406), 1,
      sym_letter,
    STATE(1659), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2438] = 5,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    ACTIONS(7408), 1,
      sym_command_name,
    ACTIONS(7410), 1,
      sym_letter,
    STATE(1662), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2455] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1687), 1,
      sym_curly_group,
    STATE(2608), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2472] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7412), 1,
      anon_sym_LBRACE,
    STATE(1686), 1,
      sym_curly_group_author_list,
    STATE(2610), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2489] = 5,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1182), 1,
      sym_curly_group,
    STATE(2540), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2506] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2757), 1,
      sym_brack_group_text,
    STATE(3216), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2523] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    STATE(1854), 1,
      sym_curly_group_path_list,
    STATE(2612), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2540] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1850), 1,
      sym_curly_group_path,
    STATE(2613), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2557] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7418), 1,
      anon_sym_LBRACE,
    STATE(1819), 1,
      sym_curly_group_glob_pattern,
    STATE(2614), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2574] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1759), 1,
      sym_curly_group_path,
    STATE(2615), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2591] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1771), 1,
      sym_curly_group_path,
    STATE(2616), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2608] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1803), 1,
      sym_curly_group_path,
    STATE(2617), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2625] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1689), 1,
      sym_curly_group,
    STATE(3062), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2642] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1852), 1,
      sym_curly_group,
    STATE(2619), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2659] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2868), 1,
      sym_brack_group_argc,
    STATE(3053), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2676] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_LBRACE,
    STATE(1866), 1,
      sym_curly_group_text_list,
    STATE(2261), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2693] = 5,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(1726), 1,
      sym_curly_group,
    STATE(2213), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2710] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7422), 1,
      anon_sym_LBRACE,
    STATE(1729), 1,
      sym_curly_group_text_list,
    STATE(3048), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2727] = 5,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    ACTIONS(7424), 1,
      sym_command_name,
    ACTIONS(7426), 1,
      sym_letter,
    STATE(1379), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2744] = 5,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    ACTIONS(7428), 1,
      sym_command_name,
    ACTIONS(7430), 1,
      sym_letter,
    STATE(1378), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2761] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7432), 1,
      anon_sym_LBRACE,
    STATE(1862), 1,
      sym_curly_group_text,
    STATE(2627), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2778] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7432), 1,
      anon_sym_LBRACE,
    STATE(1860), 1,
      sym_curly_group_text,
    STATE(2628), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2795] = 5,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1275), 1,
      sym_curly_group,
    STATE(2994), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2812] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7434), 1,
      anon_sym_LBRACE,
    STATE(1373), 1,
      sym_curly_group_author_list,
    STATE(2993), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2829] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7436), 1,
      anon_sym_LBRACE,
    STATE(1346), 1,
      sym_curly_group_path_list,
    STATE(2991), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2846] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1344), 1,
      sym_curly_group_path,
    STATE(2990), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2863] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(898), 1,
      sym_curly_group_text,
    STATE(2605), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2880] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7442), 1,
      anon_sym_LBRACE,
    STATE(1340), 1,
      sym_curly_group_glob_pattern,
    STATE(2989), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2897] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2603), 1,
      sym_brack_group_key_value,
    STATE(2604), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2914] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(894), 1,
      sym_curly_group_text,
    STATE(2578), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2931] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1337), 1,
      sym_curly_group_path,
    STATE(2988), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2948] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1336), 1,
      sym_curly_group_path,
    STATE(2986), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2965] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1335), 1,
      sym_curly_group_path,
    STATE(2467), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2982] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7422), 1,
      anon_sym_LBRACE,
    STATE(1511), 1,
      sym_curly_group_text_list,
    STATE(3040), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [2999] = 5,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1333), 1,
      sym_curly_group,
    STATE(2979), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3016] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_LBRACE,
    STATE(1332), 1,
      sym_curly_group_text_list,
    STATE(2267), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3033] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7444), 1,
      anon_sym_LBRACE,
    STATE(1761), 1,
      sym_curly_group_text,
    STATE(3039), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3050] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7444), 1,
      anon_sym_LBRACE,
    STATE(1762), 1,
      sym_curly_group_text,
    STATE(3038), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3067] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7422), 1,
      anon_sym_LBRACE,
    STATE(1770), 1,
      sym_curly_group_text_list,
    STATE(2218), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3084] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    STATE(1326), 1,
      sym_curly_group_text,
    STATE(2964), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3101] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    STATE(1325), 1,
      sym_curly_group_text,
    STATE(2962), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3118] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7448), 1,
      anon_sym_LBRACE,
    STATE(1061), 1,
      sym_curly_group_text_list,
    STATE(2273), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3135] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1772), 1,
      sym_curly_group,
    STATE(3030), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3152] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1774), 1,
      sym_curly_group_path,
    STATE(3028), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3169] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1775), 1,
      sym_curly_group_path,
    STATE(3027), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3186] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1776), 1,
      sym_curly_group_path,
    STATE(3026), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3203] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_LBRACE,
    STATE(1506), 1,
      sym_curly_group_text_list,
    STATE(2629), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3220] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7452), 1,
      anon_sym_LBRACE,
    STATE(1779), 1,
      sym_curly_group_glob_pattern,
    STATE(3025), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3237] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2713), 1,
      sym_brack_group_key_value,
    STATE(3170), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3254] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1781), 1,
      sym_curly_group_path,
    STATE(3024), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3271] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7454), 1,
      anon_sym_LBRACE,
    STATE(1782), 1,
      sym_curly_group_path_list,
    STATE(3023), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3288] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7456), 1,
      anon_sym_LBRACE,
    STATE(1783), 1,
      sym_curly_group_author_list,
    STATE(3021), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3305] = 5,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(3177), 1,
      sym_curly_group_impl,
    STATE(3219), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3322] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1784), 1,
      sym_curly_group,
    STATE(3019), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3339] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2527), 1,
      sym_brack_group_text,
    STATE(2647), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3356] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(803), 1,
      sym_curly_group_text_list,
    STATE(2577), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3373] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2574), 1,
      sym_curly_group_text,
    STATE(2576), 1,
      sym_brack_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3390] = 5,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    ACTIONS(7458), 1,
      sym_command_name,
    ACTIONS(7460), 1,
      sym_letter,
    STATE(1787), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3407] = 5,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    ACTIONS(7462), 1,
      sym_command_name,
    ACTIONS(7464), 1,
      sym_letter,
    STATE(1788), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3424] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2543), 1,
      sym_brack_group_text,
    STATE(2546), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3441] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7420), 1,
      anon_sym_LBRACE,
    STATE(1832), 1,
      sym_curly_group_text_list,
    STATE(2656), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3458] = 5,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(1829), 1,
      sym_curly_group,
    STATE(2265), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3475] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2712), 1,
      sym_brack_group_text,
    STATE(3169), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3492] = 5,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(965), 1,
      sym_curly_group,
    STATE(2189), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3509] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1794), 1,
      sym_curly_group,
    STATE(2678), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3526] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2529), 1,
      sym_brack_group_text,
    STATE(2677), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3543] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7342), 1,
      anon_sym_LBRACE,
    STATE(1056), 1,
      sym_curly_group_text_list,
    STATE(2887), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3560] = 5,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(1118), 1,
      sym_curly_group,
    STATE(2205), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3577] = 5,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    ACTIONS(7466), 1,
      sym_command_name,
    ACTIONS(7468), 1,
      sym_letter,
    STATE(2062), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3594] = 5,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(1266), 1,
      sym_curly_group,
    STATE(2304), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3611] = 5,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    ACTIONS(7470), 1,
      sym_command_name,
    ACTIONS(7472), 1,
      sym_letter,
    STATE(2020), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3628] = 5,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(591), 1,
      sym_curly_group,
    STATE(2977), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3645] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7448), 1,
      anon_sym_LBRACE,
    STATE(1115), 1,
      sym_curly_group_text_list,
    STATE(2582), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3662] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2530), 1,
      sym_brack_group_text,
    STATE(2741), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3679] = 5,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(458), 1,
      sym_curly_group,
    STATE(2272), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3696] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7474), 1,
      anon_sym_LBRACE,
    STATE(462), 1,
      sym_curly_group_text_list,
    STATE(2963), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3713] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2012), 1,
      sym_curly_group,
    STATE(2725), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3730] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7474), 1,
      anon_sym_LBRACE,
    STATE(431), 1,
      sym_curly_group_text_list,
    STATE(2955), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3747] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7476), 1,
      anon_sym_LBRACE,
    STATE(532), 1,
      sym_curly_group_text,
    STATE(2954), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3764] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7476), 1,
      anon_sym_LBRACE,
    STATE(533), 1,
      sym_curly_group_text,
    STATE(2953), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3781] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7474), 1,
      anon_sym_LBRACE,
    STATE(537), 1,
      sym_curly_group_text_list,
    STATE(2276), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3798] = 5,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(538), 1,
      sym_curly_group,
    STATE(2945), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3815] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(540), 1,
      sym_curly_group_path,
    STATE(2943), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3832] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(541), 1,
      sym_curly_group_path,
    STATE(2942), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3849] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(542), 1,
      sym_curly_group_path,
    STATE(2941), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3866] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2649), 1,
      sym_brack_group_key_value,
    STATE(3103), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3883] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7480), 1,
      anon_sym_LBRACE,
    STATE(545), 1,
      sym_curly_group_glob_pattern,
    STATE(2940), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3900] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(547), 1,
      sym_curly_group_path,
    STATE(2939), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3917] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7482), 1,
      anon_sym_LBRACE,
    STATE(548), 1,
      sym_curly_group_path_list,
    STATE(2938), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3934] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7484), 1,
      anon_sym_LBRACE,
    STATE(549), 1,
      sym_curly_group_author_list,
    STATE(2936), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3951] = 5,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(550), 1,
      sym_curly_group,
    STATE(2934), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3968] = 5,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(7486), 1,
      sym_command_name,
    ACTIONS(7488), 1,
      sym_letter,
    STATE(582), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [3985] = 5,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(7490), 1,
      sym_command_name,
    ACTIONS(7492), 1,
      sym_letter,
    STATE(583), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4002] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7494), 1,
      anon_sym_LBRACE,
    STATE(2034), 1,
      sym_curly_group_author_list,
    STATE(2727), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4019] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7496), 1,
      anon_sym_LBRACE,
    STATE(2003), 1,
      sym_curly_group_path_list,
    STATE(2729), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4036] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2007), 1,
      sym_curly_group_path,
    STATE(2730), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4053] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2648), 1,
      sym_brack_group_text,
    STATE(3098), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4070] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7500), 1,
      anon_sym_LBRACE,
    STATE(1997), 1,
      sym_curly_group_glob_pattern,
    STATE(2731), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4087] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2001), 1,
      sym_curly_group_path,
    STATE(2732), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4104] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2002), 1,
      sym_curly_group_path,
    STATE(2733), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4121] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2004), 1,
      sym_curly_group_path,
    STATE(2734), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4138] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2008), 1,
      sym_curly_group,
    STATE(2736), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4155] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACE,
    STATE(2009), 1,
      sym_curly_group_text_list,
    STATE(2322), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4172] = 5,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1201), 1,
      sym_curly_group,
    STATE(2825), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4189] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2624), 1,
      sym_brack_group_key_value,
    STATE(2995), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4206] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2621), 1,
      sym_brack_group_text,
    STATE(2973), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4223] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2595), 1,
      sym_brack_group_key_value,
    STATE(2907), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4240] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7504), 1,
      anon_sym_LBRACE,
    STATE(2016), 1,
      sym_curly_group_text,
    STATE(2744), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4257] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2592), 1,
      sym_brack_group_text,
    STATE(2906), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4274] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1899), 1,
      sym_curly_group,
    STATE(2890), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4291] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7504), 1,
      anon_sym_LBRACE,
    STATE(2017), 1,
      sym_curly_group_text,
    STATE(2745), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4308] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACE,
    STATE(1975), 1,
      sym_curly_group_text_list,
    STATE(2746), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4325] = 5,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(1887), 1,
      sym_curly_group,
    STATE(2310), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4342] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_LBRACE,
    STATE(1943), 1,
      sym_curly_group_text_list,
    STATE(2875), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4359] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2580), 1,
      sym_brack_group_key_value,
    STATE(2872), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4376] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7508), 1,
      anon_sym_LBRACE,
    STATE(2915), 1,
      sym_brack_group_key_value,
    STATE(3318), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4393] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_LBRACE,
    STATE(1791), 1,
      sym_curly_group_text_list,
    STATE(2861), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4410] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7510), 1,
      anon_sym_LBRACE,
    STATE(1965), 1,
      sym_curly_group_text,
    STATE(2860), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4427] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7510), 1,
      anon_sym_LBRACE,
    STATE(1966), 1,
      sym_curly_group_text,
    STATE(2859), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4444] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7506), 1,
      anon_sym_LBRACE,
    STATE(1947), 1,
      sym_curly_group_text_list,
    STATE(2314), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4461] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1942), 1,
      sym_curly_group,
    STATE(2851), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4478] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7502), 1,
      anon_sym_LBRACE,
    STATE(2069), 1,
      sym_curly_group_text_list,
    STATE(2773), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4495] = 5,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    ACTIONS(7294), 1,
      anon_sym_LBRACK,
    STATE(2061), 1,
      sym_curly_group,
    STATE(2324), 1,
      sym_brack_group_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4512] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2051), 1,
      sym_curly_group,
    STATE(2795), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4529] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1938), 1,
      sym_curly_group_path,
    STATE(2849), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4546] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2532), 1,
      sym_brack_group_text,
    STATE(2762), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4563] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1936), 1,
      sym_curly_group_path,
    STATE(2848), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4580] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7448), 1,
      anon_sym_LBRACE,
    STATE(866), 1,
      sym_curly_group_text_list,
    STATE(2680), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4597] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1935), 1,
      sym_curly_group_path,
    STATE(2847), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4614] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(1066), 1,
      sym_curly_group_text,
    STATE(2681), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4631] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7514), 1,
      anon_sym_LBRACE,
    STATE(1969), 1,
      sym_curly_group_glob_pattern,
    STATE(2846), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4648] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1964), 1,
      sym_curly_group_path,
    STATE(2845), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4665] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7516), 1,
      anon_sym_LBRACE,
    STATE(1963), 1,
      sym_curly_group_path_list,
    STATE(2844), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4682] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7518), 1,
      anon_sym_LBRACE,
    STATE(1885), 1,
      sym_curly_group_author_list,
    STATE(2842), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4699] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1960), 1,
      sym_curly_group,
    STATE(2840), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4716] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(1065), 1,
      sym_curly_group_text,
    STATE(2683), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4733] = 5,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    ACTIONS(7520), 1,
      sym_command_name,
    ACTIONS(7522), 1,
      sym_letter,
    STATE(1957), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4750] = 5,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    ACTIONS(7524), 1,
      sym_command_name,
    ACTIONS(7526), 1,
      sym_letter,
    STATE(1953), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4767] = 5,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    ACTIONS(7528), 1,
      sym_command_name,
    ACTIONS(7530), 1,
      sym_letter,
    STATE(1087), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4784] = 5,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    ACTIONS(7532), 1,
      sym_command_name,
    ACTIONS(7534), 1,
      sym_letter,
    STATE(1086), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4801] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2537), 1,
      sym_brack_group_text,
    STATE(2823), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4818] = 5,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1080), 1,
      sym_curly_group,
    STATE(2714), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4835] = 5,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    ACTIONS(7536), 1,
      anon_sym_LBRACE,
    STATE(1079), 1,
      sym_curly_group_author_list,
    STATE(2709), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4852] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7538), 1,
      anon_sym_LBRACE,
    STATE(1078), 1,
      sym_curly_group_path_list,
    STATE(2706), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4869] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1077), 1,
      sym_curly_group_path,
    STATE(2705), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4886] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7542), 1,
      anon_sym_LBRACE,
    STATE(1075), 1,
      sym_curly_group_glob_pattern,
    STATE(2575), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4903] = 5,
    ACTIONS(6107), 1,
      anon_sym_LBRACK,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2534), 1,
      sym_brack_group_text,
    STATE(2769), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4920] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1072), 1,
      sym_curly_group_path,
    STATE(2701), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4937] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1468), 1,
      sym_curly_group_path,
    STATE(2699), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4954] = 5,
    ACTIONS(7340), 1,
      anon_sym_LBRACK,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1058), 1,
      sym_curly_group_path,
    STATE(2698), 1,
      sym_brack_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4971] = 5,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    ACTIONS(3405), 1,
      anon_sym_LBRACK,
    STATE(1060), 1,
      sym_curly_group,
    STATE(2696), 1,
      sym_brack_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [4988] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7546), 1,
      anon_sym_RBRACE,
    STATE(2422), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5002] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7550), 1,
      anon_sym_RBRACE,
    STATE(2355), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5016] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7554), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5030] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7556), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5044] = 4,
    ACTIONS(7558), 1,
      sym_command_name,
    ACTIONS(7560), 1,
      anon_sym_LBRACE,
    STATE(1980), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5058] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7562), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5072] = 4,
    ACTIONS(7564), 1,
      anon_sym_RBRACE,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5086] = 4,
    ACTIONS(7560), 1,
      anon_sym_LBRACE,
    ACTIONS(7568), 1,
      sym_command_name,
    STATE(1983), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5100] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7570), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5114] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7572), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5128] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7574), 1,
      anon_sym_RBRACE,
    STATE(2361), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5142] = 4,
    ACTIONS(7576), 1,
      sym_command_name,
    ACTIONS(7578), 1,
      anon_sym_LBRACE,
    STATE(972), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5156] = 2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7580), 3,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_command_name,
  [5166] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7582), 1,
      anon_sym_RBRACE,
    STATE(2354), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5180] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7584), 1,
      anon_sym_RBRACE,
    STATE(2357), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5194] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7586), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5208] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7588), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5222] = 4,
    ACTIONS(7590), 1,
      anon_sym_RBRACE,
    ACTIONS(7592), 1,
      anon_sym_BSLASHand,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5236] = 2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7595), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [5246] = 4,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    ACTIONS(7597), 1,
      anon_sym_RBRACE,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5260] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7599), 1,
      anon_sym_RBRACE,
    STATE(2378), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5274] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7601), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5288] = 4,
    ACTIONS(7578), 1,
      anon_sym_LBRACE,
    ACTIONS(7603), 1,
      sym_command_name,
    STATE(941), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5302] = 4,
    ACTIONS(7605), 1,
      sym_command_name,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(1883), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5316] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7609), 1,
      anon_sym_RBRACE,
    STATE(2367), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5330] = 4,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    ACTIONS(7611), 1,
      anon_sym_RBRACE,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5344] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7613), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5358] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7615), 1,
      anon_sym_RBRACE,
    STATE(2368), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5372] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7617), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5386] = 4,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    ACTIONS(7619), 1,
      sym_command_name,
    STATE(1880), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5400] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7621), 1,
      anon_sym_RBRACE,
    STATE(2383), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5414] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7623), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5428] = 2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7625), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [5438] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7627), 1,
      anon_sym_RBRACE,
    STATE(2444), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5452] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7629), 1,
      anon_sym_RBRACE,
    STATE(2394), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5466] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7631), 1,
      anon_sym_RBRACE,
    STATE(2403), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5480] = 4,
    ACTIONS(7633), 1,
      sym_command_name,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(434), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5494] = 4,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    ACTIONS(7637), 1,
      anon_sym_RBRACE,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5508] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7639), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5522] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7641), 1,
      anon_sym_RBRACE,
    STATE(2390), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5536] = 4,
    ACTIONS(7643), 1,
      sym_command_name,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1606), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5550] = 4,
    ACTIONS(7647), 1,
      anon_sym_RBRACK,
    ACTIONS(7649), 1,
      anon_sym_COMMA,
    STATE(2393), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5564] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7652), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5578] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7654), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5592] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7656), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5606] = 4,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    ACTIONS(7658), 1,
      anon_sym_RBRACE,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5620] = 4,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    ACTIONS(7660), 1,
      sym_command_name,
    STATE(1517), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5634] = 4,
    ACTIONS(7662), 1,
      anon_sym_COMMA,
    ACTIONS(7665), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5648] = 4,
    ACTIONS(7667), 1,
      sym_command_name,
    ACTIONS(7669), 1,
      anon_sym_LBRACE,
    STATE(872), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5662] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7671), 1,
      anon_sym_RBRACE,
    STATE(2395), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5676] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7673), 1,
      anon_sym_RBRACE,
    STATE(2396), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5690] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7675), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5704] = 4,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    ACTIONS(7677), 1,
      sym_command_name,
    STATE(436), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5718] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7679), 1,
      anon_sym_RBRACE,
    STATE(2360), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5732] = 3,
    ACTIONS(7683), 1,
      aux_sym__glob_pattern_fragment_token1,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7681), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [5744] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7685), 1,
      sym_command_name,
    STATE(2356), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5758] = 3,
    ACTIONS(7689), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7687), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [5770] = 4,
    ACTIONS(7691), 1,
      anon_sym_RBRACK,
    ACTIONS(7693), 1,
      anon_sym_COMMA,
    STATE(2432), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5784] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7695), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5798] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7697), 1,
      anon_sym_RBRACE,
    STATE(2410), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5812] = 3,
    ACTIONS(7701), 1,
      aux_sym__glob_pattern_fragment_token1,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7699), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [5824] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7703), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5838] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7705), 1,
      anon_sym_RBRACE,
    STATE(2423), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5852] = 4,
    ACTIONS(7707), 1,
      sym_command_name,
    ACTIONS(7709), 1,
      anon_sym_LBRACE,
    STATE(1618), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5866] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7711), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5880] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7713), 1,
      anon_sym_RBRACE,
    STATE(2441), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5894] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7715), 1,
      anon_sym_RBRACE,
    STATE(2413), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5908] = 4,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    ACTIONS(7717), 1,
      anon_sym_RBRACE,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5922] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7719), 1,
      anon_sym_RBRACE,
    STATE(2442), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5936] = 4,
    ACTIONS(7721), 1,
      sym_command_name,
    ACTIONS(7723), 1,
      anon_sym_LBRACE,
    STATE(913), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5950] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7725), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5964] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7727), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5978] = 4,
    ACTIONS(7729), 1,
      anon_sym_COMMA,
    ACTIONS(7732), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [5992] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7734), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6006] = 4,
    ACTIONS(7736), 1,
      sym_command_name,
    ACTIONS(7738), 1,
      anon_sym_LBRACE,
    STATE(944), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6020] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7740), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6034] = 4,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    ACTIONS(7742), 1,
      anon_sym_RBRACE,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6048] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7744), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6062] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7746), 1,
      anon_sym_RBRACE,
    STATE(2429), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6076] = 4,
    ACTIONS(7748), 1,
      sym_command_name,
    ACTIONS(7750), 1,
      anon_sym_LBRACE,
    STATE(1498), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6090] = 4,
    ACTIONS(7693), 1,
      anon_sym_COMMA,
    ACTIONS(7752), 1,
      anon_sym_RBRACK,
    STATE(2393), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6104] = 2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7754), 3,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_command_name,
  [6114] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7756), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6128] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7758), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6142] = 4,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    ACTIONS(7760), 1,
      anon_sym_RBRACE,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6156] = 4,
    ACTIONS(7750), 1,
      anon_sym_LBRACE,
    ACTIONS(7762), 1,
      sym_command_name,
    STATE(1508), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6170] = 4,
    ACTIONS(7709), 1,
      anon_sym_LBRACE,
    ACTIONS(7764), 1,
      sym_command_name,
    STATE(1622), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6184] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7766), 1,
      anon_sym_RBRACE,
    STATE(2449), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6198] = 4,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    ACTIONS(7768), 1,
      anon_sym_RBRACE,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6212] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7770), 1,
      anon_sym_RBRACE,
    STATE(2399), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6226] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7772), 1,
      anon_sym_RBRACE,
    STATE(2424), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6240] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7774), 1,
      anon_sym_RBRACE,
    STATE(2434), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6254] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7776), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6268] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7778), 1,
      anon_sym_RBRACE,
    STATE(2435), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6282] = 4,
    ACTIONS(7738), 1,
      anon_sym_LBRACE,
    ACTIONS(7780), 1,
      sym_command_name,
    STATE(932), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6296] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7782), 1,
      anon_sym_RBRACE,
    STATE(2448), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6310] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7784), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6324] = 4,
    ACTIONS(7548), 1,
      anon_sym_COMMA,
    ACTIONS(7786), 1,
      anon_sym_RBRACE,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6338] = 4,
    ACTIONS(7566), 1,
      anon_sym_BSLASHand,
    ACTIONS(7788), 1,
      anon_sym_RBRACE,
    STATE(2369), 1,
      aux_sym_curly_group_author_list_repeat2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6352] = 4,
    ACTIONS(7723), 1,
      anon_sym_LBRACE,
    ACTIONS(7790), 1,
      sym_command_name,
    STATE(916), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6366] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7792), 1,
      sym_command_name,
    STATE(2421), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6380] = 4,
    ACTIONS(7552), 1,
      anon_sym_COMMA,
    ACTIONS(7794), 1,
      anon_sym_RBRACE,
    STATE(2425), 1,
      aux_sym_curly_group_text_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6394] = 4,
    ACTIONS(7669), 1,
      anon_sym_LBRACE,
    ACTIONS(7796), 1,
      sym_command_name,
    STATE(869), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6408] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7798), 1,
      anon_sym_RBRACE,
    STATE(2427), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6422] = 4,
    ACTIONS(7544), 1,
      anon_sym_COMMA,
    ACTIONS(7800), 1,
      anon_sym_RBRACE,
    STATE(2416), 1,
      aux_sym_curly_group_path_list_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6436] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7802), 1,
      sym_command_name,
    STATE(2438), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6450] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7804), 1,
      sym_command_name,
    STATE(2363), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6464] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7806), 1,
      sym_command_name,
    STATE(2381), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6478] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7808), 1,
      sym_command_name,
    STATE(2400), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6492] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7810), 1,
      sym_command_name,
    STATE(2446), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6506] = 3,
    ACTIONS(7812), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7687), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [6518] = 4,
    ACTIONS(7647), 1,
      anon_sym_RBRACE,
    ACTIONS(7814), 1,
      anon_sym_COMMA,
    STATE(2463), 1,
      aux_sym_curly_group_key_value_repeat1,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6532] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7817), 1,
      sym_command_name,
    STATE(2431), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6546] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7819), 1,
      sym_command_name,
    STATE(2404), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6560] = 4,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    ACTIONS(7821), 1,
      sym_command_name,
    STATE(2392), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6574] = 3,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1303), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6585] = 3,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(598), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6596] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1222), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6607] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1224), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6618] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1225), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6629] = 3,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1525), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6640] = 3,
    ACTIONS(7823), 1,
      anon_sym_LBRACE,
    STATE(1046), 1,
      sym__math_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6651] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1226), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6662] = 3,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(1528), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6673] = 3,
    ACTIONS(7344), 1,
      anon_sym_LBRACE,
    STATE(1529), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6684] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2541), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6695] = 3,
    ACTIONS(7825), 1,
      anon_sym_minted,
    STATE(3439), 1,
      sym__minted_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6706] = 3,
    ACTIONS(7738), 1,
      anon_sym_LBRACE,
    STATE(1220), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6717] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1229), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6728] = 3,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(1533), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6739] = 3,
    ACTIONS(7388), 1,
      anon_sym_LBRACE,
    STATE(1534), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6750] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1535), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6761] = 3,
    ACTIONS(7827), 1,
      anon_sym_LBRACE,
    STATE(1499), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6772] = 3,
    ACTIONS(7829), 1,
      anon_sym_BSLASHend,
    STATE(1047), 1,
      sym__sageblock_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6783] = 3,
    ACTIONS(7831), 1,
      anon_sym_BSLASHend,
    STATE(1048), 1,
      sym__sagesilent_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6794] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(503), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6805] = 3,
    ACTIONS(7833), 1,
      anon_sym_BSLASHend,
    STATE(1049), 1,
      sym__pycode_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6816] = 3,
    ACTIONS(7835), 1,
      anon_sym_BSLASHend,
    STATE(1050), 1,
      sym__minted_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6827] = 3,
    ACTIONS(7837), 1,
      anon_sym_BSLASHend,
    STATE(1051), 1,
      sym__listing_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6838] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1542), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6849] = 3,
    ACTIONS(7839), 1,
      anon_sym_BSLASHend,
    STATE(1052), 1,
      sym__verbatim_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6860] = 3,
    ACTIONS(7392), 1,
      anon_sym_LBRACE,
    STATE(1544), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6871] = 3,
    ACTIONS(7841), 1,
      anon_sym_RBRACE,
    ACTIONS(7843), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [6882] = 3,
    ACTIONS(7388), 1,
      anon_sym_LBRACE,
    STATE(1546), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6893] = 3,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1547), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6904] = 3,
    ACTIONS(7386), 1,
      anon_sym_LBRACE,
    STATE(1548), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6915] = 3,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1549), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6926] = 3,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1550), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6937] = 3,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1551), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6948] = 3,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1552), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6959] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1553), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6970] = 3,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1518), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6981] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2589), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [6992] = 3,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(1556), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7003] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1557), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7014] = 3,
    ACTIONS(7376), 1,
      anon_sym_LBRACE,
    STATE(1520), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7025] = 3,
    ACTIONS(7845), 1,
      sym_command_name,
    ACTIONS(7847), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7036] = 3,
    ACTIONS(7849), 1,
      anon_sym_LBRACE,
    STATE(1588), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7047] = 3,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(1561), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7058] = 3,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(1516), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7069] = 3,
    ACTIONS(7344), 1,
      anon_sym_LBRACE,
    STATE(1493), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7080] = 3,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(1575), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7091] = 3,
    ACTIONS(7851), 1,
      anon_sym_BSLASHend,
    STATE(1053), 1,
      sym__comment_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7102] = 3,
    ACTIONS(7853), 1,
      anon_sym_BSLASHend,
    STATE(1577), 1,
      sym__comment_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7113] = 3,
    ACTIONS(7855), 1,
      anon_sym_BSLASHend,
    STATE(1578), 1,
      sym__verbatim_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7124] = 3,
    ACTIONS(7857), 1,
      anon_sym_BSLASHend,
    STATE(1649), 1,
      sym__listing_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7135] = 3,
    ACTIONS(7859), 1,
      anon_sym_BSLASHend,
    STATE(1585), 1,
      sym__minted_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7146] = 3,
    ACTIONS(7861), 1,
      anon_sym_BSLASHend,
    STATE(1586), 1,
      sym__pycode_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7157] = 3,
    ACTIONS(7863), 1,
      anon_sym_BSLASHend,
    STATE(1587), 1,
      sym__sagesilent_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7168] = 3,
    ACTIONS(7865), 1,
      anon_sym_BSLASHend,
    STATE(1620), 1,
      sym__sageblock_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7179] = 3,
    ACTIONS(7867), 1,
      anon_sym_LBRACE,
    STATE(1593), 1,
      sym__math_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7190] = 3,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(1055), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7201] = 2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(6276), 2,
      anon_sym_LBRACE,
      sym_command_name,
  [7210] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2609), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7221] = 2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7869), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [7230] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2646), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7241] = 2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(7871), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [7250] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2667), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7261] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2737), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7272] = 3,
    ACTIONS(7873), 1,
      anon_sym_sageblock,
    STATE(3266), 1,
      sym__sageblock_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7283] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2761), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7294] = 3,
    ACTIONS(7875), 1,
      anon_sym_sagesilent,
    STATE(3265), 1,
      sym__sagesilent_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7305] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2767), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7316] = 3,
    ACTIONS(7877), 1,
      anon_sym_LBRACE,
    STATE(1210), 1,
      sym__sagesilent_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7327] = 3,
    ACTIONS(7879), 1,
      anon_sym_pycode,
    STATE(3263), 1,
      sym__pycode_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7338] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2810), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7349] = 3,
    ACTIONS(7825), 1,
      anon_sym_minted,
    STATE(3382), 1,
      sym__minted_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7360] = 3,
    ACTIONS(7344), 1,
      anon_sym_LBRACE,
    STATE(1603), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7371] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1215), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7382] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2864), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7393] = 3,
    ACTIONS(7881), 1,
      anon_sym_LBRACE,
    STATE(1211), 1,
      sym__sageblock_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7404] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(2912), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7415] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1189), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7426] = 3,
    ACTIONS(7750), 1,
      anon_sym_LBRACE,
    STATE(1610), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7437] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2961), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7448] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1612), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7459] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1614), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7470] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1616), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7481] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2865), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7492] = 3,
    ACTIONS(7883), 1,
      anon_sym_LBRACE,
    STATE(1625), 1,
      sym__comment_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7503] = 3,
    ACTIONS(7885), 1,
      anon_sym_LBRACE,
    STATE(1626), 1,
      sym__verbatim_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7514] = 3,
    ACTIONS(7887), 1,
      anon_sym_LBRACE,
    STATE(1627), 1,
      sym__listing_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7525] = 3,
    ACTIONS(7889), 1,
      anon_sym_LBRACE,
    STATE(1628), 1,
      sym__minted_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7536] = 3,
    ACTIONS(7891), 1,
      anon_sym_LBRACE,
    STATE(1629), 1,
      sym__pycode_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7547] = 3,
    ACTIONS(7893), 1,
      anon_sym_LBRACE,
    STATE(1572), 1,
      sym__sagesilent_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7558] = 3,
    ACTIONS(7895), 1,
      anon_sym_LBRACE,
    STATE(1584), 1,
      sym__sageblock_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7569] = 3,
    ACTIONS(7897), 1,
      anon_sym_LBRACE,
    STATE(1209), 1,
      sym__pycode_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7580] = 3,
    ACTIONS(7899), 1,
      anon_sym_LBRACE,
    STATE(1208), 1,
      sym__minted_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7591] = 3,
    ACTIONS(7901), 1,
      anon_sym_LBRACE,
    STATE(1207), 1,
      sym__listing_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7602] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1645), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7613] = 3,
    ACTIONS(7903), 1,
      anon_sym_LBRACE,
    STATE(1206), 1,
      sym__verbatim_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7624] = 3,
    ACTIONS(7905), 1,
      anon_sym_LBRACE,
    STATE(1205), 1,
      sym__comment_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7635] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2866), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7646] = 3,
    ACTIONS(7750), 1,
      anon_sym_LBRACE,
    STATE(1642), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7657] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1193), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7668] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1640), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7679] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1638), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7690] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1637), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7701] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1636), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7712] = 3,
    ACTIONS(7825), 1,
      anon_sym_minted,
    STATE(3462), 1,
      sym__minted_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7723] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1191), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7734] = 3,
    ACTIONS(3109), 1,
      anon_sym_LBRACE,
    STATE(1633), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7745] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3001), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7756] = 3,
    ACTIONS(7542), 1,
      anon_sym_LBRACE,
    STATE(1108), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7767] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2996), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7778] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(773), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7789] = 3,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(891), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7800] = 3,
    ACTIONS(7738), 1,
      anon_sym_LBRACE,
    STATE(1187), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7811] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2867), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7822] = 3,
    ACTIONS(7907), 1,
      anon_sym_lstlisting,
    STATE(3261), 1,
      sym__listing_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7833] = 3,
    ACTIONS(7448), 1,
      anon_sym_LBRACE,
    STATE(1181), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7844] = 3,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1848), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7855] = 3,
    ACTIONS(7909), 1,
      anon_sym_verbatim,
    STATE(3251), 1,
      sym__verbatim_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7866] = 3,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1751), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7877] = 3,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    STATE(1756), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7888] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2215), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7899] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2124), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7910] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2895), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7921] = 3,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1825), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7932] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2900), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7943] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2902), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7954] = 3,
    ACTIONS(7432), 1,
      anon_sym_LBRACE,
    STATE(1865), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7965] = 3,
    ACTIONS(7420), 1,
      anon_sym_LBRACE,
    STATE(1864), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7976] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2903), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7987] = 3,
    ACTIONS(7913), 1,
      anon_sym_comment,
    STATE(3249), 1,
      sym__comment_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [7998] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2792), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8009] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2159), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8020] = 3,
    ACTIONS(7432), 1,
      anon_sym_LBRACE,
    STATE(1859), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8031] = 3,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    STATE(1858), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8042] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1857), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8053] = 3,
    ACTIONS(7915), 1,
      anon_sym_LBRACE,
    STATE(1568), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8064] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3035), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8075] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3172), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8086] = 3,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(971), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8097] = 3,
    ACTIONS(7917), 1,
      anon_sym_LBRACE,
    STATE(1005), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8108] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2121), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8119] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1846), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8130] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2947), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8141] = 3,
    ACTIONS(7412), 1,
      anon_sym_LBRACE,
    STATE(1844), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8152] = 3,
    ACTIONS(7919), 1,
      anon_sym_RBRACE,
    ACTIONS(7921), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [8163] = 3,
    ACTIONS(7414), 1,
      anon_sym_LBRACE,
    STATE(1842), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8174] = 3,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1841), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8185] = 3,
    ACTIONS(7418), 1,
      anon_sym_LBRACE,
    STATE(1840), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8196] = 3,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1839), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8207] = 3,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1837), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8218] = 3,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1836), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8229] = 3,
    ACTIONS(7416), 1,
      anon_sym_LBRACE,
    STATE(1835), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8240] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1834), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8251] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2956), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8262] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2957), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8273] = 3,
    ACTIONS(7432), 1,
      anon_sym_LBRACE,
    STATE(1831), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8284] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1830), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8295] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2958), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8306] = 3,
    ACTIONS(7923), 1,
      sym_command_name,
    ACTIONS(7925), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8317] = 3,
    ACTIONS(7927), 1,
      anon_sym_LBRACE,
    STATE(1824), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8328] = 3,
    ACTIONS(7432), 1,
      anon_sym_LBRACE,
    STATE(1822), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8339] = 3,
    ACTIONS(7432), 1,
      anon_sym_LBRACE,
    STATE(1821), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8350] = 3,
    ACTIONS(7420), 1,
      anon_sym_LBRACE,
    STATE(1501), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8361] = 3,
    ACTIONS(7432), 1,
      anon_sym_LBRACE,
    STATE(1818), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8372] = 3,
    ACTIONS(7929), 1,
      sym_command_name,
    ACTIONS(7931), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8383] = 3,
    ACTIONS(7933), 1,
      anon_sym_BSLASHend,
    STATE(1816), 1,
      sym__comment_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8394] = 3,
    ACTIONS(7935), 1,
      anon_sym_BSLASHend,
    STATE(1815), 1,
      sym__verbatim_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8405] = 3,
    ACTIONS(7937), 1,
      anon_sym_BSLASHend,
    STATE(1814), 1,
      sym__listing_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8416] = 3,
    ACTIONS(7939), 1,
      anon_sym_BSLASHend,
    STATE(1813), 1,
      sym__minted_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8427] = 3,
    ACTIONS(7941), 1,
      anon_sym_BSLASHend,
    STATE(1812), 1,
      sym__pycode_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8438] = 3,
    ACTIONS(7943), 1,
      anon_sym_BSLASHend,
    STATE(1811), 1,
      sym__sagesilent_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8449] = 3,
    ACTIONS(7945), 1,
      anon_sym_BSLASHend,
    STATE(1809), 1,
      sym__sageblock_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8460] = 3,
    ACTIONS(7947), 1,
      anon_sym_LBRACE,
    STATE(1807), 1,
      sym__math_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8471] = 3,
    ACTIONS(7949), 1,
      anon_sym_LBRACE,
    STATE(1164), 1,
      sym__math_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8482] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(985), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8493] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(986), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8504] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2169), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8515] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2118), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8526] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(987), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8537] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3089), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8548] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3090), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8559] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3091), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8570] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3092), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8581] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(989), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8592] = 3,
    ACTIONS(7669), 1,
      anon_sym_LBRACE,
    STATE(992), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8603] = 3,
    ACTIONS(7951), 1,
      anon_sym_BSLASHend,
    STATE(1163), 1,
      sym__sageblock_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8614] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2135), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8625] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2123), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8636] = 3,
    ACTIONS(7953), 1,
      anon_sym_BSLASHend,
    STATE(1162), 1,
      sym__sagesilent_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8647] = 3,
    ACTIONS(7420), 1,
      anon_sym_LBRACE,
    STATE(1796), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8658] = 3,
    ACTIONS(7955), 1,
      anon_sym_BSLASHend,
    STATE(1161), 1,
      sym__pycode_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8669] = 2,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
    ACTIONS(6280), 2,
      anon_sym_LBRACE,
      sym_command_name,
  [8678] = 3,
    ACTIONS(7957), 1,
      anon_sym_BSLASHend,
    STATE(1160), 1,
      sym__minted_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8689] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(963), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8700] = 3,
    ACTIONS(7959), 1,
      anon_sym_BSLASHend,
    STATE(1159), 1,
      sym__listing_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8711] = 3,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1785), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8722] = 3,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(962), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8733] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1767), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8744] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1651), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8755] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1760), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8766] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3145), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8777] = 3,
    ACTIONS(7961), 1,
      anon_sym_LBRACE,
    STATE(1754), 1,
      sym__comment_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8788] = 3,
    ACTIONS(7963), 1,
      anon_sym_LBRACE,
    STATE(1653), 1,
      sym__verbatim_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8799] = 3,
    ACTIONS(7965), 1,
      anon_sym_LBRACE,
    STATE(1737), 1,
      sym__listing_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8810] = 3,
    ACTIONS(7967), 1,
      anon_sym_LBRACE,
    STATE(1736), 1,
      sym__minted_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8821] = 3,
    ACTIONS(7969), 1,
      anon_sym_LBRACE,
    STATE(1735), 1,
      sym__pycode_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8832] = 3,
    ACTIONS(7971), 1,
      anon_sym_LBRACE,
    STATE(1734), 1,
      sym__sagesilent_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8843] = 3,
    ACTIONS(7973), 1,
      anon_sym_LBRACE,
    STATE(1733), 1,
      sym__sageblock_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8854] = 3,
    ACTIONS(7975), 1,
      anon_sym_BSLASHend,
    STATE(1158), 1,
      sym__verbatim_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8865] = 3,
    ACTIONS(7977), 1,
      anon_sym_BSLASHend,
    STATE(1157), 1,
      sym__comment_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8876] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3162), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8887] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1719), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8898] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(1155), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8909] = 3,
    ACTIONS(7448), 1,
      anon_sym_LBRACE,
    STATE(875), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8920] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(1122), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8931] = 3,
    ACTIONS(7645), 1,
      anon_sym_LBRACE,
    STATE(1701), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8942] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(1121), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8953] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1699), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8964] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1697), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8975] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1696), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8986] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1695), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [8997] = 3,
    ACTIONS(7825), 1,
      anon_sym_minted,
    STATE(3427), 1,
      sym__minted_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9008] = 3,
    ACTIONS(7979), 1,
      anon_sym_LBRACE,
    STATE(1120), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9019] = 3,
    ACTIONS(3411), 1,
      anon_sym_LBRACE,
    STATE(1692), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9030] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(957), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9041] = 3,
    ACTIONS(7981), 1,
      sym_command_name,
    ACTIONS(7983), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9052] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1117), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9063] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(1116), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9074] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(959), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9085] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1113), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9096] = 3,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1112), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9107] = 3,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1111), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9118] = 3,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1110), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9129] = 3,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2052), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9140] = 3,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1109), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9151] = 3,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(1999), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9162] = 3,
    ACTIONS(7496), 1,
      anon_sym_LBRACE,
    STATE(2000), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9173] = 3,
    ACTIONS(7985), 1,
      anon_sym_LBRACE,
    STATE(1073), 1,
      sym__sagesilent_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9184] = 3,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1107), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9195] = 3,
    ACTIONS(7538), 1,
      anon_sym_LBRACE,
    STATE(1106), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9206] = 3,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2005), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9217] = 3,
    ACTIONS(7987), 1,
      anon_sym_RBRACE,
    ACTIONS(7989), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [9228] = 3,
    ACTIONS(7536), 1,
      anon_sym_LBRACE,
    STATE(1104), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9239] = 3,
    ACTIONS(7504), 1,
      anon_sym_LBRACE,
    STATE(2013), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9250] = 3,
    ACTIONS(7502), 1,
      anon_sym_LBRACE,
    STATE(2014), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9261] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3164), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9272] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3165), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9283] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1102), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9294] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(1001), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9305] = 3,
    ACTIONS(7504), 1,
      anon_sym_LBRACE,
    STATE(2018), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9316] = 3,
    ACTIONS(7496), 1,
      anon_sym_LBRACE,
    STATE(2019), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9327] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1901), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9338] = 3,
    ACTIONS(7991), 1,
      anon_sym_LBRACE,
    STATE(1989), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9349] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(958), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9360] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2146), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9371] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(956), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9382] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(955), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9393] = 3,
    ACTIONS(7402), 1,
      anon_sym_LBRACE,
    STATE(954), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9404] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2026), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9415] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2108), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9426] = 3,
    ACTIONS(7494), 1,
      anon_sym_LBRACE,
    STATE(2036), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9437] = 3,
    ACTIONS(7993), 1,
      anon_sym_RBRACE,
    ACTIONS(7995), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [9448] = 3,
    ACTIONS(7496), 1,
      anon_sym_LBRACE,
    STATE(2042), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9459] = 3,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2049), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9470] = 3,
    ACTIONS(7500), 1,
      anon_sym_LBRACE,
    STATE(2054), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9481] = 3,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2060), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9492] = 3,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2063), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9503] = 3,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2064), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9514] = 3,
    ACTIONS(7498), 1,
      anon_sym_LBRACE,
    STATE(2070), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9525] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2071), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9536] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3225), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9547] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1095), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9558] = 3,
    ACTIONS(7504), 1,
      anon_sym_LBRACE,
    STATE(2068), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9569] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2067), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9580] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3223), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9591] = 3,
    ACTIONS(7997), 1,
      sym_command_name,
    ACTIONS(7999), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9602] = 3,
    ACTIONS(8001), 1,
      anon_sym_LBRACE,
    STATE(1996), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9613] = 3,
    ACTIONS(7504), 1,
      anon_sym_LBRACE,
    STATE(2011), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9624] = 3,
    ACTIONS(7504), 1,
      anon_sym_LBRACE,
    STATE(1995), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9635] = 3,
    ACTIONS(7502), 1,
      anon_sym_LBRACE,
    STATE(1974), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9646] = 3,
    ACTIONS(7476), 1,
      anon_sym_LBRACE,
    STATE(643), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9657] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(953), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9668] = 3,
    ACTIONS(8003), 1,
      anon_sym_BSLASHend,
    STATE(641), 1,
      sym__comment_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9679] = 3,
    ACTIONS(8005), 1,
      anon_sym_BSLASHend,
    STATE(640), 1,
      sym__verbatim_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9690] = 3,
    ACTIONS(8007), 1,
      anon_sym_BSLASHend,
    STATE(635), 1,
      sym__listing_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9701] = 3,
    ACTIONS(8009), 1,
      anon_sym_BSLASHend,
    STATE(630), 1,
      sym__minted_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9712] = 3,
    ACTIONS(8011), 1,
      anon_sym_BSLASHend,
    STATE(629), 1,
      sym__pycode_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9723] = 3,
    ACTIONS(8013), 1,
      anon_sym_BSLASHend,
    STATE(628), 1,
      sym__sagesilent_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9734] = 3,
    ACTIONS(8015), 1,
      anon_sym_BSLASHend,
    STATE(626), 1,
      sym__sageblock_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9745] = 3,
    ACTIONS(8017), 1,
      anon_sym_LBRACE,
    STATE(625), 1,
      sym__math_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9756] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3222), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9767] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3221), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9778] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2155), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9789] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2113), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9800] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3188), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9811] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3186), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9822] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3185), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9833] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3184), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9844] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2163), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9855] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2119), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9866] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3151), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9877] = 3,
    ACTIONS(7356), 1,
      anon_sym_LBRACE,
    STATE(952), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9888] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3149), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9899] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3148), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9910] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3147), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9921] = 3,
    ACTIONS(8019), 1,
      anon_sym_LBRACE,
    STATE(1039), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9932] = 3,
    ACTIONS(7502), 1,
      anon_sym_LBRACE,
    STATE(2053), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9943] = 3,
    ACTIONS(684), 1,
      anon_sym_LBRACE,
    STATE(1070), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9954] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2131), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9965] = 3,
    ACTIONS(7538), 1,
      anon_sym_LBRACE,
    STATE(1069), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9976] = 3,
    ACTIONS(8021), 1,
      anon_sym_RBRACE,
    ACTIONS(8023), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [9987] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(1068), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [9998] = 3,
    ACTIONS(7560), 1,
      anon_sym_LBRACE,
    STATE(2047), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10009] = 3,
    ACTIONS(7348), 1,
      anon_sym_LBRACE,
    STATE(930), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10020] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2045), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10031] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2043), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10042] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2041), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10053] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2129), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10064] = 3,
    ACTIONS(8025), 1,
      anon_sym_LBRACE,
    STATE(617), 1,
      sym__comment_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10075] = 3,
    ACTIONS(8027), 1,
      anon_sym_LBRACE,
    STATE(615), 1,
      sym__verbatim_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10086] = 3,
    ACTIONS(8029), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym__listing_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10097] = 3,
    ACTIONS(8031), 1,
      anon_sym_LBRACE,
    STATE(605), 1,
      sym__minted_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10108] = 3,
    ACTIONS(8033), 1,
      anon_sym_LBRACE,
    STATE(602), 1,
      sym__pycode_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10119] = 3,
    ACTIONS(8035), 1,
      anon_sym_LBRACE,
    STATE(595), 1,
      sym__sagesilent_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10130] = 3,
    ACTIONS(8037), 1,
      anon_sym_LBRACE,
    STATE(627), 1,
      sym__sageblock_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10141] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(981), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10152] = 3,
    ACTIONS(7448), 1,
      anon_sym_LBRACE,
    STATE(1063), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10163] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(1062), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10174] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2037), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10185] = 3,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1059), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10196] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(948), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10207] = 3,
    ACTIONS(7538), 1,
      anon_sym_LBRACE,
    STATE(1071), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10218] = 3,
    ACTIONS(7560), 1,
      anon_sym_LBRACE,
    STATE(2033), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10229] = 3,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1067), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10240] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2031), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10251] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2029), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10262] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2028), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10273] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2027), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10284] = 3,
    ACTIONS(7825), 1,
      anon_sym_minted,
    STATE(3398), 1,
      sym__minted_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10295] = 3,
    ACTIONS(7540), 1,
      anon_sym_LBRACE,
    STATE(1076), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10306] = 3,
    ACTIONS(7169), 1,
      anon_sym_LBRACE,
    STATE(2021), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10317] = 3,
    ACTIONS(8039), 1,
      anon_sym_LBRACE,
    STATE(1007), 1,
      sym__sagesilent_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10328] = 3,
    ACTIONS(8041), 1,
      anon_sym_LBRACE,
    STATE(1008), 1,
      sym__pycode_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10339] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3112), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10350] = 3,
    ACTIONS(8043), 1,
      anon_sym_LBRACE,
    STATE(883), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10361] = 3,
    ACTIONS(8045), 1,
      anon_sym_LBRACE,
    STATE(1009), 1,
      sym__minted_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10372] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1128), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10383] = 3,
    ACTIONS(7825), 1,
      anon_sym_minted,
    STATE(3344), 1,
      sym__minted_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10394] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1131), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10405] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1132), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10416] = 3,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1973), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10427] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1133), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10438] = 3,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1912), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10449] = 3,
    ACTIONS(7516), 1,
      anon_sym_LBRACE,
    STATE(1926), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10460] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1135), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10471] = 3,
    ACTIONS(7578), 1,
      anon_sym_LBRACE,
    STATE(1137), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10482] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3109), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10493] = 3,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1886), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10504] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1141), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10515] = 3,
    ACTIONS(8047), 1,
      anon_sym_LBRACE,
    STATE(1145), 1,
      sym__sageblock_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10526] = 3,
    ACTIONS(7510), 1,
      anon_sym_LBRACE,
    STATE(1948), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10537] = 3,
    ACTIONS(7506), 1,
      anon_sym_LBRACE,
    STATE(1961), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10548] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3108), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10559] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3107), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10570] = 3,
    ACTIONS(8049), 1,
      anon_sym_LBRACE,
    STATE(1147), 1,
      sym__pycode_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10581] = 3,
    ACTIONS(8051), 1,
      anon_sym_LBRACE,
    STATE(1148), 1,
      sym__minted_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10592] = 3,
    ACTIONS(7510), 1,
      anon_sym_LBRACE,
    STATE(1962), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10603] = 3,
    ACTIONS(7516), 1,
      anon_sym_LBRACE,
    STATE(1893), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10614] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(618), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10625] = 3,
    ACTIONS(8053), 1,
      anon_sym_LBRACE,
    STATE(1878), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10636] = 3,
    ACTIONS(8055), 1,
      anon_sym_LBRACE,
    STATE(1010), 1,
      sym__listing_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10647] = 3,
    ACTIONS(8057), 1,
      anon_sym_LBRACE,
    STATE(1149), 1,
      sym__listing_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10658] = 3,
    ACTIONS(8059), 1,
      anon_sym_LBRACE,
    STATE(1011), 1,
      sym__verbatim_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10669] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1955), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10680] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2190), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10691] = 3,
    ACTIONS(7518), 1,
      anon_sym_LBRACE,
    STATE(1934), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10702] = 3,
    ACTIONS(8061), 1,
      anon_sym_RBRACE,
    ACTIONS(8063), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [10713] = 3,
    ACTIONS(7516), 1,
      anon_sym_LBRACE,
    STATE(1972), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10724] = 3,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1970), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10735] = 3,
    ACTIONS(7514), 1,
      anon_sym_LBRACE,
    STATE(1968), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10746] = 3,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1939), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10757] = 3,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1930), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10768] = 3,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1929), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10779] = 3,
    ACTIONS(7512), 1,
      anon_sym_LBRACE,
    STATE(1928), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10790] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1927), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10801] = 3,
    ACTIONS(8065), 1,
      anon_sym_LBRACE,
    STATE(1150), 1,
      sym__verbatim_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10812] = 3,
    ACTIONS(8067), 1,
      anon_sym_LBRACE,
    STATE(1152), 1,
      sym__comment_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10823] = 3,
    ACTIONS(7510), 1,
      anon_sym_LBRACE,
    STATE(1924), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10834] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1937), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10845] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2112), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10856] = 3,
    ACTIONS(8069), 1,
      sym_command_name,
    ACTIONS(8071), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10867] = 3,
    ACTIONS(8073), 1,
      anon_sym_LBRACE,
    STATE(1889), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10878] = 3,
    ACTIONS(7510), 1,
      anon_sym_LBRACE,
    STATE(1890), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10889] = 3,
    ACTIONS(7510), 1,
      anon_sym_LBRACE,
    STATE(1891), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10900] = 3,
    ACTIONS(7506), 1,
      anon_sym_LBRACE,
    STATE(1826), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10911] = 3,
    ACTIONS(8075), 1,
      anon_sym_LBRACE,
    STATE(1015), 1,
      sym__comment_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10922] = 3,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1287), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10933] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3072), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10944] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3070), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10955] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3069), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10966] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3067), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10977] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(3065), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10988] = 3,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1289), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [10999] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3057), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11010] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1154), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11021] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11032] = 3,
    ACTIONS(7384), 1,
      anon_sym_LBRACE,
    STATE(1290), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11043] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1186), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11054] = 3,
    ACTIONS(7506), 1,
      anon_sym_LBRACE,
    STATE(1898), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11065] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1195), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11076] = 3,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1294), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11087] = 3,
    ACTIONS(7342), 1,
      anon_sym_LBRACE,
    STATE(876), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11098] = 3,
    ACTIONS(7578), 1,
      anon_sym_LBRACE,
    STATE(1197), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11109] = 3,
    ACTIONS(7368), 1,
      anon_sym_LBRACE,
    STATE(1299), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11120] = 3,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(1902), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11131] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(927), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11142] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1904), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11153] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1906), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11164] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1907), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11175] = 3,
    ACTIONS(7354), 1,
      anon_sym_LBRACE,
    STATE(1300), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11186] = 3,
    ACTIONS(7342), 1,
      anon_sym_LBRACE,
    STATE(1202), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11197] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3037), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11208] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2217), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11219] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1911), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11230] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3034), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11241] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3033), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11252] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(3029), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11263] = 3,
    ACTIONS(7607), 1,
      anon_sym_LBRACE,
    STATE(1914), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11274] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2987), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11285] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1916), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11296] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1918), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11307] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1919), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11318] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1920), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11329] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2985), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11340] = 3,
    ACTIONS(5067), 1,
      anon_sym_LBRACE,
    STATE(1923), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11351] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2984), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11362] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2982), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11373] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2980), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11384] = 3,
    ACTIONS(8077), 1,
      anon_sym_LBRACE,
    STATE(1006), 1,
      sym__sageblock_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11395] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2972), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11406] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2970), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11417] = 3,
    ACTIONS(7384), 1,
      anon_sym_LBRACE,
    STATE(1350), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11428] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1351), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11439] = 3,
    ACTIONS(8079), 1,
      anon_sym_LBRACE,
    STATE(968), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11450] = 3,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(546), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11461] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2597), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11472] = 3,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(544), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11483] = 3,
    ACTIONS(7482), 1,
      anon_sym_LBRACE,
    STATE(543), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11494] = 3,
    ACTIONS(7508), 1,
      anon_sym_LBRACE,
    STATE(3404), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11505] = 3,
    ACTIONS(8081), 1,
      anon_sym_LBRACE,
    STATE(1248), 1,
      sym__math_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11516] = 3,
    ACTIONS(8083), 1,
      anon_sym_BSLASHend,
    STATE(1249), 1,
      sym__sageblock_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11527] = 3,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(539), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11538] = 3,
    ACTIONS(8085), 1,
      anon_sym_BSLASHend,
    STATE(1250), 1,
      sym__sagesilent_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11549] = 3,
    ACTIONS(8087), 1,
      anon_sym_BSLASHend,
    STATE(1251), 1,
      sym__pycode_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11560] = 3,
    ACTIONS(7476), 1,
      anon_sym_LBRACE,
    STATE(536), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11571] = 3,
    ACTIONS(7474), 1,
      anon_sym_LBRACE,
    STATE(535), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11582] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2952), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11593] = 3,
    ACTIONS(8089), 1,
      anon_sym_BSLASHend,
    STATE(1252), 1,
      sym__minted_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11604] = 3,
    ACTIONS(8091), 1,
      anon_sym_BSLASHend,
    STATE(1253), 1,
      sym__listing_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11615] = 3,
    ACTIONS(8093), 1,
      anon_sym_BSLASHend,
    STATE(1146), 1,
      sym__verbatim_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11626] = 3,
    ACTIONS(7476), 1,
      anon_sym_LBRACE,
    STATE(529), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11637] = 3,
    ACTIONS(7482), 1,
      anon_sym_LBRACE,
    STATE(527), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11648] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1861), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11659] = 3,
    ACTIONS(8095), 1,
      anon_sym_LBRACE,
    STATE(438), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11670] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2275), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11681] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2949), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11692] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2948), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11703] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(519), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11714] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(2944), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11725] = 3,
    ACTIONS(7484), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11736] = 3,
    ACTIONS(8097), 1,
      anon_sym_RBRACE,
    ACTIONS(8099), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [11747] = 3,
    ACTIONS(7482), 1,
      anon_sym_LBRACE,
    STATE(515), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11758] = 3,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(514), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11769] = 3,
    ACTIONS(7480), 1,
      anon_sym_LBRACE,
    STATE(513), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11780] = 3,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(493), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11791] = 3,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11802] = 3,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(478), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11813] = 3,
    ACTIONS(7478), 1,
      anon_sym_LBRACE,
    STATE(472), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11824] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(466), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11835] = 3,
    ACTIONS(8101), 1,
      anon_sym_BSLASHend,
    STATE(1255), 1,
      sym__comment_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11846] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2901), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11857] = 3,
    ACTIONS(7476), 1,
      anon_sym_LBRACE,
    STATE(460), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11868] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(459), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11879] = 3,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    STATE(1257), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11890] = 3,
    ACTIONS(8103), 1,
      sym_command_name,
    ACTIONS(8105), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11901] = 3,
    ACTIONS(8107), 1,
      anon_sym_LBRACE,
    STATE(455), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11912] = 3,
    ACTIONS(7476), 1,
      anon_sym_LBRACE,
    STATE(454), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11923] = 3,
    ACTIONS(7476), 1,
      anon_sym_LBRACE,
    STATE(453), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11934] = 3,
    ACTIONS(7474), 1,
      anon_sym_LBRACE,
    STATE(424), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11945] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2899), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11956] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2898), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11967] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2896), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11978] = 3,
    ACTIONS(8109), 1,
      anon_sym_LBRACE,
    STATE(1462), 1,
      sym__listing_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [11989] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2894), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12000] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2641), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12011] = 3,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    STATE(1262), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12022] = 3,
    ACTIONS(7474), 1,
      anon_sym_LBRACE,
    STATE(567), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12033] = 3,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    STATE(1263), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12044] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1358), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12055] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(907), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12066] = 3,
    ACTIONS(8111), 1,
      anon_sym_LBRACE,
    STATE(1264), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12077] = 3,
    ACTIONS(7388), 1,
      anon_sym_LBRACE,
    STATE(1521), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12088] = 3,
    ACTIONS(7356), 1,
      anon_sym_LBRACE,
    STATE(906), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12099] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(579), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12110] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(577), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12121] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(574), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12132] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2885), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12143] = 3,
    ACTIONS(8113), 1,
      sym_command_name,
    ACTIONS(8115), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12154] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1267), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12165] = 3,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    STATE(1268), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12176] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(568), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12187] = 3,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(928), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12198] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1273), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12209] = 3,
    ACTIONS(7635), 1,
      anon_sym_LBRACE,
    STATE(556), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12220] = 3,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1254), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12231] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(531), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12242] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(528), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12253] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(522), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12264] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(521), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12275] = 3,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1304), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12286] = 3,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    STATE(506), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12297] = 3,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1305), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12308] = 3,
    ACTIONS(7442), 1,
      anon_sym_LBRACE,
    STATE(1306), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12319] = 3,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1307), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12330] = 3,
    ACTIONS(7436), 1,
      anon_sym_LBRACE,
    STATE(1308), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12341] = 3,
    ACTIONS(8117), 1,
      anon_sym_RBRACE,
    ACTIONS(8119), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [12352] = 3,
    ACTIONS(7434), 1,
      anon_sym_LBRACE,
    STATE(1310), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12363] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1312), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12374] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2883), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12385] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2642), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12396] = 3,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1780), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12407] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1316), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12418] = 3,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1778), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12429] = 3,
    ACTIONS(7454), 1,
      anon_sym_LBRACE,
    STATE(1777), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12440] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(1018), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12451] = 3,
    ACTIONS(8121), 1,
      anon_sym_LBRACE,
    STATE(1031), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12462] = 3,
    ACTIONS(1144), 1,
      anon_sym_LBRACE,
    STATE(1322), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12473] = 3,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1773), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12484] = 3,
    ACTIONS(7436), 1,
      anon_sym_LBRACE,
    STATE(1323), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12495] = 3,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    STATE(1324), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12506] = 3,
    ACTIONS(7444), 1,
      anon_sym_LBRACE,
    STATE(1768), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12517] = 3,
    ACTIONS(7422), 1,
      anon_sym_LBRACE,
    STATE(1765), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12528] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(1020), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12539] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1240), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12550] = 3,
    ACTIONS(7342), 1,
      anon_sym_LBRACE,
    STATE(1328), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12561] = 3,
    ACTIONS(7446), 1,
      anon_sym_LBRACE,
    STATE(1331), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12572] = 3,
    ACTIONS(7444), 1,
      anon_sym_LBRACE,
    STATE(1757), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12583] = 3,
    ACTIONS(7454), 1,
      anon_sym_LBRACE,
    STATE(1755), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12594] = 3,
    ACTIONS(8123), 1,
      anon_sym_LBRACE,
    STATE(1591), 1,
      sym_curly_group_uri,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12605] = 3,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1334), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12616] = 3,
    ACTIONS(7436), 1,
      anon_sym_LBRACE,
    STATE(1338), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12627] = 3,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1339), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12638] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1750), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12649] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2606), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12660] = 3,
    ACTIONS(7456), 1,
      anon_sym_LBRACE,
    STATE(1748), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12671] = 3,
    ACTIONS(8125), 1,
      anon_sym_RBRACE,
    ACTIONS(8127), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [12682] = 3,
    ACTIONS(7454), 1,
      anon_sym_LBRACE,
    STATE(1746), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12693] = 3,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1745), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12704] = 3,
    ACTIONS(7452), 1,
      anon_sym_LBRACE,
    STATE(1744), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12715] = 3,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1742), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12726] = 3,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1741), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12737] = 3,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1740), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12748] = 3,
    ACTIONS(7450), 1,
      anon_sym_LBRACE,
    STATE(1739), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12759] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1738), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12770] = 3,
    ACTIONS(7438), 1,
      anon_sym_LBRACE,
    STATE(1342), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12781] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(1035), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12792] = 3,
    ACTIONS(7444), 1,
      anon_sym_LBRACE,
    STATE(1728), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12803] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1727), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12814] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2650), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12825] = 3,
    ACTIONS(8129), 1,
      sym_command_name,
    ACTIONS(8131), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12836] = 3,
    ACTIONS(8133), 1,
      anon_sym_LBRACE,
    STATE(1724), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12847] = 3,
    ACTIONS(7444), 1,
      anon_sym_LBRACE,
    STATE(1723), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12858] = 3,
    ACTIONS(7444), 1,
      anon_sym_LBRACE,
    STATE(1722), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12869] = 3,
    ACTIONS(7422), 1,
      anon_sym_LBRACE,
    STATE(1509), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12880] = 3,
    ACTIONS(7378), 1,
      anon_sym_LBRACE,
    STATE(1281), 1,
      sym_curly_group_author_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12891] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2858), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12902] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2253), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12913] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1393), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12924] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2313), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12935] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2855), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12946] = 3,
    ACTIONS(7825), 1,
      anon_sym_minted,
    STATE(3262), 1,
      sym__minted_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12957] = 3,
    ACTIONS(7422), 1,
      anon_sym_LBRACE,
    STATE(1690), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12968] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1396), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12979] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2854), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [12990] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2107), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13001] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1397), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13012] = 3,
    ACTIONS(7709), 1,
      anon_sym_LBRACE,
    STATE(1685), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13023] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1398), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13034] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1683), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13045] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1681), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13056] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1679), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13067] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(2850), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13078] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1400), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13089] = 3,
    ACTIONS(7723), 1,
      anon_sym_LBRACE,
    STATE(1374), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13100] = 3,
    ACTIONS(7873), 1,
      anon_sym_sageblock,
    STATE(3364), 1,
      sym__sageblock_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13111] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1674), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13122] = 3,
    ACTIONS(7875), 1,
      anon_sym_sagesilent,
    STATE(3365), 1,
      sym__sagesilent_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13133] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1444), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13144] = 3,
    ACTIONS(7709), 1,
      anon_sym_LBRACE,
    STATE(1671), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13155] = 3,
    ACTIONS(8135), 1,
      anon_sym_LBRACE,
    STATE(1448), 1,
      sym__sageblock_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13166] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1669), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13177] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1667), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13188] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1666), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13199] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1665), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13210] = 3,
    ACTIONS(8137), 1,
      anon_sym_LBRACE,
    STATE(1449), 1,
      sym__sagesilent_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13221] = 3,
    ACTIONS(4530), 1,
      anon_sym_LBRACE,
    STATE(1660), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13232] = 3,
    ACTIONS(8139), 1,
      anon_sym_LBRACE,
    STATE(1450), 1,
      sym__pycode_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13243] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2264), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13254] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2660), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13265] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2663), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13276] = 3,
    ACTIONS(7879), 1,
      anon_sym_pycode,
    STATE(3366), 1,
      sym__pycode_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13287] = 3,
    ACTIONS(7352), 1,
      anon_sym_LBRACE,
    STATE(901), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13298] = 3,
    ACTIONS(7440), 1,
      anon_sym_LBRACE,
    STATE(969), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13309] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(3130), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13320] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3167), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13331] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3168), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13342] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2147), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13353] = 3,
    ACTIONS(7907), 1,
      anon_sym_lstlisting,
    STATE(3367), 1,
      sym__listing_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13364] = 3,
    ACTIONS(8141), 1,
      anon_sym_LBRACE,
    STATE(1451), 1,
      sym__minted_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13375] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3173), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13386] = 3,
    ACTIONS(7909), 1,
      anon_sym_verbatim,
    STATE(3368), 1,
      sym__verbatim_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13397] = 3,
    ACTIONS(7913), 1,
      anon_sym_comment,
    STATE(3369), 1,
      sym__comment_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13408] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2807), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13419] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2804), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13430] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2803), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13441] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2801), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13452] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2799), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13463] = 3,
    ACTIONS(8143), 1,
      anon_sym_RBRACE,
    ACTIONS(8145), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [13474] = 3,
    ACTIONS(7384), 1,
      anon_sym_LBRACE,
    STATE(1330), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13485] = 3,
    ACTIONS(8147), 1,
      anon_sym_LBRACE,
    STATE(1457), 1,
      sym__verbatim_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13496] = 3,
    ACTIONS(8149), 1,
      anon_sym_LBRACE,
    STATE(1455), 1,
      sym__comment_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13507] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2783), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13518] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1241), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13529] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1230), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13540] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3104), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13551] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3099), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13562] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2781), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13573] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1366), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13584] = 3,
    ACTIONS(7723), 1,
      anon_sym_LBRACE,
    STATE(1461), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13595] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(3060), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13606] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3059), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13617] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(3052), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13628] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3049), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13639] = 3,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1341), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13650] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(2720), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13661] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(3044), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13672] = 3,
    ACTIONS(7913), 1,
      anon_sym_comment,
    STATE(3338), 1,
      sym__comment_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13683] = 3,
    ACTIONS(7909), 1,
      anon_sym_verbatim,
    STATE(3339), 1,
      sym__verbatim_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13694] = 3,
    ACTIONS(7907), 1,
      anon_sym_lstlisting,
    STATE(3340), 1,
      sym__listing_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13705] = 3,
    ACTIONS(7879), 1,
      anon_sym_pycode,
    STATE(3345), 1,
      sym__pycode_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13716] = 3,
    ACTIONS(7875), 1,
      anon_sym_sagesilent,
    STATE(3347), 1,
      sym__sagesilent_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13727] = 3,
    ACTIONS(7873), 1,
      anon_sym_sageblock,
    STATE(3348), 1,
      sym__sageblock_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13738] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(892), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13749] = 3,
    ACTIONS(8151), 1,
      anon_sym_BSLASHend,
    STATE(1418), 1,
      sym__comment_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13760] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(2981), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13771] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2976), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13782] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2975), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13793] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2270), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13804] = 3,
    ACTIONS(7390), 1,
      anon_sym_LBRACE,
    STATE(1343), 1,
      sym_curly_group_glob_pattern,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13815] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2967), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13826] = 3,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1345), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13837] = 3,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1347), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13848] = 3,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1349), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13859] = 3,
    ACTIONS(7350), 1,
      anon_sym_LBRACE,
    STATE(1368), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13870] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2743), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13881] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2323), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13892] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2740), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13903] = 3,
    ACTIONS(7354), 1,
      anon_sym_LBRACE,
    STATE(1440), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13914] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2739), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13925] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(2735), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13936] = 3,
    ACTIONS(7873), 1,
      anon_sym_sageblock,
    STATE(3393), 1,
      sym__sageblock_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13947] = 3,
    ACTIONS(7875), 1,
      anon_sym_sagesilent,
    STATE(3394), 1,
      sym__sagesilent_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13958] = 3,
    ACTIONS(7879), 1,
      anon_sym_pycode,
    STATE(3397), 1,
      sym__pycode_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13969] = 3,
    ACTIONS(7907), 1,
      anon_sym_lstlisting,
    STATE(3399), 1,
      sym__listing_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13980] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2876), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [13991] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2871), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14002] = 3,
    ACTIONS(7909), 1,
      anon_sym_verbatim,
    STATE(3400), 1,
      sym__verbatim_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14013] = 3,
    ACTIONS(7913), 1,
      anon_sym_comment,
    STATE(3402), 1,
      sym__comment_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14024] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2690), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14035] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2822), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14046] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2821), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14057] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2816), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14068] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2815), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14079] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1369), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14090] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2813), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14101] = 3,
    ACTIONS(7913), 1,
      anon_sym_comment,
    STATE(3436), 1,
      sym__comment_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14112] = 3,
    ACTIONS(7909), 1,
      anon_sym_verbatim,
    STATE(3437), 1,
      sym__verbatim_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14123] = 3,
    ACTIONS(7907), 1,
      anon_sym_lstlisting,
    STATE(3438), 1,
      sym__listing_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14134] = 3,
    ACTIONS(7879), 1,
      anon_sym_pycode,
    STATE(3440), 1,
      sym__pycode_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14145] = 3,
    ACTIONS(7875), 1,
      anon_sym_sagesilent,
    STATE(3442), 1,
      sym__sagesilent_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14156] = 3,
    ACTIONS(7873), 1,
      anon_sym_sageblock,
    STATE(3443), 1,
      sym__sageblock_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14167] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(2697), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14178] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2694), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14189] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2693), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14200] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2268), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14211] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2687), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14222] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2689), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14233] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2686), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14244] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2684), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14255] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2682), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14266] = 3,
    ACTIONS(7368), 1,
      anon_sym_LBRACE,
    STATE(1402), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14277] = 3,
    ACTIONS(1032), 1,
      anon_sym_LBRACE,
    STATE(1403), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14288] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2666), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14299] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2664), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14310] = 3,
    ACTIONS(8153), 1,
      sym_command_name,
    ACTIONS(8155), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14321] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(1022), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14332] = 3,
    ACTIONS(8157), 1,
      anon_sym_LBRACE,
    STATE(1406), 1,
      sym_curly_group_key_value,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14343] = 3,
    ACTIONS(7368), 1,
      anon_sym_LBRACE,
    STATE(1407), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14354] = 3,
    ACTIONS(7356), 1,
      anon_sym_LBRACE,
    STATE(1014), 1,
      sym_curly_group_path_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14365] = 3,
    ACTIONS(7368), 1,
      anon_sym_LBRACE,
    STATE(1408), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14376] = 3,
    ACTIONS(7669), 1,
      anon_sym_LBRACE,
    STATE(1024), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14387] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2544), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14398] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2566), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14409] = 3,
    ACTIONS(7354), 1,
      anon_sym_LBRACE,
    STATE(888), 1,
      sym_curly_group_text_list,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14420] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(983), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14431] = 3,
    ACTIONS(8159), 1,
      anon_sym_LBRACE,
    STATE(1429), 1,
      sym__math_environment_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14442] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2479), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14453] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2469), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14464] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2471), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14475] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2474), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14486] = 3,
    ACTIONS(8161), 1,
      anon_sym_BSLASHend,
    STATE(1428), 1,
      sym__sageblock_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14497] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2480), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14508] = 3,
    ACTIONS(7913), 1,
      anon_sym_comment,
    STATE(3465), 1,
      sym__comment_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14519] = 3,
    ACTIONS(7909), 1,
      anon_sym_verbatim,
    STATE(3464), 1,
      sym__verbatim_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14530] = 3,
    ACTIONS(7907), 1,
      anon_sym_lstlisting,
    STATE(3463), 1,
      sym__listing_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14541] = 3,
    ACTIONS(7879), 1,
      anon_sym_pycode,
    STATE(3460), 1,
      sym__pycode_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14552] = 3,
    ACTIONS(7875), 1,
      anon_sym_sagesilent,
    STATE(3459), 1,
      sym__sagesilent_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14563] = 3,
    ACTIONS(7873), 1,
      anon_sym_sageblock,
    STATE(3458), 1,
      sym__sageblock_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14574] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(2501), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14585] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2505), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14596] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2506), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14607] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2191), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14618] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2626), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14629] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2509), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14640] = 3,
    ACTIONS(7911), 1,
      anon_sym_LBRACE,
    STATE(2262), 1,
      sym_curly_group_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14651] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2623), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14662] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2622), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14673] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(2618), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14684] = 3,
    ACTIONS(7873), 1,
      anon_sym_sageblock,
    STATE(3424), 1,
      sym__sageblock_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14695] = 3,
    ACTIONS(7875), 1,
      anon_sym_sagesilent,
    STATE(3425), 1,
      sym__sagesilent_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14706] = 3,
    ACTIONS(7879), 1,
      anon_sym_pycode,
    STATE(3426), 1,
      sym__pycode_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14717] = 3,
    ACTIONS(8163), 1,
      anon_sym_BSLASHend,
    STATE(1427), 1,
      sym__sagesilent_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14728] = 3,
    ACTIONS(7907), 1,
      anon_sym_lstlisting,
    STATE(3428), 1,
      sym__listing_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14739] = 3,
    ACTIONS(8165), 1,
      anon_sym_BSLASHend,
    STATE(1426), 1,
      sym__pycode_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14750] = 3,
    ACTIONS(8167), 1,
      anon_sym_BSLASHend,
    STATE(1425), 1,
      sym__minted_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14761] = 3,
    ACTIONS(8169), 1,
      anon_sym_BSLASHend,
    STATE(1424), 1,
      sym__listing_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14772] = 3,
    ACTIONS(8171), 1,
      anon_sym_BSLASHend,
    STATE(1423), 1,
      sym__verbatim_environment_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14783] = 3,
    ACTIONS(7368), 1,
      anon_sym_LBRACE,
    STATE(1329), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14794] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2547), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14805] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2549), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14816] = 3,
    ACTIONS(7909), 1,
      anon_sym_verbatim,
    STATE(3429), 1,
      sym__verbatim_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14827] = 3,
    ACTIONS(7358), 1,
      anon_sym_LBRACE,
    STATE(977), 1,
      sym_curly_group_path,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14838] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2651), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14849] = 3,
    ACTIONS(7296), 1,
      anon_sym_LBRACE,
    STATE(2565), 1,
      sym_curly_group_impl,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14860] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2567), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14871] = 3,
    ACTIONS(7346), 1,
      anon_sym_LBRACE,
    STATE(2569), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14882] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2570), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14893] = 3,
    ACTIONS(7368), 1,
      anon_sym_LBRACE,
    STATE(1453), 1,
      sym_curly_group_text,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14904] = 3,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    STATE(2573), 1,
      sym_curly_group,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14915] = 3,
    ACTIONS(7913), 1,
      anon_sym_comment,
    STATE(3430), 1,
      sym__comment_environment_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14926] = 2,
    ACTIONS(8173), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [14934] = 2,
    ACTIONS(8175), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [14942] = 2,
    ACTIONS(8177), 1,
      sym__trivia_raw_env_sageblock,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14950] = 2,
    ACTIONS(8179), 1,
      sym__trivia_raw_env_sagesilent,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14958] = 2,
    ACTIONS(8181), 1,
      sym__trivia_raw_env_pycode,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14966] = 2,
    ACTIONS(8183), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14974] = 2,
    ACTIONS(8185), 1,
      sym__trivia_raw_env_listing,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14982] = 2,
    ACTIONS(8187), 1,
      sym__trivia_raw_env_verbatim,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14990] = 2,
    ACTIONS(8189), 1,
      sym__trivia_raw_env_comment,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [14998] = 2,
    ACTIONS(8191), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15006] = 2,
    ACTIONS(8193), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15014] = 2,
    ACTIONS(8195), 1,
      sym__trivia_raw_env_comment,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15022] = 2,
    ACTIONS(8197), 1,
      sym__trivia_raw_env_verbatim,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15030] = 2,
    ACTIONS(8199), 1,
      sym__trivia_raw_env_listing,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15038] = 2,
    ACTIONS(8201), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15046] = 2,
    ACTIONS(8203), 1,
      sym__trivia_raw_env_pycode,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15054] = 2,
    ACTIONS(8205), 1,
      sym__trivia_raw_env_sagesilent,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15062] = 2,
    ACTIONS(8207), 1,
      sym__trivia_raw_env_sageblock,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15070] = 2,
    ACTIONS(8209), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15078] = 2,
    ACTIONS(8211), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15086] = 2,
    ACTIONS(8213), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15094] = 2,
    ACTIONS(8215), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15102] = 2,
    ACTIONS(8217), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15110] = 2,
    ACTIONS(8219), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15118] = 2,
    ACTIONS(8221), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15126] = 2,
    ACTIONS(8223), 1,
      sym__trivia_raw_env_sageblock,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15134] = 2,
    ACTIONS(8225), 1,
      sym__trivia_raw_env_sagesilent,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15142] = 2,
    ACTIONS(8227), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15150] = 2,
    ACTIONS(8229), 1,
      sym__trivia_raw_env_pycode,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15158] = 2,
    ACTIONS(8231), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15166] = 2,
    ACTIONS(8233), 1,
      sym__trivia_raw_env_listing,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15174] = 2,
    ACTIONS(8235), 1,
      sym__trivia_raw_env_verbatim,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15182] = 2,
    ACTIONS(8237), 1,
      sym__trivia_raw_env_comment,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15190] = 2,
    ACTIONS(8239), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15198] = 2,
    ACTIONS(8241), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15206] = 2,
    ACTIONS(8243), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15214] = 2,
    ACTIONS(8245), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15222] = 2,
    ACTIONS(8247), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15230] = 2,
    ACTIONS(8249), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15238] = 2,
    ACTIONS(8251), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15246] = 2,
    ACTIONS(8253), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15254] = 2,
    ACTIONS(8255), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15262] = 2,
    ACTIONS(8257), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15270] = 2,
    ACTIONS(8259), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15278] = 2,
    ACTIONS(8261), 1,
      sym__trivia_raw_env_sageblock,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15286] = 2,
    ACTIONS(8263), 1,
      sym__trivia_raw_env_sagesilent,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15294] = 2,
    ACTIONS(8265), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15302] = 2,
    ACTIONS(8267), 1,
      sym__trivia_raw_env_pycode,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15310] = 2,
    ACTIONS(8269), 1,
      sym__trivia_raw_env_comment,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15318] = 2,
    ACTIONS(8271), 1,
      sym__trivia_raw_env_verbatim,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15326] = 2,
    ACTIONS(8273), 1,
      sym__trivia_raw_env_listing,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15334] = 2,
    ACTIONS(8275), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15342] = 2,
    ACTIONS(8277), 1,
      sym__trivia_raw_env_pycode,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15350] = 2,
    ACTIONS(8279), 1,
      sym__trivia_raw_env_sagesilent,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15358] = 2,
    ACTIONS(8281), 1,
      sym__trivia_raw_env_sageblock,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15366] = 2,
    ACTIONS(8283), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15374] = 2,
    ACTIONS(8285), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15382] = 2,
    ACTIONS(8287), 1,
      sym__trivia_raw_env_listing,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15390] = 2,
    ACTIONS(8289), 1,
      sym__trivia_raw_env_verbatim,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15398] = 2,
    ACTIONS(8291), 1,
      sym__trivia_raw_env_comment,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15406] = 2,
    ACTIONS(8293), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15414] = 2,
    ACTIONS(8295), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15422] = 2,
    ACTIONS(8297), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15430] = 2,
    ACTIONS(8299), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15438] = 2,
    ACTIONS(8301), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15446] = 2,
    ACTIONS(8303), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15454] = 2,
    ACTIONS(8305), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15462] = 2,
    ACTIONS(8307), 1,
      sym__trivia_raw_env_sageblock,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15470] = 2,
    ACTIONS(8309), 1,
      sym__trivia_raw_env_sagesilent,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15478] = 2,
    ACTIONS(8311), 1,
      sym__trivia_raw_env_pycode,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15486] = 2,
    ACTIONS(8313), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15494] = 2,
    ACTIONS(8315), 1,
      sym__trivia_raw_env_listing,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15502] = 2,
    ACTIONS(8317), 1,
      sym__trivia_raw_env_verbatim,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15510] = 2,
    ACTIONS(8319), 1,
      sym__trivia_raw_env_comment,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15518] = 2,
    ACTIONS(8321), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15526] = 2,
    ACTIONS(8323), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15534] = 2,
    ACTIONS(8325), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15542] = 2,
    ACTIONS(8327), 1,
      sym_argc,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15550] = 2,
    ACTIONS(8329), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15558] = 2,
    ACTIONS(8331), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15566] = 2,
    ACTIONS(8333), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15574] = 2,
    ACTIONS(8335), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15582] = 2,
    ACTIONS(8337), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15590] = 2,
    ACTIONS(8339), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15598] = 2,
    ACTIONS(8341), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15606] = 2,
    ACTIONS(8343), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15614] = 2,
    ACTIONS(8345), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15622] = 2,
    ACTIONS(8347), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15630] = 2,
    ACTIONS(8349), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15638] = 2,
    ACTIONS(8351), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15646] = 2,
    ACTIONS(8353), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15654] = 2,
    ACTIONS(8355), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15662] = 2,
    ACTIONS(8357), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15670] = 2,
    ACTIONS(8359), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15678] = 2,
    ACTIONS(8361), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15686] = 2,
    ACTIONS(8363), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15694] = 2,
    ACTIONS(8365), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15702] = 2,
    ACTIONS(8367), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15710] = 2,
    ACTIONS(8369), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15718] = 2,
    ACTIONS(8371), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15726] = 2,
    ACTIONS(8373), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15734] = 2,
    ACTIONS(8375), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15742] = 2,
    ACTIONS(8377), 1,
      sym__trivia_raw_env_comment,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15750] = 2,
    ACTIONS(8379), 1,
      sym__trivia_raw_env_verbatim,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15758] = 2,
    ACTIONS(8381), 1,
      sym__trivia_raw_env_listing,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15766] = 2,
    ACTIONS(8383), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15774] = 2,
    ACTIONS(8385), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15782] = 2,
    ACTIONS(8387), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15790] = 2,
    ACTIONS(8389), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15798] = 2,
    ACTIONS(8391), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15806] = 2,
    ACTIONS(8393), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15814] = 2,
    ACTIONS(8395), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15822] = 2,
    ACTIONS(8397), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15830] = 2,
    ACTIONS(8399), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15838] = 2,
    ACTIONS(8401), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15846] = 2,
    ACTIONS(8403), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15854] = 2,
    ACTIONS(8405), 1,
      sym__trivia_raw_env_pycode,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15862] = 2,
    ACTIONS(8407), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15870] = 2,
    ACTIONS(8409), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15878] = 2,
    ACTIONS(8411), 1,
      sym__trivia_raw_env_sagesilent,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15886] = 2,
    ACTIONS(8413), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15894] = 2,
    ACTIONS(8415), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15902] = 2,
    ACTIONS(8417), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15910] = 2,
    ACTIONS(8419), 1,
      sym__trivia_raw_env_sageblock,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15918] = 2,
    ACTIONS(8421), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15926] = 2,
    ACTIONS(8423), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15934] = 2,
    ACTIONS(8425), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15942] = 2,
    ACTIONS(8427), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15950] = 2,
    ACTIONS(8429), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15958] = 2,
    ACTIONS(8431), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [15966] = 2,
    ACTIONS(8433), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15974] = 2,
    ACTIONS(8435), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15982] = 2,
    ACTIONS(8437), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15990] = 2,
    ACTIONS(8439), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [15998] = 2,
    ACTIONS(8441), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16006] = 2,
    ACTIONS(8443), 1,
      sym__trivia_raw_env_comment,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16014] = 2,
    ACTIONS(8445), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [16022] = 2,
    ACTIONS(8447), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16030] = 2,
    ACTIONS(8449), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16038] = 2,
    ACTIONS(8451), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16046] = 2,
    ACTIONS(8453), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16054] = 2,
    ACTIONS(8455), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16062] = 2,
    ACTIONS(8457), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16070] = 2,
    ACTIONS(8459), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16078] = 2,
    ACTIONS(8461), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16086] = 2,
    ACTIONS(8463), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16094] = 2,
    ACTIONS(8465), 1,
      sym__trivia_raw_env_verbatim,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16102] = 2,
    ACTIONS(8467), 1,
      sym__trivia_raw_env_listing,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16110] = 2,
    ACTIONS(8469), 1,
      sym__trivia_raw_env_pycode,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16118] = 2,
    ACTIONS(8471), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16126] = 2,
    ACTIONS(8473), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16134] = 2,
    ACTIONS(8475), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16142] = 2,
    ACTIONS(8477), 1,
      sym__trivia_raw_env_sagesilent,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16150] = 2,
    ACTIONS(8479), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16158] = 2,
    ACTIONS(8481), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16166] = 2,
    ACTIONS(8483), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16174] = 2,
    ACTIONS(8485), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16182] = 2,
    ACTIONS(8487), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16190] = 2,
    ACTIONS(8489), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16198] = 2,
    ACTIONS(6624), 1,
      sym__trivia_raw_env_comment,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16206] = 2,
    ACTIONS(6620), 1,
      sym__trivia_raw_env_verbatim,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16214] = 2,
    ACTIONS(8491), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16222] = 2,
    ACTIONS(8493), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16230] = 2,
    ACTIONS(8495), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16238] = 2,
    ACTIONS(8497), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16246] = 2,
    ACTIONS(6616), 1,
      sym__trivia_raw_env_listing,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16254] = 2,
    ACTIONS(8499), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16262] = 2,
    ACTIONS(8501), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16270] = 2,
    ACTIONS(6612), 1,
      sym__trivia_raw_env_pycode,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16278] = 2,
    ACTIONS(6608), 1,
      sym__trivia_raw_env_sagesilent,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16286] = 2,
    ACTIONS(8503), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16294] = 2,
    ACTIONS(8505), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16302] = 2,
    ACTIONS(8507), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16310] = 2,
    ACTIONS(8509), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16318] = 2,
    ACTIONS(6604), 1,
      sym__trivia_raw_env_sageblock,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16326] = 2,
    ACTIONS(8511), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16334] = 2,
    ACTIONS(8513), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16342] = 2,
    ACTIONS(8515), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16350] = 2,
    ACTIONS(8517), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16358] = 2,
    ACTIONS(8519), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16366] = 2,
    ACTIONS(8521), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [16374] = 2,
    ACTIONS(8523), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16382] = 2,
    ACTIONS(8525), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16390] = 2,
    ACTIONS(8527), 1,
      sym_path,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [16398] = 2,
    ACTIONS(8529), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16406] = 2,
    ACTIONS(8531), 1,
      sym__trivia_raw_env_sageblock,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16414] = 2,
    ACTIONS(8533), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16422] = 2,
    ACTIONS(8535), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16430] = 2,
    ACTIONS(8537), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16438] = 2,
    ACTIONS(8539), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16446] = 2,
    ACTIONS(8541), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16454] = 2,
    ACTIONS(8543), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16462] = 2,
    ACTIONS(8545), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16470] = 2,
    ACTIONS(8547), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16478] = 2,
    ACTIONS(8549), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16486] = 2,
    ACTIONS(8551), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16494] = 2,
    ACTIONS(8553), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16502] = 2,
    ACTIONS(8555), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16510] = 2,
    ACTIONS(8557), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16518] = 2,
    ACTIONS(8559), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16526] = 2,
    ACTIONS(8561), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16534] = 2,
    ACTIONS(8563), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16542] = 2,
    ACTIONS(8565), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16550] = 2,
    ACTIONS(8567), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16558] = 2,
    ACTIONS(8569), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16566] = 2,
    ACTIONS(8571), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16574] = 2,
    ACTIONS(8573), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16582] = 2,
    ACTIONS(8575), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16590] = 2,
    ACTIONS(8577), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16598] = 2,
    ACTIONS(8579), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16606] = 2,
    ACTIONS(8581), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16614] = 2,
    ACTIONS(8583), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16622] = 2,
    ACTIONS(8585), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16630] = 2,
    ACTIONS(8587), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16638] = 2,
    ACTIONS(8589), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16646] = 2,
    ACTIONS(8591), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16654] = 2,
    ACTIONS(8593), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16662] = 2,
    ACTIONS(8595), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16670] = 2,
    ACTIONS(8597), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16678] = 2,
    ACTIONS(8599), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16686] = 2,
    ACTIONS(8601), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16694] = 2,
    ACTIONS(8603), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16702] = 2,
    ACTIONS(8605), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16710] = 2,
    ACTIONS(8607), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16718] = 2,
    ACTIONS(8609), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16726] = 2,
    ACTIONS(8611), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16734] = 2,
    ACTIONS(8613), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16742] = 2,
    ACTIONS(8615), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16750] = 2,
    ACTIONS(8617), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16758] = 2,
    ACTIONS(8619), 1,
      sym_uri,
    ACTIONS(7300), 2,
      sym__whitespace,
      sym_line_comment,
  [16766] = 2,
    ACTIONS(8621), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16774] = 2,
    ACTIONS(8623), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16782] = 2,
    ACTIONS(8625), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16790] = 2,
    ACTIONS(8627), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16798] = 2,
    ACTIONS(8629), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16806] = 2,
    ACTIONS(8631), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16814] = 2,
    ACTIONS(8633), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16822] = 2,
    ACTIONS(8635), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16830] = 2,
    ACTIONS(8637), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16838] = 2,
    ACTIONS(8639), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16846] = 2,
    ACTIONS(8641), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16854] = 2,
    ACTIONS(8643), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16862] = 2,
    ACTIONS(6284), 1,
      sym__trivia_raw_env_minted,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
  [16870] = 2,
    ACTIONS(8645), 1,
      sym_command_name,
    ACTIONS(3), 2,
      sym__whitespace,
      sym_line_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2072)] = 0,
  [SMALL_STATE(2073)] = 33,
  [SMALL_STATE(2074)] = 66,
  [SMALL_STATE(2075)] = 99,
  [SMALL_STATE(2076)] = 132,
  [SMALL_STATE(2077)] = 165,
  [SMALL_STATE(2078)] = 198,
  [SMALL_STATE(2079)] = 231,
  [SMALL_STATE(2080)] = 266,
  [SMALL_STATE(2081)] = 285,
  [SMALL_STATE(2082)] = 304,
  [SMALL_STATE(2083)] = 323,
  [SMALL_STATE(2084)] = 342,
  [SMALL_STATE(2085)] = 361,
  [SMALL_STATE(2086)] = 380,
  [SMALL_STATE(2087)] = 399,
  [SMALL_STATE(2088)] = 418,
  [SMALL_STATE(2089)] = 437,
  [SMALL_STATE(2090)] = 456,
  [SMALL_STATE(2091)] = 475,
  [SMALL_STATE(2092)] = 494,
  [SMALL_STATE(2093)] = 513,
  [SMALL_STATE(2094)] = 532,
  [SMALL_STATE(2095)] = 551,
  [SMALL_STATE(2096)] = 570,
  [SMALL_STATE(2097)] = 589,
  [SMALL_STATE(2098)] = 608,
  [SMALL_STATE(2099)] = 627,
  [SMALL_STATE(2100)] = 646,
  [SMALL_STATE(2101)] = 665,
  [SMALL_STATE(2102)] = 684,
  [SMALL_STATE(2103)] = 703,
  [SMALL_STATE(2104)] = 722,
  [SMALL_STATE(2105)] = 741,
  [SMALL_STATE(2106)] = 760,
  [SMALL_STATE(2107)] = 779,
  [SMALL_STATE(2108)] = 799,
  [SMALL_STATE(2109)] = 819,
  [SMALL_STATE(2110)] = 837,
  [SMALL_STATE(2111)] = 855,
  [SMALL_STATE(2112)] = 873,
  [SMALL_STATE(2113)] = 893,
  [SMALL_STATE(2114)] = 913,
  [SMALL_STATE(2115)] = 931,
  [SMALL_STATE(2116)] = 949,
  [SMALL_STATE(2117)] = 967,
  [SMALL_STATE(2118)] = 985,
  [SMALL_STATE(2119)] = 1005,
  [SMALL_STATE(2120)] = 1025,
  [SMALL_STATE(2121)] = 1043,
  [SMALL_STATE(2122)] = 1063,
  [SMALL_STATE(2123)] = 1081,
  [SMALL_STATE(2124)] = 1101,
  [SMALL_STATE(2125)] = 1121,
  [SMALL_STATE(2126)] = 1139,
  [SMALL_STATE(2127)] = 1157,
  [SMALL_STATE(2128)] = 1175,
  [SMALL_STATE(2129)] = 1193,
  [SMALL_STATE(2130)] = 1213,
  [SMALL_STATE(2131)] = 1231,
  [SMALL_STATE(2132)] = 1248,
  [SMALL_STATE(2133)] = 1265,
  [SMALL_STATE(2134)] = 1282,
  [SMALL_STATE(2135)] = 1299,
  [SMALL_STATE(2136)] = 1316,
  [SMALL_STATE(2137)] = 1333,
  [SMALL_STATE(2138)] = 1350,
  [SMALL_STATE(2139)] = 1367,
  [SMALL_STATE(2140)] = 1384,
  [SMALL_STATE(2141)] = 1401,
  [SMALL_STATE(2142)] = 1418,
  [SMALL_STATE(2143)] = 1435,
  [SMALL_STATE(2144)] = 1452,
  [SMALL_STATE(2145)] = 1469,
  [SMALL_STATE(2146)] = 1486,
  [SMALL_STATE(2147)] = 1503,
  [SMALL_STATE(2148)] = 1520,
  [SMALL_STATE(2149)] = 1537,
  [SMALL_STATE(2150)] = 1554,
  [SMALL_STATE(2151)] = 1571,
  [SMALL_STATE(2152)] = 1588,
  [SMALL_STATE(2153)] = 1605,
  [SMALL_STATE(2154)] = 1622,
  [SMALL_STATE(2155)] = 1639,
  [SMALL_STATE(2156)] = 1656,
  [SMALL_STATE(2157)] = 1673,
  [SMALL_STATE(2158)] = 1690,
  [SMALL_STATE(2159)] = 1707,
  [SMALL_STATE(2160)] = 1724,
  [SMALL_STATE(2161)] = 1741,
  [SMALL_STATE(2162)] = 1758,
  [SMALL_STATE(2163)] = 1775,
  [SMALL_STATE(2164)] = 1792,
  [SMALL_STATE(2165)] = 1809,
  [SMALL_STATE(2166)] = 1826,
  [SMALL_STATE(2167)] = 1843,
  [SMALL_STATE(2168)] = 1860,
  [SMALL_STATE(2169)] = 1877,
  [SMALL_STATE(2170)] = 1894,
  [SMALL_STATE(2171)] = 1911,
  [SMALL_STATE(2172)] = 1928,
  [SMALL_STATE(2173)] = 1945,
  [SMALL_STATE(2174)] = 1962,
  [SMALL_STATE(2175)] = 1979,
  [SMALL_STATE(2176)] = 1996,
  [SMALL_STATE(2177)] = 2013,
  [SMALL_STATE(2178)] = 2030,
  [SMALL_STATE(2179)] = 2047,
  [SMALL_STATE(2180)] = 2064,
  [SMALL_STATE(2181)] = 2081,
  [SMALL_STATE(2182)] = 2098,
  [SMALL_STATE(2183)] = 2115,
  [SMALL_STATE(2184)] = 2132,
  [SMALL_STATE(2185)] = 2149,
  [SMALL_STATE(2186)] = 2166,
  [SMALL_STATE(2187)] = 2183,
  [SMALL_STATE(2188)] = 2200,
  [SMALL_STATE(2189)] = 2217,
  [SMALL_STATE(2190)] = 2234,
  [SMALL_STATE(2191)] = 2251,
  [SMALL_STATE(2192)] = 2268,
  [SMALL_STATE(2193)] = 2285,
  [SMALL_STATE(2194)] = 2302,
  [SMALL_STATE(2195)] = 2319,
  [SMALL_STATE(2196)] = 2336,
  [SMALL_STATE(2197)] = 2353,
  [SMALL_STATE(2198)] = 2370,
  [SMALL_STATE(2199)] = 2387,
  [SMALL_STATE(2200)] = 2404,
  [SMALL_STATE(2201)] = 2421,
  [SMALL_STATE(2202)] = 2438,
  [SMALL_STATE(2203)] = 2455,
  [SMALL_STATE(2204)] = 2472,
  [SMALL_STATE(2205)] = 2489,
  [SMALL_STATE(2206)] = 2506,
  [SMALL_STATE(2207)] = 2523,
  [SMALL_STATE(2208)] = 2540,
  [SMALL_STATE(2209)] = 2557,
  [SMALL_STATE(2210)] = 2574,
  [SMALL_STATE(2211)] = 2591,
  [SMALL_STATE(2212)] = 2608,
  [SMALL_STATE(2213)] = 2625,
  [SMALL_STATE(2214)] = 2642,
  [SMALL_STATE(2215)] = 2659,
  [SMALL_STATE(2216)] = 2676,
  [SMALL_STATE(2217)] = 2693,
  [SMALL_STATE(2218)] = 2710,
  [SMALL_STATE(2219)] = 2727,
  [SMALL_STATE(2220)] = 2744,
  [SMALL_STATE(2221)] = 2761,
  [SMALL_STATE(2222)] = 2778,
  [SMALL_STATE(2223)] = 2795,
  [SMALL_STATE(2224)] = 2812,
  [SMALL_STATE(2225)] = 2829,
  [SMALL_STATE(2226)] = 2846,
  [SMALL_STATE(2227)] = 2863,
  [SMALL_STATE(2228)] = 2880,
  [SMALL_STATE(2229)] = 2897,
  [SMALL_STATE(2230)] = 2914,
  [SMALL_STATE(2231)] = 2931,
  [SMALL_STATE(2232)] = 2948,
  [SMALL_STATE(2233)] = 2965,
  [SMALL_STATE(2234)] = 2982,
  [SMALL_STATE(2235)] = 2999,
  [SMALL_STATE(2236)] = 3016,
  [SMALL_STATE(2237)] = 3033,
  [SMALL_STATE(2238)] = 3050,
  [SMALL_STATE(2239)] = 3067,
  [SMALL_STATE(2240)] = 3084,
  [SMALL_STATE(2241)] = 3101,
  [SMALL_STATE(2242)] = 3118,
  [SMALL_STATE(2243)] = 3135,
  [SMALL_STATE(2244)] = 3152,
  [SMALL_STATE(2245)] = 3169,
  [SMALL_STATE(2246)] = 3186,
  [SMALL_STATE(2247)] = 3203,
  [SMALL_STATE(2248)] = 3220,
  [SMALL_STATE(2249)] = 3237,
  [SMALL_STATE(2250)] = 3254,
  [SMALL_STATE(2251)] = 3271,
  [SMALL_STATE(2252)] = 3288,
  [SMALL_STATE(2253)] = 3305,
  [SMALL_STATE(2254)] = 3322,
  [SMALL_STATE(2255)] = 3339,
  [SMALL_STATE(2256)] = 3356,
  [SMALL_STATE(2257)] = 3373,
  [SMALL_STATE(2258)] = 3390,
  [SMALL_STATE(2259)] = 3407,
  [SMALL_STATE(2260)] = 3424,
  [SMALL_STATE(2261)] = 3441,
  [SMALL_STATE(2262)] = 3458,
  [SMALL_STATE(2263)] = 3475,
  [SMALL_STATE(2264)] = 3492,
  [SMALL_STATE(2265)] = 3509,
  [SMALL_STATE(2266)] = 3526,
  [SMALL_STATE(2267)] = 3543,
  [SMALL_STATE(2268)] = 3560,
  [SMALL_STATE(2269)] = 3577,
  [SMALL_STATE(2270)] = 3594,
  [SMALL_STATE(2271)] = 3611,
  [SMALL_STATE(2272)] = 3628,
  [SMALL_STATE(2273)] = 3645,
  [SMALL_STATE(2274)] = 3662,
  [SMALL_STATE(2275)] = 3679,
  [SMALL_STATE(2276)] = 3696,
  [SMALL_STATE(2277)] = 3713,
  [SMALL_STATE(2278)] = 3730,
  [SMALL_STATE(2279)] = 3747,
  [SMALL_STATE(2280)] = 3764,
  [SMALL_STATE(2281)] = 3781,
  [SMALL_STATE(2282)] = 3798,
  [SMALL_STATE(2283)] = 3815,
  [SMALL_STATE(2284)] = 3832,
  [SMALL_STATE(2285)] = 3849,
  [SMALL_STATE(2286)] = 3866,
  [SMALL_STATE(2287)] = 3883,
  [SMALL_STATE(2288)] = 3900,
  [SMALL_STATE(2289)] = 3917,
  [SMALL_STATE(2290)] = 3934,
  [SMALL_STATE(2291)] = 3951,
  [SMALL_STATE(2292)] = 3968,
  [SMALL_STATE(2293)] = 3985,
  [SMALL_STATE(2294)] = 4002,
  [SMALL_STATE(2295)] = 4019,
  [SMALL_STATE(2296)] = 4036,
  [SMALL_STATE(2297)] = 4053,
  [SMALL_STATE(2298)] = 4070,
  [SMALL_STATE(2299)] = 4087,
  [SMALL_STATE(2300)] = 4104,
  [SMALL_STATE(2301)] = 4121,
  [SMALL_STATE(2302)] = 4138,
  [SMALL_STATE(2303)] = 4155,
  [SMALL_STATE(2304)] = 4172,
  [SMALL_STATE(2305)] = 4189,
  [SMALL_STATE(2306)] = 4206,
  [SMALL_STATE(2307)] = 4223,
  [SMALL_STATE(2308)] = 4240,
  [SMALL_STATE(2309)] = 4257,
  [SMALL_STATE(2310)] = 4274,
  [SMALL_STATE(2311)] = 4291,
  [SMALL_STATE(2312)] = 4308,
  [SMALL_STATE(2313)] = 4325,
  [SMALL_STATE(2314)] = 4342,
  [SMALL_STATE(2315)] = 4359,
  [SMALL_STATE(2316)] = 4376,
  [SMALL_STATE(2317)] = 4393,
  [SMALL_STATE(2318)] = 4410,
  [SMALL_STATE(2319)] = 4427,
  [SMALL_STATE(2320)] = 4444,
  [SMALL_STATE(2321)] = 4461,
  [SMALL_STATE(2322)] = 4478,
  [SMALL_STATE(2323)] = 4495,
  [SMALL_STATE(2324)] = 4512,
  [SMALL_STATE(2325)] = 4529,
  [SMALL_STATE(2326)] = 4546,
  [SMALL_STATE(2327)] = 4563,
  [SMALL_STATE(2328)] = 4580,
  [SMALL_STATE(2329)] = 4597,
  [SMALL_STATE(2330)] = 4614,
  [SMALL_STATE(2331)] = 4631,
  [SMALL_STATE(2332)] = 4648,
  [SMALL_STATE(2333)] = 4665,
  [SMALL_STATE(2334)] = 4682,
  [SMALL_STATE(2335)] = 4699,
  [SMALL_STATE(2336)] = 4716,
  [SMALL_STATE(2337)] = 4733,
  [SMALL_STATE(2338)] = 4750,
  [SMALL_STATE(2339)] = 4767,
  [SMALL_STATE(2340)] = 4784,
  [SMALL_STATE(2341)] = 4801,
  [SMALL_STATE(2342)] = 4818,
  [SMALL_STATE(2343)] = 4835,
  [SMALL_STATE(2344)] = 4852,
  [SMALL_STATE(2345)] = 4869,
  [SMALL_STATE(2346)] = 4886,
  [SMALL_STATE(2347)] = 4903,
  [SMALL_STATE(2348)] = 4920,
  [SMALL_STATE(2349)] = 4937,
  [SMALL_STATE(2350)] = 4954,
  [SMALL_STATE(2351)] = 4971,
  [SMALL_STATE(2352)] = 4988,
  [SMALL_STATE(2353)] = 5002,
  [SMALL_STATE(2354)] = 5016,
  [SMALL_STATE(2355)] = 5030,
  [SMALL_STATE(2356)] = 5044,
  [SMALL_STATE(2357)] = 5058,
  [SMALL_STATE(2358)] = 5072,
  [SMALL_STATE(2359)] = 5086,
  [SMALL_STATE(2360)] = 5100,
  [SMALL_STATE(2361)] = 5114,
  [SMALL_STATE(2362)] = 5128,
  [SMALL_STATE(2363)] = 5142,
  [SMALL_STATE(2364)] = 5156,
  [SMALL_STATE(2365)] = 5166,
  [SMALL_STATE(2366)] = 5180,
  [SMALL_STATE(2367)] = 5194,
  [SMALL_STATE(2368)] = 5208,
  [SMALL_STATE(2369)] = 5222,
  [SMALL_STATE(2370)] = 5236,
  [SMALL_STATE(2371)] = 5246,
  [SMALL_STATE(2372)] = 5260,
  [SMALL_STATE(2373)] = 5274,
  [SMALL_STATE(2374)] = 5288,
  [SMALL_STATE(2375)] = 5302,
  [SMALL_STATE(2376)] = 5316,
  [SMALL_STATE(2377)] = 5330,
  [SMALL_STATE(2378)] = 5344,
  [SMALL_STATE(2379)] = 5358,
  [SMALL_STATE(2380)] = 5372,
  [SMALL_STATE(2381)] = 5386,
  [SMALL_STATE(2382)] = 5400,
  [SMALL_STATE(2383)] = 5414,
  [SMALL_STATE(2384)] = 5428,
  [SMALL_STATE(2385)] = 5438,
  [SMALL_STATE(2386)] = 5452,
  [SMALL_STATE(2387)] = 5466,
  [SMALL_STATE(2388)] = 5480,
  [SMALL_STATE(2389)] = 5494,
  [SMALL_STATE(2390)] = 5508,
  [SMALL_STATE(2391)] = 5522,
  [SMALL_STATE(2392)] = 5536,
  [SMALL_STATE(2393)] = 5550,
  [SMALL_STATE(2394)] = 5564,
  [SMALL_STATE(2395)] = 5578,
  [SMALL_STATE(2396)] = 5592,
  [SMALL_STATE(2397)] = 5606,
  [SMALL_STATE(2398)] = 5620,
  [SMALL_STATE(2399)] = 5634,
  [SMALL_STATE(2400)] = 5648,
  [SMALL_STATE(2401)] = 5662,
  [SMALL_STATE(2402)] = 5676,
  [SMALL_STATE(2403)] = 5690,
  [SMALL_STATE(2404)] = 5704,
  [SMALL_STATE(2405)] = 5718,
  [SMALL_STATE(2406)] = 5732,
  [SMALL_STATE(2407)] = 5744,
  [SMALL_STATE(2408)] = 5758,
  [SMALL_STATE(2409)] = 5770,
  [SMALL_STATE(2410)] = 5784,
  [SMALL_STATE(2411)] = 5798,
  [SMALL_STATE(2412)] = 5812,
  [SMALL_STATE(2413)] = 5824,
  [SMALL_STATE(2414)] = 5838,
  [SMALL_STATE(2415)] = 5852,
  [SMALL_STATE(2416)] = 5866,
  [SMALL_STATE(2417)] = 5880,
  [SMALL_STATE(2418)] = 5894,
  [SMALL_STATE(2419)] = 5908,
  [SMALL_STATE(2420)] = 5922,
  [SMALL_STATE(2421)] = 5936,
  [SMALL_STATE(2422)] = 5950,
  [SMALL_STATE(2423)] = 5964,
  [SMALL_STATE(2424)] = 5978,
  [SMALL_STATE(2425)] = 5992,
  [SMALL_STATE(2426)] = 6006,
  [SMALL_STATE(2427)] = 6020,
  [SMALL_STATE(2428)] = 6034,
  [SMALL_STATE(2429)] = 6048,
  [SMALL_STATE(2430)] = 6062,
  [SMALL_STATE(2431)] = 6076,
  [SMALL_STATE(2432)] = 6090,
  [SMALL_STATE(2433)] = 6104,
  [SMALL_STATE(2434)] = 6114,
  [SMALL_STATE(2435)] = 6128,
  [SMALL_STATE(2436)] = 6142,
  [SMALL_STATE(2437)] = 6156,
  [SMALL_STATE(2438)] = 6170,
  [SMALL_STATE(2439)] = 6184,
  [SMALL_STATE(2440)] = 6198,
  [SMALL_STATE(2441)] = 6212,
  [SMALL_STATE(2442)] = 6226,
  [SMALL_STATE(2443)] = 6240,
  [SMALL_STATE(2444)] = 6254,
  [SMALL_STATE(2445)] = 6268,
  [SMALL_STATE(2446)] = 6282,
  [SMALL_STATE(2447)] = 6296,
  [SMALL_STATE(2448)] = 6310,
  [SMALL_STATE(2449)] = 6324,
  [SMALL_STATE(2450)] = 6338,
  [SMALL_STATE(2451)] = 6352,
  [SMALL_STATE(2452)] = 6366,
  [SMALL_STATE(2453)] = 6380,
  [SMALL_STATE(2454)] = 6394,
  [SMALL_STATE(2455)] = 6408,
  [SMALL_STATE(2456)] = 6422,
  [SMALL_STATE(2457)] = 6436,
  [SMALL_STATE(2458)] = 6450,
  [SMALL_STATE(2459)] = 6464,
  [SMALL_STATE(2460)] = 6478,
  [SMALL_STATE(2461)] = 6492,
  [SMALL_STATE(2462)] = 6506,
  [SMALL_STATE(2463)] = 6518,
  [SMALL_STATE(2464)] = 6532,
  [SMALL_STATE(2465)] = 6546,
  [SMALL_STATE(2466)] = 6560,
  [SMALL_STATE(2467)] = 6574,
  [SMALL_STATE(2468)] = 6585,
  [SMALL_STATE(2469)] = 6596,
  [SMALL_STATE(2470)] = 6607,
  [SMALL_STATE(2471)] = 6618,
  [SMALL_STATE(2472)] = 6629,
  [SMALL_STATE(2473)] = 6640,
  [SMALL_STATE(2474)] = 6651,
  [SMALL_STATE(2475)] = 6662,
  [SMALL_STATE(2476)] = 6673,
  [SMALL_STATE(2477)] = 6684,
  [SMALL_STATE(2478)] = 6695,
  [SMALL_STATE(2479)] = 6706,
  [SMALL_STATE(2480)] = 6717,
  [SMALL_STATE(2481)] = 6728,
  [SMALL_STATE(2482)] = 6739,
  [SMALL_STATE(2483)] = 6750,
  [SMALL_STATE(2484)] = 6761,
  [SMALL_STATE(2485)] = 6772,
  [SMALL_STATE(2486)] = 6783,
  [SMALL_STATE(2487)] = 6794,
  [SMALL_STATE(2488)] = 6805,
  [SMALL_STATE(2489)] = 6816,
  [SMALL_STATE(2490)] = 6827,
  [SMALL_STATE(2491)] = 6838,
  [SMALL_STATE(2492)] = 6849,
  [SMALL_STATE(2493)] = 6860,
  [SMALL_STATE(2494)] = 6871,
  [SMALL_STATE(2495)] = 6882,
  [SMALL_STATE(2496)] = 6893,
  [SMALL_STATE(2497)] = 6904,
  [SMALL_STATE(2498)] = 6915,
  [SMALL_STATE(2499)] = 6926,
  [SMALL_STATE(2500)] = 6937,
  [SMALL_STATE(2501)] = 6948,
  [SMALL_STATE(2502)] = 6959,
  [SMALL_STATE(2503)] = 6970,
  [SMALL_STATE(2504)] = 6981,
  [SMALL_STATE(2505)] = 6992,
  [SMALL_STATE(2506)] = 7003,
  [SMALL_STATE(2507)] = 7014,
  [SMALL_STATE(2508)] = 7025,
  [SMALL_STATE(2509)] = 7036,
  [SMALL_STATE(2510)] = 7047,
  [SMALL_STATE(2511)] = 7058,
  [SMALL_STATE(2512)] = 7069,
  [SMALL_STATE(2513)] = 7080,
  [SMALL_STATE(2514)] = 7091,
  [SMALL_STATE(2515)] = 7102,
  [SMALL_STATE(2516)] = 7113,
  [SMALL_STATE(2517)] = 7124,
  [SMALL_STATE(2518)] = 7135,
  [SMALL_STATE(2519)] = 7146,
  [SMALL_STATE(2520)] = 7157,
  [SMALL_STATE(2521)] = 7168,
  [SMALL_STATE(2522)] = 7179,
  [SMALL_STATE(2523)] = 7190,
  [SMALL_STATE(2524)] = 7201,
  [SMALL_STATE(2525)] = 7210,
  [SMALL_STATE(2526)] = 7221,
  [SMALL_STATE(2527)] = 7230,
  [SMALL_STATE(2528)] = 7241,
  [SMALL_STATE(2529)] = 7250,
  [SMALL_STATE(2530)] = 7261,
  [SMALL_STATE(2531)] = 7272,
  [SMALL_STATE(2532)] = 7283,
  [SMALL_STATE(2533)] = 7294,
  [SMALL_STATE(2534)] = 7305,
  [SMALL_STATE(2535)] = 7316,
  [SMALL_STATE(2536)] = 7327,
  [SMALL_STATE(2537)] = 7338,
  [SMALL_STATE(2538)] = 7349,
  [SMALL_STATE(2539)] = 7360,
  [SMALL_STATE(2540)] = 7371,
  [SMALL_STATE(2541)] = 7382,
  [SMALL_STATE(2542)] = 7393,
  [SMALL_STATE(2543)] = 7404,
  [SMALL_STATE(2544)] = 7415,
  [SMALL_STATE(2545)] = 7426,
  [SMALL_STATE(2546)] = 7437,
  [SMALL_STATE(2547)] = 7448,
  [SMALL_STATE(2548)] = 7459,
  [SMALL_STATE(2549)] = 7470,
  [SMALL_STATE(2550)] = 7481,
  [SMALL_STATE(2551)] = 7492,
  [SMALL_STATE(2552)] = 7503,
  [SMALL_STATE(2553)] = 7514,
  [SMALL_STATE(2554)] = 7525,
  [SMALL_STATE(2555)] = 7536,
  [SMALL_STATE(2556)] = 7547,
  [SMALL_STATE(2557)] = 7558,
  [SMALL_STATE(2558)] = 7569,
  [SMALL_STATE(2559)] = 7580,
  [SMALL_STATE(2560)] = 7591,
  [SMALL_STATE(2561)] = 7602,
  [SMALL_STATE(2562)] = 7613,
  [SMALL_STATE(2563)] = 7624,
  [SMALL_STATE(2564)] = 7635,
  [SMALL_STATE(2565)] = 7646,
  [SMALL_STATE(2566)] = 7657,
  [SMALL_STATE(2567)] = 7668,
  [SMALL_STATE(2568)] = 7679,
  [SMALL_STATE(2569)] = 7690,
  [SMALL_STATE(2570)] = 7701,
  [SMALL_STATE(2571)] = 7712,
  [SMALL_STATE(2572)] = 7723,
  [SMALL_STATE(2573)] = 7734,
  [SMALL_STATE(2574)] = 7745,
  [SMALL_STATE(2575)] = 7756,
  [SMALL_STATE(2576)] = 7767,
  [SMALL_STATE(2577)] = 7778,
  [SMALL_STATE(2578)] = 7789,
  [SMALL_STATE(2579)] = 7800,
  [SMALL_STATE(2580)] = 7811,
  [SMALL_STATE(2581)] = 7822,
  [SMALL_STATE(2582)] = 7833,
  [SMALL_STATE(2583)] = 7844,
  [SMALL_STATE(2584)] = 7855,
  [SMALL_STATE(2585)] = 7866,
  [SMALL_STATE(2586)] = 7877,
  [SMALL_STATE(2587)] = 7888,
  [SMALL_STATE(2588)] = 7899,
  [SMALL_STATE(2589)] = 7910,
  [SMALL_STATE(2590)] = 7921,
  [SMALL_STATE(2591)] = 7932,
  [SMALL_STATE(2592)] = 7943,
  [SMALL_STATE(2593)] = 7954,
  [SMALL_STATE(2594)] = 7965,
  [SMALL_STATE(2595)] = 7976,
  [SMALL_STATE(2596)] = 7987,
  [SMALL_STATE(2597)] = 7998,
  [SMALL_STATE(2598)] = 8009,
  [SMALL_STATE(2599)] = 8020,
  [SMALL_STATE(2600)] = 8031,
  [SMALL_STATE(2601)] = 8042,
  [SMALL_STATE(2602)] = 8053,
  [SMALL_STATE(2603)] = 8064,
  [SMALL_STATE(2604)] = 8075,
  [SMALL_STATE(2605)] = 8086,
  [SMALL_STATE(2606)] = 8097,
  [SMALL_STATE(2607)] = 8108,
  [SMALL_STATE(2608)] = 8119,
  [SMALL_STATE(2609)] = 8130,
  [SMALL_STATE(2610)] = 8141,
  [SMALL_STATE(2611)] = 8152,
  [SMALL_STATE(2612)] = 8163,
  [SMALL_STATE(2613)] = 8174,
  [SMALL_STATE(2614)] = 8185,
  [SMALL_STATE(2615)] = 8196,
  [SMALL_STATE(2616)] = 8207,
  [SMALL_STATE(2617)] = 8218,
  [SMALL_STATE(2618)] = 8229,
  [SMALL_STATE(2619)] = 8240,
  [SMALL_STATE(2620)] = 8251,
  [SMALL_STATE(2621)] = 8262,
  [SMALL_STATE(2622)] = 8273,
  [SMALL_STATE(2623)] = 8284,
  [SMALL_STATE(2624)] = 8295,
  [SMALL_STATE(2625)] = 8306,
  [SMALL_STATE(2626)] = 8317,
  [SMALL_STATE(2627)] = 8328,
  [SMALL_STATE(2628)] = 8339,
  [SMALL_STATE(2629)] = 8350,
  [SMALL_STATE(2630)] = 8361,
  [SMALL_STATE(2631)] = 8372,
  [SMALL_STATE(2632)] = 8383,
  [SMALL_STATE(2633)] = 8394,
  [SMALL_STATE(2634)] = 8405,
  [SMALL_STATE(2635)] = 8416,
  [SMALL_STATE(2636)] = 8427,
  [SMALL_STATE(2637)] = 8438,
  [SMALL_STATE(2638)] = 8449,
  [SMALL_STATE(2639)] = 8460,
  [SMALL_STATE(2640)] = 8471,
  [SMALL_STATE(2641)] = 8482,
  [SMALL_STATE(2642)] = 8493,
  [SMALL_STATE(2643)] = 8504,
  [SMALL_STATE(2644)] = 8515,
  [SMALL_STATE(2645)] = 8526,
  [SMALL_STATE(2646)] = 8537,
  [SMALL_STATE(2647)] = 8548,
  [SMALL_STATE(2648)] = 8559,
  [SMALL_STATE(2649)] = 8570,
  [SMALL_STATE(2650)] = 8581,
  [SMALL_STATE(2651)] = 8592,
  [SMALL_STATE(2652)] = 8603,
  [SMALL_STATE(2653)] = 8614,
  [SMALL_STATE(2654)] = 8625,
  [SMALL_STATE(2655)] = 8636,
  [SMALL_STATE(2656)] = 8647,
  [SMALL_STATE(2657)] = 8658,
  [SMALL_STATE(2658)] = 8669,
  [SMALL_STATE(2659)] = 8678,
  [SMALL_STATE(2660)] = 8689,
  [SMALL_STATE(2661)] = 8700,
  [SMALL_STATE(2662)] = 8711,
  [SMALL_STATE(2663)] = 8722,
  [SMALL_STATE(2664)] = 8733,
  [SMALL_STATE(2665)] = 8744,
  [SMALL_STATE(2666)] = 8755,
  [SMALL_STATE(2667)] = 8766,
  [SMALL_STATE(2668)] = 8777,
  [SMALL_STATE(2669)] = 8788,
  [SMALL_STATE(2670)] = 8799,
  [SMALL_STATE(2671)] = 8810,
  [SMALL_STATE(2672)] = 8821,
  [SMALL_STATE(2673)] = 8832,
  [SMALL_STATE(2674)] = 8843,
  [SMALL_STATE(2675)] = 8854,
  [SMALL_STATE(2676)] = 8865,
  [SMALL_STATE(2677)] = 8876,
  [SMALL_STATE(2678)] = 8887,
  [SMALL_STATE(2679)] = 8898,
  [SMALL_STATE(2680)] = 8909,
  [SMALL_STATE(2681)] = 8920,
  [SMALL_STATE(2682)] = 8931,
  [SMALL_STATE(2683)] = 8942,
  [SMALL_STATE(2684)] = 8953,
  [SMALL_STATE(2685)] = 8964,
  [SMALL_STATE(2686)] = 8975,
  [SMALL_STATE(2687)] = 8986,
  [SMALL_STATE(2688)] = 8997,
  [SMALL_STATE(2689)] = 9008,
  [SMALL_STATE(2690)] = 9019,
  [SMALL_STATE(2691)] = 9030,
  [SMALL_STATE(2692)] = 9041,
  [SMALL_STATE(2693)] = 9052,
  [SMALL_STATE(2694)] = 9063,
  [SMALL_STATE(2695)] = 9074,
  [SMALL_STATE(2696)] = 9085,
  [SMALL_STATE(2697)] = 9096,
  [SMALL_STATE(2698)] = 9107,
  [SMALL_STATE(2699)] = 9118,
  [SMALL_STATE(2700)] = 9129,
  [SMALL_STATE(2701)] = 9140,
  [SMALL_STATE(2702)] = 9151,
  [SMALL_STATE(2703)] = 9162,
  [SMALL_STATE(2704)] = 9173,
  [SMALL_STATE(2705)] = 9184,
  [SMALL_STATE(2706)] = 9195,
  [SMALL_STATE(2707)] = 9206,
  [SMALL_STATE(2708)] = 9217,
  [SMALL_STATE(2709)] = 9228,
  [SMALL_STATE(2710)] = 9239,
  [SMALL_STATE(2711)] = 9250,
  [SMALL_STATE(2712)] = 9261,
  [SMALL_STATE(2713)] = 9272,
  [SMALL_STATE(2714)] = 9283,
  [SMALL_STATE(2715)] = 9294,
  [SMALL_STATE(2716)] = 9305,
  [SMALL_STATE(2717)] = 9316,
  [SMALL_STATE(2718)] = 9327,
  [SMALL_STATE(2719)] = 9338,
  [SMALL_STATE(2720)] = 9349,
  [SMALL_STATE(2721)] = 9360,
  [SMALL_STATE(2722)] = 9371,
  [SMALL_STATE(2723)] = 9382,
  [SMALL_STATE(2724)] = 9393,
  [SMALL_STATE(2725)] = 9404,
  [SMALL_STATE(2726)] = 9415,
  [SMALL_STATE(2727)] = 9426,
  [SMALL_STATE(2728)] = 9437,
  [SMALL_STATE(2729)] = 9448,
  [SMALL_STATE(2730)] = 9459,
  [SMALL_STATE(2731)] = 9470,
  [SMALL_STATE(2732)] = 9481,
  [SMALL_STATE(2733)] = 9492,
  [SMALL_STATE(2734)] = 9503,
  [SMALL_STATE(2735)] = 9514,
  [SMALL_STATE(2736)] = 9525,
  [SMALL_STATE(2737)] = 9536,
  [SMALL_STATE(2738)] = 9547,
  [SMALL_STATE(2739)] = 9558,
  [SMALL_STATE(2740)] = 9569,
  [SMALL_STATE(2741)] = 9580,
  [SMALL_STATE(2742)] = 9591,
  [SMALL_STATE(2743)] = 9602,
  [SMALL_STATE(2744)] = 9613,
  [SMALL_STATE(2745)] = 9624,
  [SMALL_STATE(2746)] = 9635,
  [SMALL_STATE(2747)] = 9646,
  [SMALL_STATE(2748)] = 9657,
  [SMALL_STATE(2749)] = 9668,
  [SMALL_STATE(2750)] = 9679,
  [SMALL_STATE(2751)] = 9690,
  [SMALL_STATE(2752)] = 9701,
  [SMALL_STATE(2753)] = 9712,
  [SMALL_STATE(2754)] = 9723,
  [SMALL_STATE(2755)] = 9734,
  [SMALL_STATE(2756)] = 9745,
  [SMALL_STATE(2757)] = 9756,
  [SMALL_STATE(2758)] = 9767,
  [SMALL_STATE(2759)] = 9778,
  [SMALL_STATE(2760)] = 9789,
  [SMALL_STATE(2761)] = 9800,
  [SMALL_STATE(2762)] = 9811,
  [SMALL_STATE(2763)] = 9822,
  [SMALL_STATE(2764)] = 9833,
  [SMALL_STATE(2765)] = 9844,
  [SMALL_STATE(2766)] = 9855,
  [SMALL_STATE(2767)] = 9866,
  [SMALL_STATE(2768)] = 9877,
  [SMALL_STATE(2769)] = 9888,
  [SMALL_STATE(2770)] = 9899,
  [SMALL_STATE(2771)] = 9910,
  [SMALL_STATE(2772)] = 9921,
  [SMALL_STATE(2773)] = 9932,
  [SMALL_STATE(2774)] = 9943,
  [SMALL_STATE(2775)] = 9954,
  [SMALL_STATE(2776)] = 9965,
  [SMALL_STATE(2777)] = 9976,
  [SMALL_STATE(2778)] = 9987,
  [SMALL_STATE(2779)] = 9998,
  [SMALL_STATE(2780)] = 10009,
  [SMALL_STATE(2781)] = 10020,
  [SMALL_STATE(2782)] = 10031,
  [SMALL_STATE(2783)] = 10042,
  [SMALL_STATE(2784)] = 10053,
  [SMALL_STATE(2785)] = 10064,
  [SMALL_STATE(2786)] = 10075,
  [SMALL_STATE(2787)] = 10086,
  [SMALL_STATE(2788)] = 10097,
  [SMALL_STATE(2789)] = 10108,
  [SMALL_STATE(2790)] = 10119,
  [SMALL_STATE(2791)] = 10130,
  [SMALL_STATE(2792)] = 10141,
  [SMALL_STATE(2793)] = 10152,
  [SMALL_STATE(2794)] = 10163,
  [SMALL_STATE(2795)] = 10174,
  [SMALL_STATE(2796)] = 10185,
  [SMALL_STATE(2797)] = 10196,
  [SMALL_STATE(2798)] = 10207,
  [SMALL_STATE(2799)] = 10218,
  [SMALL_STATE(2800)] = 10229,
  [SMALL_STATE(2801)] = 10240,
  [SMALL_STATE(2802)] = 10251,
  [SMALL_STATE(2803)] = 10262,
  [SMALL_STATE(2804)] = 10273,
  [SMALL_STATE(2805)] = 10284,
  [SMALL_STATE(2806)] = 10295,
  [SMALL_STATE(2807)] = 10306,
  [SMALL_STATE(2808)] = 10317,
  [SMALL_STATE(2809)] = 10328,
  [SMALL_STATE(2810)] = 10339,
  [SMALL_STATE(2811)] = 10350,
  [SMALL_STATE(2812)] = 10361,
  [SMALL_STATE(2813)] = 10372,
  [SMALL_STATE(2814)] = 10383,
  [SMALL_STATE(2815)] = 10394,
  [SMALL_STATE(2816)] = 10405,
  [SMALL_STATE(2817)] = 10416,
  [SMALL_STATE(2818)] = 10427,
  [SMALL_STATE(2819)] = 10438,
  [SMALL_STATE(2820)] = 10449,
  [SMALL_STATE(2821)] = 10460,
  [SMALL_STATE(2822)] = 10471,
  [SMALL_STATE(2823)] = 10482,
  [SMALL_STATE(2824)] = 10493,
  [SMALL_STATE(2825)] = 10504,
  [SMALL_STATE(2826)] = 10515,
  [SMALL_STATE(2827)] = 10526,
  [SMALL_STATE(2828)] = 10537,
  [SMALL_STATE(2829)] = 10548,
  [SMALL_STATE(2830)] = 10559,
  [SMALL_STATE(2831)] = 10570,
  [SMALL_STATE(2832)] = 10581,
  [SMALL_STATE(2833)] = 10592,
  [SMALL_STATE(2834)] = 10603,
  [SMALL_STATE(2835)] = 10614,
  [SMALL_STATE(2836)] = 10625,
  [SMALL_STATE(2837)] = 10636,
  [SMALL_STATE(2838)] = 10647,
  [SMALL_STATE(2839)] = 10658,
  [SMALL_STATE(2840)] = 10669,
  [SMALL_STATE(2841)] = 10680,
  [SMALL_STATE(2842)] = 10691,
  [SMALL_STATE(2843)] = 10702,
  [SMALL_STATE(2844)] = 10713,
  [SMALL_STATE(2845)] = 10724,
  [SMALL_STATE(2846)] = 10735,
  [SMALL_STATE(2847)] = 10746,
  [SMALL_STATE(2848)] = 10757,
  [SMALL_STATE(2849)] = 10768,
  [SMALL_STATE(2850)] = 10779,
  [SMALL_STATE(2851)] = 10790,
  [SMALL_STATE(2852)] = 10801,
  [SMALL_STATE(2853)] = 10812,
  [SMALL_STATE(2854)] = 10823,
  [SMALL_STATE(2855)] = 10834,
  [SMALL_STATE(2856)] = 10845,
  [SMALL_STATE(2857)] = 10856,
  [SMALL_STATE(2858)] = 10867,
  [SMALL_STATE(2859)] = 10878,
  [SMALL_STATE(2860)] = 10889,
  [SMALL_STATE(2861)] = 10900,
  [SMALL_STATE(2862)] = 10911,
  [SMALL_STATE(2863)] = 10922,
  [SMALL_STATE(2864)] = 10933,
  [SMALL_STATE(2865)] = 10944,
  [SMALL_STATE(2866)] = 10955,
  [SMALL_STATE(2867)] = 10966,
  [SMALL_STATE(2868)] = 10977,
  [SMALL_STATE(2869)] = 10988,
  [SMALL_STATE(2870)] = 10999,
  [SMALL_STATE(2871)] = 11010,
  [SMALL_STATE(2872)] = 11021,
  [SMALL_STATE(2873)] = 11032,
  [SMALL_STATE(2874)] = 11043,
  [SMALL_STATE(2875)] = 11054,
  [SMALL_STATE(2876)] = 11065,
  [SMALL_STATE(2877)] = 11076,
  [SMALL_STATE(2878)] = 11087,
  [SMALL_STATE(2879)] = 11098,
  [SMALL_STATE(2880)] = 11109,
  [SMALL_STATE(2881)] = 11120,
  [SMALL_STATE(2882)] = 11131,
  [SMALL_STATE(2883)] = 11142,
  [SMALL_STATE(2884)] = 11153,
  [SMALL_STATE(2885)] = 11164,
  [SMALL_STATE(2886)] = 11175,
  [SMALL_STATE(2887)] = 11186,
  [SMALL_STATE(2888)] = 11197,
  [SMALL_STATE(2889)] = 11208,
  [SMALL_STATE(2890)] = 11219,
  [SMALL_STATE(2891)] = 11230,
  [SMALL_STATE(2892)] = 11241,
  [SMALL_STATE(2893)] = 11252,
  [SMALL_STATE(2894)] = 11263,
  [SMALL_STATE(2895)] = 11274,
  [SMALL_STATE(2896)] = 11285,
  [SMALL_STATE(2897)] = 11296,
  [SMALL_STATE(2898)] = 11307,
  [SMALL_STATE(2899)] = 11318,
  [SMALL_STATE(2900)] = 11329,
  [SMALL_STATE(2901)] = 11340,
  [SMALL_STATE(2902)] = 11351,
  [SMALL_STATE(2903)] = 11362,
  [SMALL_STATE(2904)] = 11373,
  [SMALL_STATE(2905)] = 11384,
  [SMALL_STATE(2906)] = 11395,
  [SMALL_STATE(2907)] = 11406,
  [SMALL_STATE(2908)] = 11417,
  [SMALL_STATE(2909)] = 11428,
  [SMALL_STATE(2910)] = 11439,
  [SMALL_STATE(2911)] = 11450,
  [SMALL_STATE(2912)] = 11461,
  [SMALL_STATE(2913)] = 11472,
  [SMALL_STATE(2914)] = 11483,
  [SMALL_STATE(2915)] = 11494,
  [SMALL_STATE(2916)] = 11505,
  [SMALL_STATE(2917)] = 11516,
  [SMALL_STATE(2918)] = 11527,
  [SMALL_STATE(2919)] = 11538,
  [SMALL_STATE(2920)] = 11549,
  [SMALL_STATE(2921)] = 11560,
  [SMALL_STATE(2922)] = 11571,
  [SMALL_STATE(2923)] = 11582,
  [SMALL_STATE(2924)] = 11593,
  [SMALL_STATE(2925)] = 11604,
  [SMALL_STATE(2926)] = 11615,
  [SMALL_STATE(2927)] = 11626,
  [SMALL_STATE(2928)] = 11637,
  [SMALL_STATE(2929)] = 11648,
  [SMALL_STATE(2930)] = 11659,
  [SMALL_STATE(2931)] = 11670,
  [SMALL_STATE(2932)] = 11681,
  [SMALL_STATE(2933)] = 11692,
  [SMALL_STATE(2934)] = 11703,
  [SMALL_STATE(2935)] = 11714,
  [SMALL_STATE(2936)] = 11725,
  [SMALL_STATE(2937)] = 11736,
  [SMALL_STATE(2938)] = 11747,
  [SMALL_STATE(2939)] = 11758,
  [SMALL_STATE(2940)] = 11769,
  [SMALL_STATE(2941)] = 11780,
  [SMALL_STATE(2942)] = 11791,
  [SMALL_STATE(2943)] = 11802,
  [SMALL_STATE(2944)] = 11813,
  [SMALL_STATE(2945)] = 11824,
  [SMALL_STATE(2946)] = 11835,
  [SMALL_STATE(2947)] = 11846,
  [SMALL_STATE(2948)] = 11857,
  [SMALL_STATE(2949)] = 11868,
  [SMALL_STATE(2950)] = 11879,
  [SMALL_STATE(2951)] = 11890,
  [SMALL_STATE(2952)] = 11901,
  [SMALL_STATE(2953)] = 11912,
  [SMALL_STATE(2954)] = 11923,
  [SMALL_STATE(2955)] = 11934,
  [SMALL_STATE(2956)] = 11945,
  [SMALL_STATE(2957)] = 11956,
  [SMALL_STATE(2958)] = 11967,
  [SMALL_STATE(2959)] = 11978,
  [SMALL_STATE(2960)] = 11989,
  [SMALL_STATE(2961)] = 12000,
  [SMALL_STATE(2962)] = 12011,
  [SMALL_STATE(2963)] = 12022,
  [SMALL_STATE(2964)] = 12033,
  [SMALL_STATE(2965)] = 12044,
  [SMALL_STATE(2966)] = 12055,
  [SMALL_STATE(2967)] = 12066,
  [SMALL_STATE(2968)] = 12077,
  [SMALL_STATE(2969)] = 12088,
  [SMALL_STATE(2970)] = 12099,
  [SMALL_STATE(2971)] = 12110,
  [SMALL_STATE(2972)] = 12121,
  [SMALL_STATE(2973)] = 12132,
  [SMALL_STATE(2974)] = 12143,
  [SMALL_STATE(2975)] = 12154,
  [SMALL_STATE(2976)] = 12165,
  [SMALL_STATE(2977)] = 12176,
  [SMALL_STATE(2978)] = 12187,
  [SMALL_STATE(2979)] = 12198,
  [SMALL_STATE(2980)] = 12209,
  [SMALL_STATE(2981)] = 12220,
  [SMALL_STATE(2982)] = 12231,
  [SMALL_STATE(2983)] = 12242,
  [SMALL_STATE(2984)] = 12253,
  [SMALL_STATE(2985)] = 12264,
  [SMALL_STATE(2986)] = 12275,
  [SMALL_STATE(2987)] = 12286,
  [SMALL_STATE(2988)] = 12297,
  [SMALL_STATE(2989)] = 12308,
  [SMALL_STATE(2990)] = 12319,
  [SMALL_STATE(2991)] = 12330,
  [SMALL_STATE(2992)] = 12341,
  [SMALL_STATE(2993)] = 12352,
  [SMALL_STATE(2994)] = 12363,
  [SMALL_STATE(2995)] = 12374,
  [SMALL_STATE(2996)] = 12385,
  [SMALL_STATE(2997)] = 12396,
  [SMALL_STATE(2998)] = 12407,
  [SMALL_STATE(2999)] = 12418,
  [SMALL_STATE(3000)] = 12429,
  [SMALL_STATE(3001)] = 12440,
  [SMALL_STATE(3002)] = 12451,
  [SMALL_STATE(3003)] = 12462,
  [SMALL_STATE(3004)] = 12473,
  [SMALL_STATE(3005)] = 12484,
  [SMALL_STATE(3006)] = 12495,
  [SMALL_STATE(3007)] = 12506,
  [SMALL_STATE(3008)] = 12517,
  [SMALL_STATE(3009)] = 12528,
  [SMALL_STATE(3010)] = 12539,
  [SMALL_STATE(3011)] = 12550,
  [SMALL_STATE(3012)] = 12561,
  [SMALL_STATE(3013)] = 12572,
  [SMALL_STATE(3014)] = 12583,
  [SMALL_STATE(3015)] = 12594,
  [SMALL_STATE(3016)] = 12605,
  [SMALL_STATE(3017)] = 12616,
  [SMALL_STATE(3018)] = 12627,
  [SMALL_STATE(3019)] = 12638,
  [SMALL_STATE(3020)] = 12649,
  [SMALL_STATE(3021)] = 12660,
  [SMALL_STATE(3022)] = 12671,
  [SMALL_STATE(3023)] = 12682,
  [SMALL_STATE(3024)] = 12693,
  [SMALL_STATE(3025)] = 12704,
  [SMALL_STATE(3026)] = 12715,
  [SMALL_STATE(3027)] = 12726,
  [SMALL_STATE(3028)] = 12737,
  [SMALL_STATE(3029)] = 12748,
  [SMALL_STATE(3030)] = 12759,
  [SMALL_STATE(3031)] = 12770,
  [SMALL_STATE(3032)] = 12781,
  [SMALL_STATE(3033)] = 12792,
  [SMALL_STATE(3034)] = 12803,
  [SMALL_STATE(3035)] = 12814,
  [SMALL_STATE(3036)] = 12825,
  [SMALL_STATE(3037)] = 12836,
  [SMALL_STATE(3038)] = 12847,
  [SMALL_STATE(3039)] = 12858,
  [SMALL_STATE(3040)] = 12869,
  [SMALL_STATE(3041)] = 12880,
  [SMALL_STATE(3042)] = 12891,
  [SMALL_STATE(3043)] = 12902,
  [SMALL_STATE(3044)] = 12913,
  [SMALL_STATE(3045)] = 12924,
  [SMALL_STATE(3046)] = 12935,
  [SMALL_STATE(3047)] = 12946,
  [SMALL_STATE(3048)] = 12957,
  [SMALL_STATE(3049)] = 12968,
  [SMALL_STATE(3050)] = 12979,
  [SMALL_STATE(3051)] = 12990,
  [SMALL_STATE(3052)] = 13001,
  [SMALL_STATE(3053)] = 13012,
  [SMALL_STATE(3054)] = 13023,
  [SMALL_STATE(3055)] = 13034,
  [SMALL_STATE(3056)] = 13045,
  [SMALL_STATE(3057)] = 13056,
  [SMALL_STATE(3058)] = 13067,
  [SMALL_STATE(3059)] = 13078,
  [SMALL_STATE(3060)] = 13089,
  [SMALL_STATE(3061)] = 13100,
  [SMALL_STATE(3062)] = 13111,
  [SMALL_STATE(3063)] = 13122,
  [SMALL_STATE(3064)] = 13133,
  [SMALL_STATE(3065)] = 13144,
  [SMALL_STATE(3066)] = 13155,
  [SMALL_STATE(3067)] = 13166,
  [SMALL_STATE(3068)] = 13177,
  [SMALL_STATE(3069)] = 13188,
  [SMALL_STATE(3070)] = 13199,
  [SMALL_STATE(3071)] = 13210,
  [SMALL_STATE(3072)] = 13221,
  [SMALL_STATE(3073)] = 13232,
  [SMALL_STATE(3074)] = 13243,
  [SMALL_STATE(3075)] = 13254,
  [SMALL_STATE(3076)] = 13265,
  [SMALL_STATE(3077)] = 13276,
  [SMALL_STATE(3078)] = 13287,
  [SMALL_STATE(3079)] = 13298,
  [SMALL_STATE(3080)] = 13309,
  [SMALL_STATE(3081)] = 13320,
  [SMALL_STATE(3082)] = 13331,
  [SMALL_STATE(3083)] = 13342,
  [SMALL_STATE(3084)] = 13353,
  [SMALL_STATE(3085)] = 13364,
  [SMALL_STATE(3086)] = 13375,
  [SMALL_STATE(3087)] = 13386,
  [SMALL_STATE(3088)] = 13397,
  [SMALL_STATE(3089)] = 13408,
  [SMALL_STATE(3090)] = 13419,
  [SMALL_STATE(3091)] = 13430,
  [SMALL_STATE(3092)] = 13441,
  [SMALL_STATE(3093)] = 13452,
  [SMALL_STATE(3094)] = 13463,
  [SMALL_STATE(3095)] = 13474,
  [SMALL_STATE(3096)] = 13485,
  [SMALL_STATE(3097)] = 13496,
  [SMALL_STATE(3098)] = 13507,
  [SMALL_STATE(3099)] = 13518,
  [SMALL_STATE(3100)] = 13529,
  [SMALL_STATE(3101)] = 13540,
  [SMALL_STATE(3102)] = 13551,
  [SMALL_STATE(3103)] = 13562,
  [SMALL_STATE(3104)] = 13573,
  [SMALL_STATE(3105)] = 13584,
  [SMALL_STATE(3106)] = 13595,
  [SMALL_STATE(3107)] = 13606,
  [SMALL_STATE(3108)] = 13617,
  [SMALL_STATE(3109)] = 13628,
  [SMALL_STATE(3110)] = 13639,
  [SMALL_STATE(3111)] = 13650,
  [SMALL_STATE(3112)] = 13661,
  [SMALL_STATE(3113)] = 13672,
  [SMALL_STATE(3114)] = 13683,
  [SMALL_STATE(3115)] = 13694,
  [SMALL_STATE(3116)] = 13705,
  [SMALL_STATE(3117)] = 13716,
  [SMALL_STATE(3118)] = 13727,
  [SMALL_STATE(3119)] = 13738,
  [SMALL_STATE(3120)] = 13749,
  [SMALL_STATE(3121)] = 13760,
  [SMALL_STATE(3122)] = 13771,
  [SMALL_STATE(3123)] = 13782,
  [SMALL_STATE(3124)] = 13793,
  [SMALL_STATE(3125)] = 13804,
  [SMALL_STATE(3126)] = 13815,
  [SMALL_STATE(3127)] = 13826,
  [SMALL_STATE(3128)] = 13837,
  [SMALL_STATE(3129)] = 13848,
  [SMALL_STATE(3130)] = 13859,
  [SMALL_STATE(3131)] = 13870,
  [SMALL_STATE(3132)] = 13881,
  [SMALL_STATE(3133)] = 13892,
  [SMALL_STATE(3134)] = 13903,
  [SMALL_STATE(3135)] = 13914,
  [SMALL_STATE(3136)] = 13925,
  [SMALL_STATE(3137)] = 13936,
  [SMALL_STATE(3138)] = 13947,
  [SMALL_STATE(3139)] = 13958,
  [SMALL_STATE(3140)] = 13969,
  [SMALL_STATE(3141)] = 13980,
  [SMALL_STATE(3142)] = 13991,
  [SMALL_STATE(3143)] = 14002,
  [SMALL_STATE(3144)] = 14013,
  [SMALL_STATE(3145)] = 14024,
  [SMALL_STATE(3146)] = 14035,
  [SMALL_STATE(3147)] = 14046,
  [SMALL_STATE(3148)] = 14057,
  [SMALL_STATE(3149)] = 14068,
  [SMALL_STATE(3150)] = 14079,
  [SMALL_STATE(3151)] = 14090,
  [SMALL_STATE(3152)] = 14101,
  [SMALL_STATE(3153)] = 14112,
  [SMALL_STATE(3154)] = 14123,
  [SMALL_STATE(3155)] = 14134,
  [SMALL_STATE(3156)] = 14145,
  [SMALL_STATE(3157)] = 14156,
  [SMALL_STATE(3158)] = 14167,
  [SMALL_STATE(3159)] = 14178,
  [SMALL_STATE(3160)] = 14189,
  [SMALL_STATE(3161)] = 14200,
  [SMALL_STATE(3162)] = 14211,
  [SMALL_STATE(3163)] = 14222,
  [SMALL_STATE(3164)] = 14233,
  [SMALL_STATE(3165)] = 14244,
  [SMALL_STATE(3166)] = 14255,
  [SMALL_STATE(3167)] = 14266,
  [SMALL_STATE(3168)] = 14277,
  [SMALL_STATE(3169)] = 14288,
  [SMALL_STATE(3170)] = 14299,
  [SMALL_STATE(3171)] = 14310,
  [SMALL_STATE(3172)] = 14321,
  [SMALL_STATE(3173)] = 14332,
  [SMALL_STATE(3174)] = 14343,
  [SMALL_STATE(3175)] = 14354,
  [SMALL_STATE(3176)] = 14365,
  [SMALL_STATE(3177)] = 14376,
  [SMALL_STATE(3178)] = 14387,
  [SMALL_STATE(3179)] = 14398,
  [SMALL_STATE(3180)] = 14409,
  [SMALL_STATE(3181)] = 14420,
  [SMALL_STATE(3182)] = 14431,
  [SMALL_STATE(3183)] = 14442,
  [SMALL_STATE(3184)] = 14453,
  [SMALL_STATE(3185)] = 14464,
  [SMALL_STATE(3186)] = 14475,
  [SMALL_STATE(3187)] = 14486,
  [SMALL_STATE(3188)] = 14497,
  [SMALL_STATE(3189)] = 14508,
  [SMALL_STATE(3190)] = 14519,
  [SMALL_STATE(3191)] = 14530,
  [SMALL_STATE(3192)] = 14541,
  [SMALL_STATE(3193)] = 14552,
  [SMALL_STATE(3194)] = 14563,
  [SMALL_STATE(3195)] = 14574,
  [SMALL_STATE(3196)] = 14585,
  [SMALL_STATE(3197)] = 14596,
  [SMALL_STATE(3198)] = 14607,
  [SMALL_STATE(3199)] = 14618,
  [SMALL_STATE(3200)] = 14629,
  [SMALL_STATE(3201)] = 14640,
  [SMALL_STATE(3202)] = 14651,
  [SMALL_STATE(3203)] = 14662,
  [SMALL_STATE(3204)] = 14673,
  [SMALL_STATE(3205)] = 14684,
  [SMALL_STATE(3206)] = 14695,
  [SMALL_STATE(3207)] = 14706,
  [SMALL_STATE(3208)] = 14717,
  [SMALL_STATE(3209)] = 14728,
  [SMALL_STATE(3210)] = 14739,
  [SMALL_STATE(3211)] = 14750,
  [SMALL_STATE(3212)] = 14761,
  [SMALL_STATE(3213)] = 14772,
  [SMALL_STATE(3214)] = 14783,
  [SMALL_STATE(3215)] = 14794,
  [SMALL_STATE(3216)] = 14805,
  [SMALL_STATE(3217)] = 14816,
  [SMALL_STATE(3218)] = 14827,
  [SMALL_STATE(3219)] = 14838,
  [SMALL_STATE(3220)] = 14849,
  [SMALL_STATE(3221)] = 14860,
  [SMALL_STATE(3222)] = 14871,
  [SMALL_STATE(3223)] = 14882,
  [SMALL_STATE(3224)] = 14893,
  [SMALL_STATE(3225)] = 14904,
  [SMALL_STATE(3226)] = 14915,
  [SMALL_STATE(3227)] = 14926,
  [SMALL_STATE(3228)] = 14934,
  [SMALL_STATE(3229)] = 14942,
  [SMALL_STATE(3230)] = 14950,
  [SMALL_STATE(3231)] = 14958,
  [SMALL_STATE(3232)] = 14966,
  [SMALL_STATE(3233)] = 14974,
  [SMALL_STATE(3234)] = 14982,
  [SMALL_STATE(3235)] = 14990,
  [SMALL_STATE(3236)] = 14998,
  [SMALL_STATE(3237)] = 15006,
  [SMALL_STATE(3238)] = 15014,
  [SMALL_STATE(3239)] = 15022,
  [SMALL_STATE(3240)] = 15030,
  [SMALL_STATE(3241)] = 15038,
  [SMALL_STATE(3242)] = 15046,
  [SMALL_STATE(3243)] = 15054,
  [SMALL_STATE(3244)] = 15062,
  [SMALL_STATE(3245)] = 15070,
  [SMALL_STATE(3246)] = 15078,
  [SMALL_STATE(3247)] = 15086,
  [SMALL_STATE(3248)] = 15094,
  [SMALL_STATE(3249)] = 15102,
  [SMALL_STATE(3250)] = 15110,
  [SMALL_STATE(3251)] = 15118,
  [SMALL_STATE(3252)] = 15126,
  [SMALL_STATE(3253)] = 15134,
  [SMALL_STATE(3254)] = 15142,
  [SMALL_STATE(3255)] = 15150,
  [SMALL_STATE(3256)] = 15158,
  [SMALL_STATE(3257)] = 15166,
  [SMALL_STATE(3258)] = 15174,
  [SMALL_STATE(3259)] = 15182,
  [SMALL_STATE(3260)] = 15190,
  [SMALL_STATE(3261)] = 15198,
  [SMALL_STATE(3262)] = 15206,
  [SMALL_STATE(3263)] = 15214,
  [SMALL_STATE(3264)] = 15222,
  [SMALL_STATE(3265)] = 15230,
  [SMALL_STATE(3266)] = 15238,
  [SMALL_STATE(3267)] = 15246,
  [SMALL_STATE(3268)] = 15254,
  [SMALL_STATE(3269)] = 15262,
  [SMALL_STATE(3270)] = 15270,
  [SMALL_STATE(3271)] = 15278,
  [SMALL_STATE(3272)] = 15286,
  [SMALL_STATE(3273)] = 15294,
  [SMALL_STATE(3274)] = 15302,
  [SMALL_STATE(3275)] = 15310,
  [SMALL_STATE(3276)] = 15318,
  [SMALL_STATE(3277)] = 15326,
  [SMALL_STATE(3278)] = 15334,
  [SMALL_STATE(3279)] = 15342,
  [SMALL_STATE(3280)] = 15350,
  [SMALL_STATE(3281)] = 15358,
  [SMALL_STATE(3282)] = 15366,
  [SMALL_STATE(3283)] = 15374,
  [SMALL_STATE(3284)] = 15382,
  [SMALL_STATE(3285)] = 15390,
  [SMALL_STATE(3286)] = 15398,
  [SMALL_STATE(3287)] = 15406,
  [SMALL_STATE(3288)] = 15414,
  [SMALL_STATE(3289)] = 15422,
  [SMALL_STATE(3290)] = 15430,
  [SMALL_STATE(3291)] = 15438,
  [SMALL_STATE(3292)] = 15446,
  [SMALL_STATE(3293)] = 15454,
  [SMALL_STATE(3294)] = 15462,
  [SMALL_STATE(3295)] = 15470,
  [SMALL_STATE(3296)] = 15478,
  [SMALL_STATE(3297)] = 15486,
  [SMALL_STATE(3298)] = 15494,
  [SMALL_STATE(3299)] = 15502,
  [SMALL_STATE(3300)] = 15510,
  [SMALL_STATE(3301)] = 15518,
  [SMALL_STATE(3302)] = 15526,
  [SMALL_STATE(3303)] = 15534,
  [SMALL_STATE(3304)] = 15542,
  [SMALL_STATE(3305)] = 15550,
  [SMALL_STATE(3306)] = 15558,
  [SMALL_STATE(3307)] = 15566,
  [SMALL_STATE(3308)] = 15574,
  [SMALL_STATE(3309)] = 15582,
  [SMALL_STATE(3310)] = 15590,
  [SMALL_STATE(3311)] = 15598,
  [SMALL_STATE(3312)] = 15606,
  [SMALL_STATE(3313)] = 15614,
  [SMALL_STATE(3314)] = 15622,
  [SMALL_STATE(3315)] = 15630,
  [SMALL_STATE(3316)] = 15638,
  [SMALL_STATE(3317)] = 15646,
  [SMALL_STATE(3318)] = 15654,
  [SMALL_STATE(3319)] = 15662,
  [SMALL_STATE(3320)] = 15670,
  [SMALL_STATE(3321)] = 15678,
  [SMALL_STATE(3322)] = 15686,
  [SMALL_STATE(3323)] = 15694,
  [SMALL_STATE(3324)] = 15702,
  [SMALL_STATE(3325)] = 15710,
  [SMALL_STATE(3326)] = 15718,
  [SMALL_STATE(3327)] = 15726,
  [SMALL_STATE(3328)] = 15734,
  [SMALL_STATE(3329)] = 15742,
  [SMALL_STATE(3330)] = 15750,
  [SMALL_STATE(3331)] = 15758,
  [SMALL_STATE(3332)] = 15766,
  [SMALL_STATE(3333)] = 15774,
  [SMALL_STATE(3334)] = 15782,
  [SMALL_STATE(3335)] = 15790,
  [SMALL_STATE(3336)] = 15798,
  [SMALL_STATE(3337)] = 15806,
  [SMALL_STATE(3338)] = 15814,
  [SMALL_STATE(3339)] = 15822,
  [SMALL_STATE(3340)] = 15830,
  [SMALL_STATE(3341)] = 15838,
  [SMALL_STATE(3342)] = 15846,
  [SMALL_STATE(3343)] = 15854,
  [SMALL_STATE(3344)] = 15862,
  [SMALL_STATE(3345)] = 15870,
  [SMALL_STATE(3346)] = 15878,
  [SMALL_STATE(3347)] = 15886,
  [SMALL_STATE(3348)] = 15894,
  [SMALL_STATE(3349)] = 15902,
  [SMALL_STATE(3350)] = 15910,
  [SMALL_STATE(3351)] = 15918,
  [SMALL_STATE(3352)] = 15926,
  [SMALL_STATE(3353)] = 15934,
  [SMALL_STATE(3354)] = 15942,
  [SMALL_STATE(3355)] = 15950,
  [SMALL_STATE(3356)] = 15958,
  [SMALL_STATE(3357)] = 15966,
  [SMALL_STATE(3358)] = 15974,
  [SMALL_STATE(3359)] = 15982,
  [SMALL_STATE(3360)] = 15990,
  [SMALL_STATE(3361)] = 15998,
  [SMALL_STATE(3362)] = 16006,
  [SMALL_STATE(3363)] = 16014,
  [SMALL_STATE(3364)] = 16022,
  [SMALL_STATE(3365)] = 16030,
  [SMALL_STATE(3366)] = 16038,
  [SMALL_STATE(3367)] = 16046,
  [SMALL_STATE(3368)] = 16054,
  [SMALL_STATE(3369)] = 16062,
  [SMALL_STATE(3370)] = 16070,
  [SMALL_STATE(3371)] = 16078,
  [SMALL_STATE(3372)] = 16086,
  [SMALL_STATE(3373)] = 16094,
  [SMALL_STATE(3374)] = 16102,
  [SMALL_STATE(3375)] = 16110,
  [SMALL_STATE(3376)] = 16118,
  [SMALL_STATE(3377)] = 16126,
  [SMALL_STATE(3378)] = 16134,
  [SMALL_STATE(3379)] = 16142,
  [SMALL_STATE(3380)] = 16150,
  [SMALL_STATE(3381)] = 16158,
  [SMALL_STATE(3382)] = 16166,
  [SMALL_STATE(3383)] = 16174,
  [SMALL_STATE(3384)] = 16182,
  [SMALL_STATE(3385)] = 16190,
  [SMALL_STATE(3386)] = 16198,
  [SMALL_STATE(3387)] = 16206,
  [SMALL_STATE(3388)] = 16214,
  [SMALL_STATE(3389)] = 16222,
  [SMALL_STATE(3390)] = 16230,
  [SMALL_STATE(3391)] = 16238,
  [SMALL_STATE(3392)] = 16246,
  [SMALL_STATE(3393)] = 16254,
  [SMALL_STATE(3394)] = 16262,
  [SMALL_STATE(3395)] = 16270,
  [SMALL_STATE(3396)] = 16278,
  [SMALL_STATE(3397)] = 16286,
  [SMALL_STATE(3398)] = 16294,
  [SMALL_STATE(3399)] = 16302,
  [SMALL_STATE(3400)] = 16310,
  [SMALL_STATE(3401)] = 16318,
  [SMALL_STATE(3402)] = 16326,
  [SMALL_STATE(3403)] = 16334,
  [SMALL_STATE(3404)] = 16342,
  [SMALL_STATE(3405)] = 16350,
  [SMALL_STATE(3406)] = 16358,
  [SMALL_STATE(3407)] = 16366,
  [SMALL_STATE(3408)] = 16374,
  [SMALL_STATE(3409)] = 16382,
  [SMALL_STATE(3410)] = 16390,
  [SMALL_STATE(3411)] = 16398,
  [SMALL_STATE(3412)] = 16406,
  [SMALL_STATE(3413)] = 16414,
  [SMALL_STATE(3414)] = 16422,
  [SMALL_STATE(3415)] = 16430,
  [SMALL_STATE(3416)] = 16438,
  [SMALL_STATE(3417)] = 16446,
  [SMALL_STATE(3418)] = 16454,
  [SMALL_STATE(3419)] = 16462,
  [SMALL_STATE(3420)] = 16470,
  [SMALL_STATE(3421)] = 16478,
  [SMALL_STATE(3422)] = 16486,
  [SMALL_STATE(3423)] = 16494,
  [SMALL_STATE(3424)] = 16502,
  [SMALL_STATE(3425)] = 16510,
  [SMALL_STATE(3426)] = 16518,
  [SMALL_STATE(3427)] = 16526,
  [SMALL_STATE(3428)] = 16534,
  [SMALL_STATE(3429)] = 16542,
  [SMALL_STATE(3430)] = 16550,
  [SMALL_STATE(3431)] = 16558,
  [SMALL_STATE(3432)] = 16566,
  [SMALL_STATE(3433)] = 16574,
  [SMALL_STATE(3434)] = 16582,
  [SMALL_STATE(3435)] = 16590,
  [SMALL_STATE(3436)] = 16598,
  [SMALL_STATE(3437)] = 16606,
  [SMALL_STATE(3438)] = 16614,
  [SMALL_STATE(3439)] = 16622,
  [SMALL_STATE(3440)] = 16630,
  [SMALL_STATE(3441)] = 16638,
  [SMALL_STATE(3442)] = 16646,
  [SMALL_STATE(3443)] = 16654,
  [SMALL_STATE(3444)] = 16662,
  [SMALL_STATE(3445)] = 16670,
  [SMALL_STATE(3446)] = 16678,
  [SMALL_STATE(3447)] = 16686,
  [SMALL_STATE(3448)] = 16694,
  [SMALL_STATE(3449)] = 16702,
  [SMALL_STATE(3450)] = 16710,
  [SMALL_STATE(3451)] = 16718,
  [SMALL_STATE(3452)] = 16726,
  [SMALL_STATE(3453)] = 16734,
  [SMALL_STATE(3454)] = 16742,
  [SMALL_STATE(3455)] = 16750,
  [SMALL_STATE(3456)] = 16758,
  [SMALL_STATE(3457)] = 16766,
  [SMALL_STATE(3458)] = 16774,
  [SMALL_STATE(3459)] = 16782,
  [SMALL_STATE(3460)] = 16790,
  [SMALL_STATE(3461)] = 16798,
  [SMALL_STATE(3462)] = 16806,
  [SMALL_STATE(3463)] = 16814,
  [SMALL_STATE(3464)] = 16822,
  [SMALL_STATE(3465)] = 16830,
  [SMALL_STATE(3466)] = 16838,
  [SMALL_STATE(3467)] = 16846,
  [SMALL_STATE(3468)] = 16854,
  [SMALL_STATE(3469)] = 16862,
  [SMALL_STATE(3470)] = 16870,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3181),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3079),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3303),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3020),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2227),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2229),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2260),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2969),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2966),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_displayed_equation, 3, 0, 0),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_displayed_equation, 3, 0, 0),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_formula, 2, 0, 0),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_formula, 2, 0, 0),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_formula, 3, 0, 0),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_formula, 3, 0, 0),
  [165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_displayed_equation, 2, 0, 0),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_displayed_equation, 2, 0, 0),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2290),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2289),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2913),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2914),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2921),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2931),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3333),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2307),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2928),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2095),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2093),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(427),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(426),
  [353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(19),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(354),
  [359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(354),
  [362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(362),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(362),
  [368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(365),
  [371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(365),
  [374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(367),
  [377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(367),
  [380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(391),
  [383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(391),
  [386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(405),
  [389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(405),
  [392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(420),
  [395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(420),
  [398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(433),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(433),
  [404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(116),
  [407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(601),
  [410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(601),
  [413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(599),
  [416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(599),
  [419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2293),
  [422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2292),
  [425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(115),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(114),
  [431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(114),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2079),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2291),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2290),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2289),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2288),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2911),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2287),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2913),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2914),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2285),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2284),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2283),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2918),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2935),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2282),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2281),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2281),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2921),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2922),
  [491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2922),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2933),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2933),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2932),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2931),
  [506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2931),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3333),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3332),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2099),
  [518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2607),
  [523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2598),
  [526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2923),
  [529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2280),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2307),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2279),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2278),
  [541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2278),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2309),
  [547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2186),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2927),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2928),
  [556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2835),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2930),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2344),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2800),
  [720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2349),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2350),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2351),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2242),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3161),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3260),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2080),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2766),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2336),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2679),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2747),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(725),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(769),
  [820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(64),
  [823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(484),
  [826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(484),
  [829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(486),
  [832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(486),
  [835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(488),
  [841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(490),
  [844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(490),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(551),
  [850] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(551),
  [853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(555),
  [856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(555),
  [859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(564),
  [862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(564),
  [865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(867),
  [868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(867),
  [871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(134),
  [874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1030),
  [877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1030),
  [880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1029),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1029),
  [886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2157),
  [889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2168),
  [892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(128),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2134),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2137),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2145),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2149),
  [913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3218),
  [916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2197),
  [919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3181),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3175),
  [925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2171),
  [928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2174),
  [931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2181),
  [934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3119),
  [937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3111),
  [940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2188),
  [943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2192),
  [946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2192),
  [949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3079),
  [952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3078),
  [955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3078),
  [958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3076),
  [961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3076),
  [964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3075),
  [967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3074),
  [970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3074),
  [973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3324),
  [976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3303),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2091),
  [982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3051),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3043),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3020),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2227),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2229),
  [997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2230),
  [1000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2256),
  [1003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2256),
  [1006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2257),
  [1009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2260),
  [1012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2978),
  [1015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2969),
  [1018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2966),
  [1021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2811),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [1058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2138),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2877),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3080),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2886),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [1110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2856),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2841),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3086),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2136),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [1130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [1136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [1152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [1170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [1172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [1176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2228),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2231),
  [1184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [1186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [1194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2236),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [1210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3287),
  [1218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2784),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2347),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3005),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [1258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(879),
  [1261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(878),
  [1264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(73),
  [1267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(820),
  [1270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(820),
  [1273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(819),
  [1276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(819),
  [1279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(802),
  [1282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(802),
  [1285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(800),
  [1288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(800),
  [1291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(794),
  [1294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(794),
  [1297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(793),
  [1300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(793),
  [1303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(791),
  [1306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(791),
  [1309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(950),
  [1312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(950),
  [1315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(117),
  [1318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1364),
  [1321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1364),
  [1324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1363),
  [1327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1363),
  [1330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2150),
  [1333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2151),
  [1336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(86),
  [1339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(83),
  [1342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(83),
  [1345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2164),
  [1348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2166),
  [1351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2172),
  [1354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2173),
  [1357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2863),
  [1360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2178),
  [1363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2869),
  [1366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2873),
  [1369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2138),
  [1372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2139),
  [1375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2140),
  [1378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2877),
  [1381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3080),
  [1384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2143),
  [1387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2148),
  [1390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2148),
  [1393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2880),
  [1396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2886),
  [1399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2886),
  [1402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3081),
  [1405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3081),
  [1408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3082),
  [1411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3083),
  [1414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3083),
  [1417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3355),
  [1420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3301),
  [1423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2092),
  [1426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2856),
  [1429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2841),
  [1432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3086),
  [1435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2153),
  [1438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2141),
  [1441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2156),
  [1444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2158),
  [1447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2158),
  [1450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2136),
  [1453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2341),
  [1456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3214),
  [1459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2908),
  [1462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2909),
  [1465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2910),
  [1468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [1624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(874),
  [1627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(877),
  [1630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(125),
  [1633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [1636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [1639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(835),
  [1642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(835),
  [1645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(836),
  [1648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(836),
  [1651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(837),
  [1654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(837),
  [1657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(838),
  [1660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(838),
  [1663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [1666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [1669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(841),
  [1672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(841),
  [1675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(991),
  [1678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(991),
  [1681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(142),
  [1684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1127),
  [1687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1127),
  [1690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1126),
  [1693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1126),
  [1696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2339),
  [1699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2340),
  [1702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(141),
  [1705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(140),
  [1708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(140),
  [1711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2342),
  [1714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2343),
  [1717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2344),
  [1720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2345),
  [1723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2806),
  [1726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2346),
  [1729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2800),
  [1732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2798),
  [1735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2348),
  [1738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2349),
  [1741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2350),
  [1744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2796),
  [1747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3158),
  [1750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [1753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2242),
  [1756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2242),
  [1759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2794),
  [1762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2793),
  [1765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2793),
  [1768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3159),
  [1771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3159),
  [1774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3160),
  [1777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3161),
  [1780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3161),
  [1783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3383),
  [1786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3260),
  [1789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2080),
  [1792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2766),
  [1795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2765),
  [1798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3163),
  [1801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2336),
  [1804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2193),
  [1807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2330),
  [1810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [1813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [1816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2194),
  [1819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2326),
  [1822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2778),
  [1825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2776),
  [1828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2774),
  [1831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2772),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [1856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(889),
  [1859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(882),
  [1862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(132),
  [1865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(735),
  [1868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(735),
  [1871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(736),
  [1874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(736),
  [1877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(737),
  [1880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(737),
  [1883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(738),
  [1886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(738),
  [1889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(739),
  [1892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(739),
  [1895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(740),
  [1898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(740),
  [1901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(741),
  [1904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(741),
  [1907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(905),
  [1910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(905),
  [1913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(138),
  [1916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1392),
  [1919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1392),
  [1922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1391),
  [1925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1391),
  [1928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2219),
  [1931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2220),
  [1934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(139),
  [1937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(103),
  [1940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(103),
  [1943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2223),
  [1946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2224),
  [1949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2225),
  [1952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2226),
  [1955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3031),
  [1958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2228),
  [1961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3018),
  [1964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3017),
  [1967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2231),
  [1970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2232),
  [1973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2233),
  [1976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3016),
  [1979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3121),
  [1982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2235),
  [1985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2236),
  [1988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2236),
  [1991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3012),
  [1994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3011),
  [1997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3011),
  [2000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3122),
  [2003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3122),
  [2006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3123),
  [2009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3124),
  [2012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3124),
  [2015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3314),
  [2018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3287),
  [2021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2084),
  [2024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2784),
  [2027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2775),
  [2030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3126),
  [2033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2240),
  [2036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2184),
  [2039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2241),
  [2042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2132),
  [2045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2132),
  [2048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2185),
  [2051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(2347),
  [2054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3006),
  [2057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3005),
  [2060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3003),
  [2063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(3002),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part, 2, 0, 4),
  [2134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part, 2, 0, 4),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part, 1, 0, 4),
  [2140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part, 1, 0, 4),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_chapter, 2, 0, 4),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chapter, 2, 0, 4),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_chapter, 1, 0, 4),
  [2152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chapter, 1, 0, 4),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 2, 0, 4),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 2, 0, 4),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 1, 0, 4),
  [2180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 1, 0, 4),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subsection, 2, 0, 4),
  [2192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subsection, 2, 0, 4),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subsection, 1, 0, 4),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subsection, 1, 0, 4),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subsubsection, 1, 0, 4),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subsubsection, 1, 0, 4),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subsubsection, 2, 0, 4),
  [2216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subsubsection, 2, 0, 4),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paragraph, 1, 0, 4),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paragraph, 1, 0, 4),
  [2232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paragraph, 2, 0, 4),
  [2234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paragraph, 2, 0, 4),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [2246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subparagraph, 1, 0, 4),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subparagraph, 1, 0, 4),
  [2250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subparagraph, 2, 0, 4),
  [2252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subparagraph, 2, 0, 4),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 1, 0, 5),
  [2264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 1, 0, 5),
  [2266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(427),
  [2269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(426),
  [2272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(211),
  [2275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0),
  [2277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0),
  [2279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(116),
  [2282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(601),
  [2285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(601),
  [2288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(599),
  [2291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(599),
  [2294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2293),
  [2297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2292),
  [2300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(115),
  [2303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(114),
  [2306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(114),
  [2309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2079),
  [2312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2291),
  [2315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2290),
  [2318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2289),
  [2321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2288),
  [2324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2911),
  [2327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2287),
  [2330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2913),
  [2333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2914),
  [2336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2285),
  [2339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2284),
  [2342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2283),
  [2345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2918),
  [2348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2935),
  [2351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2282),
  [2354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2281),
  [2357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2281),
  [2360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2921),
  [2363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2922),
  [2366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2922),
  [2369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2933),
  [2372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2933),
  [2375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2932),
  [2378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2931),
  [2381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2931),
  [2384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3333),
  [2387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3332),
  [2390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2099),
  [2393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2607),
  [2396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2598),
  [2399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2923),
  [2402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2280),
  [2405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2307),
  [2408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2279),
  [2411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2278),
  [2414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2278),
  [2417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2309),
  [2420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2186),
  [2423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2927),
  [2426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2928),
  [2429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2835),
  [2432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2930),
  [2435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 2, 0, 5),
  [2437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 2, 0, 5),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(725),
  [2450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(769),
  [2453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(221),
  [2456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(134),
  [2459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1030),
  [2462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1030),
  [2465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1029),
  [2468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1029),
  [2471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2157),
  [2474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2168),
  [2477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(128),
  [2480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [2483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [2486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2134),
  [2489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2137),
  [2492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2145),
  [2495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2149),
  [2498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3218),
  [2501] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2197),
  [2504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3181),
  [2507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3175),
  [2510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2171),
  [2513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2174),
  [2516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2181),
  [2519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3119),
  [2522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3111),
  [2525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2188),
  [2528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2192),
  [2531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2192),
  [2534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3079),
  [2537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3078),
  [2540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3078),
  [2543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3076),
  [2546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3076),
  [2549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3075),
  [2552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3074),
  [2555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3074),
  [2558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3324),
  [2561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3303),
  [2564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2091),
  [2567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3051),
  [2570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3043),
  [2573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3020),
  [2576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2227),
  [2579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2229),
  [2582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2230),
  [2585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2256),
  [2588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2256),
  [2591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2257),
  [2594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2260),
  [2597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2978),
  [2600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2969),
  [2603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2966),
  [2606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2811),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(874),
  [2616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(877),
  [2619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(228),
  [2622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(142),
  [2625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1127),
  [2628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1127),
  [2631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1126),
  [2634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1126),
  [2637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2339),
  [2640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2340),
  [2643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(141),
  [2646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(140),
  [2649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(140),
  [2652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2342),
  [2655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2343),
  [2658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2344),
  [2661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2345),
  [2664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2806),
  [2667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2346),
  [2670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2800),
  [2673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2798),
  [2676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2348),
  [2679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2349),
  [2682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2350),
  [2685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2796),
  [2688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3158),
  [2691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2351),
  [2694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2242),
  [2697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2242),
  [2700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2794),
  [2703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2793),
  [2706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2793),
  [2709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3159),
  [2712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3159),
  [2715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3160),
  [2718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3161),
  [2721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3161),
  [2724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3383),
  [2727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3260),
  [2730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2080),
  [2733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2766),
  [2736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2765),
  [2739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3163),
  [2742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2336),
  [2745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2193),
  [2748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2330),
  [2751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [2754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2328),
  [2757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2194),
  [2760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2326),
  [2763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2778),
  [2766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2776),
  [2769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2774),
  [2772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2772),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(879),
  [2782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(878),
  [2785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(231),
  [2788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(117),
  [2791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1364),
  [2794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1364),
  [2797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1363),
  [2800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1363),
  [2803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2150),
  [2806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2151),
  [2809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(86),
  [2812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(83),
  [2815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(83),
  [2818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2164),
  [2821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2166),
  [2824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2172),
  [2827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2173),
  [2830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2863),
  [2833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2178),
  [2836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2869),
  [2839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2873),
  [2842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2138),
  [2845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2139),
  [2848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2140),
  [2851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2877),
  [2854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3080),
  [2857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2143),
  [2860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2148),
  [2863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2148),
  [2866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2880),
  [2869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2886),
  [2872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2886),
  [2875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3081),
  [2878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3081),
  [2881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3082),
  [2884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3083),
  [2887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3083),
  [2890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3355),
  [2893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3301),
  [2896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2092),
  [2899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2856),
  [2902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2841),
  [2905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3086),
  [2908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2153),
  [2911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2141),
  [2914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2156),
  [2917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2158),
  [2920] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2158),
  [2923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2136),
  [2926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2341),
  [2929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3214),
  [2932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2908),
  [2935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2909),
  [2938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2910),
  [2941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(889),
  [2944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(882),
  [2947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(232),
  [2950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(138),
  [2953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1392),
  [2956] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1392),
  [2959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1391),
  [2962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1391),
  [2965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2219),
  [2968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2220),
  [2971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(139),
  [2974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(103),
  [2977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(103),
  [2980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2223),
  [2983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2224),
  [2986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2225),
  [2989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2226),
  [2992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3031),
  [2995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2228),
  [2998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3018),
  [3001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3017),
  [3004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2231),
  [3007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2232),
  [3010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2233),
  [3013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3016),
  [3016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3121),
  [3019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2235),
  [3022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2236),
  [3025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2236),
  [3028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3012),
  [3031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3011),
  [3034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3011),
  [3037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3122),
  [3040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3122),
  [3043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3123),
  [3046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3124),
  [3049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3124),
  [3052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3314),
  [3055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3287),
  [3058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2084),
  [3061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2784),
  [3064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2775),
  [3067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3126),
  [3070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2240),
  [3073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2184),
  [3076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2241),
  [3079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2132),
  [3082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2132),
  [3085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2185),
  [3088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2347),
  [3091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3006),
  [3094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3005),
  [3097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3003),
  [3100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3002),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1631),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [3129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [3131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [3133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [3135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [3139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [3141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [3145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2968),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [3149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [3153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3195),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [3159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2161),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [3165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3470),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [3185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2759),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3200),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [3195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [3203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2274),
  [3205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2483),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3182),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2640),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [3231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2916),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [3239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1496),
  [3242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1497),
  [3245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(247),
  [3248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(94),
  [3251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1560),
  [3254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1560),
  [3257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1631),
  [3260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(1631),
  [3263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2195),
  [3266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2187),
  [3269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(68),
  [3272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(76),
  [3275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(76),
  [3278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2180),
  [3281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2179),
  [3284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2177),
  [3287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2176),
  [3290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2503),
  [3293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2175),
  [3296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2507),
  [3299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2968),
  [3302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2170),
  [3305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2167),
  [3308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2165),
  [3311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2472),
  [3314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3195),
  [3317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2162),
  [3320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2161),
  [3323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2161),
  [3326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2475),
  [3329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2476),
  [3332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2476),
  [3335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3196),
  [3338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3196),
  [3341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3197),
  [3344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3198),
  [3347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3198),
  [3350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3470),
  [3353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3237),
  [3356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2103),
  [3359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2760),
  [3362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2759),
  [3365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(3200),
  [3368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2160),
  [3371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2183),
  [3374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2154),
  [3377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2152),
  [3380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2152),
  [3383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2206),
  [3386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2274),
  [3389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2481),
  [3392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2482),
  [3395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2483),
  [3398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_part_repeat1, 2, 0, 0), SHIFT_REPEAT(2484),
  [3401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [3403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [3413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [3419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [3427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [3431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [3433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [3435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [3437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [3439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [3441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [3443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [3445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2586),
  [3447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [3449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [3451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [3453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [3455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [3457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2214),
  [3459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2216),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [3463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [3465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [3469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [3473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3202),
  [3475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [3479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [3481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [3483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [3485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [3487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [3489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [3491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [3493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [3495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [3497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [3499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [3501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [3503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [3505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [3507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2601),
  [3511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [3513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(1503),
  [3516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(1502),
  [3519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(248),
  [3522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0),
  [3524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(249),
  [3527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(91),
  [3530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(1763),
  [3533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(1763),
  [3536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(1652),
  [3539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(1652),
  [3542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2201),
  [3545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2202),
  [3548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(123),
  [3551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(147),
  [3554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(147),
  [3557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2079),
  [3560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2203),
  [3563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2204),
  [3566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2207),
  [3569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2208),
  [3572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2583),
  [3575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2209),
  [3578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2585),
  [3581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2586),
  [3584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2210),
  [3587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2211),
  [3590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2212),
  [3593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2590),
  [3596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(3204),
  [3599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2214),
  [3602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2216),
  [3605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2216),
  [3608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2593),
  [3611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2594),
  [3614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2594),
  [3617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(3203),
  [3620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(3203),
  [3623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(3202),
  [3626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(3201),
  [3629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(3201),
  [3632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(3441),
  [3635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(3236),
  [3638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2097),
  [3641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2726),
  [3644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2721),
  [3647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(3199),
  [3650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2221),
  [3653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2249),
  [3656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2222),
  [3659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2247),
  [3662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2247),
  [3665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2263),
  [3668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2266),
  [3671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2599),
  [3674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2600),
  [3677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2601),
  [3680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_brack_group_repeat1, 2, 0, 0), SHIFT_REPEAT(2602),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [3699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(427),
  [3702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(426),
  [3705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30),
  [3707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30),
  [3709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(601),
  [3712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(601),
  [3715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(599),
  [3718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(599),
  [3721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2293),
  [3724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2292),
  [3727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2291),
  [3730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2290),
  [3733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2289),
  [3736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2288),
  [3739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2911),
  [3742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2287),
  [3745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2913),
  [3748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2914),
  [3751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2285),
  [3754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2284),
  [3757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2283),
  [3760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2918),
  [3763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2935),
  [3766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2282),
  [3769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2281),
  [3772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2281),
  [3775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2921),
  [3778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2922),
  [3781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2922),
  [3784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2933),
  [3787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2933),
  [3790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2932),
  [3793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2931),
  [3796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2931),
  [3799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3333),
  [3802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3332),
  [3805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2607),
  [3808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2598),
  [3811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2923),
  [3814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2280),
  [3817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2307),
  [3820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2279),
  [3823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2278),
  [3826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2278),
  [3829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2309),
  [3832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2186),
  [3835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2927),
  [3838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2928),
  [3841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2930),
  [3844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_text, 1, 0, 6),
  [3846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_text, 1, 0, 6),
  [3848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(725),
  [3851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(769),
  [3854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1030),
  [3857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1030),
  [3860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1029),
  [3863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1029),
  [3866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2157),
  [3869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2168),
  [3872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2134),
  [3875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2137),
  [3878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2145),
  [3881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2149),
  [3884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3218),
  [3887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2197),
  [3890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3181),
  [3893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3175),
  [3896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2171),
  [3899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2174),
  [3902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2181),
  [3905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3119),
  [3908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3111),
  [3911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2188),
  [3914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2192),
  [3917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2192),
  [3920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3079),
  [3923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3078),
  [3926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3078),
  [3929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3076),
  [3932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3076),
  [3935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3075),
  [3938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3074),
  [3941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3074),
  [3944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3324),
  [3947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3303),
  [3950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3051),
  [3953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3043),
  [3956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3020),
  [3959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2227),
  [3962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2229),
  [3965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2230),
  [3968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2256),
  [3971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2256),
  [3974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2257),
  [3977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2260),
  [3980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2978),
  [3983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2969),
  [3986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2811),
  [3989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(879),
  [3992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(878),
  [3995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1364),
  [3998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1364),
  [4001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1363),
  [4004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1363),
  [4007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2150),
  [4010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2151),
  [4013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2164),
  [4016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2166),
  [4019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2172),
  [4022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2173),
  [4025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2863),
  [4028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2178),
  [4031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2869),
  [4034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2873),
  [4037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2138),
  [4040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2139),
  [4043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2140),
  [4046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2877),
  [4049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3080),
  [4052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2143),
  [4055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2148),
  [4058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2148),
  [4061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2880),
  [4064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2886),
  [4067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2886),
  [4070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3081),
  [4073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3081),
  [4076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3082),
  [4079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3083),
  [4082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3083),
  [4085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3355),
  [4088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3301),
  [4091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2856),
  [4094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2841),
  [4097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3086),
  [4100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2153),
  [4103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2141),
  [4106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2156),
  [4109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2158),
  [4112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2158),
  [4115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2136),
  [4118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2341),
  [4121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3214),
  [4124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2908),
  [4127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2910),
  [4130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(874),
  [4133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(877),
  [4136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1127),
  [4139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1127),
  [4142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1126),
  [4145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1126),
  [4148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2339),
  [4151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2340),
  [4154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2342),
  [4157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2343),
  [4160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2344),
  [4163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2345),
  [4166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2806),
  [4169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2346),
  [4172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2800),
  [4175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2798),
  [4178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2348),
  [4181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2349),
  [4184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2350),
  [4187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2796),
  [4190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3158),
  [4193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2351),
  [4196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2242),
  [4199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2242),
  [4202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2794),
  [4205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2793),
  [4208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2793),
  [4211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3159),
  [4214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3159),
  [4217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3160),
  [4220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3161),
  [4223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3161),
  [4226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3383),
  [4229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3260),
  [4232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2766),
  [4235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2765),
  [4238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3163),
  [4241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2336),
  [4244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2193),
  [4247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2330),
  [4250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2328),
  [4253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2328),
  [4256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2194),
  [4259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2326),
  [4262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2778),
  [4265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2776),
  [4268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2772),
  [4271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(889),
  [4274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(882),
  [4277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1392),
  [4280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1392),
  [4283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1391),
  [4286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1391),
  [4289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2219),
  [4292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2220),
  [4295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2223),
  [4298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2224),
  [4301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2225),
  [4304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2226),
  [4307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3031),
  [4310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2228),
  [4313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3018),
  [4316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3017),
  [4319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2231),
  [4322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2232),
  [4325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2233),
  [4328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3016),
  [4331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3121),
  [4334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2235),
  [4337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2236),
  [4340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2236),
  [4343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3012),
  [4346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3011),
  [4349] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3011),
  [4352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3122),
  [4355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3122),
  [4358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3123),
  [4361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3124),
  [4364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3124),
  [4367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3314),
  [4370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3287),
  [4373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2784),
  [4376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2775),
  [4379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3126),
  [4382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2240),
  [4385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2184),
  [4388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2241),
  [4391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2132),
  [4394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2132),
  [4397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2185),
  [4400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2347),
  [4403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3006),
  [4406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3005),
  [4409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3002),
  [4412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [4414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [4416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [4428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [4432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [4438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [4448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2294),
  [4450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2295),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [4454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [4456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [4458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [4460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [4462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2300),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [4468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3136),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [4474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2303),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2711),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3135),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3133),
  [4490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3132),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [4494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3416),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [4502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3131),
  [4504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [4506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [4508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2255),
  [4518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [4520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [4524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [4534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1797),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [4540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1795),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [4548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [4552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [4554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2251),
  [4558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [4560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [4566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [4570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [4572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [4574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3004),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2893),
  [4578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2239),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [4584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3008),
  [4588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [4590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [4592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2891),
  [4596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [4598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [4602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [4604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [4606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [4610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [4616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [4618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [4622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [4626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3013),
  [4628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3014),
  [4630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2929),
  [4632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [4634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [4638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [4640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [4652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [4656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(1513),
  [4659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(1515),
  [4662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(274),
  [4665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(96),
  [4668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0),
  [4670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(1797),
  [4673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(1797),
  [4676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(1795),
  [4679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(1795),
  [4682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2259),
  [4685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [4688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(71),
  [4691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(70),
  [4694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(70),
  [4697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2254),
  [4700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2252),
  [4703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2251),
  [4706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2250),
  [4709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2997),
  [4712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [4715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2999),
  [4718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3000),
  [4721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2246),
  [4724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2245),
  [4727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2244),
  [4730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3004),
  [4733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2893),
  [4736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2243),
  [4739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2239),
  [4742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2239),
  [4745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3007),
  [4748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3008),
  [4751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3008),
  [4754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2892),
  [4757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2892),
  [4760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2891),
  [4763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2889),
  [4766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2889),
  [4769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3315),
  [4772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3353),
  [4775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2104),
  [4778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2588),
  [4781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2587),
  [4784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2888),
  [4787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2238),
  [4790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2315),
  [4793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2237),
  [4796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2234),
  [4799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2234),
  [4802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2196),
  [4805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2142),
  [4808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3013),
  [4811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3014),
  [4814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(2929),
  [4817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(3015),
  [4820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [4846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [4854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [4860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [4862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(1513),
  [4865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(1515),
  [4868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(253),
  [4871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0),
  [4873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(289),
  [4876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(96),
  [4879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(1797),
  [4882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(1797),
  [4885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(1795),
  [4888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(1795),
  [4891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2259),
  [4894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2258),
  [4897] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(97),
  [4900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(98),
  [4903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(98),
  [4906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2254),
  [4909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2252),
  [4912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2251),
  [4915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2250),
  [4918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2997),
  [4921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [4924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2999),
  [4927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3000),
  [4930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2246),
  [4933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2245),
  [4936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2244),
  [4939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3004),
  [4942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2893),
  [4945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2243),
  [4948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2239),
  [4951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2239),
  [4954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3007),
  [4957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3008),
  [4960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3008),
  [4963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2892),
  [4966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2892),
  [4969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2891),
  [4972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2889),
  [4975] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2889),
  [4978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3315),
  [4981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3353),
  [4984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2104),
  [4987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2588),
  [4990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2587),
  [4993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2888),
  [4996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2238),
  [4999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2315),
  [5002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2237),
  [5005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2234),
  [5008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2234),
  [5011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2196),
  [5014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2142),
  [5017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3013),
  [5020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3014),
  [5023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(2929),
  [5026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(3015),
  [5029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(290),
  [5032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(118),
  [5035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(119),
  [5038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_value_repeat1, 2, 0, 0), SHIFT_REPEAT(119),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [5043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value, 1, 0, 0),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [5049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [5057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [5061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [5063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [5071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [5073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1949),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [5079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1950),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [5087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [5091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2335),
  [5093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [5095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2333),
  [5097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [5099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [5101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [5103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2819),
  [5105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [5107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [5109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2327),
  [5111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2325),
  [5113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2824),
  [5115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [5117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [5119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2320),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [5123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2827),
  [5125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2828),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [5129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [5133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [5135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [5139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [5141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [5143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [5145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [5147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [5149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [5151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [5153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [5155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2318),
  [5157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [5159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [5161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [5163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [5165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2833),
  [5167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [5169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2718),
  [5171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [5179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [5181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [5183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [5191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [5195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1873),
  [5198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1875),
  [5201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1959),
  [5204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(137),
  [5207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0),
  [5209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0),
  [5211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1949),
  [5214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1949),
  [5217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1950),
  [5220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1950),
  [5223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2338),
  [5226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2337),
  [5229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(136),
  [5232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(135),
  [5235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(135),
  [5238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2335),
  [5241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2334),
  [5244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2333),
  [5247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2332),
  [5250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2817),
  [5253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2331),
  [5256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2819),
  [5259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2820),
  [5262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2329),
  [5265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2327),
  [5268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2325),
  [5271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2824),
  [5274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3058),
  [5277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2321),
  [5280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2320),
  [5283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2320),
  [5286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2827),
  [5289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2828),
  [5292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2828),
  [5295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3050),
  [5298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3050),
  [5301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3046),
  [5304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3045),
  [5307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3045),
  [5310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3377),
  [5313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3309),
  [5316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2105),
  [5319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2644),
  [5322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2643),
  [5325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3042),
  [5328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2319),
  [5331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2305),
  [5334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2318),
  [5337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2317),
  [5340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2317),
  [5343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2306),
  [5346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2199),
  [5349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2833),
  [5352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2834),
  [5355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2718),
  [5358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2836),
  [5361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat2, 2, 0, 60),
  [5363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat2, 2, 0, 60),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [5373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [5377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [5385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1496),
  [5388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1497),
  [5391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1560),
  [5394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1560),
  [5397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1631),
  [5400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1631),
  [5403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2195),
  [5406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2187),
  [5409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2180),
  [5412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2179),
  [5415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2177),
  [5418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2176),
  [5421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2503),
  [5424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2175),
  [5427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2507),
  [5430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2968),
  [5433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2170),
  [5436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2167),
  [5439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2165),
  [5442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2472),
  [5445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3195),
  [5448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2162),
  [5451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2161),
  [5454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2161),
  [5457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2475),
  [5460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2476),
  [5463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2476),
  [5466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3196),
  [5469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3196),
  [5472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3197),
  [5475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3198),
  [5478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3198),
  [5481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3470),
  [5484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3237),
  [5487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2760),
  [5490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2759),
  [5493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3200),
  [5496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2160),
  [5499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2183),
  [5502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2154),
  [5505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2152),
  [5508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2152),
  [5511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2206),
  [5514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2274),
  [5517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2481),
  [5520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2482),
  [5523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2484),
  [5526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1513),
  [5529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1515),
  [5532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1797),
  [5535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1797),
  [5538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1795),
  [5541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1795),
  [5544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2259),
  [5547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2258),
  [5550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2254),
  [5553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2252),
  [5556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2251),
  [5559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2250),
  [5562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2997),
  [5565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2248),
  [5568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2999),
  [5571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3000),
  [5574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2246),
  [5577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2245),
  [5580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2244),
  [5583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3004),
  [5586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2893),
  [5589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2243),
  [5592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2239),
  [5595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2239),
  [5598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3007),
  [5601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3008),
  [5604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3008),
  [5607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2892),
  [5610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2892),
  [5613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2891),
  [5616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2889),
  [5619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2889),
  [5622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3315),
  [5625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3353),
  [5628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2588),
  [5631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2587),
  [5634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2888),
  [5637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2238),
  [5640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2315),
  [5643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2237),
  [5646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2234),
  [5649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2234),
  [5652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2196),
  [5655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2142),
  [5658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3013),
  [5661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3014),
  [5664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3015),
  [5667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1503),
  [5670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1502),
  [5673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1763),
  [5676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1763),
  [5679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1652),
  [5682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1652),
  [5685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2201),
  [5688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2202),
  [5691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2203),
  [5694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2204),
  [5697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2207),
  [5700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2208),
  [5703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2583),
  [5706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2209),
  [5709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2585),
  [5712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2586),
  [5715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2210),
  [5718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2211),
  [5721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2212),
  [5724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2590),
  [5727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3204),
  [5730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2214),
  [5733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2216),
  [5736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2216),
  [5739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2593),
  [5742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2594),
  [5745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2594),
  [5748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3203),
  [5751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3203),
  [5754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3202),
  [5757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3201),
  [5760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3201),
  [5763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3441),
  [5766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3236),
  [5769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2726),
  [5772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2721),
  [5775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3199),
  [5778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2221),
  [5781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2249),
  [5784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2222),
  [5787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2247),
  [5790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2247),
  [5793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2263),
  [5796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2266),
  [5799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2599),
  [5802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2600),
  [5805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2602),
  [5808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part, 3, 0, 4),
  [5810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part, 3, 0, 4),
  [5812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1873),
  [5815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1875),
  [5818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1949),
  [5821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1949),
  [5824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1950),
  [5827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1950),
  [5830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2338),
  [5833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2337),
  [5836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2335),
  [5839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2334),
  [5842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2333),
  [5845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2332),
  [5848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2817),
  [5851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2331),
  [5854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2819),
  [5857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2820),
  [5860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2329),
  [5863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2327),
  [5866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2325),
  [5869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2824),
  [5872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3058),
  [5875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2321),
  [5878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2320),
  [5881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2320),
  [5884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2827),
  [5887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2828),
  [5890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2828),
  [5893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3050),
  [5896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3050),
  [5899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3046),
  [5902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3045),
  [5905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3045),
  [5908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3377),
  [5911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3309),
  [5914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2644),
  [5917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2643),
  [5920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3042),
  [5923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2319),
  [5926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2305),
  [5929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2318),
  [5932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2317),
  [5935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2317),
  [5938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2306),
  [5941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2199),
  [5944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2833),
  [5947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2834),
  [5950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2836),
  [5953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_chapter, 3, 0, 4),
  [5955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chapter, 3, 0, 4),
  [5957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 3, 0, 4),
  [5959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 3, 0, 4),
  [5961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0),
  [5963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0),
  [5965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(367),
  [5968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(367),
  [5971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__part_declaration, 1, 0, 2),
  [5973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__part_declaration, 1, 0, 2),
  [5975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__chapter_declaration, 1, 0, 2),
  [5977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__chapter_declaration, 1, 0, 2),
  [5979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__section_declaration, 1, 0, 2),
  [5981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section_declaration, 1, 0, 2),
  [5983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subsection_declaration, 1, 0, 2),
  [5985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subsection_declaration, 1, 0, 2),
  [5987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0),
  [5989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0),
  [5991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(354),
  [5994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(354),
  [5997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0),
  [5999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0),
  [6001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(362),
  [6004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(362),
  [6007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0),
  [6009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0),
  [6011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(365),
  [6014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(365),
  [6017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0),
  [6019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0),
  [6021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(391),
  [6024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(391),
  [6027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0),
  [6029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0),
  [6031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(405),
  [6034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(405),
  [6037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0),
  [6039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0),
  [6041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(420),
  [6044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(420),
  [6047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0),
  [6049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0),
  [6051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(433),
  [6054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(433),
  [6057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paragraph, 1, 0, 0),
  [6059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paragraph, 1, 0, 0),
  [6061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subsubsection_declaration, 1, 0, 2),
  [6063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subsubsection_declaration, 1, 0, 2),
  [6065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subsection, 3, 0, 4),
  [6067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subsection, 3, 0, 4),
  [6069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paragraph, 3, 0, 4),
  [6071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paragraph, 3, 0, 4),
  [6073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subparagraph, 3, 0, 4),
  [6075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subparagraph, 3, 0, 4),
  [6077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__section, 1, 0, 0),
  [6079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section, 1, 0, 0),
  [6081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paragraph_declaration, 1, 0, 2),
  [6083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paragraph_declaration, 1, 0, 2),
  [6085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_part, 4, 0, 4),
  [6087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_part, 4, 0, 4),
  [6089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_chapter, 4, 0, 4),
  [6091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chapter, 4, 0, 4),
  [6093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_section, 4, 0, 4),
  [6095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_section, 4, 0, 4),
  [6097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subsection, 4, 0, 4),
  [6099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subsection, 4, 0, 4),
  [6101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subparagraph_declaration, 1, 0, 2),
  [6103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subparagraph_declaration, 1, 0, 2),
  [6105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem_definition, 3, 0, 48),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [6109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem_definition, 3, 0, 48),
  [6111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_comment, 1, 0, 1),
  [6113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [6115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 1, 0, 1),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [6119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_command, 1, 0, 2),
  [6121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_command, 1, 0, 2),
  [6123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_command, 2, 0, 17),
  [6125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_command, 2, 0, 17),
  [6127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem_definition, 2, 0, 14),
  [6129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem_definition, 2, 0, 14),
  [6131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35),
  [6133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35),
  [6135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(116),
  [6138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_itemdeclaration, 1, 0, 2),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [6142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_itemdeclaration, 1, 0, 2),
  [6144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paired_delimiter_definition, 4, 0, 69),
  [6146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paired_delimiter_definition, 4, 0, 69),
  [6148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem_definition, 4, 0, 74),
  [6150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem_definition, 4, 0, 74),
  [6152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paired_delimiter_definition, 5, 0, 88),
  [6154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paired_delimiter_definition, 5, 0, 88),
  [6156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_comment, 2, 0, 7),
  [6158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [6160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 2, 0, 7),
  [6162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hyperlink, 2, 0, 28),
  [6164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hyperlink, 2, 0, 28),
  [6166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem_definition, 3, 0, 49),
  [6168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem_definition, 3, 0, 49),
  [6170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_math_delimiter, 4, 0, 68),
  [6172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_math_delimiter, 4, 0, 68),
  [6174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_path, 3, 0, 62),
  [6176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_path, 3, 0, 62),
  [6178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__part_declaration, 2, 0, 9),
  [6180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__part_declaration, 2, 0, 9),
  [6182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_path_list, 3, 0, 62),
  [6184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_path_list, 3, 0, 62),
  [6186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__section_part, 1, 0, 10),
  [6188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section_part, 1, 0, 10),
  [6190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_author_list, 3, 0, 60),
  [6192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_author_list, 3, 0, 60),
  [6194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__chapter_declaration, 2, 0, 9),
  [6196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__chapter_declaration, 2, 0, 9),
  [6198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hyperlink, 3, 0, 50),
  [6200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hyperlink, 3, 0, 50),
  [6202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__section_declaration, 2, 0, 9),
  [6204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section_declaration, 2, 0, 9),
  [6206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subsection_declaration, 2, 0, 9),
  [6208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subsection_declaration, 2, 0, 9),
  [6210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subsubsection_declaration, 2, 0, 9),
  [6212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subsubsection_declaration, 2, 0, 9),
  [6214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_acronym_reference, 3, 0, 48),
  [6216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_acronym_reference, 3, 0, 48),
  [6218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glossary_entry_reference, 3, 0, 48),
  [6220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glossary_entry_reference, 3, 0, 48),
  [6222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glossary_entry_definition, 3, 0, 33),
  [6224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glossary_entry_definition, 3, 0, 33),
  [6226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_command_definition, 3, 0, 47),
  [6228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_command_definition, 3, 0, 47),
  [6230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_command_definition, 3, 0, 47),
  [6232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_command_definition, 3, 0, 47),
  [6234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label_number, 3, 0, 46),
  [6236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_number, 3, 0, 46),
  [6238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label_reference_range, 3, 0, 45),
  [6240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_reference_range, 3, 0, 45),
  [6242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_citation, 3, 0, 44),
  [6244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_citation, 3, 0, 44),
  [6246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_text_list, 2, 0, 0),
  [6248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_text_list, 2, 0, 0),
  [6250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_caption, 3, 0, 43),
  [6252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caption, 3, 0, 43),
  [6254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__paragraph_declaration, 2, 0, 9),
  [6256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__paragraph_declaration, 2, 0, 9),
  [6258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__subparagraph_declaration, 2, 0, 9),
  [6260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__subparagraph_declaration, 2, 0, 9),
  [6262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_itemdeclaration, 2, 0, 11),
  [6264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_itemdeclaration, 2, 0, 11),
  [6266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_include, 3, 0, 42),
  [6268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_include, 3, 0, 42),
  [6270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inkscape_include, 3, 0, 40),
  [6272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inkscape_include, 3, 0, 40),
  [6274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_impl, 3, 0, 0),
  [6276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_impl, 3, 0, 0),
  [6278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_impl, 2, 0, 0),
  [6280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_impl, 2, 0, 0),
  [6282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_text, 3, 0, 57),
  [6284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_text, 3, 0, 57),
  [6286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_svg_include, 3, 0, 40),
  [6288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_svg_include, 3, 0, 40),
  [6290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_graphics_include, 3, 0, 40),
  [6292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_graphics_include, 3, 0, 40),
  [6294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__section_part, 2, 0, 32),
  [6296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__section_part, 2, 0, 32),
  [6298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_color_set_definition, 6, 0, 96),
  [6300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_color_set_definition, 6, 0, 96),
  [6302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_key_value, 4, 0, 78),
  [6304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_key_value, 4, 0, 78),
  [6306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paired_delimiter_definition, 6, 0, 95),
  [6308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paired_delimiter_definition, 6, 0, 95),
  [6310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_biblatex_include, 3, 0, 41),
  [6312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_biblatex_include, 3, 0, 41),
  [6314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_include, 3, 0, 40),
  [6316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_include, 3, 0, 40),
  [6318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_include, 3, 0, 39),
  [6320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_include, 3, 0, 39),
  [6322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_path_list, 2, 0, 0),
  [6324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_path_list, 2, 0, 0),
  [6326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_author_declaration, 3, 0, 37),
  [6328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_author_declaration, 3, 0, 37),
  [6330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_author_list, 2, 0, 0),
  [6332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_author_list, 2, 0, 0),
  [6334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_title_declaration, 3, 0, 36),
  [6336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_title_declaration, 3, 0, 36),
  [6338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_color_set_definition, 5, 0, 94),
  [6340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_color_set_definition, 5, 0, 94),
  [6342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_color_definition, 5, 0, 93),
  [6344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_color_definition, 5, 0, 93),
  [6346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_comment, 3, 0, 31),
  [6348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 31),
  [6350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_glob_pattern, 3, 0, 63),
  [6352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_glob_pattern, 3, 0, 63),
  [6354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tikz_library_import, 2, 0, 20),
  [6356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tikz_library_import, 2, 0, 20),
  [6358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem_definition, 5, 0, 92),
  [6360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem_definition, 5, 0, 92),
  [6362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_color_reference, 2, 0, 14),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_color_reference, 2, 0, 14),
  [6366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem_definition, 5, 0, 91),
  [6368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem_definition, 5, 0, 91),
  [6370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_acronym_definition, 5, 0, 90),
  [6372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_acronym_definition, 5, 0, 90),
  [6374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_acronym_reference, 2, 0, 14),
  [6376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_acronym_reference, 2, 0, 14),
  [6378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_glossary_entry_reference, 2, 0, 14),
  [6380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glossary_entry_reference, 2, 0, 14),
  [6382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_old_command_definition, 2, 0, 26),
  [6384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_old_command_definition, 2, 0, 26),
  [6386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label_reference, 2, 0, 25),
  [6388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_reference, 2, 0, 25),
  [6390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label_definition, 2, 0, 14),
  [6392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label_definition, 2, 0, 14),
  [6394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_citation, 2, 0, 24),
  [6396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_citation, 2, 0, 24),
  [6398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_caption, 2, 0, 23),
  [6400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_caption, 2, 0, 23),
  [6402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_include, 2, 0, 21),
  [6404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_include, 2, 0, 21),
  [6406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inkscape_include, 2, 0, 21),
  [6408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inkscape_include, 2, 0, 21),
  [6410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_svg_include, 2, 0, 21),
  [6412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_svg_include, 2, 0, 21),
  [6414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_graphics_include, 2, 0, 21),
  [6416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_graphics_include, 2, 0, 21),
  [6418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bibtex_include, 2, 0, 20),
  [6420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bibtex_include, 2, 0, 20),
  [6422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bibstyle_include, 2, 0, 21),
  [6424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bibstyle_include, 2, 0, 21),
  [6426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_biblatex_include, 2, 0, 22),
  [6428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_biblatex_include, 2, 0, 22),
  [6430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_latex_include, 2, 0, 21),
  [6432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_latex_include, 2, 0, 21),
  [6434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_include, 2, 0, 21),
  [6436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_include, 2, 0, 21),
  [6438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_include, 2, 0, 20),
  [6440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_include, 2, 0, 20),
  [6442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_author_declaration, 2, 0, 19),
  [6444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_author_declaration, 2, 0, 19),
  [6446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_title_declaration, 2, 0, 18),
  [6448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_title_declaration, 2, 0, 18),
  [6450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_text_list, 3, 0, 57),
  [6452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_text_list, 3, 0, 57),
  [6454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_generic_command_repeat1, 1, 0, 16),
  [6456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 1, 0, 16),
  [6458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_key_value, 3, 0, 61),
  [6460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_key_value, 3, 0, 61),
  [6462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_environment_definition, 5, 0, 89),
  [6464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_environment_definition, 5, 0, 89),
  [6466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paired_delimiter_definition, 5, 0, 87),
  [6468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paired_delimiter_definition, 5, 0, 87),
  [6470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_citation, 4, 0, 64),
  [6472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_citation, 4, 0, 64),
  [6474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_command_definition, 5, 0, 85),
  [6476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_command_definition, 5, 0, 85),
  [6478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_text_list, 4, 0, 82),
  [6480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_text_list, 4, 0, 82),
  [6482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_path_list, 4, 0, 80),
  [6484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_path_list, 4, 0, 80),
  [6486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_author_list, 4, 0, 60),
  [6488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_author_list, 4, 0, 60),
  [6490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subsubsection, 3, 0, 4),
  [6492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subsubsection, 3, 0, 4),
  [6494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_uri, 3, 0, 76),
  [6496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_uri, 3, 0, 76),
  [6498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_color_definition, 4, 0, 75),
  [6500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_color_definition, 4, 0, 75),
  [6502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brack_group_text, 3, 0, 57),
  [6504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brack_group_text, 3, 0, 57),
  [6506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem_definition, 4, 0, 73),
  [6508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem_definition, 4, 0, 73),
  [6510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_theorem_definition, 4, 0, 72),
  [6512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_theorem_definition, 4, 0, 72),
  [6514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_acronym_definition, 4, 0, 71),
  [6516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_acronym_definition, 4, 0, 71),
  [6518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group_key_value, 2, 0, 0),
  [6520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_key_value, 2, 0, 0),
  [6522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_superscript, 2, 0, 13),
  [6524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superscript, 2, 0, 13),
  [6526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 2, 0, 12),
  [6528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 2, 0, 12),
  [6530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(484),
  [6533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(484),
  [6536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(486),
  [6539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(486),
  [6542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_math_environment, 2, 0, 29),
  [6544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_math_environment, 2, 0, 29),
  [6546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_environment, 2, 0, 8),
  [6548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_environment, 2, 0, 8),
  [6550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_command_definition, 4, 0, 66),
  [6552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_command_definition, 4, 0, 66),
  [6554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_command_definition, 4, 0, 67),
  [6556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_command_definition, 4, 0, 67),
  [6558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_comment, 2, 0, 8),
  [6560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 2, 0, 8),
  [6562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__sagesilent_environment_end, 2, 0, 15),
  [6564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sagesilent_environment_end, 2, 0, 15),
  [6566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(867),
  [6569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(867),
  [6572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_environment_definition, 4, 0, 70),
  [6574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_environment_definition, 4, 0, 70),
  [6576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1, 0, 0),
  [6578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1, 0, 0),
  [6580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(564),
  [6583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(564),
  [6586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 1, 0, 3),
  [6588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 1, 0, 3),
  [6590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pycode_environment_end, 2, 0, 15),
  [6592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pycode_environment_end, 2, 0, 15),
  [6594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_math_delimiter, 5, 0, 86),
  [6596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_math_delimiter, 5, 0, 86),
  [6598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__minted_environment_end, 2, 0, 15),
  [6600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__minted_environment_end, 2, 0, 15),
  [6602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__sageblock_environment_group, 3, 0, 58),
  [6604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sageblock_environment_group, 3, 0, 58),
  [6606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__sagesilent_environment_group, 3, 0, 58),
  [6608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sagesilent_environment_group, 3, 0, 58),
  [6610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pycode_environment_group, 3, 0, 58),
  [6612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pycode_environment_group, 3, 0, 58),
  [6614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__listing_environment_group, 3, 0, 58),
  [6616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__listing_environment_group, 3, 0, 58),
  [6618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__verbatim_environment_group, 3, 0, 58),
  [6620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__verbatim_environment_group, 3, 0, 58),
  [6622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__comment_environment_group, 3, 0, 58),
  [6624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment_environment_group, 3, 0, 58),
  [6626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__listing_environment_end, 2, 0, 15),
  [6628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__listing_environment_end, 2, 0, 15),
  [6630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__verbatim_environment_end, 2, 0, 15),
  [6632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__verbatim_environment_end, 2, 0, 15),
  [6634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group, 3, 0, 0),
  [6636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group, 3, 0, 0),
  [6638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__comment_environment_end, 2, 0, 15),
  [6640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment_environment_end, 2, 0, 15),
  [6642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_text_mode, 2, 0, 27),
  [6644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_text_mode, 2, 0, 27),
  [6646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__math_environment_group, 3, 0, 58),
  [6648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__math_environment_group, 3, 0, 58),
  [6650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__minted_environment_group, 3, 0, 58),
  [6652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__minted_environment_group, 3, 0, 58),
  [6654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_group, 2, 0, 0),
  [6656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group, 2, 0, 0),
  [6658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_math_environment, 3, 0, 56),
  [6660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_math_environment, 3, 0, 56),
  [6662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__math_environment_end, 2, 0, 15),
  [6664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__math_environment_end, 2, 0, 15),
  [6666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sageblock_environment, 3, 0, 54),
  [6668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sageblock_environment, 3, 0, 54),
  [6670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__sageblock_environment_end, 2, 0, 15),
  [6672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sageblock_environment_end, 2, 0, 15),
  [6674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sagesilent_environment, 3, 0, 54),
  [6676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sagesilent_environment, 3, 0, 54),
  [6678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pycode_environment, 3, 0, 54),
  [6680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pycode_environment, 3, 0, 54),
  [6682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_minted_environment, 3, 0, 55),
  [6684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_minted_environment, 3, 0, 55),
  [6686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(555),
  [6689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(555),
  [6692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(551),
  [6695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(551),
  [6698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(488),
  [6701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(488),
  [6704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(490),
  [6707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(490),
  [6710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_listing_environment, 3, 0, 54),
  [6712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_listing_environment, 3, 0, 54),
  [6714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_verbatim_environment, 3, 0, 53),
  [6716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_verbatim_environment, 3, 0, 53),
  [6718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comment_environment, 3, 0, 52),
  [6720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment_environment, 3, 0, 52),
  [6722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_environment, 3, 0, 51),
  [6724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_environment, 3, 0, 51),
  [6726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_end, 2, 0, 14),
  [6728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end, 2, 0, 14),
  [6730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(802),
  [6733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(802),
  [6736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(800),
  [6739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(800),
  [6742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(794),
  [6745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(794),
  [6748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(793),
  [6751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(793),
  [6754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(791),
  [6757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(791),
  [6760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(950),
  [6763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(950),
  [6766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(841),
  [6769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(841),
  [6772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(991),
  [6775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(991),
  [6778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(820),
  [6781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(820),
  [6784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [6787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [6790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(838),
  [6793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(838),
  [6796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(837),
  [6799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(837),
  [6802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(836),
  [6805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(836),
  [6808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(835),
  [6811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(835),
  [6814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [6817] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [6820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(819),
  [6823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(819),
  [6826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(134),
  [6829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [6831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [6833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(735),
  [6836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat1, 2, 0, 0), SHIFT_REPEAT(735),
  [6839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(736),
  [6842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat2, 2, 0, 0), SHIFT_REPEAT(736),
  [6845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(737),
  [6848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat3, 2, 0, 0), SHIFT_REPEAT(737),
  [6851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(738),
  [6854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat4, 2, 0, 0), SHIFT_REPEAT(738),
  [6857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(739),
  [6860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__section_repeat5, 2, 0, 0), SHIFT_REPEAT(739),
  [6863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(740),
  [6866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat1, 2, 0, 0), SHIFT_REPEAT(740),
  [6869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(741),
  [6872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat2, 2, 0, 0), SHIFT_REPEAT(741),
  [6875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(905),
  [6878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__paragraph_repeat3, 2, 0, 0), SHIFT_REPEAT(905),
  [6881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1978),
  [6884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(1979),
  [6887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2022),
  [6890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2022),
  [6893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2066),
  [6896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2066),
  [6899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2269),
  [6902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2271),
  [6905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2277),
  [6908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2294),
  [6911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2295),
  [6914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2296),
  [6917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2700),
  [6920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2298),
  [6923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2702),
  [6926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2703),
  [6929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2299),
  [6932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2300),
  [6935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2301),
  [6938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2707),
  [6941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3136),
  [6944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2302),
  [6947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2303),
  [6950] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2303),
  [6953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2710),
  [6956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2711),
  [6959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2711),
  [6962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3135),
  [6965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3135),
  [6968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3133),
  [6971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3132),
  [6974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3132),
  [6977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3416),
  [6980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3273),
  [6983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2654),
  [6986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2653),
  [6989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(3131),
  [6992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2308),
  [6995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2286),
  [6998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2311),
  [7001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2312),
  [7004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2312),
  [7007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2297),
  [7010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2255),
  [7013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2716),
  [7016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2717),
  [7019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2, 0, 30), SHIFT_REPEAT(2719),
  [7022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(142),
  [7025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [7027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [7031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [7035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [7039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(138),
  [7042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(117),
  [7045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [7047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [7051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [7053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [7065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [7067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 2, 0, 14),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [7071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 2, 0, 14),
  [7073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [7075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [7081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [7083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [7085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [7087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [7089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brack_group, 2, 0, 0),
  [7091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brack_group, 2, 0, 0),
  [7093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [7095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [7097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_brack_group, 3, 0, 0),
  [7099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brack_group, 3, 0, 0),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [7105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_begin, 3, 0, 33),
  [7107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_begin, 3, 0, 33),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [7113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [7117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(94),
  [7120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [7124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(91),
  [7127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1657),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [7131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [7135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(96),
  [7138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [7142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [7148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__math_environment_begin, 2, 0, 15),
  [7150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__math_environment_begin, 2, 0, 15),
  [7152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1853),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [7156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(137),
  [7159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [7163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1925),
  [7165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 1, 0, 0),
  [7167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat1, 1, 0, 0),
  [7169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [7171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_command_repeat1, 2, 0, 35), SHIFT_REPEAT(72),
  [7174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [7180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [7186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [7190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [7194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [7198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [7202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [7206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [7210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [7214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [7218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [7222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [7226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [7230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [7234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [7238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [7242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [7246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [7250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1808),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [7254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [7258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [7266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [7270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [7274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [7278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [7282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [7286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [7290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [7300] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [7304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2126),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [7320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_glob_pattern, 1, 0, 0),
  [7322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [7326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [7332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_glob_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2127),
  [7335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_glob_pattern_repeat1, 2, 0, 0),
  [7337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_glob_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(2130),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [7374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [7382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [7396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [7400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [7406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1659),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [7410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [7426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [7430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [7460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [7464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1788),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [7468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2062),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [7472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [7488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [7492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [7522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [7526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [7530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [7534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [7580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_group_command_name, 3, 0, 65),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [7590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat2, 2, 0, 0),
  [7592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_author_list_repeat2, 2, 0, 0), SHIFT_REPEAT(317),
  [7595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_value_pair, 3, 0, 77),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [7599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [7601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [7603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [7607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [7609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [7611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [7613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [7615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [7617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [7619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [7625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_key_value_repeat1, 2, 0, 61),
  [7627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [7631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [7633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [7635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [7639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [7647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_key_value_repeat1, 2, 0, 79),
  [7649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_key_value_repeat1, 2, 0, 79), SHIFT_REPEAT(1367),
  [7652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [7662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_path_list_repeat1, 2, 0, 81), SHIFT_REPEAT(3410),
  [7665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_path_list_repeat1, 2, 0, 81),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [7669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [7671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [7681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__glob_pattern_fragment, 3, 0, 0),
  [7683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__glob_pattern_fragment, 3, 0, 0),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [7687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_key_value_pair, 1, 0, 38),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [7691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [7693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [7699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__glob_pattern_fragment, 2, 0, 0),
  [7701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__glob_pattern_fragment, 2, 0, 0),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [7707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [7709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [7711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [7715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [7717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [7725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [7729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_text_list_repeat1, 2, 0, 83), SHIFT_REPEAT(1491),
  [7732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_text_list_repeat1, 2, 0, 83),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [7742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [7748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [7754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brack_group_argc, 3, 0, 84),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [7786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [7788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [7806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [7810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [7814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_curly_group_key_value_repeat1, 2, 0, 79), SHIFT_REPEAT(1454),
  [7817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [7829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [7839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [7841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [7843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [7845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [7847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [7857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [7859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [7863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [7867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [7869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_text_list_repeat1, 2, 0, 57),
  [7871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_curly_group_path_list_repeat1, 2, 0, 62),
  [7873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [7877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [7879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [7883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [7885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [7887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [7889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [7893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [7897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [7899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [7911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [7921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [7929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [7931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [7933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [7935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [7937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [7939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [7941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [7943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [7945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [7947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [7951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [7953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [7955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [7957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [7959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [7961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [7981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [7989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [7995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [7999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [8023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2805),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [8063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2372),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [8069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [8073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [8099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [8109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [8119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [8127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [8145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [8173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [8175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [8181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [8191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [8209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3450),
  [8211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [8219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [8227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [8247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3372),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [8259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [8279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [8285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [8295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [8297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [8301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3384),
  [8303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3268),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [8321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [8323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [8333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [8339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [8341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [8343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [8345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [8347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [8349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [8353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [8355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__minted_environment_begin, 3, 0, 34),
  [8357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [8359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3357),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [8363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [8367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [8369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [8373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brack_group_key_value, 2, 0, 0),
  [8375] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [8377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [8383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [8389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [8395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [8403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [8405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [8419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [8421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__verbatim_environment_name, 1, 0, 3),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [8425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [8431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [8439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [8441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [8443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment_environment_begin, 2, 0, 15),
  [8445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [8447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [8449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [8451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [8455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [8459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [8463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [8465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__verbatim_environment_begin, 2, 0, 15),
  [8467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__listing_environment_begin, 2, 0, 15),
  [8469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pycode_environment_begin, 2, 0, 15),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [8473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [8475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [8477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sagesilent_environment_begin, 2, 0, 15),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [8481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [8483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [8487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [8489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [8491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [8493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [8495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [8509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [8513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [8515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__minted_environment_begin, 4, 0, 59),
  [8517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brack_group_key_value, 3, 0, 61),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [8521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [8527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2528),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [8531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sageblock_environment_begin, 2, 0, 15),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [8535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__math_environment_name, 1, 0, 3),
  [8537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sageblock_environment_name, 1, 0, 3),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [8541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__sagesilent_environment_name, 1, 0, 3),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [8545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [8549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [8555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [8559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [8563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [8567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [8571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [8573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pycode_environment_name, 1, 0, 3),
  [8575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [8577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [8581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [8583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [8597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__minted_environment_name, 1, 0, 3),
  [8599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [8601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [8603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [8605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__listing_environment_name, 1, 0, 3),
  [8607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [8609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [8611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [8613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comment_environment_name, 1, 0, 3),
  [8615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [8617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [8619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [8621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [8623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [8629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_brack_group_key_value, 4, 0, 78),
  [8631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [8633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [8637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [8639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [8641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [8643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [8645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__trivia_raw_fi = 0,
  ts_external_token__trivia_raw_env_comment = 1,
  ts_external_token__trivia_raw_env_verbatim = 2,
  ts_external_token__trivia_raw_env_listing = 3,
  ts_external_token__trivia_raw_env_minted = 4,
  ts_external_token__trivia_raw_env_pycode = 5,
  ts_external_token__trivia_raw_env_sagesilent = 6,
  ts_external_token__trivia_raw_env_sageblock = 7,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__trivia_raw_fi] = sym__trivia_raw_fi,
  [ts_external_token__trivia_raw_env_comment] = sym__trivia_raw_env_comment,
  [ts_external_token__trivia_raw_env_verbatim] = sym__trivia_raw_env_verbatim,
  [ts_external_token__trivia_raw_env_listing] = sym__trivia_raw_env_listing,
  [ts_external_token__trivia_raw_env_minted] = sym__trivia_raw_env_minted,
  [ts_external_token__trivia_raw_env_pycode] = sym__trivia_raw_env_pycode,
  [ts_external_token__trivia_raw_env_sagesilent] = sym__trivia_raw_env_sagesilent,
  [ts_external_token__trivia_raw_env_sageblock] = sym__trivia_raw_env_sageblock,
};

static const bool ts_external_scanner_states[10][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__trivia_raw_fi] = true,
    [ts_external_token__trivia_raw_env_comment] = true,
    [ts_external_token__trivia_raw_env_verbatim] = true,
    [ts_external_token__trivia_raw_env_listing] = true,
    [ts_external_token__trivia_raw_env_minted] = true,
    [ts_external_token__trivia_raw_env_pycode] = true,
    [ts_external_token__trivia_raw_env_sagesilent] = true,
    [ts_external_token__trivia_raw_env_sageblock] = true,
  },
  [2] = {
    [ts_external_token__trivia_raw_fi] = true,
  },
  [3] = {
    [ts_external_token__trivia_raw_env_sageblock] = true,
  },
  [4] = {
    [ts_external_token__trivia_raw_env_sagesilent] = true,
  },
  [5] = {
    [ts_external_token__trivia_raw_env_pycode] = true,
  },
  [6] = {
    [ts_external_token__trivia_raw_env_minted] = true,
  },
  [7] = {
    [ts_external_token__trivia_raw_env_listing] = true,
  },
  [8] = {
    [ts_external_token__trivia_raw_env_verbatim] = true,
  },
  [9] = {
    [ts_external_token__trivia_raw_env_comment] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_latex_external_scanner_create(void);
void tree_sitter_latex_external_scanner_destroy(void *);
bool tree_sitter_latex_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_latex_external_scanner_serialize(void *, char *);
void tree_sitter_latex_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_latex(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_command_name,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_latex_external_scanner_create,
      tree_sitter_latex_external_scanner_destroy,
      tree_sitter_latex_external_scanner_scan,
      tree_sitter_latex_external_scanner_serialize,
      tree_sitter_latex_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
